class
	P_MICRO_HTTPD

inherit
	MICRO_HTTPD_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_LIBIO
	S_STDIO
	S_STRING
	S_DIRENT
	S_CTYPE
	S_TIME
	S_SYS_STAT

feature {NONE} -- Initialization

	default_create
		do
			create encoded_name.make (<<1_000>>)
			create path.make (<<2_000>>)
		end

feature {ANY} -- attributes

	encoded_name: CE_ARRAY [INTEGER_8]

	path: CE_ARRAY [INTEGER_8]

feature {ANY} -- routines

	file_details (a_dir: CE_POINTER [INTEGER_8]; a_name: CE_POINTER [INTEGER_8])
		local
			l_sb: CE_ARRAY [SD_STAT]
			l_timestr: CE_ARRAY [INTEGER_8]
		do
			create l_sb.make (<<1>>)
			create l_timestr.make (<<16>>)

			strencode (encoded_name, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_000).to_natural_32), a_name)
			snprintf ([path, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (2_000).to_natural_32), ce_string ("%%s/%%s"), a_dir, a_name]).do_nothing
			if (lstat (path, l_sb)) < 0 then
				printf ([ce_string ("<a href=%"%%s%">%%-32.32s</a>    ???%N"), encoded_name, a_name]).do_nothing
			else
				strftime (l_timestr, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (16).to_natural_32), ce_string ("%%d%%b%%Y %%H:%%M"), (localtime ((create {CE_POINTER [INTEGER_32]}.make_shared (l_sb.item.c_pointer + (create {SD_STAT}.make).offset_of ("st_mtim") + (create {SD_TIMESPEC}.make).offset_of ("tv_sec")))))).do_nothing
				printf ([ce_string ("<a href=%"%%s%">%%-32.32s</a>    %%15s %%14lld%N"), encoded_name, a_name, l_timestr, (l_sb.item.st_size).to_integer_64]).do_nothing
			end
		end

	get_mime_type (a_name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_dot: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_dot.make

			l_dot := strrchr (a_name, ('.').code)
			if l_dot.is_void then
				Result := (ce_string ("text/plain; charset=iso-8859-1"))
				js.return
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".html"))) = 0 then
					Result := (ce_string ("text/html; charset=iso-8859-1"))
					js.return
				elseif (strcmp (l_dot, ce_string (".htm"))) = 0 then
					Result := (ce_string ("text/html; charset=iso-8859-1"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".jpg"))) = 0 then
					Result := (ce_string ("image/jpeg"))
					js.return
				elseif (strcmp (l_dot, ce_string (".jpeg"))) = 0 then
					Result := (ce_string ("image/jpeg"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".gif"))) = 0 then
					Result := (ce_string ("image/gif"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".png"))) = 0 then
					Result := (ce_string ("image/png"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".css"))) = 0 then
					Result := (ce_string ("text/css"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".au"))) = 0 then
					Result := (ce_string ("audio/basic"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".wav"))) = 0 then
					Result := (ce_string ("audio/wav"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".avi"))) = 0 then
					Result := (ce_string ("video/x-msvideo"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".mov"))) = 0 then
					Result := (ce_string ("video/quicktime"))
					js.return
				elseif (strcmp (l_dot, ce_string (".qt"))) = 0 then
					Result := (ce_string ("video/quicktime"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".mpeg"))) = 0 then
					Result := (ce_string ("video/mpeg"))
					js.return
				elseif (strcmp (l_dot, ce_string (".mpe"))) = 0 then
					Result := (ce_string ("video/mpeg"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".vrml"))) = 0 then
					Result := (ce_string ("model/vrml"))
					js.return
				elseif (strcmp (l_dot, ce_string (".wrl"))) = 0 then
					Result := (ce_string ("model/vrml"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".midi"))) = 0 then
					Result := (ce_string ("audio/midi"))
					js.return
				elseif (strcmp (l_dot, ce_string (".mid"))) = 0 then
					Result := (ce_string ("audio/midi"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".mp3"))) = 0 then
					Result := (ce_string ("audio/mpeg"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".ogg"))) = 0 then
					Result := (ce_string ("application/ogg"))
					js.return
				end
			end
			if not js.return_called then
				if (strcmp (l_dot, ce_string (".pac"))) = 0 then
					Result := (ce_string ("application/x-ns-proxy-autoconfig"))
					js.return
				end
			end
			if not js.return_called then
				Result := (ce_string ("text/plain; charset=iso-8859-1"))
			end
		end

	hexit (a_c: INTEGER_8): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c.to_integer_32 >= 48 then
				if a_c.to_integer_32 <= 57 then
					Result := (a_c.to_integer_32 - 48)
					js.return
				end
			end
			if not js.return_called and then (a_c.to_integer_32 >= 97) then
				if a_c.to_integer_32 <= 102 then
					Result := ((a_c.to_integer_32 - 97) + 10)
					js.return
				end
			end
			if not js.return_called and then (a_c.to_integer_32 >= 65) then
				if a_c.to_integer_32 <= 70 then
					Result := ((a_c.to_integer_32 - 65) + 10)
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_line: CE_ARRAY [INTEGER_8]
			l_method: CE_ARRAY [INTEGER_8]
			l_path: CE_ARRAY [INTEGER_8]
			l_protocol: CE_ARRAY [INTEGER_8]
			l_idx: CE_ARRAY [INTEGER_8]
			l_location: CE_ARRAY [INTEGER_8]
			l_file: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_ich: INTEGER_32
			l_sb: CE_ARRAY [SD_STAT]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_dl: CE_ARRAY [CE_POINTER [CE_POINTER [SD_DIRENT]]]
			l_i: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make (<<10_000>>)
			create l_method.make (<<10_000>>)
			create l_path.make (<<10_000>>)
			create l_protocol.make (<<10_000>>)
			create l_idx.make (<<20_000>>)
			create l_location.make (<<20_000>>)
			create l_file.make
			create l_sb.make (<<1>>)
			create l_fp.make
			create l_dl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_argc /= 2 then
						send_error (500, ce_string ("Internal Error"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("Config error - no dir specified."))
					end
					if (chdir (a_argv[1])) < 0 then
						send_error (500, ce_string ("Internal Error"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("Config error - couldn%'t chdir()."))
					end
					if (fgets (l_line, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (10_000).to_natural_32).to_integer_32, (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer)))).is_void then
						send_error (400, ce_string ("Bad Request"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("No request found."))
					end
					if (sscanf ([l_line, ce_string ("%%[^ ] %%[^ ] %%[^ ]"), l_method, l_path, l_protocol])) /= 3 then
						send_error (400, ce_string ("Bad Request"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("Can%'t parse request."))
					end
					from
					until
						js.loop_done
					loop
						if (fgets (l_line, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (10_000).to_natural_32).to_integer_32, (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer)))).is_void then
							js.break
						end
						if not js.loop_jumped then
							if (strcmp (l_line, ce_string ("%N"))) = 0 then
								js.break
							elseif (strcmp (l_line, ce_string ("%R%N"))) = 0 then
								js.break
							end
						end
					end
					if (strcasecmp (l_method, ce_string ("get"))) /= 0 then
						send_error (501, ce_string ("Not Implemented"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("That method is not implemented."))
					end
					if (l_path[0]).to_integer_32 /= 47 then
						send_error (400, ce_string ("Bad Request"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("Bad filename."))
					end
					l_file := l_path + 1
					strdecode (l_file, l_file)
					if (l_file[0]).to_integer_32 = 0 then
						l_file := ce_string ("./")
					end
					l_len := strlen (l_file)
					if (l_file[0]).to_integer_32 = 47 then
						send_error (400, ce_string ("Bad Request"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("Illegal filename."))
					elseif (strcmp (l_file, ce_string (".."))) = 0 then
						send_error (400, ce_string ("Bad Request"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("Illegal filename."))
					elseif (strncmp (l_file, ce_string ("../"), {NATURAL_32} 3)) = 0 then
						send_error (400, ce_string ("Bad Request"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("Illegal filename."))
					elseif not (strstr (l_file, ce_string ("/../"))).is_void then
						send_error (400, ce_string ("Bad Request"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("Illegal filename."))
					elseif (strcmp ((l_file + (l_len - {NATURAL_32} 3).to_integer_32), ce_string ("/.."))) = 0 then
						send_error (400, ce_string ("Bad Request"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("Illegal filename."))
					end
					if (stat (l_file, l_sb)) < 0 then
						send_error (404, ce_string ("Not Found"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("File not found."))
					end
					if ((l_sb.item.st_mode).bit_and ({NATURAL_32} 61_440)) /= {NATURAL_32} 16_384 then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if (l_file[(l_len - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
							snprintf ([l_location, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (20_000).to_natural_32), ce_string ("Location: %%s/"), l_path]).do_nothing
							send_error (302, ce_string ("Found"), l_location, ce_string ("Directories must end with a slash."))
						end
						snprintf ([l_idx, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (20_000).to_natural_32), ce_string ("%%sindex.html"), l_file]).do_nothing
						if (stat (l_idx, l_sb)) >= 0 then
							l_file := l_idx
							l_pos := -1 + 4 -- goto do_file
						end
				when 2 then
						send_headers (200, ce_string ("Ok"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("text/html"), -1, l_sb.item.st_mtim.tv_sec)
						Io.put_string ("<html><head><title>Index of " + eif_string (l_file) + "</title></head>%N<body bgcolor=%"#99cc99%"><h4>Index of " + eif_string (l_file) + "</h4>%N<pre>%N")
						l_n := scandir (l_file, l_dl, create {CE_ROUTINE}.make_shared (default_pointer), alphasort_address)
						if l_n < 0 then
							perror (ce_string ("scandir"))
						else
							l_i := 0
							from
							until
								not (l_i < l_n)
							loop
								file_details (l_file, (l_dl.item[l_i]).item.d_name)
								l_i := l_i + 1
							end
						end
						Io.put_string ("</pre>%N<hr>%N<address><a href=%"http://www.acme.com/software/micro_httpd/%">micro_httpd</a></address>%N</body></html>%N")
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | do_file:
						l_fp := fopen (l_file, ce_string ("r"))
						if l_fp.is_void then
							send_error (403, ce_string ("Forbidden"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("File is protected."))
						end
						send_headers (200, ce_string ("Ok"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), (get_mime_type (l_file)), l_sb.item.st_size, l_sb.item.st_mtim.tv_sec)
						from
						until
							js.loop_done
						loop
							l_ich := IO_getc (l_fp)
							if l_ich = -1 then
								js.break
							end
							if not js.loop_jumped then
								putchar (l_ich).do_nothing
							end
						end
				when 5 then -- if done
					Io.standard_default.flush
					exit (0)
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	send_error (a_status: INTEGER_32; a_title: CE_POINTER [INTEGER_8]; a_extra_header: CE_POINTER [INTEGER_8]; a_text: CE_POINTER [INTEGER_8])
		do
			send_headers (a_status, a_title, a_extra_header, ce_string ("text/html"), -1, -1)
			Io.put_string ("<html><head><title>" + a_status.out + " " + eif_string (a_title) + "</title></head>%N<body bgcolor=%"#cc9999%"><h4>" + a_status.out + " " + eif_string (a_title) + "</h4>%N")
			Io.put_string (eif_string (a_text) + "%N")
			Io.put_string ("<hr>%N<address><a href=%"http://www.acme.com/software/micro_httpd/%">micro_httpd</a></address>%N</body></html>%N")
			Io.standard_default.flush
			exit (1)
		end

	send_headers (a_status: INTEGER_32; a_title: CE_POINTER [INTEGER_8]; a_extra_header: CE_POINTER [INTEGER_8]; a_mime_type: CE_POINTER [INTEGER_8]; a_length: INTEGER_32; a_mod: INTEGER_32)
		local
			l_mod: CE_ARRAY [INTEGER_32]
			l_now: CE_ARRAY [INTEGER_32]
			l_timebuf: CE_ARRAY [INTEGER_8]
		do
			create l_mod.make (<<1>>)
			create l_now.make (<<1>>)
			create l_timebuf.make (<<100>>)

			l_mod.item := a_mod
			Io.put_string ("HTTP/1.0 " + a_status.out + " " + eif_string (a_title) + "%R%N")
			Io.put_string ("Server: micro_httpd%R%N")
			l_now.item := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			strftime (l_timebuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (100).to_natural_32), ce_string ("%%a, %%d %%b %%Y %%H:%%M:%%S GMT"), (gmtime (l_now))).do_nothing
			Io.put_string ("Date: " + eif_string (l_timebuf) + "%R%N")
			if not a_extra_header.is_void then
				Io.put_string (eif_string (a_extra_header) + "%R%N")
			end
			if not a_mime_type.is_void then
				Io.put_string ("Content-Type: " + eif_string (a_mime_type) + "%R%N")
			end
			if a_length >= 0 then
				printf ([ce_string ("Content-Length: %%lld%R%N"), a_length.to_integer_64]).do_nothing
			end
			if l_mod.item /= -1 then
				strftime (l_timebuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (100).to_natural_32), ce_string ("%%a, %%d %%b %%Y %%H:%%M:%%S GMT"), (gmtime (l_mod))).do_nothing
				Io.put_string ("Last-Modified: " + eif_string (l_timebuf) + "%R%N")
			end
			Io.put_string ("Connection: close%R%N")
			Io.put_string ("%R%N")
		end

	strdecode (a_to: CE_POINTER [INTEGER_8]; a_from: CE_POINTER [INTEGER_8])
		local
			l_to: CE_POINTER [INTEGER_8]
			l_from: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
		do
			create l_to.make
			create l_from.make

			l_to := a_to
			l_from := a_from
			from
			until
				(l_from[0]).to_integer_32 = 0
			loop
				if (l_from[0]).to_integer_32 = 37 then
					if ((((ctype_b_loc).item[(l_from[1]).to_integer_32]).to_integer_32).bit_and (4_096)).to_boolean then
						if ((((ctype_b_loc).item[(l_from[2]).to_integer_32]).to_integer_32).bit_and (4_096)).to_boolean then
							l_tmp := hexit (l_from[1])
							l_to[0] := (l_tmp * 16 + (hexit (l_from[2]))).to_integer_8
							l_from := l_from + (2)
						else
							l_to[0] := l_from[0]
						end
					else
						l_to[0] := l_from[0]
					end
				else
					l_to[0] := l_from[0]
				end
				l_to := l_to + 1
				l_from := l_from + 1
			end
			l_to[0] := (('%/0/').code).to_integer_8
		end

	strencode (a_to: CE_POINTER [INTEGER_8]; a_tosize: NATURAL_32; a_from: CE_POINTER [INTEGER_8])
		local
			l_to: CE_POINTER [INTEGER_8]
			l_from: CE_POINTER [INTEGER_8]
			l_tolen: INTEGER_32
			js: JUMP_STATE
		do
			create l_to.make
			create l_from.make

			l_to := a_to
			l_from := a_from
			l_tolen := 0
			from
			until
				js.loop_done
			loop
				if (l_from[0]).to_integer_32 /= 0 then
					if not ((l_tolen + 4).to_natural_32 < a_tosize) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if ((((ctype_b_loc).item[(l_from[0]).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
						l_to[0] := l_from[0]
						l_to := l_to + 1
						l_tolen := l_tolen + 1
					elseif not (strchr (ce_string ("/_.-~"), (l_from[0]).to_integer_32)).is_void then
						l_to[0] := l_from[0]
						l_to := l_to + 1
						l_tolen := l_tolen + 1
					else
						sprintf ([l_to, ce_string ("%%%%%%02x"), ((l_from[0]).to_integer_32).bit_and (255)]).do_nothing
						l_to := l_to + (3)
						l_tolen := l_tolen + (3)
					end
					l_from := l_from + 1
				end
			end
			l_to[0] := (('%/0/').code).to_integer_8
		end

end
