class
	SD_DIRENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create d_name.make (<<256>>)
		end

feature {ANY} -- fields

	d_ino: NATURAL_32 assign set_d_ino

	d_off: INTEGER_32 assign set_d_off

	d_reclen: NATURAL_16 assign set_d_reclen

	d_type: NATURAL_8 assign set_d_type

	d_name: CE_ARRAY [INTEGER_8]

feature {ANY} -- setters

	set_d_ino (a_d_ino: NATURAL_32)
		do
			d_ino := a_d_ino
			update_memory_field ("d_ino")
		end

	set_d_off (a_d_off: INTEGER_32)
		do
			d_off := a_d_off
			update_memory_field ("d_off")
		end

	set_d_reclen (a_d_reclen: NATURAL_16)
		do
			d_reclen := a_d_reclen
			update_memory_field ("d_reclen")
		end

	set_d_type (a_d_type: NATURAL_8)
		do
			d_type := a_d_type
			update_memory_field ("d_type")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			d_ino := a_other.d_ino
			d_off := a_other.d_off
			d_reclen := a_other.d_reclen
			d_type := a_other.d_type
			d_name := a_other.d_name.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				d_ino = a_other.d_ino and
				d_off = a_other.d_off and
				d_reclen = a_other.d_reclen and
				d_type = a_other.d_type and
				d_name.is_equal (a_other.d_name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("d_ino"),
					create {CE_STRUCTURE_FIELD}.make ("d_off"),
					create {CE_STRUCTURE_FIELD}.make ("d_reclen"),
					create {CE_STRUCTURE_FIELD}.make ("d_type"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("d_name", <<256>>)
				>>)
			init_structure_info
		end

end
