class
	SD_XGCVALUES

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	function: INTEGER_32 assign set_function

	plane_mask: NATURAL_32 assign set_plane_mask

	foreground: NATURAL_32 assign set_foreground

	background: NATURAL_32 assign set_background

	line_width: INTEGER_32 assign set_line_width

	line_style: INTEGER_32 assign set_line_style

	cap_style: INTEGER_32 assign set_cap_style

	join_style: INTEGER_32 assign set_join_style

	fill_style: INTEGER_32 assign set_fill_style

	fill_rule: INTEGER_32 assign set_fill_rule

	arc_mode: INTEGER_32 assign set_arc_mode

	tile: NATURAL_32 assign set_tile

	stipple: NATURAL_32 assign set_stipple

	ts_x_origin: INTEGER_32 assign set_ts_x_origin

	ts_y_origin: INTEGER_32 assign set_ts_y_origin

	font: NATURAL_32 assign set_font

	subwindow_mode: INTEGER_32 assign set_subwindow_mode

	graphics_exposures: INTEGER_32 assign set_graphics_exposures

	clip_x_origin: INTEGER_32 assign set_clip_x_origin

	clip_y_origin: INTEGER_32 assign set_clip_y_origin

	clip_mask: NATURAL_32 assign set_clip_mask

	dash_offset: INTEGER_32 assign set_dash_offset

	dashes: INTEGER_8 assign set_dashes

feature {ANY} -- setters

	set_function (a_function: INTEGER_32)
		do
			function := a_function
			update_memory_field ("function")
		end

	set_plane_mask (a_plane_mask: NATURAL_32)
		do
			plane_mask := a_plane_mask
			update_memory_field ("plane_mask")
		end

	set_foreground (a_foreground: NATURAL_32)
		do
			foreground := a_foreground
			update_memory_field ("foreground")
		end

	set_background (a_background: NATURAL_32)
		do
			background := a_background
			update_memory_field ("background")
		end

	set_line_width (a_line_width: INTEGER_32)
		do
			line_width := a_line_width
			update_memory_field ("line_width")
		end

	set_line_style (a_line_style: INTEGER_32)
		do
			line_style := a_line_style
			update_memory_field ("line_style")
		end

	set_cap_style (a_cap_style: INTEGER_32)
		do
			cap_style := a_cap_style
			update_memory_field ("cap_style")
		end

	set_join_style (a_join_style: INTEGER_32)
		do
			join_style := a_join_style
			update_memory_field ("join_style")
		end

	set_fill_style (a_fill_style: INTEGER_32)
		do
			fill_style := a_fill_style
			update_memory_field ("fill_style")
		end

	set_fill_rule (a_fill_rule: INTEGER_32)
		do
			fill_rule := a_fill_rule
			update_memory_field ("fill_rule")
		end

	set_arc_mode (a_arc_mode: INTEGER_32)
		do
			arc_mode := a_arc_mode
			update_memory_field ("arc_mode")
		end

	set_tile (a_tile: NATURAL_32)
		do
			tile := a_tile
			update_memory_field ("tile")
		end

	set_stipple (a_stipple: NATURAL_32)
		do
			stipple := a_stipple
			update_memory_field ("stipple")
		end

	set_ts_x_origin (a_ts_x_origin: INTEGER_32)
		do
			ts_x_origin := a_ts_x_origin
			update_memory_field ("ts_x_origin")
		end

	set_ts_y_origin (a_ts_y_origin: INTEGER_32)
		do
			ts_y_origin := a_ts_y_origin
			update_memory_field ("ts_y_origin")
		end

	set_font (a_font: NATURAL_32)
		do
			font := a_font
			update_memory_field ("font")
		end

	set_subwindow_mode (a_subwindow_mode: INTEGER_32)
		do
			subwindow_mode := a_subwindow_mode
			update_memory_field ("subwindow_mode")
		end

	set_graphics_exposures (a_graphics_exposures: INTEGER_32)
		do
			graphics_exposures := a_graphics_exposures
			update_memory_field ("graphics_exposures")
		end

	set_clip_x_origin (a_clip_x_origin: INTEGER_32)
		do
			clip_x_origin := a_clip_x_origin
			update_memory_field ("clip_x_origin")
		end

	set_clip_y_origin (a_clip_y_origin: INTEGER_32)
		do
			clip_y_origin := a_clip_y_origin
			update_memory_field ("clip_y_origin")
		end

	set_clip_mask (a_clip_mask: NATURAL_32)
		do
			clip_mask := a_clip_mask
			update_memory_field ("clip_mask")
		end

	set_dash_offset (a_dash_offset: INTEGER_32)
		do
			dash_offset := a_dash_offset
			update_memory_field ("dash_offset")
		end

	set_dashes (a_dashes: INTEGER_8)
		do
			dashes := a_dashes
			update_memory_field ("dashes")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			function := a_other.function
			plane_mask := a_other.plane_mask
			foreground := a_other.foreground
			background := a_other.background
			line_width := a_other.line_width
			line_style := a_other.line_style
			cap_style := a_other.cap_style
			join_style := a_other.join_style
			fill_style := a_other.fill_style
			fill_rule := a_other.fill_rule
			arc_mode := a_other.arc_mode
			tile := a_other.tile
			stipple := a_other.stipple
			ts_x_origin := a_other.ts_x_origin
			ts_y_origin := a_other.ts_y_origin
			font := a_other.font
			subwindow_mode := a_other.subwindow_mode
			graphics_exposures := a_other.graphics_exposures
			clip_x_origin := a_other.clip_x_origin
			clip_y_origin := a_other.clip_y_origin
			clip_mask := a_other.clip_mask
			dash_offset := a_other.dash_offset
			dashes := a_other.dashes
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				function = a_other.function and
				plane_mask = a_other.plane_mask and
				foreground = a_other.foreground and
				background = a_other.background and
				line_width = a_other.line_width and
				line_style = a_other.line_style and
				cap_style = a_other.cap_style and
				join_style = a_other.join_style and
				fill_style = a_other.fill_style and
				fill_rule = a_other.fill_rule and
				arc_mode = a_other.arc_mode and
				tile = a_other.tile and
				stipple = a_other.stipple and
				ts_x_origin = a_other.ts_x_origin and
				ts_y_origin = a_other.ts_y_origin and
				font = a_other.font and
				subwindow_mode = a_other.subwindow_mode and
				graphics_exposures = a_other.graphics_exposures and
				clip_x_origin = a_other.clip_x_origin and
				clip_y_origin = a_other.clip_y_origin and
				clip_mask = a_other.clip_mask and
				dash_offset = a_other.dash_offset and
				dashes = a_other.dashes
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("plane_mask"),
					create {CE_STRUCTURE_FIELD}.make ("foreground"),
					create {CE_STRUCTURE_FIELD}.make ("background"),
					create {CE_STRUCTURE_FIELD}.make ("line_width"),
					create {CE_STRUCTURE_FIELD}.make ("line_style"),
					create {CE_STRUCTURE_FIELD}.make ("cap_style"),
					create {CE_STRUCTURE_FIELD}.make ("join_style"),
					create {CE_STRUCTURE_FIELD}.make ("fill_style"),
					create {CE_STRUCTURE_FIELD}.make ("fill_rule"),
					create {CE_STRUCTURE_FIELD}.make ("arc_mode"),
					create {CE_STRUCTURE_FIELD}.make ("tile"),
					create {CE_STRUCTURE_FIELD}.make ("stipple"),
					create {CE_STRUCTURE_FIELD}.make ("ts_x_origin"),
					create {CE_STRUCTURE_FIELD}.make ("ts_y_origin"),
					create {CE_STRUCTURE_FIELD}.make ("font"),
					create {CE_STRUCTURE_FIELD}.make ("subwindow_mode"),
					create {CE_STRUCTURE_FIELD}.make ("graphics_exposures"),
					create {CE_STRUCTURE_FIELD}.make ("clip_x_origin"),
					create {CE_STRUCTURE_FIELD}.make ("clip_y_origin"),
					create {CE_STRUCTURE_FIELD}.make ("clip_mask"),
					create {CE_STRUCTURE_FIELD}.make ("dash_offset"),
					create {CE_STRUCTURE_FIELD}.make ("dashes")
				>>)
			init_structure_info
		end

end
