class
	SD_XTCONVERTARGREC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create address_id.make
		end

feature {ANY} -- fields

	address_mode: NATURAL_32 assign set_address_mode

	address_id: CE_POINTER [ANY] assign set_address_id

	size: NATURAL_32 assign set_size

feature {ANY} -- setters

	set_address_mode (a_address_mode: NATURAL_32)
		do
			address_mode := a_address_mode
			update_memory_field ("address_mode")
		end

	set_address_id (a_address_id: CE_POINTER [ANY])
		do
			address_id := a_address_id
			update_memory_field ("address_id")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			address_mode := a_other.address_mode
			address_id := a_other.address_id
			size := a_other.size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				address_mode = a_other.address_mode and
				address_id.is_equal (a_other.address_id) and
				size = a_other.size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("address_mode"),
					create {CE_STRUCTURE_FIELD}.make ("address_id"),
					create {CE_STRUCTURE_FIELD}.make ("size")
				>>)
			init_structure_info
		end

end
