class
	SD_XTRESOURCE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create resource_name.make
			create resource_class.make
			create resource_type.make
			create default_type.make
			create default_addr.make
		end

feature {ANY} -- fields

	resource_name: CE_POINTER [INTEGER_8] assign set_resource_name

	resource_class: CE_POINTER [INTEGER_8] assign set_resource_class

	resource_type: CE_POINTER [INTEGER_8] assign set_resource_type

	resource_size: NATURAL_32 assign set_resource_size

	resource_offset: NATURAL_32 assign set_resource_offset

	default_type: CE_POINTER [INTEGER_8] assign set_default_type

	default_addr: CE_POINTER [ANY] assign set_default_addr

feature {ANY} -- setters

	set_resource_name (a_resource_name: CE_POINTER [INTEGER_8])
		do
			resource_name := a_resource_name
			update_memory_field ("resource_name")
		end

	set_resource_class (a_resource_class: CE_POINTER [INTEGER_8])
		do
			resource_class := a_resource_class
			update_memory_field ("resource_class")
		end

	set_resource_type (a_resource_type: CE_POINTER [INTEGER_8])
		do
			resource_type := a_resource_type
			update_memory_field ("resource_type")
		end

	set_resource_size (a_resource_size: NATURAL_32)
		do
			resource_size := a_resource_size
			update_memory_field ("resource_size")
		end

	set_resource_offset (a_resource_offset: NATURAL_32)
		do
			resource_offset := a_resource_offset
			update_memory_field ("resource_offset")
		end

	set_default_type (a_default_type: CE_POINTER [INTEGER_8])
		do
			default_type := a_default_type
			update_memory_field ("default_type")
		end

	set_default_addr (a_default_addr: CE_POINTER [ANY])
		do
			default_addr := a_default_addr
			update_memory_field ("default_addr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			resource_name := a_other.resource_name
			resource_class := a_other.resource_class
			resource_type := a_other.resource_type
			resource_size := a_other.resource_size
			resource_offset := a_other.resource_offset
			default_type := a_other.default_type
			default_addr := a_other.default_addr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				resource_name.is_equal (a_other.resource_name) and
				resource_class.is_equal (a_other.resource_class) and
				resource_type.is_equal (a_other.resource_type) and
				resource_size = a_other.resource_size and
				resource_offset = a_other.resource_offset and
				default_type.is_equal (a_other.default_type) and
				default_addr.is_equal (a_other.default_addr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("resource_name"),
					create {CE_STRUCTURE_FIELD}.make ("resource_class"),
					create {CE_STRUCTURE_FIELD}.make ("resource_type"),
					create {CE_STRUCTURE_FIELD}.make ("resource_size"),
					create {CE_STRUCTURE_FIELD}.make ("resource_offset"),
					create {CE_STRUCTURE_FIELD}.make ("default_type"),
					create {CE_STRUCTURE_FIELD}.make ("default_addr")
				>>)
			init_structure_info
		end

end
