class
	PD_BUF

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create hnext.make
			create hprev.make
			create data.make (<<8_192>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_BUF] assign set_next

	prev: CE_POINTER [PD_BUF] assign set_prev

	hnext: CE_POINTER [PD_BUF] assign set_hnext

	hprev: CE_POINTER [PD_BUF] assign set_hprev

	block: INTEGER_32 assign set_block

	datasize: NATURAL_32 assign set_datasize

	data: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_BUF])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_BUF])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_hnext (a_hnext: CE_POINTER [PD_BUF])
		do
			hnext := a_hnext
			update_memory_field ("hnext")
		end

	set_hprev (a_hprev: CE_POINTER [PD_BUF])
		do
			hprev := a_hprev
			update_memory_field ("hprev")
		end

	set_block (a_block: INTEGER_32)
		do
			block := a_block
			update_memory_field ("block")
		end

	set_datasize (a_datasize: NATURAL_32)
		do
			datasize := a_datasize
			update_memory_field ("datasize")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			hnext := a_other.hnext
			hprev := a_other.hprev
			block := a_other.block
			datasize := a_other.datasize
			data := a_other.data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				hnext.is_equal (a_other.hnext) and
				hprev.is_equal (a_other.hprev) and
				block = a_other.block and
				datasize = a_other.datasize and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("hnext"),
					create {CE_STRUCTURE_FIELD}.make ("hprev"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("datasize"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("data", <<8_192>>)
				>>)
			init_structure_info
		end

end
