class
	PD_BUFLIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create buf_next.make
			create buf_prev.make
			create buf_hnext.make
			create buf_hprev.make
		end

feature {ANY} -- fields

	buf_next: CE_POINTER [PD_BUF] assign set_buf_next

	buf_prev: CE_POINTER [PD_BUF] assign set_buf_prev

	buf_hnext: CE_POINTER [PD_BUF] assign set_buf_hnext

	buf_hprev: CE_POINTER [PD_BUF] assign set_buf_hprev

feature {ANY} -- setters

	set_buf_next (a_buf_next: CE_POINTER [PD_BUF])
		do
			buf_next := a_buf_next
			update_memory_field ("buf_next")
		end

	set_buf_prev (a_buf_prev: CE_POINTER [PD_BUF])
		do
			buf_prev := a_buf_prev
			update_memory_field ("buf_prev")
		end

	set_buf_hnext (a_buf_hnext: CE_POINTER [PD_BUF])
		do
			buf_hnext := a_buf_hnext
			update_memory_field ("buf_hnext")
		end

	set_buf_hprev (a_buf_hprev: CE_POINTER [PD_BUF])
		do
			buf_hprev := a_buf_hprev
			update_memory_field ("buf_hprev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buf_next := a_other.buf_next
			buf_prev := a_other.buf_prev
			buf_hnext := a_other.buf_hnext
			buf_hprev := a_other.buf_hprev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buf_next.is_equal (a_other.buf_next) and
				buf_prev.is_equal (a_other.buf_prev) and
				buf_hnext.is_equal (a_other.buf_hnext) and
				buf_hprev.is_equal (a_other.buf_hprev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buf_next"),
					create {CE_STRUCTURE_FIELD}.make ("buf_prev"),
					create {CE_STRUCTURE_FIELD}.make ("buf_hnext"),
					create {CE_STRUCTURE_FIELD}.make ("buf_hprev")
				>>)
			init_structure_info
		end

end
