class
	PD_CHARSET

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create p_flag.make
			create desc.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	p_flag: CE_POINTER [INTEGER_32] assign set_p_flag

	desc: CE_POINTER [INTEGER_8] assign set_desc

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_p_flag (a_p_flag: CE_POINTER [INTEGER_32])
		do
			p_flag := a_p_flag
			update_memory_field ("p_flag")
		end

	set_desc (a_desc: CE_POINTER [INTEGER_8])
		do
			desc := a_desc
			update_memory_field ("desc")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			p_flag := a_other.p_flag
			desc := a_other.desc
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				p_flag.is_equal (a_other.p_flag) and
				desc.is_equal (a_other.desc)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("p_flag"),
					create {CE_STRUCTURE_FIELD}.make ("desc")
				>>)
			init_structure_info
		end

end
