class
	PD_MLIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create curr_mp.make
			create string.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_MLIST] assign set_next

	prev: CE_POINTER [PD_MLIST] assign set_prev

	curr_mp: CE_POINTER [PD_MLIST] assign set_curr_mp

	string: CE_POINTER [INTEGER_8] assign set_string

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_MLIST])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_MLIST])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_curr_mp (a_curr_mp: CE_POINTER [PD_MLIST])
		do
			curr_mp := a_curr_mp
			update_memory_field ("curr_mp")
		end

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			string := a_string
			update_memory_field ("string")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			curr_mp := a_other.curr_mp
			string := a_other.string
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				curr_mp.is_equal (a_other.curr_mp) and
				string.is_equal (a_other.string)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("curr_mp"),
					create {CE_STRUCTURE_FIELD}.make ("string")
				>>)
			init_structure_info
		end

end
