class
	PD_TABLELIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create t_next.make
			create t_start.make
			create t_end.make
		end

feature {ANY} -- fields

	t_next: CE_POINTER [PD_TABLELIST] assign set_t_next

	t_start: CE_POINTER [INTEGER_8] assign set_t_start

	t_end: CE_POINTER [INTEGER_8] assign set_t_end

feature {ANY} -- setters

	set_t_next (a_t_next: CE_POINTER [PD_TABLELIST])
		do
			t_next := a_t_next
			update_memory_field ("t_next")
		end

	set_t_start (a_t_start: CE_POINTER [INTEGER_8])
		do
			t_start := a_t_start
			update_memory_field ("t_start")
		end

	set_t_end (a_t_end: CE_POINTER [INTEGER_8])
		do
			t_end := a_t_end
			update_memory_field ("t_end")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			t_next := a_other.t_next
			t_start := a_other.t_start
			t_end := a_other.t_end
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				t_next.is_equal (a_other.t_next) and
				t_start.is_equal (a_other.t_start) and
				t_end.is_equal (a_other.t_end)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("t_next"),
					create {CE_STRUCTURE_FIELD}.make ("t_start"),
					create {CE_STRUCTURE_FIELD}.make ("t_end")
				>>)
			init_structure_info
		end

end
