class
	P_CMDBUF

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create cmdbuf.make (<<512>>)
			create cp.make
			create curr_mlist.make
			create ml_examine.make
			create ml_search.make
			create ml_shell.make
			create mlist_examine.make (<<1>>)
			create mlist_search.make (<<1>>)
			create mlist_shell.make (<<1>>)
			create tk_ipoint.make
			create tk_original.make
			create tk_text.make
			create tk_tlist.make (<<1>>)
			create tk_trial.make
		end

feature {ANY} -- attributes

	closequote: INTEGER_8 assign set_closequote

	set_closequote (a_closequote: INTEGER_8)
		do
			closequote := a_closequote
		end

	cmd_col: INTEGER_32 assign set_cmd_col

	set_cmd_col (a_cmd_col: INTEGER_32)
		do
			cmd_col := a_cmd_col
		end

	cmd_offset: INTEGER_32 assign set_cmd_offset

	set_cmd_offset (a_cmd_offset: INTEGER_32)
		do
			cmd_offset := a_cmd_offset
		end

	cmdbuf: CE_ARRAY [INTEGER_8]

	cp: CE_POINTER [INTEGER_8] assign set_cp

	set_cp (a_cp: CE_POINTER [INTEGER_8])
		do
			cp := a_cp
		end

	curr_cmdflags: INTEGER_32 assign set_curr_cmdflags

	set_curr_cmdflags (a_curr_cmdflags: INTEGER_32)
		do
			curr_cmdflags := a_curr_cmdflags
		end

	curr_mlist: CE_POINTER [PD_MLIST] assign set_curr_mlist

	set_curr_mlist (a_curr_mlist: CE_POINTER [PD_MLIST])
		do
			curr_mlist := a_curr_mlist
		end

	in_completion: INTEGER_32 assign set_in_completion

	set_in_completion (a_in_completion: INTEGER_32)
		do
			in_completion := a_in_completion
		end

	literal: INTEGER_32 assign set_literal

	set_literal (a_literal: INTEGER_32)
		do
			literal := a_literal
		end

	ml_examine: CE_POINTER [ANY] assign set_ml_examine

	set_ml_examine (a_ml_examine: CE_POINTER [ANY])
		do
			ml_examine := a_ml_examine
		end

	ml_search: CE_POINTER [ANY] assign set_ml_search

	set_ml_search (a_ml_search: CE_POINTER [ANY])
		do
			ml_search := a_ml_search
		end

	ml_shell: CE_POINTER [ANY] assign set_ml_shell

	set_ml_shell (a_ml_shell: CE_POINTER [ANY])
		do
			ml_shell := a_ml_shell
		end

	mlist_examine: CE_ARRAY [PD_MLIST]

	mlist_search: CE_ARRAY [PD_MLIST]

	mlist_shell: CE_ARRAY [PD_MLIST]

	openquote: INTEGER_8 assign set_openquote

	set_openquote (a_openquote: INTEGER_8)
		do
			openquote := a_openquote
		end

	prompt_col: INTEGER_32 assign set_prompt_col

	set_prompt_col (a_prompt_col: INTEGER_32)
		do
			prompt_col := a_prompt_col
		end

	tk_ipoint: CE_POINTER [INTEGER_8] assign set_tk_ipoint

	set_tk_ipoint (a_tk_ipoint: CE_POINTER [INTEGER_8])
		do
			tk_ipoint := a_tk_ipoint
		end

	tk_original: CE_POINTER [INTEGER_8] assign set_tk_original

	set_tk_original (a_tk_original: CE_POINTER [INTEGER_8])
		do
			tk_original := a_tk_original
		end

	tk_text: CE_POINTER [INTEGER_8] assign set_tk_text

	set_tk_text (a_tk_text: CE_POINTER [INTEGER_8])
		do
			tk_text := a_tk_text
		end

	tk_tlist: CE_ARRAY [PD_TEXTLIST]

	tk_trial: CE_POINTER [INTEGER_8] assign set_tk_trial

	set_tk_trial (a_tk_trial: CE_POINTER [INTEGER_8])
		do
			tk_trial := a_tk_trial
		end

feature {ANY} -- routines

	clear_cmd
		do
			screen_inst.clear_bot
			prompt_col := 0
			cmd_col := prompt_col
		end

	cmd_accept
		local
			js: JUMP_STATE
		do
			if curr_mlist.is_void then
				js.return
			end
			if not js.return_called then
				cmd_addhist (curr_mlist, cmdbuf)
			end
		end

	cmd_addhist (a_mlist: CE_POINTER [PD_MLIST]; a_cmd: CE_POINTER [INTEGER_8])
		local
			l_ml: CE_POINTER [PD_MLIST]
			js: JUMP_STATE
		do
			create l_ml.make

			if (strlen (a_cmd)) = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_ml := a_mlist.item.next
				from
				until
					not (not js.loop_done and then (not l_ml.is_equal (a_mlist)))
				loop
					if (strcmp (l_ml.item.string, a_cmd)) = 0 then
						js.break
					end
					if not js.loop_jumped then
						l_ml := l_ml.item.next
					end
				end
				if l_ml.is_equal (a_mlist) then
					l_ml := create {CE_POINTER [PD_MLIST]}.make_cast ((main_inst.ecalloc (1, (create {PD_MLIST}.make).structure_size.to_natural_32)))
					l_ml.item.string := main_inst.save (a_cmd)
					l_ml.item.next := a_mlist
					l_ml.item.prev := a_mlist.item.prev;
					(a_mlist.item.prev).item.next := l_ml
					a_mlist.item.prev := l_ml
				end
				a_mlist.item.curr_mp := l_ml.item.next
			end
		end

	cmd_char (a_c: INTEGER_32): INTEGER_32
		local
			l_action: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if literal.to_boolean then
						literal := 0
						Result := (cmd_ichar (a_c))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not ((command_inst.in_mca).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						l_action := cmd_edit (a_c)
						inspect l_action -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 0 | switch 1, case 1
						Result := l_action
						js.return
				when 4 then -- switch 1, case 3
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done: | if done | if done
						if not js.return_called then
							Result := (cmd_ichar (a_c))
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cmd_complete (a_action: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if in_completion.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_action /= 15 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						init_compl
						if tk_text.is_void then
							screen_inst.bell
							Result := 0
							js.return
						end
						if not js.return_called then
							if a_action = 15 then
								tk_trial := tk_text
							else
								in_completion := 1
								edit_inst.init_textlist (tk_tlist, tk_text)
								tk_trial := next_compl (a_action, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						tk_trial := next_compl (a_action, tk_trial)
				when 7 then -- if done
						if js.return_called then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
							from
							until
								not ((cp.c_pointer.to_integer_32).to_natural_32 > (tk_ipoint.c_pointer.to_integer_32).to_natural_32)
							loop
								cmd_erase.do_nothing
							end
							if not (tk_trial.is_void) then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							in_completion := 0
							if (cmd_istr (tk_original)) /= 0 then
								l_pos := -1 + 15 -- goto fail
							end
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 13
				when 11 then -- else:
							if (cmd_istr (tk_trial)) /= 0 then
								l_pos := -1 + 15 -- goto fail
							end
				when 12 then
							if (filename_inst.is_dir (tk_trial)).to_boolean then
								if (cp.c_pointer.to_integer_32).to_natural_32 > (cmdbuf.c_pointer.to_integer_32).to_natural_32 then
									if (cp[-1]).to_integer_32 = closequote.to_integer_32 then
										cmd_erase.do_nothing
									end
								end
								l_s := decode_inst.lgetenv (ce_string ("LESSSEPARATOR"))
								if l_s.is_void then
									l_s := ce_string ("/")
								end
								if (cmd_istr (l_s)) /= 0 then
									l_pos := -1 + 15 -- goto fail
								end
							end
				when 13 then
							Result := 0
							js.return
				when 14 then -- if done
						if js.return_called then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | fail:
							in_completion := 0
							screen_inst.bell
							Result := 0
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cmd_delete: INTEGER_32
		local
			js: JUMP_STATE
		do
			if (cp[0]).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				cmd_right.do_nothing
				cmd_erase.do_nothing
				Result := 0
			end
		end

	cmd_edit (a_c: INTEGER_32): INTEGER_32
		local
			l_action: INTEGER_32
			l_flags: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_flags := 0
					if curr_mlist.is_void then
						l_flags := (l_flags).bit_or ((2))
					end
					if curr_mlist.is_equal (ml_search) then
						l_flags := (l_flags).bit_or ((4))
					end
					l_action := decode_inst.editchar (a_c, l_flags)
					inspect l_action -- switch 1 head
					when 3 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 2
					when 6 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					when 9 then l_pos := -1 + 5
					when 10 then l_pos := -1 + 6
					when 7 then l_pos := -1 + 7
					when 1 then l_pos := -1 + 8
					when 2 then l_pos := -1 + 9
					when 11 then l_pos := -1 + 10
					when 8 then l_pos := -1 + 11
					when 12 then l_pos := -1 + 12
					when 19 then l_pos := -1 + 13
					when 13 then l_pos := -1 + 14
					when 14 then l_pos := -1 + 14
					when 17 then l_pos := -1 + 15
					when 18 then l_pos := -1 + 15
					when 15 then l_pos := -1 + 15
					when 101 then l_pos := -1 + 16
					else l_pos := -1 + 17
					end
				when 1 then -- switch 1, case 3
					in_completion := 0
					Result := (cmd_right)
					js.return
				when 2 then -- switch 1, case 4
					if not js.return_called then
						in_completion := 0
						Result := (cmd_left)
						js.return
					end
				when 3 then -- switch 1, case 6
					if not js.return_called then
						in_completion := 0
						from
						until
							js.loop_done
						loop
							if (cp[0]).to_integer_32 /= 0 then
								if (cp[0]).to_integer_32 = 32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								cmd_right.do_nothing
							end
						end
						from
						until
							(cp[0]).to_integer_32 /= 32
						loop
							cmd_right.do_nothing
						end
						Result := 0
						js.return
					end
				when 4 then -- switch 1, case 5
					if not js.return_called then
						in_completion := 0
						from
						until
							js.loop_done
						loop
							if (cp.c_pointer.to_integer_32).to_natural_32 > (cmdbuf.c_pointer.to_integer_32).to_natural_32 then
								if (cp[-1]).to_integer_32 /= 32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								cmd_left.do_nothing
							end
						end
						from
						until
							js.loop_done
						loop
							if (cp.c_pointer.to_integer_32).to_natural_32 > (cmdbuf.c_pointer.to_integer_32).to_natural_32 then
								if (cp[-1]).to_integer_32 = 32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								cmd_left.do_nothing
							end
						end
						Result := 0
						js.return
					end
				when 5 then -- switch 1, case 9
					if not js.return_called then
						in_completion := 0
						cmd_offset := 0
						cmd_home
						cmd_repaint (cp)
						Result := 0
						js.return
					end
				when 6 then -- switch 1, case 10
					if not js.return_called then
						in_completion := 0
						from
						until
							(cp[0]).to_integer_32 = 0
						loop
							cmd_right.do_nothing
						end
						Result := 0
						js.return
					end
				when 7 then -- switch 1, case 7
					if not js.return_called then
						in_completion := 0
						Result := 0
						js.return
					end
				when 8 then -- switch 1, case 1
					if not js.return_called then
						in_completion := 0
						Result := (cmd_erase)
						js.return
					end
				when 9 then -- switch 1, case 2
					if not js.return_called then
						in_completion := 0
						Result := (cmd_kill)
						js.return
					end
				when 10 then -- switch 1, case 11
					if not js.return_called then
						in_completion := 0
						Result := (cmd_werase)
						js.return
					end
				when 11 then -- switch 1, case 8
					if not js.return_called then
						in_completion := 0
						Result := (cmd_delete)
						js.return
					end
				when 12 then -- switch 1, case 12
					if not js.return_called then
						in_completion := 0
						Result := (cmd_wdelete)
						js.return
					end
				when 13 then -- switch 1, case 19
					if not js.return_called then
						literal := 1
						Result := 0
						js.return
					end
				when 14 then -- switch 1, case 13 | switch 1, case 14
					if not js.return_called then
						in_completion := 0
						Result := (cmd_updown (l_action))
						js.return
					end
				when 15 then -- switch 1, case 17 | switch 1, case 18 | switch 1, case 15
					if not js.return_called then
						Result := (cmd_complete (l_action))
						js.return
					end
				when 16 then -- switch 1, case 101
					if not js.return_called then
						Result := 0
						js.return
					end
				when 17 then -- switch 1, default:
					if not js.return_called then
						in_completion := 0
						Result := 3
					end
				when 18 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cmd_erase: INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			if cp.is_equal (cmdbuf) then
				Result := 1
				js.return
			end
			if not js.return_called then
				cmd_left.do_nothing
				l_s := cp
				from
				until
					(l_s[0]).to_integer_32 = 0
				loop
					l_s[0] := l_s[1]
					l_s := l_s + 1
				end
				cmd_repaint (cp)
				if ((curr_cmdflags).bit_and (1)).to_boolean then
					if cp.is_equal (cmdbuf) then
						if (cp[0]).to_integer_32 = 0 then
							Result := 1
							js.return
						end
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cmd_home
		do
			from
			until
				not (cmd_col > prompt_col)
			loop
				screen_inst.putbs
				cmd_col := cmd_col - 1
			end
			cp := cmdbuf + cmd_offset
		end

	cmd_ichar (a_c: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			if (strlen (cmdbuf)) >= ({PLATFORM}.Integer_8_bytes.to_natural_32 * (512).to_natural_32) - {NATURAL_32} 2 then
				screen_inst.bell
				Result := 2
				js.return
			end
			if not js.return_called then
				l_s := cmdbuf + (strlen (cmdbuf)).to_integer_32
				from
				until
					not ((l_s.c_pointer.to_integer_32).to_natural_32 >= (cp.c_pointer.to_integer_32).to_natural_32)
				loop
					l_s[1] := l_s[0]
					l_s := l_s - 1
				end
				cp[0] := a_c.to_integer_8
				cmd_repaint (cp)
				cmd_right.do_nothing
				Result := 0
			end
		end

	cmd_int: INTEGER_32
		local
			l_p: CE_POINTER [INTEGER_8]
			l_n: INTEGER_32
		do
			create l_p.make

			l_n := (0).to_integer_32
			l_p := cmdbuf
			from
			until
				(l_p[0]).to_integer_32 = 0
			loop
				l_n := 10 * l_n + ((l_p[0]).to_integer_32 - 48).to_integer_32
				l_p := l_p + 1
			end
			Result := l_n
		end

	cmd_istr (a_str: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_action: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s := a_str
			from
			until
				not (not js.loop_done and then ((l_s[0]).to_integer_32 /= 0))
			loop
				l_action := cmd_ichar ((l_s[0]).to_integer_32)
				if l_action /= 0 then
					screen_inst.bell
					Result := l_action
					js.return
				end
				if not js.return_called then
					l_s := l_s + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cmd_kill: INTEGER_32
		local
			js: JUMP_STATE
		do
			if (cmdbuf[0]).to_integer_32 = 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				cmd_offset := 0
				cmd_home
				cp[0] := (('%/0/').code).to_integer_8
				cmd_repaint (cp)
				if ((curr_cmdflags).bit_and (1)).to_boolean then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cmd_left: INTEGER_32
		local
			l_p: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p.make
			create l_tmp___1.make

			if (cp.c_pointer.to_integer_32).to_natural_32 <= (cmdbuf.c_pointer.to_integer_32).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_p := charset_inst.prchar ((cp[-1]).to_integer_32)
				if cmd_col < prompt_col + (strlen (l_p)).to_integer_32 then
					cmd_rshift
				end
				cp := cp - 1
				cmd_col := (cmd_col.to_natural_32 - (strlen (l_p))).to_integer_32
				from
				until
					js.loop_done
				loop
					l_tmp___1 := l_p
					l_p := l_p + 1
					if (l_tmp___1[0]).to_integer_32 = 0 then
						js.break
					end
					if not js.loop_jumped then
						screen_inst.putbs
					end
				end
				Result := 0
			end
		end

	cmd_lshift
		local
			l_s: CE_POINTER [INTEGER_8]
			l_save_cp: CE_POINTER [INTEGER_8]
			l_cols: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make
			create l_save_cp.make
			create l_tmp.make

			l_s := cmdbuf + cmd_offset
			l_cols := 0
			from
			until
				js.loop_done
			loop
				if l_cols < (screen_inst.sc_width - prompt_col) // 2 then
					if (l_s[0]).to_integer_32 = 0 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_tmp := l_s
					l_s := l_s + 1
					l_cols := (l_cols.to_natural_32 + (strlen ((charset_inst.prchar ((l_tmp[0]).to_integer_32))))).to_integer_32
				end
			end
			cmd_offset := l_s.distance (cmdbuf)
			l_save_cp := cp
			cmd_home
			cmd_repaint (l_save_cp)
		end

	cmd_putstr (a_s: CE_POINTER [INTEGER_8])
		do
			output_inst.putstr (a_s)
			cmd_col := (cmd_col.to_natural_32 + (strlen (a_s))).to_integer_32
			prompt_col := (prompt_col.to_natural_32 + (strlen (a_s))).to_integer_32
		end

	cmd_repaint (a_old_cp: CE_POINTER [INTEGER_8])
		local
			l_p: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p.make

			screen_inst.clear_eol
			from
			until
				not (not js.loop_done and then ((cp[0]).to_integer_32 /= 0))
			loop
				l_p := charset_inst.prchar ((cp[0]).to_integer_32)
				if cmd_col + (strlen (l_p)).to_integer_32 >= screen_inst.sc_width then
					js.break
				end
				if not js.loop_jumped then
					output_inst.putstr (l_p)
					cmd_col := (cmd_col.to_natural_32 + (strlen (l_p))).to_integer_32
					cp := cp + 1
				end
			end
			from
			until
				not ((cp.c_pointer.to_integer_32).to_natural_32 > (a_old_cp.c_pointer.to_integer_32).to_natural_32)
			loop
				cmd_left.do_nothing
			end
		end

	cmd_reset
		do
			cp := cmdbuf
			cp[0] := (('%/0/').code).to_integer_8
			cmd_col := 0
			cmd_offset := 0
			literal := 0
		end

	cmd_right: INTEGER_32
		local
			l_p: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p.make

			if (cp[0]).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_p := charset_inst.prchar ((cp[0]).to_integer_32)
				if cmd_col + (strlen (l_p)).to_integer_32 >= screen_inst.sc_width then
					cmd_lshift
				elseif cmd_col + (strlen (l_p)).to_integer_32 = screen_inst.sc_width - 1 then
					if (cp[1]).to_integer_32 /= 0 then
						cmd_lshift
					end
				end
				cp := cp + 1
				output_inst.putstr (l_p)
				cmd_col := (cmd_col.to_natural_32 + (strlen (l_p))).to_integer_32
				Result := 0
			end
		end

	cmd_rshift
		local
			l_s: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_save_cp: CE_POINTER [INTEGER_8]
			l_cols: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make
			create l_p.make
			create l_save_cp.make

			l_s := cmdbuf + cmd_offset
			l_cols := 0
			from
			until
				js.loop_done
			loop
				if l_cols < (screen_inst.sc_width - prompt_col) // 2 then
					if not ((l_s.c_pointer.to_integer_32).to_natural_32 > (cmdbuf.c_pointer.to_integer_32).to_natural_32) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_s := l_s - 1
					l_p := charset_inst.prchar ((l_s[0]).to_integer_32)
					l_cols := (l_cols.to_natural_32 + (strlen (l_p))).to_integer_32
				end
			end
			cmd_offset := l_s.distance (cmdbuf)
			l_save_cp := cp
			cmd_home
			cmd_repaint (l_save_cp)
		end

	cmd_updown (a_action: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			if curr_mlist.is_void then
				screen_inst.bell
				Result := 0
				js.return
			end
			if not js.return_called then
				cmd_home
				screen_inst.clear_eol
				if a_action = 13 then
					curr_mlist.item.curr_mp := (curr_mlist.item.curr_mp).item.prev
				else
					curr_mlist.item.curr_mp := (curr_mlist.item.curr_mp).item.next
				end
				l_s := (curr_mlist.item.curr_mp).item.string
				if l_s.is_void then
					l_s := ce_string ("")
				end
				cp := cmdbuf
				from
				until
					(l_s[0]).to_integer_32 = 0
				loop
					cp[0] := l_s[0]
					cmd_right.do_nothing
					l_s := l_s + 1
				end
				cp[0] := (('%/0/').code).to_integer_8
				Result := 0
			end
		end

	cmd_wdelete: INTEGER_32
		local
			js: JUMP_STATE
		do
			if (cp[0]).to_integer_32 = 32 then
				from
				until
					(cp[0]).to_integer_32 /= 32
				loop
					cmd_delete.do_nothing
				end
			else
				from
				until
					js.loop_done
				loop
					if (cp[0]).to_integer_32 /= 32 then
						if (cp[0]).to_integer_32 = 0 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						cmd_delete.do_nothing
					end
				end
			end
			Result := 0
		end

	cmd_werase: INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((cp.c_pointer.to_integer_32).to_natural_32 > (cmdbuf.c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (cp[-1]).to_integer_32 = 32 then
							from
							until
								js.loop_done
							loop
								if (cp.c_pointer.to_integer_32).to_natural_32 > (cmdbuf.c_pointer.to_integer_32).to_natural_32 then
									if (cp[-1]).to_integer_32 /= 32 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									cmd_erase.do_nothing
								end
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							if (cp.c_pointer.to_integer_32).to_natural_32 > (cmdbuf.c_pointer.to_integer_32).to_natural_32 then
								if (cp[-1]).to_integer_32 = 32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								cmd_erase.do_nothing
							end
						end
				when 4 then
					Result := 0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	delimit_word: CE_POINTER [INTEGER_8]
		local
			l_word: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_delim_quoted: INTEGER_32
			l_meta_quoted: INTEGER_32
			l_esc: CE_POINTER [INTEGER_8]
			l_esclen: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_word.make
			create l_p.make
			create l_esc.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_delim_quoted := 0
					l_meta_quoted := 0
					l_esc := (filename_inst.get_meta_escape)
					l_esclen := (strlen (l_esc)).to_integer_32
					if (cp[0]).to_integer_32 = 32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (cp[0]).to_integer_32 /= 0 then
							from
							until
								js.loop_done
							loop
								if (cp[0]).to_integer_32 /= 32 then
									if (cp[0]).to_integer_32 = 0 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									cmd_right.do_nothing
								end
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (cp.c_pointer.to_integer_32).to_natural_32 > (cmdbuf.c_pointer.to_integer_32).to_natural_32 then
							if (cp[-1]).to_integer_32 /= 32 then
								l_tmp___1 := 1
							else
								l_tmp___1 := 0
							end
						else
							l_tmp___1 := 0
						end
				when 4 then
					if cp.is_equal (cmdbuf) then
						Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_word := cmdbuf
						from
						until
							not (not js.loop_done and then ((l_word.c_pointer.to_integer_32).to_natural_32 < (cp.c_pointer.to_integer_32).to_natural_32))
						loop
							if (l_word[0]).to_integer_32 /= 32 then
								js.break
							end
							if not js.loop_jumped then
								l_word := l_word + 1
							end
						end
						if (l_word.c_pointer.to_integer_32).to_natural_32 >= (cp.c_pointer.to_integer_32).to_natural_32 then
							Result := cp
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 5 then -- if:
						l_p := cmdbuf
				when 6 then -- loop condition:
						if not ((l_p.c_pointer.to_integer_32).to_natural_32 < (cp.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 15 -- skip loop
						end
				when 7 then -- loop body:
						if not (l_meta_quoted.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_meta_quoted := 0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not (l_esclen > 0) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if ((l_p + l_esclen).c_pointer.to_integer_32).to_natural_32 < (cp.c_pointer.to_integer_32).to_natural_32 then
							if (strncmp (l_p, l_esc, l_esclen.to_natural_32)) = 0 then
								l_meta_quoted := 1
								l_p := l_p + (l_esclen - 1)
							else
								l_pos := -1 + 13 -- goto _L___1
							end
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___1:
						if l_delim_quoted.to_boolean then
							if (l_p[0]).to_integer_32 = closequote.to_integer_32 then
								l_delim_quoted := 0
							end
						elseif (l_p[0]).to_integer_32 = openquote.to_integer_32 then
							l_delim_quoted := 1
						elseif (l_p[0]).to_integer_32 = 32 then
							l_word := l_p + 1
						end
				when 14 then -- if done
						l_p := l_p + 1
						l_pos := -1 + 6 -- back to loop condition
				when 15 then -- loop done
						Result := l_word
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_cmdbuf: CE_POINTER [INTEGER_8]
		do
			Result := cmdbuf
		end

	init_compl
		local
			l_word: CE_POINTER [INTEGER_8]
			l_c: INTEGER_8
			l_qword: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_word.make
			create l_qword.make

			if not tk_text.is_void then
				free (create {CE_POINTER [ANY]}.make_cast (tk_text))
				tk_text := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			l_word := delimit_word
			if l_word.is_void then
				js.return
			end
			if not js.return_called then
				tk_ipoint := l_word
				if not tk_original.is_void then
					free (create {CE_POINTER [ANY]}.make_cast (tk_original))
				end
				tk_original := create {CE_POINTER [INTEGER_8]}.make_cast ((main_inst.ecalloc ((cp.distance (l_word)) + 1, {PLATFORM}.Integer_8_bytes.to_natural_32)))
				strncpy (tk_original, l_word, (cp.distance (l_word)).to_natural_32).do_nothing
				l_c := cp[0]
				cp[0] := (('%/0/').code).to_integer_8
				if (l_word[0]).to_integer_32 /= openquote.to_integer_32 then
					tk_text := filename_inst.fcomplete (l_word)
				else
					l_qword := (filename_inst.shell_quote (l_word + 1))
					if l_qword.is_void then
						tk_text := filename_inst.fcomplete (l_word + 1)
					else
						tk_text := filename_inst.fcomplete (l_qword)
						free (create {CE_POINTER [ANY]}.make_cast (l_qword))
					end
				end
				cp[0] := l_c
			end
		end

	len_cmdbuf: INTEGER_32
		do
			Result := (strlen (cmdbuf)).to_integer_32
		end

	next_compl (a_action: INTEGER_32; a_prev: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_action -- switch 1 head
					when 17 then l_pos := -1 + 1
					when 18 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 17
					Result := (edit_inst.forw_textlist (tk_tlist, a_prev))
					js.return
				when 2 then -- switch 1, case 18
					if not js.return_called then
						Result := (edit_inst.back_textlist (tk_tlist, a_prev))
						js.return
					end
				when 3 then -- switch 1, done:
					if not js.return_called then
						Result := (ce_string ("?"))
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_mlist (a_mlist: CE_POINTER [ANY]; a_cmdflags: INTEGER_32)
		do
			curr_mlist := create {CE_POINTER [PD_MLIST]}.make_cast (a_mlist)
			curr_cmdflags := a_cmdflags
		end

end
