class
	P_COMMAND

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create quit_at_eof.make (<<1>>)
			create quit_if_one_screen.make (<<1>>)
			create shellcmd.make
			create shift_count.make (<<1>>)
			create show_attn.make (<<1>>)
			create swindow.make (<<1>>)
			create top_scroll.make (<<1>>)
			create ungot.make (<<100>>)
			create ungotp.make
		end

feature {ANY} -- attributes

	bottompos: INTEGER_32 assign set_bottompos

	set_bottompos (a_bottompos: INTEGER_32)
		do
			bottompos := a_bottompos
		end

	hit_eof: INTEGER_32 assign set_hit_eof

	set_hit_eof (a_hit_eof: INTEGER_32)
		do
			hit_eof := a_hit_eof
		end

	hshift: INTEGER_32 assign set_hshift

	set_hshift (a_hshift: INTEGER_32)
		do
			hshift := a_hshift
		end

	mca: INTEGER_32 assign set_mca

	set_mca (a_mca: INTEGER_32)
		do
			mca := a_mca
		end

	number: INTEGER_32 assign set_number

	set_number (a_number: INTEGER_32)
		do
			number := a_number
		end

	optchar: INTEGER_8 assign set_optchar

	set_optchar (a_optchar: INTEGER_8)
		do
			optchar := a_optchar
		end

	optflag: INTEGER_32 assign set_optflag

	set_optflag (a_optflag: INTEGER_32)
		do
			optflag := a_optflag
		end

	optgetname: INTEGER_32 assign set_optgetname

	set_optgetname (a_optgetname: INTEGER_32)
		do
			optgetname := a_optgetname
		end

	pipec: INTEGER_8 assign set_pipec

	set_pipec (a_pipec: INTEGER_8)
		do
			pipec := a_pipec
		end

	quit_at_eof: CE_ARRAY [INTEGER_32]

	quit_if_one_screen: CE_ARRAY [INTEGER_32]

	screen_trashed: INTEGER_32 assign set_screen_trashed

	set_screen_trashed (a_screen_trashed: INTEGER_32)
		do
			screen_trashed := a_screen_trashed
		end

	search_type: INTEGER_32 assign set_search_type

	set_search_type (a_search_type: INTEGER_32)
		do
			search_type := a_search_type
		end

	shellcmd: CE_POINTER [INTEGER_8] assign set_shellcmd

	set_shellcmd (a_shellcmd: CE_POINTER [INTEGER_8])
		do
			shellcmd := a_shellcmd
		end

	shift_count: CE_ARRAY [INTEGER_32]

	show_attn: CE_ARRAY [INTEGER_32]

	swindow: CE_ARRAY [INTEGER_32]

	top_scroll: CE_ARRAY [INTEGER_32]

	ungot: CE_ARRAY [INTEGER_8]

	ungotp: CE_POINTER [INTEGER_8] assign set_ungotp

	set_ungotp (a_ungotp: CE_POINTER [INTEGER_8])
		do
			ungotp := a_ungotp
		end

feature {ANY} -- routines

	cmd_exec
		do
			search_inst.clear_attn
			screen_inst.lower_left
			output_inst.flush
		end

	commands
		local
			l_c: INTEGER_32
			l_action: INTEGER_32
			l_cbuf: CE_POINTER [INTEGER_8]
			l_newaction: INTEGER_32
			l_save_search_type: INTEGER_32
			l_extra: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tbuf___0: CE_ARRAY [INTEGER_8]
			l_parg: CE_ARRAY [PD_PARG]
			l_old_ifile___0: CE_POINTER [ANY]
			l_new_ifile___0: CE_POINTER [ANY]
			l_tagfile: CE_POINTER [INTEGER_8]
			l_pos2: INTEGER_32
			l_pos___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cbuf.make
			create l_extra.make (<<1>>)
			create l_tbuf___0.make (<<2>>)
			create l_parg.make (<<1>>)
			create l_old_ifile___0.make
			create l_new_ifile___0.make
			create l_tagfile.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					search_type := 1
					main_inst.wscroll := (screen_inst.sc_height + 1) // 2
					l_newaction := 101
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 92 -- skip loop
					end
				when 2 then -- loop body:
						mca := 0
						cmdbuf_inst.cmd_accept
						number := (0).to_integer_32
						optchar := (('%/0/').code).to_integer_8
						if ch_inst.sigs.to_boolean then
							signal_inst.psignals
							if main_inst.quitting.to_boolean then
								main_inst.quit (-1)
							end
						end
						screen_inst.check_winch
						cmdbuf_inst.cmd_reset
						prompt
						if ch_inst.sigs.to_boolean then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_newaction = 101 then
							l_c := getcc
						end
				when 4 then -- again:
						if ch_inst.sigs.to_boolean then
							js.continue
						end
				when 5 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 6 then -- if:
						if l_newaction = 101 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_action := l_newaction
						l_newaction := 101
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 9 then -- else:
						if not (mca.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 10 then -- if:
						inspect (mca_char (l_c)) -- switch 1 head
						when 2 then l_pos := -1 + 11
						when 1 then l_pos := -1 + 12
						when 0 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 11 then -- switch 1, case 2
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 12 then -- switch 1, case 1
						js.continue
				when 13 then -- switch 1, case 0
						l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done: | if done
						if not js.loop_jumped then
							if mca.to_boolean then
								if (cmdbuf_inst.cmd_char (l_c)) = 1 then
									js.continue
								elseif (cmdbuf_inst.len_cmdbuf) = 0 then
									js.continue
								end
								if not js.loop_jumped then
									l_cbuf := cmdbuf_inst.get_cmdbuf
								end
							else
								l_tbuf___0[0] := l_c.to_integer_8
								l_tbuf___0[1] := (('%/0/').code).to_integer_8
								l_cbuf := l_tbuf___0
							end
						end
						if not js.loop_jumped then
							l_extra.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							l_action := decode_inst.fcmd_decode (l_cbuf, l_extra)
							if not (l_extra.item).is_void then
								ungetsc (l_extra.item)
							end
						end
				when 15 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 91 -- skip if block
						end
				when 16 then -- if:
						if l_action /= 22 then
							cmdbuf_inst.cmd_reset
						end
						inspect l_action -- switch 2 head
						when 6 then l_pos := -1 + 17
						when 33 then l_pos := -1 + 18
						when 13 then l_pos := -1 + 19
						when 34 then l_pos := -1 + 20
						when 3 then l_pos := -1 + 21
						when 12 then l_pos := -1 + 22
						when 2 then l_pos := -1 + 23
						when 29 then l_pos := -1 + 24
						when 30 then l_pos := -1 + 25
						when 40 then l_pos := -1 + 26
						when 50 then l_pos := -1 + 27
						when 14 then l_pos := -1 + 29
						when 4 then l_pos := -1 + 30
						when 11 then l_pos := -1 + 31
						when 25 then l_pos := -1 + 32
						when 17 then l_pos := -1 + 33
						when 21 then l_pos := -1 + 34
						when 16 then l_pos := -1 + 35
						when 51 then l_pos := -1 + 36
						when 28 then l_pos := -1 + 37
						when 31 then l_pos := -1 + 39
						when 24 then l_pos := -1 + 40
						when 15 then l_pos := -1 + 42
						when 5 then l_pos := -1 + 43
						when 43 then l_pos := -1 + 44
						when 44 then l_pos := -1 + 45
						when 45 then l_pos := -1 + 46
						when 46 then l_pos := -1 + 47
						when 39 then l_pos := -1 + 48
						when 19 then l_pos := -1 + 49
						when 9 then l_pos := -1 + 51
						when 32 then l_pos := -1 + 53
						when 20 then l_pos := -1 + 58
						when 23 then l_pos := -1 + 60
						when 53 then l_pos := -1 + 62
						when 54 then l_pos := -1 + 64
						when 38 then l_pos := -1 + 66
						when 52 then l_pos := -1 + 67
						when 47 then l_pos := -1 + 71
						when 7 then l_pos := -1 + 72
						when 10 then l_pos := -1 + 73
						when 27 then l_pos := -1 + 74
						when 26 then l_pos := -1 + 76
						when 18 then l_pos := -1 + 79
						when 37 then l_pos := -1 + 81
						when 36 then l_pos := -1 + 85
						when 35 then l_pos := -1 + 85
						when 41 then l_pos := -1 + 86
						when 42 then l_pos := -1 + 87
						when 22 then l_pos := -1 + 88
						when 101 then l_pos := -1 + 89
						else l_pos := -1 + 90
						end
				when 17 then -- switch 2, case 6
						start_mca (6, ce_string (":"), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1)
						l_pos := -1 + 4 -- goto again
				when 18 then -- switch 2, case 33
						if number > 0 then
							swindow.item := number.to_integer_32
						end
				when 19 then -- switch 2, case 13
						if number <= 0 then
							number := (optfunc_inst.get_swindow).to_integer_32
						end
						cmd_exec
						if (show_attn.item).to_boolean then
							input_inst.set_attnpos (bottompos)
						end
						forwback_inst.forward (number.to_integer_32, 0, 1)
						l_pos := -1 + 91 -- switch 2; break
				when 20 then -- switch 2, case 34
						if number > 0 then
							swindow.item := number.to_integer_32
						end
				when 21 then -- switch 2, case 3
						if number <= 0 then
							number := (optfunc_inst.get_swindow).to_integer_32
						end
						cmd_exec
						forwback_inst.backward (number.to_integer_32, 0, 1)
						l_pos := -1 + 91 -- switch 2; break
				when 22 then -- switch 2, case 12
						if number <= 0 then
							number := (1).to_integer_32
						end
						cmd_exec
						if show_attn.item = 2 then
							if number > 1 then
								input_inst.set_attnpos (bottompos)
							end
						end
						forwback_inst.forward (number.to_integer_32, 0, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 23 then -- switch 2, case 2
						if number <= 0 then
							number := (1).to_integer_32
						end
						cmd_exec
						forwback_inst.backward (number.to_integer_32, 0, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 24 then -- switch 2, case 29
						if number <= 0 then
							number := (1).to_integer_32
						end
						cmd_exec
						if show_attn.item = 2 then
							if number > 1 then
								input_inst.set_attnpos (bottompos)
							end
						end
						forwback_inst.forward (number.to_integer_32, 1, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 25 then -- switch 2, case 30
						if number <= 0 then
							number := (1).to_integer_32
						end
						cmd_exec
						forwback_inst.backward (number.to_integer_32, 1, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 26 then -- switch 2, case 40
						if number <= 0 then
							number := (optfunc_inst.get_swindow).to_integer_32
						end
						cmd_exec
						if show_attn.item = 2 then
							input_inst.set_attnpos (bottompos)
						end
						forwback_inst.forward (number.to_integer_32, 1, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 27 then -- switch 2, case 50
						if (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 28 then
						cmd_exec
						jump_inst.jump_forw
						ch_inst.ignore_eoi := 1
						hit_eof := 0
						from
						until
							ch_inst.sigs.to_boolean
						loop
							forwback_inst.forward (1, 0, 0)
						end
						ch_inst.ignore_eoi := 0
						if ch_inst.sigs.to_boolean then
							if not ((ch_inst.sigs).bit_and (3)).to_boolean then
								l_newaction := 50
							end
						end
						l_pos := -1 + 91 -- switch 2; break
				when 29 then -- switch 2, case 14
						if number > 0 then
							main_inst.wscroll := number.to_integer_32
						end
						cmd_exec
						if show_attn.item = 2 then
							input_inst.set_attnpos (bottompos)
						end
						forwback_inst.forward (main_inst.wscroll, 0, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 30 then -- switch 2, case 4
						if number > 0 then
							main_inst.wscroll := number.to_integer_32
						end
						cmd_exec
						forwback_inst.backward (main_inst.wscroll, 0, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 31 then -- switch 2, case 11
						if (((ch_inst.ch_getflags)).bit_and (1)).to_boolean then
							ch_inst.ch_flush
							linenum_inst.clr_linenum
							search_inst.clr_hilite
						end
				when 32 then -- switch 2, case 25
						cmd_exec
						jump_inst.repaint
						l_pos := -1 + 91 -- switch 2; break
				when 33 then -- switch 2, case 17
						if number <= 0 then
							number := (1).to_integer_32
						end
						cmd_exec
						jump_inst.jump_back (number)
						l_pos := -1 + 91 -- switch 2; break
				when 34 then -- switch 2, case 21
						if number < 0 then
							number := (0).to_integer_32
						end
						if number > 100 then
							number := (100).to_integer_32
						end
						cmd_exec
						jump_inst.jump_percent (number.to_integer_32)
						l_pos := -1 + 91 -- switch 2; break
				when 35 then -- switch 2, case 16
						cmd_exec
						if number <= 0 then
							jump_inst.jump_forw
						else
							jump_inst.jump_back (number)
						end
						l_pos := -1 + 91 -- switch 2; break
				when 36 then -- switch 2, case 51
						cmd_exec
						if number < 0 then
							number := (0).to_integer_32
						end
						jump_inst.jump_line_loc (number, main_inst.jump_sline.item)
						l_pos := -1 + 91 -- switch 2; break
				when 37 then -- switch 2, case 28
						if (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 38 then
						cmd_exec
						l_parg.item.p_string := prompt_inst.eq_message
						output_inst.error (ce_string ("%%s"), l_parg)
						l_pos := -1 + 91 -- switch 2; break
				when 39 then -- switch 2, case 31
						cmd_exec
						dispversion
						l_pos := -1 + 91 -- switch 2; break
				when 40 then -- switch 2, case 24
						if not main_inst.curr_ifile.is_void then
							if (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
								if (edit_inst.edit_prev (1)) = 0 then
									l_pos := -1 + 91 -- switch 2; break
								end
							end
						end
				when 41 then
						if not (l_extra.item).is_void then
							main_inst.quit ((l_extra.item[0]).to_integer_32)
						end
						main_inst.quit (0)
						l_pos := -1 + 91 -- switch 2; break
				when 42 then -- switch 2, case 15
						search_type := 1
						if number <= 0 then
							number := (1).to_integer_32
						end
						mca_search
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 43 then -- switch 2, case 5
						search_type := 2
						if number <= 0 then
							number := (1).to_integer_32
						end
						mca_search
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 44 then -- switch 2, case 43
						if number <= 0 then
							number := (1).to_integer_32
						end
						mca_search
						cmd_exec
						multi_search (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), number.to_integer_32)
						l_pos := -1 + 91 -- switch 2; break
				when 45 then -- switch 2, case 44
						search_type := (search_type).bit_or ((128))
						if number <= 0 then
							number := (1).to_integer_32
						end
						mca_search
						cmd_exec
						multi_search (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), number.to_integer_32)
						l_pos := -1 + 91 -- switch 2; break
				when 46 then -- switch 2, case 45
						l_save_search_type := search_type
						if ((search_type).bit_and (1)).to_boolean then
							search_type := (((search_type).bit_and (-2))).bit_or (2)
						else
							search_type := (((search_type).bit_and (-3))).bit_or (1)
						end
						if number <= 0 then
							number := (1).to_integer_32
						end
						mca_search
						cmd_exec
						multi_search (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), number.to_integer_32)
						search_type := l_save_search_type
						l_pos := -1 + 91 -- switch 2; break
				when 47 then -- switch 2, case 46
						l_save_search_type := search_type
						if ((search_type).bit_and (1)).to_boolean then
							search_type := (((search_type).bit_and (-2))).bit_or (2)
						else
							search_type := (((search_type).bit_and (-3))).bit_or (1)
						end
						search_type := (search_type).bit_or ((128))
						if number <= 0 then
							number := (1).to_integer_32
						end
						mca_search
						cmd_exec
						multi_search (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), number.to_integer_32)
						search_type := l_save_search_type
						l_pos := -1 + 91 -- switch 2; break
				when 48 then -- switch 2, case 39
						search_inst.undo_search
						l_pos := -1 + 91 -- switch 2; break
				when 49 then -- switch 2, case 19
						if (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 50 then
						cmd_exec
						edit_inst.edit (ce_string ("@/\less/\help/\file/\@")).do_nothing
						l_pos := -1 + 91 -- switch 2; break
				when 51 then -- switch 2, case 9
						if main_inst.secure.to_boolean then
							output_inst.error (ce_string ("Command not available"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 52 then
						start_mca (9, ce_string ("Examine: "), cmdbuf_inst.ml_examine, 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 53 then -- switch 2, case 32
						if main_inst.secure.to_boolean then
							output_inst.error (ce_string ("Command not available"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 54 then
						if (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 55 then
						if (strcmp ((ifile_inst.get_filename (main_inst.curr_ifile)), ce_string ("-"))) = 0 then
							output_inst.error (ce_string ("Cannot edit standard input"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 56 then
						if not edit_inst.curr_altfilename.is_void then
							output_inst.error (ce_string ("Cannot edit file processed with LESSOPEN"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 57 then
						start_mca (27, ce_string ("!"), cmdbuf_inst.ml_shell, 0)
						make_display
						cmd_exec
						lsystem_inst.lsystem ((prompt_inst.pr_expand (main_inst.editproto, 0)), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						l_pos := -1 + 91 -- switch 2; break
				when 58 then -- switch 2, case 20
						if (tags_inst.ntags).to_boolean then
							output_inst.error (ce_string ("No next file"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 59 then
						if number <= 0 then
							number := (1).to_integer_32
						end
						if (edit_inst.edit_next (number.to_integer_32)).to_boolean then
							if (quit_at_eof.item).to_boolean then
								if hit_eof.to_boolean then
									if not (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
										main_inst.quit (0)
									end
								end
							end
							if number > 1 then
								l_parg.item.p_string := ce_string ("(N-th) ")
							else
								l_parg.item.p_string := ce_string ("")
							end
							output_inst.error (ce_string ("No %%snext file"), l_parg)
						end
						l_pos := -1 + 91 -- switch 2; break
				when 60 then -- switch 2, case 23
						if (tags_inst.ntags).to_boolean then
							output_inst.error (ce_string ("No previous file"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 61 then
						if number <= 0 then
							number := (1).to_integer_32
						end
						if (edit_inst.edit_prev (number.to_integer_32)).to_boolean then
							if number > 1 then
								l_parg.item.p_string := ce_string ("(N-th) ")
							else
								l_parg.item.p_string := ce_string ("")
							end
							output_inst.error (ce_string ("No %%sprevious file"), l_parg)
						end
						l_pos := -1 + 91 -- switch 2; break
				when 62 then -- switch 2, case 53
						if number <= 0 then
							number := (1).to_integer_32
						end
						l_tagfile := tags_inst.nexttag (number.to_integer_32)
						if l_tagfile.is_void then
							output_inst.error (ce_string ("No next tag"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 63 then
						if (edit_inst.edit (l_tagfile)) = 0 then
							l_pos2 := (tags_inst.tagsearch)
							if l_pos2 /= -1 then
								jump_inst.jump_loc (l_pos2, main_inst.jump_sline.item)
							end
						end
						l_pos := -1 + 91 -- switch 2; break
				when 64 then -- switch 2, case 54
						if number <= 0 then
							number := (1).to_integer_32
						end
						l_tagfile := tags_inst.prevtag (number.to_integer_32)
						if l_tagfile.is_void then
							output_inst.error (ce_string ("No previous tag"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 65 then
						if (edit_inst.edit (l_tagfile)) = 0 then
							l_pos___0 := (tags_inst.tagsearch)
							if l_pos___0 /= -1 then
								jump_inst.jump_loc (l_pos___0, main_inst.jump_sline.item)
							end
						end
						l_pos := -1 + 91 -- switch 2; break
				when 66 then -- switch 2, case 38
						if number <= 0 then
							number := (1).to_integer_32
						end
						if (edit_inst.edit_index (number.to_integer_32)).to_boolean then
							output_inst.error (ce_string ("No such file"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
						end
						l_pos := -1 + 91 -- switch 2; break
				when 67 then -- switch 2, case 52
						if (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 68 then
						l_old_ifile___0 := main_inst.curr_ifile
						l_new_ifile___0 := ifile_inst.getoff_ifile (main_inst.curr_ifile)
						if l_new_ifile___0.is_void then
							screen_inst.bell
							l_pos := -1 + 91 -- switch 2; break
						end
				when 69 then
						if (edit_inst.edit_ifile (l_new_ifile___0)) /= 0 then
							edit_inst.reedit_ifile (l_old_ifile___0)
							l_pos := -1 + 91 -- switch 2; break
						end
				when 70 then
						ifile_inst.del_ifile (l_old_ifile___0)
						l_pos := -1 + 91 -- switch 2; break
				when 71 then -- switch 2, case 47
						optflag := 1
						optgetname := 0
						mca_opt_toggle
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 72 then -- switch 2, case 7
						optflag := 0
						optgetname := 0
						mca_opt_toggle
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 73 then -- switch 2, case 10
						start_mca (10, ce_string ("+"), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 74 then -- switch 2, case 27
						if main_inst.secure.to_boolean then
							output_inst.error (ce_string ("Command not available"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 75 then
						start_mca (27, ce_string ("!"), cmdbuf_inst.ml_shell, 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 76 then -- switch 2, case 26
						if (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 77 then
						start_mca (26, ce_string ("mark: "), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
						l_c := getcc
						if l_c = screen_inst.erase_char then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = screen_inst.kill_char then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = 10 then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = 13 then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 78 then
						mark_inst.setmark (l_c)
						l_pos := -1 + 91 -- switch 2; break
				when 79 then -- switch 2, case 18
						start_mca (18, ce_string ("goto mark: "), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
						l_c := getcc
						if l_c = screen_inst.erase_char then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = screen_inst.kill_char then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = 10 then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = 13 then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 80 then
						mark_inst.gomark (l_c)
						l_pos := -1 + 91 -- switch 2; break
				when 81 then -- switch 2, case 37
						if main_inst.secure.to_boolean then
							output_inst.error (ce_string ("Command not available"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 82 then
						start_mca (37, ce_string ("|mark: "), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
						l_c := getcc
						if l_c = screen_inst.erase_char then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = screen_inst.kill_char then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 83 then
						if l_c = 10 then
							l_c := ('.').code
						elseif l_c = 13 then
							l_c := ('.').code
						end
						if (mark_inst.badmark (l_c)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 84 then
						pipec := l_c.to_integer_8
						start_mca (37, ce_string ("!"), cmdbuf_inst.ml_shell, 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 85 then -- switch 2, case 36 | switch 2, case 35
						start_mca (l_action, ce_string ("Brackets: "), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 86 then -- switch 2, case 41
						if number > 0 then
							shift_count.item := number.to_integer_32
						elseif shift_count.item > 0 then
							number := (shift_count.item).to_integer_32
						else
							number := (screen_inst.sc_width // 2).to_integer_32
						end
						if number > hshift.to_integer_32 then
							number := hshift.to_integer_32
						end
						hshift := (hshift.to_integer_32 - number).to_integer_32
						screen_trashed := 1
						l_pos := -1 + 91 -- switch 2; break
				when 87 then -- switch 2, case 42
						if number > 0 then
							shift_count.item := number.to_integer_32
						elseif shift_count.item > 0 then
							number := (shift_count.item).to_integer_32
						else
							number := (screen_inst.sc_width // 2).to_integer_32
						end
						hshift := (hshift.to_integer_32 + number).to_integer_32
						screen_trashed := 1
						l_pos := -1 + 91 -- switch 2; break
				when 88 then -- switch 2, case 22
						if mca /= 22 then
							cmdbuf_inst.cmd_reset
							start_mca (22, ce_string (" "), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1)
							cmdbuf_inst.cmd_char (l_c).do_nothing
						end
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 89 then -- switch 2, case 101
						l_pos := -1 + 91 -- switch 2; break
				when 90 then -- switch 2, default:
						screen_inst.bell
						l_pos := -1 + 91 -- switch 2; break
				when 91 then -- switch 2, done: | if done
						if js.loop_increment then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 92 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dispversion
		local
			l_parg: CE_ARRAY [PD_PARG]
		do
			create l_parg.make (<<1>>)

			l_parg.item.p_string := version_inst.version
			output_inst.error (ce_string ("less %%s"), l_parg)
		end

	exec_mca
		local
			l_cbuf: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cbuf.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					cmd_exec
					l_cbuf := cmdbuf_inst.get_cmdbuf
					inspect mca -- switch 1 head
					when 15 then l_pos := -1 + 1
					when 5 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					when 47 then l_pos := -1 + 3
					when 35 then l_pos := -1 + 4
					when 36 then l_pos := -1 + 5
					when 9 then l_pos := -1 + 6
					when 27 then l_pos := -1 + 8
					when 37 then l_pos := -1 + 10
					else l_pos := -1 + 12
					end
				when 1 then -- switch 1, case 15 | switch 1, case 5
					multi_search (l_cbuf, number.to_integer_32)
					l_pos := -1 + 12 -- switch 1; break
				when 2 then -- switch 1, case 10
					from
					until
						js.loop_done
					loop
						if (l_cbuf[0]).to_integer_32 /= 43 then
							if (l_cbuf[0]).to_integer_32 /= 32 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_cbuf := l_cbuf + 1
						end
					end
					if not main_inst.every_first_cmd.is_void then
						free (create {CE_POINTER [ANY]}.make_cast (main_inst.every_first_cmd))
					end
					if (l_cbuf[0]).to_integer_32 = 0 then
						main_inst.every_first_cmd := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					else
						main_inst.every_first_cmd := main_inst.save (l_cbuf)
					end
					l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 47
					option_inst.toggle_option (optchar.to_integer_32, l_cbuf, optflag)
					optchar := (('%/0/').code).to_integer_8
					l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 35
					brac_inst.match_brac ((l_cbuf[0]).to_integer_32, (l_cbuf[1]).to_integer_32, 1, number.to_integer_32)
					l_pos := -1 + 12 -- switch 1; break
				when 5 then -- switch 1, case 36
					brac_inst.match_brac ((l_cbuf[1]).to_integer_32, (l_cbuf[0]).to_integer_32, 0, number.to_integer_32)
					l_pos := -1 + 12 -- switch 1; break
				when 6 then -- switch 1, case 9
					if main_inst.secure.to_boolean then
						l_pos := -1 + 12 -- switch 1; break
					end
				when 7 then
					edit_inst.edit_list (l_cbuf).do_nothing
					tags_inst.cleantags
					l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 27
					if (l_cbuf[0]).to_integer_32 /= 33 then
						if not shellcmd.is_void then
							free (create {CE_POINTER [ANY]}.make_cast (shellcmd))
						end
						shellcmd := filename_inst.fexpand (l_cbuf)
					end
					if main_inst.secure.to_boolean then
						l_pos := -1 + 12 -- switch 1; break
					end
				when 9 then
					if shellcmd.is_void then
						lsystem_inst.lsystem (ce_string (""), ce_string ("!done"))
					else
						lsystem_inst.lsystem (shellcmd, ce_string ("!done"))
					end
					l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 37
					if main_inst.secure.to_boolean then
						l_pos := -1 + 12 -- switch 1; break
					end
				when 11 then
					lsystem_inst.pipe_mark (pipec.to_integer_32, l_cbuf).do_nothing
					output_inst.error (ce_string ("|done"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
					l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getcc: INTEGER_32
		local
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ungotp.is_void then
						Result := (ttyin_inst.getchr)
						js.return
					end
					if not js.return_called and then ((ungotp.c_pointer.to_integer_32).to_natural_32 > (ungot.c_pointer.to_integer_32).to_natural_32) then
						ungotp := ungotp - 1
						Result := (ungotp[0]).to_integer_32
						js.return
					end
					if not js.return_called then
						ungotp := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						if (cmdbuf_inst.len_cmdbuf) = 0 then
							l_tmp___0 := ttyin_inst.getchr
							Result := l_tmp___0
							js.return
						elseif not (position_inst.empty_screen).to_boolean then
							l_tmp___0 := ttyin_inst.getchr
							Result := l_tmp___0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect mca -- switch 1 head
						when 6 then l_pos := -1 + 2
						when 15 then l_pos := -1 + 3
						when 5 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 6
						Result := (('g').code)
						js.return
				when 3 then -- switch 1, case 15 | switch 1, case 5
						if not js.return_called then
							Result := (('%N').code)
							js.return
						end
				when 4 then -- switch 1, default:
						if not js.return_called then
							Result := (ttyin_inst.getchr)
						end
				when 5 then -- switch 1, done:
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	in_mca: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if mca /= 0 then
				if mca /= 22 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	make_display
		local
			l_save_top_scroll: INTEGER_32
		do
			if (position_inst.empty_screen).to_boolean then
				if main_inst.initial_scrpos.item.pos = -1 then
					jump_inst.jump_loc ((0).to_integer_32, 1)
				else
					jump_inst.jump_loc (main_inst.initial_scrpos.item.pos, main_inst.initial_scrpos.item.ln)
				end
			elseif screen_trashed.to_boolean then
				l_save_top_scroll := top_scroll.item
				top_scroll.item := 1
				jump_inst.repaint
				top_scroll.item := l_save_top_scroll
			end
		end

	mca_char (a_c: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_p: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_flag: INTEGER_32
			l_buf___1: CE_ARRAY [INTEGER_8]
			l_parg: CE_ARRAY [PD_PARG]
			l_o: CE_POINTER [PD_LOPTION]
			l_oname: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_lc: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make (<<1>>)
			create l_buf___1.make (<<3>>)
			create l_parg.make (<<1>>)
			create l_o.make
			create l_oname.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					inspect mca -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 22 then l_pos := -1 + 2
					when 6 then l_pos := -1 + 3
					when 47 then l_pos := -1 + 10
					when 15 then l_pos := -1 + 34
					when 5 then l_pos := -1 + 34
					else l_pos := -1 + 44
					end
				when 1 then -- switch 1, case 0
					Result := 0
					js.return
				when 2 then -- switch 1, case 22
					if not js.return_called then
						Result := 0
						js.return
					end
				when 3 then -- switch 1, case 6
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 4 then -- if:
						if not (l_c < 48) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (l_c > 57) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (decode_inst.editchar (l_c, 15)) = 100 then
							number := cmdbuf_inst.cmd_int
							mca := 0
							cmdbuf_inst.cmd_accept
							Result := 0
							js.return
						end
				when 9 then -- if done | if done
						l_pos := -1 + 44 -- switch 1; break
				when 10 then -- switch 1, case 47
						if optchar.to_integer_32 /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 11 then -- if:
							if (cmdbuf_inst.len_cmdbuf) /= 0 then
								l_pos := -1 + 21 -- skip if block
							end
				when 12 then -- if:
							l_flag := (optflag).bit_and (-65)
							if l_flag /= 0 then
								l_pos := -1 + 16 -- skip if block
							end
				when 13 then -- if:
							inspect l_c -- switch 2 head
							when 95 then l_pos := -1 + 14
							else l_pos := -1 + 15
							end
				when 14 then -- switch 2, case 95
							optgetname := 1
							mca_opt_toggle
							Result := 2
							js.return
				when 15 then -- switch 2, done: | if block done, skip else block:
							l_pos := -1 + 21
				when 16 then -- else:
							inspect l_c -- switch 3 head
							when 43 then l_pos := -1 + 17
							when 33 then l_pos := -1 + 18
							when 16 then l_pos := -1 + 19
							when 45 then l_pos := -1 + 20
							else l_pos := -1 + 21
							end
				when 17 then -- switch 3, case 43
							if l_flag = 2 then
								optflag := 1
							else
								optflag := 2
							end
							mca_opt_toggle
							Result := 2
							js.return
				when 18 then -- switch 3, case 33
							if not js.return_called then
								if l_flag = 3 then
									optflag := 1
								else
									optflag := 3
								end
								mca_opt_toggle
								Result := 2
								js.return
							end
				when 19 then -- switch 3, case 16
							if not js.return_called then
								optflag := (optflag).bit_xor ((64))
								mca_opt_toggle
								Result := 2
								js.return
							end
				when 20 then -- switch 3, case 45
							if not js.return_called then
								optgetname := 1
								mca_opt_toggle
								Result := 2
								js.return
							end
				when 21 then -- switch 3, done: | if done | if done | if done
							if js.return_called then
								l_pos := -1 + 33 -- skip if block
							end
				when 22 then -- if:
								if not (optgetname.to_boolean) then
									l_pos := -1 + 31 -- skip if block
								end
				when 23 then -- if:
								if l_c /= 10 then
									l_pos := -1 + 26 -- skip if block
								end
				when 24 then -- if:
								l_pos := -1 + 27 -- goto _L___0
				when 25 then -- if block done, skip else block:
								l_pos := -1 + 30
				when 26 then -- else:
								if l_c /= 13 then
									l_pos := -1 + 29 -- skip if block
								end
				when 27 then -- if: | _L___0:
								if optchar.to_integer_32 = 0 then
									l_parg.item.p_string := cmdbuf_inst.get_cmdbuf
									output_inst.error (ce_string ("There is no --%%s option"), l_parg)
									Result := 1
									js.return
								end
								if not js.return_called then
									optgetname := 0
									cmdbuf_inst.cmd_reset
									l_c := optchar.to_integer_32
								end
				when 28 then -- if block done, skip else block:
								l_pos := -1 + 30
				when 29 then -- else:
								if optchar.to_integer_32 /= 0 then
									if l_c = screen_inst.erase_char then
										Result := 1
										js.return
									elseif l_c = screen_inst.kill_char then
										Result := 1
										js.return
									end
									if not js.return_called then
										Result := 2
										js.return
									end
								end
								if not js.return_called then
									if (cmdbuf_inst.cmd_char (l_c)) = 1 then
										Result := 1
										js.return
									end
								end
								if not js.return_called then
									l_p.item := cmdbuf_inst.get_cmdbuf
									l_lc := ((((ctype_b_loc).item[(l_p.item[0]).to_integer_32]).to_integer_32).bit_and (512))
									l_o := opttbl_inst.findopt_name (l_p, l_oname, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
									if not l_o.is_void then
										optchar := l_o.item.oletter
										if not l_lc.to_boolean then
											if ((((ctype_b_loc).item[optchar.to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
												optchar := (toupper (optchar.to_integer_32)).to_integer_8
											end
										end
										cmdbuf_inst.cmd_reset
										mca_opt_toggle
										l_p.item := l_oname.item
										from
										until
											not (not js.loop_done and then ((l_p.item[0]).to_integer_32 /= 0))
										loop
											l_c := (l_p.item[0]).to_integer_32
											if not l_lc.to_boolean then
												if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (512)).to_boolean then
													l_c := toupper (l_c)
												end
											end
											if (cmdbuf_inst.cmd_char (l_c)) /= 0 then
												Result := 1
												js.return
											end
											if not js.return_called then
												l_p.item := l_p.item + 1
											end
										end
									end
								end
								if not js.return_called then
									Result := 2
									js.return
								end
				when 30 then -- if done | if done | if block done, skip else block:
								l_pos := -1 + 33
				when 31 then -- else:
								if l_c = screen_inst.erase_char then
									l_pos := -1 + 44 -- switch 1; break
								elseif l_c = screen_inst.kill_char then
									l_pos := -1 + 44 -- switch 1; break
								end
				when 32 then
								if optchar.to_integer_32 /= 0 then
									l_pos := -1 + 44 -- switch 1; break
								end
				when 33 then -- if done
								if not js.return_called then
									optchar := l_c.to_integer_8
									if ((optflag).bit_and (-65)) /= 1 then
										option_inst.toggle_option (l_c, ce_string (""), optflag)
										Result := 1
										js.return
									elseif (option_inst.single_char_option (l_c)).to_boolean then
										option_inst.toggle_option (l_c, ce_string (""), optflag)
										Result := 1
										js.return
									end
								end
								if not js.return_called then
									l_p.item := option_inst.opt_prompt (l_c)
									if (l_p.item).is_void then
										l_buf___1[0] := (('-').code).to_integer_8
										l_buf___1[1] := l_c.to_integer_8
										l_buf___1[2] := (('%/0/').code).to_integer_8
										l_p.item := l_buf___1
									end
									start_mca (47, l_p.item, create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
									Result := 2
									js.return
								end
				when 34 then -- switch 1, case 15 | switch 1, case 5
								if js.return_called then
									l_pos := -1 + 43 -- skip if block
								end
				when 35 then -- if:
									if (cmdbuf_inst.len_cmdbuf) > 0 then
										l_pos := -1 + 44 -- switch 1; break
									end
				when 36 then
									l_flag := 0
									inspect l_c -- switch 4 head
									when 5 then l_pos := -1 + 37
									when 42 then l_pos := -1 + 37
									when 6 then l_pos := -1 + 38
									when 64 then l_pos := -1 + 38
									when 11 then l_pos := -1 + 39
									when 18 then l_pos := -1 + 40
									when 14 then l_pos := -1 + 41
									when 33 then l_pos := -1 + 41
									else l_pos := -1 + 42
									end
				when 37 then -- switch 4, case 5 | switch 4, case 42
									l_flag := 128
									l_pos := -1 + 42 -- switch 4; break
				when 38 then -- switch 4, case 6 | switch 4, case 64
									l_flag := 256
									l_pos := -1 + 42 -- switch 4; break
				when 39 then -- switch 4, case 11
									l_flag := 4
									l_pos := -1 + 42 -- switch 4; break
				when 40 then -- switch 4, case 18
									l_flag := 512
									l_pos := -1 + 42 -- switch 4; break
				when 41 then -- switch 4, case 14 | switch 4, case 33
									l_flag := 64
									l_pos := -1 + 42 -- switch 4; break
				when 42 then -- switch 4, done:
									if l_flag /= 0 then
										search_type := (search_type).bit_xor (l_flag)
										mca_search
										Result := 2
										js.return
									end
				when 43 then -- if done
								l_pos := -1 + 44 -- switch 1; break
				when 44 then -- switch 1, done:
								if not js.return_called then
									if l_c = 10 then
										exec_mca
										Result := 1
										js.return
									elseif l_c = 13 then
										exec_mca
										Result := 1
										js.return
									end
								end
								if not js.return_called then
									if (cmdbuf_inst.cmd_char (l_c)) = 1 then
										Result := 1
										js.return
									end
								end
								if js.return_called then
									l_pos := -1 + 50 -- skip if block
								end
				when 45 then -- if:
									if mca /= 35 then
										l_pos := -1 + 48 -- skip if block
									end
				when 46 then -- if:
									l_pos := -1 + 49 -- goto _L___1
				when 47 then -- if block done, skip else block:
									l_pos := -1 + 50
				when 48 then -- else:
									if mca /= 36 then
										l_pos := -1 + 50 -- skip if block
									end
				when 49 then -- if: | _L___1:
									if (cmdbuf_inst.len_cmdbuf) >= 2 then
										exec_mca
										Result := 1
										js.return
									end
				when 50 then -- if done | if done
									if not js.return_called then
										Result := 2
									end
				when 51 then
									l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
						end

	mca_opt_toggle
		local
			l_no_prompt: INTEGER_32
			l_flag: INTEGER_32
			l_dash: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_dash.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_no_prompt := (optflag).bit_and (64)
					l_flag := (optflag).bit_and (-65)
					if l_flag = 0 then
						l_dash := ce_string ("_")
					else
						l_dash := ce_string ("-")
					end
					mca := 47
					cmdbuf_inst.clear_cmd
					cmdbuf_inst.cmd_putstr (l_dash)
					if optgetname.to_boolean then
						cmdbuf_inst.cmd_putstr (l_dash)
					end
					if l_no_prompt.to_boolean then
						cmdbuf_inst.cmd_putstr (ce_string ("(P)"))
					end
					inspect l_flag -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					cmdbuf_inst.cmd_putstr (ce_string ("+"))
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 3
					cmdbuf_inst.cmd_putstr (ce_string ("!"))
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					cmdbuf_inst.set_mlist (create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mca_search
		do
			if ((search_type).bit_and (1)).to_boolean then
				mca := 15
			else
				mca := 5
			end
			cmdbuf_inst.clear_cmd
			if ((search_type).bit_and (64)).to_boolean then
				cmdbuf_inst.cmd_putstr (ce_string ("Non-match "))
			end
			if ((search_type).bit_and (256)).to_boolean then
				cmdbuf_inst.cmd_putstr (ce_string ("First-file "))
			end
			if ((search_type).bit_and (128)).to_boolean then
				cmdbuf_inst.cmd_putstr (ce_string ("EOF-ignore "))
			end
			if ((search_type).bit_and (4)).to_boolean then
				cmdbuf_inst.cmd_putstr (ce_string ("Keep-pos "))
			end
			if ((search_type).bit_and (512)).to_boolean then
				cmdbuf_inst.cmd_putstr (ce_string ("Regex-off "))
			end
			if ((search_type).bit_and (1)).to_boolean then
				cmdbuf_inst.cmd_putstr (ce_string ("/"))
			else
				cmdbuf_inst.cmd_putstr (ce_string ("?"))
			end
			cmdbuf_inst.set_mlist (cmdbuf_inst.ml_search, 0)
		end

	multi_search (a_pattern: CE_POINTER [INTEGER_8]; a_n: INTEGER_32)
		local
			l_n: INTEGER_32
			l_nomore: INTEGER_32
			l_save_ifile: CE_POINTER [ANY]
			l_changed_file: INTEGER_32
			js: JUMP_STATE
		do
			create l_save_ifile.make

			l_n := a_n
			l_changed_file := 0
			l_save_ifile := edit_inst.save_curr_ifile
			if ((search_type).bit_and (256)).to_boolean then
				if ((search_type).bit_and (1)).to_boolean then
					l_nomore := edit_inst.edit_first
				else
					l_nomore := edit_inst.edit_last
				end
				if l_nomore.to_boolean then
					edit_inst.unsave_ifile (l_save_ifile)
					js.return
				end
				if not js.return_called then
					l_changed_file := 1
					search_type := (search_type).bit_and ((-257))
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l_n := search_inst.search (search_type, a_pattern, l_n)
					search_type := (search_type).bit_and ((-5))
					if l_n = 0 then
						edit_inst.unsave_ifile (l_save_ifile)
						js.return
					end
					if not js.return_called then
						if l_n < 0 then
							js.break
						end
						if not js.loop_jumped and then (((search_type).bit_and (128)) = 0) then
							js.break
						end
						if not js.loop_jumped then
							if ((search_type).bit_and (1)).to_boolean then
								l_nomore := edit_inst.edit_next (1)
							else
								l_nomore := edit_inst.edit_prev (1)
							end
							if l_nomore.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							l_changed_file := 1
						end
					end
				end
			end
			if not js.return_called then
				if l_n > 0 then
					output_inst.error (ce_string ("Pattern not found"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				end
				if l_changed_file.to_boolean then
					edit_inst.reedit_ifile (l_save_ifile)
				end
			end
		end

	prompt
		local
			l_p: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ungotp.is_void then
						if (ungotp.c_pointer.to_integer_32).to_natural_32 > (ungot.c_pointer.to_integer_32).to_natural_32 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						make_display
						bottompos := position_inst.position (-2)
						if quit_at_eof.item /= 2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((quit_if_one_screen.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if hit_eof.to_boolean then
							if not (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
								if (ifile_inst.next_ifile (main_inst.curr_ifile)).is_void then
									main_inst.quit (0)
								end
							end
						end
				when 6 then -- if done
						quit_if_one_screen.item := 0
						cmdbuf_inst.clear_cmd
						l_p := prompt_inst.pr_string
						if l_p.is_void then
							output_inst.putchr ((':').code).do_nothing
						else
							screen_inst.so_enter
							output_inst.putstr (l_p)
							screen_inst.so_exit
						end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	start_mca (a_action: INTEGER_32; a_prompt___0: CE_POINTER [INTEGER_8]; a_mlist: CE_POINTER [ANY]; a_cmdflags: INTEGER_32)
		do
			mca := a_action
			cmdbuf_inst.clear_cmd
			cmdbuf_inst.cmd_putstr (a_prompt___0)
			cmdbuf_inst.set_mlist (a_mlist, a_cmdflags)
		end

	ungetcc (a_c: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			if ungotp.is_void then
				ungotp := ungot
			end
			if (ungotp.c_pointer.to_integer_32).to_natural_32 >= ((ungot + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (100).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
				output_inst.error (ce_string ("ungetcc overflow"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				main_inst.quit (1)
			end
			l_tmp := ungotp
			ungotp := ungotp + 1
			l_tmp[0] := a_c.to_integer_8
		end

	ungetsc (a_s: CE_POINTER [INTEGER_8])
		local
			l_p: CE_POINTER [INTEGER_8]
		do
			create l_p.make

			l_p := (a_s + (strlen (a_s)).to_integer_32) - 1
			from
			until
				not ((l_p.c_pointer.to_integer_32).to_natural_32 >= (a_s.c_pointer.to_integer_32).to_natural_32)
			loop
				ungetcc ((l_p[0]).to_integer_32)
				l_p := l_p - 1
			end
		end

end
