class
	P_MAIN

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create curr_ifile.make
			create editor.make
			create editproto.make
			create every_first_cmd.make
			create initial_scrpos.make (<<1>>)
			create jump_sline.make (<<1>>)
			create know_dumb.make (<<1>>)
			create namelogfile.make
			create old_ifile.make
			create progname.make
		end

feature {ANY} -- attributes

	any_display: INTEGER_32 assign set_any_display

	set_any_display (a_any_display: INTEGER_32)
		do
			any_display := a_any_display
		end

	curr_ifile: CE_POINTER [ANY] assign set_curr_ifile

	set_curr_ifile (a_curr_ifile: CE_POINTER [ANY])
		do
			curr_ifile := a_curr_ifile
		end

	dohelp: INTEGER_32 assign set_dohelp

	set_dohelp (a_dohelp: INTEGER_32)
		do
			dohelp := a_dohelp
		end

	editor: CE_POINTER [INTEGER_8] assign set_editor

	set_editor (a_editor: CE_POINTER [INTEGER_8])
		do
			editor := a_editor
		end

	editproto: CE_POINTER [INTEGER_8] assign set_editproto

	set_editproto (a_editproto: CE_POINTER [INTEGER_8])
		do
			editproto := a_editproto
		end

	end_attnpos: INTEGER_32 assign set_end_attnpos

	set_end_attnpos (a_end_attnpos: INTEGER_32)
		do
			end_attnpos := a_end_attnpos
		end

	every_first_cmd: CE_POINTER [INTEGER_8] assign set_every_first_cmd

	set_every_first_cmd (a_every_first_cmd: CE_POINTER [INTEGER_8])
		do
			every_first_cmd := a_every_first_cmd
		end

	force_logfile: INTEGER_32 assign set_force_logfile

	set_force_logfile (a_force_logfile: INTEGER_32)
		do
			force_logfile := a_force_logfile
		end

	initial_scrpos: CE_ARRAY [PD_SCRPOS]

	is_tty: INTEGER_32 assign set_is_tty

	set_is_tty (a_is_tty: INTEGER_32)
		do
			is_tty := a_is_tty
		end

	jump_sline: CE_ARRAY [INTEGER_32]

	know_dumb: CE_ARRAY [INTEGER_32]

	logfile: INTEGER_32 assign set_logfile

	set_logfile (a_logfile: INTEGER_32)
		do
			logfile := a_logfile
		end

	namelogfile: CE_POINTER [INTEGER_8] assign set_namelogfile

	set_namelogfile (a_namelogfile: CE_POINTER [INTEGER_8])
		do
			namelogfile := a_namelogfile
		end

	new_file: INTEGER_32 assign set_new_file

	set_new_file (a_new_file: INTEGER_32)
		do
			new_file := a_new_file
		end

	old_ifile: CE_POINTER [ANY] assign set_old_ifile

	set_old_ifile (a_old_ifile: CE_POINTER [ANY])
		do
			old_ifile := a_old_ifile
		end

	progname: CE_POINTER [INTEGER_8] assign set_progname

	set_progname (a_progname: CE_POINTER [INTEGER_8])
		do
			progname := a_progname
		end

	quitting: INTEGER_32 assign set_quitting

	set_quitting (a_quitting: INTEGER_32)
		do
			quitting := a_quitting
		end

	save_status: INTEGER_32 assign set_save_status

	set_save_status (a_save_status: INTEGER_32)
		do
			save_status := a_save_status
		end

	secure: INTEGER_32 assign set_secure

	set_secure (a_secure: INTEGER_32)
		do
			secure := a_secure
		end

	start_attnpos: INTEGER_32 assign set_start_attnpos

	set_start_attnpos (a_start_attnpos: INTEGER_32)
		do
			start_attnpos := a_start_attnpos
		end

	wscroll: INTEGER_32 assign set_wscroll

	set_wscroll (a_wscroll: INTEGER_32)
		do
			wscroll := a_wscroll
		end

feature {ANY} -- routines

	ecalloc (a_count: INTEGER_32; a_size: NATURAL_32): CE_POINTER [ANY]
		local
			l_p: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_p.make

			l_p := (calloc (a_count.to_natural_32, a_size))
			if not l_p.is_void then
				Result := l_p
				js.return
			end
			if not js.return_called then
				output_inst.error (ce_string ("Cannot allocate memory"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				quit (1)
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_argc: INTEGER_32
			l_argv: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_ifile: CE_POINTER [ANY]
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_tmp___1: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_filename: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_argv.make
			create l_ifile.make
			create l_s.make
			create l_tmp.make
			create l_tmp___1.make
			create l_filename.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_argc := a_argc
					l_argv := a_argv
					l_tmp := l_argv
					l_argv := l_argv + 1
					progname := l_tmp.item
					l_argc := l_argc - 1
					secure := 0
					l_s := decode_inst.lgetenv (ce_string ("LESSSECURE"))
					if not l_s.is_void then
						if (l_s[0]).to_integer_32 /= 0 then
							secure := 1
						end
					end
					is_tty := isatty (1)
					screen_inst.get_term
					decode_inst.init_cmds
					prompt_inst.init_prompt
					charset_inst.init_charset
					line_inst.init_line
					opttbl_inst.init_option
					l_s := decode_inst.lgetenv (ce_string ("LESS"))
					if not l_s.is_void then
						option_inst.scan_option ((save (l_s)))
					end
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_argc > 0) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if (l_argv.item[0]).to_integer_32 /= 45 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (l_argv.item[0]).to_integer_32 /= 43 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if (l_argv.item[1]).to_integer_32 = 0 then
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if not (option_inst.isoptpending).to_boolean then
							js.break
						end
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						js.break
				when 12 then
						if not js.loop_jumped then
							l_tmp___1 := l_argv
							l_argv := l_argv + 1
							l_s := l_tmp___1.item
							l_argc := l_argc - 1
							if (strcmp (l_s, ce_string ("--"))) = 0 then
								js.break
							end
						end
						if not js.loop_jumped then
							option_inst.scan_option (l_s)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					if (option_inst.isoptpending).to_boolean then
						option_inst.nopendopt
						quit (0)
					end
					editor := decode_inst.lgetenv (ce_string ("VISUAL"))
					if not (editor.is_void) then
						l_pos := -1 + 16 -- skip if block
					end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if (editor[0]).to_integer_32 /= 0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___1:
						editor := decode_inst.lgetenv (ce_string ("EDITOR"))
						if editor.is_void then
							editor := ce_string ("vi")
						elseif (editor[0]).to_integer_32 = 0 then
							editor := ce_string ("vi")
						end
				when 18 then -- if done
						editproto := decode_inst.lgetenv (ce_string ("LESSEDIT"))
						if editproto.is_void then
							editproto := ce_string ("%%E ?lm+%%lm. %%f")
						elseif (editproto[0]).to_integer_32 = 0 then
							editproto := ce_string ("%%E ?lm+%%lm. %%f")
						end
						l_ifile := create {CE_POINTER [ANY]}.make_shared (default_pointer)
						if dohelp.to_boolean then
							l_ifile := ifile_inst.get_ifile (ce_string ("@/\less/\help/\file/\@"), l_ifile)
						end
						from
						until
							js.loop_done
						loop
							l_tmp___5 := l_argc
							l_argc := l_argc - 1
							if not (l_tmp___5 > 0) then
								js.break
							end
							if not js.loop_jumped then
								l_filename := filename_inst.shell_quote (l_argv.item)
								if l_filename.is_void then
									l_filename := l_argv.item
								end
								l_argv := l_argv + 1
								ifile_inst.get_ifile (l_filename, l_ifile).do_nothing
								l_ifile := ifile_inst.prev_ifile (create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
						end
						if not is_tty.to_boolean then
							if (ifile_inst.nifile) = 0 then
								if (edit_inst.edit_stdin) = 0 then
									edit_inst.cat_file
								end
							elseif (edit_inst.edit_first) = 0 then
								from
								until
									js.loop_done
								loop
									edit_inst.cat_file
									if (edit_inst.edit_next (1)) /= 0 then
										js.break
									end
								end
							end
							quit (0)
						end
						if screen_inst.missing_cap.to_boolean then
							if not (know_dumb.item).to_boolean then
								output_inst.error (ce_string ("WARNING: terminal is not fully functional"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							end
						end
						mark_inst.init_mark
						ttyin_inst.open_getchr
						screen_inst.raw_mode (1)
						signal_inst.init_signals (1)
						if optfunc_inst.tagoption.is_void then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
							l_pos := -1 + 22 -- goto _L___2
				when 20 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 21 then -- else:
							if (strcmp (tags_inst.tags, ce_string ("-"))) /= 0 then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if: | _L___2:
							if (ifile_inst.nifile) > 0 then
								output_inst.error (ce_string ("No filenames allowed with -t option"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
								quit (1)
							end
							tags_inst.findtag (optfunc_inst.tagoption)
							if (tags_inst.edit_tagfile).to_boolean then
								quit (1)
							end
							initial_scrpos.item.pos := tags_inst.tagsearch
							if initial_scrpos.item.pos = -1 then
								quit (1)
							end
							initial_scrpos.item.ln := jump_sline.item
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 24 then -- else:
							if (ifile_inst.nifile) = 0 then
								if (edit_inst.edit_stdin).to_boolean then
									quit (1)
								end
							elseif (edit_inst.edit_first).to_boolean then
								quit (1)
							end
				when 25 then -- if done
							screen_inst.init
							command_inst.commands
							quit (0)
							Result := 0
				when 26 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	quit (a_status: INTEGER_32)
		local
			l_status: INTEGER_32
		do
			l_status := a_status
			if l_status < 0 then
				l_status := save_status
			else
				save_status := l_status
			end
			quitting := 1
			edit_inst.edit (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)).do_nothing
			if any_display.to_boolean then
				if is_tty.to_boolean then
					screen_inst.clear_bot
				end
			end
			screen_inst.deinit
			output_inst.flush
			screen_inst.raw_mode (0)
			ttyin_inst.close_getchr
			exit (l_status)
		end

	save (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p: CE_POINTER [INTEGER_8]
		do
			create l_p.make

			l_p := create {CE_POINTER [INTEGER_8]}.make_cast ((ecalloc (((strlen (a_s)) + {NATURAL_32} 1).to_integer_32, {PLATFORM}.Integer_8_bytes.to_natural_32)))
			strcpy (l_p, a_s).do_nothing
			Result := l_p
		end

	skipsp (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := a_s
			from
			until
				js.loop_done
			loop
				if (l_s[0]).to_integer_32 /= 32 then
					if (l_s[0]).to_integer_32 /= 9 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_s := l_s + 1
				end
			end
			Result := l_s
		end

	sprefix (a_ps: CE_POINTER [INTEGER_8]; a_s: CE_POINTER [INTEGER_8]; a_uppercase: INTEGER_32): INTEGER_32
		local
			l_ps: CE_POINTER [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_sc: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_ps.make
			create l_s.make

			l_ps := a_ps
			l_s := a_s
			l_len := 0
			from
			until
				not (not js.loop_done and then ((l_s[0]).to_integer_32 /= 0))
			loop
				l_c := (l_ps[0]).to_integer_32
				if a_uppercase.to_boolean then
					if l_len = 0 then
						if l_c >= 97 then
							if l_c <= 122 then
								Result := (-1)
								js.return
							end
						end
					end
					if not js.return_called and then (l_c >= 65) then
						if l_c <= 90 then
							l_c := (l_c - 65) + 97
						end
					end
				end
				if not js.return_called then
					l_sc := (l_s[0]).to_integer_32
					if l_len > 0 then
						if l_sc >= 65 then
							if l_sc <= 90 then
								l_sc := (l_sc - 65) + 97
							end
						end
					end
					if l_c /= l_sc then
						js.break
					end
					if not js.loop_jumped then
						l_len := l_len + 1
						l_s := l_s + 1
						l_ps := l_ps + 1
					end
				end
			end
			if not js.return_called then
				Result := l_len
			end
		end

end
