class
	P_OPTTBL

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create B__optname.make (<<1>>)
			create F__optname.make (<<1>>)
			create J__optname.make (<<1>>)
			create L__optname.make (<<1>>)
			create O__optname.make (<<1>>)
			create P__optname.make (<<1>>)
			create S__optname.make (<<1>>)
			create T__optname.make (<<1>>)
			create V__optname.make (<<1>>)
			create X__optname.make (<<1>>)
			create a_optname.make (<<1>>)
			create b_optname.make (<<1>>)
			create c2_optname.make (<<1>>)
			create caseless.make (<<1>>)
			create d_optname.make (<<1>>)
			create e_optname.make (<<1>>)
			create f_optname.make (<<1>>)
			create g_optname.make (<<1>>)
			create h_optname.make (<<1>>)
			create how_search.make (<<1>>)
			create i_optname.make (<<1>>)
			create j_optname.make (<<1>>)
			create k_optname.make (<<1>>)
			create keypad_optname.make (<<1>>)
			create m_optname.make (<<1>>)
			create n_optname.make (<<1>>)
			create o_optname.make (<<1>>)
			create option.make (<<41>>)
			create p_optname.make (<<1>>)
			create pound_optname.make (<<1>>)
			create q2_optname.make (<<1>>)
			create q_optname.make (<<1>>)
			create query_optname.make (<<1>>)
			create quote_optname.make (<<1>>)
			create r_optname.make (<<1>>)
			create s_optname.make (<<1>>)
			create t_optname.make (<<1>>)
			create tilde_optname.make (<<1>>)
			create u_optname.make (<<1>>)
			create w_optname.make (<<1>>)
			create x_optname.make (<<1>>)
			create y_optname.make (<<1>>)
			create z_optname.make (<<1>>)
		end

feature {ANY} -- attributes

	B__optname: CE_ARRAY [PD_OPTNAME]

	F__optname: CE_ARRAY [PD_OPTNAME]

	J__optname: CE_ARRAY [PD_OPTNAME]

	L__optname: CE_ARRAY [PD_OPTNAME]

	O__optname: CE_ARRAY [PD_OPTNAME]

	P__optname: CE_ARRAY [PD_OPTNAME]

	S__optname: CE_ARRAY [PD_OPTNAME]

	T__optname: CE_ARRAY [PD_OPTNAME]

	V__optname: CE_ARRAY [PD_OPTNAME]

	X__optname: CE_ARRAY [PD_OPTNAME]

	a_optname: CE_ARRAY [PD_OPTNAME]

	b_optname: CE_ARRAY [PD_OPTNAME]

	c2_optname: CE_ARRAY [PD_OPTNAME]

	caseless: CE_ARRAY [INTEGER_32]

	d_optname: CE_ARRAY [PD_OPTNAME]

	e_optname: CE_ARRAY [PD_OPTNAME]

	f_optname: CE_ARRAY [PD_OPTNAME]

	g_optname: CE_ARRAY [PD_OPTNAME]

	h_optname: CE_ARRAY [PD_OPTNAME]

	how_search: CE_ARRAY [INTEGER_32]

	i_optname: CE_ARRAY [PD_OPTNAME]

	j_optname: CE_ARRAY [PD_OPTNAME]

	k_optname: CE_ARRAY [PD_OPTNAME]

	keypad_optname: CE_ARRAY [PD_OPTNAME]

	m_optname: CE_ARRAY [PD_OPTNAME]

	n_optname: CE_ARRAY [PD_OPTNAME]

	o_optname: CE_ARRAY [PD_OPTNAME]

	option: CE_ARRAY [PD_LOPTION]

	p_optname: CE_ARRAY [PD_OPTNAME]

	pound_optname: CE_ARRAY [PD_OPTNAME]

	q2_optname: CE_ARRAY [PD_OPTNAME]

	q_optname: CE_ARRAY [PD_OPTNAME]

	query_optname: CE_ARRAY [PD_OPTNAME]

	quote_optname: CE_ARRAY [PD_OPTNAME]

	r_optname: CE_ARRAY [PD_OPTNAME]

	s_optname: CE_ARRAY [PD_OPTNAME]

	t_optname: CE_ARRAY [PD_OPTNAME]

	tabstop: INTEGER_32 assign set_tabstop

	set_tabstop (a_tabstop: INTEGER_32)
		do
			tabstop := a_tabstop
		end

	tilde_optname: CE_ARRAY [PD_OPTNAME]

	u_optname: CE_ARRAY [PD_OPTNAME]

	w_optname: CE_ARRAY [PD_OPTNAME]

	x_optname: CE_ARRAY [PD_OPTNAME]

	y_optname: CE_ARRAY [PD_OPTNAME]

	z_optname: CE_ARRAY [PD_OPTNAME]

feature {ANY} -- routines

	findopt (a_c: INTEGER_32): CE_POINTER [PD_LOPTION]
		local
			l_o: CE_POINTER [PD_LOPTION]
			js: JUMP_STATE
		do
			create l_o.make

			l_o := option
			from
			until
				not (not js.loop_done and then ((l_o.item.oletter).to_integer_32 /= 0))
			loop
				if (l_o.item.oletter).to_integer_32 = a_c then
					Result := l_o
					js.return
				end
				if not js.return_called and then (((l_o.item.otype).bit_and (2)).to_boolean) then
					if (toupper ((l_o.item.oletter).to_integer_32)) = a_c then
						Result := l_o
						js.return
					end
				end
				if not js.return_called then
					l_o := l_o + 1
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_LOPTION]}.make_shared (default_pointer))
			end
		end

	findopt_name (a_p_optname___0: CE_POINTER [CE_POINTER [INTEGER_8]]; a_p_oname: CE_POINTER [CE_POINTER [INTEGER_8]]; a_p_err: CE_POINTER [INTEGER_32]): CE_POINTER [PD_LOPTION]
		local
			l_optname: CE_POINTER [INTEGER_8]
			l_o: CE_POINTER [PD_LOPTION]
			l_oname: CE_POINTER [PD_OPTNAME]
			l_len: INTEGER_32
			l_uppercase: INTEGER_32
			l_maxo: CE_POINTER [PD_LOPTION]
			l_maxoname: CE_POINTER [PD_OPTNAME]
			l_maxlen: INTEGER_32
			l_ambig: INTEGER_32
			l_exact: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_optname.make
			create l_o.make
			create l_oname.make
			create l_maxo.make
			create l_maxoname.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_optname := a_p_optname___0.item
					l_maxo := create {CE_POINTER [PD_LOPTION]}.make_shared (default_pointer)
					l_maxoname := create {CE_POINTER [PD_OPTNAME]}.make_shared (default_pointer)
					l_maxlen := 0
					l_ambig := 0
					l_exact := 0
					l_o := option
				when 1 then -- loop condition:
					if not (not js.loop_done and then ((l_o.item.oletter).to_integer_32 /= 0)) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_oname := l_o.item.onames
				when 3 then -- loop condition:
						if not (not js.loop_done and then (not l_oname.is_void)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 4 then -- loop body:
						l_uppercase := 0
				when 5 then -- loop condition:
						if not (not js.loop_done and then (l_uppercase <= 1)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						l_len := main_inst.sprefix (l_optname, l_oname.item.oname, l_uppercase)
						if l_len <= 0 then
							js.continue
						elseif (is_optchar (l_optname[l_len])).to_boolean then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if l_exact.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_len = l_maxlen then
							l_ambig := 1
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_len > l_maxlen then
							l_maxo := l_o
							l_maxoname := l_oname
							l_maxlen := l_len
							l_ambig := 0
							l_exact := (l_len = (strlen (l_oname.item.oname)).to_integer_32).to_integer
						end
				when 11 then
						if not ((l_o.item.otype).bit_and (2)).to_boolean then
							js.break
						end
				when 12 then -- if done
						if js.loop_increment then
							l_uppercase := l_uppercase + 1
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						l_oname := l_oname.item.onext
						l_pos := -1 + 3 -- back to loop condition
				when 14 then -- loop done
						l_o := l_o + 1
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if l_ambig.to_boolean then
						if not a_p_err.is_void then
							a_p_err.item := 1
						end
						Result := (create {CE_POINTER [PD_LOPTION]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						a_p_optname___0.item := l_optname + l_maxlen
						if not a_p_oname.is_void then
							if l_maxoname.is_void then
								a_p_oname.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							else
								a_p_oname.item := l_maxoname.item.oname
							end
						end
						Result := l_maxo
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_option
		local
			l_o: CE_POINTER [PD_LOPTION]
		do
			create l_o.make

			l_o := option
			from
			until
				(l_o.item.oletter).to_integer_32 = 0
			loop
				if not (l_o.item.ovar).is_void then
					(l_o.item.ovar).item := l_o.item.odefault
				end
				if ((l_o.item.otype).bit_and (512)).to_boolean then
					(l_o.item.ofunc).call ([0, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)])
				end
				l_o := l_o + 1
			end
		end

	is_optchar (a_c: INTEGER_8): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c.to_integer_32 >= 65 then
				if a_c.to_integer_32 <= 90 then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then (a_c.to_integer_32 >= 97) then
				if a_c.to_integer_32 <= 122 then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then (a_c.to_integer_32 = 45) then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
