class
	P_OUTPUT

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create intr_to_abort.make (<<25>>)
			create ob.make
			create obuf.make (<<1_024>>)
			create return_to_continue.make (<<17>>)
		end

feature {ANY} -- attributes

	intr_to_abort: CE_ARRAY [INTEGER_8]

	need_clr: INTEGER_32 assign set_need_clr

	set_need_clr (a_need_clr: INTEGER_32)
		do
			need_clr := a_need_clr
		end

	ob: CE_POINTER [INTEGER_8] assign set_ob

	set_ob (a_ob: CE_POINTER [INTEGER_8])
		do
			ob := a_ob
		end

	obuf: CE_ARRAY [INTEGER_8]

	return_to_continue: CE_ARRAY [INTEGER_8]

feature {ANY} -- routines

	error (a_fmt: CE_POINTER [INTEGER_8]; a_parg: CE_POINTER [PD_PARG])
		local
			l_col: INTEGER_32
			js: JUMP_STATE
		do
			l_col := 0
			edit_inst.errmsgs := edit_inst.errmsgs + 1
			if main_inst.any_display.to_boolean then
				if main_inst.is_tty.to_boolean then
					screen_inst.clear_bot
					screen_inst.so_enter
					l_col := l_col + screen_inst.so_s_width
				end
			end
			l_col := l_col + (less_printf (a_fmt, a_parg))
			if main_inst.any_display.to_boolean then
				if not main_inst.is_tty.to_boolean then
					putchr (('%N').code).do_nothing
					js.return
				end
			else
				putchr (('%N').code).do_nothing
				js.return
			end
			if not js.return_called then
				putstr (return_to_continue)
				screen_inst.so_exit
				l_col := (l_col.to_natural_32 + (({PLATFORM}.Integer_8_bytes.to_natural_32 * (17).to_natural_32) + screen_inst.so_e_width.to_natural_32)).to_integer_32
				get_return
				screen_inst.lower_left
				if l_col >= screen_inst.sc_width then
					command_inst.screen_trashed := 1
				end
				flush
			end
		end

	flush
		local
			l_n: INTEGER_32
			l_fd: INTEGER_32
			js: JUMP_STATE
		do
			l_n := ob.distance (obuf)
			if l_n = 0 then
				js.return
			end
			if not js.return_called then
				if main_inst.any_display.to_boolean then
					l_fd := 1
				else
					l_fd := 2
				end
				if (write (l_fd, create {CE_POINTER [ANY]}.make_cast (obuf), l_n.to_natural_32)) /= l_n then
					command_inst.screen_trashed := 1
				end
				ob := obuf
			end
		end

	get_return
		local
			l_c: INTEGER_32
		do
			l_c := ttyin_inst.getchr
			if l_c /= 10 then
				if l_c /= 13 then
					if l_c /= 32 then
						if l_c /= -2 then
							command_inst.ungetcc (l_c)
						end
					end
				end
			end
		end

	ierror (a_fmt: CE_POINTER [INTEGER_8]; a_parg: CE_POINTER [PD_PARG])
		do
			screen_inst.clear_bot
			screen_inst.so_enter
			less_printf (a_fmt, a_parg).do_nothing
			putstr (intr_to_abort)
			screen_inst.so_exit
			flush
			need_clr := 1
		end

	inttoa (a_num: INTEGER_32; a_buf___1: CE_POINTER [INTEGER_8])
		local
			l_num: INTEGER_32
			l_neg: INTEGER_32
			l_tbuf___0: CE_ARRAY [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tbuf___0.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)
			create l_s.make

			l_num := a_num
			l_neg := (l_num < 0).to_integer
			l_s := l_tbuf___0 + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32
			if l_neg.to_boolean then
				l_num := -l_num
			end
			l_s := l_s - 1
			l_s[0] := (('%/0/').code).to_integer_8
			from
			until
				js.loop_done
			loop
				l_s := l_s - 1
				l_s[0] := (l_num \\ 10 + 48).to_integer_8
				l_num := l_num // (10)
				if l_num = 0 then
					js.break
				end
			end
			if l_neg.to_boolean then
				l_s := l_s - 1
				l_s[0] := (('-').code).to_integer_8
			end
			strcpy (a_buf___1, l_s).do_nothing
		end

	iprint_int (a_num: INTEGER_32): INTEGER_32
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create l_buf___1.make (<<(((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1).to_integer_32>>)

			inttoa (a_num, l_buf___1)
			putstr (l_buf___1)
			Result := (strlen (l_buf___1)).to_integer_32
		end

	iprint_linenum (a_num: INTEGER_32): INTEGER_32
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create l_buf___1.make (<<(((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1).to_integer_32>>)

			linenumtoa (a_num, l_buf___1)
			putstr (l_buf___1)
			Result := (strlen (l_buf___1)).to_integer_32
		end

	less_printf (a_fmt: CE_POINTER [INTEGER_8]; a_parg: CE_POINTER [PD_PARG]): INTEGER_32
		local
			l_fmt: CE_POINTER [INTEGER_8]
			l_parg: CE_POINTER [PD_PARG]
			l_s: CE_POINTER [INTEGER_8]
			l_col: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fmt.make
			create l_parg.make
			create l_s.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fmt := a_fmt
					l_parg := a_parg
					l_col := 0
				when 1 then -- loop condition:
					if not (not js.loop_done and then ((l_fmt[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if (l_fmt[0]).to_integer_32 = 37 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_tmp := l_fmt
						l_fmt := l_fmt + 1
						putchr ((l_tmp[0]).to_integer_32).do_nothing
						l_col := l_col + 1
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						l_fmt := l_fmt + 1
						l_tmp___0 := l_fmt
						l_fmt := l_fmt + 1
						inspect (l_tmp___0[0]).to_integer_32 -- switch 1 head
						when 115 then l_pos := -1 + 6
						when 100 then l_pos := -1 + 7
						when 110 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 6 then -- switch 1, case 115
						l_s := l_parg.item.p_string
						l_parg := l_parg + 1
						from
						until
							(l_s[0]).to_integer_32 = 0
						loop
							l_tmp___1 := l_s
							l_s := l_s + 1
							putchr ((l_tmp___1[0]).to_integer_32).do_nothing
							l_col := l_col + 1
						end
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 100
						l_col := l_col + (iprint_int (l_parg.item.p_int))
						l_parg := l_parg + 1
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, case 110
						l_col := l_col + (iprint_linenum (l_parg.item.p_linenum))
						l_parg := l_parg + 1
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					Result := l_col
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	linenumtoa (a_num: INTEGER_32; a_buf___1: CE_POINTER [INTEGER_8])
		local
			l_num: INTEGER_32
			l_neg: INTEGER_32
			l_tbuf___0: CE_ARRAY [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tbuf___0.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)
			create l_s.make

			l_num := a_num
			l_neg := (l_num < 0).to_integer
			l_s := l_tbuf___0 + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32
			if l_neg.to_boolean then
				l_num := -l_num
			end
			l_s := l_s - 1
			l_s[0] := (('%/0/').code).to_integer_8
			from
			until
				js.loop_done
			loop
				l_s := l_s - 1
				l_s[0] := (l_num \\ 10 + 48).to_integer_8
				l_num := l_num // (10)
				if l_num = 0 then
					js.break
				end
			end
			if l_neg.to_boolean then
				l_s := l_s - 1
				l_s[0] := (('-').code).to_integer_8
			end
			strcpy (a_buf___1, l_s).do_nothing
		end

	postoa (a_num: INTEGER_32; a_buf___1: CE_POINTER [INTEGER_8])
		local
			l_num: INTEGER_32
			l_neg: INTEGER_32
			l_tbuf___0: CE_ARRAY [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tbuf___0.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)
			create l_s.make

			l_num := a_num
			l_neg := (l_num < 0).to_integer
			l_s := l_tbuf___0 + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32
			if l_neg.to_boolean then
				l_num := -l_num
			end
			l_s := l_s - 1
			l_s[0] := (('%/0/').code).to_integer_8
			from
			until
				js.loop_done
			loop
				l_s := l_s - 1
				l_s[0] := (l_num \\ 10 + 48).to_integer_8
				l_num := l_num // (10)
				if l_num = 0 then
					js.break
				end
			end
			if l_neg.to_boolean then
				l_s := l_s - 1
				l_s[0] := (('-').code).to_integer_8
			end
			strcpy (a_buf___1, l_s).do_nothing
		end

	put_line
		local
			l_c: INTEGER_32
			l_i: INTEGER_32
			l_a: CE_ARRAY [INTEGER_32]
			l_curr_attr: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_a.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((ch_inst.sigs).bit_and (3)).to_boolean then
						command_inst.screen_trashed := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 24 -- skip if block
					end
				when 1 then -- if:
						l_curr_attr := 0
						l_i := 0
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 18 -- skip loop
						end
				when 3 then -- loop body:
						l_c := line_inst.gline (l_i, l_a)
						if l_c = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if l_a.item = l_curr_attr then
							l_pos := -1 + 16 -- skip if block
						end
				when 5 then -- if:
						inspect l_curr_attr -- switch 1 head
						when 1 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						when 3 then l_pos := -1 + 8
						when 5 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 6 then -- switch 1, case 1
						screen_inst.ul_exit
						l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 2
						screen_inst.bo_exit
						l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 3
						screen_inst.bl_exit
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, case 5
						screen_inst.so_exit
						l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done:
						inspect l_a.item -- switch 2 head
						when 1 then l_pos := -1 + 11
						when 2 then l_pos := -1 + 12
						when 3 then l_pos := -1 + 13
						when 5 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 11 then -- switch 2, case 1
						screen_inst.ul_enter
						l_pos := -1 + 15 -- switch 2; break
				when 12 then -- switch 2, case 2
						screen_inst.bo_enter
						l_pos := -1 + 15 -- switch 2; break
				when 13 then -- switch 2, case 3
						screen_inst.bl_enter
						l_pos := -1 + 15 -- switch 2; break
				when 14 then -- switch 2, case 5
						screen_inst.so_enter
						l_pos := -1 + 15 -- switch 2; break
				when 15 then -- switch 2, done:
						l_curr_attr := l_a.item
				when 16 then -- if done
						if l_curr_attr = 4 then
							js.continue
						end
				when 17 then -- if done
						if not js.loop_jumped then
							if l_c = 8 then
								screen_inst.putbs
							else
								putchr (l_c).do_nothing
							end
						end
						if js.loop_increment then
							l_i := l_i + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 18 then -- loop done
						inspect l_curr_attr -- switch 3 head
						when 1 then l_pos := -1 + 19
						when 2 then l_pos := -1 + 20
						when 3 then l_pos := -1 + 21
						when 5 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 19 then -- switch 3, case 1
						screen_inst.ul_exit
						l_pos := -1 + 23 -- switch 3; break
				when 20 then -- switch 3, case 2
						screen_inst.bo_exit
						l_pos := -1 + 23 -- switch 3; break
				when 21 then -- switch 3, case 3
						screen_inst.bl_exit
						l_pos := -1 + 23 -- switch 3; break
				when 22 then -- switch 3, case 5
						screen_inst.so_exit
						l_pos := -1 + 23 -- switch 3; break
				when 23 then -- switch 3, done:
						forwback_inst.final_attr := l_curr_attr
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	putchr (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			if need_clr.to_boolean then
				need_clr := 0
				screen_inst.clear_bot
			end
			if (ob.c_pointer.to_integer_32).to_natural_32 >= ((obuf + (({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_024).to_natural_32) - {NATURAL_32} 1).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
				flush
			end
			l_tmp := ob
			ob := ob + 1
			l_tmp[0] := a_c.to_integer_8
			Result := a_c
		end

	putchr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent putchr)
		end

	putstr (a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_s.make
			create l_tmp.make

			l_s := a_s
			from
			until
				(l_s[0]).to_integer_32 = 0
			loop
				l_tmp := l_s
				l_s := l_s + 1
				putchr ((l_tmp[0]).to_integer_32).do_nothing
			end
		end

	query (a_fmt: CE_POINTER [INTEGER_8]; a_parg: CE_POINTER [PD_PARG]): INTEGER_32
		local
			l_c: INTEGER_32
			l_col: INTEGER_32
			js: JUMP_STATE
		do
			l_col := 0
			if main_inst.any_display.to_boolean then
				if main_inst.is_tty.to_boolean then
					screen_inst.clear_bot
				end
			end
			less_printf (a_fmt, a_parg).do_nothing
			l_c := ttyin_inst.getchr
			if main_inst.any_display.to_boolean then
				if not main_inst.is_tty.to_boolean then
					putchr (('%N').code).do_nothing
					Result := l_c
					js.return
				end
			else
				putchr (('%N').code).do_nothing
				Result := l_c
				js.return
			end
			if not js.return_called then
				screen_inst.lower_left
				if l_col >= screen_inst.sc_width then
					command_inst.screen_trashed := 1
				end
				flush
				Result := l_c
			end
		end

end
