class
	SD_RE_PATTERN_BUFFER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	buffer: CE_POINTER [NATURAL_8] assign set_buffer

	allocated: NATURAL_32 assign set_allocated

	used: NATURAL_32 assign set_used

	syntax: NATURAL_32 assign set_syntax

	fastmap: CE_POINTER [INTEGER_8] assign set_fastmap

	translate: CE_POINTER [NATURAL_8] assign set_translate

	re_nsub: NATURAL_32 assign set_re_nsub

	can_be_null: NATURAL_32 assign set_can_be_null

	regs_allocated: NATURAL_32 assign set_regs_allocated

	fastmap_accurate: NATURAL_32 assign set_fastmap_accurate

	no_sub: NATURAL_32 assign set_no_sub

	not_bol: NATURAL_32 assign set_not_bol

	not_eol: NATURAL_32 assign set_not_eol

	newline_anchor: NATURAL_32 assign set_newline_anchor

feature {ANY} -- setters

	set_buffer (a_buffer: CE_POINTER [NATURAL_8])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_allocated (a_allocated: NATURAL_32)
		do
			allocated := a_allocated
			update_memory_field ("allocated")
		end

	set_used (a_used: NATURAL_32)
		do
			used := a_used
			update_memory_field ("used")
		end

	set_syntax (a_syntax: NATURAL_32)
		do
			syntax := a_syntax
			update_memory_field ("syntax")
		end

	set_fastmap (a_fastmap: CE_POINTER [INTEGER_8])
		do
			fastmap := a_fastmap
			update_memory_field ("fastmap")
		end

	set_translate (a_translate: CE_POINTER [NATURAL_8])
		do
			translate := a_translate
			update_memory_field ("translate")
		end

	set_re_nsub (a_re_nsub: NATURAL_32)
		do
			re_nsub := a_re_nsub
			update_memory_field ("re_nsub")
		end

	set_can_be_null (a_can_be_null: NATURAL_32)
		do
			can_be_null := a_can_be_null
			update_memory_field ("can_be_null")
		end

	set_regs_allocated (a_regs_allocated: NATURAL_32)
		do
			regs_allocated := a_regs_allocated
			update_memory_field ("regs_allocated")
		end

	set_fastmap_accurate (a_fastmap_accurate: NATURAL_32)
		do
			fastmap_accurate := a_fastmap_accurate
			update_memory_field ("fastmap_accurate")
		end

	set_no_sub (a_no_sub: NATURAL_32)
		do
			no_sub := a_no_sub
			update_memory_field ("no_sub")
		end

	set_not_bol (a_not_bol: NATURAL_32)
		do
			not_bol := a_not_bol
			update_memory_field ("not_bol")
		end

	set_not_eol (a_not_eol: NATURAL_32)
		do
			not_eol := a_not_eol
			update_memory_field ("not_eol")
		end

	set_newline_anchor (a_newline_anchor: NATURAL_32)
		do
			newline_anchor := a_newline_anchor
			update_memory_field ("newline_anchor")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buffer := a_other.buffer
			allocated := a_other.allocated
			used := a_other.used
			syntax := a_other.syntax
			fastmap := a_other.fastmap
			translate := a_other.translate
			re_nsub := a_other.re_nsub
			can_be_null := a_other.can_be_null
			regs_allocated := a_other.regs_allocated
			fastmap_accurate := a_other.fastmap_accurate
			no_sub := a_other.no_sub
			not_bol := a_other.not_bol
			not_eol := a_other.not_eol
			newline_anchor := a_other.newline_anchor
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buffer.is_equal (a_other.buffer) and
				allocated = a_other.allocated and
				used = a_other.used and
				syntax = a_other.syntax and
				fastmap.is_equal (a_other.fastmap) and
				translate.is_equal (a_other.translate) and
				re_nsub = a_other.re_nsub and
				can_be_null = a_other.can_be_null and
				regs_allocated = a_other.regs_allocated and
				fastmap_accurate = a_other.fastmap_accurate and
				no_sub = a_other.no_sub and
				not_bol = a_other.not_bol and
				not_eol = a_other.not_eol and
				newline_anchor = a_other.newline_anchor
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("allocated"),
					create {CE_STRUCTURE_FIELD}.make ("used"),
					create {CE_STRUCTURE_FIELD}.make ("syntax"),
					create {CE_STRUCTURE_FIELD}.make ("fastmap"),
					create {CE_STRUCTURE_FIELD}.make ("translate"),
					create {CE_STRUCTURE_FIELD}.make ("re_nsub"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("can_be_null"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("regs_allocated"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("fastmap_accurate"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("no_sub"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("not_bol"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("not_eol"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("newline_anchor")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <regex.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct re_pattern_buffer);
				} else {
					struct re_pattern_buffer *p = (struct re_pattern_buffer *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "can_be_null") == 0) p->can_be_null = (unsigned int)$a_value;
						else if(strcmp(field_name, "regs_allocated") == 0) p->regs_allocated = (unsigned int)$a_value;
						else if(strcmp(field_name, "fastmap_accurate") == 0) p->fastmap_accurate = (unsigned int)$a_value;
						else if(strcmp(field_name, "no_sub") == 0) p->no_sub = (unsigned int)$a_value;
						else if(strcmp(field_name, "not_bol") == 0) p->not_bol = (unsigned int)$a_value;
						else if(strcmp(field_name, "not_eol") == 0) p->not_eol = (unsigned int)$a_value;
						else if(strcmp(field_name, "newline_anchor") == 0) p->newline_anchor = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "can_be_null") == 0) return p->can_be_null;
						if(strcmp(field_name, "regs_allocated") == 0) return p->regs_allocated;
						if(strcmp(field_name, "fastmap_accurate") == 0) return p->fastmap_accurate;
						if(strcmp(field_name, "no_sub") == 0) return p->no_sub;
						if(strcmp(field_name, "not_bol") == 0) return p->not_bol;
						if(strcmp(field_name, "not_eol") == 0) return p->not_eol;
						if(strcmp(field_name, "newline_anchor") == 0) return p->newline_anchor;
					}
				}
			]"
		end

end
