class
	PD_BAR_PROGRESS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create buffer.make
			create hist.make
		end

feature {ANY} -- fields

	initial_length: INTEGER_64 assign set_initial_length

	total_length: INTEGER_64 assign set_total_length

	count: INTEGER_64 assign set_count

	last_screen_update: REAL_64 assign set_last_screen_update

	width: INTEGER_32 assign set_width

	buffer: CE_POINTER [INTEGER_8] assign set_buffer

	tick: INTEGER_32 assign set_tick

	hist: PD_BAR_PROGRESS_HIST assign set_hist

	recent_start: REAL_64 assign set_recent_start

	recent_bytes: INTEGER_64 assign set_recent_bytes

	stalled: BOOLEAN assign set_stalled

	last_eta_time: REAL_64 assign set_last_eta_time

	last_eta_value: INTEGER_32 assign set_last_eta_value

feature {ANY} -- setters

	set_initial_length (a_initial_length: INTEGER_64)
		do
			initial_length := a_initial_length
			update_memory_field ("initial_length")
		end

	set_total_length (a_total_length: INTEGER_64)
		do
			total_length := a_total_length
			update_memory_field ("total_length")
		end

	set_count (a_count: INTEGER_64)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_last_screen_update (a_last_screen_update: REAL_64)
		do
			last_screen_update := a_last_screen_update
			update_memory_field ("last_screen_update")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_tick (a_tick: INTEGER_32)
		do
			tick := a_tick
			update_memory_field ("tick")
		end

	set_hist (a_hist: PD_BAR_PROGRESS_HIST)
		do
			hist := a_hist
			update_memory_field ("hist")
		end

	set_recent_start (a_recent_start: REAL_64)
		do
			recent_start := a_recent_start
			update_memory_field ("recent_start")
		end

	set_recent_bytes (a_recent_bytes: INTEGER_64)
		do
			recent_bytes := a_recent_bytes
			update_memory_field ("recent_bytes")
		end

	set_stalled (a_stalled: BOOLEAN)
		do
			stalled := a_stalled
			update_memory_field ("stalled")
		end

	set_last_eta_time (a_last_eta_time: REAL_64)
		do
			last_eta_time := a_last_eta_time
			update_memory_field ("last_eta_time")
		end

	set_last_eta_value (a_last_eta_value: INTEGER_32)
		do
			last_eta_value := a_last_eta_value
			update_memory_field ("last_eta_value")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			initial_length := a_other.initial_length
			total_length := a_other.total_length
			count := a_other.count
			last_screen_update := a_other.last_screen_update
			width := a_other.width
			buffer := a_other.buffer
			tick := a_other.tick
			hist := a_other.hist.twin
			recent_start := a_other.recent_start
			recent_bytes := a_other.recent_bytes
			stalled := a_other.stalled
			last_eta_time := a_other.last_eta_time
			last_eta_value := a_other.last_eta_value
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				initial_length = a_other.initial_length and
				total_length = a_other.total_length and
				count = a_other.count and
				last_screen_update = a_other.last_screen_update and
				width = a_other.width and
				buffer.is_equal (a_other.buffer) and
				tick = a_other.tick and
				hist.is_equal (a_other.hist) and
				recent_start = a_other.recent_start and
				recent_bytes = a_other.recent_bytes and
				stalled = a_other.stalled and
				last_eta_time = a_other.last_eta_time and
				last_eta_value = a_other.last_eta_value
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("initial_length"),
					create {CE_STRUCTURE_FIELD}.make ("total_length"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("last_screen_update"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("tick"),
					create {CE_STRUCTURE_FIELD}.make ("hist"),
					create {CE_STRUCTURE_FIELD}.make ("recent_start"),
					create {CE_STRUCTURE_FIELD}.make ("recent_bytes"),
					create {CE_STRUCTURE_FIELD}.make ("stalled"),
					create {CE_STRUCTURE_FIELD}.make ("last_eta_time"),
					create {CE_STRUCTURE_FIELD}.make ("last_eta_value")
				>>)
			init_structure_info
		end

end
