class
	PD_BAR_PROGRESS_HIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create times.make (<<20>>)
			create bytes.make (<<20>>)
		end

feature {ANY} -- fields

	pos: INTEGER_32 assign set_pos

	times: CE_ARRAY [REAL_64]

	bytes: CE_ARRAY [INTEGER_64]

	total_time: REAL_64 assign set_total_time

	total_bytes: INTEGER_64 assign set_total_bytes

feature {ANY} -- setters

	set_pos (a_pos: INTEGER_32)
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_total_time (a_total_time: REAL_64)
		do
			total_time := a_total_time
			update_memory_field ("total_time")
		end

	set_total_bytes (a_total_bytes: INTEGER_64)
		do
			total_bytes := a_total_bytes
			update_memory_field ("total_bytes")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pos := a_other.pos
			times := a_other.times.twin
			bytes := a_other.bytes.twin
			total_time := a_other.total_time
			total_bytes := a_other.total_bytes
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pos = a_other.pos and
				times.is_equal (a_other.times) and
				bytes.is_equal (a_other.bytes) and
				total_time = a_other.total_time and
				total_bytes = a_other.total_bytes
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("times", <<20>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("bytes", <<20>>),
					create {CE_STRUCTURE_FIELD}.make ("total_time"),
					create {CE_STRUCTURE_FIELD}.make ("total_bytes")
				>>)
			init_structure_info
		end

end
