class
	PD_COOKIE_JAR

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create chains.make
		end

feature {ANY} -- fields

	chains: CE_POINTER [PD_HASH_TABLE] assign set_chains

	cookie_count: INTEGER_32 assign set_cookie_count

feature {ANY} -- setters

	set_chains (a_chains: CE_POINTER [PD_HASH_TABLE])
		do
			chains := a_chains
			update_memory_field ("chains")
		end

	set_cookie_count (a_cookie_count: INTEGER_32)
		do
			cookie_count := a_cookie_count
			update_memory_field ("cookie_count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			chains := a_other.chains
			cookie_count := a_other.cookie_count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				chains.is_equal (a_other.chains) and
				cookie_count = a_other.cookie_count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("chains"),
					create {CE_STRUCTURE_FIELD}.make ("cookie_count")
				>>)
			init_structure_info
		end

end
