class
	PD_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	d4: SD_IN_ADDR assign set_d4

	d6: SD_IN6_ADDR assign set_d6

feature {ANY} -- setters

	set_d4 (a_d4: SD_IN_ADDR)
		do
			d4 := a_d4
			update_memory_field ("d4")
		end

	set_d6 (a_d6: SD_IN6_ADDR)
		do
			d6 := a_d6
			update_memory_field ("d6")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			d4 := a_other.d4.twin
			d6 := a_other.d6.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				d4.is_equal (a_other.d4) and
				d6.is_equal (a_other.d6)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("d4"),
					create {CE_STRUCTURE_FIELD}.make ("d6")
				>>)
			init_structure_info
		end

end
