class
	PD_FILE_MEMORY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create content.make
		end

feature {ANY} -- fields

	content: CE_POINTER [INTEGER_8] assign set_content

	length: INTEGER_32 assign set_length

	mmap_p: INTEGER_32 assign set_mmap_p

feature {ANY} -- setters

	set_content (a_content: CE_POINTER [INTEGER_8])
		do
			content := a_content
			update_memory_field ("content")
		end

	set_length (a_length: INTEGER_32)
		do
			length := a_length
			update_memory_field ("length")
		end

	set_mmap_p (a_mmap_p: INTEGER_32)
		do
			mmap_p := a_mmap_p
			update_memory_field ("mmap_p")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			content := a_other.content
			length := a_other.length
			mmap_p := a_other.mmap_p
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				content.is_equal (a_other.content) and
				length = a_other.length and
				mmap_p = a_other.mmap_p
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("content"),
					create {CE_STRUCTURE_FIELD}.make ("length"),
					create {CE_STRUCTURE_FIELD}.make ("mmap_p")
				>>)
			init_structure_info
		end

end
