class
	PD_GAIWT_CONTEXT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create node.make
			create service.make
			create hints.make
			create res.make
		end

feature {ANY} -- fields

	node: CE_POINTER [INTEGER_8] assign set_node

	service: CE_POINTER [INTEGER_8] assign set_service

	hints: CE_POINTER [SD_ADDRINFO] assign set_hints

	res: CE_POINTER [CE_POINTER [SD_ADDRINFO]] assign set_res

	exit_code: INTEGER_32 assign set_exit_code

feature {ANY} -- setters

	set_node (a_node: CE_POINTER [INTEGER_8])
		do
			node := a_node
			update_memory_field ("node")
		end

	set_service (a_service: CE_POINTER [INTEGER_8])
		do
			service := a_service
			update_memory_field ("service")
		end

	set_hints (a_hints: CE_POINTER [SD_ADDRINFO])
		do
			hints := a_hints
			update_memory_field ("hints")
		end

	set_res (a_res: CE_POINTER [CE_POINTER [SD_ADDRINFO]])
		do
			res := a_res
			update_memory_field ("res")
		end

	set_exit_code (a_exit_code: INTEGER_32)
		do
			exit_code := a_exit_code
			update_memory_field ("exit_code")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			node := a_other.node
			service := a_other.service
			hints := a_other.hints
			res := a_other.res
			exit_code := a_other.exit_code
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				node.is_equal (a_other.node) and
				service.is_equal (a_other.service) and
				hints.is_equal (a_other.hints) and
				res.is_equal (a_other.res) and
				exit_code = a_other.exit_code
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("node"),
					create {CE_STRUCTURE_FIELD}.make ("service"),
					create {CE_STRUCTURE_FIELD}.make ("hints"),
					create {CE_STRUCTURE_FIELD}.make ("res"),
					create {CE_STRUCTURE_FIELD}.make ("exit_code")
				>>)
			init_structure_info
		end

end
