class
	PD_HASH_TABLE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create hash_function.make
			create test_function.make
			create cells.make
		end

feature {ANY} -- fields

	hash_function: CE_ROUTINE assign set_hash_function

	test_function: CE_ROUTINE assign set_test_function

	cells: CE_POINTER [PD_CELL] assign set_cells

	size: INTEGER_32 assign set_size

	count: INTEGER_32 assign set_count

	resize_threshold: INTEGER_32 assign set_resize_threshold

	prime_offset: INTEGER_32 assign set_prime_offset

feature {ANY} -- setters

	set_hash_function (a_hash_function: CE_ROUTINE)
		do
			hash_function := a_hash_function
			update_memory_field ("hash_function")
		end

	set_test_function (a_test_function: CE_ROUTINE)
		do
			test_function := a_test_function
			update_memory_field ("test_function")
		end

	set_cells (a_cells: CE_POINTER [PD_CELL])
		do
			cells := a_cells
			update_memory_field ("cells")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_count (a_count: INTEGER_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_resize_threshold (a_resize_threshold: INTEGER_32)
		do
			resize_threshold := a_resize_threshold
			update_memory_field ("resize_threshold")
		end

	set_prime_offset (a_prime_offset: INTEGER_32)
		do
			prime_offset := a_prime_offset
			update_memory_field ("prime_offset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hash_function := a_other.hash_function
			test_function := a_other.test_function
			cells := a_other.cells
			size := a_other.size
			count := a_other.count
			resize_threshold := a_other.resize_threshold
			prime_offset := a_other.prime_offset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hash_function.is_equal (a_other.hash_function) and
				test_function.is_equal (a_other.test_function) and
				cells.is_equal (a_other.cells) and
				size = a_other.size and
				count = a_other.count and
				resize_threshold = a_other.resize_threshold and
				prime_offset = a_other.prime_offset
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hash_function"),
					create {CE_STRUCTURE_FIELD}.make ("test_function"),
					create {CE_STRUCTURE_FIELD}.make ("cells"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("resize_threshold"),
					create {CE_STRUCTURE_FIELD}.make ("prime_offset")
				>>)
			init_structure_info
		end

end
