class
	PD_HASH_TABLE_ITERATOR

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create key.make
			create value.make
			create pos.make
			create end2.make
		end

feature {ANY} -- fields

	key: CE_POINTER [ANY] assign set_key

	value: CE_POINTER [ANY] assign set_value

	pos: CE_POINTER [ANY] assign set_pos

	end2: CE_POINTER [ANY] assign set_end2

feature {ANY} -- setters

	set_key (a_key: CE_POINTER [ANY])
		do
			key := a_key
			update_memory_field ("key")
		end

	set_value (a_value: CE_POINTER [ANY])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_pos (a_pos: CE_POINTER [ANY])
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_end2 (a_end2: CE_POINTER [ANY])
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			key := a_other.key
			value := a_other.value
			pos := a_other.pos
			end2 := a_other.end2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				key.is_equal (a_other.key) and
				value.is_equal (a_other.value) and
				pos.is_equal (a_other.pos) and
				end2.is_equal (a_other.end2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("key"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("end2")
				>>)
			init_structure_info
		end

end
