class
	PD_MAP_CONTEXT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create text.make
			create base.make
			create parent_base.make
			create document_file.make
			create head.make
			create tail.make
		end

feature {ANY} -- fields

	text: CE_POINTER [INTEGER_8] assign set_text

	base: CE_POINTER [INTEGER_8] assign set_base

	parent_base: CE_POINTER [INTEGER_8] assign set_parent_base

	document_file: CE_POINTER [INTEGER_8] assign set_document_file

	nofollow: BOOLEAN assign set_nofollow

	head: CE_POINTER [PD_URLPOS] assign set_head

	tail: CE_POINTER [PD_URLPOS] assign set_tail

feature {ANY} -- setters

	set_text (a_text: CE_POINTER [INTEGER_8])
		do
			text := a_text
			update_memory_field ("text")
		end

	set_base (a_base: CE_POINTER [INTEGER_8])
		do
			base := a_base
			update_memory_field ("base")
		end

	set_parent_base (a_parent_base: CE_POINTER [INTEGER_8])
		do
			parent_base := a_parent_base
			update_memory_field ("parent_base")
		end

	set_document_file (a_document_file: CE_POINTER [INTEGER_8])
		do
			document_file := a_document_file
			update_memory_field ("document_file")
		end

	set_nofollow (a_nofollow: BOOLEAN)
		do
			nofollow := a_nofollow
			update_memory_field ("nofollow")
		end

	set_head (a_head: CE_POINTER [PD_URLPOS])
		do
			head := a_head
			update_memory_field ("head")
		end

	set_tail (a_tail: CE_POINTER [PD_URLPOS])
		do
			tail := a_tail
			update_memory_field ("tail")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			text := a_other.text
			base := a_other.base
			parent_base := a_other.parent_base
			document_file := a_other.document_file
			nofollow := a_other.nofollow
			head := a_other.head
			tail := a_other.tail
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				text.is_equal (a_other.text) and
				base.is_equal (a_other.base) and
				parent_base.is_equal (a_other.parent_base) and
				document_file.is_equal (a_other.document_file) and
				nofollow = a_other.nofollow and
				head.is_equal (a_other.head) and
				tail.is_equal (a_other.tail)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("text"),
					create {CE_STRUCTURE_FIELD}.make ("base"),
					create {CE_STRUCTURE_FIELD}.make ("parent_base"),
					create {CE_STRUCTURE_FIELD}.make ("document_file"),
					create {CE_STRUCTURE_FIELD}.make ("nofollow"),
					create {CE_STRUCTURE_FIELD}.make ("head"),
					create {CE_STRUCTURE_FIELD}.make ("tail")
				>>)
			init_structure_info
		end

end
