class
	PD_MD5_CTX

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create total.make (<<2>>)
			create buffer.make (<<32>>)
		end

feature {ANY} -- fields

	A: NATURAL_32 assign set_A

	B: NATURAL_32 assign set_B

	C: NATURAL_32 assign set_C

	D: NATURAL_32 assign set_D

	total: CE_ARRAY [NATURAL_32]

	buflen: NATURAL_32 assign set_buflen

	buffer: CE_ARRAY [NATURAL_32]

feature {ANY} -- setters

	set_A (a_A: NATURAL_32)
		do
			A := a_A
			update_memory_field ("A")
		end

	set_B (a_B: NATURAL_32)
		do
			B := a_B
			update_memory_field ("B")
		end

	set_C (a_C: NATURAL_32)
		do
			C := a_C
			update_memory_field ("C")
		end

	set_D (a_D: NATURAL_32)
		do
			D := a_D
			update_memory_field ("D")
		end

	set_buflen (a_buflen: NATURAL_32)
		do
			buflen := a_buflen
			update_memory_field ("buflen")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			A := a_other.A
			B := a_other.B
			C := a_other.C
			D := a_other.D
			total := a_other.total.twin
			buflen := a_other.buflen
			buffer := a_other.buffer.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				A = a_other.A and
				B = a_other.B and
				C = a_other.C and
				D = a_other.D and
				total.is_equal (a_other.total) and
				buflen = a_other.buflen and
				buffer.is_equal (a_other.buffer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("A"),
					create {CE_STRUCTURE_FIELD}.make ("B"),
					create {CE_STRUCTURE_FIELD}.make ("C"),
					create {CE_STRUCTURE_FIELD}.make ("D"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("total", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("buflen"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("buffer", <<32>>)
				>>)
			init_structure_info
		end

end
