class
	PD_OPTIONS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create dir_prefix.make
			create lfilename.make
			create input_filename.make
			create default_page.make
			create accepts.make
			create rejects.make
			create excludes.make
			create includes.make
			create domains.make
			create exclude_domains.make
			create follow_tags.make
			create ignore_tags.make
			create output_document.make
			create user.make
			create passwd.make
			create ftp_user.make
			create ftp_passwd.make
			create http_user.make
			create http_passwd.make
			create user_headers.make
			create http_proxy.make
			create ftp_proxy.make
			create https_proxy.make
			create no_proxy.make
			create base_href.make
			create progress_type.make
			create proxy_user.make
			create proxy_passwd.make
			create useragent.make
			create referer.make
			create dot_style.make
			create bind_address.make
			create cookies_input.make
			create cookies_output.make
			create post_data.make
			create post_file_name.make
			create encoding_remote.make
			create locale.make
		end

feature {ANY} -- fields

	verbose: INTEGER_32 assign set_verbose

	quiet: BOOLEAN assign set_quiet

	ntry: INTEGER_32 assign set_ntry

	retry_connrefused: BOOLEAN assign set_retry_connrefused

	background: BOOLEAN assign set_background

	ignore_length: BOOLEAN assign set_ignore_length

	recursive: BOOLEAN assign set_recursive

	spanhost: BOOLEAN assign set_spanhost

	max_redirect: INTEGER_32 assign set_max_redirect

	relative_only: BOOLEAN assign set_relative_only

	no_parent: BOOLEAN assign set_no_parent

	reclevel: INTEGER_32 assign set_reclevel

	dirstruct: BOOLEAN assign set_dirstruct

	no_dirstruct: BOOLEAN assign set_no_dirstruct

	cut_dirs: INTEGER_32 assign set_cut_dirs

	add_hostdir: BOOLEAN assign set_add_hostdir

	protocol_directories: BOOLEAN assign set_protocol_directories

	noclobber: BOOLEAN assign set_noclobber

	dir_prefix: CE_POINTER [INTEGER_8] assign set_dir_prefix

	lfilename: CE_POINTER [INTEGER_8] assign set_lfilename

	input_filename: CE_POINTER [INTEGER_8] assign set_input_filename

	force_html: BOOLEAN assign set_force_html

	default_page: CE_POINTER [INTEGER_8] assign set_default_page

	spider: BOOLEAN assign set_spider

	accepts: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_accepts

	rejects: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_rejects

	excludes: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_excludes

	includes: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_includes

	ignore_case: BOOLEAN assign set_ignore_case

	domains: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_domains

	exclude_domains: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_exclude_domains

	dns_cache: BOOLEAN assign set_dns_cache

	follow_tags: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_follow_tags

	ignore_tags: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_ignore_tags

	follow_ftp: BOOLEAN assign set_follow_ftp

	retr_symlinks: BOOLEAN assign set_retr_symlinks

	output_document: CE_POINTER [INTEGER_8] assign set_output_document

	user: CE_POINTER [INTEGER_8] assign set_user

	passwd: CE_POINTER [INTEGER_8] assign set_passwd

	ask_passwd: BOOLEAN assign set_ask_passwd

	always_rest: BOOLEAN assign set_always_rest

	ftp_user: CE_POINTER [INTEGER_8] assign set_ftp_user

	ftp_passwd: CE_POINTER [INTEGER_8] assign set_ftp_passwd

	netrc: BOOLEAN assign set_netrc

	ftp_glob: BOOLEAN assign set_ftp_glob

	ftp_pasv: BOOLEAN assign set_ftp_pasv

	http_user: CE_POINTER [INTEGER_8] assign set_http_user

	http_passwd: CE_POINTER [INTEGER_8] assign set_http_passwd

	user_headers: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_user_headers

	http_keep_alive: BOOLEAN assign set_http_keep_alive

	use_proxy: BOOLEAN assign set_use_proxy

	allow_cache: BOOLEAN assign set_allow_cache

	http_proxy: CE_POINTER [INTEGER_8] assign set_http_proxy

	ftp_proxy: CE_POINTER [INTEGER_8] assign set_ftp_proxy

	https_proxy: CE_POINTER [INTEGER_8] assign set_https_proxy

	no_proxy: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_no_proxy

	base_href: CE_POINTER [INTEGER_8] assign set_base_href

	progress_type: CE_POINTER [INTEGER_8] assign set_progress_type

	proxy_user: CE_POINTER [INTEGER_8] assign set_proxy_user

	proxy_passwd: CE_POINTER [INTEGER_8] assign set_proxy_passwd

	read_timeout: REAL_64 assign set_read_timeout

	dns_timeout: REAL_64 assign set_dns_timeout

	connect_timeout: REAL_64 assign set_connect_timeout

	random_wait: BOOLEAN assign set_random_wait

	wait: REAL_64 assign set_wait

	waitretry: REAL_64 assign set_waitretry

	use_robots: BOOLEAN assign set_use_robots

	limit_rate: INTEGER_64 assign set_limit_rate

	quota: INTEGER_64 assign set_quota

	server_response: BOOLEAN assign set_server_response

	save_headers: BOOLEAN assign set_save_headers

	debug2: BOOLEAN assign set_debug2

	timestamping: BOOLEAN assign set_timestamping

	backup_converted: BOOLEAN assign set_backup_converted

	backups: BOOLEAN assign set_backups

	useragent: CE_POINTER [INTEGER_8] assign set_useragent

	referer: CE_POINTER [INTEGER_8] assign set_referer

	convert_links: BOOLEAN assign set_convert_links

	remove_listing: BOOLEAN assign set_remove_listing

	htmlify: BOOLEAN assign set_htmlify

	dot_style: CE_POINTER [INTEGER_8] assign set_dot_style

	dot_bytes: INTEGER_64 assign set_dot_bytes

	dots_in_line: INTEGER_32 assign set_dots_in_line

	dot_spacing: INTEGER_32 assign set_dot_spacing

	delete_after: BOOLEAN assign set_delete_after

	adjust_extension: BOOLEAN assign set_adjust_extension

	page_requisites: BOOLEAN assign set_page_requisites

	bind_address: CE_POINTER [INTEGER_8] assign set_bind_address

	cookies: BOOLEAN assign set_cookies

	cookies_input: CE_POINTER [INTEGER_8] assign set_cookies_input

	cookies_output: CE_POINTER [INTEGER_8] assign set_cookies_output

	keep_session_cookies: BOOLEAN assign set_keep_session_cookies

	post_data: CE_POINTER [INTEGER_8] assign set_post_data

	post_file_name: CE_POINTER [INTEGER_8] assign set_post_file_name

	restrict_files_os: NATURAL_32 assign set_restrict_files_os

	restrict_files_ctrl: BOOLEAN assign set_restrict_files_ctrl

	restrict_files_nonascii: BOOLEAN assign set_restrict_files_nonascii

	restrict_files_case: NATURAL_32 assign set_restrict_files_case

	strict_comments: BOOLEAN assign set_strict_comments

	preserve_perm: BOOLEAN assign set_preserve_perm

	ipv4_only: BOOLEAN assign set_ipv4_only

	ipv6_only: BOOLEAN assign set_ipv6_only

	prefer_family: NATURAL_32 assign set_prefer_family

	content_disposition: BOOLEAN assign set_content_disposition

	auth_without_challenge: BOOLEAN assign set_auth_without_challenge

	enable_iri: BOOLEAN assign set_enable_iri

	encoding_remote: CE_POINTER [INTEGER_8] assign set_encoding_remote

	locale: CE_POINTER [INTEGER_8] assign set_locale

feature {ANY} -- setters

	set_verbose (a_verbose: INTEGER_32)
		do
			verbose := a_verbose
			update_memory_field ("verbose")
		end

	set_quiet (a_quiet: BOOLEAN)
		do
			quiet := a_quiet
			update_memory_field ("quiet")
		end

	set_ntry (a_ntry: INTEGER_32)
		do
			ntry := a_ntry
			update_memory_field ("ntry")
		end

	set_retry_connrefused (a_retry_connrefused: BOOLEAN)
		do
			retry_connrefused := a_retry_connrefused
			update_memory_field ("retry_connrefused")
		end

	set_background (a_background: BOOLEAN)
		do
			background := a_background
			update_memory_field ("background")
		end

	set_ignore_length (a_ignore_length: BOOLEAN)
		do
			ignore_length := a_ignore_length
			update_memory_field ("ignore_length")
		end

	set_recursive (a_recursive: BOOLEAN)
		do
			recursive := a_recursive
			update_memory_field ("recursive")
		end

	set_spanhost (a_spanhost: BOOLEAN)
		do
			spanhost := a_spanhost
			update_memory_field ("spanhost")
		end

	set_max_redirect (a_max_redirect: INTEGER_32)
		do
			max_redirect := a_max_redirect
			update_memory_field ("max_redirect")
		end

	set_relative_only (a_relative_only: BOOLEAN)
		do
			relative_only := a_relative_only
			update_memory_field ("relative_only")
		end

	set_no_parent (a_no_parent: BOOLEAN)
		do
			no_parent := a_no_parent
			update_memory_field ("no_parent")
		end

	set_reclevel (a_reclevel: INTEGER_32)
		do
			reclevel := a_reclevel
			update_memory_field ("reclevel")
		end

	set_dirstruct (a_dirstruct: BOOLEAN)
		do
			dirstruct := a_dirstruct
			update_memory_field ("dirstruct")
		end

	set_no_dirstruct (a_no_dirstruct: BOOLEAN)
		do
			no_dirstruct := a_no_dirstruct
			update_memory_field ("no_dirstruct")
		end

	set_cut_dirs (a_cut_dirs: INTEGER_32)
		do
			cut_dirs := a_cut_dirs
			update_memory_field ("cut_dirs")
		end

	set_add_hostdir (a_add_hostdir: BOOLEAN)
		do
			add_hostdir := a_add_hostdir
			update_memory_field ("add_hostdir")
		end

	set_protocol_directories (a_protocol_directories: BOOLEAN)
		do
			protocol_directories := a_protocol_directories
			update_memory_field ("protocol_directories")
		end

	set_noclobber (a_noclobber: BOOLEAN)
		do
			noclobber := a_noclobber
			update_memory_field ("noclobber")
		end

	set_dir_prefix (a_dir_prefix: CE_POINTER [INTEGER_8])
		do
			dir_prefix := a_dir_prefix
			update_memory_field ("dir_prefix")
		end

	set_lfilename (a_lfilename: CE_POINTER [INTEGER_8])
		do
			lfilename := a_lfilename
			update_memory_field ("lfilename")
		end

	set_input_filename (a_input_filename: CE_POINTER [INTEGER_8])
		do
			input_filename := a_input_filename
			update_memory_field ("input_filename")
		end

	set_force_html (a_force_html: BOOLEAN)
		do
			force_html := a_force_html
			update_memory_field ("force_html")
		end

	set_default_page (a_default_page: CE_POINTER [INTEGER_8])
		do
			default_page := a_default_page
			update_memory_field ("default_page")
		end

	set_spider (a_spider: BOOLEAN)
		do
			spider := a_spider
			update_memory_field ("spider")
		end

	set_accepts (a_accepts: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			accepts := a_accepts
			update_memory_field ("accepts")
		end

	set_rejects (a_rejects: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			rejects := a_rejects
			update_memory_field ("rejects")
		end

	set_excludes (a_excludes: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			excludes := a_excludes
			update_memory_field ("excludes")
		end

	set_includes (a_includes: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			includes := a_includes
			update_memory_field ("includes")
		end

	set_ignore_case (a_ignore_case: BOOLEAN)
		do
			ignore_case := a_ignore_case
			update_memory_field ("ignore_case")
		end

	set_domains (a_domains: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			domains := a_domains
			update_memory_field ("domains")
		end

	set_exclude_domains (a_exclude_domains: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			exclude_domains := a_exclude_domains
			update_memory_field ("exclude_domains")
		end

	set_dns_cache (a_dns_cache: BOOLEAN)
		do
			dns_cache := a_dns_cache
			update_memory_field ("dns_cache")
		end

	set_follow_tags (a_follow_tags: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			follow_tags := a_follow_tags
			update_memory_field ("follow_tags")
		end

	set_ignore_tags (a_ignore_tags: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			ignore_tags := a_ignore_tags
			update_memory_field ("ignore_tags")
		end

	set_follow_ftp (a_follow_ftp: BOOLEAN)
		do
			follow_ftp := a_follow_ftp
			update_memory_field ("follow_ftp")
		end

	set_retr_symlinks (a_retr_symlinks: BOOLEAN)
		do
			retr_symlinks := a_retr_symlinks
			update_memory_field ("retr_symlinks")
		end

	set_output_document (a_output_document: CE_POINTER [INTEGER_8])
		do
			output_document := a_output_document
			update_memory_field ("output_document")
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			user := a_user
			update_memory_field ("user")
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			passwd := a_passwd
			update_memory_field ("passwd")
		end

	set_ask_passwd (a_ask_passwd: BOOLEAN)
		do
			ask_passwd := a_ask_passwd
			update_memory_field ("ask_passwd")
		end

	set_always_rest (a_always_rest: BOOLEAN)
		do
			always_rest := a_always_rest
			update_memory_field ("always_rest")
		end

	set_ftp_user (a_ftp_user: CE_POINTER [INTEGER_8])
		do
			ftp_user := a_ftp_user
			update_memory_field ("ftp_user")
		end

	set_ftp_passwd (a_ftp_passwd: CE_POINTER [INTEGER_8])
		do
			ftp_passwd := a_ftp_passwd
			update_memory_field ("ftp_passwd")
		end

	set_netrc (a_netrc: BOOLEAN)
		do
			netrc := a_netrc
			update_memory_field ("netrc")
		end

	set_ftp_glob (a_ftp_glob: BOOLEAN)
		do
			ftp_glob := a_ftp_glob
			update_memory_field ("ftp_glob")
		end

	set_ftp_pasv (a_ftp_pasv: BOOLEAN)
		do
			ftp_pasv := a_ftp_pasv
			update_memory_field ("ftp_pasv")
		end

	set_http_user (a_http_user: CE_POINTER [INTEGER_8])
		do
			http_user := a_http_user
			update_memory_field ("http_user")
		end

	set_http_passwd (a_http_passwd: CE_POINTER [INTEGER_8])
		do
			http_passwd := a_http_passwd
			update_memory_field ("http_passwd")
		end

	set_user_headers (a_user_headers: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			user_headers := a_user_headers
			update_memory_field ("user_headers")
		end

	set_http_keep_alive (a_http_keep_alive: BOOLEAN)
		do
			http_keep_alive := a_http_keep_alive
			update_memory_field ("http_keep_alive")
		end

	set_use_proxy (a_use_proxy: BOOLEAN)
		do
			use_proxy := a_use_proxy
			update_memory_field ("use_proxy")
		end

	set_allow_cache (a_allow_cache: BOOLEAN)
		do
			allow_cache := a_allow_cache
			update_memory_field ("allow_cache")
		end

	set_http_proxy (a_http_proxy: CE_POINTER [INTEGER_8])
		do
			http_proxy := a_http_proxy
			update_memory_field ("http_proxy")
		end

	set_ftp_proxy (a_ftp_proxy: CE_POINTER [INTEGER_8])
		do
			ftp_proxy := a_ftp_proxy
			update_memory_field ("ftp_proxy")
		end

	set_https_proxy (a_https_proxy: CE_POINTER [INTEGER_8])
		do
			https_proxy := a_https_proxy
			update_memory_field ("https_proxy")
		end

	set_no_proxy (a_no_proxy: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			no_proxy := a_no_proxy
			update_memory_field ("no_proxy")
		end

	set_base_href (a_base_href: CE_POINTER [INTEGER_8])
		do
			base_href := a_base_href
			update_memory_field ("base_href")
		end

	set_progress_type (a_progress_type: CE_POINTER [INTEGER_8])
		do
			progress_type := a_progress_type
			update_memory_field ("progress_type")
		end

	set_proxy_user (a_proxy_user: CE_POINTER [INTEGER_8])
		do
			proxy_user := a_proxy_user
			update_memory_field ("proxy_user")
		end

	set_proxy_passwd (a_proxy_passwd: CE_POINTER [INTEGER_8])
		do
			proxy_passwd := a_proxy_passwd
			update_memory_field ("proxy_passwd")
		end

	set_read_timeout (a_read_timeout: REAL_64)
		do
			read_timeout := a_read_timeout
			update_memory_field ("read_timeout")
		end

	set_dns_timeout (a_dns_timeout: REAL_64)
		do
			dns_timeout := a_dns_timeout
			update_memory_field ("dns_timeout")
		end

	set_connect_timeout (a_connect_timeout: REAL_64)
		do
			connect_timeout := a_connect_timeout
			update_memory_field ("connect_timeout")
		end

	set_random_wait (a_random_wait: BOOLEAN)
		do
			random_wait := a_random_wait
			update_memory_field ("random_wait")
		end

	set_wait (a_wait: REAL_64)
		do
			wait := a_wait
			update_memory_field ("wait")
		end

	set_waitretry (a_waitretry: REAL_64)
		do
			waitretry := a_waitretry
			update_memory_field ("waitretry")
		end

	set_use_robots (a_use_robots: BOOLEAN)
		do
			use_robots := a_use_robots
			update_memory_field ("use_robots")
		end

	set_limit_rate (a_limit_rate: INTEGER_64)
		do
			limit_rate := a_limit_rate
			update_memory_field ("limit_rate")
		end

	set_quota (a_quota: INTEGER_64)
		do
			quota := a_quota
			update_memory_field ("quota")
		end

	set_server_response (a_server_response: BOOLEAN)
		do
			server_response := a_server_response
			update_memory_field ("server_response")
		end

	set_save_headers (a_save_headers: BOOLEAN)
		do
			save_headers := a_save_headers
			update_memory_field ("save_headers")
		end

	set_debug2 (a_debug2: BOOLEAN)
		do
			debug2 := a_debug2
			update_memory_field ("debug2")
		end

	set_timestamping (a_timestamping: BOOLEAN)
		do
			timestamping := a_timestamping
			update_memory_field ("timestamping")
		end

	set_backup_converted (a_backup_converted: BOOLEAN)
		do
			backup_converted := a_backup_converted
			update_memory_field ("backup_converted")
		end

	set_backups (a_backups: BOOLEAN)
		do
			backups := a_backups
			update_memory_field ("backups")
		end

	set_useragent (a_useragent: CE_POINTER [INTEGER_8])
		do
			useragent := a_useragent
			update_memory_field ("useragent")
		end

	set_referer (a_referer: CE_POINTER [INTEGER_8])
		do
			referer := a_referer
			update_memory_field ("referer")
		end

	set_convert_links (a_convert_links: BOOLEAN)
		do
			convert_links := a_convert_links
			update_memory_field ("convert_links")
		end

	set_remove_listing (a_remove_listing: BOOLEAN)
		do
			remove_listing := a_remove_listing
			update_memory_field ("remove_listing")
		end

	set_htmlify (a_htmlify: BOOLEAN)
		do
			htmlify := a_htmlify
			update_memory_field ("htmlify")
		end

	set_dot_style (a_dot_style: CE_POINTER [INTEGER_8])
		do
			dot_style := a_dot_style
			update_memory_field ("dot_style")
		end

	set_dot_bytes (a_dot_bytes: INTEGER_64)
		do
			dot_bytes := a_dot_bytes
			update_memory_field ("dot_bytes")
		end

	set_dots_in_line (a_dots_in_line: INTEGER_32)
		do
			dots_in_line := a_dots_in_line
			update_memory_field ("dots_in_line")
		end

	set_dot_spacing (a_dot_spacing: INTEGER_32)
		do
			dot_spacing := a_dot_spacing
			update_memory_field ("dot_spacing")
		end

	set_delete_after (a_delete_after: BOOLEAN)
		do
			delete_after := a_delete_after
			update_memory_field ("delete_after")
		end

	set_adjust_extension (a_adjust_extension: BOOLEAN)
		do
			adjust_extension := a_adjust_extension
			update_memory_field ("adjust_extension")
		end

	set_page_requisites (a_page_requisites: BOOLEAN)
		do
			page_requisites := a_page_requisites
			update_memory_field ("page_requisites")
		end

	set_bind_address (a_bind_address: CE_POINTER [INTEGER_8])
		do
			bind_address := a_bind_address
			update_memory_field ("bind_address")
		end

	set_cookies (a_cookies: BOOLEAN)
		do
			cookies := a_cookies
			update_memory_field ("cookies")
		end

	set_cookies_input (a_cookies_input: CE_POINTER [INTEGER_8])
		do
			cookies_input := a_cookies_input
			update_memory_field ("cookies_input")
		end

	set_cookies_output (a_cookies_output: CE_POINTER [INTEGER_8])
		do
			cookies_output := a_cookies_output
			update_memory_field ("cookies_output")
		end

	set_keep_session_cookies (a_keep_session_cookies: BOOLEAN)
		do
			keep_session_cookies := a_keep_session_cookies
			update_memory_field ("keep_session_cookies")
		end

	set_post_data (a_post_data: CE_POINTER [INTEGER_8])
		do
			post_data := a_post_data
			update_memory_field ("post_data")
		end

	set_post_file_name (a_post_file_name: CE_POINTER [INTEGER_8])
		do
			post_file_name := a_post_file_name
			update_memory_field ("post_file_name")
		end

	set_restrict_files_os (a_restrict_files_os: NATURAL_32)
		do
			restrict_files_os := a_restrict_files_os
			update_memory_field ("restrict_files_os")
		end

	set_restrict_files_ctrl (a_restrict_files_ctrl: BOOLEAN)
		do
			restrict_files_ctrl := a_restrict_files_ctrl
			update_memory_field ("restrict_files_ctrl")
		end

	set_restrict_files_nonascii (a_restrict_files_nonascii: BOOLEAN)
		do
			restrict_files_nonascii := a_restrict_files_nonascii
			update_memory_field ("restrict_files_nonascii")
		end

	set_restrict_files_case (a_restrict_files_case: NATURAL_32)
		do
			restrict_files_case := a_restrict_files_case
			update_memory_field ("restrict_files_case")
		end

	set_strict_comments (a_strict_comments: BOOLEAN)
		do
			strict_comments := a_strict_comments
			update_memory_field ("strict_comments")
		end

	set_preserve_perm (a_preserve_perm: BOOLEAN)
		do
			preserve_perm := a_preserve_perm
			update_memory_field ("preserve_perm")
		end

	set_ipv4_only (a_ipv4_only: BOOLEAN)
		do
			ipv4_only := a_ipv4_only
			update_memory_field ("ipv4_only")
		end

	set_ipv6_only (a_ipv6_only: BOOLEAN)
		do
			ipv6_only := a_ipv6_only
			update_memory_field ("ipv6_only")
		end

	set_prefer_family (a_prefer_family: NATURAL_32)
		do
			prefer_family := a_prefer_family
			update_memory_field ("prefer_family")
		end

	set_content_disposition (a_content_disposition: BOOLEAN)
		do
			content_disposition := a_content_disposition
			update_memory_field ("content_disposition")
		end

	set_auth_without_challenge (a_auth_without_challenge: BOOLEAN)
		do
			auth_without_challenge := a_auth_without_challenge
			update_memory_field ("auth_without_challenge")
		end

	set_enable_iri (a_enable_iri: BOOLEAN)
		do
			enable_iri := a_enable_iri
			update_memory_field ("enable_iri")
		end

	set_encoding_remote (a_encoding_remote: CE_POINTER [INTEGER_8])
		do
			encoding_remote := a_encoding_remote
			update_memory_field ("encoding_remote")
		end

	set_locale (a_locale: CE_POINTER [INTEGER_8])
		do
			locale := a_locale
			update_memory_field ("locale")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			verbose := a_other.verbose
			quiet := a_other.quiet
			ntry := a_other.ntry
			retry_connrefused := a_other.retry_connrefused
			background := a_other.background
			ignore_length := a_other.ignore_length
			recursive := a_other.recursive
			spanhost := a_other.spanhost
			max_redirect := a_other.max_redirect
			relative_only := a_other.relative_only
			no_parent := a_other.no_parent
			reclevel := a_other.reclevel
			dirstruct := a_other.dirstruct
			no_dirstruct := a_other.no_dirstruct
			cut_dirs := a_other.cut_dirs
			add_hostdir := a_other.add_hostdir
			protocol_directories := a_other.protocol_directories
			noclobber := a_other.noclobber
			dir_prefix := a_other.dir_prefix
			lfilename := a_other.lfilename
			input_filename := a_other.input_filename
			force_html := a_other.force_html
			default_page := a_other.default_page
			spider := a_other.spider
			accepts := a_other.accepts
			rejects := a_other.rejects
			excludes := a_other.excludes
			includes := a_other.includes
			ignore_case := a_other.ignore_case
			domains := a_other.domains
			exclude_domains := a_other.exclude_domains
			dns_cache := a_other.dns_cache
			follow_tags := a_other.follow_tags
			ignore_tags := a_other.ignore_tags
			follow_ftp := a_other.follow_ftp
			retr_symlinks := a_other.retr_symlinks
			output_document := a_other.output_document
			user := a_other.user
			passwd := a_other.passwd
			ask_passwd := a_other.ask_passwd
			always_rest := a_other.always_rest
			ftp_user := a_other.ftp_user
			ftp_passwd := a_other.ftp_passwd
			netrc := a_other.netrc
			ftp_glob := a_other.ftp_glob
			ftp_pasv := a_other.ftp_pasv
			http_user := a_other.http_user
			http_passwd := a_other.http_passwd
			user_headers := a_other.user_headers
			http_keep_alive := a_other.http_keep_alive
			use_proxy := a_other.use_proxy
			allow_cache := a_other.allow_cache
			http_proxy := a_other.http_proxy
			ftp_proxy := a_other.ftp_proxy
			https_proxy := a_other.https_proxy
			no_proxy := a_other.no_proxy
			base_href := a_other.base_href
			progress_type := a_other.progress_type
			proxy_user := a_other.proxy_user
			proxy_passwd := a_other.proxy_passwd
			read_timeout := a_other.read_timeout
			dns_timeout := a_other.dns_timeout
			connect_timeout := a_other.connect_timeout
			random_wait := a_other.random_wait
			wait := a_other.wait
			waitretry := a_other.waitretry
			use_robots := a_other.use_robots
			limit_rate := a_other.limit_rate
			quota := a_other.quota
			server_response := a_other.server_response
			save_headers := a_other.save_headers
			debug2 := a_other.debug2
			timestamping := a_other.timestamping
			backup_converted := a_other.backup_converted
			backups := a_other.backups
			useragent := a_other.useragent
			referer := a_other.referer
			convert_links := a_other.convert_links
			remove_listing := a_other.remove_listing
			htmlify := a_other.htmlify
			dot_style := a_other.dot_style
			dot_bytes := a_other.dot_bytes
			dots_in_line := a_other.dots_in_line
			dot_spacing := a_other.dot_spacing
			delete_after := a_other.delete_after
			adjust_extension := a_other.adjust_extension
			page_requisites := a_other.page_requisites
			bind_address := a_other.bind_address
			cookies := a_other.cookies
			cookies_input := a_other.cookies_input
			cookies_output := a_other.cookies_output
			keep_session_cookies := a_other.keep_session_cookies
			post_data := a_other.post_data
			post_file_name := a_other.post_file_name
			restrict_files_os := a_other.restrict_files_os
			restrict_files_ctrl := a_other.restrict_files_ctrl
			restrict_files_nonascii := a_other.restrict_files_nonascii
			restrict_files_case := a_other.restrict_files_case
			strict_comments := a_other.strict_comments
			preserve_perm := a_other.preserve_perm
			ipv4_only := a_other.ipv4_only
			ipv6_only := a_other.ipv6_only
			prefer_family := a_other.prefer_family
			content_disposition := a_other.content_disposition
			auth_without_challenge := a_other.auth_without_challenge
			enable_iri := a_other.enable_iri
			encoding_remote := a_other.encoding_remote
			locale := a_other.locale
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				verbose = a_other.verbose and
				quiet = a_other.quiet and
				ntry = a_other.ntry and
				retry_connrefused = a_other.retry_connrefused and
				background = a_other.background and
				ignore_length = a_other.ignore_length and
				recursive = a_other.recursive and
				spanhost = a_other.spanhost and
				max_redirect = a_other.max_redirect and
				relative_only = a_other.relative_only and
				no_parent = a_other.no_parent and
				reclevel = a_other.reclevel and
				dirstruct = a_other.dirstruct and
				no_dirstruct = a_other.no_dirstruct and
				cut_dirs = a_other.cut_dirs and
				add_hostdir = a_other.add_hostdir and
				protocol_directories = a_other.protocol_directories and
				noclobber = a_other.noclobber and
				dir_prefix.is_equal (a_other.dir_prefix) and
				lfilename.is_equal (a_other.lfilename) and
				input_filename.is_equal (a_other.input_filename) and
				force_html = a_other.force_html and
				default_page.is_equal (a_other.default_page) and
				spider = a_other.spider and
				accepts.is_equal (a_other.accepts) and
				rejects.is_equal (a_other.rejects) and
				excludes.is_equal (a_other.excludes) and
				includes.is_equal (a_other.includes) and
				ignore_case = a_other.ignore_case and
				domains.is_equal (a_other.domains) and
				exclude_domains.is_equal (a_other.exclude_domains) and
				dns_cache = a_other.dns_cache and
				follow_tags.is_equal (a_other.follow_tags) and
				ignore_tags.is_equal (a_other.ignore_tags) and
				follow_ftp = a_other.follow_ftp and
				retr_symlinks = a_other.retr_symlinks and
				output_document.is_equal (a_other.output_document) and
				user.is_equal (a_other.user) and
				passwd.is_equal (a_other.passwd) and
				ask_passwd = a_other.ask_passwd and
				always_rest = a_other.always_rest and
				ftp_user.is_equal (a_other.ftp_user) and
				ftp_passwd.is_equal (a_other.ftp_passwd) and
				netrc = a_other.netrc and
				ftp_glob = a_other.ftp_glob and
				ftp_pasv = a_other.ftp_pasv and
				http_user.is_equal (a_other.http_user) and
				http_passwd.is_equal (a_other.http_passwd) and
				user_headers.is_equal (a_other.user_headers) and
				http_keep_alive = a_other.http_keep_alive and
				use_proxy = a_other.use_proxy and
				allow_cache = a_other.allow_cache and
				http_proxy.is_equal (a_other.http_proxy) and
				ftp_proxy.is_equal (a_other.ftp_proxy) and
				https_proxy.is_equal (a_other.https_proxy) and
				no_proxy.is_equal (a_other.no_proxy) and
				base_href.is_equal (a_other.base_href) and
				progress_type.is_equal (a_other.progress_type) and
				proxy_user.is_equal (a_other.proxy_user) and
				proxy_passwd.is_equal (a_other.proxy_passwd) and
				read_timeout = a_other.read_timeout and
				dns_timeout = a_other.dns_timeout and
				connect_timeout = a_other.connect_timeout and
				random_wait = a_other.random_wait and
				wait = a_other.wait and
				waitretry = a_other.waitretry and
				use_robots = a_other.use_robots and
				limit_rate = a_other.limit_rate and
				quota = a_other.quota and
				server_response = a_other.server_response and
				save_headers = a_other.save_headers and
				debug2 = a_other.debug2 and
				timestamping = a_other.timestamping and
				backup_converted = a_other.backup_converted and
				backups = a_other.backups and
				useragent.is_equal (a_other.useragent) and
				referer.is_equal (a_other.referer) and
				convert_links = a_other.convert_links and
				remove_listing = a_other.remove_listing and
				htmlify = a_other.htmlify and
				dot_style.is_equal (a_other.dot_style) and
				dot_bytes = a_other.dot_bytes and
				dots_in_line = a_other.dots_in_line and
				dot_spacing = a_other.dot_spacing and
				delete_after = a_other.delete_after and
				adjust_extension = a_other.adjust_extension and
				page_requisites = a_other.page_requisites and
				bind_address.is_equal (a_other.bind_address) and
				cookies = a_other.cookies and
				cookies_input.is_equal (a_other.cookies_input) and
				cookies_output.is_equal (a_other.cookies_output) and
				keep_session_cookies = a_other.keep_session_cookies and
				post_data.is_equal (a_other.post_data) and
				post_file_name.is_equal (a_other.post_file_name) and
				restrict_files_os = a_other.restrict_files_os and
				restrict_files_ctrl = a_other.restrict_files_ctrl and
				restrict_files_nonascii = a_other.restrict_files_nonascii and
				restrict_files_case = a_other.restrict_files_case and
				strict_comments = a_other.strict_comments and
				preserve_perm = a_other.preserve_perm and
				ipv4_only = a_other.ipv4_only and
				ipv6_only = a_other.ipv6_only and
				prefer_family = a_other.prefer_family and
				content_disposition = a_other.content_disposition and
				auth_without_challenge = a_other.auth_without_challenge and
				enable_iri = a_other.enable_iri and
				encoding_remote.is_equal (a_other.encoding_remote) and
				locale.is_equal (a_other.locale)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("verbose"),
					create {CE_STRUCTURE_FIELD}.make ("quiet"),
					create {CE_STRUCTURE_FIELD}.make ("ntry"),
					create {CE_STRUCTURE_FIELD}.make ("retry_connrefused"),
					create {CE_STRUCTURE_FIELD}.make ("background"),
					create {CE_STRUCTURE_FIELD}.make ("ignore_length"),
					create {CE_STRUCTURE_FIELD}.make ("recursive"),
					create {CE_STRUCTURE_FIELD}.make ("spanhost"),
					create {CE_STRUCTURE_FIELD}.make ("max_redirect"),
					create {CE_STRUCTURE_FIELD}.make ("relative_only"),
					create {CE_STRUCTURE_FIELD}.make ("no_parent"),
					create {CE_STRUCTURE_FIELD}.make ("reclevel"),
					create {CE_STRUCTURE_FIELD}.make ("dirstruct"),
					create {CE_STRUCTURE_FIELD}.make ("no_dirstruct"),
					create {CE_STRUCTURE_FIELD}.make ("cut_dirs"),
					create {CE_STRUCTURE_FIELD}.make ("add_hostdir"),
					create {CE_STRUCTURE_FIELD}.make ("protocol_directories"),
					create {CE_STRUCTURE_FIELD}.make ("noclobber"),
					create {CE_STRUCTURE_FIELD}.make ("dir_prefix"),
					create {CE_STRUCTURE_FIELD}.make ("lfilename"),
					create {CE_STRUCTURE_FIELD}.make ("input_filename"),
					create {CE_STRUCTURE_FIELD}.make ("force_html"),
					create {CE_STRUCTURE_FIELD}.make ("default_page"),
					create {CE_STRUCTURE_FIELD}.make ("spider"),
					create {CE_STRUCTURE_FIELD}.make ("accepts"),
					create {CE_STRUCTURE_FIELD}.make ("rejects"),
					create {CE_STRUCTURE_FIELD}.make ("excludes"),
					create {CE_STRUCTURE_FIELD}.make ("includes"),
					create {CE_STRUCTURE_FIELD}.make ("ignore_case"),
					create {CE_STRUCTURE_FIELD}.make ("domains"),
					create {CE_STRUCTURE_FIELD}.make ("exclude_domains"),
					create {CE_STRUCTURE_FIELD}.make ("dns_cache"),
					create {CE_STRUCTURE_FIELD}.make ("follow_tags"),
					create {CE_STRUCTURE_FIELD}.make ("ignore_tags"),
					create {CE_STRUCTURE_FIELD}.make ("follow_ftp"),
					create {CE_STRUCTURE_FIELD}.make ("retr_symlinks"),
					create {CE_STRUCTURE_FIELD}.make ("output_document"),
					create {CE_STRUCTURE_FIELD}.make ("user"),
					create {CE_STRUCTURE_FIELD}.make ("passwd"),
					create {CE_STRUCTURE_FIELD}.make ("ask_passwd"),
					create {CE_STRUCTURE_FIELD}.make ("always_rest"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_user"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_passwd"),
					create {CE_STRUCTURE_FIELD}.make ("netrc"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_glob"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_pasv"),
					create {CE_STRUCTURE_FIELD}.make ("http_user"),
					create {CE_STRUCTURE_FIELD}.make ("http_passwd"),
					create {CE_STRUCTURE_FIELD}.make ("user_headers"),
					create {CE_STRUCTURE_FIELD}.make ("http_keep_alive"),
					create {CE_STRUCTURE_FIELD}.make ("use_proxy"),
					create {CE_STRUCTURE_FIELD}.make ("allow_cache"),
					create {CE_STRUCTURE_FIELD}.make ("http_proxy"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_proxy"),
					create {CE_STRUCTURE_FIELD}.make ("https_proxy"),
					create {CE_STRUCTURE_FIELD}.make ("no_proxy"),
					create {CE_STRUCTURE_FIELD}.make ("base_href"),
					create {CE_STRUCTURE_FIELD}.make ("progress_type"),
					create {CE_STRUCTURE_FIELD}.make ("proxy_user"),
					create {CE_STRUCTURE_FIELD}.make ("proxy_passwd"),
					create {CE_STRUCTURE_FIELD}.make ("read_timeout"),
					create {CE_STRUCTURE_FIELD}.make ("dns_timeout"),
					create {CE_STRUCTURE_FIELD}.make ("connect_timeout"),
					create {CE_STRUCTURE_FIELD}.make ("random_wait"),
					create {CE_STRUCTURE_FIELD}.make ("wait"),
					create {CE_STRUCTURE_FIELD}.make ("waitretry"),
					create {CE_STRUCTURE_FIELD}.make ("use_robots"),
					create {CE_STRUCTURE_FIELD}.make ("limit_rate"),
					create {CE_STRUCTURE_FIELD}.make ("quota"),
					create {CE_STRUCTURE_FIELD}.make ("server_response"),
					create {CE_STRUCTURE_FIELD}.make ("save_headers"),
					create {CE_STRUCTURE_FIELD}.make ("debug2"),
					create {CE_STRUCTURE_FIELD}.make ("timestamping"),
					create {CE_STRUCTURE_FIELD}.make ("backup_converted"),
					create {CE_STRUCTURE_FIELD}.make ("backups"),
					create {CE_STRUCTURE_FIELD}.make ("useragent"),
					create {CE_STRUCTURE_FIELD}.make ("referer"),
					create {CE_STRUCTURE_FIELD}.make ("convert_links"),
					create {CE_STRUCTURE_FIELD}.make ("remove_listing"),
					create {CE_STRUCTURE_FIELD}.make ("htmlify"),
					create {CE_STRUCTURE_FIELD}.make ("dot_style"),
					create {CE_STRUCTURE_FIELD}.make ("dot_bytes"),
					create {CE_STRUCTURE_FIELD}.make ("dots_in_line"),
					create {CE_STRUCTURE_FIELD}.make ("dot_spacing"),
					create {CE_STRUCTURE_FIELD}.make ("delete_after"),
					create {CE_STRUCTURE_FIELD}.make ("adjust_extension"),
					create {CE_STRUCTURE_FIELD}.make ("page_requisites"),
					create {CE_STRUCTURE_FIELD}.make ("bind_address"),
					create {CE_STRUCTURE_FIELD}.make ("cookies"),
					create {CE_STRUCTURE_FIELD}.make ("cookies_input"),
					create {CE_STRUCTURE_FIELD}.make ("cookies_output"),
					create {CE_STRUCTURE_FIELD}.make ("keep_session_cookies"),
					create {CE_STRUCTURE_FIELD}.make ("post_data"),
					create {CE_STRUCTURE_FIELD}.make ("post_file_name"),
					create {CE_STRUCTURE_FIELD}.make ("restrict_files_os"),
					create {CE_STRUCTURE_FIELD}.make ("restrict_files_ctrl"),
					create {CE_STRUCTURE_FIELD}.make ("restrict_files_nonascii"),
					create {CE_STRUCTURE_FIELD}.make ("restrict_files_case"),
					create {CE_STRUCTURE_FIELD}.make ("strict_comments"),
					create {CE_STRUCTURE_FIELD}.make ("preserve_perm"),
					create {CE_STRUCTURE_FIELD}.make ("ipv4_only"),
					create {CE_STRUCTURE_FIELD}.make ("ipv6_only"),
					create {CE_STRUCTURE_FIELD}.make ("prefer_family"),
					create {CE_STRUCTURE_FIELD}.make ("content_disposition"),
					create {CE_STRUCTURE_FIELD}.make ("auth_without_challenge"),
					create {CE_STRUCTURE_FIELD}.make ("enable_iri"),
					create {CE_STRUCTURE_FIELD}.make ("encoding_remote"),
					create {CE_STRUCTURE_FIELD}.make ("locale")
				>>)
			init_structure_info
		end

end
