class
	PD_PCONN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create host.make
		end

feature {ANY} -- fields

	socket: INTEGER_32 assign set_socket

	host: CE_POINTER [INTEGER_8] assign set_host

	port: INTEGER_32 assign set_port

	ssl: BOOLEAN assign set_ssl

	authorized: BOOLEAN assign set_authorized

feature {ANY} -- setters

	set_socket (a_socket: INTEGER_32)
		do
			socket := a_socket
			update_memory_field ("socket")
		end

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			host := a_host
			update_memory_field ("host")
		end

	set_port (a_port: INTEGER_32)
		do
			port := a_port
			update_memory_field ("port")
		end

	set_ssl (a_ssl: BOOLEAN)
		do
			ssl := a_ssl
			update_memory_field ("ssl")
		end

	set_authorized (a_authorized: BOOLEAN)
		do
			authorized := a_authorized
			update_memory_field ("authorized")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			socket := a_other.socket
			host := a_other.host
			port := a_other.port
			ssl := a_other.ssl
			authorized := a_other.authorized
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				socket = a_other.socket and
				host.is_equal (a_other.host) and
				port = a_other.port and
				ssl = a_other.ssl and
				authorized = a_other.authorized
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("socket"),
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("port"),
					create {CE_STRUCTURE_FIELD}.make ("ssl"),
					create {CE_STRUCTURE_FIELD}.make ("authorized")
				>>)
			init_structure_info
		end

end
