class
	PD_POOL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create contents.make
			create orig_contents.make
		end

feature {ANY} -- fields

	contents: CE_POINTER [INTEGER_8] assign set_contents

	size: INTEGER_32 assign set_size

	tail: INTEGER_32 assign set_tail

	resized: BOOLEAN assign set_resized

	orig_contents: CE_POINTER [INTEGER_8] assign set_orig_contents

	orig_size: INTEGER_32 assign set_orig_size

feature {ANY} -- setters

	set_contents (a_contents: CE_POINTER [INTEGER_8])
		do
			contents := a_contents
			update_memory_field ("contents")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_tail (a_tail: INTEGER_32)
		do
			tail := a_tail
			update_memory_field ("tail")
		end

	set_resized (a_resized: BOOLEAN)
		do
			resized := a_resized
			update_memory_field ("resized")
		end

	set_orig_contents (a_orig_contents: CE_POINTER [INTEGER_8])
		do
			orig_contents := a_orig_contents
			update_memory_field ("orig_contents")
		end

	set_orig_size (a_orig_size: INTEGER_32)
		do
			orig_size := a_orig_size
			update_memory_field ("orig_size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			contents := a_other.contents
			size := a_other.size
			tail := a_other.tail
			resized := a_other.resized
			orig_contents := a_other.orig_contents
			orig_size := a_other.orig_size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				contents.is_equal (a_other.contents) and
				size = a_other.size and
				tail = a_other.tail and
				resized = a_other.resized and
				orig_contents.is_equal (a_other.orig_contents) and
				orig_size = a_other.orig_size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("contents"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("tail"),
					create {CE_STRUCTURE_FIELD}.make ("resized"),
					create {CE_STRUCTURE_FIELD}.make ("orig_contents"),
					create {CE_STRUCTURE_FIELD}.make ("orig_size")
				>>)
			init_structure_info
		end

end
