class
	PD_PROGRESS_IMPLEMENTATION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create create2.make
			create update.make
			create finish.make
			create set_params.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	interactive: BOOLEAN assign set_interactive

	create2: CE_ROUTINE assign set_create2

	update: CE_ROUTINE assign set_update

	finish: CE_ROUTINE assign set_finish

	set_params: CE_ROUTINE assign set_set_params

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_interactive (a_interactive: BOOLEAN)
		do
			interactive := a_interactive
			update_memory_field ("interactive")
		end

	set_create2 (a_create2: CE_ROUTINE)
		do
			create2 := a_create2
			update_memory_field ("create2")
		end

	set_update (a_update: CE_ROUTINE)
		do
			update := a_update
			update_memory_field ("update")
		end

	set_finish (a_finish: CE_ROUTINE)
		do
			finish := a_finish
			update_memory_field ("finish")
		end

	set_set_params (a_set_params: CE_ROUTINE)
		do
			set_params := a_set_params
			update_memory_field ("set_params")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			interactive := a_other.interactive
			create2 := a_other.create2
			update := a_other.update
			finish := a_other.finish
			set_params := a_other.set_params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				interactive = a_other.interactive and
				create2.is_equal (a_other.create2) and
				update.is_equal (a_other.update) and
				finish.is_equal (a_other.finish) and
				set_params.is_equal (a_other.set_params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("interactive"),
					create {CE_STRUCTURE_FIELD}.make ("create2"),
					create {CE_STRUCTURE_FIELD}.make ("update"),
					create {CE_STRUCTURE_FIELD}.make ("finish"),
					create {CE_STRUCTURE_FIELD}.make ("set_params")
				>>)
			init_structure_info
		end

end
