class
	PD_PTIMER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create start.make
		end

feature {ANY} -- fields

	start: SD_TIMESPEC assign set_start

	elapsed_last: REAL_64 assign set_elapsed_last

	elapsed_pre_start: REAL_64 assign set_elapsed_pre_start

feature {ANY} -- setters

	set_start (a_start: SD_TIMESPEC)
		do
			start := a_start
			update_memory_field ("start")
		end

	set_elapsed_last (a_elapsed_last: REAL_64)
		do
			elapsed_last := a_elapsed_last
			update_memory_field ("elapsed_last")
		end

	set_elapsed_pre_start (a_elapsed_pre_start: REAL_64)
		do
			elapsed_pre_start := a_elapsed_pre_start
			update_memory_field ("elapsed_pre_start")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			start := a_other.start.twin
			elapsed_last := a_other.elapsed_last
			elapsed_pre_start := a_other.elapsed_pre_start
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				start.is_equal (a_other.start) and
				elapsed_last = a_other.elapsed_last and
				elapsed_pre_start = a_other.elapsed_pre_start
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("elapsed_last"),
					create {CE_STRUCTURE_FIELD}.make ("elapsed_pre_start")
				>>)
			init_structure_info
		end

end
