class
	PD_QUOTING_OPTIONS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create quote_these_too.make (<<({NATURAL_32} 255 // ({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8) + {NATURAL_32} 1).to_integer_32>>)
			create left_quote.make
			create right_quote.make
		end

feature {ANY} -- fields

	style: NATURAL_32 assign set_style

	flags: INTEGER_32 assign set_flags

	quote_these_too: CE_ARRAY [NATURAL_32]

	left_quote: CE_POINTER [INTEGER_8] assign set_left_quote

	right_quote: CE_POINTER [INTEGER_8] assign set_right_quote

feature {ANY} -- setters

	set_style (a_style: NATURAL_32)
		do
			style := a_style
			update_memory_field ("style")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_left_quote (a_left_quote: CE_POINTER [INTEGER_8])
		do
			left_quote := a_left_quote
			update_memory_field ("left_quote")
		end

	set_right_quote (a_right_quote: CE_POINTER [INTEGER_8])
		do
			right_quote := a_right_quote
			update_memory_field ("right_quote")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			style := a_other.style
			flags := a_other.flags
			quote_these_too := a_other.quote_these_too.twin
			left_quote := a_other.left_quote
			right_quote := a_other.right_quote
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				style = a_other.style and
				flags = a_other.flags and
				quote_these_too.is_equal (a_other.quote_these_too) and
				left_quote.is_equal (a_other.left_quote) and
				right_quote.is_equal (a_other.right_quote)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("style"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("quote_these_too", <<({NATURAL_32} 255 // ({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8) + {NATURAL_32} 1).to_integer_32>>),
					create {CE_STRUCTURE_FIELD}.make ("left_quote"),
					create {CE_STRUCTURE_FIELD}.make ("right_quote")
				>>)
			init_structure_info
		end

end
