class
	PD_REQUEST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create method.make
			create arg.make
			create headers.make
		end

feature {ANY} -- fields

	method: CE_POINTER [INTEGER_8] assign set_method

	arg: CE_POINTER [INTEGER_8] assign set_arg

	headers: CE_POINTER [PD_REQUEST_HEADER] assign set_headers

	hcount: INTEGER_32 assign set_hcount

	hcapacity: INTEGER_32 assign set_hcapacity

feature {ANY} -- setters

	set_method (a_method: CE_POINTER [INTEGER_8])
		do
			method := a_method
			update_memory_field ("method")
		end

	set_arg (a_arg: CE_POINTER [INTEGER_8])
		do
			arg := a_arg
			update_memory_field ("arg")
		end

	set_headers (a_headers: CE_POINTER [PD_REQUEST_HEADER])
		do
			headers := a_headers
			update_memory_field ("headers")
		end

	set_hcount (a_hcount: INTEGER_32)
		do
			hcount := a_hcount
			update_memory_field ("hcount")
		end

	set_hcapacity (a_hcapacity: INTEGER_32)
		do
			hcapacity := a_hcapacity
			update_memory_field ("hcapacity")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			method := a_other.method
			arg := a_other.arg
			headers := a_other.headers
			hcount := a_other.hcount
			hcapacity := a_other.hcapacity
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				method.is_equal (a_other.method) and
				arg.is_equal (a_other.arg) and
				headers.is_equal (a_other.headers) and
				hcount = a_other.hcount and
				hcapacity = a_other.hcapacity
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("method"),
					create {CE_STRUCTURE_FIELD}.make ("arg"),
					create {CE_STRUCTURE_FIELD}.make ("headers"),
					create {CE_STRUCTURE_FIELD}.make ("hcount"),
					create {CE_STRUCTURE_FIELD}.make ("hcapacity")
				>>)
			init_structure_info
		end

end
