class
	PD_RINGEL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create buffer.make
		end

feature {ANY} -- fields

	buffer: CE_POINTER [INTEGER_8] assign set_buffer

	size: INTEGER_32 assign set_size

feature {ANY} -- setters

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buffer := a_other.buffer
			size := a_other.size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buffer.is_equal (a_other.buffer) and
				size = a_other.size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("size")
				>>)
			init_structure_info
		end

end
