class
	PD_SCHEME_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create leading_string.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	leading_string: CE_POINTER [INTEGER_8] assign set_leading_string

	default_port: INTEGER_32 assign set_default_port

	flags: INTEGER_32 assign set_flags

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_leading_string (a_leading_string: CE_POINTER [INTEGER_8])
		do
			leading_string := a_leading_string
			update_memory_field ("leading_string")
		end

	set_default_port (a_default_port: INTEGER_32)
		do
			default_port := a_default_port
			update_memory_field ("default_port")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			leading_string := a_other.leading_string
			default_port := a_other.default_port
			flags := a_other.flags
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				leading_string.is_equal (a_other.leading_string) and
				default_port = a_other.default_port and
				flags = a_other.flags
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("leading_string"),
					create {CE_STRUCTURE_FIELD}.make ("default_port"),
					create {CE_STRUCTURE_FIELD}.make ("flags")
				>>)
			init_structure_info
		end

end
