class
	PD_SLOTVEC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create val.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	val: CE_POINTER [INTEGER_8] assign set_val

feature {ANY} -- setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_val (a_val: CE_POINTER [INTEGER_8])
		do
			val := a_val
			update_memory_field ("val")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			val := a_other.val
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				val.is_equal (a_other.val)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("val")
				>>)
			init_structure_info
		end

end
