class
	PD_TAGINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create attrs.make
			create start_position.make
			create end_position.make
			create contents_begin.make
			create contents_end.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	end_tag_p: INTEGER_32 assign set_end_tag_p

	nattrs: INTEGER_32 assign set_nattrs

	attrs: CE_POINTER [PD_ATTR_PAIR] assign set_attrs

	start_position: CE_POINTER [INTEGER_8] assign set_start_position

	end_position: CE_POINTER [INTEGER_8] assign set_end_position

	contents_begin: CE_POINTER [INTEGER_8] assign set_contents_begin

	contents_end: CE_POINTER [INTEGER_8] assign set_contents_end

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_end_tag_p (a_end_tag_p: INTEGER_32)
		do
			end_tag_p := a_end_tag_p
			update_memory_field ("end_tag_p")
		end

	set_nattrs (a_nattrs: INTEGER_32)
		do
			nattrs := a_nattrs
			update_memory_field ("nattrs")
		end

	set_attrs (a_attrs: CE_POINTER [PD_ATTR_PAIR])
		do
			attrs := a_attrs
			update_memory_field ("attrs")
		end

	set_start_position (a_start_position: CE_POINTER [INTEGER_8])
		do
			start_position := a_start_position
			update_memory_field ("start_position")
		end

	set_end_position (a_end_position: CE_POINTER [INTEGER_8])
		do
			end_position := a_end_position
			update_memory_field ("end_position")
		end

	set_contents_begin (a_contents_begin: CE_POINTER [INTEGER_8])
		do
			contents_begin := a_contents_begin
			update_memory_field ("contents_begin")
		end

	set_contents_end (a_contents_end: CE_POINTER [INTEGER_8])
		do
			contents_end := a_contents_end
			update_memory_field ("contents_end")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			end_tag_p := a_other.end_tag_p
			nattrs := a_other.nattrs
			attrs := a_other.attrs
			start_position := a_other.start_position
			end_position := a_other.end_position
			contents_begin := a_other.contents_begin
			contents_end := a_other.contents_end
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				end_tag_p = a_other.end_tag_p and
				nattrs = a_other.nattrs and
				attrs.is_equal (a_other.attrs) and
				start_position.is_equal (a_other.start_position) and
				end_position.is_equal (a_other.end_position) and
				contents_begin.is_equal (a_other.contents_begin) and
				contents_end.is_equal (a_other.contents_end)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("end_tag_p"),
					create {CE_STRUCTURE_FIELD}.make ("nattrs"),
					create {CE_STRUCTURE_FIELD}.make ("attrs"),
					create {CE_STRUCTURE_FIELD}.make ("start_position"),
					create {CE_STRUCTURE_FIELD}.make ("end_position"),
					create {CE_STRUCTURE_FIELD}.make ("contents_begin"),
					create {CE_STRUCTURE_FIELD}.make ("contents_end")
				>>)
			init_structure_info
		end

end
