class
	PD_TRANSPORT_IMPLEMENTATION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create reader.make
			create writer.make
			create poller.make
			create peeker.make
			create errstr.make
			create closer.make
		end

feature {ANY} -- fields

	reader: CE_ROUTINE assign set_reader

	writer: CE_ROUTINE assign set_writer

	poller: CE_ROUTINE assign set_poller

	peeker: CE_ROUTINE assign set_peeker

	errstr: CE_ROUTINE assign set_errstr

	closer: CE_ROUTINE assign set_closer

feature {ANY} -- setters

	set_reader (a_reader: CE_ROUTINE)
		do
			reader := a_reader
			update_memory_field ("reader")
		end

	set_writer (a_writer: CE_ROUTINE)
		do
			writer := a_writer
			update_memory_field ("writer")
		end

	set_poller (a_poller: CE_ROUTINE)
		do
			poller := a_poller
			update_memory_field ("poller")
		end

	set_peeker (a_peeker: CE_ROUTINE)
		do
			peeker := a_peeker
			update_memory_field ("peeker")
		end

	set_errstr (a_errstr: CE_ROUTINE)
		do
			errstr := a_errstr
			update_memory_field ("errstr")
		end

	set_closer (a_closer: CE_ROUTINE)
		do
			closer := a_closer
			update_memory_field ("closer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			reader := a_other.reader
			writer := a_other.writer
			poller := a_other.poller
			peeker := a_other.peeker
			errstr := a_other.errstr
			closer := a_other.closer
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				reader.is_equal (a_other.reader) and
				writer.is_equal (a_other.writer) and
				poller.is_equal (a_other.poller) and
				peeker.is_equal (a_other.peeker) and
				errstr.is_equal (a_other.errstr) and
				closer.is_equal (a_other.closer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("reader"),
					create {CE_STRUCTURE_FIELD}.make ("writer"),
					create {CE_STRUCTURE_FIELD}.make ("poller"),
					create {CE_STRUCTURE_FIELD}.make ("peeker"),
					create {CE_STRUCTURE_FIELD}.make ("errstr"),
					create {CE_STRUCTURE_FIELD}.make ("closer")
				>>)
			init_structure_info
		end

end
