class
	PD_TRANSPORT_INFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create imp.make
			create ctx.make
		end

feature {ANY} -- fields

	imp: CE_POINTER [PD_TRANSPORT_IMPLEMENTATION] assign set_imp

	ctx: CE_POINTER [ANY] assign set_ctx

feature {ANY} -- setters

	set_imp (a_imp: CE_POINTER [PD_TRANSPORT_IMPLEMENTATION])
		do
			imp := a_imp
			update_memory_field ("imp")
		end

	set_ctx (a_ctx: CE_POINTER [ANY])
		do
			ctx := a_ctx
			update_memory_field ("ctx")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			imp := a_other.imp
			ctx := a_other.ctx
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				imp.is_equal (a_other.imp) and
				ctx.is_equal (a_other.ctx)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("imp"),
					create {CE_STRUCTURE_FIELD}.make ("ctx")
				>>)
			init_structure_info
		end

end
