class
	PD_URLPOS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	url: CE_POINTER [PD_URL] assign set_url

	local_name: CE_POINTER [INTEGER_8] assign set_local_name

	ignore_when_downloading: NATURAL_32 assign set_ignore_when_downloading

	link_relative_p: NATURAL_32 assign set_link_relative_p

	link_complete_p: NATURAL_32 assign set_link_complete_p

	link_base_p: NATURAL_32 assign set_link_base_p

	link_inline_p: NATURAL_32 assign set_link_inline_p

	link_css_p: NATURAL_32 assign set_link_css_p

	link_expect_html: NATURAL_32 assign set_link_expect_html

	link_expect_css: NATURAL_32 assign set_link_expect_css

	link_refresh_p: NATURAL_32 assign set_link_refresh_p

	refresh_timeout: INTEGER_32 assign set_refresh_timeout

	convert2: NATURAL_32 assign set_convert2

	pos: INTEGER_32 assign set_pos

	size: INTEGER_32 assign set_size

	next: CE_POINTER [PD_URLPOS] assign set_next

feature {ANY} -- setters

	set_url (a_url: CE_POINTER [PD_URL])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_local_name (a_local_name: CE_POINTER [INTEGER_8])
		do
			local_name := a_local_name
			update_memory_field ("local_name")
		end

	set_ignore_when_downloading (a_ignore_when_downloading: NATURAL_32)
		do
			ignore_when_downloading := a_ignore_when_downloading
			update_memory_field ("ignore_when_downloading")
		end

	set_link_relative_p (a_link_relative_p: NATURAL_32)
		do
			link_relative_p := a_link_relative_p
			update_memory_field ("link_relative_p")
		end

	set_link_complete_p (a_link_complete_p: NATURAL_32)
		do
			link_complete_p := a_link_complete_p
			update_memory_field ("link_complete_p")
		end

	set_link_base_p (a_link_base_p: NATURAL_32)
		do
			link_base_p := a_link_base_p
			update_memory_field ("link_base_p")
		end

	set_link_inline_p (a_link_inline_p: NATURAL_32)
		do
			link_inline_p := a_link_inline_p
			update_memory_field ("link_inline_p")
		end

	set_link_css_p (a_link_css_p: NATURAL_32)
		do
			link_css_p := a_link_css_p
			update_memory_field ("link_css_p")
		end

	set_link_expect_html (a_link_expect_html: NATURAL_32)
		do
			link_expect_html := a_link_expect_html
			update_memory_field ("link_expect_html")
		end

	set_link_expect_css (a_link_expect_css: NATURAL_32)
		do
			link_expect_css := a_link_expect_css
			update_memory_field ("link_expect_css")
		end

	set_link_refresh_p (a_link_refresh_p: NATURAL_32)
		do
			link_refresh_p := a_link_refresh_p
			update_memory_field ("link_refresh_p")
		end

	set_refresh_timeout (a_refresh_timeout: INTEGER_32)
		do
			refresh_timeout := a_refresh_timeout
			update_memory_field ("refresh_timeout")
		end

	set_convert2 (a_convert2: NATURAL_32)
		do
			convert2 := a_convert2
			update_memory_field ("convert2")
		end

	set_pos (a_pos: INTEGER_32)
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_next (a_next: CE_POINTER [PD_URLPOS])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			url := a_other.url
			local_name := a_other.local_name
			ignore_when_downloading := a_other.ignore_when_downloading
			link_relative_p := a_other.link_relative_p
			link_complete_p := a_other.link_complete_p
			link_base_p := a_other.link_base_p
			link_inline_p := a_other.link_inline_p
			link_css_p := a_other.link_css_p
			link_expect_html := a_other.link_expect_html
			link_expect_css := a_other.link_expect_css
			link_refresh_p := a_other.link_refresh_p
			refresh_timeout := a_other.refresh_timeout
			convert2 := a_other.convert2
			pos := a_other.pos
			size := a_other.size
			next := a_other.next
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				url.is_equal (a_other.url) and
				local_name.is_equal (a_other.local_name) and
				ignore_when_downloading = a_other.ignore_when_downloading and
				link_relative_p = a_other.link_relative_p and
				link_complete_p = a_other.link_complete_p and
				link_base_p = a_other.link_base_p and
				link_inline_p = a_other.link_inline_p and
				link_css_p = a_other.link_css_p and
				link_expect_html = a_other.link_expect_html and
				link_expect_css = a_other.link_expect_css and
				link_refresh_p = a_other.link_refresh_p and
				refresh_timeout = a_other.refresh_timeout and
				convert2 = a_other.convert2 and
				pos = a_other.pos and
				size = a_other.size and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("local_name"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("ignore_when_downloading"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_relative_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_complete_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_base_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_inline_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_css_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_expect_html"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_expect_css"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_refresh_p"),
					create {CE_STRUCTURE_FIELD}.make ("refresh_timeout"),
					create {CE_STRUCTURE_FIELD}.make ("convert2"),
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline"
		alias
			"[
				struct urlpos {
					struct url * url;
					char * local_name;
					unsigned int ignore_when_downloading : 1;
					unsigned int link_relative_p : 1;
					unsigned int link_complete_p : 1;
					unsigned int link_base_p : 1;
					unsigned int link_inline_p : 1;
					unsigned int link_css_p : 1;
					unsigned int link_expect_html : 1;
					unsigned int link_expect_css : 1;
					unsigned int link_refresh_p : 1;
					int refresh_timeout;
					unsigned int convert;
					int pos;
					int size;
					struct urlpos * next;
				};
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct urlpos);
					if(strcmp(field_name, "refresh_timeout") == 0) return offsetof(struct urlpos, refresh_timeout);
				} else {
					struct urlpos *p = (struct urlpos *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "ignore_when_downloading") == 0) p->ignore_when_downloading = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_relative_p") == 0) p->link_relative_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_complete_p") == 0) p->link_complete_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_base_p") == 0) p->link_base_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_inline_p") == 0) p->link_inline_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_css_p") == 0) p->link_css_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_expect_html") == 0) p->link_expect_html = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_expect_css") == 0) p->link_expect_css = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_refresh_p") == 0) p->link_refresh_p = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "ignore_when_downloading") == 0) return p->ignore_when_downloading;
						if(strcmp(field_name, "link_relative_p") == 0) return p->link_relative_p;
						if(strcmp(field_name, "link_complete_p") == 0) return p->link_complete_p;
						if(strcmp(field_name, "link_base_p") == 0) return p->link_base_p;
						if(strcmp(field_name, "link_inline_p") == 0) return p->link_inline_p;
						if(strcmp(field_name, "link_css_p") == 0) return p->link_css_p;
						if(strcmp(field_name, "link_expect_html") == 0) return p->link_expect_html;
						if(strcmp(field_name, "link_expect_css") == 0) return p->link_expect_css;
						if(strcmp(field_name, "link_refresh_p") == 0) return p->link_refresh_p;
					}
				}
			]"
		end

end
