class
	PD_YY_BUFFER_STATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create yy_input_file.make
			create yy_ch_buf.make
			create yy_buf_pos.make
		end

feature {ANY} -- fields

	yy_input_file: CE_POINTER [SD_IO_FILE] assign set_yy_input_file

	yy_ch_buf: CE_POINTER [INTEGER_8] assign set_yy_ch_buf

	yy_buf_pos: CE_POINTER [INTEGER_8] assign set_yy_buf_pos

	yy_buf_size: NATURAL_32 assign set_yy_buf_size

	yy_n_chars: INTEGER_32 assign set_yy_n_chars

	yy_is_our_buffer: INTEGER_32 assign set_yy_is_our_buffer

	yy_is_interactive: INTEGER_32 assign set_yy_is_interactive

	yy_at_bol: INTEGER_32 assign set_yy_at_bol

	yy_bs_lineno: INTEGER_32 assign set_yy_bs_lineno

	yy_bs_column: INTEGER_32 assign set_yy_bs_column

	yy_fill_buffer: INTEGER_32 assign set_yy_fill_buffer

	yy_buffer_status: INTEGER_32 assign set_yy_buffer_status

feature {ANY} -- setters

	set_yy_input_file (a_yy_input_file: CE_POINTER [SD_IO_FILE])
		do
			yy_input_file := a_yy_input_file
			update_memory_field ("yy_input_file")
		end

	set_yy_ch_buf (a_yy_ch_buf: CE_POINTER [INTEGER_8])
		do
			yy_ch_buf := a_yy_ch_buf
			update_memory_field ("yy_ch_buf")
		end

	set_yy_buf_pos (a_yy_buf_pos: CE_POINTER [INTEGER_8])
		do
			yy_buf_pos := a_yy_buf_pos
			update_memory_field ("yy_buf_pos")
		end

	set_yy_buf_size (a_yy_buf_size: NATURAL_32)
		do
			yy_buf_size := a_yy_buf_size
			update_memory_field ("yy_buf_size")
		end

	set_yy_n_chars (a_yy_n_chars: INTEGER_32)
		do
			yy_n_chars := a_yy_n_chars
			update_memory_field ("yy_n_chars")
		end

	set_yy_is_our_buffer (a_yy_is_our_buffer: INTEGER_32)
		do
			yy_is_our_buffer := a_yy_is_our_buffer
			update_memory_field ("yy_is_our_buffer")
		end

	set_yy_is_interactive (a_yy_is_interactive: INTEGER_32)
		do
			yy_is_interactive := a_yy_is_interactive
			update_memory_field ("yy_is_interactive")
		end

	set_yy_at_bol (a_yy_at_bol: INTEGER_32)
		do
			yy_at_bol := a_yy_at_bol
			update_memory_field ("yy_at_bol")
		end

	set_yy_bs_lineno (a_yy_bs_lineno: INTEGER_32)
		do
			yy_bs_lineno := a_yy_bs_lineno
			update_memory_field ("yy_bs_lineno")
		end

	set_yy_bs_column (a_yy_bs_column: INTEGER_32)
		do
			yy_bs_column := a_yy_bs_column
			update_memory_field ("yy_bs_column")
		end

	set_yy_fill_buffer (a_yy_fill_buffer: INTEGER_32)
		do
			yy_fill_buffer := a_yy_fill_buffer
			update_memory_field ("yy_fill_buffer")
		end

	set_yy_buffer_status (a_yy_buffer_status: INTEGER_32)
		do
			yy_buffer_status := a_yy_buffer_status
			update_memory_field ("yy_buffer_status")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			yy_input_file := a_other.yy_input_file
			yy_ch_buf := a_other.yy_ch_buf
			yy_buf_pos := a_other.yy_buf_pos
			yy_buf_size := a_other.yy_buf_size
			yy_n_chars := a_other.yy_n_chars
			yy_is_our_buffer := a_other.yy_is_our_buffer
			yy_is_interactive := a_other.yy_is_interactive
			yy_at_bol := a_other.yy_at_bol
			yy_bs_lineno := a_other.yy_bs_lineno
			yy_bs_column := a_other.yy_bs_column
			yy_fill_buffer := a_other.yy_fill_buffer
			yy_buffer_status := a_other.yy_buffer_status
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				yy_input_file.is_equal (a_other.yy_input_file) and
				yy_ch_buf.is_equal (a_other.yy_ch_buf) and
				yy_buf_pos.is_equal (a_other.yy_buf_pos) and
				yy_buf_size = a_other.yy_buf_size and
				yy_n_chars = a_other.yy_n_chars and
				yy_is_our_buffer = a_other.yy_is_our_buffer and
				yy_is_interactive = a_other.yy_is_interactive and
				yy_at_bol = a_other.yy_at_bol and
				yy_bs_lineno = a_other.yy_bs_lineno and
				yy_bs_column = a_other.yy_bs_column and
				yy_fill_buffer = a_other.yy_fill_buffer and
				yy_buffer_status = a_other.yy_buffer_status
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("yy_input_file"),
					create {CE_STRUCTURE_FIELD}.make ("yy_ch_buf"),
					create {CE_STRUCTURE_FIELD}.make ("yy_buf_pos"),
					create {CE_STRUCTURE_FIELD}.make ("yy_buf_size"),
					create {CE_STRUCTURE_FIELD}.make ("yy_n_chars"),
					create {CE_STRUCTURE_FIELD}.make ("yy_is_our_buffer"),
					create {CE_STRUCTURE_FIELD}.make ("yy_is_interactive"),
					create {CE_STRUCTURE_FIELD}.make ("yy_at_bol"),
					create {CE_STRUCTURE_FIELD}.make ("yy_bs_lineno"),
					create {CE_STRUCTURE_FIELD}.make ("yy_bs_column"),
					create {CE_STRUCTURE_FIELD}.make ("yy_fill_buffer"),
					create {CE_STRUCTURE_FIELD}.make ("yy_buffer_status")
				>>)
			init_structure_info
		end

end
