class
	P_HASH

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create primes.make (<<71>>)
		end

feature {ANY} -- attributes

	primes: CE_ARRAY [INTEGER_32]

feature {ANY} -- routines

	cmp_pointer (a_ptr1: CE_POINTER [ANY]; a_ptr2: CE_POINTER [ANY]): INTEGER_32
		do
			Result := (a_ptr1.is_equal (a_ptr2)).to_integer
		end

	cmp_pointer_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmp_pointer)
		end

	cmp_string (a_s1: CE_POINTER [ANY]; a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s1), create {CE_POINTER [INTEGER_8]}.make_cast (a_s2))).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	cmp_string_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmp_string)
		end

	find_cell (a_ht: CE_POINTER [PD_HASH_TABLE]; a_key: CE_POINTER [ANY]): CE_POINTER [PD_CELL]
		local
			l_cells: CE_POINTER [PD_CELL]
			l_size: INTEGER_32
			l_c: CE_POINTER [PD_CELL]
			l_equals: CE_ROUTINE
			js: JUMP_STATE
		do
			create l_cells.make
			create l_c.make
			create l_equals.make

			l_cells := a_ht.item.cells
			l_size := a_ht.item.size
			l_c := l_cells + (((a_ht.item.hash_function).natural_32_item ([a_key])) \\ l_size.to_natural_32).to_integer_32
			l_equals := a_ht.item.test_function
			from
			until
				not (not js.loop_done and then (((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32))
			loop
				if (l_equals.integer_32_item ([a_key, l_c.item.key])).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					if not l_c.is_equal (l_cells + (l_size - 1)) then
						l_c := l_c + 1
					else
						l_c := l_cells
					end
				end
			end
			Result := l_c
		end

	grow_hash_table (a_ht: CE_POINTER [PD_HASH_TABLE])
		local
			l_hasher: CE_ROUTINE
			l_old_cells: CE_POINTER [PD_CELL]
			l_old_end: CE_POINTER [PD_CELL]
			l_c: CE_POINTER [PD_CELL]
			l_cells: CE_POINTER [PD_CELL]
			l_newsize: INTEGER_32
			l_new_c: CE_POINTER [PD_CELL]
			js: JUMP_STATE
		do
			create l_hasher.make
			create l_old_cells.make
			create l_old_end.make
			create l_c.make
			create l_cells.make
			create l_new_c.make

			l_hasher := a_ht.item.hash_function
			l_old_cells := a_ht.item.cells
			l_old_end := a_ht.item.cells + a_ht.item.size
			l_newsize := prime_size (a_ht.item.size * 2, create {CE_POINTER [INTEGER_32]}.make_shared (a_ht.c_pointer + (create {PD_HASH_TABLE}.make).offset_of ("prime_offset")))
			a_ht.item.size := l_newsize
			a_ht.item.resize_threshold := (l_newsize.to_double * 0.75).truncated_to_integer
			l_cells := create {CE_POINTER [PD_CELL]}.make_cast ((xmalloc_inst.xmalloc (l_newsize.to_natural_32 * (create {PD_CELL}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_cells), 255, l_newsize.to_natural_32 * (create {PD_CELL}.make).structure_size.to_natural_32).do_nothing
			a_ht.item.cells := l_cells
			l_c := l_old_cells
			from
			until
				not (not js.loop_done and then ((l_c.c_pointer.to_integer_32).to_natural_32 < (l_old_end.c_pointer.to_integer_32).to_natural_32))
			loop
				if ((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32 then
					l_new_c := l_cells + ((l_hasher.natural_32_item ([l_c.item.key])) \\ l_newsize.to_natural_32).to_integer_32
					from
					until
						((l_new_c.item.key).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32
					loop
						if not l_new_c.is_equal (l_cells + (l_newsize - 1)) then
							l_new_c := l_new_c + 1
						else
							l_new_c := l_cells
						end
					end
					l_new_c.item := (l_c.item).twin
				end
				l_c := l_c + 1
			end
			free (create {CE_POINTER [ANY]}.make_cast (l_old_cells))
		end

	hash_pointer (a_ptr: CE_POINTER [ANY]): NATURAL_32
		local
			l_key: NATURAL_32
		do
			l_key := (a_ptr.c_pointer.to_integer_32).to_natural_32
			l_key := l_key + ((l_key).bit_shift_left (12))
			l_key := (l_key).bit_xor (((l_key).bit_shift_right (22)))
			l_key := l_key + ((l_key).bit_shift_left (4))
			l_key := (l_key).bit_xor (((l_key).bit_shift_right (9)))
			l_key := l_key + ((l_key).bit_shift_left (10))
			l_key := (l_key).bit_xor (((l_key).bit_shift_right (2)))
			l_key := l_key + ((l_key).bit_shift_left (7))
			l_key := (l_key).bit_xor (((l_key).bit_shift_right (12)))
			Result := l_key.to_natural_32
		end

	hash_pointer_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hash_pointer)
		end

	hash_string (a_key: CE_POINTER [ANY]): NATURAL_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_h: NATURAL_32
		do
			create l_p___0.make

			l_p___0 := create {CE_POINTER [INTEGER_8]}.make_cast (a_key)
			l_h := (l_p___0[0]).to_natural_32
			if l_h.to_boolean then
				l_p___0 := l_p___0 + 1
				from
				until
					(l_p___0[0]).to_integer_32 = 0
				loop
					l_h := (((l_h).bit_shift_left (5)) - l_h) + (l_p___0[0]).to_natural_32
					l_p___0 := l_p___0 + 1
				end
			end
			Result := l_h.to_natural_32
		end

	hash_string_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hash_string)
		end

	hash_string_nocase (a_key: CE_POINTER [ANY]): NATURAL_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_h: NATURAL_32
		do
			create l_p___0.make

			l_p___0 := create {CE_POINTER [INTEGER_8]}.make_cast (a_key)
			l_h := (c_ctype_inst.c2_tolower ((l_p___0[0]).to_integer_32)).to_natural_32
			if l_h.to_boolean then
				l_p___0 := l_p___0 + 1
				from
				until
					(l_p___0[0]).to_integer_32 = 0
				loop
					l_h := (((l_h).bit_shift_left (5)) - l_h) + (c_ctype_inst.c2_tolower ((l_p___0[0]).to_integer_32)).to_natural_32
					l_p___0 := l_p___0 + 1
				end
			end
			Result := l_h.to_natural_32
		end

	hash_string_nocase_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hash_string_nocase)
		end

	hash_table_clear (a_ht: CE_POINTER [PD_HASH_TABLE])
		do
			memset (create {CE_POINTER [ANY]}.make_cast (a_ht.item.cells), 255, (a_ht.item.size).to_natural_32 * (create {PD_CELL}.make).structure_size.to_natural_32).do_nothing
			a_ht.item.count := 0
		end

	hash_table_contains (a_ht: CE_POINTER [PD_HASH_TABLE]; a_key: CE_POINTER [ANY]): INTEGER_32
		local
			l_c: CE_POINTER [PD_CELL]
		do
			create l_c.make

			l_c := (find_cell (a_ht, a_key))
			Result := (((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32).to_integer
		end

	hash_table_count (a_ht: CE_POINTER [PD_HASH_TABLE]): INTEGER_32
		do
			Result := (a_ht.item.count)
		end

	hash_table_destroy (a_ht: CE_POINTER [PD_HASH_TABLE])
		do
			free (create {CE_POINTER [ANY]}.make_cast (a_ht.item.cells))
			free (create {CE_POINTER [ANY]}.make_cast (a_ht))
		end

	hash_table_for_each (a_ht: CE_POINTER [PD_HASH_TABLE]; a_fn: CE_ROUTINE; a_arg: CE_POINTER [ANY])
		local
			l_c: CE_POINTER [PD_CELL]
			l_end: CE_POINTER [PD_CELL]
			l_key: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_end.make
			create l_key.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_ht.item.cells
					l_end := a_ht.item.cells + a_ht.item.size
				when 1 then -- loop condition:
					if not (not js.loop_done and then ((l_c.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 5 -- skip loop
					end
				when 2 then -- loop body:
						if ((l_c.item.key).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | repeat:
						l_key := l_c.item.key
						if (a_fn.integer_32_item ([l_key, l_c.item.value, a_arg])).to_boolean then
							js.return
						end
						if not js.return_called and then (not (l_c.item.key).is_equal (l_key)) then
							if ((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 3 -- goto repeat
							end
						end
				when 4 then
						if not js.return_called then
							l_c := l_c + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 5 then -- loop done
					if not js.return_called then
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hash_table_get (a_ht: CE_POINTER [PD_HASH_TABLE]; a_key: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_c: CE_POINTER [PD_CELL]
		do
			create l_c.make

			l_c := (find_cell (a_ht, a_key))
			if ((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32 then
				Result := (l_c.item.value)
			else
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	hash_table_get_pair (a_ht: CE_POINTER [PD_HASH_TABLE]; a_lookup_key: CE_POINTER [ANY]; a_orig_key: CE_POINTER [ANY]; a_value: CE_POINTER [ANY]): INTEGER_32
		local
			l_c: CE_POINTER [PD_CELL]
		do
			create l_c.make

			l_c := (find_cell (a_ht, a_lookup_key))
			if ((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32 then
				if (not a_orig_key.is_void) then
					(create {CE_POINTER [CE_POINTER [ANY]]}.make_cast (a_orig_key)).item := l_c.item.key
				end
				if (not a_value.is_void) then
					(create {CE_POINTER [CE_POINTER [ANY]]}.make_cast (a_value)).item := l_c.item.value
				end
				Result := 1
			else
				Result := 0
			end
		end

	hash_table_iter_next (a_iter: CE_POINTER [PD_HASH_TABLE_ITERATOR]): INTEGER_32
		local
			l_c: CE_POINTER [PD_CELL]
			l_end: CE_POINTER [PD_CELL]
			js: JUMP_STATE
		do
			create l_c.make
			create l_end.make

			l_c := create {CE_POINTER [PD_CELL]}.make_cast (a_iter.item.pos)
			l_end := create {CE_POINTER [PD_CELL]}.make_cast (a_iter.item.end2)
			from
			until
				not (not js.loop_done and then ((l_c.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32))
			loop
				if ((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32 then
					a_iter.item.key := l_c.item.key
					a_iter.item.value := l_c.item.value
					a_iter.item.pos := create {CE_POINTER [ANY]}.make_cast ((l_c + 1))
					Result := 1
					js.return
				end
				if not js.return_called then
					l_c := l_c + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	hash_table_iterate (a_ht: CE_POINTER [PD_HASH_TABLE]; a_iter: CE_POINTER [PD_HASH_TABLE_ITERATOR])
		do
			a_iter.item.pos := create {CE_POINTER [ANY]}.make_cast (a_ht.item.cells)
			a_iter.item.end2 := create {CE_POINTER [ANY]}.make_cast ((a_ht.item.cells + a_ht.item.size))
		end

	hash_table_new (a_items: INTEGER_32; a_hash_function: CE_ROUTINE; a_test_function: CE_ROUTINE): CE_POINTER [PD_HASH_TABLE]
		local
			l_size: INTEGER_32
			l_ht: CE_POINTER [PD_HASH_TABLE]
		do
			create l_ht.make

			l_ht := create {CE_POINTER [PD_HASH_TABLE]}.make_cast ((xmalloc_inst.xmalloc ((create {PD_HASH_TABLE}.make).structure_size.to_natural_32)))
			if (not a_hash_function.is_void) then
				l_ht.item.hash_function := a_hash_function
			else
				l_ht.item.hash_function := hash_pointer_address
			end
			if (not a_test_function.is_void) then
				l_ht.item.test_function := a_test_function
			else
				l_ht.item.test_function := cmp_pointer_address
			end
			l_ht.item.prime_offset := 0
			l_size := ((1).to_double + a_items.to_double / 0.75).truncated_to_integer
			l_size := prime_size (l_size, create {CE_POINTER [INTEGER_32]}.make_shared (l_ht.c_pointer + (create {PD_HASH_TABLE}.make).offset_of ("prime_offset")))
			l_ht.item.size := l_size
			l_ht.item.resize_threshold := (l_size.to_double * 0.75).truncated_to_integer
			l_ht.item.cells := create {CE_POINTER [PD_CELL]}.make_cast ((xmalloc_inst.xmalloc ((l_ht.item.size).to_natural_32 * (create {PD_CELL}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_ht.item.cells), 255, l_size.to_natural_32 * (create {PD_CELL}.make).structure_size.to_natural_32).do_nothing
			l_ht.item.count := 0
			Result := l_ht
		end

	hash_table_put (a_ht: CE_POINTER [PD_HASH_TABLE]; a_key: CE_POINTER [ANY]; a_value: CE_POINTER [ANY])
		local
			l_c: CE_POINTER [PD_CELL]
			js: JUMP_STATE
		do
			create l_c.make

			l_c := (find_cell (a_ht, a_key))
			if ((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32 then
				l_c.item.key := a_key
				l_c.item.value := a_value
				js.return
			end
			if not js.return_called then
				if a_ht.item.count >= a_ht.item.resize_threshold then
					grow_hash_table (a_ht)
					l_c := find_cell (a_ht, a_key)
				end
				a_ht.item.count := (a_ht.item.count) + 1
				l_c.item.key := a_key
				l_c.item.value := a_value
			end
		end

	hash_table_remove (a_ht: CE_POINTER [PD_HASH_TABLE]; a_key: CE_POINTER [ANY]): INTEGER_32
		local
			l_c: CE_POINTER [PD_CELL]
			l_size: INTEGER_32
			l_cells: CE_POINTER [PD_CELL]
			l_hasher: CE_ROUTINE
			l_key2: CE_POINTER [ANY]
			l_c_new: CE_POINTER [PD_CELL]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_cells.make
			create l_hasher.make
			create l_key2.make
			create l_c_new.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := (find_cell (a_ht, a_key))
					if (((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := 0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 3 then -- else:
						l_size := a_ht.item.size
						l_cells := a_ht.item.cells
						l_hasher := a_ht.item.hash_function
						l_c.item.key := create {CE_POINTER [ANY]}.make_shared (default_pointer + (((0).to_natural_32).bit_not).to_integer_32)
						a_ht.item.count := (a_ht.item.count) - 1
						if not l_c.is_equal (l_cells + (l_size - 1)) then
							l_c := l_c + 1
						else
							l_c := l_cells
						end
				when 4 then -- loop condition:
						if not (not js.loop_done and then (((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 5 then -- loop body:
						l_key2 := l_c.item.key
						l_c_new := l_cells + ((l_hasher.natural_32_item ([l_key2])) \\ l_size.to_natural_32).to_integer_32
				when 6 then -- loop condition:
						if ((l_c_new.item.key).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [ANY]}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						if l_key2.is_equal (l_c_new.item.key) then
							l_pos := -1 + 10 -- goto next_rehash
						end
				when 8 then
						if not l_c_new.is_equal (l_cells + (l_size - 1)) then
							l_c_new := l_c_new + 1
						else
							l_c_new := l_cells
						end
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done
						l_c_new.item := (l_c.item).twin
						l_c.item.key := create {CE_POINTER [ANY]}.make_shared (default_pointer + (((0).to_natural_32).bit_not).to_integer_32)
				when 10 then -- next_rehash:
						
						if not l_c.is_equal (l_cells + (l_size - 1)) then
							l_c := l_c + 1
						else
							l_c := l_cells
						end
						l_pos := -1 + 4 -- back to loop condition
				when 11 then -- loop done
						Result := 1
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	make_nocase_string_hash_table (a_items: INTEGER_32): CE_POINTER [PD_HASH_TABLE]
		do
			Result := (hash_table_new (a_items, hash_string_nocase_address, string_cmp_nocase_address))
		end

	make_string_hash_table (a_items: INTEGER_32): CE_POINTER [PD_HASH_TABLE]
		do
			Result := (hash_table_new (a_items, hash_string_address, cmp_string_address))
		end

	prime_size (a_size: INTEGER_32; a_prime_offset: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_i := (a_prime_offset.item).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < ({PLATFORM}.Integer_32_bytes.to_natural_32 * (71).to_natural_32) // {PLATFORM}.Integer_32_bytes.to_natural_32))
			loop
				if primes[l_i.to_integer_32] >= a_size then
					a_prime_offset.item := (l_i + {NATURAL_32} 1).to_integer_32
					Result := (primes[l_i.to_integer_32])
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				abort
			end
		end

	string_cmp_nocase (a_s1: CE_POINTER [ANY]; a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s1), create {CE_POINTER [INTEGER_8]}.make_cast (a_s2))).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	string_cmp_nocase_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent string_cmp_nocase)
		end

end
