class
	P_HTTP

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create basic_authed_hosts.make
			create chunk.make (<<8_192>>)
			create hfmt.make (<<2, 2>>)
			create nonce.make (<<1>>)
			create opaque.make (<<1>>)
			create options.make (<<3>>)
			create pconn.make (<<1>>)
			create realm.make (<<1>>)
			create time_formats.make (<<4>>)
			create wget_cookie_jar.make
		end

feature {ANY} -- attributes

	basic_authed_hosts: CE_POINTER [PD_HASH_TABLE] assign set_basic_authed_hosts

	set_basic_authed_hosts (a_basic_authed_hosts: CE_POINTER [PD_HASH_TABLE])
		do
			basic_authed_hosts := a_basic_authed_hosts
		end

	chunk: CE_ARRAY [INTEGER_8]

	cookies_loaded_p: BOOLEAN assign set_cookies_loaded_p

	set_cookies_loaded_p (a_cookies_loaded_p: BOOLEAN)
		do
			cookies_loaded_p := a_cookies_loaded_p
		end

	hfmt: CE_ARRAY [CE_ARRAY [CE_POINTER [INTEGER_8]]]

	nonce: CE_ARRAY [CE_POINTER [INTEGER_8]]

	opaque: CE_ARRAY [CE_POINTER [INTEGER_8]]

	options: CE_ARRAY [PD_OPTIONS2]

	pconn: CE_ARRAY [PD_PCONN]

	pconn_active: BOOLEAN assign set_pconn_active

	set_pconn_active (a_pconn_active: BOOLEAN)
		do
			pconn_active := a_pconn_active
		end

	realm: CE_ARRAY [CE_POINTER [INTEGER_8]]

	time_formats: CE_ARRAY [CE_POINTER [INTEGER_8]]

	wget_cookie_jar: CE_POINTER [PD_COOKIE_JAR] assign set_wget_cookie_jar

	set_wget_cookie_jar (a_wget_cookie_jar: CE_POINTER [PD_COOKIE_JAR])
		do
			wget_cookie_jar := a_wget_cookie_jar
		end

feature {ANY} -- routines

	basic_authentication_encode (a_user: CE_POINTER [INTEGER_8]; a_passwd: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_t1: CE_POINTER [INTEGER_8]
			l_t2: CE_POINTER [INTEGER_8]
			l_len1: INTEGER_32
			l_tmp: NATURAL_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_t1.make
			create l_t2.make

			l_tmp := strlen (a_user)
			l_len1 := ((l_tmp + {NATURAL_32} 1) + (strlen (a_passwd))).to_integer_32
			l_t1 := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_len1 + 1).to_natural_32)))
			sprintf ([l_t1, ce_string ("%%s:%%s"), a_user, a_passwd]).do_nothing
			l_t2 := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((4 * ((l_len1 + 2) // 3) + 1).to_natural_32)))
			utils_inst.base64_encode (create {CE_POINTER [ANY]}.make_cast (l_t1), l_len1, l_t2).do_nothing
			Result := (utils_inst.concat_strings ([ce_string ("Basic "), l_t2, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)]))
		end

	check_end (a_p___0: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_p___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
					if l_p___0.is_void then
						Result := (0).to_boolean
						js.return
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
						if (l_p___0[0]).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						Result := (1).to_boolean
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if (l_p___0[0]).to_integer_32 /= 71 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_p___0[1]).to_integer_32 = 77 then
							if (l_p___0[2]).to_integer_32 = 84 then
								Result := (1).to_boolean
							else
								l_pos := -1 + 7 -- goto _L___1
							end
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else: | _L___1:
						if (l_p___0[0]).to_integer_32 /= 43 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if (l_p___0[0]).to_integer_32 /= 45 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						if (c_ctype_inst.c2_isdigit ((l_p___0[1]).to_integer_32)) then
							Result := (1).to_boolean
						else
							Result := (0).to_boolean
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						Result := (0).to_boolean
				when 14 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	create_authorization_line (a_au: CE_POINTER [INTEGER_8]; a_user: CE_POINTER [INTEGER_8]; a_passwd: CE_POINTER [INTEGER_8]; a_method: CE_POINTER [INTEGER_8]; a_path: CE_POINTER [INTEGER_8]; a_finished: CE_POINTER [BOOLEAN]): CE_POINTER [INTEGER_8]
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (c_ctype_inst.c2_toupper ((a_au[0]).to_integer_32)) -- switch 1 head
					when 66 then l_pos := -1 + 1
					when 68 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 66
					a_finished.item := (1).to_boolean
					Result := (basic_authentication_encode (a_user, a_passwd))
					js.return
				when 2 then -- switch 1, case 68
					if not js.return_called then
						a_finished.item := (1).to_boolean
						Result := (digest_authentication_encode (a_au, a_user, a_passwd, a_method, a_path))
						js.return
					end
				when 3 then -- switch 1, default:
					if not js.return_called then
						abort
					end
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	digest_authentication_encode (a_au: CE_POINTER [INTEGER_8]; a_user: CE_POINTER [INTEGER_8]; a_passwd: CE_POINTER [INTEGER_8]; a_method: CE_POINTER [INTEGER_8]; a_path: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_au: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_res___0: CE_POINTER [INTEGER_8]
			l_name: CE_ARRAY [PD_PARAM_TOKEN]
			l_value: CE_ARRAY [PD_PARAM_TOKEN]
			l_i: NATURAL_32
			l_namelen: NATURAL_32
			l_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT]
			l_hash: CE_ARRAY [NATURAL_8]
			l_a1buf: CE_ARRAY [INTEGER_8]
			l_a2buf: CE_ARRAY [INTEGER_8]
			l_response_digest: CE_ARRAY [INTEGER_8]
			l_tmp___10: NATURAL_32
			l_tmp___11: NATURAL_32
			l_tmp___12: NATURAL_32
			l_tmp___13: NATURAL_32
			l_tmp___14: NATURAL_32
			l_tmp___16: NATURAL_32
			l_p___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_au.make (<<1>>)
			create l_res___0.make
			create l_name.make (<<1>>)
			create l_value.make (<<1>>)
			create l_ctx.make
			create l_hash.make (<<16>>)
			create l_a1buf.make (<<33>>)
			create l_a2buf.make (<<33>>)
			create l_response_digest.make (<<33>>)
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_au.item := a_au
					nonce.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					opaque.item := nonce.item
					realm.item := opaque.item
					l_au.item := l_au.item + (6)
					from
					until
						js.loop_done
					loop
						if not (extract_param (l_au, l_name, l_value, ((',').code).to_integer_8)) then
							js.break
						end
						if not js.loop_jumped then
							l_namelen := ((l_name.item.e).distance ((l_name.item.b))).to_natural_32
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < ((create {PD_OPTIONS2}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_OPTIONS2}.make).structure_size.to_natural_32))
							loop
								if l_namelen = (strlen (options[l_i.to_integer_32].name)) then
									if 0 = (strncmp (l_name.item.b, options[l_i.to_integer_32].name, l_namelen)) then
										(options[l_i.to_integer_32].variable).item := utils_inst.strdupdelim (l_value.item.b, l_value.item.e)
										js.break
									end
								end
								if not js.loop_jumped then
									l_i := l_i + 1
								end
							end
						end
					end
					if (not (realm.item).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 3 then -- else:
						if (not (nonce.item).is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 6 then -- else:
						if (not a_user.is_void) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 9 then -- else:
						if (not a_passwd.is_void) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 12 then -- else:
						if (not a_path.is_void) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if (not a_method.is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if (not (realm.item).is_void) then
							free (create {CE_POINTER [ANY]}.make_cast (realm.item))
						end
						if (not (opaque.item).is_void) then
							free (create {CE_POINTER [ANY]}.make_cast (opaque.item))
						end
						if (not (nonce.item).is_void) then
							free (create {CE_POINTER [ANY]}.make_cast (nonce.item))
						end
						Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						js.return
				when 17 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							l_ctx := create {CE_POINTER [PD_GEN_MD5_CONTEXT]}.make_cast ((l_aaf.new ((gen_md5_inst.gen_md5_context_size).to_natural_32)))
							gen_md5_inst.gen_md5_init (l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (a_user), (strlen (a_user)).to_integer_32, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")), 1, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (realm.item), (strlen (realm.item)).to_integer_32, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")), 1, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (a_passwd), (strlen (a_passwd)).to_integer_32, l_ctx)
							gen_md5_inst.gen_md5_finish (l_ctx, l_hash)
							dump_hash (l_a1buf, create {CE_POINTER [NATURAL_8]}.make_cast (l_hash))
							gen_md5_inst.gen_md5_init (l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (a_method), (strlen (a_method)).to_integer_32, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")), 1, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (a_path), (strlen (a_path)).to_integer_32, l_ctx)
							gen_md5_inst.gen_md5_finish (l_ctx, l_hash)
							dump_hash (l_a2buf, create {CE_POINTER [NATURAL_8]}.make_cast (l_hash))
							gen_md5_inst.gen_md5_init (l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (l_a1buf), 32, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")), 1, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (nonce.item), (strlen (nonce.item)).to_integer_32, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")), 1, l_ctx)
							gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (l_a2buf), 32, l_ctx)
							gen_md5_inst.gen_md5_finish (l_ctx, l_hash)
							dump_hash (l_response_digest, create {CE_POINTER [NATURAL_8]}.make_cast (l_hash))
							l_tmp___10 := strlen (a_user)
							l_tmp___11 := strlen (a_user)
							l_tmp___12 := strlen (realm.item)
							l_tmp___13 := strlen (nonce.item)
							l_tmp___14 := strlen (a_path)
							if (not (opaque.item).is_void) then
								l_tmp___16 := (strlen (opaque.item))
							else
								l_tmp___16 := (0).to_natural_32
							end
							l_res___0 := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (((((((l_tmp___10 + l_tmp___11) + l_tmp___12) + l_tmp___13) + l_tmp___14) + {NATURAL_32} 32) + l_tmp___16) + {NATURAL_32} 128)))
							sprintf ([l_res___0, ce_string ("Digest username=%"%%s%", realm=%"%%s%", nonce=%"%%s%", uri=%"%%s%", response=%"%%s%""), a_user, realm.item, nonce.item, a_path, l_response_digest]).do_nothing
							if (not (opaque.item).is_void) then
								l_p___0 := l_res___0 + (strlen (l_res___0)).to_integer_32
								strcat (l_p___0, ce_string (", opaque=%"")).do_nothing
								strcat (l_p___0, opaque.item).do_nothing
								strcat (l_p___0, ce_string ("%"")).do_nothing
							end
							Result := l_res___0
						end
				when 18 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	dump_hash (a_buf___6: CE_POINTER [INTEGER_8]; a_hash: CE_POINTER [NATURAL_8])
		local
			l_buf___6: CE_POINTER [INTEGER_8]
			l_hash: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_buf___6.make
			create l_hash.make
			create l_tmp.make
			create l_tmp___0.make

			l_buf___6 := a_buf___6
			l_hash := a_hash
			l_i := 0
			from
			until
				not (l_i < 16)
			loop
				l_tmp := l_buf___6
				l_buf___6 := l_buf___6 + 1
				l_tmp[0] := (((ce_string ("0123456789abcdef") + (((l_hash.item).to_integer_32).bit_shift_right (4))).item).to_integer_32).to_integer_8
				l_tmp___0 := l_buf___6
				l_buf___6 := l_buf___6 + 1
				l_tmp___0[0] := (((ce_string ("0123456789abcdef") + (((l_hash.item).to_integer_32).bit_and (15))).item).to_integer_32).to_integer_8
				l_i := l_i + 1
				l_hash := l_hash + 1
			end
			l_buf___6[0] := (('%/0/').code).to_integer_8
		end

	ensure_extension (a_hs: CE_POINTER [PD_HTTP_STAT]; a_ext: CE_POINTER [INTEGER_8]; a_dt: CE_POINTER [INTEGER_32])
		local
			l_last_period_in_local_filename: CE_POINTER [INTEGER_8]
			l_shortext: CE_ARRAY [INTEGER_8]
			l_len: INTEGER_32
			l_local_filename_len: INTEGER_32
			l_ext_num: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_last_period_in_local_filename.make
			create l_shortext.make (<<8>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_last_period_in_local_filename := (strrchr (a_hs.item.local_file, ('.').code))
					l_len := (strlen (a_ext)).to_integer_32
					if l_len = 5 then
						strncpy (l_shortext, a_ext, (l_len - 1).to_natural_32).do_nothing
						l_shortext[l_len - 2] := (('%/0/').code).to_integer_8
					end
					if not (l_last_period_in_local_filename.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if (0 = (strcasecmp (l_last_period_in_local_filename, l_shortext))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (0 = (strcasecmp (l_last_period_in_local_filename, a_ext))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_local_filename_len := (strlen (a_hs.item.local_file)).to_integer_32
						a_hs.item.local_file := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (a_hs.item.local_file), ((l_local_filename_len + 24) + l_len).to_natural_32)))
						strcpy ((a_hs.item.local_file + l_local_filename_len), a_ext).do_nothing
						if not options_inst.opt.item.noclobber then
							if not options_inst.opt.item.always_rest then
								if not options_inst.opt.item.timestamping then
									if not options_inst.opt.item.dirstruct then
										if (options_inst.opt.item.output_document).is_void then
											if (utils_inst.file_exists_p (a_hs.item.local_file)) then
												l_ext_num := 1
												from
												until
													js.loop_done
												loop
													l_tmp___3 := l_ext_num
													l_ext_num := l_ext_num + 1
													sprintf ([(a_hs.item.local_file + l_local_filename_len), ce_string (".%%d%%s"), l_tmp___3, a_ext]).do_nothing
													if not (utils_inst.file_exists_p (a_hs.item.local_file)) then
														js.break
													end
												end
											end
										end
									end
								end
							end
						end
						a_dt.item := (a_dt.item).bit_or ((32))
				when 6 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	extract_param (a_source: CE_POINTER [CE_POINTER [INTEGER_8]]; a_name: CE_POINTER [PD_PARAM_TOKEN]; a_value: CE_POINTER [PD_PARAM_TOKEN]; a_separator: INTEGER_8): BOOLEAN
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_source.item
					from
					until
						js.loop_done
					loop
						if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
						if not js.loop_jumped then
							l_p___0 := l_p___0 + 1
						end
					end
					if not (l_p___0[0]).to_boolean then
						a_source.item := l_p___0
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						a_name.item.b := l_p___0
						from
						until
							js.loop_done
						loop
							if (l_p___0[0]).to_boolean then
								if (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
									js.break
								elseif (l_p___0[0]).to_integer_32 /= 61 then
									if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
						a_name.item.e := l_p___0
						if (a_name.item.b).is_equal (a_name.item.e) then
							Result := (0).to_boolean
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
						if (l_p___0[0]).to_integer_32 /= a_separator.to_integer_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_p___0[0]).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						memset (create {CE_POINTER [ANY]}.make_cast (a_value), ('%/0/').code, (create {PD_PARAM_TOKEN}.make).structure_size.to_natural_32).do_nothing
						if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
							l_p___0 := l_p___0 + 1
						end
						a_source.item := l_p___0
						Result := (1).to_boolean
						js.return
				when 6 then -- if done | if done
						if not js.return_called and then ((l_p___0[0]).to_integer_32 /= 61) then
							Result := (0).to_boolean
							js.return
						end
						if not js.return_called then
							l_p___0 := l_p___0 + 1
							from
							until
								js.loop_done
							loop
								if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 + 1
								end
							end
							if (l_p___0[0]).to_integer_32 = 34 then
								l_p___0 := l_p___0 + 1
								a_value.item.b := l_p___0
								from
								until
									js.loop_done
								loop
									if (l_p___0[0]).to_boolean then
										if (l_p___0[0]).to_integer_32 = 34 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0 := l_p___0 + 1
									end
								end
								if not (l_p___0[0]).to_boolean then
									Result := (0).to_boolean
									js.return
								end
								if not js.return_called then
									l_tmp___3 := l_p___0
									l_p___0 := l_p___0 + 1
									a_value.item.e := l_tmp___3
									from
									until
										js.loop_done
									loop
										if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
											js.break
										end
										if not js.loop_jumped then
											l_p___0 := l_p___0 + 1
										end
									end
									from
									until
										js.loop_done
									loop
										if (l_p___0[0]).to_boolean then
											if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_p___0 := l_p___0 + 1
										end
									end
									if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
										l_p___0 := l_p___0 + 1
									elseif (l_p___0[0]).to_boolean then
										Result := (0).to_boolean
										js.return
									end
								end
							else
								a_value.item.b := l_p___0
								from
								until
									js.loop_done
								loop
									if (l_p___0[0]).to_boolean then
										if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0 := l_p___0 + 1
									end
								end
								a_value.item.e := l_p___0
								from
								until
									js.loop_done
								loop
									if not (a_value.item.e).is_equal (a_value.item.b) then
										if not (c_ctype_inst.c2_isspace ((a_value.item.e[-1]).to_integer_32)) then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										a_value.item.e := (a_value.item.e) - 1
									end
								end
								if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
									l_p___0 := l_p___0 + 1
								end
							end
						end
						if not js.return_called then
							a_source.item := l_p___0
							Result := (1).to_boolean
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	free_hstat (a_hs: CE_POINTER [PD_HTTP_STAT])
		do
			if (not (a_hs.item.newloc).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_hs.item.newloc))
			end
			if (not (a_hs.item.remote_time).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_hs.item.remote_time))
			end
			if (not (a_hs.item.error).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_hs.item.error))
			end
			if (not (a_hs.item.rderrmsg).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_hs.item.rderrmsg))
			end
			if (not (a_hs.item.local_file).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_hs.item.local_file))
			end
			if (not (a_hs.item.orig_file_name).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_hs.item.orig_file_name))
			end
			if (not (a_hs.item.message).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_hs.item.message))
			end
			a_hs.item.newloc := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			a_hs.item.remote_time := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			a_hs.item.error := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
		end

	gethttp (a_u: CE_POINTER [PD_URL]; a_hs: CE_POINTER [PD_HTTP_STAT]; a_dt: CE_POINTER [INTEGER_32]; a_proxy: CE_POINTER [PD_URL]; a_iri: CE_POINTER [PD_IRI]): NATURAL_32
		local
			l_req: CE_POINTER [PD_REQUEST]
			l_type: CE_POINTER [INTEGER_8]
			l_user: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_passwd: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_proxyauth: CE_POINTER [INTEGER_8]
			l_statcode: INTEGER_32
			l_write_error: INTEGER_32
			l_contlen: INTEGER_64
			l_contrange: INTEGER_64
			l_conn: CE_POINTER [PD_URL]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_sock: INTEGER_32
			l_flags: INTEGER_32
			l_auth_finished: CE_ARRAY [BOOLEAN]
			l_basic_auth_finished: BOOLEAN
			l_ntlm_seen: BOOLEAN
			l_using_ssl: BOOLEAN
			l_head_only: BOOLEAN
			l_head: CE_POINTER [INTEGER_8]
			l_resp: CE_POINTER [PD_RESPONSE]
			l_hdrval: CE_ARRAY [INTEGER_8]
			l_message: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_keep_alive: BOOLEAN
			l_inhibit_keep_alive: BOOLEAN
			l_tmp: INTEGER_32
			l_post_data_size: INTEGER_64
			l_host_lookup_failed: CE_ARRAY [BOOLEAN]
			l_meth_arg: CE_POINTER [INTEGER_8]
			l_meth: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_add_port: INTEGER_32
			l_add_squares: INTEGER_32
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_proxy_user: CE_POINTER [INTEGER_8]
			l_proxy_passwd: CE_POINTER [INTEGER_8]
			l_relevant: CE_POINTER [PD_URL]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___24: INTEGER_32
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___31: CE_POINTER [INTEGER_8]
			l_tmp___36: CE_POINTER [INTEGER_8]
			l_parsed: INTEGER_64
			l_scpos: INTEGER_32
			l_scbeg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_scend: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_set_cookie: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_wapos: INTEGER_32
			l_wabeg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_waend: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_www_authenticate: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_BTA_beg___0: CE_POINTER [INTEGER_8]
			l_BTA_len___0: INTEGER_32
			l_BTA_dest___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_pth: CE_POINTER [INTEGER_8]
			l_tmp___59: CE_POINTER [INTEGER_8]
			l_unique: CE_POINTER [INTEGER_8]
			l_filename_len: NATURAL_32
			l_filename_plus_orig_suffix: CE_POINTER [INTEGER_8]
			l_local_dot_orig_file_exists: BOOLEAN
			l_local_filename: CE_POINTER [INTEGER_8]
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___70: CE_POINTER [INTEGER_8]
			l_tmp2: CE_POINTER [INTEGER_8]
			l_first_byte_pos: CE_ARRAY [INTEGER_64]
			l_last_byte_pos: CE_ARRAY [INTEGER_64]
			l_entity_length: CE_ARRAY [INTEGER_64]
			l_tmp___76: CE_POINTER [INTEGER_8]
			l_tmp___79: CE_POINTER [INTEGER_8]
			l_tmp___92: CE_POINTER [INTEGER_8]
			l_tmp___93: CE_POINTER [INTEGER_8]
			l_tmp___95: CE_POINTER [INTEGER_8]
			l_tmp___99: CE_POINTER [INTEGER_8]
			l_tmp___107: CE_POINTER [INTEGER_8]
			l_tmp___108: CE_POINTER [INTEGER_8]
			l_tmp___111: INTEGER_64
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_req.make
			create l_type.make
			create l_user.make (<<1>>)
			create l_passwd.make (<<1>>)
			create l_proxyauth.make
			create l_conn.make
			create l_fp.make
			create l_auth_finished.make (<<1>>)
			create l_head.make
			create l_resp.make
			create l_hdrval.make (<<256>>)
			create l_message.make (<<1>>)
			create l_host_lookup_failed.make (<<1>>)
			create l_meth_arg.make
			create l_meth.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_proxy_user.make
			create l_proxy_passwd.make
			create l_relevant.make
			create l_tmp___16.make
			create l_tmp___19.make
			create l_tmp___28.make
			create l_tmp___31.make
			create l_tmp___36.make
			create l_scbeg.make (<<1>>)
			create l_scend.make (<<1>>)
			create l_set_cookie.make (<<1>>)
			create l_BTA_beg.make
			create l_BTA_dest.make
			create l_wabeg.make (<<1>>)
			create l_waend.make (<<1>>)
			create l_www_authenticate.make (<<1>>)
			create l_BTA_beg___0.make
			create l_BTA_dest___0.make
			create l_pth.make
			create l_tmp___59.make
			create l_unique.make
			create l_filename_plus_orig_suffix.make
			create l_local_filename.make
			create l_st.make (<<1>>)
			create l_tmp___70.make
			create l_tmp2.make
			create l_first_byte_pos.make (<<1>>)
			create l_last_byte_pos.make (<<1>>)
			create l_entity_length.make (<<1>>)
			create l_tmp___76.make
			create l_tmp___79.make
			create l_tmp___92.make
			create l_tmp___93.make
			create l_tmp___95.make
			create l_tmp___99.make
			create l_tmp___107.make
			create l_tmp___108.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := -1
					l_auth_finished.item := (0).to_boolean
					l_basic_auth_finished := (0).to_boolean
					l_ntlm_seen := (0).to_boolean
					l_using_ssl := (0).to_boolean
					l_head_only := (((a_dt.item).bit_and (4)).to_boolean)
					if not options_inst.opt.item.http_keep_alive then
						l_tmp := 1
					elseif options_inst.opt.item.ignore_length then
						l_tmp := 1
					elseif not a_proxy.is_void then
						l_tmp := 1
					else
						l_tmp := 0
					end
					l_inhibit_keep_alive := l_tmp.to_boolean
					l_post_data_size := (0).to_integer_64
					l_host_lookup_failed.item := (0).to_boolean
					a_hs.item.len := (0).to_integer_64
					a_hs.item.contlen := (-1).to_integer_64
					a_hs.item.res := -1
					a_hs.item.rderrmsg := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					a_hs.item.newloc := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					a_hs.item.remote_time := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					a_hs.item.error := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					a_hs.item.message := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_conn := a_u
					l_req := request_new
					l_meth := ce_string ("GET")
					if l_head_only then
						l_meth := ce_string ("HEAD")
					elseif (not (options_inst.opt.item.post_file_name).is_void) then
						l_meth := ce_string ("POST")
					elseif (not (options_inst.opt.item.post_data).is_void) then
						l_meth := ce_string ("POST")
					end
					if (not a_proxy.is_void) then
						l_meth_arg := xmalloc_inst.xstrdup (a_u.item.url)
					else
						l_meth_arg := url_inst.url_full_path (a_u)
					end
					request_set_method (l_req, l_meth, l_meth_arg)
					request_set_header (l_req, ce_string ("Referer"), a_hs.item.referer, {PC_RP}.rel_none)
					if ((a_dt.item).bit_and (8)).to_boolean then
						request_set_header (l_req, ce_string ("Pragma"), ce_string ("no-cache"), {PC_RP}.rel_none)
					end
					if (a_hs.item.restval).to_boolean then
						request_set_header (l_req, ce_string ("Range"), (utils_inst.aprintf ([ce_string ("bytes=%%s-"), (utils_inst.number_to_static_string (a_hs.item.restval))])), {PC_RP}.rel_value)
					end
					from
					until
						js.loop_done
					loop
						if (options_inst.opt.item.useragent).is_void then
							request_set_header (l_req, ce_string ("User-Agent"), (utils_inst.aprintf ([ce_string ("Wget/%%s (%%s)"), version_inst.version_string, ce_string ("linux-gnu")])), {PC_RP}.rel_value)
						elseif ((options_inst.opt.item.useragent).item).to_boolean then
							request_set_header (l_req, ce_string ("User-Agent"), options_inst.opt.item.useragent, {PC_RP}.rel_none)
						end
						js.break
					end
					request_set_header (l_req, ce_string ("Accept"), ce_string ("*/*"), {PC_RP}.rel_none)
					l_user.item := a_u.item.user
					l_passwd.item := a_u.item.passwd
					netrc_inst.search_netrc (a_u.item.host, l_user, l_passwd, 0)
					if (not (l_user.item).is_void) then
						l_user.item := l_user.item
					else
						if (not (options_inst.opt.item.http_user).is_void) then
							l_tmp___3 := options_inst.opt.item.http_user
						else
							l_tmp___3 := options_inst.opt.item.user
						end
						l_user.item := l_tmp___3
					end
					if (not (l_passwd.item).is_void) then
						l_passwd.item := l_passwd.item
					else
						if (not (options_inst.opt.item.http_passwd).is_void) then
							l_tmp___4 := options_inst.opt.item.http_passwd
						else
							l_tmp___4 := options_inst.opt.item.passwd
						end
						l_passwd.item := l_tmp___4
					end
					if (not (l_user.item).is_void) then
						if (not (l_passwd.item).is_void) then
							if (a_u.item.user).is_void then
								l_basic_auth_finished := maybe_send_basic_creds (a_u.item.host, l_user.item, l_passwd.item, l_req)
							elseif options_inst.opt.item.auth_without_challenge then
								l_basic_auth_finished := maybe_send_basic_creds (a_u.item.host, l_user.item, l_passwd.item, l_req)
							end
						end
					end
					l_add_port := (a_u.item.port /= (url_inst.scheme_default_port (a_u.item.scheme))).to_integer
					l_add_squares := (not (strchr (a_u.item.host, (':').code)).is_void).to_integer
					request_set_header (l_req, ce_string ("Host"), (utils_inst.aprintf ([(hfmt[l_add_port])[l_add_squares], a_u.item.host, a_u.item.port])), {PC_RP}.rel_value)
					if not l_inhibit_keep_alive then
						request_set_header (l_req, ce_string ("Connection"), ce_string ("Keep-Alive"), {PC_RP}.rel_none)
					end
					if options_inst.opt.item.cookies then
						request_set_header (l_req, ce_string ("Cookie"), (cookies_inst.cookie_header (wget_cookie_jar, a_u.item.host, a_u.item.port, a_u.item.path, (0).to_boolean)), {PC_RP}.rel_value)
					end
					if (options_inst.opt.item.post_data).is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (options_inst.opt.item.post_file_name).is_void then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						request_set_header (l_req, ce_string ("Content-Type"), ce_string ("application/x-www-form-urlencoded"), {PC_RP}.rel_none)
						if (not (options_inst.opt.item.post_data).is_void) then
							l_post_data_size := (strlen (options_inst.opt.item.post_data)).to_integer_64
						else
							l_post_data_size := utils_inst.file_size (options_inst.opt.item.post_file_name)
							if l_post_data_size = -{INTEGER_64} 1 then
								l_tmp___11 := strerror ((errno_location).item)
								l_tmp___12 := quote_inst.quote (options_inst.opt.item.post_file_name)
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("POST data file %%s missing: %%s%N"))), l_tmp___12, l_tmp___11])
								l_post_data_size := (0).to_integer_64
							end
						end
						request_set_header (l_req, ce_string ("Content-Length"), (xmalloc_inst.xstrdup ((utils_inst.number_to_static_string (l_post_data_size)))), {PC_RP}.rel_value)
				when 5 then -- if done
						if (not (options_inst.opt.item.user_headers).is_void) then
							l_i := 0
							from
							until
								(options_inst.opt.item.user_headers[l_i]).is_void
							loop
								request_set_user_header (l_req, options_inst.opt.item.user_headers[l_i])
								l_i := l_i + 1
							end
						end
				when 6 then -- retry_with_auth:
						l_proxyauth := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						if (not a_proxy.is_void) then
							if (not (options_inst.opt.item.proxy_user).is_void) then
								if (not (options_inst.opt.item.proxy_passwd).is_void) then
									l_proxy_user := options_inst.opt.item.proxy_user
									l_proxy_passwd := options_inst.opt.item.proxy_passwd
								else
									l_proxy_user := a_proxy.item.user
									l_proxy_passwd := a_proxy.item.passwd
								end
							else
								l_proxy_user := a_proxy.item.user
								l_proxy_passwd := a_proxy.item.passwd
							end
							if (not l_proxy_user.is_void) then
								if (not l_proxy_passwd.is_void) then
									l_proxyauth := basic_authentication_encode (l_proxy_user, l_proxy_passwd)
								end
							end
							l_conn := a_proxy
							request_set_header (l_req, ce_string ("Proxy-Authorization"), l_proxyauth, {PC_RP}.rel_value)
						end
						l_keep_alive := (0).to_boolean
						if not l_inhibit_keep_alive then
							l_relevant := l_conn
							if (persistent_available_p (l_relevant.item.host, l_relevant.item.port, (0).to_boolean, l_host_lookup_failed)) then
								l_sock := pconn.item.socket
								l_using_ssl := pconn.item.ssl
								l_tmp___16 := quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, pconn.item.host)
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Reusing existing connection to %%s:%%d.%N"))), l_tmp___16, pconn.item.port])
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("Reusing fd %%d.%N"), l_sock])
									end
									js.break
								end
								if pconn.item.authorized then
									request_remove_header (l_req, ce_string ("Authorization")).do_nothing
								end
							elseif l_host_lookup_failed.item then
								request_free (l_req)
								l_tmp___19 := quote_inst.quote (l_relevant.item.host)
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: unable to resolve host address %%s%N"))), wget_inst.exec_name, l_tmp___19])
								Result := ({PC_UERR_T}.HOSTERR)
								js.return
							end
						end
						if not js.return_called and then (l_sock < 0) then
							l_sock := connect_inst.connect_to_host (l_conn.item.host, l_conn.item.port)
							if l_sock = -100 then
								request_free (l_req)
								Result := ({PC_UERR_T}.HOSTERR)
								js.return
							elseif l_sock < 0 then
								request_free (l_req)
								if (connect_inst.retryable_socket_connect_error ((errno_location).item)) then
									l_tmp___24 := 3
								else
									l_tmp___24 := 5
								end
								Result := l_tmp___24.to_natural_32
								js.return
							end
						end
						if not js.return_called then
							l_write_error := request_send (l_req, l_sock)
							if l_write_error >= 0 then
								if (not (options_inst.opt.item.post_data).is_void) then
									from
									until
										js.loop_done
									loop
										if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("[POST data: %%s]%N"), options_inst.opt.item.post_data])
										end
										js.break
									end
									l_write_error := connect_inst.fd_write (l_sock, options_inst.opt.item.post_data, l_post_data_size.to_integer_32, (-1).to_double)
								elseif (not (options_inst.opt.item.post_file_name).is_void) then
									if l_post_data_size /= {INTEGER_64} 0 then
										l_write_error := post_file (l_sock, options_inst.opt.item.post_file_name, l_post_data_size)
									end
								end
							end
							if l_write_error < 0 then
								from
								until
									js.loop_done
								loop
									if pconn_active then
										if l_sock = pconn.item.socket then
											invalidate_persistent
										else
											connect_inst.fd_close (l_sock)
										end
									else
										connect_inst.fd_close (l_sock)
									end
									l_sock := -1
									js.break
								end
								request_free (l_req)
								Result := ({PC_UERR_T}.WRITEFAILED)
								js.return
							end
						end
						if not js.return_called then
							if (not a_proxy.is_void) then
								l_tmp___28 := ce_string ("Proxy")
							else
								l_tmp___28 := ce_string ("HTTP")
							end
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%%s request sent, awaiting response... "))), l_tmp___28])
							l_contlen := (-1).to_integer_64
							l_contrange := (0).to_integer_64
							a_dt.item := (a_dt.item).bit_and ((-3))
							l_head := read_http_response_head (l_sock)
							if l_head.is_void then
								if (errno_location).item = 0 then
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("No data received.%N"))))
									from
									until
										js.loop_done
									loop
										if pconn_active then
											if l_sock = pconn.item.socket then
												invalidate_persistent
											else
												connect_inst.fd_close (l_sock)
											end
										else
											connect_inst.fd_close (l_sock)
										end
										l_sock := -1
										js.break
									end
									request_free (l_req)
									Result := ({PC_UERR_T}.HEOF)
									js.return
								else
									l_tmp___31 := connect_inst.fd_errstr (l_sock)
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Read error (%%s) in headers.%N"))), l_tmp___31])
									from
									until
										js.loop_done
									loop
										if pconn_active then
											if l_sock = pconn.item.socket then
												invalidate_persistent
											else
												connect_inst.fd_close (l_sock)
											end
										else
											connect_inst.fd_close (l_sock)
										end
										l_sock := -1
										js.break
									end
									request_free (l_req)
									Result := ({PC_UERR_T}.HERR)
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 38 -- skip if block
						end
				when 7 then -- if:
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("%N---response begin---%N%%s---response end---%N"), l_head])
								end
								js.break
							end
							l_resp := resp_new (l_head)
							l_message.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							l_statcode := resp_status (l_resp, l_message)
							a_hs.item.message := xmalloc_inst.xstrdup (l_message.item)
							if not options_inst.opt.item.server_response then
								if (not (l_message.item).is_void) then
									l_tmp___36 := (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_message.item))
								else
									l_tmp___36 := ce_string ("")
								end
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%%2d %%s%N"), l_statcode, l_tmp___36])
							else
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N")])
								print_server_response (l_resp, ce_string ("  "))
							end
							if options_inst.opt.item.ignore_length then
								l_pos := -1 + 13 -- skip if block
							end
				when 8 then -- if:
							if not (resp_header_copy (l_resp, ce_string ("Content-Length"), l_hdrval, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)) then
								l_pos := -1 + 13 -- skip if block
							end
				when 9 then; -- if:
							(errno_location).item := 0
							l_parsed := strtoll (l_hdrval, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
							if l_parsed /= (((-{INTEGER_64} 1).bit_shift_left (({PLATFORM}.Integer_64_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							if (errno_location).item = 34 then
								l_contlen := (-1).to_integer_64
							else
								l_pos := -1 + 12 -- goto _L___0
							end
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 13
				when 12 then -- else: | _L___0:
							if l_parsed < {INTEGER_64} 0 then
								l_contlen := (-1).to_integer_64
							else
								l_contlen := l_parsed
							end
				when 13 then -- if done | if done
							if not l_inhibit_keep_alive then
								if l_contlen /= -{INTEGER_64} 1 then
									if (resp_header_copy (l_resp, ce_string ("Keep-Alive"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), 0)) then
										l_keep_alive := (1).to_boolean
									elseif (resp_header_copy (l_resp, ce_string ("Connection"), l_hdrval, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)) then
										if 0 = (strcasecmp (l_hdrval, ce_string ("Keep-Alive"))) then
											l_keep_alive := (1).to_boolean
										end
									end
								end
							end
							if options_inst.opt.item.cookies then
								if wget_cookie_jar.is_void then
									assert_fail (ce_string ("wget_cookie_jar != ((void *)0)"), ce_string ("http.c"), {NATURAL_32} 1_885, ce_string ("gethttp"))
								end
								l_scpos := 0
								from
								until
									js.loop_done
								loop
									l_scpos := resp_header_locate (l_resp, ce_string ("Set-Cookie"), l_scpos, l_scbeg, l_scend)
									if l_scpos = -1 then
										js.break
									end
									if not js.loop_jumped then
										from
										until
											js.loop_done
										loop
											l_BTA_beg := l_scbeg.item
											l_BTA_len := (l_scend.item).distance (l_BTA_beg)
											l_BTA_dest := l_set_cookie
											l_BTA_dest.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
											memcpy (create {CE_POINTER [ANY]}.make_cast (l_BTA_dest.item), create {CE_POINTER [ANY]}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
											l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
											js.break
										end
										cookies_inst.cookie_handle_set_cookie (wget_cookie_jar, a_u.item.host, a_u.item.port, a_u.item.path, l_set_cookie.item)
										l_scpos := l_scpos + 1
									end
								end
							end
							if l_keep_alive then
								register_persistent (l_conn.item.host, l_conn.item.port, l_sock, l_using_ssl)
							end
							if l_statcode /= 401 then
								l_pos := -1 + 37 -- skip if block
							end
				when 14 then -- if:
							if not l_keep_alive then
								l_pos := -1 + 17 -- skip if block
							end
				when 15 then -- if:
							if not l_head_only then
								if (skip_short_body (l_sock, l_contlen)) then
									from
									until
										js.loop_done
									loop
										if not l_keep_alive then
											if pconn_active then
												if l_sock = pconn.item.socket then
													invalidate_persistent
												else
													connect_inst.fd_close (l_sock)
													l_sock := -1
												end
											else
												connect_inst.fd_close (l_sock)
												l_sock := -1
											end
										end
										js.break
									end
								else
									l_pos := -1 + 17 -- goto _L___2
								end
							else
								l_pos := -1 + 17 -- goto _L___2
							end
				when 16 then -- if block done, skip else block:
							l_pos := -1 + 18
				when 17 then -- else: | _L___2:
							from
							until
								js.loop_done
							loop
								if pconn_active then
									if l_sock = pconn.item.socket then
										invalidate_persistent
									else
										connect_inst.fd_close (l_sock)
									end
								else
									connect_inst.fd_close (l_sock)
								end
								l_sock := -1
								js.break
							end
				when 18 then
							pconn.item.authorized := (0).to_boolean
							if l_auth_finished.item then
								l_pos := -1 + 35 -- skip if block
							end
				when 19 then -- if:
							if (l_user.item).is_void then
								l_pos := -1 + 35 -- skip if block
							end
				when 20 then -- if:
							if (l_passwd.item).is_void then
								l_pos := -1 + 35 -- skip if block
							end
				when 21 then -- if:
							l_www_authenticate.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							l_wapos := 0
							from
							until
								js.loop_done
							loop
								l_wapos := resp_header_locate (l_resp, ce_string ("WWW-Authenticate"), l_wapos, l_wabeg, l_waend)
								if l_wapos = -1 then
									js.break
								end
								if not js.loop_jumped then
									if (known_authentication_scheme_p (l_wabeg.item, l_waend.item)) then
										from
										until
											js.loop_done
										loop
											l_BTA_beg___0 := l_wabeg.item
											l_BTA_len___0 := (l_waend.item).distance (l_BTA_beg___0)
											l_BTA_dest___0 := l_www_authenticate
											l_BTA_dest___0.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_BTA_len___0 + 1).to_natural_32)))
											memcpy (create {CE_POINTER [ANY]}.make_cast (l_BTA_dest___0.item), create {CE_POINTER [ANY]}.make_cast (l_BTA_beg___0), l_BTA_len___0.to_natural_32).do_nothing
											l_BTA_dest___0.item[l_BTA_len___0] := (('%/0/').code).to_integer_8
											js.break
										end
										js.break
									end
								end
								if not js.loop_jumped then
									l_wapos := l_wapos + 1
								end
							end
							if (not (l_www_authenticate.item).is_void) then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if:
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Unknown authentication scheme.%N"))))
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 35
				when 24 then -- else:
							if l_basic_auth_finished then
								l_pos := -1 + 27 -- skip if block
							end
				when 25 then -- if:
							l_pos := -1 + 28 -- goto _L___5
				when 26 then -- if block done, skip else block:
							l_pos := -1 + 35
				when 27 then -- else:
							if not ((strncasecmp (l_www_authenticate.item, ce_string ("Basic"), (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
								l_pos := -1 + 34 -- skip if block
							end
				when 28 then -- if: | _L___5:
							l_pth := url_inst.url_full_path (a_u)
							request_set_header (l_req, ce_string ("Authorization"), (create_authorization_line (l_www_authenticate.item, l_user.item, l_passwd.item, (request_method (l_req)), l_pth, l_auth_finished)), {PC_RP}.rel_value)
							if not ((strncasecmp (l_www_authenticate.item, ce_string ("NTLM"), (("NTLM").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
								l_pos := -1 + 31 -- skip if block
							end
				when 29 then -- if: | _L___3:
							if (a_u.item.user).is_void then
								if not (strncasecmp (l_www_authenticate.item, ce_string ("Basic"), (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
									if (c_ctype_inst.c2_isspace ((l_www_authenticate.item[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)) then
										register_basic_auth_host (a_u.item.host)
									elseif not (l_www_authenticate.item[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_boolean then
										register_basic_auth_host (a_u.item.host)
									end
								end
							end
				when 30 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 31 then -- else:
							if (c_ctype_inst.c2_isspace ((l_www_authenticate.item[((("NTLM").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)) then
								l_ntlm_seen := (1).to_boolean
							elseif not (l_www_authenticate.item[((("NTLM").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_boolean then
								l_ntlm_seen := (1).to_boolean
							else
								l_pos := -1 + 29 -- goto _L___3
							end
				when 32 then
							free (create {CE_POINTER [ANY]}.make_cast (l_pth))
							if (not (l_message.item).is_void) then
								free (create {CE_POINTER [ANY]}.make_cast (l_message.item))
							end
							resp_free (l_resp)
							free (create {CE_POINTER [ANY]}.make_cast (l_head))
							l_pos := -1 + 6 -- goto retry_with_auth
				when 33 then -- if block done, skip else block:
							l_pos := -1 + 35
				when 34 then -- else:
							if not (c_ctype_inst.c2_isspace ((l_www_authenticate.item[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)) then
								if (l_www_authenticate.item[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_boolean then
									l_pos := -1 + 28 -- goto _L___5
								end
							end
				when 35 then -- if done | if done | if done | if done | if done
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Authorization failed.%N"))))
							request_free (l_req)
							if (not (l_message.item).is_void) then
								free (create {CE_POINTER [ANY]}.make_cast (l_message.item))
							end
							resp_free (l_resp)
							free (create {CE_POINTER [ANY]}.make_cast (l_head))
							Result := ({PC_UERR_T}.AUTHFAILED)
							js.return
				when 36 then -- if block done, skip else block:
							l_pos := -1 + 38
				when 37 then -- else:
							if l_ntlm_seen then
								pconn.item.authorized := (1).to_boolean
							end
				when 38 then -- if done | if done
							if js.return_called then
								l_pos := -1 + 45 -- skip if block
							end
				when 39 then -- if:
								if (a_hs.item.local_file).is_void then
									if not options_inst.opt.item.content_disposition then
										a_hs.item.local_file := url_inst.url_file_name (a_u)
									elseif (resp_header_copy (l_resp, ce_string ("Content-Disposition"), l_hdrval, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)) then
										if not (parse_content_disposition (l_hdrval, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (a_hs.c_pointer + (create {PD_HTTP_STAT}.make).offset_of ("local_file")))) then
											a_hs.item.local_file := url_inst.url_file_name (a_u)
										end
									else
										a_hs.item.local_file := url_inst.url_file_name (a_u)
									end
								end
								if a_hs.item.existence_checked then
									l_pos := -1 + 45 -- skip if block
								end
				when 40 then -- if:
								if not (utils_inst.file_exists_p (a_hs.item.local_file)) then
									l_pos := -1 + 45 -- skip if block
								end
				when 41 then -- if:
								if not (options_inst.opt.item.noclobber) then
									l_pos := -1 + 44 -- skip if block
								end
				when 42 then -- if:
								if (options_inst.opt.item.output_document).is_void then
									l_tmp___59 := quote_inst.quote (a_hs.item.local_file)
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("File %%s already there; not retrieving.%N%N"))), l_tmp___59])
									a_dt.item := (a_dt.item).bit_or ((2))
									if (utils_inst.has_html_suffix_p (a_hs.item.local_file)) then
										a_dt.item := (a_dt.item).bit_or ((1))
									end
									free (create {CE_POINTER [ANY]}.make_cast (l_head))
									if (not (l_message.item).is_void) then
										free (create {CE_POINTER [ANY]}.make_cast (l_message.item))
									end
									Result := ({PC_UERR_T}.RETRUNNEEDED)
									js.return
								else
									l_pos := -1 + 44 -- goto _L___6
								end
				when 43 then -- if block done, skip else block:
								l_pos := -1 + 45
				when 44 then -- else: | _L___6:
								if not options_inst.opt.item.noclobber then
									if not options_inst.opt.item.always_rest then
										if not options_inst.opt.item.timestamping then
											if not options_inst.opt.item.dirstruct then
												if (options_inst.opt.item.output_document).is_void then
													l_unique := (utils_inst.unique_name (a_hs.item.local_file, (1).to_boolean))
													if not l_unique.is_equal (a_hs.item.local_file) then
														free (create {CE_POINTER [ANY]}.make_cast (a_hs.item.local_file))
													end
													a_hs.item.local_file := l_unique
												end
											end
										end
									end
								end
				when 45 then -- if done | if done | if done
								if js.return_called then
									l_pos := -1 + 67 -- skip if block
								end
				when 46 then -- if:
									a_hs.item.existence_checked := (1).to_boolean
									if options_inst.opt.item.timestamping then
										if not a_hs.item.timestamp_checked then
											l_filename_len := (strlen (a_hs.item.local_file))
											l_filename_plus_orig_suffix := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (l_filename_len + ((".orig").count + 1).to_natural_32)))
											l_local_dot_orig_file_exists := (0).to_boolean
											l_local_filename := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
											if options_inst.opt.item.backup_converted then
												memcpy (create {CE_POINTER [ANY]}.make_cast (l_filename_plus_orig_suffix), create {CE_POINTER [ANY]}.make_cast (a_hs.item.local_file), l_filename_len).do_nothing
												memcpy (create {CE_POINTER [ANY]}.make_cast ((l_filename_plus_orig_suffix + l_filename_len.to_integer_32)), create {CE_POINTER [ANY]}.make_cast (ce_string (".orig")), ((".orig").count + 1).to_natural_32).do_nothing
												if (stat (l_filename_plus_orig_suffix, l_st)) = 0 then
													l_local_dot_orig_file_exists := (1).to_boolean
													l_local_filename := l_filename_plus_orig_suffix
												end
											end
											if not l_local_dot_orig_file_exists then
												if (stat (a_hs.item.local_file, l_st)) = 0 then
													l_local_filename := a_hs.item.local_file
												end
											end
											if not l_local_filename.is_void then
												a_hs.item.orig_file_name := xmalloc_inst.xstrdup (l_local_filename)
												a_hs.item.orig_file_size := (l_st.item.st_size).to_integer_64
												a_hs.item.orig_file_tstamp := l_st.item.st_mtim.tv_sec
											end
										end
									end
									request_free (l_req)
									a_hs.item.statcode := l_statcode
									if l_statcode = -1 then
										a_hs.item.error := xmalloc_inst.xstrdup ((gettext (ce_string ("Malformed status line"))))
									elseif not (l_message.item[0]).to_boolean then
										a_hs.item.error := xmalloc_inst.xstrdup ((gettext (ce_string ("(no description)"))))
									else
										a_hs.item.error := xmalloc_inst.xstrdup (l_message.item)
									end
									if (not (l_message.item).is_void) then
										free (create {CE_POINTER [ANY]}.make_cast (l_message.item))
									end
									l_type := resp_header_strdup (l_resp, ce_string ("Content-Type"))
									if (not l_type.is_void) then
										l_tmp___70 := (strchr (l_type, (';').code))
										if (not l_tmp___70.is_void) then
											l_tmp2 := l_tmp___70 + 1
											from
											until
												js.loop_done
											loop
												if (l_tmp___70.c_pointer.to_integer_32).to_natural_32 > (l_type.c_pointer.to_integer_32).to_natural_32 then
													if not (c_ctype_inst.c2_isspace ((l_tmp___70[-1]).to_integer_32)) then
														js.break
													end
												else
													js.break
												end
												if not js.loop_jumped then
													l_tmp___70 := l_tmp___70 - 1
												end
											end
											l_tmp___70[0] := (('%/0/').code).to_integer_8
											if options_inst.opt.item.enable_iri then
												if (options_inst.opt.item.encoding_remote).is_void then
													l_tmp___70 := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
												end
											end
										end
									end
									a_hs.item.newloc := resp_header_strdup (l_resp, ce_string ("Location"))
									a_hs.item.remote_time := resp_header_strdup (l_resp, ce_string ("Last-Modified"))
									if (resp_header_copy (l_resp, ce_string ("Content-Range"), l_hdrval, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)) then
										if (parse_content_range (l_hdrval, l_first_byte_pos, l_last_byte_pos, l_entity_length)) then
											l_contrange := l_first_byte_pos.item
											l_contlen := (l_last_byte_pos.item - l_first_byte_pos.item) + {INTEGER_64} 1
										end
									end
									resp_free (l_resp)
									if l_statcode >= 200 then
										if l_statcode < 300 then
											a_dt.item := (a_dt.item).bit_or ((2))
										end
									end
									if l_statcode /= 301 then
										l_pos := -1 + 49 -- skip if block
									end
				when 47 then -- if:
									l_pos := -1 + 59 -- goto _L___10
				when 48 then -- if block done, skip else block:
									l_pos := -1 + 67
				when 49 then -- else:
									if l_statcode /= 302 then
										l_pos := -1 + 52 -- skip if block
									end
				when 50 then -- if:
									l_pos := -1 + 59 -- goto _L___10
				when 51 then -- if block done, skip else block:
									l_pos := -1 + 67
				when 52 then -- else:
									if l_statcode /= 303 then
										l_pos := -1 + 55 -- skip if block
									end
				when 53 then -- if:
									l_pos := -1 + 59 -- goto _L___10
				when 54 then -- if block done, skip else block:
									l_pos := -1 + 67
				when 55 then -- else:
									if l_statcode /= 307 then
										l_pos := -1 + 58 -- skip if block
									end
				when 56 then -- if:
									l_pos := -1 + 59 -- goto _L___10
				when 57 then -- if block done, skip else block:
									l_pos := -1 + 67
				when 58 then -- else:
									if l_statcode /= 300 then
										l_pos := -1 + 67 -- skip if block
									end
				when 59 then -- if: | _L___10:
									if l_statcode /= 300 then
										l_pos := -1 + 62 -- skip if block
									end
				when 60 then -- if:
									if (a_hs.item.newloc).is_void then
										a_dt.item := (a_dt.item).bit_or ((2))
									else
										l_pos := -1 + 62 -- goto _L___9
									end
				when 61 then -- if block done, skip else block:
									l_pos := -1 + 67
				when 62 then -- else: | _L___9:
									if (not (a_hs.item.newloc).is_void) then
										l_tmp___76 := (gettext (ce_string (" [following]")))
									else
										l_tmp___76 := ce_string ("")
									end
									if (not (a_hs.item.newloc).is_void) then
										l_tmp___79 := (log_inst.escnonprint_uri (a_hs.item.newloc))
									else
										l_tmp___79 := (gettext (ce_string ("unspecified")))
									end
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Location: %%s%%s%N"))), l_tmp___79, l_tmp___76])
									if not l_keep_alive then
										l_pos := -1 + 65 -- skip if block
									end
				when 63 then -- if:
									if not l_head_only then
										if (skip_short_body (l_sock, l_contlen)) then
											from
											until
												js.loop_done
											loop
												if not l_keep_alive then
													if pconn_active then
														if l_sock = pconn.item.socket then
															invalidate_persistent
														else
															connect_inst.fd_close (l_sock)
															l_sock := -1
														end
													else
														connect_inst.fd_close (l_sock)
														l_sock := -1
													end
												end
												js.break
											end
										else
											l_pos := -1 + 65 -- goto _L___8
										end
									else
										l_pos := -1 + 65 -- goto _L___8
									end
				when 64 then -- if block done, skip else block:
									l_pos := -1 + 66
				when 65 then -- else: | _L___8:
									from
									until
										js.loop_done
									loop
										if pconn_active then
											if l_sock = pconn.item.socket then
												invalidate_persistent
											else
												connect_inst.fd_close (l_sock)
											end
										else
											connect_inst.fd_close (l_sock)
										end
										l_sock := -1
										js.break
									end
				when 66 then
									if (not l_type.is_void) then
										free (create {CE_POINTER [ANY]}.make_cast (l_type))
									end
									free (create {CE_POINTER [ANY]}.make_cast (l_head))
									Result := ({PC_UERR_T}.NEWLOCATION)
									js.return
				when 67 then -- if done | if done | if done | if done | if done | if done
									if js.return_called then
										l_pos := -1 + 76 -- skip if block
									end
				when 68 then -- if:
										if l_type.is_void then
											a_dt.item := (a_dt.item).bit_or ((1))
										elseif 0 = (strncasecmp (l_type, ce_string ("text/html"), (strlen (ce_string ("text/html"))))) then
											a_dt.item := (a_dt.item).bit_or ((1))
										elseif 0 = (strncasecmp (l_type, ce_string ("application/xhtml+xml"), (strlen (ce_string ("application/xhtml+xml"))))) then
											a_dt.item := (a_dt.item).bit_or ((1))
										else
											a_dt.item := (a_dt.item).bit_and ((-2))
										end
										if (not l_type.is_void) then
											if 0 = (strncasecmp (l_type, ce_string ("text/css"), (strlen (ce_string ("text/css"))))) then
												a_dt.item := (a_dt.item).bit_or ((64))
											else
												a_dt.item := (a_dt.item).bit_and ((-65))
											end
										else
											a_dt.item := (a_dt.item).bit_and ((-65))
										end
										if options_inst.opt.item.adjust_extension then
											if ((a_dt.item).bit_and (1)).to_boolean then
												ensure_extension (a_hs, ce_string (".html"), a_dt)
											elseif ((a_dt.item).bit_and (64)).to_boolean then
												ensure_extension (a_hs, ce_string (".css"), a_dt)
											end
										end
										if l_statcode /= 416 then
											l_pos := -1 + 71 -- skip if block
										end
				when 69 then -- if:
										l_pos := -1 + 75 -- goto _L___11
				when 70 then -- if block done, skip else block:
										l_pos := -1 + 76
				when 71 then -- else:
										if not (a_hs.item.restval > {INTEGER_64} 0) then
											l_pos := -1 + 76 -- skip if block
										end
				when 72 then -- if:
										if l_statcode /= 200 then
											l_pos := -1 + 76 -- skip if block
										end
				when 73 then -- if:
										if l_contrange /= {INTEGER_64} 0 then
											l_pos := -1 + 76 -- skip if block
										end
				when 74 then -- if:
										if not (a_hs.item.restval >= l_contlen) then
											l_pos := -1 + 76 -- skip if block
										end
				when 75 then -- if: | _L___11:
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%N    The file is already fully retrieved; nothing to do.%N%N"))))
										a_hs.item.len := l_contlen
										a_hs.item.res := 0
										a_dt.item := (a_dt.item).bit_or ((2))
										if (not l_type.is_void) then
											free (create {CE_POINTER [ANY]}.make_cast (l_type))
										end
										from
										until
											js.loop_done
										loop
											if pconn_active then
												if l_sock = pconn.item.socket then
													invalidate_persistent
												else
													connect_inst.fd_close (l_sock)
												end
											else
												connect_inst.fd_close (l_sock)
											end
											l_sock := -1
											js.break
										end
										free (create {CE_POINTER [ANY]}.make_cast (l_head))
										Result := ({PC_UERR_T}.RETRUNNEEDED)
										js.return
				when 76 then -- if done | if done | if done | if done | if done
										if js.return_called then
											l_pos := -1 + 83 -- skip if block
										end
				when 77 then -- if:
											if l_contrange = {INTEGER_64} 0 then
												l_pos := -1 + 80 -- skip if block
											end
				when 78 then -- if:
											if l_contrange /= a_hs.item.restval then
												l_pos := -1 + 82 -- goto _L___12
											else
												l_pos := -1 + 80 -- goto _L___13
											end
				when 79 then -- if block done, skip else block:
											l_pos := -1 + 83
				when 80 then -- else: | _L___13:
											if l_statcode /= 206 then
												l_pos := -1 + 83 -- skip if block
											end
				when 81 then -- if:
											if l_contrange.to_boolean then
												l_pos := -1 + 83 -- skip if block
											end
				when 82 then -- if: | _L___12:
											if (not l_type.is_void) then
												free (create {CE_POINTER [ANY]}.make_cast (l_type))
											end
											from
											until
												js.loop_done
											loop
												if pconn_active then
													if l_sock = pconn.item.socket then
														invalidate_persistent
													else
														connect_inst.fd_close (l_sock)
													end
												else
													connect_inst.fd_close (l_sock)
												end
												l_sock := -1
												js.break
											end
											free (create {CE_POINTER [ANY]}.make_cast (l_head))
											Result := ({PC_UERR_T}.RANGEERR)
											js.return
				when 83 then -- if done | if done | if done
											if js.return_called then
												l_pos := -1 + 96 -- skip if block
											end
				when 84 then -- if:
												if l_contlen = -{INTEGER_64} 1 then
													a_hs.item.contlen := (-1).to_integer_64
												else
													a_hs.item.contlen := l_contlen + l_contrange
												end
												if (options_inst.opt.item.verbose).to_boolean then
													if ((a_dt.item).bit_and (2)).to_boolean then
														log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Length: "))))
														if l_contlen /= -{INTEGER_64} 1 then
															log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (utils_inst.number_to_static_string (l_contlen + l_contrange)))
															if l_contlen + l_contrange >= {INTEGER_64} 1_024 then
																log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" (%%s)"), (utils_inst.human_readable (l_contlen + l_contrange))])
															end
															if l_contrange.to_boolean then
																if l_contlen >= {INTEGER_64} 1_024 then
																	l_tmp___92 := utils_inst.human_readable (l_contlen)
																	l_tmp___93 := utils_inst.number_to_static_string (l_contlen)
																	log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string (", %%s (%%s) remaining"))), l_tmp___93, l_tmp___92])
																else
																	l_tmp___95 := utils_inst.number_to_static_string (l_contlen)
																	log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string (", %%s remaining"))), l_tmp___95])
																end
															end
														else
															if options_inst.opt.item.ignore_length then
																l_tmp___99 := (gettext (ce_string ("ignored")))
															else
																l_tmp___99 := (gettext (ce_string ("unspecified")))
															end
															log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___99)
														end
														if (not l_type.is_void) then
															log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" [%%s]%N"), (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_type))])
														else
															log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
														end
													end
												end
												if (not l_type.is_void) then
													free (create {CE_POINTER [ANY]}.make_cast (l_type))
												end
												l_type := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
												if ((a_dt.item).bit_and (2)).to_boolean then
													l_pos := -1 + 87 -- skip if block
												end
				when 85 then -- if:
												l_pos := -1 + 88 -- goto _L___15
				when 86 then -- if block done, skip else block:
												l_pos := -1 + 96
				when 87 then -- else:
												if not l_head_only then
													l_pos := -1 + 96 -- skip if block
												end
				when 88 then -- if: | _L___15:
												a_hs.item.len := (0).to_integer_64
												a_hs.item.res := 0
												if (not l_type.is_void) then
													free (create {CE_POINTER [ANY]}.make_cast (l_type))
												end
												if not l_head_only then
													l_pos := -1 + 91 -- skip if block
												end
				when 89 then -- if:
												from
												until
													js.loop_done
												loop
													if not l_keep_alive then
														if pconn_active then
															if l_sock = pconn.item.socket then
																invalidate_persistent
															else
																connect_inst.fd_close (l_sock)
																l_sock := -1
															end
														else
															connect_inst.fd_close (l_sock)
															l_sock := -1
														end
													end
													js.break
												end
				when 90 then -- if block done, skip else block:
												l_pos := -1 + 95
				when 91 then -- else:
												if not l_keep_alive then
													l_pos := -1 + 94 -- skip if block
												end
				when 92 then -- if:
												if (skip_short_body (l_sock, l_contlen)) then
													from
													until
														js.loop_done
													loop
														if not l_keep_alive then
															if pconn_active then
																if l_sock = pconn.item.socket then
																	invalidate_persistent
																else
																	connect_inst.fd_close (l_sock)
																	l_sock := -1
																end
															else
																connect_inst.fd_close (l_sock)
																l_sock := -1
															end
														end
														js.break
													end
												else
													l_pos := -1 + 94 -- goto _L___14
												end
				when 93 then -- if block done, skip else block:
												l_pos := -1 + 95
				when 94 then -- else: | _L___14:
												from
												until
													js.loop_done
												loop
													if pconn_active then
														if l_sock = pconn.item.socket then
															invalidate_persistent
														else
															connect_inst.fd_close (l_sock)
														end
													else
														connect_inst.fd_close (l_sock)
													end
													l_sock := -1
													js.break
												end
				when 95 then -- if done
												free (create {CE_POINTER [ANY]}.make_cast (l_head))
												Result := ({PC_UERR_T}.RETRFINISHED)
												js.return
				when 96 then -- if done | if done
												if not js.return_called then
													if retr_inst.output_stream.is_void then
														url_inst.mkalldirs (a_hs.item.local_file).do_nothing
														if options_inst.opt.item.backups then
															retr_inst.rotate_backups (a_hs.item.local_file)
														end
														if (a_hs.item.restval).to_boolean then
															l_fp := fopen (a_hs.item.local_file, ce_string ("ab"))
														elseif options_inst.opt.item.noclobber then
															l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
														elseif options_inst.opt.item.always_rest then
															l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
														elseif options_inst.opt.item.timestamping then
															l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
														elseif options_inst.opt.item.dirstruct then
															l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
														elseif (not (options_inst.opt.item.output_document).is_void) then
															l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
														else
															l_fp := utils_inst.fopen_excl (a_hs.item.local_file, 1)
															if l_fp.is_void then
																if (errno_location).item = 17 then
																	log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s has sprung into existence.%N"))), a_hs.item.local_file])
																	from
																	until
																		js.loop_done
																	loop
																		if pconn_active then
																			if l_sock = pconn.item.socket then
																				invalidate_persistent
																			else
																				connect_inst.fd_close (l_sock)
																			end
																		else
																			connect_inst.fd_close (l_sock)
																		end
																		l_sock := -1
																		js.break
																	end
																	free (create {CE_POINTER [ANY]}.make_cast (l_head))
																	Result := ({PC_UERR_T}.FOPEN_EXCL_ERR)
																	js.return
																end
															end
														end
														if not js.return_called and then (l_fp.is_void) then
															log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_hs.item.local_file, (strerror ((errno_location).item))])
															from
															until
																js.loop_done
															loop
																if pconn_active then
																	if l_sock = pconn.item.socket then
																		invalidate_persistent
																	else
																		connect_inst.fd_close (l_sock)
																	end
																else
																	connect_inst.fd_close (l_sock)
																end
																l_sock := -1
																js.break
															end
															free (create {CE_POINTER [ANY]}.make_cast (l_head))
															Result := ({PC_UERR_T}.FOPENERR)
															js.return
														end
													else
														l_fp := retr_inst.output_stream
													end
												end
												if not js.return_called then
													if (options_inst.opt.item.verbose).to_boolean then
														if ((a_hs.item.local_file).item).to_integer_32 = 45 then
															if not (a_hs.item.local_file[1]).to_boolean then
																l_tmp___108 := (quote_inst.quote (ce_string ("STDOUT")))
															else
																l_tmp___107 := quote_inst.quote (a_hs.item.local_file)
																l_tmp___108 := l_tmp___107
															end
														else
															l_tmp___107 := quote_inst.quote (a_hs.item.local_file)
															l_tmp___108 := l_tmp___107
														end
														log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Saving to: %%s%N"))), l_tmp___108])
													end
													if options_inst.opt.item.save_headers then
														if a_hs.item.restval = {INTEGER_64} 0 then
															fwrite (create {CE_POINTER [ANY]}.make_cast (l_head), (1).to_natural_32, (strlen (l_head)), l_fp).do_nothing
														end
													end
													free (create {CE_POINTER [ANY]}.make_cast (l_head))
													l_flags := 0
													if l_contlen /= -{INTEGER_64} 1 then
														l_flags := (l_flags).bit_or ((1))
													end
													if a_hs.item.restval > {INTEGER_64} 0 then
														if l_contrange = {INTEGER_64} 0 then
															l_flags := (l_flags).bit_or ((2))
														end
													end
													a_hs.item.len := a_hs.item.restval
													a_hs.item.rd_size := (0).to_integer_64
													if l_contlen /= -{INTEGER_64} 1 then
														l_tmp___111 := l_contlen
													else
														l_tmp___111 := (0).to_integer_64
													end
													a_hs.item.res := retr_inst.fd_read_body (l_sock, l_fp, l_tmp___111, a_hs.item.restval, create {CE_POINTER [INTEGER_64]}.make_shared (a_hs.c_pointer + (create {PD_HTTP_STAT}.make).offset_of ("rd_size")), create {CE_POINTER [INTEGER_64]}.make_shared (a_hs.c_pointer + (create {PD_HTTP_STAT}.make).offset_of ("len")), create {CE_POINTER [REAL_64]}.make_shared (a_hs.c_pointer + (create {PD_HTTP_STAT}.make).offset_of ("dltime")), l_flags)
													if a_hs.item.res >= 0 then
														from
														until
															js.loop_done
														loop
															if not l_keep_alive then
																if pconn_active then
																	if l_sock = pconn.item.socket then
																		invalidate_persistent
																	else
																		connect_inst.fd_close (l_sock)
																		l_sock := -1
																	end
																else
																	connect_inst.fd_close (l_sock)
																	l_sock := -1
																end
															end
															js.break
														end
													else
														if a_hs.item.res < 0 then
															a_hs.item.rderrmsg := xmalloc_inst.xstrdup ((connect_inst.fd_errstr (l_sock)))
														end
														from
														until
															js.loop_done
														loop
															if pconn_active then
																if l_sock = pconn.item.socket then
																	invalidate_persistent
																else
																	connect_inst.fd_close (l_sock)
																end
															else
																connect_inst.fd_close (l_sock)
															end
															l_sock := -1
															js.break
														end
													end
													if retr_inst.output_stream.is_void then
														fclose (l_fp).do_nothing
													end
													if a_hs.item.res = -2 then
														Result := ({PC_UERR_T}.FWRITEERR)
														js.return
													end
												end
												if not js.return_called then
													Result := ({PC_UERR_T}.RETRFINISHED)
												end
				when 97 then
												l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
									end

	http_atotm (a_time_string: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_oldlocale: CE_POINTER [INTEGER_8]
			l_savedlocale: CE_ARRAY [INTEGER_8]
			l_i: NATURAL_32
			l_ret: INTEGER_32
			l_l: NATURAL_32
			l_t: CE_ARRAY [SD_TM]
			js: JUMP_STATE
		do
			create l_oldlocale.make
			create l_savedlocale.make (<<256>>)
			create l_t.make (<<1>>)

			l_ret := (-1).to_integer_32
			l_oldlocale := (setlocale (2, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))
			if (not l_oldlocale.is_void) then
				l_l := (strlen (l_oldlocale))
				if l_l >= ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32) then
					l_savedlocale[0] := (('%/0/').code).to_integer_8
				else
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_savedlocale), create {CE_POINTER [ANY]}.make_cast (l_oldlocale), l_l).do_nothing
				end
			else
				l_savedlocale[0] := (('%/0/').code).to_integer_8
			end
			setlocale (2, ce_string ("C")).do_nothing
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < ({PLATFORM}.Pointer_bytes.to_natural_32 * (4).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32))
			loop
				memset (create {CE_POINTER [ANY]}.make_cast (l_t), ('%/0/').code, (create {SD_TM}.make).structure_size.to_natural_32).do_nothing
				if (check_end ((strptime (a_time_string, time_formats[l_i.to_integer_32], l_t)))) then
					l_ret := timegm (l_t)
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			if (l_savedlocale[0]).to_boolean then
				setlocale (2, l_savedlocale).do_nothing
			end
			Result := l_ret
		end

	http_cleanup
		do
			if (not (pconn.item.host).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (pconn.item.host))
			end
			if (not wget_cookie_jar.is_void) then
				cookies_inst.cookie_jar_delete (wget_cookie_jar)
			end
		end

	http_loop (a_u: CE_POINTER [PD_URL]; a_newloc: CE_POINTER [CE_POINTER [INTEGER_8]]; a_local_file: CE_POINTER [CE_POINTER [INTEGER_8]]; a_referer: CE_POINTER [INTEGER_8]; a_dt: CE_POINTER [INTEGER_32]; a_proxy: CE_POINTER [PD_URL]; a_iri: CE_POINTER [PD_IRI]): NATURAL_32
		local
			l_count: INTEGER_32
			l_got_head: BOOLEAN
			l_time_came_from_head: BOOLEAN
			l_got_name: BOOLEAN
			l_tms: CE_POINTER [INTEGER_8]
			l_tmrate: CE_POINTER [INTEGER_8]
			l_err: NATURAL_32
			l_ret: NATURAL_32
			l_tmr: INTEGER_32
			l_hstat: CE_ARRAY [PD_HTTP_STAT]
			l_st: CE_ARRAY [SD_STAT]
			l_send_head_first: BOOLEAN
			l_file_name: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_hurl: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_ARRAY [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_hurl___0: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___25: CE_POINTER [INTEGER_8]
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: CE_POINTER [INTEGER_8]
			l_finished: BOOLEAN
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_fl: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_newtmr: INTEGER_32
			l_write_to_stdout: BOOLEAN
			l_tmp___37: INTEGER_32
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___45: CE_POINTER [INTEGER_8]
			l_write_to_stdout___0: BOOLEAN
			l_tmp___47: INTEGER_32
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_tmp___50: CE_POINTER [INTEGER_8]
			l_tmp___53: CE_POINTER [INTEGER_8]
			l_tmp___55: CE_POINTER [INTEGER_8]
			l_tmp___57: CE_POINTER [INTEGER_8]
			l_tmp___59: CE_POINTER [INTEGER_8]
			l_tmp___60: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tms.make
			create l_tmrate.make
			create l_hstat.make (<<1>>)
			create l_st.make (<<1>>)
			create l_file_name.make
			create l_tmp.make
			create l_tmp___2.make
			create l_hurl.make
			create l_tmp___10.make (<<256>>)
			create l_tmp___15.make
			create l_tmp___16.make
			create l_hurl___0.make
			create l_tmp___21.make
			create l_tmp___22.make
			create l_tmp___25.make
			create l_tmp___26.make
			create l_tmp___27.make
			create l_tmp___35.make
			create l_fl.make (<<1>>)
			create l_tmp___38.make
			create l_tmp___39.make
			create l_tmp___41.make
			create l_tmp___44.make
			create l_tmp___45.make
			create l_tmp___48.make
			create l_tmp___50.make
			create l_tmp___53.make
			create l_tmp___55.make
			create l_tmp___57.make
			create l_tmp___59.make
			create l_tmp___60.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_got_head := (0).to_boolean
					l_time_came_from_head := (0).to_boolean
					l_got_name := (0).to_boolean
					l_ret := {PC_UERR_T}.TRYLIMEXC
					l_tmr := (-1).to_integer_32
					l_send_head_first := (1).to_boolean
					if not (a_local_file.is_void) then
						if not ((a_local_file.item).is_void) then
							assert_fail (ce_string ("local_file == ((void *)0) || *local_file == ((void *)0)"), ce_string ("http.c"), {NATURAL_32} 2_430, ce_string ("http_loop"))
						end
					end
					if (not a_local_file.is_void) then
						if (not (options_inst.opt.item.output_document).is_void) then
							if ((options_inst.opt.item.output_document).item).to_integer_32 = 45 then
								if not (options_inst.opt.item.output_document[1]).to_boolean then
									a_local_file.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
								else
									l_tmp := xmalloc_inst.xstrdup (options_inst.opt.item.output_document)
									a_local_file.item := l_tmp
								end
							else
								l_tmp := xmalloc_inst.xstrdup (options_inst.opt.item.output_document)
								a_local_file.item := l_tmp
							end
						end
					end
					a_newloc.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					if options_inst.opt.item.cookies then
						load_cookies
					end
					if options_inst.opt.item.ftp_glob then
						if (utils_inst.has_wildcards_p (a_u.item.path)) then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Warning: wildcards not supported in HTTP.%N"))))
						end
					end
					memset (create {CE_POINTER [ANY]}.make_cast (l_hstat), ('%/0/').code, (create {PD_HTTP_STAT}.make).structure_size.to_natural_32).do_nothing
					l_hstat.item.referer := a_referer
					if (not (options_inst.opt.item.output_document).is_void) then
						l_hstat.item.local_file := xmalloc_inst.xstrdup (options_inst.opt.item.output_document)
						l_got_name := (1).to_boolean
					elseif not options_inst.opt.item.content_disposition then
						l_hstat.item.local_file := url_inst.url_file_name (a_u)
						l_got_name := (1).to_boolean
					end
					if l_got_name then
						if (utils_inst.file_exists_p (l_hstat.item.local_file)) then
							if options_inst.opt.item.noclobber then
								if (options_inst.opt.item.output_document).is_void then
									l_tmp___2 := quote_inst.quote (l_hstat.item.local_file)
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("File %%s already there; not retrieving.%N%N"))), l_tmp___2])
									a_dt.item := (a_dt.item).bit_or ((2))
									if (utils_inst.has_html_suffix_p (l_hstat.item.local_file)) then
										a_dt.item := (a_dt.item).bit_or ((1))
									end
									l_ret := {PC_UERR_T}.RETROK
									l_pos := -1 + 52 -- goto exit
								end
							end
						end
					end
				when 1 then
					l_count := 0
					a_dt.item := 0
					if not options_inst.opt.item.spider then
						if l_got_name then
							l_send_head_first := (0).to_boolean
						elseif not options_inst.opt.item.content_disposition then
							l_send_head_first := (0).to_boolean
						end
					end
					l_file_name := url_inst.url_file_name (a_u)
					if options_inst.opt.item.timestamping then
						if not options_inst.opt.item.content_disposition then
							if (utils_inst.file_exists_p (l_file_name)) then
								l_send_head_first := (1).to_boolean
							end
						end
					end
					free (create {CE_POINTER [ANY]}.make_cast (l_file_name))
				when 2 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 52 -- skip loop
					end
				when 3 then -- loop body:
						l_count := l_count + 1
						retr_inst.sleep_between_retrievals (l_count)
						l_tms := utils_inst.datetime_str ((time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
						if options_inst.opt.item.spider then
							if not l_got_head then
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Spider mode enabled. Check if remote file exists.%N")))])
							end
						end
						if (options_inst.opt.item.verbose).to_boolean then
							l_hurl := (url_inst.url_string (a_u, {PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD))
							if l_count > 1 then
								sprintf ([l_tmp___10, (gettext (ce_string ("(try:%%2d)"))), l_count]).do_nothing
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("--%%s--  %%s  %%s%N"), l_tms, l_tmp___10, l_hurl])
							else
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("--%%s--  %%s%N"), l_tms, l_hurl])
							end
							free (create {CE_POINTER [ANY]}.make_cast (l_hurl))
						end
						if l_send_head_first then
							if not l_got_head then
								a_dt.item := (a_dt.item).bit_or ((4))
							else
								a_dt.item := (a_dt.item).bit_and ((-5))
							end
						else
							a_dt.item := (a_dt.item).bit_and ((-5))
						end
						if not (options_inst.opt.item.always_rest) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_got_name then
							if (stat (l_hstat.item.local_file, l_st)) = 0 then
								if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 32_768 then
									l_hstat.item.restval := (l_st.item.st_size).to_integer_64
								else
									l_pos := -1 + 6 -- goto _L___1
								end
							else
								l_pos := -1 + 6 -- goto _L___1
							end
						else
							l_pos := -1 + 6 -- goto _L___1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___1:
						if l_count > 1 then
							l_hstat.item.restval := l_hstat.item.len
						else
							l_hstat.item.restval := (0).to_integer_64
						end
				when 7 then
						if a_proxy.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_count > 1 then
							a_dt.item := (a_dt.item).bit_or ((8))
						else
							l_pos := -1 + 10 -- goto _L___2
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___2:
						if not options_inst.opt.item.allow_cache then
							a_dt.item := (a_dt.item).bit_or ((8))
						else
							a_dt.item := (a_dt.item).bit_and ((-9))
						end
				when 11 then
						l_err := gethttp (a_u, l_hstat, a_dt, a_proxy, a_iri)
						l_tms := utils_inst.datetime_str ((time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
						if (not (l_hstat.item.newloc).is_void) then
							a_newloc.item := xmalloc_inst.xstrdup (l_hstat.item.newloc)
						end
						inspect l_err.to_integer_32 -- switch 1 head
						when 30 then l_pos := -1 + 12
						when 29 then l_pos := -1 + 12
						when 2 then l_pos := -1 + 12
						when 9 then l_pos := -1 + 12
						when 3 then l_pos := -1 + 12
						when 40 then l_pos := -1 + 12
						when 52 then l_pos := -1 + 12
						when 44 then l_pos := -1 + 12
						when 25 then l_pos := -1 + 12
						when 26 then l_pos := -1 + 13
						when 24 then l_pos := -1 + 13
						when 1 then l_pos := -1 + 14
						when 5 then l_pos := -1 + 14
						when 49 then l_pos := -1 + 14
						when 50 then l_pos := -1 + 14
						when 53 then l_pos := -1 + 14
						when 37 then l_pos := -1 + 14
						when 54 then l_pos := -1 + 14
						when 4 then l_pos := -1 + 15
						when 6 then l_pos := -1 + 16
						when 38 then l_pos := -1 + 17
						when 39 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 12 then -- switch 1, case 30 | switch 1, case 29 | switch 1, case 2 | switch 1, case 9 | switch 1, case 3 | switch 1, case 40 | switch 1, case 52 | switch 1, case 44 | switch 1, case 25
						retr_inst.printwhat (l_count, options_inst.opt.item.ntry)
						js.continue
				when 13 then -- switch 1, case 26 | switch 1, case 24
						if not js.loop_jumped then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							l_tmp___15 := strerror ((errno_location).item)
							l_tmp___16 := quote_inst.quote (l_hstat.item.local_file)
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot write to %%s (%%s).%N"))), l_tmp___16, l_tmp___15])
						end
				when 14 then -- switch 1, case 1 | switch 1, case 5 | switch 1, case 49 | switch 1, case 50 | switch 1, case 53 | switch 1, case 37 | switch 1, case 54
						if not js.loop_jumped then
							l_ret := l_err
							l_pos := -1 + 52 -- goto exit
						end
				when 15 then -- switch 1, case 4
						if not js.loop_jumped then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Unable to establish SSL connection.%N")))])
							l_ret := l_err
							l_pos := -1 + 52 -- goto exit
						end
				when 16 then -- switch 1, case 6
						if not js.loop_jumped then
							if (a_newloc.item).is_void then
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("ERROR: Redirection (%%d) without location.%N"))), l_hstat.item.statcode])
								l_ret := {PC_UERR_T}.WRONGCODE
							else
								l_ret := {PC_UERR_T}.NEWLOCATION
							end
							l_pos := -1 + 52 -- goto exit
						end
				when 17 then -- switch 1, case 38
						if not js.loop_jumped then
							l_ret := {PC_UERR_T}.RETROK
							l_pos := -1 + 52 -- goto exit
						end
				when 18 then -- switch 1, case 39
						l_pos := -1 + 20 -- switch 1; break
				when 19 then -- switch 1, default:
						abort
				when 20 then -- switch 1, done:
						if not (not js.loop_jumped and then (not ((a_dt.item).bit_and (2)).to_boolean)) then
							l_pos := -1 + 26 -- skip if block
						end
				when 21 then -- if:
						l_hurl___0 := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						if not (options_inst.opt.item.verbose).to_boolean then
							l_hurl___0 := url_inst.url_string (a_u, {PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD)
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, ce_string ("%%s:%N"), l_hurl___0])
						end
						if not (((a_dt.item).bit_and (4)).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_hstat.item.statcode = 500 then
							l_got_head := (1).to_boolean
							js.continue
						elseif l_hstat.item.statcode = 501 then
							l_got_head := (1).to_boolean
							js.continue
						else
							l_pos := -1 + 24 -- goto _L___3
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___3:
						if options_inst.opt.item.spider then
							if not a_iri.item.utf8_encode then
								if l_hurl___0.is_void then
									l_hurl___0 := url_inst.url_string (a_u, {PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD)
								end
								spider_inst.nonexisting_url (l_hurl___0)
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Remote file does not exist -- broken link!!!%N")))])
							else
								l_tmp___21 := quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_hstat.item.error)
								l_tmp___22 := gettext (ce_string ("%%s ERROR %%d: %%s.%N"))
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___22, l_tms, l_hstat.item.statcode, l_tmp___21])
							end
						else
							l_tmp___21 := quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_hstat.item.error)
							l_tmp___22 := gettext (ce_string ("%%s ERROR %%d: %%s.%N"))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___22, l_tms, l_hstat.item.statcode, l_tmp___21])
						end
				when 25 then
						if not js.loop_jumped then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							l_ret := {PC_UERR_T}.WRONGCODE
							if (not l_hurl___0.is_void) then
								free (create {CE_POINTER [ANY]}.make_cast (l_hurl___0))
							end
							l_pos := -1 + 52 -- goto exit
						end
				when 26 then
						if not (not js.loop_jumped and then (not l_got_head)) then
							l_pos := -1 + 41 -- skip if block
						end
				when 27 then -- if:
						l_got_head := (1).to_boolean
						if not (options_inst.opt.item.timestamping) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if (l_hstat.item.remote_time).is_void then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Last-modified header missing -- time-stamps turned off.%N"))))
						else
							l_pos := -1 + 30 -- goto _L___4
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___4:
						if (not (l_hstat.item.remote_time).is_void) then
							l_tmr := http_atotm (l_hstat.item.remote_time)
							if l_tmr = -1 then
								log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Last-modified header invalid -- time-stamp ignored.%N"))))
							end
							if ((a_dt.item).bit_and (4)).to_boolean then
								l_time_came_from_head := (1).to_boolean
							end
						end
				when 31 then
						if not l_send_head_first then
							l_pos := -1 + 41 -- skip if block
						end
				when 32 then -- if:
						if not (options_inst.opt.item.timestamping) then
							l_pos := -1 + 39 -- skip if block
						end
				when 33 then -- if:
						if (l_hstat.item.orig_file_name).is_void then
							l_pos := -1 + 38 -- skip if block
						end
				when 34 then -- if:
						if (l_hstat.item.remote_time).is_void then
							l_pos := -1 + 38 -- skip if block
						end
				when 35 then -- if:
						if l_tmr = -1 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if l_hstat.item.orig_file_tstamp >= l_tmr then
							if l_hstat.item.contlen = -{INTEGER_64} 1 then
								l_tmp___25 := quote_inst.quote (l_hstat.item.orig_file_name)
								l_tmp___26 := gettext (ce_string ("Server file no newer than local file %%s -- not retrieving.%N%N"))
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___26, l_tmp___25])
								l_ret := {PC_UERR_T}.RETROK
								l_pos := -1 + 52 -- goto exit
							elseif l_hstat.item.orig_file_size = l_hstat.item.contlen then
								l_tmp___25 := quote_inst.quote (l_hstat.item.orig_file_name)
								l_tmp___26 := gettext (ce_string ("Server file no newer than local file %%s -- not retrieving.%N%N"))
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___26, l_tmp___25])
								l_ret := {PC_UERR_T}.RETROK
								l_pos := -1 + 52 -- goto exit
							else
								l_tmp___27 := utils_inst.number_to_static_string (l_hstat.item.orig_file_size)
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("The sizes do not match (local %%s) -- retrieving.%N"))), l_tmp___27])
							end
						else
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file is newer, retrieving.%N"))))
						end
				when 37 then
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
				when 38 then -- if done | if done | if done
						l_hstat.item.timestamp_checked := (1).to_boolean
				when 39 then -- if done
						if options_inst.opt.item.spider then
							l_finished := (1).to_boolean
							if options_inst.opt.item.recursive then
								if ((a_dt.item).bit_and (1)).to_boolean then
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file exists and could contain links to other resources -- retrieving.%N%N"))))
									l_finished := (0).to_boolean
								else
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file exists but does not contain any link -- not retrieving.%N%N")))])
									l_ret := {PC_UERR_T}.RETROK
								end
							else
								if ((a_dt.item).bit_and (1)).to_boolean then
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file exists and could contain further links,%Nbut recursion is disabled -- not retrieving.%N%N")))])
								else
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file exists.%N%N")))])
								end
								l_ret := {PC_UERR_T}.RETROK
							end
							if l_finished then
								if (not (l_hstat.item.message).is_void) then
									l_tmp___35 := (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_hstat.item.message))
								else
									l_tmp___35 := ce_string ("")
								end
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, (gettext (ce_string ("%%s URL: %%s %%2d %%s%N"))), l_tms, a_u.item.url, l_hstat.item.statcode, l_tmp___35])
								l_pos := -1 + 52 -- goto exit
							end
						end
				when 40 then
						l_got_name := (1).to_boolean
						a_dt.item := (a_dt.item).bit_and ((-5))
						l_count := 0
						js.continue
				when 41 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 50 -- skip if block
						end
				when 42 then -- if:
						if l_tmr = -1 then
							l_pos := -1 + 49 -- skip if block
						end
				when 43 then -- if:
						if l_hstat.item.len /= l_hstat.item.contlen then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_pos := -1 + 48 -- goto _L___5
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 46 then -- else:
						if l_hstat.item.res /= 0 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if l_hstat.item.contlen /= -{INTEGER_64} 1 then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | _L___5:
						l_fl.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						retr_inst.set_local_file (l_fl, l_hstat.item.local_file)
						if (not (l_fl.item).is_void) then
							l_newtmr := (-1).to_integer_32
							if l_time_came_from_head then
								if (not (l_hstat.item.remote_time).is_void) then
									if (l_hstat.item.remote_time[0]).to_boolean then
										l_newtmr := http_atotm (l_hstat.item.remote_time)
										if l_newtmr /= -1 then
											l_tmr := l_newtmr
										end
									end
								end
							end
							utils_inst.touch (l_fl.item, l_tmr)
						end
				when 49 then -- if done | if done | if done
						l_tmrate := retr_inst.retr_rate (l_hstat.item.rd_size, l_hstat.item.dltime)
						retr_inst.total_download_time := retr_inst.total_download_time + (l_hstat.item.dltime)
						if l_hstat.item.len = l_hstat.item.contlen then
							if ((a_dt.item).bit_and (2)).to_boolean then
								if (not (options_inst.opt.item.output_document).is_void) then
									if ((options_inst.opt.item.output_document).item).to_integer_32 = 45 then
										if not (options_inst.opt.item.output_document[1]).to_boolean then
											l_tmp___37 := 1
										else
											l_tmp___37 := 0
										end
									else
										l_tmp___37 := 0
									end
								else
									l_tmp___37 := 0
								end
								l_write_to_stdout := l_tmp___37.to_boolean
								l_tmp___38 := utils_inst.number_to_static_string (l_hstat.item.contlen)
								l_tmp___39 := utils_inst.number_to_static_string (l_hstat.item.len)
								if l_write_to_stdout then
									l_tmp___41 := ce_string ("")
								else
									l_tmp___41 := (quote_inst.quote (l_hstat.item.local_file))
								end
								if l_write_to_stdout then
									l_tmp___44 := (gettext (ce_string ("%%s (%%s) - written to stdout %%s[%%s/%%s]%N%N")))
								else
									l_tmp___44 := (gettext (ce_string ("%%s (%%s) - %%s saved [%%s/%%s]%N%N")))
								end
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___44, l_tms, l_tmrate, l_tmp___41, l_tmp___39, l_tmp___38])
								l_tmp___45 := utils_inst.number_to_static_string (l_hstat.item.contlen)
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, ce_string ("%%s URL:%%s [%%s/%%s] -> %"%%s%" [%%d]%N"), l_tms, a_u.item.url, (utils_inst.number_to_static_string (l_hstat.item.len)), l_tmp___45, l_hstat.item.local_file, l_count])
							end
							main_inst.numurls := main_inst.numurls + 1
							retr_inst.total_downloaded_bytes := retr_inst.total_downloaded_bytes + (l_hstat.item.len)
							if ((a_dt.item).bit_and (32)).to_boolean then
								convert_inst.downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_AND_HTML_EXTENSION_ADDED, l_hstat.item.local_file).do_nothing
							else
								convert_inst.downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_NORMALLY, l_hstat.item.local_file).do_nothing
							end
							l_ret := {PC_UERR_T}.RETROK
							l_pos := -1 + 52 -- goto exit
						elseif l_hstat.item.res = 0 then
							if l_hstat.item.contlen = -{INTEGER_64} 1 then
								if ((a_dt.item).bit_and (2)).to_boolean then
									if (not (options_inst.opt.item.output_document).is_void) then
										if ((options_inst.opt.item.output_document).item).to_integer_32 = 45 then
											if not (options_inst.opt.item.output_document[1]).to_boolean then
												l_tmp___47 := 1
											else
												l_tmp___47 := 0
											end
										else
											l_tmp___47 := 0
										end
									else
										l_tmp___47 := 0
									end
									l_write_to_stdout___0 := l_tmp___47.to_boolean
									l_tmp___48 := utils_inst.number_to_static_string (l_hstat.item.len)
									if l_write_to_stdout___0 then
										l_tmp___50 := ce_string ("")
									else
										l_tmp___50 := (quote_inst.quote (l_hstat.item.local_file))
									end
									if l_write_to_stdout___0 then
										l_tmp___53 := (gettext (ce_string ("%%s (%%s) - written to stdout %%s[%%s]%N%N")))
									else
										l_tmp___53 := (gettext (ce_string ("%%s (%%s) - %%s saved [%%s]%N%N")))
									end
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___53, l_tms, l_tmrate, l_tmp___50, l_tmp___48])
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, ce_string ("%%s URL:%%s [%%s] -> %"%%s%" [%%d]%N"), l_tms, a_u.item.url, (utils_inst.number_to_static_string (l_hstat.item.len)), l_hstat.item.local_file, l_count])
								end
								main_inst.numurls := main_inst.numurls + 1
								retr_inst.total_downloaded_bytes := retr_inst.total_downloaded_bytes + (l_hstat.item.len)
								if ((a_dt.item).bit_and (32)).to_boolean then
									convert_inst.downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_AND_HTML_EXTENSION_ADDED, l_hstat.item.local_file).do_nothing
								else
									convert_inst.downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_NORMALLY, l_hstat.item.local_file).do_nothing
								end
								l_ret := {PC_UERR_T}.RETROK
								l_pos := -1 + 52 -- goto exit
							elseif l_hstat.item.len < l_hstat.item.contlen then
								l_tmp___55 := utils_inst.number_to_static_string (l_hstat.item.len)
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%%s (%%s) - Connection closed at byte %%s. "))), l_tms, l_tmrate, l_tmp___55])
								retr_inst.printwhat (l_count, options_inst.opt.item.ntry)
								js.continue
							elseif l_hstat.item.len /= l_hstat.item.restval then
								abort
							else
								l_ret := {PC_UERR_T}.RETROK
								l_pos := -1 + 52 -- goto exit
							end
						elseif l_hstat.item.contlen = -{INTEGER_64} 1 then
							l_tmp___57 := utils_inst.number_to_static_string (l_hstat.item.len)
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%%s (%%s) - Read error at byte %%s (%%s)."))), l_tms, l_tmrate, l_tmp___57, l_hstat.item.rderrmsg])
							retr_inst.printwhat (l_count, options_inst.opt.item.ntry)
							js.continue
						else
							l_tmp___59 := utils_inst.number_to_static_string (l_hstat.item.contlen)
							l_tmp___60 := utils_inst.number_to_static_string (l_hstat.item.len)
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%%s (%%s) - Read error at byte %%s/%%s (%%s). "))), l_tms, l_tmrate, l_tmp___60, l_tmp___59, l_hstat.item.rderrmsg])
							retr_inst.printwhat (l_count, options_inst.opt.item.ntry)
							js.continue
						end
				when 50 then
						if js.loop_increment and then ((options_inst.opt.item.ntry).to_boolean) then
							if not (l_count < options_inst.opt.item.ntry) then
								l_pos := -1 + 52 -- break
							end
						end
				when 51 then
						l_pos := -1 + 2 -- back to loop condition
				when 52 then -- loop done | exit:
					if l_ret = {NATURAL_32} 31 then
						a_local_file.item := xmalloc_inst.xstrdup (l_hstat.item.local_file)
					end
					free_hstat (l_hstat)
					Result := l_ret
				when 53 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	invalidate_persistent
		local
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
					log_inst.debug_logprintf ([ce_string ("Disabling further reuse of socket %%d.%N"), pconn.item.socket])
				end
				js.break
			end
			pconn_active := (0).to_boolean
			connect_inst.fd_close (pconn.item.socket)
			free (create {CE_POINTER [ANY]}.make_cast (pconn.item.host))
			memset (create {CE_POINTER [ANY]}.make_cast (pconn), ('%/0/').code, (create {PD_PCONN}.make).structure_size.to_natural_32).do_nothing
		end

	known_authentication_scheme_p (a_hdrbeg: CE_POINTER [INTEGER_8]; a_hdrend: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_tmp___3: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_hdrend.c_pointer.to_integer_32).to_natural_32 > (a_hdrbeg.c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_hdrend.distance (a_hdrbeg)).to_natural_32 >= (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if 0 = (strncasecmp (a_hdrbeg, ce_string ("Basic"), (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1)) then
								if (a_hdrend.distance (a_hdrbeg)).to_natural_32 = (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1 then
									l_tmp___3 := 1
								elseif (c_ctype_inst.c2_isspace ((a_hdrbeg[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)) then
									l_tmp___3 := 1
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						if (a_hdrend.c_pointer.to_integer_32).to_natural_32 > (a_hdrbeg.c_pointer.to_integer_32).to_natural_32 then
							if (a_hdrend.distance (a_hdrbeg)).to_natural_32 >= (("Digest").count + 1).to_natural_32 - {NATURAL_32} 1 then
								if 0 = (strncasecmp (a_hdrbeg, ce_string ("Digest"), (("Digest").count + 1).to_natural_32 - {NATURAL_32} 1)) then
									if (a_hdrend.distance (a_hdrbeg)).to_natural_32 = (("Digest").count + 1).to_natural_32 - {NATURAL_32} 1 then
										l_tmp___3 := 1
									elseif (c_ctype_inst.c2_isspace ((a_hdrbeg[((("Digest").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)) then
										l_tmp___3 := 1
									else
										l_tmp___3 := 0
									end
								else
									l_tmp___3 := 0
								end
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
				when 4 then
					Result := l_tmp___3.to_boolean
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	load_cookies
		do
			if wget_cookie_jar.is_void then
				wget_cookie_jar := cookies_inst.cookie_jar_new
			end
			if (not (options_inst.opt.item.cookies_input).is_void) then
				if not cookies_loaded_p then
					cookies_inst.cookie_jar_load (wget_cookie_jar, options_inst.opt.item.cookies_input)
					cookies_loaded_p := (1).to_boolean
				end
			end
		end

	maybe_send_basic_creds (a_hostname: CE_POINTER [INTEGER_8]; a_user: CE_POINTER [INTEGER_8]; a_passwd: CE_POINTER [INTEGER_8]; a_req: CE_POINTER [PD_REQUEST]): BOOLEAN
		local
			l_do_challenge: BOOLEAN
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_do_challenge := (0).to_boolean
					if not (options_inst.opt.item.auth_without_challenge) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Auth-without-challenge set, sending Basic credentials.%N")])
							end
							js.break
						end
						l_do_challenge := (1).to_boolean
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if basic_authed_hosts.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (hash_inst.hash_table_contains (basic_authed_hosts, create {CE_POINTER [ANY]}.make_cast (a_hostname))).to_boolean then
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Found %%s in basic_authed_hosts.%N"), (quote_inst.quote (a_hostname))])
								end
								js.break
							end
							l_do_challenge := (1).to_boolean
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Host %%s has not issued a general basic challenge.%N"), (quote_inst.quote (a_hostname))])
							end
							js.break
						end
				when 7 then -- if done
						if l_do_challenge then
							request_set_header (a_req, ce_string ("Authorization"), (basic_authentication_encode (a_user, a_passwd)), {PC_RP}.rel_value)
						end
						Result := l_do_challenge
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	parse_content_disposition (a_hdr: CE_POINTER [INTEGER_8]; a_filename: CE_POINTER [CE_POINTER [INTEGER_8]]): BOOLEAN
		local
			l_hdr: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_name: CE_ARRAY [PD_PARAM_TOKEN]
			l_value: CE_ARRAY [PD_PARAM_TOKEN]
			l_last_slash: CE_POINTER [INTEGER_8]
			l_last_bs: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_prefix_length: INTEGER_32
			l_add_slash: BOOLEAN
			l_total_length: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hdr.make (<<1>>)
			create l_name.make (<<1>>)
			create l_value.make (<<1>>)
			create l_last_slash.make
			create l_last_bs.make
			create l_tmp___1.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_hdr.item := a_hdr
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						if not (extract_param (l_hdr, l_name, l_value, ((';').code).to_integer_8)) then
							js.break
						end
						if not (not js.loop_jumped and then (((l_name.item.e).distance ((l_name.item.b))).to_natural_32 = (("filename").count + 1).to_natural_32 - {NATURAL_32} 1)) then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						if (strncasecmp (l_name.item.b, ce_string ("filename"), (("filename").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						if (l_value.item.b).is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						l_last_slash := create {CE_POINTER [INTEGER_8]}.make_cast ((memrchr (create {CE_POINTER [ANY]}.make_cast (l_value.item.b), ('/').code, ((l_value.item.e).distance ((l_value.item.b))).to_natural_32)))
						l_last_bs := create {CE_POINTER [INTEGER_8]}.make_cast ((memrchr (create {CE_POINTER [ANY]}.make_cast (l_value.item.b), ('\').code, ((l_value.item.e).distance ((l_value.item.b))).to_natural_32)))
						if l_last_slash.is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (not l_last_bs.is_void) then
							if (l_last_slash.c_pointer.to_integer_32).to_natural_32 > (l_last_bs.c_pointer.to_integer_32).to_natural_32 then
								l_tmp___1 := l_last_slash
							else
								l_tmp___1 := l_last_bs
							end
							l_value.item.b := l_tmp___1 + 1
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else: | _L___0:
						if l_last_slash.is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if l_last_bs.is_void then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if (not l_last_slash.is_void) then
							l_tmp___2 := l_last_slash
						else
							l_tmp___2 := l_last_bs
						end
						l_value.item.b := l_tmp___2 + 1
				when 13 then -- if done | if done
						if (l_value.item.b).is_equal (l_value.item.e) then
							js.continue
						end
						if not js.loop_jumped then
							if (not (options_inst.opt.item.dir_prefix).is_void) then
								l_prefix_length := (strlen (options_inst.opt.item.dir_prefix)).to_integer_32
								l_add_slash := ((options_inst.opt.item.dir_prefix[(l_prefix_length - 1)]).to_integer_32 /= 47)
								if l_add_slash then
									l_prefix_length := l_prefix_length + 1
								end
								l_total_length := l_prefix_length + ((l_value.item.e).distance ((l_value.item.b)))
								a_filename.item := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((l_total_length + 1).to_natural_32)))
								strcpy (a_filename.item, options_inst.opt.item.dir_prefix).do_nothing
								if l_add_slash then
									a_filename.item[(l_prefix_length - 1)] := (('/').code).to_integer_8
								end
								memcpy (create {CE_POINTER [ANY]}.make_cast ((a_filename.item + l_prefix_length)), create {CE_POINTER [ANY]}.make_cast (l_value.item.b), ((l_value.item.e).distance ((l_value.item.b))).to_natural_32).do_nothing
								a_filename.item[l_total_length] := (('%/0/').code).to_integer_8
							else
								a_filename.item := utils_inst.strdupdelim (l_value.item.b, l_value.item.e)
							end
							Result := (1).to_boolean
							js.return
						end
				when 14 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if not js.return_called then
						Result := (0).to_boolean
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_content_range (a_hdr: CE_POINTER [INTEGER_8]; a_first_byte_ptr: CE_POINTER [INTEGER_64]; a_last_byte_ptr: CE_POINTER [INTEGER_64]; a_entity_length_ptr: CE_POINTER [INTEGER_64]): BOOLEAN
		local
			l_hdr: CE_POINTER [INTEGER_8]
			l_num: INTEGER_64
			js: JUMP_STATE
		do
			create l_hdr.make

			l_hdr := a_hdr
			if 0 = (strncasecmp (l_hdr, ce_string ("bytes"), (5).to_natural_32)) then
				l_hdr := l_hdr + (5)
				if (l_hdr[0]).to_integer_32 = 58 then
					l_hdr := l_hdr + 1
				end
				from
				until
					js.loop_done
				loop
					if not (c_ctype_inst.c2_isspace ((l_hdr[0]).to_integer_32)) then
						js.break
					end
					if not js.loop_jumped then
						l_hdr := l_hdr + 1
					end
				end
				if not (l_hdr[0]).to_boolean then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				if not (c_ctype_inst.c2_isdigit ((l_hdr[0]).to_integer_32)) then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				l_num := (0).to_integer_64
				from
				until
					js.loop_done
				loop
					if not (c_ctype_inst.c2_isdigit ((l_hdr[0]).to_integer_32)) then
						js.break
					end
					if not js.loop_jumped then
						l_num := {INTEGER_64} 10 * l_num + ((l_hdr[0]).to_integer_32 - 48).to_integer_64
						l_hdr := l_hdr + 1
					end
				end
				if (l_hdr[0]).to_integer_32 /= 45 then
					Result := (0).to_boolean
					js.return
				elseif not (c_ctype_inst.c2_isdigit ((l_hdr[1]).to_integer_32)) then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				a_first_byte_ptr.item := l_num
				l_hdr := l_hdr + 1
				l_num := (0).to_integer_64
				from
				until
					js.loop_done
				loop
					if not (c_ctype_inst.c2_isdigit ((l_hdr[0]).to_integer_32)) then
						js.break
					end
					if not js.loop_jumped then
						l_num := {INTEGER_64} 10 * l_num + ((l_hdr[0]).to_integer_32 - 48).to_integer_64
						l_hdr := l_hdr + 1
					end
				end
				if (l_hdr[0]).to_integer_32 /= 47 then
					Result := (0).to_boolean
					js.return
				elseif not (c_ctype_inst.c2_isdigit ((l_hdr[1]).to_integer_32)) then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				a_last_byte_ptr.item := l_num
				l_hdr := l_hdr + 1
				if (l_hdr[0]).to_integer_32 = 42 then
					l_num := (-1).to_integer_64
				else
					l_num := (0).to_integer_64
					from
					until
						js.loop_done
					loop
						if not (c_ctype_inst.c2_isdigit ((l_hdr[0]).to_integer_32)) then
							js.break
						end
						if not js.loop_jumped then
							l_num := {INTEGER_64} 10 * l_num + ((l_hdr[0]).to_integer_32 - 48).to_integer_64
							l_hdr := l_hdr + 1
						end
					end
				end
				a_entity_length_ptr.item := l_num
				Result := (1).to_boolean
			end
		end

	persistent_available_p (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_ssl: BOOLEAN; a_host_lookup_failed: CE_POINTER [BOOLEAN]): BOOLEAN
		local
			l_found: BOOLEAN
			l_ip___0: CE_ARRAY [PD_IP_ADDRESS]
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			js: JUMP_STATE
		do
			create l_ip___0.make (<<1>>)
			create l_al.make

			if not pconn_active then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called and then (a_ssl.to_integer /= (pconn.item.ssl).to_integer) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called and then (a_port /= pconn.item.port) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if 0 /= (strcasecmp (a_host, pconn.item.host)) then
					if a_ssl then
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						if not (connect_inst.socket_ip_address (pconn.item.socket, l_ip___0, 1)) then
							invalidate_persistent
							Result := (0).to_boolean
							js.return
						end
					end
					if not js.return_called then
						l_al := host_inst.lookup_host (a_host, 0)
						if l_al.is_void then
							a_host_lookup_failed.item := (1).to_boolean
							Result := (0).to_boolean
							js.return
						end
					end
					if not js.return_called then
						l_found := host_inst.address_list_contains (l_al, l_ip___0)
						host_inst.address_list_release (l_al)
						if not l_found then
							Result := (0).to_boolean
							js.return
						end
					end
				end
			end
			if not js.return_called then
				if not (connect_inst.test_socket_open (pconn.item.socket)) then
					invalidate_persistent
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	post_file (a_sock: INTEGER_32; a_file_name: CE_POINTER [INTEGER_8]; a_promised_size: INTEGER_64): INTEGER_32
		local
			l_written: INTEGER_64
			l_write_error: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_towrite: INTEGER_32
			l_length: INTEGER_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_written := (0).to_integer_64
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
					log_inst.debug_logprintf ([ce_string ("[writing POST file %%s ... "), a_file_name])
				end
				js.break
			end
			l_fp := fopen (a_file_name, ce_string ("rb"))
			if l_fp.is_void then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if (feof (l_fp)).to_boolean then
						js.break
					elseif not (l_written < a_promised_size) then
						js.break
					end
					if not js.loop_jumped then
						l_length := (fread (create {CE_POINTER [ANY]}.make_cast (chunk), (1).to_natural_32, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), l_fp)).to_integer_32
						if l_length = 0 then
							js.break
						end
					end
					if not js.loop_jumped then
						if a_promised_size - l_written > l_length.to_integer_64 then
							l_towrite := l_length
						else
							l_towrite := (a_promised_size - l_written).to_integer_32
						end
						l_write_error := connect_inst.fd_write (a_sock, chunk, l_towrite, (-1).to_double)
						if l_write_error < 0 then
							fclose (l_fp).do_nothing
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_written := l_written + l_towrite.to_integer_64
						end
					end
				end
			end
			if not js.return_called then
				fclose (l_fp).do_nothing
				if l_written < a_promised_size then
					(errno_location).item := 22
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				if l_written /= a_promised_size then
					assert_fail (ce_string ("written == promised_size"), ce_string ("http.c"), {NATURAL_32} 489, ce_string ("post_file"))
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("done]%N")])
					end
					js.break
				end
				Result := 0
			end
		end

	print_response_line (a_prefix: CE_POINTER [INTEGER_8]; a_b: CE_POINTER [INTEGER_8]; a_e: CE_POINTER [INTEGER_8])
		local
			l_copy: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_copy.make (<<1>>)
			create l_BTA_beg.make
			create l_BTA_dest.make

			from
			until
				js.loop_done
			loop
				l_BTA_beg := a_b
				l_BTA_len := a_e.distance (l_BTA_beg)
				l_BTA_dest := l_copy
				l_BTA_dest.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_BTA_dest.item), create {CE_POINTER [ANY]}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
				l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
				js.break
			end
			log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%%s%%s%N"), a_prefix, (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_copy.item))])
		end

	print_server_response (a_resp: CE_POINTER [PD_RESPONSE]; a_prefix: CE_POINTER [INTEGER_8])
		local
			l_i: INTEGER_32
			l_b: CE_POINTER [INTEGER_8]
			l_e: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_b.make
			create l_e.make

			if (a_resp.item.headers).is_void then
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					(a_resp.item.headers[(l_i + 1)]).is_void
				loop
					l_b := a_resp.item.headers[l_i]
					l_e := a_resp.item.headers[(l_i + 1)]
					if (l_b.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
						if (l_e[-1]).to_integer_32 = 10 then
							l_e := l_e - 1
						end
					end
					if (l_b.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
						if (l_e[-1]).to_integer_32 = 13 then
							l_e := l_e - 1
						end
					end
					print_response_line (a_prefix, l_b, l_e)
					l_i := l_i + 1
				end
			end
		end

	read_http_response_head (a_fd: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			Result := (retr_inst.fd_read_hunk (a_fd, response_head_terminator_address, 512, 65_536))
		end

	register_basic_auth_host (a_hostname: CE_POINTER [INTEGER_8])
		local
			js: JUMP_STATE
		do
			if basic_authed_hosts.is_void then
				basic_authed_hosts := hash_inst.make_nocase_string_hash_table (1)
			end
			if not (hash_inst.hash_table_contains (basic_authed_hosts, create {CE_POINTER [ANY]}.make_cast (a_hostname))).to_boolean then
				hash_inst.hash_table_put (basic_authed_hosts, create {CE_POINTER [ANY]}.make_cast ((xmalloc_inst.xstrdup (a_hostname))), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Inserted %%s into basic_authed_hosts%N"), (quote_inst.quote (a_hostname))])
					end
					js.break
				end
			end
		end

	register_persistent (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_fd: INTEGER_32; a_ssl: BOOLEAN)
		local
			js: JUMP_STATE
		do
			if pconn_active then
				if pconn.item.socket = a_fd then
					js.return
				else
					invalidate_persistent
				end
			end
			if not js.return_called then
				pconn_active := (1).to_boolean
				pconn.item.socket := a_fd
				pconn.item.host := xmalloc_inst.xstrdup (a_host)
				pconn.item.port := a_port
				pconn.item.ssl := a_ssl
				pconn.item.authorized := (0).to_boolean
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Registered socket %%d for persistent reuse.%N"), a_fd])
					end
					js.break
				end
			end
		end

	release_header (a_hdr: CE_POINTER [PD_REQUEST_HEADER])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_hdr.item.release_policy).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 1
					free (create {CE_POINTER [ANY]}.make_cast (a_hdr.item.name))
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 2
					free (create {CE_POINTER [ANY]}.make_cast (a_hdr.item.value))
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 3
					free (create {CE_POINTER [ANY]}.make_cast (a_hdr.item.name))
					free (create {CE_POINTER [ANY]}.make_cast (a_hdr.item.value))
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	request_free (a_req: CE_POINTER [PD_REQUEST])
		local
			l_i: INTEGER_32
		do
			if (not (a_req.item.arg).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_req.item.arg))
			end
			l_i := 0
			from
			until
				not (l_i < a_req.item.hcount)
			loop
				release_header (a_req.item.headers + l_i)
				l_i := l_i + 1
			end
			if (not (a_req.item.headers).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_req.item.headers))
			end
			free (create {CE_POINTER [ANY]}.make_cast (a_req))
		end

	request_method (a_req: CE_POINTER [PD_REQUEST]): CE_POINTER [INTEGER_8]
		do
			Result := (a_req.item.method)
		end

	request_new: CE_POINTER [PD_REQUEST]
		local
			l_req: CE_POINTER [PD_REQUEST]
		do
			create l_req.make

			l_req := create {CE_POINTER [PD_REQUEST]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, (create {PD_REQUEST}.make).structure_size.to_natural_32)))
			l_req.item.hcapacity := 8
			l_req.item.headers := create {CE_POINTER [PD_REQUEST_HEADER]}.make_cast ((xmalloc_inst.xmalloc ((l_req.item.hcapacity).to_natural_32 * (create {PD_REQUEST_HEADER}.make).structure_size.to_natural_32)))
			Result := l_req
		end

	request_remove_header (a_req: CE_POINTER [PD_REQUEST]; a_name: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_i: INTEGER_32
			l_hdr: CE_POINTER [PD_REQUEST_HEADER]
			js: JUMP_STATE
		do
			create l_hdr.make

			l_i := 0
			from
			until
				not (not js.loop_done and then (l_i < a_req.item.hcount))
			loop
				l_hdr := a_req.item.headers + l_i
				if 0 = (strcasecmp (a_name, l_hdr.item.name)) then
					release_header (l_hdr)
					if l_i < a_req.item.hcount - 1 then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_hdr), create {CE_POINTER [ANY]}.make_cast ((l_hdr + 1)), ((a_req.item.hcount - l_i) - 1).to_natural_32 * (create {PD_REQUEST_HEADER}.make).structure_size.to_natural_32).do_nothing
					end
					a_req.item.hcount := (a_req.item.hcount) - 1
					Result := (1).to_boolean
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	request_send (a_req: CE_POINTER [PD_REQUEST]; a_fd: INTEGER_32): INTEGER_32
		local
			l_request_string: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_size: INTEGER_32
			l_write_error: INTEGER_32
			l_tmp: NATURAL_32
			l_hdr: CE_POINTER [PD_REQUEST_HEADER]
			l_tmp___1: NATURAL_32
			l_A_len: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_A_len___0: INTEGER_32
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_hdr___0: CE_POINTER [PD_REQUEST_HEADER]
			l_A_len___1: INTEGER_32
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_A_len___2: INTEGER_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_request_string.make
			create l_p___0.make
			create l_hdr.make
			create l_tmp___5.make
			create l_tmp___7.make
			create l_hdr___0.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___15.make
			create l_tmp___16.make
			create l_tmp___18.make

			l_size := 0
			l_tmp := strlen (a_req.item.method)
			l_size := (l_size.to_natural_32 + (((((l_tmp + {NATURAL_32} 1) + (strlen (a_req.item.arg))) + {NATURAL_32} 1) + {NATURAL_32} 8) + {NATURAL_32} 2)).to_integer_32
			l_i := 0
			from
			until
				not (l_i < a_req.item.hcount)
			loop
				l_hdr := a_req.item.headers + l_i
				l_tmp___1 := strlen (l_hdr.item.name)
				l_size := (l_size.to_natural_32 + (((l_tmp___1 + {NATURAL_32} 2) + (strlen (l_hdr.item.value))) + {NATURAL_32} 2)).to_integer_32
				l_i := l_i + 1
			end
			l_size := l_size + (3)
			l_request_string := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (l_size.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32)))
			l_p___0 := l_request_string
			from
			until
				js.loop_done
			loop
				l_A_len := (strlen (a_req.item.method)).to_integer_32
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (a_req.item.method), l_A_len.to_natural_32).do_nothing
				l_p___0 := l_p___0 + l_A_len
				js.break
			end
			l_tmp___5 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___5[0] := ((' ').code).to_integer_8
			from
			until
				js.loop_done
			loop
				l_A_len___0 := (strlen (a_req.item.arg)).to_integer_32
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (a_req.item.arg), l_A_len___0.to_natural_32).do_nothing
				l_p___0 := l_p___0 + l_A_len___0
				js.break
			end
			l_tmp___7 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___7[0] := ((' ').code).to_integer_8
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (ce_string ("HTTP/1.0%R%N")), (10).to_natural_32).do_nothing
			l_p___0 := l_p___0 + (10)
			l_i := 0
			from
			until
				not (not js.loop_done and then (l_i < a_req.item.hcount))
			loop
				l_hdr___0 := a_req.item.headers + l_i
				from
				until
					js.loop_done
				loop
					l_A_len___1 := (strlen (l_hdr___0.item.name)).to_integer_32
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_hdr___0.item.name), l_A_len___1.to_natural_32).do_nothing
					l_p___0 := l_p___0 + l_A_len___1
					js.break
				end
				l_tmp___9 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___9[0] := ((':').code).to_integer_8
				l_tmp___10 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___10[0] := ((' ').code).to_integer_8
				from
				until
					js.loop_done
				loop
					l_A_len___2 := (strlen (l_hdr___0.item.value)).to_integer_32
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_hdr___0.item.value), l_A_len___2.to_natural_32).do_nothing
					l_p___0 := l_p___0 + l_A_len___2
					js.break
				end
				l_tmp___12 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___12[0] := (('%R').code).to_integer_8
				l_tmp___13 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___13[0] := (('%N').code).to_integer_8
				l_i := l_i + 1
			end
			l_tmp___14 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___14[0] := (('%R').code).to_integer_8
			l_tmp___15 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___15[0] := (('%N').code).to_integer_8
			l_tmp___16 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___16[0] := (('%/0/').code).to_integer_8
			if l_p___0.distance (l_request_string) /= l_size then
				assert_fail (ce_string ("p - request_string == size"), ce_string ("http.c"), {NATURAL_32} 367, ce_string ("request_send"))
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
					log_inst.debug_logprintf ([ce_string ("%N---request begin---%N%%s---request end---%N"), l_request_string])
				end
				js.break
			end
			l_write_error := connect_inst.fd_write (a_fd, l_request_string, l_size - 1, (-1).to_double)
			if l_write_error < 0 then
				l_tmp___18 := connect_inst.fd_errstr (a_fd)
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Failed writing HTTP request: %%s.%N"))), l_tmp___18])
			end
			Result := l_write_error
		end

	request_set_header (a_req: CE_POINTER [PD_REQUEST]; a_name: CE_POINTER [INTEGER_8]; a_value: CE_POINTER [INTEGER_8]; a_release_policy: NATURAL_32)
		local
			l_hdr: CE_POINTER [PD_REQUEST_HEADER]
			l_i: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_hdr.make

			if a_value.is_void then
				if a_release_policy = {NATURAL_32} 1 then
					free (create {CE_POINTER [ANY]}.make_cast (a_name))
				elseif a_release_policy = {NATURAL_32} 3 then
					free (create {CE_POINTER [ANY]}.make_cast (a_name))
				end
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (not js.loop_done and then (l_i < a_req.item.hcount))
				loop
					l_hdr := a_req.item.headers + l_i
					if 0 = (strcasecmp (a_name, l_hdr.item.name)) then
						release_header (l_hdr)
						l_hdr.item.name := a_name
						l_hdr.item.value := a_value
						l_hdr.item.release_policy := a_release_policy
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				if a_req.item.hcount >= a_req.item.hcapacity then
					a_req.item.hcapacity := (a_req.item.hcapacity).bit_shift_left ((1))
					a_req.item.headers := create {CE_POINTER [PD_REQUEST_HEADER]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (a_req.item.headers), (a_req.item.hcapacity).to_natural_32 * (create {PD_REQUEST_HEADER}.make).structure_size.to_natural_32)))
				end
				l_tmp___1 := a_req.item.hcount
				a_req.item.hcount := (a_req.item.hcount) + 1
				l_hdr := a_req.item.headers + l_tmp___1
				l_hdr.item.name := a_name
				l_hdr.item.value := a_value
				l_hdr.item.release_policy := a_release_policy
			end
		end

	request_set_method (a_req: CE_POINTER [PD_REQUEST]; a_meth: CE_POINTER [INTEGER_8]; a_arg: CE_POINTER [INTEGER_8])
		do
			a_req.item.method := a_meth
			a_req.item.arg := a_arg
		end

	request_set_user_header (a_req: CE_POINTER [PD_REQUEST]; a_header: CE_POINTER [INTEGER_8])
		local
			l_name: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [INTEGER_8]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_name.make (<<1>>)
			create l_p___0.make
			create l_BTA_beg.make
			create l_BTA_dest.make

			l_p___0 := (strchr (a_header, (':').code))
			if l_p___0.is_void then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l_BTA_beg := a_header
					l_BTA_len := l_p___0.distance (l_BTA_beg)
					l_BTA_dest := l_name
					l_BTA_dest.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_BTA_dest.item), create {CE_POINTER [ANY]}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
					l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
					js.break
				end
				l_p___0 := l_p___0 + 1
				from
				until
					js.loop_done
				loop
					if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
						js.break
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0 + 1
					end
				end
				request_set_header (a_req, (xmalloc_inst.xstrdup (l_name.item)), l_p___0, {PC_RP}.rel_name)
			end
		end

	resp_free (a_resp: CE_POINTER [PD_RESPONSE])
		do
			if (not (a_resp.item.headers).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_resp.item.headers))
			end
			free (create {CE_POINTER [ANY]}.make_cast (a_resp))
		end

	resp_header_copy (a_resp: CE_POINTER [PD_RESPONSE]; a_name: CE_POINTER [INTEGER_8]; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32): BOOLEAN
		local
			l_b: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_e: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_len: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_b.make (<<1>>)
			create l_e.make (<<1>>)

			if not (resp_header_get (a_resp, a_name, l_b, l_e)) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if a_bufsize___0.to_boolean then
					if (l_e.item).distance ((l_b.item)) > a_bufsize___0 - 1 then
						l_tmp___0 := a_bufsize___0 - 1
					else
						l_tmp___0 := (l_e.item).distance ((l_b.item))
					end
					l_len := l_tmp___0
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_buf___6), create {CE_POINTER [ANY]}.make_cast (l_b.item), l_len.to_natural_32).do_nothing
					a_buf___6[l_len] := (('%/0/').code).to_integer_8
				end
				Result := (1).to_boolean
			end
		end

	resp_header_get (a_resp: CE_POINTER [PD_RESPONSE]; a_name: CE_POINTER [INTEGER_8]; a_begptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]): BOOLEAN
		local
			l_pos2: INTEGER_32
		do
			l_pos2 := (resp_header_locate (a_resp, a_name, 0, a_begptr, a_endptr))
			Result := (l_pos2 /= -1)
		end

	resp_header_locate (a_resp: CE_POINTER [PD_RESPONSE]; a_name: CE_POINTER [INTEGER_8]; a_start: INTEGER_32; a_begptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_i: INTEGER_32
			l_headers: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_name_len: INTEGER_32
			l_b: CE_POINTER [INTEGER_8]
			l_e: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_headers.make
			create l_b.make
			create l_e.make

			l_headers := a_resp.item.headers
			if l_headers.is_void then
				Result := (-1)
				js.return
			elseif (l_headers[1]).is_void then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_name_len := (strlen (a_name)).to_integer_32
				if a_start > 0 then
					l_i := a_start
				else
					l_i := 1
				end
				from
				until
					not (not js.loop_done and then (not (l_headers[(l_i + 1)]).is_void))
				loop
					l_b := l_headers[l_i]
					l_e := l_headers[(l_i + 1)]
					if l_e.distance (l_b) > l_name_len then
						if (l_b[l_name_len]).to_integer_32 = 58 then
							if 0 = (strncasecmp (l_b, a_name, l_name_len.to_natural_32)) then
								l_b := l_b + (l_name_len + 1)
								from
								until
									js.loop_done
								loop
									if (l_b.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
										if not (c_ctype_inst.c2_isspace ((l_b[0]).to_integer_32)) then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_b := l_b + 1
									end
								end
								from
								until
									js.loop_done
								loop
									if (l_b.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
										if not (c_ctype_inst.c2_isspace ((l_e[-1]).to_integer_32)) then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_e := l_e - 1
									end
								end
								a_begptr.item := l_b
								a_endptr.item := l_e
								Result := l_i
								js.return
							end
						end
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	resp_header_strdup (a_resp: CE_POINTER [PD_RESPONSE]; a_name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_b: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_e: CE_ARRAY [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
		do
			create l_b.make (<<1>>)
			create l_e.make (<<1>>)

			if not (resp_header_get (a_resp, a_name, l_b, l_e)) then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (utils_inst.strdupdelim (l_b.item, l_e.item))
			end
		end

	resp_new (a_head: CE_POINTER [INTEGER_8]): CE_POINTER [PD_RESPONSE]
		local
			l_hdr: CE_POINTER [INTEGER_8]
			l_count: INTEGER_32
			l_size: INTEGER_32
			l_resp: CE_POINTER [PD_RESPONSE]
			l_DR_needed_size: INTEGER_32
			l_DR_newsize: INTEGER_32
			l_tmp___1: INTEGER_32
			l_end: CE_POINTER [INTEGER_8]
			l_DR_needed_size___0: INTEGER_32
			l_DR_newsize___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hdr.make
			create l_resp.make
			create l_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_resp := create {CE_POINTER [PD_RESPONSE]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, (create {PD_RESPONSE}.make).structure_size.to_natural_32)))
					l_resp.item.data := a_head
					if (a_head[0]).to_integer_32 = 0 then
						Result := l_resp
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_count := 0
						l_size := l_count
						l_hdr := a_head
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						from
						until
							js.loop_done
						loop
							l_DR_needed_size := (l_count + 1).to_integer_32
							l_DR_newsize := 0
							from
							until
								not (l_size.to_integer_32 < l_DR_needed_size)
							loop
								l_DR_newsize := ((l_size).bit_shift_left (1)).to_integer_32
								if l_DR_newsize < 16 then
									l_DR_newsize := 16
								end
								l_size := l_DR_newsize.to_integer_32
							end
							if l_DR_newsize.to_boolean then
								l_resp.item.headers := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_resp.item.headers), (l_DR_newsize.to_natural_32 * ({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							js.break
						end
						l_tmp___1 := l_count
						l_count := l_count + 1
						l_resp.item.headers[l_tmp___1] := l_hdr
						if (l_hdr[0]).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						js.break
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (l_hdr[0]).to_integer_32 /= 13 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_hdr[1]).to_integer_32 = 10 then
							js.break
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (l_hdr[0]).to_integer_32 = 10 then
							js.break
						end
				when 10 then -- if done
						if not js.loop_jumped then
							from
							until
								js.loop_done
							loop
								l_end := (strchr (l_hdr, ('%N').code))
								if (not l_end.is_void) then
									l_hdr := l_end + 1
								else
									l_hdr := l_hdr + (strlen (l_hdr)).to_integer_32
								end
								if (l_hdr[0]).to_integer_32 /= 32 then
									if (l_hdr[0]).to_integer_32 /= 9 then
										js.break
									end
								end
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						from
						until
							js.loop_done
						loop
							l_DR_needed_size___0 := (l_count + 1).to_integer_32
							l_DR_newsize___0 := 0
							from
							until
								not (l_size.to_integer_32 < l_DR_needed_size___0)
							loop
								l_DR_newsize___0 := ((l_size).bit_shift_left (1)).to_integer_32
								if l_DR_newsize___0 < 16 then
									l_DR_newsize___0 := 16
								end
								l_size := l_DR_newsize___0.to_integer_32
							end
							if l_DR_newsize___0.to_boolean then
								l_resp.item.headers := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_resp.item.headers), (l_DR_newsize___0.to_natural_32 * ({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							js.break
						end
						l_resp.item.headers[l_count] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						Result := l_resp
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	resp_status (a_resp: CE_POINTER [PD_RESPONSE]; a_message: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_status: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_end.make

			if (a_resp.item.headers).is_void then
				if (not a_message.is_void) then
					a_message.item := xmalloc_inst.xstrdup ((gettext (ce_string ("No headers, assuming HTTP/0.9"))))
				end
				Result := 200
				js.return
			end
			if not js.return_called then
				l_p___0 := a_resp.item.headers[0]
				l_end := a_resp.item.headers[1]
				if l_end.is_void then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				if l_end.distance (l_p___0) < 4 then
					Result := (-1)
					js.return
				elseif 0 /= (strncmp (l_p___0, ce_string ("HTTP"), (4).to_natural_32)) then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_p___0 := l_p___0 + (4)
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
					if (l_p___0[0]).to_integer_32 = 47 then
						l_p___0 := l_p___0 + 1
						from
						until
							js.loop_done
						loop
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
							if (l_p___0[0]).to_integer_32 = 46 then
								l_p___0 := l_p___0 + 1
							end
						end
						from
						until
							js.loop_done
						loop
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
					end
				end
				from
				until
					js.loop_done
				loop
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
						if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0 + 1
					end
				end
				if l_end.distance (l_p___0) < 3 then
					Result := (-1)
					js.return
				elseif (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
					if (c_ctype_inst.c2_isdigit ((l_p___0[1]).to_integer_32)) then
						if not (c_ctype_inst.c2_isdigit ((l_p___0[2]).to_integer_32)) then
							Result := (-1)
							js.return
						end
					else
						Result := (-1)
						js.return
					end
				else
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_status := (100 * ((l_p___0[0]).to_integer_32 - 48) + 10 * ((l_p___0[1]).to_integer_32 - 48)) + ((l_p___0[2]).to_integer_32 - 48)
				l_p___0 := l_p___0 + (3)
				if (not a_message.is_void) then
					from
					until
						js.loop_done
					loop
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
							if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_p___0 := l_p___0 + 1
						end
					end
					from
					until
						js.loop_done
					loop
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
							if not (c_ctype_inst.c2_isspace ((l_end[-1]).to_integer_32)) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_end := l_end - 1
						end
					end
					a_message.item := utils_inst.strdupdelim (l_p___0, l_end)
				end
				Result := l_status
			end
		end

	response_head_terminator (a_start: CE_POINTER [INTEGER_8]; a_peeked: CE_POINTER [INTEGER_8]; a_peeklen: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_start.is_equal (a_peeked) then
						if a_peeklen > 4 then
							l_tmp := 4
						else
							l_tmp := a_peeklen
						end
						if 0 /= (memcmp (create {CE_POINTER [ANY]}.make_cast (a_start), create {CE_POINTER [ANY]}.make_cast (ce_string ("HTTP")), l_tmp.to_natural_32)) then
							Result := a_start
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_peeked.distance (a_start) < 2 then
							l_p___0 := a_start
						else
							l_p___0 := a_peeked - 2
						end
						l_end := a_peeked + a_peeklen
				when 2 then -- loop condition:
						if not (not js.loop_done and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_end - 2).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						if (l_p___0[0]).to_integer_32 /= 10 then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0[1]).to_integer_32 /= 13 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_p___0[2]).to_integer_32 = 10 then
							Result := (l_p___0 + 3)
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (l_p___0[1]).to_integer_32 = 10 then
							Result := (l_p___0 + 2)
							js.return
						end
				when 8 then -- if done
						if not js.return_called then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done | if done
						if not js.return_called and then ((l_p___0[0]).to_integer_32 = 10) then
							if (l_p___0[1]).to_integer_32 = 10 then
								Result := (l_p___0 + 2)
								js.return
							end
						end
						if not js.return_called then
							Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	response_head_terminator_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent response_head_terminator)
		end

	save_cookies
		do
			if (not wget_cookie_jar.is_void) then
				cookies_inst.cookie_jar_save (wget_cookie_jar, options_inst.opt.item.cookies_output)
			end
		end

	skip_short_body (a_fd: INTEGER_32; a_contlen: INTEGER_64): BOOLEAN
		local
			l_contlen: INTEGER_64
			l_dlbuf___0: CE_ARRAY [INTEGER_8]
			l_ret: INTEGER_32
			l_tmp___1: INTEGER_64
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_dlbuf___0.make (<<513>>)
			create l_tmp___4.make

			l_contlen := a_contlen
			l_dlbuf___0[512] := (('%/0/').code).to_integer_8
			if l_contlen = -{INTEGER_64} 1 then
				assert_fail (ce_string ("contlen != -1"), ce_string ("http.c"), {NATURAL_32} 915, ce_string ("skip_short_body"))
			end
			if l_contlen > {INTEGER_64} 4_096 then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Skipping %%s bytes of body: ["), (utils_inst.number_to_static_string (l_contlen))])
					end
					js.break
				end
				from
				until
					not (not js.loop_done and then (l_contlen > {INTEGER_64} 0))
				loop
					if l_contlen > {INTEGER_64} 512 then
						l_tmp___1 := (512).to_integer_64
					else
						l_tmp___1 := l_contlen
					end
					l_ret := (connect_inst.fd_read (a_fd, l_dlbuf___0, l_tmp___1.to_integer_32, (-1).to_double))
					if l_ret <= 0 then
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								if l_ret < 0 then
									l_tmp___4 := (connect_inst.fd_errstr (a_fd))
								else
									l_tmp___4 := ce_string ("EOF received")
								end
								log_inst.debug_logprintf ([ce_string ("] aborting (%%s).%N"), l_tmp___4])
							end
							js.break
						end
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						l_contlen := l_contlen - l_ret.to_integer_64
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("%%.*s"), l_ret, l_dlbuf___0])
							end
							js.break
						end
					end
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("] done.%N")])
					end
					js.break
				end
				Result := (1).to_boolean
			end
		end

end
