class
	P_RECUR

inherit
	WGET_DATA
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {ANY} -- routines

	descend_redirect_p (a_redirected: CE_POINTER [INTEGER_8]; a_orig_parsed: CE_POINTER [PD_URL]; a_depth___0: INTEGER_32; a_start_url_parsed: CE_POINTER [PD_URL]; a_blacklist: CE_POINTER [PD_HASH_TABLE]; a_iri: CE_POINTER [PD_IRI]): BOOLEAN
		local
			l_new_parsed: CE_POINTER [PD_URL]
			l_upos: CE_POINTER [PD_URLPOS]
			l_success: BOOLEAN
			js: JUMP_STATE
		do
			create l_new_parsed.make
			create l_upos.make

			if a_orig_parsed.is_void then
				assert_fail (ce_string ("orig_parsed != ((void *)0)"), ce_string ("recur.c"), {NATURAL_32} 694, ce_string ("descend_redirect_p"))
			end
			l_new_parsed := url_inst.url_parse (a_redirected, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [PD_IRI]}.make_shared (default_pointer), (0).to_boolean)
			if l_new_parsed.is_void then
				assert_fail (ce_string ("new_parsed != ((void *)0)"), ce_string ("recur.c"), {NATURAL_32} 697, ce_string ("descend_redirect_p"))
			end
			l_upos := create {CE_POINTER [PD_URLPOS]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, (create {PD_URLPOS}.make).structure_size.to_natural_32)))
			l_upos.item.url := l_new_parsed
			l_success := download_child_p (l_upos, a_orig_parsed, a_depth___0, a_start_url_parsed, a_blacklist, a_iri)
			url_inst.url_free (l_new_parsed)
			free (create {CE_POINTER [ANY]}.make_cast (l_upos))
			if not l_success then
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Redirection %"%%s%" failed the test.%N"), a_redirected])
					end
					js.break
				end
			end
			Result := l_success
		end

	download_child_p (a_upos: CE_POINTER [PD_URLPOS]; a_parent: CE_POINTER [PD_URL]; a_depth___0: INTEGER_32; a_start_url_parsed: CE_POINTER [PD_URL]; a_blacklist: CE_POINTER [PD_HASH_TABLE]; a_iri: CE_POINTER [PD_IRI]): BOOLEAN
		local
			l_u: CE_POINTER [PD_URL]
			l_url: CE_POINTER [INTEGER_8]
			l_u_scheme_like_http: BOOLEAN
			l_referrer: CE_POINTER [INTEGER_8]
			l_specs: CE_POINTER [PD_ROBOT_SPECS]
			l_rfile: CE_ARRAY [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_u.make
			create l_url.make
			create l_referrer.make
			create l_specs.make
			create l_rfile.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := a_upos.item.url
					l_url := l_u.item.url
					from
					until
						js.loop_done
					loop
						if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("Deciding whether to enqueue %"%%s%".%N"), l_url])
						end
						js.break
					end
					if (utils_inst.string_set_contains (a_blacklist, l_url)).to_boolean then
						if options_inst.opt.item.spider then
							l_referrer := (url_inst.url_string (a_parent, {PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD))
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("download_child_p: parent->url is: %%s%N"), (quote_inst.quote (a_parent.item.url))])
								end
								js.break
							end
							free (create {CE_POINTER [ANY]}.make_cast (l_referrer))
						end
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Already on the black list.%N")])
							end
							js.break
						end
						l_pos := -1 + 42 -- goto out
					end
				when 1 then
					l_u_scheme_like_http := url_inst.schemes_are_similar_p (l_u.item.scheme, {PC_URL_SCHEME}.SCHEME_HTTP)
					if l_u_scheme_like_http then
						l_pos := -1 + 6 -- skip if block
					end
				when 2 then -- if:
						if l_u.item.scheme /= {NATURAL_32} 1 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not options_inst.opt.item.follow_ftp then
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Not following non-HTTP schemes.%N")])
							end
							js.break
						end
						l_pos := -1 + 42 -- goto out
				when 6 then -- if done
						if l_u_scheme_like_http then
							if options_inst.opt.item.relative_only then
								if not (a_upos.item.link_relative_p).to_boolean then
									from
									until
										js.loop_done
									loop
										if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("It doesn%'t really look like a relative link.%N")])
										end
										js.break
									end
									l_pos := -1 + 42 -- goto out
								end
							end
						end
				when 7 then
						if not (host_inst.accept_domain (l_u)) then
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("The domain was not accepted.%N")])
								end
								js.break
							end
							l_pos := -1 + 42 -- goto out
						end
				when 8 then
						if not (options_inst.opt.item.no_parent) then
							l_pos := -1 + 16 -- skip if block
						end
				when 9 then -- if:
							if not (url_inst.schemes_are_similar_p (l_u.item.scheme, a_start_url_parsed.item.scheme)) then
								l_pos := -1 + 16 -- skip if block
							end
				when 10 then -- if:
							if 0 /= (strcasecmp (l_u.item.host, a_start_url_parsed.item.host)) then
								l_pos := -1 + 16 -- skip if block
							end
				when 11 then -- if:
							if l_u.item.port /= a_start_url_parsed.item.port then
								l_pos := -1 + 16 -- skip if block
							end
				when 12 then -- if:
							if not (options_inst.opt.item.page_requisites) then
								l_pos := -1 + 15 -- skip if block
							end
				when 13 then -- if:
							if not (a_upos.item.link_inline_p).to_boolean then
								l_pos := -1 + 15 -- goto _L___0
							end
				when 14 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 15 then -- else: | _L___0:
							if not (utils_inst.subdir_p (a_start_url_parsed.item.dir, l_u.item.dir)) then
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("Going to %"%%s%" would escape %"%%s%" with no_parent on.%N"), l_u.item.dir, a_start_url_parsed.item.dir])
									end
									js.break
								end
								l_pos := -1 + 42 -- goto out
							end
				when 16 then -- if done | if done | if done | if done
							if (options_inst.opt.item.includes).is_void then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
								l_pos := -1 + 20 -- goto _L___1
				when 18 then -- if block done, skip else block:
								l_pos := -1 + 21
				when 19 then -- else:
								if (options_inst.opt.item.excludes).is_void then
									l_pos := -1 + 21 -- skip if block
								end
				when 20 then -- if: | _L___1:
								if not (utils_inst.accdir (l_u.item.dir)) then
									from
									until
										js.loop_done
									loop
										if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("%%s (%%s) is excluded/not-included.%N"), l_url, l_u.item.dir])
										end
										js.break
									end
									l_pos := -1 + 42 -- goto out
								end
				when 21 then -- if done
								if (l_u.item.file[0]).to_integer_32 = 0 then
									l_pos := -1 + 26 -- skip if block
								end
				when 22 then -- if:
									if not (utils_inst.has_html_suffix_p (l_u.item.file)) then
										l_pos := -1 + 25 -- skip if block
									end
				when 23 then -- if:
									if options_inst.opt.item.reclevel /= -1 then
										if not (a_depth___0 < options_inst.opt.item.reclevel - 1) then
											if not options_inst.opt.item.page_requisites then
												l_pos := -1 + 25 -- goto _L___2
											end
										end
									end
				when 24 then -- if block done, skip else block:
									l_pos := -1 + 26
				when 25 then -- else: | _L___2:
									if not (utils_inst.acceptable (l_u.item.file)) then
										from
										until
											js.loop_done
										loop
											if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
												log_inst.debug_logprintf ([ce_string ("%%s (%%s) does not match acc/rej rules.%N"), l_url, l_u.item.file])
											end
											js.break
										end
										l_pos := -1 + 42 -- goto out
									end
				when 26 then -- if done
									if (url_inst.schemes_are_similar_p (l_u.item.scheme, a_parent.item.scheme)) then
										if not options_inst.opt.item.spanhost then
											if 0 /= (strcasecmp (a_parent.item.host, l_u.item.host)) then
												from
												until
													js.loop_done
												loop
													if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
														log_inst.debug_logprintf ([ce_string ("This is not the same hostname as the parent%'s (%%s and %%s).%N"), l_u.item.host, a_parent.item.host])
													end
													js.break
												end
												l_pos := -1 + 42 -- goto out
											end
										end
									end
				when 27 then
									if not (options_inst.opt.item.use_robots) then
										l_pos := -1 + 41 -- skip if block
									end
				when 28 then -- if:
										if not l_u_scheme_like_http then
											l_pos := -1 + 41 -- skip if block
										end
				when 29 then -- if:
										l_specs := (res_inst.res_get_specs (l_u.item.host, l_u.item.port))
										if (not l_specs.is_void) then
											l_pos := -1 + 40 -- skip if block
										end
				when 30 then -- if:
										if not (res_inst.res_retrieve_file (l_url, l_rfile, a_iri)) then
											l_pos := -1 + 38 -- skip if block
										end
				when 31 then -- if:
										l_specs := res_inst.res_parse_from_file (l_rfile.item)
										if not (options_inst.opt.item.delete_after) then
											l_pos := -1 + 34 -- skip if block
										end
				when 32 then -- if:
										l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
										l_pos := -1 + 36
				when 34 then -- else:
										if not (options_inst.opt.item.spider) then
											l_pos := -1 + 36 -- skip if block
										end
				when 35 then -- if: | _L___3:
										log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("Removing %%s.%N"), l_rfile.item])
										if (unlink (l_rfile.item)).to_boolean then
											log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), (strerror ((errno_location).item))])
										end
				when 36 then -- if done
										free (create {CE_POINTER [ANY]}.make_cast (l_rfile.item))
				when 37 then -- if block done, skip else block:
										l_pos := -1 + 39
				when 38 then -- else:
										l_specs := res_inst.res_parse (ce_string (""), 0)
				when 39 then -- if done
										res_inst.res_register_specs (l_u.item.host, l_u.item.port, l_specs)
				when 40 then -- if done
										if not (res_inst.res_match_path (l_specs, l_u.item.path)) then
											from
											until
												js.loop_done
											loop
												if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
													log_inst.debug_logprintf ([ce_string ("Not following %%s because robots.txt forbids it.%N"), l_url])
												end
												js.break
											end
											utils_inst.string_set_add (a_blacklist, l_url)
											l_pos := -1 + 42 -- goto out
										end
				when 41 then -- if done
										from
										until
											js.loop_done
										loop
											if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
												log_inst.debug_logprintf ([ce_string ("Decided to load it.%N")])
											end
											js.break
										end
										Result := (1).to_boolean
										js.return
										if js.return_called then
											l_pos := -1 + 43 -- skip if block
										end
				when 42 then -- if: | out:
											from
											until
												js.loop_done
											loop
												if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
													log_inst.debug_logprintf ([ce_string ("Decided NOT to load it.%N")])
												end
												js.break
											end
											Result := (0).to_boolean
				when 43 then
										l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
							end

	retrieve_tree (a_start_url_parsed: CE_POINTER [PD_URL]; a_pi: CE_POINTER [PD_IRI]): NATURAL_32
		local
			l_status: NATURAL_32
			l_queue: CE_POINTER [PD_URL_QUEUE]
			l_blacklist: CE_POINTER [PD_HASH_TABLE]
			l_i: CE_ARRAY [CE_POINTER [PD_IRI]]
			l_descend: BOOLEAN
			l_url: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_referer: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_file: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_depth___0: CE_ARRAY [INTEGER_32]
			l_html_allowed: CE_ARRAY [BOOLEAN]
			l_css_allowed: CE_ARRAY [BOOLEAN]
			l_is_css: BOOLEAN
			l_dash_p_leaf_HTML: BOOLEAN
			l_dt: CE_ARRAY [INTEGER_32]
			l_url_err: CE_ARRAY [INTEGER_32]
			l_redirected: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_url_parsed: CE_POINTER [PD_URL]
			l_meta_disallow_follow: CE_ARRAY [BOOLEAN]
			l_children: CE_POINTER [PD_URLPOS]
			l_tmp___13: CE_POINTER [PD_URLPOS]
			l_child: CE_POINTER [PD_URLPOS]
			l_url_parsed___0: CE_POINTER [PD_URL]
			l_ci: CE_POINTER [PD_IRI]
			l_referer_url: CE_POINTER [INTEGER_8]
			l_strip_auth: BOOLEAN
			l_tmp___15: INTEGER_32
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_d1: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_d2: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_d3: CE_ARRAY [INTEGER_32]
			l_d4: CE_ARRAY [BOOLEAN]
			l_d5: CE_ARRAY [BOOLEAN]
			l_d6: CE_ARRAY [CE_POINTER [PD_IRI]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_queue.make
			create l_blacklist.make
			create l_i.make (<<1>>)
			create l_url.make (<<1>>)
			create l_referer.make (<<1>>)
			create l_file.make (<<1>>)
			create l_depth___0.make (<<1>>)
			create l_html_allowed.make (<<1>>)
			create l_css_allowed.make (<<1>>)
			create l_dt.make (<<1>>)
			create l_url_err.make (<<1>>)
			create l_redirected.make (<<1>>)
			create l_url_parsed.make
			create l_meta_disallow_follow.make (<<1>>)
			create l_children.make
			create l_tmp___13.make
			create l_child.make
			create l_url_parsed___0.make
			create l_ci.make
			create l_referer_url.make
			create l_tmp___16.make
			create l_tmp___19.make
			create l_tmp___20.make
			create l_tmp___22.make
			create l_tmp___24.make
			create l_d1.make (<<1>>)
			create l_d2.make (<<1>>)
			create l_d3.make (<<1>>)
			create l_d4.make (<<1>>)
			create l_d5.make (<<1>>)
			create l_d6.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_status := {PC_UERR_T}.RETROK
					l_i.item := iri_inst.dummy_iri
					if (not a_pi.is_void) then
						if (not (a_pi.item.uri_encoding).is_void) then
							l_i.item.item.uri_encoding := (xmalloc_inst.xstrdup (a_pi.item.uri_encoding))
						else
							l_i.item.item.uri_encoding := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
						if (not (a_pi.item.content_encoding).is_void) then
							l_i.item.item.content_encoding := (xmalloc_inst.xstrdup (a_pi.item.content_encoding))
						else
							l_i.item.item.content_encoding := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
						l_i.item.item.utf8_encode := a_pi.item.utf8_encode
					end
					l_queue := url_queue_new
					l_blacklist := hash_inst.make_string_hash_table (0)
					url_enqueue (l_queue, l_i.item, (xmalloc_inst.xstrdup (a_start_url_parsed.item.url)), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), 0, (1).to_boolean, (0).to_boolean)
					utils_inst.string_set_add (l_blacklist, a_start_url_parsed.item.url)
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 25 -- skip loop
					end
				when 2 then -- loop body:
						l_descend := (0).to_boolean
						l_file.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_is_css := (0).to_boolean
						l_dash_p_leaf_HTML := (0).to_boolean
						if (options_inst.opt.item.quota).to_boolean then
							if retr_inst.total_downloaded_bytes > options_inst.opt.item.quota then
								js.break
							end
						end
						if not js.loop_jumped and then (l_status = {NATURAL_32} 26) then
							js.break
						end
						if not js.loop_jumped then
							if not (url_dequeue (l_queue, l_i, l_url, l_referer, l_depth___0, l_html_allowed, l_css_allowed)) then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 24 -- skip if block
						end
				when 3 then -- if:
						if convert_inst.dl_url_file_map.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (hash_inst.hash_table_contains (convert_inst.dl_url_file_map, create {CE_POINTER [ANY]}.make_cast (l_url.item))).to_boolean then
							l_file.item := xmalloc_inst.xstrdup (create {CE_POINTER [INTEGER_8]}.make_cast ((hash_inst.hash_table_get (convert_inst.dl_url_file_map, create {CE_POINTER [ANY]}.make_cast (l_url.item)))))
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Already downloaded %"%%s%", reusing it from %"%%s%".%N"), l_url.item, l_file.item])
								end
								js.break
							end
							if l_html_allowed.item then
								if (not convert_inst.downloaded_html_set.is_void) then
									if (utils_inst.string_set_contains (convert_inst.downloaded_html_set, l_file.item)).to_boolean then
										l_descend := (1).to_boolean
										l_is_css := (0).to_boolean
									end
								end
							end
							if l_css_allowed.item then
								if (not convert_inst.downloaded_css_set.is_void) then
									if (utils_inst.string_set_contains (convert_inst.downloaded_css_set, l_file.item)).to_boolean then
										l_descend := (1).to_boolean
										l_is_css := (1).to_boolean
									end
								end
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_dt.item := 0
						l_redirected.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_url_parsed := (url_inst.url_parse (l_url.item, l_url_err, l_i.item, (1).to_boolean))
						l_status := retr_inst.retrieve_url (l_url_parsed, l_url.item, l_file, l_redirected, l_referer.item, l_dt, (0).to_boolean, l_i.item, (1).to_boolean)
						if l_html_allowed.item then
							if (not (l_file.item).is_void) then
								if l_status = {NATURAL_32} 31 then
									if ((l_dt.item).bit_and (2)).to_boolean then
										if ((l_dt.item).bit_and (1)).to_boolean then
											l_descend := (1).to_boolean
											l_is_css := (0).to_boolean
										end
									end
								end
							end
						end
						if (not (l_file.item).is_void) then
							if l_status = {NATURAL_32} 31 then
								if ((l_dt.item).bit_and (2)).to_boolean then
									if ((l_dt.item).bit_and (64)).to_boolean then
										l_descend := (1).to_boolean
										l_is_css := (1).to_boolean
									elseif l_css_allowed.item then
										l_descend := (1).to_boolean
										l_is_css := (1).to_boolean
									end
								end
							end
						end
						if (not (l_redirected.item).is_void) then
							if l_descend then
								if (descend_redirect_p (l_redirected.item, l_url_parsed, l_depth___0.item, a_start_url_parsed, l_blacklist, l_i.item)) then
									utils_inst.string_set_add (l_blacklist, l_url.item)
								else
									l_descend := (0).to_boolean
								end
							end
							free (create {CE_POINTER [ANY]}.make_cast (l_url.item))
							l_url.item := l_redirected.item
						else
							free (create {CE_POINTER [ANY]}.make_cast (l_url.item))
							l_url.item := xmalloc_inst.xstrdup (l_url_parsed.item.url)
						end
						url_inst.url_free (l_url_parsed)
				when 7 then
						if not l_descend then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if not (l_depth___0.item >= options_inst.opt.item.reclevel) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if options_inst.opt.item.reclevel = -1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 10 then -- if:
						if not (options_inst.opt.item.page_requisites) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_depth___0.item = options_inst.opt.item.reclevel then
							l_dash_p_leaf_HTML := (1).to_boolean
						elseif l_depth___0.item = options_inst.opt.item.reclevel + 1 then
							l_dash_p_leaf_HTML := (1).to_boolean
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___0:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Not descending further; at depth %%d, max. %%d.%N"), l_depth___0.item, options_inst.opt.item.reclevel])
							end
							js.break
						end
						l_descend := (0).to_boolean
				when 14 then -- if done | if done | if done
						if l_descend then
							l_meta_disallow_follow.item := (0).to_boolean
							if l_is_css then
								l_tmp___13 := (css_url_inst.get_urls_css_file (l_file.item, l_url.item))
							else
								l_tmp___13 := (html_url_inst.get_urls_html (l_file.item, l_url.item, l_meta_disallow_follow, l_i.item))
							end
							l_children := l_tmp___13
							if options_inst.opt.item.use_robots then
								if l_meta_disallow_follow.item then
									retr_inst.free_urlpos (l_children)
									l_children := create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer)
								end
							end
							if (not l_children.is_void) then
								l_child := l_children
								l_url_parsed___0 := (url_inst.url_parse (l_url.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_i.item, (1).to_boolean))
								l_referer_url := l_url.item
								if not l_url_parsed___0.is_void then
									if not (l_url_parsed___0.item.user).is_void then
										l_tmp___15 := 1
									else
										l_tmp___15 := 0
									end
								else
									l_tmp___15 := 0
								end
								l_strip_auth := l_tmp___15.to_boolean
								if l_url_parsed___0.is_void then
									assert_fail (ce_string ("url_parsed != ((void *)0)"), ce_string ("recur.c"), {NATURAL_32} 388, ce_string ("retrieve_tree"))
								end
								if l_strip_auth then
									l_referer_url := url_inst.url_string (l_url_parsed___0, {PC_URL_AUTH_MODE}.URL_AUTH_HIDE)
								end
								from
								until
									l_child.is_void
								loop
									if (l_child.item.ignore_when_downloading).to_boolean then
										js.continue
									end
									if not js.loop_jumped and then l_dash_p_leaf_HTML then
										if not (l_child.item.link_inline_p).to_boolean then
											js.continue
										end
									end
									if not js.loop_jumped then
										if (download_child_p (l_child, l_url_parsed___0, l_depth___0.item, a_start_url_parsed, l_blacklist, l_i.item)) then
											l_ci := iri_inst.dummy_iri
											l_tmp___16 := xmalloc_inst.xstrdup (l_referer_url)
											url_enqueue (l_queue, l_ci, (xmalloc_inst.xstrdup ((l_child.item.url).item.url)), l_tmp___16, l_depth___0.item + 1, (l_child.item.link_expect_html).to_boolean, (l_child.item.link_expect_css).to_boolean)
											utils_inst.string_set_add (l_blacklist, (l_child.item.url).item.url)
										end
									end
									l_child := l_child.item.next
								end
								if l_strip_auth then
									free (create {CE_POINTER [ANY]}.make_cast (l_referer_url))
								end
								url_inst.url_free (l_url_parsed___0)
								retr_inst.free_urlpos (l_children)
							end
						end
						if (l_file.item).is_void then
							l_pos := -1 + 23 -- skip if block
						end
				when 15 then -- if:
						if not (options_inst.opt.item.delete_after) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 22 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 18 then -- else:
						if not (options_inst.opt.item.spider) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___1
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if (utils_inst.acceptable (l_file.item)) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___1:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								if options_inst.opt.item.delete_after then
									l_tmp___20 := ce_string ("--delete-after")
								else
									if options_inst.opt.item.spider then
										l_tmp___19 := ce_string ("--spider")
									else
										l_tmp___19 := ce_string ("recursive rejection criteria")
									end
									l_tmp___20 := l_tmp___19
								end
								log_inst.debug_logprintf ([ce_string ("Removing file due to %%s in recursive_retrieve():%N"), l_tmp___20])
							end
							js.break
						end
						if options_inst.opt.item.delete_after then
							l_tmp___22 := gettext (ce_string ("Removing %%s.%N"))
							l_tmp___24 := l_tmp___22
						elseif options_inst.opt.item.spider then
							l_tmp___22 := gettext (ce_string ("Removing %%s.%N"))
							l_tmp___24 := l_tmp___22
						else
							l_tmp___24 := (gettext (ce_string ("Removing %%s since it should be rejected.%N")))
						end
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___24, l_file.item])
						if (unlink (l_file.item)).to_boolean then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), (strerror ((errno_location).item))])
						end
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						convert_inst.register_delete_file (l_file.item)
				when 23 then -- if done | if done | if done
						free (create {CE_POINTER [ANY]}.make_cast (l_url.item))
						if (not (l_referer.item).is_void) then
							free (create {CE_POINTER [ANY]}.make_cast (l_referer.item))
						end
						if (not (l_file.item).is_void) then
							free (create {CE_POINTER [ANY]}.make_cast (l_file.item))
						end
				when 24 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 25 then -- loop done
					from
					until
						js.loop_done
					loop
						if not (url_dequeue (l_queue, l_d6, l_d1, l_d2, l_d3, l_d4, l_d5)) then
							js.break
						end
						if not js.loop_jumped then
							free (create {CE_POINTER [ANY]}.make_cast (l_d1.item))
							if (not (l_d2.item).is_void) then
								free (create {CE_POINTER [ANY]}.make_cast (l_d2.item))
							end
						end
					end
					url_queue_delete (l_queue)
					utils_inst.string_set_free (l_blacklist)
					if not ((options_inst.opt.item.quota).to_boolean) then
						l_pos := -1 + 28 -- skip if block
					end
				when 26 then -- if:
						if retr_inst.total_downloaded_bytes > options_inst.opt.item.quota then
							Result := ({PC_UERR_T}.QUOTEXC)
						else
							l_pos := -1 + 28 -- goto _L___2
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L___2:
						if l_status = {NATURAL_32} 26 then
							Result := ({PC_UERR_T}.FWRITEERR)
						else
							Result := ({PC_UERR_T}.RETROK)
						end
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	url_dequeue (a_queue: CE_POINTER [PD_URL_QUEUE]; a_i: CE_POINTER [CE_POINTER [PD_IRI]]; a_url: CE_POINTER [CE_POINTER [INTEGER_8]]; a_referer: CE_POINTER [CE_POINTER [INTEGER_8]]; a_depth___0: CE_POINTER [INTEGER_32]; a_html_allowed: CE_POINTER [BOOLEAN]; a_css_allowed: CE_POINTER [BOOLEAN]): BOOLEAN
		local
			l_qel: CE_POINTER [PD_QUEUE_ELEMENT]
			js: JUMP_STATE
		do
			create l_qel.make

			l_qel := a_queue.item.head
			if l_qel.is_void then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				a_queue.item.head := (a_queue.item.head).item.next
				if (a_queue.item.head).is_void then
					a_queue.item.tail := create {CE_POINTER [PD_QUEUE_ELEMENT]}.make_shared (default_pointer)
				end
				a_i.item := l_qel.item.iri
				a_url.item := l_qel.item.url
				a_referer.item := l_qel.item.referer
				a_depth___0.item := l_qel.item.depth
				a_html_allowed.item := l_qel.item.html_allowed
				a_css_allowed.item := l_qel.item.css_allowed
				a_queue.item.count := (a_queue.item.count) - 1
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Dequeuing %%s at depth %%d%N"), (quotearg_inst.quotearg_n_style (0, {PC_QUOTING_STYLE}.escape_quoting_style, l_qel.item.url)), l_qel.item.depth])
					end
					js.break
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Queue count %%d, maxcount %%d.%N"), a_queue.item.count, a_queue.item.maxcount])
					end
					js.break
				end
				free (create {CE_POINTER [ANY]}.make_cast (l_qel))
				Result := (1).to_boolean
			end
		end

	url_enqueue (a_queue: CE_POINTER [PD_URL_QUEUE]; a_i: CE_POINTER [PD_IRI]; a_url: CE_POINTER [INTEGER_8]; a_referer: CE_POINTER [INTEGER_8]; a_depth___0: INTEGER_32; a_html_allowed: BOOLEAN; a_css_allowed: BOOLEAN)
		local
			l_qel: CE_POINTER [PD_QUEUE_ELEMENT]
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_qel.make
			create l_tmp___4.make

			l_qel := create {CE_POINTER [PD_QUEUE_ELEMENT]}.make_cast ((xmalloc_inst.xmalloc ((create {PD_QUEUE_ELEMENT}.make).structure_size.to_natural_32)))
			l_qel.item.iri := a_i
			l_qel.item.url := a_url
			l_qel.item.referer := a_referer
			l_qel.item.depth := a_depth___0
			l_qel.item.html_allowed := a_html_allowed
			l_qel.item.css_allowed := a_css_allowed
			l_qel.item.next := create {CE_POINTER [PD_QUEUE_ELEMENT]}.make_shared (default_pointer)
			a_queue.item.count := (a_queue.item.count) + 1
			if a_queue.item.count > a_queue.item.maxcount then
				a_queue.item.maxcount := a_queue.item.count
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
					log_inst.debug_logprintf ([ce_string ("Enqueuing %%s at depth %%d%N"), (quotearg_inst.quotearg_n_style (0, {PC_QUOTING_STYLE}.escape_quoting_style, a_url)), a_depth___0])
				end
				js.break
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
					log_inst.debug_logprintf ([ce_string ("Queue count %%d, maxcount %%d.%N"), a_queue.item.count, a_queue.item.maxcount])
				end
				js.break
			end
			if (not a_i.is_void) then
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						if (not (a_i.item.uri_encoding).is_void) then
							l_tmp___4 := (quote_inst.quote_n (1, a_i.item.uri_encoding))
						else
							l_tmp___4 := ce_string ("None")
						end
						log_inst.debug_logprintf ([ce_string ("[IRI Enqueuing %%s with %%s%N"), (quote_inst.quote_n (0, a_url)), l_tmp___4])
					end
					js.break
				end
			end
			if (not (a_queue.item.tail).is_void) then
				(a_queue.item.tail).item.next := l_qel
			end
			a_queue.item.tail := l_qel
			if (a_queue.item.head).is_void then
				a_queue.item.head := a_queue.item.tail
			end
		end

	url_queue_delete (a_queue: CE_POINTER [PD_URL_QUEUE])
		do
			free (create {CE_POINTER [ANY]}.make_cast (a_queue))
		end

	url_queue_new: CE_POINTER [PD_URL_QUEUE]
		local
			l_queue: CE_POINTER [PD_URL_QUEUE]
		do
			create l_queue.make

			l_queue := create {CE_POINTER [PD_URL_QUEUE]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, (create {PD_URL_QUEUE}.make).structure_size.to_natural_32)))
			Result := l_queue
		end

end
