class
	P_RES

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create registered_specs.make
		end

feature {ANY} -- attributes

	registered_specs: CE_POINTER [PD_HASH_TABLE] assign set_registered_specs

	set_registered_specs (a_registered_specs: CE_POINTER [PD_HASH_TABLE])
		do
			registered_specs := a_registered_specs
		end

feature {ANY} -- routines

	add_path (a_specs: CE_POINTER [PD_ROBOT_SPECS]; a_path_b: CE_POINTER [INTEGER_8]; a_path_e: CE_POINTER [INTEGER_8]; a_allowedp: BOOLEAN; a_exactp: BOOLEAN)
		local
			l_path_b: CE_POINTER [INTEGER_8]
			l_pp: PD_PATH_INFO
		do
			create l_path_b.make
			create l_pp.make

			l_path_b := a_path_b
			if (l_path_b.c_pointer.to_integer_32).to_natural_32 < (a_path_e.c_pointer.to_integer_32).to_natural_32 then
				if (l_path_b[0]).to_integer_32 = 47 then
					l_path_b := l_path_b + 1
				end
			end
			l_pp.path := utils_inst.strdupdelim (l_path_b, a_path_e)
			l_pp.allowedp := a_allowedp
			l_pp.user_agent_exact_p := a_exactp
			a_specs.item.count := (a_specs.item.count) + 1
			if a_specs.item.count > a_specs.item.size then
				if a_specs.item.size = 0 then
					a_specs.item.size := 1
				else
					a_specs.item.size := (a_specs.item.size).bit_shift_left ((1))
				end
				a_specs.item.paths := create {CE_POINTER [PD_PATH_INFO]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (a_specs.item.paths), (a_specs.item.size).to_natural_32 * (create {PD_PATH_INFO}.make).structure_size.to_natural_32)))
			end
			a_specs.item.paths[(a_specs.item.count - 1)] := l_pp.twin
		end

	free_specs (a_specs: CE_POINTER [PD_ROBOT_SPECS])
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < a_specs.item.count)
			loop
				free (create {CE_POINTER [ANY]}.make_cast ((a_specs.item.paths + l_i).item.path))
				l_i := l_i + 1
			end
			if (not (a_specs.item.paths).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (a_specs.item.paths))
			end
			free (create {CE_POINTER [ANY]}.make_cast (a_specs))
		end

	is_robots_txt_url (a_url: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_robots_url: CE_POINTER [INTEGER_8]
			l_ret: BOOLEAN
		do
			create l_robots_url.make

			l_robots_url := (url_inst.uri_merge (a_url, ce_string ("/robots.txt")))
			l_ret := (url_inst.are_urls_equal (a_url, l_robots_url))
			free (create {CE_POINTER [ANY]}.make_cast (l_robots_url))
			Result := l_ret
		end

	match_user_agent (a_agent: CE_POINTER [INTEGER_8]; a_length: INTEGER_32; a_matches___0: CE_POINTER [BOOLEAN]; a_exact_match: CE_POINTER [BOOLEAN])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_length /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_agent[0]).to_integer_32 = 42 then
							a_matches___0.item := (1).to_boolean
							a_exact_match.item := (0).to_boolean
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((a_agent + a_length).distance (a_agent)).to_natural_32 = (("wget").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if (strncasecmp (a_agent, ce_string ("wget"), (("wget").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
								a_matches___0.item := (0).to_boolean
								a_exact_match.item := (0).to_boolean
							else
								a_matches___0.item := (1).to_boolean
								a_exact_match.item := (1).to_boolean
							end
						else
							a_matches___0.item := (0).to_boolean
							a_exact_match.item := (0).to_boolean
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	matches (a_record_path: CE_POINTER [INTEGER_8]; a_url_path: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_rp: CE_POINTER [INTEGER_8]
			l_up: CE_POINTER [INTEGER_8]
			l_rc: INTEGER_8
			l_uc: INTEGER_8
			l_decoded: INTEGER_8
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_decoded___0: INTEGER_8
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
		do
			create l_rp.make
			create l_up.make

			l_rp := a_record_path
			l_up := a_url_path
			from
			until
				js.loop_done
			loop
				l_rc := l_rp[0]
				l_uc := l_up[0]
				if not l_rc.to_boolean then
					Result := (1).to_boolean
					js.return
				end
				if not js.return_called and then (not l_uc.to_boolean) then
					Result := (0).to_boolean
					js.return
				end
				if not js.return_called then
					from
					until
						js.loop_done
					loop
						if l_rc.to_integer_32 = 37 then
							if (c_ctype_inst.c2_isxdigit ((l_rp[1]).to_integer_32)) then
								if (c_ctype_inst.c2_isxdigit ((l_rp[2]).to_integer_32)) then
									if (l_rp[1]).to_integer_32 < 65 then
										l_tmp___0 := (l_rp[1]).to_integer_32 - 48
									else
										l_tmp___0 := (((c_ctype_inst.c2_toupper ((l_rp[1]).to_integer_32)) - 65) + 10)
									end
									if (l_rp[2]).to_integer_32 < 65 then
										l_tmp___2 := (l_rp[2]).to_integer_32 - 48
									else
										l_tmp___2 := (((c_ctype_inst.c2_toupper ((l_rp[2]).to_integer_32)) - 65) + 10)
									end
									l_decoded := (((l_tmp___0).bit_shift_left (4)) + l_tmp___2).to_integer_8
									if l_decoded.to_integer_32 /= 47 then
										l_rc := l_decoded
										l_rp := l_rp + (2)
									end
								end
							end
						end
						js.break
					end
					from
					until
						js.loop_done
					loop
						if l_uc.to_integer_32 = 37 then
							if (c_ctype_inst.c2_isxdigit ((l_up[1]).to_integer_32)) then
								if (c_ctype_inst.c2_isxdigit ((l_up[2]).to_integer_32)) then
									if (l_up[1]).to_integer_32 < 65 then
										l_tmp___6 := (l_up[1]).to_integer_32 - 48
									else
										l_tmp___6 := (((c_ctype_inst.c2_toupper ((l_up[1]).to_integer_32)) - 65) + 10)
									end
									if (l_up[2]).to_integer_32 < 65 then
										l_tmp___8 := (l_up[2]).to_integer_32 - 48
									else
										l_tmp___8 := (((c_ctype_inst.c2_toupper ((l_up[2]).to_integer_32)) - 65) + 10)
									end
									l_decoded___0 := (((l_tmp___6).bit_shift_left (4)) + l_tmp___8).to_integer_8
									if l_decoded___0.to_integer_32 /= 47 then
										l_uc := l_decoded___0
										l_up := l_up + (2)
									end
								end
							end
						end
						js.break
					end
					if l_rc.to_integer_32 /= l_uc.to_integer_32 then
						Result := (0).to_boolean
						js.return
					end
				end
				if not js.return_called then
					l_rp := l_rp + 1
					l_up := l_up + 1
				end
			end
		end

	prune_non_exact (a_specs: CE_POINTER [PD_ROBOT_SPECS])
		local
			l_newpaths: CE_POINTER [PD_PATH_INFO]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_cnt: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			create l_newpaths.make

			l_cnt := 0
			l_i := 0
			from
			until
				not (l_i < a_specs.item.count)
			loop
				if (a_specs.item.paths + l_i).item.user_agent_exact_p then
					l_cnt := l_cnt + 1
				end
				l_i := l_i + 1
			end
			l_newpaths := create {CE_POINTER [PD_PATH_INFO]}.make_cast ((xmalloc_inst.xmalloc (l_cnt.to_natural_32 * (create {PD_PATH_INFO}.make).structure_size.to_natural_32)))
			l_i := 0
			l_j := 0
			from
			until
				not (l_i < a_specs.item.count)
			loop
				if (a_specs.item.paths + l_i).item.user_agent_exact_p then
					l_tmp___0 := l_j
					l_j := l_j + 1
					l_newpaths[l_tmp___0] := (a_specs.item.paths[l_i]).twin
				end
				l_i := l_i + 1
			end
			if l_j /= l_cnt then
				assert_fail (ce_string ("j == cnt"), ce_string ("res.c"), {NATURAL_32} 172, ce_string ("prune_non_exact"))
			end
			free (create {CE_POINTER [ANY]}.make_cast (a_specs.item.paths))
			a_specs.item.paths := l_newpaths
			a_specs.item.count := l_cnt
			a_specs.item.size := l_cnt
		end

	res_cleanup
		local
			l_iter: CE_ARRAY [PD_HASH_TABLE_ITERATOR]
			js: JUMP_STATE
		do
			create l_iter.make (<<1>>)

			if (not registered_specs.is_void) then
				hash_inst.hash_table_iterate (registered_specs, l_iter)
				from
				until
					js.loop_done
				loop
					if not (hash_inst.hash_table_iter_next (l_iter)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						free (l_iter.item.key)
						free_specs (create {CE_POINTER [PD_ROBOT_SPECS]}.make_cast (l_iter.item.value))
					end
				end
				hash_inst.hash_table_destroy (registered_specs)
				registered_specs := create {CE_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer)
			end
		end

	res_get_specs (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): CE_POINTER [PD_ROBOT_SPECS]
		local
			l_hp: CE_POINTER [INTEGER_8]
			l_HP_len: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_hp.make

			from
			until
				js.loop_done
			loop
				l_HP_len := (strlen (a_host)).to_integer_32
				l_hp := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((((l_HP_len + 1) + (utils_inst.numdigit (a_port.to_integer_64))) + 1).to_natural_32)))
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_hp), create {CE_POINTER [ANY]}.make_cast (a_host), l_HP_len.to_natural_32).do_nothing
				l_hp[l_HP_len] := ((':').code).to_integer_8
				utils_inst.number_to_string ((l_hp + l_HP_len) + 1, a_port.to_integer_64).do_nothing
				js.break
			end
			if registered_specs.is_void then
				Result := (create {CE_POINTER [PD_ROBOT_SPECS]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_ROBOT_SPECS]}.make_cast ((hash_inst.hash_table_get (registered_specs, create {CE_POINTER [ANY]}.make_cast (l_hp)))))
			end
		end

	res_match_path (a_specs: CE_POINTER [PD_ROBOT_SPECS]; a_path: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_i: INTEGER_32
			l_allowedp: BOOLEAN
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make
			create l_tmp___0.make

			if a_specs.is_void then
				Result := (1).to_boolean
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (not js.loop_done and then (l_i < a_specs.item.count))
				loop
					if (matches ((a_specs.item.paths + l_i).item.path, a_path)) then
						l_allowedp := (a_specs.item.paths + l_i).item.allowedp
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								l_tmp := quote_inst.quote ((a_specs.item.paths + l_i).item.path)
								if l_allowedp then
									l_tmp___0 := ce_string ("Allowing")
								else
									l_tmp___0 := ce_string ("Rejecting")
								end
								log_inst.debug_logprintf ([ce_string ("%%s path %%s because of rule %%s.%N"), l_tmp___0, a_path, l_tmp])
							end
							js.break
						end
						Result := l_allowedp
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	res_parse (a_source: CE_POINTER [INTEGER_8]; a_length: INTEGER_32): CE_POINTER [PD_ROBOT_SPECS]
		local
			l_line_count: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_user_agent_applies: CE_ARRAY [BOOLEAN]
			l_user_agent_exact: CE_ARRAY [BOOLEAN]
			l_found_exact: BOOLEAN
			l_record_count: INTEGER_32
			l_specs: CE_POINTER [PD_ROBOT_SPECS]
			l_lineend: CE_POINTER [INTEGER_8]
			l_lineend_real: CE_POINTER [INTEGER_8]
			l_field_b: CE_POINTER [INTEGER_8]
			l_field_e: CE_POINTER [INTEGER_8]
			l_value_b: CE_POINTER [INTEGER_8]
			l_value_e: CE_POINTER [INTEGER_8]
			l_allowed: BOOLEAN
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_end.make
			create l_user_agent_applies.make (<<1>>)
			create l_user_agent_exact.make (<<1>>)
			create l_specs.make
			create l_lineend.make
			create l_lineend_real.make
			create l_field_b.make
			create l_field_e.make
			create l_value_b.make
			create l_value_e.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := 1
					l_p___0 := a_source
					l_end := a_source + a_length
					l_user_agent_applies.item := (0).to_boolean
					l_user_agent_exact.item := (0).to_boolean
					l_found_exact := (0).to_boolean
					l_record_count := 0
					l_specs := create {CE_POINTER [PD_ROBOT_SPECS]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, (create {PD_ROBOT_SPECS}.make).structure_size.to_natural_32)))
				when 1 then -- loop condition:
					if not (not js.loop_done and then (not (l_p___0.is_equal (l_end)))) then
						l_pos := -1 + 30 -- skip loop
					end
				when 2 then -- loop body:
						l_lineend_real := create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (l_p___0), ('%N').code, (l_end.distance (l_p___0)).to_natural_32)))
						if (not l_lineend_real.is_void) then
							l_lineend_real := l_lineend_real + 1
						else
							l_lineend_real := l_end
						end
						l_lineend := l_lineend_real
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
									if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 + 1
								end
							end
							js.break
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 29 -- goto next
						elseif (l_p___0[0]).to_integer_32 = 35 then
							l_pos := -1 + 29 -- goto next
						end
				when 3 then
						l_lineend := l_p___0
				when 4 then -- loop condition:
						if not (not js.loop_done and then ((l_lineend.c_pointer.to_integer_32).to_natural_32 < (l_lineend_real.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 5 then -- loop body:
						if not (l_lineend.is_equal (l_p___0)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not (c_ctype_inst.c2_isspace ((l_lineend[-1]).to_integer_32)) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if (l_lineend[0]).to_integer_32 = 35 then
							js.break
						end
				when 10 then -- if done
						if not js.loop_jumped then
							l_lineend := l_lineend + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 11 then -- loop done
						from
						until
							js.loop_done
						loop
							if (l_lineend.c_pointer.to_integer_32).to_natural_32 > (l_p___0.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isspace ((l_lineend[-1]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_lineend := l_lineend - 1
							end
						end
						if ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
							assert_fail (ce_string ("!((p) >= lineend)"), ce_string ("res.c"), {NATURAL_32} 276, ce_string ("res_parse"))
						end
						l_field_b := l_p___0
						from
						until
							js.loop_done
						loop
							if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
								if not (c_ctype_inst.c2_isalnum ((l_p___0[0]).to_integer_32)) then
									if (l_p___0[0]).to_integer_32 /= 45 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
						l_field_e := l_p___0
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
									if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 + 1
								end
							end
							js.break
						end
						if not (l_field_b.is_equal (l_field_e)) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 14 then -- else:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if (l_p___0[0]).to_integer_32 = 58 then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___0:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Ignoring malformed line %%d"), l_line_count])
							end
							js.break
						end
						l_pos := -1 + 29 -- goto next
				when 19 then -- if done | if done
						l_p___0 := l_p___0 + 1
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
									if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 + 1
								end
							end
							js.break
						end
						l_value_b := l_p___0
						from
						until
							((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32)
						loop
							l_p___0 := l_p___0 + 1
						end
						l_value_e := l_p___0
						if (l_field_e.distance (l_field_b)).to_natural_32 /= (("user-agent").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (strncasecmp (l_field_b, ce_string ("user-agent"), (("user-agent").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 22 -- goto _L___3
						else
							if l_record_count /= 0 then
								match_user_agent (l_value_b, l_value_e.distance (l_value_b), l_user_agent_applies, l_user_agent_exact)
							elseif (l_user_agent_applies.item).to_integer = 0 then
								match_user_agent (l_value_b, l_value_e.distance (l_value_b), l_user_agent_applies, l_user_agent_exact)
							end
							if l_user_agent_exact.item then
								l_found_exact := (1).to_boolean
							end
							l_record_count := 0
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else: | _L___3:
						if (l_field_e.distance (l_field_b)).to_natural_32 /= (("allow").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if (strncasecmp (l_field_b, ce_string ("allow"), (("allow").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 25 -- goto _L___2
						else
							if l_user_agent_applies.item then
								add_path (l_specs, l_value_b, l_value_e, (1).to_boolean, l_user_agent_exact.item)
							end
							l_record_count := l_record_count + 1
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 25 then -- else: | _L___2:
						if (l_field_e.distance (l_field_b)).to_natural_32 /= (("disallow").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if (strncasecmp (l_field_b, ce_string ("disallow"), (("disallow").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 28 -- goto _L___1
						else
							if l_user_agent_applies.item then
								l_allowed := (0).to_boolean
								if l_value_b.is_equal (l_value_e) then
									l_allowed := (1).to_boolean
								end
								add_path (l_specs, l_value_b, l_value_e, l_allowed, l_user_agent_exact.item)
							end
							l_record_count := l_record_count + 1
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L___1:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Ignoring unknown field at line %%d"), l_line_count])
							end
							js.break
						end
						l_pos := -1 + 29 -- goto next
				when 29 then -- if done | if done | next:
						l_p___0 := l_lineend_real
						l_line_count := l_line_count + 1
						l_pos := -1 + 1 -- back to loop condition
				when 30 then -- loop done
					if l_found_exact then
						prune_non_exact (l_specs)
					elseif l_specs.item.size > l_specs.item.count then
						l_specs.item.paths := create {CE_POINTER [PD_PATH_INFO]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_specs.item.paths), (l_specs.item.count).to_natural_32 * (create {PD_PATH_INFO}.make).structure_size.to_natural_32)))
						l_specs.item.size := l_specs.item.count
					end
					Result := l_specs
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	res_parse_from_file (a_filename: CE_POINTER [INTEGER_8]): CE_POINTER [PD_ROBOT_SPECS]
		local
			l_specs: CE_POINTER [PD_ROBOT_SPECS]
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_specs.make
			create l_fm.make
			create l_tmp___1.make

			l_fm := (utils_inst.read_file (a_filename))
			if l_fm.is_void then
				l_tmp___1 := strerror ((errno_location).item)
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot open %%s: %%s"))), a_filename, l_tmp___1])
				Result := (create {CE_POINTER [PD_ROBOT_SPECS]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_specs := res_parse (l_fm.item.content, (l_fm.item.length).to_integer_32)
				utils_inst.read_file_free (l_fm)
				Result := l_specs
			end
		end

	res_register_specs (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_specs: CE_POINTER [PD_ROBOT_SPECS])
		local
			l_old: CE_ARRAY [CE_POINTER [PD_ROBOT_SPECS]]
			l_hp: CE_POINTER [INTEGER_8]
			l_hp_old: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_HP_len: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_old.make (<<1>>)
			create l_hp.make
			create l_hp_old.make (<<1>>)

			from
			until
				js.loop_done
			loop
				l_HP_len := (strlen (a_host)).to_integer_32
				l_hp := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((((l_HP_len + 1) + (utils_inst.numdigit (a_port.to_integer_64))) + 1).to_natural_32)))
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_hp), create {CE_POINTER [ANY]}.make_cast (a_host), l_HP_len.to_natural_32).do_nothing
				l_hp[l_HP_len] := ((':').code).to_integer_8
				utils_inst.number_to_string ((l_hp + l_HP_len) + 1, a_port.to_integer_64).do_nothing
				js.break
			end
			if registered_specs.is_void then
				registered_specs := hash_inst.make_nocase_string_hash_table (0)
			end
			if (hash_inst.hash_table_get_pair (registered_specs, create {CE_POINTER [ANY]}.make_cast (l_hp), create {CE_POINTER [ANY]}.make_cast (l_hp_old), create {CE_POINTER [ANY]}.make_cast (l_old))).to_boolean then
				if (not (l_old.item).is_void) then
					free_specs (l_old.item)
				end
				hash_inst.hash_table_put (registered_specs, create {CE_POINTER [ANY]}.make_cast (l_hp_old.item), create {CE_POINTER [ANY]}.make_cast (a_specs))
			else
				hash_inst.hash_table_put (registered_specs, create {CE_POINTER [ANY]}.make_cast ((xmalloc_inst.xstrdup (l_hp))), create {CE_POINTER [ANY]}.make_cast (a_specs))
			end
		end

	res_retrieve_file (a_url: CE_POINTER [INTEGER_8]; a_file: CE_POINTER [CE_POINTER [INTEGER_8]]; a_iri: CE_POINTER [PD_IRI]): BOOLEAN
		local
			l_i: CE_POINTER [PD_IRI]
			l_err: NATURAL_32
			l_robots_url: CE_POINTER [INTEGER_8]
			l_saved_ts_val: INTEGER_32
			l_saved_sp_val: INTEGER_32
			l_url_err: CE_ARRAY [INTEGER_32]
			l_url_parsed: CE_POINTER [PD_URL]
			l_error___0: CE_POINTER [INTEGER_8]
		do
			create l_i.make
			create l_robots_url.make
			create l_url_err.make (<<1>>)
			create l_url_parsed.make
			create l_error___0.make

			l_i := iri_inst.dummy_iri
			l_robots_url := (url_inst.uri_merge (a_url, ce_string ("/robots.txt")))
			l_saved_ts_val := (options_inst.opt.item.timestamping).to_integer
			l_saved_sp_val := (options_inst.opt.item.spider).to_integer
			l_i.item.utf8_encode := (0).to_boolean
			log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Loading robots.txt; please ignore errors.%N"))))
			a_file.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			options_inst.opt.item.timestamping := (0).to_boolean
			options_inst.opt.item.spider := (0).to_boolean
			l_url_parsed := url_inst.url_parse (l_robots_url, l_url_err, a_iri, (1).to_boolean)
			if l_url_parsed.is_void then
				l_error___0 := (url_inst.url_error (l_robots_url, l_url_err.item))
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s.%N"), l_robots_url, l_error___0])
				free (create {CE_POINTER [ANY]}.make_cast (l_error___0))
				l_err := {PC_UERR_T}.URLERROR
			else
				l_err := retr_inst.retrieve_url (l_url_parsed, l_robots_url, a_file, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), (0).to_boolean, l_i, (0).to_boolean)
				url_inst.url_free (l_url_parsed)
			end
			options_inst.opt.item.timestamping := l_saved_ts_val.to_boolean
			options_inst.opt.item.spider := l_saved_sp_val.to_boolean
			free (create {CE_POINTER [ANY]}.make_cast (l_robots_url))
			if l_err /= {NATURAL_32} 31 then
				if not (a_file.item).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (a_file.item))
					a_file.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
			end
			Result := (l_err = {NATURAL_32} 31)
		end

end
