class
	SD_IN6_U

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	u6_addr8: CE_ARRAY [NATURAL_8]

	u6_addr16: CE_ARRAY [NATURAL_16]

	u6_addr32: CE_ARRAY [NATURAL_32]

feature {ANY}

	copy (a_other: like Current)
		do
			u6_addr8 := a_other.u6_addr8.twin
			u6_addr16 := a_other.u6_addr16.twin
			u6_addr32 := a_other.u6_addr32.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				u6_addr8.is_equal (a_other.u6_addr8) and
				u6_addr16.is_equal (a_other.u6_addr16) and
				u6_addr32.is_equal (a_other.u6_addr32)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("u6_addr8", <<16>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("u6_addr16", <<8>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("u6_addr32", <<4>>)
				>>)
			init_structure_info
		end

end
