class
	SD_MBSTATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create value.make
		end

feature {ANY} -- fields

	count: INTEGER_32 assign set_count

	value: SD_VALUE assign set_value

feature {ANY} -- setters

	set_count (a_count: INTEGER_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_value (a_value: SD_VALUE)
		do
			value := a_value
			update_memory_field ("value")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			count := a_other.count
			value := a_other.value.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				count = a_other.count and
				value.is_equal (a_other.value)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("value")
				>>)
			init_structure_info
		end

end
