class
	SD_OPTION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create flag.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	has_arg: INTEGER_32 assign set_has_arg

	flag: CE_POINTER [INTEGER_32] assign set_flag

	val: INTEGER_32 assign set_val

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_has_arg (a_has_arg: INTEGER_32)
		do
			has_arg := a_has_arg
			update_memory_field ("has_arg")
		end

	set_flag (a_flag: CE_POINTER [INTEGER_32])
		do
			flag := a_flag
			update_memory_field ("flag")
		end

	set_val (a_val: INTEGER_32)
		do
			val := a_val
			update_memory_field ("val")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			has_arg := a_other.has_arg
			flag := a_other.flag
			val := a_other.val
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				has_arg = a_other.has_arg and
				flag.is_equal (a_other.flag) and
				val = a_other.val
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("has_arg"),
					create {CE_STRUCTURE_FIELD}.make ("flag"),
					create {CE_STRUCTURE_FIELD}.make ("val")
				>>)
			init_structure_info
		end

end
