class
	PD_ASSOC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create label.make
			create ct.make
			create prog.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_ASSOC] assign set_next

	prev: CE_POINTER [PD_ASSOC] assign set_prev

	cnt: NATURAL_32 assign set_cnt

	label: CE_POINTER [NATURAL_8] assign set_label

	ct: CE_POINTER [NATURAL_8] assign set_ct

	prog: CE_POINTER [NATURAL_8] assign set_prog

	cons: INTEGER_32 assign set_cons

	xwin: INTEGER_32 assign set_xwin

	block: INTEGER_32 assign set_block

	ask: INTEGER_32 assign set_ask

	system: INTEGER_32 assign set_system

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_ASSOC])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_ASSOC])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_cnt (a_cnt: NATURAL_32)
		do
			cnt := a_cnt
			update_memory_field ("cnt")
		end

	set_label (a_label: CE_POINTER [NATURAL_8])
		do
			label := a_label
			update_memory_field ("label")
		end

	set_ct (a_ct: CE_POINTER [NATURAL_8])
		do
			ct := a_ct
			update_memory_field ("ct")
		end

	set_prog (a_prog: CE_POINTER [NATURAL_8])
		do
			prog := a_prog
			update_memory_field ("prog")
		end

	set_cons (a_cons: INTEGER_32)
		do
			cons := a_cons
			update_memory_field ("cons")
		end

	set_xwin (a_xwin: INTEGER_32)
		do
			xwin := a_xwin
			update_memory_field ("xwin")
		end

	set_block (a_block: INTEGER_32)
		do
			block := a_block
			update_memory_field ("block")
		end

	set_ask (a_ask: INTEGER_32)
		do
			ask := a_ask
			update_memory_field ("ask")
		end

	set_system (a_system: INTEGER_32)
		do
			system := a_system
			update_memory_field ("system")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			cnt := a_other.cnt
			label := a_other.label
			ct := a_other.ct
			prog := a_other.prog
			cons := a_other.cons
			xwin := a_other.xwin
			block := a_other.block
			ask := a_other.ask
			system := a_other.system
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				cnt = a_other.cnt and
				label.is_equal (a_other.label) and
				ct.is_equal (a_other.ct) and
				prog.is_equal (a_other.prog) and
				cons = a_other.cons and
				xwin = a_other.xwin and
				block = a_other.block and
				ask = a_other.ask and
				system = a_other.system
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("cnt"),
					create {CE_STRUCTURE_FIELD}.make ("label"),
					create {CE_STRUCTURE_FIELD}.make ("ct"),
					create {CE_STRUCTURE_FIELD}.make ("prog"),
					create {CE_STRUCTURE_FIELD}.make ("cons"),
					create {CE_STRUCTURE_FIELD}.make ("xwin"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("ask"),
					create {CE_STRUCTURE_FIELD}.make ("system")
				>>)
			init_structure_info
		end

end
