class
	PD_COOKIE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create name.make
			create value.make
			create server.make
			create path.make
			create domain.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_COOKIE] assign set_next

	prev: CE_POINTER [PD_COOKIE] assign set_prev

	name: CE_POINTER [NATURAL_8] assign set_name

	value: CE_POINTER [NATURAL_8] assign set_value

	server: CE_POINTER [NATURAL_8] assign set_server

	path: CE_POINTER [NATURAL_8] assign set_path

	domain: CE_POINTER [NATURAL_8] assign set_domain

	expires: INTEGER_32 assign set_expires

	secure: INTEGER_32 assign set_secure

	id: INTEGER_32 assign set_id

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_COOKIE])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_COOKIE])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_server (a_server: CE_POINTER [NATURAL_8])
		do
			server := a_server
			update_memory_field ("server")
		end

	set_path (a_path: CE_POINTER [NATURAL_8])
		do
			path := a_path
			update_memory_field ("path")
		end

	set_domain (a_domain: CE_POINTER [NATURAL_8])
		do
			domain := a_domain
			update_memory_field ("domain")
		end

	set_expires (a_expires: INTEGER_32)
		do
			expires := a_expires
			update_memory_field ("expires")
		end

	set_secure (a_secure: INTEGER_32)
		do
			secure := a_secure
			update_memory_field ("secure")
		end

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			name := a_other.name
			value := a_other.value
			server := a_other.server
			path := a_other.path
			domain := a_other.domain
			expires := a_other.expires
			secure := a_other.secure
			id := a_other.id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				name.is_equal (a_other.name) and
				value.is_equal (a_other.value) and
				server.is_equal (a_other.server) and
				path.is_equal (a_other.path) and
				domain.is_equal (a_other.domain) and
				expires = a_other.expires and
				secure = a_other.secure and
				id = a_other.id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("server"),
					create {CE_STRUCTURE_FIELD}.make ("path"),
					create {CE_STRUCTURE_FIELD}.make ("domain"),
					create {CE_STRUCTURE_FIELD}.make ("expires"),
					create {CE_STRUCTURE_FIELD}.make ("secure"),
					create {CE_STRUCTURE_FIELD}.make ("id")
				>>)
			init_structure_info
		end

end
