class
	PD_DIALOG_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create win.make
			create dlg.make
			create ml.make
			create items.make (<<1>>)
		end

feature {ANY} -- fields

	win: CE_POINTER [PD_WINDOW] assign set_win

	dlg: CE_POINTER [PD_DIALOG] assign set_dlg

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	xw: INTEGER_32 assign set_xw

	yw: INTEGER_32 assign set_yw

	n: INTEGER_32 assign set_n

	selected: INTEGER_32 assign set_selected

	ml: CE_POINTER [PD_MEMORY_LIST] assign set_ml

	items: CE_ARRAY [PD_DIALOG_ITEM_DATA]

feature {ANY} -- setters

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			win := a_win
			update_memory_field ("win")
		end

	set_dlg (a_dlg: CE_POINTER [PD_DIALOG])
		do
			dlg := a_dlg
			update_memory_field ("dlg")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_xw (a_xw: INTEGER_32)
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: INTEGER_32)
		do
			yw := a_yw
			update_memory_field ("yw")
		end

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_selected (a_selected: INTEGER_32)
		do
			selected := a_selected
			update_memory_field ("selected")
		end

	set_ml (a_ml: CE_POINTER [PD_MEMORY_LIST])
		do
			ml := a_ml
			update_memory_field ("ml")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			win := a_other.win
			dlg := a_other.dlg
			x := a_other.x
			y := a_other.y
			xw := a_other.xw
			yw := a_other.yw
			n := a_other.n
			selected := a_other.selected
			ml := a_other.ml
			items := a_other.items.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				win.is_equal (a_other.win) and
				dlg.is_equal (a_other.dlg) and
				x = a_other.x and
				y = a_other.y and
				xw = a_other.xw and
				yw = a_other.yw and
				n = a_other.n and
				selected = a_other.selected and
				ml.is_equal (a_other.ml) and
				items.is_equal (a_other.items)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("win"),
					create {CE_STRUCTURE_FIELD}.make ("dlg"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("selected"),
					create {CE_STRUCTURE_FIELD}.make ("ml"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("items", <<1>>)
				>>)
			init_structure_info
		end

end
