class
	PD_DIALOG_ITEM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fn.make
			create history.make
			create data.make
			create udata.make
			create text.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	gid: INTEGER_32 assign set_gid

	gnum: INTEGER_32 assign set_gnum

	fn: CE_ROUTINE assign set_fn

	history: CE_POINTER [PD_HISTORY] assign set_history

	dlen: INTEGER_32 assign set_dlen

	data: CE_POINTER [NATURAL_8] assign set_data

	udata: CE_POINTER [ANY] assign set_udata

	text: CE_POINTER [NATURAL_8] assign set_text

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_gid (a_gid: INTEGER_32)
		do
			gid := a_gid
			update_memory_field ("gid")
		end

	set_gnum (a_gnum: INTEGER_32)
		do
			gnum := a_gnum
			update_memory_field ("gnum")
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

	set_history (a_history: CE_POINTER [PD_HISTORY])
		do
			history := a_history
			update_memory_field ("history")
		end

	set_dlen (a_dlen: INTEGER_32)
		do
			dlen := a_dlen
			update_memory_field ("dlen")
		end

	set_data (a_data: CE_POINTER [NATURAL_8])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_udata (a_udata: CE_POINTER [ANY])
		do
			udata := a_udata
			update_memory_field ("udata")
		end

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			text := a_text
			update_memory_field ("text")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			gid := a_other.gid
			gnum := a_other.gnum
			fn := a_other.fn
			history := a_other.history
			dlen := a_other.dlen
			data := a_other.data
			udata := a_other.udata
			text := a_other.text
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				gid = a_other.gid and
				gnum = a_other.gnum and
				fn.is_equal (a_other.fn) and
				history.is_equal (a_other.history) and
				dlen = a_other.dlen and
				data.is_equal (a_other.data) and
				udata.is_equal (a_other.udata) and
				text.is_equal (a_other.text)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("gid"),
					create {CE_STRUCTURE_FIELD}.make ("gnum"),
					create {CE_STRUCTURE_FIELD}.make ("fn"),
					create {CE_STRUCTURE_FIELD}.make ("history"),
					create {CE_STRUCTURE_FIELD}.make ("dlen"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("udata"),
					create {CE_STRUCTURE_FIELD}.make ("text")
				>>)
			init_structure_info
		end

end
