class
	PD_F_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create url.make
			create opt.make
			create title.make
			create frame_desc.make
			create data.make
			create links.make
			create lines1.make
			create lines2.make
			create forms.make
			create tags.make
			create nodes.make
			create search.make
			create slines1.make
			create slines2.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_F_DATA] assign set_next

	prev: CE_POINTER [PD_F_DATA] assign set_prev

	refcount: INTEGER_32 assign set_refcount

	url: CE_POINTER [NATURAL_8] assign set_url

	opt: PD_DOCUMENT_OPTIONS assign set_opt

	title: CE_POINTER [NATURAL_8] assign set_title

	cp: INTEGER_32 assign set_cp

	ass: INTEGER_32 assign set_ass

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	time_to_get: INTEGER_32 assign set_time_to_get

	use_tag: NATURAL_32 assign set_use_tag

	frame: INTEGER_32 assign set_frame

	frame_desc: CE_POINTER [PD_FRAMESET_DESC] assign set_frame_desc

	bg: INTEGER_32 assign set_bg

	data: CE_POINTER [PD_LINE] assign set_data

	links: CE_POINTER [PD_LINK] assign set_links

	nlinks: INTEGER_32 assign set_nlinks

	lines1: CE_POINTER [CE_POINTER [PD_LINK]] assign set_lines1

	lines2: CE_POINTER [CE_POINTER [PD_LINK]] assign set_lines2

	forms: PD_LIST_HEAD assign set_forms

	tags: PD_LIST_HEAD assign set_tags

	nodes: PD_LIST_HEAD assign set_nodes

	search: CE_POINTER [PD_SEARCH] assign set_search

	nsearch: INTEGER_32 assign set_nsearch

	slines1: CE_POINTER [CE_POINTER [PD_SEARCH]] assign set_slines1

	slines2: CE_POINTER [CE_POINTER [PD_SEARCH]] assign set_slines2

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_F_DATA])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_F_DATA])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_refcount (a_refcount: INTEGER_32)
		do
			refcount := a_refcount
			update_memory_field ("refcount")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_opt (a_opt: PD_DOCUMENT_OPTIONS)
		do
			opt := a_opt
			update_memory_field ("opt")
		end

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			title := a_title
			update_memory_field ("title")
		end

	set_cp (a_cp: INTEGER_32)
		do
			cp := a_cp
			update_memory_field ("cp")
		end

	set_ass (a_ass: INTEGER_32)
		do
			ass := a_ass
			update_memory_field ("ass")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_time_to_get (a_time_to_get: INTEGER_32)
		do
			time_to_get := a_time_to_get
			update_memory_field ("time_to_get")
		end

	set_use_tag (a_use_tag: NATURAL_32)
		do
			use_tag := a_use_tag
			update_memory_field ("use_tag")
		end

	set_frame (a_frame: INTEGER_32)
		do
			frame := a_frame
			update_memory_field ("frame")
		end

	set_frame_desc (a_frame_desc: CE_POINTER [PD_FRAMESET_DESC])
		do
			frame_desc := a_frame_desc
			update_memory_field ("frame_desc")
		end

	set_bg (a_bg: INTEGER_32)
		do
			bg := a_bg
			update_memory_field ("bg")
		end

	set_data (a_data: CE_POINTER [PD_LINE])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_links (a_links: CE_POINTER [PD_LINK])
		do
			links := a_links
			update_memory_field ("links")
		end

	set_nlinks (a_nlinks: INTEGER_32)
		do
			nlinks := a_nlinks
			update_memory_field ("nlinks")
		end

	set_lines1 (a_lines1: CE_POINTER [CE_POINTER [PD_LINK]])
		do
			lines1 := a_lines1
			update_memory_field ("lines1")
		end

	set_lines2 (a_lines2: CE_POINTER [CE_POINTER [PD_LINK]])
		do
			lines2 := a_lines2
			update_memory_field ("lines2")
		end

	set_forms (a_forms: PD_LIST_HEAD)
		do
			forms := a_forms
			update_memory_field ("forms")
		end

	set_tags (a_tags: PD_LIST_HEAD)
		do
			tags := a_tags
			update_memory_field ("tags")
		end

	set_nodes (a_nodes: PD_LIST_HEAD)
		do
			nodes := a_nodes
			update_memory_field ("nodes")
		end

	set_search (a_search: CE_POINTER [PD_SEARCH])
		do
			search := a_search
			update_memory_field ("search")
		end

	set_nsearch (a_nsearch: INTEGER_32)
		do
			nsearch := a_nsearch
			update_memory_field ("nsearch")
		end

	set_slines1 (a_slines1: CE_POINTER [CE_POINTER [PD_SEARCH]])
		do
			slines1 := a_slines1
			update_memory_field ("slines1")
		end

	set_slines2 (a_slines2: CE_POINTER [CE_POINTER [PD_SEARCH]])
		do
			slines2 := a_slines2
			update_memory_field ("slines2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			refcount := a_other.refcount
			url := a_other.url
			opt := a_other.opt.twin
			title := a_other.title
			cp := a_other.cp
			ass := a_other.ass
			x := a_other.x
			y := a_other.y
			time_to_get := a_other.time_to_get
			use_tag := a_other.use_tag
			frame := a_other.frame
			frame_desc := a_other.frame_desc
			bg := a_other.bg
			data := a_other.data
			links := a_other.links
			nlinks := a_other.nlinks
			lines1 := a_other.lines1
			lines2 := a_other.lines2
			forms := a_other.forms.twin
			tags := a_other.tags.twin
			nodes := a_other.nodes.twin
			search := a_other.search
			nsearch := a_other.nsearch
			slines1 := a_other.slines1
			slines2 := a_other.slines2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				refcount = a_other.refcount and
				url.is_equal (a_other.url) and
				opt.is_equal (a_other.opt) and
				title.is_equal (a_other.title) and
				cp = a_other.cp and
				ass = a_other.ass and
				x = a_other.x and
				y = a_other.y and
				time_to_get = a_other.time_to_get and
				use_tag = a_other.use_tag and
				frame = a_other.frame and
				frame_desc.is_equal (a_other.frame_desc) and
				bg = a_other.bg and
				data.is_equal (a_other.data) and
				links.is_equal (a_other.links) and
				nlinks = a_other.nlinks and
				lines1.is_equal (a_other.lines1) and
				lines2.is_equal (a_other.lines2) and
				forms.is_equal (a_other.forms) and
				tags.is_equal (a_other.tags) and
				nodes.is_equal (a_other.nodes) and
				search.is_equal (a_other.search) and
				nsearch = a_other.nsearch and
				slines1.is_equal (a_other.slines1) and
				slines2.is_equal (a_other.slines2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("refcount"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("opt"),
					create {CE_STRUCTURE_FIELD}.make ("title"),
					create {CE_STRUCTURE_FIELD}.make ("cp"),
					create {CE_STRUCTURE_FIELD}.make ("ass"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("time_to_get"),
					create {CE_STRUCTURE_FIELD}.make ("use_tag"),
					create {CE_STRUCTURE_FIELD}.make ("frame"),
					create {CE_STRUCTURE_FIELD}.make ("frame_desc"),
					create {CE_STRUCTURE_FIELD}.make ("bg"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("links"),
					create {CE_STRUCTURE_FIELD}.make ("nlinks"),
					create {CE_STRUCTURE_FIELD}.make ("lines1"),
					create {CE_STRUCTURE_FIELD}.make ("lines2"),
					create {CE_STRUCTURE_FIELD}.make ("forms"),
					create {CE_STRUCTURE_FIELD}.make ("tags"),
					create {CE_STRUCTURE_FIELD}.make ("nodes"),
					create {CE_STRUCTURE_FIELD}.make ("search"),
					create {CE_STRUCTURE_FIELD}.make ("nsearch"),
					create {CE_STRUCTURE_FIELD}.make ("slines1"),
					create {CE_STRUCTURE_FIELD}.make ("slines2")
				>>)
			init_structure_info
		end

end
