class
	PD_FORM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create action.make
			create target.make
		end

feature {ANY} -- fields

	action: CE_POINTER [NATURAL_8] assign set_action

	target: CE_POINTER [NATURAL_8] assign set_target

	method: INTEGER_32 assign set_method

	num: INTEGER_32 assign set_num

feature {ANY} -- setters

	set_action (a_action: CE_POINTER [NATURAL_8])
		do
			action := a_action
			update_memory_field ("action")
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_method (a_method: INTEGER_32)
		do
			method := a_method
			update_memory_field ("method")
		end

	set_num (a_num: INTEGER_32)
		do
			num := a_num
			update_memory_field ("num")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			action := a_other.action
			target := a_other.target
			method := a_other.method
			num := a_other.num
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				action.is_equal (a_other.action) and
				target.is_equal (a_other.target) and
				method = a_other.method and
				num = a_other.num
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("action"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("method"),
					create {CE_STRUCTURE_FIELD}.make ("num")
				>>)
			init_structure_info
		end

end
