class
	PD_FORM_STATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create value.make
		end

feature {ANY} -- fields

	form_num: INTEGER_32 assign set_form_num

	ctrl_num: INTEGER_32 assign set_ctrl_num

	g_ctrl_num: INTEGER_32 assign set_g_ctrl_num

	position: INTEGER_32 assign set_position

	type: INTEGER_32 assign set_type

	value: CE_POINTER [NATURAL_8] assign set_value

	state: INTEGER_32 assign set_state

	vpos: INTEGER_32 assign set_vpos

	vypos: INTEGER_32 assign set_vypos

feature {ANY} -- setters

	set_form_num (a_form_num: INTEGER_32)
		do
			form_num := a_form_num
			update_memory_field ("form_num")
		end

	set_ctrl_num (a_ctrl_num: INTEGER_32)
		do
			ctrl_num := a_ctrl_num
			update_memory_field ("ctrl_num")
		end

	set_g_ctrl_num (a_g_ctrl_num: INTEGER_32)
		do
			g_ctrl_num := a_g_ctrl_num
			update_memory_field ("g_ctrl_num")
		end

	set_position (a_position: INTEGER_32)
		do
			position := a_position
			update_memory_field ("position")
		end

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_state (a_state: INTEGER_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_vpos (a_vpos: INTEGER_32)
		do
			vpos := a_vpos
			update_memory_field ("vpos")
		end

	set_vypos (a_vypos: INTEGER_32)
		do
			vypos := a_vypos
			update_memory_field ("vypos")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			form_num := a_other.form_num
			ctrl_num := a_other.ctrl_num
			g_ctrl_num := a_other.g_ctrl_num
			position := a_other.position
			type := a_other.type
			value := a_other.value
			state := a_other.state
			vpos := a_other.vpos
			vypos := a_other.vypos
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				form_num = a_other.form_num and
				ctrl_num = a_other.ctrl_num and
				g_ctrl_num = a_other.g_ctrl_num and
				position = a_other.position and
				type = a_other.type and
				value.is_equal (a_other.value) and
				state = a_other.state and
				vpos = a_other.vpos and
				vypos = a_other.vypos
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("form_num"),
					create {CE_STRUCTURE_FIELD}.make ("ctrl_num"),
					create {CE_STRUCTURE_FIELD}.make ("g_ctrl_num"),
					create {CE_STRUCTURE_FIELD}.make ("position"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("vpos"),
					create {CE_STRUCTURE_FIELD}.make ("vypos")
				>>)
			init_structure_info
		end

end
