class
	PD_FRAME

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create name.make
			create vs.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_FRAME] assign set_next

	prev: CE_POINTER [PD_FRAME] assign set_prev

	name: CE_POINTER [NATURAL_8] assign set_name

	redirect_cnt: INTEGER_32 assign set_redirect_cnt

	vs: PD_VIEW_STATE assign set_vs

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_FRAME])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_FRAME])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_redirect_cnt (a_redirect_cnt: INTEGER_32)
		do
			redirect_cnt := a_redirect_cnt
			update_memory_field ("redirect_cnt")
		end

	set_vs (a_vs: PD_VIEW_STATE)
		do
			vs := a_vs
			update_memory_field ("vs")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			name := a_other.name
			redirect_cnt := a_other.redirect_cnt
			vs := a_other.vs.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				name.is_equal (a_other.name) and
				redirect_cnt = a_other.redirect_cnt and
				vs.is_equal (a_other.vs)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("redirect_cnt"),
					create {CE_STRUCTURE_FIELD}.make ("vs")
				>>)
			init_structure_info
		end

end
