class
	PD_HTTP_CONNECTION_INFO

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	bl_flags: INTEGER_32 assign set_bl_flags

	http10: INTEGER_32 assign set_http10

	close: INTEGER_32 assign set_close

	length: INTEGER_32 assign set_length

	version: INTEGER_32 assign set_version

	chunk_remaining: INTEGER_32 assign set_chunk_remaining

feature {ANY} -- setters

	set_bl_flags (a_bl_flags: INTEGER_32)
		do
			bl_flags := a_bl_flags
			update_memory_field ("bl_flags")
		end

	set_http10 (a_http10: INTEGER_32)
		do
			http10 := a_http10
			update_memory_field ("http10")
		end

	set_close (a_close: INTEGER_32)
		do
			close := a_close
			update_memory_field ("close")
		end

	set_length (a_length: INTEGER_32)
		do
			length := a_length
			update_memory_field ("length")
		end

	set_version (a_version: INTEGER_32)
		do
			version := a_version
			update_memory_field ("version")
		end

	set_chunk_remaining (a_chunk_remaining: INTEGER_32)
		do
			chunk_remaining := a_chunk_remaining
			update_memory_field ("chunk_remaining")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bl_flags := a_other.bl_flags
			http10 := a_other.http10
			close := a_other.close
			length := a_other.length
			version := a_other.version
			chunk_remaining := a_other.chunk_remaining
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bl_flags = a_other.bl_flags and
				http10 = a_other.http10 and
				close = a_other.close and
				length = a_other.length and
				version = a_other.version and
				chunk_remaining = a_other.chunk_remaining
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bl_flags"),
					create {CE_STRUCTURE_FIELD}.make ("http10"),
					create {CE_STRUCTURE_FIELD}.make ("close"),
					create {CE_STRUCTURE_FIELD}.make ("length"),
					create {CE_STRUCTURE_FIELD}.make ("version"),
					create {CE_STRUCTURE_FIELD}.make ("chunk_remaining")
				>>)
			init_structure_info
		end

end
