class
	PD_K_CONN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create protocol.make
			create host.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_K_CONN] assign set_next

	prev: CE_POINTER [PD_K_CONN] assign set_prev

	protocol: CE_ROUTINE assign set_protocol

	host: CE_POINTER [NATURAL_8] assign set_host

	port: INTEGER_32 assign set_port

	conn: INTEGER_32 assign set_conn

	timeout: INTEGER_32 assign set_timeout

	add_time: INTEGER_32 assign set_add_time

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_K_CONN])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_K_CONN])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_protocol (a_protocol: CE_ROUTINE)
		do
			protocol := a_protocol
			update_memory_field ("protocol")
		end

	set_host (a_host: CE_POINTER [NATURAL_8])
		do
			host := a_host
			update_memory_field ("host")
		end

	set_port (a_port: INTEGER_32)
		do
			port := a_port
			update_memory_field ("port")
		end

	set_conn (a_conn: INTEGER_32)
		do
			conn := a_conn
			update_memory_field ("conn")
		end

	set_timeout (a_timeout: INTEGER_32)
		do
			timeout := a_timeout
			update_memory_field ("timeout")
		end

	set_add_time (a_add_time: INTEGER_32)
		do
			add_time := a_add_time
			update_memory_field ("add_time")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			protocol := a_other.protocol
			host := a_other.host
			port := a_other.port
			conn := a_other.conn
			timeout := a_other.timeout
			add_time := a_other.add_time
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				protocol.is_equal (a_other.protocol) and
				host.is_equal (a_other.host) and
				port = a_other.port and
				conn = a_other.conn and
				timeout = a_other.timeout and
				add_time = a_other.add_time
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("protocol"),
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("port"),
					create {CE_STRUCTURE_FIELD}.make ("conn"),
					create {CE_STRUCTURE_FIELD}.make ("timeout"),
					create {CE_STRUCTURE_FIELD}.make ("add_time")
				>>)
			init_structure_info
		end

end
