class
	PD_KEYBINDING

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_KEYBINDING] assign set_next

	prev: CE_POINTER [PD_KEYBINDING] assign set_prev

	act: INTEGER_32 assign set_act

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_KEYBINDING])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_KEYBINDING])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_act (a_act: INTEGER_32)
		do
			act := a_act
			update_memory_field ("act")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			act := a_other.act
			x := a_other.x
			y := a_other.y
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				act = a_other.act and
				x = a_other.x and
				y = a_other.y
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("act"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y")
				>>)
			init_structure_info
		end

end
