class
	PD_PROTOCOL_PROGRAM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create prog.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_PROTOCOL_PROGRAM] assign set_next

	prev: CE_POINTER [PD_PROTOCOL_PROGRAM] assign set_prev

	prog: CE_POINTER [NATURAL_8] assign set_prog

	system: INTEGER_32 assign set_system

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_PROTOCOL_PROGRAM])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_PROTOCOL_PROGRAM])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_prog (a_prog: CE_POINTER [NATURAL_8])
		do
			prog := a_prog
			update_memory_field ("prog")
		end

	set_system (a_system: INTEGER_32)
		do
			system := a_system
			update_memory_field ("system")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			prog := a_other.prog
			system := a_other.system
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				prog.is_equal (a_other.prog) and
				system = a_other.system
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("prog"),
					create {CE_STRUCTURE_FIELD}.make ("system")
				>>)
			init_structure_info
		end

end
