class
	PD_REMAINING_INFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data_in_secs.make (<<50>>)
		end

feature {ANY} -- fields

	valid: INTEGER_32 assign set_valid

	size: INTEGER_32 assign set_size

	loaded: INTEGER_32 assign set_loaded

	last_loaded: INTEGER_32 assign set_last_loaded

	cur_loaded: INTEGER_32 assign set_cur_loaded

	pos: INTEGER_32 assign set_pos

	elapsed: INTEGER_32 assign set_elapsed

	last_time: INTEGER_32 assign set_last_time

	dis_b: INTEGER_32 assign set_dis_b

	data_in_secs: CE_ARRAY [INTEGER_32]

	timer: INTEGER_32 assign set_timer

feature {ANY} -- setters

	set_valid (a_valid: INTEGER_32)
		do
			valid := a_valid
			update_memory_field ("valid")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_loaded (a_loaded: INTEGER_32)
		do
			loaded := a_loaded
			update_memory_field ("loaded")
		end

	set_last_loaded (a_last_loaded: INTEGER_32)
		do
			last_loaded := a_last_loaded
			update_memory_field ("last_loaded")
		end

	set_cur_loaded (a_cur_loaded: INTEGER_32)
		do
			cur_loaded := a_cur_loaded
			update_memory_field ("cur_loaded")
		end

	set_pos (a_pos: INTEGER_32)
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_elapsed (a_elapsed: INTEGER_32)
		do
			elapsed := a_elapsed
			update_memory_field ("elapsed")
		end

	set_last_time (a_last_time: INTEGER_32)
		do
			last_time := a_last_time
			update_memory_field ("last_time")
		end

	set_dis_b (a_dis_b: INTEGER_32)
		do
			dis_b := a_dis_b
			update_memory_field ("dis_b")
		end

	set_timer (a_timer: INTEGER_32)
		do
			timer := a_timer
			update_memory_field ("timer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			valid := a_other.valid
			size := a_other.size
			loaded := a_other.loaded
			last_loaded := a_other.last_loaded
			cur_loaded := a_other.cur_loaded
			pos := a_other.pos
			elapsed := a_other.elapsed
			last_time := a_other.last_time
			dis_b := a_other.dis_b
			data_in_secs := a_other.data_in_secs.twin
			timer := a_other.timer
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				valid = a_other.valid and
				size = a_other.size and
				loaded = a_other.loaded and
				last_loaded = a_other.last_loaded and
				cur_loaded = a_other.cur_loaded and
				pos = a_other.pos and
				elapsed = a_other.elapsed and
				last_time = a_other.last_time and
				dis_b = a_other.dis_b and
				data_in_secs.is_equal (a_other.data_in_secs) and
				timer = a_other.timer
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("valid"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("loaded"),
					create {CE_STRUCTURE_FIELD}.make ("last_loaded"),
					create {CE_STRUCTURE_FIELD}.make ("cur_loaded"),
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("elapsed"),
					create {CE_STRUCTURE_FIELD}.make ("last_time"),
					create {CE_STRUCTURE_FIELD}.make ("dis_b"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("data_in_secs", <<50>>),
					create {CE_STRUCTURE_FIELD}.make ("timer")
				>>)
			init_structure_info
		end

end
