class
	PD_RGB

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	r: NATURAL_8 assign set_r

	g: NATURAL_8 assign set_g

	b: NATURAL_8 assign set_b

	pad: NATURAL_8 assign set_pad

feature {ANY} -- setters

	set_r (a_r: NATURAL_8)
		do
			r := a_r
			update_memory_field ("r")
		end

	set_g (a_g: NATURAL_8)
		do
			g := a_g
			update_memory_field ("g")
		end

	set_b (a_b: NATURAL_8)
		do
			b := a_b
			update_memory_field ("b")
		end

	set_pad (a_pad: NATURAL_8)
		do
			pad := a_pad
			update_memory_field ("pad")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			r := a_other.r
			g := a_other.g
			b := a_other.b
			pad := a_other.pad
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				r = a_other.r and
				g = a_other.g and
				b = a_other.b and
				pad = a_other.pad
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("r"),
					create {CE_STRUCTURE_FIELD}.make ("g"),
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("pad")
				>>)
			init_structure_info
		end

end
