class
	PD_SMB_CONNECTION_INFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create text.make (<<1>>)
		end

feature {ANY} -- fields

	client: INTEGER_32 assign set_client

	list: INTEGER_32 assign set_list

	cl: INTEGER_32 assign set_cl

	ntext: INTEGER_32 assign set_ntext

	text: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_client (a_client: INTEGER_32)
		do
			client := a_client
			update_memory_field ("client")
		end

	set_list (a_list: INTEGER_32)
		do
			list := a_list
			update_memory_field ("list")
		end

	set_cl (a_cl: INTEGER_32)
		do
			cl := a_cl
			update_memory_field ("cl")
		end

	set_ntext (a_ntext: INTEGER_32)
		do
			ntext := a_ntext
			update_memory_field ("ntext")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			client := a_other.client
			list := a_other.list
			cl := a_other.cl
			ntext := a_other.ntext
			text := a_other.text.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				client = a_other.client and
				list = a_other.list and
				cl = a_other.cl and
				ntext = a_other.ntext and
				text.is_equal (a_other.text)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("client"),
					create {CE_STRUCTURE_FIELD}.make ("list"),
					create {CE_STRUCTURE_FIELD}.make ("cl"),
					create {CE_STRUCTURE_FIELD}.make ("ntext"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("text", <<1>>)
				>>)
			init_structure_info
		end

end
