class
	PD_TABLE_COLUMN

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	group: INTEGER_32 assign set_group

	align: INTEGER_32 assign set_align

	valign: INTEGER_32 assign set_valign

	width: INTEGER_32 assign set_width

feature {ANY} -- setters

	set_group (a_group: INTEGER_32)
		do
			group := a_group
			update_memory_field ("group")
		end

	set_align (a_align: INTEGER_32)
		do
			align := a_align
			update_memory_field ("align")
		end

	set_valign (a_valign: INTEGER_32)
		do
			valign := a_valign
			update_memory_field ("valign")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			group := a_other.group
			align := a_other.align
			valign := a_other.valign
			width := a_other.width
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				group = a_other.group and
				align = a_other.align and
				valign = a_other.valign and
				width = a_other.width
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make ("align"),
					create {CE_STRUCTURE_FIELD}.make ("valign"),
					create {CE_STRUCTURE_FIELD}.make ("width")
				>>)
			init_structure_info
		end

end
