class
	PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create p.make
			create min_c.make
			create max_c.make
			create w_c.make
			create cells.make
			create cols.make
			create xcols.make
			create r_heights.make
		end

feature {ANY} -- fields

	p: CE_POINTER [PD_PART] assign set_p

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	rx: INTEGER_32 assign set_rx

	ry: INTEGER_32 assign set_ry

	border: INTEGER_32 assign set_border

	cellpd: INTEGER_32 assign set_cellpd

	vcellpd: INTEGER_32 assign set_vcellpd

	cellsp: INTEGER_32 assign set_cellsp

	frame: INTEGER_32 assign set_frame

	rules: INTEGER_32 assign set_rules

	width: INTEGER_32 assign set_width

	wf: INTEGER_32 assign set_wf

	min_c: CE_POINTER [INTEGER_32] assign set_min_c

	max_c: CE_POINTER [INTEGER_32] assign set_max_c

	w_c: CE_POINTER [INTEGER_32] assign set_w_c

	rw: INTEGER_32 assign set_rw

	min_t: INTEGER_32 assign set_min_t

	max_t: INTEGER_32 assign set_max_t

	cells: CE_POINTER [PD_TABLE_CELL] assign set_cells

	c: INTEGER_32 assign set_c

	rc: INTEGER_32 assign set_rc

	cols: CE_POINTER [PD_TABLE_COLUMN] assign set_cols

	xc: INTEGER_32 assign set_xc

	xcols: CE_POINTER [INTEGER_32] assign set_xcols

	r_heights: CE_POINTER [INTEGER_32] assign set_r_heights

	rh: INTEGER_32 assign set_rh

	link_num: INTEGER_32 assign set_link_num

feature {ANY} -- setters

	set_p (a_p: CE_POINTER [PD_PART])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_rx (a_rx: INTEGER_32)
		do
			rx := a_rx
			update_memory_field ("rx")
		end

	set_ry (a_ry: INTEGER_32)
		do
			ry := a_ry
			update_memory_field ("ry")
		end

	set_border (a_border: INTEGER_32)
		do
			border := a_border
			update_memory_field ("border")
		end

	set_cellpd (a_cellpd: INTEGER_32)
		do
			cellpd := a_cellpd
			update_memory_field ("cellpd")
		end

	set_vcellpd (a_vcellpd: INTEGER_32)
		do
			vcellpd := a_vcellpd
			update_memory_field ("vcellpd")
		end

	set_cellsp (a_cellsp: INTEGER_32)
		do
			cellsp := a_cellsp
			update_memory_field ("cellsp")
		end

	set_frame (a_frame: INTEGER_32)
		do
			frame := a_frame
			update_memory_field ("frame")
		end

	set_rules (a_rules: INTEGER_32)
		do
			rules := a_rules
			update_memory_field ("rules")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_wf (a_wf: INTEGER_32)
		do
			wf := a_wf
			update_memory_field ("wf")
		end

	set_min_c (a_min_c: CE_POINTER [INTEGER_32])
		do
			min_c := a_min_c
			update_memory_field ("min_c")
		end

	set_max_c (a_max_c: CE_POINTER [INTEGER_32])
		do
			max_c := a_max_c
			update_memory_field ("max_c")
		end

	set_w_c (a_w_c: CE_POINTER [INTEGER_32])
		do
			w_c := a_w_c
			update_memory_field ("w_c")
		end

	set_rw (a_rw: INTEGER_32)
		do
			rw := a_rw
			update_memory_field ("rw")
		end

	set_min_t (a_min_t: INTEGER_32)
		do
			min_t := a_min_t
			update_memory_field ("min_t")
		end

	set_max_t (a_max_t: INTEGER_32)
		do
			max_t := a_max_t
			update_memory_field ("max_t")
		end

	set_cells (a_cells: CE_POINTER [PD_TABLE_CELL])
		do
			cells := a_cells
			update_memory_field ("cells")
		end

	set_c (a_c: INTEGER_32)
		do
			c := a_c
			update_memory_field ("c")
		end

	set_rc (a_rc: INTEGER_32)
		do
			rc := a_rc
			update_memory_field ("rc")
		end

	set_cols (a_cols: CE_POINTER [PD_TABLE_COLUMN])
		do
			cols := a_cols
			update_memory_field ("cols")
		end

	set_xc (a_xc: INTEGER_32)
		do
			xc := a_xc
			update_memory_field ("xc")
		end

	set_xcols (a_xcols: CE_POINTER [INTEGER_32])
		do
			xcols := a_xcols
			update_memory_field ("xcols")
		end

	set_r_heights (a_r_heights: CE_POINTER [INTEGER_32])
		do
			r_heights := a_r_heights
			update_memory_field ("r_heights")
		end

	set_rh (a_rh: INTEGER_32)
		do
			rh := a_rh
			update_memory_field ("rh")
		end

	set_link_num (a_link_num: INTEGER_32)
		do
			link_num := a_link_num
			update_memory_field ("link_num")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			p := a_other.p
			x := a_other.x
			y := a_other.y
			rx := a_other.rx
			ry := a_other.ry
			border := a_other.border
			cellpd := a_other.cellpd
			vcellpd := a_other.vcellpd
			cellsp := a_other.cellsp
			frame := a_other.frame
			rules := a_other.rules
			width := a_other.width
			wf := a_other.wf
			min_c := a_other.min_c
			max_c := a_other.max_c
			w_c := a_other.w_c
			rw := a_other.rw
			min_t := a_other.min_t
			max_t := a_other.max_t
			cells := a_other.cells
			c := a_other.c
			rc := a_other.rc
			cols := a_other.cols
			xc := a_other.xc
			xcols := a_other.xcols
			r_heights := a_other.r_heights
			rh := a_other.rh
			link_num := a_other.link_num
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				p.is_equal (a_other.p) and
				x = a_other.x and
				y = a_other.y and
				rx = a_other.rx and
				ry = a_other.ry and
				border = a_other.border and
				cellpd = a_other.cellpd and
				vcellpd = a_other.vcellpd and
				cellsp = a_other.cellsp and
				frame = a_other.frame and
				rules = a_other.rules and
				width = a_other.width and
				wf = a_other.wf and
				min_c.is_equal (a_other.min_c) and
				max_c.is_equal (a_other.max_c) and
				w_c.is_equal (a_other.w_c) and
				rw = a_other.rw and
				min_t = a_other.min_t and
				max_t = a_other.max_t and
				cells.is_equal (a_other.cells) and
				c = a_other.c and
				rc = a_other.rc and
				cols.is_equal (a_other.cols) and
				xc = a_other.xc and
				xcols.is_equal (a_other.xcols) and
				r_heights.is_equal (a_other.r_heights) and
				rh = a_other.rh and
				link_num = a_other.link_num
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("rx"),
					create {CE_STRUCTURE_FIELD}.make ("ry"),
					create {CE_STRUCTURE_FIELD}.make ("border"),
					create {CE_STRUCTURE_FIELD}.make ("cellpd"),
					create {CE_STRUCTURE_FIELD}.make ("vcellpd"),
					create {CE_STRUCTURE_FIELD}.make ("cellsp"),
					create {CE_STRUCTURE_FIELD}.make ("frame"),
					create {CE_STRUCTURE_FIELD}.make ("rules"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("wf"),
					create {CE_STRUCTURE_FIELD}.make ("min_c"),
					create {CE_STRUCTURE_FIELD}.make ("max_c"),
					create {CE_STRUCTURE_FIELD}.make ("w_c"),
					create {CE_STRUCTURE_FIELD}.make ("rw"),
					create {CE_STRUCTURE_FIELD}.make ("min_t"),
					create {CE_STRUCTURE_FIELD}.make ("max_t"),
					create {CE_STRUCTURE_FIELD}.make ("cells"),
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("rc"),
					create {CE_STRUCTURE_FIELD}.make ("cols"),
					create {CE_STRUCTURE_FIELD}.make ("xc"),
					create {CE_STRUCTURE_FIELD}.make ("xcols"),
					create {CE_STRUCTURE_FIELD}.make ("r_heights"),
					create {CE_STRUCTURE_FIELD}.make ("rh"),
					create {CE_STRUCTURE_FIELD}.make ("link_num")
				>>)
			init_structure_info
		end

end
