class
	PD_TAG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create name.make (<<1>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_TAG] assign set_next

	prev: CE_POINTER [PD_TAG] assign set_prev

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	name: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_TAG])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_TAG])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			x := a_other.x
			y := a_other.y
			name := a_other.name.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				x = a_other.x and
				y = a_other.y and
				name.is_equal (a_other.name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("name", <<1>>)
				>>)
			init_structure_info
		end

end
