class
	PD_TERMINAL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create term.make (<<32>>)
			create cwd.make (<<256>>)
			create screen.make
			create last_screen.make
			create spec.make
			create input_queue.make
			create windows.make
			create title.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_TERMINAL] assign set_next

	prev: CE_POINTER [PD_TERMINAL] assign set_prev

	master: INTEGER_32 assign set_master

	fdin: INTEGER_32 assign set_fdin

	fdout: INTEGER_32 assign set_fdout

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	environment: INTEGER_32 assign set_environment

	term: CE_ARRAY [NATURAL_8]

	cwd: CE_ARRAY [NATURAL_8]

	screen: CE_POINTER [NATURAL_32] assign set_screen

	last_screen: CE_POINTER [NATURAL_32] assign set_last_screen

	spec: CE_POINTER [PD_TERM_SPEC] assign set_spec

	cx: INTEGER_32 assign set_cx

	cy: INTEGER_32 assign set_cy

	lcx: INTEGER_32 assign set_lcx

	lcy: INTEGER_32 assign set_lcy

	dirty: INTEGER_32 assign set_dirty

	redrawing: INTEGER_32 assign set_redrawing

	blocked: INTEGER_32 assign set_blocked

	input_queue: CE_POINTER [NATURAL_8] assign set_input_queue

	qlen: INTEGER_32 assign set_qlen

	windows: PD_LIST_HEAD assign set_windows

	title: CE_POINTER [NATURAL_8] assign set_title

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_TERMINAL])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_TERMINAL])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_master (a_master: INTEGER_32)
		do
			master := a_master
			update_memory_field ("master")
		end

	set_fdin (a_fdin: INTEGER_32)
		do
			fdin := a_fdin
			update_memory_field ("fdin")
		end

	set_fdout (a_fdout: INTEGER_32)
		do
			fdout := a_fdout
			update_memory_field ("fdout")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_environment (a_environment: INTEGER_32)
		do
			environment := a_environment
			update_memory_field ("environment")
		end

	set_screen (a_screen: CE_POINTER [NATURAL_32])
		do
			screen := a_screen
			update_memory_field ("screen")
		end

	set_last_screen (a_last_screen: CE_POINTER [NATURAL_32])
		do
			last_screen := a_last_screen
			update_memory_field ("last_screen")
		end

	set_spec (a_spec: CE_POINTER [PD_TERM_SPEC])
		do
			spec := a_spec
			update_memory_field ("spec")
		end

	set_cx (a_cx: INTEGER_32)
		do
			cx := a_cx
			update_memory_field ("cx")
		end

	set_cy (a_cy: INTEGER_32)
		do
			cy := a_cy
			update_memory_field ("cy")
		end

	set_lcx (a_lcx: INTEGER_32)
		do
			lcx := a_lcx
			update_memory_field ("lcx")
		end

	set_lcy (a_lcy: INTEGER_32)
		do
			lcy := a_lcy
			update_memory_field ("lcy")
		end

	set_dirty (a_dirty: INTEGER_32)
		do
			dirty := a_dirty
			update_memory_field ("dirty")
		end

	set_redrawing (a_redrawing: INTEGER_32)
		do
			redrawing := a_redrawing
			update_memory_field ("redrawing")
		end

	set_blocked (a_blocked: INTEGER_32)
		do
			blocked := a_blocked
			update_memory_field ("blocked")
		end

	set_input_queue (a_input_queue: CE_POINTER [NATURAL_8])
		do
			input_queue := a_input_queue
			update_memory_field ("input_queue")
		end

	set_qlen (a_qlen: INTEGER_32)
		do
			qlen := a_qlen
			update_memory_field ("qlen")
		end

	set_windows (a_windows: PD_LIST_HEAD)
		do
			windows := a_windows
			update_memory_field ("windows")
		end

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			title := a_title
			update_memory_field ("title")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			master := a_other.master
			fdin := a_other.fdin
			fdout := a_other.fdout
			x := a_other.x
			y := a_other.y
			environment := a_other.environment
			term := a_other.term.twin
			cwd := a_other.cwd.twin
			screen := a_other.screen
			last_screen := a_other.last_screen
			spec := a_other.spec
			cx := a_other.cx
			cy := a_other.cy
			lcx := a_other.lcx
			lcy := a_other.lcy
			dirty := a_other.dirty
			redrawing := a_other.redrawing
			blocked := a_other.blocked
			input_queue := a_other.input_queue
			qlen := a_other.qlen
			windows := a_other.windows.twin
			title := a_other.title
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				master = a_other.master and
				fdin = a_other.fdin and
				fdout = a_other.fdout and
				x = a_other.x and
				y = a_other.y and
				environment = a_other.environment and
				term.is_equal (a_other.term) and
				cwd.is_equal (a_other.cwd) and
				screen.is_equal (a_other.screen) and
				last_screen.is_equal (a_other.last_screen) and
				spec.is_equal (a_other.spec) and
				cx = a_other.cx and
				cy = a_other.cy and
				lcx = a_other.lcx and
				lcy = a_other.lcy and
				dirty = a_other.dirty and
				redrawing = a_other.redrawing and
				blocked = a_other.blocked and
				input_queue.is_equal (a_other.input_queue) and
				qlen = a_other.qlen and
				windows.is_equal (a_other.windows) and
				title.is_equal (a_other.title)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("master"),
					create {CE_STRUCTURE_FIELD}.make ("fdin"),
					create {CE_STRUCTURE_FIELD}.make ("fdout"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("environment"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("term", <<32>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cwd", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("screen"),
					create {CE_STRUCTURE_FIELD}.make ("last_screen"),
					create {CE_STRUCTURE_FIELD}.make ("spec"),
					create {CE_STRUCTURE_FIELD}.make ("cx"),
					create {CE_STRUCTURE_FIELD}.make ("cy"),
					create {CE_STRUCTURE_FIELD}.make ("lcx"),
					create {CE_STRUCTURE_FIELD}.make ("lcy"),
					create {CE_STRUCTURE_FIELD}.make ("dirty"),
					create {CE_STRUCTURE_FIELD}.make ("redrawing"),
					create {CE_STRUCTURE_FIELD}.make ("blocked"),
					create {CE_STRUCTURE_FIELD}.make ("input_queue"),
					create {CE_STRUCTURE_FIELD}.make ("qlen"),
					create {CE_STRUCTURE_FIELD}.make ("windows"),
					create {CE_STRUCTURE_FIELD}.make ("title")
				>>)
			init_structure_info
		end

end
