class
	PD_TEXT_ATTRIB

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fg.make
			create bg.make
			create link.make
			create target.make
			create image.make
			create form.make
			create clink.make
			create vlink.make
			create href_base.make
			create target_base.make
			create select2.make
		end

feature {ANY} -- fields

	attr: INTEGER_32 assign set_attr

	fg: PD_RGB assign set_fg

	bg: PD_RGB assign set_bg

	fontsize: INTEGER_32 assign set_fontsize

	link: CE_POINTER [NATURAL_8] assign set_link

	target: CE_POINTER [NATURAL_8] assign set_target

	image: CE_POINTER [NATURAL_8] assign set_image

	form: CE_POINTER [PD_FORM_CONTROL] assign set_form

	clink: PD_RGB assign set_clink

	vlink: PD_RGB assign set_vlink

	href_base: CE_POINTER [NATURAL_8] assign set_href_base

	target_base: CE_POINTER [NATURAL_8] assign set_target_base

	select2: CE_POINTER [NATURAL_8] assign set_select2

	select_disabled: INTEGER_32 assign set_select_disabled

feature {ANY} -- setters

	set_attr (a_attr: INTEGER_32)
		do
			attr := a_attr
			update_memory_field ("attr")
		end

	set_fg (a_fg: PD_RGB)
		do
			fg := a_fg
			update_memory_field ("fg")
		end

	set_bg (a_bg: PD_RGB)
		do
			bg := a_bg
			update_memory_field ("bg")
		end

	set_fontsize (a_fontsize: INTEGER_32)
		do
			fontsize := a_fontsize
			update_memory_field ("fontsize")
		end

	set_link (a_link: CE_POINTER [NATURAL_8])
		do
			link := a_link
			update_memory_field ("link")
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_image (a_image: CE_POINTER [NATURAL_8])
		do
			image := a_image
			update_memory_field ("image")
		end

	set_form (a_form: CE_POINTER [PD_FORM_CONTROL])
		do
			form := a_form
			update_memory_field ("form")
		end

	set_clink (a_clink: PD_RGB)
		do
			clink := a_clink
			update_memory_field ("clink")
		end

	set_vlink (a_vlink: PD_RGB)
		do
			vlink := a_vlink
			update_memory_field ("vlink")
		end

	set_href_base (a_href_base: CE_POINTER [NATURAL_8])
		do
			href_base := a_href_base
			update_memory_field ("href_base")
		end

	set_target_base (a_target_base: CE_POINTER [NATURAL_8])
		do
			target_base := a_target_base
			update_memory_field ("target_base")
		end

	set_select2 (a_select2: CE_POINTER [NATURAL_8])
		do
			select2 := a_select2
			update_memory_field ("select2")
		end

	set_select_disabled (a_select_disabled: INTEGER_32)
		do
			select_disabled := a_select_disabled
			update_memory_field ("select_disabled")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			attr := a_other.attr
			fg := a_other.fg.twin
			bg := a_other.bg.twin
			fontsize := a_other.fontsize
			link := a_other.link
			target := a_other.target
			image := a_other.image
			form := a_other.form
			clink := a_other.clink.twin
			vlink := a_other.vlink.twin
			href_base := a_other.href_base
			target_base := a_other.target_base
			select2 := a_other.select2
			select_disabled := a_other.select_disabled
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				attr = a_other.attr and
				fg.is_equal (a_other.fg) and
				bg.is_equal (a_other.bg) and
				fontsize = a_other.fontsize and
				link.is_equal (a_other.link) and
				target.is_equal (a_other.target) and
				image.is_equal (a_other.image) and
				form.is_equal (a_other.form) and
				clink.is_equal (a_other.clink) and
				vlink.is_equal (a_other.vlink) and
				href_base.is_equal (a_other.href_base) and
				target_base.is_equal (a_other.target_base) and
				select2.is_equal (a_other.select2) and
				select_disabled = a_other.select_disabled
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("attr"),
					create {CE_STRUCTURE_FIELD}.make ("fg"),
					create {CE_STRUCTURE_FIELD}.make ("bg"),
					create {CE_STRUCTURE_FIELD}.make ("fontsize"),
					create {CE_STRUCTURE_FIELD}.make ("link"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("image"),
					create {CE_STRUCTURE_FIELD}.make ("form"),
					create {CE_STRUCTURE_FIELD}.make ("clink"),
					create {CE_STRUCTURE_FIELD}.make ("vlink"),
					create {CE_STRUCTURE_FIELD}.make ("href_base"),
					create {CE_STRUCTURE_FIELD}.make ("target_base"),
					create {CE_STRUCTURE_FIELD}.make ("select2"),
					create {CE_STRUCTURE_FIELD}.make ("select_disabled")
				>>)
			init_structure_info
		end

end
