class
	PD_TEXT_ATTRIB_BEGINNING

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fg.make
			create bg.make
		end

feature {ANY} -- fields

	attr: INTEGER_32 assign set_attr

	fg: PD_RGB assign set_fg

	bg: PD_RGB assign set_bg

feature {ANY} -- setters

	set_attr (a_attr: INTEGER_32)
		do
			attr := a_attr
			update_memory_field ("attr")
		end

	set_fg (a_fg: PD_RGB)
		do
			fg := a_fg
			update_memory_field ("fg")
		end

	set_bg (a_bg: PD_RGB)
		do
			bg := a_bg
			update_memory_field ("bg")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			attr := a_other.attr
			fg := a_other.fg.twin
			bg := a_other.bg.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				attr = a_other.attr and
				fg.is_equal (a_other.fg) and
				bg.is_equal (a_other.bg)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("attr"),
					create {CE_STRUCTURE_FIELD}.make ("fg"),
					create {CE_STRUCTURE_FIELD}.make ("bg")
				>>)
			init_structure_info
		end

end
