class
	PD_WTD_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ses.make
			create url.make
			create target.make
			create pos.make
			create fn.make
		end

feature {ANY} -- fields

	ses: CE_POINTER [PD_SESSION] assign set_ses

	url: CE_POINTER [NATURAL_8] assign set_url

	pri: INTEGER_32 assign set_pri

	cache: INTEGER_32 assign set_cache

	wtd: INTEGER_32 assign set_wtd

	target: CE_POINTER [NATURAL_8] assign set_target

	pos: CE_POINTER [NATURAL_8] assign set_pos

	fn: CE_ROUTINE assign set_fn

feature {ANY} -- setters

	set_ses (a_ses: CE_POINTER [PD_SESSION])
		do
			ses := a_ses
			update_memory_field ("ses")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_pri (a_pri: INTEGER_32)
		do
			pri := a_pri
			update_memory_field ("pri")
		end

	set_cache (a_cache: INTEGER_32)
		do
			cache := a_cache
			update_memory_field ("cache")
		end

	set_wtd (a_wtd: INTEGER_32)
		do
			wtd := a_wtd
			update_memory_field ("wtd")
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_pos (a_pos: CE_POINTER [NATURAL_8])
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ses := a_other.ses
			url := a_other.url
			pri := a_other.pri
			cache := a_other.cache
			wtd := a_other.wtd
			target := a_other.target
			pos := a_other.pos
			fn := a_other.fn
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ses.is_equal (a_other.ses) and
				url.is_equal (a_other.url) and
				pri = a_other.pri and
				cache = a_other.cache and
				wtd = a_other.wtd and
				target.is_equal (a_other.target) and
				pos.is_equal (a_other.pos) and
				fn.is_equal (a_other.fn)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ses"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("pri"),
					create {CE_STRUCTURE_FIELD}.make ("cache"),
					create {CE_STRUCTURE_FIELD}.make ("wtd"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("fn")
				>>)
			init_structure_info
		end

end
