class
	P_DNS

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create dns_cache.make (<<1>>)
		end

feature {ANY} -- attributes

	dns_cache: CE_ARRAY [PD_LIST_HEAD]

feature {ANY} -- routines

	do_lookup (a_q: CE_POINTER [PD_DNSQUERY]; a_force_async: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (default_inst.async_lookup.item).to_boolean then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_force_async.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if: | sync_lookup:
						l_r := do_real_lookup (create {CE_POINTER [NATURAL_8]}.make_cast ((a_q.item.name)), a_q.item.addr);
						(a_q.item.xfn).call ([a_q, l_r])
						Result := 0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else:
						l_pos := -1 + 6 -- goto _L
				when 5 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else: | _L:
						l_tmp := os_dep_inst.start_thread ((lookup_fn_address), create {CE_POINTER [ANY]}.make_cast ((a_q.item.name)), ((strlen ((a_q.item.name))) + {NATURAL_32} 1).to_integer_32)
						a_q.item.h := l_tmp
						if l_tmp = -1 then
							l_pos := -1 + 2 -- goto sync_lookup
						end
				when 7 then
						select_inst.set_handlers (a_q.item.h, (end_real_lookup_address), create {CE_ROUTINE}.make_shared (default_pointer), (failed_real_lookup_address), create {CE_POINTER [ANY]}.make_cast (a_q))
						Result := 1
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_queued_lookup (a_q: CE_POINTER [PD_DNSQUERY]): INTEGER_32
		do
			Result := (do_lookup (a_q, 0))
		end

	do_real_lookup (a_name: CE_POINTER [NATURAL_8]; a_host: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_n: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hst: CE_POINTER [SD_HOSTENT]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_n.make (<<1>>)
			create l_hst.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_name.item).to_boolean then
						Result := (-1)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_n.item := a_name
				when 2 then -- loop condition:
						if not ((l_n.item.item).to_boolean) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if (l_n.item.item).to_integer_32 /= 46 then
							if (l_n.item.item).to_integer_32 < 48 then
								l_pos := -1 + 12 -- goto nogethostbyaddr
							elseif (l_n.item.item).to_integer_32 > 57 then
								l_pos := -1 + 12 -- goto nogethostbyaddr
							end
						end
				when 4 then
						l_n.item := l_n.item + 1
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_n.item := a_name
						if (get_addr_byte (l_n, create {CE_POINTER [NATURAL_8]}.make_cast (a_host) + 0, (('.').code).to_integer_8)).to_boolean then
							l_pos := -1 + 11 -- goto skip_addr
						end
				when 6 then
						if (get_addr_byte (l_n, create {CE_POINTER [NATURAL_8]}.make_cast (a_host) + 1, (('.').code).to_integer_8)).to_boolean then
							l_pos := -1 + 11 -- goto skip_addr
						end
				when 7 then
						if (get_addr_byte (l_n, create {CE_POINTER [NATURAL_8]}.make_cast (a_host) + 2, (('.').code).to_integer_8)).to_boolean then
							l_pos := -1 + 11 -- goto skip_addr
						end
				when 8 then
						if (get_addr_byte (l_n, create {CE_POINTER [NATURAL_8]}.make_cast (a_host) + 3, (0).to_integer_8)).to_boolean then
							l_pos := -1 + 11 -- goto skip_addr
						end
				when 9 then
						Result := 0
						js.return
				when 10 then -- if done
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 11 then -- if: | skip_addr:
						l_hst := gethostbyaddr (create {CE_POINTER [ANY]}.make_cast (a_name), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name))), 2)
						if (not l_hst.is_void) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | nogethostbyaddr:
						l_hst := gethostbyname (create {CE_POINTER [INTEGER_8]}.make_cast (a_name))
						if l_hst.is_void then
							Result := (-1)
							js.return
						end
				when 13 then -- if done | if done
						if not js.return_called then
							memcpy (create {CE_POINTER [ANY]}.make_cast (a_host), create {CE_POINTER [ANY]}.make_cast (l_hst.item.h_addr_list[0]), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	end_dns_lookup (a_q: CE_POINTER [PD_DNSQUERY]; a_a: INTEGER_32)
		local
			l_a: INTEGER_32
			l_dnsentry: CE_ARRAY [CE_POINTER [PD_DNSENTRY]]
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dnsentry.make (<<1>>)
			create l_fn.make
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					if (a_q.item.fn).is_void then
						free (create {CE_POINTER [ANY]}.make_cast (a_q))
						js.return
					elseif (a_q.item.addr).is_void then
						free (create {CE_POINTER [ANY]}.make_cast (a_q))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if (find_in_dns_cache (a_q.item.name, l_dnsentry)).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_a.to_boolean then
							memcpy (create {CE_POINTER [ANY]}.make_cast (a_q.item.addr), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [NATURAL_32]}.make_shared (l_dnsentry.item.c_pointer + (create {PD_DNSENTRY}.make).offset_of ("addr")))), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
							l_a := 0
							l_pos := -1 + 6 -- goto e
						end
				when 3 then
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_dnsentry.item));
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_dnsentry.item.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_dnsentry.item.item.prev);
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_dnsentry.item.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_dnsentry.item.item.next)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_dnsentry.item))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("dns.c")), 171, create {CE_POINTER [ANY]}.make_cast (l_dnsentry.item))
				when 4 then -- if done
						if l_a.to_boolean then
							l_pos := -1 + 6 -- goto e
						end
				when 5 then
						l_dnsentry.item := create {CE_POINTER [PD_DNSENTRY]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("dns.c")), 174, ((create {PD_DNSENTRY}.make).structure_size.to_natural_32 + (strlen ((a_q.item.name)))) + {NATURAL_32} 1)))
						strcpy ((l_dnsentry.item.item.name), (a_q.item.name)).do_nothing
						memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [NATURAL_32]}.make_shared (l_dnsentry.item.c_pointer + (create {PD_DNSENTRY}.make).offset_of ("addr")))), create {CE_POINTER [ANY]}.make_cast (a_q.item.addr), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
						l_dnsentry.item.item.get_time := select_inst.get_time
						from
						until
							js.loop_done
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (dns_cache))
							l_dnsentry.item.item.next := (create {CE_POINTER [PD_DNSENTRY]}.make_cast (dns_cache)).item.next
							l_dnsentry.item.item.prev := create {CE_POINTER [PD_DNSENTRY]}.make_cast (dns_cache);
							(create {CE_POINTER [PD_DNSENTRY]}.make_cast (dns_cache)).item.next := l_dnsentry.item;
							(l_dnsentry.item.item.next).item.prev := l_dnsentry.item
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (dns_cache))
							js.break
						end
				when 6 then -- e:
						if (not (a_q.item.s).is_void) then
							(a_q.item.s).item := create {CE_POINTER [PD_DNSQUERY]}.make_shared (default_pointer)
						end
						l_fn := a_q.item.fn
						l_data := a_q.item.data
						free (create {CE_POINTER [ANY]}.make_cast (a_q))
						l_fn.call ([l_data, l_a])
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	end_dns_lookup_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent end_dns_lookup)
		end

	end_real_lookup (a_q: CE_POINTER [PD_DNSQUERY])
		local
			l_r: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_r := 1
					if (a_q.item.addr).is_void then
						l_pos := -1 + 2 -- goto end
					elseif (read (a_q.item.h, create {CE_POINTER [ANY]}.make_cast (a_q.item.addr), {PLATFORM}.Natural_32_bytes.to_natural_32)).to_natural_32 /= {PLATFORM}.Natural_32_bytes.to_natural_32 then
						l_pos := -1 + 2 -- goto end
					end
				when 1 then
					l_r := 0
				when 2 then -- end:
					select_inst.set_handlers (a_q.item.h, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					close (a_q.item.h).do_nothing;
					(a_q.item.xfn).call ([a_q, l_r])
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	end_real_lookup_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent end_real_lookup)
		end

	failed_real_lookup (a_q: CE_POINTER [PD_DNSQUERY])
		do
			select_inst.set_handlers (a_q.item.h, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
			close (a_q.item.h).do_nothing;
			(a_q.item.xfn).call ([a_q, -1])
		end

	failed_real_lookup_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent failed_real_lookup)
		end

	find_host (a_name: CE_POINTER [NATURAL_8]; a_addr: CE_POINTER [NATURAL_32]; a_qp: CE_POINTER [CE_POINTER [ANY]]; a_fn: CE_ROUTINE; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_dnsentry: CE_ARRAY [CE_POINTER [PD_DNSENTRY]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dnsentry.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not a_qp.is_void) then
						a_qp.item := create {CE_POINTER [ANY]}.make_shared (default_pointer)
					end
					if (find_in_dns_cache (create {CE_POINTER [INTEGER_8]}.make_cast (a_name), l_dnsentry)).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (select_inst.get_time).to_natural_32 - (l_dnsentry.item.item.get_time).to_natural_32 > {NATURAL_32} 3_600_000 then
							l_pos := -1 + 4 -- goto timeout
						end
				when 2 then
						memcpy (create {CE_POINTER [ANY]}.make_cast (a_addr), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [NATURAL_32]}.make_shared (l_dnsentry.item.c_pointer + (create {PD_DNSENTRY}.make).offset_of ("addr")))), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
						a_fn.call ([a_data, 0])
						Result := 0
						js.return
				when 3 then -- if done
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 4 then -- if: | timeout:
						Result := (find_host_no_cache (a_name, a_addr, a_qp, a_fn, a_data))
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_host_no_cache (a_name: CE_POINTER [NATURAL_8]; a_addr: CE_POINTER [NATURAL_32]; a_qp: CE_POINTER [CE_POINTER [ANY]]; a_fn: CE_ROUTINE; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_q: CE_POINTER [PD_DNSQUERY]
			js: JUMP_STATE
		do
			create l_q.make

			l_q := create {CE_POINTER [PD_DNSQUERY]}.make_cast ((malloc (((create {PD_DNSQUERY}.make).structure_size.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name)))) + {NATURAL_32} 1)))
			if l_q.is_void then
				a_fn.call ([a_data, -1])
				Result := 0
				js.return
			end
			if not js.return_called then
				l_q.item.fn := a_fn
				l_q.item.data := a_data
				l_q.item.s := create {CE_POINTER [CE_POINTER [PD_DNSQUERY]]}.make_cast (a_qp)
				l_q.item.addr := a_addr
				strcpy ((l_q.item.name), create {CE_POINTER [INTEGER_8]}.make_cast (a_name)).do_nothing
				if (not a_qp.is_void) then
					(create {CE_POINTER [CE_POINTER [PD_DNSQUERY]]}.make_cast (a_qp)).item := l_q
				end
				l_q.item.xfn := end_dns_lookup_address
				Result := (do_queued_lookup (l_q))
			end
		end

	find_in_dns_cache (a_name: CE_POINTER [INTEGER_8]; a_dnsentry: CE_POINTER [CE_POINTER [PD_DNSENTRY]]): INTEGER_32
		local
			l_e: CE_POINTER [PD_DNSENTRY]
			js: JUMP_STATE
		do
			create l_e.make

			l_e := create {CE_POINTER [PD_DNSENTRY]}.make_cast (dns_cache.item.next)
			from
			until
				not (not js.loop_done and then (not l_e.is_equal (dns_cache)))
			loop
				if not (strcasecmp ((l_e.item.name), a_name)).to_boolean then
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_e));
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_e.item.prev);
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_e.item.next)
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_e))
					from
					until
						js.loop_done
					loop
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (dns_cache))
						l_e.item.next := (create {CE_POINTER [PD_DNSENTRY]}.make_cast (dns_cache)).item.next
						l_e.item.prev := create {CE_POINTER [PD_DNSENTRY]}.make_cast (dns_cache);
						(create {CE_POINTER [PD_DNSENTRY]}.make_cast (dns_cache)).item.next := l_e;
						(l_e.item.next).item.prev := l_e
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (dns_cache))
						js.break
					end
					a_dnsentry.item := l_e
					Result := 0
					js.return
				end
				if not js.return_called then
					l_e := l_e.item.next
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	get_addr_byte (a_ptr: CE_POINTER [CE_POINTER [NATURAL_8]]; a_res: CE_POINTER [NATURAL_8]; a_stp: INTEGER_8): INTEGER_32
		local
			l_u: NATURAL_32
			js: JUMP_STATE
		do
			l_u := {NATURAL_32} 0
			if ((a_ptr.item).item).to_integer_32 >= 48 then
				if not (((a_ptr.item).item).to_integer_32 <= 57) then
					Result := (-1)
					js.return
				end
			else
				Result := (-1)
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if ((a_ptr.item).item).to_integer_32 >= 48 then
						if not (((a_ptr.item).item).to_integer_32 <= 57) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_u := (l_u * {NATURAL_32} 10 + ((a_ptr.item).item).to_natural_32) - {NATURAL_32} 48
						if l_u >= {NATURAL_32} 256 then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							a_ptr.item := (a_ptr.item) + 1
						end
					end
				end
			end
			if not js.return_called and then (((a_ptr.item).item).to_integer_32 /= a_stp.to_integer_32) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				a_ptr.item := (a_ptr.item) + 1
				a_res.item := l_u.to_natural_8
				Result := 0
			end
		end

	kill_dns_request (a_qp: CE_POINTER [CE_POINTER [ANY]])
		local
			l_q: CE_POINTER [PD_DNSQUERY]
		do
			create l_q.make

			l_q := create {CE_POINTER [PD_DNSQUERY]}.make_cast (a_qp.item)
			l_q.item.fn := create {CE_ROUTINE}.make_shared (default_pointer)
			l_q.item.addr := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			a_qp.item := create {CE_POINTER [ANY]}.make_shared (default_pointer)
		end

	lookup_fn (a_name: CE_POINTER [NATURAL_8]; a_h: INTEGER_32)
		local
			l_host: CE_ARRAY [NATURAL_32]
			js: JUMP_STATE
		do
			create l_host.make (<<1>>)

			if (do_real_lookup (a_name, l_host)).to_boolean then
				js.return
			end
			if not js.return_called then
				write (a_h, create {CE_POINTER [ANY]}.make_cast (l_host), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
			end
		end

	lookup_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lookup_fn)
		end

	shrink_dns_cache (a_u: INTEGER_32)
		local
			l_d: CE_POINTER [PD_DNSENTRY]
			l_e: CE_POINTER [PD_DNSENTRY]
			l_pos: INTEGER_32
		do
			create l_d.make
			create l_e.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := create {CE_POINTER [PD_DNSENTRY]}.make_cast (dns_cache.item.next)
				when 1 then -- loop condition:
					if l_d.is_equal (dns_cache) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						if not (a_u.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not ((select_inst.get_time).to_natural_32 - (l_d.item.get_time).to_natural_32 > {NATURAL_32} 3_600_000) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_e := l_d
						l_d := l_d.item.prev
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_e));
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_e.item.prev);
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_e.item.next)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_e))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("dns.c")), 236, create {CE_POINTER [ANY]}.make_cast (l_e))
				when 7 then -- if done
						l_d := l_d.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
