class
	P_FTP

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create ftp_head.make (<<21>>)
			create ftp_head2.make (<<37>>)
			create ftp_head3.make (<<11>>)
		end

feature {ANY} -- attributes

	ftp_head: CE_ARRAY [NATURAL_8]

	ftp_head2: CE_ARRAY [NATURAL_8]

	ftp_head3: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	add_file_cmd_to_str (a_c: CE_POINTER [PD_CONNECTION]): CE_POINTER [PD_FTP_CONNECTION_INFO]
		local
			l_d: CE_POINTER [NATURAL_8]
			l_de: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_del: CE_ARRAY [INTEGER_32]
			l_pc: CE_ARRAY [NATURAL_8]
			l_ps: INTEGER_32
			l_inf: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_inf2: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_on: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_d.make
			create l_de.make (<<1>>)
			create l_del.make (<<1>>)
			create l_pc.make (<<6>>)
			create l_inf.make
			create l_inf2.make
			create l_s.make (<<1>>)
			create l_l.make (<<1>>)
			create l_on.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := (url_inst.get_url_data (a_c.item.url))
					if l_d.is_void then
						from
						until
							False
						loop
							links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c"))
							links_inst.errline := 226
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("get_url_data failed"))])
						end
						sched_inst.setcstate (a_c, -1_003)
						sched_inst.abort_connection (a_c)
						Result := (create {CE_POINTER [PD_FTP_CONNECTION_INFO]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_de.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 231)
						l_del.item := 0
						url_inst.add_conv_str (l_de, l_del, l_d, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_d))).to_integer_32, -2)
						l_d := l_de.item
						l_inf := create {CE_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 234, (create {PD_FTP_CONNECTION_INFO}.make).structure_size.to_natural_32)))
						memset (create {CE_POINTER [ANY]}.make_cast (l_inf), 0, (create {PD_FTP_CONNECTION_INFO}.make).structure_size.to_natural_32).do_nothing
						l_l.item := 0
						l_s.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 237)
						l_inf.item.pasv := default_inst.ftp_options.item.passive_ftp
						a_c.item.info := create {CE_POINTER [ANY]}.make_cast (l_inf)
						if not (l_inf.item.pasv).to_boolean then
							l_ps := connect_inst.get_pasv_socket (a_c, a_c.item.sock1, create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")), l_pc)
							if l_ps.to_boolean then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 241, create {CE_POINTER [ANY]}.make_cast (l_d))
								Result := (create {CE_POINTER [PD_FTP_CONNECTION_INFO]}.make_shared (default_pointer))
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (default_inst.ftp_options.item.set_tos).to_boolean then
							l_on.item := 8
							setsockopt (a_c.item.sock2, 0, 1, create {CE_POINTER [ANY]}.make_cast (l_on), {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
						end
						l_de.item := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), 1)))
						if (l_de.item).is_void then
							l_de.item := l_d + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_d))).to_integer_32
						end
						if not (l_d.is_equal (l_de.item)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if (l_de.item[-1]).to_integer_32 /= 47 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_inf.item.dir := 1
						l_inf.item.pending_commands := 4
						links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TYPE A%R%N")))
						if not (l_inf.item.pasv).to_boolean then
							links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PORT ")))
							links_inst.add_num_to_str (l_s, l_l, (l_pc[0]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[1]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[2]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[3]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[4]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[5]).to_integer_32)
							links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
						else
							links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PASV%R%N")))
						end
						links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("CWD /")))
						links_inst.add_bytes_to_str (l_s, l_l, l_d, (l_de.item).distance (l_d))
						links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%NLIST%R%N")))
						a_c.item.from2 := (0).to_integer_32
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_inf.item.dir := 0
						l_inf.item.pending_commands := 3
						links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TYPE I%R%N")))
						if not (l_inf.item.pasv).to_boolean then
							links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PORT ")))
							links_inst.add_num_to_str (l_s, l_l, (l_pc[0]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[1]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[2]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[3]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[4]).to_integer_32)
							links_inst.add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							links_inst.add_num_to_str (l_s, l_l, (l_pc[5]).to_integer_32)
							links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
						else
							links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PASV%R%N")))
						end
						if (a_c.item.from2).to_boolean then
							if a_c.item.no_cache < 2 then
								links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("REST ")))
								links_inst.add_num_to_str (l_s, l_l, a_c.item.from2)
								links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
								l_inf.item.rest_sent := 1
								l_inf.item.pending_commands := (l_inf.item.pending_commands) + 1
							else
								a_c.item.from2 := (0).to_integer_32
							end
						else
							a_c.item.from2 := (0).to_integer_32
						end
						links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("RETR /")))
						links_inst.add_bytes_to_str (l_s, l_l, l_d, (l_de.item).distance (l_d))
						links_inst.add_to_str (l_s, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
				when 8 then -- if done
						l_inf.item.opc := l_inf.item.pending_commands
						if (l_l.item).to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_FTP_CONNECTION_INFO}.make).structure_size.to_natural_32) - {NATURAL_32} 1 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("ftp.c"), 309])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_inf2 := create {CE_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 310, create {CE_POINTER [ANY]}.make_cast (l_inf), ((create {PD_FTP_CONNECTION_INFO}.make).structure_size.to_natural_32 + (l_l.item).to_natural_32) + {NATURAL_32} 1)))
						l_inf := l_inf2
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_inf.item.cmdbuf)), create {CE_POINTER [INTEGER_8]}.make_cast (l_s.item)).do_nothing
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 312, create {CE_POINTER [ANY]}.make_cast (l_s.item))
						a_c.item.info := create {CE_POINTER [ANY]}.make_cast (l_inf)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 314, create {CE_POINTER [ANY]}.make_cast (l_d))
						Result := l_inf
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_dummy_info (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_g: INTEGER_32
			js: JUMP_STATE
		do
			l_g := (get_ftp_response (a_c, a_rb, 0))
			if l_g = -1 then
				sched_inst.setcstate (a_c, -1_300)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called and then (not l_g.to_boolean) then
				connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, ftp_dummy_info_address)
				js.return
			end
			if not js.return_called then
				ftp_retr_file (a_c, a_rb)
			end
		end

	ftp_dummy_info_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_dummy_info)
		end

	ftp_end_request (a_c: CE_POINTER [PD_CONNECTION])
		do
			if a_c.item.state = -1_000 then
				if (not (a_c.item.cache).is_void) then
					cache_inst.truncate_entry (a_c.item.cache, a_c.item.from2, 1);
					(a_c.item.cache).item.incomplete := 0
				end
			end
			sched_inst.add_keepalive_socket (a_c, (600_000).to_integer_32)
		end

	ftp_func (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_p: INTEGER_32
			l_tmp: CE_ROUTINE
			js: JUMP_STATE
		do
			create l_tmp.make

			if (sched_inst.get_keepalive_socket (a_c)).to_boolean then
				l_p := url_inst.get_port (a_c.item.url)
				if l_p = -1 then
					sched_inst.setcstate (a_c, -1_003)
					sched_inst.abort_connection (a_c)
					js.return
				end
				if not js.return_called then
					if (default_inst.ftp_options.item.fast_ftp).to_boolean then
						l_tmp := ftp_login_address
					else
						l_tmp := ftp_get_banner_address
					end
					connect_inst.make_connection (a_c, l_p, create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock1")), l_tmp)
				end
			else
				ftp_send_retr_req (a_c, 4)
			end
			if not js.return_called then
			end
		end

	ftp_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_func)
		end

	ftp_get_banner (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			js: JUMP_STATE
		do
			create l_rb.make

			sched_inst.set_timeout (a_c)
			sched_inst.setcstate (a_c, 4)
			l_rb := connect_inst.alloc_read_buffer (a_c)
			if l_rb.is_void then
				js.return
			end
			if not js.return_called then
				connect_inst.read_from_socket (a_c, a_c.item.sock1, l_rb, ftp_got_banner_address)
			end
		end

	ftp_get_banner_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_get_banner)
		end

	ftp_got_banner (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_g: INTEGER_32
			js: JUMP_STATE
		do
			l_g := (get_ftp_response (a_c, a_rb, 0))
			if l_g = -1 then
				sched_inst.setcstate (a_c, -1_300)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called and then (not l_g.to_boolean) then
				connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, ftp_got_banner_address)
				js.return
			end
			if not js.return_called and then (l_g >= 400) then
				sched_inst.setcstate (a_c, -1_301)
				sched_inst.retry_connection (a_c)
				js.return
			end
			if not js.return_called then
				ftp_login (a_c)
			end
		end

	ftp_got_banner_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_got_banner)
		end

	ftp_got_final_response (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_inf: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_g: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_inf.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_inf := create {CE_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (a_c.item.info)
					l_g := (get_ftp_response (a_c, a_rb, 0))
					if l_g = -1 then
						sched_inst.setcstate (a_c, -1_300)
						sched_inst.abort_connection (a_c)
						js.return
					end
					if not js.return_called and then (not l_g.to_boolean) then
						connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, ftp_got_final_response_address)
						if a_c.item.state /= 8 then
							sched_inst.setcstate (a_c, 6)
						end
						js.return
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if l_g /= 425 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 4 then -- else:
						if l_g /= 450 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 7 then -- else:
						if l_g /= 500 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 10 then -- else:
						if l_g /= 501 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 13 then -- else:
						if l_g /= 550 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L:
						if (a_c.item.url[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.url))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 47 then
							l_pos := -1 + 17 -- goto skip_redir
						end
				when 15 then
						if (a_c.item.cache).is_void then
							if (cache_inst.get_cache_entry (a_c.item.url, create {CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))).to_boolean then
								sched_inst.setcstate (a_c, -1_004)
								sched_inst.abort_connection (a_c)
								js.return
							end
						end
						if not js.return_called then
							if (not ((a_c.item.cache).item.redirect).is_void) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 507, create {CE_POINTER [ANY]}.make_cast ((a_c.item.cache).item.redirect))
							end
							(a_c.item.cache).item.redirect := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 508, a_c.item.url);
							(a_c.item.cache).item.redirect_get := 1
							links_inst.add_to_strn (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared ((a_c.item.cache).c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("redirect")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")));
							(a_c.item.cache).item.incomplete := 0
							sched_inst.setcstate (a_c, -1_000)
							sched_inst.abort_connection (a_c)
							js.return
						end
				when 16 then -- if done | if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | skip_redir:
							if l_g >= 400 then
								sched_inst.setcstate (a_c, -1_305)
								sched_inst.abort_connection (a_c)
								js.return
							end
				when 18 then -- if done
						if not js.return_called then
							if l_inf.item.conn_st = 2 then
								sched_inst.setcstate (a_c, -1_000)
								ftp_end_request (a_c)
							else
								l_inf.item.conn_st := 1
								if a_c.item.state /= 8 then
									sched_inst.setcstate (a_c, 6)
								end
							end
						end
				when 19 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ftp_got_final_response_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_got_final_response)
		end

	ftp_got_info (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_g: INTEGER_32
			js: JUMP_STATE
		do
			l_g := (get_ftp_response (a_c, a_rb, 0))
			if l_g = -1 then
				sched_inst.setcstate (a_c, -1_300)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called and then (not l_g.to_boolean) then
				connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, ftp_got_info_address)
				js.return
			end
			if not js.return_called and then (l_g >= 400) then
				sched_inst.setcstate (a_c, -1_301)
				sched_inst.retry_connection (a_c)
				js.return
			end
			if not js.return_called then
				ftp_got_user_info (a_c, a_rb)
			end
		end

	ftp_got_info_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_got_info)
		end

	ftp_got_user_info (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_g: INTEGER_32
			l_login: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_u: CE_POINTER [NATURAL_8]
			l_logl: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_login.make (<<1>>)
			create l_u.make
			create l_logl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_g := (get_ftp_response (a_c, a_rb, 0))
					if l_g = -1 then
						sched_inst.setcstate (a_c, -1_300)
						sched_inst.abort_connection (a_c)
						js.return
					end
					if not js.return_called and then (not l_g.to_boolean) then
						connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, ftp_got_user_info_address)
						js.return
					end
					if not js.return_called and then (l_g >= 530) then
						if l_g < 540 then
							sched_inst.setcstate (a_c, -1_302)
							sched_inst.retry_connection (a_c)
							js.return
						end
					end
					if not js.return_called and then (l_g >= 400) then
						sched_inst.setcstate (a_c, -1_301)
						sched_inst.retry_connection (a_c)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (l_g >= 200) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_g < 300 then
							if (default_inst.ftp_options.item.fast_ftp).to_boolean then
								ftp_dummy_info (a_c, a_rb)
							else
								ftp_send_retr_req (a_c, 6)
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (default_inst.ftp_options.item.fast_ftp).to_boolean then
							ftp_pass_info (a_c, a_rb)
						else
							l_logl.item := 0
							l_login.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 176)
							links_inst.add_to_str (l_login, l_logl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PASS ")))
							l_u := url_inst.get_pass (a_c.item.url)
							if (not l_u.is_void) then
								if (l_u.item).to_boolean then
									links_inst.add_to_str (l_login, l_logl, l_u)
								else
									links_inst.add_to_str (l_login, l_logl, default_inst.ftp_options.item.anon_pass)
								end
							else
								links_inst.add_to_str (l_login, l_logl, default_inst.ftp_options.item.anon_pass)
							end
							if (not l_u.is_void) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 180, create {CE_POINTER [ANY]}.make_cast (l_u))
							end
							links_inst.add_to_str (l_login, l_logl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
							connect_inst.write_to_socket (a_c, a_c.item.sock1, l_login.item, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_login.item))).to_integer_32, ftp_sent_passwd_address)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 183, create {CE_POINTER [ANY]}.make_cast (l_login.item))
							sched_inst.setcstate (a_c, 5)
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ftp_got_user_info_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_got_user_info)
		end

	ftp_logged (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			js: JUMP_STATE
		do
			create l_rb.make

			l_rb := connect_inst.alloc_read_buffer (a_c)
			if l_rb.is_void then
				js.return
			end
			if not js.return_called and then (not (default_inst.ftp_options.item.fast_ftp).to_boolean) then
				ftp_got_user_info (a_c, l_rb)
				js.return
			end
			if not js.return_called then
				connect_inst.read_from_socket (a_c, a_c.item.sock1, l_rb, ftp_got_info_address)
			end
		end

	ftp_logged_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_logged)
		end

	ftp_login (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_login: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_u: CE_POINTER [NATURAL_8]
			l_logl: CE_ARRAY [INTEGER_32]
			l_fi: CE_POINTER [PD_FTP_CONNECTION_INFO]
			js: JUMP_STATE
		do
			create l_login.make (<<1>>)
			create l_u.make
			create l_logl.make (<<1>>)
			create l_fi.make

			l_logl.item := 0
			sched_inst.set_timeout (a_c)
			l_login.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 117)
			links_inst.add_to_str (l_login, l_logl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("USER ")))
			l_u := url_inst.get_user_name (a_c.item.url)
			if (not l_u.is_void) then
				if (l_u.item).to_boolean then
					links_inst.add_to_str (l_login, l_logl, l_u)
				else
					links_inst.add_to_str (l_login, l_logl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("anonymous")))
				end
			else
				links_inst.add_to_str (l_login, l_logl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("anonymous")))
			end
			if (not l_u.is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 121, create {CE_POINTER [ANY]}.make_cast (l_u))
			end
			if (default_inst.ftp_options.item.fast_ftp).to_boolean then
				links_inst.add_to_str (l_login, l_logl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%NPASS ")))
				l_u := url_inst.get_pass (a_c.item.url)
				if (not l_u.is_void) then
					if (l_u.item).to_boolean then
						links_inst.add_to_str (l_login, l_logl, l_u)
					else
						links_inst.add_to_str (l_login, l_logl, default_inst.ftp_options.item.anon_pass)
					end
				else
					links_inst.add_to_str (l_login, l_logl, default_inst.ftp_options.item.anon_pass)
				end
				if (not l_u.is_void) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 127, create {CE_POINTER [ANY]}.make_cast (l_u))
				end
				links_inst.add_to_str (l_login, l_logl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
				l_fi := add_file_cmd_to_str (a_c)
				if l_fi.is_void then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 130, create {CE_POINTER [ANY]}.make_cast (l_login.item))
					js.return
				end
				if not js.return_called then
					links_inst.add_to_str (l_login, l_logl, l_fi.item.cmdbuf)
				end
			else
				links_inst.add_to_str (l_login, l_logl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
			end
			if not js.return_called then
				connect_inst.write_to_socket (a_c, a_c.item.sock1, l_login.item, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_login.item))).to_integer_32, ftp_logged_address)
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 136, create {CE_POINTER [ANY]}.make_cast (l_login.item))
				sched_inst.setcstate (a_c, 4)
			end
		end

	ftp_login_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_login)
		end

	ftp_pass_info (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_g: INTEGER_32
			js: JUMP_STATE
		do
			l_g := (get_ftp_response (a_c, a_rb, 0))
			if l_g = -1 then
				sched_inst.setcstate (a_c, -1_300)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called and then (not l_g.to_boolean) then
				connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, ftp_pass_info_address)
				sched_inst.setcstate (a_c, 5)
				js.return
			end
			if not js.return_called and then (l_g >= 530) then
				if l_g < 540 then
					sched_inst.setcstate (a_c, -1_302)
					sched_inst.abort_connection (a_c)
					js.return
				end
			end
			if not js.return_called and then (l_g >= 400) then
				sched_inst.setcstate (a_c, -1_301)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called then
				if (default_inst.ftp_options.item.fast_ftp).to_boolean then
					ftp_retr_file (a_c, a_rb)
				else
					ftp_send_retr_req (a_c, 6)
				end
			end
		end

	ftp_pass_info_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_pass_info)
		end

	ftp_process_dirlist (a_ce: CE_POINTER [PD_CACHE_ENTRY]; a_pos___0: CE_POINTER [INTEGER_32]; a_d: CE_POINTER [INTEGER_32]; a_bf: CE_POINTER [NATURAL_8]; a_ln: INTEGER_32; a_fin: INTEGER_32; a_tr: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_str: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_buf___0: CE_POINTER [NATURAL_8]
			l_sl: CE_ARRAY [INTEGER_32]
			l_ret: INTEGER_32
			l_p: INTEGER_32
			l_len: INTEGER_32
			l_f: INTEGER_32
			l_ee: INTEGER_32
			l_dir: INTEGER_32
			l_i: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_pp: INTEGER_32
			l_ppos: INTEGER_32
			l_bp: INTEGER_32
			l_bn: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str.make (<<1>>)
			create l_buf___0.make
			create l_sl.make (<<1>>)
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ret := 0
				when 1 then -- again:
					l_buf___0 := a_bf + l_ret
					l_len := a_ln - l_ret
					l_p := 0
				when 2 then -- loop condition:
					if not (l_p < l_len) then
						l_pos := -1 + 5 -- skip loop
					end
				when 3 then -- loop body:
						if (l_buf___0[l_p]).to_integer_32 = 10 then
							l_pos := -1 + 7 -- goto lb
						end
				when 4 then
						l_p := l_p + 1
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
					if l_p.to_boolean then
						if a_fin.to_boolean then
							l_ret := l_ret + l_p
							l_pos := -1 + 8 -- goto pl
						elseif l_len >= 16_384 then
							l_ret := l_ret + l_p
							l_pos := -1 + 8 -- goto pl
						end
					end
				when 6 then
					Result := l_ret
					js.return
					if js.return_called then
						l_pos := -1 + 130 -- skip if block
					end
				when 7 then -- if: | lb:
						l_ret := l_ret + (l_p + 1)
						if l_p.to_boolean then
							if (l_buf___0[(l_p - 1)]).to_integer_32 = 13 then
								l_p := l_p - 1
							end
						end
				when 8 then -- pl:
						l_str.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 562)
						l_sl.item := 0
						l_f := a_d.item
						if not ((a_d.item).to_boolean) then
							l_pos := -1 + 47 -- skip if block
						end
				when 9 then -- if:
						if not (a_d.item < l_p) then
							l_pos := -1 + 45 -- skip if block
						end
				when 10 then -- if:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 9 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 23 -- goto ppp
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 13 then -- else:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 10 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 23 -- goto ppp
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 16 then -- else:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 12 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 23 -- goto ppp
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 19 then -- else:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 13 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto ppp
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 22 then -- else:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 32 then
							l_pos := -1 + 43 -- skip if block
						end
				when 23 then -- if: | ppp:
						l_ee := a_d.item
				when 24 then -- loop condition:
						if not (l_ee <= l_p - 4) then
							l_pos := -1 + 27 -- skip loop
						end
				when 25 then -- loop body:
						if not (memcmp (create {CE_POINTER [ANY]}.make_cast ((l_buf___0 + l_ee)), create {CE_POINTER [ANY]}.make_cast (ce_string (" -> ")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 28 -- goto syml
						end
				when 26 then
						l_ee := l_ee + 1
						l_pos := -1 + 24 -- back to loop condition
				when 27 then -- loop done
						l_ee := l_p
				when 28 then -- syml:
						if l_f.to_boolean then
							l_pos := -1 + 41 -- skip if block
						end
				when 29 then -- if:
						if l_ee - a_d.item = 1 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 33 -- goto _L___0
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 32 then -- else:
						if (l_buf___0[a_d.item]).to_integer_32 = 46 then
							l_pos := -1 + 41 -- skip if block
						end
				when 33 then -- if: | _L___0:
						if l_ee - a_d.item = 2 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 40 -- goto _L
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 36 then -- else:
						if (l_buf___0[a_d.item]).to_integer_32 = 46 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_pos := -1 + 40 -- goto _L
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 39 then -- else:
						if (l_buf___0[(a_d.item + 1)]).to_integer_32 = 46 then
							l_pos := -1 + 41 -- skip if block
						end
				when 40 then -- if: | _L:
						l_i := 0
						from
						until
							not (l_i < a_d.item)
						loop
							links_inst.add_chr_to_str (l_str, l_sl, ((' ').code).to_natural_8)
							l_i := l_i + 1
						end
						links_inst.add_to_str (l_str, l_sl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<a href=%"../%">..</a>%N")))
				when 41 then -- if done | if done | if done | if done | if done
						l_dir := ((l_buf___0[0]).to_integer_32 = 100).to_integer
						if not l_dir.to_boolean then
							l_p___0 := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 583, l_buf___0, a_d.item))
							if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("<DIR>"))).is_void) then
								l_dir := 1
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 585, create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
						url_inst.add_conv_str (l_str, l_sl, l_buf___0, a_d.item, 0)
						links_inst.add_to_str (l_str, l_sl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<a href=%"./")))
						url_inst.add_conv_str (l_str, l_sl, l_buf___0 + a_d.item, l_ee - a_d.item, 1)
						if l_dir.to_boolean then
							links_inst.add_chr_to_str (l_str, l_sl, (('/').code).to_natural_8)
						end
						links_inst.add_to_str (l_str, l_sl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%">")))
						url_inst.add_conv_str (l_str, l_sl, l_buf___0 + a_d.item, l_ee - a_d.item, 0)
						links_inst.add_to_str (l_str, l_sl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</a>")))
						url_inst.add_conv_str (l_str, l_sl, l_buf___0 + l_ee, l_p - l_ee, 0)
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_pos := -1 + 47 -- goto _L___11
				when 44 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:
						l_pos := -1 + 47 -- goto _L___11
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 129
				when 47 then -- else: | _L___11:
						if l_p > 5 then
							if not (links_inst.casecmp (l_buf___0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("total")), (5).to_natural_32)).to_boolean then
								l_pos := -1 + 128 -- goto raw
							end
						end
				when 48 then
						l_pp := l_p - 1
						from
						until
							not (not js.loop_done and then (l_pp >= 0))
						loop
							if (l_buf___0[l_pp]).to_integer_32 /= 9 then
								if (l_buf___0[l_pp]).to_integer_32 /= 10 then
									if (l_buf___0[l_pp]).to_integer_32 /= 12 then
										if (l_buf___0[l_pp]).to_integer_32 /= 13 then
											if (l_buf___0[l_pp]).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_pp := l_pp - 1
							end
						end
						if l_pp < 0 then
							l_pos := -1 + 128 -- goto raw
						end
				when 49 then
						l_ppos := -1
				when 50 then -- loop condition:
						if not (l_pp >= 10) then
							l_pos := -1 + 79 -- skip loop
						end
				when 51 then -- loop body:
						if (l_buf___0[l_pp]).to_integer_32 /= 9 then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 54 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 10 then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 57 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 12 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 60 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 13 then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 63 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 32 then
							l_pos := -1 + 78 -- skip if block
						end
				when 64 then -- if: | _L___5:
						if not ((is_date (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___0 + (l_pp - 6))))).to_boolean) then
							l_pos := -1 + 72 -- skip if block
						end
				when 65 then -- if:
						if (l_buf___0[(l_pp - 5)]).to_integer_32 /= 32 then
							l_pos := -1 + 72 -- skip if block
						end
				when 66 then -- if:
						if (l_buf___0[(l_pp - 4)]).to_integer_32 /= 50 then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						if (l_buf___0[(l_pp - 3)]).to_integer_32 = 48 then
							l_pos := -1 + 71 -- goto _L___1
						else
							l_pos := -1 + 69 -- goto _L___2
						end
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 69 then -- else: | _L___2:
						if (l_buf___0[(l_pp - 4)]).to_integer_32 /= 49 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						if (l_buf___0[(l_pp - 3)]).to_integer_32 /= 57 then
							l_pos := -1 + 72 -- skip if block
						end
				when 71 then -- if: | _L___1:
						if (l_buf___0[(l_pp - 2)]).to_integer_32 >= 48 then
							if (l_buf___0[(l_pp - 2)]).to_integer_32 <= 57 then
								if (l_buf___0[(l_pp - 1)]).to_integer_32 >= 48 then
									if (l_buf___0[(l_pp - 1)]).to_integer_32 <= 57 then
										if l_pp < l_p - 1 then
											if (l_buf___0[(l_pp + 1)]).to_integer_32 = 32 then
												l_ppos := l_pp + 1
											else
												l_ppos := l_pp
											end
										else
											l_ppos := l_pp
										end
									end
								end
							end
						end
				when 72 then -- if done | if done | if done | if done
						if (l_buf___0[(l_pp - 6)]).to_integer_32 /= 32 then
							l_pos := -1 + 78 -- skip if block
						end
				when 73 then -- if:
						if not ((l_buf___0[(l_pp - 5)]).to_integer_32 >= 48) then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						if (l_buf___0[(l_pp - 5)]).to_integer_32 <= 50 then
							l_pos := -1 + 77 -- goto _L___3
						else
							l_pos := -1 + 76 -- goto _L___4
						end
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 76 then -- else: | _L___4:
						if (l_buf___0[(l_pp - 5)]).to_integer_32 /= 32 then
							l_pos := -1 + 78 -- skip if block
						end
				when 77 then -- if: | _L___3:
						if (l_buf___0[(l_pp - 4)]).to_integer_32 >= 48 then
							if (l_buf___0[(l_pp - 4)]).to_integer_32 <= 57 then
								if (l_buf___0[(l_pp - 3)]).to_integer_32 = 58 then
									if (l_buf___0[(l_pp - 2)]).to_integer_32 >= 48 then
										if (l_buf___0[(l_pp - 2)]).to_integer_32 <= 53 then
											if (l_buf___0[(l_pp - 1)]).to_integer_32 >= 48 then
												if (l_buf___0[(l_pp - 1)]).to_integer_32 <= 57 then
													l_ppos := l_pp
												end
											end
										end
									end
								end
							end
						end
				when 78 then -- if done | if done | if done | if done | if done | if done | if done
						l_pp := l_pp - 1
						l_pos := -1 + 50 -- back to loop condition
				when 79 then -- loop done
						if l_ppos /= -1 then
							l_pp := l_ppos
							l_pos := -1 + 127 -- goto done
						end
				when 80 then
						l_pp := 0
				when 81 then -- loop condition:
						if not (not js.loop_done and then (l_pp + 5 <= l_p)) then
							l_pos := -1 + 84 -- skip loop
						end
				when 82 then -- loop body:
						if not (links_inst.casecmp (l_buf___0 + l_pp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<DIR>")), (5).to_natural_32)).to_boolean then
							l_pp := l_pp + (4)
							from
							until
								js.loop_done
							loop
								if l_pp + 1 < l_p then
									if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 9 then
										if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 10 then
											if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 12 then
												if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 13 then
													if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 32 then
														js.break
													end
												end
											end
										end
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_pp := l_pp + 1
								end
							end
							if l_pp + 1 < l_p then
								l_pos := -1 + 127 -- goto done
							end
						end
				when 83 then
						l_pp := l_pp + 1
						l_pos := -1 + 81 -- back to loop condition
				when 84 then -- loop done
						l_bn := -1
						l_bp := 0
						l_pp := 0
				when 85 then -- loop condition:
						if not (not js.loop_done and then (l_pp < l_p)) then
							l_pos := -1 + 105 -- skip loop
						end
				when 86 then -- loop body:
						if not ((l_buf___0[l_pp]).to_integer_32 >= 48) then
							l_pos := -1 + 104 -- skip if block
						end
				when 87 then -- if:
						if not ((l_buf___0[l_pp]).to_integer_32 <= 57) then
							l_pos := -1 + 104 -- skip if block
						end
				when 88 then -- if:
						l_i___0 := l_pp
						from
						until
							not (not js.loop_done and then (l_i___0 < l_p))
						loop
							if (l_buf___0[l_i___0]).to_integer_32 < 48 then
								js.break
							elseif (l_buf___0[l_i___0]).to_integer_32 > 57 then
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						if not (l_i___0 < l_p) then
							l_pos := -1 + 103 -- skip if block
						end
				when 89 then -- if:
						if (l_buf___0[l_i___0]).to_integer_32 /= 9 then
							l_pos := -1 + 92 -- skip if block
						end
				when 90 then -- if:
						l_pos := -1 + 102 -- goto _L___6
				when 91 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 92 then -- else:
						if (l_buf___0[l_i___0]).to_integer_32 /= 10 then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						l_pos := -1 + 102 -- goto _L___6
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 95 then -- else:
						if (l_buf___0[l_i___0]).to_integer_32 /= 12 then
							l_pos := -1 + 98 -- skip if block
						end
				when 96 then -- if:
						l_pos := -1 + 102 -- goto _L___6
				when 97 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 98 then -- else:
						if (l_buf___0[l_i___0]).to_integer_32 /= 13 then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						l_pos := -1 + 102 -- goto _L___6
				when 100 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 101 then -- else:
						if (l_buf___0[l_i___0]).to_integer_32 /= 32 then
							l_pos := -1 + 103 -- skip if block
						end
				when 102 then -- if: | _L___6:
						if l_i___0 - l_pp > l_bn then
							l_bn := l_i___0 - l_pp
							l_bp := l_pp
						end
				when 103 then -- if done | if done | if done | if done | if done
						l_pp := l_i___0
				when 104 then -- if done | if done
						from
						until
							js.loop_done
						loop
							if l_pp < l_p then
								if (l_buf___0[l_pp]).to_integer_32 = 9 then
									js.break
								elseif (l_buf___0[l_pp]).to_integer_32 = 10 then
									js.break
								elseif (l_buf___0[l_pp]).to_integer_32 = 12 then
									js.break
								elseif (l_buf___0[l_pp]).to_integer_32 = 13 then
									js.break
								elseif (l_buf___0[l_pp]).to_integer_32 = 32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_pp := l_pp + 1
							end
						end
						from
						until
							js.loop_done
						loop
							if l_pp < l_p then
								if (l_buf___0[l_pp]).to_integer_32 /= 9 then
									if (l_buf___0[l_pp]).to_integer_32 /= 10 then
										if (l_buf___0[l_pp]).to_integer_32 /= 12 then
											if (l_buf___0[l_pp]).to_integer_32 /= 13 then
												if (l_buf___0[l_pp]).to_integer_32 /= 32 then
													js.break
												end
											end
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_pp := l_pp + 1
							end
						end
						l_pos := -1 + 85 -- back to loop condition
				when 105 then -- loop done
						if l_bn >= 0 then
							l_pp := l_bp + l_bn
							from
							until
								js.loop_done
							loop
								if l_pp + 1 < l_p then
									if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 9 then
										if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 10 then
											if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 12 then
												if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 13 then
													if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 32 then
														js.break
													end
												end
											end
										end
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_pp := l_pp + 1
								end
							end
							if l_pp + 1 < l_p then
								l_pos := -1 + 127 -- goto done
							end
						end
				when 106 then
						l_pp := l_p - 1
						from
						until
							not (not js.loop_done and then (l_pp >= 0))
						loop
							if (l_buf___0[l_pp]).to_integer_32 /= 9 then
								if (l_buf___0[l_pp]).to_integer_32 /= 10 then
									if (l_buf___0[l_pp]).to_integer_32 /= 12 then
										if (l_buf___0[l_pp]).to_integer_32 /= 13 then
											if (l_buf___0[l_pp]).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_pp := l_pp - 1
							end
						end
						if l_pp < 0 then
							l_pos := -1 + 128 -- goto raw
						end
				when 107 then
						if not (not js.loop_done and then (l_pp >= 0)) then
							l_pos := -1 + 127 -- skip loop
						end
				when 108 then -- loop body:
						if (l_buf___0[l_pp]).to_integer_32 /= 9 then
							l_pos := -1 + 111 -- skip if block
						end
				when 109 then -- if:
						l_pos := -1 + 121 -- goto _L___8
				when 110 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 111 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 10 then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						l_pos := -1 + 121 -- goto _L___8
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 114 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 12 then
							l_pos := -1 + 117 -- skip if block
						end
				when 115 then -- if:
						l_pos := -1 + 121 -- goto _L___8
				when 116 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 117 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 13 then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						l_pos := -1 + 121 -- goto _L___8
				when 119 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 120 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 32 then
							l_pos := -1 + 126 -- skip if block
						end
				when 121 then -- if: | _L___8:
						if not (l_pp < 3) then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						l_pos := -1 + 125 -- goto _L___7
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 124 then -- else:
						if not ((memcmp (create {CE_POINTER [ANY]}.make_cast (((l_buf___0 + l_pp) - 3)), create {CE_POINTER [ANY]}.make_cast (ce_string (" -> ")), (4).to_natural_32)).to_boolean) then
							l_pos := -1 + 126 -- skip if block
						end
				when 125 then -- if: | _L___7:
						if l_pp > l_p - 4 then
							js.break
						elseif (memcmp (create {CE_POINTER [ANY]}.make_cast ((l_buf___0 + l_pp)), create {CE_POINTER [ANY]}.make_cast (ce_string (" -> ")), (4).to_natural_32)).to_boolean then
							js.break
						end
				when 126 then -- if done | if done | if done | if done | if done | if done
						if not js.loop_jumped then
							l_pp := l_pp - 1
						end
						l_pos := -1 + 107 -- back to loop condition
				when 127 then -- done:
						a_d.item := l_pp + 1
						l_pos := -1 + 23 -- goto ppp
				when 128 then -- raw:
						url_inst.add_conv_str (l_str, l_sl, l_buf___0, l_p, 0)
				when 129 then
						links_inst.add_chr_to_str (l_str, l_sl, (('%N').code).to_natural_8)
						if (cache_inst.add_fragment (a_ce, a_pos___0.item, l_str.item, (l_sl.item).to_integer_32)).to_boolean then
							a_tr.item := 0
						end
						a_pos___0.item := a_pos___0.item + (l_sl.item).to_integer_32
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 667, create {CE_POINTER [ANY]}.make_cast (l_str.item))
						l_pos := -1 + 1 -- goto again
				when 130 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_retr_1 (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			js: JUMP_STATE
		do
			create l_rb.make

			l_rb := connect_inst.alloc_read_buffer (a_c)
			if l_rb.is_void then
				js.return
			end
			if not js.return_called then
				connect_inst.read_from_socket (a_c, a_c.item.sock1, l_rb, ftp_retr_file_address)
			end
		end

	ftp_retr_1_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_retr_1)
		end

	ftp_retr_file (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_g: INTEGER_32
			l_inf: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_pc: CE_ARRAY [NATURAL_8]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_n: INTEGER_32
			l_a: NATURAL_32
			l_sa: CE_ARRAY [SD_SOCKADDR_IN]
			l_nl: CE_ARRAY [NATURAL_32]
			l_sa___0: CE_ARRAY [SD_SOCKADDR_IN]
			l_tmp___1: INTEGER_32
			l_on: CE_ARRAY [INTEGER_32]
			l_d: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_p: INTEGER_32
			l_est: INTEGER_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_inf.make
			create l_pc.make (<<6>>)
			create l_sa.make (<<1>>)
			create l_nl.make (<<1>>)
			create l_sa___0.make (<<1>>)
			create l_on.make (<<1>>)
			create l_d.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_inf := create {CE_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (a_c.item.info)
					if True then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | rep:
						if not (default_inst.ftp_options.item.fast_ftp).to_boolean then
							ftp_send_retr_req (a_c, 6)
							js.return
						end
				when 2 then -- if done
					if not (not js.return_called and then (l_inf.item.pending_commands > 1)) then
						l_pos := -1 + 39 -- skip if block
					end
				when 3 then -- if:
						if not ((l_inf.item.pasv).to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 4 then -- if:
						if l_inf.item.opc - (l_inf.item.pending_commands - 1) /= 2 then
							l_pos := -1 + 33 -- skip if block
						end
				when 5 then -- if:
						l_i := 3
				when 6 then -- loop condition:
						if not (not js.loop_done and then (l_i < a_rb.item.len)) then
							l_pos := -1 + 31 -- skip loop
						end
				when 7 then -- loop body:
						if not ((a_rb.item.data[l_i]).to_integer_32 >= 48) then
							l_pos := -1 + 30 -- skip if block
						end
				when 8 then -- if:
						if not ((a_rb.item.data[l_i]).to_integer_32 <= 57) then
							l_pos := -1 + 30 -- skip if block
						end
				when 9 then -- if:
						l_j := 0
				when 10 then -- loop condition:
						if not (not js.loop_done and then (l_j < 6)) then
							l_pos := -1 + 29 -- skip loop
						end
				when 11 then -- loop body:
						l_n := 0
				when 12 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 17 -- skip loop
						end
				when 13 then -- loop body:
						if (a_rb.item.data[l_i]).to_integer_32 >= 48 then
							if not ((a_rb.item.data[l_i]).to_integer_32 <= 57) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_n := (l_n * 10 + (a_rb.item.data[l_i]).to_integer_32) - 48
						if l_n >= 256 then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 15 then
						l_i := l_i + 1
						if l_i >= a_rb.item.len then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 16 then
						l_pos := -1 + 12 -- back to loop condition
				when 17 then -- loop done
						l_pc[l_j] := l_n.to_natural_8
						if l_j = 5 then
							l_pos := -1 + 28 -- skip if block
						end
				when 18 then -- if:
						if (a_rb.item.data[l_i]).to_integer_32 /= 44 then
							l_pos := -1 + 24 -- goto xa
						end
				when 19 then
						l_i := l_i + 1
						if l_i >= a_rb.item.len then
							l_pos := -1 + 24 -- goto xa
						end
				when 20 then
						if not ((a_rb.item.data[l_i]).to_integer_32 < 48) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto xa
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 23 then -- else:
						if not ((a_rb.item.data[l_i]).to_integer_32 > 57) then
							l_pos := -1 + 28 -- skip if block
						end
				when 24 then -- if: | xa:
						if l_j /= 1 then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 25 then
						l_pc[4] := l_pc[0]
						l_pc[5] := l_pc[1]
						l_nl.item := (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32
						if (getpeername (a_c.item.sock1, create {CE_POINTER [SD_SOCKADDR]}.make_cast (l_sa), l_nl)).to_boolean then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 26 then
						if l_nl.item /= (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32 then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 27 then
						l_a := ntohl (l_sa.item.sin_addr.s_addr)
						l_pc[0] := ((l_a).bit_shift_right (24)).to_natural_8
						l_pc[1] := ((l_a).bit_shift_right (16)).to_natural_8
						l_pc[2] := ((l_a).bit_shift_right (8)).to_natural_8
						l_pc[3] := l_a.to_natural_8
						l_pos := -1 + 32 -- goto pasv_ok
				when 28 then -- if done | if done
						l_j := l_j + 1
						l_pos := -1 + 10 -- back to loop condition
				when 29 then -- loop done
						l_pos := -1 + 32 -- goto pasv_ok
				when 30 then -- if done
						l_i := l_i + 1
						l_pos := -1 + 6 -- back to loop condition
				when 31 then -- no_pasv:
						memset (create {CE_POINTER [ANY]}.make_cast (l_pc), 0, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (6).to_natural_32)).do_nothing
				when 32 then -- pasv_ok:
						
				when 33 then -- if done | if done
						l_g := get_ftp_response (a_c, a_rb, 0)
						if l_g = -1 then
							sched_inst.setcstate (a_c, -1_300)
							sched_inst.abort_connection (a_c)
							js.return
						end
						if not js.return_called and then (not l_g.to_boolean) then
							connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, ftp_retr_file_address)
							sched_inst.setcstate (a_c, 6)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 38 -- skip if block
						end
				when 34 then -- if:
						l_inf.item.pending_commands := (l_inf.item.pending_commands) - 1
						inspect l_inf.item.opc - l_inf.item.pending_commands -- switch 1 head
						when 1 then l_pos := -1 + 35
						when 2 then l_pos := -1 + 36
						when 3 then l_pos := -1 + 37
						else l_pos := -1 + 38
						end
				when 35 then -- switch 1, case 1
						l_pos := -1 + 1 -- goto rep
				when 36 then -- switch 1, case 2
						if l_g >= 400 then
							sched_inst.setcstate (a_c, -1_303)
							sched_inst.abort_connection (a_c)
							js.return
						end
						if not js.return_called and then ((l_inf.item.pasv).to_boolean) then
							if not (l_pc[0]).to_boolean then
								if not (l_pc[1]).to_boolean then
									if not (l_pc[2]).to_boolean then
										if not (l_pc[3]).to_boolean then
											if not (l_pc[4]).to_boolean then
												if not (l_pc[5]).to_boolean then
													sched_inst.setcstate (a_c, -1_300)
													sched_inst.retry_connection (a_c)
													js.return
												end
											end
										end
									end
								end
							end
							if not js.return_called then
								l_sa___0.item.sin_family := (2).to_natural_16
								l_sa___0.item.sin_port := htons (((((l_pc[4]).to_integer_32).bit_shift_left (8)) + (l_pc[5]).to_integer_32).to_natural_16)
								l_sa___0.item.sin_addr.s_addr := htonl (((((((l_pc[0]).to_integer_32).bit_shift_left (24)) + (((l_pc[1]).to_integer_32).bit_shift_left (16))) + (((l_pc[2]).to_integer_32).bit_shift_left (8))) + (l_pc[3]).to_integer_32).to_natural_32)
								l_tmp___1 := socket (2, 1, 6)
								a_c.item.sock2 := l_tmp___1
								if l_tmp___1 = -1 then
									sched_inst.setcstate (a_c, -(errno_location).item)
									sched_inst.retry_connection (a_c)
									js.return
								end
							end
							if not js.return_called then
								fcntl ([a_c.item.sock2, 4, 2_048]).do_nothing
								if (default_inst.ftp_options.item.set_tos).to_boolean then
									l_on.item := 8
									setsockopt (a_c.item.sock2, 0, 1, create {CE_POINTER [ANY]}.make_cast (l_on), {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
								end
								if (connect (a_c.item.sock2, create {CE_POINTER [SD_SOCKADDR]}.make_cast (l_sa___0), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)).to_boolean then
									if (errno_location).item /= 115 then
										if (errno_location).item /= 114 then
											sched_inst.setcstate (a_c, -(errno_location).item)
											sched_inst.retry_connection (a_c)
											js.return
										end
									end
								end
							end
							if not js.return_called then
								l_inf.item.d := 1
								select_inst.set_handlers (a_c.item.sock2, (got_something_from_data_connection_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_c))
							end
						end
						if not js.return_called then
							l_pos := -1 + 1 -- goto rep
						end
				when 37 then -- switch 1, case 3
						if not js.return_called and then (l_g >= 400) then
							if not (l_inf.item.dir).to_boolean then
								a_c.item.from2 := (0).to_integer_32
							else
								sched_inst.setcstate (a_c, -1_304)
								sched_inst.abort_connection (a_c)
								js.return
							end
						end
						if not js.return_called then
							l_pos := -1 + 1 -- goto rep
						end
				when 38 then -- switch 1, done: | if done
						if not js.return_called then
							from
							until
								False
							loop
								links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c"))
								links_inst.errline := 457
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("WHAT???"))])
							end
						end
				when 39 then -- if done
					if not js.return_called then
						l_g := get_ftp_response (a_c, a_rb, 2)
						if not l_g.to_boolean then
							connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, ftp_retr_file_address)
							sched_inst.setcstate (a_c, 6)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 54 -- skip if block
					end
				when 40 then -- if:
						if not (l_g >= 100) then
							l_pos := -1 + 53 -- skip if block
						end
				when 41 then -- if:
						if not (l_g < 200) then
							l_pos := -1 + 53 -- skip if block
						end
				when 42 then -- if:
						l_d := a_rb.item.data
						l_p := 0
						l_i___0 := 0
						from
						until
							js.loop_done
						loop
							if l_i___0 < a_rb.item.len then
								if (l_d[l_i___0]).to_integer_32 = 10 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_d[l_i___0]).to_integer_32 = 40 then
									l_p := l_i___0
								end
								l_i___0 := l_i___0 + 1
							end
						end
						if not l_p.to_boolean then
							l_pos := -1 + 52 -- goto nol
						elseif l_p = a_rb.item.len - 1 then
							l_pos := -1 + 52 -- goto nol
						end
				when 43 then
						l_p := l_p + 1
						if (l_d[l_p]).to_integer_32 < 48 then
							l_pos := -1 + 52 -- goto nol
						elseif (l_d[l_p]).to_integer_32 > 57 then
							l_pos := -1 + 52 -- goto nol
						end
				when 44 then
						l_i___0 := l_p
				when 45 then -- loop condition:
						if not (l_i___0 < a_rb.item.len) then
							l_pos := -1 + 48 -- skip loop
						end
				when 46 then -- loop body:
						if (l_d[l_i___0]).to_integer_32 < 48 then
							l_pos := -1 + 49 -- goto quak
						elseif (l_d[l_i___0]).to_integer_32 > 57 then
							l_pos := -1 + 49 -- goto quak
						end
				when 47 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 45 -- back to loop condition
				when 48 then -- loop done
						l_pos := -1 + 52 -- goto nol
				when 49 then -- quak:
						from
						until
							not (not js.loop_done and then (l_i___0 < a_rb.item.len))
						loop
							if (l_d[l_i___0]).to_integer_32 /= 32 then
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						if l_i___0 + 4 > a_rb.item.len then
							l_pos := -1 + 52 -- goto nol
						end
				when 50 then
						if (links_inst.casecmp (l_d + l_i___0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("byte")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 52 -- goto nol
						end
				when 51 then
						l_est := (strtoll (create {CE_POINTER [INTEGER_8]}.make_cast ((l_d + l_p)), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10))
						if l_est < {INTEGER_64} 0 then
							l_est := {INTEGER_64} 0
						elseif l_est.to_integer_32 < 0 then
							l_est := {INTEGER_64} 0
						elseif (l_est.to_integer_32).to_integer_64 /= l_est then
							l_est := {INTEGER_64} 0
						end
						if l_est.to_boolean then
							if not (a_c.item.from2).to_boolean then
								a_c.item.est_length := l_est.to_integer_32
							end
						end
				when 52 then -- nol:
						
				when 53 then -- if done | if done
						if not (l_inf.item.pasv).to_boolean then
							select_inst.set_handlers (a_c.item.sock2, (got_something_from_data_connection_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_c))
						end
						ftp_got_final_response (a_c, a_rb)
				when 54 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_retr_file_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_retr_file)
		end

	ftp_send_retr_req (a_c: CE_POINTER [PD_CONNECTION]; a_state: INTEGER_32)
		local
			l_fi: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_login: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_logl: CE_ARRAY [INTEGER_32]
			l_nl: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fi.make
			create l_login.make (<<1>>)
			create l_logl.make (<<1>>)
			create l_nl.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_logl.item := 0
					sched_inst.set_timeout (a_c)
					l_login.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 325)
					if (a_c.item.info).is_void then
						l_fi := add_file_cmd_to_str (a_c)
						if (not l_fi.is_void) then
							l_fi := create {CE_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (a_c.item.info)
						else
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 327, create {CE_POINTER [ANY]}.make_cast (l_login.item))
							js.return
						end
					else
						l_fi := create {CE_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (a_c.item.info)
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not ((default_inst.ftp_options.item.fast_ftp).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if: | a:
						links_inst.add_to_str (l_login, l_logl, l_fi.item.cmdbuf)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						l_nl := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_fi.item.cmdbuf)), ('%N').code)))
						if l_nl.is_void then
							l_pos := -1 + 2 -- goto a
						end
				when 5 then
						l_nl := l_nl + 1
						links_inst.add_bytes_to_str (l_login, l_logl, l_fi.item.cmdbuf, l_nl.distance ((l_fi.item.cmdbuf)))
						memmove (create {CE_POINTER [ANY]}.make_cast ((l_fi.item.cmdbuf)), create {CE_POINTER [ANY]}.make_cast (l_nl), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_nl))) + {NATURAL_32} 1).do_nothing
				when 6 then -- if done
						connect_inst.write_to_socket (a_c, a_c.item.sock1, l_login.item, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_login.item))).to_integer_32, ftp_retr_1_address)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 339, create {CE_POINTER [ANY]}.make_cast (l_login.item))
						sched_inst.setcstate (a_c, a_state)
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_sent_passwd (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			js: JUMP_STATE
		do
			create l_rb.make

			l_rb := connect_inst.alloc_read_buffer (a_c)
			if l_rb.is_void then
				js.return
			end
			if not js.return_called then
				connect_inst.read_from_socket (a_c, a_c.item.sock1, l_rb, ftp_pass_info_address)
			end
		end

	ftp_sent_passwd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftp_sent_passwd)
		end

	get_ftp_response (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER]; a_part: INTEGER_32): INTEGER_32
		local
			l_l: INTEGER_32
			l_e: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_k: INTEGER_32
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					sched_inst.set_timeout (a_c)
				when 1 then -- again:
					l_l := 0
				when 2 then -- loop condition:
					if not (not js.loop_done and then (l_l < a_rb.item.len)) then
						l_pos := -1 + 23 -- skip loop
					end
				when 3 then -- loop body:
						if (a_rb.item.data[l_l]).to_integer_32 /= 10 then
							l_pos := -1 + 22 -- skip if block
						end
				when 4 then -- if:
						l_k := (strtoul (create {CE_POINTER [INTEGER_8]}.make_cast ((a_rb.item.data)), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (l_e), 10)).to_integer_32
						if not (l_e.item).is_equal (a_rb.item.data + 3) then
							Result := (-1)
							js.return
						elseif l_k < 100 then
							Result := (-1)
							js.return
						elseif l_k >= 1_000 then
							Result := (-1)
							js.return
						end
						if not (not js.return_called and then ((l_e.item.item).to_integer_32 = 45)) then
							l_pos := -1 + 18 -- skip if block
						end
				when 5 then -- if:
						l_i := 0
				when 6 then -- loop condition:
						if not (not js.loop_done and then (l_i < a_rb.item.len - 5)) then
							l_pos := -1 + 16 -- skip loop
						end
				when 7 then -- loop body:
						if (a_rb.item.data[l_i]).to_integer_32 /= 10 then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (((a_rb.item.data + l_i) + 1)), create {CE_POINTER [ANY]}.make_cast ((a_rb.item.data)), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						if (a_rb.item.data[l_i + 4]).to_integer_32 /= 32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						l_i := l_i + 1
				when 11 then -- loop condition:
						if not (l_i < a_rb.item.len) then
							l_pos := -1 + 14 -- skip loop
						end
				when 12 then -- loop body:
						if (a_rb.item.data[l_i]).to_integer_32 = 10 then
							l_pos := -1 + 17 -- goto ok
						end
				when 13 then
						l_i := l_i + 1
						l_pos := -1 + 11 -- back to loop condition
				when 14 then -- loop done
						Result := 0
						js.return
				when 15 then -- if done | if done | if done
						if not js.return_called then
							l_i := l_i + 1
						end
						l_pos := -1 + 6 -- back to loop condition
				when 16 then -- loop done
						if not js.return_called then
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | ok:
						l_l := l_i
				when 18 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not a_part.to_boolean then
							if l_k >= 100 then
								if l_k < 200 then
									connect_inst.kill_buffer_data (a_rb, l_l + 1)
									l_pos := -1 + 1 -- goto again
								end
							end
						end
				when 20 then
						if a_part = 2 then
							Result := l_k.to_integer_32
							js.return
						end
				when 21 then -- if done
						if not js.return_called then
							connect_inst.kill_buffer_data (a_rb, l_l + 1)
							Result := l_k.to_integer_32
							js.return
						end
				when 22 then -- if done
						if not js.return_called then
							l_l := l_l + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 23 then -- loop done
					if not js.return_called then
						Result := 0
					end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	got_something_from_data_connection (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_inf: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_l: INTEGER_32
			l_ns: INTEGER_32
			l_ud: CE_POINTER [NATURAL_8]
			l_s0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_s0l: CE_ARRAY [INTEGER_32]
			l_m: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_inf.make
			create l_ud.make
			create l_s0.make (<<1>>)
			create l_s0l.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_inf := create {CE_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (a_c.item.info)
					sched_inst.set_timeout (a_c)
					if (l_inf.item.d).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_inf.item.d := 1
						select_inst.set_handlers (a_c.item.sock2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						l_ns := accept (a_c.item.sock2, create {CE_POINTER [SD_SOCKADDR]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer))
						if l_ns = -1 then
							l_pos := -1 + 5 -- goto e
						end
				when 2 then
						close (a_c.item.sock2).do_nothing
						a_c.item.sock2 := l_ns
						select_inst.set_handlers (l_ns, (got_something_from_data_connection_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_c))
						js.return
				when 3 then -- if done
					if not js.return_called and then ((a_c.item.cache).is_void) then
						if (cache_inst.get_cache_entry (a_c.item.url, create {CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))).to_boolean then
							sched_inst.setcstate (a_c, -1_004)
							sched_inst.abort_connection (a_c)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						if (l_inf.item.dir).to_boolean then
							if not (a_c.item.from2).to_boolean then
								cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, ftp_head, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ftp_head))).to_integer_32).do_nothing
								a_c.item.from2 := ((a_c.item.from2).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ftp_head))).to_natural_32).to_integer_32
								l_ud := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 700, (url_inst.get_url_data (a_c.item.url)))
								if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_ud), 1)).is_void) then
									(strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_ud), 1))[0] := (0).to_integer_8
								end
								l_s0.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 702)
								l_s0l.item := 0
								url_inst.add_conv_str (l_s0, l_s0l, l_ud, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ud))).to_integer_32, -1)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 705, create {CE_POINTER [ANY]}.make_cast (l_ud))
								cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, l_s0.item, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s0.item))).to_integer_32).do_nothing
								a_c.item.from2 := ((a_c.item.from2).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s0.item))).to_natural_32).to_integer_32
								cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, ftp_head2, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ftp_head2))).to_integer_32).do_nothing
								a_c.item.from2 := ((a_c.item.from2).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ftp_head2))).to_natural_32).to_integer_32
								cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, l_s0.item, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s0.item))).to_integer_32).do_nothing
								a_c.item.from2 := ((a_c.item.from2).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s0.item))).to_natural_32).to_integer_32
								cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, ftp_head3, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ftp_head3))).to_integer_32).do_nothing
								a_c.item.from2 := ((a_c.item.from2).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ftp_head3))).to_natural_32).to_integer_32
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 710, create {CE_POINTER [ANY]}.make_cast (l_s0.item))
								if ((a_c.item.cache).item.head).is_void then
									(a_c.item.cache).item.head := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.c")), 711, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
								end
								links_inst.add_to_strn (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared ((a_c.item.cache).c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("head")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content-Type: text/html%R%N")))
							end
						end
						l_l := read (a_c.item.sock2, create {CE_POINTER [ANY]}.make_cast ((l_inf.item.ftp_buffer + l_inf.item.buf_pos)), (16_384 - l_inf.item.buf_pos).to_natural_32)
						if l_l /= -1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | e:
						if l_inf.item.conn_st /= 1 then
							if not (l_inf.item.dir).to_boolean then
								if not (a_c.item.from2).to_boolean then
									select_inst.set_handlers (a_c.item.sock2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
									connect_inst.close_socket (create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")))
									l_inf.item.conn_st := 2
									js.return
								end
							end
						end
						if not js.return_called then
							sched_inst.setcstate (a_c, -(errno_location).item)
							sched_inst.retry_connection (a_c)
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called and then (l_l > 0) then
							if not (l_inf.item.dir).to_boolean then
								if a_c.item.from2 + l_l.to_integer_32 < 0 then
									sched_inst.setcstate (a_c, -1_014)
									sched_inst.abort_connection (a_c)
									js.return
								end
								if not js.return_called then
									a_c.item.received := a_c.item.received + l_l.to_integer_32
									if (cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, l_inf.item.ftp_buffer, l_l.to_integer_32)) = 1 then
										a_c.item.tries := 0
									end
									a_c.item.from2 := a_c.item.from2 + l_l.to_integer_32
								end
							else
								a_c.item.received := a_c.item.received + l_l.to_integer_32
								l_m := ftp_process_dirlist (a_c.item.cache, create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("from2")), create {CE_POINTER [INTEGER_32]}.make_shared (l_inf.c_pointer + (create {PD_FTP_CONNECTION_INFO}.make).offset_of ("dpos")), l_inf.item.ftp_buffer, l_l + l_inf.item.buf_pos, 0, create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("tries")))
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_inf.item.ftp_buffer)), create {CE_POINTER [ANY]}.make_cast ((l_inf.item.ftp_buffer + l_m)), ((l_inf.item.buf_pos + l_l) - l_m).to_natural_32).do_nothing
								l_inf.item.buf_pos := l_inf.item.buf_pos + (l_l - l_m)
							end
							if not js.return_called then
								sched_inst.setcstate (a_c, 8)
								js.return
							end
						end
						if not js.return_called then
							ftp_process_dirlist (a_c.item.cache, create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("from2")), create {CE_POINTER [INTEGER_32]}.make_shared (l_inf.c_pointer + (create {PD_FTP_CONNECTION_INFO}.make).offset_of ("dpos")), l_inf.item.ftp_buffer, l_inf.item.buf_pos, 1, create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("tries"))).do_nothing
							select_inst.set_handlers (a_c.item.sock2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							connect_inst.close_socket (create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")))
							if l_inf.item.conn_st = 1 then
								sched_inst.setcstate (a_c, -1_000)
								ftp_end_request (a_c)
							else
								l_inf.item.conn_st := 2
							end
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	got_something_from_data_connection_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent got_something_from_data_connection)
		end

	is_date (a_data: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_data: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_data
					if (l_data[0]).to_integer_32 = 32 then
						l_data := l_data - 1
					end
					if not ((l_data[0]).to_integer_32 >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_data[0]).to_integer_32 <= 57 then
							if (l_data[-1]).to_integer_32 >= 48 then
								if (l_data[-1]).to_integer_32 <= 57 then
									l_data := l_data - (2)
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						if (l_data[0]).to_integer_32 >= 49 then
							if (l_data[0]).to_integer_32 <= 57 then
								if (l_data[-1]).to_integer_32 = 32 then
									l_data := l_data - (1 + ((l_data[-2]).to_integer_32 = 32).to_integer)
								else
									Result := 0
									js.return
								end
							else
								Result := 0
								js.return
							end
						else
							Result := 0
							js.return
						end
				when 4 then
					if not js.return_called and then ((l_data[0]).to_integer_32 = 58) then
						Result := 1
						js.return
					end
					if not js.return_called and then ((l_data[0]).to_integer_32 /= 32) then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 5 then -- if:
						if not ((l_data[-1]).to_integer_32 < 97) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___2
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not ((l_data[-1]).to_integer_32 > 122) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L___2:
						if (l_data[-1]).to_integer_32 < 65 then
							Result := 0
							js.return
						elseif (l_data[-1]).to_integer_32 > 90 then
							Result := 0
							js.return
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 1
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
