class
	P_KBDBIND

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create default_edit_keymap.make (<<21>>)
			create default_main_keymap.make (<<50>>)
			create default_menu_keymap.make (<<14>>)
			create keymaps.make (<<3>>)
		end

feature {ANY} -- attributes

	default_edit_keymap: CE_ARRAY [PD_DEFAULT_KB]

	default_main_keymap: CE_ARRAY [PD_DEFAULT_KB]

	default_menu_keymap: CE_ARRAY [PD_DEFAULT_KB]

	keymaps: CE_ARRAY [PD_LIST_HEAD]

feature {ANY} -- routines

	add_default_keybindings
		local
			l_kb: CE_POINTER [PD_DEFAULT_KB]
		do
			create l_kb.make

			l_kb := default_main_keymap
			from
			until
				not ((l_kb.item.x).to_boolean)
			loop
				add_keybinding (0, l_kb.item.act, l_kb.item.x, l_kb.item.y)
				l_kb := l_kb + 1
			end
			l_kb := default_edit_keymap
			from
			until
				not ((l_kb.item.x).to_boolean)
			loop
				add_keybinding (1, l_kb.item.act, l_kb.item.x, l_kb.item.y)
				l_kb := l_kb + 1
			end
			l_kb := default_menu_keymap
			from
			until
				not ((l_kb.item.x).to_boolean)
			loop
				add_keybinding (2, l_kb.item.act, l_kb.item.x, l_kb.item.y)
				l_kb := l_kb + 1
			end
		end

	add_keybinding (a_km: INTEGER_32; a_act: INTEGER_32; a_x: INTEGER_32; a_y: INTEGER_32)
		local
			l_kb: CE_POINTER [PD_KEYBINDING]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_kb.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_kb := create {CE_POINTER [PD_KEYBINDING]}.make_cast (keymaps[a_km].next)
				when 1 then -- loop condition:
					if l_kb.is_equal (keymaps + a_km) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_kb.item.x = a_x then
							if l_kb.item.y = a_y then
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_kb));
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_kb.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_kb.item.prev);
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_kb.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_kb.item.next)
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_kb))
								l_pos := -1 + 5 -- goto add
							end
						end
				when 3 then
						l_kb := l_kb.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_kb := create {CE_POINTER [PD_KEYBINDING]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbdbind.c")), 26, (create {PD_KEYBINDING}.make).structure_size.to_natural_32)))
				when 5 then -- add:
					l_kb.item.act := a_act
					l_kb.item.x := a_x
					l_kb.item.y := a_y
					from
					until
						js.loop_done
					loop
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((keymaps + a_km)))
						l_kb.item.next := (create {CE_POINTER [PD_KEYBINDING]}.make_cast ((keymaps + a_km))).item.next
						l_kb.item.prev := create {CE_POINTER [PD_KEYBINDING]}.make_cast ((keymaps + a_km));
						(create {CE_POINTER [PD_KEYBINDING]}.make_cast ((keymaps + a_km))).item.next := l_kb;
						(l_kb.item.next).item.prev := l_kb
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((keymaps + a_km)))
						js.break
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bind_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_line: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_line: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_err: CE_POINTER [NATURAL_8]
			l_ckmap: CE_POINTER [NATURAL_8]
			l_ckey: CE_POINTER [NATURAL_8]
			l_cact: CE_POINTER [NATURAL_8]
			l_kmap: INTEGER_32
			l_x: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_act: INTEGER_32
		do
			create l_line.make (<<1>>)
			create l_err.make
			create l_ckmap.make
			create l_ckey.make
			create l_cact.make
			create l_x.make (<<1>>)
			create l_y.make (<<1>>)

			l_line.item := a_line
			l_err := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_ckmap := default_inst.get_token (l_line)
			l_ckey := default_inst.get_token (l_line)
			l_cact := default_inst.get_token (l_line)
			if l_ckmap.is_void then
				l_err := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Missing arguments"))
			elseif l_ckey.is_void then
				l_err := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Missing arguments"))
			elseif l_cact.is_void then
				l_err := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Missing arguments"))
			else
				l_kmap := parse_keymap (l_ckmap)
				if l_kmap < 0 then
					l_err := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unrecognised keymap"))
				elseif (parse_keystroke (l_ckey, l_x, l_y)) < 0 then
					l_err := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error parsing keystroke"))
				else
					l_act := parse_act (l_cact)
					if l_act < 0 then
						l_err := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unrecognised action"))
					else
						add_keybinding (l_kmap, l_act, l_x.item, l_y.item)
					end
				end
			end
			if (not l_cact.is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbdbind.c")), 226, create {CE_POINTER [ANY]}.make_cast (l_cact))
			end
			if (not l_ckey.is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbdbind.c")), 227, create {CE_POINTER [ANY]}.make_cast (l_ckey))
			end
			if (not l_ckmap.is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbdbind.c")), 228, create {CE_POINTER [ANY]}.make_cast (l_ckmap))
			end
			Result := l_err
		end

	bind_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bind_rd)
		end

	delete_keybinding (a_km: INTEGER_32; a_x: INTEGER_32; a_y: INTEGER_32)
		local
			l_kb: CE_POINTER [PD_KEYBINDING]
			js: JUMP_STATE
		do
			create l_kb.make

			l_kb := create {CE_POINTER [PD_KEYBINDING]}.make_cast (keymaps[a_km].next)
			from
			until
				not (not js.loop_done and then (not l_kb.is_equal (keymaps + a_km)))
			loop
				if l_kb.item.x = a_x then
					if l_kb.item.y = a_y then
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_kb));
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_kb.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_kb.item.prev);
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_kb.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_kb.item.next)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_kb))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbdbind.c")), 40, create {CE_POINTER [ANY]}.make_cast (l_kb))
						js.break
					end
				end
				if not js.loop_jumped then
					l_kb := l_kb.item.next
				end
			end
		end

	free_keymaps
		local
			l_i: INTEGER_32
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			js: JUMP_STATE
		do
			create l_a__.make

			l_i := 0
			from
			until
				not (not js.loop_done and then (l_i < 3))
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((keymaps + l_i)))
				l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (keymaps[l_i].next)
				from
				until
					l_a__.is_equal (keymaps + l_i)
				loop
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
					l_a__ := l_a__.item.next
				end
				l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (keymaps[l_i].prev)
				from
				until
					l_a__.is_equal (keymaps + l_i)
				loop
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
					l_a__ := l_a__.item.prev
				end
				from
				until
					(keymaps[l_i].next).is_equal (keymaps + l_i)
				loop
					l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (keymaps[l_i].next)
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbdbind.c")), 55, create {CE_POINTER [ANY]}.make_cast (l_a__))
				end
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((keymaps + l_i)))
				l_i := l_i + 1
			end
		end

	init_keymaps
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < 3)
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((keymaps + l_i)))
				keymaps[l_i].next := create {CE_POINTER [ANY]}.make_cast ((keymaps + l_i))
				keymaps[l_i].prev := create {CE_POINTER [ANY]}.make_cast ((keymaps + l_i))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((keymaps + l_i)))
				l_i := l_i + 1
			end
			add_default_keybindings
		end

	kbd_action (a_kmap: INTEGER_32; a_ev: CE_POINTER [PD_EVENT]): INTEGER_32
		local
			l_kb: CE_POINTER [PD_KEYBINDING]
			js: JUMP_STATE
		do
			create l_kb.make

			if a_ev.item.ev = 1 then
				l_kb := create {CE_POINTER [PD_KEYBINDING]}.make_cast (keymaps[a_kmap].next)
				from
				until
					not (not js.loop_done and then (not l_kb.is_equal (keymaps + a_kmap)))
				loop
					if a_ev.item.x = l_kb.item.x then
						if a_ev.item.y = l_kb.item.y then
							Result := (l_kb.item.act)
							js.return
						end
					end
					if not js.return_called then
						l_kb := l_kb.item.next
					end
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	parse_act (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i: INTEGER_32
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			js: JUMP_STATE
		do
			create l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0.make (<<49>>)

			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("add-bookmark"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("auto-complete"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[2] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("back"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[3] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("backspace"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[4] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark-manager"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[5] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("copy-clipboard"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[6] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cut-clipboard"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[7] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("delete"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[8] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("document-info"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[9] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("down"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[10] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("download"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[11] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("end"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[12] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("enter"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[13] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file-menu"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[14] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("find-next"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[15] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("find-next-back"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[16] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("goto-url"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[17] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("goto-url-current"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[18] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("goto-url-current-link"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[19] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("header-info"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[20] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("home"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[21] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kill-to-bol"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[22] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kill-to-eol"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[23] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("left"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[24] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[25] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("next-frame"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[26] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("open-new-window"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[27] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("open-link-in-new-window"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[28] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("page-down"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[29] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("page-up"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[30] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("paste-clipboard"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[31] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("previous-frame"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[32] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("really-quit"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[33] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("quit"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[34] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("reload"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[35] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("right"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[36] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("scroll-down"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[37] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("scroll-left"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[38] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("scroll-right"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[39] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("scroll-up"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[40] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("search"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[41] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("search-back"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[42] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("toggle-display-images"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[43] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("toggle-display-tables"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[44] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("toggle-html-plain"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[45] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("up"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[46] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view-image"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[47] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("zoom-frame"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[48] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_i := 0
			from
			until
				not (not js.loop_done and then (not (l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[l_i]).is_void))
			loop
				if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[l_i]), create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_boolean then
					Result := l_i
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	parse_key (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0: CE_ARRAY [PD_STR2NUM]
			l_tmp___1: INTEGER_32
		do
			create l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0.make (<<27>>)

			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[0].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Enter"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[0].num := 256
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[1].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Backspace"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[1].num := 257
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[2].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tab"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[2].num := 258
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[3].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Escape"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[3].num := 259
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[4].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Left"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[4].num := 260
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[5].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Right"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[5].num := 261
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[6].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Up"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[6].num := 262
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[7].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Down"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[7].num := 263
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[8].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Insert"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[8].num := 264
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[9].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Delete"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[9].num := 265
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[10].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Home"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[10].num := 266
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[11].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("End"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[11].num := 267
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[12].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PageUp"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[12].num := 268
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[13].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PageDown"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[13].num := 269
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[14].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F1"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[14].num := 288
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[15].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F2"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[15].num := 289
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[16].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F3"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[16].num := 290
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[17].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F4"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[17].num := 291
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[18].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F5"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[18].num := 292
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[19].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F6"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[19].num := 293
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[20].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F7"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[20].num := 294
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[21].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F8"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[21].num := 295
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[22].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F9"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[22].num := 296
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[23].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F10"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[23].num := 297
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[24].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F11"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[24].num := 298
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[25].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F12"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[25].num := 299
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[26].str := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[26].num := 0
			if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s))) = {NATURAL_32} 1 then
				l_tmp___1 := (a_s.item).to_integer_32
			else
				l_tmp___1 := (str2num (l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0, create {CE_POINTER [INTEGER_8]}.make_cast (a_s)))
			end
			Result := l_tmp___1
		end

	parse_keymap (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0: CE_ARRAY [PD_STR2NUM]
		do
			create l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0.make (<<4>>)

			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[0].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("main"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[0].num := 0
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[1].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("edit"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[1].num := 1
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[2].str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu"))
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[2].num := 2
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[3].str := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0[3].num := 0
			Result := (str2num (l_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0, create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_integer_32
		end

	parse_keystroke (a_s: CE_POINTER [NATURAL_8]; a_x: CE_POINTER [INTEGER_32]; a_y: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			create l_s.make

			l_s := a_s
			a_y.item := 0
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("Shift-"), (6).to_natural_32)).to_boolean then
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("Ctrl-"), (5).to_natural_32)).to_boolean then
					if not (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("Alt-"), (4).to_natural_32)).to_boolean then
						a_y.item := (a_y.item).bit_or ((4))
						l_s := l_s + (4)
					end
				else
					a_y.item := (a_y.item).bit_or ((2))
					l_s := l_s + (5)
				end
			else
				a_y.item := (a_y.item).bit_or ((1))
				l_s := l_s + (6)
			end
			l_tmp___4 := parse_key (l_s)
			a_x.item := l_tmp___4
			if l_tmp___4 < 0 then
				l_tmp___3 := -1
			else
				l_tmp___3 := 0
			end
			Result := l_tmp___3
		end

	str2num (a_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0: CE_POINTER [PD_STR2NUM]; a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_p: CE_POINTER [PD_STR2NUM]
			js: JUMP_STATE
		do
			create l_p.make

			l_p := a_table_dirty_workaround_for_name_clash_with_libraries_on_macos___0
			from
			until
				not (not js.loop_done and then (not (l_p.item.str).is_void))
			loop
				if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p.item.str), a_s)).to_boolean then
					Result := (l_p.item.num)
					js.return
				end
				if not js.return_called then
					l_p := l_p + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	unbind_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_line: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_line: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_err: CE_POINTER [NATURAL_8]
			l_ckmap: CE_POINTER [NATURAL_8]
			l_ckey: CE_POINTER [NATURAL_8]
			l_kmap: INTEGER_32
			l_x: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create l_line.make (<<1>>)
			create l_err.make
			create l_ckmap.make
			create l_ckey.make
			create l_x.make (<<1>>)
			create l_y.make (<<1>>)

			l_line.item := a_line
			l_err := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_ckmap := default_inst.get_token (l_line)
			l_ckey := default_inst.get_token (l_line)
			if l_ckmap.is_void then
				l_err := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Missing arguments"))
			else
				l_kmap := parse_keymap (l_ckmap)
				if l_kmap < 0 then
					l_err := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unrecognised keymap"))
				elseif (parse_keystroke (l_ckey, l_x, l_y)) < 0 then
					l_err := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error parsing keystroke"))
				else
					delete_keybinding (l_kmap, l_x.item, l_y.item)
				end
			end
			if (not l_ckey.is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbdbind.c")), 252, create {CE_POINTER [ANY]}.make_cast (l_ckey))
			end
			if (not l_ckmap.is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kbdbind.c")), 253, create {CE_POINTER [ANY]}.make_cast (l_ckmap))
			end
			Result := l_err
		end

	unbind_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent unbind_rd)
		end

end
