class
	P_LINKS

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create current_language.make (<<1>>)
			create d_opt.make
			create dummyarray.make (<<378>>)
			create eofff.make
			create errfile.make
			create ff.make
			create g_argv.make
			create last_form_attr.make
			create last_form_tag.make
			create last_input_tag.make
			create line_break_f.make
			create path_to_exe.make
			create put_chars_f.make
			create special_f.make
			create startf.make
			create system_name.make (<<1_024>>)
		end

feature {ANY} -- attributes

	current_language: CE_ARRAY [INTEGER_32]

	d_opt: CE_POINTER [PD_DOCUMENT_OPTIONS] assign set_d_opt

	set_d_opt (a_d_opt: CE_POINTER [PD_DOCUMENT_OPTIONS])
		do
			d_opt := a_d_opt
		end

	dummyarray: CE_ARRAY [NATURAL_8]

	empty_format: INTEGER_32 assign set_empty_format

	set_empty_format (a_empty_format: INTEGER_32)
		do
			empty_format := a_empty_format
		end

	eofff: CE_POINTER [NATURAL_8] assign set_eofff

	set_eofff (a_eofff: CE_POINTER [NATURAL_8])
		do
			eofff := a_eofff
		end

	errfile: CE_POINTER [NATURAL_8] assign set_errfile

	set_errfile (a_errfile: CE_POINTER [NATURAL_8])
		do
			errfile := a_errfile
		end

	errline: INTEGER_32 assign set_errline

	set_errline (a_errline: INTEGER_32)
		do
			errline := a_errline
		end

	ff: CE_POINTER [ANY] assign set_ff

	set_ff (a_ff: CE_POINTER [ANY])
		do
			ff := a_ff
		end

	g_argc: INTEGER_32 assign set_g_argc

	set_g_argc (a_g_argc: INTEGER_32)
		do
			g_argc := a_g_argc
		end

	g_argv: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_g_argv

	set_g_argv (a_g_argv: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			g_argv := a_g_argv
		end

	last_form_attr: CE_POINTER [NATURAL_8] assign set_last_form_attr

	set_last_form_attr (a_last_form_attr: CE_POINTER [NATURAL_8])
		do
			last_form_attr := a_last_form_attr
		end

	last_form_tag: CE_POINTER [NATURAL_8] assign set_last_form_tag

	set_last_form_tag (a_last_form_tag: CE_POINTER [NATURAL_8])
		do
			last_form_tag := a_last_form_tag
		end

	last_input_tag: CE_POINTER [NATURAL_8] assign set_last_input_tag

	set_last_input_tag (a_last_input_tag: CE_POINTER [NATURAL_8])
		do
			last_input_tag := a_last_input_tag
		end

	last_link_to_move: INTEGER_32 assign set_last_link_to_move

	set_last_link_to_move (a_last_link_to_move: INTEGER_32)
		do
			last_link_to_move := a_last_link_to_move
		end

	line_break_f: CE_ROUTINE assign set_line_break_f

	set_line_break_f (a_line_break_f: CE_ROUTINE)
		do
			line_break_f := a_line_break_f
		end

	line_breax: INTEGER_32 assign set_line_breax

	set_line_breax (a_line_breax: INTEGER_32)
		do
			line_breax := a_line_breax
		end

	margin: INTEGER_32 assign set_margin

	set_margin (a_margin: INTEGER_32)
		do
			margin := a_margin
		end

	path_to_exe: CE_POINTER [NATURAL_8] assign set_path_to_exe

	set_path_to_exe (a_path_to_exe: CE_POINTER [NATURAL_8])
		do
			path_to_exe := a_path_to_exe
		end

	put_chars_f: CE_ROUTINE assign set_put_chars_f

	set_put_chars_f (a_put_chars_f: CE_ROUTINE)
		do
			put_chars_f := a_put_chars_f
		end

	special_f: CE_ROUTINE assign set_special_f

	set_special_f (a_special_f: CE_ROUTINE)
		do
			special_f := a_special_f
		end

	startf: CE_POINTER [NATURAL_8] assign set_startf

	set_startf (a_startf: CE_POINTER [NATURAL_8])
		do
			startf := a_startf
		end

	system_name: CE_ARRAY [NATURAL_8]

	table_level: INTEGER_32 assign set_table_level

	set_table_level (a_table_level: INTEGER_32)
		do
			table_level := a_table_level
		end

feature {ANY} -- routines

	add_bytes_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_a: CE_POINTER [NATURAL_8]; a_ll: INTEGER_32)
		local
			l_p: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			create l_p.make
			create l_tmp.make

			if a_l.item + a_ll < 0 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("links.h"), 418])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_p := a_s.item
			if ((a_l.item).bit_and (-64)) /= (((a_l.item + a_ll)).bit_and (-64)) then
				l_tmp := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.h")), 421, create {CE_POINTER [ANY]}.make_cast (a_s.item), ((((a_l.item + a_ll) + 64)).bit_and (-64)).to_natural_32)))
				a_s.item := l_tmp
				l_p := l_tmp
			end
			memcpy (create {CE_POINTER [ANY]}.make_cast ((l_p + a_l.item)), create {CE_POINTER [ANY]}.make_cast (a_a), a_ll.to_natural_32).do_nothing
			l_tmp___1 := a_l.item + a_ll
			a_l.item := l_tmp___1
			l_p[l_tmp___1] := (0).to_natural_8
		end

	add_chr_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_a: NATURAL_8)
		local
			l_p: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_p.make
			create l_tmp.make

			if a_l.item + 1 < 0 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("links.h"), 429])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_p := a_s.item
			if ((a_l.item).bit_and (63)) = 63 then
				l_tmp := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.h")), 432, create {CE_POINTER [ANY]}.make_cast (a_s.item), ((((a_l.item + 1) + 64)).bit_and (-64)).to_natural_32)))
				a_s.item := l_tmp
				l_p := l_tmp
			end
			l_p[a_l.item] := a_a
			a_l.item := (a_l.item) + 1
			l_p[a_l.item] := (0).to_natural_8
		end

	add_knum_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_n: INTEGER_32)
		local
			l_a: CE_ARRAY [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_a.make (<<13>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_n.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_n // 1_048_576) * 1_048_576 = a_n then
							snzprint (l_a, 12, (a_n // 1_048_576).to_integer_32).do_nothing
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_a), ce_string ("M")).do_nothing
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if a_n.to_boolean then
							if (a_n // 1_024) * 1_024 = a_n then
								snzprint (l_a, 12, (a_n // 1_024).to_integer_32).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_a), ce_string ("k")).do_nothing
							else
								snzprint (l_a, 13, a_n.to_integer_32).do_nothing
							end
						else
							snzprint (l_a, 13, a_n.to_integer_32).do_nothing
						end
				when 4 then
					add_to_str (a_s, a_l, l_a)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_num_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_n: INTEGER_32)
		local
			l_a: CE_ARRAY [NATURAL_8]
		do
			create l_a.make (<<64>>)

			snzprint (l_a, 64, a_n).do_nothing
			add_to_str (a_s, a_l, l_a)
		end

	add_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_a: CE_POINTER [NATURAL_8])
		local
			l_p: CE_POINTER [NATURAL_8]
			l_ll: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ll := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_a)))
					if not (l_ll > {NATURAL_32} 2_147_483_647) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((a_l.item).to_natural_32 + l_ll > {NATURAL_32} 2_147_483_647) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("links.h"), 407])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
				when 5 then -- if done
						l_p := a_s.item
						if (((a_l.item).to_natural_32).bit_and ({NATURAL_32} 4_294_967_232)) /= ((((a_l.item).to_natural_32 + l_ll)).bit_and ({NATURAL_32} 4_294_967_232)) then
							l_tmp___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.h")), 410, create {CE_POINTER [ANY]}.make_cast (a_s.item), ((((a_l.item).to_natural_32 + l_ll) + {NATURAL_32} 64)).bit_and ({NATURAL_32} 4_294_967_232))))
							a_s.item := l_tmp___0
							l_p := l_tmp___0
						end
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p + a_l.item)), create {CE_POINTER [INTEGER_8]}.make_cast (a_a)).do_nothing
						a_l.item := ((a_l.item).to_natural_32 + l_ll).to_integer_32
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	add_to_strn (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_a: CE_POINTER [NATURAL_8])
		local
			l_p: CE_POINTER [NATURAL_8]
			l_l1: NATURAL_32
			l_l2: NATURAL_32
		do
			create l_p.make

			l_l1 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s.item)))
			l_l2 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_a)))
			if ((((l_l1).bit_or (l_l2))).bit_or (((l_l1 + l_l2) + {NATURAL_32} 1))) > {NATURAL_32} 2_147_483_647 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("links.h"), 386])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_p := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.h")), 387, create {CE_POINTER [ANY]}.make_cast (a_s.item), (l_l1 + l_l2) + {NATURAL_32} 1)))
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p), create {CE_POINTER [INTEGER_8]}.make_cast (a_a)).do_nothing
			a_s.item := l_p
		end

	can_read (a_fd: INTEGER_32): INTEGER_32
		local
			l_fd: CE_ARRAY [INTEGER_32]
			l_fds: CE_ARRAY [SD_FD_SET]
			l_tv: CE_ARRAY [SD_TIMEVAL]
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_fd.make (<<1>>)
			create l_fds.make (<<1>>)
			create l_tv.make (<<1>>)
			create l___d0.make (<<1>>)
			create l___d1.make (<<1>>)

			l_fd.item := a_fd
			l_tv.item.tv_sec := (0).to_integer_32
			l_tv.item.tv_usec := (0).to_integer_32
			from
			until
				js.loop_done
			loop
				asm4 (l___d0, l___d1, l_fds)
				js.break
			end
			asm5 (l_fds, l_fd)
			Result := (select2 (l_fd.item + 1, l_fds, create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_tv))
		end

	can_write (a_fd: INTEGER_32): INTEGER_32
		local
			l_fd: CE_ARRAY [INTEGER_32]
			l_fds: CE_ARRAY [SD_FD_SET]
			l_tv: CE_ARRAY [SD_TIMEVAL]
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_fd.make (<<1>>)
			create l_fds.make (<<1>>)
			create l_tv.make (<<1>>)
			create l___d0.make (<<1>>)
			create l___d1.make (<<1>>)

			l_fd.item := a_fd
			l_tv.item.tv_sec := (0).to_integer_32
			l_tv.item.tv_usec := (0).to_integer_32
			from
			until
				js.loop_done
			loop
				asm2 (l___d0, l___d1, l_fds)
				js.break
			end
			asm3 (l_fds, l_fd)
			Result := (select2 (l_fd.item + 1, create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_fds, create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_tv))
		end

	casecmp (a_c1: CE_POINTER [NATURAL_8]; a_c2: CE_POINTER [NATURAL_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_len))
			loop
				l_tmp := upcase (a_c1[l_i.to_integer_32])
				if l_tmp.to_integer_32 /= (upcase (a_c2[l_i.to_integer_32])).to_integer_32 then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cmpbeg (a_str: CE_POINTER [NATURAL_8]; a_b: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_str: CE_POINTER [NATURAL_8]
			l_b: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			create l_str.make
			create l_b.make

			l_str := a_str
			l_b := a_b
			from
			until
				js.loop_done
			loop
				if (l_str.item).to_boolean then
					l_tmp := upcase (l_str.item)
					if l_tmp.to_integer_32 /= (upcase (l_b.item)).to_integer_32 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_str := l_str + 1
					l_b := l_b + 1
				end
			end
			Result := ((l_b.item).to_boolean).to_integer
		end

	debug_memacpy (a_f: CE_POINTER [NATURAL_8]; a_l: INTEGER_32; a_src: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_m: CE_POINTER [NATURAL_8]
		do
			create l_m.make

			l_m := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (a_f, a_l, (a_len + 1).to_natural_32)))
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_m), create {CE_POINTER [ANY]}.make_cast (a_src), a_len.to_natural_32).do_nothing
			l_m[a_len] := (0).to_natural_8
			Result := l_m
		end

	debug_stracpy (a_f: CE_POINTER [NATURAL_8]; a_l: INTEGER_32; a_src: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_tmp___0: NATURAL_32
			l_tmp___2: CE_POINTER [NATURAL_8]
		do
			create l_tmp___2.make

			if (not a_src.is_void) then
				if (a_src.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [ANY]}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
					l_tmp___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_src)))
				else
					l_tmp___0 := (0).to_natural_32
				end
				l_tmp___2 := (debug_memacpy (a_f, a_l, a_src, l_tmp___0.to_integer_32))
			else
				l_tmp___2 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			Result := l_tmp___2
		end

	ds2do (a_ds: CE_POINTER [PD_DOCUMENT_SETUP]; a_doo: CE_POINTER [PD_DOCUMENT_OPTIONS])
		do
			a_doo.item.assume_cp := a_ds.item.assume_cp
			a_doo.item.hard_assume := a_ds.item.hard_assume
			a_doo.item.tables := a_ds.item.tables
			a_doo.item.frames := a_ds.item.frames
			a_doo.item.images := a_ds.item.images
			a_doo.item.margin := a_ds.item.margin
			a_doo.item.num_links := a_ds.item.num_links
			a_doo.item.table_order := a_ds.item.table_order
		end

	end_of_dir (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c.to_integer_32 = 1 then
				l_tmp := 1
			elseif a_c.to_integer_32 = 35 then
				l_tmp := 1
			elseif a_c.to_integer_32 = 59 then
				l_tmp := 1
			elseif a_c.to_integer_32 = 63 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	getpri (a_c: CE_POINTER [PD_CONNECTION]): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_done and then (l_i < 6))
			loop
				if (a_c.item.pri[l_i]).to_boolean then
					Result := l_i
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				from
				until
					False
				loop
					errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.h"))
					errline := 785
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connection has no owner"))])
				end
				Result := 6
			end
		end

	init_str_x (a_file: CE_POINTER [NATURAL_8]; a_line: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
		do
			create l_s.make

			l_s := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (a_file, a_line, (64).to_natural_32)))
			l_s.item := (0).to_natural_8
			Result := l_s
		end

	isA (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_c.to_integer_32 >= 65) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_c.to_integer_32 <= 90 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else: | _L___1:
						if not (a_c.to_integer_32 >= 97) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_c.to_integer_32 <= 122 then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___0:
						if not (a_c.to_integer_32 >= 48) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_c.to_integer_32 <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if a_c.to_integer_32 = 95 then
							l_tmp := 1
						elseif a_c.to_integer_32 = 45 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 10 then -- if done | if done
						Result := l_tmp
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	prealloc_truncate (a_x: INTEGER_32; a_y: INTEGER_32)
		do
		end

	safe_strncpy (a_dst: CE_POINTER [NATURAL_8]; a_src: CE_POINTER [NATURAL_8]; a_dst_size: NATURAL_32): CE_POINTER [NATURAL_8]
		do
			strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_dst), create {CE_POINTER [INTEGER_8]}.make_cast (a_src), a_dst_size).do_nothing
			if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_src))) >= a_dst_size then
				a_dst[(a_dst_size - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
			end
			Result := a_dst
		end

	snprint (a_s: CE_POINTER [NATURAL_8]; a_n: INTEGER_32; a_num: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_num: INTEGER_32
			l_q: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make
			create l_tmp.make

			l_s := a_s
			l_n := a_n
			l_num := a_num
			l_q := (1).to_integer_32
			from
			until
				not (l_q <= l_num // 10)
			loop
				l_q := l_q * (10)
			end
			from
			until
				js.loop_done
			loop
				l_tmp___0 := l_n
				l_n := l_n - 1
				if l_tmp___0 > 1 then
					if not l_q.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_tmp := l_s
					l_s := l_s + 1
					l_tmp.item := (l_num // l_q + 48).to_natural_8
					l_num := l_num \\ l_q
					l_q := l_q // (10)
				end
			end
			l_s.item := (0).to_natural_8
			Result := (l_q.to_boolean).to_integer
		end

	snzprint (a_s: CE_POINTER [NATURAL_8]; a_n: INTEGER_32; a_num: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_num: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_s.make
			create l_tmp.make

			l_s := a_s
			l_n := a_n
			l_num := a_num
			if l_n > 1 then
				if l_num < 0 then
					l_tmp := l_s
					l_s := l_s + 1
					l_tmp.item := (('-').code).to_natural_8
					l_num := -l_num
					l_n := l_n - 1
				end
			end
			Result := (snprint (l_s, l_n, l_num))
		end

	strtolx (a_c: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			if (a_c[0]).to_integer_32 = 48 then
				if (upcase (a_c[1])).to_integer_32 = 88 then
					if (a_c[2]).to_boolean then
						l_l := strtol ((create {CE_POINTER [INTEGER_8]}.make_cast (a_c) + 2), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_end), 16)
					else
						l_l := strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_c), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_end), 10)
					end
				else
					l_l := strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_c), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_end), 10)
				end
			else
				l_l := strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_c), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_end), 10)
			end
			if (a_end.item).is_void then
				Result := l_l
				js.return
			end
			if not js.return_called then
				if (upcase ((a_end.item).item)).to_integer_32 = 75 then
					a_end.item := (a_end.item) + 1
					if l_l < -2_097_151 then
						Result := (-2_147_483_647)
						js.return
					end
					if not js.return_called and then (l_l > 2_097_151) then
						Result := 2_147_483_647
						js.return
					end
					if not js.return_called then
						Result := (l_l * 1_024)
						js.return
					end
				end
			end
			if not js.return_called then
				if (upcase ((a_end.item).item)).to_integer_32 = 77 then
					a_end.item := (a_end.item) + 1
					if l_l < -2_047 then
						Result := (-2_147_483_647)
						js.return
					end
					if not js.return_called and then (l_l > 2_047) then
						Result := 2_147_483_647
						js.return
					end
					if not js.return_called then
						Result := (l_l * 1_048_576)
						js.return
					end
				end
			end
			if not js.return_called then
				Result := l_l
			end
		end

	upcase (a_a: NATURAL_8): NATURAL_8
		local
			l_a: NATURAL_8
		do
			l_a := a_a
			if l_a.to_integer_32 >= 97 then
				if l_a.to_integer_32 <= 122 then
					l_a := (l_a.to_integer_32 - 32).to_natural_8
				end
			end
			Result := l_a
		end

	xstrcmp (a_s1: CE_POINTER [NATURAL_8]; a_s2: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_s1.is_void then
				if a_s2.is_void then
					Result := 0
					js.return
				end
			end
			if not js.return_called and then (a_s1.is_void) then
				Result := (-1)
				js.return
			end
			if not js.return_called and then (a_s2.is_void) then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s1), create {CE_POINTER [INTEGER_8]}.make_cast (a_s2)))
			end
		end

end
