class
	P_SCHED

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create blacklist.make (<<1>>)
			create h_conns.make (<<1>>)
			create keepalive_connections.make (<<1>>)
			create msg_dsc.make (<<39>>)
			create queue.make (<<1>>)
		end

feature {ANY} -- attributes

	active_connections: INTEGER_32 assign set_active_connections

	set_active_connections (a_active_connections: INTEGER_32)
		do
			active_connections := a_active_connections
		end

	blacklist: CE_ARRAY [PD_LIST_HEAD]

	connection_count: NATURAL_32 assign set_connection_count

	set_connection_count (a_connection_count: NATURAL_32)
		do
			connection_count := a_connection_count
		end

	h_conns: CE_ARRAY [PD_LIST_HEAD]

	keepalive_connections: CE_ARRAY [PD_LIST_HEAD]

	keepalive_timeout: INTEGER_32 assign set_keepalive_timeout

	set_keepalive_timeout (a_keepalive_timeout: INTEGER_32)
		do
			keepalive_timeout := a_keepalive_timeout
		end

	msg_dsc: CE_ARRAY [PD_S_MSG_DSC]

	queue: CE_ARRAY [PD_LIST_HEAD]

	st_r: INTEGER_32 assign set_st_r

	set_st_r (a_st_r: INTEGER_32)
		do
			st_r := a_st_r
		end

feature {ANY} -- routines

	abort_all_connections
		do
			from
			until
				(queue.item.next).is_equal (queue)
			loop
				setcstate (create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next), -1_001)
				abort_connection (create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next))
			end
			abort_all_keepalive_connections
		end

	abort_all_keepalive_connections
		local
			l_k: CE_POINTER [PD_K_CONN]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_k.make
			create l_a__.make

			l_k := create {CE_POINTER [PD_K_CONN]}.make_cast (keepalive_connections.item.next)
			from
			until
				l_k.is_equal (keepalive_connections)
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 158, create {CE_POINTER [ANY]}.make_cast (l_k.item.host))
				close (l_k.item.conn).do_nothing
				l_k := l_k.item.next
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (keepalive_connections))
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (keepalive_connections.item.next)
			from
			until
				l_a__.is_equal (keepalive_connections)
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (keepalive_connections.item.prev)
			from
			until
				l_a__.is_equal (keepalive_connections)
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(keepalive_connections.item.next).is_equal (keepalive_connections)
			loop
				l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (keepalive_connections.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 159, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (keepalive_connections))
			check_keepalive_connections
		end

	abort_background_connections
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_c: CE_POINTER [PD_CONNECTION]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_c := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue)
						l_j := 0
				when 3 then -- loop condition:
						if not (l_j <= l_i) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_c := l_c.item.next
						if l_c.is_equal (queue) then
							l_pos := -1 + 7 -- goto brk
						end
				when 5 then
						l_j := l_j + 1
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						if (links_inst.getpri (l_c)) >= 5 then
							setcstate (l_c, -1_001)
							abort_connection (l_c)
						else
							l_i := l_i + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- brk:
					abort_all_keepalive_connections
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	abort_connection (a_c: CE_POINTER [PD_CONNECTION])
		do
			if (a_c.item.running).to_boolean then
				interrupt_connection (a_c)
			end
			del_connection (a_c)
			check_queue_bugs
			select_inst.register_bottom_half (check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
		end

	add_blacklist_entry (a_host: CE_POINTER [NATURAL_8]; a_flags: INTEGER_32)
		local
			l_b: CE_POINTER [PD_BLACKLIST_ENTRY]
			js: JUMP_STATE
		do
			create l_b.make

			l_b := create {CE_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (blacklist.item.next)
			from
			until
				not (not js.loop_done and then (not l_b.is_equal (blacklist)))
			loop
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_host), create {CE_POINTER [INTEGER_8]}.make_cast ((l_b.item.host)))).to_boolean then
					l_b.item.flags := (l_b.item.flags).bit_or (a_flags)
					js.return
				end
				if not js.return_called then
					l_b := l_b.item.next
				end
			end
			if not js.return_called then
				l_b := create {CE_POINTER [PD_BLACKLIST_ENTRY]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 778, ((create {PD_BLACKLIST_ENTRY}.make).structure_size.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_host)))) + {NATURAL_32} 1)))
				l_b.item.flags := a_flags
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_b.item.host)), create {CE_POINTER [INTEGER_8]}.make_cast (a_host)).do_nothing
				from
				until
					js.loop_done
				loop
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (blacklist))
					l_b.item.next := (create {CE_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (blacklist)).item.next
					l_b.item.prev := create {CE_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (blacklist);
					(create {CE_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (blacklist)).item.next := l_b;
					(l_b.item.next).item.prev := l_b
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (blacklist))
					js.break
				end
			end
		end

	add_keepalive_socket (a_c: CE_POINTER [PD_CONNECTION]; a_timeout: INTEGER_32)
		local
			l_k: CE_POINTER [PD_K_CONN]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_ROUTINE
			l_tmp___2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_k.make
			create l_tmp___1.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					free_connection_data (a_c)
					if a_c.item.sock1 = -1 then
						from
						until
							False
						loop
							links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
							links_inst.errline := 234
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("keepalive connection not connected"))])
						end
						l_pos := -1 + 3 -- goto del
					end
				when 1 then
					l_k := create {CE_POINTER [PD_K_CONN]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 237, (create {PD_K_CONN}.make).structure_size.to_natural_32)))
					l_tmp___0 := url_inst.get_port (a_c.item.url)
					l_k.item.port := l_tmp___0
					if l_tmp___0 = -1 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 239, create {CE_POINTER [ANY]}.make_cast (l_k))
						del_connection (a_c)
						l_pos := -1 + 4 -- goto close
					else
						l_tmp___1 := url_inst.get_protocol_handle (a_c.item.url)
						l_k.item.protocol := l_tmp___1
						if (not l_tmp___1.is_void) then
							l_tmp___2 := url_inst.get_host_and_pass (a_c.item.url)
							l_k.item.host := l_tmp___2
							if l_tmp___2.is_void then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 239, create {CE_POINTER [ANY]}.make_cast (l_k))
								del_connection (a_c)
								l_pos := -1 + 4 -- goto close
							end
						else
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 239, create {CE_POINTER [ANY]}.make_cast (l_k))
							del_connection (a_c)
							l_pos := -1 + 4 -- goto close
						end
					end
				when 2 then
					l_k.item.conn := a_c.item.sock1
					l_k.item.timeout := a_timeout
					l_k.item.add_time := select_inst.get_time
					from
					until
						js.loop_done
					loop
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (keepalive_connections))
						l_k.item.next := (create {CE_POINTER [PD_K_CONN]}.make_cast (keepalive_connections)).item.next
						l_k.item.prev := create {CE_POINTER [PD_K_CONN]}.make_cast (keepalive_connections);
						(create {CE_POINTER [PD_K_CONN]}.make_cast (keepalive_connections)).item.next := l_k;
						(l_k.item.next).item.prev := l_k
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (keepalive_connections))
						js.break
					end
				when 3 then -- del:
					del_connection (a_c)
					check_queue_bugs
					select_inst.register_bottom_half (check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
					js.return
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 4 then -- if: | close:
						close (a_c.item.sock1).do_nothing
						check_queue_bugs
						select_inst.register_bottom_half (check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_to_queue (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_cc: CE_POINTER [PD_CONNECTION]
			l_pri: INTEGER_32
			js: JUMP_STATE
		do
			create l_cc.make

			l_pri := (links_inst.getpri (a_c))
			l_cc := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
			from
			until
				not (not js.loop_done and then (not l_cc.is_equal (queue)))
			loop
				if (links_inst.getpri (l_cc)) > l_pri then
					js.break
				end
				if not js.loop_jumped then
					l_cc := l_cc.item.next
				end
			end
			from
			until
				js.loop_done
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_cc.item.prev))
				a_c.item.next := (l_cc.item.prev).item.next
				a_c.item.prev := l_cc.item.prev;
				(l_cc.item.prev).item.next := a_c;
				(a_c.item.next).item.prev := a_c
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_cc.item.prev))
				js.break
			end
		end

	change_connection (a_oldstat: CE_POINTER [PD_STATUS]; a_newstat: CE_POINTER [PD_STATUS]; a_newpri: INTEGER_32)
		local
			l_c: CE_POINTER [PD_CONNECTION]
			l_oldpri: INTEGER_32
			js: JUMP_STATE
		do
			create l_c.make

			if a_oldstat.is_void then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
					links_inst.errline := 639
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("change_connection: oldstat == NULL"))])
				end
				js.return
			end
			if not js.return_called then
				l_oldpri := a_oldstat.item.pri
				if a_oldstat.item.state < 0 then
					if (not a_newstat.is_void) then
						a_newstat.item.ce := a_oldstat.item.ce
						a_newstat.item.state := a_oldstat.item.state
						a_newstat.item.prev_error := a_oldstat.item.prev_error
						if (not (a_newstat.item.end2).is_void) then
							(a_newstat.item.end2).call ([a_newstat, a_newstat.item.data])
						end
					end
					js.return
				end
			end
			if not js.return_called then
				check_queue_bugs
				l_c := a_oldstat.item.c
				l_c.item.pri[l_oldpri] := (l_c.item.pri[l_oldpri]) - 1
				if l_c.item.pri[l_oldpri] < 0 then
					from
					until
						False
					loop
						links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
						links_inst.errline := 657
						error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("priority counter underflow"))])
					end
					l_c.item.pri[l_oldpri] := 0
				end
				l_c.item.pri[a_newpri] := (l_c.item.pri[a_newpri]) + 1
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_oldstat));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_oldstat.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_oldstat.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_oldstat.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_oldstat.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_oldstat))
				a_oldstat.item.state := -1_001
				if (not a_newstat.is_void) then
					a_newstat.item.prg := create {CE_POINTER [PD_REMAINING_INFO]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
					from
					until
						js.loop_done
					loop
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
						a_newstat.item.next := (create {CE_POINTER [PD_STATUS]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next
						a_newstat.item.prev := create {CE_POINTER [PD_STATUS]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))));
						(create {CE_POINTER [PD_STATUS]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next := a_newstat;
						(a_newstat.item.next).item.prev := a_newstat
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
						js.break
					end
					a_newstat.item.state := l_c.item.state
					a_newstat.item.prev_error := l_c.item.prev_error
					a_newstat.item.pri := a_newpri
					a_newstat.item.c := l_c
					a_newstat.item.ce := l_c.item.cache
				end
				if (l_c.item.detached).to_boolean then
					if a_newstat.is_void then
						setcstate (l_c, -1_001)
						abort_connection (l_c)
					end
				end
				sort_queue
				check_queue_bugs
				select_inst.register_bottom_half (check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
			end
		end

	check_keepalive_connections
		local
			l_kc: CE_POINTER [PD_K_CONN]
			l_ct: INTEGER_32
			l_p: INTEGER_32
			js: JUMP_STATE
		do
			create l_kc.make

			l_ct := (select_inst.get_time)
			l_p := 0
			if keepalive_timeout /= -1 then
				select_inst.kill_timer (keepalive_timeout)
				keepalive_timeout := -1
			end
			l_kc := create {CE_POINTER [PD_K_CONN]}.make_cast (keepalive_connections.item.next)
			from
			until
				l_kc.is_equal (keepalive_connections)
			loop
				if (links_inst.can_read (l_kc.item.conn)).to_boolean then
					l_kc := l_kc.item.prev
					del_keepalive_socket (l_kc.item.next)
				elseif l_ct - l_kc.item.add_time > l_kc.item.timeout then
					l_kc := l_kc.item.prev
					del_keepalive_socket (l_kc.item.next)
				else
					l_p := l_p + 1
				end
				l_kc := l_kc.item.next
			end
			from
			until
				not (not js.loop_done and then (l_p > 30))
			loop
				if not ((keepalive_connections.item.next).is_equal (keepalive_connections)) then
					del_keepalive_socket (create {CE_POINTER [PD_K_CONN]}.make_cast (keepalive_connections.item.prev))
				else
					from
					until
						False
					loop
						links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
						links_inst.errline := 293
						error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("keepalive list empty"))])
					end
				end
				l_p := l_p - 1
			end
			if not ((keepalive_connections.item.next).is_equal (keepalive_connections)) then
				keepalive_timeout := select_inst.install_timer ((20_000).to_integer_32, keepalive_timer_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	check_queue (a_dummy: CE_POINTER [ANY])
		local
			l_c: CE_POINTER [PD_CONNECTION]
			l_d: CE_POINTER [PD_CONNECTION]
			l_cp: INTEGER_32
			l_dd: CE_POINTER [PD_CONNECTION]
			l_dd___0: CE_POINTER [PD_CONNECTION]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_d.make
			create l_dd.make
			create l_dd___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start: | again:
					l_c := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
					check_queue_bugs
					check_keepalive_connections
				when 1 then -- loop condition:
					if not (not js.loop_done and then (not l_c.is_equal (queue))) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_cp := (links_inst.getpri (l_c))
						l_d := l_c
				when 3 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						if not l_d.is_equal (queue) then
							if (links_inst.getpri (l_d)) /= l_cp then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_dd := l_d
							l_d := l_d.item.next
							if not (l_dd.item.state).to_boolean then
								if (not (is_host_on_keepalive_list (l_dd)).is_void) then
									if (try_connection (l_dd)).to_boolean then
										l_pos := -1 + 0 -- goto again
									end
								end
							end
						end
				when 5 then
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						l_d := l_c
				when 7 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						if not l_d.is_equal (queue) then
							if (links_inst.getpri (l_d)) /= l_cp then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_dd___0 := l_d
							l_d := l_d.item.next
							if not (l_dd___0.item.state).to_boolean then
								if (try_connection (l_dd___0)).to_boolean then
									l_pos := -1 + 0 -- goto again
								end
							end
						end
				when 9 then
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						l_c := l_d
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- again2:
					l_c := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.prev)
				when 12 then -- loop condition:
					if not (not js.loop_done and then (not l_c.is_equal (queue))) then
						l_pos := -1 + 17 -- skip loop
					end
				when 13 then -- loop body:
						if (links_inst.getpri (l_c)) < 5 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_c.item.state = 0 then
							setcstate (l_c, -1_001)
							del_connection (l_c)
							l_pos := -1 + 11 -- goto again2
						elseif l_c.item.est_length > default_inst.memory_cache_size.item // 4 then
							setcstate (l_c, -1_001)
							abort_connection (l_c)
							l_pos := -1 + 11 -- goto again2
						elseif l_c.item.from2 > default_inst.memory_cache_size.item // 4 then
							setcstate (l_c, -1_001)
							abort_connection (l_c)
							l_pos := -1 + 11 -- goto again2
						end
				when 15 then
						l_c := l_c.item.prev
				when 16 then -- if done
						l_pos := -1 + 12 -- back to loop condition
				when 17 then -- loop done
					check_queue_bugs
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_queue_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent check_queue)
		end

	check_queue_bugs
		local
			l_d: CE_POINTER [PD_CONNECTION]
			l_p: INTEGER_32
			l_ps: INTEGER_32
			l_cc: INTEGER_32
			l_q: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_d.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := 0
					l_ps := 0
				when 1 then -- again:
					l_cc := 0
					l_d := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
				when 2 then -- loop condition:
					if not (not js.loop_done and then (not l_d.is_equal (queue))) then
						l_pos := -1 + 5 -- skip loop
					end
				when 3 then -- loop body:
						l_q := (links_inst.getpri (l_d))
						l_cc := l_cc + (l_d.item.running)
						if l_q < l_p then
							if not l_ps.to_boolean then
								from
								until
									False
								loop
									links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
									links_inst.errline := 460
									error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("queue is not sorted"))])
								end
								sort_queue
								l_ps := 1
								l_pos := -1 + 1 -- goto again
							else
								from
								until
									False
								loop
									links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
									links_inst.errline := 465
									error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("queue is not sorted even after sort_queue!"))])
								end
								js.break
							end
						else
							l_p := l_q
						end
				when 4 then
						if not js.loop_jumped then
							if l_d.item.state < 0 then
								from
								until
									False
								loop
									links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
									links_inst.errline := 469
									error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("interrupted connection on queue (conn %%s, state %%d)")), l_d.item.url, l_d.item.state])
								end
								l_d := l_d.item.prev
								abort_connection (l_d.item.next)
							end
							l_d := l_d.item.next
						end
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
					if l_cc /= active_connections then
						from
						until
							False
						loop
							links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
							links_inst.errline := 475
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bad number of active connections (counted %%d, stored %%d)")), l_cc, active_connections])
						end
						active_connections := l_cc
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	connect_info (a_type: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_ce: CE_POINTER [PD_CONNECTION]
			l_cee: CE_POINTER [PD_K_CONN]
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ce.make
			create l_cee.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
					inspect a_type -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 7 then l_pos := -1 + 2
					when 6 then l_pos := -1 + 3
					when 8 then l_pos := -1 + 4
					when 9 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 2
					l_ce := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
					from
					until
						l_ce.is_equal (queue)
					loop
						l_i := l_i + 1
						l_ce := l_ce.item.next
					end
					Result := l_i.to_integer_32
					js.return
				when 2 then -- switch 1, case 7
					if not js.return_called then
						l_ce := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
						from
						until
							l_ce.is_equal (queue)
						loop
							if l_ce.item.state > 0 then
								if l_ce.item.state < 8 then
									l_tmp := 1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
							l_i := l_i + l_tmp
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						js.return
					end
				when 3 then -- switch 1, case 6
					if not js.return_called then
						l_ce := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
						from
						until
							l_ce.is_equal (queue)
						loop
							l_i := l_i + (l_ce.item.state = 8).to_integer
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						js.return
					end
				when 4 then -- switch 1, case 8
					if not js.return_called then
						l_cee := create {CE_POINTER [PD_K_CONN]}.make_cast (keepalive_connections.item.next)
						from
						until
							l_cee.is_equal (keepalive_connections)
						loop
							l_i := l_i + 1
							l_cee := l_cee.item.next
						end
						Result := l_i.to_integer_32
						js.return
					end
				when 5 then -- switch 1, case 9
					if not js.return_called then
						Result := (queue.c_pointer.to_integer_32).to_integer_32
						js.return
					end
				when 6 then -- switch 1, default:
					if not js.return_called then
						from
						until
							False
						loop
							links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
							links_inst.errline := 41
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cache_info: bad request"))])
						end
					end
				when 7 then -- switch 1, done:
					if not js.return_called then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	connection_disappeared (a_c: CE_POINTER [PD_CONNECTION]; a_count: NATURAL_32): INTEGER_32
		local
			l_d: CE_POINTER [PD_CONNECTION]
			js: JUMP_STATE
		do
			create l_d.make

			l_d := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
			from
			until
				not (not js.loop_done and then (not l_d.is_equal (queue)))
			loop
				if a_c.is_equal (l_d) then
					if a_count = l_d.item.count then
						Result := 0
						js.return
					end
				end
				if not js.return_called then
					l_d := l_d.item.next
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	connection_timeout (a_c: CE_POINTER [PD_CONNECTION])
		do
			a_c.item.timer := -1
			setcstate (a_c, -1_010)
			if (not (a_c.item.dnsquery).is_void) then
				abort_connection (a_c)
			else
				retry_connection (a_c)
			end
		end

	connection_timeout_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent connection_timeout)
		end

	connection_timeout_1 (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_tmp: INTEGER_32
		do
			if (a_c.item.unrestartable).to_boolean then
				l_tmp := default_inst.unrestartable_receive_timeout.item
			else
				l_tmp := default_inst.receive_timeout.item
			end
			a_c.item.timer := select_inst.install_timer ((l_tmp * 500).to_integer_32, (connection_timeout_address), create {CE_POINTER [ANY]}.make_cast (a_c))
		end

	connection_timeout_1_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent connection_timeout_1)
		end

	del_blacklist_entry (a_host: CE_POINTER [NATURAL_8]; a_flags: INTEGER_32)
		local
			l_b: CE_POINTER [PD_BLACKLIST_ENTRY]
			js: JUMP_STATE
		do
			create l_b.make

			l_b := create {CE_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (blacklist.item.next)
			from
			until
				not (not js.loop_done and then (not l_b.is_equal (blacklist)))
			loop
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_host), create {CE_POINTER [INTEGER_8]}.make_cast ((l_b.item.host)))).to_boolean then
					l_b.item.flags := (l_b.item.flags).bit_and (((a_flags).bit_not))
					if not (l_b.item.flags).to_boolean then
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_b));
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_b.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_b.item.prev);
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_b.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_b.item.next)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_b))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 791, create {CE_POINTER [ANY]}.make_cast (l_b))
					end
					js.return
				end
				if not js.return_called then
					l_b := l_b.item.next
				end
			end
			if not js.return_called then
			end
		end

	del_connection (a_c: CE_POINTER [PD_CONNECTION])
		do
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_c));
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_c.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_c.item.prev);
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_c.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_c.item.next)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_c))
			send_connection_info (a_c)
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 221, create {CE_POINTER [ANY]}.make_cast (a_c.item.url))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 222, create {CE_POINTER [ANY]}.make_cast (a_c))
		end

	del_keepalive_socket (a_kc: CE_POINTER [PD_K_CONN])
		do
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_kc));
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_kc.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_kc.item.prev);
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_kc.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_kc.item.next)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_kc))
			close (a_kc.item.conn).do_nothing
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 266, create {CE_POINTER [ANY]}.make_cast (a_kc.item.host))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 267, create {CE_POINTER [ANY]}.make_cast (a_kc))
		end

	detach_connection (a_stat___0: CE_POINTER [PD_STATUS]; a_pos___0: INTEGER_32)
		local
			l_c: CE_POINTER [PD_CONNECTION]
			l_i: INTEGER_32
			l_l: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_stat___0.item.state < 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_c := a_stat___0.item.c
						if (l_c.item.detached).to_boolean then
							l_pos := -1 + 5 -- goto detach_done
						end
				when 2 then
						if (l_c.item.cache).is_void then
							js.return
						end
				when 3 then -- if done
					if not js.return_called then
						if l_c.item.est_length = -1 then
							l_l := l_c.item.from2
						else
							l_l := l_c.item.est_length
						end
						if l_l < default_inst.memory_cache_size.item // 4 then
							js.return
						end
					end
					if not js.return_called then
						l_l := (0).to_integer_32
						l_i := 0
						from
						until
							not (l_i < 5)
						loop
							l_l := l_l + (l_c.item.pri[l_i]).to_integer_32
							l_i := l_i + 1
						end
						if not l_l.to_boolean then
							from
							until
								False
							loop
								links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
								links_inst.errline := 697
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("detaching free connection"))])
							end
						end
						html_r_inst.delete_unused_format_cache_entries
						if l_l /= 1 then
							js.return
						elseif ((l_c.item.cache).item.refcount).to_boolean then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then; -- if:
						(l_c.item.cache).item.url[0] := (0).to_natural_8
						l_c.item.detached := 1
				when 5 then -- detach_done:
						cache_inst.free_entry_to (l_c.item.cache, a_pos___0)
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_blacklist
		local
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_a__.make

			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (blacklist))
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (blacklist.item.next)
			from
			until
				l_a__.is_equal (blacklist)
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (blacklist.item.prev)
			from
			until
				l_a__.is_equal (blacklist)
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(blacklist.item.next).is_equal (blacklist)
			loop
				l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (blacklist.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 806, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (blacklist))
		end

	free_connection_data (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_h: CE_POINTER [PD_H_CONN]
		do
			create l_h.make

			if a_c.item.sock1 /= -1 then
				select_inst.set_handlers (a_c.item.sock1, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
			if a_c.item.sock2 /= -1 then
				select_inst.set_handlers (a_c.item.sock2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
			connect_inst.close_socket (create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")))
			if (a_c.item.pid).to_boolean then
				kill (a_c.item.pid, 2).do_nothing
				kill (a_c.item.pid, 15).do_nothing
				kill (a_c.item.pid, 9).do_nothing
				a_c.item.pid := 0
			end
			if not (a_c.item.running).to_boolean then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
					links_inst.errline := 176
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connection already suspended"))])
				end
			end
			a_c.item.running := 0
			if (not (a_c.item.dnsquery).is_void) then
				dns_inst.kill_dns_request (create {CE_POINTER [CE_POINTER [ANY]]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("dnsquery")))
			end
			if (not (a_c.item.buffer).is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 181, a_c.item.buffer)
				a_c.item.buffer := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			end
			if (not (a_c.item.info).is_void) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 185, a_c.item.info)
				a_c.item.info := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			end
			if a_c.item.timer /= -1 then
				select_inst.kill_timer (a_c.item.timer)
				a_c.item.timer := -1
			end
			active_connections := active_connections - 1
			if active_connections < 0 then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
					links_inst.errline := 190
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("active connections underflow"))])
				end
				active_connections := 0
			end
			if a_c.item.state /= 0 then
				l_h := is_host_on_list (a_c)
				if (not l_h.is_void) then
					l_h.item.conn := (l_h.item.conn) - 1
					if not (l_h.item.conn).to_boolean then
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_h));
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_h.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_h.item.prev);
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_h.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_h.item.next)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_h))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 197, create {CE_POINTER [ANY]}.make_cast (l_h.item.host))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 198, create {CE_POINTER [ANY]}.make_cast (l_h))
					end
				else
					from
					until
						False
					loop
						links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
						links_inst.errline := 200
						error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("suspending connection that is not on the list (state %%d)")), a_c.item.state])
					end
				end
			end
		end

	get_blacklist_flags (a_host: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_b: CE_POINTER [PD_BLACKLIST_ENTRY]
			js: JUMP_STATE
		do
			create l_b.make

			l_b := create {CE_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (blacklist.item.next)
			from
			until
				not (not js.loop_done and then (not l_b.is_equal (blacklist)))
			loop
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_host), create {CE_POINTER [INTEGER_8]}.make_cast ((l_b.item.host)))).to_boolean then
					Result := (l_b.item.flags)
					js.return
				end
				if not js.return_called then
					l_b := l_b.item.next
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	get_keepalive_socket (a_c: CE_POINTER [PD_CONNECTION]): INTEGER_32
		local
			l_k: CE_POINTER [PD_K_CONN]
			l_cc: INTEGER_32
			js: JUMP_STATE
		do
			create l_k.make

			l_k := is_host_on_keepalive_list (a_c)
			if l_k.is_void then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_cc := l_k.item.conn
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_k));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_k.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_k.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_k.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_k.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_k))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 147, create {CE_POINTER [ANY]}.make_cast (l_k.item.host))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 148, create {CE_POINTER [ANY]}.make_cast (l_k))
				a_c.item.sock1 := l_cc
				Result := 0
			end
		end

	get_proxy (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_l: NATURAL_32
			l_proxy: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_32
		do
			create l_proxy.make
			create l_u.make

			l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_url)))
			l_proxy := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if (default_inst.http_proxy[0]).to_boolean then
				if l_l >= {NATURAL_32} 7 then
					if not (links_inst.casecmp (a_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http://")), (7).to_natural_32)).to_boolean then
						l_proxy := default_inst.http_proxy
					end
				end
			end
			if (default_inst.ftp_proxy[0]).to_boolean then
				if l_l >= {NATURAL_32} 6 then
					if not (links_inst.casecmp (a_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp://")), (6).to_natural_32)).to_boolean then
						l_proxy := default_inst.ftp_proxy
					end
				end
			end
			if (not l_proxy.is_void) then
				l_tmp___3 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_proxy))) + {NATURAL_32} 9
			else
				l_tmp___3 := (0).to_natural_32
			end
			l_u := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 532, (l_l + {NATURAL_32} 1) + l_tmp___3)))
			if (not l_proxy.is_void) then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_u), ce_string ("proxy://")).do_nothing
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_u), create {CE_POINTER [INTEGER_8]}.make_cast (l_proxy)).do_nothing
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_u), ce_string ("/")).do_nothing
			else
				l_u.item := (0).to_natural_8
			end
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_u), create {CE_POINTER [INTEGER_8]}.make_cast (a_url)).do_nothing
			Result := l_u
		end

	interrupt_connection (a_c: CE_POINTER [PD_CONNECTION])
		do
			connect_inst.close_socket (create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock1")))
			free_connection_data (a_c)
		end

	is_connection_restartable (a_c: CE_POINTER [PD_CONNECTION]): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if a_c.item.unrestartable >= 2 then
				l_tmp___0 := 0
			else
				if (default_inst.max_tries.item).to_boolean then
					l_tmp := default_inst.max_tries.item
				else
					l_tmp := 1_000
				end
				if a_c.item.tries + 1 >= l_tmp then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
			end
			Result := l_tmp___0
		end

	is_entry_used (a_e: CE_POINTER [PD_CACHE_ENTRY]): INTEGER_32
		local
			l_c: CE_POINTER [PD_CONNECTION]
			js: JUMP_STATE
		do
			create l_c.make

			l_c := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
			from
			until
				not (not js.loop_done and then (not l_c.is_equal (queue)))
			loop
				if (l_c.item.cache).is_equal (a_e) then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_c := l_c.item.next
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	is_host_on_keepalive_list (a_c: CE_POINTER [PD_CONNECTION]): CE_POINTER [PD_K_CONN]
		local
			l_ho: CE_POINTER [NATURAL_8]
			l_po: INTEGER_32
			l_ph: CE_ROUTINE
			l_h: CE_POINTER [PD_K_CONN]
			js: JUMP_STATE
		do
			create l_ho.make
			create l_ph.make
			create l_h.make

			l_po := url_inst.get_port (a_c.item.url)
			if l_po = -1 then
				Result := (create {CE_POINTER [PD_K_CONN]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_ph := url_inst.get_protocol_handle (a_c.item.url)
				if l_ph.is_void then
					Result := (create {CE_POINTER [PD_K_CONN]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_ho := url_inst.get_host_and_pass (a_c.item.url)
				if l_ho.is_void then
					Result := (create {CE_POINTER [PD_K_CONN]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_h := create {CE_POINTER [PD_K_CONN]}.make_cast (keepalive_connections.item.next)
				from
				until
					not (not js.loop_done and then (not l_h.is_equal (keepalive_connections)))
				loop
					if (l_h.item.protocol).is_equal (l_ph) then
						if l_h.item.port = l_po then
							if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_h.item.host), create {CE_POINTER [INTEGER_8]}.make_cast (l_ho))).to_boolean then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 133, create {CE_POINTER [ANY]}.make_cast (l_ho))
								Result := l_h
								js.return
							end
						end
					end
					if not js.return_called then
						l_h := l_h.item.next
					end
				end
			end
			if not js.return_called then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 136, create {CE_POINTER [ANY]}.make_cast (l_ho))
				Result := (create {CE_POINTER [PD_K_CONN]}.make_shared (default_pointer))
			end
		end

	is_host_on_list (a_c: CE_POINTER [PD_CONNECTION]): CE_POINTER [PD_H_CONN]
		local
			l_ho: CE_POINTER [NATURAL_8]
			l_h: CE_POINTER [PD_H_CONN]
			js: JUMP_STATE
		do
			create l_ho.make
			create l_h.make

			l_ho := url_inst.get_host_name (a_c.item.url)
			if l_ho.is_void then
				Result := (create {CE_POINTER [PD_H_CONN]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_h := create {CE_POINTER [PD_H_CONN]}.make_cast (h_conns.item.next)
				from
				until
					not (not js.loop_done and then (not l_h.is_equal (h_conns)))
				loop
					if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_h.item.host), create {CE_POINTER [INTEGER_8]}.make_cast (l_ho))).to_boolean then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 59, create {CE_POINTER [ANY]}.make_cast (l_ho))
						Result := l_h
						js.return
					end
					if not js.return_called then
						l_h := l_h.item.next
					end
				end
			end
			if not js.return_called then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 62, create {CE_POINTER [ANY]}.make_cast (l_ho))
				Result := (create {CE_POINTER [PD_H_CONN]}.make_shared (default_pointer))
			end
		end

	keepalive_timer (a_x: CE_POINTER [ANY])
		do
			keepalive_timeout := -1
			check_keepalive_connections
		end

	keepalive_timer_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent keepalive_timer)
		end

	load_url (a_url: CE_POINTER [NATURAL_8]; a_stat___0: CE_POINTER [PD_STATUS]; a_pri: INTEGER_32; a_no_cache: INTEGER_32): INTEGER_32
		local
			l_e: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_c: CE_POINTER [PD_CONNECTION]
			l_u: CE_POINTER [NATURAL_8]
			l_st: CE_POINTER [PD_STATUS]
			l_tmp___4: NATURAL_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_e.make (<<1>>)
			create l_c.make
			create l_u.make
			create l_st.make

			l_e.item := create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
			if (not a_stat___0.is_void) then
				a_stat___0.item.c := create {CE_POINTER [PD_CONNECTION]}.make_shared (default_pointer)
				a_stat___0.item.ce := create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
				a_stat___0.item.pri := a_pri
			end
			l_c := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
			from
			until
				not (not js.loop_done and then (not l_c.is_equal (queue)))
			loop
				l_st := create {CE_POINTER [PD_STATUS]}.make_cast (l_c.item.statuss.next)
				from
				until
					not (not js.loop_done and then (not l_st.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
				loop
					if l_st.is_equal (a_stat___0) then
						from
						until
							False
						loop
							links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
							links_inst.errline := 550
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("status already assigned to %'%%s%'")), l_c.item.url])
						end
						a_stat___0.item.state := -1_003
						if (not (a_stat___0.item.end2).is_void) then
							(a_stat___0.item.end2).call ([a_stat___0, a_stat___0.item.data])
						end
						Result := 0
						js.return
					end
					if not js.return_called then
						l_st := l_st.item.next
					end
				end
				if not js.return_called then
					l_c := l_c.item.next
				end
			end
			if not js.return_called then
				if (not a_stat___0.is_void) then
					a_stat___0.item.state := -1_004
					a_stat___0.item.prev_error := 0
				end
				if a_no_cache <= 1 then
					if not (cache_inst.find_in_cache (a_url, l_e)).to_boolean then
						if not (l_e.item.item.incomplete).to_boolean then
							if (not a_stat___0.is_void) then
								a_stat___0.item.ce := l_e.item
								a_stat___0.item.state := -1_000
								if (not (a_stat___0.item.end2).is_void) then
									(a_stat___0.item.end2).call ([a_stat___0, a_stat___0.item.data])
								end
							end
							Result := 0
							js.return
						end
					end
				end
			end
			if not js.return_called then
				if not (links_inst.casecmp (a_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("proxy://")), (8).to_natural_32)).to_boolean then
					if (not a_stat___0.is_void) then
						a_stat___0.item.state := -1_009
						if (not (a_stat___0.item.end2).is_void) then
							(a_stat___0.item.end2).call ([a_stat___0, a_stat___0.item.data])
						end
					end
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_u := get_proxy (a_url)
				if l_u.is_void then
					if (not a_stat___0.is_void) then
						(a_stat___0.item.end2).call ([a_stat___0, a_stat___0.item.data])
					end
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_c := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
				from
				until
					not (not js.loop_done and then (not l_c.is_equal (queue)))
				loop
					if not (l_c.item.detached).to_boolean then
						if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_c.item.url), create {CE_POINTER [INTEGER_8]}.make_cast (l_u))).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 579, create {CE_POINTER [ANY]}.make_cast (l_u))
							if (links_inst.getpri (l_c)) > a_pri then
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_c));
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_c.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_c.item.prev);
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_c.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_c.item.next)
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_c))
								l_c.item.pri[a_pri] := (l_c.item.pri[a_pri]) + 1
								add_to_queue (l_c)
								select_inst.register_bottom_half (check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
							else
								l_c.item.pri[a_pri] := (l_c.item.pri[a_pri]) + 1
							end
							if (not a_stat___0.is_void) then
								a_stat___0.item.prg := create {CE_POINTER [PD_REMAINING_INFO]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
								a_stat___0.item.c := l_c
								a_stat___0.item.ce := l_c.item.cache
								from
								until
									js.loop_done
								loop
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
									a_stat___0.item.next := (create {CE_POINTER [PD_STATUS]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next
									a_stat___0.item.prev := create {CE_POINTER [PD_STATUS]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))));
									(create {CE_POINTER [PD_STATUS]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next := a_stat___0;
									(a_stat___0.item.next).item.prev := a_stat___0
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
									js.break
								end
								setcstate (l_c, l_c.item.state)
							end
							check_queue_bugs
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_c := l_c.item.next
					end
				end
			end
			if not js.return_called then
				l_c := create {CE_POINTER [PD_CONNECTION]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 598, (create {PD_CONNECTION}.make).structure_size.to_natural_32)))
				memset (create {CE_POINTER [ANY]}.make_cast (l_c), 0, (create {PD_CONNECTION}.make).structure_size.to_natural_32).do_nothing
				l_tmp___4 := connection_count
				connection_count := connection_count + 1
				l_c.item.count := l_tmp___4
				l_c.item.url := l_u
				l_c.item.running := 0
				l_c.item.prev_error := 0
				if a_no_cache >= 2 then
					l_c.item.from2 := (0).to_integer_32
				elseif (l_e.item).is_void then
					l_c.item.from2 := (0).to_integer_32
				elseif (l_e.item.item.frag.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_e.item.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
					l_c.item.from2 := (0).to_integer_32
				elseif ((create {CE_POINTER [PD_FRAGMENT]}.make_cast (l_e.item.item.frag.next)).item.offset).to_boolean then
					l_c.item.from2 := (0).to_integer_32
				else
					l_c.item.from2 := (create {CE_POINTER [PD_FRAGMENT]}.make_cast (l_e.item.item.frag.next)).item.length
				end
				memset (create {CE_POINTER [ANY]}.make_cast ((l_c.item.pri)), 0, ({PLATFORM}.Integer_32_bytes.to_natural_32 * (6).to_natural_32)).do_nothing
				l_c.item.pri[a_pri] := 1
				l_c.item.no_cache := a_no_cache
				l_tmp___5 := -1
				l_c.item.sock2 := l_tmp___5
				l_c.item.sock1 := l_tmp___5
				l_c.item.dnsquery := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				l_c.item.info := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				l_c.item.buffer := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				l_c.item.cache := create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
				l_c.item.tries := 0
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
				l_c.item.statuss.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))
				l_c.item.statuss.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
				l_c.item.est_length := (-1).to_integer_32
				l_c.item.unrestartable := 0
				l_c.item.prg.timer := -1
				l_c.item.timer := -1
				if (not a_stat___0.is_void) then
					a_stat___0.item.prg := create {CE_POINTER [PD_REMAINING_INFO]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
					a_stat___0.item.c := l_c
					a_stat___0.item.ce := create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
					from
					until
						js.loop_done
					loop
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
						a_stat___0.item.next := (create {CE_POINTER [PD_STATUS]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next
						a_stat___0.item.prev := create {CE_POINTER [PD_STATUS]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))));
						(create {CE_POINTER [PD_STATUS]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next := a_stat___0;
						(a_stat___0.item.next).item.prev := a_stat___0
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
						js.break
					end
				end
				add_to_queue (l_c)
				setcstate (l_c, 0)
				check_queue_bugs
				select_inst.register_bottom_half (check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
				Result := 0
			end
		end

	reset_timeout (a_c: CE_POINTER [PD_CONNECTION])
		do
			if a_c.item.timer /= -1 then
				select_inst.kill_timer (a_c.item.timer)
				a_c.item.timer := -1
			end
		end

	retry_connection (a_c: CE_POINTER [PD_CONNECTION])
		do
			interrupt_connection (a_c)
			if (is_connection_restartable (a_c)).to_boolean then
				a_c.item.tries := (a_c.item.tries) + 1
				a_c.item.prev_error := a_c.item.state
				run_connection (a_c)
			else
				del_connection (a_c)
				check_queue_bugs
				select_inst.register_bottom_half (check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
			end
		end

	run_connection (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_hc: CE_POINTER [PD_H_CONN]
			l_func: CE_ROUTINE
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_hc.make
			create l_func.make
			create l_tmp___0.make

			if (a_c.item.running).to_boolean then
				from
				until
					False
				loop
					links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c"))
					links_inst.errline := 369
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connection already running"))])
				end
				js.return
			end
			if not js.return_called then
				l_func := url_inst.get_protocol_handle (a_c.item.url)
				if l_func.is_void then
					setcstate (a_c, -1_009)
					del_connection (a_c)
					js.return
				end
			end
			if not js.return_called then
				l_hc := is_host_on_list (a_c)
				if l_hc.is_void then
					l_hc := create {CE_POINTER [PD_H_CONN]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 378, (create {PD_H_CONN}.make).structure_size.to_natural_32)))
					if l_hc.is_void then
						setcstate (a_c, -1_004)
						del_connection (a_c)
						js.return
					end
					if not js.return_called then
						l_tmp___0 := url_inst.get_host_name (a_c.item.url)
						l_hc.item.host := l_tmp___0
						if l_tmp___0.is_void then
							setcstate (a_c, -1_009)
							del_connection (a_c)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 386, create {CE_POINTER [ANY]}.make_cast (l_hc))
							js.return
						end
					end
					if not js.return_called then
						l_hc.item.conn := 0
						from
						until
							js.loop_done
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (h_conns))
							l_hc.item.next := (create {CE_POINTER [PD_H_CONN]}.make_cast (h_conns)).item.next
							l_hc.item.prev := create {CE_POINTER [PD_H_CONN]}.make_cast (h_conns);
							(create {CE_POINTER [PD_H_CONN]}.make_cast (h_conns)).item.next := l_hc;
							(l_hc.item.next).item.prev := l_hc
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (h_conns))
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_hc.item.conn := (l_hc.item.conn) + 1
				active_connections := active_connections + 1
				a_c.item.running := 1
				l_func.call ([a_c])
			end
		end

	send_connection_info (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_st: INTEGER_32
			l_count: NATURAL_32
			l_stat___0: CE_POINTER [PD_STATUS]
			js: JUMP_STATE
		do
			create l_stat___0.make

			l_st := a_c.item.state
			l_count := a_c.item.count
			l_stat___0 := create {CE_POINTER [PD_STATUS]}.make_cast (a_c.item.statuss.next)
			from
			until
				not (not js.loop_done and then (not l_stat___0.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
			loop
				l_stat___0.item.ce := a_c.item.cache
				l_stat___0 := l_stat___0.item.next
				if (not ((l_stat___0.item.prev).item.end2).is_void) then
					((l_stat___0.item.prev).item.end2).call ([l_stat___0.item.prev, (l_stat___0.item.prev).item.data])
				end
				if l_st >= 0 then
					if (connection_disappeared (a_c, l_count)).to_boolean then
						js.return
					end
				end
			end
			if not js.return_called then
			end
		end

	set_timeout (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_tmp: INTEGER_32
		do
			if a_c.item.timer /= -1 then
				select_inst.kill_timer (a_c.item.timer)
			end
			if (a_c.item.unrestartable).to_boolean then
				l_tmp := default_inst.unrestartable_receive_timeout.item
			else
				l_tmp := default_inst.receive_timeout.item
			end
			a_c.item.timer := select_inst.install_timer ((l_tmp * 500).to_integer_32, (connection_timeout_1_address), create {CE_POINTER [ANY]}.make_cast (a_c))
		end

	setcstate (a_c: CE_POINTER [PD_CONNECTION]; a_state: INTEGER_32)
		local
			l_stat___0: CE_POINTER [PD_STATUS]
			l_r: CE_POINTER [PD_REMAINING_INFO]
			l_count: NATURAL_32
			l_r___0: CE_POINTER [PD_REMAINING_INFO]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_stat___0.make
			create l_r.make
			create l_r___0.make

			if a_c.item.state < 0 then
				if a_state >= 0 then
					a_c.item.prev_error := a_c.item.state
				end
			end
			l_tmp___0 := a_state
			a_c.item.state := l_tmp___0
			if l_tmp___0 = 8 then
				l_r := create {CE_POINTER [PD_REMAINING_INFO]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
				if l_r.item.timer = -1 then
					l_count := a_c.item.count
					if not (l_r.item.valid).to_boolean then
						memset (create {CE_POINTER [ANY]}.make_cast (l_r), 0, (create {PD_REMAINING_INFO}.make).structure_size.to_natural_32).do_nothing
						l_r.item.valid := 1
					end
					l_r.item.last_time := select_inst.get_time
					l_r.item.last_loaded := l_r.item.loaded
					st_r := 1
					stat_timer (a_c)
					st_r := 0
					if (connection_disappeared (a_c, l_count)).to_boolean then
						js.return
					end
				end
			else
				l_r___0 := create {CE_POINTER [PD_REMAINING_INFO]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
				if l_r___0.item.timer /= -1 then
					select_inst.kill_timer (l_r___0.item.timer)
					l_r___0.item.timer := -1
				end
			end
			if not js.return_called then
				l_stat___0 := create {CE_POINTER [PD_STATUS]}.make_cast (a_c.item.statuss.next)
				from
				until
					l_stat___0.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))
				loop
					l_stat___0.item.state := a_state
					l_stat___0.item.prev_error := a_c.item.prev_error
					l_stat___0 := l_stat___0.item.next
				end
				if a_state >= 0 then
					send_connection_info (a_c)
				end
			end
		end

	sort_queue
		local
			l_c: CE_POINTER [PD_CONNECTION]
			l_n: CE_POINTER [PD_CONNECTION]
			l_swp: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_c.make
			create l_n.make

			from
			until
				js.loop_done
			loop
				l_swp := 0
				l_c := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.next)
				from
				until
					not (not js.loop_done and then (not l_c.is_equal (queue)))
				loop
					if not (l_c.item.next).is_equal (queue) then
						l_tmp := links_inst.getpri (l_c.item.next)
						if l_tmp < (links_inst.getpri (l_c)) then
							l_n := l_c.item.next
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_c));
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_c.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_c.item.prev);
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_c.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_c.item.next)
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_c))
							from
							until
								js.loop_done
							loop
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_n))
								l_c.item.next := l_n.item.next
								l_c.item.prev := l_n
								l_n.item.next := l_c;
								(l_c.item.next).item.prev := l_c
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_n))
								js.break
							end
							l_swp := 1
						end
					end
					l_c := l_c.item.next
				end
				if not l_swp.to_boolean then
					js.break
				end
			end
		end

	stat_timer (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_a: INTEGER_32
			l_r: CE_POINTER [PD_REMAINING_INFO]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			create l_r.make

			l_r := create {CE_POINTER [PD_REMAINING_INFO]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
			if (links_inst.getpri (a_c)) = 5 then
				if a_c.item.est_length > default_inst.memory_cache_size.item // 4 then
					select_inst.register_bottom_half (check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
				elseif a_c.item.from2 > default_inst.memory_cache_size.item // 4 then
					select_inst.register_bottom_half (check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
				end
			end
			l_r.item.loaded := a_c.item.received
			l_tmp___0 := a_c.item.est_length
			l_r.item.size := l_tmp___0
			l_tmp___1 := a_c.item.from2
			l_r.item.pos := l_tmp___1
			if l_tmp___0 < l_tmp___1 then
				if l_r.item.size /= -1 then
					l_r.item.size := a_c.item.from2
				end
			end
			l_a := (select_inst.get_time) - l_r.item.last_time
			l_r.item.dis_b := l_r.item.dis_b + l_a
			from
			until
				not (l_r.item.dis_b >= 5_000)
			loop
				l_r.item.cur_loaded := l_r.item.cur_loaded - (l_r.item.data_in_secs[0]).to_integer_32
				memmove (create {CE_POINTER [ANY]}.make_cast ((l_r.item.data_in_secs)), create {CE_POINTER [ANY]}.make_cast ((l_r.item.data_in_secs + 1)), {PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 49).do_nothing
				l_r.item.data_in_secs[49] := 0
				l_r.item.dis_b := l_r.item.dis_b - (100)
			end
			l_r.item.data_in_secs[49] := ((l_r.item.data_in_secs[49]).to_integer_32 + (l_r.item.loaded - l_r.item.last_loaded)).to_integer_32
			l_r.item.cur_loaded := l_r.item.cur_loaded + (l_r.item.loaded - l_r.item.last_loaded)
			l_r.item.last_loaded := l_r.item.loaded
			l_r.item.last_time := l_r.item.last_time + l_a
			l_r.item.elapsed := l_r.item.elapsed + l_a
			l_r.item.timer := select_inst.install_timer ((100).to_integer_32, (stat_timer_address), create {CE_POINTER [ANY]}.make_cast (a_c))
			if not st_r.to_boolean then
				send_connection_info (a_c)
			end
		end

	stat_timer_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent stat_timer)
		end

	suspend_connection (a_c: CE_POINTER [PD_CONNECTION])
		do
			interrupt_connection (a_c)
			setcstate (a_c, 0)
		end

	try_connection (a_c: CE_POINTER [PD_CONNECTION]): INTEGER_32
		local
			l_hc: CE_POINTER [PD_H_CONN]
			js: JUMP_STATE
		do
			create l_hc.make

			l_hc := create {CE_POINTER [PD_H_CONN]}.make_shared (default_pointer)
			l_hc := is_host_on_list (a_c)
			if (not l_hc.is_void) then
				if l_hc.item.conn >= default_inst.max_connections_to_host.item then
					if (try_to_suspend_connection (a_c, l_hc.item.host)).to_boolean then
						Result := 0
						js.return
					else
						Result := (-1)
						js.return
					end
				end
			end
			if not js.return_called and then (active_connections >= default_inst.max_connections.item) then
				if (try_to_suspend_connection (a_c, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
					Result := 0
					js.return
				else
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				run_connection (a_c)
				Result := 1
			end
		end

	try_to_suspend_connection (a_c: CE_POINTER [PD_CONNECTION]; a_ho: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_pri: INTEGER_32
			l_d: CE_POINTER [PD_CONNECTION]
			l_h: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_d.make
			create l_h.make

			l_pri := (links_inst.getpri (a_c))
			l_d := create {CE_POINTER [PD_CONNECTION]}.make_cast (queue.item.prev)
			from
			until
				not (not js.loop_done and then (not l_d.is_equal (queue)))
			loop
				if (links_inst.getpri (l_d)) <= l_pri then
					Result := (-1)
					js.return
				end
				if not js.return_called then
					if l_d.item.state = 0 then
						js.continue
					end
					if not js.loop_jumped and then (l_d.item.unrestartable = 2) then
						if (links_inst.getpri (l_d)) < 5 then
							js.continue
						end
					end
					if not js.loop_jumped and then (not a_ho.is_void) then
						l_h := url_inst.get_host_name (l_d.item.url)
						if l_h.is_void then
							js.continue
						end
						if not js.loop_jumped then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_h), create {CE_POINTER [INTEGER_8]}.make_cast (a_ho))).to_boolean then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 353, create {CE_POINTER [ANY]}.make_cast (l_h))
								js.continue
							end
						end
						if not js.loop_jumped then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sched.c")), 356, create {CE_POINTER [ANY]}.make_cast (l_h))
						end
					end
					if not js.loop_jumped then
						suspend_connection (l_d)
						Result := 0
						js.return
					end
					if js.loop_increment then
						l_d := l_d.item.prev
					end
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

end
