class
	SD_SIGACTION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sigaction_handler.make
			create sa_mask.make
			create sa_restorer.make
		end

feature {ANY} -- fields

	sigaction_handler: SD_SIGACTION_HANDLER assign set_sigaction_handler

	sa_mask: SD_SIGSET_T assign set_sa_mask

	sa_flags: INTEGER_32 assign set_sa_flags

	sa_restorer: CE_ROUTINE assign set_sa_restorer

feature {ANY} -- setters

	set_sigaction_handler (a_sigaction_handler: SD_SIGACTION_HANDLER)
		do
			sigaction_handler := a_sigaction_handler
			update_memory_field ("sigaction_handler")
		end

	set_sa_mask (a_sa_mask: SD_SIGSET_T)
		do
			sa_mask := a_sa_mask
			update_memory_field ("sa_mask")
		end

	set_sa_flags (a_sa_flags: INTEGER_32)
		do
			sa_flags := a_sa_flags
			update_memory_field ("sa_flags")
		end

	set_sa_restorer (a_sa_restorer: CE_ROUTINE)
		do
			sa_restorer := a_sa_restorer
			update_memory_field ("sa_restorer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sigaction_handler := a_other.sigaction_handler.twin
			sa_mask := a_other.sa_mask.twin
			sa_flags := a_other.sa_flags
			sa_restorer := a_other.sa_restorer
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sigaction_handler.is_equal (a_other.sigaction_handler) and
				sa_mask.is_equal (a_other.sa_mask) and
				sa_flags = a_other.sa_flags and
				sa_restorer.is_equal (a_other.sa_restorer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sigaction_handler"),
					create {CE_STRUCTURE_FIELD}.make ("sa_mask"),
					create {CE_STRUCTURE_FIELD}.make ("sa_flags"),
					create {CE_STRUCTURE_FIELD}.make ("sa_restorer")
				>>)
			init_structure_info
		end

end
