deferred class
	S_UNISTD

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	chdir (a___path: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_chdir (a___path.c_pointer)
		end

	c_chdir (a___path: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return chdir($a___path);"
		end

	close (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return close($a___fd);"
		end

	dup2 (a___fd: INTEGER_32; a___fd2: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return dup2($a___fd, $a___fd2);"
		end

	execvp (a___file: CE_POINTER [INTEGER_8]; a___argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := c_execvp (a___file.c_pointer, a___argv.c_pointer)
		end

	c_execvp (a___file: POINTER; a___argv: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return execvp($a___file, $a___argv);"
		end

	exit2 (a___status: INTEGER_32)
		external
			"C inline use <links.h>"
		alias
			"_exit($a___status);"
		end

	fork: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return eiffel_fork();"
		end

	getcwd (a___buf: CE_POINTER [INTEGER_8]; a___size: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_getcwd (a___buf.c_pointer, a___size))
		end

	c_getcwd (a___buf: POINTER; a___size: NATURAL_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return getcwd($a___buf, $a___size);"
		end

	getpagesize: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getpagesize();"
		end

	getpid: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getpid();"
		end

	pipe (a___pipedes: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_pipe (a___pipedes.c_pointer)
		end

	c_pipe (a___pipedes: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return pipe($a___pipedes);"
		end

	read (a___fd: INTEGER_32; a___buf: CE_POINTER [ANY]; a___nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a___fd, a___buf.c_pointer, a___nbytes)
		end

	c_read (a___fd: INTEGER_32; a___buf: POINTER; a___nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return read($a___fd, $a___buf, $a___nbytes);"
		end

	readlink (a___path: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [INTEGER_8]; a___len: NATURAL_32): INTEGER_32
		do
			Result := c_readlink (a___path.c_pointer, a___buf.c_pointer, a___len)
		end

	c_readlink (a___path: POINTER; a___buf: POINTER; a___len: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return readlink($a___path, $a___buf, $a___len);"
		end

	setpgid (a___pid: INTEGER_32; a___pgid: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return setpgid($a___pid, $a___pgid);"
		end

	sleep (a___seconds: NATURAL_32): NATURAL_32
		external
			"C inline use <links.h>"
		alias
			"return sleep($a___seconds);"
		end

	unlink (a___name: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_unlink (a___name.c_pointer)
		end

	c_unlink (a___name: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return unlink($a___name);"
		end

	write (a___fd: INTEGER_32; a___buf: CE_POINTER [ANY]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_write (a___fd, a___buf.c_pointer, a___n)
		end

	c_write (a___fd: INTEGER_32; a___buf: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return write($a___fd, $a___buf, $a___n);"
		end

end
