class
	PD_AFFFILE_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create af_enc.make
			create af_pref.make
			create af_suff.make
			create af_comp.make
		end

feature {ANY} -- fields

	af_enc: CE_POINTER [NATURAL_8] assign set_af_enc

	af_flagtype: INTEGER_32 assign set_af_flagtype

	af_rare: NATURAL_32 assign set_af_rare

	af_keepcase: NATURAL_32 assign set_af_keepcase

	af_bad: NATURAL_32 assign set_af_bad

	af_needaffix: NATURAL_32 assign set_af_needaffix

	af_circumfix: NATURAL_32 assign set_af_circumfix

	af_needcomp: NATURAL_32 assign set_af_needcomp

	af_comproot: NATURAL_32 assign set_af_comproot

	af_compforbid: NATURAL_32 assign set_af_compforbid

	af_comppermit: NATURAL_32 assign set_af_comppermit

	af_nosuggest: NATURAL_32 assign set_af_nosuggest

	af_pfxpostpone: INTEGER_32 assign set_af_pfxpostpone

	af_pref: PD_HASHTABLE_S assign set_af_pref

	af_suff: PD_HASHTABLE_S assign set_af_suff

	af_comp: PD_HASHTABLE_S assign set_af_comp

feature {ANY} -- setters

	set_af_enc (a_af_enc: CE_POINTER [NATURAL_8])
		do
			af_enc := a_af_enc
			update_memory_field ("af_enc")
		end

	set_af_flagtype (a_af_flagtype: INTEGER_32)
		do
			af_flagtype := a_af_flagtype
			update_memory_field ("af_flagtype")
		end

	set_af_rare (a_af_rare: NATURAL_32)
		do
			af_rare := a_af_rare
			update_memory_field ("af_rare")
		end

	set_af_keepcase (a_af_keepcase: NATURAL_32)
		do
			af_keepcase := a_af_keepcase
			update_memory_field ("af_keepcase")
		end

	set_af_bad (a_af_bad: NATURAL_32)
		do
			af_bad := a_af_bad
			update_memory_field ("af_bad")
		end

	set_af_needaffix (a_af_needaffix: NATURAL_32)
		do
			af_needaffix := a_af_needaffix
			update_memory_field ("af_needaffix")
		end

	set_af_circumfix (a_af_circumfix: NATURAL_32)
		do
			af_circumfix := a_af_circumfix
			update_memory_field ("af_circumfix")
		end

	set_af_needcomp (a_af_needcomp: NATURAL_32)
		do
			af_needcomp := a_af_needcomp
			update_memory_field ("af_needcomp")
		end

	set_af_comproot (a_af_comproot: NATURAL_32)
		do
			af_comproot := a_af_comproot
			update_memory_field ("af_comproot")
		end

	set_af_compforbid (a_af_compforbid: NATURAL_32)
		do
			af_compforbid := a_af_compforbid
			update_memory_field ("af_compforbid")
		end

	set_af_comppermit (a_af_comppermit: NATURAL_32)
		do
			af_comppermit := a_af_comppermit
			update_memory_field ("af_comppermit")
		end

	set_af_nosuggest (a_af_nosuggest: NATURAL_32)
		do
			af_nosuggest := a_af_nosuggest
			update_memory_field ("af_nosuggest")
		end

	set_af_pfxpostpone (a_af_pfxpostpone: INTEGER_32)
		do
			af_pfxpostpone := a_af_pfxpostpone
			update_memory_field ("af_pfxpostpone")
		end

	set_af_pref (a_af_pref: PD_HASHTABLE_S)
		do
			af_pref := a_af_pref
			update_memory_field ("af_pref")
		end

	set_af_suff (a_af_suff: PD_HASHTABLE_S)
		do
			af_suff := a_af_suff
			update_memory_field ("af_suff")
		end

	set_af_comp (a_af_comp: PD_HASHTABLE_S)
		do
			af_comp := a_af_comp
			update_memory_field ("af_comp")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			af_enc := a_other.af_enc
			af_flagtype := a_other.af_flagtype
			af_rare := a_other.af_rare
			af_keepcase := a_other.af_keepcase
			af_bad := a_other.af_bad
			af_needaffix := a_other.af_needaffix
			af_circumfix := a_other.af_circumfix
			af_needcomp := a_other.af_needcomp
			af_comproot := a_other.af_comproot
			af_compforbid := a_other.af_compforbid
			af_comppermit := a_other.af_comppermit
			af_nosuggest := a_other.af_nosuggest
			af_pfxpostpone := a_other.af_pfxpostpone
			af_pref := a_other.af_pref.twin
			af_suff := a_other.af_suff.twin
			af_comp := a_other.af_comp.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				af_enc.is_equal (a_other.af_enc) and
				af_flagtype = a_other.af_flagtype and
				af_rare = a_other.af_rare and
				af_keepcase = a_other.af_keepcase and
				af_bad = a_other.af_bad and
				af_needaffix = a_other.af_needaffix and
				af_circumfix = a_other.af_circumfix and
				af_needcomp = a_other.af_needcomp and
				af_comproot = a_other.af_comproot and
				af_compforbid = a_other.af_compforbid and
				af_comppermit = a_other.af_comppermit and
				af_nosuggest = a_other.af_nosuggest and
				af_pfxpostpone = a_other.af_pfxpostpone and
				af_pref.is_equal (a_other.af_pref) and
				af_suff.is_equal (a_other.af_suff) and
				af_comp.is_equal (a_other.af_comp)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("af_enc"),
					create {CE_STRUCTURE_FIELD}.make ("af_flagtype"),
					create {CE_STRUCTURE_FIELD}.make ("af_rare"),
					create {CE_STRUCTURE_FIELD}.make ("af_keepcase"),
					create {CE_STRUCTURE_FIELD}.make ("af_bad"),
					create {CE_STRUCTURE_FIELD}.make ("af_needaffix"),
					create {CE_STRUCTURE_FIELD}.make ("af_circumfix"),
					create {CE_STRUCTURE_FIELD}.make ("af_needcomp"),
					create {CE_STRUCTURE_FIELD}.make ("af_comproot"),
					create {CE_STRUCTURE_FIELD}.make ("af_compforbid"),
					create {CE_STRUCTURE_FIELD}.make ("af_comppermit"),
					create {CE_STRUCTURE_FIELD}.make ("af_nosuggest"),
					create {CE_STRUCTURE_FIELD}.make ("af_pfxpostpone"),
					create {CE_STRUCTURE_FIELD}.make ("af_pref"),
					create {CE_STRUCTURE_FIELD}.make ("af_suff"),
					create {CE_STRUCTURE_FIELD}.make ("af_comp")
				>>)
			init_structure_info
		end

end
