class
	PD_BALLOONEVALSTRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create target.make
			create balloonShell.make
			create balloonLabel.make
			create msg.make
			create msgCB.make
			create clientData.make
		end

feature {ANY} -- fields

	target: CE_POINTER [SD_GTKWIDGET] assign set_target

	balloonShell: CE_POINTER [SD_GTKWIDGET] assign set_balloonShell

	balloonLabel: CE_POINTER [SD_GTKWIDGET] assign set_balloonLabel

	timerID: NATURAL_32 assign set_timerID

	showState: NATURAL_32 assign set_showState

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	state: NATURAL_32 assign set_state

	ts: INTEGER_32 assign set_ts

	msg: CE_POINTER [NATURAL_8] assign set_msg

	msgCB: CE_ROUTINE assign set_msgCB

	clientData: CE_POINTER [ANY] assign set_clientData

feature {ANY} -- setters

	set_target (a_target: CE_POINTER [SD_GTKWIDGET])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_balloonShell (a_balloonShell: CE_POINTER [SD_GTKWIDGET])
		do
			balloonShell := a_balloonShell
			update_memory_field ("balloonShell")
		end

	set_balloonLabel (a_balloonLabel: CE_POINTER [SD_GTKWIDGET])
		do
			balloonLabel := a_balloonLabel
			update_memory_field ("balloonLabel")
		end

	set_timerID (a_timerID: NATURAL_32)
		do
			timerID := a_timerID
			update_memory_field ("timerID")
		end

	set_showState (a_showState: NATURAL_32)
		do
			showState := a_showState
			update_memory_field ("showState")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_ts (a_ts: INTEGER_32)
		do
			ts := a_ts
			update_memory_field ("ts")
		end

	set_msg (a_msg: CE_POINTER [NATURAL_8])
		do
			msg := a_msg
			update_memory_field ("msg")
		end

	set_msgCB (a_msgCB: CE_ROUTINE)
		do
			msgCB := a_msgCB
			update_memory_field ("msgCB")
		end

	set_clientData (a_clientData: CE_POINTER [ANY])
		do
			clientData := a_clientData
			update_memory_field ("clientData")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			target := a_other.target
			balloonShell := a_other.balloonShell
			balloonLabel := a_other.balloonLabel
			timerID := a_other.timerID
			showState := a_other.showState
			x := a_other.x
			y := a_other.y
			state := a_other.state
			ts := a_other.ts
			msg := a_other.msg
			msgCB := a_other.msgCB
			clientData := a_other.clientData
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				target.is_equal (a_other.target) and
				balloonShell.is_equal (a_other.balloonShell) and
				balloonLabel.is_equal (a_other.balloonLabel) and
				timerID = a_other.timerID and
				showState = a_other.showState and
				x = a_other.x and
				y = a_other.y and
				state = a_other.state and
				ts = a_other.ts and
				msg.is_equal (a_other.msg) and
				msgCB.is_equal (a_other.msgCB) and
				clientData.is_equal (a_other.clientData)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("balloonShell"),
					create {CE_STRUCTURE_FIELD}.make ("balloonLabel"),
					create {CE_STRUCTURE_FIELD}.make ("timerID"),
					create {CE_STRUCTURE_FIELD}.make ("showState"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("ts"),
					create {CE_STRUCTURE_FIELD}.make ("msg"),
					create {CE_STRUCTURE_FIELD}.make ("msgCB"),
					create {CE_STRUCTURE_FIELD}.make ("clientData")
				>>)
			init_structure_info
		end

end
