class
	PD_BLOCK0

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create b0_id.make (<<2>>)
			create b0_version.make (<<10>>)
			create b0_page_size.make (<<4>>)
			create b0_mtime.make (<<4>>)
			create b0_ino.make (<<4>>)
			create b0_pid.make (<<4>>)
			create b0_uname.make (<<40>>)
			create b0_hname.make (<<40>>)
			create b0_fname.make (<<900>>)
		end

feature {ANY} -- fields

	b0_id: CE_ARRAY [NATURAL_8]

	b0_version: CE_ARRAY [NATURAL_8]

	b0_page_size: CE_ARRAY [NATURAL_8]

	b0_mtime: CE_ARRAY [NATURAL_8]

	b0_ino: CE_ARRAY [NATURAL_8]

	b0_pid: CE_ARRAY [NATURAL_8]

	b0_uname: CE_ARRAY [NATURAL_8]

	b0_hname: CE_ARRAY [NATURAL_8]

	b0_fname: CE_ARRAY [NATURAL_8]

	b0_magic_long: INTEGER_32 assign set_b0_magic_long

	b0_magic_int: INTEGER_32 assign set_b0_magic_int

	b0_magic_short: INTEGER_16 assign set_b0_magic_short

	b0_magic_char: NATURAL_8 assign set_b0_magic_char

feature {ANY} -- setters

	set_b0_magic_long (a_b0_magic_long: INTEGER_32)
		do
			b0_magic_long := a_b0_magic_long
			update_memory_field ("b0_magic_long")
		end

	set_b0_magic_int (a_b0_magic_int: INTEGER_32)
		do
			b0_magic_int := a_b0_magic_int
			update_memory_field ("b0_magic_int")
		end

	set_b0_magic_short (a_b0_magic_short: INTEGER_16)
		do
			b0_magic_short := a_b0_magic_short
			update_memory_field ("b0_magic_short")
		end

	set_b0_magic_char (a_b0_magic_char: NATURAL_8)
		do
			b0_magic_char := a_b0_magic_char
			update_memory_field ("b0_magic_char")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			b0_id := a_other.b0_id.twin
			b0_version := a_other.b0_version.twin
			b0_page_size := a_other.b0_page_size.twin
			b0_mtime := a_other.b0_mtime.twin
			b0_ino := a_other.b0_ino.twin
			b0_pid := a_other.b0_pid.twin
			b0_uname := a_other.b0_uname.twin
			b0_hname := a_other.b0_hname.twin
			b0_fname := a_other.b0_fname.twin
			b0_magic_long := a_other.b0_magic_long
			b0_magic_int := a_other.b0_magic_int
			b0_magic_short := a_other.b0_magic_short
			b0_magic_char := a_other.b0_magic_char
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				b0_id.is_equal (a_other.b0_id) and
				b0_version.is_equal (a_other.b0_version) and
				b0_page_size.is_equal (a_other.b0_page_size) and
				b0_mtime.is_equal (a_other.b0_mtime) and
				b0_ino.is_equal (a_other.b0_ino) and
				b0_pid.is_equal (a_other.b0_pid) and
				b0_uname.is_equal (a_other.b0_uname) and
				b0_hname.is_equal (a_other.b0_hname) and
				b0_fname.is_equal (a_other.b0_fname) and
				b0_magic_long = a_other.b0_magic_long and
				b0_magic_int = a_other.b0_magic_int and
				b0_magic_short = a_other.b0_magic_short and
				b0_magic_char = a_other.b0_magic_char
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b0_id", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b0_version", <<10>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b0_page_size", <<4>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b0_mtime", <<4>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b0_ino", <<4>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b0_pid", <<4>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b0_uname", <<40>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b0_hname", <<40>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b0_fname", <<900>>),
					create {CE_STRUCTURE_FIELD}.make ("b0_magic_long"),
					create {CE_STRUCTURE_FIELD}.make ("b0_magic_int"),
					create {CE_STRUCTURE_FIELD}.make ("b0_magic_short"),
					create {CE_STRUCTURE_FIELD}.make ("b0_magic_char")
				>>)
			init_structure_info
		end

end
