class
	PD_BLOCK_HDR

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create bh_next.make
			create bh_prev.make
			create bh_hash_next.make
			create bh_hash_prev.make
			create bh_data.make
		end

feature {ANY} -- fields

	bh_next: CE_POINTER [PD_BLOCK_HDR] assign set_bh_next

	bh_prev: CE_POINTER [PD_BLOCK_HDR] assign set_bh_prev

	bh_hash_next: CE_POINTER [PD_BLOCK_HDR] assign set_bh_hash_next

	bh_hash_prev: CE_POINTER [PD_BLOCK_HDR] assign set_bh_hash_prev

	bh_bnum: INTEGER_32 assign set_bh_bnum

	bh_data: CE_POINTER [NATURAL_8] assign set_bh_data

	bh_page_count: INTEGER_32 assign set_bh_page_count

	bh_flags: INTEGER_8 assign set_bh_flags

feature {ANY} -- setters

	set_bh_next (a_bh_next: CE_POINTER [PD_BLOCK_HDR])
		do
			bh_next := a_bh_next
			update_memory_field ("bh_next")
		end

	set_bh_prev (a_bh_prev: CE_POINTER [PD_BLOCK_HDR])
		do
			bh_prev := a_bh_prev
			update_memory_field ("bh_prev")
		end

	set_bh_hash_next (a_bh_hash_next: CE_POINTER [PD_BLOCK_HDR])
		do
			bh_hash_next := a_bh_hash_next
			update_memory_field ("bh_hash_next")
		end

	set_bh_hash_prev (a_bh_hash_prev: CE_POINTER [PD_BLOCK_HDR])
		do
			bh_hash_prev := a_bh_hash_prev
			update_memory_field ("bh_hash_prev")
		end

	set_bh_bnum (a_bh_bnum: INTEGER_32)
		do
			bh_bnum := a_bh_bnum
			update_memory_field ("bh_bnum")
		end

	set_bh_data (a_bh_data: CE_POINTER [NATURAL_8])
		do
			bh_data := a_bh_data
			update_memory_field ("bh_data")
		end

	set_bh_page_count (a_bh_page_count: INTEGER_32)
		do
			bh_page_count := a_bh_page_count
			update_memory_field ("bh_page_count")
		end

	set_bh_flags (a_bh_flags: INTEGER_8)
		do
			bh_flags := a_bh_flags
			update_memory_field ("bh_flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bh_next := a_other.bh_next
			bh_prev := a_other.bh_prev
			bh_hash_next := a_other.bh_hash_next
			bh_hash_prev := a_other.bh_hash_prev
			bh_bnum := a_other.bh_bnum
			bh_data := a_other.bh_data
			bh_page_count := a_other.bh_page_count
			bh_flags := a_other.bh_flags
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bh_next.is_equal (a_other.bh_next) and
				bh_prev.is_equal (a_other.bh_prev) and
				bh_hash_next.is_equal (a_other.bh_hash_next) and
				bh_hash_prev.is_equal (a_other.bh_hash_prev) and
				bh_bnum = a_other.bh_bnum and
				bh_data.is_equal (a_other.bh_data) and
				bh_page_count = a_other.bh_page_count and
				bh_flags = a_other.bh_flags
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bh_next"),
					create {CE_STRUCTURE_FIELD}.make ("bh_prev"),
					create {CE_STRUCTURE_FIELD}.make ("bh_hash_next"),
					create {CE_STRUCTURE_FIELD}.make ("bh_hash_prev"),
					create {CE_STRUCTURE_FIELD}.make ("bh_bnum"),
					create {CE_STRUCTURE_FIELD}.make ("bh_data"),
					create {CE_STRUCTURE_FIELD}.make ("bh_page_count"),
					create {CE_STRUCTURE_FIELD}.make ("bh_flags")
				>>)
			init_structure_info
		end

end
