class
	PD_BUILTIN_TERM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create bt_string.make
		end

feature {ANY} -- fields

	bt_entry: INTEGER_32 assign set_bt_entry

	bt_string: CE_POINTER [INTEGER_8] assign set_bt_string

feature {ANY} -- setters

	set_bt_entry (a_bt_entry: INTEGER_32)
		do
			bt_entry := a_bt_entry
			update_memory_field ("bt_entry")
		end

	set_bt_string (a_bt_string: CE_POINTER [INTEGER_8])
		do
			bt_string := a_bt_string
			update_memory_field ("bt_string")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bt_entry := a_other.bt_entry
			bt_string := a_other.bt_string
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bt_entry = a_other.bt_entry and
				bt_string.is_equal (a_other.bt_string)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bt_entry"),
					create {CE_STRUCTURE_FIELD}.make ("bt_string")
				>>)
			init_structure_info
		end

end
