class
	PD_CLEANUP_STUFF

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create exception.make
		end

feature {ANY} -- fields

	pending: INTEGER_32 assign set_pending

	exception: CE_POINTER [PD_VIM_EXCEPTION] assign set_exception

feature {ANY} -- setters

	set_pending (a_pending: INTEGER_32)
		do
			pending := a_pending
			update_memory_field ("pending")
		end

	set_exception (a_exception: CE_POINTER [PD_VIM_EXCEPTION])
		do
			exception := a_exception
			update_memory_field ("exception")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pending := a_other.pending
			exception := a_other.exception
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pending = a_other.pending and
				exception.is_equal (a_other.exception)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pending"),
					create {CE_STRUCTURE_FIELD}.make ("exception")
				>>)
			init_structure_info
		end

end
