class
	PD_CMDARG_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create oap.make
			create searchbuf.make
		end

feature {ANY} -- fields

	oap: CE_POINTER [PD_OPARG_S] assign set_oap

	prechar: INTEGER_32 assign set_prechar

	cmdchar: INTEGER_32 assign set_cmdchar

	nchar: INTEGER_32 assign set_nchar

	ncharC1: INTEGER_32 assign set_ncharC1

	ncharC2: INTEGER_32 assign set_ncharC2

	extra_char: INTEGER_32 assign set_extra_char

	opcount: INTEGER_32 assign set_opcount

	count0: INTEGER_32 assign set_count0

	count1: INTEGER_32 assign set_count1

	arg: INTEGER_32 assign set_arg

	retval: INTEGER_32 assign set_retval

	searchbuf: CE_POINTER [NATURAL_8] assign set_searchbuf

feature {ANY} -- setters

	set_oap (a_oap: CE_POINTER [PD_OPARG_S])
		do
			oap := a_oap
			update_memory_field ("oap")
		end

	set_prechar (a_prechar: INTEGER_32)
		do
			prechar := a_prechar
			update_memory_field ("prechar")
		end

	set_cmdchar (a_cmdchar: INTEGER_32)
		do
			cmdchar := a_cmdchar
			update_memory_field ("cmdchar")
		end

	set_nchar (a_nchar: INTEGER_32)
		do
			nchar := a_nchar
			update_memory_field ("nchar")
		end

	set_ncharC1 (a_ncharC1: INTEGER_32)
		do
			ncharC1 := a_ncharC1
			update_memory_field ("ncharC1")
		end

	set_ncharC2 (a_ncharC2: INTEGER_32)
		do
			ncharC2 := a_ncharC2
			update_memory_field ("ncharC2")
		end

	set_extra_char (a_extra_char: INTEGER_32)
		do
			extra_char := a_extra_char
			update_memory_field ("extra_char")
		end

	set_opcount (a_opcount: INTEGER_32)
		do
			opcount := a_opcount
			update_memory_field ("opcount")
		end

	set_count0 (a_count0: INTEGER_32)
		do
			count0 := a_count0
			update_memory_field ("count0")
		end

	set_count1 (a_count1: INTEGER_32)
		do
			count1 := a_count1
			update_memory_field ("count1")
		end

	set_arg (a_arg: INTEGER_32)
		do
			arg := a_arg
			update_memory_field ("arg")
		end

	set_retval (a_retval: INTEGER_32)
		do
			retval := a_retval
			update_memory_field ("retval")
		end

	set_searchbuf (a_searchbuf: CE_POINTER [NATURAL_8])
		do
			searchbuf := a_searchbuf
			update_memory_field ("searchbuf")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			oap := a_other.oap
			prechar := a_other.prechar
			cmdchar := a_other.cmdchar
			nchar := a_other.nchar
			ncharC1 := a_other.ncharC1
			ncharC2 := a_other.ncharC2
			extra_char := a_other.extra_char
			opcount := a_other.opcount
			count0 := a_other.count0
			count1 := a_other.count1
			arg := a_other.arg
			retval := a_other.retval
			searchbuf := a_other.searchbuf
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				oap.is_equal (a_other.oap) and
				prechar = a_other.prechar and
				cmdchar = a_other.cmdchar and
				nchar = a_other.nchar and
				ncharC1 = a_other.ncharC1 and
				ncharC2 = a_other.ncharC2 and
				extra_char = a_other.extra_char and
				opcount = a_other.opcount and
				count0 = a_other.count0 and
				count1 = a_other.count1 and
				arg = a_other.arg and
				retval = a_other.retval and
				searchbuf.is_equal (a_other.searchbuf)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("oap"),
					create {CE_STRUCTURE_FIELD}.make ("prechar"),
					create {CE_STRUCTURE_FIELD}.make ("cmdchar"),
					create {CE_STRUCTURE_FIELD}.make ("nchar"),
					create {CE_STRUCTURE_FIELD}.make ("ncharC1"),
					create {CE_STRUCTURE_FIELD}.make ("ncharC2"),
					create {CE_STRUCTURE_FIELD}.make ("extra_char"),
					create {CE_STRUCTURE_FIELD}.make ("opcount"),
					create {CE_STRUCTURE_FIELD}.make ("count0"),
					create {CE_STRUCTURE_FIELD}.make ("count1"),
					create {CE_STRUCTURE_FIELD}.make ("arg"),
					create {CE_STRUCTURE_FIELD}.make ("retval"),
					create {CE_STRUCTURE_FIELD}.make ("searchbuf")
				>>)
			init_structure_info
		end

end
