class
	PD_CMDMOD_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create save_ei.make
		end

feature {ANY} -- fields

	hide: INTEGER_32 assign set_hide

	browse: INTEGER_32 assign set_browse

	split: INTEGER_32 assign set_split

	tab: INTEGER_32 assign set_tab

	confirm: INTEGER_32 assign set_confirm

	keepalt: INTEGER_32 assign set_keepalt

	keepmarks: INTEGER_32 assign set_keepmarks

	keepjumps: INTEGER_32 assign set_keepjumps

	lockmarks: INTEGER_32 assign set_lockmarks

	save_ei: CE_POINTER [NATURAL_8] assign set_save_ei

feature {ANY} -- setters

	set_hide (a_hide: INTEGER_32)
		do
			hide := a_hide
			update_memory_field ("hide")
		end

	set_browse (a_browse: INTEGER_32)
		do
			browse := a_browse
			update_memory_field ("browse")
		end

	set_split (a_split: INTEGER_32)
		do
			split := a_split
			update_memory_field ("split")
		end

	set_tab (a_tab: INTEGER_32)
		do
			tab := a_tab
			update_memory_field ("tab")
		end

	set_confirm (a_confirm: INTEGER_32)
		do
			confirm := a_confirm
			update_memory_field ("confirm")
		end

	set_keepalt (a_keepalt: INTEGER_32)
		do
			keepalt := a_keepalt
			update_memory_field ("keepalt")
		end

	set_keepmarks (a_keepmarks: INTEGER_32)
		do
			keepmarks := a_keepmarks
			update_memory_field ("keepmarks")
		end

	set_keepjumps (a_keepjumps: INTEGER_32)
		do
			keepjumps := a_keepjumps
			update_memory_field ("keepjumps")
		end

	set_lockmarks (a_lockmarks: INTEGER_32)
		do
			lockmarks := a_lockmarks
			update_memory_field ("lockmarks")
		end

	set_save_ei (a_save_ei: CE_POINTER [NATURAL_8])
		do
			save_ei := a_save_ei
			update_memory_field ("save_ei")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hide := a_other.hide
			browse := a_other.browse
			split := a_other.split
			tab := a_other.tab
			confirm := a_other.confirm
			keepalt := a_other.keepalt
			keepmarks := a_other.keepmarks
			keepjumps := a_other.keepjumps
			lockmarks := a_other.lockmarks
			save_ei := a_other.save_ei
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hide = a_other.hide and
				browse = a_other.browse and
				split = a_other.split and
				tab = a_other.tab and
				confirm = a_other.confirm and
				keepalt = a_other.keepalt and
				keepmarks = a_other.keepmarks and
				keepjumps = a_other.keepjumps and
				lockmarks = a_other.lockmarks and
				save_ei.is_equal (a_other.save_ei)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hide"),
					create {CE_STRUCTURE_FIELD}.make ("browse"),
					create {CE_STRUCTURE_FIELD}.make ("split"),
					create {CE_STRUCTURE_FIELD}.make ("tab"),
					create {CE_STRUCTURE_FIELD}.make ("confirm"),
					create {CE_STRUCTURE_FIELD}.make ("keepalt"),
					create {CE_STRUCTURE_FIELD}.make ("keepmarks"),
					create {CE_STRUCTURE_FIELD}.make ("keepjumps"),
					create {CE_STRUCTURE_FIELD}.make ("lockmarks"),
					create {CE_STRUCTURE_FIELD}.make ("save_ei")
				>>)
			init_structure_info
		end

end
