class
	PD_CMDNAME

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create cmd_name.make
			create cmd_func.make
		end

feature {ANY} -- fields

	cmd_name: CE_POINTER [NATURAL_8] assign set_cmd_name

	cmd_func: CE_ROUTINE assign set_cmd_func

	cmd_argt: NATURAL_32 assign set_cmd_argt

feature {ANY} -- setters

	set_cmd_name (a_cmd_name: CE_POINTER [NATURAL_8])
		do
			cmd_name := a_cmd_name
			update_memory_field ("cmd_name")
		end

	set_cmd_func (a_cmd_func: CE_ROUTINE)
		do
			cmd_func := a_cmd_func
			update_memory_field ("cmd_func")
		end

	set_cmd_argt (a_cmd_argt: NATURAL_32)
		do
			cmd_argt := a_cmd_argt
			update_memory_field ("cmd_argt")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cmd_name := a_other.cmd_name
			cmd_func := a_other.cmd_func
			cmd_argt := a_other.cmd_argt
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cmd_name.is_equal (a_other.cmd_name) and
				cmd_func.is_equal (a_other.cmd_func) and
				cmd_argt = a_other.cmd_argt
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cmd_name"),
					create {CE_STRUCTURE_FIELD}.make ("cmd_func"),
					create {CE_STRUCTURE_FIELD}.make ("cmd_argt")
				>>)
			init_structure_info
		end

end
