class
	PD_CONTEXT_SHA256_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create total.make (<<2>>)
			create state.make (<<8>>)
			create buffer.make (<<64>>)
		end

feature {ANY} -- fields

	total: CE_ARRAY [NATURAL_32]

	state: CE_ARRAY [NATURAL_32]

	buffer: CE_ARRAY [NATURAL_8]

feature {ANY}

	copy (a_other: like Current)
		do
			total := a_other.total.twin
			state := a_other.state.twin
			buffer := a_other.buffer.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				total.is_equal (a_other.total) and
				state.is_equal (a_other.state) and
				buffer.is_equal (a_other.buffer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("total", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("state", <<8>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("buffer", <<64>>)
				>>)
			init_structure_info
		end

end
