class
	PD_CONVERTSTRUCT

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	rangeStart: INTEGER_32 assign set_rangeStart

	rangeEnd: INTEGER_32 assign set_rangeEnd

	step: INTEGER_32 assign set_step

	offset: INTEGER_32 assign set_offset

feature {ANY} -- setters

	set_rangeStart (a_rangeStart: INTEGER_32)
		do
			rangeStart := a_rangeStart
			update_memory_field ("rangeStart")
		end

	set_rangeEnd (a_rangeEnd: INTEGER_32)
		do
			rangeEnd := a_rangeEnd
			update_memory_field ("rangeEnd")
		end

	set_step (a_step: INTEGER_32)
		do
			step := a_step
			update_memory_field ("step")
		end

	set_offset (a_offset: INTEGER_32)
		do
			offset := a_offset
			update_memory_field ("offset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			rangeStart := a_other.rangeStart
			rangeEnd := a_other.rangeEnd
			step := a_other.step
			offset := a_other.offset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				rangeStart = a_other.rangeStart and
				rangeEnd = a_other.rangeEnd and
				step = a_other.step and
				offset = a_other.offset
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("rangeStart"),
					create {CE_STRUCTURE_FIELD}.make ("rangeEnd"),
					create {CE_STRUCTURE_FIELD}.make ("step"),
					create {CE_STRUCTURE_FIELD}.make ("offset")
				>>)
			init_structure_info
		end

end
