class
	PD_DATA_BLOCK

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create db_index.make (<<1>>)
		end

feature {ANY} -- fields

	db_id: NATURAL_16 assign set_db_id

	db_free: NATURAL_32 assign set_db_free

	db_txt_start: NATURAL_32 assign set_db_txt_start

	db_txt_end: NATURAL_32 assign set_db_txt_end

	db_line_count: INTEGER_32 assign set_db_line_count

	db_index: CE_ARRAY [NATURAL_32]

feature {ANY} -- setters

	set_db_id (a_db_id: NATURAL_16)
		do
			db_id := a_db_id
			update_memory_field ("db_id")
		end

	set_db_free (a_db_free: NATURAL_32)
		do
			db_free := a_db_free
			update_memory_field ("db_free")
		end

	set_db_txt_start (a_db_txt_start: NATURAL_32)
		do
			db_txt_start := a_db_txt_start
			update_memory_field ("db_txt_start")
		end

	set_db_txt_end (a_db_txt_end: NATURAL_32)
		do
			db_txt_end := a_db_txt_end
			update_memory_field ("db_txt_end")
		end

	set_db_line_count (a_db_line_count: INTEGER_32)
		do
			db_line_count := a_db_line_count
			update_memory_field ("db_line_count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			db_id := a_other.db_id
			db_free := a_other.db_free
			db_txt_start := a_other.db_txt_start
			db_txt_end := a_other.db_txt_end
			db_line_count := a_other.db_line_count
			db_index := a_other.db_index.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				db_id = a_other.db_id and
				db_free = a_other.db_free and
				db_txt_start = a_other.db_txt_start and
				db_txt_end = a_other.db_txt_end and
				db_line_count = a_other.db_line_count and
				db_index.is_equal (a_other.db_index)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("db_id"),
					create {CE_STRUCTURE_FIELD}.make ("db_free"),
					create {CE_STRUCTURE_FIELD}.make ("db_txt_start"),
					create {CE_STRUCTURE_FIELD}.make ("db_txt_end"),
					create {CE_STRUCTURE_FIELD}.make ("db_line_count"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("db_index", <<1>>)
				>>)
			init_structure_info
		end

end
