class
	PD_DIALOGINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create dialog.make
		end

feature {ANY} -- fields

	ignore_enter: INTEGER_32 assign set_ignore_enter

	noalt: INTEGER_32 assign set_noalt

	dialog: CE_POINTER [SD_GTKDIALOG] assign set_dialog

feature {ANY} -- setters

	set_ignore_enter (a_ignore_enter: INTEGER_32)
		do
			ignore_enter := a_ignore_enter
			update_memory_field ("ignore_enter")
		end

	set_noalt (a_noalt: INTEGER_32)
		do
			noalt := a_noalt
			update_memory_field ("noalt")
		end

	set_dialog (a_dialog: CE_POINTER [SD_GTKDIALOG])
		do
			dialog := a_dialog
			update_memory_field ("dialog")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ignore_enter := a_other.ignore_enter
			noalt := a_other.noalt
			dialog := a_other.dialog
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ignore_enter = a_other.ignore_enter and
				noalt = a_other.noalt and
				dialog.is_equal (a_other.dialog)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ignore_enter"),
					create {CE_STRUCTURE_FIELD}.make ("noalt"),
					create {CE_STRUCTURE_FIELD}.make ("dialog")
				>>)
			init_structure_info
		end

end
