class
	PD_DICTVAR_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create dv_hashtab.make
			create dv_copydict.make
			create dv_used_next.make
			create dv_used_prev.make
		end

feature {ANY} -- fields

	dv_refcount: INTEGER_32 assign set_dv_refcount

	dv_hashtab: PD_HASHTABLE_S assign set_dv_hashtab

	dv_copyID: INTEGER_32 assign set_dv_copyID

	dv_copydict: CE_POINTER [PD_DICTVAR_S] assign set_dv_copydict

	dv_lock: INTEGER_8 assign set_dv_lock

	dv_used_next: CE_POINTER [PD_DICTVAR_S] assign set_dv_used_next

	dv_used_prev: CE_POINTER [PD_DICTVAR_S] assign set_dv_used_prev

feature {ANY} -- setters

	set_dv_refcount (a_dv_refcount: INTEGER_32)
		do
			dv_refcount := a_dv_refcount
			update_memory_field ("dv_refcount")
		end

	set_dv_hashtab (a_dv_hashtab: PD_HASHTABLE_S)
		do
			dv_hashtab := a_dv_hashtab
			update_memory_field ("dv_hashtab")
		end

	set_dv_copyID (a_dv_copyID: INTEGER_32)
		do
			dv_copyID := a_dv_copyID
			update_memory_field ("dv_copyID")
		end

	set_dv_copydict (a_dv_copydict: CE_POINTER [PD_DICTVAR_S])
		do
			dv_copydict := a_dv_copydict
			update_memory_field ("dv_copydict")
		end

	set_dv_lock (a_dv_lock: INTEGER_8)
		do
			dv_lock := a_dv_lock
			update_memory_field ("dv_lock")
		end

	set_dv_used_next (a_dv_used_next: CE_POINTER [PD_DICTVAR_S])
		do
			dv_used_next := a_dv_used_next
			update_memory_field ("dv_used_next")
		end

	set_dv_used_prev (a_dv_used_prev: CE_POINTER [PD_DICTVAR_S])
		do
			dv_used_prev := a_dv_used_prev
			update_memory_field ("dv_used_prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dv_refcount := a_other.dv_refcount
			dv_hashtab := a_other.dv_hashtab.twin
			dv_copyID := a_other.dv_copyID
			dv_copydict := a_other.dv_copydict
			dv_lock := a_other.dv_lock
			dv_used_next := a_other.dv_used_next
			dv_used_prev := a_other.dv_used_prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dv_refcount = a_other.dv_refcount and
				dv_hashtab.is_equal (a_other.dv_hashtab) and
				dv_copyID = a_other.dv_copyID and
				dv_copydict.is_equal (a_other.dv_copydict) and
				dv_lock = a_other.dv_lock and
				dv_used_next.is_equal (a_other.dv_used_next) and
				dv_used_prev.is_equal (a_other.dv_used_prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dv_refcount"),
					create {CE_STRUCTURE_FIELD}.make ("dv_hashtab"),
					create {CE_STRUCTURE_FIELD}.make ("dv_copyID"),
					create {CE_STRUCTURE_FIELD}.make ("dv_copydict"),
					create {CE_STRUCTURE_FIELD}.make ("dv_lock"),
					create {CE_STRUCTURE_FIELD}.make ("dv_used_next"),
					create {CE_STRUCTURE_FIELD}.make ("dv_used_prev")
				>>)
			init_structure_info
		end

end
