class
	PD_EXARG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create arg.make
			create nextcmd.make
			create cmd.make
			create cmdlinep.make
			create do_ecmd_cmd.make
			create errmsg.make
			create getline.make
			create cookie.make
			create cstack.make
		end

feature {ANY} -- fields

	arg: CE_POINTER [NATURAL_8] assign set_arg

	nextcmd: CE_POINTER [NATURAL_8] assign set_nextcmd

	cmd: CE_POINTER [NATURAL_8] assign set_cmd

	cmdlinep: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_cmdlinep

	cmdidx: INTEGER_32 assign set_cmdidx

	argt: INTEGER_32 assign set_argt

	skip: INTEGER_32 assign set_skip

	forceit: INTEGER_32 assign set_forceit

	addr_count: INTEGER_32 assign set_addr_count

	line1: INTEGER_32 assign set_line1

	line2: INTEGER_32 assign set_line2

	flags: INTEGER_32 assign set_flags

	do_ecmd_cmd: CE_POINTER [NATURAL_8] assign set_do_ecmd_cmd

	do_ecmd_lnum: INTEGER_32 assign set_do_ecmd_lnum

	append: INTEGER_32 assign set_append

	usefilter: INTEGER_32 assign set_usefilter

	amount: INTEGER_32 assign set_amount

	regname: INTEGER_32 assign set_regname

	force_bin: INTEGER_32 assign set_force_bin

	read_edit: INTEGER_32 assign set_read_edit

	force_ff: INTEGER_32 assign set_force_ff

	force_enc: INTEGER_32 assign set_force_enc

	bad_char: INTEGER_32 assign set_bad_char

	useridx: INTEGER_32 assign set_useridx

	errmsg: CE_POINTER [NATURAL_8] assign set_errmsg

	getline: CE_ROUTINE assign set_getline

	cookie: CE_POINTER [ANY] assign set_cookie

	cstack: CE_POINTER [PD_CONDSTACK] assign set_cstack

feature {ANY} -- setters

	set_arg (a_arg: CE_POINTER [NATURAL_8])
		do
			arg := a_arg
			update_memory_field ("arg")
		end

	set_nextcmd (a_nextcmd: CE_POINTER [NATURAL_8])
		do
			nextcmd := a_nextcmd
			update_memory_field ("nextcmd")
		end

	set_cmd (a_cmd: CE_POINTER [NATURAL_8])
		do
			cmd := a_cmd
			update_memory_field ("cmd")
		end

	set_cmdlinep (a_cmdlinep: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			cmdlinep := a_cmdlinep
			update_memory_field ("cmdlinep")
		end

	set_cmdidx (a_cmdidx: INTEGER_32)
		do
			cmdidx := a_cmdidx
			update_memory_field ("cmdidx")
		end

	set_argt (a_argt: INTEGER_32)
		do
			argt := a_argt
			update_memory_field ("argt")
		end

	set_skip (a_skip: INTEGER_32)
		do
			skip := a_skip
			update_memory_field ("skip")
		end

	set_forceit (a_forceit: INTEGER_32)
		do
			forceit := a_forceit
			update_memory_field ("forceit")
		end

	set_addr_count (a_addr_count: INTEGER_32)
		do
			addr_count := a_addr_count
			update_memory_field ("addr_count")
		end

	set_line1 (a_line1: INTEGER_32)
		do
			line1 := a_line1
			update_memory_field ("line1")
		end

	set_line2 (a_line2: INTEGER_32)
		do
			line2 := a_line2
			update_memory_field ("line2")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_do_ecmd_cmd (a_do_ecmd_cmd: CE_POINTER [NATURAL_8])
		do
			do_ecmd_cmd := a_do_ecmd_cmd
			update_memory_field ("do_ecmd_cmd")
		end

	set_do_ecmd_lnum (a_do_ecmd_lnum: INTEGER_32)
		do
			do_ecmd_lnum := a_do_ecmd_lnum
			update_memory_field ("do_ecmd_lnum")
		end

	set_append (a_append: INTEGER_32)
		do
			append := a_append
			update_memory_field ("append")
		end

	set_usefilter (a_usefilter: INTEGER_32)
		do
			usefilter := a_usefilter
			update_memory_field ("usefilter")
		end

	set_amount (a_amount: INTEGER_32)
		do
			amount := a_amount
			update_memory_field ("amount")
		end

	set_regname (a_regname: INTEGER_32)
		do
			regname := a_regname
			update_memory_field ("regname")
		end

	set_force_bin (a_force_bin: INTEGER_32)
		do
			force_bin := a_force_bin
			update_memory_field ("force_bin")
		end

	set_read_edit (a_read_edit: INTEGER_32)
		do
			read_edit := a_read_edit
			update_memory_field ("read_edit")
		end

	set_force_ff (a_force_ff: INTEGER_32)
		do
			force_ff := a_force_ff
			update_memory_field ("force_ff")
		end

	set_force_enc (a_force_enc: INTEGER_32)
		do
			force_enc := a_force_enc
			update_memory_field ("force_enc")
		end

	set_bad_char (a_bad_char: INTEGER_32)
		do
			bad_char := a_bad_char
			update_memory_field ("bad_char")
		end

	set_useridx (a_useridx: INTEGER_32)
		do
			useridx := a_useridx
			update_memory_field ("useridx")
		end

	set_errmsg (a_errmsg: CE_POINTER [NATURAL_8])
		do
			errmsg := a_errmsg
			update_memory_field ("errmsg")
		end

	set_getline (a_getline: CE_ROUTINE)
		do
			getline := a_getline
			update_memory_field ("getline")
		end

	set_cookie (a_cookie: CE_POINTER [ANY])
		do
			cookie := a_cookie
			update_memory_field ("cookie")
		end

	set_cstack (a_cstack: CE_POINTER [PD_CONDSTACK])
		do
			cstack := a_cstack
			update_memory_field ("cstack")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			arg := a_other.arg
			nextcmd := a_other.nextcmd
			cmd := a_other.cmd
			cmdlinep := a_other.cmdlinep
			cmdidx := a_other.cmdidx
			argt := a_other.argt
			skip := a_other.skip
			forceit := a_other.forceit
			addr_count := a_other.addr_count
			line1 := a_other.line1
			line2 := a_other.line2
			flags := a_other.flags
			do_ecmd_cmd := a_other.do_ecmd_cmd
			do_ecmd_lnum := a_other.do_ecmd_lnum
			append := a_other.append
			usefilter := a_other.usefilter
			amount := a_other.amount
			regname := a_other.regname
			force_bin := a_other.force_bin
			read_edit := a_other.read_edit
			force_ff := a_other.force_ff
			force_enc := a_other.force_enc
			bad_char := a_other.bad_char
			useridx := a_other.useridx
			errmsg := a_other.errmsg
			getline := a_other.getline
			cookie := a_other.cookie
			cstack := a_other.cstack
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				arg.is_equal (a_other.arg) and
				nextcmd.is_equal (a_other.nextcmd) and
				cmd.is_equal (a_other.cmd) and
				cmdlinep.is_equal (a_other.cmdlinep) and
				cmdidx = a_other.cmdidx and
				argt = a_other.argt and
				skip = a_other.skip and
				forceit = a_other.forceit and
				addr_count = a_other.addr_count and
				line1 = a_other.line1 and
				line2 = a_other.line2 and
				flags = a_other.flags and
				do_ecmd_cmd.is_equal (a_other.do_ecmd_cmd) and
				do_ecmd_lnum = a_other.do_ecmd_lnum and
				append = a_other.append and
				usefilter = a_other.usefilter and
				amount = a_other.amount and
				regname = a_other.regname and
				force_bin = a_other.force_bin and
				read_edit = a_other.read_edit and
				force_ff = a_other.force_ff and
				force_enc = a_other.force_enc and
				bad_char = a_other.bad_char and
				useridx = a_other.useridx and
				errmsg.is_equal (a_other.errmsg) and
				getline.is_equal (a_other.getline) and
				cookie.is_equal (a_other.cookie) and
				cstack.is_equal (a_other.cstack)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("arg"),
					create {CE_STRUCTURE_FIELD}.make ("nextcmd"),
					create {CE_STRUCTURE_FIELD}.make ("cmd"),
					create {CE_STRUCTURE_FIELD}.make ("cmdlinep"),
					create {CE_STRUCTURE_FIELD}.make ("cmdidx"),
					create {CE_STRUCTURE_FIELD}.make ("argt"),
					create {CE_STRUCTURE_FIELD}.make ("skip"),
					create {CE_STRUCTURE_FIELD}.make ("forceit"),
					create {CE_STRUCTURE_FIELD}.make ("addr_count"),
					create {CE_STRUCTURE_FIELD}.make ("line1"),
					create {CE_STRUCTURE_FIELD}.make ("line2"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("do_ecmd_cmd"),
					create {CE_STRUCTURE_FIELD}.make ("do_ecmd_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("append"),
					create {CE_STRUCTURE_FIELD}.make ("usefilter"),
					create {CE_STRUCTURE_FIELD}.make ("amount"),
					create {CE_STRUCTURE_FIELD}.make ("regname"),
					create {CE_STRUCTURE_FIELD}.make ("force_bin"),
					create {CE_STRUCTURE_FIELD}.make ("read_edit"),
					create {CE_STRUCTURE_FIELD}.make ("force_ff"),
					create {CE_STRUCTURE_FIELD}.make ("force_enc"),
					create {CE_STRUCTURE_FIELD}.make ("bad_char"),
					create {CE_STRUCTURE_FIELD}.make ("useridx"),
					create {CE_STRUCTURE_FIELD}.make ("errmsg"),
					create {CE_STRUCTURE_FIELD}.make ("getline"),
					create {CE_STRUCTURE_FIELD}.make ("cookie"),
					create {CE_STRUCTURE_FIELD}.make ("cstack")
				>>)
			init_structure_info
		end

end
