class
	PD_EXPAND

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create xp_pattern.make
			create xp_arg.make
			create xp_files.make
		end

feature {ANY} -- fields

	xp_context: INTEGER_32 assign set_xp_context

	xp_pattern: CE_POINTER [NATURAL_8] assign set_xp_pattern

	xp_pattern_len: INTEGER_32 assign set_xp_pattern_len

	xp_arg: CE_POINTER [NATURAL_8] assign set_xp_arg

	xp_scriptID: INTEGER_32 assign set_xp_scriptID

	xp_backslash: INTEGER_32 assign set_xp_backslash

	xp_shell: INTEGER_32 assign set_xp_shell

	xp_numfiles: INTEGER_32 assign set_xp_numfiles

	xp_files: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_xp_files

feature {ANY} -- setters

	set_xp_context (a_xp_context: INTEGER_32)
		do
			xp_context := a_xp_context
			update_memory_field ("xp_context")
		end

	set_xp_pattern (a_xp_pattern: CE_POINTER [NATURAL_8])
		do
			xp_pattern := a_xp_pattern
			update_memory_field ("xp_pattern")
		end

	set_xp_pattern_len (a_xp_pattern_len: INTEGER_32)
		do
			xp_pattern_len := a_xp_pattern_len
			update_memory_field ("xp_pattern_len")
		end

	set_xp_arg (a_xp_arg: CE_POINTER [NATURAL_8])
		do
			xp_arg := a_xp_arg
			update_memory_field ("xp_arg")
		end

	set_xp_scriptID (a_xp_scriptID: INTEGER_32)
		do
			xp_scriptID := a_xp_scriptID
			update_memory_field ("xp_scriptID")
		end

	set_xp_backslash (a_xp_backslash: INTEGER_32)
		do
			xp_backslash := a_xp_backslash
			update_memory_field ("xp_backslash")
		end

	set_xp_shell (a_xp_shell: INTEGER_32)
		do
			xp_shell := a_xp_shell
			update_memory_field ("xp_shell")
		end

	set_xp_numfiles (a_xp_numfiles: INTEGER_32)
		do
			xp_numfiles := a_xp_numfiles
			update_memory_field ("xp_numfiles")
		end

	set_xp_files (a_xp_files: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			xp_files := a_xp_files
			update_memory_field ("xp_files")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			xp_context := a_other.xp_context
			xp_pattern := a_other.xp_pattern
			xp_pattern_len := a_other.xp_pattern_len
			xp_arg := a_other.xp_arg
			xp_scriptID := a_other.xp_scriptID
			xp_backslash := a_other.xp_backslash
			xp_shell := a_other.xp_shell
			xp_numfiles := a_other.xp_numfiles
			xp_files := a_other.xp_files
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				xp_context = a_other.xp_context and
				xp_pattern.is_equal (a_other.xp_pattern) and
				xp_pattern_len = a_other.xp_pattern_len and
				xp_arg.is_equal (a_other.xp_arg) and
				xp_scriptID = a_other.xp_scriptID and
				xp_backslash = a_other.xp_backslash and
				xp_shell = a_other.xp_shell and
				xp_numfiles = a_other.xp_numfiles and
				xp_files.is_equal (a_other.xp_files)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("xp_context"),
					create {CE_STRUCTURE_FIELD}.make ("xp_pattern"),
					create {CE_STRUCTURE_FIELD}.make ("xp_pattern_len"),
					create {CE_STRUCTURE_FIELD}.make ("xp_arg"),
					create {CE_STRUCTURE_FIELD}.make ("xp_scriptID"),
					create {CE_STRUCTURE_FIELD}.make ("xp_backslash"),
					create {CE_STRUCTURE_FIELD}.make ("xp_shell"),
					create {CE_STRUCTURE_FIELD}.make ("xp_numfiles"),
					create {CE_STRUCTURE_FIELD}.make ("xp_files")
				>>)
			init_structure_info
		end

end
