class
	PD_FILEMARK

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create mark.make
		end

feature {ANY} -- fields

	mark: PD_POS_T assign set_mark

	fnum: INTEGER_32 assign set_fnum

feature {ANY} -- setters

	set_mark (a_mark: PD_POS_T)
		do
			mark := a_mark
			update_memory_field ("mark")
		end

	set_fnum (a_fnum: INTEGER_32)
		do
			fnum := a_fnum
			update_memory_field ("fnum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mark := a_other.mark.twin
			fnum := a_other.fnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mark.is_equal (a_other.mark) and
				fnum = a_other.fnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mark"),
					create {CE_STRUCTURE_FIELD}.make ("fnum")
				>>)
			init_structure_info
		end

end
