class
	PD_FLAG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	argtype: INTEGER_32 assign set_argtype

	flags: INTEGER_32 assign set_flags

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_argtype (a_argtype: INTEGER_32)
		do
			argtype := a_argtype
			update_memory_field ("argtype")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			argtype := a_other.argtype
			flags := a_other.flags
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				argtype = a_other.argtype and
				flags = a_other.flags
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("argtype"),
					create {CE_STRUCTURE_FIELD}.make ("flags")
				>>)
			init_structure_info
		end

end
