class
	PD_FLINE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create wp.make
		end

feature {ANY} -- fields

	wp: CE_POINTER [PD_WINDOW_S] assign set_wp

	lnum: INTEGER_32 assign set_lnum

	off: INTEGER_32 assign set_off

	lnum_save: INTEGER_32 assign set_lnum_save

	lvl: INTEGER_32 assign set_lvl

	lvl_next: INTEGER_32 assign set_lvl_next

	start: INTEGER_32 assign set_start

	end2: INTEGER_32 assign set_end2

	had_end: INTEGER_32 assign set_had_end

feature {ANY} -- setters

	set_wp (a_wp: CE_POINTER [PD_WINDOW_S])
		do
			wp := a_wp
			update_memory_field ("wp")
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_off (a_off: INTEGER_32)
		do
			off := a_off
			update_memory_field ("off")
		end

	set_lnum_save (a_lnum_save: INTEGER_32)
		do
			lnum_save := a_lnum_save
			update_memory_field ("lnum_save")
		end

	set_lvl (a_lvl: INTEGER_32)
		do
			lvl := a_lvl
			update_memory_field ("lvl")
		end

	set_lvl_next (a_lvl_next: INTEGER_32)
		do
			lvl_next := a_lvl_next
			update_memory_field ("lvl_next")
		end

	set_start (a_start: INTEGER_32)
		do
			start := a_start
			update_memory_field ("start")
		end

	set_end2 (a_end2: INTEGER_32)
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_had_end (a_had_end: INTEGER_32)
		do
			had_end := a_had_end
			update_memory_field ("had_end")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			wp := a_other.wp
			lnum := a_other.lnum
			off := a_other.off
			lnum_save := a_other.lnum_save
			lvl := a_other.lvl
			lvl_next := a_other.lvl_next
			start := a_other.start
			end2 := a_other.end2
			had_end := a_other.had_end
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				wp.is_equal (a_other.wp) and
				lnum = a_other.lnum and
				off = a_other.off and
				lnum_save = a_other.lnum_save and
				lvl = a_other.lvl and
				lvl_next = a_other.lvl_next and
				start = a_other.start and
				end2 = a_other.end2 and
				had_end = a_other.had_end
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("wp"),
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("off"),
					create {CE_STRUCTURE_FIELD}.make ("lnum_save"),
					create {CE_STRUCTURE_FIELD}.make ("lvl"),
					create {CE_STRUCTURE_FIELD}.make ("lvl_next"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("had_end")
				>>)
			init_structure_info
		end

end
