class
	PD_FOLD_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fd_nested.make
		end

feature {ANY} -- fields

	fd_top: INTEGER_32 assign set_fd_top

	fd_len: INTEGER_32 assign set_fd_len

	fd_nested: PD_GROWARRAY assign set_fd_nested

	fd_flags: INTEGER_8 assign set_fd_flags

	fd_small: INTEGER_8 assign set_fd_small

feature {ANY} -- setters

	set_fd_top (a_fd_top: INTEGER_32)
		do
			fd_top := a_fd_top
			update_memory_field ("fd_top")
		end

	set_fd_len (a_fd_len: INTEGER_32)
		do
			fd_len := a_fd_len
			update_memory_field ("fd_len")
		end

	set_fd_nested (a_fd_nested: PD_GROWARRAY)
		do
			fd_nested := a_fd_nested
			update_memory_field ("fd_nested")
		end

	set_fd_flags (a_fd_flags: INTEGER_8)
		do
			fd_flags := a_fd_flags
			update_memory_field ("fd_flags")
		end

	set_fd_small (a_fd_small: INTEGER_8)
		do
			fd_small := a_fd_small
			update_memory_field ("fd_small")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fd_top := a_other.fd_top
			fd_len := a_other.fd_len
			fd_nested := a_other.fd_nested.twin
			fd_flags := a_other.fd_flags
			fd_small := a_other.fd_small
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fd_top = a_other.fd_top and
				fd_len = a_other.fd_len and
				fd_nested.is_equal (a_other.fd_nested) and
				fd_flags = a_other.fd_flags and
				fd_small = a_other.fd_small
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fd_top"),
					create {CE_STRUCTURE_FIELD}.make ("fd_len"),
					create {CE_STRUCTURE_FIELD}.make ("fd_nested"),
					create {CE_STRUCTURE_FIELD}.make ("fd_flags"),
					create {CE_STRUCTURE_FIELD}.make ("fd_small")
				>>)
			init_structure_info
		end

end
