class
	PD_FST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create f_name.make
			create f_func.make
		end

feature {ANY} -- fields

	f_name: CE_POINTER [INTEGER_8] assign set_f_name

	f_min_argc: INTEGER_8 assign set_f_min_argc

	f_max_argc: INTEGER_8 assign set_f_max_argc

	f_func: CE_ROUTINE assign set_f_func

feature {ANY} -- setters

	set_f_name (a_f_name: CE_POINTER [INTEGER_8])
		do
			f_name := a_f_name
			update_memory_field ("f_name")
		end

	set_f_min_argc (a_f_min_argc: INTEGER_8)
		do
			f_min_argc := a_f_min_argc
			update_memory_field ("f_min_argc")
		end

	set_f_max_argc (a_f_max_argc: INTEGER_8)
		do
			f_max_argc := a_f_max_argc
			update_memory_field ("f_max_argc")
		end

	set_f_func (a_f_func: CE_ROUTINE)
		do
			f_func := a_f_func
			update_memory_field ("f_func")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f_name := a_other.f_name
			f_min_argc := a_other.f_min_argc
			f_max_argc := a_other.f_max_argc
			f_func := a_other.f_func
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f_name.is_equal (a_other.f_name) and
				f_min_argc = a_other.f_min_argc and
				f_max_argc = a_other.f_max_argc and
				f_func.is_equal (a_other.f_func)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f_name"),
					create {CE_STRUCTURE_FIELD}.make ("f_min_argc"),
					create {CE_STRUCTURE_FIELD}.make ("f_max_argc"),
					create {CE_STRUCTURE_FIELD}.make ("f_func")
				>>)
			init_structure_info
		end

end
