class
	PD_FUNCCALL_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create func.make
			create fixvar.make (<<12>>)
			create l_vars.make
			create l_vars_var.make
			create l_avars.make
			create l_avars_var.make
			create l_varlist.make
			create l_listitems.make (<<20>>)
			create rettv.make
			create caller.make
		end

feature {ANY} -- fields

	func: CE_POINTER [PD_UFUNC] assign set_func

	linenr: INTEGER_32 assign set_linenr

	returned: INTEGER_32 assign set_returned

	fixvar: CE_ARRAY [PD_FIXVAR]

	l_vars: PD_DICTVAR_S assign set_l_vars

	l_vars_var: PD_DICTITEM_S assign set_l_vars_var

	l_avars: PD_DICTVAR_S assign set_l_avars

	l_avars_var: PD_DICTITEM_S assign set_l_avars_var

	l_varlist: PD_LISTVAR_S assign set_l_varlist

	l_listitems: CE_ARRAY [PD_LISTITEM_S]

	rettv: CE_POINTER [PD_TYPVAL_T] assign set_rettv

	breakpoint: INTEGER_32 assign set_breakpoint

	dbg_tick: INTEGER_32 assign set_dbg_tick

	level: INTEGER_32 assign set_level

	caller: CE_POINTER [PD_FUNCCALL_S] assign set_caller

feature {ANY} -- setters

	set_func (a_func: CE_POINTER [PD_UFUNC])
		do
			func := a_func
			update_memory_field ("func")
		end

	set_linenr (a_linenr: INTEGER_32)
		do
			linenr := a_linenr
			update_memory_field ("linenr")
		end

	set_returned (a_returned: INTEGER_32)
		do
			returned := a_returned
			update_memory_field ("returned")
		end

	set_l_vars (a_l_vars: PD_DICTVAR_S)
		do
			l_vars := a_l_vars
			update_memory_field ("l_vars")
		end

	set_l_vars_var (a_l_vars_var: PD_DICTITEM_S)
		do
			l_vars_var := a_l_vars_var
			update_memory_field ("l_vars_var")
		end

	set_l_avars (a_l_avars: PD_DICTVAR_S)
		do
			l_avars := a_l_avars
			update_memory_field ("l_avars")
		end

	set_l_avars_var (a_l_avars_var: PD_DICTITEM_S)
		do
			l_avars_var := a_l_avars_var
			update_memory_field ("l_avars_var")
		end

	set_l_varlist (a_l_varlist: PD_LISTVAR_S)
		do
			l_varlist := a_l_varlist
			update_memory_field ("l_varlist")
		end

	set_rettv (a_rettv: CE_POINTER [PD_TYPVAL_T])
		do
			rettv := a_rettv
			update_memory_field ("rettv")
		end

	set_breakpoint (a_breakpoint: INTEGER_32)
		do
			breakpoint := a_breakpoint
			update_memory_field ("breakpoint")
		end

	set_dbg_tick (a_dbg_tick: INTEGER_32)
		do
			dbg_tick := a_dbg_tick
			update_memory_field ("dbg_tick")
		end

	set_level (a_level: INTEGER_32)
		do
			level := a_level
			update_memory_field ("level")
		end

	set_caller (a_caller: CE_POINTER [PD_FUNCCALL_S])
		do
			caller := a_caller
			update_memory_field ("caller")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			func := a_other.func
			linenr := a_other.linenr
			returned := a_other.returned
			fixvar := a_other.fixvar.twin
			l_vars := a_other.l_vars.twin
			l_vars_var := a_other.l_vars_var.twin
			l_avars := a_other.l_avars.twin
			l_avars_var := a_other.l_avars_var.twin
			l_varlist := a_other.l_varlist.twin
			l_listitems := a_other.l_listitems.twin
			rettv := a_other.rettv
			breakpoint := a_other.breakpoint
			dbg_tick := a_other.dbg_tick
			level := a_other.level
			caller := a_other.caller
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				func.is_equal (a_other.func) and
				linenr = a_other.linenr and
				returned = a_other.returned and
				fixvar.is_equal (a_other.fixvar) and
				l_vars.is_equal (a_other.l_vars) and
				l_vars_var.is_equal (a_other.l_vars_var) and
				l_avars.is_equal (a_other.l_avars) and
				l_avars_var.is_equal (a_other.l_avars_var) and
				l_varlist.is_equal (a_other.l_varlist) and
				l_listitems.is_equal (a_other.l_listitems) and
				rettv.is_equal (a_other.rettv) and
				breakpoint = a_other.breakpoint and
				dbg_tick = a_other.dbg_tick and
				level = a_other.level and
				caller.is_equal (a_other.caller)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("func"),
					create {CE_STRUCTURE_FIELD}.make ("linenr"),
					create {CE_STRUCTURE_FIELD}.make ("returned"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("fixvar", <<12>>),
					create {CE_STRUCTURE_FIELD}.make ("l_vars"),
					create {CE_STRUCTURE_FIELD}.make ("l_vars_var"),
					create {CE_STRUCTURE_FIELD}.make ("l_avars"),
					create {CE_STRUCTURE_FIELD}.make ("l_avars_var"),
					create {CE_STRUCTURE_FIELD}.make ("l_varlist"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("l_listitems", <<20>>),
					create {CE_STRUCTURE_FIELD}.make ("rettv"),
					create {CE_STRUCTURE_FIELD}.make ("breakpoint"),
					create {CE_STRUCTURE_FIELD}.make ("dbg_tick"),
					create {CE_STRUCTURE_FIELD}.make ("level"),
					create {CE_STRUCTURE_FIELD}.make ("caller")
				>>)
			init_structure_info
		end

end
