class
	PD_GROWARRAY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ga_data.make
		end

feature {ANY} -- fields

	ga_len: INTEGER_32 assign set_ga_len

	ga_maxlen: INTEGER_32 assign set_ga_maxlen

	ga_itemsize: INTEGER_32 assign set_ga_itemsize

	ga_growsize: INTEGER_32 assign set_ga_growsize

	ga_data: CE_POINTER [ANY] assign set_ga_data

feature {ANY} -- setters

	set_ga_len (a_ga_len: INTEGER_32)
		do
			ga_len := a_ga_len
			update_memory_field ("ga_len")
		end

	set_ga_maxlen (a_ga_maxlen: INTEGER_32)
		do
			ga_maxlen := a_ga_maxlen
			update_memory_field ("ga_maxlen")
		end

	set_ga_itemsize (a_ga_itemsize: INTEGER_32)
		do
			ga_itemsize := a_ga_itemsize
			update_memory_field ("ga_itemsize")
		end

	set_ga_growsize (a_ga_growsize: INTEGER_32)
		do
			ga_growsize := a_ga_growsize
			update_memory_field ("ga_growsize")
		end

	set_ga_data (a_ga_data: CE_POINTER [ANY])
		do
			ga_data := a_ga_data
			update_memory_field ("ga_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ga_len := a_other.ga_len
			ga_maxlen := a_other.ga_maxlen
			ga_itemsize := a_other.ga_itemsize
			ga_growsize := a_other.ga_growsize
			ga_data := a_other.ga_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ga_len = a_other.ga_len and
				ga_maxlen = a_other.ga_maxlen and
				ga_itemsize = a_other.ga_itemsize and
				ga_growsize = a_other.ga_growsize and
				ga_data.is_equal (a_other.ga_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ga_len"),
					create {CE_STRUCTURE_FIELD}.make ("ga_maxlen"),
					create {CE_STRUCTURE_FIELD}.make ("ga_itemsize"),
					create {CE_STRUCTURE_FIELD}.make ("ga_growsize"),
					create {CE_STRUCTURE_FIELD}.make ("ga_data")
				>>)
			init_structure_info
		end

end
