class
	PD_GUI2

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create font.make
		end

feature {ANY} -- fields

	fg_color: INTEGER_32 assign set_fg_color

	bg_color: INTEGER_32 assign set_bg_color

	sp_color: INTEGER_32 assign set_sp_color

	font: CE_POINTER [ANY] assign set_font

feature {ANY} -- setters

	set_fg_color (a_fg_color: INTEGER_32)
		do
			fg_color := a_fg_color
			update_memory_field ("fg_color")
		end

	set_bg_color (a_bg_color: INTEGER_32)
		do
			bg_color := a_bg_color
			update_memory_field ("bg_color")
		end

	set_sp_color (a_sp_color: INTEGER_32)
		do
			sp_color := a_sp_color
			update_memory_field ("sp_color")
		end

	set_font (a_font: CE_POINTER [ANY])
		do
			font := a_font
			update_memory_field ("font")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fg_color := a_other.fg_color
			bg_color := a_other.bg_color
			sp_color := a_other.sp_color
			font := a_other.font
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fg_color = a_other.fg_color and
				bg_color = a_other.bg_color and
				sp_color = a_other.sp_color and
				font.is_equal (a_other.font)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fg_color"),
					create {CE_STRUCTURE_FIELD}.make ("bg_color"),
					create {CE_STRUCTURE_FIELD}.make ("sp_color"),
					create {CE_STRUCTURE_FIELD}.make ("font")
				>>)
			init_structure_info
		end

end
