class
	PD_HASHTABLE_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ht_array.make
			create ht_smallarray.make (<<16>>)
		end

feature {ANY} -- fields

	ht_mask: NATURAL_32 assign set_ht_mask

	ht_used: NATURAL_32 assign set_ht_used

	ht_filled: NATURAL_32 assign set_ht_filled

	ht_locked: INTEGER_32 assign set_ht_locked

	ht_error: INTEGER_32 assign set_ht_error

	ht_array: CE_POINTER [PD_HASHITEM_S] assign set_ht_array

	ht_smallarray: CE_ARRAY [PD_HASHITEM_S]

feature {ANY} -- setters

	set_ht_mask (a_ht_mask: NATURAL_32)
		do
			ht_mask := a_ht_mask
			update_memory_field ("ht_mask")
		end

	set_ht_used (a_ht_used: NATURAL_32)
		do
			ht_used := a_ht_used
			update_memory_field ("ht_used")
		end

	set_ht_filled (a_ht_filled: NATURAL_32)
		do
			ht_filled := a_ht_filled
			update_memory_field ("ht_filled")
		end

	set_ht_locked (a_ht_locked: INTEGER_32)
		do
			ht_locked := a_ht_locked
			update_memory_field ("ht_locked")
		end

	set_ht_error (a_ht_error: INTEGER_32)
		do
			ht_error := a_ht_error
			update_memory_field ("ht_error")
		end

	set_ht_array (a_ht_array: CE_POINTER [PD_HASHITEM_S])
		do
			ht_array := a_ht_array
			update_memory_field ("ht_array")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ht_mask := a_other.ht_mask
			ht_used := a_other.ht_used
			ht_filled := a_other.ht_filled
			ht_locked := a_other.ht_locked
			ht_error := a_other.ht_error
			ht_array := a_other.ht_array
			ht_smallarray := a_other.ht_smallarray.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ht_mask = a_other.ht_mask and
				ht_used = a_other.ht_used and
				ht_filled = a_other.ht_filled and
				ht_locked = a_other.ht_locked and
				ht_error = a_other.ht_error and
				ht_array.is_equal (a_other.ht_array) and
				ht_smallarray.is_equal (a_other.ht_smallarray)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ht_mask"),
					create {CE_STRUCTURE_FIELD}.make ("ht_used"),
					create {CE_STRUCTURE_FIELD}.make ("ht_filled"),
					create {CE_STRUCTURE_FIELD}.make ("ht_locked"),
					create {CE_STRUCTURE_FIELD}.make ("ht_error"),
					create {CE_STRUCTURE_FIELD}.make ("ht_array"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ht_smallarray", <<16>>)
				>>)
			init_structure_info
		end

end
