class
	PD_INFO_POINTER

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	ip_bnum: INTEGER_32 assign set_ip_bnum

	ip_low: INTEGER_32 assign set_ip_low

	ip_high: INTEGER_32 assign set_ip_high

	ip_index: INTEGER_32 assign set_ip_index

feature {ANY} -- setters

	set_ip_bnum (a_ip_bnum: INTEGER_32)
		do
			ip_bnum := a_ip_bnum
			update_memory_field ("ip_bnum")
		end

	set_ip_low (a_ip_low: INTEGER_32)
		do
			ip_low := a_ip_low
			update_memory_field ("ip_low")
		end

	set_ip_high (a_ip_high: INTEGER_32)
		do
			ip_high := a_ip_high
			update_memory_field ("ip_high")
		end

	set_ip_index (a_ip_index: INTEGER_32)
		do
			ip_index := a_ip_index
			update_memory_field ("ip_index")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ip_bnum := a_other.ip_bnum
			ip_low := a_other.ip_low
			ip_high := a_other.ip_high
			ip_index := a_other.ip_index
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ip_bnum = a_other.ip_bnum and
				ip_low = a_other.ip_low and
				ip_high = a_other.ip_high and
				ip_index = a_other.ip_index
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ip_bnum"),
					create {CE_STRUCTURE_FIELD}.make ("ip_low"),
					create {CE_STRUCTURE_FIELD}.make ("ip_high"),
					create {CE_STRUCTURE_FIELD}.make ("ip_index")
				>>)
			init_structure_info
		end

end
