class
	PD_KEYQUEUE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create keystr.make
			create next.make
			create prev.make
		end

feature {ANY} -- fields

	keystr: CE_POINTER [NATURAL_8] assign set_keystr

	next: CE_POINTER [PD_KEYQUEUE] assign set_next

	prev: CE_POINTER [PD_KEYQUEUE] assign set_prev

feature {ANY} -- setters

	set_keystr (a_keystr: CE_POINTER [NATURAL_8])
		do
			keystr := a_keystr
			update_memory_field ("keystr")
		end

	set_next (a_next: CE_POINTER [PD_KEYQUEUE])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_KEYQUEUE])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			keystr := a_other.keystr
			next := a_other.next
			prev := a_other.prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				keystr.is_equal (a_other.keystr) and
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("keystr"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev")
				>>)
			init_structure_info
		end

end
