class
	PD_LISTWATCH_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create lw_item.make
			create lw_next.make
		end

feature {ANY} -- fields

	lw_item: CE_POINTER [PD_LISTITEM_S] assign set_lw_item

	lw_next: CE_POINTER [PD_LISTWATCH_S] assign set_lw_next

feature {ANY} -- setters

	set_lw_item (a_lw_item: CE_POINTER [PD_LISTITEM_S])
		do
			lw_item := a_lw_item
			update_memory_field ("lw_item")
		end

	set_lw_next (a_lw_next: CE_POINTER [PD_LISTWATCH_S])
		do
			lw_next := a_lw_next
			update_memory_field ("lw_next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lw_item := a_other.lw_item
			lw_next := a_other.lw_next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lw_item.is_equal (a_other.lw_item) and
				lw_next.is_equal (a_other.lw_next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lw_item"),
					create {CE_STRUCTURE_FIELD}.make ("lw_next")
				>>)
			init_structure_info
		end

end
