class
	PD_LVAL_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ll_name.make
			create ll_exp_name.make
			create ll_tv.make
			create ll_li.make
			create ll_list.make
			create ll_dict.make
			create ll_di.make
			create ll_newkey.make
		end

feature {ANY} -- fields

	ll_name: CE_POINTER [NATURAL_8] assign set_ll_name

	ll_exp_name: CE_POINTER [NATURAL_8] assign set_ll_exp_name

	ll_tv: CE_POINTER [PD_TYPVAL_T] assign set_ll_tv

	ll_li: CE_POINTER [PD_LISTITEM_S] assign set_ll_li

	ll_list: CE_POINTER [PD_LISTVAR_S] assign set_ll_list

	ll_range: INTEGER_32 assign set_ll_range

	ll_n1: INTEGER_32 assign set_ll_n1

	ll_n2: INTEGER_32 assign set_ll_n2

	ll_empty2: INTEGER_32 assign set_ll_empty2

	ll_dict: CE_POINTER [PD_DICTVAR_S] assign set_ll_dict

	ll_di: CE_POINTER [PD_DICTITEM_S] assign set_ll_di

	ll_newkey: CE_POINTER [NATURAL_8] assign set_ll_newkey

feature {ANY} -- setters

	set_ll_name (a_ll_name: CE_POINTER [NATURAL_8])
		do
			ll_name := a_ll_name
			update_memory_field ("ll_name")
		end

	set_ll_exp_name (a_ll_exp_name: CE_POINTER [NATURAL_8])
		do
			ll_exp_name := a_ll_exp_name
			update_memory_field ("ll_exp_name")
		end

	set_ll_tv (a_ll_tv: CE_POINTER [PD_TYPVAL_T])
		do
			ll_tv := a_ll_tv
			update_memory_field ("ll_tv")
		end

	set_ll_li (a_ll_li: CE_POINTER [PD_LISTITEM_S])
		do
			ll_li := a_ll_li
			update_memory_field ("ll_li")
		end

	set_ll_list (a_ll_list: CE_POINTER [PD_LISTVAR_S])
		do
			ll_list := a_ll_list
			update_memory_field ("ll_list")
		end

	set_ll_range (a_ll_range: INTEGER_32)
		do
			ll_range := a_ll_range
			update_memory_field ("ll_range")
		end

	set_ll_n1 (a_ll_n1: INTEGER_32)
		do
			ll_n1 := a_ll_n1
			update_memory_field ("ll_n1")
		end

	set_ll_n2 (a_ll_n2: INTEGER_32)
		do
			ll_n2 := a_ll_n2
			update_memory_field ("ll_n2")
		end

	set_ll_empty2 (a_ll_empty2: INTEGER_32)
		do
			ll_empty2 := a_ll_empty2
			update_memory_field ("ll_empty2")
		end

	set_ll_dict (a_ll_dict: CE_POINTER [PD_DICTVAR_S])
		do
			ll_dict := a_ll_dict
			update_memory_field ("ll_dict")
		end

	set_ll_di (a_ll_di: CE_POINTER [PD_DICTITEM_S])
		do
			ll_di := a_ll_di
			update_memory_field ("ll_di")
		end

	set_ll_newkey (a_ll_newkey: CE_POINTER [NATURAL_8])
		do
			ll_newkey := a_ll_newkey
			update_memory_field ("ll_newkey")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ll_name := a_other.ll_name
			ll_exp_name := a_other.ll_exp_name
			ll_tv := a_other.ll_tv
			ll_li := a_other.ll_li
			ll_list := a_other.ll_list
			ll_range := a_other.ll_range
			ll_n1 := a_other.ll_n1
			ll_n2 := a_other.ll_n2
			ll_empty2 := a_other.ll_empty2
			ll_dict := a_other.ll_dict
			ll_di := a_other.ll_di
			ll_newkey := a_other.ll_newkey
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ll_name.is_equal (a_other.ll_name) and
				ll_exp_name.is_equal (a_other.ll_exp_name) and
				ll_tv.is_equal (a_other.ll_tv) and
				ll_li.is_equal (a_other.ll_li) and
				ll_list.is_equal (a_other.ll_list) and
				ll_range = a_other.ll_range and
				ll_n1 = a_other.ll_n1 and
				ll_n2 = a_other.ll_n2 and
				ll_empty2 = a_other.ll_empty2 and
				ll_dict.is_equal (a_other.ll_dict) and
				ll_di.is_equal (a_other.ll_di) and
				ll_newkey.is_equal (a_other.ll_newkey)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ll_name"),
					create {CE_STRUCTURE_FIELD}.make ("ll_exp_name"),
					create {CE_STRUCTURE_FIELD}.make ("ll_tv"),
					create {CE_STRUCTURE_FIELD}.make ("ll_li"),
					create {CE_STRUCTURE_FIELD}.make ("ll_list"),
					create {CE_STRUCTURE_FIELD}.make ("ll_range"),
					create {CE_STRUCTURE_FIELD}.make ("ll_n1"),
					create {CE_STRUCTURE_FIELD}.make ("ll_n2"),
					create {CE_STRUCTURE_FIELD}.make ("ll_empty2"),
					create {CE_STRUCTURE_FIELD}.make ("ll_dict"),
					create {CE_STRUCTURE_FIELD}.make ("ll_di"),
					create {CE_STRUCTURE_FIELD}.make ("ll_newkey")
				>>)
			init_structure_info
		end

end
