class
	PD_MSG_HIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create msg.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_MSG_HIST] assign set_next

	msg: CE_POINTER [NATURAL_8] assign set_msg

	attr: INTEGER_32 assign set_attr

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_MSG_HIST])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_msg (a_msg: CE_POINTER [NATURAL_8])
		do
			msg := a_msg
			update_memory_field ("msg")
		end

	set_attr (a_attr: INTEGER_32)
		do
			attr := a_attr
			update_memory_field ("attr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			msg := a_other.msg
			attr := a_other.attr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				msg.is_equal (a_other.msg) and
				attr = a_other.attr
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("msg"),
					create {CE_STRUCTURE_FIELD}.make ("attr")
				>>)
			init_structure_info
		end

end
