class
	PD_NR_TRANS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create nt_next.make
			create nt_prev.make
		end

feature {ANY} -- fields

	nt_next: CE_POINTER [PD_NR_TRANS] assign set_nt_next

	nt_prev: CE_POINTER [PD_NR_TRANS] assign set_nt_prev

	nt_old_bnum: INTEGER_32 assign set_nt_old_bnum

	nt_new_bnum: INTEGER_32 assign set_nt_new_bnum

feature {ANY} -- setters

	set_nt_next (a_nt_next: CE_POINTER [PD_NR_TRANS])
		do
			nt_next := a_nt_next
			update_memory_field ("nt_next")
		end

	set_nt_prev (a_nt_prev: CE_POINTER [PD_NR_TRANS])
		do
			nt_prev := a_nt_prev
			update_memory_field ("nt_prev")
		end

	set_nt_old_bnum (a_nt_old_bnum: INTEGER_32)
		do
			nt_old_bnum := a_nt_old_bnum
			update_memory_field ("nt_old_bnum")
		end

	set_nt_new_bnum (a_nt_new_bnum: INTEGER_32)
		do
			nt_new_bnum := a_nt_new_bnum
			update_memory_field ("nt_new_bnum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			nt_next := a_other.nt_next
			nt_prev := a_other.nt_prev
			nt_old_bnum := a_other.nt_old_bnum
			nt_new_bnum := a_other.nt_new_bnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				nt_next.is_equal (a_other.nt_next) and
				nt_prev.is_equal (a_other.nt_prev) and
				nt_old_bnum = a_other.nt_old_bnum and
				nt_new_bnum = a_other.nt_new_bnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("nt_next"),
					create {CE_STRUCTURE_FIELD}.make ("nt_prev"),
					create {CE_STRUCTURE_FIELD}.make ("nt_old_bnum"),
					create {CE_STRUCTURE_FIELD}.make ("nt_new_bnum")
				>>)
			init_structure_info
		end

end
