class
	PD_OPARG_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create start.make
			create end2.make
			create cursor_start.make
		end

feature {ANY} -- fields

	op_type: INTEGER_32 assign set_op_type

	regname: INTEGER_32 assign set_regname

	motion_type: INTEGER_32 assign set_motion_type

	motion_force: INTEGER_32 assign set_motion_force

	use_reg_one: INTEGER_32 assign set_use_reg_one

	inclusive: INTEGER_32 assign set_inclusive

	end_adjusted: INTEGER_32 assign set_end_adjusted

	start: PD_POS_T assign set_start

	end2: PD_POS_T assign set_end2

	cursor_start: PD_POS_T assign set_cursor_start

	line_count: INTEGER_32 assign set_line_count

	empty: INTEGER_32 assign set_empty

	is_VIsual: INTEGER_32 assign set_is_VIsual

	block_mode: INTEGER_32 assign set_block_mode

	start_vcol: INTEGER_32 assign set_start_vcol

	end_vcol: INTEGER_32 assign set_end_vcol

	prev_opcount: INTEGER_32 assign set_prev_opcount

	prev_count0: INTEGER_32 assign set_prev_count0

feature {ANY} -- setters

	set_op_type (a_op_type: INTEGER_32)
		do
			op_type := a_op_type
			update_memory_field ("op_type")
		end

	set_regname (a_regname: INTEGER_32)
		do
			regname := a_regname
			update_memory_field ("regname")
		end

	set_motion_type (a_motion_type: INTEGER_32)
		do
			motion_type := a_motion_type
			update_memory_field ("motion_type")
		end

	set_motion_force (a_motion_force: INTEGER_32)
		do
			motion_force := a_motion_force
			update_memory_field ("motion_force")
		end

	set_use_reg_one (a_use_reg_one: INTEGER_32)
		do
			use_reg_one := a_use_reg_one
			update_memory_field ("use_reg_one")
		end

	set_inclusive (a_inclusive: INTEGER_32)
		do
			inclusive := a_inclusive
			update_memory_field ("inclusive")
		end

	set_end_adjusted (a_end_adjusted: INTEGER_32)
		do
			end_adjusted := a_end_adjusted
			update_memory_field ("end_adjusted")
		end

	set_start (a_start: PD_POS_T)
		do
			start := a_start
			update_memory_field ("start")
		end

	set_end2 (a_end2: PD_POS_T)
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_cursor_start (a_cursor_start: PD_POS_T)
		do
			cursor_start := a_cursor_start
			update_memory_field ("cursor_start")
		end

	set_line_count (a_line_count: INTEGER_32)
		do
			line_count := a_line_count
			update_memory_field ("line_count")
		end

	set_empty (a_empty: INTEGER_32)
		do
			empty := a_empty
			update_memory_field ("empty")
		end

	set_is_VIsual (a_is_VIsual: INTEGER_32)
		do
			is_VIsual := a_is_VIsual
			update_memory_field ("is_VIsual")
		end

	set_block_mode (a_block_mode: INTEGER_32)
		do
			block_mode := a_block_mode
			update_memory_field ("block_mode")
		end

	set_start_vcol (a_start_vcol: INTEGER_32)
		do
			start_vcol := a_start_vcol
			update_memory_field ("start_vcol")
		end

	set_end_vcol (a_end_vcol: INTEGER_32)
		do
			end_vcol := a_end_vcol
			update_memory_field ("end_vcol")
		end

	set_prev_opcount (a_prev_opcount: INTEGER_32)
		do
			prev_opcount := a_prev_opcount
			update_memory_field ("prev_opcount")
		end

	set_prev_count0 (a_prev_count0: INTEGER_32)
		do
			prev_count0 := a_prev_count0
			update_memory_field ("prev_count0")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			op_type := a_other.op_type
			regname := a_other.regname
			motion_type := a_other.motion_type
			motion_force := a_other.motion_force
			use_reg_one := a_other.use_reg_one
			inclusive := a_other.inclusive
			end_adjusted := a_other.end_adjusted
			start := a_other.start.twin
			end2 := a_other.end2.twin
			cursor_start := a_other.cursor_start.twin
			line_count := a_other.line_count
			empty := a_other.empty
			is_VIsual := a_other.is_VIsual
			block_mode := a_other.block_mode
			start_vcol := a_other.start_vcol
			end_vcol := a_other.end_vcol
			prev_opcount := a_other.prev_opcount
			prev_count0 := a_other.prev_count0
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				op_type = a_other.op_type and
				regname = a_other.regname and
				motion_type = a_other.motion_type and
				motion_force = a_other.motion_force and
				use_reg_one = a_other.use_reg_one and
				inclusive = a_other.inclusive and
				end_adjusted = a_other.end_adjusted and
				start.is_equal (a_other.start) and
				end2.is_equal (a_other.end2) and
				cursor_start.is_equal (a_other.cursor_start) and
				line_count = a_other.line_count and
				empty = a_other.empty and
				is_VIsual = a_other.is_VIsual and
				block_mode = a_other.block_mode and
				start_vcol = a_other.start_vcol and
				end_vcol = a_other.end_vcol and
				prev_opcount = a_other.prev_opcount and
				prev_count0 = a_other.prev_count0
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("op_type"),
					create {CE_STRUCTURE_FIELD}.make ("regname"),
					create {CE_STRUCTURE_FIELD}.make ("motion_type"),
					create {CE_STRUCTURE_FIELD}.make ("motion_force"),
					create {CE_STRUCTURE_FIELD}.make ("use_reg_one"),
					create {CE_STRUCTURE_FIELD}.make ("inclusive"),
					create {CE_STRUCTURE_FIELD}.make ("end_adjusted"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("cursor_start"),
					create {CE_STRUCTURE_FIELD}.make ("line_count"),
					create {CE_STRUCTURE_FIELD}.make ("empty"),
					create {CE_STRUCTURE_FIELD}.make ("is_VIsual"),
					create {CE_STRUCTURE_FIELD}.make ("block_mode"),
					create {CE_STRUCTURE_FIELD}.make ("start_vcol"),
					create {CE_STRUCTURE_FIELD}.make ("end_vcol"),
					create {CE_STRUCTURE_FIELD}.make ("prev_opcount"),
					create {CE_STRUCTURE_FIELD}.make ("prev_count0")
				>>)
			init_structure_info
		end

end
