class
	PD_OPTION_TABLE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create string.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	hasnum: INTEGER_32 assign set_hasnum

	number: INTEGER_32 assign set_number

	string: CE_POINTER [NATURAL_8] assign set_string

	strlen: INTEGER_32 assign set_strlen

	present: INTEGER_32 assign set_present

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_hasnum (a_hasnum: INTEGER_32)
		do
			hasnum := a_hasnum
			update_memory_field ("hasnum")
		end

	set_number (a_number: INTEGER_32)
		do
			number := a_number
			update_memory_field ("number")
		end

	set_string (a_string: CE_POINTER [NATURAL_8])
		do
			string := a_string
			update_memory_field ("string")
		end

	set_strlen (a_strlen: INTEGER_32)
		do
			strlen := a_strlen
			update_memory_field ("strlen")
		end

	set_present (a_present: INTEGER_32)
		do
			present := a_present
			update_memory_field ("present")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			hasnum := a_other.hasnum
			number := a_other.number
			string := a_other.string
			strlen := a_other.strlen
			present := a_other.present
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				hasnum = a_other.hasnum and
				number = a_other.number and
				string.is_equal (a_other.string) and
				strlen = a_other.strlen and
				present = a_other.present
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("hasnum"),
					create {CE_STRUCTURE_FIELD}.make ("number"),
					create {CE_STRUCTURE_FIELD}.make ("string"),
					create {CE_STRUCTURE_FIELD}.make ("strlen"),
					create {CE_STRUCTURE_FIELD}.make ("present")
				>>)
			init_structure_info
		end

end
