class
	PD_PAT_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pat.make
			create head.make
			create regmatch.make
		end

feature {ANY} -- fields

	pat: CE_POINTER [NATURAL_8] assign set_pat

	len: INTEGER_32 assign set_len

	head: CE_POINTER [NATURAL_8] assign set_head

	headlen: INTEGER_32 assign set_headlen

	regmatch: PD_REGMATCH_T assign set_regmatch

feature {ANY} -- setters

	set_pat (a_pat: CE_POINTER [NATURAL_8])
		do
			pat := a_pat
			update_memory_field ("pat")
		end

	set_len (a_len: INTEGER_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_head (a_head: CE_POINTER [NATURAL_8])
		do
			head := a_head
			update_memory_field ("head")
		end

	set_headlen (a_headlen: INTEGER_32)
		do
			headlen := a_headlen
			update_memory_field ("headlen")
		end

	set_regmatch (a_regmatch: PD_REGMATCH_T)
		do
			regmatch := a_regmatch
			update_memory_field ("regmatch")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pat := a_other.pat
			len := a_other.len
			head := a_other.head
			headlen := a_other.headlen
			regmatch := a_other.regmatch.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pat.is_equal (a_other.pat) and
				len = a_other.len and
				head.is_equal (a_other.head) and
				headlen = a_other.headlen and
				regmatch.is_equal (a_other.regmatch)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pat"),
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("head"),
					create {CE_STRUCTURE_FIELD}.make ("headlen"),
					create {CE_STRUCTURE_FIELD}.make ("regmatch")
				>>)
			init_structure_info
		end

end
