class
	PD_POS_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	lnum: INTEGER_32 assign set_lnum

	col: INTEGER_32 assign set_col

	coladd: INTEGER_32 assign set_coladd

feature {ANY} -- setters

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_col (a_col: INTEGER_32)
		do
			col := a_col
			update_memory_field ("col")
		end

	set_coladd (a_coladd: INTEGER_32)
		do
			coladd := a_coladd
			update_memory_field ("coladd")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lnum := a_other.lnum
			col := a_other.col
			coladd := a_other.coladd
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lnum = a_other.lnum and
				col = a_other.col and
				coladd = a_other.coladd
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("col"),
					create {CE_STRUCTURE_FIELD}.make ("coladd")
				>>)
			init_structure_info
		end

end
