class
	PD_PRT_PS_MBFONT_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create encodings.make
			create charsets.make
			create ascii_enc.make
			create defcs.make
		end

feature {ANY} -- fields

	num_encodings: INTEGER_32 assign set_num_encodings

	encodings: CE_POINTER [PD_PRT_PS_ENCODING_S] assign set_encodings

	num_charsets: INTEGER_32 assign set_num_charsets

	charsets: CE_POINTER [PD_PRT_PS_CHARSET_S] assign set_charsets

	ascii_enc: CE_POINTER [INTEGER_8] assign set_ascii_enc

	defcs: CE_POINTER [INTEGER_8] assign set_defcs

feature {ANY} -- setters

	set_num_encodings (a_num_encodings: INTEGER_32)
		do
			num_encodings := a_num_encodings
			update_memory_field ("num_encodings")
		end

	set_encodings (a_encodings: CE_POINTER [PD_PRT_PS_ENCODING_S])
		do
			encodings := a_encodings
			update_memory_field ("encodings")
		end

	set_num_charsets (a_num_charsets: INTEGER_32)
		do
			num_charsets := a_num_charsets
			update_memory_field ("num_charsets")
		end

	set_charsets (a_charsets: CE_POINTER [PD_PRT_PS_CHARSET_S])
		do
			charsets := a_charsets
			update_memory_field ("charsets")
		end

	set_ascii_enc (a_ascii_enc: CE_POINTER [INTEGER_8])
		do
			ascii_enc := a_ascii_enc
			update_memory_field ("ascii_enc")
		end

	set_defcs (a_defcs: CE_POINTER [INTEGER_8])
		do
			defcs := a_defcs
			update_memory_field ("defcs")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			num_encodings := a_other.num_encodings
			encodings := a_other.encodings
			num_charsets := a_other.num_charsets
			charsets := a_other.charsets
			ascii_enc := a_other.ascii_enc
			defcs := a_other.defcs
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				num_encodings = a_other.num_encodings and
				encodings.is_equal (a_other.encodings) and
				num_charsets = a_other.num_charsets and
				charsets.is_equal (a_other.charsets) and
				ascii_enc.is_equal (a_other.ascii_enc) and
				defcs.is_equal (a_other.defcs)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("num_encodings"),
					create {CE_STRUCTURE_FIELD}.make ("encodings"),
					create {CE_STRUCTURE_FIELD}.make ("num_charsets"),
					create {CE_STRUCTURE_FIELD}.make ("charsets"),
					create {CE_STRUCTURE_FIELD}.make ("ascii_enc"),
					create {CE_STRUCTURE_FIELD}.make ("defcs")
				>>)
			init_structure_info
		end

end
