class
	PD_PRT_PS_RESOURCE_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make (<<64>>)
			create filename.make (<<4_097>>)
			create title.make (<<256>>)
			create version.make (<<256>>)
		end

feature {ANY} -- fields

	name: CE_ARRAY [NATURAL_8]

	filename: CE_ARRAY [NATURAL_8]

	type: INTEGER_32 assign set_type

	title: CE_ARRAY [NATURAL_8]

	version: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name.twin
			filename := a_other.filename.twin
			type := a_other.type
			title := a_other.title.twin
			version := a_other.version.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				filename.is_equal (a_other.filename) and
				type = a_other.type and
				title.is_equal (a_other.title) and
				version.is_equal (a_other.version)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("name", <<64>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("filename", <<4_097>>),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("title", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("version", <<256>>)
				>>)
			init_structure_info
		end

end
