class
	PD_PRT_SETTINGS_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create number.make
			create jobname.make
			create outfile.make
			create arguments.make
		end

feature {ANY} -- fields

	n_collated_copies: INTEGER_32 assign set_n_collated_copies

	n_uncollated_copies: INTEGER_32 assign set_n_uncollated_copies

	duplex: INTEGER_32 assign set_duplex

	chars_per_line: INTEGER_32 assign set_chars_per_line

	lines_per_page: INTEGER_32 assign set_lines_per_page

	has_color: INTEGER_32 assign set_has_color

	number: PD_PRT_TEXT_ATTR_T assign set_number

	modec: INTEGER_32 assign set_modec

	do_syntax: INTEGER_32 assign set_do_syntax

	user_abort: INTEGER_32 assign set_user_abort

	jobname: CE_POINTER [NATURAL_8] assign set_jobname

	outfile: CE_POINTER [NATURAL_8] assign set_outfile

	arguments: CE_POINTER [NATURAL_8] assign set_arguments

feature {ANY} -- setters

	set_n_collated_copies (a_n_collated_copies: INTEGER_32)
		do
			n_collated_copies := a_n_collated_copies
			update_memory_field ("n_collated_copies")
		end

	set_n_uncollated_copies (a_n_uncollated_copies: INTEGER_32)
		do
			n_uncollated_copies := a_n_uncollated_copies
			update_memory_field ("n_uncollated_copies")
		end

	set_duplex (a_duplex: INTEGER_32)
		do
			duplex := a_duplex
			update_memory_field ("duplex")
		end

	set_chars_per_line (a_chars_per_line: INTEGER_32)
		do
			chars_per_line := a_chars_per_line
			update_memory_field ("chars_per_line")
		end

	set_lines_per_page (a_lines_per_page: INTEGER_32)
		do
			lines_per_page := a_lines_per_page
			update_memory_field ("lines_per_page")
		end

	set_has_color (a_has_color: INTEGER_32)
		do
			has_color := a_has_color
			update_memory_field ("has_color")
		end

	set_number (a_number: PD_PRT_TEXT_ATTR_T)
		do
			number := a_number
			update_memory_field ("number")
		end

	set_modec (a_modec: INTEGER_32)
		do
			modec := a_modec
			update_memory_field ("modec")
		end

	set_do_syntax (a_do_syntax: INTEGER_32)
		do
			do_syntax := a_do_syntax
			update_memory_field ("do_syntax")
		end

	set_user_abort (a_user_abort: INTEGER_32)
		do
			user_abort := a_user_abort
			update_memory_field ("user_abort")
		end

	set_jobname (a_jobname: CE_POINTER [NATURAL_8])
		do
			jobname := a_jobname
			update_memory_field ("jobname")
		end

	set_outfile (a_outfile: CE_POINTER [NATURAL_8])
		do
			outfile := a_outfile
			update_memory_field ("outfile")
		end

	set_arguments (a_arguments: CE_POINTER [NATURAL_8])
		do
			arguments := a_arguments
			update_memory_field ("arguments")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n_collated_copies := a_other.n_collated_copies
			n_uncollated_copies := a_other.n_uncollated_copies
			duplex := a_other.duplex
			chars_per_line := a_other.chars_per_line
			lines_per_page := a_other.lines_per_page
			has_color := a_other.has_color
			number := a_other.number.twin
			modec := a_other.modec
			do_syntax := a_other.do_syntax
			user_abort := a_other.user_abort
			jobname := a_other.jobname
			outfile := a_other.outfile
			arguments := a_other.arguments
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n_collated_copies = a_other.n_collated_copies and
				n_uncollated_copies = a_other.n_uncollated_copies and
				duplex = a_other.duplex and
				chars_per_line = a_other.chars_per_line and
				lines_per_page = a_other.lines_per_page and
				has_color = a_other.has_color and
				number.is_equal (a_other.number) and
				modec = a_other.modec and
				do_syntax = a_other.do_syntax and
				user_abort = a_other.user_abort and
				jobname.is_equal (a_other.jobname) and
				outfile.is_equal (a_other.outfile) and
				arguments.is_equal (a_other.arguments)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n_collated_copies"),
					create {CE_STRUCTURE_FIELD}.make ("n_uncollated_copies"),
					create {CE_STRUCTURE_FIELD}.make ("duplex"),
					create {CE_STRUCTURE_FIELD}.make ("chars_per_line"),
					create {CE_STRUCTURE_FIELD}.make ("lines_per_page"),
					create {CE_STRUCTURE_FIELD}.make ("has_color"),
					create {CE_STRUCTURE_FIELD}.make ("number"),
					create {CE_STRUCTURE_FIELD}.make ("modec"),
					create {CE_STRUCTURE_FIELD}.make ("do_syntax"),
					create {CE_STRUCTURE_FIELD}.make ("user_abort"),
					create {CE_STRUCTURE_FIELD}.make ("jobname"),
					create {CE_STRUCTURE_FIELD}.make ("outfile"),
					create {CE_STRUCTURE_FIELD}.make ("arguments")
				>>)
			init_structure_info
		end

end
