class
	PD_REGITEM_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create rs_scan.make
			create rs_un.make
		end

feature {ANY} -- fields

	rs_state: NATURAL_32 assign set_rs_state

	rs_scan: CE_POINTER [NATURAL_8] assign set_rs_scan

	rs_un: PD_RS_UN assign set_rs_un

	rs_no: INTEGER_16 assign set_rs_no

feature {ANY} -- setters

	set_rs_state (a_rs_state: NATURAL_32)
		do
			rs_state := a_rs_state
			update_memory_field ("rs_state")
		end

	set_rs_scan (a_rs_scan: CE_POINTER [NATURAL_8])
		do
			rs_scan := a_rs_scan
			update_memory_field ("rs_scan")
		end

	set_rs_un (a_rs_un: PD_RS_UN)
		do
			rs_un := a_rs_un
			update_memory_field ("rs_un")
		end

	set_rs_no (a_rs_no: INTEGER_16)
		do
			rs_no := a_rs_no
			update_memory_field ("rs_no")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			rs_state := a_other.rs_state
			rs_scan := a_other.rs_scan
			rs_un := a_other.rs_un.twin
			rs_no := a_other.rs_no
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				rs_state = a_other.rs_state and
				rs_scan.is_equal (a_other.rs_scan) and
				rs_un.is_equal (a_other.rs_un) and
				rs_no = a_other.rs_no
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("rs_state"),
					create {CE_STRUCTURE_FIELD}.make ("rs_scan"),
					create {CE_STRUCTURE_FIELD}.make ("rs_un"),
					create {CE_STRUCTURE_FIELD}.make ("rs_no")
				>>)
			init_structure_info
		end

end
