class
	PD_REGMMATCH_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create regprog.make
			create startpos.make (<<10>>)
			create endpos.make (<<10>>)
		end

feature {ANY} -- fields

	regprog: CE_POINTER [PD_REGPROG_T] assign set_regprog

	startpos: CE_ARRAY [PD_LPOS_T]

	endpos: CE_ARRAY [PD_LPOS_T]

	rmm_ic: INTEGER_32 assign set_rmm_ic

	rmm_maxcol: INTEGER_32 assign set_rmm_maxcol

feature {ANY} -- setters

	set_regprog (a_regprog: CE_POINTER [PD_REGPROG_T])
		do
			regprog := a_regprog
			update_memory_field ("regprog")
		end

	set_rmm_ic (a_rmm_ic: INTEGER_32)
		do
			rmm_ic := a_rmm_ic
			update_memory_field ("rmm_ic")
		end

	set_rmm_maxcol (a_rmm_maxcol: INTEGER_32)
		do
			rmm_maxcol := a_rmm_maxcol
			update_memory_field ("rmm_maxcol")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			regprog := a_other.regprog
			startpos := a_other.startpos.twin
			endpos := a_other.endpos.twin
			rmm_ic := a_other.rmm_ic
			rmm_maxcol := a_other.rmm_maxcol
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				regprog.is_equal (a_other.regprog) and
				startpos.is_equal (a_other.startpos) and
				endpos.is_equal (a_other.endpos) and
				rmm_ic = a_other.rmm_ic and
				rmm_maxcol = a_other.rmm_maxcol
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("regprog"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("startpos", <<10>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("endpos", <<10>>),
					create {CE_STRUCTURE_FIELD}.make ("rmm_ic"),
					create {CE_STRUCTURE_FIELD}.make ("rmm_maxcol")
				>>)
			init_structure_info
		end

end
