class
	PD_SALITEM_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sm_lead.make
			create sm_oneof.make
			create sm_rules.make
			create sm_to.make
			create sm_lead_w.make
			create sm_oneof_w.make
			create sm_to_w.make
		end

feature {ANY} -- fields

	sm_lead: CE_POINTER [NATURAL_8] assign set_sm_lead

	sm_leadlen: INTEGER_32 assign set_sm_leadlen

	sm_oneof: CE_POINTER [NATURAL_8] assign set_sm_oneof

	sm_rules: CE_POINTER [NATURAL_8] assign set_sm_rules

	sm_to: CE_POINTER [NATURAL_8] assign set_sm_to

	sm_lead_w: CE_POINTER [INTEGER_32] assign set_sm_lead_w

	sm_oneof_w: CE_POINTER [INTEGER_32] assign set_sm_oneof_w

	sm_to_w: CE_POINTER [INTEGER_32] assign set_sm_to_w

feature {ANY} -- setters

	set_sm_lead (a_sm_lead: CE_POINTER [NATURAL_8])
		do
			sm_lead := a_sm_lead
			update_memory_field ("sm_lead")
		end

	set_sm_leadlen (a_sm_leadlen: INTEGER_32)
		do
			sm_leadlen := a_sm_leadlen
			update_memory_field ("sm_leadlen")
		end

	set_sm_oneof (a_sm_oneof: CE_POINTER [NATURAL_8])
		do
			sm_oneof := a_sm_oneof
			update_memory_field ("sm_oneof")
		end

	set_sm_rules (a_sm_rules: CE_POINTER [NATURAL_8])
		do
			sm_rules := a_sm_rules
			update_memory_field ("sm_rules")
		end

	set_sm_to (a_sm_to: CE_POINTER [NATURAL_8])
		do
			sm_to := a_sm_to
			update_memory_field ("sm_to")
		end

	set_sm_lead_w (a_sm_lead_w: CE_POINTER [INTEGER_32])
		do
			sm_lead_w := a_sm_lead_w
			update_memory_field ("sm_lead_w")
		end

	set_sm_oneof_w (a_sm_oneof_w: CE_POINTER [INTEGER_32])
		do
			sm_oneof_w := a_sm_oneof_w
			update_memory_field ("sm_oneof_w")
		end

	set_sm_to_w (a_sm_to_w: CE_POINTER [INTEGER_32])
		do
			sm_to_w := a_sm_to_w
			update_memory_field ("sm_to_w")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sm_lead := a_other.sm_lead
			sm_leadlen := a_other.sm_leadlen
			sm_oneof := a_other.sm_oneof
			sm_rules := a_other.sm_rules
			sm_to := a_other.sm_to
			sm_lead_w := a_other.sm_lead_w
			sm_oneof_w := a_other.sm_oneof_w
			sm_to_w := a_other.sm_to_w
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sm_lead.is_equal (a_other.sm_lead) and
				sm_leadlen = a_other.sm_leadlen and
				sm_oneof.is_equal (a_other.sm_oneof) and
				sm_rules.is_equal (a_other.sm_rules) and
				sm_to.is_equal (a_other.sm_to) and
				sm_lead_w.is_equal (a_other.sm_lead_w) and
				sm_oneof_w.is_equal (a_other.sm_oneof_w) and
				sm_to_w.is_equal (a_other.sm_to_w)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sm_lead"),
					create {CE_STRUCTURE_FIELD}.make ("sm_leadlen"),
					create {CE_STRUCTURE_FIELD}.make ("sm_oneof"),
					create {CE_STRUCTURE_FIELD}.make ("sm_rules"),
					create {CE_STRUCTURE_FIELD}.make ("sm_to"),
					create {CE_STRUCTURE_FIELD}.make ("sm_lead_w"),
					create {CE_STRUCTURE_FIELD}.make ("sm_oneof_w"),
					create {CE_STRUCTURE_FIELD}.make ("sm_to_w")
				>>)
			init_structure_info
		end

end
