class
	PD_SBLOCK_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sb_next.make
			create sb_data.make (<<1>>)
		end

feature {ANY} -- fields

	sb_used: INTEGER_32 assign set_sb_used

	sb_next: CE_POINTER [PD_SBLOCK_S] assign set_sb_next

	sb_data: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_sb_used (a_sb_used: INTEGER_32)
		do
			sb_used := a_sb_used
			update_memory_field ("sb_used")
		end

	set_sb_next (a_sb_next: CE_POINTER [PD_SBLOCK_S])
		do
			sb_next := a_sb_next
			update_memory_field ("sb_next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sb_used := a_other.sb_used
			sb_next := a_other.sb_next
			sb_data := a_other.sb_data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sb_used = a_other.sb_used and
				sb_next.is_equal (a_other.sb_next) and
				sb_data.is_equal (a_other.sb_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sb_used"),
					create {CE_STRUCTURE_FIELD}.make ("sb_next"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sb_data", <<1>>)
				>>)
			init_structure_info
		end

end
