class
	PD_SHAREDFINDREPLACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create dialog.make
			create wword.make
			create mcase.make
			create up.make
			create down.make
			create what.make
			create with.make
			create find.make
			create replace.make
			create all2.make
		end

feature {ANY} -- fields

	dialog: CE_POINTER [SD_GTKWIDGET] assign set_dialog

	wword: CE_POINTER [SD_GTKWIDGET] assign set_wword

	mcase: CE_POINTER [SD_GTKWIDGET] assign set_mcase

	up: CE_POINTER [SD_GTKWIDGET] assign set_up

	down: CE_POINTER [SD_GTKWIDGET] assign set_down

	what: CE_POINTER [SD_GTKWIDGET] assign set_what

	with: CE_POINTER [SD_GTKWIDGET] assign set_with

	find: CE_POINTER [SD_GTKWIDGET] assign set_find

	replace: CE_POINTER [SD_GTKWIDGET] assign set_replace

	all2: CE_POINTER [SD_GTKWIDGET] assign set_all2

feature {ANY} -- setters

	set_dialog (a_dialog: CE_POINTER [SD_GTKWIDGET])
		do
			dialog := a_dialog
			update_memory_field ("dialog")
		end

	set_wword (a_wword: CE_POINTER [SD_GTKWIDGET])
		do
			wword := a_wword
			update_memory_field ("wword")
		end

	set_mcase (a_mcase: CE_POINTER [SD_GTKWIDGET])
		do
			mcase := a_mcase
			update_memory_field ("mcase")
		end

	set_up (a_up: CE_POINTER [SD_GTKWIDGET])
		do
			up := a_up
			update_memory_field ("up")
		end

	set_down (a_down: CE_POINTER [SD_GTKWIDGET])
		do
			down := a_down
			update_memory_field ("down")
		end

	set_what (a_what: CE_POINTER [SD_GTKWIDGET])
		do
			what := a_what
			update_memory_field ("what")
		end

	set_with (a_with: CE_POINTER [SD_GTKWIDGET])
		do
			with := a_with
			update_memory_field ("with")
		end

	set_find (a_find: CE_POINTER [SD_GTKWIDGET])
		do
			find := a_find
			update_memory_field ("find")
		end

	set_replace (a_replace: CE_POINTER [SD_GTKWIDGET])
		do
			replace := a_replace
			update_memory_field ("replace")
		end

	set_all2 (a_all2: CE_POINTER [SD_GTKWIDGET])
		do
			all2 := a_all2
			update_memory_field ("all2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dialog := a_other.dialog
			wword := a_other.wword
			mcase := a_other.mcase
			up := a_other.up
			down := a_other.down
			what := a_other.what
			with := a_other.with
			find := a_other.find
			replace := a_other.replace
			all2 := a_other.all2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dialog.is_equal (a_other.dialog) and
				wword.is_equal (a_other.wword) and
				mcase.is_equal (a_other.mcase) and
				up.is_equal (a_other.up) and
				down.is_equal (a_other.down) and
				what.is_equal (a_other.what) and
				with.is_equal (a_other.with) and
				find.is_equal (a_other.find) and
				replace.is_equal (a_other.replace) and
				all2.is_equal (a_other.all2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dialog"),
					create {CE_STRUCTURE_FIELD}.make ("wword"),
					create {CE_STRUCTURE_FIELD}.make ("mcase"),
					create {CE_STRUCTURE_FIELD}.make ("up"),
					create {CE_STRUCTURE_FIELD}.make ("down"),
					create {CE_STRUCTURE_FIELD}.make ("what"),
					create {CE_STRUCTURE_FIELD}.make ("with"),
					create {CE_STRUCTURE_FIELD}.make ("find"),
					create {CE_STRUCTURE_FIELD}.make ("replace"),
					create {CE_STRUCTURE_FIELD}.make ("all2")
				>>)
			init_structure_info
		end

end
