class
	PD_SORTI_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	lnum: INTEGER_32 assign set_lnum

	start_col_nr: INTEGER_32 assign set_start_col_nr

	end_col_nr: INTEGER_32 assign set_end_col_nr

feature {ANY} -- setters

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_start_col_nr (a_start_col_nr: INTEGER_32)
		do
			start_col_nr := a_start_col_nr
			update_memory_field ("start_col_nr")
		end

	set_end_col_nr (a_end_col_nr: INTEGER_32)
		do
			end_col_nr := a_end_col_nr
			update_memory_field ("end_col_nr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lnum := a_other.lnum
			start_col_nr := a_other.start_col_nr
			end_col_nr := a_other.end_col_nr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lnum = a_other.lnum and
				start_col_nr = a_other.start_col_nr and
				end_col_nr = a_other.end_col_nr
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("start_col_nr"),
					create {CE_STRUCTURE_FIELD}.make ("end_col_nr")
				>>)
			init_structure_info
		end

end
