class
	PD_STATE_ITEM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create si_m_endpos.make
			create si_h_startpos.make
			create si_h_endpos.make
			create si_eoe_pos.make
			create si_cont_list.make
			create si_next_list.make
			create si_extmatch.make
		end

feature {ANY} -- fields

	si_idx: INTEGER_32 assign set_si_idx

	si_id: INTEGER_32 assign set_si_id

	si_trans_id: INTEGER_32 assign set_si_trans_id

	si_m_lnum: INTEGER_32 assign set_si_m_lnum

	si_m_startcol: INTEGER_32 assign set_si_m_startcol

	si_m_endpos: PD_LPOS_T assign set_si_m_endpos

	si_h_startpos: PD_LPOS_T assign set_si_h_startpos

	si_h_endpos: PD_LPOS_T assign set_si_h_endpos

	si_eoe_pos: PD_LPOS_T assign set_si_eoe_pos

	si_end_idx: INTEGER_32 assign set_si_end_idx

	si_ends: INTEGER_32 assign set_si_ends

	si_attr: INTEGER_32 assign set_si_attr

	si_flags: INTEGER_32 assign set_si_flags

	si_cont_list: CE_POINTER [INTEGER_16] assign set_si_cont_list

	si_next_list: CE_POINTER [INTEGER_16] assign set_si_next_list

	si_extmatch: CE_POINTER [PD_REG_EXTMATCH_T] assign set_si_extmatch

feature {ANY} -- setters

	set_si_idx (a_si_idx: INTEGER_32)
		do
			si_idx := a_si_idx
			update_memory_field ("si_idx")
		end

	set_si_id (a_si_id: INTEGER_32)
		do
			si_id := a_si_id
			update_memory_field ("si_id")
		end

	set_si_trans_id (a_si_trans_id: INTEGER_32)
		do
			si_trans_id := a_si_trans_id
			update_memory_field ("si_trans_id")
		end

	set_si_m_lnum (a_si_m_lnum: INTEGER_32)
		do
			si_m_lnum := a_si_m_lnum
			update_memory_field ("si_m_lnum")
		end

	set_si_m_startcol (a_si_m_startcol: INTEGER_32)
		do
			si_m_startcol := a_si_m_startcol
			update_memory_field ("si_m_startcol")
		end

	set_si_m_endpos (a_si_m_endpos: PD_LPOS_T)
		do
			si_m_endpos := a_si_m_endpos
			update_memory_field ("si_m_endpos")
		end

	set_si_h_startpos (a_si_h_startpos: PD_LPOS_T)
		do
			si_h_startpos := a_si_h_startpos
			update_memory_field ("si_h_startpos")
		end

	set_si_h_endpos (a_si_h_endpos: PD_LPOS_T)
		do
			si_h_endpos := a_si_h_endpos
			update_memory_field ("si_h_endpos")
		end

	set_si_eoe_pos (a_si_eoe_pos: PD_LPOS_T)
		do
			si_eoe_pos := a_si_eoe_pos
			update_memory_field ("si_eoe_pos")
		end

	set_si_end_idx (a_si_end_idx: INTEGER_32)
		do
			si_end_idx := a_si_end_idx
			update_memory_field ("si_end_idx")
		end

	set_si_ends (a_si_ends: INTEGER_32)
		do
			si_ends := a_si_ends
			update_memory_field ("si_ends")
		end

	set_si_attr (a_si_attr: INTEGER_32)
		do
			si_attr := a_si_attr
			update_memory_field ("si_attr")
		end

	set_si_flags (a_si_flags: INTEGER_32)
		do
			si_flags := a_si_flags
			update_memory_field ("si_flags")
		end

	set_si_cont_list (a_si_cont_list: CE_POINTER [INTEGER_16])
		do
			si_cont_list := a_si_cont_list
			update_memory_field ("si_cont_list")
		end

	set_si_next_list (a_si_next_list: CE_POINTER [INTEGER_16])
		do
			si_next_list := a_si_next_list
			update_memory_field ("si_next_list")
		end

	set_si_extmatch (a_si_extmatch: CE_POINTER [PD_REG_EXTMATCH_T])
		do
			si_extmatch := a_si_extmatch
			update_memory_field ("si_extmatch")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			si_idx := a_other.si_idx
			si_id := a_other.si_id
			si_trans_id := a_other.si_trans_id
			si_m_lnum := a_other.si_m_lnum
			si_m_startcol := a_other.si_m_startcol
			si_m_endpos := a_other.si_m_endpos.twin
			si_h_startpos := a_other.si_h_startpos.twin
			si_h_endpos := a_other.si_h_endpos.twin
			si_eoe_pos := a_other.si_eoe_pos.twin
			si_end_idx := a_other.si_end_idx
			si_ends := a_other.si_ends
			si_attr := a_other.si_attr
			si_flags := a_other.si_flags
			si_cont_list := a_other.si_cont_list
			si_next_list := a_other.si_next_list
			si_extmatch := a_other.si_extmatch
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				si_idx = a_other.si_idx and
				si_id = a_other.si_id and
				si_trans_id = a_other.si_trans_id and
				si_m_lnum = a_other.si_m_lnum and
				si_m_startcol = a_other.si_m_startcol and
				si_m_endpos.is_equal (a_other.si_m_endpos) and
				si_h_startpos.is_equal (a_other.si_h_startpos) and
				si_h_endpos.is_equal (a_other.si_h_endpos) and
				si_eoe_pos.is_equal (a_other.si_eoe_pos) and
				si_end_idx = a_other.si_end_idx and
				si_ends = a_other.si_ends and
				si_attr = a_other.si_attr and
				si_flags = a_other.si_flags and
				si_cont_list.is_equal (a_other.si_cont_list) and
				si_next_list.is_equal (a_other.si_next_list) and
				si_extmatch.is_equal (a_other.si_extmatch)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("si_idx"),
					create {CE_STRUCTURE_FIELD}.make ("si_id"),
					create {CE_STRUCTURE_FIELD}.make ("si_trans_id"),
					create {CE_STRUCTURE_FIELD}.make ("si_m_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("si_m_startcol"),
					create {CE_STRUCTURE_FIELD}.make ("si_m_endpos"),
					create {CE_STRUCTURE_FIELD}.make ("si_h_startpos"),
					create {CE_STRUCTURE_FIELD}.make ("si_h_endpos"),
					create {CE_STRUCTURE_FIELD}.make ("si_eoe_pos"),
					create {CE_STRUCTURE_FIELD}.make ("si_end_idx"),
					create {CE_STRUCTURE_FIELD}.make ("si_ends"),
					create {CE_STRUCTURE_FIELD}.make ("si_attr"),
					create {CE_STRUCTURE_FIELD}.make ("si_flags"),
					create {CE_STRUCTURE_FIELD}.make ("si_cont_list"),
					create {CE_STRUCTURE_FIELD}.make ("si_next_list"),
					create {CE_STRUCTURE_FIELD}.make ("si_extmatch")
				>>)
			init_structure_info
		end

end
