class
	PD_STRUCT_BF_TEST_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create password.make (<<64>>)
			create salt.make (<<9>>)
			create plaintxt.make (<<9>>)
			create cryptxt.make (<<9>>)
			create badcryptxt.make (<<9>>)
		end

feature {ANY} -- fields

	password: CE_ARRAY [NATURAL_8]

	salt: CE_ARRAY [NATURAL_8]

	plaintxt: CE_ARRAY [NATURAL_8]

	cryptxt: CE_ARRAY [NATURAL_8]

	badcryptxt: CE_ARRAY [NATURAL_8]

	keysum: NATURAL_32 assign set_keysum

feature {ANY} -- setters

	set_keysum (a_keysum: NATURAL_32)
		do
			keysum := a_keysum
			update_memory_field ("keysum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			password := a_other.password.twin
			salt := a_other.salt.twin
			plaintxt := a_other.plaintxt.twin
			cryptxt := a_other.cryptxt.twin
			badcryptxt := a_other.badcryptxt.twin
			keysum := a_other.keysum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				password.is_equal (a_other.password) and
				salt.is_equal (a_other.salt) and
				plaintxt.is_equal (a_other.plaintxt) and
				cryptxt.is_equal (a_other.cryptxt) and
				badcryptxt.is_equal (a_other.badcryptxt) and
				keysum = a_other.keysum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("password", <<64>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("salt", <<9>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("plaintxt", <<9>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cryptxt", <<9>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("badcryptxt", <<9>>),
					create {CE_STRUCTURE_FIELD}.make ("keysum")
				>>)
			init_structure_info
		end

end
