class
	PD_SUBCOMMAND

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create func.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	func: CE_ROUTINE assign set_func

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_func (a_func: CE_ROUTINE)
		do
			func := a_func
			update_memory_field ("func")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			func := a_other.func
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				func.is_equal (a_other.func)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("func")
				>>)
			init_structure_info
		end

end
