class
	PD_SYN_CLUSTER_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create scl_name.make
			create scl_name_u.make
			create scl_list.make
		end

feature {ANY} -- fields

	scl_name: CE_POINTER [NATURAL_8] assign set_scl_name

	scl_name_u: CE_POINTER [NATURAL_8] assign set_scl_name_u

	scl_list: CE_POINTER [INTEGER_16] assign set_scl_list

feature {ANY} -- setters

	set_scl_name (a_scl_name: CE_POINTER [NATURAL_8])
		do
			scl_name := a_scl_name
			update_memory_field ("scl_name")
		end

	set_scl_name_u (a_scl_name_u: CE_POINTER [NATURAL_8])
		do
			scl_name_u := a_scl_name_u
			update_memory_field ("scl_name_u")
		end

	set_scl_list (a_scl_list: CE_POINTER [INTEGER_16])
		do
			scl_list := a_scl_list
			update_memory_field ("scl_list")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			scl_name := a_other.scl_name
			scl_name_u := a_other.scl_name_u
			scl_list := a_other.scl_list
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				scl_name.is_equal (a_other.scl_name) and
				scl_name_u.is_equal (a_other.scl_name_u) and
				scl_list.is_equal (a_other.scl_list)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("scl_name"),
					create {CE_STRUCTURE_FIELD}.make ("scl_name_u"),
					create {CE_STRUCTURE_FIELD}.make ("scl_list")
				>>)
			init_structure_info
		end

end
