class
	PD_SYN_PATTERN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sp_syn.make
			create sp_pattern.make
			create sp_prog.make
			create sp_offsets.make (<<7>>)
			create sp_cont_list.make
			create sp_next_list.make
		end

feature {ANY} -- fields

	sp_type: INTEGER_8 assign set_sp_type

	sp_syncing: INTEGER_8 assign set_sp_syncing

	sp_flags: INTEGER_32 assign set_sp_flags

	sp_syn: PD_SP_SYN assign set_sp_syn

	sp_syn_match_id: INTEGER_16 assign set_sp_syn_match_id

	sp_pattern: CE_POINTER [NATURAL_8] assign set_sp_pattern

	sp_prog: CE_POINTER [PD_REGPROG_T] assign set_sp_prog

	sp_ic: INTEGER_32 assign set_sp_ic

	sp_off_flags: INTEGER_16 assign set_sp_off_flags

	sp_offsets: CE_ARRAY [INTEGER_32]

	sp_cont_list: CE_POINTER [INTEGER_16] assign set_sp_cont_list

	sp_next_list: CE_POINTER [INTEGER_16] assign set_sp_next_list

	sp_sync_idx: INTEGER_32 assign set_sp_sync_idx

	sp_line_id: INTEGER_32 assign set_sp_line_id

	sp_startcol: INTEGER_32 assign set_sp_startcol

feature {ANY} -- setters

	set_sp_type (a_sp_type: INTEGER_8)
		do
			sp_type := a_sp_type
			update_memory_field ("sp_type")
		end

	set_sp_syncing (a_sp_syncing: INTEGER_8)
		do
			sp_syncing := a_sp_syncing
			update_memory_field ("sp_syncing")
		end

	set_sp_flags (a_sp_flags: INTEGER_32)
		do
			sp_flags := a_sp_flags
			update_memory_field ("sp_flags")
		end

	set_sp_syn (a_sp_syn: PD_SP_SYN)
		do
			sp_syn := a_sp_syn
			update_memory_field ("sp_syn")
		end

	set_sp_syn_match_id (a_sp_syn_match_id: INTEGER_16)
		do
			sp_syn_match_id := a_sp_syn_match_id
			update_memory_field ("sp_syn_match_id")
		end

	set_sp_pattern (a_sp_pattern: CE_POINTER [NATURAL_8])
		do
			sp_pattern := a_sp_pattern
			update_memory_field ("sp_pattern")
		end

	set_sp_prog (a_sp_prog: CE_POINTER [PD_REGPROG_T])
		do
			sp_prog := a_sp_prog
			update_memory_field ("sp_prog")
		end

	set_sp_ic (a_sp_ic: INTEGER_32)
		do
			sp_ic := a_sp_ic
			update_memory_field ("sp_ic")
		end

	set_sp_off_flags (a_sp_off_flags: INTEGER_16)
		do
			sp_off_flags := a_sp_off_flags
			update_memory_field ("sp_off_flags")
		end

	set_sp_cont_list (a_sp_cont_list: CE_POINTER [INTEGER_16])
		do
			sp_cont_list := a_sp_cont_list
			update_memory_field ("sp_cont_list")
		end

	set_sp_next_list (a_sp_next_list: CE_POINTER [INTEGER_16])
		do
			sp_next_list := a_sp_next_list
			update_memory_field ("sp_next_list")
		end

	set_sp_sync_idx (a_sp_sync_idx: INTEGER_32)
		do
			sp_sync_idx := a_sp_sync_idx
			update_memory_field ("sp_sync_idx")
		end

	set_sp_line_id (a_sp_line_id: INTEGER_32)
		do
			sp_line_id := a_sp_line_id
			update_memory_field ("sp_line_id")
		end

	set_sp_startcol (a_sp_startcol: INTEGER_32)
		do
			sp_startcol := a_sp_startcol
			update_memory_field ("sp_startcol")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sp_type := a_other.sp_type
			sp_syncing := a_other.sp_syncing
			sp_flags := a_other.sp_flags
			sp_syn := a_other.sp_syn.twin
			sp_syn_match_id := a_other.sp_syn_match_id
			sp_pattern := a_other.sp_pattern
			sp_prog := a_other.sp_prog
			sp_ic := a_other.sp_ic
			sp_off_flags := a_other.sp_off_flags
			sp_offsets := a_other.sp_offsets.twin
			sp_cont_list := a_other.sp_cont_list
			sp_next_list := a_other.sp_next_list
			sp_sync_idx := a_other.sp_sync_idx
			sp_line_id := a_other.sp_line_id
			sp_startcol := a_other.sp_startcol
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sp_type = a_other.sp_type and
				sp_syncing = a_other.sp_syncing and
				sp_flags = a_other.sp_flags and
				sp_syn.is_equal (a_other.sp_syn) and
				sp_syn_match_id = a_other.sp_syn_match_id and
				sp_pattern.is_equal (a_other.sp_pattern) and
				sp_prog.is_equal (a_other.sp_prog) and
				sp_ic = a_other.sp_ic and
				sp_off_flags = a_other.sp_off_flags and
				sp_offsets.is_equal (a_other.sp_offsets) and
				sp_cont_list.is_equal (a_other.sp_cont_list) and
				sp_next_list.is_equal (a_other.sp_next_list) and
				sp_sync_idx = a_other.sp_sync_idx and
				sp_line_id = a_other.sp_line_id and
				sp_startcol = a_other.sp_startcol
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sp_type"),
					create {CE_STRUCTURE_FIELD}.make ("sp_syncing"),
					create {CE_STRUCTURE_FIELD}.make ("sp_flags"),
					create {CE_STRUCTURE_FIELD}.make ("sp_syn"),
					create {CE_STRUCTURE_FIELD}.make ("sp_syn_match_id"),
					create {CE_STRUCTURE_FIELD}.make ("sp_pattern"),
					create {CE_STRUCTURE_FIELD}.make ("sp_prog"),
					create {CE_STRUCTURE_FIELD}.make ("sp_ic"),
					create {CE_STRUCTURE_FIELD}.make ("sp_off_flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sp_offsets", <<7>>),
					create {CE_STRUCTURE_FIELD}.make ("sp_cont_list"),
					create {CE_STRUCTURE_FIELD}.make ("sp_next_list"),
					create {CE_STRUCTURE_FIELD}.make ("sp_sync_idx"),
					create {CE_STRUCTURE_FIELD}.make ("sp_line_id"),
					create {CE_STRUCTURE_FIELD}.make ("sp_startcol")
				>>)
			init_structure_info
		end

end
