class
	PD_SYN_STATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sst_next.make
			create sst_union.make
			create sst_next_list.make
		end

feature {ANY} -- fields

	sst_next: CE_POINTER [PD_SYN_STATE] assign set_sst_next

	sst_lnum: INTEGER_32 assign set_sst_lnum

	sst_union: PD_SST_UNION assign set_sst_union

	sst_next_flags: INTEGER_32 assign set_sst_next_flags

	sst_stacksize: INTEGER_32 assign set_sst_stacksize

	sst_next_list: CE_POINTER [INTEGER_16] assign set_sst_next_list

	sst_tick: NATURAL_16 assign set_sst_tick

	sst_change_lnum: INTEGER_32 assign set_sst_change_lnum

feature {ANY} -- setters

	set_sst_next (a_sst_next: CE_POINTER [PD_SYN_STATE])
		do
			sst_next := a_sst_next
			update_memory_field ("sst_next")
		end

	set_sst_lnum (a_sst_lnum: INTEGER_32)
		do
			sst_lnum := a_sst_lnum
			update_memory_field ("sst_lnum")
		end

	set_sst_union (a_sst_union: PD_SST_UNION)
		do
			sst_union := a_sst_union
			update_memory_field ("sst_union")
		end

	set_sst_next_flags (a_sst_next_flags: INTEGER_32)
		do
			sst_next_flags := a_sst_next_flags
			update_memory_field ("sst_next_flags")
		end

	set_sst_stacksize (a_sst_stacksize: INTEGER_32)
		do
			sst_stacksize := a_sst_stacksize
			update_memory_field ("sst_stacksize")
		end

	set_sst_next_list (a_sst_next_list: CE_POINTER [INTEGER_16])
		do
			sst_next_list := a_sst_next_list
			update_memory_field ("sst_next_list")
		end

	set_sst_tick (a_sst_tick: NATURAL_16)
		do
			sst_tick := a_sst_tick
			update_memory_field ("sst_tick")
		end

	set_sst_change_lnum (a_sst_change_lnum: INTEGER_32)
		do
			sst_change_lnum := a_sst_change_lnum
			update_memory_field ("sst_change_lnum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sst_next := a_other.sst_next
			sst_lnum := a_other.sst_lnum
			sst_union := a_other.sst_union.twin
			sst_next_flags := a_other.sst_next_flags
			sst_stacksize := a_other.sst_stacksize
			sst_next_list := a_other.sst_next_list
			sst_tick := a_other.sst_tick
			sst_change_lnum := a_other.sst_change_lnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sst_next.is_equal (a_other.sst_next) and
				sst_lnum = a_other.sst_lnum and
				sst_union.is_equal (a_other.sst_union) and
				sst_next_flags = a_other.sst_next_flags and
				sst_stacksize = a_other.sst_stacksize and
				sst_next_list.is_equal (a_other.sst_next_list) and
				sst_tick = a_other.sst_tick and
				sst_change_lnum = a_other.sst_change_lnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sst_next"),
					create {CE_STRUCTURE_FIELD}.make ("sst_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("sst_union"),
					create {CE_STRUCTURE_FIELD}.make ("sst_next_flags"),
					create {CE_STRUCTURE_FIELD}.make ("sst_stacksize"),
					create {CE_STRUCTURE_FIELD}.make ("sst_next_list"),
					create {CE_STRUCTURE_FIELD}.make ("sst_tick"),
					create {CE_STRUCTURE_FIELD}.make ("sst_change_lnum")
				>>)
			init_structure_info
		end

end
