class
	PD_SYNBLOCK_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create b_keywtab.make
			create b_keywtab_ic.make
			create b_syn_patterns.make
			create b_syn_clusters.make
			create b_syn_linecont_pat.make
			create b_syn_linecont_prog.make
			create b_sst_array.make
			create b_sst_first.make
			create b_sst_firstfree.make
			create b_langp.make
			create b_spell_ismw.make (<<256>>)
			create b_spell_ismw_mb.make
			create b_p_spc.make
			create b_cap_prog.make
			create b_p_spf.make
			create b_p_spl.make
		end

feature {ANY} -- fields

	b_keywtab: PD_HASHTABLE_S assign set_b_keywtab

	b_keywtab_ic: PD_HASHTABLE_S assign set_b_keywtab_ic

	b_syn_error: INTEGER_32 assign set_b_syn_error

	b_syn_ic: INTEGER_32 assign set_b_syn_ic

	b_syn_spell: INTEGER_32 assign set_b_syn_spell

	b_syn_patterns: PD_GROWARRAY assign set_b_syn_patterns

	b_syn_clusters: PD_GROWARRAY assign set_b_syn_clusters

	b_spell_cluster_id: INTEGER_32 assign set_b_spell_cluster_id

	b_nospell_cluster_id: INTEGER_32 assign set_b_nospell_cluster_id

	b_syn_containedin: INTEGER_32 assign set_b_syn_containedin

	b_syn_sync_flags: INTEGER_32 assign set_b_syn_sync_flags

	b_syn_sync_id: INTEGER_16 assign set_b_syn_sync_id

	b_syn_sync_minlines: INTEGER_32 assign set_b_syn_sync_minlines

	b_syn_sync_maxlines: INTEGER_32 assign set_b_syn_sync_maxlines

	b_syn_sync_linebreaks: INTEGER_32 assign set_b_syn_sync_linebreaks

	b_syn_linecont_pat: CE_POINTER [NATURAL_8] assign set_b_syn_linecont_pat

	b_syn_linecont_prog: CE_POINTER [PD_REGPROG_T] assign set_b_syn_linecont_prog

	b_syn_linecont_ic: INTEGER_32 assign set_b_syn_linecont_ic

	b_syn_topgrp: INTEGER_32 assign set_b_syn_topgrp

	b_syn_folditems: INTEGER_32 assign set_b_syn_folditems

	b_sst_array: CE_POINTER [PD_SYN_STATE] assign set_b_sst_array

	b_sst_len: INTEGER_32 assign set_b_sst_len

	b_sst_first: CE_POINTER [PD_SYN_STATE] assign set_b_sst_first

	b_sst_firstfree: CE_POINTER [PD_SYN_STATE] assign set_b_sst_firstfree

	b_sst_freecount: INTEGER_32 assign set_b_sst_freecount

	b_sst_check_lnum: INTEGER_32 assign set_b_sst_check_lnum

	b_sst_lasttick: NATURAL_16 assign set_b_sst_lasttick

	b_langp: PD_GROWARRAY assign set_b_langp

	b_spell_ismw: CE_ARRAY [NATURAL_8]

	b_spell_ismw_mb: CE_POINTER [NATURAL_8] assign set_b_spell_ismw_mb

	b_p_spc: CE_POINTER [NATURAL_8] assign set_b_p_spc

	b_cap_prog: CE_POINTER [PD_REGPROG_T] assign set_b_cap_prog

	b_p_spf: CE_POINTER [NATURAL_8] assign set_b_p_spf

	b_p_spl: CE_POINTER [NATURAL_8] assign set_b_p_spl

feature {ANY} -- setters

	set_b_keywtab (a_b_keywtab: PD_HASHTABLE_S)
		do
			b_keywtab := a_b_keywtab
			update_memory_field ("b_keywtab")
		end

	set_b_keywtab_ic (a_b_keywtab_ic: PD_HASHTABLE_S)
		do
			b_keywtab_ic := a_b_keywtab_ic
			update_memory_field ("b_keywtab_ic")
		end

	set_b_syn_error (a_b_syn_error: INTEGER_32)
		do
			b_syn_error := a_b_syn_error
			update_memory_field ("b_syn_error")
		end

	set_b_syn_ic (a_b_syn_ic: INTEGER_32)
		do
			b_syn_ic := a_b_syn_ic
			update_memory_field ("b_syn_ic")
		end

	set_b_syn_spell (a_b_syn_spell: INTEGER_32)
		do
			b_syn_spell := a_b_syn_spell
			update_memory_field ("b_syn_spell")
		end

	set_b_syn_patterns (a_b_syn_patterns: PD_GROWARRAY)
		do
			b_syn_patterns := a_b_syn_patterns
			update_memory_field ("b_syn_patterns")
		end

	set_b_syn_clusters (a_b_syn_clusters: PD_GROWARRAY)
		do
			b_syn_clusters := a_b_syn_clusters
			update_memory_field ("b_syn_clusters")
		end

	set_b_spell_cluster_id (a_b_spell_cluster_id: INTEGER_32)
		do
			b_spell_cluster_id := a_b_spell_cluster_id
			update_memory_field ("b_spell_cluster_id")
		end

	set_b_nospell_cluster_id (a_b_nospell_cluster_id: INTEGER_32)
		do
			b_nospell_cluster_id := a_b_nospell_cluster_id
			update_memory_field ("b_nospell_cluster_id")
		end

	set_b_syn_containedin (a_b_syn_containedin: INTEGER_32)
		do
			b_syn_containedin := a_b_syn_containedin
			update_memory_field ("b_syn_containedin")
		end

	set_b_syn_sync_flags (a_b_syn_sync_flags: INTEGER_32)
		do
			b_syn_sync_flags := a_b_syn_sync_flags
			update_memory_field ("b_syn_sync_flags")
		end

	set_b_syn_sync_id (a_b_syn_sync_id: INTEGER_16)
		do
			b_syn_sync_id := a_b_syn_sync_id
			update_memory_field ("b_syn_sync_id")
		end

	set_b_syn_sync_minlines (a_b_syn_sync_minlines: INTEGER_32)
		do
			b_syn_sync_minlines := a_b_syn_sync_minlines
			update_memory_field ("b_syn_sync_minlines")
		end

	set_b_syn_sync_maxlines (a_b_syn_sync_maxlines: INTEGER_32)
		do
			b_syn_sync_maxlines := a_b_syn_sync_maxlines
			update_memory_field ("b_syn_sync_maxlines")
		end

	set_b_syn_sync_linebreaks (a_b_syn_sync_linebreaks: INTEGER_32)
		do
			b_syn_sync_linebreaks := a_b_syn_sync_linebreaks
			update_memory_field ("b_syn_sync_linebreaks")
		end

	set_b_syn_linecont_pat (a_b_syn_linecont_pat: CE_POINTER [NATURAL_8])
		do
			b_syn_linecont_pat := a_b_syn_linecont_pat
			update_memory_field ("b_syn_linecont_pat")
		end

	set_b_syn_linecont_prog (a_b_syn_linecont_prog: CE_POINTER [PD_REGPROG_T])
		do
			b_syn_linecont_prog := a_b_syn_linecont_prog
			update_memory_field ("b_syn_linecont_prog")
		end

	set_b_syn_linecont_ic (a_b_syn_linecont_ic: INTEGER_32)
		do
			b_syn_linecont_ic := a_b_syn_linecont_ic
			update_memory_field ("b_syn_linecont_ic")
		end

	set_b_syn_topgrp (a_b_syn_topgrp: INTEGER_32)
		do
			b_syn_topgrp := a_b_syn_topgrp
			update_memory_field ("b_syn_topgrp")
		end

	set_b_syn_folditems (a_b_syn_folditems: INTEGER_32)
		do
			b_syn_folditems := a_b_syn_folditems
			update_memory_field ("b_syn_folditems")
		end

	set_b_sst_array (a_b_sst_array: CE_POINTER [PD_SYN_STATE])
		do
			b_sst_array := a_b_sst_array
			update_memory_field ("b_sst_array")
		end

	set_b_sst_len (a_b_sst_len: INTEGER_32)
		do
			b_sst_len := a_b_sst_len
			update_memory_field ("b_sst_len")
		end

	set_b_sst_first (a_b_sst_first: CE_POINTER [PD_SYN_STATE])
		do
			b_sst_first := a_b_sst_first
			update_memory_field ("b_sst_first")
		end

	set_b_sst_firstfree (a_b_sst_firstfree: CE_POINTER [PD_SYN_STATE])
		do
			b_sst_firstfree := a_b_sst_firstfree
			update_memory_field ("b_sst_firstfree")
		end

	set_b_sst_freecount (a_b_sst_freecount: INTEGER_32)
		do
			b_sst_freecount := a_b_sst_freecount
			update_memory_field ("b_sst_freecount")
		end

	set_b_sst_check_lnum (a_b_sst_check_lnum: INTEGER_32)
		do
			b_sst_check_lnum := a_b_sst_check_lnum
			update_memory_field ("b_sst_check_lnum")
		end

	set_b_sst_lasttick (a_b_sst_lasttick: NATURAL_16)
		do
			b_sst_lasttick := a_b_sst_lasttick
			update_memory_field ("b_sst_lasttick")
		end

	set_b_langp (a_b_langp: PD_GROWARRAY)
		do
			b_langp := a_b_langp
			update_memory_field ("b_langp")
		end

	set_b_spell_ismw_mb (a_b_spell_ismw_mb: CE_POINTER [NATURAL_8])
		do
			b_spell_ismw_mb := a_b_spell_ismw_mb
			update_memory_field ("b_spell_ismw_mb")
		end

	set_b_p_spc (a_b_p_spc: CE_POINTER [NATURAL_8])
		do
			b_p_spc := a_b_p_spc
			update_memory_field ("b_p_spc")
		end

	set_b_cap_prog (a_b_cap_prog: CE_POINTER [PD_REGPROG_T])
		do
			b_cap_prog := a_b_cap_prog
			update_memory_field ("b_cap_prog")
		end

	set_b_p_spf (a_b_p_spf: CE_POINTER [NATURAL_8])
		do
			b_p_spf := a_b_p_spf
			update_memory_field ("b_p_spf")
		end

	set_b_p_spl (a_b_p_spl: CE_POINTER [NATURAL_8])
		do
			b_p_spl := a_b_p_spl
			update_memory_field ("b_p_spl")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			b_keywtab := a_other.b_keywtab.twin
			b_keywtab_ic := a_other.b_keywtab_ic.twin
			b_syn_error := a_other.b_syn_error
			b_syn_ic := a_other.b_syn_ic
			b_syn_spell := a_other.b_syn_spell
			b_syn_patterns := a_other.b_syn_patterns.twin
			b_syn_clusters := a_other.b_syn_clusters.twin
			b_spell_cluster_id := a_other.b_spell_cluster_id
			b_nospell_cluster_id := a_other.b_nospell_cluster_id
			b_syn_containedin := a_other.b_syn_containedin
			b_syn_sync_flags := a_other.b_syn_sync_flags
			b_syn_sync_id := a_other.b_syn_sync_id
			b_syn_sync_minlines := a_other.b_syn_sync_minlines
			b_syn_sync_maxlines := a_other.b_syn_sync_maxlines
			b_syn_sync_linebreaks := a_other.b_syn_sync_linebreaks
			b_syn_linecont_pat := a_other.b_syn_linecont_pat
			b_syn_linecont_prog := a_other.b_syn_linecont_prog
			b_syn_linecont_ic := a_other.b_syn_linecont_ic
			b_syn_topgrp := a_other.b_syn_topgrp
			b_syn_folditems := a_other.b_syn_folditems
			b_sst_array := a_other.b_sst_array
			b_sst_len := a_other.b_sst_len
			b_sst_first := a_other.b_sst_first
			b_sst_firstfree := a_other.b_sst_firstfree
			b_sst_freecount := a_other.b_sst_freecount
			b_sst_check_lnum := a_other.b_sst_check_lnum
			b_sst_lasttick := a_other.b_sst_lasttick
			b_langp := a_other.b_langp.twin
			b_spell_ismw := a_other.b_spell_ismw.twin
			b_spell_ismw_mb := a_other.b_spell_ismw_mb
			b_p_spc := a_other.b_p_spc
			b_cap_prog := a_other.b_cap_prog
			b_p_spf := a_other.b_p_spf
			b_p_spl := a_other.b_p_spl
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				b_keywtab.is_equal (a_other.b_keywtab) and
				b_keywtab_ic.is_equal (a_other.b_keywtab_ic) and
				b_syn_error = a_other.b_syn_error and
				b_syn_ic = a_other.b_syn_ic and
				b_syn_spell = a_other.b_syn_spell and
				b_syn_patterns.is_equal (a_other.b_syn_patterns) and
				b_syn_clusters.is_equal (a_other.b_syn_clusters) and
				b_spell_cluster_id = a_other.b_spell_cluster_id and
				b_nospell_cluster_id = a_other.b_nospell_cluster_id and
				b_syn_containedin = a_other.b_syn_containedin and
				b_syn_sync_flags = a_other.b_syn_sync_flags and
				b_syn_sync_id = a_other.b_syn_sync_id and
				b_syn_sync_minlines = a_other.b_syn_sync_minlines and
				b_syn_sync_maxlines = a_other.b_syn_sync_maxlines and
				b_syn_sync_linebreaks = a_other.b_syn_sync_linebreaks and
				b_syn_linecont_pat.is_equal (a_other.b_syn_linecont_pat) and
				b_syn_linecont_prog.is_equal (a_other.b_syn_linecont_prog) and
				b_syn_linecont_ic = a_other.b_syn_linecont_ic and
				b_syn_topgrp = a_other.b_syn_topgrp and
				b_syn_folditems = a_other.b_syn_folditems and
				b_sst_array.is_equal (a_other.b_sst_array) and
				b_sst_len = a_other.b_sst_len and
				b_sst_first.is_equal (a_other.b_sst_first) and
				b_sst_firstfree.is_equal (a_other.b_sst_firstfree) and
				b_sst_freecount = a_other.b_sst_freecount and
				b_sst_check_lnum = a_other.b_sst_check_lnum and
				b_sst_lasttick = a_other.b_sst_lasttick and
				b_langp.is_equal (a_other.b_langp) and
				b_spell_ismw.is_equal (a_other.b_spell_ismw) and
				b_spell_ismw_mb.is_equal (a_other.b_spell_ismw_mb) and
				b_p_spc.is_equal (a_other.b_p_spc) and
				b_cap_prog.is_equal (a_other.b_cap_prog) and
				b_p_spf.is_equal (a_other.b_p_spf) and
				b_p_spl.is_equal (a_other.b_p_spl)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("b_keywtab"),
					create {CE_STRUCTURE_FIELD}.make ("b_keywtab_ic"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_error"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_ic"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_spell"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_patterns"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_clusters"),
					create {CE_STRUCTURE_FIELD}.make ("b_spell_cluster_id"),
					create {CE_STRUCTURE_FIELD}.make ("b_nospell_cluster_id"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_containedin"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_flags"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_id"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_minlines"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_maxlines"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_linebreaks"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_linecont_pat"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_linecont_prog"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_linecont_ic"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_topgrp"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_folditems"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_array"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_len"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_first"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_firstfree"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_freecount"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_check_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_lasttick"),
					create {CE_STRUCTURE_FIELD}.make ("b_langp"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b_spell_ismw", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("b_spell_ismw_mb"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_spc"),
					create {CE_STRUCTURE_FIELD}.make ("b_cap_prog"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_spf"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_spl")
				>>)
			init_structure_info
		end

end
