class
	PD_TAG_POINTERS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create tagname.make
			create tagname_end.make
			create fname.make
			create fname_end.make
			create command.make
			create command_end.make
			create tag_fname.make
			create tagkind.make
			create tagkind_end.make
		end

feature {ANY} -- fields

	tagname: CE_POINTER [NATURAL_8] assign set_tagname

	tagname_end: CE_POINTER [NATURAL_8] assign set_tagname_end

	fname: CE_POINTER [NATURAL_8] assign set_fname

	fname_end: CE_POINTER [NATURAL_8] assign set_fname_end

	command: CE_POINTER [NATURAL_8] assign set_command

	command_end: CE_POINTER [NATURAL_8] assign set_command_end

	tag_fname: CE_POINTER [NATURAL_8] assign set_tag_fname

	tagkind: CE_POINTER [NATURAL_8] assign set_tagkind

	tagkind_end: CE_POINTER [NATURAL_8] assign set_tagkind_end

feature {ANY} -- setters

	set_tagname (a_tagname: CE_POINTER [NATURAL_8])
		do
			tagname := a_tagname
			update_memory_field ("tagname")
		end

	set_tagname_end (a_tagname_end: CE_POINTER [NATURAL_8])
		do
			tagname_end := a_tagname_end
			update_memory_field ("tagname_end")
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			fname := a_fname
			update_memory_field ("fname")
		end

	set_fname_end (a_fname_end: CE_POINTER [NATURAL_8])
		do
			fname_end := a_fname_end
			update_memory_field ("fname_end")
		end

	set_command (a_command: CE_POINTER [NATURAL_8])
		do
			command := a_command
			update_memory_field ("command")
		end

	set_command_end (a_command_end: CE_POINTER [NATURAL_8])
		do
			command_end := a_command_end
			update_memory_field ("command_end")
		end

	set_tag_fname (a_tag_fname: CE_POINTER [NATURAL_8])
		do
			tag_fname := a_tag_fname
			update_memory_field ("tag_fname")
		end

	set_tagkind (a_tagkind: CE_POINTER [NATURAL_8])
		do
			tagkind := a_tagkind
			update_memory_field ("tagkind")
		end

	set_tagkind_end (a_tagkind_end: CE_POINTER [NATURAL_8])
		do
			tagkind_end := a_tagkind_end
			update_memory_field ("tagkind_end")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tagname := a_other.tagname
			tagname_end := a_other.tagname_end
			fname := a_other.fname
			fname_end := a_other.fname_end
			command := a_other.command
			command_end := a_other.command_end
			tag_fname := a_other.tag_fname
			tagkind := a_other.tagkind
			tagkind_end := a_other.tagkind_end
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tagname.is_equal (a_other.tagname) and
				tagname_end.is_equal (a_other.tagname_end) and
				fname.is_equal (a_other.fname) and
				fname_end.is_equal (a_other.fname_end) and
				command.is_equal (a_other.command) and
				command_end.is_equal (a_other.command_end) and
				tag_fname.is_equal (a_other.tag_fname) and
				tagkind.is_equal (a_other.tagkind) and
				tagkind_end.is_equal (a_other.tagkind_end)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tagname"),
					create {CE_STRUCTURE_FIELD}.make ("tagname_end"),
					create {CE_STRUCTURE_FIELD}.make ("fname"),
					create {CE_STRUCTURE_FIELD}.make ("fname_end"),
					create {CE_STRUCTURE_FIELD}.make ("command"),
					create {CE_STRUCTURE_FIELD}.make ("command_end"),
					create {CE_STRUCTURE_FIELD}.make ("tag_fname"),
					create {CE_STRUCTURE_FIELD}.make ("tagkind"),
					create {CE_STRUCTURE_FIELD}.make ("tagkind_end")
				>>)
			init_structure_info
		end

end
