class
	PD_TAGGY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create tagname.make
			create fmark.make
		end

feature {ANY} -- fields

	tagname: CE_POINTER [NATURAL_8] assign set_tagname

	fmark: PD_FILEMARK assign set_fmark

	cur_match: INTEGER_32 assign set_cur_match

	cur_fnum: INTEGER_32 assign set_cur_fnum

feature {ANY} -- setters

	set_tagname (a_tagname: CE_POINTER [NATURAL_8])
		do
			tagname := a_tagname
			update_memory_field ("tagname")
		end

	set_fmark (a_fmark: PD_FILEMARK)
		do
			fmark := a_fmark
			update_memory_field ("fmark")
		end

	set_cur_match (a_cur_match: INTEGER_32)
		do
			cur_match := a_cur_match
			update_memory_field ("cur_match")
		end

	set_cur_fnum (a_cur_fnum: INTEGER_32)
		do
			cur_fnum := a_cur_fnum
			update_memory_field ("cur_fnum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tagname := a_other.tagname
			fmark := a_other.fmark.twin
			cur_match := a_other.cur_match
			cur_fnum := a_other.cur_fnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tagname.is_equal (a_other.tagname) and
				fmark.is_equal (a_other.fmark) and
				cur_match = a_other.cur_match and
				cur_fnum = a_other.cur_fnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tagname"),
					create {CE_STRUCTURE_FIELD}.make ("fmark"),
					create {CE_STRUCTURE_FIELD}.make ("cur_match"),
					create {CE_STRUCTURE_FIELD}.make ("cur_fnum")
				>>)
			init_structure_info
		end

end
