class
	PD_TERM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create start.make
			create stop.make
		end

feature {ANY} -- fields

	start: CE_POINTER [NATURAL_8] assign set_start

	stop: CE_POINTER [NATURAL_8] assign set_stop

feature {ANY} -- setters

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			start := a_start
			update_memory_field ("start")
		end

	set_stop (a_stop: CE_POINTER [NATURAL_8])
		do
			stop := a_stop
			update_memory_field ("stop")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			start := a_other.start
			stop := a_other.stop
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				start.is_equal (a_other.start) and
				stop.is_equal (a_other.stop)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("stop")
				>>)
			init_structure_info
		end

end
