class
	PD_TRYSTATE_S

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	ts_state: NATURAL_32 assign set_ts_state

	ts_score: INTEGER_32 assign set_ts_score

	ts_arridx: INTEGER_32 assign set_ts_arridx

	ts_curi: INTEGER_16 assign set_ts_curi

	ts_fidx: NATURAL_8 assign set_ts_fidx

	ts_fidxtry: NATURAL_8 assign set_ts_fidxtry

	ts_twordlen: NATURAL_8 assign set_ts_twordlen

	ts_prefixdepth: NATURAL_8 assign set_ts_prefixdepth

	ts_flags: NATURAL_8 assign set_ts_flags

	ts_tcharlen: NATURAL_8 assign set_ts_tcharlen

	ts_tcharidx: NATURAL_8 assign set_ts_tcharidx

	ts_isdiff: NATURAL_8 assign set_ts_isdiff

	ts_fcharstart: NATURAL_8 assign set_ts_fcharstart

	ts_prewordlen: NATURAL_8 assign set_ts_prewordlen

	ts_splitoff: NATURAL_8 assign set_ts_splitoff

	ts_splitfidx: NATURAL_8 assign set_ts_splitfidx

	ts_complen: NATURAL_8 assign set_ts_complen

	ts_compsplit: NATURAL_8 assign set_ts_compsplit

	ts_save_badflags: NATURAL_8 assign set_ts_save_badflags

	ts_delidx: NATURAL_8 assign set_ts_delidx

feature {ANY} -- setters

	set_ts_state (a_ts_state: NATURAL_32)
		do
			ts_state := a_ts_state
			update_memory_field ("ts_state")
		end

	set_ts_score (a_ts_score: INTEGER_32)
		do
			ts_score := a_ts_score
			update_memory_field ("ts_score")
		end

	set_ts_arridx (a_ts_arridx: INTEGER_32)
		do
			ts_arridx := a_ts_arridx
			update_memory_field ("ts_arridx")
		end

	set_ts_curi (a_ts_curi: INTEGER_16)
		do
			ts_curi := a_ts_curi
			update_memory_field ("ts_curi")
		end

	set_ts_fidx (a_ts_fidx: NATURAL_8)
		do
			ts_fidx := a_ts_fidx
			update_memory_field ("ts_fidx")
		end

	set_ts_fidxtry (a_ts_fidxtry: NATURAL_8)
		do
			ts_fidxtry := a_ts_fidxtry
			update_memory_field ("ts_fidxtry")
		end

	set_ts_twordlen (a_ts_twordlen: NATURAL_8)
		do
			ts_twordlen := a_ts_twordlen
			update_memory_field ("ts_twordlen")
		end

	set_ts_prefixdepth (a_ts_prefixdepth: NATURAL_8)
		do
			ts_prefixdepth := a_ts_prefixdepth
			update_memory_field ("ts_prefixdepth")
		end

	set_ts_flags (a_ts_flags: NATURAL_8)
		do
			ts_flags := a_ts_flags
			update_memory_field ("ts_flags")
		end

	set_ts_tcharlen (a_ts_tcharlen: NATURAL_8)
		do
			ts_tcharlen := a_ts_tcharlen
			update_memory_field ("ts_tcharlen")
		end

	set_ts_tcharidx (a_ts_tcharidx: NATURAL_8)
		do
			ts_tcharidx := a_ts_tcharidx
			update_memory_field ("ts_tcharidx")
		end

	set_ts_isdiff (a_ts_isdiff: NATURAL_8)
		do
			ts_isdiff := a_ts_isdiff
			update_memory_field ("ts_isdiff")
		end

	set_ts_fcharstart (a_ts_fcharstart: NATURAL_8)
		do
			ts_fcharstart := a_ts_fcharstart
			update_memory_field ("ts_fcharstart")
		end

	set_ts_prewordlen (a_ts_prewordlen: NATURAL_8)
		do
			ts_prewordlen := a_ts_prewordlen
			update_memory_field ("ts_prewordlen")
		end

	set_ts_splitoff (a_ts_splitoff: NATURAL_8)
		do
			ts_splitoff := a_ts_splitoff
			update_memory_field ("ts_splitoff")
		end

	set_ts_splitfidx (a_ts_splitfidx: NATURAL_8)
		do
			ts_splitfidx := a_ts_splitfidx
			update_memory_field ("ts_splitfidx")
		end

	set_ts_complen (a_ts_complen: NATURAL_8)
		do
			ts_complen := a_ts_complen
			update_memory_field ("ts_complen")
		end

	set_ts_compsplit (a_ts_compsplit: NATURAL_8)
		do
			ts_compsplit := a_ts_compsplit
			update_memory_field ("ts_compsplit")
		end

	set_ts_save_badflags (a_ts_save_badflags: NATURAL_8)
		do
			ts_save_badflags := a_ts_save_badflags
			update_memory_field ("ts_save_badflags")
		end

	set_ts_delidx (a_ts_delidx: NATURAL_8)
		do
			ts_delidx := a_ts_delidx
			update_memory_field ("ts_delidx")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ts_state := a_other.ts_state
			ts_score := a_other.ts_score
			ts_arridx := a_other.ts_arridx
			ts_curi := a_other.ts_curi
			ts_fidx := a_other.ts_fidx
			ts_fidxtry := a_other.ts_fidxtry
			ts_twordlen := a_other.ts_twordlen
			ts_prefixdepth := a_other.ts_prefixdepth
			ts_flags := a_other.ts_flags
			ts_tcharlen := a_other.ts_tcharlen
			ts_tcharidx := a_other.ts_tcharidx
			ts_isdiff := a_other.ts_isdiff
			ts_fcharstart := a_other.ts_fcharstart
			ts_prewordlen := a_other.ts_prewordlen
			ts_splitoff := a_other.ts_splitoff
			ts_splitfidx := a_other.ts_splitfidx
			ts_complen := a_other.ts_complen
			ts_compsplit := a_other.ts_compsplit
			ts_save_badflags := a_other.ts_save_badflags
			ts_delidx := a_other.ts_delidx
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ts_state = a_other.ts_state and
				ts_score = a_other.ts_score and
				ts_arridx = a_other.ts_arridx and
				ts_curi = a_other.ts_curi and
				ts_fidx = a_other.ts_fidx and
				ts_fidxtry = a_other.ts_fidxtry and
				ts_twordlen = a_other.ts_twordlen and
				ts_prefixdepth = a_other.ts_prefixdepth and
				ts_flags = a_other.ts_flags and
				ts_tcharlen = a_other.ts_tcharlen and
				ts_tcharidx = a_other.ts_tcharidx and
				ts_isdiff = a_other.ts_isdiff and
				ts_fcharstart = a_other.ts_fcharstart and
				ts_prewordlen = a_other.ts_prewordlen and
				ts_splitoff = a_other.ts_splitoff and
				ts_splitfidx = a_other.ts_splitfidx and
				ts_complen = a_other.ts_complen and
				ts_compsplit = a_other.ts_compsplit and
				ts_save_badflags = a_other.ts_save_badflags and
				ts_delidx = a_other.ts_delidx
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ts_state"),
					create {CE_STRUCTURE_FIELD}.make ("ts_score"),
					create {CE_STRUCTURE_FIELD}.make ("ts_arridx"),
					create {CE_STRUCTURE_FIELD}.make ("ts_curi"),
					create {CE_STRUCTURE_FIELD}.make ("ts_fidx"),
					create {CE_STRUCTURE_FIELD}.make ("ts_fidxtry"),
					create {CE_STRUCTURE_FIELD}.make ("ts_twordlen"),
					create {CE_STRUCTURE_FIELD}.make ("ts_prefixdepth"),
					create {CE_STRUCTURE_FIELD}.make ("ts_flags"),
					create {CE_STRUCTURE_FIELD}.make ("ts_tcharlen"),
					create {CE_STRUCTURE_FIELD}.make ("ts_tcharidx"),
					create {CE_STRUCTURE_FIELD}.make ("ts_isdiff"),
					create {CE_STRUCTURE_FIELD}.make ("ts_fcharstart"),
					create {CE_STRUCTURE_FIELD}.make ("ts_prewordlen"),
					create {CE_STRUCTURE_FIELD}.make ("ts_splitoff"),
					create {CE_STRUCTURE_FIELD}.make ("ts_splitfidx"),
					create {CE_STRUCTURE_FIELD}.make ("ts_complen"),
					create {CE_STRUCTURE_FIELD}.make ("ts_compsplit"),
					create {CE_STRUCTURE_FIELD}.make ("ts_save_badflags"),
					create {CE_STRUCTURE_FIELD}.make ("ts_delidx")
				>>)
			init_structure_info
		end

end
