class
	PD_UCMD

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create uc_name.make
			create uc_rep.make
			create uc_compl_arg.make
		end

feature {ANY} -- fields

	uc_name: CE_POINTER [NATURAL_8] assign set_uc_name

	uc_argt: NATURAL_32 assign set_uc_argt

	uc_rep: CE_POINTER [NATURAL_8] assign set_uc_rep

	uc_def: INTEGER_32 assign set_uc_def

	uc_compl: INTEGER_32 assign set_uc_compl

	uc_scriptID: INTEGER_32 assign set_uc_scriptID

	uc_compl_arg: CE_POINTER [NATURAL_8] assign set_uc_compl_arg

feature {ANY} -- setters

	set_uc_name (a_uc_name: CE_POINTER [NATURAL_8])
		do
			uc_name := a_uc_name
			update_memory_field ("uc_name")
		end

	set_uc_argt (a_uc_argt: NATURAL_32)
		do
			uc_argt := a_uc_argt
			update_memory_field ("uc_argt")
		end

	set_uc_rep (a_uc_rep: CE_POINTER [NATURAL_8])
		do
			uc_rep := a_uc_rep
			update_memory_field ("uc_rep")
		end

	set_uc_def (a_uc_def: INTEGER_32)
		do
			uc_def := a_uc_def
			update_memory_field ("uc_def")
		end

	set_uc_compl (a_uc_compl: INTEGER_32)
		do
			uc_compl := a_uc_compl
			update_memory_field ("uc_compl")
		end

	set_uc_scriptID (a_uc_scriptID: INTEGER_32)
		do
			uc_scriptID := a_uc_scriptID
			update_memory_field ("uc_scriptID")
		end

	set_uc_compl_arg (a_uc_compl_arg: CE_POINTER [NATURAL_8])
		do
			uc_compl_arg := a_uc_compl_arg
			update_memory_field ("uc_compl_arg")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			uc_name := a_other.uc_name
			uc_argt := a_other.uc_argt
			uc_rep := a_other.uc_rep
			uc_def := a_other.uc_def
			uc_compl := a_other.uc_compl
			uc_scriptID := a_other.uc_scriptID
			uc_compl_arg := a_other.uc_compl_arg
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				uc_name.is_equal (a_other.uc_name) and
				uc_argt = a_other.uc_argt and
				uc_rep.is_equal (a_other.uc_rep) and
				uc_def = a_other.uc_def and
				uc_compl = a_other.uc_compl and
				uc_scriptID = a_other.uc_scriptID and
				uc_compl_arg.is_equal (a_other.uc_compl_arg)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("uc_name"),
					create {CE_STRUCTURE_FIELD}.make ("uc_argt"),
					create {CE_STRUCTURE_FIELD}.make ("uc_rep"),
					create {CE_STRUCTURE_FIELD}.make ("uc_def"),
					create {CE_STRUCTURE_FIELD}.make ("uc_compl"),
					create {CE_STRUCTURE_FIELD}.make ("uc_scriptID"),
					create {CE_STRUCTURE_FIELD}.make ("uc_compl_arg")
				>>)
			init_structure_info
		end

end
