class
	PD_UFUNC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create uf_args.make
			create uf_lines.make
			create uf_name.make (<<1>>)
		end

feature {ANY} -- fields

	uf_varargs: INTEGER_32 assign set_uf_varargs

	uf_flags: INTEGER_32 assign set_uf_flags

	uf_calls: INTEGER_32 assign set_uf_calls

	uf_args: PD_GROWARRAY assign set_uf_args

	uf_lines: PD_GROWARRAY assign set_uf_lines

	uf_script_ID: INTEGER_32 assign set_uf_script_ID

	uf_refcount: INTEGER_32 assign set_uf_refcount

	uf_name: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_uf_varargs (a_uf_varargs: INTEGER_32)
		do
			uf_varargs := a_uf_varargs
			update_memory_field ("uf_varargs")
		end

	set_uf_flags (a_uf_flags: INTEGER_32)
		do
			uf_flags := a_uf_flags
			update_memory_field ("uf_flags")
		end

	set_uf_calls (a_uf_calls: INTEGER_32)
		do
			uf_calls := a_uf_calls
			update_memory_field ("uf_calls")
		end

	set_uf_args (a_uf_args: PD_GROWARRAY)
		do
			uf_args := a_uf_args
			update_memory_field ("uf_args")
		end

	set_uf_lines (a_uf_lines: PD_GROWARRAY)
		do
			uf_lines := a_uf_lines
			update_memory_field ("uf_lines")
		end

	set_uf_script_ID (a_uf_script_ID: INTEGER_32)
		do
			uf_script_ID := a_uf_script_ID
			update_memory_field ("uf_script_ID")
		end

	set_uf_refcount (a_uf_refcount: INTEGER_32)
		do
			uf_refcount := a_uf_refcount
			update_memory_field ("uf_refcount")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			uf_varargs := a_other.uf_varargs
			uf_flags := a_other.uf_flags
			uf_calls := a_other.uf_calls
			uf_args := a_other.uf_args.twin
			uf_lines := a_other.uf_lines.twin
			uf_script_ID := a_other.uf_script_ID
			uf_refcount := a_other.uf_refcount
			uf_name := a_other.uf_name.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				uf_varargs = a_other.uf_varargs and
				uf_flags = a_other.uf_flags and
				uf_calls = a_other.uf_calls and
				uf_args.is_equal (a_other.uf_args) and
				uf_lines.is_equal (a_other.uf_lines) and
				uf_script_ID = a_other.uf_script_ID and
				uf_refcount = a_other.uf_refcount and
				uf_name.is_equal (a_other.uf_name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("uf_varargs"),
					create {CE_STRUCTURE_FIELD}.make ("uf_flags"),
					create {CE_STRUCTURE_FIELD}.make ("uf_calls"),
					create {CE_STRUCTURE_FIELD}.make ("uf_args"),
					create {CE_STRUCTURE_FIELD}.make ("uf_lines"),
					create {CE_STRUCTURE_FIELD}.make ("uf_script_ID"),
					create {CE_STRUCTURE_FIELD}.make ("uf_refcount"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("uf_name", <<1>>)
				>>)
			init_structure_info
		end

end
