class
	PD_VIMCLIPBOARD

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create start.make
			create end2.make
			create prev.make
			create gtk_sel_atom.make
		end

feature {ANY} -- fields

	available: INTEGER_32 assign set_available

	owned: INTEGER_32 assign set_owned

	start: PD_POS_T assign set_start

	end2: PD_POS_T assign set_end2

	vmode: INTEGER_32 assign set_vmode

	origin_row: NATURAL_16 assign set_origin_row

	origin_start_col: NATURAL_16 assign set_origin_start_col

	origin_end_col: NATURAL_16 assign set_origin_end_col

	word_start_col: NATURAL_16 assign set_word_start_col

	word_end_col: NATURAL_16 assign set_word_end_col

	prev: PD_POS_T assign set_prev

	state: NATURAL_16 assign set_state

	mode: NATURAL_16 assign set_mode

	sel_atom: NATURAL_32 assign set_sel_atom

	gtk_sel_atom: CE_POINTER [ANY] assign set_gtk_sel_atom

feature {ANY} -- setters

	set_available (a_available: INTEGER_32)
		do
			available := a_available
			update_memory_field ("available")
		end

	set_owned (a_owned: INTEGER_32)
		do
			owned := a_owned
			update_memory_field ("owned")
		end

	set_start (a_start: PD_POS_T)
		do
			start := a_start
			update_memory_field ("start")
		end

	set_end2 (a_end2: PD_POS_T)
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_vmode (a_vmode: INTEGER_32)
		do
			vmode := a_vmode
			update_memory_field ("vmode")
		end

	set_origin_row (a_origin_row: NATURAL_16)
		do
			origin_row := a_origin_row
			update_memory_field ("origin_row")
		end

	set_origin_start_col (a_origin_start_col: NATURAL_16)
		do
			origin_start_col := a_origin_start_col
			update_memory_field ("origin_start_col")
		end

	set_origin_end_col (a_origin_end_col: NATURAL_16)
		do
			origin_end_col := a_origin_end_col
			update_memory_field ("origin_end_col")
		end

	set_word_start_col (a_word_start_col: NATURAL_16)
		do
			word_start_col := a_word_start_col
			update_memory_field ("word_start_col")
		end

	set_word_end_col (a_word_end_col: NATURAL_16)
		do
			word_end_col := a_word_end_col
			update_memory_field ("word_end_col")
		end

	set_prev (a_prev: PD_POS_T)
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_state (a_state: NATURAL_16)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_mode (a_mode: NATURAL_16)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_sel_atom (a_sel_atom: NATURAL_32)
		do
			sel_atom := a_sel_atom
			update_memory_field ("sel_atom")
		end

	set_gtk_sel_atom (a_gtk_sel_atom: CE_POINTER [ANY])
		do
			gtk_sel_atom := a_gtk_sel_atom
			update_memory_field ("gtk_sel_atom")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			available := a_other.available
			owned := a_other.owned
			start := a_other.start.twin
			end2 := a_other.end2.twin
			vmode := a_other.vmode
			origin_row := a_other.origin_row
			origin_start_col := a_other.origin_start_col
			origin_end_col := a_other.origin_end_col
			word_start_col := a_other.word_start_col
			word_end_col := a_other.word_end_col
			prev := a_other.prev.twin
			state := a_other.state
			mode := a_other.mode
			sel_atom := a_other.sel_atom
			gtk_sel_atom := a_other.gtk_sel_atom
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				available = a_other.available and
				owned = a_other.owned and
				start.is_equal (a_other.start) and
				end2.is_equal (a_other.end2) and
				vmode = a_other.vmode and
				origin_row = a_other.origin_row and
				origin_start_col = a_other.origin_start_col and
				origin_end_col = a_other.origin_end_col and
				word_start_col = a_other.word_start_col and
				word_end_col = a_other.word_end_col and
				prev.is_equal (a_other.prev) and
				state = a_other.state and
				mode = a_other.mode and
				sel_atom = a_other.sel_atom and
				gtk_sel_atom.is_equal (a_other.gtk_sel_atom)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("available"),
					create {CE_STRUCTURE_FIELD}.make ("owned"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("vmode"),
					create {CE_STRUCTURE_FIELD}.make ("origin_row"),
					create {CE_STRUCTURE_FIELD}.make ("origin_start_col"),
					create {CE_STRUCTURE_FIELD}.make ("origin_end_col"),
					create {CE_STRUCTURE_FIELD}.make ("word_start_col"),
					create {CE_STRUCTURE_FIELD}.make ("word_end_col"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("sel_atom"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_sel_atom")
				>>)
			init_structure_info
		end

end
