class
	PD_VIMCONV_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create vc_fd.make
		end

feature {ANY} -- fields

	vc_type: INTEGER_32 assign set_vc_type

	vc_factor: INTEGER_32 assign set_vc_factor

	vc_fd: CE_POINTER [ANY] assign set_vc_fd

	vc_fail: INTEGER_32 assign set_vc_fail

feature {ANY} -- setters

	set_vc_type (a_vc_type: INTEGER_32)
		do
			vc_type := a_vc_type
			update_memory_field ("vc_type")
		end

	set_vc_factor (a_vc_factor: INTEGER_32)
		do
			vc_factor := a_vc_factor
			update_memory_field ("vc_factor")
		end

	set_vc_fd (a_vc_fd: CE_POINTER [ANY])
		do
			vc_fd := a_vc_fd
			update_memory_field ("vc_fd")
		end

	set_vc_fail (a_vc_fail: INTEGER_32)
		do
			vc_fail := a_vc_fail
			update_memory_field ("vc_fail")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			vc_type := a_other.vc_type
			vc_factor := a_other.vc_factor
			vc_fd := a_other.vc_fd
			vc_fail := a_other.vc_fail
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				vc_type = a_other.vc_type and
				vc_factor = a_other.vc_factor and
				vc_fd.is_equal (a_other.vc_fd) and
				vc_fail = a_other.vc_fail
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("vc_type"),
					create {CE_STRUCTURE_FIELD}.make ("vc_factor"),
					create {CE_STRUCTURE_FIELD}.make ("vc_fd"),
					create {CE_STRUCTURE_FIELD}.make ("vc_fail")
				>>)
			init_structure_info
		end

end
