class
	PD_VIMOPTION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fullname.make
			create shortname.make
			create var.make
			create def_val.make (<<2>>)
		end

feature {ANY} -- fields

	fullname: CE_POINTER [INTEGER_8] assign set_fullname

	shortname: CE_POINTER [INTEGER_8] assign set_shortname

	flags: NATURAL_32 assign set_flags

	var: CE_POINTER [NATURAL_8] assign set_var

	indir: NATURAL_32 assign set_indir

	def_val: CE_ARRAY [CE_POINTER [NATURAL_8]]

	scriptID: INTEGER_32 assign set_scriptID

feature {ANY} -- setters

	set_fullname (a_fullname: CE_POINTER [INTEGER_8])
		do
			fullname := a_fullname
			update_memory_field ("fullname")
		end

	set_shortname (a_shortname: CE_POINTER [INTEGER_8])
		do
			shortname := a_shortname
			update_memory_field ("shortname")
		end

	set_flags (a_flags: NATURAL_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_var (a_var: CE_POINTER [NATURAL_8])
		do
			var := a_var
			update_memory_field ("var")
		end

	set_indir (a_indir: NATURAL_32)
		do
			indir := a_indir
			update_memory_field ("indir")
		end

	set_scriptID (a_scriptID: INTEGER_32)
		do
			scriptID := a_scriptID
			update_memory_field ("scriptID")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fullname := a_other.fullname
			shortname := a_other.shortname
			flags := a_other.flags
			var := a_other.var
			indir := a_other.indir
			def_val := a_other.def_val.twin
			scriptID := a_other.scriptID
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fullname.is_equal (a_other.fullname) and
				shortname.is_equal (a_other.shortname) and
				flags = a_other.flags and
				var.is_equal (a_other.var) and
				indir = a_other.indir and
				def_val.is_equal (a_other.def_val) and
				scriptID = a_other.scriptID
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fullname"),
					create {CE_STRUCTURE_FIELD}.make ("shortname"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("var"),
					create {CE_STRUCTURE_FIELD}.make ("indir"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("def_val", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("scriptID")
				>>)
			init_structure_info
		end

end
