class
	PD_VIMVAR

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create vv_name.make
			create vv_di.make
			create vv_filler.make (<<16>>)
		end

feature {ANY} -- fields

	vv_name: CE_POINTER [INTEGER_8] assign set_vv_name

	vv_di: PD_DICTITEM_S assign set_vv_di

	vv_filler: CE_ARRAY [INTEGER_8]

	vv_flags: INTEGER_8 assign set_vv_flags

feature {ANY} -- setters

	set_vv_name (a_vv_name: CE_POINTER [INTEGER_8])
		do
			vv_name := a_vv_name
			update_memory_field ("vv_name")
		end

	set_vv_di (a_vv_di: PD_DICTITEM_S)
		do
			vv_di := a_vv_di
			update_memory_field ("vv_di")
		end

	set_vv_flags (a_vv_flags: INTEGER_8)
		do
			vv_flags := a_vv_flags
			update_memory_field ("vv_flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			vv_name := a_other.vv_name
			vv_di := a_other.vv_di.twin
			vv_filler := a_other.vv_filler.twin
			vv_flags := a_other.vv_flags
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				vv_name.is_equal (a_other.vv_name) and
				vv_di.is_equal (a_other.vv_di) and
				vv_filler.is_equal (a_other.vv_filler) and
				vv_flags = a_other.vv_flags
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("vv_name"),
					create {CE_STRUCTURE_FIELD}.make ("vv_di"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("vv_filler", <<16>>),
					create {CE_STRUCTURE_FIELD}.make ("vv_flags")
				>>)
			init_structure_info
		end

end
