class
	PD_VIR_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create vir_line.make
			create vir_fd.make
			create vir_conv.make
		end

feature {ANY} -- fields

	vir_line: CE_POINTER [NATURAL_8] assign set_vir_line

	vir_fd: CE_POINTER [SD_IO_FILE] assign set_vir_fd

	vir_conv: PD_VIMCONV_T assign set_vir_conv

feature {ANY} -- setters

	set_vir_line (a_vir_line: CE_POINTER [NATURAL_8])
		do
			vir_line := a_vir_line
			update_memory_field ("vir_line")
		end

	set_vir_fd (a_vir_fd: CE_POINTER [SD_IO_FILE])
		do
			vir_fd := a_vir_fd
			update_memory_field ("vir_fd")
		end

	set_vir_conv (a_vir_conv: PD_VIMCONV_T)
		do
			vir_conv := a_vir_conv
			update_memory_field ("vir_conv")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			vir_line := a_other.vir_line
			vir_fd := a_other.vir_fd
			vir_conv := a_other.vir_conv.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				vir_line.is_equal (a_other.vir_line) and
				vir_fd.is_equal (a_other.vir_fd) and
				vir_conv.is_equal (a_other.vir_conv)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("vir_line"),
					create {CE_STRUCTURE_FIELD}.make ("vir_fd"),
					create {CE_STRUCTURE_FIELD}.make ("vir_conv")
				>>)
			init_structure_info
		end

end
