class
	PD_VISUALINFO_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create vi_start.make
			create vi_end.make
		end

feature {ANY} -- fields

	vi_start: PD_POS_T assign set_vi_start

	vi_end: PD_POS_T assign set_vi_end

	vi_mode: INTEGER_32 assign set_vi_mode

	vi_curswant: INTEGER_32 assign set_vi_curswant

feature {ANY} -- setters

	set_vi_start (a_vi_start: PD_POS_T)
		do
			vi_start := a_vi_start
			update_memory_field ("vi_start")
		end

	set_vi_end (a_vi_end: PD_POS_T)
		do
			vi_end := a_vi_end
			update_memory_field ("vi_end")
		end

	set_vi_mode (a_vi_mode: INTEGER_32)
		do
			vi_mode := a_vi_mode
			update_memory_field ("vi_mode")
		end

	set_vi_curswant (a_vi_curswant: INTEGER_32)
		do
			vi_curswant := a_vi_curswant
			update_memory_field ("vi_curswant")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			vi_start := a_other.vi_start.twin
			vi_end := a_other.vi_end.twin
			vi_mode := a_other.vi_mode
			vi_curswant := a_other.vi_curswant
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				vi_start.is_equal (a_other.vi_start) and
				vi_end.is_equal (a_other.vi_end) and
				vi_mode = a_other.vi_mode and
				vi_curswant = a_other.vi_curswant
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("vi_start"),
					create {CE_STRUCTURE_FIELD}.make ("vi_end"),
					create {CE_STRUCTURE_FIELD}.make ("vi_mode"),
					create {CE_STRUCTURE_FIELD}.make ("vi_curswant")
				>>)
			init_structure_info
		end

end
