class
	PD_VVAL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	v_number: INTEGER_32 assign set_v_number

	v_float: REAL_64 assign set_v_float

	v_string: CE_POINTER [NATURAL_8] assign set_v_string

	v_list: CE_POINTER [PD_LISTVAR_S] assign set_v_list

	v_dict: CE_POINTER [PD_DICTVAR_S] assign set_v_dict

feature {ANY} -- setters

	set_v_number (a_v_number: INTEGER_32)
		do
			v_number := a_v_number
			update_memory_field ("v_number")
		end

	set_v_float (a_v_float: REAL_64)
		do
			v_float := a_v_float
			update_memory_field ("v_float")
		end

	set_v_string (a_v_string: CE_POINTER [NATURAL_8])
		do
			v_string := a_v_string
			update_memory_field ("v_string")
		end

	set_v_list (a_v_list: CE_POINTER [PD_LISTVAR_S])
		do
			v_list := a_v_list
			update_memory_field ("v_list")
		end

	set_v_dict (a_v_dict: CE_POINTER [PD_DICTVAR_S])
		do
			v_dict := a_v_dict
			update_memory_field ("v_dict")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			v_number := a_other.v_number
			v_float := a_other.v_float
			v_string := a_other.v_string
			v_list := a_other.v_list
			v_dict := a_other.v_dict
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				v_number = a_other.v_number and
				v_float = a_other.v_float and
				v_string.is_equal (a_other.v_string) and
				v_list.is_equal (a_other.v_list) and
				v_dict.is_equal (a_other.v_dict)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("v_number"),
					create {CE_STRUCTURE_FIELD}.make ("v_float"),
					create {CE_STRUCTURE_FIELD}.make ("v_string"),
					create {CE_STRUCTURE_FIELD}.make ("v_list"),
					create {CE_STRUCTURE_FIELD}.make ("v_dict")
				>>)
			init_structure_info
		end

end
