class
	PD_WINDOW_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create w_buffer.make
			create w_s.make
			create w_prev.make
			create w_next.make
			create w_frame.make
			create w_cursor.make
			create w_valid_cursor.make
			create w_lines.make
			create w_folds.make
			create w_ru_cursor.make
			create w_alist.make
			create w_localdir.make
			create w_onebuf_opt.make
			create w_allbuf_opt.make
			create w_p_cc_cols.make
			create w_winvar.make
			create w_vars.make
			create w_pcmark.make
			create w_prev_pcmark.make
			create w_jumplist.make (<<100>>)
			create w_match_head.make
			create w_tagstack.make (<<20>>)
			create w_scrollbars.make (<<2>>)
			create w_llist.make
			create w_llist_ref.make
		end

feature {ANY} -- fields

	w_buffer: CE_POINTER [PD_FILE_BUFFER] assign set_w_buffer

	w_s: CE_POINTER [PD_SYNBLOCK_T] assign set_w_s

	w_prev: CE_POINTER [PD_WINDOW_S] assign set_w_prev

	w_next: CE_POINTER [PD_WINDOW_S] assign set_w_next

	w_frame: CE_POINTER [PD_FRAME_S] assign set_w_frame

	w_cursor: PD_POS_T assign set_w_cursor

	w_curswant: INTEGER_32 assign set_w_curswant

	w_set_curswant: INTEGER_32 assign set_w_set_curswant

	w_old_visual_mode: INTEGER_8 assign set_w_old_visual_mode

	w_old_cursor_lnum: INTEGER_32 assign set_w_old_cursor_lnum

	w_old_cursor_fcol: INTEGER_32 assign set_w_old_cursor_fcol

	w_old_cursor_lcol: INTEGER_32 assign set_w_old_cursor_lcol

	w_old_visual_lnum: INTEGER_32 assign set_w_old_visual_lnum

	w_old_visual_col: INTEGER_32 assign set_w_old_visual_col

	w_old_curswant: INTEGER_32 assign set_w_old_curswant

	w_topline: INTEGER_32 assign set_w_topline

	w_topline_was_set: INTEGER_8 assign set_w_topline_was_set

	w_topfill: INTEGER_32 assign set_w_topfill

	w_old_topfill: INTEGER_32 assign set_w_old_topfill

	w_botfill: INTEGER_32 assign set_w_botfill

	w_old_botfill: INTEGER_32 assign set_w_old_botfill

	w_leftcol: INTEGER_32 assign set_w_leftcol

	w_skipcol: INTEGER_32 assign set_w_skipcol

	w_winrow: INTEGER_32 assign set_w_winrow

	w_height: INTEGER_32 assign set_w_height

	w_status_height: INTEGER_32 assign set_w_status_height

	w_wincol: INTEGER_32 assign set_w_wincol

	w_width: INTEGER_32 assign set_w_width

	w_vsep_width: INTEGER_32 assign set_w_vsep_width

	w_valid: INTEGER_32 assign set_w_valid

	w_valid_cursor: PD_POS_T assign set_w_valid_cursor

	w_valid_leftcol: INTEGER_32 assign set_w_valid_leftcol

	w_cline_height: INTEGER_32 assign set_w_cline_height

	w_cline_folded: INTEGER_32 assign set_w_cline_folded

	w_cline_row: INTEGER_32 assign set_w_cline_row

	w_virtcol: INTEGER_32 assign set_w_virtcol

	w_wrow: INTEGER_32 assign set_w_wrow

	w_wcol: INTEGER_32 assign set_w_wcol

	w_botline: INTEGER_32 assign set_w_botline

	w_empty_rows: INTEGER_32 assign set_w_empty_rows

	w_filler_rows: INTEGER_32 assign set_w_filler_rows

	w_lines_valid: INTEGER_32 assign set_w_lines_valid

	w_lines: CE_POINTER [PD_W_LINE] assign set_w_lines

	w_folds: PD_GROWARRAY assign set_w_folds

	w_fold_manual: INTEGER_8 assign set_w_fold_manual

	w_foldinvalid: INTEGER_8 assign set_w_foldinvalid

	w_nrwidth: INTEGER_32 assign set_w_nrwidth

	w_redr_type: INTEGER_32 assign set_w_redr_type

	w_upd_rows: INTEGER_32 assign set_w_upd_rows

	w_redraw_top: INTEGER_32 assign set_w_redraw_top

	w_redraw_bot: INTEGER_32 assign set_w_redraw_bot

	w_redr_status: INTEGER_32 assign set_w_redr_status

	w_ru_cursor: PD_POS_T assign set_w_ru_cursor

	w_ru_virtcol: INTEGER_32 assign set_w_ru_virtcol

	w_ru_topline: INTEGER_32 assign set_w_ru_topline

	w_ru_line_count: INTEGER_32 assign set_w_ru_line_count

	w_ru_topfill: INTEGER_32 assign set_w_ru_topfill

	w_ru_empty: INTEGER_8 assign set_w_ru_empty

	w_alt_fnum: INTEGER_32 assign set_w_alt_fnum

	w_alist: CE_POINTER [PD_ARGLIST] assign set_w_alist

	w_arg_idx: INTEGER_32 assign set_w_arg_idx

	w_arg_idx_invalid: INTEGER_32 assign set_w_arg_idx_invalid

	w_localdir: CE_POINTER [NATURAL_8] assign set_w_localdir

	w_onebuf_opt: PD_WINOPT_T assign set_w_onebuf_opt

	w_allbuf_opt: PD_WINOPT_T assign set_w_allbuf_opt

	w_p_stl_flags: NATURAL_32 assign set_w_p_stl_flags

	w_p_fde_flags: NATURAL_32 assign set_w_p_fde_flags

	w_p_fdt_flags: NATURAL_32 assign set_w_p_fdt_flags

	w_p_cc_cols: CE_POINTER [INTEGER_32] assign set_w_p_cc_cols

	w_scbind_pos: INTEGER_32 assign set_w_scbind_pos

	w_winvar: PD_DICTITEM_S assign set_w_winvar

	w_vars: PD_DICTVAR_S assign set_w_vars

	w_pcmark: PD_POS_T assign set_w_pcmark

	w_prev_pcmark: PD_POS_T assign set_w_prev_pcmark

	w_jumplist: CE_ARRAY [PD_XFILEMARK]

	w_jumplistlen: INTEGER_32 assign set_w_jumplistlen

	w_jumplistidx: INTEGER_32 assign set_w_jumplistidx

	w_changelistidx: INTEGER_32 assign set_w_changelistidx

	w_match_head: CE_POINTER [PD_MATCHITEM] assign set_w_match_head

	w_next_match_id: INTEGER_32 assign set_w_next_match_id

	w_tagstack: CE_ARRAY [PD_TAGGY]

	w_tagstackidx: INTEGER_32 assign set_w_tagstackidx

	w_tagstacklen: INTEGER_32 assign set_w_tagstacklen

	w_fraction: INTEGER_32 assign set_w_fraction

	w_prev_fraction_row: INTEGER_32 assign set_w_prev_fraction_row

	w_scrollbars: CE_ARRAY [PD_GUISCROLLBAR]

	w_nrwidth_line_count: INTEGER_32 assign set_w_nrwidth_line_count

	w_nrwidth_width: INTEGER_32 assign set_w_nrwidth_width

	w_llist: CE_POINTER [PD_QF_INFO_S] assign set_w_llist

	w_llist_ref: CE_POINTER [PD_QF_INFO_S] assign set_w_llist_ref

feature {ANY} -- setters

	set_w_buffer (a_w_buffer: CE_POINTER [PD_FILE_BUFFER])
		do
			w_buffer := a_w_buffer
			update_memory_field ("w_buffer")
		end

	set_w_s (a_w_s: CE_POINTER [PD_SYNBLOCK_T])
		do
			w_s := a_w_s
			update_memory_field ("w_s")
		end

	set_w_prev (a_w_prev: CE_POINTER [PD_WINDOW_S])
		do
			w_prev := a_w_prev
			update_memory_field ("w_prev")
		end

	set_w_next (a_w_next: CE_POINTER [PD_WINDOW_S])
		do
			w_next := a_w_next
			update_memory_field ("w_next")
		end

	set_w_frame (a_w_frame: CE_POINTER [PD_FRAME_S])
		do
			w_frame := a_w_frame
			update_memory_field ("w_frame")
		end

	set_w_cursor (a_w_cursor: PD_POS_T)
		do
			w_cursor := a_w_cursor
			update_memory_field ("w_cursor")
		end

	set_w_curswant (a_w_curswant: INTEGER_32)
		do
			w_curswant := a_w_curswant
			update_memory_field ("w_curswant")
		end

	set_w_set_curswant (a_w_set_curswant: INTEGER_32)
		do
			w_set_curswant := a_w_set_curswant
			update_memory_field ("w_set_curswant")
		end

	set_w_old_visual_mode (a_w_old_visual_mode: INTEGER_8)
		do
			w_old_visual_mode := a_w_old_visual_mode
			update_memory_field ("w_old_visual_mode")
		end

	set_w_old_cursor_lnum (a_w_old_cursor_lnum: INTEGER_32)
		do
			w_old_cursor_lnum := a_w_old_cursor_lnum
			update_memory_field ("w_old_cursor_lnum")
		end

	set_w_old_cursor_fcol (a_w_old_cursor_fcol: INTEGER_32)
		do
			w_old_cursor_fcol := a_w_old_cursor_fcol
			update_memory_field ("w_old_cursor_fcol")
		end

	set_w_old_cursor_lcol (a_w_old_cursor_lcol: INTEGER_32)
		do
			w_old_cursor_lcol := a_w_old_cursor_lcol
			update_memory_field ("w_old_cursor_lcol")
		end

	set_w_old_visual_lnum (a_w_old_visual_lnum: INTEGER_32)
		do
			w_old_visual_lnum := a_w_old_visual_lnum
			update_memory_field ("w_old_visual_lnum")
		end

	set_w_old_visual_col (a_w_old_visual_col: INTEGER_32)
		do
			w_old_visual_col := a_w_old_visual_col
			update_memory_field ("w_old_visual_col")
		end

	set_w_old_curswant (a_w_old_curswant: INTEGER_32)
		do
			w_old_curswant := a_w_old_curswant
			update_memory_field ("w_old_curswant")
		end

	set_w_topline (a_w_topline: INTEGER_32)
		do
			w_topline := a_w_topline
			update_memory_field ("w_topline")
		end

	set_w_topline_was_set (a_w_topline_was_set: INTEGER_8)
		do
			w_topline_was_set := a_w_topline_was_set
			update_memory_field ("w_topline_was_set")
		end

	set_w_topfill (a_w_topfill: INTEGER_32)
		do
			w_topfill := a_w_topfill
			update_memory_field ("w_topfill")
		end

	set_w_old_topfill (a_w_old_topfill: INTEGER_32)
		do
			w_old_topfill := a_w_old_topfill
			update_memory_field ("w_old_topfill")
		end

	set_w_botfill (a_w_botfill: INTEGER_32)
		do
			w_botfill := a_w_botfill
			update_memory_field ("w_botfill")
		end

	set_w_old_botfill (a_w_old_botfill: INTEGER_32)
		do
			w_old_botfill := a_w_old_botfill
			update_memory_field ("w_old_botfill")
		end

	set_w_leftcol (a_w_leftcol: INTEGER_32)
		do
			w_leftcol := a_w_leftcol
			update_memory_field ("w_leftcol")
		end

	set_w_skipcol (a_w_skipcol: INTEGER_32)
		do
			w_skipcol := a_w_skipcol
			update_memory_field ("w_skipcol")
		end

	set_w_winrow (a_w_winrow: INTEGER_32)
		do
			w_winrow := a_w_winrow
			update_memory_field ("w_winrow")
		end

	set_w_height (a_w_height: INTEGER_32)
		do
			w_height := a_w_height
			update_memory_field ("w_height")
		end

	set_w_status_height (a_w_status_height: INTEGER_32)
		do
			w_status_height := a_w_status_height
			update_memory_field ("w_status_height")
		end

	set_w_wincol (a_w_wincol: INTEGER_32)
		do
			w_wincol := a_w_wincol
			update_memory_field ("w_wincol")
		end

	set_w_width (a_w_width: INTEGER_32)
		do
			w_width := a_w_width
			update_memory_field ("w_width")
		end

	set_w_vsep_width (a_w_vsep_width: INTEGER_32)
		do
			w_vsep_width := a_w_vsep_width
			update_memory_field ("w_vsep_width")
		end

	set_w_valid (a_w_valid: INTEGER_32)
		do
			w_valid := a_w_valid
			update_memory_field ("w_valid")
		end

	set_w_valid_cursor (a_w_valid_cursor: PD_POS_T)
		do
			w_valid_cursor := a_w_valid_cursor
			update_memory_field ("w_valid_cursor")
		end

	set_w_valid_leftcol (a_w_valid_leftcol: INTEGER_32)
		do
			w_valid_leftcol := a_w_valid_leftcol
			update_memory_field ("w_valid_leftcol")
		end

	set_w_cline_height (a_w_cline_height: INTEGER_32)
		do
			w_cline_height := a_w_cline_height
			update_memory_field ("w_cline_height")
		end

	set_w_cline_folded (a_w_cline_folded: INTEGER_32)
		do
			w_cline_folded := a_w_cline_folded
			update_memory_field ("w_cline_folded")
		end

	set_w_cline_row (a_w_cline_row: INTEGER_32)
		do
			w_cline_row := a_w_cline_row
			update_memory_field ("w_cline_row")
		end

	set_w_virtcol (a_w_virtcol: INTEGER_32)
		do
			w_virtcol := a_w_virtcol
			update_memory_field ("w_virtcol")
		end

	set_w_wrow (a_w_wrow: INTEGER_32)
		do
			w_wrow := a_w_wrow
			update_memory_field ("w_wrow")
		end

	set_w_wcol (a_w_wcol: INTEGER_32)
		do
			w_wcol := a_w_wcol
			update_memory_field ("w_wcol")
		end

	set_w_botline (a_w_botline: INTEGER_32)
		do
			w_botline := a_w_botline
			update_memory_field ("w_botline")
		end

	set_w_empty_rows (a_w_empty_rows: INTEGER_32)
		do
			w_empty_rows := a_w_empty_rows
			update_memory_field ("w_empty_rows")
		end

	set_w_filler_rows (a_w_filler_rows: INTEGER_32)
		do
			w_filler_rows := a_w_filler_rows
			update_memory_field ("w_filler_rows")
		end

	set_w_lines_valid (a_w_lines_valid: INTEGER_32)
		do
			w_lines_valid := a_w_lines_valid
			update_memory_field ("w_lines_valid")
		end

	set_w_lines (a_w_lines: CE_POINTER [PD_W_LINE])
		do
			w_lines := a_w_lines
			update_memory_field ("w_lines")
		end

	set_w_folds (a_w_folds: PD_GROWARRAY)
		do
			w_folds := a_w_folds
			update_memory_field ("w_folds")
		end

	set_w_fold_manual (a_w_fold_manual: INTEGER_8)
		do
			w_fold_manual := a_w_fold_manual
			update_memory_field ("w_fold_manual")
		end

	set_w_foldinvalid (a_w_foldinvalid: INTEGER_8)
		do
			w_foldinvalid := a_w_foldinvalid
			update_memory_field ("w_foldinvalid")
		end

	set_w_nrwidth (a_w_nrwidth: INTEGER_32)
		do
			w_nrwidth := a_w_nrwidth
			update_memory_field ("w_nrwidth")
		end

	set_w_redr_type (a_w_redr_type: INTEGER_32)
		do
			w_redr_type := a_w_redr_type
			update_memory_field ("w_redr_type")
		end

	set_w_upd_rows (a_w_upd_rows: INTEGER_32)
		do
			w_upd_rows := a_w_upd_rows
			update_memory_field ("w_upd_rows")
		end

	set_w_redraw_top (a_w_redraw_top: INTEGER_32)
		do
			w_redraw_top := a_w_redraw_top
			update_memory_field ("w_redraw_top")
		end

	set_w_redraw_bot (a_w_redraw_bot: INTEGER_32)
		do
			w_redraw_bot := a_w_redraw_bot
			update_memory_field ("w_redraw_bot")
		end

	set_w_redr_status (a_w_redr_status: INTEGER_32)
		do
			w_redr_status := a_w_redr_status
			update_memory_field ("w_redr_status")
		end

	set_w_ru_cursor (a_w_ru_cursor: PD_POS_T)
		do
			w_ru_cursor := a_w_ru_cursor
			update_memory_field ("w_ru_cursor")
		end

	set_w_ru_virtcol (a_w_ru_virtcol: INTEGER_32)
		do
			w_ru_virtcol := a_w_ru_virtcol
			update_memory_field ("w_ru_virtcol")
		end

	set_w_ru_topline (a_w_ru_topline: INTEGER_32)
		do
			w_ru_topline := a_w_ru_topline
			update_memory_field ("w_ru_topline")
		end

	set_w_ru_line_count (a_w_ru_line_count: INTEGER_32)
		do
			w_ru_line_count := a_w_ru_line_count
			update_memory_field ("w_ru_line_count")
		end

	set_w_ru_topfill (a_w_ru_topfill: INTEGER_32)
		do
			w_ru_topfill := a_w_ru_topfill
			update_memory_field ("w_ru_topfill")
		end

	set_w_ru_empty (a_w_ru_empty: INTEGER_8)
		do
			w_ru_empty := a_w_ru_empty
			update_memory_field ("w_ru_empty")
		end

	set_w_alt_fnum (a_w_alt_fnum: INTEGER_32)
		do
			w_alt_fnum := a_w_alt_fnum
			update_memory_field ("w_alt_fnum")
		end

	set_w_alist (a_w_alist: CE_POINTER [PD_ARGLIST])
		do
			w_alist := a_w_alist
			update_memory_field ("w_alist")
		end

	set_w_arg_idx (a_w_arg_idx: INTEGER_32)
		do
			w_arg_idx := a_w_arg_idx
			update_memory_field ("w_arg_idx")
		end

	set_w_arg_idx_invalid (a_w_arg_idx_invalid: INTEGER_32)
		do
			w_arg_idx_invalid := a_w_arg_idx_invalid
			update_memory_field ("w_arg_idx_invalid")
		end

	set_w_localdir (a_w_localdir: CE_POINTER [NATURAL_8])
		do
			w_localdir := a_w_localdir
			update_memory_field ("w_localdir")
		end

	set_w_onebuf_opt (a_w_onebuf_opt: PD_WINOPT_T)
		do
			w_onebuf_opt := a_w_onebuf_opt
			update_memory_field ("w_onebuf_opt")
		end

	set_w_allbuf_opt (a_w_allbuf_opt: PD_WINOPT_T)
		do
			w_allbuf_opt := a_w_allbuf_opt
			update_memory_field ("w_allbuf_opt")
		end

	set_w_p_stl_flags (a_w_p_stl_flags: NATURAL_32)
		do
			w_p_stl_flags := a_w_p_stl_flags
			update_memory_field ("w_p_stl_flags")
		end

	set_w_p_fde_flags (a_w_p_fde_flags: NATURAL_32)
		do
			w_p_fde_flags := a_w_p_fde_flags
			update_memory_field ("w_p_fde_flags")
		end

	set_w_p_fdt_flags (a_w_p_fdt_flags: NATURAL_32)
		do
			w_p_fdt_flags := a_w_p_fdt_flags
			update_memory_field ("w_p_fdt_flags")
		end

	set_w_p_cc_cols (a_w_p_cc_cols: CE_POINTER [INTEGER_32])
		do
			w_p_cc_cols := a_w_p_cc_cols
			update_memory_field ("w_p_cc_cols")
		end

	set_w_scbind_pos (a_w_scbind_pos: INTEGER_32)
		do
			w_scbind_pos := a_w_scbind_pos
			update_memory_field ("w_scbind_pos")
		end

	set_w_winvar (a_w_winvar: PD_DICTITEM_S)
		do
			w_winvar := a_w_winvar
			update_memory_field ("w_winvar")
		end

	set_w_vars (a_w_vars: PD_DICTVAR_S)
		do
			w_vars := a_w_vars
			update_memory_field ("w_vars")
		end

	set_w_pcmark (a_w_pcmark: PD_POS_T)
		do
			w_pcmark := a_w_pcmark
			update_memory_field ("w_pcmark")
		end

	set_w_prev_pcmark (a_w_prev_pcmark: PD_POS_T)
		do
			w_prev_pcmark := a_w_prev_pcmark
			update_memory_field ("w_prev_pcmark")
		end

	set_w_jumplistlen (a_w_jumplistlen: INTEGER_32)
		do
			w_jumplistlen := a_w_jumplistlen
			update_memory_field ("w_jumplistlen")
		end

	set_w_jumplistidx (a_w_jumplistidx: INTEGER_32)
		do
			w_jumplistidx := a_w_jumplistidx
			update_memory_field ("w_jumplistidx")
		end

	set_w_changelistidx (a_w_changelistidx: INTEGER_32)
		do
			w_changelistidx := a_w_changelistidx
			update_memory_field ("w_changelistidx")
		end

	set_w_match_head (a_w_match_head: CE_POINTER [PD_MATCHITEM])
		do
			w_match_head := a_w_match_head
			update_memory_field ("w_match_head")
		end

	set_w_next_match_id (a_w_next_match_id: INTEGER_32)
		do
			w_next_match_id := a_w_next_match_id
			update_memory_field ("w_next_match_id")
		end

	set_w_tagstackidx (a_w_tagstackidx: INTEGER_32)
		do
			w_tagstackidx := a_w_tagstackidx
			update_memory_field ("w_tagstackidx")
		end

	set_w_tagstacklen (a_w_tagstacklen: INTEGER_32)
		do
			w_tagstacklen := a_w_tagstacklen
			update_memory_field ("w_tagstacklen")
		end

	set_w_fraction (a_w_fraction: INTEGER_32)
		do
			w_fraction := a_w_fraction
			update_memory_field ("w_fraction")
		end

	set_w_prev_fraction_row (a_w_prev_fraction_row: INTEGER_32)
		do
			w_prev_fraction_row := a_w_prev_fraction_row
			update_memory_field ("w_prev_fraction_row")
		end

	set_w_nrwidth_line_count (a_w_nrwidth_line_count: INTEGER_32)
		do
			w_nrwidth_line_count := a_w_nrwidth_line_count
			update_memory_field ("w_nrwidth_line_count")
		end

	set_w_nrwidth_width (a_w_nrwidth_width: INTEGER_32)
		do
			w_nrwidth_width := a_w_nrwidth_width
			update_memory_field ("w_nrwidth_width")
		end

	set_w_llist (a_w_llist: CE_POINTER [PD_QF_INFO_S])
		do
			w_llist := a_w_llist
			update_memory_field ("w_llist")
		end

	set_w_llist_ref (a_w_llist_ref: CE_POINTER [PD_QF_INFO_S])
		do
			w_llist_ref := a_w_llist_ref
			update_memory_field ("w_llist_ref")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			w_buffer := a_other.w_buffer
			w_s := a_other.w_s
			w_prev := a_other.w_prev
			w_next := a_other.w_next
			w_frame := a_other.w_frame
			w_cursor := a_other.w_cursor.twin
			w_curswant := a_other.w_curswant
			w_set_curswant := a_other.w_set_curswant
			w_old_visual_mode := a_other.w_old_visual_mode
			w_old_cursor_lnum := a_other.w_old_cursor_lnum
			w_old_cursor_fcol := a_other.w_old_cursor_fcol
			w_old_cursor_lcol := a_other.w_old_cursor_lcol
			w_old_visual_lnum := a_other.w_old_visual_lnum
			w_old_visual_col := a_other.w_old_visual_col
			w_old_curswant := a_other.w_old_curswant
			w_topline := a_other.w_topline
			w_topline_was_set := a_other.w_topline_was_set
			w_topfill := a_other.w_topfill
			w_old_topfill := a_other.w_old_topfill
			w_botfill := a_other.w_botfill
			w_old_botfill := a_other.w_old_botfill
			w_leftcol := a_other.w_leftcol
			w_skipcol := a_other.w_skipcol
			w_winrow := a_other.w_winrow
			w_height := a_other.w_height
			w_status_height := a_other.w_status_height
			w_wincol := a_other.w_wincol
			w_width := a_other.w_width
			w_vsep_width := a_other.w_vsep_width
			w_valid := a_other.w_valid
			w_valid_cursor := a_other.w_valid_cursor.twin
			w_valid_leftcol := a_other.w_valid_leftcol
			w_cline_height := a_other.w_cline_height
			w_cline_folded := a_other.w_cline_folded
			w_cline_row := a_other.w_cline_row
			w_virtcol := a_other.w_virtcol
			w_wrow := a_other.w_wrow
			w_wcol := a_other.w_wcol
			w_botline := a_other.w_botline
			w_empty_rows := a_other.w_empty_rows
			w_filler_rows := a_other.w_filler_rows
			w_lines_valid := a_other.w_lines_valid
			w_lines := a_other.w_lines
			w_folds := a_other.w_folds.twin
			w_fold_manual := a_other.w_fold_manual
			w_foldinvalid := a_other.w_foldinvalid
			w_nrwidth := a_other.w_nrwidth
			w_redr_type := a_other.w_redr_type
			w_upd_rows := a_other.w_upd_rows
			w_redraw_top := a_other.w_redraw_top
			w_redraw_bot := a_other.w_redraw_bot
			w_redr_status := a_other.w_redr_status
			w_ru_cursor := a_other.w_ru_cursor.twin
			w_ru_virtcol := a_other.w_ru_virtcol
			w_ru_topline := a_other.w_ru_topline
			w_ru_line_count := a_other.w_ru_line_count
			w_ru_topfill := a_other.w_ru_topfill
			w_ru_empty := a_other.w_ru_empty
			w_alt_fnum := a_other.w_alt_fnum
			w_alist := a_other.w_alist
			w_arg_idx := a_other.w_arg_idx
			w_arg_idx_invalid := a_other.w_arg_idx_invalid
			w_localdir := a_other.w_localdir
			w_onebuf_opt := a_other.w_onebuf_opt.twin
			w_allbuf_opt := a_other.w_allbuf_opt.twin
			w_p_stl_flags := a_other.w_p_stl_flags
			w_p_fde_flags := a_other.w_p_fde_flags
			w_p_fdt_flags := a_other.w_p_fdt_flags
			w_p_cc_cols := a_other.w_p_cc_cols
			w_scbind_pos := a_other.w_scbind_pos
			w_winvar := a_other.w_winvar.twin
			w_vars := a_other.w_vars.twin
			w_pcmark := a_other.w_pcmark.twin
			w_prev_pcmark := a_other.w_prev_pcmark.twin
			w_jumplist := a_other.w_jumplist.twin
			w_jumplistlen := a_other.w_jumplistlen
			w_jumplistidx := a_other.w_jumplistidx
			w_changelistidx := a_other.w_changelistidx
			w_match_head := a_other.w_match_head
			w_next_match_id := a_other.w_next_match_id
			w_tagstack := a_other.w_tagstack.twin
			w_tagstackidx := a_other.w_tagstackidx
			w_tagstacklen := a_other.w_tagstacklen
			w_fraction := a_other.w_fraction
			w_prev_fraction_row := a_other.w_prev_fraction_row
			w_scrollbars := a_other.w_scrollbars.twin
			w_nrwidth_line_count := a_other.w_nrwidth_line_count
			w_nrwidth_width := a_other.w_nrwidth_width
			w_llist := a_other.w_llist
			w_llist_ref := a_other.w_llist_ref
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				w_buffer.is_equal (a_other.w_buffer) and
				w_s.is_equal (a_other.w_s) and
				w_prev.is_equal (a_other.w_prev) and
				w_next.is_equal (a_other.w_next) and
				w_frame.is_equal (a_other.w_frame) and
				w_cursor.is_equal (a_other.w_cursor) and
				w_curswant = a_other.w_curswant and
				w_set_curswant = a_other.w_set_curswant and
				w_old_visual_mode = a_other.w_old_visual_mode and
				w_old_cursor_lnum = a_other.w_old_cursor_lnum and
				w_old_cursor_fcol = a_other.w_old_cursor_fcol and
				w_old_cursor_lcol = a_other.w_old_cursor_lcol and
				w_old_visual_lnum = a_other.w_old_visual_lnum and
				w_old_visual_col = a_other.w_old_visual_col and
				w_old_curswant = a_other.w_old_curswant and
				w_topline = a_other.w_topline and
				w_topline_was_set = a_other.w_topline_was_set and
				w_topfill = a_other.w_topfill and
				w_old_topfill = a_other.w_old_topfill and
				w_botfill = a_other.w_botfill and
				w_old_botfill = a_other.w_old_botfill and
				w_leftcol = a_other.w_leftcol and
				w_skipcol = a_other.w_skipcol and
				w_winrow = a_other.w_winrow and
				w_height = a_other.w_height and
				w_status_height = a_other.w_status_height and
				w_wincol = a_other.w_wincol and
				w_width = a_other.w_width and
				w_vsep_width = a_other.w_vsep_width and
				w_valid = a_other.w_valid and
				w_valid_cursor.is_equal (a_other.w_valid_cursor) and
				w_valid_leftcol = a_other.w_valid_leftcol and
				w_cline_height = a_other.w_cline_height and
				w_cline_folded = a_other.w_cline_folded and
				w_cline_row = a_other.w_cline_row and
				w_virtcol = a_other.w_virtcol and
				w_wrow = a_other.w_wrow and
				w_wcol = a_other.w_wcol and
				w_botline = a_other.w_botline and
				w_empty_rows = a_other.w_empty_rows and
				w_filler_rows = a_other.w_filler_rows and
				w_lines_valid = a_other.w_lines_valid and
				w_lines.is_equal (a_other.w_lines) and
				w_folds.is_equal (a_other.w_folds) and
				w_fold_manual = a_other.w_fold_manual and
				w_foldinvalid = a_other.w_foldinvalid and
				w_nrwidth = a_other.w_nrwidth and
				w_redr_type = a_other.w_redr_type and
				w_upd_rows = a_other.w_upd_rows and
				w_redraw_top = a_other.w_redraw_top and
				w_redraw_bot = a_other.w_redraw_bot and
				w_redr_status = a_other.w_redr_status and
				w_ru_cursor.is_equal (a_other.w_ru_cursor) and
				w_ru_virtcol = a_other.w_ru_virtcol and
				w_ru_topline = a_other.w_ru_topline and
				w_ru_line_count = a_other.w_ru_line_count and
				w_ru_topfill = a_other.w_ru_topfill and
				w_ru_empty = a_other.w_ru_empty and
				w_alt_fnum = a_other.w_alt_fnum and
				w_alist.is_equal (a_other.w_alist) and
				w_arg_idx = a_other.w_arg_idx and
				w_arg_idx_invalid = a_other.w_arg_idx_invalid and
				w_localdir.is_equal (a_other.w_localdir) and
				w_onebuf_opt.is_equal (a_other.w_onebuf_opt) and
				w_allbuf_opt.is_equal (a_other.w_allbuf_opt) and
				w_p_stl_flags = a_other.w_p_stl_flags and
				w_p_fde_flags = a_other.w_p_fde_flags and
				w_p_fdt_flags = a_other.w_p_fdt_flags and
				w_p_cc_cols.is_equal (a_other.w_p_cc_cols) and
				w_scbind_pos = a_other.w_scbind_pos and
				w_winvar.is_equal (a_other.w_winvar) and
				w_vars.is_equal (a_other.w_vars) and
				w_pcmark.is_equal (a_other.w_pcmark) and
				w_prev_pcmark.is_equal (a_other.w_prev_pcmark) and
				w_jumplist.is_equal (a_other.w_jumplist) and
				w_jumplistlen = a_other.w_jumplistlen and
				w_jumplistidx = a_other.w_jumplistidx and
				w_changelistidx = a_other.w_changelistidx and
				w_match_head.is_equal (a_other.w_match_head) and
				w_next_match_id = a_other.w_next_match_id and
				w_tagstack.is_equal (a_other.w_tagstack) and
				w_tagstackidx = a_other.w_tagstackidx and
				w_tagstacklen = a_other.w_tagstacklen and
				w_fraction = a_other.w_fraction and
				w_prev_fraction_row = a_other.w_prev_fraction_row and
				w_scrollbars.is_equal (a_other.w_scrollbars) and
				w_nrwidth_line_count = a_other.w_nrwidth_line_count and
				w_nrwidth_width = a_other.w_nrwidth_width and
				w_llist.is_equal (a_other.w_llist) and
				w_llist_ref.is_equal (a_other.w_llist_ref)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("w_buffer"),
					create {CE_STRUCTURE_FIELD}.make ("w_s"),
					create {CE_STRUCTURE_FIELD}.make ("w_prev"),
					create {CE_STRUCTURE_FIELD}.make ("w_next"),
					create {CE_STRUCTURE_FIELD}.make ("w_frame"),
					create {CE_STRUCTURE_FIELD}.make ("w_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("w_curswant"),
					create {CE_STRUCTURE_FIELD}.make ("w_set_curswant"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_visual_mode"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_cursor_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_cursor_fcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_cursor_lcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_visual_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_visual_col"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_curswant"),
					create {CE_STRUCTURE_FIELD}.make ("w_topline"),
					create {CE_STRUCTURE_FIELD}.make ("w_topline_was_set"),
					create {CE_STRUCTURE_FIELD}.make ("w_topfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_topfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_botfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_botfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_leftcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_skipcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_winrow"),
					create {CE_STRUCTURE_FIELD}.make ("w_height"),
					create {CE_STRUCTURE_FIELD}.make ("w_status_height"),
					create {CE_STRUCTURE_FIELD}.make ("w_wincol"),
					create {CE_STRUCTURE_FIELD}.make ("w_width"),
					create {CE_STRUCTURE_FIELD}.make ("w_vsep_width"),
					create {CE_STRUCTURE_FIELD}.make ("w_valid"),
					create {CE_STRUCTURE_FIELD}.make ("w_valid_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("w_valid_leftcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_cline_height"),
					create {CE_STRUCTURE_FIELD}.make ("w_cline_folded"),
					create {CE_STRUCTURE_FIELD}.make ("w_cline_row"),
					create {CE_STRUCTURE_FIELD}.make ("w_virtcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_wrow"),
					create {CE_STRUCTURE_FIELD}.make ("w_wcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_botline"),
					create {CE_STRUCTURE_FIELD}.make ("w_empty_rows"),
					create {CE_STRUCTURE_FIELD}.make ("w_filler_rows"),
					create {CE_STRUCTURE_FIELD}.make ("w_lines_valid"),
					create {CE_STRUCTURE_FIELD}.make ("w_lines"),
					create {CE_STRUCTURE_FIELD}.make ("w_folds"),
					create {CE_STRUCTURE_FIELD}.make ("w_fold_manual"),
					create {CE_STRUCTURE_FIELD}.make ("w_foldinvalid"),
					create {CE_STRUCTURE_FIELD}.make ("w_nrwidth"),
					create {CE_STRUCTURE_FIELD}.make ("w_redr_type"),
					create {CE_STRUCTURE_FIELD}.make ("w_upd_rows"),
					create {CE_STRUCTURE_FIELD}.make ("w_redraw_top"),
					create {CE_STRUCTURE_FIELD}.make ("w_redraw_bot"),
					create {CE_STRUCTURE_FIELD}.make ("w_redr_status"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_virtcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_topline"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_line_count"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_topfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_empty"),
					create {CE_STRUCTURE_FIELD}.make ("w_alt_fnum"),
					create {CE_STRUCTURE_FIELD}.make ("w_alist"),
					create {CE_STRUCTURE_FIELD}.make ("w_arg_idx"),
					create {CE_STRUCTURE_FIELD}.make ("w_arg_idx_invalid"),
					create {CE_STRUCTURE_FIELD}.make ("w_localdir"),
					create {CE_STRUCTURE_FIELD}.make ("w_onebuf_opt"),
					create {CE_STRUCTURE_FIELD}.make ("w_allbuf_opt"),
					create {CE_STRUCTURE_FIELD}.make ("w_p_stl_flags"),
					create {CE_STRUCTURE_FIELD}.make ("w_p_fde_flags"),
					create {CE_STRUCTURE_FIELD}.make ("w_p_fdt_flags"),
					create {CE_STRUCTURE_FIELD}.make ("w_p_cc_cols"),
					create {CE_STRUCTURE_FIELD}.make ("w_scbind_pos"),
					create {CE_STRUCTURE_FIELD}.make ("w_winvar"),
					create {CE_STRUCTURE_FIELD}.make ("w_vars"),
					create {CE_STRUCTURE_FIELD}.make ("w_pcmark"),
					create {CE_STRUCTURE_FIELD}.make ("w_prev_pcmark"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("w_jumplist", <<100>>),
					create {CE_STRUCTURE_FIELD}.make ("w_jumplistlen"),
					create {CE_STRUCTURE_FIELD}.make ("w_jumplistidx"),
					create {CE_STRUCTURE_FIELD}.make ("w_changelistidx"),
					create {CE_STRUCTURE_FIELD}.make ("w_match_head"),
					create {CE_STRUCTURE_FIELD}.make ("w_next_match_id"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("w_tagstack", <<20>>),
					create {CE_STRUCTURE_FIELD}.make ("w_tagstackidx"),
					create {CE_STRUCTURE_FIELD}.make ("w_tagstacklen"),
					create {CE_STRUCTURE_FIELD}.make ("w_fraction"),
					create {CE_STRUCTURE_FIELD}.make ("w_prev_fraction_row"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("w_scrollbars", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("w_nrwidth_line_count"),
					create {CE_STRUCTURE_FIELD}.make ("w_nrwidth_width"),
					create {CE_STRUCTURE_FIELD}.make ("w_llist"),
					create {CE_STRUCTURE_FIELD}.make ("w_llist_ref")
				>>)
			init_structure_info
		end

end
