class
	PD_WORDNODE_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create wn_u1.make
			create wn_u2.make
			create wn_child.make
			create wn_sibling.make
		end

feature {ANY} -- fields

	wn_u1: PD_WN_U1 assign set_wn_u1

	wn_u2: PD_WN_U2 assign set_wn_u2

	wn_child: CE_POINTER [PD_WORDNODE_S] assign set_wn_child

	wn_sibling: CE_POINTER [PD_WORDNODE_S] assign set_wn_sibling

	wn_refs: INTEGER_32 assign set_wn_refs

	wn_byte: NATURAL_8 assign set_wn_byte

	wn_affixID: NATURAL_8 assign set_wn_affixID

	wn_flags: NATURAL_16 assign set_wn_flags

	wn_region: INTEGER_16 assign set_wn_region

feature {ANY} -- setters

	set_wn_u1 (a_wn_u1: PD_WN_U1)
		do
			wn_u1 := a_wn_u1
			update_memory_field ("wn_u1")
		end

	set_wn_u2 (a_wn_u2: PD_WN_U2)
		do
			wn_u2 := a_wn_u2
			update_memory_field ("wn_u2")
		end

	set_wn_child (a_wn_child: CE_POINTER [PD_WORDNODE_S])
		do
			wn_child := a_wn_child
			update_memory_field ("wn_child")
		end

	set_wn_sibling (a_wn_sibling: CE_POINTER [PD_WORDNODE_S])
		do
			wn_sibling := a_wn_sibling
			update_memory_field ("wn_sibling")
		end

	set_wn_refs (a_wn_refs: INTEGER_32)
		do
			wn_refs := a_wn_refs
			update_memory_field ("wn_refs")
		end

	set_wn_byte (a_wn_byte: NATURAL_8)
		do
			wn_byte := a_wn_byte
			update_memory_field ("wn_byte")
		end

	set_wn_affixID (a_wn_affixID: NATURAL_8)
		do
			wn_affixID := a_wn_affixID
			update_memory_field ("wn_affixID")
		end

	set_wn_flags (a_wn_flags: NATURAL_16)
		do
			wn_flags := a_wn_flags
			update_memory_field ("wn_flags")
		end

	set_wn_region (a_wn_region: INTEGER_16)
		do
			wn_region := a_wn_region
			update_memory_field ("wn_region")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			wn_u1 := a_other.wn_u1.twin
			wn_u2 := a_other.wn_u2.twin
			wn_child := a_other.wn_child
			wn_sibling := a_other.wn_sibling
			wn_refs := a_other.wn_refs
			wn_byte := a_other.wn_byte
			wn_affixID := a_other.wn_affixID
			wn_flags := a_other.wn_flags
			wn_region := a_other.wn_region
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				wn_u1.is_equal (a_other.wn_u1) and
				wn_u2.is_equal (a_other.wn_u2) and
				wn_child.is_equal (a_other.wn_child) and
				wn_sibling.is_equal (a_other.wn_sibling) and
				wn_refs = a_other.wn_refs and
				wn_byte = a_other.wn_byte and
				wn_affixID = a_other.wn_affixID and
				wn_flags = a_other.wn_flags and
				wn_region = a_other.wn_region
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("wn_u1"),
					create {CE_STRUCTURE_FIELD}.make ("wn_u2"),
					create {CE_STRUCTURE_FIELD}.make ("wn_child"),
					create {CE_STRUCTURE_FIELD}.make ("wn_sibling"),
					create {CE_STRUCTURE_FIELD}.make ("wn_refs"),
					create {CE_STRUCTURE_FIELD}.make ("wn_byte"),
					create {CE_STRUCTURE_FIELD}.make ("wn_affixID"),
					create {CE_STRUCTURE_FIELD}.make ("wn_flags"),
					create {CE_STRUCTURE_FIELD}.make ("wn_region")
				>>)
			init_structure_info
		end

end
