class
	PD_XFILEMARK

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fmark.make
			create fname.make
		end

feature {ANY} -- fields

	fmark: PD_FILEMARK assign set_fmark

	fname: CE_POINTER [NATURAL_8] assign set_fname

feature {ANY} -- setters

	set_fmark (a_fmark: PD_FILEMARK)
		do
			fmark := a_fmark
			update_memory_field ("fmark")
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			fname := a_fname
			update_memory_field ("fname")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fmark := a_other.fmark.twin
			fname := a_other.fname
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fmark.is_equal (a_other.fmark) and
				fname.is_equal (a_other.fname)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fmark"),
					create {CE_STRUCTURE_FIELD}.make ("fname")
				>>)
			init_structure_info
		end

end
