class
	P_EX_EVAL

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	cause_abort: INTEGER_32 assign set_cause_abort

	set_cause_abort (a_cause_abort: INTEGER_32)
		do
			cause_abort := a_cause_abort
		end

feature {ANY} -- routines

	aborted_in_try: INTEGER_32
		do
			Result := globals_inst.force_abort
		end

	aborting: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (globals_inst.did_emsg.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.force_abort.to_boolean then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if globals_inst.got_int.to_boolean then
							l_tmp := 1
						elseif globals_inst.did_throw.to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 4 then
					Result := l_tmp
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	catch_exception (a_excp: CE_POINTER [PD_VIM_EXCEPTION])
		local
			l_save_msg_silent: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_excp.item.caught := globals_inst.caught_stack
					globals_inst.caught_stack := a_excp
					eval_inst.set_vim_var_string (29, a_excp.item.value, -1)
					if ((a_excp.item.throw_name).item).to_integer_32 /= 0 then
						if a_excp.item.throw_lnum /= 0 then
							message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("%%s, line %%ld"))), a_excp.item.throw_name, a_excp.item.throw_lnum]).do_nothing
						else
							message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("%%s"), a_excp.item.throw_name]).do_nothing
						end
						eval_inst.set_vim_var_string (30, globals_inst.IObuff, -1)
					else
						eval_inst.set_vim_var_string (30, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
					end
					if not (option_inst.p_verbose.item >= 13) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (globals_inst.debug_break_level > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_save_msg_silent := globals_inst.msg_silent
						if globals_inst.debug_break_level > 0 then
							globals_inst.msg_silent := 0
						else
							message_inst.verbose_enter
						end
						globals_inst.no_wait_return := globals_inst.no_wait_return + 1
						if globals_inst.debug_break_level > 0 then
							globals_inst.msg_scroll := 1
						elseif (option_inst.p_vfile.item.item).to_integer_32 = 0 then
							globals_inst.msg_scroll := 1
						end
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Exception caught: %%s")))), a_excp.item.value]).do_nothing
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
						if globals_inst.debug_break_level > 0 then
							globals_inst.cmdline_row := globals_inst.msg_row
						elseif (option_inst.p_vfile.item.item).to_integer_32 = 0 then
							globals_inst.cmdline_row := globals_inst.msg_row
						end
						globals_inst.no_wait_return := globals_inst.no_wait_return - 1
						if globals_inst.debug_break_level > 0 then
							globals_inst.msg_silent := l_save_msg_silent
						else
							message_inst.verbose_leave
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cause_errthrow (a_mesg: CE_POINTER [NATURAL_8]; a_severe: INTEGER_32; a_ignore___0: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_elem: CE_POINTER [PD_MSGLIST]
			l_plist: CE_POINTER [CE_POINTER [PD_MSGLIST]]
			l_tmsg: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_elem.make
			create l_plist.make
			create l_tmsg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.suppress_errthrow.to_boolean then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not globals_inst.did_emsg.to_boolean then
							cause_abort := globals_inst.force_abort
							globals_inst.force_abort := 0
						end
						if globals_inst.trylevel /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not cause_abort.to_boolean then
							l_pos := -1 + 5 -- goto _L
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else: | _L___0:
						if not (globals_inst.emsg_silent.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not globals_inst.did_throw.to_boolean then
							Result := 0
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called then
							if a_mesg.is_equal ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr)))) then
								a_ignore___0.item := 1
								Result := 1
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 7 then -- if:
							cause_abort := 1
							if globals_inst.did_throw.to_boolean then
								if globals_inst.current_exception.item.type = 2 then
									globals_inst.got_int := 0
								end
								discard_current_exception
							end
							if globals_inst.msg_list.is_void then
								l_pos := -1 + 19 -- skip if block
							end
				when 8 then -- if:
							l_plist := globals_inst.msg_list
							from
							until
								(l_plist.item).is_void
							loop
								l_plist := create {CE_POINTER [CE_POINTER [PD_MSGLIST]]}.make_shared ((l_plist.item).c_pointer + (create {PD_MSGLIST}.make).offset_of ("next"))
							end
							l_elem := create {CE_POINTER [PD_MSGLIST]}.make_cast ((misc2_inst.alloc ((create {PD_MSGLIST}.make).structure_size.to_natural_32)))
							if not (l_elem.is_void) then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							globals_inst.suppress_errthrow := 1
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_outofmem))))).do_nothing
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 11 then -- else:
							l_elem.item.msg := misc2_inst.vim_strsave (a_mesg)
							if not ((l_elem.item.msg).is_void) then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_elem))
							globals_inst.suppress_errthrow := 1
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_outofmem))))).do_nothing
				when 13 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 14 then -- else:
							l_elem.item.next := create {CE_POINTER [PD_MSGLIST]}.make_shared (default_pointer)
							l_elem.item.throw_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_plist.item := l_elem
							if not (l_plist.is_equal (globals_inst.msg_list)) then
								l_pos := -1 + 17 -- skip if block
							end
				when 15 then -- if:
							l_pos := -1 + 18 -- goto _L___1
				when 16 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 17 then -- else:
							if not (a_severe.to_boolean) then
								l_pos := -1 + 19 -- skip if block
							end
				when 18 then -- if: | _L___1:
							l_tmsg := l_elem.item.msg
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmsg), ce_string ("Vim E"), (5).to_natural_32)) = 0 then
								if (l_tmsg[5]).to_integer_32 >= 48 then
									if (l_tmsg[5]).to_integer_32 <= 57 then
										if (l_tmsg[6]).to_integer_32 >= 48 then
											if (l_tmsg[6]).to_integer_32 <= 57 then
												if (l_tmsg[7]).to_integer_32 >= 48 then
													if (l_tmsg[7]).to_integer_32 <= 57 then
														if (l_tmsg[8]).to_integer_32 = 58 then
															if (l_tmsg[9]).to_integer_32 = 32 then
																(globals_inst.msg_list.item).item.throw_msg := l_tmsg + 4
															else
																(globals_inst.msg_list.item).item.throw_msg := l_tmsg
															end
														else
															(globals_inst.msg_list.item).item.throw_msg := l_tmsg
														end
													else
														(globals_inst.msg_list.item).item.throw_msg := l_tmsg
													end
												else
													(globals_inst.msg_list.item).item.throw_msg := l_tmsg
												end
											else
												(globals_inst.msg_list.item).item.throw_msg := l_tmsg
											end
										else
											(globals_inst.msg_list.item).item.throw_msg := l_tmsg
										end
									else
										(globals_inst.msg_list.item).item.throw_msg := l_tmsg
									end
								else
									(globals_inst.msg_list.item).item.throw_msg := l_tmsg
								end
							else
								(globals_inst.msg_list.item).item.throw_msg := l_tmsg
							end
				when 19 then -- if done | if done | if done | if done
							Result := 1
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cleanup_conditionals (a_cstack: CE_POINTER [PD_CONDSTACK]; a_searched_cond: INTEGER_32; a_inclusive: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			l_stop: INTEGER_32
			l_elem: CE_POINTER [PD_ESLIST_ELEM]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_elem.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stop := 0
					l_idx := a_cstack.item.cs_idx
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_idx >= 0)) then
						l_pos := -1 + 17 -- skip loop
					end
				when 2 then -- loop body:
						if not ((((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (256)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 3 then -- if:
						if not (globals_inst.did_emsg.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 6 then -- else:
						if not (globals_inst.got_int.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 9 then -- else:
						if not ((((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if: | _L:
						inspect (a_cstack.item.cs_pending[l_idx]).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 11
						when 16 then l_pos := -1 + 12
						when 8 then l_pos := -1 + 12
						when 32 then l_pos := -1 + 12
						when 24 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 11 then -- switch 1, case 0
						l_pos := -1 + 15 -- switch 1; break
				when 12 then -- switch 1, case 16 | switch 1, case 8 | switch 1, case 32
						report_discard_pending ((a_cstack.item.cs_pending[l_idx]).to_integer_32, create {CE_POINTER [ANY]}.make_shared (default_pointer))
						a_cstack.item.cs_pending[l_idx] := (0).to_integer_8
						l_pos := -1 + 15 -- switch 1; break
				when 13 then -- switch 1, case 24
						report_discard_pending (24, a_cstack.item.cs_pend.csp_rv[l_idx])
						eval_inst.discard_pending_return (a_cstack.item.cs_pend.csp_rv[l_idx])
						a_cstack.item.cs_pending[l_idx] := (0).to_integer_8
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, default:
						if (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean then
							if (((a_cstack.item.cs_pending[l_idx]).to_integer_32).bit_and (4)).to_boolean then
								discard_exception (create {CE_POINTER [PD_VIM_EXCEPTION]}.make_cast (a_cstack.item.cs_pend.csp_ex[l_idx]), 0)
							else
								report_discard_pending ((a_cstack.item.cs_pending[l_idx]).to_integer_32, create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
							a_cstack.item.cs_pending[l_idx] := (0).to_integer_8
						end
						l_pos := -1 + 15 -- switch 1; break
				when 15 then -- switch 1, done: | if done | if done
						if not (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean then
							if (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (2)).to_boolean then
								if (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (2_048)).to_boolean then
									finish_exception (create {CE_POINTER [PD_VIM_EXCEPTION]}.make_cast (a_cstack.item.cs_pend.csp_ex[l_idx]))
								end
							end
							if (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (1)).to_boolean then
								if a_searched_cond = 0 then
									if not a_inclusive.to_boolean then
										js.break
									end
								end
								if not js.loop_jumped then
									l_stop := 1
								end
							end
						end
				when 16 then -- if done
						if not js.loop_jumped and then ((((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (a_searched_cond)).to_boolean) then
							if not a_inclusive.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_stop := 1
							end
						end
						if not js.loop_jumped then
							a_cstack.item.cs_flags[l_idx] := (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (-3)).to_integer_16
							if l_stop.to_boolean then
								if a_searched_cond /= 4_352 then
									js.break
								end
							end
						end
						if not js.loop_jumped then
							if (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (256)).to_boolean then
								if (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (4_096)).to_boolean then
									l_elem := a_cstack.item.cs_emsg_silent_list
									a_cstack.item.cs_emsg_silent_list := l_elem.item.next
									globals_inst.emsg_silent := l_elem.item.saved_emsg_silent
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_elem))
									a_cstack.item.cs_flags[l_idx] := (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (-4_097)).to_integer_16
								end
							end
							if l_stop.to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							l_idx := l_idx - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 17 then -- loop done
					Result := l_idx
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	discard_current_exception
		do
			discard_exception (globals_inst.current_exception, 0)
			globals_inst.current_exception := create {CE_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer)
			globals_inst.did_throw := 0
			globals_inst.need_rethrow := 0
		end

	discard_exception (a_excp: CE_POINTER [PD_VIM_EXCEPTION]; a_was_finished: INTEGER_32)
		local
			l_saved_IObuff: CE_POINTER [NATURAL_8]
			l_save_msg_silent: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_saved_IObuff.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_excp.is_void then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_internal))))).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not (option_inst.p_verbose.item >= 13) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (globals_inst.debug_break_level > 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_save_msg_silent := globals_inst.msg_silent
						l_saved_IObuff := misc2_inst.vim_strsave (globals_inst.IObuff)
						if globals_inst.debug_break_level > 0 then
							globals_inst.msg_silent := 0
						else
							message_inst.verbose_enter
						end
						globals_inst.no_wait_return := globals_inst.no_wait_return + 1
						if globals_inst.debug_break_level > 0 then
							globals_inst.msg_scroll := 1
						elseif (option_inst.p_vfile.item.item).to_integer_32 = 0 then
							globals_inst.msg_scroll := 1
						end
						if a_was_finished.to_boolean then
							l_tmp___2 := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Exception finished: %%s"))))
						else
							l_tmp___2 := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Exception discarded: %%s"))))
						end
						message_inst.smsg ([l_tmp___2, a_excp.item.value]).do_nothing
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
						if globals_inst.debug_break_level > 0 then
							globals_inst.cmdline_row := globals_inst.msg_row
						elseif (option_inst.p_vfile.item.item).to_integer_32 = 0 then
							globals_inst.cmdline_row := globals_inst.msg_row
						end
						globals_inst.no_wait_return := globals_inst.no_wait_return - 1
						if globals_inst.debug_break_level > 0 then
							globals_inst.msg_silent := l_save_msg_silent
						else
							message_inst.verbose_leave
						end
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_saved_IObuff)).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_saved_IObuff))
				when 6 then -- if done
						if a_excp.item.type /= 2 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_excp.item.value))
						end
						if a_excp.item.type = 1 then
							free_msglist (a_excp.item.messages)
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_excp.item.throw_name))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_excp))
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_errthrow (a_cstack: CE_POINTER [PD_CONDSTACK]; a_cmdname: CE_POINTER [NATURAL_8])
		local
			js: JUMP_STATE
		do
			if cause_abort.to_boolean then
				cause_abort := 0
				globals_inst.force_abort := 1
			end
			if globals_inst.msg_list.is_void then
				js.return
			elseif (globals_inst.msg_list.item).is_void then
				js.return
			end
			if not js.return_called then
				if (throw_exception (create {CE_POINTER [ANY]}.make_cast (globals_inst.msg_list.item), 1, a_cmdname)) = 0 then
					free_msglist (globals_inst.msg_list.item)
				elseif not a_cstack.is_void then
					do_throw (a_cstack)
				else
					globals_inst.need_rethrow := 1
				end
				globals_inst.msg_list.item := create {CE_POINTER [PD_MSGLIST]}.make_shared (default_pointer)
			end
		end

	do_intthrow (a_cstack: CE_POINTER [PD_CONDSTACK]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if not globals_inst.got_int.to_boolean then
				Result := 0
				js.return
			elseif globals_inst.trylevel = 0 then
				if not globals_inst.did_throw.to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called and then (globals_inst.did_throw.to_boolean) then
				if globals_inst.current_exception.item.type = 2 then
					Result := 0
					js.return
				end
				if not js.return_called then
					discard_current_exception
				end
			end
			if not js.return_called then
				if (throw_exception (create {CE_POINTER [ANY]}.make_cast (ce_string ("Vim:Interrupt")), 2, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) /= 0 then
					do_throw (a_cstack)
				end
				Result := 1
			end
		end

	do_throw (a_cstack: CE_POINTER [PD_CONDSTACK])
		local
			l_idx: INTEGER_32
			l_inactivate_try: INTEGER_32
		do
			l_inactivate_try := 0
			l_idx := cleanup_conditionals (a_cstack, 0, l_inactivate_try)
			if l_idx >= 0 then
				if not (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (2_048)).to_boolean then
					if (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (2)).to_boolean then
						a_cstack.item.cs_flags[l_idx] := (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_or (1_024)).to_integer_16
					else
						a_cstack.item.cs_flags[l_idx] := (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (-1_025)).to_integer_16
					end
				end
				a_cstack.item.cs_flags[l_idx] := (((a_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (-3)).to_integer_16
				a_cstack.item.cs_pend.csp_ex[l_idx] := create {CE_POINTER [ANY]}.make_cast (globals_inst.current_exception)
			end
			globals_inst.did_throw := 1
		end

	enter_cleanup (a_csp: CE_POINTER [PD_CLEANUP_STUFF])
		local
			l_pending: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pending := 0
					if not (globals_inst.did_emsg.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if not (globals_inst.got_int.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (globals_inst.did_throw.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (globals_inst.need_rethrow.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						if globals_inst.did_emsg.to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
						if globals_inst.got_int.to_boolean then
							l_tmp___0 := 2
						else
							l_tmp___0 := 0
						end
						if globals_inst.did_throw.to_boolean then
							l_tmp___1 := 4
						else
							l_tmp___1 := 0
						end
						if globals_inst.need_rethrow.to_boolean then
							l_tmp___2 := 4
						else
							l_tmp___2 := 0
						end
						a_csp.item.pending := (((((l_tmp).bit_or (l_tmp___0))).bit_or (l_tmp___1))).bit_or (l_tmp___2)
						if globals_inst.did_throw.to_boolean then
							a_csp.item.exception := globals_inst.current_exception
						elseif globals_inst.need_rethrow.to_boolean then
							a_csp.item.exception := globals_inst.current_exception
						else
							a_csp.item.exception := create {CE_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer)
							if globals_inst.did_emsg.to_boolean then
								globals_inst.force_abort := (globals_inst.force_abort).bit_or (cause_abort)
								cause_abort := 0
							end
						end
						globals_inst.need_rethrow := 0
						globals_inst.did_throw := globals_inst.need_rethrow
						globals_inst.got_int := globals_inst.did_throw
						globals_inst.did_emsg := globals_inst.got_int
						report_make_pending (l_pending, create {CE_POINTER [ANY]}.make_cast (a_csp.item.exception))
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						a_csp.item.pending := 0
						a_csp.item.exception := create {CE_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer)
				when 13 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_break (a_eap: CE_POINTER [PD_EXARG])
		local
			l_idx: INTEGER_32
			l_cstack: CE_POINTER [PD_CONDSTACK]
		do
			create l_cstack.make

			l_cstack := a_eap.item.cstack
			if l_cstack.item.cs_looplevel <= 0 then
				a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E587: :break without :while or :for"))
			elseif l_cstack.item.cs_idx < 0 then
				a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E587: :break without :while or :for"))
			else
				l_idx := cleanup_conditionals (l_cstack, 24, 1)
				if l_idx >= 0 then
					if not (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (24)).to_boolean then
						l_cstack.item.cs_pending[l_idx] := (8).to_integer_8
						report_make_pending (8, create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
				end
			end
		end

	ex_break_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_break)
		end

	ex_catch (a_eap: CE_POINTER [PD_EXARG])
		local
			l_idx: INTEGER_32
			l_give_up: INTEGER_32
			l_skip___0: INTEGER_32
			l_caught: INTEGER_32
			l_end: CE_POINTER [NATURAL_8]
			l_save_char: INTEGER_32
			l_save_cpo: CE_POINTER [NATURAL_8]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_prev_got_int: INTEGER_32
			l_cstack: CE_POINTER [PD_CONDSTACK]
			l_pat: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_end.make
			create l_save_cpo.make
			create l_regmatch___0.make (<<1>>)
			create l_cstack.make
			create l_pat.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx := 0
					l_give_up := 0
					l_skip___0 := 0
					l_caught := 0
					l_save_char := 0
					l_cstack := a_eap.item.cstack
					if l_cstack.item.cs_trylevel <= 0 then
						a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E603: :catch without :try"))
						l_give_up := 1
					elseif l_cstack.item.cs_idx < 0 then
						a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E603: :catch without :try"))
						l_give_up := 1
					else
						if not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (256)).to_boolean then
							a_eap.item.errmsg := get_end_emsg (l_cstack)
							l_skip___0 := 1
						end
						l_idx := l_cstack.item.cs_idx
						from
						until
							not (not js.loop_done and then (l_idx > 0))
						loop
							if (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (256)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_idx := l_idx - 1
							end
						end
						if (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean then
							a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E604: :catch after :finally"))
							l_give_up := 1
						else
							rewind_conditionals (l_cstack, l_idx, 24, create {CE_POINTER [INTEGER_32]}.make_shared (l_cstack.c_pointer + (create {PD_CONDSTACK}.make).offset_of ("cs_looplevel")))
						end
					end
					if (ex_docmd_inst.ends_excmd (((a_eap.item.arg).item).to_integer_32)).to_boolean then
						l_pat := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".*"))
						l_end := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						a_eap.item.nextcmd := ex_docmd_inst.find_nextcmd (a_eap.item.arg)
					else
						l_pat := a_eap.item.arg + 1
						l_end := regexp_inst.skip_regexp (l_pat, ((a_eap.item.arg).item).to_integer_32, 1, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
					end
					if l_give_up.to_boolean then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if not globals_inst.did_throw.to_boolean then
							l_skip___0 := 1
						elseif not (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (1)).to_boolean then
							l_skip___0 := 1
						end
						if l_skip___0.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if not ((((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (1_024)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (2_048)).to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if not l_end.is_void then
							if (l_end.item).to_integer_32 /= 0 then
								if not (ex_docmd_inst.ends_excmd (((charset_inst.skipwhite (l_end + 1)).item).to_integer_32)).to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing))))).do_nothing
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not ((ex_cmds2_inst.dbg_check_skipped (a_eap)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						if (do_intthrow (l_cstack)).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if not l_end.is_void then
							l_save_char := (l_end.item).to_integer_32
							l_end.item := (('%/0/').code).to_natural_8
						end
						l_save_cpo := option_inst.p_cpo.item
						option_inst.p_cpo.item := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
						l_regmatch___0.item.regprog := regexp_inst.vim_regcomp (l_pat, 3)
						l_regmatch___0.item.rm_ic := 0
						if not l_end.is_void then
							l_end.item := l_save_char.to_natural_8
						end
						option_inst.p_cpo.item := l_save_cpo
						if (l_regmatch___0.item.regprog).is_void then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), l_pat).do_nothing
						else
							l_prev_got_int := globals_inst.got_int
							globals_inst.got_int := 0
							l_caught := regexp_inst.vim_regexec_nl (l_regmatch___0, globals_inst.current_exception.item.value, 0)
							globals_inst.got_int := (globals_inst.got_int).bit_or (l_prev_got_int)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.item.regprog))
						end
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 7 -- goto _L
				when 10 then -- if done | if done | if done | if done
						if not js.return_called then
							if l_caught.to_boolean then
								l_cstack.item.cs_flags[l_idx] := (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_or (2_050)).to_integer_16
								globals_inst.did_throw := 0
								globals_inst.got_int := globals_inst.did_throw
								globals_inst.did_emsg := globals_inst.got_int
								catch_exception (create {CE_POINTER [PD_VIM_EXCEPTION]}.make_cast (l_cstack.item.cs_pend.csp_ex[l_idx]))
								if not (l_cstack.item.cs_pend.csp_ex[l_cstack.item.cs_idx]).is_equal (globals_inst.current_exception) then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_internal))))).do_nothing
								end
							else
								cleanup_conditionals (l_cstack, 256, 1).do_nothing
							end
						end
				when 11 then -- if done
					if not js.return_called and then (not l_end.is_void) then
						a_eap.item.nextcmd := ex_docmd_inst.find_nextcmd (l_end)
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_catch_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_catch)
		end

	ex_continue (a_eap: CE_POINTER [PD_EXARG])
		local
			l_idx: INTEGER_32
			l_cstack: CE_POINTER [PD_CONDSTACK]
		do
			create l_cstack.make

			l_cstack := a_eap.item.cstack
			if l_cstack.item.cs_looplevel <= 0 then
				a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E586: :continue without :while or :for"))
			elseif l_cstack.item.cs_idx < 0 then
				a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E586: :continue without :while or :for"))
			else
				l_idx := cleanup_conditionals (l_cstack, 24, 0)
				if l_idx >= 0 then
					if (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (24)).to_boolean then
						rewind_conditionals (l_cstack, l_idx, 256, create {CE_POINTER [INTEGER_32]}.make_shared (l_cstack.c_pointer + (create {PD_CONDSTACK}.make).offset_of ("cs_trylevel")))
						l_cstack.item.cs_lflags := (((l_cstack.item.cs_lflags).to_integer_32).bit_or (4)).to_integer_8
					else
						l_cstack.item.cs_pending[l_idx] := (16).to_integer_8
						report_make_pending (16, create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
				else
					l_cstack.item.cs_pending[l_idx] := (16).to_integer_8
					report_make_pending (16, create {CE_POINTER [ANY]}.make_shared (default_pointer))
				end
			end
		end

	ex_continue_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_continue)
		end

	ex_else (a_eap: CE_POINTER [PD_EXARG])
		local
			l_error: CE_ARRAY [INTEGER_32]
			l_skip___0: INTEGER_32
			l_result___2: INTEGER_32
			l_cstack: CE_POINTER [PD_CONDSTACK]
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_error.make (<<1>>)
			create l_cstack.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cstack := a_eap.item.cstack
					if globals_inst.did_emsg.to_boolean then
						l_tmp := 1
					elseif globals_inst.got_int.to_boolean then
						l_tmp := 1
					elseif globals_inst.did_throw.to_boolean then
						l_tmp := 1
					elseif l_cstack.item.cs_idx > 0 then
						if not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx - 1]).to_integer_32).bit_and (2)).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_skip___0 := l_tmp
					if not (l_cstack.item.cs_idx < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (280)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if a_eap.item.cmdidx = 127 then
							a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E581: :else without :if"))
							js.return
						end
						if not js.return_called then
							a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E582: :elseif without :if"))
							l_skip___0 := 1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (4)).to_boolean then
							if a_eap.item.cmdidx = 127 then
								a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E583: multiple :else"))
								js.return
							end
							if not js.return_called then
								a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E584: :elseif after :else"))
								l_skip___0 := 1
							end
						end
				when 7 then -- if done
						if js.return_called then
							l_pos := -1 + 22 -- skip if block
						end
				when 8 then -- if:
							if not (l_skip___0.to_boolean) then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 15
				when 11 then -- else:
							if not ((((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (1)).to_boolean) then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if: | _L___0:
							if (a_eap.item.errmsg).is_void then
								l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (1).to_integer_16
							end
							l_skip___0 := 1
				when 13 then -- if block done, skip else block:
							l_pos := -1 + 15
				when 14 then -- else:
							l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (2).to_integer_16
				when 15 then -- if done
							if not l_skip___0.to_boolean then
								if (ex_cmds2_inst.dbg_check_skipped (a_eap)).to_boolean then
									if globals_inst.got_int.to_boolean then
										do_intthrow (l_cstack).do_nothing
										l_skip___0 := 1
									end
								end
							end
							if a_eap.item.cmdidx /= 128 then
								l_pos := -1 + 21 -- skip if block
							end
				when 16 then -- if:
							l_result___2 := eval_inst.eval_to_bool (a_eap.item.arg, l_error, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + (create {PD_EXARG}.make).offset_of ("nextcmd")), l_skip___0)
							if l_skip___0.to_boolean then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
							if not (l_error.item).to_boolean then
								if l_result___2.to_boolean then
									l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (3).to_integer_16
								else
									l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (0).to_integer_16
								end
							else
								l_pos := -1 + 19 -- goto _L___1
							end
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 19 then -- else: | _L___1:
							if (a_eap.item.errmsg).is_void then
								l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (1).to_integer_16
							end
				when 20 then -- if done | if block done, skip else block:
							l_pos := -1 + 22
				when 21 then -- else:
							l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_or (4)).to_integer_16
				when 22 then -- if done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	ex_else_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_else)
		end

	ex_endfunction (a_eap: CE_POINTER [PD_EXARG])
		do
			message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E193: :endfunction not inside a function"))))).do_nothing
		end

	ex_endfunction_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_endfunction)
		end

	ex_endif (a_eap: CE_POINTER [PD_EXARG])
		do
			globals_inst.did_endif := 1
			if (a_eap.item.cstack).item.cs_idx < 0 then
				a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E580: :endif without :if"))
			elseif ((((a_eap.item.cstack).item.cs_flags[(a_eap.item.cstack).item.cs_idx]).to_integer_32).bit_and (280)).to_boolean then
				a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E580: :endif without :if"))
			else
				if not ((((a_eap.item.cstack).item.cs_flags[(a_eap.item.cstack).item.cs_idx]).to_integer_32).bit_and (1)).to_boolean then
					if (ex_cmds2_inst.dbg_check_skipped (a_eap)).to_boolean then
						do_intthrow (a_eap.item.cstack).do_nothing
					end
				end
				(a_eap.item.cstack).item.cs_idx := ((a_eap.item.cstack).item.cs_idx) - 1
			end
		end

	ex_endif_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_endif)
		end

	ex_endtry (a_eap: CE_POINTER [PD_EXARG])
		local
			l_idx: INTEGER_32
			l_skip___0: INTEGER_32
			l_rethrow: INTEGER_32
			l_pending: INTEGER_32
			l_rettv: CE_POINTER [ANY]
			l_cstack: CE_POINTER [PD_CONDSTACK]
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_rettv.make
			create l_cstack.make
			create l_tmp___1.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rethrow := 0
					l_pending := 0
					l_rettv := create {CE_POINTER [ANY]}.make_shared (default_pointer)
					l_cstack := a_eap.item.cstack
					if not (l_cstack.item.cs_trylevel <= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E602: :endtry without :try"))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if not (l_cstack.item.cs_idx < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E602: :endtry without :try"))
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if globals_inst.did_emsg.to_boolean then
							l_tmp := 1
						elseif globals_inst.got_int.to_boolean then
							l_tmp := 1
						elseif globals_inst.did_throw.to_boolean then
							l_tmp := 1
						elseif not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (1)).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
						l_skip___0 := l_tmp
						if not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (256)).to_boolean then
							a_eap.item.errmsg := get_end_emsg (l_cstack)
							l_idx := l_cstack.item.cs_idx
							from
							until
								js.loop_done
							loop
								l_idx := l_idx - 1
								if l_idx > 0 then
									if (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (256)).to_boolean then
										js.break
									end
								else
									js.break
								end
							end
							rewind_conditionals (l_cstack, l_idx, 24, create {CE_POINTER [INTEGER_32]}.make_shared (l_cstack.c_pointer + (create {PD_CONDSTACK}.make).offset_of ("cs_looplevel")))
							l_skip___0 := 1
							if globals_inst.did_throw.to_boolean then
								discard_current_exception
							end
						else
							l_idx := l_cstack.item.cs_idx
							if globals_inst.did_throw.to_boolean then
								if (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (1)).to_boolean then
									if not (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean then
										l_rethrow := 1
									end
								end
							end
						end
						if not (l_rethrow.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if l_skip___0.to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 10 then -- if:
						if (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (l_cstack.item.cs_pending[l_idx]).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if (ex_cmds2_inst.dbg_check_skipped (a_eap)).to_boolean then
							if globals_inst.got_int.to_boolean then
								l_skip___0 := 1
								do_intthrow (l_cstack).do_nothing
								l_rethrow := 0
								if globals_inst.did_throw.to_boolean then
									if not (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean then
										l_rethrow := 1
									end
								end
							end
						end
				when 13 then -- if done | if done | if done
						if not l_skip___0.to_boolean then
							l_pending := (l_cstack.item.cs_pending[l_idx]).to_integer_32
							l_cstack.item.cs_pending[l_idx] := (0).to_integer_8
							if l_pending = 24 then
								l_rettv := l_cstack.item.cs_pend.csp_rv[l_idx]
							elseif ((l_pending).bit_and (4)).to_boolean then
								globals_inst.current_exception := create {CE_POINTER [PD_VIM_EXCEPTION]}.make_cast (l_cstack.item.cs_pend.csp_ex[l_idx])
							end
						end
						cleanup_conditionals (l_cstack, 4_352, 1).do_nothing
						l_cstack.item.cs_idx := (l_cstack.item.cs_idx) - 1
						l_cstack.item.cs_trylevel := (l_cstack.item.cs_trylevel) - 1
						if l_skip___0.to_boolean then
							l_pos := -1 + 21 -- skip if block
						end
				when 14 then -- if:
						if l_pending = 24 then
							l_tmp___2 := l_rettv
						else
							if ((l_pending).bit_and (4)).to_boolean then
								l_tmp___1 := create {CE_POINTER [ANY]}.make_cast (globals_inst.current_exception)
							else
								l_tmp___1 := create {CE_POINTER [ANY]}.make_shared (default_pointer)
							end
							l_tmp___2 := l_tmp___1
						end
						report_resume_pending (l_pending, l_tmp___2)
						inspect l_pending -- switch 1 head
						when 0 then l_pos := -1 + 15
						when 16 then l_pos := -1 + 16
						when 8 then l_pos := -1 + 17
						when 24 then l_pos := -1 + 18
						when 32 then l_pos := -1 + 19
						else l_pos := -1 + 20
						end
				when 15 then -- switch 1, case 0
						l_pos := -1 + 21 -- switch 1; break
				when 16 then -- switch 1, case 16
						ex_continue (a_eap)
						l_pos := -1 + 21 -- switch 1; break
				when 17 then -- switch 1, case 8
						ex_break (a_eap)
						l_pos := -1 + 21 -- switch 1; break
				when 18 then -- switch 1, case 24
						eval_inst.do_return (a_eap, 0, 0, l_rettv).do_nothing
						l_pos := -1 + 21 -- switch 1; break
				when 19 then -- switch 1, case 32
						ex_cmds2_inst.do_finish (a_eap, 0)
						l_pos := -1 + 21 -- switch 1; break
				when 20 then -- switch 1, default:
						if ((l_pending).bit_and (1)).to_boolean then
							globals_inst.did_emsg := 1
						end
						if ((l_pending).bit_and (2)).to_boolean then
							globals_inst.got_int := 1
						end
						if ((l_pending).bit_and (4)).to_boolean then
							l_rethrow := 1
						end
						l_pos := -1 + 21 -- switch 1; break
				when 21 then -- switch 1, done: | if done
						if l_rethrow.to_boolean then
							do_throw (l_cstack)
						end
				when 22 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_endtry_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_endtry)
		end

	ex_endwhile (a_eap: CE_POINTER [PD_EXARG])
		local
			l_cstack: CE_POINTER [PD_CONDSTACK]
			l_idx: INTEGER_32
			l_err: CE_POINTER [NATURAL_8]
			l_csf: INTEGER_32
			l_fl: INTEGER_32
			js: JUMP_STATE
		do
			create l_cstack.make
			create l_err.make

			l_cstack := a_eap.item.cstack
			if a_eap.item.cmdidx = 134 then
				l_err := globals_inst.e_while
				l_csf := 8
			else
				l_err := globals_inst.e_for
				l_csf := 16
			end
			if l_cstack.item.cs_looplevel <= 0 then
				a_eap.item.errmsg := l_err
			elseif l_cstack.item.cs_idx < 0 then
				a_eap.item.errmsg := l_err
			else
				l_fl := (l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32
				if not ((l_fl).bit_and (l_csf)).to_boolean then
					if ((l_fl).bit_and (8)).to_boolean then
						a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E732: Using :endfor with :while"))))
					elseif ((l_fl).bit_and (16)).to_boolean then
						a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E733: Using :endwhile with :for"))))
					end
				end
				if not ((l_fl).bit_and (24)).to_boolean then
					if not ((l_fl).bit_and (256)).to_boolean then
						a_eap.item.errmsg := globals_inst.e_endif
					elseif ((l_fl).bit_and (512)).to_boolean then
						a_eap.item.errmsg := globals_inst.e_endtry
					end
					l_idx := l_cstack.item.cs_idx
					from
					until
						not (not js.loop_done and then (l_idx > 0))
					loop
						l_fl := (l_cstack.item.cs_flags[l_idx]).to_integer_32
						if ((l_fl).bit_and (256)).to_boolean then
							if not ((l_fl).bit_and (512)).to_boolean then
								a_eap.item.errmsg := l_err
								js.return
							end
						end
						if not js.return_called then
							if ((l_fl).bit_and (l_csf)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_idx := l_idx - 1
							end
						end
					end
					if not js.return_called then
						cleanup_conditionals (l_cstack, 24, 0).do_nothing
						rewind_conditionals (l_cstack, l_idx, 256, create {CE_POINTER [INTEGER_32]}.make_shared (l_cstack.c_pointer + (create {PD_CONDSTACK}.make).offset_of ("cs_trylevel")))
					end
				elseif (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (1)).to_boolean then
					if not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (2)).to_boolean then
						if (ex_cmds2_inst.dbg_check_skipped (a_eap)).to_boolean then
							do_intthrow (l_cstack).do_nothing
						end
					end
				end
				if not js.return_called then
					l_cstack.item.cs_lflags := (((l_cstack.item.cs_lflags).to_integer_32).bit_or (2)).to_integer_8
				end
			end
			if not js.return_called then
			end
		end

	ex_endwhile_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_endwhile)
		end

	ex_finally (a_eap: CE_POINTER [PD_EXARG])
		local
			l_idx: INTEGER_32
			l_skip___0: INTEGER_32
			l_pending: INTEGER_32
			l_cstack: CE_POINTER [PD_CONDSTACK]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cstack.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_skip___0 := 0
					l_pending := 0
					l_cstack := a_eap.item.cstack
					if not (l_cstack.item.cs_trylevel <= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E606: :finally without :try"))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 3 then -- else:
						if not (l_cstack.item.cs_idx < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E606: :finally without :try"))
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 6 then -- else:
						if not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (256)).to_boolean then
							a_eap.item.errmsg := get_end_emsg (l_cstack)
							l_idx := l_cstack.item.cs_idx - 1
							from
							until
								not (not js.loop_done and then (l_idx > 0))
							loop
								if (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (256)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_idx := l_idx - 1
								end
							end
							l_pending := 1
						else
							l_idx := l_cstack.item.cs_idx
						end
						if (((l_cstack.item.cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean then
							a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E607: multiple :finally"))
							js.return
						end
						if js.return_called then
							l_pos := -1 + 24 -- skip if block
						end
				when 7 then -- if:
						rewind_conditionals (l_cstack, l_idx, 24, create {CE_POINTER [INTEGER_32]}.make_shared (l_cstack.c_pointer + (create {PD_CONDSTACK}.make).offset_of ("cs_looplevel")))
						l_skip___0 := (not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_and (1)).to_boolean).to_integer
						if l_skip___0.to_boolean then
							l_pos := -1 + 24 -- skip if block
						end
				when 8 then -- if:
						if (ex_cmds2_inst.dbg_check_skipped (a_eap)).to_boolean then
							do_intthrow (l_cstack).do_nothing
						end
						cleanup_conditionals (l_cstack, 256, 0).do_nothing
						if l_pending /= 1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 11 then -- else:
						if not (globals_inst.did_emsg.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 14 then -- else:
						if not (globals_inst.got_int.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 17 then -- else:
						if not (globals_inst.did_throw.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if: | _L___0:
						if (l_cstack.item.cs_pending[l_cstack.item.cs_idx]).to_integer_32 = 24 then
							report_discard_pending (24, l_cstack.item.cs_pend.csp_rv[l_cstack.item.cs_idx])
							eval_inst.discard_pending_return (l_cstack.item.cs_pend.csp_rv[l_cstack.item.cs_idx])
						end
						if l_pending /= 1 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not globals_inst.did_emsg.to_boolean then
							l_pending := (l_pending).bit_or ((4))
						else
							l_pos := -1 + 21 -- goto _L
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L:
						if globals_inst.did_throw.to_boolean then
							l_tmp___0 := 4
						else
							l_tmp___0 := 0
						end
						l_pending := (l_pending).bit_or (l_tmp___0)
				when 22 then
						if globals_inst.did_emsg.to_boolean then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_pending := (l_pending).bit_or (l_tmp___1)
						if globals_inst.got_int.to_boolean then
							l_tmp___2 := 2
						else
							l_tmp___2 := 0
						end
						l_pending := (l_pending).bit_or (l_tmp___2)
						l_cstack.item.cs_pending[l_cstack.item.cs_idx] := l_pending.to_integer_8
						if globals_inst.did_throw.to_boolean then
							if not (l_cstack.item.cs_pend.csp_ex[l_cstack.item.cs_idx]).is_equal (globals_inst.current_exception) then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_internal))))).do_nothing
							end
						end
				when 23 then -- if done | if done | if done
						l_cstack.item.cs_lflags := (((l_cstack.item.cs_lflags).to_integer_32).bit_or (8)).to_integer_8
				when 24 then -- if done | if done | if done | if done
						if not js.return_called then
						end
				when 25 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_finally_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_finally)
		end

	ex_if (a_eap: CE_POINTER [PD_EXARG])
		local
			l_error: CE_ARRAY [INTEGER_32]
			l_skip___0: INTEGER_32
			l_result___2: INTEGER_32
			l_cstack: CE_POINTER [PD_CONDSTACK]
			l_tmp: INTEGER_32
		do
			create l_error.make (<<1>>)
			create l_cstack.make

			l_cstack := a_eap.item.cstack
			if l_cstack.item.cs_idx = 49 then
				a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E579: :if nesting too deep"))
			else
				l_cstack.item.cs_idx := (l_cstack.item.cs_idx) + 1
				l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (0).to_integer_16
				if globals_inst.did_emsg.to_boolean then
					l_tmp := 1
				elseif globals_inst.got_int.to_boolean then
					l_tmp := 1
				elseif globals_inst.did_throw.to_boolean then
					l_tmp := 1
				elseif l_cstack.item.cs_idx > 0 then
					if not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx - 1]).to_integer_32).bit_and (2)).to_boolean then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
				l_skip___0 := l_tmp
				l_result___2 := eval_inst.eval_to_bool (a_eap.item.arg, l_error, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + (create {PD_EXARG}.make).offset_of ("nextcmd")), l_skip___0)
				if not l_skip___0.to_boolean then
					if not (l_error.item).to_boolean then
						if l_result___2.to_boolean then
							l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (3).to_integer_16
						end
					else
						l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (1).to_integer_16
					end
				else
					l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (1).to_integer_16
				end
			end
		end

	ex_if_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_if)
		end

	ex_throw (a_eap: CE_POINTER [PD_EXARG])
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_value: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_arg.make
			create l_value.make
			create l_tmp.make

			l_arg := a_eap.item.arg
			if (l_arg.item).to_integer_32 /= 0 then
				if (l_arg.item).to_integer_32 /= 124 then
					if (l_arg.item).to_integer_32 /= 10 then
						l_value := eval_inst.eval_to_string_skip (l_arg, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + (create {PD_EXARG}.make).offset_of ("nextcmd")), a_eap.item.skip)
					else
						l_tmp := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						l_value := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
				else
					l_tmp := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
					l_value := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
			else
				l_tmp := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
				l_value := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			if not (a_eap.item.skip).to_boolean then
				if not l_value.is_void then
					if (throw_exception (create {CE_POINTER [ANY]}.make_cast (l_value), 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_value))
					else
						do_throw (a_eap.item.cstack)
					end
				end
			end
		end

	ex_throw_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_throw)
		end

	ex_try (a_eap: CE_POINTER [PD_EXARG])
		local
			l_skip___0: INTEGER_32
			l_cstack: CE_POINTER [PD_CONDSTACK]
			l_tmp: INTEGER_32
			l_elem: CE_POINTER [PD_ESLIST_ELEM]
		do
			create l_cstack.make
			create l_elem.make

			l_cstack := a_eap.item.cstack
			if l_cstack.item.cs_idx = 49 then
				a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E601: :try nesting too deep"))
			else
				l_cstack.item.cs_idx := (l_cstack.item.cs_idx) + 1
				l_cstack.item.cs_trylevel := (l_cstack.item.cs_trylevel) + 1
				l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (256).to_integer_16
				l_cstack.item.cs_pending[l_cstack.item.cs_idx] := (0).to_integer_8
				if globals_inst.did_emsg.to_boolean then
					l_tmp := 1
				elseif globals_inst.got_int.to_boolean then
					l_tmp := 1
				elseif globals_inst.did_throw.to_boolean then
					l_tmp := 1
				elseif l_cstack.item.cs_idx > 0 then
					if not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx - 1]).to_integer_32).bit_and (2)).to_boolean then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
				l_skip___0 := l_tmp
				if not l_skip___0.to_boolean then
					l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_or (3)).to_integer_16
					if globals_inst.emsg_silent.to_boolean then
						l_elem := create {CE_POINTER [PD_ESLIST_ELEM]}.make_cast ((misc2_inst.alloc ((create {PD_ESLIST_ELEM}.make).structure_size.to_natural_32)))
						if l_elem.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_outofmem))))).do_nothing
						else
							l_elem.item.saved_emsg_silent := globals_inst.emsg_silent
							l_elem.item.next := l_cstack.item.cs_emsg_silent_list
							l_cstack.item.cs_emsg_silent_list := l_elem
							l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_or (4_096)).to_integer_16
							globals_inst.emsg_silent := 0
						end
					end
				end
			end
		end

	ex_try_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_try)
		end

	ex_while (a_eap: CE_POINTER [PD_EXARG])
		local
			l_error: CE_ARRAY [INTEGER_32]
			l_skip___0: INTEGER_32
			l_result___2: INTEGER_32
			l_cstack: CE_POINTER [PD_CONDSTACK]
			l_tmp: INTEGER_32
			l_fi: CE_POINTER [ANY]
			l_pos: INTEGER_32
		do
			create l_error.make (<<1>>)
			create l_cstack.make
			create l_fi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cstack := a_eap.item.cstack
					if l_cstack.item.cs_idx /= 49 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E585: :while/:for nesting too deep"))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (((l_cstack.item.cs_lflags).to_integer_32).bit_and (1)) = 0 then
							l_cstack.item.cs_idx := (l_cstack.item.cs_idx) + 1
							l_cstack.item.cs_looplevel := (l_cstack.item.cs_looplevel) + 1
							l_cstack.item.cs_line[l_cstack.item.cs_idx] := -1
						end
						if a_eap.item.cmdidx = 482 then
							l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (8).to_integer_16
						else
							l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (16).to_integer_16
						end
						if globals_inst.did_emsg.to_boolean then
							l_tmp := 1
						elseif globals_inst.got_int.to_boolean then
							l_tmp := 1
						elseif globals_inst.did_throw.to_boolean then
							l_tmp := 1
						elseif l_cstack.item.cs_idx > 0 then
							if not (((l_cstack.item.cs_flags[l_cstack.item.cs_idx - 1]).to_integer_32).bit_and (2)).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_skip___0 := l_tmp
						if a_eap.item.cmdidx = 482 then
							l_result___2 := eval_inst.eval_to_bool (a_eap.item.arg, l_error, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + (create {PD_EXARG}.make).offset_of ("nextcmd")), l_skip___0)
						else
							if (((l_cstack.item.cs_lflags).to_integer_32).bit_and (1)) /= 0 then
								l_fi := l_cstack.item.cs_forinfo[l_cstack.item.cs_idx]
								l_error.item := 0
							else
								l_fi := eval_inst.eval_for_line (a_eap.item.arg, l_error, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + (create {PD_EXARG}.make).offset_of ("nextcmd")), l_skip___0)
								l_cstack.item.cs_forinfo[l_cstack.item.cs_idx] := l_fi
							end
							if not (l_error.item).to_boolean then
								if not l_fi.is_void then
									if not l_skip___0.to_boolean then
										l_result___2 := eval_inst.next_for_item (l_fi, a_eap.item.arg)
									else
										l_result___2 := 0
									end
								else
									l_result___2 := 0
								end
							else
								l_result___2 := 0
							end
							if not l_result___2.to_boolean then
								eval_inst.free_for_info (l_fi)
								l_cstack.item.cs_forinfo[l_cstack.item.cs_idx] := create {CE_POINTER [ANY]}.make_shared (default_pointer)
							end
						end
						if l_skip___0.to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not (l_error.item).to_boolean then
							if l_result___2.to_boolean then
								l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_or (3)).to_integer_16
								l_cstack.item.cs_lflags := (((l_cstack.item.cs_lflags).to_integer_32).bit_xor (1)).to_integer_8
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						l_cstack.item.cs_lflags := (((l_cstack.item.cs_lflags).to_integer_32).bit_and (-2)).to_integer_8
						if not l_skip___0.to_boolean then
							if not (l_error.item).to_boolean then
								l_cstack.item.cs_flags[l_cstack.item.cs_idx] := (((l_cstack.item.cs_flags[l_cstack.item.cs_idx]).to_integer_32).bit_or (1)).to_integer_16
							end
						end
				when 7 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_while_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_while)
		end

	finish_exception (a_excp: CE_POINTER [PD_VIM_EXCEPTION])
		do
			if not a_excp.is_equal (globals_inst.caught_stack) then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_internal))))).do_nothing
			end
			globals_inst.caught_stack := globals_inst.caught_stack.item.caught
			if not globals_inst.caught_stack.is_void then
				eval_inst.set_vim_var_string (29, globals_inst.caught_stack.item.value, -1)
				if ((globals_inst.caught_stack.item.throw_name).item).to_integer_32 /= 0 then
					if globals_inst.caught_stack.item.throw_lnum /= 0 then
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("%%s, line %%ld"))), globals_inst.caught_stack.item.throw_name, globals_inst.caught_stack.item.throw_lnum]).do_nothing
					else
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("%%s"), globals_inst.caught_stack.item.throw_name]).do_nothing
					end
					eval_inst.set_vim_var_string (30, globals_inst.IObuff, -1)
				else
					eval_inst.set_vim_var_string (30, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
				end
			else
				eval_inst.set_vim_var_string (29, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
				eval_inst.set_vim_var_string (30, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
			end
			discard_exception (a_excp, 1)
		end

	free_msglist (a_l: CE_POINTER [PD_MSGLIST])
		local
			l_messages: CE_POINTER [PD_MSGLIST]
			l_next: CE_POINTER [PD_MSGLIST]
		do
			create l_messages.make
			create l_next.make

			l_messages := a_l
			from
			until
				l_messages.is_void
			loop
				l_next := l_messages.item.next
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_messages.item.msg))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_messages))
				l_messages := l_next
			end
		end

	get_end_emsg (a_cstack: CE_POINTER [PD_CONDSTACK]): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if (((a_cstack.item.cs_flags[a_cstack.item.cs_idx]).to_integer_32).bit_and (8)).to_boolean then
				Result := globals_inst.e_endwhile
				js.return
			end
			if not js.return_called and then ((((a_cstack.item.cs_flags[a_cstack.item.cs_idx]).to_integer_32).bit_and (16)).to_boolean) then
				Result := globals_inst.e_endfor
				js.return
			end
			if not js.return_called then
				Result := globals_inst.e_endif
			end
		end

	has_loop_cmd (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							if (l_p___0.item).to_integer_32 /= 32 then
								if (l_p___0.item).to_integer_32 /= 9 then
									if (l_p___0.item).to_integer_32 /= 58 then
										js.break
									end
								end
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 + 1
							end
						end
						l_len := ex_docmd_inst.modifier_len (l_p___0)
						if l_len = 0 then
							js.break
						end
						if not js.loop_jumped then
							l_p___0 := l_p___0 + l_len
						end
					end
					if (l_p___0[0]).to_integer_32 /= 119 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_p___0[1]).to_integer_32 = 104 then
							Result := 1
							js.return
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (l_p___0[0]).to_integer_32 = 102 then
							if (l_p___0[1]).to_integer_32 = 111 then
								if (l_p___0[2]).to_integer_32 = 114 then
									Result := 1
									js.return
								end
							end
						end
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	leave_cleanup (a_csp: CE_POINTER [PD_CLEANUP_STUFF])
		local
			l_pending: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pending := a_csp.item.pending
					if l_pending = 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if not ((aborting).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (globals_inst.need_rethrow.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((l_pending).bit_and (4)).to_boolean then
							discard_exception (a_csp.item.exception, 0)
						else
							report_discard_pending (l_pending, create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
						if not globals_inst.msg_list.is_void then
							free_msglist (globals_inst.msg_list.item)
							globals_inst.msg_list.item := create {CE_POINTER [PD_MSGLIST]}.make_shared (default_pointer)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if ((l_pending).bit_and (4)).to_boolean then
							globals_inst.current_exception := a_csp.item.exception
						elseif ((l_pending).bit_and (1)).to_boolean then
							cause_abort := globals_inst.force_abort
							globals_inst.force_abort := 0
						end
						if ((l_pending).bit_and (1)).to_boolean then
							globals_inst.did_emsg := 1
						end
						if ((l_pending).bit_and (2)).to_boolean then
							globals_inst.got_int := 1
						end
						if ((l_pending).bit_and (4)).to_boolean then
							globals_inst.need_rethrow := 1
						end
						if ((l_pending).bit_and (4)).to_boolean then
							l_tmp := create {CE_POINTER [ANY]}.make_cast (globals_inst.current_exception)
						else
							l_tmp := create {CE_POINTER [ANY]}.make_shared (default_pointer)
						end
						report_resume_pending (l_pending, l_tmp)
				when 8 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	report_discard_pending (a_pending: INTEGER_32; a_value: CE_POINTER [ANY])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (option_inst.p_verbose.item >= 14) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (globals_inst.debug_break_level > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if globals_inst.debug_break_level <= 0 then
							message_inst.verbose_enter
						end
						report_pending (2, a_pending, a_value)
						if globals_inst.debug_break_level <= 0 then
							message_inst.verbose_leave
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	report_make_pending (a_pending: INTEGER_32; a_value: CE_POINTER [ANY])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (option_inst.p_verbose.item >= 14) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (globals_inst.debug_break_level > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if globals_inst.debug_break_level <= 0 then
							message_inst.verbose_enter
						end
						report_pending (0, a_pending, a_value)
						if globals_inst.debug_break_level <= 0 then
							message_inst.verbose_leave
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	report_pending (a_action: INTEGER_32; a_pending: INTEGER_32; a_value: CE_POINTER [ANY])
		local
			l_mesg: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [INTEGER_8]
			l_save_msg_silent: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_mesg.make
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_action -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 0
					l_mesg := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%s made pending"))))
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_mesg := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%s resumed"))))
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					l_mesg := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%s discarded"))))
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					inspect a_pending -- switch 2 head
					when 0 then l_pos := -1 + 5
					when 16 then l_pos := -1 + 6
					when 8 then l_pos := -1 + 7
					when 32 then l_pos := -1 + 8
					when 24 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 5 then -- switch 2, case 0
					js.return
				when 6 then -- switch 2, case 16
					if not js.return_called then
						l_s := ce_string (":continue")
					end
					l_pos := -1 + 17 -- switch 2; break
				when 7 then -- switch 2, case 8
					l_s := ce_string (":break")
					l_pos := -1 + 17 -- switch 2; break
				when 8 then -- switch 2, case 32
					l_s := ce_string (":finish")
					l_pos := -1 + 17 -- switch 2; break
				when 9 then -- switch 2, case 24
					l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((eval_inst.get_return_cmd (a_value)))
					l_pos := -1 + 17 -- switch 2; break
				when 10 then -- switch 2, default:
					if not (((a_pending).bit_and (4)).to_boolean) then
						l_pos := -1 + 13 -- skip if block
					end
				when 11 then -- if:
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, create {CE_POINTER [INTEGER_8]}.make_cast (l_mesg), (gettext (ce_string ("Exception")))]).do_nothing
						l_mesg := misc2_inst.vim_strnsave (globals_inst.IObuff, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32 + 4)
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_mesg), ce_string (": %%s")).do_nothing
						l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [PD_VIM_EXCEPTION]}.make_cast (a_value)).item.value)
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if not (((a_pending).bit_and (1)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if ((a_pending).bit_and (2)).to_boolean then
							l_s := gettext (ce_string ("Error and interrupt"))
						else
							l_pos := -1 + 16 -- goto _L
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L:
						if ((a_pending).bit_and (1)).to_boolean then
							l_s := gettext (ce_string ("Error"))
						else
							l_s := gettext (ce_string ("Interrupt"))
						end
				when 17 then -- if done | switch 2, done:
						if not js.return_called then
							l_save_msg_silent := globals_inst.msg_silent
							if globals_inst.debug_break_level > 0 then
								globals_inst.msg_silent := 0
							end
							globals_inst.no_wait_return := globals_inst.no_wait_return + 1
							globals_inst.msg_scroll := 1
							message_inst.smsg ([l_mesg, create {CE_POINTER [NATURAL_8]}.make_cast (l_s)]).do_nothing
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
							globals_inst.cmdline_row := globals_inst.msg_row
							globals_inst.no_wait_return := globals_inst.no_wait_return - 1
							if globals_inst.debug_break_level > 0 then
								globals_inst.msg_silent := l_save_msg_silent
							end
							if a_pending = 24 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s))
							elseif ((a_pending).bit_and (4)).to_boolean then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mesg))
							end
						end
				when 18 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	report_resume_pending (a_pending: INTEGER_32; a_value: CE_POINTER [ANY])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (option_inst.p_verbose.item >= 14) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (globals_inst.debug_break_level > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if globals_inst.debug_break_level <= 0 then
							message_inst.verbose_enter
						end
						report_pending (1, a_pending, a_value)
						if globals_inst.debug_break_level <= 0 then
							message_inst.verbose_leave
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	rewind_conditionals (a_cstack: CE_POINTER [PD_CONDSTACK]; a_idx: INTEGER_32; a_cond_type: INTEGER_32; a_cond_level: CE_POINTER [INTEGER_32])
		do
			from
			until
				not (a_cstack.item.cs_idx > a_idx)
			loop
				if (((a_cstack.item.cs_flags[a_cstack.item.cs_idx]).to_integer_32).bit_and (a_cond_type)).to_boolean then
					a_cond_level.item := (a_cond_level.item) - 1
				end
				if (((a_cstack.item.cs_flags[a_cstack.item.cs_idx]).to_integer_32).bit_and (16)).to_boolean then
					eval_inst.free_for_info (a_cstack.item.cs_forinfo[a_cstack.item.cs_idx])
				end
				a_cstack.item.cs_idx := (a_cstack.item.cs_idx) - 1
			end
		end

	should_abort (a_retcode: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_retcode /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.trylevel /= 0 then
							if not globals_inst.emsg_silent.to_boolean then
								l_tmp___0 := 1
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						if (aborting).to_boolean then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
				when 4 then
					Result := l_tmp___0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	throw_exception (a_value: CE_POINTER [ANY]; a_type: INTEGER_32; a_cmdname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_excp: CE_POINTER [PD_VIM_EXCEPTION]
			l_p___0: CE_POINTER [NATURAL_8]
			l_mesg: CE_POINTER [NATURAL_8]
			l_val___0: CE_POINTER [NATURAL_8]
			l_cmdlen: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_save_msg_silent: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_excp.make
			create l_p___0.make
			create l_mesg.make
			create l_val___0.make
			create l_tmp.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_type = 0 then
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_value), ce_string ("Vim"), (3).to_natural_32)) = 0 then
							if (create {CE_POINTER [NATURAL_8]}.make_cast (a_value)[3]).to_integer_32 = 0 then
								l_tmp := gettext (ce_string ("E608: Cannot :throw exceptions with %'Vim%' prefix"))
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
								l_pos := -1 + 43 -- goto fail
							elseif (create {CE_POINTER [NATURAL_8]}.make_cast (a_value)[3]).to_integer_32 = 58 then
								l_tmp := gettext (ce_string ("E608: Cannot :throw exceptions with %'Vim%' prefix"))
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
								l_pos := -1 + 43 -- goto fail
							elseif (create {CE_POINTER [NATURAL_8]}.make_cast (a_value)[3]).to_integer_32 = 40 then
								l_tmp := gettext (ce_string ("E608: Cannot :throw exceptions with %'Vim%' prefix"))
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
								l_pos := -1 + 43 -- goto fail
							end
						end
					end
				when 1 then
					l_excp := create {CE_POINTER [PD_VIM_EXCEPTION]}.make_cast ((misc2_inst.alloc ((create {PD_VIM_EXCEPTION}.make).structure_size.to_natural_32)))
					if l_excp.is_void then
						l_pos := -1 + 42 -- goto nomem
					end
				when 2 then
					if a_type /= 1 then
						l_pos := -1 + 34 -- skip if block
					end
				when 3 then -- if:
						l_excp.item.messages := create {CE_POINTER [PD_MSGLIST]}.make_cast (a_value)
						l_mesg := (l_excp.item.messages).item.throw_msg
						if a_cmdname.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if (a_cmdname.item).to_integer_32 = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 5 then -- if:
						l_cmdlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmdname))).to_integer_32
						l_excp.item.value := misc2_inst.vim_strnsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vim(")), ((4 + l_cmdlen) + 2) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_mesg))).to_integer_32)
						if (l_excp.item.value).is_void then
							l_pos := -1 + 42 -- goto nomem
						end
				when 6 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_excp.item.value + 4)), create {CE_POINTER [INTEGER_8]}.make_cast (a_cmdname)).do_nothing
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_excp.item.value + (4 + l_cmdlen))), ce_string ("):")).do_nothing
						l_val___0 := ((l_excp.item.value + 4) + l_cmdlen) + 2
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else: | _L:
						l_excp.item.value := misc2_inst.vim_strnsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vim:")), 4 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_mesg))).to_integer_32)
						if (l_excp.item.value).is_void then
							l_pos := -1 + 42 -- goto nomem
						end
				when 11 then
						l_val___0 := l_excp.item.value + 4
				when 12 then
						l_p___0 := l_mesg
				when 13 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 33 -- skip loop
						end
				when 14 then -- loop body:
						if (l_p___0.item).to_integer_32 /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 31 -- goto _L___2
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 17 then -- else:
						if (l_p___0.item).to_integer_32 /= 69 then
							l_pos := -1 + 32 -- skip if block
						end
				when 18 then -- if:
						if not ((l_p___0[1]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 19 then -- if:
						if not ((l_p___0[1]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 20 then -- if:
						if (l_p___0[2]).to_integer_32 /= 58 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 31 -- goto _L___2
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 23 then -- else:
						if not ((l_p___0[2]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
						if not ((l_p___0[2]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 25 then -- if:
						if (l_p___0[3]).to_integer_32 /= 58 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 31 -- goto _L___2
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 28 then -- else:
						if not ((l_p___0[3]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 29 then -- if:
						if not ((l_p___0[3]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if (l_p___0[4]).to_integer_32 /= 58 then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | _L___2:
						if (l_p___0.item).to_integer_32 = 0 then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_val___0), create {CE_POINTER [INTEGER_8]}.make_cast (l_mesg)).do_nothing
						elseif l_p___0.is_equal (l_mesg) then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_val___0), create {CE_POINTER [INTEGER_8]}.make_cast (l_mesg)).do_nothing
						else
							if (l_mesg[0]).to_integer_32 /= 34 then
								js.continue
							elseif ((l_p___0 - 2).c_pointer.to_integer_32).to_natural_32 < ((l_mesg + 1).c_pointer.to_integer_32).to_natural_32 then
								js.continue
							elseif (l_p___0[-2]).to_integer_32 /= 34 then
								js.continue
							elseif (l_p___0[-1]).to_integer_32 /= 32 then
								js.continue
							end
							if not js.loop_jumped then
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_val___0), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
								l_p___0[-2] := (('%/0/').code).to_natural_8
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast ((l_val___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32)), ce_string (" (%%s)"), l_mesg + 1]).do_nothing
								l_p___0[-2] := (('%"').code).to_natural_8
							end
						end
						if not js.loop_jumped then
							js.break
						end
				when 32 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if js.loop_increment then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 13 -- back to loop condition
				when 33 then -- loop done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_excp.item.value := create {CE_POINTER [NATURAL_8]}.make_cast (a_value)
				when 35 then -- if done
					l_excp.item.type := a_type
					if globals_inst.sourcing_name.is_void then
						l_tmp___6 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
					else
						l_tmp___6 := globals_inst.sourcing_name
					end
					l_excp.item.throw_name := misc2_inst.vim_strsave (l_tmp___6)
					if (l_excp.item.throw_name).is_void then
						if a_type = 1 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_excp.item.value))
						end
						l_pos := -1 + 42 -- goto nomem
					end
				when 36 then
					l_excp.item.throw_lnum := globals_inst.sourcing_lnum
					if not (option_inst.p_verbose.item >= 13) then
						l_pos := -1 + 39 -- skip if block
					end
				when 37 then -- if:
						l_pos := -1 + 40 -- goto _L___3
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 39 then -- else:
						if not (globals_inst.debug_break_level > 0) then
							l_pos := -1 + 41 -- skip if block
						end
				when 40 then -- if: | _L___3:
						l_save_msg_silent := globals_inst.msg_silent
						if globals_inst.debug_break_level > 0 then
							globals_inst.msg_silent := 0
						else
							message_inst.verbose_enter
						end
						globals_inst.no_wait_return := globals_inst.no_wait_return + 1
						if globals_inst.debug_break_level > 0 then
							globals_inst.msg_scroll := 1
						elseif (option_inst.p_vfile.item.item).to_integer_32 = 0 then
							globals_inst.msg_scroll := 1
						end
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Exception thrown: %%s")))), l_excp.item.value]).do_nothing
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
						if globals_inst.debug_break_level > 0 then
							globals_inst.cmdline_row := globals_inst.msg_row
						elseif (option_inst.p_vfile.item.item).to_integer_32 = 0 then
							globals_inst.cmdline_row := globals_inst.msg_row
						end
						globals_inst.no_wait_return := globals_inst.no_wait_return - 1
						if globals_inst.debug_break_level > 0 then
							globals_inst.msg_silent := l_save_msg_silent
						else
							message_inst.verbose_leave
						end
				when 41 then -- if done
						globals_inst.current_exception := l_excp
						Result := 1
						js.return
						if js.return_called then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if: | nomem:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_excp))
							globals_inst.suppress_errthrow := 1
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_outofmem))))).do_nothing
				when 43 then -- fail:
							globals_inst.current_exception := create {CE_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer)
							Result := 0
				when 44 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	update_force_abort
		do
			if cause_abort.to_boolean then
				globals_inst.force_abort := 1
			end
		end

end
