class
	P_HARDCOPY

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create cterm_color_16.make (<<16>>)
			create cterm_color_8.make (<<8>>)
			create j_charsets.make (<<8>>)
			create j_encodings.make (<<6>>)
			create k_charsets.make (<<7>>)
			create k_encodings.make (<<8>>)
			create mbfont_opts.make (<<6>>)
			create prt_ascii_encoding.make
			create prt_cmap.make (<<80>>)
			create prt_conv.make (<<1>>)
			create prt_dsc_table.make (<<3>>)
			create prt_hexchar.make (<<17>>)
			create prt_line_buffer.make (<<257>>)
			create prt_mediasize.make (<<14>>)
			create prt_page_num.make (<<1>>)
			create prt_ps_buffer.make (<<1>>)
			create prt_ps_courier_font.make (<<1>>)
			create prt_ps_fd.make
			create prt_ps_file_name.make
			create prt_ps_font.make
			create prt_ps_mb_font.make (<<1>>)
			create prt_ps_mbfonts.make (<<4>>)
			create prt_resfile.make (<<1>>)
			create prt_resource_types.make (<<3>>)
			create sc_charsets.make (<<7>>)
			create sc_encodings.make (<<6>>)
			create tc_charsets.make (<<14>>)
			create tc_encodings.make (<<8>>)
			create units.make (<<4>>)
		end

feature {ANY} -- attributes

	cterm_color_16: CE_ARRAY [NATURAL_32]

	cterm_color_8: CE_ARRAY [NATURAL_32]

	curr_bg: NATURAL_32 assign set_curr_bg

	set_curr_bg (a_curr_bg: NATURAL_32)
		do
			curr_bg := a_curr_bg
		end

	curr_bold: INTEGER_32 assign set_curr_bold

	set_curr_bold (a_curr_bold: INTEGER_32)
		do
			curr_bold := a_curr_bold
		end

	curr_fg: NATURAL_32 assign set_curr_fg

	set_curr_fg (a_curr_fg: NATURAL_32)
		do
			curr_fg := a_curr_fg
		end

	curr_italic: INTEGER_32 assign set_curr_italic

	set_curr_italic (a_curr_italic: INTEGER_32)
		do
			curr_italic := a_curr_italic
		end

	curr_underline: INTEGER_32 assign set_curr_underline

	set_curr_underline (a_curr_underline: INTEGER_32)
		do
			curr_underline := a_curr_underline
		end

	current_syn_id: INTEGER_32 assign set_current_syn_id

	set_current_syn_id (a_current_syn_id: INTEGER_32)
		do
			current_syn_id := a_current_syn_id
		end

	j_charsets: CE_ARRAY [PD_PRT_PS_CHARSET_S]

	j_encodings: CE_ARRAY [PD_PRT_PS_ENCODING_S]

	k_charsets: CE_ARRAY [PD_PRT_PS_CHARSET_S]

	k_encodings: CE_ARRAY [PD_PRT_PS_ENCODING_S]

	mbfont_opts: CE_ARRAY [PD_OPTION_TABLE_T]

	page_count: INTEGER_32 assign set_page_count

	set_page_count (a_page_count: INTEGER_32)
		do
			page_count := a_page_count
		end

	prt_ascii_encoding: CE_POINTER [INTEGER_8] assign set_prt_ascii_encoding

	set_prt_ascii_encoding (a_prt_ascii_encoding: CE_POINTER [INTEGER_8])
		do
			prt_ascii_encoding := a_prt_ascii_encoding
		end

	prt_attribute_change: INTEGER_32 assign set_prt_attribute_change

	set_prt_attribute_change (a_prt_attribute_change: INTEGER_32)
		do
			prt_attribute_change := a_prt_attribute_change
		end

	prt_bgcol: INTEGER_32 assign set_prt_bgcol

	set_prt_bgcol (a_prt_bgcol: INTEGER_32)
		do
			prt_bgcol := a_prt_bgcol
		end

	prt_bgcol_offset: REAL_32 assign set_prt_bgcol_offset

	set_prt_bgcol_offset (a_prt_bgcol_offset: REAL_32)
		do
			prt_bgcol_offset := a_prt_bgcol_offset
		end

	prt_bottom_margin: REAL_32 assign set_prt_bottom_margin

	set_prt_bottom_margin (a_prt_bottom_margin: REAL_32)
		do
			prt_bottom_margin := a_prt_bottom_margin
		end

	prt_bufsiz: INTEGER_32 assign set_prt_bufsiz

	set_prt_bufsiz (a_prt_bufsiz: INTEGER_32)
		do
			prt_bufsiz := a_prt_bufsiz
		end

	prt_char_width: REAL_32 assign set_prt_char_width

	set_prt_char_width (a_prt_char_width: REAL_32)
		do
			prt_char_width := a_prt_char_width
		end

	prt_cmap: CE_ARRAY [INTEGER_8]

	prt_collate: INTEGER_32 assign set_prt_collate

	set_prt_collate (a_prt_collate: INTEGER_32)
		do
			prt_collate := a_prt_collate
		end

	prt_conv: CE_ARRAY [PD_VIMCONV_T]

	prt_custom_cmap: INTEGER_32 assign set_prt_custom_cmap

	set_prt_custom_cmap (a_prt_custom_cmap: INTEGER_32)
		do
			prt_custom_cmap := a_prt_custom_cmap
		end

	prt_do_bgcol: INTEGER_32 assign set_prt_do_bgcol

	set_prt_do_bgcol (a_prt_do_bgcol: INTEGER_32)
		do
			prt_do_bgcol := a_prt_do_bgcol
		end

	prt_do_conv: INTEGER_32 assign set_prt_do_conv

	set_prt_do_conv (a_prt_do_conv: INTEGER_32)
		do
			prt_do_conv := a_prt_do_conv
		end

	prt_do_moveto: INTEGER_32 assign set_prt_do_moveto

	set_prt_do_moveto (a_prt_do_moveto: INTEGER_32)
		do
			prt_do_moveto := a_prt_do_moveto
		end

	prt_do_underline: INTEGER_32 assign set_prt_do_underline

	set_prt_do_underline (a_prt_do_underline: INTEGER_32)
		do
			prt_do_underline := a_prt_do_underline
		end

	prt_dsc_table: CE_ARRAY [PD_PRT_DSC_COMMENT_S]

	prt_duplex: INTEGER_32 assign set_prt_duplex

	set_prt_duplex (a_prt_duplex: INTEGER_32)
		do
			prt_duplex := a_prt_duplex
		end

	prt_fgcol: INTEGER_32 assign set_prt_fgcol

	set_prt_fgcol (a_prt_fgcol: INTEGER_32)
		do
			prt_fgcol := a_prt_fgcol
		end

	prt_file_error: INTEGER_32 assign set_prt_file_error

	set_prt_file_error (a_prt_file_error: INTEGER_32)
		do
			prt_file_error := a_prt_file_error
		end

	prt_first_line_height: REAL_32 assign set_prt_first_line_height

	set_prt_first_line_height (a_prt_first_line_height: REAL_32)
		do
			prt_first_line_height := a_prt_first_line_height
		end

	prt_font: INTEGER_32 assign set_prt_font

	set_prt_font (a_prt_font: INTEGER_32)
		do
			prt_font := a_prt_font
		end

	prt_half_width: INTEGER_32 assign set_prt_half_width

	set_prt_half_width (a_prt_half_width: INTEGER_32)
		do
			prt_half_width := a_prt_half_width
		end

	prt_hexchar: CE_ARRAY [NATURAL_8]

	prt_in_ascii: INTEGER_32 assign set_prt_in_ascii

	set_prt_in_ascii (a_prt_in_ascii: INTEGER_32)
		do
			prt_in_ascii := a_prt_in_ascii
		end

	prt_left_margin: REAL_32 assign set_prt_left_margin

	set_prt_left_margin (a_prt_left_margin: REAL_32)
		do
			prt_left_margin := a_prt_left_margin
		end

	prt_line_buffer: CE_ARRAY [NATURAL_8]

	prt_line_height: REAL_32 assign set_prt_line_height

	set_prt_line_height (a_prt_line_height: REAL_32)
		do
			prt_line_height := a_prt_line_height
		end

	prt_media: INTEGER_32 assign set_prt_media

	set_prt_media (a_prt_media: INTEGER_32)
		do
			prt_media := a_prt_media
		end

	prt_mediasize: CE_ARRAY [PD_PRT_MEDIASIZE_S]

	prt_need_bgcol: INTEGER_32 assign set_prt_need_bgcol

	set_prt_need_bgcol (a_prt_need_bgcol: INTEGER_32)
		do
			prt_need_bgcol := a_prt_need_bgcol
		end

	prt_need_fgcol: INTEGER_32 assign set_prt_need_fgcol

	set_prt_need_fgcol (a_prt_need_fgcol: INTEGER_32)
		do
			prt_need_fgcol := a_prt_need_fgcol
		end

	prt_need_font: INTEGER_32 assign set_prt_need_font

	set_prt_need_font (a_prt_need_font: INTEGER_32)
		do
			prt_need_font := a_prt_need_font
		end

	prt_need_moveto: INTEGER_32 assign set_prt_need_moveto

	set_prt_need_moveto (a_prt_need_moveto: INTEGER_32)
		do
			prt_need_moveto := a_prt_need_moveto
		end

	prt_need_underline: INTEGER_32 assign set_prt_need_underline

	set_prt_need_underline (a_prt_need_underline: INTEGER_32)
		do
			prt_need_underline := a_prt_need_underline
		end

	prt_new_bgcol: INTEGER_32 assign set_prt_new_bgcol

	set_prt_new_bgcol (a_prt_new_bgcol: INTEGER_32)
		do
			prt_new_bgcol := a_prt_new_bgcol
		end

	prt_num_copies: INTEGER_32 assign set_prt_num_copies

	set_prt_num_copies (a_prt_num_copies: INTEGER_32)
		do
			prt_num_copies := a_prt_num_copies
		end

	prt_number_width: REAL_32 assign set_prt_number_width

	set_prt_number_width (a_prt_number_width: REAL_32)
		do
			prt_number_width := a_prt_number_width
		end

	prt_out_mbyte: INTEGER_32 assign set_prt_out_mbyte

	set_prt_out_mbyte (a_prt_out_mbyte: INTEGER_32)
		do
			prt_out_mbyte := a_prt_out_mbyte
		end

	prt_page_height: REAL_32 assign set_prt_page_height

	set_prt_page_height (a_prt_page_height: REAL_32)
		do
			prt_page_height := a_prt_page_height
		end

	prt_page_num: CE_ARRAY [INTEGER_32]

	prt_page_width: REAL_32 assign set_prt_page_width

	set_prt_page_width (a_prt_page_width: REAL_32)
		do
			prt_page_width := a_prt_page_width
		end

	prt_portrait: INTEGER_32 assign set_prt_portrait

	set_prt_portrait (a_prt_portrait: INTEGER_32)
		do
			prt_portrait := a_prt_portrait
		end

	prt_pos_x: REAL_32 assign set_prt_pos_x

	set_prt_pos_x (a_prt_pos_x: REAL_32)
		do
			prt_pos_x := a_prt_pos_x
		end

	prt_pos_x_moveto: REAL_32 assign set_prt_pos_x_moveto

	set_prt_pos_x_moveto (a_prt_pos_x_moveto: REAL_32)
		do
			prt_pos_x_moveto := a_prt_pos_x_moveto
		end

	prt_pos_y: REAL_32 assign set_prt_pos_y

	set_prt_pos_y (a_prt_pos_y: REAL_32)
		do
			prt_pos_y := a_prt_pos_y
		end

	prt_pos_y_moveto: REAL_32 assign set_prt_pos_y_moveto

	set_prt_pos_y_moveto (a_prt_pos_y_moveto: REAL_32)
		do
			prt_pos_y_moveto := a_prt_pos_y_moveto
		end

	prt_ps_buffer: CE_ARRAY [PD_GROWARRAY]

	prt_ps_courier_font: CE_ARRAY [PD_PRT_PS_FONT_S]

	prt_ps_fd: CE_POINTER [SD_IO_FILE] assign set_prt_ps_fd

	set_prt_ps_fd (a_prt_ps_fd: CE_POINTER [SD_IO_FILE])
		do
			prt_ps_fd := a_prt_ps_fd
		end

	prt_ps_file_name: CE_POINTER [NATURAL_8] assign set_prt_ps_file_name

	set_prt_ps_file_name (a_prt_ps_file_name: CE_POINTER [NATURAL_8])
		do
			prt_ps_file_name := a_prt_ps_file_name
		end

	prt_ps_font: CE_POINTER [PD_PRT_PS_FONT_S] assign set_prt_ps_font

	set_prt_ps_font (a_prt_ps_font: CE_POINTER [PD_PRT_PS_FONT_S])
		do
			prt_ps_font := a_prt_ps_font
		end

	prt_ps_mb_font: CE_ARRAY [PD_PRT_PS_FONT_S]

	prt_ps_mbfonts: CE_ARRAY [PD_PRT_PS_MBFONT_S]

	prt_resfile: CE_ARRAY [PD_PRT_RESFILE_BUFFER_S]

	prt_resource_types: CE_ARRAY [CE_POINTER [INTEGER_8]]

	prt_right_margin: REAL_32 assign set_prt_right_margin

	set_prt_right_margin (a_prt_right_margin: REAL_32)
		do
			prt_right_margin := a_prt_right_margin
		end

	prt_text_run: REAL_32 assign set_prt_text_run

	set_prt_text_run (a_prt_text_run: REAL_32)
		do
			prt_text_run := a_prt_text_run
		end

	prt_top_margin: REAL_32 assign set_prt_top_margin

	set_prt_top_margin (a_prt_top_margin: REAL_32)
		do
			prt_top_margin := a_prt_top_margin
		end

	prt_tumble: INTEGER_32 assign set_prt_tumble

	set_prt_tumble (a_prt_tumble: INTEGER_32)
		do
			prt_tumble := a_prt_tumble
		end

	prt_underline: INTEGER_32 assign set_prt_underline

	set_prt_underline (a_prt_underline: INTEGER_32)
		do
			prt_underline := a_prt_underline
		end

	prt_use_courier: INTEGER_32 assign set_prt_use_courier

	set_prt_use_courier (a_prt_use_courier: INTEGER_32)
		do
			prt_use_courier := a_prt_use_courier
		end

	sc_charsets: CE_ARRAY [PD_PRT_PS_CHARSET_S]

	sc_encodings: CE_ARRAY [PD_PRT_PS_ENCODING_S]

	tc_charsets: CE_ARRAY [PD_PRT_PS_CHARSET_S]

	tc_encodings: CE_ARRAY [PD_PRT_PS_ENCODING_S]

	units: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- routines

	darken_rgb (a_rgb: NATURAL_32): NATURAL_32
		do
			Result := ((((((a_rgb).bit_shift_right (17))).bit_shift_left (16)) + ((((((a_rgb).bit_and ({NATURAL_32} 65_280))).bit_shift_right (9))).bit_shift_left (8))) + ((((a_rgb).bit_and ({NATURAL_32} 255))).bit_shift_right (1)))
		end

	ex_hardcopy (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lnum: INTEGER_32
			l_collated_copies: INTEGER_32
			l_uncollated_copies: INTEGER_32
			l_settings: CE_ARRAY [PD_PRT_SETTINGS_T]
			l_bytes_to_print: NATURAL_32
			l_page_line: INTEGER_32
			l_jobsplit: INTEGER_32
			l_errormsg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_id: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_prtpos: CE_ARRAY [PD_PRT_POS_T]
			l_page_prtpos: CE_ARRAY [PD_PRT_POS_T]
			l_side: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___28: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_settings.make (<<1>>)
			create l_errormsg.make (<<1>>)
			create l_tmp___1.make
			create l_tmp___2.make
			create l_prtpos.make (<<1>>)
			create l_page_prtpos.make (<<1>>)
			create l_tmp___19.make
			create l_tmp___28.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bytes_to_print := (0).to_natural_32
					memset (create {CE_POINTER [ANY]}.make_cast (l_settings), 0, (create {PD_PRT_SETTINGS_T}.make).structure_size.to_natural_32).do_nothing
					l_settings.item.has_color := 1
					if ((a_eap.item.arg).item).to_integer_32 = 62 then
						l_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						if (ex_docmd_inst.expand_filename (a_eap, a_eap.item.cmdlinep, l_errormsg)) = 0 then
							if not (l_errormsg.item).is_void then
								message_inst.emsg (l_errormsg.item).do_nothing
							end
							js.return
						end
						if not js.return_called then
							l_settings.item.outfile := charset_inst.skipwhite (a_eap.item.arg + 1)
						end
					elseif ((a_eap.item.arg).item).to_integer_32 /= 0 then
						l_settings.item.arguments := a_eap.item.arg
					end
					if not js.return_called then
						if (globals_inst.curbuf.item.b_fname).is_void then
							l_tmp___2 := create {CE_POINTER [NATURAL_8]}.make_cast ((buffer_inst.buf_spname (globals_inst.curbuf)))
						else
							if (globals_inst.curbuf.item.b_sfname).is_void then
								l_tmp___1 := globals_inst.curbuf.item.b_fname
							else
								l_tmp___1 := globals_inst.curbuf.item.b_sfname
							end
							l_tmp___2 := l_tmp___1
						end
						if (mch_print_init (l_settings, l_tmp___2, a_eap.item.forceit)) = 0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if (gui_inst.gui.item.in_use).to_boolean then
							l_settings.item.modec := ('g').code
						elseif globals_inst.t_colors > 1 then
							l_settings.item.modec := ('c').code
						else
							l_settings.item.modec := ('t').code
						end
						if (syntax_inst.syntax_present (globals_inst.curwin)).to_boolean then
							if (globals_inst.printer_opts[5].present).to_boolean then
								if (globals_inst.printer_opts[5].string[0]).to_integer_32 < 65 then
									l_tmp___5 := (globals_inst.printer_opts[5].string[0]).to_integer_32
								elseif (globals_inst.printer_opts[5].string[0]).to_integer_32 > 90 then
									l_tmp___5 := (globals_inst.printer_opts[5].string[0]).to_integer_32
								else
									l_tmp___5 := (globals_inst.printer_opts[5].string[0]).to_integer_32 + 32
								end
								if l_tmp___5 /= 97 then
									if (globals_inst.printer_opts[5].string[0]).to_integer_32 < 65 then
										l_tmp___4 := (globals_inst.printer_opts[5].string[0]).to_integer_32
									elseif (globals_inst.printer_opts[5].string[0]).to_integer_32 > 90 then
										l_tmp___4 := (globals_inst.printer_opts[5].string[0]).to_integer_32
									else
										l_tmp___4 := (globals_inst.printer_opts[5].string[0]).to_integer_32 + 32
									end
									l_settings.item.do_syntax := (l_tmp___4 = 121).to_integer
								else
									l_settings.item.do_syntax := l_settings.item.has_color
								end
							else
								l_settings.item.do_syntax := l_settings.item.has_color
							end
						else
							l_settings.item.do_syntax := 0
						end
						l_settings.item.number.fg_color := (0).to_natural_32
						l_settings.item.number.bg_color := (16_777_215).to_natural_32
						l_settings.item.number.bold := 0
						l_settings.item.number.italic := 1
						l_settings.item.number.underline := 0
						if (prt_use_number).to_boolean then
							if (l_settings.item.do_syntax).to_boolean then
								l_id := syntax_inst.syn_name2id (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("LineNr")))
								if l_id > 0 then
									l_id := syntax_inst.syn_get_final_id (l_id)
								end
								prt_get_attr (l_id, create {CE_POINTER [PD_PRT_TEXT_ATTR_T]}.make_shared (l_settings.item.c_pointer + (create {PD_PRT_SETTINGS_T}.make).offset_of ("number")), l_settings.item.modec)
							end
						end
						l_lnum := a_eap.item.line1
						from
						until
							not (l_lnum <= a_eap.item.line2)
						loop
							l_bytes_to_print := l_bytes_to_print + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((charset_inst.skipwhite ((memline_inst.ml_get (l_lnum))))))).to_natural_32
							l_lnum := l_lnum + 1
						end
						if l_bytes_to_print = {NATURAL_32} 0 then
							message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("No text to be printed"))))).do_nothing
							l_pos := -1 + 21 -- goto print_fail_no_begin
						end
				when 2 then
						curr_bg := {NATURAL_32} 4_294_967_295
						curr_fg := {NATURAL_32} 4_294_967_295
						curr_italic := 2
						curr_bold := 2
						curr_underline := 2
						prt_set_fg ((0).to_natural_32)
						prt_set_bg ((16_777_215).to_natural_32)
						prt_set_font (0, 0, 0)
						current_syn_id := -1
						if (globals_inst.printer_opts[12].present).to_boolean then
							if (globals_inst.printer_opts[12].string[0]).to_integer_32 < 65 then
								l_tmp___12 := (globals_inst.printer_opts[12].string[0]).to_integer_32
							elseif (globals_inst.printer_opts[12].string[0]).to_integer_32 > 90 then
								l_tmp___12 := (globals_inst.printer_opts[12].string[0]).to_integer_32
							else
								l_tmp___12 := (globals_inst.printer_opts[12].string[0]).to_integer_32 + 32
							end
							if l_tmp___12 = 121 then
								l_tmp___13 := 1
							else
								l_tmp___13 := 0
							end
						else
							l_tmp___13 := 0
						end
						l_jobsplit := l_tmp___13
						if not (mch_print_begin (l_settings)).to_boolean then
							l_pos := -1 + 21 -- goto print_fail_no_begin
						end
				when 3 then
						page_count := 0
						l_collated_copies := 0
				when 4 then -- loop condition:
						if not (not js.loop_done and then (l_collated_copies < l_settings.item.n_collated_copies)) then
							l_pos := -1 + 20 -- skip loop
						end
				when 5 then -- loop body:
						memset (create {CE_POINTER [ANY]}.make_cast (l_page_prtpos), 0, (create {PD_PRT_POS_T}.make).structure_size.to_natural_32).do_nothing
						l_page_prtpos.item.file_line := a_eap.item.line1
						l_prtpos.item := (l_page_prtpos.item).twin
						if l_jobsplit.to_boolean then
							if l_collated_copies > 0 then
								mch_print_end (l_settings)
								if not (mch_print_begin (l_settings)).to_boolean then
									l_pos := -1 + 21 -- goto print_fail_no_begin
								end
							end
						end
				when 6 then
						page_count := 0
				when 7 then -- loop condition:
						if not (not js.loop_done and then (l_prtpos.item.file_line <= a_eap.item.line2)) then
							l_pos := -1 + 19 -- skip loop
						end
				when 8 then -- loop body:
						l_uncollated_copies := 0
				when 9 then -- loop condition:
						if not (not js.loop_done and then (l_uncollated_copies < l_settings.item.n_uncollated_copies)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 10 then -- loop body:
						l_prtpos.item := (l_page_prtpos.item).twin
						l_side := 0
				when 11 then -- loop condition:
						if not (not js.loop_done and then (l_side <= l_settings.item.duplex)) then
							l_pos := -1 + 16 -- skip loop
						end
				when 12 then -- loop body:
						ui_inst.ui_breakcheck
						if globals_inst.got_int.to_boolean then
							l_pos := -1 + 20 -- goto print_fail
						elseif (l_settings.item.user_abort).to_boolean then
							l_pos := -1 + 20 -- goto print_fail
						end
				when 13 then
						if l_prtpos.item.bytes_printed > {NATURAL_32} 1_000_000 then
							l_tmp___16 := (l_prtpos.item.bytes_printed // (l_bytes_to_print // {NATURAL_32} 100)).to_integer_32
						else
							l_tmp___16 := ((l_prtpos.item.bytes_printed * {NATURAL_32} 100) // l_bytes_to_print).to_integer_32
						end
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("Printing page %%d (%%d%%%%)"))), (page_count + 1) + l_side, l_tmp___16]).do_nothing
						if not (mch_print_begin_page (globals_inst.IObuff)).to_boolean then
							l_pos := -1 + 20 -- goto print_fail
						end
				when 14 then
						if l_settings.item.n_collated_copies > 1 then
							l_tmp___19 := gettext (ce_string (" Copy %%d of %%d"))
							sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32), l_tmp___19, l_collated_copies + 1, l_settings.item.n_collated_copies]).do_nothing
						end
						prt_message (globals_inst.IObuff)
						if (prt_header_height) > 0 then
							prt_header (l_settings, (page_count + 1) + l_side, l_prtpos.item.file_line)
						end
						l_page_line := 0
						from
						until
							not (not js.loop_done and then (l_page_line < l_settings.item.lines_per_page))
						loop
							l_prtpos.item.column := hardcopy_line (l_settings, l_page_line, l_prtpos)
							if l_prtpos.item.column = 0 then
								l_prtpos.item.bytes_printed := l_prtpos.item.bytes_printed + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((charset_inst.skipwhite ((memline_inst.ml_get (l_prtpos.item.file_line))))))).to_natural_32
								l_prtpos.item.file_line := (l_prtpos.item.file_line) + 1
								if l_prtpos.item.file_line > a_eap.item.line2 then
									js.break
								end
							elseif (l_prtpos.item.ff).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_page_line := l_page_line + 1
							end
						end
						if not (mch_print_end_page).to_boolean then
							l_pos := -1 + 20 -- goto print_fail
						end
				when 15 then
						if l_prtpos.item.file_line > a_eap.item.line2 then
							js.break
						end
						if not js.loop_jumped then
							l_side := l_side + 1
						end
						l_pos := -1 + 11 -- back to loop condition
				when 16 then -- loop done
						if l_prtpos.item.file_line > a_eap.item.line2 then
							if (l_settings.item.duplex).to_boolean then
								if l_side = 0 then
									if l_uncollated_copies + 1 < l_settings.item.n_uncollated_copies then
										if not (mch_print_blank_page).to_boolean then
											l_pos := -1 + 20 -- goto print_fail
										end
									end
								end
							end
						end
				when 17 then
						l_uncollated_copies := l_uncollated_copies + 1
						l_pos := -1 + 9 -- back to loop condition
				when 18 then -- loop done
						if (l_settings.item.duplex).to_boolean then
							if l_prtpos.item.file_line <= a_eap.item.line2 then
								page_count := page_count + 1
							end
						end
						l_page_prtpos.item := (l_prtpos.item).twin
						page_count := page_count + 1
						l_pos := -1 + 7 -- back to loop condition
				when 19 then -- loop done
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Printed: %%s"))), l_settings.item.jobname]).do_nothing
						prt_message (globals_inst.IObuff)
						l_collated_copies := l_collated_copies + 1
						l_pos := -1 + 4 -- back to loop condition
				when 20 then -- print_fail:
						if globals_inst.got_int.to_boolean then
							l_tmp___28 := gettext (ce_string ("Printing aborted"))
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%%s"), l_tmp___28]).do_nothing
							prt_message (globals_inst.IObuff)
						elseif (l_settings.item.user_abort).to_boolean then
							l_tmp___28 := gettext (ce_string ("Printing aborted"))
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%%s"), l_tmp___28]).do_nothing
							prt_message (globals_inst.IObuff)
						end
						mch_print_end (l_settings)
				when 21 then -- print_fail_no_begin:
						mch_print_cleanup
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_hardcopy_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_hardcopy)
		end

	hardcopy_line (a_psettings: CE_POINTER [PD_PRT_SETTINGS_T]; a_page_line: INTEGER_32; a_ppos: CE_POINTER [PD_PRT_POS_T]): INTEGER_32
		local
			l_col: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_need_break: INTEGER_32
			l_outputlen: INTEGER_32
			l_tab_spaces: INTEGER_32
			l_print_pos: NATURAL_32
			l_attr: CE_ARRAY [PD_PRT_TEXT_ATTR_T]
			l_id: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_attr.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_need_break := 0
					if a_ppos.item.column /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((a_ppos.item.ff).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_print_pos := (0).to_natural_32
						l_tab_spaces := 0
						if not (a_ppos.item.ff).to_boolean then
							if (prt_use_number).to_boolean then
								prt_line_number (a_psettings, a_page_line, a_ppos.item.file_line)
							end
						end
						a_ppos.item.ff := 0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_print_pos := (a_ppos.item.print_pos).to_natural_32
						l_tab_spaces := a_ppos.item.lead_spaces
				when 7 then -- if done
						mch_print_start_line (0, a_page_line)
						l_line := memline_inst.ml_get (a_ppos.item.file_line)
						l_col := a_ppos.item.column
				when 8 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 21 -- skip loop
						end
				when 9 then -- loop body:
							if (l_line[l_col]).to_integer_32 /= 0 then
								if l_need_break.to_boolean then
									js.break
								end
							else
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 20 -- skip if block
							end
				when 10 then -- if:
							l_outputlen := 1
							if globals_inst.has_mbyte.to_boolean then
								l_outputlen := globals_inst.mb_ptr2len.integer_32_item ([l_line + l_col])
								if l_outputlen < 1 then
									l_outputlen := 1
								end
							end
							if (a_psettings.item.do_syntax).to_boolean then
								l_id := syntax_inst.syn_get_id (globals_inst.curwin, a_ppos.item.file_line, l_col, 1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
								if l_id > 0 then
									l_id := syntax_inst.syn_get_final_id (l_id)
								else
									l_id := 0
								end
								l_line := memline_inst.ml_get (a_ppos.item.file_line)
								if l_id /= current_syn_id then
									current_syn_id := l_id
									prt_get_attr (l_id, l_attr, a_psettings.item.modec)
									prt_set_font (l_attr.item.bold, l_attr.item.italic, l_attr.item.underline)
									prt_set_fg (l_attr.item.fg_color)
									prt_set_bg (l_attr.item.bg_color)
								end
							end
							if (l_line[l_col]).to_integer_32 /= 9 then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							l_pos := -1 + 14 -- goto _L___2
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 13 then -- else:
							if l_tab_spaces = 0 then
								l_pos := -1 + 16 -- skip if block
							end
				when 14 then -- if: | _L___2:
							if l_tab_spaces = 0 then
								l_tab_spaces := ((globals_inst.curbuf.item.b_p_ts).to_natural_32 - l_print_pos \\ (globals_inst.curbuf.item.b_p_ts).to_natural_32).to_integer_32
							end
							from
							until
								not (not js.loop_done and then (l_tab_spaces > 0))
							loop
								l_need_break := mch_print_text_out (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1)
								l_print_pos := l_print_pos + 1
								l_tab_spaces := l_tab_spaces - 1
								if l_need_break.to_boolean then
									js.break
								end
							end
							if l_need_break.to_boolean then
								if l_tab_spaces > 0 then
									js.break
								end
							end
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 16 then -- else:
							if (l_line[l_col]).to_integer_32 /= 12 then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
							if (globals_inst.printer_opts[13].present).to_boolean then
								if (globals_inst.printer_opts[13].string[0]).to_integer_32 < 65 then
									l_tmp___1 := (globals_inst.printer_opts[13].string[0]).to_integer_32
								elseif (globals_inst.printer_opts[13].string[0]).to_integer_32 > 90 then
									l_tmp___1 := (globals_inst.printer_opts[13].string[0]).to_integer_32
								else
									l_tmp___1 := (globals_inst.printer_opts[13].string[0]).to_integer_32 + 32
								end
								if l_tmp___1 = 121 then
									a_ppos.item.ff := 1
									l_need_break := 1
								else
									l_pos := -1 + 19 -- goto _L___1
								end
							else
								l_pos := -1 + 19 -- goto _L___1
							end
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 19 then -- else: | _L___1:
							l_need_break := mch_print_text_out (l_line + l_col, l_outputlen)
							if globals_inst.has_mbyte.to_boolean then
								l_print_pos := l_print_pos + (globals_inst.mb_ptr2cells.integer_32_item ([l_line + l_col])).to_natural_32
							else
								l_print_pos := l_print_pos + 1
							end
				when 20 then -- if done | if done | if done
							if not js.loop_jumped then
								l_col := l_col + l_outputlen
							end
							l_pos := -1 + 8 -- back to loop condition
				when 21 then -- loop done
						a_ppos.item.lead_spaces := l_tab_spaces
						a_ppos.item.print_pos := l_print_pos.to_integer_32
						if not (a_ppos.item.ff).to_boolean then
							if (l_line[l_col]).to_integer_32 = 0 then
								Result := 0
								js.return
							elseif (globals_inst.printer_opts[7].present).to_boolean then
								if (globals_inst.printer_opts[7].string[0]).to_integer_32 < 65 then
									l_tmp___2 := (globals_inst.printer_opts[7].string[0]).to_integer_32
								elseif (globals_inst.printer_opts[7].string[0]).to_integer_32 > 90 then
									l_tmp___2 := (globals_inst.printer_opts[7].string[0]).to_integer_32
								else
									l_tmp___2 := (globals_inst.printer_opts[7].string[0]).to_integer_32 + 32
								end
								if l_tmp___2 = 110 then
									Result := 0
									js.return
								end
							end
						end
						if not js.return_called then
							Result := l_col
						end
				when 22 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mch_print_begin (a_psettings: CE_POINTER [PD_PRT_SETTINGS_T]): INTEGER_32
		local
			l_now: CE_ARRAY [INTEGER_32]
			l_bbox: CE_ARRAY [INTEGER_32]
			l_p_time: CE_POINTER [INTEGER_8]
			l_left: CE_ARRAY [REAL_64]
			l_right: CE_ARRAY [REAL_64]
			l_top: CE_ARRAY [REAL_64]
			l_bottom: CE_ARRAY [REAL_64]
			l_res_prolog: CE_ARRAY [PD_PRT_PS_RESOURCE_S]
			l_res_encoding: CE_ARRAY [PD_PRT_PS_RESOURCE_S]
			l_buffer: CE_ARRAY [INTEGER_8]
			l_p_encoding: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_res_cidfont: CE_ARRAY [PD_PRT_PS_RESOURCE_S]
			l_res_cmap: CE_ARRAY [PD_PRT_PS_RESOURCE_S]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_props: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___26: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_now.make (<<1>>)
			create l_bbox.make (<<4>>)
			create l_p_time.make
			create l_left.make (<<1>>)
			create l_right.make (<<1>>)
			create l_top.make (<<1>>)
			create l_bottom.make (<<1>>)
			create l_res_prolog.make (<<1>>)
			create l_res_encoding.make (<<1>>)
			create l_buffer.make (<<256>>)
			create l_p_encoding.make
			create l_p___0.make
			create l_res_cidfont.make (<<1>>)
			create l_res_cmap.make (<<1>>)
			create l_tmp___2.make
			create l_tmp___26.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					prt_dsc_start
					prt_dsc_textline (ce_string ("Title"), create {CE_POINTER [INTEGER_8]}.make_cast (a_psettings.item.jobname))
					if not (misc2_inst.get_user_name (create {CE_POINTER [NATURAL_8]}.make_cast (l_buffer), 256)).to_boolean then
						strcpy (l_buffer, ce_string ("Unknown")).do_nothing
					end
					prt_dsc_textline (ce_string ("For"), l_buffer)
					prt_dsc_textline (ce_string ("Creator"), ce_string ("VIM - Vi IMproved 7.3 (2010 Aug 15)"))
					l_now.item := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					l_p_time := ctime (l_now)
					l_p___0 := misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (l_p_time), ('%N').code)
					if not l_p___0.is_void then
						l_p___0.item := (('%/0/').code).to_natural_8
					end
					prt_dsc_textline (ce_string ("CreationDate"), l_p_time)
					prt_dsc_textline (ce_string ("DocumentData"), ce_string ("Clean8Bit"))
					prt_dsc_textline (ce_string ("Orientation"), ce_string ("Portrait"))
					prt_dsc_text (ce_string ("Pages"), ce_string ("atend"))
					prt_dsc_textline (ce_string ("PageOrder"), ce_string ("Ascend"))
					prt_page_margins ((prt_mediasize[prt_media].width).to_double, (prt_mediasize[prt_media].height).to_double, l_left, l_right, l_top, l_bottom)
					l_bbox[0] := (l_left.item).truncated_to_integer
					if prt_portrait.to_boolean then
						l_bbox[1] := (l_top.item - ((a_psettings.item.lines_per_page + (prt_header_height)).to_real * prt_line_height).to_double).truncated_to_integer
						l_bbox[2] := ((l_left.item + ((a_psettings.item.chars_per_line).to_real * prt_char_width).to_double) + 0.5).truncated_to_integer
						l_bbox[3] := (l_top.item + 0.5).truncated_to_integer
					else
						l_bbox[1] := (l_bottom.item).truncated_to_integer
						l_bbox[2] := ((l_left.item + ((a_psettings.item.lines_per_page + (prt_header_height)).to_real * prt_line_height).to_double) + 0.5).truncated_to_integer
						l_bbox[3] := ((l_bottom.item + ((a_psettings.item.chars_per_line).to_real * prt_char_width).to_double) + 0.5).truncated_to_integer
					end
					prt_dsc_ints (ce_string ("BoundingBox"), 4, l_bbox)
					prt_dsc_docmedia (prt_mediasize[prt_media].name, (prt_mediasize[prt_media].width).to_double, (prt_mediasize[prt_media].height).to_double, (0).to_double, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					if not prt_out_mbyte.to_boolean then
						prt_dsc_font_resource (ce_string ("DocumentNeededResources"), prt_ps_courier_font)
					elseif prt_use_courier.to_boolean then
						prt_dsc_font_resource (ce_string ("DocumentNeededResources"), prt_ps_courier_font)
					end
					if prt_out_mbyte.to_boolean then
						if prt_use_courier.to_boolean then
							l_tmp___2 := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						else
							l_tmp___2 := ce_string ("DocumentNeededResources")
						end
						prt_dsc_font_resource (l_tmp___2, prt_ps_mb_font)
						if not prt_custom_cmap.to_boolean then
							prt_dsc_resources (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("cmap"), prt_cmap)
						end
					end
					if not (prt_find_resource (ce_string ("prolog"), l_res_prolog)).to_boolean then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E456: Can%'t find PostScript resource file %"prolog.ps%""))))).do_nothing
						Result := 0
						js.return
					end
					if not js.return_called then
						if not (prt_open_resource (l_res_prolog)).to_boolean then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if not (prt_check_resource (l_res_prolog, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("1.4")))).to_boolean then
							Result := 0
							js.return
						end
					end
					if not js.return_called and then (prt_out_mbyte.to_boolean) then
						if not (prt_find_resource (ce_string ("cidfont"), l_res_cidfont)).to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E456: Can%'t find PostScript resource file %"cidfont.ps%""))))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							if not (prt_open_resource (l_res_cidfont)).to_boolean then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if not (prt_check_resource (l_res_cidfont, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("1.0")))).to_boolean then
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if prt_out_mbyte.to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						l_p_encoding := mbyte_inst.enc_skip (option_inst.p_penc.item)
						if (l_p_encoding.item).to_integer_32 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___0
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 5 then -- else:
						if (prt_find_resource (create {CE_POINTER [INTEGER_8]}.make_cast (l_p_encoding), l_res_encoding)).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if: | _L___0:
						l_p_encoding := mbyte_inst.enc_skip (option_inst.p_enc.item)
						l_props := mbyte_inst.enc_canon_props (l_p_encoding)
						if ((l_props).bit_and (1)).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if (prt_find_resource (create {CE_POINTER [INTEGER_8]}.make_cast (l_p_encoding), l_res_encoding)).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_p_encoding := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("latin1"))
						if not (prt_find_resource (create {CE_POINTER [INTEGER_8]}.make_cast (l_p_encoding), l_res_encoding)).to_boolean then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E456: Can%'t find PostScript resource file %"%%s.ps%"")))), l_p_encoding).do_nothing
							Result := 0
							js.return
						end
				when 11 then -- if done | if done | if done
						if not js.return_called then
							if not (prt_open_resource (l_res_encoding)).to_boolean then
								Result := 0
								js.return
							end
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_p_encoding := mbyte_inst.enc_skip (option_inst.p_penc.item)
						if (l_p_encoding.item).to_integer_32 = 0 then
							l_p_encoding := mbyte_inst.enc_skip (option_inst.p_enc.item)
						end
						if prt_use_courier.to_boolean then
							if not (prt_find_resource (prt_ascii_encoding, l_res_encoding)).to_boolean then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E456: Can%'t find PostScript resource file %"%%s.ps%"")))), create {CE_POINTER [NATURAL_8]}.make_cast (prt_ascii_encoding)).do_nothing
								Result := 0
								js.return
							end
							if not js.return_called then
								if not (prt_open_resource (l_res_encoding)).to_boolean then
									Result := 0
									js.return
								end
							end
						end
				when 14 then -- if done | if done
						if not js.return_called then
							prt_conv.item.vc_type := 0
							l_tmp___21 := mbyte_inst.enc_canon_props (option_inst.p_enc.item)
							if not ((((l_tmp___21).bit_and ((mbyte_inst.enc_canon_props (l_p_encoding))))).bit_and (1)).to_boolean then
								if 0 = (mbyte_inst.convert_setup (prt_conv, option_inst.p_enc.item, l_p_encoding)) then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E620: Unable to convert to print encoding %"%%s%"")))), l_p_encoding).do_nothing
									Result := 0
									js.return
								end
								if not js.return_called then
									prt_do_conv := 1
								end
							end
						end
						if not js.return_called then
							prt_do_conv := (prt_conv.item.vc_type /= 0).to_integer
							if prt_out_mbyte.to_boolean then
								if prt_custom_cmap.to_boolean then
									if not (prt_find_resource (prt_cmap, l_res_cmap)).to_boolean then
										message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E456: Can%'t find PostScript resource file %"%%s.ps%"")))), create {CE_POINTER [NATURAL_8]}.make_cast (prt_cmap)).do_nothing
										Result := 0
										js.return
									end
									if not js.return_called then
										if not (prt_open_resource (l_res_cmap)).to_boolean then
											Result := 0
											js.return
										end
									end
								end
							end
						end
						if not js.return_called then
							strcpy (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_prolog.item.title))).do_nothing
							strcat (l_buffer, ce_string (" ")).do_nothing
							strcat (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_prolog.item.version))).do_nothing
							prt_dsc_resources (ce_string ("DocumentSuppliedResources"), ce_string ("procset"), l_buffer)
							if prt_out_mbyte.to_boolean then
								strcpy (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_cidfont.item.title))).do_nothing
								strcat (l_buffer, ce_string (" ")).do_nothing
								strcat (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_cidfont.item.version))).do_nothing
								prt_dsc_resources (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("procset"), l_buffer)
								if prt_custom_cmap.to_boolean then
									strcpy (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_cmap.item.title))).do_nothing
									strcat (l_buffer, ce_string (" ")).do_nothing
									strcat (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_cmap.item.version))).do_nothing
									prt_dsc_resources (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("cmap"), l_buffer)
								end
							end
							if not prt_out_mbyte.to_boolean then
								strcpy (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_encoding.item.title))).do_nothing
								strcat (l_buffer, ce_string (" ")).do_nothing
								strcat (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_encoding.item.version))).do_nothing
								prt_dsc_resources (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("encoding"), l_buffer)
							elseif prt_use_courier.to_boolean then
								strcpy (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_encoding.item.title))).do_nothing
								strcat (l_buffer, ce_string (" ")).do_nothing
								strcat (l_buffer, create {CE_POINTER [INTEGER_8]}.make_cast ((l_res_encoding.item.version))).do_nothing
								prt_dsc_resources (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("encoding"), l_buffer)
							end
							prt_dsc_requirements (prt_duplex, prt_tumble, prt_collate, a_psettings.item.do_syntax, prt_num_copies)
							prt_dsc_noarg (ce_string ("EndComments"))
							prt_dsc_noarg (ce_string ("BeginDefaults"))
							if not prt_out_mbyte.to_boolean then
								prt_dsc_font_resource (ce_string ("PageResources"), prt_ps_courier_font)
							elseif prt_use_courier.to_boolean then
								prt_dsc_font_resource (ce_string ("PageResources"), prt_ps_courier_font)
							end
							if prt_out_mbyte.to_boolean then
								if prt_use_courier.to_boolean then
									l_tmp___26 := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
								else
									l_tmp___26 := ce_string ("PageResources")
								end
								prt_dsc_font_resource (l_tmp___26, prt_ps_mb_font)
								if not prt_custom_cmap.to_boolean then
									prt_dsc_resources (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("cmap"), prt_cmap)
								end
							end
							prt_dsc_textline (ce_string ("PageMedia"), prt_mediasize[prt_media].name)
							prt_dsc_noarg (ce_string ("EndDefaults"))
							prt_dsc_noarg (ce_string ("BeginProlog"))
							if not (prt_add_resource (l_res_prolog)).to_boolean then
								Result := 0
								js.return
							end
						end
						if not js.return_called and then (prt_out_mbyte.to_boolean) then
							if not (prt_add_resource (l_res_cidfont)).to_boolean then
								Result := 0
								js.return
							end
							if not js.return_called and then (prt_custom_cmap.to_boolean) then
								if not (prt_add_resource (l_res_cmap)).to_boolean then
									Result := 0
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 15 then -- if:
							if prt_out_mbyte.to_boolean then
								l_pos := -1 + 18 -- skip if block
							end
				when 16 then -- if:
							l_pos := -1 + 19 -- goto _L___1
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 18 then -- else:
							if not (prt_use_courier.to_boolean) then
								l_pos := -1 + 20 -- skip if block
							end
				when 19 then -- if: | _L___1:
							if not (prt_add_resource (l_res_encoding)).to_boolean then
								Result := 0
								js.return
							end
				when 20 then -- if done | if done
							if js.return_called then
								l_pos := -1 + 27 -- skip if block
							end
				when 21 then -- if:
								prt_dsc_noarg (ce_string ("EndProlog"))
								prt_dsc_noarg (ce_string ("BeginSetup"))
								prt_write_int ((prt_mediasize[prt_media].width).truncated_to_integer)
								prt_write_int ((prt_mediasize[prt_media].height).truncated_to_integer)
								prt_write_int (0)
								prt_write_string (ce_string ("sps%N"))
								prt_write_int (prt_num_copies)
								prt_write_string (ce_string ("nc%N"))
								prt_write_boolean (prt_duplex)
								prt_write_boolean (prt_tumble)
								prt_write_string (ce_string ("dt%N"))
								prt_write_boolean (prt_collate)
								prt_write_string (ce_string ("c%N"))
								if prt_out_mbyte.to_boolean then
									l_pos := -1 + 24 -- skip if block
								end
				when 22 then -- if:
								l_pos := -1 + 25 -- goto _L___2
				when 23 then -- if block done, skip else block:
								l_pos := -1 + 26
				when 24 then -- else:
								if not (prt_use_courier.to_boolean) then
									l_pos := -1 + 26 -- skip if block
								end
				when 25 then -- if: | _L___2:
								if prt_use_courier.to_boolean then
									l_p_encoding := create {CE_POINTER [NATURAL_8]}.make_cast (prt_ascii_encoding)
								end
								prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), prt_ps_courier_font.item.ps_fontname[0])
								prt_def_font (ce_string ("F0"), create {CE_POINTER [INTEGER_8]}.make_cast (l_p_encoding), prt_line_height.truncated_to_integer, prt_ps_courier_font.item.ps_fontname[0])
								prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), prt_ps_courier_font.item.ps_fontname[1])
								prt_def_font (ce_string ("F1"), create {CE_POINTER [INTEGER_8]}.make_cast (l_p_encoding), prt_line_height.truncated_to_integer, prt_ps_courier_font.item.ps_fontname[1])
								prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), prt_ps_courier_font.item.ps_fontname[2])
								prt_def_font (ce_string ("F2"), create {CE_POINTER [INTEGER_8]}.make_cast (l_p_encoding), prt_line_height.truncated_to_integer, prt_ps_courier_font.item.ps_fontname[2])
								prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), prt_ps_courier_font.item.ps_fontname[3])
								prt_def_font (ce_string ("F3"), create {CE_POINTER [INTEGER_8]}.make_cast (l_p_encoding), prt_line_height.truncated_to_integer, prt_ps_courier_font.item.ps_fontname[3])
				when 26 then -- if done
								if prt_out_mbyte.to_boolean then
									prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), prt_ps_mb_font.item.ps_fontname[0])
									if not prt_custom_cmap.to_boolean then
										prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("cmap"), prt_cmap)
									end
									prt_def_cidfont (ce_string ("CF0"), prt_line_height.truncated_to_integer, prt_ps_mb_font.item.ps_fontname[0])
									if not (prt_ps_mb_font.item.ps_fontname[1]).is_void then
										prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), prt_ps_mb_font.item.ps_fontname[1])
										if not prt_custom_cmap.to_boolean then
											prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("cmap"), prt_cmap)
										end
										prt_def_cidfont (ce_string ("CF1"), prt_line_height.truncated_to_integer, prt_ps_mb_font.item.ps_fontname[1])
									else
										prt_dup_cidfont (ce_string ("CF0"), ce_string ("CF1"))
									end
									if not (prt_ps_mb_font.item.ps_fontname[2]).is_void then
										prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), prt_ps_mb_font.item.ps_fontname[2])
										if not prt_custom_cmap.to_boolean then
											prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("cmap"), prt_cmap)
										end
										prt_def_cidfont (ce_string ("CF2"), prt_line_height.truncated_to_integer, prt_ps_mb_font.item.ps_fontname[2])
									else
										prt_dup_cidfont (ce_string ("CF0"), ce_string ("CF2"))
									end
									if not (prt_ps_mb_font.item.ps_fontname[3]).is_void then
										prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), prt_ps_mb_font.item.ps_fontname[3])
										if not prt_custom_cmap.to_boolean then
											prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("cmap"), prt_cmap)
										end
										prt_def_cidfont (ce_string ("CF3"), prt_line_height.truncated_to_integer, prt_ps_mb_font.item.ps_fontname[3])
									else
										prt_dup_cidfont (ce_string ("CF1"), ce_string ("CF3"))
									end
								end
								prt_def_var (ce_string ("UO"), (prt_ps_font.item.uline_offset).to_double * (prt_line_height.to_double / 1000.0), 2)
								prt_def_var (ce_string ("UW"), (prt_ps_font.item.uline_width).to_double * (prt_line_height.to_double / 1000.0), 2)
								prt_def_var (ce_string ("BO"), prt_bgcol_offset.to_double, 2)
								prt_dsc_noarg (ce_string ("EndSetup"))
								Result := (not prt_file_error.to_boolean).to_integer
				when 27 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	mch_print_begin_page (a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_page_num: CE_ARRAY [INTEGER_32]
		do
			create l_page_num.make (<<2>>)

			prt_page_num.item := prt_page_num.item + 1
			l_page_num[1] := prt_page_num.item
			l_page_num[0] := l_page_num[1]
			prt_dsc_ints (ce_string ("Page"), 2, l_page_num)
			prt_dsc_noarg (ce_string ("BeginPageSetup"))
			prt_write_string (ce_string ("sv%N0 g%N"))
			prt_in_ascii := (not prt_out_mbyte.to_boolean).to_integer
			if prt_out_mbyte.to_boolean then
				prt_write_string (ce_string ("CF0 sf%N"))
			else
				prt_write_string (ce_string ("F0 sf%N"))
			end
			prt_fgcol := ((0).to_natural_32).to_integer_32
			prt_bgcol := ((16_777_215).to_natural_32).to_integer_32
			prt_font := 0
			if not prt_portrait.to_boolean then
				prt_write_int (-(prt_mediasize[prt_media].width).truncated_to_integer)
				prt_write_string (ce_string ("sl%N"))
			end
			prt_dsc_noarg (ce_string ("EndPageSetup"))
			curr_bg := ({NATURAL_32} 4_294_967_295).to_natural_32
			curr_fg := ({NATURAL_32} 4_294_967_295).to_natural_32
			curr_bold := 2
			Result := (not prt_file_error.to_boolean).to_integer
		end

	mch_print_blank_page: INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (mch_print_begin_page (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
				l_tmp___1 := (mch_print_end_page)
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	mch_print_cleanup
		local
			l_i___0: INTEGER_32
		do
			if prt_out_mbyte.to_boolean then
				l_i___0 := 0
				from
				until
					not (l_i___0 <= 3)
				loop
					if not (prt_ps_mb_font.item.ps_fontname[l_i___0]).is_void then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (prt_ps_mb_font.item.ps_fontname[l_i___0]))
					end
					prt_ps_mb_font.item.ps_fontname[l_i___0] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_i___0 := l_i___0 + 1
				end
			end
			if prt_do_conv.to_boolean then
				mbyte_inst.convert_setup (prt_conv, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
				prt_do_conv := 0
			end
			if not prt_ps_fd.is_void then
				fclose (prt_ps_fd).do_nothing
				prt_ps_fd := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
				prt_file_error := 0
			end
			if not prt_ps_file_name.is_void then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (prt_ps_file_name))
				prt_ps_file_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
		end

	mch_print_end (a_psettings: CE_POINTER [PD_PRT_SETTINGS_T])
		do
			prt_dsc_noarg (ce_string ("Trailer"))
			prt_dsc_ints (ce_string ("Pages"), 1, prt_page_num)
			prt_dsc_noarg (ce_string ("EOF"))
			prt_write_file (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/4/")))
			if not prt_file_error.to_boolean then
				if (a_psettings.item.outfile).is_void then
					if not globals_inst.got_int.to_boolean then
						if not (a_psettings.item.user_abort).to_boolean then
							if not prt_ps_fd.is_void then
								fclose (prt_ps_fd).do_nothing
								prt_ps_fd := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
							end
							prt_message (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Sending to printer...")))))
							if (eval_inst.eval_printexpr (prt_ps_file_name, a_psettings.item.arguments)) = 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E365: Failed to print PostScript file"))))).do_nothing
							else
								prt_message (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Print job sent.")))))
							end
						end
					end
				end
			end
			mch_print_cleanup
		end

	mch_print_end_page: INTEGER_32
		do
			prt_flush_buffer
			prt_write_string (ce_string ("re sp%N"))
			prt_dsc_noarg (ce_string ("PageTrailer"))
			Result := (not prt_file_error.to_boolean).to_integer
		end

	mch_print_init (a_psettings: CE_POINTER [PD_PRT_SETTINGS_T]; a_jobname: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_paper_name: CE_POINTER [INTEGER_8]
			l_paper_strlen: INTEGER_32
			l_fontsize: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_left: CE_ARRAY [REAL_64]
			l_right: CE_ARRAY [REAL_64]
			l_top: CE_ARRAY [REAL_64]
			l_bottom: CE_ARRAY [REAL_64]
			l_props: INTEGER_32
			l_cmap: INTEGER_32
			l_p_encoding: CE_POINTER [NATURAL_8]
			l_p_mbenc: CE_ARRAY [CE_POINTER [PD_PRT_PS_ENCODING_S]]
			l_p_mbenc_first: CE_POINTER [PD_PRT_PS_ENCODING_S]
			l_p_mbchar: CE_ARRAY [CE_POINTER [PD_PRT_PS_CHARSET_S]]
			l_tmp___3: NATURAL_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_paper_name.make
			create l_p___0.make
			create l_left.make (<<1>>)
			create l_right.make (<<1>>)
			create l_top.make (<<1>>)
			create l_bottom.make (<<1>>)
			create l_p_encoding.make
			create l_p_mbenc.make (<<1>>)
			create l_p_mbenc_first.make
			create l_p_mbchar.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmap := 0
					l_p_mbchar.item := create {CE_POINTER [PD_PRT_PS_CHARSET_S]}.make_shared (default_pointer)
					l_p_encoding := mbyte_inst.enc_skip (option_inst.p_penc.item)
					if (l_p_encoding.item).to_integer_32 = 0 then
						l_p_encoding := mbyte_inst.enc_skip (option_inst.p_enc.item)
					end
					l_p_mbenc.item := create {CE_POINTER [PD_PRT_PS_ENCODING_S]}.make_shared (default_pointer)
					l_props := mbyte_inst.enc_canon_props (l_p_encoding)
					if ((l_props).bit_and (1)).to_boolean then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (option_inst.p_pmcs.item.item).to_integer_32 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if ((l_props).bit_and (4)).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_p_mbenc_first := create {CE_POINTER [PD_PRT_PS_ENCODING_S]}.make_shared (default_pointer)
						l_cmap := 0
						from
						until
							not (not js.loop_done and then (l_cmap < (((create {PD_PRT_PS_MBFONT_S}.make).structure_size.to_natural_32 * (4).to_natural_32) // (create {PD_PRT_PS_MBFONT_S}.make).structure_size.to_natural_32).to_integer_32))
						loop
							if (prt_match_encoding (create {CE_POINTER [INTEGER_8]}.make_cast (l_p_encoding), prt_ps_mbfonts + l_cmap, l_p_mbenc)).to_boolean then
								if l_p_mbenc_first.is_void then
									l_p_mbenc_first := l_p_mbenc.item
								end
								if (prt_match_charset (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_pmcs.item), prt_ps_mbfonts + l_cmap, l_p_mbchar)).to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								l_cmap := l_cmap + 1
							end
						end
						if (l_p_mbchar.item).is_void then
							if not l_p_mbenc_first.is_void then
								l_p_mbenc.item := l_p_mbenc_first
							end
						end
				when 6 then -- if done | if done
						prt_out_mbyte := (not (l_p_mbenc.item).is_void).to_integer
						if prt_out_mbyte.to_boolean then
							prt_cmap[0] := (('%/0/').code).to_integer_8
							prt_custom_cmap := ((l_p_mbchar.item).is_void).to_integer
							if not prt_custom_cmap.to_boolean then
								if ((l_p_mbenc.item.item.needs_charset).bit_and (l_p_mbchar.item.item.has_charset)) = 0 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E673: Incompatible multi-byte encoding and character set."))))).do_nothing
									Result := 0
									js.return
								end
								if not js.return_called and then (not (l_p_mbchar.item.item.cmap_charset).is_void) then
									misc2_inst.vim_strncpy (create {CE_POINTER [NATURAL_8]}.make_cast (prt_cmap), create {CE_POINTER [NATURAL_8]}.make_cast (l_p_mbchar.item.item.cmap_charset), ({PLATFORM}.Integer_8_bytes.to_natural_32 * (80).to_natural_32) - {NATURAL_32} 3)
									strcat (prt_cmap, ce_string ("-")).do_nothing
								end
							else
								if (option_inst.p_pmcs.item.item).to_integer_32 = 0 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E674: printmbcharset cannot be empty with multi-byte encoding."))))).do_nothing
									Result := 0
									js.return
								end
								if not js.return_called then
									misc2_inst.vim_strncpy (create {CE_POINTER [NATURAL_8]}.make_cast (prt_cmap), option_inst.p_pmcs.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (80).to_natural_32) - {NATURAL_32} 3)
									strcat (prt_cmap, ce_string ("-")).do_nothing
								end
							end
							if not js.return_called then
								if not (l_p_mbenc.item.item.cmap_encoding).is_void then
									l_tmp___3 := strlen (prt_cmap)
									if (l_tmp___3 + (strlen (l_p_mbenc.item.item.cmap_encoding))) + {NATURAL_32} 3 < ({PLATFORM}.Integer_8_bytes.to_natural_32 * (80).to_natural_32) then
										strcat (prt_cmap, l_p_mbenc.item.item.cmap_encoding).do_nothing
										strcat (prt_cmap, ce_string ("-")).do_nothing
									end
								end
								strcat (prt_cmap, ce_string ("H")).do_nothing
								if not (mbfont_opts[2].present).to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E675: No default font specified for multi-byte printing."))))).do_nothing
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								if not (prt_build_cid_fontname (0, mbfont_opts[2].string, mbfont_opts[2].strlen)).to_boolean then
									Result := 0
									js.return
								end
							end
							if not js.return_called and then ((mbfont_opts[3].present).to_boolean) then
								if not (prt_build_cid_fontname (1, mbfont_opts[3].string, mbfont_opts[3].strlen)).to_boolean then
									Result := 0
									js.return
								end
							end
							if not js.return_called and then ((mbfont_opts[4].present).to_boolean) then
								if not (prt_build_cid_fontname (2, mbfont_opts[4].string, mbfont_opts[4].strlen)).to_boolean then
									Result := 0
									js.return
								end
							end
							if not js.return_called and then ((mbfont_opts[5].present).to_boolean) then
								if not (prt_build_cid_fontname (3, mbfont_opts[5].string, mbfont_opts[5].strlen)).to_boolean then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								if (mbfont_opts[0].present).to_boolean then
									if (mbfont_opts[0].string[0]).to_integer_32 < 65 then
										l_tmp___10 := (mbfont_opts[0].string[0]).to_integer_32
									elseif (mbfont_opts[0].string[0]).to_integer_32 > 90 then
										l_tmp___10 := (mbfont_opts[0].string[0]).to_integer_32
									else
										l_tmp___10 := (mbfont_opts[0].string[0]).to_integer_32 + 32
									end
									if l_tmp___10 = 121 then
										l_tmp___11 := 1
									else
										l_tmp___11 := 0
									end
								else
									l_tmp___11 := 0
								end
								prt_use_courier := l_tmp___11
								if prt_use_courier.to_boolean then
									if (mbfont_opts[1].present).to_boolean then
										if (mbfont_opts[1].string[0]).to_integer_32 < 65 then
											l_tmp___12 := (mbfont_opts[1].string[0]).to_integer_32
										elseif (mbfont_opts[1].string[0]).to_integer_32 > 90 then
											l_tmp___12 := (mbfont_opts[1].string[0]).to_integer_32
										else
											l_tmp___12 := (mbfont_opts[1].string[0]).to_integer_32 + 32
										end
										if l_tmp___12 = 121 then
											prt_ascii_encoding := ce_string ("ascii")
										else
											prt_ascii_encoding := prt_ps_mbfonts[l_cmap].ascii_enc
										end
									else
										prt_ascii_encoding := prt_ps_mbfonts[l_cmap].ascii_enc
									end
								end
								prt_ps_font := prt_ps_mb_font
							end
						else
							prt_use_courier := 0
							prt_ps_font := prt_ps_courier_font
						end
						if not js.return_called then
							if not (globals_inst.printer_opts[9].present).to_boolean then
								l_tmp___14 := 1
							else
								if (globals_inst.printer_opts[9].string[0]).to_integer_32 < 65 then
									l_tmp___13 := (globals_inst.printer_opts[9].string[0]).to_integer_32
								elseif (globals_inst.printer_opts[9].string[0]).to_integer_32 > 90 then
									l_tmp___13 := (globals_inst.printer_opts[9].string[0]).to_integer_32
								else
									l_tmp___13 := (globals_inst.printer_opts[9].string[0]).to_integer_32 + 32
								end
								if l_tmp___13 = 121 then
									l_tmp___14 := 1
								else
									l_tmp___14 := 0
								end
							end
							prt_portrait := l_tmp___14
							if (globals_inst.printer_opts[10].present).to_boolean then
								l_paper_name := create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.printer_opts[10].string)
								l_paper_strlen := globals_inst.printer_opts[10].strlen
							else
								l_paper_name := ce_string ("A4")
								l_paper_strlen := 2
							end
							l_i___0 := 0
							from
							until
								not (not js.loop_done and then (l_i___0 < (((create {PD_PRT_MEDIASIZE_S}.make).structure_size.to_natural_32 * (14).to_natural_32) // (create {PD_PRT_MEDIASIZE_S}.make).structure_size.to_natural_32).to_integer_32))
							loop
								if (strlen (prt_mediasize[l_i___0].name)) = l_paper_strlen.to_natural_32 then
									if (strncasecmp (prt_mediasize[l_i___0].name, l_paper_name, l_paper_strlen.to_natural_32)) = 0 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							if l_i___0.to_natural_32 = ((create {PD_PRT_MEDIASIZE_S}.make).structure_size.to_natural_32 * (14).to_natural_32) // (create {PD_PRT_MEDIASIZE_S}.make).structure_size.to_natural_32 then
								l_i___0 := 0
							end
							prt_media := l_i___0
							if prt_portrait.to_boolean then
								prt_page_width := prt_mediasize[l_i___0].width
								prt_page_height := prt_mediasize[l_i___0].height
							else
								prt_page_width := prt_mediasize[l_i___0].height
								prt_page_height := prt_mediasize[l_i___0].width
							end
							prt_page_margins (prt_page_width.to_double, prt_page_height.to_double, l_left, l_right, l_top, l_bottom)
							prt_left_margin := (l_left.item).truncated_to_real
							prt_right_margin := (l_right.item).truncated_to_real
							prt_top_margin := (l_top.item).truncated_to_real
							prt_bottom_margin := (l_bottom.item).truncated_to_real
							l_fontsize := 10
							l_p___0 := option_inst.p_pfn.item
							from
							until
								js.loop_done
							loop
								l_p___0 := misc2_inst.vim_strchr (l_p___0, (':').code)
								if l_p___0.is_void then
									js.break
								end
								if not js.loop_jumped then
									if (l_p___0[1]).to_integer_32 = 104 then
										if (l_p___0[2]).to_integer_32 >= 48 then
											if (l_p___0[2]).to_integer_32 <= 57 then
												l_fontsize := atoi ((create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0) + 2))
											end
										end
									end
									l_p___0 := l_p___0 + 1
								end
							end
							prt_font_metrics (l_fontsize)
							a_psettings.item.chars_per_line := prt_get_cpl
							a_psettings.item.lines_per_page := prt_get_lpp
							if a_psettings.item.chars_per_line <= 0 then
								Result := 0
								js.return
							elseif a_psettings.item.lines_per_page <= 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							a_psettings.item.n_collated_copies := 1
							a_psettings.item.n_uncollated_copies := 1
							prt_num_copies := 1
							if not (globals_inst.printer_opts[11].present).to_boolean then
								l_tmp___18 := 1
							else
								if (globals_inst.printer_opts[11].string[0]).to_integer_32 < 65 then
									l_tmp___17 := (globals_inst.printer_opts[11].string[0]).to_integer_32
								elseif (globals_inst.printer_opts[11].string[0]).to_integer_32 > 90 then
									l_tmp___17 := (globals_inst.printer_opts[11].string[0]).to_integer_32
								else
									l_tmp___17 := (globals_inst.printer_opts[11].string[0]).to_integer_32 + 32
								end
								if l_tmp___17 = 121 then
									l_tmp___18 := 1
								else
									l_tmp___18 := 0
								end
							end
							prt_collate := l_tmp___18
							if prt_collate.to_boolean then
								a_psettings.item.n_collated_copies := 1
							else
								prt_num_copies := 1
							end
							a_psettings.item.jobname := a_jobname
							prt_duplex := 1
							prt_tumble := 0
							a_psettings.item.duplex := 1
							if (globals_inst.printer_opts[8].present).to_boolean then
								if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.printer_opts[8].string), ce_string ("off"), (3).to_natural_32)) = 0 then
									prt_duplex := 0
									a_psettings.item.duplex := 0
								elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.printer_opts[8].string), ce_string ("short"), (5).to_natural_32)) = 0 then
									prt_tumble := 1
								end
							end
							a_psettings.item.user_abort := 0
							if (a_psettings.item.outfile).is_void then
								prt_ps_file_name := fileio_inst.vim_tempname (('p').code)
								if prt_ps_file_name.is_void then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notmp))))).do_nothing
									Result := 0
									js.return
								end
								if not js.return_called then
									prt_ps_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (prt_ps_file_name), ce_string ("w"))
								end
							else
								l_p___0 := misc1_inst.expand_env_save (a_psettings.item.outfile)
								if not l_p___0.is_void then
									prt_ps_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("w"))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								end
							end
						end
						if not js.return_called and then (prt_ps_fd.is_void) then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E324: Can%'t open PostScript output file"))))).do_nothing
							mch_print_cleanup
							Result := 0
							js.return
						end
						if not js.return_called then
							prt_bufsiz := a_psettings.item.chars_per_line
							if prt_out_mbyte.to_boolean then
								prt_bufsiz := prt_bufsiz * (2)
							end
							misc2_inst.ga_init2 (prt_ps_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32).to_integer_32, prt_bufsiz)
							prt_page_num.item := 0
							prt_attribute_change := 0
							prt_need_moveto := 0
							prt_need_font := 0
							prt_need_fgcol := 0
							prt_need_bgcol := 0
							prt_need_underline := 0
							prt_file_error := 0
							Result := 1
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mch_print_set_bg (a_bgcol: NATURAL_32)
		do
			prt_bgcol := a_bgcol.to_integer_32
			prt_attribute_change := 1
			prt_need_bgcol := 1
		end

	mch_print_set_fg (a_fgcol: NATURAL_32)
		do
			if a_fgcol /= prt_fgcol.to_natural_32 then
				prt_fgcol := a_fgcol.to_integer_32
				prt_attribute_change := 1
				prt_need_fgcol := 1
			end
		end

	mch_print_set_font (a_iBold: INTEGER_32; a_iItalic: INTEGER_32; a_iUnderline: INTEGER_32)
		local
			l_font: INTEGER_32
		do
			l_font := 0
			if a_iBold.to_boolean then
				l_font := (l_font).bit_or ((1))
			end
			if a_iItalic.to_boolean then
				l_font := (l_font).bit_or ((2))
			end
			if l_font /= prt_font then
				prt_font := l_font
				prt_attribute_change := 1
				prt_need_font := 1
			end
			if prt_underline /= a_iUnderline then
				prt_underline := a_iUnderline
				prt_attribute_change := 1
				prt_need_underline := 1
			end
		end

	mch_print_start_line (a_margin: INTEGER_32; a_page_line: INTEGER_32)
		do
			prt_pos_x := prt_left_margin
			if a_margin.to_boolean then
				prt_pos_x := prt_pos_x - prt_number_width
			end
			prt_pos_y := (prt_top_margin - prt_first_line_height) - a_page_line.to_real * prt_line_height
			prt_attribute_change := 1
			prt_need_moveto := 1
			prt_half_width := 0
		end

	mch_print_text_out (a_p___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: CE_ARRAY [INTEGER_32]
			l_need_break: INTEGER_32
			l_ch: NATURAL_8
			l_ch_buff: CE_ARRAY [NATURAL_8]
			l_char_width: REAL_32
			l_next_pos: REAL_32
			l_in_ascii: INTEGER_32
			l_half_width: INTEGER_32
			l_tmp: INTEGER_32
			l_r: INTEGER_32
			l_g: INTEGER_32
			l_b: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_len.make (<<1>>)
			create l_ch_buff.make (<<8>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
					l_len.item := a_len
					l_char_width := prt_char_width
					if prt_use_courier.to_boolean then
						if l_len.item = 1 then
							if (l_p___0.item).to_integer_32 < 128 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_in_ascii := l_tmp
						if prt_in_ascii.to_boolean then
							if not l_in_ascii.to_boolean then
								prt_in_ascii := 0
								prt_need_font := 1
								prt_attribute_change := 1
							end
						elseif l_in_ascii.to_boolean then
							prt_in_ascii := 1
							prt_need_font := 1
							prt_attribute_change := 1
						end
					end
					if prt_out_mbyte.to_boolean then
						l_half_width := ((globals_inst.mb_ptr2cells.integer_32_item ([l_p___0])) = 1).to_integer
						if l_half_width.to_boolean then
							l_char_width := l_char_width / (2).to_real
						end
						if prt_half_width.to_boolean then
							if not l_half_width.to_boolean then
								prt_half_width := 0
								prt_pos_x := prt_pos_x + (prt_char_width / (4).to_real)
								prt_need_moveto := 1
								prt_attribute_change := 1
							end
						elseif l_half_width.to_boolean then
							prt_half_width := 1
							prt_pos_x := prt_pos_x + (prt_char_width / (4).to_real)
							prt_need_moveto := 1
							prt_attribute_change := 1
						end
					end
					if prt_attribute_change.to_boolean then
						prt_flush_buffer
						prt_text_run := (0).to_real
						if prt_need_moveto.to_boolean then
							prt_pos_x_moveto := prt_pos_x
							prt_pos_y_moveto := prt_pos_y
							prt_do_moveto := 1
							prt_need_moveto := 0
						end
						if prt_need_font.to_boolean then
							if not prt_in_ascii.to_boolean then
								prt_write_string (ce_string ("CF"))
							else
								prt_write_string (ce_string ("F"))
							end
							prt_write_int (prt_font)
							prt_write_string (ce_string ("sf%N"))
							prt_need_font := 0
						end
						if prt_need_fgcol.to_boolean then
							l_r := ((((prt_fgcol.to_natural_32).bit_and ({NATURAL_32} 16_711_680))).bit_shift_right (16)).to_integer_32
							l_g := ((((prt_fgcol.to_natural_32).bit_and ({NATURAL_32} 65_280))).bit_shift_right (8)).to_integer_32
							l_b := (prt_fgcol).bit_and (255)
							prt_write_real (l_r.to_double / 255.0, 3)
							if l_r = l_g then
								if l_g = l_b then
									prt_write_string (ce_string ("g%N"))
								else
									prt_write_real (l_g.to_double / 255.0, 3)
									prt_write_real (l_b.to_double / 255.0, 3)
									prt_write_string (ce_string ("r%N"))
								end
							else
								prt_write_real (l_g.to_double / 255.0, 3)
								prt_write_real (l_b.to_double / 255.0, 3)
								prt_write_string (ce_string ("r%N"))
							end
							prt_need_fgcol := 0
						end
						if prt_bgcol.to_natural_32 /= {NATURAL_32} 16_777_215 then
							prt_new_bgcol := prt_bgcol
							if prt_need_bgcol.to_boolean then
								prt_do_bgcol := 1
							end
						else
							prt_do_bgcol := 0
						end
						prt_need_bgcol := 0
						if prt_need_underline.to_boolean then
							prt_do_underline := prt_underline
						end
						prt_need_underline := 0
						prt_attribute_change := 0
					end
					if prt_do_conv.to_boolean then
						l_p___0 := mbyte_inst.string_convert (prt_conv, l_p___0, l_len)
						if l_p___0.is_void then
							l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
						end
					end
					if not (prt_out_mbyte.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							l_ch := prt_hexchar[(((l_p___0.item).to_natural_32).bit_shift_right (4)).to_integer_32]
							misc2_inst.ga_append (prt_ps_buffer, l_ch.to_integer_32)
							l_ch := prt_hexchar[((l_p___0.item).to_integer_32).bit_and (15)]
							misc2_inst.ga_append (prt_ps_buffer, l_ch.to_integer_32)
							l_p___0 := l_p___0 + 1
							l_len.item := l_len.item - 1
							if not (l_len.item).to_boolean then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 3 then -- else:
						l_ch := l_p___0.item
						if not (l_ch.to_integer_32 < 32) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else:
						if l_ch.to_integer_32 /= 40 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 9 then -- else:
						if l_ch.to_integer_32 /= 41 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else:
						if l_ch.to_integer_32 /= 92 then
							l_pos := -1 + 24 -- skip if block
						end
				when 13 then -- if: | _L:
						misc2_inst.ga_append (prt_ps_buffer, ('\').code)
						inspect l_ch.to_integer_32 -- switch 1 head
						when 8 then l_pos := -1 + 14
						when 9 then l_pos := -1 + 15
						when 10 then l_pos := -1 + 16
						when 12 then l_pos := -1 + 17
						when 13 then l_pos := -1 + 18
						when 40 then l_pos := -1 + 19
						when 41 then l_pos := -1 + 20
						when 92 then l_pos := -1 + 21
						else l_pos := -1 + 22
						end
				when 14 then -- switch 1, case 8
						misc2_inst.ga_append (prt_ps_buffer, ('b').code)
						l_pos := -1 + 23 -- switch 1; break
				when 15 then -- switch 1, case 9
						misc2_inst.ga_append (prt_ps_buffer, ('t').code)
						l_pos := -1 + 23 -- switch 1; break
				when 16 then -- switch 1, case 10
						misc2_inst.ga_append (prt_ps_buffer, ('n').code)
						l_pos := -1 + 23 -- switch 1; break
				when 17 then -- switch 1, case 12
						misc2_inst.ga_append (prt_ps_buffer, ('f').code)
						l_pos := -1 + 23 -- switch 1; break
				when 18 then -- switch 1, case 13
						misc2_inst.ga_append (prt_ps_buffer, ('r').code)
						l_pos := -1 + 23 -- switch 1; break
				when 19 then -- switch 1, case 40
						misc2_inst.ga_append (prt_ps_buffer, ('(').code)
						l_pos := -1 + 23 -- switch 1; break
				when 20 then -- switch 1, case 41
						misc2_inst.ga_append (prt_ps_buffer, (')').code)
						l_pos := -1 + 23 -- switch 1; break
				when 21 then -- switch 1, case 92
						misc2_inst.ga_append (prt_ps_buffer, ('\').code)
						l_pos := -1 + 23 -- switch 1; break
				when 22 then -- switch 1, default:
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_ch_buff), ce_string ("%%03o"), l_ch.to_natural_32]).do_nothing
						misc2_inst.ga_append (prt_ps_buffer, (l_ch_buff[0]).to_integer_32)
						misc2_inst.ga_append (prt_ps_buffer, (l_ch_buff[1]).to_integer_32)
						misc2_inst.ga_append (prt_ps_buffer, (l_ch_buff[2]).to_integer_32)
						l_pos := -1 + 23 -- switch 1; break
				when 23 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						misc2_inst.ga_append (prt_ps_buffer, l_ch.to_integer_32)
				when 25 then -- if done | if done | if done | if done
						if prt_do_conv.to_boolean then
							if (l_p___0.item).to_integer_32 /= 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
							end
						end
						prt_text_run := prt_text_run + l_char_width
						prt_pos_x := prt_pos_x + l_char_width
						l_next_pos := prt_pos_x + prt_char_width
						if l_next_pos > prt_right_margin then
							if (l_next_pos - prt_right_margin).to_double > prt_right_margin.to_double * 1.e-5 then
								l_tmp___1 := 1
							else
								l_tmp___1 := 0
							end
						else
							l_tmp___1 := 0
						end
						l_need_break := l_tmp___1
						if l_need_break.to_boolean then
							prt_flush_buffer
						end
						Result := l_need_break
				when 26 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	parse_list_options (a_option_str: CE_POINTER [NATURAL_8]; a_table: CE_POINTER [PD_OPTION_TABLE_T]; a_table_size: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_stringp: CE_POINTER [NATURAL_8]
			l_colonp: CE_POINTER [NATURAL_8]
			l_commap: CE_POINTER [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_idx: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_stringp.make
			create l_colonp.make
			create l_commap.make
			create l_p___0.make (<<1>>)

			l_idx := 0
			l_idx := 0
			from
			until
				not (l_idx < a_table_size)
			loop
				(a_table + l_idx).item.present := 0
				l_idx := l_idx + 1
			end
			l_stringp := a_option_str
			from
			until
				not (not js.loop_done and then ((l_stringp.item).to_boolean))
			loop
				l_colonp := misc2_inst.vim_strchr (l_stringp, (':').code)
				if l_colonp.is_void then
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E550: Missing colon")))
					js.return
				end
				if not js.return_called then
					l_commap := misc2_inst.vim_strchr (l_stringp, (',').code)
					if l_commap.is_void then
						l_commap := a_option_str + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_option_str))).to_integer_32
					end
					l_len := l_colonp.distance (l_stringp)
					l_idx := 0
					from
					until
						not (not js.loop_done and then (l_idx < a_table_size))
					loop
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_stringp), (a_table + l_idx).item.name, l_len.to_natural_32)) = 0 then
							js.break
						end
						if not js.loop_jumped then
							l_idx := l_idx + 1
						end
					end
					if l_idx = a_table_size then
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E551: Illegal component")))
						js.return
					end
				end
				if not js.return_called then
					l_p___0.item := l_colonp + 1;
					(a_table + l_idx).item.present := 1
					if ((a_table + l_idx).item.hasnum).to_boolean then
						if (l_p___0.item.item).to_integer_32 >= 48 then
							if not ((l_p___0.item.item).to_integer_32 <= 57) then
								Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E552: digit expected")))
								js.return
							end
						else
							Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E552: digit expected")))
							js.return
						end
						if not js.return_called then
							(a_table + l_idx).item.number := charset_inst.getdigits (l_p___0)
						end
					end
				end
				if not js.return_called then
					(a_table + l_idx).item.string := l_p___0.item;
					(a_table + l_idx).item.strlen := l_commap.distance ((l_p___0.item))
					l_stringp := l_commap
					if (l_stringp.item).to_integer_32 = 44 then
						l_stringp := l_stringp + 1
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	parse_printmbfont: CE_POINTER [NATURAL_8]
		do
			Result := (parse_list_options (option_inst.p_pmfn.item, mbfont_opts, 6))
		end

	parse_printoptions: CE_POINTER [NATURAL_8]
		do
			Result := (parse_list_options (option_inst.p_popt.item, globals_inst.printer_opts, 14))
		end

	prt_add_resource (a_resource: CE_POINTER [PD_PRT_PS_RESOURCE_S]): INTEGER_32
		local
			l_fd_resource: CE_POINTER [SD_IO_FILE]
			l_resource_buffer: CE_ARRAY [NATURAL_8]
			l_bytes_read: NATURAL_32
			js: JUMP_STATE
		do
			create l_fd_resource.make
			create l_resource_buffer.make (<<512>>)

			l_fd_resource := fopen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_resource.item.filename)), ce_string ("r"))
			if l_fd_resource.is_void then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E456: Can%'t open file %"%%s%"")))), a_resource.item.filename).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				prt_dsc_resources (ce_string ("BeginResource"), prt_resource_types[a_resource.item.type], create {CE_POINTER [INTEGER_8]}.make_cast ((a_resource.item.title)))
				prt_dsc_textline (ce_string ("BeginDocument"), create {CE_POINTER [INTEGER_8]}.make_cast ((a_resource.item.filename)))
				from
				until
					js.loop_done
				loop
					l_bytes_read := fread (create {CE_POINTER [ANY]}.make_cast (l_resource_buffer), {PLATFORM}.Natural_8_bytes.to_natural_32, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (512).to_natural_32), l_fd_resource)
					if (ferror (l_fd_resource)).to_boolean then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E457: Can%'t read PostScript resource file %"%%s%"")))), a_resource.item.filename).do_nothing
						fclose (l_fd_resource).do_nothing
						Result := 0
						js.return
					end
					if not js.return_called then
						if l_bytes_read = {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							prt_write_file_raw_len (l_resource_buffer, l_bytes_read.to_integer_32)
							if prt_file_error.to_boolean then
								fclose (l_fd_resource).do_nothing
								Result := 0
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				fclose (l_fd_resource).do_nothing
				prt_dsc_noarg (ce_string ("EndDocument"))
				prt_dsc_noarg (ce_string ("EndResource"))
				Result := 1
			end
		end

	prt_build_cid_fontname (a_font: INTEGER_32; a_name___1: CE_POINTER [NATURAL_8]; a_name_len: INTEGER_32): INTEGER_32
		local
			l_fontname: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_fontname.make

			l_fontname := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.alloc ((a_name_len + 1).to_natural_32)))
			if l_fontname.is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				misc2_inst.vim_strncpy (create {CE_POINTER [NATURAL_8]}.make_cast (l_fontname), a_name___1, a_name_len.to_natural_32)
				prt_ps_mb_font.item.ps_fontname[a_font] := l_fontname
				Result := 1
			end
		end

	prt_check_resource (a_resource: CE_POINTER [PD_PRT_PS_RESOURCE_S]; a_version: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((a_resource.item.version)), create {CE_POINTER [INTEGER_8]}.make_cast (a_version), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_version))))).to_boolean then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E621: %"%%s%" resource file has wrong version")))), a_resource.item.name).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	prt_def_cidfont (a_new_name: CE_POINTER [INTEGER_8]; a_height: INTEGER_32; a_cidfont: CE_POINTER [INTEGER_8])
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/_%%s /%%s[/%%s] vim_composefont%N"), a_new_name, prt_cmap, a_cidfont]).do_nothing
			prt_write_file (prt_line_buffer)
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/%%s %%d /_%%s ffs%N"), a_new_name, a_height, a_new_name]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_def_font (a_new_name: CE_POINTER [INTEGER_8]; a_encoding: CE_POINTER [INTEGER_8]; a_height: INTEGER_32; a_font: CE_POINTER [INTEGER_8])
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/_%%s /VIM-%%s /%%s ref%N"), a_new_name, a_encoding, a_font]).do_nothing
			prt_write_file (prt_line_buffer)
			if prt_out_mbyte.to_boolean then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string ("/%%s %%d %%f /_%%s sffs%N"), a_new_name, a_height, 500. / (prt_ps_courier_font.item.wx).to_double, a_new_name]).do_nothing
			else
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/%%s %%d /_%%s ffs%N"), a_new_name, a_height, a_new_name]).do_nothing
			end
			prt_write_file (prt_line_buffer)
		end

	prt_def_var (a_name___1: CE_POINTER [INTEGER_8]; a_value: REAL_64; a_prec: INTEGER_32)
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/%%s "), a_name___1]).do_nothing
			prt_write_file (prt_line_buffer)
			prt_write_real (a_value, a_prec)
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string ("d%N")]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_dsc_docmedia (a_paper_name: CE_POINTER [INTEGER_8]; a_width: REAL_64; a_height: REAL_64; a_weight: REAL_64; a_colour: CE_POINTER [INTEGER_8]; a_type: CE_POINTER [INTEGER_8])
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%DocumentMedia: %%s "), a_paper_name]).do_nothing
			prt_write_file (prt_line_buffer)
			prt_write_real (a_width, 2)
			prt_write_real (a_height, 2)
			prt_write_real (a_weight, 2)
			if a_colour.is_void then
				prt_write_string (ce_string ("()"))
			else
				prt_write_string (a_colour)
			end
			prt_write_string (ce_string (" "))
			if a_type.is_void then
				prt_write_string (ce_string ("()"))
			else
				prt_write_string (a_type)
			end
			prt_write_string (ce_string ("%N"))
		end

	prt_dsc_font_resource (a_resource: CE_POINTER [INTEGER_8]; a_ps_font: CE_POINTER [PD_PRT_PS_FONT_S])
		local
			l_i___0: INTEGER_32
		do
			prt_dsc_resources (a_resource, ce_string ("font"), a_ps_font.item.ps_fontname[0])
			l_i___0 := 1
			from
			until
				not (l_i___0 <= 3)
			loop
				if not (a_ps_font.item.ps_fontname[l_i___0]).is_void then
					prt_dsc_resources (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("font"), a_ps_font.item.ps_fontname[l_i___0])
				end
				l_i___0 := l_i___0 + 1
			end
		end

	prt_dsc_ints (a_comment: CE_POINTER [INTEGER_8]; a_count___2: INTEGER_32; a_ints: CE_POINTER [INTEGER_32])
		local
			l_i___0: INTEGER_32
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s:"), a_comment]).do_nothing
			prt_write_file (prt_line_buffer)
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_count___2)
			loop
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string (" %%d"), a_ints[l_i___0]]).do_nothing
				prt_write_file (prt_line_buffer)
				l_i___0 := l_i___0 + 1
			end
			prt_write_string (ce_string ("%N"))
		end

	prt_dsc_noarg (a_comment: CE_POINTER [INTEGER_8])
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s%N"), a_comment]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_dsc_requirements (a_duplex: INTEGER_32; a_tumble: INTEGER_32; a_collate: INTEGER_32; a_color: INTEGER_32; a_num_copies: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if not a_duplex.to_boolean then
				if not a_collate.to_boolean then
					if not a_color.to_boolean then
						if not (a_num_copies > 1) then
							js.return
						end
					end
				end
			end
			if not js.return_called then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string ("%%%%%%%%Requirements:")]).do_nothing
				prt_write_file (prt_line_buffer)
				if a_duplex.to_boolean then
					prt_write_string (ce_string (" duplex"))
					if a_tumble.to_boolean then
						prt_write_string (ce_string ("(tumble)"))
					end
				end
				if a_collate.to_boolean then
					prt_write_string (ce_string (" collate"))
				end
				if a_color.to_boolean then
					prt_write_string (ce_string (" color"))
				end
				if a_num_copies > 1 then
					prt_write_string (ce_string (" numcopies("))
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string ("%%d"), a_num_copies]).do_nothing
					prt_write_file (prt_line_buffer)
					prt_write_string (ce_string (")"))
				end
				prt_write_string (ce_string ("%N"))
			end
		end

	prt_dsc_resources (a_comment: CE_POINTER [INTEGER_8]; a_type: CE_POINTER [INTEGER_8]; a_string___0: CE_POINTER [INTEGER_8])
		do
			if not a_comment.is_void then
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s: %%s"), a_comment, a_type]).do_nothing
			else
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%+ %%s"), a_type]).do_nothing
			end
			prt_write_file (prt_line_buffer)
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string (" %%s%N"), a_string___0]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_dsc_start
		do
			prt_write_string (ce_string ("%%!PS-Adobe-3.0%N"))
		end

	prt_dsc_text (a_comment: CE_POINTER [INTEGER_8]; a_text: CE_POINTER [INTEGER_8])
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s: (%%s)%N"), a_comment, a_text]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_dsc_textline (a_comment: CE_POINTER [INTEGER_8]; a_text: CE_POINTER [INTEGER_8])
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s: %%s%N"), a_comment, a_text]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_dup_cidfont (a_original_name: CE_POINTER [INTEGER_8]; a_new_name: CE_POINTER [INTEGER_8])
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/%%s %%s d%N"), a_new_name, a_original_name]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_find_resource (a_name___1: CE_POINTER [INTEGER_8]; a_resource: CE_POINTER [PD_PRT_PS_RESOURCE_S]): INTEGER_32
		local
			l_buffer: CE_ARRAY [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			create l_buffer.make (<<4_097>>)

			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((a_resource.item.name)), a_name___1).do_nothing
			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer), ce_string ("print")).do_nothing
			misc1_inst.add_pathsep (l_buffer)
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer), a_name___1).do_nothing
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer), ce_string (".ps")).do_nothing
			a_resource.item.filename[0] := (('%/0/').code).to_natural_8
			if (ex_cmds2_inst.do_in_runtimepath (l_buffer, 0, prt_resource_name_address, create {CE_POINTER [ANY]}.make_cast ((a_resource.item.filename)))).to_boolean then
				if (a_resource.item.filename[0]).to_integer_32 /= 0 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	prt_flush_buffer
		local
			l_r: INTEGER_32
			l_g: INTEGER_32
			l_b: INTEGER_32
		do
			if prt_ps_buffer.item.ga_len > 0 then
				if prt_do_bgcol.to_boolean then
					if prt_new_bgcol.to_natural_32 /= {NATURAL_32} 16_777_215 then
						if prt_do_moveto.to_boolean then
							prt_write_real (prt_pos_x_moveto.to_double, 2)
							prt_write_real (prt_pos_y_moveto.to_double, 2)
							prt_write_string (ce_string ("m%N"))
							prt_do_moveto := 0
						end
						prt_write_real (prt_text_run.to_double, 2)
						prt_write_real (prt_line_height.to_double, 2)
						l_r := ((((prt_new_bgcol.to_natural_32).bit_and ({NATURAL_32} 16_711_680))).bit_shift_right (16)).to_integer_32
						l_g := ((((prt_new_bgcol.to_natural_32).bit_and ({NATURAL_32} 65_280))).bit_shift_right (8)).to_integer_32
						l_b := (prt_new_bgcol).bit_and (255)
						prt_write_real (l_r.to_double / 255.0, 3)
						prt_write_real (l_g.to_double / 255.0, 3)
						prt_write_real (l_b.to_double / 255.0, 3)
						prt_write_string (ce_string ("bg%N"))
					end
				end
				if prt_do_underline.to_boolean then
					if prt_do_moveto.to_boolean then
						prt_write_real (prt_pos_x_moveto.to_double, 2)
						prt_write_real (prt_pos_y_moveto.to_double, 2)
						prt_write_string (ce_string ("m%N"))
						prt_do_moveto := 0
					end
					prt_write_real (prt_text_run.to_double, 2)
					prt_write_string (ce_string ("ul%N"))
				end
				if prt_out_mbyte.to_boolean then
					prt_write_string (ce_string ("<"))
				else
					prt_write_string (ce_string ("("))
				end
				prt_write_file_raw_len (create {CE_POINTER [NATURAL_8]}.make_cast (prt_ps_buffer.item.ga_data), prt_ps_buffer.item.ga_len)
				if prt_out_mbyte.to_boolean then
					prt_write_string (ce_string (">"))
				else
					prt_write_string (ce_string (")"))
				end
				if prt_do_moveto.to_boolean then
					prt_write_real (prt_pos_x_moveto.to_double, 2)
					prt_write_real (prt_pos_y_moveto.to_double, 2)
					prt_write_string (ce_string ("ms%N"))
					prt_do_moveto := 0
				else
					prt_write_string (ce_string ("s%N"))
				end
				misc2_inst.ga_clear (prt_ps_buffer)
				misc2_inst.ga_init2 (prt_ps_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32).to_integer_32, prt_bufsiz)
			end
		end

	prt_font_metrics (a_font_scale: INTEGER_32)
		do
			prt_line_height := a_font_scale.to_real
			prt_char_width := ((prt_ps_font.item.wx).to_double * (a_font_scale.to_double / 1000.0)).truncated_to_real
		end

	prt_get_attr (a_hl_id: INTEGER_32; a_pattr: CE_POINTER [PD_PRT_TEXT_ATTR_T]; a_modec: INTEGER_32)
		local
			l_colorindex: INTEGER_32
			l_fg_color: NATURAL_32
			l_bg_color: NATURAL_32
			l_color: CE_POINTER [INTEGER_8]
		do
			create l_color.make

			a_pattr.item.bold := (not (syntax_inst.highlight_has_attr (a_hl_id, 2, a_modec)).is_void).to_integer
			a_pattr.item.italic := (not (syntax_inst.highlight_has_attr (a_hl_id, 4, a_modec)).is_void).to_integer
			a_pattr.item.underline := (not (syntax_inst.highlight_has_attr (a_hl_id, 8, a_modec)).is_void).to_integer
			a_pattr.item.undercurl := (not (syntax_inst.highlight_has_attr (a_hl_id, 16, a_modec)).is_void).to_integer
			if (gui_inst.gui.item.in_use).to_boolean then
				l_bg_color := syntax_inst.highlight_gui_color_rgb (a_hl_id, 0)
				if l_bg_color = {NATURAL_32} 0 then
					l_bg_color := (16_777_215).to_natural_32
				end
				l_fg_color := syntax_inst.highlight_gui_color_rgb (a_hl_id, 1)
			else
				l_bg_color := (16_777_215).to_natural_32
				l_color := create {CE_POINTER [INTEGER_8]}.make_cast ((syntax_inst.highlight_color (a_hl_id, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fg")), a_modec)))
				if l_color.is_void then
					l_colorindex := 0
				else
					l_colorindex := atoi (l_color)
				end
				if l_colorindex >= 0 then
					if l_colorindex < globals_inst.t_colors then
						l_fg_color := prt_get_term_color (l_colorindex)
					else
						l_fg_color := (0).to_natural_32
					end
				else
					l_fg_color := (0).to_natural_32
				end
			end
			if l_fg_color = {NATURAL_32} 16_777_215 then
				l_fg_color := (0).to_natural_32
			elseif (option_inst.p_bg.item.item).to_integer_32 = 100 then
				l_fg_color := darken_rgb (l_fg_color)
			end
			a_pattr.item.fg_color := l_fg_color
			a_pattr.item.bg_color := l_bg_color
		end

	prt_get_cpl: INTEGER_32
		do
			if (prt_use_number).to_boolean then
				prt_number_width := (8).to_real * prt_char_width
				if prt_out_mbyte.to_boolean then
					prt_number_width := prt_number_width / (2).to_real
				end
				prt_left_margin := prt_left_margin + prt_number_width
			else
				prt_number_width := (0.0).truncated_to_real
			end
			Result := ((prt_right_margin - prt_left_margin) / prt_char_width).truncated_to_integer
		end

	prt_get_lpp: INTEGER_32
		local
			l_lpp: INTEGER_32
		do
			prt_bgcol_offset := ((prt_ps_font.item.bbox_min_y).to_double * (prt_line_height.to_double / 1000.0)).truncated_to_real
			if (prt_ps_font.item.bbox_max_y - prt_ps_font.item.bbox_min_y).to_double < 1000.0 then
				prt_bgcol_offset := prt_bgcol_offset - (((1000.0 - (prt_ps_font.item.bbox_max_y - prt_ps_font.item.bbox_min_y).to_double) / (2).to_double) * (prt_line_height.to_double / 1000.0)).truncated_to_real
			end
			prt_first_line_height := prt_line_height + prt_bgcol_offset
			l_lpp := ((prt_top_margin - prt_bottom_margin) / prt_line_height).truncated_to_integer
			prt_top_margin := prt_top_margin - (prt_line_height * (prt_header_height).to_real)
			Result := (l_lpp - (prt_header_height))
		end

	prt_get_term_color (a_colorindex: INTEGER_32): NATURAL_32
		local
			js: JUMP_STATE
		do
			if globals_inst.t_colors > 8 then
				Result := (cterm_color_16[a_colorindex \\ 16])
				js.return
			end
			if not js.return_called then
				Result := (cterm_color_8[a_colorindex \\ 8])
			end
		end

	prt_get_unit (a_idx: INTEGER_32): INTEGER_32
		local
			l_u: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_u := -1
			if (globals_inst.printer_opts[a_idx].present).to_boolean then
				l_i___0 := 0
				from
				until
					not (not js.loop_done and then (l_i___0 < 4))
				loop
					if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.printer_opts[a_idx].string), units[l_i___0], (2).to_natural_32)) = 0 then
						l_u := l_i___0
						js.break
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			Result := l_u
		end

	prt_header (a_psettings: CE_POINTER [PD_PRT_SETTINGS_T]; a_pagenum: INTEGER_32; a_lnum: INTEGER_32)
		local
			l_width: INTEGER_32
			l_page_line: INTEGER_32
			l_tbuf: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp_lnum: INTEGER_32
			l_tmp_topline: INTEGER_32
			l_tmp_botline: INTEGER_32
			l_use_sandbox: INTEGER_32
			js: JUMP_STATE
		do
			create l_tbuf.make
			create l_p___0.make

			l_width := a_psettings.item.chars_per_line
			if (prt_use_number).to_boolean then
				l_width := l_width + (8)
			end
			l_tbuf := misc2_inst.alloc ((l_width + 1_025).to_natural_32)
			if l_tbuf.is_void then
				js.return
			end
			if not js.return_called then
				if (option_inst.p_header.item.item).to_integer_32 /= 0 then
					l_use_sandbox := 0
					l_tmp_lnum := globals_inst.curwin.item.w_cursor.lnum
					l_tmp_topline := globals_inst.curwin.item.w_topline
					l_tmp_botline := globals_inst.curwin.item.w_botline
					globals_inst.curwin.item.w_cursor.lnum := a_lnum
					globals_inst.curwin.item.w_topline := a_lnum
					globals_inst.curwin.item.w_botline := a_lnum + 63
					globals_inst.printer_page_num := a_pagenum.to_integer_32
					l_use_sandbox := option_inst.was_set_insecurely (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("printheader")), 0)
					buffer_inst.build_stl_str_hl (globals_inst.curwin, l_tbuf, (l_width + 1_025).to_natural_32, option_inst.p_header.item, l_use_sandbox, (' ').code, l_width, create {CE_POINTER [PD_STL_HLREC]}.make_shared (default_pointer), create {CE_POINTER [PD_STL_HLREC]}.make_shared (default_pointer)).do_nothing
					globals_inst.curwin.item.w_cursor.lnum := l_tmp_lnum
					globals_inst.curwin.item.w_topline := l_tmp_topline
					globals_inst.curwin.item.w_botline := l_tmp_botline
				else
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_tbuf), (gettext (ce_string ("Page %%d"))), a_pagenum]).do_nothing
				end
				prt_set_fg ((0).to_natural_32)
				prt_set_bg ((16_777_215).to_natural_32)
				prt_set_font (1, 0, 0)
				l_page_line := 0 - (prt_header_height)
				mch_print_start_line (1, l_page_line)
				l_p___0 := l_tbuf
				from
				until
					not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
					if (mch_print_text_out (l_p___0, l_l)).to_boolean then
						l_page_line := l_page_line + 1
						if l_page_line >= 0 then
							js.break
						end
						if not js.loop_jumped then
							mch_print_start_line (1, l_page_line)
						end
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0 + l_l
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tbuf))
				if (a_psettings.item.do_syntax).to_boolean then
					current_syn_id := -1
				else
					prt_set_fg ((0).to_natural_32)
					prt_set_bg ((16_777_215).to_natural_32)
					prt_set_font (0, 0, 0)
				end
			end
		end

	prt_header_height: INTEGER_32
		local
			js: JUMP_STATE
		do
			if (globals_inst.printer_opts[4].present).to_boolean then
				Result := (globals_inst.printer_opts[4].number).to_integer_32
				js.return
			end
			if not js.return_called then
				Result := 2
			end
		end

	prt_line_number (a_psettings: CE_POINTER [PD_PRT_SETTINGS_T]; a_page_line: INTEGER_32; a_lnum: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_tbuf: CE_ARRAY [NATURAL_8]
		do
			create l_tbuf.make (<<20>>)

			prt_set_fg (a_psettings.item.number.fg_color)
			prt_set_bg (a_psettings.item.number.bg_color)
			prt_set_font (a_psettings.item.number.bold, a_psettings.item.number.italic, a_psettings.item.number.underline)
			mch_print_start_line (1, a_page_line)
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_tbuf), ce_string ("%%6ld"), a_lnum]).do_nothing
			l_i___0 := 0
			from
			until
				not (l_i___0 < 6)
			loop
				mch_print_text_out (l_tbuf + l_i___0, 1).do_nothing
				l_i___0 := l_i___0 + 1
			end
			if (a_psettings.item.do_syntax).to_boolean then
				current_syn_id := -1
			else
				prt_set_fg ((0).to_natural_32)
				prt_set_bg ((16_777_215).to_natural_32)
				prt_set_font (0, 0, 0)
			end
		end

	prt_match_charset (a_p_charset: CE_POINTER [INTEGER_8]; a_p_cmap: CE_POINTER [PD_PRT_PS_MBFONT_S]; a_pp_mbchar: CE_POINTER [CE_POINTER [PD_PRT_PS_CHARSET_S]]): INTEGER_32
		local
			l_p_charset: CE_POINTER [INTEGER_8]
			l_mbchar: INTEGER_32
			l_char_len: INTEGER_32
			l_p_mbchar: CE_POINTER [PD_PRT_PS_CHARSET_S]
			js: JUMP_STATE
		do
			create l_p_charset.make
			create l_p_mbchar.make

			l_p_charset := a_p_charset
			if (l_p_charset[0]).to_integer_32 = 0 then
				l_p_charset := a_p_cmap.item.defcs
			end
			l_char_len := (strlen (l_p_charset)).to_integer_32
			l_p_mbchar := a_p_cmap.item.charsets
			l_mbchar := 0
			from
			until
				not (not js.loop_done and then (l_mbchar < a_p_cmap.item.num_charsets))
			loop
				if (strncasecmp (l_p_mbchar.item.charset, l_p_charset, l_char_len.to_natural_32)) = 0 then
					a_pp_mbchar.item := l_p_mbchar
					Result := 1
					js.return
				end
				if not js.return_called then
					l_p_mbchar := l_p_mbchar + 1
					l_mbchar := l_mbchar + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	prt_match_encoding (a_p_encoding: CE_POINTER [INTEGER_8]; a_p_cmap: CE_POINTER [PD_PRT_PS_MBFONT_S]; a_pp_mbenc: CE_POINTER [CE_POINTER [PD_PRT_PS_ENCODING_S]]): INTEGER_32
		local
			l_mbenc: INTEGER_32
			l_enc_len: INTEGER_32
			l_p_mbenc: CE_POINTER [PD_PRT_PS_ENCODING_S]
			js: JUMP_STATE
		do
			create l_p_mbenc.make

			a_pp_mbenc.item := create {CE_POINTER [PD_PRT_PS_ENCODING_S]}.make_shared (default_pointer)
			l_enc_len := (strlen (a_p_encoding)).to_integer_32
			l_p_mbenc := a_p_cmap.item.encodings
			l_mbenc := 0
			from
			until
				not (not js.loop_done and then (l_mbenc < a_p_cmap.item.num_encodings))
			loop
				if (strncasecmp (l_p_mbenc.item.encoding, a_p_encoding, l_enc_len.to_natural_32)) = 0 then
					a_pp_mbenc.item := l_p_mbenc
					Result := 1
					js.return
				end
				if not js.return_called then
					l_p_mbenc := l_p_mbenc + 1
					l_mbenc := l_mbenc + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	prt_message (a_s: CE_POINTER [NATURAL_8])
		do
			screen_inst.screen_fill ((globals_inst.Rows.item).to_integer_32 - 1, (globals_inst.Rows.item).to_integer_32, 0, (globals_inst.Columns.item).to_integer_32, (' ').code, (' ').code, 0)
			screen_inst.screen_puts (a_s, (globals_inst.Rows.item).to_integer_32 - 1, 0, globals_inst.highlight_attr[10])
			term_inst.out_flush
		end

	prt_next_dsc (a_p_dsc_line: CE_POINTER [PD_PRT_DSC_LINE_S]): INTEGER_32
		local
			l_comment: INTEGER_32
			l_offset: INTEGER_32
			js: JUMP_STATE
		do
			if not (prt_resfile_next_line).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (prt_resfile_strncmp (0, ce_string ("%%%%"), 2)) /= 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_comment := 0
				from
				until
					not (not js.loop_done and then (l_comment < (((create {PD_PRT_DSC_COMMENT_S}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_PRT_DSC_COMMENT_S}.make).structure_size.to_natural_32).to_integer_32))
				loop
					if (prt_resfile_strncmp (0, prt_dsc_table[l_comment].string, prt_dsc_table[l_comment].len)) = 0 then
						js.break
					end
					if not js.loop_jumped then
						l_comment := l_comment + 1
					end
				end
				if l_comment.to_natural_32 /= ((create {PD_PRT_DSC_COMMENT_S}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_PRT_DSC_COMMENT_S}.make).structure_size.to_natural_32 then
					a_p_dsc_line.item.type := prt_dsc_table[l_comment].type
					l_offset := prt_dsc_table[l_comment].len
				else
					a_p_dsc_line.item.type := -1
					l_offset := prt_resfile_skip_nonws (0)
					if l_offset = -1 then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				l_offset := prt_resfile_skip_ws (l_offset)
				if l_offset = -1 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				a_p_dsc_line.item.string := prt_resfile.item.buffer + prt_resfile.item.line_start + l_offset
				a_p_dsc_line.item.len := prt_resfile.item.line_end - (prt_resfile.item.line_start + l_offset)
				Result := 1
			end
		end

	prt_open_resource (a_resource: CE_POINTER [PD_PRT_PS_RESOURCE_S]): INTEGER_32
		local
			l_offset: INTEGER_32
			l_seen_all: INTEGER_32
			l_seen_title: INTEGER_32
			l_seen_version: INTEGER_32
			l_fd_resource: CE_POINTER [SD_IO_FILE]
			l_dsc_line: CE_ARRAY [PD_PRT_DSC_LINE_S]
			l_tmp___20: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fd_resource.make
			create l_dsc_line.make (<<1>>)
			create l_tmp___20.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fd_resource := fopen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_resource.item.filename)), ce_string ("r"))
					if l_fd_resource.is_void then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E624: Can%'t open file %"%%s%"")))), a_resource.item.filename).do_nothing
						Result := 0
						js.return
					end
					if not js.return_called then
						memset (create {CE_POINTER [ANY]}.make_cast ((prt_resfile.item.buffer)), ('%/0/').code, (2_048).to_natural_32).do_nothing
						prt_resfile.item.len := (fread (create {CE_POINTER [ANY]}.make_cast ((prt_resfile.item.buffer)), {PLATFORM}.Natural_8_bytes.to_natural_32, (2_048).to_natural_32, l_fd_resource)).to_integer_32
						if (ferror (l_fd_resource)).to_boolean then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E457: Can%'t read PostScript resource file %"%%s%"")))), a_resource.item.filename).do_nothing
							fclose (l_fd_resource).do_nothing
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						fclose (l_fd_resource).do_nothing
						prt_resfile.item.line_end := -1
						prt_resfile.item.line_start := 0
						if not (prt_resfile_next_line).to_boolean then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_offset := 0
						if (prt_resfile_strncmp (l_offset, ce_string ("%%!PS-Adobe-"), (strlen (ce_string ("%%!PS-Adobe-"))).to_integer_32)) /= 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E618: file %"%%s%" is not a PostScript resource file")))), a_resource.item.filename).do_nothing
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_offset := l_offset + (strlen (ce_string ("%%!PS-Adobe-"))).to_integer_32
						l_offset := prt_resfile_skip_nonws (l_offset)
						if l_offset = -1 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_offset := prt_resfile_skip_ws (l_offset)
						if l_offset = -1 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if (prt_resfile_strncmp (l_offset, ce_string ("Resource-"), (strlen (ce_string ("Resource-"))).to_integer_32)) /= 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E619: file %"%%s%" is not a supported PostScript resource file")))), a_resource.item.filename).do_nothing
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_offset := l_offset + (strlen (ce_string ("Resource-"))).to_integer_32
						if (prt_resfile_strncmp (l_offset, ce_string ("ProcSet"), (strlen (ce_string ("ProcSet"))).to_integer_32)) = 0 then
							a_resource.item.type := 0
						elseif (prt_resfile_strncmp (l_offset, ce_string ("Encoding"), (strlen (ce_string ("Encoding"))).to_integer_32)) = 0 then
							a_resource.item.type := 1
						elseif (prt_resfile_strncmp (l_offset, ce_string ("CMap"), (strlen (ce_string ("CMap"))).to_integer_32)) = 0 then
							a_resource.item.type := 2
						else
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E619: file %"%%s%" is not a supported PostScript resource file")))), a_resource.item.filename).do_nothing
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						a_resource.item.title[0] := (('%/0/').code).to_natural_8
						a_resource.item.version[0] := (('%/0/').code).to_natural_8
						l_seen_title := 0
						l_seen_version := 0
						l_seen_all := 0
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						if not l_seen_all.to_boolean then
							if not (prt_next_dsc (l_dsc_line)).to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						inspect l_dsc_line.item.type -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						when -1 then l_pos := -1 + 8 -- -1
						else l_pos := -1 + 9
						end
				when 5 then -- switch 1, case 1
						misc2_inst.vim_strncpy (a_resource.item.title, l_dsc_line.item.string, (l_dsc_line.item.len).to_natural_32)
						l_seen_title := 1
						if l_seen_version.to_boolean then
							l_seen_all := 1
						end
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 2
						misc2_inst.vim_strncpy (a_resource.item.version, l_dsc_line.item.string, (l_dsc_line.item.len).to_natural_32)
						l_seen_version := 1
						if l_seen_title.to_boolean then
							l_seen_all := 1
						end
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 3
						l_seen_all := 1
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, case -1
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						if not l_seen_title.to_boolean then
							l_tmp___20 := gettext (ce_string ("E619: file %"%%s%" is not a supported PostScript resource file"))
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___20), a_resource.item.filename).do_nothing
							Result := 0
							js.return
						elseif not l_seen_version.to_boolean then
							l_tmp___20 := gettext (ce_string ("E619: file %"%%s%" is not a supported PostScript resource file"))
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___20), a_resource.item.filename).do_nothing
							Result := 0
							js.return
						end
				when 11 then -- if done
					if not js.return_called then
						Result := 1
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prt_page_margins (a_width: REAL_64; a_height: REAL_64; a_left: CE_POINTER [REAL_64]; a_right: CE_POINTER [REAL_64]; a_top: CE_POINTER [REAL_64]; a_bottom: CE_POINTER [REAL_64])
		do
			a_left.item := (to_device_units (2, a_width, 10)).to_double
			a_right.item := a_width - (to_device_units (3, a_width, 5)).to_double
			a_top.item := a_height - (to_device_units (0, a_height, 5)).to_double
			a_bottom.item := (to_device_units (1, a_height, 5)).to_double
		end

	prt_real_bits (a_real: REAL_64; a_precision: INTEGER_32; a_pinteger: CE_POINTER [INTEGER_32]; a_pfraction: CE_POINTER [INTEGER_32])
		local
			l_i___0: INTEGER_32
			l_integer: INTEGER_32
			l_fraction: REAL_32
		do
			l_integer := a_real.truncated_to_integer
			l_fraction := (a_real - l_integer.to_double).truncated_to_real
			if a_real < l_integer.to_double then
				l_fraction := -l_fraction
			end
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_precision)
			loop
				l_fraction := (l_fraction.to_double * 10.0).truncated_to_real
				l_i___0 := l_i___0 + 1
			end
			a_pinteger.item := l_integer
			a_pfraction.item := (l_fraction.to_double + 0.5).truncated_to_integer
		end

	prt_resfile_next_line: INTEGER_32
		local
			l_idx: INTEGER_32
			js: JUMP_STATE
		do
			l_idx := prt_resfile.item.line_end + 1
			from
			until
				not (not js.loop_done and then (l_idx < prt_resfile.item.len))
			loop
				if (prt_resfile.item.buffer[l_idx]).to_integer_32 /= 10 then
					if (prt_resfile.item.buffer[l_idx]).to_integer_32 /= 13 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_idx := l_idx + 1
				end
			end
			prt_resfile.item.line_start := l_idx
			from
			until
				not (not js.loop_done and then (l_idx < prt_resfile.item.len))
			loop
				if (prt_resfile.item.buffer[l_idx]).to_integer_32 = 10 then
					js.break
				elseif (prt_resfile.item.buffer[l_idx]).to_integer_32 = 13 then
					js.break
				end
				if not js.loop_jumped then
					l_idx := l_idx + 1
				end
			end
			prt_resfile.item.line_end := l_idx
			Result := (l_idx < prt_resfile.item.len).to_integer
		end

	prt_resfile_skip_nonws (a_offset: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			js: JUMP_STATE
		do
			l_idx := prt_resfile.item.line_start + a_offset
			from
			until
				not (not js.loop_done and then (l_idx < prt_resfile.item.line_end))
			loop
				if ((((ctype_b_loc).item[(prt_resfile.item.buffer[l_idx]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
					Result := (l_idx - prt_resfile.item.line_start)
					js.return
				end
				if not js.return_called then
					l_idx := l_idx + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	prt_resfile_skip_ws (a_offset: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			js: JUMP_STATE
		do
			l_idx := prt_resfile.item.line_start + a_offset
			from
			until
				not (not js.loop_done and then (l_idx < prt_resfile.item.line_end))
			loop
				if not ((((ctype_b_loc).item[(prt_resfile.item.buffer[l_idx]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
					Result := (l_idx - prt_resfile.item.line_start)
					js.return
				end
				if not js.return_called then
					l_idx := l_idx + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	prt_resfile_strncmp (a_offset: INTEGER_32; a_string___0: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_len > prt_resfile.item.line_end - (prt_resfile.item.line_start + a_offset) then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((prt_resfile.item.buffer + prt_resfile.item.line_start + a_offset)), a_string___0, a_len.to_natural_32))
			end
		end

	prt_resource_name (a_filename: CE_POINTER [NATURAL_8]; a_cookie: CE_POINTER [ANY])
		local
			l_resource_filename: CE_POINTER [NATURAL_8]
		do
			create l_resource_filename.make

			l_resource_filename := create {CE_POINTER [NATURAL_8]}.make_cast (a_cookie)
			if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_filename))) >= {NATURAL_32} 4_096 then
				l_resource_filename.item := (('%/0/').code).to_natural_8
			else
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_resource_filename), create {CE_POINTER [INTEGER_8]}.make_cast (a_filename)).do_nothing
			end
		end

	prt_resource_name_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent prt_resource_name)
		end

	prt_set_bg (a_bg: NATURAL_32)
		do
			if a_bg /= curr_bg then
				curr_bg := a_bg
				mch_print_set_bg (a_bg)
			end
		end

	prt_set_fg (a_fg: NATURAL_32)
		do
			if a_fg /= curr_fg then
				curr_fg := a_fg
				mch_print_set_fg (a_fg)
			end
		end

	prt_set_font (a_bold: INTEGER_32; a_italic: INTEGER_32; a_underline: INTEGER_32)
		do
			if curr_bold /= a_bold then
				curr_underline := a_underline
				curr_italic := a_italic
				curr_bold := a_bold
				mch_print_set_font (a_bold, a_italic, a_underline)
			elseif curr_italic /= a_italic then
				curr_underline := a_underline
				curr_italic := a_italic
				curr_bold := a_bold
				mch_print_set_font (a_bold, a_italic, a_underline)
			elseif curr_underline /= a_underline then
				curr_underline := a_underline
				curr_italic := a_italic
				curr_bold := a_bold
				mch_print_set_font (a_bold, a_italic, a_underline)
			end
		end

	prt_use_number: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if (globals_inst.printer_opts[6].present).to_boolean then
				if (globals_inst.printer_opts[6].string[0]).to_integer_32 < 65 then
					l_tmp := (globals_inst.printer_opts[6].string[0]).to_integer_32
				elseif (globals_inst.printer_opts[6].string[0]).to_integer_32 > 90 then
					l_tmp := (globals_inst.printer_opts[6].string[0]).to_integer_32
				else
					l_tmp := (globals_inst.printer_opts[6].string[0]).to_integer_32 + 32
				end
				if l_tmp = 121 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	prt_write_boolean (a_b: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			if a_b.to_boolean then
				l_tmp := ce_string ("T")
			else
				l_tmp := ce_string ("F")
			end
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string ("%%s "), l_tmp]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_write_file (a_buffer: CE_POINTER [NATURAL_8])
		do
			prt_write_file_len (a_buffer, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buffer))).to_integer_32)
		end

	prt_write_file_len (a_buffer: CE_POINTER [NATURAL_8]; a_bytes___0: INTEGER_32)
		do
			prt_write_file_raw_len (a_buffer, a_bytes___0)
		end

	prt_write_file_raw_len (a_buffer: CE_POINTER [NATURAL_8]; a_bytes___0: INTEGER_32)
		do
			if not prt_file_error.to_boolean then
				if (fwrite (create {CE_POINTER [ANY]}.make_cast (a_buffer), {PLATFORM}.Natural_8_bytes.to_natural_32, a_bytes___0.to_natural_32, prt_ps_fd)) /= a_bytes___0.to_natural_32 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E455: Error writing to PostScript output file"))))).do_nothing
					prt_file_error := 1
				end
			end
		end

	prt_write_int (a_i___0: INTEGER_32)
		do
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string ("%%d "), a_i___0]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_write_real (a_val___0: REAL_64; a_prec: INTEGER_32)
		local
			l_prec: INTEGER_32
			l_integer: CE_ARRAY [INTEGER_32]
			l_fraction: CE_ARRAY [INTEGER_32]
		do
			create l_integer.make (<<1>>)
			create l_fraction.make (<<1>>)

			l_prec := a_prec
			prt_real_bits (a_val___0, l_prec, l_integer, l_fraction)
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string ("%%d"), l_integer.item]).do_nothing
			prt_write_file (prt_line_buffer)
			if l_fraction.item /= 0 then
				from
				until
					l_fraction.item \\ 10 /= 0
				loop
					l_prec := l_prec - 1
					l_fraction.item := l_fraction.item // (10)
				end
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string (".%%0*d"), l_prec, l_fraction.item]).do_nothing
				prt_write_file (prt_line_buffer)
			end
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ce_string (" ")]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	prt_write_string (a_s: CE_POINTER [INTEGER_8])
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (prt_line_buffer), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%s"), a_s]).do_nothing
			prt_write_file (prt_line_buffer)
		end

	to_device_units (a_idx: INTEGER_32; a_physsize: REAL_64; a_def_number: INTEGER_32): REAL_32
		local
			l_ret: REAL_32
			l_u: INTEGER_32
			l_nr: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := prt_get_unit (a_idx)
					if l_u = -1 then
						l_u := 0
						l_nr := a_def_number
					else
						l_nr := (globals_inst.printer_opts[a_idx].number).to_integer_32
					end
					inspect l_u -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 1
					l_ret := (l_nr * 72).to_real
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_ret := (l_nr * 72).to_real / (25.4).truncated_to_real
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 3
					l_ret := l_nr.to_real
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
					l_ret := (a_physsize * l_nr.to_double).truncated_to_real / (100).to_real
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					Result := l_ret
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
