class
	P_MARK

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create namedfm.make (<<36>>)
			create pos_copy.make (<<1>>)
		end

feature {ANY} -- attributes

	did_title: INTEGER_32 assign set_did_title

	set_did_title (a_did_title: INTEGER_32)
		do
			did_title := a_did_title
		end

	i: INTEGER_32 assign set_i

	set_i (a_i: INTEGER_32)
		do
			i := a_i
		end

	namedfm: CE_ARRAY [PD_XFILEMARK]

	pos_copy: CE_ARRAY [PD_POS_T]

feature {ANY} -- routines

	check_mark (a_pos___3: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_pos___3.is_void then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_umark))))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called and then (a_pos___3.item.lnum <= 0) then
				if a_pos___3.item.lnum = 0 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_marknotset))))).do_nothing
				end
				Result := 0
				js.return
			end
			if not js.return_called and then (a_pos___3.item.lnum > globals_inst.curbuf.item.b_ml.ml_line_count) then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_markinval))))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	checkpcmark
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.curwin.item.w_prev_pcmark.lnum = 0 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.curwin.item.w_pcmark.lnum /= globals_inst.curwin.item.w_cursor.lnum then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if globals_inst.curwin.item.w_pcmark.col = globals_inst.curwin.item.w_cursor.col then
							if globals_inst.curwin.item.w_pcmark.coladd = globals_inst.curwin.item.w_cursor.coladd then
								globals_inst.curwin.item.w_pcmark := (globals_inst.curwin.item.w_prev_pcmark).twin
								globals_inst.curwin.item.w_prev_pcmark.lnum := (0).to_integer_32
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___0:
						if globals_inst.curwin.item.w_pcmark.lnum = 0 then
							globals_inst.curwin.item.w_pcmark := (globals_inst.curwin.item.w_prev_pcmark).twin
							globals_inst.curwin.item.w_prev_pcmark.lnum := (0).to_integer_32
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cleanup_jumplist
		local
			l_i___0: INTEGER_32
			l_from: INTEGER_32
			l_to: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_to := 0
			l_from := 0
			from
			until
				not (not js.loop_done and then (l_from < globals_inst.curwin.item.w_jumplistlen))
			loop
				if globals_inst.curwin.item.w_jumplistidx = l_from then
					globals_inst.curwin.item.w_jumplistidx := l_to
				end
				l_i___0 := l_from + 1
				from
				until
					not (not js.loop_done and then (l_i___0 < globals_inst.curwin.item.w_jumplistlen))
				loop
					if globals_inst.curwin.item.w_jumplist[l_i___0].fmark.fnum = globals_inst.curwin.item.w_jumplist[l_from].fmark.fnum then
						if globals_inst.curwin.item.w_jumplist[l_from].fmark.fnum /= 0 then
							if globals_inst.curwin.item.w_jumplist[l_i___0].fmark.mark.lnum = globals_inst.curwin.item.w_jumplist[l_from].fmark.mark.lnum then
								js.break
							end
						end
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
				if l_i___0 >= globals_inst.curwin.item.w_jumplistlen then
					l_tmp := l_to
					l_to := l_to + 1
					globals_inst.curwin.item.w_jumplist[l_tmp] := (globals_inst.curwin.item.w_jumplist[l_from]).twin
				else
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.curwin.item.w_jumplist[l_from].fname))
				end
				l_from := l_from + 1
			end
			if globals_inst.curwin.item.w_jumplistidx = globals_inst.curwin.item.w_jumplistlen then
				globals_inst.curwin.item.w_jumplistidx := l_to
			end
			globals_inst.curwin.item.w_jumplistlen := l_to
		end

	clrallmarks (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			if i = -1 then
				i := 0
				from
				until
					not (i < 27)
				loop
					namedfm[i].fmark.mark.lnum := (0).to_integer_32
					namedfm[i].fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					i := i + 1
				end
			end
			i := 0
			from
			until
				not (i < 26)
			loop
				a_buf___6.item.b_namedm[i].lnum := (0).to_integer_32
				i := i + 1
			end
			a_buf___6.item.b_op_start.lnum := (0).to_integer_32
			a_buf___6.item.b_op_end.lnum := (0).to_integer_32
			a_buf___6.item.b_last_cursor.lnum := (1).to_integer_32
			a_buf___6.item.b_last_cursor.col := 0
			a_buf___6.item.b_last_cursor.coladd := 0
			a_buf___6.item.b_last_insert.lnum := (0).to_integer_32
			a_buf___6.item.b_last_change.lnum := (0).to_integer_32
			a_buf___6.item.b_changelistlen := 0
		end

	copy_jumplist (a_from: CE_POINTER [PD_WINDOW_S]; a_to: CE_POINTER [PD_WINDOW_S])
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_from.item.w_jumplistlen)
			loop
				a_to.item.w_jumplist[l_i___0] := (a_from.item.w_jumplist[l_i___0]).twin
				if not (a_from.item.w_jumplist[l_i___0].fname).is_void then
					a_to.item.w_jumplist[l_i___0].fname := misc2_inst.vim_strsave (a_from.item.w_jumplist[l_i___0].fname)
				end
				l_i___0 := l_i___0 + 1
			end
			a_to.item.w_jumplistlen := a_from.item.w_jumplistlen
			a_to.item.w_jumplistidx := a_from.item.w_jumplistidx
		end

	copy_viminfo_marks (a_virp: CE_POINTER [PD_VIR_T]; a_fp_out: CE_POINTER [SD_IO_FILE]; a_count___2: INTEGER_32; a_eof: INTEGER_32; a_flags___0: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_eof: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_num_marked_files: INTEGER_32
			l_load_marks: INTEGER_32
			l_copy_marks_out: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_name_buf: CE_POINTER [NATURAL_8]
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_list: CE_POINTER [PD_LISTVAR_S]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_buf___6.make
			create l_str___1.make
			create l_p___0.make
			create l_name_buf.make
			create l_pos___3.make (<<1>>)
			create l_list.make
			create l_wp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_eof := a_eof
					l_line := a_virp.item.vir_line
					l_list := create {CE_POINTER [PD_LISTVAR_S]}.make_shared (default_pointer)
					l_name_buf := misc2_inst.alloc ({NATURAL_32} 512)
					if l_name_buf.is_void then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						l_name_buf.item := (('%/0/').code).to_natural_8
						if a_fp_out.is_void then
							if ((a_flags___0).bit_and (12)).to_boolean then
								l_list := eval_inst.list_alloc
								if not l_list.is_void then
									eval_inst.set_vim_var_list (54, l_list)
								end
							end
						end
						l_num_marked_files := option_inst.get_viminfo_parameter (('%'').code)
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 20 -- skip loop
						end
				when 3 then -- loop body:
						if not l_eof.to_boolean then
							if not (l_count___2 < l_num_marked_files) then
								if not (a_fp_out.is_void) then
									js.break
								end
							end
						else
							js.break
						end
						if not js.loop_jumped and then ((l_line[0]).to_integer_32 /= 62) then
							if (l_line[0]).to_integer_32 /= 10 then
								if (l_line[0]).to_integer_32 /= 13 then
									if (l_line[0]).to_integer_32 /= 35 then
										if (ex_cmds_inst.viminfo_error (ce_string ("E576: "), (gettext (ce_string ("Missing %'>%'"))), l_line)).to_boolean then
											js.break
										end
									end
								end
							end
							if not js.loop_jumped then
								l_eof := fileio_inst.vim_fgets (l_line, 512, a_virp.item.vir_fd)
								js.continue
							end
						end
						if not js.loop_jumped then
							l_str___1 := charset_inst.skipwhite (l_line + 1)
							l_str___1 := ex_cmds_inst.viminfo_readstring (a_virp, l_str___1.distance ((a_virp.item.vir_line)), 0)
							if l_str___1.is_void then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 19 -- skip if block
						end
				when 4 then -- if:
						l_p___0 := l_str___1 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1))).to_integer_32
						from
						until
							js.loop_done
						loop
							if not l_p___0.is_equal (l_str___1) then
								if (l_p___0.item).to_integer_32 /= 0 then
									if not (misc2_inst.vim_isspace ((l_p___0.item).to_integer_32)).to_boolean then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := l_p___0 - 1
							end
						end
						if (l_p___0.item).to_boolean then
							l_p___0 := l_p___0 + 1
						end
						l_p___0.item := (('%/0/').code).to_natural_8
						if not l_list.is_void then
							eval_inst.list_append_string (l_list, l_str___1, -1).do_nothing
						end
						l_copy_marks_out := 0
						l_load_marks := l_copy_marks_out
						if a_fp_out.is_void then
							if ((a_flags___0).bit_and (2)).to_boolean then
								if not (globals_inst.curbuf.item.b_ffname).is_void then
									if (l_name_buf.item).to_integer_32 = 0 then
										misc1_inst.home_replace (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), globals_inst.curbuf.item.b_ffname, l_name_buf, 512, 1)
									end
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1), create {CE_POINTER [INTEGER_8]}.make_cast (l_name_buf))) = 0 then
										l_load_marks := 1
									end
								end
							end
						else
							l_buf___6 := globals_inst.firstbuf
							from
							until
								not (not js.loop_done and then (not l_buf___6.is_void))
							loop
								if not (l_buf___6.item.b_ffname).is_void then
									misc1_inst.home_replace (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_buf___6.item.b_ffname, l_name_buf, 512, 1)
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1), create {CE_POINTER [INTEGER_8]}.make_cast (l_name_buf))) = 0 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_buf___6 := l_buf___6.item.b_next
								end
							end
							if l_buf___6.is_void then
								l_copy_marks_out := 1
								fputs (ce_string ("%N> "), a_fp_out).do_nothing
								ex_cmds_inst.viminfo_writestring (a_fp_out, l_str___1)
								l_count___2 := l_count___2 + 1
							elseif not (l_buf___6.item.b_marks_read).to_boolean then
								l_copy_marks_out := 1
								fputs (ce_string ("%N> "), a_fp_out).do_nothing
								ex_cmds_inst.viminfo_writestring (a_fp_out, l_str___1)
								l_count___2 := l_count___2 + 1
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_str___1))
						l_pos___3.item.coladd := 0
				when 5 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 18 -- skip loop
						end
				when 6 then -- loop body:
						l_eof := ex_cmds_inst.viminfo_readline (a_virp)
						if l_eof.to_boolean then
							js.break
						elseif (l_line[0]).to_integer_32 /= 9 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 17 -- skip if block
						end
				when 7 then -- if:
						if not (l_load_marks.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						if (l_line[1]).to_integer_32 = 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						sscanf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_line) + 2), ce_string ("%%ld %%u"), create {CE_POINTER [INTEGER_32]}.make_shared (l_pos___3.item.c_pointer + (create {PD_POS_T}.make).offset_of ("lnum")), create {CE_POINTER [INTEGER_32]}.make_shared (l_pos___3.item.c_pointer + (create {PD_POS_T}.make).offset_of ("col"))]).do_nothing
						inspect (l_line[1]).to_integer_32 -- switch 1 head
						when 34 then l_pos := -1 + 10
						when 94 then l_pos := -1 + 11
						when 46 then l_pos := -1 + 12
						when 43 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 10 then -- switch 1, case 34
						globals_inst.curbuf.item.b_last_cursor := (l_pos___3.item).twin
						l_pos := -1 + 15 -- switch 1; break
				when 11 then -- switch 1, case 94
						globals_inst.curbuf.item.b_last_insert := (l_pos___3.item).twin
						l_pos := -1 + 15 -- switch 1; break
				when 12 then -- switch 1, case 46
						globals_inst.curbuf.item.b_last_change := (l_pos___3.item).twin
						l_pos := -1 + 15 -- switch 1; break
				when 13 then -- switch 1, case 43
						if globals_inst.curbuf.item.b_changelistlen = 100 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.curbuf.item.b_changelist)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.curbuf.item.b_changelist + 1)), (create {PD_POS_T}.make).structure_size.to_natural_32 * {NATURAL_32} 99).do_nothing
						else
							globals_inst.curbuf.item.b_changelistlen := (globals_inst.curbuf.item.b_changelistlen) + 1
						end
						globals_inst.curbuf.item.b_changelist[globals_inst.curbuf.item.b_changelistlen - 1] := (l_pos___3.item).twin
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, default:
						l_i___0 := (l_line[1]).to_integer_32 - 97
						if l_i___0 >= 0 then
							if l_i___0 < 26 then
								globals_inst.curbuf.item.b_namedm[l_i___0] := (l_pos___3.item).twin
							end
						end
				when 15 then -- switch 1, done: | if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						if l_copy_marks_out.to_boolean then
							fputs (create {CE_POINTER [INTEGER_8]}.make_cast (l_line), a_fp_out).do_nothing
						end
				when 17 then -- if done | if done
						l_pos := -1 + 5 -- back to loop condition
				when 18 then -- loop done
						if l_load_marks.to_boolean then
							l_wp___0 := globals_inst.firstwin
							from
							until
								l_wp___0.is_void
							loop
								if (l_wp___0.item.w_buffer).is_equal (globals_inst.curbuf) then
									l_wp___0.item.w_changelistidx := globals_inst.curbuf.item.b_changelistlen
								end
								l_wp___0 := l_wp___0.item.w_next
							end
							js.break
						end
				when 19 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 20 then -- loop done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name_buf))
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_marks (a_eap: CE_POINTER [PD_EXARG])
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_arg.make
			create l_name___1.make

			l_arg := a_eap.item.arg
			if not l_arg.is_void then
				if (l_arg.item).to_integer_32 = 0 then
					l_arg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
			end
			show_one_mark (('%'').code, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_pcmark")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
			l_i___0 := 0
			from
			until
				not (l_i___0 < 26)
			loop
				show_one_mark (l_i___0 + 97, l_arg, globals_inst.curbuf.item.b_namedm + l_i___0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
				l_i___0 := l_i___0 + 1
			end
			l_i___0 := 0
			from
			until
				not (l_i___0 < 36)
			loop
				if namedfm[l_i___0].fmark.fnum /= 0 then
					l_name___1 := fm_getname (create {CE_POINTER [PD_FILEMARK]}.make_shared (namedfm.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark")), 15)
				else
					l_name___1 := namedfm[l_i___0].fname
				end
				if not l_name___1.is_void then
					if l_i___0 >= 26 then
						l_tmp := (l_i___0 - 26) + 48
					else
						l_tmp := l_i___0 + 65
					end
					show_one_mark (l_tmp, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (namedfm.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark")), l_name___1, (namedfm[l_i___0].fmark.fnum = globals_inst.curbuf.item.b_fnum).to_integer)
					if namedfm[l_i___0].fmark.fnum /= 0 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
					end
				end
				l_i___0 := l_i___0 + 1
			end
			show_one_mark (('%"').code, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_cursor")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
			show_one_mark (('[').code, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_op_start")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
			show_one_mark ((']').code, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_op_end")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
			show_one_mark (('^').code, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_insert")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
			show_one_mark (('.').code, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_change")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
			show_one_mark (('<').code, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_start")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
			show_one_mark (('>').code, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_end")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
			show_one_mark (-1, l_arg, create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
		end

	do_marks_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_marks)
		end

	ex_changes (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_name___1.make

			message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%Nchange line  col text")))))
			l_i___0 := 0
			from
			until
				js.loop_done
			loop
				if l_i___0 < globals_inst.curbuf.item.b_changelistlen then
					if globals_inst.got_int.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped and then (globals_inst.curbuf.item.b_changelist[l_i___0].lnum /= 0) then
					message_inst.msg_putchar (('%N').code)
					if globals_inst.got_int.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						if l_i___0 > globals_inst.curwin.item.w_changelistidx then
							l_tmp___0 := l_i___0 - globals_inst.curwin.item.w_changelistidx
						else
							l_tmp___0 := globals_inst.curwin.item.w_changelistidx - l_i___0
						end
						if l_i___0 = globals_inst.curwin.item.w_changelistidx then
							l_tmp___1 := ('>').code
						else
							l_tmp___1 := (' ').code
						end
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%%c %%3d %%5ld %%4d "), l_tmp___1, l_tmp___0, globals_inst.curbuf.item.b_changelist[l_i___0].lnum, globals_inst.curbuf.item.b_changelist[l_i___0].col]).do_nothing
						message_inst.msg_outtrans (globals_inst.IObuff).do_nothing
						l_name___1 := mark_line (globals_inst.curbuf.item.b_changelist + l_i___0, 17)
						if l_name___1.is_void then
							js.break
						end
					end
					if not js.loop_jumped then
						message_inst.msg_outtrans_attr (l_name___1, globals_inst.highlight_attr[2]).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
						ui_inst.ui_breakcheck
					end
				end
				if not js.loop_jumped then
					term_inst.out_flush
					l_i___0 := l_i___0 + 1
				end
			end
			if globals_inst.curwin.item.w_changelistidx = globals_inst.curbuf.item.b_changelistlen then
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N>")))
			end
		end

	ex_changes_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_changes)
		end

	ex_delmarks (a_eap: CE_POINTER [PD_EXARG])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_from: INTEGER_32
			l_to: INTEGER_32
			l_i___0: INTEGER_32
			l_lower: INTEGER_32
			l_digit: INTEGER_32
			l_n: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_eap.item.arg).item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_eap.item.forceit).to_boolean then
							clrallmarks (globals_inst.curbuf)
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 3 then -- else: | _L___1:
						if not ((a_eap.item.forceit).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 6 then -- else:
						if ((a_eap.item.arg).item).to_integer_32 /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))))).do_nothing
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 9 then -- else:
						l_p___0 := a_eap.item.arg
				when 10 then -- loop condition:
						if not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 34 -- skip loop
						end
				when 11 then -- loop body:
						if (l_p___0.item).to_integer_32 < 127 then
							if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						l_lower := l_tmp___2
						if (l_p___0.item).to_integer_32 >= 48 then
							if (l_p___0.item).to_integer_32 <= 57 then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
						l_digit := l_tmp___3
						if not (l_lower.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 14 then -- else:
						if not (l_digit.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 17 then -- else:
						if not ((l_p___0.item).to_integer_32 < 127) then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if not (((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (256)).to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L:
						if (l_p___0[1]).to_integer_32 = 45 then
							l_from := (l_p___0.item).to_integer_32
							l_to := (l_p___0[2]).to_integer_32
							if l_lower.to_boolean then
								if (l_p___0[2]).to_integer_32 < 127 then
									if ((((ctype_b_loc).item[(l_p___0[2]).to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
										l_tmp___6 := 1
									else
										l_tmp___6 := 0
									end
								else
									l_tmp___6 := 0
								end
								l_tmp___11 := l_tmp___6
							else
								if l_digit.to_boolean then
									if (l_p___0[2]).to_integer_32 >= 48 then
										if (l_p___0[2]).to_integer_32 <= 57 then
											l_tmp___7 := 1
										else
											l_tmp___7 := 0
										end
									else
										l_tmp___7 := 0
									end
									l_tmp___10 := l_tmp___7
								else
									if (l_p___0[2]).to_integer_32 < 127 then
										if ((((ctype_b_loc).item[(l_p___0[2]).to_integer_32]).to_integer_32).bit_and (256)).to_boolean then
											l_tmp___9 := 1
										else
											l_tmp___9 := 0
										end
									else
										l_tmp___9 := 0
									end
									l_tmp___10 := l_tmp___9
								end
								l_tmp___11 := l_tmp___10
							end
							if l_tmp___11.to_boolean then
								if l_to < l_from then
									l_tmp___4 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2))
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4), l_p___0).do_nothing
									js.return
								end
							else
								l_tmp___4 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4), l_p___0).do_nothing
								js.return
							end
							if not js.return_called then
								l_p___0 := l_p___0 + (2)
							end
						else
							l_to := (l_p___0.item).to_integer_32
							l_from := l_to
						end
						if not js.return_called then
							l_i___0 := l_from
							from
							until
								not (l_i___0 <= l_to)
							loop
								if l_lower.to_boolean then
									globals_inst.curbuf.item.b_namedm[l_i___0 - 97].lnum := (0).to_integer_32
								else
									if l_digit.to_boolean then
										l_n := (l_i___0 - 48) + 26
									else
										l_n := l_i___0 - 65
									end
									namedfm[l_n].fmark.mark.lnum := (0).to_integer_32
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (namedfm[l_n].fname))
									namedfm[l_n].fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								end
								l_i___0 := l_i___0 + 1
							end
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 23 -- goto _L___0
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 33
				when 23 then -- else: | _L___0:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 34 then l_pos := -1 + 24
						when 94 then l_pos := -1 + 25
						when 46 then l_pos := -1 + 26
						when 91 then l_pos := -1 + 27
						when 93 then l_pos := -1 + 28
						when 60 then l_pos := -1 + 29
						when 62 then l_pos := -1 + 30
						when 32 then l_pos := -1 + 31
						else l_pos := -1 + 32
						end
				when 24 then -- switch 1, case 34
						globals_inst.curbuf.item.b_last_cursor.lnum := (0).to_integer_32
						l_pos := -1 + 33 -- switch 1; break
				when 25 then -- switch 1, case 94
						globals_inst.curbuf.item.b_last_insert.lnum := (0).to_integer_32
						l_pos := -1 + 33 -- switch 1; break
				when 26 then -- switch 1, case 46
						globals_inst.curbuf.item.b_last_change.lnum := (0).to_integer_32
						l_pos := -1 + 33 -- switch 1; break
				when 27 then -- switch 1, case 91
						globals_inst.curbuf.item.b_op_start.lnum := (0).to_integer_32
						l_pos := -1 + 33 -- switch 1; break
				when 28 then -- switch 1, case 93
						globals_inst.curbuf.item.b_op_end.lnum := (0).to_integer_32
						l_pos := -1 + 33 -- switch 1; break
				when 29 then -- switch 1, case 60
						globals_inst.curbuf.item.b_visual.vi_start.lnum := (0).to_integer_32
						l_pos := -1 + 33 -- switch 1; break
				when 30 then -- switch 1, case 62
						globals_inst.curbuf.item.b_visual.vi_end.lnum := (0).to_integer_32
						l_pos := -1 + 33 -- switch 1; break
				when 31 then -- switch 1, case 32
						l_pos := -1 + 33 -- switch 1; break
				when 32 then -- switch 1, default:
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), l_p___0).do_nothing
						js.return
				when 33 then -- switch 1, done: | if done | if done
						if not js.return_called then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 10 -- back to loop condition
				when 34 then -- loop done | if done | if done
						if not js.return_called then
						end
				when 35 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_delmarks_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_delmarks)
		end

	ex_jumps (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_name___1.make

			cleanup_jumplist
			message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%N jump line  col file/text")))))
			l_i___0 := 0
			from
			until
				js.loop_done
			loop
				if l_i___0 < globals_inst.curwin.item.w_jumplistlen then
					if globals_inst.got_int.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped and then (globals_inst.curwin.item.w_jumplist[l_i___0].fmark.mark.lnum /= 0) then
					if globals_inst.curwin.item.w_jumplist[l_i___0].fmark.fnum = 0 then
						fname2fnum (globals_inst.curwin.item.w_jumplist + l_i___0)
					end
					l_name___1 := fm_getname (create {CE_POINTER [PD_FILEMARK]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark")), 16)
					if l_name___1.is_void then
						js.continue
					end
					if not js.loop_jumped then
						message_inst.msg_putchar (('%N').code)
						if globals_inst.got_int.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
							js.break
						end
					end
					if not js.loop_jumped then
						if l_i___0 > globals_inst.curwin.item.w_jumplistidx then
							l_tmp___0 := l_i___0 - globals_inst.curwin.item.w_jumplistidx
						else
							l_tmp___0 := globals_inst.curwin.item.w_jumplistidx - l_i___0
						end
						if l_i___0 = globals_inst.curwin.item.w_jumplistidx then
							l_tmp___1 := ('>').code
						else
							l_tmp___1 := (' ').code
						end
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%%c %%2d %%5ld %%4d "), l_tmp___1, l_tmp___0, globals_inst.curwin.item.w_jumplist[l_i___0].fmark.mark.lnum, globals_inst.curwin.item.w_jumplist[l_i___0].fmark.mark.col]).do_nothing
						message_inst.msg_outtrans (globals_inst.IObuff).do_nothing
						if globals_inst.curwin.item.w_jumplist[l_i___0].fmark.fnum = globals_inst.curbuf.item.b_fnum then
							l_tmp___2 := globals_inst.highlight_attr[2]
						else
							l_tmp___2 := 0
						end
						message_inst.msg_outtrans_attr (l_name___1, l_tmp___2).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
						ui_inst.ui_breakcheck
					end
				end
				if not js.loop_jumped then
					term_inst.out_flush
				end
				if js.loop_increment then
					l_i___0 := l_i___0 + 1
				end
			end
			if globals_inst.curwin.item.w_jumplistidx = globals_inst.curwin.item.w_jumplistlen then
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N>")))
			end
		end

	ex_jumps_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_jumps)
		end

	fm_getname (a_fmark: CE_POINTER [PD_FILEMARK]; a_lead_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_fmark.item.fnum = globals_inst.curbuf.item.b_fnum then
				Result := (mark_line (create {CE_POINTER [PD_POS_T]}.make_shared (a_fmark.c_pointer + (create {PD_FILEMARK}.make).offset_of ("mark")), a_lead_len))
				js.return
			end
			if not js.return_called then
				Result := (buffer_inst.buflist_nr2name (a_fmark.item.fnum, 0, 1))
			end
		end

	fmarks_check_names (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
		do
			create l_name___1.make
			create l_wp___0.make

			if (a_buf___6.item.b_ffname).is_void then
				js.return
			end
			if not js.return_called then
				l_name___1 := misc1_inst.home_replace_save (a_buf___6, a_buf___6.item.b_ffname)
				if l_name___1.is_void then
					js.return
				end
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (l_i___0 < 36)
				loop
					fmarks_check_one (namedfm + l_i___0, l_name___1, a_buf___6)
					l_i___0 := l_i___0 + 1
				end
				l_wp___0 := globals_inst.firstwin
				from
				until
					not (not js.loop_done and then (not l_wp___0.is_void))
				loop
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_wp___0.item.w_jumplistlen)
					loop
						fmarks_check_one (l_wp___0.item.w_jumplist + l_i___0, l_name___1, a_buf___6)
						l_i___0 := l_i___0 + 1
					end
					l_wp___0 := l_wp___0.item.w_next
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
			end
		end

	fmarks_check_one (a_fm: CE_POINTER [PD_XFILEMARK]; a_name___1: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			if a_fm.item.fmark.fnum = 0 then
				if not (a_fm.item.fname).is_void then
					if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (a_fm.item.fname))) = 0 then
						a_fm.item.fmark.fnum := a_buf___6.item.b_fnum
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_fm.item.fname))
						a_fm.item.fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
				end
			end
		end

	fname2fnum (a_fm: CE_POINTER [PD_XFILEMARK])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
		do
			create l_p___0.make

			if not (a_fm.item.fname).is_void then
				if (a_fm.item.fname[0]).to_integer_32 = 126 then
					if (a_fm.item.fname[1]).to_integer_32 = 47 then
						misc1_inst.expand_env (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("~/")), globals_inst.NameBuff.item, 4_096)
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff.item))).to_integer_32
						misc2_inst.vim_strncpy (globals_inst.NameBuff.item + l_len, a_fm.item.fname + 2, ((4_096 - l_len) - 1).to_natural_32)
					else
						misc2_inst.vim_strncpy (globals_inst.NameBuff.item, a_fm.item.fname, (4_095).to_natural_32)
					end
				else
					misc2_inst.vim_strncpy (globals_inst.NameBuff.item, a_fm.item.fname, (4_095).to_natural_32)
				end
				os_unix_inst.mch_dirname (globals_inst.IObuff, 1_025).do_nothing
				l_p___0 := fileio_inst.shorten_fname (globals_inst.NameBuff.item, globals_inst.IObuff)
				buffer_inst.buflist_new (globals_inst.NameBuff.item, l_p___0, (1).to_integer_32, 0).do_nothing
			end
		end

	free_jumplist (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_wp___0.item.w_jumplistlen)
			loop
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_wp___0.item.w_jumplist[l_i___0].fname))
				l_i___0 := l_i___0 + 1
			end
		end

	getmark (a_c: INTEGER_32; a_changefile: INTEGER_32): CE_POINTER [PD_POS_T]
		do
			Result := (getmark_fnum (a_c, a_changefile, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
		end

	getmark_fnum (a_c: INTEGER_32; a_changefile: INTEGER_32; a_fnum___0: CE_POINTER [INTEGER_32]): CE_POINTER [PD_POS_T]
		local
			l_c: INTEGER_32
			l_posp: CE_POINTER [PD_POS_T]
			l_startp: CE_POINTER [PD_POS_T]
			l_endp: CE_POINTER [PD_POS_T]
			l_pos___3: PD_POS_T
			l_oa: CE_ARRAY [PD_OPARG_S]
			l_slcb: INTEGER_32
			l_tmp: INTEGER_32
			l_pos___4: PD_POS_T
			l_slcb___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_posp.make
			create l_startp.make
			create l_endp.make
			create l_pos___3.make
			create l_oa.make (<<1>>)
			create l_pos___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer)
					if l_c < 0 then
						Result := l_posp
						js.return
					end
					if not (not js.return_called and then (not (l_c > 126))) then
						l_pos := -1 + 49 -- skip if block
					end
				when 1 then -- if:
						if l_c /= 39 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						pos_copy.item := (globals_inst.curwin.item.w_pcmark).twin
						l_posp := pos_copy
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 4 then -- else:
						if l_c /= 96 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						pos_copy.item := (globals_inst.curwin.item.w_pcmark).twin
						l_posp := pos_copy
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 7 then -- else:
						if l_c /= 34 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_cursor"))
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 10 then -- else:
						if l_c /= 94 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_insert"))
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 13 then -- else:
						if l_c /= 46 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_change"))
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 16 then -- else:
						if l_c /= 91 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_op_start"))
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 19 then -- else:
						if l_c /= 93 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_op_end"))
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 22 then -- else:
						if l_c /= 123 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___4
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 25 then -- else:
						if l_c /= 125 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L___4:
						l_slcb := globals_inst.listcmd_busy
						l_pos___3 := (globals_inst.curwin.item.w_cursor).twin
						globals_inst.listcmd_busy := 1
						if l_c = 125 then
							l_tmp := 1
						else
							l_tmp := -1
						end
						if (search_inst.findpar (create {CE_POINTER [INTEGER_32]}.make_shared (l_oa.item.c_pointer + (create {PD_OPARG_S}.make).offset_of ("inclusive")), l_tmp, 1, ('%/0/').code, 0)).to_boolean then
							pos_copy.item := (globals_inst.curwin.item.w_cursor).twin
							l_posp := pos_copy
						end
						globals_inst.curwin.item.w_cursor := l_pos___3.twin
						globals_inst.listcmd_busy := l_slcb
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 28 then -- else:
						if l_c /= 40 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 32 -- goto _L___3
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 31 then -- else:
						if l_c /= 41 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if: | _L___3:
						l_slcb___0 := globals_inst.listcmd_busy
						l_pos___4 := (globals_inst.curwin.item.w_cursor).twin
						globals_inst.listcmd_busy := 1
						if l_c = 41 then
							l_tmp___1 := 1
						else
							l_tmp___1 := -1
						end
						if (search_inst.findsent (l_tmp___1, 1)).to_boolean then
							pos_copy.item := (globals_inst.curwin.item.w_cursor).twin
							l_posp := pos_copy
						end
						globals_inst.curwin.item.w_cursor := l_pos___4.twin
						globals_inst.listcmd_busy := l_slcb___0
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 34 then -- else:
						if l_c /= 60 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 38 -- goto _L___2
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 37 then -- else:
						if l_c /= 62 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if: | _L___2:
						l_startp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_start"))
						l_endp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_end"))
						if l_startp.item.lnum /= l_endp.item.lnum then
							l_tmp___4 := (l_startp.item.lnum < l_endp.item.lnum).to_integer
						else
							if l_startp.item.col /= l_endp.item.col then
								l_tmp___3 := (l_startp.item.col < l_endp.item.col).to_integer
							else
								l_tmp___3 := (l_startp.item.coladd < l_endp.item.coladd).to_integer
							end
							l_tmp___4 := l_tmp___3
						end
						if (l_c = 60) = l_tmp___4.to_boolean then
							l_posp := l_startp
						else
							l_posp := l_endp
						end
						if globals_inst.curbuf.item.b_visual.vi_mode = 86 then
							pos_copy.item := (l_posp.item).twin
							l_posp := pos_copy
							if l_c = 60 then
								pos_copy.item.col := 0
							else
								pos_copy.item.col := (2_147_483_647).to_integer_32
							end
							pos_copy.item.coladd := 0
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 40 then -- else:
						if not (l_c < 127) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (512)).to_boolean then
							l_posp := globals_inst.curbuf.item.b_namedm + l_c - 97
						else
							l_pos := -1 + 43 -- goto _L___1
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 43 then -- else: | _L___1:
						if not (l_c < 127) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (256)).to_boolean then
							l_pos := -1 + 48 -- goto _L
						else
							l_pos := -1 + 46 -- goto _L___0
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 46 then -- else: | _L___0:
						if not (l_c >= 48) then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if not (l_c <= 57) then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | _L:
						if l_c >= 48 then
							if l_c <= 57 then
								l_c := (l_c - 48) + 26
							else
								l_c := l_c - (65)
							end
						else
							l_c := l_c - (65)
						end
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (namedfm.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_c) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
						if namedfm[l_c].fmark.fnum = 0 then
							fname2fnum (namedfm + l_c)
						end
						if not a_fnum___0.is_void then
							a_fnum___0.item := namedfm[l_c].fmark.fnum
						elseif namedfm[l_c].fmark.fnum /= globals_inst.curbuf.item.b_fnum then
							l_posp := pos_copy
							if namedfm[l_c].fmark.mark.lnum /= 0 then
								if a_changefile.to_boolean then
									if (namedfm[l_c].fmark.fnum).to_boolean then
										if (buffer_inst.buflist_getfile (namedfm[l_c].fmark.fnum, (1).to_integer_32, 1, 0)) = 1 then
											globals_inst.curwin.item.w_cursor := (namedfm[l_c].fmark.mark).twin
											Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer + -1))
											js.return
										end
										if not js.return_called then
											pos_copy.item.lnum := (-1).to_integer_32
										end
									else
										pos_copy.item.lnum := (0).to_integer_32
									end
								else
									pos_copy.item.lnum := (0).to_integer_32
								end
							else
								pos_copy.item.lnum := (0).to_integer_32
							end
						end
				when 49 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := l_posp
						end
				when 50 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	getnextmark (a_startpos: CE_POINTER [PD_POS_T]; a_dir___0: INTEGER_32; a_begin_line: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_i___0: INTEGER_32
			l_result___2: CE_POINTER [PD_POS_T]
			l_pos___3: PD_POS_T
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_result___2.make
			create l_pos___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result___2 := create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer)
					l_pos___3 := (a_startpos.item).twin
					if a_dir___0 /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_begin_line.to_boolean then
							l_pos___3.col := 0
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if a_dir___0 = 1 then
							if a_begin_line.to_boolean then
								l_pos___3.col := (2_147_483_647).to_integer_32
							end
						end
				when 4 then
					l_i___0 := 0
				when 5 then -- loop condition:
					if not (l_i___0 < 26) then
						l_pos := -1 + 20 -- skip loop
					end
				when 6 then -- loop body:
						if not (globals_inst.curbuf.item.b_namedm[l_i___0].lnum > 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 7 then -- if:
						if a_dir___0 /= 1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if not (l_result___2.is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if globals_inst.curbuf.item.b_namedm[l_i___0].lnum /= l_result___2.item.lnum then
							l_tmp___0 := (globals_inst.curbuf.item.b_namedm[l_i___0].lnum < l_result___2.item.lnum).to_integer
						else
							if globals_inst.curbuf.item.b_namedm[l_i___0].col /= l_result___2.item.col then
								l_tmp := (globals_inst.curbuf.item.b_namedm[l_i___0].col < l_result___2.item.col).to_integer
							else
								l_tmp := (globals_inst.curbuf.item.b_namedm[l_i___0].coladd < l_result___2.item.coladd).to_integer
							end
							l_tmp___0 := l_tmp
						end
						if not (l_tmp___0.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if l_pos___3.lnum /= globals_inst.curbuf.item.b_namedm[l_i___0].lnum then
							l_tmp___2 := (l_pos___3.lnum < globals_inst.curbuf.item.b_namedm[l_i___0].lnum).to_integer
						else
							if l_pos___3.col /= globals_inst.curbuf.item.b_namedm[l_i___0].col then
								l_tmp___1 := (l_pos___3.col < globals_inst.curbuf.item.b_namedm[l_i___0].col).to_integer
							else
								l_tmp___1 := (l_pos___3.coladd < globals_inst.curbuf.item.b_namedm[l_i___0].coladd).to_integer
							end
							l_tmp___2 := l_tmp___1
						end
						if l_tmp___2.to_boolean then
							l_result___2 := globals_inst.curbuf.item.b_namedm + l_i___0
						end
				when 13 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 14 then -- else:
						if not (l_result___2.is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___1
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if l_result___2.item.lnum /= globals_inst.curbuf.item.b_namedm[l_i___0].lnum then
							l_tmp___4 := (l_result___2.item.lnum < globals_inst.curbuf.item.b_namedm[l_i___0].lnum).to_integer
						else
							if l_result___2.item.col /= globals_inst.curbuf.item.b_namedm[l_i___0].col then
								l_tmp___3 := (l_result___2.item.col < globals_inst.curbuf.item.b_namedm[l_i___0].col).to_integer
							else
								l_tmp___3 := (l_result___2.item.coladd < globals_inst.curbuf.item.b_namedm[l_i___0].coladd).to_integer
							end
							l_tmp___4 := l_tmp___3
						end
						if not (l_tmp___4.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___1:
						if globals_inst.curbuf.item.b_namedm[l_i___0].lnum /= l_pos___3.lnum then
							l_tmp___6 := (globals_inst.curbuf.item.b_namedm[l_i___0].lnum < l_pos___3.lnum).to_integer
						else
							if globals_inst.curbuf.item.b_namedm[l_i___0].col /= l_pos___3.col then
								l_tmp___5 := (globals_inst.curbuf.item.b_namedm[l_i___0].col < l_pos___3.col).to_integer
							else
								l_tmp___5 := (globals_inst.curbuf.item.b_namedm[l_i___0].coladd < l_pos___3.coladd).to_integer
							end
							l_tmp___6 := l_tmp___5
						end
						if l_tmp___6.to_boolean then
							l_result___2 := globals_inst.curbuf.item.b_namedm + l_i___0
						end
				when 19 then -- if done | if done | if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 5 -- back to loop condition
				when 20 then -- loop done
					Result := l_result___2
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mark_adjust (a_line1: INTEGER_32; a_line2: INTEGER_32; a_amount: INTEGER_32; a_amount_after: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_fnum___0: INTEGER_32
			l_lp: CE_POINTER [INTEGER_32]
			l_win: CE_POINTER [PD_WINDOW_S]
			l_tab___0: CE_POINTER [PD_TABPAGE_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lp.make
			create l_win.make
			create l_tab___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fnum___0 := globals_inst.curbuf.item.b_fnum
					if a_line2 < a_line1 then
						if a_amount_after = 0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 104 -- skip if block
					end
				when 1 then -- if:
						if (globals_inst.cmdmod.item.lockmarks).to_boolean then
							l_pos := -1 + 46 -- skip if block
						end
				when 2 then -- if:
						l_i___0 := 0
				when 3 then -- loop condition:
						if not (l_i___0 < 26) then
							l_pos := -1 + 14 -- skip loop
						end
				when 4 then -- loop body:
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_namedm") + (create {PD_POS_T}.make).structure_size * (l_i___0) + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 8 then
						if namedfm[l_i___0].fmark.fnum /= l_fnum___0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 9 then -- if:
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (namedfm.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 13 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 3 -- back to loop condition
				when 14 then -- loop done
						l_i___0 := 26
				when 15 then -- loop condition:
						if not (l_i___0 < 36) then
							l_pos := -1 + 22 -- skip loop
						end
				when 16 then -- loop body:
						if namedfm[l_i___0].fmark.fnum /= l_fnum___0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 17 then -- if:
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (namedfm.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 20 -- goto _L___1
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L___1:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 21 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 15 -- back to loop condition
				when 22 then -- loop done
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_insert") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 25 -- goto _L___2
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___2:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 26 then
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_change") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 29 -- goto _L___3
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L___3:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 30 then
						l_i___0 := 0
				when 31 then -- loop condition:
						if not (l_i___0 < globals_inst.curbuf.item.b_changelistlen) then
							l_pos := -1 + 37 -- skip loop
						end
				when 32 then -- loop body:
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_changelist") + (create {PD_POS_T}.make).structure_size * (l_i___0) + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 35 -- goto _L___4
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else: | _L___4:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 36 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 31 -- back to loop condition
				when 37 then -- loop done
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_start") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 40 -- goto _L___5
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L___5:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 41 then
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_end") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 44 -- goto _L___6
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___6:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 45 then
						quickfix_inst.qf_mark_adjust (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), a_line1, a_line2, a_amount, a_amount_after)
						l_tab___0 := globals_inst.first_tabpage
						from
						until
							not (not js.loop_done and then (not l_tab___0.is_void))
						loop
							if l_tab___0.is_equal (globals_inst.curtab) then
								l_win := globals_inst.firstwin
							else
								l_win := l_tab___0.item.tp_firstwin
							end
							from
							until
								l_win.is_void
							loop
								quickfix_inst.qf_mark_adjust (l_win, a_line1, a_line2, a_amount, a_amount_after)
								l_win := l_win.item.w_next
							end
							l_tab___0 := l_tab___0.item.tp_next
						end
						buffer_inst.sign_mark_adjust (a_line1, a_line2, a_amount, a_amount_after)
				when 46 then -- if done
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_pcmark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 49 -- goto _L___7
						end
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else: | _L___7:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 50 then
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_prev_pcmark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := (0).to_integer_32
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 53 -- goto _L___8
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 53 then -- else: | _L___8:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 54 then
						if globals_inst.saved_cursor.item.lnum = 0 then
							l_pos := -1 + 59 -- skip if block
						end
				when 55 then -- if:
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.saved_cursor.item.c_pointer + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 58 -- goto _L___9
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else: | _L___9:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 59 then -- if done
						l_tab___0 := globals_inst.first_tabpage
				when 60 then -- loop condition:
						if not (not js.loop_done and then (not l_tab___0.is_void)) then
							l_pos := -1 + 103 -- skip loop
						end
				when 61 then -- loop body:
						if l_tab___0.is_equal (globals_inst.curtab) then
							l_win := globals_inst.firstwin
						else
							l_win := l_tab___0.item.tp_firstwin
						end
				when 62 then -- loop condition:
						if not (not js.loop_done and then (not l_win.is_void)) then
							l_pos := -1 + 102 -- skip loop
						end
				when 63 then -- loop body:
						if (globals_inst.cmdmod.item.lockmarks).to_boolean then
							l_pos := -1 + 72 -- skip if block
						end
				when 64 then -- if:
						l_i___0 := 0
				when 65 then -- loop condition:
						if not (l_i___0 < l_win.item.w_jumplistlen) then
							l_pos := -1 + 72 -- skip loop
						end
				when 66 then -- loop body:
						if l_win.item.w_jumplist[l_i___0].fmark.fnum /= l_fnum___0 then
							l_pos := -1 + 71 -- skip if block
						end
				when 67 then -- if:
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 70 -- goto _L___10
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else: | _L___10:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 71 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 65 -- back to loop condition
				when 72 then -- loop done | if done
						if not ((l_win.item.w_buffer).is_equal (globals_inst.curbuf)) then
							l_pos := -1 + 101 -- skip if block
						end
				when 73 then -- if:
						if (globals_inst.cmdmod.item.lockmarks).to_boolean then
							l_pos := -1 + 82 -- skip if block
						end
				when 74 then -- if:
						l_i___0 := 0
				when 75 then -- loop condition:
						if not (l_i___0 < l_win.item.w_tagstacklen) then
							l_pos := -1 + 82 -- skip loop
						end
				when 76 then -- loop body:
						if l_win.item.w_tagstack[l_i___0].fmark.fnum /= l_fnum___0 then
							l_pos := -1 + 81 -- skip if block
						end
				when 77 then -- if:
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_tagstack") + (create {PD_TAGGY}.make).structure_size * (l_i___0) + (create {PD_TAGGY}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark") + (create {PD_POS_T}.make).offset_of ("lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 80 -- goto _L___11
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 80 then -- else: | _L___11:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 81 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 75 -- back to loop condition
				when 82 then -- loop done | if done
						if l_win.item.w_old_cursor_lnum = 0 then
							l_pos := -1 + 91 -- skip if block
						end
				when 83 then -- if:
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_old_cursor_lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 86 -- goto _L___12
						end
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else: | _L___12:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 87 then
						l_lp := create {CE_POINTER [INTEGER_32]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_old_visual_lnum"))
						if not (l_lp.item >= a_line1) then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						if l_lp.item <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_lp.item := a_line1
							else
								l_lp.item := l_lp.item + a_amount
							end
						else
							l_pos := -1 + 90 -- goto _L___13
						end
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 90 then -- else: | _L___13:
						if a_amount_after.to_boolean then
							if l_lp.item > a_line2 then
								l_lp.item := l_lp.item + a_amount_after
							end
						end
				when 91 then -- if done
						if l_win.is_equal (globals_inst.curwin) then
							l_pos := -1 + 100 -- skip if block
						end
				when 92 then -- if:
						if not (l_win.item.w_topline >= a_line1) then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						if l_win.item.w_topline <= a_line2 then
							if a_amount = 2_147_483_647 then
								if a_line1 <= 1 then
									l_win.item.w_topline := (1).to_integer_32
								else
									l_win.item.w_topline := a_line1 - 1
								end
							else
								l_win.item.w_topline := l_win.item.w_topline + a_amount
							end
							l_win.item.w_topfill := 0
						else
							l_pos := -1 + 95 -- goto _L___14
						end
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 95 then -- else: | _L___14:
						if a_amount_after.to_boolean then
							if l_win.item.w_topline > a_line2 then
								l_win.item.w_topline := l_win.item.w_topline + a_amount_after
								l_win.item.w_topfill := 0
							end
						end
				when 96 then
						if not (l_win.item.w_cursor.lnum >= a_line1) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						if l_win.item.w_cursor.lnum <= a_line2 then
							if a_amount = 2_147_483_647 then
								if a_line1 <= 1 then
									l_win.item.w_cursor.lnum := (1).to_integer_32
								else
									l_win.item.w_cursor.lnum := a_line1 - 1
								end
								l_win.item.w_cursor.col := 0
							else
								l_win.item.w_cursor.lnum := l_win.item.w_cursor.lnum + a_amount
							end
						else
							l_pos := -1 + 99 -- goto _L___15
						end
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 99 then -- else: | _L___15:
						if a_amount_after.to_boolean then
							if l_win.item.w_cursor.lnum > a_line2 then
								l_win.item.w_cursor.lnum := l_win.item.w_cursor.lnum + a_amount_after
							end
						end
				when 100 then -- if done
						fold_inst.foldMarkAdjust (l_win, a_line1, a_line2, a_amount, a_amount_after)
				when 101 then -- if done
						l_win := l_win.item.w_next
						l_pos := -1 + 62 -- back to loop condition
				when 102 then -- loop done
						l_tab___0 := l_tab___0.item.tp_next
						l_pos := -1 + 60 -- back to loop condition
				when 103 then -- loop done
						diff_inst.diff_mark_adjust (a_line1, a_line2, a_amount, a_amount_after)
				when 104 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mark_col_adjust (a_lnum: INTEGER_32; a_mincol: INTEGER_32; a_lnum_amount: INTEGER_32; a_col_amount: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_fnum___0: INTEGER_32
			l_win: CE_POINTER [PD_WINDOW_S]
			l_posp: CE_POINTER [PD_POS_T]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_win.make
			create l_posp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fnum___0 := globals_inst.curbuf.item.b_fnum
					if a_col_amount /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_lnum_amount = 0 then
							js.return
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (globals_inst.cmdmod.item.lockmarks).to_boolean then
							js.return
						end
				when 4 then
					if not js.return_called then
						l_i___0 := 0
						from
						until
							not (l_i___0 < 26)
						loop
							l_posp := globals_inst.curbuf.item.b_namedm + l_i___0
							if l_posp.item.lnum = a_lnum then
								if l_posp.item.col >= a_mincol then
									l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
									if a_col_amount < 0 then
										if l_posp.item.col <= (-a_col_amount).to_integer_32 then
											l_posp.item.col := 0
										else
											l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
										end
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								end
							end
							if namedfm[l_i___0].fmark.fnum = l_fnum___0 then
								l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (namedfm.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
								if l_posp.item.lnum = a_lnum then
									if l_posp.item.col >= a_mincol then
										l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
										if a_col_amount < 0 then
											if l_posp.item.col <= (-a_col_amount).to_integer_32 then
												l_posp.item.col := 0
											else
												l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
											end
										else
											l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
										end
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						l_i___0 := 26
						from
						until
							not (l_i___0 < 36)
						loop
							if namedfm[l_i___0].fmark.fnum = l_fnum___0 then
								l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (namedfm.c_pointer + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
								if l_posp.item.lnum = a_lnum then
									if l_posp.item.col >= a_mincol then
										l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
										if a_col_amount < 0 then
											if l_posp.item.col <= (-a_col_amount).to_integer_32 then
												l_posp.item.col := 0
											else
												l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
											end
										else
											l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
										end
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_insert"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_change"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < globals_inst.curbuf.item.b_changelistlen)
						loop
							l_posp := globals_inst.curbuf.item.b_changelist + l_i___0
							if l_posp.item.lnum = a_lnum then
								if l_posp.item.col >= a_mincol then
									l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
									if a_col_amount < 0 then
										if l_posp.item.col <= (-a_col_amount).to_integer_32 then
											l_posp.item.col := 0
										else
											l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
										end
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_start"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_visual") + (create {PD_VISUALINFO_T}.make).offset_of ("vi_end"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_pcmark"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_prev_pcmark"))
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_posp := globals_inst.saved_cursor
						if l_posp.item.lnum = a_lnum then
							if l_posp.item.col >= a_mincol then
								l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
								if a_col_amount < 0 then
									if l_posp.item.col <= (-a_col_amount).to_integer_32 then
										l_posp.item.col := 0
									else
										l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
									end
								else
									l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
								end
							end
						end
						l_win := globals_inst.firstwin
						from
						until
							not (not js.loop_done and then (not l_win.is_void))
						loop
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_win.item.w_jumplistlen)
							loop
								if l_win.item.w_jumplist[l_i___0].fmark.fnum = l_fnum___0 then
									l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * (l_i___0) + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
									if l_posp.item.lnum = a_lnum then
										if l_posp.item.col >= a_mincol then
											l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
											if a_col_amount < 0 then
												if l_posp.item.col <= (-a_col_amount).to_integer_32 then
													l_posp.item.col := 0
												else
													l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
												end
											else
												l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
											end
										end
									end
								end
								l_i___0 := l_i___0 + 1
							end
							if (l_win.item.w_buffer).is_equal (globals_inst.curbuf) then
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_win.item.w_tagstacklen)
								loop
									if l_win.item.w_tagstack[l_i___0].fmark.fnum = l_fnum___0 then
										l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_tagstack") + (create {PD_TAGGY}.make).structure_size * (l_i___0) + (create {PD_TAGGY}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
										if l_posp.item.lnum = a_lnum then
											if l_posp.item.col >= a_mincol then
												l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
												if a_col_amount < 0 then
													if l_posp.item.col <= (-a_col_amount).to_integer_32 then
														l_posp.item.col := 0
													else
														l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
													end
												else
													l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
												end
											end
										end
									end
									l_i___0 := l_i___0 + 1
								end
								if not l_win.is_equal (globals_inst.curwin) then
									l_posp := create {CE_POINTER [PD_POS_T]}.make_shared (l_win.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
									if l_posp.item.lnum = a_lnum then
										if l_posp.item.col >= a_mincol then
											l_posp.item.lnum := l_posp.item.lnum + a_lnum_amount
											if a_col_amount < 0 then
												if l_posp.item.col <= (-a_col_amount).to_integer_32 then
													l_posp.item.col := 0
												else
													l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
												end
											else
												l_posp.item.col := ((l_posp.item.col).to_integer_32 + a_col_amount).to_integer_32
											end
										end
									end
								end
							end
							l_win := l_win.item.w_next
						end
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mark_line (a_mp: CE_POINTER [PD_POS_T]; a_lead_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make
			create l_p___0.make
			create l_tmp.make

			if a_mp.item.lnum = 0 then
				l_tmp := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-invalid-")))
				Result := l_tmp
				js.return
			elseif a_mp.item.lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
				l_tmp := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-invalid-")))
				Result := l_tmp
				js.return
			end
			if not js.return_called then
				l_s := misc2_inst.vim_strnsave ((charset_inst.skipwhite ((memline_inst.ml_get (a_mp.item.lnum)))), (globals_inst.Columns.item).to_integer_32)
				if l_s.is_void then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_len := 0
				l_p___0 := l_s
				from
				until
					not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					l_len := l_len + (charset_inst.ptr2cells (l_p___0))
					if l_len.to_integer_32 >= globals_inst.Columns.item - a_lead_len.to_integer_32 then
						js.break
					end
					if not js.loop_jumped then
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___3 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
						else
							l_tmp___3 := 1
						end
						l_p___0 := l_p___0 + l_tmp___3
					end
				end
				l_p___0.item := (('%/0/').code).to_natural_8
				Result := l_s
			end
		end

	movechangelist (a_count___2: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.curbuf.item.b_changelistlen = 0 then
				Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_n := globals_inst.curwin.item.w_changelistidx
				if l_n + a_count___2 < 0 then
					if l_n = 0 then
						Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_n := 0
					end
				elseif l_n + a_count___2 >= globals_inst.curbuf.item.b_changelistlen then
					if l_n = globals_inst.curbuf.item.b_changelistlen - 1 then
						Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_n := globals_inst.curbuf.item.b_changelistlen - 1
					end
				else
					l_n := l_n + a_count___2
				end
			end
			if not js.return_called then
				globals_inst.curwin.item.w_changelistidx := l_n
				Result := (globals_inst.curbuf.item.b_changelist + l_n)
			end
		end

	movemark (a_count___2: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_count___2: INTEGER_32
			l_pos___3: CE_POINTER [PD_POS_T]
			l_jmp: CE_POINTER [PD_XFILEMARK]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_pos___3.make
			create l_jmp.make

			l_count___2 := a_count___2
			cleanup_jumplist
			if globals_inst.curwin.item.w_jumplistlen = 0 then
				Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if globals_inst.curwin.item.w_jumplistidx + l_count___2 < 0 then
						Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
						js.return
					elseif globals_inst.curwin.item.w_jumplistidx + l_count___2 >= globals_inst.curwin.item.w_jumplistlen then
						Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called and then (globals_inst.curwin.item.w_jumplistidx = globals_inst.curwin.item.w_jumplistlen) then
						setpcmark
						globals_inst.curwin.item.w_jumplistidx := (globals_inst.curwin.item.w_jumplistidx) - 1
						if globals_inst.curwin.item.w_jumplistidx + l_count___2 < 0 then
							Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
							js.return
						end
					end
					if not js.return_called then
						globals_inst.curwin.item.w_jumplistidx := globals_inst.curwin.item.w_jumplistidx + l_count___2
						l_jmp := globals_inst.curwin.item.w_jumplist + globals_inst.curwin.item.w_jumplistidx
						if l_jmp.item.fmark.fnum = 0 then
							fname2fnum (l_jmp)
						end
						if l_jmp.item.fmark.fnum /= globals_inst.curbuf.item.b_fnum then
							if (buffer_inst.buflist_findnr (l_jmp.item.fmark.fnum)).is_void then
								if l_count___2 < 0 then
									l_tmp := -1
								else
									l_tmp := 1
								end
								l_count___2 := l_count___2 + l_tmp
								js.continue
							end
							if not js.loop_jumped then
								if (buffer_inst.buflist_getfile (l_jmp.item.fmark.fnum, l_jmp.item.fmark.mark.lnum, 0, 0)) = 0 then
									Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
									js.return
								end
								if not js.return_called then
									globals_inst.curwin.item.w_cursor := (l_jmp.item.fmark.mark).twin
									l_pos___3 := create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer + -1)
								end
							end
						else
							l_pos___3 := create {CE_POINTER [PD_POS_T]}.make_shared (l_jmp.c_pointer + (create {PD_XFILEMARK}.make).offset_of ("fmark") + (create {PD_FILEMARK}.make).offset_of ("mark"))
						end
					end
					if not js.return_called then
						if not js.loop_jumped then
							Result := l_pos___3
							js.return
						end
						if js.loop_increment then
							
						end
					end
				end
			end
		end

	read_viminfo_filemark (a_virp: CE_POINTER [PD_VIR_T]; a_force: INTEGER_32): INTEGER_32
		local
			l_str___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fm: CE_POINTER [PD_XFILEMARK]
			l_i___0: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_str___1.make (<<1>>)
			create l_fm.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1.item := a_virp.item.vir_line + 1
					if not ((l_str___1.item.item).to_integer_32 <= 127) then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						if ((a_virp.item.vir_line).item).to_integer_32 /= 39 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not ((l_str___1.item.item).to_integer_32 >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_str___1.item.item).to_integer_32 <= 57 then
							l_pos := -1 + 9 -- goto _L___0
						else
							l_pos := -1 + 5 -- goto _L___2
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L___2:
						if ((((ctype_b_loc).item[(l_str___1.item.item).to_integer_32]).to_integer_32).bit_and (256)).to_boolean then
							l_pos := -1 + 9 -- goto _L___0
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else: | _L___1:
						if ((a_virp.item.vir_line).item).to_integer_32 /= 45 then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if (l_str___1.item.item).to_integer_32 /= 39 then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if (l_str___1.item.item).to_integer_32 = 39 then
							if globals_inst.curwin.item.w_jumplistlen = 100 then
								l_fm := create {CE_POINTER [PD_XFILEMARK]}.make_shared (default_pointer)
							else
								l_i___0 := globals_inst.curwin.item.w_jumplistlen
								from
								until
									not (l_i___0 > 0)
								loop
									globals_inst.curwin.item.w_jumplist[l_i___0] := (globals_inst.curwin.item.w_jumplist[l_i___0 - 1]).twin
									l_i___0 := l_i___0 - 1
								end
								globals_inst.curwin.item.w_jumplistidx := (globals_inst.curwin.item.w_jumplistidx) + 1
								globals_inst.curwin.item.w_jumplistlen := (globals_inst.curwin.item.w_jumplistlen) + 1
								l_fm := globals_inst.curwin.item.w_jumplist + 0
								l_fm.item.fmark.mark.lnum := (0).to_integer_32
								l_fm.item.fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
						elseif (l_str___1.item.item).to_integer_32 >= 48 then
							if (l_str___1.item.item).to_integer_32 <= 57 then
								l_fm := namedfm + ((l_str___1.item.item).to_integer_32 - 48) + 26
							else
								l_fm := namedfm + (l_str___1.item.item).to_integer_32 - 65
							end
						else
							l_fm := namedfm + (l_str___1.item.item).to_integer_32 - 65
						end
						if l_fm.is_void then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if l_fm.item.fmark.mark.lnum /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (a_force.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						l_str___1.item := charset_inst.skipwhite (l_str___1.item + 1)
						l_fm.item.fmark.mark.lnum := charset_inst.getdigits (l_str___1)
						l_str___1.item := charset_inst.skipwhite (l_str___1.item)
						l_fm.item.fmark.mark.col := (charset_inst.getdigits (l_str___1)).to_integer_32
						l_fm.item.fmark.mark.coladd := 0
						l_fm.item.fmark.fnum := 0
						l_str___1.item := charset_inst.skipwhite (l_str___1.item)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fm.item.fname))
						l_fm.item.fname := ex_cmds_inst.viminfo_readstring (a_virp, (l_str___1.item).distance ((a_virp.item.vir_line)), 0)
				when 15 then -- if done | if done | if done | if done | if done | if done
						Result := (fileio_inst.vim_fgets (a_virp.item.vir_line, 512, a_virp.item.vir_fd))
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	removable (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_part: CE_ARRAY [NATURAL_8]
			l_retval: INTEGER_32
			l_n: NATURAL_32
			js: JUMP_STATE
		do
			create l_name___1.make
			create l_p___0.make (<<1>>)
			create l_part.make (<<51>>)

			l_name___1 := a_name___1
			l_retval := 0
			l_name___1 := misc1_inst.home_replace_save (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_name___1)
			if not l_name___1.is_void then
				l_p___0.item := option_inst.p_viminfo.item
				from
				until
					not (not js.loop_done and then ((l_p___0.item.item).to_boolean))
				loop
					misc2_inst.copy_option_part (l_p___0, l_part, 51, ce_string (", ")).do_nothing
					if (l_part[0]).to_integer_32 = 114 then
						l_n := strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_part + 1)))
						if (mbyte_inst.mb_strnicmp (l_part + 1, l_name___1, (l_n.to_integer_32).to_natural_32)) = 0 then
							l_retval := 1
							js.break
						end
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
			end
			Result := l_retval
		end

	set_last_cursor (a_win: CE_POINTER [PD_WINDOW_S])
		do
			(a_win.item.w_buffer).item.b_last_cursor := (a_win.item.w_cursor).twin
		end

	setmark (a_c: INTEGER_32): INTEGER_32
		do
			Result := (setmark_pos (a_c, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), globals_inst.curbuf.item.b_fnum))
		end

	setmark_pos (a_c: INTEGER_32; a_pos___3: CE_POINTER [PD_POS_T]; a_fnum___0: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c < 0 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_c /= 39 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if a_c /= 96 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if a_pos___3.is_equal (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))) then
							setpcmark
							globals_inst.curwin.item.w_prev_pcmark := (globals_inst.curwin.item.w_pcmark).twin
						else
							globals_inst.curwin.item.w_pcmark := (a_pos___3.item).twin
						end
						Result := 1
						js.return
				when 6 then -- if done | if done
						if not js.return_called and then (a_c = 34) then
							globals_inst.curbuf.item.b_last_cursor := (a_pos___3.item).twin
							Result := 1
							js.return
						end
						if not js.return_called and then (a_c = 91) then
							globals_inst.curbuf.item.b_op_start := (a_pos___3.item).twin
							Result := 1
							js.return
						end
						if not js.return_called and then (a_c = 93) then
							globals_inst.curbuf.item.b_op_end := (a_pos___3.item).twin
							Result := 1
							js.return
						end
						if not js.return_called and then (a_c > 122) then
							Result := 0
							js.return
						end
						if not js.return_called then
							if ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (512)).to_boolean then
								l_i___0 := a_c - 97
								globals_inst.curbuf.item.b_namedm[l_i___0] := (a_pos___3.item).twin
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							if ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (256)).to_boolean then
								l_i___0 := a_c - 65
								namedfm[l_i___0].fmark.mark := (a_pos___3.item).twin
								namedfm[l_i___0].fmark.fnum := a_fnum___0
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (namedfm[l_i___0].fname))
								namedfm[l_i___0].fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	setpcmark
		local
			l_i___0: INTEGER_32
			l_fm: CE_POINTER [PD_XFILEMARK]
			js: JUMP_STATE
		do
			create l_fm.make

			if globals_inst.global_busy.to_boolean then
				js.return
			elseif globals_inst.listcmd_busy.to_boolean then
				js.return
			elseif (globals_inst.cmdmod.item.keepjumps).to_boolean then
				js.return
			end
			if not js.return_called then
				globals_inst.curwin.item.w_prev_pcmark := (globals_inst.curwin.item.w_pcmark).twin
				globals_inst.curwin.item.w_pcmark := (globals_inst.curwin.item.w_cursor).twin
				globals_inst.curwin.item.w_jumplistlen := (globals_inst.curwin.item.w_jumplistlen) + 1
				if globals_inst.curwin.item.w_jumplistlen > 100 then
					globals_inst.curwin.item.w_jumplistlen := 100
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.curwin.item.w_jumplist[0].fname))
					l_i___0 := 1
					from
					until
						not (l_i___0 < 100)
					loop
						globals_inst.curwin.item.w_jumplist[l_i___0 - 1] := (globals_inst.curwin.item.w_jumplist[l_i___0]).twin
						l_i___0 := l_i___0 + 1
					end
				end
				globals_inst.curwin.item.w_jumplistidx := globals_inst.curwin.item.w_jumplistlen
				l_fm := globals_inst.curwin.item.w_jumplist + globals_inst.curwin.item.w_jumplistlen - 1
				l_fm.item.fmark.mark := (globals_inst.curwin.item.w_pcmark).twin
				l_fm.item.fmark.fnum := globals_inst.curbuf.item.b_fnum
				l_fm.item.fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
		end

	show_one_mark (a_c: INTEGER_32; a_arg: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [PD_POS_T]; a_name___1: CE_POINTER [NATURAL_8]; a_current: INTEGER_32)
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_mustfree: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_name___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name___1 := a_name___1
					l_mustfree := 0
					if a_c /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if did_title.to_boolean then
							did_title := 0
						elseif a_arg.is_void then
							message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("No marks set"))))).do_nothing
						else
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E283: No marks matching %"%%s%"")))), a_arg).do_nothing
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if globals_inst.got_int.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not (a_arg.is_void) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (misc2_inst.vim_strchr (a_arg, a_c)).is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if a_p___0.item.lnum /= 0 then
							if not did_title.to_boolean then
								message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%Nmark line  col file/text")))))
								did_title := 1
							end
							message_inst.msg_putchar (('%N').code)
							if not globals_inst.got_int.to_boolean then
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string (" %%c %%6ld %%4d "), a_c, a_p___0.item.lnum, a_p___0.item.col]).do_nothing
								message_inst.msg_outtrans (globals_inst.IObuff).do_nothing
								if l_name___1.is_void then
									if a_current.to_boolean then
										l_name___1 := mark_line (a_p___0, 15)
										l_mustfree := 1
									end
								end
								if not l_name___1.is_void then
									if a_current.to_boolean then
										l_tmp___2 := globals_inst.highlight_attr[2]
									else
										l_tmp___2 := 0
									end
									message_inst.msg_outtrans_attr (l_name___1, l_tmp___2).do_nothing
									if l_mustfree.to_boolean then
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
									end
								end
							end
							term_inst.out_flush
						end
				when 9 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	write_one_filemark (a_fp: CE_POINTER [SD_IO_FILE]; a_fm: CE_POINTER [PD_XFILEMARK]; a_c1: INTEGER_32; a_c2: INTEGER_32)
		local
			l_name___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_name___1.make

			if a_fm.item.fmark.mark.lnum = 0 then
				js.return
			end
			if not js.return_called then
				if a_fm.item.fmark.fnum /= 0 then
					l_name___1 := buffer_inst.buflist_nr2name (a_fm.item.fmark.fnum, 1, 0)
				else
					l_name___1 := a_fm.item.fname
				end
				if not l_name___1.is_void then
					if (l_name___1.item).to_integer_32 /= 0 then
						fprintf ([a_fp, ce_string ("%%c%%c  %%ld  %%ld  "), a_c1, a_c2, a_fm.item.fmark.mark.lnum, (a_fm.item.fmark.mark.col).to_integer_32]).do_nothing
						ex_cmds_inst.viminfo_writestring (a_fp, l_name___1)
					end
				end
				if a_fm.item.fmark.fnum /= 0 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
				end
			end
		end

	write_one_mark (a_fp_out: CE_POINTER [SD_IO_FILE]; a_c: INTEGER_32; a_pos___3: CE_POINTER [PD_POS_T])
		do
			if a_pos___3.item.lnum /= 0 then
				fprintf ([a_fp_out, ce_string ("%T%%c%T%%ld%T%%d%N"), a_c, a_pos___3.item.lnum, a_pos___3.item.col]).do_nothing
			end
		end

	write_viminfo_filemarks (a_fp: CE_POINTER [SD_IO_FILE])
		local
			l_i___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_fm: CE_POINTER [PD_XFILEMARK]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_name___1.make
			create l_buf___6.make
			create l_fm.make

			if (option_inst.get_viminfo_parameter (('f').code)) = 0 then
				js.return
			end
			if not js.return_called then
				fputs ((gettext (ce_string ("%N# File marks:%N"))), a_fp).do_nothing
				if not (globals_inst.curbuf.item.b_ffname).is_void then
					if not (removable (globals_inst.curbuf.item.b_ffname)).to_boolean then
						l_name___1 := buffer_inst.buflist_nr2name (globals_inst.curbuf.item.b_fnum, 1, 0)
						l_i___0 := 26
						from
						until
							not (not js.loop_done and then (l_i___0 < 35))
						loop
							if namedfm[l_i___0].fmark.mark.lnum = globals_inst.curwin.item.w_cursor.lnum then
								if (namedfm[l_i___0].fname).is_void then
									l_tmp___3 := (namedfm[l_i___0].fmark.fnum = globals_inst.curbuf.item.b_fnum).to_integer
								else
									if not l_name___1.is_void then
										if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (namedfm[l_i___0].fname))) = 0 then
											l_tmp___2 := 1
										else
											l_tmp___2 := 0
										end
									else
										l_tmp___2 := 0
									end
									l_tmp___3 := l_tmp___2
								end
								if l_tmp___3.to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (namedfm[l_i___0].fname))
						from
						until
							not (l_i___0 > 26)
						loop
							namedfm[l_i___0] := (namedfm[l_i___0 - 1]).twin
							l_i___0 := l_i___0 - 1
						end
						namedfm[26].fmark.mark := (globals_inst.curwin.item.w_cursor).twin
						namedfm[26].fmark.fnum := globals_inst.curbuf.item.b_fnum
						namedfm[26].fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
				end
				l_i___0 := 0
				from
				until
					not (l_i___0 < 36)
				loop
					if l_i___0 < 26 then
						l_tmp___5 := l_i___0 + 65
					else
						l_tmp___5 := (l_i___0 - 26) + 48
					end
					write_one_filemark (a_fp, namedfm + l_i___0, ('%'').code, l_tmp___5)
					l_i___0 := l_i___0 + 1
				end
				fputs ((gettext (ce_string ("%N# Jumplist (newest first):%N"))), a_fp).do_nothing
				setpcmark
				cleanup_jumplist
				l_fm := globals_inst.curwin.item.w_jumplist + globals_inst.curwin.item.w_jumplistlen - 1
				from
				until
					not ((l_fm.c_pointer.to_integer_32).to_natural_32 >= ((globals_inst.curwin.item.w_jumplist + 0).c_pointer.to_integer_32).to_natural_32)
				loop
					if l_fm.item.fmark.fnum = 0 then
						write_one_filemark (a_fp, l_fm, ('-').code, ('%'').code)
					else
						l_buf___6 := buffer_inst.buflist_findnr (l_fm.item.fmark.fnum)
						if not l_buf___6.is_void then
							if not (removable (l_buf___6.item.b_ffname)).to_boolean then
								write_one_filemark (a_fp, l_fm, ('-').code, ('%'').code)
							end
						end
					end
					l_fm := l_fm - 1
				end
			end
		end

	write_viminfo_marks (a_fp_out: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_is_mark_set: INTEGER_32
			l_i___0: INTEGER_32
			l_win: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			js: JUMP_STATE
		do
			create l_buf___6.make
			create l_win.make
			create l_tp.make

			l_tp := globals_inst.first_tabpage
			from
			until
				not (not js.loop_done and then (not l_tp.is_void))
			loop
				if l_tp.is_equal (globals_inst.curtab) then
					l_win := globals_inst.firstwin
				else
					l_win := l_tp.item.tp_firstwin
				end
				from
				until
					l_win.is_void
				loop
					set_last_cursor (l_win)
					l_win := l_win.item.w_next
				end
				l_tp := l_tp.item.tp_next
			end
			fputs ((gettext (ce_string ("%N# History of marks within files (newest to oldest):%N"))), a_fp_out).do_nothing
			l_count___2 := 0
			l_buf___6 := globals_inst.firstbuf
			from
			until
				not (not js.loop_done and then (not l_buf___6.is_void))
			loop
				if (l_buf___6.item.b_marks_read).to_boolean then
					if l_buf___6.item.b_last_cursor.lnum /= 0 then
						l_is_mark_set := 1
					else
						l_is_mark_set := 0
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0 < 26))
						loop
							if l_buf___6.item.b_namedm[l_i___0].lnum /= 0 then
								l_is_mark_set := 1
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
					end
					if l_is_mark_set.to_boolean then
						if not (l_buf___6.item.b_ffname).is_void then
							if (l_buf___6.item.b_ffname[0]).to_integer_32 /= 0 then
								if not (removable (l_buf___6.item.b_ffname)).to_boolean then
									misc1_inst.home_replace (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_buf___6.item.b_ffname, globals_inst.IObuff, 1_025, 1)
									fprintf ([a_fp_out, ce_string ("%N> ")]).do_nothing
									ex_cmds_inst.viminfo_writestring (a_fp_out, globals_inst.IObuff)
									write_one_mark (a_fp_out, ('%"').code, create {CE_POINTER [PD_POS_T]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_cursor")))
									write_one_mark (a_fp_out, ('^').code, create {CE_POINTER [PD_POS_T]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_insert")))
									write_one_mark (a_fp_out, ('.').code, create {CE_POINTER [PD_POS_T]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_last_change")))
									l_i___0 := 0
									from
									until
										not (l_i___0 < l_buf___6.item.b_changelistlen)
									loop
										write_one_mark (a_fp_out, ('+').code, l_buf___6.item.b_changelist + l_i___0)
										l_i___0 := l_i___0 + 1
									end
									l_i___0 := 0
									from
									until
										not (l_i___0 < 26)
									loop
										write_one_mark (a_fp_out, 97 + l_i___0, l_buf___6.item.b_namedm + l_i___0)
										l_i___0 := l_i___0 + 1
									end
									l_count___2 := l_count___2 + 1
								end
							end
						end
					end
				end
				l_buf___6 := l_buf___6.item.b_next
			end
			Result := l_count___2
		end

end
