class
	P_PTY

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create TtyName.make (<<32>>)
		end

feature {ANY} -- attributes

	TtyName: CE_ARRAY [INTEGER_8]

feature {ANY} -- routines

	OpenPTY (a_ttyn: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_f: INTEGER_32
			l_m: CE_POINTER [INTEGER_8]
			l_sigcld: CE_ROUTINE
			js: JUMP_STATE
		do
			create l_m.make
			create l_sigcld.make

			l_f := open ([ce_string ("/dev/ptmx"), 258, 0])
			if l_f = -1 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_sigcld := signal (17, create {CE_ROUTINE}.make_shared (default_pointer))
				l_m := ptsname (l_f)
				if l_m.is_void then
					signal (17, l_sigcld).do_nothing
					close (l_f).do_nothing
					Result := (-1)
					js.return
				elseif (grantpt (l_f)).to_boolean then
					signal (17, l_sigcld).do_nothing
					close (l_f).do_nothing
					Result := (-1)
					js.return
				elseif (unlockpt (l_f)).to_boolean then
					signal (17, l_sigcld).do_nothing
					close (l_f).do_nothing
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				signal (17, l_sigcld).do_nothing
				strncpy (TtyName, l_m, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32)).do_nothing
				initmaster (l_f)
				a_ttyn.item := TtyName
				Result := l_f
			end
		end

	SetupSlavePTY (a_fd: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_fd < 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	initmaster (a_f: INTEGER_32)
		do
		end

end
