class
	SD_GARRAY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
		end

feature {ANY} -- fields

	data: CE_POINTER [INTEGER_8] assign set_data

	len: NATURAL_32 assign set_len

feature {ANY} -- setters

	set_data (a_data: CE_POINTER [INTEGER_8])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_len (a_len: NATURAL_32)
		do
			len := a_len
			update_memory_field ("len")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
			len := a_other.len
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data) and
				len = a_other.len
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("len")
				>>)
			init_structure_info
		end

end
