class
	SD_GCLOSURE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	ref_count: NATURAL_32 assign set_ref_count

	meta_marshal: NATURAL_32 assign set_meta_marshal

	n_guards: NATURAL_32 assign set_n_guards

	n_fnotifiers: NATURAL_32 assign set_n_fnotifiers

	n_inotifiers: NATURAL_32 assign set_n_inotifiers

	in_inotify: NATURAL_32 assign set_in_inotify

	floating: NATURAL_32 assign set_floating

	derivative_flag: NATURAL_32 assign set_derivative_flag

	in_marshal: NATURAL_32 assign set_in_marshal

	is_invalid: NATURAL_32 assign set_is_invalid

	marshal: CE_ROUTINE assign set_marshal

	data: CE_POINTER [ANY] assign set_data

	notifiers: CE_POINTER [SD_GCLOSURENOTIFYDATA] assign set_notifiers

feature {ANY} -- setters

	set_ref_count (a_ref_count: NATURAL_32)
		do
			ref_count := a_ref_count
			update_memory_field ("ref_count")
		end

	set_meta_marshal (a_meta_marshal: NATURAL_32)
		do
			meta_marshal := a_meta_marshal
			update_memory_field ("meta_marshal")
		end

	set_n_guards (a_n_guards: NATURAL_32)
		do
			n_guards := a_n_guards
			update_memory_field ("n_guards")
		end

	set_n_fnotifiers (a_n_fnotifiers: NATURAL_32)
		do
			n_fnotifiers := a_n_fnotifiers
			update_memory_field ("n_fnotifiers")
		end

	set_n_inotifiers (a_n_inotifiers: NATURAL_32)
		do
			n_inotifiers := a_n_inotifiers
			update_memory_field ("n_inotifiers")
		end

	set_in_inotify (a_in_inotify: NATURAL_32)
		do
			in_inotify := a_in_inotify
			update_memory_field ("in_inotify")
		end

	set_floating (a_floating: NATURAL_32)
		do
			floating := a_floating
			update_memory_field ("floating")
		end

	set_derivative_flag (a_derivative_flag: NATURAL_32)
		do
			derivative_flag := a_derivative_flag
			update_memory_field ("derivative_flag")
		end

	set_in_marshal (a_in_marshal: NATURAL_32)
		do
			in_marshal := a_in_marshal
			update_memory_field ("in_marshal")
		end

	set_is_invalid (a_is_invalid: NATURAL_32)
		do
			is_invalid := a_is_invalid
			update_memory_field ("is_invalid")
		end

	set_marshal (a_marshal: CE_ROUTINE)
		do
			marshal := a_marshal
			update_memory_field ("marshal")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_notifiers (a_notifiers: CE_POINTER [SD_GCLOSURENOTIFYDATA])
		do
			notifiers := a_notifiers
			update_memory_field ("notifiers")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ref_count := a_other.ref_count
			meta_marshal := a_other.meta_marshal
			n_guards := a_other.n_guards
			n_fnotifiers := a_other.n_fnotifiers
			n_inotifiers := a_other.n_inotifiers
			in_inotify := a_other.in_inotify
			floating := a_other.floating
			derivative_flag := a_other.derivative_flag
			in_marshal := a_other.in_marshal
			is_invalid := a_other.is_invalid
			marshal := a_other.marshal
			data := a_other.data
			notifiers := a_other.notifiers
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ref_count = a_other.ref_count and
				meta_marshal = a_other.meta_marshal and
				n_guards = a_other.n_guards and
				n_fnotifiers = a_other.n_fnotifiers and
				n_inotifiers = a_other.n_inotifiers and
				in_inotify = a_other.in_inotify and
				floating = a_other.floating and
				derivative_flag = a_other.derivative_flag and
				in_marshal = a_other.in_marshal and
				is_invalid = a_other.is_invalid and
				marshal.is_equal (a_other.marshal) and
				data.is_equal (a_other.data) and
				notifiers.is_equal (a_other.notifiers)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_bitfield ("ref_count"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("meta_marshal"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("n_guards"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("n_fnotifiers"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("n_inotifiers"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("in_inotify"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("floating"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("derivative_flag"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("in_marshal"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("is_invalid"),
					create {CE_STRUCTURE_FIELD}.make ("marshal"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("notifiers")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <glib-object.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GClosure);
					if(strcmp(field_name, "marshal") == 0) return offsetof(struct _GClosure, marshal);
				} else {
					struct _GClosure *p = (struct _GClosure *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "ref_count") == 0) p->ref_count = (unsigned int)$a_value;
						else if(strcmp(field_name, "meta_marshal") == 0) p->meta_marshal = (unsigned int)$a_value;
						else if(strcmp(field_name, "n_guards") == 0) p->n_guards = (unsigned int)$a_value;
						else if(strcmp(field_name, "n_fnotifiers") == 0) p->n_fnotifiers = (unsigned int)$a_value;
						else if(strcmp(field_name, "n_inotifiers") == 0) p->n_inotifiers = (unsigned int)$a_value;
						else if(strcmp(field_name, "in_inotify") == 0) p->in_inotify = (unsigned int)$a_value;
						else if(strcmp(field_name, "floating") == 0) p->floating = (unsigned int)$a_value;
						else if(strcmp(field_name, "derivative_flag") == 0) p->derivative_flag = (unsigned int)$a_value;
						else if(strcmp(field_name, "in_marshal") == 0) p->in_marshal = (unsigned int)$a_value;
						else if(strcmp(field_name, "is_invalid") == 0) p->is_invalid = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "ref_count") == 0) return p->ref_count;
						if(strcmp(field_name, "meta_marshal") == 0) return p->meta_marshal;
						if(strcmp(field_name, "n_guards") == 0) return p->n_guards;
						if(strcmp(field_name, "n_fnotifiers") == 0) return p->n_fnotifiers;
						if(strcmp(field_name, "n_inotifiers") == 0) return p->n_inotifiers;
						if(strcmp(field_name, "in_inotify") == 0) return p->in_inotify;
						if(strcmp(field_name, "floating") == 0) return p->floating;
						if(strcmp(field_name, "derivative_flag") == 0) return p->derivative_flag;
						if(strcmp(field_name, "in_marshal") == 0) return p->in_marshal;
						if(strcmp(field_name, "is_invalid") == 0) return p->is_invalid;
					}
				}
			]"
		end

end
