class
	SD_GDKDISPLAY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	queued_events: CE_POINTER [SD_GLIST] assign set_queued_events

	queued_tail: CE_POINTER [SD_GLIST] assign set_queued_tail

	button_click_time: CE_ARRAY [NATURAL_32]

	button_window: CE_ARRAY [CE_POINTER [SD_GDKDRAWABLE]]

	button_number: CE_ARRAY [INTEGER_32]

	double_click_time: NATURAL_32 assign set_double_click_time

	core_pointer: CE_POINTER [SD_GDKDEVICE] assign set_core_pointer

	pointer_hooks: CE_POINTER [SD_GDKDISPLAYPOINTERHOOKS] assign set_pointer_hooks

	closed: NATURAL_32 assign set_closed

	ignore_core_events: NATURAL_32 assign set_ignore_core_events

	double_click_distance: NATURAL_32 assign set_double_click_distance

	button_x: CE_ARRAY [INTEGER_32]

	button_y: CE_ARRAY [INTEGER_32]

	pointer_grabs: CE_POINTER [SD_GLIST] assign set_pointer_grabs

	keyboard_grab: SD_GDKKEYBOARDGRABINFO assign set_keyboard_grab

	pointer_info: SD_GDKPOINTERWINDOWINFO assign set_pointer_info

	last_event_time: NATURAL_32 assign set_last_event_time

feature {ANY} -- setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_queued_events (a_queued_events: CE_POINTER [SD_GLIST])
		do
			queued_events := a_queued_events
			update_memory_field ("queued_events")
		end

	set_queued_tail (a_queued_tail: CE_POINTER [SD_GLIST])
		do
			queued_tail := a_queued_tail
			update_memory_field ("queued_tail")
		end

	set_double_click_time (a_double_click_time: NATURAL_32)
		do
			double_click_time := a_double_click_time
			update_memory_field ("double_click_time")
		end

	set_core_pointer (a_core_pointer: CE_POINTER [SD_GDKDEVICE])
		do
			core_pointer := a_core_pointer
			update_memory_field ("core_pointer")
		end

	set_pointer_hooks (a_pointer_hooks: CE_POINTER [SD_GDKDISPLAYPOINTERHOOKS])
		do
			pointer_hooks := a_pointer_hooks
			update_memory_field ("pointer_hooks")
		end

	set_closed (a_closed: NATURAL_32)
		do
			closed := a_closed
			update_memory_field ("closed")
		end

	set_ignore_core_events (a_ignore_core_events: NATURAL_32)
		do
			ignore_core_events := a_ignore_core_events
			update_memory_field ("ignore_core_events")
		end

	set_double_click_distance (a_double_click_distance: NATURAL_32)
		do
			double_click_distance := a_double_click_distance
			update_memory_field ("double_click_distance")
		end

	set_pointer_grabs (a_pointer_grabs: CE_POINTER [SD_GLIST])
		do
			pointer_grabs := a_pointer_grabs
			update_memory_field ("pointer_grabs")
		end

	set_keyboard_grab (a_keyboard_grab: SD_GDKKEYBOARDGRABINFO)
		do
			keyboard_grab := a_keyboard_grab
			update_memory_field ("keyboard_grab")
		end

	set_pointer_info (a_pointer_info: SD_GDKPOINTERWINDOWINFO)
		do
			pointer_info := a_pointer_info
			update_memory_field ("pointer_info")
		end

	set_last_event_time (a_last_event_time: NATURAL_32)
		do
			last_event_time := a_last_event_time
			update_memory_field ("last_event_time")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			queued_events := a_other.queued_events
			queued_tail := a_other.queued_tail
			button_click_time := a_other.button_click_time.twin
			button_window := a_other.button_window.twin
			button_number := a_other.button_number.twin
			double_click_time := a_other.double_click_time
			core_pointer := a_other.core_pointer
			pointer_hooks := a_other.pointer_hooks
			closed := a_other.closed
			ignore_core_events := a_other.ignore_core_events
			double_click_distance := a_other.double_click_distance
			button_x := a_other.button_x.twin
			button_y := a_other.button_y.twin
			pointer_grabs := a_other.pointer_grabs
			keyboard_grab := a_other.keyboard_grab.twin
			pointer_info := a_other.pointer_info.twin
			last_event_time := a_other.last_event_time
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				queued_events.is_equal (a_other.queued_events) and
				queued_tail.is_equal (a_other.queued_tail) and
				button_click_time.is_equal (a_other.button_click_time) and
				button_window.is_equal (a_other.button_window) and
				button_number.is_equal (a_other.button_number) and
				double_click_time = a_other.double_click_time and
				core_pointer.is_equal (a_other.core_pointer) and
				pointer_hooks.is_equal (a_other.pointer_hooks) and
				closed = a_other.closed and
				ignore_core_events = a_other.ignore_core_events and
				double_click_distance = a_other.double_click_distance and
				button_x.is_equal (a_other.button_x) and
				button_y.is_equal (a_other.button_y) and
				pointer_grabs.is_equal (a_other.pointer_grabs) and
				keyboard_grab.is_equal (a_other.keyboard_grab) and
				pointer_info.is_equal (a_other.pointer_info) and
				last_event_time = a_other.last_event_time
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("queued_events"),
					create {CE_STRUCTURE_FIELD}.make ("queued_tail"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("button_click_time", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("button_window", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("button_number", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("double_click_time"),
					create {CE_STRUCTURE_FIELD}.make ("core_pointer"),
					create {CE_STRUCTURE_FIELD}.make ("pointer_hooks"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("closed"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("ignore_core_events"),
					create {CE_STRUCTURE_FIELD}.make ("double_click_distance"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("button_x", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("button_y", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("pointer_grabs"),
					create {CE_STRUCTURE_FIELD}.make ("keyboard_grab"),
					create {CE_STRUCTURE_FIELD}.make ("pointer_info"),
					create {CE_STRUCTURE_FIELD}.make ("last_event_time")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gdk/gdk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GdkDisplay);
					if(strcmp(field_name, "double_click_distance") == 0) return offsetof(struct _GdkDisplay, double_click_distance);
				} else {
					struct _GdkDisplay *p = (struct _GdkDisplay *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "closed") == 0) p->closed = (unsigned int)$a_value;
						else if(strcmp(field_name, "ignore_core_events") == 0) p->ignore_core_events = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "closed") == 0) return p->closed;
						if(strcmp(field_name, "ignore_core_events") == 0) return p->ignore_core_events;
					}
				}
			]"
		end

end
