class
	SD_GDKEVENTDND

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create window.make
			create context.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	context: CE_POINTER [SD_GDKDRAGCONTEXT] assign set_context

	time: NATURAL_32 assign set_time

	x_root: INTEGER_16 assign set_x_root

	y_root: INTEGER_16 assign set_y_root

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_context (a_context: CE_POINTER [SD_GDKDRAGCONTEXT])
		do
			context := a_context
			update_memory_field ("context")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_x_root (a_x_root: INTEGER_16)
		do
			x_root := a_x_root
			update_memory_field ("x_root")
		end

	set_y_root (a_y_root: INTEGER_16)
		do
			y_root := a_y_root
			update_memory_field ("y_root")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			context := a_other.context
			time := a_other.time
			x_root := a_other.x_root
			y_root := a_other.y_root
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				context.is_equal (a_other.context) and
				time = a_other.time and
				x_root = a_other.x_root and
				y_root = a_other.y_root
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("context"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("x_root"),
					create {CE_STRUCTURE_FIELD}.make ("y_root")
				>>)
			init_structure_info
		end

end
