class
	SD_GDKEVENTKEY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	time: NATURAL_32 assign set_time

	state: NATURAL_32 assign set_state

	keyval: NATURAL_32 assign set_keyval

	length: INTEGER_32 assign set_length

	string: CE_POINTER [INTEGER_8] assign set_string

	hardware_keycode: NATURAL_16 assign set_hardware_keycode

	group: NATURAL_8 assign set_group

	is_modifier: NATURAL_32 assign set_is_modifier

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_keyval (a_keyval: NATURAL_32)
		do
			keyval := a_keyval
			update_memory_field ("keyval")
		end

	set_length (a_length: INTEGER_32)
		do
			length := a_length
			update_memory_field ("length")
		end

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			string := a_string
			update_memory_field ("string")
		end

	set_hardware_keycode (a_hardware_keycode: NATURAL_16)
		do
			hardware_keycode := a_hardware_keycode
			update_memory_field ("hardware_keycode")
		end

	set_group (a_group: NATURAL_8)
		do
			group := a_group
			update_memory_field ("group")
		end

	set_is_modifier (a_is_modifier: NATURAL_32)
		do
			is_modifier := a_is_modifier
			update_memory_field ("is_modifier")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			time := a_other.time
			state := a_other.state
			keyval := a_other.keyval
			length := a_other.length
			string := a_other.string
			hardware_keycode := a_other.hardware_keycode
			group := a_other.group
			is_modifier := a_other.is_modifier
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				time = a_other.time and
				state = a_other.state and
				keyval = a_other.keyval and
				length = a_other.length and
				string.is_equal (a_other.string) and
				hardware_keycode = a_other.hardware_keycode and
				group = a_other.group and
				is_modifier = a_other.is_modifier
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("keyval"),
					create {CE_STRUCTURE_FIELD}.make ("length"),
					create {CE_STRUCTURE_FIELD}.make ("string"),
					create {CE_STRUCTURE_FIELD}.make ("hardware_keycode"),
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("is_modifier")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gdk/gdk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GdkEventKey);
				} else {
					struct _GdkEventKey *p = (struct _GdkEventKey *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "is_modifier") == 0) p->is_modifier = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "is_modifier") == 0) return p->is_modifier;
					}
				}
			]"
		end

end
