class
	SD_GDKEVENTSCROLL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create window.make
			create device.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	time: NATURAL_32 assign set_time

	x: REAL_64 assign set_x

	y: REAL_64 assign set_y

	state: NATURAL_32 assign set_state

	direction: NATURAL_32 assign set_direction

	device: CE_POINTER [SD_GDKDEVICE] assign set_device

	x_root: REAL_64 assign set_x_root

	y_root: REAL_64 assign set_y_root

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_x (a_x: REAL_64)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: REAL_64)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_direction (a_direction: NATURAL_32)
		do
			direction := a_direction
			update_memory_field ("direction")
		end

	set_device (a_device: CE_POINTER [SD_GDKDEVICE])
		do
			device := a_device
			update_memory_field ("device")
		end

	set_x_root (a_x_root: REAL_64)
		do
			x_root := a_x_root
			update_memory_field ("x_root")
		end

	set_y_root (a_y_root: REAL_64)
		do
			y_root := a_y_root
			update_memory_field ("y_root")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			time := a_other.time
			x := a_other.x
			y := a_other.y
			state := a_other.state
			direction := a_other.direction
			device := a_other.device
			x_root := a_other.x_root
			y_root := a_other.y_root
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				time = a_other.time and
				x = a_other.x and
				y = a_other.y and
				state = a_other.state and
				direction = a_other.direction and
				device.is_equal (a_other.device) and
				x_root = a_other.x_root and
				y_root = a_other.y_root
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("direction"),
					create {CE_STRUCTURE_FIELD}.make ("device"),
					create {CE_STRUCTURE_FIELD}.make ("x_root"),
					create {CE_STRUCTURE_FIELD}.make ("y_root")
				>>)
			init_structure_info
		end

end
