class
	SD_GDKEVENTSELECTION

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create window.make
			create selection.make
			create target.make
			create property.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	selection: CE_POINTER [ANY] assign set_selection

	target: CE_POINTER [ANY] assign set_target

	property: CE_POINTER [ANY] assign set_property

	time: NATURAL_32 assign set_time

	requestor: NATURAL_32 assign set_requestor

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_selection (a_selection: CE_POINTER [ANY])
		do
			selection := a_selection
			update_memory_field ("selection")
		end

	set_target (a_target: CE_POINTER [ANY])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_property (a_property: CE_POINTER [ANY])
		do
			property := a_property
			update_memory_field ("property")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_requestor (a_requestor: NATURAL_32)
		do
			requestor := a_requestor
			update_memory_field ("requestor")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			selection := a_other.selection
			target := a_other.target
			property := a_other.property
			time := a_other.time
			requestor := a_other.requestor
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				selection.is_equal (a_other.selection) and
				target.is_equal (a_other.target) and
				property.is_equal (a_other.property) and
				time = a_other.time and
				requestor = a_other.requestor
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("selection"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("property"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("requestor")
				>>)
			init_structure_info
		end

end
