class
	SD_GDKGCVALUES

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create foreground.make
			create background.make
			create font.make
			create tile.make
			create stipple.make
			create clip_mask.make
		end

feature {ANY} -- fields

	foreground: SD_GDKCOLOR assign set_foreground

	background: SD_GDKCOLOR assign set_background

	font: CE_POINTER [SD_GDKFONT] assign set_font

	function: NATURAL_32 assign set_function

	fill: NATURAL_32 assign set_fill

	tile: CE_POINTER [SD_GDKDRAWABLE] assign set_tile

	stipple: CE_POINTER [SD_GDKDRAWABLE] assign set_stipple

	clip_mask: CE_POINTER [SD_GDKDRAWABLE] assign set_clip_mask

	subwindow_mode: NATURAL_32 assign set_subwindow_mode

	ts_x_origin: INTEGER_32 assign set_ts_x_origin

	ts_y_origin: INTEGER_32 assign set_ts_y_origin

	clip_x_origin: INTEGER_32 assign set_clip_x_origin

	clip_y_origin: INTEGER_32 assign set_clip_y_origin

	graphics_exposures: INTEGER_32 assign set_graphics_exposures

	line_width: INTEGER_32 assign set_line_width

	line_style: NATURAL_32 assign set_line_style

	cap_style: NATURAL_32 assign set_cap_style

	join_style: NATURAL_32 assign set_join_style

feature {ANY} -- setters

	set_foreground (a_foreground: SD_GDKCOLOR)
		do
			foreground := a_foreground
			update_memory_field ("foreground")
		end

	set_background (a_background: SD_GDKCOLOR)
		do
			background := a_background
			update_memory_field ("background")
		end

	set_font (a_font: CE_POINTER [SD_GDKFONT])
		do
			font := a_font
			update_memory_field ("font")
		end

	set_function (a_function: NATURAL_32)
		do
			function := a_function
			update_memory_field ("function")
		end

	set_fill (a_fill: NATURAL_32)
		do
			fill := a_fill
			update_memory_field ("fill")
		end

	set_tile (a_tile: CE_POINTER [SD_GDKDRAWABLE])
		do
			tile := a_tile
			update_memory_field ("tile")
		end

	set_stipple (a_stipple: CE_POINTER [SD_GDKDRAWABLE])
		do
			stipple := a_stipple
			update_memory_field ("stipple")
		end

	set_clip_mask (a_clip_mask: CE_POINTER [SD_GDKDRAWABLE])
		do
			clip_mask := a_clip_mask
			update_memory_field ("clip_mask")
		end

	set_subwindow_mode (a_subwindow_mode: NATURAL_32)
		do
			subwindow_mode := a_subwindow_mode
			update_memory_field ("subwindow_mode")
		end

	set_ts_x_origin (a_ts_x_origin: INTEGER_32)
		do
			ts_x_origin := a_ts_x_origin
			update_memory_field ("ts_x_origin")
		end

	set_ts_y_origin (a_ts_y_origin: INTEGER_32)
		do
			ts_y_origin := a_ts_y_origin
			update_memory_field ("ts_y_origin")
		end

	set_clip_x_origin (a_clip_x_origin: INTEGER_32)
		do
			clip_x_origin := a_clip_x_origin
			update_memory_field ("clip_x_origin")
		end

	set_clip_y_origin (a_clip_y_origin: INTEGER_32)
		do
			clip_y_origin := a_clip_y_origin
			update_memory_field ("clip_y_origin")
		end

	set_graphics_exposures (a_graphics_exposures: INTEGER_32)
		do
			graphics_exposures := a_graphics_exposures
			update_memory_field ("graphics_exposures")
		end

	set_line_width (a_line_width: INTEGER_32)
		do
			line_width := a_line_width
			update_memory_field ("line_width")
		end

	set_line_style (a_line_style: NATURAL_32)
		do
			line_style := a_line_style
			update_memory_field ("line_style")
		end

	set_cap_style (a_cap_style: NATURAL_32)
		do
			cap_style := a_cap_style
			update_memory_field ("cap_style")
		end

	set_join_style (a_join_style: NATURAL_32)
		do
			join_style := a_join_style
			update_memory_field ("join_style")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			foreground := a_other.foreground.twin
			background := a_other.background.twin
			font := a_other.font
			function := a_other.function
			fill := a_other.fill
			tile := a_other.tile
			stipple := a_other.stipple
			clip_mask := a_other.clip_mask
			subwindow_mode := a_other.subwindow_mode
			ts_x_origin := a_other.ts_x_origin
			ts_y_origin := a_other.ts_y_origin
			clip_x_origin := a_other.clip_x_origin
			clip_y_origin := a_other.clip_y_origin
			graphics_exposures := a_other.graphics_exposures
			line_width := a_other.line_width
			line_style := a_other.line_style
			cap_style := a_other.cap_style
			join_style := a_other.join_style
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				foreground.is_equal (a_other.foreground) and
				background.is_equal (a_other.background) and
				font.is_equal (a_other.font) and
				function = a_other.function and
				fill = a_other.fill and
				tile.is_equal (a_other.tile) and
				stipple.is_equal (a_other.stipple) and
				clip_mask.is_equal (a_other.clip_mask) and
				subwindow_mode = a_other.subwindow_mode and
				ts_x_origin = a_other.ts_x_origin and
				ts_y_origin = a_other.ts_y_origin and
				clip_x_origin = a_other.clip_x_origin and
				clip_y_origin = a_other.clip_y_origin and
				graphics_exposures = a_other.graphics_exposures and
				line_width = a_other.line_width and
				line_style = a_other.line_style and
				cap_style = a_other.cap_style and
				join_style = a_other.join_style
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("foreground"),
					create {CE_STRUCTURE_FIELD}.make ("background"),
					create {CE_STRUCTURE_FIELD}.make ("font"),
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("fill"),
					create {CE_STRUCTURE_FIELD}.make ("tile"),
					create {CE_STRUCTURE_FIELD}.make ("stipple"),
					create {CE_STRUCTURE_FIELD}.make ("clip_mask"),
					create {CE_STRUCTURE_FIELD}.make ("subwindow_mode"),
					create {CE_STRUCTURE_FIELD}.make ("ts_x_origin"),
					create {CE_STRUCTURE_FIELD}.make ("ts_y_origin"),
					create {CE_STRUCTURE_FIELD}.make ("clip_x_origin"),
					create {CE_STRUCTURE_FIELD}.make ("clip_y_origin"),
					create {CE_STRUCTURE_FIELD}.make ("graphics_exposures"),
					create {CE_STRUCTURE_FIELD}.make ("line_width"),
					create {CE_STRUCTURE_FIELD}.make ("line_style"),
					create {CE_STRUCTURE_FIELD}.make ("cap_style"),
					create {CE_STRUCTURE_FIELD}.make ("join_style")
				>>)
			init_structure_info
		end

end
