class
	SD_GDKWINDOWATTR

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create title.make
			create visual.make
			create colormap.make
			create cursor.make
			create wmclass_name.make
			create wmclass_class.make
		end

feature {ANY} -- fields

	title: CE_POINTER [INTEGER_8] assign set_title

	event_mask: INTEGER_32 assign set_event_mask

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	width: INTEGER_32 assign set_width

	height: INTEGER_32 assign set_height

	wclass: NATURAL_32 assign set_wclass

	visual: CE_POINTER [SD_GDKVISUAL] assign set_visual

	colormap: CE_POINTER [SD_GDKCOLORMAP] assign set_colormap

	window_type: NATURAL_32 assign set_window_type

	cursor: CE_POINTER [SD_GDKCURSOR] assign set_cursor

	wmclass_name: CE_POINTER [INTEGER_8] assign set_wmclass_name

	wmclass_class: CE_POINTER [INTEGER_8] assign set_wmclass_class

	override_redirect: INTEGER_32 assign set_override_redirect

	type_hint: NATURAL_32 assign set_type_hint

feature {ANY} -- setters

	set_title (a_title: CE_POINTER [INTEGER_8])
		do
			title := a_title
			update_memory_field ("title")
		end

	set_event_mask (a_event_mask: INTEGER_32)
		do
			event_mask := a_event_mask
			update_memory_field ("event_mask")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_wclass (a_wclass: NATURAL_32)
		do
			wclass := a_wclass
			update_memory_field ("wclass")
		end

	set_visual (a_visual: CE_POINTER [SD_GDKVISUAL])
		do
			visual := a_visual
			update_memory_field ("visual")
		end

	set_colormap (a_colormap: CE_POINTER [SD_GDKCOLORMAP])
		do
			colormap := a_colormap
			update_memory_field ("colormap")
		end

	set_window_type (a_window_type: NATURAL_32)
		do
			window_type := a_window_type
			update_memory_field ("window_type")
		end

	set_cursor (a_cursor: CE_POINTER [SD_GDKCURSOR])
		do
			cursor := a_cursor
			update_memory_field ("cursor")
		end

	set_wmclass_name (a_wmclass_name: CE_POINTER [INTEGER_8])
		do
			wmclass_name := a_wmclass_name
			update_memory_field ("wmclass_name")
		end

	set_wmclass_class (a_wmclass_class: CE_POINTER [INTEGER_8])
		do
			wmclass_class := a_wmclass_class
			update_memory_field ("wmclass_class")
		end

	set_override_redirect (a_override_redirect: INTEGER_32)
		do
			override_redirect := a_override_redirect
			update_memory_field ("override_redirect")
		end

	set_type_hint (a_type_hint: NATURAL_32)
		do
			type_hint := a_type_hint
			update_memory_field ("type_hint")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			title := a_other.title
			event_mask := a_other.event_mask
			x := a_other.x
			y := a_other.y
			width := a_other.width
			height := a_other.height
			wclass := a_other.wclass
			visual := a_other.visual
			colormap := a_other.colormap
			window_type := a_other.window_type
			cursor := a_other.cursor
			wmclass_name := a_other.wmclass_name
			wmclass_class := a_other.wmclass_class
			override_redirect := a_other.override_redirect
			type_hint := a_other.type_hint
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				title.is_equal (a_other.title) and
				event_mask = a_other.event_mask and
				x = a_other.x and
				y = a_other.y and
				width = a_other.width and
				height = a_other.height and
				wclass = a_other.wclass and
				visual.is_equal (a_other.visual) and
				colormap.is_equal (a_other.colormap) and
				window_type = a_other.window_type and
				cursor.is_equal (a_other.cursor) and
				wmclass_name.is_equal (a_other.wmclass_name) and
				wmclass_class.is_equal (a_other.wmclass_class) and
				override_redirect = a_other.override_redirect and
				type_hint = a_other.type_hint
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("title"),
					create {CE_STRUCTURE_FIELD}.make ("event_mask"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("wclass"),
					create {CE_STRUCTURE_FIELD}.make ("visual"),
					create {CE_STRUCTURE_FIELD}.make ("colormap"),
					create {CE_STRUCTURE_FIELD}.make ("window_type"),
					create {CE_STRUCTURE_FIELD}.make ("cursor"),
					create {CE_STRUCTURE_FIELD}.make ("wmclass_name"),
					create {CE_STRUCTURE_FIELD}.make ("wmclass_class"),
					create {CE_STRUCTURE_FIELD}.make ("override_redirect"),
					create {CE_STRUCTURE_FIELD}.make ("type_hint")
				>>)
			init_structure_info
		end

end
