class
	SD_GIOFUNCS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create io_read.make
			create io_write.make
			create io_seek.make
			create io_close.make
			create io_create_watch.make
			create io_free.make
			create io_set_flags.make
			create io_get_flags.make
		end

feature {ANY} -- fields

	io_read: CE_ROUTINE assign set_io_read

	io_write: CE_ROUTINE assign set_io_write

	io_seek: CE_ROUTINE assign set_io_seek

	io_close: CE_ROUTINE assign set_io_close

	io_create_watch: CE_ROUTINE assign set_io_create_watch

	io_free: CE_ROUTINE assign set_io_free

	io_set_flags: CE_ROUTINE assign set_io_set_flags

	io_get_flags: CE_ROUTINE assign set_io_get_flags

feature {ANY} -- setters

	set_io_read (a_io_read: CE_ROUTINE)
		do
			io_read := a_io_read
			update_memory_field ("io_read")
		end

	set_io_write (a_io_write: CE_ROUTINE)
		do
			io_write := a_io_write
			update_memory_field ("io_write")
		end

	set_io_seek (a_io_seek: CE_ROUTINE)
		do
			io_seek := a_io_seek
			update_memory_field ("io_seek")
		end

	set_io_close (a_io_close: CE_ROUTINE)
		do
			io_close := a_io_close
			update_memory_field ("io_close")
		end

	set_io_create_watch (a_io_create_watch: CE_ROUTINE)
		do
			io_create_watch := a_io_create_watch
			update_memory_field ("io_create_watch")
		end

	set_io_free (a_io_free: CE_ROUTINE)
		do
			io_free := a_io_free
			update_memory_field ("io_free")
		end

	set_io_set_flags (a_io_set_flags: CE_ROUTINE)
		do
			io_set_flags := a_io_set_flags
			update_memory_field ("io_set_flags")
		end

	set_io_get_flags (a_io_get_flags: CE_ROUTINE)
		do
			io_get_flags := a_io_get_flags
			update_memory_field ("io_get_flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			io_read := a_other.io_read
			io_write := a_other.io_write
			io_seek := a_other.io_seek
			io_close := a_other.io_close
			io_create_watch := a_other.io_create_watch
			io_free := a_other.io_free
			io_set_flags := a_other.io_set_flags
			io_get_flags := a_other.io_get_flags
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				io_read.is_equal (a_other.io_read) and
				io_write.is_equal (a_other.io_write) and
				io_seek.is_equal (a_other.io_seek) and
				io_close.is_equal (a_other.io_close) and
				io_create_watch.is_equal (a_other.io_create_watch) and
				io_free.is_equal (a_other.io_free) and
				io_set_flags.is_equal (a_other.io_set_flags) and
				io_get_flags.is_equal (a_other.io_get_flags)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("io_read"),
					create {CE_STRUCTURE_FIELD}.make ("io_write"),
					create {CE_STRUCTURE_FIELD}.make ("io_seek"),
					create {CE_STRUCTURE_FIELD}.make ("io_close"),
					create {CE_STRUCTURE_FIELD}.make ("io_create_watch"),
					create {CE_STRUCTURE_FIELD}.make ("io_free"),
					create {CE_STRUCTURE_FIELD}.make ("io_set_flags"),
					create {CE_STRUCTURE_FIELD}.make ("io_get_flags")
				>>)
			init_structure_info
		end

end
