class
	SD_GOBJECT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create g_type_instance.make
			create qdata.make
		end

feature {ANY} -- fields

	g_type_instance: SD_GTYPEINSTANCE assign set_g_type_instance

	ref_count: NATURAL_32 assign set_ref_count

	qdata: CE_POINTER [ANY] assign set_qdata

feature {ANY} -- setters

	set_g_type_instance (a_g_type_instance: SD_GTYPEINSTANCE)
		do
			g_type_instance := a_g_type_instance
			update_memory_field ("g_type_instance")
		end

	set_ref_count (a_ref_count: NATURAL_32)
		do
			ref_count := a_ref_count
			update_memory_field ("ref_count")
		end

	set_qdata (a_qdata: CE_POINTER [ANY])
		do
			qdata := a_qdata
			update_memory_field ("qdata")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			g_type_instance := a_other.g_type_instance.twin
			ref_count := a_other.ref_count
			qdata := a_other.qdata
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				g_type_instance.is_equal (a_other.g_type_instance) and
				ref_count = a_other.ref_count and
				qdata.is_equal (a_other.qdata)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("g_type_instance"),
					create {CE_STRUCTURE_FIELD}.make ("ref_count"),
					create {CE_STRUCTURE_FIELD}.make ("qdata")
				>>)
			init_structure_info
		end

end
