class
	SD_GOBJECTCLASS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create g_type_class.make
			create construct_properties.make
			create constructor.make
			create set_property.make
			create get_property.make
			create dispose2.make
			create finalize.make
			create dispatch_properties_changed.make
			create notify.make
			create constructed.make
			create pdummy.make (<<6>>)
		end

feature {ANY} -- fields

	g_type_class: SD_GTYPECLASS assign set_g_type_class

	construct_properties: CE_POINTER [SD_GSLIST] assign set_construct_properties

	constructor: CE_ROUTINE assign set_constructor

	set_property: CE_ROUTINE assign set_set_property

	get_property: CE_ROUTINE assign set_get_property

	dispose2: CE_ROUTINE assign set_dispose2

	finalize: CE_ROUTINE assign set_finalize

	dispatch_properties_changed: CE_ROUTINE assign set_dispatch_properties_changed

	notify: CE_ROUTINE assign set_notify

	constructed: CE_ROUTINE assign set_constructed

	flags: NATURAL_32 assign set_flags

	pdummy: CE_ARRAY [CE_POINTER [ANY]]

feature {ANY} -- setters

	set_g_type_class (a_g_type_class: SD_GTYPECLASS)
		do
			g_type_class := a_g_type_class
			update_memory_field ("g_type_class")
		end

	set_construct_properties (a_construct_properties: CE_POINTER [SD_GSLIST])
		do
			construct_properties := a_construct_properties
			update_memory_field ("construct_properties")
		end

	set_constructor (a_constructor: CE_ROUTINE)
		do
			constructor := a_constructor
			update_memory_field ("constructor")
		end

	set_set_property (a_set_property: CE_ROUTINE)
		do
			set_property := a_set_property
			update_memory_field ("set_property")
		end

	set_get_property (a_get_property: CE_ROUTINE)
		do
			get_property := a_get_property
			update_memory_field ("get_property")
		end

	set_dispose2 (a_dispose2: CE_ROUTINE)
		do
			dispose2 := a_dispose2
			update_memory_field ("dispose2")
		end

	set_finalize (a_finalize: CE_ROUTINE)
		do
			finalize := a_finalize
			update_memory_field ("finalize")
		end

	set_dispatch_properties_changed (a_dispatch_properties_changed: CE_ROUTINE)
		do
			dispatch_properties_changed := a_dispatch_properties_changed
			update_memory_field ("dispatch_properties_changed")
		end

	set_notify (a_notify: CE_ROUTINE)
		do
			notify := a_notify
			update_memory_field ("notify")
		end

	set_constructed (a_constructed: CE_ROUTINE)
		do
			constructed := a_constructed
			update_memory_field ("constructed")
		end

	set_flags (a_flags: NATURAL_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			g_type_class := a_other.g_type_class.twin
			construct_properties := a_other.construct_properties
			constructor := a_other.constructor
			set_property := a_other.set_property
			get_property := a_other.get_property
			dispose2 := a_other.dispose2
			finalize := a_other.finalize
			dispatch_properties_changed := a_other.dispatch_properties_changed
			notify := a_other.notify
			constructed := a_other.constructed
			flags := a_other.flags
			pdummy := a_other.pdummy.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				g_type_class.is_equal (a_other.g_type_class) and
				construct_properties.is_equal (a_other.construct_properties) and
				constructor.is_equal (a_other.constructor) and
				set_property.is_equal (a_other.set_property) and
				get_property.is_equal (a_other.get_property) and
				dispose2.is_equal (a_other.dispose2) and
				finalize.is_equal (a_other.finalize) and
				dispatch_properties_changed.is_equal (a_other.dispatch_properties_changed) and
				notify.is_equal (a_other.notify) and
				constructed.is_equal (a_other.constructed) and
				flags = a_other.flags and
				pdummy.is_equal (a_other.pdummy)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("g_type_class"),
					create {CE_STRUCTURE_FIELD}.make ("construct_properties"),
					create {CE_STRUCTURE_FIELD}.make ("constructor"),
					create {CE_STRUCTURE_FIELD}.make ("set_property"),
					create {CE_STRUCTURE_FIELD}.make ("get_property"),
					create {CE_STRUCTURE_FIELD}.make ("dispose2"),
					create {CE_STRUCTURE_FIELD}.make ("finalize"),
					create {CE_STRUCTURE_FIELD}.make ("dispatch_properties_changed"),
					create {CE_STRUCTURE_FIELD}.make ("notify"),
					create {CE_STRUCTURE_FIELD}.make ("constructed"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("pdummy", <<6>>)
				>>)
			init_structure_info
		end

end
