class
	SD_GSOURCECALLBACKFUNCS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ref.make
			create unref.make
			create get.make
		end

feature {ANY} -- fields

	ref: CE_ROUTINE assign set_ref

	unref: CE_ROUTINE assign set_unref

	get: CE_ROUTINE assign set_get

feature {ANY} -- setters

	set_ref (a_ref: CE_ROUTINE)
		do
			ref := a_ref
			update_memory_field ("ref")
		end

	set_unref (a_unref: CE_ROUTINE)
		do
			unref := a_unref
			update_memory_field ("unref")
		end

	set_get (a_get: CE_ROUTINE)
		do
			get := a_get
			update_memory_field ("get")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ref := a_other.ref
			unref := a_other.unref
			get := a_other.get
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ref.is_equal (a_other.ref) and
				unref.is_equal (a_other.unref) and
				get.is_equal (a_other.get)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ref"),
					create {CE_STRUCTURE_FIELD}.make ("unref"),
					create {CE_STRUCTURE_FIELD}.make ("get")
				>>)
			init_structure_info
		end

end
