class
	SD_GTKARG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create d.make
		end

feature {ANY} -- fields

	type: NATURAL_32 assign set_type

	name: CE_POINTER [INTEGER_8] assign set_name

	d: SD_D assign set_d

feature {ANY} -- setters

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_d (a_d: SD_D)
		do
			d := a_d
			update_memory_field ("d")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			name := a_other.name
			d := a_other.d.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				name.is_equal (a_other.name) and
				d.is_equal (a_other.d)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("d")
				>>)
			init_structure_info
		end

end
