class
	SD_GTKBOX

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	container: SD_GTKCONTAINER assign set_container

	children: CE_POINTER [SD_GLIST] assign set_children

	spacing: INTEGER_16 assign set_spacing

	homogeneous: NATURAL_32 assign set_homogeneous

feature {ANY} -- setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container := a_container
			update_memory_field ("container")
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			children := a_children
			update_memory_field ("children")
		end

	set_spacing (a_spacing: INTEGER_16)
		do
			spacing := a_spacing
			update_memory_field ("spacing")
		end

	set_homogeneous (a_homogeneous: NATURAL_32)
		do
			homogeneous := a_homogeneous
			update_memory_field ("homogeneous")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			container := a_other.container.twin
			children := a_other.children
			spacing := a_other.spacing
			homogeneous := a_other.homogeneous
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				container.is_equal (a_other.container) and
				children.is_equal (a_other.children) and
				spacing = a_other.spacing and
				homogeneous = a_other.homogeneous
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("container"),
					create {CE_STRUCTURE_FIELD}.make ("children"),
					create {CE_STRUCTURE_FIELD}.make ("spacing"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("homogeneous")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkBox);
				} else {
					struct _GtkBox *p = (struct _GtkBox *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "homogeneous") == 0) p->homogeneous = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "homogeneous") == 0) return p->homogeneous;
					}
				}
			]"
		end

end
