class
	SD_GTKBUTTON

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	bin: SD_GTKBIN assign set_bin

	event_window: CE_POINTER [SD_GDKDRAWABLE] assign set_event_window

	label_text: CE_POINTER [INTEGER_8] assign set_label_text

	activate_timeout: NATURAL_32 assign set_activate_timeout

	constructed: NATURAL_32 assign set_constructed

	in_button: NATURAL_32 assign set_in_button

	button_down: NATURAL_32 assign set_button_down

	relief: NATURAL_32 assign set_relief

	use_underline: NATURAL_32 assign set_use_underline

	use_stock: NATURAL_32 assign set_use_stock

	depressed: NATURAL_32 assign set_depressed

	depress_on_activate: NATURAL_32 assign set_depress_on_activate

	focus_on_click: NATURAL_32 assign set_focus_on_click

feature {ANY} -- setters

	set_bin (a_bin: SD_GTKBIN)
		do
			bin := a_bin
			update_memory_field ("bin")
		end

	set_event_window (a_event_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			event_window := a_event_window
			update_memory_field ("event_window")
		end

	set_label_text (a_label_text: CE_POINTER [INTEGER_8])
		do
			label_text := a_label_text
			update_memory_field ("label_text")
		end

	set_activate_timeout (a_activate_timeout: NATURAL_32)
		do
			activate_timeout := a_activate_timeout
			update_memory_field ("activate_timeout")
		end

	set_constructed (a_constructed: NATURAL_32)
		do
			constructed := a_constructed
			update_memory_field ("constructed")
		end

	set_in_button (a_in_button: NATURAL_32)
		do
			in_button := a_in_button
			update_memory_field ("in_button")
		end

	set_button_down (a_button_down: NATURAL_32)
		do
			button_down := a_button_down
			update_memory_field ("button_down")
		end

	set_relief (a_relief: NATURAL_32)
		do
			relief := a_relief
			update_memory_field ("relief")
		end

	set_use_underline (a_use_underline: NATURAL_32)
		do
			use_underline := a_use_underline
			update_memory_field ("use_underline")
		end

	set_use_stock (a_use_stock: NATURAL_32)
		do
			use_stock := a_use_stock
			update_memory_field ("use_stock")
		end

	set_depressed (a_depressed: NATURAL_32)
		do
			depressed := a_depressed
			update_memory_field ("depressed")
		end

	set_depress_on_activate (a_depress_on_activate: NATURAL_32)
		do
			depress_on_activate := a_depress_on_activate
			update_memory_field ("depress_on_activate")
		end

	set_focus_on_click (a_focus_on_click: NATURAL_32)
		do
			focus_on_click := a_focus_on_click
			update_memory_field ("focus_on_click")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bin := a_other.bin.twin
			event_window := a_other.event_window
			label_text := a_other.label_text
			activate_timeout := a_other.activate_timeout
			constructed := a_other.constructed
			in_button := a_other.in_button
			button_down := a_other.button_down
			relief := a_other.relief
			use_underline := a_other.use_underline
			use_stock := a_other.use_stock
			depressed := a_other.depressed
			depress_on_activate := a_other.depress_on_activate
			focus_on_click := a_other.focus_on_click
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bin.is_equal (a_other.bin) and
				event_window.is_equal (a_other.event_window) and
				label_text.is_equal (a_other.label_text) and
				activate_timeout = a_other.activate_timeout and
				constructed = a_other.constructed and
				in_button = a_other.in_button and
				button_down = a_other.button_down and
				relief = a_other.relief and
				use_underline = a_other.use_underline and
				use_stock = a_other.use_stock and
				depressed = a_other.depressed and
				depress_on_activate = a_other.depress_on_activate and
				focus_on_click = a_other.focus_on_click
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bin"),
					create {CE_STRUCTURE_FIELD}.make ("event_window"),
					create {CE_STRUCTURE_FIELD}.make ("label_text"),
					create {CE_STRUCTURE_FIELD}.make ("activate_timeout"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("constructed"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("in_button"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("button_down"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("relief"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("use_underline"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("use_stock"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("depressed"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("depress_on_activate"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("focus_on_click")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkButton);
				} else {
					struct _GtkButton *p = (struct _GtkButton *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "constructed") == 0) p->constructed = (unsigned int)$a_value;
						else if(strcmp(field_name, "in_button") == 0) p->in_button = (unsigned int)$a_value;
						else if(strcmp(field_name, "button_down") == 0) p->button_down = (unsigned int)$a_value;
						else if(strcmp(field_name, "relief") == 0) p->relief = (unsigned int)$a_value;
						else if(strcmp(field_name, "use_underline") == 0) p->use_underline = (unsigned int)$a_value;
						else if(strcmp(field_name, "use_stock") == 0) p->use_stock = (unsigned int)$a_value;
						else if(strcmp(field_name, "depressed") == 0) p->depressed = (unsigned int)$a_value;
						else if(strcmp(field_name, "depress_on_activate") == 0) p->depress_on_activate = (unsigned int)$a_value;
						else if(strcmp(field_name, "focus_on_click") == 0) p->focus_on_click = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "constructed") == 0) return p->constructed;
						if(strcmp(field_name, "in_button") == 0) return p->in_button;
						if(strcmp(field_name, "button_down") == 0) return p->button_down;
						if(strcmp(field_name, "relief") == 0) return p->relief;
						if(strcmp(field_name, "use_underline") == 0) return p->use_underline;
						if(strcmp(field_name, "use_stock") == 0) return p->use_stock;
						if(strcmp(field_name, "depressed") == 0) return p->depressed;
						if(strcmp(field_name, "depress_on_activate") == 0) return p->depress_on_activate;
						if(strcmp(field_name, "focus_on_click") == 0) return p->focus_on_click;
					}
				}
			]"
		end

end
