class
	SD_GTKCONTAINERCLASS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parent_class.make
			create add.make
			create remove.make
			create check_resize.make
			create forall.make
			create set_focus_child.make
			create child_type.make
			create composite_name.make
			create set_child_property.make
			create get_child_property.make
			create gtk_reserved1.make
			create gtk_reserved2.make
			create gtk_reserved3.make
			create gtk_reserved4.make
		end

feature {ANY} -- fields

	parent_class: SD_GTKWIDGETCLASS assign set_parent_class

	add: CE_ROUTINE assign set_add

	remove: CE_ROUTINE assign set_remove

	check_resize: CE_ROUTINE assign set_check_resize

	forall: CE_ROUTINE assign set_forall

	set_focus_child: CE_ROUTINE assign set_set_focus_child

	child_type: CE_ROUTINE assign set_child_type

	composite_name: CE_ROUTINE assign set_composite_name

	set_child_property: CE_ROUTINE assign set_set_child_property

	get_child_property: CE_ROUTINE assign set_get_child_property

	gtk_reserved1: CE_ROUTINE assign set_gtk_reserved1

	gtk_reserved2: CE_ROUTINE assign set_gtk_reserved2

	gtk_reserved3: CE_ROUTINE assign set_gtk_reserved3

	gtk_reserved4: CE_ROUTINE assign set_gtk_reserved4

feature {ANY} -- setters

	set_parent_class (a_parent_class: SD_GTKWIDGETCLASS)
		do
			parent_class := a_parent_class
			update_memory_field ("parent_class")
		end

	set_add (a_add: CE_ROUTINE)
		do
			add := a_add
			update_memory_field ("add")
		end

	set_remove (a_remove: CE_ROUTINE)
		do
			remove := a_remove
			update_memory_field ("remove")
		end

	set_check_resize (a_check_resize: CE_ROUTINE)
		do
			check_resize := a_check_resize
			update_memory_field ("check_resize")
		end

	set_forall (a_forall: CE_ROUTINE)
		do
			forall := a_forall
			update_memory_field ("forall")
		end

	set_set_focus_child (a_set_focus_child: CE_ROUTINE)
		do
			set_focus_child := a_set_focus_child
			update_memory_field ("set_focus_child")
		end

	set_child_type (a_child_type: CE_ROUTINE)
		do
			child_type := a_child_type
			update_memory_field ("child_type")
		end

	set_composite_name (a_composite_name: CE_ROUTINE)
		do
			composite_name := a_composite_name
			update_memory_field ("composite_name")
		end

	set_set_child_property (a_set_child_property: CE_ROUTINE)
		do
			set_child_property := a_set_child_property
			update_memory_field ("set_child_property")
		end

	set_get_child_property (a_get_child_property: CE_ROUTINE)
		do
			get_child_property := a_get_child_property
			update_memory_field ("get_child_property")
		end

	set_gtk_reserved1 (a_gtk_reserved1: CE_ROUTINE)
		do
			gtk_reserved1 := a_gtk_reserved1
			update_memory_field ("gtk_reserved1")
		end

	set_gtk_reserved2 (a_gtk_reserved2: CE_ROUTINE)
		do
			gtk_reserved2 := a_gtk_reserved2
			update_memory_field ("gtk_reserved2")
		end

	set_gtk_reserved3 (a_gtk_reserved3: CE_ROUTINE)
		do
			gtk_reserved3 := a_gtk_reserved3
			update_memory_field ("gtk_reserved3")
		end

	set_gtk_reserved4 (a_gtk_reserved4: CE_ROUTINE)
		do
			gtk_reserved4 := a_gtk_reserved4
			update_memory_field ("gtk_reserved4")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_class := a_other.parent_class.twin
			add := a_other.add
			remove := a_other.remove
			check_resize := a_other.check_resize
			forall := a_other.forall
			set_focus_child := a_other.set_focus_child
			child_type := a_other.child_type
			composite_name := a_other.composite_name
			set_child_property := a_other.set_child_property
			get_child_property := a_other.get_child_property
			gtk_reserved1 := a_other.gtk_reserved1
			gtk_reserved2 := a_other.gtk_reserved2
			gtk_reserved3 := a_other.gtk_reserved3
			gtk_reserved4 := a_other.gtk_reserved4
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_class.is_equal (a_other.parent_class) and
				add.is_equal (a_other.add) and
				remove.is_equal (a_other.remove) and
				check_resize.is_equal (a_other.check_resize) and
				forall.is_equal (a_other.forall) and
				set_focus_child.is_equal (a_other.set_focus_child) and
				child_type.is_equal (a_other.child_type) and
				composite_name.is_equal (a_other.composite_name) and
				set_child_property.is_equal (a_other.set_child_property) and
				get_child_property.is_equal (a_other.get_child_property) and
				gtk_reserved1.is_equal (a_other.gtk_reserved1) and
				gtk_reserved2.is_equal (a_other.gtk_reserved2) and
				gtk_reserved3.is_equal (a_other.gtk_reserved3) and
				gtk_reserved4.is_equal (a_other.gtk_reserved4)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_class"),
					create {CE_STRUCTURE_FIELD}.make ("add"),
					create {CE_STRUCTURE_FIELD}.make ("remove"),
					create {CE_STRUCTURE_FIELD}.make ("check_resize"),
					create {CE_STRUCTURE_FIELD}.make ("forall"),
					create {CE_STRUCTURE_FIELD}.make ("set_focus_child"),
					create {CE_STRUCTURE_FIELD}.make ("child_type"),
					create {CE_STRUCTURE_FIELD}.make ("composite_name"),
					create {CE_STRUCTURE_FIELD}.make ("set_child_property"),
					create {CE_STRUCTURE_FIELD}.make ("get_child_property"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_reserved1"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_reserved2"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_reserved3"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_reserved4")
				>>)
			init_structure_info
		end

end
