class
	SD_GTKENTRY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	widget: SD_GTKWIDGET assign set_widget

	text: CE_POINTER [INTEGER_8] assign set_text

	editable: NATURAL_32 assign set_editable

	visible: NATURAL_32 assign set_visible

	overwrite_mode: NATURAL_32 assign set_overwrite_mode

	in_drag: NATURAL_32 assign set_in_drag

	text_length: NATURAL_16 assign set_text_length

	text_max_length: NATURAL_16 assign set_text_max_length

	text_area: CE_POINTER [SD_GDKDRAWABLE] assign set_text_area

	im_context: CE_POINTER [SD_GTKIMCONTEXT] assign set_im_context

	popup_menu: CE_POINTER [SD_GTKWIDGET] assign set_popup_menu

	current_pos: INTEGER_32 assign set_current_pos

	selection_bound: INTEGER_32 assign set_selection_bound

	cached_layout: CE_POINTER [ANY] assign set_cached_layout

	cache_includes_preedit: NATURAL_32 assign set_cache_includes_preedit

	need_im_reset: NATURAL_32 assign set_need_im_reset

	has_frame: NATURAL_32 assign set_has_frame

	activates_default: NATURAL_32 assign set_activates_default

	cursor_visible: NATURAL_32 assign set_cursor_visible

	in_click: NATURAL_32 assign set_in_click

	is_cell_renderer: NATURAL_32 assign set_is_cell_renderer

	editing_canceled: NATURAL_32 assign set_editing_canceled

	mouse_cursor_obscured: NATURAL_32 assign set_mouse_cursor_obscured

	select_words: NATURAL_32 assign set_select_words

	select_lines: NATURAL_32 assign set_select_lines

	resolved_dir: NATURAL_32 assign set_resolved_dir

	truncate_multiline: NATURAL_32 assign set_truncate_multiline

	button: NATURAL_32 assign set_button

	blink_timeout: NATURAL_32 assign set_blink_timeout

	recompute_idle: NATURAL_32 assign set_recompute_idle

	scroll_offset: INTEGER_32 assign set_scroll_offset

	ascent: INTEGER_32 assign set_ascent

	descent: INTEGER_32 assign set_descent

	x_text_size: NATURAL_16 assign set_x_text_size

	x_n_bytes: NATURAL_16 assign set_x_n_bytes

	preedit_length: NATURAL_16 assign set_preedit_length

	preedit_cursor: NATURAL_16 assign set_preedit_cursor

	dnd_position: INTEGER_32 assign set_dnd_position

	drag_start_x: INTEGER_32 assign set_drag_start_x

	drag_start_y: INTEGER_32 assign set_drag_start_y

	invisible_char: NATURAL_32 assign set_invisible_char

	width_chars: INTEGER_32 assign set_width_chars

feature {ANY} -- setters

	set_widget (a_widget: SD_GTKWIDGET)
		do
			widget := a_widget
			update_memory_field ("widget")
		end

	set_text (a_text: CE_POINTER [INTEGER_8])
		do
			text := a_text
			update_memory_field ("text")
		end

	set_editable (a_editable: NATURAL_32)
		do
			editable := a_editable
			update_memory_field ("editable")
		end

	set_visible (a_visible: NATURAL_32)
		do
			visible := a_visible
			update_memory_field ("visible")
		end

	set_overwrite_mode (a_overwrite_mode: NATURAL_32)
		do
			overwrite_mode := a_overwrite_mode
			update_memory_field ("overwrite_mode")
		end

	set_in_drag (a_in_drag: NATURAL_32)
		do
			in_drag := a_in_drag
			update_memory_field ("in_drag")
		end

	set_text_length (a_text_length: NATURAL_16)
		do
			text_length := a_text_length
			update_memory_field ("text_length")
		end

	set_text_max_length (a_text_max_length: NATURAL_16)
		do
			text_max_length := a_text_max_length
			update_memory_field ("text_max_length")
		end

	set_text_area (a_text_area: CE_POINTER [SD_GDKDRAWABLE])
		do
			text_area := a_text_area
			update_memory_field ("text_area")
		end

	set_im_context (a_im_context: CE_POINTER [SD_GTKIMCONTEXT])
		do
			im_context := a_im_context
			update_memory_field ("im_context")
		end

	set_popup_menu (a_popup_menu: CE_POINTER [SD_GTKWIDGET])
		do
			popup_menu := a_popup_menu
			update_memory_field ("popup_menu")
		end

	set_current_pos (a_current_pos: INTEGER_32)
		do
			current_pos := a_current_pos
			update_memory_field ("current_pos")
		end

	set_selection_bound (a_selection_bound: INTEGER_32)
		do
			selection_bound := a_selection_bound
			update_memory_field ("selection_bound")
		end

	set_cached_layout (a_cached_layout: CE_POINTER [ANY])
		do
			cached_layout := a_cached_layout
			update_memory_field ("cached_layout")
		end

	set_cache_includes_preedit (a_cache_includes_preedit: NATURAL_32)
		do
			cache_includes_preedit := a_cache_includes_preedit
			update_memory_field ("cache_includes_preedit")
		end

	set_need_im_reset (a_need_im_reset: NATURAL_32)
		do
			need_im_reset := a_need_im_reset
			update_memory_field ("need_im_reset")
		end

	set_has_frame (a_has_frame: NATURAL_32)
		do
			has_frame := a_has_frame
			update_memory_field ("has_frame")
		end

	set_activates_default (a_activates_default: NATURAL_32)
		do
			activates_default := a_activates_default
			update_memory_field ("activates_default")
		end

	set_cursor_visible (a_cursor_visible: NATURAL_32)
		do
			cursor_visible := a_cursor_visible
			update_memory_field ("cursor_visible")
		end

	set_in_click (a_in_click: NATURAL_32)
		do
			in_click := a_in_click
			update_memory_field ("in_click")
		end

	set_is_cell_renderer (a_is_cell_renderer: NATURAL_32)
		do
			is_cell_renderer := a_is_cell_renderer
			update_memory_field ("is_cell_renderer")
		end

	set_editing_canceled (a_editing_canceled: NATURAL_32)
		do
			editing_canceled := a_editing_canceled
			update_memory_field ("editing_canceled")
		end

	set_mouse_cursor_obscured (a_mouse_cursor_obscured: NATURAL_32)
		do
			mouse_cursor_obscured := a_mouse_cursor_obscured
			update_memory_field ("mouse_cursor_obscured")
		end

	set_select_words (a_select_words: NATURAL_32)
		do
			select_words := a_select_words
			update_memory_field ("select_words")
		end

	set_select_lines (a_select_lines: NATURAL_32)
		do
			select_lines := a_select_lines
			update_memory_field ("select_lines")
		end

	set_resolved_dir (a_resolved_dir: NATURAL_32)
		do
			resolved_dir := a_resolved_dir
			update_memory_field ("resolved_dir")
		end

	set_truncate_multiline (a_truncate_multiline: NATURAL_32)
		do
			truncate_multiline := a_truncate_multiline
			update_memory_field ("truncate_multiline")
		end

	set_button (a_button: NATURAL_32)
		do
			button := a_button
			update_memory_field ("button")
		end

	set_blink_timeout (a_blink_timeout: NATURAL_32)
		do
			blink_timeout := a_blink_timeout
			update_memory_field ("blink_timeout")
		end

	set_recompute_idle (a_recompute_idle: NATURAL_32)
		do
			recompute_idle := a_recompute_idle
			update_memory_field ("recompute_idle")
		end

	set_scroll_offset (a_scroll_offset: INTEGER_32)
		do
			scroll_offset := a_scroll_offset
			update_memory_field ("scroll_offset")
		end

	set_ascent (a_ascent: INTEGER_32)
		do
			ascent := a_ascent
			update_memory_field ("ascent")
		end

	set_descent (a_descent: INTEGER_32)
		do
			descent := a_descent
			update_memory_field ("descent")
		end

	set_x_text_size (a_x_text_size: NATURAL_16)
		do
			x_text_size := a_x_text_size
			update_memory_field ("x_text_size")
		end

	set_x_n_bytes (a_x_n_bytes: NATURAL_16)
		do
			x_n_bytes := a_x_n_bytes
			update_memory_field ("x_n_bytes")
		end

	set_preedit_length (a_preedit_length: NATURAL_16)
		do
			preedit_length := a_preedit_length
			update_memory_field ("preedit_length")
		end

	set_preedit_cursor (a_preedit_cursor: NATURAL_16)
		do
			preedit_cursor := a_preedit_cursor
			update_memory_field ("preedit_cursor")
		end

	set_dnd_position (a_dnd_position: INTEGER_32)
		do
			dnd_position := a_dnd_position
			update_memory_field ("dnd_position")
		end

	set_drag_start_x (a_drag_start_x: INTEGER_32)
		do
			drag_start_x := a_drag_start_x
			update_memory_field ("drag_start_x")
		end

	set_drag_start_y (a_drag_start_y: INTEGER_32)
		do
			drag_start_y := a_drag_start_y
			update_memory_field ("drag_start_y")
		end

	set_invisible_char (a_invisible_char: NATURAL_32)
		do
			invisible_char := a_invisible_char
			update_memory_field ("invisible_char")
		end

	set_width_chars (a_width_chars: INTEGER_32)
		do
			width_chars := a_width_chars
			update_memory_field ("width_chars")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			widget := a_other.widget.twin
			text := a_other.text
			editable := a_other.editable
			visible := a_other.visible
			overwrite_mode := a_other.overwrite_mode
			in_drag := a_other.in_drag
			text_length := a_other.text_length
			text_max_length := a_other.text_max_length
			text_area := a_other.text_area
			im_context := a_other.im_context
			popup_menu := a_other.popup_menu
			current_pos := a_other.current_pos
			selection_bound := a_other.selection_bound
			cached_layout := a_other.cached_layout
			cache_includes_preedit := a_other.cache_includes_preedit
			need_im_reset := a_other.need_im_reset
			has_frame := a_other.has_frame
			activates_default := a_other.activates_default
			cursor_visible := a_other.cursor_visible
			in_click := a_other.in_click
			is_cell_renderer := a_other.is_cell_renderer
			editing_canceled := a_other.editing_canceled
			mouse_cursor_obscured := a_other.mouse_cursor_obscured
			select_words := a_other.select_words
			select_lines := a_other.select_lines
			resolved_dir := a_other.resolved_dir
			truncate_multiline := a_other.truncate_multiline
			button := a_other.button
			blink_timeout := a_other.blink_timeout
			recompute_idle := a_other.recompute_idle
			scroll_offset := a_other.scroll_offset
			ascent := a_other.ascent
			descent := a_other.descent
			x_text_size := a_other.x_text_size
			x_n_bytes := a_other.x_n_bytes
			preedit_length := a_other.preedit_length
			preedit_cursor := a_other.preedit_cursor
			dnd_position := a_other.dnd_position
			drag_start_x := a_other.drag_start_x
			drag_start_y := a_other.drag_start_y
			invisible_char := a_other.invisible_char
			width_chars := a_other.width_chars
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				widget.is_equal (a_other.widget) and
				text.is_equal (a_other.text) and
				editable = a_other.editable and
				visible = a_other.visible and
				overwrite_mode = a_other.overwrite_mode and
				in_drag = a_other.in_drag and
				text_length = a_other.text_length and
				text_max_length = a_other.text_max_length and
				text_area.is_equal (a_other.text_area) and
				im_context.is_equal (a_other.im_context) and
				popup_menu.is_equal (a_other.popup_menu) and
				current_pos = a_other.current_pos and
				selection_bound = a_other.selection_bound and
				cached_layout.is_equal (a_other.cached_layout) and
				cache_includes_preedit = a_other.cache_includes_preedit and
				need_im_reset = a_other.need_im_reset and
				has_frame = a_other.has_frame and
				activates_default = a_other.activates_default and
				cursor_visible = a_other.cursor_visible and
				in_click = a_other.in_click and
				is_cell_renderer = a_other.is_cell_renderer and
				editing_canceled = a_other.editing_canceled and
				mouse_cursor_obscured = a_other.mouse_cursor_obscured and
				select_words = a_other.select_words and
				select_lines = a_other.select_lines and
				resolved_dir = a_other.resolved_dir and
				truncate_multiline = a_other.truncate_multiline and
				button = a_other.button and
				blink_timeout = a_other.blink_timeout and
				recompute_idle = a_other.recompute_idle and
				scroll_offset = a_other.scroll_offset and
				ascent = a_other.ascent and
				descent = a_other.descent and
				x_text_size = a_other.x_text_size and
				x_n_bytes = a_other.x_n_bytes and
				preedit_length = a_other.preedit_length and
				preedit_cursor = a_other.preedit_cursor and
				dnd_position = a_other.dnd_position and
				drag_start_x = a_other.drag_start_x and
				drag_start_y = a_other.drag_start_y and
				invisible_char = a_other.invisible_char and
				width_chars = a_other.width_chars
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("widget"),
					create {CE_STRUCTURE_FIELD}.make ("text"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("editable"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("visible"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("overwrite_mode"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("in_drag"),
					create {CE_STRUCTURE_FIELD}.make ("text_length"),
					create {CE_STRUCTURE_FIELD}.make ("text_max_length"),
					create {CE_STRUCTURE_FIELD}.make ("text_area"),
					create {CE_STRUCTURE_FIELD}.make ("im_context"),
					create {CE_STRUCTURE_FIELD}.make ("popup_menu"),
					create {CE_STRUCTURE_FIELD}.make ("current_pos"),
					create {CE_STRUCTURE_FIELD}.make ("selection_bound"),
					create {CE_STRUCTURE_FIELD}.make ("cached_layout"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("cache_includes_preedit"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("need_im_reset"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_frame"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("activates_default"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("cursor_visible"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("in_click"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("is_cell_renderer"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("editing_canceled"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("mouse_cursor_obscured"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("select_words"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("select_lines"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("resolved_dir"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("truncate_multiline"),
					create {CE_STRUCTURE_FIELD}.make ("button"),
					create {CE_STRUCTURE_FIELD}.make ("blink_timeout"),
					create {CE_STRUCTURE_FIELD}.make ("recompute_idle"),
					create {CE_STRUCTURE_FIELD}.make ("scroll_offset"),
					create {CE_STRUCTURE_FIELD}.make ("ascent"),
					create {CE_STRUCTURE_FIELD}.make ("descent"),
					create {CE_STRUCTURE_FIELD}.make ("x_text_size"),
					create {CE_STRUCTURE_FIELD}.make ("x_n_bytes"),
					create {CE_STRUCTURE_FIELD}.make ("preedit_length"),
					create {CE_STRUCTURE_FIELD}.make ("preedit_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("dnd_position"),
					create {CE_STRUCTURE_FIELD}.make ("drag_start_x"),
					create {CE_STRUCTURE_FIELD}.make ("drag_start_y"),
					create {CE_STRUCTURE_FIELD}.make ("invisible_char"),
					create {CE_STRUCTURE_FIELD}.make ("width_chars")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkEntry);
					if(strcmp(field_name, "text_length") == 0) return offsetof(struct _GtkEntry, text_length);
					if(strcmp(field_name, "button") == 0) return offsetof(struct _GtkEntry, button);
				} else {
					struct _GtkEntry *p = (struct _GtkEntry *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "editable") == 0) p->editable = (unsigned int)$a_value;
						else if(strcmp(field_name, "visible") == 0) p->visible = (unsigned int)$a_value;
						else if(strcmp(field_name, "overwrite_mode") == 0) p->overwrite_mode = (unsigned int)$a_value;
						else if(strcmp(field_name, "in_drag") == 0) p->in_drag = (unsigned int)$a_value;
						else if(strcmp(field_name, "cache_includes_preedit") == 0) p->cache_includes_preedit = (unsigned int)$a_value;
						else if(strcmp(field_name, "need_im_reset") == 0) p->need_im_reset = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_frame") == 0) p->has_frame = (unsigned int)$a_value;
						else if(strcmp(field_name, "activates_default") == 0) p->activates_default = (unsigned int)$a_value;
						else if(strcmp(field_name, "cursor_visible") == 0) p->cursor_visible = (unsigned int)$a_value;
						else if(strcmp(field_name, "in_click") == 0) p->in_click = (unsigned int)$a_value;
						else if(strcmp(field_name, "is_cell_renderer") == 0) p->is_cell_renderer = (unsigned int)$a_value;
						else if(strcmp(field_name, "editing_canceled") == 0) p->editing_canceled = (unsigned int)$a_value;
						else if(strcmp(field_name, "mouse_cursor_obscured") == 0) p->mouse_cursor_obscured = (unsigned int)$a_value;
						else if(strcmp(field_name, "select_words") == 0) p->select_words = (unsigned int)$a_value;
						else if(strcmp(field_name, "select_lines") == 0) p->select_lines = (unsigned int)$a_value;
						else if(strcmp(field_name, "resolved_dir") == 0) p->resolved_dir = (unsigned int)$a_value;
						else if(strcmp(field_name, "truncate_multiline") == 0) p->truncate_multiline = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "editable") == 0) return p->editable;
						if(strcmp(field_name, "visible") == 0) return p->visible;
						if(strcmp(field_name, "overwrite_mode") == 0) return p->overwrite_mode;
						if(strcmp(field_name, "in_drag") == 0) return p->in_drag;
						if(strcmp(field_name, "cache_includes_preedit") == 0) return p->cache_includes_preedit;
						if(strcmp(field_name, "need_im_reset") == 0) return p->need_im_reset;
						if(strcmp(field_name, "has_frame") == 0) return p->has_frame;
						if(strcmp(field_name, "activates_default") == 0) return p->activates_default;
						if(strcmp(field_name, "cursor_visible") == 0) return p->cursor_visible;
						if(strcmp(field_name, "in_click") == 0) return p->in_click;
						if(strcmp(field_name, "is_cell_renderer") == 0) return p->is_cell_renderer;
						if(strcmp(field_name, "editing_canceled") == 0) return p->editing_canceled;
						if(strcmp(field_name, "mouse_cursor_obscured") == 0) return p->mouse_cursor_obscured;
						if(strcmp(field_name, "select_words") == 0) return p->select_words;
						if(strcmp(field_name, "select_lines") == 0) return p->select_lines;
						if(strcmp(field_name, "resolved_dir") == 0) return p->resolved_dir;
						if(strcmp(field_name, "truncate_multiline") == 0) return p->truncate_multiline;
					}
				}
			]"
		end

end
