class
	SD_GTKICONFACTORY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parent_instance.make
			create icons.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	icons: CE_POINTER [ANY] assign set_icons

feature {ANY} -- setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_icons (a_icons: CE_POINTER [ANY])
		do
			icons := a_icons
			update_memory_field ("icons")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			icons := a_other.icons
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				icons.is_equal (a_other.icons)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("icons")
				>>)
			init_structure_info
		end

end
