class
	SD_GTKIMAGEANIMATIONDATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create anim.make
			create iter.make
		end

feature {ANY} -- fields

	anim: CE_POINTER [ANY] assign set_anim

	iter: CE_POINTER [ANY] assign set_iter

	frame_timeout: NATURAL_32 assign set_frame_timeout

feature {ANY} -- setters

	set_anim (a_anim: CE_POINTER [ANY])
		do
			anim := a_anim
			update_memory_field ("anim")
		end

	set_iter (a_iter: CE_POINTER [ANY])
		do
			iter := a_iter
			update_memory_field ("iter")
		end

	set_frame_timeout (a_frame_timeout: NATURAL_32)
		do
			frame_timeout := a_frame_timeout
			update_memory_field ("frame_timeout")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			anim := a_other.anim
			iter := a_other.iter
			frame_timeout := a_other.frame_timeout
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				anim.is_equal (a_other.anim) and
				iter.is_equal (a_other.iter) and
				frame_timeout = a_other.frame_timeout
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("anim"),
					create {CE_STRUCTURE_FIELD}.make ("iter"),
					create {CE_STRUCTURE_FIELD}.make ("frame_timeout")
				>>)
			init_structure_info
		end

end
