class
	SD_GTKIMMULTICONTEXT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create object.make
			create slave.make
			create priv.make
			create context_id.make
		end

feature {ANY} -- fields

	object: SD_GTKIMCONTEXT assign set_object

	slave: CE_POINTER [SD_GTKIMCONTEXT] assign set_slave

	priv: CE_POINTER [ANY] assign set_priv

	context_id: CE_POINTER [INTEGER_8] assign set_context_id

feature {ANY} -- setters

	set_object (a_object: SD_GTKIMCONTEXT)
		do
			object := a_object
			update_memory_field ("object")
		end

	set_slave (a_slave: CE_POINTER [SD_GTKIMCONTEXT])
		do
			slave := a_slave
			update_memory_field ("slave")
		end

	set_priv (a_priv: CE_POINTER [ANY])
		do
			priv := a_priv
			update_memory_field ("priv")
		end

	set_context_id (a_context_id: CE_POINTER [INTEGER_8])
		do
			context_id := a_context_id
			update_memory_field ("context_id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			object := a_other.object.twin
			slave := a_other.slave
			priv := a_other.priv
			context_id := a_other.context_id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				object.is_equal (a_other.object) and
				slave.is_equal (a_other.slave) and
				priv.is_equal (a_other.priv) and
				context_id.is_equal (a_other.context_id)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("object"),
					create {CE_STRUCTURE_FIELD}.make ("slave"),
					create {CE_STRUCTURE_FIELD}.make ("priv"),
					create {CE_STRUCTURE_FIELD}.make ("context_id")
				>>)
			init_structure_info
		end

end
