class
	SD_GTKMENUSHELL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	container: SD_GTKCONTAINER assign set_container

	children: CE_POINTER [SD_GLIST] assign set_children

	active_menu_item: CE_POINTER [SD_GTKWIDGET] assign set_active_menu_item

	parent_menu_shell: CE_POINTER [SD_GTKWIDGET] assign set_parent_menu_shell

	button: NATURAL_32 assign set_button

	activate_time: NATURAL_32 assign set_activate_time

	active: NATURAL_32 assign set_active

	have_grab: NATURAL_32 assign set_have_grab

	have_xgrab: NATURAL_32 assign set_have_xgrab

	ignore_leave: NATURAL_32 assign set_ignore_leave

	menu_flag: NATURAL_32 assign set_menu_flag

	ignore_enter: NATURAL_32 assign set_ignore_enter

	keyboard_mode: NATURAL_32 assign set_keyboard_mode

feature {ANY} -- setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container := a_container
			update_memory_field ("container")
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			children := a_children
			update_memory_field ("children")
		end

	set_active_menu_item (a_active_menu_item: CE_POINTER [SD_GTKWIDGET])
		do
			active_menu_item := a_active_menu_item
			update_memory_field ("active_menu_item")
		end

	set_parent_menu_shell (a_parent_menu_shell: CE_POINTER [SD_GTKWIDGET])
		do
			parent_menu_shell := a_parent_menu_shell
			update_memory_field ("parent_menu_shell")
		end

	set_button (a_button: NATURAL_32)
		do
			button := a_button
			update_memory_field ("button")
		end

	set_activate_time (a_activate_time: NATURAL_32)
		do
			activate_time := a_activate_time
			update_memory_field ("activate_time")
		end

	set_active (a_active: NATURAL_32)
		do
			active := a_active
			update_memory_field ("active")
		end

	set_have_grab (a_have_grab: NATURAL_32)
		do
			have_grab := a_have_grab
			update_memory_field ("have_grab")
		end

	set_have_xgrab (a_have_xgrab: NATURAL_32)
		do
			have_xgrab := a_have_xgrab
			update_memory_field ("have_xgrab")
		end

	set_ignore_leave (a_ignore_leave: NATURAL_32)
		do
			ignore_leave := a_ignore_leave
			update_memory_field ("ignore_leave")
		end

	set_menu_flag (a_menu_flag: NATURAL_32)
		do
			menu_flag := a_menu_flag
			update_memory_field ("menu_flag")
		end

	set_ignore_enter (a_ignore_enter: NATURAL_32)
		do
			ignore_enter := a_ignore_enter
			update_memory_field ("ignore_enter")
		end

	set_keyboard_mode (a_keyboard_mode: NATURAL_32)
		do
			keyboard_mode := a_keyboard_mode
			update_memory_field ("keyboard_mode")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			container := a_other.container.twin
			children := a_other.children
			active_menu_item := a_other.active_menu_item
			parent_menu_shell := a_other.parent_menu_shell
			button := a_other.button
			activate_time := a_other.activate_time
			active := a_other.active
			have_grab := a_other.have_grab
			have_xgrab := a_other.have_xgrab
			ignore_leave := a_other.ignore_leave
			menu_flag := a_other.menu_flag
			ignore_enter := a_other.ignore_enter
			keyboard_mode := a_other.keyboard_mode
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				container.is_equal (a_other.container) and
				children.is_equal (a_other.children) and
				active_menu_item.is_equal (a_other.active_menu_item) and
				parent_menu_shell.is_equal (a_other.parent_menu_shell) and
				button = a_other.button and
				activate_time = a_other.activate_time and
				active = a_other.active and
				have_grab = a_other.have_grab and
				have_xgrab = a_other.have_xgrab and
				ignore_leave = a_other.ignore_leave and
				menu_flag = a_other.menu_flag and
				ignore_enter = a_other.ignore_enter and
				keyboard_mode = a_other.keyboard_mode
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("container"),
					create {CE_STRUCTURE_FIELD}.make ("children"),
					create {CE_STRUCTURE_FIELD}.make ("active_menu_item"),
					create {CE_STRUCTURE_FIELD}.make ("parent_menu_shell"),
					create {CE_STRUCTURE_FIELD}.make ("button"),
					create {CE_STRUCTURE_FIELD}.make ("activate_time"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("active"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("have_grab"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("have_xgrab"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("ignore_leave"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("menu_flag"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("ignore_enter"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("keyboard_mode")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkMenuShell);
				} else {
					struct _GtkMenuShell *p = (struct _GtkMenuShell *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "active") == 0) p->active = (unsigned int)$a_value;
						else if(strcmp(field_name, "have_grab") == 0) p->have_grab = (unsigned int)$a_value;
						else if(strcmp(field_name, "have_xgrab") == 0) p->have_xgrab = (unsigned int)$a_value;
						else if(strcmp(field_name, "ignore_leave") == 0) p->ignore_leave = (unsigned int)$a_value;
						else if(strcmp(field_name, "menu_flag") == 0) p->menu_flag = (unsigned int)$a_value;
						else if(strcmp(field_name, "ignore_enter") == 0) p->ignore_enter = (unsigned int)$a_value;
						else if(strcmp(field_name, "keyboard_mode") == 0) p->keyboard_mode = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "active") == 0) return p->active;
						if(strcmp(field_name, "have_grab") == 0) return p->have_grab;
						if(strcmp(field_name, "have_xgrab") == 0) return p->have_xgrab;
						if(strcmp(field_name, "ignore_leave") == 0) return p->ignore_leave;
						if(strcmp(field_name, "menu_flag") == 0) return p->menu_flag;
						if(strcmp(field_name, "ignore_enter") == 0) return p->ignore_enter;
						if(strcmp(field_name, "keyboard_mode") == 0) return p->keyboard_mode;
					}
				}
			]"
		end

end
