class
	SD_GTKOBJECTCLASS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create parent_class.make
			create set_arg.make
			create get_arg.make
			create destroy.make
		end

feature {ANY} -- fields

	parent_class: SD_GOBJECTCLASS assign set_parent_class

	set_arg: CE_ROUTINE assign set_set_arg

	get_arg: CE_ROUTINE assign set_get_arg

	destroy: CE_ROUTINE assign set_destroy

feature {ANY} -- setters

	set_parent_class (a_parent_class: SD_GOBJECTCLASS)
		do
			parent_class := a_parent_class
			update_memory_field ("parent_class")
		end

	set_set_arg (a_set_arg: CE_ROUTINE)
		do
			set_arg := a_set_arg
			update_memory_field ("set_arg")
		end

	set_get_arg (a_get_arg: CE_ROUTINE)
		do
			get_arg := a_get_arg
			update_memory_field ("get_arg")
		end

	set_destroy (a_destroy: CE_ROUTINE)
		do
			destroy := a_destroy
			update_memory_field ("destroy")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_class := a_other.parent_class.twin
			set_arg := a_other.set_arg
			get_arg := a_other.get_arg
			destroy := a_other.destroy
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_class.is_equal (a_other.parent_class) and
				set_arg.is_equal (a_other.set_arg) and
				get_arg.is_equal (a_other.get_arg) and
				destroy.is_equal (a_other.destroy)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_class"),
					create {CE_STRUCTURE_FIELD}.make ("set_arg"),
					create {CE_STRUCTURE_FIELD}.make ("get_arg"),
					create {CE_STRUCTURE_FIELD}.make ("destroy")
				>>)
			init_structure_info
		end

end
