class
	SD_GTKTOGGLEBUTTON

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	button: SD_GTKBUTTON assign set_button

	active: NATURAL_32 assign set_active

	draw_indicator: NATURAL_32 assign set_draw_indicator

	inconsistent: NATURAL_32 assign set_inconsistent

feature {ANY} -- setters

	set_button (a_button: SD_GTKBUTTON)
		do
			button := a_button
			update_memory_field ("button")
		end

	set_active (a_active: NATURAL_32)
		do
			active := a_active
			update_memory_field ("active")
		end

	set_draw_indicator (a_draw_indicator: NATURAL_32)
		do
			draw_indicator := a_draw_indicator
			update_memory_field ("draw_indicator")
		end

	set_inconsistent (a_inconsistent: NATURAL_32)
		do
			inconsistent := a_inconsistent
			update_memory_field ("inconsistent")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			button := a_other.button.twin
			active := a_other.active
			draw_indicator := a_other.draw_indicator
			inconsistent := a_other.inconsistent
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				button.is_equal (a_other.button) and
				active = a_other.active and
				draw_indicator = a_other.draw_indicator and
				inconsistent = a_other.inconsistent
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("button"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("active"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("draw_indicator"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("inconsistent")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkToggleButton);
				} else {
					struct _GtkToggleButton *p = (struct _GtkToggleButton *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "active") == 0) p->active = (unsigned int)$a_value;
						else if(strcmp(field_name, "draw_indicator") == 0) p->draw_indicator = (unsigned int)$a_value;
						else if(strcmp(field_name, "inconsistent") == 0) p->inconsistent = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "active") == 0) return p->active;
						if(strcmp(field_name, "draw_indicator") == 0) return p->draw_indicator;
						if(strcmp(field_name, "inconsistent") == 0) return p->inconsistent;
					}
				}
			]"
		end

end
