class
	SD_PANGOANALYSIS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create shape_engine.make
			create lang_engine.make
			create font.make
			create language.make
			create extra_attrs.make
		end

feature {ANY} -- fields

	shape_engine: CE_POINTER [ANY] assign set_shape_engine

	lang_engine: CE_POINTER [ANY] assign set_lang_engine

	font: CE_POINTER [ANY] assign set_font

	level: NATURAL_8 assign set_level

	gravity: NATURAL_8 assign set_gravity

	flags: NATURAL_8 assign set_flags

	script: NATURAL_8 assign set_script

	language: CE_POINTER [ANY] assign set_language

	extra_attrs: CE_POINTER [SD_GSLIST] assign set_extra_attrs

feature {ANY} -- setters

	set_shape_engine (a_shape_engine: CE_POINTER [ANY])
		do
			shape_engine := a_shape_engine
			update_memory_field ("shape_engine")
		end

	set_lang_engine (a_lang_engine: CE_POINTER [ANY])
		do
			lang_engine := a_lang_engine
			update_memory_field ("lang_engine")
		end

	set_font (a_font: CE_POINTER [ANY])
		do
			font := a_font
			update_memory_field ("font")
		end

	set_level (a_level: NATURAL_8)
		do
			level := a_level
			update_memory_field ("level")
		end

	set_gravity (a_gravity: NATURAL_8)
		do
			gravity := a_gravity
			update_memory_field ("gravity")
		end

	set_flags (a_flags: NATURAL_8)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_script (a_script: NATURAL_8)
		do
			script := a_script
			update_memory_field ("script")
		end

	set_language (a_language: CE_POINTER [ANY])
		do
			language := a_language
			update_memory_field ("language")
		end

	set_extra_attrs (a_extra_attrs: CE_POINTER [SD_GSLIST])
		do
			extra_attrs := a_extra_attrs
			update_memory_field ("extra_attrs")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			shape_engine := a_other.shape_engine
			lang_engine := a_other.lang_engine
			font := a_other.font
			level := a_other.level
			gravity := a_other.gravity
			flags := a_other.flags
			script := a_other.script
			language := a_other.language
			extra_attrs := a_other.extra_attrs
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				shape_engine.is_equal (a_other.shape_engine) and
				lang_engine.is_equal (a_other.lang_engine) and
				font.is_equal (a_other.font) and
				level = a_other.level and
				gravity = a_other.gravity and
				flags = a_other.flags and
				script = a_other.script and
				language.is_equal (a_other.language) and
				extra_attrs.is_equal (a_other.extra_attrs)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("shape_engine"),
					create {CE_STRUCTURE_FIELD}.make ("lang_engine"),
					create {CE_STRUCTURE_FIELD}.make ("font"),
					create {CE_STRUCTURE_FIELD}.make ("level"),
					create {CE_STRUCTURE_FIELD}.make ("gravity"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("script"),
					create {CE_STRUCTURE_FIELD}.make ("language"),
					create {CE_STRUCTURE_FIELD}.make ("extra_attrs")
				>>)
			init_structure_info
		end

end
