class
	SD_SCREENFORMAT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ext_data.make
		end

feature {ANY} -- fields

	ext_data: CE_POINTER [SD_XEXTDATA] assign set_ext_data

	depth: INTEGER_32 assign set_depth

	bits_per_pixel: INTEGER_32 assign set_bits_per_pixel

	scanline_pad: INTEGER_32 assign set_scanline_pad

feature {ANY} -- setters

	set_ext_data (a_ext_data: CE_POINTER [SD_XEXTDATA])
		do
			ext_data := a_ext_data
			update_memory_field ("ext_data")
		end

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

	set_bits_per_pixel (a_bits_per_pixel: INTEGER_32)
		do
			bits_per_pixel := a_bits_per_pixel
			update_memory_field ("bits_per_pixel")
		end

	set_scanline_pad (a_scanline_pad: INTEGER_32)
		do
			scanline_pad := a_scanline_pad
			update_memory_field ("scanline_pad")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ext_data := a_other.ext_data
			depth := a_other.depth
			bits_per_pixel := a_other.bits_per_pixel
			scanline_pad := a_other.scanline_pad
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ext_data.is_equal (a_other.ext_data) and
				depth = a_other.depth and
				bits_per_pixel = a_other.bits_per_pixel and
				scanline_pad = a_other.scanline_pad
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ext_data"),
					create {CE_STRUCTURE_FIELD}.make ("depth"),
					create {CE_STRUCTURE_FIELD}.make ("bits_per_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("scanline_pad")
				>>)
			init_structure_info
		end

end
