class
	SD_SHUTDOWN_CANCELLED

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create callback.make
			create client_data.make
		end

feature {ANY} -- fields

	callback: CE_ROUTINE assign set_callback

	client_data: CE_POINTER [ANY] assign set_client_data

feature {ANY} -- setters

	set_callback (a_callback: CE_ROUTINE)
		do
			callback := a_callback
			update_memory_field ("callback")
		end

	set_client_data (a_client_data: CE_POINTER [ANY])
		do
			client_data := a_client_data
			update_memory_field ("client_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			callback := a_other.callback
			client_data := a_other.client_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				callback.is_equal (a_other.callback) and
				client_data.is_equal (a_other.client_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("callback"),
					create {CE_STRUCTURE_FIELD}.make ("client_data")
				>>)
			init_structure_info
		end

end
