class
	SD_SOCKADDR_IN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sin_addr.make
			create sin_zero.make (<<((((create {SD_SOCKADDR}.make).structure_size.to_natural_32 - {PLATFORM}.Natural_16_bytes.to_natural_32) - {PLATFORM}.Natural_16_bytes.to_natural_32) - (create {SD_IN_ADDR}.make).structure_size.to_natural_32).to_integer_32>>)
		end

feature {ANY} -- fields

	sin_family: NATURAL_16 assign set_sin_family

	sin_port: NATURAL_16 assign set_sin_port

	sin_addr: SD_IN_ADDR assign set_sin_addr

	sin_zero: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_sin_family (a_sin_family: NATURAL_16)
		do
			sin_family := a_sin_family
			update_memory_field ("sin_family")
		end

	set_sin_port (a_sin_port: NATURAL_16)
		do
			sin_port := a_sin_port
			update_memory_field ("sin_port")
		end

	set_sin_addr (a_sin_addr: SD_IN_ADDR)
		do
			sin_addr := a_sin_addr
			update_memory_field ("sin_addr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sin_family := a_other.sin_family
			sin_port := a_other.sin_port
			sin_addr := a_other.sin_addr.twin
			sin_zero := a_other.sin_zero.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sin_family = a_other.sin_family and
				sin_port = a_other.sin_port and
				sin_addr.is_equal (a_other.sin_addr) and
				sin_zero.is_equal (a_other.sin_zero)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sin_family"),
					create {CE_STRUCTURE_FIELD}.make ("sin_port"),
					create {CE_STRUCTURE_FIELD}.make ("sin_addr"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sin_zero", <<((((create {SD_SOCKADDR}.make).structure_size.to_natural_32 - {PLATFORM}.Natural_16_bytes.to_natural_32) - {PLATFORM}.Natural_16_bytes.to_natural_32) - (create {SD_IN_ADDR}.make).structure_size.to_natural_32).to_integer_32>>)
				>>)
			init_structure_info
		end

end
