class
	SD_SYSINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create loads.make (<<3>>)
			create f.make (<<(({NATURAL_32} 20 - {NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32) - {PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32>>)
		end

feature {ANY} -- fields

	uptime: INTEGER_32 assign set_uptime

	loads: CE_ARRAY [NATURAL_32]

	totalram: NATURAL_32 assign set_totalram

	freeram: NATURAL_32 assign set_freeram

	sharedram: NATURAL_32 assign set_sharedram

	bufferram: NATURAL_32 assign set_bufferram

	totalswap: NATURAL_32 assign set_totalswap

	freeswap: NATURAL_32 assign set_freeswap

	procs: NATURAL_16 assign set_procs

	pad: NATURAL_16 assign set_pad

	totalhigh: NATURAL_32 assign set_totalhigh

	freehigh: NATURAL_32 assign set_freehigh

	mem_unit: NATURAL_32 assign set_mem_unit

	f: CE_ARRAY [INTEGER_8]

feature {ANY} -- setters

	set_uptime (a_uptime: INTEGER_32)
		do
			uptime := a_uptime
			update_memory_field ("uptime")
		end

	set_totalram (a_totalram: NATURAL_32)
		do
			totalram := a_totalram
			update_memory_field ("totalram")
		end

	set_freeram (a_freeram: NATURAL_32)
		do
			freeram := a_freeram
			update_memory_field ("freeram")
		end

	set_sharedram (a_sharedram: NATURAL_32)
		do
			sharedram := a_sharedram
			update_memory_field ("sharedram")
		end

	set_bufferram (a_bufferram: NATURAL_32)
		do
			bufferram := a_bufferram
			update_memory_field ("bufferram")
		end

	set_totalswap (a_totalswap: NATURAL_32)
		do
			totalswap := a_totalswap
			update_memory_field ("totalswap")
		end

	set_freeswap (a_freeswap: NATURAL_32)
		do
			freeswap := a_freeswap
			update_memory_field ("freeswap")
		end

	set_procs (a_procs: NATURAL_16)
		do
			procs := a_procs
			update_memory_field ("procs")
		end

	set_pad (a_pad: NATURAL_16)
		do
			pad := a_pad
			update_memory_field ("pad")
		end

	set_totalhigh (a_totalhigh: NATURAL_32)
		do
			totalhigh := a_totalhigh
			update_memory_field ("totalhigh")
		end

	set_freehigh (a_freehigh: NATURAL_32)
		do
			freehigh := a_freehigh
			update_memory_field ("freehigh")
		end

	set_mem_unit (a_mem_unit: NATURAL_32)
		do
			mem_unit := a_mem_unit
			update_memory_field ("mem_unit")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			uptime := a_other.uptime
			loads := a_other.loads.twin
			totalram := a_other.totalram
			freeram := a_other.freeram
			sharedram := a_other.sharedram
			bufferram := a_other.bufferram
			totalswap := a_other.totalswap
			freeswap := a_other.freeswap
			procs := a_other.procs
			pad := a_other.pad
			totalhigh := a_other.totalhigh
			freehigh := a_other.freehigh
			mem_unit := a_other.mem_unit
			f := a_other.f.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				uptime = a_other.uptime and
				loads.is_equal (a_other.loads) and
				totalram = a_other.totalram and
				freeram = a_other.freeram and
				sharedram = a_other.sharedram and
				bufferram = a_other.bufferram and
				totalswap = a_other.totalswap and
				freeswap = a_other.freeswap and
				procs = a_other.procs and
				pad = a_other.pad and
				totalhigh = a_other.totalhigh and
				freehigh = a_other.freehigh and
				mem_unit = a_other.mem_unit and
				f.is_equal (a_other.f)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("uptime"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("loads", <<3>>),
					create {CE_STRUCTURE_FIELD}.make ("totalram"),
					create {CE_STRUCTURE_FIELD}.make ("freeram"),
					create {CE_STRUCTURE_FIELD}.make ("sharedram"),
					create {CE_STRUCTURE_FIELD}.make ("bufferram"),
					create {CE_STRUCTURE_FIELD}.make ("totalswap"),
					create {CE_STRUCTURE_FIELD}.make ("freeswap"),
					create {CE_STRUCTURE_FIELD}.make ("procs"),
					create {CE_STRUCTURE_FIELD}.make ("pad"),
					create {CE_STRUCTURE_FIELD}.make ("totalhigh"),
					create {CE_STRUCTURE_FIELD}.make ("freehigh"),
					create {CE_STRUCTURE_FIELD}.make ("mem_unit"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("f", <<(({NATURAL_32} 20 - {NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32) - {PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32>>)
				>>)
			init_structure_info
		end

end
