class
	SD_TIMER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create si_sigval.make
		end

feature {ANY} -- fields

	si_tid: INTEGER_32 assign set_si_tid

	si_overrun: INTEGER_32 assign set_si_overrun

	si_sigval: SD_SIGVAL assign set_si_sigval

feature {ANY} -- setters

	set_si_tid (a_si_tid: INTEGER_32)
		do
			si_tid := a_si_tid
			update_memory_field ("si_tid")
		end

	set_si_overrun (a_si_overrun: INTEGER_32)
		do
			si_overrun := a_si_overrun
			update_memory_field ("si_overrun")
		end

	set_si_sigval (a_si_sigval: SD_SIGVAL)
		do
			si_sigval := a_si_sigval
			update_memory_field ("si_sigval")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			si_tid := a_other.si_tid
			si_overrun := a_other.si_overrun
			si_sigval := a_other.si_sigval.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				si_tid = a_other.si_tid and
				si_overrun = a_other.si_overrun and
				si_sigval.is_equal (a_other.si_sigval)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("si_tid"),
					create {CE_STRUCTURE_FIELD}.make ("si_overrun"),
					create {CE_STRUCTURE_FIELD}.make ("si_sigval")
				>>)
			init_structure_info
		end

end
