class
	SD_XCLIENTMESSAGEEVENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create display.make
			create data.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	serial: NATURAL_32 assign set_serial

	send_event: INTEGER_32 assign set_send_event

	display: CE_POINTER [ANY] assign set_display

	window: NATURAL_32 assign set_window

	message_type: NATURAL_32 assign set_message_type

	format: INTEGER_32 assign set_format

	data: SD_DATA2 assign set_data

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_serial (a_serial: NATURAL_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			display := a_display
			update_memory_field ("display")
		end

	set_window (a_window: NATURAL_32)
		do
			window := a_window
			update_memory_field ("window")
		end

	set_message_type (a_message_type: NATURAL_32)
		do
			message_type := a_message_type
			update_memory_field ("message_type")
		end

	set_format (a_format: INTEGER_32)
		do
			format := a_format
			update_memory_field ("format")
		end

	set_data (a_data: SD_DATA2)
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			serial := a_other.serial
			send_event := a_other.send_event
			display := a_other.display
			window := a_other.window
			message_type := a_other.message_type
			format := a_other.format
			data := a_other.data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				serial = a_other.serial and
				send_event = a_other.send_event and
				display.is_equal (a_other.display) and
				window = a_other.window and
				message_type = a_other.message_type and
				format = a_other.format and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("display"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("message_type"),
					create {CE_STRUCTURE_FIELD}.make ("format"),
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
