class
	SD_XUNMAPEVENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create display.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	serial: NATURAL_32 assign set_serial

	send_event: INTEGER_32 assign set_send_event

	display: CE_POINTER [ANY] assign set_display

	event: NATURAL_32 assign set_event

	window: NATURAL_32 assign set_window

	from_configure: INTEGER_32 assign set_from_configure

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_serial (a_serial: NATURAL_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			display := a_display
			update_memory_field ("display")
		end

	set_event (a_event: NATURAL_32)
		do
			event := a_event
			update_memory_field ("event")
		end

	set_window (a_window: NATURAL_32)
		do
			window := a_window
			update_memory_field ("window")
		end

	set_from_configure (a_from_configure: INTEGER_32)
		do
			from_configure := a_from_configure
			update_memory_field ("from_configure")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			serial := a_other.serial
			send_event := a_other.send_event
			display := a_other.display
			event := a_other.event
			window := a_other.window
			from_configure := a_other.from_configure
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				serial = a_other.serial and
				send_event = a_other.send_event and
				display.is_equal (a_other.display) and
				event = a_other.event and
				window = a_other.window and
				from_configure = a_other.from_configure
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("display"),
					create {CE_STRUCTURE_FIELD}.make ("event"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("from_configure")
				>>)
			init_structure_info
		end

end
