deferred class
	CE_CLASS

inherit
	DISPOSABLE

feature {CE_CLASS, CE_POINTER, CE_VA_LIST}

	make
		do
		end

	make_memory
		local
			l_internal: INTERNAL
			l_fields: like structure_info.fields.area
			l_i: INTEGER_32
			l_field: CE_STRUCTURE_FIELD
			l_old_state: BOOLEAN
			l_tmp_array: CE_ARRAY [ANY]
			l_tmp_class: CE_CLASS
			l_tmp_pointer: CE_POINTER [ANY]
		do
			internal_c_pointer := default_pointer.memory_calloc (1, structure_size)
			is_allocated_memory := True
			from
				create l_internal
				l_fields := structure_info.fields.area
				l_i := l_fields.count - 1
			until
				l_i < 0
			loop
				l_field := l_fields[l_i]
				inspect l_field.ce_type
				when {CE_UTILITIES}.Ce_type_array then
					l_old_state := {ISE_RUNTIME}.check_assert (False)
					l_tmp_array ?= l_internal.new_instance_of (l_field.eif_type)
					l_tmp_array.make_shared (internal_c_pointer + l_field.c_offset, l_field.dimensions)
					l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
					l_internal.set_reference_field (l_field.internal_index, Current, l_tmp_array)
				when {CE_UTILITIES}.Ce_type_class then
					l_old_state := {ISE_RUNTIME}.check_assert (False)
					l_tmp_class ?= l_internal.new_instance_of (l_field.eif_type)
					l_tmp_class.make_shared (internal_c_pointer + l_field.c_offset)
					l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
					l_internal.set_reference_field (l_field.internal_index, Current, l_tmp_class)
				when {CE_UTILITIES}.Ce_type_pointer then
					l_tmp_pointer ?= l_internal.new_instance_of (l_field.eif_type)
					l_internal.set_reference_field (l_field.internal_index, Current, l_tmp_pointer)
				else
					-- nothing to do
				end
				l_i := l_i - 1
			end
		end

	make_shared (a_c_pointer: POINTER)
		local
			l_internal: INTERNAL
			l_fields: like structure_info.fields.area
			l_i: INTEGER_32
			l_field: CE_STRUCTURE_FIELD
			l_old_state: BOOLEAN
			l_tmp_array: CE_ARRAY [ANY]
			l_tmp_class: CE_CLASS
		do
			internal_c_pointer := a_c_pointer
			from
				create l_internal
				l_fields := structure_info.fields.area
				l_i := l_fields.count - 1
			until
				l_i < 0
			loop
				l_field := l_fields[l_i]
				inspect l_field.ce_type
				when {CE_UTILITIES}.Ce_type_array then
					l_old_state := {ISE_RUNTIME}.check_assert (False)
					l_tmp_array ?= l_internal.new_instance_of (l_field.eif_type)
					l_tmp_array.make_shared (a_c_pointer + l_field.c_offset, l_field.dimensions)
					l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
					l_internal.set_reference_field (l_field.internal_index, Current, l_tmp_array)
				when {CE_UTILITIES}.Ce_type_class then
					l_old_state := {ISE_RUNTIME}.check_assert (False)
					l_tmp_class ?= l_internal.new_instance_of (l_field.eif_type)
					l_tmp_class.make_shared (a_c_pointer + l_field.c_offset)
					l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
					l_internal.set_reference_field (l_field.internal_index, Current, l_tmp_class)
				else
					update_class (l_field)
				end
				l_i := l_i - 1
			end
		end

feature {CE_CLASS} -- data

	internal_c_pointer: POINTER

	is_allocated_memory: BOOLEAN

	dispose
		do
			if is_allocated_memory then
				internal_c_pointer.memory_free
			end
		end

feature {ANY}

	create_memory_copy
		local
			l_internal: INTERNAL
			l_fields: like structure_info.fields.area
			l_i: INTEGER_32
			l_field: CE_STRUCTURE_FIELD
			l_old_state: BOOLEAN
			l_tmp_array: CE_ARRAY [ANY]
		do
			if internal_c_pointer = default_pointer then
				internal_c_pointer := default_pointer.memory_calloc (1, structure_size)
				is_allocated_memory := True

				from
					create l_internal
					l_fields := structure_info.fields.area
					l_i := l_fields.count - 1
				until
					l_i < 0
				loop
					l_field := l_fields[l_i]
					inspect l_field.ce_type
					when {CE_UTILITIES}.Ce_type_array then
						l_tmp_array ?= l_internal.field (l_field.internal_index, Current)
						(internal_c_pointer + l_field.c_offset).memory_copy (l_tmp_array.c_pointer, l_tmp_array.total_count * l_tmp_array.element_size)

						l_old_state := {ISE_RUNTIME}.check_assert (False)
						l_tmp_array ?= l_internal.new_instance_of (l_field.eif_type)
						l_tmp_array.make_shared (internal_c_pointer + l_field.c_offset, l_field.dimensions)
						l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
						l_internal.set_reference_field (l_field.internal_index, Current, l_tmp_array)
					else
						update_memory (l_field)
					end
					l_i := l_i - 1
				end
			end
		end

feature {ANY}

	c_pointer: POINTER
		do
			create_memory_copy
			Result := internal_c_pointer
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		require
			a_field_name /= Void
		do
			Result := structure_info.field_table[a_field_name].c_offset
		end

	structure_size: INTEGER_32
		do
			Result := structure_info.size
		end

	update_memory_field (a_name: STRING_8)
		require
			a_name /= Void
		do
			if internal_c_pointer /= default_pointer then
				update_memory (structure_info.field_table[a_name])
				if structure_info.field_table[a_name].is_bitfield then
					update_class_field (a_name)
				end
			end
		end

	update_memory_fields
		local
			l_fields: like structure_info.fields.area
			l_i: INTEGER_32
		do
			from
				l_fields := structure_info.fields.area
				l_i := l_fields.count - 1
			until
				l_i < 0
			loop
				update_memory (l_fields[l_i])
				l_i := l_i - 1
			end
		end

	update_class_field (a_name: STRING_8)
		require
			a_name /= Void
		do
			update_class (structure_info.field_table[a_name])
		end

	update_class_fields
		local
			l_fields: like structure_info.fields.area
			l_i: INTEGER_32
		do
			from
				l_fields := structure_info.fields.area
				l_i := l_fields.count - 1
			until
				l_i < 0
			loop
				update_class (l_fields[l_i])
				l_i := l_i - 1
			end
		end

feature {CE_CLASS, CE_STRUCTURE, CE_UTILITIES}

	structure_info: CE_STRUCTURE
		deferred
		end

feature {NONE}

	init_structure_info
		local
			l_internal: INTERNAL
			l_type_id, l_i, l_count: INTEGER_32
			l_internal_info: HASH_TABLE [TUPLE [type: TYPE [ANY]; internal_index: INTEGER_32], STRING] -- field name is lower case
			l_type: TYPE [ANY]
			l_size, l_c_offset, l_alignment: INTEGER_32
			l_old_state: BOOLEAN
			l_tmp_array: CE_ARRAY [ANY]
		do
			create l_internal

			-- get the INTERNAL info
			from
				l_type_id := l_internal.dynamic_type (Current)
				l_i := 1
				l_count := l_internal.field_count_of_type (l_type_id)
				create l_internal_info.make (l_count)
			until
				l_i > l_count
			loop
				l_internal_info[l_internal.field_name_of_type (l_i, l_type_id)] := [l_internal.type_of_type (l_internal.field_static_type_of_type (l_i, l_type_id)), l_i]
				l_i := l_i + 1
			end

			-- fill in data
			across structure_info.fields as c loop
				l_type := l_internal_info[c.item.name.as_lower].type
				c.item.ce_type := (create {CE_UTILITIES}).ce_type (l_type)
				c.item.eif_type := l_type.type_id
				c.item.internal_index := l_internal_info[c.item.name.as_lower].internal_index

				inspect c.item.ce_type
				when {CE_UTILITIES}.Ce_type_boolean    then l_size := {PLATFORM}.Boolean_bytes
				when {CE_UTILITIES}.Ce_type_integer_8  then l_size := {PLATFORM}.Integer_8_bytes
				when {CE_UTILITIES}.Ce_type_integer_16 then l_size := {PLATFORM}.Integer_16_bytes
				when {CE_UTILITIES}.Ce_type_integer_32 then l_size := {PLATFORM}.Integer_32_bytes
				when {CE_UTILITIES}.Ce_type_integer_64 then l_size := {PLATFORM}.Integer_64_bytes
				when {CE_UTILITIES}.Ce_type_natural_8  then l_size := {PLATFORM}.Natural_8_bytes
				when {CE_UTILITIES}.Ce_type_natural_16 then l_size := {PLATFORM}.Natural_16_bytes
				when {CE_UTILITIES}.Ce_type_natural_32 then l_size := {PLATFORM}.Natural_32_bytes
				when {CE_UTILITIES}.Ce_type_natural_64 then l_size := {PLATFORM}.Natural_64_bytes
				when {CE_UTILITIES}.Ce_type_real_32    then l_size := {PLATFORM}.Real_32_bytes
				when {CE_UTILITIES}.Ce_type_real_64    then l_size := {PLATFORM}.Real_64_bytes
				when {CE_UTILITIES}.Ce_type_real_96    then l_size := {CE_UTILITIES}.Real_96_bytes
				when {CE_UTILITIES}.Ce_type_va_list    then l_size := {PLATFORM}.Pointer_bytes
				when {CE_UTILITIES}.Ce_type_pointer    then l_size := {PLATFORM}.Pointer_bytes
				when {CE_UTILITIES}.Ce_type_array then
					l_old_state := {ISE_RUNTIME}.check_assert (False)
					l_tmp_array ?= l_internal.new_instance_of (c.item.eif_type)
					l_tmp_array.set_element_info

					l_size := l_tmp_array.element_size
					across c.item.dimensions as c2 loop l_size := l_size * c2.item end

					l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
				when {CE_UTILITIES}.Ce_type_class then
					l_old_state := {ISE_RUNTIME}.check_assert (False)
					l_size :=  ({CE_CLASS} #? l_internal.new_instance_of (c.item.eif_type)).structure_size
					l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
				end

				if c.item.is_bitfield then
					if structure_info.is_union then
						structure_info.size := structure_info.size.max (l_size)
					elseif c.target_index = structure_info.fields.count then
						l_c_offset := bitfield_helper (1, default_pointer, default_pointer, 0).to_integer_32
					elseif
						attached structure_info.fields[c.target_index + 1] as next_field and then
						not next_field.is_bitfield and then
						attached (create {C_STRING}.make (next_field.name)) as c_name -- "local" variable
					then
						l_c_offset := bitfield_helper (1, c_name.item, default_pointer, 0).to_integer_32
					end
				elseif structure_info.is_struct then
					if c.item.alignment /= 0 then
						l_alignment := c.item.alignment
					else
						l_alignment := (create {CE_UTILITIES}).ce_alignof (l_type).to_integer_32
					end
					l_c_offset := (l_c_offset / l_alignment).ceiling * l_alignment
					c.item.c_offset := l_c_offset
					l_c_offset := l_c_offset + l_size
				else -- is_union
					structure_info.size := structure_info.size.max (l_size)
				end
			end
			if structure_info.is_struct then
				l_alignment := max_alignment (structure_info)
				structure_info.size := (l_c_offset / l_alignment).ceiling * l_alignment
			else
				-- unions handled above
			end
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
			-- a_operation:
			--    1: get non-bitfield offset
			--    2: set bitfield
			--    3: get bitfield
		require
			a_operation = 1 or a_operation = 2 or a_operation = 3
			a_operation = 1 implies
				(
					a_field_name = default_pointer or else
					(attached structure_info.field_table[create {STRING_8}.make_from_c (a_field_name)] as field and then not field.is_bitfield)
				) and
				a_struct_pointer = default_pointer and
				a_value = 0
			a_operation = 2 implies
				(attached structure_info.field_table[create {STRING_8}.make_from_c (a_field_name)] as field and then field.is_bitfield) and
				a_struct_pointer /= default_pointer
			a_operation = 3 implies
				(attached structure_info.field_table[create {STRING_8}.make_from_c (a_field_name)] as field and then field.is_bitfield) and
				a_struct_pointer /= default_pointer and
				a_value = 0
		do
		end

	max_alignment (a_structure_info: CE_STRUCTURE): INTEGER_32
		require
			a_structure_info /= Void
		local
			l_internal: INTERNAL
			l_tmp_class: CE_CLASS
			l_alignment: INTEGER_32
		do
			create l_internal
			across a_structure_info.fields as c loop
				if c.item.eif_type = {CE_UTILITIES}.Ce_type_class then
					l_tmp_class ?= l_internal.new_instance_of (c.item.ce_type)
					Result := Result.max (max_alignment (l_tmp_class.structure_info))
				else
					if c.item.alignment /= 0 then
						l_alignment := c.item.alignment
					else
						l_alignment := (create {CE_UTILITIES}).ce_alignof (l_internal.type_of_type (c.item.eif_type)).to_integer_32
					end
					Result := Result.max (l_alignment)
				end
			end
		ensure
			Result = 0 or Result = 1 or Result = 2 or Result = 4
		end

feature {NONE} -- data synchronization

	update_memory (a_field: CE_STRUCTURE_FIELD)
		local
			l_internal: INTERNAL
			l_c_name: C_STRING
			l_tmp_pointer: CE_POINTER [ANY]
			l_old_state: BOOLEAN
			l_tmp_class: CE_CLASS
			l_tmp_va_list: CE_VA_LIST

			l_boolean: BOOLEAN
			l_integer_8: INTEGER_8
			l_integer_16: INTEGER_16
			l_integer_32: INTEGER_32
			l_integer_64: INTEGER_64
			l_natural_8: NATURAL_8
			l_natural_16: NATURAL_16
			l_natural_32: NATURAL_32
			l_natural_64: NATURAL_64
			l_real_32: REAL_32
			l_real_64: REAL_64
			l_pointer: POINTER
		do
			create l_internal
			if a_field.is_bitfield then
				create l_c_name.make (a_field.name)
				inspect a_field.ce_type
				when {CE_UTILITIES}.Ce_type_boolean    then bitfield_helper (2, l_c_name.item, internal_c_pointer, l_internal.boolean_field    (a_field.internal_index, Current).to_integer.to_natural_64).do_nothing
				when {CE_UTILITIES}.Ce_type_integer_8  then bitfield_helper (2, l_c_name.item, internal_c_pointer, l_internal.integer_8_field  (a_field.internal_index, Current).to_natural_64).do_nothing
				when {CE_UTILITIES}.Ce_type_integer_16 then bitfield_helper (2, l_c_name.item, internal_c_pointer, l_internal.integer_16_field (a_field.internal_index, Current).to_natural_64).do_nothing
				when {CE_UTILITIES}.Ce_type_integer_32 then bitfield_helper (2, l_c_name.item, internal_c_pointer, l_internal.integer_32_field (a_field.internal_index, Current).to_natural_64).do_nothing
				when {CE_UTILITIES}.Ce_type_integer_64 then bitfield_helper (2, l_c_name.item, internal_c_pointer, l_internal.integer_64_field (a_field.internal_index, Current).to_natural_64).do_nothing
				when {CE_UTILITIES}.Ce_type_natural_8  then bitfield_helper (2, l_c_name.item, internal_c_pointer, l_internal.natural_8_field  (a_field.internal_index, Current)).do_nothing
				when {CE_UTILITIES}.Ce_type_natural_16 then bitfield_helper (2, l_c_name.item, internal_c_pointer, l_internal.natural_16_field (a_field.internal_index, Current)).do_nothing
				when {CE_UTILITIES}.Ce_type_natural_32 then bitfield_helper (2, l_c_name.item, internal_c_pointer, l_internal.natural_32_field (a_field.internal_index, Current)).do_nothing
				when {CE_UTILITIES}.Ce_type_natural_64 then bitfield_helper (2, l_c_name.item, internal_c_pointer, l_internal.natural_64_field (a_field.internal_index, Current)).do_nothing
				end
			else
				inspect a_field.ce_type
				when {CE_UTILITIES}.Ce_type_boolean then
					l_boolean := l_internal.boolean_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_boolean, {PLATFORM}.Boolean_bytes)
				when {CE_UTILITIES}.Ce_type_integer_8 then
					l_integer_8 := l_internal.integer_8_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_integer_8, {PLATFORM}.Integer_8_bytes)
				when {CE_UTILITIES}.Ce_type_integer_16 then
					l_integer_16 := l_internal.integer_16_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_integer_16, {PLATFORM}.Integer_16_bytes)
				when {CE_UTILITIES}.Ce_type_integer_32 then
					l_integer_32 := l_internal.integer_32_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_integer_32, {PLATFORM}.Integer_32_bytes)
				when {CE_UTILITIES}.Ce_type_integer_64 then
					l_integer_64 := l_internal.integer_64_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_integer_64, {PLATFORM}.Integer_64_bytes)
				when {CE_UTILITIES}.Ce_type_natural_8 then
					l_natural_8 := l_internal.natural_8_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_natural_8, {PLATFORM}.Natural_8_bytes)
				when {CE_UTILITIES}.Ce_type_natural_16 then
					l_natural_16 := l_internal.natural_16_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_natural_16, {PLATFORM}.Natural_16_bytes)
				when {CE_UTILITIES}.Ce_type_natural_32 then
					l_natural_32 := l_internal.natural_32_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_natural_32, {PLATFORM}.Natural_32_bytes)
				when {CE_UTILITIES}.Ce_type_natural_64 then
					l_natural_64 := l_internal.natural_64_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_natural_64, {PLATFORM}.Natural_64_bytes)
				when {CE_UTILITIES}.Ce_type_real_32 then
					l_real_32 := l_internal.real_32_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_real_32, {PLATFORM}.Real_32_bytes)
				when {CE_UTILITIES}.Ce_type_real_64 then
					l_real_64 := l_internal.real_64_field (a_field.internal_index, Current)
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_real_64, {PLATFORM}.Real_64_bytes)
				when {CE_UTILITIES}.Ce_type_real_96 then
					if attached {REAL_96} l_internal.field (a_field.internal_index, Current) as r96 then
						(internal_c_pointer + a_field.c_offset).memory_copy (r96.c_pointer, {CE_UTILITIES}.Real_96_bytes)
					else
						(create {EXCEPTIONS}).raise (l_internal.field (a_field.internal_index, Current).generator)
					end
				when {CE_UTILITIES}.Ce_type_pointer then
					l_tmp_pointer ?= l_internal.field (a_field.internal_index, Current)
					l_pointer := l_tmp_pointer.c_pointer;
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_pointer, {PLATFORM}.Pointer_bytes)
				when {CE_UTILITIES}.Ce_type_array then
					-- nothing to do, uses the struct memory
				when {CE_UTILITIES}.Ce_type_class then
					l_tmp_class ?= l_internal.field (a_field.internal_index, Current)
					if l_tmp_class.c_pointer /= internal_c_pointer + a_field.c_offset then
						(internal_c_pointer + a_field.c_offset).memory_copy (l_tmp_class.c_pointer, l_tmp_class.structure_size)

						l_old_state := {ISE_RUNTIME}.check_assert (False)
						l_tmp_class ?= l_internal.new_instance_of (a_field.eif_type)
						l_tmp_class.make_shared (internal_c_pointer + a_field.c_offset)
						l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)

						l_internal.set_reference_field (a_field.internal_index, Current, l_tmp_class)
					end
				when {CE_UTILITIES}.Ce_type_va_list then
					l_tmp_va_list ?= l_internal.field (a_field.internal_index, Current)
					l_pointer := l_tmp_va_list.c_pointer;
					(internal_c_pointer + a_field.c_offset).memory_copy ($l_pointer, {PLATFORM}.Pointer_bytes)
				end
			end
		end

	update_class (a_field: CE_STRUCTURE_FIELD)
		local
			l_internal: INTERNAL
			l_c_name: C_STRING
			l_tmp_pointer: CE_POINTER [ANY]
			l_tmp_class: CE_CLASS

			l_boolean: BOOLEAN
			l_integer_8: INTEGER_8
			l_integer_16: INTEGER_16
			l_integer_32: INTEGER_32
			l_integer_64: INTEGER_64
			l_natural_8: NATURAL_8
			l_natural_16: NATURAL_16
			l_natural_32: NATURAL_32
			l_natural_64: NATURAL_64
			l_real_32: REAL_32
			l_real_64: REAL_64
			l_pointer: POINTER
		do
			create l_internal
			if a_field.is_bitfield then
				create l_c_name.make (a_field.name)
				inspect a_field.ce_type
				when {CE_UTILITIES}.Ce_type_boolean    then l_internal.set_boolean_field    (a_field.internal_index, Current, bitfield_helper (3, l_c_name.item, internal_c_pointer, 0).to_boolean)
				when {CE_UTILITIES}.Ce_type_integer_8  then l_internal.set_integer_8_field  (a_field.internal_index, Current, bitfield_helper (3, l_c_name.item, internal_c_pointer, 0).to_integer_8)
				when {CE_UTILITIES}.Ce_type_integer_16 then l_internal.set_integer_16_field (a_field.internal_index, Current, bitfield_helper (3, l_c_name.item, internal_c_pointer, 0).to_integer_16)
				when {CE_UTILITIES}.Ce_type_integer_32 then l_internal.set_integer_32_field (a_field.internal_index, Current, bitfield_helper (3, l_c_name.item, internal_c_pointer, 0).to_integer_32)
				when {CE_UTILITIES}.Ce_type_integer_64 then l_internal.set_integer_64_field (a_field.internal_index, Current, bitfield_helper (3, l_c_name.item, internal_c_pointer, 0).to_integer_64)
				when {CE_UTILITIES}.Ce_type_natural_8  then l_internal.set_natural_8_field  (a_field.internal_index, Current, bitfield_helper (3, l_c_name.item, internal_c_pointer, 0).to_natural_8)
				when {CE_UTILITIES}.Ce_type_natural_16 then l_internal.set_natural_16_field (a_field.internal_index, Current, bitfield_helper (3, l_c_name.item, internal_c_pointer, 0).to_natural_16)
				when {CE_UTILITIES}.Ce_type_natural_32 then l_internal.set_natural_32_field (a_field.internal_index, Current, bitfield_helper (3, l_c_name.item, internal_c_pointer, 0).to_natural_32)
				when {CE_UTILITIES}.Ce_type_natural_64 then l_internal.set_natural_64_field (a_field.internal_index, Current, bitfield_helper (3, l_c_name.item, internal_c_pointer, 0).to_natural_64)
				end
			else
				inspect a_field.ce_type
				when {CE_UTILITIES}.Ce_type_boolean then
					($l_boolean).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Boolean_bytes)
					l_internal.set_boolean_field (a_field.internal_index, Current, l_boolean)
				when {CE_UTILITIES}.Ce_type_integer_8 then
					($l_integer_8).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Integer_8_bytes)
					l_internal.set_integer_8_field  (a_field.internal_index, Current, l_integer_8)
				when {CE_UTILITIES}.Ce_type_integer_16 then
					($l_integer_16).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Integer_16_bytes)
					l_internal.set_integer_16_field (a_field.internal_index, Current, l_integer_16)
				when {CE_UTILITIES}.Ce_type_integer_32 then
					($l_integer_32).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Integer_32_bytes)
					l_internal.set_integer_32_field (a_field.internal_index, Current, l_integer_32)
				when {CE_UTILITIES}.Ce_type_integer_64 then
					($l_integer_64).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Integer_64_bytes)
					l_internal.set_integer_64_field (a_field.internal_index, Current, l_integer_64)
				when {CE_UTILITIES}.Ce_type_natural_8 then
					($l_natural_8).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Natural_8_bytes)
					l_internal.set_natural_8_field (a_field.internal_index, Current, l_natural_8)
				when {CE_UTILITIES}.Ce_type_natural_16 then
					($l_natural_16).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Natural_16_bytes)
					l_internal.set_natural_16_field (a_field.internal_index, Current, l_natural_16)
				when {CE_UTILITIES}.Ce_type_natural_32 then
					($l_natural_32).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Natural_32_bytes)
					l_internal.set_natural_32_field (a_field.internal_index, Current, l_natural_32)
				when {CE_UTILITIES}.Ce_type_natural_64 then
					($l_natural_64).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Natural_64_bytes)
					l_internal.set_natural_64_field (a_field.internal_index, Current, l_natural_64)
				when {CE_UTILITIES}.Ce_type_real_32 then
					($l_real_32).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Real_32_bytes)
					l_internal.set_real_32_field (a_field.internal_index, Current, l_real_32)
				when {CE_UTILITIES}.Ce_type_real_64 then
					($l_real_64).memory_copy (internal_c_pointer + a_field.c_offset, {PLATFORM}.Real_64_bytes)
					l_internal.set_real_64_field (a_field.internal_index, Current, l_real_64)
				when {CE_UTILITIES}.Ce_type_real_96 then
					if attached {REAL_96} l_internal.field (a_field.internal_index, Current) as r96 then
						r96.c_pointer.memory_copy (internal_c_pointer + a_field.c_offset, {CE_UTILITIES}.Real_96_bytes)
					else
						(create {EXCEPTIONS}).raise (l_internal.field (a_field.internal_index, Current).generator)
					end
				when {CE_UTILITIES}.Ce_type_pointer then
					($l_pointer).memory_copy(internal_c_pointer + a_field.c_offset, {PLATFORM}.Pointer_bytes)
					l_tmp_pointer ?= l_internal.new_instance_of (a_field.eif_type)
					l_tmp_pointer.make_shared (l_pointer)
					l_internal.set_reference_field (a_field.internal_index, Current, l_tmp_pointer)
				when {CE_UTILITIES}.Ce_type_array then
					-- nothing to do, uses the struct memory
				when {CE_UTILITIES}.Ce_type_class then
					if structure_info.is_union then
						l_tmp_class ?= l_internal.field (a_field.internal_index, Current)
						l_tmp_class.update_class_fields
					end
				when {CE_UTILITIES}.Ce_type_va_list then
					l_internal.set_reference_field (a_field.internal_index, Current, create {CE_VA_LIST}.make_shared_indirect (internal_c_pointer + a_field.c_offset))
				end
			end
		end

invariant
	internal_c_pointer /= default_pointer implies across structure_info.fields as c all
			(c.item.ce_type = {CE_UTILITIES}.Ce_type_array implies internal_c_pointer + c.item.c_offset = ({CE_ARRAY [ANY]} #? (create {INTERNAL}).field (c.item.internal_index, Current)).c_pointer) and
			(c.item.ce_type = {CE_UTILITIES}.Ce_type_class implies internal_c_pointer + c.item.c_offset = ({CE_CLASS} #? (create {INTERNAL}).field (c.item.internal_index, Current)).c_pointer)
		end
	(structure_info.is_union or structure_info.has_bitfields) implies internal_c_pointer /= default_pointer

end
