class
	PD_ASPRINTF

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create buffer.make
		end

feature {ANY} -- fields

	buffer: CE_POINTER [INTEGER_8] assign set_buffer

	len: NATURAL_32 assign set_len

	alloc: NATURAL_32 assign set_alloc

	fail: INTEGER_32 assign set_fail

feature {ANY} -- setters

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_len (a_len: NATURAL_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_alloc (a_alloc: NATURAL_32)
		do
			alloc := a_alloc
			update_memory_field ("alloc")
		end

	set_fail (a_fail: INTEGER_32)
		do
			fail := a_fail
			update_memory_field ("fail")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buffer := a_other.buffer
			len := a_other.len
			alloc := a_other.alloc
			fail := a_other.fail
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buffer.is_equal (a_other.buffer) and
				len = a_other.len and
				alloc = a_other.alloc and
				fail = a_other.fail
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("alloc"),
					create {CE_STRUCTURE_FIELD}.make ("fail")
				>>)
			init_structure_info
		end

end
