class
	PD_CLOSURE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create easy_handle.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_CLOSURE] assign set_next

	easy_handle: CE_POINTER [PD_SESSIONHANDLE] assign set_easy_handle

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_CLOSURE])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_easy_handle (a_easy_handle: CE_POINTER [PD_SESSIONHANDLE])
		do
			easy_handle := a_easy_handle
			update_memory_field ("easy_handle")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			easy_handle := a_other.easy_handle
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				easy_handle.is_equal (a_other.easy_handle)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("easy_handle")
				>>)
			init_structure_info
		end

end
