class
	PD_CONNECTBITS

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	close: BOOLEAN assign set_close

	reuse: BOOLEAN assign set_reuse

	proxy: BOOLEAN assign set_proxy

	httpproxy: BOOLEAN assign set_httpproxy

	user_passwd: BOOLEAN assign set_user_passwd

	proxy_user_passwd: BOOLEAN assign set_proxy_user_passwd

	ipv6_ip: BOOLEAN assign set_ipv6_ip

	ipv6: BOOLEAN assign set_ipv6

	do_more: BOOLEAN assign set_do_more

	tcpconnect: BOOLEAN assign set_tcpconnect

	protoconnstart: BOOLEAN assign set_protoconnstart

	retry2: BOOLEAN assign set_retry2

	tunnel_proxy: BOOLEAN assign set_tunnel_proxy

	tunnel_connecting: BOOLEAN assign set_tunnel_connecting

	authneg: BOOLEAN assign set_authneg

	rewindaftersend: BOOLEAN assign set_rewindaftersend

	ftp_use_epsv: BOOLEAN assign set_ftp_use_epsv

	ftp_use_eprt: BOOLEAN assign set_ftp_use_eprt

	netrc: BOOLEAN assign set_netrc

	userpwd_in_url: BOOLEAN assign set_userpwd_in_url

	done: BOOLEAN assign set_done

	stream_was_rewound: BOOLEAN assign set_stream_was_rewound

	proxy_connect_closed: BOOLEAN assign set_proxy_connect_closed

	bound: BOOLEAN assign set_bound

	type_set: BOOLEAN assign set_type_set

feature {ANY} -- setters

	set_close (a_close: BOOLEAN)
		do
			close := a_close
			update_memory_field ("close")
		end

	set_reuse (a_reuse: BOOLEAN)
		do
			reuse := a_reuse
			update_memory_field ("reuse")
		end

	set_proxy (a_proxy: BOOLEAN)
		do
			proxy := a_proxy
			update_memory_field ("proxy")
		end

	set_httpproxy (a_httpproxy: BOOLEAN)
		do
			httpproxy := a_httpproxy
			update_memory_field ("httpproxy")
		end

	set_user_passwd (a_user_passwd: BOOLEAN)
		do
			user_passwd := a_user_passwd
			update_memory_field ("user_passwd")
		end

	set_proxy_user_passwd (a_proxy_user_passwd: BOOLEAN)
		do
			proxy_user_passwd := a_proxy_user_passwd
			update_memory_field ("proxy_user_passwd")
		end

	set_ipv6_ip (a_ipv6_ip: BOOLEAN)
		do
			ipv6_ip := a_ipv6_ip
			update_memory_field ("ipv6_ip")
		end

	set_ipv6 (a_ipv6: BOOLEAN)
		do
			ipv6 := a_ipv6
			update_memory_field ("ipv6")
		end

	set_do_more (a_do_more: BOOLEAN)
		do
			do_more := a_do_more
			update_memory_field ("do_more")
		end

	set_tcpconnect (a_tcpconnect: BOOLEAN)
		do
			tcpconnect := a_tcpconnect
			update_memory_field ("tcpconnect")
		end

	set_protoconnstart (a_protoconnstart: BOOLEAN)
		do
			protoconnstart := a_protoconnstart
			update_memory_field ("protoconnstart")
		end

	set_retry2 (a_retry2: BOOLEAN)
		do
			retry2 := a_retry2
			update_memory_field ("retry2")
		end

	set_tunnel_proxy (a_tunnel_proxy: BOOLEAN)
		do
			tunnel_proxy := a_tunnel_proxy
			update_memory_field ("tunnel_proxy")
		end

	set_tunnel_connecting (a_tunnel_connecting: BOOLEAN)
		do
			tunnel_connecting := a_tunnel_connecting
			update_memory_field ("tunnel_connecting")
		end

	set_authneg (a_authneg: BOOLEAN)
		do
			authneg := a_authneg
			update_memory_field ("authneg")
		end

	set_rewindaftersend (a_rewindaftersend: BOOLEAN)
		do
			rewindaftersend := a_rewindaftersend
			update_memory_field ("rewindaftersend")
		end

	set_ftp_use_epsv (a_ftp_use_epsv: BOOLEAN)
		do
			ftp_use_epsv := a_ftp_use_epsv
			update_memory_field ("ftp_use_epsv")
		end

	set_ftp_use_eprt (a_ftp_use_eprt: BOOLEAN)
		do
			ftp_use_eprt := a_ftp_use_eprt
			update_memory_field ("ftp_use_eprt")
		end

	set_netrc (a_netrc: BOOLEAN)
		do
			netrc := a_netrc
			update_memory_field ("netrc")
		end

	set_userpwd_in_url (a_userpwd_in_url: BOOLEAN)
		do
			userpwd_in_url := a_userpwd_in_url
			update_memory_field ("userpwd_in_url")
		end

	set_done (a_done: BOOLEAN)
		do
			done := a_done
			update_memory_field ("done")
		end

	set_stream_was_rewound (a_stream_was_rewound: BOOLEAN)
		do
			stream_was_rewound := a_stream_was_rewound
			update_memory_field ("stream_was_rewound")
		end

	set_proxy_connect_closed (a_proxy_connect_closed: BOOLEAN)
		do
			proxy_connect_closed := a_proxy_connect_closed
			update_memory_field ("proxy_connect_closed")
		end

	set_bound (a_bound: BOOLEAN)
		do
			bound := a_bound
			update_memory_field ("bound")
		end

	set_type_set (a_type_set: BOOLEAN)
		do
			type_set := a_type_set
			update_memory_field ("type_set")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			close := a_other.close
			reuse := a_other.reuse
			proxy := a_other.proxy
			httpproxy := a_other.httpproxy
			user_passwd := a_other.user_passwd
			proxy_user_passwd := a_other.proxy_user_passwd
			ipv6_ip := a_other.ipv6_ip
			ipv6 := a_other.ipv6
			do_more := a_other.do_more
			tcpconnect := a_other.tcpconnect
			protoconnstart := a_other.protoconnstart
			retry2 := a_other.retry2
			tunnel_proxy := a_other.tunnel_proxy
			tunnel_connecting := a_other.tunnel_connecting
			authneg := a_other.authneg
			rewindaftersend := a_other.rewindaftersend
			ftp_use_epsv := a_other.ftp_use_epsv
			ftp_use_eprt := a_other.ftp_use_eprt
			netrc := a_other.netrc
			userpwd_in_url := a_other.userpwd_in_url
			done := a_other.done
			stream_was_rewound := a_other.stream_was_rewound
			proxy_connect_closed := a_other.proxy_connect_closed
			bound := a_other.bound
			type_set := a_other.type_set
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				close = a_other.close and
				reuse = a_other.reuse and
				proxy = a_other.proxy and
				httpproxy = a_other.httpproxy and
				user_passwd = a_other.user_passwd and
				proxy_user_passwd = a_other.proxy_user_passwd and
				ipv6_ip = a_other.ipv6_ip and
				ipv6 = a_other.ipv6 and
				do_more = a_other.do_more and
				tcpconnect = a_other.tcpconnect and
				protoconnstart = a_other.protoconnstart and
				retry2 = a_other.retry2 and
				tunnel_proxy = a_other.tunnel_proxy and
				tunnel_connecting = a_other.tunnel_connecting and
				authneg = a_other.authneg and
				rewindaftersend = a_other.rewindaftersend and
				ftp_use_epsv = a_other.ftp_use_epsv and
				ftp_use_eprt = a_other.ftp_use_eprt and
				netrc = a_other.netrc and
				userpwd_in_url = a_other.userpwd_in_url and
				done = a_other.done and
				stream_was_rewound = a_other.stream_was_rewound and
				proxy_connect_closed = a_other.proxy_connect_closed and
				bound = a_other.bound and
				type_set = a_other.type_set
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("close"),
					create {CE_STRUCTURE_FIELD}.make ("reuse"),
					create {CE_STRUCTURE_FIELD}.make ("proxy"),
					create {CE_STRUCTURE_FIELD}.make ("httpproxy"),
					create {CE_STRUCTURE_FIELD}.make ("user_passwd"),
					create {CE_STRUCTURE_FIELD}.make ("proxy_user_passwd"),
					create {CE_STRUCTURE_FIELD}.make ("ipv6_ip"),
					create {CE_STRUCTURE_FIELD}.make ("ipv6"),
					create {CE_STRUCTURE_FIELD}.make ("do_more"),
					create {CE_STRUCTURE_FIELD}.make ("tcpconnect"),
					create {CE_STRUCTURE_FIELD}.make ("protoconnstart"),
					create {CE_STRUCTURE_FIELD}.make ("retry2"),
					create {CE_STRUCTURE_FIELD}.make ("tunnel_proxy"),
					create {CE_STRUCTURE_FIELD}.make ("tunnel_connecting"),
					create {CE_STRUCTURE_FIELD}.make ("authneg"),
					create {CE_STRUCTURE_FIELD}.make ("rewindaftersend"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_use_epsv"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_use_eprt"),
					create {CE_STRUCTURE_FIELD}.make ("netrc"),
					create {CE_STRUCTURE_FIELD}.make ("userpwd_in_url"),
					create {CE_STRUCTURE_FIELD}.make ("done"),
					create {CE_STRUCTURE_FIELD}.make ("stream_was_rewound"),
					create {CE_STRUCTURE_FIELD}.make ("proxy_connect_closed"),
					create {CE_STRUCTURE_FIELD}.make ("bound"),
					create {CE_STRUCTURE_FIELD}.make ("type_set")
				>>)
			init_structure_info
		end

end
