class
	PD_CONNECTDATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
			create chunk.make
			create dns_entry.make
			create ip_addr.make
			create ip_addr_str.make (<<((("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32).to_integer_32>>)
			create host.make
			create proxy.make
			create user.make
			create passwd.make
			create proxyuser.make
			create proxypasswd.make
			create now.make
			create created.make
			create sock.make (<<2>>)
			create recv.make (<<2>>)
			create send.make (<<2>>)
			create ssl.make (<<2>>)
			create ssl_config.make
			create bits.make
			create handler.make
			create allocptr.make
			create send_pipe.make
			create recv_pipe.make
			create pend_pipe.make
			create done_pipe.make
			create master_buffer.make
			create seek_func.make
			create seek_client.make
			create fread_func.make
			create fread_in.make
			create ntlm.make
			create proxyntlm.make
			create syserr_buf.make (<<256>>)
			create trailer.make
			create proto.make
		end

feature {ANY} -- fields

	data: CE_POINTER [PD_SESSIONHANDLE] assign set_data

	chunk: PD_CURL_CHUNKER assign set_chunk

	inuse: BOOLEAN assign set_inuse

	connectindex: INTEGER_32 assign set_connectindex

	protocol: INTEGER_32 assign set_protocol

	dns_entry: CE_POINTER [PD_CURL_DNS_ENTRY] assign set_dns_entry

	ip_addr: CE_POINTER [PD_CURL_ADDRINFO] assign set_ip_addr

	ip_addr_str: CE_ARRAY [INTEGER_8]

	scope: NATURAL_32 assign set_scope

	socktype: INTEGER_32 assign set_socktype

	host: PD_HOSTNAME assign set_host

	proxy: PD_HOSTNAME assign set_proxy

	port: INTEGER_32 assign set_port

	remote_port: NATURAL_16 assign set_remote_port

	user: CE_POINTER [INTEGER_8] assign set_user

	passwd: CE_POINTER [INTEGER_8] assign set_passwd

	proxyuser: CE_POINTER [INTEGER_8] assign set_proxyuser

	proxypasswd: CE_POINTER [INTEGER_8] assign set_proxypasswd

	proxytype: NATURAL_32 assign set_proxytype

	httpversion: INTEGER_32 assign set_httpversion

	rtspversion: INTEGER_32 assign set_rtspversion

	now: SD_TIMEVAL assign set_now

	created: SD_TIMEVAL assign set_created

	sock: CE_ARRAY [INTEGER_32]

	recv: CE_ARRAY [CE_ROUTINE]

	send: CE_ARRAY [CE_ROUTINE]

	ssl: CE_ARRAY [PD_SSL_CONNECT_DATA]

	ssl_config: PD_SSL_CONFIG_DATA assign set_ssl_config

	bits: PD_CONNECTBITS assign set_bits

	handler: CE_POINTER [PD_CURL_HANDLER] assign set_handler

	sockfd: INTEGER_32 assign set_sockfd

	writesockfd: INTEGER_32 assign set_writesockfd

	allocptr: PD_DYNAMICALLY_ALLOCATED_DATA assign set_allocptr

	sec_complete: INTEGER_32 assign set_sec_complete

	readchannel_inuse: BOOLEAN assign set_readchannel_inuse

	writechannel_inuse: BOOLEAN assign set_writechannel_inuse

	server_supports_pipelining: BOOLEAN assign set_server_supports_pipelining

	send_pipe: CE_POINTER [PD_CURL_LLIST] assign set_send_pipe

	recv_pipe: CE_POINTER [PD_CURL_LLIST] assign set_recv_pipe

	pend_pipe: CE_POINTER [PD_CURL_LLIST] assign set_pend_pipe

	done_pipe: CE_POINTER [PD_CURL_LLIST] assign set_done_pipe

	master_buffer: CE_POINTER [INTEGER_8] assign set_master_buffer

	read_pos: NATURAL_32 assign set_read_pos

	buf_len: NATURAL_32 assign set_buf_len

	seek_func: CE_ROUTINE assign set_seek_func

	seek_client: CE_POINTER [ANY] assign set_seek_client

	fread_func: CE_ROUTINE assign set_fread_func

	fread_in: CE_POINTER [ANY] assign set_fread_in

	ntlm: PD_NTLMDATA assign set_ntlm

	proxyntlm: PD_NTLMDATA assign set_proxyntlm

	syserr_buf: CE_ARRAY [INTEGER_8]

	trailer: CE_POINTER [INTEGER_8] assign set_trailer

	trlMax: INTEGER_32 assign set_trlMax

	trlPos: INTEGER_32 assign set_trlPos

	proto: PD_PROTO assign set_proto

	cselect_bits: INTEGER_32 assign set_cselect_bits

	waitfor: INTEGER_32 assign set_waitfor

	verifypeer: INTEGER_32 assign set_verifypeer

	verifyhost: INTEGER_32 assign set_verifyhost

feature {ANY} -- setters

	set_data (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_chunk (a_chunk: PD_CURL_CHUNKER)
		do
			chunk := a_chunk
			update_memory_field ("chunk")
		end

	set_inuse (a_inuse: BOOLEAN)
		do
			inuse := a_inuse
			update_memory_field ("inuse")
		end

	set_connectindex (a_connectindex: INTEGER_32)
		do
			connectindex := a_connectindex
			update_memory_field ("connectindex")
		end

	set_protocol (a_protocol: INTEGER_32)
		do
			protocol := a_protocol
			update_memory_field ("protocol")
		end

	set_dns_entry (a_dns_entry: CE_POINTER [PD_CURL_DNS_ENTRY])
		do
			dns_entry := a_dns_entry
			update_memory_field ("dns_entry")
		end

	set_ip_addr (a_ip_addr: CE_POINTER [PD_CURL_ADDRINFO])
		do
			ip_addr := a_ip_addr
			update_memory_field ("ip_addr")
		end

	set_scope (a_scope: NATURAL_32)
		do
			scope := a_scope
			update_memory_field ("scope")
		end

	set_socktype (a_socktype: INTEGER_32)
		do
			socktype := a_socktype
			update_memory_field ("socktype")
		end

	set_host (a_host: PD_HOSTNAME)
		do
			host := a_host
			update_memory_field ("host")
		end

	set_proxy (a_proxy: PD_HOSTNAME)
		do
			proxy := a_proxy
			update_memory_field ("proxy")
		end

	set_port (a_port: INTEGER_32)
		do
			port := a_port
			update_memory_field ("port")
		end

	set_remote_port (a_remote_port: NATURAL_16)
		do
			remote_port := a_remote_port
			update_memory_field ("remote_port")
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			user := a_user
			update_memory_field ("user")
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			passwd := a_passwd
			update_memory_field ("passwd")
		end

	set_proxyuser (a_proxyuser: CE_POINTER [INTEGER_8])
		do
			proxyuser := a_proxyuser
			update_memory_field ("proxyuser")
		end

	set_proxypasswd (a_proxypasswd: CE_POINTER [INTEGER_8])
		do
			proxypasswd := a_proxypasswd
			update_memory_field ("proxypasswd")
		end

	set_proxytype (a_proxytype: NATURAL_32)
		do
			proxytype := a_proxytype
			update_memory_field ("proxytype")
		end

	set_httpversion (a_httpversion: INTEGER_32)
		do
			httpversion := a_httpversion
			update_memory_field ("httpversion")
		end

	set_rtspversion (a_rtspversion: INTEGER_32)
		do
			rtspversion := a_rtspversion
			update_memory_field ("rtspversion")
		end

	set_now (a_now: SD_TIMEVAL)
		do
			now := a_now
			update_memory_field ("now")
		end

	set_created (a_created: SD_TIMEVAL)
		do
			created := a_created
			update_memory_field ("created")
		end

	set_ssl_config (a_ssl_config: PD_SSL_CONFIG_DATA)
		do
			ssl_config := a_ssl_config
			update_memory_field ("ssl_config")
		end

	set_bits (a_bits: PD_CONNECTBITS)
		do
			bits := a_bits
			update_memory_field ("bits")
		end

	set_handler (a_handler: CE_POINTER [PD_CURL_HANDLER])
		do
			handler := a_handler
			update_memory_field ("handler")
		end

	set_sockfd (a_sockfd: INTEGER_32)
		do
			sockfd := a_sockfd
			update_memory_field ("sockfd")
		end

	set_writesockfd (a_writesockfd: INTEGER_32)
		do
			writesockfd := a_writesockfd
			update_memory_field ("writesockfd")
		end

	set_allocptr (a_allocptr: PD_DYNAMICALLY_ALLOCATED_DATA)
		do
			allocptr := a_allocptr
			update_memory_field ("allocptr")
		end

	set_sec_complete (a_sec_complete: INTEGER_32)
		do
			sec_complete := a_sec_complete
			update_memory_field ("sec_complete")
		end

	set_readchannel_inuse (a_readchannel_inuse: BOOLEAN)
		do
			readchannel_inuse := a_readchannel_inuse
			update_memory_field ("readchannel_inuse")
		end

	set_writechannel_inuse (a_writechannel_inuse: BOOLEAN)
		do
			writechannel_inuse := a_writechannel_inuse
			update_memory_field ("writechannel_inuse")
		end

	set_server_supports_pipelining (a_server_supports_pipelining: BOOLEAN)
		do
			server_supports_pipelining := a_server_supports_pipelining
			update_memory_field ("server_supports_pipelining")
		end

	set_send_pipe (a_send_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			send_pipe := a_send_pipe
			update_memory_field ("send_pipe")
		end

	set_recv_pipe (a_recv_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			recv_pipe := a_recv_pipe
			update_memory_field ("recv_pipe")
		end

	set_pend_pipe (a_pend_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			pend_pipe := a_pend_pipe
			update_memory_field ("pend_pipe")
		end

	set_done_pipe (a_done_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			done_pipe := a_done_pipe
			update_memory_field ("done_pipe")
		end

	set_master_buffer (a_master_buffer: CE_POINTER [INTEGER_8])
		do
			master_buffer := a_master_buffer
			update_memory_field ("master_buffer")
		end

	set_read_pos (a_read_pos: NATURAL_32)
		do
			read_pos := a_read_pos
			update_memory_field ("read_pos")
		end

	set_buf_len (a_buf_len: NATURAL_32)
		do
			buf_len := a_buf_len
			update_memory_field ("buf_len")
		end

	set_seek_func (a_seek_func: CE_ROUTINE)
		do
			seek_func := a_seek_func
			update_memory_field ("seek_func")
		end

	set_seek_client (a_seek_client: CE_POINTER [ANY])
		do
			seek_client := a_seek_client
			update_memory_field ("seek_client")
		end

	set_fread_func (a_fread_func: CE_ROUTINE)
		do
			fread_func := a_fread_func
			update_memory_field ("fread_func")
		end

	set_fread_in (a_fread_in: CE_POINTER [ANY])
		do
			fread_in := a_fread_in
			update_memory_field ("fread_in")
		end

	set_ntlm (a_ntlm: PD_NTLMDATA)
		do
			ntlm := a_ntlm
			update_memory_field ("ntlm")
		end

	set_proxyntlm (a_proxyntlm: PD_NTLMDATA)
		do
			proxyntlm := a_proxyntlm
			update_memory_field ("proxyntlm")
		end

	set_trailer (a_trailer: CE_POINTER [INTEGER_8])
		do
			trailer := a_trailer
			update_memory_field ("trailer")
		end

	set_trlMax (a_trlMax: INTEGER_32)
		do
			trlMax := a_trlMax
			update_memory_field ("trlMax")
		end

	set_trlPos (a_trlPos: INTEGER_32)
		do
			trlPos := a_trlPos
			update_memory_field ("trlPos")
		end

	set_proto (a_proto: PD_PROTO)
		do
			proto := a_proto
			update_memory_field ("proto")
		end

	set_cselect_bits (a_cselect_bits: INTEGER_32)
		do
			cselect_bits := a_cselect_bits
			update_memory_field ("cselect_bits")
		end

	set_waitfor (a_waitfor: INTEGER_32)
		do
			waitfor := a_waitfor
			update_memory_field ("waitfor")
		end

	set_verifypeer (a_verifypeer: INTEGER_32)
		do
			verifypeer := a_verifypeer
			update_memory_field ("verifypeer")
		end

	set_verifyhost (a_verifyhost: INTEGER_32)
		do
			verifyhost := a_verifyhost
			update_memory_field ("verifyhost")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
			chunk := a_other.chunk.twin
			inuse := a_other.inuse
			connectindex := a_other.connectindex
			protocol := a_other.protocol
			dns_entry := a_other.dns_entry
			ip_addr := a_other.ip_addr
			ip_addr_str := a_other.ip_addr_str.twin
			scope := a_other.scope
			socktype := a_other.socktype
			host := a_other.host.twin
			proxy := a_other.proxy.twin
			port := a_other.port
			remote_port := a_other.remote_port
			user := a_other.user
			passwd := a_other.passwd
			proxyuser := a_other.proxyuser
			proxypasswd := a_other.proxypasswd
			proxytype := a_other.proxytype
			httpversion := a_other.httpversion
			rtspversion := a_other.rtspversion
			now := a_other.now.twin
			created := a_other.created.twin
			sock := a_other.sock.twin
			recv := a_other.recv.twin
			send := a_other.send.twin
			ssl := a_other.ssl.twin
			ssl_config := a_other.ssl_config.twin
			bits := a_other.bits.twin
			handler := a_other.handler
			sockfd := a_other.sockfd
			writesockfd := a_other.writesockfd
			allocptr := a_other.allocptr.twin
			sec_complete := a_other.sec_complete
			readchannel_inuse := a_other.readchannel_inuse
			writechannel_inuse := a_other.writechannel_inuse
			server_supports_pipelining := a_other.server_supports_pipelining
			send_pipe := a_other.send_pipe
			recv_pipe := a_other.recv_pipe
			pend_pipe := a_other.pend_pipe
			done_pipe := a_other.done_pipe
			master_buffer := a_other.master_buffer
			read_pos := a_other.read_pos
			buf_len := a_other.buf_len
			seek_func := a_other.seek_func
			seek_client := a_other.seek_client
			fread_func := a_other.fread_func
			fread_in := a_other.fread_in
			ntlm := a_other.ntlm.twin
			proxyntlm := a_other.proxyntlm.twin
			syserr_buf := a_other.syserr_buf.twin
			trailer := a_other.trailer
			trlMax := a_other.trlMax
			trlPos := a_other.trlPos
			proto := a_other.proto.twin
			cselect_bits := a_other.cselect_bits
			waitfor := a_other.waitfor
			verifypeer := a_other.verifypeer
			verifyhost := a_other.verifyhost
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data) and
				chunk.is_equal (a_other.chunk) and
				inuse = a_other.inuse and
				connectindex = a_other.connectindex and
				protocol = a_other.protocol and
				dns_entry.is_equal (a_other.dns_entry) and
				ip_addr.is_equal (a_other.ip_addr) and
				ip_addr_str.is_equal (a_other.ip_addr_str) and
				scope = a_other.scope and
				socktype = a_other.socktype and
				host.is_equal (a_other.host) and
				proxy.is_equal (a_other.proxy) and
				port = a_other.port and
				remote_port = a_other.remote_port and
				user.is_equal (a_other.user) and
				passwd.is_equal (a_other.passwd) and
				proxyuser.is_equal (a_other.proxyuser) and
				proxypasswd.is_equal (a_other.proxypasswd) and
				proxytype = a_other.proxytype and
				httpversion = a_other.httpversion and
				rtspversion = a_other.rtspversion and
				now.is_equal (a_other.now) and
				created.is_equal (a_other.created) and
				sock.is_equal (a_other.sock) and
				recv.is_equal (a_other.recv) and
				send.is_equal (a_other.send) and
				ssl.is_equal (a_other.ssl) and
				ssl_config.is_equal (a_other.ssl_config) and
				bits.is_equal (a_other.bits) and
				handler.is_equal (a_other.handler) and
				sockfd = a_other.sockfd and
				writesockfd = a_other.writesockfd and
				allocptr.is_equal (a_other.allocptr) and
				sec_complete = a_other.sec_complete and
				readchannel_inuse = a_other.readchannel_inuse and
				writechannel_inuse = a_other.writechannel_inuse and
				server_supports_pipelining = a_other.server_supports_pipelining and
				send_pipe.is_equal (a_other.send_pipe) and
				recv_pipe.is_equal (a_other.recv_pipe) and
				pend_pipe.is_equal (a_other.pend_pipe) and
				done_pipe.is_equal (a_other.done_pipe) and
				master_buffer.is_equal (a_other.master_buffer) and
				read_pos = a_other.read_pos and
				buf_len = a_other.buf_len and
				seek_func.is_equal (a_other.seek_func) and
				seek_client.is_equal (a_other.seek_client) and
				fread_func.is_equal (a_other.fread_func) and
				fread_in.is_equal (a_other.fread_in) and
				ntlm.is_equal (a_other.ntlm) and
				proxyntlm.is_equal (a_other.proxyntlm) and
				syserr_buf.is_equal (a_other.syserr_buf) and
				trailer.is_equal (a_other.trailer) and
				trlMax = a_other.trlMax and
				trlPos = a_other.trlPos and
				proto.is_equal (a_other.proto) and
				cselect_bits = a_other.cselect_bits and
				waitfor = a_other.waitfor and
				verifypeer = a_other.verifypeer and
				verifyhost = a_other.verifyhost
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("chunk"),
					create {CE_STRUCTURE_FIELD}.make ("inuse"),
					create {CE_STRUCTURE_FIELD}.make ("connectindex"),
					create {CE_STRUCTURE_FIELD}.make ("protocol"),
					create {CE_STRUCTURE_FIELD}.make ("dns_entry"),
					create {CE_STRUCTURE_FIELD}.make ("ip_addr"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ip_addr_str", <<((("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32).to_integer_32>>),
					create {CE_STRUCTURE_FIELD}.make ("scope"),
					create {CE_STRUCTURE_FIELD}.make ("socktype"),
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("proxy"),
					create {CE_STRUCTURE_FIELD}.make ("port"),
					create {CE_STRUCTURE_FIELD}.make ("remote_port"),
					create {CE_STRUCTURE_FIELD}.make ("user"),
					create {CE_STRUCTURE_FIELD}.make ("passwd"),
					create {CE_STRUCTURE_FIELD}.make ("proxyuser"),
					create {CE_STRUCTURE_FIELD}.make ("proxypasswd"),
					create {CE_STRUCTURE_FIELD}.make ("proxytype"),
					create {CE_STRUCTURE_FIELD}.make ("httpversion"),
					create {CE_STRUCTURE_FIELD}.make ("rtspversion"),
					create {CE_STRUCTURE_FIELD}.make ("now"),
					create {CE_STRUCTURE_FIELD}.make ("created"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sock", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("recv", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("send", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ssl", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("ssl_config"),
					create {CE_STRUCTURE_FIELD}.make ("bits"),
					create {CE_STRUCTURE_FIELD}.make ("handler"),
					create {CE_STRUCTURE_FIELD}.make ("sockfd"),
					create {CE_STRUCTURE_FIELD}.make ("writesockfd"),
					create {CE_STRUCTURE_FIELD}.make ("allocptr"),
					create {CE_STRUCTURE_FIELD}.make ("sec_complete"),
					create {CE_STRUCTURE_FIELD}.make ("readchannel_inuse"),
					create {CE_STRUCTURE_FIELD}.make ("writechannel_inuse"),
					create {CE_STRUCTURE_FIELD}.make ("server_supports_pipelining"),
					create {CE_STRUCTURE_FIELD}.make ("send_pipe"),
					create {CE_STRUCTURE_FIELD}.make ("recv_pipe"),
					create {CE_STRUCTURE_FIELD}.make ("pend_pipe"),
					create {CE_STRUCTURE_FIELD}.make ("done_pipe"),
					create {CE_STRUCTURE_FIELD}.make ("master_buffer"),
					create {CE_STRUCTURE_FIELD}.make ("read_pos"),
					create {CE_STRUCTURE_FIELD}.make ("buf_len"),
					create {CE_STRUCTURE_FIELD}.make ("seek_func"),
					create {CE_STRUCTURE_FIELD}.make ("seek_client"),
					create {CE_STRUCTURE_FIELD}.make ("fread_func"),
					create {CE_STRUCTURE_FIELD}.make ("fread_in"),
					create {CE_STRUCTURE_FIELD}.make ("ntlm"),
					create {CE_STRUCTURE_FIELD}.make ("proxyntlm"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("syserr_buf", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("trailer"),
					create {CE_STRUCTURE_FIELD}.make ("trlMax"),
					create {CE_STRUCTURE_FIELD}.make ("trlPos"),
					create {CE_STRUCTURE_FIELD}.make ("proto"),
					create {CE_STRUCTURE_FIELD}.make ("cselect_bits"),
					create {CE_STRUCTURE_FIELD}.make ("waitfor"),
					create {CE_STRUCTURE_FIELD}.make ("verifypeer"),
					create {CE_STRUCTURE_FIELD}.make ("verifyhost")
				>>)
			init_structure_info
		end

end
