class
	PD_CURL_LLIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create head.make
			create tail.make
			create dtor.make
		end

feature {ANY} -- fields

	head: CE_POINTER [PD_CURL_LLIST_ELEMENT] assign set_head

	tail: CE_POINTER [PD_CURL_LLIST_ELEMENT] assign set_tail

	dtor: CE_ROUTINE assign set_dtor

	size: NATURAL_32 assign set_size

feature {ANY} -- setters

	set_head (a_head: CE_POINTER [PD_CURL_LLIST_ELEMENT])
		do
			head := a_head
			update_memory_field ("head")
		end

	set_tail (a_tail: CE_POINTER [PD_CURL_LLIST_ELEMENT])
		do
			tail := a_tail
			update_memory_field ("tail")
		end

	set_dtor (a_dtor: CE_ROUTINE)
		do
			dtor := a_dtor
			update_memory_field ("dtor")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			head := a_other.head
			tail := a_other.tail
			dtor := a_other.dtor
			size := a_other.size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				head.is_equal (a_other.head) and
				tail.is_equal (a_other.tail) and
				dtor.is_equal (a_other.dtor) and
				size = a_other.size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("head"),
					create {CE_STRUCTURE_FIELD}.make ("tail"),
					create {CE_STRUCTURE_FIELD}.make ("dtor"),
					create {CE_STRUCTURE_FIELD}.make ("size")
				>>)
			init_structure_info
		end

end
