class
	PD_CURL_LLIST_ELEMENT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ptr.make
			create prev.make
			create next.make
		end

feature {ANY} -- fields

	ptr: CE_POINTER [ANY] assign set_ptr

	prev: CE_POINTER [PD_CURL_LLIST_ELEMENT] assign set_prev

	next: CE_POINTER [PD_CURL_LLIST_ELEMENT] assign set_next

feature {ANY} -- setters

	set_ptr (a_ptr: CE_POINTER [ANY])
		do
			ptr := a_ptr
			update_memory_field ("ptr")
		end

	set_prev (a_prev: CE_POINTER [PD_CURL_LLIST_ELEMENT])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_next (a_next: CE_POINTER [PD_CURL_LLIST_ELEMENT])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ptr := a_other.ptr
			prev := a_other.prev
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ptr.is_equal (a_other.ptr) and
				prev.is_equal (a_other.prev) and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ptr"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
