class
	PD_CURL_MULTI

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create easy.make
			create msglist.make
			create socket_cb.make
			create socket_userp.make
			create hostcache.make
			create timetree.make
			create sockhash.make
			create connc.make
			create closure.make
			create timer_cb.make
			create timer_userp.make
			create timer_lastcall.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	easy: PD_CURL_ONE_EASY assign set_easy

	num_easy: INTEGER_32 assign set_num_easy

	num_alive: INTEGER_32 assign set_num_alive

	msglist: CE_POINTER [PD_CURL_LLIST] assign set_msglist

	socket_cb: CE_ROUTINE assign set_socket_cb

	socket_userp: CE_POINTER [ANY] assign set_socket_userp

	hostcache: CE_POINTER [PD_CURL_HASH] assign set_hostcache

	timetree: CE_POINTER [PD_CURL_TREE] assign set_timetree

	sockhash: CE_POINTER [PD_CURL_HASH] assign set_sockhash

	pipelining_enabled: BOOLEAN assign set_pipelining_enabled

	connc: CE_POINTER [PD_CONNCACHE] assign set_connc

	maxconnects: INTEGER_32 assign set_maxconnects

	closure: CE_POINTER [PD_CLOSURE] assign set_closure

	timer_cb: CE_ROUTINE assign set_timer_cb

	timer_userp: CE_POINTER [ANY] assign set_timer_userp

	timer_lastcall: SD_TIMEVAL assign set_timer_lastcall

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_easy (a_easy: PD_CURL_ONE_EASY)
		do
			easy := a_easy
			update_memory_field ("easy")
		end

	set_num_easy (a_num_easy: INTEGER_32)
		do
			num_easy := a_num_easy
			update_memory_field ("num_easy")
		end

	set_num_alive (a_num_alive: INTEGER_32)
		do
			num_alive := a_num_alive
			update_memory_field ("num_alive")
		end

	set_msglist (a_msglist: CE_POINTER [PD_CURL_LLIST])
		do
			msglist := a_msglist
			update_memory_field ("msglist")
		end

	set_socket_cb (a_socket_cb: CE_ROUTINE)
		do
			socket_cb := a_socket_cb
			update_memory_field ("socket_cb")
		end

	set_socket_userp (a_socket_userp: CE_POINTER [ANY])
		do
			socket_userp := a_socket_userp
			update_memory_field ("socket_userp")
		end

	set_hostcache (a_hostcache: CE_POINTER [PD_CURL_HASH])
		do
			hostcache := a_hostcache
			update_memory_field ("hostcache")
		end

	set_timetree (a_timetree: CE_POINTER [PD_CURL_TREE])
		do
			timetree := a_timetree
			update_memory_field ("timetree")
		end

	set_sockhash (a_sockhash: CE_POINTER [PD_CURL_HASH])
		do
			sockhash := a_sockhash
			update_memory_field ("sockhash")
		end

	set_pipelining_enabled (a_pipelining_enabled: BOOLEAN)
		do
			pipelining_enabled := a_pipelining_enabled
			update_memory_field ("pipelining_enabled")
		end

	set_connc (a_connc: CE_POINTER [PD_CONNCACHE])
		do
			connc := a_connc
			update_memory_field ("connc")
		end

	set_maxconnects (a_maxconnects: INTEGER_32)
		do
			maxconnects := a_maxconnects
			update_memory_field ("maxconnects")
		end

	set_closure (a_closure: CE_POINTER [PD_CLOSURE])
		do
			closure := a_closure
			update_memory_field ("closure")
		end

	set_timer_cb (a_timer_cb: CE_ROUTINE)
		do
			timer_cb := a_timer_cb
			update_memory_field ("timer_cb")
		end

	set_timer_userp (a_timer_userp: CE_POINTER [ANY])
		do
			timer_userp := a_timer_userp
			update_memory_field ("timer_userp")
		end

	set_timer_lastcall (a_timer_lastcall: SD_TIMEVAL)
		do
			timer_lastcall := a_timer_lastcall
			update_memory_field ("timer_lastcall")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			easy := a_other.easy.twin
			num_easy := a_other.num_easy
			num_alive := a_other.num_alive
			msglist := a_other.msglist
			socket_cb := a_other.socket_cb
			socket_userp := a_other.socket_userp
			hostcache := a_other.hostcache
			timetree := a_other.timetree
			sockhash := a_other.sockhash
			pipelining_enabled := a_other.pipelining_enabled
			connc := a_other.connc
			maxconnects := a_other.maxconnects
			closure := a_other.closure
			timer_cb := a_other.timer_cb
			timer_userp := a_other.timer_userp
			timer_lastcall := a_other.timer_lastcall.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				easy.is_equal (a_other.easy) and
				num_easy = a_other.num_easy and
				num_alive = a_other.num_alive and
				msglist.is_equal (a_other.msglist) and
				socket_cb.is_equal (a_other.socket_cb) and
				socket_userp.is_equal (a_other.socket_userp) and
				hostcache.is_equal (a_other.hostcache) and
				timetree.is_equal (a_other.timetree) and
				sockhash.is_equal (a_other.sockhash) and
				pipelining_enabled = a_other.pipelining_enabled and
				connc.is_equal (a_other.connc) and
				maxconnects = a_other.maxconnects and
				closure.is_equal (a_other.closure) and
				timer_cb.is_equal (a_other.timer_cb) and
				timer_userp.is_equal (a_other.timer_userp) and
				timer_lastcall.is_equal (a_other.timer_lastcall)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("easy"),
					create {CE_STRUCTURE_FIELD}.make ("num_easy"),
					create {CE_STRUCTURE_FIELD}.make ("num_alive"),
					create {CE_STRUCTURE_FIELD}.make ("msglist"),
					create {CE_STRUCTURE_FIELD}.make ("socket_cb"),
					create {CE_STRUCTURE_FIELD}.make ("socket_userp"),
					create {CE_STRUCTURE_FIELD}.make ("hostcache"),
					create {CE_STRUCTURE_FIELD}.make ("timetree"),
					create {CE_STRUCTURE_FIELD}.make ("sockhash"),
					create {CE_STRUCTURE_FIELD}.make ("pipelining_enabled"),
					create {CE_STRUCTURE_FIELD}.make ("connc"),
					create {CE_STRUCTURE_FIELD}.make ("maxconnects"),
					create {CE_STRUCTURE_FIELD}.make ("closure"),
					create {CE_STRUCTURE_FIELD}.make ("timer_cb"),
					create {CE_STRUCTURE_FIELD}.make ("timer_userp"),
					create {CE_STRUCTURE_FIELD}.make ("timer_lastcall")
				>>)
			init_structure_info
		end

end
