class
	PD_CURL_ONE_EASY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
			create prev.make
			create easy_handle.make
			create easy_conn.make
			create msg.make
			create sockets.make (<<5>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_CURL_ONE_EASY] assign set_next

	prev: CE_POINTER [PD_CURL_ONE_EASY] assign set_prev

	easy_handle: CE_POINTER [PD_SESSIONHANDLE] assign set_easy_handle

	easy_conn: CE_POINTER [PD_CONNECTDATA] assign set_easy_conn

	state: NATURAL_32 assign set_state

	result2: NATURAL_32 assign set_result2

	msg: PD_CURL_MESSAGE assign set_msg

	sockets: CE_ARRAY [INTEGER_32]

	numsocks: INTEGER_32 assign set_numsocks

feature {ANY} -- setters

	set_next (a_next: CE_POINTER [PD_CURL_ONE_EASY])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_CURL_ONE_EASY])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_easy_handle (a_easy_handle: CE_POINTER [PD_SESSIONHANDLE])
		do
			easy_handle := a_easy_handle
			update_memory_field ("easy_handle")
		end

	set_easy_conn (a_easy_conn: CE_POINTER [PD_CONNECTDATA])
		do
			easy_conn := a_easy_conn
			update_memory_field ("easy_conn")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_result2 (a_result2: NATURAL_32)
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

	set_msg (a_msg: PD_CURL_MESSAGE)
		do
			msg := a_msg
			update_memory_field ("msg")
		end

	set_numsocks (a_numsocks: INTEGER_32)
		do
			numsocks := a_numsocks
			update_memory_field ("numsocks")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			easy_handle := a_other.easy_handle
			easy_conn := a_other.easy_conn
			state := a_other.state
			result2 := a_other.result2
			msg := a_other.msg.twin
			sockets := a_other.sockets.twin
			numsocks := a_other.numsocks
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				easy_handle.is_equal (a_other.easy_handle) and
				easy_conn.is_equal (a_other.easy_conn) and
				state = a_other.state and
				result2 = a_other.result2 and
				msg.is_equal (a_other.msg) and
				sockets.is_equal (a_other.sockets) and
				numsocks = a_other.numsocks
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("easy_handle"),
					create {CE_STRUCTURE_FIELD}.make ("easy_conn"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("result2"),
					create {CE_STRUCTURE_FIELD}.make ("msg"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sockets", <<5>>),
					create {CE_STRUCTURE_FIELD}.make ("numsocks")
				>>)
			init_structure_info
		end

end
