class
	PD_CURL_SHARE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create lockfunc.make
			create unlockfunc.make
			create clientdata.make
			create hostcache.make
			create cookies.make
		end

feature {ANY} -- fields

	specifier: NATURAL_32 assign set_specifier

	dirty: NATURAL_32 assign set_dirty

	lockfunc: CE_ROUTINE assign set_lockfunc

	unlockfunc: CE_ROUTINE assign set_unlockfunc

	clientdata: CE_POINTER [ANY] assign set_clientdata

	hostcache: CE_POINTER [PD_CURL_HASH] assign set_hostcache

	cookies: CE_POINTER [PD_COOKIEINFO] assign set_cookies

feature {ANY} -- setters

	set_specifier (a_specifier: NATURAL_32)
		do
			specifier := a_specifier
			update_memory_field ("specifier")
		end

	set_dirty (a_dirty: NATURAL_32)
		do
			dirty := a_dirty
			update_memory_field ("dirty")
		end

	set_lockfunc (a_lockfunc: CE_ROUTINE)
		do
			lockfunc := a_lockfunc
			update_memory_field ("lockfunc")
		end

	set_unlockfunc (a_unlockfunc: CE_ROUTINE)
		do
			unlockfunc := a_unlockfunc
			update_memory_field ("unlockfunc")
		end

	set_clientdata (a_clientdata: CE_POINTER [ANY])
		do
			clientdata := a_clientdata
			update_memory_field ("clientdata")
		end

	set_hostcache (a_hostcache: CE_POINTER [PD_CURL_HASH])
		do
			hostcache := a_hostcache
			update_memory_field ("hostcache")
		end

	set_cookies (a_cookies: CE_POINTER [PD_COOKIEINFO])
		do
			cookies := a_cookies
			update_memory_field ("cookies")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			specifier := a_other.specifier
			dirty := a_other.dirty
			lockfunc := a_other.lockfunc
			unlockfunc := a_other.unlockfunc
			clientdata := a_other.clientdata
			hostcache := a_other.hostcache
			cookies := a_other.cookies
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				specifier = a_other.specifier and
				dirty = a_other.dirty and
				lockfunc.is_equal (a_other.lockfunc) and
				unlockfunc.is_equal (a_other.unlockfunc) and
				clientdata.is_equal (a_other.clientdata) and
				hostcache.is_equal (a_other.hostcache) and
				cookies.is_equal (a_other.cookies)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("specifier"),
					create {CE_STRUCTURE_FIELD}.make ("dirty"),
					create {CE_STRUCTURE_FIELD}.make ("lockfunc"),
					create {CE_STRUCTURE_FIELD}.make ("unlockfunc"),
					create {CE_STRUCTURE_FIELD}.make ("clientdata"),
					create {CE_STRUCTURE_FIELD}.make ("hostcache"),
					create {CE_STRUCTURE_FIELD}.make ("cookies")
				>>)
			init_structure_info
		end

end
