class
	PD_CURL_SOCKADDR

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create addr.make
		end

feature {ANY} -- fields

	family: INTEGER_32 assign set_family

	socktype: INTEGER_32 assign set_socktype

	protocol: INTEGER_32 assign set_protocol

	addrlen: NATURAL_32 assign set_addrlen

	addr: SD_SOCKADDR assign set_addr

feature {ANY} -- setters

	set_family (a_family: INTEGER_32)
		do
			family := a_family
			update_memory_field ("family")
		end

	set_socktype (a_socktype: INTEGER_32)
		do
			socktype := a_socktype
			update_memory_field ("socktype")
		end

	set_protocol (a_protocol: INTEGER_32)
		do
			protocol := a_protocol
			update_memory_field ("protocol")
		end

	set_addrlen (a_addrlen: NATURAL_32)
		do
			addrlen := a_addrlen
			update_memory_field ("addrlen")
		end

	set_addr (a_addr: SD_SOCKADDR)
		do
			addr := a_addr
			update_memory_field ("addr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			family := a_other.family
			socktype := a_other.socktype
			protocol := a_other.protocol
			addrlen := a_other.addrlen
			addr := a_other.addr.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				family = a_other.family and
				socktype = a_other.socktype and
				protocol = a_other.protocol and
				addrlen = a_other.addrlen and
				addr.is_equal (a_other.addr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("family"),
					create {CE_STRUCTURE_FIELD}.make ("socktype"),
					create {CE_STRUCTURE_FIELD}.make ("protocol"),
					create {CE_STRUCTURE_FIELD}.make ("addrlen"),
					create {CE_STRUCTURE_FIELD}.make ("addr")
				>>)
			init_structure_info
		end

end
