class
	PD_CURL_TREE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create smaller.make
			create larger.make
			create same.make
			create key.make
			create payload.make
		end

feature {ANY} -- fields

	smaller: CE_POINTER [PD_CURL_TREE] assign set_smaller

	larger: CE_POINTER [PD_CURL_TREE] assign set_larger

	same: CE_POINTER [PD_CURL_TREE] assign set_same

	key: SD_TIMEVAL assign set_key

	payload: CE_POINTER [ANY] assign set_payload

feature {ANY} -- setters

	set_smaller (a_smaller: CE_POINTER [PD_CURL_TREE])
		do
			smaller := a_smaller
			update_memory_field ("smaller")
		end

	set_larger (a_larger: CE_POINTER [PD_CURL_TREE])
		do
			larger := a_larger
			update_memory_field ("larger")
		end

	set_same (a_same: CE_POINTER [PD_CURL_TREE])
		do
			same := a_same
			update_memory_field ("same")
		end

	set_key (a_key: SD_TIMEVAL)
		do
			key := a_key
			update_memory_field ("key")
		end

	set_payload (a_payload: CE_POINTER [ANY])
		do
			payload := a_payload
			update_memory_field ("payload")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			smaller := a_other.smaller
			larger := a_other.larger
			same := a_other.same
			key := a_other.key.twin
			payload := a_other.payload
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				smaller.is_equal (a_other.smaller) and
				larger.is_equal (a_other.larger) and
				same.is_equal (a_other.same) and
				key.is_equal (a_other.key) and
				payload.is_equal (a_other.payload)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("smaller"),
					create {CE_STRUCTURE_FIELD}.make ("larger"),
					create {CE_STRUCTURE_FIELD}.make ("same"),
					create {CE_STRUCTURE_FIELD}.make ("key"),
					create {CE_STRUCTURE_FIELD}.make ("payload")
				>>)
			init_structure_info
		end

end
