class
	PD_CURL_VERSION_INFO_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create version.make
			create host.make
			create ssl_version.make
			create libz_version.make
			create protocols.make
			create ares.make
			create libidn.make
			create libssh_version.make
		end

feature {ANY} -- fields

	age: NATURAL_32 assign set_age

	version: CE_POINTER [INTEGER_8] assign set_version

	version_num: NATURAL_32 assign set_version_num

	host: CE_POINTER [INTEGER_8] assign set_host

	features: INTEGER_32 assign set_features

	ssl_version: CE_POINTER [INTEGER_8] assign set_ssl_version

	ssl_version_num: INTEGER_32 assign set_ssl_version_num

	libz_version: CE_POINTER [INTEGER_8] assign set_libz_version

	protocols: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_protocols

	ares: CE_POINTER [INTEGER_8] assign set_ares

	ares_num: INTEGER_32 assign set_ares_num

	libidn: CE_POINTER [INTEGER_8] assign set_libidn

	iconv_ver_num: INTEGER_32 assign set_iconv_ver_num

	libssh_version: CE_POINTER [INTEGER_8] assign set_libssh_version

feature {ANY} -- setters

	set_age (a_age: NATURAL_32)
		do
			age := a_age
			update_memory_field ("age")
		end

	set_version (a_version: CE_POINTER [INTEGER_8])
		do
			version := a_version
			update_memory_field ("version")
		end

	set_version_num (a_version_num: NATURAL_32)
		do
			version_num := a_version_num
			update_memory_field ("version_num")
		end

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			host := a_host
			update_memory_field ("host")
		end

	set_features (a_features: INTEGER_32)
		do
			features := a_features
			update_memory_field ("features")
		end

	set_ssl_version (a_ssl_version: CE_POINTER [INTEGER_8])
		do
			ssl_version := a_ssl_version
			update_memory_field ("ssl_version")
		end

	set_ssl_version_num (a_ssl_version_num: INTEGER_32)
		do
			ssl_version_num := a_ssl_version_num
			update_memory_field ("ssl_version_num")
		end

	set_libz_version (a_libz_version: CE_POINTER [INTEGER_8])
		do
			libz_version := a_libz_version
			update_memory_field ("libz_version")
		end

	set_protocols (a_protocols: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			protocols := a_protocols
			update_memory_field ("protocols")
		end

	set_ares (a_ares: CE_POINTER [INTEGER_8])
		do
			ares := a_ares
			update_memory_field ("ares")
		end

	set_ares_num (a_ares_num: INTEGER_32)
		do
			ares_num := a_ares_num
			update_memory_field ("ares_num")
		end

	set_libidn (a_libidn: CE_POINTER [INTEGER_8])
		do
			libidn := a_libidn
			update_memory_field ("libidn")
		end

	set_iconv_ver_num (a_iconv_ver_num: INTEGER_32)
		do
			iconv_ver_num := a_iconv_ver_num
			update_memory_field ("iconv_ver_num")
		end

	set_libssh_version (a_libssh_version: CE_POINTER [INTEGER_8])
		do
			libssh_version := a_libssh_version
			update_memory_field ("libssh_version")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			age := a_other.age
			version := a_other.version
			version_num := a_other.version_num
			host := a_other.host
			features := a_other.features
			ssl_version := a_other.ssl_version
			ssl_version_num := a_other.ssl_version_num
			libz_version := a_other.libz_version
			protocols := a_other.protocols
			ares := a_other.ares
			ares_num := a_other.ares_num
			libidn := a_other.libidn
			iconv_ver_num := a_other.iconv_ver_num
			libssh_version := a_other.libssh_version
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				age = a_other.age and
				version.is_equal (a_other.version) and
				version_num = a_other.version_num and
				host.is_equal (a_other.host) and
				features = a_other.features and
				ssl_version.is_equal (a_other.ssl_version) and
				ssl_version_num = a_other.ssl_version_num and
				libz_version.is_equal (a_other.libz_version) and
				protocols.is_equal (a_other.protocols) and
				ares.is_equal (a_other.ares) and
				ares_num = a_other.ares_num and
				libidn.is_equal (a_other.libidn) and
				iconv_ver_num = a_other.iconv_ver_num and
				libssh_version.is_equal (a_other.libssh_version)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("age"),
					create {CE_STRUCTURE_FIELD}.make ("version"),
					create {CE_STRUCTURE_FIELD}.make ("version_num"),
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("features"),
					create {CE_STRUCTURE_FIELD}.make ("ssl_version"),
					create {CE_STRUCTURE_FIELD}.make ("ssl_version_num"),
					create {CE_STRUCTURE_FIELD}.make ("libz_version"),
					create {CE_STRUCTURE_FIELD}.make ("protocols"),
					create {CE_STRUCTURE_FIELD}.make ("ares"),
					create {CE_STRUCTURE_FIELD}.make ("ares_num"),
					create {CE_STRUCTURE_FIELD}.make ("libidn"),
					create {CE_STRUCTURE_FIELD}.make ("iconv_ver_num"),
					create {CE_STRUCTURE_FIELD}.make ("libssh_version")
				>>)
			init_structure_info
		end

end
