class
	PD_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	str: CE_POINTER [INTEGER_8] assign set_str

	ptr: CE_POINTER [ANY] assign set_ptr

	num: PD_NUM assign set_num

	dnum: REAL_64 assign set_dnum

feature {ANY} -- setters

	set_str (a_str: CE_POINTER [INTEGER_8])
		do
			str := a_str
			update_memory_field ("str")
		end

	set_ptr (a_ptr: CE_POINTER [ANY])
		do
			ptr := a_ptr
			update_memory_field ("ptr")
		end

	set_num (a_num: PD_NUM)
		do
			num := a_num
			update_memory_field ("num")
		end

	set_dnum (a_dnum: REAL_64)
		do
			dnum := a_dnum
			update_memory_field ("dnum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			str := a_other.str
			ptr := a_other.ptr
			num := a_other.num.twin
			dnum := a_other.dnum
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				str.is_equal (a_other.str) and
				ptr.is_equal (a_other.ptr) and
				num.is_equal (a_other.num) and
				dnum = a_other.dnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("str"),
					create {CE_STRUCTURE_FIELD}.make ("ptr"),
					create {CE_STRUCTURE_FIELD}.make ("num"),
					create {CE_STRUCTURE_FIELD}.make ("dnum")
				>>)
			init_structure_info
		end

end
