class
	PD_DLEN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	sig: INTEGER_32 assign set_sig

	uns: NATURAL_32 assign set_uns

feature {ANY} -- setters

	set_sig (a_sig: INTEGER_32)
		do
			sig := a_sig
			update_memory_field ("sig")
		end

	set_uns (a_uns: NATURAL_32)
		do
			uns := a_uns
			update_memory_field ("uns")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sig := a_other.sig
			uns := a_other.uns
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sig = a_other.sig and
				uns = a_other.uns
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("sig"),
					create {CE_STRUCTURE_FIELD}.make ("uns")
				>>)
			init_structure_info
		end

end
