class
	PD_FILEPROTO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create path.make
			create freepath.make
		end

feature {ANY} -- fields

	path: CE_POINTER [INTEGER_8] assign set_path

	freepath: CE_POINTER [INTEGER_8] assign set_freepath

	fd: INTEGER_32 assign set_fd

feature {ANY} -- setters

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			path := a_path
			update_memory_field ("path")
		end

	set_freepath (a_freepath: CE_POINTER [INTEGER_8])
		do
			freepath := a_freepath
			update_memory_field ("freepath")
		end

	set_fd (a_fd: INTEGER_32)
		do
			fd := a_fd
			update_memory_field ("fd")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			path := a_other.path
			freepath := a_other.freepath
			fd := a_other.fd
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				path.is_equal (a_other.path) and
				freepath.is_equal (a_other.freepath) and
				fd = a_other.fd
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("path"),
					create {CE_STRUCTURE_FIELD}.make ("freepath"),
					create {CE_STRUCTURE_FIELD}.make ("fd")
				>>)
			init_structure_info
		end

end
