class
	PD_FORMINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create value.make
			create contenttype.make
			create buffer.make
			create showfilename.make
			create userp.make
			create contentheader.make
			create more.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	name_alloc: BOOLEAN assign set_name_alloc

	namelength: NATURAL_32 assign set_namelength

	value: CE_POINTER [INTEGER_8] assign set_value

	value_alloc: BOOLEAN assign set_value_alloc

	contentslength: NATURAL_32 assign set_contentslength

	contenttype: CE_POINTER [INTEGER_8] assign set_contenttype

	contenttype_alloc: BOOLEAN assign set_contenttype_alloc

	flags: INTEGER_32 assign set_flags

	buffer: CE_POINTER [INTEGER_8] assign set_buffer

	bufferlength: NATURAL_32 assign set_bufferlength

	showfilename: CE_POINTER [INTEGER_8] assign set_showfilename

	showfilename_alloc: BOOLEAN assign set_showfilename_alloc

	userp: CE_POINTER [INTEGER_8] assign set_userp

	contentheader: CE_POINTER [PD_CURL_SLIST] assign set_contentheader

	more: CE_POINTER [PD_FORMINFO] assign set_more

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_name_alloc (a_name_alloc: BOOLEAN)
		do
			name_alloc := a_name_alloc
			update_memory_field ("name_alloc")
		end

	set_namelength (a_namelength: NATURAL_32)
		do
			namelength := a_namelength
			update_memory_field ("namelength")
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_value_alloc (a_value_alloc: BOOLEAN)
		do
			value_alloc := a_value_alloc
			update_memory_field ("value_alloc")
		end

	set_contentslength (a_contentslength: NATURAL_32)
		do
			contentslength := a_contentslength
			update_memory_field ("contentslength")
		end

	set_contenttype (a_contenttype: CE_POINTER [INTEGER_8])
		do
			contenttype := a_contenttype
			update_memory_field ("contenttype")
		end

	set_contenttype_alloc (a_contenttype_alloc: BOOLEAN)
		do
			contenttype_alloc := a_contenttype_alloc
			update_memory_field ("contenttype_alloc")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_bufferlength (a_bufferlength: NATURAL_32)
		do
			bufferlength := a_bufferlength
			update_memory_field ("bufferlength")
		end

	set_showfilename (a_showfilename: CE_POINTER [INTEGER_8])
		do
			showfilename := a_showfilename
			update_memory_field ("showfilename")
		end

	set_showfilename_alloc (a_showfilename_alloc: BOOLEAN)
		do
			showfilename_alloc := a_showfilename_alloc
			update_memory_field ("showfilename_alloc")
		end

	set_userp (a_userp: CE_POINTER [INTEGER_8])
		do
			userp := a_userp
			update_memory_field ("userp")
		end

	set_contentheader (a_contentheader: CE_POINTER [PD_CURL_SLIST])
		do
			contentheader := a_contentheader
			update_memory_field ("contentheader")
		end

	set_more (a_more: CE_POINTER [PD_FORMINFO])
		do
			more := a_more
			update_memory_field ("more")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			name_alloc := a_other.name_alloc
			namelength := a_other.namelength
			value := a_other.value
			value_alloc := a_other.value_alloc
			contentslength := a_other.contentslength
			contenttype := a_other.contenttype
			contenttype_alloc := a_other.contenttype_alloc
			flags := a_other.flags
			buffer := a_other.buffer
			bufferlength := a_other.bufferlength
			showfilename := a_other.showfilename
			showfilename_alloc := a_other.showfilename_alloc
			userp := a_other.userp
			contentheader := a_other.contentheader
			more := a_other.more
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				name_alloc = a_other.name_alloc and
				namelength = a_other.namelength and
				value.is_equal (a_other.value) and
				value_alloc = a_other.value_alloc and
				contentslength = a_other.contentslength and
				contenttype.is_equal (a_other.contenttype) and
				contenttype_alloc = a_other.contenttype_alloc and
				flags = a_other.flags and
				buffer.is_equal (a_other.buffer) and
				bufferlength = a_other.bufferlength and
				showfilename.is_equal (a_other.showfilename) and
				showfilename_alloc = a_other.showfilename_alloc and
				userp.is_equal (a_other.userp) and
				contentheader.is_equal (a_other.contentheader) and
				more.is_equal (a_other.more)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("name_alloc"),
					create {CE_STRUCTURE_FIELD}.make ("namelength"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("value_alloc"),
					create {CE_STRUCTURE_FIELD}.make ("contentslength"),
					create {CE_STRUCTURE_FIELD}.make ("contenttype"),
					create {CE_STRUCTURE_FIELD}.make ("contenttype_alloc"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("bufferlength"),
					create {CE_STRUCTURE_FIELD}.make ("showfilename"),
					create {CE_STRUCTURE_FIELD}.make ("showfilename_alloc"),
					create {CE_STRUCTURE_FIELD}.make ("userp"),
					create {CE_STRUCTURE_FIELD}.make ("contentheader"),
					create {CE_STRUCTURE_FIELD}.make ("more")
				>>)
			init_structure_info
		end

end
