class
	PD_HMAC_CONTEXT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create hmac_hash.make
			create hmac_hashctxt1.make
			create hmac_hashctxt2.make
		end

feature {ANY} -- fields

	hmac_hash: CE_POINTER [PD_HMAC_PARAMS] assign set_hmac_hash

	hmac_hashctxt1: CE_POINTER [ANY] assign set_hmac_hashctxt1

	hmac_hashctxt2: CE_POINTER [ANY] assign set_hmac_hashctxt2

feature {ANY} -- setters

	set_hmac_hash (a_hmac_hash: CE_POINTER [PD_HMAC_PARAMS])
		do
			hmac_hash := a_hmac_hash
			update_memory_field ("hmac_hash")
		end

	set_hmac_hashctxt1 (a_hmac_hashctxt1: CE_POINTER [ANY])
		do
			hmac_hashctxt1 := a_hmac_hashctxt1
			update_memory_field ("hmac_hashctxt1")
		end

	set_hmac_hashctxt2 (a_hmac_hashctxt2: CE_POINTER [ANY])
		do
			hmac_hashctxt2 := a_hmac_hashctxt2
			update_memory_field ("hmac_hashctxt2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hmac_hash := a_other.hmac_hash
			hmac_hashctxt1 := a_other.hmac_hashctxt1
			hmac_hashctxt2 := a_other.hmac_hashctxt2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hmac_hash.is_equal (a_other.hmac_hash) and
				hmac_hashctxt1.is_equal (a_other.hmac_hashctxt1) and
				hmac_hashctxt2.is_equal (a_other.hmac_hashctxt2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hmac_hash"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_hashctxt1"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_hashctxt2")
				>>)
			init_structure_info
		end

end
