class
	PD_HMAC_PARAMS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create hmac_hinit.make
			create hmac_hupdate.make
			create hmac_hfinal.make
		end

feature {ANY} -- fields

	hmac_hinit: CE_ROUTINE assign set_hmac_hinit

	hmac_hupdate: CE_ROUTINE assign set_hmac_hupdate

	hmac_hfinal: CE_ROUTINE assign set_hmac_hfinal

	hmac_ctxtsize: NATURAL_32 assign set_hmac_ctxtsize

	hmac_maxkeylen: NATURAL_32 assign set_hmac_maxkeylen

	hmac_resultlen: NATURAL_32 assign set_hmac_resultlen

feature {ANY} -- setters

	set_hmac_hinit (a_hmac_hinit: CE_ROUTINE)
		do
			hmac_hinit := a_hmac_hinit
			update_memory_field ("hmac_hinit")
		end

	set_hmac_hupdate (a_hmac_hupdate: CE_ROUTINE)
		do
			hmac_hupdate := a_hmac_hupdate
			update_memory_field ("hmac_hupdate")
		end

	set_hmac_hfinal (a_hmac_hfinal: CE_ROUTINE)
		do
			hmac_hfinal := a_hmac_hfinal
			update_memory_field ("hmac_hfinal")
		end

	set_hmac_ctxtsize (a_hmac_ctxtsize: NATURAL_32)
		do
			hmac_ctxtsize := a_hmac_ctxtsize
			update_memory_field ("hmac_ctxtsize")
		end

	set_hmac_maxkeylen (a_hmac_maxkeylen: NATURAL_32)
		do
			hmac_maxkeylen := a_hmac_maxkeylen
			update_memory_field ("hmac_maxkeylen")
		end

	set_hmac_resultlen (a_hmac_resultlen: NATURAL_32)
		do
			hmac_resultlen := a_hmac_resultlen
			update_memory_field ("hmac_resultlen")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hmac_hinit := a_other.hmac_hinit
			hmac_hupdate := a_other.hmac_hupdate
			hmac_hfinal := a_other.hmac_hfinal
			hmac_ctxtsize := a_other.hmac_ctxtsize
			hmac_maxkeylen := a_other.hmac_maxkeylen
			hmac_resultlen := a_other.hmac_resultlen
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hmac_hinit.is_equal (a_other.hmac_hinit) and
				hmac_hupdate.is_equal (a_other.hmac_hupdate) and
				hmac_hfinal.is_equal (a_other.hmac_hfinal) and
				hmac_ctxtsize = a_other.hmac_ctxtsize and
				hmac_maxkeylen = a_other.hmac_maxkeylen and
				hmac_resultlen = a_other.hmac_resultlen
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hmac_hinit"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_hupdate"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_hfinal"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_ctxtsize"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_maxkeylen"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_resultlen")
				>>)
			init_structure_info
		end

end
