class
	PD_HOSTCACHE_PRUNE_DATA

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	cache_timeout: INTEGER_32 assign set_cache_timeout

	now: INTEGER_32 assign set_now

feature {ANY} -- setters

	set_cache_timeout (a_cache_timeout: INTEGER_32)
		do
			cache_timeout := a_cache_timeout
			update_memory_field ("cache_timeout")
		end

	set_now (a_now: INTEGER_32)
		do
			now := a_now
			update_memory_field ("now")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cache_timeout := a_other.cache_timeout
			now := a_other.now
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cache_timeout = a_other.cache_timeout and
				now = a_other.now
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cache_timeout"),
					create {CE_STRUCTURE_FIELD}.make ("now")
				>>)
			init_structure_info
		end

end
