class
	PD_IMAP_CONN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pp.make
			create mailbox.make
			create idstr.make
		end

feature {ANY} -- fields

	pp: PD_PINGPONG assign set_pp

	mailbox: CE_POINTER [INTEGER_8] assign set_mailbox

	state: NATURAL_32 assign set_state

	cmdid: INTEGER_32 assign set_cmdid

	idstr: CE_POINTER [INTEGER_8] assign set_idstr

feature {ANY} -- setters

	set_pp (a_pp: PD_PINGPONG)
		do
			pp := a_pp
			update_memory_field ("pp")
		end

	set_mailbox (a_mailbox: CE_POINTER [INTEGER_8])
		do
			mailbox := a_mailbox
			update_memory_field ("mailbox")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_cmdid (a_cmdid: INTEGER_32)
		do
			cmdid := a_cmdid
			update_memory_field ("cmdid")
		end

	set_idstr (a_idstr: CE_POINTER [INTEGER_8])
		do
			idstr := a_idstr
			update_memory_field ("idstr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pp := a_other.pp.twin
			mailbox := a_other.mailbox
			state := a_other.state
			cmdid := a_other.cmdid
			idstr := a_other.idstr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pp.is_equal (a_other.pp) and
				mailbox.is_equal (a_other.mailbox) and
				state = a_other.state and
				cmdid = a_other.cmdid and
				idstr.is_equal (a_other.idstr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pp"),
					create {CE_STRUCTURE_FIELD}.make ("mailbox"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("cmdid"),
					create {CE_STRUCTURE_FIELD}.make ("idstr")
				>>)
			init_structure_info
		end

end
