class
	PD_MY_TM

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	tm_sec: INTEGER_32 assign set_tm_sec

	tm_min: INTEGER_32 assign set_tm_min

	tm_hour: INTEGER_32 assign set_tm_hour

	tm_mday: INTEGER_32 assign set_tm_mday

	tm_mon: INTEGER_32 assign set_tm_mon

	tm_year: INTEGER_32 assign set_tm_year

feature {ANY} -- setters

	set_tm_sec (a_tm_sec: INTEGER_32)
		do
			tm_sec := a_tm_sec
			update_memory_field ("tm_sec")
		end

	set_tm_min (a_tm_min: INTEGER_32)
		do
			tm_min := a_tm_min
			update_memory_field ("tm_min")
		end

	set_tm_hour (a_tm_hour: INTEGER_32)
		do
			tm_hour := a_tm_hour
			update_memory_field ("tm_hour")
		end

	set_tm_mday (a_tm_mday: INTEGER_32)
		do
			tm_mday := a_tm_mday
			update_memory_field ("tm_mday")
		end

	set_tm_mon (a_tm_mon: INTEGER_32)
		do
			tm_mon := a_tm_mon
			update_memory_field ("tm_mon")
		end

	set_tm_year (a_tm_year: INTEGER_32)
		do
			tm_year := a_tm_year
			update_memory_field ("tm_year")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tm_sec := a_other.tm_sec
			tm_min := a_other.tm_min
			tm_hour := a_other.tm_hour
			tm_mday := a_other.tm_mday
			tm_mon := a_other.tm_mon
			tm_year := a_other.tm_year
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tm_sec = a_other.tm_sec and
				tm_min = a_other.tm_min and
				tm_hour = a_other.tm_hour and
				tm_mday = a_other.tm_mday and
				tm_mon = a_other.tm_mon and
				tm_year = a_other.tm_year
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tm_sec"),
					create {CE_STRUCTURE_FIELD}.make ("tm_min"),
					create {CE_STRUCTURE_FIELD}.make ("tm_hour"),
					create {CE_STRUCTURE_FIELD}.make ("tm_mday"),
					create {CE_STRUCTURE_FIELD}.make ("tm_mon"),
					create {CE_STRUCTURE_FIELD}.make ("tm_year")
				>>)
			init_structure_info
		end

end
