class
	PD_NSPRINTF

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create buffer.make
		end

feature {ANY} -- fields

	buffer: CE_POINTER [INTEGER_8] assign set_buffer

	length: NATURAL_32 assign set_length

	max: NATURAL_32 assign set_max

feature {ANY} -- setters

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_length (a_length: NATURAL_32)
		do
			length := a_length
			update_memory_field ("length")
		end

	set_max (a_max: NATURAL_32)
		do
			max := a_max
			update_memory_field ("max")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buffer := a_other.buffer
			length := a_other.length
			max := a_other.max
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buffer.is_equal (a_other.buffer) and
				length = a_other.length and
				max = a_other.max
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("length"),
					create {CE_STRUCTURE_FIELD}.make ("max")
				>>)
			init_structure_info
		end

end
