class
	PD_NTLMDATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create nonce.make (<<8>>)
		end

feature {ANY} -- fields

	state: NATURAL_32 assign set_state

	flags: NATURAL_32 assign set_flags

	nonce: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_flags (a_flags: NATURAL_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			state := a_other.state
			flags := a_other.flags
			nonce := a_other.nonce.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				state = a_other.state and
				flags = a_other.flags and
				nonce.is_equal (a_other.nonce)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("nonce", <<8>>)
				>>)
			init_structure_info
		end

end
