class
	PD_PINGPONG

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create cache.make
			create linestart_resp.make
			create sendthis.make
			create response.make
			create conn.make
			create statemach_act.make
			create endofresp.make
		end

feature {ANY} -- fields

	cache: CE_POINTER [INTEGER_8] assign set_cache

	cache_size: NATURAL_32 assign set_cache_size

	nread_resp: NATURAL_32 assign set_nread_resp

	linestart_resp: CE_POINTER [INTEGER_8] assign set_linestart_resp

	pending_resp: BOOLEAN assign set_pending_resp

	sendthis: CE_POINTER [INTEGER_8] assign set_sendthis

	sendleft: NATURAL_32 assign set_sendleft

	sendsize: NATURAL_32 assign set_sendsize

	response: SD_TIMEVAL assign set_response

	response_time: INTEGER_32 assign set_response_time

	conn: CE_POINTER [PD_CONNECTDATA] assign set_conn

	statemach_act: CE_ROUTINE assign set_statemach_act

	endofresp: CE_ROUTINE assign set_endofresp

feature {ANY} -- setters

	set_cache (a_cache: CE_POINTER [INTEGER_8])
		do
			cache := a_cache
			update_memory_field ("cache")
		end

	set_cache_size (a_cache_size: NATURAL_32)
		do
			cache_size := a_cache_size
			update_memory_field ("cache_size")
		end

	set_nread_resp (a_nread_resp: NATURAL_32)
		do
			nread_resp := a_nread_resp
			update_memory_field ("nread_resp")
		end

	set_linestart_resp (a_linestart_resp: CE_POINTER [INTEGER_8])
		do
			linestart_resp := a_linestart_resp
			update_memory_field ("linestart_resp")
		end

	set_pending_resp (a_pending_resp: BOOLEAN)
		do
			pending_resp := a_pending_resp
			update_memory_field ("pending_resp")
		end

	set_sendthis (a_sendthis: CE_POINTER [INTEGER_8])
		do
			sendthis := a_sendthis
			update_memory_field ("sendthis")
		end

	set_sendleft (a_sendleft: NATURAL_32)
		do
			sendleft := a_sendleft
			update_memory_field ("sendleft")
		end

	set_sendsize (a_sendsize: NATURAL_32)
		do
			sendsize := a_sendsize
			update_memory_field ("sendsize")
		end

	set_response (a_response: SD_TIMEVAL)
		do
			response := a_response
			update_memory_field ("response")
		end

	set_response_time (a_response_time: INTEGER_32)
		do
			response_time := a_response_time
			update_memory_field ("response_time")
		end

	set_conn (a_conn: CE_POINTER [PD_CONNECTDATA])
		do
			conn := a_conn
			update_memory_field ("conn")
		end

	set_statemach_act (a_statemach_act: CE_ROUTINE)
		do
			statemach_act := a_statemach_act
			update_memory_field ("statemach_act")
		end

	set_endofresp (a_endofresp: CE_ROUTINE)
		do
			endofresp := a_endofresp
			update_memory_field ("endofresp")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cache := a_other.cache
			cache_size := a_other.cache_size
			nread_resp := a_other.nread_resp
			linestart_resp := a_other.linestart_resp
			pending_resp := a_other.pending_resp
			sendthis := a_other.sendthis
			sendleft := a_other.sendleft
			sendsize := a_other.sendsize
			response := a_other.response.twin
			response_time := a_other.response_time
			conn := a_other.conn
			statemach_act := a_other.statemach_act
			endofresp := a_other.endofresp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cache.is_equal (a_other.cache) and
				cache_size = a_other.cache_size and
				nread_resp = a_other.nread_resp and
				linestart_resp.is_equal (a_other.linestart_resp) and
				pending_resp = a_other.pending_resp and
				sendthis.is_equal (a_other.sendthis) and
				sendleft = a_other.sendleft and
				sendsize = a_other.sendsize and
				response.is_equal (a_other.response) and
				response_time = a_other.response_time and
				conn.is_equal (a_other.conn) and
				statemach_act.is_equal (a_other.statemach_act) and
				endofresp.is_equal (a_other.endofresp)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cache"),
					create {CE_STRUCTURE_FIELD}.make ("cache_size"),
					create {CE_STRUCTURE_FIELD}.make ("nread_resp"),
					create {CE_STRUCTURE_FIELD}.make ("linestart_resp"),
					create {CE_STRUCTURE_FIELD}.make ("pending_resp"),
					create {CE_STRUCTURE_FIELD}.make ("sendthis"),
					create {CE_STRUCTURE_FIELD}.make ("sendleft"),
					create {CE_STRUCTURE_FIELD}.make ("sendsize"),
					create {CE_STRUCTURE_FIELD}.make ("response"),
					create {CE_STRUCTURE_FIELD}.make ("response_time"),
					create {CE_STRUCTURE_FIELD}.make ("conn"),
					create {CE_STRUCTURE_FIELD}.make ("statemach_act"),
					create {CE_STRUCTURE_FIELD}.make ("endofresp")
				>>)
			init_structure_info
		end

end
