class
	PD_PL_UNIX_SUBSTATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	total_dirsize: NATURAL_32 assign set_total_dirsize

	hlinks: NATURAL_32 assign set_hlinks

	user: NATURAL_32 assign set_user

	group: NATURAL_32 assign set_group

	size: NATURAL_32 assign set_size

	time: NATURAL_32 assign set_time

	filename: NATURAL_32 assign set_filename

	symlink: NATURAL_32 assign set_symlink

feature {ANY} -- setters

	set_total_dirsize (a_total_dirsize: NATURAL_32)
		do
			total_dirsize := a_total_dirsize
			update_memory_field ("total_dirsize")
		end

	set_hlinks (a_hlinks: NATURAL_32)
		do
			hlinks := a_hlinks
			update_memory_field ("hlinks")
		end

	set_user (a_user: NATURAL_32)
		do
			user := a_user
			update_memory_field ("user")
		end

	set_group (a_group: NATURAL_32)
		do
			group := a_group
			update_memory_field ("group")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_filename (a_filename: NATURAL_32)
		do
			filename := a_filename
			update_memory_field ("filename")
		end

	set_symlink (a_symlink: NATURAL_32)
		do
			symlink := a_symlink
			update_memory_field ("symlink")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			total_dirsize := a_other.total_dirsize
			hlinks := a_other.hlinks
			user := a_other.user
			group := a_other.group
			size := a_other.size
			time := a_other.time
			filename := a_other.filename
			symlink := a_other.symlink
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				total_dirsize = a_other.total_dirsize and
				hlinks = a_other.hlinks and
				user = a_other.user and
				group = a_other.group and
				size = a_other.size and
				time = a_other.time and
				filename = a_other.filename and
				symlink = a_other.symlink
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("total_dirsize"),
					create {CE_STRUCTURE_FIELD}.make ("hlinks"),
					create {CE_STRUCTURE_FIELD}.make ("user"),
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("filename"),
					create {CE_STRUCTURE_FIELD}.make ("symlink")
				>>)
			init_structure_info
		end

end
