class
	PD_PL_WINNT_SUBSTATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	time: NATURAL_32 assign set_time

	dirorsize: NATURAL_32 assign set_dirorsize

	filename: NATURAL_32 assign set_filename

feature {ANY} -- setters

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_dirorsize (a_dirorsize: NATURAL_32)
		do
			dirorsize := a_dirorsize
			update_memory_field ("dirorsize")
		end

	set_filename (a_filename: NATURAL_32)
		do
			filename := a_filename
			update_memory_field ("filename")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			time := a_other.time
			dirorsize := a_other.dirorsize
			filename := a_other.filename
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				time = a_other.time and
				dirorsize = a_other.dirorsize and
				filename = a_other.filename
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("dirorsize"),
					create {CE_STRUCTURE_FIELD}.make ("filename")
				>>)
			init_structure_info
		end

end
