class
	PD_PROTO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	ftpc: PD_FTP_CONN assign set_ftpc

	sshc: PD_SSH_CONN assign set_sshc

	tftpc: CE_POINTER [PD_TFTP_STATE_DATA] assign set_tftpc

	imapc: PD_IMAP_CONN assign set_imapc

	pop3c: PD_POP3_CONN assign set_pop3c

	smtpc: PD_SMTP_CONN assign set_smtpc

	rtspc: PD_RTSP_CONN assign set_rtspc

	generic: CE_POINTER [ANY] assign set_generic

feature {ANY} -- setters

	set_ftpc (a_ftpc: PD_FTP_CONN)
		do
			ftpc := a_ftpc
			update_memory_field ("ftpc")
		end

	set_sshc (a_sshc: PD_SSH_CONN)
		do
			sshc := a_sshc
			update_memory_field ("sshc")
		end

	set_tftpc (a_tftpc: CE_POINTER [PD_TFTP_STATE_DATA])
		do
			tftpc := a_tftpc
			update_memory_field ("tftpc")
		end

	set_imapc (a_imapc: PD_IMAP_CONN)
		do
			imapc := a_imapc
			update_memory_field ("imapc")
		end

	set_pop3c (a_pop3c: PD_POP3_CONN)
		do
			pop3c := a_pop3c
			update_memory_field ("pop3c")
		end

	set_smtpc (a_smtpc: PD_SMTP_CONN)
		do
			smtpc := a_smtpc
			update_memory_field ("smtpc")
		end

	set_rtspc (a_rtspc: PD_RTSP_CONN)
		do
			rtspc := a_rtspc
			update_memory_field ("rtspc")
		end

	set_generic (a_generic: CE_POINTER [ANY])
		do
			generic := a_generic
			update_memory_field ("generic")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ftpc := a_other.ftpc.twin
			sshc := a_other.sshc.twin
			tftpc := a_other.tftpc
			imapc := a_other.imapc.twin
			pop3c := a_other.pop3c.twin
			smtpc := a_other.smtpc.twin
			rtspc := a_other.rtspc.twin
			generic := a_other.generic
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ftpc.is_equal (a_other.ftpc) and
				sshc.is_equal (a_other.sshc) and
				tftpc.is_equal (a_other.tftpc) and
				imapc.is_equal (a_other.imapc) and
				pop3c.is_equal (a_other.pop3c) and
				smtpc.is_equal (a_other.smtpc) and
				rtspc.is_equal (a_other.rtspc) and
				generic.is_equal (a_other.generic)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("ftpc"),
					create {CE_STRUCTURE_FIELD}.make ("sshc"),
					create {CE_STRUCTURE_FIELD}.make ("tftpc"),
					create {CE_STRUCTURE_FIELD}.make ("imapc"),
					create {CE_STRUCTURE_FIELD}.make ("pop3c"),
					create {CE_STRUCTURE_FIELD}.make ("smtpc"),
					create {CE_STRUCTURE_FIELD}.make ("rtspc"),
					create {CE_STRUCTURE_FIELD}.make ("generic")
				>>)
			init_structure_info
		end

end
