class
	PD_PTR

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	to_certinfo: CE_POINTER [PD_CURL_CERTINFO] assign set_to_certinfo

	to_slist: CE_POINTER [PD_CURL_SLIST] assign set_to_slist

feature {ANY} -- setters

	set_to_certinfo (a_to_certinfo: CE_POINTER [PD_CURL_CERTINFO])
		do
			to_certinfo := a_to_certinfo
			update_memory_field ("to_certinfo")
		end

	set_to_slist (a_to_slist: CE_POINTER [PD_CURL_SLIST])
		do
			to_slist := a_to_slist
			update_memory_field ("to_slist")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			to_certinfo := a_other.to_certinfo
			to_slist := a_other.to_slist
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				to_certinfo.is_equal (a_other.to_certinfo) and
				to_slist.is_equal (a_other.to_slist)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("to_certinfo"),
					create {CE_STRUCTURE_FIELD}.make ("to_slist")
				>>)
			init_structure_info
		end

end
