class
	PD_SMTP_CONN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pp.make
			create domain.make
			create rcpt.make
		end

feature {ANY} -- fields

	pp: PD_PINGPONG assign set_pp

	domain: CE_POINTER [INTEGER_8] assign set_domain

	eob: NATURAL_32 assign set_eob

	authmechs: NATURAL_32 assign set_authmechs

	state: NATURAL_32 assign set_state

	rcpt: CE_POINTER [PD_CURL_SLIST] assign set_rcpt

feature {ANY} -- setters

	set_pp (a_pp: PD_PINGPONG)
		do
			pp := a_pp
			update_memory_field ("pp")
		end

	set_domain (a_domain: CE_POINTER [INTEGER_8])
		do
			domain := a_domain
			update_memory_field ("domain")
		end

	set_eob (a_eob: NATURAL_32)
		do
			eob := a_eob
			update_memory_field ("eob")
		end

	set_authmechs (a_authmechs: NATURAL_32)
		do
			authmechs := a_authmechs
			update_memory_field ("authmechs")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_rcpt (a_rcpt: CE_POINTER [PD_CURL_SLIST])
		do
			rcpt := a_rcpt
			update_memory_field ("rcpt")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pp := a_other.pp.twin
			domain := a_other.domain
			eob := a_other.eob
			authmechs := a_other.authmechs
			state := a_other.state
			rcpt := a_other.rcpt
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pp.is_equal (a_other.pp) and
				domain.is_equal (a_other.domain) and
				eob = a_other.eob and
				authmechs = a_other.authmechs and
				state = a_other.state and
				rcpt.is_equal (a_other.rcpt)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pp"),
					create {CE_STRUCTURE_FIELD}.make ("domain"),
					create {CE_STRUCTURE_FIELD}.make ("eob"),
					create {CE_STRUCTURE_FIELD}.make ("authmechs"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("rcpt")
				>>)
			init_structure_info
		end

end
