class
	PD_TFTP_STATE_DATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create conn.make
			create local_addr.make
			create remote_addr.make
			create rpacket.make
			create spacket.make
		end

feature {ANY} -- fields

	state: NATURAL_32 assign set_state

	mode: NATURAL_32 assign set_mode

	error: INTEGER_32 assign set_error

	event: INTEGER_32 assign set_event

	conn: CE_POINTER [PD_CONNECTDATA] assign set_conn

	sockfd: INTEGER_32 assign set_sockfd

	retries: INTEGER_32 assign set_retries

	retry_time: INTEGER_32 assign set_retry_time

	retry_max: INTEGER_32 assign set_retry_max

	start_time: INTEGER_32 assign set_start_time

	max_time: INTEGER_32 assign set_max_time

	rx_time: INTEGER_32 assign set_rx_time

	block: NATURAL_16 assign set_block

	local_addr: PD_CURL_SOCKADDR_STORAGE assign set_local_addr

	remote_addr: PD_CURL_SOCKADDR_STORAGE assign set_remote_addr

	remote_addrlen: NATURAL_32 assign set_remote_addrlen

	rbytes: INTEGER_32 assign set_rbytes

	sbytes: INTEGER_32 assign set_sbytes

	blksize: INTEGER_32 assign set_blksize

	requested_blksize: INTEGER_32 assign set_requested_blksize

	rpacket: PD_TFTP_PACKET assign set_rpacket

	spacket: PD_TFTP_PACKET assign set_spacket

feature {ANY} -- setters

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_mode (a_mode: NATURAL_32)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_error (a_error: INTEGER_32)
		do
			error := a_error
			update_memory_field ("error")
		end

	set_event (a_event: INTEGER_32)
		do
			event := a_event
			update_memory_field ("event")
		end

	set_conn (a_conn: CE_POINTER [PD_CONNECTDATA])
		do
			conn := a_conn
			update_memory_field ("conn")
		end

	set_sockfd (a_sockfd: INTEGER_32)
		do
			sockfd := a_sockfd
			update_memory_field ("sockfd")
		end

	set_retries (a_retries: INTEGER_32)
		do
			retries := a_retries
			update_memory_field ("retries")
		end

	set_retry_time (a_retry_time: INTEGER_32)
		do
			retry_time := a_retry_time
			update_memory_field ("retry_time")
		end

	set_retry_max (a_retry_max: INTEGER_32)
		do
			retry_max := a_retry_max
			update_memory_field ("retry_max")
		end

	set_start_time (a_start_time: INTEGER_32)
		do
			start_time := a_start_time
			update_memory_field ("start_time")
		end

	set_max_time (a_max_time: INTEGER_32)
		do
			max_time := a_max_time
			update_memory_field ("max_time")
		end

	set_rx_time (a_rx_time: INTEGER_32)
		do
			rx_time := a_rx_time
			update_memory_field ("rx_time")
		end

	set_block (a_block: NATURAL_16)
		do
			block := a_block
			update_memory_field ("block")
		end

	set_local_addr (a_local_addr: PD_CURL_SOCKADDR_STORAGE)
		do
			local_addr := a_local_addr
			update_memory_field ("local_addr")
		end

	set_remote_addr (a_remote_addr: PD_CURL_SOCKADDR_STORAGE)
		do
			remote_addr := a_remote_addr
			update_memory_field ("remote_addr")
		end

	set_remote_addrlen (a_remote_addrlen: NATURAL_32)
		do
			remote_addrlen := a_remote_addrlen
			update_memory_field ("remote_addrlen")
		end

	set_rbytes (a_rbytes: INTEGER_32)
		do
			rbytes := a_rbytes
			update_memory_field ("rbytes")
		end

	set_sbytes (a_sbytes: INTEGER_32)
		do
			sbytes := a_sbytes
			update_memory_field ("sbytes")
		end

	set_blksize (a_blksize: INTEGER_32)
		do
			blksize := a_blksize
			update_memory_field ("blksize")
		end

	set_requested_blksize (a_requested_blksize: INTEGER_32)
		do
			requested_blksize := a_requested_blksize
			update_memory_field ("requested_blksize")
		end

	set_rpacket (a_rpacket: PD_TFTP_PACKET)
		do
			rpacket := a_rpacket
			update_memory_field ("rpacket")
		end

	set_spacket (a_spacket: PD_TFTP_PACKET)
		do
			spacket := a_spacket
			update_memory_field ("spacket")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			state := a_other.state
			mode := a_other.mode
			error := a_other.error
			event := a_other.event
			conn := a_other.conn
			sockfd := a_other.sockfd
			retries := a_other.retries
			retry_time := a_other.retry_time
			retry_max := a_other.retry_max
			start_time := a_other.start_time
			max_time := a_other.max_time
			rx_time := a_other.rx_time
			block := a_other.block
			local_addr := a_other.local_addr.twin
			remote_addr := a_other.remote_addr.twin
			remote_addrlen := a_other.remote_addrlen
			rbytes := a_other.rbytes
			sbytes := a_other.sbytes
			blksize := a_other.blksize
			requested_blksize := a_other.requested_blksize
			rpacket := a_other.rpacket.twin
			spacket := a_other.spacket.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				state = a_other.state and
				mode = a_other.mode and
				error = a_other.error and
				event = a_other.event and
				conn.is_equal (a_other.conn) and
				sockfd = a_other.sockfd and
				retries = a_other.retries and
				retry_time = a_other.retry_time and
				retry_max = a_other.retry_max and
				start_time = a_other.start_time and
				max_time = a_other.max_time and
				rx_time = a_other.rx_time and
				block = a_other.block and
				local_addr.is_equal (a_other.local_addr) and
				remote_addr.is_equal (a_other.remote_addr) and
				remote_addrlen = a_other.remote_addrlen and
				rbytes = a_other.rbytes and
				sbytes = a_other.sbytes and
				blksize = a_other.blksize and
				requested_blksize = a_other.requested_blksize and
				rpacket.is_equal (a_other.rpacket) and
				spacket.is_equal (a_other.spacket)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("error"),
					create {CE_STRUCTURE_FIELD}.make ("event"),
					create {CE_STRUCTURE_FIELD}.make ("conn"),
					create {CE_STRUCTURE_FIELD}.make ("sockfd"),
					create {CE_STRUCTURE_FIELD}.make ("retries"),
					create {CE_STRUCTURE_FIELD}.make ("retry_time"),
					create {CE_STRUCTURE_FIELD}.make ("retry_max"),
					create {CE_STRUCTURE_FIELD}.make ("start_time"),
					create {CE_STRUCTURE_FIELD}.make ("max_time"),
					create {CE_STRUCTURE_FIELD}.make ("rx_time"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("local_addr"),
					create {CE_STRUCTURE_FIELD}.make ("remote_addr"),
					create {CE_STRUCTURE_FIELD}.make ("remote_addrlen"),
					create {CE_STRUCTURE_FIELD}.make ("rbytes"),
					create {CE_STRUCTURE_FIELD}.make ("sbytes"),
					create {CE_STRUCTURE_FIELD}.make ("blksize"),
					create {CE_STRUCTURE_FIELD}.make ("requested_blksize"),
					create {CE_STRUCTURE_FIELD}.make ("rpacket"),
					create {CE_STRUCTURE_FIELD}.make ("spacket")
				>>)
			init_structure_info
		end

end
