class
	PD_URLSTATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create connc.make
			create keeps_speed.make
			create headerbuff.make
			create buffer.make (<<16_385>>)
			create uploadbuffer.make (<<16_385>>)
			create first_host.make
			create session.make
			create tempwrite.make
			create scratch.make
			create prev_signal.make
			create digest.make
			create proxydigest.make
			create authhost.make
			create authproxy.make
			create expiretime.make
			create timenode.make
			create timeoutlist.make
			create most_recent_ftp_entrypath.make
			create shared_conn.make
			create pathbuffer.make
			create path.make
			create range.make
			create proto.make
			create current_conn.make
		end

feature {ANY} -- fields

	used_interface: NATURAL_32 assign set_used_interface

	connc: CE_POINTER [PD_CONNCACHE] assign set_connc

	keeps_speed: SD_TIMEVAL assign set_keeps_speed

	lastconnect: INTEGER_32 assign set_lastconnect

	headerbuff: CE_POINTER [INTEGER_8] assign set_headerbuff

	headersize: NATURAL_32 assign set_headersize

	buffer: CE_ARRAY [INTEGER_8]

	uploadbuffer: CE_ARRAY [INTEGER_8]

	current_speed: INTEGER_64 assign set_current_speed

	this_is_a_follow: BOOLEAN assign set_this_is_a_follow

	first_host: CE_POINTER [INTEGER_8] assign set_first_host

	session: CE_POINTER [PD_CURL_SSL_SESSION] assign set_session

	sessionage: INTEGER_32 assign set_sessionage

	tempwrite: CE_POINTER [INTEGER_8] assign set_tempwrite

	tempwritesize: NATURAL_32 assign set_tempwritesize

	tempwritetype: INTEGER_32 assign set_tempwritetype

	scratch: CE_POINTER [INTEGER_8] assign set_scratch

	errorbuf: BOOLEAN assign set_errorbuf

	os_errno: INTEGER_32 assign set_os_errno

	prev_signal: CE_ROUTINE assign set_prev_signal

	allow_port: BOOLEAN assign set_allow_port

	digest: PD_DIGESTDATA assign set_digest

	proxydigest: PD_DIGESTDATA assign set_proxydigest

	authhost: PD_AUTH assign set_authhost

	authproxy: PD_AUTH assign set_authproxy

	authproblem: BOOLEAN assign set_authproblem

	expiretime: SD_TIMEVAL assign set_expiretime

	timenode: PD_CURL_TREE assign set_timenode

	timeoutlist: CE_POINTER [PD_CURL_LLIST] assign set_timeoutlist

	most_recent_ftp_entrypath: CE_POINTER [INTEGER_8] assign set_most_recent_ftp_entrypath

	ftp_trying_alternative: BOOLEAN assign set_ftp_trying_alternative

	httpversion: INTEGER_32 assign set_httpversion

	expect100header: BOOLEAN assign set_expect100header

	pipe_broke: BOOLEAN assign set_pipe_broke

	prev_block_had_trailing_cr: BOOLEAN assign set_prev_block_had_trailing_cr

	crlf_conversions: INTEGER_64 assign set_crlf_conversions

	shared_conn: CE_POINTER [ANY] assign set_shared_conn

	closed: BOOLEAN assign set_closed

	pathbuffer: CE_POINTER [INTEGER_8] assign set_pathbuffer

	path: CE_POINTER [INTEGER_8] assign set_path

	slash_removed: BOOLEAN assign set_slash_removed

	use_range: BOOLEAN assign set_use_range

	rangestringalloc: BOOLEAN assign set_rangestringalloc

	range: CE_POINTER [INTEGER_8] assign set_range

	resume_from: INTEGER_64 assign set_resume_from

	rtsp_next_client_CSeq: INTEGER_32 assign set_rtsp_next_client_CSeq

	rtsp_next_server_CSeq: INTEGER_32 assign set_rtsp_next_server_CSeq

	rtsp_CSeq_recv: INTEGER_32 assign set_rtsp_CSeq_recv

	proto: PD_PROTO2 assign set_proto

	current_conn: CE_POINTER [PD_CONNECTDATA] assign set_current_conn

	ssl_connect_retry: BOOLEAN assign set_ssl_connect_retry

feature {ANY} -- setters

	set_used_interface (a_used_interface: NATURAL_32)
		do
			used_interface := a_used_interface
			update_memory_field ("used_interface")
		end

	set_connc (a_connc: CE_POINTER [PD_CONNCACHE])
		do
			connc := a_connc
			update_memory_field ("connc")
		end

	set_keeps_speed (a_keeps_speed: SD_TIMEVAL)
		do
			keeps_speed := a_keeps_speed
			update_memory_field ("keeps_speed")
		end

	set_lastconnect (a_lastconnect: INTEGER_32)
		do
			lastconnect := a_lastconnect
			update_memory_field ("lastconnect")
		end

	set_headerbuff (a_headerbuff: CE_POINTER [INTEGER_8])
		do
			headerbuff := a_headerbuff
			update_memory_field ("headerbuff")
		end

	set_headersize (a_headersize: NATURAL_32)
		do
			headersize := a_headersize
			update_memory_field ("headersize")
		end

	set_current_speed (a_current_speed: INTEGER_64)
		do
			current_speed := a_current_speed
			update_memory_field ("current_speed")
		end

	set_this_is_a_follow (a_this_is_a_follow: BOOLEAN)
		do
			this_is_a_follow := a_this_is_a_follow
			update_memory_field ("this_is_a_follow")
		end

	set_first_host (a_first_host: CE_POINTER [INTEGER_8])
		do
			first_host := a_first_host
			update_memory_field ("first_host")
		end

	set_session (a_session: CE_POINTER [PD_CURL_SSL_SESSION])
		do
			session := a_session
			update_memory_field ("session")
		end

	set_sessionage (a_sessionage: INTEGER_32)
		do
			sessionage := a_sessionage
			update_memory_field ("sessionage")
		end

	set_tempwrite (a_tempwrite: CE_POINTER [INTEGER_8])
		do
			tempwrite := a_tempwrite
			update_memory_field ("tempwrite")
		end

	set_tempwritesize (a_tempwritesize: NATURAL_32)
		do
			tempwritesize := a_tempwritesize
			update_memory_field ("tempwritesize")
		end

	set_tempwritetype (a_tempwritetype: INTEGER_32)
		do
			tempwritetype := a_tempwritetype
			update_memory_field ("tempwritetype")
		end

	set_scratch (a_scratch: CE_POINTER [INTEGER_8])
		do
			scratch := a_scratch
			update_memory_field ("scratch")
		end

	set_errorbuf (a_errorbuf: BOOLEAN)
		do
			errorbuf := a_errorbuf
			update_memory_field ("errorbuf")
		end

	set_os_errno (a_os_errno: INTEGER_32)
		do
			os_errno := a_os_errno
			update_memory_field ("os_errno")
		end

	set_prev_signal (a_prev_signal: CE_ROUTINE)
		do
			prev_signal := a_prev_signal
			update_memory_field ("prev_signal")
		end

	set_allow_port (a_allow_port: BOOLEAN)
		do
			allow_port := a_allow_port
			update_memory_field ("allow_port")
		end

	set_digest (a_digest: PD_DIGESTDATA)
		do
			digest := a_digest
			update_memory_field ("digest")
		end

	set_proxydigest (a_proxydigest: PD_DIGESTDATA)
		do
			proxydigest := a_proxydigest
			update_memory_field ("proxydigest")
		end

	set_authhost (a_authhost: PD_AUTH)
		do
			authhost := a_authhost
			update_memory_field ("authhost")
		end

	set_authproxy (a_authproxy: PD_AUTH)
		do
			authproxy := a_authproxy
			update_memory_field ("authproxy")
		end

	set_authproblem (a_authproblem: BOOLEAN)
		do
			authproblem := a_authproblem
			update_memory_field ("authproblem")
		end

	set_expiretime (a_expiretime: SD_TIMEVAL)
		do
			expiretime := a_expiretime
			update_memory_field ("expiretime")
		end

	set_timenode (a_timenode: PD_CURL_TREE)
		do
			timenode := a_timenode
			update_memory_field ("timenode")
		end

	set_timeoutlist (a_timeoutlist: CE_POINTER [PD_CURL_LLIST])
		do
			timeoutlist := a_timeoutlist
			update_memory_field ("timeoutlist")
		end

	set_most_recent_ftp_entrypath (a_most_recent_ftp_entrypath: CE_POINTER [INTEGER_8])
		do
			most_recent_ftp_entrypath := a_most_recent_ftp_entrypath
			update_memory_field ("most_recent_ftp_entrypath")
		end

	set_ftp_trying_alternative (a_ftp_trying_alternative: BOOLEAN)
		do
			ftp_trying_alternative := a_ftp_trying_alternative
			update_memory_field ("ftp_trying_alternative")
		end

	set_httpversion (a_httpversion: INTEGER_32)
		do
			httpversion := a_httpversion
			update_memory_field ("httpversion")
		end

	set_expect100header (a_expect100header: BOOLEAN)
		do
			expect100header := a_expect100header
			update_memory_field ("expect100header")
		end

	set_pipe_broke (a_pipe_broke: BOOLEAN)
		do
			pipe_broke := a_pipe_broke
			update_memory_field ("pipe_broke")
		end

	set_prev_block_had_trailing_cr (a_prev_block_had_trailing_cr: BOOLEAN)
		do
			prev_block_had_trailing_cr := a_prev_block_had_trailing_cr
			update_memory_field ("prev_block_had_trailing_cr")
		end

	set_crlf_conversions (a_crlf_conversions: INTEGER_64)
		do
			crlf_conversions := a_crlf_conversions
			update_memory_field ("crlf_conversions")
		end

	set_shared_conn (a_shared_conn: CE_POINTER [ANY])
		do
			shared_conn := a_shared_conn
			update_memory_field ("shared_conn")
		end

	set_closed (a_closed: BOOLEAN)
		do
			closed := a_closed
			update_memory_field ("closed")
		end

	set_pathbuffer (a_pathbuffer: CE_POINTER [INTEGER_8])
		do
			pathbuffer := a_pathbuffer
			update_memory_field ("pathbuffer")
		end

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			path := a_path
			update_memory_field ("path")
		end

	set_slash_removed (a_slash_removed: BOOLEAN)
		do
			slash_removed := a_slash_removed
			update_memory_field ("slash_removed")
		end

	set_use_range (a_use_range: BOOLEAN)
		do
			use_range := a_use_range
			update_memory_field ("use_range")
		end

	set_rangestringalloc (a_rangestringalloc: BOOLEAN)
		do
			rangestringalloc := a_rangestringalloc
			update_memory_field ("rangestringalloc")
		end

	set_range (a_range: CE_POINTER [INTEGER_8])
		do
			range := a_range
			update_memory_field ("range")
		end

	set_resume_from (a_resume_from: INTEGER_64)
		do
			resume_from := a_resume_from
			update_memory_field ("resume_from")
		end

	set_rtsp_next_client_CSeq (a_rtsp_next_client_CSeq: INTEGER_32)
		do
			rtsp_next_client_CSeq := a_rtsp_next_client_CSeq
			update_memory_field ("rtsp_next_client_CSeq")
		end

	set_rtsp_next_server_CSeq (a_rtsp_next_server_CSeq: INTEGER_32)
		do
			rtsp_next_server_CSeq := a_rtsp_next_server_CSeq
			update_memory_field ("rtsp_next_server_CSeq")
		end

	set_rtsp_CSeq_recv (a_rtsp_CSeq_recv: INTEGER_32)
		do
			rtsp_CSeq_recv := a_rtsp_CSeq_recv
			update_memory_field ("rtsp_CSeq_recv")
		end

	set_proto (a_proto: PD_PROTO2)
		do
			proto := a_proto
			update_memory_field ("proto")
		end

	set_current_conn (a_current_conn: CE_POINTER [PD_CONNECTDATA])
		do
			current_conn := a_current_conn
			update_memory_field ("current_conn")
		end

	set_ssl_connect_retry (a_ssl_connect_retry: BOOLEAN)
		do
			ssl_connect_retry := a_ssl_connect_retry
			update_memory_field ("ssl_connect_retry")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			used_interface := a_other.used_interface
			connc := a_other.connc
			keeps_speed := a_other.keeps_speed.twin
			lastconnect := a_other.lastconnect
			headerbuff := a_other.headerbuff
			headersize := a_other.headersize
			buffer := a_other.buffer.twin
			uploadbuffer := a_other.uploadbuffer.twin
			current_speed := a_other.current_speed
			this_is_a_follow := a_other.this_is_a_follow
			first_host := a_other.first_host
			session := a_other.session
			sessionage := a_other.sessionage
			tempwrite := a_other.tempwrite
			tempwritesize := a_other.tempwritesize
			tempwritetype := a_other.tempwritetype
			scratch := a_other.scratch
			errorbuf := a_other.errorbuf
			os_errno := a_other.os_errno
			prev_signal := a_other.prev_signal
			allow_port := a_other.allow_port
			digest := a_other.digest.twin
			proxydigest := a_other.proxydigest.twin
			authhost := a_other.authhost.twin
			authproxy := a_other.authproxy.twin
			authproblem := a_other.authproblem
			expiretime := a_other.expiretime.twin
			timenode := a_other.timenode.twin
			timeoutlist := a_other.timeoutlist
			most_recent_ftp_entrypath := a_other.most_recent_ftp_entrypath
			ftp_trying_alternative := a_other.ftp_trying_alternative
			httpversion := a_other.httpversion
			expect100header := a_other.expect100header
			pipe_broke := a_other.pipe_broke
			prev_block_had_trailing_cr := a_other.prev_block_had_trailing_cr
			crlf_conversions := a_other.crlf_conversions
			shared_conn := a_other.shared_conn
			closed := a_other.closed
			pathbuffer := a_other.pathbuffer
			path := a_other.path
			slash_removed := a_other.slash_removed
			use_range := a_other.use_range
			rangestringalloc := a_other.rangestringalloc
			range := a_other.range
			resume_from := a_other.resume_from
			rtsp_next_client_CSeq := a_other.rtsp_next_client_CSeq
			rtsp_next_server_CSeq := a_other.rtsp_next_server_CSeq
			rtsp_CSeq_recv := a_other.rtsp_CSeq_recv
			proto := a_other.proto.twin
			current_conn := a_other.current_conn
			ssl_connect_retry := a_other.ssl_connect_retry
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				used_interface = a_other.used_interface and
				connc.is_equal (a_other.connc) and
				keeps_speed.is_equal (a_other.keeps_speed) and
				lastconnect = a_other.lastconnect and
				headerbuff.is_equal (a_other.headerbuff) and
				headersize = a_other.headersize and
				buffer.is_equal (a_other.buffer) and
				uploadbuffer.is_equal (a_other.uploadbuffer) and
				current_speed = a_other.current_speed and
				this_is_a_follow = a_other.this_is_a_follow and
				first_host.is_equal (a_other.first_host) and
				session.is_equal (a_other.session) and
				sessionage = a_other.sessionage and
				tempwrite.is_equal (a_other.tempwrite) and
				tempwritesize = a_other.tempwritesize and
				tempwritetype = a_other.tempwritetype and
				scratch.is_equal (a_other.scratch) and
				errorbuf = a_other.errorbuf and
				os_errno = a_other.os_errno and
				prev_signal.is_equal (a_other.prev_signal) and
				allow_port = a_other.allow_port and
				digest.is_equal (a_other.digest) and
				proxydigest.is_equal (a_other.proxydigest) and
				authhost.is_equal (a_other.authhost) and
				authproxy.is_equal (a_other.authproxy) and
				authproblem = a_other.authproblem and
				expiretime.is_equal (a_other.expiretime) and
				timenode.is_equal (a_other.timenode) and
				timeoutlist.is_equal (a_other.timeoutlist) and
				most_recent_ftp_entrypath.is_equal (a_other.most_recent_ftp_entrypath) and
				ftp_trying_alternative = a_other.ftp_trying_alternative and
				httpversion = a_other.httpversion and
				expect100header = a_other.expect100header and
				pipe_broke = a_other.pipe_broke and
				prev_block_had_trailing_cr = a_other.prev_block_had_trailing_cr and
				crlf_conversions = a_other.crlf_conversions and
				shared_conn.is_equal (a_other.shared_conn) and
				closed = a_other.closed and
				pathbuffer.is_equal (a_other.pathbuffer) and
				path.is_equal (a_other.path) and
				slash_removed = a_other.slash_removed and
				use_range = a_other.use_range and
				rangestringalloc = a_other.rangestringalloc and
				range.is_equal (a_other.range) and
				resume_from = a_other.resume_from and
				rtsp_next_client_CSeq = a_other.rtsp_next_client_CSeq and
				rtsp_next_server_CSeq = a_other.rtsp_next_server_CSeq and
				rtsp_CSeq_recv = a_other.rtsp_CSeq_recv and
				proto.is_equal (a_other.proto) and
				current_conn.is_equal (a_other.current_conn) and
				ssl_connect_retry = a_other.ssl_connect_retry
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("used_interface"),
					create {CE_STRUCTURE_FIELD}.make ("connc"),
					create {CE_STRUCTURE_FIELD}.make ("keeps_speed"),
					create {CE_STRUCTURE_FIELD}.make ("lastconnect"),
					create {CE_STRUCTURE_FIELD}.make ("headerbuff"),
					create {CE_STRUCTURE_FIELD}.make ("headersize"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("buffer", <<16_385>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("uploadbuffer", <<16_385>>),
					create {CE_STRUCTURE_FIELD}.make ("current_speed"),
					create {CE_STRUCTURE_FIELD}.make ("this_is_a_follow"),
					create {CE_STRUCTURE_FIELD}.make ("first_host"),
					create {CE_STRUCTURE_FIELD}.make ("session"),
					create {CE_STRUCTURE_FIELD}.make ("sessionage"),
					create {CE_STRUCTURE_FIELD}.make ("tempwrite"),
					create {CE_STRUCTURE_FIELD}.make ("tempwritesize"),
					create {CE_STRUCTURE_FIELD}.make ("tempwritetype"),
					create {CE_STRUCTURE_FIELD}.make ("scratch"),
					create {CE_STRUCTURE_FIELD}.make ("errorbuf"),
					create {CE_STRUCTURE_FIELD}.make ("os_errno"),
					create {CE_STRUCTURE_FIELD}.make ("prev_signal"),
					create {CE_STRUCTURE_FIELD}.make ("allow_port"),
					create {CE_STRUCTURE_FIELD}.make ("digest"),
					create {CE_STRUCTURE_FIELD}.make ("proxydigest"),
					create {CE_STRUCTURE_FIELD}.make ("authhost"),
					create {CE_STRUCTURE_FIELD}.make ("authproxy"),
					create {CE_STRUCTURE_FIELD}.make ("authproblem"),
					create {CE_STRUCTURE_FIELD}.make ("expiretime"),
					create {CE_STRUCTURE_FIELD}.make ("timenode"),
					create {CE_STRUCTURE_FIELD}.make ("timeoutlist"),
					create {CE_STRUCTURE_FIELD}.make ("most_recent_ftp_entrypath"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_trying_alternative"),
					create {CE_STRUCTURE_FIELD}.make ("httpversion"),
					create {CE_STRUCTURE_FIELD}.make ("expect100header"),
					create {CE_STRUCTURE_FIELD}.make ("pipe_broke"),
					create {CE_STRUCTURE_FIELD}.make ("prev_block_had_trailing_cr"),
					create {CE_STRUCTURE_FIELD}.make ("crlf_conversions"),
					create {CE_STRUCTURE_FIELD}.make ("shared_conn"),
					create {CE_STRUCTURE_FIELD}.make ("closed"),
					create {CE_STRUCTURE_FIELD}.make ("pathbuffer"),
					create {CE_STRUCTURE_FIELD}.make ("path"),
					create {CE_STRUCTURE_FIELD}.make ("slash_removed"),
					create {CE_STRUCTURE_FIELD}.make ("use_range"),
					create {CE_STRUCTURE_FIELD}.make ("rangestringalloc"),
					create {CE_STRUCTURE_FIELD}.make ("range"),
					create {CE_STRUCTURE_FIELD}.make ("resume_from"),
					create {CE_STRUCTURE_FIELD}.make ("rtsp_next_client_CSeq"),
					create {CE_STRUCTURE_FIELD}.make ("rtsp_next_server_CSeq"),
					create {CE_STRUCTURE_FIELD}.make ("rtsp_CSeq_recv"),
					create {CE_STRUCTURE_FIELD}.make ("proto"),
					create {CE_STRUCTURE_FIELD}.make ("current_conn"),
					create {CE_STRUCTURE_FIELD}.make ("ssl_connect_retry")
				>>)
			init_structure_info
		end

end
