class
	PD_USERDEFINED

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create err.make
			create debugdata.make
			create errorbuffer.make
			create out2.make
			create in.make
			create writeheader.make
			create rtp_out.make
			create postfields.make
			create seek_func.make
			create fwrite_func.make
			create fwrite_header.make
			create fwrite_rtp.make
			create fread_func.make
			create fprogress.make
			create fdebug.make
			create ioctl_func.make
			create fsockopt.make
			create sockopt_client.make
			create fopensocket.make
			create opensocket_client.make
			create seek_client.make
			create convfromnetwork.make
			create convtonetwork.make
			create convfromutf8.make
			create progress_client.make
			create ioctl_client.make
			create headers.make
			create httppost.make
			create quote.make
			create postquote.make
			create prequote.make
			create source_quote.make
			create source_prequote.make
			create source_postquote.make
			create telnet_options.make
			create ssl.make
			create private_data.make
			create one_easy.make
			create http200aliases.make
			create ssh_keyfunc.make
			create ssh_keyfunc_userp.make
			create str.make (<<37>>)
			create mail_rcpt.make
			create chunk_bgn.make
			create chunk_end.make
			create fnmatch.make
			create fnmatch_data.make
		end

feature {ANY} -- fields

	err: CE_POINTER [SD_IO_FILE] assign set_err

	debugdata: CE_POINTER [ANY] assign set_debugdata

	errorbuffer: CE_POINTER [INTEGER_8] assign set_errorbuffer

	proxyport: INTEGER_32 assign set_proxyport

	out2: CE_POINTER [ANY] assign set_out2

	in: CE_POINTER [ANY] assign set_in

	writeheader: CE_POINTER [ANY] assign set_writeheader

	rtp_out: CE_POINTER [ANY] assign set_rtp_out

	use_port: INTEGER_32 assign set_use_port

	httpauth: INTEGER_32 assign set_httpauth

	proxyauth: INTEGER_32 assign set_proxyauth

	followlocation: INTEGER_32 assign set_followlocation

	maxredirs: INTEGER_32 assign set_maxredirs

	post301: BOOLEAN assign set_post301

	post302: BOOLEAN assign set_post302

	free_referer: BOOLEAN assign set_free_referer

	postfields: CE_POINTER [ANY] assign set_postfields

	seek_func: CE_ROUTINE assign set_seek_func

	postfieldsize: INTEGER_64 assign set_postfieldsize

	localport: NATURAL_16 assign set_localport

	localportrange: INTEGER_32 assign set_localportrange

	fwrite_func: CE_ROUTINE assign set_fwrite_func

	fwrite_header: CE_ROUTINE assign set_fwrite_header

	fwrite_rtp: CE_ROUTINE assign set_fwrite_rtp

	fread_func: CE_ROUTINE assign set_fread_func

	is_fread_set: INTEGER_32 assign set_is_fread_set

	is_fwrite_set: INTEGER_32 assign set_is_fwrite_set

	fprogress: CE_ROUTINE assign set_fprogress

	fdebug: CE_ROUTINE assign set_fdebug

	ioctl_func: CE_ROUTINE assign set_ioctl_func

	fsockopt: CE_ROUTINE assign set_fsockopt

	sockopt_client: CE_POINTER [ANY] assign set_sockopt_client

	fopensocket: CE_ROUTINE assign set_fopensocket

	opensocket_client: CE_POINTER [ANY] assign set_opensocket_client

	seek_client: CE_POINTER [ANY] assign set_seek_client

	convfromnetwork: CE_ROUTINE assign set_convfromnetwork

	convtonetwork: CE_ROUTINE assign set_convtonetwork

	convfromutf8: CE_ROUTINE assign set_convfromutf8

	progress_client: CE_POINTER [ANY] assign set_progress_client

	ioctl_client: CE_POINTER [ANY] assign set_ioctl_client

	timeout: INTEGER_32 assign set_timeout

	connecttimeout: INTEGER_32 assign set_connecttimeout

	server_response_timeout: INTEGER_32 assign set_server_response_timeout

	tftp_blksize: INTEGER_32 assign set_tftp_blksize

	infilesize: INTEGER_64 assign set_infilesize

	low_speed_limit: INTEGER_32 assign set_low_speed_limit

	low_speed_time: INTEGER_32 assign set_low_speed_time

	max_send_speed: INTEGER_64 assign set_max_send_speed

	max_recv_speed: INTEGER_64 assign set_max_recv_speed

	set_resume_from: INTEGER_64 assign set_set_resume_from

	headers: CE_POINTER [PD_CURL_SLIST] assign set_headers

	httppost: CE_POINTER [PD_CURL_HTTPPOST] assign set_httppost

	cookiesession: BOOLEAN assign set_cookiesession

	crlf: BOOLEAN assign set_crlf

	quote: CE_POINTER [PD_CURL_SLIST] assign set_quote

	postquote: CE_POINTER [PD_CURL_SLIST] assign set_postquote

	prequote: CE_POINTER [PD_CURL_SLIST] assign set_prequote

	source_quote: CE_POINTER [PD_CURL_SLIST] assign set_source_quote

	source_prequote: CE_POINTER [PD_CURL_SLIST] assign set_source_prequote

	source_postquote: CE_POINTER [PD_CURL_SLIST] assign set_source_postquote

	telnet_options: CE_POINTER [PD_CURL_SLIST] assign set_telnet_options

	timecondition: NATURAL_32 assign set_timecondition

	timevalue: INTEGER_32 assign set_timevalue

	httpreq: NATURAL_32 assign set_httpreq

	httpversion: INTEGER_32 assign set_httpversion

	ssl: PD_SSL_CONFIG_DATA assign set_ssl

	proxytype: NATURAL_32 assign set_proxytype

	dns_cache_timeout: INTEGER_32 assign set_dns_cache_timeout

	buffer_size: INTEGER_32 assign set_buffer_size

	private_data: CE_POINTER [ANY] assign set_private_data

	one_easy: CE_POINTER [PD_CURL_ONE_EASY] assign set_one_easy

	http200aliases: CE_POINTER [PD_CURL_SLIST] assign set_http200aliases

	ip_version: INTEGER_32 assign set_ip_version

	max_filesize: INTEGER_64 assign set_max_filesize

	ftp_filemethod: NATURAL_32 assign set_ftp_filemethod

	ftp_create_missing_dirs: INTEGER_32 assign set_ftp_create_missing_dirs

	ssh_keyfunc: CE_ROUTINE assign set_ssh_keyfunc

	ssh_keyfunc_userp: CE_POINTER [ANY] assign set_ssh_keyfunc_userp

	printhost: BOOLEAN assign set_printhost

	get_filetime: BOOLEAN assign set_get_filetime

	tunnel_thru_httpproxy: BOOLEAN assign set_tunnel_thru_httpproxy

	prefer_ascii: BOOLEAN assign set_prefer_ascii

	ftp_append: BOOLEAN assign set_ftp_append

	ftp_list_only: BOOLEAN assign set_ftp_list_only

	ftp_use_port: BOOLEAN assign set_ftp_use_port

	hide_progress: BOOLEAN assign set_hide_progress

	http_fail_on_error: BOOLEAN assign set_http_fail_on_error

	http_follow_location: BOOLEAN assign set_http_follow_location

	http_disable_hostname_check_before_authentication: BOOLEAN assign set_http_disable_hostname_check_before_authentication

	include_header: BOOLEAN assign set_include_header

	http_set_referer: BOOLEAN assign set_http_set_referer

	http_auto_referer: BOOLEAN assign set_http_auto_referer

	opt_no_body: BOOLEAN assign set_opt_no_body

	set_port: BOOLEAN assign set_set_port

	upload: BOOLEAN assign set_upload

	use_netrc: NATURAL_32 assign set_use_netrc

	verbose: BOOLEAN assign set_verbose

	krb: BOOLEAN assign set_krb

	reuse_forbid: BOOLEAN assign set_reuse_forbid

	reuse_fresh: BOOLEAN assign set_reuse_fresh

	ftp_use_epsv: BOOLEAN assign set_ftp_use_epsv

	ftp_use_eprt: BOOLEAN assign set_ftp_use_eprt

	ftp_use_pret: BOOLEAN assign set_ftp_use_pret

	ftp_ssl: NATURAL_32 assign set_ftp_ssl

	ftpsslauth: NATURAL_32 assign set_ftpsslauth

	ftp_ccc: NATURAL_32 assign set_ftp_ccc

	no_signal: BOOLEAN assign set_no_signal

	global_dns_cache: BOOLEAN assign set_global_dns_cache

	tcp_nodelay: BOOLEAN assign set_tcp_nodelay

	ignorecl: BOOLEAN assign set_ignorecl

	ftp_skip_ip: BOOLEAN assign set_ftp_skip_ip

	connect_only: BOOLEAN assign set_connect_only

	ssh_auth_types: INTEGER_32 assign set_ssh_auth_types

	http_te_skip: BOOLEAN assign set_http_te_skip

	http_ce_skip: BOOLEAN assign set_http_ce_skip

	new_file_perms: INTEGER_32 assign set_new_file_perms

	new_directory_perms: INTEGER_32 assign set_new_directory_perms

	proxy_transfer_mode: BOOLEAN assign set_proxy_transfer_mode

	str: CE_ARRAY [CE_POINTER [INTEGER_8]]

	scope: NATURAL_32 assign set_scope

	allowed_protocols: INTEGER_32 assign set_allowed_protocols

	redir_protocols: INTEGER_32 assign set_redir_protocols

	mail_rcpt: CE_POINTER [PD_CURL_SLIST] assign set_mail_rcpt

	rtspreq: NATURAL_32 assign set_rtspreq

	rtspversion: INTEGER_32 assign set_rtspversion

	wildcardmatch: BOOLEAN assign set_wildcardmatch

	chunk_bgn: CE_ROUTINE assign set_chunk_bgn

	chunk_end: CE_ROUTINE assign set_chunk_end

	fnmatch: CE_ROUTINE assign set_fnmatch

	fnmatch_data: CE_POINTER [ANY] assign set_fnmatch_data

feature {ANY} -- setters

	set_err (a_err: CE_POINTER [SD_IO_FILE])
		do
			err := a_err
			update_memory_field ("err")
		end

	set_debugdata (a_debugdata: CE_POINTER [ANY])
		do
			debugdata := a_debugdata
			update_memory_field ("debugdata")
		end

	set_errorbuffer (a_errorbuffer: CE_POINTER [INTEGER_8])
		do
			errorbuffer := a_errorbuffer
			update_memory_field ("errorbuffer")
		end

	set_proxyport (a_proxyport: INTEGER_32)
		do
			proxyport := a_proxyport
			update_memory_field ("proxyport")
		end

	set_out2 (a_out2: CE_POINTER [ANY])
		do
			out2 := a_out2
			update_memory_field ("out2")
		end

	set_in (a_in: CE_POINTER [ANY])
		do
			in := a_in
			update_memory_field ("in")
		end

	set_writeheader (a_writeheader: CE_POINTER [ANY])
		do
			writeheader := a_writeheader
			update_memory_field ("writeheader")
		end

	set_rtp_out (a_rtp_out: CE_POINTER [ANY])
		do
			rtp_out := a_rtp_out
			update_memory_field ("rtp_out")
		end

	set_use_port (a_use_port: INTEGER_32)
		do
			use_port := a_use_port
			update_memory_field ("use_port")
		end

	set_httpauth (a_httpauth: INTEGER_32)
		do
			httpauth := a_httpauth
			update_memory_field ("httpauth")
		end

	set_proxyauth (a_proxyauth: INTEGER_32)
		do
			proxyauth := a_proxyauth
			update_memory_field ("proxyauth")
		end

	set_followlocation (a_followlocation: INTEGER_32)
		do
			followlocation := a_followlocation
			update_memory_field ("followlocation")
		end

	set_maxredirs (a_maxredirs: INTEGER_32)
		do
			maxredirs := a_maxredirs
			update_memory_field ("maxredirs")
		end

	set_post301 (a_post301: BOOLEAN)
		do
			post301 := a_post301
			update_memory_field ("post301")
		end

	set_post302 (a_post302: BOOLEAN)
		do
			post302 := a_post302
			update_memory_field ("post302")
		end

	set_free_referer (a_free_referer: BOOLEAN)
		do
			free_referer := a_free_referer
			update_memory_field ("free_referer")
		end

	set_postfields (a_postfields: CE_POINTER [ANY])
		do
			postfields := a_postfields
			update_memory_field ("postfields")
		end

	set_seek_func (a_seek_func: CE_ROUTINE)
		do
			seek_func := a_seek_func
			update_memory_field ("seek_func")
		end

	set_postfieldsize (a_postfieldsize: INTEGER_64)
		do
			postfieldsize := a_postfieldsize
			update_memory_field ("postfieldsize")
		end

	set_localport (a_localport: NATURAL_16)
		do
			localport := a_localport
			update_memory_field ("localport")
		end

	set_localportrange (a_localportrange: INTEGER_32)
		do
			localportrange := a_localportrange
			update_memory_field ("localportrange")
		end

	set_fwrite_func (a_fwrite_func: CE_ROUTINE)
		do
			fwrite_func := a_fwrite_func
			update_memory_field ("fwrite_func")
		end

	set_fwrite_header (a_fwrite_header: CE_ROUTINE)
		do
			fwrite_header := a_fwrite_header
			update_memory_field ("fwrite_header")
		end

	set_fwrite_rtp (a_fwrite_rtp: CE_ROUTINE)
		do
			fwrite_rtp := a_fwrite_rtp
			update_memory_field ("fwrite_rtp")
		end

	set_fread_func (a_fread_func: CE_ROUTINE)
		do
			fread_func := a_fread_func
			update_memory_field ("fread_func")
		end

	set_is_fread_set (a_is_fread_set: INTEGER_32)
		do
			is_fread_set := a_is_fread_set
			update_memory_field ("is_fread_set")
		end

	set_is_fwrite_set (a_is_fwrite_set: INTEGER_32)
		do
			is_fwrite_set := a_is_fwrite_set
			update_memory_field ("is_fwrite_set")
		end

	set_fprogress (a_fprogress: CE_ROUTINE)
		do
			fprogress := a_fprogress
			update_memory_field ("fprogress")
		end

	set_fdebug (a_fdebug: CE_ROUTINE)
		do
			fdebug := a_fdebug
			update_memory_field ("fdebug")
		end

	set_ioctl_func (a_ioctl_func: CE_ROUTINE)
		do
			ioctl_func := a_ioctl_func
			update_memory_field ("ioctl_func")
		end

	set_fsockopt (a_fsockopt: CE_ROUTINE)
		do
			fsockopt := a_fsockopt
			update_memory_field ("fsockopt")
		end

	set_sockopt_client (a_sockopt_client: CE_POINTER [ANY])
		do
			sockopt_client := a_sockopt_client
			update_memory_field ("sockopt_client")
		end

	set_fopensocket (a_fopensocket: CE_ROUTINE)
		do
			fopensocket := a_fopensocket
			update_memory_field ("fopensocket")
		end

	set_opensocket_client (a_opensocket_client: CE_POINTER [ANY])
		do
			opensocket_client := a_opensocket_client
			update_memory_field ("opensocket_client")
		end

	set_seek_client (a_seek_client: CE_POINTER [ANY])
		do
			seek_client := a_seek_client
			update_memory_field ("seek_client")
		end

	set_convfromnetwork (a_convfromnetwork: CE_ROUTINE)
		do
			convfromnetwork := a_convfromnetwork
			update_memory_field ("convfromnetwork")
		end

	set_convtonetwork (a_convtonetwork: CE_ROUTINE)
		do
			convtonetwork := a_convtonetwork
			update_memory_field ("convtonetwork")
		end

	set_convfromutf8 (a_convfromutf8: CE_ROUTINE)
		do
			convfromutf8 := a_convfromutf8
			update_memory_field ("convfromutf8")
		end

	set_progress_client (a_progress_client: CE_POINTER [ANY])
		do
			progress_client := a_progress_client
			update_memory_field ("progress_client")
		end

	set_ioctl_client (a_ioctl_client: CE_POINTER [ANY])
		do
			ioctl_client := a_ioctl_client
			update_memory_field ("ioctl_client")
		end

	set_timeout (a_timeout: INTEGER_32)
		do
			timeout := a_timeout
			update_memory_field ("timeout")
		end

	set_connecttimeout (a_connecttimeout: INTEGER_32)
		do
			connecttimeout := a_connecttimeout
			update_memory_field ("connecttimeout")
		end

	set_server_response_timeout (a_server_response_timeout: INTEGER_32)
		do
			server_response_timeout := a_server_response_timeout
			update_memory_field ("server_response_timeout")
		end

	set_tftp_blksize (a_tftp_blksize: INTEGER_32)
		do
			tftp_blksize := a_tftp_blksize
			update_memory_field ("tftp_blksize")
		end

	set_infilesize (a_infilesize: INTEGER_64)
		do
			infilesize := a_infilesize
			update_memory_field ("infilesize")
		end

	set_low_speed_limit (a_low_speed_limit: INTEGER_32)
		do
			low_speed_limit := a_low_speed_limit
			update_memory_field ("low_speed_limit")
		end

	set_low_speed_time (a_low_speed_time: INTEGER_32)
		do
			low_speed_time := a_low_speed_time
			update_memory_field ("low_speed_time")
		end

	set_max_send_speed (a_max_send_speed: INTEGER_64)
		do
			max_send_speed := a_max_send_speed
			update_memory_field ("max_send_speed")
		end

	set_max_recv_speed (a_max_recv_speed: INTEGER_64)
		do
			max_recv_speed := a_max_recv_speed
			update_memory_field ("max_recv_speed")
		end

	set_set_resume_from (a_set_resume_from: INTEGER_64)
		do
			set_resume_from := a_set_resume_from
			update_memory_field ("set_resume_from")
		end

	set_headers (a_headers: CE_POINTER [PD_CURL_SLIST])
		do
			headers := a_headers
			update_memory_field ("headers")
		end

	set_httppost (a_httppost: CE_POINTER [PD_CURL_HTTPPOST])
		do
			httppost := a_httppost
			update_memory_field ("httppost")
		end

	set_cookiesession (a_cookiesession: BOOLEAN)
		do
			cookiesession := a_cookiesession
			update_memory_field ("cookiesession")
		end

	set_crlf (a_crlf: BOOLEAN)
		do
			crlf := a_crlf
			update_memory_field ("crlf")
		end

	set_quote (a_quote: CE_POINTER [PD_CURL_SLIST])
		do
			quote := a_quote
			update_memory_field ("quote")
		end

	set_postquote (a_postquote: CE_POINTER [PD_CURL_SLIST])
		do
			postquote := a_postquote
			update_memory_field ("postquote")
		end

	set_prequote (a_prequote: CE_POINTER [PD_CURL_SLIST])
		do
			prequote := a_prequote
			update_memory_field ("prequote")
		end

	set_source_quote (a_source_quote: CE_POINTER [PD_CURL_SLIST])
		do
			source_quote := a_source_quote
			update_memory_field ("source_quote")
		end

	set_source_prequote (a_source_prequote: CE_POINTER [PD_CURL_SLIST])
		do
			source_prequote := a_source_prequote
			update_memory_field ("source_prequote")
		end

	set_source_postquote (a_source_postquote: CE_POINTER [PD_CURL_SLIST])
		do
			source_postquote := a_source_postquote
			update_memory_field ("source_postquote")
		end

	set_telnet_options (a_telnet_options: CE_POINTER [PD_CURL_SLIST])
		do
			telnet_options := a_telnet_options
			update_memory_field ("telnet_options")
		end

	set_timecondition (a_timecondition: NATURAL_32)
		do
			timecondition := a_timecondition
			update_memory_field ("timecondition")
		end

	set_timevalue (a_timevalue: INTEGER_32)
		do
			timevalue := a_timevalue
			update_memory_field ("timevalue")
		end

	set_httpreq (a_httpreq: NATURAL_32)
		do
			httpreq := a_httpreq
			update_memory_field ("httpreq")
		end

	set_httpversion (a_httpversion: INTEGER_32)
		do
			httpversion := a_httpversion
			update_memory_field ("httpversion")
		end

	set_ssl (a_ssl: PD_SSL_CONFIG_DATA)
		do
			ssl := a_ssl
			update_memory_field ("ssl")
		end

	set_proxytype (a_proxytype: NATURAL_32)
		do
			proxytype := a_proxytype
			update_memory_field ("proxytype")
		end

	set_dns_cache_timeout (a_dns_cache_timeout: INTEGER_32)
		do
			dns_cache_timeout := a_dns_cache_timeout
			update_memory_field ("dns_cache_timeout")
		end

	set_buffer_size (a_buffer_size: INTEGER_32)
		do
			buffer_size := a_buffer_size
			update_memory_field ("buffer_size")
		end

	set_private_data (a_private_data: CE_POINTER [ANY])
		do
			private_data := a_private_data
			update_memory_field ("private_data")
		end

	set_one_easy (a_one_easy: CE_POINTER [PD_CURL_ONE_EASY])
		do
			one_easy := a_one_easy
			update_memory_field ("one_easy")
		end

	set_http200aliases (a_http200aliases: CE_POINTER [PD_CURL_SLIST])
		do
			http200aliases := a_http200aliases
			update_memory_field ("http200aliases")
		end

	set_ip_version (a_ip_version: INTEGER_32)
		do
			ip_version := a_ip_version
			update_memory_field ("ip_version")
		end

	set_max_filesize (a_max_filesize: INTEGER_64)
		do
			max_filesize := a_max_filesize
			update_memory_field ("max_filesize")
		end

	set_ftp_filemethod (a_ftp_filemethod: NATURAL_32)
		do
			ftp_filemethod := a_ftp_filemethod
			update_memory_field ("ftp_filemethod")
		end

	set_ftp_create_missing_dirs (a_ftp_create_missing_dirs: INTEGER_32)
		do
			ftp_create_missing_dirs := a_ftp_create_missing_dirs
			update_memory_field ("ftp_create_missing_dirs")
		end

	set_ssh_keyfunc (a_ssh_keyfunc: CE_ROUTINE)
		do
			ssh_keyfunc := a_ssh_keyfunc
			update_memory_field ("ssh_keyfunc")
		end

	set_ssh_keyfunc_userp (a_ssh_keyfunc_userp: CE_POINTER [ANY])
		do
			ssh_keyfunc_userp := a_ssh_keyfunc_userp
			update_memory_field ("ssh_keyfunc_userp")
		end

	set_printhost (a_printhost: BOOLEAN)
		do
			printhost := a_printhost
			update_memory_field ("printhost")
		end

	set_get_filetime (a_get_filetime: BOOLEAN)
		do
			get_filetime := a_get_filetime
			update_memory_field ("get_filetime")
		end

	set_tunnel_thru_httpproxy (a_tunnel_thru_httpproxy: BOOLEAN)
		do
			tunnel_thru_httpproxy := a_tunnel_thru_httpproxy
			update_memory_field ("tunnel_thru_httpproxy")
		end

	set_prefer_ascii (a_prefer_ascii: BOOLEAN)
		do
			prefer_ascii := a_prefer_ascii
			update_memory_field ("prefer_ascii")
		end

	set_ftp_append (a_ftp_append: BOOLEAN)
		do
			ftp_append := a_ftp_append
			update_memory_field ("ftp_append")
		end

	set_ftp_list_only (a_ftp_list_only: BOOLEAN)
		do
			ftp_list_only := a_ftp_list_only
			update_memory_field ("ftp_list_only")
		end

	set_ftp_use_port (a_ftp_use_port: BOOLEAN)
		do
			ftp_use_port := a_ftp_use_port
			update_memory_field ("ftp_use_port")
		end

	set_hide_progress (a_hide_progress: BOOLEAN)
		do
			hide_progress := a_hide_progress
			update_memory_field ("hide_progress")
		end

	set_http_fail_on_error (a_http_fail_on_error: BOOLEAN)
		do
			http_fail_on_error := a_http_fail_on_error
			update_memory_field ("http_fail_on_error")
		end

	set_http_follow_location (a_http_follow_location: BOOLEAN)
		do
			http_follow_location := a_http_follow_location
			update_memory_field ("http_follow_location")
		end

	set_http_disable_hostname_check_before_authentication (a_http_disable_hostname_check_before_authentication: BOOLEAN)
		do
			http_disable_hostname_check_before_authentication := a_http_disable_hostname_check_before_authentication
			update_memory_field ("http_disable_hostname_check_before_authentication")
		end

	set_include_header (a_include_header: BOOLEAN)
		do
			include_header := a_include_header
			update_memory_field ("include_header")
		end

	set_http_set_referer (a_http_set_referer: BOOLEAN)
		do
			http_set_referer := a_http_set_referer
			update_memory_field ("http_set_referer")
		end

	set_http_auto_referer (a_http_auto_referer: BOOLEAN)
		do
			http_auto_referer := a_http_auto_referer
			update_memory_field ("http_auto_referer")
		end

	set_opt_no_body (a_opt_no_body: BOOLEAN)
		do
			opt_no_body := a_opt_no_body
			update_memory_field ("opt_no_body")
		end

	set_set_port (a_set_port: BOOLEAN)
		do
			set_port := a_set_port
			update_memory_field ("set_port")
		end

	set_upload (a_upload: BOOLEAN)
		do
			upload := a_upload
			update_memory_field ("upload")
		end

	set_use_netrc (a_use_netrc: NATURAL_32)
		do
			use_netrc := a_use_netrc
			update_memory_field ("use_netrc")
		end

	set_verbose (a_verbose: BOOLEAN)
		do
			verbose := a_verbose
			update_memory_field ("verbose")
		end

	set_krb (a_krb: BOOLEAN)
		do
			krb := a_krb
			update_memory_field ("krb")
		end

	set_reuse_forbid (a_reuse_forbid: BOOLEAN)
		do
			reuse_forbid := a_reuse_forbid
			update_memory_field ("reuse_forbid")
		end

	set_reuse_fresh (a_reuse_fresh: BOOLEAN)
		do
			reuse_fresh := a_reuse_fresh
			update_memory_field ("reuse_fresh")
		end

	set_ftp_use_epsv (a_ftp_use_epsv: BOOLEAN)
		do
			ftp_use_epsv := a_ftp_use_epsv
			update_memory_field ("ftp_use_epsv")
		end

	set_ftp_use_eprt (a_ftp_use_eprt: BOOLEAN)
		do
			ftp_use_eprt := a_ftp_use_eprt
			update_memory_field ("ftp_use_eprt")
		end

	set_ftp_use_pret (a_ftp_use_pret: BOOLEAN)
		do
			ftp_use_pret := a_ftp_use_pret
			update_memory_field ("ftp_use_pret")
		end

	set_ftp_ssl (a_ftp_ssl: NATURAL_32)
		do
			ftp_ssl := a_ftp_ssl
			update_memory_field ("ftp_ssl")
		end

	set_ftpsslauth (a_ftpsslauth: NATURAL_32)
		do
			ftpsslauth := a_ftpsslauth
			update_memory_field ("ftpsslauth")
		end

	set_ftp_ccc (a_ftp_ccc: NATURAL_32)
		do
			ftp_ccc := a_ftp_ccc
			update_memory_field ("ftp_ccc")
		end

	set_no_signal (a_no_signal: BOOLEAN)
		do
			no_signal := a_no_signal
			update_memory_field ("no_signal")
		end

	set_global_dns_cache (a_global_dns_cache: BOOLEAN)
		do
			global_dns_cache := a_global_dns_cache
			update_memory_field ("global_dns_cache")
		end

	set_tcp_nodelay (a_tcp_nodelay: BOOLEAN)
		do
			tcp_nodelay := a_tcp_nodelay
			update_memory_field ("tcp_nodelay")
		end

	set_ignorecl (a_ignorecl: BOOLEAN)
		do
			ignorecl := a_ignorecl
			update_memory_field ("ignorecl")
		end

	set_ftp_skip_ip (a_ftp_skip_ip: BOOLEAN)
		do
			ftp_skip_ip := a_ftp_skip_ip
			update_memory_field ("ftp_skip_ip")
		end

	set_connect_only (a_connect_only: BOOLEAN)
		do
			connect_only := a_connect_only
			update_memory_field ("connect_only")
		end

	set_ssh_auth_types (a_ssh_auth_types: INTEGER_32)
		do
			ssh_auth_types := a_ssh_auth_types
			update_memory_field ("ssh_auth_types")
		end

	set_http_te_skip (a_http_te_skip: BOOLEAN)
		do
			http_te_skip := a_http_te_skip
			update_memory_field ("http_te_skip")
		end

	set_http_ce_skip (a_http_ce_skip: BOOLEAN)
		do
			http_ce_skip := a_http_ce_skip
			update_memory_field ("http_ce_skip")
		end

	set_new_file_perms (a_new_file_perms: INTEGER_32)
		do
			new_file_perms := a_new_file_perms
			update_memory_field ("new_file_perms")
		end

	set_new_directory_perms (a_new_directory_perms: INTEGER_32)
		do
			new_directory_perms := a_new_directory_perms
			update_memory_field ("new_directory_perms")
		end

	set_proxy_transfer_mode (a_proxy_transfer_mode: BOOLEAN)
		do
			proxy_transfer_mode := a_proxy_transfer_mode
			update_memory_field ("proxy_transfer_mode")
		end

	set_scope (a_scope: NATURAL_32)
		do
			scope := a_scope
			update_memory_field ("scope")
		end

	set_allowed_protocols (a_allowed_protocols: INTEGER_32)
		do
			allowed_protocols := a_allowed_protocols
			update_memory_field ("allowed_protocols")
		end

	set_redir_protocols (a_redir_protocols: INTEGER_32)
		do
			redir_protocols := a_redir_protocols
			update_memory_field ("redir_protocols")
		end

	set_mail_rcpt (a_mail_rcpt: CE_POINTER [PD_CURL_SLIST])
		do
			mail_rcpt := a_mail_rcpt
			update_memory_field ("mail_rcpt")
		end

	set_rtspreq (a_rtspreq: NATURAL_32)
		do
			rtspreq := a_rtspreq
			update_memory_field ("rtspreq")
		end

	set_rtspversion (a_rtspversion: INTEGER_32)
		do
			rtspversion := a_rtspversion
			update_memory_field ("rtspversion")
		end

	set_wildcardmatch (a_wildcardmatch: BOOLEAN)
		do
			wildcardmatch := a_wildcardmatch
			update_memory_field ("wildcardmatch")
		end

	set_chunk_bgn (a_chunk_bgn: CE_ROUTINE)
		do
			chunk_bgn := a_chunk_bgn
			update_memory_field ("chunk_bgn")
		end

	set_chunk_end (a_chunk_end: CE_ROUTINE)
		do
			chunk_end := a_chunk_end
			update_memory_field ("chunk_end")
		end

	set_fnmatch (a_fnmatch: CE_ROUTINE)
		do
			fnmatch := a_fnmatch
			update_memory_field ("fnmatch")
		end

	set_fnmatch_data (a_fnmatch_data: CE_POINTER [ANY])
		do
			fnmatch_data := a_fnmatch_data
			update_memory_field ("fnmatch_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			err := a_other.err
			debugdata := a_other.debugdata
			errorbuffer := a_other.errorbuffer
			proxyport := a_other.proxyport
			out2 := a_other.out2
			in := a_other.in
			writeheader := a_other.writeheader
			rtp_out := a_other.rtp_out
			use_port := a_other.use_port
			httpauth := a_other.httpauth
			proxyauth := a_other.proxyauth
			followlocation := a_other.followlocation
			maxredirs := a_other.maxredirs
			post301 := a_other.post301
			post302 := a_other.post302
			free_referer := a_other.free_referer
			postfields := a_other.postfields
			seek_func := a_other.seek_func
			postfieldsize := a_other.postfieldsize
			localport := a_other.localport
			localportrange := a_other.localportrange
			fwrite_func := a_other.fwrite_func
			fwrite_header := a_other.fwrite_header
			fwrite_rtp := a_other.fwrite_rtp
			fread_func := a_other.fread_func
			is_fread_set := a_other.is_fread_set
			is_fwrite_set := a_other.is_fwrite_set
			fprogress := a_other.fprogress
			fdebug := a_other.fdebug
			ioctl_func := a_other.ioctl_func
			fsockopt := a_other.fsockopt
			sockopt_client := a_other.sockopt_client
			fopensocket := a_other.fopensocket
			opensocket_client := a_other.opensocket_client
			seek_client := a_other.seek_client
			convfromnetwork := a_other.convfromnetwork
			convtonetwork := a_other.convtonetwork
			convfromutf8 := a_other.convfromutf8
			progress_client := a_other.progress_client
			ioctl_client := a_other.ioctl_client
			timeout := a_other.timeout
			connecttimeout := a_other.connecttimeout
			server_response_timeout := a_other.server_response_timeout
			tftp_blksize := a_other.tftp_blksize
			infilesize := a_other.infilesize
			low_speed_limit := a_other.low_speed_limit
			low_speed_time := a_other.low_speed_time
			max_send_speed := a_other.max_send_speed
			max_recv_speed := a_other.max_recv_speed
			set_resume_from := a_other.set_resume_from
			headers := a_other.headers
			httppost := a_other.httppost
			cookiesession := a_other.cookiesession
			crlf := a_other.crlf
			quote := a_other.quote
			postquote := a_other.postquote
			prequote := a_other.prequote
			source_quote := a_other.source_quote
			source_prequote := a_other.source_prequote
			source_postquote := a_other.source_postquote
			telnet_options := a_other.telnet_options
			timecondition := a_other.timecondition
			timevalue := a_other.timevalue
			httpreq := a_other.httpreq
			httpversion := a_other.httpversion
			ssl := a_other.ssl.twin
			proxytype := a_other.proxytype
			dns_cache_timeout := a_other.dns_cache_timeout
			buffer_size := a_other.buffer_size
			private_data := a_other.private_data
			one_easy := a_other.one_easy
			http200aliases := a_other.http200aliases
			ip_version := a_other.ip_version
			max_filesize := a_other.max_filesize
			ftp_filemethod := a_other.ftp_filemethod
			ftp_create_missing_dirs := a_other.ftp_create_missing_dirs
			ssh_keyfunc := a_other.ssh_keyfunc
			ssh_keyfunc_userp := a_other.ssh_keyfunc_userp
			printhost := a_other.printhost
			get_filetime := a_other.get_filetime
			tunnel_thru_httpproxy := a_other.tunnel_thru_httpproxy
			prefer_ascii := a_other.prefer_ascii
			ftp_append := a_other.ftp_append
			ftp_list_only := a_other.ftp_list_only
			ftp_use_port := a_other.ftp_use_port
			hide_progress := a_other.hide_progress
			http_fail_on_error := a_other.http_fail_on_error
			http_follow_location := a_other.http_follow_location
			http_disable_hostname_check_before_authentication := a_other.http_disable_hostname_check_before_authentication
			include_header := a_other.include_header
			http_set_referer := a_other.http_set_referer
			http_auto_referer := a_other.http_auto_referer
			opt_no_body := a_other.opt_no_body
			set_port := a_other.set_port
			upload := a_other.upload
			use_netrc := a_other.use_netrc
			verbose := a_other.verbose
			krb := a_other.krb
			reuse_forbid := a_other.reuse_forbid
			reuse_fresh := a_other.reuse_fresh
			ftp_use_epsv := a_other.ftp_use_epsv
			ftp_use_eprt := a_other.ftp_use_eprt
			ftp_use_pret := a_other.ftp_use_pret
			ftp_ssl := a_other.ftp_ssl
			ftpsslauth := a_other.ftpsslauth
			ftp_ccc := a_other.ftp_ccc
			no_signal := a_other.no_signal
			global_dns_cache := a_other.global_dns_cache
			tcp_nodelay := a_other.tcp_nodelay
			ignorecl := a_other.ignorecl
			ftp_skip_ip := a_other.ftp_skip_ip
			connect_only := a_other.connect_only
			ssh_auth_types := a_other.ssh_auth_types
			http_te_skip := a_other.http_te_skip
			http_ce_skip := a_other.http_ce_skip
			new_file_perms := a_other.new_file_perms
			new_directory_perms := a_other.new_directory_perms
			proxy_transfer_mode := a_other.proxy_transfer_mode
			str := a_other.str.twin
			scope := a_other.scope
			allowed_protocols := a_other.allowed_protocols
			redir_protocols := a_other.redir_protocols
			mail_rcpt := a_other.mail_rcpt
			rtspreq := a_other.rtspreq
			rtspversion := a_other.rtspversion
			wildcardmatch := a_other.wildcardmatch
			chunk_bgn := a_other.chunk_bgn
			chunk_end := a_other.chunk_end
			fnmatch := a_other.fnmatch
			fnmatch_data := a_other.fnmatch_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				err.is_equal (a_other.err) and
				debugdata.is_equal (a_other.debugdata) and
				errorbuffer.is_equal (a_other.errorbuffer) and
				proxyport = a_other.proxyport and
				out2.is_equal (a_other.out2) and
				in.is_equal (a_other.in) and
				writeheader.is_equal (a_other.writeheader) and
				rtp_out.is_equal (a_other.rtp_out) and
				use_port = a_other.use_port and
				httpauth = a_other.httpauth and
				proxyauth = a_other.proxyauth and
				followlocation = a_other.followlocation and
				maxredirs = a_other.maxredirs and
				post301 = a_other.post301 and
				post302 = a_other.post302 and
				free_referer = a_other.free_referer and
				postfields.is_equal (a_other.postfields) and
				seek_func.is_equal (a_other.seek_func) and
				postfieldsize = a_other.postfieldsize and
				localport = a_other.localport and
				localportrange = a_other.localportrange and
				fwrite_func.is_equal (a_other.fwrite_func) and
				fwrite_header.is_equal (a_other.fwrite_header) and
				fwrite_rtp.is_equal (a_other.fwrite_rtp) and
				fread_func.is_equal (a_other.fread_func) and
				is_fread_set = a_other.is_fread_set and
				is_fwrite_set = a_other.is_fwrite_set and
				fprogress.is_equal (a_other.fprogress) and
				fdebug.is_equal (a_other.fdebug) and
				ioctl_func.is_equal (a_other.ioctl_func) and
				fsockopt.is_equal (a_other.fsockopt) and
				sockopt_client.is_equal (a_other.sockopt_client) and
				fopensocket.is_equal (a_other.fopensocket) and
				opensocket_client.is_equal (a_other.opensocket_client) and
				seek_client.is_equal (a_other.seek_client) and
				convfromnetwork.is_equal (a_other.convfromnetwork) and
				convtonetwork.is_equal (a_other.convtonetwork) and
				convfromutf8.is_equal (a_other.convfromutf8) and
				progress_client.is_equal (a_other.progress_client) and
				ioctl_client.is_equal (a_other.ioctl_client) and
				timeout = a_other.timeout and
				connecttimeout = a_other.connecttimeout and
				server_response_timeout = a_other.server_response_timeout and
				tftp_blksize = a_other.tftp_blksize and
				infilesize = a_other.infilesize and
				low_speed_limit = a_other.low_speed_limit and
				low_speed_time = a_other.low_speed_time and
				max_send_speed = a_other.max_send_speed and
				max_recv_speed = a_other.max_recv_speed and
				set_resume_from = a_other.set_resume_from and
				headers.is_equal (a_other.headers) and
				httppost.is_equal (a_other.httppost) and
				cookiesession = a_other.cookiesession and
				crlf = a_other.crlf and
				quote.is_equal (a_other.quote) and
				postquote.is_equal (a_other.postquote) and
				prequote.is_equal (a_other.prequote) and
				source_quote.is_equal (a_other.source_quote) and
				source_prequote.is_equal (a_other.source_prequote) and
				source_postquote.is_equal (a_other.source_postquote) and
				telnet_options.is_equal (a_other.telnet_options) and
				timecondition = a_other.timecondition and
				timevalue = a_other.timevalue and
				httpreq = a_other.httpreq and
				httpversion = a_other.httpversion and
				ssl.is_equal (a_other.ssl) and
				proxytype = a_other.proxytype and
				dns_cache_timeout = a_other.dns_cache_timeout and
				buffer_size = a_other.buffer_size and
				private_data.is_equal (a_other.private_data) and
				one_easy.is_equal (a_other.one_easy) and
				http200aliases.is_equal (a_other.http200aliases) and
				ip_version = a_other.ip_version and
				max_filesize = a_other.max_filesize and
				ftp_filemethod = a_other.ftp_filemethod and
				ftp_create_missing_dirs = a_other.ftp_create_missing_dirs and
				ssh_keyfunc.is_equal (a_other.ssh_keyfunc) and
				ssh_keyfunc_userp.is_equal (a_other.ssh_keyfunc_userp) and
				printhost = a_other.printhost and
				get_filetime = a_other.get_filetime and
				tunnel_thru_httpproxy = a_other.tunnel_thru_httpproxy and
				prefer_ascii = a_other.prefer_ascii and
				ftp_append = a_other.ftp_append and
				ftp_list_only = a_other.ftp_list_only and
				ftp_use_port = a_other.ftp_use_port and
				hide_progress = a_other.hide_progress and
				http_fail_on_error = a_other.http_fail_on_error and
				http_follow_location = a_other.http_follow_location and
				http_disable_hostname_check_before_authentication = a_other.http_disable_hostname_check_before_authentication and
				include_header = a_other.include_header and
				http_set_referer = a_other.http_set_referer and
				http_auto_referer = a_other.http_auto_referer and
				opt_no_body = a_other.opt_no_body and
				set_port = a_other.set_port and
				upload = a_other.upload and
				use_netrc = a_other.use_netrc and
				verbose = a_other.verbose and
				krb = a_other.krb and
				reuse_forbid = a_other.reuse_forbid and
				reuse_fresh = a_other.reuse_fresh and
				ftp_use_epsv = a_other.ftp_use_epsv and
				ftp_use_eprt = a_other.ftp_use_eprt and
				ftp_use_pret = a_other.ftp_use_pret and
				ftp_ssl = a_other.ftp_ssl and
				ftpsslauth = a_other.ftpsslauth and
				ftp_ccc = a_other.ftp_ccc and
				no_signal = a_other.no_signal and
				global_dns_cache = a_other.global_dns_cache and
				tcp_nodelay = a_other.tcp_nodelay and
				ignorecl = a_other.ignorecl and
				ftp_skip_ip = a_other.ftp_skip_ip and
				connect_only = a_other.connect_only and
				ssh_auth_types = a_other.ssh_auth_types and
				http_te_skip = a_other.http_te_skip and
				http_ce_skip = a_other.http_ce_skip and
				new_file_perms = a_other.new_file_perms and
				new_directory_perms = a_other.new_directory_perms and
				proxy_transfer_mode = a_other.proxy_transfer_mode and
				str.is_equal (a_other.str) and
				scope = a_other.scope and
				allowed_protocols = a_other.allowed_protocols and
				redir_protocols = a_other.redir_protocols and
				mail_rcpt.is_equal (a_other.mail_rcpt) and
				rtspreq = a_other.rtspreq and
				rtspversion = a_other.rtspversion and
				wildcardmatch = a_other.wildcardmatch and
				chunk_bgn.is_equal (a_other.chunk_bgn) and
				chunk_end.is_equal (a_other.chunk_end) and
				fnmatch.is_equal (a_other.fnmatch) and
				fnmatch_data.is_equal (a_other.fnmatch_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("err"),
					create {CE_STRUCTURE_FIELD}.make ("debugdata"),
					create {CE_STRUCTURE_FIELD}.make ("errorbuffer"),
					create {CE_STRUCTURE_FIELD}.make ("proxyport"),
					create {CE_STRUCTURE_FIELD}.make ("out2"),
					create {CE_STRUCTURE_FIELD}.make ("in"),
					create {CE_STRUCTURE_FIELD}.make ("writeheader"),
					create {CE_STRUCTURE_FIELD}.make ("rtp_out"),
					create {CE_STRUCTURE_FIELD}.make ("use_port"),
					create {CE_STRUCTURE_FIELD}.make ("httpauth"),
					create {CE_STRUCTURE_FIELD}.make ("proxyauth"),
					create {CE_STRUCTURE_FIELD}.make ("followlocation"),
					create {CE_STRUCTURE_FIELD}.make ("maxredirs"),
					create {CE_STRUCTURE_FIELD}.make ("post301"),
					create {CE_STRUCTURE_FIELD}.make ("post302"),
					create {CE_STRUCTURE_FIELD}.make ("free_referer"),
					create {CE_STRUCTURE_FIELD}.make ("postfields"),
					create {CE_STRUCTURE_FIELD}.make ("seek_func"),
					create {CE_STRUCTURE_FIELD}.make ("postfieldsize"),
					create {CE_STRUCTURE_FIELD}.make ("localport"),
					create {CE_STRUCTURE_FIELD}.make ("localportrange"),
					create {CE_STRUCTURE_FIELD}.make ("fwrite_func"),
					create {CE_STRUCTURE_FIELD}.make ("fwrite_header"),
					create {CE_STRUCTURE_FIELD}.make ("fwrite_rtp"),
					create {CE_STRUCTURE_FIELD}.make ("fread_func"),
					create {CE_STRUCTURE_FIELD}.make ("is_fread_set"),
					create {CE_STRUCTURE_FIELD}.make ("is_fwrite_set"),
					create {CE_STRUCTURE_FIELD}.make ("fprogress"),
					create {CE_STRUCTURE_FIELD}.make ("fdebug"),
					create {CE_STRUCTURE_FIELD}.make ("ioctl_func"),
					create {CE_STRUCTURE_FIELD}.make ("fsockopt"),
					create {CE_STRUCTURE_FIELD}.make ("sockopt_client"),
					create {CE_STRUCTURE_FIELD}.make ("fopensocket"),
					create {CE_STRUCTURE_FIELD}.make ("opensocket_client"),
					create {CE_STRUCTURE_FIELD}.make ("seek_client"),
					create {CE_STRUCTURE_FIELD}.make ("convfromnetwork"),
					create {CE_STRUCTURE_FIELD}.make ("convtonetwork"),
					create {CE_STRUCTURE_FIELD}.make ("convfromutf8"),
					create {CE_STRUCTURE_FIELD}.make ("progress_client"),
					create {CE_STRUCTURE_FIELD}.make ("ioctl_client"),
					create {CE_STRUCTURE_FIELD}.make ("timeout"),
					create {CE_STRUCTURE_FIELD}.make ("connecttimeout"),
					create {CE_STRUCTURE_FIELD}.make ("server_response_timeout"),
					create {CE_STRUCTURE_FIELD}.make ("tftp_blksize"),
					create {CE_STRUCTURE_FIELD}.make ("infilesize"),
					create {CE_STRUCTURE_FIELD}.make ("low_speed_limit"),
					create {CE_STRUCTURE_FIELD}.make ("low_speed_time"),
					create {CE_STRUCTURE_FIELD}.make ("max_send_speed"),
					create {CE_STRUCTURE_FIELD}.make ("max_recv_speed"),
					create {CE_STRUCTURE_FIELD}.make ("set_resume_from"),
					create {CE_STRUCTURE_FIELD}.make ("headers"),
					create {CE_STRUCTURE_FIELD}.make ("httppost"),
					create {CE_STRUCTURE_FIELD}.make ("cookiesession"),
					create {CE_STRUCTURE_FIELD}.make ("crlf"),
					create {CE_STRUCTURE_FIELD}.make ("quote"),
					create {CE_STRUCTURE_FIELD}.make ("postquote"),
					create {CE_STRUCTURE_FIELD}.make ("prequote"),
					create {CE_STRUCTURE_FIELD}.make ("source_quote"),
					create {CE_STRUCTURE_FIELD}.make ("source_prequote"),
					create {CE_STRUCTURE_FIELD}.make ("source_postquote"),
					create {CE_STRUCTURE_FIELD}.make ("telnet_options"),
					create {CE_STRUCTURE_FIELD}.make ("timecondition"),
					create {CE_STRUCTURE_FIELD}.make ("timevalue"),
					create {CE_STRUCTURE_FIELD}.make ("httpreq"),
					create {CE_STRUCTURE_FIELD}.make ("httpversion"),
					create {CE_STRUCTURE_FIELD}.make ("ssl"),
					create {CE_STRUCTURE_FIELD}.make ("proxytype"),
					create {CE_STRUCTURE_FIELD}.make ("dns_cache_timeout"),
					create {CE_STRUCTURE_FIELD}.make ("buffer_size"),
					create {CE_STRUCTURE_FIELD}.make ("private_data"),
					create {CE_STRUCTURE_FIELD}.make ("one_easy"),
					create {CE_STRUCTURE_FIELD}.make ("http200aliases"),
					create {CE_STRUCTURE_FIELD}.make ("ip_version"),
					create {CE_STRUCTURE_FIELD}.make ("max_filesize"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_filemethod"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_create_missing_dirs"),
					create {CE_STRUCTURE_FIELD}.make ("ssh_keyfunc"),
					create {CE_STRUCTURE_FIELD}.make ("ssh_keyfunc_userp"),
					create {CE_STRUCTURE_FIELD}.make ("printhost"),
					create {CE_STRUCTURE_FIELD}.make ("get_filetime"),
					create {CE_STRUCTURE_FIELD}.make ("tunnel_thru_httpproxy"),
					create {CE_STRUCTURE_FIELD}.make ("prefer_ascii"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_append"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_list_only"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_use_port"),
					create {CE_STRUCTURE_FIELD}.make ("hide_progress"),
					create {CE_STRUCTURE_FIELD}.make ("http_fail_on_error"),
					create {CE_STRUCTURE_FIELD}.make ("http_follow_location"),
					create {CE_STRUCTURE_FIELD}.make ("http_disable_hostname_check_before_authentication"),
					create {CE_STRUCTURE_FIELD}.make ("include_header"),
					create {CE_STRUCTURE_FIELD}.make ("http_set_referer"),
					create {CE_STRUCTURE_FIELD}.make ("http_auto_referer"),
					create {CE_STRUCTURE_FIELD}.make ("opt_no_body"),
					create {CE_STRUCTURE_FIELD}.make ("set_port"),
					create {CE_STRUCTURE_FIELD}.make ("upload"),
					create {CE_STRUCTURE_FIELD}.make ("use_netrc"),
					create {CE_STRUCTURE_FIELD}.make ("verbose"),
					create {CE_STRUCTURE_FIELD}.make ("krb"),
					create {CE_STRUCTURE_FIELD}.make ("reuse_forbid"),
					create {CE_STRUCTURE_FIELD}.make ("reuse_fresh"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_use_epsv"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_use_eprt"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_use_pret"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_ssl"),
					create {CE_STRUCTURE_FIELD}.make ("ftpsslauth"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_ccc"),
					create {CE_STRUCTURE_FIELD}.make ("no_signal"),
					create {CE_STRUCTURE_FIELD}.make ("global_dns_cache"),
					create {CE_STRUCTURE_FIELD}.make ("tcp_nodelay"),
					create {CE_STRUCTURE_FIELD}.make ("ignorecl"),
					create {CE_STRUCTURE_FIELD}.make ("ftp_skip_ip"),
					create {CE_STRUCTURE_FIELD}.make ("connect_only"),
					create {CE_STRUCTURE_FIELD}.make ("ssh_auth_types"),
					create {CE_STRUCTURE_FIELD}.make ("http_te_skip"),
					create {CE_STRUCTURE_FIELD}.make ("http_ce_skip"),
					create {CE_STRUCTURE_FIELD}.make ("new_file_perms"),
					create {CE_STRUCTURE_FIELD}.make ("new_directory_perms"),
					create {CE_STRUCTURE_FIELD}.make ("proxy_transfer_mode"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("str", <<37>>),
					create {CE_STRUCTURE_FIELD}.make ("scope"),
					create {CE_STRUCTURE_FIELD}.make ("allowed_protocols"),
					create {CE_STRUCTURE_FIELD}.make ("redir_protocols"),
					create {CE_STRUCTURE_FIELD}.make ("mail_rcpt"),
					create {CE_STRUCTURE_FIELD}.make ("rtspreq"),
					create {CE_STRUCTURE_FIELD}.make ("rtspversion"),
					create {CE_STRUCTURE_FIELD}.make ("wildcardmatch"),
					create {CE_STRUCTURE_FIELD}.make ("chunk_bgn"),
					create {CE_STRUCTURE_FIELD}.make ("chunk_end"),
					create {CE_STRUCTURE_FIELD}.make ("fnmatch"),
					create {CE_STRUCTURE_FIELD}.make ("fnmatch_data")
				>>)
			init_structure_info
		end

end
