class
	P_CURL_ADDRINFO

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_freeaddrinfo (a_cahead: CE_POINTER [PD_CURL_ADDRINFO])
		local
			l_canext: CE_POINTER [PD_CURL_ADDRINFO]
			l_ca: CE_POINTER [PD_CURL_ADDRINFO]
		do
			create l_canext.make
			create l_ca.make

			l_ca := a_cahead
			from
			until
				l_ca.is_void
			loop
				if (not (l_ca.item.ai_addr).is_void) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ca.item.ai_addr)])
				end
				if (not (l_ca.item.ai_canonname).is_void) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ca.item.ai_canonname)])
				end
				l_canext := l_ca.item.ai_next
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ca)])
				l_ca := l_canext
			end
		end

	Curl_getaddrinfo_ex (a_nodename: CE_POINTER [INTEGER_8]; a_servname: CE_POINTER [INTEGER_8]; a_hints: CE_POINTER [SD_ADDRINFO]; a_result: CE_POINTER [CE_POINTER [PD_CURL_ADDRINFO]]): INTEGER_32
		local
			l_ainext: CE_POINTER [SD_ADDRINFO]
			l_ai: CE_POINTER [SD_ADDRINFO]
			l_aihead: CE_ARRAY [CE_POINTER [SD_ADDRINFO]]
			l_cafirst: CE_POINTER [PD_CURL_ADDRINFO]
			l_calast: CE_POINTER [PD_CURL_ADDRINFO]
			l_ca: CE_POINTER [PD_CURL_ADDRINFO]
			l_error: INTEGER_32
			l_tmp___0: CE_POINTER [SD_SOCKADDR]
			l_tmp___2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_ainext.make
			create l_ai.make
			create l_aihead.make (<<1>>)
			create l_cafirst.make
			create l_calast.make
			create l_ca.make
			create l_tmp___0.make
			create l_tmp___2.make

			l_cafirst := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
			l_calast := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
			a_result.item := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
			l_error := getaddrinfo (a_nodename, a_servname, a_hints, l_aihead)
			if l_error.to_boolean then
				Result := l_error
				js.return
			end
			if not js.return_called then
				l_ai := l_aihead.item
				from
				until
					not (not js.loop_done and then (not l_ai.is_void))
				loop
					l_ca := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(create {PD_CURL_ADDRINFO}.make).structure_size.to_natural_32]))))
					if l_ca.is_void then
						l_error := -10
						js.break
					end
					if not js.loop_jumped then
						l_ca.item.ai_flags := l_ai.item.ai_flags
						l_ca.item.ai_family := l_ai.item.ai_family
						l_ca.item.ai_socktype := l_ai.item.ai_socktype
						l_ca.item.ai_protocol := l_ai.item.ai_protocol
						l_ca.item.ai_addrlen := (0).to_natural_32
						l_ca.item.ai_addr := create {CE_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
						l_ca.item.ai_canonname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_ca.item.ai_next := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
						if l_ai.item.ai_addrlen > {NATURAL_32} 0 then
							if not (l_ai.item.ai_addr).is_void then
								l_ca.item.ai_addrlen := l_ai.item.ai_addrlen
								l_tmp___0 := create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_ca.item.ai_addrlen]))))
								l_ca.item.ai_addr := l_tmp___0
								if l_tmp___0.is_void then
									l_error := -10
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ca)])
									js.break
								end
								if not js.loop_jumped then
									memcpy (create {CE_POINTER [ANY]}.make_cast (l_ca.item.ai_addr), create {CE_POINTER [ANY]}.make_cast (l_ai.item.ai_addr), l_ca.item.ai_addrlen).do_nothing
								end
							end
						end
					end
					if not js.loop_jumped and then (not (l_ai.item.ai_canonname).is_void) then
						l_tmp___2 := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_ai.item.ai_canonname]))
						l_ca.item.ai_canonname := l_tmp___2
						if l_tmp___2.is_void then
							l_error := -10
							if (not (l_ca.item.ai_addr).is_void) then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ca.item.ai_addr)])
							end
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ca)])
							js.break
						end
					end
					if not js.loop_jumped then
						if l_cafirst.is_void then
							l_cafirst := l_ca
						end
						if (not l_calast.is_void) then
							l_calast.item.ai_next := l_ca
						end
						l_calast := l_ca
						l_ainext := l_ai.item.ai_next
						l_ai := l_ainext
					end
				end
				if (not (l_aihead.item).is_void) then
					freeaddrinfo (l_aihead.item)
				end
				if l_error.to_boolean then
					Curl_freeaddrinfo (l_cafirst)
					l_cafirst := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
				end
				a_result.item := l_cafirst
				Result := l_error
			end
		end

	Curl_he2ai (a_he: CE_POINTER [SD_HOSTENT]; a_port: INTEGER_32): CE_POINTER [PD_CURL_ADDRINFO]
		local
			l_ai: CE_POINTER [PD_CURL_ADDRINFO]
			l_prevai: CE_POINTER [PD_CURL_ADDRINFO]
			l_firstai: CE_POINTER [PD_CURL_ADDRINFO]
			l_addr: CE_POINTER [SD_SOCKADDR_IN]
			l_addr6: CE_POINTER [SD_SOCKADDR_IN6]
			l_result: NATURAL_32
			l_i: INTEGER_32
			l_curr: CE_POINTER [INTEGER_8]
			l_ss_size: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [SD_SOCKADDR]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ai.make
			create l_prevai.make
			create l_firstai.make
			create l_addr.make
			create l_addr6.make
			create l_curr.make
			create l_tmp___0.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_prevai := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
					l_firstai := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
					l_result := {PC_CURLCODE}.CURLE_OK
					if a_he.is_void then
						Result := (create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_i := 0
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						l_curr := a_he.item.h_addr_list[l_i]
						if l_curr.is_void then
							js.break
						end
						if not js.loop_jumped then
							if a_he.item.h_addrtype = 10 then
								l_ss_size := (create {SD_SOCKADDR_IN6}.make).structure_size.to_natural_32
							else
								l_ss_size := (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32
							end
							l_ai := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, (create {PD_CURL_ADDRINFO}.make).structure_size.to_natural_32]))))
							if l_ai.is_void then
								l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
								js.break
							end
						end
						if not js.loop_jumped then
							l_tmp___0 := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_he.item.h_name]))
							l_ai.item.ai_canonname := l_tmp___0
							if l_tmp___0.is_void then
								l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ai)])
								js.break
							end
						end
						if not js.loop_jumped then
							l_tmp___1 := create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, l_ss_size]))))
							l_ai.item.ai_addr := l_tmp___1
							if l_tmp___1.is_void then
								l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ai.item.ai_canonname)])
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ai)])
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if l_firstai.is_void then
							l_firstai := l_ai
						end
						if (not l_prevai.is_void) then
							l_prevai.item.ai_next := l_ai
						end
						l_ai.item.ai_family := a_he.item.h_addrtype
						l_ai.item.ai_socktype := 1
						l_ai.item.ai_addrlen := l_ss_size
						inspect l_ai.item.ai_family -- switch 1 head
						when 2 then l_pos := -1 + 5
						when 10 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 5 then -- switch 1, case 2
						l_addr := create {CE_POINTER [SD_SOCKADDR_IN]}.make_cast (l_ai.item.ai_addr)
						memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_IN_ADDR]}.make_shared (l_addr.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr")))), create {CE_POINTER [ANY]}.make_cast (l_curr), (create {SD_IN_ADDR}.make).structure_size.to_natural_32).do_nothing
						l_addr.item.sin_family := (a_he.item.h_addrtype).to_natural_16
						l_addr.item.sin_port := htons (a_port.to_natural_16)
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, case 10
						l_addr6 := create {CE_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_ai.item.ai_addr)
						memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (l_addr6.c_pointer + (create {SD_SOCKADDR_IN6}.make).offset_of ("sin6_addr")))), create {CE_POINTER [ANY]}.make_cast (l_curr), (create {SD_IN6_ADDR}.make).structure_size.to_natural_32).do_nothing
						l_addr6.item.sin6_family := (a_he.item.h_addrtype).to_natural_16
						l_addr6.item.sin6_port := htons (a_port.to_natural_16)
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_prevai := l_ai
						l_i := l_i + 1
				when 8 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done
						if l_result /= {NATURAL_32} 0 then
							Curl_freeaddrinfo (l_firstai)
							l_firstai := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
						end
						Result := l_firstai
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_ip2addr (a_af: INTEGER_32; a_inaddr: CE_POINTER [ANY]; a_hostname: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): CE_POINTER [PD_CURL_ADDRINFO]
		local
			l_ai: CE_POINTER [PD_CURL_ADDRINFO]
			l_h: CE_POINTER [SD_HOSTENT]
			l_buf: CE_POINTER [PD_NAMEBUFF]
			l_addrentry: CE_POINTER [INTEGER_8]
			l_hoststr: CE_POINTER [INTEGER_8]
			l_addrsize: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ai.make
			create l_h.make
			create l_buf.make
			create l_addrentry.make
			create l_hoststr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf := create {CE_POINTER [PD_NAMEBUFF]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(create {PD_NAMEBUFF}.make).structure_size.to_natural_32]))))
					if l_buf.is_void then
						Result := (create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_hoststr := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_hostname]))
						if l_hoststr.is_void then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_buf)])
							Result := (create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect a_af -- switch 1 head
						when 2 then l_pos := -1 + 2
						when 10 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 2
						l_addrsize := (create {SD_IN_ADDR}.make).structure_size.to_natural_32
						l_addrentry := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [SD_IN_ADDR]}.make_shared (l_buf.c_pointer + (create {PD_NAMEBUFF}.make).offset_of ("addrentry") + (create {PD_ADDRENTRY}.make).offset_of ("ina4"))))
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_addrentry), a_inaddr, (create {SD_IN_ADDR}.make).structure_size.to_natural_32).do_nothing
						l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 10
						l_addrsize := (create {SD_IN6_ADDR}.make).structure_size.to_natural_32
						l_addrentry := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (l_buf.c_pointer + (create {PD_NAMEBUFF}.make).offset_of ("addrentry") + (create {PD_ADDRENTRY}.make).offset_of ("ina6"))))
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_addrentry), a_inaddr, (create {SD_IN6_ADDR}.make).structure_size.to_natural_32).do_nothing
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_hoststr)])
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_buf)])
						Result := (create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer))
						js.return
				when 5 then -- switch 1, done: | if done
						if not js.return_called then
							l_h := create {CE_POINTER [SD_HOSTENT]}.make_shared (l_buf.c_pointer + (create {PD_NAMEBUFF}.make).offset_of ("hostentry"))
							l_h.item.h_name := l_hoststr
							l_h.item.h_aliases := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer)
							l_h.item.h_addrtype := (a_af.to_integer_16).to_integer_32
							l_h.item.h_length := (l_addrsize.to_integer_16).to_integer_32
							l_h.item.h_addr_list := l_buf.item.h_addr_list + 0
							l_h.item.h_addr_list[0] := l_addrentry
							l_h.item.h_addr_list[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							l_ai := Curl_he2ai (l_h, a_port)
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_hoststr)])
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_buf)])
							Result := l_ai
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
