class
	P_CURL_FNMATCH

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_fnmatch (a_ptr: CE_POINTER [ANY]; a_pattern: CE_POINTER [INTEGER_8]; a_string: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_pattern.is_void then
				Result := 2
				js.return
			elseif a_string.is_void then
				Result := 2
				js.return
			end
			if not js.return_called then
				Result := (loop2 (create {CE_POINTER [NATURAL_8]}.make_cast (a_pattern), create {CE_POINTER [NATURAL_8]}.make_cast (a_string)))
			end
		end

	Curl_fnmatch_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_fnmatch)
		end

	loop2 (a_pattern: CE_POINTER [NATURAL_8]; a_string: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_state___3: NATURAL_32
			l_p: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_charset: CE_ARRAY [NATURAL_8]
			l_rc: INTEGER_32
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_found: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make
			create l_s.make
			create l_charset.make (<<({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 15).to_integer_32>>)
			create l_pp.make (<<1>>)
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state___3 := {PC_LOOP_STATE}.CURLFNM_LOOP_DEFAULT
					l_p := a_pattern
					l_s := a_string
					l_charset[0] := (0).to_natural_8
					l_rc := 0
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body:
						inspect l_state___3.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 0
						if (l_p.item).to_integer_32 = 42 then
							from
							until
								(l_p[1]).to_integer_32 /= 42
							loop
								l_p := l_p + 1
							end
							if (l_s.item).to_integer_32 = 0 then
								if (l_p[1]).to_integer_32 = 0 then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								l_rc := loop2 ((l_p + 1), l_s)
								if l_rc = 0 then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								if (l_s.item).to_boolean then
									l_s := l_s + 1
								else
									Result := 1
									js.return
								end
							end
						elseif (l_p.item).to_integer_32 = 63 then
							if ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (16_384)).to_boolean then
								l_s := l_s + 1
								l_p := l_p + 1
							elseif (l_s.item).to_integer_32 = 0 then
								Result := 1
								js.return
							else
								Result := 2
								js.return
							end
						elseif (l_p.item).to_integer_32 = 0 then
							if (l_s.item).to_integer_32 = 0 then
								Result := 0
								js.return
							else
								Result := 1
								js.return
							end
						elseif (l_p.item).to_integer_32 = 92 then
							l_state___3 := {PC_LOOP_STATE}.CURLFNM_LOOP_BACKSLASH
							l_p := l_p + 1
						elseif (l_p.item).to_integer_32 = 91 then
							l_pp.item := l_p + 1
							if (setcharset (l_pp, l_charset)).to_boolean then
								l_found := 0
								if (l_charset[((l_s.item).to_natural_32).to_integer_32]).to_boolean then
									l_found := 1
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 1).to_integer_32]).to_boolean then
									l_found := ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (8))
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 4).to_integer_32]).to_boolean then
									l_found := ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (1_024))
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 2).to_integer_32]).to_boolean then
									l_found := ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (2_048))
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 3).to_integer_32]).to_boolean then
									l_found := ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (4_096))
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 5).to_integer_32]).to_boolean then
									l_found := ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (16_384))
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 9).to_integer_32]).to_boolean then
									l_found := ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (8_192))
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 10).to_integer_32]).to_boolean then
									l_found := ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (256))
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 7).to_integer_32]).to_boolean then
									l_found := ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (512))
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 6).to_integer_32]).to_boolean then
									if (l_s.item).to_integer_32 = 32 then
										l_tmp___8 := 1
									elseif (l_s.item).to_integer_32 = 9 then
										l_tmp___8 := 1
									else
										l_tmp___8 := 0
									end
									l_found := l_tmp___8
								elseif (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 8).to_integer_32]).to_boolean then
									l_found := ((((ctype_b_loc).item[(l_s.item).to_integer_32]).to_integer_32).bit_and (32_768))
								end
								if (l_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256).to_integer_32]).to_boolean then
									l_found := (not l_found.to_boolean).to_integer
								end
								if l_found.to_boolean then
									l_p := l_pp.item + 1
									l_s := l_s + 1
									memset (create {CE_POINTER [ANY]}.make_cast (l_charset), 0, {PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 15).do_nothing
								else
									Result := 1
									js.return
								end
							else
								Result := 2
								js.return
							end
						else
							l_tmp___11 := l_p
							l_p := l_p + 1
							l_tmp___12 := l_s
							l_s := l_s + 1
							if (l_tmp___11.item).to_integer_32 /= (l_tmp___12.item).to_integer_32 then
								Result := 1
								js.return
							end
						end
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 1
						if ((((ctype_b_loc).item[(l_p.item).to_integer_32]).to_integer_32).bit_and (16_384)).to_boolean then
							l_tmp___13 := l_p
							l_p := l_p + 1
							l_tmp___14 := l_s
							l_s := l_s + 1
							if (l_tmp___13.item).to_integer_32 = (l_tmp___14.item).to_integer_32 then
								l_state___3 := {PC_LOOP_STATE}.CURLFNM_LOOP_DEFAULT
							else
								Result := 1
								js.return
							end
						else
							Result := 2
							js.return
						end
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
						l_pos := -1 + 1 -- back to loop condition
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parsekeyword (a_pattern: CE_POINTER [CE_POINTER [NATURAL_8]]; a_charset: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_state___3: NATURAL_32
			l_keyword: CE_ARRAY [INTEGER_8]
			l_found: INTEGER_32
			l_i: INTEGER_32
			l_p: CE_POINTER [NATURAL_8]
			l_c: INTEGER_8
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_keyword.make (<<10>>)
			create l_p.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state___3 := {PC_PARSEKEY_STATE}.CURLFNM_PKW_INIT
					l_keyword[0] := (0).to_integer_8
					l_keyword[1] := (0).to_integer_8
					l_keyword[2] := (0).to_integer_8
					l_keyword[3] := (0).to_integer_8
					l_keyword[4] := (0).to_integer_8
					l_keyword[5] := (0).to_integer_8
					l_keyword[6] := (0).to_integer_8
					l_keyword[7] := (0).to_integer_8
					l_keyword[8] := (0).to_integer_8
					l_keyword[9] := (0).to_integer_8
					l_found := 0
					l_p := a_pattern.item
					l_i := 0
				when 1 then -- loop condition:
					if not (not js.loop_done and then (not l_found.to_boolean)) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_tmp := l_p
						l_p := l_p + 1
						l_c := (l_tmp.item).to_integer_8
						if l_i >= 10 then
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						inspect l_state___3.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 4 then -- switch 1, case 0
						if not (((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if ((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
							l_keyword[l_i] := l_c
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_c.to_integer_32 = 58 then
							l_state___3 := {PC_PARSEKEY_STATE}.CURLFNM_PKW_DDOT
						else
							Result := 0
							js.return
						end
				when 8 then
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, case 1
						if l_c.to_integer_32 = 93 then
							l_found := 1
						else
							Result := 0
							js.return
						end
				when 10 then -- switch 1, done: | if done
						if not js.return_called then
							l_i := l_i + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					if not js.return_called then
						a_pattern.item := l_p
						if (strcmp (l_keyword, ce_string ("digit"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 2).to_integer_32] := (1).to_natural_8
						elseif (strcmp (l_keyword, ce_string ("alnum"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 1).to_integer_32] := (1).to_natural_8
						elseif (strcmp (l_keyword, ce_string ("alpha"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 4).to_integer_32] := (1).to_natural_8
						elseif (strcmp (l_keyword, ce_string ("xdigit"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 3).to_integer_32] := (1).to_natural_8
						elseif (strcmp (l_keyword, ce_string ("print"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 5).to_integer_32] := (1).to_natural_8
						elseif (strcmp (l_keyword, ce_string ("graph"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 8).to_integer_32] := (1).to_natural_8
						elseif (strcmp (l_keyword, ce_string ("space"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 9).to_integer_32] := (1).to_natural_8
						elseif (strcmp (l_keyword, ce_string ("blank"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 6).to_integer_32] := (1).to_natural_8
						elseif (strcmp (l_keyword, ce_string ("upper"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 10).to_integer_32] := (1).to_natural_8
						elseif (strcmp (l_keyword, ce_string ("lower"))) = 0 then
							a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256 + {NATURAL_32} 7).to_integer_32] := (1).to_natural_8
						else
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						Result := 1
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	setcharset (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_charset: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_state___3: NATURAL_32
			l_rangestart: NATURAL_8
			l_lastchar: NATURAL_8
			l_something_found: BOOLEAN
			l_c: NATURAL_8
			l_c2: INTEGER_8
			l_tmp___6: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_DEFAULT
					l_rangestart := (0).to_natural_8
					l_lastchar := (0).to_natural_8
					l_something_found := (0).to_boolean
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 46 -- skip loop
					end
				when 2 then -- loop body:
						l_c := (a_p.item).item
						inspect l_state___3.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 26
						when 2 then l_pos := -1 + 27
						when 3 then l_pos := -1 + 42
						when 4 then l_pos := -1 + 44
						else l_pos := -1 + 45
						end
				when 3 then -- switch 1, case 0
						if not (((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (8)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_rangestart := l_c
						a_charset[l_c.to_integer_32] := (1).to_natural_8
						a_p.item := (a_p.item) + 1
						l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_MAYRANGE
						l_something_found := (1).to_boolean
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else:
						if l_c.to_integer_32 /= 93 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_something_found then
							Result := 1
							js.return
						else
							l_something_found := (1).to_boolean
						end
						if not js.return_called then
							l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_RIGHTBR
							a_charset[l_c.to_integer_32] := (1).to_natural_8
							a_p.item := (a_p.item) + 1
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 9 then -- else:
						if l_c.to_integer_32 /= 91 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_c2 := (a_p.item[1]).to_integer_8
						if l_c2.to_integer_32 = 58 then
							a_p.item := a_p.item + (2)
							if (parsekeyword (a_p, a_charset)).to_boolean then
								l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_DEFAULT
							else
								Result := 0
								js.return
							end
						else
							a_charset[l_c.to_integer_32] := (1).to_natural_8
							a_p.item := (a_p.item) + 1
						end
						if not js.return_called then
							l_something_found := (1).to_boolean
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else:
						if l_c.to_integer_32 /= 63 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_something_found := (1).to_boolean
						a_charset[l_c.to_integer_32] := (1).to_natural_8
						a_p.item := (a_p.item) + 1
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						if l_c.to_integer_32 /= 42 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_something_found := (1).to_boolean
						a_charset[l_c.to_integer_32] := (1).to_natural_8
						a_p.item := (a_p.item) + 1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if l_c.to_integer_32 /= 94 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						if l_c.to_integer_32 /= 33 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if: | _L:
						if not l_something_found then
							if (a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256).to_integer_32]).to_boolean then
								a_charset[l_c.to_integer_32] := (1).to_natural_8
								l_something_found := (1).to_boolean
							else
								a_charset[({PLATFORM}.Integer_8_bytes.to_natural_32 * {NATURAL_32} 256).to_integer_32] := (1).to_natural_8
							end
						else
							a_charset[l_c.to_integer_32] := (1).to_natural_8
						end
						a_p.item := (a_p.item) + 1
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						if l_c.to_integer_32 = 92 then
							a_p.item := (a_p.item) + 1
							l_c := (a_p.item).item
							if ((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (16_384)).to_boolean then
								l_something_found := (1).to_boolean
								l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_MAYRANGE
								a_charset[l_c.to_integer_32] := (1).to_natural_8
								l_rangestart := l_c
								a_p.item := (a_p.item) + 1
							else
								Result := 0
								js.return
							end
						elseif l_c.to_integer_32 = 0 then
							Result := 0
							js.return
						else
							a_charset[l_c.to_integer_32] := (1).to_natural_8
							a_p.item := (a_p.item) + 1
							l_something_found := (1).to_boolean
						end
				when 25 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 45 -- switch 1; break
				when 26 then -- switch 1, case 1
						if l_c.to_integer_32 = 45 then
							a_charset[l_c.to_integer_32] := (1).to_natural_8
							a_p.item := (a_p.item) + 1
							l_lastchar := (('-').code).to_natural_8
							l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_MAYRANGE2
						elseif l_c.to_integer_32 = 91 then
							l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_DEFAULT
						elseif ((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							a_charset[l_c.to_integer_32] := (1).to_natural_8
							a_p.item := (a_p.item) + 1
						elseif l_c.to_integer_32 = 92 then
							a_p.item := (a_p.item) + 1
							l_c := (a_p.item).item
							if ((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (16_384)).to_boolean then
								a_charset[l_c.to_integer_32] := (1).to_natural_8
								a_p.item := (a_p.item) + 1
							else
								Result := 0
								js.return
							end
						elseif l_c.to_integer_32 = 93 then
							Result := 1
							js.return
						else
							Result := 0
							js.return
						end
						l_pos := -1 + 45 -- switch 1; break
				when 27 then -- switch 1, case 2
						if l_c.to_integer_32 = 92 then
							a_p.item := (a_p.item) + 1
							l_c := (a_p.item).item
							if not ((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (16_384)).to_boolean then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if l_c.to_integer_32 = 93 then
								Result := 1
								js.return
							elseif l_c.to_integer_32 = 92 then
								a_p.item := (a_p.item) + 1
								l_c := (a_p.item).item
								if ((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (16_384)).to_boolean then
									a_charset[l_c.to_integer_32] := (1).to_natural_8
									l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_DEFAULT
									a_p.item := (a_p.item) + 1
								else
									Result := 0
									js.return
								end
							end
						end
						if not (not js.return_called and then (l_c.to_integer_32 >= l_rangestart.to_integer_32)) then
							l_pos := -1 + 41 -- skip if block
						end
				when 28 then -- if:
						if not (((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (512)).to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if ((((ctype_b_loc).item[l_rangestart.to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
							l_pos := -1 + 36 -- goto _L___0
						else
							l_pos := -1 + 31 -- goto _L___2
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 31 then -- else: | _L___2:
						if not (((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if ((((ctype_b_loc).item[l_rangestart.to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							l_pos := -1 + 36 -- goto _L___0
						else
							l_pos := -1 + 34 -- goto _L___1
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 34 then -- else: | _L___1:
						if not (((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (256)).to_boolean) then
							l_pos := -1 + 40 -- skip if block
						end
				when 35 then -- if:
						if not (((((ctype_b_loc).item[l_rangestart.to_integer_32]).to_integer_32).bit_and (256)).to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if: | _L___0:
						a_charset[l_lastchar.to_integer_32] := (0).to_natural_8
						l_rangestart := (l_rangestart.to_integer_32 + 1).to_natural_8
						from
						until
							js.loop_done
						loop
							l_tmp___6 := l_rangestart
							l_rangestart := (l_rangestart.to_integer_32 + 1).to_natural_8
							if not (l_tmp___6 <= l_c.to_integer_32) then
								js.break
							end
							if not js.loop_jumped then
								a_charset[(l_rangestart.to_integer_32 - 1)] := (1).to_natural_8
							end
						end
						a_p.item := (a_p.item) + 1
						l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_DEFAULT
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else:
						Result := 0
						js.return
				when 39 then -- if done | if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else:
						Result := 0
						js.return
				when 41 then -- if done | if done | if done
						l_pos := -1 + 45 -- switch 1; break
				when 42 then -- switch 1, case 3
						if l_c.to_integer_32 = 91 then
							l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_RIGHTBRLEFTBR
							a_charset[l_c.to_integer_32] := (1).to_natural_8
							a_p.item := (a_p.item) + 1
						elseif l_c.to_integer_32 = 93 then
							Result := 1
							js.return
						elseif l_c.to_integer_32 = 0 then
							Result := 0
							js.return
						elseif ((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (16_384)).to_boolean then
							a_charset[l_c.to_integer_32] := (1).to_natural_8
							a_p.item := (a_p.item) + 1
							l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_DEFAULT
						else
							l_pos := -1 + 47 -- goto fail
						end
				when 43 then
						l_pos := -1 + 45 -- switch 1; break
				when 44 then -- switch 1, case 4
						if l_c.to_integer_32 = 93 then
							Result := 1
							js.return
						else
							l_state___3 := {PC_SETCHARSET_STATE}.CURLFNM_SCHS_DEFAULT
							a_charset[l_c.to_integer_32] := (1).to_natural_8
							a_p.item := (a_p.item) + 1
						end
						l_pos := -1 + 45 -- switch 1; break
				when 45 then -- switch 1, done:
						l_pos := -1 + 1 -- back to loop condition
				when 46 then -- loop done
					if js.return_called then
						l_pos := -1 + 48 -- skip if block
					end
				when 47 then -- if: | fail:
						Result := 0
				when 48 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
