class
	P_FTPLISTPARSER

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_ftp_parselist (a_buffer: CE_POINTER [INTEGER_8]; a_size: NATURAL_32; a_nmemb: NATURAL_32; a_connptr: CE_POINTER [ANY]): NATURAL_32
		local
			l_bufflen: NATURAL_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_parser: CE_POINTER [PD_FTP_PARSELIST_DATA]
			l_finfo: CE_POINTER [PD_CURL_FILEINFO]
			l_i: NATURAL_32
			l_rc: NATURAL_32
			l_c: INTEGER_8
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_endptr: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_perm: NATURAL_32
			l_p: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_hlinks: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_fsize: INTEGER_64
			l_endptr___0: CE_ARRAY [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_conn.make
			create l_parser.make
			create l_finfo.make
			create l_tmp___1.make
			create l_endptr.make (<<1>>)
			create l_p.make (<<1>>)
			create l_p___0.make (<<1>>)
			create l_endptr___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bufflen := a_size * a_nmemb
					l_conn := create {CE_POINTER [PD_CONNECTDATA]}.make_cast (a_connptr)
					l_parser := (create {CE_POINTER [PD_FTP_WC_TMPDATA]}.make_cast ((l_conn.item.data).item.wildcard.tmp)).item.parser
					l_i := {NATURAL_32} 0
					if (l_parser.item.error).to_boolean then
						Result := l_bufflen
						js.return
					end
					if js.return_called then
						l_pos := -1 + 94 -- skip if block
					end
				when 1 then -- if:
						if l_parser.item.os_type = {NATURAL_32} 0 then
							if l_bufflen > {NATURAL_32} 0 then
								if (a_buffer[0]).to_integer_32 >= 48 then
									if (a_buffer[0]).to_integer_32 <= 57 then
										l_parser.item.os_type := {PC_OS_TYPE}.OS_TYPE_WIN_NT
									else
										l_parser.item.os_type := {PC_OS_TYPE}.OS_TYPE_UNIX
									end
								else
									l_parser.item.os_type := {PC_OS_TYPE}.OS_TYPE_UNIX
								end
							end
						end
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_i < l_bufflen.to_natural_32)) then
							l_pos := -1 + 94 -- skip loop
						end
				when 3 then -- loop body:
						l_c := a_buffer[l_i.to_integer_32]
						if (l_parser.item.file_data).is_void then
							l_parser.item.file_data := fileinfo_inst.Curl_fileinfo_alloc
							if (l_parser.item.file_data).is_void then
								l_parser.item.error := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
								Result := l_bufflen
								js.return
							end
							if not js.return_called then
								(l_parser.item.file_data).item.b_data := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(160).to_natural_32]))))
								if ((l_parser.item.file_data).item.b_data).is_void then
									PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									Result := l_bufflen
									js.return
								end
							end
							if not js.return_called then
								(l_parser.item.file_data).item.b_size := (160).to_natural_32
								l_parser.item.item_offset := (0).to_natural_32
								l_parser.item.item_length := {NATURAL_32} 0
							end
						end
						if not js.return_called then
							l_finfo := l_parser.item.file_data
							l_tmp___0 := l_finfo.item.b_used
							l_finfo.item.b_used := (l_finfo.item.b_used) + 1
							l_finfo.item.b_data[l_tmp___0.to_integer_32] := l_c
							if l_finfo.item.b_used >= l_finfo.item.b_size - {NATURAL_32} 1 then
								l_tmp___1 := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_finfo.item.b_data), l_finfo.item.b_size + {NATURAL_32} 160]))))
								if (not l_tmp___1.is_void) then
									l_finfo.item.b_size := l_finfo.item.b_size + ({NATURAL_32} 160)
									l_finfo.item.b_data := l_tmp___1
								else
									fileinfo_inst.Curl_fileinfo_dtor (create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (l_parser.item.file_data))
									l_parser.item.file_data := create {CE_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer)
									l_parser.item.error := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
									PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									Result := l_bufflen
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 93 -- skip if block
						end
				when 4 then -- if:
						inspect (l_parser.item.os_type).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 62
						else l_pos := -1 + 92
						end
				when 5 then -- switch 1, case 1
						inspect (l_parser.item.state.UNIX.main).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 6
						when 1 then l_pos := -1 + 10
						when 2 then l_pos := -1 + 21
						when 3 then l_pos := -1 + 22
						when 4 then l_pos := -1 + 26
						when 5 then l_pos := -1 + 30
						when 6 then l_pos := -1 + 34
						when 7 then l_pos := -1 + 38
						when 8 then l_pos := -1 + 46
						when 9 then l_pos := -1 + 51
						else l_pos := -1 + 61
						end
				when 6 then -- switch 2, case 0
						inspect (l_parser.item.state.UNIX.sub.total_dirsize).to_integer_32 -- switch 3 head
						when 0 then l_pos := -1 + 7
						when 1 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 7 then -- switch 3, case 0
						if l_c.to_integer_32 = 116 then
							l_parser.item.state.UNIX.sub.total_dirsize := {PC_TOTAL_DIRSIZE}.PL_UNIX_TOTALSIZE_READING
							l_parser.item.item_length := (l_parser.item.item_length) + 1
						else
							l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_FILETYPE
							l_finfo.item.b_used := (0).to_natural_32
							l_i := l_i - 1
						end
						l_pos := -1 + 9 -- switch 3; break
				when 8 then -- switch 3, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 13 then
							l_parser.item.item_length := (l_parser.item.item_length) - 1
							l_finfo.item.b_used := (l_finfo.item.b_used) - 1
						elseif l_c.to_integer_32 = 10 then
							l_finfo.item.b_data[(l_parser.item.item_length - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							if (strncmp (ce_string ("total "), l_finfo.item.b_data, (6).to_natural_32)) = 0 then
								l_endptr.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
								strtoll ((l_finfo.item.b_data + 6), l_endptr, 10).do_nothing
								if (l_endptr.item[0]).to_integer_32 /= 0 then
									PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
									Result := l_bufflen
									js.return
								else
									l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_FILETYPE
									l_finfo.item.b_used := (0).to_natural_32
								end
							else
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						end
						l_pos := -1 + 9 -- switch 3; break
				when 9 then -- switch 3, done:
						l_pos := -1 + 61 -- switch 2; break
				when 10 then -- switch 2, case 1
						inspect l_c.to_integer_32 -- switch 4 head
						when 45 then l_pos := -1 + 11
						when 100 then l_pos := -1 + 12
						when 108 then l_pos := -1 + 13
						when 112 then l_pos := -1 + 14
						when 115 then l_pos := -1 + 15
						when 99 then l_pos := -1 + 16
						when 98 then l_pos := -1 + 17
						when 68 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 11 then -- switch 4, case 45
						l_finfo.item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_FILE
						l_pos := -1 + 20 -- switch 4; break
				when 12 then -- switch 4, case 100
						l_finfo.item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_DIRECTORY
						l_pos := -1 + 20 -- switch 4; break
				when 13 then -- switch 4, case 108
						l_finfo.item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_SYMLINK
						l_pos := -1 + 20 -- switch 4; break
				when 14 then -- switch 4, case 112
						l_finfo.item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_NAMEDPIPE
						l_pos := -1 + 20 -- switch 4; break
				when 15 then -- switch 4, case 115
						l_finfo.item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_SOCKET
						l_pos := -1 + 20 -- switch 4; break
				when 16 then -- switch 4, case 99
						l_finfo.item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_DEVICE_CHAR
						l_pos := -1 + 20 -- switch 4; break
				when 17 then -- switch 4, case 98
						l_finfo.item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_DEVICE_BLOCK
						l_pos := -1 + 20 -- switch 4; break
				when 18 then -- switch 4, case 68
						l_finfo.item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_DOOR
						l_pos := -1 + 20 -- switch 4; break
				when 19 then -- switch 4, default:
						PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
						Result := l_bufflen
						js.return
				when 20 then -- switch 4, done:
						if not js.return_called then
							l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_PERMISSION
							l_parser.item.item_length := {NATURAL_32} 0
							l_parser.item.item_offset := (1).to_natural_32
						end
						l_pos := -1 + 61 -- switch 2; break
				when 21 then -- switch 2, case 2
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_parser.item.item_length <= {NATURAL_32} 9 then
							if (strchr (ce_string ("rwx-tTsS"), l_c.to_integer_32)).is_void then
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						elseif l_parser.item.item_length = {NATURAL_32} 10 then
							if l_c.to_integer_32 /= 32 then
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
							if not js.return_called then
								l_finfo.item.b_data[10] := (0).to_integer_8
								l_perm := (ftp_pl_get_permission ((l_finfo.item.b_data + (l_parser.item.item_offset).to_integer_32))).to_natural_32
								if ((l_perm).bit_and ({NATURAL_32} 16_777_216)).to_boolean then
									PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
									Result := l_bufflen
									js.return
								end
							end
							if not js.return_called then
								(l_parser.item.file_data).item.flags := ((l_parser.item.file_data).item.flags).bit_or (((1).bit_shift_left (3)).to_natural_32);
								(l_parser.item.file_data).item.perm := l_perm
								l_parser.item.offsets.perm := l_parser.item.item_offset
								l_parser.item.item_length := {NATURAL_32} 0
								l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_HLINKS
								l_parser.item.state.UNIX.sub.hlinks := {PC_HLINKS}.PL_UNIX_HLINKS_PRESPACE
							end
						end
						l_pos := -1 + 61 -- switch 2; break
				when 22 then -- switch 2, case 3
						inspect (l_parser.item.state.UNIX.sub.hlinks).to_integer_32 -- switch 5 head
						when 0 then l_pos := -1 + 23
						when 1 then l_pos := -1 + 24
						else l_pos := -1 + 25
						end
				when 23 then -- switch 5, case 0
						if l_c.to_integer_32 /= 32 then
							if l_c.to_integer_32 >= 48 then
								if l_c.to_integer_32 <= 57 then
									l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
									l_parser.item.item_length := {NATURAL_32} 1
									l_parser.item.state.UNIX.sub.hlinks := {PC_HLINKS}.PL_UNIX_HLINKS_NUMBER
								else
									PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
									Result := l_bufflen
									js.return
								end
							else
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						end
						l_pos := -1 + 25 -- switch 5; break
				when 24 then -- switch 5, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 32 then
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_hlinks := strtol ((l_finfo.item.b_data + (l_parser.item.item_offset).to_integer_32), l_p, 10)
							if (l_p.item[0]).to_integer_32 = 0 then
								if l_hlinks /= 2_147_483_647 then
									if l_hlinks /= (-0x7fffffff - 1) then
										(l_parser.item.file_data).item.flags := ((l_parser.item.file_data).item.flags).bit_or (((1).bit_shift_left (7)).to_natural_32);
										(l_parser.item.file_data).item.hardlinks := l_hlinks
									end
								end
							end
							l_parser.item.item_length := {NATURAL_32} 0
							l_parser.item.item_offset := (0).to_natural_32
							l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_USER
							l_parser.item.state.UNIX.sub.user := {PC_USER}.PL_UNIX_USER_PRESPACE
						elseif l_c.to_integer_32 < 48 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						elseif l_c.to_integer_32 > 57 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
						l_pos := -1 + 25 -- switch 5; break
				when 25 then -- switch 5, done:
						l_pos := -1 + 61 -- switch 2; break
				when 26 then -- switch 2, case 4
						inspect (l_parser.item.state.UNIX.sub.user).to_integer_32 -- switch 6 head
						when 0 then l_pos := -1 + 27
						when 1 then l_pos := -1 + 28
						else l_pos := -1 + 29
						end
				when 27 then -- switch 6, case 0
						if l_c.to_integer_32 /= 32 then
							l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
							l_parser.item.item_length := {NATURAL_32} 1
							l_parser.item.state.UNIX.sub.user := {PC_USER}.PL_UNIX_USER_PARSING
						end
						l_pos := -1 + 29 -- switch 6; break
				when 28 then -- switch 6, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 32 then
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_parser.item.offsets.user := l_parser.item.item_offset
							l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_GROUP
							l_parser.item.state.UNIX.sub.group := {PC_GROUP}.PL_UNIX_GROUP_PRESPACE
							l_parser.item.item_offset := (0).to_natural_32
							l_parser.item.item_length := {NATURAL_32} 0
						end
						l_pos := -1 + 29 -- switch 6; break
				when 29 then -- switch 6, done:
						l_pos := -1 + 61 -- switch 2; break
				when 30 then -- switch 2, case 5
						inspect (l_parser.item.state.UNIX.sub.group).to_integer_32 -- switch 7 head
						when 0 then l_pos := -1 + 31
						when 1 then l_pos := -1 + 32
						else l_pos := -1 + 33
						end
				when 31 then -- switch 7, case 0
						if l_c.to_integer_32 /= 32 then
							l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
							l_parser.item.item_length := {NATURAL_32} 1
							l_parser.item.state.UNIX.sub.group := {PC_GROUP}.PL_UNIX_GROUP_NAME
						end
						l_pos := -1 + 33 -- switch 7; break
				when 32 then -- switch 7, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 32 then
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_parser.item.offsets.group := l_parser.item.item_offset
							l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_SIZE
							l_parser.item.state.UNIX.sub.size := {PC_SIZE}.PL_UNIX_SIZE_PRESPACE
							l_parser.item.item_offset := (0).to_natural_32
							l_parser.item.item_length := {NATURAL_32} 0
						end
						l_pos := -1 + 33 -- switch 7; break
				when 33 then -- switch 7, done:
						l_pos := -1 + 61 -- switch 2; break
				when 34 then -- switch 2, case 6
						inspect (l_parser.item.state.UNIX.sub.size).to_integer_32 -- switch 8 head
						when 0 then l_pos := -1 + 35
						when 1 then l_pos := -1 + 36
						else l_pos := -1 + 37
						end
				when 35 then -- switch 8, case 0
						if l_c.to_integer_32 /= 32 then
							if l_c.to_integer_32 >= 48 then
								if l_c.to_integer_32 <= 57 then
									l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
									l_parser.item.item_length := {NATURAL_32} 1
									l_parser.item.state.UNIX.sub.size := {PC_SIZE}.PL_UNIX_SIZE_NUMBER
								else
									PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
									Result := l_bufflen
									js.return
								end
							else
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						end
						l_pos := -1 + 37 -- switch 8; break
				when 36 then -- switch 8, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 32 then
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_fsize := strtoll ((l_finfo.item.b_data + (l_parser.item.item_offset).to_integer_32), l_p___0, 10)
							if (l_p___0.item[0]).to_integer_32 = 0 then
								if l_fsize /= {INTEGER_64} 9_223_372_036_854_775_807 then
									if l_fsize /= (-0x7fffffffffffffff - 1) then
										(l_parser.item.file_data).item.flags := ((l_parser.item.file_data).item.flags).bit_or (((1).bit_shift_left (6)).to_natural_32);
										(l_parser.item.file_data).item.size := l_fsize
									end
								end
							end
							l_parser.item.item_length := {NATURAL_32} 0
							l_parser.item.item_offset := (0).to_natural_32
							l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_TIME
							l_parser.item.state.UNIX.sub.time := {PC_TIME}.PL_UNIX_TIME_PREPART1
						elseif not ((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
						l_pos := -1 + 37 -- switch 8; break
				when 37 then -- switch 8, done:
						l_pos := -1 + 61 -- switch 2; break
				when 38 then -- switch 2, case 7
						inspect (l_parser.item.state.UNIX.sub.time).to_integer_32 -- switch 9 head
						when 0 then l_pos := -1 + 39
						when 1 then l_pos := -1 + 40
						when 2 then l_pos := -1 + 41
						when 3 then l_pos := -1 + 42
						when 4 then l_pos := -1 + 43
						when 5 then l_pos := -1 + 44
						else l_pos := -1 + 45
						end
				when 39 then -- switch 9, case 0
						if l_c.to_integer_32 /= 32 then
							if ((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
								l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
								l_parser.item.item_length := {NATURAL_32} 1
								l_parser.item.state.UNIX.sub.time := {PC_TIME}.PL_UNIX_TIME_PART1
							else
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						end
						l_pos := -1 + 45 -- switch 9; break
				when 40 then -- switch 9, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 32 then
							l_parser.item.state.UNIX.sub.time := {PC_TIME}.PL_UNIX_TIME_PREPART2
						elseif not ((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							if l_c.to_integer_32 /= 46 then
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						end
						l_pos := -1 + 45 -- switch 9; break
				when 41 then -- switch 9, case 2
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 /= 32 then
							if ((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
								l_parser.item.state.UNIX.sub.time := {PC_TIME}.PL_UNIX_TIME_PART2
							else
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						end
						l_pos := -1 + 45 -- switch 9; break
				when 42 then -- switch 9, case 3
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 32 then
							l_parser.item.state.UNIX.sub.time := {PC_TIME}.PL_UNIX_TIME_PREPART3
						elseif not ((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							if l_c.to_integer_32 /= 46 then
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						end
						l_pos := -1 + 45 -- switch 9; break
				when 43 then -- switch 9, case 4
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 /= 32 then
							if ((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
								l_parser.item.state.UNIX.sub.time := {PC_TIME}.PL_UNIX_TIME_PART3
							else
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						end
						l_pos := -1 + 45 -- switch 9; break
				when 44 then -- switch 9, case 5
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 32 then
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_parser.item.offsets.time := l_parser.item.item_offset
							if (ftp_pl_gettime (l_parser, l_finfo.item.b_data + (l_parser.item.item_offset).to_integer_32)) then
								(l_parser.item.file_data).item.flags := ((l_parser.item.file_data).item.flags).bit_or (((1).bit_shift_left (2)).to_natural_32)
							end
							if l_finfo.item.filetype = {NATURAL_32} 2 then
								l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_SYMLINK
								l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_PRESPACE
							else
								l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_FILENAME
								l_parser.item.state.UNIX.sub.filename := {PC_FILENAME}.PL_UNIX_FILENAME_PRESPACE
							end
						elseif not ((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							if l_c.to_integer_32 /= 46 then
								if l_c.to_integer_32 /= 58 then
									PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
									Result := l_bufflen
									js.return
								end
							end
						end
						l_pos := -1 + 45 -- switch 9; break
				when 45 then -- switch 9, done:
						l_pos := -1 + 61 -- switch 2; break
				when 46 then -- switch 2, case 8
						inspect (l_parser.item.state.UNIX.sub.filename).to_integer_32 -- switch 10 head
						when 0 then l_pos := -1 + 47
						when 1 then l_pos := -1 + 48
						when 2 then l_pos := -1 + 49
						else l_pos := -1 + 50
						end
				when 47 then -- switch 10, case 0
						if l_c.to_integer_32 /= 32 then
							l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
							l_parser.item.item_length := {NATURAL_32} 1
							l_parser.item.state.UNIX.sub.filename := {PC_FILENAME}.PL_UNIX_FILENAME_NAME
						end
						l_pos := -1 + 50 -- switch 10; break
				when 48 then -- switch 10, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 13 then
							l_parser.item.item_length := (l_parser.item.item_length) - 1
							l_parser.item.state.UNIX.sub.filename := {PC_FILENAME}.PL_UNIX_FILENAME_WINDOWSEOL
						elseif l_c.to_integer_32 = 10 then
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_parser.item.offsets.filename := l_parser.item.item_offset
							l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_FILETYPE
							l_rc := ftp_pl_insert_finfo (l_conn, l_finfo)
							if l_rc.to_boolean then
								PL_ERROR (l_conn, l_rc)
								Result := l_bufflen
								js.return
							end
						end
						l_pos := -1 + 50 -- switch 10; break
				when 49 then -- switch 10, case 2
						if l_c.to_integer_32 = 10 then
							l_finfo.item.b_data[(l_parser.item.item_offset + l_parser.item.item_length).to_integer_32] := (0).to_integer_8
							l_parser.item.offsets.filename := l_parser.item.item_offset
							l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_FILETYPE
							l_rc := ftp_pl_insert_finfo (l_conn, l_finfo)
							if l_rc.to_boolean then
								PL_ERROR (l_conn, l_rc)
								Result := l_bufflen
								js.return
							end
						else
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
						l_pos := -1 + 50 -- switch 10; break
				when 50 then -- switch 10, done:
						l_pos := -1 + 61 -- switch 2; break
				when 51 then -- switch 2, case 9
						inspect (l_parser.item.state.UNIX.sub.symlink).to_integer_32 -- switch 11 head
						when 0 then l_pos := -1 + 52
						when 1 then l_pos := -1 + 53
						when 2 then l_pos := -1 + 54
						when 3 then l_pos := -1 + 55
						when 4 then l_pos := -1 + 56
						when 5 then l_pos := -1 + 57
						when 6 then l_pos := -1 + 58
						when 7 then l_pos := -1 + 59
						else l_pos := -1 + 60
						end
				when 52 then -- switch 11, case 0
						if l_c.to_integer_32 /= 32 then
							l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
							l_parser.item.item_length := {NATURAL_32} 1
							l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_NAME
						end
						l_pos := -1 + 60 -- switch 11; break
				when 53 then -- switch 11, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 32 then
							l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_PRETARGET1
						elseif l_c.to_integer_32 = 13 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						elseif l_c.to_integer_32 = 10 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
						l_pos := -1 + 60 -- switch 11; break
				when 54 then -- switch 11, case 2
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 45 then
							l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_PRETARGET2
						elseif l_c.to_integer_32 = 13 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						elseif l_c.to_integer_32 = 10 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						else
							l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_NAME
						end
						l_pos := -1 + 60 -- switch 11; break
				when 55 then -- switch 11, case 3
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 62 then
							l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_PRETARGET3
						elseif l_c.to_integer_32 = 13 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						elseif l_c.to_integer_32 = 10 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						else
							l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_NAME
						end
						l_pos := -1 + 60 -- switch 11; break
				when 56 then -- switch 11, case 4
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 32 then
							l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_PRETARGET4
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 4).to_integer_32] := (0).to_integer_8
							l_parser.item.offsets.filename := l_parser.item.item_offset
							l_parser.item.item_length := {NATURAL_32} 0
							l_parser.item.item_offset := (0).to_natural_32
						elseif l_c.to_integer_32 = 13 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						elseif l_c.to_integer_32 = 10 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						else
							l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_NAME
						end
						l_pos := -1 + 60 -- switch 11; break
				when 57 then -- switch 11, case 5
						if l_c.to_integer_32 /= 13 then
							if l_c.to_integer_32 /= 10 then
								l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_TARGET
								l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
								l_parser.item.item_length := {NATURAL_32} 1
							else
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						else
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
						l_pos := -1 + 60 -- switch 11; break
				when 58 then -- switch 11, case 6
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 13 then
							l_parser.item.item_length := (l_parser.item.item_length) - 1
							l_parser.item.state.UNIX.sub.symlink := {PC_SYMLINK}.PL_UNIX_SYMLINK_WINDOWSEOL
						elseif l_c.to_integer_32 = 10 then
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_parser.item.offsets.symlink_target := l_parser.item.item_offset
							l_rc := ftp_pl_insert_finfo (l_conn, l_finfo)
							if l_rc.to_boolean then
								PL_ERROR (l_conn, l_rc)
								Result := l_bufflen
								js.return
							end
							if not js.return_called then
								l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_FILETYPE
							end
						end
						l_pos := -1 + 60 -- switch 11; break
				when 59 then -- switch 11, case 7
						if l_c.to_integer_32 = 10 then
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_parser.item.offsets.symlink_target := l_parser.item.item_offset
							l_rc := ftp_pl_insert_finfo (l_conn, l_finfo)
							if l_rc.to_boolean then
								PL_ERROR (l_conn, l_rc)
								Result := l_bufflen
								js.return
							end
							if not js.return_called then
								l_parser.item.state.UNIX.main := {PC_PL_UNIX_MAINSTATE}.PL_UNIX_FILETYPE
							end
						else
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
						l_pos := -1 + 60 -- switch 11; break
				when 60 then -- switch 11, done:
						l_pos := -1 + 61 -- switch 2; break
				when 61 then -- switch 2, done:
						l_pos := -1 + 93 -- switch 1; break
				when 62 then -- switch 1, case 2
						inspect (l_parser.item.state.NT.main).to_integer_32 -- switch 12 head
						when 0 then l_pos := -1 + 63
						when 1 then l_pos := -1 + 64
						when 2 then l_pos := -1 + 68
						when 3 then l_pos := -1 + 86
						else l_pos := -1 + 91
						end
				when 63 then -- switch 12, case 0
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_parser.item.item_length < {NATURAL_32} 9 then
							if (strchr (ce_string ("0123456789-"), l_c.to_integer_32)).is_void then
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						elseif l_parser.item.item_length = {NATURAL_32} 9 then
							if l_c.to_integer_32 = 32 then
								l_parser.item.state.NT.main := {PC_PL_WINNT_MAINSTATE}.PL_WINNT_TIME
								l_parser.item.state.NT.sub.time := {PC_TIME2}.PL_WINNT_TIME_PRESPACE
							else
								PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
								Result := l_bufflen
								js.return
							end
						else
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
						l_pos := -1 + 91 -- switch 12; break
				when 64 then -- switch 12, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						inspect (l_parser.item.state.NT.sub.time).to_integer_32 -- switch 13 head
						when 0 then l_pos := -1 + 65
						when 1 then l_pos := -1 + 66
						else l_pos := -1 + 67
						end
				when 65 then -- switch 13, case 0
						if not ((((ctype_b_loc).item[(l_c.to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
							l_parser.item.state.NT.sub.time := {PC_TIME2}.PL_WINNT_TIME_TIME
						end
						l_pos := -1 + 67 -- switch 13; break
				when 66 then -- switch 13, case 1
						if l_c.to_integer_32 = 32 then
							l_parser.item.offsets.time := l_parser.item.item_offset
							l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_parser.item.state.NT.main := {PC_PL_WINNT_MAINSTATE}.PL_WINNT_DIRORSIZE
							l_parser.item.state.NT.sub.dirorsize := {PC_DIRORSIZE}.PL_WINNT_DIRORSIZE_PRESPACE
							l_parser.item.item_length := {NATURAL_32} 0
						elseif (strchr (ce_string ("APM0123456789:"), l_c.to_integer_32)).is_void then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
						l_pos := -1 + 67 -- switch 13; break
				when 67 then -- switch 13, done:
						l_pos := -1 + 91 -- switch 12; break
				when 68 then -- switch 12, case 2
						inspect (l_parser.item.state.NT.sub.dirorsize).to_integer_32 -- switch 14 head
						when 0 then l_pos := -1 + 69
						when 1 then l_pos := -1 + 70
						else l_pos := -1 + 85
						end
				when 69 then -- switch 14, case 0
						if l_c.to_integer_32 /= 32 then
							l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
							l_parser.item.item_length := {NATURAL_32} 1
							l_parser.item.state.NT.sub.dirorsize := {PC_DIRORSIZE}.PL_WINNT_DIRORSIZE_CONTENT
						end
						l_pos := -1 + 85 -- switch 14; break
				when 70 then -- switch 14, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 /= 32 then
							l_pos := -1 + 84 -- skip if block
						end
				when 71 then -- if:
						l_finfo.item.b_data[((l_parser.item.item_offset + l_parser.item.item_length) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
						if (strcmp (ce_string ("<DIR>"), (l_finfo.item.b_data + (l_parser.item.item_offset).to_integer_32))) /= 0 then
							l_pos := -1 + 74 -- skip if block
						end
				when 72 then -- if:
						l_finfo.item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_DIRECTORY
						l_finfo.item.size := (0).to_integer_64
				when 73 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 74 then -- else:
						l_finfo.item.size := strtoll ((l_finfo.item.b_data + (l_parser.item.item_offset).to_integer_32), l_endptr___0, 10)
						if (l_endptr___0.item[0]).to_boolean then
							l_pos := -1 + 81 -- skip if block
						end
				when 75 then -- if:
						if l_finfo.item.size /= {INTEGER_64} 9_223_372_036_854_775_807 then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						l_pos := -1 + 79 -- goto _L
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 78 then -- else:
						if l_finfo.item.size /= (-0x7fffffffffffffff - 1) then
							l_pos := -1 + 80 -- skip if block
						end
				when 79 then -- if: | _L:
						if (errno_location).item = 34 then
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
				when 80 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 82
				when 81 then -- else:
						PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
						Result := l_bufflen
						js.return
				when 82 then
						if not js.return_called then
							(l_parser.item.file_data).item.filetype := {PC_CURLFILETYPE}.CURLFILETYPE_FILE
						end
				when 83 then -- if done
						if not js.return_called then
							(l_parser.item.file_data).item.flags := ((l_parser.item.file_data).item.flags).bit_or (((1).bit_shift_left (6)).to_natural_32)
							l_parser.item.item_length := {NATURAL_32} 0
							l_parser.item.state.NT.main := {PC_PL_WINNT_MAINSTATE}.PL_WINNT_FILENAME
							l_parser.item.state.NT.sub.filename := {PC_FILENAME2}.PL_WINNT_FILENAME_PRESPACE
						end
				when 84 then -- if done
						l_pos := -1 + 85 -- switch 14; break
				when 85 then -- switch 14, done:
						l_pos := -1 + 91 -- switch 12; break
				when 86 then -- switch 12, case 3
						inspect (l_parser.item.state.NT.sub.filename).to_integer_32 -- switch 15 head
						when 0 then l_pos := -1 + 87
						when 1 then l_pos := -1 + 88
						when 2 then l_pos := -1 + 89
						else l_pos := -1 + 90
						end
				when 87 then -- switch 15, case 0
						if l_c.to_integer_32 /= 32 then
							l_parser.item.item_offset := l_finfo.item.b_used - {NATURAL_32} 1
							l_parser.item.item_length := {NATURAL_32} 1
							l_parser.item.state.NT.sub.filename := {PC_FILENAME2}.PL_WINNT_FILENAME_CONTENT
						end
						l_pos := -1 + 90 -- switch 15; break
				when 88 then -- switch 15, case 1
						l_parser.item.item_length := (l_parser.item.item_length) + 1
						if l_c.to_integer_32 = 13 then
							l_parser.item.state.NT.sub.filename := {PC_FILENAME2}.PL_WINNT_FILENAME_WINEOL
							l_finfo.item.b_data[(l_finfo.item.b_used - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
						elseif l_c.to_integer_32 = 10 then
							l_parser.item.offsets.filename := l_parser.item.item_offset
							l_finfo.item.b_data[(l_finfo.item.b_used - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_parser.item.offsets.filename := l_parser.item.item_offset
							l_rc := ftp_pl_insert_finfo (l_conn, l_finfo)
							if l_rc.to_boolean then
								PL_ERROR (l_conn, l_rc)
								Result := l_bufflen
								js.return
							end
							if not js.return_called then
								l_parser.item.state.NT.main := {PC_PL_WINNT_MAINSTATE}.PL_WINNT_DATE
								l_parser.item.state.NT.sub.filename := {PC_FILENAME2}.PL_WINNT_FILENAME_PRESPACE
							end
						end
						l_pos := -1 + 90 -- switch 15; break
				when 89 then -- switch 15, case 2
						if l_c.to_integer_32 = 10 then
							l_parser.item.offsets.filename := l_parser.item.item_offset
							l_rc := ftp_pl_insert_finfo (l_conn, l_finfo)
							if l_rc.to_boolean then
								PL_ERROR (l_conn, l_rc)
								Result := l_bufflen
								js.return
							end
							if not js.return_called then
								l_parser.item.state.NT.main := {PC_PL_WINNT_MAINSTATE}.PL_WINNT_DATE
								l_parser.item.state.NT.sub.filename := {PC_FILENAME2}.PL_WINNT_FILENAME_PRESPACE
							end
						else
							PL_ERROR (l_conn, {PC_CURLCODE}.CURLE_FTP_BAD_FILE_LIST)
							Result := l_bufflen
							js.return
						end
						l_pos := -1 + 90 -- switch 15; break
				when 90 then -- switch 15, done:
						l_pos := -1 + 91 -- switch 12; break
				when 91 then -- switch 12, done:
						l_pos := -1 + 93 -- switch 1; break
				when 92 then -- switch 1, default:
						Result := (l_bufflen + {NATURAL_32} 1)
						js.return
				when 93 then -- switch 1, done: | if done
						if not js.return_called then
							l_i := l_i + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 94 then -- loop done | if done
						if not js.return_called then
							Result := l_bufflen
						end
				when 95 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_ftp_parselist_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_ftp_parselist)
		end

	Curl_ftp_parselist_data_alloc: CE_POINTER [PD_FTP_PARSELIST_DATA]
		do
			Result := (create {CE_POINTER [PD_FTP_PARSELIST_DATA]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, (create {PD_FTP_PARSELIST_DATA}.make).structure_size.to_natural_32])))))
		end

	Curl_ftp_parselist_data_free (a_pl_data: CE_POINTER [CE_POINTER [PD_FTP_PARSELIST_DATA]])
		do
			if (not (a_pl_data.item).is_void) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_pl_data.item)])
			end
			a_pl_data.item := create {CE_POINTER [PD_FTP_PARSELIST_DATA]}.make_shared (default_pointer)
		end

	Curl_ftp_parselist_geterror (a_pl_data: CE_POINTER [PD_FTP_PARSELIST_DATA]): NATURAL_32
		do
			Result := (a_pl_data.item.error)
		end

	PL_ERROR (a_conn: CE_POINTER [PD_CONNECTDATA]; a_err: NATURAL_32)
		local
			l_parser: CE_POINTER [PD_FTP_PARSELIST_DATA]
		do
			create l_parser.make

			l_parser := (create {CE_POINTER [PD_FTP_WC_TMPDATA]}.make_cast ((a_conn.item.data).item.wildcard.tmp)).item.parser
			if (not (l_parser.item.file_data).is_void) then
				fileinfo_inst.Curl_fileinfo_dtor (create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (l_parser.item.file_data))
			end
			l_parser.item.file_data := create {CE_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer)
			l_parser.item.error := a_err
		end

	ftp_pl_get_permission (a_str: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_permissions: INTEGER_32
		do
			l_permissions := 0
			if (a_str[0]).to_integer_32 = 114 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (8)))
			elseif (a_str[0]).to_integer_32 /= 45 then
				l_permissions := (l_permissions).bit_or ((16_777_216))
			end
			if (a_str[1]).to_integer_32 = 119 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (7)))
			elseif (a_str[1]).to_integer_32 /= 45 then
				l_permissions := (l_permissions).bit_or ((16_777_216))
			end
			if (a_str[2]).to_integer_32 = 120 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (6)))
			elseif (a_str[2]).to_integer_32 = 115 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (6)))
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (11)))
			elseif (a_str[2]).to_integer_32 = 83 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (11)))
			elseif (a_str[2]).to_integer_32 /= 45 then
				l_permissions := (l_permissions).bit_or ((16_777_216))
			end
			if (a_str[3]).to_integer_32 = 114 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (5)))
			elseif (a_str[3]).to_integer_32 /= 45 then
				l_permissions := (l_permissions).bit_or ((16_777_216))
			end
			if (a_str[4]).to_integer_32 = 119 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (4)))
			elseif (a_str[4]).to_integer_32 /= 45 then
				l_permissions := (l_permissions).bit_or ((16_777_216))
			end
			if (a_str[5]).to_integer_32 = 120 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (3)))
			elseif (a_str[5]).to_integer_32 = 115 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (3)))
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (10)))
			elseif (a_str[5]).to_integer_32 = 83 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (10)))
			elseif (a_str[5]).to_integer_32 /= 45 then
				l_permissions := (l_permissions).bit_or ((16_777_216))
			end
			if (a_str[6]).to_integer_32 = 114 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (2)))
			elseif (a_str[6]).to_integer_32 /= 45 then
				l_permissions := (l_permissions).bit_or ((16_777_216))
			end
			if (a_str[7]).to_integer_32 = 119 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (1)))
			elseif (a_str[7]).to_integer_32 /= 45 then
				l_permissions := (l_permissions).bit_or ((16_777_216))
			end
			if (a_str[8]).to_integer_32 = 120 then
				l_permissions := (l_permissions).bit_or ((1))
			elseif (a_str[8]).to_integer_32 = 116 then
				l_permissions := (l_permissions).bit_or ((1))
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (9)))
			elseif (a_str[8]).to_integer_32 = 84 then
				l_permissions := (l_permissions).bit_or (((1).bit_shift_left (9)))
			elseif (a_str[8]).to_integer_32 /= 45 then
				l_permissions := (l_permissions).bit_or ((16_777_216))
			end
			Result := l_permissions
		end

	ftp_pl_gettime (a_parser: CE_POINTER [PD_FTP_PARSELIST_DATA]; a_string: CE_POINTER [INTEGER_8]): BOOLEAN
		do
			Result := (0).to_boolean
		end

	ftp_pl_insert_finfo (a_conn: CE_POINTER [PD_CONNECTDATA]; a_finfo: CE_POINTER [PD_CURL_FILEINFO]): NATURAL_32
		local
			l_compare: CE_ROUTINE
			l_wc: CE_POINTER [PD_WILDCARDDATA]
			l_tmpdata: CE_POINTER [PD_FTP_WC_TMPDATA]
			l_llist: CE_POINTER [PD_CURL_LLIST]
			l_parser: CE_POINTER [PD_FTP_PARSELIST_DATA]
			l_add: BOOLEAN
			l_str: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_compare.make
			create l_wc.make
			create l_tmpdata.make
			create l_llist.make
			create l_parser.make
			create l_str.make

			l_wc := create {CE_POINTER [PD_WILDCARDDATA]}.make_shared ((a_conn.item.data).c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard"))
			l_tmpdata := create {CE_POINTER [PD_FTP_WC_TMPDATA]}.make_cast (l_wc.item.tmp)
			l_llist := l_wc.item.filelist
			l_parser := l_tmpdata.item.parser
			l_add := (1).to_boolean
			l_str := a_finfo.item.b_data
			a_finfo.item.filename := l_str + (l_parser.item.offsets.filename).to_integer_32
			if (l_parser.item.offsets.group).to_boolean then
				a_finfo.item.strings.group := l_str + (l_parser.item.offsets.group).to_integer_32
			else
				a_finfo.item.strings.group := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			if (l_parser.item.offsets.perm).to_boolean then
				a_finfo.item.strings.perm := l_str + (l_parser.item.offsets.perm).to_integer_32
			else
				a_finfo.item.strings.perm := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			if (l_parser.item.offsets.symlink_target).to_boolean then
				a_finfo.item.strings.target := l_str + (l_parser.item.offsets.symlink_target).to_integer_32
			else
				a_finfo.item.strings.target := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			a_finfo.item.strings.time := l_str + (l_parser.item.offsets.time).to_integer_32
			if (l_parser.item.offsets.user).to_boolean then
				a_finfo.item.strings.user := l_str + (l_parser.item.offsets.user).to_integer_32
			else
				a_finfo.item.strings.user := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			l_compare := (a_conn.item.data).item.set.fnmatch
			if l_compare.is_void then
				l_compare := curl_fnmatch_inst.Curl_fnmatch_address
			end
			if (l_compare.integer_32_item ([(a_conn.item.data).item.set.fnmatch_data, l_wc.item.pattern, a_finfo.item.filename])) = 0 then
				if a_finfo.item.filetype = {NATURAL_32} 2 then
					if (not (a_finfo.item.strings.target).is_void) then
						if (not (strstr (a_finfo.item.strings.target, ce_string (" -> "))).is_void) then
							l_add := (0).to_boolean
						end
					end
				end
			else
				l_add := (0).to_boolean
			end
			if l_add then
				if not (llist_inst.Curl_llist_insert_next (l_llist, l_llist.item.tail, create {CE_POINTER [ANY]}.make_cast (a_finfo))).to_boolean then
					fileinfo_inst.Curl_fileinfo_dtor (create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_finfo));
					(l_tmpdata.item.parser).item.file_data := create {CE_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer)
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			else
				fileinfo_inst.Curl_fileinfo_dtor (create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_finfo))
			end
			if not js.return_called then
				(l_tmpdata.item.parser).item.file_data := create {CE_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

end
