class
	P_GETINFO

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_getinfo (a_args: TUPLE [a_data: CE_POINTER [PD_SESSIONHANDLE]; a_info: NATURAL_32]): NATURAL_32
		local
			l_arg: CE_VA_LIST
			l_param_longp: CE_POINTER [INTEGER_32]
			l_param_doublep: CE_POINTER [REAL_64]
			l_param_charp: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_param_slistp: CE_POINTER [CE_POINTER [PD_CURL_SLIST]]
			l_type: INTEGER_32
			l_sockfd: INTEGER_32
			l_ptr: PD_PTR
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make_shared (default_pointer)
			create l_param_longp.make
			create l_param_doublep.make
			create l_param_charp.make
			create l_param_slistp.make
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_param_longp := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
					l_param_doublep := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
					l_param_charp := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer)
					l_param_slistp := create {CE_POINTER [CE_POINTER [PD_CURL_SLIST]]}.make_shared (default_pointer)
					if a_args.a_data.is_void then
						Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_arg := create {CE_VA_LIST}.make (a_args, 3)
						l_type := (15_728_640).bit_and (a_args.a_info.to_integer_32)
						inspect l_type -- switch 1 head
						when 1048576 then l_pos := -1 + 2
						when 2097152 then l_pos := -1 + 3
						when 3145728 then l_pos := -1 + 4
						when 4194304 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 1048576
						l_param_charp := (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (l_arg.pointer_item))
						if l_param_charp.is_void then
							Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
							js.return
						end
						l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 2097152
						l_param_longp := (create {CE_POINTER [INTEGER_32]}.make_cast (l_arg.pointer_item))
						if l_param_longp.is_void then
							Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
							js.return
						end
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 3145728
						l_param_doublep := (create {CE_POINTER [REAL_64]}.make_cast (l_arg.pointer_item))
						if l_param_doublep.is_void then
							Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
							js.return
						end
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 4194304
						l_param_slistp := (create {CE_POINTER [CE_POINTER [PD_CURL_SLIST]]}.make_cast (l_arg.pointer_item))
						if l_param_slistp.is_void then
							Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
							js.return
						end
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
						js.return
				when 7 then -- switch 1, done: | if done
						if js.return_called then
							l_pos := -1 + 52 -- skip if block
						end
				when 8 then -- if:
							inspect a_args.a_info.to_integer_32 -- switch 2 head
							when 1048577 then l_pos := -1 + 9
							when 2097154 then l_pos := -1 + 10
							when 2097174 then l_pos := -1 + 11
							when 2097166 then l_pos := -1 + 12
							when 2097163 then l_pos := -1 + 13
							when 2097164 then l_pos := -1 + 14
							when 3145731 then l_pos := -1 + 15
							when 3145732 then l_pos := -1 + 16
							when 3145733 then l_pos := -1 + 17
							when 3145761 then l_pos := -1 + 18
							when 3145734 then l_pos := -1 + 19
							when 3145745 then l_pos := -1 + 20
							when 3145735 then l_pos := -1 + 21
							when 3145736 then l_pos := -1 + 22
							when 3145737 then l_pos := -1 + 23
							when 3145738 then l_pos := -1 + 24
							when 2097165 then l_pos := -1 + 25
							when 3145743 then l_pos := -1 + 26
							when 3145744 then l_pos := -1 + 27
							when 3145747 then l_pos := -1 + 28
							when 2097172 then l_pos := -1 + 29
							when 1048594 then l_pos := -1 + 30
							when 1048597 then l_pos := -1 + 31
							when 2097175 then l_pos := -1 + 32
							when 2097176 then l_pos := -1 + 33
							when 2097177 then l_pos := -1 + 34
							when 2097178 then l_pos := -1 + 35
							when 4194331 then l_pos := -1 + 36
							when 4194332 then l_pos := -1 + 37
							when 1048606 then l_pos := -1 + 38
							when 2097181 then l_pos := -1 + 39
							when 1048607 then l_pos := -1 + 40
							when 1048608 then l_pos := -1 + 41
							when 2097192 then l_pos := -1 + 42
							when 1048617 then l_pos := -1 + 43
							when 2097194 then l_pos := -1 + 44
							when 4194338 then l_pos := -1 + 45
							when 2097187 then l_pos := -1 + 46
							when 1048612 then l_pos := -1 + 47
							when 2097189 then l_pos := -1 + 48
							when 2097190 then l_pos := -1 + 49
							when 2097191 then l_pos := -1 + 50
							else l_pos := -1 + 51
							end
				when 9 then -- switch 2, case 1048577
							if (not (a_args.a_data.item.change.url).is_void) then
								l_param_charp.item := a_args.a_data.item.change.url
							else
								l_param_charp.item := ce_string ("")
							end
							l_pos := -1 + 52 -- switch 2; break
				when 10 then -- switch 2, case 2097154
							l_param_longp.item := (a_args.a_data.item.info.httpcode).to_integer_32
							l_pos := -1 + 52 -- switch 2; break
				when 11 then -- switch 2, case 2097174
							l_param_longp.item := (a_args.a_data.item.info.httpproxycode).to_integer_32
							l_pos := -1 + 52 -- switch 2; break
				when 12 then -- switch 2, case 2097166
							l_param_longp.item := a_args.a_data.item.info.filetime
							l_pos := -1 + 52 -- switch 2; break
				when 13 then -- switch 2, case 2097163
							l_param_longp.item := a_args.a_data.item.info.header_size
							l_pos := -1 + 52 -- switch 2; break
				when 14 then -- switch 2, case 2097164
							l_param_longp.item := a_args.a_data.item.info.request_size
							l_pos := -1 + 52 -- switch 2; break
				when 15 then -- switch 2, case 3145731
							l_param_doublep.item := a_args.a_data.item.progress.timespent
							l_pos := -1 + 52 -- switch 2; break
				when 16 then -- switch 2, case 3145732
							l_param_doublep.item := a_args.a_data.item.progress.t_nslookup
							l_pos := -1 + 52 -- switch 2; break
				when 17 then -- switch 2, case 3145733
							l_param_doublep.item := a_args.a_data.item.progress.t_connect
							l_pos := -1 + 52 -- switch 2; break
				when 18 then -- switch 2, case 3145761
							l_param_doublep.item := a_args.a_data.item.progress.t_appconnect
							l_pos := -1 + 52 -- switch 2; break
				when 19 then -- switch 2, case 3145734
							l_param_doublep.item := a_args.a_data.item.progress.t_pretransfer
							l_pos := -1 + 52 -- switch 2; break
				when 20 then -- switch 2, case 3145745
							l_param_doublep.item := a_args.a_data.item.progress.t_starttransfer
							l_pos := -1 + 52 -- switch 2; break
				when 21 then -- switch 2, case 3145735
							l_param_doublep.item := (a_args.a_data.item.progress.uploaded).to_double
							l_pos := -1 + 52 -- switch 2; break
				when 22 then -- switch 2, case 3145736
							l_param_doublep.item := (a_args.a_data.item.progress.downloaded).to_double
							l_pos := -1 + 52 -- switch 2; break
				when 23 then -- switch 2, case 3145737
							l_param_doublep.item := (a_args.a_data.item.progress.dlspeed).to_double
							l_pos := -1 + 52 -- switch 2; break
				when 24 then -- switch 2, case 3145738
							l_param_doublep.item := (a_args.a_data.item.progress.ulspeed).to_double
							l_pos := -1 + 52 -- switch 2; break
				when 25 then -- switch 2, case 2097165
							l_param_longp.item := a_args.a_data.item.set.ssl.certverifyresult
							l_pos := -1 + 52 -- switch 2; break
				when 26 then -- switch 2, case 3145743
							if ((a_args.a_data.item.progress.flags).bit_and (((1).bit_shift_left (6)))).to_boolean then
								l_param_doublep.item := (a_args.a_data.item.progress.size_dl).to_double
							else
								l_param_doublep.item := (-1).to_double
							end
							l_pos := -1 + 52 -- switch 2; break
				when 27 then -- switch 2, case 3145744
							if ((a_args.a_data.item.progress.flags).bit_and (((1).bit_shift_left (5)))).to_boolean then
								l_param_doublep.item := (a_args.a_data.item.progress.size_ul).to_double
							else
								l_param_doublep.item := (-1).to_double
							end
							l_pos := -1 + 52 -- switch 2; break
				when 28 then -- switch 2, case 3145747
							l_param_doublep.item := a_args.a_data.item.progress.t_redirect
							l_pos := -1 + 52 -- switch 2; break
				when 29 then -- switch 2, case 2097172
							l_param_longp.item := a_args.a_data.item.set.followlocation
							l_pos := -1 + 52 -- switch 2; break
				when 30 then -- switch 2, case 1048594
							l_param_charp.item := a_args.a_data.item.info.contenttype
							l_pos := -1 + 52 -- switch 2; break
				when 31 then -- switch 2, case 1048597
							l_param_charp.item := create {CE_POINTER [INTEGER_8]}.make_cast (a_args.a_data.item.set.private_data)
							l_pos := -1 + 52 -- switch 2; break
				when 32 then -- switch 2, case 2097175
							l_param_longp.item := a_args.a_data.item.info.httpauthavail
							l_pos := -1 + 52 -- switch 2; break
				when 33 then -- switch 2, case 2097176
							l_param_longp.item := a_args.a_data.item.info.proxyauthavail
							l_pos := -1 + 52 -- switch 2; break
				when 34 then -- switch 2, case 2097177
							l_param_longp.item := (a_args.a_data.item.state.os_errno).to_integer_32
							l_pos := -1 + 52 -- switch 2; break
				when 35 then -- switch 2, case 2097178
							l_param_longp.item := a_args.a_data.item.info.numconnects
							l_pos := -1 + 52 -- switch 2; break
				when 36 then -- switch 2, case 4194331
							l_param_slistp.item := create {CE_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer)
							l_pos := -1 + 52 -- switch 2; break
				when 37 then -- switch 2, case 4194332
							l_param_slistp.item := cookie_inst.Curl_cookie_list (a_args.a_data)
							l_pos := -1 + 52 -- switch 2; break
				when 38 then -- switch 2, case 1048606
							l_param_charp.item := a_args.a_data.item.state.most_recent_ftp_entrypath
							l_pos := -1 + 52 -- switch 2; break
				when 39 then -- switch 2, case 2097181
							l_sockfd := connect_inst.Curl_getconnectinfo (a_args.a_data, create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (default_pointer))
							if l_sockfd /= -1 then
								l_param_longp.item := l_sockfd.to_integer_32
							else
								l_param_longp.item := -1
							end
							l_pos := -1 + 52 -- switch 2; break
				when 40 then -- switch 2, case 1048607
							l_param_charp.item := a_args.a_data.item.info.wouldredirect
							l_pos := -1 + 52 -- switch 2; break
				when 41 then -- switch 2, case 1048608
							l_param_charp.item := a_args.a_data.item.info.ip
							l_pos := -1 + 52 -- switch 2; break
				when 42 then -- switch 2, case 2097192
							l_param_longp.item := a_args.a_data.item.info.port
							l_pos := -1 + 52 -- switch 2; break
				when 43 then -- switch 2, case 1048617
							l_param_charp.item := a_args.a_data.item.info.localip
							l_pos := -1 + 52 -- switch 2; break
				when 44 then -- switch 2, case 2097194
							l_param_longp.item := a_args.a_data.item.info.localport
							l_pos := -1 + 52 -- switch 2; break
				when 45 then -- switch 2, case 4194338
							l_ptr.to_certinfo := create {CE_POINTER [PD_CURL_CERTINFO]}.make_shared (a_args.a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("certs"))
							l_ptr.update_class_fields -- synchronize union
							l_param_slistp.item := l_ptr.to_slist
							l_pos := -1 + 52 -- switch 2; break
				when 46 then -- switch 2, case 2097187
							l_param_longp.item := (a_args.a_data.item.info.timecond).to_integer
							l_pos := -1 + 52 -- switch 2; break
				when 47 then -- switch 2, case 1048612
							l_param_charp.item := a_args.a_data.item.set.str[33]
							l_pos := -1 + 52 -- switch 2; break
				when 48 then -- switch 2, case 2097189
							l_param_longp.item := a_args.a_data.item.state.rtsp_next_client_CSeq
							l_pos := -1 + 52 -- switch 2; break
				when 49 then -- switch 2, case 2097190
							l_param_longp.item := a_args.a_data.item.state.rtsp_next_server_CSeq
							l_pos := -1 + 52 -- switch 2; break
				when 50 then -- switch 2, case 2097191
							l_param_longp.item := a_args.a_data.item.state.rtsp_CSeq_recv
							l_pos := -1 + 52 -- switch 2; break
				when 51 then -- switch 2, default:
							Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
							js.return
				when 52 then -- switch 2, done: | if done
							if not js.return_called then
								Result := ({PC_CURLCODE}.CURLE_OK)
							end
				when 53 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	Curl_initinfo (a_data: CE_POINTER [PD_SESSIONHANDLE]): NATURAL_32
		local
			l_pro: CE_POINTER [PD_PROGRESS]
			l_info: CE_POINTER [PD_PUREINFO]
		do
			create l_pro.make
			create l_info.make

			l_pro := create {CE_POINTER [PD_PROGRESS]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("progress"))
			l_info := create {CE_POINTER [PD_PUREINFO]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info"))
			l_pro.item.t_nslookup := (0).to_double
			l_pro.item.t_connect := (0).to_double
			l_pro.item.t_pretransfer := (0).to_double
			l_pro.item.t_starttransfer := (0).to_double
			l_pro.item.timespent := (0).to_double
			l_pro.item.t_redirect := (0).to_double
			l_info.item.httpcode := 0
			l_info.item.httpversion := 0
			l_info.item.filetime := -1
			if (not (l_info.item.contenttype).is_void) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_info.item.contenttype)])
			end
			l_info.item.contenttype := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_info.item.header_size := 0
			l_info.item.request_size := 0
			l_info.item.numconnects := 0
			l_info.item.ip[0] := (0).to_integer_8
			l_info.item.port := 0
			l_info.item.localip[0] := (0).to_integer_8
			l_info.item.localport := 0
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

end
