class
	P_HASH

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_hash_add (a_h: CE_POINTER [PD_CURL_HASH]; a_key: CE_POINTER [ANY]; a_key_len: NATURAL_32; a_p: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			l_le: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_l: CE_POINTER [PD_CURL_LLIST]
			js: JUMP_STATE
		do
			create l_he.make
			create l_le.make
			create l_l.make

			l_l := a_h.item.table[((a_h.item.hash_func).natural_32_item ([a_key, a_key_len, (a_h.item.slots).to_natural_32])).to_integer_32]
			l_le := l_l.item.head
			from
			until
				not (not js.loop_done and then (not l_le.is_void))
			loop
				l_he := create {CE_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (l_le.item.ptr)
				if ((a_h.item.comp_func).natural_32_item ([create {CE_POINTER [ANY]}.make_cast (l_he.item.key), l_he.item.key_len, a_key, a_key_len])).to_boolean then
					llist_inst.Curl_llist_remove (l_l, l_le, create {CE_POINTER [ANY]}.make_cast (a_h)).do_nothing
					a_h.item.size := (a_h.item.size) - 1
					js.break
				end
				if not js.loop_jumped then
					l_le := l_le.item.next
				end
			end
			l_he := mk_hash_element (a_key, a_key_len, a_p)
			if (not l_he.is_void) then
				if (llist_inst.Curl_llist_insert_next (l_l, l_l.item.tail, create {CE_POINTER [ANY]}.make_cast (l_he))).to_boolean then
					a_h.item.size := (a_h.item.size) + 1
					Result := a_p
					js.return
				end
				if not js.return_called then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_he.item.key)])
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_he)])
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	Curl_hash_alloc (a_slots: INTEGER_32; a_hfunc: CE_ROUTINE; a_comparator: CE_ROUTINE; a_dtor: CE_ROUTINE): CE_POINTER [PD_CURL_HASH]
		local
			l_h: CE_POINTER [PD_CURL_HASH]
			js: JUMP_STATE
		do
			create l_h.make

			if not a_slots.to_boolean then
				Result := (create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer))
				js.return
			elseif a_hfunc.is_void then
				Result := (create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer))
				js.return
			elseif a_comparator.is_void then
				Result := (create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer))
				js.return
			elseif a_dtor.is_void then
				Result := (create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_h := create {CE_POINTER [PD_CURL_HASH]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(create {PD_CURL_HASH}.make).structure_size.to_natural_32]))))
				if (not l_h.is_void) then
					if (Curl_hash_init (l_h, a_slots, a_hfunc, a_comparator, a_dtor)).to_boolean then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_h)])
						l_h := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
					end
				end
				Result := l_h
			end
		end

	Curl_hash_clean (a_h: CE_POINTER [PD_CURL_HASH])
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < a_h.item.slots)
			loop
				llist_inst.Curl_llist_destroy (a_h.item.table[l_i], create {CE_POINTER [ANY]}.make_cast (a_h))
				a_h.item.table[l_i] := create {CE_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
				l_i := l_i + 1
			end
			easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_h.item.table)])
		end

	Curl_hash_clean_with_criterium (a_h: CE_POINTER [PD_CURL_HASH]; a_user: CE_POINTER [ANY]; a_comp: CE_ROUTINE)
		local
			l_le: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_lnext: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_list: CE_POINTER [PD_CURL_LLIST]
			l_i: INTEGER_32
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			js: JUMP_STATE
		do
			create l_le.make
			create l_lnext.make
			create l_list.make
			create l_he.make

			l_i := 0
			from
			until
				not (not js.loop_done and then (l_i < a_h.item.slots))
			loop
				l_list := a_h.item.table[l_i]
				l_le := l_list.item.head
				from
				until
					l_le.is_void
				loop
					l_he := create {CE_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (l_le.item.ptr)
					l_lnext := l_le.item.next
					if (a_comp.integer_32_item ([a_user, l_he.item.ptr])).to_boolean then
						llist_inst.Curl_llist_remove (l_list, l_le, create {CE_POINTER [ANY]}.make_cast (a_h)).do_nothing
						a_h.item.size := (a_h.item.size) - 1
					end
					l_le := l_lnext
				end
				l_i := l_i + 1
			end
		end

	Curl_hash_delete (a_h: CE_POINTER [PD_CURL_HASH]; a_key: CE_POINTER [ANY]; a_key_len: NATURAL_32): INTEGER_32
		local
			l_le: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			l_l: CE_POINTER [PD_CURL_LLIST]
			js: JUMP_STATE
		do
			create l_le.make
			create l_he.make
			create l_l.make

			l_l := a_h.item.table[((a_h.item.hash_func).natural_32_item ([a_key, a_key_len, (a_h.item.slots).to_natural_32])).to_integer_32]
			l_le := l_l.item.head
			from
			until
				not (not js.loop_done and then (not l_le.is_void))
			loop
				l_he := create {CE_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (l_le.item.ptr)
				if ((a_h.item.comp_func).natural_32_item ([create {CE_POINTER [ANY]}.make_cast (l_he.item.key), l_he.item.key_len, a_key, a_key_len])).to_boolean then
					llist_inst.Curl_llist_remove (l_l, l_le, create {CE_POINTER [ANY]}.make_cast (a_h)).do_nothing
					Result := 0
					js.return
				end
				if not js.return_called then
					l_le := l_le.item.next
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	Curl_hash_destroy (a_h: CE_POINTER [PD_CURL_HASH])
		local
			js: JUMP_STATE
		do
			if a_h.is_void then
				js.return
			end
			if not js.return_called then
				Curl_hash_clean (a_h)
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_h)])
			end
		end

	Curl_hash_init (a_h: CE_POINTER [PD_CURL_HASH]; a_slots: INTEGER_32; a_hfunc: CE_ROUTINE; a_comparator: CE_ROUTINE; a_dtor: CE_ROUTINE): INTEGER_32
		local
			l_i: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			if not a_slots.to_boolean then
				Result := 1
				js.return
			elseif a_hfunc.is_void then
				Result := 1
				js.return
			elseif a_comparator.is_void then
				Result := 1
				js.return
			elseif a_dtor.is_void then
				Result := 1
				js.return
			end
			if not js.return_called then
				a_h.item.hash_func := a_hfunc
				a_h.item.comp_func := a_comparator
				a_h.item.dtor := a_dtor
				a_h.item.size := (0).to_natural_32
				a_h.item.slots := a_slots
				a_h.item.table := create {CE_POINTER [CE_POINTER [PD_CURL_LLIST]]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([a_slots.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32]))))
				if (not (a_h.item.table).is_void) then
					l_i := 0
					from
					until
						not (not js.loop_done and then (l_i < a_slots))
					loop
						a_h.item.table[l_i] := llist_inst.Curl_llist_alloc (hash_element_dtor_address)
						if (a_h.item.table[l_i]).is_void then
							from
							until
								js.loop_done
							loop
								l_tmp___0 := l_i
								l_i := l_i - 1
								if not l_tmp___0.to_boolean then
									js.break
								end
								if not js.loop_jumped then
									llist_inst.Curl_llist_destroy (a_h.item.table[l_i], create {CE_POINTER [ANY]}.make_shared (default_pointer))
								end
							end
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_h.item.table)])
							Result := 1
							js.return
						end
						if not js.return_called then
							l_i := l_i + 1
						end
					end
					if not js.return_called then
						Result := 0
					end
				else
					Result := 1
				end
			end
		end

	Curl_hash_pick (a_h: CE_POINTER [PD_CURL_HASH]; a_key: CE_POINTER [ANY]; a_key_len: NATURAL_32): CE_POINTER [ANY]
		local
			l_le: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			l_l: CE_POINTER [PD_CURL_LLIST]
			js: JUMP_STATE
		do
			create l_le.make
			create l_he.make
			create l_l.make

			l_l := a_h.item.table[((a_h.item.hash_func).natural_32_item ([a_key, a_key_len, (a_h.item.slots).to_natural_32])).to_integer_32]
			l_le := l_l.item.head
			from
			until
				not (not js.loop_done and then (not l_le.is_void))
			loop
				l_he := create {CE_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (l_le.item.ptr)
				if ((a_h.item.comp_func).natural_32_item ([create {CE_POINTER [ANY]}.make_cast (l_he.item.key), l_he.item.key_len, a_key, a_key_len])).to_boolean then
					Result := (l_he.item.ptr)
					js.return
				end
				if not js.return_called then
					l_le := l_le.item.next
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	Curl_hash_str (a_key: CE_POINTER [ANY]; a_key_length: NATURAL_32; a_slots_num: NATURAL_32): NATURAL_32
		local
			l_key_str: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_h: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_key_str.make
			create l_end.make
			create l_tmp.make

			l_key_str := create {CE_POINTER [INTEGER_8]}.make_cast (a_key)
			l_end := l_key_str + a_key_length.to_integer_32
			l_h := {NATURAL_32} 5_381
			from
			until
				not ((l_key_str.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)
			loop
				l_h := l_h + ((l_h).bit_shift_left (5))
				l_tmp := l_key_str
				l_key_str := l_key_str + 1
				l_h := (l_h).bit_xor ((l_tmp[0]).to_natural_32)
			end
			Result := (l_h \\ a_slots_num.to_natural_32).to_natural_32
		end

	Curl_hash_str_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_hash_str)
		end

	Curl_str_key_compare (a_k1: CE_POINTER [ANY]; a_key1_len: NATURAL_32; a_k2: CE_POINTER [ANY]; a_key2_len: NATURAL_32): NATURAL_32
		local
			l_key1: CE_POINTER [INTEGER_8]
			l_key2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_key1.make
			create l_key2.make

			l_key1 := create {CE_POINTER [INTEGER_8]}.make_cast (a_k1)
			l_key2 := create {CE_POINTER [INTEGER_8]}.make_cast (a_k2)
			if a_key1_len = a_key2_len then
				if (l_key1[0]).to_integer_32 = (l_key2[0]).to_integer_32 then
					if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_key1), create {CE_POINTER [ANY]}.make_cast (l_key2), a_key1_len)) = 0 then
						Result := (1).to_natural_32
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (0).to_natural_32
			end
		end

	Curl_str_key_compare_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_str_key_compare)
		end

	hash_element_dtor (a_user: CE_POINTER [ANY]; a_element: CE_POINTER [ANY])
		local
			l_h: CE_POINTER [PD_CURL_HASH]
			l_e: CE_POINTER [PD_CURL_HASH_ELEMENT]
		do
			create l_h.make
			create l_e.make

			l_h := create {CE_POINTER [PD_CURL_HASH]}.make_cast (a_user)
			l_e := create {CE_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (a_element)
			if (not (l_e.item.key).is_void) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_e.item.key)])
			end
			if (not (l_e.item.ptr).is_void) then
				(l_h.item.dtor).call ([l_e.item.ptr])
			end
			easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_e)])
		end

	hash_element_dtor_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hash_element_dtor)
		end

	mk_hash_element (a_key: CE_POINTER [ANY]; a_key_len: NATURAL_32; a_p: CE_POINTER [ANY]): CE_POINTER [PD_CURL_HASH_ELEMENT]
		local
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			l_dupkey: CE_POINTER [ANY]
		do
			create l_he.make
			create l_dupkey.make

			l_he := create {CE_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(create {PD_CURL_HASH_ELEMENT}.make).structure_size.to_natural_32]))))
			if (not l_he.is_void) then
				l_dupkey := (create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([a_key_len])))
				if (not l_dupkey.is_void) then
					memcpy (l_dupkey, a_key, a_key_len).do_nothing
					l_he.item.key := create {CE_POINTER [INTEGER_8]}.make_cast (l_dupkey)
					l_he.item.key_len := a_key_len
					l_he.item.ptr := a_p
				else
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_he)])
					l_he := create {CE_POINTER [PD_CURL_HASH_ELEMENT]}.make_shared (default_pointer)
				end
			end
			Result := l_he
		end

end
