class
	P_HMAC

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create hmac_ipad.make (<<1>>)
			create hmac_opad.make (<<1>>)
		end

feature {ANY} -- attributes

	hmac_ipad: CE_ARRAY [NATURAL_8]

	hmac_opad: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	Curl_HMAC_final (a_ctxt: CE_POINTER [PD_HMAC_CONTEXT]; a_result: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_result: CE_POINTER [NATURAL_8]
			l_hashparams: CE_POINTER [PD_HMAC_PARAMS]
		do
			create l_result.make
			create l_hashparams.make

			l_result := a_result
			l_hashparams := a_ctxt.item.hmac_hash
			if l_result.is_void then
				l_result := create {CE_POINTER [NATURAL_8]}.make_cast (a_ctxt.item.hmac_hashctxt2) + ((a_ctxt.item.hmac_hash).item.hmac_ctxtsize).to_integer_32
			end
			(l_hashparams.item.hmac_hfinal).call ([l_result, a_ctxt.item.hmac_hashctxt1]);
			(l_hashparams.item.hmac_hupdate).call ([a_ctxt.item.hmac_hashctxt2, l_result, l_hashparams.item.hmac_resultlen]);
			(l_hashparams.item.hmac_hfinal).call ([l_result, a_ctxt.item.hmac_hashctxt2])
			easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_ctxt)])
			Result := 0
		end

	Curl_HMAC_init (a_hashparams: CE_POINTER [PD_HMAC_PARAMS]; a_key: CE_POINTER [NATURAL_8]; a_keylen: NATURAL_32): CE_POINTER [PD_HMAC_CONTEXT]
		local
			l_key: CE_POINTER [NATURAL_8]
			l_keylen: NATURAL_32
			l_i: NATURAL_32
			l_ctxt: CE_POINTER [PD_HMAC_CONTEXT]
			l_hkey: CE_POINTER [NATURAL_8]
			l_b: CE_ARRAY [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_key.make
			create l_ctxt.make
			create l_hkey.make
			create l_b.make (<<1>>)
			create l_tmp___0.make

			l_key := a_key
			l_keylen := a_keylen
			l_i := ((create {PD_HMAC_CONTEXT}.make).structure_size.to_natural_32 + ({NATURAL_32} 2 * a_hashparams.item.hmac_ctxtsize)) + a_hashparams.item.hmac_resultlen
			l_ctxt := create {CE_POINTER [PD_HMAC_CONTEXT]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_i]))))
			if l_ctxt.is_void then
				Result := l_ctxt
				js.return
			end
			if not js.return_called then
				l_ctxt.item.hmac_hash := a_hashparams
				l_ctxt.item.hmac_hashctxt1 := create {CE_POINTER [ANY]}.make_cast ((l_ctxt + 1))
				l_ctxt.item.hmac_hashctxt2 := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (l_ctxt.item.hmac_hashctxt1) + (a_hashparams.item.hmac_ctxtsize).to_integer_32))
				if l_keylen > a_hashparams.item.hmac_maxkeylen then
					(a_hashparams.item.hmac_hinit).call ([l_ctxt.item.hmac_hashctxt1]);
					(a_hashparams.item.hmac_hupdate).call ([l_ctxt.item.hmac_hashctxt1, l_key, l_keylen])
					l_hkey := create {CE_POINTER [NATURAL_8]}.make_cast (l_ctxt.item.hmac_hashctxt2) + (a_hashparams.item.hmac_ctxtsize).to_integer_32;
					(a_hashparams.item.hmac_hfinal).call ([l_hkey, l_ctxt.item.hmac_hashctxt1])
					l_key := l_hkey
					l_keylen := a_hashparams.item.hmac_resultlen
				end
				(a_hashparams.item.hmac_hinit).call ([l_ctxt.item.hmac_hashctxt1]);
				(a_hashparams.item.hmac_hinit).call ([l_ctxt.item.hmac_hashctxt2])
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_keylen)
				loop
					l_b.item := (((l_key.item).to_integer_32).bit_xor ((hmac_ipad.item).to_integer_32)).to_natural_8;
					(a_hashparams.item.hmac_hupdate).call ([l_ctxt.item.hmac_hashctxt1, l_b, {NATURAL_32} 1])
					l_tmp___0 := l_key
					l_key := l_key + 1
					l_b.item := (((l_tmp___0.item).to_integer_32).bit_xor ((hmac_opad.item).to_integer_32)).to_natural_8;
					(a_hashparams.item.hmac_hupdate).call ([l_ctxt.item.hmac_hashctxt2, l_b, {NATURAL_32} 1])
					l_i := l_i + 1
				end
				from
				until
					not (l_i < a_hashparams.item.hmac_maxkeylen)
				loop
					(a_hashparams.item.hmac_hupdate).call ([l_ctxt.item.hmac_hashctxt1, hmac_ipad, {NATURAL_32} 1]);
					(a_hashparams.item.hmac_hupdate).call ([l_ctxt.item.hmac_hashctxt2, hmac_opad, {NATURAL_32} 1])
					l_i := l_i + 1
				end
				Result := l_ctxt
			end
		end

	Curl_HMAC_update (a_ctxt: CE_POINTER [PD_HMAC_CONTEXT]; a_data: CE_POINTER [NATURAL_8]; a_len: NATURAL_32): INTEGER_32
		do
			((a_ctxt.item.hmac_hash).item.hmac_hupdate).call ([a_ctxt.item.hmac_hashctxt1, a_data, a_len])
			Result := 0
		end

end
