class
	P_HOSTIP4

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_ipv4_resolve_r (a_hostname: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): CE_POINTER [PD_CURL_ADDRINFO]
		local
			l_ai: CE_ARRAY [CE_POINTER [PD_CURL_ADDRINFO]]
			l_h: CE_POINTER [SD_HOSTENT]
			l_in: CE_ARRAY [SD_IN_ADDR]
			l_buf: CE_POINTER [SD_HOSTENT]
			l_hints: CE_ARRAY [SD_ADDRINFO]
			l_sbuf: CE_ARRAY [INTEGER_8]
			l_sbufptr: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_ai.make (<<1>>)
			create l_h.make
			create l_in.make (<<1>>)
			create l_buf.make
			create l_hints.make (<<1>>)
			create l_sbuf.make (<<32>>)
			create l_sbufptr.make

			l_ai.item := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
			l_h := create {CE_POINTER [SD_HOSTENT]}.make_shared (default_pointer)
			l_buf := create {CE_POINTER [SD_HOSTENT]}.make_shared (default_pointer)
			if (inet_pton (2, a_hostname, create {CE_POINTER [ANY]}.make_cast (l_in))) > 0 then
				Result := (curl_addrinfo_inst.Curl_ip2addr (2, create {CE_POINTER [ANY]}.make_cast (l_in), a_hostname, a_port))
				js.return
			else
				l_sbufptr := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				memset (create {CE_POINTER [ANY]}.make_cast (l_hints), 0, (create {SD_ADDRINFO}.make).structure_size.to_natural_32).do_nothing
				l_hints.item.ai_family := 2
				l_hints.item.ai_socktype := 1
				if a_port.to_boolean then
					mprintf_inst.curl_msnprintf ([l_sbuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%d"), a_port]).do_nothing
					l_sbufptr := l_sbuf
				end
				curl_addrinfo_inst.Curl_getaddrinfo_ex (a_hostname, l_sbufptr, l_hints, l_ai).do_nothing
			end
			if not js.return_called then
				if (not l_h.is_void) then
					l_ai.item := curl_addrinfo_inst.Curl_he2ai (l_h, a_port)
					if (not l_buf.is_void) then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_buf)])
					end
				end
				Result := (l_ai.item)
			end
		end

end
