class
	P_HOSTIP6

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_getaddrinfo (a_conn: CE_POINTER [PD_CONNECTDATA]; a_hostname: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_waitp: CE_POINTER [INTEGER_32]): CE_POINTER [PD_CURL_ADDRINFO]
		local
			l_hints: CE_ARRAY [SD_ADDRINFO]
			l_res: CE_ARRAY [CE_POINTER [PD_CURL_ADDRINFO]]
			l_error: INTEGER_32
			l_sbuf: CE_ARRAY [INTEGER_8]
			l_sbufptr: CE_POINTER [INTEGER_8]
			l_addrbuf: CE_ARRAY [INTEGER_8]
			l_pf: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_s: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hints.make (<<1>>)
			create l_res.make (<<1>>)
			create l_sbuf.make (<<32>>)
			create l_sbufptr.make
			create l_addrbuf.make (<<128>>)
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sbufptr := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_data := a_conn.item.data
					a_waitp.item := 0
					inspect (l_data.item.set.ip_version).to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1
					l_pf := 2
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_pf := 10
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					l_pf := 0
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if l_pf /= 2 then
						l_s := (socket (10, 2, 0))
						if l_s = -1 then
							l_pf := 2
						else
							close (l_s).do_nothing
						end
					end
					memset (create {CE_POINTER [ANY]}.make_cast (l_hints), 0, (create {SD_ADDRINFO}.make).structure_size.to_natural_32).do_nothing
					l_hints.item.ai_family := l_pf
					l_hints.item.ai_socktype := a_conn.item.socktype
					if 1 = (inet_pton (2, a_hostname, create {CE_POINTER [ANY]}.make_cast (l_addrbuf))) then
						l_hints.item.ai_flags := 4
					elseif 1 = (inet_pton (10, a_hostname, create {CE_POINTER [ANY]}.make_cast (l_addrbuf))) then
						l_hints.item.ai_flags := 4
					end
					if a_port.to_boolean then
						mprintf_inst.curl_msnprintf ([l_sbuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%d"), a_port]).do_nothing
						l_sbufptr := l_sbuf
					end
					l_error := curl_addrinfo_inst.Curl_getaddrinfo_ex (a_hostname, l_sbufptr, l_hints, l_res)
					if l_error.to_boolean then
						sendf_inst.Curl_infof ([l_data, ce_string ("getaddrinfo(3) failed for %%s:%%d%N"), a_hostname, a_port])
						Result := (create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						Result := (l_res.item)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_ipvalid (a_data: CE_POINTER [PD_SESSIONHANDLE]): BOOLEAN
		local
			l_s: INTEGER_32
			js: JUMP_STATE
		do
			if a_data.item.set.ip_version = 2 then
				l_s := (socket (10, 2, 0))
				if l_s = -1 then
					Result := (0).to_boolean
					js.return
				end
				if not js.return_called then
					close (l_s).do_nothing
				end
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

end
