class
	P_HTTP_CHUNKS

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_httpchunk_init (a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_chunk: CE_POINTER [PD_CURL_CHUNKER]
		do
			create l_chunk.make

			l_chunk := create {CE_POINTER [PD_CURL_CHUNKER]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("chunk"))
			l_chunk.item.hexindex := 0
			l_chunk.item.dataleft := (0).to_natural_32
			l_chunk.item.state := {PC_CHUNKYSTATE}.CHUNK_HEX
		end

	Curl_httpchunk_read (a_conn: CE_POINTER [PD_CONNECTDATA]; a_datap: CE_POINTER [INTEGER_8]; a_datalen: INTEGER_32; a_wrotep: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_datap: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ch: CE_POINTER [PD_CURL_CHUNKER]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_piece: NATURAL_32
			l_length: NATURAL_32
			l_wrote: CE_POINTER [NATURAL_32]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_datap.make
			create l_data.make
			create l_ch.make
			create l_k.make
			create l_wrote.make
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_datap := a_datap
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := a_conn.item.data
					l_ch := create {CE_POINTER [PD_CURL_CHUNKER]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("chunk"))
					l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_length := a_datalen.to_natural_32
					l_wrote := create {CE_POINTER [NATURAL_32]}.make_cast (a_wrotep)
					l_wrote.item := (0).to_natural_32
					if l_data.item.set.http_te_skip then
						if not l_k.item.ignorebody then
							l_result := sendf_inst.Curl_client_write (a_conn, 1, l_datap, a_datalen.to_natural_32)
							if l_result.to_boolean then
								Result := ({PC_CHUNKCODE}.CHUNKE_WRITE_ERROR)
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not js.loop_done and then (l_length.to_boolean)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 2 then -- loop body:
						inspect (l_ch.item.state).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						when 5 then l_pos := -1 + 7
						when 6 then l_pos := -1 + 8
						when 9 then l_pos := -1 + 9
						when 10 then l_pos := -1 + 11
						when 11 then l_pos := -1 + 12
						when 7 then l_pos := -1 + 14
						when 8 then l_pos := -1 + 15
						else l_pos := -1 + 16
						end
				when 3 then -- switch 1, case 1
						if (Curl_isxdigit (l_datap[0])) then
							if l_ch.item.hexindex < 16 then
								l_ch.item.hexbuffer[l_ch.item.hexindex] := l_datap[0]
								l_datap := l_datap + 1
								l_length := l_length - 1
								l_ch.item.hexindex := (l_ch.item.hexindex) + 1
							else
								Result := ({PC_CHUNKCODE}.CHUNKE_TOO_LONG_HEX)
								js.return
							end
						else
							if 0 = l_ch.item.hexindex then
								Result := ({PC_CHUNKCODE}.CHUNKE_ILLEGAL_HEX)
								js.return
							end
							if not js.return_called then
								l_ch.item.hexbuffer[l_ch.item.hexindex] := (0).to_integer_8
								l_ch.item.datasize := (strtoul ((l_ch.item.hexbuffer), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 16)).to_natural_32
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_POSTHEX
							end
						end
						l_pos := -1 + 17 -- switch 1; break
				when 4 then -- switch 1, case 2
						if (l_datap[0]).to_integer_32 = 13 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_CR
						end
						l_length := l_length - 1
						l_datap := l_datap + 1
						l_pos := -1 + 17 -- switch 1; break
				when 5 then -- switch 1, case 3
						if (l_datap[0]).to_integer_32 = 10 then
							if {NATURAL_32} 0 = l_ch.item.datasize then
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER
								a_conn.item.trlPos := 0
							else
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_DATA
							end
						else
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_CR
						end
						l_datap := l_datap + 1
						l_length := l_length - 1
						l_pos := -1 + 17 -- switch 1; break
				when 6 then -- switch 1, case 4
						if l_ch.item.datasize >= l_length then
							l_piece := l_length
						else
							l_piece := l_ch.item.datasize
						end
						if not l_k.item.ignorebody then
							if not l_data.item.set.http_te_skip then
								l_result := sendf_inst.Curl_client_write (a_conn, 1, l_datap, l_piece)
							else
								l_result := {PC_CURLCODE}.CURLE_OK
							end
						end
						if l_result.to_boolean then
							Result := ({PC_CHUNKCODE}.CHUNKE_WRITE_ERROR)
							js.return
						end
						if not js.return_called then
							l_wrote.item := l_wrote.item + l_piece
							l_ch.item.datasize := l_ch.item.datasize - l_piece
							l_datap := l_datap + l_piece.to_integer_32
							l_length := l_length - l_piece
							if {NATURAL_32} 0 = l_ch.item.datasize then
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_POSTCR
							end
						end
						l_pos := -1 + 17 -- switch 1; break
				when 7 then -- switch 1, case 5
						if (l_datap[0]).to_integer_32 = 13 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_POSTLF
							l_datap := l_datap + 1
							l_length := l_length - 1
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							js.return
						end
						l_pos := -1 + 17 -- switch 1; break
				when 8 then -- switch 1, case 6
						if (l_datap[0]).to_integer_32 = 10 then
							Curl_httpchunk_init (a_conn)
							l_datap := l_datap + 1
							l_length := l_length - 1
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							js.return
						end
						l_pos := -1 + 17 -- switch 1; break
				when 9 then -- switch 1, case 9
						if (l_datap[0]).to_integer_32 = 13 then
							if (a_conn.item.trlPos).to_boolean then
								l_tmp___1 := a_conn.item.trlPos
								a_conn.item.trlPos := (a_conn.item.trlPos) + 1
								a_conn.item.trailer[l_tmp___1] := (13).to_integer_8
								l_tmp___2 := a_conn.item.trlPos
								a_conn.item.trlPos := (a_conn.item.trlPos) + 1
								a_conn.item.trailer[l_tmp___2] := (10).to_integer_8
								a_conn.item.trailer[a_conn.item.trlPos] := (0).to_integer_8
								if not l_data.item.set.http_te_skip then
									l_result := sendf_inst.Curl_client_write (a_conn, (1).bit_shift_left (1), a_conn.item.trailer, (a_conn.item.trlPos).to_natural_32)
									if l_result.to_boolean then
										Result := ({PC_CHUNKCODE}.CHUNKE_WRITE_ERROR)
										js.return
									end
								end
								if not js.return_called then
									a_conn.item.trlPos := 0
									l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER_CR
								end
							else
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER_POSTCR
								l_pos := -1 + 17 -- switch 1; break
							end
						else
							if a_conn.item.trlPos >= a_conn.item.trlMax then
								if (a_conn.item.trlMax).to_boolean then
									a_conn.item.trlMax := a_conn.item.trlMax * (2)
									l_ptr := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (a_conn.item.trailer), (a_conn.item.trlMax + 3).to_natural_32]))))
								else
									a_conn.item.trlMax := 128
									l_ptr := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(a_conn.item.trlMax + 3).to_natural_32]))))
								end
								if l_ptr.is_void then
									Result := ({PC_CHUNKCODE}.CHUNKE_OUT_OF_MEMORY)
									js.return
								end
								if not js.return_called then
									a_conn.item.trailer := l_ptr
								end
							end
							if not js.return_called then
								mprintf_inst.curl_mfprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), ce_string ("MOO: %%c%N"), (l_datap[0]).to_integer_32]).do_nothing
								l_tmp___5 := a_conn.item.trlPos
								a_conn.item.trlPos := (a_conn.item.trlPos) + 1
								a_conn.item.trailer[l_tmp___5] := l_datap[0]
							end
						end
				when 10 then
						if not js.return_called then
							l_datap := l_datap + 1
							l_length := l_length - 1
						end
						l_pos := -1 + 17 -- switch 1; break
				when 11 then -- switch 1, case 10
						if (l_datap[0]).to_integer_32 = 10 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER_POSTCR
							l_datap := l_datap + 1
							l_length := l_length - 1
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							js.return
						end
						l_pos := -1 + 17 -- switch 1; break
				when 12 then -- switch 1, case 11
						if (l_datap[0]).to_integer_32 /= 13 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER
							l_pos := -1 + 17 -- switch 1; break
						end
				when 13 then
						l_datap := l_datap + 1
						l_length := l_length - 1
						l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_STOP
						l_pos := -1 + 17 -- switch 1; break
				when 14 then -- switch 1, case 7
						if (l_datap[0]).to_integer_32 = 13 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_STOP
							l_datap := l_datap + 1
							l_length := l_length - 1
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							js.return
						end
						l_pos := -1 + 17 -- switch 1; break
				when 15 then -- switch 1, case 8
						if (l_datap[0]).to_integer_32 = 10 then
							l_length := l_length - 1
							l_ch.item.dataleft := l_length
							Result := (-1)
							js.return
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							js.return
						end
				when 16 then -- switch 1, default:
						if not js.return_called then
							Result := ({PC_CHUNKCODE}.CHUNKE_STATE_ERROR)
							js.return
						end
				when 17 then -- switch 1, done:
						l_pos := -1 + 1 -- back to loop condition
				when 18 then -- loop done | if done
						if not js.return_called then
							Result := ({PC_CHUNKCODE}.CHUNKE_OK)
						end
				when 19 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_isxdigit (a_digit: INTEGER_8): BOOLEAN
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_digit.to_integer_32 >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_digit.to_integer_32 <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if not (a_digit.to_integer_32 >= 65) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_digit.to_integer_32 <= 70 then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_digit.to_integer_32 >= 97 then
							if a_digit.to_integer_32 <= 102 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 7 then -- if done
						Result := l_tmp.to_boolean
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
