class
	P_HTTP_DIGEST

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_digest_cleanup (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			Curl_digest_cleanup_one (create {CE_POINTER [PD_DIGESTDATA]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("digest")))
			Curl_digest_cleanup_one (create {CE_POINTER [PD_DIGESTDATA]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("proxydigest")))
		end

	Curl_digest_cleanup_one (a_d: CE_POINTER [PD_DIGESTDATA])
		do
			if (not (a_d.item.nonce).is_void) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_d.item.nonce)])
			end
			a_d.item.nonce := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			if (not (a_d.item.cnonce).is_void) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_d.item.cnonce)])
			end
			a_d.item.cnonce := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			if (not (a_d.item.realm).is_void) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_d.item.realm)])
			end
			a_d.item.realm := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			if (not (a_d.item.opaque).is_void) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_d.item.opaque)])
			end
			a_d.item.opaque := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			if (not (a_d.item.qop).is_void) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_d.item.qop)])
			end
			a_d.item.qop := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			if (not (a_d.item.algorithm).is_void) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_d.item.algorithm)])
			end
			a_d.item.algorithm := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			a_d.item.nc := 0
			a_d.item.algo := 0
			a_d.item.stale := (0).to_boolean
		end

	Curl_input_digest (a_conn: CE_POINTER [PD_CONNECTDATA]; a_proxy: BOOLEAN; a_header: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_header: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_token: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_foundAuth: BOOLEAN
			l_foundAuthInt: BOOLEAN
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_before: BOOLEAN
			l_d: CE_POINTER [PD_DIGESTDATA]
			l_value: CE_ARRAY [INTEGER_8]
			l_content: CE_ARRAY [INTEGER_8]
			l_tok_buf: CE_ARRAY [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
		do
			create l_header.make (<<1>>)
			create l_token.make
			create l_tmp.make
			create l_data.make
			create l_d.make
			create l_value.make (<<256>>)
			create l_content.make (<<1_024>>)
			create l_tok_buf.make (<<1>>)

			l_header.item := a_header
			l_token := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_tmp := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_foundAuth := (0).to_boolean
			l_foundAuthInt := (0).to_boolean
			l_data := a_conn.item.data
			l_before := (0).to_boolean
			if a_proxy then
				l_d := create {CE_POINTER [PD_DIGESTDATA]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("proxydigest"))
			else
				l_d := create {CE_POINTER [PD_DIGESTDATA]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("digest"))
			end
			from
			until
				js.loop_done
			loop
				if (l_header.item[0]).to_boolean then
					if not ((((ctype_b_loc).item[((l_header.item[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_header.item := l_header.item + 1
				end
			end
			if (rawstr_inst.Curl_raw_nequal (ce_string ("Digest"), l_header.item, (strlen (ce_string ("Digest"))))).to_boolean then
				l_header.item := l_header.item + (strlen (ce_string ("Digest"))).to_integer_32
				if (not (l_d.item.nonce).is_void) then
					l_before := (1).to_boolean
				end
				Curl_digest_cleanup_one (l_d)
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						if (l_header.item[0]).to_boolean then
							if not ((((ctype_b_loc).item[((l_header.item[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_header.item := l_header.item + 1
						end
					end
					if (get_pair (l_header.item, l_value, l_content, l_header)).to_boolean then
						js.break
					elseif (rawstr_inst.Curl_raw_equal (l_value, ce_string ("nonce"))).to_boolean then
						l_d.item.nonce := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_content]))
						if (l_d.item.nonce).is_void then
							Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
							js.return
						end
					elseif (rawstr_inst.Curl_raw_equal (l_value, ce_string ("stale"))).to_boolean then
						if (rawstr_inst.Curl_raw_equal (l_content, ce_string ("true"))).to_boolean then
							l_d.item.stale := (1).to_boolean
							l_d.item.nc := 1
						end
					elseif (rawstr_inst.Curl_raw_equal (l_value, ce_string ("realm"))).to_boolean then
						l_d.item.realm := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_content]))
						if (l_d.item.realm).is_void then
							Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
							js.return
						end
					elseif (rawstr_inst.Curl_raw_equal (l_value, ce_string ("opaque"))).to_boolean then
						l_d.item.opaque := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_content]))
						if (l_d.item.opaque).is_void then
							Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
							js.return
						end
					elseif (rawstr_inst.Curl_raw_equal (l_value, ce_string ("qop"))).to_boolean then
						l_tmp := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_content]))
						if l_tmp.is_void then
							Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
							js.return
						end
						if not js.return_called then
							l_token := strtok_r (l_tmp, ce_string (","), l_tok_buf)
							from
							until
								l_token.is_void
							loop
								if (rawstr_inst.Curl_raw_equal (l_token, ce_string ("auth"))).to_boolean then
									l_foundAuth := (1).to_boolean
								elseif (rawstr_inst.Curl_raw_equal (l_token, ce_string ("auth-int"))).to_boolean then
									l_foundAuthInt := (1).to_boolean
								end
								l_token := strtok_r (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (","), l_tok_buf)
							end
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_tmp)])
							if l_foundAuth then
								l_d.item.qop := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([ce_string ("auth")]))
								if (l_d.item.qop).is_void then
									Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
									js.return
								end
							elseif l_foundAuthInt then
								l_d.item.qop := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([ce_string ("auth-int")]))
								if (l_d.item.qop).is_void then
									Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
									js.return
								end
							end
						end
					elseif (rawstr_inst.Curl_raw_equal (l_value, ce_string ("algorithm"))).to_boolean then
						l_d.item.algorithm := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_content]))
						if (l_d.item.algorithm).is_void then
							Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
							js.return
						end
						if not js.return_called then
							if (rawstr_inst.Curl_raw_equal (l_content, ce_string ("MD5-sess"))).to_boolean then
								l_d.item.algo := 1
							elseif (rawstr_inst.Curl_raw_equal (l_content, ce_string ("MD5"))).to_boolean then
								l_d.item.algo := 0
							else
								Result := ({PC_CURLDIGEST}.CURLDIGEST_BADALGO)
								js.return
							end
						end
					end
					if not js.loop_jumped then
						from
						until
							js.loop_done
						loop
							if (l_header.item[0]).to_boolean then
								if not ((((ctype_b_loc).item[((l_header.item[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_header.item := l_header.item + 1
							end
						end
						if 44 = (l_header.item[0]).to_integer_32 then
							l_header.item := l_header.item + 1
						end
					end
				end
				if not js.return_called and then l_before then
					if not l_d.item.stale then
						Result := ({PC_CURLDIGEST}.CURLDIGEST_BAD)
						js.return
					end
				end
				if not js.return_called and then ((l_d.item.nonce).is_void) then
					Result := ({PC_CURLDIGEST}.CURLDIGEST_BAD)
					js.return
				end
			else
				Result := ({PC_CURLDIGEST}.CURLDIGEST_NONE)
				js.return
			end
			if not js.return_called then
				Result := ({PC_CURLDIGEST}.CURLDIGEST_FINE)
			end
		end

	Curl_output_digest (a_conn: CE_POINTER [PD_CONNECTDATA]; a_proxy: BOOLEAN; a_request: CE_POINTER [NATURAL_8]; a_uripath: CE_POINTER [NATURAL_8]): NATURAL_32
		local
			l_md5buf: CE_ARRAY [NATURAL_8]
			l_request_digest: CE_ARRAY [NATURAL_8]
			l_md5this: CE_POINTER [NATURAL_8]
			l_ha1: CE_POINTER [NATURAL_8]
			l_ha2: CE_ARRAY [NATURAL_8]
			l_cnoncebuf: CE_ARRAY [INTEGER_8]
			l_cnonce: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp: CE_POINTER [INTEGER_8]
			l_now: SD_TIMEVAL
			l_allocuserpwd: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_userp: CE_POINTER [INTEGER_8]
			l_passwdp: CE_POINTER [INTEGER_8]
			l_authp: CE_POINTER [PD_AUTH]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_d: CE_POINTER [PD_DIGESTDATA]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___7: INTEGER_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_md5buf.make (<<16>>)
			create l_request_digest.make (<<33>>)
			create l_md5this.make
			create l_ha1.make
			create l_ha2.make (<<33>>)
			create l_cnoncebuf.make (<<7>>)
			create l_cnonce.make (<<1>>)
			create l_tmp.make
			create l_now.make
			create l_allocuserpwd.make
			create l_userp.make
			create l_passwdp.make
			create l_authp.make
			create l_data.make
			create l_d.make
			create l_tmp___5.make
			create l_tmp___10.make
			create l_tmp___12.make

			l_tmp := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_data := a_conn.item.data
			if a_proxy then
				l_d := create {CE_POINTER [PD_DIGESTDATA]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("proxydigest"))
				l_allocuserpwd := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("allocptr") + (create {PD_DYNAMICALLY_ALLOCATED_DATA}.make).offset_of ("proxyuserpwd"))
				l_userp := a_conn.item.proxyuser
				l_passwdp := a_conn.item.proxypasswd
				l_authp := create {CE_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authproxy"))
			else
				l_d := create {CE_POINTER [PD_DIGESTDATA]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("digest"))
				l_allocuserpwd := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("allocptr") + (create {PD_DYNAMICALLY_ALLOCATED_DATA}.make).offset_of ("userpwd"))
				l_userp := a_conn.item.user
				l_passwdp := a_conn.item.passwd
				l_authp := create {CE_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authhost"))
			end
			if (not (l_allocuserpwd.item).is_void) then
				url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_allocuserpwd.item))
				l_allocuserpwd.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			if l_userp.is_void then
				l_userp := ce_string ("")
			end
			if l_passwdp.is_void then
				l_passwdp := ce_string ("")
			end
			if (l_d.item.nonce).is_void then
				l_authp.item.done := (0).to_boolean
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				l_authp.item.done := (1).to_boolean
				if not (l_d.item.nc).to_boolean then
					l_d.item.nc := 1
				end
				if (l_d.item.cnonce).is_void then
					l_now := (timeval_inst.curlx_tvnow).twin
					mprintf_inst.curl_msnprintf ([l_cnoncebuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (7).to_natural_32), ce_string ("%%06ld"), l_now.tv_sec]).do_nothing
					if (base64_inst.Curl_base64_encode (l_data, l_cnoncebuf, (strlen (l_cnoncebuf)), l_cnonce)).to_boolean then
						l_d.item.cnonce := l_cnonce.item
					else
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
				end
			end
			if not js.return_called then
				l_md5this := create {CE_POINTER [NATURAL_8]}.make_cast ((mprintf_inst.curl_maprintf ([ce_string ("%%s:%%s:%%s"), l_userp, l_d.item.realm, l_passwdp])))
				if l_md5this.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				md5_inst.Curl_md5it (l_md5buf, l_md5this)
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_md5this)])
				l_ha1 := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(33).to_natural_32]))))
				if l_ha1.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				md5_to_ascii (l_md5buf, l_ha1)
				if l_d.item.algo = 1 then
					l_tmp := mprintf_inst.curl_maprintf ([ce_string ("%%s:%%s:%%s"), l_ha1, l_d.item.nonce, l_d.item.cnonce])
					if l_tmp.is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
					if not js.return_called then
						md5_inst.Curl_md5it (l_md5buf, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp))
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_tmp)])
						md5_to_ascii (l_md5buf, l_ha1)
					end
				end
			end
			if not js.return_called then
				if l_authp.item.iestyle then
					l_tmp := strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_uripath), ('?').code)
					if not l_tmp.is_void then
						l_md5this := create {CE_POINTER [NATURAL_8]}.make_cast ((mprintf_inst.curl_maprintf ([ce_string ("%%s:%%.*s"), a_request, l_tmp.distance ((create {CE_POINTER [INTEGER_8]}.make_cast (a_uripath))), a_uripath])))
					else
						l_tmp___5 := mprintf_inst.curl_maprintf ([ce_string ("%%s:%%s"), a_request, a_uripath])
						l_md5this := create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5)
					end
				else
					l_tmp___5 := mprintf_inst.curl_maprintf ([ce_string ("%%s:%%s"), a_request, a_uripath])
					l_md5this := create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5)
				end
				if l_md5this.is_void then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ha1)])
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				if (not (l_d.item.qop).is_void) then
					if (rawstr_inst.Curl_raw_equal (l_d.item.qop, ce_string ("auth-int"))).to_boolean then
						l_tmp___7 := 1
					else
						l_tmp___7 := 0
					end
				else
					l_tmp___7 := 0
				end
				md5_inst.Curl_md5it (l_md5buf, l_md5this)
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_md5this)])
				md5_to_ascii (l_md5buf, l_ha2)
				if (not (l_d.item.qop).is_void) then
					l_md5this := create {CE_POINTER [NATURAL_8]}.make_cast ((mprintf_inst.curl_maprintf ([ce_string ("%%s:%%s:%%08x:%%s:%%s:%%s"), l_ha1, l_d.item.nonce, l_d.item.nc, l_d.item.cnonce, l_d.item.qop, l_ha2])))
				else
					l_md5this := create {CE_POINTER [NATURAL_8]}.make_cast ((mprintf_inst.curl_maprintf ([ce_string ("%%s:%%s:%%s"), l_ha1, l_d.item.nonce, l_ha2])))
				end
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ha1)])
				if l_md5this.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				md5_inst.Curl_md5it (l_md5buf, l_md5this)
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_md5this)])
				md5_to_ascii (l_md5buf, l_request_digest)
				if (not (l_d.item.qop).is_void) then
					if a_proxy then
						l_tmp___10 := ce_string ("Proxy-")
					else
						l_tmp___10 := ce_string ("")
					end
					l_allocuserpwd.item := mprintf_inst.curl_maprintf ([ce_string ("%%sAuthorization: Digest username=%"%%s%", realm=%"%%s%", nonce=%"%%s%", uri=%"%%s%", cnonce=%"%%s%", nc=%%08x, qop=%"%%s%", response=%"%%s%""), l_tmp___10, l_userp, l_d.item.realm, l_d.item.nonce, a_uripath, l_d.item.cnonce, l_d.item.nc, l_d.item.qop, l_request_digest])
					if (rawstr_inst.Curl_raw_equal (l_d.item.qop, ce_string ("auth"))).to_boolean then
						l_d.item.nc := (l_d.item.nc) + 1
					end
				else
					if a_proxy then
						l_tmp___12 := ce_string ("Proxy-")
					else
						l_tmp___12 := ce_string ("")
					end
					l_allocuserpwd.item := mprintf_inst.curl_maprintf ([ce_string ("%%sAuthorization: Digest username=%"%%s%", realm=%"%%s%", nonce=%"%%s%", uri=%"%%s%", response=%"%%s%""), l_tmp___12, l_userp, l_d.item.realm, l_d.item.nonce, a_uripath, l_request_digest])
				end
				if (l_allocuserpwd.item).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called and then (not (l_d.item.opaque).is_void) then
				l_tmp := mprintf_inst.curl_maprintf ([ce_string ("%%s, opaque=%"%%s%""), l_allocuserpwd.item, l_d.item.opaque])
				if l_tmp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
				if not js.return_called then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_allocuserpwd.item)])
					l_allocuserpwd.item := l_tmp
				end
			end
			if not js.return_called and then (not (l_d.item.algorithm).is_void) then
				l_tmp := mprintf_inst.curl_maprintf ([ce_string ("%%s, algorithm=%"%%s%""), l_allocuserpwd.item, l_d.item.algorithm])
				if l_tmp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
				if not js.return_called then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_allocuserpwd.item)])
					l_allocuserpwd.item := l_tmp
				end
			end
			if not js.return_called then
				l_tmp := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_allocuserpwd.item), (strlen (l_allocuserpwd.item)) + {NATURAL_32} 3]))))
				if l_tmp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				strcat (l_tmp, ce_string ("%R%N")).do_nothing
				l_allocuserpwd.item := l_tmp
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	get_pair (a_str: CE_POINTER [INTEGER_8]; a_value: CE_POINTER [INTEGER_8]; a_content: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_str: CE_POINTER [INTEGER_8]
			l_value: CE_POINTER [INTEGER_8]
			l_content: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_starts_with_quote: BOOLEAN
			l_escape: BOOLEAN
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str.make
			create l_value.make
			create l_content.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str := a_str
					l_value := a_value
					l_content := a_content
					l_starts_with_quote := (0).to_boolean
					l_escape := (0).to_boolean
					l_c := 255
					from
					until
						js.loop_done
					loop
						if (l_str[0]).to_boolean then
							if (l_str[0]).to_integer_32 /= 61 then
								l_tmp___1 := l_c
								l_c := l_c - 1
								if not l_tmp___1.to_boolean then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_tmp := l_value
							l_value := l_value + 1
							l_tmp___0 := l_str
							l_str := l_str + 1
							l_tmp[0] := l_tmp___0[0]
						end
					end
					l_value[0] := (0).to_integer_8
					l_tmp___2 := l_str
					l_str := l_str + 1
					if 61 /= (l_tmp___2[0]).to_integer_32 then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if 34 = (l_str[0]).to_integer_32 then
							l_str := l_str + 1
							l_starts_with_quote := (1).to_boolean
						end
						l_c := 1_023
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						if (l_str[0]).to_boolean then
							l_tmp___5 := l_c
							l_c := l_c - 1
							if not l_tmp___5.to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						inspect (l_str[0]).to_integer_32 -- switch 1 head
						when 92 then l_pos := -1 + 5
						when 44 then l_pos := -1 + 6
						when 13 then l_pos := -1 + 7
						when 10 then l_pos := -1 + 7
						when 34 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 5 then -- switch 1, case 92
						if not l_escape then
							l_escape := (1).to_boolean
							l_tmp___3 := l_content
							l_content := l_content + 1
							l_tmp___3[0] := (('\').code).to_integer_8
							js.continue
						end
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 44
						if not l_starts_with_quote then
							l_c := 0
							js.continue
						end
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 13 | switch 1, case 10
						l_c := 0
						js.continue
				when 8 then -- switch 1, case 34
						if not js.loop_jumped and then (not l_escape) then
							if l_starts_with_quote then
								l_c := 0
								js.continue
							end
						end
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
						if not js.loop_jumped then
							l_escape := (0).to_boolean
							l_tmp___4 := l_content
							l_content := l_content + 1
							l_tmp___4[0] := l_str[0]
						end
						if js.loop_increment then
							l_str := l_str + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_content[0] := (0).to_integer_8
						a_endptr.item := l_str
						Result := 0
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	md5_to_ascii (a_source: CE_POINTER [NATURAL_8]; a_dest: CE_POINTER [NATURAL_8])
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < 16)
			loop
				mprintf_inst.curl_msnprintf ([create {CE_POINTER [INTEGER_8]}.make_cast ((a_dest + l_i * 2)), (3).to_natural_32, ce_string ("%%02x"), (a_source[l_i]).to_integer_32]).do_nothing
				l_i := l_i + 1
			end
		end

end
