class
	P_LLIST

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_llist_alloc (a_dtor: CE_ROUTINE): CE_POINTER [PD_CURL_LLIST]
		local
			l_list: CE_POINTER [PD_CURL_LLIST]
			js: JUMP_STATE
		do
			create l_list.make

			l_list := create {CE_POINTER [PD_CURL_LLIST]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(create {PD_CURL_LLIST}.make).structure_size.to_natural_32]))))
			if l_list.is_void then
				Result := (create {CE_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				llist_init (l_list, a_dtor)
				Result := l_list
			end
		end

	Curl_llist_count (a_list: CE_POINTER [PD_CURL_LLIST]): NATURAL_32
		do
			Result := (a_list.item.size)
		end

	Curl_llist_destroy (a_list: CE_POINTER [PD_CURL_LLIST]; a_user: CE_POINTER [ANY])
		do
			if (not a_list.is_void) then
				from
				until
					not (a_list.item.size > {NATURAL_32} 0)
				loop
					Curl_llist_remove (a_list, a_list.item.tail, a_user).do_nothing
				end
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_list)])
			end
		end

	Curl_llist_insert_next (a_list: CE_POINTER [PD_CURL_LLIST]; a_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]; a_p: CE_POINTER [ANY]): INTEGER_32
		local
			l_ne: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			js: JUMP_STATE
		do
			create l_ne.make

			l_ne := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(create {PD_CURL_LLIST_ELEMENT}.make).structure_size.to_natural_32]))))
			if l_ne.is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_ne.item.ptr := a_p
				if a_list.item.size = {NATURAL_32} 0 then
					a_list.item.head := l_ne;
					(a_list.item.head).item.prev := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer);
					(a_list.item.head).item.next := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
					a_list.item.tail := l_ne
				else
					if (not a_e.is_void) then
						l_ne.item.next := a_e.item.next
					else
						l_ne.item.next := a_list.item.head
					end
					l_ne.item.prev := a_e
					if a_e.is_void then
						(a_list.item.head).item.prev := l_ne
						a_list.item.head := l_ne
					elseif (not (a_e.item.next).is_void) then
						(a_e.item.next).item.prev := l_ne
					else
						a_list.item.tail := l_ne
					end
					if (not a_e.is_void) then
						a_e.item.next := l_ne
					end
				end
				a_list.item.size := (a_list.item.size) + 1
				Result := 1
			end
		end

	Curl_llist_move (a_list: CE_POINTER [PD_CURL_LLIST]; a_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]; a_to_list: CE_POINTER [PD_CURL_LLIST]; a_to_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_e.is_void then
				Result := 0
				js.return
			elseif a_list.item.size = {NATURAL_32} 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if a_e.is_equal (a_list.item.head) then
					a_list.item.head := a_e.item.next
					if (a_list.item.head).is_void then
						a_list.item.tail := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
					else
						(a_e.item.next).item.prev := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
					end
				else
					(a_e.item.prev).item.next := a_e.item.next
					if (a_e.item.next).is_void then
						a_list.item.tail := a_e.item.prev
					else
						(a_e.item.next).item.prev := a_e.item.prev
					end
				end
				a_list.item.size := (a_list.item.size) - 1
				if a_to_list.item.size = {NATURAL_32} 0 then
					a_to_list.item.head := a_e;
					(a_to_list.item.head).item.prev := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer);
					(a_to_list.item.head).item.next := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
					a_to_list.item.tail := a_e
				else
					a_e.item.next := a_to_e.item.next
					a_e.item.prev := a_to_e
					if (not (a_to_e.item.next).is_void) then
						(a_to_e.item.next).item.prev := a_e
					else
						a_to_list.item.tail := a_e
					end
					a_to_e.item.next := a_e
				end
				a_to_list.item.size := (a_to_list.item.size) + 1
				Result := 1
			end
		end

	Curl_llist_remove (a_list: CE_POINTER [PD_CURL_LLIST]; a_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]; a_user: CE_POINTER [ANY]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_e.is_void then
				Result := 1
				js.return
			elseif a_list.item.size = {NATURAL_32} 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				if a_e.is_equal (a_list.item.head) then
					a_list.item.head := a_e.item.next
					if (a_list.item.head).is_void then
						a_list.item.tail := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
					else
						(a_e.item.next).item.prev := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
					end
				else
					(a_e.item.prev).item.next := a_e.item.next
					if (a_e.item.next).is_void then
						a_list.item.tail := a_e.item.prev
					else
						(a_e.item.next).item.prev := a_e.item.prev
					end
				end
				(a_list.item.dtor).call ([a_user, a_e.item.ptr])
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_e)])
				a_list.item.size := (a_list.item.size) - 1
				Result := 1
			end
		end

	llist_init (a_l: CE_POINTER [PD_CURL_LLIST]; a_dtor: CE_ROUTINE)
		do
			a_l.item.size := (0).to_natural_32
			a_l.item.dtor := a_dtor
			a_l.item.head := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
			a_l.item.tail := create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
		end

end
