class
	P_MD5

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_HMAC_MD5.make (<<1>>)
			create PADDING.make (<<64>>)
		end

feature {ANY} -- attributes

	Curl_HMAC_MD5: CE_ARRAY [PD_HMAC_PARAMS]

	PADDING: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	Curl_md5it (a_outbuffer: CE_POINTER [NATURAL_8]; a_input: CE_POINTER [NATURAL_8])
		local
			l_ctx: CE_ARRAY [PD_MD5_CTX]
		do
			create l_ctx.make (<<1>>)

			MD5_Init (l_ctx)
			MD5_Update (l_ctx, a_input, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_input))))
			MD5_Final (a_outbuffer, l_ctx)
		end

	Decode (a_output: CE_POINTER [NATURAL_32]; a_input: CE_POINTER [NATURAL_8]; a_len: NATURAL_32)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
		do
			l_i := {NATURAL_32} 0
			l_j := {NATURAL_32} 0
			from
			until
				not (l_j < a_len)
			loop
				a_output[l_i.to_integer_32] := ((((((a_input[l_j.to_integer_32]).to_natural_32).bit_or ((((a_input[(l_j + {NATURAL_32} 1).to_integer_32]).to_natural_32).bit_shift_left (8))))).bit_or ((((a_input[(l_j + {NATURAL_32} 2).to_integer_32]).to_natural_32).bit_shift_left (16))))).bit_or ((((a_input[(l_j + {NATURAL_32} 3).to_integer_32]).to_natural_32).bit_shift_left (24)))
				l_i := l_i + 1
				l_j := l_j + ({NATURAL_32} 4)
			end
		end

	Encode (a_output: CE_POINTER [NATURAL_8]; a_input: CE_POINTER [NATURAL_32]; a_len: NATURAL_32)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
		do
			l_i := {NATURAL_32} 0
			l_j := {NATURAL_32} 0
			from
			until
				not (l_j < a_len)
			loop
				a_output[l_j.to_integer_32] := ((a_input[l_i.to_integer_32]).bit_and ({NATURAL_32} 255)).to_natural_8
				a_output[(l_j + {NATURAL_32} 1).to_integer_32] := ((((a_input[l_i.to_integer_32]).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
				a_output[(l_j + {NATURAL_32} 2).to_integer_32] := ((((a_input[l_i.to_integer_32]).bit_shift_right (16))).bit_and ({NATURAL_32} 255)).to_natural_8
				a_output[(l_j + {NATURAL_32} 3).to_integer_32] := ((((a_input[l_i.to_integer_32]).bit_shift_right (24))).bit_and ({NATURAL_32} 255)).to_natural_8
				l_i := l_i + 1
				l_j := l_j + ({NATURAL_32} 4)
			end
		end

	MD5Transform (a_state___3: CE_POINTER [NATURAL_32]; a_block: CE_POINTER [NATURAL_8])
		local
			l_a: NATURAL_32
			l_b: NATURAL_32
			l_c: NATURAL_32
			l_d: NATURAL_32
			l_x: CE_ARRAY [NATURAL_32]
		do
			create l_x.make (<<16>>)

			l_a := a_state___3[0]
			l_b := a_state___3[1]
			l_c := a_state___3[2]
			l_d := a_state___3[3]
			Decode (l_x, a_block, {NATURAL_32} 64)
			l_a := l_a + ((((((l_b).bit_and (l_c))).bit_or ((((l_b).bit_not).bit_and (l_d)))) + l_x[0]) + {NATURAL_32} 3_614_090_360)
			l_a := (((l_a).bit_shift_left (7))).bit_or (((l_a).bit_shift_right (25)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_and (l_b))).bit_or ((((l_a).bit_not).bit_and (l_c)))) + l_x[1]) + {NATURAL_32} 3_905_402_710)
			l_d := (((l_d).bit_shift_left (12))).bit_or (((l_d).bit_shift_right (20)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_and (l_a))).bit_or ((((l_d).bit_not).bit_and (l_b)))) + l_x[2]) + {NATURAL_32} 606_105_819)
			l_c := (((l_c).bit_shift_left (17))).bit_or (((l_c).bit_shift_right (15)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_and (l_d))).bit_or ((((l_c).bit_not).bit_and (l_a)))) + l_x[3]) + {NATURAL_32} 3_250_441_966)
			l_b := (((l_b).bit_shift_left (22))).bit_or (((l_b).bit_shift_right (10)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_and (l_c))).bit_or ((((l_b).bit_not).bit_and (l_d)))) + l_x[4]) + {NATURAL_32} 4_118_548_399)
			l_a := (((l_a).bit_shift_left (7))).bit_or (((l_a).bit_shift_right (25)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_and (l_b))).bit_or ((((l_a).bit_not).bit_and (l_c)))) + l_x[5]) + {NATURAL_32} 1_200_080_426)
			l_d := (((l_d).bit_shift_left (12))).bit_or (((l_d).bit_shift_right (20)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_and (l_a))).bit_or ((((l_d).bit_not).bit_and (l_b)))) + l_x[6]) + {NATURAL_32} 2_821_735_955)
			l_c := (((l_c).bit_shift_left (17))).bit_or (((l_c).bit_shift_right (15)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_and (l_d))).bit_or ((((l_c).bit_not).bit_and (l_a)))) + l_x[7]) + {NATURAL_32} 4_249_261_313)
			l_b := (((l_b).bit_shift_left (22))).bit_or (((l_b).bit_shift_right (10)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_and (l_c))).bit_or ((((l_b).bit_not).bit_and (l_d)))) + l_x[8]) + {NATURAL_32} 1_770_035_416)
			l_a := (((l_a).bit_shift_left (7))).bit_or (((l_a).bit_shift_right (25)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_and (l_b))).bit_or ((((l_a).bit_not).bit_and (l_c)))) + l_x[9]) + {NATURAL_32} 2_336_552_879)
			l_d := (((l_d).bit_shift_left (12))).bit_or (((l_d).bit_shift_right (20)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_and (l_a))).bit_or ((((l_d).bit_not).bit_and (l_b)))) + l_x[10]) + {NATURAL_32} 4_294_925_233)
			l_c := (((l_c).bit_shift_left (17))).bit_or (((l_c).bit_shift_right (15)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_and (l_d))).bit_or ((((l_c).bit_not).bit_and (l_a)))) + l_x[11]) + {NATURAL_32} 2_304_563_134)
			l_b := (((l_b).bit_shift_left (22))).bit_or (((l_b).bit_shift_right (10)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_and (l_c))).bit_or ((((l_b).bit_not).bit_and (l_d)))) + l_x[12]) + {NATURAL_32} 1_804_603_682)
			l_a := (((l_a).bit_shift_left (7))).bit_or (((l_a).bit_shift_right (25)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_and (l_b))).bit_or ((((l_a).bit_not).bit_and (l_c)))) + l_x[13]) + {NATURAL_32} 4_254_626_195)
			l_d := (((l_d).bit_shift_left (12))).bit_or (((l_d).bit_shift_right (20)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_and (l_a))).bit_or ((((l_d).bit_not).bit_and (l_b)))) + l_x[14]) + {NATURAL_32} 2_792_965_006)
			l_c := (((l_c).bit_shift_left (17))).bit_or (((l_c).bit_shift_right (15)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_and (l_d))).bit_or ((((l_c).bit_not).bit_and (l_a)))) + l_x[15]) + {NATURAL_32} 1_236_535_329)
			l_b := (((l_b).bit_shift_left (22))).bit_or (((l_b).bit_shift_right (10)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_and (l_d))).bit_or (((l_c).bit_and ((l_d).bit_not)))) + l_x[1]) + {NATURAL_32} 4_129_170_786)
			l_a := (((l_a).bit_shift_left (5))).bit_or (((l_a).bit_shift_right (27)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_and (l_c))).bit_or (((l_b).bit_and ((l_c).bit_not)))) + l_x[6]) + {NATURAL_32} 3_225_465_664)
			l_d := (((l_d).bit_shift_left (9))).bit_or (((l_d).bit_shift_right (23)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_and (l_b))).bit_or (((l_a).bit_and ((l_b).bit_not)))) + l_x[11]) + {NATURAL_32} 643_717_713)
			l_c := (((l_c).bit_shift_left (14))).bit_or (((l_c).bit_shift_right (18)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_and (l_a))).bit_or (((l_d).bit_and ((l_a).bit_not)))) + l_x[0]) + {NATURAL_32} 3_921_069_994)
			l_b := (((l_b).bit_shift_left (20))).bit_or (((l_b).bit_shift_right (12)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_and (l_d))).bit_or (((l_c).bit_and ((l_d).bit_not)))) + l_x[5]) + {NATURAL_32} 3_593_408_605)
			l_a := (((l_a).bit_shift_left (5))).bit_or (((l_a).bit_shift_right (27)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_and (l_c))).bit_or (((l_b).bit_and ((l_c).bit_not)))) + l_x[10]) + {NATURAL_32} 38_016_083)
			l_d := (((l_d).bit_shift_left (9))).bit_or (((l_d).bit_shift_right (23)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_and (l_b))).bit_or (((l_a).bit_and ((l_b).bit_not)))) + l_x[15]) + {NATURAL_32} 3_634_488_961)
			l_c := (((l_c).bit_shift_left (14))).bit_or (((l_c).bit_shift_right (18)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_and (l_a))).bit_or (((l_d).bit_and ((l_a).bit_not)))) + l_x[4]) + {NATURAL_32} 3_889_429_448)
			l_b := (((l_b).bit_shift_left (20))).bit_or (((l_b).bit_shift_right (12)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_and (l_d))).bit_or (((l_c).bit_and ((l_d).bit_not)))) + l_x[9]) + {NATURAL_32} 568_446_438)
			l_a := (((l_a).bit_shift_left (5))).bit_or (((l_a).bit_shift_right (27)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_and (l_c))).bit_or (((l_b).bit_and ((l_c).bit_not)))) + l_x[14]) + {NATURAL_32} 3_275_163_606)
			l_d := (((l_d).bit_shift_left (9))).bit_or (((l_d).bit_shift_right (23)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_and (l_b))).bit_or (((l_a).bit_and ((l_b).bit_not)))) + l_x[3]) + {NATURAL_32} 4_107_603_335)
			l_c := (((l_c).bit_shift_left (14))).bit_or (((l_c).bit_shift_right (18)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_and (l_a))).bit_or (((l_d).bit_and ((l_a).bit_not)))) + l_x[8]) + {NATURAL_32} 1_163_531_501)
			l_b := (((l_b).bit_shift_left (20))).bit_or (((l_b).bit_shift_right (12)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_and (l_d))).bit_or (((l_c).bit_and ((l_d).bit_not)))) + l_x[13]) + {NATURAL_32} 2_850_285_829)
			l_a := (((l_a).bit_shift_left (5))).bit_or (((l_a).bit_shift_right (27)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_and (l_c))).bit_or (((l_b).bit_and ((l_c).bit_not)))) + l_x[2]) + {NATURAL_32} 4_243_563_512)
			l_d := (((l_d).bit_shift_left (9))).bit_or (((l_d).bit_shift_right (23)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_and (l_b))).bit_or (((l_a).bit_and ((l_b).bit_not)))) + l_x[7]) + {NATURAL_32} 1_735_328_473)
			l_c := (((l_c).bit_shift_left (14))).bit_or (((l_c).bit_shift_right (18)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_and (l_a))).bit_or (((l_d).bit_and ((l_a).bit_not)))) + l_x[12]) + {NATURAL_32} 2_368_359_562)
			l_b := (((l_b).bit_shift_left (20))).bit_or (((l_b).bit_shift_right (12)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_xor (l_c))).bit_xor (l_d)) + l_x[5]) + {NATURAL_32} 4_294_588_738)
			l_a := (((l_a).bit_shift_left (4))).bit_or (((l_a).bit_shift_right (28)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_xor (l_b))).bit_xor (l_c)) + l_x[8]) + {NATURAL_32} 2_272_392_833)
			l_d := (((l_d).bit_shift_left (11))).bit_or (((l_d).bit_shift_right (21)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_xor (l_a))).bit_xor (l_b)) + l_x[11]) + {NATURAL_32} 1_839_030_562)
			l_c := (((l_c).bit_shift_left (16))).bit_or (((l_c).bit_shift_right (16)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_xor (l_d))).bit_xor (l_a)) + l_x[14]) + {NATURAL_32} 4_259_657_740)
			l_b := (((l_b).bit_shift_left (23))).bit_or (((l_b).bit_shift_right (9)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_xor (l_c))).bit_xor (l_d)) + l_x[1]) + {NATURAL_32} 2_763_975_236)
			l_a := (((l_a).bit_shift_left (4))).bit_or (((l_a).bit_shift_right (28)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_xor (l_b))).bit_xor (l_c)) + l_x[4]) + {NATURAL_32} 1_272_893_353)
			l_d := (((l_d).bit_shift_left (11))).bit_or (((l_d).bit_shift_right (21)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_xor (l_a))).bit_xor (l_b)) + l_x[7]) + {NATURAL_32} 4_139_469_664)
			l_c := (((l_c).bit_shift_left (16))).bit_or (((l_c).bit_shift_right (16)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_xor (l_d))).bit_xor (l_a)) + l_x[10]) + {NATURAL_32} 3_200_236_656)
			l_b := (((l_b).bit_shift_left (23))).bit_or (((l_b).bit_shift_right (9)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_xor (l_c))).bit_xor (l_d)) + l_x[13]) + {NATURAL_32} 681_279_174)
			l_a := (((l_a).bit_shift_left (4))).bit_or (((l_a).bit_shift_right (28)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_xor (l_b))).bit_xor (l_c)) + l_x[0]) + {NATURAL_32} 3_936_430_074)
			l_d := (((l_d).bit_shift_left (11))).bit_or (((l_d).bit_shift_right (21)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_xor (l_a))).bit_xor (l_b)) + l_x[3]) + {NATURAL_32} 3_572_445_317)
			l_c := (((l_c).bit_shift_left (16))).bit_or (((l_c).bit_shift_right (16)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_xor (l_d))).bit_xor (l_a)) + l_x[6]) + {NATURAL_32} 76_029_189)
			l_b := (((l_b).bit_shift_left (23))).bit_or (((l_b).bit_shift_right (9)))
			l_b := l_b + l_c
			l_a := l_a + ((((((l_b).bit_xor (l_c))).bit_xor (l_d)) + l_x[9]) + {NATURAL_32} 3_654_602_809)
			l_a := (((l_a).bit_shift_left (4))).bit_or (((l_a).bit_shift_right (28)))
			l_a := l_a + l_b
			l_d := l_d + ((((((l_a).bit_xor (l_b))).bit_xor (l_c)) + l_x[12]) + {NATURAL_32} 3_873_151_461)
			l_d := (((l_d).bit_shift_left (11))).bit_or (((l_d).bit_shift_right (21)))
			l_d := l_d + l_a
			l_c := l_c + ((((((l_d).bit_xor (l_a))).bit_xor (l_b)) + l_x[15]) + {NATURAL_32} 530_742_520)
			l_c := (((l_c).bit_shift_left (16))).bit_or (((l_c).bit_shift_right (16)))
			l_c := l_c + l_d
			l_b := l_b + ((((((l_c).bit_xor (l_d))).bit_xor (l_a)) + l_x[2]) + {NATURAL_32} 3_299_628_645)
			l_b := (((l_b).bit_shift_left (23))).bit_or (((l_b).bit_shift_right (9)))
			l_b := l_b + l_c
			l_a := l_a + ((((l_c).bit_xor (((l_b).bit_or ((l_d).bit_not)))) + l_x[0]) + {NATURAL_32} 4_096_336_452)
			l_a := (((l_a).bit_shift_left (6))).bit_or (((l_a).bit_shift_right (26)))
			l_a := l_a + l_b
			l_d := l_d + ((((l_b).bit_xor (((l_a).bit_or ((l_c).bit_not)))) + l_x[7]) + {NATURAL_32} 1_126_891_415)
			l_d := (((l_d).bit_shift_left (10))).bit_or (((l_d).bit_shift_right (22)))
			l_d := l_d + l_a
			l_c := l_c + ((((l_a).bit_xor (((l_d).bit_or ((l_b).bit_not)))) + l_x[14]) + {NATURAL_32} 2_878_612_391)
			l_c := (((l_c).bit_shift_left (15))).bit_or (((l_c).bit_shift_right (17)))
			l_c := l_c + l_d
			l_b := l_b + ((((l_d).bit_xor (((l_c).bit_or ((l_a).bit_not)))) + l_x[5]) + {NATURAL_32} 4_237_533_241)
			l_b := (((l_b).bit_shift_left (21))).bit_or (((l_b).bit_shift_right (11)))
			l_b := l_b + l_c
			l_a := l_a + ((((l_c).bit_xor (((l_b).bit_or ((l_d).bit_not)))) + l_x[12]) + {NATURAL_32} 1_700_485_571)
			l_a := (((l_a).bit_shift_left (6))).bit_or (((l_a).bit_shift_right (26)))
			l_a := l_a + l_b
			l_d := l_d + ((((l_b).bit_xor (((l_a).bit_or ((l_c).bit_not)))) + l_x[3]) + {NATURAL_32} 2_399_980_690)
			l_d := (((l_d).bit_shift_left (10))).bit_or (((l_d).bit_shift_right (22)))
			l_d := l_d + l_a
			l_c := l_c + ((((l_a).bit_xor (((l_d).bit_or ((l_b).bit_not)))) + l_x[10]) + {NATURAL_32} 4_293_915_773)
			l_c := (((l_c).bit_shift_left (15))).bit_or (((l_c).bit_shift_right (17)))
			l_c := l_c + l_d
			l_b := l_b + ((((l_d).bit_xor (((l_c).bit_or ((l_a).bit_not)))) + l_x[1]) + {NATURAL_32} 2_240_044_497)
			l_b := (((l_b).bit_shift_left (21))).bit_or (((l_b).bit_shift_right (11)))
			l_b := l_b + l_c
			l_a := l_a + ((((l_c).bit_xor (((l_b).bit_or ((l_d).bit_not)))) + l_x[8]) + {NATURAL_32} 1_873_313_359)
			l_a := (((l_a).bit_shift_left (6))).bit_or (((l_a).bit_shift_right (26)))
			l_a := l_a + l_b
			l_d := l_d + ((((l_b).bit_xor (((l_a).bit_or ((l_c).bit_not)))) + l_x[15]) + {NATURAL_32} 4_264_355_552)
			l_d := (((l_d).bit_shift_left (10))).bit_or (((l_d).bit_shift_right (22)))
			l_d := l_d + l_a
			l_c := l_c + ((((l_a).bit_xor (((l_d).bit_or ((l_b).bit_not)))) + l_x[6]) + {NATURAL_32} 2_734_768_916)
			l_c := (((l_c).bit_shift_left (15))).bit_or (((l_c).bit_shift_right (17)))
			l_c := l_c + l_d
			l_b := l_b + ((((l_d).bit_xor (((l_c).bit_or ((l_a).bit_not)))) + l_x[13]) + {NATURAL_32} 1_309_151_649)
			l_b := (((l_b).bit_shift_left (21))).bit_or (((l_b).bit_shift_right (11)))
			l_b := l_b + l_c
			l_a := l_a + ((((l_c).bit_xor (((l_b).bit_or ((l_d).bit_not)))) + l_x[4]) + {NATURAL_32} 4_149_444_226)
			l_a := (((l_a).bit_shift_left (6))).bit_or (((l_a).bit_shift_right (26)))
			l_a := l_a + l_b
			l_d := l_d + ((((l_b).bit_xor (((l_a).bit_or ((l_c).bit_not)))) + l_x[11]) + {NATURAL_32} 3_174_756_917)
			l_d := (((l_d).bit_shift_left (10))).bit_or (((l_d).bit_shift_right (22)))
			l_d := l_d + l_a
			l_c := l_c + ((((l_a).bit_xor (((l_d).bit_or ((l_b).bit_not)))) + l_x[2]) + {NATURAL_32} 718_787_259)
			l_c := (((l_c).bit_shift_left (15))).bit_or (((l_c).bit_shift_right (17)))
			l_c := l_c + l_d
			l_b := l_b + ((((l_d).bit_xor (((l_c).bit_or ((l_a).bit_not)))) + l_x[9]) + {NATURAL_32} 3_951_481_745)
			l_b := (((l_b).bit_shift_left (21))).bit_or (((l_b).bit_shift_right (11)))
			l_b := l_b + l_c
			a_state___3[0] := a_state___3[0] + l_a
			a_state___3[1] := a_state___3[1] + l_b
			a_state___3[2] := a_state___3[2] + l_c
			a_state___3[3] := a_state___3[3] + l_d
			memset (create {CE_POINTER [ANY]}.make_cast (l_x), 0, ({PLATFORM}.Natural_32_bytes.to_natural_32 * (16).to_natural_32)).do_nothing
		end

	MD5_Final (a_digest: CE_POINTER [NATURAL_8]; a_context: CE_POINTER [PD_MD5_CTX])
		local
			l_bits: CE_ARRAY [NATURAL_8]
			l_count: NATURAL_32
			l_padLen: NATURAL_32
		do
			create l_bits.make (<<8>>)

			Encode (l_bits, a_context.item.count, {NATURAL_32} 8)
			l_count := (((a_context.item.count[0]).bit_shift_right (3))).bit_and ({NATURAL_32} 63)
			if l_count < {NATURAL_32} 56 then
				l_padLen := {NATURAL_32} 56 - l_count
			else
				l_padLen := {NATURAL_32} 120 - l_count
			end
			MD5_Update (a_context, PADDING, l_padLen)
			MD5_Update (a_context, create {CE_POINTER [NATURAL_8]}.make_cast (l_bits), {NATURAL_32} 8)
			Encode (a_digest, a_context.item.state, {NATURAL_32} 16)
			memset (create {CE_POINTER [ANY]}.make_cast (a_context), 0, (create {PD_MD5_CTX}.make).structure_size.to_natural_32).do_nothing
		end

	MD5_Final_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent MD5_Final)
		end

	MD5_Init (a_context: CE_POINTER [PD_MD5_CTX])
		local
			l_tmp: NATURAL_32
		do
			l_tmp := (0).to_natural_32
			a_context.item.count[1] := l_tmp
			a_context.item.count[0] := l_tmp
			a_context.item.state[0] := (1_732_584_193).to_natural_32
			a_context.item.state[1] := {NATURAL_32} 4_023_233_417
			a_context.item.state[2] := {NATURAL_32} 2_562_383_102
			a_context.item.state[3] := (271_733_878).to_natural_32
		end

	MD5_Init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent MD5_Init)
		end

	MD5_Update (a_context: CE_POINTER [PD_MD5_CTX]; a_input: CE_POINTER [NATURAL_8]; a_inputLen: NATURAL_32)
		local
			l_i: NATURAL_32
			l_bufindex: NATURAL_32
			l_partLen: NATURAL_32
			l_tmp: NATURAL_32
		do
			l_bufindex := (((a_context.item.count[0]).bit_shift_right (3))).bit_and ({NATURAL_32} 63)
			l_tmp := a_context.item.count[0] + ((a_inputLen).bit_shift_left (3))
			a_context.item.count[0] := l_tmp
			if l_tmp < (a_inputLen).bit_shift_left (3) then
				a_context.item.count[1] := (a_context.item.count[1]) + 1
			end
			a_context.item.count[1] := a_context.item.count[1] + ((a_inputLen).bit_shift_right (29))
			l_partLen := {NATURAL_32} 64 - l_bufindex
			if a_inputLen >= l_partLen then
				memcpy (create {CE_POINTER [ANY]}.make_cast ((a_context.item.buffer + l_bufindex.to_integer_32)), create {CE_POINTER [ANY]}.make_cast (a_input), l_partLen).do_nothing
				MD5Transform (create {CE_POINTER [NATURAL_32]}.make_cast ((a_context.item.state)), create {CE_POINTER [NATURAL_8]}.make_cast ((a_context.item.buffer)))
				l_i := l_partLen
				from
				until
					not (l_i + {NATURAL_32} 63 < a_inputLen)
				loop
					MD5Transform (create {CE_POINTER [NATURAL_32]}.make_cast ((a_context.item.state)), (a_input + l_i.to_integer_32))
					l_i := l_i + ({NATURAL_32} 64)
				end
				l_bufindex := {NATURAL_32} 0
			else
				l_i := {NATURAL_32} 0
			end
			memcpy (create {CE_POINTER [ANY]}.make_cast ((a_context.item.buffer + l_bufindex.to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((a_input + l_i.to_integer_32)), a_inputLen - l_i).do_nothing
		end

	MD5_Update_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent MD5_Update)
		end

end
