class
	P_POP3

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_handler_pop3.make (<<1>>)
			create Curl_handler_pop3_proxy.make (<<1>>)
		end

feature {ANY} -- attributes

	Curl_handler_pop3: CE_ARRAY [PD_CURL_HANDLER]

	Curl_handler_pop3_proxy: CE_ARRAY [PD_CURL_HANDLER]

feature {ANY} -- routines

	Curl_pop3_write (a_conn: CE_POINTER [PD_CONNECTDATA]; a_str: CE_POINTER [INTEGER_8]; a_nread: NATURAL_32): NATURAL_32
		local
			l_nread: NATURAL_32
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_checkmax: NATURAL_32
			l_tmp: NATURAL_32
			l_checkleft: NATURAL_32
			l_check: NATURAL_32
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_k.make
			create l_pop3c.make

			l_nread := a_nread
			l_data := a_conn.item.data
			l_k := create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			if l_nread >= {NATURAL_32} 5 then
				l_tmp := (5).to_natural_32
			else
				l_tmp := l_nread
			end
			l_checkmax := l_tmp
			l_checkleft := {NATURAL_32} 5 - l_pop3c.item.eob
			if l_checkmax >= l_checkleft then
				l_tmp___0 := l_checkleft
			else
				l_tmp___0 := l_checkmax
			end
			l_check := l_tmp___0
			if (memcmp (create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N.%R%N")), create {CE_POINTER [ANY]}.make_cast ((a_str + (l_nread - l_check).to_integer_32)), l_check)).to_boolean then
				if (l_pop3c.item.eob).to_boolean then
					l_result := sendf_inst.Curl_client_write (a_conn, 1, ce_string ("%R%N.%R%N"), l_pop3c.item.eob)
					if l_result.to_boolean then
						Result := l_result
						js.return
					end
					if not js.return_called then
						l_pop3c.item.eob := (0).to_natural_32
					end
				end
			else
				l_pop3c.item.eob := l_pop3c.item.eob + l_check
				if l_pop3c.item.eob = {NATURAL_32} 5 then
					a_str[(l_nread - l_check).to_integer_32] := (('%/0/').code).to_integer_8
					l_nread := l_nread - l_check
					l_k.item.keepon := (l_k.item.keepon).bit_and ((-2))
					l_pop3c.item.eob := (0).to_natural_32
				end
			end
			if not js.return_called then
				l_result := sendf_inst.Curl_client_write (a_conn, 1, a_str, l_nread)
				Result := l_result
			end
		end

	pop3_connect (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_http_proxy: CE_ARRAY [PD_HTTP]
			l_pop3_save: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_pop3c.make
			create l_data.make
			create l_pp.make
			create l_http_proxy.make (<<1>>)
			create l_pop3_save.make

			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_data := a_conn.item.data
			l_pp := create {CE_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
			a_done.item := (0).to_boolean
			url_inst.Curl_reset_reqproto (a_conn)
			l_result := pop3_init (a_conn)
			if {NATURAL_32} 0 /= l_result then
				Result := l_result
				js.return
			end
			if not js.return_called then
				a_conn.item.bits.close := (0).to_boolean
				l_pp.item.response_time := 1_800_000
				l_pp.item.statemach_act := pop3_statemach_act_address
				l_pp.item.endofresp := pop3_endofresp_address
				l_pp.item.conn := a_conn
				if a_conn.item.bits.tunnel_proxy then
					if a_conn.item.bits.httpproxy then
						l_pop3_save := l_data.item.state.proto.pop3
						memset (create {CE_POINTER [ANY]}.make_cast (l_http_proxy), 0, (create {PD_HTTP}.make).structure_size.to_natural_32).do_nothing
						l_data.item.state.proto.http := l_http_proxy
						l_result := http_inst.Curl_proxyCONNECT (a_conn, 0, a_conn.item.host.name, a_conn.item.remote_port)
						l_data.item.state.proto.pop3 := l_pop3_save
						if {NATURAL_32} 0 /= l_result then
							Result := l_result
							js.return
						end
					end
				end
			end
			if not js.return_called and then (((a_conn.item.protocol).bit_and (((1).bit_shift_left (15)).to_integer_32)).to_boolean) then
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if l_result.to_boolean then
					Result := l_result
					js.return
				end
			end
			if not js.return_called then
				pingpong_inst.Curl_pp_init (l_pp)
				state___1 (a_conn, {PC_POP3STATE}.POP3_SERVERGREET)
				if l_data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := pop3_multi_statemach (a_conn, a_done)
				else
					l_result := pop3_easy_statemach (a_conn)
					if not l_result.to_boolean then
						a_done.item := (1).to_boolean
					end
				end
				Result := l_result
			end
		end

	pop3_connect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_connect)
		end

	pop3_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
		do
			create l_pop3c.make

			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			if (not (l_pop3c.item.pp.conn).is_void) then
				pop3_quit (a_conn).do_nothing
			end
			pingpong_inst.Curl_pp_disconnect (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))).do_nothing
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	pop3_disconnect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_disconnect)
		end

	pop3_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_retcode: NATURAL_32
			js: JUMP_STATE
		do
			l_retcode := {PC_CURLCODE}.CURLE_OK
			a_done.item := (0).to_boolean
			url_inst.Curl_reset_reqproto (a_conn)
			l_retcode := pop3_init (a_conn)
			if l_retcode.to_boolean then
				Result := l_retcode
				js.return
			end
			if not js.return_called then
				l_retcode := pop3_parse_url_path (a_conn)
				if l_retcode.to_boolean then
					Result := l_retcode
					js.return
				end
			end
			if not js.return_called then
				l_retcode := pop3_regular_transfer (a_conn, a_done)
				Result := l_retcode
			end
		end

	pop3_do_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_do)
		end

	pop3_doing (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
		do
			l_result := pop3_multi_statemach (a_conn, a_dophase_done)
			if a_dophase_done.item then
				l_result := pop3_dophase_done (a_conn, (0).to_boolean)
			end
			Result := l_result
		end

	pop3_doing_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_doing)
		end

	pop3_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_result: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_pop3.make

			l_data := a_conn.item.data
			l_pop3 := l_data.item.state.proto.pop3
			l_result := {PC_CURLCODE}.CURLE_OK
			if l_pop3.is_void then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				if a_status.to_boolean then
					a_conn.item.bits.close := (1).to_boolean
					l_result := a_status
				end
				l_pop3.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_BODY
				Result := l_result
			end
		end

	pop3_done_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_done)
		end

	pop3_dophase_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_connected: BOOLEAN): NATURAL_32
		local
			l_pop3: CE_POINTER [PD_FTP]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
		do
			create l_pop3.make
			create l_pop3c.make

			l_pop3 := (a_conn.item.data).item.state.proto.pop3
			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			if l_pop3.item.transfer /= {NATURAL_32} 0 then
				transfer_inst.Curl_setup_transfer (a_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
			end
			easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_pop3c.item.mailbox)])
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	pop3_easy_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_result: NATURAL_32
			js: JUMP_STATE
		do
			create l_pop3c.make
			create l_pp.make

			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_pp := create {CE_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
			l_result := {PC_CURLCODE}.CURLE_OK
			from
			until
				not (not js.loop_done and then (l_pop3c.item.state /= {NATURAL_32} 0))
			loop
				l_result := pingpong_inst.Curl_pp_easy_statemach (l_pp)
				if l_result.to_boolean then
					js.break
				end
			end
			Result := l_result
		end

	pop3_endofresp (a_pp: CE_POINTER [PD_PINGPONG]; a_resp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line := a_pp.item.linestart_resp
					l_len := a_pp.item.nread_resp
					if not (l_len >= {NATURAL_32} 3) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (ce_string ("+OK")), create {CE_POINTER [ANY]}.make_cast (l_line), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 3 -- goto _L
						else
							a_resp.item := (l_line[1]).to_integer_32
							Result := 1
							js.return
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_len >= {NATURAL_32} 4 then
							if not (memcmp (create {CE_POINTER [ANY]}.make_cast (ce_string ("-ERR")), create {CE_POINTER [ANY]}.make_cast (l_line), (4).to_natural_32)).to_boolean then
								a_resp.item := (l_line[1]).to_integer_32
								Result := 1
								js.return
							end
						end
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pop3_endofresp_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_endofresp)
		end

	pop3_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			Result := (pingpong_inst.Curl_pp_getsock (create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp")), a_socks, a_numsocks))
		end

	pop3_getsock_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_getsock)
		end

	pop3_init (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_data.make
			create l_pop3.make
			create l_tmp.make

			l_data := a_conn.item.data
			l_pop3 := l_data.item.state.proto.pop3
			if l_pop3.is_void then
				l_tmp := create {CE_POINTER [PD_FTP]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(create {PD_FTP}.make).structure_size.to_natural_32, (1).to_natural_32]))))
				l_data.item.state.proto.pop3 := l_tmp
				l_pop3 := l_tmp
				if l_pop3.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				l_pop3.item.bytecountp := create {CE_POINTER [INTEGER_64]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req") + (create {PD_SINGLEREQUEST}.make).offset_of ("bytecount"))
				l_pop3.item.user := a_conn.item.user
				l_pop3.item.passwd := a_conn.item.passwd
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	pop3_list (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			js: JUMP_STATE
		do
			create l_pop3c.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp")), ce_string ("LIST %%s"), l_pop3c.item.mailbox])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___1 (a_conn, {PC_POP3STATE}.POP3_LIST)
				Result := l_result
			end
		end

	pop3_multi_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_result: NATURAL_32
		do
			create l_pop3c.make

			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_result := (pingpong_inst.Curl_pp_multi_statemach (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))))
			a_done.item := (l_pop3c.item.state = {NATURAL_32} 0)
			Result := l_result
		end

	pop3_multi_statemach_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_multi_statemach)
		end

	pop3_parse_url_path (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_path: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_pop3c.make
			create l_data.make
			create l_path.make

			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_data := a_conn.item.data
			l_path := l_data.item.state.path
			l_pop3c.item.mailbox := escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (l_data), l_path, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			if (l_pop3c.item.mailbox).is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	pop3_perform (a_conn: CE_POINTER [PD_CONNECTDATA]; a_connected: CE_POINTER [BOOLEAN]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pop3: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_pop3c.make
			create l_pop3.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			if (a_conn.item.data).item.set.opt_no_body then
				l_pop3 := (a_conn.item.data).item.state.proto.pop3
				l_pop3.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_INFO
			end
			a_dophase_done.item := (0).to_boolean
			if (strlen (l_pop3c.item.mailbox)).to_boolean then
				l_result := pop3_retr (a_conn)
			else
				l_result := pop3_list (a_conn)
			end
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				if (a_conn.item.data).item.state.used_interface = {NATURAL_32} 2 then
					l_result := pop3_multi_statemach (a_conn, a_dophase_done)
				else
					l_result := pop3_easy_statemach (a_conn)
					a_dophase_done.item := (1).to_boolean
				end
				a_connected.item := a_conn.item.bits.tcpconnect
				if a_dophase_done.item then
				end
				Result := l_result
			end
		end

	pop3_quit (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			js: JUMP_STATE
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp")), ce_string ("QUIT"), create {CE_POINTER [ANY]}.make_shared (default_pointer)])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___1 (a_conn, {PC_POP3STATE}.POP3_QUIT)
				l_result := pop3_easy_statemach (a_conn)
				Result := l_result
			end
		end

	pop3_regular_transfer (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
			l_connected: CE_ARRAY [BOOLEAN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_connected.make (<<1>>)
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_connected.item := (0).to_boolean
			l_data := a_conn.item.data
			l_data.item.req.size := (-1).to_integer_64
			progress_inst.Curl_pgrsSetUploadCounter (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetDownloadCounter (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetUploadSize (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetDownloadSize (l_data, (0).to_integer_64)
			l_result := pop3_perform (a_conn, l_connected, a_dophase_done)
			if {NATURAL_32} 0 = l_result then
				if not a_dophase_done.item then
					Result := ({PC_CURLCODE}.CURLE_OK)
					js.return
				end
				if not js.return_called then
					l_result := pop3_dophase_done (a_conn, l_connected.item)
					if l_result.to_boolean then
						Result := l_result
						js.return
					end
				end
			end
			if not js.return_called then
				Result := l_result
			end
		end

	pop3_retr (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			js: JUMP_STATE
		do
			create l_pop3c.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp")), ce_string ("RETR %%s"), l_pop3c.item.mailbox])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___1 (a_conn, {PC_POP3STATE}.POP3_RETR)
				Result := l_result
			end
		end

	pop3_setup_connection (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_conn.item.data
			if a_conn.item.bits.httpproxy then
				if not l_data.item.set.tunnel_thru_httpproxy then
					if (a_conn.item.handler).is_equal (Curl_handler_pop3) then
						a_conn.item.handler := Curl_handler_pop3_proxy
					else
						sendf_inst.Curl_failf ([l_data, ce_string ("POP3S not supported!")])
						Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
						js.return
					end
					if not js.return_called then
						a_conn.item.bits.close := (0).to_boolean
					end
				end
			end
			if not js.return_called then
				l_data.item.state.path := (l_data.item.state.path) + 1
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	pop3_setup_connection_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_setup_connection)
		end

	pop3_state_list_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			js: JUMP_STATE
		do
			create l_data.make
			create l_pop3.make
			create l_pop3c.make
			create l_pp.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			l_pop3 := l_data.item.state.proto.pop3
			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_pp := create {CE_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
			if 79 /= a_pop3code then
				state___1 (a_conn, {PC_POP3STATE}.POP3_STOP)
				Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
				js.return
			end
			if not js.return_called then
				transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (0).to_boolean, l_pop3.item.bytecountp, -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
				if (not (l_pp.item.cache).is_void) then
					l_result := Curl_pop3_write (a_conn, l_pp.item.cache, l_pp.item.cache_size)
					if l_result.to_boolean then
						Result := l_result
						js.return
					end
					if not js.return_called then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_pp.item.cache)])
						l_pp.item.cache := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_pp.item.cache_size := (0).to_natural_32
					end
				end
			end
			if not js.return_called then
				state___1 (a_conn, {PC_POP3STATE}.POP3_STOP)
				Result := l_result
			end
		end

	pop3_state_pass_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_pop3code /= 79 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied. %%c"), a_pop3code])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			end
			state___1 (a_conn, {PC_POP3STATE}.POP3_STOP)
			Result := l_result
		end

	pop3_state_retr_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			js: JUMP_STATE
		do
			create l_data.make
			create l_pop3.make
			create l_pop3c.make
			create l_pp.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			l_pop3 := l_data.item.state.proto.pop3
			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_pp := create {CE_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
			if 79 /= a_pop3code then
				state___1 (a_conn, {PC_POP3STATE}.POP3_STOP)
				Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
				js.return
			end
			if not js.return_called then
				transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (0).to_boolean, l_pop3.item.bytecountp, -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
				if (not (l_pp.item.cache).is_void) then
					l_result := Curl_pop3_write (a_conn, l_pp.item.cache, l_pp.item.cache_size)
					if l_result.to_boolean then
						Result := l_result
						js.return
					end
					if not js.return_called then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_pp.item.cache)])
						l_pp.item.cache := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_pp.item.cache_size := (0).to_natural_32
					end
				end
			end
			if not js.return_called then
				state___1 (a_conn, {PC_POP3STATE}.POP3_STOP)
				Result := l_result
			end
		end

	pop3_state_starttls_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_pop3code /= 79 then
				sendf_inst.Curl_failf ([l_data, ce_string ("STARTTLS denied. %%c"), a_pop3code])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if {NATURAL_32} 0 = l_result then
					a_conn.item.protocol := (a_conn.item.protocol).bit_or (((1).bit_shift_left (15)).to_integer_32)
					l_result := pop3_state_user (a_conn)
				end
			end
			state___1 (a_conn, {PC_POP3STATE}.POP3_STOP)
			Result := l_result
		end

	pop3_state_user (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_pop3: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_pop3.make
			create l_tmp.make

			l_pop3 := (a_conn.item.data).item.state.proto.pop3
			if (not (l_pop3.item.user).is_void) then
				l_tmp := l_pop3.item.user
			else
				l_tmp := ce_string ("")
			end
			l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp")), ce_string ("USER %%s"), l_tmp])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___1 (a_conn, {PC_POP3STATE}.POP3_USER)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	pop3_state_user_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_data.make
			create l_pop3.make
			create l_tmp.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			l_pop3 := l_data.item.state.proto.pop3
			if a_pop3code /= 79 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied. %%c"), a_pop3code])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				if (not (l_pop3.item.passwd).is_void) then
					l_tmp := l_pop3.item.passwd
				else
					l_tmp := ce_string ("")
				end
				l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp")), ce_string ("PASS %%s"), l_tmp])
			end
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___1 (a_conn, {PC_POP3STATE}.POP3_PASS)
				Result := l_result
			end
		end

	pop3_statemach_act (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_sock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3code: CE_ARRAY [INTEGER_32]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_nread: CE_ARRAY [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_pop3code.make (<<1>>)
			create l_pop3c.make
			create l_pp.make
			create l_nread.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := a_conn.item.sock[0]
					l_data := a_conn.item.data
					l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
					l_pp := create {CE_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
					l_nread.item := (0).to_natural_32
					if (l_pp.item.sendleft).to_boolean then
						Result := (pingpong_inst.Curl_pp_flushsend (l_pp))
						js.return
					end
					if not js.return_called then
						l_result := pingpong_inst.Curl_pp_readresp (l_sock, l_pp, l_pop3code, l_nread)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
					end
					if not (not js.return_called and then ((l_pop3code.item).to_boolean)) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						inspect (l_pop3c.item.state).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 4 then l_pos := -1 + 5
						when 6 then l_pos := -1 + 6
						when 5 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 2 then -- switch 1, case 1
						if l_pop3code.item /= 79 then
							sendf_inst.Curl_failf ([l_data, ce_string ("Got unexpected pop3-server response")])
							Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_SERVER_REPLY)
							js.return
						end
						if not js.return_called then
							if (l_data.item.set.ftp_ssl).to_boolean then
								if not a_conn.item.ssl[0].use then
									l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp")), ce_string ("STARTTLS"), create {CE_POINTER [ANY]}.make_shared (default_pointer)])
									state___1 (a_conn, {PC_POP3STATE}.POP3_STARTTLS)
								else
									l_result := pop3_state_user (a_conn)
								end
							else
								l_result := pop3_state_user (a_conn)
							end
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
						l_pos := -1 + 9 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_result := pop3_state_user_resp (a_conn, l_pop3code.item, l_pop3c.item.state)
						l_pos := -1 + 9 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_result := pop3_state_pass_resp (a_conn, l_pop3code.item, l_pop3c.item.state)
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 4
						l_result := pop3_state_starttls_resp (a_conn, l_pop3code.item, l_pop3c.item.state)
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 6
						l_result := pop3_state_retr_resp (a_conn, l_pop3code.item, l_pop3c.item.state)
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 5
						l_result := pop3_state_list_resp (a_conn, l_pop3code.item, l_pop3c.item.state)
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						state___1 (a_conn, {PC_POP3STATE}.POP3_STOP)
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
						if not js.return_called then
							Result := l_result
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	pop3_statemach_act_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pop3_statemach_act)
		end

	state___1 (a_conn: CE_POINTER [PD_CONNECTDATA]; a_newstate: NATURAL_32)
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
		do
			create l_pop3c.make

			l_pop3c := create {CE_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_pop3c.item.state := a_newstate
		end

end
