class
	P_SELECT

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_poll (a_ufds: CE_POINTER [SD_POLLFD]; a_nfds: NATURAL_32; a_timeout_ms: INTEGER_32): INTEGER_32
		local
			l_initial_tv: SD_TIMEVAL
			l_fds_none: BOOLEAN
			l_i: NATURAL_32
			l_pending_ms: INTEGER_32
			l_error: INTEGER_32
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_initial_tv.make

			l_initial_tv.tv_sec := (0).to_integer_32
			l_initial_tv.tv_usec := (0).to_integer_32
			l_fds_none := (1).to_boolean
			l_pending_ms := 0
			if (not a_ufds.is_void) then
				l_i := {NATURAL_32} 0
				from
				until
					not (not js.loop_done and then (l_i < a_nfds))
				loop
					if (a_ufds + l_i.to_integer_32).item.fd /= -1 then
						l_fds_none := (0).to_boolean
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			if l_fds_none then
				l_r := wait_ms (a_timeout_ms)
				Result := l_r
				js.return
			end
			if not js.return_called then
				if a_timeout_ms > 0 then
					l_pending_ms := a_timeout_ms
					l_initial_tv := (timeval_inst.curlx_tvnow).twin
				end
				from
				until
					js.loop_done
				loop
					if a_timeout_ms < 0 then
						l_pending_ms := -1
					elseif not a_timeout_ms.to_boolean then
						l_pending_ms := 0
					end
					l_r := poll (a_ufds, a_nfds.to_natural_32, l_pending_ms)
					if l_r /= -1 then
						js.break
					end
					if not js.loop_jumped then
						l_error := (errno_location).item
						if l_error.to_boolean then
							if l_error /= 4 then
								js.break
							end
						end
					end
					if not js.loop_jumped and then (a_timeout_ms > 0) then
						l_pending_ms := a_timeout_ms - (timeval_inst.curlx_tvdiff ((timeval_inst.curlx_tvnow).twin, l_initial_tv.twin)).to_integer_32
						if l_pending_ms <= 0 then
							js.break
						end
					end
					if not js.loop_jumped and then (l_r /= -1) then
						js.break
					end
				end
				if l_r < 0 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called and then (l_r = 0) then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i := {NATURAL_32} 0
				from
				until
					not (l_i < a_nfds)
				loop
					if (a_ufds + l_i.to_integer_32).item.fd = -1 then
						js.continue
					end
					if not js.loop_jumped then
						if ((((a_ufds + l_i.to_integer_32).item.revents).to_integer_32).bit_and (16)).to_boolean then
							(a_ufds + l_i.to_integer_32).item.revents := ((((a_ufds + l_i.to_integer_32).item.revents).to_integer_32).bit_or (1)).to_integer_16
						end
						if ((((a_ufds + l_i.to_integer_32).item.revents).to_integer_32).bit_and (8)).to_boolean then
							(a_ufds + l_i.to_integer_32).item.revents := ((((a_ufds + l_i.to_integer_32).item.revents).to_integer_32).bit_or (5)).to_integer_16
						end
					end
					l_i := l_i + 1
				end
				Result := l_r
			end
		end

	Curl_socket_ready (a_readfd: INTEGER_32; a_writefd: INTEGER_32; a_timeout_ms: INTEGER_32): INTEGER_32
		local
			l_pfd: CE_ARRAY [SD_POLLFD]
			l_num: INTEGER_32
			l_initial_tv: SD_TIMEVAL
			l_pending_ms: INTEGER_32
			l_error: INTEGER_32
			l_r: INTEGER_32
			l_ret: INTEGER_32
			js: JUMP_STATE
		do
			create l_pfd.make (<<2>>)
			create l_initial_tv.make

			l_initial_tv.tv_sec := (0).to_integer_32
			l_initial_tv.tv_usec := (0).to_integer_32
			l_pending_ms := 0
			if a_readfd = -1 then
				if a_writefd = -1 then
					l_r := wait_ms (a_timeout_ms)
					Result := l_r
					js.return
				end
			end
			if not js.return_called then
				if a_timeout_ms > 0 then
					l_pending_ms := a_timeout_ms
					l_initial_tv := (timeval_inst.curlx_tvnow).twin
				end
				l_num := 0
				if a_readfd /= -1 then
					l_pfd[l_num].fd := a_readfd
					l_pfd[l_num].events := (195).to_integer_16
					l_pfd[l_num].revents := (0).to_integer_16
					l_num := l_num + 1
				end
				if a_writefd /= -1 then
					l_pfd[l_num].fd := a_writefd
					l_pfd[l_num].events := (260).to_integer_16
					l_pfd[l_num].revents := (0).to_integer_16
					l_num := l_num + 1
				end
				from
				until
					js.loop_done
				loop
					if a_timeout_ms < 0 then
						l_pending_ms := -1
					elseif not a_timeout_ms.to_boolean then
						l_pending_ms := 0
					end
					l_r := poll (l_pfd, l_num.to_natural_32, l_pending_ms)
					if l_r /= -1 then
						js.break
					end
					if not js.loop_jumped then
						l_error := (errno_location).item
						if l_error.to_boolean then
							if l_error /= 4 then
								js.break
							end
						end
					end
					if not js.loop_jumped and then (a_timeout_ms > 0) then
						l_pending_ms := a_timeout_ms - (timeval_inst.curlx_tvdiff ((timeval_inst.curlx_tvnow).twin, l_initial_tv.twin)).to_integer_32
						if l_pending_ms <= 0 then
							js.break
						end
					end
					if not js.loop_jumped and then (l_r /= -1) then
						js.break
					end
				end
				if l_r < 0 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called and then (l_r = 0) then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_ret := 0
				l_num := 0
				if a_readfd /= -1 then
					if (((l_pfd[l_num].revents).to_integer_32).bit_and (89)).to_boolean then
						l_ret := (l_ret).bit_or ((1))
					end
					if (((l_pfd[l_num].revents).to_integer_32).bit_and (162)).to_boolean then
						l_ret := (l_ret).bit_or ((4))
					end
					l_num := l_num + 1
				end
				if a_writefd /= -1 then
					if (((l_pfd[l_num].revents).to_integer_32).bit_and (260)).to_boolean then
						l_ret := (l_ret).bit_or ((2))
					end
					if (((l_pfd[l_num].revents).to_integer_32).bit_and (56)).to_boolean then
						l_ret := (l_ret).bit_or ((4))
					end
				end
				Result := l_ret
			end
		end

	wait_ms (a_timeout_ms: INTEGER_32): INTEGER_32
		local
			l_initial_tv: SD_TIMEVAL
			l_pending_ms: INTEGER_32
			l_error: INTEGER_32
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_initial_tv.make

			l_r := 0
			if not a_timeout_ms.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_timeout_ms < 0) then
				(errno_location).item := 22
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_pending_ms := a_timeout_ms
				l_initial_tv := (timeval_inst.curlx_tvnow).twin
				from
				until
					js.loop_done
				loop
					l_r := poll (create {CE_POINTER [SD_POLLFD]}.make_shared (default_pointer), (0).to_natural_32, l_pending_ms)
					if l_r /= -1 then
						js.break
					end
					if not js.loop_jumped then
						l_error := (errno_location).item
						if l_error.to_boolean then
							if l_error /= 4 then
								js.break
							end
						end
					end
					if not js.loop_jumped then
						l_pending_ms := a_timeout_ms - (timeval_inst.curlx_tvdiff ((timeval_inst.curlx_tvnow).twin, l_initial_tv.twin)).to_integer_32
						if l_pending_ms <= 0 then
							js.break
						end
					end
					if not js.loop_jumped and then (l_r /= -1) then
						js.break
					end
				end
				if l_r.to_boolean then
					l_r := -1
				end
				Result := l_r
			end
		end

end
