class
	P_SMTP

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_handler_smtp.make (<<1>>)
			create Curl_handler_smtp_proxy.make (<<1>>)
		end

feature {ANY} -- attributes

	Curl_handler_smtp: CE_ARRAY [PD_CURL_HANDLER]

	Curl_handler_smtp_proxy: CE_ARRAY [PD_CURL_HANDLER]

feature {ANY} -- routines

	Curl_smtp_escape_eob (a_conn: CE_POINTER [PD_CONNECTDATA]; a_nread: INTEGER_32): NATURAL_32
		local
			l_nread: INTEGER_32
			l_i: INTEGER_32
			l_si: INTEGER_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_left: INTEGER_32
			js: JUMP_STATE
		do
			create l_smtpc.make
			create l_data.make

			l_nread := a_nread
			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_data := a_conn.item.data
			if (l_data.item.state.scratch).is_void then
				l_data.item.state.scratch := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(32_768).to_natural_32]))))
			end
			if (l_data.item.state.scratch).is_void then
				sendf_inst.Curl_failf ([l_data, ce_string ("Failed to alloc scratch buffer!")])
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				l_i := 0
				l_si := 0
				from
				until
					not (not js.loop_done and then (l_i < l_nread))
				loop
					l_left := l_nread - l_i
					if l_left >= ({NATURAL_32} 5 - l_smtpc.item.eob).to_integer_32 then
						if not (memcmp (create {CE_POINTER [ANY]}.make_cast ((ce_string ("%R%N.%R%N") + (l_smtpc.item.eob).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((l_data.item.req.upload_fromhere + l_i)), {NATURAL_32} 5 - l_smtpc.item.eob)).to_boolean then
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_data.item.state.scratch + l_si)), create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N..")), (4).to_natural_32).do_nothing
							l_si := l_si + (3)
							l_i := (l_i.to_natural_32 + ((({NATURAL_32} 5 - l_smtpc.item.eob) - {NATURAL_32} 1) - {NATURAL_32} 2)).to_integer_32
							l_smtpc.item.eob := (0).to_natural_32
							js.continue
						end
					elseif not (memcmp (create {CE_POINTER [ANY]}.make_cast ((ce_string ("%R%N.%R%N") + (l_smtpc.item.eob).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((l_data.item.req.upload_fromhere + l_i)), l_left.to_natural_32)).to_boolean then
						l_smtpc.item.eob := l_smtpc.item.eob + l_left.to_natural_32
						js.break
					end
					if not js.loop_jumped then
						l_data.item.state.scratch[l_si] := l_data.item.req.upload_fromhere[l_i]
					end
					if js.loop_increment then
						l_i := l_i + 1
						l_si := l_si + 1
					end
				end
				if l_si /= l_nread then
					l_nread := l_si
					l_data.item.req.upload_fromhere := l_data.item.state.scratch
					l_data.item.req.upload_present := l_nread
				end
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_auth_login_user (a_conn: CE_POINTER [PD_CONNECTDATA]; a_outptr: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_ulen: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_ulen := strlen (a_conn.item.user)
			if not l_ulen.to_boolean then
				a_outptr.item := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([ce_string ("=")]))
				if (not (a_outptr.item).is_void) then
					l_tmp := 1
				else
					l_tmp := 0
				end
				Result := l_tmp.to_natural_32
				js.return
			end
			if not js.return_called then
				Result := (base64_inst.Curl_base64_encode (a_conn.item.data, a_conn.item.user, l_ulen, a_outptr))
			end
		end

	smtp_auth_plain_data (a_conn: CE_POINTER [PD_CONNECTDATA]; a_outptr: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_plainauth: CE_ARRAY [INTEGER_8]
			l_ulen: NATURAL_32
			l_plen: NATURAL_32
			js: JUMP_STATE
		do
			create l_plainauth.make (<<768>>)

			l_ulen := strlen (a_conn.item.user)
			l_plen := strlen (a_conn.item.passwd)
			if ({NATURAL_32} 2 * l_ulen + l_plen) + {NATURAL_32} 2 > ({PLATFORM}.Integer_8_bytes.to_natural_32 * (768).to_natural_32) then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_plainauth), create {CE_POINTER [ANY]}.make_cast (a_conn.item.user), l_ulen).do_nothing
				l_plainauth[l_ulen.to_integer_32] := (('%/0/').code).to_integer_8
				memcpy (create {CE_POINTER [ANY]}.make_cast (((l_plainauth + l_ulen.to_integer_32) + 1)), create {CE_POINTER [ANY]}.make_cast (a_conn.item.user), l_ulen).do_nothing
				l_plainauth[({NATURAL_32} 2 * l_ulen + {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_integer_8
				memcpy (create {CE_POINTER [ANY]}.make_cast (((l_plainauth + ({NATURAL_32} 2 * l_ulen).to_integer_32) + 2)), create {CE_POINTER [ANY]}.make_cast (a_conn.item.passwd), l_plen).do_nothing
				Result := (base64_inst.Curl_base64_encode (a_conn.item.data, l_plainauth, ({NATURAL_32} 2 * l_ulen + l_plen) + {NATURAL_32} 2, a_outptr))
			end
		end

	smtp_authenticate (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_initresp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_mech: CE_POINTER [INTEGER_8]
			l_l: NATURAL_32
			l_state1: NATURAL_32
			l_state2: NATURAL_32
			l_pos: INTEGER_32
		do
			create l_smtpc.make
			create l_initresp.make (<<1>>)
			create l_mech.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
					if a_conn.item.bits.user_passwd then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						l_initresp.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_l := (1).to_natural_32
						l_mech := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_state1 := {PC_SMTPSTATE}.SMTP_STOP
						l_state2 := {PC_SMTPSTATE}.SMTP_STOP
						if ((l_smtpc.item.authmechs).bit_and ({NATURAL_32} 4)).to_boolean then
							l_mech := ce_string ("CRAM-MD5")
							l_state1 := {PC_SMTPSTATE}.SMTP_AUTHCRAM
						elseif ((l_smtpc.item.authmechs).bit_and ({NATURAL_32} 2)).to_boolean then
							l_mech := ce_string ("PLAIN")
							l_state1 := {PC_SMTPSTATE}.SMTP_AUTHPLAIN
							l_state2 := {PC_SMTPSTATE}.SMTP_AUTH
							l_l := smtp_auth_plain_data (a_conn, l_initresp)
						elseif ((l_smtpc.item.authmechs).bit_and ({NATURAL_32} 1)).to_boolean then
							l_mech := ce_string ("LOGIN")
							l_state1 := {PC_SMTPSTATE}.SMTP_AUTHLOGIN
							l_state2 := {PC_SMTPSTATE}.SMTP_AUTHPASSWD
							l_l := smtp_auth_login_user (a_conn, l_initresp)
						else
							sendf_inst.Curl_infof ([a_conn.item.data, ce_string ("No known auth mechanisms supported!%N")])
							l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
						end
						if l_result.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if l_l.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (l_initresp.item).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_l + (strlen (l_mech)) <= {NATURAL_32} 504 then
							l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("AUTH %%s %%s"), l_mech, l_initresp.item])
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_initresp.item)])
							if not l_result.to_boolean then
								state___2 (a_conn, l_state2)
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_initresp.item))
						l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("AUTH %%s"), l_mech])
						if not l_result.to_boolean then
							state___2 (a_conn, l_state1)
						end
				when 11 then -- if done | if done | if done
						Result := l_result
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	smtp_connect (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_path: CE_POINTER [INTEGER_8]
			l_len: CE_ARRAY [INTEGER_32]
			l_localhost: CE_ARRAY [INTEGER_8]
			l_http_proxy: CE_ARRAY [PD_HTTP]
			l_smtp_save: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_smtpc.make
			create l_data.make
			create l_pp.make
			create l_path.make
			create l_len.make (<<1>>)
			create l_localhost.make (<<1_025>>)
			create l_http_proxy.make (<<1>>)
			create l_smtp_save.make

			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_data := a_conn.item.data
			l_pp := create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))
			l_path := (a_conn.item.data).item.state.path
			a_done.item := (0).to_boolean
			url_inst.Curl_reset_reqproto (a_conn)
			l_result := smtp_init (a_conn)
			if {NATURAL_32} 0 /= l_result then
				Result := l_result
				js.return
			end
			if not js.return_called then
				a_conn.item.bits.close := (0).to_boolean
				l_pp.item.response_time := 1_800_000
				l_pp.item.statemach_act := smtp_statemach_act_address
				l_pp.item.endofresp := smtp_endofresp_address
				l_pp.item.conn := a_conn
				if a_conn.item.bits.tunnel_proxy then
					if a_conn.item.bits.httpproxy then
						l_smtp_save := l_data.item.state.proto.smtp
						memset (create {CE_POINTER [ANY]}.make_cast (l_http_proxy), 0, (create {PD_HTTP}.make).structure_size.to_natural_32).do_nothing
						l_data.item.state.proto.http := l_http_proxy
						l_result := http_inst.Curl_proxyCONNECT (a_conn, 0, a_conn.item.host.name, a_conn.item.remote_port)
						l_data.item.state.proto.smtp := l_smtp_save
						if {NATURAL_32} 0 /= l_result then
							Result := l_result
							js.return
						end
					end
				end
			end
			if not js.return_called and then (((a_conn.item.protocol).bit_and (((1).bit_shift_left (17)).to_integer_32)).to_boolean) then
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if l_result.to_boolean then
					Result := l_result
					js.return
				end
			end
			if not js.return_called then
				pingpong_inst.Curl_pp_init (l_pp)
				l_pp.item.response_time := 1_800_000
				l_pp.item.statemach_act := smtp_statemach_act_address
				l_pp.item.endofresp := smtp_endofresp_address
				l_pp.item.conn := a_conn
				if not (l_path[0]).to_boolean then
					if (curl_gethostname_inst.Curl_gethostname (l_localhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_025).to_natural_32))).to_boolean then
						l_path := ce_string ("localhost")
					else
						l_path := l_localhost
					end
				end
				l_smtpc.item.domain := escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (a_conn.item.data), l_path, 0, l_len)
				if (l_smtpc.item.domain).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_SERVERGREET)
				if l_data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := smtp_multi_statemach (a_conn, a_done)
				else
					l_result := smtp_easy_statemach (a_conn)
					if not l_result.to_boolean then
						a_done.item := (1).to_boolean
					end
				end
				Result := l_result
			end
		end

	smtp_connect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_connect)
		end

	smtp_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			create l_smtpc.make

			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			if (not (l_smtpc.item.pp.conn).is_void) then
				smtp_quit (a_conn).do_nothing
			end
			pingpong_inst.Curl_pp_disconnect (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).do_nothing
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_smtpc.item.domain))
			l_smtpc.item.domain := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	smtp_disconnect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_disconnect)
		end

	smtp_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_retcode: NATURAL_32
			js: JUMP_STATE
		do
			l_retcode := {PC_CURLCODE}.CURLE_OK
			a_done.item := (0).to_boolean
			url_inst.Curl_reset_reqproto (a_conn)
			l_retcode := smtp_init (a_conn)
			if l_retcode.to_boolean then
				Result := l_retcode
				js.return
			end
			if not js.return_called then
				l_retcode := smtp_regular_transfer (a_conn, a_done)
				Result := l_retcode
			end
		end

	smtp_do_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_do)
		end

	smtp_doing (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
		do
			l_result := smtp_multi_statemach (a_conn, a_dophase_done)
			if a_dophase_done.item then
				l_result := smtp_dophase_done (a_conn, (0).to_boolean)
			end
			Result := l_result
		end

	smtp_doing_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_doing)
		end

	smtp_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtp: CE_POINTER [PD_FTP]
			l_result: NATURAL_32
			l_bytes_written: CE_ARRAY [INTEGER_32]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			js: JUMP_STATE
		do
			create l_data.make
			create l_smtp.make
			create l_bytes_written.make (<<1>>)
			create l_smtpc.make
			create l_pp.make

			l_data := a_conn.item.data
			l_smtp := l_data.item.state.proto.smtp
			l_result := {PC_CURLCODE}.CURLE_OK
			if l_smtp.is_void then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				if a_status.to_boolean then
					a_conn.item.bits.close := (1).to_boolean
					l_result := a_status
				else
					l_result := sendf_inst.Curl_write (a_conn, a_conn.item.writesockfd, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N.%R%N")), (5).to_natural_32, l_bytes_written)
				end
				if a_status = {NATURAL_32} 0 then
					l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
					l_pp := create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))
					l_pp.item.response := (timeval_inst.curlx_tvnow).twin
					state___2 (a_conn, {PC_SMTPSTATE}.SMTP_POSTDATA)
					l_result := smtp_easy_statemach (a_conn)
				end
				l_smtp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_BODY
				Result := l_result
			end
		end

	smtp_done_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_done)
		end

	smtp_dophase_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_connected: BOOLEAN): NATURAL_32
		local
			l_smtp: CE_POINTER [PD_FTP]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			create l_smtp.make
			create l_smtpc.make

			l_smtp := (a_conn.item.data).item.state.proto.smtp
			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			if l_smtp.item.transfer /= {NATURAL_32} 0 then
				transfer_inst.Curl_setup_transfer (a_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
			end
			easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_smtpc.item.domain)])
			l_smtpc.item.domain := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	smtp_easy_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_result: NATURAL_32
			js: JUMP_STATE
		do
			create l_smtpc.make
			create l_pp.make

			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_pp := create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))
			l_result := {PC_CURLCODE}.CURLE_OK
			from
			until
				not (not js.loop_done and then (l_smtpc.item.state /= {NATURAL_32} 0))
			loop
				l_result := pingpong_inst.Curl_pp_easy_statemach (l_pp)
				if l_result.to_boolean then
					js.break
				end
			end
			Result := l_result
		end

	smtp_endofresp (a_pp: CE_POINTER [PD_PINGPONG]; a_resp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_result: INTEGER_32
			l_wordlen: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_conn.make
			create l_smtpc.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line := a_pp.item.linestart_resp
					l_len := a_pp.item.nread_resp
					l_conn := a_pp.item.conn
					l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (l_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
					if l_len < {NATURAL_32} 4 then
						Result := 0
						js.return
					elseif ((((ctype_b_loc).item[((l_line[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
						if ((((ctype_b_loc).item[((l_line[1]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							if not ((((ctype_b_loc).item[((l_line[2]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
								Result := 0
								js.return
							end
						else
							Result := 0
							js.return
						end
					else
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 26 -- skip if block
					end
				when 1 then -- if:
						l_result := ((l_line[3]).to_integer_32 = 32).to_integer
						if l_result.to_boolean then
							a_resp.item := atoi (l_line)
						end
						l_line := l_line + (4)
						l_len := l_len - ({NATURAL_32} 4)
						if l_smtpc.item.state /= {NATURAL_32} 2 then
							l_pos := -1 + 25 -- skip if block
						end
				when 2 then -- if:
						if not (l_len >= {NATURAL_32} 5) then
							l_pos := -1 + 25 -- skip if block
						end
				when 3 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_line), create {CE_POINTER [ANY]}.make_cast (ce_string ("AUTH ")), (5).to_natural_32)).to_boolean then
							l_pos := -1 + 25 -- skip if block
						end
				when 4 then -- if:
						l_line := l_line + (5)
						l_len := l_len - ({NATURAL_32} 5)
				when 5 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 25 -- skip loop
						end
				when 6 then -- loop body:
						from
						until
							js.loop_done
						loop
							if l_len.to_boolean then
								if (l_line[0]).to_integer_32 /= 32 then
									if (l_line[0]).to_integer_32 /= 9 then
										if (l_line[0]).to_integer_32 /= 13 then
											if (l_line[0]).to_integer_32 /= 10 then
												js.break
											end
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_line := l_line + 1
								l_len := l_len - 1
							end
						end
						if not l_len.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 24 -- skip if block
						end
				when 7 then -- if:
						l_wordlen := (0).to_natural_32
						from
						until
							js.loop_done
						loop
							if l_wordlen < l_len then
								if (l_line[l_wordlen.to_integer_32]).to_integer_32 /= 32 then
									if (l_line[l_wordlen.to_integer_32]).to_integer_32 /= 9 then
										if (l_line[l_wordlen.to_integer_32]).to_integer_32 /= 13 then
											if (l_line[l_wordlen.to_integer_32]).to_integer_32 = 10 then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_wordlen := l_wordlen + 1
							end
						end
						if l_wordlen /= {NATURAL_32} 5 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_line), create {CE_POINTER [ANY]}.make_cast (ce_string ("LOGIN")), (5).to_natural_32)).to_boolean then
							l_pos := -1 + 10 -- goto _L___3
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 1))
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 10 then -- else: | _L___3:
						if l_wordlen /= {NATURAL_32} 5 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_line), create {CE_POINTER [ANY]}.make_cast (ce_string ("PLAIN")), (5).to_natural_32)).to_boolean then
							l_pos := -1 + 13 -- goto _L___2
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 2))
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 13 then -- else: | _L___2:
						if l_wordlen /= {NATURAL_32} 8 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_line), create {CE_POINTER [ANY]}.make_cast (ce_string ("CRAM-MD5")), (8).to_natural_32)).to_boolean then
							l_pos := -1 + 16 -- goto _L___1
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 4))
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 16 then -- else: | _L___1:
						if l_wordlen /= {NATURAL_32} 10 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_line), create {CE_POINTER [ANY]}.make_cast (ce_string ("DIGEST-MD5")), (10).to_natural_32)).to_boolean then
							l_pos := -1 + 19 -- goto _L___0
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 8))
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else: | _L___0:
						if l_wordlen /= {NATURAL_32} 6 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_line), create {CE_POINTER [ANY]}.make_cast (ce_string ("GSSAPI")), (6).to_natural_32)).to_boolean then
							l_pos := -1 + 22 -- goto _L
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 16))
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L:
						if l_wordlen = {NATURAL_32} 8 then
							if not (memcmp (create {CE_POINTER [ANY]}.make_cast (l_line), create {CE_POINTER [ANY]}.make_cast (ce_string ("EXTERNAL")), (8).to_natural_32)).to_boolean then
								l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 32))
							end
						end
				when 23 then -- if done | if done | if done | if done
						l_line := l_line + l_wordlen.to_integer_32
						l_len := l_len - l_wordlen
				when 24 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 25 then -- loop done | if done | if done | if done
						Result := l_result
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	smtp_endofresp_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_endofresp)
		end

	smtp_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			Result := (pingpong_inst.Curl_pp_getsock (create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), a_socks, a_numsocks))
		end

	smtp_getsock_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_getsock)
		end

	smtp_init (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtp: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_data.make
			create l_smtp.make
			create l_tmp.make

			l_data := a_conn.item.data
			l_smtp := l_data.item.state.proto.smtp
			if l_smtp.is_void then
				l_tmp := create {CE_POINTER [PD_FTP]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(create {PD_FTP}.make).structure_size.to_natural_32, (1).to_natural_32]))))
				l_data.item.state.proto.smtp := l_tmp
				l_smtp := l_tmp
				if l_smtp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				l_smtp.item.bytecountp := create {CE_POINTER [INTEGER_64]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req") + (create {PD_SINGLEREQUEST}.make).offset_of ("bytecount"))
				l_smtp.item.user := a_conn.item.user
				l_smtp.item.passwd := a_conn.item.passwd
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_mail (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("MAIL FROM:%%s"), l_data.item.set.str[36]])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_MAIL)
				Result := l_result
			end
		end

	smtp_multi_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_result: NATURAL_32
		do
			create l_smtpc.make

			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_result := (pingpong_inst.Curl_pp_multi_statemach (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))))
			a_done.item := (l_smtpc.item.state = {NATURAL_32} 0)
			Result := l_result
		end

	smtp_multi_statemach_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_multi_statemach)
		end

	smtp_perform (a_conn: CE_POINTER [PD_CONNECTDATA]; a_connected: CE_POINTER [BOOLEAN]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
			l_smtp: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_smtp.make

			l_result := {PC_CURLCODE}.CURLE_OK
			if (a_conn.item.data).item.set.opt_no_body then
				l_smtp := (a_conn.item.data).item.state.proto.smtp
				l_smtp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_INFO
			end
			a_dophase_done.item := (0).to_boolean
			l_result := smtp_mail (a_conn)
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				if (a_conn.item.data).item.state.used_interface = {NATURAL_32} 2 then
					l_result := smtp_multi_statemach (a_conn, a_dophase_done)
				else
					l_result := smtp_easy_statemach (a_conn)
					a_dophase_done.item := (1).to_boolean
				end
				a_connected.item := a_conn.item.bits.tcpconnect
				if a_dophase_done.item then
				end
				Result := l_result
			end
		end

	smtp_quit (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			js: JUMP_STATE
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("QUIT")])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_QUIT)
				l_result := smtp_easy_statemach (a_conn)
				Result := l_result
			end
		end

	smtp_rcpt_to (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			create l_smtpc.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			if (not (l_smtpc.item.rcpt).is_void) then
				if ((l_smtpc.item.rcpt).item.data[0]).to_integer_32 = 60 then
					l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("RCPT TO:%%s"), (l_smtpc.item.rcpt).item.data])
				else
					l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("RCPT TO:<%%s>"), (l_smtpc.item.rcpt).item.data])
				end
				if not l_result.to_boolean then
					state___2 (a_conn, {PC_SMTPSTATE}.SMTP_RCPT)
				end
			end
			Result := l_result
		end

	smtp_regular_transfer (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_result: NATURAL_32
			l_connected: CE_ARRAY [BOOLEAN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_connected.make (<<1>>)
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_connected.item := (0).to_boolean
			l_data := a_conn.item.data
			l_data.item.req.size := (-1).to_integer_64
			progress_inst.Curl_pgrsSetUploadCounter (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetDownloadCounter (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetUploadSize (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetDownloadSize (l_data, (0).to_integer_64)
			l_result := smtp_perform (a_conn, l_connected, a_dophase_done)
			if {NATURAL_32} 0 = l_result then
				if not a_dophase_done.item then
					Result := ({PC_CURLCODE}.CURLE_OK)
					js.return
				end
				if not js.return_called then
					l_result := smtp_dophase_done (a_conn, l_connected.item)
					if l_result.to_boolean then
						Result := l_result
						js.return
					end
				end
			end
			if not js.return_called then
				Result := l_result
			end
		end

	smtp_setup_connection (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_conn.item.data
			if a_conn.item.bits.httpproxy then
				if not l_data.item.set.tunnel_thru_httpproxy then
					if (a_conn.item.handler).is_equal (Curl_handler_smtp) then
						a_conn.item.handler := Curl_handler_smtp_proxy
					else
						sendf_inst.Curl_failf ([l_data, ce_string ("SMTPS not supported!")])
						Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
						js.return
					end
					if not js.return_called then
						a_conn.item.bits.close := (0).to_boolean
					end
				end
			end
			if not js.return_called then
				l_data.item.state.path := (l_data.item.state.path) + 1
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_setup_connection_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_setup_connection)
		end

	smtp_state_auth_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_smtpcode /= 235 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Authentication failed: %%d"), a_smtpcode])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
			end
			Result := l_result
		end

	smtp_state_authcram_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_chlg64: CE_POINTER [INTEGER_8]
			l_chlg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_chlglen: NATURAL_32
			l_l: NATURAL_32
			l_rplyb64: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ctxt: CE_POINTER [PD_HMAC_CONTEXT]
			l_digest: CE_ARRAY [NATURAL_8]
			l_reply: CE_ARRAY [INTEGER_8]
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_chlg64.make
			create l_chlg.make (<<1>>)
			create l_rplyb64.make (<<1>>)
			create l_ctxt.make
			create l_digest.make (<<16>>)
			create l_reply.make (<<289>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			l_chlg64 := l_data.item.state.buffer
			if a_smtpcode /= 334 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied: %%d"), a_smtpcode])
				Result := ({PC_CURLCODE}.CURLE_LOGIN_DENIED)
				js.return
			end
			if not js.return_called then
				l_chlg64 := l_chlg64 + (4)
				from
				until
					js.loop_done
				loop
					if (l_chlg64[0]).to_integer_32 /= 32 then
						if (l_chlg64[0]).to_integer_32 /= 9 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_chlg64 := l_chlg64 + 1
					end
				end
				l_chlg.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_chlglen := (0).to_natural_32
				if (l_chlg64[0]).to_integer_32 /= 61 then
					l_l := strlen (l_chlg64)
					from
					until
						js.loop_done
					loop
						l_tmp := l_l
						l_l := l_l - 1
						if not l_tmp.to_boolean then
							js.break
						end
						if not js.loop_jumped and then ((l_chlg64[l_l.to_integer_32]).to_integer_32 /= 13) then
							if (l_chlg64[l_l.to_integer_32]).to_integer_32 /= 10 then
								if (l_chlg64[l_l.to_integer_32]).to_integer_32 /= 32 then
									if (l_chlg64[l_l.to_integer_32]).to_integer_32 /= 9 then
										js.break
									end
								end
							end
						end
					end
					l_l := l_l + 1
					if l_l.to_boolean then
						l_chlg64[l_l.to_integer_32] := (('%/0/').code).to_integer_8
						l_chlglen := base64_inst.Curl_base64_decode (l_chlg64, l_chlg)
						if not l_chlglen.to_boolean then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
				end
			end
			if not js.return_called then
				l_ctxt := hmac_inst.Curl_HMAC_init (md5_inst.Curl_HMAC_MD5, create {CE_POINTER [NATURAL_8]}.make_cast (a_conn.item.passwd), (strlen (a_conn.item.passwd)))
				if l_ctxt.is_void then
					if (not (l_chlg.item).is_void) then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_chlg.item)])
					end
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				if l_chlglen > {NATURAL_32} 0 then
					hmac_inst.Curl_HMAC_update (l_ctxt, l_chlg.item, l_chlglen).do_nothing
				end
				if (not (l_chlg.item).is_void) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_chlg.item)])
				end
				hmac_inst.Curl_HMAC_final (l_ctxt, l_digest).do_nothing
				mprintf_inst.curl_msnprintf ([l_reply, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (289).to_natural_32), ce_string ("%%s %%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x"), a_conn.item.user, (l_digest[0]).to_integer_32, (l_digest[1]).to_integer_32, (l_digest[2]).to_integer_32, (l_digest[3]).to_integer_32, (l_digest[4]).to_integer_32, (l_digest[5]).to_integer_32, (l_digest[6]).to_integer_32, (l_digest[7]).to_integer_32, (l_digest[8]).to_integer_32, (l_digest[9]).to_integer_32, (l_digest[10]).to_integer_32, (l_digest[11]).to_integer_32, (l_digest[12]).to_integer_32, (l_digest[13]).to_integer_32, (l_digest[14]).to_integer_32, (l_digest[15]).to_integer_32]).do_nothing
				l_l := base64_inst.Curl_base64_encode (l_data, l_reply, (0).to_natural_32, l_rplyb64)
				if not l_l.to_boolean then
					l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				else
					l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("%%s"), l_rplyb64.item])
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_rplyb64.item)])
					if not l_result.to_boolean then
						state___2 (a_conn, {PC_SMTPSTATE}.SMTP_AUTH)
					end
				end
				Result := l_result
			end
		end

	smtp_state_authlogin_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_l: NATURAL_32
			l_authuser: CE_ARRAY [CE_POINTER [INTEGER_8]]
		do
			create l_data.make
			create l_authuser.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_smtpcode /= 334 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied: %%d"), a_smtpcode])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_l := smtp_auth_login_user (a_conn, l_authuser)
				if not l_l.to_boolean then
					l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				else
					l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("%%s"), l_authuser.item])
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_authuser.item)])
					if not l_result.to_boolean then
						state___2 (a_conn, {PC_SMTPSTATE}.SMTP_AUTHPASSWD)
					end
				end
			end
			Result := l_result
		end

	smtp_state_authpasswd_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_plen: NATURAL_32
			l_l: NATURAL_32
			l_authpasswd: CE_ARRAY [CE_POINTER [INTEGER_8]]
		do
			create l_data.make
			create l_authpasswd.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_smtpcode /= 334 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied: %%d"), a_smtpcode])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_plen := strlen (a_conn.item.passwd)
				if not l_plen.to_boolean then
					l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("=")])
				else
					l_l := base64_inst.Curl_base64_encode (l_data, a_conn.item.passwd, l_plen, l_authpasswd)
					if not l_l.to_boolean then
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					else
						l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("%%s"), l_authpasswd.item])
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_authpasswd.item)])
						if not l_result.to_boolean then
							state___2 (a_conn, {PC_SMTPSTATE}.SMTP_AUTH)
						end
					end
				end
			end
			Result := l_result
		end

	smtp_state_authplain_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_l: NATURAL_32
			l_plainauth: CE_ARRAY [CE_POINTER [INTEGER_8]]
		do
			create l_data.make
			create l_plainauth.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_smtpcode /= 334 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied: %%d"), a_smtpcode])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_l := smtp_auth_plain_data (a_conn, l_plainauth)
				if not l_l.to_boolean then
					l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				else
					l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("%%s"), l_plainauth.item])
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_plainauth.item)])
					if not l_result.to_boolean then
						state___2 (a_conn, {PC_SMTPSTATE}.SMTP_AUTH)
					end
				end
			end
			Result := l_result
		end

	smtp_state_data_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtp: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_data.make
			create l_smtp.make

			l_data := a_conn.item.data
			l_smtp := l_data.item.state.proto.smtp
			if a_smtpcode /= 354 then
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
				Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
				js.return
			end
			if not js.return_called then
				transfer_inst.Curl_setup_transfer (a_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), 0, l_smtp.item.bytecountp)
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_state_ehlo (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			js: JUMP_STATE
		do
			create l_smtpc.make

			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_smtpc.item.authmechs := {NATURAL_32} 0
			l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("EHLO %%s"), l_smtpc.item.domain])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_EHLO)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_state_ehlo_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pos: INTEGER_32
		do
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := a_conn.item.data
					if a_smtpcode // 100 = 2 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (l_data.item.set.ftp_ssl <= {NATURAL_32} 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (a_conn.item.ssl[0].use) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if not a_conn.item.bits.user_passwd then
							l_result := smtp_state_helo (a_conn)
						else
							sendf_inst.Curl_failf ([l_data, ce_string ("Access denied: %%d"), a_smtpcode])
							l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						sendf_inst.Curl_failf ([l_data, ce_string ("Access denied: %%d"), a_smtpcode])
						l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if (l_data.item.set.ftp_ssl).to_boolean then
							if not a_conn.item.ssl[0].use then
								l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("STARTTLS")])
								state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STARTTLS)
							else
								l_result := smtp_authenticate (a_conn)
							end
						else
							l_result := smtp_authenticate (a_conn)
						end
				when 10 then
					Result := l_result
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	smtp_state_helo (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			js: JUMP_STATE
		do
			create l_smtpc.make

			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("HELO %%s"), l_smtpc.item.domain])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_HELO)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_state_helo_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_smtpcode // 100 /= 2 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied: %%d"), a_smtpcode])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
			end
			Result := l_result
		end

	smtp_state_mail_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			create l_data.make
			create l_smtpc.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_smtpcode // 100 /= 2 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied: %%d"), a_smtpcode])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
			else
				l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
				l_smtpc.item.rcpt := l_data.item.set.mail_rcpt
				l_result := smtp_rcpt_to (a_conn)
			end
			Result := l_result
		end

	smtp_state_postdata_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if a_smtpcode /= 250 then
				l_result := {PC_CURLCODE}.CURLE_RECV_ERROR
			end
			state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
			Result := l_result
		end

	smtp_state_rcpt_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			js: JUMP_STATE
		do
			create l_data.make
			create l_smtpc.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_smtpcode // 100 /= 2 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied: %%d"), a_smtpcode])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
			else
				l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
				if (not (l_smtpc.item.rcpt).is_void) then
					l_smtpc.item.rcpt := (l_smtpc.item.rcpt).item.next
					l_result := smtp_rcpt_to (a_conn)
					if l_result.to_boolean then
						Result := l_result
						js.return
					elseif (not (l_smtpc.item.rcpt).is_void) then
						Result := l_result
						js.return
					end
				end
				if not js.return_called then
					l_result := pingpong_inst.Curl_pp_sendf ([create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp")), ce_string ("DATA")])
					if l_result.to_boolean then
						Result := l_result
						js.return
					end
				end
				if not js.return_called then
					state___2 (a_conn, {PC_SMTPSTATE}.SMTP_DATA)
				end
			end
			if not js.return_called then
				Result := l_result
			end
		end

	smtp_state_starttls_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := a_conn.item.data
			if a_smtpcode /= 220 then
				if l_data.item.set.ftp_ssl /= {NATURAL_32} 1 then
					sendf_inst.Curl_failf ([l_data, ce_string ("STARTTLS denied. %%c"), a_smtpcode])
					l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
				else
					l_result := smtp_authenticate (a_conn)
				end
			else
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if {NATURAL_32} 0 = l_result then
					a_conn.item.protocol := (a_conn.item.protocol).bit_or (((1).bit_shift_left (17)).to_integer_32)
					l_result := smtp_state_ehlo (a_conn)
				end
			end
			Result := l_result
		end

	smtp_statemach_act (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_sock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtpcode: CE_ARRAY [INTEGER_32]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_nread: CE_ARRAY [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_smtpcode.make (<<1>>)
			create l_smtpc.make
			create l_pp.make
			create l_nread.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := a_conn.item.sock[0]
					l_data := a_conn.item.data
					l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
					l_pp := create {CE_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))
					l_nread.item := (0).to_natural_32
					if (l_pp.item.sendleft).to_boolean then
						Result := (pingpong_inst.Curl_pp_flushsend (l_pp))
						js.return
					end
					if not js.return_called then
						l_result := pingpong_inst.Curl_pp_readresp (l_sock, l_pp, l_smtpcode, l_nread)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
					end
					if not (not js.return_called and then ((l_smtpcode.item).to_boolean)) then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						inspect (l_smtpc.item.state).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 4 then l_pos := -1 + 5
						when 5 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 7
						when 7 then l_pos := -1 + 8
						when 8 then l_pos := -1 + 9
						when 9 then l_pos := -1 + 10
						when 10 then l_pos := -1 + 11
						when 11 then l_pos := -1 + 12
						when 12 then l_pos := -1 + 13
						when 13 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 2 then -- switch 1, case 1
						if l_smtpcode.item // 100 /= 2 then
							sendf_inst.Curl_failf ([l_data, ce_string ("Got unexpected smtp-server response: %%d"), l_smtpcode.item])
							Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_SERVER_REPLY)
							js.return
						end
						if not js.return_called then
							l_result := smtp_state_ehlo (a_conn)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
						l_pos := -1 + 16 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_result := smtp_state_ehlo_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_result := smtp_state_helo_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 5 then -- switch 1, case 4
						l_result := smtp_state_starttls_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 6 then -- switch 1, case 5
						l_result := smtp_state_authplain_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 7 then -- switch 1, case 6
						l_result := smtp_state_authlogin_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 8 then -- switch 1, case 7
						l_result := smtp_state_authpasswd_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 9 then -- switch 1, case 8
						l_result := smtp_state_authcram_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 10 then -- switch 1, case 9
						l_result := smtp_state_auth_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 11 then -- switch 1, case 10
						l_result := smtp_state_mail_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 12 then -- switch 1, case 11
						l_result := smtp_state_rcpt_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 13 then -- switch 1, case 12
						l_result := smtp_state_data_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 14 then -- switch 1, case 13
						l_result := smtp_state_postdata_resp (a_conn, l_smtpcode.item, l_smtpc.item.state)
						l_pos := -1 + 16 -- switch 1; break
				when 15 then -- switch 1, default:
						state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
						l_pos := -1 + 16 -- switch 1; break
				when 16 then -- switch 1, done: | if done
						if not js.return_called then
							Result := l_result
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	smtp_statemach_act_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smtp_statemach_act)
		end

	state___2 (a_conn: CE_POINTER [PD_CONNECTDATA]; a_newstate: NATURAL_32)
		local
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			create l_smtpc.make

			l_smtpc := create {CE_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_smtpc.item.state := a_newstate
		end

end
