class
	P_SOCKS

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_SOCKS4 (a_proxy_name: CE_POINTER [INTEGER_8]; a_hostname: CE_POINTER [INTEGER_8]; a_remote_port: INTEGER_32; a_sockindex: INTEGER_32; a_conn: CE_POINTER [PD_CONNECTDATA]; a_protocol4a: BOOLEAN): NATURAL_32
		local
			l_socksreq: CE_ARRAY [NATURAL_8]
			l_result: INTEGER_32
			l_code: NATURAL_32
			l_sock: INTEGER_32
			l_timeout: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_dns: CE_ARRAY [CE_POINTER [PD_CURL_DNS_ENTRY]]
			l_hp: CE_POINTER [PD_CURL_ADDRINFO]
			l_rc: INTEGER_32
			l_buf: CE_ARRAY [INTEGER_8]
			l_ip: CE_ARRAY [NATURAL_16]
			l_actualread: CE_ARRAY [INTEGER_32]
			l_written: CE_ARRAY [INTEGER_32]
			l_hostnamelen: INTEGER_32
			l_packetsize: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_socksreq.make (<<262>>)
			create l_data.make
			create l_dns.make (<<1>>)
			create l_hp.make
			create l_buf.make (<<64>>)
			create l_ip.make (<<4>>)
			create l_actualread.make (<<1>>)
			create l_written.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := a_conn.item.sock[a_sockindex]
					l_data := a_conn.item.data
					l_timeout := connect_inst.Curl_timeleft (a_conn, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer), (1).to_boolean)
					if l_timeout < 0 then
						sendf_inst.Curl_failf ([l_data, ce_string ("Connection time-out")])
						Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
						js.return
					end
					if not js.return_called then
						nonblock_inst.curlx_nonblock (l_sock, 0).do_nothing
						l_socksreq[0] := (4).to_natural_8
						l_socksreq[1] := (1).to_natural_8;
						(create {CE_POINTER [NATURAL_16]}.make_cast ((l_socksreq + 2))).item := htons (a_remote_port.to_natural_16)
						if not a_protocol4a then
							l_hp := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
							l_rc := hostip_inst.Curl_resolv (a_conn, a_hostname, a_remote_port, l_dns)
							if l_rc = -1 then
								Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_PROXY)
								js.return
							end
							if not js.return_called then
								if l_rc = 1 then
									hostsyn_inst.Curl_wait_for_resolv (a_conn, l_dns).do_nothing
								end
								if (not (l_dns.item).is_void) then
									l_hp := l_dns.item.item.addr
								end
								if (not l_hp.is_void) then
									hostip_inst.Curl_printable_address (l_hp, l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (64).to_natural_32)).do_nothing
									if 4 = (sscanf ([l_buf, ce_string ("%%hu.%%hu.%%hu.%%hu"), l_ip + 0, l_ip + 1, l_ip + 2, l_ip + 3])) then
										l_socksreq[4] := (l_ip[0]).to_natural_8
										l_socksreq[5] := (l_ip[1]).to_natural_8
										l_socksreq[6] := (l_ip[2]).to_natural_8
										l_socksreq[7] := (l_ip[3]).to_natural_8
									else
										l_hp := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
									end
									hostip_inst.Curl_resolv_unlock (l_data, l_dns.item)
								end
								if l_hp.is_void then
									sendf_inst.Curl_failf ([l_data, ce_string ("Failed to resolve %"%%s%" for SOCKS4 connect."), a_hostname])
									Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
									js.return
								end
							end
						end
					end
					if not js.return_called then
						l_socksreq[8] := (0).to_natural_8
						if (not a_proxy_name.is_void) then
							strequal_inst.Curl_strlcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_socksreq) + 8, a_proxy_name, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (262).to_natural_32) - {NATURAL_32} 8).do_nothing
						end
						l_hostnamelen := 0
						l_packetsize := 9 + (strlen ((create {CE_POINTER [INTEGER_8]}.make_cast (l_socksreq) + 8))).to_integer_32
						if a_protocol4a then
							l_socksreq[4] := (0).to_natural_8
							l_socksreq[5] := (0).to_natural_8
							l_socksreq[6] := (0).to_natural_8
							l_socksreq[7] := (1).to_natural_8
							l_hostnamelen := (strlen (a_hostname)).to_integer_32 + 1
							if l_packetsize + l_hostnamelen <= 262 then
								strcpy ((create {CE_POINTER [INTEGER_8]}.make_cast (l_socksreq) + l_packetsize), a_hostname).do_nothing
							else
								l_hostnamelen := 0
							end
						end
						l_code := sendf_inst.Curl_write_plain (a_conn, l_sock, create {CE_POINTER [ANY]}.make_cast (l_socksreq), (l_packetsize + l_hostnamelen).to_natural_32, l_written)
						if l_code /= {NATURAL_32} 0 then
							sendf_inst.Curl_failf ([l_data, ce_string ("Failed to send SOCKS4 connect request.")])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							js.return
						elseif l_written.item /= l_packetsize + l_hostnamelen then
							sendf_inst.Curl_failf ([l_data, ce_string ("Failed to send SOCKS4 connect request.")])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							js.return
						end
					end
					if not js.return_called and then a_protocol4a then
						if l_hostnamelen = 0 then
							l_hostnamelen := (strlen (a_hostname)).to_integer_32 + 1
							l_code := sendf_inst.Curl_write_plain (a_conn, l_sock, create {CE_POINTER [ANY]}.make_cast (a_hostname), l_hostnamelen.to_natural_32, l_written)
							if l_code /= {NATURAL_32} 0 then
								sendf_inst.Curl_failf ([l_data, ce_string ("Failed to send SOCKS4 connect request.")])
								Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
								js.return
							elseif l_written.item /= l_hostnamelen then
								sendf_inst.Curl_failf ([l_data, ce_string ("Failed to send SOCKS4 connect request.")])
								Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
								js.return
							end
						end
					end
					if not js.return_called then
						l_packetsize := 8
						l_result := Curl_blockread_all (a_conn, l_sock, create {CE_POINTER [INTEGER_8]}.make_cast (l_socksreq), l_packetsize, l_actualread, l_timeout)
						if l_result /= 0 then
							sendf_inst.Curl_failf ([l_data, ce_string ("Failed to receive SOCKS4 connect request ack.")])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							js.return
						elseif l_actualread.item /= l_packetsize then
							sendf_inst.Curl_failf ([l_data, ce_string ("Failed to receive SOCKS4 connect request ack.")])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							js.return
						end
					end
					if not js.return_called and then ((l_socksreq[0]).to_integer_32 /= 0) then
						sendf_inst.Curl_failf ([l_data, ce_string ("SOCKS4 reply has wrong version, version should be 4.")])
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						inspect (l_socksreq[1]).to_integer_32 -- switch 1 head
						when 90 then l_pos := -1 + 2
						when 91 then l_pos := -1 + 3
						when 92 then l_pos := -1 + 4
						when 93 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 90
						if a_protocol4a then
							sendf_inst.Curl_infof ([l_data, ce_string ("SOCKS4a request granted.%N")])
						else
							sendf_inst.Curl_infof ([l_data, ce_string ("SOCKS4 request granted.%N")])
						end
						l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 91
						sendf_inst.Curl_failf ([l_data, ce_string ("Can%'t complete SOCKS4 connection to %%d.%%d.%%d.%%d:%%d. (%%d), request rejected or failed."), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, (ntohs ((create {CE_POINTER [NATURAL_16]}.make_cast ((l_socksreq + 8))).item)).to_natural_32, (l_socksreq[1]).to_integer_32])
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						js.return
				when 4 then -- switch 1, case 92
						if not js.return_called then
							sendf_inst.Curl_failf ([l_data, ce_string ("Can%'t complete SOCKS4 connection to %%d.%%d.%%d.%%d:%%d. (%%d), request rejected because SOCKS server cannot connect to identd on the client."), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, (ntohs ((create {CE_POINTER [NATURAL_16]}.make_cast ((l_socksreq + 8))).item)).to_natural_32, (l_socksreq[1]).to_integer_32])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							js.return
						end
				when 5 then -- switch 1, case 93
						if not js.return_called then
							sendf_inst.Curl_failf ([l_data, ce_string ("Can%'t complete SOCKS4 connection to %%d.%%d.%%d.%%d:%%d. (%%d), request rejected because the client program and identd report different user-ids."), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, (ntohs ((create {CE_POINTER [NATURAL_16]}.make_cast ((l_socksreq + 8))).item)).to_natural_32, (l_socksreq[1]).to_integer_32])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							js.return
						end
				when 6 then -- switch 1, default:
						if not js.return_called then
							sendf_inst.Curl_failf ([l_data, ce_string ("Can%'t complete SOCKS4 connection to %%d.%%d.%%d.%%d:%%d. (%%d), Unknown."), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, (ntohs ((create {CE_POINTER [NATURAL_16]}.make_cast ((l_socksreq + 8))).item)).to_natural_32, (l_socksreq[1]).to_integer_32])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							js.return
						end
				when 7 then -- switch 1, done: | if done
						if not js.return_called then
							nonblock_inst.curlx_nonblock (l_sock, 1).do_nothing
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_SOCKS5 (a_proxy_name: CE_POINTER [INTEGER_8]; a_proxy_password: CE_POINTER [INTEGER_8]; a_hostname: CE_POINTER [INTEGER_8]; a_remote_port: INTEGER_32; a_sockindex: INTEGER_32; a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_socksreq: CE_ARRAY [NATURAL_8]
			l_actualread: CE_ARRAY [INTEGER_32]
			l_written: CE_ARRAY [INTEGER_32]
			l_result: INTEGER_32
			l_code: NATURAL_32
			l_sock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_timeout: INTEGER_32
			l_socks5_resolve_local: BOOLEAN
			l_hostname_len: NATURAL_32
			l_packetsize: INTEGER_32
			l_tmp___0: INTEGER_32
			l_userlen: NATURAL_32
			l_pwlen: NATURAL_32
			l_len: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_dns: CE_ARRAY [CE_POINTER [PD_CURL_DNS_ENTRY]]
			l_hp: CE_POINTER [PD_CURL_ADDRINFO]
			l_rc: INTEGER_32
			l_buf: CE_ARRAY [INTEGER_8]
			l_ip: CE_ARRAY [NATURAL_16]
			l_addrlen: INTEGER_32
			js: JUMP_STATE
		do
			create l_socksreq.make (<<600>>)
			create l_actualread.make (<<1>>)
			create l_written.make (<<1>>)
			create l_data.make
			create l_dns.make (<<1>>)
			create l_hp.make
			create l_buf.make (<<64>>)
			create l_ip.make (<<4>>)

			l_sock := a_conn.item.sock[a_sockindex]
			l_data := a_conn.item.data
			l_socks5_resolve_local := (l_data.item.set.proxytype = {NATURAL_32} 5)
			l_hostname_len := (strlen (a_hostname))
			l_packetsize := 0
			if not l_socks5_resolve_local then
				if l_hostname_len > {NATURAL_32} 255 then
					sendf_inst.Curl_infof ([a_conn.item.data, ce_string ("SOCKS5: server resolving disabled for hostnames of length > 255 [actual len=%%zu]%N"), l_hostname_len])
					l_socks5_resolve_local := (1).to_boolean
				end
			end
			l_timeout := connect_inst.Curl_timeleft (a_conn, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer), (1).to_boolean)
			if l_timeout < 0 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Connection time-out")])
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				js.return
			end
			if not js.return_called then
				nonblock_inst.curlx_nonblock (l_sock, 1).do_nothing
				l_result := select_inst.Curl_socket_ready (-1, l_sock, l_timeout.to_integer_32)
				if -1 = l_result then
					sendf_inst.Curl_failf ([a_conn.item.data, ce_string ("SOCKS5: no connection here")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				elseif 0 = l_result then
					sendf_inst.Curl_failf ([a_conn.item.data, ce_string ("SOCKS5: connection timeout")])
					Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
					js.return
				end
			end
			if not js.return_called and then (((l_result).bit_and (4)).to_boolean) then
				sendf_inst.Curl_failf ([a_conn.item.data, ce_string ("SOCKS5: error occured during connection")])
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
				js.return
			end
			if not js.return_called then
				l_socksreq[0] := (5).to_natural_8
				if (not a_proxy_name.is_void) then
					l_tmp___0 := 2
				else
					l_tmp___0 := 1
				end
				l_socksreq[1] := (l_tmp___0.to_integer_8).to_natural_8
				l_socksreq[2] := (0).to_natural_8
				l_socksreq[3] := (2).to_natural_8
				nonblock_inst.curlx_nonblock (l_sock, 0).do_nothing
				l_code := sendf_inst.Curl_write_plain (a_conn, l_sock, create {CE_POINTER [ANY]}.make_cast (l_socksreq), (2 + (l_socksreq[1]).to_integer_32).to_natural_32, l_written)
				if l_code /= {NATURAL_32} 0 then
					sendf_inst.Curl_failf ([l_data, ce_string ("Unable to send initial SOCKS5 request.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				elseif l_written.item /= 2 + (l_socksreq[1]).to_integer_32 then
					sendf_inst.Curl_failf ([l_data, ce_string ("Unable to send initial SOCKS5 request.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				end
			end
			if not js.return_called then
				nonblock_inst.curlx_nonblock (l_sock, 1).do_nothing
				l_result := select_inst.Curl_socket_ready (l_sock, -1, l_timeout.to_integer_32)
				if -1 = l_result then
					sendf_inst.Curl_failf ([a_conn.item.data, ce_string ("SOCKS5 nothing to read")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				elseif 0 = l_result then
					sendf_inst.Curl_failf ([a_conn.item.data, ce_string ("SOCKS5 read timeout")])
					Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
					js.return
				end
			end
			if not js.return_called and then (((l_result).bit_and (4)).to_boolean) then
				sendf_inst.Curl_failf ([a_conn.item.data, ce_string ("SOCKS5 read error occured")])
				Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
				js.return
			end
			if not js.return_called then
				nonblock_inst.curlx_nonblock (l_sock, 0).do_nothing
				l_result := Curl_blockread_all (a_conn, l_sock, create {CE_POINTER [INTEGER_8]}.make_cast (l_socksreq), 2, l_actualread, l_timeout)
				if l_result /= 0 then
					sendf_inst.Curl_failf ([l_data, ce_string ("Unable to receive initial SOCKS5 response.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				elseif l_actualread.item /= 2 then
					sendf_inst.Curl_failf ([l_data, ce_string ("Unable to receive initial SOCKS5 response.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				end
			end
			if not js.return_called and then ((l_socksreq[0]).to_integer_32 /= 5) then
				sendf_inst.Curl_failf ([l_data, ce_string ("Received invalid version in initial SOCKS5 response.")])
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
				js.return
			end
			if not js.return_called and then ((l_socksreq[1]).to_integer_32 /= 0) then
				if (l_socksreq[1]).to_integer_32 = 2 then
					if (not a_proxy_name.is_void) then
						if (not a_proxy_password.is_void) then
							l_userlen := strlen (a_proxy_name)
							l_pwlen := strlen (a_proxy_password)
						else
							l_userlen := (0).to_natural_32
							l_pwlen := (0).to_natural_32
						end
					else
						l_userlen := (0).to_natural_32
						l_pwlen := (0).to_natural_32
					end
					l_len := 0
					l_tmp___1 := l_len
					l_len := l_len + 1
					l_socksreq[l_tmp___1] := (1).to_natural_8
					l_tmp___2 := l_len
					l_len := l_len + 1
					l_socksreq[l_tmp___2] := l_userlen.to_natural_8
					if (not a_proxy_name.is_void) then
						if l_userlen.to_boolean then
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_socksreq + l_len)), create {CE_POINTER [ANY]}.make_cast (a_proxy_name), l_userlen).do_nothing
						end
					end
					l_len := l_len + l_userlen.to_integer_32
					l_tmp___3 := l_len
					l_len := l_len + 1
					l_socksreq[l_tmp___3] := l_pwlen.to_natural_8
					if (not a_proxy_password.is_void) then
						if l_pwlen.to_boolean then
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_socksreq + l_len)), create {CE_POINTER [ANY]}.make_cast (a_proxy_password), l_pwlen).do_nothing
						end
					end
					l_len := l_len + l_pwlen.to_integer_32
					l_code := sendf_inst.Curl_write_plain (a_conn, l_sock, create {CE_POINTER [ANY]}.make_cast (l_socksreq), l_len.to_natural_32, l_written)
					if l_code /= {NATURAL_32} 0 then
						sendf_inst.Curl_failf ([l_data, ce_string ("Failed to send SOCKS5 sub-negotiation request.")])
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						js.return
					elseif l_len /= l_written.item then
						sendf_inst.Curl_failf ([l_data, ce_string ("Failed to send SOCKS5 sub-negotiation request.")])
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						js.return
					end
					if not js.return_called then
						l_result := Curl_blockread_all (a_conn, l_sock, create {CE_POINTER [INTEGER_8]}.make_cast (l_socksreq), 2, l_actualread, l_timeout)
						if l_result /= 0 then
							sendf_inst.Curl_failf ([l_data, ce_string ("Unable to receive SOCKS5 sub-negotiation response.")])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							js.return
						elseif l_actualread.item /= 2 then
							sendf_inst.Curl_failf ([l_data, ce_string ("Unable to receive SOCKS5 sub-negotiation response.")])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							js.return
						end
					end
					if not js.return_called and then ((l_socksreq[1]).to_integer_32 /= 0) then
						sendf_inst.Curl_failf ([l_data, ce_string ("User was rejected by the SOCKS5 server (%%d %%d)."), (l_socksreq[0]).to_integer_32, (l_socksreq[1]).to_integer_32])
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						js.return
					end
				elseif (l_socksreq[1]).to_integer_32 = 1 then
					sendf_inst.Curl_failf ([l_data, ce_string ("SOCKS5 GSSAPI per-message authentication is not supported.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				elseif (l_socksreq[1]).to_integer_32 = 255 then
					if a_proxy_name.is_void then
						sendf_inst.Curl_failf ([l_data, ce_string ("No authentication method was acceptable. (It is quite likely that the SOCKS5 server wanted a username/password, since none was supplied to the server on this connection.)")])
					elseif not (a_proxy_name[0]).to_boolean then
						sendf_inst.Curl_failf ([l_data, ce_string ("No authentication method was acceptable. (It is quite likely that the SOCKS5 server wanted a username/password, since none was supplied to the server on this connection.)")])
					else
						sendf_inst.Curl_failf ([l_data, ce_string ("No authentication method was acceptable.")])
					end
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				else
					sendf_inst.Curl_failf ([l_data, ce_string ("Undocumented SOCKS5 mode attempted to be used by server.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				end
			end
			if not js.return_called then
				l_socksreq[0] := (5).to_natural_8
				l_socksreq[1] := (1).to_natural_8
				l_socksreq[2] := (0).to_natural_8
				if not l_socks5_resolve_local then
					l_packetsize := (({NATURAL_32} 5 + l_hostname_len) + {NATURAL_32} 2).to_integer_32
					l_socksreq[3] := (3).to_natural_8
					l_socksreq[4] := (l_hostname_len.to_integer_8).to_natural_8
					memcpy (create {CE_POINTER [ANY]}.make_cast ((l_socksreq + 5)), create {CE_POINTER [ANY]}.make_cast (a_hostname), l_hostname_len).do_nothing;
					(create {CE_POINTER [NATURAL_16]}.make_cast ((l_socksreq + (l_hostname_len + {NATURAL_32} 5).to_integer_32))).item := htons (a_remote_port.to_natural_16)
				else
					l_hp := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
					l_rc := (hostip_inst.Curl_resolv (a_conn, a_hostname, a_remote_port, l_dns))
					l_packetsize := 10
					l_socksreq[3] := (1).to_natural_8
					if l_rc = -1 then
						Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
						js.return
					end
					if not js.return_called and then (l_rc = 1) then
						l_code := hostsyn_inst.Curl_wait_for_resolv (a_conn, l_dns)
						if l_code /= {NATURAL_32} 0 then
							Result := l_code
							js.return
						end
					end
					if not js.return_called then
						if (not (l_dns.item).is_void) then
							l_hp := l_dns.item.item.addr
						end
						if (not l_hp.is_void) then
							hostip_inst.Curl_printable_address (l_hp, l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (64).to_natural_32)).do_nothing
							if 4 = (sscanf ([l_buf, ce_string ("%%hu.%%hu.%%hu.%%hu"), l_ip + 0, l_ip + 1, l_ip + 2, l_ip + 3])) then
								l_socksreq[4] := (l_ip[0]).to_natural_8
								l_socksreq[5] := (l_ip[1]).to_natural_8
								l_socksreq[6] := (l_ip[2]).to_natural_8
								l_socksreq[7] := (l_ip[3]).to_natural_8
							else
								l_hp := create {CE_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
							end
							hostip_inst.Curl_resolv_unlock (l_data, l_dns.item)
						end
						if l_hp.is_void then
							sendf_inst.Curl_failf ([l_data, ce_string ("Failed to resolve %"%%s%" for SOCKS5 connect."), a_hostname])
							Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
							js.return
						end
					end
					if not js.return_called then
						(create {CE_POINTER [NATURAL_16]}.make_cast ((l_socksreq + 8))).item := htons (a_remote_port.to_natural_16)
					end
				end
			end
			if not js.return_called then
				l_code := sendf_inst.Curl_write_plain (a_conn, l_sock, create {CE_POINTER [ANY]}.make_cast (l_socksreq), l_packetsize.to_natural_32, l_written)
				if l_code /= {NATURAL_32} 0 then
					sendf_inst.Curl_failf ([l_data, ce_string ("Failed to send SOCKS5 connect request.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				elseif l_written.item /= l_packetsize then
					sendf_inst.Curl_failf ([l_data, ce_string ("Failed to send SOCKS5 connect request.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				end
			end
			if not js.return_called then
				l_packetsize := 10
				l_result := Curl_blockread_all (a_conn, l_sock, create {CE_POINTER [INTEGER_8]}.make_cast (l_socksreq), l_packetsize, l_actualread, l_timeout)
				if l_result /= 0 then
					sendf_inst.Curl_failf ([l_data, ce_string ("Failed to receive SOCKS5 connect request ack.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				elseif l_actualread.item /= l_packetsize then
					sendf_inst.Curl_failf ([l_data, ce_string ("Failed to receive SOCKS5 connect request ack.")])
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					js.return
				end
			end
			if not js.return_called and then ((l_socksreq[0]).to_integer_32 /= 5) then
				sendf_inst.Curl_failf ([l_data, ce_string ("SOCKS5 reply has wrong version, version should be 5.")])
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
				js.return
			end
			if not js.return_called and then ((l_socksreq[1]).to_integer_32 /= 0) then
				sendf_inst.Curl_failf ([l_data, ce_string ("Can%'t complete SOCKS5 connection to %%d.%%d.%%d.%%d:%%d. (%%d)"), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, (ntohs ((create {CE_POINTER [NATURAL_16]}.make_cast ((l_socksreq + 8))).item)).to_natural_32, (l_socksreq[1]).to_integer_32])
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
				js.return
			end
			if not js.return_called then
				if (l_socksreq[3]).to_integer_32 = 3 then
					l_addrlen := (l_socksreq[4]).to_integer_32
					l_packetsize := (5 + l_addrlen) + 2
				elseif (l_socksreq[3]).to_integer_32 = 4 then
					l_packetsize := 22
				end
				if l_packetsize > 10 then
					l_packetsize := l_packetsize - (10)
					l_result := Curl_blockread_all (a_conn, l_sock, create {CE_POINTER [INTEGER_8]}.make_cast ((l_socksreq + 10)), l_packetsize, l_actualread, l_timeout)
					if l_result /= 0 then
						sendf_inst.Curl_failf ([l_data, ce_string ("Failed to receive SOCKS5 connect request ack.")])
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						js.return
					elseif l_actualread.item /= l_packetsize then
						sendf_inst.Curl_failf ([l_data, ce_string ("Failed to receive SOCKS5 connect request ack.")])
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						js.return
					end
				end
			end
			if not js.return_called then
				nonblock_inst.curlx_nonblock (l_sock, 1).do_nothing
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_blockread_all (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sockfd: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_buffersize: INTEGER_32; a_n: CE_POINTER [INTEGER_32]; a_conn_timeout: INTEGER_32): INTEGER_32
		local
			l_buf: CE_POINTER [INTEGER_8]
			l_buffersize: INTEGER_32
			l_nread: CE_ARRAY [INTEGER_32]
			l_allread: INTEGER_32
			l_result: INTEGER_32
			l_tvnow: SD_TIMEVAL
			l_conntime: INTEGER_32
			js: JUMP_STATE
		do
			create l_buf.make
			create l_nread.make (<<1>>)
			create l_tvnow.make

			l_buf := a_buf
			l_buffersize := a_buffersize
			l_allread := 0
			a_n.item := 0
			from
			until
				js.loop_done
			loop
				l_tvnow := (timeval_inst.curlx_tvnow).twin
				l_conntime := timeval_inst.curlx_tvdiff (l_tvnow.twin, (a_conn.item.created).twin)
				if l_conntime > a_conn_timeout then
					l_result := 28
					js.break
				end
				if not js.loop_jumped then
					if (select_inst.Curl_socket_ready (a_sockfd, -1, (a_conn_timeout - l_conntime).to_integer_32)) <= 0 then
						l_result := (0).bit_not
						js.break
					end
				end
				if not js.loop_jumped then
					l_result := (sendf_inst.Curl_read_plain (a_sockfd, l_buf, l_buffersize.to_natural_32, l_nread)).to_integer_32
					if 81 = l_result then
						js.continue
					elseif l_result.to_boolean then
						js.break
					end
				end
				if not js.loop_jumped and then (l_buffersize = l_nread.item) then
					l_allread := l_allread + (l_nread.item)
					a_n.item := l_allread
					l_result := 0
					js.break
				end
				if not js.loop_jumped and then (not (l_nread.item).to_boolean) then
					l_result := (0).bit_not
					js.break
				end
				if not js.loop_jumped then
					l_buffersize := l_buffersize - (l_nread.item)
					l_buf := l_buf + (l_nread.item)
					l_allread := l_allread + (l_nread.item)
				end
				if js.loop_increment then
					
				end
			end
			Result := l_result
		end

end
