class
	SD_ADDRINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ai_addr.make
			create ai_canonname.make
			create ai_next.make
		end

feature {ANY} -- fields

	ai_flags: INTEGER_32 assign set_ai_flags

	ai_family: INTEGER_32 assign set_ai_family

	ai_socktype: INTEGER_32 assign set_ai_socktype

	ai_protocol: INTEGER_32 assign set_ai_protocol

	ai_addrlen: NATURAL_32 assign set_ai_addrlen

	ai_addr: CE_POINTER [SD_SOCKADDR] assign set_ai_addr

	ai_canonname: CE_POINTER [INTEGER_8] assign set_ai_canonname

	ai_next: CE_POINTER [SD_ADDRINFO] assign set_ai_next

feature {ANY} -- setters

	set_ai_flags (a_ai_flags: INTEGER_32)
		do
			ai_flags := a_ai_flags
			update_memory_field ("ai_flags")
		end

	set_ai_family (a_ai_family: INTEGER_32)
		do
			ai_family := a_ai_family
			update_memory_field ("ai_family")
		end

	set_ai_socktype (a_ai_socktype: INTEGER_32)
		do
			ai_socktype := a_ai_socktype
			update_memory_field ("ai_socktype")
		end

	set_ai_protocol (a_ai_protocol: INTEGER_32)
		do
			ai_protocol := a_ai_protocol
			update_memory_field ("ai_protocol")
		end

	set_ai_addrlen (a_ai_addrlen: NATURAL_32)
		do
			ai_addrlen := a_ai_addrlen
			update_memory_field ("ai_addrlen")
		end

	set_ai_addr (a_ai_addr: CE_POINTER [SD_SOCKADDR])
		do
			ai_addr := a_ai_addr
			update_memory_field ("ai_addr")
		end

	set_ai_canonname (a_ai_canonname: CE_POINTER [INTEGER_8])
		do
			ai_canonname := a_ai_canonname
			update_memory_field ("ai_canonname")
		end

	set_ai_next (a_ai_next: CE_POINTER [SD_ADDRINFO])
		do
			ai_next := a_ai_next
			update_memory_field ("ai_next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ai_flags := a_other.ai_flags
			ai_family := a_other.ai_family
			ai_socktype := a_other.ai_socktype
			ai_protocol := a_other.ai_protocol
			ai_addrlen := a_other.ai_addrlen
			ai_addr := a_other.ai_addr
			ai_canonname := a_other.ai_canonname
			ai_next := a_other.ai_next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ai_flags = a_other.ai_flags and
				ai_family = a_other.ai_family and
				ai_socktype = a_other.ai_socktype and
				ai_protocol = a_other.ai_protocol and
				ai_addrlen = a_other.ai_addrlen and
				ai_addr.is_equal (a_other.ai_addr) and
				ai_canonname.is_equal (a_other.ai_canonname) and
				ai_next.is_equal (a_other.ai_next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ai_flags"),
					create {CE_STRUCTURE_FIELD}.make ("ai_family"),
					create {CE_STRUCTURE_FIELD}.make ("ai_socktype"),
					create {CE_STRUCTURE_FIELD}.make ("ai_protocol"),
					create {CE_STRUCTURE_FIELD}.make ("ai_addrlen"),
					create {CE_STRUCTURE_FIELD}.make ("ai_addr"),
					create {CE_STRUCTURE_FIELD}.make ("ai_canonname"),
					create {CE_STRUCTURE_FIELD}.make ("ai_next")
				>>)
			init_structure_info
		end

end
