class
	SD_POLLFD

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	fd: INTEGER_32 assign set_fd

	events: INTEGER_16 assign set_events

	revents: INTEGER_16 assign set_revents

feature {ANY} -- setters

	set_fd (a_fd: INTEGER_32)
		do
			fd := a_fd
			update_memory_field ("fd")
		end

	set_events (a_events: INTEGER_16)
		do
			events := a_events
			update_memory_field ("events")
		end

	set_revents (a_revents: INTEGER_16)
		do
			revents := a_revents
			update_memory_field ("revents")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fd := a_other.fd
			events := a_other.events
			revents := a_other.revents
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fd = a_other.fd and
				events = a_other.events and
				revents = a_other.revents
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fd"),
					create {CE_STRUCTURE_FIELD}.make ("events"),
					create {CE_STRUCTURE_FIELD}.make ("revents")
				>>)
			init_structure_info
		end

end
