class
	SD_SOCKADDR_STORAGE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ss_padding.make (<<({NATURAL_32} 128 - {NATURAL_32} 2 * {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32>>)
		end

feature {ANY} -- fields

	ss_family: NATURAL_16 assign set_ss_family

	ss_align: NATURAL_32 assign set_ss_align

	ss_padding: CE_ARRAY [INTEGER_8]

feature {ANY} -- setters

	set_ss_family (a_ss_family: NATURAL_16)
		do
			ss_family := a_ss_family
			update_memory_field ("ss_family")
		end

	set_ss_align (a_ss_align: NATURAL_32)
		do
			ss_align := a_ss_align
			update_memory_field ("ss_align")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ss_family := a_other.ss_family
			ss_align := a_other.ss_align
			ss_padding := a_other.ss_padding.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ss_family = a_other.ss_family and
				ss_align = a_other.ss_align and
				ss_padding.is_equal (a_other.ss_padding)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ss_family"),
					create {CE_STRUCTURE_FIELD}.make ("ss_align"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ss_padding", <<({NATURAL_32} 128 - {NATURAL_32} 2 * {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32>>)
				>>)
			init_structure_info
		end

end
