deferred class
	S_STRING

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	memchr (a___s: CE_POINTER [ANY]; a___c: INTEGER_32; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memchr (a___s.c_pointer, a___c, a___n))
		end

	c_memchr (a___s: POINTER; a___c: INTEGER_32; a___n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return memchr($a___s, $a___c, $a___n);"
		end

	memcmp (a___s1: CE_POINTER [ANY]; a___s2: CE_POINTER [ANY]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_memcmp (a___s1.c_pointer, a___s2.c_pointer, a___n)
		end

	c_memcmp (a___s1: POINTER; a___s2: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return memcmp($a___s1, $a___s2, $a___n);"
		end

	memcpy (a___dest: CE_POINTER [ANY]; a___src: CE_POINTER [ANY]; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memcpy (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_memcpy (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return memcpy($a___dest, $a___src, $a___n);"
		end

	memmove (a___dest: CE_POINTER [ANY]; a___src: CE_POINTER [ANY]; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memmove (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_memmove (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return memmove($a___dest, $a___src, $a___n);"
		end

	memset (a___s: CE_POINTER [ANY]; a___c: INTEGER_32; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memset (a___s.c_pointer, a___c, a___n))
		end

	c_memset (a___s: POINTER; a___c: INTEGER_32; a___n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return memset($a___s, $a___c, $a___n);"
		end

	strcasecmp (a___s1: CE_POINTER [INTEGER_8]; a___s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcasecmp (a___s1.c_pointer, a___s2.c_pointer)
		end

	c_strcasecmp (a___s1: POINTER; a___s2: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strcasecmp($a___s1, $a___s2);"
		end

	strcat (a___dest: CE_POINTER [INTEGER_8]; a___src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcat (a___dest.c_pointer, a___src.c_pointer))
		end

	c_strcat (a___dest: POINTER; a___src: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strcat($a___dest, $a___src);"
		end

	strchr (a___s: CE_POINTER [INTEGER_8]; a___c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strchr (a___s.c_pointer, a___c))
		end

	c_strchr (a___s: POINTER; a___c: INTEGER_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strchr($a___s, $a___c);"
		end

	strcmp (a___s1: CE_POINTER [INTEGER_8]; a___s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcmp (a___s1.c_pointer, a___s2.c_pointer)
		end

	c_strcmp (a___s1: POINTER; a___s2: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strcmp($a___s1, $a___s2);"
		end

	strcpy (a___dest: CE_POINTER [INTEGER_8]; a___src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcpy (a___dest.c_pointer, a___src.c_pointer))
		end

	c_strcpy (a___dest: POINTER; a___src: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strcpy($a___dest, $a___src);"
		end

	strdup (a___s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strdup (a___s.c_pointer))
		end

	c_strdup (a___s: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strdup($a___s);"
		end

	strdup_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent strdup)
		end

	strerror_r (a___errnum: INTEGER_32; a___buf: CE_POINTER [INTEGER_8]; a___buflen: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strerror_r (a___errnum, a___buf.c_pointer, a___buflen))
		end

	c_strerror_r (a___errnum: INTEGER_32; a___buf: POINTER; a___buflen: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strerror_r($a___errnum, $a___buf, $a___buflen);"
		end

	strlen (a___s: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strlen (a___s.c_pointer)
		end

	c_strlen (a___s: POINTER): NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strlen($a___s);"
		end

	strncasecmp (a___s1: CE_POINTER [INTEGER_8]; a___s2: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_strncasecmp (a___s1.c_pointer, a___s2.c_pointer, a___n)
		end

	c_strncasecmp (a___s1: POINTER; a___s2: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strncasecmp($a___s1, $a___s2, $a___n);"
		end

	strncmp (a___s1: CE_POINTER [INTEGER_8]; a___s2: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_strncmp (a___s1.c_pointer, a___s2.c_pointer, a___n)
		end

	c_strncmp (a___s1: POINTER; a___s2: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strncmp($a___s1, $a___s2, $a___n);"
		end

	strncpy (a___dest: CE_POINTER [INTEGER_8]; a___src: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strncpy (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_strncpy (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strncpy($a___dest, $a___src, $a___n);"
		end

	strrchr (a___s: CE_POINTER [INTEGER_8]; a___c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strrchr (a___s.c_pointer, a___c))
		end

	c_strrchr (a___s: POINTER; a___c: INTEGER_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strrchr($a___s, $a___c);"
		end

	strstr (a___haystack: CE_POINTER [INTEGER_8]; a___needle: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strstr (a___haystack.c_pointer, a___needle.c_pointer))
		end

	c_strstr (a___haystack: POINTER; a___needle: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strstr($a___haystack, $a___needle);"
		end

	strtok_r (a___s: CE_POINTER [INTEGER_8]; a___delim: CE_POINTER [INTEGER_8]; a___save_ptr: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strtok_r (a___s.c_pointer, a___delim.c_pointer, a___save_ptr.c_pointer))
		end

	c_strtok_r (a___s: POINTER; a___delim: POINTER; a___save_ptr: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strtok_r($a___s, $a___delim, $a___save_ptr);"
		end

end
