class
	PD_DOPRNT_FUNS_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create format.make
			create memory.make
			create reps.make
			create final.make
		end

feature {ANY} -- fields

	format: CE_ROUTINE assign set_format

	memory: CE_ROUTINE assign set_memory

	reps: CE_ROUTINE assign set_reps

	final: CE_ROUTINE assign set_final

feature {ANY} -- setters

	set_format (a_format: CE_ROUTINE)
		do
			format := a_format
			update_memory_field ("format")
		end

	set_memory (a_memory: CE_ROUTINE)
		do
			memory := a_memory
			update_memory_field ("memory")
		end

	set_reps (a_reps: CE_ROUTINE)
		do
			reps := a_reps
			update_memory_field ("reps")
		end

	set_final (a_final: CE_ROUTINE)
		do
			final := a_final
			update_memory_field ("final")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			format := a_other.format
			memory := a_other.memory
			reps := a_other.reps
			final := a_other.final
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				format.is_equal (a_other.format) and
				memory.is_equal (a_other.memory) and
				reps.is_equal (a_other.reps) and
				final.is_equal (a_other.final)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("format"),
					create {CE_STRUCTURE_FIELD}.make ("memory"),
					create {CE_STRUCTURE_FIELD}.make ("reps"),
					create {CE_STRUCTURE_FIELD}.make ("final")
				>>)
			init_structure_info
		end

end
