class
	PD_GMP_ASPRINTF_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create result2.make
			create buf.make
		end

feature {ANY} -- fields

	result2: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_result2

	buf: CE_POINTER [INTEGER_8] assign set_buf

	size: NATURAL_32 assign set_size

	alloc: NATURAL_32 assign set_alloc

feature {ANY} -- setters

	set_result2 (a_result2: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

	set_buf (a_buf: CE_POINTER [INTEGER_8])
		do
			buf := a_buf
			update_memory_field ("buf")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_alloc (a_alloc: NATURAL_32)
		do
			alloc := a_alloc
			update_memory_field ("alloc")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			result2 := a_other.result2
			buf := a_other.buf
			size := a_other.size
			alloc := a_other.alloc
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				result2.is_equal (a_other.result2) and
				buf.is_equal (a_other.buf) and
				size = a_other.size and
				alloc = a_other.alloc
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("result2"),
					create {CE_STRUCTURE_FIELD}.make ("buf"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("alloc")
				>>)
			init_structure_info
		end

end
