class
	PD_GMP_RANDFNPTR_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create randseed_fn.make
			create randget_fn.make
			create randclear_fn.make
			create randiset_fn.make
		end

feature {ANY} -- fields

	randseed_fn: CE_ROUTINE assign set_randseed_fn

	randget_fn: CE_ROUTINE assign set_randget_fn

	randclear_fn: CE_ROUTINE assign set_randclear_fn

	randiset_fn: CE_ROUTINE assign set_randiset_fn

feature {ANY} -- setters

	set_randseed_fn (a_randseed_fn: CE_ROUTINE)
		do
			randseed_fn := a_randseed_fn
			update_memory_field ("randseed_fn")
		end

	set_randget_fn (a_randget_fn: CE_ROUTINE)
		do
			randget_fn := a_randget_fn
			update_memory_field ("randget_fn")
		end

	set_randclear_fn (a_randclear_fn: CE_ROUTINE)
		do
			randclear_fn := a_randclear_fn
			update_memory_field ("randclear_fn")
		end

	set_randiset_fn (a_randiset_fn: CE_ROUTINE)
		do
			randiset_fn := a_randiset_fn
			update_memory_field ("randiset_fn")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			randseed_fn := a_other.randseed_fn
			randget_fn := a_other.randget_fn
			randclear_fn := a_other.randclear_fn
			randiset_fn := a_other.randiset_fn
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				randseed_fn.is_equal (a_other.randseed_fn) and
				randget_fn.is_equal (a_other.randget_fn) and
				randclear_fn.is_equal (a_other.randclear_fn) and
				randiset_fn.is_equal (a_other.randiset_fn)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("randseed_fn"),
					create {CE_STRUCTURE_FIELD}.make ("randget_fn"),
					create {CE_STRUCTURE_FIELD}.make ("randclear_fn"),
					create {CE_STRUCTURE_FIELD}.make ("randiset_fn")
				>>)
			init_structure_info
		end

end
