class
	PD_GMP_SNPRINTF_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create buf.make
		end

feature {ANY} -- fields

	buf: CE_POINTER [INTEGER_8] assign set_buf

	size: NATURAL_32 assign set_size

feature {ANY} -- setters

	set_buf (a_buf: CE_POINTER [INTEGER_8])
		do
			buf := a_buf
			update_memory_field ("buf")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buf := a_other.buf
			size := a_other.size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buf.is_equal (a_other.buf) and
				size = a_other.size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buf"),
					create {CE_STRUCTURE_FIELD}.make ("size")
				>>)
			init_structure_info
		end

end
