class
	PD_MPZ_STRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create mp_d.make
		end

feature {ANY} -- fields

	mp_alloc: INTEGER_32 assign set_mp_alloc

	mp_size: INTEGER_32 assign set_mp_size

	mp_d: CE_POINTER [NATURAL_32] assign set_mp_d

feature {ANY} -- setters

	set_mp_alloc (a_mp_alloc: INTEGER_32)
		do
			mp_alloc := a_mp_alloc
			update_memory_field ("mp_alloc")
		end

	set_mp_size (a_mp_size: INTEGER_32)
		do
			mp_size := a_mp_size
			update_memory_field ("mp_size")
		end

	set_mp_d (a_mp_d: CE_POINTER [NATURAL_32])
		do
			mp_d := a_mp_d
			update_memory_field ("mp_d")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mp_alloc := a_other.mp_alloc
			mp_size := a_other.mp_size
			mp_d := a_other.mp_d
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mp_alloc = a_other.mp_alloc and
				mp_size = a_other.mp_size and
				mp_d.is_equal (a_other.mp_d)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mp_alloc"),
					create {CE_STRUCTURE_FIELD}.make ("mp_size"),
					create {CE_STRUCTURE_FIELD}.make ("mp_d")
				>>)
			init_structure_info
		end

end
