class
	P_AORSMUL_I

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_addmul_ui (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_y: NATURAL_32)
		do
			gmpz_aorsmul_1 ((0).to_integer_32, a_w, a_x___2, a_y)
		end

	gmpz_aorsmul_1 (a_sub: INTEGER_32; a_w: CE_POINTER [PD_MPZ_STRUCT]; a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_y: NATURAL_32)
		local
			l_sub: INTEGER_32
			l_xsize: INTEGER_32
			l_wsize: CE_ARRAY [INTEGER_32]
			l_wsize_signed: INTEGER_32
			l_new_wsize: INTEGER_32
			l_min_size: INTEGER_32
			l_dsize: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_wp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: NATURAL_32
			l_cy2: NATURAL_32
			l___d: CE_POINTER [NATURAL_32]
			l___s: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_32]
			l_tmp___3: CE_POINTER [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy2___0: NATURAL_32
			l___d___0: CE_POINTER [NATURAL_32]
			l___s___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_tmp___5: CE_POINTER [NATURAL_32]
			l___cy: NATURAL_32
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_wsize.make (<<1>>)
			create l_xp.make
			create l_wp.make (<<1>>)
			create l___d.make
			create l___s.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l___ptr_dummy.make (<<1>>)
			create l___d___0.make
			create l___s___0.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l___ptr_dummy___0.make (<<1>>)

			l_sub := a_sub
			l_xsize := (a_x___2.item.mp_size).to_integer_32
			if l_xsize = 0 then
				js.return
			elseif a_y = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_sub := (l_sub).bit_xor (l_xsize)
				if l_xsize >= 0 then
					l_xsize := l_xsize
				else
					l_xsize := -l_xsize
				end
				l_wsize_signed := (a_w.item.mp_size).to_integer_32
				if l_wsize_signed = 0 then
					if (builtin_expect ((l_xsize + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_w, l_xsize + 1).do_nothing
					end
					l_wp.item := a_w.item.mp_d
					l_cy := gmp_inst.gmpn_mul_1 (l_wp.item, a_x___2.item.mp_d, l_xsize, a_y)
					l_wp.item[l_xsize] := l_cy
					l_xsize := l_xsize + (l_cy /= {NATURAL_32} 0).to_integer
					if l_sub >= 0 then
						a_w.item.mp_size := l_xsize.to_integer_32
					else
						a_w.item.mp_size := (-l_xsize).to_integer_32
					end
					js.return
				end
			end
			if not js.return_called then
				l_sub := (l_sub).bit_xor (l_wsize_signed)
				if l_wsize_signed >= 0 then
					l_wsize.item := l_wsize_signed
				else
					l_wsize.item := -l_wsize_signed
				end
				if l_wsize.item > l_xsize then
					l_new_wsize := l_wsize.item
				else
					l_new_wsize := l_xsize
				end
				if (builtin_expect ((l_new_wsize + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_w, l_new_wsize + 1).do_nothing
				end
				l_wp.item := a_w.item.mp_d
				l_xp := a_x___2.item.mp_d
				if l_wsize.item < l_xsize then
					l_min_size := l_wsize.item
				else
					l_min_size := l_xsize
				end
				if l_sub >= 0 then
					l_cy := gmp_inst.gmpn_addmul_1 (l_wp.item, l_xp, l_min_size, a_y)
					l_wp.item := l_wp.item + l_min_size
					l_xp := l_xp + l_min_size
					l_dsize := l_xsize - l_wsize.item
					if l_dsize /= 0 then
						if l_dsize > 0 then
							l_cy2 := gmp_inst.gmpn_mul_1 (l_wp.item, l_xp, l_dsize, a_y)
						else
							l_dsize := -l_dsize
							l_cy2 := (0).to_natural_32
						end
						l_cy := l_cy2 + (gmp_inst.gmpn_add_1 (l_wp.item, l_wp.item, l_dsize, l_cy))
					end
					l_wp.item[l_dsize] := l_cy
					l_new_wsize := l_new_wsize + (l_cy /= {NATURAL_32} 0).to_integer
				else
					l_cy := gmp_inst.gmpn_submul_1 (l_wp.item, l_xp, l_min_size, a_y)
					if l_wsize.item >= l_xsize then
						if l_wsize.item /= l_xsize then
							l_cy := gmp_inst.gmpn_sub_1 (l_wp.item + l_xsize, (l_wp.item + l_xsize), l_wsize.item - l_xsize, l_cy)
						end
						if l_cy /= {NATURAL_32} 0 then
							l_wp.item[l_new_wsize] := ((-l_cy.to_integer_32).to_natural_32).bit_not
							from
							until
								js.loop_done
							loop
								l___d := l_wp.item
								l___s := l_wp.item
								l___n := l_new_wsize
								from
								until
									js.loop_done
								loop
									l_tmp___2 := l___d
									l___d := l___d + 1
									l_tmp___3 := l___s
									l___s := l___s + 1
									l_tmp___2.item := (((l_tmp___3.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
									l___n := l___n - 1
									if not l___n.to_boolean then
										js.break
									end
								end
								js.break
							end
							l_new_wsize := l_new_wsize + 1
							from
							until
								js.loop_done
							loop
								asm3 (l___ptr_dummy, l_wp)
								js.break
							end
							l_wsize_signed := -l_wsize_signed
						end
					else
						from
						until
							js.loop_done
						loop
							l___d___0 := l_wp.item
							l___s___0 := l_wp.item
							l___n___0 := l_wsize.item
							from
							until
								js.loop_done
							loop
								l_tmp___4 := l___d___0
								l___d___0 := l___d___0 + 1
								l_tmp___5 := l___s___0
								l___s___0 := l___s___0 + 1
								l_tmp___4.item := (((l_tmp___5.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l___n___0 := l___n___0 - 1
								if not l___n___0.to_boolean then
									js.break
								end
							end
							js.break
						end
						l_cy := l_cy + (gmp_inst.gmpn_add_1 (l_wp.item, l_wp.item, l_wsize.item, (1).to_natural_32))
						l_cy := l_cy - 1
						l_cy2___0 := (l_cy = {NATURAL_32} 4_294_967_295).to_integer.to_natural_32
						l_cy := l_cy + l_cy2___0
						from
						until
							js.loop_done
						loop
							l___cy := gmp_inst.gmpn_mul_1 (l_wp.item + l_wsize.item, l_xp + l_wsize.item, l_xsize - l_wsize.item, a_y)
							l_cy := l___cy + (gmp_inst.gmpn_add_1 (l_wp.item + l_wsize.item, (l_wp.item + l_wsize.item), l_xsize - l_wsize.item, l_cy))
							js.break
						end
						l_wp.item[l_new_wsize] := l_cy
						l_new_wsize := l_new_wsize + (l_cy /= {NATURAL_32} 0).to_integer
						if l_cy2___0.to_boolean then
							from
							until
								js.loop_done
							loop
								asm4 (l___ptr_dummy___0, l_wp, l_wsize)
								js.break
							end
						end
						l_wsize_signed := -l_wsize_signed
					end
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_new_wsize > 0))
						loop
							if l_wp.item[(l_new_wsize - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_new_wsize := l_new_wsize - 1
							end
						end
						js.break
					end
				end
				if l_wsize_signed >= 0 then
					a_w.item.mp_size := l_new_wsize.to_integer_32
				else
					a_w.item.mp_size := (-l_new_wsize).to_integer_32
				end
			end
		end

	gmpz_submul_ui (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_y: NATURAL_32)
		do
			gmpz_aorsmul_1 ((-1).to_integer_32, a_w, a_x___2, (a_y).bit_and ({NATURAL_32} 4_294_967_295))
		end

end
