class
	P_CMP_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_cmp_ui (a_u: CE_POINTER [PD_MPF_STRUCT]; a_vval: NATURAL_32): INTEGER_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_uexp: INTEGER_32
			l_ulimb: NATURAL_32
			js: JUMP_STATE
		do
			create l_up.make

			l_uexp := a_u.item.mp_exp
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize < 0 then
				Result := (-1)
				js.return
			end
			if not js.return_called and then (a_vval = {NATURAL_32} 0) then
				Result := (l_usize /= 0).to_integer
				js.return
			end
			if not js.return_called and then (l_uexp > 1) then
				Result := 1
				js.return
			end
			if not js.return_called and then (l_uexp < 1) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_up := a_u.item.mp_d
				l_ulimb := l_up[(l_usize - 1)]
				l_usize := l_usize - 1
				if l_ulimb > a_vval then
					Result := 1
					js.return
				elseif l_ulimb < a_vval then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				from
				until
					l_up.item /= {NATURAL_32} 0
				loop
					l_up := l_up + 1
					l_usize := l_usize - 1
				end
				if l_usize > 0 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gmpq_cmp_ui (a_op1: CE_POINTER [PD_MPQ_STRUCT]; a_num2: NATURAL_32; a_den2: NATURAL_32): INTEGER_32
		local
			l_num1_size: INTEGER_32
			l_den1_size: INTEGER_32
			l_tmp1_size: INTEGER_32
			l_tmp2_size: INTEGER_32
			l_tmp1_ptr: CE_POINTER [NATURAL_32]
			l_tmp2_ptr: CE_POINTER [NATURAL_32]
			l_cy_limb: NATURAL_32
			l_cc: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tmp1_ptr.make
			create l_tmp2_ptr.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make
			create l_tmp___7.make

			l_num1_size := (a_op1.item.mp_num.mp_size).to_integer_32
			l_den1_size := (a_op1.item.mp_den.mp_size).to_integer_32
			if a_den2 = {NATURAL_32} 0 then
				errno_inst.gmp_divide_by_zero
			end
			if l_num1_size = 0 then
				Result := (-(a_num2 /= {NATURAL_32} 0).to_integer).to_integer
				js.return
			end
			if not js.return_called and then (l_num1_size < 0) then
				Result := l_num1_size.to_integer_32
				js.return
			end
			if not js.return_called and then (a_num2 = {NATURAL_32} 0) then
				Result := l_num1_size.to_integer_32
				js.return
			end
			if not js.return_called and then (l_num1_size > l_den1_size + 1) then
				Result := l_num1_size.to_integer_32
				js.return
			end
			if not js.return_called and then (l_den1_size > l_num1_size + 1) then
				Result := (-l_num1_size).to_integer_32
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				if (builtin_expect (((l_num1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new (((l_num1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_num1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_tmp1_ptr := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
				if (builtin_expect (((l_den1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___7 := (l_aaf.new (((l_den1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___7 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_den1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_tmp2_ptr := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7)
				l_cy_limb := gmp_inst.gmpn_mul_1 (l_tmp1_ptr, a_op1.item.mp_num.mp_d, l_num1_size, a_den2)
				l_tmp1_ptr[l_num1_size] := l_cy_limb
				l_tmp1_size := l_num1_size + (l_cy_limb /= {NATURAL_32} 0).to_integer
				l_cy_limb := gmp_inst.gmpn_mul_1 (l_tmp2_ptr, a_op1.item.mp_den.mp_d, l_den1_size, a_num2)
				l_tmp2_ptr[l_den1_size] := l_cy_limb
				l_tmp2_size := l_den1_size + (l_cy_limb /= {NATURAL_32} 0).to_integer
				if l_tmp1_size - l_tmp2_size /= 0 then
					l_cc := (l_tmp1_size - l_tmp2_size).to_integer_32
				else
					l_cc := (gmp_inst.gmpn_cmp (l_tmp1_ptr, l_tmp2_ptr, l_tmp1_size))
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
				Result := l_cc
			end
		end

	gmpz_cmp_ui (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v_digit: NATURAL_32): INTEGER_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_ul: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_up.make

			l_up := a_u.item.mp_d
			l_un := (a_u.item.mp_size).to_integer_32
			if l_un = 0 then
				Result := (-(a_v_digit /= {NATURAL_32} 0).to_integer).to_integer
				js.return
			end
			if not js.return_called and then (l_un = 1) then
				l_ul := l_up[0]
				if l_ul > a_v_digit then
					Result := 1
					js.return
				end
				if not js.return_called and then (l_ul < a_v_digit) then
					Result := (-1)
					js.return
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if l_un > 0 then
					l_tmp := 1
				else
					l_tmp := -1
				end
				Result := l_tmp
			end
		end

end
