class
	P_CMPABS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_cmpabs (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_dsize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_cmp: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_vp.make

			if a_u.item.mp_size >= 0 then
				l_usize := (a_u.item.mp_size).to_integer_32
			else
				l_usize := (-a_u.item.mp_size).to_integer_32
			end
			if a_v.item.mp_size >= 0 then
				l_vsize := (a_v.item.mp_size).to_integer_32
			else
				l_vsize := (-a_v.item.mp_size).to_integer_32
			end
			l_dsize := l_usize - l_vsize
			if l_dsize /= 0 then
				Result := l_dsize.to_integer_32
				js.return
			end
			if not js.return_called then
				l_up := a_u.item.mp_d
				l_vp := a_v.item.mp_d
				from
				until
					js.loop_done
				loop
					l_cmp := 0
					l___gmp_i := l_usize
					from
					until
						js.loop_done
					loop
						l___gmp_i := l___gmp_i - 1
						if not (l___gmp_i >= 0) then
							js.break
						end
						if not js.loop_jumped then
							l___gmp_x := l_up[l___gmp_i]
							l___gmp_y := l_vp[l___gmp_i]
							if l___gmp_x /= l___gmp_y then
								if l___gmp_x > l___gmp_y then
									l_cmp := 1
								else
									l_cmp := -1
								end
								js.break
							end
						end
					end
					js.break
				end
				Result := l_cmp
			end
		end

end
