class
	P_DIVEGCD

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_divexact_gcd (a_q: CE_POINTER [PD_MPZ_STRUCT]; a_a: CE_POINTER [PD_MPZ_STRUCT]; a_d: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_dl: NATURAL_32
			l_twos: INTEGER_32
			js: JUMP_STATE
		do
			if a_d.item.mp_size = 1 then
				l_dl := a_d.item.mp_d[0]
				if l_dl = {NATURAL_32} 1 then
					if not a_q.is_equal (a_a) then
						set_inst.gmpz_set (a_q, a_a)
					end
					js.return
				end
				if not js.return_called and then (l_dl = {NATURAL_32} 3) then
					mpz_divexact_by3 (a_q, a_a)
					js.return
				end
				if not js.return_called then
					from
					until
						js.loop_done
					loop
						l_twos := builtin_ctzl (l_dl)
						js.break
					end
					l_dl := (l_dl).bit_shift_right (l_twos)
					if l_dl = {NATURAL_32} 1 then
						tdiv_q_2exp_inst.gmpz_tdiv_q_2exp (a_q, a_a, l_twos.to_natural_32)
						js.return
					end
				end
				if not js.return_called and then (l_dl = {NATURAL_32} 3) then
					tdiv_q_2exp_inst.gmpz_tdiv_q_2exp (a_q, a_a, l_twos.to_natural_32)
					mpz_divexact_by3 (a_q, a_q)
					js.return
				end
			end
			if not js.return_called then
				divexact_inst.gmpz_divexact (a_q, a_a, a_d)
			end
		end

	mpz_divexact_by3 (a_q: CE_POINTER [PD_MPZ_STRUCT]; a_a: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp___1: NATURAL_32
			js: JUMP_STATE
		do
			create l_qp.make

			l_size := (a_a.item.mp_size).to_integer_32
			if l_size = 0 then
				a_q.item.mp_size := 0
				js.return
			else
				if l_size >= 0 then
					l_tmp := l_size
				else
					l_tmp := -l_size
				end
				l_abs_size := l_tmp
				if (builtin_expect ((l_abs_size > (a_q.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_q, l_abs_size).do_nothing
				end
				l_qp := a_q.item.mp_d
				l_tmp___1 := gmp_impl_inst.gmpn_bdiv_dbm1c (l_qp, a_a.item.mp_d, l_abs_size, {NATURAL_32} 1_431_655_765, (0).to_natural_32)
				l_abs_size := l_abs_size - (l_qp[(l_abs_size - 1)] = {NATURAL_32} 0).to_integer
				if l_size > 0 then
					a_q.item.mp_size := l_abs_size.to_integer_32
				else
					a_q.item.mp_size := (-l_abs_size).to_integer_32
				end
			end
			if not js.return_called then
			end
		end

end
