class
	P_FDIV_QR_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_fdiv_qr_ui (a_quot: CE_POINTER [PD_MPZ_STRUCT]; a_rem: CE_POINTER [PD_MPZ_STRUCT]; a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_qp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rl: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_np.make
			create l_qp.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)

			if a_divisor = {NATURAL_32} 0 then
				errno_inst.gmp_divide_by_zero
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				a_quot.item.mp_size := 0
				a_rem.item.mp_size := 0
				Result := {NATURAL_32} 0
				js.return
			end
			if not js.return_called then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				if (builtin_expect ((l_nn > (a_quot.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_quot, l_nn).do_nothing
				end
				l_qp.item := a_quot.item.mp_d
				l_np := a_dividend.item.mp_d
				l_rl := gmp_inst.gmpn_divrem_1 (l_qp.item, (0).to_integer_32, l_np, l_nn, a_divisor)
				if l_rl = {NATURAL_32} 0 then
					a_rem.item.mp_size := 0
				else
					if l_ns < 0 then
						from
						until
							js.loop_done
						loop
							asm16 (l___ptr_dummy, l_qp)
							js.break
						end
						l_rl := a_divisor - l_rl
					end
					a_rem.item.mp_d[0] := l_rl
					a_rem.item.mp_size := (l_rl /= {NATURAL_32} 0).to_integer
				end
				l_qn := l_nn - (l_qp.item[(l_nn - 1)] = {NATURAL_32} 0).to_integer
				if l_ns >= 0 then
					a_quot.item.mp_size := l_qn.to_integer_32
				else
					a_quot.item.mp_size := (-l_qn).to_integer_32
				end
				Result := l_rl
			end
		end

end
