class
	P_FITS_S

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_fits_sint_p (a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_fs: INTEGER_32
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_fs := (a_f.item.mp_size).to_integer_32
			if l_fs = 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_exp := a_f.item.mp_exp
				if l_exp < 1 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_fp := a_f.item.mp_d
				if l_fs >= 0 then
					l_fn := l_fs
				else
					l_fn := -l_fs
				end
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if l_fs >= 0 then
					l_tmp := (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32
				else
					l_tmp := (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32
				end
				Result := (l_fl <= l_tmp).to_integer
			end
		end

	gmpf_fits_slong_p (a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_fs: INTEGER_32
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_fs := (a_f.item.mp_size).to_integer_32
			if l_fs = 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_exp := a_f.item.mp_exp
				if l_exp < 1 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_fp := a_f.item.mp_d
				if l_fs >= 0 then
					l_fn := l_fs
				else
					l_fn := -l_fs
				end
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if l_fs >= 0 then
					l_tmp := (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32
				else
					l_tmp := (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32
				end
				Result := (l_fl <= l_tmp).to_integer
			end
		end

	gmpf_fits_sshort_p (a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_fs: INTEGER_32
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_fs := (a_f.item.mp_size).to_integer_32
			if l_fs = 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_exp := a_f.item.mp_exp
				if l_exp < 1 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_fp := a_f.item.mp_d
				if l_fs >= 0 then
					l_fn := l_fs
				else
					l_fn := -l_fs
				end
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if l_fs >= 0 then
					l_tmp := ((-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_integer_32 + 1)).to_integer_16).to_natural_32
				else
					l_tmp := (-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_natural_32).to_integer_32).to_natural_32
				end
				Result := (l_fl <= l_tmp).to_integer
			end
		end

	gmpz_fits_sint_p (a_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			js: JUMP_STATE
		do
			create l_p.make

			l_n := (a_z.item.mp_size).to_integer_32
			l_p := a_z.item.mp_d
			l_limb := l_p[0]
			if l_n = 0 then
				Result := 1
				js.return
			end
			if not js.return_called and then (l_n = 1) then
				Result := (l_limb <= (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32).to_integer
				js.return
			end
			if not js.return_called and then (l_n = -1) then
				Result := (l_limb <= (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32).to_integer
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gmpz_fits_slong_p (a_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			js: JUMP_STATE
		do
			create l_p.make

			l_n := (a_z.item.mp_size).to_integer_32
			l_p := a_z.item.mp_d
			l_limb := l_p[0]
			if l_n = 0 then
				Result := 1
				js.return
			end
			if not js.return_called and then (l_n = 1) then
				Result := (l_limb <= (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32).to_integer
				js.return
			end
			if not js.return_called and then (l_n = -1) then
				Result := (l_limb <= (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32).to_integer
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gmpz_fits_sshort_p (a_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			js: JUMP_STATE
		do
			create l_p.make

			l_n := (a_z.item.mp_size).to_integer_32
			l_p := a_z.item.mp_d
			l_limb := l_p[0]
			if l_n = 0 then
				Result := 1
				js.return
			end
			if not js.return_called and then (l_n = 1) then
				Result := (l_limb <= ((-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_integer_32 + 1)).to_integer_16).to_natural_32).to_integer
				js.return
			end
			if not js.return_called and then (l_n = -1) then
				Result := (l_limb <= (-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_natural_32).to_integer_32).to_natural_32).to_integer
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
