class
	P_INV

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpq_inv (a_dest: CE_POINTER [PD_MPQ_STRUCT]; a_src: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_num_size: INTEGER_32
			l_den_size: INTEGER_32
			l_alloc: INTEGER_32
			l_limb_ptr: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_limb_ptr.make

			l_num_size := (a_src.item.mp_num.mp_size).to_integer_32
			l_den_size := (a_src.item.mp_den.mp_size).to_integer_32
			if l_num_size = 0 then
				errno_inst.gmp_divide_by_zero
			end
			if l_num_size < 0 then
				l_num_size := -l_num_size
				l_den_size := -l_den_size
			end
			a_dest.item.mp_den.mp_size := l_num_size.to_integer_32
			a_dest.item.mp_num.mp_size := l_den_size.to_integer_32
			if a_dest.is_equal (a_src) then
				l_alloc := (a_dest.item.mp_num.mp_alloc).to_integer_32
				l_limb_ptr := a_dest.item.mp_num.mp_d
				a_dest.item.mp_num.mp_alloc := a_dest.item.mp_den.mp_alloc
				a_dest.item.mp_num.mp_d := a_dest.item.mp_den.mp_d
				a_dest.item.mp_den.mp_alloc := l_alloc.to_integer_32
				a_dest.item.mp_den.mp_d := l_limb_ptr
			else
				if l_den_size >= 0 then
					l_den_size := l_den_size
				else
					l_den_size := -l_den_size
				end
				if (a_dest.item.mp_num.mp_alloc).to_integer_32 < l_den_size then
					realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dest.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), l_den_size).do_nothing
				end
				if (a_dest.item.mp_den.mp_alloc).to_integer_32 < l_num_size then
					realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dest.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), l_num_size).do_nothing
				end
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (a_dest.item.mp_num.mp_d, a_src.item.mp_den.mp_d, l_den_size)
						js.break
					end
					js.break
				end
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (a_dest.item.mp_den.mp_d, a_src.item.mp_num.mp_d, l_num_size)
						js.break
					end
					js.break
				end
			end
		end

end
