class
	P_KRONSZ

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_si_kronecker (a_a: INTEGER_32; a_b: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_b_ptr: CE_POINTER [NATURAL_32]
			l_b_low: NATURAL_32
			l_b_size: INTEGER_32
			l_b_abs_size: INTEGER_32
			l_a_limb: NATURAL_32
			l_b_rem: NATURAL_32
			l_twos: NATURAL_32
			l_result_bit1: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l___a_ptr: CE_POINTER [NATURAL_32]
			l___a_size: INTEGER_32
			l___b: NATURAL_32
			js: JUMP_STATE
		do
			create l_b_ptr.make
			create l___a_ptr.make

			l_b_size := (a_b.item.mp_size).to_integer_32
			if l_b_size = 0 then
				Result := (((a_a = 1).to_integer).bit_or ((a_a = -1).to_integer))
				js.return
			end
			if not js.return_called then
				l_result_bit1 := ((((a_a < 0).to_integer).bit_and ((l_b_size < 0).to_integer))).bit_shift_left (1)
				l_b_ptr := a_b.item.mp_d
				l_b_low := l_b_ptr[0]
				if l_b_size >= 0 then
					l_b_abs_size := l_b_size
				else
					l_b_abs_size := -l_b_size
				end
				if ((l_b_low).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
					l_result_bit1 := (l_result_bit1).bit_xor ((((((a_a < 0).to_integer).bit_shift_left (1))).bit_and (l_b_low.to_integer_32)))
					if a_a >= 0 then
						l_tmp := a_a
					else
						l_tmp := -a_a
					end
					l_a_limb := l_tmp.to_natural_32
					if ((l_a_limb).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
						if l_a_limb = {NATURAL_32} 0 then
							if l_b_abs_size = 1 then
								if l_b_low = {NATURAL_32} 1 then
									l_tmp___0 := 1
								else
									l_tmp___0 := 0
								end
							else
								l_tmp___0 := 0
							end
							Result := l_tmp___0
							js.return
						end
						if not js.return_called then
							from
							until
								js.loop_done
							loop
								l_twos := (builtin_ctzl (l_a_limb)).to_natural_32
								js.break
							end
							l_a_limb := (l_a_limb).bit_shift_right (l_twos.to_integer_32)
							l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos).bit_shift_left (1)).to_integer_32).bit_and (((((l_b_low).bit_shift_right (1))).bit_xor (l_b_low)).to_integer_32)))
						end
					end
				else
					if ((a_a).bit_and (1)) = 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								if not (builtin_expect ((l_b_low = {NATURAL_32} 0).to_integer, 0)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_b_abs_size := l_b_abs_size - 1
									l_b_ptr := l_b_ptr + 1
									l_b_low := l_b_ptr.item
								end
							end
							js.break
						end
						if ((l_b_low).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							if (builtin_expect ((l_b_low = ({NATURAL_32} 1).bit_shift_left (31)).to_integer, 0)).to_boolean then
								if l_b_abs_size = 1 then
									l_result_bit1 := (l_result_bit1).bit_xor (((((a_a).bit_shift_right (1))).bit_xor (a_a)).to_integer_32)
									Result := (1 - ((l_result_bit1).bit_and (2)))
									js.return
								end
								if not js.return_called then
									l_b_low := ((l_b_ptr[1]).bit_shift_left (1))
								end
							else
								from
								until
									js.loop_done
								loop
									l_twos := (builtin_ctzl (l_b_low)).to_natural_32
									js.break
								end
								l_b_low := (l_b_low).bit_shift_right (l_twos.to_integer_32)
							end
						end
					end
					if not js.return_called then
						l_result_bit1 := (l_result_bit1).bit_xor ((((((a_a < 0).to_integer).bit_shift_left (1))).bit_and (l_b_low.to_integer_32)))
						if a_a >= 0 then
							l_tmp___5 := a_a
						else
							l_tmp___5 := -a_a
						end
						l_a_limb := l_tmp___5.to_natural_32
					end
				end
			end
			if not js.return_called and then (l_a_limb = {NATURAL_32} 1) then
				Result := (1 - ((l_result_bit1).bit_and (2)))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l___a_ptr := l_b_ptr
					l___a_size := l_b_abs_size
					l___b := l_a_limb
					if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l___a_size >= 22 then
							l_b_rem := mod_1_inst.gmpn_mod_1 (l___a_ptr, l___a_size, l___b)
						else
							l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
							l_b_rem := gmp_impl_inst.gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
						end
					else
						l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
						l_b_rem := gmp_impl_inst.gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
					end
					js.break
				end
				l_result_bit1 := (l_result_bit1).bit_xor (((l_a_limb).bit_and (l_b_low)).to_integer_32)
				Result := (jacbase_inst.gmpn_jacobi_base (l_b_rem, l_a_limb, l_result_bit1))
			end
		end

end
