class
	P_KRONZU

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_kronecker_ui (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_b: NATURAL_32): INTEGER_32
		local
			l_b: NATURAL_32
			l_a_ptr: CE_POINTER [NATURAL_32]
			l_a_size: INTEGER_32
			l_a_rem: NATURAL_32
			l_result_bit1: INTEGER_32
			l_blimbs: CE_ARRAY [NATURAL_32]
			l_bz: CE_ARRAY [PD_MPZ_STRUCT]
			l_a_low: NATURAL_32
			l_twos: INTEGER_32
			l_tmp___0: INTEGER_32
			l___a_ptr: CE_POINTER [NATURAL_32]
			l___a_size: INTEGER_32
			l___b: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_a_ptr.make
			create l_blimbs.make (<<2>>)
			create l_bz.make (<<1>>)
			create l___a_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b := a_b
					l_a_size := (a_a.item.mp_size).to_integer_32
					if l_a_size = 0 then
						Result := (l_b = {NATURAL_32} 1).to_integer
						js.return
					end
					if not js.return_called and then (l_b > {NATURAL_32} 4_294_967_295) then
						l_bz[0].mp_alloc := (({PLATFORM}.Natural_32_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32
						l_bz[0].mp_d := l_blimbs
						set_ui_inst.gmpz_set_ui (l_bz, l_b)
						Result := (jacobi_inst.gmpz_jacobi (a_a, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_bz)))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_a_ptr := a_a.item.mp_d
						if ((l_b).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_result_bit1 := ((((l_a_size < 0).to_integer).bit_shift_left (1))).bit_and (l_b.to_integer_32)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						l_a_low := l_a_ptr[0]
						if l_b /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if l_a_size /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if l_a_size /= -1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_a_low = {NATURAL_32} 1 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_tmp___0 := 0
				when 12 then -- if done
						Result := l_tmp___0
						js.return
				when 13 then -- if done
						if not js.return_called and then (not ((l_a_low).bit_and ({NATURAL_32} 1)).to_boolean) then
							Result := 0
							js.return
						end
						if not js.return_called then
							from
							until
								js.loop_done
							loop
								l_twos := builtin_ctzl (l_b)
								js.break
							end
							l_b := (l_b).bit_shift_right (l_twos)
							l_result_bit1 := (((((l_twos).bit_shift_left (1))).bit_and (((((l_a_low).bit_shift_right (1))).bit_xor (l_a_low)).to_integer_32))).bit_xor ((((((l_a_size < 0).to_integer).bit_shift_left (1))).bit_and (l_b.to_integer_32)))
						end
				when 14 then -- if done | if done
						if not js.return_called and then (l_b = {NATURAL_32} 1) then
							Result := (1 - ((l_result_bit1).bit_and (2)))
							js.return
						end
						if not js.return_called then
							if l_a_size >= 0 then
								l_a_size := l_a_size
							else
								l_a_size := -l_a_size
							end
							from
							until
								js.loop_done
							loop
								l___a_ptr := l_a_ptr
								l___a_size := l_a_size
								l___b := l_b
								if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l___a_size >= 22 then
										l_a_rem := mod_1_inst.gmpn_mod_1 (l___a_ptr, l___a_size, l___b)
									else
										l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
										l_a_rem := gmp_impl_inst.gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
									end
								else
									l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
									l_a_rem := gmp_impl_inst.gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
								end
								js.break
							end
							Result := (jacbase_inst.gmpn_jacobi_base (l_a_rem, l_b, l_result_bit1))
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
