class
	P_MD_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpq_div_2exp (a_dst: CE_POINTER [PD_MPQ_STRUCT]; a_src: CE_POINTER [PD_MPQ_STRUCT]; a_n: NATURAL_32)
		local
			js: JUMP_STATE
		do
			if a_src.item.mp_num.mp_size = 0 then
				a_dst.item.mp_num.mp_size := 0
				a_dst.item.mp_den.mp_size := 1
				a_dst.item.mp_den.mp_d[0] := (1).to_natural_32
				js.return
			end
			if not js.return_called then
				mord_2exp (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dst.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dst.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_src.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_src.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), a_n)
			end
		end

	gmpq_mul_2exp (a_dst: CE_POINTER [PD_MPQ_STRUCT]; a_src: CE_POINTER [PD_MPQ_STRUCT]; a_n: NATURAL_32)
		do
			mord_2exp (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dst.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dst.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_src.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_src.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), a_n)
		end

	mord_2exp (a_ldst: CE_POINTER [PD_MPZ_STRUCT]; a_rdst: CE_POINTER [PD_MPZ_STRUCT]; a_lsrc: CE_POINTER [PD_MPZ_STRUCT]; a_rsrc: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		local
			l_n: NATURAL_32
			l_rsrc_size: INTEGER_32
			l_len: INTEGER_32
			l_tmp: INTEGER_32
			l_rsrc_ptr: CE_POINTER [NATURAL_32]
			l_p: CE_POINTER [NATURAL_32]
			l_rdst_ptr: CE_POINTER [NATURAL_32]
			l_plow: NATURAL_32
			l_shift: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_rsrc_ptr.make
			create l_p.make
			create l_rdst_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					l_rsrc_size := (a_rsrc.item.mp_size).to_integer_32
					if l_rsrc_size >= 0 then
						l_tmp := l_rsrc_size
					else
						l_tmp := -l_rsrc_size
					end
					l_len := l_tmp
					l_rsrc_ptr := a_rsrc.item.mp_d
					l_p := l_rsrc_ptr
					l_plow := l_p.item
					from
					until
						js.loop_done
					loop
						if l_n >= {NATURAL_32} 32 then
							if l_plow /= {NATURAL_32} 0 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_n := l_n - ({NATURAL_32} 32)
							l_p := l_p + 1
							l_plow := l_p.item
						end
					end
					l_len := l_len - (l_p.distance (l_rsrc_ptr)).to_integer_32
					if (builtin_expect ((l_len > (a_rdst.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_rdst, l_len).do_nothing
					end
					l_rdst_ptr := a_rdst.item.mp_d
					if not (((l_plow).bit_and ({NATURAL_32} 1)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if l_n /= {NATURAL_32} 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if not l_p.is_equal (l_rdst_ptr) then
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyd (l_rdst_ptr, l_p, l_len)
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if l_plow = {NATURAL_32} 0 then
							l_shift := l_n
						else
							from
							until
								js.loop_done
							loop
								l_shift := (builtin_ctzl (l_plow)).to_natural_32
								js.break
							end
							if l_shift < l_n then
								l_shift := l_shift
							else
								l_shift := l_n
							end
						end
						gmp_inst.gmpn_rshift (l_rdst_ptr, l_p, l_len, l_shift.to_natural_32).do_nothing
						l_len := l_len - (l_rdst_ptr[(l_len - 1)] = {NATURAL_32} 0).to_integer
						l_n := l_n - l_shift
				when 7 then -- if done
						if l_rsrc_size >= 0 then
							a_rdst.item.mp_size := l_len.to_integer_32
						else
							a_rdst.item.mp_size := (-l_len).to_integer_32
						end
						if l_n.to_boolean then
							mul_2exp_inst.gmpz_mul_2exp (a_ldst, a_lsrc, l_n)
						elseif not a_ldst.is_equal (a_lsrc) then
							set_inst.gmpz_set (a_ldst, a_lsrc)
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
