class
	P_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_mul (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: CE_POINTER [PD_MPF_STRUCT])
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_sign_product: INTEGER_32
			l_prec: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_rsize: INTEGER_32
			l_cy_limb: NATURAL_32
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_adj: INTEGER_32
			l_tmp___2: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_up.make
			create l_vp.make
			create l___tmp_marker.make (<<1>>)
			create l_rp.make
			create l_tp.make
			create l_tmp___2.make

			l_prec := (a_r.item.mp_prec).to_integer_32
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			l_sign_product := (l_usize).bit_xor (l_vsize)
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			l_up := a_u.item.mp_d
			l_vp := a_v.item.mp_d
			if l_usize > l_prec then
				l_up := l_up + (l_usize - l_prec)
				l_usize := l_prec
			end
			if l_vsize > l_prec then
				l_vp := l_vp + (l_vsize - l_prec)
				l_vsize := l_prec
			end
			if l_usize = 0 then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
			elseif l_vsize = 0 then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
			else
				l_rsize := l_usize + l_vsize
				if (builtin_expect ((l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new ((l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
				if l_usize >= l_vsize then
					l_cy_limb := (gmpn_mul (l_tp, l_up, l_usize, l_vp, l_vsize))
				else
					l_cy_limb := (gmpn_mul (l_tp, l_vp, l_vsize, l_up, l_usize))
				end
				l_adj := (l_cy_limb = {NATURAL_32} 0).to_integer
				l_rsize := l_rsize - l_adj
				l_prec := l_prec + 1
				if l_rsize > l_prec then
					l_tp := l_tp + (l_rsize - l_prec)
					l_rsize := l_prec
				end
				l_rp := a_r.item.mp_d
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_rp, l_tp, l_rsize)
						js.break
					end
					js.break
				end
				a_r.item.mp_exp := ((a_u.item.mp_exp + a_v.item.mp_exp) - l_adj)
				if l_sign_product >= 0 then
					a_r.item.mp_size := l_rsize.to_integer_32
				else
					a_r.item.mp_size := (-l_rsize).to_integer_32
				end
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				js.break
			end
		end

	gmpn_mul (a_prodp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_vp: CE_POINTER [NATURAL_32]; a_vn: INTEGER_32): NATURAL_32
		local
			l_vn: CE_ARRAY [INTEGER_32]
			l_prodp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_up: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_tp: CE_ARRAY [NATURAL_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch: CE_POINTER [NATURAL_32]
			l_cy___0: CE_ARRAY [NATURAL_32]
			l_ws: CE_POINTER [NATURAL_32]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch___0: CE_POINTER [NATURAL_32]
			l_cy___1: CE_ARRAY [NATURAL_32]
			l_ws___0: CE_POINTER [NATURAL_32]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch___1: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l_cy___2: CE_ARRAY [NATURAL_32]
			l_ws___1: CE_POINTER [NATURAL_32]
			l___tmp_marker___0: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___ptr_dummy___5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___6: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_vn.make (<<1>>)
			create l_prodp.make (<<1>>)
			create l_up.make
			create l_tp.make (<<20>>)
			create l_cy.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)
			create l___ptr_dummy___0.make (<<1>>)
			create l_scratch.make
			create l_cy___0.make (<<1>>)
			create l_ws.make
			create l___ptr_dummy___1.make (<<1>>)
			create l___ptr_dummy___2.make (<<1>>)
			create l_scratch___0.make
			create l_cy___1.make (<<1>>)
			create l_ws___0.make
			create l___ptr_dummy___3.make (<<1>>)
			create l___ptr_dummy___4.make (<<1>>)
			create l_scratch___1.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___6.make
			create l_tmp___14.make
			create l_tmp___23.make
			create l_cy___2.make (<<1>>)
			create l_ws___1.make
			create l___tmp_marker___0.make (<<1>>)
			create l___ptr_dummy___5.make (<<1>>)
			create l___ptr_dummy___6.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_vn.item := a_vn
					l_prodp.item := a_prodp
					l_up := a_up
					l_un := a_un
					if l_un /= l_vn.item then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_up.is_equal (a_vp) then
							sqr_inst.gmpn_sqr (l_prodp.item, l_up, l_un)
						else
							mul_n_inst.gmpn_mul_n (l_prodp.item, l_up, a_vp, l_un)
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 3 then -- else:
						if not (l_vn.item < 20) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_un <= 500 then
							gmp_impl_inst.gmpn_mul_basecase (l_prodp.item, l_up, l_un, a_vp, l_vn.item)
						elseif l_vn.item = 1 then
							gmp_impl_inst.gmpn_mul_basecase (l_prodp.item, l_up, l_un, a_vp, l_vn.item)
						else
							gmp_impl_inst.gmpn_mul_basecase (l_prodp.item, l_up, (500).to_integer_32, a_vp, l_vn.item)
							l_prodp.item := l_prodp.item + (500)
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi (l_tp, l_prodp.item, l_vn.item)
									js.break
								end
								js.break
							end
							l_up := l_up + (500)
							l_un := l_un - (500)
							from
							until
								not (not js.loop_done and then (l_un > 500))
							loop
								gmp_impl_inst.gmpn_mul_basecase (l_prodp.item, l_up, (500).to_integer_32, a_vp, l_vn.item)
								l_cy.item := gmp_inst.gmpn_add_n (l_prodp.item, l_prodp.item, create {CE_POINTER [NATURAL_32]}.make_cast (l_tp), l_vn.item)
								from
								until
									js.loop_done
								loop
									asm87 (l___ptr_dummy, l_prodp, l_vn, l_cy)
									js.break
								end
								l_prodp.item := l_prodp.item + (500)
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										gmp_inst.gmpn_copyi (l_tp, l_prodp.item, l_vn.item)
										js.break
									end
									js.break
								end
								l_up := l_up + (500)
								l_un := l_un - (500)
							end
							if l_un > l_vn.item then
								gmp_impl_inst.gmpn_mul_basecase (l_prodp.item, l_up, l_un, a_vp, l_vn.item)
							else
								gmp_impl_inst.gmpn_mul_basecase (l_prodp.item, a_vp, l_vn.item, l_up, l_un)
							end
							l_cy.item := gmp_inst.gmpn_add_n (l_prodp.item, l_prodp.item, create {CE_POINTER [NATURAL_32]}.make_cast (l_tp), l_vn.item)
							from
							until
								js.loop_done
							loop
								asm88 (l___ptr_dummy___0, l_prodp, l_vn, l_cy)
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 6 then -- else:
						if 77 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 40 -- skip if block
						end
				when 7 then -- if:
						if not (l_vn.item >= 77) then
							l_pos := -1 + 38 -- skip if block
						end
				when 8 then -- if:
						if 6_784 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 36 -- skip if block
						end
				when 9 then -- if:
						if not (((l_un + l_vn.item)).bit_shift_right (1) >= 6_784) then
							l_pos := -1 + 34 -- skip if block
						end
				when 10 then -- if:
						if 6_784 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if 3 * l_vn.item >= 6_784 then
							if l_un >= 8 * l_vn.item then
								l___tmp_marker___0.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
								l_ws___1 := create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker___0, (((9 * l_vn.item).bit_shift_right (1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								nussbaumer_mul_inst.gmpn_nussbaumer_mul (l_prodp.item, l_up, 3 * l_vn.item, a_vp, l_vn.item)
								l_un := l_un - (3 * l_vn.item)
								l_up := l_up + (3 * l_vn.item)
								l_prodp.item := l_prodp.item + (3 * l_vn.item)
								from
								until
									not (not js.loop_done and then (2 * l_un >= 7 * l_vn.item))
								loop
									nussbaumer_mul_inst.gmpn_nussbaumer_mul (l_ws___1, l_up, 3 * l_vn.item, a_vp, l_vn.item)
									l_un := l_un - (3 * l_vn.item)
									l_up := l_up + (3 * l_vn.item)
									l_cy___2.item := gmp_inst.gmpn_add_n (l_prodp.item, l_prodp.item, l_ws___1, l_vn.item)
									from
									until
										js.loop_done
									loop
										from
										until
											js.loop_done
										loop
											gmp_inst.gmpn_copyi (l_prodp.item + l_vn.item, (l_ws___1 + l_vn.item), 3 * l_vn.item)
											js.break
										end
										js.break
									end
									from
									until
										js.loop_done
									loop
										asm89 (l___ptr_dummy___5, l_prodp, l_vn, l_cy___2)
										js.break
									end
									l_prodp.item := l_prodp.item + (3 * l_vn.item)
								end
								if l_un < l_vn.item then
									gmpn_mul (l_ws___1, a_vp, l_vn.item, l_up, l_un).do_nothing
								else
									gmpn_mul (l_ws___1, l_up, l_un, a_vp, l_vn.item).do_nothing
								end
								l_cy___2.item := gmp_inst.gmpn_add_n (l_prodp.item, l_prodp.item, l_ws___1, l_vn.item)
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										gmp_inst.gmpn_copyi (l_prodp.item + l_vn.item, (l_ws___1 + l_vn.item), l_un)
										js.break
									end
									js.break
								end
								from
								until
									js.loop_done
								loop
									asm90 (l___ptr_dummy___6, l_prodp, l_vn, l_cy___2)
									js.break
								end
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((not (l___tmp_marker___0.item).is_void).to_integer, 0)).to_boolean then
										tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker___0.item)
									end
									js.break
								end
							else
								nussbaumer_mul_inst.gmpn_nussbaumer_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item)
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 13 then -- else: | _L___3:
						if 182 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 32 -- skip if block
						end
				when 14 then -- if:
						if not (l_vn.item >= 182) then
							l_pos := -1 + 30 -- skip if block
						end
				when 15 then -- if:
						if (12 + 3 * l_un < 4 * l_vn.item) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L___1:
						l_scratch___0 := create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((16 * l_vn.item + 100).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						if 2 * l_un >= 5 * l_vn.item then
							l_ws___0 := create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new ((((7 * l_vn.item).bit_shift_right (1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							if 79 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_vn.item >= 79 then
									toom63_mul_inst.gmpn_toom63_mul (l_prodp.item, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
								else
									toom42_mul_inst.gmpn_toom42_mul (l_prodp.item, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
								end
							else
								toom42_mul_inst.gmpn_toom42_mul (l_prodp.item, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
							end
							l_un := l_un - (2 * l_vn.item)
							l_up := l_up + (2 * l_vn.item)
							l_prodp.item := l_prodp.item + (2 * l_vn.item)
							from
							until
								not (not js.loop_done and then (2 * l_un >= 5 * l_vn.item))
							loop
								if 79 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_vn.item >= 79 then
										toom63_mul_inst.gmpn_toom63_mul (l_ws___0, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
									else
										toom42_mul_inst.gmpn_toom42_mul (l_ws___0, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
									end
								else
									toom42_mul_inst.gmpn_toom42_mul (l_ws___0, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
								end
								l_un := l_un - (2 * l_vn.item)
								l_up := l_up + (2 * l_vn.item)
								l_cy___1.item := gmp_inst.gmpn_add_n (l_prodp.item, l_prodp.item, l_ws___0, l_vn.item)
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										gmp_inst.gmpn_copyi (l_prodp.item + l_vn.item, (l_ws___0 + l_vn.item), 2 * l_vn.item)
										js.break
									end
									js.break
								end
								from
								until
									js.loop_done
								loop
									asm91 (l___ptr_dummy___3, l_prodp, l_vn, l_cy___1)
									js.break
								end
								l_prodp.item := l_prodp.item + (2 * l_vn.item)
							end
							if l_un < l_vn.item then
								gmpn_mul (l_ws___0, a_vp, l_vn.item, l_up, l_un).do_nothing
							else
								gmpn_mul (l_ws___0, l_up, l_un, a_vp, l_vn.item).do_nothing
							end
							l_cy___1.item := gmp_inst.gmpn_add_n (l_prodp.item, l_prodp.item, l_ws___0, l_vn.item)
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi (l_prodp.item + l_vn.item, (l_ws___0 + l_vn.item), l_un)
									js.break
								end
								js.break
							end
							from
							until
								js.loop_done
							loop
								asm92 (l___ptr_dummy___4, l_prodp, l_vn, l_cy___1)
								js.break
							end
						elseif 6 * l_un < 7 * l_vn.item then
							toom33_mul_inst.gmpn_toom33_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
						elseif 2 * l_un < 3 * l_vn.item then
							if 75 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_vn.item >= 75 then
									toom43_mul_inst.gmpn_toom43_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								else
									toom32_mul_inst.gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								end
							else
								toom32_mul_inst.gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
							end
						elseif 6 * l_un < 11 * l_vn.item then
							if 4 * l_un < 7 * l_vn.item then
								if 122 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_vn.item >= 122 then
										toom53_mul_inst.gmpn_toom53_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
									else
										toom32_mul_inst.gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
									end
								else
									toom32_mul_inst.gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								end
							elseif 115 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_vn.item >= 115 then
									toom53_mul_inst.gmpn_toom53_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								else
									toom42_mul_inst.gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								end
							else
								toom42_mul_inst.gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
							end
						elseif 79 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_vn.item >= 79 then
								toom63_mul_inst.gmpn_toom63_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
							else
								toom42_mul_inst.gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
							end
						else
							toom42_mul_inst.gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 18 then -- else:
						l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if 252 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if not (l_vn.item >= 252) then
							l_pos := -1 + 25 -- skip if block
						end
				when 20 then -- if:
						if 381 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if l_vn.item >= 381 then
							if (builtin_expect (((gmp_impl_inst.mpn_toom8h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___23 := (l_aaf.new (((gmp_impl_inst.mpn_toom8h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___23 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((gmp_impl_inst.mpn_toom8h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_scratch___1 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___23)
							toom8h_mul_inst.gmpn_toom8h_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___1)
						else
							l_pos := -1 + 23 -- goto _L
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L:
						if (builtin_expect (((gmp_impl_inst.mpn_toom6h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___14 := (l_aaf.new (((gmp_impl_inst.mpn_toom6h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___14 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((gmp_impl_inst.mpn_toom6h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_scratch___1 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___14)
						toom6h_mul_inst.gmpn_toom6h_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___1)
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L___0
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___0:
						if (builtin_expect (((3 * l_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___6 := (l_aaf.new (((3 * l_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___6 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((3 * l_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_scratch___1 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___6)
						toom44_mul_inst.gmpn_toom44_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___1)
				when 28 then
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							js.break
						end
				when 29 then -- if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						l_pos := -1 + 16 -- goto _L___1
				when 31 then -- if done | if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_pos := -1 + 16 -- goto _L___1
				when 33 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 13 -- goto _L___3
				when 35 then -- if done | if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						l_pos := -1 + 13 -- goto _L___3
				when 37 then -- if done | if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else:
						l_pos := -1 + 40 -- goto _L___4
				when 39 then -- if done | if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L___4:
						l_scratch := create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((16 * l_vn.item + 100).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						if l_un >= 3 * l_vn.item then
							l_ws := create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((4 * l_vn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							toom42_mul_inst.gmpn_toom42_mul (l_prodp.item, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch)
							l_un := l_un - (2 * l_vn.item)
							l_up := l_up + (2 * l_vn.item)
							l_prodp.item := l_prodp.item + (2 * l_vn.item)
							from
							until
								not (not js.loop_done and then (l_un >= 3 * l_vn.item))
							loop
								toom42_mul_inst.gmpn_toom42_mul (l_ws, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch)
								l_un := l_un - (2 * l_vn.item)
								l_up := l_up + (2 * l_vn.item)
								l_cy___0.item := gmp_inst.gmpn_add_n (l_prodp.item, l_prodp.item, l_ws, l_vn.item)
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										gmp_inst.gmpn_copyi (l_prodp.item + l_vn.item, (l_ws + l_vn.item), 2 * l_vn.item)
										js.break
									end
									js.break
								end
								from
								until
									js.loop_done
								loop
									asm93 (l___ptr_dummy___1, l_prodp, l_vn, l_cy___0)
									js.break
								end
								l_prodp.item := l_prodp.item + (2 * l_vn.item)
							end
							if 4 * l_un < 5 * l_vn.item then
								toom22_mul_inst.gmpn_toom22_mul (l_ws, l_up, l_un, a_vp, l_vn.item, l_scratch)
							elseif 4 * l_un < 7 * l_vn.item then
								toom32_mul_inst.gmpn_toom32_mul (l_ws, l_up, l_un, a_vp, l_vn.item, l_scratch)
							else
								toom42_mul_inst.gmpn_toom42_mul (l_ws, l_up, l_un, a_vp, l_vn.item, l_scratch)
							end
							l_cy___0.item := gmp_inst.gmpn_add_n (l_prodp.item, l_prodp.item, l_ws, l_vn.item)
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi (l_prodp.item + l_vn.item, (l_ws + l_vn.item), l_un)
									js.break
								end
								js.break
							end
							from
							until
								js.loop_done
							loop
								asm94 (l___ptr_dummy___2, l_prodp, l_vn, l_cy___0)
								js.break
							end
						elseif 4 * l_un < 5 * l_vn.item then
							toom22_mul_inst.gmpn_toom22_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch)
						elseif 4 * l_un < 7 * l_vn.item then
							toom32_mul_inst.gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch)
						else
							toom42_mul_inst.gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch)
						end
				when 41 then -- if done | if done
						Result := (l_prodp.item[((l_un + l_vn.item) - 1)])
				when 42 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpq_mul (a_prod: CE_POINTER [PD_MPQ_STRUCT]; a_op1: CE_POINTER [PD_MPQ_STRUCT]; a_op2: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_gcd1: CE_ARRAY [PD_MPZ_STRUCT]
			l_gcd2: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp1: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp2: CE_ARRAY [PD_MPZ_STRUCT]
			l_op1_num_size: INTEGER_32
			l_op1_den_size: INTEGER_32
			l_op2_num_size: INTEGER_32
			l_op2_den_size: INTEGER_32
			l_alloc: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___2: CE_POINTER [ANY]
			l___x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___7: CE_POINTER [ANY]
			l___x___1: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___12: CE_POINTER [ANY]
			l___x___2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___17: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_gcd1.make (<<1>>)
			create l_gcd2.make (<<1>>)
			create l_tmp1.make (<<1>>)
			create l_tmp2.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l___x.make
			create l_tmp___2.make
			create l___x___0.make
			create l_tmp___7.make
			create l___x___1.make
			create l_tmp___12.make
			create l___x___2.make
			create l_tmp___17.make

			if a_op1.is_equal (a_op2) then
				gmpz_mul (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_prod.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")))
				gmpz_mul (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_prod.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
				js.return
			end
			if not js.return_called then
				if a_op1.item.mp_num.mp_size >= 0 then
					l_op1_num_size := (a_op1.item.mp_num.mp_size).to_integer_32
				else
					l_op1_num_size := (-a_op1.item.mp_num.mp_size).to_integer_32
				end
				l_op1_den_size := (a_op1.item.mp_den.mp_size).to_integer_32
				if a_op2.item.mp_num.mp_size >= 0 then
					l_op2_num_size := (a_op2.item.mp_num.mp_size).to_integer_32
				else
					l_op2_num_size := (-a_op2.item.mp_num.mp_size).to_integer_32
				end
				l_op2_den_size := (a_op2.item.mp_den.mp_size).to_integer_32
				if l_op1_num_size = 0 then
					a_prod.item.mp_num.mp_size := 0
					a_prod.item.mp_den.mp_d[0] := (1).to_natural_32
					a_prod.item.mp_den.mp_size := 1
					js.return
				elseif l_op2_num_size = 0 then
					a_prod.item.mp_num.mp_size := 0
					a_prod.item.mp_den.mp_d[0] := (1).to_natural_32
					a_prod.item.mp_den.mp_size := 1
					js.return
				end
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				if l_op1_num_size < l_op2_den_size then
					l_alloc := l_op1_num_size
				else
					l_alloc := l_op2_den_size
				end
				from
				until
					js.loop_done
				loop
					l___x := l_gcd1
					l___x.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___2 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l___x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
					js.break
				end
				if l_op2_num_size < l_op1_den_size then
					l_alloc := l_op2_num_size
				else
					l_alloc := l_op1_den_size
				end
				from
				until
					js.loop_done
				loop
					l___x___0 := l_gcd2
					l___x___0.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___7 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___7 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l___x___0.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7)
					js.break
				end
				if l_op1_num_size > l_op2_den_size then
					l_alloc := l_op1_num_size
				else
					l_alloc := l_op2_den_size
				end
				from
				until
					js.loop_done
				loop
					l___x___1 := l_tmp1
					l___x___1.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___12 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___12 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l___x___1.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___12)
					js.break
				end
				if l_op2_num_size > l_op1_den_size then
					l_alloc := l_op2_num_size
				else
					l_alloc := l_op1_den_size
				end
				from
				until
					js.loop_done
				loop
					l___x___2 := l_tmp2
					l___x___2.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___17 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___17 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l___x___2.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___17)
					js.break
				end
				gcd_inst.gmpz_gcd (l_gcd1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
				gcd_inst.gmpz_gcd (l_gcd2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
				divegcd_inst.gmpz_divexact_gcd (l_tmp1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd1))
				divegcd_inst.gmpz_divexact_gcd (l_tmp2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd2))
				gmpz_mul (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_prod.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
				divegcd_inst.gmpz_divexact_gcd (l_tmp1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd1))
				divegcd_inst.gmpz_divexact_gcd (l_tmp2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd2))
				gmpz_mul (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_prod.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

	gmpz_mul (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_wsize: INTEGER_32
			l_sign_product: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_free_me: CE_POINTER [NATURAL_32]
			l_free_me_size: NATURAL_32
			l_cy_limb: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___9: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_u.make
			create l_v.make
			create l_up.make
			create l_vp.make
			create l_wp.make
			create l_free_me.make
			create l___tmp_marker.make (<<1>>)
			create l___mpz_srcptr_swap__tmp.make
			create l_tmp___4.make
			create l_tmp___9.make

			l_u := a_u
			l_v := a_v
			l_usize := (l_u.item.mp_size).to_integer_32
			l_vsize := (l_v.item.mp_size).to_integer_32
			l_sign_product := (l_usize).bit_xor (l_vsize)
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			if l_usize < l_vsize then
				from
				until
					js.loop_done
				loop
					l___mpz_srcptr_swap__tmp := l_u
					l_u := l_v
					l_v := l___mpz_srcptr_swap__tmp
					js.break
				end
				from
				until
					js.loop_done
				loop
					l___mp_size_t_swap__tmp := l_usize
					l_usize := l_vsize
					l_vsize := l___mp_size_t_swap__tmp
					js.break
				end
			end
			if l_vsize = 0 then
				a_w.item.mp_size := 0
				js.return
			end
			if not js.return_called and then (l_vsize = 1) then
				if (builtin_expect ((l_usize + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_w, l_usize + 1).do_nothing
				end
				l_wp := a_w.item.mp_d
				l_cy_limb := gmp_inst.gmpn_mul_1 (l_wp, l_u.item.mp_d, l_usize, l_v.item.mp_d[0])
				l_wp[l_usize] := l_cy_limb
				l_usize := l_usize + (l_cy_limb /= {NATURAL_32} 0).to_integer
				if l_sign_product >= 0 then
					a_w.item.mp_size := l_usize.to_integer_32
				else
					a_w.item.mp_size := (-l_usize).to_integer_32
				end
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_free_me := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_up := l_u.item.mp_d
				l_vp := l_v.item.mp_d
				l_wp := a_w.item.mp_d
				l_wsize := l_usize + l_vsize
				if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
					if l_wp.is_equal (l_up) then
						l_free_me := l_wp
						l_free_me_size := (a_w.item.mp_alloc).to_natural_32
					elseif l_wp.is_equal (l_vp) then
						l_free_me := l_wp
						l_free_me_size := (a_w.item.mp_alloc).to_natural_32
					else
						memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_wp), (a_w.item.mp_alloc * 4).to_natural_32])
					end
					a_w.item.mp_alloc := l_wsize.to_integer_32
					l_wp := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(l_wsize * 4).to_natural_32]))))
					a_w.item.mp_d := l_wp
				elseif l_wp.is_equal (l_up) then
					if (builtin_expect ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___4 := (l_aaf.new ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___4 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_up := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___4)
					if l_wp.is_equal (l_vp) then
						l_vp := l_up
					end
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_up, l_wp, l_usize)
							js.break
						end
						js.break
					end
				elseif l_wp.is_equal (l_vp) then
					if (builtin_expect ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___9 := (l_aaf.new ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___9 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_vp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9)
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_vp, l_wp, l_vsize)
							js.break
						end
						js.break
					end
				end
				if l_up.is_equal (l_vp) then
					sqr_inst.gmpn_sqr (l_wp, l_up, l_usize)
					l_wsize := l_usize + l_vsize
					l_cy_limb := l_wp[(l_wsize - 1)]
				else
					l_cy_limb := gmpn_mul (l_wp, l_up, l_usize, l_vp, l_vsize)
					l_wsize := l_usize + l_vsize
				end
				l_wsize := l_wsize - (l_cy_limb = {NATURAL_32} 0).to_integer
				if l_sign_product < 0 then
					a_w.item.mp_size := (-l_wsize).to_integer_32
				else
					a_w.item.mp_size := l_wsize.to_integer_32
				end
				if not l_free_me.is_void then
					memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_free_me), l_free_me_size * {NATURAL_32} 4])
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
