class
	P_MUL_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_mul_ui (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		local
			l_up: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_usize: INTEGER_32
			l_size: INTEGER_32
			l_prec: INTEGER_32
			l_excess: INTEGER_32
			l_cy_limb: NATURAL_32
			l_vl: NATURAL_32
			l_cbit: NATURAL_32
			l_cin: CE_ARRAY [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_vl_shifted: CE_ARRAY [NATURAL_32]
			l_hi: CE_ARRAY [NATURAL_32]
			l_lo: CE_ARRAY [NATURAL_32]
			l_next_lo: CE_ARRAY [NATURAL_32]
			l_sum: NATURAL_32
			l_i: CE_ARRAY [INTEGER_32]
			l___x: NATURAL_32
			l___y: NATURAL_32
			l___w: NATURAL_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_r: NATURAL_32
			l___gmp_j: INTEGER_32
			l___gmp_j___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_up.make (<<1>>)
			create l_cin.make (<<1>>)
			create l_rp.make
			create l_vl_shifted.make (<<1>>)
			create l_hi.make (<<1>>)
			create l_lo.make (<<1>>)
			create l_next_lo.make (<<1>>)
			create l_i.make (<<1>>)

			l_usize := (a_u.item.mp_size).to_integer_32
			if (builtin_expect ((a_v = {NATURAL_32} 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			elseif (builtin_expect ((l_usize = 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_size := l_usize
				else
					l_size := -l_usize
				end
				l_prec := (a_r.item.mp_prec).to_integer_32
				l_up.item := a_u.item.mp_d
				l_vl := a_v
				l_excess := l_size - l_prec
				l_cin.item := (0).to_natural_32
				if l_excess > 0 then
					l_vl_shifted.item := l_vl
					l_i.item := l_excess - 1
					asm1 (l_lo, l_cin, l_up, l_i, l_vl_shifted)
					from
					until
						js.loop_done
					loop
						l_i.item := l_i.item - 1
						if l_i.item < 0 then
							js.break
						end
						if not js.loop_jumped then
							asm2 (l_next_lo, l_hi, l_up, l_i, l_vl_shifted)
							l_lo.item := l_lo.item
							from
							until
								js.loop_done
							loop
								l___x := l_hi.item
								l___y := l_lo.item
								l___w := l___x + l___y
								l_sum := l___w
								l_cbit := (l___w < l___x).to_integer.to_natural_32
								js.break
							end
							l_cin.item := l_cin.item + l_cbit
							l_lo.item := l_next_lo.item
							if (builtin_expect ((l_sum /= {NATURAL_32} 4_294_967_295).to_integer, 1)).to_boolean then
								js.break
							end
						end
					end
					l_up.item := l_up.item + l_excess
					l_size := l_prec
				end
				l_rp := a_r.item.mp_d
				l_cy_limb := gmp_inst.gmpn_mul_1 (l_rp, l_up.item, l_size, l_vl)
				from
				until
					js.loop_done
				loop
					l___gmp_x := l_rp[0]
					l___gmp_r := l___gmp_x + l_cin.item
					l_rp[0] := l___gmp_r
					if l___gmp_r < l_cin.item then
						l_cbit := (1).to_natural_32
						l___gmp_i := (1).to_integer_32
						from
						until
							not (not js.loop_done and then (l___gmp_i < l_size))
						loop
							l___gmp_x := l_rp[l___gmp_i]
							l___gmp_r := l___gmp_x + {NATURAL_32} 1
							l_rp[l___gmp_i] := l___gmp_r
							l___gmp_i := l___gmp_i + 1
							if not (l___gmp_r < {NATURAL_32} 1) then
								if not l_rp.is_equal (l_rp) then
									from
									until
										js.loop_done
									loop
										l___gmp_j := l___gmp_i
										from
										until
											not (l___gmp_j < l_size)
										loop
											l_rp[l___gmp_j] := l_rp[l___gmp_j]
											l___gmp_j := l___gmp_j + 1
										end
										js.break
									end
								end
								l_cbit := (0).to_natural_32
								js.break
							end
						end
					else
						if not l_rp.is_equal (l_rp) then
							from
							until
								js.loop_done
							loop
								l___gmp_j___0 := (1).to_integer_32
								from
								until
									not (l___gmp_j___0 < l_size)
								loop
									l_rp[l___gmp_j___0] := l_rp[l___gmp_j___0]
									l___gmp_j___0 := l___gmp_j___0 + 1
								end
								js.break
							end
						end
						l_cbit := (0).to_natural_32
					end
					js.break
				end
				l_cy_limb := l_cy_limb + l_cbit
				l_rp[l_size] := l_cy_limb
				l_cy_limb := (l_cy_limb /= {NATURAL_32} 0).to_integer.to_natural_32
				a_r.item.mp_exp := ((a_u.item.mp_exp).to_natural_32 + l_cy_limb).to_integer_32
				l_size := (l_size.to_natural_32 + l_cy_limb).to_integer_32
				if l_usize >= 0 then
					a_r.item.mp_size := l_size.to_integer_32
				else
					a_r.item.mp_size := (-l_size).to_integer_32
				end
			end
		end

end
