class
	P_N_POW_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_n_pow_ui (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_bp: CE_POINTER [NATURAL_32]; a_bsize: INTEGER_32; a_e: NATURAL_32)
		local
			l_bp: CE_POINTER [NATURAL_32]
			l_bsize: INTEGER_32
			l_e: NATURAL_32
			l_rp: CE_POINTER [NATURAL_32]
			l_rtwos_limbs: INTEGER_32
			l_ralloc: INTEGER_32
			l_rsize: INTEGER_32
			l_rneg: INTEGER_32
			l_i: INTEGER_32
			l_cnt: INTEGER_32
			l_btwos: INTEGER_32
			l_r_bp_overlap: INTEGER_32
			l_blimb: NATURAL_32
			l_rl: NATURAL_32
			l_rtwos_bits: NATURAL_32
			l_b_twolimbs: CE_ARRAY [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_bsecond: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___3: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_32]
			l_tp___0: CE_POINTER [NATURAL_32]
			l_talloc: INTEGER_32
			l_tmp___10: CE_POINTER [ANY]
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_cy___0: NATURAL_32
			l_parity: INTEGER_32
			l___p: CE_ARRAY [INTEGER_8]
			l___n___0: CE_ARRAY [NATURAL_32]
			l___mp_ptr_swap__tmp___1: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___2: CE_POINTER [NATURAL_32]
			l_cy___1: NATURAL_32
			l___mp_ptr_swap__tmp___3: CE_POINTER [NATURAL_32]
			l_cy___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_bp.make
			create l_rp.make
			create l_b_twolimbs.make (<<2>>)
			create l___tmp_marker.make (<<1>>)
			create l_tp.make
			create l_tmp___3.make
			create l___dst.make
			create l_tmp___6.make
			create l_tp___0.make
			create l_tmp___10.make
			create l___mp_ptr_swap__tmp.make
			create l___mp_ptr_swap__tmp___0.make
			create l___p.make (<<1>>)
			create l___n___0.make (<<1>>)
			create l___mp_ptr_swap__tmp___1.make
			create l___mp_ptr_swap__tmp___2.make
			create l___mp_ptr_swap__tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bp := a_bp
					l_bsize := a_bsize
					l_e := a_e
					if l_e = {NATURAL_32} 0 then
						a_r.item.mp_d[0] := (1).to_natural_32
						a_r.item.mp_size := 1
						js.return
					end
					if not js.return_called and then (l_bsize = 0) then
						a_r.item.mp_size := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if l_bsize < 0 then
							if ((l_e).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_rneg := l_tmp
						if l_bsize >= 0 then
							l_bsize := l_bsize
						else
							l_bsize := -l_bsize
						end
						l_r_bp_overlap := ((a_r.item.mp_d).is_equal (l_bp)).to_integer
						l_rtwos_limbs := (0).to_integer_32
						l_blimb := l_bp.item
						from
						until
							not (not js.loop_done and then (l_blimb = {NATURAL_32} 0))
						loop
							l_rtwos_limbs := (l_rtwos_limbs.to_natural_32 + l_e).to_integer_32
							l_bsize := l_bsize - 1
							l_bp := l_bp + 1
							l_blimb := l_bp.item
						end
						from
						until
							js.loop_done
						loop
							l_btwos := builtin_ctzl (l_blimb)
							js.break
						end
						l_blimb := (l_blimb).bit_shift_right (l_btwos)
						l_rtwos_bits := l_e * l_btwos.to_natural_32
						l_rtwos_limbs := (l_rtwos_limbs.to_natural_32 + l_rtwos_bits // {NATURAL_32} 32).to_integer_32
						l_rtwos_bits := l_rtwos_bits \\ ({NATURAL_32} 32)
						l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						l_rl := (1).to_natural_32
						if l_bsize /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if: | bsize_1:
						if not (not js.loop_done and then (l_blimb <= (({NATURAL_32} 1).bit_shift_left (16)) - {NATURAL_32} 1)) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if ((l_e).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_rl := l_rl * l_blimb
						end
						l_e := (l_e).bit_shift_right ((1))
						if l_e = {NATURAL_32} 0 then
							l_pos := -1 + 5 -- goto got_rl
						end
				when 4 then
						l_blimb := l_blimb * l_blimb
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- got_rl:
						
						if l_rtwos_bits /= {NATURAL_32} 0 then
							if l_rl /= {NATURAL_32} 1 then
								if (l_rl).bit_shift_right (({NATURAL_32} 32 - l_rtwos_bits).to_integer_32) = {NATURAL_32} 0 then
									l_rl := (l_rl).bit_shift_left (l_rtwos_bits.to_integer_32)
									l_rtwos_bits := (0).to_natural_32
								end
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 7 then -- else:
						if l_bsize /= 2 then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						l_bsecond := l_bp[1]
						if l_btwos /= 0 then
							l_blimb := (l_blimb).bit_or (((((l_bsecond).bit_shift_left ((32 - l_btwos)))).bit_and ({NATURAL_32} 4_294_967_295)))
						end
						l_bsecond := (l_bsecond).bit_shift_right (l_btwos)
						if l_bsecond = {NATURAL_32} 0 then
							l_bsize := (1).to_integer_32
							l_pos := -1 + 2 -- goto bsize_1
						end
				when 9 then
						l_bp := create {CE_POINTER [NATURAL_32]}.make_cast (l_b_twolimbs)
						l_b_twolimbs[0] := l_blimb
						l_b_twolimbs[1] := l_bsecond
						l_blimb := l_bsecond
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 11 then -- else:
						if not (l_r_bp_overlap.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if l_btwos = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L:
						if (builtin_expect ((l_bsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___3 := (l_aaf.new ((l_bsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___3 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_bsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3)
						from
						until
							js.loop_done
						loop
							if l_btwos = 0 then
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										gmp_inst.gmpn_copyi (l_tp, l_bp, l_bsize)
										js.break
									end
									js.break
								end
							else
								gmp_inst.gmpn_rshift (l_tp, l_bp, l_bsize, l_btwos.to_natural_32).do_nothing
								l_bsize := l_bsize - (l_tp[(l_bsize - 1)] = {NATURAL_32} 0).to_integer
							end
							js.break
						end
						l_bp := l_tp
				when 16 then -- if done
						l_blimb := l_bp[(l_bsize - 1)]
				when 17 then -- if done | if done
						from
						until
							js.loop_done
						loop
							l_cnt := builtin_clzl (l_blimb)
							js.break
						end
						l_ralloc := (((l_bsize * 32 - l_cnt.to_integer_32).to_natural_32 * l_e) // {NATURAL_32} 32 + {NATURAL_32} 5).to_integer_32
						if (builtin_expect ((l_ralloc + l_rtwos_limbs > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							realloc_inst.gmpz_realloc (a_r, l_ralloc + l_rtwos_limbs).do_nothing
						end
						l_rp := a_r.item.mp_d
						from
						until
							js.loop_done
						loop
							if l_rtwos_limbs /= 0 then
								l___dst := l_rp
								l___n := l_rtwos_limbs
								from
								until
									js.loop_done
								loop
									l_tmp___6 := l___dst
									l___dst := l___dst + 1
									l_tmp___6.item := (0).to_natural_32
									l___n := l___n - 1
									if not l___n.to_boolean then
										js.break
									end
								end
							end
							js.break
						end
						l_rp := l_rp + l_rtwos_limbs
						if l_e = {NATURAL_32} 0 then
							l_rp[0] := l_rl
							l_rsize := (1).to_integer_32
						else
							l_talloc := l_ralloc
							if l_bsize <= 1 then
								l_talloc := l_talloc // (2)
							elseif ((l_e).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								l_talloc := l_talloc // (2)
							end
							if (builtin_expect ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___10 := (l_aaf.new ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___10 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp___0 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___10)
							from
							until
								js.loop_done
							loop
								l_cnt := builtin_clzl (l_e)
								js.break
							end
							l_i := (32 - l_cnt) - 2
							if l_bsize = 1 then
								if ((l_i).bit_and (1)) = 0 then
									from
									until
										js.loop_done
									loop
										from
										until
											js.loop_done
										loop
											l___mp_ptr_swap__tmp := l_rp
											l_rp := l_tp___0
											l_tp___0 := l___mp_ptr_swap__tmp
											js.break
										end
										js.break
									end
								end
								l_rp[0] := l_blimb
								l_rsize := (1).to_integer_32
								from
								until
									not (not js.loop_done and then (l_i >= 0))
								loop
									from
									until
										js.loop_done
									loop
										sqr_inst.gmpn_sqr (l_tp___0, l_rp, l_rsize)
										l_rsize := l_rsize * (2)
										l_rsize := l_rsize - (l_tp___0[(l_rsize - 1)] = {NATURAL_32} 0).to_integer
										js.break
									end
									from
									until
										js.loop_done
									loop
										from
										until
											js.loop_done
										loop
											l___mp_ptr_swap__tmp___0 := l_rp
											l_rp := l_tp___0
											l_tp___0 := l___mp_ptr_swap__tmp___0
											js.break
										end
										js.break
									end
									if ((l_e).bit_and (((1).bit_shift_left (l_i)).to_natural_32)) /= {NATURAL_32} 0 then
										from
										until
											js.loop_done
										loop
											l_cy := gmp_inst.gmpn_mul_1 (l_rp, l_rp, l_rsize, l_blimb)
											l_rp[l_rsize] := l_cy
											l_rsize := l_rsize + (l_cy /= {NATURAL_32} 0).to_integer
											js.break
										end
									end
									l_i := l_i - 1
								end
								if l_rl /= {NATURAL_32} 1 then
									from
									until
										js.loop_done
									loop
										l_cy___0 := gmp_inst.gmpn_mul_1 (l_rp, l_rp, l_rsize, l_rl)
										l_rp[l_rsize] := l_cy___0
										l_rsize := l_rsize + (l_cy___0 /= {NATURAL_32} 0).to_integer
										js.break
									end
								end
							else
								from
								until
									js.loop_done
								loop
									l___n___0.item := l_e
									l___n___0.item := (l___n___0.item).bit_xor (((l___n___0.item).bit_shift_right (16)))
									asm22 (l___p, l___n___0)
									l_parity := (l___p.item).to_integer_32
									js.break
								end
								if ((((l_parity).bit_xor (l_i))).bit_and (1)) /= 0 then
									from
									until
										js.loop_done
									loop
										from
										until
											js.loop_done
										loop
											l___mp_ptr_swap__tmp___1 := l_rp
											l_rp := l_tp___0
											l_tp___0 := l___mp_ptr_swap__tmp___1
											js.break
										end
										js.break
									end
								end
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										gmp_inst.gmpn_copyi (l_rp, l_bp, l_bsize)
										js.break
									end
									js.break
								end
								l_rsize := l_bsize
								from
								until
									not (not js.loop_done and then (l_i >= 0))
								loop
									from
									until
										js.loop_done
									loop
										sqr_inst.gmpn_sqr (l_tp___0, l_rp, l_rsize)
										l_rsize := l_rsize * (2)
										l_rsize := l_rsize - (l_tp___0[(l_rsize - 1)] = {NATURAL_32} 0).to_integer
										js.break
									end
									from
									until
										js.loop_done
									loop
										from
										until
											js.loop_done
										loop
											l___mp_ptr_swap__tmp___2 := l_rp
											l_rp := l_tp___0
											l_tp___0 := l___mp_ptr_swap__tmp___2
											js.break
										end
										js.break
									end
									if ((l_e).bit_and (((1).bit_shift_left (l_i)).to_natural_32)) /= {NATURAL_32} 0 then
										from
										until
											js.loop_done
										loop
											l_cy___1 := mul_inst.gmpn_mul (l_tp___0, l_rp, l_rsize, l_bp, l_bsize)
											l_rsize := l_rsize + (l_bsize - (l_cy___1 = {NATURAL_32} 0).to_integer)
											js.break
										end
										from
										until
											js.loop_done
										loop
											from
											until
												js.loop_done
											loop
												l___mp_ptr_swap__tmp___3 := l_rp
												l_rp := l_tp___0
												l_tp___0 := l___mp_ptr_swap__tmp___3
												js.break
											end
											js.break
										end
									end
									l_i := l_i - 1
								end
							end
						end
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							js.break
						end
						if l_rtwos_bits /= {NATURAL_32} 0 then
							from
							until
								js.loop_done
							loop
								l_cy___2 := gmp_inst.gmpn_lshift (l_rp, l_rp, l_rsize, l_rtwos_bits.to_natural_32)
								l_rp[l_rsize] := l_cy___2
								l_rsize := l_rsize + (l_cy___2 /= {NATURAL_32} 0).to_integer
								js.break
							end
						end
						l_rsize := l_rsize + l_rtwos_limbs
						if l_rneg.to_boolean then
							a_r.item.mp_size := (-l_rsize).to_integer_32
						else
							a_r.item.mp_size := l_rsize.to_integer_32
						end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
