class
	P_RANDLC2S

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create gmp_rand_lc_scheme.make (<<18>>)
		end

feature {ANY} -- attributes

	gmp_rand_lc_scheme: CE_ARRAY [PD_GMP_RAND_LC_SCHEME_STRUCT]

feature {ANY} -- routines

	gmp_randinit_lc_2exp_size (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_size: NATURAL_32): INTEGER_32
		local
			l_sp: CE_POINTER [PD_GMP_RAND_LC_SCHEME_STRUCT]
			l_a: CE_ARRAY [PD_MPZ_STRUCT]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_sp.make
			create l_a.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sp := gmp_rand_lc_scheme
				when 1 then -- loop condition:
					if l_sp.item.m2exp = {NATURAL_32} 0 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_sp.item.m2exp // {NATURAL_32} 2 >= a_size then
							l_pos := -1 + 5 -- goto found
						end
				when 3 then
						l_sp := l_sp + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					Result := 0
					js.return
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | found:
						iset_str_inst.gmpz_init_set_str (l_a, l_sp.item.astr, 16).do_nothing
						randlc2x_inst.gmp_randinit_lc_2exp (a_rstate, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_a), l_sp.item.c, l_sp.item.m2exp)
						clear_inst.gmpz_clear (l_a)
						Result := 1
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
