class
	P_SQRTREM

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create invsqrttab.make (<<384>>)
		end

feature {ANY} -- attributes

	invsqrttab: CE_ARRAY [NATURAL_16]

feature {ANY} -- routines

	gmpn_sqrtrem (a_sp: CE_POINTER [NATURAL_32]; a_rp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32): INTEGER_32
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_s0: CE_ARRAY [NATURAL_32]
			l_cc: NATURAL_32
			l_high: NATURAL_32
			l_rl: NATURAL_32
			l_c: INTEGER_32
			l_rn: INTEGER_32
			l_tn: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_r: CE_ARRAY [NATURAL_32]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___6: NATURAL_32
			l_tmp___10: CE_POINTER [ANY]
			l_tmp___12: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_rp.make
			create l_tp.make
			create l_s0.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l_r.make (<<1>>)
			create l_tmp___2.make
			create l_tmp___10.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rp := a_rp
					if a_nn = 0 then
						Result := (0).to_integer_32
						js.return
					end
					if not js.return_called then
						l_high := a_np[(a_nn - 1)]
						if a_nn = 1 then
							if ((l_high).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))).to_boolean then
								a_sp[0] := mpn_sqrtrem1 (l_r, l_high)
								if not l_rp.is_void then
									l_rp[0] := l_r.item
								end
								Result := (l_r.item /= {NATURAL_32} 0).to_integer
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							l_c := builtin_clzl (l_high)
							js.break
						end
						l_c := l_c
						l_c := l_c // (2)
						l_tn := (a_nn + 1) // 2
						l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if a_nn \\ 2 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (l_c > 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if (builtin_expect (((2 * l_tn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___2 := (l_aaf.new (((2 * l_tn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_tn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
						l_tp[0] := (0).to_natural_32
						if l_c /= 0 then
							gmp_inst.gmpn_lshift ((l_tp + 2 * l_tn) - a_nn, a_np, a_nn, (2 * l_c).to_natural_32).do_nothing
						else
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi ((l_tp + 2 * l_tn) - a_nn, a_np, a_nn)
									js.break
								end
								js.break
							end
						end
						l_rl := mpn_dc_sqrtrem (a_sp, l_tp, l_tn)
						l_c := (l_c.to_integer_32 + ((a_nn \\ 2) * 32) // 2).to_integer_32
						l_s0[0] := (a_sp[0]).bit_and (((({NATURAL_32} 1).bit_shift_left (l_c)) - {NATURAL_32} 1))
						l_rl := l_rl + (gmp_inst.gmpn_addmul_1 (l_tp, a_sp, l_tn, {NATURAL_32} 2 * l_s0[0]))
						l_cc := gmp_inst.gmpn_submul_1 (l_tp, create {CE_POINTER [NATURAL_32]}.make_cast (l_s0), (1).to_integer_32, l_s0[0])
						if l_tn > 1 then
							l_tmp___6 := (gmp_inst.gmpn_sub_1 (l_tp + 1, (l_tp + 1), l_tn - 1, l_cc))
						else
							l_tmp___6 := l_cc
						end
						l_rl := l_rl - l_tmp___6
						gmp_inst.gmpn_rshift (a_sp, a_sp, l_tn, l_c.to_natural_32).do_nothing
						l_tp[l_tn] := l_rl
						if l_rp.is_void then
							l_rp := l_tp
						end
						l_c := (l_c).bit_shift_left ((1))
						if l_c < 32 then
							l_tn := l_tn + 1
						else
							l_tp := l_tp + 1
							l_c := l_c - (32)
						end
						if l_c /= 0 then
							gmp_inst.gmpn_rshift (l_rp, l_tp, l_tn, l_c.to_natural_32).do_nothing
						else
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (l_rp, l_tp, l_tn)
								js.break
							end
						end
						l_rn := l_tn
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if l_rp.is_void then
							if (builtin_expect ((a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___10 := (l_aaf.new ((a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___10 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_rp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___10)
						end
						if not l_rp.is_equal (a_np) then
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi (l_rp, a_np, a_nn)
									js.break
								end
								js.break
							end
						end
						l_tmp___12 := mpn_dc_sqrtrem (a_sp, l_rp, l_tn)
						l_rp[l_tn] := l_tmp___12
						l_rn := (l_tn.to_natural_32 + l_tmp___12).to_integer_32
				when 8 then -- if done
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_rn > 0))
							loop
								if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_rn := l_rn - 1
								end
							end
							js.break
						end
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							js.break
						end
						Result := l_rn
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_sqrtrem (a_root: CE_POINTER [PD_MPZ_STRUCT]; a_rem: CE_POINTER [PD_MPZ_STRUCT]; a_op: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_op_size: INTEGER_32
			l_root_size: INTEGER_32
			l_rem_size: INTEGER_32
			l_root_ptr: CE_POINTER [NATURAL_32]
			l_op_ptr: CE_POINTER [NATURAL_32]
			l_free_me: CE_POINTER [NATURAL_32]
			l_free_me_size: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___3: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_root_ptr.make
			create l_op_ptr.make
			create l_free_me.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___3.make

			l_free_me := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_op_size := (a_op.item.mp_size).to_integer_32
			if l_op_size <= 0 then
				if l_op_size < 0 then
					errno_inst.gmp_sqrt_of_negative
				end
				a_root.item.mp_size := 0
				a_rem.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				if (a_rem.item.mp_alloc).to_integer_32 < l_op_size then
					realloc_inst.gmpz_realloc (a_rem, l_op_size).do_nothing
				end
				l_root_size := (l_op_size + 1) // 2
				l_root_ptr := a_root.item.mp_d
				l_op_ptr := a_op.item.mp_d
				if (a_root.item.mp_alloc).to_integer_32 < l_root_size then
					if l_root_ptr.is_equal (l_op_ptr) then
						l_free_me := l_root_ptr
						l_free_me_size := (a_root.item.mp_alloc).to_integer_32
					else
						memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_root_ptr), (a_root.item.mp_alloc * 4).to_natural_32])
					end
					a_root.item.mp_alloc := l_root_size.to_integer_32
					l_root_ptr := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(l_root_size * 4).to_natural_32]))))
					a_root.item.mp_d := l_root_ptr
				elseif l_root_ptr.is_equal (l_op_ptr) then
					if (builtin_expect ((l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___3 := (l_aaf.new ((l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___3 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_op_ptr := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3)
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_op_ptr, l_root_ptr, l_op_size)
							js.break
						end
						js.break
					end
				end
				l_rem_size := gmpn_sqrtrem (l_root_ptr, a_rem.item.mp_d, l_op_ptr, l_op_size)
				a_root.item.mp_size := l_root_size.to_integer_32
				a_rem.item.mp_size := l_rem_size.to_integer_32
				if not l_free_me.is_void then
					memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_free_me), (l_free_me_size * 4).to_natural_32])
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

	mpn_dc_sqrtrem (a_sp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): NATURAL_32
		local
			l_q: NATURAL_32
			l_c: INTEGER_32
			l_b: INTEGER_32
			l_l: INTEGER_32
			l_h: INTEGER_32
			l_tmp___4: NATURAL_32
		do
			if a_n = 1 then
				l_c := (mpn_sqrtrem2 (a_sp, a_np, a_np)).to_integer_32
			else
				l_l := a_n // 2
				l_h := a_n - l_l
				l_q := mpn_dc_sqrtrem (a_sp + l_l, a_np + 2 * l_l, l_h)
				if l_q /= {NATURAL_32} 0 then
					gmp_inst.gmpn_sub_n (a_np + 2 * l_l, (a_np + 2 * l_l), (a_sp + l_l), l_h).do_nothing
				end
				l_q := l_q + (divrem_inst.gmpn_divrem (a_sp, (0).to_integer_32, a_np + l_l, a_n, (a_sp + l_l), l_h))
				l_c := ((a_sp[0]).bit_and ({NATURAL_32} 1)).to_integer_32
				gmp_inst.gmpn_rshift (a_sp, a_sp, l_l, {NATURAL_32} 1).do_nothing
				a_sp[(l_l - 1)] := (a_sp[(l_l - 1)]).bit_or (((((l_q).bit_shift_left (31))).bit_and ({NATURAL_32} 4_294_967_295)))
				l_q := (l_q).bit_shift_right ((1))
				if l_c /= 0 then
					l_c := (gmp_inst.gmpn_add_n (a_np + l_l, (a_np + l_l), (a_sp + l_l), l_h)).to_integer_32
				end
				sqr_inst.gmpn_sqr (a_np + a_n, a_sp, l_l)
				l_b := (l_q + (gmp_inst.gmpn_sub_n (a_np, a_np, (a_np + a_n), 2 * l_l))).to_integer_32
				if l_l = l_h then
					l_tmp___4 := l_b.to_natural_32
				else
					l_tmp___4 := (gmp_inst.gmpn_sub_1 (a_np + 2 * l_l, (a_np + 2 * l_l), (1).to_integer_32, l_b.to_natural_32))
				end
				l_c := (l_c.to_natural_32 - l_tmp___4).to_integer_32
				l_q := gmp_inst.gmpn_add_1 (a_sp + l_l, (a_sp + l_l), l_h, l_q)
				if l_c < 0 then
					l_c := (l_c.to_natural_32 + ((gmp_inst.gmpn_addmul_1 (a_np, a_sp, a_n, (2).to_natural_32)) + {NATURAL_32} 2 * l_q)).to_integer_32
					l_c := (l_c.to_natural_32 - (gmp_inst.gmpn_sub_1 (a_np, a_np, a_n, (1).to_natural_32))).to_integer_32
					l_q := l_q - (gmp_inst.gmpn_sub_1 (a_sp, a_sp, a_n, (1).to_natural_32))
				end
			end
			Result := l_c.to_natural_32
		end

	mpn_sqrtrem1 (a_rp: CE_POINTER [NATURAL_32]; a_a0: NATURAL_32): NATURAL_32
		local
			l_x0: NATURAL_32
			l_t2: NATURAL_32
			l_t: NATURAL_32
			l_x2: NATURAL_32
			l_abits: NATURAL_32
		do
			l_abits := ((a_a0).bit_shift_right (23)).to_natural_32
			l_x0 := (invsqrttab[(l_abits - {NATURAL_32} 128).to_integer_32]).to_natural_32
			l_t2 := l_x0 * ((a_a0).bit_shift_right (8))
			l_t := (l_t2).bit_shift_right (13)
			l_t := ((((((a_a0).bit_shift_left (6)) - l_t * l_t) - {NATURAL_32} 1_048_576).to_integer_32).bit_shift_right (8)).to_natural_32
			l_x0 := l_t2 + (((l_x0 * l_t).to_integer_32).bit_shift_right (7)).to_natural_32
			l_x0 := (l_x0).bit_shift_right ((16))
			l_x2 := l_x0 * l_x0
			if l_x2 + {NATURAL_32} 2 * l_x0 <= a_a0 - {NATURAL_32} 1 then
				l_x2 := l_x2 + ({NATURAL_32} 2 * l_x0 + {NATURAL_32} 1)
				l_x0 := l_x0 + 1
			end
			a_rp.item := a_a0 - l_x2
			Result := l_x0
		end

	mpn_sqrtrem2 (a_sp: CE_POINTER [NATURAL_32]; a_rp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_qhl: NATURAL_32
			l_q: NATURAL_32
			l_u: NATURAL_32
			l_np0: NATURAL_32
			l_sp0: NATURAL_32
			l_rp0: NATURAL_32
			l_q2: NATURAL_32
			l_cc: INTEGER_32
		do
			l_np0 := a_np[0]
			l_sp0 := mpn_sqrtrem1 (a_rp, a_np[1])
			l_qhl := (0).to_natural_32
			l_rp0 := a_rp[0]
			from
			until
				not (l_rp0 >= l_sp0)
			loop
				l_qhl := l_qhl + 1
				l_rp0 := l_rp0 - l_sp0
			end
			l_rp0 := ((l_rp0).bit_shift_left (((32).bit_shift_right (1)))) + ((l_np0).bit_shift_right (((32).bit_shift_right (1))))
			l_u := {NATURAL_32} 2 * l_sp0
			l_q := l_rp0 // l_u
			l_u := l_rp0 - l_q * l_u
			l_q := l_q + ((((l_qhl).bit_and ({NATURAL_32} 1))).bit_shift_left ((((32).bit_shift_right (1)) - 1)))
			l_qhl := (l_qhl).bit_shift_right ((1))
			l_sp0 := (((l_sp0 + l_qhl)).bit_shift_left (((32).bit_shift_right (1)))) + l_q
			l_cc := ((l_u).bit_shift_right (((32).bit_shift_right (1)))).to_integer_32
			l_rp0 := ((((l_u).bit_shift_left (((32).bit_shift_right (1))))).bit_and ({NATURAL_32} 4_294_967_295)) + ((l_np0).bit_and (((({NATURAL_32} 1).bit_shift_left (((32).bit_shift_right (1)))) - {NATURAL_32} 1)))
			l_q2 := l_q * l_q
			l_cc := (l_cc.to_natural_32 - ((l_rp0 < l_q2).to_integer.to_natural_32 + l_qhl)).to_integer_32
			l_rp0 := l_rp0 - l_q2
			if l_cc < 0 then
				if l_sp0 /= {NATURAL_32} 0 then
					l_rp0 := l_rp0 + l_sp0
					l_cc := l_cc + (l_rp0 < l_sp0).to_integer
				else
					l_cc := l_cc + 1
				end
				l_sp0 := l_sp0 - 1
				l_rp0 := l_rp0 + l_sp0
				l_cc := l_cc + (l_rp0 < l_sp0).to_integer
			end
			a_rp[0] := l_rp0
			a_sp[0] := l_sp0
			Result := l_cc.to_natural_32
		end

end
