class
	P_SSCANFFUNS

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create gmp_sscanf_funs.make (<<1>>)
		end

feature {ANY} -- attributes

	gmp_sscanf_funs: CE_ARRAY [PD_GMP_DOSCAN_FUNS_T]

feature {ANY} -- routines

	get (a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make
			create l_tmp.make

			l_s := a_sp.item
			l_tmp := l_s
			l_s := l_s + 1
			l_c := ((l_tmp[0]).to_natural_8).to_integer_32
			if l_c = 0 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				a_sp.item := l_s
				Result := l_c
			end
		end

	get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get)
		end

	scan (a_args: TUPLE [a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_ap: CE_VA_LIST
			l_p1: CE_POINTER [ANY]
			l_p2: CE_POINTER [ANY]
			l_ret: INTEGER_32
		do
			create l_ap.make_shared (default_pointer)
			create l_p1.make
			create l_p2.make

			l_ap := create {CE_VA_LIST}.make (a_args, 3)
			l_p1 := (create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item))
			l_p2 := (create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item))
			l_ret := sscanf ([a_args.a_sp.item, a_args.a_fmt, l_p1, l_p2])
			Result := l_ret
		end

	scan_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent scan)
		end

	step___0 (a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_n: INTEGER_32)
		do
			a_sp.item := a_sp.item + a_n
		end

	step___0_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent step___0)
		end

	unget (a_c: INTEGER_32; a_sp: CE_POINTER [CE_POINTER [INTEGER_8]])
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := a_sp.item
			if a_c = -1 then
				js.return
			end
			if not js.return_called then
				l_s := l_s - 1
				a_sp.item := l_s
			end
		end

	unget_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent unget)
		end

end
