class
	P_TDIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_tdiv_q (a_quot: CE_POINTER [PD_MPZ_STRUCT]; a_num: CE_POINTER [PD_MPZ_STRUCT]; a_den: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_ql: INTEGER_32
			l_ns: INTEGER_32
			l_ds: INTEGER_32
			l_nl: INTEGER_32
			l_dl: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___3: CE_POINTER [ANY]
			l_tp___0: CE_POINTER [NATURAL_32]
			l_tmp___8: CE_POINTER [ANY]
			l_tp___1: CE_POINTER [NATURAL_32]
			l_tmp___13: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_np.make
			create l_dp.make
			create l_qp.make
			create l___tmp_marker.make (<<1>>)
			create l_tp.make
			create l_tmp___3.make
			create l_tp___0.make
			create l_tmp___8.make
			create l_tp___1.make
			create l_tmp___13.make

			l_ns := (a_num.item.mp_size).to_integer_32
			l_ds := (a_den.item.mp_size).to_integer_32
			if l_ns >= 0 then
				l_nl := l_ns
			else
				l_nl := -l_ns
			end
			if l_ds >= 0 then
				l_dl := l_ds
			else
				l_dl := -l_ds
			end
			l_ql := (l_nl - l_dl) + 1
			if l_dl = 0 then
				errno_inst.gmp_divide_by_zero
			end
			if l_ql <= 0 then
				a_quot.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				if (builtin_expect ((l_ql > (a_quot.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_quot, l_ql).do_nothing
				end
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_qp := a_quot.item.mp_d
				l_np := a_num.item.mp_d
				l_dp := a_den.item.mp_d
				if l_dp.is_equal (l_qp) then
					if (builtin_expect ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___3 := (l_aaf.new ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___3 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3)
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_tp, l_dp, l_dl)
							js.break
						end
						js.break
					end
					l_dp := l_tp
				end
				if l_np.is_equal (l_qp) then
					if (builtin_expect (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___8 := (l_aaf.new (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___8 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp___0 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___8)
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_tp___0, l_np, l_nl)
							js.break
						end
						js.break
					end
					div_q_inst.gmpn_div_q (l_qp, l_tp___0, l_nl, l_dp, l_dl, l_tp___0)
				else
					if (builtin_expect (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___13 := (l_aaf.new (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___13 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp___1 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13)
					div_q_inst.gmpn_div_q (l_qp, l_np, l_nl, l_dp, l_dl, l_tp___1)
				end
				l_ql := l_ql - (l_qp[(l_ql - 1)] = {NATURAL_32} 0).to_integer
				if ((l_ns).bit_xor (l_ds)) >= 0 then
					a_quot.item.mp_size := l_ql.to_integer_32
				else
					a_quot.item.mp_size := (-l_ql).to_integer_32
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
