class
	P_TOOM6H_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom6h_mul (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_p: INTEGER_32
			l_q: INTEGER_32
			l_half: INTEGER_32
			l_sign: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
		do
			if a_an * 17 < 18 * a_bn then
				l_q := 6
				l_p := l_q
			elseif (a_an * 5) * 18 < 119 * a_bn then
				l_p := 7
				l_q := 6
			elseif (a_an * 5) * 17 < 126 * a_bn then
				l_p := 7
				l_q := 5
			elseif a_an * 18 < 34 * a_bn then
				l_p := 8
				l_q := 5
			elseif a_an * 17 < 36 * a_bn then
				l_p := 8
				l_q := 4
			else
				l_p := 9
				l_q := 4
			end
			l_half := (((l_p).bit_xor (l_q))).bit_and (1)
			if l_q.to_integer_32 * a_an >= l_p.to_integer_32 * a_bn then
				l_tmp := (a_an - 1).to_natural_32 // (l_p.to_natural_32).to_natural_32
			else
				l_tmp := (a_bn - 1).to_natural_32 // (l_q.to_natural_32).to_natural_32
			end
			l_n := ({NATURAL_32} 1 + l_tmp).to_integer_32
			l_p := l_p - 1
			l_q := l_q - 1
			l_s := a_an - l_p.to_integer_32 * l_n
			l_t := a_bn - l_q.to_integer_32 * l_n
			if l_half.to_boolean then
				if l_s < 1 then
					l_p := l_p - 1
					l_s := l_s + l_n
					l_half := 0
				elseif l_t < 1 then
					l_q := l_q - 1
					l_t := l_t + l_n
					l_half := 0
				end
			end
			l_tmp___0 := toom_eval_pm2rexp_inst.gmpn_toom_eval_pm2rexp ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, {NATURAL_32} 1, a_pp)
			l_sign := (l_tmp___0).bit_xor ((toom_eval_pm2rexp_inst.gmpn_toom_eval_pm2rexp ((a_scratch + 9 * l_n) + 3, (a_pp + 8 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, {NATURAL_32} 1, a_pp)))
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul (a_scratch, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul (a_scratch, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul (a_scratch, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul (a_scratch, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul (a_scratch, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul (a_scratch, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul (a_scratch, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			toom_couple_handling_inst.gmpn_toom_couple_handling (a_scratch, 2 * l_n + 1, a_pp, l_sign, l_n, 1 + l_half, l_half)
			l_sign := toom_eval_pm1_inst.gmpn_toom_eval_pm1 ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, a_pp)
			if l_q = 3 then
				l_sign := (l_sign).bit_xor ((toom_eval_dgr3_pm1_inst.gmpn_toom_eval_dgr3_pm1 ((a_scratch + 9 * l_n) + 3, (a_pp + 8 * l_n) + 1, a_bp, l_n, l_t, a_pp)))
			else
				l_sign := (l_sign).bit_xor ((toom_eval_pm1_inst.gmpn_toom_eval_pm1 ((a_scratch + 9 * l_n) + 3, (a_pp + 8 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, a_pp)))
			end
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			toom_couple_handling_inst.gmpn_toom_couple_handling ((a_scratch + 3 * l_n) + 1, 2 * l_n + 1, a_pp, l_sign, l_n, 0, 0)
			l_tmp___4 := toom_eval_pm2exp_inst.gmpn_toom_eval_pm2exp ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, {NATURAL_32} 2, a_pp)
			l_sign := (l_tmp___4).bit_xor ((toom_eval_pm2exp_inst.gmpn_toom_eval_pm2exp ((a_scratch + 9 * l_n) + 3, (a_pp + 8 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, {NATURAL_32} 2, a_pp)))
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			toom_couple_handling_inst.gmpn_toom_couple_handling ((a_scratch + 6 * l_n) + 2, 2 * l_n + 1, a_pp, l_sign, l_n, 2, 4)
			l_tmp___6 := toom_eval_pm2rexp_inst.gmpn_toom_eval_pm2rexp ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, {NATURAL_32} 2, a_pp)
			l_sign := (l_tmp___6).bit_xor ((toom_eval_pm2rexp_inst.gmpn_toom_eval_pm2rexp ((a_scratch + 9 * l_n) + 3, (a_pp + 8 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, {NATURAL_32} 2, a_pp)))
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul (a_pp + 3 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul (a_pp + 3 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul (a_pp + 3 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul (a_pp + 3 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul (a_pp + 3 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul (a_pp + 3 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul (a_pp + 3 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			toom_couple_handling_inst.gmpn_toom_couple_handling (a_pp + 3 * l_n, 2 * l_n + 1, a_pp, l_sign, l_n, 2 * (1 + l_half), 2 * l_half)
			l_tmp___8 := toom_eval_pm2_inst.gmpn_toom_eval_pm2 ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, a_pp)
			l_sign := (l_tmp___8).bit_xor ((toom_eval_pm2_inst.gmpn_toom_eval_pm2 ((a_scratch + 9 * l_n) + 3, (a_pp + 8 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, a_pp)))
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul (a_pp, (a_pp + 7 * l_n), l_n + 1, ((a_pp + 8 * l_n) + 1), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 252 then
										gmpn_toom6h_mul (a_pp + 7 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									else
										toom44_mul_inst.gmpn_toom44_mul (a_pp + 7 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul (a_pp + 7 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul (a_pp + 7 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul (a_pp + 7 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul (a_pp + 7 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul (a_pp + 7 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, ((a_scratch + 9 * l_n) + 3), l_n + 1, (a_scratch + 10 * l_n) + 4)
				end
				js.break
			end
			toom_couple_handling_inst.gmpn_toom_couple_handling (a_pp + 7 * l_n, 2 * l_n + 1, a_pp, l_sign, l_n, 1, 2)
			from
			until
				js.loop_done
			loop
				if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n >= 77 then
						if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n >= 182 then
								if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n >= 252 then
										gmpn_toom6h_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 9 * l_n) + 3)
									else
										toom44_mul_inst.gmpn_toom44_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 9 * l_n) + 3)
									end
								else
									toom44_mul_inst.gmpn_toom44_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 9 * l_n) + 3)
								end
							else
								toom33_mul_inst.gmpn_toom33_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 9 * l_n) + 3)
							end
						else
							toom33_mul_inst.gmpn_toom33_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 9 * l_n) + 3)
						end
					else
						toom22_mul_inst.gmpn_toom22_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 9 * l_n) + 3)
					end
				else
					toom22_mul_inst.gmpn_toom22_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 9 * l_n) + 3)
				end
				js.break
			end
			if l_half /= 0 then
				if l_s > l_t then
					from
					until
						js.loop_done
					loop
						mul_inst.gmpn_mul (a_pp + 11 * l_n, a_ap + l_p.to_integer_32 * l_n, l_s, a_bp + l_q.to_integer_32 * l_n, l_t).do_nothing
						js.break
					end
				else
					from
					until
						js.loop_done
					loop
						mul_inst.gmpn_mul (a_pp + 11 * l_n, a_bp + l_q.to_integer_32 * l_n, l_t, a_ap + l_p.to_integer_32 * l_n, l_s).do_nothing
						js.break
					end
				end
			end
			toom_interpolate_12pts_inst.gmpn_toom_interpolate_12pts (a_pp, (a_scratch + 6 * l_n) + 2, (a_scratch + 3 * l_n) + 1, a_scratch, l_n, l_s + l_t, l_half, (a_scratch + 9 * l_n) + 3)
		end

end
