class
	SD_TEMP

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	tempint: INTEGER_32 assign set_tempint

	tempptr: CE_POINTER [ANY] assign set_tempptr

feature {ANY} -- setters

	set_tempint (a_tempint: INTEGER_32)
		do
			tempint := a_tempint
			update_memory_field ("tempint")
		end

	set_tempptr (a_tempptr: CE_POINTER [ANY])
		do
			tempptr := a_tempptr
			update_memory_field ("tempptr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tempint := a_other.tempint
			tempptr := a_other.tempptr
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tempint = a_other.tempint and
				tempptr.is_equal (a_other.tempptr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("tempint"),
					create {CE_STRUCTURE_FIELD}.make ("tempptr")
				>>)
			init_structure_info
		end

end
