class
	PD_BRENT_STATE_T2

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	a: REAL_64 assign set_a

	b: REAL_64 assign set_b

	c: REAL_64 assign set_c

	d: REAL_64 assign set_d

	e: REAL_64 assign set_e

	fa: REAL_64 assign set_fa

	fb: REAL_64 assign set_fb

	fc: REAL_64 assign set_fc

feature {ANY} -- setters

	set_a (a_a: REAL_64)
		do
			a := a_a
			update_memory_field ("a")
		end

	set_b (a_b: REAL_64)
		do
			b := a_b
			update_memory_field ("b")
		end

	set_c (a_c: REAL_64)
		do
			c := a_c
			update_memory_field ("c")
		end

	set_d (a_d: REAL_64)
		do
			d := a_d
			update_memory_field ("d")
		end

	set_e (a_e: REAL_64)
		do
			e := a_e
			update_memory_field ("e")
		end

	set_fa (a_fa: REAL_64)
		do
			fa := a_fa
			update_memory_field ("fa")
		end

	set_fb (a_fb: REAL_64)
		do
			fb := a_fb
			update_memory_field ("fb")
		end

	set_fc (a_fc: REAL_64)
		do
			fc := a_fc
			update_memory_field ("fc")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			a := a_other.a
			b := a_other.b
			c := a_other.c
			d := a_other.d
			e := a_other.e
			fa := a_other.fa
			fb := a_other.fb
			fc := a_other.fc
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				a = a_other.a and
				b = a_other.b and
				c = a_other.c and
				d = a_other.d and
				e = a_other.e and
				fa = a_other.fa and
				fb = a_other.fb and
				fc = a_other.fc
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("a"),
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("e"),
					create {CE_STRUCTURE_FIELD}.make ("fa"),
					create {CE_STRUCTURE_FIELD}.make ("fb"),
					create {CE_STRUCTURE_FIELD}.make ("fc")
				>>)
			init_structure_info
		end

end
