class
	PD_CMRG_STATE_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	x1: INTEGER_32 assign set_x1

	x2: INTEGER_32 assign set_x2

	x3: INTEGER_32 assign set_x3

	y1: INTEGER_32 assign set_y1

	y2: INTEGER_32 assign set_y2

	y3: INTEGER_32 assign set_y3

feature {ANY} -- setters

	set_x1 (a_x1: INTEGER_32)
		do
			x1 := a_x1
			update_memory_field ("x1")
		end

	set_x2 (a_x2: INTEGER_32)
		do
			x2 := a_x2
			update_memory_field ("x2")
		end

	set_x3 (a_x3: INTEGER_32)
		do
			x3 := a_x3
			update_memory_field ("x3")
		end

	set_y1 (a_y1: INTEGER_32)
		do
			y1 := a_y1
			update_memory_field ("y1")
		end

	set_y2 (a_y2: INTEGER_32)
		do
			y2 := a_y2
			update_memory_field ("y2")
		end

	set_y3 (a_y3: INTEGER_32)
		do
			y3 := a_y3
			update_memory_field ("y3")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x1 := a_other.x1
			x2 := a_other.x2
			x3 := a_other.x3
			y1 := a_other.y1
			y2 := a_other.y2
			y3 := a_other.y3
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x1 = a_other.x1 and
				x2 = a_other.x2 and
				x3 = a_other.x3 and
				y1 = a_other.y1 and
				y2 = a_other.y2 and
				y3 = a_other.y3
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x1"),
					create {CE_STRUCTURE_FIELD}.make ("x2"),
					create {CE_STRUCTURE_FIELD}.make ("x3"),
					create {CE_STRUCTURE_FIELD}.make ("y1"),
					create {CE_STRUCTURE_FIELD}.make ("y2"),
					create {CE_STRUCTURE_FIELD}.make ("y3")
				>>)
			init_structure_info
		end

end
