class
	PD_EXTRAPOLATION_TABLE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create rlist2.make (<<52>>)
			create res3la.make (<<3>>)
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	rlist2: CE_ARRAY [REAL_64]

	nres: NATURAL_32 assign set_nres

	res3la: CE_ARRAY [REAL_64]

feature {ANY} -- setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_nres (a_nres: NATURAL_32)
		do
			nres := a_nres
			update_memory_field ("nres")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			rlist2 := a_other.rlist2.twin
			nres := a_other.nres
			res3la := a_other.res3la.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				rlist2.is_equal (a_other.rlist2) and
				nres = a_other.nres and
				res3la.is_equal (a_other.res3la)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("rlist2", <<52>>),
					create {CE_STRUCTURE_FIELD}.make ("nres"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("res3la", <<3>>)
				>>)
			init_structure_info
		end

end
