class
	PD_FN_FOURIER_PARAMS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create function.make
		end

feature {ANY} -- fields

	function: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_function

	omega: REAL_64 assign set_omega

feature {ANY} -- setters

	set_function (a_function: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			function := a_function
			update_memory_field ("function")
		end

	set_omega (a_omega: REAL_64)
		do
			omega := a_omega
			update_memory_field ("omega")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			function := a_other.function
			omega := a_other.omega
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				function.is_equal (a_other.function) and
				omega = a_other.omega
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("omega")
				>>)
			init_structure_info
		end

end
