class
	PD_FN_QAWS_PARAMS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create function.make
			create table.make
		end

feature {ANY} -- fields

	function: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_function

	a: REAL_64 assign set_a

	b: REAL_64 assign set_b

	table: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE] assign set_table

feature {ANY} -- setters

	set_function (a_function: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			function := a_function
			update_memory_field ("function")
		end

	set_a (a_a: REAL_64)
		do
			a := a_a
			update_memory_field ("a")
		end

	set_b (a_b: REAL_64)
		do
			b := a_b
			update_memory_field ("b")
		end

	set_table (a_table: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE])
		do
			table := a_table
			update_memory_field ("table")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			function := a_other.function
			a := a_other.a
			b := a_other.b
			table := a_other.table
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				function.is_equal (a_other.function) and
				a = a_other.a and
				b = a_other.b and
				table.is_equal (a_other.table)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("a"),
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("table")
				>>)
			init_structure_info
		end

end
