class
	PD_GSL_DHT_STRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create j.make
			create Jjj.make
			create J2.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	nu: REAL_64 assign set_nu

	xmax: REAL_64 assign set_xmax

	kmax: REAL_64 assign set_kmax

	j: CE_POINTER [REAL_64] assign set_j

	Jjj: CE_POINTER [REAL_64] assign set_Jjj

	J2: CE_POINTER [REAL_64] assign set_J2

feature {ANY} -- setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_nu (a_nu: REAL_64)
		do
			nu := a_nu
			update_memory_field ("nu")
		end

	set_xmax (a_xmax: REAL_64)
		do
			xmax := a_xmax
			update_memory_field ("xmax")
		end

	set_kmax (a_kmax: REAL_64)
		do
			kmax := a_kmax
			update_memory_field ("kmax")
		end

	set_j (a_j: CE_POINTER [REAL_64])
		do
			j := a_j
			update_memory_field ("j")
		end

	set_Jjj (a_Jjj: CE_POINTER [REAL_64])
		do
			Jjj := a_Jjj
			update_memory_field ("Jjj")
		end

	set_J2 (a_J2: CE_POINTER [REAL_64])
		do
			J2 := a_J2
			update_memory_field ("J2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			nu := a_other.nu
			xmax := a_other.xmax
			kmax := a_other.kmax
			j := a_other.j
			Jjj := a_other.Jjj
			J2 := a_other.J2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				nu = a_other.nu and
				xmax = a_other.xmax and
				kmax = a_other.kmax and
				j.is_equal (a_other.j) and
				Jjj.is_equal (a_other.Jjj) and
				J2.is_equal (a_other.J2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("nu"),
					create {CE_STRUCTURE_FIELD}.make ("xmax"),
					create {CE_STRUCTURE_FIELD}.make ("kmax"),
					create {CE_STRUCTURE_FIELD}.make ("j"),
					create {CE_STRUCTURE_FIELD}.make ("Jjj"),
					create {CE_STRUCTURE_FIELD}.make ("J2")
				>>)
			init_structure_info
		end

end
