class
	PD_GSL_EIGEN_HERMV_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create d.make
			create sd.make
			create tau.make
			create gc.make
			create gs.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	d: CE_POINTER [REAL_64] assign set_d

	sd: CE_POINTER [REAL_64] assign set_sd

	tau: CE_POINTER [REAL_64] assign set_tau

	gc: CE_POINTER [REAL_64] assign set_gc

	gs: CE_POINTER [REAL_64] assign set_gs

feature {ANY} -- setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_d (a_d: CE_POINTER [REAL_64])
		do
			d := a_d
			update_memory_field ("d")
		end

	set_sd (a_sd: CE_POINTER [REAL_64])
		do
			sd := a_sd
			update_memory_field ("sd")
		end

	set_tau (a_tau: CE_POINTER [REAL_64])
		do
			tau := a_tau
			update_memory_field ("tau")
		end

	set_gc (a_gc: CE_POINTER [REAL_64])
		do
			gc := a_gc
			update_memory_field ("gc")
		end

	set_gs (a_gs: CE_POINTER [REAL_64])
		do
			gs := a_gs
			update_memory_field ("gs")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			d := a_other.d
			sd := a_other.sd
			tau := a_other.tau
			gc := a_other.gc
			gs := a_other.gs
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				d.is_equal (a_other.d) and
				sd.is_equal (a_other.sd) and
				tau.is_equal (a_other.tau) and
				gc.is_equal (a_other.gc) and
				gs.is_equal (a_other.gs)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("sd"),
					create {CE_STRUCTURE_FIELD}.make ("tau"),
					create {CE_STRUCTURE_FIELD}.make ("gc"),
					create {CE_STRUCTURE_FIELD}.make ("gs")
				>>)
			init_structure_info
		end

end
