class
	PD_GSL_EIGEN_NONSYMMV_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create work.make
			create work2.make
			create work3.make
			create Z.make
			create nonsymm_workspace_p.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	work: CE_POINTER [PD_GSL_VECTOR] assign set_work

	work2: CE_POINTER [PD_GSL_VECTOR] assign set_work2

	work3: CE_POINTER [PD_GSL_VECTOR] assign set_work3

	Z: CE_POINTER [PD_GSL_MATRIX] assign set_Z

	nonsymm_workspace_p: CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE] assign set_nonsymm_workspace_p

feature {ANY} -- setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_work (a_work: CE_POINTER [PD_GSL_VECTOR])
		do
			work := a_work
			update_memory_field ("work")
		end

	set_work2 (a_work2: CE_POINTER [PD_GSL_VECTOR])
		do
			work2 := a_work2
			update_memory_field ("work2")
		end

	set_work3 (a_work3: CE_POINTER [PD_GSL_VECTOR])
		do
			work3 := a_work3
			update_memory_field ("work3")
		end

	set_Z (a_Z: CE_POINTER [PD_GSL_MATRIX])
		do
			Z := a_Z
			update_memory_field ("Z")
		end

	set_nonsymm_workspace_p (a_nonsymm_workspace_p: CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE])
		do
			nonsymm_workspace_p := a_nonsymm_workspace_p
			update_memory_field ("nonsymm_workspace_p")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			work := a_other.work
			work2 := a_other.work2
			work3 := a_other.work3
			Z := a_other.Z
			nonsymm_workspace_p := a_other.nonsymm_workspace_p
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				work.is_equal (a_other.work) and
				work2.is_equal (a_other.work2) and
				work3.is_equal (a_other.work3) and
				Z.is_equal (a_other.Z) and
				nonsymm_workspace_p.is_equal (a_other.nonsymm_workspace_p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("work"),
					create {CE_STRUCTURE_FIELD}.make ("work2"),
					create {CE_STRUCTURE_FIELD}.make ("work3"),
					create {CE_STRUCTURE_FIELD}.make ("Z"),
					create {CE_STRUCTURE_FIELD}.make ("nonsymm_workspace_p")
				>>)
			init_structure_info
		end

end
