class
	PD_GSL_EIGEN_SYMM_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create d.make
			create sd.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	d: CE_POINTER [REAL_64] assign set_d

	sd: CE_POINTER [REAL_64] assign set_sd

feature {ANY} -- setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_d (a_d: CE_POINTER [REAL_64])
		do
			d := a_d
			update_memory_field ("d")
		end

	set_sd (a_sd: CE_POINTER [REAL_64])
		do
			sd := a_sd
			update_memory_field ("sd")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			d := a_other.d
			sd := a_other.sd
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				d.is_equal (a_other.d) and
				sd.is_equal (a_other.sd)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("sd")
				>>)
			init_structure_info
		end

end
