class
	PD_GSL_HISTOGRAM2D

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create xrange.make
			create yrange.make
			create bin.make
		end

feature {ANY} -- fields

	nx: NATURAL_32 assign set_nx

	ny: NATURAL_32 assign set_ny

	xrange: CE_POINTER [REAL_64] assign set_xrange

	yrange: CE_POINTER [REAL_64] assign set_yrange

	bin: CE_POINTER [REAL_64] assign set_bin

feature {ANY} -- setters

	set_nx (a_nx: NATURAL_32)
		do
			nx := a_nx
			update_memory_field ("nx")
		end

	set_ny (a_ny: NATURAL_32)
		do
			ny := a_ny
			update_memory_field ("ny")
		end

	set_xrange (a_xrange: CE_POINTER [REAL_64])
		do
			xrange := a_xrange
			update_memory_field ("xrange")
		end

	set_yrange (a_yrange: CE_POINTER [REAL_64])
		do
			yrange := a_yrange
			update_memory_field ("yrange")
		end

	set_bin (a_bin: CE_POINTER [REAL_64])
		do
			bin := a_bin
			update_memory_field ("bin")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			nx := a_other.nx
			ny := a_other.ny
			xrange := a_other.xrange
			yrange := a_other.yrange
			bin := a_other.bin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				nx = a_other.nx and
				ny = a_other.ny and
				xrange.is_equal (a_other.xrange) and
				yrange.is_equal (a_other.yrange) and
				bin.is_equal (a_other.bin)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("nx"),
					create {CE_STRUCTURE_FIELD}.make ("ny"),
					create {CE_STRUCTURE_FIELD}.make ("xrange"),
					create {CE_STRUCTURE_FIELD}.make ("yrange"),
					create {CE_STRUCTURE_FIELD}.make ("bin")
				>>)
			init_structure_info
		end

end
