class
	PD_GSL_HISTOGRAM_PDF

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create range.make
			create sum.make
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	range: CE_POINTER [REAL_64] assign set_range

	sum: CE_POINTER [REAL_64] assign set_sum

feature {ANY} -- setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_range (a_range: CE_POINTER [REAL_64])
		do
			range := a_range
			update_memory_field ("range")
		end

	set_sum (a_sum: CE_POINTER [REAL_64])
		do
			sum := a_sum
			update_memory_field ("sum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			range := a_other.range
			sum := a_other.sum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				range.is_equal (a_other.range) and
				sum.is_equal (a_other.sum)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("range"),
					create {CE_STRUCTURE_FIELD}.make ("sum")
				>>)
			init_structure_info
		end

end
