class
	PD_GSL_INTEGRATION_QAWS_TABLE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ri.make (<<25>>)
			create rj.make (<<25>>)
			create rg.make (<<25>>)
			create rh.make (<<25>>)
		end

feature {ANY} -- fields

	alpha: REAL_64 assign set_alpha

	beta: REAL_64 assign set_beta

	mu: INTEGER_32 assign set_mu

	nu: INTEGER_32 assign set_nu

	ri: CE_ARRAY [REAL_64]

	rj: CE_ARRAY [REAL_64]

	rg: CE_ARRAY [REAL_64]

	rh: CE_ARRAY [REAL_64]

feature {ANY} -- setters

	set_alpha (a_alpha: REAL_64)
		do
			alpha := a_alpha
			update_memory_field ("alpha")
		end

	set_beta (a_beta: REAL_64)
		do
			beta := a_beta
			update_memory_field ("beta")
		end

	set_mu (a_mu: INTEGER_32)
		do
			mu := a_mu
			update_memory_field ("mu")
		end

	set_nu (a_nu: INTEGER_32)
		do
			nu := a_nu
			update_memory_field ("nu")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			alpha := a_other.alpha
			beta := a_other.beta
			mu := a_other.mu
			nu := a_other.nu
			ri := a_other.ri.twin
			rj := a_other.rj.twin
			rg := a_other.rg.twin
			rh := a_other.rh.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				alpha = a_other.alpha and
				beta = a_other.beta and
				mu = a_other.mu and
				nu = a_other.nu and
				ri.is_equal (a_other.ri) and
				rj.is_equal (a_other.rj) and
				rg.is_equal (a_other.rg) and
				rh.is_equal (a_other.rh)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("alpha"),
					create {CE_STRUCTURE_FIELD}.make ("beta"),
					create {CE_STRUCTURE_FIELD}.make ("mu"),
					create {CE_STRUCTURE_FIELD}.make ("nu"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ri", <<25>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("rj", <<25>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("rg", <<25>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("rh", <<25>>)
				>>)
			init_structure_info
		end

end
