class
	PD_GSL_INTEGRATION_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create alist.make
			create blist.make
			create rlist.make
			create elist.make
			create order.make
			create level.make
		end

feature {ANY} -- fields

	limit: NATURAL_32 assign set_limit

	size: NATURAL_32 assign set_size

	nrmax: NATURAL_32 assign set_nrmax

	i: NATURAL_32 assign set_i

	maximum_level: NATURAL_32 assign set_maximum_level

	alist: CE_POINTER [REAL_64] assign set_alist

	blist: CE_POINTER [REAL_64] assign set_blist

	rlist: CE_POINTER [REAL_64] assign set_rlist

	elist: CE_POINTER [REAL_64] assign set_elist

	order: CE_POINTER [NATURAL_32] assign set_order

	level: CE_POINTER [NATURAL_32] assign set_level

feature {ANY} -- setters

	set_limit (a_limit: NATURAL_32)
		do
			limit := a_limit
			update_memory_field ("limit")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_nrmax (a_nrmax: NATURAL_32)
		do
			nrmax := a_nrmax
			update_memory_field ("nrmax")
		end

	set_i (a_i: NATURAL_32)
		do
			i := a_i
			update_memory_field ("i")
		end

	set_maximum_level (a_maximum_level: NATURAL_32)
		do
			maximum_level := a_maximum_level
			update_memory_field ("maximum_level")
		end

	set_alist (a_alist: CE_POINTER [REAL_64])
		do
			alist := a_alist
			update_memory_field ("alist")
		end

	set_blist (a_blist: CE_POINTER [REAL_64])
		do
			blist := a_blist
			update_memory_field ("blist")
		end

	set_rlist (a_rlist: CE_POINTER [REAL_64])
		do
			rlist := a_rlist
			update_memory_field ("rlist")
		end

	set_elist (a_elist: CE_POINTER [REAL_64])
		do
			elist := a_elist
			update_memory_field ("elist")
		end

	set_order (a_order: CE_POINTER [NATURAL_32])
		do
			order := a_order
			update_memory_field ("order")
		end

	set_level (a_level: CE_POINTER [NATURAL_32])
		do
			level := a_level
			update_memory_field ("level")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			limit := a_other.limit
			size := a_other.size
			nrmax := a_other.nrmax
			i := a_other.i
			maximum_level := a_other.maximum_level
			alist := a_other.alist
			blist := a_other.blist
			rlist := a_other.rlist
			elist := a_other.elist
			order := a_other.order
			level := a_other.level
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				limit = a_other.limit and
				size = a_other.size and
				nrmax = a_other.nrmax and
				i = a_other.i and
				maximum_level = a_other.maximum_level and
				alist.is_equal (a_other.alist) and
				blist.is_equal (a_other.blist) and
				rlist.is_equal (a_other.rlist) and
				elist.is_equal (a_other.elist) and
				order.is_equal (a_other.order) and
				level.is_equal (a_other.level)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("limit"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("nrmax"),
					create {CE_STRUCTURE_FIELD}.make ("i"),
					create {CE_STRUCTURE_FIELD}.make ("maximum_level"),
					create {CE_STRUCTURE_FIELD}.make ("alist"),
					create {CE_STRUCTURE_FIELD}.make ("blist"),
					create {CE_STRUCTURE_FIELD}.make ("rlist"),
					create {CE_STRUCTURE_FIELD}.make ("elist"),
					create {CE_STRUCTURE_FIELD}.make ("order"),
					create {CE_STRUCTURE_FIELD}.make ("level")
				>>)
			init_structure_info
		end

end
