class
	PD_GSL_INTERP_ACCEL

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	cache: NATURAL_32 assign set_cache

	miss_count: NATURAL_32 assign set_miss_count

	hit_count: NATURAL_32 assign set_hit_count

feature {ANY} -- setters

	set_cache (a_cache: NATURAL_32)
		do
			cache := a_cache
			update_memory_field ("cache")
		end

	set_miss_count (a_miss_count: NATURAL_32)
		do
			miss_count := a_miss_count
			update_memory_field ("miss_count")
		end

	set_hit_count (a_hit_count: NATURAL_32)
		do
			hit_count := a_hit_count
			update_memory_field ("hit_count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cache := a_other.cache
			miss_count := a_other.miss_count
			hit_count := a_other.hit_count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cache = a_other.cache and
				miss_count = a_other.miss_count and
				hit_count = a_other.hit_count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cache"),
					create {CE_STRUCTURE_FIELD}.make ("miss_count"),
					create {CE_STRUCTURE_FIELD}.make ("hit_count")
				>>)
			init_structure_info
		end

end
