class
	PD_GSL_MATRIX_FLOAT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
			create block.make
		end

feature {ANY} -- fields

	size1: NATURAL_32 assign set_size1

	size2: NATURAL_32 assign set_size2

	tda: NATURAL_32 assign set_tda

	data: CE_POINTER [REAL_32] assign set_data

	block: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT] assign set_block

	owner: INTEGER_32 assign set_owner

feature {ANY} -- setters

	set_size1 (a_size1: NATURAL_32)
		do
			size1 := a_size1
			update_memory_field ("size1")
		end

	set_size2 (a_size2: NATURAL_32)
		do
			size2 := a_size2
			update_memory_field ("size2")
		end

	set_tda (a_tda: NATURAL_32)
		do
			tda := a_tda
			update_memory_field ("tda")
		end

	set_data (a_data: CE_POINTER [REAL_32])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_block (a_block: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT])
		do
			block := a_block
			update_memory_field ("block")
		end

	set_owner (a_owner: INTEGER_32)
		do
			owner := a_owner
			update_memory_field ("owner")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size1 := a_other.size1
			size2 := a_other.size2
			tda := a_other.tda
			data := a_other.data
			block := a_other.block
			owner := a_other.owner
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size1 = a_other.size1 and
				size2 = a_other.size2 and
				tda = a_other.tda and
				data.is_equal (a_other.data) and
				block.is_equal (a_other.block) and
				owner = a_other.owner
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size1"),
					create {CE_STRUCTURE_FIELD}.make ("size2"),
					create {CE_STRUCTURE_FIELD}.make ("tda"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("owner")
				>>)
			init_structure_info
		end

end
