class
	PD_GSL_MONTE_MISER_PARAMS

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	estimate_frac: REAL_64 assign set_estimate_frac

	min_calls: NATURAL_32 assign set_min_calls

	min_calls_per_bisection: NATURAL_32 assign set_min_calls_per_bisection

	alpha: REAL_64 assign set_alpha

	dither: REAL_64 assign set_dither

feature {ANY} -- setters

	set_estimate_frac (a_estimate_frac: REAL_64)
		do
			estimate_frac := a_estimate_frac
			update_memory_field ("estimate_frac")
		end

	set_min_calls (a_min_calls: NATURAL_32)
		do
			min_calls := a_min_calls
			update_memory_field ("min_calls")
		end

	set_min_calls_per_bisection (a_min_calls_per_bisection: NATURAL_32)
		do
			min_calls_per_bisection := a_min_calls_per_bisection
			update_memory_field ("min_calls_per_bisection")
		end

	set_alpha (a_alpha: REAL_64)
		do
			alpha := a_alpha
			update_memory_field ("alpha")
		end

	set_dither (a_dither: REAL_64)
		do
			dither := a_dither
			update_memory_field ("dither")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			estimate_frac := a_other.estimate_frac
			min_calls := a_other.min_calls
			min_calls_per_bisection := a_other.min_calls_per_bisection
			alpha := a_other.alpha
			dither := a_other.dither
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				estimate_frac = a_other.estimate_frac and
				min_calls = a_other.min_calls and
				min_calls_per_bisection = a_other.min_calls_per_bisection and
				alpha = a_other.alpha and
				dither = a_other.dither
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("estimate_frac"),
					create {CE_STRUCTURE_FIELD}.make ("min_calls"),
					create {CE_STRUCTURE_FIELD}.make ("min_calls_per_bisection"),
					create {CE_STRUCTURE_FIELD}.make ("alpha"),
					create {CE_STRUCTURE_FIELD}.make ("dither")
				>>)
			init_structure_info
		end

end
