class
	PD_GSL_MONTE_VEGAS_PARAMS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ostream.make
		end

feature {ANY} -- fields

	alpha: REAL_64 assign set_alpha

	iterations: NATURAL_32 assign set_iterations

	stage: INTEGER_32 assign set_stage

	mode: INTEGER_32 assign set_mode

	verbose: INTEGER_32 assign set_verbose

	ostream: CE_POINTER [SD_IO_FILE] assign set_ostream

feature {ANY} -- setters

	set_alpha (a_alpha: REAL_64)
		do
			alpha := a_alpha
			update_memory_field ("alpha")
		end

	set_iterations (a_iterations: NATURAL_32)
		do
			iterations := a_iterations
			update_memory_field ("iterations")
		end

	set_stage (a_stage: INTEGER_32)
		do
			stage := a_stage
			update_memory_field ("stage")
		end

	set_mode (a_mode: INTEGER_32)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_verbose (a_verbose: INTEGER_32)
		do
			verbose := a_verbose
			update_memory_field ("verbose")
		end

	set_ostream (a_ostream: CE_POINTER [SD_IO_FILE])
		do
			ostream := a_ostream
			update_memory_field ("ostream")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			alpha := a_other.alpha
			iterations := a_other.iterations
			stage := a_other.stage
			mode := a_other.mode
			verbose := a_other.verbose
			ostream := a_other.ostream
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				alpha = a_other.alpha and
				iterations = a_other.iterations and
				stage = a_other.stage and
				mode = a_other.mode and
				verbose = a_other.verbose and
				ostream.is_equal (a_other.ostream)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("alpha"),
					create {CE_STRUCTURE_FIELD}.make ("iterations"),
					create {CE_STRUCTURE_FIELD}.make ("stage"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("verbose"),
					create {CE_STRUCTURE_FIELD}.make ("ostream")
				>>)
			init_structure_info
		end

end
