class
	PD_GSL_MULTIMIN_FDFMINIMIZER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create type.make
			create fdf.make
			create x.make
			create gradient.make
			create dx.make
			create state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE] assign set_type

	fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT] assign set_fdf

	f: REAL_64 assign set_f

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x

	gradient: CE_POINTER [PD_GSL_VECTOR] assign set_gradient

	dx: CE_POINTER [PD_GSL_VECTOR] assign set_dx

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- setters

	set_type (a_type: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_fdf (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT])
		do
			fdf := a_fdf
			update_memory_field ("fdf")
		end

	set_f (a_f: REAL_64)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_gradient (a_gradient: CE_POINTER [PD_GSL_VECTOR])
		do
			gradient := a_gradient
			update_memory_field ("gradient")
		end

	set_dx (a_dx: CE_POINTER [PD_GSL_VECTOR])
		do
			dx := a_dx
			update_memory_field ("dx")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			fdf := a_other.fdf
			f := a_other.f
			x := a_other.x
			gradient := a_other.gradient
			dx := a_other.dx
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				fdf.is_equal (a_other.fdf) and
				f = a_other.f and
				x.is_equal (a_other.x) and
				gradient.is_equal (a_other.gradient) and
				dx.is_equal (a_other.dx) and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("fdf"),
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("gradient"),
					create {CE_STRUCTURE_FIELD}.make ("dx"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
