class
	PD_GSL_MULTIROOT_FSOLVER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create type.make
			create function.make
			create x.make
			create f.make
			create dx.make
			create state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE] assign set_type

	function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT] assign set_function

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x

	f: CE_POINTER [PD_GSL_VECTOR] assign set_f

	dx: CE_POINTER [PD_GSL_VECTOR] assign set_dx

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- setters

	set_type (a_type: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_function (a_function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT])
		do
			function := a_function
			update_memory_field ("function")
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_f (a_f: CE_POINTER [PD_GSL_VECTOR])
		do
			f := a_f
			update_memory_field ("f")
		end

	set_dx (a_dx: CE_POINTER [PD_GSL_VECTOR])
		do
			dx := a_dx
			update_memory_field ("dx")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			function := a_other.function
			x := a_other.x
			f := a_other.f
			dx := a_other.dx
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				function.is_equal (a_other.function) and
				x.is_equal (a_other.x) and
				f.is_equal (a_other.f) and
				dx.is_equal (a_other.dx) and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("dx"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
