class
	PD_GSL_MULTISET_STRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	k: NATURAL_32 assign set_k

	data: CE_POINTER [NATURAL_32] assign set_data

feature {ANY} -- setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_k (a_k: NATURAL_32)
		do
			k := a_k
			update_memory_field ("k")
		end

	set_data (a_data: CE_POINTER [NATURAL_32])
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			k := a_other.k
			data := a_other.data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				k = a_other.k and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("k"),
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
