class
	PD_GSL_NTUPLE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create file.make
			create ntuple_data.make
		end

feature {ANY} -- fields

	file: CE_POINTER [SD_IO_FILE] assign set_file

	ntuple_data: CE_POINTER [ANY] assign set_ntuple_data

	size: NATURAL_32 assign set_size

feature {ANY} -- setters

	set_file (a_file: CE_POINTER [SD_IO_FILE])
		do
			file := a_file
			update_memory_field ("file")
		end

	set_ntuple_data (a_ntuple_data: CE_POINTER [ANY])
		do
			ntuple_data := a_ntuple_data
			update_memory_field ("ntuple_data")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			file := a_other.file
			ntuple_data := a_other.ntuple_data
			size := a_other.size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				file.is_equal (a_other.file) and
				ntuple_data.is_equal (a_other.ntuple_data) and
				size = a_other.size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("file"),
					create {CE_STRUCTURE_FIELD}.make ("ntuple_data"),
					create {CE_STRUCTURE_FIELD}.make ("size")
				>>)
			init_structure_info
		end

end
