class
	PD_GSL_ODEIV_EVOLVE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create y0.make
			create yerr.make
			create dydt_in.make
			create dydt_out.make
		end

feature {ANY} -- fields

	dimension: NATURAL_32 assign set_dimension

	y0: CE_POINTER [REAL_64] assign set_y0

	yerr: CE_POINTER [REAL_64] assign set_yerr

	dydt_in: CE_POINTER [REAL_64] assign set_dydt_in

	dydt_out: CE_POINTER [REAL_64] assign set_dydt_out

	last_step: REAL_64 assign set_last_step

	count: NATURAL_32 assign set_count

	failed_steps: NATURAL_32 assign set_failed_steps

feature {ANY} -- setters

	set_dimension (a_dimension: NATURAL_32)
		do
			dimension := a_dimension
			update_memory_field ("dimension")
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			y0 := a_y0
			update_memory_field ("y0")
		end

	set_yerr (a_yerr: CE_POINTER [REAL_64])
		do
			yerr := a_yerr
			update_memory_field ("yerr")
		end

	set_dydt_in (a_dydt_in: CE_POINTER [REAL_64])
		do
			dydt_in := a_dydt_in
			update_memory_field ("dydt_in")
		end

	set_dydt_out (a_dydt_out: CE_POINTER [REAL_64])
		do
			dydt_out := a_dydt_out
			update_memory_field ("dydt_out")
		end

	set_last_step (a_last_step: REAL_64)
		do
			last_step := a_last_step
			update_memory_field ("last_step")
		end

	set_count (a_count: NATURAL_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_failed_steps (a_failed_steps: NATURAL_32)
		do
			failed_steps := a_failed_steps
			update_memory_field ("failed_steps")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dimension := a_other.dimension
			y0 := a_other.y0
			yerr := a_other.yerr
			dydt_in := a_other.dydt_in
			dydt_out := a_other.dydt_out
			last_step := a_other.last_step
			count := a_other.count
			failed_steps := a_other.failed_steps
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dimension = a_other.dimension and
				y0.is_equal (a_other.y0) and
				yerr.is_equal (a_other.yerr) and
				dydt_in.is_equal (a_other.dydt_in) and
				dydt_out.is_equal (a_other.dydt_out) and
				last_step = a_other.last_step and
				count = a_other.count and
				failed_steps = a_other.failed_steps
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dimension"),
					create {CE_STRUCTURE_FIELD}.make ("y0"),
					create {CE_STRUCTURE_FIELD}.make ("yerr"),
					create {CE_STRUCTURE_FIELD}.make ("dydt_in"),
					create {CE_STRUCTURE_FIELD}.make ("dydt_out"),
					create {CE_STRUCTURE_FIELD}.make ("last_step"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("failed_steps")
				>>)
			init_structure_info
		end

end
