class
	PD_GSL_ODEIV_SYSTEM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create function.make
			create jacobian.make
			create params.make
		end

feature {ANY} -- fields

	function: CE_ROUTINE assign set_function

	jacobian: CE_ROUTINE assign set_jacobian

	dimension: NATURAL_32 assign set_dimension

	params: CE_POINTER [ANY] assign set_params

feature {ANY} -- setters

	set_function (a_function: CE_ROUTINE)
		do
			function := a_function
			update_memory_field ("function")
		end

	set_jacobian (a_jacobian: CE_ROUTINE)
		do
			jacobian := a_jacobian
			update_memory_field ("jacobian")
		end

	set_dimension (a_dimension: NATURAL_32)
		do
			dimension := a_dimension
			update_memory_field ("dimension")
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			params := a_params
			update_memory_field ("params")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			function := a_other.function
			jacobian := a_other.jacobian
			dimension := a_other.dimension
			params := a_other.params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				function.is_equal (a_other.function) and
				jacobian.is_equal (a_other.jacobian) and
				dimension = a_other.dimension and
				params.is_equal (a_other.params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("jacobian"),
					create {CE_STRUCTURE_FIELD}.make ("dimension"),
					create {CE_STRUCTURE_FIELD}.make ("params")
				>>)
			init_structure_info
		end

end
