class
	PD_GSL_POLY_COMPLEX_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create matrix.make
		end

feature {ANY} -- fields

	nc: NATURAL_32 assign set_nc

	matrix: CE_POINTER [REAL_64] assign set_matrix

feature {ANY} -- setters

	set_nc (a_nc: NATURAL_32)
		do
			nc := a_nc
			update_memory_field ("nc")
		end

	set_matrix (a_matrix: CE_POINTER [REAL_64])
		do
			matrix := a_matrix
			update_memory_field ("matrix")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			nc := a_other.nc
			matrix := a_other.matrix
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				nc = a_other.nc and
				matrix.is_equal (a_other.matrix)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("nc"),
					create {CE_STRUCTURE_FIELD}.make ("matrix")
				>>)
			init_structure_info
		end

end
