class
	PD_GSL_RAN_DISCRETE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create A.make
			create F.make
		end

feature {ANY} -- fields

	K: NATURAL_32 assign set_K

	A: CE_POINTER [NATURAL_32] assign set_A

	F: CE_POINTER [REAL_64] assign set_F

feature {ANY} -- setters

	set_K (a_K: NATURAL_32)
		do
			K := a_K
			update_memory_field ("K")
		end

	set_A (a_A: CE_POINTER [NATURAL_32])
		do
			A := a_A
			update_memory_field ("A")
		end

	set_F (a_F: CE_POINTER [REAL_64])
		do
			F := a_F
			update_memory_field ("F")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			K := a_other.K
			A := a_other.A
			F := a_other.F
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				K = a_other.K and
				A.is_equal (a_other.A) and
				F.is_equal (a_other.F)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("K"),
					create {CE_STRUCTURE_FIELD}.make ("A"),
					create {CE_STRUCTURE_FIELD}.make ("F")
				>>)
			init_structure_info
		end

end
