class
	PD_GSL_ROOT_FSOLVER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create type.make
			create function.make
			create state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_ROOT_FSOLVER_TYPE] assign set_type

	function: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_function

	root: REAL_64 assign set_root

	x_lower: REAL_64 assign set_x_lower

	x_upper: REAL_64 assign set_x_upper

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- setters

	set_type (a_type: CE_POINTER [PD_GSL_ROOT_FSOLVER_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_function (a_function: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			function := a_function
			update_memory_field ("function")
		end

	set_root (a_root: REAL_64)
		do
			root := a_root
			update_memory_field ("root")
		end

	set_x_lower (a_x_lower: REAL_64)
		do
			x_lower := a_x_lower
			update_memory_field ("x_lower")
		end

	set_x_upper (a_x_upper: REAL_64)
		do
			x_upper := a_x_upper
			update_memory_field ("x_upper")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			function := a_other.function
			root := a_other.root
			x_lower := a_other.x_lower
			x_upper := a_other.x_upper
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				function.is_equal (a_other.function) and
				root = a_other.root and
				x_lower = a_other.x_lower and
				x_upper = a_other.x_upper and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("root"),
					create {CE_STRUCTURE_FIELD}.make ("x_lower"),
					create {CE_STRUCTURE_FIELD}.make ("x_upper"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
