class
	PD_GSL_SF_MATHIEU_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create aa.make
			create bb.make
			create dd.make
			create ee.make
			create tt.make
			create e2.make
			create zz.make
			create eval.make
			create evec.make
			create wmat.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	even_order: NATURAL_32 assign set_even_order

	odd_order: NATURAL_32 assign set_odd_order

	extra_values: INTEGER_32 assign set_extra_values

	qa: REAL_64 assign set_qa

	qb: REAL_64 assign set_qb

	aa: CE_POINTER [REAL_64] assign set_aa

	bb: CE_POINTER [REAL_64] assign set_bb

	dd: CE_POINTER [REAL_64] assign set_dd

	ee: CE_POINTER [REAL_64] assign set_ee

	tt: CE_POINTER [REAL_64] assign set_tt

	e2: CE_POINTER [REAL_64] assign set_e2

	zz: CE_POINTER [REAL_64] assign set_zz

	eval: CE_POINTER [PD_GSL_VECTOR] assign set_eval

	evec: CE_POINTER [PD_GSL_MATRIX] assign set_evec

	wmat: CE_POINTER [PD_GSL_EIGEN_SYMMV_WORKSPACE] assign set_wmat

feature {ANY} -- setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_even_order (a_even_order: NATURAL_32)
		do
			even_order := a_even_order
			update_memory_field ("even_order")
		end

	set_odd_order (a_odd_order: NATURAL_32)
		do
			odd_order := a_odd_order
			update_memory_field ("odd_order")
		end

	set_extra_values (a_extra_values: INTEGER_32)
		do
			extra_values := a_extra_values
			update_memory_field ("extra_values")
		end

	set_qa (a_qa: REAL_64)
		do
			qa := a_qa
			update_memory_field ("qa")
		end

	set_qb (a_qb: REAL_64)
		do
			qb := a_qb
			update_memory_field ("qb")
		end

	set_aa (a_aa: CE_POINTER [REAL_64])
		do
			aa := a_aa
			update_memory_field ("aa")
		end

	set_bb (a_bb: CE_POINTER [REAL_64])
		do
			bb := a_bb
			update_memory_field ("bb")
		end

	set_dd (a_dd: CE_POINTER [REAL_64])
		do
			dd := a_dd
			update_memory_field ("dd")
		end

	set_ee (a_ee: CE_POINTER [REAL_64])
		do
			ee := a_ee
			update_memory_field ("ee")
		end

	set_tt (a_tt: CE_POINTER [REAL_64])
		do
			tt := a_tt
			update_memory_field ("tt")
		end

	set_e2 (a_e2: CE_POINTER [REAL_64])
		do
			e2 := a_e2
			update_memory_field ("e2")
		end

	set_zz (a_zz: CE_POINTER [REAL_64])
		do
			zz := a_zz
			update_memory_field ("zz")
		end

	set_eval (a_eval: CE_POINTER [PD_GSL_VECTOR])
		do
			eval := a_eval
			update_memory_field ("eval")
		end

	set_evec (a_evec: CE_POINTER [PD_GSL_MATRIX])
		do
			evec := a_evec
			update_memory_field ("evec")
		end

	set_wmat (a_wmat: CE_POINTER [PD_GSL_EIGEN_SYMMV_WORKSPACE])
		do
			wmat := a_wmat
			update_memory_field ("wmat")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			even_order := a_other.even_order
			odd_order := a_other.odd_order
			extra_values := a_other.extra_values
			qa := a_other.qa
			qb := a_other.qb
			aa := a_other.aa
			bb := a_other.bb
			dd := a_other.dd
			ee := a_other.ee
			tt := a_other.tt
			e2 := a_other.e2
			zz := a_other.zz
			eval := a_other.eval
			evec := a_other.evec
			wmat := a_other.wmat
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				even_order = a_other.even_order and
				odd_order = a_other.odd_order and
				extra_values = a_other.extra_values and
				qa = a_other.qa and
				qb = a_other.qb and
				aa.is_equal (a_other.aa) and
				bb.is_equal (a_other.bb) and
				dd.is_equal (a_other.dd) and
				ee.is_equal (a_other.ee) and
				tt.is_equal (a_other.tt) and
				e2.is_equal (a_other.e2) and
				zz.is_equal (a_other.zz) and
				eval.is_equal (a_other.eval) and
				evec.is_equal (a_other.evec) and
				wmat.is_equal (a_other.wmat)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("even_order"),
					create {CE_STRUCTURE_FIELD}.make ("odd_order"),
					create {CE_STRUCTURE_FIELD}.make ("extra_values"),
					create {CE_STRUCTURE_FIELD}.make ("qa"),
					create {CE_STRUCTURE_FIELD}.make ("qb"),
					create {CE_STRUCTURE_FIELD}.make ("aa"),
					create {CE_STRUCTURE_FIELD}.make ("bb"),
					create {CE_STRUCTURE_FIELD}.make ("dd"),
					create {CE_STRUCTURE_FIELD}.make ("ee"),
					create {CE_STRUCTURE_FIELD}.make ("tt"),
					create {CE_STRUCTURE_FIELD}.make ("e2"),
					create {CE_STRUCTURE_FIELD}.make ("zz"),
					create {CE_STRUCTURE_FIELD}.make ("eval"),
					create {CE_STRUCTURE_FIELD}.make ("evec"),
					create {CE_STRUCTURE_FIELD}.make ("wmat")
				>>)
			init_structure_info
		end

end
