class
	PD_GSL_SF_RESULT_E10_STRUCT

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	val: REAL_64 assign set_val

	err: REAL_64 assign set_err

	e10: INTEGER_32 assign set_e10

feature {ANY} -- setters

	set_val (a_val: REAL_64)
		do
			val := a_val
			update_memory_field ("val")
		end

	set_err (a_err: REAL_64)
		do
			err := a_err
			update_memory_field ("err")
		end

	set_e10 (a_e10: INTEGER_32)
		do
			e10 := a_e10
			update_memory_field ("e10")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			val := a_other.val
			err := a_other.err
			e10 := a_other.e10
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				val = a_other.val and
				err = a_other.err and
				e10 = a_other.e10
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("val"),
					create {CE_STRUCTURE_FIELD}.make ("err"),
					create {CE_STRUCTURE_FIELD}.make ("e10")
				>>)
			init_structure_info
		end

end
