class
	PD_GSL_STACK_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create v.make
		end

feature {ANY} -- fields

	N: NATURAL_32 assign set_N

	v: CE_POINTER [NATURAL_32] assign set_v

	i: NATURAL_32 assign set_i

feature {ANY} -- setters

	set_N (a_N: NATURAL_32)
		do
			N := a_N
			update_memory_field ("N")
		end

	set_v (a_v: CE_POINTER [NATURAL_32])
		do
			v := a_v
			update_memory_field ("v")
		end

	set_i (a_i: NATURAL_32)
		do
			i := a_i
			update_memory_field ("i")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			N := a_other.N
			v := a_other.v
			i := a_other.i
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				N = a_other.N and
				v.is_equal (a_other.v) and
				i = a_other.i
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("N"),
					create {CE_STRUCTURE_FIELD}.make ("v"),
					create {CE_STRUCTURE_FIELD}.make ("i")
				>>)
			init_structure_info
		end

end
