class
	PD_GSL_SUM_LEVIN_U_WORKSPACE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create q_num.make
			create q_den.make
			create dq_num.make
			create dq_den.make
			create dsum.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	i: NATURAL_32 assign set_i

	terms_used: NATURAL_32 assign set_terms_used

	sum_plain: REAL_64 assign set_sum_plain

	q_num: CE_POINTER [REAL_64] assign set_q_num

	q_den: CE_POINTER [REAL_64] assign set_q_den

	dq_num: CE_POINTER [REAL_64] assign set_dq_num

	dq_den: CE_POINTER [REAL_64] assign set_dq_den

	dsum: CE_POINTER [REAL_64] assign set_dsum

feature {ANY} -- setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_i (a_i: NATURAL_32)
		do
			i := a_i
			update_memory_field ("i")
		end

	set_terms_used (a_terms_used: NATURAL_32)
		do
			terms_used := a_terms_used
			update_memory_field ("terms_used")
		end

	set_sum_plain (a_sum_plain: REAL_64)
		do
			sum_plain := a_sum_plain
			update_memory_field ("sum_plain")
		end

	set_q_num (a_q_num: CE_POINTER [REAL_64])
		do
			q_num := a_q_num
			update_memory_field ("q_num")
		end

	set_q_den (a_q_den: CE_POINTER [REAL_64])
		do
			q_den := a_q_den
			update_memory_field ("q_den")
		end

	set_dq_num (a_dq_num: CE_POINTER [REAL_64])
		do
			dq_num := a_dq_num
			update_memory_field ("dq_num")
		end

	set_dq_den (a_dq_den: CE_POINTER [REAL_64])
		do
			dq_den := a_dq_den
			update_memory_field ("dq_den")
		end

	set_dsum (a_dsum: CE_POINTER [REAL_64])
		do
			dsum := a_dsum
			update_memory_field ("dsum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			i := a_other.i
			terms_used := a_other.terms_used
			sum_plain := a_other.sum_plain
			q_num := a_other.q_num
			q_den := a_other.q_den
			dq_num := a_other.dq_num
			dq_den := a_other.dq_den
			dsum := a_other.dsum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				i = a_other.i and
				terms_used = a_other.terms_used and
				sum_plain = a_other.sum_plain and
				q_num.is_equal (a_other.q_num) and
				q_den.is_equal (a_other.q_den) and
				dq_num.is_equal (a_other.dq_num) and
				dq_den.is_equal (a_other.dq_den) and
				dsum.is_equal (a_other.dsum)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("i"),
					create {CE_STRUCTURE_FIELD}.make ("terms_used"),
					create {CE_STRUCTURE_FIELD}.make ("sum_plain"),
					create {CE_STRUCTURE_FIELD}.make ("q_num"),
					create {CE_STRUCTURE_FIELD}.make ("q_den"),
					create {CE_STRUCTURE_FIELD}.make ("dq_num"),
					create {CE_STRUCTURE_FIELD}.make ("dq_den"),
					create {CE_STRUCTURE_FIELD}.make ("dsum")
				>>)
			init_structure_info
		end

end
