class
	PD_GSL_VECTOR_SHORT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
			create block.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	stride: NATURAL_32 assign set_stride

	data: CE_POINTER [INTEGER_16] assign set_data

	block: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT] assign set_block

	owner: INTEGER_32 assign set_owner

feature {ANY} -- setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_stride (a_stride: NATURAL_32)
		do
			stride := a_stride
			update_memory_field ("stride")
		end

	set_data (a_data: CE_POINTER [INTEGER_16])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_block (a_block: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT])
		do
			block := a_block
			update_memory_field ("block")
		end

	set_owner (a_owner: INTEGER_32)
		do
			owner := a_owner
			update_memory_field ("owner")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			stride := a_other.stride
			data := a_other.data
			block := a_other.block
			owner := a_other.owner
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				stride = a_other.stride and
				data.is_equal (a_other.data) and
				block.is_equal (a_other.block) and
				owner = a_other.owner
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("stride"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("owner")
				>>)
			init_structure_info
		end

end
