class
	PD_GSL_WAVELET

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create type.make
			create h1.make
			create g1.make
			create h2.make
			create g2.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_WAVELET_TYPE] assign set_type

	h1: CE_POINTER [REAL_64] assign set_h1

	g1: CE_POINTER [REAL_64] assign set_g1

	h2: CE_POINTER [REAL_64] assign set_h2

	g2: CE_POINTER [REAL_64] assign set_g2

	nc: NATURAL_32 assign set_nc

	offset: NATURAL_32 assign set_offset

feature {ANY} -- setters

	set_type (a_type: CE_POINTER [PD_GSL_WAVELET_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_h1 (a_h1: CE_POINTER [REAL_64])
		do
			h1 := a_h1
			update_memory_field ("h1")
		end

	set_g1 (a_g1: CE_POINTER [REAL_64])
		do
			g1 := a_g1
			update_memory_field ("g1")
		end

	set_h2 (a_h2: CE_POINTER [REAL_64])
		do
			h2 := a_h2
			update_memory_field ("h2")
		end

	set_g2 (a_g2: CE_POINTER [REAL_64])
		do
			g2 := a_g2
			update_memory_field ("g2")
		end

	set_nc (a_nc: NATURAL_32)
		do
			nc := a_nc
			update_memory_field ("nc")
		end

	set_offset (a_offset: NATURAL_32)
		do
			offset := a_offset
			update_memory_field ("offset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			h1 := a_other.h1
			g1 := a_other.g1
			h2 := a_other.h2
			g2 := a_other.g2
			nc := a_other.nc
			offset := a_other.offset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				h1.is_equal (a_other.h1) and
				g1.is_equal (a_other.g1) and
				h2.is_equal (a_other.h2) and
				g2.is_equal (a_other.g2) and
				nc = a_other.nc and
				offset = a_other.offset
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("h1"),
					create {CE_STRUCTURE_FIELD}.make ("g1"),
					create {CE_STRUCTURE_FIELD}.make ("h2"),
					create {CE_STRUCTURE_FIELD}.make ("g2"),
					create {CE_STRUCTURE_FIELD}.make ("nc"),
					create {CE_STRUCTURE_FIELD}.make ("offset")
				>>)
			init_structure_info
		end

end
