class
	PD_NMSIMPLEX_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create x1.make
			create y1.make
			create ws1.make
			create ws2.make
		end

feature {ANY} -- fields

	x1: CE_POINTER [PD_GSL_MATRIX] assign set_x1

	y1: CE_POINTER [PD_GSL_VECTOR] assign set_y1

	ws1: CE_POINTER [PD_GSL_VECTOR] assign set_ws1

	ws2: CE_POINTER [PD_GSL_VECTOR] assign set_ws2

feature {ANY} -- setters

	set_x1 (a_x1: CE_POINTER [PD_GSL_MATRIX])
		do
			x1 := a_x1
			update_memory_field ("x1")
		end

	set_y1 (a_y1: CE_POINTER [PD_GSL_VECTOR])
		do
			y1 := a_y1
			update_memory_field ("y1")
		end

	set_ws1 (a_ws1: CE_POINTER [PD_GSL_VECTOR])
		do
			ws1 := a_ws1
			update_memory_field ("ws1")
		end

	set_ws2 (a_ws2: CE_POINTER [PD_GSL_VECTOR])
		do
			ws2 := a_ws2
			update_memory_field ("ws2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x1 := a_other.x1
			y1 := a_other.y1
			ws1 := a_other.ws1
			ws2 := a_other.ws2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x1.is_equal (a_other.x1) and
				y1.is_equal (a_other.y1) and
				ws1.is_equal (a_other.ws1) and
				ws2.is_equal (a_other.ws2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x1"),
					create {CE_STRUCTURE_FIELD}.make ("y1"),
					create {CE_STRUCTURE_FIELD}.make ("ws1"),
					create {CE_STRUCTURE_FIELD}.make ("ws2")
				>>)
			init_structure_info
		end

end
