class
	PD_NMSIMPLEX_STATE_T_119__

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create x1.make
			create y1.make
			create ws1.make
			create ws2.make
			create center.make
			create delta.make
			create xmc.make
		end

feature {ANY} -- fields

	x1: CE_POINTER [PD_GSL_MATRIX] assign set_x1

	y1: CE_POINTER [PD_GSL_VECTOR] assign set_y1

	ws1: CE_POINTER [PD_GSL_VECTOR] assign set_ws1

	ws2: CE_POINTER [PD_GSL_VECTOR] assign set_ws2

	center: CE_POINTER [PD_GSL_VECTOR] assign set_center

	delta: CE_POINTER [PD_GSL_VECTOR] assign set_delta

	xmc: CE_POINTER [PD_GSL_VECTOR] assign set_xmc

	S2: REAL_64 assign set_S2

	count: NATURAL_32 assign set_count

feature {ANY} -- setters

	set_x1 (a_x1: CE_POINTER [PD_GSL_MATRIX])
		do
			x1 := a_x1
			update_memory_field ("x1")
		end

	set_y1 (a_y1: CE_POINTER [PD_GSL_VECTOR])
		do
			y1 := a_y1
			update_memory_field ("y1")
		end

	set_ws1 (a_ws1: CE_POINTER [PD_GSL_VECTOR])
		do
			ws1 := a_ws1
			update_memory_field ("ws1")
		end

	set_ws2 (a_ws2: CE_POINTER [PD_GSL_VECTOR])
		do
			ws2 := a_ws2
			update_memory_field ("ws2")
		end

	set_center (a_center: CE_POINTER [PD_GSL_VECTOR])
		do
			center := a_center
			update_memory_field ("center")
		end

	set_delta (a_delta: CE_POINTER [PD_GSL_VECTOR])
		do
			delta := a_delta
			update_memory_field ("delta")
		end

	set_xmc (a_xmc: CE_POINTER [PD_GSL_VECTOR])
		do
			xmc := a_xmc
			update_memory_field ("xmc")
		end

	set_S2 (a_S2: REAL_64)
		do
			S2 := a_S2
			update_memory_field ("S2")
		end

	set_count (a_count: NATURAL_32)
		do
			count := a_count
			update_memory_field ("count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x1 := a_other.x1
			y1 := a_other.y1
			ws1 := a_other.ws1
			ws2 := a_other.ws2
			center := a_other.center
			delta := a_other.delta
			xmc := a_other.xmc
			S2 := a_other.S2
			count := a_other.count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x1.is_equal (a_other.x1) and
				y1.is_equal (a_other.y1) and
				ws1.is_equal (a_other.ws1) and
				ws2.is_equal (a_other.ws2) and
				center.is_equal (a_other.center) and
				delta.is_equal (a_other.delta) and
				xmc.is_equal (a_other.xmc) and
				S2 = a_other.S2 and
				count = a_other.count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x1"),
					create {CE_STRUCTURE_FIELD}.make ("y1"),
					create {CE_STRUCTURE_FIELD}.make ("ws1"),
					create {CE_STRUCTURE_FIELD}.make ("ws2"),
					create {CE_STRUCTURE_FIELD}.make ("center"),
					create {CE_STRUCTURE_FIELD}.make ("delta"),
					create {CE_STRUCTURE_FIELD}.make ("xmc"),
					create {CE_STRUCTURE_FIELD}.make ("S2"),
					create {CE_STRUCTURE_FIELD}.make ("count")
				>>)
			init_structure_info
		end

end
