class
	PD_QUAD_GOLDEN_STATE_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	step_size: REAL_64 assign set_step_size

	stored_step: REAL_64 assign set_stored_step

	prev_stored_step: REAL_64 assign set_prev_stored_step

	x_prev_small: REAL_64 assign set_x_prev_small

	f_prev_small: REAL_64 assign set_f_prev_small

	x_small: REAL_64 assign set_x_small

	f_small: REAL_64 assign set_f_small

	num_iter: NATURAL_32 assign set_num_iter

feature {ANY} -- setters

	set_step_size (a_step_size: REAL_64)
		do
			step_size := a_step_size
			update_memory_field ("step_size")
		end

	set_stored_step (a_stored_step: REAL_64)
		do
			stored_step := a_stored_step
			update_memory_field ("stored_step")
		end

	set_prev_stored_step (a_prev_stored_step: REAL_64)
		do
			prev_stored_step := a_prev_stored_step
			update_memory_field ("prev_stored_step")
		end

	set_x_prev_small (a_x_prev_small: REAL_64)
		do
			x_prev_small := a_x_prev_small
			update_memory_field ("x_prev_small")
		end

	set_f_prev_small (a_f_prev_small: REAL_64)
		do
			f_prev_small := a_f_prev_small
			update_memory_field ("f_prev_small")
		end

	set_x_small (a_x_small: REAL_64)
		do
			x_small := a_x_small
			update_memory_field ("x_small")
		end

	set_f_small (a_f_small: REAL_64)
		do
			f_small := a_f_small
			update_memory_field ("f_small")
		end

	set_num_iter (a_num_iter: NATURAL_32)
		do
			num_iter := a_num_iter
			update_memory_field ("num_iter")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			step_size := a_other.step_size
			stored_step := a_other.stored_step
			prev_stored_step := a_other.prev_stored_step
			x_prev_small := a_other.x_prev_small
			f_prev_small := a_other.f_prev_small
			x_small := a_other.x_small
			f_small := a_other.f_small
			num_iter := a_other.num_iter
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				step_size = a_other.step_size and
				stored_step = a_other.stored_step and
				prev_stored_step = a_other.prev_stored_step and
				x_prev_small = a_other.x_prev_small and
				f_prev_small = a_other.f_prev_small and
				x_small = a_other.x_small and
				f_small = a_other.f_small and
				num_iter = a_other.num_iter
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("step_size"),
					create {CE_STRUCTURE_FIELD}.make ("stored_step"),
					create {CE_STRUCTURE_FIELD}.make ("prev_stored_step"),
					create {CE_STRUCTURE_FIELD}.make ("x_prev_small"),
					create {CE_STRUCTURE_FIELD}.make ("f_prev_small"),
					create {CE_STRUCTURE_FIELD}.make ("x_small"),
					create {CE_STRUCTURE_FIELD}.make ("f_small"),
					create {CE_STRUCTURE_FIELD}.make ("num_iter")
				>>)
			init_structure_info
		end

end
