class
	PD_RAN2_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create shuffle.make (<<32>>)
		end

feature {ANY} -- fields

	x: NATURAL_32 assign set_x

	y: NATURAL_32 assign set_y

	n: NATURAL_32 assign set_n

	shuffle: CE_ARRAY [NATURAL_32]

feature {ANY} -- setters

	set_x (a_x: NATURAL_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: NATURAL_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
			y := a_other.y
			n := a_other.n
			shuffle := a_other.shuffle.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x and
				y = a_other.y and
				n = a_other.n and
				shuffle.is_equal (a_other.shuffle)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("shuffle", <<32>>)
				>>)
			init_structure_info
		end

end
