class
	PD_RANLUX_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create u.make (<<24>>)
		end

feature {ANY} -- fields

	i: NATURAL_32 assign set_i

	j: NATURAL_32 assign set_j

	n: NATURAL_32 assign set_n

	skip: NATURAL_32 assign set_skip

	carry: NATURAL_32 assign set_carry

	u: CE_ARRAY [NATURAL_32]

feature {ANY} -- setters

	set_i (a_i: NATURAL_32)
		do
			i := a_i
			update_memory_field ("i")
		end

	set_j (a_j: NATURAL_32)
		do
			j := a_j
			update_memory_field ("j")
		end

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_skip (a_skip: NATURAL_32)
		do
			skip := a_skip
			update_memory_field ("skip")
		end

	set_carry (a_carry: NATURAL_32)
		do
			carry := a_carry
			update_memory_field ("carry")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			i := a_other.i
			j := a_other.j
			n := a_other.n
			skip := a_other.skip
			carry := a_other.carry
			u := a_other.u.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				i = a_other.i and
				j = a_other.j and
				n = a_other.n and
				skip = a_other.skip and
				carry = a_other.carry and
				u.is_equal (a_other.u)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("i"),
					create {CE_STRUCTURE_FIELD}.make ("j"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("skip"),
					create {CE_STRUCTURE_FIELD}.make ("carry"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("u", <<24>>)
				>>)
			init_structure_info
		end

end
