class
	PD_RANLXD_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create xdbl.make (<<12>>)
		end

feature {ANY} -- fields

	xdbl: CE_ARRAY [REAL_64]

	carry: REAL_64 assign set_carry

	ir: NATURAL_32 assign set_ir

	jr: NATURAL_32 assign set_jr

	ir_old: NATURAL_32 assign set_ir_old

	pr: NATURAL_32 assign set_pr

feature {ANY} -- setters

	set_carry (a_carry: REAL_64)
		do
			carry := a_carry
			update_memory_field ("carry")
		end

	set_ir (a_ir: NATURAL_32)
		do
			ir := a_ir
			update_memory_field ("ir")
		end

	set_jr (a_jr: NATURAL_32)
		do
			jr := a_jr
			update_memory_field ("jr")
		end

	set_ir_old (a_ir_old: NATURAL_32)
		do
			ir_old := a_ir_old
			update_memory_field ("ir_old")
		end

	set_pr (a_pr: NATURAL_32)
		do
			pr := a_pr
			update_memory_field ("pr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			xdbl := a_other.xdbl.twin
			carry := a_other.carry
			ir := a_other.ir
			jr := a_other.jr
			ir_old := a_other.ir_old
			pr := a_other.pr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				xdbl.is_equal (a_other.xdbl) and
				carry = a_other.carry and
				ir = a_other.ir and
				jr = a_other.jr and
				ir_old = a_other.ir_old and
				pr = a_other.pr
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("xdbl", <<12>>),
					create {CE_STRUCTURE_FIELD}.make ("carry"),
					create {CE_STRUCTURE_FIELD}.make ("ir"),
					create {CE_STRUCTURE_FIELD}.make ("jr"),
					create {CE_STRUCTURE_FIELD}.make ("ir_old"),
					create {CE_STRUCTURE_FIELD}.make ("pr")
				>>)
			init_structure_info
		end

end
