class
	PD_RANLXS_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create xdbl.make (<<12>>)
			create ydbl.make (<<12>>)
			create xflt.make (<<24>>)
		end

feature {ANY} -- fields

	xdbl: CE_ARRAY [REAL_64]

	ydbl: CE_ARRAY [REAL_64]

	carry: REAL_64 assign set_carry

	xflt: CE_ARRAY [REAL_32]

	ir: NATURAL_32 assign set_ir

	jr: NATURAL_32 assign set_jr

	is: NATURAL_32 assign set_is

	is_old: NATURAL_32 assign set_is_old

	pr: NATURAL_32 assign set_pr

feature {ANY} -- setters

	set_carry (a_carry: REAL_64)
		do
			carry := a_carry
			update_memory_field ("carry")
		end

	set_ir (a_ir: NATURAL_32)
		do
			ir := a_ir
			update_memory_field ("ir")
		end

	set_jr (a_jr: NATURAL_32)
		do
			jr := a_jr
			update_memory_field ("jr")
		end

	set_is (a_is: NATURAL_32)
		do
			is := a_is
			update_memory_field ("is")
		end

	set_is_old (a_is_old: NATURAL_32)
		do
			is_old := a_is_old
			update_memory_field ("is_old")
		end

	set_pr (a_pr: NATURAL_32)
		do
			pr := a_pr
			update_memory_field ("pr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			xdbl := a_other.xdbl.twin
			ydbl := a_other.ydbl.twin
			carry := a_other.carry
			xflt := a_other.xflt.twin
			ir := a_other.ir
			jr := a_other.jr
			is := a_other.is
			is_old := a_other.is_old
			pr := a_other.pr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				xdbl.is_equal (a_other.xdbl) and
				ydbl.is_equal (a_other.ydbl) and
				carry = a_other.carry and
				xflt.is_equal (a_other.xflt) and
				ir = a_other.ir and
				jr = a_other.jr and
				is = a_other.is and
				is_old = a_other.is_old and
				pr = a_other.pr
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("xdbl", <<12>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ydbl", <<12>>),
					create {CE_STRUCTURE_FIELD}.make ("carry"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("xflt", <<24>>),
					create {CE_STRUCTURE_FIELD}.make ("ir"),
					create {CE_STRUCTURE_FIELD}.make ("jr"),
					create {CE_STRUCTURE_FIELD}.make ("is"),
					create {CE_STRUCTURE_FIELD}.make ("is_old"),
					create {CE_STRUCTURE_FIELD}.make ("pr")
				>>)
			init_structure_info
		end

end
