class
	PD_RK2IMP_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create Y1.make
			create y0.make
			create ytmp.make
			create y_onestep.make
			create y0_orig.make
		end

feature {ANY} -- fields

	Y1: CE_POINTER [REAL_64] assign set_Y1

	y0: CE_POINTER [REAL_64] assign set_y0

	ytmp: CE_POINTER [REAL_64] assign set_ytmp

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep

	y0_orig: CE_POINTER [REAL_64] assign set_y0_orig

feature {ANY} -- setters

	set_Y1 (a_Y1: CE_POINTER [REAL_64])
		do
			Y1 := a_Y1
			update_memory_field ("Y1")
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			y0 := a_y0
			update_memory_field ("y0")
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			ytmp := a_ytmp
			update_memory_field ("ytmp")
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			y_onestep := a_y_onestep
			update_memory_field ("y_onestep")
		end

	set_y0_orig (a_y0_orig: CE_POINTER [REAL_64])
		do
			y0_orig := a_y0_orig
			update_memory_field ("y0_orig")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			Y1 := a_other.Y1
			y0 := a_other.y0
			ytmp := a_other.ytmp
			y_onestep := a_other.y_onestep
			y0_orig := a_other.y0_orig
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				Y1.is_equal (a_other.Y1) and
				y0.is_equal (a_other.y0) and
				ytmp.is_equal (a_other.ytmp) and
				y_onestep.is_equal (a_other.y_onestep) and
				y0_orig.is_equal (a_other.y0_orig)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("Y1"),
					create {CE_STRUCTURE_FIELD}.make ("y0"),
					create {CE_STRUCTURE_FIELD}.make ("ytmp"),
					create {CE_STRUCTURE_FIELD}.make ("y_onestep"),
					create {CE_STRUCTURE_FIELD}.make ("y0_orig")
				>>)
			init_structure_info
		end

end
