class
	PD_RK4_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create k.make
			create k1.make
			create y0.make
			create ytmp.make
			create y_onestep.make
		end

feature {ANY} -- fields

	k: CE_POINTER [REAL_64] assign set_k

	k1: CE_POINTER [REAL_64] assign set_k1

	y0: CE_POINTER [REAL_64] assign set_y0

	ytmp: CE_POINTER [REAL_64] assign set_ytmp

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep

feature {ANY} -- setters

	set_k (a_k: CE_POINTER [REAL_64])
		do
			k := a_k
			update_memory_field ("k")
		end

	set_k1 (a_k1: CE_POINTER [REAL_64])
		do
			k1 := a_k1
			update_memory_field ("k1")
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			y0 := a_y0
			update_memory_field ("y0")
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			ytmp := a_ytmp
			update_memory_field ("ytmp")
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			y_onestep := a_y_onestep
			update_memory_field ("y_onestep")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			k := a_other.k
			k1 := a_other.k1
			y0 := a_other.y0
			ytmp := a_other.ytmp
			y_onestep := a_other.y_onestep
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				k.is_equal (a_other.k) and
				k1.is_equal (a_other.k1) and
				y0.is_equal (a_other.y0) and
				ytmp.is_equal (a_other.ytmp) and
				y_onestep.is_equal (a_other.y_onestep)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("k"),
					create {CE_STRUCTURE_FIELD}.make ("k1"),
					create {CE_STRUCTURE_FIELD}.make ("y0"),
					create {CE_STRUCTURE_FIELD}.make ("ytmp"),
					create {CE_STRUCTURE_FIELD}.make ("y_onestep")
				>>)
			init_structure_info
		end

end
