class
	PD_STD_CONTROL_STATE_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	eps_abs: REAL_64 assign set_eps_abs

	eps_rel: REAL_64 assign set_eps_rel

	a_y: REAL_64 assign set_a_y

	a_dydt: REAL_64 assign set_a_dydt

feature {ANY} -- setters

	set_eps_abs (a_eps_abs: REAL_64)
		do
			eps_abs := a_eps_abs
			update_memory_field ("eps_abs")
		end

	set_eps_rel (a_eps_rel: REAL_64)
		do
			eps_rel := a_eps_rel
			update_memory_field ("eps_rel")
		end

	set_a_y (a_a_y: REAL_64)
		do
			a_y := a_a_y
			update_memory_field ("a_y")
		end

	set_a_dydt (a_a_dydt: REAL_64)
		do
			a_dydt := a_a_dydt
			update_memory_field ("a_dydt")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			eps_abs := a_other.eps_abs
			eps_rel := a_other.eps_rel
			a_y := a_other.a_y
			a_dydt := a_other.a_dydt
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				eps_abs = a_other.eps_abs and
				eps_rel = a_other.eps_rel and
				a_y = a_other.a_y and
				a_dydt = a_other.a_dydt
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("eps_abs"),
					create {CE_STRUCTURE_FIELD}.make ("eps_rel"),
					create {CE_STRUCTURE_FIELD}.make ("a_y"),
					create {CE_STRUCTURE_FIELD}.make ("a_dydt")
				>>)
			init_structure_info
		end

end
