class
	PD_STEFFENSON_STATE_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	f: REAL_64 assign set_f

	df: REAL_64 assign set_df

	x: REAL_64 assign set_x

	x_1: REAL_64 assign set_x_1

	x_2: REAL_64 assign set_x_2

	count: INTEGER_32 assign set_count

feature {ANY} -- setters

	set_f (a_f: REAL_64)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_df (a_df: REAL_64)
		do
			df := a_df
			update_memory_field ("df")
		end

	set_x (a_x: REAL_64)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_x_1 (a_x_1: REAL_64)
		do
			x_1 := a_x_1
			update_memory_field ("x_1")
		end

	set_x_2 (a_x_2: REAL_64)
		do
			x_2 := a_x_2
			update_memory_field ("x_2")
		end

	set_count (a_count: INTEGER_32)
		do
			count := a_count
			update_memory_field ("count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			df := a_other.df
			x := a_other.x
			x_1 := a_other.x_1
			x_2 := a_other.x_2
			count := a_other.count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f = a_other.f and
				df = a_other.df and
				x = a_other.x and
				x_1 = a_other.x_1 and
				x_2 = a_other.x_2 and
				count = a_other.count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("df"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("x_1"),
					create {CE_STRUCTURE_FIELD}.make ("x_2"),
					create {CE_STRUCTURE_FIELD}.make ("count")
				>>)
			init_structure_info
		end

end
