class
	PD_TAUS_STATE_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	s1: NATURAL_32 assign set_s1

	s2: NATURAL_32 assign set_s2

	s3: NATURAL_32 assign set_s3

feature {ANY} -- setters

	set_s1 (a_s1: NATURAL_32)
		do
			s1 := a_s1
			update_memory_field ("s1")
		end

	set_s2 (a_s2: NATURAL_32)
		do
			s2 := a_s2
			update_memory_field ("s2")
		end

	set_s3 (a_s3: NATURAL_32)
		do
			s3 := a_s3
			update_memory_field ("s3")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			s1 := a_other.s1
			s2 := a_other.s2
			s3 := a_other.s3
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				s1 = a_other.s1 and
				s2 = a_other.s2 and
				s3 = a_other.s3
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("s1"),
					create {CE_STRUCTURE_FIELD}.make ("s2"),
					create {CE_STRUCTURE_FIELD}.make ("s3")
				>>)
			init_structure_info
		end

end
