class
	PD_U

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	l: INTEGER_32 assign set_l

	c: CE_ARRAY [INTEGER_8]

feature {ANY} -- setters

	set_l (a_l: INTEGER_32)
		do
			l := a_l
			update_memory_field ("l")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			l := a_other.l
			c := a_other.c.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				l = a_other.l and
				c.is_equal (a_other.c)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("l"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("c", <<({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32>>)
				>>)
			init_structure_info
		end

end
