class
	PD_U2

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	f: REAL_32 assign set_f

	b: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_f (a_f: REAL_32)
		do
			f := a_f
			update_memory_field ("f")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			b := a_other.b.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f = a_other.f and
				b.is_equal (a_other.b)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b", <<4>>)
				>>)
			init_structure_info
		end

end
