class
	PD_VECTOR_BFGS_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create x1.make
			create dx1.make
			create x2.make
			create p.make
			create x0.make
			create g0.make
			create dx0.make
			create dg0.make
		end

feature {ANY} -- fields

	iter: INTEGER_32 assign set_iter

	step: REAL_64 assign set_step

	max_step: REAL_64 assign set_max_step

	tol: REAL_64 assign set_tol

	x1: CE_POINTER [PD_GSL_VECTOR] assign set_x1

	dx1: CE_POINTER [PD_GSL_VECTOR] assign set_dx1

	x2: CE_POINTER [PD_GSL_VECTOR] assign set_x2

	g0norm: REAL_64 assign set_g0norm

	pnorm: REAL_64 assign set_pnorm

	p: CE_POINTER [PD_GSL_VECTOR] assign set_p

	x0: CE_POINTER [PD_GSL_VECTOR] assign set_x0

	g0: CE_POINTER [PD_GSL_VECTOR] assign set_g0

	dx0: CE_POINTER [PD_GSL_VECTOR] assign set_dx0

	dg0: CE_POINTER [PD_GSL_VECTOR] assign set_dg0

feature {ANY} -- setters

	set_iter (a_iter: INTEGER_32)
		do
			iter := a_iter
			update_memory_field ("iter")
		end

	set_step (a_step: REAL_64)
		do
			step := a_step
			update_memory_field ("step")
		end

	set_max_step (a_max_step: REAL_64)
		do
			max_step := a_max_step
			update_memory_field ("max_step")
		end

	set_tol (a_tol: REAL_64)
		do
			tol := a_tol
			update_memory_field ("tol")
		end

	set_x1 (a_x1: CE_POINTER [PD_GSL_VECTOR])
		do
			x1 := a_x1
			update_memory_field ("x1")
		end

	set_dx1 (a_dx1: CE_POINTER [PD_GSL_VECTOR])
		do
			dx1 := a_dx1
			update_memory_field ("dx1")
		end

	set_x2 (a_x2: CE_POINTER [PD_GSL_VECTOR])
		do
			x2 := a_x2
			update_memory_field ("x2")
		end

	set_g0norm (a_g0norm: REAL_64)
		do
			g0norm := a_g0norm
			update_memory_field ("g0norm")
		end

	set_pnorm (a_pnorm: REAL_64)
		do
			pnorm := a_pnorm
			update_memory_field ("pnorm")
		end

	set_p (a_p: CE_POINTER [PD_GSL_VECTOR])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_x0 (a_x0: CE_POINTER [PD_GSL_VECTOR])
		do
			x0 := a_x0
			update_memory_field ("x0")
		end

	set_g0 (a_g0: CE_POINTER [PD_GSL_VECTOR])
		do
			g0 := a_g0
			update_memory_field ("g0")
		end

	set_dx0 (a_dx0: CE_POINTER [PD_GSL_VECTOR])
		do
			dx0 := a_dx0
			update_memory_field ("dx0")
		end

	set_dg0 (a_dg0: CE_POINTER [PD_GSL_VECTOR])
		do
			dg0 := a_dg0
			update_memory_field ("dg0")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			iter := a_other.iter
			step := a_other.step
			max_step := a_other.max_step
			tol := a_other.tol
			x1 := a_other.x1
			dx1 := a_other.dx1
			x2 := a_other.x2
			g0norm := a_other.g0norm
			pnorm := a_other.pnorm
			p := a_other.p
			x0 := a_other.x0
			g0 := a_other.g0
			dx0 := a_other.dx0
			dg0 := a_other.dg0
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				iter = a_other.iter and
				step = a_other.step and
				max_step = a_other.max_step and
				tol = a_other.tol and
				x1.is_equal (a_other.x1) and
				dx1.is_equal (a_other.dx1) and
				x2.is_equal (a_other.x2) and
				g0norm = a_other.g0norm and
				pnorm = a_other.pnorm and
				p.is_equal (a_other.p) and
				x0.is_equal (a_other.x0) and
				g0.is_equal (a_other.g0) and
				dx0.is_equal (a_other.dx0) and
				dg0.is_equal (a_other.dg0)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("iter"),
					create {CE_STRUCTURE_FIELD}.make ("step"),
					create {CE_STRUCTURE_FIELD}.make ("max_step"),
					create {CE_STRUCTURE_FIELD}.make ("tol"),
					create {CE_STRUCTURE_FIELD}.make ("x1"),
					create {CE_STRUCTURE_FIELD}.make ("dx1"),
					create {CE_STRUCTURE_FIELD}.make ("x2"),
					create {CE_STRUCTURE_FIELD}.make ("g0norm"),
					create {CE_STRUCTURE_FIELD}.make ("pnorm"),
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("x0"),
					create {CE_STRUCTURE_FIELD}.make ("g0"),
					create {CE_STRUCTURE_FIELD}.make ("dx0"),
					create {CE_STRUCTURE_FIELD}.make ("dg0")
				>>)
			init_structure_info
		end

end
