class
	PD_WRAPPER_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fdf_linear.make
			create fdf.make
			create x.make
			create g.make
			create p.make
			create x_alpha.make
			create g_alpha.make
		end

feature {ANY} -- fields

	fdf_linear: PD_GSL_FUNCTION_FDF_STRUCT assign set_fdf_linear

	fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT] assign set_fdf

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x

	g: CE_POINTER [PD_GSL_VECTOR] assign set_g

	p: CE_POINTER [PD_GSL_VECTOR] assign set_p

	f_alpha: REAL_64 assign set_f_alpha

	df_alpha: REAL_64 assign set_df_alpha

	x_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_x_alpha

	g_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_g_alpha

	f_cache_key: REAL_64 assign set_f_cache_key

	df_cache_key: REAL_64 assign set_df_cache_key

	x_cache_key: REAL_64 assign set_x_cache_key

	g_cache_key: REAL_64 assign set_g_cache_key

feature {ANY} -- setters

	set_fdf_linear (a_fdf_linear: PD_GSL_FUNCTION_FDF_STRUCT)
		do
			fdf_linear := a_fdf_linear
			update_memory_field ("fdf_linear")
		end

	set_fdf (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT])
		do
			fdf := a_fdf
			update_memory_field ("fdf")
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_g (a_g: CE_POINTER [PD_GSL_VECTOR])
		do
			g := a_g
			update_memory_field ("g")
		end

	set_p (a_p: CE_POINTER [PD_GSL_VECTOR])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_f_alpha (a_f_alpha: REAL_64)
		do
			f_alpha := a_f_alpha
			update_memory_field ("f_alpha")
		end

	set_df_alpha (a_df_alpha: REAL_64)
		do
			df_alpha := a_df_alpha
			update_memory_field ("df_alpha")
		end

	set_x_alpha (a_x_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			x_alpha := a_x_alpha
			update_memory_field ("x_alpha")
		end

	set_g_alpha (a_g_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			g_alpha := a_g_alpha
			update_memory_field ("g_alpha")
		end

	set_f_cache_key (a_f_cache_key: REAL_64)
		do
			f_cache_key := a_f_cache_key
			update_memory_field ("f_cache_key")
		end

	set_df_cache_key (a_df_cache_key: REAL_64)
		do
			df_cache_key := a_df_cache_key
			update_memory_field ("df_cache_key")
		end

	set_x_cache_key (a_x_cache_key: REAL_64)
		do
			x_cache_key := a_x_cache_key
			update_memory_field ("x_cache_key")
		end

	set_g_cache_key (a_g_cache_key: REAL_64)
		do
			g_cache_key := a_g_cache_key
			update_memory_field ("g_cache_key")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fdf_linear := a_other.fdf_linear.twin
			fdf := a_other.fdf
			x := a_other.x
			g := a_other.g
			p := a_other.p
			f_alpha := a_other.f_alpha
			df_alpha := a_other.df_alpha
			x_alpha := a_other.x_alpha
			g_alpha := a_other.g_alpha
			f_cache_key := a_other.f_cache_key
			df_cache_key := a_other.df_cache_key
			x_cache_key := a_other.x_cache_key
			g_cache_key := a_other.g_cache_key
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fdf_linear.is_equal (a_other.fdf_linear) and
				fdf.is_equal (a_other.fdf) and
				x.is_equal (a_other.x) and
				g.is_equal (a_other.g) and
				p.is_equal (a_other.p) and
				f_alpha = a_other.f_alpha and
				df_alpha = a_other.df_alpha and
				x_alpha.is_equal (a_other.x_alpha) and
				g_alpha.is_equal (a_other.g_alpha) and
				f_cache_key = a_other.f_cache_key and
				df_cache_key = a_other.df_cache_key and
				x_cache_key = a_other.x_cache_key and
				g_cache_key = a_other.g_cache_key
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fdf_linear"),
					create {CE_STRUCTURE_FIELD}.make ("fdf"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("g"),
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("f_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("df_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("x_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("g_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("f_cache_key"),
					create {CE_STRUCTURE_FIELD}.make ("df_cache_key"),
					create {CE_STRUCTURE_FIELD}.make ("x_cache_key"),
					create {CE_STRUCTURE_FIELD}.make ("g_cache_key")
				>>)
			init_structure_info
		end

end
