class
	P_ABSDEV_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_stats_absdev (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_absdev_m (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32] - a_mean)))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_char_absdev (a_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_char_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_char_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_char_absdev_m (a_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_float_absdev (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_float_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_float_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_float_absdev_m (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_int_absdev (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_int_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_int_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_int_absdev_m (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_long_absdev (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_long_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_long_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_long_absdev_m (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_long_double_absdev (a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_long_double_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_long_double_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_long_double_absdev_m (a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32] - real_96_from_real_64 (a_mean)).truncated_to_real_64))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_short_absdev (a_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_short_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_short_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_short_absdev_m (a_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_uchar_absdev (a_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_uchar_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_uchar_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_uchar_absdev_m (a_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_uint_absdev (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_uint_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_uint_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_uint_absdev_m (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_ulong_absdev (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_ulong_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_ulong_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_ulong_absdev_m (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

	gsl_stats_ushort_absdev (a_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_ushort_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_ushort_absdev_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_ushort_absdev_m (a_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_sum: REAL_64
			l_absdev: REAL_64
			l_i: NATURAL_32
			l_delta___0: REAL_64
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_delta___0 := (fabs ((a_data[(l_i * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_sum := l_sum + l_delta___0
				l_i := l_i + 1
			end
			l_absdev := l_sum / a_n.to_real_64
			Result := l_absdev
		end

end
