class
	P_ADD2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_accumulate (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_x: REAL_64; a_y: REAL_64; a_weight: REAL_64): INTEGER_32
		local
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_i: CE_ARRAY [NATURAL_32]
			l_j: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_i.make (<<1>>)
			create l_j.make (<<1>>)

			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			l_i.item := (0).to_natural_32
			l_j.item := (0).to_natural_32
			l_status := (find2d_inst.find2d (a_h.item.nx, a_h.item.xrange, a_h.item.ny, a_h.item.yrange, a_x, a_y, l_i, l_j))
			if l_status.to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called and then (l_i.item >= l_nx) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("index lies outside valid range of 0 .. nx - 1"), ce_string ("add2d.c"), 54, 7)
					Result := 7
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (l_j.item >= l_ny) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("index lies outside valid range of 0 .. ny - 1"), ce_string ("add2d.c"), 60, 7)
					Result := 7
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_h.item.bin[(l_i.item * l_ny + l_j.item).to_integer_32] := a_h.item.bin[(l_i.item * l_ny + l_j.item).to_integer_32] + a_weight
				Result := 0
			end
		end

	gsl_histogram2d_increment (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_x: REAL_64; a_y: REAL_64): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (gsl_histogram2d_accumulate (a_h, a_x, a_y, 1.0))
			Result := l_status
		end

end
