class
	P_BESSEL_I1

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ai12_cs.make (<<1>>)
			create ai12_data.make (<<22>>)
			create ai1_cs.make (<<1>>)
			create ai1_data.make (<<21>>)
			create bi1_cs.make (<<1>>)
			create bi1_data.make (<<11>>)
		end

feature {ANY} -- attributes

	ai12_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	ai12_data: CE_ARRAY [REAL_64]

	ai1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	ai1_data: CE_ARRAY [REAL_64]

	bi1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	bi1_data: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_sf_bessel_I1 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_bessel_I1_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_I1_e(x, &result)"), ce_string ("bessel_I1.c"), 257, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_I1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_xmin: REAL_64
			l_x_small: REAL_64
			l_y: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_ey: REAL_64
			l_I1_scaled: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)
			create l_I1_scaled.make (<<1>>)

			l_xmin := 2.0 * 2.2250738585072014e-308
			l_x_small := (2.0 * 1.41421356237309504880) * 1.4901161193847656e-08
			l_y := (fabs (a_x))
			if l_y = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
				js.return
			elseif l_y < l_xmin then
				from
				until
					js.loop_done
				loop
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("bessel_I1.c"), 217, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif l_y < l_x_small then
				a_result.item.val := 0.5 * a_x
				a_result.item.err := 0.0
				Result := 0
				js.return
			elseif l_y <= 3.0 then
				cheb_eval_inst.cheb_eval_e (bi1_cs, (l_y * l_y) / 4.5 - 1.0, l_c___1).do_nothing
				a_result.item.val := a_x * (0.875 + l_c___1.item.val)
				a_result.item.err := l_y * l_c___1.item.err
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif l_y < 7.0978271289338397e+02 then
				l_ey := (exp (l_y))
				gsl_sf_bessel_I1_scaled_e2 (a_x, l_I1_scaled).do_nothing
				a_result.item.val := l_ey * l_I1_scaled.item.val
				a_result.item.err := l_ey * l_I1_scaled.item.err + (l_y * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			else
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_I1.c"), 242, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_I1_scaled2 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_bessel_I1_scaled_e2 (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_I1_scaled_e(x, &result)"), ce_string ("bessel_I1.c"), 252, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_I1_scaled_e2 (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_xmin: REAL_64
			l_x_small: REAL_64
			l_y: REAL_64
			l_ey: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sy: REAL_64
			l_c___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_b___0: REAL_64
			l_s: REAL_64
			l_sy___0: REAL_64
			l_c___3: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_b___1: REAL_64
			l_s___0: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)
			create l_c___2.make (<<1>>)
			create l_c___3.make (<<1>>)

			l_xmin := 2.0 * 2.2250738585072014e-308
			l_x_small := (2.0 * 1.41421356237309504880) * 1.4901161193847656e-08
			l_y := (fabs (a_x))
			if l_y = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
				js.return
			elseif l_y < l_xmin then
				from
				until
					js.loop_done
				loop
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("bessel_I1.c"), 158, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif l_y < l_x_small then
				a_result.item.val := 0.5 * a_x
				a_result.item.err := 0.0
				Result := 0
				js.return
			elseif l_y <= 3.0 then
				l_ey := (exp (-l_y))
				cheb_eval_inst.cheb_eval_e (bi1_cs, (l_y * l_y) / 4.5 - 1.0, l_c___1).do_nothing
				a_result.item.val := (a_x * l_ey) * (0.875 + l_c___1.item.val)
				a_result.item.err := l_ey * l_c___1.item.err + (l_y * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif l_y <= 8.0 then
				l_sy := (sqrt (l_y))
				cheb_eval_inst.cheb_eval_e (ai1_cs, (48.0 / l_y - 11.0) / 5.0, l_c___2).do_nothing
				l_b___0 := (0.375 + l_c___2.item.val) / l_sy
				if a_x > 0.0 then
					l_s := 1.0
				else
					l_s := -1.0
				end
				a_result.item.val := l_s * l_b___0
				a_result.item.err := l_c___2.item.err / l_sy
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			else
				l_sy___0 := (sqrt (l_y))
				cheb_eval_inst.cheb_eval_e (ai12_cs, 16.0 / l_y - 1.0, l_c___3).do_nothing
				l_b___1 := (0.375 + l_c___3.item.val) / l_sy___0
				if a_x > 0.0 then
					l_s___0 := 1.0
				else
					l_s___0 := -1.0
				end
				a_result.item.val := l_s___0 * l_b___1
				a_result.item.err := l_c___3.item.err / l_sy___0
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
