class
	P_BESSEL_ZERO

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create P___1.make (<<4>>)
			create Q___02.make (<<4>>)
			create a___4.make (<<4>>)
			create b.make (<<4>>)
			create coef_jnu10_a.make (<<20>>)
			create coef_jnu10_b.make (<<19>>)
			create coef_jnu11_a.make (<<27>>)
			create coef_jnu12_a.make (<<27>>)
			create coef_jnu13_a.make (<<30>>)
			create coef_jnu14_a.make (<<26>>)
			create coef_jnu15_a.make (<<26>>)
			create coef_jnu16_a.make (<<26>>)
			create coef_jnu17_a.make (<<26>>)
			create coef_jnu18_a.make (<<26>>)
			create coef_jnu19_a.make (<<26>>)
			create coef_jnu1_a.make (<<24>>)
			create coef_jnu1_b.make (<<15>>)
			create coef_jnu20_a.make (<<27>>)
			create coef_jnu2_a.make (<<19>>)
			create coef_jnu2_b.make (<<19>>)
			create coef_jnu3_a.make (<<19>>)
			create coef_jnu3_b.make (<<19>>)
			create coef_jnu4_a.make (<<19>>)
			create coef_jnu4_b.make (<<19>>)
			create coef_jnu5_a.make (<<19>>)
			create coef_jnu5_b.make (<<19>>)
			create coef_jnu6_a.make (<<19>>)
			create coef_jnu6_b.make (<<19>>)
			create coef_jnu7_a.make (<<19>>)
			create coef_jnu7_b.make (<<19>>)
			create coef_jnu8_a.make (<<19>>)
			create coef_jnu8_b.make (<<19>>)
			create coef_jnu9_a.make (<<19>>)
			create coef_jnu9_b.make (<<19>>)
			create coef_jnu_a.make (<<21>>)
			create coef_jnu_b.make (<<11>>)
			create size_jnu_a.make (<<21>>)
			create size_jnu_b.make (<<11>>)
		end

feature {ANY} -- attributes

	P___1: CE_ARRAY [REAL_64]

	Q___02: CE_ARRAY [REAL_64]

	a___4: CE_ARRAY [REAL_64]

	b: CE_ARRAY [REAL_64]

	coef_jnu10_a: CE_ARRAY [REAL_64]

	coef_jnu10_b: CE_ARRAY [REAL_64]

	coef_jnu11_a: CE_ARRAY [REAL_64]

	coef_jnu12_a: CE_ARRAY [REAL_64]

	coef_jnu13_a: CE_ARRAY [REAL_64]

	coef_jnu14_a: CE_ARRAY [REAL_64]

	coef_jnu15_a: CE_ARRAY [REAL_64]

	coef_jnu16_a: CE_ARRAY [REAL_64]

	coef_jnu17_a: CE_ARRAY [REAL_64]

	coef_jnu18_a: CE_ARRAY [REAL_64]

	coef_jnu19_a: CE_ARRAY [REAL_64]

	coef_jnu1_a: CE_ARRAY [REAL_64]

	coef_jnu1_b: CE_ARRAY [REAL_64]

	coef_jnu20_a: CE_ARRAY [REAL_64]

	coef_jnu2_a: CE_ARRAY [REAL_64]

	coef_jnu2_b: CE_ARRAY [REAL_64]

	coef_jnu3_a: CE_ARRAY [REAL_64]

	coef_jnu3_b: CE_ARRAY [REAL_64]

	coef_jnu4_a: CE_ARRAY [REAL_64]

	coef_jnu4_b: CE_ARRAY [REAL_64]

	coef_jnu5_a: CE_ARRAY [REAL_64]

	coef_jnu5_b: CE_ARRAY [REAL_64]

	coef_jnu6_a: CE_ARRAY [REAL_64]

	coef_jnu6_b: CE_ARRAY [REAL_64]

	coef_jnu7_a: CE_ARRAY [REAL_64]

	coef_jnu7_b: CE_ARRAY [REAL_64]

	coef_jnu8_a: CE_ARRAY [REAL_64]

	coef_jnu8_b: CE_ARRAY [REAL_64]

	coef_jnu9_a: CE_ARRAY [REAL_64]

	coef_jnu9_b: CE_ARRAY [REAL_64]

	coef_jnu_a: CE_ARRAY [CE_POINTER [REAL_64]]

	coef_jnu_b: CE_ARRAY [CE_POINTER [REAL_64]]

	size_jnu_a: CE_ARRAY [NATURAL_32]

	size_jnu_b: CE_ARRAY [NATURAL_32]

feature {ANY} -- routines

	clenshaw (a_c___1: CE_POINTER [REAL_64]; a_N: INTEGER_32; a_u: REAL_64): REAL_64
		local
			l_B_np1: REAL_64
			l_B_n: REAL_64
			l_B_nm1: REAL_64
			l_n: INTEGER_32
		do
			l_B_np1 := 0.0
			l_B_n := a_c___1[a_N]
			l_n := a_N
			from
			until
				not (l_n > 0)
			loop
				l_B_nm1 := ((2.0 * (2.0 * a_u - 1.0)) * l_B_n - l_B_np1) + a_c___1[(l_n - 1)]
				l_B_np1 := l_B_n
				l_B_n := l_B_nm1
				l_n := l_n - 1
			end
			Result := (l_B_n - (2.0 * a_u - 1.0) * l_B_np1)
		end

	gsl_sf_bessel_zero_J0 (a_s: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_bessel_zero_J0_e (a_s, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_zero_J0_e(s, &result)"), ce_string ("bessel_zero.c"), 1_208, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_zero_J0_e (a_s: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_beta: REAL_64
			l_bi2: REAL_64
			l_R33num: REAL_64
			l_R33den: REAL_64
			l_R33: REAL_64
			js: JUMP_STATE
		do
			if a_s = {NATURAL_32} 0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("bessel_zero.c"), 1_031, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_beta := (a_s.to_real_64 - 0.25) * 3.14159265358979323846
				l_bi2 := 1.0 / (l_beta * l_beta)
				l_R33num := (P___1[0] + (l_bi2 * (P___1[1] + (l_bi2 * (P___1[2] + P___1[3] * l_bi2)))))
				l_R33den := (Q___02[0] + (l_bi2 * (Q___02[1] + (l_bi2 * (Q___02[2] + Q___02[3] * l_bi2)))))
				l_R33 := l_R33num / l_R33den
				a_result.item.val := l_beta + l_R33 / l_beta
				a_result.item.err := fabs (3.0e-15 * a_result.item.val)
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_zero_J1 (a_s: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_bessel_zero_J1_e (a_s, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_zero_J1_e(s, &result)"), ce_string ("bessel_zero.c"), 1_213, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_zero_J1_e (a_s: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_beta: REAL_64
			l_bi2: REAL_64
			l_Rnum: REAL_64
			l_Rden: REAL_64
			l_R: REAL_64
		do
			if a_s = {NATURAL_32} 0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
			else
				l_beta := (a_s.to_real_64 + 0.25) * 3.14159265358979323846
				l_bi2 := 1.0 / (l_beta * l_beta)
				l_Rnum := (a___4[3] + (l_bi2 * (a___4[2] + (l_bi2 * (a___4[1] + (l_bi2 * a___4[0]))))))
				l_Rden := (b[3] + (l_bi2 * (b[2] + (l_bi2 * (b[1] + (l_bi2 * b[0]))))))
				l_R := l_Rnum / l_Rden
				a_result.item.val := l_beta * (1.0 + l_R * l_bi2)
				a_result.item.err := fabs (2.0e-14 * a_result.item.val)
				Result := 0
			end
		end

	gsl_sf_bessel_zero_Jnu (a_nu: REAL_64; a_s: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_bessel_zero_Jnu_e (a_nu, a_s, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_zero_Jnu_e(nu, s, &result)"), ce_string ("bessel_zero.c"), 1_218, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_zero_Jnu_e (a_nu: REAL_64; a_s: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c___1: CE_POINTER [REAL_64]
			l_L: NATURAL_32
			l_arg: REAL_64
			l_chb: REAL_64
			l_c___2: CE_POINTER [REAL_64]
			l_L___0: NATURAL_32
			l_arg___0: REAL_64
			l_chb___0: REAL_64
			l_c___3: CE_POINTER [REAL_64]
			l_L___1: NATURAL_32
			l_arg___1: REAL_64
			l_chb___1: REAL_64
			l_c___4: CE_POINTER [REAL_64]
			l_L___2: NATURAL_32
			l_arg___2: REAL_64
			l_chb___2: REAL_64
			l_c___5: CE_POINTER [REAL_64]
			l_L___3: NATURAL_32
			l_arg___3: REAL_64
			l_chb___3: REAL_64
			l_beta: REAL_64
			l_mc: REAL_64
			l_rat12: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_as: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_as: INTEGER_32
			l_minus_zeta: REAL_64
			l_z: REAL_64
			l_f1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c___1.make
			create l_c___2.make
			create l_c___3.make
			create l_c___4.make
			create l_c___5.make
			create l_rat12.make (<<1>>)
			create l_as.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_nu <= -1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_zero.c"), 1_101, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if a_s /= {NATURAL_32} 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						if a_nu = 0.0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("no zero-th root for nu = 0.0"), ce_string ("bessel_zero.c"), 1_107, 4)
								Result := 4
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
						if not js.return_called then
							Result := 0
							js.return
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if not (a_nu < 0.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("unimplemented"), ce_string ("bessel_zero.c"), 1_115, 24)
							Result := 24
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if a_s /= {NATURAL_32} 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_nu < 2.0 then
							l_c___1 := coef_jnu_a[a_s.to_integer_32]
							l_L := size_jnu_a[a_s.to_integer_32]
							l_arg := a_nu / 2.0
							l_chb := (clenshaw (l_c___1, (l_L - {NATURAL_32} 1).to_integer_32, l_arg))
							a_result.item.val := l_chb
							a_result.item.err := 2.0e-15 * a_result.item.val
						else
							l_c___2 := coef_jnu_b[a_s.to_integer_32]
							l_L___0 := size_jnu_b[a_s.to_integer_32]
							l_arg___0 := (pow (2.0 / a_nu, 2.0 / 3.0))
							l_chb___0 := (clenshaw (l_c___2, (l_L___0 - {NATURAL_32} 1).to_integer_32, l_arg___0))
							a_result.item.val := a_nu * l_chb___0
							a_result.item.err := 2.0e-15 * a_result.item.val
						end
						Result := 0
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if not (a_s <= {NATURAL_32} 10) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_nu < a_s.to_real_64 then
							l_c___3 := coef_jnu_a[a_s.to_integer_32]
							l_L___1 := size_jnu_a[a_s.to_integer_32]
							l_arg___1 := a_nu / a_s.to_real_64
							l_chb___1 := (clenshaw (l_c___3, (l_L___1 - {NATURAL_32} 1).to_integer_32, l_arg___1))
							a_result.item.val := l_chb___1
							a_result.item.err := 2.0e-15 * a_result.item.val
						else
							l_c___4 := coef_jnu_b[a_s.to_integer_32]
							l_L___2 := size_jnu_b[a_s.to_integer_32]
							l_arg___2 := (pow (a_s.to_real_64 / a_nu, 2.0 / 3.0))
							l_chb___2 := (clenshaw (l_c___4, (l_L___2 - {NATURAL_32} 1).to_integer_32, l_arg___2))
							a_result.item.val := a_nu * l_chb___2
							a_result.item.err := 2.0e-15 * a_result.item.val
							if a_s = {NATURAL_32} 5 then
								a_result.item.err := a_result.item.err * (5.0e+06)
							end
						end
						Result := 0
						js.return
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if not (a_s.to_real_64 > 0.5 * a_nu) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if a_s <= {NATURAL_32} 20 then
							l_c___5 := coef_jnu_a[a_s.to_integer_32]
							l_L___3 := size_jnu_a[a_s.to_integer_32]
							l_arg___3 := a_nu / (2.0 * a_s.to_real_64)
							l_chb___3 := (clenshaw (l_c___5, (l_L___3 - {NATURAL_32} 1).to_integer_32, l_arg___3))
							a_result.item.val := l_chb___3
							a_result.item.err := 4.0e-15 * l_chb___3
							Result := 0
							js.return
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if a_s.to_real_64 > 2.0 * a_nu then
							l_beta := ((a_s.to_real_64 + 0.5 * a_nu) - 0.25) * 3.14159265358979323846
							l_mc := (mcmahon_correction ((4.0 * a_nu) * a_nu, l_beta))
							pow_int_inst.gsl_sf_pow_int_e (a_nu / l_beta, 14, l_rat12).do_nothing
							a_result.item.val := l_beta * l_mc
							a_result.item.err := (4.0 * (fabs (l_beta))) * l_rat12.item.val
							a_result.item.err := a_result.item.err + (4.0 * (fabs (2.2204460492503131e-16 * a_result.item.val)))
							Result := 0
							js.return
						else
							l_stat_as := (airy_zero_inst.gsl_sf_airy_zero_Ai_e (a_s, l_as))
							l_minus_zeta := -(pow (a_nu, -2.0 / 3.0)) * l_as.item.val
							l_z := (bessel_olver_inst.gsl_sf_bessel_Olver_zofmzeta (l_minus_zeta))
							l_f1 := (olver_f1 (l_z, l_minus_zeta))
							a_result.item.val := a_nu * (l_z + l_f1 / (a_nu * a_nu))
							a_result.item.err := 0.001 / ((a_nu * a_nu) * a_nu)
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_as
							js.return
						end
				when 19 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mcmahon_correction (a_mu: REAL_64; a_beta: REAL_64): REAL_64
		local
			l_eb: REAL_64
			l_ebsq: REAL_64
			l_term1: REAL_64
			l_term2: REAL_64
			l_term3: REAL_64
			l_term4: REAL_64
			l_term5: REAL_64
			l_mi: REAL_64
			l_r___3: REAL_64
			l_n2: REAL_64
			l_n3: REAL_64
			l_n4: REAL_64
			l_n5: REAL_64
			l_n6: REAL_64
			l_term1___0: REAL_64
			l_term2___0: REAL_64
			l_term3___0: REAL_64
			l_term4___0: REAL_64
			l_term5___0: REAL_64
			l_term6: REAL_64
		do
			l_eb := 8.0 * a_beta
			l_ebsq := l_eb * l_eb
			if a_mu < 2.2204460492503131e-16 then
				l_term1 := 1.0 / l_ebsq
				l_term2 := (-4.0 * 31.0) / (((3).to_double * l_ebsq) * l_ebsq)
				l_term3 := (32.0 * 3779.0) / (((15.0 * l_ebsq) * l_ebsq) * l_ebsq)
				l_term4 := (-64.0 * 6277237.0) / ((((105.0 * l_ebsq) * l_ebsq) * l_ebsq) * l_ebsq)
				l_term5 := (512.0 * 2092163573.0) / (((((315.0 * l_ebsq) * l_ebsq) * l_ebsq) * l_ebsq) * l_ebsq)
				Result := (1.0 + 8.0 * ((((l_term1 + l_term2) + l_term3) + l_term4) + l_term5))
			else
				l_mi := 1.0 / a_mu
				l_r___3 := a_mu / l_ebsq
				l_n2 := (4.0 / 3.0) * (7.0 - 31.0 * l_mi)
				l_n3 := (32.0 / 15.0) * (83.0 + (-982.0 + 3779.0 * l_mi) * l_mi)
				l_n4 := (64.0 / 105.0) * (6949.0 + (-153855.0 + (1585743.0 - 6277237.0 * l_mi) * l_mi) * l_mi)
				l_n5 := (512.0 / 315.0) * (70197.0 + (-2479316.0 + (48010494.0 + (-512062548.0 + 2092163573.0 * l_mi) * l_mi) * l_mi) * l_mi)
				l_n6 := (2048.0 / 3465.0) * (5592657.0 + (-287149133.0 + (8903961290.0 + (-179289628602.0 + (1982611456181.0 - 8249725736393.0 * l_mi) * l_mi) * l_mi) * l_mi) * l_mi)
				l_term1___0 := (1.0 - l_mi) * l_r___3
				l_term2___0 := (l_term1___0 * l_n2) * l_r___3
				l_term3___0 := ((l_term1___0 * l_n3) * l_r___3) * l_r___3
				l_term4___0 := (((l_term1___0 * l_n4) * l_r___3) * l_r___3) * l_r___3
				l_term5___0 := ((((l_term1___0 * l_n5) * l_r___3) * l_r___3) * l_r___3) * l_r___3
				l_term6 := (((((l_term1___0 * l_n6) * l_r___3) * l_r___3) * l_r___3) * l_r___3) * l_r___3
				Result := (1.0 - 8.0 * (((((l_term1___0 + l_term2___0) + l_term3___0) + l_term4___0) + l_term5___0) + l_term6))
			end
		end

	olver_b0 (a_z: REAL_64; a_minus_zeta: REAL_64): REAL_64
		local
			l_a___5: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_abs_zeta: REAL_64
			l_t: REAL_64
		do
			if a_z < 1.02 then
				l_a___5 := 1.0 - a_z
				l_c0___0 := 0.0179988721413553309252458658183
				l_c1___2 := 0.0111992982212877614645974276203
				l_c2___0 := 0.0059404069786014304317781160605
				l_c3___3 := 0.0028676724516390040844556450173
				l_c4___2 := 0.0012339189052567271708525111185
				l_c5___1 := 0.0004169250674535178764734660248
				l_c6___2 := 0.0000330173385085949806952777365
				l_c7___0 := -0.0001318076238578203009990106425
				l_c8___0 := -0.0001906870370050847239813945647
				Result := (l_c0___0 + l_a___5 * (l_c1___2 + l_a___5 * (l_c2___0 + l_a___5 * (l_c3___3 + l_a___5 * (l_c4___2 + l_a___5 * (l_c5___1 + l_a___5 * (l_c6___2 + l_a___5 * (l_c7___0 + l_a___5 * l_c8___0))))))))
			else
				l_abs_zeta := a_minus_zeta
				l_t := 1.0 / (a_z * (sqrt (1.0 - 1.0 / (a_z * a_z))))
				Result := (-5.0 / ((48.0 * l_abs_zeta) * l_abs_zeta) + (l_t * (3.0 + (5.0 * l_t) * l_t)) / (24.0 * (sqrt (l_abs_zeta))))
			end
		end

	olver_f1 (a_z: REAL_64; a_minus_zeta: REAL_64): REAL_64
		local
			l_b0: REAL_64
			l_h2: REAL_64
		do
			l_b0 := (olver_b0 (a_z, a_minus_zeta))
			l_h2 := (sqrt ((4.0 * a_minus_zeta) / (a_z * a_z - 1.0)))
			Result := (((0.5 * a_z) * l_h2) * l_b0)
		end

end
