class
	P_BETA

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_beta_P (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			js: JUMP_STATE
		do
			if a_x <= 0.0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called and then (a_x >= 1.0) then
				Result := (1.0)
				js.return
			end
			if not js.return_called then
				l_P___2 := beta_inc_inst.beta_inc_AXPY___0 (1.0, 0.0, a_a___5, a_b___0, a_x)
				Result := l_P___2
			end
		end

	gsl_cdf_beta_Q (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			js: JUMP_STATE
		do
			if a_x >= 1.0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called and then (a_x <= 0.0) then
				Result := (1.0)
				js.return
			end
			if not js.return_called then
				l_Q___1 := beta_inc_inst.beta_inc_AXPY___0 (-1.0, 1.0, a_a___5, a_b___0, a_x)
				Result := l_Q___1
			end
		end

	gsl_ran_beta (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_x1___0: REAL_64
			l_x2___1: REAL_64
		do
			l_x1___0 := (gamma_inst.gsl_ran_gamma (a_r___3, a_a___5, 1.0))
			l_x2___1 := (gamma_inst.gsl_ran_gamma (a_r___3, a_b___0, 1.0))
			Result := (l_x1___0 / (l_x1___0 + l_x2___1))
		end

	gsl_ran_beta_pdf (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_gab: REAL_64
			l_ga: REAL_64
			l_gb: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
		do
			if a_x < (0).to_double then
				Result := (0).to_double
			elseif a_x > (1).to_double then
				Result := (0).to_double
			else
				l_gab := (gamma_inst.gsl_sf_lngamma (a_a___5 + a_b___0))
				l_ga := (gamma_inst.gsl_sf_lngamma (a_a___5))
				l_gb := (gamma_inst.gsl_sf_lngamma (a_b___0))
				if a_x = 0.0 then
					l_tmp___2 := exp ((l_gab - l_ga) - l_gb)
					l_tmp___3 := pow (a_x, a_a___5 - (1).to_double)
					l_tmp___4 := pow ((1).to_double - a_x, a_b___0 - (1).to_double)
					l_p := (l_tmp___2 * l_tmp___3) * l_tmp___4
				elseif a_x = 1.0 then
					l_tmp___2 := exp ((l_gab - l_ga) - l_gb)
					l_tmp___3 := pow (a_x, a_a___5 - (1).to_double)
					l_tmp___4 := pow ((1).to_double - a_x, a_b___0 - (1).to_double)
					l_p := (l_tmp___2 * l_tmp___3) * l_tmp___4
				else
					l_tmp___5 := log (a_x)
					l_p := exp ((((l_gab - l_ga) - l_gb) + l_tmp___5 * (a_a___5 - (1).to_double)) + (log1p (-a_x)) * (a_b___0 - (1).to_double))
				end
				Result := l_p
			end
		end

	gsl_sf_beta (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_beta_e (a_x, a_y, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_beta_e(x, y, &result)"), ce_string ("beta.c"), 168, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_beta_e (a_x: REAL_64; a_y: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_gx: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gy: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gxy: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lb: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgn: CE_ARRAY [REAL_64]
			l_stat_lb: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_gx.make (<<1>>)
			create l_gy.make (<<1>>)
			create l_gxy.make (<<1>>)
			create l_lb.make (<<1>>)
			create l_sgn.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x > (0).to_double) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_y > (0).to_double then
							if a_x < 50.0 then
								if a_y < 50.0 then
									gamma_inst.gsl_sf_gamma_e (a_x, l_gx).do_nothing
									gamma_inst.gsl_sf_gamma_e (a_y, l_gy).do_nothing
									gamma_inst.gsl_sf_gamma_e (a_x + a_y, l_gxy).do_nothing
									a_result.item.val := (l_gx.item.val * l_gy.item.val) / l_gxy.item.val
									a_result.item.err := l_gx.item.err * (fabs (l_gy.item.val / l_gxy.item.val))
									a_result.item.err := a_result.item.err + (l_gy.item.err * (fabs (l_gx.item.val / l_gxy.item.val)))
									a_result.item.err := a_result.item.err + ((fabs ((l_gx.item.val * l_gy.item.val) / (l_gxy.item.val * l_gxy.item.val))) * l_gxy.item.err)
									a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
									Result := 0
									js.return
								else
									l_pos := -1 + 3 -- goto _L___2
								end
							else
								l_pos := -1 + 3 -- goto _L___2
							end
						else
							l_pos := -1 + 3 -- goto _L___2
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else: | _L___2:
						if not ((isnegint___0 (a_x)).truncated_to_integer.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not ((isnegint___0 (a_y)).truncated_to_integer.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("beta.c"), 134, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if (isnegint___0 (a_x + a_y)).truncated_to_integer.to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							l_stat_lb := (gsl_sf_lnbeta_sgn_e (a_x, a_y, l_lb, l_sgn))
							if l_stat_lb = 0 then
								l_status := (exp_inst.gsl_sf_exp_err_e (l_lb.item.val, l_lb.item.err, a_result))
								a_result.item.val := a_result.item.val * (l_sgn.item)
								Result := l_status
								js.return
							else
								a_result.item.val := 0.0
								a_result.item.err := 0.0
								Result := l_stat_lb
								js.return
							end
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_lnbeta (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_lnbeta_e (a_x, a_y, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_lnbeta_e(x, y, &result)"), ce_string ("beta.c"), 163, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_lnbeta_e (a_x: REAL_64; a_y: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_sgn: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_sgn.make (<<1>>)

			l_status := (gsl_sf_lnbeta_sgn_e (a_x, a_y, a_result, l_sgn))
			if l_sgn.item = (-1).to_double then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("beta.c"), 44, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := l_status
			end
		end

	gsl_sf_lnbeta_sgn_e (a_x: REAL_64; a_y: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_sgn: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_max: REAL_64
			l_tmp___5: REAL_64
			l_min: REAL_64
			l_tmp___6: REAL_64
			l_rat: REAL_64
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_lnpow_val: REAL_64
			l_lnpow_err: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_t3: REAL_64
			l_lnopr: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gsx: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gsy: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_gsxy: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___9: REAL_64
			l_tmp___10: REAL_64
			l_lgx: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lgy: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lgxy: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sgx: CE_ARRAY [REAL_64]
			l_sgy: CE_ARRAY [REAL_64]
			l_sgxy: CE_ARRAY [REAL_64]
			l_xy: REAL_64
			l_stat_gx: INTEGER_32
			l_stat_gy: INTEGER_32
			l_stat_gxy: INTEGER_32
			l_tmp___17: REAL_64
			l_tmp___18: REAL_64
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lnopr.make (<<1>>)
			create l_gsx.make (<<1>>)
			create l_gsy.make (<<1>>)
			create l_gsxy.make (<<1>>)
			create l_lgx.make (<<1>>)
			create l_lgy.make (<<1>>)
			create l_lgxy.make (<<1>>)
			create l_sgx.make (<<1>>)
			create l_sgy.make (<<1>>)
			create l_sgxy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if a_y /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___0:
						a_sgn.item := 0.0
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("beta.c"), 56, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if not ((isnegint___0 (a_x)).truncated_to_integer.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not ((isnegint___0 (a_y)).truncated_to_integer.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						a_sgn.item := 0.0
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("beta.c"), 59, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 11 then -- if done | if done | if done
						if not js.return_called and then (a_x > (0).to_double) then
							if a_y > (0).to_double then
								if a_x > a_y then
									l_tmp___5 := a_x
								else
									l_tmp___5 := a_y
								end
								l_max := l_tmp___5
								if a_x < a_y then
									l_tmp___6 := a_x
								else
									l_tmp___6 := a_y
								end
								l_min := l_tmp___6
								l_rat := l_min / l_max
								if l_rat < 0.2 then
									gamma_inst.gsl_sf_gammastar_e (a_x, l_gsx).do_nothing
									gamma_inst.gsl_sf_gammastar_e (a_y, l_gsy).do_nothing
									gamma_inst.gsl_sf_gammastar_e (a_x + a_y, l_gsxy).do_nothing
									log_inst.gsl_sf_log_1plusx_e (l_rat, l_lnopr).do_nothing
									l_lnpre_val := log ((((l_gsx.item.val * l_gsy.item.val) / l_gsxy.item.val) * 1.41421356237309504880) * 1.77245385090551602729816748334)
									l_lnpre_err := (l_gsx.item.err / l_gsx.item.val + l_gsy.item.err / l_gsy.item.val) + l_gsxy.item.err / l_gsxy.item.val
									l_t1 := l_min * (log (l_rat))
									l_t2 := 0.5 * (log (l_min))
									l_t3 := ((a_x + a_y) - 0.5) * l_lnopr.item.val
									l_lnpow_val := (l_t1 - l_t2) - l_t3
									l_tmp___9 := fabs (l_t1)
									l_tmp___10 := fabs (l_t2)
									l_lnpow_err := 2.2204460492503131e-16 * ((l_tmp___9 + l_tmp___10) + (fabs (l_t3)))
									l_lnpow_err := l_lnpow_err + ((fabs ((a_x + a_y) - 0.5)) * l_lnopr.item.err)
									a_result.item.val := l_lnpre_val + l_lnpow_val
									a_result.item.err := l_lnpre_err + l_lnpow_err
									a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
									a_sgn.item := 1.0
									Result := 0
									js.return
								end
							end
						end
						if not js.return_called then
							l_xy := a_x + a_y
							l_stat_gx := (gamma_inst.gsl_sf_lngamma_sgn_e (a_x, l_lgx, l_sgx))
							l_stat_gy := (gamma_inst.gsl_sf_lngamma_sgn_e (a_y, l_lgy, l_sgy))
							l_stat_gxy := (gamma_inst.gsl_sf_lngamma_sgn_e (l_xy, l_lgxy, l_sgxy))
							a_sgn.item := (l_sgx.item * l_sgy.item) * l_sgxy.item
							a_result.item.val := (l_lgx.item.val + l_lgy.item.val) - l_lgxy.item.val
							a_result.item.err := (l_lgx.item.err + l_lgy.item.err) + l_lgxy.item.err
							l_tmp___17 := fabs (l_lgx.item.val)
							l_tmp___18 := fabs (l_lgy.item.val)
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * ((l_tmp___17 + l_tmp___18) + (fabs (l_lgxy.item.val))))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							if l_stat_gx /= 0 then
								l_tmp___23 := l_stat_gx
							else
								if l_stat_gy /= 0 then
									l_tmp___22 := l_stat_gy
								else
									if l_stat_gxy /= 0 then
										l_tmp___21 := l_stat_gxy
									else
										l_tmp___21 := 0
									end
									l_tmp___22 := l_tmp___21
								end
								l_tmp___23 := l_tmp___22
							end
							Result := l_tmp___23
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	isnegint___0 (a_x: REAL_64): REAL_64
		local
			l_tmp___0: INTEGER_32
		do
			if a_x < (0).to_double then
				if a_x = (floor (a_x)) then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0.to_double
		end

end
