class
	P_BIGAUSS

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_bivariate_gaussian (a_r___3: CE_POINTER [PD_GSL_RNG]; a_sigma_x: REAL_64; a_sigma_y: REAL_64; a_rho: REAL_64; a_x: CE_POINTER [REAL_64]; a_y: CE_POINTER [REAL_64])
		local
			l_u: REAL_64
			l_v: REAL_64
			l_r2___0: REAL_64
			l_scale: REAL_64
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				l_u := (-1).to_double + (2).to_double * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
				l_v := (-1).to_double + (2).to_double * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
				l_r2___0 := l_u * l_u + l_v * l_v
				if not (l_r2___0 > 1.0) then
					if l_r2___0 /= (0).to_double then
						js.break
					end
				end
			end
			l_scale := sqrt ((-2.0 * (log (l_r2___0))) / l_r2___0)
			a_x.item := (a_sigma_x * l_u) * l_scale
			a_y.item := (a_sigma_y * (a_rho * l_u + (sqrt ((1).to_double - a_rho * a_rho)) * l_v)) * l_scale
		end

	gsl_ran_bivariate_gaussian_pdf (a_x: REAL_64; a_y: REAL_64; a_sigma_x: REAL_64; a_sigma_y: REAL_64; a_rho: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_v: REAL_64
			l_c___1: REAL_64
			l_p: REAL_64
			l_tmp: REAL_64
		do
			l_u := a_x / a_sigma_x
			l_v := a_y / a_sigma_y
			l_c___1 := (1).to_double - a_rho * a_rho
			l_tmp := sqrt (l_c___1)
			l_p := ((1).to_double / (((((2).to_double * 3.14159265358979323846) * a_sigma_x) * a_sigma_y) * l_tmp)) * (exp (-((l_u * l_u - (((2).to_double * a_rho) * l_u) * l_v) + l_v * l_v) / ((2).to_double * l_c___1)))
			Result := l_p
		end

end
