class
	P_BINOMIAL_TPE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	Stirling (a_y1___0: REAL_64): REAL_64
		local
			l_y2: REAL_64
			l_s: REAL_64
		do
			l_y2 := a_y1___0 * a_y1___0
			l_s := ((13860.0 - (462.0 - (132.0 - (99.0 - 140.0 / l_y2) / l_y2) / l_y2) / l_y2) / a_y1___0) / 166320.0
			Result := l_s
		end

	gsl_ran_binomial (a_rng: CE_POINTER [PD_GSL_RNG]; a_p: REAL_64; a_n: NATURAL_32): NATURAL_32
		local
			l_p: REAL_64
			l_ix: INTEGER_32
			l_flipped: INTEGER_32
			l_q___3: REAL_64
			l_s: REAL_64
			l_np: REAL_64
			l_f0: REAL_64
			l_f: REAL_64
			l_u: REAL_64
			l_k: INTEGER_32
			l_ffm: REAL_64
			l_m___4: INTEGER_32
			l_fm: REAL_64
			l_xm: REAL_64
			l_npq: REAL_64
			l_p1: REAL_64
			l_xl: REAL_64
			l_xr: REAL_64
			l_c___1: REAL_64
			l_p2: REAL_64
			l_al: REAL_64
			l_lambda_l: REAL_64
			l_ar: REAL_64
			l_lambda_r: REAL_64
			l_p3: REAL_64
			l_p4: REAL_64
			l_var: REAL_64
			l_accept: REAL_64
			l_u___0: REAL_64
			l_v: REAL_64
			l_x: REAL_64
			l_g: REAL_64
			l_f___0: REAL_64
			l_i: INTEGER_32
			l_i___0: INTEGER_32
			l_amaxp: REAL_64
			l_ynorm: REAL_64
			l_x1___0: REAL_64
			l_w1: REAL_64
			l_f1: REAL_64
			l_z1: REAL_64
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_tmp___10: REAL_64
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
			l_tmp___14: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := a_p
					l_flipped := 0
					if a_n = {NATURAL_32} 0 then
						Result := {NATURAL_32} 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 33 -- skip if block
					end
				when 1 then -- if:
						if l_p > 0.5 then
							l_p := 1.0 - l_p
							l_flipped := 1
						end
						l_q___3 := (1).to_double - l_p
						l_s := l_p / l_q___3
						l_np := a_n.to_real_64 * l_p
						if not (l_np < (14).to_double) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_f0 := (pow_int_inst.gsl_pow_int (l_q___3, a_n.to_integer_32))
				when 3 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 9 -- skip loop
						end
				when 4 then -- loop body:
						l_f := l_f0
						l_u := (gsl_gsl_rng_inst.gsl_rng_uniform (a_rng))
						l_ix := 0
				when 5 then -- loop condition:
						if not (l_ix <= 110) then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						if l_u < l_f then
							l_pos := -1 + 32 -- goto Finish
						end
				when 7 then
						l_u := l_u - l_f
						l_f := l_f * ((l_s * (a_n - l_ix.to_natural_32).to_real_64) / (l_ix + 1).to_double)
						l_ix := l_ix + 1
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						l_pos := -1 + 3 -- back to loop condition
				when 9 then -- loop done | if block done, skip else block:
						l_pos := -1 + 32
				when 10 then -- else:
						l_ffm := l_np + l_p
						l_m___4 := l_ffm.truncated_to_integer
						l_fm := l_m___4.to_double
						l_xm := l_fm + 0.5
						l_npq := l_np * l_q___3
						l_p1 := (floor (2.195 * (sqrt (l_npq)) - 4.6 * l_q___3)) + 0.5
						l_xl := l_xm - l_p1
						l_xr := l_xm + l_p1
						l_c___1 := 0.134 + 20.5 / (15.3 + l_fm)
						l_p2 := l_p1 * ((1.0 + l_c___1) + l_c___1)
						l_al := (l_ffm - l_xl) / (l_ffm - l_xl * l_p)
						l_lambda_l := l_al * (1.0 + 0.5 * l_al)
						l_ar := (l_xr - l_ffm) / (l_xr * l_q___3)
						l_lambda_r := l_ar * (1.0 + 0.5 * l_ar)
						l_p3 := l_p2 + l_c___1 / l_lambda_l
						l_p4 := l_p3 + l_c___1 / l_lambda_r
				when 11 then -- TryAgain:
						l_u___0 := (gsl_gsl_rng_inst.gsl_rng_uniform (a_rng)) * l_p4
						l_v := gsl_gsl_rng_inst.gsl_rng_uniform (a_rng)
						if not (l_u___0 <= l_p1) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_ix := ((l_xm - l_p1 * l_v) + l_u___0).truncated_to_integer
						l_pos := -1 + 32 -- goto Finish
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 14 then -- else:
						if not (l_u___0 <= l_p2) then
							l_pos := -1 + 18 -- skip if block
						end
				when 15 then -- if:
						l_x := l_xl + (l_u___0 - l_p1) / l_c___1
						l_v := (l_v * l_c___1 + 1.0) - (fabs (l_x - l_xm)) / l_p1
						if l_v > 1.0 then
							l_pos := -1 + 11 -- goto TryAgain
						elseif l_v <= 0.0 then
							l_pos := -1 + 11 -- goto TryAgain
						end
				when 16 then
						l_ix := l_x.truncated_to_integer
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 18 then -- else:
						if not (l_u___0 <= l_p3) then
							l_pos := -1 + 22 -- skip if block
						end
				when 19 then -- if:
						l_ix := (l_xl + (log (l_v)) / l_lambda_l).truncated_to_integer
						if l_ix < 0 then
							l_pos := -1 + 11 -- goto TryAgain
						end
				when 20 then
						l_v := l_v * ((l_u___0 - l_p2) * l_lambda_l)
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 22 then -- else:
						l_ix := (l_xr - (log (l_v)) / l_lambda_r).truncated_to_integer
						if l_ix.to_double > a_n.to_real_64 then
							l_pos := -1 + 11 -- goto TryAgain
						end
				when 23 then
						l_v := l_v * ((l_u___0 - l_p3) * l_lambda_r)
				when 24 then -- if done | if done
						l_k := abs (l_ix - l_m___4)
						if not (l_k <= 20) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_g := (a_n + {NATURAL_32} 1).to_real_64 * l_s
						l_f___0 := 1.0
						l_var := l_v
						if l_m___4 < l_ix then
							l_i := l_m___4 + 1
							from
							until
								not (l_i <= l_ix)
							loop
								l_f___0 := l_f___0 * (l_g / l_i.to_double - l_s)
								l_i := l_i + 1
							end
						elseif l_m___4 > l_ix then
							l_i___0 := l_ix + 1
							from
							until
								not (l_i___0 <= l_m___4)
							loop
								l_f___0 := l_f___0 / (l_g / l_i___0.to_double - l_s)
								l_i___0 := l_i___0 + 1
							end
						end
						l_accept := l_f___0
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 27 then -- else:
						l_var := log (l_v)
						if not (l_k.to_double < l_npq / (2).to_double - (1).to_double) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_amaxp := (l_k.to_double / l_npq) * ((l_k.to_double * (l_k.to_double / 3.0 + 0.625) + 1.0 / 6.0) / l_npq + 0.5)
						l_ynorm := -((l_k * l_k).to_double / (2.0 * l_npq))
						if l_var < l_ynorm - l_amaxp then
							l_pos := -1 + 32 -- goto Finish
						end
				when 29 then
						if l_var > l_ynorm + l_amaxp then
							l_pos := -1 + 11 -- goto TryAgain
						end
				when 30 then
						l_x1___0 := l_ix.to_double + 1.0
						l_w1 := (a_n - l_ix.to_natural_32).to_real_64 + 1.0
						l_f1 := l_fm + 1.0
						l_z1 := (a_n.to_real_64 + 1.0) - l_fm
						l_tmp___7 := log (l_f1 / l_x1___0)
						l_tmp___8 := log (l_z1 / l_w1)
						l_tmp___9 := log ((l_w1 * l_p) / (l_x1___0 * l_q___3))
						l_tmp___10 := Stirling (l_f1)
						l_tmp___11 := Stirling (l_z1)
						l_tmp___12 := Stirling (l_x1___0)
						l_accept := (((((l_xm * l_tmp___7 + ((a_n - l_m___4.to_natural_32).to_real_64 + 0.5) * l_tmp___8) + (l_ix - l_m___4).to_double * l_tmp___9) + l_tmp___10) + l_tmp___11) - l_tmp___12) - (Stirling (l_w1))
				when 31 then -- if done
						if l_var <= l_accept then
							l_pos := -1 + 32 -- goto Finish
						else
							l_pos := -1 + 11 -- goto TryAgain
						end
				when 32 then -- Finish:
						if l_flipped.to_boolean then
							l_tmp___14 := a_n - l_ix.to_natural_32
						else
							l_tmp___14 := l_ix.to_natural_32
						end
						Result := l_tmp___14
				when 33 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_ran_binomial_tpe (a_rng: CE_POINTER [PD_GSL_RNG]; a_p: REAL_64; a_n: NATURAL_32): NATURAL_32
		do
			Result := (gsl_ran_binomial (a_rng, a_p, a_n))
		end

end
