class
	P_BRACKETING

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_min_find_bracket (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum: CE_POINTER [REAL_64]; a_f_minimum: CE_POINTER [REAL_64]; a_x_lower: CE_POINTER [REAL_64]; a_f_lower: CE_POINTER [REAL_64]; a_x_upper: CE_POINTER [REAL_64]; a_f_upper: CE_POINTER [REAL_64]; a_eval_max: NATURAL_32): INTEGER_32
		local
			l_f_left: REAL_64
			l_f_right: REAL_64
			l_f_center: REAL_64
			l_x_left: REAL_64
			l_x_right: REAL_64
			l_x_center: REAL_64
			l_golden: REAL_64
			l_nb_eval: NATURAL_32
			js: JUMP_STATE
		do
			l_f_left := a_f_lower.item
			l_f_right := a_f_upper.item
			l_x_left := a_x_lower.item
			l_x_right := a_x_upper.item
			l_golden := 0.3819660
			l_nb_eval := (0).to_natural_32
			if l_f_right >= l_f_left then
				l_x_center := (l_x_right - l_x_left) * l_golden + l_x_left
				l_nb_eval := l_nb_eval + 1
				from
				until
					js.loop_done
				loop
					l_f_center := ((a_f.item.function).real_64_item ([l_x_center, a_f.item.params]))
					if not (infnan_inst.gsl_finite (l_f_center)).to_boolean then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("computed function value is infinite or NaN"), ce_string ("bracketing.c"), 58, 9)
							Result := 9
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						js.break
					end
				end
			else
				l_x_center := l_x_right
				l_f_center := l_f_right
				l_x_right := (l_x_center - l_x_left) / l_golden + l_x_left
				l_nb_eval := l_nb_eval + 1
				from
				until
					js.loop_done
				loop
					l_f_right := ((a_f.item.function).real_64_item ([l_x_right, a_f.item.params]))
					if not (infnan_inst.gsl_finite (l_f_right)).to_boolean then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("computed function value is infinite or NaN"), ce_string ("bracketing.c"), 66, 9)
							Result := 9
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if l_f_center < l_f_left then
						if l_f_center < l_f_right then
							a_x_lower.item := l_x_left
							a_x_upper.item := l_x_right
							a_x_minimum.item := l_x_center
							a_f_lower.item := l_f_left
							a_f_upper.item := l_f_right
							a_f_minimum.item := l_f_center
							Result := 0
							js.return
						elseif l_f_center > l_f_right then
							l_x_left := l_x_center
							l_f_left := l_f_center
							l_x_center := l_x_right
							l_f_center := l_f_right
							l_x_right := (l_x_center - l_x_left) / l_golden + l_x_left
							l_nb_eval := l_nb_eval + 1
							from
							until
								js.loop_done
							loop
								l_f_right := ((a_f.item.function).real_64_item ([l_x_right, a_f.item.params]))
								if not (infnan_inst.gsl_finite (l_f_right)).to_boolean then
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("computed function value is infinite or NaN"), ce_string ("bracketing.c"), 95, 9)
										Result := 9
										js.return
										if not js.return_called then
											js.break
										end
									end
								end
								if not js.return_called then
									js.break
								end
							end
						else
							l_x_right := l_x_center
							l_f_right := l_f_center
							l_x_center := (l_x_right - l_x_left) * l_golden + l_x_left
							l_nb_eval := l_nb_eval + 1
							from
							until
								js.loop_done
							loop
								l_f_center := ((a_f.item.function).real_64_item ([l_x_center, a_f.item.params]))
								if not (infnan_inst.gsl_finite (l_f_center)).to_boolean then
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("computed function value is infinite or NaN"), ce_string ("bracketing.c"), 103, 9)
										Result := 9
										js.return
										if not js.return_called then
											js.break
										end
									end
								end
								if not js.return_called then
									js.break
								end
							end
						end
					else
						l_x_right := l_x_center
						l_f_right := l_f_center
						l_x_center := (l_x_right - l_x_left) * l_golden + l_x_left
						l_nb_eval := l_nb_eval + 1
						from
						until
							js.loop_done
						loop
							l_f_center := ((a_f.item.function).real_64_item ([l_x_center, a_f.item.params]))
							if not (infnan_inst.gsl_finite (l_f_center)).to_boolean then
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("computed function value is infinite or NaN"), ce_string ("bracketing.c"), 112, 9)
									Result := 9
									js.return
									if not js.return_called then
										js.break
									end
								end
							end
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						if l_nb_eval < a_eval_max then
							if not (l_x_right - l_x_left > 1.4901161193847656e-08 * ((l_x_right + l_x_left) * 0.5) + 1.4901161193847656e-08) then
								js.break
							end
						else
							js.break
						end
					end
				end
			end
			if not js.return_called then
				a_x_lower.item := l_x_left
				a_x_upper.item := l_x_right
				a_x_minimum.item := l_x_center
				a_f_lower.item := l_f_left
				a_f_upper.item := l_f_right
				a_f_minimum.item := l_f_center
				Result := (-1)
			end
		end

end
