class
	P_C_PASS_6

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	fft_complex_float_pass_6 (a_in: CE_POINTER [REAL_32]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_32]; a_ostride: NATURAL_32; a_sign: INTEGER_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle1: CE_POINTER [PD_GSL_COMPLEX_FLOAT]; a_twiddle2: CE_POINTER [PD_GSL_COMPLEX_FLOAT]; a_twiddle3: CE_POINTER [PD_GSL_COMPLEX_FLOAT]; a_twiddle4: CE_POINTER [PD_GSL_COMPLEX_FLOAT]; a_twiddle5: CE_POINTER [PD_GSL_COMPLEX_FLOAT]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_factor: NATURAL_32
			l_m___4: NATURAL_32
			l_q___3: NATURAL_32
			l_p_1: NATURAL_32
			l_jump: NATURAL_32
			l_tau: REAL_32
			l_w1_real: REAL_32
			l_w1_imag: REAL_32
			l_w2_real: REAL_32
			l_w2_imag: REAL_32
			l_w3_real: REAL_32
			l_w3_imag: REAL_32
			l_w4_real: REAL_32
			l_w4_imag: REAL_32
			l_w5_real: REAL_32
			l_w5_imag: REAL_32
			l_z0_real: REAL_32
			l_z0_imag: REAL_32
			l_z1_real: REAL_32
			l_z1_imag: REAL_32
			l_z2_real: REAL_32
			l_z2_imag: REAL_32
			l_z3_real: REAL_32
			l_z3_imag: REAL_32
			l_z4_real: REAL_32
			l_z4_imag: REAL_32
			l_z5_real: REAL_32
			l_z5_imag: REAL_32
			l_ta1_real: REAL_32
			l_ta1_imag: REAL_32
			l_ta2_real: REAL_32
			l_ta2_imag: REAL_32
			l_ta3_real: REAL_32
			l_ta3_imag: REAL_32
			l_a0_real: REAL_32
			l_a0_imag: REAL_32
			l_a1_real: REAL_32
			l_a1_imag: REAL_32
			l_a2_real: REAL_32
			l_a2_imag: REAL_32
			l_tb1_real: REAL_32
			l_tb1_imag: REAL_32
			l_tb2_real: REAL_32
			l_tb2_imag: REAL_32
			l_tb3_real: REAL_32
			l_tb3_imag: REAL_32
			l_b0_real: REAL_32
			l_b0_imag: REAL_32
			l_b1_real: REAL_32
			l_b1_imag: REAL_32
			l_b2_real: REAL_32
			l_b2_imag: REAL_32
			l_x0_real: REAL_32
			l_x0_imag: REAL_32
			l_x4_real: REAL_32
			l_x4_imag: REAL_32
			l_x2_real: REAL_32
			l_x2_imag: REAL_32
			l_x3_real: REAL_32
			l_x3_imag: REAL_32
			l_x1_real: REAL_32
			l_x1_imag: REAL_32
			l_x5_real: REAL_32
			l_x5_imag: REAL_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			l_j := (0).to_natural_32
			l_factor := (6).to_natural_32
			l_m___4 := a_n // l_factor
			l_q___3 := a_n // a_product
			l_p_1 := a_product // l_factor
			l_jump := (l_factor - {NATURAL_32} 1) * l_p_1
			l_tau := ((sqrt (3.0)) / 2.0).truncated_to_real
			l_k := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_k < l_q___3))
			loop
				if l_k = {NATURAL_32} 0 then
					l_w1_real := (1.0).truncated_to_real
					l_w1_imag := (0.0).truncated_to_real
					l_w2_real := (1.0).truncated_to_real
					l_w2_imag := (0.0).truncated_to_real
					l_w3_real := (1.0).truncated_to_real
					l_w3_imag := (0.0).truncated_to_real
					l_w4_real := (1.0).truncated_to_real
					l_w4_imag := (0.0).truncated_to_real
					l_w5_real := (1.0).truncated_to_real
					l_w5_imag := (0.0).truncated_to_real
				elseif a_sign = -1 then
					l_w1_real := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w1_imag := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w2_real := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w2_imag := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w3_real := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w3_imag := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w4_real := (a_twiddle4 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w4_imag := (a_twiddle4 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w5_real := (a_twiddle5 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w5_imag := (a_twiddle5 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
				else
					l_w1_real := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w1_imag := -(a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w2_real := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w2_imag := -(a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w3_real := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w3_imag := -(a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w4_real := (a_twiddle4 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w4_imag := -(a_twiddle4 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w5_real := (a_twiddle5 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w5_imag := -(a_twiddle5 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
				end
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_p_1)
				loop
					l_z0_real := a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32]
					l_z0_imag := a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32]
					l_z1_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_m___4)).to_integer_32]
					l_z1_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_z2_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 2 * l_m___4)).to_integer_32]
					l_z2_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 2 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_z3_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 3 * l_m___4)).to_integer_32]
					l_z3_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 3 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_z4_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 4 * l_m___4)).to_integer_32]
					l_z4_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 4 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_z5_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 5 * l_m___4)).to_integer_32]
					l_z5_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 5 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_ta1_real := l_z2_real + l_z4_real
					l_ta1_imag := l_z2_imag + l_z4_imag
					l_ta2_real := l_z0_real - l_ta1_real / (2).to_real
					l_ta2_imag := l_z0_imag - l_ta1_imag / (2).to_real
					l_ta3_real := (a_sign.to_real * l_tau) * (l_z2_real - l_z4_real)
					l_ta3_imag := (a_sign.to_real * l_tau) * (l_z2_imag - l_z4_imag)
					l_a0_real := l_z0_real + l_ta1_real
					l_a0_imag := l_z0_imag + l_ta1_imag
					l_a1_real := l_ta2_real - l_ta3_imag
					l_a1_imag := l_ta2_imag + l_ta3_real
					l_a2_real := l_ta2_real + l_ta3_imag
					l_a2_imag := l_ta2_imag - l_ta3_real
					l_tb1_real := l_z5_real + l_z1_real
					l_tb1_imag := l_z5_imag + l_z1_imag
					l_tb2_real := l_z3_real - l_tb1_real / (2).to_real
					l_tb2_imag := l_z3_imag - l_tb1_imag / (2).to_real
					l_tb3_real := (a_sign.to_real * l_tau) * (l_z5_real - l_z1_real)
					l_tb3_imag := (a_sign.to_real * l_tau) * (l_z5_imag - l_z1_imag)
					l_b0_real := l_z3_real + l_tb1_real
					l_b0_imag := l_z3_imag + l_tb1_imag
					l_b1_real := l_tb2_real - l_tb3_imag
					l_b1_imag := l_tb2_imag + l_tb3_real
					l_b2_real := l_tb2_real + l_tb3_imag
					l_b2_imag := l_tb2_imag - l_tb3_real
					l_x0_real := l_a0_real + l_b0_real
					l_x0_imag := l_a0_imag + l_b0_imag
					l_x4_real := l_a1_real + l_b1_real
					l_x4_imag := l_a1_imag + l_b1_imag
					l_x2_real := l_a2_real + l_b2_real
					l_x2_imag := l_a2_imag + l_b2_imag
					l_x3_real := l_a0_real - l_b0_real
					l_x3_imag := l_a0_imag - l_b0_imag
					l_x1_real := l_a1_real - l_b1_real
					l_x1_imag := l_a1_imag - l_b1_imag
					l_x5_real := l_a2_real - l_b2_real
					l_x5_imag := l_a2_imag - l_b2_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * l_j).to_integer_32] := l_x0_real
					a_out[(({NATURAL_32} 2 * a_ostride) * l_j + {NATURAL_32} 1).to_integer_32] := l_x0_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + l_p_1)).to_integer_32] := l_w1_real * l_x1_real - l_w1_imag * l_x1_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w1_real * l_x1_imag + l_w1_imag * l_x1_real
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 2 * l_p_1)).to_integer_32] := l_w2_real * l_x2_real - l_w2_imag * l_x2_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 2 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w2_real * l_x2_imag + l_w2_imag * l_x2_real
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 3 * l_p_1)).to_integer_32] := l_w3_real * l_x3_real - l_w3_imag * l_x3_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 3 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w3_real * l_x3_imag + l_w3_imag * l_x3_real
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 4 * l_p_1)).to_integer_32] := l_w4_real * l_x4_real - l_w4_imag * l_x4_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 4 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w4_real * l_x4_imag + l_w4_imag * l_x4_real
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 5 * l_p_1)).to_integer_32] := l_w5_real * l_x5_real - l_w5_imag * l_x5_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 5 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w5_real * l_x5_imag + l_w5_imag * l_x5_real
					l_i := l_i + 1
					l_j := l_j + 1
					l_k1 := l_k1 + 1
				end
				l_j := l_j + l_jump
				l_k := l_k + 1
			end
			Result := 0
		end

	fft_complex_pass_6 (a_in: CE_POINTER [REAL_64]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_64]; a_ostride: NATURAL_32; a_sign: INTEGER_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle1: CE_POINTER [PD_GSL_COMPLEX]; a_twiddle2: CE_POINTER [PD_GSL_COMPLEX]; a_twiddle3: CE_POINTER [PD_GSL_COMPLEX]; a_twiddle4: CE_POINTER [PD_GSL_COMPLEX]; a_twiddle5: CE_POINTER [PD_GSL_COMPLEX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_factor: NATURAL_32
			l_m___4: NATURAL_32
			l_q___3: NATURAL_32
			l_p_1: NATURAL_32
			l_jump: NATURAL_32
			l_tau: REAL_64
			l_w1_real: REAL_64
			l_w1_imag: REAL_64
			l_w2_real: REAL_64
			l_w2_imag: REAL_64
			l_w3_real: REAL_64
			l_w3_imag: REAL_64
			l_w4_real: REAL_64
			l_w4_imag: REAL_64
			l_w5_real: REAL_64
			l_w5_imag: REAL_64
			l_z0_real: REAL_64
			l_z0_imag: REAL_64
			l_z1_real: REAL_64
			l_z1_imag: REAL_64
			l_z2_real: REAL_64
			l_z2_imag: REAL_64
			l_z3_real: REAL_64
			l_z3_imag: REAL_64
			l_z4_real: REAL_64
			l_z4_imag: REAL_64
			l_z5_real: REAL_64
			l_z5_imag: REAL_64
			l_ta1_real: REAL_64
			l_ta1_imag: REAL_64
			l_ta2_real: REAL_64
			l_ta2_imag: REAL_64
			l_ta3_real: REAL_64
			l_ta3_imag: REAL_64
			l_a0_real: REAL_64
			l_a0_imag: REAL_64
			l_a1_real: REAL_64
			l_a1_imag: REAL_64
			l_a2_real: REAL_64
			l_a2_imag: REAL_64
			l_tb1_real: REAL_64
			l_tb1_imag: REAL_64
			l_tb2_real: REAL_64
			l_tb2_imag: REAL_64
			l_tb3_real: REAL_64
			l_tb3_imag: REAL_64
			l_b0_real: REAL_64
			l_b0_imag: REAL_64
			l_b1_real: REAL_64
			l_b1_imag: REAL_64
			l_b2_real: REAL_64
			l_b2_imag: REAL_64
			l_x0_real: REAL_64
			l_x0_imag: REAL_64
			l_x4_real: REAL_64
			l_x4_imag: REAL_64
			l_x2_real: REAL_64
			l_x2_imag: REAL_64
			l_x3_real: REAL_64
			l_x3_imag: REAL_64
			l_x1_real: REAL_64
			l_x1_imag: REAL_64
			l_x5_real: REAL_64
			l_x5_imag: REAL_64
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			l_j := (0).to_natural_32
			l_factor := (6).to_natural_32
			l_m___4 := a_n // l_factor
			l_q___3 := a_n // a_product
			l_p_1 := a_product // l_factor
			l_jump := (l_factor - {NATURAL_32} 1) * l_p_1
			l_tau := (sqrt (3.0)) / 2.0
			l_k := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_k < l_q___3))
			loop
				if l_k = {NATURAL_32} 0 then
					l_w1_real := 1.0
					l_w1_imag := 0.0
					l_w2_real := 1.0
					l_w2_imag := 0.0
					l_w3_real := 1.0
					l_w3_imag := 0.0
					l_w4_real := 1.0
					l_w4_imag := 0.0
					l_w5_real := 1.0
					l_w5_imag := 0.0
				elseif a_sign = -1 then
					l_w1_real := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w1_imag := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w2_real := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w2_imag := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w3_real := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w3_imag := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w4_real := (a_twiddle4 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w4_imag := (a_twiddle4 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w5_real := (a_twiddle5 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w5_imag := (a_twiddle5 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
				else
					l_w1_real := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w1_imag := -(a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w2_real := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w2_imag := -(a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w3_real := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w3_imag := -(a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w4_real := (a_twiddle4 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w4_imag := -(a_twiddle4 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w5_real := (a_twiddle5 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w5_imag := -(a_twiddle5 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
				end
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_p_1)
				loop
					l_z0_real := a_in[(({NATURAL_32} 2 * a_istride) * l_i).to_integer_32]
					l_z0_imag := a_in[(({NATURAL_32} 2 * a_istride) * l_i + {NATURAL_32} 1).to_integer_32]
					l_z1_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_m___4)).to_integer_32]
					l_z1_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_z2_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 2 * l_m___4)).to_integer_32]
					l_z2_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 2 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_z3_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 3 * l_m___4)).to_integer_32]
					l_z3_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 3 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_z4_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 4 * l_m___4)).to_integer_32]
					l_z4_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 4 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_z5_real := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 5 * l_m___4)).to_integer_32]
					l_z5_imag := a_in[(({NATURAL_32} 2 * a_istride) * (l_i + {NATURAL_32} 5 * l_m___4) + {NATURAL_32} 1).to_integer_32]
					l_ta1_real := l_z2_real + l_z4_real
					l_ta1_imag := l_z2_imag + l_z4_imag
					l_ta2_real := l_z0_real - l_ta1_real / (2).to_double
					l_ta2_imag := l_z0_imag - l_ta1_imag / (2).to_double
					l_ta3_real := (a_sign.to_double * l_tau) * (l_z2_real - l_z4_real)
					l_ta3_imag := (a_sign.to_double * l_tau) * (l_z2_imag - l_z4_imag)
					l_a0_real := l_z0_real + l_ta1_real
					l_a0_imag := l_z0_imag + l_ta1_imag
					l_a1_real := l_ta2_real - l_ta3_imag
					l_a1_imag := l_ta2_imag + l_ta3_real
					l_a2_real := l_ta2_real + l_ta3_imag
					l_a2_imag := l_ta2_imag - l_ta3_real
					l_tb1_real := l_z5_real + l_z1_real
					l_tb1_imag := l_z5_imag + l_z1_imag
					l_tb2_real := l_z3_real - l_tb1_real / (2).to_double
					l_tb2_imag := l_z3_imag - l_tb1_imag / (2).to_double
					l_tb3_real := (a_sign.to_double * l_tau) * (l_z5_real - l_z1_real)
					l_tb3_imag := (a_sign.to_double * l_tau) * (l_z5_imag - l_z1_imag)
					l_b0_real := l_z3_real + l_tb1_real
					l_b0_imag := l_z3_imag + l_tb1_imag
					l_b1_real := l_tb2_real - l_tb3_imag
					l_b1_imag := l_tb2_imag + l_tb3_real
					l_b2_real := l_tb2_real + l_tb3_imag
					l_b2_imag := l_tb2_imag - l_tb3_real
					l_x0_real := l_a0_real + l_b0_real
					l_x0_imag := l_a0_imag + l_b0_imag
					l_x4_real := l_a1_real + l_b1_real
					l_x4_imag := l_a1_imag + l_b1_imag
					l_x2_real := l_a2_real + l_b2_real
					l_x2_imag := l_a2_imag + l_b2_imag
					l_x3_real := l_a0_real - l_b0_real
					l_x3_imag := l_a0_imag - l_b0_imag
					l_x1_real := l_a1_real - l_b1_real
					l_x1_imag := l_a1_imag - l_b1_imag
					l_x5_real := l_a2_real - l_b2_real
					l_x5_imag := l_a2_imag - l_b2_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * l_j).to_integer_32] := l_x0_real
					a_out[(({NATURAL_32} 2 * a_ostride) * l_j + {NATURAL_32} 1).to_integer_32] := l_x0_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + l_p_1)).to_integer_32] := l_w1_real * l_x1_real - l_w1_imag * l_x1_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w1_real * l_x1_imag + l_w1_imag * l_x1_real
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 2 * l_p_1)).to_integer_32] := l_w2_real * l_x2_real - l_w2_imag * l_x2_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 2 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w2_real * l_x2_imag + l_w2_imag * l_x2_real
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 3 * l_p_1)).to_integer_32] := l_w3_real * l_x3_real - l_w3_imag * l_x3_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 3 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w3_real * l_x3_imag + l_w3_imag * l_x3_real
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 4 * l_p_1)).to_integer_32] := l_w4_real * l_x4_real - l_w4_imag * l_x4_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 4 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w4_real * l_x4_imag + l_w4_imag * l_x4_real
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 5 * l_p_1)).to_integer_32] := l_w5_real * l_x5_real - l_w5_imag * l_x5_imag
					a_out[(({NATURAL_32} 2 * a_ostride) * (l_j + {NATURAL_32} 5 * l_p_1) + {NATURAL_32} 1).to_integer_32] := l_w5_real * l_x5_imag + l_w5_imag * l_x5_real
					l_i := l_i + 1
					l_j := l_j + 1
					l_k1 := l_k1 + 1
				end
				l_j := l_j + l_jump
				l_k := l_k + 1
			end
			Result := 0
		end

end
