class
	P_CAUCHY

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_cauchy_P (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_u: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u > (-1).to_double then
				l_P___2 := 0.5 + (atan (l_u)) / 3.14159265358979323846
			else
				l_P___2 := (atan ((-1).to_double / l_u)) / 3.14159265358979323846
			end
			Result := l_P___2
		end

	gsl_cdf_cauchy_Q (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_u: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u < (1).to_double then
				l_Q___1 := 0.5 - (atan (l_u)) / 3.14159265358979323846
			else
				l_Q___1 := (atan ((1).to_double / l_u)) / 3.14159265358979323846
			end
			Result := l_Q___1
		end

	gsl_ran_cauchy (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64): REAL_64
		local
			l_u: REAL_64
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				l_u := gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3)
				if l_u /= 0.5 then
					js.break
				end
			end
			Result := (a_a___5 * (tan (3.14159265358979323846 * l_u)))
		end

	gsl_ran_cauchy_pdf (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_p: REAL_64
		do
			l_u := a_x / a_a___5
			l_p := ((1).to_double / (3.14159265358979323846 * a_a___5)) / ((1).to_double + l_u * l_u)
			Result := l_p
		end

end
