class
	P_CMRG

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create cmrg_type.make (<<1>>)
			create gsl_rng_cmrg.make
		end

feature {ANY} -- attributes

	a2___2: INTEGER_32 assign set_a2___2

	set_a2___2 (a_a2___2: INTEGER_32)
		do
			a2___2 := a_a2___2
		end

	a32: INTEGER_32 assign set_a32

	set_a32 (a_a32: INTEGER_32)
		do
			a32 := a_a32
		end

	b1: INTEGER_32 assign set_b1

	set_b1 (a_b1: INTEGER_32)
		do
			b1 := a_b1
		end

	b3___2: INTEGER_32 assign set_b3___2

	set_b3___2 (a_b3___2: INTEGER_32)
		do
			b3___2 := a_b3___2
		end

	cmrg_type: CE_ARRAY [PD_GSL_RNG_TYPE]

	gsl_rng_cmrg: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_cmrg

	set_gsl_rng_cmrg (a_gsl_rng_cmrg: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_cmrg := a_gsl_rng_cmrg
		end

	m1___2: INTEGER_32 assign set_m1___2

	set_m1___2 (a_m1___2: INTEGER_32)
		do
			m1___2 := a_m1___2
		end

	m2___2: INTEGER_32 assign set_m2___2

	set_m2___2 (a_m2___2: INTEGER_32)
		do
			m2___2 := a_m2___2
		end

	qa2: INTEGER_32 assign set_qa2

	set_qa2 (a_qa2: INTEGER_32)
		do
			qa2 := a_qa2
		end

	qa3: INTEGER_32 assign set_qa3

	set_qa3 (a_qa3: INTEGER_32)
		do
			qa3 := a_qa3
		end

	qb1: INTEGER_32 assign set_qb1

	set_qb1 (a_qb1: INTEGER_32)
		do
			qb1 := a_qb1
		end

	qb3: INTEGER_32 assign set_qb3

	set_qb3 (a_qb3: INTEGER_32)
		do
			qb3 := a_qb3
		end

	ra2: INTEGER_32 assign set_ra2

	set_ra2 (a_ra2: INTEGER_32)
		do
			ra2 := a_ra2
		end

	ra3: INTEGER_32 assign set_ra3

	set_ra3 (a_ra3: INTEGER_32)
		do
			ra3 := a_ra3
		end

	rb1: INTEGER_32 assign set_rb1

	set_rb1 (a_rb1: INTEGER_32)
		do
			rb1 := a_rb1
		end

	rb3: INTEGER_32 assign set_rb3

	set_rb3 (a_rb3: INTEGER_32)
		do
			rb3 := a_rb3
		end

feature {ANY} -- routines

	cmrg_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_CMRG_STATE_T]
			l_h3: INTEGER_32
			l_p3: INTEGER_32
			l_h2: INTEGER_32
			l_p2: INTEGER_32
			l_h3___0: INTEGER_32
			l_p3___0: INTEGER_32
			l_h1: INTEGER_32
			l_p1: INTEGER_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_CMRG_STATE_T]}.make_cast (a_vstate)
			l_h3 := l_state.item.x3 // qa3
			l_p3 := (-a32 * (l_state.item.x3 - l_h3 * qa3) - (l_h3 * ra3))
			l_h2 := l_state.item.x2 // qa2
			l_p2 := (a2___2 * (l_state.item.x2 - l_h2 * qa2) - (l_h2 * ra2))
			if l_p3 < 0 then
				l_p3 := l_p3 + m1___2
			end
			if l_p2 < 0 then
				l_p2 := l_p2 + m1___2
			end
			l_state.item.x3 := l_state.item.x2
			l_state.item.x2 := l_state.item.x1
			l_state.item.x1 := l_p2 - l_p3
			if l_state.item.x1 < 0 then
				l_state.item.x1 := l_state.item.x1 + m1___2
			end
			l_h3___0 := l_state.item.y3 // qb3
			l_p3___0 := (-b3___2 * (l_state.item.y3 - l_h3___0 * qb3) - (l_h3___0 * rb3))
			l_h1 := l_state.item.y1 // qb1
			l_p1 := (b1 * (l_state.item.y1 - l_h1 * qb1) - (l_h1 * rb1))
			if l_p3___0 < 0 then
				l_p3___0 := l_p3___0 + m2___2
			end
			if l_p1 < 0 then
				l_p1 := l_p1 + m2___2
			end
			l_state.item.y3 := l_state.item.y2
			l_state.item.y2 := l_state.item.y1
			l_state.item.y1 := l_p1 - l_p3___0
			if l_state.item.y1 < 0 then
				l_state.item.y1 := l_state.item.y1 + m2___2
			end
			if l_state.item.x1 < l_state.item.y1 then
				Result := ((l_state.item.x1 - l_state.item.y1) + m1___2).to_natural_32
			else
				Result := (l_state.item.x1 - l_state.item.y1).to_natural_32
			end
		end

	cmrg_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmrg_get)
		end

	cmrg_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((cmrg_get (a_vstate)).to_real_64 / 2147483647.0)
		end

	cmrg_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmrg_get_double)
		end

	cmrg_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_CMRG_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_CMRG_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x1 := (l_s \\ m1___2.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x2 := (l_s \\ m1___2.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x3 := (l_s \\ m1___2.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.y1 := (l_s \\ m2___2.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.y2 := (l_s \\ m2___2.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.y3 := (l_s \\ m2___2.to_natural_32).to_integer_32
			cmrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
		end

	cmrg_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmrg_set)
		end

end
