class
	P_COPY

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_clone (a_src: CE_POINTER [PD_GSL_HISTOGRAM]): CE_POINTER [PD_GSL_HISTOGRAM]
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_h: CE_POINTER [PD_GSL_HISTOGRAM]
			js: JUMP_STATE
		do
			create l_h.make

			l_n := a_src.item.n
			l_h := calloc_range_inst.gsl_histogram_calloc_range (l_n, a_src.item.range)
			if l_h.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for histogram struct"), ce_string ("copy.c"), 82, 8)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_h.item.bin[l_i.to_integer_32] := a_src.item.bin[l_i.to_integer_32]
					l_i := l_i + 1
				end
				Result := l_h
			end
		end

	gsl_histogram_memcpy (a_dest: CE_POINTER [PD_GSL_HISTOGRAM]; a_src: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_src.item.n
			if a_dest.item.n /= a_src.item.n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("histograms have different sizes, cannot copy"), ce_string ("copy.c"), 48, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i <= l_n)
				loop
					a_dest.item.range[l_i.to_integer_32] := a_src.item.range[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					a_dest.item.bin[l_i.to_integer_32] := a_src.item.bin[l_i.to_integer_32]
					l_i := l_i + 1
				end
				Result := 0
			end
		end

end
