class
	P_CSPLINE

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create cspline_periodic_type.make (<<1>>)
			create cspline_type.make (<<1>>)
			create gsl_interp_cspline.make
			create gsl_interp_cspline_periodic.make
		end

feature {ANY} -- attributes

	cspline_periodic_type: CE_ARRAY [PD_GSL_INTERP_TYPE]

	cspline_type: CE_ARRAY [PD_GSL_INTERP_TYPE]

	gsl_interp_cspline: CE_POINTER [PD_GSL_INTERP_TYPE] assign set_gsl_interp_cspline

	set_gsl_interp_cspline (a_gsl_interp_cspline: CE_POINTER [PD_GSL_INTERP_TYPE])
		do
			gsl_interp_cspline := a_gsl_interp_cspline
		end

	gsl_interp_cspline_periodic: CE_POINTER [PD_GSL_INTERP_TYPE] assign set_gsl_interp_cspline_periodic

	set_gsl_interp_cspline_periodic (a_gsl_interp_cspline_periodic: CE_POINTER [PD_GSL_INTERP_TYPE])
		do
			gsl_interp_cspline_periodic := a_gsl_interp_cspline_periodic
		end

feature {ANY} -- routines

	coeff_calc (a_c_array: CE_POINTER [REAL_64]; a_dy: REAL_64; a_dx: REAL_64; a_index: NATURAL_32; a_b___0: CE_POINTER [REAL_64]; a_c___1: CE_POINTER [REAL_64]; a_d: CE_POINTER [REAL_64])
		local
			l_c_i: REAL_64
			l_c_ip1: REAL_64
		do
			l_c_i := a_c_array[a_index.to_integer_32]
			l_c_ip1 := a_c_array[(a_index + {NATURAL_32} 1).to_integer_32]
			a_b___0.item := a_dy / a_dx - (a_dx * (l_c_ip1 + 2.0 * l_c_i)) / 3.0
			a_c___1.item := l_c_i
			a_d.item := (l_c_ip1 - l_c_i) / (3.0 * a_dx)
		end

	cspline_alloc (a_size: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_CSPLINE_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_CSPLINE_STATE_T]}.make_cast ((malloc ((create {PD_CSPLINE_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for state"), ce_string ("cspline.c"), 47, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.c := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.c).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for c"), ce_string ("cspline.c"), 55, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.g := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.g).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.c))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for g"), ce_string ("cspline.c"), 64, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.diag := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.diag).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.g))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.c))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for diag"), ce_string ("cspline.c"), 74, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.offdiag := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.offdiag).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.diag))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.g))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.c))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for offdiag"), ce_string ("cspline.c"), 85, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	cspline_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cspline_alloc)
		end

	cspline_eval (a_vstate: CE_POINTER [ANY]; a_x_array: CE_POINTER [REAL_64]; a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_y: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_CSPLINE_STATE_T]
			l_x_lo: REAL_64
			l_x_hi: REAL_64
			l_dx: REAL_64
			l_index: NATURAL_32
			l_y_lo: REAL_64
			l_y_hi: REAL_64
			l_dy: REAL_64
			l_delx: REAL_64
			l_b_i: CE_ARRAY [REAL_64]
			l_c_i: CE_ARRAY [REAL_64]
			l_d_i: CE_ARRAY [REAL_64]
		do
			create l_state.make
			create l_b_i.make (<<1>>)
			create l_c_i.make (<<1>>)
			create l_d_i.make (<<1>>)

			l_state := create {CE_POINTER [PD_CSPLINE_STATE_T]}.make_cast (a_vstate)
			if not a_a___5.is_void then
				l_index := gsl_gsl_interp_inst.gsl_interp_accel_find (a_a___5, a_x_array, a_size, a_x)
			else
				l_index := gsl_gsl_interp_inst.gsl_interp_bsearch (a_x_array, a_x, (0).to_natural_32, a_size - {NATURAL_32} 1)
			end
			l_x_hi := a_x_array[(l_index + {NATURAL_32} 1).to_integer_32]
			l_x_lo := a_x_array[l_index.to_integer_32]
			l_dx := l_x_hi - l_x_lo
			if l_dx > 0.0 then
				l_y_lo := a_y_array[l_index.to_integer_32]
				l_y_hi := a_y_array[(l_index + {NATURAL_32} 1).to_integer_32]
				l_dy := l_y_hi - l_y_lo
				l_delx := a_x - l_x_lo
				coeff_calc (l_state.item.c, l_dy, l_dx, l_index, l_b_i, l_c_i, l_d_i)
				a_y.item := l_y_lo + l_delx * (l_b_i.item + l_delx * (l_c_i.item + l_delx * l_d_i.item))
				Result := 0
			else
				a_y.item := 0.0
				Result := 4
			end
		end

	cspline_eval_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cspline_eval)
		end

	cspline_eval_deriv (a_vstate: CE_POINTER [ANY]; a_x_array: CE_POINTER [REAL_64]; a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_dydx: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_CSPLINE_STATE_T]
			l_x_lo: REAL_64
			l_x_hi: REAL_64
			l_dx: REAL_64
			l_index: NATURAL_32
			l_y_lo: REAL_64
			l_y_hi: REAL_64
			l_dy: REAL_64
			l_delx: REAL_64
			l_b_i: CE_ARRAY [REAL_64]
			l_c_i: CE_ARRAY [REAL_64]
			l_d_i: CE_ARRAY [REAL_64]
		do
			create l_state.make
			create l_b_i.make (<<1>>)
			create l_c_i.make (<<1>>)
			create l_d_i.make (<<1>>)

			l_state := create {CE_POINTER [PD_CSPLINE_STATE_T]}.make_cast (a_vstate)
			if not a_a___5.is_void then
				l_index := gsl_gsl_interp_inst.gsl_interp_accel_find (a_a___5, a_x_array, a_size, a_x)
			else
				l_index := gsl_gsl_interp_inst.gsl_interp_bsearch (a_x_array, a_x, (0).to_natural_32, a_size - {NATURAL_32} 1)
			end
			l_x_hi := a_x_array[(l_index + {NATURAL_32} 1).to_integer_32]
			l_x_lo := a_x_array[l_index.to_integer_32]
			l_dx := l_x_hi - l_x_lo
			if l_dx > 0.0 then
				l_y_lo := a_y_array[l_index.to_integer_32]
				l_y_hi := a_y_array[(l_index + {NATURAL_32} 1).to_integer_32]
				l_dy := l_y_hi - l_y_lo
				l_delx := a_x - l_x_lo
				coeff_calc (l_state.item.c, l_dy, l_dx, l_index, l_b_i, l_c_i, l_d_i)
				a_dydx.item := l_b_i.item + l_delx * (2.0 * l_c_i.item + (3.0 * l_d_i.item) * l_delx)
				Result := 0
			else
				a_dydx.item := 0.0
				Result := (-1)
			end
		end

	cspline_eval_deriv_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cspline_eval_deriv)
		end

	cspline_eval_deriv2 (a_vstate: CE_POINTER [ANY]; a_x_array: CE_POINTER [REAL_64]; a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_y_pp: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_CSPLINE_STATE_T]
			l_x_lo: REAL_64
			l_x_hi: REAL_64
			l_dx: REAL_64
			l_index: NATURAL_32
			l_y_lo: REAL_64
			l_y_hi: REAL_64
			l_dy: REAL_64
			l_delx: REAL_64
			l_b_i: CE_ARRAY [REAL_64]
			l_c_i: CE_ARRAY [REAL_64]
			l_d_i: CE_ARRAY [REAL_64]
		do
			create l_state.make
			create l_b_i.make (<<1>>)
			create l_c_i.make (<<1>>)
			create l_d_i.make (<<1>>)

			l_state := create {CE_POINTER [PD_CSPLINE_STATE_T]}.make_cast (a_vstate)
			if not a_a___5.is_void then
				l_index := gsl_gsl_interp_inst.gsl_interp_accel_find (a_a___5, a_x_array, a_size, a_x)
			else
				l_index := gsl_gsl_interp_inst.gsl_interp_bsearch (a_x_array, a_x, (0).to_natural_32, a_size - {NATURAL_32} 1)
			end
			l_x_hi := a_x_array[(l_index + {NATURAL_32} 1).to_integer_32]
			l_x_lo := a_x_array[l_index.to_integer_32]
			l_dx := l_x_hi - l_x_lo
			if l_dx > 0.0 then
				l_y_lo := a_y_array[l_index.to_integer_32]
				l_y_hi := a_y_array[(l_index + {NATURAL_32} 1).to_integer_32]
				l_dy := l_y_hi - l_y_lo
				l_delx := a_x - l_x_lo
				coeff_calc (l_state.item.c, l_dy, l_dx, l_index, l_b_i, l_c_i, l_d_i)
				a_y_pp.item := 2.0 * l_c_i.item + (6.0 * l_d_i.item) * l_delx
				Result := 0
			else
				a_y_pp.item := 0.0
				Result := (-1)
			end
		end

	cspline_eval_deriv2_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cspline_eval_deriv2)
		end

	cspline_eval_integ (a_vstate: CE_POINTER [ANY]; a_x_array: CE_POINTER [REAL_64]; a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_acc: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_a___5: REAL_64; a_b___0: REAL_64; a_result: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_CSPLINE_STATE_T]
			l_i: NATURAL_32
			l_index_a: NATURAL_32
			l_index_b: NATURAL_32
			l_x_hi: REAL_64
			l_x_lo: REAL_64
			l_y_lo: REAL_64
			l_y_hi: REAL_64
			l_dx: REAL_64
			l_dy: REAL_64
			l_b_i: CE_ARRAY [REAL_64]
			l_c_i: CE_ARRAY [REAL_64]
			l_d_i: CE_ARRAY [REAL_64]
			l_x1___0: REAL_64
			l_tmp: REAL_64
			l_x2___1: REAL_64
			l_tmp___0: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make
			create l_b_i.make (<<1>>)
			create l_c_i.make (<<1>>)
			create l_d_i.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_POINTER [PD_CSPLINE_STATE_T]}.make_cast (a_vstate)
					if not a_acc.is_void then
						l_index_a := gsl_gsl_interp_inst.gsl_interp_accel_find (a_acc, a_x_array, a_size, a_a___5)
						l_index_b := gsl_gsl_interp_inst.gsl_interp_accel_find (a_acc, a_x_array, a_size, a_b___0)
					else
						l_index_a := gsl_gsl_interp_inst.gsl_interp_bsearch (a_x_array, a_a___5, (0).to_natural_32, a_size - {NATURAL_32} 1)
						l_index_b := gsl_gsl_interp_inst.gsl_interp_bsearch (a_x_array, a_b___0, (0).to_natural_32, a_size - {NATURAL_32} 1)
					end
					a_result.item := 0.0
					l_i := l_index_a
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_i <= l_index_b)) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						l_x_hi := a_x_array[(l_i + {NATURAL_32} 1).to_integer_32]
						l_x_lo := a_x_array[l_i.to_integer_32]
						l_y_lo := a_y_array[l_i.to_integer_32]
						l_y_hi := a_y_array[(l_i + {NATURAL_32} 1).to_integer_32]
						l_dx := l_x_hi - l_x_lo
						l_dy := l_y_hi - l_y_lo
						if l_dx = 0.0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						coeff_calc (l_state.item.c, l_dy, l_dx, l_i, l_b_i, l_c_i, l_d_i)
						if l_i /= l_index_a then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_i /= l_index_b then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_i = l_index_a then
							l_tmp := a_a___5
						else
							l_tmp := l_x_lo
						end
						l_x1___0 := l_tmp
						if l_i = l_index_b then
							l_tmp___0 := a_b___0
						else
							l_tmp___0 := l_x_hi
						end
						l_x2___1 := l_tmp___0
						a_result.item := a_result.item + (integ_eval_inst.integ_eval (l_y_lo, l_b_i.item, l_c_i.item, l_d_i.item, l_x_lo, l_x1___0, l_x2___1))
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						a_result.item := a_result.item + (l_dx * (l_y_lo + l_dx * (0.5 * l_b_i.item + l_dx * (l_c_i.item / 3.0 + (0.25 * l_d_i.item) * l_dx))))
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						a_result.item := 0.0
						Result := (-1)
						js.return
				when 12 then
						if not js.return_called then
							l_i := l_i + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					if not js.return_called then
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cspline_eval_integ_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cspline_eval_integ)
		end

	cspline_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_CSPLINE_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_CSPLINE_STATE_T]}.make_cast (a_vstate)
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.c))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.g))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.diag))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.offdiag))
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	cspline_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cspline_free)
		end

	cspline_init (a_vstate: CE_POINTER [ANY]; a_xa: CE_POINTER [REAL_64]; a_ya: CE_POINTER [REAL_64]; a_size: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_CSPLINE_STATE_T]
			l_i: NATURAL_32
			l_num_points: NATURAL_32
			l_max_index: NATURAL_32
			l_sys_size: NATURAL_32
			l_h_i: REAL_64
			l_h_ip1: REAL_64
			l_ydiff_i: REAL_64
			l_ydiff_ip1: REAL_64
			l_g_i: REAL_64
			l_tmp: REAL_64
			l_g_ip1: REAL_64
			l_tmp___0: REAL_64
			l_g_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_diag_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_offdiag_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_solution_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_status: INTEGER_32
		do
			create l_state.make
			create l_g_vec.make (<<1>>)
			create l_diag_vec.make (<<1>>)
			create l_offdiag_vec.make (<<1>>)
			create l_solution_vec.make (<<1>>)

			l_state := create {CE_POINTER [PD_CSPLINE_STATE_T]}.make_cast (a_vstate)
			l_num_points := a_size
			l_max_index := l_num_points - {NATURAL_32} 1
			l_sys_size := l_max_index - {NATURAL_32} 1
			l_state.item.c[0] := 0.0
			l_state.item.c[l_max_index.to_integer_32] := 0.0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_sys_size)
			loop
				l_h_i := (a_xa[(l_i + {NATURAL_32} 1).to_integer_32] - a_xa[l_i.to_integer_32])
				l_h_ip1 := (a_xa[(l_i + {NATURAL_32} 2).to_integer_32] - a_xa[(l_i + {NATURAL_32} 1).to_integer_32])
				l_ydiff_i := (a_ya[(l_i + {NATURAL_32} 1).to_integer_32] - a_ya[l_i.to_integer_32])
				l_ydiff_ip1 := (a_ya[(l_i + {NATURAL_32} 2).to_integer_32] - a_ya[(l_i + {NATURAL_32} 1).to_integer_32])
				if l_h_i /= 0.0 then
					l_tmp := 1.0 / l_h_i
				else
					l_tmp := 0.0
				end
				l_g_i := l_tmp
				if l_h_ip1 /= 0.0 then
					l_tmp___0 := 1.0 / l_h_ip1
				else
					l_tmp___0 := 0.0
				end
				l_g_ip1 := l_tmp___0
				l_state.item.offdiag[l_i.to_integer_32] := l_h_ip1
				l_state.item.diag[l_i.to_integer_32] := 2.0 * (l_h_ip1 + l_h_i)
				l_state.item.g[l_i.to_integer_32] := 3.0 * (l_ydiff_ip1 * l_g_ip1 - l_ydiff_i * l_g_i)
				l_i := l_i + 1
			end
			if l_sys_size = {NATURAL_32} 1 then
				l_state.item.c[1] := l_state.item.g[0] / l_state.item.diag[0]
				Result := 0
			else
				l_g_vec.item := (view_source_inst.gsl_vector_view_array (l_state.item.g, l_sys_size)).twin
				l_diag_vec.item := (view_source_inst.gsl_vector_view_array (l_state.item.diag, l_sys_size)).twin
				l_offdiag_vec.item := (view_source_inst.gsl_vector_view_array (l_state.item.offdiag, l_sys_size - {NATURAL_32} 1)).twin
				l_solution_vec.item := (view_source_inst.gsl_vector_view_array (l_state.item.c + 1, l_sys_size)).twin
				l_status := (tridiag_inst.gsl_linalg_solve_symm_tridiag ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_diag_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_offdiag_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_g_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_solution_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))))
				Result := l_status
			end
		end

	cspline_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cspline_init)
		end

	cspline_init_periodic (a_vstate: CE_POINTER [ANY]; a_xa: CE_POINTER [REAL_64]; a_ya: CE_POINTER [REAL_64]; a_size: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_CSPLINE_STATE_T]
			l_i: NATURAL_32
			l_num_points: NATURAL_32
			l_max_index: NATURAL_32
			l_sys_size: NATURAL_32
			l_h0: REAL_64
			l_h1: REAL_64
			l_A___0: REAL_64
			l_B: REAL_64
			l_g: CE_ARRAY [REAL_64]
			l_det: REAL_64
			l_h_i: REAL_64
			l_h_ip1: REAL_64
			l_ydiff_i: REAL_64
			l_ydiff_ip1: REAL_64
			l_g_i: REAL_64
			l_tmp: REAL_64
			l_g_ip1: REAL_64
			l_tmp___0: REAL_64
			l_h_i___0: REAL_64
			l_h_ip1___0: REAL_64
			l_ydiff_i___0: REAL_64
			l_ydiff_ip1___0: REAL_64
			l_g_i___0: REAL_64
			l_tmp___1: REAL_64
			l_g_ip1___0: REAL_64
			l_tmp___2: REAL_64
			l_g_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_diag_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_offdiag_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_solution_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_status: INTEGER_32
		do
			create l_state.make
			create l_g.make (<<2>>)
			create l_g_vec.make (<<1>>)
			create l_diag_vec.make (<<1>>)
			create l_offdiag_vec.make (<<1>>)
			create l_solution_vec.make (<<1>>)

			l_state := create {CE_POINTER [PD_CSPLINE_STATE_T]}.make_cast (a_vstate)
			l_num_points := a_size
			l_max_index := l_num_points - {NATURAL_32} 1
			l_sys_size := l_max_index
			if l_sys_size = {NATURAL_32} 2 then
				l_h0 := (a_xa[1] - a_xa[0])
				l_h1 := (a_xa[2] - a_xa[1])
				l_A___0 := 2.0 * (l_h0 + l_h1)
				l_B := l_h0 + l_h1
				l_g[0] := 3.0 * ((a_ya[2] - a_ya[1]) / l_h1 - (a_ya[1] - a_ya[0]) / l_h0)
				l_g[1] := 3.0 * ((a_ya[1] - a_ya[2]) / l_h0 - (a_ya[2] - a_ya[1]) / l_h1)
				l_det := (3.0 * (l_h0 + l_h1)) * (l_h0 + l_h1)
				l_state.item.c[1] := (l_A___0 * l_g[0] - l_B * l_g[1]) / l_det
				l_state.item.c[2] := (-l_B * l_g[0] + l_A___0 * l_g[1]) / l_det
				l_state.item.c[0] := l_state.item.c[2]
				Result := 0
			else
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_sys_size - {NATURAL_32} 1)
				loop
					l_h_i := (a_xa[(l_i + {NATURAL_32} 1).to_integer_32] - a_xa[l_i.to_integer_32])
					l_h_ip1 := (a_xa[(l_i + {NATURAL_32} 2).to_integer_32] - a_xa[(l_i + {NATURAL_32} 1).to_integer_32])
					l_ydiff_i := (a_ya[(l_i + {NATURAL_32} 1).to_integer_32] - a_ya[l_i.to_integer_32])
					l_ydiff_ip1 := (a_ya[(l_i + {NATURAL_32} 2).to_integer_32] - a_ya[(l_i + {NATURAL_32} 1).to_integer_32])
					if l_h_i /= 0.0 then
						l_tmp := 1.0 / l_h_i
					else
						l_tmp := 0.0
					end
					l_g_i := l_tmp
					if l_h_ip1 /= 0.0 then
						l_tmp___0 := 1.0 / l_h_ip1
					else
						l_tmp___0 := 0.0
					end
					l_g_ip1 := l_tmp___0
					l_state.item.offdiag[l_i.to_integer_32] := l_h_ip1
					l_state.item.diag[l_i.to_integer_32] := 2.0 * (l_h_ip1 + l_h_i)
					l_state.item.g[l_i.to_integer_32] := 3.0 * (l_ydiff_ip1 * l_g_ip1 - l_ydiff_i * l_g_i)
					l_i := l_i + 1
				end
				l_i := l_sys_size - {NATURAL_32} 1
				l_h_i___0 := (a_xa[(l_i + {NATURAL_32} 1).to_integer_32] - a_xa[l_i.to_integer_32])
				l_h_ip1___0 := (a_xa[1] - a_xa[0])
				l_ydiff_i___0 := (a_ya[(l_i + {NATURAL_32} 1).to_integer_32] - a_ya[l_i.to_integer_32])
				l_ydiff_ip1___0 := (a_ya[1] - a_ya[0])
				if l_h_i___0 /= 0.0 then
					l_tmp___1 := 1.0 / l_h_i___0
				else
					l_tmp___1 := 0.0
				end
				l_g_i___0 := l_tmp___1
				if l_h_ip1___0 /= 0.0 then
					l_tmp___2 := 1.0 / l_h_ip1___0
				else
					l_tmp___2 := 0.0
				end
				l_g_ip1___0 := l_tmp___2
				l_state.item.offdiag[l_i.to_integer_32] := l_h_ip1___0
				l_state.item.diag[l_i.to_integer_32] := 2.0 * (l_h_ip1___0 + l_h_i___0)
				l_state.item.g[l_i.to_integer_32] := 3.0 * (l_ydiff_ip1___0 * l_g_ip1___0 - l_ydiff_i___0 * l_g_i___0)
				l_g_vec.item := (view_source_inst.gsl_vector_view_array (l_state.item.g, l_sys_size)).twin
				l_diag_vec.item := (view_source_inst.gsl_vector_view_array (l_state.item.diag, l_sys_size)).twin
				l_offdiag_vec.item := (view_source_inst.gsl_vector_view_array (l_state.item.offdiag, l_sys_size)).twin
				l_solution_vec.item := (view_source_inst.gsl_vector_view_array (l_state.item.c + 1, l_sys_size)).twin
				l_status := (tridiag_inst.gsl_linalg_solve_symm_cyc_tridiag ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_diag_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_offdiag_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_g_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_solution_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))))
				l_state.item.c[0] := l_state.item.c[l_max_index.to_integer_32]
				Result := l_status
			end
		end

	cspline_init_periodic_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cspline_init_periodic)
		end

end
