class
	P_CSTD

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_odeiv_control_standard.make
			create std_control_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_odeiv_control_standard: CE_POINTER [PD_GSL_ODEIV_CONTROL_TYPE] assign set_gsl_odeiv_control_standard

	set_gsl_odeiv_control_standard (a_gsl_odeiv_control_standard: CE_POINTER [PD_GSL_ODEIV_CONTROL_TYPE])
		do
			gsl_odeiv_control_standard := a_gsl_odeiv_control_standard
		end

	std_control_type: CE_ARRAY [PD_GSL_ODEIV_CONTROL_TYPE]

feature {ANY} -- routines

	gsl_odeiv_control_standard_new (a_eps_abs: REAL_64; a_eps_rel: REAL_64; a_a_y: REAL_64; a_a_dydt: REAL_64): CE_POINTER [PD_GSL_ODEIV_CONTROL]
		local
			l_c___1: CE_POINTER [PD_GSL_ODEIV_CONTROL]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_c___1.make

			l_c___1 := (control_inst.gsl_odeiv_control_alloc (gsl_odeiv_control_standard))
			l_status := (control_inst.gsl_odeiv_control_init (l_c___1, a_eps_abs, a_eps_rel, a_a_y, a_a_dydt))
			if l_status /= 0 then
				control_inst.gsl_odeiv_control_free (l_c___1)
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error trying to initialize control"), ce_string ("cstd.c"), 167, l_status)
					Result := (create {CE_POINTER [PD_GSL_ODEIV_CONTROL]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := l_c___1
			end
		end

	gsl_odeiv_control_y_new (a_eps_abs: REAL_64; a_eps_rel: REAL_64): CE_POINTER [PD_GSL_ODEIV_CONTROL]
		do
			Result := (gsl_odeiv_control_standard_new (a_eps_abs, a_eps_rel, 1.0, 0.0))
		end

	gsl_odeiv_control_yp_new (a_eps_abs: REAL_64; a_eps_rel: REAL_64): CE_POINTER [PD_GSL_ODEIV_CONTROL]
		do
			Result := (gsl_odeiv_control_standard_new (a_eps_abs, a_eps_rel, 0.0, 1.0))
		end

	std_control_alloc: CE_POINTER [ANY]
		local
			l_s: CE_POINTER [PD_STD_CONTROL_STATE_T]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := create {CE_POINTER [PD_STD_CONTROL_STATE_T]}.make_cast ((malloc ((create {PD_STD_CONTROL_STATE_T}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for std_control_state"), ce_string ("cstd.c"), 45, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_s))
			end
		end

	std_control_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent std_control_alloc)
		end

	std_control_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_STD_CONTROL_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_STD_CONTROL_STATE_T]}.make_cast (a_vstate)
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	std_control_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent std_control_free)
		end

	std_control_hadjust (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_ord: NATURAL_32; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_yp: CE_POINTER [REAL_64]; a_h: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_STD_CONTROL_STATE_T]
			l_eps_abs: REAL_64
			l_eps_rel: REAL_64
			l_a_y: REAL_64
			l_a_dydt: REAL_64
			l_S: REAL_64
			l_h_old: REAL_64
			l_rmax: REAL_64
			l_i: NATURAL_32
			l_D0: REAL_64
			l_tmp: REAL_64
			l_r___3: REAL_64
			l_tmp___1: REAL_64
			l_r___4: REAL_64
			l_r___5: REAL_64
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_STD_CONTROL_STATE_T]}.make_cast (a_vstate)
			l_eps_abs := l_state.item.eps_abs
			l_eps_rel := l_state.item.eps_rel
			l_a_y := l_state.item.a_y
			l_a_dydt := l_state.item.a_dydt
			l_S := 0.9
			l_h_old := a_h.item
			l_rmax := (real_96_from_real_64 (2.22507385850720138309e-308)).truncated_to_real_64
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_dim)
			loop
				l_tmp := fabs (a_y[l_i.to_integer_32])
				l_D0 := l_eps_rel * (l_a_y * l_tmp + l_a_dydt * (fabs (l_h_old * a_yp[l_i.to_integer_32]))) + l_eps_abs
				l_tmp___1 := fabs (a_yerr[l_i.to_integer_32])
				l_r___3 := l_tmp___1 / (fabs (l_D0))
				l_rmax := gsl_gsl_minmax_inst.GSL_MAX_DBL (l_r___3, l_rmax)
				l_i := l_i + 1
			end
			if l_rmax > 1.1 then
				l_r___4 := l_S / (pow (l_rmax, 1.0 / a_ord.to_real_64))
				if l_r___4 < 0.2 then
					l_r___4 := 0.2
				end
				a_h.item := l_r___4 * l_h_old
				Result := (-1)
			elseif l_rmax < 0.5 then
				l_r___5 := l_S / (pow (l_rmax, 1.0 / (a_ord.to_real_64 + 1.0)))
				if l_r___5 > 5.0 then
					l_r___5 := 5.0
				end
				if l_r___5 < 1.0 then
					l_r___5 := 1.0
				end
				a_h.item := l_r___5 * l_h_old
				Result := 1
			else
				Result := 0
			end
		end

	std_control_hadjust_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent std_control_hadjust)
		end

	std_control_init (a_vstate: CE_POINTER [ANY]; a_eps_abs: REAL_64; a_eps_rel: REAL_64; a_a_y: REAL_64; a_a_dydt: REAL_64): INTEGER_32
		local
			l_s: CE_POINTER [PD_STD_CONTROL_STATE_T]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := create {CE_POINTER [PD_STD_CONTROL_STATE_T]}.make_cast (a_vstate)
			if a_eps_abs < (0).to_double then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("eps_abs is negative"), ce_string ("cstd.c"), 59, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_eps_rel < (0).to_double then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("eps_rel is negative"), ce_string ("cstd.c"), 63, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_a_y < (0).to_double then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("a_y is negative"), ce_string ("cstd.c"), 67, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_a_dydt < (0).to_double then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("a_dydt is negative"), ce_string ("cstd.c"), 71, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_s.item.eps_rel := a_eps_rel
				l_s.item.eps_abs := a_eps_abs
				l_s.item.a_y := a_a_y
				l_s.item.a_dydt := a_a_dydt
				Result := 0
			end
		end

	std_control_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent std_control_init)
		end

end
