class
	P_CTRSM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_ctrsm (a_Order: NATURAL_32; a_Side: NATURAL_32; a_Uplo: NATURAL_32; a_TransA: NATURAL_32; a_Diag: NATURAL_32; a_M: INTEGER_32; a_N: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_nonunit: INTEGER_32
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_side: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_Bij_real: REAL_32
			l_Bij_imag: REAL_32
			l_Aii_real: REAL_32
			l_Aii_imag: REAL_32
			l_s: REAL_32
			l_a_real: REAL_32
			l_a_imag: REAL_32
			l_Bij_real___0: REAL_32
			l_Bij_imag___0: REAL_32
			l_Aki_real: REAL_32
			l_Aki_imag: REAL_32
			l_Bij_real___1: REAL_32
			l_Bij_imag___1: REAL_32
			l_tmp___1: INTEGER_32
			l_Bij_real___2: REAL_32
			l_Bij_imag___2: REAL_32
			l_Aii_real___0: REAL_32
			l_Aii_imag___0: REAL_32
			l_s___0: REAL_32
			l_a_real___0: REAL_32
			l_a_imag___0: REAL_32
			l_Bij_real___3: REAL_32
			l_Bij_imag___3: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_Bij_real___4: REAL_32
			l_Bij_imag___4: REAL_32
			l_Bij_real___5: REAL_32
			l_Bij_imag___5: REAL_32
			l_Aii_real___1: REAL_32
			l_Aii_imag___1: REAL_32
			l_s___1: REAL_32
			l_a_real___1: REAL_32
			l_a_imag___1: REAL_32
			l_Bij_real___6: REAL_32
			l_Bij_imag___6: REAL_32
			l_Aki_real___0: REAL_32
			l_Aki_imag___0: REAL_32
			l_Bij_real___7: REAL_32
			l_Bij_imag___7: REAL_32
			l_Bij_real___8: REAL_32
			l_Bij_imag___8: REAL_32
			l_Aii_real___2: REAL_32
			l_Aii_imag___2: REAL_32
			l_s___2: REAL_32
			l_a_real___2: REAL_32
			l_a_imag___2: REAL_32
			l_Bij_real___9: REAL_32
			l_Bij_imag___9: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_Bij_real___10: REAL_32
			l_Bij_imag___10: REAL_32
			l_tmp___5: INTEGER_32
			l_Bij_real___11: REAL_32
			l_Bij_imag___11: REAL_32
			l_Ajj_real: REAL_32
			l_Ajj_imag: REAL_32
			l_s___3: REAL_32
			l_a_real___3: REAL_32
			l_a_imag___3: REAL_32
			l_Bij_real___12: REAL_32
			l_Bij_imag___12: REAL_32
			l_Bij_real___13: REAL_32
			l_Bij_imag___13: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_Bij_real___14: REAL_32
			l_Bij_imag___14: REAL_32
			l_Ajj_real___0: REAL_32
			l_Ajj_imag___0: REAL_32
			l_s___4: REAL_32
			l_a_real___4: REAL_32
			l_a_imag___4: REAL_32
			l_Bij_real___15: REAL_32
			l_Bij_imag___15: REAL_32
			l_Bij_real___16: REAL_32
			l_Bij_imag___16: REAL_32
			l_Akj_real: REAL_32
			l_Akj_imag: REAL_32
			l_tmp___8: INTEGER_32
			l_Bij_real___17: REAL_32
			l_Bij_imag___17: REAL_32
			l_Ajj_real___1: REAL_32
			l_Ajj_imag___1: REAL_32
			l_s___5: REAL_32
			l_a_real___5: REAL_32
			l_a_imag___5: REAL_32
			l_Bij_real___18: REAL_32
			l_Bij_imag___18: REAL_32
			l_Bij_real___19: REAL_32
			l_Bij_imag___19: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_tmp___10: INTEGER_32
			l_Bij_real___20: REAL_32
			l_Bij_imag___20: REAL_32
			l_Ajj_real___2: REAL_32
			l_Ajj_imag___2: REAL_32
			l_s___6: REAL_32
			l_a_real___6: REAL_32
			l_a_imag___6: REAL_32
			l_Bij_real___21: REAL_32
			l_Bij_imag___21: REAL_32
			l_Bij_real___22: REAL_32
			l_Bij_imag___22: REAL_32
			l_Akj_real___0: REAL_32
			l_Akj_imag___0: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_TransA = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					l_alpha_real := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[1]
					if a_Order = {NATURAL_32} 101 then
						l_n1 := a_M
						l_n2 := a_N
						l_side := a_Side.to_integer_32
						l_uplo := a_Uplo.to_integer_32
						l_trans := a_TransA.to_integer_32
						if a_TransA = {NATURAL_32} 111 then
							l_trans := 111
						else
							l_trans := 112
						end
					else
						l_n1 := a_N
						l_n2 := a_M
						if a_Side = {NATURAL_32} 141 then
							l_side := 142
						else
							l_side := 141
						end
						if a_Uplo = {NATURAL_32} 121 then
							l_uplo := 122
						else
							l_uplo := 121
						end
						if a_TransA = {NATURAL_32} 111 then
							l_trans := 111
						else
							l_trans := 112
						end
					end
					if l_side /= 141 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 11 -- skip if block
						end
				when 2 then -- if:
						if l_trans /= 111 then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real - l_alpha_imag * l_Bij_imag
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag + l_alpha_imag * l_Bij_real
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 7 then
						l_i := l_n1
						from
						until
							js.loop_done
						loop
							if l_i > 0 then
								l_tmp___1 := l_i
								l_i := l_i - 1
								if not l_tmp___1.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if l_nonunit.to_boolean then
									l_Aii_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
									l_Aii_imag := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
									l_s := (hypot_inst.xhypot___1 (l_Aii_real.to_double, l_Aii_imag.to_double)).truncated_to_real
									l_a_real := l_Aii_real / l_s
									l_a_imag := l_Aii_imag / l_s
									l_j := 0
									from
									until
										not (l_j < l_n2)
									loop
										l_Bij_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___0 * l_a_real + l_Bij_imag___0 * l_a_imag) / l_s
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___0 * l_a_real - l_Bij_real___0 * l_a_imag) / l_s
										l_j := l_j + 1
									end
								end
								l_k := 0
								from
								until
									not (not js.loop_done and then (l_k < l_i))
								loop
									l_Aki_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
									l_Aki_imag := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
									l_j := 0
									from
									until
										not (l_j < l_n2)
									loop
										l_Bij_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___1 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] - (l_Aki_real * l_Bij_real___1 - l_Aki_imag * l_Bij_imag___1)
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] - (l_Aki_real * l_Bij_imag___1 + l_Aki_imag * l_Bij_real___1)
										l_j := l_j + 1
									end
									l_k := l_k + 1
								end
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 13 -- goto _L___20
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L___20
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 13 then -- else: | _L___20:
						if l_side /= 141 then
							l_pos := -1 + 26 -- skip if block
						end
				when 14 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 24 -- skip if block
						end
				when 15 then -- if:
						if l_trans /= 112 then
							l_pos := -1 + 22 -- skip if block
						end
				when 16 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 19 -- goto _L___0
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___0:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___2 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___2 - l_alpha_imag * l_Bij_imag___2
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___2 + l_alpha_imag * l_Bij_real___2
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 20 then
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							if l_nonunit.to_boolean then
								l_Aii_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
								l_Aii_imag___0 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
								l_s___0 := (hypot_inst.xhypot___1 (l_Aii_real___0.to_double, l_Aii_imag___0.to_double)).truncated_to_real
								l_a_real___0 := l_Aii_real___0 / l_s___0
								l_a_imag___0 := l_Aii_imag___0 / l_s___0
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									l_Bij_real___3 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___3 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___3 * l_a_real___0 + l_Bij_imag___3 * l_a_imag___0) / l_s___0
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___3 * l_a_real___0 - l_Bij_real___3 * l_a_imag___0) / l_s___0
									l_j := l_j + 1
								end
							end
							l_k := l_i + 1
							from
							until
								not (not js.loop_done and then (l_k < l_n1))
							loop
								l_Aik_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
								l_Aik_imag := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)])
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									l_Bij_real___4 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___4 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] - (l_Aik_real * l_Bij_real___4 - l_Aik_imag * l_Bij_imag___4)
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] - (l_Aik_real * l_Bij_imag___4 + l_Aik_imag * l_Bij_real___4)
									l_j := l_j + 1
								end
								l_k := l_k + 1
							end
							l_i := l_i + 1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 26 -- goto _L___18
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_pos := -1 + 26 -- goto _L___18
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 26 then -- else: | _L___18:
						if l_side /= 141 then
							l_pos := -1 + 39 -- skip if block
						end
				when 27 then -- if:
						if l_uplo /= 122 then
							l_pos := -1 + 37 -- skip if block
						end
				when 28 then -- if:
						if l_trans /= 111 then
							l_pos := -1 + 35 -- skip if block
						end
				when 29 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 32 -- goto _L___1
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else: | _L___1:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___5 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___5 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___5 - l_alpha_imag * l_Bij_imag___5
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___5 + l_alpha_imag * l_Bij_real___5
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 33 then
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							if l_nonunit.to_boolean then
								l_Aii_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
								l_Aii_imag___1 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
								l_s___1 := (hypot_inst.xhypot___1 (l_Aii_real___1.to_double, l_Aii_imag___1.to_double)).truncated_to_real
								l_a_real___1 := l_Aii_real___1 / l_s___1
								l_a_imag___1 := l_Aii_imag___1 / l_s___1
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									l_Bij_real___6 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___6 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___6 * l_a_real___1 + l_Bij_imag___6 * l_a_imag___1) / l_s___1
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___6 * l_a_real___1 - l_Bij_real___6 * l_a_imag___1) / l_s___1
									l_j := l_j + 1
								end
							end
							l_k := l_i + 1
							from
							until
								not (not js.loop_done and then (l_k < l_n1))
							loop
								l_Aki_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
								l_Aki_imag___0 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									l_Bij_real___7 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___7 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] - (l_Aki_real___0 * l_Bij_real___7 - l_Aki_imag___0 * l_Bij_imag___7)
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] - (l_Aki_real___0 * l_Bij_imag___7 + l_Aki_imag___0 * l_Bij_real___7)
									l_j := l_j + 1
								end
								l_k := l_k + 1
							end
							l_i := l_i + 1
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 39 -- goto _L___16
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else:
						l_pos := -1 + 39 -- goto _L___16
				when 38 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 39 then -- else: | _L___16:
						if l_side /= 141 then
							l_pos := -1 + 52 -- skip if block
						end
				when 40 then -- if:
						if l_uplo /= 122 then
							l_pos := -1 + 50 -- skip if block
						end
				when 41 then -- if:
						if l_trans /= 112 then
							l_pos := -1 + 48 -- skip if block
						end
				when 42 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 45 -- goto _L___2
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else: | _L___2:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___8 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___8 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___8 - l_alpha_imag * l_Bij_imag___8
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___8 + l_alpha_imag * l_Bij_real___8
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 46 then
						l_i := l_n1
						from
						until
							js.loop_done
						loop
							if l_i > 0 then
								l_tmp___5 := l_i
								l_i := l_i - 1
								if not l_tmp___5.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if l_nonunit.to_boolean then
									l_Aii_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
									l_Aii_imag___2 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
									l_s___2 := (hypot_inst.xhypot___1 (l_Aii_real___2.to_double, l_Aii_imag___2.to_double)).truncated_to_real
									l_a_real___2 := l_Aii_real___2 / l_s___2
									l_a_imag___2 := l_Aii_imag___2 / l_s___2
									l_j := 0
									from
									until
										not (l_j < l_n2)
									loop
										l_Bij_real___9 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___9 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___9 * l_a_real___2 + l_Bij_imag___9 * l_a_imag___2) / l_s___2
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___9 * l_a_real___2 - l_Bij_real___9 * l_a_imag___2) / l_s___2
										l_j := l_j + 1
									end
								end
								l_k := 0
								from
								until
									not (not js.loop_done and then (l_k < l_i))
								loop
									l_Aik_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
									l_Aik_imag___0 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)])
									l_j := 0
									from
									until
										not (l_j < l_n2)
									loop
										l_Bij_real___10 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___10 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] - (l_Aik_real___0 * l_Bij_real___10 - l_Aik_imag___0 * l_Bij_imag___10)
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] - (l_Aik_real___0 * l_Bij_imag___10 + l_Aik_imag___0 * l_Bij_real___10)
										l_j := l_j + 1
									end
									l_k := l_k + 1
								end
							end
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:
						l_pos := -1 + 52 -- goto _L___14
				when 49 then -- if done | if block done, skip else block:
						l_pos := -1 + 51
				when 50 then -- else:
						l_pos := -1 + 52 -- goto _L___14
				when 51 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 52 then -- else: | _L___14:
						if l_side /= 142 then
							l_pos := -1 + 65 -- skip if block
						end
				when 53 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 63 -- skip if block
						end
				when 54 then -- if:
						if l_trans /= 111 then
							l_pos := -1 + 61 -- skip if block
						end
				when 55 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 58 -- goto _L___3
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else: | _L___3:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___11 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___11 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___11 - l_alpha_imag * l_Bij_imag___11
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___11 + l_alpha_imag * l_Bij_real___11
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 59 then
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (not js.loop_done and then (l_j < l_n2))
							loop
								if l_nonunit.to_boolean then
									l_Ajj_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_j + l_j)]
									l_Ajj_imag := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_j) + 1)])
									l_s___3 := (hypot_inst.xhypot___1 (l_Ajj_real.to_double, l_Ajj_imag.to_double)).truncated_to_real
									l_a_real___3 := l_Ajj_real / l_s___3
									l_a_imag___3 := l_Ajj_imag / l_s___3
									l_Bij_real___12 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___12 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___12 * l_a_real___3 + l_Bij_imag___12 * l_a_imag___3) / l_s___3
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___12 * l_a_real___3 - l_Bij_real___12 * l_a_imag___3) / l_s___3
								end
								l_Bij_real___13 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___13 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								l_k := l_j + 1
								from
								until
									not (l_k < l_n2)
								loop
									l_Ajk_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
									l_Ajk_imag := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] - (l_Ajk_real * l_Bij_real___13 - l_Ajk_imag * l_Bij_imag___13)
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] - (l_Ajk_real * l_Bij_imag___13 + l_Ajk_imag * l_Bij_real___13)
									l_k := l_k + 1
								end
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 61 then -- else:
						l_pos := -1 + 65 -- goto _L___12
				when 62 then -- if done | if block done, skip else block:
						l_pos := -1 + 64
				when 63 then -- else:
						l_pos := -1 + 65 -- goto _L___12
				when 64 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 65 then -- else: | _L___12:
						if l_side /= 142 then
							l_pos := -1 + 78 -- skip if block
						end
				when 66 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 76 -- skip if block
						end
				when 67 then -- if:
						if l_trans /= 112 then
							l_pos := -1 + 74 -- skip if block
						end
				when 68 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 71 -- skip if block
						end
				when 69 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 71 -- goto _L___4
						end
				when 70 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 71 then -- else: | _L___4:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___14 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___14 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___14 - l_alpha_imag * l_Bij_imag___14
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___14 + l_alpha_imag * l_Bij_real___14
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 72 then
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := l_n2
							from
							until
								js.loop_done
							loop
								if l_j > 0 then
									l_tmp___8 := l_j
									l_j := l_j - 1
									if not l_tmp___8.to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if l_nonunit.to_boolean then
										l_Ajj_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_j + l_j)]
										l_Ajj_imag___0 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_j) + 1)])
										l_s___4 := (hypot_inst.xhypot___1 (l_Ajj_real___0.to_double, l_Ajj_imag___0.to_double)).truncated_to_real
										l_a_real___4 := l_Ajj_real___0 / l_s___4
										l_a_imag___4 := l_Ajj_imag___0 / l_s___4
										l_Bij_real___15 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___15 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___15 * l_a_real___4 + l_Bij_imag___15 * l_a_imag___4) / l_s___4
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___15 * l_a_real___4 - l_Bij_real___15 * l_a_imag___4) / l_s___4
									end
									l_Bij_real___16 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___16 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_k := 0
									from
									until
										not (l_k < l_j)
									loop
										l_Akj_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
										l_Akj_imag := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)])
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] - (l_Akj_real * l_Bij_real___16 - l_Akj_imag * l_Bij_imag___16)
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] - (l_Akj_real * l_Bij_imag___16 + l_Akj_imag * l_Bij_real___16)
										l_k := l_k + 1
									end
								end
							end
							l_i := l_i + 1
						end
				when 73 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 74 then -- else:
						l_pos := -1 + 78 -- goto _L___10
				when 75 then -- if done | if block done, skip else block:
						l_pos := -1 + 77
				when 76 then -- else:
						l_pos := -1 + 78 -- goto _L___10
				when 77 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 78 then -- else: | _L___10:
						if l_side /= 142 then
							l_pos := -1 + 91 -- skip if block
						end
				when 79 then -- if:
						if l_uplo /= 122 then
							l_pos := -1 + 89 -- skip if block
						end
				when 80 then -- if:
						if l_trans /= 111 then
							l_pos := -1 + 87 -- skip if block
						end
				when 81 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 84 -- goto _L___5
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else: | _L___5:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___17 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___17 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___17 - l_alpha_imag * l_Bij_imag___17
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___17 + l_alpha_imag * l_Bij_real___17
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 85 then
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := l_n2
							from
							until
								js.loop_done
							loop
								if l_j > 0 then
									l_tmp___10 := l_j
									l_j := l_j - 1
									if not l_tmp___10.to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if l_nonunit.to_boolean then
										l_Ajj_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_j + l_j)]
										l_Ajj_imag___1 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_j) + 1)])
										l_s___5 := (hypot_inst.xhypot___1 (l_Ajj_real___1.to_double, l_Ajj_imag___1.to_double)).truncated_to_real
										l_a_real___5 := l_Ajj_real___1 / l_s___5
										l_a_imag___5 := l_Ajj_imag___1 / l_s___5
										l_Bij_real___18 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___18 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___18 * l_a_real___5 + l_Bij_imag___18 * l_a_imag___5) / l_s___5
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___18 * l_a_real___5 - l_Bij_real___18 * l_a_imag___5) / l_s___5
									end
									l_Bij_real___19 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___19 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_k := 0
									from
									until
										not (l_k < l_j)
									loop
										l_Ajk_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag___0 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] - (l_Ajk_real___0 * l_Bij_real___19 - l_Ajk_imag___0 * l_Bij_imag___19)
										create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] - (l_Ajk_real___0 * l_Bij_imag___19 + l_Ajk_imag___0 * l_Bij_real___19)
										l_k := l_k + 1
									end
								end
							end
							l_i := l_i + 1
						end
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 87 then -- else:
						l_pos := -1 + 91 -- goto _L___8
				when 88 then -- if done | if block done, skip else block:
						l_pos := -1 + 90
				when 89 then -- else:
						l_pos := -1 + 91 -- goto _L___8
				when 90 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 91 then -- else: | _L___8:
						if l_side /= 142 then
							l_pos := -1 + 104 -- skip if block
						end
				when 92 then -- if:
						if l_uplo /= 122 then
							l_pos := -1 + 102 -- skip if block
						end
				when 93 then -- if:
						if l_trans /= 112 then
							l_pos := -1 + 100 -- skip if block
						end
				when 94 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 97 -- skip if block
						end
				when 95 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 97 -- goto _L___6
						end
				when 96 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 97 then -- else: | _L___6:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___20 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___20 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___20 - l_alpha_imag * l_Bij_imag___20
								create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___20 + l_alpha_imag * l_Bij_real___20
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 98 then
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (not js.loop_done and then (l_j < l_n2))
							loop
								if l_nonunit.to_boolean then
									l_Ajj_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_j + l_j)]
									l_Ajj_imag___2 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_j) + 1)])
									l_s___6 := (hypot_inst.xhypot___1 (l_Ajj_real___2.to_double, l_Ajj_imag___2.to_double)).truncated_to_real
									l_a_real___6 := l_Ajj_real___2 / l_s___6
									l_a_imag___6 := l_Ajj_imag___2 / l_s___6
									l_Bij_real___21 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___21 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___21 * l_a_real___6 + l_Bij_imag___21 * l_a_imag___6) / l_s___6
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___21 * l_a_real___6 - l_Bij_real___21 * l_a_imag___6) / l_s___6
								end
								l_Bij_real___22 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___22 := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								l_k := l_j + 1
								from
								until
									not (l_k < l_n2)
								loop
									l_Akj_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
									l_Akj_imag___0 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)])
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] - (l_Akj_real___0 * l_Bij_real___22 - l_Akj_imag___0 * l_Bij_imag___22)
									create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] - (l_Akj_real___0 * l_Bij_imag___22 + l_Akj_imag___0 * l_Bij_real___22)
									l_k := l_k + 1
								end
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 99 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 100 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_trsm_c.h"), ce_string ("unrecognized operation")])
				when 101 then -- if done | if block done, skip else block:
						l_pos := -1 + 103
				when 102 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_trsm_c.h"), ce_string ("unrecognized operation")])
				when 103 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 104 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_trsm_c.h"), ce_string ("unrecognized operation")])
				when 105 then -- if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
