class
	P_DAUBECHIES

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create daubechies_centered_type.make (<<1>>)
			create daubechies_type.make (<<1>>)
			create g_10.make (<<10>>)
			create g_12.make (<<12>>)
			create g_14.make (<<14>>)
			create g_16.make (<<16>>)
			create g_18.make (<<18>>)
			create g_20.make (<<20>>)
			create g_4.make (<<4>>)
			create g_6.make (<<6>>)
			create g_8.make (<<8>>)
			create gsl_wavelet_daubechies.make
			create gsl_wavelet_daubechies_centered.make
			create h_10.make (<<10>>)
			create h_12.make (<<12>>)
			create h_14.make (<<14>>)
			create h_16.make (<<16>>)
			create h_18.make (<<18>>)
			create h_20.make (<<20>>)
			create h_4.make (<<4>>)
			create h_6.make (<<6>>)
			create h_8.make (<<8>>)
		end

feature {ANY} -- attributes

	daubechies_centered_type: CE_ARRAY [PD_GSL_WAVELET_TYPE]

	daubechies_type: CE_ARRAY [PD_GSL_WAVELET_TYPE]

	g_10: CE_ARRAY [REAL_64]

	g_12: CE_ARRAY [REAL_64]

	g_14: CE_ARRAY [REAL_64]

	g_16: CE_ARRAY [REAL_64]

	g_18: CE_ARRAY [REAL_64]

	g_20: CE_ARRAY [REAL_64]

	g_4: CE_ARRAY [REAL_64]

	g_6: CE_ARRAY [REAL_64]

	g_8: CE_ARRAY [REAL_64]

	gsl_wavelet_daubechies: CE_POINTER [PD_GSL_WAVELET_TYPE] assign set_gsl_wavelet_daubechies

	set_gsl_wavelet_daubechies (a_gsl_wavelet_daubechies: CE_POINTER [PD_GSL_WAVELET_TYPE])
		do
			gsl_wavelet_daubechies := a_gsl_wavelet_daubechies
		end

	gsl_wavelet_daubechies_centered: CE_POINTER [PD_GSL_WAVELET_TYPE] assign set_gsl_wavelet_daubechies_centered

	set_gsl_wavelet_daubechies_centered (a_gsl_wavelet_daubechies_centered: CE_POINTER [PD_GSL_WAVELET_TYPE])
		do
			gsl_wavelet_daubechies_centered := a_gsl_wavelet_daubechies_centered
		end

	h_10: CE_ARRAY [REAL_64]

	h_12: CE_ARRAY [REAL_64]

	h_14: CE_ARRAY [REAL_64]

	h_16: CE_ARRAY [REAL_64]

	h_18: CE_ARRAY [REAL_64]

	h_20: CE_ARRAY [REAL_64]

	h_4: CE_ARRAY [REAL_64]

	h_6: CE_ARRAY [REAL_64]

	h_8: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	daubechies_centered_init (a_h1: CE_POINTER [CE_POINTER [REAL_64]]; a_g1: CE_POINTER [CE_POINTER [REAL_64]]; a_h2: CE_POINTER [CE_POINTER [REAL_64]]; a_g2: CE_POINTER [CE_POINTER [REAL_64]]; a_nc: CE_POINTER [NATURAL_32]; a_offset: CE_POINTER [NATURAL_32]; a_member: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_member.to_integer_32 -- switch 1 head
					when 4 then l_pos := -1 + 1
					when 6 then l_pos := -1 + 2
					when 8 then l_pos := -1 + 3
					when 10 then l_pos := -1 + 4
					when 12 then l_pos := -1 + 5
					when 14 then l_pos := -1 + 6
					when 16 then l_pos := -1 + 7
					when 18 then l_pos := -1 + 8
					when 20 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 1 then -- switch 1, case 4
					a_h1.item := h_4
					a_g1.item := g_4
					a_h2.item := h_4
					a_g2.item := g_4
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 6
					a_h1.item := h_6
					a_g1.item := g_6
					a_h2.item := h_6
					a_g2.item := g_6
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 8
					a_h1.item := h_8
					a_g1.item := g_8
					a_h2.item := h_8
					a_g2.item := g_8
					l_pos := -1 + 11 -- switch 1; break
				when 4 then -- switch 1, case 10
					a_h1.item := h_10
					a_g1.item := g_10
					a_h2.item := h_10
					a_g2.item := g_10
					l_pos := -1 + 11 -- switch 1; break
				when 5 then -- switch 1, case 12
					a_h1.item := h_12
					a_g1.item := g_12
					a_h2.item := h_12
					a_g2.item := g_12
					l_pos := -1 + 11 -- switch 1; break
				when 6 then -- switch 1, case 14
					a_h1.item := h_14
					a_g1.item := g_14
					a_h2.item := h_14
					a_g2.item := g_14
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 16
					a_h1.item := h_16
					a_g1.item := g_16
					a_h2.item := h_16
					a_g2.item := g_16
					l_pos := -1 + 11 -- switch 1; break
				when 8 then -- switch 1, case 18
					a_h1.item := h_18
					a_g1.item := g_18
					a_h2.item := h_18
					a_g2.item := g_18
					l_pos := -1 + 11 -- switch 1; break
				when 9 then -- switch 1, case 20
					a_h1.item := h_20
					a_g1.item := g_20
					a_h2.item := h_20
					a_g2.item := g_20
					l_pos := -1 + 11 -- switch 1; break
				when 10 then -- switch 1, default:
					Result := (-1)
					js.return
				when 11 then -- switch 1, done:
					if not js.return_called then
						a_nc.item := a_member
						a_offset.item := (a_member).bit_shift_right (1)
						Result := 0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	daubechies_centered_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent daubechies_centered_init)
		end

	daubechies_init (a_h1: CE_POINTER [CE_POINTER [REAL_64]]; a_g1: CE_POINTER [CE_POINTER [REAL_64]]; a_h2: CE_POINTER [CE_POINTER [REAL_64]]; a_g2: CE_POINTER [CE_POINTER [REAL_64]]; a_nc: CE_POINTER [NATURAL_32]; a_offset: CE_POINTER [NATURAL_32]; a_member: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_member.to_integer_32 -- switch 1 head
					when 4 then l_pos := -1 + 1
					when 6 then l_pos := -1 + 2
					when 8 then l_pos := -1 + 3
					when 10 then l_pos := -1 + 4
					when 12 then l_pos := -1 + 5
					when 14 then l_pos := -1 + 6
					when 16 then l_pos := -1 + 7
					when 18 then l_pos := -1 + 8
					when 20 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 1 then -- switch 1, case 4
					a_h1.item := h_4
					a_g1.item := g_4
					a_h2.item := h_4
					a_g2.item := g_4
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 6
					a_h1.item := h_6
					a_g1.item := g_6
					a_h2.item := h_6
					a_g2.item := g_6
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 8
					a_h1.item := h_8
					a_g1.item := g_8
					a_h2.item := h_8
					a_g2.item := g_8
					l_pos := -1 + 11 -- switch 1; break
				when 4 then -- switch 1, case 10
					a_h1.item := h_10
					a_g1.item := g_10
					a_h2.item := h_10
					a_g2.item := g_10
					l_pos := -1 + 11 -- switch 1; break
				when 5 then -- switch 1, case 12
					a_h1.item := h_12
					a_g1.item := g_12
					a_h2.item := h_12
					a_g2.item := g_12
					l_pos := -1 + 11 -- switch 1; break
				when 6 then -- switch 1, case 14
					a_h1.item := h_14
					a_g1.item := g_14
					a_h2.item := h_14
					a_g2.item := g_14
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 16
					a_h1.item := h_16
					a_g1.item := g_16
					a_h2.item := h_16
					a_g2.item := g_16
					l_pos := -1 + 11 -- switch 1; break
				when 8 then -- switch 1, case 18
					a_h1.item := h_18
					a_g1.item := g_18
					a_h2.item := h_18
					a_g2.item := g_18
					l_pos := -1 + 11 -- switch 1; break
				when 9 then -- switch 1, case 20
					a_h1.item := h_20
					a_g1.item := g_20
					a_h2.item := h_20
					a_g2.item := g_20
					l_pos := -1 + 11 -- switch 1; break
				when 10 then -- switch 1, default:
					Result := (-1)
					js.return
				when 11 then -- switch 1, done:
					if not js.return_called then
						a_nc.item := a_member
						a_offset.item := (0).to_natural_32
						Result := 0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	daubechies_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent daubechies_init)
		end

end
