class
	P_DD

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_poly_dd_init (a_dd: CE_POINTER [REAL_64]; a_xa: CE_POINTER [REAL_64]; a_ya: CE_POINTER [REAL_64]; a_size: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			a_dd[0] := a_ya[0]
			l_j := a_size - {NATURAL_32} 1
			from
			until
				not (l_j >= {NATURAL_32} 1)
			loop
				a_dd[l_j.to_integer_32] := ((a_ya[l_j.to_integer_32] - a_ya[(l_j - {NATURAL_32} 1).to_integer_32]) / (a_xa[l_j.to_integer_32] - a_xa[(l_j - {NATURAL_32} 1).to_integer_32]))
				l_j := l_j - 1
			end
			l_i := (2).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_size))
			loop
				l_j := a_size - {NATURAL_32} 1
				from
				until
					not (l_j >= l_i)
				loop
					a_dd[l_j.to_integer_32] := (a_dd[l_j.to_integer_32] - a_dd[(l_j - {NATURAL_32} 1).to_integer_32]) / (a_xa[l_j.to_integer_32] - a_xa[(l_j - l_i).to_integer_32])
					l_j := l_j - 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_poly_dd_taylor (a_c___1: CE_POINTER [REAL_64]; a_xp: REAL_64; a_dd: CE_POINTER [REAL_64]; a_xa: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_w: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				a_c___1[l_i.to_integer_32] := 0.0
				a_w[l_i.to_integer_32] := 0.0
				l_i := l_i + 1
			end
			a_w[(a_size - {NATURAL_32} 1).to_integer_32] := 1.0
			a_c___1[0] := a_dd[0]
			l_i := a_size - {NATURAL_32} 1
			from
			until
				js.loop_done
			loop
				l_tmp := l_i
				l_i := l_i - 1
				if not (l_tmp > {NATURAL_32} 0) then
					js.break
				end
				if not js.loop_jumped then
					a_w[l_i.to_integer_32] := -a_w[(l_i + {NATURAL_32} 1).to_integer_32] * (a_xa[((a_size - {NATURAL_32} 2) - l_i).to_integer_32] - a_xp)
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (l_j < a_size - {NATURAL_32} 1)
					loop
						a_w[l_j.to_integer_32] := a_w[l_j.to_integer_32] - (a_w[(l_j + {NATURAL_32} 1).to_integer_32] * (a_xa[((a_size - {NATURAL_32} 2) - l_i).to_integer_32] - a_xp))
						l_j := l_j + 1
					end
					l_j := l_i
					from
					until
						not (l_j < a_size)
					loop
						a_c___1[(l_j - l_i).to_integer_32] := a_c___1[(l_j - l_i).to_integer_32] + (a_w[l_j.to_integer_32] * a_dd[((a_size - l_i) - {NATURAL_32} 1).to_integer_32])
						l_j := l_j + 1
					end
				end
			end
			Result := 0
		end

end
