class
	P_DEFAULT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_rng_env_setup: CE_POINTER [PD_GSL_RNG_TYPE]
		local
			l_seed: NATURAL_32
			l_p: CE_POINTER [INTEGER_8]
			l_t: CE_POINTER [CE_POINTER [PD_GSL_RNG_TYPE]]
			l_t0: CE_POINTER [CE_POINTER [PD_GSL_RNG_TYPE]]
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_p.make
			create l_t.make
			create l_t0.make

			l_seed := {NATURAL_32} 0
			l_p := (getenv (ce_string ("GSL_RNG_TYPE")))
			if (not l_p.is_void) then
				l_t0 := (types_inst.gsl_rng_types_setup)
				mt_inst.gsl_rng_default := create {CE_POINTER [PD_GSL_RNG_TYPE]}.make_shared (default_pointer)
				l_t := l_t0
				from
				until
					not (not js.loop_done and then (not (l_t.item).is_void))
				loop
					if (strcmp (l_p, (l_t.item).item.name)) = 0 then
						mt_inst.gsl_rng_default := l_t.item
						js.break
					end
					if not js.loop_jumped then
						l_t := l_t + 1
					end
				end
				if mt_inst.gsl_rng_default.is_void then
					l_i := 0
					Io.error.put_string ("GSL_RNG_TYPE=" + eif_string (l_p) + " not recognized%N")
					Io.error.put_string ("Valid generator types are:%N")
					l_t := l_t0
					from
					until
						(l_t.item).is_void
					loop
						fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), ce_string (" %%18s"), (l_t.item).item.name]).do_nothing
						l_i := l_i + 1
						if l_i \\ 4 = 0 then
							fputc (('%N').code, (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))).do_nothing
						end
						l_t := l_t + 1
					end
					fputc (('%N').code, (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))).do_nothing
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("unknown generator"), ce_string ("default.c"), 72, 4)
						Result := (create {CE_POINTER [PD_GSL_RNG_TYPE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					Io.error.put_string ("GSL_RNG_TYPE=" + eif_string (mt_inst.gsl_rng_default.item.name) + "%N")
				end
			else
				mt_inst.gsl_rng_default := mt_inst.gsl_rng_mt19937
			end
			if not js.return_called then
				l_p := (getenv (ce_string ("GSL_RNG_SEED")))
				if (not l_p.is_void) then
					l_seed := strtoul (l_p, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 0)
					fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), ce_string ("GSL_RNG_SEED=%%lu%N"), l_seed]).do_nothing
				end
				mt_inst.gsl_rng_default_seed := l_seed
				Result := mt_inst.gsl_rng_default
			end
		end

end
