class
	P_DZNRM2

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_dznrm2 (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32): REAL_64
		local
			l_scale: REAL_64
			l_ssq: REAL_64
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_x: REAL_64
			l_y: REAL_64
			l_ax: REAL_64
			l_ay: REAL_64
			js: JUMP_STATE
		do
			l_scale := 0.0
			l_ssq := 1.0
			l_ix := 0
			if a_N = 0 then
				Result := (0).to_double
				js.return
			elseif a_incX < 1 then
				Result := (0).to_double
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_x := create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_ix]
					l_y := create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_ix + 1)]
					if l_x /= 0.0 then
						l_ax := (fabs (l_x))
						if l_scale < l_ax then
							l_ssq := 1.0 + (l_ssq * (l_scale / l_ax)) * (l_scale / l_ax)
							l_scale := l_ax
						else
							l_ssq := l_ssq + ((l_ax / l_scale) * (l_ax / l_scale))
						end
					end
					if l_y /= 0.0 then
						l_ay := (fabs (l_y))
						if l_scale < l_ay then
							l_ssq := 1.0 + (l_ssq * (l_scale / l_ay)) * (l_scale / l_ay)
							l_scale := l_ay
						else
							l_ssq := l_ssq + ((l_ay / l_scale) * (l_ay / l_scale))
						end
					end
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
				Result := (l_scale * (sqrt (l_ssq)))
			end
		end

end
