class
	P_ELLJAC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_elljac_e (a_u: REAL_64; a_m___4: REAL_64; a_sn: CE_POINTER [REAL_64]; a_cn: CE_POINTER [REAL_64]; a_dn: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_status: INTEGER_32
			l_N: INTEGER_32
			l_mu: CE_ARRAY [REAL_64]
			l_nu: CE_ARRAY [REAL_64]
			l_c___1: CE_ARRAY [REAL_64]
			l_d: CE_ARRAY [REAL_64]
			l_sin_umu: REAL_64
			l_cos_umu: REAL_64
			l_t: REAL_64
			l_r___3: REAL_64
			l_n2: INTEGER_32
			l_tmp___0: REAL_64
			l_tmp___3: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___8: REAL_64
			js: JUMP_STATE
		do
			create l_mu.make (<<16>>)
			create l_nu.make (<<16>>)
			create l_c___1.make (<<16>>)
			create l_d.make (<<16>>)

			if (fabs (a_m___4)) > 1.0 then
				a_sn.item := 0.0
				a_cn.item := 0.0
				a_dn.item := 0.0
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("|m| > 1.0"), ce_string ("elljac.c"), 46, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif (fabs (a_m___4)) < 2.0 * 2.2204460492503131e-16 then
				a_sn.item := sin (a_u)
				a_cn.item := cos (a_u)
				a_dn.item := 1.0
				Result := 0
				js.return
			elseif (fabs (a_m___4 - 1.0)) < 2.0 * 2.2204460492503131e-16 then
				a_sn.item := tanh (a_u)
				a_cn.item := 1.0 / (cosh (a_u))
				a_dn.item := a_cn.item
				Result := 0
				js.return
			else
				l_status := 0
				l_N := 16
				l_n2 := 0
				l_mu[0] := 1.0
				l_nu[0] := sqrt (1.0 - a_m___4)
				from
				until
					js.loop_done
				loop
					l_tmp___0 := fabs (l_mu[l_n2] - l_nu[l_n2])
					if not (l_tmp___0 > (4.0 * 2.2204460492503131e-16) * (fabs (l_mu[l_n2] + l_nu[l_n2]))) then
						js.break
					end
					if not js.loop_jumped then
						l_mu[l_n2 + 1] := 0.5 * (l_mu[l_n2] + l_nu[l_n2])
						l_nu[l_n2 + 1] := sqrt (l_mu[l_n2] * l_nu[l_n2])
						l_n2 := l_n2 + 1
						if l_n2 >= l_N - 1 then
							l_status := 11
							js.break
						end
					end
				end
				l_sin_umu := sin (a_u * l_mu[l_n2])
				l_cos_umu := cos (a_u * l_mu[l_n2])
				l_tmp___8 := fabs (l_sin_umu)
				if l_tmp___8 < (fabs (l_cos_umu)) then
					l_t := l_sin_umu / l_cos_umu
					l_c___1[l_n2] := l_mu[l_n2] * l_t
					l_d[l_n2] := 1.0
					from
					until
						not (l_n2 > 0)
					loop
						l_n2 := l_n2 - 1
						l_c___1[l_n2] := l_d[l_n2 + 1] * l_c___1[l_n2 + 1]
						l_r___3 := (l_c___1[l_n2 + 1] * l_c___1[l_n2 + 1]) / l_mu[l_n2 + 1]
						l_d[l_n2] := (l_r___3 + l_nu[l_n2]) / (l_r___3 + l_mu[l_n2])
					end
					a_dn.item := (sqrt (1.0 - a_m___4)) / l_d[l_n2]
					if l_cos_umu >= 0.0 then
						l_tmp___3 := 1
					else
						l_tmp___3 := -1
					end
					a_cn.item := (a_dn.item * l_tmp___3.to_double) / (hypot_inst.gsl_hypot (1.0, l_c___1[l_n2]))
					a_sn.item := (a_cn.item * l_c___1[l_n2]) / (sqrt (1.0 - a_m___4))
				else
					l_t := l_cos_umu / l_sin_umu
					l_c___1[l_n2] := l_mu[l_n2] * l_t
					l_d[l_n2] := 1.0
					from
					until
						not (l_n2 > 0)
					loop
						l_n2 := l_n2 - 1
						l_c___1[l_n2] := l_d[l_n2 + 1] * l_c___1[l_n2 + 1]
						l_r___3 := (l_c___1[l_n2 + 1] * l_c___1[l_n2 + 1]) / l_mu[l_n2 + 1]
						l_d[l_n2] := (l_r___3 + l_nu[l_n2]) / (l_r___3 + l_mu[l_n2])
					end
					a_dn.item := l_d[l_n2]
					if l_sin_umu >= 0.0 then
						l_tmp___6 := 1
					else
						l_tmp___6 := -1
					end
					a_sn.item := l_tmp___6.to_double / (hypot_inst.gsl_hypot (1.0, l_c___1[l_n2]))
					a_cn.item := l_c___1[l_n2] * a_sn.item
				end
				Result := l_status
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
