class
	P_FDIST

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_fdist_P (a_x: REAL_64; a_nu1: REAL_64; a_nu2: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_r___3: REAL_64
			l_u: REAL_64
			l_u___0: REAL_64
		do
			l_r___3 := a_nu2 / a_nu1
			if a_x < l_r___3 then
				l_u := a_x / (l_r___3 + a_x)
				l_P___2 := beta_inc_inst.beta_inc_AXPY (1.0, 0.0, a_nu1 / 2.0, a_nu2 / 2.0, l_u)
			else
				l_u___0 := l_r___3 / (l_r___3 + a_x)
				l_P___2 := beta_inc_inst.beta_inc_AXPY (-1.0, 1.0, a_nu2 / 2.0, a_nu1 / 2.0, l_u___0)
			end
			Result := l_P___2
		end

	gsl_cdf_fdist_Q (a_x: REAL_64; a_nu1: REAL_64; a_nu2: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_r___3: REAL_64
			l_u: REAL_64
			l_u___0: REAL_64
		do
			l_r___3 := a_nu2 / a_nu1
			if a_x < l_r___3 then
				l_u := a_x / (l_r___3 + a_x)
				l_Q___1 := beta_inc_inst.beta_inc_AXPY (-1.0, 1.0, a_nu1 / 2.0, a_nu2 / 2.0, l_u)
			else
				l_u___0 := l_r___3 / (l_r___3 + a_x)
				l_Q___1 := beta_inc_inst.beta_inc_AXPY (1.0, 0.0, a_nu2 / 2.0, a_nu1 / 2.0, l_u___0)
			end
			Result := l_Q___1
		end

	gsl_ran_fdist (a_r___3: CE_POINTER [PD_GSL_RNG]; a_nu1: REAL_64; a_nu2: REAL_64): REAL_64
		local
			l_Y1: REAL_64
			l_Y2: REAL_64
			l_f: REAL_64
		do
			l_Y1 := (gamma_inst.gsl_ran_gamma (a_r___3, a_nu1 / (2).to_double, 2.0))
			l_Y2 := (gamma_inst.gsl_ran_gamma (a_r___3, a_nu2 / (2).to_double, 2.0))
			l_f := (l_Y1 * a_nu2) / (l_Y2 * a_nu1)
			Result := l_f
		end

	gsl_ran_fdist_pdf (a_x: REAL_64; a_nu1: REAL_64; a_nu2: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_lglg: REAL_64
			l_tmp: REAL_64
			l_lg12: REAL_64
			l_lg1: REAL_64
			l_lg2: REAL_64
			l_tmp___4: REAL_64
		do
			if a_x < (0).to_double then
				Result := (0).to_double
			else
				l_tmp := log (a_nu1)
				l_lglg := (a_nu1 / (2).to_double) * l_tmp + (a_nu2 / (2).to_double) * (log (a_nu2))
				l_lg12 := (gamma_inst.gsl_sf_lngamma ((a_nu1 + a_nu2) / (2).to_double))
				l_lg1 := (gamma_inst.gsl_sf_lngamma (a_nu1 / (2).to_double))
				l_lg2 := (gamma_inst.gsl_sf_lngamma (a_nu2 / (2).to_double))
				l_tmp___4 := log (a_x)
				l_p := exp (((((l_lglg + l_lg12) - l_lg1) - l_lg2) + (a_nu1 / (2).to_double - (1).to_double) * l_tmp___4) - ((a_nu1 + a_nu2) / (2).to_double) * (log (a_nu2 + a_nu1 * a_x)))
				Result := l_p
			end
		end

end
