class
	P_FDISTINV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_fdist_Pinv (a_P___2: REAL_64; a_nu1: REAL_64; a_nu2: REAL_64): REAL_64
		local
			l_result: REAL_64
			l_y: REAL_64
			js: JUMP_STATE
		do
			if a_P___2 < 0.0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("P < 0.0"), ce_string ("fdistinv.c"), 36, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_P___2 > 1.0) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("P > 1.0"), ce_string ("fdistinv.c"), 40, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_nu1 < 1.0) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("nu1 < 1"), ce_string ("fdistinv.c"), 44, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_nu2 < 1.0) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("nu2 < 1"), ce_string ("fdistinv.c"), 48, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_P___2 < 0.5 then
					l_y := betainv_inst.gsl_cdf_beta_Pinv (a_P___2, a_nu1 / 2.0, a_nu2 / 2.0)
					l_result := (a_nu2 * l_y) / (a_nu1 * (1.0 - l_y))
				else
					l_y := betainv_inst.gsl_cdf_beta_Qinv (a_P___2, a_nu2 / 2.0, a_nu1 / 2.0)
					l_result := (a_nu2 * ((1).to_double - l_y)) / (a_nu1 * l_y)
				end
				Result := l_result
			end
		end

	gsl_cdf_fdist_Qinv (a_Q___1: REAL_64; a_nu1: REAL_64; a_nu2: REAL_64): REAL_64
		local
			l_result: REAL_64
			l_y: REAL_64
			js: JUMP_STATE
		do
			if a_Q___1 < 0.0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("Q < 0.0"), ce_string ("fdistinv.c"), 75, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_Q___1 > 1.0) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("Q > 1.0"), ce_string ("fdistinv.c"), 79, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_nu1 < 1.0) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("nu1 < 1"), ce_string ("fdistinv.c"), 83, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_nu2 < 1.0) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("nu2 < 1"), ce_string ("fdistinv.c"), 87, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_Q___1 > 0.5 then
					l_y := betainv_inst.gsl_cdf_beta_Qinv (a_Q___1, a_nu1 / 2.0, a_nu2 / 2.0)
					l_result := (a_nu2 * l_y) / (a_nu1 * (1.0 - l_y))
				else
					l_y := betainv_inst.gsl_cdf_beta_Pinv (a_Q___1, a_nu2 / 2.0, a_nu1 / 2.0)
					l_result := (a_nu2 * ((1).to_double - l_y)) / (a_nu1 * l_y)
				end
				Result := l_result
			end
		end

end
