class
	P_FILE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_combination_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_k))
			loop
				l_status := (fprintf ([a_stream, a_format, l_data[l_i.to_integer_32]]))
				if l_status < 0 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file.c"), 77, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_combination_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT]): INTEGER_32
		local
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), {PLATFORM}.Natural_32_bytes.to_natural_32, l_k, a_stream))
			if l_items /= l_k then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("file.c"), 39, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_combination_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT]): INTEGER_32
		local
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_j: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_j.make (<<1>>)

			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_k))
			loop
				l_status := (fscanf ([a_stream, ce_string ("%%lu"), l_j]))
				if l_status /= 1 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("file.c"), 106, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					l_data[l_i.to_integer_32] := (l_j.item).to_natural_32
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_combination_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT]): INTEGER_32
		local
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), {PLATFORM}.Natural_32_bytes.to_natural_32, l_k, a_stream))
			if l_items /= l_k then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("file.c"), 56, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_histogram_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_range_format: CE_POINTER [INTEGER_8]; a_bin_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_n := a_h.item.n
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_status := (fprintf ([a_stream, a_range_format, a_h.item.range[l_i.to_integer_32]]))
				if l_status < 0 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file.c"), 63, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					l_status := IO_putc ((' ').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("file.c"), 70, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_status := fprintf ([a_stream, a_range_format, a_h.item.range[(l_i + {NATURAL_32} 1).to_integer_32]])
					if l_status < 0 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_status := IO_putc ((' ').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("file.c"), 84, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_status := fprintf ([a_stream, a_bin_format, a_h.item.bin[l_i.to_integer_32]])
					if l_status < 0 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file.c"), 91, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("file.c"), 98, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_histogram_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_h: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_status := (fwrite_source_inst.gsl_block_raw_fread (a_stream, a_h.item.range, a_h.item.n + {NATURAL_32} 1, (1).to_natural_32))
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_status := fwrite_source_inst.gsl_block_raw_fread (a_stream, a_h.item.bin, a_h.item.n, (1).to_natural_32)
				Result := l_status
			end
		end

	gsl_histogram_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_h: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_upper: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_upper.make (<<1>>)

			l_n := a_h.item.n
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_status := (fscanf ([a_stream, ce_string ("%%lg %%lg %%lg"), a_h.item.range + l_i.to_integer_32, l_upper, a_h.item.bin + l_i.to_integer_32]))
				if l_status /= 3 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("file.c"), 120, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				a_h.item.range[l_n.to_integer_32] := l_upper.item
				Result := 0
			end
		end

	gsl_histogram_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_h: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_status := (fwrite_source_inst.gsl_block_raw_fwrite (a_stream, a_h.item.range, (a_h.item.n + {NATURAL_32} 1), (1).to_natural_32))
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_status := fwrite_source_inst.gsl_block_raw_fwrite (a_stream, a_h.item.bin, a_h.item.n, (1).to_natural_32)
				Result := l_status
			end
		end

	gsl_multiset_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_k))
			loop
				l_status := (fprintf ([a_stream, a_format, l_data[l_i.to_integer_32]]))
				if l_status < 0 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file.c"), 79, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_multiset_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]): INTEGER_32
		local
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), {PLATFORM}.Natural_32_bytes.to_natural_32, l_k, a_stream))
			if l_items /= l_k then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("file.c"), 41, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_multiset_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]): INTEGER_32
		local
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_j: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_j.make (<<1>>)

			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_k))
			loop
				l_status := (fscanf ([a_stream, ce_string ("%%lu"), l_j]))
				if l_status /= 1 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("file.c"), 108, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					l_data[l_i.to_integer_32] := (l_j.item).to_natural_32
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_multiset_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]): INTEGER_32
		local
			l_k: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_k := a_c___1.item.k
			l_data := a_c___1.item.data
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), {PLATFORM}.Natural_32_bytes.to_natural_32, l_k, a_stream))
			if l_items /= l_k then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("file.c"), 58, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_permutation_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_p.item.size
			l_data := a_p.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_status := (fprintf ([a_stream, a_format, l_data[l_i.to_integer_32]]))
				if l_status < 0 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file.c"), 76, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_permutation_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_p.item.size
			l_data := a_p.item.data
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), {PLATFORM}.Natural_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("file.c"), 38, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_permutation_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_j: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_j.make (<<1>>)

			l_n := a_p.item.size
			l_data := a_p.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_status := (fscanf ([a_stream, ce_string ("%%lu"), l_j]))
				if l_status /= 1 then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("file.c"), 105, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
				if not js.return_called then
					l_data[l_i.to_integer_32] := (l_j.item).to_natural_32
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_permutation_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_p.item.size
			l_data := a_p.item.data
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), {PLATFORM}.Natural_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("file.c"), 55, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_rng_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_r___3: CE_POINTER [PD_GSL_RNG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_state: CE_POINTER [INTEGER_8]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_state.make

			l_n := (a_r___3.item.type).item.size
			l_state := create {CE_POINTER [INTEGER_8]}.make_cast (a_r___3.item.state)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_state), (1).to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("file.c"), 36, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_rng_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_r___3: CE_POINTER [PD_GSL_RNG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_state: CE_POINTER [INTEGER_8]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_state.make

			l_n := (a_r___3.item.type).item.size
			l_state := create {CE_POINTER [INTEGER_8]}.make_cast (a_r___3.item.state)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_state), (1).to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("file.c"), 53, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
