class
	P_FPRINTF_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_block_char_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (l_data[(l_i + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_char_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%d"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := (l_tmp.item).to_integer_8
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_char_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_8]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_char_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_8]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%d"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := (l_tmp.item).to_integer_8
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_float_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (l_data[({NATURAL_32} 2 * l_i + l_k.to_natural_32).to_integer_32]).to_double])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_float_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%g"), l_tmp]))
					l_data[({NATURAL_32} 2 * l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_float_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32]).to_double])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_float_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%g"), l_tmp]))
					a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_64]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, l_data[({NATURAL_32} 2 * l_i + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_64]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lg"), l_tmp]))
					l_data[({NATURAL_32} 2 * l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_long_double_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, l_data[({NATURAL_32} 2 * l_i + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_long_double_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_96]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%Lg"), l_tmp]))
					l_data[({NATURAL_32} 2 * l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_long_double_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_long_double_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_96]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%Lg"), l_tmp]))
					a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 2))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lg"), l_tmp]))
					a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_float_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (l_data[(l_i + l_k.to_natural_32).to_integer_32]).to_double])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_float_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%g"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_float_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_double])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_float_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%g"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_64]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, l_data[(l_i + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_64]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lg"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_int_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, l_data[(l_i + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_int_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%d"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_int_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_int_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%d"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_double_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, l_data[(l_i + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_double_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_96]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%Lg"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_double_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_double_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_96]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%Lg"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, l_data[(l_i + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%ld"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%ld"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lg"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_short_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_16]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (l_data[(l_i + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_short_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_16]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_16]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%hd"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_short_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_16]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_short_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_16]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_16]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%hd"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uchar_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_8]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (l_data[(l_i + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uchar_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_8]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%u"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := (l_tmp.item).to_natural_8
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uchar_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_8]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uchar_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_8]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%u"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := (l_tmp.item).to_natural_8
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uint_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, l_data[(l_i + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uint_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%u"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uint_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uint_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%u"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ulong_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, l_data[(l_i + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ulong_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lu"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ulong_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ulong_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lu"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ushort_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_16]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (l_data[(l_i + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ushort_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_16]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_16]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_tmp.make (<<1>>)

			l_n := a_b___0.item.size
			l_data := a_b___0.item.data
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%hu"), l_tmp]))
					l_data[(l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ushort_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_16]; a_n: NATURAL_32; a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ushort_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_16]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_16]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not js.loop_done and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%hu"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
