class
	P_FRANCIS

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	francis_get_submatrix (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]): NATURAL_32
		local
			l_diff: NATURAL_32
			l_ratio: REAL_64
			l_top: NATURAL_32
		do
			l_diff := ((a_B.item.data).distance ((a_A___0.item.data))).to_natural_32
			l_ratio := l_diff.to_real_64 / (a_A___0.item.tda + {NATURAL_32} 1).to_real_64
			l_top := (floor (l_ratio)).truncated_to_integer_64.to_natural_32
			Result := l_top
		end

	francis_qrstep (a_H: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_tau_i: REAL_64
			l_dat: CE_ARRAY [REAL_64]
			l_scale: REAL_64
			l_v2: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_v3: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_q___3: NATURAL_32
			l_r___3: NATURAL_32
			l_top: NATURAL_32
			l_s: REAL_64
			l_disc: REAL_64
			l_h_nn: REAL_64
			l_h_nm1nm1: REAL_64
			l_h_cross: REAL_64
			l_h_tmp1: REAL_64
			l_h_tmp2: REAL_64
			l_tmp___0: REAL_64
			l_tmp___4: REAL_64
			l_ave: REAL_64
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: REAL_64
			l_tmp___12: REAL_64
			l_tmp___14: REAL_64
			l_tmp___16: REAL_64
			l_tmp___17: REAL_64
			l_tmp___19: REAL_64
			l_tmp___20: REAL_64
			l_tmp___22: REAL_64
		do
			create l_m___4.make (<<1>>)
			create l_dat.make (<<3>>)
			create l_v2.make (<<1>>)
			create l_v3.make (<<1>>)

			l_N := a_H.item.size1
			l_top := (0).to_natural_32
			l_v2.item := (view_source_inst.gsl_vector_view_array (l_dat, (2).to_natural_32)).twin
			l_v3.item := (view_source_inst.gsl_vector_view_array (l_dat, (3).to_natural_32)).twin
			if a_w.item.n_iter \\ {NATURAL_32} 10 = {NATURAL_32} 0 then
				l_tmp___0 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 2)))
				l_s := l_tmp___0 + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 3))))
				l_h_nn := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 1)) + 0.75 * l_s
				l_h_nm1nm1 := l_h_nn
				l_h_cross := (-0.4375 * l_s) * l_s
			else
				l_h_nn := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 1)
				l_h_nm1nm1 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2)
				l_tmp___4 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 2)
				l_h_cross := l_tmp___4 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 1))
				l_disc := 0.5 * (l_h_nm1nm1 - l_h_nn)
				l_disc := l_disc * l_disc + l_h_cross
				if l_disc > 0.0 then
					l_disc := sqrt (l_disc)
					l_ave := 0.5 * (l_h_nm1nm1 + l_h_nn)
					l_tmp___8 := fabs (l_h_nm1nm1)
					if l_tmp___8 - (fabs (l_h_nn)) > 0.0 then
						l_h_nm1nm1 := l_h_nm1nm1 * l_h_nn - l_h_cross
						if l_ave >= 0.0 then
							l_tmp___6 := 1
						else
							l_tmp___6 := -1
						end
						l_h_nn := l_h_nm1nm1 / (l_disc * l_tmp___6.to_double + l_ave)
					else
						if l_ave >= 0.0 then
							l_tmp___7 := 1
						else
							l_tmp___7 := -1
						end
						l_h_nn := l_disc * l_tmp___7.to_double + l_ave
					end
					l_h_nm1nm1 := l_h_nn
					l_h_cross := 0.0
				end
			end
			l_h_tmp1 := l_h_nm1nm1 - (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (0).to_natural_32, (0).to_natural_32))
			l_h_tmp2 := l_h_nn - (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (0).to_natural_32, (0).to_natural_32))
			l_tmp___12 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (1).to_natural_32, (0).to_natural_32)
			l_dat[0] := (l_h_tmp1 * l_h_tmp2 - l_h_cross) / l_tmp___12 + (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (0).to_natural_32, (1).to_natural_32))
			l_tmp___14 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (1).to_natural_32, (1).to_natural_32)
			l_dat[1] := ((l_tmp___14 - (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (0).to_natural_32, (0).to_natural_32))) - l_h_tmp1) - l_h_tmp2
			l_dat[2] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (2).to_natural_32, (1).to_natural_32)
			l_tmp___16 := fabs (l_dat[0])
			l_tmp___17 := fabs (l_dat[1])
			l_scale := (l_tmp___16 + l_tmp___17) + (fabs (l_dat[2]))
			if l_scale /= 0.0 then
				l_dat[0] := l_dat[0] / l_scale
				l_dat[1] := l_dat[1] / l_scale
				l_dat[2] := l_dat[2] / l_scale
			end
			if (not (a_w.item.Z).is_void) then
				l_top := francis_get_submatrix (a_w.item.H, a_H)
			elseif (a_w.item.compute_t).to_boolean then
				l_top := francis_get_submatrix (a_w.item.H, a_H)
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N - {NATURAL_32} 2)
			loop
				l_tau_i := householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
				if l_tau_i /= 0.0 then
					if 1 > l_i.to_integer_32 - 1 then
						l_q___3 := (0).to_natural_32
					else
						l_q___3 := l_i - {NATURAL_32} 1
					end
					if l_i + {NATURAL_32} 3 < l_N - {NATURAL_32} 1 then
						l_r___3 := l_i + {NATURAL_32} 3
					else
						l_r___3 := l_N - {NATURAL_32} 1
					end
					if (a_w.item.compute_t).to_boolean then
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.H, l_top + l_i, l_top + l_q___3, (3).to_natural_32, (a_w.item.size - l_top) - l_q___3)).twin
						householder_inst.gsl_linalg_householder_hm (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.H, (0).to_natural_32, l_top + l_i, (l_top + l_r___3) + {NATURAL_32} 1, (3).to_natural_32)).twin
						householder_inst.gsl_linalg_householder_mh (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
					else
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_H, l_i, l_q___3, (3).to_natural_32, l_N - l_q___3)).twin
						householder_inst.gsl_linalg_householder_hm (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_H, (0).to_natural_32, l_i, l_r___3 + {NATURAL_32} 1, (3).to_natural_32)).twin
						householder_inst.gsl_linalg_householder_mh (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
					end
					if (not (a_w.item.Z).is_void) then
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.Z, (0).to_natural_32, l_top + l_i, a_w.item.size, (3).to_natural_32)).twin
						householder_inst.gsl_linalg_householder_mh (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
					end
				end
				l_dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_i + {NATURAL_32} 1, l_i)
				l_dat[1] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_i + {NATURAL_32} 2, l_i)
				if l_i < l_N - {NATURAL_32} 3 then
					l_dat[2] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_i + {NATURAL_32} 3, l_i)
				end
				l_tmp___19 := fabs (l_dat[0])
				l_tmp___20 := fabs (l_dat[1])
				l_scale := (l_tmp___19 + l_tmp___20) + (fabs (l_dat[2]))
				if l_scale /= 0.0 then
					l_dat[0] := l_dat[0] / l_scale
					l_dat[1] := l_dat[1] / l_scale
					l_dat[2] := l_dat[2] / l_scale
				end
				l_i := l_i + 1
			end
			l_tmp___22 := fabs (l_dat[0])
			l_scale := l_tmp___22 + (fabs (l_dat[1]))
			if l_scale /= 0.0 then
				l_dat[0] := l_dat[0] / l_scale
				l_dat[1] := l_dat[1] / l_scale
			end
			l_tau_i := householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
			if (a_w.item.compute_t).to_boolean then
				l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.H, (l_top + l_N) - {NATURAL_32} 2, (l_top + l_N) - {NATURAL_32} 3, (2).to_natural_32, ((a_w.item.size - l_top) - l_N) + {NATURAL_32} 3)).twin
				householder_inst.gsl_linalg_householder_hm (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
				l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.H, (0).to_natural_32, (l_top + l_N) - {NATURAL_32} 2, l_top + l_N, (2).to_natural_32)).twin
				householder_inst.gsl_linalg_householder_mh (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
			else
				l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 3, (2).to_natural_32, (3).to_natural_32)).twin
				householder_inst.gsl_linalg_householder_hm (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
				l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_H, (0).to_natural_32, l_N - {NATURAL_32} 2, l_N, (2).to_natural_32)).twin
				householder_inst.gsl_linalg_householder_mh (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
			end
			if (not (a_w.item.Z).is_void) then
				l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.Z, (0).to_natural_32, (l_top + l_N) - {NATURAL_32} 2, a_w.item.size, (2).to_natural_32)).twin
				householder_inst.gsl_linalg_householder_mh (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
			end
			Result := 0
		end

	francis_schur_decomp (a_H: CE_POINTER [PD_GSL_MATRIX]; a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE])
		local
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_N: NATURAL_32
			l_q___3: NATURAL_32
			l_lambda1: CE_ARRAY [PD_GSL_COMPLEX]
			l_lambda2: CE_ARRAY [PD_GSL_COMPLEX]
			l_v: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_v___0: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_v___1: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_m___4.make (<<1>>)
			create l_lambda1.make (<<1>>)
			create l_lambda2.make (<<1>>)
			create l_v.make (<<1>>)
			create l_v___0.make (<<1>>)
			create l_v___1.make (<<1>>)

			l_N := a_H.item.size1
			l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_H, (0).to_natural_32, (0).to_natural_32, l_N, l_N)).twin
			from
			until
				js.loop_done
			loop
				if l_N > {NATURAL_32} 2 then
					l_tmp := a_w.item.n_iter
					a_w.item.n_iter := (a_w.item.n_iter) + 1
					if not (l_tmp < a_w.item.max_iterations) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_q___3 := francis_search_subdiag_small_elements (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")))
					if l_q___3 = {NATURAL_32} 0 then
						francis_qrstep (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), a_w).do_nothing
						js.continue
					end
				end
				if not js.loop_jumped then
					if l_q___3 = l_N - {NATURAL_32} 1 then
						from
						until
							js.loop_done
						loop
							l_lambda1.item.dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))), l_q___3, l_q___3)
							l_lambda1.item.dat[1] := 0.0
							js.break
						end
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, a_w.item.n_evals, (l_lambda1.item).twin)
						a_w.item.n_evals := (a_w.item.n_evals) + 1
						a_w.item.n_iter := (0).to_natural_32
						l_N := l_N - 1
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), (0).to_natural_32, (0).to_natural_32, l_N, l_N)).twin
					elseif l_q___3 = l_N - {NATURAL_32} 2 then
						l_v.item := (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), l_q___3, l_q___3, (2).to_natural_32, (2).to_natural_32)).twin
						francis_schur_standardize (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_v.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), l_lambda1, l_lambda2, a_w)
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, a_w.item.n_evals, (l_lambda1.item).twin)
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, a_w.item.n_evals + {NATURAL_32} 1, (l_lambda2.item).twin)
						a_w.item.n_evals := a_w.item.n_evals + ({NATURAL_32} 2)
						a_w.item.n_iter := (0).to_natural_32
						l_N := l_N - ({NATURAL_32} 2)
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), (0).to_natural_32, (0).to_natural_32, l_N, l_N)).twin
					elseif l_q___3 = {NATURAL_32} 1 then
						from
						until
							js.loop_done
						loop
							l_lambda1.item.dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))), (0).to_natural_32, (0).to_natural_32)
							l_lambda1.item.dat[1] := 0.0
							js.break
						end
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, a_w.item.n_evals, (l_lambda1.item).twin)
						a_w.item.n_evals := (a_w.item.n_evals) + 1
						a_w.item.n_iter := (0).to_natural_32
						l_N := l_N - 1
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), (1).to_natural_32, (1).to_natural_32, l_N, l_N)).twin
					elseif l_q___3 = {NATURAL_32} 2 then
						l_v___0.item := (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), (0).to_natural_32, (0).to_natural_32, (2).to_natural_32, (2).to_natural_32)).twin
						francis_schur_standardize (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_v___0.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), l_lambda1, l_lambda2, a_w)
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, a_w.item.n_evals, (l_lambda1.item).twin)
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, a_w.item.n_evals + {NATURAL_32} 1, (l_lambda2.item).twin)
						a_w.item.n_evals := a_w.item.n_evals + ({NATURAL_32} 2)
						a_w.item.n_iter := (0).to_natural_32
						l_N := l_N - ({NATURAL_32} 2)
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), (2).to_natural_32, (2).to_natural_32, l_N, l_N)).twin
					else
						l_v___1.item := (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), l_q___3, l_q___3, l_N - l_q___3, l_N - l_q___3)).twin
						francis_schur_decomp (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_v___1.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), a_eval, a_w)
						l_v___1.item := (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), (0).to_natural_32, (0).to_natural_32, l_q___3, l_q___3)).twin
						francis_schur_decomp (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_v___1.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), a_eval, a_w)
						l_N := (0).to_natural_32
					end
				end
			end
			if l_N = {NATURAL_32} 1 then
				from
				until
					js.loop_done
				loop
					l_lambda1.item.dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))), (0).to_natural_32, (0).to_natural_32)
					l_lambda1.item.dat[1] := 0.0
					js.break
				end
				gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, a_w.item.n_evals, (l_lambda1.item).twin)
				a_w.item.n_evals := (a_w.item.n_evals) + 1
				a_w.item.n_iter := (0).to_natural_32
			elseif l_N = {NATURAL_32} 2 then
				francis_schur_standardize (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), l_lambda1, l_lambda2, a_w)
				gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, a_w.item.n_evals, (l_lambda1.item).twin)
				gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, a_w.item.n_evals + {NATURAL_32} 1, (l_lambda2.item).twin)
				a_w.item.n_evals := a_w.item.n_evals + ({NATURAL_32} 2)
				a_w.item.n_iter := (0).to_natural_32
			end
		end

	francis_schur_standardize (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_eval1: CE_POINTER [PD_GSL_COMPLEX]; a_eval2: CE_POINTER [PD_GSL_COMPLEX]; a_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE])
		local
			l_N: NATURAL_32
			l_cs: CE_ARRAY [REAL_64]
			l_sn: CE_ARRAY [REAL_64]
			l_top: NATURAL_32
			l_tmp: REAL_64
			l_tmp___1: REAL_64
			l_xv: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_yv: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_xv___0: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_yv___0: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			js: JUMP_STATE
		do
			create l_cs.make (<<1>>)
			create l_sn.make (<<1>>)
			create l_xv.make (<<1>>)
			create l_yv.make (<<1>>)
			create l_xv___0.make (<<1>>)
			create l_yv___0.make (<<1>>)

			l_N := a_w.item.size
			l_top := francis_get_submatrix (a_w.item.H, a_A___0)
			francis_standard_form (a_A___0, l_cs, l_sn)
			from
			until
				js.loop_done
			loop
				a_eval1.item.dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)
				js.break
			end
			from
			until
				js.loop_done
			loop
				a_eval2.item.dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32)
				js.break
			end
			if (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32)) = 0.0 then
				from
				until
					js.loop_done
				loop
					a_eval1.item.dat[1] := 0.0
					js.break
				end
				from
				until
					js.loop_done
				loop
					a_eval2.item.dat[1] := 0.0
					js.break
				end
			else
				l_tmp___1 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32)))
				l_tmp := (sqrt (l_tmp___1 * (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32))))))
				from
				until
					js.loop_done
				loop
					a_eval1.item.dat[1] := l_tmp
					js.break
				end
				from
				until
					js.loop_done
				loop
					a_eval2.item.dat[1] := -l_tmp
					js.break
				end
			end
			if (a_w.item.compute_t).to_boolean then
				if l_top < l_N - {NATURAL_32} 2 then
					l_xv.item := (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, l_top, l_top + {NATURAL_32} 2, (l_N - l_top) - {NATURAL_32} 2)).twin
					l_yv.item := (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, l_top + {NATURAL_32} 1, l_top + {NATURAL_32} 2, (l_N - l_top) - {NATURAL_32} 2)).twin
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), l_cs.item, l_sn.item).do_nothing
				end
				if l_top > {NATURAL_32} 0 then
					l_xv.item := (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, l_top, (0).to_natural_32, l_top)).twin
					l_yv.item := (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, l_top + {NATURAL_32} 1, (0).to_natural_32, l_top)).twin
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), l_cs.item, l_sn.item).do_nothing
				end
			end
			if (not (a_w.item.Z).is_void) then
				l_xv___0.item := (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, l_top)).twin
				l_yv___0.item := (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, l_top + {NATURAL_32} 1)).twin
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv___0.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv___0.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), l_cs.item, l_sn.item).do_nothing
			end
		end

	francis_search_subdiag_small_elements (a_A___0: CE_POINTER [PD_GSL_MATRIX]): NATURAL_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_dpel: REAL_64
			l_sel: REAL_64
			l_del: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
			js: JUMP_STATE
		do
			l_N := a_A___0.item.size1
			l_dpel := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2))
			l_i := l_N - {NATURAL_32} 1
			from
			until
				not (not js.loop_done and then (l_i > {NATURAL_32} 0))
			loop
				l_sel := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i - {NATURAL_32} 1))
				l_del := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i))
				if l_sel = 0.0 then
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_i, l_i - {NATURAL_32} 1, 0.0)
					Result := l_i
					js.return
				else
					l_tmp___2 := fabs (l_sel)
					l_tmp___3 := fabs (l_del)
					if l_tmp___2 < 2.2204460492503131e-16 * (l_tmp___3 + (fabs (l_dpel))) then
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_i, l_i - {NATURAL_32} 1, 0.0)
						Result := l_i
						js.return
					end
				end
				if not js.return_called then
					l_dpel := l_del
					l_i := l_i - 1
				end
			end
			if not js.return_called then
				Result := (0).to_natural_32
			end
		end

	francis_standard_form (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_cs: CE_POINTER [REAL_64]; a_sn: CE_POINTER [REAL_64])
		local
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_c___1: REAL_64
			l_d: REAL_64
			l_tmp: REAL_64
			l_p: REAL_64
			l_z: REAL_64
			l_bcmax: REAL_64
			l_bcmis: REAL_64
			l_scale: REAL_64
			l_tau: REAL_64
			l_sigma: REAL_64
			l_cs1: REAL_64
			l_sn1: REAL_64
			l_aa: REAL_64
			l_bb: REAL_64
			l_cc: REAL_64
			l_dd: REAL_64
			l_sab: REAL_64
			l_sac: REAL_64
			l_tmp___4: REAL_64
			l_tmp___10: REAL_64
			l_tmp___11: REAL_64
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: REAL_64
			l_tmp___23: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___30: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a___5 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)
					l_b___0 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32)
					l_c___1 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32)
					l_d := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32)
					if l_c___1 /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_cs.item := 1.0
						a_sn.item := 0.0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if l_b___0 /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_cs.item := 0.0
						a_sn.item := 1.0
						l_tmp := l_d
						l_d := l_a___5
						l_a___5 := l_tmp
						l_b___0 := -l_c___1
						l_c___1 := 0.0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_a___5 - l_d /= 0.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_b___0 >= 0.0 then
							l_tmp___32 := 1
						else
							l_tmp___32 := -1
						end
						if l_c___1 >= 0.0 then
							l_tmp___33 := 1
						else
							l_tmp___33 := -1
						end
						if l_tmp___32 /= l_tmp___33 then
							a_cs.item := 1.0
							a_sn.item := 0.0
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						l_tmp := l_a___5 - l_d
						l_p := 0.5 * l_tmp
						l_tmp___4 := fabs (l_b___0)
						if l_tmp___4 > (fabs (l_c___1)) then
							l_bcmax := (fabs (l_b___0))
						else
							l_bcmax := (fabs (l_c___1))
						end
						l_tmp___11 := fabs (l_b___0)
						if l_tmp___11 < (fabs (l_c___1)) then
							l_tmp___10 := (fabs (l_b___0))
						else
							l_tmp___10 := (fabs (l_c___1))
						end
						if l_b___0 >= 0.0 then
							l_tmp___13 := 1
						else
							l_tmp___13 := -1
						end
						if l_c___1 >= 0.0 then
							l_tmp___14 := 1
						else
							l_tmp___14 := -1
						end
						l_bcmis := (l_tmp___10 * l_tmp___13.to_double) * l_tmp___14.to_double
						if (fabs (l_p)) > l_bcmax then
							l_scale := (fabs (l_p))
						else
							l_scale := l_bcmax
						end
						l_z := (l_p / l_scale) * l_p + (l_bcmax / l_scale) * l_bcmis
						if l_z >= 4.0 * 2.2204460492503131e-16 then
							if l_p >= 0.0 then
								l_tmp___18 := 1
							else
								l_tmp___18 := -1
							end
							l_tmp___19 := sqrt (l_scale)
							l_z := l_p + l_tmp___18.to_double * (fabs (l_tmp___19 * (sqrt (l_z))))
							l_a___5 := l_d + l_z
							l_d := l_d - ((l_bcmax / l_z) * l_bcmis)
							l_tau := hypot_inst.gsl_hypot (l_c___1, l_z)
							a_cs.item := l_z / l_tau
							a_sn.item := l_c___1 / l_tau
							l_b___0 := l_b___0 - l_c___1
							l_c___1 := 0.0
						else
							l_sigma := l_b___0 + l_c___1
							l_tau := hypot_inst.gsl_hypot (l_sigma, l_tmp)
							a_cs.item := sqrt (0.5 * (1.0 + (fabs (l_sigma)) / l_tau))
							if l_sigma >= 0.0 then
								l_tmp___23 := 1
							else
								l_tmp___23 := -1
							end
							a_sn.item := -(l_p / (l_tau * a_cs.item)) * l_tmp___23.to_double
							l_aa := l_a___5 * a_cs.item + l_b___0 * a_sn.item
							l_bb := -l_a___5 * a_sn.item + l_b___0 * a_cs.item
							l_cc := l_c___1 * a_cs.item + l_d * a_sn.item
							l_dd := -l_c___1 * a_sn.item + l_d * a_cs.item
							l_a___5 := l_aa * a_cs.item + l_cc * a_sn.item
							l_b___0 := l_bb * a_cs.item + l_dd * a_sn.item
							l_c___1 := -l_aa * a_sn.item + l_cc * a_cs.item
							l_d := -l_bb * a_sn.item + l_dd * a_cs.item
							l_tmp := 0.5 * (l_a___5 + l_d)
							l_d := l_tmp
							l_a___5 := l_d
							if l_c___1 /= 0.0 then
								if l_b___0 /= 0.0 then
									if l_b___0 >= 0.0 then
										l_tmp___30 := 1
									else
										l_tmp___30 := -1
									end
									if l_c___1 >= 0.0 then
										l_tmp___31 := 1
									else
										l_tmp___31 := -1
									end
									if l_tmp___30 = l_tmp___31 then
										l_sab := sqrt ((fabs (l_b___0)))
										l_sac := sqrt ((fabs (l_c___1)))
										if l_c___1 >= 0.0 then
											l_tmp___26 := 1
										else
											l_tmp___26 := -1
										end
										l_p := l_tmp___26.to_double * (fabs (l_sab * l_sac))
										l_tau := 1.0 / (sqrt ((fabs (l_b___0 + l_c___1))))
										l_a___5 := l_tmp + l_p
										l_d := l_tmp - l_p
										l_b___0 := l_b___0 - l_c___1
										l_c___1 := 0.0
										l_cs1 := l_sab * l_tau
										l_sn1 := l_sac * l_tau
										l_tmp := a_cs.item * l_cs1 - a_sn.item * l_sn1
										a_sn.item := a_cs.item * l_sn1 + a_sn.item * l_cs1
										a_cs.item := l_tmp
									end
								else
									l_b___0 := -l_c___1
									l_c___1 := 0.0
									l_tmp := a_cs.item
									a_cs.item := -a_sn.item
									a_sn.item := l_tmp
								end
							end
						end
				when 10 then -- if done | if done
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (0).to_natural_32, (0).to_natural_32, l_a___5)
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (0).to_natural_32, (1).to_natural_32, l_b___0)
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (1).to_natural_32, (0).to_natural_32, l_c___1)
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (1).to_natural_32, (1).to_natural_32, l_d)
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_eigen_francis (a_H: CE_POINTER [PD_GSL_MATRIX]; a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			if a_H.item.size1 /= a_H.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to compute eigenvalues"), ce_string ("francis.c"), 159, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_eval.item.size /= a_H.item.size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("eigenvalue vector must match matrix size"), ce_string ("francis.c"), 163, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_N := a_H.item.size1
				a_w.item.size := l_N
				a_w.item.max_iterations := {NATURAL_32} 30 * l_N
				a_w.item.H := a_H
				a_w.item.n_iter := (0).to_natural_32
				a_w.item.n_evals := (0).to_natural_32
				l_j := 0
				from
				until
					not (l_j < l_N.to_integer_32 - 3)
				loop
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_H, l_j.to_natural_32 + {NATURAL_32} 2, l_j.to_natural_32, 0.0)
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_H, l_j.to_natural_32 + {NATURAL_32} 3, l_j.to_natural_32, 0.0)
					l_j := l_j + 1
				end
				if l_N > {NATURAL_32} 2 then
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 3, 0.0)
				end
				francis_schur_decomp (a_H, a_eval, a_w)
				if a_w.item.n_evals /= l_N then
					Result := 11
					js.return
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_eigen_francis_T (a_compute_t: INTEGER_32; a_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE])
		do
			a_w.item.compute_t := a_compute_t
		end

	gsl_eigen_francis_Z (a_H: CE_POINTER [PD_GSL_MATRIX]; a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Z: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]): INTEGER_32
		local
			l_s: INTEGER_32
		do
			a_w.item.Z := a_Z
			l_s := gsl_eigen_francis (a_H, a_eval, a_w)
			a_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
			Result := l_s
		end

	gsl_eigen_francis_alloc: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			l_w := create {CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, (create {PD_GSL_EIGEN_FRANCIS_WORKSPACE}.make).structure_size.to_natural_32)))
			if l_w.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("francis.c"), 82, 8)
					Result := (create {CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_w.item.size := (0).to_natural_32
				l_w.item.max_iterations := (0).to_natural_32
				l_w.item.n_iter := (0).to_natural_32
				l_w.item.n_evals := (0).to_natural_32
				l_w.item.compute_t := 0
				l_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.H := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				Result := l_w
			end
		end

	gsl_eigen_francis_free (a_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if a_w.is_void then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

end
