class
	P_GEOMETRIC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_geometric_P (a_k: NATURAL_32; a_p: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_a___5: REAL_64
			l_q___3: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_p > 1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_p < 0.0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("p < 0 or p > 1"), ce_string ("geometric.c"), 39, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called and then (a_k < {NATURAL_32} 1) then
							Result := (0.0)
							js.return
						end
						if not js.return_called then
							l_q___3 := 1.0 - a_p
							l_a___5 := a_k.to_real_64
							if a_p < 0.5 then
								l_P___2 := -(expm1 (l_a___5 * (log1p (-a_p))))
							else
								l_P___2 := 1.0 - (pow (l_q___3, l_a___5))
							end
							Result := l_P___2
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_cdf_geometric_Q (a_k: NATURAL_32; a_p: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_a___5: REAL_64
			l_q___3: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_p > 1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_p < 0.0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("p < 0 or p > 1"), ce_string ("geometric.c"), 69, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called and then (a_k < {NATURAL_32} 1) then
							Result := (1.0)
							js.return
						end
						if not js.return_called then
							l_q___3 := 1.0 - a_p
							l_a___5 := a_k.to_real_64
							if a_p < 0.5 then
								l_Q___1 := exp (l_a___5 * (log1p (-a_p)))
							else
								l_Q___1 := pow (l_q___3, l_a___5)
							end
							Result := l_Q___1
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_ran_geometric (a_r___3: CE_POINTER [PD_GSL_RNG]; a_p: REAL_64): NATURAL_32
		local
			l_u: REAL_64
			l_k: NATURAL_32
			l_tmp___0: REAL_64
		do
			l_u := (gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3))
			if a_p = (1).to_double then
				l_k := {NATURAL_32} 1
			else
				l_tmp___0 := log (l_u)
				l_k := (l_tmp___0 / (log ((1).to_double - a_p)) + (1).to_double).truncated_to_integer_64.to_natural_32
			end
			Result := l_k
		end

	gsl_ran_geometric_pdf (a_k: NATURAL_32; a_p: REAL_64): REAL_64
		local
			l_P___2: REAL_64
		do
			if a_k = {NATURAL_32} 0 then
				Result := (0).to_double
			elseif a_k = {NATURAL_32} 1 then
				Result := a_p
			else
				l_P___2 := a_p * (pow ((1).to_double - a_p, a_k.to_real_64 - 1.0))
				Result := l_P___2
			end
		end

end
