class
	P_GOLDEN

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create goldensection_type.make (<<1>>)
			create gsl_min_fminimizer_goldensection.make
		end

feature {ANY} -- attributes

	goldensection_type: CE_ARRAY [PD_GSL_MIN_FMINIMIZER_TYPE]

	gsl_min_fminimizer_goldensection: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE] assign set_gsl_min_fminimizer_goldensection

	set_gsl_min_fminimizer_goldensection (a_gsl_min_fminimizer_goldensection: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE])
		do
			gsl_min_fminimizer_goldensection := a_gsl_min_fminimizer_goldensection
		end

feature {ANY} -- routines

	goldensection_init (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum: REAL_64; a_f_minimum: REAL_64; a_x_lower: REAL_64; a_f_lower: REAL_64; a_x_upper: REAL_64; a_f_upper: REAL_64): INTEGER_32
		local
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_x_minimum: REAL_64
			l_f_minimum: REAL_64
			l_x_lower: REAL_64
			l_f_lower: REAL_64
			l_x_upper: REAL_64
			l_f_upper: REAL_64
			l_state: CE_POINTER [PD_GOLDENSECTION_STATE_T]
		do
			create l_f.make
			create l_state.make

			l_f := a_f
			l_x_minimum := a_x_minimum
			l_f_minimum := a_f_minimum
			l_x_lower := a_x_lower
			l_f_lower := a_f_lower
			l_x_upper := a_x_upper
			l_f_upper := a_f_upper
			l_state := create {CE_POINTER [PD_GOLDENSECTION_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_POINTER [PD_GOLDENSECTION_STATE_T]}.make_shared (default_pointer)
			l_f := create {CE_POINTER [PD_GSL_FUNCTION_STRUCT]}.make_shared (default_pointer)
			l_x_minimum := (0).to_double
			l_f_minimum := (0).to_double
			l_x_lower := (0).to_double
			l_f_lower := (0).to_double
			l_x_upper := (0).to_double
			l_f_upper := (0).to_double
			Result := 0
		end

	goldensection_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent goldensection_init)
		end

	goldensection_iterate (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum: CE_POINTER [REAL_64]; a_f_minimum: CE_POINTER [REAL_64]; a_x_lower: CE_POINTER [REAL_64]; a_f_lower: CE_POINTER [REAL_64]; a_x_upper: CE_POINTER [REAL_64]; a_f_upper: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_GOLDENSECTION_STATE_T]
			l_x_center: REAL_64
			l_x_left: REAL_64
			l_x_right: REAL_64
			l_f_min: REAL_64
			l_golden: REAL_64
			l_w_lower: REAL_64
			l_w_upper: REAL_64
			l_x_new: REAL_64
			l_f_new: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_POINTER [PD_GOLDENSECTION_STATE_T]}.make_cast (a_vstate)
					l_x_center := a_x_minimum.item
					l_x_left := a_x_lower.item
					l_x_right := a_x_upper.item
					l_f_min := a_f_minimum.item
					l_golden := 0.3819660
					l_w_lower := l_x_center - l_x_left
					l_w_upper := l_x_right - l_x_center
					l_state := create {CE_POINTER [PD_GOLDENSECTION_STATE_T]}.make_shared (default_pointer)
					if l_w_upper > l_w_lower then
						l_tmp := l_w_upper
					else
						l_tmp := -l_w_lower
					end
					l_x_new := l_x_center + l_golden * l_tmp
					from
					until
						js.loop_done
					loop
						l_f_new := (a_f.item.function).real_64_item ([l_x_new, a_f.item.params])
						if not (infnan_inst.gsl_finite (l_f_new)).to_boolean then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("computed function value is infinite or NaN"), ce_string ("golden.c"), 87, 9)
								Result := 9
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
						if not js.return_called then
							js.break
						end
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if not (l_f_new < l_f_min) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						a_x_minimum.item := l_x_new
						a_f_minimum.item := l_f_new
						Result := 0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (l_x_new < l_x_center) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_f_new > l_f_min then
							a_x_lower.item := l_x_new
							a_f_lower.item := l_f_new
							Result := 0
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_x_new > l_x_center then
							if l_f_new > l_f_min then
								a_x_upper.item := l_x_new
								a_f_upper.item := l_f_new
								Result := 0
							else
								Result := (-1)
							end
						else
							Result := (-1)
						end
				when 8 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	goldensection_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent goldensection_iterate)
		end

end
