class
	P_GSL_GSL_POLY

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_complex_poly_complex_eval (a_c___1: CE_POINTER [PD_GSL_COMPLEX]; a_len: INTEGER_32; a_z: PD_GSL_COMPLEX): PD_GSL_COMPLEX
		local
			l_i: INTEGER_32
			l_ans: PD_GSL_COMPLEX
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_ans.make

			l_ans := (a_c___1[(a_len - 1)]).twin
			l_i := a_len - 1
			from
			until
				not (not js.loop_done and then (l_i > 0))
			loop
				l_tmp := ((a_c___1 + (l_i - 1)).item.dat[0] + a_z.dat[0] * l_ans.dat[0]) - a_z.dat[1] * l_ans.dat[1]
				from
				until
					js.loop_done
				loop
					l_ans.dat[1] := ((a_c___1 + (l_i - 1)).item.dat[1] + a_z.dat[1] * l_ans.dat[0]) + a_z.dat[0] * l_ans.dat[1]
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_ans.dat[0] := l_tmp
					js.break
				end
				l_i := l_i - 1
			end
			Result := l_ans.twin
		end

	gsl_poly_complex_eval (a_c___1: CE_POINTER [REAL_64]; a_len: INTEGER_32; a_z: PD_GSL_COMPLEX): PD_GSL_COMPLEX
		local
			l_i: INTEGER_32
			l_ans: PD_GSL_COMPLEX
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_ans.make

			from
			until
				js.loop_done
			loop
				l_ans.dat[0] := a_c___1[(a_len - 1)]
				l_ans.dat[1] := 0.0
				js.break
			end
			l_i := a_len - 1
			from
			until
				not (not js.loop_done and then (l_i > 0))
			loop
				l_tmp := ((a_c___1[(l_i - 1)] + (a_z.dat[0] * l_ans.dat[0])) - (a_z.dat[1] * l_ans.dat[1]))
				from
				until
					js.loop_done
				loop
					l_ans.dat[1] := a_z.dat[1] * l_ans.dat[0] + a_z.dat[0] * l_ans.dat[1]
					js.break
				end
				from
				until
					js.loop_done
				loop
					l_ans.dat[0] := l_tmp
					js.break
				end
				l_i := l_i - 1
			end
			Result := l_ans.twin
		end

	gsl_poly_dd_eval (a_dd: CE_POINTER [REAL_64]; a_xa: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_y: REAL_64
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			l_y := a_dd[(a_size - {NATURAL_32} 1).to_integer_32]
			l_i := a_size - {NATURAL_32} 1
			from
			until
				js.loop_done
			loop
				l_tmp := l_i
				l_i := l_i - 1
				if not l_tmp.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_y := (a_dd[l_i.to_integer_32] + ((a_x - a_xa[l_i.to_integer_32]) * l_y))
				end
			end
			Result := l_y
		end

	gsl_poly_eval (a_c___1: CE_POINTER [REAL_64]; a_len: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_i: INTEGER_32
			l_ans: REAL_64
		do
			l_ans := a_c___1[(a_len - 1)]
			l_i := a_len - 1
			from
			until
				not (l_i > 0)
			loop
				l_ans := (a_c___1[(l_i - 1)] + (a_x * l_ans))
				l_i := l_i - 1
			end
			Result := l_ans
		end

end
