class
	P_GUMBEL2INV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_gumbel2_Pinv (a_P___2: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			js: JUMP_STATE
		do
			if a_P___2 = 1.0 then
				Result := (builtin_inff).to_double
				js.return
			elseif a_P___2 = 0.0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				l_x := pow (a_b___0 / -(log (a_P___2)), (1).to_double / a_a___5)
				Result := l_x
			end
		end

	gsl_cdf_gumbel2_Qinv (a_Q___1: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			js: JUMP_STATE
		do
			if a_Q___1 = 0.0 then
				Result := (builtin_inff).to_double
				js.return
			elseif a_Q___1 = 1.0 then
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				l_x := pow (a_b___0 / -(log1p (-a_Q___1)), (1).to_double / a_a___5)
				Result := l_x
			end
		end

end
