class
	P_HAAR

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create cg_2.make (<<2>>)
			create ch_2.make (<<2>>)
			create gsl_wavelet_haar.make
			create gsl_wavelet_haar_centered.make
			create haar_centered_type.make (<<1>>)
			create haar_type.make (<<1>>)
		end

feature {ANY} -- attributes

	cg_2: CE_ARRAY [REAL_64]

	ch_2: CE_ARRAY [REAL_64]

	gsl_wavelet_haar: CE_POINTER [PD_GSL_WAVELET_TYPE] assign set_gsl_wavelet_haar

	set_gsl_wavelet_haar (a_gsl_wavelet_haar: CE_POINTER [PD_GSL_WAVELET_TYPE])
		do
			gsl_wavelet_haar := a_gsl_wavelet_haar
		end

	gsl_wavelet_haar_centered: CE_POINTER [PD_GSL_WAVELET_TYPE] assign set_gsl_wavelet_haar_centered

	set_gsl_wavelet_haar_centered (a_gsl_wavelet_haar_centered: CE_POINTER [PD_GSL_WAVELET_TYPE])
		do
			gsl_wavelet_haar_centered := a_gsl_wavelet_haar_centered
		end

	haar_centered_type: CE_ARRAY [PD_GSL_WAVELET_TYPE]

	haar_type: CE_ARRAY [PD_GSL_WAVELET_TYPE]

feature {ANY} -- routines

	haar_centered_init (a_h1: CE_POINTER [CE_POINTER [REAL_64]]; a_g1: CE_POINTER [CE_POINTER [REAL_64]]; a_h2: CE_POINTER [CE_POINTER [REAL_64]]; a_g2: CE_POINTER [CE_POINTER [REAL_64]]; a_nc: CE_POINTER [NATURAL_32]; a_offset: CE_POINTER [NATURAL_32]; a_member: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_member /= {NATURAL_32} 2 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				a_h1.item := ch_2
				a_g1.item := cg_2
				a_h2.item := ch_2
				a_g2.item := cg_2
				a_nc.item := (2).to_natural_32
				a_offset.item := (1).to_natural_32
				Result := 0
			end
		end

	haar_centered_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent haar_centered_init)
		end

	haar_init (a_h1: CE_POINTER [CE_POINTER [REAL_64]]; a_g1: CE_POINTER [CE_POINTER [REAL_64]]; a_h2: CE_POINTER [CE_POINTER [REAL_64]]; a_g2: CE_POINTER [CE_POINTER [REAL_64]]; a_nc: CE_POINTER [NATURAL_32]; a_offset: CE_POINTER [NATURAL_32]; a_member: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_member /= {NATURAL_32} 2 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				a_h1.item := ch_2
				a_g1.item := cg_2
				a_h2.item := ch_2
				a_g2.item := cg_2
				a_nc.item := (2).to_natural_32
				a_offset.item := (0).to_natural_32
				Result := 0
			end
		end

	haar_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent haar_init)
		end

end
