class
	P_HC_PASS_4

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	fft_halfcomplex_float_pass_4 (a_in: CE_POINTER [REAL_32]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_32]; a_ostride: NATURAL_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle1: CE_POINTER [PD_GSL_COMPLEX_FLOAT]; a_twiddle2: CE_POINTER [PD_GSL_COMPLEX_FLOAT]; a_twiddle3: CE_POINTER [PD_GSL_COMPLEX_FLOAT])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_jump: NATURAL_32
			l_factor: NATURAL_32
			l_q___3: NATURAL_32
			l_m___4: NATURAL_32
			l_product_1: NATURAL_32
			l_from0: NATURAL_32
			l_from1: NATURAL_32
			l_from2: NATURAL_32
			l_z0_real: REAL_32
			l_z1_real: REAL_32
			l_z1_imag: REAL_32
			l_z2_real: REAL_32
			l_t1_real: REAL_32
			l_t2_real: REAL_32
			l_t3_real: REAL_32
			l_t4_imag: REAL_32
			l_to0: NATURAL_32
			l_to1: NATURAL_32
			l_to2: NATURAL_32
			l_to3: NATURAL_32
			l_w1_real: REAL_32
			l_w1_imag: REAL_32
			l_w2_real: REAL_32
			l_w2_imag: REAL_32
			l_w3_real: REAL_32
			l_w3_imag: REAL_32
			l_from0___0: NATURAL_32
			l_from1___0: NATURAL_32
			l_from2___0: NATURAL_32
			l_from3: NATURAL_32
			l_z0_real___0: REAL_32
			l_z0_imag: REAL_32
			l_z1_real___0: REAL_32
			l_z1_imag___0: REAL_32
			l_z2_real___0: REAL_32
			l_z2_imag: REAL_32
			l_z3_real: REAL_32
			l_z3_imag: REAL_32
			l_t1_real___0: REAL_32
			l_t1_imag: REAL_32
			l_t2_real___0: REAL_32
			l_t2_imag: REAL_32
			l_t3_real___0: REAL_32
			l_t3_imag: REAL_32
			l_t4_real: REAL_32
			l_t4_imag___0: REAL_32
			l_x0_real: REAL_32
			l_x0_imag: REAL_32
			l_x1_real: REAL_32
			l_x1_imag: REAL_32
			l_x2_real: REAL_32
			l_x2_imag: REAL_32
			l_x3_real: REAL_32
			l_x3_imag: REAL_32
			l_to0___0: NATURAL_32
			l_to1___0: NATURAL_32
			l_to2___0: NATURAL_32
			l_to3___0: NATURAL_32
			l_from0___1: NATURAL_32
			l_from1___1: NATURAL_32
			l_z0_real___1: REAL_32
			l_z0_imag___0: REAL_32
			l_z1_real___1: REAL_32
			l_z1_imag___1: REAL_32
			l_t1_real___1: REAL_32
			l_t2_real___1: REAL_32
			l_x0_real___0: REAL_32
			l_x1_real___0: REAL_32
			l_x2_real___0: REAL_32
			l_x3_real___0: REAL_32
			l_to0___1: NATURAL_32
			l_to1___1: NATURAL_32
			l_to2___1: NATURAL_32
			l_to3___1: NATURAL_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			l_j := (0).to_natural_32
			l_factor := (4).to_natural_32
			l_m___4 := a_n // l_factor
			l_q___3 := a_n // a_product
			l_product_1 := a_product // l_factor
			l_jump := (l_factor - {NATURAL_32} 1) * l_q___3
			l_k1 := (0).to_natural_32
			from
			until
				not (l_k1 < l_product_1)
			loop
				l_from0 := ({NATURAL_32} 4 * l_k1) * l_q___3
				l_from1 := (l_from0 + {NATURAL_32} 2 * l_q___3) - {NATURAL_32} 1
				l_from2 := l_from1 + {NATURAL_32} 2 * l_q___3
				l_z0_real := a_in[(a_istride * l_from0).to_integer_32]
				l_z1_real := a_in[(a_istride * l_from1).to_integer_32]
				l_z1_imag := a_in[(a_istride * (l_from1 + {NATURAL_32} 1)).to_integer_32]
				l_z2_real := a_in[(a_istride * l_from2).to_integer_32]
				l_t1_real := l_z0_real + l_z2_real
				l_t2_real := (2).to_real * l_z1_real
				l_t3_real := l_z0_real - l_z2_real
				l_t4_imag := (2).to_real * l_z1_imag
				l_to0 := l_q___3 * l_k1
				l_to1 := l_to0 + l_m___4
				l_to2 := l_to1 + l_m___4
				l_to3 := l_to2 + l_m___4
				a_out[(a_ostride * l_to0).to_integer_32] := l_t1_real + l_t2_real
				a_out[(a_ostride * l_to1).to_integer_32] := l_t3_real - l_t4_imag
				a_out[(a_ostride * l_to2).to_integer_32] := l_t1_real - l_t2_real
				a_out[(a_ostride * l_to3).to_integer_32] := l_t3_real + l_t4_imag
				l_k1 := l_k1 + 1
			end
			if l_q___3 = {NATURAL_32} 1 then
				js.return
			end
			if not js.return_called then
				l_k := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < (l_q___3 + {NATURAL_32} 1) // {NATURAL_32} 2))
				loop
					l_w1_real := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w1_imag := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w2_real := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w2_imag := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w3_real := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w3_imag := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_k1 := (0).to_natural_32
					from
					until
						not (l_k1 < l_product_1)
					loop
						l_from0___0 := (({NATURAL_32} 4 * l_k1) * l_q___3 + {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						l_from1___0 := l_from0___0 + {NATURAL_32} 2 * l_q___3
						l_from2___0 := ((({NATURAL_32} 4 * l_k1) * l_q___3 - {NATURAL_32} 2 * l_k) + {NATURAL_32} 2 * l_q___3) - {NATURAL_32} 1
						l_from3 := l_from2___0 + {NATURAL_32} 2 * l_q___3
						l_z0_real___0 := a_in[(a_istride * l_from0___0).to_integer_32]
						l_z0_imag := a_in[(a_istride * (l_from0___0 + {NATURAL_32} 1)).to_integer_32]
						l_z1_real___0 := a_in[(a_istride * l_from1___0).to_integer_32]
						l_z1_imag___0 := a_in[(a_istride * (l_from1___0 + {NATURAL_32} 1)).to_integer_32]
						l_z2_real___0 := a_in[(a_istride * l_from3).to_integer_32]
						l_z2_imag := (-a_in[(a_istride * (l_from3 + {NATURAL_32} 1)).to_integer_32])
						l_z3_real := a_in[(a_istride * l_from2___0).to_integer_32]
						l_z3_imag := (-a_in[(a_istride * (l_from2___0 + {NATURAL_32} 1)).to_integer_32])
						l_t1_real___0 := l_z0_real___0 + l_z2_real___0
						l_t1_imag := l_z0_imag + l_z2_imag
						l_t2_real___0 := l_z1_real___0 + l_z3_real
						l_t2_imag := l_z1_imag___0 + l_z3_imag
						l_t3_real___0 := l_z0_real___0 - l_z2_real___0
						l_t3_imag := l_z0_imag - l_z2_imag
						l_t4_real := l_z1_real___0 - l_z3_real
						l_t4_imag___0 := l_z1_imag___0 - l_z3_imag
						l_x0_real := l_t1_real___0 + l_t2_real___0
						l_x0_imag := l_t1_imag + l_t2_imag
						l_x1_real := l_t3_real___0 - l_t4_imag___0
						l_x1_imag := l_t3_imag + l_t4_real
						l_x2_real := l_t1_real___0 - l_t2_real___0
						l_x2_imag := l_t1_imag - l_t2_imag
						l_x3_real := l_t3_real___0 + l_t4_imag___0
						l_x3_imag := l_t3_imag - l_t4_real
						l_to0___0 := (l_k1 * l_q___3 + {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						l_to1___0 := l_to0___0 + l_m___4
						l_to2___0 := l_to1___0 + l_m___4
						l_to3___0 := l_to2___0 + l_m___4
						a_out[(a_ostride * l_to0___0).to_integer_32] := l_x0_real
						a_out[(a_ostride * (l_to0___0 + {NATURAL_32} 1)).to_integer_32] := l_x0_imag
						a_out[(a_ostride * l_to1___0).to_integer_32] := l_w1_real * l_x1_real - l_w1_imag * l_x1_imag
						a_out[(a_ostride * (l_to1___0 + {NATURAL_32} 1)).to_integer_32] := l_w1_imag * l_x1_real + l_w1_real * l_x1_imag
						a_out[(a_ostride * l_to2___0).to_integer_32] := l_w2_real * l_x2_real - l_w2_imag * l_x2_imag
						a_out[(a_ostride * (l_to2___0 + {NATURAL_32} 1)).to_integer_32] := l_w2_imag * l_x2_real + l_w2_real * l_x2_imag
						a_out[(a_ostride * l_to3___0).to_integer_32] := l_w3_real * l_x3_real - l_w3_imag * l_x3_imag
						a_out[(a_ostride * (l_to3___0 + {NATURAL_32} 1)).to_integer_32] := l_w3_real * l_x3_imag + l_w3_imag * l_x3_real
						l_k1 := l_k1 + 1
					end
					l_k := l_k + 1
				end
				if l_q___3 \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
					js.return
				end
			end
			if not js.return_called then
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_product_1)
				loop
					l_from0___1 := (({NATURAL_32} 4 * l_k1) * l_q___3 + l_q___3) - {NATURAL_32} 1
					l_from1___1 := l_from0___1 + {NATURAL_32} 2 * l_q___3
					l_z0_real___1 := a_in[(a_istride * l_from0___1).to_integer_32]
					l_z0_imag___0 := a_in[(a_istride * (l_from0___1 + {NATURAL_32} 1)).to_integer_32]
					l_z1_real___1 := a_in[(a_istride * l_from1___1).to_integer_32]
					l_z1_imag___1 := a_in[(a_istride * (l_from1___1 + {NATURAL_32} 1)).to_integer_32]
					l_t1_real___1 := ((sqrt (2.0)) * (l_z0_imag___0 + l_z1_imag___1).to_double).truncated_to_real
					l_t2_real___1 := ((sqrt (2.0)) * (l_z0_real___1 - l_z1_real___1).to_double).truncated_to_real
					l_x0_real___0 := (2).to_real * (l_z0_real___1 + l_z1_real___1)
					l_x1_real___0 := l_t2_real___1 - l_t1_real___1
					l_x2_real___0 := (2).to_real * (l_z1_imag___1 - l_z0_imag___0)
					l_x3_real___0 := -(l_t2_real___1 + l_t1_real___1)
					l_to0___1 := (l_k1 * l_q___3 + l_q___3) - {NATURAL_32} 1
					l_to1___1 := l_to0___1 + l_m___4
					l_to2___1 := l_to1___1 + l_m___4
					l_to3___1 := l_to2___1 + l_m___4
					a_out[(a_ostride * l_to0___1).to_integer_32] := l_x0_real___0
					a_out[(a_ostride * l_to1___1).to_integer_32] := l_x1_real___0
					a_out[(a_ostride * l_to2___1).to_integer_32] := l_x2_real___0
					a_out[(a_ostride * l_to3___1).to_integer_32] := l_x3_real___0
					l_k1 := l_k1 + 1
				end
			end
		end

	fft_halfcomplex_pass_4 (a_in: CE_POINTER [REAL_64]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_64]; a_ostride: NATURAL_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle1: CE_POINTER [PD_GSL_COMPLEX]; a_twiddle2: CE_POINTER [PD_GSL_COMPLEX]; a_twiddle3: CE_POINTER [PD_GSL_COMPLEX])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_jump: NATURAL_32
			l_factor: NATURAL_32
			l_q___3: NATURAL_32
			l_m___4: NATURAL_32
			l_product_1: NATURAL_32
			l_from0: NATURAL_32
			l_from1: NATURAL_32
			l_from2: NATURAL_32
			l_z0_real: REAL_64
			l_z1_real: REAL_64
			l_z1_imag: REAL_64
			l_z2_real: REAL_64
			l_t1_real: REAL_64
			l_t2_real: REAL_64
			l_t3_real: REAL_64
			l_t4_imag: REAL_64
			l_to0: NATURAL_32
			l_to1: NATURAL_32
			l_to2: NATURAL_32
			l_to3: NATURAL_32
			l_w1_real: REAL_64
			l_w1_imag: REAL_64
			l_w2_real: REAL_64
			l_w2_imag: REAL_64
			l_w3_real: REAL_64
			l_w3_imag: REAL_64
			l_from0___0: NATURAL_32
			l_from1___0: NATURAL_32
			l_from2___0: NATURAL_32
			l_from3: NATURAL_32
			l_z0_real___0: REAL_64
			l_z0_imag: REAL_64
			l_z1_real___0: REAL_64
			l_z1_imag___0: REAL_64
			l_z2_real___0: REAL_64
			l_z2_imag: REAL_64
			l_z3_real: REAL_64
			l_z3_imag: REAL_64
			l_t1_real___0: REAL_64
			l_t1_imag: REAL_64
			l_t2_real___0: REAL_64
			l_t2_imag: REAL_64
			l_t3_real___0: REAL_64
			l_t3_imag: REAL_64
			l_t4_real: REAL_64
			l_t4_imag___0: REAL_64
			l_x0_real: REAL_64
			l_x0_imag: REAL_64
			l_x1_real: REAL_64
			l_x1_imag: REAL_64
			l_x2_real: REAL_64
			l_x2_imag: REAL_64
			l_x3_real: REAL_64
			l_x3_imag: REAL_64
			l_to0___0: NATURAL_32
			l_to1___0: NATURAL_32
			l_to2___0: NATURAL_32
			l_to3___0: NATURAL_32
			l_from0___1: NATURAL_32
			l_from1___1: NATURAL_32
			l_z0_real___1: REAL_64
			l_z0_imag___0: REAL_64
			l_z1_real___1: REAL_64
			l_z1_imag___1: REAL_64
			l_t1_real___1: REAL_64
			l_t2_real___1: REAL_64
			l_x0_real___0: REAL_64
			l_x1_real___0: REAL_64
			l_x2_real___0: REAL_64
			l_x3_real___0: REAL_64
			l_to0___1: NATURAL_32
			l_to1___1: NATURAL_32
			l_to2___1: NATURAL_32
			l_to3___1: NATURAL_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			l_j := (0).to_natural_32
			l_factor := (4).to_natural_32
			l_m___4 := a_n // l_factor
			l_q___3 := a_n // a_product
			l_product_1 := a_product // l_factor
			l_jump := (l_factor - {NATURAL_32} 1) * l_q___3
			l_k1 := (0).to_natural_32
			from
			until
				not (l_k1 < l_product_1)
			loop
				l_from0 := ({NATURAL_32} 4 * l_k1) * l_q___3
				l_from1 := (l_from0 + {NATURAL_32} 2 * l_q___3) - {NATURAL_32} 1
				l_from2 := l_from1 + {NATURAL_32} 2 * l_q___3
				l_z0_real := a_in[(a_istride * l_from0).to_integer_32]
				l_z1_real := a_in[(a_istride * l_from1).to_integer_32]
				l_z1_imag := a_in[(a_istride * (l_from1 + {NATURAL_32} 1)).to_integer_32]
				l_z2_real := a_in[(a_istride * l_from2).to_integer_32]
				l_t1_real := l_z0_real + l_z2_real
				l_t2_real := (2).to_double * l_z1_real
				l_t3_real := l_z0_real - l_z2_real
				l_t4_imag := (2).to_double * l_z1_imag
				l_to0 := l_q___3 * l_k1
				l_to1 := l_to0 + l_m___4
				l_to2 := l_to1 + l_m___4
				l_to3 := l_to2 + l_m___4
				a_out[(a_ostride * l_to0).to_integer_32] := l_t1_real + l_t2_real
				a_out[(a_ostride * l_to1).to_integer_32] := l_t3_real - l_t4_imag
				a_out[(a_ostride * l_to2).to_integer_32] := l_t1_real - l_t2_real
				a_out[(a_ostride * l_to3).to_integer_32] := l_t3_real + l_t4_imag
				l_k1 := l_k1 + 1
			end
			if l_q___3 = {NATURAL_32} 1 then
				js.return
			end
			if not js.return_called then
				l_k := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < (l_q___3 + {NATURAL_32} 1) // {NATURAL_32} 2))
				loop
					l_w1_real := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w1_imag := (a_twiddle1 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w2_real := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w2_imag := (a_twiddle2 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_w3_real := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[0]
					l_w3_imag := (a_twiddle3 + (l_k - {NATURAL_32} 1).to_integer_32).item.dat[1]
					l_k1 := (0).to_natural_32
					from
					until
						not (l_k1 < l_product_1)
					loop
						l_from0___0 := (({NATURAL_32} 4 * l_k1) * l_q___3 + {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						l_from1___0 := l_from0___0 + {NATURAL_32} 2 * l_q___3
						l_from2___0 := ((({NATURAL_32} 4 * l_k1) * l_q___3 - {NATURAL_32} 2 * l_k) + {NATURAL_32} 2 * l_q___3) - {NATURAL_32} 1
						l_from3 := l_from2___0 + {NATURAL_32} 2 * l_q___3
						l_z0_real___0 := a_in[(a_istride * l_from0___0).to_integer_32]
						l_z0_imag := a_in[(a_istride * (l_from0___0 + {NATURAL_32} 1)).to_integer_32]
						l_z1_real___0 := a_in[(a_istride * l_from1___0).to_integer_32]
						l_z1_imag___0 := a_in[(a_istride * (l_from1___0 + {NATURAL_32} 1)).to_integer_32]
						l_z2_real___0 := a_in[(a_istride * l_from3).to_integer_32]
						l_z2_imag := (-a_in[(a_istride * (l_from3 + {NATURAL_32} 1)).to_integer_32])
						l_z3_real := a_in[(a_istride * l_from2___0).to_integer_32]
						l_z3_imag := (-a_in[(a_istride * (l_from2___0 + {NATURAL_32} 1)).to_integer_32])
						l_t1_real___0 := l_z0_real___0 + l_z2_real___0
						l_t1_imag := l_z0_imag + l_z2_imag
						l_t2_real___0 := l_z1_real___0 + l_z3_real
						l_t2_imag := l_z1_imag___0 + l_z3_imag
						l_t3_real___0 := l_z0_real___0 - l_z2_real___0
						l_t3_imag := l_z0_imag - l_z2_imag
						l_t4_real := l_z1_real___0 - l_z3_real
						l_t4_imag___0 := l_z1_imag___0 - l_z3_imag
						l_x0_real := l_t1_real___0 + l_t2_real___0
						l_x0_imag := l_t1_imag + l_t2_imag
						l_x1_real := l_t3_real___0 - l_t4_imag___0
						l_x1_imag := l_t3_imag + l_t4_real
						l_x2_real := l_t1_real___0 - l_t2_real___0
						l_x2_imag := l_t1_imag - l_t2_imag
						l_x3_real := l_t3_real___0 + l_t4_imag___0
						l_x3_imag := l_t3_imag - l_t4_real
						l_to0___0 := (l_k1 * l_q___3 + {NATURAL_32} 2 * l_k) - {NATURAL_32} 1
						l_to1___0 := l_to0___0 + l_m___4
						l_to2___0 := l_to1___0 + l_m___4
						l_to3___0 := l_to2___0 + l_m___4
						a_out[(a_ostride * l_to0___0).to_integer_32] := l_x0_real
						a_out[(a_ostride * (l_to0___0 + {NATURAL_32} 1)).to_integer_32] := l_x0_imag
						a_out[(a_ostride * l_to1___0).to_integer_32] := l_w1_real * l_x1_real - l_w1_imag * l_x1_imag
						a_out[(a_ostride * (l_to1___0 + {NATURAL_32} 1)).to_integer_32] := l_w1_imag * l_x1_real + l_w1_real * l_x1_imag
						a_out[(a_ostride * l_to2___0).to_integer_32] := l_w2_real * l_x2_real - l_w2_imag * l_x2_imag
						a_out[(a_ostride * (l_to2___0 + {NATURAL_32} 1)).to_integer_32] := l_w2_imag * l_x2_real + l_w2_real * l_x2_imag
						a_out[(a_ostride * l_to3___0).to_integer_32] := l_w3_real * l_x3_real - l_w3_imag * l_x3_imag
						a_out[(a_ostride * (l_to3___0 + {NATURAL_32} 1)).to_integer_32] := l_w3_real * l_x3_imag + l_w3_imag * l_x3_real
						l_k1 := l_k1 + 1
					end
					l_k := l_k + 1
				end
				if l_q___3 \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
					js.return
				end
			end
			if not js.return_called then
				l_k1 := (0).to_natural_32
				from
				until
					not (l_k1 < l_product_1)
				loop
					l_from0___1 := (({NATURAL_32} 4 * l_k1) * l_q___3 + l_q___3) - {NATURAL_32} 1
					l_from1___1 := l_from0___1 + {NATURAL_32} 2 * l_q___3
					l_z0_real___1 := a_in[(a_istride * l_from0___1).to_integer_32]
					l_z0_imag___0 := a_in[(a_istride * (l_from0___1 + {NATURAL_32} 1)).to_integer_32]
					l_z1_real___1 := a_in[(a_istride * l_from1___1).to_integer_32]
					l_z1_imag___1 := a_in[(a_istride * (l_from1___1 + {NATURAL_32} 1)).to_integer_32]
					l_t1_real___1 := (sqrt (2.0)) * (l_z0_imag___0 + l_z1_imag___1)
					l_t2_real___1 := (sqrt (2.0)) * (l_z0_real___1 - l_z1_real___1)
					l_x0_real___0 := (2).to_double * (l_z0_real___1 + l_z1_real___1)
					l_x1_real___0 := l_t2_real___1 - l_t1_real___1
					l_x2_real___0 := (2).to_double * (l_z1_imag___1 - l_z0_imag___0)
					l_x3_real___0 := -(l_t2_real___1 + l_t1_real___1)
					l_to0___1 := (l_k1 * l_q___3 + l_q___3) - {NATURAL_32} 1
					l_to1___1 := l_to0___1 + l_m___4
					l_to2___1 := l_to1___1 + l_m___4
					l_to3___1 := l_to2___1 + l_m___4
					a_out[(a_ostride * l_to0___1).to_integer_32] := l_x0_real___0
					a_out[(a_ostride * l_to1___1).to_integer_32] := l_x1_real___0
					a_out[(a_ostride * l_to2___1).to_integer_32] := l_x2_real___0
					a_out[(a_ostride * l_to3___1).to_integer_32] := l_x3_real___0
					l_k1 := l_k1 + 1
				end
			end
		end

end
