class
	P_HOUSEHOLDERCOMPLEX

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_complex_householder_hm (a_tau: PD_GSL_COMPLEX; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tauwj: PD_GSL_COMPLEX
			l_wj: PD_GSL_COMPLEX
			l_Aij: PD_GSL_COMPLEX
			l_vi: PD_GSL_COMPLEX
			l_Av: PD_GSL_COMPLEX
			l_A0j: PD_GSL_COMPLEX
			l_Atw: PD_GSL_COMPLEX
			l_vi___0: PD_GSL_COMPLEX
			l_tauvw: PD_GSL_COMPLEX
			l_Aij___0: PD_GSL_COMPLEX
			l_Atwv: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_tauwj.make
			create l_wj.make
			create l_Aij.make
			create l_vi.make
			create l_Av.make
			create l_A0j.make
			create l_Atw.make
			create l_vi___0.make
			create l_tauvw.make
			create l_Aij___0.make
			create l_Atwv.make

			if a_tau.dat[0] = 0.0 then
				if a_tau.dat[1] = 0.0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < a_A___0.item.size2))
				loop
					l_wj := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, (0).to_natural_32, l_j)).twin
					l_i := (1).to_natural_32
					from
					until
						not (l_i < a_A___0.item.size1)
					loop
						l_Aij := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)).twin
						l_vi := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, l_i)).twin
						l_Av := (math_inst.gsl_complex_mul (l_Aij.twin, (math_inst.gsl_complex_conjugate (l_vi.twin)).twin)).twin
						l_wj := (math_inst.gsl_complex_add (l_wj.twin, l_Av.twin)).twin
						l_i := l_i + 1
					end
					l_tauwj := (math_inst.gsl_complex_mul (a_tau.twin, l_wj.twin)).twin
					l_A0j := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, (0).to_natural_32, l_j)).twin
					l_Atw := (math_inst.gsl_complex_sub (l_A0j.twin, l_tauwj.twin)).twin
					gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, (0).to_natural_32, l_j, l_Atw.twin)
					l_i := (1).to_natural_32
					from
					until
						not (l_i < a_A___0.item.size1)
					loop
						l_vi___0 := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, l_i)).twin
						l_tauvw := (math_inst.gsl_complex_mul (l_vi___0.twin, l_tauwj.twin)).twin
						l_Aij___0 := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)).twin
						l_Atwv := (math_inst.gsl_complex_sub (l_Aij___0.twin, l_tauvw.twin)).twin
						gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_i, l_j, l_Atwv.twin)
						l_i := l_i + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_linalg_complex_householder_hv (a_tau: PD_GSL_COMPLEX; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_w: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_z0: PD_GSL_COMPLEX
			l_z1: CE_ARRAY [PD_GSL_COMPLEX]
			l_z: PD_GSL_COMPLEX
			l_tz: PD_GSL_COMPLEX
			l_ntz: PD_GSL_COMPLEX
			l_v1: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_CONST_VIEW]
			l_w1: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_w0: PD_GSL_COMPLEX
			l_w0ntz: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_z0.make
			create l_z1.make (<<1>>)
			create l_z.make
			create l_tz.make
			create l_ntz.make
			create l_v1.make (<<1>>)
			create l_w1.make (<<1>>)
			create l_w0.make
			create l_w0ntz.make

			l_N := a_v.item.size
			if a_tau.dat[0] = 0.0 then
				if a_tau.dat[1] = 0.0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_z0 := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_w, (0).to_natural_32)).twin
				l_v1.item := (subvector_source_inst.gsl_vector_complex_const_subvector (a_v, (1).to_natural_32, l_N - {NATURAL_32} 1)).twin
				l_w1.item := (subvector_source_inst.gsl_vector_complex_subvector (a_w, (1).to_natural_32, l_N - {NATURAL_32} 1)).twin
				blas_inst.gsl_blas_zdotc ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))), (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_w1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), l_z1).do_nothing
				l_z := (math_inst.gsl_complex_add (l_z0.twin, (l_z1.item).twin)).twin
				l_tz := (math_inst.gsl_complex_mul (a_tau.twin, l_z.twin)).twin
				l_ntz := (math_inst.gsl_complex_negative (l_tz.twin)).twin
				l_w0 := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_w, (0).to_natural_32)).twin
				l_w0ntz := (math_inst.gsl_complex_add (l_w0.twin, l_ntz.twin)).twin
				gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_w, (0).to_natural_32, l_w0ntz.twin)
				blas_inst.gsl_blas_zaxpy (l_ntz.twin, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_w1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).do_nothing
				Result := 0
			end
		end

	gsl_linalg_complex_householder_mh (a_tau: PD_GSL_COMPLEX; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tauwi: PD_GSL_COMPLEX
			l_Ai0: PD_GSL_COMPLEX
			l_wi: PD_GSL_COMPLEX
			l_Aij: PD_GSL_COMPLEX
			l_vj: PD_GSL_COMPLEX
			l_Av: PD_GSL_COMPLEX
			l_Atw: PD_GSL_COMPLEX
			l_vj___0: PD_GSL_COMPLEX
			l_tauwv: PD_GSL_COMPLEX
			l_Aij___0: PD_GSL_COMPLEX
			l_Atwv: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_tauwi.make
			create l_Ai0.make
			create l_wi.make
			create l_Aij.make
			create l_vj.make
			create l_Av.make
			create l_Atw.make
			create l_vj___0.make
			create l_tauwv.make
			create l_Aij___0.make
			create l_Atwv.make

			if a_tau.dat[0] = 0.0 then
				if a_tau.dat[1] = 0.0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < a_A___0.item.size1))
				loop
					l_Ai0 := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, (0).to_natural_32)).twin
					l_wi := l_Ai0.twin
					l_j := (1).to_natural_32
					from
					until
						not (l_j < a_A___0.item.size2)
					loop
						l_Aij := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)).twin
						l_vj := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, l_j)).twin
						l_Av := (math_inst.gsl_complex_mul (l_Aij.twin, l_vj.twin)).twin
						l_wi := (math_inst.gsl_complex_add (l_wi.twin, l_Av.twin)).twin
						l_j := l_j + 1
					end
					l_tauwi := (math_inst.gsl_complex_mul (a_tau.twin, l_wi.twin)).twin
					l_Atw := (math_inst.gsl_complex_sub (l_Ai0.twin, l_tauwi.twin)).twin
					gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_i, (0).to_natural_32, l_Atw.twin)
					l_j := (1).to_natural_32
					from
					until
						not (l_j < a_A___0.item.size2)
					loop
						l_vj___0 := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, l_j)).twin
						l_tauwv := (math_inst.gsl_complex_mul ((math_inst.gsl_complex_conjugate (l_vj___0.twin)).twin, l_tauwi.twin)).twin
						l_Aij___0 := (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)).twin
						l_Atwv := (math_inst.gsl_complex_sub (l_Aij___0.twin, l_tauwv.twin)).twin
						gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_i, l_j, l_Atwv.twin)
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_linalg_complex_householder_transform (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): PD_GSL_COMPLEX
		local
			l_n: NATURAL_32
			l_alpha: PD_GSL_COMPLEX
			l_absa: REAL_64
			l_beta_r: REAL_64
			l_tmp___1: INTEGER_32
			l_tau: PD_GSL_COMPLEX
			l_beta: PD_GSL_COMPLEX
			l_tau___0: PD_GSL_COMPLEX
			l_beta_r___0: REAL_64
			l_x: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_alpha___0: PD_GSL_COMPLEX
			l_absa___0: REAL_64
			l_xnorm: REAL_64
			l_zero: PD_GSL_COMPLEX
			l_tmp___8: INTEGER_32
			l_amb: PD_GSL_COMPLEX
			l_s: PD_GSL_COMPLEX
			l_beta___0: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_alpha.make
			create l_tau.make
			create l_beta.make
			create l_tau___0.make
			create l_x.make (<<1>>)
			create l_alpha___0.make
			create l_zero.make
			create l_amb.make
			create l_s.make
			create l_beta___0.make

			l_n := a_v.item.size
			if l_n = {NATURAL_32} 1 then
				l_alpha := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, (0).to_natural_32)).twin
				l_absa := (math_inst.gsl_complex_abs (l_alpha.twin))
				if l_alpha.dat[0] >= (0).to_double then
					l_tmp___1 := 1
				else
					l_tmp___1 := -1
				end
				l_beta_r := (-l_tmp___1).to_double * l_absa
				if l_beta_r = 0.0 then
					l_tau.dat[0] := 0.0
					l_tau.dat[1] := 0.0
				else
					l_tau.dat[0] := (l_beta_r - l_alpha.dat[0]) / l_beta_r
					l_tau.dat[1] := -l_alpha.dat[1] / l_beta_r
					l_beta := (gsl_gsl_complex_math_inst.gsl_complex_rect (l_beta_r, 0.0)).twin
					gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_v, (0).to_natural_32, l_beta.twin)
				end
				Result := l_tau.twin
			else
				l_x.item := (subvector_source_inst.gsl_vector_complex_subvector (a_v, (1).to_natural_32, l_n - {NATURAL_32} 1)).twin
				l_alpha___0 := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, (0).to_natural_32)).twin
				l_absa___0 := (math_inst.gsl_complex_abs (l_alpha___0.twin))
				l_xnorm := (blas_inst.gsl_blas_dznrm2 ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")))))
				if l_xnorm = (0).to_double then
					if l_alpha___0.dat[1] = (0).to_double then
						l_zero := (gsl_gsl_complex_math_inst.gsl_complex_rect (0.0, 0.0)).twin
						Result := l_zero.twin
						js.return
					end
				end
				if not js.return_called then
					if l_alpha___0.dat[0] >= (0).to_double then
						l_tmp___8 := 1
					else
						l_tmp___8 := -1
					end
					l_beta_r___0 := (-l_tmp___8).to_double * (hypot (l_absa___0, l_xnorm))
					l_tau___0.dat[0] := (l_beta_r___0 - l_alpha___0.dat[0]) / l_beta_r___0
					l_tau___0.dat[1] := -l_alpha___0.dat[1] / l_beta_r___0
					l_amb := (math_inst.gsl_complex_sub_real (l_alpha___0.twin, l_beta_r___0)).twin
					l_s := (math_inst.gsl_complex_inverse (l_amb.twin)).twin
					blas_inst.gsl_blas_zscal (l_s.twin, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector")))
					l_beta___0 := (gsl_gsl_complex_math_inst.gsl_complex_rect (l_beta_r___0, 0.0)).twin
					gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_v, (0).to_natural_32, l_beta___0.twin)
					Result := l_tau___0.twin
				end
			end
		end

end
