class
	P_HYBRIDJ

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_multiroot_fdfsolver_hybridj.make
			create gsl_multiroot_fdfsolver_hybridsj.make
			create hybridj_type.make (<<1>>)
			create hybridsj_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_multiroot_fdfsolver_hybridj: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE] assign set_gsl_multiroot_fdfsolver_hybridj

	set_gsl_multiroot_fdfsolver_hybridj (a_gsl_multiroot_fdfsolver_hybridj: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE])
		do
			gsl_multiroot_fdfsolver_hybridj := a_gsl_multiroot_fdfsolver_hybridj
		end

	gsl_multiroot_fdfsolver_hybridsj: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE] assign set_gsl_multiroot_fdfsolver_hybridsj

	set_gsl_multiroot_fdfsolver_hybridsj (a_gsl_multiroot_fdfsolver_hybridsj: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE])
		do
			gsl_multiroot_fdfsolver_hybridsj := a_gsl_multiroot_fdfsolver_hybridsj
		end

	hybridj_type: CE_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]

	hybridsj_type: CE_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]

feature {ANY} -- routines

	hybridj_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_HYBRIDJ_STATE_T]
			l_q___3: CE_POINTER [PD_GSL_MATRIX]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_qtf: CE_POINTER [PD_GSL_VECTOR]
			l_newton: CE_POINTER [PD_GSL_VECTOR]
			l_gradient: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_f_trial: CE_POINTER [PD_GSL_VECTOR]
			l_df: CE_POINTER [PD_GSL_VECTOR]
			l_qtdf: CE_POINTER [PD_GSL_VECTOR]
			l_rdx: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_v: CE_POINTER [PD_GSL_VECTOR]
			js: JUMP_STATE
		do
			create l_state.make
			create l_q___3.make
			create l_r___3.make
			create l_tau.make
			create l_diag.make
			create l_qtf.make
			create l_newton.make
			create l_gradient.make
			create l_x_trial.make
			create l_f_trial.make
			create l_df.make
			create l_qtdf.make
			create l_rdx.make
			create l_w.make
			create l_v.make

			l_state := create {CE_POINTER [PD_HYBRIDJ_STATE_T]}.make_cast (a_vstate)
			l_q___3 := init_source_inst.gsl_matrix_calloc (a_n, a_n)
			if l_q___3.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for q"), ce_string ("hybridj.c"), 81, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.q := l_q___3
				l_r___3 := init_source_inst.gsl_matrix_calloc (a_n, a_n)
				if l_r___3.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for r"), ce_string ("hybridj.c"), 92, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.r := l_r___3
				l_tau := init_source_inst.gsl_vector_calloc (a_n)
				if l_tau.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for tau"), ce_string ("hybridj.c"), 104, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.tau := l_tau
				l_diag := init_source_inst.gsl_vector_calloc (a_n)
				if l_diag.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for diag"), ce_string ("hybridj.c"), 117, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.diag := l_diag
				l_qtf := init_source_inst.gsl_vector_calloc (a_n)
				if l_qtf.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for qtf"), ce_string ("hybridj.c"), 131, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.qtf := l_qtf
				l_newton := init_source_inst.gsl_vector_calloc (a_n)
				if l_newton.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for newton"), ce_string ("hybridj.c"), 146, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.newton := l_newton
				l_gradient := init_source_inst.gsl_vector_calloc (a_n)
				if l_gradient.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for gradient"), ce_string ("hybridj.c"), 162, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.gradient := l_gradient
				l_x_trial := init_source_inst.gsl_vector_calloc (a_n)
				if l_x_trial.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for x_trial"), ce_string ("hybridj.c"), 179, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.x_trial := l_x_trial
				l_f_trial := init_source_inst.gsl_vector_calloc (a_n)
				if l_f_trial.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for f_trial"), ce_string ("hybridj.c"), 197, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.f_trial := l_f_trial
				l_df := init_source_inst.gsl_vector_calloc (a_n)
				if l_df.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for df"), ce_string ("hybridj.c"), 216, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.df := l_df
				l_qtdf := init_source_inst.gsl_vector_calloc (a_n)
				if l_qtdf.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for qtdf"), ce_string ("hybridj.c"), 236, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.qtdf := l_qtdf
				l_rdx := init_source_inst.gsl_vector_calloc (a_n)
				if l_rdx.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_qtdf)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for rdx"), ce_string ("hybridj.c"), 258, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.rdx := l_rdx
				l_w := init_source_inst.gsl_vector_calloc (a_n)
				if l_w.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_qtdf)
					init_source_inst.gsl_vector_free (l_rdx)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for w"), ce_string ("hybridj.c"), 280, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.w := l_w
				l_v := init_source_inst.gsl_vector_calloc (a_n)
				if l_v.is_void then
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_qtdf)
					init_source_inst.gsl_vector_free (l_rdx)
					init_source_inst.gsl_vector_free (l_w)
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for v"), ce_string ("hybridj.c"), 303, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.v := l_v
				Result := 0
			end
		end

	hybridj_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybridj_alloc)
		end

	hybridj_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_HYBRIDJ_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_HYBRIDJ_STATE_T]}.make_cast (a_vstate)
			init_source_inst.gsl_vector_free (l_state.item.v)
			init_source_inst.gsl_vector_free (l_state.item.w)
			init_source_inst.gsl_vector_free (l_state.item.rdx)
			init_source_inst.gsl_vector_free (l_state.item.qtdf)
			init_source_inst.gsl_vector_free (l_state.item.df)
			init_source_inst.gsl_vector_free (l_state.item.f_trial)
			init_source_inst.gsl_vector_free (l_state.item.x_trial)
			init_source_inst.gsl_vector_free (l_state.item.gradient)
			init_source_inst.gsl_vector_free (l_state.item.newton)
			init_source_inst.gsl_vector_free (l_state.item.qtf)
			init_source_inst.gsl_vector_free (l_state.item.diag)
			init_source_inst.gsl_vector_free (l_state.item.tau)
			init_source_inst.gsl_matrix_free (l_state.item.r)
			init_source_inst.gsl_matrix_free (l_state.item.q)
		end

	hybridj_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybridj_free)
		end

	hybridj_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (hybridj_iterate_impl (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 0))
			Result := l_status
		end

	hybridj_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybridj_iterate)
		end

	hybridj_iterate_impl (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_scale: INTEGER_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_HYBRIDJ_STATE_T]
			l_fnorm: REAL_64
			l_q___3: CE_POINTER [PD_GSL_MATRIX]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_qtf: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_f_trial: CE_POINTER [PD_GSL_VECTOR]
			l_df: CE_POINTER [PD_GSL_VECTOR]
			l_qtdf: CE_POINTER [PD_GSL_VECTOR]
			l_rdx: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_prered: REAL_64
			l_actred: REAL_64
			l_pnorm: REAL_64
			l_fnorm1: REAL_64
			l_fnorm1p: REAL_64
			l_ratio: REAL_64
			l_p1: REAL_64
			l_p5: REAL_64
			l_p001: REAL_64
			l_p0001: REAL_64
			l_status: INTEGER_32
			l_status___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make
			create l_q___3.make
			create l_r___3.make
			create l_tau.make
			create l_diag.make
			create l_qtf.make
			create l_x_trial.make
			create l_f_trial.make
			create l_df.make
			create l_qtdf.make
			create l_rdx.make
			create l_w.make
			create l_v.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_POINTER [PD_HYBRIDJ_STATE_T]}.make_cast (a_vstate)
					l_fnorm := l_state.item.fnorm
					l_q___3 := l_state.item.q
					l_r___3 := l_state.item.r
					l_tau := l_state.item.tau
					l_diag := l_state.item.diag
					l_qtf := l_state.item.qtf
					l_x_trial := l_state.item.x_trial
					l_f_trial := l_state.item.f_trial
					l_df := l_state.item.df
					l_qtdf := l_state.item.qtdf
					l_rdx := l_state.item.rdx
					l_w := l_state.item.w
					l_v := l_state.item.v
					l_p1 := 0.1
					l_p5 := 0.5
					l_p001 := 0.001
					l_p0001 := 0.0001
					dogleg_inst.compute_qtf (l_q___3, a_f, l_qtf)
					dogleg_inst.dogleg (l_r___3, l_qtf, l_diag, l_state.item.delta, l_state.item.newton, l_state.item.gradient, a_dx).do_nothing
					dogleg_inst.compute_trial_step___0 (a_x, a_dx, l_state.item.x_trial)
					l_pnorm := dogleg_inst.scaled_enorm___0 (l_diag, a_dx)
					if l_state.item.iter = {NATURAL_32} 1 then
						if l_pnorm < l_state.item.delta then
							l_state.item.delta := l_pnorm
						end
					end
					l_status := ((a_fdf.item.f).integer_32_item ([l_x_trial, a_fdf.item.params, l_f_trial]))
					if l_status /= 0 then
						Result := 9
						js.return
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						dogleg_inst.compute_df (l_f_trial, a_f, l_df)
						l_fnorm1 := enorm_inst.enorm___1 (l_f_trial)
						l_actred := dogleg_inst.compute_actual_reduction___0 (l_fnorm, l_fnorm1)
						dogleg_inst.compute_rdx (l_r___3, a_dx, l_rdx)
						l_fnorm1p := dogleg_inst.enorm_sum (l_qtf, l_rdx)
						l_prered := dogleg_inst.compute_predicted_reduction (l_fnorm, l_fnorm1p)
						if l_prered > (0).to_double then
							l_ratio := l_actred / l_prered
						else
							l_ratio := (0).to_double
						end
						if not (l_ratio < l_p1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_state.item.ncsuc := (0).to_natural_32
						l_state.item.ncfail := (l_state.item.ncfail) + 1
						l_state.item.delta := l_state.item.delta * l_p5
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 4 then -- else:
						l_state.item.ncfail := (0).to_natural_32
						l_state.item.ncsuc := (l_state.item.ncsuc) + 1
						if not (l_ratio >= l_p5) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (l_state.item.ncsuc > {NATURAL_32} 1) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if l_state.item.delta > l_pnorm / l_p5 then
							l_state.item.delta := l_state.item.delta
						else
							l_state.item.delta := l_pnorm / l_p5
						end
				when 9 then -- if done
						if (fabs (l_ratio - (1).to_double)) <= l_p1 then
							l_state.item.delta := l_pnorm / l_p5
						end
				when 10 then -- if done
						if l_ratio >= l_p0001 then
							copy_source_inst.gsl_vector_memcpy (a_x, l_x_trial).do_nothing
							copy_source_inst.gsl_vector_memcpy (a_f, l_f_trial).do_nothing
							l_state.item.fnorm := l_fnorm1
							l_state.item.iter := (l_state.item.iter) + 1
						end
						l_state.item.nslow1 := (l_state.item.nslow1) + 1
						if l_actred >= l_p001 then
							l_state.item.nslow1 := (0).to_natural_32
						end
						if l_actred >= l_p1 then
							l_state.item.nslow2 := (0).to_natural_32
						end
						if l_state.item.ncfail = {NATURAL_32} 2 then
							l_status___0 := ((a_fdf.item.df).integer_32_item ([a_x, a_fdf.item.params, a_J]))
							if l_status___0 /= 0 then
								Result := 9
								js.return
							end
							if not js.return_called then
								l_state.item.nslow2 := (l_state.item.nslow2) + 1
								if l_state.item.iter = {NATURAL_32} 1 then
									if a_scale.to_boolean then
										dogleg_inst.compute_diag___0 (a_J, l_diag)
									end
									l_state.item.delta := dogleg_inst.compute_delta___0 (l_diag, a_x)
								elseif a_scale.to_boolean then
									dogleg_inst.update_diag___0 (a_J, l_diag)
								end
								qr_inst.gsl_linalg_QR_decomp (a_J, l_tau).do_nothing
								qr_inst.gsl_linalg_QR_unpack (a_J, l_tau, l_q___3, l_r___3).do_nothing
								Result := 0
								js.return
							end
						end
				when 11 then -- if done
					if not js.return_called then
						dogleg_inst.compute_qtf (l_q___3, l_df, l_qtdf)
						dogleg_inst.compute_wv (l_qtdf, l_rdx, a_dx, l_diag, l_pnorm, l_w, l_v)
						qr_inst.gsl_linalg_QR_update (l_q___3, l_r___3, l_w, l_v).do_nothing
						if l_state.item.nslow2 = {NATURAL_32} 5 then
							Result := 28
							js.return
						end
					end
					if not js.return_called and then (l_state.item.nslow1 = {NATURAL_32} 10) then
						Result := 27
						js.return
					end
					if not js.return_called then
						Result := 0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hybridj_set (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (hybridj_set_impl (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 0))
			Result := l_status
		end

	hybridj_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybridj_set)
		end

	hybridj_set_impl (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_scale: INTEGER_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_HYBRIDJ_STATE_T]
			l_q___3: CE_POINTER [PD_GSL_MATRIX]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
		do
			create l_state.make
			create l_q___3.make
			create l_r___3.make
			create l_tau.make
			create l_diag.make

			l_state := create {CE_POINTER [PD_HYBRIDJ_STATE_T]}.make_cast (a_vstate)
			l_q___3 := l_state.item.q
			l_r___3 := l_state.item.r
			l_tau := l_state.item.tau
			l_diag := l_state.item.diag;
			(a_fdf.item.fdf).call ([a_x, a_fdf.item.params, a_f, a_J])
			l_state.item.iter := (1).to_natural_32
			l_state.item.fnorm := enorm_inst.enorm___1 (a_f)
			l_state.item.ncfail := (0).to_natural_32
			l_state.item.ncsuc := (0).to_natural_32
			l_state.item.nslow1 := (0).to_natural_32
			l_state.item.nslow2 := (0).to_natural_32
			init_source_inst.gsl_vector_set_all (a_dx, 0.0)
			if a_scale.to_boolean then
				dogleg_inst.compute_diag___0 (a_J, l_diag)
			else
				init_source_inst.gsl_vector_set_all (l_diag, 1.0)
			end
			l_state.item.delta := dogleg_inst.compute_delta___0 (l_diag, a_x)
			qr_inst.gsl_linalg_QR_decomp (a_J, l_tau).do_nothing
			qr_inst.gsl_linalg_QR_unpack (a_J, l_tau, l_q___3, l_r___3).do_nothing
			Result := 0
		end

	hybridsj_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (hybridj_iterate_impl (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 1))
			Result := l_status
		end

	hybridsj_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybridsj_iterate)
		end

	hybridsj_set (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (hybridj_set_impl (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 1))
			Result := l_status
		end

	hybridsj_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybridsj_set)
		end

end
