class
	P_INIT2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_alloc (a_nx: NATURAL_32; a_ny: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM2D]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM2D]
			js: JUMP_STATE
		do
			create l_h.make

			if a_nx = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("histogram2d length nx must be positive integer"), ce_string ("init2d.c"), 34, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_ny = {NATURAL_32} 0) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("histogram2d length ny must be positive integer"), ce_string ("init2d.c"), 40, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_h := create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_cast ((malloc ((create {PD_GSL_HISTOGRAM2D}.make).structure_size.to_natural_32)))
				if l_h.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d struct"), ce_string ("init2d.c"), 48, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_h.item.xrange := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_nx + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.xrange).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d x ranges"), ce_string ("init2d.c"), 58, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_h.item.yrange := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_ny + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.yrange).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.xrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d y ranges"), ce_string ("init2d.c"), 69, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_h.item.bin := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_nx * a_ny) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.bin).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.xrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.yrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram bins"), ce_string ("init2d.c"), 81, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_h.item.nx := a_nx
				l_h.item.ny := a_ny
				Result := l_h
			end
		end

	gsl_histogram2d_calloc (a_nx: NATURAL_32; a_ny: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM2D]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM2D]
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			create l_h.make

			if a_nx = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("histogram2d length nx must be positive integer"), ce_string ("init2d.c"), 141, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_ny = {NATURAL_32} 0) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("histogram2d length ny must be positive integer"), ce_string ("init2d.c"), 147, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_h := create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_cast ((malloc ((create {PD_GSL_HISTOGRAM2D}.make).structure_size.to_natural_32)))
				if l_h.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d struct"), ce_string ("init2d.c"), 155, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_h.item.xrange := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_nx + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.xrange).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d x ranges"), ce_string ("init2d.c"), 165, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_h.item.yrange := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_ny + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.yrange).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.xrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d y ranges"), ce_string ("init2d.c"), 176, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_h.item.bin := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_nx * a_ny) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.bin).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.xrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.yrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram bins"), ce_string ("init2d.c"), 188, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_nx + {NATURAL_32} 1)
				loop
					l_h.item.xrange[l_i.to_integer_32] := l_i.to_real_64
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_ny + {NATURAL_32} 1)
				loop
					l_h.item.yrange[l_i.to_integer_32] := l_i.to_real_64
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_nx * a_ny)
				loop
					l_h.item.bin[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				l_h.item.nx := a_nx
				l_h.item.ny := a_ny
				Result := l_h
			end
		end

	gsl_histogram2d_calloc_uniform (a_nx: NATURAL_32; a_ny: NATURAL_32; a_xmin: REAL_64; a_xmax: REAL_64; a_ymin: REAL_64; a_ymax: REAL_64): CE_POINTER [PD_GSL_HISTOGRAM2D]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM2D]
			js: JUMP_STATE
		do
			create l_h.make

			if a_xmin >= a_xmax then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("xmin must be less than xmax"), ce_string ("init2d.c"), 112, 4)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_ymin >= a_ymax) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("ymin must be less than ymax"), ce_string ("init2d.c"), 117, 4)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_h := gsl_histogram2d_calloc (a_nx, a_ny)
				if l_h.is_void then
					Result := l_h
					js.return
				end
			end
			if not js.return_called then
				make_uniform (l_h.item.xrange, a_nx, a_xmin, a_xmax)
				make_uniform (l_h.item.yrange, a_ny, a_ymin, a_ymax)
				Result := l_h
			end
		end

	gsl_histogram2d_free (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D])
		local
			js: JUMP_STATE
		do
			if a_h.is_void then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_h.item.xrange))
				free (create {CE_POINTER [ANY]}.make_cast (a_h.item.yrange))
				free (create {CE_POINTER [ANY]}.make_cast (a_h.item.bin))
				free (create {CE_POINTER [ANY]}.make_cast (a_h))
			end
		end

	gsl_histogram2d_set_ranges (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_xrange: CE_POINTER [REAL_64]; a_xsize: NATURAL_32; a_yrange: CE_POINTER [REAL_64]; a_ysize: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			js: JUMP_STATE
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			if a_xsize /= l_nx + {NATURAL_32} 1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of xrange must match size of histogram"), ce_string ("init2d.c"), 272, 4)
					Result := 0
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_ysize /= l_ny + {NATURAL_32} 1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of yrange must match size of histogram"), ce_string ("init2d.c"), 278, 4)
					Result := 0
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i <= l_nx)
				loop
					a_h.item.xrange[l_i.to_integer_32] := a_xrange[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i <= l_ny)
				loop
					a_h.item.yrange[l_i.to_integer_32] := a_yrange[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_nx * l_ny)
				loop
					a_h.item.bin[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_histogram2d_set_ranges_uniform (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_xmin: REAL_64; a_xmax: REAL_64; a_ymin: REAL_64; a_ymax: REAL_64): INTEGER_32
		local
			l_i: NATURAL_32
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			js: JUMP_STATE
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			if a_xmin >= a_xmax then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("xmin must be less than xmax"), ce_string ("init2d.c"), 238, 4)
					Result := 0
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_ymin >= a_ymax) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("ymin must be less than ymax"), ce_string ("init2d.c"), 243, 4)
					Result := 0
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				make_uniform (a_h.item.xrange, l_nx, a_xmin, a_xmax)
				make_uniform (a_h.item.yrange, l_ny, a_ymin, a_ymax)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_nx * l_ny)
				loop
					a_h.item.bin[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	make_uniform (a_range: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_xmin: REAL_64; a_xmax: REAL_64)
		local
			l_i: NATURAL_32
			l_f1: REAL_64
			l_f2: REAL_64
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i <= a_n)
			loop
				l_f1 := (a_n - l_i).to_real_64 / a_n.to_real_64
				l_f2 := l_i.to_real_64 / a_n.to_real_64
				a_range[l_i.to_integer_32] := l_f1 * a_xmin + l_f2 * a_xmax
				l_i := l_i + 1
			end
		end

end
