class
	P_INTEG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cheb_calc_integ (a_integ: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]; a_f: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_con: REAL_64
			l_sum: REAL_64
			l_fac: REAL_64
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_n := (a_f.item.order + {NATURAL_32} 1)
			l_con := 0.25 * (a_f.item.b - a_f.item.a)
			if a_integ.item.order /= a_f.item.order then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("order of chebyshev series must be equal"), ce_string ("integ.c"), 33, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_integ.item.a := a_f.item.a
				a_integ.item.b := a_f.item.b
				if l_n = {NATURAL_32} 1 then
					a_integ.item.c[0] := 0.
				elseif l_n = {NATURAL_32} 2 then
					a_integ.item.c[1] := l_con * a_f.item.c[0]
					a_integ.item.c[0] := 2.0 * a_integ.item.c[1]
				else
					l_sum := 0.0
					l_fac := 1.0
					l_i := (1).to_natural_32
					from
					until
						not (l_i <= l_n - {NATURAL_32} 2)
					loop
						a_integ.item.c[l_i.to_integer_32] := (l_con * (a_f.item.c[(l_i - {NATURAL_32} 1).to_integer_32] - a_f.item.c[(l_i + {NATURAL_32} 1).to_integer_32])) / l_i.to_real_64
						l_sum := l_sum + (l_fac * a_integ.item.c[l_i.to_integer_32])
						l_fac := -l_fac
						l_i := l_i + 1
					end
					a_integ.item.c[(l_n - {NATURAL_32} 1).to_integer_32] := (l_con * a_f.item.c[(l_n - {NATURAL_32} 2).to_integer_32]) / (l_n.to_real_64 - 1.0)
					l_sum := l_sum + (l_fac * a_integ.item.c[(l_n - {NATURAL_32} 1).to_integer_32])
					a_integ.item.c[0] := 2.0 * l_sum
				end
				Result := 0
			end
		end

end
