class
	P_KNUTHRAN2

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_knuthran2.make
			create ran_type___1.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_rng_knuthran2: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_knuthran2

	set_gsl_rng_knuthran2 (a_gsl_rng_knuthran2: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_knuthran2 := a_gsl_rng_knuthran2
		end

	ran_type___1: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran_get___1 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__]
			l_xtmp: NATURAL_32
			l_tmp: NATURAL_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RAN_STATE_T_26__]}.make_cast (a_vstate)
			l_xtmp := l_state.item.x1
			l_tmp := schrage_inst.schrage_mult ({NATURAL_32} 271_828_183, l_state.item.x1, {NATURAL_32} 2_147_483_647, {NATURAL_32} 46_341)
			l_state.item.x1 := l_tmp + (schrage_inst.schrage_mult ({NATURAL_32} 1_833_324_378, l_state.item.x0, {NATURAL_32} 2_147_483_647, {NATURAL_32} 46_341))
			if l_state.item.x1 >= {NATURAL_32} 2_147_483_647 then
				l_state.item.x1 := l_state.item.x1 - ({NATURAL_32} 2_147_483_647)
			end
			l_state.item.x0 := l_xtmp
			Result := (l_state.item.x1)
		end

	ran_get___1_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get___1)
		end

	ran_get_double___1 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RAN_STATE_T_26__]}.make_cast (a_vstate)
			Result := ((ran_get___1 (create {CE_POINTER [ANY]}.make_cast (l_state))).to_real_64 / 2147483647.0)
		end

	ran_get_double___1_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get_double___1)
		end

	ran_set___1 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T_26__]
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_RAN_STATE_T_26__]}.make_cast (a_vstate)
			if l_s \\ {NATURAL_32} 2_147_483_647 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x0 := l_s \\ {NATURAL_32} 2_147_483_647
			l_state.item.x1 := l_s \\ {NATURAL_32} 2_147_483_647
		end

	ran_set___1_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_set___1)
		end

end
