class
	P_LAG1_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_stats_char_lag1_autocorrelation (a_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_char_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_char_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_char_lag1_autocorrelation_m (a_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 ((((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean) * ((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 (((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32]).to_double - a_mean))
				l_delta1 := real_96_from_real_64 (((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_float_lag1_autocorrelation (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_float_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_float_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_float_lag1_autocorrelation_m (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 ((((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean) * ((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 (((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32]).to_double - a_mean))
				l_delta1 := real_96_from_real_64 (((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_int_lag1_autocorrelation (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_int_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_int_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_int_lag1_autocorrelation_m (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 ((((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean) * ((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 (((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32]).to_double - a_mean))
				l_delta1 := real_96_from_real_64 (((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_lag1_autocorrelation (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_lag1_autocorrelation_m (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 (((a_data[({NATURAL_32} 0).to_integer_32] - a_mean) * (a_data[({NATURAL_32} 0).to_integer_32] - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 ((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32] - a_mean))
				l_delta1 := real_96_from_real_64 ((a_data[(l_i * a_stride).to_integer_32] - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_long_double_lag1_autocorrelation (a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_long_double_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_long_double_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_long_double_lag1_autocorrelation_m (a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := ((a_data[({NATURAL_32} 0).to_integer_32] - real_96_from_real_64 (a_mean)) * (a_data[({NATURAL_32} 0).to_integer_32] - real_96_from_real_64 (a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := (a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32] - real_96_from_real_64 (a_mean))
				l_delta1 := (a_data[(l_i * a_stride).to_integer_32] - real_96_from_real_64 (a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_long_lag1_autocorrelation (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_long_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_long_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_long_lag1_autocorrelation_m (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 ((((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean) * ((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 (((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32]).to_double - a_mean))
				l_delta1 := real_96_from_real_64 (((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_short_lag1_autocorrelation (a_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_short_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_short_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_short_lag1_autocorrelation_m (a_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 ((((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean) * ((a_data[({NATURAL_32} 0).to_integer_32]).to_double - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 (((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32]).to_double - a_mean))
				l_delta1 := real_96_from_real_64 (((a_data[(l_i * a_stride).to_integer_32]).to_double - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_uchar_lag1_autocorrelation (a_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_uchar_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_uchar_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_uchar_lag1_autocorrelation_m (a_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 ((((a_data[({NATURAL_32} 0).to_integer_32]).to_real_64 - a_mean) * ((a_data[({NATURAL_32} 0).to_integer_32]).to_real_64 - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 (((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_delta1 := real_96_from_real_64 (((a_data[(l_i * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_uint_lag1_autocorrelation (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_uint_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_uint_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_uint_lag1_autocorrelation_m (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 ((((a_data[({NATURAL_32} 0).to_integer_32]).to_real_64 - a_mean) * ((a_data[({NATURAL_32} 0).to_integer_32]).to_real_64 - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 (((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_delta1 := real_96_from_real_64 (((a_data[(l_i * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_ulong_lag1_autocorrelation (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_ulong_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_ulong_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_ulong_lag1_autocorrelation_m (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 ((((a_data[({NATURAL_32} 0).to_integer_32]).to_real_64 - a_mean) * ((a_data[({NATURAL_32} 0).to_integer_32]).to_real_64 - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 (((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_delta1 := real_96_from_real_64 (((a_data[(l_i * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

	gsl_stats_ushort_lag1_autocorrelation (a_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32): REAL_64
		local
			l_mean: REAL_64
		do
			l_mean := (mean_source_inst.gsl_stats_ushort_mean (a_data, a_stride, a_n))
			Result := (gsl_stats_ushort_lag1_autocorrelation_m (a_data, a_stride, a_n, l_mean))
		end

	gsl_stats_ushort_lag1_autocorrelation_m (a_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_size: NATURAL_32; a_mean: REAL_64): REAL_64
		local
			l_i: NATURAL_32
			l_r1___1: REAL_96
			l_q___3: REAL_96
			l_v: REAL_96
			l_delta0: REAL_96
			l_delta1: REAL_96
		do
			l_q___3 := real_96_from_integer_32 (0)
			l_v := real_96_from_real_64 ((((a_data[({NATURAL_32} 0).to_integer_32]).to_real_64 - a_mean) * ((a_data[({NATURAL_32} 0).to_integer_32]).to_real_64 - a_mean)))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_delta0 := real_96_from_real_64 (((a_data[((l_i - {NATURAL_32} 1) * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_delta1 := real_96_from_real_64 (((a_data[(l_i * a_stride).to_integer_32]).to_real_64 - a_mean))
				l_q___3 := l_q___3 + ((l_delta0 * l_delta1 - l_q___3) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_v := l_v + ((l_delta1 * l_delta1 - l_v) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			l_r1___1 := l_q___3 / l_v
			Result := l_r1___1.truncated_to_real_64
		end

end
