class
	P_LEVIN_UTRUNC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sum_levin_utrunc_accel (a_array: CE_POINTER [REAL_64]; a_array_size: NATURAL_32; a_w: CE_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]; a_sum_accel: CE_POINTER [REAL_64]; a_abserr_trunc: CE_POINTER [REAL_64]): INTEGER_32
		do
			Result := (gsl_sum_levin_utrunc_minmax (a_array, a_array_size, (0).to_natural_32, a_array_size - {NATURAL_32} 1, a_w, a_sum_accel, a_abserr_trunc))
		end

	gsl_sum_levin_utrunc_minmax (a_array: CE_POINTER [REAL_64]; a_array_size: NATURAL_32; a_min_terms: NATURAL_32; a_max_terms: NATURAL_32; a_w: CE_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]; a_sum_accel: CE_POINTER [REAL_64]; a_abserr_trunc: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_SMALL: REAL_64
			l_nmax: NATURAL_32
			l_tmp___0: NATURAL_32
			l_trunc_n: REAL_64
			l_trunc_nm1: REAL_64
			l_actual_trunc_n: REAL_64
			l_actual_trunc_nm1: REAL_64
			l_result_n: CE_ARRAY [REAL_64]
			l_result_nm1: REAL_64
			l_n: NATURAL_32
			l_better: INTEGER_32
			l_before: INTEGER_32
			l_converging: INTEGER_32
			l_least_trunc: REAL_64
			l_result_least_trunc: REAL_64
			l_t: REAL_64
			l_t___0: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_result_n.make (<<1>>)

			if a_array_size = {NATURAL_32} 0 then
				a_sum_accel.item := 0.0
				a_abserr_trunc.item := 0.0
				a_w.item.sum_plain := 0.0
				a_w.item.terms_used := (0).to_natural_32
				Result := 0
			elseif a_array_size = {NATURAL_32} 1 then
				a_sum_accel.item := a_array[0]
				a_abserr_trunc.item := (builtin_inff).to_double
				a_w.item.sum_plain := a_array[0]
				a_w.item.terms_used := (1).to_natural_32
				Result := 0
			else
				l_SMALL := 0.01
				if a_max_terms > a_array_size then
					l_tmp___0 := a_max_terms
				else
					l_tmp___0 := a_array_size
				end
				l_nmax := l_tmp___0 - {NATURAL_32} 1
				l_trunc_n := 0.0
				l_trunc_nm1 := 0.0
				l_actual_trunc_n := 0.0
				l_actual_trunc_nm1 := 0.0
				l_result_n.item := 0.0
				l_result_nm1 := 0.0
				l_better := 0
				l_before := 0
				l_converging := 0
				l_least_trunc := 1.7976931348623157e+308
				l_n := (0).to_natural_32
				from
				until
					not (l_n < a_min_terms)
				loop
					l_t := a_array[l_n.to_integer_32]
					l_result_nm1 := l_result_n.item
					gsl_sum_levin_utrunc_step (l_t, l_n, a_w, l_result_n).do_nothing
					l_n := l_n + 1
				end
				l_result_least_trunc := l_result_n.item
				from
				until
					not (not js.loop_done and then (l_n <= l_nmax))
				loop
					l_t___0 := a_array[l_n.to_integer_32]
					l_result_nm1 := l_result_n.item
					gsl_sum_levin_utrunc_step (l_t___0, l_n, a_w, l_result_n).do_nothing
					l_actual_trunc_nm1 := l_actual_trunc_n
					l_actual_trunc_n := fabs (l_result_n.item - l_result_nm1)
					l_trunc_nm1 := l_trunc_n
					l_trunc_n := 0.5 * (l_actual_trunc_n + l_actual_trunc_nm1)
					if l_trunc_n < l_trunc_nm1 then
						l_tmp___2 := 1
					elseif l_trunc_n < l_SMALL * (fabs (l_result_n.item)) then
						l_tmp___2 := 1
					else
						l_tmp___2 := 0
					end
					l_better := l_tmp___2
					if l_converging.to_boolean then
						l_tmp___3 := 1
					elseif l_better.to_boolean then
						if l_before.to_boolean then
							l_tmp___3 := 1
						else
							l_tmp___3 := 0
						end
					else
						l_tmp___3 := 0
					end
					l_converging := l_tmp___3
					l_before := l_better
					if l_converging.to_boolean then
						if l_trunc_n < l_least_trunc then
							l_least_trunc := l_trunc_n
							l_result_least_trunc := l_result_n.item
						end
						if (fabs (l_trunc_n / l_result_n.item)) < 10.0 * 2.2204460492503131e-16 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_n := l_n + 1
					end
				end
				if l_converging.to_boolean then
					a_sum_accel.item := l_result_least_trunc
					a_abserr_trunc.item := l_least_trunc
					a_w.item.terms_used := l_n
					Result := 0
				else
					a_sum_accel.item := l_result_n.item
					a_abserr_trunc.item := l_trunc_n
					a_w.item.terms_used := l_n
					Result := 0
				end
			end
		end

	gsl_sum_levin_utrunc_step (a_term: REAL_64; a_n: NATURAL_32; a_w: CE_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]; a_sum_accel: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_factor: REAL_64
			l_ratio: REAL_64
			l_j: INTEGER_32
			l_c___1: REAL_64
		do
			if a_term = 0.0 then
				Result := 12
			elseif a_n = {NATURAL_32} 0 then
				a_sum_accel.item := a_term
				a_w.item.sum_plain := a_term
				a_w.item.q_den[0] := 1.0 / a_term
				a_w.item.q_num[0] := 1.0
				Result := 0
			else
				l_factor := 1.0
				l_ratio := a_n.to_real_64 / (a_n.to_real_64 + 1.0)
				a_w.item.sum_plain := a_w.item.sum_plain + a_term
				a_w.item.q_den[a_n.to_integer_32] := 1.0 / ((a_term * (a_n.to_real_64 + 1.0)) * (a_n.to_real_64 + 1.0))
				a_w.item.q_num[a_n.to_integer_32] := a_w.item.sum_plain * a_w.item.q_den[a_n.to_integer_32]
				l_j := (a_n - {NATURAL_32} 1).to_integer_32
				from
				until
					not (l_j >= 0)
				loop
					l_c___1 := (l_factor * (l_j + 1).to_double) / (a_n + {NATURAL_32} 1).to_real_64
					l_factor := l_factor * l_ratio
					a_w.item.q_den[l_j] := a_w.item.q_den[(l_j + 1)] - l_c___1 * a_w.item.q_den[l_j]
					a_w.item.q_num[l_j] := a_w.item.q_num[(l_j + 1)] - l_c___1 * a_w.item.q_num[l_j]
					l_j := l_j - 1
				end
				a_sum_accel.item := a_w.item.q_num[0] / a_w.item.q_den[0]
				Result := 0
			end
		end

end
