class
	P_LMPAR

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	compute_gradient_direction (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_qtf: CE_POINTER [PD_GSL_VECTOR]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_g: CE_POINTER [PD_GSL_VECTOR])
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_sum: REAL_64
			l_tmp: REAL_64
			l_pj: NATURAL_32
			l_dpj: REAL_64
			js: JUMP_STATE
		do
			l_n := a_r___3.item.size2
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i <= l_j)
				loop
					l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j)
					l_sum := l_sum + (l_tmp * (gsl_gsl_vector_double_inst.gsl_vector_get (a_qtf, l_i)))
					l_i := l_i + 1
				end
				l_pj := (gsl_gsl_permutation_inst.gsl_permutation_get (a_p, l_j))
				l_dpj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_pj))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_g, l_j, l_sum / l_dpj)
				l_j := l_j + 1
			end
		end

	compute_newton_bound (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_dxnorm: REAL_64; a_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_VECTOR])
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_nsing: NATURAL_32
			l_pi: NATURAL_32
			l_dpi: REAL_64
			l_xpi: REAL_64
			l_sum: REAL_64
			l_tmp___3: REAL_64
			l_rjj: REAL_64
			l_wj: REAL_64
			js: JUMP_STATE
		do
			l_n := a_r___3.item.size2
			l_nsing := (count_nsing (a_r___3))
			if l_nsing < l_n then
				init_source_inst.gsl_vector_set_zero (a_w)
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_pi := (gsl_gsl_permutation_inst.gsl_permutation_get (a_perm, l_i))
					l_dpi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_pi))
					l_xpi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_pi))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w, l_i, l_dpi * ((l_dpi * l_xpi) / a_dxnorm))
					l_i := l_i + 1
				end
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_n))
				loop
					l_sum := (0).to_double
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_j)
					loop
						l_tmp___3 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j)
						l_sum := l_sum + (l_tmp___3 * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_i)))
						l_i := l_i + 1
					end
					l_rjj := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_j, l_j))
					l_wj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_j))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w, l_j, (l_wj - l_sum) / l_rjj)
					l_j := l_j + 1
				end
			end
		end

	compute_newton_correction (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_sdiag: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_dxnorm: REAL_64; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_VECTOR])
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_pi: NATURAL_32
			l_dpi: REAL_64
			l_xpi: REAL_64
			l_sj: REAL_64
			l_wj: REAL_64
			l_tj: REAL_64
			l_rij: REAL_64
			l_wi: REAL_64
			js: JUMP_STATE
		do
			l_n := a_r___3.item.size2
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_pi := (gsl_gsl_permutation_inst.gsl_permutation_get (a_p, l_i))
				l_dpi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_pi))
				l_xpi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_pi))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_w, l_i, (l_dpi * (l_dpi * l_xpi)) / a_dxnorm)
				l_i := l_i + 1
			end
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_sj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_sdiag, l_j))
				l_wj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_j))
				l_tj := l_wj / l_sj
				gsl_gsl_vector_double_inst.gsl_vector_set (a_w, l_j, l_tj)
				l_i := l_j + {NATURAL_32} 1
				from
				until
					not (l_i < l_n)
				loop
					l_rij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j))
					l_wi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_i))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w, l_i, l_wi - l_rij * l_tj)
					l_i := l_i + 1
				end
				l_j := l_j + 1
			end
		end

	compute_newton_direction (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_qtf: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR])
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_nsing: NATURAL_32
			l_qtfi: REAL_64
			l_rjj: REAL_64
			l_temp: REAL_64
			l_rij: REAL_64
			l_xi: REAL_64
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_r___3.item.size2
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_qtfi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_qtf, l_i))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_i, l_qtfi)
				l_i := l_i + 1
			end
			l_nsing := count_nsing (a_r___3)
			l_i := l_nsing
			from
			until
				not (l_i < l_n)
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_i, 0.0)
				l_i := l_i + 1
			end
			if l_nsing > {NATURAL_32} 0 then
				l_j := l_nsing
				from
				until
					js.loop_done
				loop
					if l_j > {NATURAL_32} 0 then
						l_tmp___4 := l_j
						l_j := l_j - 1
						if not l_tmp___4.to_boolean then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_rjj := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_j, l_j))
						l_temp := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_j)) / l_rjj
						gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_j, l_temp)
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_j)
						loop
							l_rij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j))
							l_xi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
							gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_i, l_xi - l_rij * l_temp)
							l_i := l_i + 1
						end
					end
				end
			end
			permute_source_inst.gsl_permute_vector_inverse (a_perm, a_x).do_nothing
		end

	count_nsing (a_r___3: CE_POINTER [PD_GSL_MATRIX]): NATURAL_32
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_rii: REAL_64
			js: JUMP_STATE
		do
			l_n := a_r___3.item.size2
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_n))
			loop
				l_rii := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_i))
				if l_rii = (0).to_double then
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			Result := l_i
		end

	lmpar (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_qtf: CE_POINTER [PD_GSL_VECTOR]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_delta___0: REAL_64; a_par_inout: CE_POINTER [REAL_64]; a_newton: CE_POINTER [PD_GSL_VECTOR]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_sdiag: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_dxnorm: REAL_64
			l_gnorm: REAL_64
			l_fp: REAL_64
			l_fp_old: REAL_64
			l_par_lower: REAL_64
			l_par_upper: REAL_64
			l_par_c: REAL_64
			l_par: REAL_64
			l_iter: NATURAL_32
			l_wnorm: REAL_64
			l_phider: REAL_64
			l_sqrt_par: REAL_64
			l_wnorm___0: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_par := a_par_inout.item
					l_iter := (0).to_natural_32
					compute_newton_direction (a_r___3, a_perm, a_qtf, a_newton)
					l_dxnorm := lmutil_inst.scaled_enorm (a_diag, a_newton)
					l_fp := l_dxnorm - a_delta___0
					if l_fp <= 0.1 * a_delta___0 then
						copy_source_inst.gsl_vector_memcpy (a_x, a_newton).do_nothing
						a_par_inout.item := (0).to_double
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						compute_newton_bound (a_r___3, a_newton, l_dxnorm, a_perm, a_diag, a_w)
						l_wnorm := (lmutil_inst.enorm (a_w))
						l_phider := l_wnorm * l_wnorm
						if l_wnorm > (0).to_double then
							l_par_lower := l_fp / (a_delta___0 * l_phider)
						else
							l_par_lower := 0.0
						end
						compute_gradient_direction (a_r___3, a_perm, a_qtf, a_diag, a_gradient)
						l_gnorm := lmutil_inst.enorm (a_gradient)
						l_par_upper := l_gnorm / a_delta___0
						if l_par_upper = (0).to_double then
							l_par_upper := 2.2250738585072014e-308 / (gsl_gsl_minmax_inst.GSL_MIN_DBL (a_delta___0, 0.1))
						end
						if l_par > l_par_upper then
							l_par := l_par_upper
						elseif l_par < l_par_lower then
							l_par := l_par_lower
						end
						if l_par = (0).to_double then
							l_par := l_gnorm / l_dxnorm
						end
				when 2 then -- iteration:
						l_iter := l_iter + 1
						if l_par = (0).to_double then
							l_par := gsl_gsl_minmax_inst.GSL_MAX_DBL (0.001 * l_par_upper, 2.2250738585072014e-308)
						end
						l_sqrt_par := (sqrt (l_par))
						qrsolv_inst.qrsolv (a_r___3, a_perm, l_sqrt_par, a_diag, a_qtf, a_x, a_sdiag, a_w).do_nothing
						l_dxnorm := lmutil_inst.scaled_enorm (a_diag, a_x)
						l_fp_old := l_fp
						l_fp := l_dxnorm - a_delta___0
						if (fabs (l_fp)) <= 0.1 * a_delta___0 then
							l_pos := -1 + 6 -- goto line220
						end
				when 3 then
						if l_par_lower = (0).to_double then
							if l_fp <= l_fp_old then
								if l_fp_old < (0).to_double then
									l_pos := -1 + 6 -- goto line220
								end
							end
						end
				when 4 then
						if l_iter = {NATURAL_32} 10 then
							l_pos := -1 + 6 -- goto line220
						end
				when 5 then
						compute_newton_correction (a_r___3, a_sdiag, a_perm, a_x, l_dxnorm, a_diag, a_w)
						l_wnorm___0 := (lmutil_inst.enorm (a_w))
						l_par_c := l_fp / ((a_delta___0 * l_wnorm___0) * l_wnorm___0)
						if l_fp > (0).to_double then
							if l_par > l_par_lower then
								l_par_lower := l_par
							end
						elseif l_fp < (0).to_double then
							if l_par < l_par_upper then
								l_par_upper := l_par
							end
						end
						l_par := gsl_gsl_minmax_inst.GSL_MAX_DBL (l_par_lower, l_par + l_par_c)
						l_pos := -1 + 2 -- goto iteration
				when 6 then -- line220:
						a_par_inout.item := l_par
						Result := 0
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
