class
	P_LOG

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create lopx_cs.make (<<1>>)
			create lopx_data.make (<<21>>)
			create lopxmx_cs.make (<<1>>)
			create lopxmx_data.make (<<20>>)
		end

feature {ANY} -- attributes

	lopx_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	lopx_data: CE_ARRAY [REAL_64]

	lopxmx_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	lopxmx_data: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_sf_complex_log_e (a_zr: REAL_64; a_zi: REAL_64; a_lnr: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_theta: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ax: REAL_64
			l_ay: REAL_64
			l_min: REAL_64
			l_tmp___1: REAL_64
			l_max: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_zr = 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_zi = 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_ax := (fabs (a_zr))
						l_ay := (fabs (a_zi))
						if l_ax < l_ay then
							l_tmp___1 := l_ax
						else
							l_tmp___1 := l_ay
						end
						l_min := l_tmp___1
						if l_ax > l_ay then
							l_tmp___2 := l_ax
						else
							l_tmp___2 := l_ay
						end
						l_max := l_tmp___2
						l_tmp___3 := log (l_max)
						a_lnr.item.val := l_tmp___3 + 0.5 * (log (1.0 + (l_min / l_max) * (l_min / l_max)))
						a_lnr.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_lnr.item.val))
						a_theta.item.val := atan2 (a_zi, a_zr)
						a_theta.item.err := 2.2204460492503131e-16 * (fabs (a_lnr.item.val))
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						from
						until
							js.loop_done
						loop
							a_lnr.item.val := (builtin_nanf (ce_string (""))).to_double
							a_lnr.item.err := (builtin_nanf (ce_string (""))).to_double
							a_theta.item.val := (builtin_nanf (ce_string (""))).to_double
							a_theta.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("log.c"), 159, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_log (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_log_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_log_e(x, &result)"), ce_string ("log.c"), 250, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_log_1plusx (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_log_1plusx_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_log_1plusx_e(x, &result)"), ce_string ("log.c"), 260, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_log_1plusx_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_c9: REAL_64
			l_t: REAL_64
			l_t___0: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)

			if a_x <= -1.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("log.c"), 170, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif (fabs (a_x)) < 2.4607833005759251e-03 then
				l_c1___2 := -0.5
				l_c2___0 := 1.0 / 3.0
				l_c3___3 := -1.0 / 4.0
				l_c4___2 := 1.0 / 5.0
				l_c5___1 := -1.0 / 6.0
				l_c6___2 := 1.0 / 7.0
				l_c7___0 := -1.0 / 8.0
				l_c8___0 := 1.0 / 9.0
				l_c9 := -1.0 / 10.0
				l_t := l_c5___1 + a_x * (l_c6___2 + a_x * (l_c7___0 + a_x * (l_c8___0 + a_x * l_c9)))
				a_result.item.val := a_x * (1.0 + a_x * (l_c1___2 + a_x * (l_c2___0 + a_x * (l_c3___3 + a_x * (l_c4___2 + a_x * l_t)))))
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif (fabs (a_x)) < 0.5 then
				l_t___0 := (0.5 * (8.0 * a_x + 1.0)) / (a_x + 2.0)
				cheb_eval_inst.cheb_eval_e (lopx_cs, l_t___0, l_c___1).do_nothing
				a_result.item.val := a_x * l_c___1.item.val
				a_result.item.err := fabs (a_x * l_c___1.item.err)
				Result := 0
				js.return
			else
				a_result.item.val := log (1.0 + a_x)
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_log_1plusx_mx (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_log_1plusx_mx_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_log_1plusx_mx_e(x, &result)"), ce_string ("log.c"), 265, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_log_1plusx_mx_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_c9: REAL_64
			l_t: REAL_64
			l_t___0: REAL_64
			l_c___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lterm: REAL_64
			l_tmp___3: REAL_64
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)

			if a_x <= -1.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("log.c"), 209, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif (fabs (a_x)) < 7.4009597974140505e-04 then
				l_c1___2 := -0.5
				l_c2___0 := 1.0 / 3.0
				l_c3___3 := -1.0 / 4.0
				l_c4___2 := 1.0 / 5.0
				l_c5___1 := -1.0 / 6.0
				l_c6___2 := 1.0 / 7.0
				l_c7___0 := -1.0 / 8.0
				l_c8___0 := 1.0 / 9.0
				l_c9 := -1.0 / 10.0
				l_t := l_c5___1 + a_x * (l_c6___2 + a_x * (l_c7___0 + a_x * (l_c8___0 + a_x * l_c9)))
				a_result.item.val := (a_x * a_x) * (l_c1___2 + a_x * (l_c2___0 + a_x * (l_c3___3 + a_x * (l_c4___2 + a_x * l_t))))
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif (fabs (a_x)) < 0.5 then
				l_t___0 := (0.5 * (8.0 * a_x + 1.0)) / (a_x + 2.0)
				cheb_eval_inst.cheb_eval_e (lopxmx_cs, l_t___0, l_c___1).do_nothing
				a_result.item.val := (a_x * a_x) * l_c___1.item.val
				a_result.item.err := (a_x * a_x) * l_c___1.item.err
				Result := 0
				js.return
			else
				l_lterm := (log (1.0 + a_x))
				a_result.item.val := l_lterm - a_x
				l_tmp___3 := fabs (l_lterm)
				a_result.item.err := 2.2204460492503131e-16 * (l_tmp___3 + (fabs (a_x)))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_log_abs (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_log_abs_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_log_abs_e(x, &result)"), ce_string ("log.c"), 255, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_log_abs_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_x = 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("log.c"), 132, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			else
				a_result.item.val := log ((fabs (a_x)))
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_log_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_x <= 0.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("log.c"), 116, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			else
				a_result.item.val := log (a_x)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
