class
	P_MAKE_REP

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create nybble.make (<<16, 5>>)
		end

feature {ANY} -- attributes

	nybble: CE_ARRAY [CE_ARRAY [INTEGER_8]]

feature {ANY} -- routines

	determine_ieee_type (a_non_zero: INTEGER_32; a_exponent: INTEGER_32; a_max_exponent: INTEGER_32): INTEGER_32
		do
			if a_exponent = a_max_exponent then
				if a_non_zero.to_boolean then
					Result := 1
				else
					Result := 2
				end
			elseif a_exponent = 0 then
				if a_non_zero.to_boolean then
					Result := 4
				else
					Result := 5
				end
			else
				Result := 3
			end
		end

	gsl_ieee_double_to_rep (a_x: CE_POINTER [REAL_64]; a_r___3: CE_POINTER [PD_GSL_IEEE_DOUBLE_REP])
		local
			l_e: INTEGER_32
			l_non_zero: INTEGER_32
			l_u: CE_ARRAY [PD_U5]
			l_tmp___0: INTEGER_32
		do
			create l_u.make (<<1>>)

			l_u.item.d := a_x.item
			if (endian_inst.little_endian_p).to_boolean then
				standardize_inst.make_double_bigendian (create {CE_POINTER [REAL_64]}.make_shared (l_u.item.c_pointer + (create {PD_U5}.make).offset_of ("d")))
			end
			if (((l_u.item.ieee.byte[7]).to_integer_32).bit_shift_right (7)).to_boolean then
				a_r___3.item.sign := 1
			else
				a_r___3.item.sign := 0
			end
			l_e := ((((((l_u.item.ieee.byte[7]).to_integer_32).bit_and (127))).bit_shift_left (4))).bit_xor ((((((l_u.item.ieee.byte[6]).to_integer_32).bit_and (240))).bit_shift_right (4)))
			a_r___3.item.exponent := l_e - 1_023
			sprint_nybble ((l_u.item.ieee.byte[6]).to_integer_32, a_r___3.item.mantissa)
			sprint_byte ((l_u.item.ieee.byte[5]).to_integer_32, a_r___3.item.mantissa + 4)
			sprint_byte ((l_u.item.ieee.byte[4]).to_integer_32, a_r___3.item.mantissa + 12)
			sprint_byte ((l_u.item.ieee.byte[3]).to_integer_32, a_r___3.item.mantissa + 20)
			sprint_byte ((l_u.item.ieee.byte[2]).to_integer_32, a_r___3.item.mantissa + 28)
			sprint_byte ((l_u.item.ieee.byte[1]).to_integer_32, a_r___3.item.mantissa + 36)
			sprint_byte ((l_u.item.ieee.byte[0]).to_integer_32, a_r___3.item.mantissa + 44)
			a_r___3.item.mantissa[52] := (('%/0/').code).to_integer_8
			if (l_u.item.ieee.byte[0]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[1]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[2]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[3]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[4]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[5]).to_boolean then
				l_tmp___0 := 1
			elseif (((l_u.item.ieee.byte[6]).to_integer_32).bit_and (15)).to_boolean then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			l_non_zero := l_tmp___0
			a_r___3.item.type := determine_ieee_type (l_non_zero, l_e, 2_047)
		end

	gsl_ieee_float_to_rep (a_x: CE_POINTER [REAL_32]; a_r___3: CE_POINTER [PD_GSL_IEEE_FLOAT_REP])
		local
			l_e: INTEGER_32
			l_non_zero: INTEGER_32
			l_u: CE_ARRAY [PD_U4]
			l_tmp___0: INTEGER_32
		do
			create l_u.make (<<1>>)

			l_u.item.f := a_x.item
			if (endian_inst.little_endian_p).to_boolean then
				standardize_inst.make_float_bigendian (create {CE_POINTER [REAL_32]}.make_shared (l_u.item.c_pointer + (create {PD_U4}.make).offset_of ("f")))
			end
			if (((l_u.item.ieee.byte[3]).to_integer_32).bit_shift_right (7)).to_boolean then
				a_r___3.item.sign := 1
			else
				a_r___3.item.sign := 0
			end
			l_e := ((((((l_u.item.ieee.byte[3]).to_integer_32).bit_and (127))).bit_shift_left (1))).bit_or ((((((l_u.item.ieee.byte[2]).to_integer_32).bit_and (128))).bit_shift_right (7)))
			a_r___3.item.exponent := l_e - 127
			sprint_byte (((((l_u.item.ieee.byte[2]).to_integer_32).bit_and (127))).bit_shift_left (1), a_r___3.item.mantissa)
			sprint_byte ((l_u.item.ieee.byte[1]).to_integer_32, a_r___3.item.mantissa + 7)
			sprint_byte ((l_u.item.ieee.byte[0]).to_integer_32, a_r___3.item.mantissa + 15)
			a_r___3.item.mantissa[23] := (('%/0/').code).to_integer_8
			if (l_u.item.ieee.byte[0]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[1]).to_boolean then
				l_tmp___0 := 1
			elseif (((l_u.item.ieee.byte[2]).to_integer_32).bit_and (127)).to_boolean then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			l_non_zero := l_tmp___0
			a_r___3.item.type := determine_ieee_type (l_non_zero, l_e, 255)
		end

	sprint_byte (a_i: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_c___1: CE_POINTER [INTEGER_8]
		do
			create l_c___1.make

			l_c___1 := nybble[(((a_i).bit_and (240))).bit_shift_right (4)]
			a_s[0] := l_c___1[0]
			a_s[1] := l_c___1[1]
			a_s[2] := l_c___1[2]
			a_s[3] := l_c___1[3]
			l_c___1 := nybble[(a_i).bit_and (15)]
			a_s[4] := l_c___1[0]
			a_s[5] := l_c___1[1]
			a_s[6] := l_c___1[2]
			a_s[7] := l_c___1[3]
		end

	sprint_nybble (a_i: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_c___1: CE_POINTER [INTEGER_8]
		do
			create l_c___1.make

			l_c___1 := nybble[(a_i).bit_and (15)]
			a_s[0] := l_c___1[0]
			a_s[1] := l_c___1[1]
			a_s[2] := l_c___1[2]
			a_s[3] := l_c___1[3]
		end

end
