class
	P_MATHIEU_CHARV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	approx_c (a_order: INTEGER_32; a_qq: REAL_64): REAL_64
		local
			l_approx: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_n2: REAL_64
			l_n22: REAL_64
			l_q2___0: REAL_64
			l_q4: REAL_64
			l_tmp___9: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_order < 0 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("Undefined order for Mathieu function"), ce_string ("mathieu_charv.c"), 213, 4)
							Result := (0.0)
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						inspect a_order -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 0
						if a_qq <= (4).to_double then
							Result := ((2).to_double - (sqrt ((4).to_double + ((2).to_double * a_qq) * a_qq)))
							js.return
						else
							Result := (asymptotic (a_order, a_qq))
							js.return
						end
						l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 1
						if a_qq <= (4).to_double then
							Result := ((5).to_double + 0.5 * (a_qq - (sqrt ((((5).to_double * a_qq) * a_qq - (16).to_double * a_qq) + (64).to_double))))
							js.return
						else
							Result := (asymptotic (a_order, a_qq))
							js.return
						end
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 2
						if a_qq <= (3).to_double then
							l_c2___0 := -8.0
							l_c1___2 := (-48).to_double - ((3).to_double * a_qq) * a_qq
							l_c0___0 := ((20).to_double * a_qq) * a_qq
						else
							Result := (asymptotic (a_order, a_qq))
							js.return
						end
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 3
						if a_qq <= 6.25 then
							l_c2___0 := -a_qq - (8).to_double
							l_c1___2 := ((16).to_double * a_qq - (128).to_double) - ((2).to_double * a_qq) * a_qq
							l_c0___0 := (a_qq * a_qq) * (a_qq + (8).to_double)
						else
							Result := (asymptotic (a_order, a_qq))
							js.return
						end
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						if a_order < 70 then
							if 1.7 * a_order.to_double > (2).to_double * (sqrt (a_qq)) then
								l_n2 := (a_order * a_order).to_double
								l_n22 := (l_n2 - (1).to_double) * (l_n2 - (1).to_double)
								l_q2___0 := a_qq * a_qq
								l_q4 := l_q2___0 * l_q2___0
								l_approx := l_n2 + (0.5 * l_q2___0) / (l_n2 - (1).to_double)
								l_approx := l_approx + ((((5).to_double * l_n2 + (7).to_double) * l_q4) / ((((32).to_double * l_n22) * (l_n2 - (1).to_double)) * (l_n2 - (4).to_double)))
								l_approx := l_approx + (((((((9).to_double * l_n2) * l_n2 + (58).to_double * l_n2) + (29).to_double) * l_q4) * l_q2___0) / ((((((64).to_double * l_n22) * l_n22) * (l_n2 - (1).to_double)) * (l_n2 - (4).to_double)) * (l_n2 - (9).to_double)))
								if 1.4 * a_order.to_double < (2).to_double * (sqrt (a_qq)) then
									l_approx := l_approx + (asymptotic (a_order, a_qq))
									l_approx := l_approx * (0.5)
								end
							else
								l_approx := asymptotic (a_order, a_qq)
							end
							Result := l_approx
							js.return
						else
							Result := (a_order * a_order).to_double
							js.return
						end
				when 7 then -- switch 1, done: | if done
						if not js.return_called then
							l_approx := solve_cubic (l_c2___0, l_c1___2, l_c0___0)
							if l_approx < (0).to_double then
								if (sqrt (a_qq)) > 0.1 * a_order.to_double then
									Result := (asymptotic (a_order - 1, a_qq))
								else
									l_tmp___9 := fabs (l_approx)
									Result := ((a_order * a_order).to_double + l_tmp___9)
								end
							else
								l_tmp___9 := fabs (l_approx)
								Result := ((a_order * a_order).to_double + l_tmp___9)
							end
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	approx_s (a_order: INTEGER_32; a_qq: REAL_64): REAL_64
		local
			l_approx: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_n2: REAL_64
			l_n22: REAL_64
			l_q2___0: REAL_64
			l_q4: REAL_64
			l_tmp___8: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_order < 1 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("Undefined order for Mathieu function"), ce_string ("mathieu_charv.c"), 301, 4)
							Result := (0.0)
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						inspect a_order -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 1
						if a_qq <= (4).to_double then
							Result := ((5).to_double - 0.5 * (a_qq + (sqrt ((((5).to_double * a_qq) * a_qq + (16).to_double * a_qq) + (64).to_double))))
							js.return
						else
							Result := (asymptotic (a_order - 1, a_qq))
							js.return
						end
						l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
						if a_qq <= (5).to_double then
							Result := ((10).to_double - (sqrt ((36).to_double + a_qq * a_qq)))
							js.return
						else
							Result := (asymptotic (a_order - 1, a_qq))
							js.return
						end
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 3
						if a_qq <= 6.25 then
							l_c2___0 := a_qq - (8).to_double
							l_c1___2 := ((-128).to_double - (16).to_double * a_qq) - ((2).to_double * a_qq) * a_qq
							l_c0___0 := (a_qq * a_qq) * ((8).to_double - a_qq)
						else
							Result := (asymptotic (a_order - 1, a_qq))
							js.return
						end
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
						if a_order < 70 then
							if 1.7 * a_order.to_double > (2).to_double * (sqrt (a_qq)) then
								l_n2 := (a_order * a_order).to_double
								l_n22 := (l_n2 - (1).to_double) * (l_n2 - (1).to_double)
								l_q2___0 := a_qq * a_qq
								l_q4 := l_q2___0 * l_q2___0
								l_approx := l_n2 + (0.5 * l_q2___0) / (l_n2 - (1).to_double)
								l_approx := l_approx + ((((5).to_double * l_n2 + (7).to_double) * l_q4) / ((((32).to_double * l_n22) * (l_n2 - (1).to_double)) * (l_n2 - (4).to_double)))
								l_approx := l_approx + (((((((9).to_double * l_n2) * l_n2 + (58).to_double * l_n2) + (29).to_double) * l_q4) * l_q2___0) / ((((((64).to_double * l_n22) * l_n22) * (l_n2 - (1).to_double)) * (l_n2 - (4).to_double)) * (l_n2 - (9).to_double)))
								if 1.4 * a_order.to_double < (2).to_double * (sqrt (a_qq)) then
									l_approx := l_approx + (asymptotic (a_order - 1, a_qq))
									l_approx := l_approx * (0.5)
								end
							else
								l_approx := asymptotic (a_order - 1, a_qq)
							end
							Result := l_approx
							js.return
						else
							Result := (a_order * a_order).to_double
							js.return
						end
				when 6 then -- switch 1, done: | if done
						if not js.return_called then
							l_approx := solve_cubic (l_c2___0, l_c1___2, l_c0___0)
							if l_approx < (0).to_double then
								if (sqrt (a_qq)) > 0.1 * a_order.to_double then
									Result := (asymptotic (a_order - 1, a_qq))
								else
									l_tmp___8 := fabs (l_approx)
									Result := ((a_order * a_order).to_double + l_tmp___8)
								end
							else
								l_tmp___8 := fabs (l_approx)
								Result := ((a_order * a_order).to_double + l_tmp___8)
							end
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	asymptotic (a_order: INTEGER_32; a_qq: REAL_64): REAL_64
		local
			l_asymp: REAL_64
			l_nn: REAL_64
			l_n2: REAL_64
			l_n4: REAL_64
			l_n6: REAL_64
			l_hh: REAL_64
			l_ah___2: REAL_64
			l_ah2: REAL_64
			l_ah3: REAL_64
			l_ah4: REAL_64
			l_ah5: REAL_64
		do
			l_nn := (2 * a_order + 1).to_double
			l_n2 := l_nn * l_nn
			l_n4 := l_n2 * l_n2
			l_n6 := l_n4 * l_n2
			l_hh := (2).to_double * (sqrt (a_qq))
			l_ah___2 := (16).to_double * l_hh
			l_ah2 := l_ah___2 * l_ah___2
			l_ah3 := l_ah2 * l_ah___2
			l_ah4 := l_ah3 * l_ah___2
			l_ah5 := l_ah4 * l_ah___2
			l_asymp := ((-2).to_double * a_qq + l_nn * l_hh) - 0.125 * (l_n2 + (1).to_double)
			l_asymp := l_asymp - (((0.25 * l_nn) * (l_n2 + (3).to_double)) / l_ah___2)
			l_asymp := l_asymp - ((0.25 * (((5).to_double * l_n4 + (34).to_double * l_n2) + (9).to_double)) / l_ah2)
			l_asymp := l_asymp - (((0.25 * l_nn) * (((33).to_double * l_n4 + (410).to_double * l_n2) + (405).to_double)) / l_ah3)
			l_asymp := l_asymp - (((((63).to_double * l_n6 + (1_260).to_double * l_n4) + (2_943).to_double * l_n2) + (486).to_double) / l_ah4)
			l_asymp := l_asymp - ((l_nn * ((((527).to_double * l_n6 + (15_617).to_double * l_n4) + (69_001).to_double * l_n2) + (41_607).to_double)) / l_ah5)
			Result := l_asymp
		end

	ceer (a_order: INTEGER_32; a_qq: REAL_64; a_aa: REAL_64; a_nterms: INTEGER_32): REAL_64
		local
			l_term: REAL_64
			l_term1: REAL_64
			l_ii: INTEGER_32
			l_n1: INTEGER_32
		do
			if a_order = 0 then
				l_term := 0.0
			else
				l_term := ((2.0 * a_qq) * a_qq) / a_aa
				if a_order /= 2 then
					l_n1 := a_order // 2 - 1
					l_ii := 0
					from
					until
						not (l_ii < l_n1)
					loop
						l_term := (a_qq * a_qq) / ((a_aa - (4.0 * (l_ii + 1).to_double) * (l_ii + 1).to_double) - l_term)
						l_ii := l_ii + 1
					end
				end
			end
			l_term := l_term + (a_order * a_order).to_double
			l_term1 := 0.0
			l_ii := 0
			from
			until
				not (l_ii < a_nterms)
			loop
				l_term1 := (a_qq * a_qq) / ((a_aa - (a_order.to_double + 2.0 * (a_nterms - l_ii).to_double) * (a_order.to_double + 2.0 * (a_nterms - l_ii).to_double)) - l_term1)
				l_ii := l_ii + 1
			end
			if a_order = 0 then
				l_term1 := l_term1 * (2.0)
			end
			Result := ((l_term + l_term1) - a_aa)
		end

	ceor (a_order: INTEGER_32; a_qq: REAL_64; a_aa: REAL_64; a_nterms: INTEGER_32): REAL_64
		local
			l_term: REAL_64
			l_term1: REAL_64
			l_ii: INTEGER_32
			l_n1: INTEGER_32
		do
			l_term := a_qq
			l_n1 := ((a_order.to_real).to_double / 2.0 - 0.5).truncated_to_integer
			l_ii := 0
			from
			until
				not (l_ii < l_n1)
			loop
				l_term := (a_qq * a_qq) / ((a_aa - (2.0 * l_ii.to_double + 1.0) * (2.0 * l_ii.to_double + 1.0)) - l_term)
				l_ii := l_ii + 1
			end
			l_term := l_term + (a_order * a_order).to_double
			l_term1 := 0.0
			l_ii := 0
			from
			until
				not (l_ii < a_nterms)
			loop
				l_term1 := (a_qq * a_qq) / ((a_aa - (a_order.to_double + 2.0 * (a_nterms - l_ii).to_double) * (a_order.to_double + 2.0 * (a_nterms - l_ii).to_double)) - l_term1)
				l_ii := l_ii + 1
			end
			Result := ((l_term + l_term1) - a_aa)
		end

	figi (a_nn: INTEGER_32; a_tt: CE_POINTER [REAL_64]; a_dd: CE_POINTER [REAL_64]; a_ee: CE_POINTER [REAL_64]; a_e2: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_ii: INTEGER_32
			js: JUMP_STATE
		do
			l_ii := 0
			from
			until
				not (not js.loop_done and then (l_ii < a_nn))
			loop
				if l_ii /= 0 then
					a_e2[l_ii] := a_tt[3 * l_ii] * a_tt[(3 * (l_ii - 1) + 2)]
					if a_e2[l_ii] < 0.0 then
						Result := (a_nn + l_ii)
						js.return
					end
					if not js.return_called and then (a_e2[l_ii] = 0.0) then
						if a_tt[3 * l_ii] /= 0.0 then
							Result := (-1 * (3 * a_nn + l_ii))
							js.return
						elseif a_tt[(3 * (l_ii - 1) + 2)] /= 0.0 then
							Result := (-1 * (3 * a_nn + l_ii))
							js.return
						end
					end
					if not js.return_called then
						a_ee[l_ii] := sqrt (a_e2[l_ii])
					end
				end
				if not js.return_called then
					a_dd[l_ii] := a_tt[(3 * l_ii + 1)]
					l_ii := l_ii + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_mathieu_a (a_order: INTEGER_32; a_qq: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_order: INTEGER_32
			l_even_odd: INTEGER_32
			l_nterms: INTEGER_32
			l_ii: INTEGER_32
			l_counter: INTEGER_32
			l_maxcount: INTEGER_32
			l_dir: INTEGER_32
			l_a1___4: REAL_64
			l_a2___3: REAL_64
			l_fa: REAL_64
			l_fa1: REAL_64
			l_dela: REAL_64
			l_aa_orig: REAL_64
			l_da: REAL_64
			l_aa: REAL_64
			l_aa_approx: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_order := a_order
					l_nterms := 50
					l_counter := 0
					l_maxcount := 1_000
					l_dir := 0
					l_da := 0.025
					l_even_odd := 0
					if l_order \\ 2 /= 0 then
						l_even_odd := 1
					end
					if a_qq = (0).to_double then
						a_result.item.val := (l_order * l_order).to_double
						a_result.item.err := 0.0
						Result := 0
						js.return
					end
					if not js.return_called then
						if l_order < 0 then
							l_order := l_order * (-1)
						end
						if a_qq < 0.0 then
							if l_even_odd = 0 then
								Result := (gsl_sf_mathieu_a (l_order, -a_qq, a_result))
								js.return
							else
								Result := (gsl_sf_mathieu_b (l_order, -a_qq, a_result))
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_aa_approx := approx_c (l_order, a_qq)
						l_aa := l_aa_approx
						l_aa_orig := l_aa
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_counter < l_maxcount)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						l_a1___4 := l_aa + 0.001
						l_ii := 0
						if l_even_odd = 0 then
							l_fa1 := ceer (l_order, a_qq, l_a1___4, l_nterms)
						else
							l_fa1 := ceor (l_order, a_qq, l_a1___4, l_nterms)
						end
						from
						until
							js.loop_done
						loop
							if l_even_odd = 0 then
								l_fa := ceer (l_order, a_qq, l_aa, l_nterms)
							else
								l_fa := ceor (l_order, a_qq, l_aa, l_nterms)
							end
							l_a2___3 := l_a1___4
							l_a1___4 := l_aa
							if l_fa = l_fa1 then
								a_result.item.err := 2.2204460492503131e-16
								js.break
							end
							if not js.loop_jumped then
								l_aa := l_aa - (((l_aa - l_a2___3) / (l_fa - l_fa1)) * l_fa)
								l_dela := fabs (l_aa - l_a2___3)
								if l_dela < 2.2204460492503131e-16 then
									a_result.item.err := 2.2204460492503131e-16
									js.break
								end
							end
							if not js.loop_jumped and then (l_ii > 40) then
								a_result.item.err := l_dela
								js.break
							end
							if not js.loop_jumped then
								l_fa1 := l_fa
								l_ii := l_ii + 1
							end
						end
						l_tmp___1 := fabs (l_aa - l_aa_orig)
						if not (l_tmp___1 > (3).to_double + (0.01 * l_order.to_double) * (fabs (l_aa_orig))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (l_order > 10) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if not ((fabs (l_aa - l_aa_orig)) > 1.5 * l_order.to_double) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_counter := l_counter + 1
						if l_counter = l_maxcount then
							a_result.item.err := fabs (l_aa - l_aa_orig)
							js.break
						end
						if not js.loop_jumped then
							if l_aa > l_aa_orig then
								if l_dir = 1 then
									l_da := l_da / (2).to_double
								end
								l_dir := -1
							else
								if l_dir = -1 then
									l_da := l_da / (2).to_double
								end
								l_dir := 1
							end
							l_aa_approx := l_aa_approx + ((l_dir.to_double * l_da) * l_counter.to_double)
							l_aa := l_aa_approx
							js.continue
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						js.break
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						js.break
				when 13 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						a_result.item.val := l_aa
						if l_counter = l_maxcount then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("Wrong characteristic Mathieu value"), ce_string ("mathieu_charv.c"), 489, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
				when 15 then -- if done
					if not js.return_called then
						Result := 0
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_mathieu_a_array (a_order_min: INTEGER_32; a_order_max: INTEGER_32; a_qq: REAL_64; a_work: CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_even_order: NATURAL_32
			l_odd_order: NATURAL_32
			l_extra_values: NATURAL_32
			l_ii: NATURAL_32
			l_jj: NATURAL_32
			l_status: INTEGER_32
			l_tt: CE_POINTER [REAL_64]
			l_dd: CE_POINTER [REAL_64]
			l_ee: CE_POINTER [REAL_64]
			l_e2: CE_POINTER [REAL_64]
			l_zz: CE_POINTER [REAL_64]
			l_aa: CE_POINTER [REAL_64]
			l_mat: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_evec: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_eval: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_wmat: CE_POINTER [PD_GSL_EIGEN_SYMMV_WORKSPACE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tt.make
			create l_dd.make
			create l_ee.make
			create l_e2.make
			create l_zz.make
			create l_aa.make
			create l_mat.make (<<1>>)
			create l_evec.make (<<1>>)
			create l_eval.make (<<1>>)
			create l_wmat.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_even_order := a_work.item.even_order
					l_odd_order := a_work.item.odd_order
					l_extra_values := (a_work.item.extra_values).to_natural_32
					l_tt := a_work.item.tt
					l_dd := a_work.item.dd
					l_ee := a_work.item.ee
					l_e2 := a_work.item.e2
					l_zz := a_work.item.zz
					l_aa := a_work.item.aa
					l_wmat := a_work.item.wmat
					if not (a_order_max.to_natural_32 > a_work.item.size) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if not (a_order_max <= a_order_min) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not (a_order_min < 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("invalid range [order_min,order_max]"), ce_string ("mathieu_charv.c"), 723, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if done | if done
						if not js.return_called then
							l_tt[0] := 0.0
							l_tt[1] := 0.0
							l_tt[2] := a_qq
							l_ii := {NATURAL_32} 1
							from
							until
								not (l_ii < l_even_order - {NATURAL_32} 1)
							loop
								l_tt[({NATURAL_32} 3 * l_ii).to_integer_32] := a_qq
								l_tt[({NATURAL_32} 3 * l_ii + {NATURAL_32} 1).to_integer_32] := (({NATURAL_32} 4 * l_ii) * l_ii).to_real_64
								l_tt[({NATURAL_32} 3 * l_ii + {NATURAL_32} 2).to_integer_32] := a_qq
								l_ii := l_ii + 1
							end
							l_tt[({NATURAL_32} 3 * l_even_order - {NATURAL_32} 3).to_integer_32] := a_qq
							l_tt[({NATURAL_32} 3 * l_even_order - {NATURAL_32} 2).to_integer_32] := (({NATURAL_32} 4 * (l_even_order - {NATURAL_32} 1)) * (l_even_order - {NATURAL_32} 1)).to_real_64
							l_tt[({NATURAL_32} 3 * l_even_order - {NATURAL_32} 1).to_integer_32] := 0.0
							l_tt[3] := l_tt[3] * (2).to_double
							l_status := figi (l_even_order.to_integer_32, l_tt, l_dd, l_ee, l_e2)
							if l_status.to_boolean then
								from
								until
									js.loop_done
								loop
									error_inst.gsl_error (ce_string ("Internal error in tridiagonal Mathieu matrix"), ce_string ("mathieu_charv.c"), 748, 5)
									Result := 5
									js.return
									if not js.return_called then
										js.break
									end
								end
							end
						end
						if not js.return_called then
							l_ii := {NATURAL_32} 0
							from
							until
								not (l_ii < l_even_order * l_even_order)
							loop
								l_zz[l_ii.to_integer_32] := 0.0
								l_ii := l_ii + 1
							end
							l_zz[0] := l_dd[0]
							l_zz[1] := l_ee[1]
							l_ii := {NATURAL_32} 1
							from
							until
								not (l_ii < l_even_order - {NATURAL_32} 1)
							loop
								l_zz[((l_ii * l_even_order + l_ii) - {NATURAL_32} 1).to_integer_32] := l_ee[l_ii.to_integer_32]
								l_zz[(l_ii * l_even_order + l_ii).to_integer_32] := l_dd[l_ii.to_integer_32]
								l_zz[((l_ii * l_even_order + l_ii) + {NATURAL_32} 1).to_integer_32] := l_ee[(l_ii + {NATURAL_32} 1).to_integer_32]
								l_ii := l_ii + 1
							end
							l_zz[((l_even_order * (l_even_order - {NATURAL_32} 1) + l_even_order) - {NATURAL_32} 2).to_integer_32] := l_ee[(l_even_order - {NATURAL_32} 1).to_integer_32]
							l_zz[(l_even_order * l_even_order - {NATURAL_32} 1).to_integer_32] := l_dd[(l_even_order - {NATURAL_32} 1).to_integer_32]
							l_mat.item := (view_source_inst.gsl_matrix_view_array (l_zz, l_even_order, l_even_order)).twin
							l_eval.item := (subvector_source_inst.gsl_vector_subvector (a_work.item.eval, (0).to_natural_32, l_even_order)).twin
							l_evec.item := (submatrix_source_inst.gsl_matrix_submatrix (a_work.item.evec, (0).to_natural_32, (0).to_natural_32, l_even_order, l_even_order)).twin
							symmv_inst.gsl_eigen_symmv (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_mat.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_evec.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), l_wmat).do_nothing
							sort_inst.gsl_eigen_symmv_sort (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_evec.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), {PC_GSL_EIGEN_SORT_T}.GSL_EIGEN_SORT_VAL_ASC).do_nothing
							l_ii := {NATURAL_32} 0
							from
							until
								not (l_ii < l_even_order - l_extra_values)
							loop
								l_aa[({NATURAL_32} 2 * l_ii).to_integer_32] := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_ii)
								l_ii := l_ii + 1
							end
							l_ii := {NATURAL_32} 0
							from
							until
								not (l_ii < l_odd_order * l_odd_order)
							loop
								l_zz[l_ii.to_integer_32] := 0.0
								l_ii := l_ii + 1
							end
							l_ii := {NATURAL_32} 0
							from
							until
								not (not js.loop_done and then (l_ii < l_odd_order))
							loop
								l_jj := {NATURAL_32} 0
								from
								until
									not (l_jj < l_odd_order)
								loop
									if l_ii = l_jj then
										l_zz[(l_ii * l_odd_order + l_jj).to_integer_32] := (({NATURAL_32} 2 * l_ii + {NATURAL_32} 1) * ({NATURAL_32} 2 * l_ii + {NATURAL_32} 1)).to_real_64
									elseif l_ii = l_jj + {NATURAL_32} 1 then
										l_zz[(l_ii * l_odd_order + l_jj).to_integer_32] := a_qq
									elseif l_ii + {NATURAL_32} 1 = l_jj then
										l_zz[(l_ii * l_odd_order + l_jj).to_integer_32] := a_qq
									end
									l_jj := l_jj + 1
								end
								l_ii := l_ii + 1
							end
							l_zz[0] := l_zz[0] + a_qq
							l_mat.item := (view_source_inst.gsl_matrix_view_array (l_zz, l_odd_order, l_odd_order)).twin
							l_eval.item := (subvector_source_inst.gsl_vector_subvector (a_work.item.eval, (0).to_natural_32, l_odd_order)).twin
							l_evec.item := (submatrix_source_inst.gsl_matrix_submatrix (a_work.item.evec, (0).to_natural_32, (0).to_natural_32, l_odd_order, l_odd_order)).twin
							symmv_inst.gsl_eigen_symmv (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_mat.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_evec.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), l_wmat).do_nothing
							sort_inst.gsl_eigen_symmv_sort (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_evec.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), {PC_GSL_EIGEN_SORT_T}.GSL_EIGEN_SORT_VAL_ASC).do_nothing
							l_ii := {NATURAL_32} 0
							from
							until
								not (l_ii < l_odd_order - l_extra_values)
							loop
								l_aa[({NATURAL_32} 2 * l_ii + {NATURAL_32} 1).to_integer_32] := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_ii)
								l_ii := l_ii + 1
							end
							l_ii := a_order_min.to_natural_32
							from
							until
								not (l_ii <= a_order_max.to_natural_32)
							loop
								a_result_array[(l_ii - a_order_min.to_natural_32).to_integer_32] := l_aa[l_ii.to_integer_32]
								l_ii := l_ii + 1
							end
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_mathieu_b (a_order: INTEGER_32; a_qq: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_order: INTEGER_32
			l_even_odd: INTEGER_32
			l_nterms: INTEGER_32
			l_ii: INTEGER_32
			l_counter: INTEGER_32
			l_maxcount: INTEGER_32
			l_dir: INTEGER_32
			l_a1___4: REAL_64
			l_a2___3: REAL_64
			l_fa: REAL_64
			l_fa1: REAL_64
			l_dela: REAL_64
			l_aa_orig: REAL_64
			l_da: REAL_64
			l_aa: REAL_64
			l_aa_approx: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_order := a_order
					l_nterms := 50
					l_counter := 0
					l_maxcount := 1_000
					l_dir := 0
					l_da := 0.025
					l_even_odd := 0
					if l_order \\ 2 /= 0 then
						l_even_odd := 1
					end
					if l_order = 0 then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("Characteristic value undefined for order 0"), ce_string ("mathieu_charv.c"), 511, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called and then (a_qq = (0).to_double) then
						a_result.item.val := (l_order * l_order).to_double
						a_result.item.err := 0.0
						Result := 0
						js.return
					end
					if not js.return_called then
						if l_order < 0 then
							l_order := l_order * (-1)
						end
						if a_qq < 0.0 then
							if l_even_odd = 0 then
								Result := (gsl_sf_mathieu_b (l_order, -a_qq, a_result))
								js.return
							else
								Result := (gsl_sf_mathieu_a (l_order, -a_qq, a_result))
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_aa_approx := approx_s (l_order, a_qq)
						l_aa := l_aa_approx
						l_aa_orig := l_aa
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_counter < l_maxcount)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						l_a1___4 := l_aa + 0.001
						l_ii := 0
						if l_even_odd = 0 then
							l_fa1 := seer (l_order, a_qq, l_a1___4, l_nterms)
						else
							l_fa1 := seor (l_order, a_qq, l_a1___4, l_nterms)
						end
						from
						until
							js.loop_done
						loop
							if l_even_odd = 0 then
								l_fa := seer (l_order, a_qq, l_aa, l_nterms)
							else
								l_fa := seor (l_order, a_qq, l_aa, l_nterms)
							end
							l_a2___3 := l_a1___4
							l_a1___4 := l_aa
							if l_fa = l_fa1 then
								a_result.item.err := 2.2204460492503131e-16
								js.break
							end
							if not js.loop_jumped then
								l_aa := l_aa - (((l_aa - l_a2___3) / (l_fa - l_fa1)) * l_fa)
								l_dela := fabs (l_aa - l_a2___3)
								if l_dela < 1.e-18 then
									a_result.item.err := 2.2204460492503131e-16
									js.break
								end
							end
							if not js.loop_jumped and then (l_ii > 40) then
								a_result.item.err := l_dela
								js.break
							end
							if not js.loop_jumped then
								l_fa1 := l_fa
								l_ii := l_ii + 1
							end
						end
						l_tmp___1 := fabs (l_aa - l_aa_orig)
						if not (l_tmp___1 > (3).to_double + (0.01 * l_order.to_double) * (fabs (l_aa_orig))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (l_order > 10) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if not ((fabs (l_aa - l_aa_orig)) > 1.5 * l_order.to_double) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_counter := l_counter + 1
						if l_counter = l_maxcount then
							a_result.item.err := fabs (l_aa - l_aa_orig)
							js.break
						end
						if not js.loop_jumped then
							if l_aa > l_aa_orig then
								if l_dir = 1 then
									l_da := l_da / (2).to_double
								end
								l_dir := -1
							else
								if l_dir = -1 then
									l_da := l_da / (2).to_double
								end
								l_dir := 1
							end
							l_aa_approx := l_aa_approx + ((l_dir.to_double * l_da) * l_counter.to_double)
							l_aa := l_aa_approx
							js.continue
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						js.break
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						js.break
				when 13 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						a_result.item.val := l_aa
						if l_counter = l_maxcount then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("Wrong characteristic Mathieu value"), ce_string ("mathieu_charv.c"), 621, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
						end
				when 15 then -- if done
					if not js.return_called then
						Result := 0
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_mathieu_b_array (a_order_min: INTEGER_32; a_order_max: INTEGER_32; a_qq: REAL_64; a_work: CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_even_order: NATURAL_32
			l_odd_order: NATURAL_32
			l_extra_values: NATURAL_32
			l_ii: NATURAL_32
			l_jj: NATURAL_32
			l_zz: CE_POINTER [REAL_64]
			l_bb: CE_POINTER [REAL_64]
			l_mat: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_evec: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_eval: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_wmat: CE_POINTER [PD_GSL_EIGEN_SYMMV_WORKSPACE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_zz.make
			create l_bb.make
			create l_mat.make (<<1>>)
			create l_evec.make (<<1>>)
			create l_eval.make (<<1>>)
			create l_wmat.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_even_order := a_work.item.even_order - {NATURAL_32} 1
					l_odd_order := a_work.item.odd_order
					l_extra_values := (a_work.item.extra_values).to_natural_32
					l_zz := a_work.item.zz
					l_bb := a_work.item.bb
					l_wmat := a_work.item.wmat
					if not (a_order_max.to_natural_32 > a_work.item.size) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if not (a_order_max <= a_order_min) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not (a_order_min < 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("invalid range [order_min,order_max]"), ce_string ("mathieu_charv.c"), 819, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if done | if done
						if not js.return_called then
							l_ii := {NATURAL_32} 0
							from
							until
								not (l_ii < l_even_order * l_even_order)
							loop
								l_zz[l_ii.to_integer_32] := 0.0
								l_ii := l_ii + 1
							end
							l_ii := {NATURAL_32} 0
							from
							until
								not (not js.loop_done and then (l_ii < l_even_order))
							loop
								l_jj := {NATURAL_32} 0
								from
								until
									not (l_jj < l_even_order)
								loop
									if l_ii = l_jj then
										l_zz[(l_ii * l_even_order + l_jj).to_integer_32] := (({NATURAL_32} 4 * (l_ii + {NATURAL_32} 1)) * (l_ii + {NATURAL_32} 1)).to_real_64
									elseif l_ii = l_jj + {NATURAL_32} 1 then
										l_zz[(l_ii * l_even_order + l_jj).to_integer_32] := a_qq
									elseif l_ii + {NATURAL_32} 1 = l_jj then
										l_zz[(l_ii * l_even_order + l_jj).to_integer_32] := a_qq
									end
									l_jj := l_jj + 1
								end
								l_ii := l_ii + 1
							end
							l_mat.item := (view_source_inst.gsl_matrix_view_array (l_zz, l_even_order, l_even_order)).twin
							l_eval.item := (subvector_source_inst.gsl_vector_subvector (a_work.item.eval, (0).to_natural_32, l_even_order)).twin
							l_evec.item := (submatrix_source_inst.gsl_matrix_submatrix (a_work.item.evec, (0).to_natural_32, (0).to_natural_32, l_even_order, l_even_order)).twin
							symmv_inst.gsl_eigen_symmv (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_mat.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_evec.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), l_wmat).do_nothing
							sort_inst.gsl_eigen_symmv_sort (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_evec.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), {PC_GSL_EIGEN_SORT_T}.GSL_EIGEN_SORT_VAL_ASC).do_nothing
							l_bb[0] := 0.0
							l_ii := {NATURAL_32} 0
							from
							until
								not (l_ii < l_even_order - l_extra_values)
							loop
								l_bb[({NATURAL_32} 2 * (l_ii + {NATURAL_32} 1)).to_integer_32] := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_ii)
								l_ii := l_ii + 1
							end
							l_ii := {NATURAL_32} 0
							from
							until
								not (l_ii < l_odd_order * l_odd_order)
							loop
								l_zz[l_ii.to_integer_32] := 0.0
								l_ii := l_ii + 1
							end
							l_ii := {NATURAL_32} 0
							from
							until
								not (not js.loop_done and then (l_ii < l_odd_order))
							loop
								l_jj := {NATURAL_32} 0
								from
								until
									not (l_jj < l_odd_order)
								loop
									if l_ii = l_jj then
										l_zz[(l_ii * l_odd_order + l_jj).to_integer_32] := (({NATURAL_32} 2 * l_ii + {NATURAL_32} 1) * ({NATURAL_32} 2 * l_ii + {NATURAL_32} 1)).to_real_64
									elseif l_ii = l_jj + {NATURAL_32} 1 then
										l_zz[(l_ii * l_odd_order + l_jj).to_integer_32] := a_qq
									elseif l_ii + {NATURAL_32} 1 = l_jj then
										l_zz[(l_ii * l_odd_order + l_jj).to_integer_32] := a_qq
									end
									l_jj := l_jj + 1
								end
								l_ii := l_ii + 1
							end
							l_zz[0] := l_zz[0] - a_qq
							l_mat.item := (view_source_inst.gsl_matrix_view_array (l_zz, l_odd_order, l_odd_order)).twin
							l_eval.item := (subvector_source_inst.gsl_vector_subvector (a_work.item.eval, (0).to_natural_32, l_odd_order)).twin
							l_evec.item := (submatrix_source_inst.gsl_matrix_submatrix (a_work.item.evec, (0).to_natural_32, (0).to_natural_32, l_odd_order, l_odd_order)).twin
							symmv_inst.gsl_eigen_symmv (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_mat.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_evec.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), l_wmat).do_nothing
							sort_inst.gsl_eigen_symmv_sort (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_evec.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), {PC_GSL_EIGEN_SORT_T}.GSL_EIGEN_SORT_VAL_ASC).do_nothing
							l_ii := {NATURAL_32} 0
							from
							until
								not (l_ii < l_odd_order - l_extra_values)
							loop
								l_bb[({NATURAL_32} 2 * l_ii + {NATURAL_32} 1).to_integer_32] := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_eval.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), l_ii)
								l_ii := l_ii + 1
							end
							l_ii := a_order_min.to_natural_32
							from
							until
								not (l_ii <= a_order_max.to_natural_32)
							loop
								a_result_array[(l_ii - a_order_min.to_natural_32).to_integer_32] := l_bb[l_ii.to_integer_32]
								l_ii := l_ii + 1
							end
							Result := 0
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	seer (a_order: INTEGER_32; a_qq: REAL_64; a_aa: REAL_64; a_nterms: INTEGER_32): REAL_64
		local
			l_term: REAL_64
			l_term1: REAL_64
			l_ii: INTEGER_32
			l_n1: INTEGER_32
		do
			l_term := 0.0
			l_n1 := a_order // 2 - 1
			l_ii := 0
			from
			until
				not (l_ii < l_n1)
			loop
				l_term := (a_qq * a_qq) / ((a_aa - (4.0 * (l_ii + 1).to_double) * (l_ii + 1).to_double) - l_term)
				l_ii := l_ii + 1
			end
			l_term := l_term + (a_order * a_order).to_double
			l_term1 := 0.0
			l_ii := 0
			from
			until
				not (l_ii < a_nterms)
			loop
				l_term1 := (a_qq * a_qq) / ((a_aa - (a_order.to_double + 2.0 * (a_nterms - l_ii).to_double) * (a_order.to_double + 2.0 * (a_nterms - l_ii).to_double)) - l_term1)
				l_ii := l_ii + 1
			end
			Result := ((l_term + l_term1) - a_aa)
		end

	seor (a_order: INTEGER_32; a_qq: REAL_64; a_aa: REAL_64; a_nterms: INTEGER_32): REAL_64
		local
			l_term: REAL_64
			l_term1: REAL_64
			l_ii: INTEGER_32
			l_n1: INTEGER_32
		do
			l_term := -1.0 * a_qq
			l_n1 := ((a_order.to_real).to_double / 2.0 - 0.5).truncated_to_integer
			l_ii := 0
			from
			until
				not (l_ii < l_n1)
			loop
				l_term := (a_qq * a_qq) / ((a_aa - (2.0 * l_ii.to_double + 1.0) * (2.0 * l_ii.to_double + 1.0)) - l_term)
				l_ii := l_ii + 1
			end
			l_term := l_term + (a_order * a_order).to_double
			l_term1 := 0.0
			l_ii := 0
			from
			until
				not (l_ii < a_nterms)
			loop
				l_term1 := (a_qq * a_qq) / ((a_aa - (a_order.to_double + 2.0 * (a_nterms - l_ii).to_double) * (a_order.to_double + 2.0 * (a_nterms - l_ii).to_double)) - l_term1)
				l_ii := l_ii + 1
			end
			Result := ((l_term + l_term1) - a_aa)
		end

	solve_cubic (a_c2___0: REAL_64; a_c1___2: REAL_64; a_c0___0: REAL_64): REAL_64
		local
			l_qq: REAL_64
			l_rr: REAL_64
			l_ww: REAL_64
			l_ss: REAL_64
			l_tt: REAL_64
			l_t1: REAL_64
			l_tmp___0: REAL_64
			l_tmp___4: REAL_64
			l_theta: REAL_64
			l_tmp___9: REAL_64
		do
			l_qq := ((3).to_double * a_c1___2 - a_c2___0 * a_c2___0) / (9).to_double
			l_rr := ((((9).to_double * a_c2___0) * a_c1___2 - (27).to_double * a_c0___0) - (((2).to_double * a_c2___0) * a_c2___0) * a_c2___0) / (54).to_double
			l_ww := (l_qq * l_qq) * l_qq + l_rr * l_rr
			if l_ww >= (0).to_double then
				l_t1 := l_rr + (sqrt (l_ww))
				l_tmp___0 := fabs (l_t1)
				l_ss := (l_tmp___0 / l_t1) * (pow ((fabs (l_t1)), (1).to_double / 3.))
				l_t1 := l_rr - (sqrt (l_ww))
				l_tmp___4 := fabs (l_t1)
				l_tt := (l_tmp___4 / l_t1) * (pow ((fabs (l_t1)), (1).to_double / 3.))
			else
				l_theta := (acos (l_rr / (sqrt ((-l_qq * l_qq) * l_qq))))
				l_tmp___9 := sqrt (-l_qq)
				l_ss := ((2).to_double * l_tmp___9) * (cos ((l_theta + (4).to_double * 3.14159265358979323846) / 3.))
				l_tt := 0.0
			end
			Result := ((l_ss + l_tt) - a_c2___0 / (3).to_double)
		end

end
