class
	P_MATHIEU_WORKSPACE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_mathieu_alloc (a_nn: NATURAL_32; a_qq: REAL_64): CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]
		local
			l_workspace: CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]
			l_even_order: NATURAL_32
			l_odd_order: NATURAL_32
			l_extra_values: NATURAL_32
			js: JUMP_STATE
		do
			create l_workspace.make

			l_even_order := a_nn // {NATURAL_32} 2 + {NATURAL_32} 1
			l_odd_order := (a_nn + {NATURAL_32} 1) // {NATURAL_32} 2
			l_extra_values := ((2.1 * (pow ((fabs (a_qq)), 0.37))).truncated_to_integer + 9).to_natural_32
			l_extra_values := l_extra_values + ({NATURAL_32} 20)
			if a_nn + {NATURAL_32} 1 = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("mathieu_workspace.c"), 43, 4)
					Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_workspace := create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_cast ((malloc ((create {PD_GSL_SF_MATHIEU_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_workspace.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("mathieu_workspace.c"), 50, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_even_order := l_even_order + l_extra_values
				l_odd_order := l_odd_order + l_extra_values
				l_workspace.item.size := a_nn
				l_workspace.item.even_order := l_even_order
				l_workspace.item.odd_order := l_odd_order
				l_workspace.item.extra_values := l_extra_values.to_integer_32
				l_workspace.item.aa := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_nn + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_workspace.item.aa).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("Error allocating memory for characteristic a values"), ce_string ("mathieu_workspace.c"), 68, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_workspace.item.bb := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_nn + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_workspace.item.bb).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.aa))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("Error allocating memory for characteristic b values"), ce_string ("mathieu_workspace.c"), 77, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_workspace.item.dd := create {CE_POINTER [REAL_64]}.make_cast ((malloc (l_even_order * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_workspace.item.dd).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.aa))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.bb))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for diagonal"), ce_string ("mathieu_workspace.c"), 89, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_workspace.item.ee := create {CE_POINTER [REAL_64]}.make_cast ((malloc (l_even_order * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_workspace.item.ee).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.dd))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.aa))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.bb))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for diagonal"), ce_string ("mathieu_workspace.c"), 99, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_workspace.item.tt := create {CE_POINTER [REAL_64]}.make_cast ((malloc (({NATURAL_32} 3 * l_even_order) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_workspace.item.tt).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.ee))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.dd))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.aa))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.bb))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for diagonal"), ce_string ("mathieu_workspace.c"), 110, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_workspace.item.e2 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (l_even_order * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_workspace.item.e2).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.tt))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.ee))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.dd))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.aa))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.bb))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for diagonal"), ce_string ("mathieu_workspace.c"), 122, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_workspace.item.zz := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((l_even_order * l_even_order) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_workspace.item.zz).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.e2))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.tt))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.ee))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.dd))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.aa))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.bb))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for diagonal"), ce_string ("mathieu_workspace.c"), 135, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_workspace.item.eval := init_source_inst.gsl_vector_alloc (l_even_order)
				if (l_workspace.item.eval).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.zz))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.e2))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.tt))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.ee))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.dd))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.aa))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.bb))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for eval"), ce_string ("mathieu_workspace.c"), 150, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_workspace.item.evec := init_source_inst.gsl_matrix_alloc (l_even_order, l_even_order)
				if (l_workspace.item.evec).is_void then
					init_source_inst.gsl_vector_free (l_workspace.item.eval)
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.zz))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.e2))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.tt))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.ee))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.dd))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.aa))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.bb))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for evec"), ce_string ("mathieu_workspace.c"), 166, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_workspace.item.wmat := symmv_inst.gsl_eigen_symmv_alloc (l_even_order)
				if (l_workspace.item.wmat).is_void then
					init_source_inst.gsl_matrix_free (l_workspace.item.evec)
					init_source_inst.gsl_vector_free (l_workspace.item.eval)
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.zz))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.e2))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.tt))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.ee))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.dd))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.aa))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace.item.bb))
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for wmat"), ce_string ("mathieu_workspace.c"), 183, 8)
						Result := (create {CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := l_workspace
			end
		end

	gsl_sf_mathieu_free (a_workspace: CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if a_workspace.is_void then
				js.return
			end
			if not js.return_called then
				init_source_inst.gsl_vector_free (a_workspace.item.eval)
				init_source_inst.gsl_matrix_free (a_workspace.item.evec)
				symmv_inst.gsl_eigen_symmv_free (a_workspace.item.wmat)
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace.item.aa))
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace.item.bb))
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace.item.dd))
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace.item.ee))
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace.item.tt))
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace.item.e2))
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace.item.zz))
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace))
			end
		end

end
