class
	P_MINSTD

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_minstd.make
			create minstd_type.make (<<1>>)
		end

feature {ANY} -- attributes

	a___3: INTEGER_32 assign set_a___3

	set_a___3 (a_a___3: INTEGER_32)
		do
			a___3 := a_a___3
		end

	gsl_rng_minstd: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_minstd

	set_gsl_rng_minstd (a_gsl_rng_minstd: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_minstd := a_gsl_rng_minstd
		end

	m___2: INTEGER_32 assign set_m___2

	set_m___2 (a_m___2: INTEGER_32)
		do
			m___2 := a_m___2
		end

	minstd_type: CE_ARRAY [PD_GSL_RNG_TYPE]

	q___2: INTEGER_32 assign set_q___2

	set_q___2 (a_q___2: INTEGER_32)
		do
			q___2 := a_q___2
		end

	r___2: INTEGER_32 assign set_r___2

	set_r___2 (a_r___2: INTEGER_32)
		do
			r___2 := a_r___2
		end

feature {ANY} -- routines

	minstd_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_MINSTD_STATE_T]
			l_x: NATURAL_32
			l_h: INTEGER_32
			l_t: INTEGER_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_MINSTD_STATE_T]}.make_cast (a_vstate)
			l_x := l_state.item.x
			l_h := (l_x // q___2.to_natural_32).to_integer_32
			l_t := (a___3.to_natural_32 * (l_x - (l_h * q___2).to_natural_32) - (l_h * r___2).to_natural_32).to_integer_32
			if l_t < 0 then
				l_state.item.x := (l_t + m___2).to_natural_32
			else
				l_state.item.x := l_t.to_natural_32
			end
			Result := (l_state.item.x)
		end

	minstd_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent minstd_get)
		end

	minstd_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((minstd_get (a_vstate)).to_real_64 / 2147483647.0)
		end

	minstd_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent minstd_get_double)
		end

	minstd_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MINSTD_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_MINSTD_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s
		end

	minstd_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent minstd_set)
		end

end
