class
	P_MULTIPLY

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_matmult (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_C: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_temp: REAL_64
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_A___0.item.size2 = a_B.item.size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if a_A___0.item.size1 = a_C.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_B.item.size2 = a_C.item.size2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrix sizes are not conformant"), ce_string ("multiply.c"), 34, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < a_C.item.size1))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_j < a_C.item.size2))
							loop
								l_a___5 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, (0).to_natural_32)
								l_b___0 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (0).to_natural_32, l_j)
								l_temp := l_a___5 * l_b___0
								l_k := (1).to_natural_32
								from
								until
									not (l_k < a_A___0.item.size2)
								loop
									l_a___5 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_k)
									l_b___0 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, l_k, l_j)
									l_temp := l_temp + (l_a___5 * l_b___0)
									l_k := l_k + 1
								end
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_C, l_i, l_j, l_temp)
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_matmult_mod (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_modA: NATURAL_32; a_B: CE_POINTER [PD_GSL_MATRIX]; a_modB: NATURAL_32; a_C: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_dim1_A: NATURAL_32
			l_dim2_A: NATURAL_32
			l_dim1_B: NATURAL_32
			l_dim2_B: NATURAL_32
			l_dim1_C: NATURAL_32
			l_dim2_C: NATURAL_32
			l_swap_tmp: NATURAL_32
			l_swap_tmp___0: NATURAL_32
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_temp: REAL_64
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_a1___4: NATURAL_32
			l_a2___3: NATURAL_32
			l_b1___0: NATURAL_32
			l_b2: NATURAL_32
			l_swap_tmp___1: NATURAL_32
			l_swap_tmp___2: NATURAL_32
			l_swap_tmp___3: NATURAL_32
			l_swap_tmp___4: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_modA /= {NATURAL_32} 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_modB = {NATURAL_32} 0 then
							Result := (gsl_linalg_matmult (a_A___0, a_B, a_C))
							js.return
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else: | _L___0:
						l_dim1_A := a_A___0.item.size1
						l_dim2_A := a_A___0.item.size2
						l_dim1_B := a_B.item.size1
						l_dim2_B := a_B.item.size2
						l_dim1_C := a_C.item.size1
						l_dim2_C := a_C.item.size2
						if ((a_modA).bit_and ({NATURAL_32} 1)).to_boolean then
							from
							until
								js.loop_done
							loop
								l_swap_tmp := l_dim1_A
								l_dim1_A := l_dim2_A
								l_dim2_A := l_swap_tmp
								js.break
							end
						end
						if ((a_modB).bit_and ({NATURAL_32} 1)).to_boolean then
							from
							until
								js.loop_done
							loop
								l_swap_tmp___0 := l_dim1_B
								l_dim1_B := l_dim2_B
								l_dim2_B := l_swap_tmp___0
								js.break
							end
						end
						if l_dim2_A = l_dim1_B then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if l_dim1_A = l_dim1_C then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if l_dim2_B = l_dim2_C then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("matrix sizes are not conformant"), ce_string ("multiply.c"), 89, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_i < l_dim1_C))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_j < l_dim2_C))
							loop
								l_a1___4 := l_i
								l_a2___3 := (0).to_natural_32
								l_b1___0 := (0).to_natural_32
								l_b2 := l_j
								if ((a_modA).bit_and ({NATURAL_32} 1)).to_boolean then
									from
									until
										js.loop_done
									loop
										l_swap_tmp___1 := l_a1___4
										l_a1___4 := l_a2___3
										l_a2___3 := l_swap_tmp___1
										js.break
									end
								end
								if ((a_modB).bit_and ({NATURAL_32} 1)).to_boolean then
									from
									until
										js.loop_done
									loop
										l_swap_tmp___2 := l_b1___0
										l_b1___0 := l_b2
										l_b2 := l_swap_tmp___2
										js.break
									end
								end
								l_a___5 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_a1___4, l_a2___3)
								l_b___0 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, l_b1___0, l_b2)
								l_temp := l_a___5 * l_b___0
								l_k := (1).to_natural_32
								from
								until
									not (not js.loop_done and then (l_k < l_dim2_A))
								loop
									l_a1___4 := l_i
									l_a2___3 := l_k
									l_b1___0 := l_k
									l_b2 := l_j
									if ((a_modA).bit_and ({NATURAL_32} 1)).to_boolean then
										from
										until
											js.loop_done
										loop
											l_swap_tmp___3 := l_a1___4
											l_a1___4 := l_a2___3
											l_a2___3 := l_swap_tmp___3
											js.break
										end
									end
									if ((a_modB).bit_and ({NATURAL_32} 1)).to_boolean then
										from
										until
											js.loop_done
										loop
											l_swap_tmp___4 := l_b1___0
											l_b1___0 := l_b2
											l_b2 := l_swap_tmp___4
											js.break
										end
									end
									l_a___5 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_a1___4, l_a2___3)
									l_b___0 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, l_b1___0, l_b2)
									l_temp := l_temp + (l_a___5 * l_b___0)
									l_k := l_k + 1
								end
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_C, l_i, l_j, l_temp)
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						js.return
				when 13 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
