class
	P_PDF2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_pdf_alloc (a_nx: NATURAL_32; a_ny: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]
		local
			l_n: NATURAL_32
			l_p: CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]
			js: JUMP_STATE
		do
			create l_p.make

			l_n := a_nx * a_ny
			if l_n = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("histogram2d pdf length n must be positive integer"), ce_string ("pdf2d.c"), 76, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_p := create {CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_cast ((malloc ((create {PD_GSL_HISTOGRAM2D_PDF}.make).structure_size.to_natural_32)))
				if l_p.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d pdf struct"), ce_string ("pdf2d.c"), 84, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_p.item.xrange := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_nx + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_p.item.xrange).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_p))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d pdf xranges"), ce_string ("pdf2d.c"), 94, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_p.item.yrange := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_ny + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_p.item.yrange).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_p.item.xrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_p))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d pdf yranges"), ce_string ("pdf2d.c"), 105, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_p.item.sum := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((l_n + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_p.item.sum).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_p.item.yrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_p.item.xrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_p))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram2d pdf sums"), ce_string ("pdf2d.c"), 117, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_p.item.nx := a_nx
				l_p.item.ny := a_ny
				Result := l_p
			end
		end

	gsl_histogram2d_pdf_free (a_p: CE_POINTER [PD_GSL_HISTOGRAM2D_PDF])
		local
			js: JUMP_STATE
		do
			if a_p.is_void then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_p.item.xrange))
				free (create {CE_POINTER [ANY]}.make_cast (a_p.item.yrange))
				free (create {CE_POINTER [ANY]}.make_cast (a_p.item.sum))
				free (create {CE_POINTER [ANY]}.make_cast (a_p))
			end
		end

	gsl_histogram2d_pdf_init (a_p: CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]; a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): INTEGER_32
		local
			l_i: NATURAL_32
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_n: NATURAL_32
			l_mean: REAL_64
			l_sum: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nx := a_p.item.nx
					l_ny := a_p.item.ny
					l_n := l_nx * l_ny
					if l_nx = a_h.item.nx then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_ny = a_h.item.ny then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("histogram2d size must match pdf size"), ce_string ("pdf2d.c"), 136, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_n))
							loop
								if a_h.item.bin[l_i.to_integer_32] < (0).to_double then
									from
									until
										js.loop_done
									loop
										error_inst.gsl_error (ce_string ("histogram bins must be non-negative to computea probability distribution"), ce_string ("pdf2d.c"), 144, 1)
										Result := 1
										js.return
										if not js.return_called then
											js.break
										end
									end
								end
								if not js.return_called then
									l_i := l_i + 1
								end
							end
						end
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_nx + {NATURAL_32} 1)
							loop
								a_p.item.xrange[l_i.to_integer_32] := a_h.item.xrange[l_i.to_integer_32]
								l_i := l_i + 1
							end
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_ny + {NATURAL_32} 1)
							loop
								a_p.item.yrange[l_i.to_integer_32] := a_h.item.yrange[l_i.to_integer_32]
								l_i := l_i + 1
							end
							l_mean := (0).to_double
							l_sum := (0).to_double
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_n)
							loop
								l_mean := l_mean + ((a_h.item.bin[l_i.to_integer_32] - l_mean) / (l_i + {NATURAL_32} 1).to_real_64)
								l_i := l_i + 1
							end
							a_p.item.sum[0] := (0).to_double
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_n)
							loop
								l_sum := l_sum + ((a_h.item.bin[l_i.to_integer_32] / l_mean) / l_n.to_real_64)
								a_p.item.sum[(l_i + {NATURAL_32} 1).to_integer_32] := l_sum
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_histogram2d_pdf_sample (a_p: CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]; a_r1___1: REAL_64; a_r2___0: REAL_64; a_x: CE_POINTER [REAL_64]; a_y: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_r1___1: REAL_64
			l_r2___0: REAL_64
			l_k: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_delta___0: REAL_64
			js: JUMP_STATE
		do
			create l_k.make (<<1>>)

			l_r1___1 := a_r1___1
			l_r2___0 := a_r2___0
			if l_r2___0 = 1.0 then
				l_r2___0 := 0.0
			end
			if l_r1___1 = 1.0 then
				l_r1___1 := 0.0
			end
			l_status := find_inst.find___3 ((a_p.item.nx * a_p.item.ny), a_p.item.sum, l_r1___1, l_k)
			if l_status.to_boolean then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("cannot find r1 in cumulative pdf"), ce_string ("pdf2d.c"), 53, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_i := l_k.item // a_p.item.ny
				l_j := l_k.item - l_i * a_p.item.ny
				l_delta___0 := (l_r1___1 - a_p.item.sum[(l_k.item).to_integer_32]) / (a_p.item.sum[(l_k.item + {NATURAL_32} 1).to_integer_32] - a_p.item.sum[(l_k.item).to_integer_32])
				a_x.item := a_p.item.xrange[l_i.to_integer_32] + l_delta___0 * (a_p.item.xrange[(l_i + {NATURAL_32} 1).to_integer_32] - a_p.item.xrange[l_i.to_integer_32])
				a_y.item := a_p.item.yrange[l_j.to_integer_32] + l_r2___0 * (a_p.item.yrange[(l_j + {NATURAL_32} 1).to_integer_32] - a_p.item.yrange[l_j.to_integer_32])
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
