class
	P_QC25S

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	compute_result (a_r___3: CE_POINTER [REAL_64]; a_cheb12: CE_POINTER [REAL_64]; a_cheb24: CE_POINTER [REAL_64]; a_result12: CE_POINTER [REAL_64]; a_result24: CE_POINTER [REAL_64])
		local
			l_i: NATURAL_32
			l_res12: REAL_64
			l_res24: REAL_64
		do
			l_res12 := (0).to_double
			l_res24 := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 13)
			loop
				l_res12 := l_res12 + (a_r___3[l_i.to_integer_32] * a_cheb12[l_i.to_integer_32])
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 25)
			loop
				l_res24 := l_res24 + (a_r___3[l_i.to_integer_32] * a_cheb24[l_i.to_integer_32])
				l_i := l_i + 1
			end
			a_result12.item := l_res12
			a_result24.item := l_res24
		end

	fn_qaws (a_x: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_p: CE_POINTER [PD_FN_QAWS_PARAMS]
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_t: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]
			l_factor: REAL_64
		do
			create l_p.make
			create l_f.make
			create l_t.make

			l_p := create {CE_POINTER [PD_FN_QAWS_PARAMS]}.make_cast (a_params)
			l_f := l_p.item.function
			l_t := l_p.item.table
			l_factor := 1.0
			if l_t.item.alpha /= 0.0 then
				l_factor := l_factor * (pow (a_x - l_p.item.a, l_t.item.alpha))
			end
			if l_t.item.beta /= 0.0 then
				l_factor := l_factor * (pow (l_p.item.b - a_x, l_t.item.beta))
			end
			if l_t.item.mu = 1 then
				l_factor := l_factor * (log (a_x - l_p.item.a))
			end
			if l_t.item.nu = 1 then
				l_factor := l_factor * (log (l_p.item.b - a_x))
			end
			Result := (l_factor * ((l_f.item.function).real_64_item ([a_x, l_f.item.params])))
		end

	fn_qaws_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fn_qaws)
		end

	fn_qaws_L (a_x: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_p: CE_POINTER [PD_FN_QAWS_PARAMS]
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_t: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]
			l_factor: REAL_64
		do
			create l_p.make
			create l_f.make
			create l_t.make

			l_p := create {CE_POINTER [PD_FN_QAWS_PARAMS]}.make_cast (a_params)
			l_f := l_p.item.function
			l_t := l_p.item.table
			l_factor := 1.0
			if l_t.item.alpha /= 0.0 then
				l_factor := l_factor * (pow (a_x - l_p.item.a, l_t.item.alpha))
			end
			if l_t.item.mu = 1 then
				l_factor := l_factor * (log (a_x - l_p.item.a))
			end
			Result := (l_factor * ((l_f.item.function).real_64_item ([a_x, l_f.item.params])))
		end

	fn_qaws_L_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fn_qaws_L)
		end

	fn_qaws_R (a_x: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_p: CE_POINTER [PD_FN_QAWS_PARAMS]
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_t: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]
			l_factor: REAL_64
		do
			create l_p.make
			create l_f.make
			create l_t.make

			l_p := create {CE_POINTER [PD_FN_QAWS_PARAMS]}.make_cast (a_params)
			l_f := l_p.item.function
			l_t := l_p.item.table
			l_factor := 1.0
			if l_t.item.beta /= 0.0 then
				l_factor := l_factor * (pow (l_p.item.b - a_x, l_t.item.beta))
			end
			if l_t.item.nu = 1 then
				l_factor := l_factor * (log (l_p.item.b - a_x))
			end
			Result := (l_factor * ((l_f.item.function).real_64_item ([a_x, l_f.item.params])))
		end

	fn_qaws_R_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fn_qaws_R)
		end

	qc25s (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_a1___4: REAL_64; a_b1___0: REAL_64; a_t: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]; a_err_reliable: CE_POINTER [INTEGER_32])
		local
			l_weighted_function: CE_ARRAY [PD_GSL_FUNCTION_STRUCT]
			l_fn_params: CE_ARRAY [PD_FN_QAWS_PARAMS]
			l_cheb12: CE_ARRAY [REAL_64]
			l_cheb24: CE_ARRAY [REAL_64]
			l_factor: REAL_64
			l_res12: CE_ARRAY [REAL_64]
			l_res24: CE_ARRAY [REAL_64]
			l_u: REAL_64
			l_res12a: CE_ARRAY [REAL_64]
			l_res24a: CE_ARRAY [REAL_64]
			l_res12b: CE_ARRAY [REAL_64]
			l_res24b: CE_ARRAY [REAL_64]
			l_u___0: REAL_64
			l_v: REAL_64
			l_tmp___1: REAL_64
			l_cheb12___0: CE_ARRAY [REAL_64]
			l_cheb24___0: CE_ARRAY [REAL_64]
			l_factor___0: REAL_64
			l_res12___0: CE_ARRAY [REAL_64]
			l_res24___0: CE_ARRAY [REAL_64]
			l_u___1: REAL_64
			l_res12a___0: CE_ARRAY [REAL_64]
			l_res24a___0: CE_ARRAY [REAL_64]
			l_res12b___0: CE_ARRAY [REAL_64]
			l_res24b___0: CE_ARRAY [REAL_64]
			l_u___2: REAL_64
			l_v___0: REAL_64
			l_tmp___5: REAL_64
			l_resabs: CE_ARRAY [REAL_64]
			l_resasc: CE_ARRAY [REAL_64]
			l_pos: INTEGER_32
		do
			create l_weighted_function.make (<<1>>)
			create l_fn_params.make (<<1>>)
			create l_cheb12.make (<<13>>)
			create l_cheb24.make (<<25>>)
			create l_res12.make (<<1>>)
			create l_res24.make (<<1>>)
			create l_res12a.make (<<1>>)
			create l_res24a.make (<<1>>)
			create l_res12b.make (<<1>>)
			create l_res24b.make (<<1>>)
			create l_cheb12___0.make (<<13>>)
			create l_cheb24___0.make (<<25>>)
			create l_res12___0.make (<<1>>)
			create l_res24___0.make (<<1>>)
			create l_res12a___0.make (<<1>>)
			create l_res24a___0.make (<<1>>)
			create l_res12b___0.make (<<1>>)
			create l_res24b___0.make (<<1>>)
			create l_resabs.make (<<1>>)
			create l_resasc.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fn_params.item.function := a_f
					l_fn_params.item.a := a_a___5
					l_fn_params.item.b := a_b___0
					l_fn_params.item.table := a_t
					l_weighted_function.item.params := create {CE_POINTER [ANY]}.make_cast (l_fn_params)
					if a_a1___4 /= a_a___5 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_t.item.alpha = 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___2
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if a_t.item.mu = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L___2:
						l_factor := (pow (0.5 * (a_b1___0 - a_a1___4), a_t.item.alpha + 1.0))
						l_weighted_function.item.function := fn_qaws_R_address
						qcheb_inst.gsl_integration_qcheb (l_weighted_function, a_a1___4, a_b1___0, l_cheb12, l_cheb24)
						if a_t.item.mu = 0 then
							l_res12.item := (0).to_double
							l_res24.item := (0).to_double
							l_u := l_factor
							compute_result (create {CE_POINTER [REAL_64]}.make_cast ((a_t.item.ri)), create {CE_POINTER [REAL_64]}.make_cast (l_cheb12), create {CE_POINTER [REAL_64]}.make_cast (l_cheb24), l_res12, l_res24)
							a_result.item := l_u * l_res24.item
							a_abserr.item := fabs (l_u * (l_res24.item - l_res12.item))
						else
							l_res12a.item := (0).to_double
							l_res24a.item := (0).to_double
							l_res12b.item := (0).to_double
							l_res24b.item := (0).to_double
							l_u___0 := l_factor * (log (a_b1___0 - a_a1___4))
							l_v := l_factor
							compute_result (create {CE_POINTER [REAL_64]}.make_cast ((a_t.item.ri)), create {CE_POINTER [REAL_64]}.make_cast (l_cheb12), create {CE_POINTER [REAL_64]}.make_cast (l_cheb24), l_res12a, l_res24a)
							compute_result (create {CE_POINTER [REAL_64]}.make_cast ((a_t.item.rg)), create {CE_POINTER [REAL_64]}.make_cast (l_cheb12), create {CE_POINTER [REAL_64]}.make_cast (l_cheb24), l_res12b, l_res24b)
							a_result.item := l_u___0 * l_res24a.item + l_v * l_res24b.item
							l_tmp___1 := fabs (l_u___0 * (l_res24a.item - l_res12a.item))
							a_abserr.item := l_tmp___1 + (fabs (l_v * (l_res24b.item - l_res12b.item)))
						end
						a_err_reliable.item := 0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___1
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else: | _L___1:
						if a_b1___0 /= a_b___0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if:
						if a_t.item.beta = 0.0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if a_t.item.nu = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L___0:
						l_factor___0 := (pow (0.5 * (a_b1___0 - a_a1___4), a_t.item.beta + 1.0))
						l_weighted_function.item.function := fn_qaws_L_address
						qcheb_inst.gsl_integration_qcheb (l_weighted_function, a_a1___4, a_b1___0, l_cheb12___0, l_cheb24___0)
						if a_t.item.nu = 0 then
							l_res12___0.item := (0).to_double
							l_res24___0.item := (0).to_double
							l_u___1 := l_factor___0
							compute_result (create {CE_POINTER [REAL_64]}.make_cast ((a_t.item.rj)), create {CE_POINTER [REAL_64]}.make_cast (l_cheb12___0), create {CE_POINTER [REAL_64]}.make_cast (l_cheb24___0), l_res12___0, l_res24___0)
							a_result.item := l_u___1 * l_res24___0.item
							a_abserr.item := fabs (l_u___1 * (l_res24___0.item - l_res12___0.item))
						else
							l_res12a___0.item := (0).to_double
							l_res24a___0.item := (0).to_double
							l_res12b___0.item := (0).to_double
							l_res24b___0.item := (0).to_double
							l_u___2 := l_factor___0 * (log (a_b1___0 - a_a1___4))
							l_v___0 := l_factor___0
							compute_result (create {CE_POINTER [REAL_64]}.make_cast ((a_t.item.rj)), create {CE_POINTER [REAL_64]}.make_cast (l_cheb12___0), create {CE_POINTER [REAL_64]}.make_cast (l_cheb24___0), l_res12a___0, l_res24a___0)
							compute_result (create {CE_POINTER [REAL_64]}.make_cast ((a_t.item.rh)), create {CE_POINTER [REAL_64]}.make_cast (l_cheb12___0), create {CE_POINTER [REAL_64]}.make_cast (l_cheb24___0), l_res12b___0, l_res24b___0)
							a_result.item := l_u___2 * l_res24a___0.item + l_v___0 * l_res24b___0.item
							l_tmp___5 := fabs (l_u___2 * (l_res24a___0.item - l_res12a___0.item))
							a_abserr.item := l_tmp___5 + (fabs (l_v___0 * (l_res24b___0.item - l_res12b___0.item)))
						end
						a_err_reliable.item := 0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 18 -- goto _L
				when 17 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						l_weighted_function.item.function := fn_qaws_address
						qk15_inst.gsl_integration_qk15 (l_weighted_function, a_a1___4, a_b1___0, a_result, a_abserr, l_resabs, l_resasc)
						if a_abserr.item = l_resasc.item then
							a_err_reliable.item := 0
						else
							a_err_reliable.item := 1
						end
				when 19 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
