class
	P_QK

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_integration_qk (a_n: INTEGER_32; a_xgk___5: CE_POINTER [REAL_64]; a_wg___5: CE_POINTER [REAL_64]; a_wgk___5: CE_POINTER [REAL_64]; a_fv1: CE_POINTER [REAL_64]; a_fv2: CE_POINTER [REAL_64]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]; a_resabs: CE_POINTER [REAL_64]; a_resasc: CE_POINTER [REAL_64])
		local
			l_center: REAL_64
			l_half_length: REAL_64
			l_abs_half_length: REAL_64
			l_f_center: REAL_64
			l_result_gauss: REAL_64
			l_result_kronrod: REAL_64
			l_result_abs: REAL_64
			l_result_asc: REAL_64
			l_mean: REAL_64
			l_err: REAL_64
			l_j: INTEGER_32
			l_jtw: INTEGER_32
			l_abscissa: REAL_64
			l_fval1: REAL_64
			l_fval2: REAL_64
			l_fsum: REAL_64
			l_tmp___4: REAL_64
			l_jtwm1: INTEGER_32
			l_abscissa___0: REAL_64
			l_fval1___0: REAL_64
			l_fval2___0: REAL_64
			l_tmp___8: REAL_64
			l_tmp___11: REAL_64
		do
			l_center := 0.5 * (a_a___5 + a_b___0)
			l_half_length := 0.5 * (a_b___0 - a_a___5)
			l_abs_half_length := (fabs (l_half_length))
			l_f_center := ((a_f.item.function).real_64_item ([l_center, a_f.item.params]))
			l_result_gauss := (0).to_double
			l_result_kronrod := l_f_center * a_wgk___5[(a_n - 1)]
			l_result_abs := (fabs (l_result_kronrod))
			l_result_asc := (0).to_double
			l_mean := (0).to_double
			l_err := (0).to_double
			if a_n \\ 2 = 0 then
				l_result_gauss := l_f_center * a_wg___5[(a_n // 2 - 1)]
			end
			l_j := 0
			from
			until
				not (l_j < (a_n - 1) // 2)
			loop
				l_jtw := l_j * 2 + 1
				l_abscissa := l_half_length * a_xgk___5[l_jtw]
				l_fval1 := ((a_f.item.function).real_64_item ([l_center - l_abscissa, a_f.item.params]))
				l_fval2 := ((a_f.item.function).real_64_item ([l_center + l_abscissa, a_f.item.params]))
				l_fsum := l_fval1 + l_fval2
				a_fv1[l_jtw] := l_fval1
				a_fv2[l_jtw] := l_fval2
				l_result_gauss := l_result_gauss + (a_wg___5[l_j] * l_fsum)
				l_result_kronrod := l_result_kronrod + (a_wgk___5[l_jtw] * l_fsum)
				l_tmp___4 := fabs (l_fval1)
				l_result_abs := l_result_abs + (a_wgk___5[l_jtw] * (l_tmp___4 + (fabs (l_fval2))))
				l_j := l_j + 1
			end
			l_j := 0
			from
			until
				not (l_j < a_n // 2)
			loop
				l_jtwm1 := l_j * 2
				l_abscissa___0 := l_half_length * a_xgk___5[l_jtwm1]
				l_fval1___0 := ((a_f.item.function).real_64_item ([l_center - l_abscissa___0, a_f.item.params]))
				l_fval2___0 := ((a_f.item.function).real_64_item ([l_center + l_abscissa___0, a_f.item.params]))
				a_fv1[l_jtwm1] := l_fval1___0
				a_fv2[l_jtwm1] := l_fval2___0
				l_result_kronrod := l_result_kronrod + (a_wgk___5[l_jtwm1] * (l_fval1___0 + l_fval2___0))
				l_tmp___8 := fabs (l_fval1___0)
				l_result_abs := l_result_abs + (a_wgk___5[l_jtwm1] * (l_tmp___8 + (fabs (l_fval2___0))))
				l_j := l_j + 1
			end
			l_mean := l_result_kronrod * 0.5
			l_result_asc := (a_wgk___5[(a_n - 1)] * (fabs (l_f_center - l_mean)))
			l_j := 0
			from
			until
				not (l_j < a_n - 1)
			loop
				l_tmp___11 := fabs (a_fv1[l_j] - l_mean)
				l_result_asc := l_result_asc + (a_wgk___5[l_j] * (l_tmp___11 + (fabs (a_fv2[l_j] - l_mean))))
				l_j := l_j + 1
			end
			l_err := (l_result_kronrod - l_result_gauss) * l_half_length
			l_result_kronrod := l_result_kronrod * l_half_length
			l_result_abs := l_result_abs * l_abs_half_length
			l_result_asc := l_result_asc * l_abs_half_length
			a_result.item := l_result_kronrod
			a_resabs.item := l_result_abs
			a_resasc.item := l_result_asc
			a_abserr.item := err_inst.rescale_error___0 (l_err, l_result_abs, l_result_asc)
		end

end
