class
	P_QR

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_QR_QRsolve (a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
		do
			l_M := a_R.item.size1
			l_N := a_R.item.size2
			if l_M /= l_N then
				Result := 20
			elseif a_Q___1.item.size1 /= l_M then
				Result := 19
			elseif a_b___0.item.size /= l_M then
				Result := 19
			elseif a_x.item.size /= l_M then
				Result := 19
			else
				blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasTrans, 1.0, a_Q___1, a_b___0, 0.0, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_R, a_x).do_nothing
				Result := 0
			end
		end

	gsl_linalg_QR_QTmat (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_A___0: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_h: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_ti: REAL_64
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)
			create l_h.make (<<1>>)
			create l_m___4.make (<<1>>)

			l_M := a_QR.item.size1
			l_N := a_QR.item.size2
			if l_M < l_N then
				l_tmp___4 := l_M
			else
				l_tmp___4 := l_N
			end
			if a_tau.item.size /= l_tmp___4 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("qr.c"), 409, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_A___0.item.size1 /= l_M then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must have M rows"), ce_string ("qr.c"), 413, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					js.loop_done
				loop
					if l_M < l_N then
						l_tmp___3 := l_M
					else
						l_tmp___3 := l_N
					end
					if not (l_i < l_tmp___3) then
						js.break
					end
					if not js.loop_jumped then
						l_c___1.item := (rowcol_source_inst.gsl_matrix_const_column (a_QR, l_i)).twin
						l_h.item := (subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), l_i, l_M - l_i)).twin
						l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_i, (0).to_natural_32, l_M - l_i, a_A___0.item.size2)).twin
						l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau, l_i))
						householder_inst.gsl_linalg_householder_hm (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
						l_i := l_i + 1
					end
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_QR_QTvec (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_h: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_w: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_ti: REAL_64
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)
			create l_h.make (<<1>>)
			create l_w.make (<<1>>)

			l_M := a_QR.item.size1
			l_N := a_QR.item.size2
			if l_M < l_N then
				l_tmp___4 := l_M
			else
				l_tmp___4 := l_N
			end
			if a_tau.item.size /= l_tmp___4 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("qr.c"), 341, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_v.item.size /= l_M then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector size must be N"), ce_string ("qr.c"), 345, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					js.loop_done
				loop
					if l_M < l_N then
						l_tmp___3 := l_M
					else
						l_tmp___3 := l_N
					end
					if not (l_i < l_tmp___3) then
						js.break
					end
					if not js.loop_jumped then
						l_c___1.item := (rowcol_source_inst.gsl_matrix_const_column (a_QR, l_i)).twin
						l_h.item := (subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), l_i, l_M - l_i)).twin
						l_w.item := (subvector_source_inst.gsl_vector_subvector (a_v, l_i, l_M - l_i)).twin
						l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau, l_i))
						householder_inst.gsl_linalg_householder_hv (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_w.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).do_nothing
						l_i := l_i + 1
					end
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_QR_Qvec (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_h: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_w: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_ti: REAL_64
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			create l_c___1.make (<<1>>)
			create l_h.make (<<1>>)
			create l_w.make (<<1>>)

			l_M := a_QR.item.size1
			l_N := a_QR.item.size2
			if l_M < l_N then
				l_tmp___4 := l_M
			else
				l_tmp___4 := l_N
			end
			if a_tau.item.size /= l_tmp___4 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("qr.c"), 374, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_v.item.size /= l_M then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector size must be N"), ce_string ("qr.c"), 378, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				if l_M < l_N then
					l_i := l_M
				else
					l_i := l_N
				end
				from
				until
					js.loop_done
				loop
					l_tmp___3 := l_i
					l_i := l_i - 1
					if not (l_tmp___3 > {NATURAL_32} 0) then
						js.break
					end
					if not js.loop_jumped then
						l_c___1.item := (rowcol_source_inst.gsl_matrix_const_column (a_QR, l_i)).twin
						l_h.item := (subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), l_i, l_M - l_i)).twin
						l_w.item := (subvector_source_inst.gsl_vector_subvector (a_v, l_i, l_M - l_i)).twin
						l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau, l_i))
						householder_inst.gsl_linalg_householder_hv (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_w.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).do_nothing
					end
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_QR_Rsolve (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_QR.item.size1 /= a_QR.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("QR matrix must be square"), ce_string ("qr.c"), 232, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_QR.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("qr.c"), 236, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_QR.item.size2 /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match x size"), ce_string ("qr.c"), 240, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_QR, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_QR_Rsvx (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_QR.item.size1 /= a_QR.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("QR matrix must be square"), ce_string ("qr.c"), 262, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_QR.item.size1 /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match rhs size"), ce_string ("qr.c"), 266, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_QR, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_QR_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_c_full: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tau_i: REAL_64
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			create l_c_full.make (<<1>>)
			create l_c___1.make (<<1>>)
			create l_m___4.make (<<1>>)

			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M < l_N then
				l_tmp___4 := l_M
			else
				l_tmp___4 := l_N
			end
			if a_tau.item.size /= l_tmp___4 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("qr.c"), 68, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					js.loop_done
				loop
					if l_M < l_N then
						l_tmp___3 := l_M
					else
						l_tmp___3 := l_N
					end
					if not (l_i < l_tmp___3) then
						js.break
					end
					if not js.loop_jumped then
						l_c_full.item := (rowcol_source_inst.gsl_matrix_column (a_A___0, l_i)).twin
						l_c___1.item := (subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_full.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), l_i, l_M - l_i)).twin
						l_tau_i := (householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))))
						gsl_gsl_vector_double_inst.gsl_vector_set (a_tau, l_i, l_tau_i)
						if l_i + {NATURAL_32} 1 < l_N then
							l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_i, l_i + {NATURAL_32} 1, l_M - l_i, l_N - (l_i + {NATURAL_32} 1))).twin
							householder_inst.gsl_linalg_householder_hm (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
						end
						l_i := l_i + 1
					end
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_QR_lssolve (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_residual: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_R: CE_ARRAY [PD_GSL_MATRIX_CONST_VIEW]
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			js: JUMP_STATE
		do
			create l_R.make (<<1>>)
			create l_c___1.make (<<1>>)

			l_M := a_QR.item.size1
			l_N := a_QR.item.size2
			if l_M < l_N then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("QR matrix must have M>=N"), ce_string ("qr.c"), 185, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif l_M /= a_b___0.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("qr.c"), 189, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif l_N /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("qr.c"), 193, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif l_M /= a_residual.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match residual size"), ce_string ("qr.c"), 197, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				l_R.item := (submatrix_source_inst.gsl_matrix_const_submatrix (a_QR, (0).to_natural_32, (0).to_natural_32, l_N, l_N)).twin
				l_c___1.item := (subvector_source_inst.gsl_vector_subvector (a_residual, (0).to_natural_32, l_N)).twin
				copy_source_inst.gsl_vector_memcpy (a_residual, a_b___0).do_nothing
				gsl_linalg_QR_QTvec (a_QR, a_tau, a_residual).do_nothing
				copy_source_inst.gsl_vector_memcpy (a_x, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_R.item.c_pointer + (create {PD_GSL_MATRIX_CONST_VIEW}.make).offset_of ("matrix"))), a_x).do_nothing
				init_source_inst.gsl_vector_set_zero (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
				gsl_linalg_QR_Qvec (a_QR, a_tau, a_residual).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_QR_solve (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_QR.item.size1 /= a_QR.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("QR matrix must be square"), ce_string ("qr.c"), 112, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_QR.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("qr.c"), 116, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_QR.item.size2 /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("qr.c"), 120, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				gsl_linalg_QR_svx (a_QR, a_tau, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_QR_svx (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_QR.item.size1 /= a_QR.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("QR matrix must be square"), ce_string ("qr.c"), 149, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_QR.item.size1 /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match x/rhs size"), ce_string ("qr.c"), 153, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				gsl_linalg_QR_QTvec (a_QR, a_tau, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_QR, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_QR_unpack (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_c___1: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_h: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_ti: REAL_64
			l_tmp___3: NATURAL_32
			l_tmp___5: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c___1.make (<<1>>)
			create l_h.make (<<1>>)
			create l_m___4.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_QR.item.size1
					l_N := a_QR.item.size2
					if a_Q___1.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_Q___1.item.size2 = l_M then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___0:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("Q matrix must be M x M"), ce_string ("qr.c"), 444, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_R.item.size1 = l_M then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if a_R.item.size2 = l_N then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("R matrix must be M x N"), ce_string ("qr.c"), 448, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if l_M < l_N then
							l_tmp___5 := l_M
						else
							l_tmp___5 := l_N
						end
						if a_tau.item.size /= l_tmp___5 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("qr.c"), 452, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						else
							init_source_inst.gsl_matrix_set_identity (a_Q___1)
							if l_M < l_N then
								l_i := l_M
							else
								l_i := l_N
							end
							from
							until
								js.loop_done
							loop
								l_tmp___3 := l_i
								l_i := l_i - 1
								if not (l_tmp___3 > {NATURAL_32} 0) then
									js.break
								end
								if not js.loop_jumped then
									l_c___1.item := (rowcol_source_inst.gsl_matrix_const_column (a_QR, l_i)).twin
									l_h.item := (subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), l_i, l_M - l_i)).twin
									l_m___4.item := (submatrix_source_inst.gsl_matrix_submatrix (a_Q___1, l_i, l_i, l_M - l_i, l_M - l_i)).twin
									l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau, l_i))
									householder_inst.gsl_linalg_householder_hm (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).do_nothing
								end
							end
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_M))
							loop
								l_j := (0).to_natural_32
								from
								until
									js.loop_done
								loop
									if l_j < l_i then
										if not (l_j < l_N) then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										gsl_gsl_matrix_double_inst.gsl_matrix_set (a_R, l_i, l_j, 0.0)
										l_j := l_j + 1
									end
								end
								l_j := l_i
								from
								until
									not (l_j < l_N)
								loop
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_R, l_i, l_j, (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_QR, l_i, l_j)))
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
							js.return
						end
				when 13 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_QR_update (a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_VECTOR]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_w0: REAL_64
			l_c___1: CE_ARRAY [REAL_64]
			l_s: CE_ARRAY [REAL_64]
			l_wk: REAL_64
			l_wkm1: REAL_64
			l_r0j: REAL_64
			l_vj: REAL_64
			l_c___2: CE_ARRAY [REAL_64]
			l_s___0: CE_ARRAY [REAL_64]
			l_diag: REAL_64
			l_offdiag: REAL_64
			l_tmp___5: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c___1.make (<<1>>)
			create l_s.make (<<1>>)
			create l_c___2.make (<<1>>)
			create l_s___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_R.item.size1
					l_N := a_R.item.size2
					if a_Q___1.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_Q___1.item.size2 = l_M then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("Q matrix must be M x M if R is M x N"), ce_string ("qr.c"), 509, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_w.item.size /= l_M then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("w must be length M if R is M x N"), ce_string ("qr.c"), 513, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						elseif a_v.item.size /= l_N then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("v must be length N if R is M x N"), ce_string ("qr.c"), 517, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						else
							l_k := l_M - {NATURAL_32} 1
							from
							until
								not (l_k > {NATURAL_32} 0)
							loop
								l_wk := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_k))
								l_wkm1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_k - {NATURAL_32} 1))
								qrstep_inst.create_givens (l_wkm1, l_wk, l_c___1, l_s)
								apply_givens_inst.apply_givens_vec (a_w, l_k - {NATURAL_32} 1, l_k, l_c___1.item, l_s.item)
								apply_givens_inst.apply_givens_qr (l_M, l_N, a_Q___1, a_R, l_k - {NATURAL_32} 1, l_k, l_c___1.item, l_s.item)
								l_k := l_k - 1
							end
							l_w0 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w, (0).to_natural_32)
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_r0j := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, (0).to_natural_32, l_j))
								l_vj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_v, l_j))
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_R, (0).to_natural_32, l_j, l_r0j + l_w0 * l_vj)
								l_j := l_j + 1
							end
							l_k := (1).to_natural_32
							from
							until
								js.loop_done
							loop
								if l_M < l_N + {NATURAL_32} 1 then
									l_tmp___5 := l_M
								else
									l_tmp___5 := l_N + {NATURAL_32} 1
								end
								if not (l_k < l_tmp___5) then
									js.break
								end
								if not js.loop_jumped then
									l_diag := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_k - {NATURAL_32} 1, l_k - {NATURAL_32} 1))
									l_offdiag := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_k, l_k - {NATURAL_32} 1))
									qrstep_inst.create_givens (l_diag, l_offdiag, l_c___2, l_s___0)
									apply_givens_inst.apply_givens_qr (l_M, l_N, a_Q___1, a_R, l_k - {NATURAL_32} 1, l_k, l_c___2.item, l_s___0.item)
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_R, l_k, l_k - {NATURAL_32} 1, 0.0)
									l_k := l_k + 1
								end
							end
							Result := 0
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_R_solve (a_R: CE_POINTER [PD_GSL_MATRIX]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_R.item.size1 /= a_R.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("R matrix must be square"), ce_string ("qr.c"), 283, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_R.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("qr.c"), 287, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_R.item.size2 /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("qr.c"), 291, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_R, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_R_svx (a_R: CE_POINTER [PD_GSL_MATRIX]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_R.item.size1 /= a_R.item.size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("R matrix must be square"), ce_string ("qr.c"), 312, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			elseif a_R.item.size2 /= a_x.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("qr.c"), 316, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_R, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	qr_companion (a_h: CE_POINTER [REAL_64]; a_nc: NATURAL_32; a_zroot: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_t: REAL_64
			l_iterations: NATURAL_32
			l_e: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_m___4: NATURAL_32
			l_w: REAL_64
			l_x: REAL_64
			l_y: REAL_64
			l_s: REAL_64
			l_z: REAL_64
			l_p: REAL_64
			l_q___3: REAL_64
			l_r___3: REAL_64
			l_notlast: INTEGER_32
			l_n: NATURAL_32
			l_a1___4: REAL_64
			l_a2___3: REAL_64
			l_a3___0: REAL_64
			l_tmp___3: REAL_64
			l_a1___5: REAL_64
			l_a2___4: REAL_64
			l_a3___1: REAL_64
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_t := 0.0
					l_p := (0).to_double
					l_q___3 := (0).to_double
					l_r___3 := (0).to_double
					l_n := a_nc
				when 1 then -- next_root:
					if l_n = {NATURAL_32} 0 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 2 then -- if:
						l_iterations := (0).to_natural_32
				when 3 then -- next_iteration:
						l_e := l_n
						from
						until
							not (not js.loop_done and then (l_e >= {NATURAL_32} 2))
						loop
							l_a1___4 := (fabs (a_h[((l_e - {NATURAL_32} 1) * a_nc + ((l_e - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32]))
							l_a2___3 := (fabs (a_h[(((l_e - {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + ((l_e - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32]))
							l_a3___0 := (fabs (a_h[((l_e - {NATURAL_32} 1) * a_nc + (l_e - {NATURAL_32} 1)).to_integer_32]))
							if l_a1___4 <= 2.2204460492503131e-16 * (l_a2___3 + l_a3___0) then
								js.break
							end
							if not js.loop_jumped then
								l_e := l_e - 1
							end
						end
						l_x := a_h[((l_n - {NATURAL_32} 1) * a_nc + (l_n - {NATURAL_32} 1)).to_integer_32]
						if l_e = l_n then
							from
							until
								js.loop_done
							loop
								a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 1)).to_integer_32] := l_x + l_t
								a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 1) + {NATURAL_32} 1).to_integer_32] := (0).to_double
								js.break
							end
							l_n := l_n - 1
							l_pos := -1 + 1 -- goto next_root
						end
				when 4 then
						l_y := a_h[(((l_n - {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + ((l_n - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32]
						l_w := a_h[(((l_n - {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + (l_n - {NATURAL_32} 1)).to_integer_32] * a_h[((l_n - {NATURAL_32} 1) * a_nc + ((l_n - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32]
						if l_e = l_n - {NATURAL_32} 1 then
							l_p := (l_y - l_x) / (2).to_double
							l_q___3 := l_p * l_p + l_w
							l_y := sqrt ((fabs (l_q___3)))
							l_x := l_x + l_t
							if l_q___3 > (0).to_double then
								if l_p < (0).to_double then
									l_y := -l_y
								end
								l_y := l_y + l_p
								from
								until
									js.loop_done
								loop
									a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 1)).to_integer_32] := l_x - l_w / l_y
									a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 1) + {NATURAL_32} 1).to_integer_32] := (0).to_double
									js.break
								end
								from
								until
									js.loop_done
								loop
									a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 2)).to_integer_32] := l_x + l_y
									a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 2) + {NATURAL_32} 1).to_integer_32] := (0).to_double
									js.break
								end
							else
								from
								until
									js.loop_done
								loop
									a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 1)).to_integer_32] := l_x + l_p
									a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 1) + {NATURAL_32} 1).to_integer_32] := -l_y
									js.break
								end
								from
								until
									js.loop_done
								loop
									a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 2)).to_integer_32] := l_x + l_p
									a_zroot[({NATURAL_32} 2 * (l_n - {NATURAL_32} 2) + {NATURAL_32} 1).to_integer_32] := l_y
									js.break
								end
							end
							l_n := l_n - ({NATURAL_32} 2)
							l_pos := -1 + 1 -- goto next_root
						end
				when 5 then
						if l_iterations = {NATURAL_32} 60 then
							Result := (-1)
							js.return
						end
				when 6 then -- if done
					if not js.return_called then
						if l_iterations \\ {NATURAL_32} 10 = {NATURAL_32} 0 then
							if l_iterations > {NATURAL_32} 0 then
								l_t := l_t + l_x
								l_i := (1).to_natural_32
								from
								until
									not (l_i <= l_n)
								loop
									a_h[((l_i - {NATURAL_32} 1) * a_nc + (l_i - {NATURAL_32} 1)).to_integer_32] := a_h[((l_i - {NATURAL_32} 1) * a_nc + (l_i - {NATURAL_32} 1)).to_integer_32] - l_x
									l_i := l_i + 1
								end
								l_tmp___3 := fabs (a_h[((l_n - {NATURAL_32} 1) * a_nc + ((l_n - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32])
								l_s := l_tmp___3 + (fabs (a_h[(((l_n - {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + ((l_n - {NATURAL_32} 2) - {NATURAL_32} 1)).to_integer_32]))
								l_y := 0.75 * l_s
								l_x := l_y
								l_w := (-0.4375 * l_s) * l_s
							end
						end
						l_iterations := l_iterations + 1
						l_m___4 := l_n - {NATURAL_32} 2
						from
						until
							not (not js.loop_done and then (l_m___4 >= l_e))
						loop
							l_z := a_h[((l_m___4 - {NATURAL_32} 1) * a_nc + (l_m___4 - {NATURAL_32} 1)).to_integer_32]
							l_r___3 := l_x - l_z
							l_s := l_y - l_z
							l_p := a_h[((l_m___4 - {NATURAL_32} 1) * a_nc + ((l_m___4 + {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32] + (l_r___3 * l_s - l_w) / a_h[(((l_m___4 + {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + (l_m___4 - {NATURAL_32} 1)).to_integer_32]
							l_q___3 := ((a_h[(((l_m___4 + {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + ((l_m___4 + {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32] - l_z) - l_r___3) - l_s
							l_r___3 := a_h[(((l_m___4 + {NATURAL_32} 2) - {NATURAL_32} 1) * a_nc + ((l_m___4 + {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32]
							l_tmp___5 := fabs (l_p)
							l_tmp___6 := fabs (l_q___3)
							l_s := (l_tmp___5 + l_tmp___6) + (fabs (l_r___3))
							l_p := l_p / l_s
							l_q___3 := l_q___3 / l_s
							l_r___3 := l_r___3 / l_s
							if l_m___4 = l_e then
								js.break
							end
							if not js.loop_jumped then
								l_a1___5 := fabs (a_h[((l_m___4 - {NATURAL_32} 1) * a_nc + ((l_m___4 - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32])
								l_a2___4 := fabs (a_h[(((l_m___4 - {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + ((l_m___4 - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32])
								l_a3___1 := fabs (a_h[(((l_m___4 + {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + ((l_m___4 + {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32])
								l_tmp___8 := fabs (l_q___3)
								l_tmp___9 := fabs (l_r___3)
								if l_a1___5 * (l_tmp___8 + l_tmp___9) <= (2.2204460492503131e-16 * (fabs (l_p))) * (l_a2___4 + l_a3___1) then
									js.break
								end
							end
							if not js.loop_jumped then
								l_m___4 := l_m___4 - 1
							end
						end
						l_i := l_m___4 + {NATURAL_32} 2
						from
						until
							not (l_i <= l_n)
						loop
							a_h[((l_i - {NATURAL_32} 1) * a_nc + ((l_i - {NATURAL_32} 2) - {NATURAL_32} 1)).to_integer_32] := (0).to_double
							l_i := l_i + 1
						end
						l_i := l_m___4 + {NATURAL_32} 3
						from
						until
							not (l_i <= l_n)
						loop
							a_h[((l_i - {NATURAL_32} 1) * a_nc + ((l_i - {NATURAL_32} 3) - {NATURAL_32} 1)).to_integer_32] := (0).to_double
							l_i := l_i + 1
						end
						l_k := l_m___4
						from
						until
							not (not js.loop_done and then (l_k <= l_n - {NATURAL_32} 1))
						loop
							l_notlast := (l_k /= l_n - {NATURAL_32} 1).to_integer
							if l_k /= l_m___4 then
								l_p := a_h[((l_k - {NATURAL_32} 1) * a_nc + ((l_k - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32]
								l_q___3 := a_h[(((l_k + {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + ((l_k - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32]
								if l_notlast.to_boolean then
									l_r___3 := a_h[(((l_k + {NATURAL_32} 2) - {NATURAL_32} 1) * a_nc + ((l_k - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32]
								else
									l_r___3 := 0.0
								end
								l_tmp___11 := fabs (l_p)
								l_tmp___12 := fabs (l_q___3)
								l_x := (l_tmp___11 + l_tmp___12) + (fabs (l_r___3))
								if l_x = (0).to_double then
									js.continue
								end
								if not js.loop_jumped then
									l_p := l_p / l_x
									l_q___3 := l_q___3 / l_x
									l_r___3 := l_r___3 / l_x
								end
							end
							if not js.loop_jumped then
								l_s := sqrt ((l_p * l_p + l_q___3 * l_q___3) + l_r___3 * l_r___3)
								if l_p < (0).to_double then
									l_s := -l_s
								end
								if l_k /= l_m___4 then
									a_h[((l_k - {NATURAL_32} 1) * a_nc + ((l_k - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32] := -l_s * l_x
								elseif l_e /= l_m___4 then
									a_h[((l_k - {NATURAL_32} 1) * a_nc + ((l_k - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32] := a_h[((l_k - {NATURAL_32} 1) * a_nc + ((l_k - {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32] * (-1).to_double
								end
								l_p := l_p + l_s
								l_x := l_p / l_s
								l_y := l_q___3 / l_s
								l_z := l_r___3 / l_s
								l_q___3 := l_q___3 / l_p
								l_r___3 := l_r___3 / l_p
								l_j := l_k
								from
								until
									not (l_j <= l_n)
								loop
									l_p := a_h[((l_k - {NATURAL_32} 1) * a_nc + (l_j - {NATURAL_32} 1)).to_integer_32] + l_q___3 * a_h[(((l_k + {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + (l_j - {NATURAL_32} 1)).to_integer_32]
									if l_notlast.to_boolean then
										l_p := l_p + (l_r___3 * a_h[(((l_k + {NATURAL_32} 2) - {NATURAL_32} 1) * a_nc + (l_j - {NATURAL_32} 1)).to_integer_32])
										a_h[(((l_k + {NATURAL_32} 2) - {NATURAL_32} 1) * a_nc + (l_j - {NATURAL_32} 1)).to_integer_32] := a_h[(((l_k + {NATURAL_32} 2) - {NATURAL_32} 1) * a_nc + (l_j - {NATURAL_32} 1)).to_integer_32] - (l_p * l_z)
									end
									a_h[(((l_k + {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + (l_j - {NATURAL_32} 1)).to_integer_32] := a_h[(((l_k + {NATURAL_32} 1) - {NATURAL_32} 1) * a_nc + (l_j - {NATURAL_32} 1)).to_integer_32] - (l_p * l_y)
									a_h[((l_k - {NATURAL_32} 1) * a_nc + (l_j - {NATURAL_32} 1)).to_integer_32] := a_h[((l_k - {NATURAL_32} 1) * a_nc + (l_j - {NATURAL_32} 1)).to_integer_32] - (l_p * l_x)
									l_j := l_j + 1
								end
								if l_k + {NATURAL_32} 3 < l_n then
									l_j := l_k + {NATURAL_32} 3
								else
									l_j := l_n
								end
								l_i := l_e
								from
								until
									not (l_i <= l_j)
								loop
									l_p := l_x * a_h[((l_i - {NATURAL_32} 1) * a_nc + (l_k - {NATURAL_32} 1)).to_integer_32] + l_y * a_h[((l_i - {NATURAL_32} 1) * a_nc + ((l_k + {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32]
									if l_notlast.to_boolean then
										l_p := l_p + (l_z * a_h[((l_i - {NATURAL_32} 1) * a_nc + ((l_k + {NATURAL_32} 2) - {NATURAL_32} 1)).to_integer_32])
										a_h[((l_i - {NATURAL_32} 1) * a_nc + ((l_k + {NATURAL_32} 2) - {NATURAL_32} 1)).to_integer_32] := a_h[((l_i - {NATURAL_32} 1) * a_nc + ((l_k + {NATURAL_32} 2) - {NATURAL_32} 1)).to_integer_32] - (l_p * l_r___3)
									end
									a_h[((l_i - {NATURAL_32} 1) * a_nc + ((l_k + {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32] := a_h[((l_i - {NATURAL_32} 1) * a_nc + ((l_k + {NATURAL_32} 1) - {NATURAL_32} 1)).to_integer_32] - (l_p * l_q___3)
									a_h[((l_i - {NATURAL_32} 1) * a_nc + (l_k - {NATURAL_32} 1)).to_integer_32] := a_h[((l_i - {NATURAL_32} 1) * a_nc + (l_k - {NATURAL_32} 1)).to_integer_32] - l_p
									l_i := l_i + 1
								end
							end
							if js.loop_increment then
								l_k := l_k + 1
							end
						end
						l_pos := -1 + 3 -- goto next_iteration
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
