class
	P_R250

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_r250.make
			create r250_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_rng_r250: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_r250

	set_gsl_rng_r250 (a_gsl_rng_r250: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_r250 := a_gsl_rng_r250
		end

	r250_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	r250_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_R250_STATE_T]
			l_k: NATURAL_32
			l_j: INTEGER_32
			l_i: INTEGER_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_R250_STATE_T]}.make_cast (a_vstate)
			l_i := l_state.item.i
			if l_i >= 147 then
				l_j := l_i - 147
			else
				l_j := l_i + 103
			end
			l_k := (l_state.item.x[l_i]).bit_xor (l_state.item.x[l_j])
			l_state.item.x[l_i] := l_k
			if l_i >= 249 then
				l_state.item.i := 0
			else
				l_state.item.i := l_i + 1
			end
			Result := l_k
		end

	r250_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent r250_get)
		end

	r250_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((r250_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	r250_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent r250_get_double)
		end

	r250_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_R250_STATE_T]
			l_i: INTEGER_32
			l_msb: NATURAL_32
			l_mask___0: NATURAL_32
			l_k: INTEGER_32
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_R250_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.i := 0
			l_i := 0
			from
			until
				not (l_i < 250)
			loop
				l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
				l_state.item.x[l_i] := l_s
				l_i := l_i + 1
			end
			l_msb := {NATURAL_32} 2_147_483_648
			l_mask___0 := {NATURAL_32} 4_294_967_295
			l_i := 0
			from
			until
				not (l_i < 32)
			loop
				l_k := 7 * l_i + 3
				l_state.item.x[l_k] := (l_state.item.x[l_k]).bit_and (l_mask___0)
				l_state.item.x[l_k] := (l_state.item.x[l_k]).bit_or (l_msb)
				l_mask___0 := (l_mask___0).bit_shift_right ((1))
				l_msb := (l_msb).bit_shift_right ((1))
				l_i := l_i + 1
			end
		end

	r250_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent r250_set)
		end

end
