class
	P_RAN0

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_ran0.make
			create ran0_type.make (<<1>>)
		end

feature {ANY} -- attributes

	a___1: INTEGER_32 assign set_a___1

	set_a___1 (a_a___1: INTEGER_32)
		do
			a___1 := a_a___1
		end

	gsl_rng_ran0: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_ran0

	set_gsl_rng_ran0 (a_gsl_rng_ran0: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_ran0 := a_gsl_rng_ran0
		end

	m___0: INTEGER_32 assign set_m___0

	set_m___0 (a_m___0: INTEGER_32)
		do
			m___0 := a_m___0
		end

	mask: NATURAL_32 assign set_mask

	set_mask (a_mask: NATURAL_32)
		do
			mask := a_mask
		end

	q___0: INTEGER_32 assign set_q___0

	set_q___0 (a_q___0: INTEGER_32)
		do
			q___0 := a_q___0
		end

	r___0: INTEGER_32 assign set_r___0

	set_r___0 (a_r___0: INTEGER_32)
		do
			r___0 := a_r___0
		end

	ran0_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran0_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN0_STATE_T]
			l_x: NATURAL_32
			l_h: INTEGER_32
			l_t: INTEGER_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RAN0_STATE_T]}.make_cast (a_vstate)
			l_x := l_state.item.x
			l_h := (l_x // q___0.to_natural_32).to_integer_32
			l_t := (a___1.to_natural_32 * (l_x - (l_h * q___0).to_natural_32) - (l_h * r___0).to_natural_32).to_integer_32
			if l_t < 0 then
				l_state.item.x := (l_t + m___0).to_natural_32
			else
				l_state.item.x := l_t.to_natural_32
			end
			Result := (l_state.item.x)
		end

	ran0_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran0_get)
		end

	ran0_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((ran0_get (a_vstate)).to_real_64 / 2147483647.0)
		end

	ran0_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran0_get_double)
		end

	ran0_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RAN0_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RAN0_STATE_T]}.make_cast (a_vstate)
			if a_s = mask then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("ran0 should not use seed == mask"), ce_string ("ran0.c"), 83, 4)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.x := (a_s).bit_xor (mask)
			end
		end

	ran0_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran0_set)
		end

end
