class
	P_RAN3

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_ran3.make
			create ran3_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_rng_ran3: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_ran3

	set_gsl_rng_ran3 (a_gsl_rng_ran3: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_ran3 := a_gsl_rng_ran3
		end

	ran3_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran3_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN3_STATE_T]
			l_j: INTEGER_32
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RAN3_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := (l_state.item.x) + 1
			if l_state.item.x = {NATURAL_32} 56 then
				l_state.item.x := {NATURAL_32} 1
			end
			l_state.item.y := (l_state.item.y) + 1
			if l_state.item.y = {NATURAL_32} 56 then
				l_state.item.y := {NATURAL_32} 1
			end
			l_j := (l_state.item.buffer[(l_state.item.x).to_integer_32] - l_state.item.buffer[(l_state.item.y).to_integer_32]).to_integer_32
			if l_j < 0 then
				l_j := l_j + (1_000_000_000)
			end
			l_state.item.buffer[(l_state.item.x).to_integer_32] := l_j.to_natural_32
			Result := l_j.to_natural_32
		end

	ran3_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran3_get)
		end

	ran3_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((ran3_get (a_vstate)).to_real_64 / (1_000_000_000).to_double)
		end

	ran3_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran3_get_double)
		end

	ran3_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN3_STATE_T]
			l_i: INTEGER_32
			l_i1: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n: INTEGER_32
			l_t: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_RAN3_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_j := (({NATURAL_32} 161_803_398 - l_s) \\ {NATURAL_32} 1_000_000_000).to_integer_32
			if l_j < 0 then
				l_j := l_j + (1_000_000_000)
			end
			l_state.item.buffer[0] := {NATURAL_32} 0
			l_state.item.buffer[55] := l_j.to_natural_32
			l_k := 1
			l_i := 1
			from
			until
				not (l_i < 55)
			loop
				l_n := (21 * l_i) \\ 55
				l_state.item.buffer[l_n] := l_k.to_natural_32
				l_k := l_j - l_k
				if l_k < 0 then
					l_k := l_k + (1_000_000_000)
				end
				l_j := (l_state.item.buffer[l_n]).to_integer_32
				l_i := l_i + 1
			end
			l_i1 := 0
			from
			until
				not (not js.loop_done and then (l_i1 < 4))
			loop
				l_i := 1
				from
				until
					not (l_i < 56)
				loop
					l_t := (l_state.item.buffer[l_i] - l_state.item.buffer[1 + (l_i + 30) \\ 55]).to_integer_32
					if l_t < 0 then
						l_t := l_t + (1_000_000_000)
					end
					l_state.item.buffer[l_i] := l_t.to_natural_32
					l_i := l_i + 1
				end
				l_i1 := l_i1 + 1
			end
			l_state.item.x := {NATURAL_32} 0
			l_state.item.y := {NATURAL_32} 31
		end

	ran3_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran3_set)
		end

end
