class
	P_RK2IMP

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_odeiv_step_rk2imp.make
			create rk2imp_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_odeiv_step_rk2imp: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE] assign set_gsl_odeiv_step_rk2imp

	set_gsl_odeiv_step_rk2imp (a_gsl_odeiv_step_rk2imp: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE])
		do
			gsl_odeiv_step_rk2imp := a_gsl_odeiv_step_rk2imp
		end

	rk2imp_type: CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]

feature {ANY} -- routines

	rk2imp_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK2IMP_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2IMP_STATE_T]}.make_cast ((malloc ((create {PD_RK2IMP_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for rk2imp_state"), ce_string ("rk2imp.c"), 58, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.Y1 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.Y1).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for Y1"), ce_string ("rk2imp.c"), 66, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.ytmp := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk2imp.c"), 75, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rk2imp.c"), 85, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y_onestep := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y_onestep"), ce_string ("rk2imp.c"), 96, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0_orig := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0_orig).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("rk2imp.c"), 108, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	rk2imp_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2imp_alloc)
		end

	rk2imp_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK2IMP_STATE_T]
			l_i: NATURAL_32
			l_Y1: CE_POINTER [REAL_64]
			l_y0___0: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_y0_orig: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			l_s___3: INTEGER_32
			l_s___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_Y1.make
			create l_y0___0.make
			create l_y_onestep.make
			create l_y0_orig.make

			l_state := create {CE_POINTER [PD_RK2IMP_STATE_T]}.make_cast (a_vstate)
			l_Y1 := l_state.item.Y1
			l_y0___0 := l_state.item.y0
			l_y_onestep := l_state.item.y_onestep
			l_y0_orig := l_state.item.y0_orig
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0_orig), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			if not a_dydt_in.is_void then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_Y1), create {CE_POINTER [ANY]}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			else
				l_s := ((a_sys.item.function).integer_32_item ([a_t, a_y, l_Y1, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_y_onestep), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___0 := (rk2imp_step (l_y_onestep, l_state, a_h, a_t, a_dim, a_sys))
				if l_s___0 /= 0 then
					Result := l_s___0
					js.return
				end
			end
			if not js.return_called then
				l_s___1 := (rk2imp_step (a_y, l_state, a_h / 2.0, a_t, a_dim, a_sys))
				if l_s___1 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___1
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + a_h / 2.0, a_y, l_Y1, a_sys.item.params]))
				if l_s___2 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___2
					js.return
				end
			end
			if not js.return_called then
				l_s___3 := (rk2imp_step (a_y, l_state, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys))
				if l_s___3 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___3
					js.return
				end
			end
			if not js.return_called and then (not a_dydt_out.is_void) then
				l_s___4 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
				if l_s___4 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___4
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := (4.0 * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])) / 3.0
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk2imp_apply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2imp_apply)
		end

	rk2imp_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK2IMP_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2IMP_STATE_T]}.make_cast (a_vstate)
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	rk2imp_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2imp_free)
		end

	rk2imp_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK2IMP_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2IMP_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_POINTER [PD_RK2IMP_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 2
		end

	rk2imp_order_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2imp_order)
		end

	rk2imp_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK2IMP_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2IMP_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk2imp_reset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2imp_reset)
		end

	rk2imp_step (a_y: CE_POINTER [REAL_64]; a_state: CE_POINTER [PD_RK2IMP_STATE_T]; a_h: REAL_64; a_t: REAL_64; a_dim: NATURAL_32; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_y0___0: CE_POINTER [REAL_64]
			l_Y1: CE_POINTER [REAL_64]
			l_ytmp: CE_POINTER [REAL_64]
			l_max_iter: INTEGER_32
			l_nu: INTEGER_32
			l_i: NATURAL_32
			l_s: INTEGER_32
			js: JUMP_STATE
		do
			create l_y0___0.make
			create l_Y1.make
			create l_ytmp.make

			l_y0___0 := a_state.item.y0
			l_Y1 := a_state.item.Y1
			l_ytmp := a_state.item.ytmp
			l_max_iter := 3
			l_nu := 0
			from
			until
				not (not js.loop_done and then (l_nu < l_max_iter))
			loop
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := (l_y0___0[l_i.to_integer_32] + ((0.5 * a_h) * l_Y1[l_i.to_integer_32]))
					l_i := l_i + 1
				end
				l_s := ((a_sys.item.function).integer_32_item ([a_t + 0.5 * a_h, l_ytmp, l_Y1, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
				if not js.return_called then
					l_nu := l_nu + 1
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_y[l_i.to_integer_32] := (l_y0___0[l_i.to_integer_32] + (a_h * l_Y1[l_i.to_integer_32]))
					l_i := l_i + 1
				end
				Result := 0
			end
		end

end
