class
	P_RK2SIMP

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_odeiv_step_rk2simp.make
			create rk2simp_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_odeiv_step_rk2simp: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE] assign set_gsl_odeiv_step_rk2simp

	set_gsl_odeiv_step_rk2simp (a_gsl_odeiv_step_rk2simp: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE])
		do
			gsl_odeiv_step_rk2simp := a_gsl_odeiv_step_rk2simp
		end

	rk2simp_type: CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]

feature {ANY} -- routines

	rk2simp_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2SIMP_STATE_T]}.make_cast ((malloc ((create {PD_RK2SIMP_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for rk2simp_state"), ce_string ("rk2simp.c"), 62, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.Y1 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.Y1).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for Y1"), ce_string ("rk2simp.c"), 70, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rk2simp.c"), 79, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0_orig := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0_orig).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("rk2simp.c"), 89, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.ytmp := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk2simp.c"), 100, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.dfdy := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_dim * a_dim) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.dfdy).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for dfdy"), ce_string ("rk2simp.c"), 112, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.dfdt := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.dfdt).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.dfdy))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for dfdt"), ce_string ("rk2simp.c"), 125, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y_onestep := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.dfdy))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.dfdt))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y_onestep"), ce_string ("rk2simp.c"), 139, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.p := init_inst.gsl_permutation_alloc (a_dim)
				if (l_state.item.p).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.dfdy))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.dfdt))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for p"), ce_string ("rk2simp.c"), 153, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	rk2simp_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2simp_alloc)
		end

	rk2simp_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
			l_i: NATURAL_32
			l_y0___0: CE_POINTER [REAL_64]
			l_y0_orig: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_y0___0.make
			create l_y0_orig.make
			create l_y_onestep.make

			l_state := create {CE_POINTER [PD_RK2SIMP_STATE_T]}.make_cast (a_vstate)
			l_y0___0 := l_state.item.y0
			l_y0_orig := l_state.item.y0_orig
			l_y_onestep := l_state.item.y_onestep
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0_orig), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y_onestep), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			l_s := (rk2simp_step (l_y_onestep, l_state, a_h, a_t, a_dim, a_sys))
			if l_s /= 0 then
				Result := l_s
				js.return
			end
			if not js.return_called then
				l_s___0 := (rk2simp_step (a_y, l_state, a_h / 2.0, a_t, a_dim, a_sys))
				if l_s___0 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___0
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0___0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___1 := (rk2simp_step (a_y, l_state, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys))
				if l_s___1 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___1
					js.return
				end
			end
			if not js.return_called and then (not a_dydt_out.is_void) then
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
				if l_s___2 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___2
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := (4.0 * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])) / 3.0
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk2simp_apply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2simp_apply)
		end

	rk2simp_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2SIMP_STATE_T]}.make_cast (a_vstate)
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.dfdy))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.dfdt))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep))
			init_inst.gsl_permutation_free (l_state.item.p)
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	rk2simp_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2simp_free)
		end

	rk2simp_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2SIMP_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_POINTER [PD_RK2SIMP_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 2
		end

	rk2simp_order_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2simp_order)
		end

	rk2simp_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK2SIMP_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.Y1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0_orig), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.dfdt), 0, (a_dim * a_dim) * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.dfdt), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk2simp_reset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk2simp_reset)
		end

	rk2simp_step (a_y: CE_POINTER [REAL_64]; a_state: CE_POINTER [PD_RK2SIMP_STATE_T]; a_h: REAL_64; a_t: REAL_64; a_dim: NATURAL_32; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_y0___0: CE_POINTER [REAL_64]
			l_Y1: CE_POINTER [REAL_64]
			l_ytmp: CE_POINTER [REAL_64]
			l_i: NATURAL_32
			l_s: INTEGER_32
			l_ps: CE_ARRAY [INTEGER_32]
			l_J: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_y0_view: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_ytmp_view: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_Y1_view: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			js: JUMP_STATE
		do
			create l_y0___0.make
			create l_Y1.make
			create l_ytmp.make
			create l_ps.make (<<1>>)
			create l_J.make (<<1>>)
			create l_y0_view.make (<<1>>)
			create l_ytmp_view.make (<<1>>)
			create l_Y1_view.make (<<1>>)

			l_y0___0 := a_state.item.y0
			l_Y1 := a_state.item.Y1
			l_ytmp := a_state.item.ytmp
			l_J.item := (view_source_inst.gsl_matrix_view_array (a_state.item.dfdy, a_dim, a_dim)).twin
			l_s := (a_sys.item.jacobian).integer_32_item ([a_t, l_y0___0, a_state.item.dfdy, a_state.item.dfdt, a_sys.item.params])
			if l_s /= 0 then
				Result := l_s
				js.return
			end
			if not js.return_called then
				oper_source_inst.gsl_matrix_scale (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_J.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), -a_h / 2.0).do_nothing
				oper_source_inst.gsl_matrix_add_diagonal (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_J.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), 1.0).do_nothing
				l_s := l_s + (lu_inst.gsl_linalg_LU_decomp (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_J.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix")), a_state.item.p, l_ps))
				if l_s /= 0 then
					Result := 5
					js.return
				end
			end
			if not js.return_called then
				l_s := (a_sys.item.function).integer_32_item ([a_t + 0.5 * a_h, l_y0___0, l_ytmp, a_sys.item.params])
				if l_s /= 0 then
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				l_y0_view.item := (view_source_inst.gsl_vector_const_view_array (l_y0___0, a_dim)).twin
				l_ytmp_view.item := (view_source_inst.gsl_vector_view_array (l_ytmp, a_dim)).twin
				l_Y1_view.item := (view_source_inst.gsl_vector_view_array (l_Y1, a_dim)).twin
				l_s := lu_inst.gsl_linalg_LU_solve ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_J.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))), a_state.item.p, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ytmp_view.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_Y1_view.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
				oper_source_inst.gsl_vector_scale (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_Y1_view.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), 0.5 * a_h).do_nothing
				oper_source_inst.gsl_vector_add (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_Y1_view.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y0_view.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector")))).do_nothing
				l_s := (a_sys.item.function).integer_32_item ([a_t + 0.5 * a_h, l_Y1, l_ytmp, a_sys.item.params])
				if l_s /= 0 then
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_y[l_i.to_integer_32] := (l_y0___0[l_i.to_integer_32] + (a_h * l_ytmp[l_i.to_integer_32]))
					l_i := l_i + 1
				end
				Result := l_s
			end
		end

end
