class
	P_RK4

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_odeiv_step_rk4.make
			create rk4_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_odeiv_step_rk4: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE] assign set_gsl_odeiv_step_rk4

	set_gsl_odeiv_step_rk4 (a_gsl_odeiv_step_rk4: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE])
		do
			gsl_odeiv_step_rk4 := a_gsl_odeiv_step_rk4
		end

	rk4_type: CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]

feature {ANY} -- routines

	rk4_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK4_STATE_T]}.make_cast ((malloc ((create {PD_RK4_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for rk4_state"), ce_string ("rk4.c"), 57, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_state.item.k := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for k"), ce_string ("rk4.c"), 65, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.k1 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k1).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for k1"), ce_string ("rk4.c"), 74, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y0 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rk4.c"), 84, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.ytmp := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk4.c"), 95, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_state.item.y_onestep := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk4.c"), 107, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	rk4_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4_alloc)
		end

	rk4_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
			l_i: NATURAL_32
			l_k: CE_POINTER [REAL_64]
			l_k1: CE_POINTER [REAL_64]
			l_y0: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			l_s___3: INTEGER_32
			l_s___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_k.make
			create l_k1.make
			create l_y0.make
			create l_y_onestep.make

			l_state := create {CE_POINTER [PD_RK4_STATE_T]}.make_cast (a_vstate)
			l_k := l_state.item.k
			l_k1 := l_state.item.k1
			l_y0 := l_state.item.y0
			l_y_onestep := l_state.item.y_onestep
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			if not a_dydt_in.is_void then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k), create {CE_POINTER [ANY]}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			else
				l_s := ((a_sys.item.function).integer_32_item ([a_t, l_y0, l_k, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k1), create {CE_POINTER [ANY]}.make_cast (l_k), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_y_onestep), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___0 := (rk4_step (l_y_onestep, l_state, a_h, a_t, a_dim, a_sys))
				if l_s___0 /= 0 then
					Result := l_s___0
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k), create {CE_POINTER [ANY]}.make_cast (l_k1), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___1 := (rk4_step (a_y, l_state, a_h / 2.0, a_t, a_dim, a_sys))
				if l_s___1 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___1
					js.return
				end
			end
			if not js.return_called then
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + a_h / 2.0, a_y, l_k, a_sys.item.params]))
				if l_s___2 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___2
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k1), create {CE_POINTER [ANY]}.make_cast (l_y0), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___3 := (rk4_step (a_y, l_state, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys))
				if l_s___3 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_k1), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___3
					js.return
				end
			end
			if not js.return_called and then (not a_dydt_out.is_void) then
				l_s___4 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
				if l_s___4 /= 0 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_k1), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___4
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := (4.0 * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])) / 15.0
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk4_apply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4_apply)
		end

	rk4_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK4_STATE_T]}.make_cast (a_vstate)
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep))
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	rk4_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4_free)
		end

	rk4_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK4_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_POINTER [PD_RK4_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 4
		end

	rk4_order_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4_order)
		end

	rk4_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RK4_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y_onestep), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk4_reset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk4_reset)
		end

	rk4_step (a_y: CE_POINTER [REAL_64]; a_state: CE_POINTER [PD_RK4_STATE_T]; a_h: REAL_64; a_t: REAL_64; a_dim: NATURAL_32; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_y0: CE_POINTER [REAL_64]
			l_ytmp: CE_POINTER [REAL_64]
			l_k: CE_POINTER [REAL_64]
			l_i: NATURAL_32
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_y0.make
			create l_ytmp.make
			create l_k.make

			l_y0 := a_state.item.y0
			l_ytmp := a_state.item.ytmp
			l_k := a_state.item.k
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_dim)
			loop
				a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + ((a_h / 6.0) * l_k[l_i.to_integer_32])
				l_ytmp[l_i.to_integer_32] := (l_y0[l_i.to_integer_32] + ((0.5 * a_h) * l_k[l_i.to_integer_32]))
				l_i := l_i + 1
			end
			l_s := ((a_sys.item.function).integer_32_item ([a_t + 0.5 * a_h, l_ytmp, l_k, a_sys.item.params]))
			if l_s /= 0 then
				Result := l_s
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + ((a_h / 3.0) * l_k[l_i.to_integer_32])
					l_ytmp[l_i.to_integer_32] := (l_y0[l_i.to_integer_32] + ((0.5 * a_h) * l_k[l_i.to_integer_32]))
					l_i := l_i + 1
				end
				l_s___0 := ((a_sys.item.function).integer_32_item ([a_t + 0.5 * a_h, l_ytmp, l_k, a_sys.item.params]))
				if l_s___0 /= 0 then
					Result := l_s___0
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + ((a_h / 3.0) * l_k[l_i.to_integer_32])
					l_ytmp[l_i.to_integer_32] := (l_y0[l_i.to_integer_32] + (a_h * l_k[l_i.to_integer_32]))
					l_i := l_i + 1
				end
				l_s___1 := ((a_sys.item.function).integer_32_item ([a_t + a_h, l_ytmp, l_k, a_sys.item.params]))
				if l_s___1 /= 0 then
					Result := l_s___1
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + ((a_h / 6.0) * l_k[l_i.to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
			end
		end

end
