class
	P_SLATEC

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_slatec.make
			create slatec_type.make (<<1>>)
		end

feature {ANY} -- attributes

	P: INTEGER_32 assign set_P

	set_P (a_P: INTEGER_32)
		do
			P := a_P
		end

	a0___0: INTEGER_32 assign set_a0___0

	set_a0___0 (a_a0___0: INTEGER_32)
		do
			a0___0 := a_a0___0
		end

	a1___1: INTEGER_32 assign set_a1___1

	set_a1___1 (a_a1___1: INTEGER_32)
		do
			a1___1 := a_a1___1
		end

	a1ma0: INTEGER_32 assign set_a1ma0

	set_a1ma0 (a_a1ma0: INTEGER_32)
		do
			a1ma0 := a_a1ma0
		end

	c: INTEGER_32 assign set_c

	set_c (a_c: INTEGER_32)
		do
			c := a_c
		end

	gsl_rng_slatec: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_slatec

	set_gsl_rng_slatec (a_gsl_rng_slatec: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_slatec := a_gsl_rng_slatec
		end

	slatec_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	slatec_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_y0: INTEGER_32
			l_y1: INTEGER_32
			l_state: CE_POINTER [PD_SLATEC_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_SLATEC_STATE_T]}.make_cast (a_vstate)
			l_y0 := (a0___0 * l_state.item.x0)
			l_y1 := ((a1___1 * l_state.item.x1 + a1ma0 * (l_state.item.x0 - l_state.item.x1)) + l_y0)
			l_y0 := l_y0 + c
			l_state.item.x0 := l_y0 \\ 2_048
			l_y1 := l_y1 + ((l_y0 - l_state.item.x0) // 2_048)
			l_state.item.x1 := l_y1 \\ 2_048
			Result := (l_state.item.x1 * 2_048 + l_state.item.x0).to_natural_32
		end

	slatec_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent slatec_get)
		end

	slatec_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((slatec_get (a_vstate)).to_real_64 / 4194304.0)
		end

	slatec_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent slatec_get_double)
		end

	slatec_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_SLATEC_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_SLATEC_STATE_T]}.make_cast (a_vstate)
			l_s := l_s \\ ({NATURAL_32} 8)
			l_s := l_s * (P // 8).to_natural_32
			l_state.item.x0 := (l_s \\ {NATURAL_32} 2_048).to_integer_32
			l_state.item.x1 := ((l_s - (l_state.item.x0).to_natural_32) // {NATURAL_32} 2_048).to_integer_32
		end

	slatec_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent slatec_set)
		end

end
