class
	P_SORT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	downheap___0 (a_data: CE_POINTER [ANY]; a_size: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32; a_compare: CE_ROUTINE)
		local
			l_k: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			from
			until
				not (not js.loop_done and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if (a_compare.integer_32_item ([create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_data) + (a_size * l_j).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_data) + (a_size * (l_j + {NATURAL_32} 1)).to_integer_32))])) < 0 then
						l_j := l_j + 1
					end
				end
				if (a_compare.integer_32_item ([create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_data) + (a_size * l_k).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_data) + (a_size * l_j).to_integer_32))])) < 0 then
					shuffle_inst.swap (a_data, a_size, l_j, l_k)
				else
					js.break
				end
				if not js.loop_jumped then
					l_k := l_j
				end
			end
		end

	gsl_eigen_genhermv_sort (a_eval: CE_POINTER [PD_GSL_VECTOR]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_sort_type: NATURAL_32): INTEGER_32
		local
			l_s: INTEGER_32
		do
			l_s := gsl_eigen_hermv_sort (a_eval, a_evec, a_sort_type)
			Result := l_s
		end

	gsl_eigen_gensymmv_sort (a_eval: CE_POINTER [PD_GSL_VECTOR]; a_evec: CE_POINTER [PD_GSL_MATRIX]; a_sort_type: NATURAL_32): INTEGER_32
		local
			l_s: INTEGER_32
		do
			l_s := gsl_eigen_symmv_sort (a_eval, a_evec, a_sort_type)
			Result := l_s
		end

	gsl_eigen_genv_sort (a_alpha: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: CE_POINTER [PD_GSL_VECTOR]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_sort_type: NATURAL_32): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_ak: PD_GSL_COMPLEX
			l_bk: REAL_64
			l_ek: PD_GSL_COMPLEX
			l_tmp___4: INTEGER_32
			l_tmp___8: INTEGER_32
			l_test: INTEGER_32
			l_aj: PD_GSL_COMPLEX
			l_bj: REAL_64
			l_ej: PD_GSL_COMPLEX
			l_tmp___14: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: REAL_64
			l_tmp___21: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ak.make
			create l_ek.make
			create l_aj.make
			create l_ej.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_evec.item.size1 = a_evec.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("eigenvector matrix must be square"), ce_string ("sort.c"), 266, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 3 then -- else:
						if a_alpha.item.size = a_evec.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 6 then -- else:
						if a_beta.item.size = a_evec.item.size1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("eigenvalues must match eigenvector matrix"), ce_string ("sort.c"), 270, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 9 then -- else:
						l_N := a_alpha.item.size
						l_i := (0).to_natural_32
				when 10 then -- loop condition:
						if not (not js.loop_done and then (l_i < l_N - {NATURAL_32} 1)) then
							l_pos := -1 + 19 -- skip loop
						end
				when 11 then -- loop body:
						l_k := l_i
						l_ak := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_alpha, l_i)).twin
						l_bk := (gsl_gsl_vector_double_inst.gsl_vector_get (a_beta, l_i))
						if l_bk < 2.2204460492503131e-16 then
							from
							until
								js.loop_done
							loop
								if l_ak.dat[0] >= 0.0 then
									l_tmp___4 := 1
								else
									l_tmp___4 := -1
								end
								if l_tmp___4.to_boolean then
									l_ek.dat[0] := (builtin_inff).to_double
								else
									l_ek.dat[0] := (-(builtin_inff)).to_double
								end
								if l_ak.dat[1] >= 0.0 then
									l_tmp___8 := 1
								else
									l_tmp___8 := -1
								end
								if l_tmp___8.to_boolean then
									l_ek.dat[1] := (builtin_inff).to_double
								else
									l_ek.dat[1] := (-(builtin_inff)).to_double
								end
								js.break
							end
						else
							l_ek := (math_inst.gsl_complex_div_real (l_ak.twin, l_bk)).twin
						end
						l_j := l_i + {NATURAL_32} 1
				when 12 then -- loop condition:
						if not (not js.loop_done and then (l_j < l_N)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 13 then -- loop body:
						l_aj := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_alpha, l_j)).twin
						l_bj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_beta, l_j))
						if l_bj < 2.2204460492503131e-16 then
							from
							until
								js.loop_done
							loop
								if l_aj.dat[0] >= 0.0 then
									l_tmp___14 := 1
								else
									l_tmp___14 := -1
								end
								if l_tmp___14.to_boolean then
									l_ej.dat[0] := (builtin_inff).to_double
								else
									l_ej.dat[0] := (-(builtin_inff)).to_double
								end
								if l_aj.dat[1] >= 0.0 then
									l_tmp___18 := 1
								else
									l_tmp___18 := -1
								end
								if l_tmp___18.to_boolean then
									l_ej.dat[1] := (builtin_inff).to_double
								else
									l_ej.dat[1] := (-(builtin_inff)).to_double
								end
								js.break
							end
						else
							l_ej := (math_inst.gsl_complex_div_real (l_aj.twin, l_bj)).twin
						end
						inspect a_sort_type.to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 14
						when 3 then l_pos := -1 + 15
						else l_pos := -1 + 16
						end
				when 14 then -- switch 1, case 2
						l_tmp___19 := math_inst.gsl_complex_abs (l_ej.twin)
						l_test := (l_tmp___19 < (math_inst.gsl_complex_abs (l_ek.twin))).to_integer
						l_pos := -1 + 17 -- switch 1; break
				when 15 then -- switch 1, case 3
						l_tmp___21 := math_inst.gsl_complex_abs (l_ej.twin)
						l_test := (l_tmp___21 > (math_inst.gsl_complex_abs (l_ek.twin))).to_integer
						l_pos := -1 + 17 -- switch 1; break
				when 16 then -- switch 1, default:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("invalid sort type"), ce_string ("sort.c"), 323, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 17 then -- switch 1, done:
						if not js.return_called then
							if l_test.to_boolean then
								l_k := l_j
								l_ek := l_ej.twin
							end
							l_j := l_j + 1
						end
						l_pos := -1 + 12 -- back to loop condition
				when 18 then -- loop done
						if not js.return_called then
							if l_k /= l_i then
								swap_source_inst.gsl_vector_complex_swap_elements (a_alpha, l_i, l_k).do_nothing
								swap_source_inst.gsl_vector_swap_elements (a_beta, l_i, l_k).do_nothing
								swap_source_inst.gsl_matrix_complex_swap_columns (a_evec, l_i, l_k).do_nothing
							end
							l_i := l_i + 1
						end
						l_pos := -1 + 10 -- back to loop condition
				when 19 then -- loop done
						if not js.return_called then
							Result := 0
							js.return
						end
				when 20 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 21 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_eigen_hermv_sort (a_eval: CE_POINTER [PD_GSL_VECTOR]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_sort_type: NATURAL_32): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_ek: REAL_64
			l_test: INTEGER_32
			l_ej: REAL_64
			l_tmp___1: REAL_64
			l_tmp___3: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_evec.item.size1 = a_evec.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("eigenvector matrix must be square"), ce_string ("sort.c"), 108, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if a_eval.item.size = a_evec.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("eigenvalues must match eigenvector matrix"), ce_string ("sort.c"), 112, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						l_N := a_eval.item.size
						l_i := (0).to_natural_32
				when 7 then -- loop condition:
						if not (not js.loop_done and then (l_i < l_N - {NATURAL_32} 1)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 8 then -- loop body:
						l_k := l_i
						l_ek := (gsl_gsl_vector_double_inst.gsl_vector_get (a_eval, l_i))
						l_j := l_i + {NATURAL_32} 1
				when 9 then -- loop condition:
						if not (not js.loop_done and then (l_j < l_N)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 10 then -- loop body:
						l_ej := (gsl_gsl_vector_double_inst.gsl_vector_get (a_eval, l_j))
						inspect a_sort_type.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 11
						when 1 then l_pos := -1 + 12
						when 2 then l_pos := -1 + 13
						when 3 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 11 then -- switch 1, case 0
						l_test := (l_ej < l_ek).to_integer
						l_pos := -1 + 16 -- switch 1; break
				when 12 then -- switch 1, case 1
						l_test := (l_ej > l_ek).to_integer
						l_pos := -1 + 16 -- switch 1; break
				when 13 then -- switch 1, case 2
						l_tmp___1 := fabs (l_ej)
						l_test := (l_tmp___1 < (fabs (l_ek))).to_integer
						l_pos := -1 + 16 -- switch 1; break
				when 14 then -- switch 1, case 3
						l_tmp___3 := fabs (l_ej)
						l_test := (l_tmp___3 > (fabs (l_ek))).to_integer
						l_pos := -1 + 16 -- switch 1; break
				when 15 then -- switch 1, default:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("unrecognized sort type"), ce_string ("sort.c"), 147, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 16 then -- switch 1, done:
						if not js.return_called then
							if l_test.to_boolean then
								l_k := l_j
								l_ek := l_ej
							end
							l_j := l_j + 1
						end
						l_pos := -1 + 9 -- back to loop condition
				when 17 then -- loop done
						if not js.return_called then
							if l_k /= l_i then
								swap_source_inst.gsl_vector_swap_elements (a_eval, l_i, l_k).do_nothing
								swap_source_inst.gsl_matrix_complex_swap_columns (a_evec, l_i, l_k).do_nothing
							end
							l_i := l_i + 1
						end
						l_pos := -1 + 7 -- back to loop condition
				when 18 then -- loop done
						if not js.return_called then
							Result := 0
							js.return
						end
				when 19 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_eigen_nonsymmv_sort (a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_sort_type: NATURAL_32): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_ek: PD_GSL_COMPLEX
			l_test: INTEGER_32
			l_ej: PD_GSL_COMPLEX
			l_tmp___1: REAL_64
			l_tmp___3: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ek.make
			create l_ej.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_evec.is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_evec.item.size1 /= a_evec.item.size2 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("eigenvector matrix must be square"), ce_string ("sort.c"), 178, 20)
								Result := 20
								js.return
								if not js.return_called then
									js.break
								end
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 3 then -- else: | _L___0:
						if a_evec.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_eval.item.size /= a_evec.item.size1 then
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("eigenvalues must match eigenvector matrix"), ce_string ("sort.c"), 182, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 6 then -- else: | _L:
						l_N := a_eval.item.size
						l_i := (0).to_natural_32
				when 7 then -- loop condition:
						if not (not js.loop_done and then (l_i < l_N - {NATURAL_32} 1)) then
							l_pos := -1 + 16 -- skip loop
						end
				when 8 then -- loop body:
						l_k := l_i
						l_ek := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_eval, l_i)).twin
						l_j := l_i + {NATURAL_32} 1
				when 9 then -- loop condition:
						if not (not js.loop_done and then (l_j < l_N)) then
							l_pos := -1 + 15 -- skip loop
						end
				when 10 then -- loop body:
						l_ej := (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_eval, l_j)).twin
						inspect a_sort_type.to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 11
						when 3 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 11 then -- switch 1, case 2
						l_tmp___1 := math_inst.gsl_complex_abs (l_ej.twin)
						l_test := (l_tmp___1 < (math_inst.gsl_complex_abs (l_ek.twin))).to_integer
						l_pos := -1 + 14 -- switch 1; break
				when 12 then -- switch 1, case 3
						l_tmp___3 := math_inst.gsl_complex_abs (l_ej.twin)
						l_test := (l_tmp___3 > (math_inst.gsl_complex_abs (l_ek.twin))).to_integer
						l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, default:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("invalid sort type"), ce_string ("sort.c"), 213, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 14 then -- switch 1, done:
						if not js.return_called then
							if l_test.to_boolean then
								l_k := l_j
								l_ek := l_ej.twin
							end
							l_j := l_j + 1
						end
						l_pos := -1 + 9 -- back to loop condition
				when 15 then -- loop done
						if not js.return_called then
							if l_k /= l_i then
								swap_source_inst.gsl_vector_complex_swap_elements (a_eval, l_i, l_k).do_nothing
								if (not a_evec.is_void) then
									swap_source_inst.gsl_matrix_complex_swap_columns (a_evec, l_i, l_k).do_nothing
								end
							end
							l_i := l_i + 1
						end
						l_pos := -1 + 7 -- back to loop condition
				when 16 then -- loop done
						if not js.return_called then
							Result := 0
							js.return
						end
				when 17 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 18 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_eigen_symmv_sort (a_eval: CE_POINTER [PD_GSL_VECTOR]; a_evec: CE_POINTER [PD_GSL_MATRIX]; a_sort_type: NATURAL_32): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_ek: REAL_64
			l_test: INTEGER_32
			l_ej: REAL_64
			l_tmp___1: REAL_64
			l_tmp___3: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_evec.item.size1 = a_evec.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("eigenvector matrix must be square"), ce_string ("sort.c"), 38, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if a_eval.item.size = a_evec.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("eigenvalues must match eigenvector matrix"), ce_string ("sort.c"), 42, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						l_N := a_eval.item.size
						l_i := (0).to_natural_32
				when 7 then -- loop condition:
						if not (not js.loop_done and then (l_i < l_N - {NATURAL_32} 1)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 8 then -- loop body:
						l_k := l_i
						l_ek := (gsl_gsl_vector_double_inst.gsl_vector_get (a_eval, l_i))
						l_j := l_i + {NATURAL_32} 1
				when 9 then -- loop condition:
						if not (not js.loop_done and then (l_j < l_N)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 10 then -- loop body:
						l_ej := (gsl_gsl_vector_double_inst.gsl_vector_get (a_eval, l_j))
						inspect a_sort_type.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 11
						when 1 then l_pos := -1 + 12
						when 2 then l_pos := -1 + 13
						when 3 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 11 then -- switch 1, case 0
						l_test := (l_ej < l_ek).to_integer
						l_pos := -1 + 16 -- switch 1; break
				when 12 then -- switch 1, case 1
						l_test := (l_ej > l_ek).to_integer
						l_pos := -1 + 16 -- switch 1; break
				when 13 then -- switch 1, case 2
						l_tmp___1 := fabs (l_ej)
						l_test := (l_tmp___1 < (fabs (l_ek))).to_integer
						l_pos := -1 + 16 -- switch 1; break
				when 14 then -- switch 1, case 3
						l_tmp___3 := fabs (l_ej)
						l_test := (l_tmp___3 > (fabs (l_ek))).to_integer
						l_pos := -1 + 16 -- switch 1; break
				when 15 then -- switch 1, default:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("unrecognized sort type"), ce_string ("sort.c"), 77, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 16 then -- switch 1, done:
						if not js.return_called then
							if l_test.to_boolean then
								l_k := l_j
								l_ek := l_ej
							end
							l_j := l_j + 1
						end
						l_pos := -1 + 9 -- back to loop condition
				when 17 then -- loop done
						if not js.return_called then
							if l_k /= l_i then
								swap_source_inst.gsl_vector_swap_elements (a_eval, l_i, l_k).do_nothing
								swap_source_inst.gsl_matrix_swap_columns (a_evec, l_i, l_k).do_nothing
							end
							l_i := l_i + 1
						end
						l_pos := -1 + 7 -- back to loop condition
				when 18 then -- loop done
						if not js.return_called then
							Result := 0
							js.return
						end
				when 19 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_heapsort (a_data: CE_POINTER [ANY]; a_count: NATURAL_32; a_size: NATURAL_32; a_compare: CE_ROUTINE)
		local
			l_N: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			if a_count = {NATURAL_32} 0 then
				js.return
			end
			if not js.return_called then
				l_N := a_count - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_done
				loop
					l_k := l_k - 1
					downheap___0 (a_data, a_size, l_N, l_k, a_compare)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					shuffle_inst.swap (a_data, a_size, (0).to_natural_32, l_N)
					l_N := l_N - 1
					downheap___0 (a_data, a_size, l_N, (0).to_natural_32, a_compare)
				end
			end
		end

end
