class
	P_TAUS

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_taus.make
			create gsl_rng_taus2.make
			create taus2_type.make (<<1>>)
			create taus_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_rng_taus: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_taus

	set_gsl_rng_taus (a_gsl_rng_taus: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_taus := a_gsl_rng_taus
		end

	gsl_rng_taus2: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_taus2

	set_gsl_rng_taus2 (a_gsl_rng_taus2: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_taus2 := a_gsl_rng_taus2
		end

	taus2_type: CE_ARRAY [PD_GSL_RNG_TYPE]

	taus_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	taus2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_TAUS_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_TAUS_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.s1 := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.s1 < {NATURAL_32} 2 then
				l_state.item.s1 := l_state.item.s1 + ({NATURAL_32} 2)
			end
			l_state.item.s2 := ({NATURAL_32} 69_069 * l_state.item.s1).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.s2 < {NATURAL_32} 8 then
				l_state.item.s2 := l_state.item.s2 + ({NATURAL_32} 8)
			end
			l_state.item.s3 := ({NATURAL_32} 69_069 * l_state.item.s2).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.s3 < {NATURAL_32} 16 then
				l_state.item.s3 := l_state.item.s3 + ({NATURAL_32} 16)
			end
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
		end

	taus2_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent taus2_set)
		end

	taus_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_TAUS_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_TAUS_STATE_T]}.make_cast (a_vstate)
			l_state.item.s1 := (((((((l_state.item.s1).bit_and ({NATURAL_32} 4_294_967_294))).bit_shift_left (12))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (((((((((l_state.item.s1).bit_shift_left (13))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.s1))).bit_shift_right (19)))
			l_state.item.s2 := (((((((l_state.item.s2).bit_and ({NATURAL_32} 4_294_967_288))).bit_shift_left (4))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (((((((((l_state.item.s2).bit_shift_left (2))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.s2))).bit_shift_right (25)))
			l_state.item.s3 := (((((((l_state.item.s3).bit_and ({NATURAL_32} 4_294_967_280))).bit_shift_left (17))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (((((((((l_state.item.s3).bit_shift_left (3))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.s3))).bit_shift_right (11)))
			Result := ((((l_state.item.s1).bit_xor (l_state.item.s2))).bit_xor (l_state.item.s3))
		end

	taus_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent taus_get)
		end

	taus_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((taus_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	taus_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent taus_get_double)
		end

	taus_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_TAUS_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_TAUS_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.s1 := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.s2 := ({NATURAL_32} 69_069 * l_state.item.s1).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.s3 := ({NATURAL_32} 69_069 * l_state.item.s2).bit_and ({NATURAL_32} 4_294_967_295)
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
		end

	taus_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent taus_set)
		end

end
