class
	P_TTEST_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_stats_char_ttest (a_data1: CE_POINTER [INTEGER_8]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [INTEGER_8]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_char_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_char_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_char_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_float_ttest (a_data1: CE_POINTER [REAL_32]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [REAL_32]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_float_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_float_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_float_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_int_ttest (a_data1: CE_POINTER [INTEGER_32]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [INTEGER_32]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_int_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_int_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_int_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_long_double_ttest (a_data1: CE_POINTER [REAL_96]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [REAL_96]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_long_double_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_long_double_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_long_double_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_long_ttest (a_data1: CE_POINTER [INTEGER_32]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [INTEGER_32]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_long_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_long_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_long_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_short_ttest (a_data1: CE_POINTER [INTEGER_16]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [INTEGER_16]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_short_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_short_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_short_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_ttest (a_data1: CE_POINTER [REAL_64]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [REAL_64]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_uchar_ttest (a_data1: CE_POINTER [NATURAL_8]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [NATURAL_8]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_uchar_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_uchar_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_uchar_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_uint_ttest (a_data1: CE_POINTER [NATURAL_32]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [NATURAL_32]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_uint_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_uint_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_uint_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_ulong_ttest (a_data1: CE_POINTER [NATURAL_32]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [NATURAL_32]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_ulong_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_ulong_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_ulong_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

	gsl_stats_ushort_ttest (a_data1: CE_POINTER [NATURAL_16]; a_stride1: NATURAL_32; a_n1: NATURAL_32; a_data2: CE_POINTER [NATURAL_16]; a_stride2: NATURAL_32; a_n2: NATURAL_32): REAL_64
		local
			l_mean1: REAL_64
			l_mean2: REAL_64
			l_pv: REAL_64
			l_t: REAL_64
		do
			l_mean1 := (mean_source_inst.gsl_stats_ushort_mean (a_data1, a_stride1, a_n1))
			l_mean2 := (mean_source_inst.gsl_stats_ushort_mean (a_data2, a_stride2, a_n2))
			l_pv := (p_variance_source_inst.gsl_stats_ushort_pvariance (a_data1, a_stride1, a_n1, a_data2, a_stride2, a_n2))
			l_t := (l_mean1 - l_mean2) / (sqrt (l_pv * (1.0 / a_n1.to_real_64 + 1.0 / a_n2.to_real_64)))
			Result := l_t
		end

end
