class
	P_VAX

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_vax.make
			create vax_type.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_rng_vax: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_vax

	set_gsl_rng_vax (a_gsl_rng_vax: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_vax := a_gsl_rng_vax
		end

	vax_type: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	vax_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_VAX_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_VAX_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := (({NATURAL_32} 69_069 * l_state.item.x + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
			Result := (l_state.item.x)
		end

	vax_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vax_get)
		end

	vax_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((vax_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	vax_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vax_get_double)
		end

	vax_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_VAX_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_VAX_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := a_s
		end

	vax_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vax_set)
		end

end
