class
	P_WAVELET

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_wavelet_alloc (a_T: CE_POINTER [PD_GSL_WAVELET_TYPE]; a_k: NATURAL_32): CE_POINTER [PD_GSL_WAVELET]
		local
			l_status: INTEGER_32
			l_w: CE_POINTER [PD_GSL_WAVELET]
			js: JUMP_STATE
		do
			create l_w.make

			l_w := create {CE_POINTER [PD_GSL_WAVELET]}.make_cast ((malloc ((create {PD_GSL_WAVELET}.make).structure_size.to_natural_32)))
			if l_w.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for wavelet struct"), ce_string ("wavelet.c"), 35, 8)
					Result := (create {CE_POINTER [PD_GSL_WAVELET]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_w.item.type := a_T
				l_status := (a_T.item.init).integer_32_item ([create {CE_POINTER [CE_POINTER [REAL_64]]}.make_shared (l_w.c_pointer + (create {PD_GSL_WAVELET}.make).offset_of ("h1")), create {CE_POINTER [CE_POINTER [REAL_64]]}.make_shared (l_w.c_pointer + (create {PD_GSL_WAVELET}.make).offset_of ("g1")), create {CE_POINTER [CE_POINTER [REAL_64]]}.make_shared (l_w.c_pointer + (create {PD_GSL_WAVELET}.make).offset_of ("h2")), create {CE_POINTER [CE_POINTER [REAL_64]]}.make_shared (l_w.c_pointer + (create {PD_GSL_WAVELET}.make).offset_of ("g2")), create {CE_POINTER [NATURAL_32]}.make_shared (l_w.c_pointer + (create {PD_GSL_WAVELET}.make).offset_of ("nc")), create {CE_POINTER [NATURAL_32]}.make_shared (l_w.c_pointer + (create {PD_GSL_WAVELET}.make).offset_of ("offset")), a_k])
				if l_status.to_boolean then
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("invalid wavelet member"), ce_string ("wavelet.c"), 46, 4)
						Result := (create {CE_POINTER [PD_GSL_WAVELET]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := l_w
			end
		end

	gsl_wavelet_free (a_w: CE_POINTER [PD_GSL_WAVELET])
		local
			js: JUMP_STATE
		do
			if a_w.is_void then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

	gsl_wavelet_name (a_w: CE_POINTER [PD_GSL_WAVELET]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_w.item.type).item.name)
		end

	gsl_wavelet_workspace_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_WAVELET_WORKSPACE]
		local
			l_work: CE_POINTER [PD_GSL_WAVELET_WORKSPACE]
			js: JUMP_STATE
		do
			create l_work.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("wavelet.c"), 103, 1)
					Result := (create {CE_POINTER [PD_GSL_WAVELET_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_work := create {CE_POINTER [PD_GSL_WAVELET_WORKSPACE]}.make_cast ((malloc ((create {PD_GSL_WAVELET_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_work.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate struct"), ce_string ("wavelet.c"), 110, 8)
						Result := (create {CE_POINTER [PD_GSL_WAVELET_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_work.item.n := a_n
				l_work.item.scratch := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_work.item.scratch).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_work))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate scratch space"), ce_string ("wavelet.c"), 120, 8)
						Result := (create {CE_POINTER [PD_GSL_WAVELET_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				Result := l_work
			end
		end

	gsl_wavelet_workspace_free (a_work: CE_POINTER [PD_GSL_WAVELET_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if a_work.is_void then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_work.item.scratch))
				a_work.item.scratch := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				free (create {CE_POINTER [ANY]}.make_cast (a_work))
			end
		end

end
