class
	P_WMEAN_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_stats_float_wmean (a_w: CE_POINTER [REAL_32]; a_wstride: NATURAL_32; a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_wmean: REAL_96
			l_W: REAL_96
			l_i: NATURAL_32
			l_wi: REAL_32
		do
			l_wmean := real_96_from_integer_32 (0)
			l_W := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_wi := a_w[(l_i * a_wstride).to_integer_32]
				if l_wi > (0).to_real then
					l_W := l_W + real_96_from_real_32 (l_wi)
					l_wmean := l_wmean + ((real_96_from_real_32 (a_data[(l_i * a_stride).to_integer_32]) - l_wmean) * (real_96_from_real_32 (l_wi) / l_W))
				end
				l_i := l_i + 1
			end
			Result := l_wmean.truncated_to_real_64
		end

	gsl_stats_long_double_wmean (a_w: CE_POINTER [REAL_96]; a_wstride: NATURAL_32; a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_wmean: REAL_96
			l_W: REAL_96
			l_i: NATURAL_32
			l_wi: REAL_96
		do
			l_wmean := real_96_from_integer_32 (0)
			l_W := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_wi := a_w[(l_i * a_wstride).to_integer_32]
				if l_wi > real_96_from_integer_32 (0) then
					l_W := l_W + l_wi
					l_wmean := l_wmean + ((a_data[(l_i * a_stride).to_integer_32] - l_wmean) * (l_wi / l_W))
				end
				l_i := l_i + 1
			end
			Result := l_wmean.truncated_to_real_64
		end

	gsl_stats_wmean (a_w: CE_POINTER [REAL_64]; a_wstride: NATURAL_32; a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_wmean: REAL_96
			l_W: REAL_96
			l_i: NATURAL_32
			l_wi: REAL_64
		do
			l_wmean := real_96_from_integer_32 (0)
			l_W := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_wi := a_w[(l_i * a_wstride).to_integer_32]
				if l_wi > (0).to_double then
					l_W := l_W + real_96_from_real_64 (l_wi)
					l_wmean := l_wmean + ((real_96_from_real_64 (a_data[(l_i * a_stride).to_integer_32]) - l_wmean) * (real_96_from_real_64 (l_wi) / l_W))
				end
				l_i := l_i + 1
			end
			Result := l_wmean.truncated_to_real_64
		end

end
