class
	P_WORK_U

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sum_levin_u_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("work_u.c"), 13, 1)
					Result := (create {CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_w := create {CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_cast ((malloc ((create {PD_GSL_SUM_LEVIN_U_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_w.is_void then
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate struct"), ce_string ("work_u.c"), 20, 8)
						Result := (create {CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_w.item.q_num := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.q_num).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for q_num"), ce_string ("work_u.c"), 29, 8)
						Result := (create {CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_w.item.q_den := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.q_den).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.q_num))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for q_den"), ce_string ("work_u.c"), 39, 8)
						Result := (create {CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_w.item.dq_num := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_n * a_n) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.dq_num).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.q_den))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.q_num))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for dq_num"), ce_string ("work_u.c"), 50, 8)
						Result := (create {CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_w.item.dq_den := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_n * a_n) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.dq_den).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.dq_num))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.q_den))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.q_num))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for dq_den"), ce_string ("work_u.c"), 62, 8)
						Result := (create {CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_w.item.dsum := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.dsum).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.dq_den))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.dq_num))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.q_den))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.q_num))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for dsum"), ce_string ("work_u.c"), 75, 8)
						Result := (create {CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_w.item.size := a_n
				l_w.item.terms_used := (0).to_natural_32
				l_w.item.sum_plain := (0).to_double
				Result := l_w
			end
		end

	gsl_sum_levin_u_free (a_w: CE_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if a_w.is_void then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.dsum))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.dq_den))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.dq_num))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.q_den))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.q_num))
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

end
