class
	P_ZSCAL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_zscal (a_N: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_alpha_real: REAL_64
			l_alpha_imag: REAL_64
			l_x_real: REAL_64
			l_x_imag: REAL_64
			js: JUMP_STATE
		do
			l_ix := 0
			l_alpha_real := create {CE_POINTER [REAL_64]}.make_cast (a_alpha)[0]
			l_alpha_imag := create {CE_POINTER [REAL_64]}.make_cast (a_alpha)[1]
			if a_incX <= 0 then
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_x_real := create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_ix]
					l_x_imag := create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_ix + 1)]
					create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_ix] := l_x_real * l_alpha_real - l_x_imag * l_alpha_imag
					create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_ix + 1)] := l_x_real * l_alpha_imag + l_x_imag * l_alpha_real
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
			end
		end

end
