class
	P_ZSOLVE_QUADRATIC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_poly_complex_solve_quadratic (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_z0: CE_POINTER [PD_GSL_COMPLEX]; a_z1: CE_POINTER [PD_GSL_COMPLEX]): INTEGER_32
		local
			l_disc: REAL_64
			l_s: REAL_64
			l_sgnb: REAL_64
			l_tmp___1: INTEGER_32
			l_temp: REAL_64
			l_r1___1: REAL_64
			l_r2___0: REAL_64
			l_s___0: REAL_64
			js: JUMP_STATE
		do
			l_disc := a_b___0 * a_b___0 - ((4).to_double * a_a___5) * a_c___1
			if a_a___5 = (0).to_double then
				if a_b___0 = (0).to_double then
					Result := 0
					js.return
				else
					a_z0.item.dat[0] := -a_c___1 / a_b___0
					a_z0.item.dat[1] := (0).to_double
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				if l_disc > (0).to_double then
					if a_b___0 = (0).to_double then
						l_s := (fabs ((0.5 * (sqrt (l_disc))) / a_a___5))
						a_z0.item.dat[0] := -l_s
						a_z0.item.dat[1] := (0).to_double
						a_z1.item.dat[0] := l_s
						a_z1.item.dat[1] := (0).to_double
					else
						if a_b___0 > (0).to_double then
							l_tmp___1 := 1
						else
							l_tmp___1 := -1
						end
						l_sgnb := l_tmp___1.to_double
						l_temp := -0.5 * (a_b___0 + l_sgnb * (sqrt (l_disc)))
						l_r1___1 := l_temp / a_a___5
						l_r2___0 := a_c___1 / l_temp
						if l_r1___1 < l_r2___0 then
							a_z0.item.dat[0] := l_r1___1
							a_z0.item.dat[1] := (0).to_double
							a_z1.item.dat[0] := l_r2___0
							a_z1.item.dat[1] := (0).to_double
						else
							a_z0.item.dat[0] := l_r2___0
							a_z0.item.dat[1] := (0).to_double
							a_z1.item.dat[0] := l_r1___1
							a_z1.item.dat[1] := (0).to_double
						end
					end
					Result := 2
				elseif l_disc = (0).to_double then
					a_z0.item.dat[0] := (-0.5 * a_b___0) / a_a___5
					a_z0.item.dat[1] := (0).to_double
					a_z1.item.dat[0] := (-0.5 * a_b___0) / a_a___5
					a_z1.item.dat[1] := (0).to_double
					Result := 2
				else
					l_s___0 := (fabs ((0.5 * (sqrt (-l_disc))) / a_a___5))
					a_z0.item.dat[0] := (-0.5 * a_b___0) / a_a___5
					a_z0.item.dat[1] := -l_s___0
					a_z1.item.dat[0] := (-0.5 * a_b___0) / a_a___5
					a_z1.item.dat[1] := l_s___0
					Result := 2
				end
			end
		end

end
