class
	P_ZTRMM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_ztrmm (a_Order: NATURAL_32; a_Side: NATURAL_32; a_Uplo: NATURAL_32; a_TransA: NATURAL_32; a_Diag: NATURAL_32; a_M: INTEGER_32; a_N: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_nonunit: INTEGER_32
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_side: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_alpha_real: REAL_64
			l_alpha_imag: REAL_64
			l_temp_real: REAL_64
			l_temp_imag: REAL_64
			l_Aii_real: REAL_64
			l_Aii_imag: REAL_64
			l_Bij_real: REAL_64
			l_Bij_imag: REAL_64
			l_Aik_real: REAL_64
			l_Aik_imag: REAL_64
			l_Bkj_real: REAL_64
			l_Bkj_imag: REAL_64
			l_temp_real___0: REAL_64
			l_temp_imag___0: REAL_64
			l_Aki_real: REAL_64
			l_Aki_imag: REAL_64
			l_Bkj_real___0: REAL_64
			l_Bkj_imag___0: REAL_64
			l_Aii_real___0: REAL_64
			l_Aii_imag___0: REAL_64
			l_Bij_real___0: REAL_64
			l_Bij_imag___0: REAL_64
			l_tmp___0: INTEGER_32
			l_temp_real___1: REAL_64
			l_temp_imag___1: REAL_64
			l_Aik_real___0: REAL_64
			l_Aik_imag___0: REAL_64
			l_Bkj_real___1: REAL_64
			l_Bkj_imag___1: REAL_64
			l_Aii_real___1: REAL_64
			l_Aii_imag___1: REAL_64
			l_Bij_real___1: REAL_64
			l_Bij_imag___1: REAL_64
			l_tmp___1: INTEGER_32
			l_temp_real___2: REAL_64
			l_temp_imag___2: REAL_64
			l_Aii_real___2: REAL_64
			l_Aii_imag___2: REAL_64
			l_Bij_real___2: REAL_64
			l_Bij_imag___2: REAL_64
			l_Aki_real___0: REAL_64
			l_Aki_imag___0: REAL_64
			l_Bkj_real___2: REAL_64
			l_Bkj_imag___2: REAL_64
			l_temp_real___3: REAL_64
			l_temp_imag___3: REAL_64
			l_Akj_real: REAL_64
			l_Akj_imag: REAL_64
			l_Bik_real: REAL_64
			l_Bik_imag: REAL_64
			l_Ajj_real: REAL_64
			l_Ajj_imag: REAL_64
			l_Bij_real___3: REAL_64
			l_Bij_imag___3: REAL_64
			l_tmp___2: INTEGER_32
			l_temp_real___4: REAL_64
			l_temp_imag___4: REAL_64
			l_Ajj_real___0: REAL_64
			l_Ajj_imag___0: REAL_64
			l_Bij_real___4: REAL_64
			l_Bij_imag___4: REAL_64
			l_Ajk_real: REAL_64
			l_Ajk_imag: REAL_64
			l_Bik_real___0: REAL_64
			l_Bik_imag___0: REAL_64
			l_temp_real___5: REAL_64
			l_temp_imag___5: REAL_64
			l_Ajj_real___1: REAL_64
			l_Ajj_imag___1: REAL_64
			l_Bij_real___5: REAL_64
			l_Bij_imag___5: REAL_64
			l_Akj_real___0: REAL_64
			l_Akj_imag___0: REAL_64
			l_Bik_real___1: REAL_64
			l_Bik_imag___1: REAL_64
			l_temp_real___6: REAL_64
			l_temp_imag___6: REAL_64
			l_Ajk_real___0: REAL_64
			l_Ajk_imag___0: REAL_64
			l_Bik_real___2: REAL_64
			l_Bik_imag___2: REAL_64
			l_Ajj_real___2: REAL_64
			l_Ajj_imag___2: REAL_64
			l_Bij_real___6: REAL_64
			l_Bij_imag___6: REAL_64
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_TransA = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					l_alpha_real := create {CE_POINTER [REAL_64]}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_POINTER [REAL_64]}.make_cast (a_alpha)[1]
					if a_Order = {NATURAL_32} 101 then
						l_n1 := a_M
						l_n2 := a_N
						l_side := a_Side.to_integer_32
						l_uplo := a_Uplo.to_integer_32
						if a_TransA = {NATURAL_32} 111 then
							l_trans := 111
						else
							l_trans := 112
						end
					else
						l_n1 := a_N
						l_n2 := a_M
						if a_Side = {NATURAL_32} 141 then
							l_side := 142
						else
							l_side := 141
						end
						if a_Uplo = {NATURAL_32} 121 then
							l_uplo := 122
						else
							l_uplo := 121
						end
						if a_TransA = {NATURAL_32} 111 then
							l_trans := 111
						else
							l_trans := 112
						end
					end
					if l_side /= 141 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_uplo = 121 then
							if l_trans = 111 then
								l_i := 0
								from
								until
									not (not js.loop_done and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_done and then (l_j < l_n2))
									loop
										l_temp_real := 0.0
										l_temp_imag := 0.0
										if l_nonunit.to_boolean then
											l_Aii_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
											l_Aii_imag := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)])
											l_Bij_real := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_Bij_imag := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
											l_temp_real := l_Aii_real * l_Bij_real - l_Aii_imag * l_Bij_imag
											l_temp_imag := l_Aii_real * l_Bij_imag + l_Aii_imag * l_Bij_real
										else
											l_temp_real := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_temp_imag := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
										end
										l_k := l_i + 1
										from
										until
											not (l_k < l_n1)
										loop
											l_Aik_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
											l_Aik_imag := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)])
											l_Bkj_real := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
											l_Bkj_imag := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
											l_temp_real := l_temp_real + (l_Aik_real * l_Bkj_real - l_Aik_imag * l_Bkj_imag)
											l_temp_imag := l_temp_imag + (l_Aik_real * l_Bkj_imag + l_Aik_imag * l_Bkj_real)
											l_k := l_k + 1
										end
										create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real - l_alpha_imag * l_temp_imag
										create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag + l_alpha_imag * l_temp_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 3 -- goto _L___12
							end
						else
							l_pos := -1 + 3 -- goto _L___12
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else: | _L___12:
						if l_side /= 141 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_uplo = 121 then
							if l_trans = 112 then
								l_i := l_n1
								from
								until
									js.loop_done
								loop
									if l_i > 0 then
										l_tmp___0 := l_i
										l_i := l_i - 1
										if not l_tmp___0.to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_j := 0
										from
										until
											not (not js.loop_done and then (l_j < l_n2))
										loop
											l_temp_real___0 := 0.0
											l_temp_imag___0 := 0.0
											l_k := 0
											from
											until
												not (l_k < l_i)
											loop
												l_Aki_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
												l_Aki_imag := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
												l_Bkj_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
												l_Bkj_imag___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
												l_temp_real___0 := l_temp_real___0 + (l_Aki_real * l_Bkj_real___0 - l_Aki_imag * l_Bkj_imag___0)
												l_temp_imag___0 := l_temp_imag___0 + (l_Aki_real * l_Bkj_imag___0 + l_Aki_imag * l_Bkj_real___0)
												l_k := l_k + 1
											end
											if l_nonunit.to_boolean then
												l_Aii_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
												l_Aii_imag___0 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)])
												l_Bij_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
												l_Bij_imag___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
												l_temp_real___0 := l_temp_real___0 + (l_Aii_real___0 * l_Bij_real___0 - l_Aii_imag___0 * l_Bij_imag___0)
												l_temp_imag___0 := l_temp_imag___0 + (l_Aii_real___0 * l_Bij_imag___0 + l_Aii_imag___0 * l_Bij_real___0)
											else
												l_temp_real___0 := l_temp_real___0 + (create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)])
												l_temp_imag___0 := l_temp_imag___0 + (create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)])
											end
											create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___0 - l_alpha_imag * l_temp_imag___0
											create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___0 + l_alpha_imag * l_temp_real___0
											l_j := l_j + 1
										end
									end
								end
							else
								l_pos := -1 + 6 -- goto _L___10
							end
						else
							l_pos := -1 + 6 -- goto _L___10
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else: | _L___10:
						if l_side /= 141 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_uplo = 122 then
							if l_trans = 111 then
								l_i := l_n1
								from
								until
									js.loop_done
								loop
									if l_i > 0 then
										l_tmp___1 := l_i
										l_i := l_i - 1
										if not l_tmp___1.to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_j := 0
										from
										until
											not (not js.loop_done and then (l_j < l_n2))
										loop
											l_temp_real___1 := 0.0
											l_temp_imag___1 := 0.0
											l_k := 0
											from
											until
												not (l_k < l_i)
											loop
												l_Aik_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
												l_Aik_imag___0 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)])
												l_Bkj_real___1 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
												l_Bkj_imag___1 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
												l_temp_real___1 := l_temp_real___1 + (l_Aik_real___0 * l_Bkj_real___1 - l_Aik_imag___0 * l_Bkj_imag___1)
												l_temp_imag___1 := l_temp_imag___1 + (l_Aik_real___0 * l_Bkj_imag___1 + l_Aik_imag___0 * l_Bkj_real___1)
												l_k := l_k + 1
											end
											if l_nonunit.to_boolean then
												l_Aii_real___1 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
												l_Aii_imag___1 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)])
												l_Bij_real___1 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
												l_Bij_imag___1 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
												l_temp_real___1 := l_temp_real___1 + (l_Aii_real___1 * l_Bij_real___1 - l_Aii_imag___1 * l_Bij_imag___1)
												l_temp_imag___1 := l_temp_imag___1 + (l_Aii_real___1 * l_Bij_imag___1 + l_Aii_imag___1 * l_Bij_real___1)
											else
												l_temp_real___1 := l_temp_real___1 + (create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)])
												l_temp_imag___1 := l_temp_imag___1 + (create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)])
											end
											create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___1 - l_alpha_imag * l_temp_imag___1
											create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___1 + l_alpha_imag * l_temp_real___1
											l_j := l_j + 1
										end
									end
								end
							else
								l_pos := -1 + 9 -- goto _L___8
							end
						else
							l_pos := -1 + 9 -- goto _L___8
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else: | _L___8:
						if l_side /= 141 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_uplo = 122 then
							if l_trans = 112 then
								l_i := 0
								from
								until
									not (not js.loop_done and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_done and then (l_j < l_n2))
									loop
										l_temp_real___2 := 0.0
										l_temp_imag___2 := 0.0
										if l_nonunit.to_boolean then
											l_Aii_real___2 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
											l_Aii_imag___2 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)])
											l_Bij_real___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_Bij_imag___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
											l_temp_real___2 := l_Aii_real___2 * l_Bij_real___2 - l_Aii_imag___2 * l_Bij_imag___2
											l_temp_imag___2 := l_Aii_real___2 * l_Bij_imag___2 + l_Aii_imag___2 * l_Bij_real___2
										else
											l_temp_real___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_temp_imag___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
										end
										l_k := l_i + 1
										from
										until
											not (l_k < l_n1)
										loop
											l_Aki_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
											l_Aki_imag___0 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
											l_Bkj_real___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
											l_Bkj_imag___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
											l_temp_real___2 := l_temp_real___2 + (l_Aki_real___0 * l_Bkj_real___2 - l_Aki_imag___0 * l_Bkj_imag___2)
											l_temp_imag___2 := l_temp_imag___2 + (l_Aki_real___0 * l_Bkj_imag___2 + l_Aki_imag___0 * l_Bkj_real___2)
											l_k := l_k + 1
										end
										create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___2 - l_alpha_imag * l_temp_imag___2
										create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___2 + l_alpha_imag * l_temp_real___2
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 12 -- goto _L___6
							end
						else
							l_pos := -1 + 12 -- goto _L___6
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else: | _L___6:
						if l_side /= 142 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_uplo = 121 then
							if l_trans = 111 then
								l_i := 0
								from
								until
									not (not js.loop_done and then (l_i < l_n1))
								loop
									l_j := l_n2
									from
									until
										js.loop_done
									loop
										if l_j > 0 then
											l_tmp___2 := l_j
											l_j := l_j - 1
											if not l_tmp___2.to_boolean then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_temp_real___3 := 0.0
											l_temp_imag___3 := 0.0
											l_k := 0
											from
											until
												not (l_k < l_j)
											loop
												l_Akj_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
												l_Akj_imag := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)])
												l_Bik_real := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
												l_Bik_imag := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
												l_temp_real___3 := l_temp_real___3 + (l_Akj_real * l_Bik_real - l_Akj_imag * l_Bik_imag)
												l_temp_imag___3 := l_temp_imag___3 + (l_Akj_real * l_Bik_imag + l_Akj_imag * l_Bik_real)
												l_k := l_k + 1
											end
											if l_nonunit.to_boolean then
												l_Ajj_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
												l_Ajj_imag := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)])
												l_Bij_real___3 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
												l_Bij_imag___3 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
												l_temp_real___3 := l_temp_real___3 + (l_Ajj_real * l_Bij_real___3 - l_Ajj_imag * l_Bij_imag___3)
												l_temp_imag___3 := l_temp_imag___3 + (l_Ajj_real * l_Bij_imag___3 + l_Ajj_imag * l_Bij_real___3)
											else
												l_temp_real___3 := l_temp_real___3 + (create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)])
												l_temp_imag___3 := l_temp_imag___3 + (create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)])
											end
											create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___3 - l_alpha_imag * l_temp_imag___3
											create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___3 + l_alpha_imag * l_temp_real___3
										end
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 15 -- goto _L___4
							end
						else
							l_pos := -1 + 15 -- goto _L___4
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else: | _L___4:
						if l_side /= 142 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_uplo = 121 then
							if l_trans = 112 then
								l_i := 0
								from
								until
									not (not js.loop_done and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_done and then (l_j < l_n2))
									loop
										l_temp_real___4 := 0.0
										l_temp_imag___4 := 0.0
										if l_nonunit.to_boolean then
											l_Ajj_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
											l_Ajj_imag___0 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)])
											l_Bij_real___4 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_Bij_imag___4 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
											l_temp_real___4 := l_Ajj_real___0 * l_Bij_real___4 - l_Ajj_imag___0 * l_Bij_imag___4
											l_temp_imag___4 := l_Ajj_real___0 * l_Bij_imag___4 + l_Ajj_imag___0 * l_Bij_real___4
										else
											l_temp_real___4 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_temp_imag___4 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
										end
										l_k := l_j + 1
										from
										until
											not (l_k < l_n2)
										loop
											l_Ajk_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
											l_Ajk_imag := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
											l_Bik_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
											l_Bik_imag___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
											l_temp_real___4 := l_temp_real___4 + (l_Ajk_real * l_Bik_real___0 - l_Ajk_imag * l_Bik_imag___0)
											l_temp_imag___4 := l_temp_imag___4 + (l_Ajk_real * l_Bik_imag___0 + l_Ajk_imag * l_Bik_real___0)
											l_k := l_k + 1
										end
										create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___4 - l_alpha_imag * l_temp_imag___4
										create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___4 + l_alpha_imag * l_temp_real___4
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 18 -- goto _L___2
							end
						else
							l_pos := -1 + 18 -- goto _L___2
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else: | _L___2:
						if l_side /= 142 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if l_uplo = 122 then
							if l_trans = 111 then
								l_i := 0
								from
								until
									not (not js.loop_done and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_done and then (l_j < l_n2))
									loop
										l_temp_real___5 := 0.0
										l_temp_imag___5 := 0.0
										if l_nonunit.to_boolean then
											l_Ajj_real___1 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
											l_Ajj_imag___1 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)])
											l_Bij_real___5 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_Bij_imag___5 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
											l_temp_real___5 := l_Ajj_real___1 * l_Bij_real___5 - l_Ajj_imag___1 * l_Bij_imag___5
											l_temp_imag___5 := l_Ajj_real___1 * l_Bij_imag___5 + l_Ajj_imag___1 * l_Bij_real___5
										else
											l_temp_real___5 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_temp_imag___5 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
										end
										l_k := l_j + 1
										from
										until
											not (l_k < l_n2)
										loop
											l_Akj_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
											l_Akj_imag___0 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)])
											l_Bik_real___1 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
											l_Bik_imag___1 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
											l_temp_real___5 := l_temp_real___5 + (l_Akj_real___0 * l_Bik_real___1 - l_Akj_imag___0 * l_Bik_imag___1)
											l_temp_imag___5 := l_temp_imag___5 + (l_Akj_real___0 * l_Bik_imag___1 + l_Akj_imag___0 * l_Bik_real___1)
											l_k := l_k + 1
										end
										create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___5 - l_alpha_imag * l_temp_imag___5
										create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___5 + l_alpha_imag * l_temp_real___5
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 21 -- goto _L___0
							end
						else
							l_pos := -1 + 21 -- goto _L___0
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L___0:
						if l_side = 142 then
							if l_uplo = 122 then
								if l_trans = 112 then
									l_i := 0
									from
									until
										not (not js.loop_done and then (l_i < l_n1))
									loop
										l_j := l_n2
										from
										until
											js.loop_done
										loop
											if l_j > 0 then
												l_tmp___3 := l_j
												l_j := l_j - 1
												if not l_tmp___3.to_boolean then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_temp_real___6 := 0.0
												l_temp_imag___6 := 0.0
												l_k := 0
												from
												until
													not (l_k < l_j)
												loop
													l_Ajk_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
													l_Ajk_imag___0 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
													l_Bik_real___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
													l_Bik_imag___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
													l_temp_real___6 := l_temp_real___6 + (l_Ajk_real___0 * l_Bik_real___2 - l_Ajk_imag___0 * l_Bik_imag___2)
													l_temp_imag___6 := l_temp_imag___6 + (l_Ajk_real___0 * l_Bik_imag___2 + l_Ajk_imag___0 * l_Bik_real___2)
													l_k := l_k + 1
												end
												if l_nonunit.to_boolean then
													l_Ajj_real___2 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
													l_Ajj_imag___2 := (l_conj.to_double * create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)])
													l_Bij_real___6 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
													l_Bij_imag___6 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
													l_temp_real___6 := l_temp_real___6 + (l_Ajj_real___2 * l_Bij_real___6 - l_Ajj_imag___2 * l_Bij_imag___6)
													l_temp_imag___6 := l_temp_imag___6 + (l_Ajj_real___2 * l_Bij_imag___6 + l_Ajj_imag___2 * l_Bij_real___6)
												else
													l_temp_real___6 := l_temp_real___6 + (create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)])
													l_temp_imag___6 := l_temp_imag___6 + (create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)])
												end
												create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___6 - l_alpha_imag * l_temp_imag___6
												create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___6 + l_alpha_imag * l_temp_real___6
											end
										end
										l_i := l_i + 1
									end
								else
									xerbla_inst.cblas_xerbla ([0, ce_string ("source_trmm_c.h"), ce_string ("unrecognized operation")])
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_trmm_c.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_trmm_c.h"), ce_string ("unrecognized operation")])
						end
				when 22 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
