class
	P_EX_GETLN

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create ccline.make (<<1>>)
			create hisidx.make (<<5>>)
			create hisnum.make (<<5>>)
			create history.make (<<5>>)
			create history_names.make (<<6>>)
			create orig_save.make
			create prev_ccline.make (<<1>>)
			create tab.make (<<19>>)
			create viminfo_hisidx.make (<<5>>)
			create viminfo_hislen.make (<<5>>)
			create viminfo_history.make (<<5>>)
		end

feature {ANY} -- attributes

	ccline: CE_ARRAY [PD_CMDLINE_INFO]

	cmd_showtail: INTEGER_32 assign set_cmd_showtail

	set_cmd_showtail (a_cmd_showtail: INTEGER_32)
		do
			cmd_showtail := a_cmd_showtail
		end

	findex: INTEGER_32 assign set_findex

	set_findex (a_findex: INTEGER_32)
		do
			findex := a_findex
		end

	hisidx: CE_ARRAY [INTEGER_32]

	hislen: INTEGER_32 assign set_hislen

	set_hislen (a_hislen: INTEGER_32)
		do
			hislen := a_hislen
		end

	hisnum: CE_ARRAY [INTEGER_32]

	history: CE_ARRAY [CE_POINTER [PD_HIST_ENTRY]]

	history_names: CE_ARRAY [CE_POINTER [INTEGER_8]]

	last_maptick: INTEGER_32 assign set_last_maptick

	set_last_maptick (a_last_maptick: INTEGER_32)
		do
			last_maptick := a_last_maptick
		end

	new_cmdpos: INTEGER_32 assign set_new_cmdpos

	set_new_cmdpos (a_new_cmdpos: INTEGER_32)
		do
			new_cmdpos := a_new_cmdpos
		end

	orig_save: CE_POINTER [NATURAL_8] assign set_orig_save

	set_orig_save (a_orig_save: CE_POINTER [NATURAL_8])
		do
			orig_save := a_orig_save
		end

	prev_ccline: CE_ARRAY [PD_CMDLINE_INFO]

	prev_ccline_used: INTEGER_32 assign set_prev_ccline_used

	set_prev_ccline_used (a_prev_ccline_used: INTEGER_32)
		do
			prev_ccline_used := a_prev_ccline_used
		end

	tab: CE_ARRAY [PD_EXPGEN]

	viminfo_add_at_front: INTEGER_32 assign set_viminfo_add_at_front

	set_viminfo_add_at_front (a_viminfo_add_at_front: INTEGER_32)
		do
			viminfo_add_at_front := a_viminfo_add_at_front
		end

	viminfo_hisidx: CE_ARRAY [INTEGER_32]

	viminfo_hislen: CE_ARRAY [INTEGER_32]

	viminfo_history: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]

feature {ANY} -- routines

	ExpandCleanup (a_xp: CE_POINTER [PD_EXPAND])
		do
			if a_xp.item.xp_numfiles >= 0 then
				misc1_inst.FreeWild (a_xp.item.xp_numfiles, a_xp.item.xp_files)
				a_xp.item.xp_numfiles := -1
			end
		end

	ExpandEscape (a_xp: CE_POINTER [PD_EXPAND]; a_str___1: CE_POINTER [NATURAL_8]; a_numfiles: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]]; a_options___0: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_options___0).bit_and (2)).to_boolean then
						tilde_replace (a_str___1, a_numfiles, a_files)
					end
					if not (((a_options___0).bit_and (128)).to_boolean) then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if a_xp.item.xp_context /= 2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if a_xp.item.xp_context /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if a_xp.item.xp_context /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if a_xp.item.xp_context /= 3 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_numfiles)
						loop
							if a_xp.item.xp_backslash = 2 then
								l_p___0 := misc2_inst.vim_strsave_escaped (a_files[l_i___0], create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
								if not l_p___0.is_void then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_files[l_i___0]))
									a_files[l_i___0] := l_p___0
								end
							end
							l_p___0 := vim_strsave_fnameescape (a_files[l_i___0], a_xp.item.xp_shell)
							if not l_p___0.is_void then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_files[l_i___0]))
								a_files[l_i___0] := l_p___0
							end
							if (a_str___1[0]).to_integer_32 = 92 then
								if (a_str___1[1]).to_integer_32 = 126 then
									if ((a_files[l_i___0])[0]).to_integer_32 = 126 then
										escape_fname (a_files + l_i___0)
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						a_xp.item.xp_backslash := 0
						if ((a_files[0]).item).to_integer_32 = 43 then
							escape_fname (a_files + 0)
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						if a_xp.item.xp_context = 6 then
							l_i___0 := 0
							from
							until
								not (l_i___0 < a_numfiles)
							loop
								l_p___0 := misc2_inst.vim_strsave_escaped (a_files[l_i___0], create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("\|%"")))
								if not l_p___0.is_void then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_files[l_i___0]))
									a_files[l_i___0] := l_p___0
								end
								l_i___0 := l_i___0 + 1
							end
						end
				when 14 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ExpandFromContext (a_xp: CE_POINTER [PD_EXPAND]; a_pat: CE_POINTER [NATURAL_8]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_options___0: INTEGER_32): INTEGER_32
		local
			l_pat: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_ret: INTEGER_32
			l_flags___0: INTEGER_32
			l_free_pat: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_tmp___12: INTEGER_32
			l_i___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pat.make (<<1>>)
			create l_regmatch___0.make (<<1>>)
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pat.item := a_pat
					l_flags___0 := 1
					if ((a_options___0).bit_and (1)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((4))
					end
					if ((a_options___0).bit_and (16)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((8))
					end
					if ((a_options___0).bit_and (32)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((16))
					end
					if ((a_options___0).bit_and (64)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((32))
					end
					if a_xp.item.xp_context /= 2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_xp.item.xp_context /= 3 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_xp.item.xp_context /= 38 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_free_pat := 0
						if a_xp.item.xp_backslash /= 0 then
							l_free_pat := 1
							l_pat.item := misc2_inst.vim_strsave (l_pat.item)
							l_i___0 := 0
							from
							until
								not ((l_pat.item[l_i___0]).to_boolean)
							loop
								if (l_pat.item[l_i___0]).to_integer_32 = 92 then
									if a_xp.item.xp_backslash = 2 then
										if (l_pat.item[(l_i___0 + 1)]).to_integer_32 = 92 then
											if (l_pat.item[(l_i___0 + 2)]).to_integer_32 = 92 then
												if (l_pat.item[(l_i___0 + 3)]).to_integer_32 = 32 then
													memmove (create {CE_POINTER [ANY]}.make_cast ((l_pat.item + l_i___0)), create {CE_POINTER [ANY]}.make_cast (((l_pat.item + l_i___0) + 3)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((l_pat.item + l_i___0) + 3)))) + {NATURAL_32} 1).do_nothing
												end
											end
										end
									end
									if a_xp.item.xp_backslash = 1 then
										if (l_pat.item[(l_i___0 + 1)]).to_integer_32 = 32 then
											memmove (create {CE_POINTER [ANY]}.make_cast ((l_pat.item + l_i___0)), create {CE_POINTER [ANY]}.make_cast (((l_pat.item + l_i___0) + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((l_pat.item + l_i___0) + 1)))) + {NATURAL_32} 1).do_nothing
										end
									end
								end
								l_i___0 := l_i___0 + 1
							end
						end
						if a_xp.item.xp_context = 2 then
							l_flags___0 := (l_flags___0).bit_or ((2))
						elseif a_xp.item.xp_context = 38 then
							l_flags___0 := (l_flags___0).bit_or ((130))
						else
							l_flags___0 := (((l_flags___0).bit_or (1))).bit_and (-3)
						end
						l_ret := misc1_inst.expand_wildcards_eval (l_pat, a_num_file, a_file, l_flags___0)
						if l_free_pat.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat.item))
						end
						Result := l_ret
						js.return
				when 8 then -- if done | if done
						if not js.return_called then
							a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (ce_string (""))
							a_num_file.item := 0
							if a_xp.item.xp_context = 8 then
								if (l_pat.item.item).to_integer_32 = 0 then
									l_tmp___1 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("help"))
								else
									l_tmp___1 := l_pat.item
								end
								if (ex_cmds_inst.find_help_tags (l_tmp___1, a_num_file, a_file, 0)) = 1 then
									cleanup_help_tags (a_num_file.item, a_file.item)
									Result := 1
									js.return
								end
								if not js.return_called then
									Result := 0
									js.return
								end
							end
						end
						if not js.return_called and then (a_xp.item.xp_context = 32) then
							Result := (expand_shellcmd (l_pat.item, a_num_file, a_file, l_flags___0))
							js.return
						end
						if not js.return_called and then (a_xp.item.xp_context = 7) then
							Result := (option_inst.ExpandOldSetting (a_num_file, a_file))
							js.return
						end
						if not js.return_called and then (a_xp.item.xp_context = 9) then
							Result := (buffer_inst.ExpandBufnames (l_pat.item, a_num_file, a_file, a_options___0))
							js.return
						end
						if not js.return_called then
							if a_xp.item.xp_context = 6 then
								l_tmp___6 := tag_inst.expand_tags ((a_xp.item.xp_context = 6).to_integer, l_pat.item, a_num_file, a_file)
								Result := l_tmp___6
								js.return
							elseif a_xp.item.xp_context = 17 then
								l_tmp___6 := tag_inst.expand_tags ((a_xp.item.xp_context = 6).to_integer, l_pat.item, a_num_file, a_file)
								Result := l_tmp___6
								js.return
							end
						end
						if not js.return_called and then (a_xp.item.xp_context = 28) then
							Result := (ExpandRTDir (l_pat.item, a_num_file, a_file, ce_string ("colors")))
							js.return
						end
						if not js.return_called and then (a_xp.item.xp_context = 29) then
							Result := (ExpandRTDir (l_pat.item, a_num_file, a_file, ce_string ("compiler")))
							js.return
						end
						if not js.return_called and then (a_xp.item.xp_context = 39) then
							Result := (ExpandRTDir (l_pat.item, a_num_file, a_file, ce_string ("syntax")))
							js.return
						end
						if not js.return_called and then (a_xp.item.xp_context = 37) then
							Result := (ExpandRTDir (l_pat.item, a_num_file, a_file, ce_string ("{syntax,indent,ftplugin}")))
							js.return
						end
						if not js.return_called and then (a_xp.item.xp_context = 31) then
							Result := (ExpandUserList (a_xp, a_num_file, a_file))
							js.return
						end
						if not js.return_called then
							if (option_inst.p_magic.item).to_boolean then
								l_tmp___12 := 1
							else
								l_tmp___12 := 0
							end
							l_regmatch___0.item.regprog := regexp_inst.vim_regcomp (l_pat.item, l_tmp___12)
							if (l_regmatch___0.item.regprog).is_void then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_regmatch___0.item.rm_ic := search_inst.ignorecase (l_pat.item)
							if a_xp.item.xp_context = 4 then
								l_ret := option_inst.ExpandSettings (a_xp, l_regmatch___0, a_num_file, a_file)
							elseif a_xp.item.xp_context = 5 then
								l_ret := option_inst.ExpandSettings (a_xp, l_regmatch___0, a_num_file, a_file)
							elseif a_xp.item.xp_context = 16 then
								l_ret := getchar_inst.ExpandMappings (l_regmatch___0, a_num_file, a_file)
							elseif a_xp.item.xp_context = 30 then
								l_ret := ExpandUserDefined (a_xp, l_regmatch___0, a_num_file, a_file)
							else
								l_ret := 0
								l_i___1 := 0
								from
								until
									not (not js.loop_done and then (l_i___1 < (((create {PD_EXPGEN}.make).structure_size.to_natural_32 * (19).to_natural_32) // (create {PD_EXPGEN}.make).structure_size.to_natural_32).to_integer_32))
								loop
									if a_xp.item.xp_context = tab[l_i___1].context then
										if (tab[l_i___1].ic).to_boolean then
											l_regmatch___0.item.rm_ic := 1
										end
										l_ret := ExpandGeneric (a_xp, l_regmatch___0, a_num_file, a_file, tab[l_i___1].func)
										js.break
									end
									if not js.loop_jumped then
										l_i___1 := l_i___1 + 1
									end
								end
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.item.regprog))
							Result := l_ret
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ExpandGeneric (a_xp: CE_POINTER [PD_EXPAND]; a_regmatch___0: CE_POINTER [PD_REGMATCH_T]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_func: CE_ROUTINE): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_count___2: INTEGER_32
			l_round: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_str___1.make

			l_count___2 := 0
			l_round := 0
			from
			until
				not (not js.loop_done and then (l_round <= 1))
			loop
				l_i___0 := 0
				from
				until
					js.loop_done
				loop
					l_str___1 := create {CE_POINTER [NATURAL_8]}.make_cast (a_func.pointer_item ([a_xp, l_i___0]))
					if l_str___1.is_void then
						js.break
					end
					if not js.loop_jumped and then ((l_str___1.item).to_integer_32 = 0) then
						js.continue
					end
					if not js.loop_jumped then
						if (regexp_inst.vim_regexec (a_regmatch___0, l_str___1, 0)).to_boolean then
							if l_round.to_boolean then
								l_str___1 := misc2_inst.vim_strsave_escaped (l_str___1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T\.")))
								a_file.item[l_count___2] := l_str___1
								if a_func.is_equal (menu_inst.get_menu_names_address) then
									if not l_str___1.is_void then
										l_str___1 := l_str___1 + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1))) - {NATURAL_32} 1).to_integer_32
										if (l_str___1.item).to_integer_32 = 1 then
											l_str___1.item := (('.').code).to_natural_8
										end
									end
								end
							end
							l_count___2 := l_count___2 + 1
						end
					end
					if js.loop_increment then
						l_i___0 := l_i___0 + 1
					end
				end
				if l_round = 0 then
					if l_count___2 = 0 then
						Result := 1
						js.return
					end
					if not js.return_called then
						a_num_file.item := l_count___2
						a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc (l_count___2.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
						if (a_file.item).is_void then
							a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (ce_string (""))
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_count___2 := 0
					end
				end
				if not js.return_called then
					l_round := l_round + 1
				end
			end
			if not js.return_called then
				if a_xp.item.xp_context /= 21 then
					if a_xp.item.xp_context /= 11 then
						misc2_inst.sort_strings (a_file.item, a_num_file.item)
					end
				end
				syntax_inst.reset_expand_highlight
				Result := 1
			end
		end

	ExpandInit (a_xp: CE_POINTER [PD_EXPAND])
		do
			a_xp.item.xp_pattern := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_xp.item.xp_pattern_len := 0
			a_xp.item.xp_backslash := 0
			a_xp.item.xp_shell := 0
			a_xp.item.xp_numfiles := -1
			a_xp.item.xp_files := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			a_xp.item.xp_arg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
		end

	ExpandOne (a_xp: CE_POINTER [PD_EXPAND]; a_str___1: CE_POINTER [NATURAL_8]; a_orig: CE_POINTER [NATURAL_8]; a_options___0: INTEGER_32; a_mode: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_ss: CE_POINTER [NATURAL_8]
			l_orig_saved: INTEGER_32
			l_i___0: INTEGER_32
			l_len: NATURAL_32
			l_non_suf_match: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ss.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ss := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_orig_saved := 0
					if a_mode /= 4 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_mode /= 5 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if a_xp.item.xp_numfiles > 0 then
							if a_mode = 5 then
								if findex = -1 then
									findex := a_xp.item.xp_numfiles
								end
								findex := findex - 1
							else
								findex := findex + 1
							end
							if findex < 0 then
								if orig_save.is_void then
									findex := a_xp.item.xp_numfiles - 1
								else
									findex := -1
								end
							end
							if findex >= a_xp.item.xp_numfiles then
								if orig_save.is_void then
									findex := 0
								else
									findex := -1
								end
							end
							if (option_inst.p_wmnu.item).to_boolean then
								screen_inst.win_redr_status_matches (a_xp, a_xp.item.xp_numfiles, a_xp.item.xp_files, findex, cmd_showtail)
							end
							if findex = -1 then
								Result := (misc2_inst.vim_strsave (orig_save))
								js.return
							end
							if not js.return_called then
								Result := (misc2_inst.vim_strsave (a_xp.item.xp_files[findex]))
								js.return
							end
						else
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							if a_xp.item.xp_numfiles /= -1 then
								if a_mode /= 6 then
									if a_mode /= 7 then
										misc1_inst.FreeWild (a_xp.item.xp_numfiles, a_xp.item.xp_files)
										a_xp.item.xp_numfiles := -1
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (orig_save))
										orig_save := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
									end
								end
							end
							findex := 0
							if a_mode = 1 then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 6 then -- if:
							if a_xp.item.xp_numfiles /= -1 then
								l_pos := -1 + 19 -- skip if block
							end
				when 7 then -- if:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (orig_save))
							orig_save := a_orig
							l_orig_saved := 1
							if ((ExpandFromContext (a_xp, a_str___1, create {CE_POINTER [INTEGER_32]}.make_shared (a_xp.c_pointer + (create {PD_EXPAND}.make).offset_of ("xp_numfiles")), create {CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]}.make_shared (a_xp.c_pointer + (create {PD_EXPAND}.make).offset_of ("xp_files")), a_options___0)) = 0) then
								l_pos := -1 + 19 -- skip if block
							end
				when 8 then -- if:
							if a_xp.item.xp_numfiles /= 0 then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							if not ((a_options___0).bit_and (64)).to_boolean then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nomatch2)))), a_str___1).do_nothing
							end
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 11 then -- else:
							ExpandEscape (a_xp, a_str___1, a_xp.item.xp_numfiles, a_xp.item.xp_files, a_options___0)
							if a_mode = 6 then
								l_pos := -1 + 19 -- skip if block
							end
				when 12 then -- if:
							if a_mode = 7 then
								l_pos := -1 + 19 -- skip if block
							end
				when 13 then -- if:
							if (a_xp.item.xp_numfiles).to_boolean then
								l_non_suf_match := a_xp.item.xp_numfiles
							else
								l_non_suf_match := 1
							end
							if a_xp.item.xp_context /= 2 then
								l_pos := -1 + 16 -- skip if block
							end
				when 14 then -- if:
							l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 18
				when 16 then -- else:
							if a_xp.item.xp_context /= 3 then
								l_pos := -1 + 18 -- skip if block
							end
				when 17 then -- if: | _L___0:
							if a_xp.item.xp_numfiles > 1 then
								l_non_suf_match := 0
								l_i___0 := 0
								from
								until
									not (l_i___0 < 2)
								loop
									if (misc1_inst.match_suffix (a_xp.item.xp_files[l_i___0])).to_boolean then
										l_non_suf_match := l_non_suf_match + 1
									end
									l_i___0 := l_i___0 + 1
								end
							end
				when 18 then -- if done
							if l_non_suf_match /= 1 then
								if not ((a_options___0).bit_and (64)).to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_toomany))))).do_nothing
								elseif not ((a_options___0).bit_and (8)).to_boolean then
									misc1_inst.beep_flush
								end
							end
							if l_non_suf_match /= 1 then
								if a_mode /= 2 then
									l_ss := misc2_inst.vim_strsave (a_xp.item.xp_files[0])
								end
							else
								l_ss := misc2_inst.vim_strsave (a_xp.item.xp_files[0])
							end
				when 19 then -- if done | if done | if done | if done | if done
							if a_mode = 7 then
								if a_xp.item.xp_numfiles > 0 then
									l_len := (0).to_natural_32
									from
									until
										not (not js.loop_done and then (((a_xp.item.xp_files[0])[l_len.to_integer_32]).to_boolean))
									loop
										l_i___0 := 0
										from
										until
											not (not js.loop_done and then (l_i___0 < a_xp.item.xp_numfiles))
										loop
											if ((a_xp.item.xp_files[l_i___0])[l_len.to_integer_32]).to_integer_32 /= ((a_xp.item.xp_files[0])[l_len.to_integer_32]).to_integer_32 then
												js.break
											end
											if not js.loop_jumped then
												l_i___0 := l_i___0 + 1
											end
										end
										if l_i___0 < a_xp.item.xp_numfiles then
											if not ((a_options___0).bit_and (8)).to_boolean then
												misc1_inst.vim_beep
											end
											js.break
										end
										if not js.loop_jumped then
											l_len := l_len + 1
										end
									end
									l_ss := misc2_inst.alloc (l_len.to_natural_32 + {NATURAL_32} 1)
									if (not l_ss.is_void) then
										misc2_inst.vim_strncpy (l_ss, a_xp.item.xp_files[0], l_len.to_natural_32)
									end
									findex := -1
								end
							end
							if a_mode = 6 then
								if a_xp.item.xp_numfiles > 0 then
									l_len := (0).to_natural_32
									l_i___0 := 0
									from
									until
										not (l_i___0 < a_xp.item.xp_numfiles)
									loop
										l_len := l_len + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_xp.item.xp_files[l_i___0]))).to_natural_32 + {NATURAL_32} 1)
										l_i___0 := l_i___0 + 1
									end
									l_ss := misc2_inst.lalloc (l_len, 1)
									if not l_ss.is_void then
										l_ss.item := (('%/0/').code).to_natural_8
										l_i___0 := 0
										from
										until
											not (l_i___0 < a_xp.item.xp_numfiles)
										loop
											strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_ss), create {CE_POINTER [INTEGER_8]}.make_cast (a_xp.item.xp_files[l_i___0])).do_nothing
											if l_i___0 /= a_xp.item.xp_numfiles - 1 then
												if ((a_options___0).bit_and (4)).to_boolean then
													l_tmp___6 := ce_string ("%N")
												else
													l_tmp___6 := ce_string (" ")
												end
												strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_ss), l_tmp___6).do_nothing
											end
											l_i___0 := l_i___0 + 1
										end
									end
								end
							end
							if a_mode = 2 then
								ExpandCleanup (a_xp)
							elseif a_mode = 6 then
								ExpandCleanup (a_xp)
							end
							if not l_orig_saved.to_boolean then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_orig))
							end
							Result := l_ss
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ExpandRTDir (a_pat: CE_POINTER [NATURAL_8]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_dirnames: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_all: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_tmp: NATURAL_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_all.make
			create l_s.make
			create l_e.make
			create l_ga.make (<<1>>)

			a_num_file.item := 0
			a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pat))
			l_s := misc2_inst.alloc ((l_tmp + (strlen (a_dirnames))) + {NATURAL_32} 7)
			if l_s.is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("%%s/%%s*.vim"), a_dirnames, a_pat]).do_nothing
				l_all := globpath (option_inst.p_rtp.item, l_s, 0)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s))
				if l_all.is_void then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				misc2_inst.ga_init2 (l_ga, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 3)
				l_s := l_all
				from
				until
					not (not js.loop_done and then ((l_s.item).to_integer_32 /= 0))
				loop
					l_e := misc2_inst.vim_strchr (l_s, ('%N').code)
					if l_e.is_void then
						l_e := l_s + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
					end
					if (misc2_inst.ga_grow (l_ga, 1)) = 0 then
						js.break
					end
					if not js.loop_jumped then
						if ((l_e - 4).c_pointer.to_integer_32).to_natural_32 > (l_s.c_pointer.to_integer_32).to_natural_32 then
							if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_e - 4)), ce_string (".vim"), (4).to_natural_32)) = 0 then
								l_s := l_e - 4
								from
								until
									not (not js.loop_done and then ((l_s.c_pointer.to_integer_32).to_natural_32 > (l_all.c_pointer.to_integer_32).to_natural_32))
								loop
									if (l_s.item).to_integer_32 = 10 then
										js.break
									elseif (misc1_inst.vim_ispathsep ((l_s.item).to_integer_32)).to_boolean then
										js.break
									end
									if not js.loop_jumped then
										if globals_inst.has_mbyte.to_boolean then
											l_tmp___4 := (globals_inst.mb_head_off.integer_32_item ([l_all, l_s - 1])) + 1
										else
											l_tmp___4 := 1
										end
										l_s := l_s - l_tmp___4
									end
								end
								l_s := l_s + 1
								create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.item.ga_data)[l_ga.item.ga_len] := misc2_inst.vim_strnsave (l_s, (l_e.distance (l_s)) - 4)
								l_ga.item.ga_len := (l_ga.item.ga_len) + 1
							end
						end
						if (l_e.item).to_integer_32 /= 0 then
							l_e := l_e + 1
						end
						l_s := l_e
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_all))
				misc1_inst.remove_duplicates (l_ga)
				a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.item.ga_data)
				a_num_file.item := l_ga.item.ga_len
				Result := 1
			end
		end

	ExpandUserDefined (a_xp: CE_POINTER [PD_EXPAND]; a_regmatch___0: CE_POINTER [PD_REGMATCH_T]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_retstr: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_keep: NATURAL_8
			l_ga: CE_ARRAY [PD_GROWARRAY]
			js: JUMP_STATE
		do
			create l_retstr.make
			create l_s.make
			create l_e.make
			create l_ga.make (<<1>>)

			l_retstr := create {CE_POINTER [NATURAL_8]}.make_cast ((call_user_expand_func (eval_inst.call_func_retstr_address, a_xp, a_num_file, a_file)))
			if l_retstr.is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				misc2_inst.ga_init2 (l_ga, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 3)
				l_s := l_retstr
				from
				until
					not (not js.loop_done and then ((l_s.item).to_integer_32 /= 0))
				loop
					l_e := misc2_inst.vim_strchr (l_s, ('%N').code)
					if l_e.is_void then
						l_e := l_s + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
					end
					l_keep := l_e.item
					l_e.item := (0).to_natural_8
					if (a_xp.item.xp_pattern[0]).to_boolean then
						if (regexp_inst.vim_regexec (a_regmatch___0, l_s, 0)) = 0 then
							l_e.item := l_keep
							if (l_e.item).to_integer_32 /= 0 then
								l_e := l_e + 1
							end
							js.continue
						end
					end
					if not js.loop_jumped then
						if (misc2_inst.ga_grow (l_ga, 1)) = 0 then
							js.break
						end
					end
					if not js.loop_jumped then
						create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.item.ga_data)[l_ga.item.ga_len] := misc2_inst.vim_strnsave (l_s, l_e.distance (l_s))
						l_ga.item.ga_len := (l_ga.item.ga_len) + 1
						l_e.item := l_keep
						if (l_e.item).to_integer_32 /= 0 then
							l_e := l_e + 1
						end
					end
					if js.loop_increment then
						l_s := l_e
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_retstr))
				a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.item.ga_data)
				a_num_file.item := l_ga.item.ga_len
				Result := 1
			end
		end

	ExpandUserList (a_xp: CE_POINTER [PD_EXPAND]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_retlist: CE_POINTER [PD_LISTVAR_S]
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			js: JUMP_STATE
		do
			create l_retlist.make
			create l_li.make
			create l_ga.make (<<1>>)

			l_retlist := create {CE_POINTER [PD_LISTVAR_S]}.make_cast ((call_user_expand_func (eval_inst.call_func_retlist_address, a_xp, a_num_file, a_file)))
			if l_retlist.is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				misc2_inst.ga_init2 (l_ga, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 3)
				l_li := l_retlist.item.lv_first
				from
				until
					not (not js.loop_done and then (not l_li.is_void))
				loop
					if (l_li.item.li_tv.v_type).to_integer_32 /= 2 then
						js.continue
					elseif (l_li.item.li_tv.vval.v_string).is_void then
						js.continue
					end
					if not js.loop_jumped then
						if (misc2_inst.ga_grow (l_ga, 1)) = 0 then
							js.break
						end
					end
					if not js.loop_jumped then
						create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.item.ga_data)[l_ga.item.ga_len] := misc2_inst.vim_strsave (l_li.item.li_tv.vval.v_string)
						l_ga.item.ga_len := (l_ga.item.ga_len) + 1
					end
					if js.loop_increment then
						l_li := l_li.item.li_next
					end
				end
				eval_inst.list_unref (l_retlist)
				a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.item.ga_data)
				a_num_file.item := l_ga.item.ga_len
				Result := 1
			end
		end

	add_to_history (a_histype: INTEGER_32; a_new_entry: CE_POINTER [NATURAL_8]; a_in_map: INTEGER_32; a_sep: INTEGER_32)
		local
			l_hisptr: CE_POINTER [PD_HIST_ENTRY]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_hisptr.make

			if hislen = 0 then
				js.return
			end
			if not js.return_called then
				if a_histype = 1 then
					if a_in_map.to_boolean then
						if globals_inst.maptick = last_maptick then
							l_hisptr := history[1] + hisidx[1]
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hisptr.item.hisstr))
							l_hisptr.item.hisstr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_hisptr.item.hisnum := 0
							hisnum[a_histype] := (hisnum[a_histype]) - 1
							hisidx[1] := (hisidx[1]) - 1
							if hisidx[1] < 0 then
								hisidx[1] := hislen - 1
							end
						end
						last_maptick := -1
					end
				end
				if not (in_history (a_histype, a_new_entry, 1)).to_boolean then
					hisidx[a_histype] := (hisidx[a_histype]) + 1
					if hisidx[a_histype] = hislen then
						hisidx[a_histype] := 0
					end
					l_hisptr := history[a_histype] + hisidx[a_histype]
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hisptr.item.hisstr))
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_new_entry))).to_integer_32
					l_hisptr.item.hisstr := misc2_inst.vim_strnsave (a_new_entry, l_len + 2)
					if not (l_hisptr.item.hisstr).is_void then
						l_hisptr.item.hisstr[(l_len + 1)] := a_sep.to_natural_8
					end
					hisnum[a_histype] := (hisnum[a_histype]) + 1
					l_hisptr.item.hisnum := hisnum[a_histype]
					if a_histype = 1 then
						if a_in_map.to_boolean then
							last_maptick := globals_inst.maptick
						end
					end
				end
			end
		end

	addstar (a_fname: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_context: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_retval: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_new_len: INTEGER_32
			l_tail: CE_POINTER [NATURAL_8]
			l_ends_in_star: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_retval.make
			create l_tail.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					if a_context = 2 then
						l_pos := -1 + 49 -- skip if block
					end
				when 1 then -- if:
						if a_context = 38 then
							l_pos := -1 + 47 -- skip if block
						end
				when 2 then -- if:
						if a_context = 32 then
							l_pos := -1 + 45 -- skip if block
						end
				when 3 then -- if:
						if a_context = 3 then
							l_pos := -1 + 43 -- skip if block
						end
				when 4 then -- if:
						if a_context /= 8 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_retval := misc2_inst.vim_strnsave (a_fname, l_len)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 7 then -- else:
						if a_context /= 28 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_retval := misc2_inst.vim_strnsave (a_fname, l_len)
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 10 then -- else:
						if a_context /= 29 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_retval := misc2_inst.vim_strnsave (a_fname, l_len)
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 13 then -- else:
						if a_context /= 39 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_retval := misc2_inst.vim_strnsave (a_fname, l_len)
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 16 then -- else:
						if a_context /= 37 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_retval := misc2_inst.vim_strnsave (a_fname, l_len)
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 19 then -- else:
						if a_context /= 6 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (a_fname[0]).to_integer_32 = 47 then
							l_retval := misc2_inst.vim_strnsave (a_fname, l_len)
						else
							l_pos := -1 + 22 -- goto _L___0
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 22 then -- else: | _L___0:
						l_new_len := l_len + 2
						l_i___0 := 0
				when 23 then -- loop condition:
						if not (l_i___0 < l_len) then
							l_pos := -1 + 30 -- skip loop
						end
				when 24 then -- loop body:
						if (a_fname[l_i___0]).to_integer_32 = 42 then
							l_new_len := l_new_len + 1
						elseif (a_fname[l_i___0]).to_integer_32 = 126 then
							l_new_len := l_new_len + 1
						end
						if a_context = 9 then
							if (a_fname[l_i___0]).to_integer_32 = 46 then
								l_new_len := l_new_len + 1
							end
						end
						if a_context /= 30 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 27 then -- else:
						if a_context /= 31 then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L:
						if (a_fname[l_i___0]).to_integer_32 = 92 then
							l_new_len := l_new_len + 1
						end
				when 29 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 23 -- back to loop condition
				when 30 then -- loop done
						l_retval := misc2_inst.alloc (l_new_len.to_natural_32)
						if l_retval.is_void then
							l_pos := -1 + 42 -- skip if block
						end
				when 31 then -- if:
						l_retval[0] := (('^').code).to_natural_8
						l_j := 1
						l_i___0 := 0
				when 32 then -- loop condition:
						if not (not js.loop_done and then (l_i___0 < l_len)) then
							l_pos := -1 + 41 -- skip loop
						end
				when 33 then -- loop body:
						if a_context /= 30 then
							if a_context /= 31 then
								if (a_fname[l_i___0]).to_integer_32 = 92 then
									l_i___0 := l_i___0 + 1
									if l_i___0 = l_len then
										js.break
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 40 -- skip if block
						end
				when 34 then -- if:
						inspect (a_fname[l_i___0]).to_integer_32 -- switch 1 head
						when 42 then l_pos := -1 + 35
						when 126 then l_pos := -1 + 36
						when 63 then l_pos := -1 + 37
						when 46 then l_pos := -1 + 38
						when 92 then l_pos := -1 + 39
						else l_pos := -1 + 40
						end
				when 35 then -- switch 1, case 42
						l_tmp := l_j
						l_j := l_j + 1
						l_retval[l_tmp] := (('.').code).to_natural_8
						l_pos := -1 + 40 -- switch 1; break
				when 36 then -- switch 1, case 126
						l_tmp___0 := l_j
						l_j := l_j + 1
						l_retval[l_tmp___0] := (('\').code).to_natural_8
						l_pos := -1 + 40 -- switch 1; break
				when 37 then -- switch 1, case 63
						l_retval[l_j] := (('.').code).to_natural_8
						js.continue
				when 38 then -- switch 1, case 46
						if not js.loop_jumped and then (a_context = 9) then
							l_tmp___1 := l_j
							l_j := l_j + 1
							l_retval[l_tmp___1] := (('\').code).to_natural_8
						end
						l_pos := -1 + 40 -- switch 1; break
				when 39 then -- switch 1, case 92
						if a_context = 30 then
							l_tmp___2 := l_j
							l_j := l_j + 1
							l_retval[l_tmp___2] := (('\').code).to_natural_8
						elseif a_context = 31 then
							l_tmp___2 := l_j
							l_j := l_j + 1
							l_retval[l_tmp___2] := (('\').code).to_natural_8
						end
						l_pos := -1 + 40 -- switch 1; break
				when 40 then -- switch 1, done: | if done
						if not js.loop_jumped then
							l_retval[l_j] := a_fname[l_i___0]
						end
						if js.loop_increment then
							l_i___0 := l_i___0 + 1
							l_j := l_j + 1
						end
						l_pos := -1 + 32 -- back to loop condition
				when 41 then -- loop done
						l_retval[l_j] := (('%/0/').code).to_natural_8
				when 42 then -- if done | if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_pos := -1 + 49 -- goto _L___7
				when 44 then -- if done | if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:
						l_pos := -1 + 49 -- goto _L___7
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:
						l_pos := -1 + 49 -- goto _L___7
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 58
				when 49 then -- else: | _L___7:
						l_retval := misc2_inst.alloc ((l_len + 4).to_natural_32)
						if l_retval.is_void then
							l_pos := -1 + 58 -- skip if block
						end
				when 50 then -- if:
						misc2_inst.vim_strncpy (l_retval, a_fname, l_len.to_natural_32)
						l_tail := misc1_inst.gettail (l_retval)
						if l_len > 0 then
							if (l_retval[(l_len - 1)]).to_integer_32 = 42 then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
						l_ends_in_star := l_tmp___3
						l_i___0 := l_len - 2
						from
						until
							not (not js.loop_done and then (l_i___0 >= 0))
						loop
							if (l_retval[l_i___0]).to_integer_32 /= 92 then
								js.break
							end
							if not js.loop_jumped then
								l_ends_in_star := (not l_ends_in_star.to_boolean).to_integer
								l_i___0 := l_i___0 - 1
							end
						end
						if (l_retval.item).to_integer_32 = 126 then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						l_pos := -1 + 54 -- goto _L___4
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 53 then -- else:
						if l_tail.is_equal (l_retval) then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if: | _L___4:
						if not l_ends_in_star.to_boolean then
							if (misc2_inst.vim_strchr (l_tail, ('$').code)).is_void then
								if (misc2_inst.vim_strchr (l_retval, ('`').code)).is_void then
									l_tmp___4 := l_len
									l_len := l_len + 1
									l_retval[l_tmp___4] := (('*').code).to_natural_8
								else
									l_pos := -1 + 56 -- goto _L___3
								end
							else
								l_pos := -1 + 56 -- goto _L___3
							end
						else
							l_pos := -1 + 56 -- goto _L___3
						end
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 56 then -- else: | _L___3:
						if l_len > 0 then
							if (l_retval[(l_len - 1)]).to_integer_32 = 36 then
								l_len := l_len - 1
							end
						end
				when 57 then -- if done
						l_retval[l_len] := (('%/0/').code).to_natural_8
				when 58 then -- if done
						Result := l_retval
				when 59 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	allbuf_locked: INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.allbuf_lock > 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E811: Not allowed to change buffer information now"))))).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	alloc_cmdbuff (a_len: INTEGER_32)
		local
			l_len: INTEGER_32
		do
			l_len := a_len
			if l_len < 80 then
				l_len := 100
			else
				l_len := l_len + (20)
			end
			ccline.item.cmdbuff := misc2_inst.alloc (l_len.to_natural_32)
			ccline.item.cmdbufflen := l_len
		end

	calc_hist_idx (a_histype: INTEGER_32; a_num: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_hist: CE_POINTER [PD_HIST_ENTRY]
			l_wrapped: INTEGER_32
			js: JUMP_STATE
		do
			create l_hist.make

			l_wrapped := 0
			if hislen = 0 then
				Result := (-1)
				js.return
			elseif a_histype < 0 then
				Result := (-1)
				js.return
			elseif a_histype >= 5 then
				Result := (-1)
				js.return
			else
				l_i___0 := hisidx[a_histype]
				if l_i___0 < 0 then
					Result := (-1)
					js.return
				elseif a_num = 0 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_hist := history[a_histype]
				if a_num > 0 then
					from
					until
						not (not js.loop_done and then ((l_hist + l_i___0).item.hisnum > a_num))
					loop
						l_i___0 := l_i___0 - 1
						if l_i___0 < 0 then
							if l_wrapped.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + hislen
								l_wrapped := 1
							end
						end
					end
					if (l_hist + l_i___0).item.hisnum = a_num then
						if not ((l_hist + l_i___0).item.hisstr).is_void then
							Result := l_i___0
							js.return
						end
					end
				elseif -a_num <= hislen then
					l_i___0 := l_i___0 + (a_num + 1)
					if l_i___0 < 0 then
						l_i___0 := l_i___0 + hislen
					end
					if not ((l_hist + l_i___0).item.hisstr).is_void then
						Result := l_i___0
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	call_user_expand_func (a_user_expand_func: CE_ROUTINE; a_xp: CE_POINTER [PD_EXPAND]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): CE_POINTER [ANY]
		local
			l_keep: NATURAL_8
			l_num: CE_ARRAY [NATURAL_8]
			l_args: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_save_current_SID: INTEGER_32
			l_ret: CE_POINTER [ANY]
			l_save_ccline: PD_CMDLINE_INFO
			js: JUMP_STATE
		do
			create l_num.make (<<50>>)
			create l_args.make (<<3>>)
			create l_ret.make
			create l_save_ccline.make

			l_save_current_SID := globals_inst.current_SID
			if (a_xp.item.xp_arg).is_void then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				js.return
			elseif (a_xp.item.xp_arg[0]).to_integer_32 = 0 then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				a_num_file.item := 0
				a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
				if (ccline.item.cmdbuff).is_void then
					l_keep := (0).to_natural_8
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_num), ce_string ("%%d"), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_xp.item.xp_pattern))).to_integer_32]).do_nothing
					l_args[1] := a_xp.item.xp_pattern
				else
					l_keep := ccline.item.cmdbuff[ccline.item.cmdlen]
					ccline.item.cmdbuff[ccline.item.cmdlen] := (0).to_natural_8
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_num), ce_string ("%%d"), ccline.item.cmdpos]).do_nothing
					l_args[1] := ccline.item.cmdbuff
				end
				l_args[0] := misc2_inst.vim_strnsave (a_xp.item.xp_pattern, a_xp.item.xp_pattern_len)
				l_args[2] := l_num
				l_save_ccline := (ccline.item).twin
				ccline.item.cmdbuff := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				ccline.item.cmdprompt := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				globals_inst.current_SID := a_xp.item.xp_scriptID
				l_ret := create {CE_POINTER [ANY]}.make_cast (a_user_expand_func.pointer_item ([a_xp.item.xp_arg, 3, l_args, 0]))
				ccline.item := l_save_ccline.twin
				globals_inst.current_SID := l_save_current_SID
				if not (ccline.item.cmdbuff).is_void then
					ccline.item.cmdbuff[ccline.item.cmdlen] := l_keep
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_args[0]))
				Result := l_ret
			end
		end

	ccheck_abbr (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (option_inst.p_paste.item).to_boolean then
				Result := 0
				js.return
			elseif globals_inst.no_abbr.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := (getchar_inst.check_abbr (a_c, ccline.item.cmdbuff, ccline.item.cmdpos, 0))
			end
		end

	cleanup_help_tags (a_num_file: INTEGER_32; a_file: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_done and then (l_i___0 < a_num_file))
			loop
				l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_file[l_i___0]))).to_integer_32 - 3
				if l_len > 0 then
					if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((a_file[l_i___0] + l_len)), ce_string ("@en"))) = 0 then
						l_j := 0
						from
						until
							not (not js.loop_done and then (l_j < a_num_file))
						loop
							if l_j /= l_i___0 then
								if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_file[l_j]))).to_integer_32 = l_len + 3 then
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_file[l_i___0]), create {CE_POINTER [INTEGER_8]}.make_cast (a_file[l_j]), (l_len + 1).to_natural_32)) = 0 then
										js.break
									end
								end
							end
							if not js.loop_jumped then
								l_j := l_j + 1
							end
						end
						if l_j = a_num_file then
							(a_file[l_i___0])[l_len] := (('%/0/').code).to_natural_8
						end
					end
				end
				l_i___0 := l_i___0 + 1
			end
		end

	clr_history (a_histype: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_hisptr: CE_POINTER [PD_HIST_ENTRY]
			l_tmp: CE_POINTER [PD_HIST_ENTRY]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_hisptr.make
			create l_tmp.make

			if hislen /= 0 then
				if a_histype >= 0 then
					if a_histype < 5 then
						l_hisptr := history[a_histype]
						l_i___0 := hislen
						from
						until
							js.loop_done
						loop
							l_tmp___0 := l_i___0
							l_i___0 := l_i___0 - 1
							if not l_tmp___0.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hisptr.item.hisstr))
								l_hisptr.item.hisnum := 0
								l_tmp := l_hisptr
								l_hisptr := l_hisptr + 1
								l_tmp.item.hisstr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
						end
						hisidx[a_histype] := -1
						hisnum[a_histype] := 0
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cmdline_at_end: INTEGER_32
		do
			Result := (ccline.item.cmdpos >= ccline.item.cmdlen).to_integer
		end

	cmdline_charsize (a_idx: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.cmdline_star > 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (charset_inst.ptr2cells (ccline.item.cmdbuff + a_idx))
			end
		end

	cmdline_del (a_from: INTEGER_32)
		do
			memmove (create {CE_POINTER [ANY]}.make_cast ((ccline.item.cmdbuff + a_from)), create {CE_POINTER [ANY]}.make_cast ((ccline.item.cmdbuff + ccline.item.cmdpos)), ((ccline.item.cmdlen - ccline.item.cmdpos) + 1).to_natural_32).do_nothing
			ccline.item.cmdlen := ccline.item.cmdlen - (ccline.item.cmdpos - a_from)
			ccline.item.cmdpos := a_from
		end

	cmdline_getvcol_cursor: INTEGER_32
		local
			l_col: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if (ccline.item.cmdbuff).is_void then
				Result := (2_147_483_647).to_integer_32
				js.return
			elseif ccline.item.cmdpos > ccline.item.cmdlen then
				Result := (2_147_483_647).to_integer_32
				js.return
			end
			if not js.return_called then
				if globals_inst.has_mbyte.to_boolean then
					l_i___0 := 0
					l_col := 0
					from
					until
						not (l_i___0 < ccline.item.cmdpos)
					loop
						l_i___0 := l_i___0 + (globals_inst.mb_ptr2len.integer_32_item ([ccline.item.cmdbuff + l_i___0]))
						l_col := l_col + 1
					end
					Result := l_col
				else
					Result := (ccline.item.cmdpos)
				end
			end
		end

	cmdline_overstrike: INTEGER_32
		do
			Result := (ccline.item.overstrike)
		end

	cmdline_paste (a_regname___0: INTEGER_32; a_literally: INTEGER_32; a_remcr: INTEGER_32): INTEGER_32
		local
			l_regname___0: INTEGER_32
			l_i___0: INTEGER_32
			l_arg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_allocated: CE_ARRAY [INTEGER_32]
			l_save_ccline: CE_ARRAY [PD_CMDLINE_INFO]
			l_w: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
		do
			create l_arg.make (<<1>>)
			create l_p___0.make
			create l_allocated.make (<<1>>)
			create l_save_ccline.make (<<1>>)
			create l_w.make

			l_regname___0 := a_regname___0
			if l_regname___0 /= 6 then
				if l_regname___0 /= 16 then
					if l_regname___0 /= 23 then
						if l_regname___0 /= 1 then
							if not (ops_inst.valid_yank_reg (l_regname___0, 0)).to_boolean then
								Result := 0
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				misc1_inst.line_breakcheck
				if globals_inst.got_int.to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_regname___0 := ops_inst.may_get_selection (l_regname___0)
				save_cmdline (l_save_ccline)
				globals_inst.textlock := globals_inst.textlock + 1
				l_i___0 := (ops_inst.get_spec_reg (l_regname___0, l_arg, l_allocated, 1)).to_integer_32
				globals_inst.textlock := globals_inst.textlock - 1
				restore_cmdline (l_save_ccline)
				if l_i___0.to_boolean then
					if (l_arg.item).is_void then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_p___0 := l_arg.item
						if (option_inst.p_is.item).to_boolean then
							if l_regname___0 = 23 then
								l_w := ccline.item.cmdbuff + ccline.item.cmdlen
								from
								until
									not (not js.loop_done and then ((l_w.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.cmdbuff).c_pointer.to_integer_32).to_natural_32))
								loop
									if globals_inst.has_mbyte.to_boolean then
										l_len := (globals_inst.mb_head_off.integer_32_item ([ccline.item.cmdbuff, l_w - 1])) + 1
										if not (charset_inst.vim_iswordc ((globals_inst.mb_ptr2char.integer_32_item ([l_w - l_len])))).to_boolean then
											js.break
										end
										if not js.loop_jumped then
											l_w := l_w - l_len
										end
									else
										if not (charset_inst.vim_iswordc ((l_w[-1]).to_integer_32)).to_boolean then
											js.break
										end
										if not js.loop_jumped then
											l_w := l_w - 1
										end
									end
								end
								l_len := (ccline.item.cmdbuff + ccline.item.cmdlen).distance (l_w)
								if (option_inst.p_ic.item).to_boolean then
									l_tmp___7 := ((strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_w), create {CE_POINTER [INTEGER_8]}.make_cast (l_arg.item), l_len.to_natural_32)) = 0).to_integer
								else
									l_tmp___7 := ((strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_w), create {CE_POINTER [INTEGER_8]}.make_cast (l_arg.item), l_len.to_natural_32)) = 0).to_integer
								end
								if l_tmp___7.to_boolean then
									l_p___0 := l_p___0 + l_len
								end
							end
						end
						cmdline_paste_str (l_p___0, a_literally)
						if (l_allocated.item).to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_arg.item))
						end
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (ops_inst.cmdline_paste_reg (l_regname___0, a_literally, a_remcr))
			end
		end

	cmdline_paste_str (a_s: CE_POINTER [NATURAL_8]; a_literally: INTEGER_32)
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_cv: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_s.make (<<1>>)
			create l_tmp.make

			l_s.item := a_s
			if a_literally.to_boolean then
				put_on_cmdline (l_s.item, -1, 1).do_nothing
			else
				from
				until
					(l_s.item.item).to_integer_32 = 0
				loop
					l_cv := (l_s.item.item).to_integer_32
					if l_cv = 22 then
						if (l_s.item[1]).to_boolean then
							l_s.item := l_s.item + 1
						end
					end
					if globals_inst.has_mbyte.to_boolean then
						l_c := mbyte_inst.mb_cptr2char_adv (l_s)
					else
						l_tmp := l_s.item
						l_s.item := l_s.item + 1
						l_c := (l_tmp.item).to_integer_32
					end
					if l_cv = 22 then
						getchar_inst.stuffcharReadbuff (22)
					elseif l_c = 27 then
						getchar_inst.stuffcharReadbuff (22)
					elseif l_c = 3 then
						getchar_inst.stuffcharReadbuff (22)
					elseif l_c = 13 then
						getchar_inst.stuffcharReadbuff (22)
					elseif l_c = 10 then
						getchar_inst.stuffcharReadbuff (22)
					elseif l_c = globals_inst.intr_char then
						getchar_inst.stuffcharReadbuff (22)
					elseif l_c = 28 then
						if (l_s.item.item).to_integer_32 = 14 then
							getchar_inst.stuffcharReadbuff (22)
						end
					end
					getchar_inst.stuffcharReadbuff (l_c)
				end
			end
		end

	compute_cmdrow
		do
			if globals_inst.exmode_active.to_boolean then
				globals_inst.cmdline_row := (globals_inst.Rows.item - 1).to_integer_32
			elseif globals_inst.msg_scrolled /= 0 then
				globals_inst.cmdline_row := (globals_inst.Rows.item - 1).to_integer_32
			else
				globals_inst.cmdline_row := (globals_inst.lastwin.item.w_winrow + globals_inst.lastwin.item.w_height) + globals_inst.lastwin.item.w_status_height
			end
		end

	correct_cmdspos (a_idx: INTEGER_32; a_cells: INTEGER_32)
		do
			if (globals_inst.mb_ptr2len.integer_32_item ([ccline.item.cmdbuff + a_idx])) > 1 then
				if (globals_inst.mb_ptr2cells.integer_32_item ([ccline.item.cmdbuff + a_idx])) > 1 then
					if (ccline.item.cmdspos).to_integer_32 \\ globals_inst.Columns.item + a_cells.to_integer_32 > globals_inst.Columns.item then
						ccline.item.cmdspos := (ccline.item.cmdspos) + 1
					end
				end
			end
		end

	curbuf_locked: INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.curbuf_lock > 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E788: Not allowed to edit another buffer now"))))).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (allbuf_locked)
			end
		end

	cursorcmd
		local
			js: JUMP_STATE
		do
			if globals_inst.cmd_silent.to_boolean then
				js.return
			end
			if not js.return_called then
				globals_inst.msg_row := globals_inst.cmdline_row + ccline.item.cmdspos // (globals_inst.Columns.item).to_integer_32
				globals_inst.msg_col := ccline.item.cmdspos \\ (globals_inst.Columns.item).to_integer_32
				if globals_inst.msg_row.to_integer_32 >= globals_inst.Rows.item then
					globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
				end
				screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
				redrawcmd_preedit
			end
		end

	del_history_entry (a_histype: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_hisptr: CE_POINTER [PD_HIST_ENTRY]
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_last: INTEGER_32
			l_found: INTEGER_32
			js: JUMP_STATE
		do
			create l_regmatch___0.make (<<1>>)
			create l_hisptr.make

			l_found := 0
			l_regmatch___0.item.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			l_regmatch___0.item.rm_ic := 0
			if hislen /= 0 then
				if a_histype >= 0 then
					if a_histype < 5 then
						if (a_str___1.item).to_integer_32 /= 0 then
							l_idx := hisidx[a_histype]
							if l_idx >= 0 then
								l_regmatch___0.item.regprog := regexp_inst.vim_regcomp (a_str___1, 3)
								if not (l_regmatch___0.item.regprog).is_void then
									l_last := l_idx
									l_i___0 := l_last
									from
									until
										js.loop_done
									loop
										l_hisptr := history[a_histype] + l_i___0
										if (l_hisptr.item.hisstr).is_void then
											js.break
										end
										if not js.loop_jumped then
											if (regexp_inst.vim_regexec (l_regmatch___0, l_hisptr.item.hisstr, 0)).to_boolean then
												l_found := 1
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hisptr.item.hisstr))
												l_hisptr.item.hisstr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
												l_hisptr.item.hisnum := 0
											else
												if l_i___0 /= l_last then
													(history[a_histype])[l_last] := (l_hisptr.item).twin
													l_hisptr.item.hisstr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
													l_hisptr.item.hisnum := 0
												end
												l_last := l_last - 1
												if l_last < 0 then
													l_last := l_last + hislen
												end
											end
											l_i___0 := l_i___0 - 1
											if l_i___0 < 0 then
												l_i___0 := l_i___0 + hislen
											end
											if l_i___0 = l_idx then
												js.break
											end
										end
									end
									if ((history[a_histype] + l_idx).item.hisstr).is_void then
										hisidx[a_histype] := -1
									end
								end
							end
						end
					end
				end
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.item.regprog))
			Result := l_found
		end

	del_history_idx (a_histype: INTEGER_32; a_idx: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			l_idx := a_idx
			l_i___0 := calc_hist_idx (a_histype, l_idx)
			if l_i___0 < 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_idx := hisidx[a_histype]
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((history[a_histype] + l_i___0).item.hisstr))
				if a_histype = 1 then
					if globals_inst.maptick = last_maptick then
						if l_i___0 = l_idx then
							last_maptick := -1
						end
					end
				end
				from
				until
					l_i___0 = l_idx
				loop
					l_j := (l_i___0 + 1) \\ hislen;
					(history[a_histype])[l_i___0] := ((history[a_histype])[l_j]).twin
					l_i___0 := l_j
				end
				(history[a_histype] + l_i___0).item.hisstr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer);
				(history[a_histype] + l_i___0).item.hisnum := 0
				l_i___0 := l_i___0 - 1
				if l_i___0 < 0 then
					l_i___0 := l_i___0 + hislen
				end
				hisidx[a_histype] := l_i___0
				Result := 1
			end
		end

	draw_cmdline (a_start___1: INTEGER_32; a_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			if globals_inst.cmdline_star > 0 then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_len)
				loop
					message_inst.msg_putchar (('*').code)
					if globals_inst.has_mbyte.to_boolean then
						l_i___0 := l_i___0 + ((globals_inst.mb_ptr2len.integer_32_item ([(ccline.item.cmdbuff + a_start___1) + l_i___0])) - 1)
					end
					l_i___0 := l_i___0 + 1
				end
			else
				message_inst.msg_outtrans_len (ccline.item.cmdbuff + a_start___1, a_len).do_nothing
			end
		end

	escape_fname (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0 := misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pp.item))) + {NATURAL_32} 2)
			if not l_p___0.is_void then
				l_p___0[0] := (('\').code).to_natural_8
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (a_pp.item)).do_nothing
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_pp.item))
				a_pp.item := l_p___0
			end
		end

	ex_history (a_eap: CE_POINTER [PD_EXARG])
		local
			l_hist: CE_POINTER [PD_HIST_ENTRY]
			l_histype1: INTEGER_32
			l_histype2: INTEGER_32
			l_hisidx1: CE_ARRAY [INTEGER_32]
			l_hisidx2: CE_ARRAY [INTEGER_32]
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_end: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_arg: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hist.make
			create l_hisidx1.make (<<1>>)
			create l_hisidx2.make (<<1>>)
			create l_end.make (<<1>>)
			create l_arg.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_histype1 := 0
					l_histype2 := 0
					l_hisidx1.item := 1
					l_hisidx2.item := -1
					l_arg := a_eap.item.arg
					if hislen = 0 then
						message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%'history%' option is zero"))))).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if not ((l_arg.item).to_integer_32 >= 48) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_arg.item).to_integer_32 <= 57 then
							l_end.item := l_arg
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else: | _L___0:
						if (l_arg.item).to_integer_32 /= 45 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_end.item := l_arg
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else:
						if (l_arg.item).to_integer_32 /= 44 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_end.item := l_arg
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 10 then -- else:
						l_end.item := l_arg
				when 11 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 17 -- skip loop
						end
				when 12 then -- loop body:
						if not ((l_end.item.item).to_integer_32 < 127) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if not ((((ctype_b_loc).item[(l_end.item.item).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
							l_pos := -1 + 15 -- goto _L
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L:
						if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":=@>/?")), (l_end.item.item).to_integer_32)).is_void then
							js.break
						end
				when 16 then
						if not js.loop_jumped then
							l_end.item := l_end.item + 1
						end
						l_pos := -1 + 11 -- back to loop condition
				when 17 then -- loop done
						l_i___0 := (l_end.item.item).to_integer_32
						l_end.item.item := (('%/0/').code).to_natural_8
						l_histype1 := get_histtype (l_arg)
						if l_histype1 = -1 then
							if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("all"), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg))))) = 0 then
								l_histype1 := 0
								l_histype2 := 4
							else
								l_end.item.item := l_i___0.to_natural_8
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing))))).do_nothing
								js.return
							end
						else
							l_histype2 := l_histype1
						end
						if not js.return_called then
							l_end.item.item := l_i___0.to_natural_8
						end
				when 18 then -- if done | if done | if done
						if not js.return_called then
							if (get_list_range (l_end, l_hisidx1, l_hisidx2)).to_boolean then
								if (l_end.item.item).to_integer_32 /= 0 then
									l_tmp___5 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5)).do_nothing
									js.return
								end
							else
								l_tmp___5 := gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing))
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5)).do_nothing
								js.return
							end
						end
						if not js.return_called then
							from
							until
								js.loop_done
							loop
								if not globals_inst.got_int.to_boolean then
									if not (l_histype1 <= l_histype2) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%N      #  ")).do_nothing
									strcat ((strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), history_names[l_histype1])), ce_string (" history")).do_nothing
									message_inst.msg_puts_title (globals_inst.IObuff)
									l_idx := hisidx[l_histype1]
									l_hist := history[l_histype1]
									l_j := l_hisidx1.item
									l_k := l_hisidx2.item
									if l_j < 0 then
										if -l_j > hislen then
											l_j := 0
										else
											l_j := (l_hist + (((hislen + l_j) + l_idx) + 1) \\ hislen).item.hisnum
										end
									end
									if l_k < 0 then
										if -l_k > hislen then
											l_k := 0
										else
											l_k := (l_hist + (((hislen + l_k) + l_idx) + 1) \\ hislen).item.hisnum
										end
									end
									if l_idx >= 0 then
										if l_j <= l_k then
											l_i___0 := l_idx + 1
											from
											until
												not (not js.loop_done and then (not globals_inst.got_int.to_boolean))
											loop
												if l_i___0 = hislen then
													l_i___0 := 0
												end
												if not ((l_hist + l_i___0).item.hisstr).is_void then
													if (l_hist + l_i___0).item.hisnum >= l_j then
														if (l_hist + l_i___0).item.hisnum <= l_k then
															message_inst.msg_putchar (('%N').code)
															if l_i___0 = l_idx then
																l_tmp___8 := ('>').code
															else
																l_tmp___8 := (' ').code
															end
															sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%%c%%6d  "), l_tmp___8, (l_hist + l_i___0).item.hisnum]).do_nothing
															if (charset_inst.vim_strsize ((l_hist + l_i___0).item.hisstr)) > (globals_inst.Columns.item).to_integer_32 - 10 then
																message_inst.trunc_string ((l_hist + l_i___0).item.hisstr, globals_inst.IObuff + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32, (globals_inst.Columns.item).to_integer_32 - 10)
															else
																strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast ((l_hist + l_i___0).item.hisstr)).do_nothing
															end
															message_inst.msg_outtrans (globals_inst.IObuff).do_nothing
															term_inst.out_flush
														end
													end
												end
												if l_i___0 = l_idx then
													js.break
												end
												if not js.loop_jumped then
													l_i___0 := l_i___0 + 1
												end
											end
										end
									end
									l_histype1 := l_histype1 + 1
								end
							end
						end
				when 19 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_history_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_history)
		end

	ex_window: INTEGER_32
		local
			l_save_ccline: PD_CMDLINE_INFO
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_bp___0: CE_POINTER [PD_FILE_BUFFER]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_i___0: INTEGER_32
			l_lnum: INTEGER_32
			l_histtype: INTEGER_32
			l_winsizes: CE_ARRAY [PD_GROWARRAY]
			l_typestr: CE_ARRAY [NATURAL_8]
			l_save_restart_edit: INTEGER_32
			l_save_State: INTEGER_32
			l_save_exmode: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_save_ccline.make
			create l_old_curbuf.make
			create l_old_curwin___1.make
			create l_bp___0.make
			create l_wp___0.make
			create l_winsizes.make (<<1>>)
			create l_typestr.make (<<2>>)
			create l_tmp___1.make
			create l_p___0.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_curbuf := globals_inst.curbuf
					l_old_curwin___1 := globals_inst.curwin
					l_save_restart_edit := globals_inst.restart_edit
					l_save_State := globals_inst.State
					l_save_exmode := globals_inst.exmode_active
					if globals_inst.cmdwin_type /= 0 then
						misc1_inst.beep_flush
						Result := (-(253 + ((53).bit_shift_left (8))))
						js.return
					elseif globals_inst.cmdline_star > 0 then
						misc1_inst.beep_flush
						Result := (-(253 + ((53).bit_shift_left (8))))
						js.return
					end
					if not js.return_called then
						window_inst.win_size_save (l_winsizes)
						fileio_inst.block_autocmds
						globals_inst.cmdmod.item.tab := 0
						if (window_inst.win_split ((option_inst.p_cwh.item).to_integer_32, 8)) = 0 then
							misc1_inst.beep_flush
							fileio_inst.unblock_autocmds
							Result := (-(253 + ((53).bit_shift_left (8))))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						globals_inst.cmdwin_type := get_cmdline_type
						ex_cmds_inst.do_ecmd (0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 1, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)).do_nothing
						buffer_inst.setfname (globals_inst.curbuf, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[Command Line]")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1).do_nothing
						option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bt")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("nofile")), 4)
						option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("swf")), 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 4)
						globals_inst.curbuf.item.b_p_ma := 1
						globals_inst.curwin.item.w_onebuf_opt.wo_fen := 0
						globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
						fileio_inst.unblock_autocmds
						globals_inst.need_wait_return := 0
						l_histtype := hist_char2type (globals_inst.cmdwin_type)
						if l_histtype /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_histtype /= 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if option_inst.p_wc.item = 9 then
							getchar_inst.add_map (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<buffer> <Tab> <C-X><C-V>")), 16)
							getchar_inst.add_map (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<buffer> <Tab> a<C-X><C-V>")), 1)
						end
						option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ft")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("vim")), 4)
				when 6 then -- if done
						globals_inst.curbuf.item.b_p_tw := 0
						init_history
						if hislen > 0 then
							l_i___0 := hisidx[l_histtype]
							if l_i___0 >= 0 then
								l_lnum := (0).to_integer_32
								from
								until
									js.loop_done
								loop
									l_i___0 := l_i___0 + 1
									if l_i___0 = hislen then
										l_i___0 := 0
									end
									if not ((history[l_histtype] + l_i___0).item.hisstr).is_void then
										l_tmp___0 := l_lnum
										l_lnum := l_lnum + 1
										memline_inst.ml_append (l_tmp___0, (history[l_histtype] + l_i___0).item.hisstr, 0, 0).do_nothing
									end
									if l_i___0 = hisidx[l_histtype] then
										js.break
									end
								end
							end
						end
						memline_inst.ml_replace (globals_inst.curbuf.item.b_ml.ml_line_count, ccline.item.cmdbuff, 1).do_nothing
						globals_inst.curwin.item.w_cursor.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
						globals_inst.curwin.item.w_cursor.col := ccline.item.cmdpos
						move_inst.changed_line_abv_curs
						move_inst.invalidate_botline
						screen_inst.redraw_later (35)
						l_save_ccline := (ccline.item).twin
						ccline.item.cmdbuff := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						ccline.item.cmdprompt := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						globals_inst.exmode_active := 0
						globals_inst.State := 1
						term_inst.setmouse
						l_typestr[0] := globals_inst.cmdwin_type.to_natural_8
						l_typestr[1] := (('%/0/').code).to_natural_8
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_CMDWINENTER, l_typestr, l_typestr, 0, globals_inst.curbuf).do_nothing
						if globals_inst.restart_edit /= 0 then
							getchar_inst.stuffcharReadbuff (-(253 + ((97).bit_shift_left (8))))
						end
						l_i___0 := globals_inst.RedrawingDisabled
						globals_inst.RedrawingDisabled := 0
						globals_inst.cmdwin_result := 0
						main_inst.main_loop (1, 0)
						globals_inst.RedrawingDisabled := l_i___0
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_CMDWINLEAVE, l_typestr, l_typestr, 0, globals_inst.curbuf).do_nothing
						ccline.item := l_save_ccline.twin
						globals_inst.cmdwin_type := 0
						globals_inst.exmode_active := l_save_exmode
						if not ((window_inst.win_valid (l_old_curwin___1)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 7 then -- if:
						if not ((buffer_inst.buf_valid (l_old_curbuf)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if (ex_eval_inst.aborting).to_boolean then
							if globals_inst.cmdwin_result /= -(253 + ((53).bit_shift_left (8))) then
								globals_inst.cmdwin_result := 3
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (ccline.item.cmdbuff))
						if globals_inst.cmdwin_result /= -(253 + ((57).bit_shift_left (8))) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if globals_inst.cmdwin_result /= -(253 + ((58).bit_shift_left (8))) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if globals_inst.cmdwin_result = -(253 + ((58).bit_shift_left (8))) then
							l_tmp___3 := ce_string ("qa")
						else
							l_tmp___3 := ce_string ("qa!")
						end
						l_p___0 := l_tmp___3
						if l_histtype = 0 then
							ccline.item.cmdbuff := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0))
							globals_inst.cmdwin_result := ('%R').code
						else
							ccline.item.cmdbuff := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							getchar_inst.stuffcharReadbuff ((':').code)
							getchar_inst.stuffReadbuff (create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0))
							getchar_inst.stuffcharReadbuff (('%R').code)
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						if globals_inst.cmdwin_result = -(253 + ((58).bit_shift_left (8))) then
							ccline.item.cmdbuff := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("qa")))
							globals_inst.cmdwin_result := ('%R').code
						else
							ccline.item.cmdbuff := misc2_inst.vim_strsave ((memline_inst.ml_get_curline))
						end
				when 15 then -- if done
						if (ccline.item.cmdbuff).is_void then
							globals_inst.cmdwin_result := 3
						else
							ccline.item.cmdlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ccline.item.cmdbuff))).to_integer_32
							ccline.item.cmdbufflen := ccline.item.cmdlen + 1
							ccline.item.cmdpos := globals_inst.curwin.item.w_cursor.col
							if ccline.item.cmdpos > ccline.item.cmdlen then
								ccline.item.cmdpos := ccline.item.cmdlen
							end
							if globals_inst.cmdwin_result = -(253 + ((53).bit_shift_left (8))) then
								set_cmdspos_cursor
								redrawcmd
							end
						end
						fileio_inst.block_autocmds
						l_wp___0 := globals_inst.curwin
						l_bp___0 := globals_inst.curbuf
						window_inst.win_goto (l_old_curwin___1)
						window_inst.win_close (l_wp___0, 1)
						if (buffer_inst.buf_valid (l_bp___0)).to_boolean then
							buffer_inst.close_buffer (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), l_bp___0, 4)
						end
						window_inst.win_size_restore (l_winsizes)
						fileio_inst.unblock_autocmds
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						globals_inst.cmdwin_result := 3
						l_tmp___1 := gettext (ce_string ("E199: Active window or buffer deleted"))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						globals_inst.cmdwin_result := 3
						l_tmp___1 := gettext (ce_string ("E199: Active window or buffer deleted"))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
				when 20 then -- if done
						misc2_inst.ga_clear (l_winsizes)
						globals_inst.restart_edit := l_save_restart_edit
						globals_inst.State := l_save_State
						term_inst.setmouse
						Result := globals_inst.cmdwin_result
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	expand_cmdline (a_xp: CE_POINTER [PD_EXPAND]; a_str___1: CE_POINTER [NATURAL_8]; a_col: INTEGER_32; a_matchcount: CE_POINTER [INTEGER_32]; a_matches___0: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_file_str: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_file_str.make

			l_file_str := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if a_xp.item.xp_context = -2 then
				misc1_inst.beep_flush
				Result := (-2)
				js.return
			end
			if not js.return_called and then (a_xp.item.xp_context = 0) then
				Result := 0
				js.return
			end
			if not js.return_called then
				a_xp.item.xp_pattern_len := (a_str___1 + a_col).distance ((a_xp.item.xp_pattern))
				l_file_str := addstar (a_xp.item.xp_pattern, a_xp.item.xp_pattern_len, a_xp.item.xp_context)
				if l_file_str.is_void then
					Result := (-2)
					js.return
				end
			end
			if not js.return_called then
				if (ExpandFromContext (a_xp, l_file_str, a_matchcount, a_matches___0, 80)) = 0 then
					a_matchcount.item := 0
					a_matches___0.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_file_str))
				Result := (-1)
			end
		end

	expand_shellcmd (a_filepat: CE_POINTER [NATURAL_8]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flagsarg: INTEGER_32): INTEGER_32
		local
			l_pat: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_path: CE_POINTER [NATURAL_8]
			l_mustfree: CE_ARRAY [INTEGER_32]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_buf___6: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: NATURAL_32
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_flags___0: INTEGER_32
			l_ret: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
		do
			create l_pat.make
			create l_path.make
			create l_mustfree.make (<<1>>)
			create l_ga.make (<<1>>)
			create l_buf___6.make (<<1>>)
			create l_s.make
			create l_e.make

			l_mustfree.item := 0
			l_buf___6.item := (misc2_inst.alloc ({NATURAL_32} 4_096))
			l_flags___0 := a_flagsarg
			if (l_buf___6.item).is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_pat := misc2_inst.vim_strsave (a_filepat)
				l_i___0 := 0
				from
				until
					not ((l_pat[l_i___0]).to_boolean)
				loop
					if (l_pat[l_i___0]).to_integer_32 = 92 then
						if (l_pat[(l_i___0 + 1)]).to_integer_32 = 32 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_pat + l_i___0)), create {CE_POINTER [ANY]}.make_cast (((l_pat + l_i___0) + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((l_pat + l_i___0) + 1)))) + {NATURAL_32} 1).do_nothing
						end
					end
					l_i___0 := l_i___0 + 1
				end
				l_flags___0 := (l_flags___0).bit_or ((66))
				if (os_unix_inst.mch_isFullName (l_pat)).to_boolean then
					l_path := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" "))
				elseif (l_pat[0]).to_integer_32 = 46 then
					if (misc1_inst.vim_ispathsep ((l_pat[1]).to_integer_32)).to_boolean then
						l_path := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("."))
					elseif (l_pat[1]).to_integer_32 = 46 then
						if (misc1_inst.vim_ispathsep ((l_pat[2]).to_integer_32)).to_boolean then
							l_path := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("."))
						else
							l_path := misc1_inst.vim_getenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PATH")), l_mustfree)
						end
					else
						l_path := misc1_inst.vim_getenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PATH")), l_mustfree)
					end
				else
					l_path := misc1_inst.vim_getenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("PATH")), l_mustfree)
				end
				misc2_inst.ga_init2 (l_ga, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 10)
				l_s := l_path
				from
				until
					not (not js.loop_done and then ((l_s.item).to_integer_32 /= 0))
				loop
					if (l_s.item).to_integer_32 = 32 then
						l_s := l_s + 1
					end
					l_e := misc2_inst.vim_strchr (l_s, (':').code)
					if l_e.is_void then
						l_e := l_s + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
					end
					l_l := (l_e.distance (l_s)).to_natural_32
					if l_l > {NATURAL_32} 4_091 then
						js.break
					end
					if not js.loop_jumped then
						misc2_inst.vim_strncpy (l_buf___6.item, l_s, l_l)
						misc1_inst.add_pathsep (l_buf___6.item)
						l_l := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6.item))
						misc2_inst.vim_strncpy (l_buf___6.item + l_l.to_integer_32, l_pat, {NATURAL_32} 4_095 - l_l)
						l_ret := misc1_inst.expand_wildcards (1, l_buf___6, a_num_file, a_file, l_flags___0)
						if l_ret = 1 then
							if (misc2_inst.ga_grow (l_ga, a_num_file.item)) = 0 then
								misc1_inst.FreeWild (a_num_file.item, a_file.item)
							else
								l_i___0 := 0
								from
								until
									not (l_i___0 < a_num_file.item)
								loop
									l_s := a_file.item[l_i___0]
									if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))) > l_l then
										memmove (create {CE_POINTER [ANY]}.make_cast (l_s), create {CE_POINTER [ANY]}.make_cast ((l_s + l_l.to_integer_32)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_s + l_l.to_integer_32)))) + {NATURAL_32} 1).do_nothing
										l_tmp___6 := l_ga.item.ga_len
										l_ga.item.ga_len := (l_ga.item.ga_len) + 1
										create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.item.ga_data)[l_tmp___6] := l_s
									else
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s))
									end
									l_i___0 := l_i___0 + 1
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_file.item))
							end
						end
						if (l_e.item).to_integer_32 /= 0 then
							l_e := l_e + 1
						end
						l_s := l_e
					end
				end
				a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.item.ga_data)
				a_num_file.item := l_ga.item.ga_len
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6.item))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat))
				if (l_mustfree.item).to_boolean then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path))
				end
				Result := 1
			end
		end

	expand_showtail (a_xp: CE_POINTER [PD_EXPAND]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make
			create l_end.make

			if a_xp.item.xp_context /= 2 then
				if a_xp.item.xp_context /= 32 then
					if a_xp.item.xp_context /= 3 then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				l_end := misc1_inst.gettail (a_xp.item.xp_pattern)
				if l_end.is_equal (a_xp.item.xp_pattern) then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_s := a_xp.item.xp_pattern
				from
				until
					not (not js.loop_done and then ((l_s.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32))
				loop
					if (charset_inst.rem_backslash (l_s)).to_boolean then
						l_s := l_s + 1
					elseif not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("*?[")), (l_s.item).to_integer_32)).is_void then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_s := l_s + 1
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	finish_viminfo_history
		local
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_type: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_type := 0
			from
			until
				not (not js.loop_done and then (l_type < 5))
			loop
				if (history[l_type]).is_void then
					js.return
				end
				if not js.return_called then
					l_idx := hisidx[l_type] + viminfo_hisidx[l_type]
					if l_idx >= hislen then
						l_idx := l_idx - hislen
					elseif l_idx < 0 then
						l_idx := hislen - 1
					end
					if viminfo_add_at_front.to_boolean then
						hisidx[l_type] := l_idx
					else
						if hisidx[l_type] = -1 then
							hisidx[l_type] := hislen - 1
						end
						from
						until
							not (not js.loop_done and then (((history[l_type] + l_idx).item.hisstr).is_void))
						loop
							l_idx := l_idx + 1
							if l_idx = hislen then
								l_idx := 0
							end
							if l_idx = hisidx[l_type] then
								js.break
							end
						end
						if l_idx /= hisidx[l_type] then
							l_idx := l_idx - 1
							if l_idx < 0 then
								l_idx := hislen - 1
							end
						end
					end
					l_i___0 := 0
					from
					until
						not (l_i___0 < viminfo_hisidx[l_type])
					loop
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((history[l_type] + l_idx).item.hisstr));
						(history[l_type] + l_idx).item.hisstr := (viminfo_history[l_type])[l_i___0]
						l_idx := l_idx - 1
						if l_idx < 0 then
							l_idx := hislen - 1
						end
						l_i___0 := l_i___0 + 1
					end
					l_idx := l_idx + 1
					l_idx := l_idx \\ hislen
					l_i___0 := 0
					from
					until
						not (l_i___0 < viminfo_hisidx[l_type])
					loop
						l_tmp := l_idx
						l_idx := l_idx + 1
						hisnum[l_type] := (hisnum[l_type]) + 1;
						(history[l_type] + l_tmp).item.hisnum := hisnum[l_type]
						l_idx := l_idx \\ hislen
						l_i___0 := l_i___0 + 1
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (viminfo_history[l_type]))
					viminfo_history[l_type] := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
					l_type := l_type + 1
				end
			end
			if not js.return_called then
			end
		end

	get_ccline_ptr: CE_POINTER [PD_CMDLINE_INFO]
		local
			js: JUMP_STATE
		do
			if ((globals_inst.State).bit_and (8)) = 0 then
				Result := (create {CE_POINTER [PD_CMDLINE_INFO]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called and then (not (ccline.item.cmdbuff).is_void) then
				Result := ccline
				js.return
			end
			if not js.return_called and then (prev_ccline_used.to_boolean) then
				if not (prev_ccline.item.cmdbuff).is_void then
					Result := prev_ccline
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_CMDLINE_INFO]}.make_shared (default_pointer))
			end
		end

	get_cmdline_pos: INTEGER_32
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0 := (get_ccline_ptr)
			if l_p___0.is_void then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				Result := (l_p___0.item.cmdpos)
			end
		end

	get_cmdline_str: CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0 := (get_ccline_ptr)
			if l_p___0.is_void then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (misc2_inst.vim_strnsave (l_p___0.item.cmdbuff, l_p___0.item.cmdlen))
			end
		end

	get_cmdline_type: INTEGER_32
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0 := (get_ccline_ptr)
			if l_p___0.is_void then
				Result := (('%/0/').code)
				js.return
			end
			if not js.return_called and then (l_p___0.item.cmdfirstc = 0) then
				if (l_p___0.item.input_fn).to_boolean then
					l_tmp___0 := ('@').code
				else
					l_tmp___0 := ('-').code
				end
				Result := l_tmp___0
				js.return
			end
			if not js.return_called then
				Result := (l_p___0.item.cmdfirstc)
			end
		end

	get_history_entry (a_histype: INTEGER_32; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_idx: INTEGER_32
		do
			l_idx := a_idx
			l_idx := calc_hist_idx (a_histype, l_idx)
			if l_idx >= 0 then
				Result := ((history[a_histype] + l_idx).item.hisstr)
			else
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
			end
		end

	get_history_idx (a_histype: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if hislen = 0 then
				Result := (-1)
				js.return
			elseif a_histype < 0 then
				Result := (-1)
				js.return
			elseif a_histype >= 5 then
				Result := (-1)
				js.return
			elseif hisidx[a_histype] < 0 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				Result := ((history[a_histype] + hisidx[a_histype]).item.hisnum)
			end
		end

	get_histtype (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1))).to_integer_32
			if l_len = 0 then
				Result := (hist_char2type (ccline.item.cmdfirstc))
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (not js.loop_done and then (not (history_names[l_i___0]).is_void))
				loop
					if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), history_names[l_i___0], l_len.to_natural_32)) = 0 then
						Result := l_i___0
						js.return
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":=@>?/")), (a_name___1[0]).to_integer_32)).is_void then
					if (a_name___1[1]).to_integer_32 = 0 then
						Result := (hist_char2type ((a_name___1[0]).to_integer_32))
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	get_list_range (a_str___1: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num1: CE_POINTER [INTEGER_32]; a_num2: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_len: CE_ARRAY [INTEGER_32]
			l_first___0: INTEGER_32
			l_num: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_len.make (<<1>>)
			create l_num.make (<<1>>)

			l_first___0 := 0
			a_str___1.item := charset_inst.skipwhite (a_str___1.item)
			if ((a_str___1.item).item).to_integer_32 = 45 then
				charset_inst.vim_str2nr (a_str___1.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_len, 0, 0, l_num, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer))
				a_str___1.item := a_str___1.item + (l_len.item)
				a_num1.item := (l_num.item).to_integer_32
				l_first___0 := 1
			elseif (charset_inst.vim_isdigit (((a_str___1.item).item).to_integer_32)).to_boolean then
				charset_inst.vim_str2nr (a_str___1.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_len, 0, 0, l_num, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer))
				a_str___1.item := a_str___1.item + (l_len.item)
				a_num1.item := (l_num.item).to_integer_32
				l_first___0 := 1
			end
			a_str___1.item := charset_inst.skipwhite (a_str___1.item)
			if ((a_str___1.item).item).to_integer_32 = 44 then
				a_str___1.item := charset_inst.skipwhite (a_str___1.item + 1)
				charset_inst.vim_str2nr (a_str___1.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_len, 0, 0, l_num, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer))
				if l_len.item > 0 then
					a_num2.item := (l_num.item).to_integer_32
					a_str___1.item := charset_inst.skipwhite (a_str___1.item + l_len.item)
				elseif not l_first___0.to_boolean then
					Result := 0
					js.return
				end
			elseif l_first___0.to_boolean then
				a_num2.item := a_num1.item
			end
			if not js.return_called then
				Result := 1
			end
		end

	getcmdline (a_firstc: INTEGER_32; a_count___2: INTEGER_32; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_firstc: INTEGER_32
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_gotesc: INTEGER_32
			l_do_abbr: INTEGER_32
			l_lookfor: CE_POINTER [NATURAL_8]
			l_hiscnt: INTEGER_32
			l_histype: INTEGER_32
			l_old_cursor: PD_POS_T
			l_old_curswant: INTEGER_32
			l_old_leftcol___0: INTEGER_32
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
			l_old_botline: INTEGER_32
			l_did_incsearch: INTEGER_32
			l_incsearch_postponed: INTEGER_32
			l_did_wild_list: INTEGER_32
			l_wim_index: INTEGER_32
			l_res: INTEGER_32
			l_save_msg_scroll: INTEGER_32
			l_save_State: INTEGER_32
			l_some_key_typed: INTEGER_32
			l_ignore_drag_release: INTEGER_32
			l_break_ctrl_c: INTEGER_32
			l_xpc: CE_ARRAY [PD_EXPAND]
			l_b_im_ptr: CE_POINTER [INTEGER_32]
			l_save_ccline: CE_ARRAY [PD_CMDLINE_INFO]
			l_tmp: INTEGER_32
			l_skt: INTEGER_32
			l_old_RedrawingDisabled: INTEGER_32
			l_found: INTEGER_32
			l_upseg: CE_ARRAY [NATURAL_8]
			l_found___0: INTEGER_32
			l_found___1: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_p_wmnu_save: INTEGER_32
			l_tmp___12: INTEGER_32
			l_p___1: CE_POINTER [NATURAL_8]
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___30: INTEGER_32
			l_button: INTEGER_32
			l_is_click: CE_ARRAY [INTEGER_32]
			l_is_drag: CE_ARRAY [INTEGER_32]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___47: INTEGER_32
			l_p___2: CE_POINTER [NATURAL_8]
			l_len___0: INTEGER_32
			l_old_firstc: INTEGER_32
			l_tmp___56: INTEGER_32
			l_tmp___58: CE_POINTER [NATURAL_8]
			l_end_pos: PD_POS_T
			l_tm: CE_ARRAY [SD_TIMEVAL]
			l_save_pos: PD_POS_T
			l_tmp___61: INTEGER_32
			l_p___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lookfor.make
			create l_old_cursor.make
			create l_xpc.make (<<1>>)
			create l_b_im_ptr.make
			create l_save_ccline.make (<<1>>)
			create l_upseg.make (<<5>>)
			create l_p___0.make
			create l_p___1.make
			create l_is_click.make (<<1>>)
			create l_is_drag.make (<<1>>)
			create l_tmp___44.make
			create l_p___2.make
			create l_tmp___58.make
			create l_end_pos.make
			create l_tm.make (<<1>>)
			create l_save_pos.make
			create l_p___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_firstc := a_firstc
					l_gotesc := 0
					l_lookfor := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_did_incsearch := 0
					l_incsearch_postponed := 0
					l_did_wild_list := 0
					l_wim_index := 0
					l_save_msg_scroll := globals_inst.msg_scroll
					l_save_State := globals_inst.State
					l_some_key_typed := 0
					l_ignore_drag_release := 1
					l_break_ctrl_c := 0
					l_b_im_ptr := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
					if l_firstc = -1 then
						l_firstc := ('%/0/').code
						l_break_ctrl_c := 1
					end
					ccline.item.overstrike := 0
					l_old_cursor := (globals_inst.curwin.item.w_cursor).twin
					l_old_curswant := globals_inst.curwin.item.w_curswant
					l_old_leftcol___0 := globals_inst.curwin.item.w_leftcol
					l_old_topline___0 := globals_inst.curwin.item.w_topline
					l_old_topfill___0 := globals_inst.curwin.item.w_topfill
					l_old_botline := globals_inst.curwin.item.w_botline
					if l_firstc = 64 then
						ccline.item.cmdfirstc := 0
					else
						ccline.item.cmdfirstc := l_firstc
					end
					if l_firstc > 0 then
						ccline.item.cmdindent := a_indent
					else
						ccline.item.cmdindent := 0
					end
					if globals_inst.exmode_active.to_boolean then
						l_tmp := 250
					else
						l_tmp := a_indent + 1
					end
					alloc_cmdbuff (l_tmp)
					if (ccline.item.cmdbuff).is_void then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 301 -- skip if block
					end
				when 1 then -- if:
						ccline.item.cmdpos := 0
						ccline.item.cmdlen := ccline.item.cmdpos
						ccline.item.cmdbuff[0] := (('%/0/').code).to_natural_8
						if l_firstc <= 0 then
							misc2_inst.copy_spaces (ccline.item.cmdbuff, a_indent.to_natural_32)
							ccline.item.cmdbuff[a_indent] := (('%/0/').code).to_natural_8
							ccline.item.cmdpos := a_indent
							ccline.item.cmdspos := a_indent
							ccline.item.cmdlen := a_indent
						end
						ExpandInit (l_xpc)
						ccline.item.xpc := l_xpc
						globals_inst.redir_off := 1
						if not globals_inst.cmd_silent.to_boolean then
							l_i___0 := globals_inst.msg_scrolled
							globals_inst.msg_scrolled := 0
							gotocmdline (1)
							globals_inst.msg_scrolled := globals_inst.msg_scrolled + l_i___0
							redrawcmdprompt
							set_cmdspos
						end
						l_xpc.item.xp_context := 0
						l_xpc.item.xp_backslash := 0
						l_xpc.item.xp_shell := 0
						if (ccline.item.input_fn).to_boolean then
							l_xpc.item.xp_context := ccline.item.xp_context
							l_xpc.item.xp_pattern := ccline.item.cmdbuff
							l_xpc.item.xp_arg := ccline.item.xp_arg
						end
						globals_inst.msg_scroll := 0
						globals_inst.State := 8
						if l_firstc /= 47 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if l_firstc /= 63 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if l_firstc /= 64 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						if globals_inst.curbuf.item.b_p_imsearch = -1 then
							l_b_im_ptr := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_iminsert"))
						else
							l_b_im_ptr := create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_imsearch"))
						end
						if l_b_im_ptr.item = 1 then
							globals_inst.State := (globals_inst.State).bit_or ((32))
						end
						mbyte_inst.im_set_active ((l_b_im_ptr.item = 2).to_integer)
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if (option_inst.p_imcmdline.item).to_boolean then
							mbyte_inst.im_set_active (1)
						end
				when 11 then -- if done | if done
						term_inst.setmouse
						ui_inst.ui_cursor_shape
						term_inst.settmode (2)
						init_history
						l_hiscnt := hislen
						l_histype := hist_char2type (l_firstc)
						digraph_inst.do_digraph (-1).do_nothing
				when 12 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 291 -- skip loop
						end
				when 13 then -- loop body:
						globals_inst.redir_off := 1
						globals_inst.dont_scroll := 0
						globals_inst.quit_more := 0
						cursorcmd
						from
						until
							js.loop_done
						loop
							l_c := getchar_inst.safe_vgetc
							if l_c /= -(253 + ((53).bit_shift_left (8))) then
								js.break
							end
						end
						if globals_inst.KeyTyped.to_boolean then
							l_some_key_typed := 1
						end
						if l_c /= 3 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if l_c /= globals_inst.intr_char then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						if l_firstc /= 64 then
							if not l_break_ctrl_c.to_boolean then
								if not globals_inst.global_busy.to_boolean then
									globals_inst.got_int := 0
								end
							end
						end
				when 18 then -- if done
						if not l_lookfor.is_void then
							if l_c /= -(253 + ((5).bit_shift_left (8))) then
								if l_c /= -(253 + ((4).bit_shift_left (8))) then
									if l_c /= -(107 + ((100).bit_shift_left (8))) then
										if l_c /= -(107 + ((117).bit_shift_left (8))) then
											if l_c /= -(107 + ((78).bit_shift_left (8))) then
												if l_c /= -(107 + ((80).bit_shift_left (8))) then
													if l_c /= -(75 + ((53).bit_shift_left (8))) then
														if l_c /= -(75 + ((51).bit_shift_left (8))) then
															if l_c /= -(107 + ((108).bit_shift_left (8))) then
																if l_c /= -(107 + ((114).bit_shift_left (8))) then
																	if l_xpc.item.xp_numfiles > 0 then
																		misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_lookfor))
																		l_lookfor := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
																	elseif l_c /= 16 then
																		if l_c /= 14 then
																			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_lookfor))
																			l_lookfor := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
																		end
																	end
																end
															end
														end
													end
												end
											end
										end
									end
								end
							end
						end
						if l_c.to_integer_32 /= option_inst.p_wc.item then
							if l_c = -(107 + ((66).bit_shift_left (8))) then
								if l_xpc.item.xp_numfiles > 0 then
									l_c := 16
								end
							end
						end
						if l_did_wild_list.to_boolean then
							if (option_inst.p_wmnu.item).to_boolean then
								if l_c = -(107 + ((108).bit_shift_left (8))) then
									l_c := 16
								elseif l_c = -(107 + ((114).bit_shift_left (8))) then
									l_c := 14
								end
							end
						end
						if l_xpc.item.xp_context = 21 then
							if (option_inst.p_wmnu.item).to_boolean then
								if ccline.item.cmdpos > 1 then
									if (ccline.item.cmdbuff[(ccline.item.cmdpos - 1)]).to_integer_32 = 46 then
										if (ccline.item.cmdbuff[(ccline.item.cmdpos - 2)]).to_integer_32 /= 92 then
											if l_c = 10 then
												l_c := -(107 + ((100).bit_shift_left (8)))
											elseif l_c = 13 then
												l_c := -(107 + ((100).bit_shift_left (8)))
											elseif l_c = -(75 + ((65).bit_shift_left (8))) then
												l_c := -(107 + ((100).bit_shift_left (8)))
											end
										end
									end
								end
							end
						end
						if l_xpc.item.xp_numfiles = -1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 19 then -- if:
						if l_c.to_integer_32 /= option_inst.p_wc.item then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if not globals_inst.KeyTyped.to_boolean then
							l_pos := -1 + 22 -- goto _L___1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L___1:
						if l_c.to_integer_32 /= option_inst.p_wcm.item then
							if l_c /= 14 then
								if l_c /= 16 then
									if l_c /= 1 then
										if l_c /= 12 then
											ExpandOne (l_xpc, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 1).do_nothing
											l_did_wild_list := 0
											if not (option_inst.p_wmnu.item).to_boolean then
												l_xpc.item.xp_context := 0
											elseif l_c /= -(107 + ((117).bit_shift_left (8))) then
												if l_c /= -(107 + ((100).bit_shift_left (8))) then
													l_xpc.item.xp_context := 0
												end
											end
											l_wim_index := 0
											if (option_inst.p_wmnu.item).to_boolean then
												if globals_inst.wild_menu_showing /= 0 then
													l_skt := globals_inst.KeyTyped
													l_old_RedrawingDisabled := globals_inst.RedrawingDisabled
													if (ccline.item.input_fn).to_boolean then
														globals_inst.RedrawingDisabled := 0
													end
													if globals_inst.wild_menu_showing = 2 then
														globals_inst.cmdline_row := globals_inst.cmdline_row - 1
														redrawcmd
													elseif globals_inst.save_p_ls /= -1 then
														option_inst.p_ls.item := globals_inst.save_p_ls.to_integer_32
														option_inst.p_wmh.item := globals_inst.save_p_wmh.to_integer_32
														window_inst.last_status (0)
														save_cmdline (l_save_ccline)
														screen_inst.update_screen (10)
														restore_cmdline (l_save_ccline)
														redrawcmd
														globals_inst.save_p_ls := -1
													else
														screen_inst.win_redraw_last_status (globals_inst.topframe)
														screen_inst.redraw_statuslines
													end
													globals_inst.KeyTyped := l_skt
													globals_inst.wild_menu_showing := 0
													if (ccline.item.input_fn).to_boolean then
														globals_inst.RedrawingDisabled := l_old_RedrawingDisabled
													end
												end
											end
										end
									end
								end
							end
						end
				when 23 then -- if done
						if l_xpc.item.xp_context /= 21 then
							l_pos := -1 + 29 -- skip if block
						end
				when 24 then -- if:
						if not ((option_inst.p_wmnu.item).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 25 then -- if:
						if l_c /= -(107 + ((100).bit_shift_left (8))) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if ccline.item.cmdpos > 0 then
							if (ccline.item.cmdbuff[(ccline.item.cmdpos - 1)]).to_integer_32 = 46 then
								l_c := (option_inst.p_wc.item).to_integer_32
							else
								l_pos := -1 + 28 -- goto _L___3
							end
						else
							l_pos := -1 + 28 -- goto _L___3
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L___3:
						if l_c = -(107 + ((117).bit_shift_left (8))) then
							l_found := 0
							l_j := (l_xpc.item.xp_pattern).distance ((ccline.item.cmdbuff))
							l_i___0 := 0
							from
							until
								js.loop_done
							loop
								l_j := l_j - 1
								if not (l_j > 0) then
									js.break
								end
								if not js.loop_jumped and then ((ccline.item.cmdbuff[l_j]).to_integer_32 = 32) then
									if (ccline.item.cmdbuff[(l_j - 1)]).to_integer_32 /= 92 then
										l_i___0 := l_j + 1
										js.break
									end
								end
								if not js.loop_jumped and then ((ccline.item.cmdbuff[l_j]).to_integer_32 = 46) then
									if (ccline.item.cmdbuff[(l_j - 1)]).to_integer_32 /= 92 then
										if l_found.to_boolean then
											l_i___0 := l_j + 1
											js.break
										else
											l_found := 1
										end
									end
								end
							end
							if l_i___0 > 0 then
								cmdline_del (l_i___0)
							end
							l_c := (option_inst.p_wc.item).to_integer_32
							l_xpc.item.xp_context := 0
						end
				when 29 then -- if done | if done
						if l_xpc.item.xp_context /= 2 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 36 -- goto _L___8
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 32 then -- else:
						if l_xpc.item.xp_context /= 3 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___8
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 35 then -- else:
						if l_xpc.item.xp_context /= 32 then
							l_pos := -1 + 44 -- skip if block
						end
				when 36 then -- if: | _L___8:
						if not ((option_inst.p_wmnu.item).to_boolean) then
							l_pos := -1 + 44 -- skip if block
						end
				when 37 then -- if:
						l_upseg[0] := (('/').code).to_natural_8
						l_upseg[1] := (('.').code).to_natural_8
						l_upseg[2] := (('.').code).to_natural_8
						l_upseg[3] := (('/').code).to_natural_8
						l_upseg[4] := (('%/0/').code).to_natural_8
						if l_c /= -(107 + ((100).bit_shift_left (8))) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if ccline.item.cmdpos > 0 then
							if (ccline.item.cmdbuff[(ccline.item.cmdpos - 1)]).to_integer_32 = 47 then
								if ccline.item.cmdpos < 3 then
									l_c := (option_inst.p_wc.item).to_integer_32
								elseif (ccline.item.cmdbuff[(ccline.item.cmdpos - 2)]).to_integer_32 /= 46 then
									l_c := (option_inst.p_wc.item).to_integer_32
								elseif (ccline.item.cmdbuff[(ccline.item.cmdpos - 3)]).to_integer_32 /= 46 then
									l_c := (option_inst.p_wc.item).to_integer_32
								else
									l_pos := -1 + 40 -- goto _L___7
								end
							else
								l_pos := -1 + 40 -- goto _L___7
							end
						else
							l_pos := -1 + 40 -- goto _L___7
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 40 then -- else: | _L___7:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_xpc.item.xp_pattern), create {CE_POINTER [INTEGER_8]}.make_cast ((l_upseg + 1)), (3).to_natural_32)) /= 0 then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if l_c = -(107 + ((100).bit_shift_left (8))) then
							l_found___0 := 0
							l_j := ccline.item.cmdpos
							l_i___0 := (l_xpc.item.xp_pattern).distance ((ccline.item.cmdbuff))
							from
							until
								js.loop_done
							loop
								l_j := l_j - 1
								if not (l_j > l_i___0) then
									js.break
								end
								if not js.loop_jumped then
									if globals_inst.has_mbyte.to_boolean then
										l_j := l_j - (globals_inst.mb_head_off.integer_32_item ([ccline.item.cmdbuff, ccline.item.cmdbuff + l_j]))
									end
									if (misc1_inst.vim_ispathsep ((ccline.item.cmdbuff[l_j]).to_integer_32)).to_boolean then
										l_found___0 := 1
										js.break
									end
								end
							end
							if l_found___0.to_boolean then
								if (ccline.item.cmdbuff[(l_j - 1)]).to_integer_32 = 46 then
									if (ccline.item.cmdbuff[(l_j - 2)]).to_integer_32 = 46 then
										if (misc1_inst.vim_ispathsep ((ccline.item.cmdbuff[(l_j - 3)]).to_integer_32)).to_boolean then
											cmdline_del (l_j - 2)
											l_c := (option_inst.p_wc.item).to_integer_32
										elseif l_j = l_i___0 + 2 then
											cmdline_del (l_j - 2)
											l_c := (option_inst.p_wc.item).to_integer_32
										end
									end
								end
							end
						else
							l_pos := -1 + 43 -- goto _L___4
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else: | _L___4:
						if l_c = -(107 + ((117).bit_shift_left (8))) then
							l_found___1 := 0
							l_j := ccline.item.cmdpos - 1
							l_i___0 := (l_xpc.item.xp_pattern).distance ((ccline.item.cmdbuff))
							from
							until
								js.loop_done
							loop
								l_j := l_j - 1
								if not (l_j > l_i___0) then
									js.break
								end
								if not js.loop_jumped then
									if globals_inst.has_mbyte.to_boolean then
										l_j := l_j - (globals_inst.mb_head_off.integer_32_item ([ccline.item.cmdbuff, ccline.item.cmdbuff + l_j]))
									end
									if (misc1_inst.vim_ispathsep ((ccline.item.cmdbuff[l_j]).to_integer_32)).to_boolean then
										if l_found___1.to_boolean then
											l_i___0 := l_j + 1
											js.break
										else
											l_found___1 := 1
										end
									end
								end
							end
							if not l_found___1.to_boolean then
								l_j := l_i___0
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((ccline.item.cmdbuff + l_j)), create {CE_POINTER [INTEGER_8]}.make_cast (l_upseg), (4).to_natural_32)) = 0 then
								l_j := l_j + (4)
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((ccline.item.cmdbuff + l_j)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_upseg + 1)), (3).to_natural_32)) = 0 then
								if l_j = l_i___0 then
									l_j := l_j + (3)
								else
									l_j := 0
								end
							else
								l_j := 0
							end
							if l_j > 0 then
								cmdline_del (l_j)
								put_on_cmdline (l_upseg + 1, 3, 0).do_nothing
							elseif ccline.item.cmdpos > l_i___0 then
								cmdline_del (l_i___0)
							end
							l_c := (option_inst.p_wc.item).to_integer_32
						end
				when 44 then -- if done | if done | if done | if done | if done
						if l_c /= 28 then
							l_pos := -1 + 53 -- skip if block
						end
				when 45 then -- if:
						globals_inst.no_mapping := globals_inst.no_mapping + 1
						globals_inst.allow_keys := globals_inst.allow_keys + 1
						l_c := getchar_inst.plain_vgetc
						globals_inst.no_mapping := globals_inst.no_mapping - 1
						globals_inst.allow_keys := globals_inst.allow_keys - 1
						if l_c = 14 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if l_c /= 7 then
							if l_c /= 101 then
								getchar_inst.vungetc (l_c)
								l_c := 28
							elseif ccline.item.cmdfirstc = 61 then
								getchar_inst.vungetc (l_c)
								l_c := 28
							else
								l_pos := -1 + 48 -- goto _L___10
							end
						else
							l_pos := -1 + 48 -- goto _L___10
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 48 then -- else: | _L___10:
						if l_c /= 101 then
							l_pos := -1 + 52 -- skip if block
						end
				when 49 then -- if:
						l_p___0 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						if ccline.item.cmdpos = ccline.item.cmdlen then
							new_cmdpos := 99_999
						else
							new_cmdpos := ccline.item.cmdpos
						end
						save_cmdline (l_save_ccline)
						l_c := ops_inst.get_expr_register
						restore_cmdline (l_save_ccline)
						if l_c = 61 then
							save_cmdline (l_save_ccline)
							globals_inst.textlock := globals_inst.textlock + 1
							l_p___0 := ops_inst.get_expr_line
							globals_inst.textlock := globals_inst.textlock - 1
							restore_cmdline (l_save_ccline)
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
							if not l_p___0.is_void then
								if (realloc_cmdbuff (l_len + 1)) = 1 then
									ccline.item.cmdlen := l_len
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (ccline.item.cmdbuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
									if new_cmdpos > ccline.item.cmdlen then
										ccline.item.cmdpos := ccline.item.cmdlen
									else
										ccline.item.cmdpos := new_cmdpos
									end
									globals_inst.KeyTyped := 0
									redrawcmd
									l_pos := -1 + 283 -- goto cmdline_changed
								end
							end
						end
				when 50 then
						misc1_inst.beep_flush
						l_c := ('%/27/').code
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 52 then -- else:
						if l_c = 7 then
							if (option_inst.p_im.item).to_boolean then
								if globals_inst.restart_edit = 0 then
									globals_inst.restart_edit := ('a').code
								end
							end
						end
						l_gotesc := 1
						l_pos := -1 + 291 -- goto returncmd
				when 53 then -- if done | if done
						if l_c = globals_inst.cedit_key then
							l_c := ex_window
							l_some_key_typed := 1
						elseif l_c = -(253 + ((84).bit_shift_left (8))) then
							l_c := ex_window
							l_some_key_typed := 1
						else
							l_c := digraph_inst.do_digraph (l_c)
						end
						if l_c /= 10 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_pos := -1 + 67 -- goto _L___16
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 56 then -- else:
						if l_c /= 13 then
							l_pos := -1 + 59 -- skip if block
						end
				when 57 then -- if:
						l_pos := -1 + 67 -- goto _L___16
				when 58 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 59 then -- else:
						if l_c /= -(75 + ((65).bit_shift_left (8))) then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						l_pos := -1 + 67 -- goto _L___16
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 62 then -- else:
						if l_c /= 27 then
							l_pos := -1 + 72 -- skip if block
						end
				when 63 then -- if:
						if globals_inst.KeyTyped.to_boolean then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						l_pos := -1 + 67 -- goto _L___16
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 66 then -- else:
						if (misc2_inst.vim_strchr (option_inst.p_cpo.item, ('x').code)).is_void then
							l_pos := -1 + 72 -- skip if block
						end
				when 67 then -- if: | _L___16:
						if not (globals_inst.exmode_active.to_boolean) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if l_c /= 27 then
							if ccline.item.cmdpos = ccline.item.cmdlen then
								if ccline.item.cmdpos > 0 then
									if (ccline.item.cmdbuff[(ccline.item.cmdpos - 1)]).to_integer_32 = 92 then
										if l_c = -(75 + ((65).bit_shift_left (8))) then
											l_c := ('%N').code
										end
									else
										l_pos := -1 + 70 -- goto _L___14
									end
								else
									l_pos := -1 + 70 -- goto _L___14
								end
							else
								l_pos := -1 + 70 -- goto _L___14
							end
						else
							l_pos := -1 + 70 -- goto _L___14
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 70 then -- else: | _L___14:
						l_gotesc := 0
						if (ccheck_abbr (l_c + 256)).to_boolean then
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 71 then
						if not globals_inst.cmd_silent.to_boolean then
							screen_inst.windgoto (globals_inst.msg_row, 0)
							term_inst.out_flush
						end
						js.break
				when 72 then -- if done | if done | if done | if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 273 -- skip if block
						end
				when 73 then -- if:
						if l_c.to_integer_32 /= option_inst.p_wc.item then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						if not l_gotesc.to_boolean then
							if globals_inst.KeyTyped.to_boolean then
								l_pos := -1 + 77 -- goto _L___19
							else
								l_pos := -1 + 76 -- goto _L___21
							end
						else
							l_pos := -1 + 76 -- goto _L___21
						end
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 76 then -- else: | _L___21:
						if l_c.to_integer_32 /= option_inst.p_wcm.item then
							l_pos := -1 + 98 -- skip if block
						end
				when 77 then -- if: | _L___19:
						if not (l_xpc.item.xp_numfiles > 0) then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if l_xpc.item.xp_numfiles > 1 then
							if not l_did_wild_list.to_boolean then
								if (((globals_inst.wim_flags[l_wim_index]).to_integer_32).bit_and (4)).to_boolean then
									showmatches (l_xpc, 0).do_nothing
									redrawcmd
									l_did_wild_list := 1
								end
							end
						end
						if (((globals_inst.wim_flags[l_wim_index]).to_integer_32).bit_and (2)).to_boolean then
							l_res := nextwild (l_xpc, 7, 8)
						elseif (((globals_inst.wim_flags[l_wim_index]).to_integer_32).bit_and (1)).to_boolean then
							l_res := nextwild (l_xpc, 4, 8)
						else
							l_res := 1
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 80 then -- else:
						l_wim_index := 0
						l_j := ccline.item.cmdpos
						if (((globals_inst.wim_flags[0]).to_integer_32).bit_and (2)).to_boolean then
							l_res := nextwild (l_xpc, 7, 8)
						else
							l_res := nextwild (l_xpc, 3, 8)
						end
						if globals_inst.got_int.to_boolean then
							getchar_inst.vpeekc.do_nothing
							globals_inst.got_int := 0
							ExpandOne (l_xpc, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 1).do_nothing
							l_xpc.item.xp_context := 0
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 81 then
						if l_res /= 1 then
							l_pos := -1 + 96 -- skip if block
						end
				when 82 then -- if:
						if not (l_xpc.item.xp_numfiles > 1) then
							l_pos := -1 + 94 -- skip if block
						end
				when 83 then -- if:
						if (globals_inst.wim_flags[0]).to_integer_32 = 2 then
							if ccline.item.cmdpos = l_j then
								l_wim_index := 1
							end
						end
						if not ((((globals_inst.wim_flags[l_wim_index]).to_integer_32).bit_and (4)).to_boolean) then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						l_pos := -1 + 88 -- goto _L___17
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 93
				when 86 then -- else:
						if not ((option_inst.p_wmnu.item).to_boolean) then
							l_pos := -1 + 92 -- skip if block
						end
				when 87 then -- if:
						if (((globals_inst.wim_flags[l_wim_index]).to_integer_32).bit_and (1)) = 0 then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if: | _L___17:
						if not (((globals_inst.wim_flags[0]).to_integer_32).bit_and (2)).to_boolean then
							l_p_wmnu_save := option_inst.p_wmnu.item
							option_inst.p_wmnu.item := 0
							nextwild (l_xpc, 5, 0).do_nothing
							option_inst.p_wmnu.item := l_p_wmnu_save
						end
						if (option_inst.p_wmnu.item).to_boolean then
							if (((globals_inst.wim_flags[l_wim_index]).to_integer_32).bit_and (4)) = 0 then
								l_tmp___12 := 1
							else
								l_tmp___12 := 0
							end
						else
							l_tmp___12 := 0
						end
						showmatches (l_xpc, l_tmp___12).do_nothing
						redrawcmd
						l_did_wild_list := 1
						if (((globals_inst.wim_flags[l_wim_index]).to_integer_32).bit_and (2)).to_boolean then
							nextwild (l_xpc, 7, 8).do_nothing
						elseif (((globals_inst.wim_flags[l_wim_index]).to_integer_32).bit_and (1)).to_boolean then
							nextwild (l_xpc, 4, 8).do_nothing
						end
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 90 then -- else:
						misc1_inst.vim_beep
				when 91 then -- if done | if block done, skip else block:
						l_pos := -1 + 93
				when 92 then -- else:
						misc1_inst.vim_beep
				when 93 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 95
				when 94 then -- else:
						l_pos := -1 + 96 -- goto _L___18
				when 95 then -- if done | if block done, skip else block:
						l_pos := -1 + 97
				when 96 then -- else: | _L___18:
						if l_xpc.item.xp_numfiles = -1 then
							l_xpc.item.xp_context := 0
						end
				when 97 then -- if done
						if l_wim_index < 3 then
							l_wim_index := l_wim_index + 1
						end
						if l_c = 27 then
							l_gotesc := 1
						end
						if l_res = 1 then
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 98 then -- if done
						l_gotesc := 0
						if l_c = -(107 + ((66).bit_shift_left (8))) then
							if globals_inst.KeyTyped.to_boolean then
								if (nextwild (l_xpc, 3, 0)) = 1 then
									if (nextwild (l_xpc, 5, 0)) = 1 then
										if (nextwild (l_xpc, 5, 0)) = 1 then
											l_pos := -1 + 283 -- goto cmdline_changed
										end
									end
								end
							end
						end
				when 99 then
						if l_c = 0 then
							l_c := ('%N').code
						elseif l_c = -(255 + ((88).bit_shift_left (8))) then
							l_c := ('%N').code
						end
						l_do_abbr := 1
						inspect l_c -- switch 1 head
						when -25195 then l_pos := -1 + 100 -- -(107 + ((98).bit_shift_left (8)))
						when 8 then l_pos := -1 + 100
						when -17515 then l_pos := -1 + 100 -- -(107 + ((68).bit_shift_left (8)))
						when -20733 then l_pos := -1 + 100 -- -(253 + ((80).bit_shift_left (8)))
						when 23 then l_pos := -1 + 100
						when -18795 then l_pos := -1 + 110 -- -(107 + ((73).bit_shift_left (8)))
						when -20477 then l_pos := -1 + 110 -- -(253 + ((79).bit_shift_left (8)))
						when 30 then l_pos := -1 + 111
						when 21 then l_pos := -1 + 112
						when 25 then l_pos := -1 + 113
						when 27 then l_pos := -1 + 115
						when 3 then l_pos := -1 + 115
						when 18 then l_pos := -1 + 117
						when 4 then l_pos := -1 + 121
						when -29291 then l_pos := -1 + 123 -- -(107 + ((114).bit_shift_left (8)))
						when -26917 then l_pos := -1 + 123 -- -(37 + ((105).bit_shift_left (8)))
						when -22269 then l_pos := -1 + 123 -- -(253 + ((86).bit_shift_left (8)))
						when -27755 then l_pos := -1 + 138 -- -(107 + ((108).bit_shift_left (8)))
						when -13347 then l_pos := -1 + 138 -- -(35 + ((52).bit_shift_left (8)))
						when -22013 then l_pos := -1 + 138 -- -(253 + ((85).bit_shift_left (8)))
						when -13821 then l_pos := -1 + 156 -- -(253 + ((53).bit_shift_left (8)))
						when -12541 then l_pos := -1 + 157 -- -(253 + ((48).bit_shift_left (8)))
						when -12797 then l_pos := -1 + 157 -- -(253 + ((49).bit_shift_left (8)))
						when -12285 then l_pos := -1 + 158 -- -(253 + ((47).bit_shift_left (8)))
						when -24573 then l_pos := -1 + 161 -- -(253 + ((95).bit_shift_left (8)))
						when -11773 then l_pos := -1 + 162 -- -(253 + ((45).bit_shift_left (8)))
						when -12029 then l_pos := -1 + 162 -- -(253 + ((46).bit_shift_left (8)))
						when -13309 then l_pos := -1 + 162 -- -(253 + ((51).bit_shift_left (8)))
						when -13565 then l_pos := -1 + 162 -- -(253 + ((52).bit_shift_left (8)))
						when -11517 then l_pos := -1 + 163 -- -(253 + ((44).bit_shift_left (8)))
						when -13053 then l_pos := -1 + 163 -- -(253 + ((50).bit_shift_left (8)))
						when -19453 then l_pos := -1 + 167 -- -(253 + ((75).bit_shift_left (8)))
						when -19709 then l_pos := -1 + 167 -- -(253 + ((76).bit_shift_left (8)))
						when -19965 then l_pos := -1 + 167 -- -(253 + ((77).bit_shift_left (8)))
						when -20221 then l_pos := -1 + 167 -- -(253 + ((78).bit_shift_left (8)))
						when -23037 then l_pos := -1 + 167 -- -(253 + ((89).bit_shift_left (8)))
						when -23293 then l_pos := -1 + 167 -- -(253 + ((90).bit_shift_left (8)))
						when -23549 then l_pos := -1 + 167 -- -(253 + ((91).bit_shift_left (8)))
						when -23805 then l_pos := -1 + 167 -- -(253 + ((92).bit_shift_left (8)))
						when -24061 then l_pos := -1 + 167 -- -(253 + ((93).bit_shift_left (8)))
						when -24317 then l_pos := -1 + 167 -- -(253 + ((94).bit_shift_left (8)))
						when -17917 then l_pos := -1 + 168 -- -(253 + ((69).bit_shift_left (8)))
						when -18173 then l_pos := -1 + 168 -- -(253 + ((70).bit_shift_left (8)))
						when -22777 then l_pos := -1 + 169 -- -(249 + ((88).bit_shift_left (8)))
						when -22776 then l_pos := -1 + 170 -- -(248 + ((88).bit_shift_left (8)))
						when -22768 then l_pos := -1 + 171 -- -(240 + ((88).bit_shift_left (8)))
						when -22767 then l_pos := -1 + 171 -- -(239 + ((88).bit_shift_left (8)))
						when -22773 then l_pos := -1 + 172 -- -(245 + ((88).bit_shift_left (8)))
						when 2 then l_pos := -1 + 173
						when -26731 then l_pos := -1 + 173 -- -(107 + ((104).bit_shift_left (8)))
						when -12619 then l_pos := -1 + 173 -- -(75 + ((49).bit_shift_left (8)))
						when -12835 then l_pos := -1 + 173 -- -(35 + ((50).bit_shift_left (8)))
						when -22525 then l_pos := -1 + 173 -- -(253 + ((87).bit_shift_left (8)))
						when 5 then l_pos := -1 + 174
						when -14144 then l_pos := -1 + 174 -- -(64 + ((55).bit_shift_left (8)))
						when -13387 then l_pos := -1 + 174 -- -(75 + ((52).bit_shift_left (8)))
						when -14122 then l_pos := -1 + 174 -- -(42 + ((55).bit_shift_left (8)))
						when -22781 then l_pos := -1 + 174 -- -(253 + ((88).bit_shift_left (8)))
						when 1 then l_pos := -1 + 175
						when 12 then l_pos := -1 + 178
						when 14 then l_pos := -1 + 193
						when 16 then l_pos := -1 + 193
						when -30059 then l_pos := -1 + 196 -- -(107 + ((117).bit_shift_left (8)))
						when -25707 then l_pos := -1 + 196 -- -(107 + ((100).bit_shift_left (8)))
						when -1277 then l_pos := -1 + 196 -- -(253 + ((4).bit_shift_left (8)))
						when -1533 then l_pos := -1 + 196 -- -(253 + ((5).bit_shift_left (8)))
						when -20587 then l_pos := -1 + 196 -- -(107 + ((80).bit_shift_left (8)))
						when -13131 then l_pos := -1 + 196 -- -(75 + ((51).bit_shift_left (8)))
						when -20075 then l_pos := -1 + 196 -- -(107 + ((78).bit_shift_left (8)))
						when -13643 then l_pos := -1 + 196 -- -(75 + ((53).bit_shift_left (8)))
						when 22 then l_pos := -1 + 268
						when 17 then l_pos := -1 + 268
						when 11 then l_pos := -1 + 269
						else l_pos := -1 + 271
						end
				when 100 then -- switch 1, case -(107 + (98 << 8)) | switch 1, case 8 | switch 1, case -(107 + (68 << 8)) | switch 1, case -(253 + (80 << 8)) | switch 1, case 23
						if l_c = -(253 + ((80).bit_shift_left (8))) then
							l_c := -(107 + ((68).bit_shift_left (8)))
						end
						if l_c = -(107 + ((68).bit_shift_left (8))) then
							if ccline.item.cmdpos /= ccline.item.cmdlen then
								ccline.item.cmdpos := (ccline.item.cmdpos) + 1
							end
						end
						if globals_inst.has_mbyte.to_boolean then
							if l_c = -(107 + ((68).bit_shift_left (8))) then
								ccline.item.cmdpos := ccline.item.cmdpos + (mbyte_inst.mb_off_next (ccline.item.cmdbuff, ccline.item.cmdbuff + ccline.item.cmdpos))
							end
						end
						if not (ccline.item.cmdpos > 0) then
							l_pos := -1 + 103 -- skip if block
						end
				when 101 then -- if:
						l_j := ccline.item.cmdpos
						l_p___1 := ccline.item.cmdbuff + l_j
						if globals_inst.has_mbyte.to_boolean then
							l_p___1 := mbyte_inst.mb_prevptr (ccline.item.cmdbuff, l_p___1)
							if l_c = 23 then
								from
								until
									js.loop_done
								loop
									if (l_p___1.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.cmdbuff).c_pointer.to_integer_32).to_natural_32 then
										if not (misc2_inst.vim_isspace ((l_p___1.item).to_integer_32)).to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___1 := mbyte_inst.mb_prevptr (ccline.item.cmdbuff, l_p___1)
									end
								end
								l_i___0 := mbyte_inst.mb_get_class (l_p___1)
								from
								until
									js.loop_done
								loop
									if (l_p___1.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.cmdbuff).c_pointer.to_integer_32).to_natural_32 then
										if (mbyte_inst.mb_get_class (l_p___1)) /= l_i___0 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___1 := mbyte_inst.mb_prevptr (ccline.item.cmdbuff, l_p___1)
									end
								end
								if (mbyte_inst.mb_get_class (l_p___1)) /= l_i___0 then
									l_p___1 := l_p___1 + (globals_inst.mb_ptr2len.integer_32_item ([l_p___1]))
								end
							end
						elseif l_c = 23 then
							from
							until
								js.loop_done
							loop
								if (l_p___1.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.cmdbuff).c_pointer.to_integer_32).to_natural_32 then
									if not (misc2_inst.vim_isspace ((l_p___1[-1]).to_integer_32)).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___1 := l_p___1 - 1
								end
							end
							l_i___0 := charset_inst.vim_iswordc ((l_p___1[-1]).to_integer_32)
							from
							until
								js.loop_done
							loop
								if (l_p___1.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.cmdbuff).c_pointer.to_integer_32).to_natural_32 then
									if (misc2_inst.vim_isspace ((l_p___1[-1]).to_integer_32)).to_boolean then
										js.break
									elseif (charset_inst.vim_iswordc ((l_p___1[-1]).to_integer_32)) /= l_i___0 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___1 := l_p___1 - 1
								end
							end
						else
							l_p___1 := l_p___1 - 1
						end
						ccline.item.cmdpos := l_p___1.distance ((ccline.item.cmdbuff))
						ccline.item.cmdlen := ccline.item.cmdlen - (l_j - ccline.item.cmdpos)
						l_i___0 := ccline.item.cmdpos
						from
						until
							not (l_i___0 < ccline.item.cmdlen)
						loop
							l_tmp___24 := l_i___0
							l_i___0 := l_i___0 + 1
							l_tmp___25 := l_j
							l_j := l_j + 1
							ccline.item.cmdbuff[l_tmp___24] := ccline.item.cmdbuff[l_tmp___25]
						end
						ccline.item.cmdbuff[ccline.item.cmdlen] := (('%/0/').code).to_natural_8
						redrawcmd
				when 102 then -- if block done, skip else block:
						l_pos := -1 + 109
				when 103 then -- else:
						if ccline.item.cmdlen /= 0 then
							l_pos := -1 + 109 -- skip if block
						end
				when 104 then -- if:
						if l_c = 23 then
							l_pos := -1 + 109 -- skip if block
						end
				when 105 then -- if:
						if not ((ccline.item.cmdprompt).is_void) then
							l_pos := -1 + 109 -- skip if block
						end
				when 106 then -- if:
						if a_indent /= 0 then
							l_pos := -1 + 109 -- skip if block
						end
				when 107 then -- if:
						if globals_inst.exmode_active.to_boolean then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						elseif ccline.item.cmdfirstc = 62 then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 108 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (ccline.item.cmdbuff))
						ccline.item.cmdbuff := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						if not globals_inst.cmd_silent.to_boolean then
							globals_inst.msg_col := 0
							message_inst.msg_putchar ((' ').code)
						end
						globals_inst.redraw_cmdline := 1
						l_pos := -1 + 291 -- goto returncmd
				when 109 then -- if done | if done | if done | if done
						l_pos := -1 + 283 -- goto cmdline_changed
				when 110 then -- switch 1, case -(107 + (73 << 8)) | switch 1, case -(253 + (79 << 8))
						ccline.item.overstrike := (not (ccline.item.overstrike).to_boolean).to_integer
						ui_inst.ui_cursor_shape
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 111 then -- switch 1, case 30
						if (getchar_inst.map_to_exists_mode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 32, 0)).to_boolean then
							globals_inst.State := (globals_inst.State).bit_xor ((32))
							mbyte_inst.im_set_active (0)
							if not l_b_im_ptr.is_void then
								if ((globals_inst.State).bit_and (32)).to_boolean then
									l_b_im_ptr.item := 1
								else
									l_b_im_ptr.item := 0
								end
							end
						else
							if (option_inst.p_imdisable.item).to_boolean then
								if not l_b_im_ptr.is_void then
									l_tmp___27 := (l_b_im_ptr.item = 2).to_integer
								else
									l_tmp___26 := mbyte_inst.im_get_status
									l_tmp___27 := l_tmp___26
								end
							else
								l_tmp___26 := mbyte_inst.im_get_status
								l_tmp___27 := l_tmp___26
							end
							if l_tmp___27.to_boolean then
								mbyte_inst.im_set_active (0)
								if not l_b_im_ptr.is_void then
									l_b_im_ptr.item := 0
								end
							else
								mbyte_inst.im_set_active (1)
								if not l_b_im_ptr.is_void then
									l_b_im_ptr.item := 2
								end
							end
						end
						if not l_b_im_ptr.is_void then
							if l_b_im_ptr.is_equal (create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curbuf.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_iminsert"))) then
								option_inst.set_iminsert_global
							else
								option_inst.set_imsearch_global
							end
						end
						ui_inst.ui_cursor_shape
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 112 then -- switch 1, case 21
						l_j := ccline.item.cmdpos
						ccline.item.cmdlen := ccline.item.cmdlen - l_j
						ccline.item.cmdpos := 0
						l_i___0 := ccline.item.cmdpos
						from
						until
							not (l_i___0 < ccline.item.cmdlen)
						loop
							l_tmp___29 := l_i___0
							l_i___0 := l_i___0 + 1
							l_tmp___30 := l_j
							l_j := l_j + 1
							ccline.item.cmdbuff[l_tmp___29] := ccline.item.cmdbuff[l_tmp___30]
						end
						ccline.item.cmdbuff[ccline.item.cmdlen] := (('%/0/').code).to_natural_8
						redrawcmd
						l_pos := -1 + 283 -- goto cmdline_changed
				when 113 then -- switch 1, case 25
						if (globals_inst.clip_star.item.state).to_integer_32 /= 0 then
							if (globals_inst.clip_star.item.state).to_integer_32 = 2 then
								ui_inst.clip_copy_modeless_selection (1)
							end
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 114 then
						l_pos := -1 + 273 -- switch 1; break
				when 115 then -- switch 1, case 27 | switch 1, case 3
						if globals_inst.exmode_active.to_boolean then
							if globals_inst.ex_normal_busy = 0 then
								l_pos := -1 + 281 -- goto cmdline_not_changed
							elseif globals_inst.typebuf.tb_len > 0 then
								l_pos := -1 + 281 -- goto cmdline_not_changed
							end
						end
				when 116 then
						l_gotesc := 1
						l_pos := -1 + 291 -- goto returncmd
				when 117 then -- switch 1, case 18
						globals_inst.dont_scroll := 1
						putcmdline (('%"').code, 1)
						globals_inst.no_mapping := globals_inst.no_mapping + 1
						l_c := getchar_inst.plain_vgetc
						l_i___0 := l_c
						if l_i___0 = 15 then
							l_i___0 := 18
						end
						if l_i___0 = 18 then
							l_c := getchar_inst.plain_vgetc
						end
						globals_inst.no_mapping := globals_inst.no_mapping - 1
						new_cmdpos := -1
						if l_c = 61 then
							if ccline.item.cmdfirstc = 61 then
								misc1_inst.beep_flush
								l_c := ('%/27/').code
							else
								save_cmdline (l_save_ccline)
								l_c := ops_inst.get_expr_register
								restore_cmdline (l_save_ccline)
							end
						end
						if l_c = 27 then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						cmdline_paste (l_c, (l_i___0 = 18).to_integer, 0).do_nothing
						if (ex_eval_inst.aborting).to_boolean then
							l_gotesc := 1
							l_pos := -1 + 291 -- goto returncmd
						end
				when 119 then
						globals_inst.KeyTyped := 0
						if new_cmdpos >= 0 then
							if new_cmdpos > ccline.item.cmdlen then
								ccline.item.cmdpos := ccline.item.cmdlen
							else
								ccline.item.cmdpos := new_cmdpos
							end
						end
				when 120 then -- if done
						redrawcmd
						l_pos := -1 + 283 -- goto cmdline_changed
				when 121 then -- switch 1, case 4
						if (showmatches (l_xpc, 0)) = 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 122 then
						redrawcmd
						js.continue
				when 123 then -- switch 1, case -(107 + (114 << 8)) | switch 1, case -(37 + (105 << 8)) | switch 1, case -(253 + (86 << 8))
						if js.loop_jumped then
							l_pos := -1 + 138 -- skip if block
						end
				when 124 then -- if: | loop condition:
						if not (not js.loop_done and then (not (ccline.item.cmdpos >= ccline.item.cmdlen))) then
							l_pos := -1 + 137 -- skip loop
						end
				when 125 then -- loop body:
						l_i___0 := cmdline_charsize (ccline.item.cmdpos)
						if globals_inst.KeyTyped.to_boolean then
							if (ccline.item.cmdspos + l_i___0).to_integer_32 >= globals_inst.Columns.item * globals_inst.Rows.item then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 136 -- skip if block
						end
				when 126 then -- if:
						ccline.item.cmdspos := ccline.item.cmdspos + l_i___0
						if globals_inst.has_mbyte.to_boolean then
							ccline.item.cmdpos := ccline.item.cmdpos + (globals_inst.mb_ptr2len.integer_32_item ([ccline.item.cmdbuff + ccline.item.cmdpos]))
						else
							ccline.item.cmdpos := (ccline.item.cmdpos) + 1
						end
						if l_c /= -(37 + ((105).bit_shift_left (8))) then
							l_pos := -1 + 129 -- skip if block
						end
				when 127 then -- if:
						l_pos := -1 + 133 -- goto _L___22
				when 128 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 129 then -- else:
						if l_c /= -(253 + ((86).bit_shift_left (8))) then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if:
						l_pos := -1 + 133 -- goto _L___22
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 132 then -- else:
						if not (((globals_inst.mod_mask.item).bit_and (6)).to_boolean) then
							l_pos := -1 + 135 -- skip if block
						end
				when 133 then -- if: | _L___22:
						if (ccline.item.cmdbuff[ccline.item.cmdpos]).to_integer_32 = 32 then
							js.break
						end
				when 134 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 135 then -- else:
						js.break
				when 136 then -- if done | if done | if done
						l_pos := -1 + 124 -- back to loop condition
				when 137 then -- loop done
						if globals_inst.has_mbyte.to_boolean then
							set_cmdspos_cursor
						end
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 138 then -- switch 1, case -(107 + (108 << 8)) | switch 1, case -(35 + (52 << 8)) | switch 1, case -(253 + (85 << 8))
						if js.loop_jumped then
							l_pos := -1 + 156 -- skip if block
						end
				when 139 then -- if:
						if ccline.item.cmdpos = 0 then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 140 then
						if js.loop_done then
							l_pos := -1 + 155 -- skip loop
						end
				when 141 then -- loop body:
						ccline.item.cmdpos := (ccline.item.cmdpos) - 1
						if globals_inst.has_mbyte.to_boolean then
							ccline.item.cmdpos := ccline.item.cmdpos - (globals_inst.mb_head_off.integer_32_item ([ccline.item.cmdbuff, ccline.item.cmdbuff + ccline.item.cmdpos]))
						end
						ccline.item.cmdspos := ccline.item.cmdspos - (cmdline_charsize (ccline.item.cmdpos))
						if not (ccline.item.cmdpos > 0) then
							l_pos := -1 + 153 -- skip if block
						end
				when 142 then -- if:
						if l_c /= -(35 + ((52).bit_shift_left (8))) then
							l_pos := -1 + 145 -- skip if block
						end
				when 143 then -- if:
						l_pos := -1 + 149 -- goto _L___23
				when 144 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 145 then -- else:
						if l_c /= -(253 + ((85).bit_shift_left (8))) then
							l_pos := -1 + 148 -- skip if block
						end
				when 146 then -- if:
						l_pos := -1 + 149 -- goto _L___23
				when 147 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 148 then -- else:
						if not (((globals_inst.mod_mask.item).bit_and (6)).to_boolean) then
							l_pos := -1 + 151 -- skip if block
						end
				when 149 then -- if: | _L___23:
						if (ccline.item.cmdbuff[(ccline.item.cmdpos - 1)]).to_integer_32 = 32 then
							js.break
						end
				when 150 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 151 then -- else:
						js.break
				when 152 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 154
				when 153 then -- else:
						js.break
				when 154 then
						l_pos := -1 + 140 -- back to loop condition
				when 155 then -- loop done
						if globals_inst.has_mbyte.to_boolean then
							set_cmdspos_cursor
						end
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 156 then -- switch 1, case -(253 + (53 << 8))
						if not js.loop_jumped then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 157 then -- switch 1, case -(253 + (48 << 8)) | switch 1, case -(253 + (49 << 8))
						if not js.loop_jumped then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 158 then -- switch 1, case -(253 + (47 << 8))
						if js.loop_jumped then
							l_pos := -1 + 161 -- skip if block
						end
				when 159 then -- if:
						if not (gui_inst.gui.item.in_use).to_boolean then
							if not (term_inst.mouse_has (('c').code)).to_boolean then
								l_pos := -1 + 281 -- goto cmdline_not_changed
							end
						end
				when 160 then
						if (globals_inst.clip_star.item.available).to_boolean then
							cmdline_paste (('*').code, 1, 1).do_nothing
						else
							cmdline_paste (0, 1, 1).do_nothing
						end
						redrawcmd
						l_pos := -1 + 283 -- goto cmdline_changed
				when 161 then -- switch 1, case -(253 + (95 << 8))
						if not js.loop_jumped then
							cmdline_paste (('~').code, 1, 0).do_nothing
							redrawcmd
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 162 then -- switch 1, case -(253 + (45 << 8)) | switch 1, case -(253 + (46 << 8)) | switch 1, case -(253 + (51 << 8)) | switch 1, case -(253 + (52 << 8))
						if not js.loop_jumped and then (l_ignore_drag_release.to_boolean) then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 163 then -- switch 1, case -(253 + (44 << 8)) | switch 1, case -(253 + (50 << 8))
						if js.loop_jumped then
							l_pos := -1 + 167 -- skip if block
						end
				when 164 then -- if:
						if l_c = -(253 + ((46).bit_shift_left (8))) then
							l_ignore_drag_release := 1
						elseif l_c = -(253 + ((52).bit_shift_left (8))) then
							l_ignore_drag_release := 1
						else
							l_ignore_drag_release := 0
						end
						if not (gui_inst.gui.item.in_use).to_boolean then
							if not (term_inst.mouse_has (('c').code)).to_boolean then
								l_pos := -1 + 281 -- goto cmdline_not_changed
							end
						end
				when 165 then
						if globals_inst.mouse_row < globals_inst.cmdline_row then
							if (globals_inst.clip_star.item.available).to_boolean then
								l_button := misc2_inst.get_mouse_button ((((((-l_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_integer_32, l_is_click, l_is_drag)
								if (term_inst.mouse_model_popup).to_boolean then
									if l_button = 0 then
										if ((globals_inst.mod_mask.item).bit_and (2)).to_boolean then
											l_button := 2
											globals_inst.mod_mask.item := (globals_inst.mod_mask.item).bit_and ((-3))
										end
									end
								end
								ui_inst.clip_modeless (l_button, l_is_click.item, l_is_drag.item)
								l_pos := -1 + 281 -- goto cmdline_not_changed
							end
						end
				when 166 then
						set_cmdspos
						ccline.item.cmdpos := 0
						from
						until
							not (not js.loop_done and then (ccline.item.cmdpos < ccline.item.cmdlen))
						loop
							l_i___0 := cmdline_charsize (ccline.item.cmdpos)
							if globals_inst.mouse_row.to_integer_32 <= globals_inst.cmdline_row.to_integer_32 + (ccline.item.cmdspos).to_integer_32 // globals_inst.Columns.item then
								if globals_inst.mouse_col.to_integer_32 < (ccline.item.cmdspos).to_integer_32 \\ globals_inst.Columns.item + l_i___0.to_integer_32 then
									js.break
								end
							end
							if not js.loop_jumped then
								if globals_inst.has_mbyte.to_boolean then
									correct_cmdspos (ccline.item.cmdpos, l_i___0)
									ccline.item.cmdpos := ccline.item.cmdpos + ((globals_inst.mb_ptr2len.integer_32_item ([ccline.item.cmdbuff + ccline.item.cmdpos])) - 1)
								end
								ccline.item.cmdspos := ccline.item.cmdspos + l_i___0
								ccline.item.cmdpos := (ccline.item.cmdpos) + 1
							end
						end
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 167 then -- switch 1, case -(253 + (75 << 8)) | switch 1, case -(253 + (76 << 8)) | switch 1, case -(253 + (77 << 8)) | switch 1, case -(253 + (78 << 8)) | switch 1, case -(253 + (89 << 8)) | switch 1, case -(253 + (90 << 8)) | switch 1, case -(253 + (91 << 8)) | switch 1, case -(253 + (92 << 8)) | switch 1, case -(253 + (93 << 8)) | switch 1, case -(253 + (94 << 8))
						if not js.loop_jumped then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 168 then -- switch 1, case -(253 + (69 << 8)) | switch 1, case -(253 + (70 << 8))
						if not js.loop_jumped then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 169 then -- switch 1, case -(249 + (88 << 8))
						if not js.loop_jumped then
							if globals_inst.msg_scrolled = 0 then
								gui_inst.gui_do_scroll.do_nothing
								redrawcmd
							end
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 170 then -- switch 1, case -(248 + (88 << 8))
						if not js.loop_jumped then
							if globals_inst.msg_scrolled = 0 then
								gui_inst.gui_do_horiz_scroll (globals_inst.scrollbar_value, 0).do_nothing
								redrawcmd
							end
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 171 then -- switch 1, case -(240 + (88 << 8)) | switch 1, case -(239 + (88 << 8))
						if not js.loop_jumped then
							if (gui_inst.gui_use_tabline).to_boolean then
								gui_gtk_x11_inst.gui_mch_set_curtab ((window_inst.tabpage_index (globals_inst.curtab)))
							end
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 172 then -- switch 1, case -(245 + (88 << 8))
						if not js.loop_jumped then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 173 then -- switch 1, case 2 | switch 1, case -(107 + (104 << 8)) | switch 1, case -(75 + (49 << 8)) | switch 1, case -(35 + (50 << 8)) | switch 1, case -(253 + (87 << 8))
						if not js.loop_jumped then
							ccline.item.cmdpos := 0
							set_cmdspos
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 174 then -- switch 1, case 5 | switch 1, case -(64 + (55 << 8)) | switch 1, case -(75 + (52 << 8)) | switch 1, case -(42 + (55 << 8)) | switch 1, case -(253 + (88 << 8))
						if not js.loop_jumped then
							ccline.item.cmdpos := ccline.item.cmdlen
							set_cmdspos_cursor
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 175 then -- switch 1, case 1
						if js.loop_jumped then
							l_pos := -1 + 178 -- skip if block
						end
				when 176 then -- if:
						if (nextwild (l_xpc, 6, 0)) = 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 177 then
						l_pos := -1 + 283 -- goto cmdline_changed
				when 178 then -- switch 1, case 12
						if js.loop_jumped then
							l_pos := -1 + 193 -- skip if block
						end
				when 179 then -- if:
						if not ((option_inst.p_is.item).to_boolean) then
							l_pos := -1 + 191 -- skip if block
						end
				when 180 then -- if:
						if globals_inst.cmd_silent.to_boolean then
							l_pos := -1 + 191 -- skip if block
						end
				when 181 then -- if:
						if l_firstc /= 47 then
							l_pos := -1 + 184 -- skip if block
						end
				when 182 then -- if:
						l_pos := -1 + 185 -- goto _L___26
				when 183 then -- if block done, skip else block:
						l_pos := -1 + 191
				when 184 then -- else:
						if l_firstc /= 63 then
							l_pos := -1 + 191 -- skip if block
						end
				when 185 then -- if: | _L___26:
						if not (l_did_incsearch.to_boolean) then
							l_pos := -1 + 190 -- skip if block
						end
				when 186 then -- if:
						if globals_inst.curwin.item.w_cursor.lnum /= l_old_cursor.lnum then
							l_pos := -1 + 189 -- skip if block
						end
				when 187 then -- if:
						if globals_inst.curwin.item.w_cursor.col = l_old_cursor.col then
							if globals_inst.curwin.item.w_cursor.coladd /= l_old_cursor.coladd then
								l_pos := -1 + 189 -- goto _L___25
							end
						else
							l_pos := -1 + 189 -- goto _L___25
						end
				when 188 then -- if block done, skip else block:
						l_pos := -1 + 190
				when 189 then -- else: | _L___25:
						l_c := misc1_inst.gchar_cursor
						if (option_inst.p_ic.item).to_boolean then
							if (option_inst.p_scs.item).to_boolean then
								if not (search_inst.pat_has_uppercase (ccline.item.cmdbuff)).to_boolean then
									l_c := charset_inst.vim_tolower (l_c)
								end
							end
						end
						if l_c /= 0 then
							if l_c = l_firstc then
								getchar_inst.stuffcharReadbuff (l_c)
								l_c := ('\').code
							else
								if (option_inst.p_magic.item).to_boolean then
									l_tmp___44 := ce_string ("\^$.*[")
								else
									l_tmp___44 := ce_string ("\^$")
								end
								if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___44), l_c)).is_void then
									getchar_inst.stuffcharReadbuff (l_c)
									l_c := ('\').code
								end
							end
							l_pos := -1 + 273 -- switch 1; break
						end
				when 190 then -- if done
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 191 then -- if done | if done | if done
						if (nextwild (l_xpc, 7, 0)) = 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 192 then
						l_pos := -1 + 283 -- goto cmdline_changed
				when 193 then -- switch 1, case 14 | switch 1, case 16
						if not (not js.loop_jumped and then (l_xpc.item.xp_numfiles > 0)) then
							l_pos := -1 + 196 -- skip if block
						end
				when 194 then -- if:
						if l_c = 16 then
							l_tmp___47 := 5
						else
							l_tmp___47 := 4
						end
						if (nextwild (l_xpc, l_tmp___47, 0)) = 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 195 then
						l_pos := -1 + 283 -- goto cmdline_changed
				when 196 then -- switch 1, case -(107 + (117 << 8)) | switch 1, case -(107 + (100 << 8)) | switch 1, case -(253 + (4 << 8)) | switch 1, case -(253 + (5 << 8)) | switch 1, case -(107 + (80 << 8)) | switch 1, case -(75 + (51 << 8)) | switch 1, case -(107 + (78 << 8)) | switch 1, case -(75 + (53 << 8))
						if js.loop_jumped then
							l_pos := -1 + 268 -- skip if block
						end
				when 197 then -- if:
						if hislen = 0 then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						elseif l_firstc = 0 then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 198 then
						l_i___0 := l_hiscnt
						if not (l_lookfor.is_void) then
							l_pos := -1 + 201 -- skip if block
						end
				when 199 then -- if:
						l_lookfor := misc2_inst.vim_strsave (ccline.item.cmdbuff)
						if l_lookfor.is_void then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 200 then
						l_lookfor[ccline.item.cmdpos] := (('%/0/').code).to_natural_8
				when 201 then -- if done
						l_j := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lookfor))).to_integer_32
				when 202 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 231 -- skip loop
						end
				when 203 then -- loop body:
						if l_c /= -(107 + ((117).bit_shift_left (8))) then
							l_pos := -1 + 206 -- skip if block
						end
				when 204 then -- if:
						l_pos := -1 + 216 -- goto _L___28
				when 205 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 206 then -- else:
						if l_c /= -(253 + ((4).bit_shift_left (8))) then
							l_pos := -1 + 209 -- skip if block
						end
				when 207 then -- if:
						l_pos := -1 + 216 -- goto _L___28
				when 208 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 209 then -- else:
						if l_c /= 16 then
							l_pos := -1 + 212 -- skip if block
						end
				when 210 then -- if:
						l_pos := -1 + 216 -- goto _L___28
				when 211 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 212 then -- else:
						if l_c /= -(107 + ((80).bit_shift_left (8))) then
							l_pos := -1 + 215 -- skip if block
						end
				when 213 then -- if:
						l_pos := -1 + 216 -- goto _L___28
				when 214 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 215 then -- else:
						if l_c /= -(75 + ((51).bit_shift_left (8))) then
							l_pos := -1 + 224 -- skip if block
						end
				when 216 then -- if: | _L___28:
						if l_hiscnt /= hislen then
							l_pos := -1 + 219 -- skip if block
						end
				when 217 then -- if:
						l_hiscnt := hisidx[l_histype]
				when 218 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 219 then -- else:
						if l_hiscnt /= 0 then
							l_pos := -1 + 222 -- skip if block
						end
				when 220 then -- if:
						if hisidx[l_histype] /= hislen - 1 then
							l_hiscnt := hislen - 1
						else
							l_pos := -1 + 222 -- goto _L___27
						end
				when 221 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 222 then -- else: | _L___27:
						if l_hiscnt /= hisidx[l_histype] + 1 then
							l_hiscnt := l_hiscnt - 1
						else
							l_hiscnt := l_i___0
							js.break
						end
				when 223 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 225
				when 224 then -- else:
						if l_hiscnt = hisidx[l_histype] then
							l_hiscnt := hislen
							js.break
						end
						if not js.loop_jumped and then (l_hiscnt = hislen) then
							js.break
						end
						if not js.loop_jumped then
							if l_hiscnt = hislen - 1 then
								l_hiscnt := 0
							else
								l_hiscnt := l_hiscnt + 1
							end
						end
				when 225 then -- if done | if done | if done | if done
						if not js.loop_jumped then
							if l_hiscnt < 0 then
								l_hiscnt := l_i___0
								js.break
							elseif ((history[l_histype] + l_hiscnt).item.hisstr).is_void then
								l_hiscnt := l_i___0
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 230 -- skip if block
						end
				when 226 then -- if:
						if l_c = -(107 + ((117).bit_shift_left (8))) then
							l_pos := -1 + 229 -- skip if block
						end
				when 227 then -- if:
						if l_c /= -(107 + ((100).bit_shift_left (8))) then
							js.break
						else
							l_pos := -1 + 229 -- goto _L___29
						end
				when 228 then -- if block done, skip else block:
						l_pos := -1 + 230
				when 229 then -- else: | _L___29:
						if l_hiscnt = l_i___0 then
							js.break
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((history[l_histype] + l_hiscnt).item.hisstr), create {CE_POINTER [INTEGER_8]}.make_cast (l_lookfor), l_j.to_natural_32)) = 0 then
							js.break
						end
				when 230 then -- if done
						l_pos := -1 + 202 -- back to loop condition
				when 231 then -- loop done
						if l_hiscnt = l_i___0 then
							l_pos := -1 + 267 -- skip if block
						end
				when 232 then -- if:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (ccline.item.cmdbuff))
						l_xpc.item.xp_context := 0
						if l_hiscnt = hislen then
							l_p___2 := l_lookfor
						else
							l_p___2 := (history[l_histype] + l_hiscnt).item.hisstr
						end
						if l_histype /= 1 then
							l_pos := -1 + 264 -- skip if block
						end
				when 233 then -- if:
						if l_p___2.is_equal (l_lookfor) then
							l_pos := -1 + 262 -- skip if block
						end
				when 234 then -- if:
						l_old_firstc := (l_p___2[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___2))) + {NATURAL_32} 1).to_integer_32]).to_integer_32
						if l_old_firstc = l_firstc then
							l_pos := -1 + 260 -- skip if block
						end
				when 235 then -- if:
						l_i___0 := 0
				when 236 then -- loop condition:
						if not (not js.loop_done and then (l_i___0 <= 1)) then
							l_pos := -1 + 258 -- skip loop
						end
				when 237 then -- loop body:
						l_len___0 := 0
						l_j := 0
				when 238 then -- loop condition:
						if (l_p___2[l_j]).to_integer_32 = 0 then
							l_pos := -1 + 256 -- skip loop
						end
				when 239 then -- loop body:
						if (l_p___2[l_j]).to_integer_32 /= l_old_firstc then
							l_pos := -1 + 248 -- skip if block
						end
				when 240 then -- if:
						if l_j /= 0 then
							l_pos := -1 + 243 -- skip if block
						end
				when 241 then -- if:
						l_pos := -1 + 244 -- goto _L___32
				when 242 then -- if block done, skip else block:
						l_pos := -1 + 247
				when 243 then -- else:
						if (l_p___2[(l_j - 1)]).to_integer_32 = 92 then
							l_pos := -1 + 246 -- skip if block
						end
				when 244 then -- if: | _L___32:
						if l_i___0 > 0 then
							ccline.item.cmdbuff[l_len___0] := l_firstc.to_natural_8
						end
				when 245 then -- if block done, skip else block:
						l_pos := -1 + 247
				when 246 then -- else:
						l_pos := -1 + 248 -- goto _L___31
				when 247 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 255
				when 248 then -- else: | _L___31:
						if (l_p___2[l_j]).to_integer_32 /= l_firstc then
							l_pos := -1 + 254 -- skip if block
						end
				when 249 then -- if:
						if l_j /= 0 then
							l_pos := -1 + 252 -- skip if block
						end
				when 250 then -- if:
						l_pos := -1 + 253 -- goto _L___30
				when 251 then -- if block done, skip else block:
						l_pos := -1 + 254
				when 252 then -- else:
						if (l_p___2[(l_j - 1)]).to_integer_32 = 92 then
							l_pos := -1 + 254 -- skip if block
						end
				when 253 then -- if: | _L___30:
						if l_i___0 > 0 then
							ccline.item.cmdbuff[l_len___0] := (('\').code).to_natural_8
						end
						l_len___0 := l_len___0 + 1
				when 254 then -- if done | if done
						if l_i___0 > 0 then
							ccline.item.cmdbuff[l_len___0] := l_p___2[l_j]
						end
				when 255 then
						l_len___0 := l_len___0 + 1
						l_j := l_j + 1
						l_pos := -1 + 238 -- back to loop condition
				when 256 then -- loop done
						if l_i___0 = 0 then
							alloc_cmdbuff (l_len___0)
							if (ccline.item.cmdbuff).is_void then
								l_pos := -1 + 291 -- goto returncmd
							end
						end
				when 257 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 236 -- back to loop condition
				when 258 then -- loop done
						ccline.item.cmdbuff[l_len___0] := (('%/0/').code).to_natural_8
				when 259 then -- if block done, skip else block:
						l_pos := -1 + 261
				when 260 then -- else:
						l_pos := -1 + 264 -- goto _L___34
				when 261 then -- if done | if block done, skip else block:
						l_pos := -1 + 263
				when 262 then -- else:
						l_pos := -1 + 264 -- goto _L___34
				when 263 then -- if done | if block done, skip else block:
						l_pos := -1 + 266
				when 264 then -- else: | _L___34:
						alloc_cmdbuff ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___2))).to_integer_32)
						if (ccline.item.cmdbuff).is_void then
							l_pos := -1 + 291 -- goto returncmd
						end
				when 265 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (ccline.item.cmdbuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___2)).do_nothing
				when 266 then
						ccline.item.cmdlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (ccline.item.cmdbuff))).to_integer_32
						ccline.item.cmdpos := ccline.item.cmdlen
						redrawcmd
						l_pos := -1 + 283 -- goto cmdline_changed
				when 267 then
						misc1_inst.beep_flush
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 268 then -- switch 1, case 22 | switch 1, case 17
						if not js.loop_jumped then
							l_ignore_drag_release := 1
							putcmdline (('^').code, 1)
							l_c := edit_inst.get_literal
							l_do_abbr := 0
							if globals_inst.enc_utf8.to_boolean then
								if (mbyte_inst.utf_iscomposing (l_c)).to_boolean then
									if not globals_inst.cmd_silent.to_boolean then
										draw_cmdline (ccline.item.cmdpos, ccline.item.cmdlen - ccline.item.cmdpos)
										message_inst.msg_putchar ((' ').code)
										cursorcmd
									end
								end
							end
						end
						l_pos := -1 + 273 -- switch 1; break
				when 269 then -- switch 1, case 11
						l_ignore_drag_release := 1
						putcmdline (('?').code, 1)
						globals_inst.dont_scroll := 1
						l_c := digraph_inst.get_digraph (1)
						if l_c /= 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 270 then
						redrawcmd
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 271 then -- switch 1, default:
						if l_c = globals_inst.intr_char then
							l_gotesc := 1
							l_pos := -1 + 291 -- goto returncmd
						end
				when 272 then
						if not (l_c < 0) then
							globals_inst.mod_mask.item := 0
						end
						l_pos := -1 + 273 -- switch 1; break
				when 273 then -- switch 1, done: | if done
						if js.loop_jumped then
							l_pos := -1 + 282 -- skip if block
						end
				when 274 then -- if:
						if not (l_do_abbr.to_boolean) then
							l_pos := -1 + 280 -- skip if block
						end
				when 275 then -- if:
						if not (l_c < 0) then
							l_pos := -1 + 278 -- skip if block
						end
				when 276 then -- if:
						l_pos := -1 + 279 -- goto _L___35
				when 277 then -- if block done, skip else block:
						l_pos := -1 + 280
				when 278 then -- else:
						if (charset_inst.vim_iswordc (l_c)).to_boolean then
							l_pos := -1 + 280 -- skip if block
						end
				when 279 then -- if: | _L___35:
						if globals_inst.has_mbyte.to_boolean then
							if l_c >= 256 then
								l_tmp___56 := l_c + 256
							else
								l_tmp___56 := l_c
							end
						else
							l_tmp___56 := l_c
						end
						if (ccheck_abbr (l_tmp___56)).to_boolean then
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 280 then -- if done | if done
						if l_c < 0 then
							l_tmp___58 := misc2_inst.get_special_key_name (l_c, globals_inst.mod_mask.item)
							put_on_cmdline (l_tmp___58, -1, 1).do_nothing
						elseif globals_inst.mod_mask.item /= 0 then
							l_tmp___58 := misc2_inst.get_special_key_name (l_c, globals_inst.mod_mask.item)
							put_on_cmdline (l_tmp___58, -1, 1).do_nothing
						elseif globals_inst.has_mbyte.to_boolean then
							l_j := globals_inst.mb_char2bytes.integer_32_item ([l_c, globals_inst.IObuff])
							globals_inst.IObuff[l_j] := (('%/0/').code).to_natural_8
							put_on_cmdline (globals_inst.IObuff, l_j, 1).do_nothing
						else
							globals_inst.IObuff[0] := l_c.to_natural_8
							put_on_cmdline (globals_inst.IObuff, 1, 1).do_nothing
						end
						l_pos := -1 + 283 -- goto cmdline_changed
				when 281 then -- cmdline_not_changed:
						if not l_incsearch_postponed.to_boolean then
							js.continue
						end
				when 282 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 290 -- skip if block
						end
				when 283 then -- if: | cmdline_changed:
						if not ((option_inst.p_is.item).to_boolean) then
							l_pos := -1 + 290 -- skip if block
						end
				when 284 then -- if:
						if globals_inst.cmd_silent.to_boolean then
							l_pos := -1 + 290 -- skip if block
						end
				when 285 then -- if:
						if l_firstc /= 47 then
							l_pos := -1 + 288 -- skip if block
						end
				when 286 then -- if:
						l_pos := -1 + 289 -- goto _L___36
				when 287 then -- if block done, skip else block:
						l_pos := -1 + 290
				when 288 then -- else:
						if l_firstc /= 63 then
							l_pos := -1 + 290 -- skip if block
						end
				when 289 then -- if: | _L___36:
						if (getchar_inst.char_avail).to_boolean then
							l_incsearch_postponed := 1
							js.continue
						end
						if not js.loop_jumped then
							l_incsearch_postponed := 0
							globals_inst.curwin.item.w_cursor := l_old_cursor.twin
							if ccline.item.cmdlen = 0 then
								l_i___0 := 0
							else
								term_inst.cursor_off
								term_inst.out_flush
								globals_inst.emsg_off := globals_inst.emsg_off + 1
								ex_cmds2_inst.profile_setlimit (500, l_tm)
								l_i___0 := search_inst.do_search (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), l_firstc, ccline.item.cmdbuff, a_count___2, 3_216, l_tm)
								globals_inst.emsg_off := globals_inst.emsg_off - 1
								if globals_inst.got_int.to_boolean then
									getchar_inst.vpeekc.do_nothing
									globals_inst.got_int := 0
									l_i___0 := 0
								elseif (getchar_inst.char_avail).to_boolean then
									l_incsearch_postponed := 1
								end
							end
							if l_i___0 /= 0 then
								globals_inst.highlight_match := 1
							else
								globals_inst.highlight_match := 0
							end
							globals_inst.curwin.item.w_leftcol := l_old_leftcol___0
							globals_inst.curwin.item.w_topline := l_old_topline___0
							globals_inst.curwin.item.w_topfill := l_old_topfill___0
							globals_inst.curwin.item.w_botline := l_old_botline
							move_inst.changed_cline_bef_curs
							move_inst.update_topline
							if l_i___0 /= 0 then
								l_save_pos := (globals_inst.curwin.item.w_cursor).twin
								globals_inst.curwin.item.w_cursor.lnum := globals_inst.curwin.item.w_cursor.lnum + globals_inst.search_match_lines
								globals_inst.curwin.item.w_cursor.col := globals_inst.search_match_endcol
								if globals_inst.curwin.item.w_cursor.lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
									globals_inst.curwin.item.w_cursor.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
									misc2_inst.coladvance ((2_147_483_647).to_integer_32).do_nothing
								end
								move_inst.validate_cursor
								l_end_pos := (globals_inst.curwin.item.w_cursor).twin
								globals_inst.curwin.item.w_cursor := l_save_pos.twin
							else
								l_end_pos := (globals_inst.curwin.item.w_cursor).twin
							end
							move_inst.validate_cursor
							if (option_inst.p_ru.item).to_boolean then
								if globals_inst.curwin.item.w_status_height > 0 then
									globals_inst.curwin.item.w_redr_status := 1
								end
							end
							save_cmdline (l_save_ccline)
							screen_inst.update_screen (35)
							restore_cmdline (l_save_ccline)
							if l_i___0 /= 0 then
								globals_inst.curwin.item.w_cursor := l_end_pos.twin
							end
							message_inst.msg_starthere
							redrawcmdline
							l_did_incsearch := 1
						end
				when 290 then -- if done | if done | if done | if done
						if js.loop_increment then
							
						end
						l_pos := -1 + 12 -- back to loop condition
				when 291 then -- returncmd:
						ExpandCleanup (l_xpc)
						ccline.item.xpc := create {CE_POINTER [PD_EXPAND]}.make_shared (default_pointer)
						if l_did_incsearch.to_boolean then
							globals_inst.curwin.item.w_cursor := l_old_cursor.twin
							globals_inst.curwin.item.w_curswant := l_old_curswant
							globals_inst.curwin.item.w_leftcol := l_old_leftcol___0
							globals_inst.curwin.item.w_topline := l_old_topline___0
							globals_inst.curwin.item.w_topfill := l_old_topfill___0
							globals_inst.curwin.item.w_botline := l_old_botline
							globals_inst.highlight_match := 0
							move_inst.validate_cursor
							screen_inst.redraw_later (35)
						end
						if (ccline.item.cmdbuff).is_void then
							l_pos := -1 + 300 -- skip if block
						end
				when 292 then -- if:
						if not ((ccline.item.cmdlen).to_boolean) then
							l_pos := -1 + 299 -- skip if block
						end
				when 293 then -- if:
						if l_firstc = 0 then
							l_pos := -1 + 299 -- skip if block
						end
				when 294 then -- if:
						if not (l_some_key_typed.to_boolean) then
							l_pos := -1 + 297 -- skip if block
						end
				when 295 then -- if:
						l_pos := -1 + 298 -- goto _L___37
				when 296 then -- if block done, skip else block:
						l_pos := -1 + 299
				when 297 then -- else:
						if l_histype /= 1 then
							l_pos := -1 + 299 -- skip if block
						end
				when 298 then -- if: | _L___37:
						if l_histype = 1 then
							l_tmp___61 := l_firstc
						else
							l_tmp___61 := ('%/0/').code
						end
						add_to_history (l_histype, ccline.item.cmdbuff, 1, l_tmp___61)
						if l_firstc = 58 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.new_last_cmdline))
							globals_inst.new_last_cmdline := misc2_inst.vim_strsave (ccline.item.cmdbuff)
						end
				when 299 then -- if done | if done | if done
						if l_gotesc.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (ccline.item.cmdbuff))
							ccline.item.cmdbuff := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							if globals_inst.msg_scrolled = 0 then
								compute_cmdrow
							end
							message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))).do_nothing
							globals_inst.redraw_cmdline := 1
						end
				when 300 then -- if done
						message_inst.msg_check
						globals_inst.msg_scroll := l_save_msg_scroll
						globals_inst.redir_off := 0
						if l_some_key_typed.to_boolean then
							globals_inst.need_wait_return := 0
						end
						globals_inst.State := l_save_State
						if not l_b_im_ptr.is_void then
							if l_b_im_ptr.item /= 1 then
								ui_inst.im_save_status (l_b_im_ptr)
							end
						end
						mbyte_inst.im_set_active (0)
						term_inst.setmouse
						ui_inst.ui_cursor_shape
						l_p___3 := ccline.item.cmdbuff
						ccline.item.cmdbuff := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						Result := l_p___3
				when 301 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getcmdline_prompt (a_firstc: INTEGER_32; a_prompt: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32; a_xp_context: INTEGER_32; a_xp_arg: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_save_ccline: CE_ARRAY [PD_CMDLINE_INFO]
			l_msg_col_save: INTEGER_32
		do
			create l_s.make
			create l_save_ccline.make (<<1>>)

			l_msg_col_save := globals_inst.msg_col
			save_cmdline (l_save_ccline)
			ccline.item.cmdprompt := a_prompt
			ccline.item.cmdattr := a_attr
			ccline.item.xp_context := a_xp_context
			ccline.item.xp_arg := a_xp_arg
			ccline.item.input_fn := (a_firstc = 64).to_integer
			l_s := getcmdline (a_firstc, 1, 0)
			restore_cmdline (l_save_ccline)
			globals_inst.msg_col := l_msg_col_save
			Result := l_s
		end

	getexline (a_c: INTEGER_32; a_cookie: CE_POINTER [ANY]; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		do
			if globals_inst.exec_from_reg.to_boolean then
				if (getchar_inst.vpeekc) = 58 then
					getchar_inst.vgetc.do_nothing
				end
			end
			Result := (getcmdline (a_c, 1, a_indent))
		end

	getexline_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent getexline)
		end

	getexmodeline (a_promptc: INTEGER_32; a_cookie: CE_POINTER [ANY]; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_indent: INTEGER_32
			l_line_ga: CE_ARRAY [PD_GROWARRAY]
			l_pend: CE_POINTER [NATURAL_8]
			l_startcol: INTEGER_32
			l_c1: INTEGER_32
			l_escaped: INTEGER_32
			l_vcol: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_prev_char: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_s___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line_ga.make (<<1>>)
			create l_pend.make
			create l_p___0.make
			create l_s.make
			create l_s___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_indent := a_indent
					l_startcol := 0
					l_c1 := 0
					l_escaped := 0
					l_vcol := 0
					term_inst.cursor_on
					compute_cmdrow
					if not (globals_inst.msg_col.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (globals_inst.msg_didout.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if a_promptc /= 63 then
							message_inst.msg_putchar (('%N').code)
						end
				when 5 then -- if done
						if a_promptc = 58 then
							if (option_inst.p_prompt.item).to_boolean then
								message_inst.msg_putchar ((':').code)
							end
							from
							until
								js.loop_done
							loop
								l_tmp := l_indent
								l_indent := l_indent - 1
								if not (l_tmp > 0) then
									js.break
								end
								if not js.loop_jumped then
									message_inst.msg_putchar ((' ').code)
								end
							end
							l_startcol := globals_inst.msg_col
						end
						misc2_inst.ga_init2 (l_line_ga, 1, 30)
						if a_promptc <= 0 then
							l_vcol := l_indent
							from
							until
								not (l_indent >= 8)
							loop
								misc2_inst.ga_append (l_line_ga, ('%T').code)
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("        ")))
								l_indent := l_indent - (8)
							end
							from
							until
								js.loop_done
							loop
								l_tmp___0 := l_indent
								l_indent := l_indent - 1
								if not (l_tmp___0 > 0) then
									js.break
								end
								if not js.loop_jumped then
									misc2_inst.ga_append (l_line_ga, (' ').code)
									message_inst.msg_putchar ((' ').code)
								end
							end
						end
						globals_inst.no_mapping := globals_inst.no_mapping + 1
						globals_inst.allow_keys := globals_inst.allow_keys + 1
						globals_inst.got_int := 0
				when 6 then -- loop condition:
						if not (not js.loop_done and then (not globals_inst.got_int.to_boolean)) then
							l_pos := -1 + 40 -- skip loop
						end
				when 7 then -- loop body:
							if (misc2_inst.ga_grow (l_line_ga, 40)) = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_prev_char := l_c1
								l_c1 := getchar_inst.vgetc
								if globals_inst.got_int.to_boolean then
									message_inst.msg_putchar (('%N').code)
									js.break
								end
							end
							if not (not js.loop_jumped and then (not l_escaped.to_boolean)) then
								l_pos := -1 + 39 -- skip if block
							end
				when 8 then -- if:
							if l_c1 = 13 then
								l_c1 := ('%N').code
							end
							if l_c1 /= 8 then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							l_pos := -1 + 21 -- goto _L___0
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 23
				when 11 then -- else:
							if l_c1 /= -(107 + ((98).bit_shift_left (8))) then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if:
							l_pos := -1 + 21 -- goto _L___0
				when 13 then -- if block done, skip else block:
							l_pos := -1 + 23
				when 14 then -- else:
							if l_c1 /= 127 then
								l_pos := -1 + 17 -- skip if block
							end
				when 15 then -- if:
							l_pos := -1 + 21 -- goto _L___0
				when 16 then -- if block done, skip else block:
							l_pos := -1 + 23
				when 17 then -- else:
							if l_c1 /= -(107 + ((68).bit_shift_left (8))) then
								l_pos := -1 + 20 -- skip if block
							end
				when 18 then -- if:
							l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
							l_pos := -1 + 23
				when 20 then -- else:
							if l_c1 /= -(253 + ((80).bit_shift_left (8))) then
								l_pos := -1 + 23 -- skip if block
							end
				when 21 then -- if: | _L___0:
							if l_line_ga.item.ga_len > 0 then
								l_line_ga.item.ga_len := (l_line_ga.item.ga_len) - 1
								l_pos := -1 + 26 -- goto redraw
							end
				when 22 then
							js.continue
				when 23 then -- if done | if done | if done | if done
							if not js.loop_jumped and then (l_c1 = 21) then
								globals_inst.msg_col := l_startcol
								message_inst.msg_clr_eos
								l_line_ga.item.ga_len := 0
								js.continue
							end
							if not (not js.loop_jumped and then (l_c1 = 20)) then
								l_pos := -1 + 27 -- skip if block
							end
				when 24 then -- if:
							l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (l_line_ga.item.ga_data)
							l_p___0[l_line_ga.item.ga_len] := (('%/0/').code).to_natural_8
							l_indent := misc1_inst.get_indent_str (l_p___0, 8)
							l_indent := (l_indent.to_integer_32 + (globals_inst.curbuf.item.b_p_sw - l_indent.to_integer_32 \\ globals_inst.curbuf.item.b_p_sw)).to_integer_32
				when 25 then -- add_indent:
							from
							until
								js.loop_done
							loop
								if not ((misc1_inst.get_indent_str (l_p___0, 8)) < l_indent) then
									js.break
								end
								if not js.loop_jumped then
									l_s := (charset_inst.skipwhite (l_p___0))
									misc2_inst.ga_grow (l_line_ga, 1).do_nothing
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_s + 1)), create {CE_POINTER [ANY]}.make_cast (l_s), ((l_line_ga.item.ga_len - (l_s.distance (l_p___0))) + 1).to_natural_32).do_nothing
									l_s.item := ((' ').code).to_natural_8
									l_line_ga.item.ga_len := (l_line_ga.item.ga_len) + 1
								end
							end
				when 26 then -- redraw:
							globals_inst.msg_col := l_startcol
							l_vcol := 0
							l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (l_line_ga.item.ga_data)
							from
							until
								not (not js.loop_done and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((create {CE_POINTER [NATURAL_8]}.make_cast (l_line_ga.item.ga_data) + l_line_ga.item.ga_len).c_pointer.to_integer_32).to_natural_32))
							loop
								if (l_p___0.item).to_integer_32 = 9 then
									from
									until
										js.loop_done
									loop
										message_inst.msg_putchar ((' ').code)
										l_vcol := l_vcol + 1
										if not (l_vcol \\ 8).to_boolean then
											js.break
										end
									end
								else
									message_inst.msg_outtrans_len (l_p___0, 1).do_nothing
									l_vcol := l_vcol + (charset_inst.char2cells ((l_p___0.item).to_integer_32))
								end
								l_p___0 := l_p___0 + 1
							end
							message_inst.msg_clr_eos
							screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
							js.continue
				when 27 then -- if done
							if js.loop_jumped then
								l_pos := -1 + 38 -- skip if block
							end
				when 28 then -- if:
							if l_c1 /= 4 then
								l_pos := -1 + 37 -- skip if block
							end
				when 29 then -- if:
							l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (l_line_ga.item.ga_data)
							if l_prev_char /= 48 then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 33 -- goto _L___1
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 36
				when 32 then -- else:
							if l_prev_char /= 94 then
								l_pos := -1 + 35 -- skip if block
							end
				when 33 then -- if: | _L___1:
							if l_prev_char = 94 then
								globals_inst.ex_keep_indent := 1
							end
							l_indent := 0
							l_line_ga.item.ga_len := (l_line_ga.item.ga_len) - 1
							l_p___0[l_line_ga.item.ga_len] := (('%/0/').code).to_natural_8
				when 34 then -- if block done, skip else block:
							l_pos := -1 + 36
				when 35 then -- else:
							l_p___0[l_line_ga.item.ga_len] := (('%/0/').code).to_natural_8
							l_indent := misc1_inst.get_indent_str (l_p___0, 8)
							l_indent := l_indent - 1
							l_indent := (l_indent.to_integer_32 - l_indent.to_integer_32 \\ globals_inst.curbuf.item.b_p_sw).to_integer_32
				when 36 then -- if done
							from
							until
								js.loop_done
							loop
								if not ((misc1_inst.get_indent_str (l_p___0, 8)) > l_indent) then
									js.break
								end
								if not js.loop_jumped then
									l_s___0 := (charset_inst.skipwhite (l_p___0))
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_s___0 - 1)), create {CE_POINTER [ANY]}.make_cast (l_s___0), ((l_line_ga.item.ga_len - (l_s___0.distance (l_p___0))) + 1).to_natural_32).do_nothing
									l_line_ga.item.ga_len := (l_line_ga.item.ga_len) - 1
								end
							end
							l_pos := -1 + 25 -- goto add_indent
				when 37 then
							if l_c1 = 22 then
								l_escaped := 1
								js.continue
							elseif l_c1 = 17 then
								l_escaped := 1
								js.continue
							end
				when 38 then -- if done
							if not js.loop_jumped and then (l_c1 < 0) then
								js.continue
							end
				when 39 then -- if done
							if not js.loop_jumped then
								if l_c1 < 0 then
									l_c1 := ('?').code
								end
								create {CE_POINTER [NATURAL_8]}.make_cast (l_line_ga.item.ga_data)[l_line_ga.item.ga_len] := l_c1.to_natural_8
								if l_c1 = 10 then
									message_inst.msg_putchar (('%N').code)
								elseif l_c1 = 9 then
									from
									until
										js.loop_done
									loop
										message_inst.msg_putchar ((' ').code)
										l_vcol := l_vcol + 1
										if not (l_vcol \\ 8).to_boolean then
											js.break
										end
									end
								else
									message_inst.msg_outtrans_len (create {CE_POINTER [NATURAL_8]}.make_cast (l_line_ga.item.ga_data) + l_line_ga.item.ga_len, 1).do_nothing
									l_vcol := l_vcol + (charset_inst.char2cells (l_c1))
								end
								l_line_ga.item.ga_len := (l_line_ga.item.ga_len) + 1
								l_escaped := 0
								screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
								l_pend := create {CE_POINTER [NATURAL_8]}.make_cast (l_line_ga.item.ga_data) + l_line_ga.item.ga_len
								if l_line_ga.item.ga_len > 0 then
									if (l_pend[-1]).to_integer_32 = 10 then
										if l_line_ga.item.ga_len <= 1 then
											l_line_ga.item.ga_len := (l_line_ga.item.ga_len) - 1
											l_pend := l_pend - 1
											l_pend.item := (('%/0/').code).to_natural_8
											js.break
										elseif (l_pend[-2]).to_integer_32 /= 92 then
											l_line_ga.item.ga_len := (l_line_ga.item.ga_len) - 1
											l_pend := l_pend - 1
											l_pend.item := (('%/0/').code).to_natural_8
											js.break
										end
									end
								end
							end
							l_pos := -1 + 6 -- back to loop condition
				when 40 then -- loop done
						globals_inst.no_mapping := globals_inst.no_mapping - 1
						globals_inst.allow_keys := globals_inst.allow_keys - 1
						globals_inst.msg_didout := 0
						globals_inst.msg_col := 0
						if globals_inst.msg_row.to_integer_32 < globals_inst.Rows.item - 1 then
							globals_inst.msg_row := globals_inst.msg_row + 1
						end
						globals_inst.emsg_on_display := 0
						if globals_inst.got_int.to_boolean then
							misc2_inst.ga_clear (l_line_ga)
						end
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_line_ga.item.ga_data))
				when 41 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	getexmodeline_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent getexmodeline)
		end

	globpath (a_path: CE_POINTER [NATURAL_8]; a_file: CE_POINTER [NATURAL_8]; a_expand_options: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_path: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_xpc: CE_ARRAY [PD_EXPAND]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_num_p: CE_ARRAY [INTEGER_32]
			l_p___0: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_cur: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			create l_path.make (<<1>>)
			create l_xpc.make (<<1>>)
			create l_buf___6.make
			create l_ga.make (<<1>>)
			create l_num_p.make (<<1>>)
			create l_p___0.make (<<1>>)
			create l_cur.make
			create l_tmp___1.make

			l_path.item := a_path
			l_cur := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_buf___6 := misc2_inst.alloc ({NATURAL_32} 4_096)
			if l_buf___6.is_void then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				ExpandInit (l_xpc)
				l_xpc.item.xp_context := 2
				misc2_inst.ga_init2 (l_ga, 1, 100)
				from
				until
					not (not js.loop_done and then ((l_path.item.item).to_integer_32 /= 0))
				loop
					misc2_inst.copy_option_part (l_path, l_buf___6, 4_096, ce_string (",")).do_nothing
					l_tmp___4 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))
					if (l_tmp___4 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_file)))) + {NATURAL_32} 2 < {NATURAL_32} 4_096 then
						misc1_inst.add_pathsep (l_buf___6)
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_file)).do_nothing
						if (ExpandFromContext (l_xpc, l_buf___6, l_num_p, l_p___0, (64).bit_or (a_expand_options))) /= 0 then
							if l_num_p.item > 0 then
								ExpandEscape (l_xpc, l_buf___6, l_num_p.item, l_p___0.item, (64).bit_or (a_expand_options))
								l_len := 0
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_num_p.item)
								loop
									l_len := l_len + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item[l_i___0]))).to_integer_32 + 1)
									l_i___0 := l_i___0 + 1
								end
								if (misc2_inst.ga_grow (l_ga, l_len)) = 1 then
									l_cur := create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len
									l_i___0 := 0
									from
									until
										not (l_i___0 < l_num_p.item)
									loop
										strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_cur), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item[l_i___0])).do_nothing
										l_cur := l_cur + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item[l_i___0]))).to_integer_32
										l_tmp___1 := l_cur
										l_cur := l_cur + 1
										l_tmp___1.item := (('%N').code).to_natural_8
										l_i___0 := l_i___0 + 1
									end
									l_ga.item.ga_len := l_ga.item.ga_len + l_len
								end
								misc1_inst.FreeWild (l_num_p.item, l_p___0.item)
							end
						end
					end
				end
				if not l_cur.is_void then
					l_cur := l_cur - 1
					l_cur.item := (0).to_natural_8
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data))
			end
		end

	gotocmdline (a_clr: INTEGER_32)
		do
			message_inst.msg_start
			globals_inst.msg_col := 0
			if a_clr.to_boolean then
				message_inst.msg_clr_eos
			end
			screen_inst.windgoto (globals_inst.cmdline_row, 0)
		end

	hist_char2type (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c = 58 then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_c = 61) then
				Result := 2
				js.return
			end
			if not js.return_called and then (a_c = 64) then
				Result := 3
				js.return
			end
			if not js.return_called and then (a_c = 62) then
				Result := 4
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	hist_type2char (a_type: INTEGER_32; a_use_question: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_type = 0 then
				Result := ((':').code)
				js.return
			end
			if not js.return_called and then (a_type = 1) then
				if a_use_question.to_boolean then
					Result := (('?').code)
					js.return
				else
					Result := (('/').code)
					js.return
				end
			end
			if not js.return_called and then (a_type = 2) then
				Result := (('=').code)
				js.return
			end
			if not js.return_called then
				Result := (('@').code)
			end
		end

	in_history (a_type: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_move_to_front: INTEGER_32): INTEGER_32
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_last_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_str___1.make

			l_str___1 := a_str___1
			l_last_i := -1
			if hisidx[a_type] < 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i___0 := hisidx[a_type]
				from
				until
					js.loop_done
				loop
					if ((history[a_type] + l_i___0).item.hisstr).is_void then
						Result := 0
						js.return
					end
					if not js.return_called then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1), create {CE_POINTER [INTEGER_8]}.make_cast ((history[a_type] + l_i___0).item.hisstr))) = 0 then
							if not a_move_to_front.to_boolean then
								Result := 1
								js.return
							end
							if not js.return_called then
								l_last_i := l_i___0
								js.break
							end
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 - 1
							if l_i___0 < 0 then
								l_i___0 := hislen - 1
							end
							if l_i___0 = hisidx[a_type] then
								js.break
							end
						end
					end
				end
			end
			if not js.return_called and then (l_last_i >= 0) then
				l_str___1 := (history[a_type] + l_i___0).item.hisstr
				from
				until
					l_i___0 = hisidx[a_type]
				loop
					l_i___0 := l_i___0 + 1
					if l_i___0 >= hislen then
						l_i___0 := 0
					end
					(history[a_type])[l_last_i] := ((history[a_type])[l_i___0]).twin
					l_last_i := l_i___0
				end
				(history[a_type] + l_i___0).item.hisstr := l_str___1
				hisnum[a_type] := (hisnum[a_type]) + 1;
				(history[a_type] + l_i___0).item.hisnum := hisnum[a_type]
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	init_history
		local
			l_newlen: INTEGER_32
			l_temp: CE_POINTER [PD_HIST_ENTRY]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_type: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_temp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newlen := (option_inst.p_hi.item).to_integer_32
					if l_newlen = hislen then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_type := 0
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_type < 5)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						if l_newlen.to_boolean then
							l_temp := create {CE_POINTER [PD_HIST_ENTRY]}.make_cast ((misc2_inst.lalloc ((l_newlen.to_natural_32 * (create {PD_HIST_ENTRY}.make).structure_size.to_natural_32).to_natural_32, 1)))
							if l_temp.is_void then
								if l_type = 0 then
									l_newlen := hislen
									js.break
								end
								if not js.loop_jumped then
									l_newlen := 0
									l_type := -1
									js.continue
								end
							end
						else
							l_temp := create {CE_POINTER [PD_HIST_ENTRY]}.make_shared (default_pointer)
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_newlen /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_temp.is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if hisidx[l_type] < 0 then
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_newlen)
							loop
								(l_temp + l_i___0).item.hisnum := 0;
								(l_temp + l_i___0).item.hisstr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								l_i___0 := l_i___0 + 1
							end
						elseif l_newlen > hislen then
							l_i___0 := 0
							from
							until
								not (l_i___0 <= hisidx[l_type])
							loop
								l_temp[l_i___0] := ((history[l_type])[l_i___0]).twin
								l_i___0 := l_i___0 + 1
							end
							l_j := l_i___0
							from
							until
								not (l_i___0 <= l_newlen - (hislen - hisidx[l_type]))
							loop
								(l_temp + l_i___0).item.hisnum := 0;
								(l_temp + l_i___0).item.hisstr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								l_i___0 := l_i___0 + 1
							end
							from
							until
								not (l_j < hislen)
							loop
								l_temp[l_i___0] := ((history[l_type])[l_j]).twin
								l_i___0 := l_i___0 + 1
								l_j := l_j + 1
							end
						else
							l_j := hisidx[l_type]
							l_i___0 := l_newlen - 1
							from
							until
								js.loop_done
							loop
								if l_i___0 >= 0 then
									l_temp[l_i___0] := ((history[l_type])[l_j]).twin
								else
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((history[l_type] + l_j).item.hisstr))
								end
								l_j := l_j - 1
								if l_j < 0 then
									l_j := hislen - 1
								end
								if l_j = hisidx[l_type] then
									js.break
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 - 1
								end
							end
							hisidx[l_type] := l_newlen - 1
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (history[l_type]))
						history[l_type] := l_temp
				when 9 then -- if done | if done
						if js.loop_increment then
							l_type := l_type + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						hislen := l_newlen
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nextwild (a_xp: CE_POINTER [PD_EXPAND]; a_type: INTEGER_32; a_options___0: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p1: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_difflen: INTEGER_32
			l_v: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p1.make
			create l_p2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_xp.item.xp_numfiles = -1 then
						set_expand_context (a_xp)
						cmd_showtail := expand_showtail (a_xp)
					end
					if a_xp.item.xp_context = -2 then
						misc1_inst.beep_flush
						Result := 1
						js.return
					end
					if not js.return_called and then (a_xp.item.xp_context = 0) then
						Result := 0
						js.return
					end
					if not js.return_called then
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("...")))
						term_inst.out_flush
						l_i___0 := (a_xp.item.xp_pattern).distance ((ccline.item.cmdbuff))
						a_xp.item.xp_pattern_len := ccline.item.cmdpos - l_i___0
						if a_type = 4 then
							l_p2 := ExpandOne (a_xp, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, a_type)
						elseif a_type = 5 then
							l_p2 := ExpandOne (a_xp, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, a_type)
						else
							l_p1 := addstar (a_xp.item.xp_pattern, a_xp.item.xp_pattern_len, a_xp.item.xp_context)
							if l_p1.is_void then
								l_p2 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							else
								l_p2 := ExpandOne (a_xp, l_p1, (misc2_inst.vim_strnsave (ccline.item.cmdbuff + l_i___0, a_xp.item.xp_pattern_len)), (210).bit_or (a_options___0), a_type)
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p1))
								if not l_p2.is_void then
									if a_type = 7 then
										l_j := 0
										from
										until
											not (not js.loop_done and then (l_j < a_xp.item.xp_pattern_len))
										loop
											if (ccline.item.cmdbuff[(l_i___0 + l_j)]).to_integer_32 = 42 then
												js.break
											elseif (ccline.item.cmdbuff[(l_i___0 + l_j)]).to_integer_32 = 63 then
												js.break
											end
											if not js.loop_jumped then
												l_j := l_j + 1
											end
										end
										if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p2))).to_integer_32 < l_j then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p2))
											l_p2 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
										end
									end
								end
							end
						end
						if not l_p2.is_void then
							if not globals_inst.got_int.to_boolean then
								l_difflen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p2))).to_integer_32 - a_xp.item.xp_pattern_len
								if (ccline.item.cmdlen + l_difflen) + 4 > ccline.item.cmdbufflen then
									l_v := realloc_cmdbuff ((ccline.item.cmdlen + l_difflen) + 4)
									a_xp.item.xp_pattern := ccline.item.cmdbuff + l_i___0
								else
									l_v := 1
								end
								if l_v = 1 then
									memmove (create {CE_POINTER [ANY]}.make_cast ((ccline.item.cmdbuff + (ccline.item.cmdpos + l_difflen))), create {CE_POINTER [ANY]}.make_cast ((ccline.item.cmdbuff + ccline.item.cmdpos)), ((ccline.item.cmdlen - ccline.item.cmdpos) + 1).to_natural_32).do_nothing
									memmove (create {CE_POINTER [ANY]}.make_cast ((ccline.item.cmdbuff + l_i___0)), create {CE_POINTER [ANY]}.make_cast (l_p2), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p2)))).do_nothing
									ccline.item.cmdlen := ccline.item.cmdlen + l_difflen
									ccline.item.cmdpos := ccline.item.cmdpos + l_difflen
								end
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p2))
						redrawcmd
						cursorcmd
						if a_xp.item.xp_context = 16 then
							if l_p2.is_void then
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_xp.item.xp_numfiles <= 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_p2.is_void then
							misc1_inst.beep_flush
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if a_xp.item.xp_numfiles = 1 then
							ExpandOne (a_xp, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 1).do_nothing
						end
				when 5 then
						Result := 1
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prepare_viminfo_history (a_asklen: INTEGER_32)
		local
			l_asklen: INTEGER_32
			l_i___0: INTEGER_32
			l_num: INTEGER_32
			l_type: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			l_asklen := a_asklen
			init_history
			viminfo_add_at_front := (l_asklen /= 0).to_integer
			if l_asklen > hislen then
				l_asklen := hislen
			end
			l_type := 0
			from
			until
				not (not js.loop_done and then (l_type < 5))
			loop
				l_i___0 := 0
				l_num := 0
				from
				until
					not (l_i___0 < hislen)
				loop
					if ((history[l_type] + l_i___0).item.hisstr).is_void then
						l_num := l_num + 1
					end
					l_i___0 := l_i___0 + 1
				end
				l_len := l_asklen
				if l_num > l_len then
					l_len := l_num
				end
				if l_len <= 0 then
					viminfo_history[l_type] := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
				else
					viminfo_history[l_type] := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.lalloc ((l_len.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32, 0)))
				end
				if (viminfo_history[l_type]).is_void then
					l_len := 0
				end
				viminfo_hislen[l_type] := l_len
				viminfo_hisidx[l_type] := 0
				l_type := l_type + 1
			end
		end

	put_on_cmdline (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_redraw: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_retval: INTEGER_32
			l_i___0: INTEGER_32
			l_m: INTEGER_32
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			l_len := a_len
			if l_len < 0 then
				l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1))).to_integer_32
			end
			if (ccline.item.cmdlen + l_len) + 1 >= ccline.item.cmdbufflen then
				l_retval := realloc_cmdbuff ((ccline.item.cmdlen + l_len) + 1)
			else
				l_retval := 1
			end
			if l_retval = 1 then
				if not (ccline.item.overstrike).to_boolean then
					memmove (create {CE_POINTER [ANY]}.make_cast (((ccline.item.cmdbuff + ccline.item.cmdpos) + l_len)), create {CE_POINTER [ANY]}.make_cast ((ccline.item.cmdbuff + ccline.item.cmdpos)), (ccline.item.cmdlen - ccline.item.cmdpos).to_natural_32).do_nothing
					ccline.item.cmdlen := ccline.item.cmdlen + l_len
				elseif globals_inst.has_mbyte.to_boolean then
					l_m := 0
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_len)
					loop
						l_m := l_m + 1
						l_i___0 := l_i___0 + (globals_inst.mb_ptr2len.integer_32_item ([a_str___1 + l_i___0]))
					end
					l_i___0 := ccline.item.cmdpos
					from
					until
						js.loop_done
					loop
						if l_i___0 < ccline.item.cmdlen then
							if not (l_m > 0) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_m := l_m - 1
							l_i___0 := l_i___0 + (globals_inst.mb_ptr2len.integer_32_item ([ccline.item.cmdbuff + l_i___0]))
						end
					end
					if l_i___0 < ccline.item.cmdlen then
						memmove (create {CE_POINTER [ANY]}.make_cast (((ccline.item.cmdbuff + ccline.item.cmdpos) + l_len)), create {CE_POINTER [ANY]}.make_cast ((ccline.item.cmdbuff + l_i___0)), (ccline.item.cmdlen - l_i___0).to_natural_32).do_nothing
						ccline.item.cmdlen := ccline.item.cmdlen + ((ccline.item.cmdpos + l_len) - l_i___0)
					else
						ccline.item.cmdlen := ccline.item.cmdpos + l_len
					end
				elseif ccline.item.cmdpos + l_len > ccline.item.cmdlen then
					ccline.item.cmdlen := ccline.item.cmdpos + l_len
				end
				memmove (create {CE_POINTER [ANY]}.make_cast ((ccline.item.cmdbuff + ccline.item.cmdpos)), create {CE_POINTER [ANY]}.make_cast (a_str___1), l_len.to_natural_32).do_nothing
				ccline.item.cmdbuff[ccline.item.cmdlen] := (('%/0/').code).to_natural_8
				if globals_inst.enc_utf8.to_boolean then
					l_i___0 := 0
					l_c := mbyte_inst.utf_ptr2char (ccline.item.cmdbuff + ccline.item.cmdpos)
					from
					until
						js.loop_done
					loop
						if ccline.item.cmdpos > 0 then
							if not (mbyte_inst.utf_iscomposing (l_c)).to_boolean then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := (globals_inst.mb_head_off.integer_32_item ([ccline.item.cmdbuff, (ccline.item.cmdbuff + ccline.item.cmdpos) - 1])) + 1
							ccline.item.cmdpos := ccline.item.cmdpos - l_i___0
							l_len := l_len + l_i___0
							l_c := mbyte_inst.utf_ptr2char (ccline.item.cmdbuff + ccline.item.cmdpos)
						end
					end
					if l_i___0 /= 0 then
						l_i___0 := charset_inst.ptr2cells (ccline.item.cmdbuff + ccline.item.cmdpos)
						ccline.item.cmdspos := ccline.item.cmdspos - l_i___0
						globals_inst.msg_col := globals_inst.msg_col - l_i___0
						if globals_inst.msg_col < 0 then
							globals_inst.msg_col := (globals_inst.msg_col.to_integer_32 + globals_inst.Columns.item).to_integer_32
							globals_inst.msg_row := globals_inst.msg_row - 1
						end
					end
				end
				if a_redraw.to_boolean then
					if not globals_inst.cmd_silent.to_boolean then
						globals_inst.msg_no_more := 1
						l_i___0 := globals_inst.cmdline_row
						draw_cmdline (ccline.item.cmdpos, ccline.item.cmdlen - ccline.item.cmdpos)
						if globals_inst.cmdline_row /= l_i___0 then
							message_inst.msg_clr_eos
						elseif (ccline.item.overstrike).to_boolean then
							message_inst.msg_clr_eos
						end
						globals_inst.msg_no_more := 0
					end
				end
				if globals_inst.KeyTyped.to_boolean then
					l_m := (globals_inst.Columns.item * globals_inst.Rows.item).to_integer_32
					if l_m < 0 then
						l_m := 2_147_483_647
					end
				else
					l_m := 2_147_483_647
				end
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_len)
				loop
					l_c := cmdline_charsize (ccline.item.cmdpos)
					if globals_inst.has_mbyte.to_boolean then
						correct_cmdspos (ccline.item.cmdpos, l_c)
					end
					if ccline.item.cmdspos + l_c < l_m then
						ccline.item.cmdspos := ccline.item.cmdspos + l_c
					end
					if globals_inst.has_mbyte.to_boolean then
						l_c := (globals_inst.mb_ptr2len.integer_32_item ([ccline.item.cmdbuff + ccline.item.cmdpos])) - 1
						if l_c > (l_len - l_i___0) - 1 then
							l_c := (l_len - l_i___0) - 1
						end
						ccline.item.cmdpos := ccline.item.cmdpos + l_c
						l_i___0 := l_i___0 + l_c
					end
					ccline.item.cmdpos := (ccline.item.cmdpos) + 1
					l_i___0 := l_i___0 + 1
				end
			end
			if a_redraw.to_boolean then
				message_inst.msg_check
			end
			Result := l_retval
		end

	putcmdline (a_c: INTEGER_32; a_shift: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if globals_inst.cmd_silent.to_boolean then
				js.return
			end
			if not js.return_called then
				globals_inst.msg_no_more := 1
				message_inst.msg_putchar (a_c)
				if a_shift.to_boolean then
					draw_cmdline (ccline.item.cmdpos, ccline.item.cmdlen - ccline.item.cmdpos)
				end
				globals_inst.msg_no_more := 0
				cursorcmd
			end
		end

	read_viminfo_history (a_virp: CE_POINTER [PD_VIR_T]): INTEGER_32
		local
			l_type: INTEGER_32
			l_len: NATURAL_32
			l_val___0: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			create l_val___0.make
			create l_p___0.make

			l_type := hist_char2type ((a_virp.item.vir_line[0]).to_integer_32)
			if viminfo_hisidx[l_type] < viminfo_hislen[l_type] then
				l_val___0 := ex_cmds_inst.viminfo_readstring (a_virp, 1, 1)
				if not l_val___0.is_void then
					if (l_val___0.item).to_integer_32 /= 0 then
						if not (in_history (l_type, l_val___0 + (l_type = 1).to_integer, viminfo_add_at_front)).to_boolean then
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_val___0))).to_natural_32
							l_p___0 := misc2_inst.lalloc (l_len + {NATURAL_32} 2, 1)
							if not l_p___0.is_void then
								if l_type = 1 then
									memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_val___0 + 1)), l_len.to_natural_32).do_nothing
									if (l_val___0.item).to_integer_32 = 32 then
										l_p___0[l_len.to_integer_32] := (('%/0/').code).to_natural_8
									else
										l_p___0[l_len.to_integer_32] := l_val___0.item
									end
								else
									memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_val___0), l_len.to_natural_32 + {NATURAL_32} 1).do_nothing
									l_p___0[(l_len + {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_natural_8
								end
								l_tmp___0 := viminfo_hisidx[l_type]
								viminfo_hisidx[l_type] := (viminfo_hisidx[l_type]) + 1;
								(viminfo_history[l_type])[l_tmp___0] := l_p___0
							end
						end
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_val___0))
			end
			Result := (ex_cmds_inst.viminfo_readline (a_virp))
		end

	realloc_cmdbuff (a_len: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			if a_len < ccline.item.cmdbufflen then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_p___0 := ccline.item.cmdbuff
				alloc_cmdbuff (a_len)
				if (ccline.item.cmdbuff).is_void then
					ccline.item.cmdbuff := l_p___0
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				memmove (create {CE_POINTER [ANY]}.make_cast (ccline.item.cmdbuff), create {CE_POINTER [ANY]}.make_cast (l_p___0), (ccline.item.cmdlen).to_natural_32).do_nothing
				ccline.item.cmdbuff[ccline.item.cmdlen] := (('%/0/').code).to_natural_8
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				if not (ccline.item.xpc).is_void then
					if not ((ccline.item.xpc).item.xp_pattern).is_void then
						if (ccline.item.xpc).item.xp_context /= 0 then
							if (ccline.item.xpc).item.xp_context /= -2 then
								l_i___0 := ((ccline.item.xpc).item.xp_pattern).distance (l_p___0)
								if l_i___0 >= 0 then
									if l_i___0 <= ccline.item.cmdlen then
										(ccline.item.xpc).item.xp_pattern := ccline.item.cmdbuff + l_i___0
									end
								end
							end
						end
					end
				end
				Result := 1
			end
		end

	redrawcmd
		local
			js: JUMP_STATE
		do
			if globals_inst.cmd_silent.to_boolean then
				js.return
			end
			if not js.return_called and then ((ccline.item.cmdbuff).is_void) then
				screen_inst.windgoto (globals_inst.cmdline_row, 0)
				message_inst.msg_clr_eos
				js.return
			end
			if not js.return_called then
				message_inst.msg_start
				redrawcmdprompt
				globals_inst.msg_no_more := 1
				draw_cmdline (0, ccline.item.cmdlen)
				message_inst.msg_clr_eos
				globals_inst.msg_no_more := 0
				set_cmdspos_cursor
				globals_inst.msg_scroll := 0
				globals_inst.skip_redraw := 0
			end
		end

	redrawcmd_preedit
		local
			l_cmdpos: INTEGER_32
			l_cmdspos: INTEGER_32
			l_old_row: INTEGER_32
			l_old_col: INTEGER_32
			l_col: INTEGER_32
			l_tmp: INTEGER_32
			l_char_len: INTEGER_32
			l_char_attr: INTEGER_32
			js: JUMP_STATE
		do
			if ((globals_inst.State).bit_and (8)).to_boolean then
				if not globals_inst.xic.is_void then
					if not (option_inst.p_imdisable.item).to_boolean then
						if (mbyte_inst.im_is_preediting).to_boolean then
							l_cmdpos := 0
							l_old_row := globals_inst.msg_row
							l_old_col := globals_inst.msg_col
							if ccline.item.cmdfirstc /= 0 then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_cmdspos := l_tmp + ccline.item.cmdindent
							if globals_inst.has_mbyte.to_boolean then
								l_col := 0
								from
								until
									js.loop_done
								loop
									if l_col < globals_inst.preedit_start_col.item then
										if not (l_cmdpos < ccline.item.cmdlen) then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_cmdspos := l_cmdspos + (globals_inst.mb_ptr2cells.integer_32_item ([ccline.item.cmdbuff + l_cmdpos]))
										l_cmdpos := l_cmdpos + (globals_inst.mb_ptr2len.integer_32_item ([ccline.item.cmdbuff + l_cmdpos]))
										l_col := l_col + 1
									end
								end
							else
								l_cmdspos := l_cmdspos + (globals_inst.preedit_start_col.item)
								l_cmdpos := l_cmdpos + (globals_inst.preedit_start_col.item)
							end
							globals_inst.msg_row := globals_inst.cmdline_row + l_cmdspos // (globals_inst.Columns.item).to_integer_32
							globals_inst.msg_col := l_cmdspos \\ (globals_inst.Columns.item).to_integer_32
							if globals_inst.msg_row.to_integer_32 >= globals_inst.Rows.item then
								globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
							end
							l_col := 0
							from
							until
								not (not js.loop_done and then (l_cmdpos < ccline.item.cmdlen))
							loop
								l_char_attr := mbyte_inst.im_get_feedback_attr (l_col)
								if l_char_attr < 0 then
									js.break
								end
								if not js.loop_jumped then
									if globals_inst.has_mbyte.to_boolean then
										l_char_len := globals_inst.mb_ptr2len.integer_32_item ([ccline.item.cmdbuff + l_cmdpos])
									else
										l_char_len := 1
									end
									message_inst.msg_outtrans_len_attr (ccline.item.cmdbuff + l_cmdpos, l_char_len, l_char_attr).do_nothing
									l_cmdpos := l_cmdpos + l_char_len
									l_col := l_col + 1
								end
							end
							globals_inst.msg_row := l_old_row
							globals_inst.msg_col := l_old_col
						end
					end
				end
			end
		end

	redrawcmdline
		local
			js: JUMP_STATE
		do
			if globals_inst.cmd_silent.to_boolean then
				js.return
			end
			if not js.return_called then
				globals_inst.need_wait_return := 0
				compute_cmdrow
				redrawcmd
				cursorcmd
			end
		end

	redrawcmdprompt
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.cmd_silent.to_boolean then
				js.return
			end
			if not js.return_called then
				if ccline.item.cmdfirstc /= 0 then
					message_inst.msg_putchar (ccline.item.cmdfirstc)
				end
				if not (ccline.item.cmdprompt).is_void then
					message_inst.msg_puts_attr (ccline.item.cmdprompt, ccline.item.cmdattr)
					ccline.item.cmdindent := (globals_inst.msg_col.to_integer_32 + (globals_inst.msg_row - globals_inst.cmdline_row).to_integer_32 * globals_inst.Columns.item).to_integer_32
					if ccline.item.cmdfirstc /= 0 then
						ccline.item.cmdindent := (ccline.item.cmdindent) - 1
					end
				else
					l_i___0 := ccline.item.cmdindent
					from
					until
						not (l_i___0 > 0)
					loop
						message_inst.msg_putchar ((' ').code)
						l_i___0 := l_i___0 - 1
					end
				end
			end
		end

	remove_key_from_history
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_i___0 := hisidx[0]
			if l_i___0 < 0 then
				js.return
			end
			if not js.return_called then
				l_p___0 := (history[0] + l_i___0).item.hisstr
				if not l_p___0.is_void then
					from
					until
						not (not js.loop_done and then ((l_p___0.item).to_boolean))
					loop
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("key"), (3).to_natural_32)) = 0 then
							if not ((((ctype_b_loc).item[(l_p___0[3]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
								l_p___0 := misc2_inst.vim_strchr (l_p___0 + 3, ('=').code)
								if l_p___0.is_void then
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 + 1
									l_i___0 := 0
									from
									until
										js.loop_done
									loop
										if (l_p___0[l_i___0]).to_boolean then
											if (l_p___0[l_i___0]).to_integer_32 = 32 then
												js.break
											elseif (l_p___0[l_i___0]).to_integer_32 = 9 then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											if (l_p___0[l_i___0]).to_integer_32 = 92 then
												if (l_p___0[(l_i___0 + 1)]).to_boolean then
													l_i___0 := l_i___0 + 1
												end
											end
											l_i___0 := l_i___0 + 1
										end
									end
									memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_i___0)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_i___0)))) + {NATURAL_32} 1).do_nothing
									l_p___0 := l_p___0 - 1
								end
							end
						end
						if not js.loop_jumped then
							l_p___0 := l_p___0 + 1
						end
					end
				end
			end
		end

	restore_cmdline (a_ccp: CE_POINTER [PD_CMDLINE_INFO])
		do
			ccline.item := (prev_ccline.item).twin
			prev_ccline.item := (a_ccp.item).twin
		end

	restore_cmdline_alloc (a_p___0: CE_POINTER [NATURAL_8])
		do
			if not a_p___0.is_void then
				restore_cmdline (create {CE_POINTER [PD_CMDLINE_INFO]}.make_cast (a_p___0))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_p___0))
			end
		end

	save_cmdline (a_ccp: CE_POINTER [PD_CMDLINE_INFO])
		do
			if not prev_ccline_used.to_boolean then
				memset (create {CE_POINTER [ANY]}.make_cast (prev_ccline), 0, (create {PD_CMDLINE_INFO}.make).structure_size.to_natural_32).do_nothing
				prev_ccline_used := 1
			end
			a_ccp.item := (prev_ccline.item).twin
			prev_ccline.item := (ccline.item).twin
			ccline.item.cmdbuff := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			ccline.item.cmdprompt := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			ccline.item.xpc := create {CE_POINTER [PD_EXPAND]}.make_shared (default_pointer)
		end

	save_cmdline_alloc: CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
		do
			create l_p___0.make

			l_p___0 := create {CE_POINTER [PD_CMDLINE_INFO]}.make_cast ((misc2_inst.alloc ((create {PD_CMDLINE_INFO}.make).structure_size.to_natural_32)))
			if not l_p___0.is_void then
				save_cmdline (l_p___0)
			end
			Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0))
		end

	script_get (a_eap: CE_POINTER [PD_EXARG]; a_cmd: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_theline: CE_POINTER [NATURAL_8]
			l_end_pattern: CE_POINTER [INTEGER_8]
			l_dot: CE_ARRAY [INTEGER_8]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_theline.make
			create l_end_pattern.make
			create l_dot.make (<<2>>)
			create l_ga.make (<<1>>)

			l_end_pattern := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_dot[0] := (('.').code).to_integer_8
			l_dot[1] := (('%/0/').code).to_integer_8
			if (a_cmd[0]).to_integer_32 /= 60 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			elseif (a_cmd[1]).to_integer_32 /= 60 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			elseif (a_eap.item.getline).is_void then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				misc2_inst.ga_init2 (l_ga, 1, 1_024)
				if (a_cmd[2]).to_integer_32 /= 0 then
					l_end_pattern := create {CE_POINTER [INTEGER_8]}.make_cast ((charset_inst.skipwhite (a_cmd + 2)))
				else
					l_end_pattern := l_dot
				end
				from
				until
					js.loop_done
				loop
					if (a_eap.item.cstack).item.cs_looplevel > 0 then
						l_tmp___0 := -1
					else
						l_tmp___0 := ('%/0/').code
					end
					l_theline := create {CE_POINTER [NATURAL_8]}.make_cast ((a_eap.item.getline).pointer_item ([l_tmp___0, a_eap.item.cookie, 0]))
					if l_theline.is_void then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_theline))
						js.break
					elseif (strcmp (l_end_pattern, create {CE_POINTER [INTEGER_8]}.make_cast (l_theline))) = 0 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_theline))
						js.break
					end
					if not js.loop_jumped then
						misc2_inst.ga_concat (l_ga, l_theline)
						misc2_inst.ga_append (l_ga, ('%N').code)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_theline))
					end
				end
				misc2_inst.ga_append (l_ga, ('%/0/').code)
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data))
			end
		end

	set_cmd_context (a_xp: CE_POINTER [PD_EXPAND]; a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_col: INTEGER_32)
		local
			l_old_char___0: INTEGER_32
			l_nextcomm: CE_POINTER [NATURAL_8]
		do
			create l_nextcomm.make

			l_old_char___0 := ('%/0/').code
			if a_col < a_len then
				l_old_char___0 := (a_str___1[a_col]).to_integer_32
			end
			a_str___1[a_col] := (('%/0/').code).to_natural_8
			l_nextcomm := a_str___1
			if ccline.item.cmdfirstc = 61 then
				eval_inst.set_context_for_expression (a_xp, a_str___1, {PC_CMD_INDEX}.CMD_SIZE)
			elseif (ccline.item.input_fn).to_boolean then
				a_xp.item.xp_context := ccline.item.xp_context
				a_xp.item.xp_pattern := ccline.item.cmdbuff
				a_xp.item.xp_arg := ccline.item.xp_arg
			else
				from
				until
					l_nextcomm.is_void
				loop
					l_nextcomm := ex_docmd_inst.set_one_cmd_context (a_xp, l_nextcomm)
				end
			end
			a_str___1[a_col] := l_old_char___0.to_natural_8
		end

	set_cmdline_pos (a_pos___3: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0 := (get_ccline_ptr)
			if l_p___0.is_void then
				Result := 1
				js.return
			end
			if not js.return_called then
				if a_pos___3 < 0 then
					new_cmdpos := 0
				else
					new_cmdpos := a_pos___3
				end
				Result := 0
			end
		end

	set_cmdspos
		do
			if ccline.item.cmdfirstc /= 0 then
				ccline.item.cmdspos := 1 + ccline.item.cmdindent
			else
				ccline.item.cmdspos := ccline.item.cmdindent
			end
		end

	set_cmdspos_cursor
		local
			l_i___0: INTEGER_32
			l_m: INTEGER_32
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			set_cmdspos
			if globals_inst.KeyTyped.to_boolean then
				l_m := (globals_inst.Columns.item * globals_inst.Rows.item).to_integer_32
				if l_m < 0 then
					l_m := 2_147_483_647
				end
			else
				l_m := 2_147_483_647
			end
			l_i___0 := 0
			from
			until
				js.loop_done
			loop
				if l_i___0 < ccline.item.cmdlen then
					if not (l_i___0 < ccline.item.cmdpos) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_c := cmdline_charsize (l_i___0)
					if globals_inst.has_mbyte.to_boolean then
						correct_cmdspos (l_i___0, l_c)
					end
					ccline.item.cmdspos := ccline.item.cmdspos + l_c
					if ccline.item.cmdspos >= l_m then
						ccline.item.cmdspos := ccline.item.cmdspos - l_c
						js.break
					end
				end
				if not js.loop_jumped then
					if globals_inst.has_mbyte.to_boolean then
						l_i___0 := l_i___0 + ((globals_inst.mb_ptr2len.integer_32_item ([ccline.item.cmdbuff + l_i___0])) - 1)
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	set_expand_context (a_xp: CE_POINTER [PD_EXPAND])
		local
			js: JUMP_STATE
		do
			if ccline.item.cmdfirstc /= 58 then
				if ccline.item.cmdfirstc /= 62 then
					if ccline.item.cmdfirstc /= 61 then
						if not (ccline.item.input_fn).to_boolean then
							a_xp.item.xp_context := 0
							js.return
						end
					end
				end
			end
			if not js.return_called then
				set_cmd_context (a_xp, ccline.item.cmdbuff, ccline.item.cmdlen, ccline.item.cmdpos)
			end
		end

	showmatches (a_xp: CE_POINTER [PD_EXPAND]; a_wildmenu: INTEGER_32): INTEGER_32
		local
			l_num_files: CE_ARRAY [INTEGER_32]
			l_files_found: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_maxlen: INTEGER_32
			l_lines___0: INTEGER_32
			l_columns: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_lastlen: INTEGER_32
			l_attr: INTEGER_32
			l_showtail: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_halved_slash: CE_POINTER [NATURAL_8]
			l_exp_path: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_num_files.make (<<1>>)
			create l_files_found.make (<<1>>)
			create l_p___0.make
			create l_tmp___0.make
			create l_halved_slash.make
			create l_exp_path.make
			create l_tmp___4.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_xp.item.xp_numfiles = -1 then
						set_expand_context (a_xp)
						l_i___0 := expand_cmdline (a_xp, ccline.item.cmdbuff, ccline.item.cmdpos, l_num_files, l_files_found)
						l_showtail := expand_showtail (a_xp)
						if l_i___0 /= -1 then
							Result := l_i___0
							js.return
						end
					else
						l_num_files.item := a_xp.item.xp_numfiles
						l_files_found.item := a_xp.item.xp_files
						l_showtail := cmd_showtail
					end
					if js.return_called then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						if not a_wildmenu.to_boolean then
							globals_inst.msg_didany := 0
							message_inst.msg_start
							message_inst.msg_putchar (('%N').code)
							term_inst.out_flush
							globals_inst.cmdline_row := globals_inst.msg_row
							globals_inst.msg_didany := 0
							message_inst.msg_start
						end
						if not (globals_inst.got_int.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						globals_inst.got_int := 0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 4 then -- else:
						if not (a_wildmenu.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						screen_inst.win_redr_status_matches (a_xp, l_num_files.item, l_files_found.item, 0, l_showtail)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 7 then -- else:
						l_maxlen := 0
						l_i___0 := 0
				when 8 then -- loop condition:
						if not (l_i___0 < l_num_files.item) then
							l_pos := -1 + 14 -- skip loop
						end
				when 9 then -- loop body:
						if l_showtail.to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_xp.item.xp_context = 2 then
							misc1_inst.home_replace (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_files_found.item[l_i___0], globals_inst.NameBuff.item, 4_096, 1)
							l_j := charset_inst.vim_strsize (globals_inst.NameBuff.item)
						elseif a_xp.item.xp_context = 32 then
							misc1_inst.home_replace (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_files_found.item[l_i___0], globals_inst.NameBuff.item, 4_096, 1)
							l_j := charset_inst.vim_strsize (globals_inst.NameBuff.item)
						elseif a_xp.item.xp_context = 9 then
							misc1_inst.home_replace (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_files_found.item[l_i___0], globals_inst.NameBuff.item, 4_096, 1)
							l_j := charset_inst.vim_strsize (globals_inst.NameBuff.item)
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if l_showtail.to_boolean then
							l_tmp___0 := (sm_gettail (l_files_found.item[l_i___0]))
						else
							l_tmp___0 := l_files_found.item[l_i___0]
						end
						l_j := charset_inst.vim_strsize (l_tmp___0)
				when 13 then
						if l_j > l_maxlen then
							l_maxlen := l_j
						end
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 8 -- back to loop condition
				when 14 then -- loop done
						if a_xp.item.xp_context = 17 then
							l_lines___0 := l_num_files.item
						else
							l_maxlen := l_maxlen + (2)
							l_columns := ((globals_inst.Columns.item).to_integer_32 + 2) // l_maxlen
							if l_columns < 1 then
								l_columns := 1
							end
							l_lines___0 := ((l_num_files.item + l_columns) - 1) // l_columns
						end
						l_attr := globals_inst.highlight_attr[2]
						if a_xp.item.xp_context = 17 then
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("tagname")))), globals_inst.highlight_attr[14])
							message_inst.msg_clr_eos
							message_inst.msg_advance (l_maxlen - 3)
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" kind file%N")))), globals_inst.highlight_attr[14])
						end
						l_i___0 := 0
				when 15 then -- loop condition:
						if not (not js.loop_done and then (l_i___0 < l_lines___0)) then
							l_pos := -1 + 32 -- skip loop
						end
				when 16 then -- loop body:
						l_lastlen := 999
						l_k := l_i___0
				when 17 then -- loop condition:
						if not (not js.loop_done and then (l_k < l_num_files.item)) then
							l_pos := -1 + 31 -- skip loop
						end
				when 18 then -- loop body:
						if a_xp.item.xp_context = 17 then
							message_inst.msg_outtrans_attr (l_files_found.item[l_k], globals_inst.highlight_attr[2]).do_nothing
							l_p___0 := (l_files_found.item[l_k] + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_files_found.item[l_k]))).to_integer_32) + 1
							message_inst.msg_advance (l_maxlen + 1)
							message_inst.msg_puts (l_p___0)
							message_inst.msg_advance (l_maxlen + 3)
							message_inst.msg_puts_long_attr (l_p___0 + 2, globals_inst.highlight_attr[2])
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 30 -- skip if block
						end
				when 19 then -- if:
						l_j := l_maxlen - l_lastlen
						from
						until
							js.loop_done
						loop
							l_j := l_j - 1
							if not (l_j >= 0) then
								js.break
							end
							if not js.loop_jumped then
								message_inst.msg_putchar ((' ').code)
							end
						end
						if a_xp.item.xp_context /= 2 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else:
						if a_xp.item.xp_context /= 32 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 25 then -- else:
						if a_xp.item.xp_context /= 9 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L___0:
						if a_xp.item.xp_numfiles /= -1 then
							l_exp_path := misc1_inst.expand_env_save_opt (l_files_found.item[l_k], 1)
							if not l_exp_path.is_void then
								l_tmp___4 := l_exp_path
							else
								l_tmp___4 := l_files_found.item[l_k]
							end
							l_halved_slash := charset_inst.backslash_halve_save (l_tmp___4)
							if not l_halved_slash.is_void then
								l_tmp___5 := l_halved_slash
							else
								l_tmp___5 := l_files_found.item[l_k]
							end
							l_j := os_unix_inst.mch_isdir (l_tmp___5)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_exp_path))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_halved_slash))
						else
							l_j := os_unix_inst.mch_isdir (l_files_found.item[l_k])
						end
						if l_showtail.to_boolean then
							if l_showtail.to_boolean then
								l_p___0 := (sm_gettail (l_files_found.item[l_k]))
							else
								l_p___0 := l_files_found.item[l_k]
							end
						else
							misc1_inst.home_replace (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_files_found.item[l_k], globals_inst.NameBuff.item, 4_096, 1)
							l_p___0 := globals_inst.NameBuff.item
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_j := 0
						if l_showtail.to_boolean then
							l_p___0 := (sm_gettail (l_files_found.item[l_k]))
						else
							l_p___0 := l_files_found.item[l_k]
						end
				when 29 then -- if done | if done
						if l_j.to_boolean then
							l_tmp___8 := l_attr
						else
							l_tmp___8 := 0
						end
						l_lastlen := message_inst.msg_outtrans_attr (l_p___0, l_tmp___8)
						l_k := l_k + l_lines___0
				when 30 then -- if done
						l_pos := -1 + 17 -- back to loop condition
				when 31 then -- loop done
						if globals_inst.msg_col > 0 then
							message_inst.msg_clr_eos
							message_inst.msg_putchar (('%N').code)
						end
						term_inst.out_flush
						if globals_inst.got_int.to_boolean then
							globals_inst.got_int := 0
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 15 -- back to loop condition
				when 32 then -- loop done
						globals_inst.cmdline_row := globals_inst.msg_row
				when 33 then -- if done | if done
						if a_xp.item.xp_numfiles = -1 then
							misc1_inst.FreeWild (l_num_files.item, l_files_found.item)
						end
						Result := (-1)
				when 34 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sm_gettail (a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_t: CE_POINTER [NATURAL_8]
			l_had_sep: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			create l_p___0.make
			create l_t.make

			l_t := a_s
			l_had_sep := 0
			l_p___0 := a_s
			from
			until
				(l_p___0.item).to_integer_32 = 0
			loop
				if (misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
					l_had_sep := 1
				elseif l_had_sep.to_boolean then
					l_t := l_p___0
					l_had_sep := 0
				end
				if globals_inst.has_mbyte.to_boolean then
					l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
				else
					l_tmp___1 := 1
				end
				l_p___0 := l_p___0 + l_tmp___1
			end
			Result := l_t
		end

	text_locked: INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.cmdwin_type /= 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (globals_inst.textlock /= 0).to_integer
			end
		end

	text_locked_msg
		do
			if globals_inst.cmdwin_type /= 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_cmdwin))))).do_nothing
			else
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_secure))))).do_nothing
			end
		end

	tilde_replace (a_orig_pat: CE_POINTER [NATURAL_8]; a_num_files: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			if (a_orig_pat[0]).to_integer_32 = 126 then
				if (misc1_inst.vim_ispathsep ((a_orig_pat[1]).to_integer_32)).to_boolean then
					l_i___0 := 0
					from
					until
						not (l_i___0 < a_num_files)
					loop
						l_p___0 := misc1_inst.home_replace_save (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_files[l_i___0])
						if not l_p___0.is_void then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_files[l_i___0]))
							a_files[l_i___0] := l_p___0
						end
						l_i___0 := l_i___0 + 1
					end
				end
			end
		end

	unputcmdline
		local
			js: JUMP_STATE
		do
			if globals_inst.cmd_silent.to_boolean then
				js.return
			end
			if not js.return_called then
				globals_inst.msg_no_more := 1
				if ccline.item.cmdlen = ccline.item.cmdpos then
					message_inst.msg_putchar ((' ').code)
				else
					draw_cmdline (ccline.item.cmdpos, 1)
				end
				globals_inst.msg_no_more := 0
				cursorcmd
			end
		end

	vim_strsave_fnameescape (a_fname: CE_POINTER [NATURAL_8]; a_shell: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make (<<1>>)
			create l_tmp.make
			create l_s.make

			if a_shell.to_boolean then
				l_tmp := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T%N*?[{`$\%%#%'%"|!<>();&"))
			else
				l_tmp := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T%N*?[{`$\%%#%'%"|!<"))
			end
			l_p___0.item := misc2_inst.vim_strsave_escaped (a_fname, l_tmp)
			if a_shell.to_boolean then
				if (misc2_inst.csh_like_shell).to_boolean then
					if not (l_p___0.item).is_void then
						l_s := misc2_inst.vim_strsave_escaped (l_p___0.item, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("!")))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0.item))
						l_p___0.item := l_s
					end
				end
			end
			if not (l_p___0.item).is_void then
				if (l_p___0.item.item).to_integer_32 = 62 then
					escape_fname (l_p___0)
				elseif (l_p___0.item.item).to_integer_32 = 43 then
					escape_fname (l_p___0)
				elseif (l_p___0.item.item).to_integer_32 = 45 then
					if (l_p___0.item[1]).to_integer_32 = 0 then
						escape_fname (l_p___0)
					end
				end
			end
			Result := (l_p___0.item)
		end

	write_viminfo_history (a_fp: CE_POINTER [SD_IO_FILE])
		local
			l_i___0: INTEGER_32
			l_type: INTEGER_32
			l_num_saved: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make

			init_history
			if hislen = 0 then
				js.return
			end
			if not js.return_called then
				l_type := 0
				from
				until
					not (not js.loop_done and then (l_type < 5))
				loop
					l_num_saved := option_inst.get_viminfo_parameter ((hist_type2char (l_type, 0)))
					if l_num_saved = 0 then
						js.continue
					end
					if not js.loop_jumped then
						if l_num_saved < 0 then
							l_num_saved := hislen
						end
						if l_type = 0 then
							l_tmp___6 := (gettext (ce_string ("Command Line")))
						else
							if l_type = 1 then
								l_tmp___5 := (gettext (ce_string ("Search String")))
							else
								if l_type = 2 then
									l_tmp___4 := (gettext (ce_string ("Expression")))
								else
									l_tmp___4 := (gettext (ce_string ("Input Line")))
								end
								l_tmp___5 := l_tmp___4
							end
							l_tmp___6 := l_tmp___5
						end
						fprintf ([a_fp, (gettext (ce_string ("%N# %%s History (newest to oldest):%N"))), l_tmp___6]).do_nothing
						if l_num_saved > hislen then
							l_num_saved := hislen
						end
						l_i___0 := hisidx[l_type]
						if l_i___0 >= 0 then
							from
							until
								js.loop_done
							loop
								l_tmp___11 := l_num_saved
								l_num_saved := l_num_saved - 1
								if not l_tmp___11.to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := (history[l_type] + l_i___0).item.hisstr
									if not l_p___0.is_void then
										fputc ((hist_type2char (l_type, 1)), a_fp).do_nothing
										if l_type = 1 then
											l_c := (l_p___0[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1).to_integer_32]).to_integer_32
											if l_c = 0 then
												l_tmp___10 := (' ').code
											else
												l_tmp___10 := l_c
											end
											IO_putc (l_tmp___10, a_fp).do_nothing
										end
										ex_cmds_inst.viminfo_writestring (a_fp, l_p___0)
									end
									l_i___0 := l_i___0 - 1
									if l_i___0 < 0 then
										l_i___0 := hislen - 1
									end
								end
							end
						end
					end
					if js.loop_increment then
						l_type := l_type + 1
					end
				end
			end
		end

end
