class
	P_MESSAGE

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create buf___0.make (<<7>>)
			create confirm_msg.make
			create confirm_msg_tail.make
			create e_printf.make
			create first_msg_hist.make
			create last_dir.make
			create last_msg_hist.make
			create last_msgchunk.make
			create last_sourcing_name.make
			create rs.make
			create str.make
			create verbose_fd.make
		end

feature {ANY} -- attributes

	buf___0: CE_ARRAY [NATURAL_8]

	confirm_msg: CE_POINTER [NATURAL_8] assign set_confirm_msg

	set_confirm_msg (a_confirm_msg: CE_POINTER [NATURAL_8])
		do
			confirm_msg := a_confirm_msg
		end

	confirm_msg_tail: CE_POINTER [NATURAL_8] assign set_confirm_msg_tail

	set_confirm_msg_tail (a_confirm_msg_tail: CE_POINTER [NATURAL_8])
		do
			confirm_msg_tail := a_confirm_msg_tail
		end

	confirm_msg_used: INTEGER_32 assign set_confirm_msg_used

	set_confirm_msg_used (a_confirm_msg_used: INTEGER_32)
		do
			confirm_msg_used := a_confirm_msg_used
		end

	cur_col: INTEGER_32 assign set_cur_col

	set_cur_col (a_cur_col: INTEGER_32)
		do
			cur_col := a_cur_col
		end

	cur_col___0: INTEGER_32 assign set_cur_col___0

	set_cur_col___0 (a_cur_col___0: INTEGER_32)
		do
			cur_col___0 := a_cur_col___0
		end

	do_clear_sb_text: INTEGER_32 assign set_do_clear_sb_text

	set_do_clear_sb_text (a_do_clear_sb_text: INTEGER_32)
		do
			do_clear_sb_text := a_do_clear_sb_text
		end

	e_printf: CE_POINTER [INTEGER_8] assign set_e_printf

	set_e_printf (a_e_printf: CE_POINTER [INTEGER_8])
		do
			e_printf := a_e_printf
		end

	entered___1: INTEGER_32 assign set_entered___1

	set_entered___1 (a_entered___1: INTEGER_32)
		do
			entered___1 := a_entered___1
		end

	first_msg_hist: CE_POINTER [PD_MSG_HIST] assign set_first_msg_hist

	set_first_msg_hist (a_first_msg_hist: CE_POINTER [PD_MSG_HIST])
		do
			first_msg_hist := a_first_msg_hist
		end

	last_dir: CE_POINTER [NATURAL_8] assign set_last_dir

	set_last_dir (a_last_dir: CE_POINTER [NATURAL_8])
		do
			last_dir := a_last_dir
		end

	last_msg_hist: CE_POINTER [PD_MSG_HIST] assign set_last_msg_hist

	set_last_msg_hist (a_last_msg_hist: CE_POINTER [PD_MSG_HIST])
		do
			last_msg_hist := a_last_msg_hist
		end

	last_msgchunk: CE_POINTER [PD_MSGCHUNK_S] assign set_last_msgchunk

	set_last_msgchunk (a_last_msgchunk: CE_POINTER [PD_MSGCHUNK_S])
		do
			last_msgchunk := a_last_msgchunk
		end

	last_sourcing_lnum: INTEGER_32 assign set_last_sourcing_lnum

	set_last_sourcing_lnum (a_last_sourcing_lnum: INTEGER_32)
		do
			last_sourcing_lnum := a_last_sourcing_lnum
		end

	last_sourcing_name: CE_POINTER [NATURAL_8] assign set_last_sourcing_name

	set_last_sourcing_name (a_last_sourcing_name: CE_POINTER [NATURAL_8])
		do
			last_sourcing_name := a_last_sourcing_name
		end

	msg_hist_len: INTEGER_32 assign set_msg_hist_len

	set_msg_hist_len (a_msg_hist_len: INTEGER_32)
		do
			msg_hist_len := a_msg_hist_len
		end

	rs: CE_POINTER [NATURAL_8] assign set_rs

	set_rs (a_rs: CE_POINTER [NATURAL_8])
		do
			rs := a_rs
		end

	str: CE_POINTER [NATURAL_8] assign set_str

	set_str (a_str: CE_POINTER [NATURAL_8])
		do
			str := a_str
		end

	verbose_did_open: INTEGER_32 assign set_verbose_did_open

	set_verbose_did_open (a_verbose_did_open: INTEGER_32)
		do
			verbose_did_open := a_verbose_did_open
		end

	verbose_fd: CE_POINTER [SD_IO_FILE] assign set_verbose_fd

	set_verbose_fd (a_verbose_fd: CE_POINTER [SD_IO_FILE])
		do
			verbose_fd := a_verbose_fd
		end

feature {ANY} -- routines

	add_msg_hist (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_attr: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_p___0: CE_POINTER [PD_MSG_HIST]
			js: JUMP_STATE
		do
			create l_s.make
			create l_p___0.make

			l_s := a_s
			l_len := a_len
			if globals_inst.msg_hist_off.to_boolean then
				js.return
			elseif globals_inst.msg_silent /= 0 then
				js.return
			end
			if not js.return_called then
				from
				until
					not (msg_hist_len > 200)
				loop
					delete_first_msg.do_nothing
				end
				l_p___0 := create {CE_POINTER [PD_MSG_HIST]}.make_cast ((misc2_inst.alloc ((((create {PD_MSG_HIST}.make).structure_size.to_natural_32).to_integer_32).to_natural_32)))
				if not l_p___0.is_void then
					if l_len < 0 then
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
					end
					from
					until
						js.loop_done
					loop
						if l_len > 0 then
							if (l_s.item).to_integer_32 /= 10 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_s := l_s + 1
							l_len := l_len - 1
						end
					end
					from
					until
						js.loop_done
					loop
						if l_len > 0 then
							if (l_s[(l_len - 1)]).to_integer_32 /= 10 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_len := l_len - 1
						end
					end
					l_p___0.item.msg := misc2_inst.vim_strnsave (l_s, l_len)
					l_p___0.item.next := create {CE_POINTER [PD_MSG_HIST]}.make_shared (default_pointer)
					l_p___0.item.attr := a_attr
					if not last_msg_hist.is_void then
						last_msg_hist.item.next := l_p___0
					end
					last_msg_hist := l_p___0
					if first_msg_hist.is_void then
						first_msg_hist := last_msg_hist
					end
					msg_hist_len := msg_hist_len + 1
				end
			end
		end

	clear_sb_text
		local
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
		do
			create l_mp.make

			from
			until
				last_msgchunk.is_void
			loop
				l_mp := last_msgchunk.item.sb_prev
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (last_msgchunk))
				last_msgchunk := l_mp
			end
		end

	copy_char (a_from: CE_POINTER [NATURAL_8]; a_to: CE_POINTER [NATURAL_8]; a_lowercase: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_c: INTEGER_32
		do
			if globals_inst.has_mbyte.to_boolean then
				if a_lowercase.to_boolean then
					l_c := charset_inst.vim_tolower ((globals_inst.mb_ptr2char.integer_32_item ([a_from])))
					Result := (globals_inst.mb_char2bytes.integer_32_item ([l_c, a_to]))
				else
					l_len := globals_inst.mb_ptr2len.integer_32_item ([a_from])
					memmove (create {CE_POINTER [ANY]}.make_cast (a_to), create {CE_POINTER [ANY]}.make_cast (a_from), l_len.to_natural_32).do_nothing
					Result := l_len
				end
			else
				if a_lowercase.to_boolean then
					a_to.item := (tolower ((a_from.item).to_integer_32)).to_natural_8
				else
					a_to.item := a_from.item
				end
				Result := 1
			end
		end

	delete_first_msg: INTEGER_32
		local
			l_p___0: CE_POINTER [PD_MSG_HIST]
			js: JUMP_STATE
		do
			create l_p___0.make

			if msg_hist_len <= 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_p___0 := first_msg_hist
				first_msg_hist := l_p___0.item.next
				if first_msg_hist.is_void then
					last_msg_hist := create {CE_POINTER [PD_MSG_HIST]}.make_shared (default_pointer)
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0.item.msg))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				msg_hist_len := msg_hist_len - 1
				Result := 1
			end
		end

	disp_sb_line (a_row: INTEGER_32; a_smp: CE_POINTER [PD_MSGCHUNK_S]): CE_POINTER [PD_MSGCHUNK_S]
		local
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_mp.make
			create l_p___0.make

			l_mp := a_smp
			from
			until
				js.loop_done
			loop
				globals_inst.msg_row := a_row
				globals_inst.msg_col := l_mp.item.sb_msg_col
				l_p___0 := l_mp.item.sb_text
				if (l_p___0.item).to_integer_32 = 10 then
					l_p___0 := l_p___0 + 1
				end
				msg_puts_display (l_p___0, -1, l_mp.item.sb_attr, 1)
				if (l_mp.item.sb_eol).to_boolean then
					js.break
				elseif (l_mp.item.sb_next).is_void then
					js.break
				end
				if not js.loop_jumped then
					l_mp := l_mp.item.sb_next
				end
			end
			Result := (l_mp.item.sb_next)
		end

	display_confirm_msg
		do
			confirm_msg_used := confirm_msg_used + 1
			if not confirm_msg.is_void then
				msg_puts_attr (confirm_msg, globals_inst.highlight_attr[7])
			end
			confirm_msg_used := confirm_msg_used - 1
		end

	do_browse (a_flags___0: INTEGER_32; a_title: CE_POINTER [NATURAL_8]; a_dflt: CE_POINTER [NATURAL_8]; a_ext: CE_POINTER [NATURAL_8]; a_initdir: CE_POINTER [NATURAL_8]; a_filter: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): CE_POINTER [NATURAL_8]
		local
			l_title: CE_POINTER [NATURAL_8]
			l_dflt: CE_POINTER [NATURAL_8]
			l_initdir: CE_POINTER [NATURAL_8]
			l_filter: CE_POINTER [NATURAL_8]
			l_fname: CE_POINTER [NATURAL_8]
			l_tofree: CE_POINTER [NATURAL_8]
			l_save_browse: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_title.make
			create l_dflt.make
			create l_initdir.make
			create l_filter.make
			create l_fname.make
			create l_tofree.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_title := a_title
					l_dflt := a_dflt
					l_initdir := a_initdir
					l_filter := a_filter
					l_tofree := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_save_browse := globals_inst.cmdmod.item.browse
					globals_inst.cmdmod.item.browse := 0
					if not (l_title.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (l_title.item).to_integer_32 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_title := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Select Directory dialog"))))
						elseif ((a_flags___0).bit_and (1)).to_boolean then
							l_title := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Save File dialog"))))
						else
							l_title := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Open File dialog"))))
						end
				when 5 then -- if done
						if not (l_initdir.is_void) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
							l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
							l_pos := -1 + 10
				when 8 then -- else:
							if (l_initdir.item).to_integer_32 /= 0 then
								l_pos := -1 + 10 -- skip if block
							end
				when 9 then -- if: | _L___0:
							if not l_dflt.is_void then
								if (l_dflt.item).to_integer_32 /= 0 then
									if (os_unix_inst.mch_isdir (l_dflt)).to_boolean then
										l_initdir := l_dflt
										l_dflt := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
									elseif not (misc1_inst.gettail (l_dflt)).is_equal (l_dflt) then
										l_tofree := misc2_inst.vim_strsave (l_dflt)
										if not l_tofree.is_void then
											l_initdir := l_tofree;
											(misc1_inst.gettail (l_initdir)).item := (('%/0/').code).to_natural_8
											l_dflt := misc1_inst.gettail (l_dflt)
										end
									end
								end
							end
				when 10 then -- if done
							if not (l_initdir.is_void) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
								l_pos := -1 + 14 -- goto _L___7
				when 12 then -- if block done, skip else block:
								l_pos := -1 + 24
				when 13 then -- else:
								if (l_initdir.item).to_integer_32 /= 0 then
									l_pos := -1 + 24 -- skip if block
								end
				when 14 then -- if: | _L___7:
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_bsdir.item), ce_string ("last"))) = 0 then
									l_pos := -1 + 17 -- skip if block
								end
				when 15 then -- if:
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_bsdir.item), ce_string ("buffer"))) /= 0 then
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_bsdir.item), ce_string ("current"))) /= 0 then
										if (os_unix_inst.mch_isdir (option_inst.p_bsdir.item)).to_boolean then
											l_initdir := option_inst.p_bsdir.item
										else
											l_pos := -1 + 17 -- goto _L___6
										end
									else
										l_pos := -1 + 17 -- goto _L___6
									end
								else
									l_pos := -1 + 17 -- goto _L___6
								end
				when 16 then -- if block done, skip else block:
								l_pos := -1 + 24
				when 17 then -- else: | _L___6:
								if not (((a_flags___0).bit_and (1)).to_boolean) then
									l_pos := -1 + 20 -- skip if block
								end
				when 18 then -- if:
								l_pos := -1 + 21 -- goto _L___3
				when 19 then -- if block done, skip else block:
								l_pos := -1 + 24
				when 20 then -- else:
								if (option_inst.p_bsdir.item.item).to_integer_32 /= 98 then
									l_pos := -1 + 23 -- skip if block
								end
				when 21 then -- if: | _L___3:
								if not a_buf___6.is_void then
									if not (a_buf___6.item.b_ffname).is_void then
										if l_dflt.is_void then
											l_dflt := misc1_inst.gettail (globals_inst.curbuf.item.b_ffname)
										elseif (l_dflt.item).to_integer_32 = 0 then
											l_dflt := misc1_inst.gettail (globals_inst.curbuf.item.b_ffname)
										end
										l_tofree := misc2_inst.vim_strsave (globals_inst.curbuf.item.b_ffname)
										if not l_tofree.is_void then
											l_initdir := l_tofree;
											(misc1_inst.gettail (l_initdir)).item := (('%/0/').code).to_natural_8
										end
									else
										l_pos := -1 + 23 -- goto _L___2
									end
								else
									l_pos := -1 + 23 -- goto _L___2
								end
				when 22 then -- if block done, skip else block:
								l_pos := -1 + 24
				when 23 then -- else: | _L___2:
								if (option_inst.p_bsdir.item.item).to_integer_32 = 108 then
									l_initdir := last_dir
								end
				when 24 then -- if done | if done | if done | if done
								if (gui_inst.gui.item.in_use).to_boolean then
									if l_filter.is_void then
										l_filter := eval_inst.get_var_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("b:browsefilter")))
										if l_filter.is_void then
											l_filter := eval_inst.get_var_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("g:browsefilter")))
											if l_filter.is_void then
												l_filter := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("All Files (*)%T*%NC source (*.c, *.h)%T*.c;*.h%NC++ source (*.cpp, *.hpp)%T*.cpp;*.hpp%NVim files (*.vim, _vimrc, _gvimrc)%T*.vim;_vimrc;_gvimrc%N"))
											end
										end
									end
									if ((a_flags___0).bit_and (2)).to_boolean then
										l_fname := gui_gtk_inst.gui_mch_browsedir (l_title, l_initdir)
									else
										l_fname := gui_gtk_inst.gui_mch_browse ((a_flags___0).bit_and (1), l_title, l_dflt, a_ext, l_initdir, l_filter)
									end
									globals_inst.need_check_timestamps := 1
									globals_inst.did_check_timestamps := 0
								else
									emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E338: Sorry, no file browser in console mode"))))).do_nothing
									l_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								end
								if not l_fname.is_void then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (last_dir))
									last_dir := misc2_inst.vim_strsave (l_fname)
									if not last_dir.is_void then
										if not ((a_flags___0).bit_and (2)).to_boolean then
											(misc1_inst.gettail (last_dir)).item := (('%/0/').code).to_natural_8
											if (last_dir.item).to_integer_32 = 0 then
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (last_dir))
												last_dir := misc2_inst.alloc ({NATURAL_32} 4_096)
												if not last_dir.is_void then
													os_unix_inst.mch_dirname (last_dir, 4_096).do_nothing
												end
											end
										end
									end
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tofree))
								globals_inst.cmdmod.item.browse := l_save_browse
								Result := l_fname
				when 25 then
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	do_dialog (a_type: INTEGER_32; a_title: CE_POINTER [NATURAL_8]; a_message: CE_POINTER [NATURAL_8]; a_buttons: CE_POINTER [NATURAL_8]; a_dfltbutton: INTEGER_32; a_textfield: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_oldState: INTEGER_32
			l_retval: INTEGER_32
			l_hotkeys: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hotkeys.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					if globals_inst.silent_mode.to_boolean then
						Result := a_dfltbutton
						js.return
					end
					if not js.return_called and then ((gui_inst.gui.item.in_use).to_boolean) then
						if (misc2_inst.vim_strchr (option_inst.p_go.item, ('c').code)).is_void then
							l_c := gui_gtk_inst.gui_mch_dialog (a_type, a_title, a_message, a_buttons, a_dfltbutton, a_textfield)
							globals_inst.need_wait_return := 0
							globals_inst.emsg_on_display := 0
							globals_inst.cmdline_row := globals_inst.msg_row
							term_inst.out_flush
							gui_gtk_x11_inst.gui_mch_update
							Result := l_c
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_oldState := globals_inst.State
						globals_inst.State := 2_048
						term_inst.setmouse
						globals_inst.no_wait_return := globals_inst.no_wait_return + 1
						l_hotkeys := msg_show_console_dialog (a_message, a_buttons, a_dfltbutton)
						if l_hotkeys.is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 2 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_c := misc1_inst.get_keystroke
						inspect l_c -- switch 1 head
						when 13 then l_pos := -1 + 4
						when 10 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						when 27 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case 13 | switch 1, case 10
						l_retval := a_dfltbutton
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 3 | switch 1, case 27
						l_retval := 0
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, default:
						if l_c < 0 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_c := charset_inst.vim_tolower (l_c)
						l_retval := 1
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then ((l_hotkeys[l_i___0]).to_boolean))
						loop
							if globals_inst.has_mbyte.to_boolean then
								if (globals_inst.mb_ptr2char.integer_32_item ([l_hotkeys + l_i___0])) = l_c then
									js.break
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + ((globals_inst.mb_ptr2len.integer_32_item ([l_hotkeys + l_i___0])) - 1)
								end
							elseif (l_hotkeys[l_i___0]).to_integer_32 = l_c then
								js.break
							end
							if not js.loop_jumped then
								l_retval := l_retval + 1
								l_i___0 := l_i___0 + 1
							end
						end
						if (l_hotkeys[l_i___0]).to_boolean then
							l_pos := -1 + 9 -- switch 1; break
						end
				when 8 then
						js.continue
				when 9 then -- switch 1, done:
						if not js.loop_jumped then
							js.break
						end
						if js.loop_increment then
							
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hotkeys))
				when 11 then -- if done
						globals_inst.State := l_oldState
						term_inst.setmouse
						globals_inst.no_wait_return := globals_inst.no_wait_return - 1
						msg_end_prompt
						Result := l_retval
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_more_prompt (a_typed_char: INTEGER_32): INTEGER_32
		local
			l_used_typed_char: INTEGER_32
			l_oldState: INTEGER_32
			l_c: INTEGER_32
			l_retval: INTEGER_32
			l_scroll: INTEGER_32
			l_mp_last: CE_POINTER [PD_MSGCHUNK_S]
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_mp_last.make
			create l_mp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_used_typed_char := a_typed_char
					l_oldState := globals_inst.State
					l_retval := 0
					l_mp_last := create {CE_POINTER [PD_MSGCHUNK_S]}.make_shared (default_pointer)
					if a_typed_char = 71 then
						l_mp_last := msg_sb_start (last_msgchunk)
						l_i___0 := 0
						from
						until
							js.loop_done
						loop
							if l_i___0.to_integer_32 < globals_inst.Rows.item - 2 then
								if not l_mp_last.is_void then
									if (l_mp_last.item.sb_prev).is_void then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_mp_last := msg_sb_start (l_mp_last.item.sb_prev)
								l_i___0 := l_i___0 + 1
							end
						end
					end
					globals_inst.State := 768
					term_inst.setmouse
					if a_typed_char = 0 then
						msg_moremsg (0)
					end
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 29 -- skip loop
					end
				when 2 then -- loop body:
						if l_used_typed_char /= 0 then
							l_c := l_used_typed_char
							l_used_typed_char := ('%/0/').code
						else
							l_c := misc1_inst.get_keystroke
						end
						if l_c = -(250 + ((88).bit_shift_left (8))) then
							l_idx := (menu_inst.get_menu_index (globals_inst.current_menu, 768))
							if l_idx = -1 then
								js.continue
							end
							if not js.loop_jumped then
								l_c := ((globals_inst.current_menu.item.strings[l_idx]).item).to_integer_32
								if l_c /= 0 then
									if ((globals_inst.current_menu.item.strings[l_idx])[1]).to_integer_32 /= 0 then
										getchar_inst.ins_typebuf (globals_inst.current_menu.item.strings[l_idx] + 1, globals_inst.current_menu.item.noremap[l_idx], 0, 1, (globals_inst.current_menu.item.silent[l_idx]).to_integer_32).do_nothing
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 16 -- skip if block
						end
				when 3 then -- if:
						l_scroll := 0
						inspect l_c -- switch 1 head
						when 8 then l_pos := -1 + 4
						when -25195 then l_pos := -1 + 4 -- -(107 + ((98).bit_shift_left (8)))
						when 107 then l_pos := -1 + 4
						when -30059 then l_pos := -1 + 4 -- -(107 + ((117).bit_shift_left (8)))
						when 13 then l_pos := -1 + 5
						when 10 then l_pos := -1 + 5
						when 106 then l_pos := -1 + 5
						when -25707 then l_pos := -1 + 5 -- -(107 + ((100).bit_shift_left (8)))
						when 117 then l_pos := -1 + 6
						when 100 then l_pos := -1 + 7
						when 98 then l_pos := -1 + 8
						when -20587 then l_pos := -1 + 8 -- -(107 + ((80).bit_shift_left (8)))
						when 32 then l_pos := -1 + 9
						when 102 then l_pos := -1 + 9
						when -20075 then l_pos := -1 + 9 -- -(107 + ((78).bit_shift_left (8)))
						when -11517 then l_pos := -1 + 9 -- -(253 + ((44).bit_shift_left (8)))
						when 103 then l_pos := -1 + 10
						when 71 then l_pos := -1 + 11
						when 58 then l_pos := -1 + 12
						when 113 then l_pos := -1 + 13
						when 3 then l_pos := -1 + 13
						when 27 then l_pos := -1 + 13
						when 25 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 4 then -- switch 1, case 8 | switch 1, case -(107 + (98 << 8)) | switch 1, case 107 | switch 1, case -(107 + (117 << 8))
						l_scroll := -1
						l_pos := -1 + 16 -- switch 1; break
				when 5 then -- switch 1, case 13 | switch 1, case 10 | switch 1, case 106 | switch 1, case -(107 + (100 << 8))
						l_scroll := 1
						l_pos := -1 + 16 -- switch 1; break
				when 6 then -- switch 1, case 117
						l_scroll := (-(globals_inst.Rows.item // 2)).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 7 then -- switch 1, case 100
						l_scroll := (globals_inst.Rows.item // 2).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 8 then -- switch 1, case 98 | switch 1, case -(107 + (80 << 8))
						l_scroll := (-(globals_inst.Rows.item - 1)).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 9 then -- switch 1, case 32 | switch 1, case 102 | switch 1, case -(107 + (78 << 8)) | switch 1, case -(253 + (44 << 8))
						l_scroll := (globals_inst.Rows.item - 1).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 10 then -- switch 1, case 103
						l_scroll := -999_999
						l_pos := -1 + 16 -- switch 1; break
				when 11 then -- switch 1, case 71
						l_scroll := 999_999
						globals_inst.lines_left := 999_999
						l_pos := -1 + 16 -- switch 1; break
				when 12 then -- switch 1, case 58
						if not confirm_msg_used.to_boolean then
							getchar_inst.typeahead_noflush ((':').code)
							globals_inst.cmdline_row := (globals_inst.Rows.item - 1).to_integer_32
							globals_inst.skip_redraw := 1
							globals_inst.need_wait_return := 0
						end
				when 13 then -- switch 1, case 113 | switch 1, case 3 | switch 1, case 27
						if confirm_msg_used.to_boolean then
							l_retval := 1
						else
							globals_inst.got_int := 1
							globals_inst.quit_more := 1
						end
						globals_inst.lines_left := (globals_inst.Rows.item - 1).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 14 then -- switch 1, case 25
						if (globals_inst.clip_star.item.state).to_integer_32 = 2 then
							ui_inst.clip_copy_modeless_selection (1)
						end
						js.continue
				when 15 then -- switch 1, default:
						if not js.loop_jumped then
							msg_moremsg (1)
							js.continue
						end
				when 16 then -- switch 1, done: | if done
						if not (not js.loop_jumped and then (l_scroll /= 0)) then
							l_pos := -1 + 28 -- skip if block
						end
				when 17 then -- if:
						if not (l_scroll < 0) then
							l_pos := -1 + 26 -- skip if block
						end
				when 18 then -- if:
						if l_mp_last.is_void then
							l_mp := msg_sb_start (last_msgchunk)
						elseif not (l_mp_last.item.sb_prev).is_void then
							l_mp := msg_sb_start (l_mp_last.item.sb_prev)
						else
							l_mp := create {CE_POINTER [PD_MSGCHUNK_S]}.make_shared (default_pointer)
						end
						l_i___0 := 0
						from
						until
							js.loop_done
						loop
							if l_i___0.to_integer_32 < globals_inst.Rows.item - 2 then
								if not l_mp.is_void then
									if (l_mp.item.sb_prev).is_void then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_mp := msg_sb_start (l_mp.item.sb_prev)
								l_i___0 := l_i___0 + 1
							end
						end
						if l_mp.is_void then
							l_pos := -1 + 25 -- skip if block
						end
				when 19 then -- if:
						if (l_mp.item.sb_prev).is_void then
							l_pos := -1 + 25 -- skip if block
						end
				when 20 then -- if:
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0 > l_scroll))
						loop
							if l_mp.is_void then
								js.break
							elseif (l_mp.item.sb_prev).is_void then
								js.break
							end
							if not js.loop_jumped then
								l_mp := msg_sb_start (l_mp.item.sb_prev)
								if l_mp_last.is_void then
									l_mp_last := msg_sb_start (last_msgchunk)
								else
									l_mp_last := msg_sb_start (l_mp_last.item.sb_prev)
								end
								l_i___0 := l_i___0 - 1
							end
						end
						if l_scroll /= -1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if (screen_inst.screen_ins_lines (0, 0, 1, (globals_inst.Rows.item).to_integer_32, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))) = 1 then
							disp_sb_line (0, l_mp).do_nothing
						else
							l_pos := -1 + 23 -- goto _L
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L:
						screen_inst.screenclear
						l_i___0 := 0
						from
						until
							js.loop_done
						loop
							if not l_mp.is_void then
								if not (l_i___0.to_integer_32 < globals_inst.Rows.item - 1) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_mp := disp_sb_line (l_i___0, l_mp)
								globals_inst.msg_scrolled := globals_inst.msg_scrolled + 1
								l_i___0 := l_i___0 + 1
							end
						end
				when 24 then
						l_scroll := 0
				when 25 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						from
						until
							js.loop_done
						loop
							if l_scroll > 0 then
								if l_mp_last.is_void then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								msg_scroll_up
								inc_msg_scrolled
								screen_inst.screen_fill ((globals_inst.Rows.item).to_integer_32 - 2, (globals_inst.Rows.item).to_integer_32 - 1, 0, (globals_inst.Columns.item).to_integer_32, (' ').code, (' ').code, 0)
								l_mp_last := disp_sb_line ((globals_inst.Rows.item).to_integer_32 - 2, l_mp_last)
								l_scroll := l_scroll - 1
							end
						end
				when 27 then -- if done
						if l_scroll <= 0 then
							screen_inst.screen_fill ((globals_inst.Rows.item).to_integer_32 - 1, (globals_inst.Rows.item).to_integer_32, 0, (globals_inst.Columns.item).to_integer_32, (' ').code, (' ').code, 0)
							msg_moremsg (0)
							js.continue
						end
						if not js.loop_jumped then
							globals_inst.lines_left := l_scroll
						end
				when 28 then -- if done
						if not js.loop_jumped then
							js.break
						end
						if js.loop_increment then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 29 then -- loop done
					screen_inst.screen_fill ((globals_inst.Rows.item).to_integer_32 - 1, (globals_inst.Rows.item).to_integer_32, 0, (globals_inst.Columns.item).to_integer_32, (' ').code, (' ').code, 0)
					globals_inst.State := l_oldState
					term_inst.setmouse
					if globals_inst.quit_more.to_boolean then
						globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
						globals_inst.msg_col := 0
					end
					Result := l_retval
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	emsg (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_attr: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_ignore___0: CE_ARRAY [INTEGER_32]
			l_severe: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_ignore___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ignore___0.item := 0
					globals_inst.called_emsg := 1
					globals_inst.ex_exitval := 1
					l_severe := globals_inst.emsg_severe
					globals_inst.emsg_severe := 0
					if (emsg_not_now).to_boolean then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.emsg_off.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (misc2_inst.vim_strchr (option_inst.p_debug.item, ('t').code)).is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (ex_eval_inst.cause_errthrow (a_s, l_severe, l_ignore___0)) = 1 then
							if not (l_ignore___0.item).to_boolean then
								globals_inst.did_emsg := 1
							end
							Result := 1
							js.return
						end
						if not js.return_called then
							eval_inst.set_vim_var_string (3, a_s, -1)
							if globals_inst.emsg_silent /= 0 then
								msg_start
								l_p___0 := get_emsg_source
								if not l_p___0.is_void then
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("%N")).do_nothing
									redir_write (l_p___0, -1)
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								end
								l_p___0 := get_emsg_lnum
								if not l_p___0.is_void then
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("%N")).do_nothing
									redir_write (l_p___0, -1)
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								end
								redir_write (a_s, -1)
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							globals_inst.msg_silent := 0
							globals_inst.cmd_silent := 0
							if globals_inst.global_busy.to_boolean then
								globals_inst.global_busy := globals_inst.global_busy + 1
							end
							if (option_inst.p_eb.item).to_boolean then
								misc1_inst.beep_flush
							else
								getchar_inst.flush_buffers (0)
							end
							globals_inst.did_emsg := 1
						end
				when 6 then -- if done | if done
						if not js.return_called then
							globals_inst.emsg_on_display := 1
							globals_inst.msg_scroll := globals_inst.msg_scroll + 1
							l_attr := globals_inst.highlight_attr[3]
							if globals_inst.msg_scrolled /= 0 then
								globals_inst.need_wait_return := 1
							end
							msg_source (l_attr)
							globals_inst.msg_nowait := 0
							Result := (msg_attr (a_s, l_attr))
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	emsg2 (a_s: CE_POINTER [NATURAL_8]; a_a1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (misc2_inst.emsg3 (a_s, a_a1, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)))
		end

	emsg_invreg (a_name___1: INTEGER_32)
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_tmp.make

			l_tmp := charset_inst.transchar (a_name___1)
			emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E354: Invalid register name: %'%%s%'")))), l_tmp).do_nothing
		end

	emsg_not_now: INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (globals_inst.emsg_off > 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (misc2_inst.vim_strchr (option_inst.p_debug.item, ('m').code)).is_void then
							if (misc2_inst.vim_strchr (option_inst.p_debug.item, ('t').code)).is_void then
								Result := 1
								js.return
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						if globals_inst.emsg_skip > 0 then
							Result := 1
							js.return
						end
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_messages (a_eap: CE_POINTER [PD_EXARG])
		local
			l_p___0: CE_POINTER [PD_MSG_HIST]
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_s.make

			globals_inst.msg_hist_off := 1
			l_s := create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("LANG"))))
			if not l_s.is_void then
				if (l_s.item).to_integer_32 /= 0 then
					msg_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Messages maintainer: Bram Moolenaar <Bram@vim.org>")))), globals_inst.highlight_attr[14]).do_nothing
				end
			end
			l_p___0 := first_msg_hist
			from
			until
				js.loop_done
			loop
				if not l_p___0.is_void then
					if globals_inst.got_int.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if not (l_p___0.item.msg).is_void then
						msg_attr (l_p___0.item.msg, l_p___0.item.attr).do_nothing
					end
					l_p___0 := l_p___0.item.next
				end
			end
			globals_inst.msg_hist_off := 0
		end

	ex_messages_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_messages)
		end

	get_emsg_lnum: CE_POINTER [NATURAL_8]
		local
			l_Buf: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_Buf.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.sourcing_name.is_void then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not ((other_sourcing_name).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if globals_inst.sourcing_lnum = last_sourcing_lnum.to_integer_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if globals_inst.sourcing_lnum /= 0 then
							l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("line %%4ld:"))))
							l_Buf := misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 20)
							if not l_Buf.is_void then
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_Buf), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), globals_inst.sourcing_lnum]).do_nothing
							end
							Result := l_Buf
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_emsg_source: CE_POINTER [NATURAL_8]
		local
			l_Buf: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_Buf.make
			create l_p___0.make

			if not globals_inst.sourcing_name.is_void then
				if (other_sourcing_name).to_boolean then
					l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Error detected while processing %%s:"))))
					l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.sourcing_name))
					l_Buf := misc2_inst.alloc (l_tmp___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))))
					if not l_Buf.is_void then
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_Buf), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), globals_inst.sourcing_name]).do_nothing
					end
					Result := l_Buf
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	give_warning (a_message: CE_POINTER [NATURAL_8]; a_hl: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if globals_inst.msg_silent /= 0 then
				js.return
			end
			if not js.return_called then
				globals_inst.no_wait_return := globals_inst.no_wait_return + 1
				eval_inst.set_vim_var_string (4, a_message, -1)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.keep_msg))
				globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				if a_hl.to_boolean then
					globals_inst.keep_msg_attr := globals_inst.highlight_attr[17]
				else
					globals_inst.keep_msg_attr := 0
				end
				if (msg_attr (a_message, globals_inst.keep_msg_attr)).to_boolean then
					if globals_inst.msg_scrolled = 0 then
						set_keep_msg (a_message, globals_inst.keep_msg_attr)
					end
				end
				globals_inst.msg_didout := 0
				globals_inst.msg_nowait := 1
				globals_inst.msg_col := 0
				globals_inst.no_wait_return := globals_inst.no_wait_return - 1
			end
		end

	hit_return_msg
		local
			l_save_p_more: INTEGER_32
		do
			l_save_p_more := option_inst.p_more.item
			option_inst.p_more.item := 0
			if globals_inst.msg_didout.to_boolean then
				msg_putchar (('%N').code)
			end
			if globals_inst.got_int.to_boolean then
				msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Interrupt: ")))))
			end
			msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Press ENTER or type command to continue")))), globals_inst.highlight_attr[10])
			if not (msg_use_printf).to_boolean then
				msg_clr_eos
			end
			option_inst.p_more.item := l_save_p_more
		end

	inc_msg_scrolled
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tofree: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
		do
			create l_p___0.make
			create l_tofree.make

			if ((eval_inst.get_vim_var_str (44)).item).to_integer_32 = 0 then
				l_p___0 := globals_inst.sourcing_name
				l_tofree := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				if l_p___0.is_void then
					l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Unknown"))))
				else
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32 + 40
					l_tofree := misc2_inst.alloc (l_len.to_natural_32)
					if not l_tofree.is_void then
						vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_tofree), l_len.to_natural_32, (gettext (ce_string ("%%s line %%ld"))), l_p___0, globals_inst.sourcing_lnum]).do_nothing
						l_p___0 := l_tofree
					end
				end
				eval_inst.set_vim_var_string (44, l_p___0, -1)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tofree))
			end
			globals_inst.msg_scrolled := globals_inst.msg_scrolled + 1
		end

	may_clear_sb_text
		do
			do_clear_sb_text := 1
		end

	mch_errmsg (a_str___1: CE_POINTER [INTEGER_8])
		local
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			if (isatty (2)).to_boolean then
				Io.error.put_string (eif_string (a_str___1))
				js.return
			elseif not (gui_inst.gui.item.in_use).to_boolean then
				if not (gui_inst.gui.item.starting).to_boolean then
					Io.error.put_string (eif_string (a_str___1))
					js.return
				end
			end
			if not js.return_called then
				globals_inst.emsg_on_display := 0
				l_len := (strlen (a_str___1)).to_integer_32 + 1
				if globals_inst.error_ga.item.ga_growsize = 0 then
					globals_inst.error_ga.item.ga_growsize := 80
					globals_inst.error_ga.item.ga_itemsize := 1
				end
				if (misc2_inst.ga_grow (globals_inst.error_ga, l_len)) = 1 then
					memmove (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [NATURAL_8]}.make_cast (globals_inst.error_ga.item.ga_data) + globals_inst.error_ga.item.ga_len)), create {CE_POINTER [ANY]}.make_cast (a_str___1), l_len.to_natural_32).do_nothing
					l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (globals_inst.error_ga.item.ga_data) + globals_inst.error_ga.item.ga_len
					from
					until
						js.loop_done
					loop
						l_p___0 := misc2_inst.vim_strchr (l_p___0, ('%R').code)
						if l_p___0.is_void then
							js.break
						end
						if not js.loop_jumped then
							l_p___0.item := ((' ').code).to_natural_8
						end
					end
					l_len := l_len - 1
					globals_inst.error_ga.item.ga_len := globals_inst.error_ga.item.ga_len + l_len
				end
			end
		end

	mch_msg (a_str___1: CE_POINTER [INTEGER_8])
		local
			js: JUMP_STATE
		do
			if (isatty (2)).to_boolean then
				Io.put_string (eif_string (a_str___1))
				js.return
			elseif not (gui_inst.gui.item.in_use).to_boolean then
				if not (gui_inst.gui.item.starting).to_boolean then
					Io.put_string (eif_string (a_str___1))
					js.return
				end
			end
			if not js.return_called then
				mch_errmsg (a_str___1)
			end
		end

	msg (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (msg_attr_keep (a_s, 0, 0))
		end

	msg_advance (a_col: INTEGER_32)
		local
			l_col: INTEGER_32
			js: JUMP_STATE
		do
			l_col := a_col
			if globals_inst.msg_silent /= 0 then
				globals_inst.msg_col := l_col
				js.return
			end
			if not js.return_called then
				if l_col.to_integer_32 >= globals_inst.Columns.item then
					l_col := (globals_inst.Columns.item - 1).to_integer_32
				end
				from
				until
					not (globals_inst.msg_col < l_col)
				loop
					msg_putchar ((' ').code)
				end
			end
		end

	msg_attr (a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32): INTEGER_32
		do
			Result := (msg_attr_keep (a_s, a_attr, 0))
		end

	msg_attr_keep (a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32; a_keep: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make
			create l_buf___6.make

			l_s := a_s
			l_buf___6 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if a_attr = 0 then
				eval_inst.set_vim_var_string (5, l_s, -1)
			end
			if entered___1 >= 3 then
				Result := 1
				js.return
			end
			if not js.return_called then
				entered___1 := entered___1 + 1
				if not l_s.is_equal (globals_inst.keep_msg) then
					add_msg_hist (l_s, -1, a_attr)
				elseif (l_s.item).to_integer_32 /= 60 then
					if not last_msg_hist.is_void then
						if not (last_msg_hist.item.msg).is_void then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (last_msg_hist.item.msg))).to_boolean then
								add_msg_hist (l_s, -1, a_attr)
							end
						end
					end
				end
				if l_s.is_equal (globals_inst.keep_msg) then
					globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
				msg_start
				l_buf___6 := msg_strtrunc (l_s, 0)
				if not l_buf___6.is_void then
					l_s := l_buf___6
				end
				msg_outtrans_attr (l_s, a_attr).do_nothing
				msg_clr_eos
				l_retval := msg_end
				if a_keep.to_boolean then
					if l_retval.to_boolean then
						if (charset_inst.vim_strsize (l_s)).to_integer_32 < (((globals_inst.Rows.item - globals_inst.cmdline_row.to_integer_32) - 1).to_integer_32).to_integer_32 * globals_inst.Columns.item + globals_inst.sc_col.to_integer_32 then
							set_keep_msg (l_s, 0)
						end
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
				entered___1 := entered___1 - 1
				Result := l_retval
			end
		end

	msg_check
		do
			if globals_inst.msg_row.to_integer_32 = globals_inst.Rows.item - 1 then
				if globals_inst.msg_col >= globals_inst.sc_col then
					globals_inst.need_wait_return := 1
					globals_inst.redraw_cmdline := 1
				end
			end
		end

	msg_check_screen: INTEGER_32
		local
			js: JUMP_STATE
		do
			if not globals_inst.full_screen.to_boolean then
				Result := 0
				js.return
			elseif not (screen_inst.screen_valid (0)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				if globals_inst.msg_row.to_integer_32 >= globals_inst.Rows.item then
					globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
				end
				if globals_inst.msg_col.to_integer_32 >= globals_inst.Columns.item then
					globals_inst.msg_col := (globals_inst.Columns.item - 1).to_integer_32
				end
				Result := 1
			end
		end

	msg_clr_cmdline
		do
			globals_inst.msg_row := globals_inst.cmdline_row
			globals_inst.msg_col := 0
			msg_clr_eos_force
		end

	msg_clr_eos
		do
			if globals_inst.msg_silent = 0 then
				msg_clr_eos_force
			end
		end

	msg_clr_eos_force
		do
			if (msg_use_printf).to_boolean then
				if globals_inst.full_screen.to_boolean then
					if ((term_inst.term_strings[8]).item).to_boolean then
						term_inst.out_str (term_inst.term_strings[8])
					elseif ((term_inst.term_strings[1]).item).to_boolean then
						term_inst.out_str (term_inst.term_strings[1])
					end
				end
			else
				screen_inst.screen_fill (globals_inst.msg_row, globals_inst.msg_row + 1, globals_inst.msg_col, (globals_inst.Columns.item).to_integer_32, (' ').code, (' ').code, 0)
				screen_inst.screen_fill (globals_inst.msg_row + 1, (globals_inst.Rows.item).to_integer_32, 0, (globals_inst.Columns.item).to_integer_32, (' ').code, (' ').code, 0)
			end
		end

	msg_end: INTEGER_32
		local
			js: JUMP_STATE
		do
			if not globals_inst.exiting.to_boolean then
				if globals_inst.need_wait_return.to_boolean then
					if not ((globals_inst.State).bit_and (8)).to_boolean then
						wait_return (0)
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				term_inst.out_flush
				Result := 1
			end
		end

	msg_end_prompt
		do
			globals_inst.need_wait_return := 0
			globals_inst.emsg_on_display := 0
			globals_inst.cmdline_row := globals_inst.msg_row
			globals_inst.msg_col := 0
			msg_clr_eos
		end

	msg_home_replace (a_fname: CE_POINTER [NATURAL_8])
		do
			msg_home_replace_attr (a_fname, 0)
		end

	msg_home_replace_attr (a_fname: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		local
			l_name___1: CE_POINTER [NATURAL_8]
		do
			create l_name___1.make

			l_name___1 := misc1_inst.home_replace_save (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_fname)
			if not l_name___1.is_void then
				msg_outtrans_attr (l_name___1, a_attr).do_nothing
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
		end

	msg_home_replace_hl (a_fname: CE_POINTER [NATURAL_8])
		do
			msg_home_replace_attr (a_fname, globals_inst.highlight_attr[2])
		end

	msg_make (a_arg: CE_POINTER [NATURAL_8])
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_arg.make
			create l_tmp.make

			l_arg := a_arg
			l_arg := charset_inst.skipwhite (l_arg)
			l_i___0 := 5
			from
			until
				js.loop_done
			loop
				if (l_arg.item).to_boolean then
					if not (l_i___0 >= 0) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_tmp := l_arg
					l_arg := l_arg + 1
					if (l_tmp.item).to_integer_32 /= (str[l_i___0]).to_integer_32 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_i___0 := l_i___0 - 1
				end
			end
			if l_i___0 < 0 then
				msg_putchar (('%N').code)
				l_i___0 := 0
				from
				until
					not ((rs[l_i___0]).to_boolean)
				loop
					msg_putchar ((rs[l_i___0]).to_integer_32 - 3)
					l_i___0 := l_i___0 + 1
				end
			end
		end

	msg_may_trunc (a_force: INTEGER_32; a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_room: INTEGER_32
			l_size: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_room := (((((globals_inst.Rows.item - globals_inst.cmdline_row.to_integer_32) - 1).to_integer_32).to_integer_32 * globals_inst.Columns.item + globals_inst.sc_col.to_integer_32) - 1).to_integer_32
					if not (a_force.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if not ((option_inst.shortmess (('t').code)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if globals_inst.exmode_active.to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_n := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32 - l_room
						if l_n > 0 then
							if globals_inst.has_mbyte.to_boolean then
								l_size := (charset_inst.vim_strsize (l_s))
								if l_size <= l_room then
									Result := l_s
									js.return
								end
								if not js.return_called then
									l_n := 0
									from
									until
										not (l_size >= l_room)
									loop
										l_size := l_size - (globals_inst.mb_ptr2cells.integer_32_item ([l_s + l_n]))
										l_n := l_n + (globals_inst.mb_ptr2len.integer_32_item ([l_s + l_n]))
									end
									l_n := l_n - 1
								end
							end
							if not js.return_called then
								l_s := l_s + l_n
								l_s.item := (('<').code).to_natural_8
							end
						end
				when 6 then -- if done | if done
						if not js.return_called then
							Result := l_s
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	msg_moremsg (a_full: INTEGER_32)
		local
			l_attr: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			create l_s.make

			l_s := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("-- More --"))))
			l_attr := globals_inst.highlight_attr[7]
			screen_inst.screen_puts (l_s, (globals_inst.Rows.item).to_integer_32 - 1, 0, l_attr)
			if a_full.to_boolean then
				l_tmp___0 := charset_inst.vim_strsize (l_s)
				screen_inst.screen_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" SPACE/d/j: screen/page/line down, b/u/k: up, q: quit ")))), (globals_inst.Rows.item).to_integer_32 - 1, l_tmp___0, l_attr)
			end
		end

	msg_outnum (a_n: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create l_buf___6.make (<<20>>)

			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("%%ld"), a_n]).do_nothing
			msg_puts (l_buf___6)
		end

	msg_outtrans (a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (msg_outtrans_attr (a_str___1, 0))
		end

	msg_outtrans_attr (a_str___1: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32): INTEGER_32
		do
			Result := (msg_outtrans_len_attr (a_str___1, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1))).to_integer_32, a_attr))
		end

	msg_outtrans_len (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		do
			Result := (msg_outtrans_len_attr (a_str___1, a_len, 0))
		end

	msg_outtrans_len_attr (a_msgstr: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_attr: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_attr: INTEGER_32
			l_retval: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_plain_start: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_mb_l: INTEGER_32
			l_c: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str___1.make
			create l_plain_start.make
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					l_attr := a_attr
					l_retval := 0
					l_str___1 := a_msgstr
					l_plain_start := a_msgstr
					if ((l_attr).bit_and (4_096)).to_boolean then
						add_msg_hist (l_str___1, l_len, l_attr)
						l_attr := (l_attr).bit_and ((-4_097))
					end
					if globals_inst.enc_utf8.to_boolean then
						if (mbyte_inst.utf_iscomposing ((mbyte_inst.utf_ptr2char (a_msgstr)))).to_boolean then
							msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), l_attr)
						end
					end
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_len := l_len - 1
						if not (l_len >= 0) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if globals_inst.enc_utf8.to_boolean then
							l_mb_l := mbyte_inst.utfc_ptr2len_len (l_str___1, l_len + 1)
						elseif globals_inst.has_mbyte.to_boolean then
							l_mb_l := globals_inst.mb_ptr2len.integer_32_item ([l_str___1])
						else
							l_mb_l := 1
						end
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_mb_l > 1 then
							l_c := globals_inst.mb_ptr2char.integer_32_item ([l_str___1])
							if (charset_inst.vim_isprintc (l_c)).to_boolean then
								l_retval := l_retval + (globals_inst.mb_ptr2cells.integer_32_item ([l_str___1]))
							else
								if (l_str___1.c_pointer.to_integer_32).to_natural_32 > (l_plain_start.c_pointer.to_integer_32).to_natural_32 then
									msg_puts_attr_len (l_plain_start, l_str___1.distance (l_plain_start), l_attr)
								end
								l_plain_start := l_str___1 + l_mb_l
								if l_attr = 0 then
									l_tmp___2 := globals_inst.highlight_attr[0]
								else
									l_tmp___2 := l_attr
								end
								msg_puts_attr ((charset_inst.transchar (l_c)), l_tmp___2)
								l_retval := l_retval + (charset_inst.char2cells (l_c))
							end
							l_len := l_len - (l_mb_l - 1)
							l_str___1 := l_str___1 + l_mb_l
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_s := charset_inst.transchar_byte ((l_str___1.item).to_integer_32)
						if (l_s[1]).to_integer_32 /= 0 then
							if (l_str___1.c_pointer.to_integer_32).to_natural_32 > (l_plain_start.c_pointer.to_integer_32).to_natural_32 then
								msg_puts_attr_len (l_plain_start, l_str___1.distance (l_plain_start), l_attr)
							end
							l_plain_start := l_str___1 + 1
							if l_attr = 0 then
								l_tmp___6 := globals_inst.highlight_attr[0]
							else
								l_tmp___6 := l_attr
							end
							msg_puts_attr (l_s, l_tmp___6)
							l_retval := l_retval + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
						else
							l_retval := l_retval + 1
						end
						l_str___1 := l_str___1 + 1
				when 7 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					if (l_str___1.c_pointer.to_integer_32).to_natural_32 > (l_plain_start.c_pointer.to_integer_32).to_natural_32 then
						msg_puts_attr_len (l_plain_start, l_str___1.distance (l_plain_start), l_attr)
					end
					Result := l_retval
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_outtrans_one (a_p___0: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.has_mbyte.to_boolean then
				l_l := globals_inst.mb_ptr2len.integer_32_item ([a_p___0])
				if l_l > 1 then
					msg_outtrans_len_attr (a_p___0, l_l, a_attr).do_nothing
					Result := (a_p___0 + l_l)
					js.return
				end
			end
			if not js.return_called then
				msg_puts_attr ((charset_inst.transchar_byte ((a_p___0.item).to_integer_32)), a_attr)
				Result := (a_p___0 + 1)
			end
		end

	msg_outtrans_special (a_strstart: CE_POINTER [NATURAL_8]; a_from: INTEGER_32): INTEGER_32
		local
			l_str___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_retval: INTEGER_32
			l_string___0: CE_POINTER [NATURAL_8]
			l_attr: INTEGER_32
			l_len: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_str___1.make (<<1>>)
			create l_string___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1.item := a_strstart
					l_retval := 0
					l_attr := globals_inst.highlight_attr[0]
				when 1 then -- loop condition:
					if (l_str___1.item.item).to_integer_32 = 0 then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if not ((l_str___1.item).is_equal (a_strstart)) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if (l_str___1.item[1]).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						if (l_str___1.item.item).to_integer_32 = 32 then
							l_string___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<Space>"))
							l_str___1.item := l_str___1.item + 1
						else
							l_string___0 := str2special (l_str___1, a_from)
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_string___0 := str2special (l_str___1, a_from)
				when 9 then -- if done
						l_len := charset_inst.vim_strsize (l_string___0)
						if l_len > 1 then
							if (globals_inst.mb_ptr2len.integer_32_item ([l_string___0])) <= 1 then
								l_tmp___0 := l_attr
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						msg_puts_attr (l_string___0, l_tmp___0)
						l_retval := l_retval + l_len
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					Result := l_retval
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_prt_line (a_s: CE_POINTER [NATURAL_8]; a_list: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_list: INTEGER_32
			l_c: INTEGER_32
			l_col: INTEGER_32
			l_n_extra: INTEGER_32
			l_c_extra: INTEGER_32
			l_p_extra: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_attr: INTEGER_32
			l_trail: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_p_extra.make
			create l_trail.make
			create l_buf___6.make (<<22>>)
			create l_tmp___0.make
			create l_tmp___2.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_list := a_list
					l_col := 0
					l_n_extra := 0
					l_c_extra := 0
					l_p_extra := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_attr := 0
					l_trail := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					if (globals_inst.curwin.item.w_onebuf_opt.wo_list).to_boolean then
						l_list := 1
					end
					if l_list.to_boolean then
						if (globals_inst.lcs_trail.item).to_boolean then
							l_trail := l_s + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
							from
							until
								js.loop_done
							loop
								if (l_trail.c_pointer.to_integer_32).to_natural_32 > (l_s.c_pointer.to_integer_32).to_natural_32 then
									if (l_trail[-1]).to_integer_32 /= 32 then
										if (l_trail[-1]).to_integer_32 /= 9 then
											js.break
										end
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_trail := l_trail - 1
								end
							end
						end
					end
					if (l_s.item).to_integer_32 = 0 then
						if l_list.to_boolean then
							if globals_inst.lcs_eol.item = 0 then
								msg_putchar ((' ').code)
							end
						else
							msg_putchar ((' ').code)
						end
					end
				when 1 then -- loop condition:
					if not (not js.loop_done and then (not globals_inst.got_int.to_boolean)) then
						l_pos := -1 + 25 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_n_extra > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_n_extra := l_n_extra - 1
						if l_c_extra.to_boolean then
							l_c := l_c_extra
						else
							l_tmp___0 := l_p_extra
							l_p_extra := l_p_extra + 1
							l_c := (l_tmp___0.item).to_integer_32
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 5 then -- else:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_l := globals_inst.mb_ptr2len.integer_32_item ([l_s])
						if l_l > 1 then
							l_col := l_col + (globals_inst.mb_ptr2cells.integer_32_item ([l_s]))
							memmove (create {CE_POINTER [ANY]}.make_cast (l_buf___6), create {CE_POINTER [ANY]}.make_cast (l_s), l_l.to_natural_32).do_nothing
							l_buf___6[l_l] := (('%/0/').code).to_natural_8
							msg_puts (l_buf___6)
							l_s := l_s + l_l
							js.continue
						else
							l_pos := -1 + 8 -- goto _L___4
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 8 then -- else: | _L___4:
						l_attr := 0
						l_tmp___2 := l_s
						l_s := l_s + 1
						l_c := (l_tmp___2.item).to_integer_32
						if l_c /= 9 then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if:
						if l_list.to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___3
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if not (globals_inst.lcs_tab1.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L___3:
						l_n_extra := ((globals_inst.curbuf.item.b_p_ts - l_col.to_integer_32 \\ globals_inst.curbuf.item.b_p_ts) - 1).to_integer_32
						if not l_list.to_boolean then
							l_c := (' ').code
							l_c_extra := (' ').code
						else
							l_c := globals_inst.lcs_tab1
							l_c_extra := globals_inst.lcs_tab2.item
							l_attr := globals_inst.highlight_attr[0]
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___2
				when 16 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else: | _L___2:
						if l_c /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if l_list.to_boolean then
							if globals_inst.lcs_eol.item /= 0 then
								l_p_extra := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
								l_c_extra := ('%/0/').code
								l_n_extra := 1
								l_c := globals_inst.lcs_eol.item
								l_attr := globals_inst.highlight_attr[1]
								l_s := l_s - 1
							else
								l_pos := -1 + 20 -- goto _L___1
							end
						else
							l_pos := -1 + 20 -- goto _L___1
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else: | _L___1:
						if l_c = 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_n := charset_inst.byte2cells (l_c)
						if l_n > 1 then
							l_n_extra := l_n - 1
							l_p_extra := charset_inst.transchar_byte (l_c)
							l_c_extra := ('%/0/').code
							l_tmp___3 := l_p_extra
							l_p_extra := l_p_extra + 1
							l_c := (l_tmp___3.item).to_integer_32
							l_attr := globals_inst.highlight_attr[0]
						else
							l_pos := -1 + 23 -- goto _L
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L:
						if l_c = 32 then
							if not l_trail.is_void then
								if (l_s.c_pointer.to_integer_32).to_natural_32 > (l_trail.c_pointer.to_integer_32).to_natural_32 then
									l_c := globals_inst.lcs_trail.item
									l_attr := globals_inst.highlight_attr[0]
								end
							end
						end
				when 24 then -- if done | if done | if done | if done
						if not js.loop_jumped and then (l_c = 0) then
							js.break
						end
						if not js.loop_jumped then
							msg_putchar_attr (l_c, l_attr)
							l_col := l_col + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 25 then -- loop done
					msg_clr_eos
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_putchar (a_c: INTEGER_32)
		do
			msg_putchar_attr (a_c, 0)
		end

	msg_putchar_attr (a_c: INTEGER_32; a_attr: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_buf___6.make (<<22>>)

			if a_c < 0 then
				l_buf___6[0] := (128).to_natural_8
				if a_c = 128 then
					l_buf___6[1] := (254).to_natural_8
				else
					if a_c = 0 then
						l_tmp := 255
					else
						l_tmp := (-a_c).bit_and (255)
					end
					l_buf___6[1] := l_tmp.to_natural_8
				end
				if a_c = 128 then
					l_buf___6[2] := (('X').code).to_natural_8
				elseif a_c = 0 then
					l_buf___6[2] := (('X').code).to_natural_8
				else
					l_buf___6[2] := (((((-a_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
				end
				l_buf___6[3] := (('%/0/').code).to_natural_8
			else
				l_buf___6[(globals_inst.mb_char2bytes.integer_32_item ([a_c, l_buf___6]))] := (('%/0/').code).to_natural_8
			end
			msg_puts_attr (l_buf___6, a_attr)
		end

	msg_puts (a_s: CE_POINTER [NATURAL_8])
		do
			msg_puts_attr (a_s, 0)
		end

	msg_puts_attr (a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		do
			msg_puts_attr_len (a_s, -1, a_attr)
		end

	msg_puts_attr_len (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_attr: INTEGER_32)
		local
			l_attr: INTEGER_32
			js: JUMP_STATE
		do
			l_attr := a_attr
			redir_write (a_str___1, a_maxlen)
			if globals_inst.msg_silent /= 0 then
				js.return
			end
			if not js.return_called then
				if ((l_attr).bit_and (4_096)).to_boolean then
					if a_maxlen < 0 then
						add_msg_hist (a_str___1, -1, l_attr)
						l_attr := (l_attr).bit_and ((-4_097))
					end
				end
				if globals_inst.msg_scrolled /= 0 then
					if not globals_inst.msg_scrolled_ign.to_boolean then
						globals_inst.need_wait_return := 1
					end
				end
				globals_inst.msg_didany := 1
				if (msg_use_printf).to_boolean then
					msg_puts_printf (a_str___1, a_maxlen)
				else
					msg_puts_display (a_str___1, a_maxlen, l_attr, 0)
				end
			end
		end

	msg_puts_display (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_attr: INTEGER_32; a_recurse___2: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_t_s: CE_POINTER [NATURAL_8]
			l_t_col: CE_ARRAY [INTEGER_32]
			l_l: INTEGER_32
			l_cw: INTEGER_32
			l_sb_str: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_sb_col: CE_ARRAY [INTEGER_32]
			l_wrap: INTEGER_32
			l_did_last_char: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_t_s.make
			create l_t_col.make (<<1>>)
			create l_sb_str.make (<<1>>)
			create l_sb_col.make (<<1>>)
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_str___1
					l_t_s := a_str___1
					l_t_col.item := 0
					l_sb_str.item := a_str___1
					l_sb_col.item := globals_inst.msg_col
					globals_inst.did_wait_return := 0
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 46 -- skip loop
					end
				when 2 then -- loop body:
						if not (a_maxlen < 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___3
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if not (l_s.distance (a_str___1) < a_maxlen) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___3:
						if (l_s.item).to_integer_32 = 0 then
							js.break
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						js.break
				when 9 then -- if done
						if not (not js.loop_jumped and then (not a_recurse___2.to_boolean)) then
							l_pos := -1 + 24 -- skip if block
						end
				when 10 then -- if:
						if not (globals_inst.msg_row.to_integer_32 >= globals_inst.Rows.item - 1) then
							l_pos := -1 + 24 -- skip if block
						end
				when 11 then -- if:
						if (l_s.item).to_integer_32 /= 10 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 14 then -- else:
						if not ((globals_inst.msg_col + l_t_col.item).to_integer_32 >= globals_inst.Columns.item - 1) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else:
						if (l_s.item).to_integer_32 /= 9 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if (globals_inst.msg_col + l_t_col.item).to_integer_32 >= (((globals_inst.Columns.item - 1)).bit_and (-8)) then
							l_pos := -1 + 23 -- goto _L___0
						else
							l_pos := -1 + 20 -- goto _L___1
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else: | _L___1:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 21 then -- if:
						if not ((globals_inst.mb_ptr2cells.integer_32_item ([l_s])) > 1) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if not ((globals_inst.msg_col + l_t_col.item).to_integer_32 >= globals_inst.Columns.item - 2) then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | _L___0:
						if l_t_col.item > 0 then
							t_puts (l_t_col, l_t_s, l_s, a_attr)
						end
						if globals_inst.msg_no_more.to_boolean then
							if globals_inst.lines_left = 0 then
								js.break
							end
						end
						if not js.loop_jumped then
							msg_scroll_up
							globals_inst.msg_row := (globals_inst.Rows.item - 2).to_integer_32
							if globals_inst.msg_col.to_integer_32 >= globals_inst.Columns.item then
								globals_inst.msg_col := (globals_inst.Columns.item - 1).to_integer_32
							end
							if (l_s.item).to_integer_32 >= 32 then
								if globals_inst.has_mbyte.to_boolean then
									if globals_inst.enc_utf8.to_boolean then
										if a_maxlen >= 0 then
											l_l := mbyte_inst.utfc_ptr2len_len (l_s, (a_str___1 + a_maxlen).distance (l_s))
										else
											l_l := globals_inst.mb_ptr2len.integer_32_item ([l_s])
										end
									else
										l_l := globals_inst.mb_ptr2len.integer_32_item ([l_s])
									end
									l_s := screen_puts_mbyte (l_s, l_l, a_attr)
								else
									l_tmp := l_s
									l_s := l_s + 1
									msg_screen_putchar ((l_tmp.item).to_integer_32, a_attr)
								end
								l_did_last_char := 1
							else
								l_did_last_char := 0
							end
							if (option_inst.p_more.item).to_boolean then
								store_sb_text (l_sb_str, l_s, a_attr, l_sb_col, 1)
							end
							inc_msg_scrolled
							globals_inst.need_wait_return := 1
							if globals_inst.must_redraw < 10 then
								globals_inst.must_redraw := 10
							end
							globals_inst.redraw_cmdline := 1
							if globals_inst.cmdline_row > 0 then
								if not globals_inst.exmode_active.to_boolean then
									globals_inst.cmdline_row := globals_inst.cmdline_row - 1
								end
							end
							if globals_inst.lines_left > 0 then
								globals_inst.lines_left := globals_inst.lines_left - 1
							end
							if (option_inst.p_more.item).to_boolean then
								if globals_inst.lines_left = 0 then
									if globals_inst.State /= 513 then
										if not globals_inst.msg_no_more.to_boolean then
											if not globals_inst.exmode_active.to_boolean then
												if (do_more_prompt (('%/0/').code)).to_boolean then
													l_s := confirm_msg_tail
												end
												if globals_inst.quit_more.to_boolean then
													js.return
												end
											end
										end
									end
								end
							end
							if not js.return_called and then (l_did_last_char.to_boolean) then
								js.continue
							end
						end
				when 24 then -- if done | if done | if done | if done | if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 45 -- skip if block
						end
				when 25 then -- if:
						if (l_s.item).to_integer_32 = 10 then
							l_tmp___3 := 1
						elseif (globals_inst.msg_col + l_t_col.item).to_integer_32 >= globals_inst.Columns.item then
							l_tmp___3 := 1
						elseif globals_inst.has_mbyte.to_boolean then
							if (globals_inst.mb_ptr2cells.integer_32_item ([l_s])) > 1 then
								if (globals_inst.msg_col + l_t_col.item).to_integer_32 >= globals_inst.Columns.item - 1 then
									l_tmp___3 := 1
								else
									l_tmp___3 := 0
								end
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
						l_wrap := l_tmp___3
						if l_t_col.item > 0 then
							if l_wrap.to_boolean then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							elseif (l_s.item).to_integer_32 = 13 then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							elseif (l_s.item).to_integer_32 = 8 then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							elseif (l_s.item).to_integer_32 = 9 then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							elseif (l_s.item).to_integer_32 = 7 then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							end
						end
						if l_wrap.to_boolean then
							if (option_inst.p_more.item).to_boolean then
								if not a_recurse___2.to_boolean then
									store_sb_text (l_sb_str, l_s, a_attr, l_sb_col, 1)
								end
							end
						end
						if (l_s.item).to_integer_32 /= 10 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						globals_inst.msg_didout := 0
						globals_inst.msg_col := 0
						globals_inst.msg_row := globals_inst.msg_row + 1
						if globals_inst.msg_row.to_integer_32 >= globals_inst.Rows.item then
							globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 28 then -- else:
						if (l_s.item).to_integer_32 /= 13 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						globals_inst.msg_col := 0
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 31 then -- else:
						if (l_s.item).to_integer_32 /= 8 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if globals_inst.msg_col.to_boolean then
							globals_inst.msg_col := globals_inst.msg_col - 1
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 34 then -- else:
						if (l_s.item).to_integer_32 /= 9 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						from
						until
							js.loop_done
						loop
							msg_screen_putchar ((' ').code, a_attr)
							if not ((globals_inst.msg_col).bit_and (7)).to_boolean then
								js.break
							end
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 37 then -- else:
						if (l_s.item).to_integer_32 /= 7 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						misc1_inst.vim_beep
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 40 then -- else:
						if globals_inst.has_mbyte.to_boolean then
							l_cw := globals_inst.mb_ptr2cells.integer_32_item ([l_s])
							if globals_inst.enc_utf8.to_boolean then
								if a_maxlen >= 0 then
									l_l := mbyte_inst.utfc_ptr2len_len (l_s, (a_str___1 + a_maxlen).distance (l_s))
								else
									l_l := globals_inst.mb_ptr2len.integer_32_item ([l_s])
								end
							else
								l_l := globals_inst.mb_ptr2len.integer_32_item ([l_s])
							end
						else
							l_cw := 1
							l_l := 1
						end
						if not (l_cw > 1) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if (globals_inst.msg_col + l_t_col.item).to_integer_32 >= globals_inst.Columns.item - 1 then
							if l_l > 1 then
								l_s := (screen_puts_mbyte (l_s, l_l, a_attr)) - 1
							else
								msg_screen_putchar ((l_s.item).to_integer_32, a_attr)
							end
						else
							l_pos := -1 + 43 -- goto _L___2
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else: | _L___2:
						if l_t_col.item = 0 then
							l_t_s := l_s
						end
						l_t_col.item := l_t_col.item + l_cw
						l_s := l_s + (l_l - 1)
				when 44 then -- if done | if done | if done | if done | if done
						l_s := l_s + 1
				when 45 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 46 then -- loop done
					if not js.return_called then
						if l_t_col.item > 0 then
							t_puts (l_t_col, l_t_s, l_s, a_attr)
						end
						if (option_inst.p_more.item).to_boolean then
							if not a_recurse___2.to_boolean then
								store_sb_text (l_sb_str, l_s, a_attr, l_sb_col, 0)
							end
						end
						msg_check
					end
				when 47 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_puts_long_attr (a_longstr: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		do
			msg_puts_long_len_attr (a_longstr, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_longstr))).to_integer_32, a_attr)
		end

	msg_puts_long_len_attr (a_longstr: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_attr: INTEGER_32)
		local
			l_slen: INTEGER_32
			l_room: INTEGER_32
		do
			l_slen := a_len
			l_room := (globals_inst.Columns.item - globals_inst.msg_col.to_integer_32).to_integer_32
			if a_len > l_room then
				if l_room >= 20 then
					l_slen := (l_room - 3) // 2
					msg_outtrans_len_attr (a_longstr, l_slen, a_attr).do_nothing
					msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("...")), globals_inst.highlight_attr[0])
				end
			end
			msg_outtrans_len_attr ((a_longstr + a_len) - l_slen, l_slen, a_attr).do_nothing
		end

	msg_puts_printf (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_buf___6.make (<<4>>)
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_str___1
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						if (l_s.item).to_integer_32 /= 0 then
							if not (a_maxlen < 0) then
								if not (l_s.distance (a_str___1) < a_maxlen) then
									js.break
								end
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if not (globals_inst.silent_mode.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if option_inst.p_verbose.item /= 0 then
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_p___0 := l_buf___6 + 0
						if (l_s.item).to_integer_32 = 10 then
							if not globals_inst.info_message.to_boolean then
								l_tmp := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp.item := (('%R').code).to_natural_8
							end
						end
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___0.item := l_s.item
						l_p___0.item := (('%/0/').code).to_natural_8
						if globals_inst.info_message.to_boolean then
							mch_msg (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))
						else
							mch_errmsg (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))
						end
				when 7 then
						if (l_s.item).to_integer_32 = 13 then
							globals_inst.msg_col := 0
						elseif (l_s.item).to_integer_32 = 10 then
							globals_inst.msg_col := 0
						else
							globals_inst.msg_col := globals_inst.msg_col + 1
						end
						l_s := l_s + 1
				when 8 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					globals_inst.msg_didout := 1
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_puts_title (a_s: CE_POINTER [NATURAL_8])
		do
			msg_puts_attr (a_s, globals_inst.highlight_attr[14])
		end

	msg_sb_start (a_mps: CE_POINTER [PD_MSGCHUNK_S]): CE_POINTER [PD_MSGCHUNK_S]
		local
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
			js: JUMP_STATE
		do
			create l_mp.make

			l_mp := a_mps
			from
			until
				js.loop_done
			loop
				if not l_mp.is_void then
					if not (l_mp.item.sb_prev).is_void then
						if ((l_mp.item.sb_prev).item.sb_eol).to_boolean then
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_mp := l_mp.item.sb_prev
				end
			end
			Result := l_mp
		end

	msg_screen_putchar (a_c: INTEGER_32; a_attr: INTEGER_32)
		do
			globals_inst.msg_didout := 1
			screen_inst.screen_putchar (a_c, globals_inst.msg_row, globals_inst.msg_col, a_attr)
			globals_inst.msg_col := globals_inst.msg_col + 1
			if globals_inst.msg_col.to_integer_32 >= globals_inst.Columns.item then
				globals_inst.msg_col := 0
				globals_inst.msg_row := globals_inst.msg_row + 1
			end
		end

	msg_scroll_up
		do
			if (gui_inst.gui.item.in_use).to_boolean then
				gui_inst.gui_undraw_cursor
			end
			screen_inst.screen_del_lines (0, 0, 1, (globals_inst.Rows.item).to_integer_32, 1, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)).do_nothing
			if not (screen_inst.can_clear (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))).to_boolean then
				screen_inst.screen_fill ((globals_inst.Rows.item).to_integer_32 - 1, (globals_inst.Rows.item).to_integer_32, 0, (globals_inst.Columns.item).to_integer_32, (' ').code, (' ').code, 0)
				if (globals_inst.ScreenAttrs[(((globals_inst.LineOffset[(globals_inst.Rows.item - 2)]).to_natural_32 + (globals_inst.Columns.item).to_natural_32) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 65_535 then
					screen_inst.screen_fill ((globals_inst.Rows.item).to_integer_32 - 2, (globals_inst.Rows.item).to_integer_32 - 1, (globals_inst.Columns.item).to_integer_32 - 1, (globals_inst.Columns.item).to_integer_32, (' ').code, (' ').code, 0)
				end
			end
		end

	msg_show_console_dialog (a_message: CE_POINTER [NATURAL_8]; a_buttons: CE_POINTER [NATURAL_8]; a_dfltbutton: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_dfltbutton: INTEGER_32
			l_len: INTEGER_32
			l_lenhotkey: INTEGER_32
			l_tmp: INTEGER_32
			l_hotk: CE_POINTER [NATURAL_8]
			l_msgp: CE_POINTER [NATURAL_8]
			l_hotkp: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			l_copy: INTEGER_32
			l_has_hotkey: CE_ARRAY [NATURAL_8]
			l_first_hotkey: INTEGER_32
			l_idx: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___15: NATURAL_32
			l_tmp___19: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hotk.make
			create l_msgp.make
			create l_hotkp.make
			create l_r.make
			create l_has_hotkey.make (<<30>>)
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___8.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___19.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dfltbutton := a_dfltbutton
					l_len := 0
					if globals_inst.has_mbyte.to_boolean then
						l_tmp := 21
					else
						l_tmp := 1
					end
					l_lenhotkey := l_tmp
					l_hotk := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_msgp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_hotkp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_first_hotkey := 0
					l_has_hotkey[0] := (0).to_natural_8
					l_copy := 0
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_copy <= 1)) then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						l_r := a_buttons
						l_idx := 0
				when 3 then -- loop condition:
						if not ((l_r.item).to_boolean) then
							l_pos := -1 + 15 -- skip loop
						end
				when 4 then -- loop body:
						if (l_r.item).to_integer_32 /= 10 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_copy.to_boolean then
							l_tmp___0 := l_msgp
							l_msgp := l_msgp + 1
							l_tmp___0.item := ((',').code).to_natural_8
							l_tmp___1 := l_msgp
							l_msgp := l_msgp + 1
							l_tmp___1.item := ((' ').code).to_natural_8
							if globals_inst.has_mbyte.to_boolean then
								l_hotkp := l_hotkp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_hotkp))).to_integer_32
							else
								l_hotkp := l_hotkp + 1
							end
							l_hotkp[(copy_char (l_r + 1, l_hotkp, 1))] := (('%/0/').code).to_natural_8
							if l_dfltbutton.to_boolean then
								l_dfltbutton := l_dfltbutton - 1
							end
							if l_idx < 29 then
								l_idx := l_idx + 1
								if not (l_has_hotkey[l_idx]).to_boolean then
									l_first_hotkey := 1
								end
							end
						else
							l_len := l_len + (3)
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___4 := 21
							else
								l_tmp___4 := 1
							end
							l_lenhotkey := l_lenhotkey + l_tmp___4
							if l_idx < 29 then
								l_idx := l_idx + 1
								l_has_hotkey[l_idx] := (0).to_natural_8
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if (l_r.item).to_integer_32 /= 38 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not (l_first_hotkey.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						if (l_r.item).to_integer_32 = 38 then
							l_r := l_r + 1
						end
						l_first_hotkey := 0
						if l_copy.to_boolean then
							if (l_r.item).to_integer_32 = 38 then
								l_tmp___5 := l_msgp
								l_msgp := l_msgp + 1
								l_tmp___5.item := l_r.item
							else
								l_tmp___6 := l_msgp
								l_msgp := l_msgp + 1
								if l_dfltbutton = 1 then
									l_tmp___6.item := (('[').code).to_natural_8
								else
									l_tmp___6.item := (('(').code).to_natural_8
								end
								l_msgp := l_msgp + (copy_char (l_r, l_msgp, 0))
								l_tmp___8 := l_msgp
								l_msgp := l_msgp + 1
								if l_dfltbutton = 1 then
									l_tmp___8.item := ((']').code).to_natural_8
								else
									l_tmp___8.item := ((')').code).to_natural_8
								end
								l_hotkp[(copy_char (l_r, l_hotkp, 1))] := (('%/0/').code).to_natural_8
							end
						else
							l_len := l_len + 1
							if l_idx < 29 then
								l_has_hotkey[l_idx] := (1).to_natural_8
							end
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						if l_copy.to_boolean then
							l_msgp := l_msgp + (copy_char (l_r, l_msgp, 0))
						end
				when 14 then -- if done | if done
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___12 := (globals_inst.mb_ptr2len.integer_32_item ([l_r]))
						else
							l_tmp___12 := 1
						end
						l_r := l_r + l_tmp___12
						l_pos := -1 + 3 -- back to loop condition
				when 15 then -- loop done
						if l_copy.to_boolean then
							l_tmp___13 := l_msgp
							l_msgp := l_msgp + 1
							l_tmp___13.item := ((':').code).to_natural_8
							l_tmp___14 := l_msgp
							l_msgp := l_msgp + 1
							l_tmp___14.item := ((' ').code).to_natural_8
							l_msgp.item := (('%/0/').code).to_natural_8
						else
							l_tmp___15 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_message))
							l_len := l_len + (((l_tmp___15 + {NATURAL_32} 2) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buttons)))) + {NATURAL_32} 3).to_integer_32
							l_lenhotkey := l_lenhotkey + 1
							if not (l_has_hotkey[0]).to_boolean then
								l_first_hotkey := 1
								l_len := l_len + (2)
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (confirm_msg))
							confirm_msg := misc2_inst.alloc (l_len.to_natural_32)
							if confirm_msg.is_void then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
							if not js.return_called then
								confirm_msg.item := (('%/0/').code).to_natural_8
								l_hotk := misc2_inst.alloc (l_lenhotkey.to_natural_32)
								if l_hotk.is_void then
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									js.return
								end
							end
							if not js.return_called then
								confirm_msg.item := (('%N').code).to_natural_8
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((confirm_msg + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (a_message)).do_nothing
								l_msgp := (confirm_msg + 1) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_message))).to_integer_32
								l_hotkp := l_hotk
								l_hotkp[(copy_char (a_buttons, l_hotkp, 1))] := (('%/0/').code).to_natural_8
								confirm_msg_tail := l_msgp
								l_tmp___19 := l_msgp
								l_msgp := l_msgp + 1
								l_tmp___19.item := (('%N').code).to_natural_8
							end
						end
						if not js.return_called then
							l_copy := l_copy + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					if not js.return_called then
						display_confirm_msg
						Result := l_hotk
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_source (a_attr: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					globals_inst.no_wait_return := globals_inst.no_wait_return + 1
					l_p___0 := get_emsg_source
					if not l_p___0.is_void then
						msg_attr (l_p___0, a_attr).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
					end
					l_p___0 := get_emsg_lnum
					if not l_p___0.is_void then
						msg_attr (l_p___0, globals_inst.highlight_attr[9]).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						last_sourcing_lnum := globals_inst.sourcing_lnum.to_integer_32
					end
					if not (globals_inst.sourcing_name.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((other_sourcing_name).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (last_sourcing_name))
						if globals_inst.sourcing_name.is_void then
							last_sourcing_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						else
							last_sourcing_name := misc2_inst.vim_strsave (globals_inst.sourcing_name)
						end
				when 5 then -- if done
						globals_inst.no_wait_return := globals_inst.no_wait_return - 1
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	msg_start
		local
			l_did_return: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_return := 0
					if not globals_inst.msg_silent.to_boolean then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.keep_msg))
						globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if globals_inst.need_clr_eos.to_boolean then
						globals_inst.need_clr_eos := 0
						msg_clr_eos
					end
					if globals_inst.msg_scroll.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.full_screen.to_boolean then
							globals_inst.msg_row := globals_inst.cmdline_row
							globals_inst.msg_col := 0
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if globals_inst.msg_didout.to_boolean then
							msg_putchar (('%N').code)
							l_did_return := 1
							if globals_inst.exmode_active /= 1 then
								globals_inst.cmdline_row := globals_inst.msg_row
							end
						end
				when 4 then
					if not globals_inst.msg_didany.to_boolean then
						msg_starthere
					elseif globals_inst.lines_left < 0 then
						msg_starthere
					end
					if globals_inst.msg_silent = 0 then
						globals_inst.msg_didout := 0
						term_inst.cursor_off
					end
					if not l_did_return.to_boolean then
						redir_write (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")), -1)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_starthere
		do
			globals_inst.lines_left := globals_inst.cmdline_row
			globals_inst.msg_didany := 0
		end

	msg_strtrunc (a_s: CE_POINTER [NATURAL_8]; a_force: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_room: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_buf___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					if globals_inst.msg_scroll.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not globals_inst.need_wait_return.to_boolean then
							if (option_inst.shortmess (('T').code)).to_boolean then
								if not globals_inst.exmode_active.to_boolean then
									if globals_inst.msg_silent = 0 then
										l_pos := -1 + 4 -- goto _L
									else
										l_pos := -1 + 3 -- goto _L___3
									end
								else
									l_pos := -1 + 3 -- goto _L___3
								end
							else
								l_pos := -1 + 3 -- goto _L___3
							end
						else
							l_pos := -1 + 3 -- goto _L___3
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else: | _L___3:
						if not (a_force.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_len := charset_inst.vim_strsize (a_s)
						if globals_inst.msg_scrolled /= 0 then
							l_room := (((globals_inst.Rows.item - globals_inst.msg_row.to_integer_32).to_integer_32).to_integer_32 * globals_inst.Columns.item - 1).to_integer_32
						else
							l_room := (((((globals_inst.Rows.item - globals_inst.msg_row.to_integer_32) - 1).to_integer_32).to_integer_32 * globals_inst.Columns.item + globals_inst.sc_col.to_integer_32) - 1).to_integer_32
						end
						if l_len > l_room then
							if l_room > 0 then
								if globals_inst.enc_utf8.to_boolean then
									l_buf___6 := misc2_inst.alloc (((l_room + 2) * 18).to_natural_32)
								elseif globals_inst.enc_dbcs = 9_932 then
									l_buf___6 := misc2_inst.alloc (((l_room + 2) * 2).to_natural_32)
								else
									l_buf___6 := misc2_inst.alloc ((l_room + 2).to_natural_32)
								end
								if not l_buf___6.is_void then
									trunc_string (a_s, l_buf___6, l_room)
								end
							end
						end
				when 5 then -- if done
						Result := l_buf___6
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	msg_trunc_attr (a_s: CE_POINTER [NATURAL_8]; a_force: INTEGER_32; a_attr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s := a_s
			add_msg_hist (l_s, -1, a_attr)
			l_s := msg_may_trunc (a_force, l_s)
			globals_inst.msg_hist_off := 1
			l_n := msg_attr (l_s, a_attr)
			globals_inst.msg_hist_off := 0
			if l_n.to_boolean then
				Result := l_s
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	msg_use_printf: INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (msg_check_screen).to_boolean then
				if (term_inst.swapping_screen).to_boolean then
					if not globals_inst.termcap_active.to_boolean then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 1
			end
			Result := l_tmp___1
		end

	other_sourcing_name: INTEGER_32
		local
			js: JUMP_STATE
		do
			if not globals_inst.sourcing_name.is_void then
				if not last_sourcing_name.is_void then
					Result := ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.sourcing_name), create {CE_POINTER [INTEGER_8]}.make_cast (last_sourcing_name))) /= 0).to_integer
					js.return
				end
				if not js.return_called then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	redir_write (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := a_str___1
			if globals_inst.redir_off.to_boolean then
				js.return
			end
			if not js.return_called then
				if (option_inst.p_vfile.item.item).to_integer_32 /= 0 then
					verbose_write (l_s, a_maxlen)
				end
				if (redirecting).to_boolean then
					if (l_s.item).to_integer_32 /= 10 then
						if (l_s.item).to_integer_32 /= 13 then
							from
							until
								not (cur_col < globals_inst.msg_col)
							loop
								if globals_inst.redir_reg.to_boolean then
									ops_inst.write_reg_contents (globals_inst.redir_reg, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), -1, 1)
								elseif globals_inst.redir_vname.to_boolean then
									eval_inst.var_redir_str (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), -1)
								elseif (not globals_inst.redir_fd.is_void) then
									fputs (ce_string (" "), globals_inst.redir_fd).do_nothing
								end
								cur_col := cur_col + 1
							end
						end
					end
					if globals_inst.redir_reg.to_boolean then
						ops_inst.write_reg_contents (globals_inst.redir_reg, l_s, a_maxlen, 1)
					end
					if globals_inst.redir_vname.to_boolean then
						eval_inst.var_redir_str (l_s, a_maxlen)
					end
					from
					until
						js.loop_done
					loop
						if (l_s.item).to_integer_32 /= 0 then
							if not (a_maxlen < 0) then
								if not (l_s.distance (a_str___1) < a_maxlen) then
									js.break
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							if not globals_inst.redir_reg.to_boolean then
								if not globals_inst.redir_vname.to_boolean then
									if not globals_inst.redir_fd.is_void then
										IO_putc ((l_s.item).to_integer_32, globals_inst.redir_fd).do_nothing
									end
								end
							end
							if (l_s.item).to_integer_32 = 13 then
								cur_col := 0
							elseif (l_s.item).to_integer_32 = 10 then
								cur_col := 0
							elseif (l_s.item).to_integer_32 = 9 then
								cur_col := cur_col + (8 - cur_col \\ 8)
							else
								cur_col := cur_col + 1
							end
							l_s := l_s + 1
						end
					end
					if globals_inst.msg_silent /= 0 then
						globals_inst.msg_col := cur_col
					end
				end
			end
		end

	redirecting: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not globals_inst.redir_fd.is_void then
				l_tmp := 1
			elseif globals_inst.redir_reg.to_boolean then
				l_tmp := 1
			elseif globals_inst.redir_vname.to_boolean then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	repeat_message
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.State /= 768 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						msg_moremsg (1)
						globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 3 then -- else:
						if globals_inst.State /= 2_048 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						display_confirm_msg
						globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						if globals_inst.State /= 1_536 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else:
						if globals_inst.State /= 513 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if globals_inst.State /= 1_024 then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						if globals_inst.msg_row.to_integer_32 = globals_inst.Rows.item - 1 then
							globals_inst.msg_didout := 0
							globals_inst.msg_col := 0
							msg_clr_eos
						end
						hit_return_msg
						globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
				when 14 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	reset_last_sourcing
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (last_sourcing_name))
			last_sourcing_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			last_sourcing_lnum := 0
		end

	screen_puts_mbyte (a_s: CE_POINTER [NATURAL_8]; a_l: INTEGER_32; a_attr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_cw: INTEGER_32
			js: JUMP_STATE
		do
			globals_inst.msg_didout := 1
			l_cw := globals_inst.mb_ptr2cells.integer_32_item ([a_s])
			if l_cw > 1 then
				if globals_inst.msg_col.to_integer_32 = globals_inst.Columns.item - 1 then
					msg_screen_putchar (('>').code, globals_inst.highlight_attr[1])
					Result := a_s
					js.return
				end
			end
			if not js.return_called then
				screen_inst.screen_puts_len (a_s, a_l, globals_inst.msg_row, globals_inst.msg_col, a_attr)
				globals_inst.msg_col := globals_inst.msg_col + l_cw
				if globals_inst.msg_col.to_integer_32 >= globals_inst.Columns.item then
					globals_inst.msg_col := 0
					globals_inst.msg_row := globals_inst.msg_row + 1
				end
				Result := (a_s + a_l)
			end
		end

	set_keep_msg (a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.keep_msg))
			if not a_s.is_void then
				if globals_inst.msg_silent = 0 then
					globals_inst.keep_msg := misc2_inst.vim_strsave (a_s)
				else
					globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
			else
				globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			globals_inst.keep_msg_more := 0
			globals_inst.keep_msg_attr := a_attr
		end

	set_keep_msg_from_hist
		do
			if globals_inst.keep_msg.is_void then
				if not last_msg_hist.is_void then
					if globals_inst.msg_scrolled = 0 then
						if ((globals_inst.State).bit_and (1)).to_boolean then
							set_keep_msg (last_msg_hist.item.msg, last_msg_hist.item.attr)
						end
					end
				end
			end
		end

	show_sb_text
		local
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
		do
			create l_mp.make

			l_mp := msg_sb_start (last_msgchunk)
			if l_mp.is_void then
				misc1_inst.vim_beep
			elseif (l_mp.item.sb_prev).is_void then
				misc1_inst.vim_beep
			else
				do_more_prompt (('G').code).do_nothing
				wait_return (0)
			end
		end

	smsg (a_args: TUPLE [a_s: CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_arglist: CE_VA_LIST
		do
			create l_arglist.make_shared (default_pointer)

			l_arglist := create {CE_VA_LIST}.make (a_args, 2)
			vim_vsnprintf (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, create {CE_POINTER [INTEGER_8]}.make_cast (a_args.a_s), l_arglist.twin, create {CE_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer)).do_nothing
			Result := (msg (globals_inst.IObuff))
		end

	smsg_attr (a_args: TUPLE [a_attr: INTEGER_32; a_s: CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_arglist: CE_VA_LIST
		do
			create l_arglist.make_shared (default_pointer)

			l_arglist := create {CE_VA_LIST}.make (a_args, 3)
			vim_vsnprintf (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, create {CE_POINTER [INTEGER_8]}.make_cast (a_args.a_s), l_arglist.twin, create {CE_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer)).do_nothing
			Result := (msg_attr (globals_inst.IObuff, a_args.a_attr))
		end

	store_sb_text (a_sb_str: CE_POINTER [CE_POINTER [NATURAL_8]]; a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32; a_sb_col: CE_POINTER [INTEGER_32]; a_finish: INTEGER_32)
		local
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
		do
			create l_mp.make

			if do_clear_sb_text.to_boolean then
				clear_sb_text
				do_clear_sb_text := 0
			end
			if (a_s.c_pointer.to_integer_32).to_natural_32 > ((a_sb_str.item).c_pointer.to_integer_32).to_natural_32 then
				l_mp := create {CE_POINTER [PD_MSGCHUNK_S]}.make_cast ((misc2_inst.alloc ((((create {PD_MSGCHUNK_S}.make).structure_size.to_natural_32 + (a_s.distance ((a_sb_str.item))).to_natural_32).to_integer_32).to_natural_32)))
				if not l_mp.is_void then
					l_mp.item.sb_eol := a_finish.to_integer_8
					l_mp.item.sb_msg_col := a_sb_col.item
					l_mp.item.sb_attr := a_attr
					misc2_inst.vim_strncpy (l_mp.item.sb_text, a_sb_str.item, (a_s.distance ((a_sb_str.item))).to_natural_32)
					if last_msgchunk.is_void then
						last_msgchunk := l_mp
						l_mp.item.sb_prev := create {CE_POINTER [PD_MSGCHUNK_S]}.make_shared (default_pointer)
					else
						l_mp.item.sb_prev := last_msgchunk
						last_msgchunk.item.sb_next := l_mp
						last_msgchunk := l_mp
					end
					l_mp.item.sb_next := create {CE_POINTER [PD_MSGCHUNK_S]}.make_shared (default_pointer)
				end
			elseif a_finish.to_boolean then
				if not last_msgchunk.is_void then
					last_msgchunk.item.sb_eol := (1).to_integer_8
				end
			end
			a_sb_str.item := a_s
			a_sb_col.item := 0
		end

	str2special (a_sp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_from: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_c: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_modifiers: INTEGER_32
			l_special: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_str___1.make
			create l_p___0.make
			create l_tmp___1.make

			l_str___1 := a_sp.item
			l_modifiers := 0
			l_special := 0
			if globals_inst.has_mbyte.to_boolean then
				l_p___0 := mbyte_inst.mb_unescape (a_sp)
				if not l_p___0.is_void then
					Result := l_p___0
					js.return
				end
			end
			if not js.return_called then
				l_c := (l_str___1.item).to_integer_32
				if l_c = 128 then
					if (l_str___1[1]).to_integer_32 /= 0 then
						if (l_str___1[2]).to_integer_32 /= 0 then
							if (l_str___1[1]).to_integer_32 = 252 then
								l_modifiers := (l_str___1[2]).to_integer_32
								l_str___1 := l_str___1 + (3)
								l_c := (l_str___1.item).to_integer_32
							end
							if l_c = 128 then
								if (l_str___1[1]).to_integer_32 /= 0 then
									if (l_str___1[2]).to_integer_32 /= 0 then
										if (l_str___1[1]).to_integer_32 = 254 then
											l_c := 128
										else
											if (l_str___1[1]).to_integer_32 = 255 then
												l_tmp := -(255 + ((88).bit_shift_left (8)))
											else
												l_tmp := -((l_str___1[1]).to_integer_32 + (((l_str___1[2]).to_integer_32).bit_shift_left (8)))
											end
											l_c := l_tmp
										end
										l_str___1 := l_str___1 + (2)
										if l_c = -(255 + ((88).bit_shift_left (8))) then
											l_c := ('%/0/').code
										end
									end
								end
							end
							if l_c < 0 then
								l_special := 1
							elseif l_modifiers.to_boolean then
								l_special := 1
							end
						end
					end
				end
				a_sp.item := l_str___1 + 1
				if globals_inst.has_mbyte.to_boolean then
					if (globals_inst.mb_bytelen_tab[(l_str___1.item).to_integer_32]).to_integer_32 > (globals_inst.mb_ptr2len.integer_32_item ([l_str___1])) then
						charset_inst.transchar_nonprint (buf___0, l_c)
						Result := buf___0
						js.return
					end
				end
			end
			if not js.return_called then
				if l_special.to_boolean then
					l_tmp___1 := misc2_inst.get_special_key_name (l_c, l_modifiers)
					Result := l_tmp___1
					js.return
				elseif (charset_inst.char2cells (l_c)) > 1 then
					l_tmp___1 := misc2_inst.get_special_key_name (l_c, l_modifiers)
					Result := l_tmp___1
					js.return
				elseif a_from.to_boolean then
					if l_c = 32 then
						l_tmp___1 := misc2_inst.get_special_key_name (l_c, l_modifiers)
						Result := l_tmp___1
						js.return
					end
				end
			end
			if not js.return_called then
				buf___0[0] := l_c.to_natural_8
				buf___0[1] := (('%/0/').code).to_natural_8
				Result := buf___0
			end
		end

	str2specialbuf (a_sp: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_sp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
		do
			create l_sp.make (<<1>>)
			create l_s.make

			l_sp.item := a_sp
			a_buf___6.item := (('%/0/').code).to_natural_8
			from
			until
				not ((l_sp.item.item).to_boolean)
			loop
				l_s := str2special (l_sp, 0)
				l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))
				if (l_tmp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6)))).to_integer_32 < a_len then
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (l_s)).do_nothing
				end
			end
		end

	t_puts (a_t_col: CE_POINTER [INTEGER_32]; a_t_s: CE_POINTER [NATURAL_8]; a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		do
			globals_inst.msg_didout := 1
			screen_inst.screen_puts_len (a_t_s, a_s.distance (a_t_s), globals_inst.msg_row, globals_inst.msg_col, a_attr)
			globals_inst.msg_col := globals_inst.msg_col + (a_t_col.item)
			a_t_col.item := 0
			if globals_inst.enc_utf8.to_boolean then
				if (mbyte_inst.utf_iscomposing ((mbyte_inst.utf_ptr2char (a_t_s)))).to_boolean then
					globals_inst.msg_col := globals_inst.msg_col - 1
				end
			end
			if globals_inst.msg_col.to_integer_32 >= globals_inst.Columns.item then
				globals_inst.msg_col := 0
				globals_inst.msg_row := globals_inst.msg_row + 1
			end
		end

	trunc_string (a_s: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [NATURAL_8]; a_room: INTEGER_32)
		local
			l_room: INTEGER_32
			l_half: INTEGER_32
			l_len: INTEGER_32
			l_e: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			l_room := a_room
			l_room := l_room - (3)
			l_half := l_room // 2
			l_len := 0
			l_e := 0
			from
			until
				not (not js.loop_done and then (l_len < l_half))
			loop
				if (a_s[l_e]).to_integer_32 = 0 then
					a_buf___6[l_e] := (('%/0/').code).to_natural_8
					js.return
				end
				if not js.return_called then
					l_n := charset_inst.ptr2cells (a_s + l_e)
					if l_len + l_n >= l_half then
						js.break
					end
					if not js.loop_jumped then
						l_len := l_len + l_n
						a_buf___6[l_e] := a_s[l_e]
						if globals_inst.has_mbyte.to_boolean then
							l_n := globals_inst.mb_ptr2len.integer_32_item ([a_s + l_e])
							from
							until
								js.loop_done
							loop
								l_n := l_n - 1
								if not (l_n > 0) then
									js.break
								end
								if not js.loop_jumped then
									l_e := l_e + 1
									a_buf___6[l_e] := a_s[l_e]
								end
							end
						end
						l_e := l_e + 1
					end
				end
			end
			if not js.return_called then
				l_i___0 := l_e
				if globals_inst.enc_dbcs /= 0 then
					l_n := charset_inst.vim_strsize (a_s + l_i___0)
					from
					until
						not (l_len + l_n > l_room)
					loop
						l_n := l_n - (charset_inst.ptr2cells (a_s + l_i___0))
						l_i___0 := l_i___0 + (globals_inst.mb_ptr2len.integer_32_item ([a_s + l_i___0]))
					end
				elseif globals_inst.enc_utf8.to_boolean then
					l_i___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_integer_32
					l_half := l_i___0
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							l_half := (l_half - (globals_inst.mb_head_off.integer_32_item ([a_s, (a_s + l_half) - 1]))) - 1
							if (mbyte_inst.utf_iscomposing ((mbyte_inst.utf_ptr2char (a_s + l_half)))).to_boolean then
								if not (l_half > 0) then
									js.break
								end
							else
								js.break
							end
						end
						l_n := charset_inst.ptr2cells (a_s + l_half)
						if l_len + l_n > l_room then
							js.break
						end
						if not js.loop_jumped then
							l_len := l_len + l_n
							l_i___0 := l_half
						end
					end
				else
					l_i___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_integer_32
					from
					until
						js.loop_done
					loop
						l_n := charset_inst.ptr2cells ((a_s + l_i___0) - 1)
						if not (l_len + l_n <= l_room) then
							js.break
						end
						if not js.loop_jumped then
							l_len := l_len + l_n
							l_i___0 := l_i___0 - 1
						end
					end
				end
				memmove (create {CE_POINTER [ANY]}.make_cast ((a_buf___6 + l_e)), create {CE_POINTER [ANY]}.make_cast (ce_string ("...")), (3).to_natural_32).do_nothing
				memmove (create {CE_POINTER [ANY]}.make_cast (((a_buf___6 + l_e) + 3)), create {CE_POINTER [ANY]}.make_cast ((a_s + l_i___0)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_s + l_i___0)))) + {NATURAL_32} 1).do_nothing
			end
		end

	tv_float (a_tvs: CE_POINTER [PD_TYPVAL_T]; a_idxp: CE_POINTER [INTEGER_32]): REAL_64
		local
			l_idx: INTEGER_32
			l_f: REAL_64
		do
			l_idx := a_idxp.item - 1
			l_f := (0).to_double
			if ((a_tvs + l_idx).item.v_type).to_integer_32 = 0 then
				emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_printf)))).do_nothing
			else
				a_idxp.item := (a_idxp.item) + 1
				if ((a_tvs + l_idx).item.v_type).to_integer_32 = 6 then
					l_f := (a_tvs + l_idx).item.vval.v_float
				elseif ((a_tvs + l_idx).item.v_type).to_integer_32 = 1 then
					l_f := ((a_tvs + l_idx).item.vval.v_number).to_double
				else
					emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E807: Expected Float argument for printf()"))))).do_nothing
				end
			end
			Result := l_f
		end

	tv_nr (a_tvs: CE_POINTER [PD_TYPVAL_T]; a_idxp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_idx: INTEGER_32
			l_n: INTEGER_32
			l_err: CE_ARRAY [INTEGER_32]
		do
			create l_err.make (<<1>>)

			l_idx := a_idxp.item - 1
			l_n := 0
			l_err.item := 0
			if ((a_tvs + l_idx).item.v_type).to_integer_32 = 0 then
				emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_printf)))).do_nothing
			else
				a_idxp.item := (a_idxp.item) + 1
				l_n := eval_inst.get_tv_number_chk (a_tvs + l_idx, l_err)
				if (l_err.item).to_boolean then
					l_n := 0
				end
			end
			Result := l_n
		end

	tv_str (a_tvs: CE_POINTER [PD_TYPVAL_T]; a_idxp: CE_POINTER [INTEGER_32]): CE_POINTER [INTEGER_8]
		local
			l_idx: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
		do
			create l_s.make

			l_idx := a_idxp.item - 1
			l_s := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			if ((a_tvs + l_idx).item.v_type).to_integer_32 = 0 then
				emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_printf)))).do_nothing
			else
				a_idxp.item := (a_idxp.item) + 1
				l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((eval_inst.get_tv_string_chk (a_tvs + l_idx)))
			end
			Result := l_s
		end

	verb_msg (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_n: INTEGER_32
		do
			verbose_enter
			l_n := msg_attr_keep (a_s, 0, 0)
			verbose_leave
			Result := l_n
		end

	verbose_enter
		do
			if (option_inst.p_vfile.item.item).to_integer_32 /= 0 then
				globals_inst.msg_silent := globals_inst.msg_silent + 1
			end
		end

	verbose_enter_scroll
		do
			if (option_inst.p_vfile.item.item).to_integer_32 /= 0 then
				globals_inst.msg_silent := globals_inst.msg_silent + 1
			else
				globals_inst.msg_scroll := 1
			end
		end

	verbose_leave
		do
			if (option_inst.p_vfile.item.item).to_integer_32 /= 0 then
				globals_inst.msg_silent := globals_inst.msg_silent - 1
				if globals_inst.msg_silent < 0 then
					globals_inst.msg_silent := 0
				end
			end
		end

	verbose_leave_scroll
		do
			if (option_inst.p_vfile.item.item).to_integer_32 /= 0 then
				globals_inst.msg_silent := globals_inst.msg_silent - 1
				if globals_inst.msg_silent < 0 then
					globals_inst.msg_silent := 0
				end
			else
				globals_inst.cmdline_row := globals_inst.msg_row
			end
		end

	verbose_open: INTEGER_32
		local
			js: JUMP_STATE
		do
			if verbose_fd.is_void then
				if not verbose_did_open.to_boolean then
					verbose_did_open := 1
					verbose_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_vfile.item), ce_string ("a"))
					if verbose_fd.is_void then
						emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), option_inst.p_vfile.item).do_nothing
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	verbose_stop
		do
			if not verbose_fd.is_void then
				fclose (verbose_fd).do_nothing
				verbose_fd := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			end
			verbose_did_open := 0
		end

	verbose_write (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s := a_str___1
			if verbose_fd.is_void then
				verbose_open.do_nothing
			end
			if not verbose_fd.is_void then
				if (l_s.item).to_integer_32 /= 10 then
					if (l_s.item).to_integer_32 /= 13 then
						from
						until
							not (cur_col___0 < globals_inst.msg_col)
						loop
							fputs (ce_string (" "), verbose_fd).do_nothing
							cur_col___0 := cur_col___0 + 1
						end
					end
				end
				from
				until
					js.loop_done
				loop
					if (l_s.item).to_integer_32 /= 0 then
						if not (a_maxlen < 0) then
							if not (l_s.distance (a_str___1) < a_maxlen) then
								js.break
							end
						end
					else
						js.break
					end
					if not js.loop_jumped then
						IO_putc ((l_s.item).to_integer_32, verbose_fd).do_nothing
						if (l_s.item).to_integer_32 = 13 then
							cur_col___0 := 0
						elseif (l_s.item).to_integer_32 = 10 then
							cur_col___0 := 0
						elseif (l_s.item).to_integer_32 = 9 then
							cur_col___0 := cur_col___0 + (8 - cur_col___0 \\ 8)
						else
							cur_col___0 := cur_col___0 + 1
						end
						l_s := l_s + 1
					end
				end
			end
		end

	vim_dialog_yesno (a_type: INTEGER_32; a_title: CE_POINTER [NATURAL_8]; a_message: CE_POINTER [NATURAL_8]; a_dflt: INTEGER_32): INTEGER_32
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_tmp.make
			create l_tmp___1.make

			l_tmp := gettext (ce_string ("&Yes%N&No"))
			if a_title.is_void then
				l_tmp___1 := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Question"))))
			else
				l_tmp___1 := a_title
			end
			if (do_dialog (a_type, l_tmp___1, a_message, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), a_dflt, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 1 then
				Result := 2
				js.return
			end
			if not js.return_called then
				Result := 3
			end
		end

	vim_dialog_yesnoallcancel (a_type: INTEGER_32; a_title: CE_POINTER [NATURAL_8]; a_message: CE_POINTER [NATURAL_8]; a_dflt: INTEGER_32): INTEGER_32
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := gettext (ce_string ("&Yes%N&No%NSave &All%N&Discard All%N&Cancel"))
					if a_title.is_void then
						l_tmp___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Question"))
					else
						l_tmp___0 := a_title
					end
					inspect (do_dialog (a_type, l_tmp___0, a_message, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), a_dflt, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 1
					Result := 2
					js.return
				when 2 then -- switch 1, case 2
					if not js.return_called then
						Result := 3
						js.return
					end
				when 3 then -- switch 1, case 3
					if not js.return_called then
						Result := 5
						js.return
					end
				when 4 then -- switch 1, case 4
					if not js.return_called then
						Result := 6
						js.return
					end
				when 5 then -- switch 1, done:
					if not js.return_called then
						Result := 4
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_dialog_yesnocancel (a_type: INTEGER_32; a_title: CE_POINTER [NATURAL_8]; a_message: CE_POINTER [NATURAL_8]; a_dflt: INTEGER_32): INTEGER_32
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := gettext (ce_string ("&Yes%N&No%N&Cancel"))
					if a_title.is_void then
						l_tmp___1 := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Question"))))
					else
						l_tmp___1 := a_title
					end
					inspect (do_dialog (a_type, l_tmp___1, a_message, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), a_dflt, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1
					Result := 2
					js.return
				when 2 then -- switch 1, case 2
					if not js.return_called then
						Result := 3
						js.return
					end
				when 3 then -- switch 1, done:
					if not js.return_called then
						Result := 4
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_snprintf (a_args: TUPLE [a_str___1: CE_POINTER [INTEGER_8]; a_str_m: NATURAL_32; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_ap___0: CE_VA_LIST
			l_str_l: INTEGER_32
		do
			create l_ap___0.make_shared (default_pointer)

			l_ap___0 := create {CE_VA_LIST}.make (a_args, 4)
			l_str_l := vim_vsnprintf (a_args.a_str___1, a_args.a_str_m, a_args.a_fmt, l_ap___0.twin, create {CE_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer))
			Result := l_str_l
		end

	vim_snprintf_add (a_args: TUPLE [a_str___1: CE_POINTER [INTEGER_8]; a_str_m: NATURAL_32; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_ap___0: CE_VA_LIST
			l_str_l: INTEGER_32
			l_len: NATURAL_32
			l_space: NATURAL_32
		do
			create l_ap___0.make_shared (default_pointer)

			l_len := (strlen (a_args.a_str___1))
			if a_args.a_str_m <= l_len then
				l_space := (0).to_natural_32
			else
				l_space := a_args.a_str_m - l_len
			end
			l_ap___0 := create {CE_VA_LIST}.make (a_args, 4)
			l_str_l := vim_vsnprintf (a_args.a_str___1 + l_len.to_integer_32, l_space, a_args.a_fmt, l_ap___0.twin, create {CE_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer))
			Result := l_str_l
		end

	vim_vsnprintf (a_str___1: CE_POINTER [INTEGER_8]; a_str_m: NATURAL_32; a_fmt: CE_POINTER [INTEGER_8]; a_ap___0: CE_VA_LIST; a_tvs: CE_POINTER [PD_TYPVAL_T]): INTEGER_32
		local
			l_ap___0: CE_VA_LIST
			l_str_l: NATURAL_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_arg_idx: CE_ARRAY [INTEGER_32]
			l_q: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_tmp___1: NATURAL_32
			l_avail: NATURAL_32
			l_tmp___2: NATURAL_32
			l_min_field_width: NATURAL_32
			l_precision: NATURAL_32
			l_zero_padding: INTEGER_32
			l_precision_specified: INTEGER_32
			l_justify_left: INTEGER_32
			l_alternate_form: INTEGER_32
			l_force_sign: INTEGER_32
			l_space_for_positive: INTEGER_32
			l_length_modifier: INTEGER_8
			l_tmp___3: CE_ARRAY [INTEGER_8]
			l_str_arg: CE_POINTER [INTEGER_8]
			l_str_arg_l: NATURAL_32
			l_uchar_arg: CE_ARRAY [NATURAL_8]
			l_number_of_zeros_to_pad: NATURAL_32
			l_zero_padding_insertion_ind: NATURAL_32
			l_fmt_spec: INTEGER_8
			l_j: INTEGER_32
			l_uj: NATURAL_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_j___0: INTEGER_32
			l_uj___0: NATURAL_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_j___1: INTEGER_32
			l_q___0: CE_POINTER [INTEGER_8]
			l_tmp___16: NATURAL_32
			l_arg_sign: INTEGER_32
			l_int_arg: INTEGER_32
			l_uint_arg: NATURAL_32
			l_long_arg: INTEGER_32
			l_ulong_arg: NATURAL_32
			l_ptr_arg: CE_POINTER [ANY]
			l_tmp___28: NATURAL_32
			l_tmp___29: NATURAL_32
			l_tmp___30: NATURAL_32
			l_f: CE_ARRAY [INTEGER_8]
			l_f_l: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_num_of_digits: NATURAL_32
			l_n___0: INTEGER_32
			l_f___0: REAL_64
			l_abs_f: REAL_64
			l_format: CE_ARRAY [INTEGER_8]
			l_l: INTEGER_32
			l_remove_trailing_zeroes: INTEGER_32
			l_max_prec: NATURAL_32
			l_i___0: INTEGER_32
			l_tp: CE_POINTER [INTEGER_8]
			l_tmp___47: INTEGER_32
			l_tp___0: CE_POINTER [INTEGER_8]
			l_tmp___52: INTEGER_32
			l_pn: INTEGER_32
			l_avail___0: NATURAL_32
			l_tmp___57: NATURAL_32
			l_tmp___58: INTEGER_32
			l_zn: INTEGER_32
			l_avail___1: NATURAL_32
			l_tmp___59: NATURAL_32
			l_avail___2: NATURAL_32
			l_tmp___60: NATURAL_32
			l_sn: INTEGER_32
			l_avail___3: NATURAL_32
			l_tmp___61: NATURAL_32
			l_pn___0: INTEGER_32
			l_avail___4: NATURAL_32
			l_tmp___62: NATURAL_32
			l_tmp___63: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ap___0.make_shared (default_pointer)
			create l_p___0.make
			create l_arg_idx.make (<<1>>)
			create l_q.make
			create l_tmp___3.make (<<350>>)
			create l_str_arg.make
			create l_uchar_arg.make (<<1>>)
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_q___0.make
			create l_ptr_arg.make
			create l_f.make (<<5>>)
			create l_format.make (<<40>>)
			create l_tp.make
			create l_tp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap___0 := a_ap___0.twin
					l_str_l := (0).to_natural_32
					l_p___0 := a_fmt
					l_arg_idx.item := 1
					if l_p___0.is_void then
						l_p___0 := ce_string ("")
					end
				when 1 then -- loop condition:
					if not (not js.loop_done and then ((l_p___0[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 104 -- skip loop
					end
				when 2 then -- loop body:
						if (l_p___0[0]).to_integer_32 = 37 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_q := (strchr ((l_p___0 + 1), ('%%').code))
						if l_q.is_void then
							l_tmp___1 := (strlen (l_p___0))
						else
							l_tmp___1 := (l_q.distance (l_p___0)).to_natural_32
						end
						l_n := l_tmp___1
						if l_str_l < a_str_m then
							l_avail := a_str_m - l_str_l
							if l_n > l_avail then
								l_tmp___2 := l_avail
							else
								l_tmp___2 := l_n
							end
							memmove (create {CE_POINTER [ANY]}.make_cast ((a_str___1 + l_str_l.to_integer_32)), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_tmp___2).do_nothing
						end
						l_p___0 := l_p___0 + l_n.to_integer_32
						l_str_l := l_str_l + l_n
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 5 then -- else:
						l_min_field_width := (0).to_natural_32
						l_precision := (0).to_natural_32
						l_zero_padding := 0
						l_precision_specified := 0
						l_justify_left := 0
						l_alternate_form := 0
						l_force_sign := 0
						l_space_for_positive := 1
						l_length_modifier := (('%/0/').code).to_integer_8
						l_number_of_zeros_to_pad := (0).to_natural_32
						l_zero_padding_insertion_ind := (0).to_natural_32
						l_fmt_spec := (('%/0/').code).to_integer_8
						l_str_arg := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_p___0 := l_p___0 + 1
				when 6 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 17 -- skip loop
						end
				when 7 then -- loop body:
						if (l_p___0[0]).to_integer_32 /= 48 then
							if (l_p___0[0]).to_integer_32 /= 45 then
								if (l_p___0[0]).to_integer_32 /= 43 then
									if (l_p___0[0]).to_integer_32 /= 32 then
										if (l_p___0[0]).to_integer_32 /= 35 then
											if (l_p___0[0]).to_integer_32 /= 39 then
												js.break
											end
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						inspect (l_p___0[0]).to_integer_32 -- switch 1 head
						when 48 then l_pos := -1 + 9
						when 45 then l_pos := -1 + 10
						when 43 then l_pos := -1 + 11
						when 32 then l_pos := -1 + 12
						when 35 then l_pos := -1 + 13
						when 39 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 9 then -- switch 1, case 48
						l_zero_padding := 1
						l_pos := -1 + 15 -- switch 1; break
				when 10 then -- switch 1, case 45
						l_justify_left := 1
						l_pos := -1 + 15 -- switch 1; break
				when 11 then -- switch 1, case 43
						l_force_sign := 1
						l_space_for_positive := 0
						l_pos := -1 + 15 -- switch 1; break
				when 12 then -- switch 1, case 32
						l_force_sign := 1
						l_pos := -1 + 15 -- switch 1; break
				when 13 then -- switch 1, case 35
						l_alternate_form := 1
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, case 39
						l_pos := -1 + 15 -- switch 1; break
				when 15 then -- switch 1, done:
						l_p___0 := l_p___0 + 1
				when 16 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 17 then -- loop done
						if (l_p___0[0]).to_integer_32 = 42 then
							l_p___0 := l_p___0 + 1
							if not a_tvs.is_void then
								l_j := (tv_nr (a_tvs, l_arg_idx)).to_integer_32
							else
								l_j := (l_ap___0.integer_32_item)
							end
							if l_j >= 0 then
								l_min_field_width := l_j.to_natural_32
							else
								l_min_field_width := (-l_j).to_natural_32
								l_justify_left := 1
							end
						elseif (l_p___0[0]).to_integer_32 >= 48 then
							if (l_p___0[0]).to_integer_32 <= 57 then
								l_tmp___6 := l_p___0
								l_p___0 := l_p___0 + 1
								l_uj := ((l_tmp___6[0]).to_integer_32 - 48).to_natural_32
								from
								until
									js.loop_done
								loop
									if (l_p___0[0]).to_integer_32 >= 48 then
										if not ((l_p___0[0]).to_integer_32 <= 57) then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_tmp___7 := l_p___0
										l_p___0 := l_p___0 + 1
										l_uj := {NATURAL_32} 10 * l_uj + ((l_tmp___7[0]).to_integer_32 - 48).to_natural_32
									end
								end
								l_min_field_width := l_uj
							end
						end
						if (l_p___0[0]).to_integer_32 = 46 then
							l_p___0 := l_p___0 + 1
							l_precision_specified := 1
							if (l_p___0[0]).to_integer_32 = 42 then
								if not a_tvs.is_void then
									l_j___0 := (tv_nr (a_tvs, l_arg_idx)).to_integer_32
								else
									l_j___0 := (l_ap___0.integer_32_item)
								end
								l_p___0 := l_p___0 + 1
								if l_j___0 >= 0 then
									l_precision := l_j___0.to_natural_32
								else
									l_precision_specified := 0
									l_precision := (0).to_natural_32
								end
							elseif (l_p___0[0]).to_integer_32 >= 48 then
								if (l_p___0[0]).to_integer_32 <= 57 then
									l_tmp___10 := l_p___0
									l_p___0 := l_p___0 + 1
									l_uj___0 := ((l_tmp___10[0]).to_integer_32 - 48).to_natural_32
									from
									until
										js.loop_done
									loop
										if (l_p___0[0]).to_integer_32 >= 48 then
											if not ((l_p___0[0]).to_integer_32 <= 57) then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_tmp___11 := l_p___0
											l_p___0 := l_p___0 + 1
											l_uj___0 := {NATURAL_32} 10 * l_uj___0 + ((l_tmp___11[0]).to_integer_32 - 48).to_natural_32
										end
									end
									l_precision := l_uj___0
								end
							end
						end
						if (l_p___0[0]).to_integer_32 /= 104 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if (l_p___0[0]).to_integer_32 /= 108 then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L:
						l_length_modifier := l_p___0[0]
						l_p___0 := l_p___0 + 1
						if l_length_modifier.to_integer_32 = 108 then
							if (l_p___0[0]).to_integer_32 = 108 then
								l_length_modifier := (('l').code).to_integer_8
								l_p___0 := l_p___0 + 1
							end
						end
				when 22 then -- if done
						l_fmt_spec := l_p___0[0]
						inspect l_fmt_spec.to_integer_32 -- switch 2 head
						when 105 then l_pos := -1 + 23
						when 68 then l_pos := -1 + 24
						when 85 then l_pos := -1 + 25
						when 79 then l_pos := -1 + 26
						when 70 then l_pos := -1 + 27
						else l_pos := -1 + 28
						end
				when 23 then -- switch 2, case 105
						l_fmt_spec := (('d').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 24 then -- switch 2, case 68
						l_fmt_spec := (('d').code).to_integer_8
						l_length_modifier := (('l').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 25 then -- switch 2, case 85
						l_fmt_spec := (('u').code).to_integer_8
						l_length_modifier := (('l').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 26 then -- switch 2, case 79
						l_fmt_spec := (('o').code).to_integer_8
						l_length_modifier := (('l').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 27 then -- switch 2, case 70
						l_fmt_spec := (('f').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 28 then -- switch 2, default:
						l_pos := -1 + 29 -- switch 2; break
				when 29 then -- switch 2, done:
						inspect l_fmt_spec.to_integer_32 -- switch 3 head
						when 37 then l_pos := -1 + 30
						when 99 then l_pos := -1 + 30
						when 115 then l_pos := -1 + 30
						when 100 then l_pos := -1 + 36
						when 117 then l_pos := -1 + 36
						when 111 then l_pos := -1 + 36
						when 120 then l_pos := -1 + 36
						when 88 then l_pos := -1 + 36
						when 112 then l_pos := -1 + 36
						when 102 then l_pos := -1 + 79
						when 101 then l_pos := -1 + 79
						when 69 then l_pos := -1 + 79
						when 103 then l_pos := -1 + 79
						when 71 then l_pos := -1 + 79
						else l_pos := -1 + 101
						end
				when 30 then -- switch 3, case 37 | switch 3, case 99 | switch 3, case 115
						l_length_modifier := (('%/0/').code).to_integer_8
						l_str_arg_l := (1).to_natural_32
						inspect l_fmt_spec.to_integer_32 -- switch 4 head
						when 37 then l_pos := -1 + 31
						when 99 then l_pos := -1 + 32
						when 115 then l_pos := -1 + 33
						else l_pos := -1 + 34
						end
				when 31 then -- switch 4, case 37
						l_str_arg := l_p___0
						l_pos := -1 + 35 -- switch 4; break
				when 32 then -- switch 4, case 99
						if not a_tvs.is_void then
							l_j___1 := (tv_nr (a_tvs, l_arg_idx)).to_integer_32
						else
							l_j___1 := (l_ap___0.integer_32_item)
						end
						l_uchar_arg.item := l_j___1.to_natural_8
						l_str_arg := create {CE_POINTER [INTEGER_8]}.make_cast (l_uchar_arg)
						l_pos := -1 + 35 -- switch 4; break
				when 33 then -- switch 4, case 115
						if not a_tvs.is_void then
							l_str_arg := (tv_str (a_tvs, l_arg_idx))
						else
							l_str_arg := (create {CE_POINTER [INTEGER_8]}.make_cast (l_ap___0.pointer_item))
						end
						if l_str_arg.is_void then
							l_str_arg := ce_string ("[NULL]")
							l_str_arg_l := (6).to_natural_32
						elseif not l_precision_specified.to_boolean then
							l_str_arg_l := strlen (l_str_arg)
						elseif l_precision = {NATURAL_32} 0 then
							l_str_arg_l := (0).to_natural_32
						else
							if l_precision <= {NATURAL_32} 2_147_483_647 then
								l_tmp___16 := l_precision
							else
								l_tmp___16 := (2_147_483_647).to_natural_32
							end
							l_q___0 := create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (l_str_arg), ('%/0/').code, l_tmp___16)))
							if l_q___0.is_void then
								l_str_arg_l := l_precision
							else
								l_str_arg_l := (l_q___0.distance (l_str_arg)).to_natural_32
							end
						end
						l_pos := -1 + 35 -- switch 4; break
				when 34 then -- switch 4, default:
						l_pos := -1 + 35 -- switch 4; break
				when 35 then -- switch 4, done:
						l_pos := -1 + 102 -- switch 3; break
				when 36 then -- switch 3, case 100 | switch 3, case 117 | switch 3, case 111 | switch 3, case 120 | switch 3, case 88 | switch 3, case 112
						l_arg_sign := 0
						l_int_arg := 0
						l_uint_arg := {NATURAL_32} 0
						l_long_arg := 0
						l_ulong_arg := {NATURAL_32} 0
						l_ptr_arg := create {CE_POINTER [ANY]}.make_shared (default_pointer)
						if l_fmt_spec.to_integer_32 /= 112 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_length_modifier := (('%/0/').code).to_integer_8
						if not a_tvs.is_void then
							l_ptr_arg := create {CE_POINTER [ANY]}.make_cast ((tv_str (a_tvs, l_arg_idx)))
						else
							l_ptr_arg := (create {CE_POINTER [ANY]}.make_cast (l_ap___0.pointer_item))
						end
						if not l_ptr_arg.is_void then
							l_arg_sign := 1
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 39 then -- else:
						if l_fmt_spec.to_integer_32 /= 100 then
							l_pos := -1 + 44 -- skip if block
						end
				when 40 then -- if:
						inspect l_length_modifier.to_integer_32 -- switch 5 head
						when 0 then l_pos := -1 + 41
						when 104 then l_pos := -1 + 41
						when 108 then l_pos := -1 + 42
						else l_pos := -1 + 43
						end
				when 41 then -- switch 5, case 0 | switch 5, case 104
						if not a_tvs.is_void then
							l_int_arg := (tv_nr (a_tvs, l_arg_idx)).to_integer_32
						else
							l_int_arg := (l_ap___0.integer_32_item)
						end
						if l_int_arg > 0 then
							l_arg_sign := 1
						elseif l_int_arg < 0 then
							l_arg_sign := -1
						end
						l_pos := -1 + 43 -- switch 5; break
				when 42 then -- switch 5, case 108
						if not a_tvs.is_void then
							l_long_arg := (tv_nr (a_tvs, l_arg_idx))
						else
							l_long_arg := (l_ap___0.integer_32_item)
						end
						if l_long_arg > 0 then
							l_arg_sign := 1
						elseif l_long_arg < 0 then
							l_arg_sign := -1
						end
						l_pos := -1 + 43 -- switch 5; break
				when 43 then -- switch 5, done: | if block done, skip else block:
						l_pos := -1 + 47
				when 44 then -- else:
						inspect l_length_modifier.to_integer_32 -- switch 6 head
						when 0 then l_pos := -1 + 45
						when 104 then l_pos := -1 + 45
						when 108 then l_pos := -1 + 46
						else l_pos := -1 + 47
						end
				when 45 then -- switch 6, case 0 | switch 6, case 104
						if not a_tvs.is_void then
							l_uint_arg := (tv_nr (a_tvs, l_arg_idx)).to_natural_32
						else
							l_uint_arg := (l_ap___0.natural_32_item)
						end
						if l_uint_arg /= {NATURAL_32} 0 then
							l_arg_sign := 1
						end
						l_pos := -1 + 47 -- switch 6; break
				when 46 then -- switch 6, case 108
						if not a_tvs.is_void then
							l_ulong_arg := (tv_nr (a_tvs, l_arg_idx)).to_natural_32
						else
							l_ulong_arg := (l_ap___0.natural_32_item)
						end
						if l_ulong_arg /= {NATURAL_32} 0 then
							l_arg_sign := 1
						end
						l_pos := -1 + 47 -- switch 6; break
				when 47 then -- switch 6, done: | if done | if done
						l_str_arg := l_tmp___3
						l_str_arg_l := (0).to_natural_32
						if l_precision_specified.to_boolean then
							l_zero_padding := 0
						end
						if l_fmt_spec.to_integer_32 /= 100 then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						if l_force_sign.to_boolean then
							if l_arg_sign >= 0 then
								l_tmp___28 := l_str_arg_l
								l_str_arg_l := l_str_arg_l + 1
								if l_space_for_positive.to_boolean then
									l_tmp___3[l_tmp___28.to_integer_32] := ((' ').code).to_integer_8
								else
									l_tmp___3[l_tmp___28.to_integer_32] := (('+').code).to_integer_8
								end
							end
						end
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 50 then -- else:
						if not (l_alternate_form.to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 51 then -- if:
						if l_arg_sign = 0 then
							l_pos := -1 + 57 -- skip if block
						end
				when 52 then -- if:
						if l_fmt_spec.to_integer_32 /= 120 then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 56 -- goto _L___0
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 55 then -- else:
						if l_fmt_spec.to_integer_32 /= 88 then
							l_pos := -1 + 57 -- skip if block
						end
				when 56 then -- if: | _L___0:
						l_tmp___29 := l_str_arg_l
						l_str_arg_l := l_str_arg_l + 1
						l_tmp___3[l_tmp___29.to_integer_32] := (('0').code).to_integer_8
						l_tmp___30 := l_str_arg_l
						l_str_arg_l := l_str_arg_l + 1
						l_tmp___3[l_tmp___30.to_integer_32] := l_fmt_spec
				when 57 then -- if done | if done | if done | if done
						l_zero_padding_insertion_ind := l_str_arg_l
						if not l_precision_specified.to_boolean then
							l_precision := (1).to_natural_32
						end
						if l_precision /= {NATURAL_32} 0 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if l_arg_sign /= 0 then
							l_pos := -1 + 60 -- goto _L___1
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 60 then -- else: | _L___1:
						l_f_l := 0
						l_tmp___31 := l_f_l
						l_f_l := l_f_l + 1
						l_f[l_tmp___31] := (('%%').code).to_integer_8
						if l_length_modifier.to_boolean then
							if l_length_modifier.to_integer_32 = 50 then
								l_tmp___32 := l_f_l
								l_f_l := l_f_l + 1
								l_f[l_tmp___32] := (('l').code).to_integer_8
								l_tmp___33 := l_f_l
								l_f_l := l_f_l + 1
								l_f[l_tmp___33] := (('l').code).to_integer_8
							else
								l_tmp___34 := l_f_l
								l_f_l := l_f_l + 1
								l_f[l_tmp___34] := l_length_modifier
							end
						end
						l_tmp___35 := l_f_l
						l_f_l := l_f_l + 1
						l_f[l_tmp___35] := l_fmt_spec
						l_tmp___36 := l_f_l
						l_f_l := l_f_l + 1
						l_f[l_tmp___36] := (('%/0/').code).to_integer_8
						if l_fmt_spec.to_integer_32 /= 112 then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_ptr_arg])).to_natural_32
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 63 then -- else:
						if l_fmt_spec.to_integer_32 /= 100 then
							l_pos := -1 + 68 -- skip if block
						end
				when 64 then -- if:
						inspect l_length_modifier.to_integer_32 -- switch 7 head
						when 0 then l_pos := -1 + 65
						when 104 then l_pos := -1 + 65
						when 108 then l_pos := -1 + 66
						else l_pos := -1 + 67
						end
				when 65 then -- switch 7, case 0 | switch 7, case 104
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_int_arg])).to_natural_32
						l_pos := -1 + 67 -- switch 7; break
				when 66 then -- switch 7, case 108
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_long_arg])).to_natural_32
						l_pos := -1 + 67 -- switch 7; break
				when 67 then -- switch 7, done: | if block done, skip else block:
						l_pos := -1 + 71
				when 68 then -- else:
						inspect l_length_modifier.to_integer_32 -- switch 8 head
						when 0 then l_pos := -1 + 69
						when 104 then l_pos := -1 + 69
						when 108 then l_pos := -1 + 70
						else l_pos := -1 + 71
						end
				when 69 then -- switch 8, case 0 | switch 8, case 104
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_uint_arg])).to_natural_32
						l_pos := -1 + 71 -- switch 8; break
				when 70 then -- switch 8, case 108
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_ulong_arg])).to_natural_32
						l_pos := -1 + 71 -- switch 8; break
				when 71 then -- switch 8, done: | if done | if done
						if l_zero_padding_insertion_ind < l_str_arg_l then
							if (l_tmp___3[l_zero_padding_insertion_ind.to_integer_32]).to_integer_32 = 45 then
								l_zero_padding_insertion_ind := l_zero_padding_insertion_ind + 1
							end
						end
						if l_zero_padding_insertion_ind + {NATURAL_32} 1 < l_str_arg_l then
							if (l_tmp___3[l_zero_padding_insertion_ind.to_integer_32]).to_integer_32 = 48 then
								if (l_tmp___3[(l_zero_padding_insertion_ind + {NATURAL_32} 1).to_integer_32]).to_integer_32 = 120 then
									l_zero_padding_insertion_ind := l_zero_padding_insertion_ind + ({NATURAL_32} 2)
								elseif (l_tmp___3[(l_zero_padding_insertion_ind + {NATURAL_32} 1).to_integer_32]).to_integer_32 = 88 then
									l_zero_padding_insertion_ind := l_zero_padding_insertion_ind + ({NATURAL_32} 2)
								end
							end
						end
				when 72 then
						l_num_of_digits := l_str_arg_l - l_zero_padding_insertion_ind
						if not (l_alternate_form.to_boolean) then
							l_pos := -1 + 78 -- skip if block
						end
				when 73 then -- if:
						if l_fmt_spec.to_integer_32 /= 111 then
							l_pos := -1 + 78 -- skip if block
						end
				when 74 then -- if:
						if not (l_zero_padding_insertion_ind < l_str_arg_l) then
							l_pos := -1 + 77 -- skip if block
						end
				when 75 then -- if:
						if (l_tmp___3[l_zero_padding_insertion_ind.to_integer_32]).to_integer_32 /= 48 then
							l_pos := -1 + 77 -- goto _L___2
						end
				when 76 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 77 then -- else: | _L___2:
						if not l_precision_specified.to_boolean then
							l_precision := l_num_of_digits + {NATURAL_32} 1
							l_precision_specified := 1
						elseif l_precision < l_num_of_digits + {NATURAL_32} 1 then
							l_precision := l_num_of_digits + {NATURAL_32} 1
							l_precision_specified := 1
						end
				when 78 then -- if done | if done
						if l_num_of_digits < l_precision then
							l_number_of_zeros_to_pad := l_precision - l_num_of_digits
						end
						if not l_justify_left.to_boolean then
							if l_zero_padding.to_boolean then
								l_n___0 := (l_min_field_width - (l_str_arg_l + l_number_of_zeros_to_pad)).to_integer_32
								if l_n___0 > 0 then
									l_number_of_zeros_to_pad := l_number_of_zeros_to_pad + l_n___0.to_natural_32
								end
							end
						end
						l_pos := -1 + 102 -- switch 3; break
				when 79 then -- switch 3, case 102 | switch 3, case 101 | switch 3, case 69 | switch 3, case 103 | switch 3, case 71
						l_remove_trailing_zeroes := 0
						if not a_tvs.is_void then
							l_f___0 := (tv_float (a_tvs, l_arg_idx))
						else
							l_f___0 := (l_ap___0.real_64_item)
						end
						if l_f___0 < (0).to_double then
							l_abs_f := -l_f___0
						else
							l_abs_f := l_f___0
						end
						if l_fmt_spec.to_integer_32 /= 103 then
							l_pos := -1 + 82 -- skip if block
						end
				when 80 then -- if:
						l_pos := -1 + 83 -- goto _L___4
				when 81 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 82 then -- else:
						if l_fmt_spec.to_integer_32 /= 71 then
							l_pos := -1 + 88 -- skip if block
						end
				when 83 then -- if: | _L___4:
						if not (l_abs_f >= 0.001) then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						if l_abs_f < 10000000.0 then
							l_fmt_spec := (('f').code).to_integer_8
						else
							l_pos := -1 + 86 -- goto _L___3
						end
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else: | _L___3:
						if l_abs_f = 0.0 then
							l_fmt_spec := (('f').code).to_integer_8
						elseif l_fmt_spec.to_integer_32 = 103 then
							l_fmt_spec := (('e').code).to_integer_8
						else
							l_fmt_spec := (('E').code).to_integer_8
						end
				when 87 then
						l_remove_trailing_zeroes := 1
				when 88 then -- if done
						if l_fmt_spec.to_integer_32 /= 102 then
							l_pos := -1 + 91 -- skip if block
						end
				when 89 then -- if:
						if l_abs_f > 1.0e307 then
							strcpy (l_tmp___3, ce_string ("inf")).do_nothing
							l_str_arg_l := (3).to_natural_32
						else
							l_pos := -1 + 91 -- goto _L___6
						end
				when 90 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 91 then -- else: | _L___6:
						l_format[0] := (('%%').code).to_integer_8
						l_l := 1
						if l_precision_specified.to_boolean then
							l_max_prec := (340).to_natural_32
							if l_fmt_spec.to_integer_32 = 102 then
								if l_abs_f > 1.0 then
									l_max_prec := l_max_prec - (log10 (l_abs_f)).truncated_to_integer_64.to_natural_32
								end
							end
							if l_precision > l_max_prec then
								l_precision := l_max_prec
							end
							l_l := l_l + (sprintf ([(l_format + 1), ce_string (".%%d"), l_precision.to_integer_32]))
						end
						l_format[l_l] := l_fmt_spec
						l_format[l_l + 1] := (('%/0/').code).to_integer_8
						l_str_arg_l := (sprintf ([l_tmp___3, l_format, l_f___0])).to_natural_32
						if not (l_remove_trailing_zeroes.to_boolean) then
							l_pos := -1 + 94 -- skip if block
						end
				when 92 then -- if:
						if l_fmt_spec.to_integer_32 = 102 then
							l_tp := (l_tmp___3 + l_str_arg_l.to_integer_32) - 1
						else
							if l_fmt_spec.to_integer_32 = 101 then
								l_tmp___47 := ('e').code
							else
								l_tmp___47 := ('E').code
							end
							l_tp := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3), l_tmp___47)))
							if not l_tp.is_void then
								if (l_tp[1]).to_integer_32 = 43 then
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_tp + 1)), create {CE_POINTER [ANY]}.make_cast ((l_tp + 2)), (strlen ((l_tp + 2))) + {NATURAL_32} 1).do_nothing
									l_str_arg_l := l_str_arg_l - 1
								end
								if (l_tp[1]).to_integer_32 = 45 then
									l_i___0 := 2
								else
									l_i___0 := 1
								end
								from
								until
									(l_tp[l_i___0]).to_integer_32 /= 48
								loop
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_tp + l_i___0)), create {CE_POINTER [ANY]}.make_cast (((l_tp + l_i___0) + 1)), (strlen (((l_tp + l_i___0) + 1))) + {NATURAL_32} 1).do_nothing
									l_str_arg_l := l_str_arg_l - 1
								end
								l_tp := l_tp - 1
							end
						end
						if not l_tp.is_void then
							if not l_precision_specified.to_boolean then
								from
								until
									js.loop_done
								loop
									if (l_tp.c_pointer.to_integer_32).to_natural_32 > ((l_tmp___3 + 2).c_pointer.to_integer_32).to_natural_32 then
										if (l_tp[0]).to_integer_32 = 48 then
											if (l_tp[-1]).to_integer_32 = 46 then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										memmove (create {CE_POINTER [ANY]}.make_cast (l_tp), create {CE_POINTER [ANY]}.make_cast ((l_tp + 1)), (strlen ((l_tp + 1))) + {NATURAL_32} 1).do_nothing
										l_tp := l_tp - 1
										l_str_arg_l := l_str_arg_l - 1
									end
								end
							end
						end
				when 93 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 94 then -- else:
						if l_fmt_spec.to_integer_32 = 101 then
							l_tmp___52 := ('e').code
						else
							l_tmp___52 := ('E').code
						end
						l_tp___0 := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3), l_tmp___52)))
						if l_tp___0.is_void then
							l_pos := -1 + 100 -- skip if block
						end
				when 95 then -- if:
						if (l_tp___0[1]).to_integer_32 /= 43 then
							l_pos := -1 + 98 -- skip if block
						end
				when 96 then -- if:
						l_pos := -1 + 99 -- goto _L___5
				when 97 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 98 then -- else:
						if (l_tp___0[1]).to_integer_32 /= 45 then
							l_pos := -1 + 100 -- skip if block
						end
				when 99 then -- if: | _L___5:
						if (l_tp___0[2]).to_integer_32 = 48 then
							if (charset_inst.vim_isdigit ((l_tp___0[3]).to_integer_32)).to_boolean then
								if (charset_inst.vim_isdigit ((l_tp___0[4]).to_integer_32)).to_boolean then
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_tp___0 + 2)), create {CE_POINTER [ANY]}.make_cast ((l_tp___0 + 3)), (strlen ((l_tp___0 + 3))) + {NATURAL_32} 1).do_nothing
									l_str_arg_l := l_str_arg_l - 1
								end
							end
						end
				when 100 then -- if done | if done | if done | if done
						l_str_arg := l_tmp___3
						l_pos := -1 + 102 -- switch 3; break
				when 101 then -- switch 3, default:
						l_zero_padding := 0
						l_justify_left := 1
						l_min_field_width := (0).to_natural_32
						l_str_arg := l_p___0
						l_str_arg_l := (0).to_natural_32
						if (l_p___0[0]).to_integer_32 /= 0 then
							l_str_arg_l := l_str_arg_l + 1
						end
						l_pos := -1 + 102 -- switch 3; break
				when 102 then -- switch 3, done:
						if (l_p___0[0]).to_integer_32 /= 0 then
							l_p___0 := l_p___0 + 1
						end
						if not l_justify_left.to_boolean then
							l_pn := (l_min_field_width - (l_str_arg_l + l_number_of_zeros_to_pad)).to_integer_32
							if l_pn > 0 then
								if l_str_l < a_str_m then
									l_avail___0 := a_str_m - l_str_l
									if l_pn.to_natural_32 > l_avail___0 then
										l_tmp___57 := l_avail___0
									else
										l_tmp___57 := l_pn.to_natural_32
									end
									if l_zero_padding.to_boolean then
										l_tmp___58 := ('0').code
									else
										l_tmp___58 := (' ').code
									end
									memset (create {CE_POINTER [ANY]}.make_cast ((a_str___1 + l_str_l.to_integer_32)), l_tmp___58, l_tmp___57).do_nothing
								end
								l_str_l := l_str_l + l_pn.to_natural_32
							end
						end
						if l_number_of_zeros_to_pad = {NATURAL_32} 0 then
							l_zero_padding_insertion_ind := (0).to_natural_32
						else
							l_zn := l_zero_padding_insertion_ind.to_integer_32
							if l_zn > 0 then
								if l_str_l < a_str_m then
									l_avail___1 := a_str_m - l_str_l
									if l_zn.to_natural_32 > l_avail___1 then
										l_tmp___59 := l_avail___1
									else
										l_tmp___59 := l_zn.to_natural_32
									end
									memmove (create {CE_POINTER [ANY]}.make_cast ((a_str___1 + l_str_l.to_integer_32)), create {CE_POINTER [ANY]}.make_cast (l_str_arg), l_tmp___59).do_nothing
								end
								l_str_l := l_str_l + l_zn.to_natural_32
							end
							l_zn := l_number_of_zeros_to_pad.to_integer_32
							if l_zn > 0 then
								if l_str_l < a_str_m then
									l_avail___2 := a_str_m - l_str_l
									if l_zn.to_natural_32 > l_avail___2 then
										l_tmp___60 := l_avail___2
									else
										l_tmp___60 := l_zn.to_natural_32
									end
									memset (create {CE_POINTER [ANY]}.make_cast ((a_str___1 + l_str_l.to_integer_32)), ('0').code, l_tmp___60).do_nothing
								end
								l_str_l := l_str_l + l_zn.to_natural_32
							end
						end
						l_sn := (l_str_arg_l - l_zero_padding_insertion_ind).to_integer_32
						if l_sn > 0 then
							if l_str_l < a_str_m then
								l_avail___3 := a_str_m - l_str_l
								if l_sn.to_natural_32 > l_avail___3 then
									l_tmp___61 := l_avail___3
								else
									l_tmp___61 := l_sn.to_natural_32
								end
								memmove (create {CE_POINTER [ANY]}.make_cast ((a_str___1 + l_str_l.to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((l_str_arg + l_zero_padding_insertion_ind.to_integer_32)), l_tmp___61).do_nothing
							end
							l_str_l := l_str_l + l_sn.to_natural_32
						end
						if l_justify_left.to_boolean then
							l_pn___0 := (l_min_field_width - (l_str_arg_l + l_number_of_zeros_to_pad)).to_integer_32
							if l_pn___0 > 0 then
								if l_str_l < a_str_m then
									l_avail___4 := a_str_m - l_str_l
									if l_pn___0.to_natural_32 > l_avail___4 then
										l_tmp___62 := l_avail___4
									else
										l_tmp___62 := l_pn___0.to_natural_32
									end
									memset (create {CE_POINTER [ANY]}.make_cast ((a_str___1 + l_str_l.to_integer_32)), (' ').code, l_tmp___62).do_nothing
								end
								l_str_l := l_str_l + l_pn___0.to_natural_32
							end
						end
				when 103 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 104 then -- loop done
					if a_str_m > {NATURAL_32} 0 then
						if l_str_l <= a_str_m - {NATURAL_32} 1 then
							l_tmp___63 := l_str_l
						else
							l_tmp___63 := a_str_m - {NATURAL_32} 1
						end
						a_str___1[l_tmp___63.to_integer_32] := (('%/0/').code).to_integer_8
					end
					if not a_tvs.is_void then
						if ((a_tvs + (l_arg_idx.item - 1)).item.v_type).to_integer_32 /= 0 then
							emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E767: Too many arguments to printf()"))))).do_nothing
						end
					end
					Result := l_str_l.to_integer_32
				when 105 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	wait_return (a_redraw: INTEGER_32)
		local
			l_c: INTEGER_32
			l_oldState: INTEGER_32
			l_tmpState: INTEGER_32
			l_had_got_int: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_redraw = 1 then
						globals_inst.must_redraw := 50
					end
					if globals_inst.msg_silent /= 0 then
						js.return
					end
					if not js.return_called and then (globals_inst.vgetc_busy > 0) then
						js.return
					end
					if not js.return_called and then (globals_inst.no_wait_return.to_boolean) then
						globals_inst.need_wait_return := 1
						if not globals_inst.exmode_active.to_boolean then
							globals_inst.cmdline_row := globals_inst.msg_row
						end
						js.return
					end
					if js.return_called then
						l_pos := -1 + 42 -- skip if block
					end
				when 1 then -- if:
						globals_inst.redir_off := 1
						l_oldState := globals_inst.State
						if not (globals_inst.quit_more.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_c := ('%R').code
						globals_inst.quit_more := 0
						globals_inst.got_int := 0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 4 then -- else:
						if not (globals_inst.exmode_active.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
						l_c := ('%R').code
						globals_inst.got_int := 0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 7 then -- else:
						screen_inst.screenalloc (0)
						globals_inst.State := 513
						term_inst.setmouse
						globals_inst.dont_scroll := 1
						hit_return_msg
				when 8 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 32 -- skip loop
						end
				when 9 then -- loop body:
						l_had_got_int := globals_inst.got_int
						globals_inst.no_mapping := globals_inst.no_mapping + 1
						globals_inst.allow_keys := globals_inst.allow_keys + 1
						l_c := getchar_inst.safe_vgetc
						if l_had_got_int.to_boolean then
							if not globals_inst.global_busy.to_boolean then
								globals_inst.got_int := 0
							end
						end
						globals_inst.no_mapping := globals_inst.no_mapping - 1
						globals_inst.allow_keys := globals_inst.allow_keys - 1
						if l_c = 25 then
							if (globals_inst.clip_star.item.state).to_integer_32 = 2 then
								ui_inst.clip_copy_modeless_selection (1)
								l_c := -(253 + ((53).bit_shift_left (8)))
							end
						end
						if not ((option_inst.p_more.item).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 10 then -- if:
						if (option_inst.p_cp.item).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 11 then -- if:
						if l_c /= 98 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 14 then -- else:
						if l_c /= 107 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 17 then -- else:
						if l_c /= 117 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 20 then -- else:
						if l_c /= 103 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 23 then -- else:
						if l_c /= -(107 + ((117).bit_shift_left (8))) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if: | _L:
						do_more_prompt (l_c).do_nothing
						if globals_inst.quit_more.to_boolean then
							l_c := ('%R').code
							globals_inst.quit_more := 0
							globals_inst.got_int := 0
						else
							l_c := -(253 + ((53).bit_shift_left (8)))
							hit_return_msg
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						if globals_inst.msg_scrolled.to_integer_32 > globals_inst.Rows.item - 2 then
							if l_c = 106 then
								l_c := -(253 + ((53).bit_shift_left (8)))
							elseif l_c = -(107 + ((100).bit_shift_left (8))) then
								l_c := -(253 + ((53).bit_shift_left (8)))
							elseif l_c = 100 then
								l_c := -(253 + ((53).bit_shift_left (8)))
							elseif l_c = 102 then
								l_c := -(253 + ((53).bit_shift_left (8)))
							end
						end
				when 27 then -- if done | if done | if done | if done | if done | if done
						if not (l_had_got_int.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if l_c /= 3 then
							l_pos := -1 + 30 -- goto _L___0
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___0:
						if l_c /= -(253 + ((53).bit_shift_left (8))) then
							if l_c /= -(249 + ((88).bit_shift_left (8))) then
								if l_c /= -(248 + ((88).bit_shift_left (8))) then
									if l_c /= -(253 + ((45).bit_shift_left (8))) then
										if l_c /= -(253 + ((46).bit_shift_left (8))) then
											if l_c /= -(253 + ((48).bit_shift_left (8))) then
												if l_c /= -(253 + ((49).bit_shift_left (8))) then
													if l_c /= -(253 + ((51).bit_shift_left (8))) then
														if l_c /= -(253 + ((52).bit_shift_left (8))) then
															if l_c /= -(253 + ((77).bit_shift_left (8))) then
																if l_c /= -(253 + ((78).bit_shift_left (8))) then
																	if l_c /= -(253 + ((75).bit_shift_left (8))) then
																		if l_c /= -(253 + ((76).bit_shift_left (8))) then
																			if (term_inst.mouse_has (('r').code)).to_boolean then
																				js.break
																			elseif globals_inst.mouse_row < globals_inst.msg_row then
																				if l_c /= -(253 + ((44).bit_shift_left (8))) then
																					if l_c /= -(253 + ((47).bit_shift_left (8))) then
																						if l_c /= -(253 + ((50).bit_shift_left (8))) then
																							if l_c /= -(253 + ((89).bit_shift_left (8))) then
																								if l_c /= -(253 + ((92).bit_shift_left (8))) then
																									js.break
																								end
																							end
																						end
																					end
																				end
																			else
																				js.break
																			end
																		end
																	end
																end
															end
														end
													end
												end
											end
										end
									end
								end
							end
						end
				when 31 then
						l_pos := -1 + 8 -- back to loop condition
				when 32 then -- loop done
						ui_inst.ui_breakcheck
						if l_c = -(253 + ((44).bit_shift_left (8))) then
							ui_inst.jump_to_mouse (8, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0).do_nothing
						elseif l_c = -(253 + ((47).bit_shift_left (8))) then
							ui_inst.jump_to_mouse (8, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0).do_nothing
						elseif l_c = -(253 + ((50).bit_shift_left (8))) then
							ui_inst.jump_to_mouse (8, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0).do_nothing
						elseif l_c = -(253 + ((89).bit_shift_left (8))) then
							ui_inst.jump_to_mouse (8, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0).do_nothing
						elseif l_c = -(253 + ((92).bit_shift_left (8))) then
							ui_inst.jump_to_mouse (8, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0).do_nothing
						elseif (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N ")), l_c)).is_void then
							if l_c /= 3 then
								getchar_inst.ins_char_typebuf (l_c)
								globals_inst.do_redraw := 1
							end
						end
				when 33 then -- if done | if done
						globals_inst.redir_off := 0
						if l_c /= 58 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 40 -- goto _L___1
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 36 then -- else:
						if l_c /= 63 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_pos := -1 + 40 -- goto _L___1
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 39 then -- else:
						if l_c /= 47 then
							l_pos := -1 + 41 -- skip if block
						end
				when 40 then -- if: | _L___1:
						if not globals_inst.exmode_active.to_boolean then
							globals_inst.cmdline_row := globals_inst.msg_row
						end
						globals_inst.skip_redraw := 1
						globals_inst.do_redraw := 0
				when 41 then -- if done | if done
						l_tmpState := globals_inst.State
						globals_inst.State := l_oldState
						term_inst.setmouse
						msg_check
						if (term_inst.swapping_screen).to_boolean then
							if not globals_inst.termcap_active.to_boolean then
								globals_inst.newline_on_exit := 1
							end
						end
						globals_inst.need_wait_return := 0
						globals_inst.did_wait_return := 1
						globals_inst.emsg_on_display := 0
						globals_inst.lines_left := -1
						reset_last_sourcing
						if not globals_inst.keep_msg.is_void then
							if (charset_inst.vim_strsize (globals_inst.keep_msg)).to_integer_32 >= ((globals_inst.Rows.item - globals_inst.cmdline_row.to_integer_32) - 1) * globals_inst.Columns.item + globals_inst.sc_col.to_integer_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.keep_msg))
								globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
						end
						if l_tmpState = 1_024 then
							term_inst.starttermcap
							term_inst.shell_resized
						elseif not globals_inst.skip_redraw.to_boolean then
							if a_redraw = 1 then
								term_inst.starttermcap
								screen_inst.redraw_later (10)
							elseif globals_inst.msg_scrolled /= 0 then
								if a_redraw /= -1 then
									term_inst.starttermcap
									screen_inst.redraw_later (10)
								end
							end
						end
				when 42 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
