class
	P_SCREEN

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create at_end_str.make
			create cap_col.make (<<1>>)
			create current_ScreenLine.make
			create search_hl.make (<<1>>)
			create win_foldinfo.make (<<1>>)
		end

feature {ANY} -- attributes

	at_end_str: CE_POINTER [NATURAL_8] assign set_at_end_str

	set_at_end_str (a_at_end_str: CE_POINTER [NATURAL_8])
		do
			at_end_str := a_at_end_str
		end

	busy___1: INTEGER_32 assign set_busy___1

	set_busy___1 (a_busy___1: INTEGER_32)
		do
			busy___1 := a_busy___1
		end

	cap_col: CE_ARRAY [INTEGER_32]

	capcol_lnum: INTEGER_32 assign set_capcol_lnum

	set_capcol_lnum (a_capcol_lnum: INTEGER_32)
		do
			capcol_lnum := a_capcol_lnum
		end

	checked_col: INTEGER_32 assign set_checked_col

	set_checked_col (a_checked_col: INTEGER_32)
		do
			checked_col := a_checked_col
		end

	checked_lnum: INTEGER_32 assign set_checked_lnum

	set_checked_lnum (a_checked_lnum: INTEGER_32)
		do
			checked_lnum := a_checked_lnum
		end

	current_ScreenLine: CE_POINTER [NATURAL_8] assign set_current_ScreenLine

	set_current_ScreenLine (a_current_ScreenLine: CE_POINTER [NATURAL_8])
		do
			current_ScreenLine := a_current_ScreenLine
		end

	did_intro: INTEGER_32 assign set_did_intro

	set_did_intro (a_did_intro: INTEGER_32)
		do
			did_intro := a_did_intro
		end

	done_outofmem_msg: INTEGER_32 assign set_done_outofmem_msg

	set_done_outofmem_msg (a_done_outofmem_msg: INTEGER_32)
		do
			done_outofmem_msg := a_done_outofmem_msg
		end

	entered___3: INTEGER_32 assign set_entered___3

	set_entered___3 (a_entered___3: INTEGER_32)
		do
			entered___3 := a_entered___3
		end

	entered___4: INTEGER_32 assign set_entered___4

	set_entered___4 (a_entered___4: INTEGER_32)
		do
			entered___4 := a_entered___4
		end

	first_match: INTEGER_32 assign set_first_match

	set_first_match (a_first_match: INTEGER_32)
		do
			first_match := a_first_match
		end

	recursive___4: INTEGER_32 assign set_recursive___4

	set_recursive___4 (a_recursive___4: INTEGER_32)
		do
			recursive___4 := a_recursive___4
		end

	screen_attr: INTEGER_32 assign set_screen_attr

	set_screen_attr (a_screen_attr: INTEGER_32)
		do
			screen_attr := a_screen_attr
		end

	screen_char_attr: INTEGER_32 assign set_screen_char_attr

	set_screen_char_attr (a_screen_char_attr: INTEGER_32)
		do
			screen_char_attr := a_screen_char_attr
		end

	screen_cur_col: INTEGER_32 assign set_screen_cur_col

	set_screen_cur_col (a_screen_cur_col: INTEGER_32)
		do
			screen_cur_col := a_screen_cur_col
		end

	screen_cur_row: INTEGER_32 assign set_screen_cur_row

	set_screen_cur_row (a_screen_cur_row: INTEGER_32)
		do
			screen_cur_row := a_screen_cur_row
		end

	search_hl: CE_ARRAY [PD_MATCH_T]

	win_foldinfo: CE_ARRAY [PD_FOLDINFO]

feature {ANY} -- routines

	advance_color_col (a_vcol: INTEGER_32; a_color_cols: CE_POINTER [CE_POINTER [INTEGER_32]]): INTEGER_32
		local
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				if (a_color_cols.item).item >= 0 then
					if not (a_vcol > (a_color_cols.item).item) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					a_color_cols.item := (a_color_cols.item) + 1
				end
			end
			Result := ((a_color_cols.item).item >= 0).to_integer
		end

	can_clear (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (a_p___0.item).to_integer_32 /= 0 then
				if globals_inst.t_colors <= 1 then
					l_tmp := 1
				elseif (gui_inst.gui.item.in_use).to_boolean then
					l_tmp := 1
				elseif globals_inst.cterm_normal_bg_color = 0 then
					l_tmp := 1
				elseif ((term_inst.term_strings[9]).item).to_integer_32 /= 0 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	char_needs_redraw (a_off_from: INTEGER_32; a_off_to: INTEGER_32; a_cols: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_cols > 0) then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						if (globals_inst.ScreenLines[a_off_from]).to_integer_32 = (globals_inst.ScreenLines[a_off_to]).to_integer_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						Result := 1
						js.return
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 4 then -- else:
						if (globals_inst.ScreenAttrs[a_off_from]).to_integer_32 = (globals_inst.ScreenAttrs[a_off_to]).to_integer_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						Result := 1
						js.return
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 7 then -- else:
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if not ((globals_inst.mb_bytelen_tab[(globals_inst.ScreenLines[a_off_from]).to_integer_32]).to_integer_32 > 1) then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						if globals_inst.enc_dbcs /= 9_932 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (globals_inst.ScreenLines[a_off_from]).to_integer_32 = 142 then
							l_tmp___0 := ((globals_inst.ScreenLines2[a_off_from]).to_integer_32 /= (globals_inst.ScreenLines2[a_off_to]).to_integer_32).to_integer
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if a_cols > 1 then
							if (globals_inst.ScreenLines[(a_off_from + 1)]).to_integer_32 /= (globals_inst.ScreenLines[(a_off_to + 1)]).to_integer_32 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_tmp___0 := l_tmp
				when 13 then
						if l_tmp___0.to_boolean then
							Result := 1
							js.return
						else
							l_pos := -1 + 17 -- goto _L___2
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___2
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 17 then -- else: | _L___2:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 18 then -- if:
						if globals_inst.ScreenLinesUC[a_off_from] = globals_inst.ScreenLinesUC[a_off_to] then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						Result := 1
						js.return
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						if globals_inst.ScreenLinesUC[a_off_from] = {NATURAL_32} 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if (comp_char_differs (a_off_from, a_off_to)).to_boolean then
							Result := 1
							js.return
						else
							l_pos := -1 + 24 -- goto _L___0
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___0:
						if a_cols > 1 then
							if (globals_inst.ScreenLines[(a_off_from + 1)]).to_integer_32 /= (globals_inst.ScreenLines[(a_off_to + 1)]).to_integer_32 then
								Result := 1
								js.return
							end
						end
				when 25 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 26 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_for_delay (a_check_msg_scroll: INTEGER_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (globals_inst.emsg_on_display.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if not (a_check_msg_scroll.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not (globals_inst.msg_scroll.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not globals_inst.did_wait_return.to_boolean then
							if globals_inst.emsg_silent = 0 then
								term_inst.out_flush
								ui_inst.ui_delay (1_000, 1)
								globals_inst.emsg_on_display := 0
								if a_check_msg_scroll.to_boolean then
									globals_inst.msg_scroll := 0
								end
							end
						end
				when 6 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	comp_char_differs (a_off_from: INTEGER_32; a_off_to: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_done and then (l_i___0 < globals_inst.Screen_mco))
			loop
				if (globals_inst.ScreenLinesC[l_i___0])[a_off_from] /= (globals_inst.ScreenLinesC[l_i___0])[a_off_to] then
					Result := 1
					js.return
				end
				if not js.return_called then
					if (globals_inst.ScreenLinesC[l_i___0])[a_off_from] = {NATURAL_32} 0 then
						js.break
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	copy_text_attr (a_off___0: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_attr: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLines + a_off___0)), create {CE_POINTER [ANY]}.make_cast (a_buf___6), a_len.to_natural_32).do_nothing
			if globals_inst.enc_utf8.to_boolean then
				memset (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLinesUC + a_off___0)), 0, {PLATFORM}.Natural_32_bytes.to_natural_32 * a_len.to_natural_32).do_nothing
			end
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_len)
			loop
				globals_inst.ScreenAttrs[(a_off___0 + l_i___0)] := a_attr.to_natural_16
				l_i___0 := l_i___0 + 1
			end
		end

	draw_signcolumn (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if not ((a_wp___0.item.w_buffer).item.b_signlist).is_void then
				l_tmp___0 := 1
			elseif (netbeans_inst.netbeans_active).to_boolean then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	draw_tabline
		local
			l_tabcount: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_tabwidth: INTEGER_32
			l_col: INTEGER_32
			l_scol: INTEGER_32
			l_attr: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_cwp: CE_POINTER [PD_WINDOW_S]
			l_wincount: INTEGER_32
			l_modified: INTEGER_32
			l_c: INTEGER_32
			l_len: INTEGER_32
			l_attr_sel: INTEGER_32
			l_attr_nosel: INTEGER_32
			l_attr_fill: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_room: INTEGER_32
			l_use_sep_chars: INTEGER_32
			l_tmp: INTEGER_32
			l_save_called_emsg: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tp.make
			create l_wp___0.make
			create l_cwp.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tabcount := 0
					l_col := 0
					l_scol := 0
					l_attr_sel := globals_inst.highlight_attr[36]
					l_attr_nosel := globals_inst.highlight_attr[35]
					l_attr_fill := globals_inst.highlight_attr[37]
					if globals_inst.t_colors < 8 then
						if not (gui_inst.gui.item.in_use).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_use_sep_chars := l_tmp
					globals_inst.redraw_tabline := 0
					if (gui_inst.gui_use_tabline).to_boolean then
						gui_inst.gui_update_tabline
						js.return
					end
					if not js.return_called then
						if (window_inst.tabline_height) < 1 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_scol := 0
						from
						until
							not (l_scol.to_integer_32 < globals_inst.Columns.item)
						loop
							globals_inst.TabPageIdxs[l_scol] := (0).to_integer_16
							l_scol := l_scol + 1
						end
						if (option_inst.p_tal.item.item).to_integer_32 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_save_called_emsg := globals_inst.called_emsg
						globals_inst.called_emsg := 0
						win_redr_custom (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), 0)
						if globals_inst.called_emsg.to_boolean then
							option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tabline")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 1, -5)
						end
						globals_inst.called_emsg := (globals_inst.called_emsg).bit_or (l_save_called_emsg)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						l_tp := globals_inst.first_tabpage
						from
						until
							l_tp.is_void
						loop
							l_tabcount := l_tabcount + 1
							l_tp := l_tp.item.tp_next
						end
						l_tabwidth := (((globals_inst.Columns.item - 1) + (l_tabcount // 2).to_integer_32) // l_tabcount.to_integer_32).to_integer_32
						if l_tabwidth < 6 then
							l_tabwidth := 6
						end
						l_attr := l_attr_nosel
						l_tabcount := 0
						l_scol := 0
						l_tp := globals_inst.first_tabpage
				when 5 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						if not l_tp.is_void then
							if not (l_col.to_integer_32 < globals_inst.Columns.item - 4) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						l_scol := l_col
						if (l_tp.item.tp_topframe).is_equal (globals_inst.topframe) then
							l_attr := l_attr_sel
						end
						if l_use_sep_chars.to_boolean then
							if l_col > 0 then
								l_tmp___2 := l_col
								l_col := l_col + 1
								screen_putchar (('|').code, 0, l_tmp___2, l_attr)
							end
						end
						if not (l_tp.item.tp_topframe).is_equal (globals_inst.topframe) then
							l_attr := l_attr_nosel
						end
						l_tmp___3 := l_col
						l_col := l_col + 1
						screen_putchar ((' ').code, 0, l_tmp___3, l_attr)
						if l_tp.is_equal (globals_inst.curtab) then
							l_cwp := globals_inst.curwin
							l_wp___0 := globals_inst.firstwin
						else
							l_cwp := l_tp.item.tp_curwin
							l_wp___0 := l_tp.item.tp_firstwin
						end
						l_modified := 0
						l_wincount := 0
						from
						until
							l_wp___0.is_void
						loop
							if (undo_inst.bufIsChanged (l_wp___0.item.w_buffer)).to_boolean then
								l_modified := 1
							end
							l_wp___0 := l_wp___0.item.w_next
							l_wincount := l_wincount + 1
						end
						if not (l_modified.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not (l_wincount > 1) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if l_wincount > 1 then
							message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff.item), (4_096).to_natural_32, ce_string ("%%d"), l_wincount]).do_nothing
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff.item))).to_integer_32
							if (l_col + l_len).to_integer_32 >= globals_inst.Columns.item - 3 then
								js.break
							end
							if not js.loop_jumped then
								screen_puts_len (globals_inst.NameBuff.item, l_len, 0, l_col, (syntax_inst.hl_combine_attr (l_attr, globals_inst.highlight_attr[14])))
								l_col := l_col + l_len
							end
						end
						if not js.loop_jumped then
							if l_modified.to_boolean then
								l_tmp___7 := l_col
								l_col := l_col + 1
								screen_puts_len (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("+")), 1, 0, l_tmp___7, l_attr)
							end
							l_tmp___8 := l_col
							l_col := l_col + 1
							screen_putchar ((' ').code, 0, l_tmp___8, l_attr)
						end
				when 12 then -- if done | if done
						if not js.loop_jumped then
							l_room := ((l_scol - l_col) + l_tabwidth) - 1
							if l_room > 0 then
								get_trans_bufname (l_cwp.item.w_buffer)
								misc1_inst.shorten_dir (globals_inst.NameBuff.item)
								l_len := charset_inst.vim_strsize (globals_inst.NameBuff.item)
								l_p___0 := globals_inst.NameBuff.item
								if globals_inst.has_mbyte.to_boolean then
									from
									until
										not (l_len > l_room)
									loop
										l_len := l_len - (charset_inst.ptr2cells (l_p___0))
										if globals_inst.has_mbyte.to_boolean then
											l_tmp___11 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
										else
											l_tmp___11 := 1
										end
										l_p___0 := l_p___0 + l_tmp___11
									end
								elseif l_len > l_room then
									l_p___0 := l_p___0 + (l_len - l_room)
									l_len := l_room
								end
								if l_len.to_integer_32 > (globals_inst.Columns.item - l_col.to_integer_32) - 1 then
									l_len := ((globals_inst.Columns.item - l_col.to_integer_32) - 1).to_integer_32
								end
								screen_puts_len (l_p___0, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32, 0, l_col, l_attr)
								l_col := l_col + l_len
							end
							l_tmp___13 := l_col
							l_col := l_col + 1
							screen_putchar ((' ').code, 0, l_tmp___13, l_attr)
							l_tabcount := l_tabcount + 1
							from
							until
								not (l_scol < l_col)
							loop
								l_tmp___14 := l_scol
								l_scol := l_scol + 1
								globals_inst.TabPageIdxs[l_tmp___14] := l_tabcount.to_integer_16
							end
							l_tp := l_tp.item.tp_next
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						if l_use_sep_chars.to_boolean then
							l_c := ('_').code
						else
							l_c := (' ').code
						end
						screen_fill (0, 1, l_col, (globals_inst.Columns.item).to_integer_32, l_c, l_c, l_attr_fill)
						if not (globals_inst.first_tabpage.item.tp_next).is_void then
							screen_putchar (('X').code, 0, (globals_inst.Columns.item).to_integer_32 - 1, l_attr_nosel)
							globals_inst.TabPageIdxs[(globals_inst.Columns.item - 1)] := (-999).to_integer_16
						end
				when 14 then -- if done
						globals_inst.redraw_tabline := 0
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	draw_vsep_win (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_row: INTEGER_32)
		local
			l_hl: CE_ARRAY [INTEGER_32]
			l_c: INTEGER_32
		do
			create l_hl.make (<<1>>)

			if (a_wp___0.item.w_vsep_width).to_boolean then
				l_c := fillchar_vsep (l_hl)
				screen_fill (a_wp___0.item.w_winrow + a_row, a_wp___0.item.w_winrow + a_wp___0.item.w_height, a_wp___0.item.w_wincol + a_wp___0.item.w_width, (a_wp___0.item.w_wincol + a_wp___0.item.w_width) + 1, l_c, (' ').code, l_hl.item)
			end
		end

	end_search_hl
		do
			if not (search_hl.item.rm.regprog).is_void then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (search_hl.item.rm.regprog))
				search_hl.item.rm.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			end
		end

	fill_foldcolumn (a_p___0: CE_POINTER [NATURAL_8]; a_wp___0: CE_POINTER [PD_WINDOW_S]; a_closed: INTEGER_32; a_lnum: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_level: INTEGER_32
			l_first_level: INTEGER_32
			l_empty: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 0
					misc2_inst.copy_spaces (a_p___0, (a_wp___0.item.w_onebuf_opt.wo_fdc).to_natural_32)
					l_level := win_foldinfo.item.fi_level
					if not (l_level > 0) then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_wp___0.item.w_onebuf_opt.wo_fdc = 1 then
							l_empty := 0
						else
							l_empty := 1
						end
						l_first_level := ((((l_level.to_integer_32 - a_wp___0.item.w_onebuf_opt.wo_fdc) - a_closed.to_integer_32) + 1) + l_empty.to_integer_32).to_integer_32
						if l_first_level < 1 then
							l_first_level := 1
						end
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (not js.loop_done and then ((l_i___0 + l_empty).to_integer_32 < a_wp___0.item.w_onebuf_opt.wo_fdc)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						if (win_foldinfo.item.fi_lnum).to_integer_32 /= a_lnum then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_first_level + l_i___0 >= win_foldinfo.item.fi_low_level then
							a_p___0[l_i___0] := (('-').code).to_natural_8
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if l_first_level = 1 then
							a_p___0[l_i___0] := (('|').code).to_natural_8
						elseif l_first_level + l_i___0 <= 9 then
							a_p___0[l_i___0] := ((48 + l_first_level) + l_i___0).to_natural_8
						else
							a_p___0[l_i___0] := (('>').code).to_natural_8
						end
				when 7 then
						if l_first_level + l_i___0 = l_level then
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done | if done
						if a_closed.to_boolean then
							if l_i___0.to_integer_32 >= a_wp___0.item.w_onebuf_opt.wo_fdc then
								l_tmp := l_i___0 - 1
							else
								l_tmp := l_i___0
							end
							a_p___0[l_tmp] := (('+').code).to_natural_8
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	fillchar_status (a_attr: CE_POINTER [INTEGER_32]; a_is_curwin: INTEGER_32): INTEGER_32
		local
			l_fill: INTEGER_32
			js: JUMP_STATE
		do
			if a_is_curwin.to_boolean then
				a_attr.item := globals_inst.highlight_attr[11]
				l_fill := globals_inst.fill_stl.item
			else
				a_attr.item := globals_inst.highlight_attr[12]
				l_fill := globals_inst.fill_stlnc.item
			end
			if a_attr.item /= 0 then
				if globals_inst.highlight_attr[11] /= globals_inst.highlight_attr[12] then
					Result := l_fill
					js.return
				elseif not a_is_curwin.to_boolean then
					Result := l_fill
					js.return
				elseif globals_inst.firstwin.is_equal (globals_inst.lastwin) then
					Result := l_fill
					js.return
				elseif globals_inst.fill_stl.item /= globals_inst.fill_stlnc.item then
					Result := l_fill
					js.return
				end
			end
			if not js.return_called and then (a_is_curwin.to_boolean) then
				Result := (('^').code)
				js.return
			end
			if not js.return_called then
				Result := (('=').code)
			end
		end

	fillchar_vsep (a_attr: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			a_attr.item := globals_inst.highlight_attr[13]
			if a_attr.item = 0 then
				if globals_inst.fill_vert.item = 32 then
					Result := (('|').code)
				else
					Result := (globals_inst.fill_vert.item)
				end
			else
				Result := (globals_inst.fill_vert.item)
			end
		end

	fold_line (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_fold_count: INTEGER_32; a_foldinfo: CE_POINTER [PD_FOLDINFO]; a_lnum: INTEGER_32; a_row: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_top: CE_POINTER [PD_POS_T]
			l_bot: CE_POINTER [PD_POS_T]
			l_lnume: INTEGER_32
			l_len: INTEGER_32
			l_text: CE_POINTER [NATURAL_8]
			l_fdc: INTEGER_32
			l_col: INTEGER_32
			l_txtcol: INTEGER_32
			l_off___0: INTEGER_32
			l_ri: INTEGER_32
			l_w: INTEGER_32
			l_num: INTEGER_32
			l_cells: INTEGER_32
			l_u8c: INTEGER_32
			l_u8cc: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_c_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make (<<51>>)
			create l_top.make
			create l_bot.make
			create l_text.make
			create l_u8cc.make (<<6>>)
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnume := (a_lnum + a_fold_count) - 1
					l_off___0 := current_ScreenLine.distance (globals_inst.ScreenLines)
					l_col := 0
					if globals_inst.cmdwin_type /= 0 then
						if a_wp___0.is_equal (globals_inst.curwin) then
							globals_inst.ScreenLines[l_off___0] := globals_inst.cmdwin_type.to_natural_8
							globals_inst.ScreenAttrs[l_off___0] := (globals_inst.highlight_attr[1]).to_natural_16
							if globals_inst.enc_utf8.to_boolean then
								globals_inst.ScreenLinesUC[l_off___0] := (0).to_natural_32
							end
							l_col := l_col + 1
						end
					end
					l_fdc := (a_wp___0.item.w_onebuf_opt.wo_fdc).to_integer_32
					if l_fdc > a_wp___0.item.w_width - l_col then
						l_fdc := a_wp___0.item.w_width - l_col
					end
					if l_fdc > 0 then
						fill_foldcolumn (l_buf___6, a_wp___0, 1, a_lnum)
						copy_text_attr (l_off___0 + l_col, l_buf___6, l_fdc, globals_inst.highlight_attr[20])
						l_col := l_col + l_fdc
					end
					l_ri := 0
					from
					until
						not (l_ri < a_wp___0.item.w_width - l_col)
					loop
						globals_inst.ScreenAttrs[((l_off___0 + l_col) + l_ri)] := (globals_inst.highlight_attr[19]).to_natural_16
						l_ri := l_ri + 1
					end
					if (draw_signcolumn (a_wp___0)).to_boolean then
						l_len := a_wp___0.item.w_width - l_col
						if l_len > 0 then
							if l_len > 2 then
								l_len := 2
							end
							copy_text_attr (l_off___0 + l_col, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("  ")), l_len, globals_inst.highlight_attr[19])
							l_col := l_col + l_len
						end
					end
					if not ((a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((a_wp___0.item.w_onebuf_opt.wo_rnu).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_len := a_wp___0.item.w_width - l_col
						if l_len > 0 then
							l_w := (number_width (a_wp___0))
							if l_len > l_w + 1 then
								l_len := l_w + 1
							end
							if (a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean then
								l_num := a_lnum
							else
								l_num := (abs ((misc2_inst.get_cursor_rel_lnum (a_wp___0, a_lnum)).to_integer_32)).to_integer_32
							end
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("%%*ld "), l_w, l_num]).do_nothing
							copy_text_attr (l_off___0 + l_col, l_buf___6, l_len, globals_inst.highlight_attr[19])
							l_col := l_col + l_len
						end
				when 5 then -- if done
						l_text := fold_inst.get_foldtext (a_wp___0, a_lnum, l_lnume, a_foldinfo, l_buf___6)
						l_txtcol := l_col
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 6 then -- if:
							l_idx := l_off___0 + l_col
							l_p___0 := l_text
				when 7 then -- loop condition:
							if not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0)) then
								l_pos := -1 + 22 -- skip loop
							end
				when 8 then -- loop body:
							l_cells := globals_inst.mb_ptr2cells.integer_32_item ([l_p___0])
							l_c_len := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
							if l_col + l_cells > a_wp___0.item.w_width then
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 21 -- skip if block
							end
				when 9 then -- if:
							globals_inst.ScreenLines[l_idx] := l_p___0.item
							if not (globals_inst.enc_utf8.to_boolean) then
								l_pos := -1 + 16 -- skip if block
							end
				when 10 then -- if:
							l_u8c := mbyte_inst.utfc_ptr2char (l_p___0, l_u8cc)
							if not ((l_p___0.item).to_integer_32 < 128) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							if l_u8cc[0] = 0 then
								globals_inst.ScreenLinesUC[l_idx] := (0).to_natural_32
							else
								l_pos := -1 + 13 -- goto _L___0
							end
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 13 then -- else: | _L___0:
							globals_inst.ScreenLinesUC[l_idx] := l_u8c.to_natural_32
							l_i___0 := 0
							from
							until
								not (not js.loop_done and then (l_i___0 < globals_inst.Screen_mco))
							loop
								(globals_inst.ScreenLinesC[l_i___0])[l_idx] := (l_u8cc[l_i___0]).to_natural_32
								if l_u8cc[l_i___0] = 0 then
									js.break
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
				when 14 then
							if l_cells > 1 then
								globals_inst.ScreenLines[(l_idx + 1)] := (0).to_natural_8
							end
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 16 then -- else:
							if globals_inst.enc_dbcs /= 9_932 then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
							if (l_p___0.item).to_integer_32 = 142 then
								globals_inst.ScreenLines2[l_idx] := l_p___0[1]
							else
								l_pos := -1 + 19 -- goto _L___1
							end
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 19 then -- else: | _L___1:
							if l_cells > 1 then
								globals_inst.ScreenLines[(l_idx + 1)] := l_p___0[1]
							end
				when 20 then -- if done
							l_col := l_col + l_cells
							l_idx := l_idx + l_cells
							l_p___0 := l_p___0 + l_c_len
				when 21 then -- if done
							l_pos := -1 + 7 -- back to loop condition
				when 22 then -- loop done | if block done, skip else block:
							l_pos := -1 + 24
				when 23 then -- else:
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_text))).to_integer_32
							if l_len > a_wp___0.item.w_width - l_col then
								l_len := a_wp___0.item.w_width - l_col
							end
							if l_len > 0 then
								strncpy (create {CE_POINTER [INTEGER_8]}.make_cast ((current_ScreenLine + l_col)), create {CE_POINTER [INTEGER_8]}.make_cast (l_text), l_len.to_natural_32).do_nothing
								l_col := l_col + l_len
							end
				when 24 then -- if done
						from
						until
							not (l_col < a_wp___0.item.w_width)
						loop
							if globals_inst.enc_utf8.to_boolean then
								if globals_inst.fill_fold.item >= 128 then
									globals_inst.ScreenLinesUC[(l_off___0 + l_col)] := (globals_inst.fill_fold.item).to_natural_32;
									(globals_inst.ScreenLinesC[0])[(l_off___0 + l_col)] := (0).to_natural_32
								else
									globals_inst.ScreenLinesUC[(l_off___0 + l_col)] := (0).to_natural_32
								end
							end
							l_tmp___4 := l_col
							l_col := l_col + 1
							globals_inst.ScreenLines[(l_off___0 + l_tmp___4)] := (globals_inst.fill_fold.item).to_natural_8
						end
						if not l_text.is_equal (l_buf___6) then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text))
						end
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 25 then -- if:
							if not ((a_wp___0.item.w_buffer).is_equal (globals_inst.curwin.item.w_buffer)) then
								l_pos := -1 + 42 -- skip if block
							end
				when 26 then -- if:
							if globals_inst.curwin.item.w_cursor.lnum /= globals_inst.VIsual.item.lnum then
								l_tmp___6 := (globals_inst.curwin.item.w_cursor.lnum < globals_inst.VIsual.item.lnum).to_integer
							else
								if globals_inst.curwin.item.w_cursor.col /= globals_inst.VIsual.item.col then
									l_tmp___5 := (globals_inst.curwin.item.w_cursor.col < globals_inst.VIsual.item.col).to_integer
								else
									l_tmp___5 := (globals_inst.curwin.item.w_cursor.coladd < globals_inst.VIsual.item.coladd).to_integer
								end
								l_tmp___6 := l_tmp___5
							end
							if l_tmp___6.to_boolean then
								l_top := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
								l_bot := globals_inst.VIsual
							elseif globals_inst.curwin.item.w_cursor.lnum = globals_inst.VIsual.item.lnum then
								if globals_inst.curwin.item.w_cursor.col = globals_inst.VIsual.item.col then
									if globals_inst.curwin.item.w_cursor.coladd = globals_inst.VIsual.item.coladd then
										l_top := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
										l_bot := globals_inst.VIsual
									else
										l_top := globals_inst.VIsual
										l_bot := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
									end
								else
									l_top := globals_inst.VIsual
									l_bot := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
								end
							else
								l_top := globals_inst.VIsual
								l_bot := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							end
							if not (a_lnum >= l_top.item.lnum) then
								l_pos := -1 + 42 -- skip if block
							end
				when 27 then -- if:
							if not (l_lnume <= l_bot.item.lnum) then
								l_pos := -1 + 42 -- skip if block
							end
				when 28 then -- if:
							if globals_inst.VIsual_mode = 118 then
								l_pos := -1 + 31 -- skip if block
							end
				when 29 then -- if:
							l_pos := -1 + 41 -- goto _L___3
				when 30 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 31 then -- else:
							if not (a_lnum > l_top.item.lnum) then
								l_pos := -1 + 34 -- skip if block
							end
				when 32 then -- if:
							l_pos := -1 + 36 -- goto _L___4
				when 33 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 34 then -- else:
							if a_lnum /= l_top.item.lnum then
								l_pos := -1 + 42 -- skip if block
							end
				when 35 then -- if:
							if l_top.item.col /= 0 then
								l_pos := -1 + 42 -- skip if block
							end
				when 36 then -- if: | _L___4:
							if not (l_lnume < l_bot.item.lnum) then
								l_pos := -1 + 39 -- skip if block
							end
				when 37 then -- if:
							l_pos := -1 + 41 -- goto _L___3
				when 38 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 39 then -- else:
							if l_lnume /= l_bot.item.lnum then
								l_pos := -1 + 42 -- skip if block
							end
				when 40 then -- if:
							if not (l_bot.item.col - ((option_inst.p_sel.item.item).to_integer_32 = 101).to_integer >= (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_buf (a_wp___0.item.w_buffer, l_lnume, 0))))).to_integer_32) then
								l_pos := -1 + 42 -- skip if block
							end
				when 41 then -- if: | _L___3:
							if globals_inst.VIsual_mode = 22 then
								if a_wp___0.item.w_old_cursor_fcol + l_txtcol < a_wp___0.item.w_width then
									if a_wp___0.item.w_old_cursor_lcol + l_txtcol < a_wp___0.item.w_width then
										l_len := a_wp___0.item.w_old_cursor_lcol
									else
										l_len := a_wp___0.item.w_width - l_txtcol
									end
									l_ri := 0
									from
									until
										not (l_ri < l_len - a_wp___0.item.w_old_cursor_fcol)
									loop
										globals_inst.ScreenAttrs[((l_off___0 + (a_wp___0.item.w_old_cursor_fcol + l_txtcol)) + l_ri)] := (globals_inst.highlight_attr[15]).to_natural_16
										l_ri := l_ri + 1
									end
								end
							else
								l_ri := 0
								from
								until
									not (l_ri < a_wp___0.item.w_width - l_txtcol)
								loop
									globals_inst.ScreenAttrs[((l_off___0 + l_txtcol) + l_ri)] := (globals_inst.highlight_attr[15]).to_natural_16
									l_ri := l_ri + 1
								end
							end
				when 42 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
							if (a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean then
								l_txtcol := l_txtcol + (a_wp___0.item.w_virtcol)
								if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
									l_txtcol := l_txtcol - (a_wp___0.item.w_skipcol)
								else
									l_txtcol := l_txtcol - (a_wp___0.item.w_leftcol)
								end
								if l_txtcol >= 0 then
									if l_txtcol < a_wp___0.item.w_width then
										globals_inst.ScreenAttrs[(l_off___0 + l_txtcol)] := (syntax_inst.hl_combine_attr ((globals_inst.ScreenAttrs[(l_off___0 + l_txtcol)]).to_integer_32, globals_inst.highlight_attr[38])).to_natural_16
									end
								end
							end
							screen_line (a_row + a_wp___0.item.w_winrow, a_wp___0.item.w_wincol, a_wp___0.item.w_width, a_wp___0.item.w_width)
							if a_wp___0.is_equal (globals_inst.curwin) then
								if a_lnum <= globals_inst.curwin.item.w_cursor.lnum then
									if l_lnume >= globals_inst.curwin.item.w_cursor.lnum then
										globals_inst.curwin.item.w_cline_row := a_row
										globals_inst.curwin.item.w_cline_height := 1
										globals_inst.curwin.item.w_cline_folded := 1
										globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((24))
									end
								end
							end
				when 43 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	free_screenlines
		local
			l_i___0: INTEGER_32
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.ScreenLinesUC))
			l_i___0 := 0
			from
			until
				not (l_i___0 < globals_inst.Screen_mco)
			loop
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.ScreenLinesC[l_i___0]))
				l_i___0 := l_i___0 + 1
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.ScreenLines2))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.ScreenLines))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.ScreenAttrs))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.LineOffset))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.LineWraps))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.TabPageIdxs))
		end

	get_keymap_str (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_old_curbuf.make
			create l_old_curwin___1.make
			create l_s.make

			if (a_wp___0.item.w_buffer).item.b_p_iminsert /= 1 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_old_curbuf := globals_inst.curbuf
				l_old_curwin___1 := globals_inst.curwin
				globals_inst.curbuf := a_wp___0.item.w_buffer
				globals_inst.curwin := a_wp___0
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), ce_string ("b:keymap_name")).do_nothing
				globals_inst.emsg_skip := globals_inst.emsg_skip + 1
				l_p___0 := eval_inst.eval_to_string (a_buf___6, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), 0)
				l_s := l_p___0
				globals_inst.emsg_skip := globals_inst.emsg_skip - 1
				globals_inst.curbuf := l_old_curbuf
				globals_inst.curwin := l_old_curwin___1
				if l_p___0.is_void then
					l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lang"))
				elseif (l_p___0.item).to_integer_32 = 0 then
					l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lang"))
				end
				if ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 3).to_integer_32 < a_len then
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), ce_string ("<%%s>"), l_p___0]).do_nothing
				else
					a_buf___6[0] := (('%/0/').code).to_natural_8
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s))
				Result := ((a_buf___6[0]).to_integer_32 /= 0).to_integer
			end
		end

	get_trans_bufname (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			if not (buffer_inst.buf_spname (a_buf___6)).is_void then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff.item), (buffer_inst.buf_spname (a_buf___6))).do_nothing
			else
				misc1_inst.home_replace (a_buf___6, a_buf___6.item.b_fname, globals_inst.NameBuff.item, 4_096, 1)
			end
			charset_inst.trans_characters (globals_inst.NameBuff.item, 4_096)
		end

	init_search_hl (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_cur: CE_POINTER [PD_MATCHITEM]
		do
			create l_cur.make

			l_cur := a_wp___0.item.w_match_head
			from
			until
				l_cur.is_void
			loop
				l_cur.item.hl.rm := (l_cur.item.match).twin
				if l_cur.item.hlg_id = 0 then
					l_cur.item.hl.attr := 0
				else
					l_cur.item.hl.attr := syntax_inst.syn_id2attr (l_cur.item.hlg_id)
				end
				l_cur.item.hl.buf := a_wp___0.item.w_buffer
				l_cur.item.hl.lnum := (0).to_integer_32
				l_cur.item.hl.first_lnum := (0).to_integer_32
				ex_cmds2_inst.profile_setlimit (option_inst.p_rdt.item, create {CE_POINTER [SD_TIMEVAL]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl") + (create {PD_MATCH_T}.make).offset_of ("tm")))
				l_cur := l_cur.item.next
			end
			search_hl.item.buf := a_wp___0.item.w_buffer
			search_hl.item.lnum := (0).to_integer_32
			search_hl.item.first_lnum := (0).to_integer_32
		end

	lineclear (a_off___0: NATURAL_32; a_width: INTEGER_32)
		do
			memset (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLines + a_off___0.to_integer_32)), (' ').code, a_width.to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
			if globals_inst.enc_utf8.to_boolean then
				memset (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLinesUC + a_off___0.to_integer_32)), 0, a_width.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
			end
			memset (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenAttrs + a_off___0.to_integer_32)), 0, a_width.to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
		end

	linecopy (a_to: INTEGER_32; a_from: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_off_to: NATURAL_32
			l_off_from: NATURAL_32
			l_i___0: INTEGER_32
		do
			l_off_to := globals_inst.LineOffset[a_to] + (a_wp___0.item.w_wincol).to_natural_32
			l_off_from := globals_inst.LineOffset[a_from] + (a_wp___0.item.w_wincol).to_natural_32
			memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLines + l_off_to.to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLines + l_off_from.to_integer_32)), (a_wp___0.item.w_width).to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
			if globals_inst.enc_utf8.to_boolean then
				memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLinesUC + l_off_to.to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLinesUC + l_off_from.to_integer_32)), (a_wp___0.item.w_width).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
				l_i___0 := 0
				from
				until
					not (l_i___0.to_integer_32 < option_inst.p_mco.item)
				loop
					memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLinesC[l_i___0] + l_off_to.to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLinesC[l_i___0] + l_off_from.to_integer_32)), (a_wp___0.item.w_width).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
					l_i___0 := l_i___0 + 1
				end
			end
			if globals_inst.enc_dbcs = 9_932 then
				memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLines2 + l_off_to.to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLines2 + l_off_from.to_integer_32)), (a_wp___0.item.w_width).to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
			end
			memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenAttrs + l_off_to.to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenAttrs + l_off_from.to_integer_32)), (a_wp___0.item.w_width).to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
		end

	lineinvalid (a_off___0: NATURAL_32; a_width: INTEGER_32)
		do
			memset (create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenAttrs + a_off___0.to_integer_32)), -1, a_width.to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
		end

	messaging: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (option_inst.p_lz.item).to_boolean then
				if (getchar_inst.char_avail).to_boolean then
					if not globals_inst.KeyTyped.to_boolean then
						l_tmp___0 := 0
					else
						l_tmp___0 := 1
					end
				else
					l_tmp___0 := 1
				end
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	msg_pos_mode
		do
			globals_inst.msg_col := 0
			globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
		end

	next_search_hl (a_win: CE_POINTER [PD_WINDOW_S]; a_shl: CE_POINTER [PD_MATCH_T]; a_lnum: INTEGER_32; a_mincol: INTEGER_32)
		local
			l_l: INTEGER_32
			l_matchcol: INTEGER_32
			l_nmatched: INTEGER_32
			l_ml: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ml.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_shl.item.lnum /= 0 then
						l_l := (a_shl.item.lnum + a_shl.item.rm.endpos[0].lnum) - a_shl.item.rm.startpos[0].lnum
						if a_lnum > l_l then
							a_shl.item.lnum := (0).to_integer_32
						elseif a_lnum < l_l then
							js.return
						elseif a_shl.item.rm.endpos[0].col > a_mincol then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 24 -- skip if block
					end
				when 1 then -- if:
						globals_inst.called_emsg := 0
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 24 -- skip loop
						end
				when 3 then -- loop body:
						if (ex_cmds2_inst.profile_passed_limit (create {CE_POINTER [SD_TIMEVAL]}.make_shared (a_shl.c_pointer + (create {PD_MATCH_T}.make).offset_of ("tm")))).to_boolean then
							a_shl.item.lnum := (0).to_integer_32
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if a_shl.item.lnum /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_matchcol := 0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 7 then -- else:
						if not ((misc2_inst.vim_strchr (option_inst.p_cpo.item, ('c').code)).is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else:
						if a_shl.item.rm.endpos[0].lnum /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if not (a_shl.item.rm.endpos[0].col <= a_shl.item.rm.startpos[0].col) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L:
						l_matchcol := a_shl.item.rm.startpos[0].col
						l_ml := (memline_inst.ml_get_buf (a_shl.item.buf, a_lnum, 0)) + l_matchcol
						if (l_ml.item).to_integer_32 = 0 then
							l_matchcol := l_matchcol + 1
							a_shl.item.lnum := (0).to_integer_32
							js.break
						end
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								l_matchcol := l_matchcol + (globals_inst.mb_ptr2len.integer_32_item ([l_ml]))
							else
								l_matchcol := l_matchcol + 1
							end
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_matchcol := a_shl.item.rm.endpos[0].col
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_matchcol := a_shl.item.rm.endpos[0].col
				when 17 then -- if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						a_shl.item.lnum := a_lnum
						l_nmatched := regexp_inst.vim_regexec_multi (create {CE_POINTER [PD_REGMMATCH_T]}.make_shared (a_shl.c_pointer + (create {PD_MATCH_T}.make).offset_of ("rm")), a_win, a_shl.item.buf, a_lnum, l_matchcol, create {CE_POINTER [SD_TIMEVAL]}.make_shared (a_shl.c_pointer + (create {PD_MATCH_T}.make).offset_of ("tm")))
						if not (globals_inst.called_emsg.to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if not (globals_inst.got_int.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___0:
						if a_shl.is_equal (search_hl) then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_shl.item.rm.regprog))
							globals_inst.no_hlsearch := 1
						end
						a_shl.item.rm.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
						a_shl.item.lnum := (0).to_integer_32
						globals_inst.got_int := 0
						js.break
				when 23 then -- if done | if done
						if not js.loop_jumped and then (l_nmatched = 0) then
							a_shl.item.lnum := (0).to_integer_32
							js.break
						end
						if not js.loop_jumped then
							if a_shl.item.rm.startpos[0].lnum > 0 then
								a_shl.item.lnum := a_shl.item.lnum + (a_shl.item.rm.startpos[0].lnum)
								js.break
							elseif a_shl.item.rm.startpos[0].col >= a_mincol then
								a_shl.item.lnum := a_shl.item.lnum + (a_shl.item.rm.startpos[0].lnum)
								js.break
							elseif l_nmatched > 1 then
								a_shl.item.lnum := a_shl.item.lnum + (a_shl.item.rm.startpos[0].lnum)
								js.break
							elseif a_shl.item.rm.endpos[0].col > a_mincol then
								a_shl.item.lnum := a_shl.item.lnum + (a_shl.item.rm.startpos[0].lnum)
								js.break
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 24 then -- loop done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	number_width (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_n: INTEGER_32
			l_lnum: INTEGER_32
			js: JUMP_STATE
		do
			if (a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean then
				l_lnum := (a_wp___0.item.w_buffer).item.b_ml.ml_line_count
			else
				l_lnum := (a_wp___0.item.w_height).to_integer_32
			end
			if l_lnum = a_wp___0.item.w_nrwidth_line_count then
				Result := (a_wp___0.item.w_nrwidth_width)
				js.return
			end
			if not js.return_called then
				a_wp___0.item.w_nrwidth_line_count := l_lnum
				l_n := 0
				from
				until
					js.loop_done
				loop
					l_lnum := l_lnum // (10)
					l_n := l_n + 1
					if not (l_lnum > 0) then
						js.break
					end
				end
				if l_n.to_integer_32 < a_wp___0.item.w_onebuf_opt.wo_nuw - 1 then
					l_n := (a_wp___0.item.w_onebuf_opt.wo_nuw - 1).to_integer_32
				end
				a_wp___0.item.w_nrwidth_width := l_n
				Result := l_n
			end
		end

	prepare_search_hl (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32)
		local
			l_cur: CE_POINTER [PD_MATCHITEM]
			l_shl: CE_POINTER [PD_MATCH_T]
			l_shl_flag: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_cur.make
			create l_shl.make

			l_cur := a_wp___0.item.w_match_head
			l_shl_flag := 0
			from
			until
				js.loop_done
			loop
				if l_cur.is_void then
					if l_shl_flag /= 0 then
						js.break
					end
				end
				if not js.loop_jumped then
					if l_shl_flag = 0 then
						l_shl := search_hl
						l_shl_flag := 1
					else
						l_shl := create {CE_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
					end
					if not (l_shl.item.rm.regprog).is_void then
						if l_shl.item.lnum = 0 then
							if (regexp_inst.re_multiline (l_shl.item.rm.regprog)).to_boolean then
								if l_shl.item.first_lnum = 0 then
									l_shl.item.first_lnum := a_lnum
									from
									until
										not (not js.loop_done and then (l_shl.item.first_lnum > a_wp___0.item.w_topline))
									loop
										if (fold_inst.hasFoldingWin (a_wp___0, l_shl.item.first_lnum - 1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))).to_boolean then
											js.break
										end
										if not js.loop_jumped then
											l_shl.item.first_lnum := (l_shl.item.first_lnum) - 1
										end
									end
								end
								l_n := 0
								from
								until
									js.loop_done
								loop
									if l_shl.item.first_lnum < a_lnum then
										if (l_shl.item.rm.regprog).is_void then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										next_search_hl (a_wp___0, l_shl, l_shl.item.first_lnum, l_n)
										if l_shl.item.lnum /= 0 then
											l_shl.item.first_lnum := (l_shl.item.lnum + l_shl.item.rm.endpos[0].lnum) - l_shl.item.rm.startpos[0].lnum
											l_n := l_shl.item.rm.endpos[0].col
										else
											l_shl.item.first_lnum := (l_shl.item.first_lnum) + 1
											l_n := 0
										end
									end
								end
							end
						end
					end
					if not l_shl.is_equal (search_hl) then
						if not l_cur.is_void then
							l_cur := l_cur.item.next
						end
					end
				end
			end
		end

	redrawWinline (a_lnum: INTEGER_32; a_invalid: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			if globals_inst.curwin.item.w_redraw_top = 0 then
				globals_inst.curwin.item.w_redraw_top := a_lnum
			elseif globals_inst.curwin.item.w_redraw_top > a_lnum then
				globals_inst.curwin.item.w_redraw_top := a_lnum
			end
			if globals_inst.curwin.item.w_redraw_bot = 0 then
				globals_inst.curwin.item.w_redraw_bot := a_lnum
			elseif globals_inst.curwin.item.w_redraw_bot < a_lnum then
				globals_inst.curwin.item.w_redraw_bot := a_lnum
			end
			redraw_later (10)
			if a_invalid.to_boolean then
				l_i___0 := fold_inst.find_wl_entry (globals_inst.curwin, a_lnum)
				if l_i___0 >= 0 then
					(globals_inst.curwin.item.w_lines + l_i___0).item.wl_valid := (0).to_integer_8
				end
			end
		end

	redraw_all_later (a_type: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			create l_wp___0.make

			l_wp___0 := globals_inst.firstwin
			from
			until
				l_wp___0.is_void
			loop
				redraw_win_later (l_wp___0, a_type)
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	redraw_block (a_row: INTEGER_32; a_end: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_col: INTEGER_32
			l_width: INTEGER_32
		do
			ui_inst.clip_may_clear_selection (a_row, a_end - 1)
			if a_wp___0.is_void then
				l_col := 0
				l_width := (globals_inst.Columns.item).to_integer_32
			else
				l_col := a_wp___0.item.w_wincol
				l_width := a_wp___0.item.w_width
			end
			screen_draw_rectangle (a_row, l_col, a_end - a_row, l_width, 0)
		end

	redraw_buf_later (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_type: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			create l_wp___0.make

			l_wp___0 := globals_inst.firstwin
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_buffer).is_equal (a_buf___6) then
					redraw_win_later (l_wp___0, a_type)
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	redraw_curbuf_later (a_type: INTEGER_32)
		do
			redraw_buf_later (globals_inst.curbuf, a_type)
		end

	redraw_custom_statusline (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_save_called_emsg: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_save_called_emsg := globals_inst.called_emsg
			if entered___3.to_boolean then
				js.return
			end
			if not js.return_called then
				entered___3 := 1
				globals_inst.called_emsg := 0
				win_redr_custom (a_wp___0, 0)
				if globals_inst.called_emsg.to_boolean then
					if ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 /= 0 then
						l_tmp := 4
					else
						l_tmp := 2
					end
					option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("statusline")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), (1).bit_or (l_tmp), -5)
				end
				globals_inst.called_emsg := (globals_inst.called_emsg).bit_or (l_save_called_emsg)
				entered___3 := 0
			end
		end

	redraw_later (a_type: INTEGER_32)
		do
			redraw_win_later (globals_inst.curwin, a_type)
		end

	redraw_later_clear
		do
			redraw_all_later (50)
			if (gui_inst.gui.item.in_use).to_boolean then
				screen_attr := 64
			else
				screen_attr := 11
			end
		end

	redraw_statuslines
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			create l_wp___0.make

			l_wp___0 := globals_inst.firstwin
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_redr_status).to_boolean then
					win_redr_status (l_wp___0)
				end
				l_wp___0 := l_wp___0.item.w_next
			end
			if globals_inst.redraw_tabline.to_boolean then
				draw_tabline
			end
		end

	redraw_win_later (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_type: INTEGER_32)
		do
			if a_wp___0.item.w_redr_type < a_type then
				a_wp___0.item.w_redr_type := a_type
				if a_type >= 40 then
					a_wp___0.item.w_lines_valid := 0
				end
				if globals_inst.must_redraw < a_type then
					globals_inst.must_redraw := a_type
				end
			end
		end

	redrawing: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if not globals_inst.RedrawingDisabled.to_boolean then
				if (option_inst.p_lz.item).to_boolean then
					if (getchar_inst.char_avail).to_boolean then
						if not globals_inst.KeyTyped.to_boolean then
							if not globals_inst.do_redraw.to_boolean then
								l_tmp___0 := 0
							else
								l_tmp___0 := 1
							end
						else
							l_tmp___0 := 1
						end
					else
						l_tmp___0 := 1
					end
				else
					l_tmp___0 := 1
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	reset_cterm_colors
		do
			if globals_inst.t_colors > 1 then
				if globals_inst.cterm_normal_fg_color > 0 then
					term_inst.out_str (term_inst.term_strings[56])
					screen_attr := -1
				elseif globals_inst.cterm_normal_bg_color > 0 then
					term_inst.out_str (term_inst.term_strings[56])
					screen_attr := -1
				end
				if globals_inst.cterm_normal_fg_bold.to_boolean then
					term_inst.out_str (term_inst.term_strings[15])
					screen_attr := -1
				end
			end
		end

	screen_char (a_off___0: NATURAL_32; a_row: INTEGER_32; a_col: INTEGER_32)
		local
			l_attr: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make (<<22>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_row >= globals_inst.screen_Rows then
						js.return
					elseif a_col >= globals_inst.screen_Columns then
						js.return
					end
					if not js.return_called and then (a_row = globals_inst.screen_Rows - 1) then
						if a_col = globals_inst.screen_Columns - 1 then
							globals_inst.ScreenAttrs[a_off___0.to_integer_32] := (-1).to_natural_16
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if screen_char_attr /= 0 then
							l_attr := screen_char_attr
						else
							l_attr := (globals_inst.ScreenAttrs[a_off___0.to_integer_32]).to_integer_32
						end
						if screen_attr /= l_attr then
							screen_stop_highlight
						end
						windgoto (a_row, a_col)
						if screen_attr /= l_attr then
							screen_start_highlight (l_attr)
						end
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if globals_inst.ScreenLinesUC[a_off___0.to_integer_32] /= {NATURAL_32} 0 then
							l_buf___6[(mbyte_inst.utfc_char2bytes (a_off___0.to_integer_32, l_buf___6))] := (('%/0/').code).to_natural_8
							term_inst.out_str (l_buf___6)
							if (mbyte_inst.utf_char2cells ((globals_inst.ScreenLinesUC[a_off___0.to_integer_32]).to_integer_32)) > 1 then
								screen_cur_col := screen_cur_col + 1
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						term_inst.out_flush_check
						term_inst.out_char ((globals_inst.ScreenLines[a_off___0.to_integer_32]).to_natural_32)
						if globals_inst.enc_dbcs = 9_932 then
							if (globals_inst.ScreenLines[a_off___0.to_integer_32]).to_integer_32 = 142 then
								term_inst.out_char ((globals_inst.ScreenLines2[a_off___0.to_integer_32]).to_natural_32)
							end
						end
				when 5 then
						screen_cur_col := screen_cur_col + 1
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_char_2 (a_off___0: NATURAL_32; a_row: INTEGER_32; a_col: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if a_off___0 + {NATURAL_32} 1 >= (globals_inst.screen_Rows * globals_inst.screen_Columns).to_natural_32 then
				js.return
			end
			if not js.return_called and then (a_row = globals_inst.screen_Rows - 1) then
				if a_col >= globals_inst.screen_Columns - 2 then
					globals_inst.ScreenAttrs[a_off___0.to_integer_32] := (-1).to_natural_16
					js.return
				end
			end
			if not js.return_called then
				screen_char (a_off___0, a_row, a_col)
				term_inst.out_char ((globals_inst.ScreenLines[(a_off___0 + {NATURAL_32} 1).to_integer_32]).to_natural_32)
				screen_cur_col := screen_cur_col + 1
			end
		end

	screen_comp_differs (a_off___0: INTEGER_32; a_u8cc: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_done and then (l_i___0 < globals_inst.Screen_mco))
			loop
				if (globals_inst.ScreenLinesC[l_i___0])[a_off___0] /= (a_u8cc[l_i___0]).to_natural_32 then
					Result := 1
					js.return
				end
				if not js.return_called then
					if a_u8cc[l_i___0] = 0 then
						js.break
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	screen_del_lines (a_off___0: INTEGER_32; a_row: INTEGER_32; a_line_count: INTEGER_32; a_end: INTEGER_32; a_force: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_row: INTEGER_32
			l_end: INTEGER_32
			l_j: INTEGER_32
			l_i___0: INTEGER_32
			l_temp: NATURAL_32
			l_cursor_row: INTEGER_32
			l_cursor_end: INTEGER_32
			l_result_empty: INTEGER_32
			l_can_delete: INTEGER_32
			l_type: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_row := a_row
					l_end := a_end
					if (screen_valid (1)).to_boolean then
						if a_line_count <= 0 then
							Result := 0
							js.return
						elseif not a_force.to_boolean then
							if a_line_count.to_integer_32 > option_inst.p_ttyscroll.item then
								Result := 0
								js.return
							end
						end
					else
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_result_empty := (l_row + a_line_count >= l_end).to_integer
						if ((term_inst.term_strings[11]).item).to_integer_32 = 0 then
							l_tmp___1 := 1
						elseif (can_clear (term_inst.term_strings[1])).to_boolean then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_can_delete := l_tmp___1
						if a_wp___0.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_wp___0.item.w_width).to_integer_32 /= globals_inst.Columns.item then
							if ((term_inst.term_strings[55]).item).to_integer_32 = 0 then
								l_type := 9
							else
								l_pos := -1 + 4 -- goto _L___7
							end
						else
							l_pos := -1 + 4 -- goto _L___7
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | _L___7:
						if not ((can_clear (term_inst.term_strings[8])).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_result_empty.to_boolean then
							l_type := 8
						else
							l_pos := -1 + 7 -- goto _L___5
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 7 then -- else: | _L___5:
						if l_row /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if a_line_count = 1 then
							l_type := 7
						elseif ((term_inst.term_strings[5]).item).to_integer_32 = 0 then
							l_type := 7
						else
							l_pos := -1 + 10 -- goto _L___4
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else: | _L___4:
						if ((term_inst.term_strings[5]).item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_line_count > 1 then
							if l_can_delete.to_boolean then
								l_type := 2
							else
								l_pos := -1 + 13 -- goto _L___3
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___3:
						if not ((can_clear (term_inst.term_strings[1])).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_result_empty.to_boolean then
							if a_wp___0.is_void then
								l_type := 4
							elseif (a_wp___0.item.w_width).to_integer_32 = globals_inst.Columns.item then
								l_type := 4
							else
								l_pos := -1 + 16 -- goto _L___1
							end
						else
							l_pos := -1 + 16 -- goto _L___1
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else: | _L___1:
						if ((term_inst.term_strings[4]).item).to_integer_32 = 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_can_delete.to_boolean then
							l_type := 5
						else
							l_pos := -1 + 19 -- goto _L
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L:
						if ((term_inst.term_strings[5]).item).to_integer_32 /= 0 then
							if l_can_delete.to_boolean then
								l_type := 2
							else
								Result := 0
								js.return
							end
						else
							Result := 0
							js.return
						end
				when 20 then -- if done | if done | if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 35 -- skip if block
						end
				when 21 then -- if:
							if a_off___0 + l_row > 0 then
								ui_inst.clip_clear_selection
							elseif not a_wp___0.is_void then
								if (a_wp___0.item.w_width).to_integer_32 /= globals_inst.Columns.item then
									ui_inst.clip_clear_selection
								else
									ui_inst.clip_scroll_selection (a_line_count)
								end
							else
								ui_inst.clip_scroll_selection (a_line_count)
							end
							gui_inst.gui_dont_update_cursor
							if ((term_inst.term_strings[36]).item).to_integer_32 /= 0 then
								l_cursor_row := l_row
								l_cursor_end := l_end
							else
								l_cursor_row := l_row + a_off___0
								l_cursor_end := l_end + a_off___0
							end
							l_row := l_row + a_off___0
							l_end := l_end + a_off___0
							l_i___0 := 0
				when 22 then -- loop condition:
							if not (not js.loop_done and then (l_i___0 < a_line_count)) then
								l_pos := -1 + 28 -- skip loop
							end
				when 23 then -- loop body:
							if a_wp___0.is_void then
								l_pos := -1 + 26 -- skip if block
							end
				when 24 then -- if:
							if (a_wp___0.item.w_width).to_integer_32 /= globals_inst.Columns.item then
								l_j := l_row + l_i___0
								from
								until
									js.loop_done
								loop
									l_j := l_j + a_line_count
									if not (l_j <= l_end - 1) then
										js.break
									end
									if not js.loop_jumped then
										linecopy (l_j - a_line_count, l_j, a_wp___0)
									end
								end
								l_j := l_j - a_line_count
								if (can_clear (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))).to_boolean then
									lineclear (globals_inst.LineOffset[l_j] + (a_wp___0.item.w_wincol).to_natural_32, a_wp___0.item.w_width)
								else
									lineinvalid (globals_inst.LineOffset[l_j] + (a_wp___0.item.w_wincol).to_natural_32, a_wp___0.item.w_width)
								end
								globals_inst.LineWraps[l_j] := (0).to_natural_8
							else
								l_pos := -1 + 26 -- goto _L___8
							end
				when 25 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 26 then -- else: | _L___8:
							l_j := l_row + l_i___0
							l_temp := globals_inst.LineOffset[l_j]
							from
							until
								js.loop_done
							loop
								l_j := l_j + a_line_count
								if not (l_j <= l_end - 1) then
									js.break
								end
								if not js.loop_jumped then
									globals_inst.LineOffset[(l_j - a_line_count)] := globals_inst.LineOffset[l_j]
									globals_inst.LineWraps[(l_j - a_line_count)] := globals_inst.LineWraps[l_j]
								end
							end
							globals_inst.LineOffset[(l_j - a_line_count)] := l_temp
							globals_inst.LineWraps[(l_j - a_line_count)] := (0).to_natural_8
							if (can_clear (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))).to_boolean then
								lineclear (l_temp, (globals_inst.Columns.item).to_integer_32)
							else
								lineinvalid (l_temp, (globals_inst.Columns.item).to_integer_32)
							end
				when 27 then
							l_i___0 := l_i___0 + 1
							l_pos := -1 + 22 -- back to loop condition
				when 28 then -- loop done
							screen_stop_highlight
							if l_type = 9 then
								redraw_block (l_row, l_end, a_wp___0)
							elseif l_type = 8 then
								windgoto (l_cursor_row, 0)
								term_inst.out_str (term_inst.term_strings[8])
								screen_start
							elseif l_type = 2 then
								windgoto (l_cursor_row, 0)
								term_inst.term_delete_lines (a_line_count)
								screen_start
							elseif l_type = 7 then
								windgoto (l_cursor_end - 1, 0)
								l_i___0 := a_line_count
								from
								until
									js.loop_done
								loop
									l_i___0 := l_i___0 - 1
									if not (l_i___0 >= 0) then
										js.break
									end
									if not js.loop_jumped then
										term_inst.out_char ((('%N').code).to_natural_32)
									end
								end
							else
								l_i___0 := a_line_count
								from
								until
									js.loop_done
								loop
									l_i___0 := l_i___0 - 1
									if not (l_i___0 >= 0) then
										js.break
									end
									if not js.loop_jumped then
										if l_type = 5 then
											windgoto (l_cursor_row, 0)
											term_inst.out_str (term_inst.term_strings[4])
										else
											windgoto (l_cursor_row + l_i___0, 0)
											term_inst.out_str (term_inst.term_strings[1])
										end
										screen_start
									end
								end
							end
							if not (((term_inst.term_strings[11]).item).to_boolean) then
								l_pos := -1 + 34 -- skip if block
							end
				when 29 then -- if:
							if l_type /= 5 then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 33 -- goto _L___9
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 32 then -- else:
							if l_type /= 2 then
								l_pos := -1 + 34 -- skip if block
							end
				when 33 then -- if: | _L___9:
							l_i___0 := a_line_count
							from
							until
								not (l_i___0 > 0)
							loop
								windgoto (l_cursor_end - l_i___0, 0)
								term_inst.out_str (term_inst.term_strings[1])
								screen_start
								l_i___0 := l_i___0 - 1
							end
				when 34 then -- if done | if done
							gui_inst.gui_can_update_cursor
							if (gui_inst.gui.item.in_use).to_boolean then
								term_inst.out_flush
							end
							Result := 1
				when 35 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	screen_draw_rectangle (a_row: INTEGER_32; a_col: INTEGER_32; a_height: INTEGER_32; a_width: INTEGER_32; a_invert: INTEGER_32)
		local
			l_r: INTEGER_32
			l_c: INTEGER_32
			l_off___0: INTEGER_32
			l_max_off: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.ScreenLines.is_void then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if a_invert.to_boolean then
							screen_char_attr := 1
						end
						l_r := a_row
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_r < a_row + a_height)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						l_off___0 := (globals_inst.LineOffset[l_r]).to_integer_32
						l_max_off := l_off___0 + globals_inst.screen_Columns
						l_c := a_col
				when 4 then -- loop condition:
						if not (l_c < a_col + a_width) then
							l_pos := -1 + 10 -- skip loop
						end
				when 5 then -- loop body:
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (mbyte_inst.dbcs_off2cells ((l_off___0 + l_c).to_natural_32, l_max_off.to_natural_32)) > 1 then
							screen_char_2 ((l_off___0 + l_c).to_natural_32, l_r, l_c)
							l_c := l_c + 1
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						screen_char ((l_off___0 + l_c).to_natural_32, l_r, l_c)
						if (mbyte_inst.utf_off2cells ((l_off___0 + l_c).to_natural_32, l_max_off.to_natural_32)) > 1 then
							l_c := l_c + 1
						end
				when 9 then
						l_c := l_c + 1
						l_pos := -1 + 4 -- back to loop condition
				when 10 then -- loop done
						l_r := l_r + 1
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						screen_char_attr := 0
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_fill (a_start_row: INTEGER_32; a_end_row: INTEGER_32; a_start_col: INTEGER_32; a_end_col: INTEGER_32; a_c1: INTEGER_32; a_c2: INTEGER_32; a_attr: INTEGER_32)
		local
			l_end_row: INTEGER_32
			l_end_col: INTEGER_32
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_off___0: INTEGER_32
			l_end_off: INTEGER_32
			l_did_delete: INTEGER_32
			l_c: INTEGER_32
			l_norm_term: INTEGER_32
			l_force_next: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_end_row := a_end_row
					l_end_col := a_end_col
					l_force_next := 0
					if l_end_row > globals_inst.screen_Rows then
						l_end_row := globals_inst.screen_Rows
					end
					if l_end_col > globals_inst.screen_Columns then
						l_end_col := globals_inst.screen_Columns
					end
					if globals_inst.ScreenLines.is_void then
						js.return
					elseif a_start_row >= l_end_row then
						js.return
					elseif a_start_col >= l_end_col then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 33 -- skip if block
					end
				when 1 then -- if:
						if not (gui_inst.gui.item.in_use).to_boolean then
							if globals_inst.t_colors <= 1 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_norm_term := l_tmp
						l_row := a_start_row
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_row < l_end_row)) then
							l_pos := -1 + 33 -- skip loop
						end
				when 3 then -- loop body:
						if globals_inst.has_mbyte.to_boolean then
							if not (gui_inst.gui.item.in_use).to_boolean then
								if a_start_col > 0 then
									if (mbyte_inst.mb_fix_col (a_start_col, l_row)) /= a_start_col then
										screen_puts_len (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, l_row, a_start_col - 1, 0)
									end
								end
								if l_end_col < globals_inst.screen_Columns then
									if (mbyte_inst.mb_fix_col (l_end_col, l_row)) /= l_end_col then
										screen_puts_len (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, l_row, l_end_col, 0)
									end
								end
							end
						end
						l_did_delete := 0
						if a_c2 /= 32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						if l_end_col.to_integer_32 /= globals_inst.Columns.item then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if not ((can_clear (term_inst.term_strings[1])).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if:
						if a_attr /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (l_norm_term.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 10 then -- if:
						if not (a_attr <= 63) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if ((a_attr).bit_and (-7)) /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_col := a_start_col
						if a_c1 /= 32 then
							l_col := l_col + 1
						end
						l_off___0 := (globals_inst.LineOffset[l_row] + l_col.to_natural_32).to_integer_32
						l_end_off := (globals_inst.LineOffset[l_row] + l_end_col.to_natural_32).to_integer_32
						if globals_inst.enc_utf8.to_boolean then
							from
							until
								js.loop_done
							loop
								if l_off___0 < l_end_off then
									if (globals_inst.ScreenLines[l_off___0]).to_integer_32 = 32 then
										if (globals_inst.ScreenAttrs[l_off___0]).to_integer_32 = 0 then
											if globals_inst.ScreenLinesUC[l_off___0] /= {NATURAL_32} 0 then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_off___0 := l_off___0 + 1
								end
							end
						else
							from
							until
								js.loop_done
							loop
								if l_off___0 < l_end_off then
									if (globals_inst.ScreenLines[l_off___0]).to_integer_32 = 32 then
										if (globals_inst.ScreenAttrs[l_off___0]).to_integer_32 /= 0 then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_off___0 := l_off___0 + 1
								end
							end
						end
						if l_off___0 < l_end_off then
							l_col := (l_off___0.to_natural_32 - globals_inst.LineOffset[l_row]).to_integer_32
							screen_stop_highlight
							term_inst.term_windgoto (l_row, l_col)
							term_inst.out_str (term_inst.term_strings[1])
							screen_start
							l_col := l_end_col - l_col
							from
							until
								js.loop_done
							loop
								l_tmp___2 := l_col
								l_col := l_col - 1
								if not l_tmp___2.to_boolean then
									js.break
								end
								if not js.loop_jumped then
									globals_inst.ScreenLines[l_off___0] := ((' ').code).to_natural_8
									if globals_inst.enc_utf8.to_boolean then
										globals_inst.ScreenLinesUC[l_off___0] := (0).to_natural_32
									end
									globals_inst.ScreenAttrs[l_off___0] := (0).to_natural_16
									l_off___0 := l_off___0 + 1
								end
							end
						end
						l_did_delete := 1
				when 13 then -- if done | if done | if done | if done | if done | if done
						l_off___0 := (globals_inst.LineOffset[l_row] + a_start_col.to_natural_32).to_integer_32
						l_c := a_c1
						l_col := a_start_col
				when 14 then -- loop condition:
						if not (not js.loop_done and then (l_col < l_end_col)) then
							l_pos := -1 + 32 -- skip loop
						end
				when 15 then -- loop body:
						if (globals_inst.ScreenLines[l_off___0]).to_integer_32 = l_c then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 18 then -- else:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if l_c >= 128 then
							l_tmp___4 := l_c
						else
							l_tmp___4 := 0
						end
						if (globals_inst.ScreenLinesUC[l_off___0]).to_integer_32 /= l_tmp___4 then
							l_pos := -1 + 25 -- goto _L___1
						else
							l_pos := -1 + 21 -- goto _L___2
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 21 then -- else: | _L___2:
						if (globals_inst.ScreenAttrs[l_off___0]).to_integer_32 = a_attr then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 24 then -- else:
						if not (l_force_next.to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 25 then -- if: | _L___1:
						if not ((gui_inst.gui.item.in_use).to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L___0
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if not (globals_inst.term_is_xterm.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L___0:
						if (globals_inst.ScreenLines[l_off___0]).to_integer_32 /= 32 then
							if (globals_inst.ScreenAttrs[l_off___0]).to_integer_32 > 63 then
								l_force_next := 1
							elseif (((globals_inst.ScreenAttrs[l_off___0]).to_integer_32).bit_and (2)).to_boolean then
								l_force_next := 1
							else
								l_force_next := 0
							end
						else
							l_force_next := 0
						end
				when 30 then -- if done
						globals_inst.ScreenLines[l_off___0] := l_c.to_natural_8
						if globals_inst.enc_utf8.to_boolean then
							if l_c >= 128 then
								globals_inst.ScreenLinesUC[l_off___0] := l_c.to_natural_32;
								(globals_inst.ScreenLinesC[0])[l_off___0] := (0).to_natural_32
							else
								globals_inst.ScreenLinesUC[l_off___0] := (0).to_natural_32
							end
						end
						globals_inst.ScreenAttrs[l_off___0] := a_attr.to_natural_16
						if not l_did_delete.to_boolean then
							screen_char (l_off___0.to_natural_32, l_row, l_col)
						elseif l_c /= 32 then
							screen_char (l_off___0.to_natural_32, l_row, l_col)
						end
				when 31 then -- if done | if done | if done
						l_off___0 := l_off___0 + 1
						if l_col = a_start_col then
							if l_did_delete.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_c := a_c2
							end
						end
						if not js.loop_jumped then
							l_col := l_col + 1
						end
						l_pos := -1 + 14 -- back to loop condition
				when 32 then -- loop done
						if l_end_col.to_integer_32 = globals_inst.Columns.item then
							globals_inst.LineWraps[l_row] := (0).to_natural_8
						end
						if l_row.to_integer_32 = globals_inst.Rows.item - 1 then
							globals_inst.redraw_cmdline := 1
							if a_c1 = 32 then
								if a_c2 = 32 then
									globals_inst.clear_cmdline := 0
								end
							end
							if a_start_col = 0 then
								globals_inst.mode_displayed := 0
							end
						end
						l_row := l_row + 1
						l_pos := -1 + 2 -- back to loop condition
				when 33 then -- loop done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	screen_getbytes (a_row: INTEGER_32; a_col: INTEGER_32; a_bytes___0: CE_POINTER [NATURAL_8]; a_attrp: CE_POINTER [INTEGER_32])
		local
			l_off___0: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.ScreenLines.is_void then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if not (a_row < globals_inst.screen_Rows) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if not (a_col < globals_inst.screen_Columns) then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						l_off___0 := globals_inst.LineOffset[a_row] + a_col.to_natural_32
						a_attrp.item := (globals_inst.ScreenAttrs[l_off___0.to_integer_32]).to_integer_32
						a_bytes___0[0] := globals_inst.ScreenLines[l_off___0.to_integer_32]
						a_bytes___0[1] := (('%/0/').code).to_natural_8
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if globals_inst.ScreenLinesUC[l_off___0.to_integer_32] /= {NATURAL_32} 0 then
							a_bytes___0[(mbyte_inst.utfc_char2bytes (l_off___0.to_integer_32, a_bytes___0))] := (('%/0/').code).to_natural_8
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___0:
						if globals_inst.enc_dbcs /= 9_932 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (globals_inst.ScreenLines[l_off___0.to_integer_32]).to_integer_32 = 142 then
							a_bytes___0[0] := globals_inst.ScreenLines[l_off___0.to_integer_32]
							a_bytes___0[1] := globals_inst.ScreenLines2[l_off___0.to_integer_32]
							a_bytes___0[2] := (('%/0/').code).to_natural_8
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if globals_inst.enc_dbcs.to_boolean then
							if (globals_inst.mb_bytelen_tab[(a_bytes___0[0]).to_integer_32]).to_integer_32 > 1 then
								a_bytes___0[1] := globals_inst.ScreenLines[(l_off___0 + {NATURAL_32} 1).to_integer_32]
								a_bytes___0[2] := (('%/0/').code).to_natural_8
							end
						end
				when 10 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	screen_ins_lines (a_off___0: INTEGER_32; a_row: INTEGER_32; a_line_count: INTEGER_32; a_end: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_row: INTEGER_32
			l_end: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_temp: NATURAL_32
			l_cursor_row: INTEGER_32
			l_type: INTEGER_32
			l_result_empty: INTEGER_32
			l_can_ce: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_row := a_row
					l_end := a_end
					l_can_ce := (can_clear (term_inst.term_strings[1]))
					if (screen_valid (1)).to_boolean then
						if a_line_count <= 0 then
							Result := 0
							js.return
						elseif a_line_count.to_integer_32 > option_inst.p_ttyscroll.item then
							Result := 0
							js.return
						end
					else
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						l_result_empty := (l_row + a_line_count >= l_end).to_integer
						if a_wp___0.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_wp___0.item.w_width).to_integer_32 /= globals_inst.Columns.item then
							if ((term_inst.term_strings[55]).item).to_integer_32 = 0 then
								l_type := 9
							else
								l_pos := -1 + 4 -- goto _L___6
							end
						else
							l_pos := -1 + 4 -- goto _L___6
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 4 then -- else: | _L___6:
						if not ((can_clear (term_inst.term_strings[8])).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_result_empty.to_boolean then
							l_type := 8
						else
							l_pos := -1 + 7 -- goto _L___4
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 7 then -- else: | _L___4:
						if ((term_inst.term_strings[3]).item).to_integer_32 = 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if a_line_count > 1 then
							l_type := 1
						elseif ((term_inst.term_strings[2]).item).to_integer_32 = 0 then
							l_type := 1
						else
							l_pos := -1 + 10 -- goto _L___3
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 10 then -- else: | _L___3:
						if ((term_inst.term_strings[5]).item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_result_empty.to_boolean then
							if a_line_count > 1 then
								l_type := 2
							elseif not l_can_ce.to_boolean then
								l_type := 2
							else
								l_pos := -1 + 13 -- goto _L___2
							end
						else
							l_pos := -1 + 13 -- goto _L___2
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 13 then -- else: | _L___2:
						if ((term_inst.term_strings[2]).item).to_integer_32 = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_type := 3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 16 then -- else:
						if not (l_can_ce.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_result_empty.to_boolean then
							l_type := 4
						else
							l_pos := -1 + 19 -- goto _L___0
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else: | _L___0:
						if ((term_inst.term_strings[4]).item).to_integer_32 = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if l_result_empty.to_boolean then
							l_type := 5
						else
							l_pos := -1 + 22 -- goto _L
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L:
						if ((term_inst.term_strings[28]).item).to_integer_32 /= 0 then
							if l_row = 0 then
								if ((term_inst.term_strings[10]).item).to_integer_32 = 0 then
									l_type := 6
								elseif l_can_ce.to_boolean then
									l_type := 6
								else
									Result := 0
									js.return
								end
							else
								Result := 0
								js.return
							end
						else
							Result := 0
							js.return
						end
				when 23 then -- if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							if l_type = 8 then
								l_tmp___2 := screen_del_lines (a_off___0, l_row, a_line_count, l_end, 0, a_wp___0)
								Result := l_tmp___2
								js.return
							elseif l_type = 2 then
								l_tmp___2 := screen_del_lines (a_off___0, l_row, a_line_count, l_end, 0, a_wp___0)
								Result := l_tmp___2
								js.return
							elseif l_type = 4 then
								l_tmp___2 := screen_del_lines (a_off___0, l_row, a_line_count, l_end, 0, a_wp___0)
								Result := l_tmp___2
								js.return
							elseif l_type = 5 then
								l_tmp___2 := screen_del_lines (a_off___0, l_row, a_line_count, l_end, 0, a_wp___0)
								Result := l_tmp___2
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
							if ((term_inst.term_strings[11]).item).to_boolean then
								screen_del_lines (a_off___0, l_end - a_line_count, a_line_count, l_end, 0, a_wp___0).do_nothing
							end
							if a_off___0 + l_row > 0 then
								ui_inst.clip_clear_selection
							elseif not a_wp___0.is_void then
								if (a_wp___0.item.w_width).to_integer_32 /= globals_inst.Columns.item then
									ui_inst.clip_clear_selection
								else
									ui_inst.clip_scroll_selection (-a_line_count)
								end
							else
								ui_inst.clip_scroll_selection (-a_line_count)
							end
							gui_inst.gui_dont_update_cursor
							if ((term_inst.term_strings[36]).item).to_integer_32 /= 0 then
								l_cursor_row := l_row
							else
								l_cursor_row := l_row + a_off___0
							end
							l_row := l_row + a_off___0
							l_end := l_end + a_off___0
							l_i___0 := 0
				when 25 then -- loop condition:
							if not (not js.loop_done and then (l_i___0 < a_line_count)) then
								l_pos := -1 + 31 -- skip loop
							end
				when 26 then -- loop body:
							if a_wp___0.is_void then
								l_pos := -1 + 29 -- skip if block
							end
				when 27 then -- if:
							if (a_wp___0.item.w_width).to_integer_32 /= globals_inst.Columns.item then
								l_j := (l_end - 1) - l_i___0
								from
								until
									js.loop_done
								loop
									l_j := l_j - a_line_count
									if not (l_j >= l_row) then
										js.break
									end
									if not js.loop_jumped then
										linecopy (l_j + a_line_count, l_j, a_wp___0)
									end
								end
								l_j := l_j + a_line_count
								if (can_clear (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))).to_boolean then
									lineclear (globals_inst.LineOffset[l_j] + (a_wp___0.item.w_wincol).to_natural_32, a_wp___0.item.w_width)
								else
									lineinvalid (globals_inst.LineOffset[l_j] + (a_wp___0.item.w_wincol).to_natural_32, a_wp___0.item.w_width)
								end
								globals_inst.LineWraps[l_j] := (0).to_natural_8
							else
								l_pos := -1 + 29 -- goto _L___7
							end
				when 28 then -- if block done, skip else block:
							l_pos := -1 + 30
				when 29 then -- else: | _L___7:
							l_j := (l_end - 1) - l_i___0
							l_temp := globals_inst.LineOffset[l_j]
							from
							until
								js.loop_done
							loop
								l_j := l_j - a_line_count
								if not (l_j >= l_row) then
									js.break
								end
								if not js.loop_jumped then
									globals_inst.LineOffset[(l_j + a_line_count)] := globals_inst.LineOffset[l_j]
									globals_inst.LineWraps[(l_j + a_line_count)] := globals_inst.LineWraps[l_j]
								end
							end
							globals_inst.LineOffset[(l_j + a_line_count)] := l_temp
							globals_inst.LineWraps[(l_j + a_line_count)] := (0).to_natural_8
							if (can_clear (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))).to_boolean then
								lineclear (l_temp, (globals_inst.Columns.item).to_integer_32)
							else
								lineinvalid (l_temp, (globals_inst.Columns.item).to_integer_32)
							end
				when 30 then
							l_i___0 := l_i___0 + 1
							l_pos := -1 + 25 -- back to loop condition
				when 31 then -- loop done
							screen_stop_highlight
							windgoto (l_cursor_row, 0)
							if l_type = 9 then
								redraw_block (l_row, l_end, a_wp___0)
							elseif l_type = 1 then
								term_inst.term_append_lines (a_line_count)
								screen_start
							else
								l_i___0 := 0
								from
								until
									not (l_i___0 < a_line_count)
								loop
									if l_type = 3 then
										if l_i___0.to_boolean then
											if l_cursor_row /= 0 then
												windgoto (l_cursor_row, 0)
											end
										end
										term_inst.out_str (term_inst.term_strings[2])
									else
										term_inst.out_str (term_inst.term_strings[28])
									end
									screen_start
									l_i___0 := l_i___0 + 1
								end
							end
							if l_type = 6 then
								if ((term_inst.term_strings[10]).item).to_boolean then
									l_i___0 := 0
									from
									until
										not (l_i___0 < a_line_count)
									loop
										windgoto (a_off___0 + l_i___0, 0)
										term_inst.out_str (term_inst.term_strings[1])
										screen_start
										l_i___0 := l_i___0 + 1
									end
								end
							end
							gui_inst.gui_can_update_cursor
							if (gui_inst.gui.item.in_use).to_boolean then
								term_inst.out_flush
							end
							Result := 1
				when 32 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	screen_line (a_row: INTEGER_32; a_coloff: INTEGER_32; a_endcol: INTEGER_32; a_clear_width: INTEGER_32)
		local
			l_off_from: NATURAL_32
			l_off_to: NATURAL_32
			l_max_off_from: NATURAL_32
			l_max_off_to: NATURAL_32
			l_col: INTEGER_32
			l_hl: CE_ARRAY [INTEGER_32]
			l_force: INTEGER_32
			l_redraw_this: INTEGER_32
			l_redraw_next: INTEGER_32
			l_clear_next: INTEGER_32
			l_char_cells: INTEGER_32
			l_tmp___0: INTEGER_32
			l_i___0: INTEGER_32
			l_startCol: INTEGER_32
			l_prev_cells: INTEGER_32
			l_off___0: NATURAL_32
			l_max_off: NATURAL_32
			l_c: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := 0
					l_force := 0
					l_redraw_this := 1
					l_clear_next := 0
					ui_inst.clip_may_clear_selection (a_row, a_row)
					l_off_from := (current_ScreenLine.distance (globals_inst.ScreenLines)).to_natural_32
					l_off_to := globals_inst.LineOffset[a_row] + a_coloff.to_natural_32
					l_max_off_from := l_off_from + globals_inst.screen_Columns.to_natural_32
					l_max_off_to := globals_inst.LineOffset[a_row] + globals_inst.screen_Columns.to_natural_32
					l_redraw_next := char_needs_redraw (l_off_from.to_integer_32, l_off_to.to_integer_32, a_endcol - l_col)
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_col < a_endcol)) then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						if globals_inst.has_mbyte.to_boolean then
							if l_col + 1 < a_endcol then
								l_char_cells := globals_inst.mb_off2cells.integer_32_item ([l_off_from, l_max_off_from])
							else
								l_char_cells := 1
							end
						else
							l_char_cells := 1
						end
						l_redraw_this := l_redraw_next
						if l_force.to_boolean then
							l_tmp___0 := 1
						elseif (char_needs_redraw ((l_off_from + l_char_cells.to_natural_32).to_integer_32, (l_off_to + l_char_cells.to_natural_32).to_integer_32, (a_endcol - l_col) - l_char_cells)).to_boolean then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
						l_redraw_next := l_tmp___0
						if l_redraw_next.to_boolean then
							if (gui_inst.gui.item.in_use).to_boolean then
								l_hl.item := (globals_inst.ScreenAttrs[(l_off_to + l_char_cells.to_natural_32).to_integer_32]).to_integer_32
								if l_hl.item > 63 then
									l_hl.item := syntax_inst.syn_attr2attr (l_hl.item)
								end
								if ((l_hl.item).bit_and (2)).to_boolean then
									l_redraw_this := 1
								end
							end
						end
						if not (l_redraw_this.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 3 then -- if:
						if (option_inst.p_wiv.item).to_boolean then
							if not l_force.to_boolean then
								if not (gui_inst.gui.item.in_use).to_boolean then
									if (globals_inst.ScreenAttrs[l_off_to.to_integer_32]).to_integer_32 /= 0 then
										if (globals_inst.ScreenAttrs[l_off_from.to_integer_32]).to_integer_32 /= (globals_inst.ScreenAttrs[l_off_to.to_integer_32]).to_integer_32 then
											windgoto (a_row, l_col + a_coloff)
											term_inst.out_str (term_inst.term_strings[1])
											screen_start
											l_force := 1
											l_redraw_next := 1
											if l_col + a_coloff > 0 then
												if (globals_inst.ScreenAttrs[(l_off_to - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 0 then
													screen_attr := (globals_inst.ScreenAttrs[(l_off_to - {NATURAL_32} 1).to_integer_32]).to_integer_32
													term_inst.term_windgoto (a_row, l_col + a_coloff)
													screen_stop_highlight
												else
													screen_attr := 0
												end
											else
												screen_attr := 0
											end
										end
									end
								end
							end
						end
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_char_cells /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_col + 1 < a_endcol then
							if (globals_inst.mb_off2cells.integer_32_item ([l_off_to, l_max_off_to])) > 1 then
								globals_inst.ScreenLines[(l_off_to + {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
								l_redraw_next := 1
							else
								l_pos := -1 + 7 -- goto _L___0
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L___0:
						if l_char_cells = 2 then
							if l_col + 2 < a_endcol then
								if (globals_inst.mb_off2cells.integer_32_item ([l_off_to, l_max_off_to])) = 1 then
									if (globals_inst.mb_off2cells.integer_32_item ([l_off_to + {NATURAL_32} 1, l_max_off_to])) > 1 then
										globals_inst.ScreenLines[(l_off_to + {NATURAL_32} 2).to_integer_32] := (0).to_natural_8
										l_redraw_next := 1
									end
								end
							end
						end
				when 8 then
						if globals_inst.enc_dbcs = 9_932 then
							globals_inst.ScreenLines2[l_off_to.to_integer_32] := globals_inst.ScreenLines2[l_off_from.to_integer_32]
						end
				when 9 then -- if done
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if l_col + l_char_cells /= a_endcol then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						if l_char_cells /= 1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (globals_inst.mb_off2cells.integer_32_item ([l_off_to, l_max_off_to])) > 1 then
							l_clear_next := 1
						else
							l_pos := -1 + 14 -- goto _L___1
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___1:
						if l_char_cells = 2 then
							if (globals_inst.mb_off2cells.integer_32_item ([l_off_to, l_max_off_to])) = 1 then
								if (globals_inst.mb_off2cells.integer_32_item ([l_off_to + {NATURAL_32} 1, l_max_off_to])) > 1 then
									l_clear_next := 1
								end
							end
						end
				when 15 then -- if done | if done
						globals_inst.ScreenLines[l_off_to.to_integer_32] := globals_inst.ScreenLines[l_off_from.to_integer_32]
						if globals_inst.enc_utf8.to_boolean then
							globals_inst.ScreenLinesUC[l_off_to.to_integer_32] := globals_inst.ScreenLinesUC[l_off_from.to_integer_32]
							if globals_inst.ScreenLinesUC[l_off_from.to_integer_32] /= {NATURAL_32} 0 then
								l_i___0 := 0
								from
								until
									not (l_i___0 < globals_inst.Screen_mco)
								loop
									(globals_inst.ScreenLinesC[l_i___0])[l_off_to.to_integer_32] := (globals_inst.ScreenLinesC[l_i___0])[l_off_from.to_integer_32]
									l_i___0 := l_i___0 + 1
								end
							end
						end
						if l_char_cells = 2 then
							globals_inst.ScreenLines[(l_off_to + {NATURAL_32} 1).to_integer_32] := globals_inst.ScreenLines[(l_off_from + {NATURAL_32} 1).to_integer_32]
						end
						if not ((gui_inst.gui.item.in_use).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___2
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if not (globals_inst.term_is_xterm.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___2:
						l_hl.item := (globals_inst.ScreenAttrs[l_off_to.to_integer_32]).to_integer_32
						if l_hl.item > 63 then
							l_hl.item := syntax_inst.syn_attr2attr (l_hl.item)
						end
						if ((l_hl.item).bit_and (2)).to_boolean then
							l_redraw_next := 1
						end
				when 20 then -- if done
						globals_inst.ScreenAttrs[l_off_to.to_integer_32] := globals_inst.ScreenAttrs[l_off_from.to_integer_32]
						if l_char_cells = 2 then
							globals_inst.ScreenAttrs[(l_off_to + {NATURAL_32} 1).to_integer_32] := globals_inst.ScreenAttrs[l_off_from.to_integer_32]
						end
						if globals_inst.enc_dbcs /= 0 then
							if l_char_cells = 2 then
								screen_char_2 (l_off_to, a_row, l_col + a_coloff)
							else
								screen_char (l_off_to, a_row, l_col + a_coloff)
							end
						else
							screen_char (l_off_to, a_row, l_col + a_coloff)
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						if (option_inst.p_wiv.item).to_boolean then
							if not (gui_inst.gui.item.in_use).to_boolean then
								if l_col + a_coloff > 0 then
									if (globals_inst.ScreenAttrs[l_off_to.to_integer_32]).to_integer_32 = (globals_inst.ScreenAttrs[(l_off_to - {NATURAL_32} 1).to_integer_32]).to_integer_32 then
										screen_attr := 0
									elseif screen_attr /= 0 then
										screen_stop_highlight
									end
								end
							end
						end
				when 23 then -- if done
						l_off_to := l_off_to + l_char_cells.to_natural_32
						l_off_from := l_off_from + l_char_cells.to_natural_32
						l_col := l_col + l_char_cells
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
					if l_clear_next.to_boolean then
						globals_inst.ScreenLines[l_off_to.to_integer_32] := ((' ').code).to_natural_8
						if globals_inst.enc_utf8.to_boolean then
							globals_inst.ScreenLinesUC[l_off_to.to_integer_32] := (0).to_natural_32
						end
						screen_char (l_off_to, a_row, l_col + a_coloff)
					end
					if not (a_clear_width > 0) then
						l_pos := -1 + 37 -- skip if block
					end
				when 25 then -- if:
						l_startCol := l_col
						from
						until
							js.loop_done
						loop
							if l_col < a_clear_width then
								if (globals_inst.ScreenLines[l_off_to.to_integer_32]).to_integer_32 = 32 then
									if (globals_inst.ScreenAttrs[l_off_to.to_integer_32]).to_integer_32 = 0 then
										if globals_inst.enc_utf8.to_boolean then
											if globals_inst.ScreenLinesUC[l_off_to.to_integer_32] /= {NATURAL_32} 0 then
												js.break
											end
										end
									else
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_off_to := l_off_to + 1
								l_col := l_col + 1
							end
						end
						if not (l_col < a_clear_width) then
							l_pos := -1 + 37 -- skip if block
						end
				when 26 then -- if:
						if not ((gui_inst.gui.item.in_use).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 27 then -- if:
						if not (l_col > l_startCol) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L___4
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 30 then -- else:
						if l_redraw_this.to_boolean then
							l_pos := -1 + 36 -- skip if block
						end
				when 31 then -- if: | _L___4:
						l_hl.item := (globals_inst.ScreenAttrs[l_off_to.to_integer_32]).to_integer_32
						if not (l_hl.item > 63) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 34 then -- else:
						if not (((l_hl.item).bit_and (2)).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 35 then -- if: | _L___3:
						l_prev_cells := 1
						if globals_inst.enc_utf8.to_boolean then
							if (globals_inst.ScreenLines[(l_off_to - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 0 then
								l_prev_cells := 2
							else
								l_prev_cells := 1
							end
						elseif globals_inst.enc_dbcs /= 0 then
							l_off___0 := globals_inst.LineOffset[a_row]
							l_max_off := globals_inst.LineOffset[a_row] + globals_inst.screen_Columns.to_natural_32
							from
							until
								not (l_off___0 < l_off_to)
							loop
								l_prev_cells := globals_inst.mb_off2cells.integer_32_item ([l_off___0, l_max_off])
								l_off___0 := l_off___0 + l_prev_cells.to_natural_32
							end
						end
						if globals_inst.enc_dbcs /= 0 then
							if l_prev_cells > 1 then
								screen_char_2 (l_off_to - l_prev_cells.to_natural_32, a_row, (l_col + a_coloff) - l_prev_cells)
							else
								screen_char (l_off_to - l_prev_cells.to_natural_32, a_row, (l_col + a_coloff) - l_prev_cells)
							end
						else
							screen_char (l_off_to - l_prev_cells.to_natural_32, a_row, (l_col + a_coloff) - l_prev_cells)
						end
				when 36 then -- if done | if done | if done | if done
						screen_fill (a_row, a_row + 1, l_col + a_coloff, a_clear_width + a_coloff, (' ').code, (' ').code, 0)
						l_off_to := l_off_to + (a_clear_width - l_col).to_natural_32
						l_col := a_clear_width
				when 37 then -- if done | if done
						if not (a_clear_width > 0) then
							l_pos := -1 + 49 -- skip if block
						end
				when 38 then -- if:
							if not ((l_col + a_coloff).to_integer_32 < globals_inst.Columns.item) then
								l_pos := -1 + 48 -- skip if block
							end
				when 39 then -- if:
							l_c := fillchar_vsep (l_hl)
							if (globals_inst.ScreenLines[l_off_to.to_integer_32]).to_integer_32 = l_c then
								l_pos := -1 + 42 -- skip if block
							end
				when 40 then -- if:
							l_pos := -1 + 46 -- goto _L___5
				when 41 then -- if block done, skip else block:
							l_pos := -1 + 47
				when 42 then -- else:
							if not (globals_inst.enc_utf8.to_boolean) then
								l_pos := -1 + 45 -- skip if block
							end
				when 43 then -- if:
							if l_c >= 128 then
								l_tmp___7 := l_c
							else
								l_tmp___7 := 0
							end
							if (globals_inst.ScreenLinesUC[l_off_to.to_integer_32]).to_integer_32 /= l_tmp___7 then
								l_pos := -1 + 46 -- goto _L___5
							else
								l_pos := -1 + 45 -- goto _L___6
							end
				when 44 then -- if block done, skip else block:
							l_pos := -1 + 47
				when 45 then -- else: | _L___6:
							if (globals_inst.ScreenAttrs[l_off_to.to_integer_32]).to_integer_32 = l_hl.item then
								l_pos := -1 + 47 -- skip if block
							end
				when 46 then -- if: | _L___5:
							globals_inst.ScreenLines[l_off_to.to_integer_32] := l_c.to_natural_8
							globals_inst.ScreenAttrs[l_off_to.to_integer_32] := (l_hl.item).to_natural_16
							if globals_inst.enc_utf8.to_boolean then
								if l_c >= 128 then
									globals_inst.ScreenLinesUC[l_off_to.to_integer_32] := l_c.to_natural_32;
									(globals_inst.ScreenLinesC[0])[l_off_to.to_integer_32] := (0).to_natural_32
								else
									globals_inst.ScreenLinesUC[l_off_to.to_integer_32] := (0).to_natural_32
								end
							end
							screen_char (l_off_to, a_row, l_col + a_coloff)
				when 47 then -- if done | if done | if done | if block done, skip else block:
							l_pos := -1 + 49
				when 48 then -- else:
							globals_inst.LineWraps[a_row] := (0).to_natural_8
				when 49 then -- if done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	screen_putchar (a_c: INTEGER_32; a_row: INTEGER_32; a_col: INTEGER_32; a_attr: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create l_buf___6.make (<<22>>)

			l_buf___6[(globals_inst.mb_char2bytes.integer_32_item ([a_c, l_buf___6]))] := (('%/0/').code).to_natural_8
			screen_puts (l_buf___6, a_row, a_col, a_attr)
		end

	screen_puts (a_text: CE_POINTER [NATURAL_8]; a_row: INTEGER_32; a_col: INTEGER_32; a_attr: INTEGER_32)
		do
			screen_puts_len (a_text, -1, a_row, a_col, a_attr)
		end

	screen_puts_len (a_text: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_row: INTEGER_32; a_col: INTEGER_32; a_attr: INTEGER_32)
		local
			l_col: INTEGER_32
			l_off___0: NATURAL_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_max_off: NATURAL_32
			l_mbyte_blen: INTEGER_32
			l_mbyte_cells: INTEGER_32
			l_u8c: INTEGER_32
			l_u8cc: CE_ARRAY [INTEGER_32]
			l_clear_next_cell: INTEGER_32
			l_force_redraw_this: INTEGER_32
			l_force_redraw_next: INTEGER_32
			l_need_redraw: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_n: INTEGER_32
			l_tmp___4: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_u8cc.make (<<6>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
					l_ptr := a_text
					l_mbyte_blen := 1
					l_mbyte_cells := 1
					l_u8c := 0
					l_clear_next_cell := 0
					l_force_redraw_next := 0
					if globals_inst.ScreenLines.is_void then
						js.return
					elseif a_row >= globals_inst.screen_Rows then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 68 -- skip if block
					end
				when 1 then -- if:
						l_off___0 := globals_inst.LineOffset[a_row] + l_col.to_natural_32
						if globals_inst.has_mbyte.to_boolean then
							if l_col > 0 then
								if l_col < globals_inst.screen_Columns then
									if not (gui_inst.gui.item.in_use).to_boolean then
										if (mbyte_inst.mb_fix_col (l_col, a_row)) /= l_col then
											globals_inst.ScreenLines[(l_off___0 - {NATURAL_32} 1).to_integer_32] := ((' ').code).to_natural_8
											globals_inst.ScreenAttrs[(l_off___0 - {NATURAL_32} 1).to_integer_32] := (0).to_natural_16
											if globals_inst.enc_utf8.to_boolean then
												globals_inst.ScreenLinesUC[(l_off___0 - {NATURAL_32} 1).to_integer_32] := (0).to_natural_32;
												(globals_inst.ScreenLinesC[0])[(l_off___0 - {NATURAL_32} 1).to_integer_32] := (0).to_natural_32
											end
											screen_char (l_off___0 - {NATURAL_32} 1, a_row, l_col - 1)
											l_force_redraw_next := 1
										end
									end
								end
							end
						end
						l_max_off := globals_inst.LineOffset[a_row] + globals_inst.screen_Columns.to_natural_32
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 67 -- skip loop
						end
				when 3 then -- loop body:
						if not (l_col < globals_inst.screen_Columns) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not (a_len < 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___9
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if not (l_ptr.distance (a_text) < a_len) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___9:
						if (l_ptr.item).to_integer_32 = 0 then
							js.break
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						js.break
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						js.break
				when 13 then
						if js.loop_jumped then
							l_pos := -1 + 66 -- skip if block
						end
				when 14 then -- if:
						l_c := (l_ptr.item).to_integer_32
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						if globals_inst.enc_utf8.to_boolean then
							if a_len > 0 then
								l_mbyte_blen := mbyte_inst.utfc_ptr2len_len (l_ptr, (a_text + a_len).distance (l_ptr))
							else
								l_mbyte_blen := globals_inst.mb_ptr2len.integer_32_item ([l_ptr])
							end
						else
							l_mbyte_blen := globals_inst.mb_ptr2len.integer_32_item ([l_ptr])
						end
						if globals_inst.enc_dbcs /= 9_932 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_c = 142 then
							l_mbyte_cells := 1
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if globals_inst.enc_dbcs /= 0 then
							l_mbyte_cells := l_mbyte_blen
						else
							if a_len >= 0 then
								l_u8c := mbyte_inst.utfc_ptr2char_len (l_ptr, l_u8cc, (a_text + a_len).distance (l_ptr))
							else
								l_u8c := mbyte_inst.utfc_ptr2char (l_ptr, l_u8cc)
							end
							l_mbyte_cells := mbyte_inst.utf_char2cells (l_u8c)
							if l_col + l_mbyte_cells > globals_inst.screen_Columns then
								l_c := ('>').code
								l_mbyte_cells := 1
							end
						end
				when 19 then -- if done
						l_force_redraw_this := l_force_redraw_next
						l_force_redraw_next := 0
						if (globals_inst.ScreenLines[l_off___0.to_integer_32]).to_integer_32 = l_c then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_tmp___3 := 1
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 22 then -- else:
						if l_mbyte_cells /= 2 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if globals_inst.enc_dbcs.to_boolean then
							l_tmp___0 := (l_ptr[1]).to_integer_32
						else
							l_tmp___0 := 0
						end
						if (globals_inst.ScreenLines[(l_off___0 + {NATURAL_32} 1).to_integer_32]).to_integer_32 /= l_tmp___0 then
							l_tmp___3 := 1
						else
							l_pos := -1 + 25 -- goto _L___3
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 25 then -- else: | _L___3:
						if globals_inst.enc_dbcs /= 9_932 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_c = 142 then
							if (globals_inst.ScreenLines2[l_off___0.to_integer_32]).to_integer_32 /= (l_ptr[1]).to_integer_32 then
								l_tmp___3 := 1
							else
								l_pos := -1 + 28 -- goto _L___2
							end
						else
							l_pos := -1 + 28 -- goto _L___2
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 28 then -- else: | _L___2:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if l_c < 128 then
							if l_u8cc[0] = 0 then
								l_tmp___1 := 0
							else
								l_tmp___1 := l_u8c
							end
						else
							l_tmp___1 := l_u8c
						end
						if globals_inst.ScreenLinesUC[l_off___0.to_integer_32] /= l_tmp___1.to_natural_32 then
							l_tmp___3 := 1
						elseif globals_inst.ScreenLinesUC[l_off___0.to_integer_32] /= {NATURAL_32} 0 then
							if (screen_comp_differs (l_off___0.to_integer_32, l_u8cc)).to_boolean then
								l_tmp___3 := 1
							else
								l_pos := -1 + 31 -- goto _L___0
							end
						else
							l_pos := -1 + 31 -- goto _L___0
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___0:
						if (globals_inst.ScreenAttrs[l_off___0.to_integer_32]).to_integer_32 /= a_attr then
							l_tmp___3 := 1
						elseif globals_inst.exmode_active.to_boolean then
							l_tmp___3 := 1
						else
							l_tmp___3 := 0
						end
				when 32 then -- if done | if done | if done
						l_need_redraw := l_tmp___3
						if not (l_need_redraw.to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___8
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 35 then -- else:
						if not (l_force_redraw_this.to_boolean) then
							l_pos := -1 + 65 -- skip if block
						end
				when 36 then -- if: | _L___8:
						if not (l_need_redraw.to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 37 then -- if:
						if (globals_inst.ScreenLines[l_off___0.to_integer_32]).to_integer_32 = 32 then
							l_pos := -1 + 43 -- skip if block
						end
				when 38 then -- if:
						if not ((gui_inst.gui.item.in_use).to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_pos := -1 + 42 -- goto _L___4
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 41 then -- else:
						if not (globals_inst.term_is_xterm.to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 42 then -- if: | _L___4:
						l_n := (globals_inst.ScreenAttrs[l_off___0.to_integer_32]).to_integer_32
						if l_n > 63 then
							l_n := syntax_inst.syn_attr2attr (l_n)
						end
						if ((l_n).bit_and (2)).to_boolean then
							l_force_redraw_next := 1
						end
				when 43 then -- if done | if done | if done
						if not (l_clear_next_cell.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_clear_next_cell := 0
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 46 then -- else:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 52 -- skip if block
						end
				when 47 then -- if:
						if a_len < 0 then
							l_tmp___4 := ((l_ptr[l_mbyte_blen]).to_integer_32 = 0).to_integer
						else
							l_tmp___4 := (((l_ptr + l_mbyte_blen).c_pointer.to_integer_32).to_natural_32 >= ((a_text + a_len).c_pointer.to_integer_32).to_natural_32).to_integer
						end
						if not (l_tmp___4.to_boolean) then
							l_pos := -1 + 52 -- skip if block
						end
				when 48 then -- if:
						if l_mbyte_cells /= 1 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if (globals_inst.mb_off2cells.integer_32_item ([l_off___0, l_max_off])) > 1 then
							l_clear_next_cell := 1
						else
							l_pos := -1 + 51 -- goto _L___5
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 51 then -- else: | _L___5:
						if l_mbyte_cells = 2 then
							if (globals_inst.mb_off2cells.integer_32_item ([l_off___0, l_max_off])) = 1 then
								if (globals_inst.mb_off2cells.integer_32_item ([l_off___0 + {NATURAL_32} 1, l_max_off])) > 1 then
									l_clear_next_cell := 1
								end
							end
						end
				when 52 then -- if done | if done | if done
						if not (globals_inst.enc_dbcs.to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 53 then -- if:
						if l_mbyte_cells /= 1 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						if (globals_inst.mb_off2cells.integer_32_item ([l_off___0, l_max_off])) > 1 then
							globals_inst.ScreenLines[(l_off___0 + l_mbyte_blen.to_natural_32).to_integer_32] := (0).to_natural_8
						else
							l_pos := -1 + 56 -- goto _L___6
						end
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 56 then -- else: | _L___6:
						if l_mbyte_cells = 2 then
							if (globals_inst.mb_off2cells.integer_32_item ([l_off___0, l_max_off])) = 1 then
								if (globals_inst.mb_off2cells.integer_32_item ([l_off___0 + {NATURAL_32} 1, l_max_off])) > 1 then
									globals_inst.ScreenLines[(l_off___0 + l_mbyte_blen.to_natural_32).to_integer_32] := (0).to_natural_8
								end
							end
						end
				when 57 then -- if done
						globals_inst.ScreenLines[l_off___0.to_integer_32] := l_c.to_natural_8
						globals_inst.ScreenAttrs[l_off___0.to_integer_32] := a_attr.to_natural_16
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 64 -- skip if block
						end
				when 58 then -- if:
						if not (l_c < 128) then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						if l_u8cc[0] = 0 then
							globals_inst.ScreenLinesUC[l_off___0.to_integer_32] := (0).to_natural_32
						else
							l_pos := -1 + 61 -- goto _L___7
						end
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 61 then -- else: | _L___7:
						globals_inst.ScreenLinesUC[l_off___0.to_integer_32] := l_u8c.to_natural_32
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0 < globals_inst.Screen_mco))
						loop
							(globals_inst.ScreenLinesC[l_i___0])[l_off___0.to_integer_32] := (l_u8cc[l_i___0]).to_natural_32
							if l_u8cc[l_i___0] = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
				when 62 then
						if l_mbyte_cells = 2 then
							globals_inst.ScreenLines[(l_off___0 + {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
							globals_inst.ScreenAttrs[(l_off___0 + {NATURAL_32} 1).to_integer_32] := a_attr.to_natural_16
						end
						screen_char (l_off___0, a_row, l_col)
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 64 then -- else:
						if l_mbyte_cells = 2 then
							globals_inst.ScreenLines[(l_off___0 + {NATURAL_32} 1).to_integer_32] := l_ptr[1]
							globals_inst.ScreenAttrs[(l_off___0 + {NATURAL_32} 1).to_integer_32] := a_attr.to_natural_16
							screen_char_2 (l_off___0, a_row, l_col)
						elseif globals_inst.enc_dbcs = 9_932 then
							if l_c = 142 then
								globals_inst.ScreenLines2[l_off___0.to_integer_32] := l_ptr[1]
								screen_char (l_off___0, a_row, l_col)
							else
								screen_char (l_off___0, a_row, l_col)
							end
						else
							screen_char (l_off___0, a_row, l_col)
						end
				when 65 then -- if done | if done
						if globals_inst.has_mbyte.to_boolean then
							l_off___0 := l_off___0 + l_mbyte_cells.to_natural_32
							l_col := l_col + l_mbyte_cells
							l_ptr := l_ptr + l_mbyte_blen
							if l_clear_next_cell.to_boolean then
								l_ptr := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" "))
							end
						else
							l_off___0 := l_off___0 + 1
							l_col := l_col + 1
							l_ptr := l_ptr + 1
						end
				when 66 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 67 then -- loop done
						if l_force_redraw_next.to_boolean then
							if l_col < globals_inst.screen_Columns then
								if globals_inst.enc_dbcs /= 0 then
									if (mbyte_inst.dbcs_off2cells (l_off___0, l_max_off)) > 1 then
										screen_char_2 (l_off___0, a_row, l_col)
									else
										screen_char (l_off___0, a_row, l_col)
									end
								else
									screen_char (l_off___0, a_row, l_col)
								end
							end
						end
				when 68 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_start
		do
			screen_cur_col := 9_999
			screen_cur_row := screen_cur_col
		end

	screen_start_highlight (a_attr: INTEGER_32)
		local
			l_attr: INTEGER_32
			l_aep: CE_POINTER [PD_ATTR_ENTRY]
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_aep.make
			create l_buf___6.make (<<20>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_attr := a_attr
					l_aep := create {CE_POINTER [PD_ATTR_ENTRY]}.make_shared (default_pointer)
					screen_attr := l_attr
					if not (globals_inst.full_screen.to_boolean) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not ((gui_inst.gui.item.in_use).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						sprintf ([l_buf___6, ce_string ("%/27/|%%dh"), l_attr]).do_nothing
						term_inst.out_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_buf___6))
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if l_attr > 63 then
							if globals_inst.t_colors > 1 then
								l_aep := syntax_inst.syn_cterm_attr2entry (l_attr)
							else
								l_aep := syntax_inst.syn_term_attr2entry (l_attr)
							end
							if l_aep.is_void then
								l_attr := 0
							else
								l_attr := (l_aep.item.ae_attr).to_integer_32
							end
						end
						if not (((l_attr).bit_and (2)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (term_inst.term_strings[17]).is_void then
							term_inst.out_str (term_inst.term_strings[17])
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if not l_aep.is_void then
							if globals_inst.t_colors > 1 then
								if (l_aep.item.ae_u.cterm.fg_color).to_boolean then
									if globals_inst.cterm_normal_fg_bold.to_boolean then
										term_inst.out_str (term_inst.term_strings[15])
									end
								end
							end
						end
				when 8 then
						if ((l_attr).bit_and (32)).to_boolean then
							if not (term_inst.term_strings[19]).is_void then
								term_inst.out_str (term_inst.term_strings[19])
							end
						end
						if ((l_attr).bit_and (24)).to_boolean then
							if not (term_inst.term_strings[23]).is_void then
								term_inst.out_str (term_inst.term_strings[23])
							end
						end
						if ((l_attr).bit_and (4)).to_boolean then
							if not (term_inst.term_strings[20]).is_void then
								term_inst.out_str (term_inst.term_strings[20])
							end
						end
						if ((l_attr).bit_and (1)).to_boolean then
							if not (term_inst.term_strings[16]).is_void then
								term_inst.out_str (term_inst.term_strings[16])
							end
						end
						if not l_aep.is_void then
							if globals_inst.t_colors > 1 then
								if (l_aep.item.ae_u.cterm.fg_color).to_boolean then
									term_inst.term_fg_color ((l_aep.item.ae_u.cterm.fg_color).to_integer_32 - 1)
								end
								if (l_aep.item.ae_u.cterm.bg_color).to_boolean then
									term_inst.term_bg_color ((l_aep.item.ae_u.cterm.bg_color).to_integer_32 - 1)
								end
							elseif not (l_aep.item.ae_u.term.start).is_void then
								term_inst.out_str (l_aep.item.ae_u.term.start)
							end
						end
				when 9 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	screen_stop_highlight
		local
			l_do_ME: INTEGER_32
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_aep: CE_POINTER [PD_ATTR_ENTRY]
		do
			create l_buf___6.make (<<20>>)
			create l_aep.make

			l_do_ME := 0
			if screen_attr /= 0 then
				if (gui_inst.gui.item.in_use).to_boolean then
					sprintf ([l_buf___6, ce_string ("%/27/|%%dH"), screen_attr]).do_nothing
					term_inst.out_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_buf___6))
				else
					if screen_attr > 63 then
						if globals_inst.t_colors > 1 then
							l_aep := syntax_inst.syn_cterm_attr2entry (screen_attr)
							if not l_aep.is_void then
								if (l_aep.item.ae_u.cterm.fg_color).to_boolean then
									l_do_ME := 1
								elseif (l_aep.item.ae_u.cterm.bg_color).to_boolean then
									l_do_ME := 1
								end
							end
						else
							l_aep := syntax_inst.syn_term_attr2entry (screen_attr)
							if not l_aep.is_void then
								if not (l_aep.item.ae_u.term.stop).is_void then
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_aep.item.ae_u.term.stop), create {CE_POINTER [INTEGER_8]}.make_cast (term_inst.term_strings[15]))) = 0 then
										l_do_ME := 1
									else
										term_inst.out_str (l_aep.item.ae_u.term.stop)
									end
								end
							end
						end
						if l_aep.is_void then
							screen_attr := 0
						else
							screen_attr := (l_aep.item.ae_attr).to_integer_32
						end
					end
					if ((screen_attr).bit_and (32)).to_boolean then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (term_inst.term_strings[18]), create {CE_POINTER [INTEGER_8]}.make_cast (term_inst.term_strings[15]))) = 0 then
							l_do_ME := 1
						else
							term_inst.out_str (term_inst.term_strings[18])
						end
					end
					if ((screen_attr).bit_and (24)).to_boolean then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (term_inst.term_strings[22]), create {CE_POINTER [INTEGER_8]}.make_cast (term_inst.term_strings[15]))) = 0 then
							l_do_ME := 1
						else
							term_inst.out_str (term_inst.term_strings[22])
						end
					end
					if ((screen_attr).bit_and (4)).to_boolean then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (term_inst.term_strings[21]), create {CE_POINTER [INTEGER_8]}.make_cast (term_inst.term_strings[15]))) = 0 then
							l_do_ME := 1
						else
							term_inst.out_str (term_inst.term_strings[21])
						end
					end
					if l_do_ME.to_boolean then
						term_inst.out_str (term_inst.term_strings[15])
					elseif ((screen_attr).bit_and (3)).to_boolean then
						term_inst.out_str (term_inst.term_strings[15])
					end
					if globals_inst.t_colors > 1 then
						if globals_inst.cterm_normal_fg_color /= 0 then
							term_inst.term_fg_color (globals_inst.cterm_normal_fg_color - 1)
						end
						if globals_inst.cterm_normal_bg_color /= 0 then
							term_inst.term_bg_color (globals_inst.cterm_normal_bg_color - 1)
						end
						if globals_inst.cterm_normal_fg_bold.to_boolean then
							term_inst.out_str (term_inst.term_strings[17])
						end
					end
				end
			end
			screen_attr := 0
		end

	screen_valid (a_clear: INTEGER_32): INTEGER_32
		do
			screenalloc (a_clear)
			Result := (not globals_inst.ScreenLines.is_void).to_integer
		end

	screenalloc (a_clear: INTEGER_32)
		local
			l_new_row: INTEGER_32
			l_old_row: INTEGER_32
			l_old_Rows___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_outofmem: INTEGER_32
			l_len: INTEGER_32
			l_new_ScreenLines: CE_POINTER [NATURAL_8]
			l_new_ScreenLinesUC: CE_POINTER [NATURAL_32]
			l_new_ScreenLinesC: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_new_ScreenLines2: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_new_ScreenAttrs: CE_POINTER [NATURAL_16]
			l_new_LineOffset: CE_POINTER [NATURAL_32]
			l_new_LineWraps: CE_POINTER [NATURAL_8]
			l_new_TabPageIdxs: CE_POINTER [INTEGER_16]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_retry_count: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_wp___0.make
			create l_new_ScreenLines.make
			create l_new_ScreenLinesUC.make
			create l_new_ScreenLinesC.make (<<6>>)
			create l_new_ScreenLines2.make
			create l_new_ScreenAttrs.make
			create l_new_LineOffset.make
			create l_new_LineWraps.make
			create l_new_TabPageIdxs.make
			create l_tp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_outofmem := 0
					l_new_ScreenLinesUC := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
					l_new_ScreenLines2 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_retry_count := 0
				when 1 then -- retry:
					if globals_inst.ScreenLines.is_void then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						if globals_inst.Rows.item = globals_inst.screen_Rows.to_integer_32 then
							if globals_inst.Columns.item = globals_inst.screen_Columns.to_integer_32 then
								if globals_inst.enc_utf8.to_boolean = (not globals_inst.ScreenLinesUC.is_void) then
									if (globals_inst.enc_dbcs = 9_932) = (not globals_inst.ScreenLines2.is_void) then
										if option_inst.p_mco.item = globals_inst.Screen_mco.to_integer_32 then
											js.return
										else
											l_pos := -1 + 4 -- goto _L___3
										end
									else
										l_pos := -1 + 4 -- goto _L___3
									end
								else
									l_pos := -1 + 4 -- goto _L___3
								end
							else
								l_pos := -1 + 4 -- goto _L___3
							end
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___3:
						if globals_inst.Rows.item = 0 then
							js.return
						elseif globals_inst.Columns.item = 0 then
							js.return
						elseif not globals_inst.full_screen.to_boolean then
							if globals_inst.ScreenLines.is_void then
								js.return
							end
						end
				when 5 then
					if not js.return_called and then (entered___4.to_boolean) then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 51 -- skip if block
					end
				when 6 then -- if:
						entered___4 := 1
						globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled + 1
						term_inst.win_new_shellsize
						option_inst.comp_col
						l_tp := globals_inst.first_tabpage
						from
						until
							not (not js.loop_done and then (not l_tp.is_void))
						loop
							if l_tp.is_equal (globals_inst.curtab) then
								l_wp___0 := globals_inst.firstwin
							else
								l_wp___0 := l_tp.item.tp_firstwin
							end
							from
							until
								l_wp___0.is_void
							loop
								window_inst.win_free_lsize (l_wp___0)
								l_wp___0 := l_wp___0.item.w_next
							end
							l_tp := l_tp.item.tp_next
						end
						if not globals_inst.aucmd_win.is_void then
							window_inst.win_free_lsize (globals_inst.aucmd_win)
						end
						l_new_ScreenLines := (misc2_inst.lalloc (((globals_inst.Rows.item + 1) * globals_inst.Columns.item).to_natural_32 * ({PLATFORM}.Natural_8_bytes.to_natural_32).to_natural_32, 0))
						memset (create {CE_POINTER [ANY]}.make_cast (l_new_ScreenLinesC), 0, {PLATFORM}.Pointer_bytes.to_natural_32 * {NATURAL_32} 6).do_nothing
						if globals_inst.enc_utf8.to_boolean then
							l_new_ScreenLinesUC := create {CE_POINTER [NATURAL_32]}.make_cast ((misc2_inst.lalloc (((globals_inst.Rows.item + 1) * globals_inst.Columns.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32, 0)))
							l_i___0 := 0
							from
							until
								not (l_i___0.to_integer_32 < option_inst.p_mco.item)
							loop
								l_new_ScreenLinesC[l_i___0] := create {CE_POINTER [NATURAL_32]}.make_cast ((misc2_inst.lalloc_clear (((globals_inst.Rows.item + 1) * globals_inst.Columns.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32, 0)))
								l_i___0 := l_i___0 + 1
							end
						end
						if globals_inst.enc_dbcs = 9_932 then
							l_new_ScreenLines2 := (misc2_inst.lalloc (((globals_inst.Rows.item + 1) * globals_inst.Columns.item).to_natural_32 * ({PLATFORM}.Natural_8_bytes.to_natural_32).to_natural_32, 0))
						end
						l_new_ScreenAttrs := create {CE_POINTER [NATURAL_16]}.make_cast ((misc2_inst.lalloc (((globals_inst.Rows.item + 1) * globals_inst.Columns.item).to_natural_32 * ({PLATFORM}.Natural_16_bytes.to_natural_32).to_natural_32, 0)))
						l_new_LineOffset := create {CE_POINTER [NATURAL_32]}.make_cast ((misc2_inst.lalloc ((globals_inst.Rows.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32, 0)))
						l_new_LineWraps := (misc2_inst.lalloc ((globals_inst.Rows.item).to_natural_32 * ({PLATFORM}.Natural_8_bytes.to_natural_32).to_natural_32, 0))
						l_new_TabPageIdxs := create {CE_POINTER [INTEGER_16]}.make_cast ((misc2_inst.lalloc ((globals_inst.Columns.item).to_natural_32 * ({PLATFORM}.Integer_16_bytes.to_natural_32).to_natural_32, 0)))
						l_tp := globals_inst.first_tabpage
				when 7 then -- loop condition:
						if not (not js.loop_done and then (not l_tp.is_void)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 8 then -- loop body:
						if l_tp.is_equal (globals_inst.curtab) then
							l_wp___0 := globals_inst.firstwin
						else
							l_wp___0 := l_tp.item.tp_firstwin
						end
				when 9 then -- loop condition:
						if l_wp___0.is_void then
							l_pos := -1 + 12 -- skip loop
						end
				when 10 then -- loop body:
						if (window_inst.win_alloc_lines (l_wp___0)) = 0 then
							l_outofmem := 1
							l_pos := -1 + 14 -- goto give_up
						end
				when 11 then
						l_wp___0 := l_wp___0.item.w_next
						l_pos := -1 + 9 -- back to loop condition
				when 12 then -- loop done
						l_tp := l_tp.item.tp_next
						l_pos := -1 + 7 -- back to loop condition
				when 13 then -- loop done
						if not globals_inst.aucmd_win.is_void then
							if (globals_inst.aucmd_win.item.w_lines).is_void then
								if (window_inst.win_alloc_lines (globals_inst.aucmd_win)) = 0 then
									l_outofmem := 1
								end
							end
						end
				when 14 then -- give_up:
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0.to_integer_32 < option_inst.p_mco.item))
						loop
							if (l_new_ScreenLinesC[l_i___0]).is_void then
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						if not (l_new_ScreenLines.is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 17 then -- else:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if l_new_ScreenLinesUC.is_void then
							l_pos := -1 + 36 -- goto _L___5
						elseif l_i___0.to_integer_32 /= option_inst.p_mco.item then
							l_pos := -1 + 36 -- goto _L___5
						else
							l_pos := -1 + 20 -- goto _L___7
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 20 then -- else: | _L___7:
						if globals_inst.enc_dbcs /= 9_932 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if l_new_ScreenLines2.is_void then
							l_pos := -1 + 36 -- goto _L___5
						else
							l_pos := -1 + 23 -- goto _L___6
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 23 then -- else: | _L___6:
						if not (l_new_ScreenAttrs.is_void) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 26 then -- else:
						if not (l_new_LineOffset.is_void) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 29 then -- else:
						if not (l_new_LineWraps.is_void) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 32 then -- else:
						if not (l_new_TabPageIdxs.is_void) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 35 then -- else:
						if not (l_outofmem.to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if: | _L___5:
						if not globals_inst.ScreenLines.is_void then
							misc2_inst.do_outofmem_msg (((globals_inst.Rows.item + 1) * globals_inst.Columns.item).to_natural_32)
							done_outofmem_msg := 1
						elseif not done_outofmem_msg.to_boolean then
							misc2_inst.do_outofmem_msg (((globals_inst.Rows.item + 1) * globals_inst.Columns.item).to_natural_32)
							done_outofmem_msg := 1
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_ScreenLines))
						l_new_ScreenLines := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_ScreenLinesUC))
						l_new_ScreenLinesUC := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
						l_i___0 := 0
						from
						until
							not (l_i___0.to_integer_32 < option_inst.p_mco.item)
						loop
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_ScreenLinesC[l_i___0]))
							l_new_ScreenLinesC[l_i___0] := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
							l_i___0 := l_i___0 + 1
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_ScreenLines2))
						l_new_ScreenLines2 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_ScreenAttrs))
						l_new_ScreenAttrs := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_LineOffset))
						l_new_LineOffset := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_LineWraps))
						l_new_LineWraps := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_TabPageIdxs))
						l_new_TabPageIdxs := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 38 then -- else:
						done_outofmem_msg := 0
						l_new_row := 0
				when 39 then -- loop condition:
						if not (not js.loop_done and then (l_new_row.to_integer_32 < globals_inst.Rows.item)) then
							l_pos := -1 + 49 -- skip loop
						end
				when 40 then -- loop body:
						l_new_LineOffset[l_new_row] := (l_new_row.to_integer_32 * globals_inst.Columns.item).to_natural_32
						l_new_LineWraps[l_new_row] := (0).to_natural_8
						if a_clear.to_boolean then
							l_pos := -1 + 48 -- skip if block
						end
				when 41 then -- if:
						memset (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenLines + l_new_row.to_integer_32 * globals_inst.Columns.item)), (' ').code, (globals_inst.Columns.item).to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
						if globals_inst.enc_utf8.to_boolean then
							memset (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenLinesUC + l_new_row.to_integer_32 * globals_inst.Columns.item)), 0, (globals_inst.Columns.item).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
							l_i___0 := 0
							from
							until
								not (l_i___0.to_integer_32 < option_inst.p_mco.item)
							loop
								memset (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenLinesC[l_i___0] + l_new_row.to_integer_32 * globals_inst.Columns.item)), 0, (globals_inst.Columns.item).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
								l_i___0 := l_i___0 + 1
							end
						end
						if globals_inst.enc_dbcs = 9_932 then
							memset (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenLines2 + l_new_row.to_integer_32 * globals_inst.Columns.item)), 0, (globals_inst.Columns.item).to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
						end
						memset (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenAttrs + l_new_row.to_integer_32 * globals_inst.Columns.item)), 0, (globals_inst.Columns.item).to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
						l_old_row := (l_new_row.to_integer_32 + (globals_inst.screen_Rows.to_integer_32 - globals_inst.Rows.item)).to_integer_32
						if not (l_old_row >= 0) then
							l_pos := -1 + 48 -- skip if block
						end
				when 42 then -- if:
						if globals_inst.ScreenLines.is_void then
							l_pos := -1 + 48 -- skip if block
						end
				when 43 then -- if:
						if globals_inst.screen_Columns.to_integer_32 < globals_inst.Columns.item then
							l_len := globals_inst.screen_Columns
						else
							l_len := (globals_inst.Columns.item).to_integer_32
						end
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if not (globals_inst.ScreenLinesUC.is_void) then
							l_pos := -1 + 46 -- goto _L___4
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else: | _L___4:
						if option_inst.p_mco.item = globals_inst.Screen_mco.to_integer_32 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenLines + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLines + (globals_inst.LineOffset[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
						end
				when 47 then
						if globals_inst.enc_utf8.to_boolean then
							if not globals_inst.ScreenLinesUC.is_void then
								if option_inst.p_mco.item = globals_inst.Screen_mco.to_integer_32 then
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenLinesUC + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLinesUC + (globals_inst.LineOffset[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
									l_i___0 := 0
									from
									until
										not (l_i___0.to_integer_32 < option_inst.p_mco.item)
									loop
										memmove (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenLinesC[l_i___0] + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLinesC[l_i___0] + (globals_inst.LineOffset[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
										l_i___0 := l_i___0 + 1
									end
								end
							end
						end
						if globals_inst.enc_dbcs = 9_932 then
							if not globals_inst.ScreenLines2.is_void then
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenLines2 + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenLines2 + (globals_inst.LineOffset[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
							end
						end
						memmove (create {CE_POINTER [ANY]}.make_cast ((l_new_ScreenAttrs + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.ScreenAttrs + (globals_inst.LineOffset[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
				when 48 then -- if done | if done | if done
						l_new_row := l_new_row + 1
						l_pos := -1 + 39 -- back to loop condition
				when 49 then -- loop done
						current_ScreenLine := l_new_ScreenLines + globals_inst.Rows.item * globals_inst.Columns.item
				when 50 then -- if done | if done | if done | if done | if done | if done | if done
						free_screenlines
						globals_inst.ScreenLines := l_new_ScreenLines
						globals_inst.ScreenLinesUC := l_new_ScreenLinesUC
						l_i___0 := 0
						from
						until
							not (l_i___0.to_integer_32 < option_inst.p_mco.item)
						loop
							globals_inst.ScreenLinesC[l_i___0] := l_new_ScreenLinesC[l_i___0]
							l_i___0 := l_i___0 + 1
						end
						globals_inst.Screen_mco := (option_inst.p_mco.item).to_integer_32
						globals_inst.ScreenLines2 := l_new_ScreenLines2
						globals_inst.ScreenAttrs := l_new_ScreenAttrs
						globals_inst.LineOffset := l_new_LineOffset
						globals_inst.LineWraps := l_new_LineWraps
						globals_inst.TabPageIdxs := l_new_TabPageIdxs
						l_old_Rows___0 := globals_inst.screen_Rows
						globals_inst.screen_Rows := (globals_inst.Rows.item).to_integer_32
						globals_inst.screen_Columns := (globals_inst.Columns.item).to_integer_32
						globals_inst.must_redraw := 50
						if a_clear.to_boolean then
							screenclear2
						elseif (gui_inst.gui.item.in_use).to_boolean then
							if not (gui_inst.gui.item.starting).to_boolean then
								if not globals_inst.ScreenLines.is_void then
									if l_old_Rows___0.to_integer_32 /= globals_inst.Rows.item then
										gui_inst.gui_redraw_block (0, 0, (globals_inst.Rows.item).to_integer_32 - 1, (globals_inst.Columns.item).to_integer_32 - 1, 0).do_nothing
										if globals_inst.msg_row.to_integer_32 >= globals_inst.Rows.item then
											globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
										elseif globals_inst.Rows.item > l_old_Rows___0.to_integer_32 then
											globals_inst.msg_row := (globals_inst.msg_row.to_integer_32 + (globals_inst.Rows.item - l_old_Rows___0.to_integer_32)).to_integer_32
										end
										if globals_inst.msg_col.to_integer_32 >= globals_inst.Columns.item then
											globals_inst.msg_col := (globals_inst.Columns.item - 1).to_integer_32
										end
									end
								end
							end
						end
						entered___4 := 0
						globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled - 1
						if globals_inst.starting = 0 then
							l_retry_count := l_retry_count + 1
							if l_retry_count <= 3 then
								fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_VIMRESIZED, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
								l_pos := -1 + 1 -- goto retry
							end
						end
				when 51 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screenclear
		do
			check_for_delay (0)
			screenalloc (0)
			screenclear2
		end

	screenclear2
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.starting = 2 then
				js.return
			elseif globals_inst.ScreenLines.is_void then
				js.return
			elseif (gui_inst.gui.item.in_use).to_boolean then
				if (gui_inst.gui.item.starting).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				if not (gui_inst.gui.item.in_use).to_boolean then
					screen_attr := -1
				end
				screen_stop_highlight
				ui_inst.clip_scroll_selection (9_999)
				l_i___0 := 0
				from
				until
					not (l_i___0.to_integer_32 < globals_inst.Rows.item)
				loop
					lineclear (globals_inst.LineOffset[l_i___0], (globals_inst.Columns.item).to_integer_32)
					globals_inst.LineWraps[l_i___0] := (0).to_natural_8
					l_i___0 := l_i___0 + 1
				end
				if (can_clear (term_inst.term_strings[7])).to_boolean then
					term_inst.out_str (term_inst.term_strings[7])
					globals_inst.clear_cmdline := 0
					globals_inst.mode_displayed := 0
				else
					l_i___0 := 0
					from
					until
						not (l_i___0.to_integer_32 < globals_inst.Rows.item)
					loop
						lineinvalid (globals_inst.LineOffset[l_i___0], (globals_inst.Columns.item).to_integer_32)
						l_i___0 := l_i___0 + 1
					end
					globals_inst.clear_cmdline := 1
				end
				globals_inst.screen_cleared := 1
				win_rest_invalid (globals_inst.firstwin)
				globals_inst.redraw_cmdline := 1
				globals_inst.redraw_tabline := 1
				if globals_inst.must_redraw = 50 then
					globals_inst.must_redraw := 40
				end
				ex_getln_inst.compute_cmdrow
				globals_inst.msg_row := globals_inst.cmdline_row
				globals_inst.msg_col := 0
				screen_start
				globals_inst.msg_scrolled := 0
				globals_inst.msg_didany := 0
				globals_inst.msg_didout := 0
			end
		end

	setcursor
		do
			if (redrawing).to_boolean then
				move_inst.validate_cursor
				windgoto (globals_inst.curwin.item.w_winrow + globals_inst.curwin.item.w_wrow, globals_inst.curwin.item.w_wincol + globals_inst.curwin.item.w_wcol)
			end
		end

	showmode: INTEGER_32
		local
			l_need_clear: INTEGER_32
			l_length: INTEGER_32
			l_do_mode: INTEGER_32
			l_attr: INTEGER_32
			l_nwr_save: INTEGER_32
			l_sub_attr: INTEGER_32
			l_tmp: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___13: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_length := 0
					if (option_inst.p_smd.item).to_boolean then
						if globals_inst.msg_silent = 0 then
							if ((globals_inst.State).bit_and (16)).to_boolean then
								l_tmp := 1
							elseif globals_inst.restart_edit.to_boolean then
								l_tmp := 1
							elseif globals_inst.VIsual_active.to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_do_mode := l_tmp
					if not (l_do_mode.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 3 then -- else:
						if not (globals_inst.Recording.to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if not ((redrawing).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not ((getchar_inst.char_avail).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if not globals_inst.KeyTyped.to_boolean then
							globals_inst.redraw_cmdline := 1
							Result := 0
							js.return
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if globals_inst.msg_silent /= 0 then
							globals_inst.redraw_cmdline := 1
							Result := 0
							js.return
						end
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						globals_inst.redraw_cmdline := 1
						Result := 0
						js.return
				when 11 then
						if js.return_called then
							l_pos := -1 + 28 -- skip if block
						end
				when 12 then -- if:
						l_nwr_save := globals_inst.need_wait_return
						check_for_delay (0)
						l_need_clear := globals_inst.clear_cmdline
						if globals_inst.clear_cmdline.to_boolean then
							if globals_inst.cmdline_row.to_integer_32 < globals_inst.Rows.item - 1 then
								message_inst.msg_clr_cmdline
							end
						end
						msg_pos_mode
						term_inst.cursor_off
						l_attr := globals_inst.highlight_attr[8]
						if not (l_do_mode.to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 13 then -- if:
						message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("--")), l_attr)
						if (mbyte_inst.preedit_get_status).to_boolean then
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" IM")), l_attr)
						end
						if globals_inst.edit_submode.is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_length := ((globals_inst.Rows.item - globals_inst.msg_row.to_integer_32) * globals_inst.Columns.item - 3).to_integer_32
						if not globals_inst.edit_submode_extra.is_void then
							l_length := l_length - (charset_inst.vim_strsize (globals_inst.edit_submode_extra))
						end
						if l_length > 0 then
							if not globals_inst.edit_submode_pre.is_void then
								l_length := l_length - (charset_inst.vim_strsize (globals_inst.edit_submode_pre))
							end
							if l_length - (charset_inst.vim_strsize (globals_inst.edit_submode)) > 0 then
								if not globals_inst.edit_submode_pre.is_void then
									message_inst.msg_puts_attr (globals_inst.edit_submode_pre, l_attr)
								end
								message_inst.msg_puts_attr (globals_inst.edit_submode, l_attr)
							end
							if not globals_inst.edit_submode_extra.is_void then
								message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), l_attr)
								if globals_inst.edit_submode_highl.to_integer_32 < 41 then
									l_sub_attr := globals_inst.highlight_attr[globals_inst.edit_submode_highl.to_integer_32]
								else
									l_sub_attr := l_attr
								end
								message_inst.msg_puts_attr (globals_inst.edit_submode_extra, l_sub_attr)
							end
						end
						l_length := 0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 16 then -- else:
						if ((globals_inst.State).bit_and (128)).to_boolean then
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" VREPLACE")))), l_attr)
						elseif ((globals_inst.State).bit_and (64)).to_boolean then
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" REPLACE")))), l_attr)
						elseif ((globals_inst.State).bit_and (16)).to_boolean then
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" INSERT")))), l_attr)
						elseif globals_inst.restart_edit = 73 then
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" (insert)")))), l_attr)
						elseif globals_inst.restart_edit = 82 then
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" (replace)")))), l_attr)
						elseif globals_inst.restart_edit = 86 then
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" (vreplace)")))), l_attr)
						end
						if ((globals_inst.State).bit_and (16)).to_boolean then
							if (option_inst.p_paste.item).to_boolean then
								message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" (paste)")))), l_attr)
							end
						end
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if:
						if globals_inst.VIsual_select.to_boolean then
							l_tmp___13 := 4
						else
							l_tmp___13 := 0
						end
						inspect (l_tmp___13 + (globals_inst.VIsual_mode = 22).to_integer * 2) + (globals_inst.VIsual_mode = 86).to_integer -- switch 1 head
						when 0 then l_pos := -1 + 18
						when 1 then l_pos := -1 + 19
						when 2 then l_pos := -1 + 20
						when 4 then l_pos := -1 + 21
						when 5 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 18 then -- switch 1, case 0
						l_p___0 := ce_string (" VISUAL")
						l_pos := -1 + 24 -- switch 1; break
				when 19 then -- switch 1, case 1
						l_p___0 := ce_string (" VISUAL LINE")
						l_pos := -1 + 24 -- switch 1; break
				when 20 then -- switch 1, case 2
						l_p___0 := ce_string (" VISUAL BLOCK")
						l_pos := -1 + 24 -- switch 1; break
				when 21 then -- switch 1, case 4
						l_p___0 := ce_string (" SELECT")
						l_pos := -1 + 24 -- switch 1; break
				when 22 then -- switch 1, case 5
						l_p___0 := ce_string (" SELECT LINE")
						l_pos := -1 + 24 -- switch 1; break
				when 23 then -- switch 1, default:
						l_p___0 := ce_string (" SELECT BLOCK")
						l_pos := -1 + 24 -- switch 1; break
				when 24 then -- switch 1, done:
						message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (l_p___0))), l_attr)
				when 25 then -- if done
						message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" --")), l_attr)
				when 26 then -- if done
						l_need_clear := 1
				when 27 then -- if done
						if globals_inst.Recording.to_boolean then
							if globals_inst.edit_submode.is_void then
								message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("recording")))), l_attr)
								l_need_clear := 1
							end
						end
						globals_inst.mode_displayed := 1
						if l_need_clear.to_boolean then
							message_inst.msg_clr_eos
						elseif globals_inst.clear_cmdline.to_boolean then
							message_inst.msg_clr_eos
						end
						globals_inst.msg_didout := 0
						l_length := globals_inst.msg_col
						globals_inst.msg_col := 0
						globals_inst.need_wait_return := l_nwr_save
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						if globals_inst.clear_cmdline.to_boolean then
							if globals_inst.msg_silent = 0 then
								message_inst.msg_clr_cmdline
							end
						end
				when 30 then -- if done
						if not js.return_called then
							if globals_inst.VIsual_active.to_boolean then
								normal_inst.clear_showcmd
							end
							if (redrawing).to_boolean then
								if globals_inst.lastwin.item.w_status_height = 0 then
									win_redr_ruler (globals_inst.lastwin, 1)
								end
							end
							globals_inst.redraw_cmdline := 0
							globals_inst.clear_cmdline := 0
							Result := l_length
						end
				when 31 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	showruler (a_always: INTEGER_32)
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not a_always.to_boolean then
						if not (redrawing).to_boolean then
							js.return
						end
					end
					if not js.return_called then
						if (popupmnu_inst.pum_visible).to_boolean then
							globals_inst.curwin.item.w_redr_status := 1
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if (option_inst.p_stl.item.item).to_integer_32 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if ((globals_inst.curwin.item.w_onebuf_opt.wo_stl).item).to_integer_32 = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if (globals_inst.curwin.item.w_status_height).to_boolean then
							redraw_custom_statusline (globals_inst.curwin)
						else
							win_redr_ruler (globals_inst.curwin, a_always)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						win_redr_ruler (globals_inst.curwin, a_always)
				when 8 then -- if done
						if not (globals_inst.need_maketitle.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						buffer_inst.maketitle
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if not ((option_inst.p_icon.item).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if ((globals_inst.stl_syntax).bit_and (1)).to_boolean then
							buffer_inst.maketitle
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___0:
						if (option_inst.p_title.item).to_boolean then
							if ((globals_inst.stl_syntax).bit_and (2)).to_boolean then
								buffer_inst.maketitle
							end
						end
				when 15 then -- if done
						if globals_inst.redraw_tabline.to_boolean then
							draw_tabline
						end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	skip_status_match_char (a_xp: CE_POINTER [PD_EXPAND]; a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((charset_inst.rem_backslash (a_s)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_xp.item.xp_context /= 8 then
							l_pos := -1 + 12 -- goto _L___0
						else
							l_pos := -1 + 3 -- goto _L___2
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else: | _L___2:
						if a_xp.item.xp_context /= 11 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_xp.item.xp_context /= 21 then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if: | _L___1:
						if (a_s[0]).to_integer_32 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 10 then -- else:
						if (a_s[0]).to_integer_32 /= 92 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (a_s[1]).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if (a_xp.item.xp_shell).to_boolean then
							if (misc2_inst.csh_like_shell).to_boolean then
								if (a_s[1]).to_integer_32 = 92 then
									if (a_s[2]).to_integer_32 = 33 then
										Result := 2
										js.return
									end
								end
							end
						end
						if not js.return_called then
							Result := 1
							js.return
						end
				when 13 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	start_search_hl
		do
			if (option_inst.p_hls.item).to_boolean then
				if not globals_inst.no_hlsearch.to_boolean then
					search_inst.last_pat_prog (create {CE_POINTER [PD_REGMMATCH_T]}.make_shared (search_hl.item.c_pointer + (create {PD_MATCH_T}.make).offset_of ("rm")))
					search_hl.item.attr := globals_inst.highlight_attr[6]
					ex_cmds2_inst.profile_setlimit (option_inst.p_rdt.item, create {CE_POINTER [SD_TIMEVAL]}.make_shared (search_hl.item.c_pointer + (create {PD_MATCH_T}.make).offset_of ("tm")))
				end
			end
		end

	status_match_len (a_xp: CE_POINTER [PD_EXPAND]; a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_emenu: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s := a_s
			l_len := 0
			if a_xp.item.xp_context = 11 then
				l_tmp := 1
			elseif a_xp.item.xp_context = 21 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			l_emenu := l_tmp
			if l_emenu.to_boolean then
				if (menu_inst.menu_is_separator (l_s)).to_boolean then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				from
				until
					(l_s.item).to_integer_32 = 0
				loop
					l_s := l_s + (skip_status_match_char (a_xp, l_s))
					l_len := l_len + (charset_inst.ptr2cells (l_s))
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___4 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
					else
						l_tmp___4 := 1
					end
					l_s := l_s + l_tmp___4
				end
				Result := l_len
			end
		end

	status_redraw_all
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			create l_wp___0.make

			l_wp___0 := globals_inst.firstwin
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_status_height).to_boolean then
					l_wp___0.item.w_redr_status := 1
					redraw_later (10)
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	status_redraw_curbuf
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			create l_wp___0.make

			l_wp___0 := globals_inst.firstwin
			from
			until
				l_wp___0.is_void
			loop
				if l_wp___0.item.w_status_height /= 0 then
					if (l_wp___0.item.w_buffer).is_equal (globals_inst.curbuf) then
						l_wp___0.item.w_redr_status := 1
						redraw_later (10)
					end
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	stl_connected (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_fr: CE_POINTER [PD_FRAME_S]
			js: JUMP_STATE
		do
			create l_fr.make

			l_fr := a_wp___0.item.w_frame
			from
			until
				not (not js.loop_done and then (not (l_fr.item.fr_parent).is_void))
			loop
				if ((l_fr.item.fr_parent).item.fr_layout).to_integer_32 = 2 then
					if not (l_fr.item.fr_next).is_void then
						js.break
					end
				elseif not (l_fr.item.fr_next).is_void then
					Result := 1
					js.return
				end
				if not js.loop_jumped then
					l_fr := l_fr.item.fr_parent
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	unshowmode (a_force: INTEGER_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((redrawing).to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_force.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (getchar_inst.char_avail).to_boolean then
							if not globals_inst.KeyTyped.to_boolean then
								globals_inst.redraw_cmdline := 1
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___0:
						msg_pos_mode
						if globals_inst.Recording.to_boolean then
							message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("recording")))), globals_inst.highlight_attr[8])
						end
						message_inst.msg_clr_eos
				when 5 then -- if done | if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						globals_inst.redraw_cmdline := 1
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	updateWindow (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			js: JUMP_STATE
		do
			if globals_inst.updating_screen.to_boolean then
				js.return
			end
			if not js.return_called then
				update_prepare
				if (globals_inst.clip_star.item.available).to_boolean then
					if (ui_inst.clip_isautosel).to_boolean then
						ui_inst.clip_update_selection
					end
				end
				win_update (a_wp___0)
				if globals_inst.redraw_tabline.to_boolean then
					draw_tabline
				end
				if (a_wp___0.item.w_redr_status).to_boolean then
					win_redr_status (a_wp___0)
				elseif (option_inst.p_ru.item).to_boolean then
					win_redr_status (a_wp___0)
				elseif (option_inst.p_stl.item.item).to_integer_32 /= 0 then
					win_redr_status (a_wp___0)
				elseif ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 /= 0 then
					win_redr_status (a_wp___0)
				end
				update_finish
			end
		end

	update_curbuf (a_type: INTEGER_32)
		do
			redraw_curbuf_later (a_type)
			update_screen (a_type)
		end

	update_debug_sign (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lnum: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_doit: INTEGER_32
			js: JUMP_STATE
		do
			create l_wp___0.make

			l_doit := 0
			win_foldinfo.item.fi_level := 0
			l_wp___0 := globals_inst.firstwin
			from
			until
				l_wp___0.is_void
			loop
				if not a_buf___6.is_void then
					if a_lnum > 0 then
						if (l_wp___0.item.w_buffer).is_equal (a_buf___6) then
							if a_lnum >= l_wp___0.item.w_topline then
								if a_lnum < l_wp___0.item.w_botline then
									if l_wp___0.item.w_redraw_top = 0 then
										l_wp___0.item.w_redraw_top := a_lnum
									elseif l_wp___0.item.w_redraw_top > a_lnum then
										l_wp___0.item.w_redraw_top := a_lnum
									end
									if l_wp___0.item.w_redraw_bot = 0 then
										l_wp___0.item.w_redraw_bot := a_lnum
									elseif l_wp___0.item.w_redraw_bot < a_lnum then
										l_wp___0.item.w_redraw_bot := a_lnum
									end
									redraw_win_later (l_wp___0, 10)
								end
							end
						end
					else
						redraw_win_later (l_wp___0, 10)
					end
				else
					redraw_win_later (l_wp___0, 10)
				end
				if l_wp___0.item.w_redr_type /= 0 then
					l_doit := 1
				end
				l_wp___0 := l_wp___0.item.w_next
			end
			if not l_doit.to_boolean then
				js.return
			elseif globals_inst.updating_screen.to_boolean then
				js.return
			end
			if not js.return_called then
				update_prepare
				l_wp___0 := globals_inst.firstwin
				from
				until
					l_wp___0.is_void
				loop
					if l_wp___0.item.w_redr_type /= 0 then
						win_update (l_wp___0)
					end
					if (l_wp___0.item.w_redr_status).to_boolean then
						win_redr_status (l_wp___0)
					end
					l_wp___0 := l_wp___0.item.w_next
				end
				update_finish
			end
		end

	update_finish
		do
			if globals_inst.redraw_cmdline.to_boolean then
				showmode.do_nothing
			end
			end_search_hl
			globals_inst.updating_screen := 0
			gui_inst.gui_may_resize_shell
			if (gui_inst.gui.item.in_use).to_boolean then
				term_inst.out_flush
				gui_inst.gui_update_cursor (0, 0)
				gui_inst.gui_update_scrollbars (0)
			end
		end

	update_prepare
		do
			term_inst.cursor_off
			globals_inst.updating_screen := 1
			if (gui_inst.gui.item.in_use).to_boolean then
				gui_inst.gui_undraw_cursor
			end
			start_search_hl
		end

	update_screen (a_type: INTEGER_32)
		local
			l_type: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_did_one: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_wwp: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_wp___0.make
			create l_wwp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_type := a_type
					if not (screen_valid (1)).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.must_redraw.to_boolean then
							if l_type < globals_inst.must_redraw then
								l_type := globals_inst.must_redraw
							end
							globals_inst.must_redraw := 0
						end
						if globals_inst.curwin.item.w_lines_valid = 0 then
							if l_type < 40 then
								l_type := 40
							end
						end
						if not ((redrawing).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if not (globals_inst.updating_screen.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | _L:
						redraw_later (l_type)
						globals_inst.must_redraw := l_type
						if l_type > 25 then
							globals_inst.curwin.item.w_lines_valid := 0
						end
						js.return
				when 4 then -- if done | if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else:
						l_pos := -1 + 3 -- goto _L
				when 6 then -- if done
						if js.return_called then
							l_pos := -1 + 28 -- skip if block
						end
				when 7 then -- if:
							globals_inst.updating_screen := 1
							globals_inst.display_tick := (globals_inst.display_tick.to_integer_32 + 1).to_natural_16
							if not (globals_inst.msg_scrolled.to_boolean) then
								l_pos := -1 + 22 -- skip if block
							end
				when 8 then -- if:
							globals_inst.clear_cmdline := 1
							if not (globals_inst.msg_scrolled.to_integer_32 > globals_inst.Rows.item - 5) then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							l_type := 50
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 21
				when 11 then -- else:
							if l_type = 50 then
								l_pos := -1 + 21 -- skip if block
							end
				when 12 then -- if:
							check_for_delay (0)
							if (screen_ins_lines (0, 0, globals_inst.msg_scrolled, (globals_inst.Rows.item).to_integer_32, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))) = 0 then
								l_type := 50
							end
							l_wp___0 := globals_inst.firstwin
				when 13 then -- loop condition:
							if l_wp___0.is_void then
								l_pos := -1 + 20 -- skip loop
							end
				when 14 then -- loop body:
							if not (l_wp___0.item.w_winrow < globals_inst.msg_scrolled) then
								l_pos := -1 + 19 -- skip if block
							end
				when 15 then -- if:
							if not (l_wp___0.item.w_winrow + l_wp___0.item.w_height > globals_inst.msg_scrolled) then
								l_pos := -1 + 18 -- skip if block
							end
				when 16 then -- if:
							if l_wp___0.item.w_redr_type < 30 then
								if l_wp___0.item.w_lines_valid > 0 then
									if l_wp___0.item.w_topline = (l_wp___0.item.w_lines + 0).item.wl_lnum then
										l_wp___0.item.w_upd_rows := globals_inst.msg_scrolled - l_wp___0.item.w_winrow
										l_wp___0.item.w_redr_type := 30
									else
										l_pos := -1 + 18 -- goto _L___2
									end
								else
									l_pos := -1 + 18 -- goto _L___2
								end
							else
								l_pos := -1 + 18 -- goto _L___2
							end
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 18 then -- else: | _L___2:
							l_wp___0.item.w_redr_type := 40
							if (l_wp___0.item.w_winrow + l_wp___0.item.w_height) + l_wp___0.item.w_status_height <= globals_inst.msg_scrolled then
								l_wp___0.item.w_redr_status := 1
							end
				when 19 then -- if done
							l_wp___0 := l_wp___0.item.w_next
							l_pos := -1 + 13 -- back to loop condition
				when 20 then -- loop done
							globals_inst.redraw_cmdline := 1
							globals_inst.redraw_tabline := 1
				when 21 then -- if done | if done
							globals_inst.msg_scrolled := 0
							globals_inst.need_wait_return := 0
				when 22 then -- if done
							ex_getln_inst.compute_cmdrow
							if globals_inst.need_highlight_changed.to_boolean then
								syntax_inst.highlight_changed.do_nothing
							end
							if l_type = 50 then
								screenclear
								l_type := 40
							end
							if globals_inst.clear_cmdline.to_boolean then
								check_for_delay (0)
							end
							if globals_inst.curwin.item.w_redr_type < 40 then
								if (globals_inst.curwin.item.w_onebuf_opt.wo_nu).to_boolean then
									l_tmp___2 := number_width (globals_inst.curwin)
									l_tmp___3 := l_tmp___2
								elseif (globals_inst.curwin.item.w_onebuf_opt.wo_rnu).to_boolean then
									l_tmp___2 := number_width (globals_inst.curwin)
									l_tmp___3 := l_tmp___2
								else
									l_tmp___3 := 0
								end
								if globals_inst.curwin.item.w_nrwidth /= l_tmp___3 then
									globals_inst.curwin.item.w_redr_type := 40
								end
							end
							if l_type = 20 then
								move_inst.update_curswant
							end
							if not (globals_inst.curwin.item.w_redr_type < l_type) then
								l_pos := -1 + 27 -- skip if block
							end
				when 23 then -- if:
							if l_type /= 10 then
								l_pos := -1 + 26 -- skip if block
							end
				when 24 then -- if:
							if ((globals_inst.curwin.item.w_lines + 0).item.wl_valid).to_boolean then
								if globals_inst.curwin.item.w_topfill = globals_inst.curwin.item.w_old_topfill then
									if globals_inst.curwin.item.w_botfill = globals_inst.curwin.item.w_old_botfill then
										if globals_inst.curwin.item.w_topline /= (globals_inst.curwin.item.w_lines + 0).item.wl_lnum then
											l_pos := -1 + 26 -- goto _L___6
										end
									else
										l_pos := -1 + 26 -- goto _L___6
									end
								else
									l_pos := -1 + 26 -- goto _L___6
								end
							else
								l_pos := -1 + 26 -- goto _L___6
							end
				when 25 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 26 then -- else: | _L___6:
							if l_type = 20 then
								if globals_inst.VIsual_active.to_boolean then
									if globals_inst.curwin.item.w_old_cursor_lnum = globals_inst.curwin.item.w_cursor.lnum then
										if (globals_inst.curwin.item.w_old_visual_mode).to_integer_32 = globals_inst.VIsual_mode then
											if ((globals_inst.curwin.item.w_valid).bit_and (4)).to_boolean then
												if globals_inst.curwin.item.w_old_curswant /= globals_inst.curwin.item.w_curswant then
													globals_inst.curwin.item.w_redr_type := l_type
												end
											else
												globals_inst.curwin.item.w_redr_type := l_type
											end
										else
											globals_inst.curwin.item.w_redr_type := l_type
										end
									else
										globals_inst.curwin.item.w_redr_type := l_type
									end
								else
									globals_inst.curwin.item.w_redr_type := l_type
								end
							else
								globals_inst.curwin.item.w_redr_type := l_type
							end
				when 27 then -- if done
							if globals_inst.redraw_tabline.to_boolean then
								draw_tabline
							elseif l_type >= 40 then
								draw_tabline
							end
							l_wp___0 := globals_inst.firstwin
							from
							until
								not (not js.loop_done and then (not l_wp___0.is_void))
							loop
								if ((l_wp___0.item.w_buffer).item.b_mod_set).to_boolean then
									l_wwp := globals_inst.firstwin
									from
									until
										not (not js.loop_done and then (not l_wwp.is_equal (l_wp___0)))
									loop
										if (l_wwp.item.w_buffer).is_equal (l_wp___0.item.w_buffer) then
											js.break
										end
										if not js.loop_jumped then
											l_wwp := l_wwp.item.w_next
										end
									end
									if l_wwp.is_equal (l_wp___0) then
										if (syntax_inst.syntax_present (l_wp___0)).to_boolean then
											syntax_inst.syn_stack_apply_changes (l_wp___0.item.w_buffer)
										end
									end
								end
								l_wp___0 := l_wp___0.item.w_next
							end
							l_did_one := 0
							search_hl.item.rm.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
							l_wp___0 := globals_inst.firstwin
							from
							until
								l_wp___0.is_void
							loop
								if l_wp___0.item.w_redr_type /= 0 then
									term_inst.cursor_off
									if not l_did_one.to_boolean then
										l_did_one := 1
										start_search_hl
										if (globals_inst.clip_star.item.available).to_boolean then
											if (ui_inst.clip_isautosel).to_boolean then
												ui_inst.clip_update_selection
											end
										end
										if (gui_inst.gui.item.in_use).to_boolean then
											gui_inst.gui_undraw_cursor
										end
									end
									win_update (l_wp___0)
								end
								if (l_wp___0.item.w_redr_status).to_boolean then
									term_inst.cursor_off
									win_redr_status (l_wp___0)
								end
								l_wp___0 := l_wp___0.item.w_next
							end
							end_search_hl
							l_wp___0 := globals_inst.firstwin
							from
							until
								l_wp___0.is_void
							loop
								(l_wp___0.item.w_buffer).item.b_mod_set := 0
								l_wp___0 := l_wp___0.item.w_next
							end
							globals_inst.updating_screen := 0
							gui_inst.gui_may_resize_shell
							if globals_inst.clear_cmdline.to_boolean then
								showmode.do_nothing
							elseif globals_inst.redraw_cmdline.to_boolean then
								showmode.do_nothing
							end
							if not did_intro.to_boolean then
								if globals_inst.curbuf.item.b_ml.ml_line_count = 1 then
									if ((memline_inst.ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
										if (globals_inst.curbuf.item.b_fname).is_void then
											if (globals_inst.firstwin.item.w_next).is_void then
												if (misc2_inst.vim_strchr (option_inst.p_shm.item, ('I').code)).is_void then
													version_inst.intro_message (0)
												end
											end
										end
									end
								end
							end
							did_intro := 1
							if (gui_inst.gui.item.in_use).to_boolean then
								term_inst.out_flush
								if l_did_one.to_boolean then
									gui_inst.gui_update_cursor (0, 0)
								end
								gui_inst.gui_update_scrollbars (0)
							end
				when 28 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	win_del_lines (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_row: INTEGER_32; a_line_count: INTEGER_32; a_invalid: INTEGER_32; a_mayclear: INTEGER_32): INTEGER_32
		local
			l_line_count: INTEGER_32
			l_retval: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := a_line_count
					if a_invalid.to_boolean then
						a_wp___0.item.w_lines_valid := 0
					end
					if l_line_count > a_wp___0.item.w_height - a_row then
						l_line_count := a_wp___0.item.w_height - a_row
					end
					l_retval := win_do_lines (a_wp___0, a_row, l_line_count, a_mayclear, 1)
					if l_retval /= 2 then
						Result := l_retval
						js.return
					end
					if not js.return_called then
						if (screen_del_lines (0, a_wp___0.item.w_winrow + a_row, l_line_count, (globals_inst.Rows.item).to_integer_32, 0, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))) = 0 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if (a_wp___0.item.w_next).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if not ((a_wp___0.item.w_status_height).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if not (globals_inst.cmdline_row.to_integer_32 < globals_inst.Rows.item - 1) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						if (screen_ins_lines (0, (a_wp___0.item.w_winrow + a_wp___0.item.w_height) - l_line_count, l_line_count, (globals_inst.Rows.item).to_integer_32, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))) = 0 then
							a_wp___0.item.w_redr_status := 1
							win_rest_invalid (a_wp___0.item.w_next)
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						globals_inst.redraw_cmdline := 1
				when 11 then -- if done | if done
						Result := 1
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_do_lines (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_row: INTEGER_32; a_line_count: INTEGER_32; a_mayclear: INTEGER_32; a_del: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (redrawing).to_boolean then
						if a_line_count <= 0 then
							Result := 0
							js.return
						end
					else
						Result := 0
						js.return
					end
					if not js.return_called and then (a_mayclear.to_boolean) then
						if globals_inst.Rows.item - a_line_count.to_integer_32 < 5 then
							if (a_wp___0.item.w_width).to_integer_32 = globals_inst.Columns.item then
								screenclear
								Result := 0
								js.return
							end
						end
					end
					if not js.return_called and then (a_row + a_line_count >= a_wp___0.item.w_height) then
						screen_fill (a_wp___0.item.w_winrow + a_row, a_wp___0.item.w_winrow + a_wp___0.item.w_height, a_wp___0.item.w_wincol, a_wp___0.item.w_wincol + a_wp___0.item.w_width, (' ').code, (' ').code, 0)
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						globals_inst.clear_cmdline := 1
						if not (globals_inst.scroll_region.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (a_wp___0.item.w_width).to_integer_32 = globals_inst.Columns.item then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if globals_inst.scroll_region.to_boolean then
							if (a_wp___0.item.w_width).to_integer_32 = globals_inst.Columns.item then
								term_inst.scroll_region_set (a_wp___0, a_row)
							elseif ((term_inst.term_strings[55]).item).to_integer_32 /= 0 then
								term_inst.scroll_region_set (a_wp___0, a_row)
							end
						end
						if a_del.to_boolean then
							l_retval := screen_del_lines (a_wp___0.item.w_winrow + a_row, 0, a_line_count, a_wp___0.item.w_height - a_row, 0, a_wp___0)
						else
							l_retval := screen_ins_lines (a_wp___0.item.w_winrow + a_row, 0, a_line_count, a_wp___0.item.w_height - a_row, a_wp___0)
						end
						if globals_inst.scroll_region.to_boolean then
							if (a_wp___0.item.w_width).to_integer_32 = globals_inst.Columns.item then
								term_inst.scroll_region_reset
							elseif ((term_inst.term_strings[55]).item).to_integer_32 /= 0 then
								term_inst.scroll_region_reset
							end
						end
						Result := l_retval
						js.return
				when 6 then -- if done | if done
						if not js.return_called and then (not (a_wp___0.item.w_next).is_void) then
							if (option_inst.p_tf.item).to_boolean then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							Result := 2
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	win_draw_end (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_c1: INTEGER_32; a_c2: INTEGER_32; a_row: INTEGER_32; a_endrow: INTEGER_32; a_hl: NATURAL_32)
		local
			l_n: INTEGER_32
			l_nn: INTEGER_32
			l_nn___0: INTEGER_32
		do
			l_n := 0
			if globals_inst.cmdwin_type /= 0 then
				if a_wp___0.is_equal (globals_inst.curwin) then
					l_n := 1
					if l_n > a_wp___0.item.w_width then
						l_n := a_wp___0.item.w_width
					end
					screen_fill (a_wp___0.item.w_winrow + a_row, a_wp___0.item.w_winrow + a_endrow, a_wp___0.item.w_wincol, a_wp___0.item.w_wincol + l_n, globals_inst.cmdwin_type, (' ').code, globals_inst.highlight_attr[1])
				end
			end
			if a_wp___0.item.w_onebuf_opt.wo_fdc > 0 then
				l_nn := (l_n.to_integer_32 + a_wp___0.item.w_onebuf_opt.wo_fdc).to_integer_32
				if l_nn > a_wp___0.item.w_width then
					l_nn := a_wp___0.item.w_width
				end
				screen_fill (a_wp___0.item.w_winrow + a_row, a_wp___0.item.w_winrow + a_endrow, a_wp___0.item.w_wincol + l_n, a_wp___0.item.w_wincol + l_nn, (' ').code, (' ').code, globals_inst.highlight_attr[20])
				l_n := l_nn
			end
			if (draw_signcolumn (a_wp___0)).to_boolean then
				l_nn___0 := l_n + 2
				if l_nn___0 > a_wp___0.item.w_width then
					l_nn___0 := a_wp___0.item.w_width
				end
				screen_fill (a_wp___0.item.w_winrow + a_row, a_wp___0.item.w_winrow + a_endrow, a_wp___0.item.w_wincol + l_n, a_wp___0.item.w_wincol + l_nn___0, (' ').code, (' ').code, globals_inst.highlight_attr[26])
				l_n := l_nn___0
			end
			screen_fill (a_wp___0.item.w_winrow + a_row, a_wp___0.item.w_winrow + a_endrow, a_wp___0.item.w_wincol + l_n, a_wp___0.item.w_wincol + a_wp___0.item.w_width, a_c1, a_c2, globals_inst.highlight_attr[a_hl.to_integer_32])
			move_inst.set_empty_rows (a_wp___0, a_row)
		end

	win_ins_lines (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_row: INTEGER_32; a_line_count: INTEGER_32; a_invalid: INTEGER_32; a_mayclear: INTEGER_32): INTEGER_32
		local
			l_line_count: INTEGER_32
			l_did_delete: INTEGER_32
			l_nextrow: INTEGER_32
			l_lastrow: INTEGER_32
			l_retval: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := a_line_count
					if a_invalid.to_boolean then
						a_wp___0.item.w_lines_valid := 0
					end
					if a_wp___0.item.w_height < 5 then
						Result := 0
						js.return
					end
					if not js.return_called then
						if l_line_count > a_wp___0.item.w_height - a_row then
							l_line_count := a_wp___0.item.w_height - a_row
						end
						l_retval := win_do_lines (a_wp___0, a_row, l_line_count, a_mayclear, 0)
						if l_retval /= 2 then
							Result := l_retval
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_did_delete := 0
						if (a_wp___0.item.w_next).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((a_wp___0.item.w_status_height).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (screen_del_lines (0, (a_wp___0.item.w_winrow + a_wp___0.item.w_height) - l_line_count, l_line_count, (globals_inst.Rows.item).to_integer_32, 0, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))) = 1 then
							l_did_delete := 1
						elseif (not (a_wp___0.item.w_next).is_void) then
							Result := 0
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called then
							if not l_did_delete.to_boolean then
								a_wp___0.item.w_redr_status := 1
								globals_inst.redraw_cmdline := 1
								l_nextrow := (a_wp___0.item.w_winrow + a_wp___0.item.w_height) + a_wp___0.item.w_status_height
								l_lastrow := l_nextrow + l_line_count
								if l_lastrow.to_integer_32 > globals_inst.Rows.item then
									l_lastrow := (globals_inst.Rows.item).to_integer_32
								end
								screen_fill (l_nextrow - l_line_count, l_lastrow - l_line_count, a_wp___0.item.w_wincol, a_wp___0.item.w_wincol + a_wp___0.item.w_width, (' ').code, (' ').code, 0)
							end
							if (screen_ins_lines (0, a_wp___0.item.w_winrow + a_row, l_line_count, (globals_inst.Rows.item).to_integer_32, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))) = 0 then
								if l_did_delete.to_boolean then
									a_wp___0.item.w_redr_status := 1
									win_rest_invalid (a_wp___0.item.w_next)
								end
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							Result := 1
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	win_line (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_startrow: INTEGER_32; a_endrow: INTEGER_32; a_nochange: INTEGER_32): INTEGER_32
		local
			l_col: INTEGER_32
			l_off___0: NATURAL_32
			l_c: INTEGER_32
			l_vcol: INTEGER_32
			l_vcol_prev: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_row: INTEGER_32
			l_screen_row: INTEGER_32
			l_extra: CE_ARRAY [NATURAL_8]
			l_n_extra: INTEGER_32
			l_p_extra: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c_extra: INTEGER_32
			l_extra_attr: INTEGER_32
			l_lcs_eol_one: INTEGER_32
			l_lcs_prec_todo: INTEGER_32
			l_saved_n_extra: INTEGER_32
			l_saved_p_extra: CE_POINTER [NATURAL_8]
			l_saved_c_extra: INTEGER_32
			l_saved_char_attr: INTEGER_32
			l_n_attr: INTEGER_32
			l_saved_attr2: INTEGER_32
			l_n_attr3: INTEGER_32
			l_saved_attr3: INTEGER_32
			l_n_skip: INTEGER_32
			l_fromcol: CE_ARRAY [INTEGER_32]
			l_tocol: CE_ARRAY [INTEGER_32]
			l_fromcol_prev: INTEGER_32
			l_noinvcur: INTEGER_32
			l_top: CE_POINTER [PD_POS_T]
			l_bot: CE_POINTER [PD_POS_T]
			l_lnum_in_visual_area: INTEGER_32
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_v: INTEGER_32
			l_char_attr: INTEGER_32
			l_attr_pri: INTEGER_32
			l_area_highlighting: INTEGER_32
			l_attr: INTEGER_32
			l_area_attr: INTEGER_32
			l_search_attr: INTEGER_32
			l_vcol_save_attr: INTEGER_32
			l_syntax_attr: INTEGER_32
			l_has_syntax: INTEGER_32
			l_save_did_emsg: INTEGER_32
			l_eol_hl_off: INTEGER_32
			l_draw_color_col: INTEGER_32
			l_color_cols: CE_ARRAY [CE_POINTER [INTEGER_32]]
			l_has_spell: INTEGER_32
			l_nextline: CE_ARRAY [NATURAL_8]
			l_nextlinecol: INTEGER_32
			l_nextline_idx: INTEGER_32
			l_spell_attr: INTEGER_32
			l_word_end: INTEGER_32
			l_cur_checked_col: INTEGER_32
			l_extra_check: INTEGER_32
			l_multi_attr: INTEGER_32
			l_mb_l: INTEGER_32
			l_mb_c: INTEGER_32
			l_mb_utf8: INTEGER_32
			l_u8cc: CE_ARRAY [INTEGER_32]
			l_filler_lines: INTEGER_32
			l_filler_todo: INTEGER_32
			l_diff_hlf: NATURAL_32
			l_change_start___0: CE_ARRAY [INTEGER_32]
			l_change_end___0: CE_ARRAY [INTEGER_32]
			l_trailcol: INTEGER_32
			l_need_showbreak: INTEGER_32
			l_line_attr: INTEGER_32
			l_cur: CE_POINTER [PD_MATCHITEM]
			l_shl: CE_POINTER [PD_MATCH_T]
			l_shl_flag: INTEGER_32
			l_prevcol_hl_flag: INTEGER_32
			l_did_line_attr: INTEGER_32
			l_draw_state: INTEGER_32
			l_feedback_col: INTEGER_32
			l_feedback_old_attr: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_prev_ptr: CE_POINTER [NATURAL_8]
			l_tmp___14: INTEGER_32
			l_len: INTEGER_32
			l_linecol: INTEGER_32
			l_spell_hlf: CE_ARRAY [NATURAL_32]
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_text_sign: NATURAL_32
			l_icon_sign: NATURAL_32
			l_num: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___38: CE_POINTER [NATURAL_8]
			l_can_spell: CE_ARRAY [INTEGER_32]
			l_tmp___41: CE_POINTER [INTEGER_32]
			l_prev_ptr___0: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len___0: INTEGER_32
			l_spell_hlf___0: CE_ARRAY [NATURAL_32]
			l_tmp___42: INTEGER_32
			l_tmp___49: CE_POINTER [NATURAL_8]
			l_tcol: CE_ARRAY [INTEGER_32]
			l_tmp___53: INTEGER_32
			l_prevcol: INTEGER_32
			l_tmp___54: INTEGER_32
			l_n: INTEGER_32
			l_rightmost_vcol: INTEGER_32
			l_i___1: INTEGER_32
			l_tmp___57: NATURAL_32
			l_tmp___58: NATURAL_32
			l_tmp___59: NATURAL_32
			l_i___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_ptr.make
			create l_extra.make (<<18>>)
			create l_p_extra.make (<<1>>)
			create l_saved_p_extra.make
			create l_fromcol.make (<<1>>)
			create l_tocol.make (<<1>>)
			create l_top.make
			create l_bot.make
			create l_pos___3.make (<<1>>)
			create l_color_cols.make (<<1>>)
			create l_nextline.make (<<300>>)
			create l_u8cc.make (<<6>>)
			create l_change_start___0.make (<<1>>)
			create l_change_end___0.make (<<1>>)
			create l_cur.make
			create l_shl.make
			create l_prev_ptr.make
			create l_spell_hlf.make (<<1>>)
			create l_tmp___16.make
			create l_tmp___38.make
			create l_can_spell.make (<<1>>)
			create l_tmp___41.make
			create l_prev_ptr___0.make
			create l_p___0.make
			create l_spell_hlf___0.make (<<1>>)
			create l_tmp___49.make
			create l_tcol.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := 0
					l_vcol := 0
					l_vcol_prev := -1
					l_n_extra := 0
					l_p_extra.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_c_extra := ('%/0/').code
					l_extra_attr := 0
					l_lcs_eol_one := globals_inst.lcs_eol.item
					l_lcs_prec_todo := globals_inst.lcs_prec.item
					l_saved_n_extra := 0
					l_saved_p_extra := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_saved_c_extra := 0
					l_saved_char_attr := 0
					l_n_attr := 0
					l_saved_attr2 := 0
					l_n_attr3 := 0
					l_saved_attr3 := 0
					l_n_skip := 0
					l_fromcol_prev := -2
					l_noinvcur := 0
					l_lnum_in_visual_area := 0
					l_char_attr := 0
					l_attr_pri := 0
					l_area_highlighting := 0
					l_attr := 0
					l_area_attr := 0
					l_search_attr := 0
					l_vcol_save_attr := 0
					l_syntax_attr := 0
					l_has_syntax := 0
					l_eol_hl_off := 0
					l_draw_color_col := 0
					l_color_cols.item := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
					l_has_spell := 0
					l_nextlinecol := 0
					l_nextline_idx := 0
					l_spell_attr := 0
					l_word_end := 0
					l_cur_checked_col := 0
					l_multi_attr := 0
					l_mb_l := 1
					l_mb_c := 0
					l_mb_utf8 := 0
					l_diff_hlf := {PC_HLF_T}.HLF_8
					l_change_start___0.item := 2_147_483_647
					l_change_end___0.item := -1
					l_trailcol := (2_147_483_647).to_integer_32
					l_need_showbreak := 0
					l_line_attr := 0
					l_did_line_attr := 0
					l_draw_state := 0
					l_feedback_col := 0
					l_feedback_old_attr := -1
					if a_startrow > a_endrow then
						Result := a_startrow
						js.return
					end
					if js.return_called then
						l_pos := -1 + 317 -- skip if block
					end
				when 1 then -- if:
						l_row := a_startrow
						l_screen_row := l_row + a_wp___0.item.w_winrow
						l_extra_check := a_wp___0.item.w_onebuf_opt.wo_lbr
						if (syntax_inst.syntax_present (a_wp___0)).to_boolean then
							if not ((a_wp___0.item.w_s).item.b_syn_error).to_boolean then
								l_save_did_emsg := globals_inst.did_emsg
								globals_inst.did_emsg := 0
								syntax_inst.syntax_start (a_wp___0, a_lnum)
								if globals_inst.did_emsg.to_boolean then
									(a_wp___0.item.w_s).item.b_syn_error := 1
								else
									globals_inst.did_emsg := l_save_did_emsg
									l_has_syntax := 1
									l_extra_check := 1
								end
							end
						end
						l_color_cols.item := a_wp___0.item.w_p_cc_cols
						if not (l_color_cols.item).is_void then
							l_draw_color_col := advance_color_col (l_vcol.to_integer_32, l_color_cols)
						end
						if (a_wp___0.item.w_onebuf_opt.wo_spell).to_boolean then
							if (((a_wp___0.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
								if (a_wp___0.item.w_s).item.b_langp.ga_len > 0 then
									if not ((create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((a_wp___0.item.w_s).item.b_langp.ga_data)).item).is_void then
										l_has_spell := 1
										l_extra_check := 1
										l_nextline[150] := (('%/0/').code).to_natural_8
										if a_lnum < (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
											l_line := memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum + 1, 0)
											spell_inst.spell_cat_line (l_nextline + 150, l_line, 150)
										end
										if a_lnum = checked_lnum then
											l_cur_checked_col := checked_col
										end
										checked_lnum := (0).to_integer_32
										if a_lnum /= capcol_lnum then
											cap_col.item := -1
										end
										if a_lnum = 1 then
											cap_col.item := 0
										end
										capcol_lnum := (0).to_integer_32
									end
								end
							end
						end
						l_fromcol.item := -10
						l_tocol.item := 2_147_483_647
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 2 then -- if:
						if not ((a_wp___0.item.w_buffer).is_equal (globals_inst.curwin.item.w_buffer)) then
							l_pos := -1 + 18 -- skip if block
						end
				when 3 then -- if:
						if globals_inst.curwin.item.w_cursor.lnum /= globals_inst.VIsual.item.lnum then
							l_tmp___1 := (globals_inst.curwin.item.w_cursor.lnum < globals_inst.VIsual.item.lnum).to_integer
						else
							if globals_inst.curwin.item.w_cursor.col /= globals_inst.VIsual.item.col then
								l_tmp___0 := (globals_inst.curwin.item.w_cursor.col < globals_inst.VIsual.item.col).to_integer
							else
								l_tmp___0 := (globals_inst.curwin.item.w_cursor.coladd < globals_inst.VIsual.item.coladd).to_integer
							end
							l_tmp___1 := l_tmp___0
						end
						if l_tmp___1.to_boolean then
							l_top := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							l_bot := globals_inst.VIsual
						elseif globals_inst.curwin.item.w_cursor.lnum = globals_inst.VIsual.item.lnum then
							if globals_inst.curwin.item.w_cursor.col = globals_inst.VIsual.item.col then
								if globals_inst.curwin.item.w_cursor.coladd = globals_inst.VIsual.item.coladd then
									l_top := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
									l_bot := globals_inst.VIsual
								else
									l_top := globals_inst.VIsual
									l_bot := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
								end
							else
								l_top := globals_inst.VIsual
								l_bot := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							end
						else
							l_top := globals_inst.VIsual
							l_bot := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
						end
						if a_lnum >= l_top.item.lnum then
							if a_lnum <= l_bot.item.lnum then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						l_lnum_in_visual_area := l_tmp___2
						if globals_inst.VIsual_mode /= 22 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_lnum_in_visual_area.to_boolean then
							l_fromcol.item := a_wp___0.item.w_old_cursor_fcol
							l_tocol.item := a_wp___0.item.w_old_cursor_lcol
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if not (a_lnum > l_top.item.lnum) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_lnum <= l_bot.item.lnum then
							l_fromcol.item := 0
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if a_lnum = l_top.item.lnum then
							if globals_inst.VIsual_mode = 86 then
								l_fromcol.item := 0
							else
								charset_inst.getvvcol (a_wp___0, l_top, l_fromcol, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								if (misc1_inst.gchar_pos (l_top)) = 0 then
									l_tocol.item := l_fromcol.item + 1
								end
							end
						end
				when 10 then
						if globals_inst.VIsual_mode = 86 then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if a_lnum /= l_bot.item.lnum then
							l_pos := -1 + 16 -- skip if block
						end
				when 12 then -- if:
						if (option_inst.p_sel.item.item).to_integer_32 /= 101 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_bot.item.col = 0 then
							if l_bot.item.coladd = 0 then
								l_fromcol.item := -10
								l_tocol.item := 2_147_483_647
							else
								l_pos := -1 + 15 -- goto _L___1
							end
						else
							l_pos := -1 + 15 -- goto _L___1
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L___1:
						if (l_bot.item.col).to_integer_32 = 2_147_483_647 then
							l_tocol.item := 2_147_483_647
						else
							l_pos___3.item := (l_bot.item).twin
							if (option_inst.p_sel.item.item).to_integer_32 = 101 then
								charset_inst.getvvcol (a_wp___0, l_pos___3, l_tocol, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							else
								charset_inst.getvvcol (a_wp___0, l_pos___3, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_tocol)
								l_tocol.item := l_tocol.item + 1
							end
						end
				when 16 then -- if done | if done | if done
						if not globals_inst.highlight_match.to_boolean then
							if a_lnum = globals_inst.curwin.item.w_cursor.lnum then
								if a_wp___0.is_equal (globals_inst.curwin) then
									if not (gui_inst.gui.item.in_use).to_boolean then
										l_noinvcur := 1
									end
								end
							end
						end
						if l_fromcol.item >= 0 then
							l_area_highlighting := 1
							l_attr := globals_inst.highlight_attr[15]
							if (globals_inst.clip_star.item.available).to_boolean then
								if not (globals_inst.clip_star.item.owned).to_boolean then
									if (ui_inst.clip_isautosel).to_boolean then
										l_attr := globals_inst.highlight_attr[16]
									end
								end
							end
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 20 -- goto _L___2
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L___2:
						if globals_inst.highlight_match.to_boolean then
							if a_wp___0.is_equal (globals_inst.curwin) then
								if a_lnum >= globals_inst.curwin.item.w_cursor.lnum then
									if a_lnum <= globals_inst.curwin.item.w_cursor.lnum + globals_inst.search_match_lines then
										if a_lnum = globals_inst.curwin.item.w_cursor.lnum then
											charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_fromcol, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
										else
											l_fromcol.item := 0
										end
										if a_lnum = globals_inst.curwin.item.w_cursor.lnum + globals_inst.search_match_lines then
											l_pos___3.item.lnum := a_lnum
											l_pos___3.item.col := globals_inst.search_match_endcol
											charset_inst.getvcol (globals_inst.curwin, l_pos___3, l_tocol, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
										else
											l_tocol.item := 2_147_483_647
										end
										if l_fromcol.item = l_tocol.item then
											l_tocol.item := l_fromcol.item + 1
										end
										l_area_highlighting := 1
										l_attr := globals_inst.highlight_attr[5]
									end
								end
							end
						end
				when 21 then
						l_filler_lines := diff_inst.diff_check (a_wp___0, a_lnum)
						if l_filler_lines < 0 then
							if l_filler_lines = -1 then
								if (diff_inst.diff_find_change (a_wp___0, a_lnum, l_change_start___0, l_change_end___0)).to_boolean then
									l_diff_hlf := {PC_HLF_T}.HLF_ADD
								elseif l_change_start___0.item = 0 then
									l_diff_hlf := {PC_HLF_T}.HLF_TXD
								else
									l_diff_hlf := {PC_HLF_T}.HLF_CHD
								end
							else
								l_diff_hlf := {PC_HLF_T}.HLF_ADD
							end
							l_filler_lines := 0
							l_area_highlighting := 1
						end
						if a_lnum = a_wp___0.item.w_topline then
							l_filler_lines := a_wp___0.item.w_topfill
						end
						l_filler_todo := l_filler_lines
						l_v := (buffer_inst.buf_getsigntype (a_wp___0.item.w_buffer, a_lnum, 1)).to_integer_32
						if l_v /= 0 then
							l_line_attr := ex_cmds_inst.sign_get_attr (l_v.to_integer_32, 1)
						end
						if (quickfix_inst.bt_quickfix (a_wp___0.item.w_buffer)).to_boolean then
							if (quickfix_inst.qf_current_entry (a_wp___0)) = a_lnum then
								l_line_attr := globals_inst.highlight_attr[6]
							end
						end
						if l_line_attr /= 0 then
							l_area_highlighting := 1
						end
						l_line := memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum, 0)
						l_ptr := l_line
						if l_has_spell.to_boolean then
							if cap_col.item = 0 then
								cap_col.item := (charset_inst.skipwhite (l_line)).distance (l_line)
							end
							if (l_nextline[150]).to_integer_32 = 0 then
								l_nextlinecol := 2_147_483_647
								l_nextline_idx := 0
							else
								l_v := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32
								if l_v < 150 then
									l_nextlinecol := 0
									memmove (create {CE_POINTER [ANY]}.make_cast (l_nextline), create {CE_POINTER [ANY]}.make_cast (l_line), l_v.to_natural_32).do_nothing
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_nextline + l_v)), create {CE_POINTER [ANY]}.make_cast ((l_nextline + 150)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_nextline + 150)))) + {NATURAL_32} 1).do_nothing
									l_nextline_idx := (l_v + 1).to_integer_32
								else
									l_nextlinecol := (l_v - 150).to_integer_32
									memmove (create {CE_POINTER [ANY]}.make_cast (l_nextline), create {CE_POINTER [ANY]}.make_cast ((l_line + l_nextlinecol)), (150).to_natural_32).do_nothing
									l_nextline_idx := 151
								end
							end
						end
						if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
							if (globals_inst.lcs_trail.item).to_boolean then
								l_trailcol := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))).to_integer_32
								from
								until
									js.loop_done
								loop
									if l_trailcol > 0 then
										if (l_ptr[(l_trailcol - 1)]).to_integer_32 /= 32 then
											if (l_ptr[(l_trailcol - 1)]).to_integer_32 /= 9 then
												js.break
											end
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_trailcol := l_trailcol - 1
									end
								end
								l_trailcol := l_trailcol + (l_ptr.distance (l_line))
								l_extra_check := 1
							end
						end
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_v := (a_wp___0.item.w_skipcol).to_integer_32
						else
							l_v := (a_wp___0.item.w_leftcol).to_integer_32
						end
						if l_v > 0 then
							l_prev_ptr := l_ptr
							from
							until
								js.loop_done
							loop
								if l_vcol < l_v then
									if (l_ptr.item).to_integer_32 = 0 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_c := charset_inst.win_lbr_chartabsize (a_wp___0, l_ptr, l_vcol.to_integer_32, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
									l_vcol := l_vcol + l_c.to_integer_32
									l_prev_ptr := l_ptr
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___14 := (globals_inst.mb_ptr2len.integer_32_item ([l_ptr]))
									else
										l_tmp___14 := 1
									end
									l_ptr := l_ptr + l_tmp___14
								end
							end
							if l_vcol < l_v then
								if (a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean then
									l_vcol := l_v
								elseif l_draw_color_col.to_boolean then
									l_vcol := l_v
								elseif (misc2_inst.virtual_active).to_boolean then
									l_vcol := l_v
								elseif globals_inst.VIsual_active.to_boolean then
									if (a_wp___0.item.w_buffer).is_equal (globals_inst.curwin.item.w_buffer) then
										l_vcol := l_v
									end
								end
							end
							if l_vcol > l_v then
								l_vcol := l_vcol - l_c.to_integer_32
								l_ptr := l_prev_ptr
								l_n_skip := (l_v - l_vcol).to_integer_32
							end
							if (l_tocol.item).to_integer_32 <= l_vcol then
								l_fromcol.item := 0
							elseif l_fromcol.item >= 0 then
								if (l_fromcol.item).to_integer_32 < l_vcol then
									l_fromcol.item := l_vcol.to_integer_32
								end
							end
							if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
								l_need_showbreak := 1
							end
							if l_has_spell.to_boolean then
								l_linecol := l_ptr.distance (l_line)
								l_spell_hlf.item := {PC_HLF_T}.HLF_COUNT
								l_pos___3.item := (a_wp___0.item.w_cursor).twin
								a_wp___0.item.w_cursor.lnum := a_lnum
								a_wp___0.item.w_cursor.col := l_linecol
								l_len := spell_inst.spell_move_to (a_wp___0, 1, 1, 1, l_spell_hlf)
								l_line := memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum, 0)
								l_ptr := l_line + l_linecol
								if l_len = 0 then
									l_spell_hlf.item := {PC_HLF_T}.HLF_COUNT
									l_tmp___16 := spell_inst.spell_to_word_end (l_ptr, a_wp___0)
									l_word_end := (l_tmp___16.distance (l_line)) + 1
								elseif a_wp___0.item.w_cursor.col > l_ptr.distance (l_line) then
									l_spell_hlf.item := {PC_HLF_T}.HLF_COUNT
									l_tmp___16 := spell_inst.spell_to_word_end (l_ptr, a_wp___0)
									l_word_end := (l_tmp___16.distance (l_line)) + 1
								else
									l_word_end := (a_wp___0.item.w_cursor.col + l_len) + 1
									if l_spell_hlf.item /= {NATURAL_32} 41 then
										l_spell_attr := globals_inst.highlight_attr[(l_spell_hlf.item).to_integer_32]
									end
								end
								a_wp___0.item.w_cursor := (l_pos___3.item).twin
								if l_has_syntax.to_boolean then
									syntax_inst.syntax_start (a_wp___0, a_lnum)
								end
							end
						end
						if l_fromcol.item >= 0 then
							if l_noinvcur.to_boolean then
								if l_fromcol.item = a_wp___0.item.w_virtcol then
									l_fromcol_prev := l_fromcol.item
									l_fromcol.item := -1
								elseif l_fromcol.item < a_wp___0.item.w_virtcol then
									l_fromcol_prev := a_wp___0.item.w_virtcol
								end
							end
							if l_fromcol.item >= l_tocol.item then
								l_fromcol.item := -1
							end
						end
						l_cur := a_wp___0.item.w_match_head
						l_shl_flag := 0
						from
						until
							js.loop_done
						loop
							if l_cur.is_void then
								if l_shl_flag /= 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								if l_shl_flag = 0 then
									l_shl := search_hl
									l_shl_flag := 1
								else
									l_shl := create {CE_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
								end
								l_shl.item.startcol := (2_147_483_647).to_integer_32
								l_shl.item.endcol := (2_147_483_647).to_integer_32
								l_shl.item.attr_cur := 0
								if not (l_shl.item.rm.regprog).is_void then
									l_v := (l_ptr.distance (l_line)).to_integer_32
									next_search_hl (a_wp___0, l_shl, a_lnum, l_v.to_integer_32)
									l_line := memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum, 0)
									l_ptr := l_line + l_v
									if l_shl.item.lnum /= 0 then
										if l_shl.item.lnum <= a_lnum then
											if l_shl.item.lnum = a_lnum then
												l_shl.item.startcol := l_shl.item.rm.startpos[0].col
											else
												l_shl.item.startcol := 0
											end
											if a_lnum = (l_shl.item.lnum + l_shl.item.rm.endpos[0].lnum) - l_shl.item.rm.startpos[0].lnum then
												l_shl.item.endcol := l_shl.item.rm.endpos[0].col
											else
												l_shl.item.endcol := (2_147_483_647).to_integer_32
											end
											if l_shl.item.startcol = l_shl.item.endcol then
												if globals_inst.has_mbyte.to_boolean then
													if (l_line[l_shl.item.endcol]).to_integer_32 /= 0 then
														l_shl.item.endcol := l_shl.item.endcol + (globals_inst.mb_ptr2len.integer_32_item ([l_line + l_shl.item.endcol]))
													else
														l_shl.item.endcol := (l_shl.item.endcol) + 1
													end
												else
													l_shl.item.endcol := (l_shl.item.endcol) + 1
												end
											end
											if (l_shl.item.startcol).to_integer_32 < l_v then
												l_shl.item.attr_cur := l_shl.item.attr
												l_search_attr := l_shl.item.attr
											end
											l_area_highlighting := 1
										end
									end
								end
								if not l_shl.is_equal (search_hl) then
									if not l_cur.is_void then
										l_cur := l_cur.item.next
									end
								end
							end
						end
						if (a_wp___0.item.w_onebuf_opt.wo_cul).to_boolean then
							if a_lnum = a_wp___0.item.w_cursor.lnum then
								if not globals_inst.VIsual_active.to_boolean then
									l_line_attr := globals_inst.highlight_attr[39]
									l_area_highlighting := 1
								end
							end
						end
						l_off___0 := (current_ScreenLine.distance (globals_inst.ScreenLines)).to_natural_32
						l_col := 0
				when 22 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 316 -- skip loop
						end
				when 23 then -- loop body:
						if l_draw_state = 6 then
							l_pos := -1 + 45 -- skip if block
						end
				when 24 then -- if:
						if l_draw_state = 0 then
							if l_n_extra = 0 then
								l_draw_state := 1
								if globals_inst.cmdwin_type /= 0 then
									if a_wp___0.is_equal (globals_inst.curwin) then
										l_n_extra := 1
										l_c_extra := globals_inst.cmdwin_type
										l_char_attr := globals_inst.highlight_attr[1]
									end
								end
							end
						end
						if l_draw_state = 1 then
							if l_n_extra = 0 then
								l_draw_state := 2
								if a_wp___0.item.w_onebuf_opt.wo_fdc > 0 then
									fill_foldcolumn (l_extra, a_wp___0, 0, a_lnum)
									l_n_extra := (a_wp___0.item.w_onebuf_opt.wo_fdc).to_integer_32
									l_p_extra.item := l_extra
									l_p_extra.item[l_n_extra] := (('%/0/').code).to_natural_8
									l_c_extra := ('%/0/').code
									l_char_attr := globals_inst.highlight_attr[20]
								end
							end
						end
						if l_draw_state /= 2 then
							l_pos := -1 + 33 -- skip if block
						end
				when 25 then -- if:
						if l_n_extra /= 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 26 then -- if:
						l_draw_state := 3
						if not ((draw_signcolumn (a_wp___0)).to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 27 then -- if:
						if not (l_filler_todo <= 0) then
							l_pos := -1 + 33 -- skip if block
						end
				when 28 then -- if:
						l_c_extra := (' ').code
						l_char_attr := globals_inst.highlight_attr[26]
						l_n_extra := 2
						if l_row /= a_startrow then
							l_pos := -1 + 33 -- skip if block
						end
				when 29 then -- if:
						l_text_sign := (buffer_inst.buf_getsigntype (a_wp___0.item.w_buffer, a_lnum, 3)).to_natural_32
						l_icon_sign := (buffer_inst.buf_getsigntype (a_wp___0.item.w_buffer, a_lnum, 2)).to_natural_32
						if not ((gui_inst.gui.item.in_use).to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if l_icon_sign /= {NATURAL_32} 0 then
							l_c_extra := 1
							if (buffer_inst.buf_signcount (a_wp___0.item.w_buffer, a_lnum)) > 1 then
								l_c_extra := 2
							end
							l_char_attr := l_icon_sign.to_integer_32
						else
							l_pos := -1 + 32 -- goto _L___3
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else: | _L___3:
						if l_text_sign /= {NATURAL_32} 0 then
							l_p_extra.item := ex_cmds_inst.sign_get_text (l_text_sign.to_integer_32)
							if not (l_p_extra.item).is_void then
								l_c_extra := ('%/0/').code
								l_n_extra := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p_extra.item))).to_integer_32
							end
							l_char_attr := ex_cmds_inst.sign_get_attr (l_text_sign.to_integer_32, 0)
						end
				when 33 then -- if done | if done | if done | if done | if done
						if l_draw_state /= 3 then
							l_pos := -1 + 44 -- skip if block
						end
				when 34 then -- if:
						if l_n_extra /= 0 then
							l_pos := -1 + 44 -- skip if block
						end
				when 35 then -- if:
						l_draw_state := 4
						if not ((a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_pos := -1 + 39 -- goto _L___5
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 38 then -- else:
						if not ((a_wp___0.item.w_onebuf_opt.wo_rnu).to_boolean) then
							l_pos := -1 + 44 -- skip if block
						end
				when 39 then -- if: | _L___5:
						if l_row /= a_startrow + l_filler_lines then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 43 -- goto _L___4
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 42 then -- else:
						if not ((misc2_inst.vim_strchr (option_inst.p_cpo.item, ('n').code)).is_void) then
							l_pos := -1 + 44 -- skip if block
						end
				when 43 then -- if: | _L___4:
						if l_row = a_startrow + l_filler_lines then
							if (a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean then
								l_num := a_lnum
							else
								l_num := (abs ((misc2_inst.get_cursor_rel_lnum (a_wp___0, a_lnum)).to_integer_32)).to_integer_32
							end
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_extra), ce_string ("%%*ld "), (number_width (a_wp___0)), l_num]).do_nothing
							if a_wp___0.item.w_skipcol > 0 then
								l_p_extra.item := l_extra
								from
								until
									(l_p_extra.item.item).to_integer_32 /= 32
								loop
									l_p_extra.item.item := (('-').code).to_natural_8
									l_p_extra.item := l_p_extra.item + 1
								end
							end
							l_p_extra.item := l_extra
							l_c_extra := ('%/0/').code
						else
							l_c_extra := (' ').code
						end
						l_n_extra := (number_width (a_wp___0)) + 1
						l_char_attr := globals_inst.highlight_attr[9]
						if (a_wp___0.item.w_onebuf_opt.wo_cul).to_boolean then
							if a_lnum = a_wp___0.item.w_cursor.lnum then
								l_char_attr := syntax_inst.hl_combine_attr (globals_inst.highlight_attr[39], l_char_attr)
							end
						end
				when 44 then -- if done | if done | if done | if done | if done
						if l_draw_state = 4 then
							if l_n_extra = 0 then
								l_draw_state := 5
								if l_filler_todo > 0 then
									if (charset_inst.char2cells (globals_inst.fill_diff.item)) > 1 then
										l_c_extra := ('-').code
									else
										l_c_extra := globals_inst.fill_diff.item
									end
									l_n_extra := a_wp___0.item.w_width - l_col
									l_char_attr := globals_inst.highlight_attr[23]
								end
								if (option_inst.p_sbr.item.item).to_integer_32 /= 0 then
									if l_need_showbreak.to_boolean then
										l_p_extra.item := option_inst.p_sbr.item
										l_c_extra := ('%/0/').code
										l_n_extra := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_sbr.item))).to_integer_32
										l_char_attr := globals_inst.highlight_attr[1]
										l_need_showbreak := 0
										if (l_tocol.item).to_integer_32 = l_vcol then
											l_tocol.item := l_tocol.item + l_n_extra
										end
									end
								end
							end
						end
						if l_draw_state = 5 then
							if l_n_extra = 0 then
								l_draw_state := 6
								if l_saved_n_extra.to_boolean then
									l_n_extra := l_saved_n_extra
									l_c_extra := l_saved_c_extra
									l_p_extra.item := l_saved_p_extra
									l_char_attr := l_saved_char_attr
								else
									l_char_attr := 0
								end
							end
						end
				when 45 then -- if done
						if globals_inst.dollar_vcol /= 0 then
							if a_wp___0.is_equal (globals_inst.curwin) then
								if a_lnum = a_wp___0.item.w_cursor.lnum then
									if l_vcol >= (a_wp___0.item.w_virtcol).to_integer_32 then
										if l_filler_todo <= 0 then
											screen_line (l_screen_row, a_wp___0.item.w_wincol, l_col, -a_wp___0.item.w_width)
											if (a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean then
												l_row := a_wp___0.item.w_cline_row + a_wp___0.item.w_cline_height
											else
												l_row := a_wp___0.item.w_height
											end
											js.break
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 255 -- skip if block
						end
				when 46 then -- if:
						if l_draw_state /= 6 then
							l_pos := -1 + 102 -- skip if block
						end
				when 47 then -- if:
						if not (l_area_highlighting.to_boolean) then
							l_pos := -1 + 102 -- skip if block
						end
				when 48 then -- if:
						if l_vcol /= (l_fromcol.item).to_integer_32 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_area_attr := l_attr
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 51 then -- else:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						if l_vcol + 1 = (l_fromcol.item).to_integer_32 then
							if l_n_extra = 0 then
								if (globals_inst.mb_ptr2cells.integer_32_item ([l_ptr])) > 1 then
									l_area_attr := l_attr
								else
									l_pos := -1 + 54 -- goto _L___10
								end
							else
								l_pos := -1 + 54 -- goto _L___10
							end
						else
							l_pos := -1 + 54 -- goto _L___10
						end
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 54 then -- else: | _L___10:
						if l_vcol_prev.to_integer_32 /= l_fromcol_prev then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if l_vcol_prev < l_vcol then
							if l_vcol < (l_tocol.item).to_integer_32 then
								l_area_attr := l_attr
							else
								l_pos := -1 + 57 -- goto _L___7
							end
						else
							l_pos := -1 + 57 -- goto _L___7
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else: | _L___7:
						if l_area_attr /= 0 then
							if l_vcol = (l_tocol.item).to_integer_32 then
								l_area_attr := 0
							elseif l_noinvcur.to_boolean then
								if l_vcol.to_integer_32 = a_wp___0.item.w_virtcol then
									l_area_attr := 0
								end
							end
						end
				when 58 then -- if done | if done
						if l_n_extra.to_boolean then
							l_pos := -1 + 89 -- skip if block
						end
				when 59 then -- if:
						l_v := (l_ptr.distance (l_line)).to_integer_32
						l_cur := a_wp___0.item.w_match_head
						l_shl_flag := 0
				when 60 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 77 -- skip loop
						end
				when 61 then -- loop body:
						if l_cur.is_void then
							if l_shl_flag /= 0 then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 76 -- skip if block
						end
				when 62 then -- if:
						if l_shl_flag /= 0 then
							l_pos := -1 + 68 -- skip if block
						end
				when 63 then -- if:
						if l_cur.is_void then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if l_cur.item.priority > 0 then
							l_shl := search_hl
							l_shl_flag := 1
						else
							l_pos := -1 + 66 -- goto _L___11
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else: | _L___11:
						if l_cur.is_void then
							l_shl := search_hl
							l_shl_flag := 1
						else
							l_shl := create {CE_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
						end
				when 67 then -- if done | if block done, skip else block:
						l_pos := -1 + 69
				when 68 then -- else:
						l_shl := create {CE_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
				when 69 then
						if not (not js.loop_done and then (not (l_shl.item.rm.regprog).is_void)) then
							l_pos := -1 + 75 -- skip loop
						end
				when 70 then -- loop body:
						if (l_shl.item.startcol).to_integer_32 = 2_147_483_647 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						if l_v >= (l_shl.item.startcol).to_integer_32 then
							if l_v < (l_shl.item.endcol).to_integer_32 then
								l_shl.item.attr_cur := l_shl.item.attr
							else
								l_pos := -1 + 73 -- goto _L___13
							end
						else
							l_pos := -1 + 73 -- goto _L___13
						end
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 73 then -- else: | _L___13:
						if l_v = (l_shl.item.endcol).to_integer_32 then
							l_shl.item.attr_cur := 0
							next_search_hl (a_wp___0, l_shl, a_lnum, l_v.to_integer_32)
							l_line := memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum, 0)
							l_ptr := l_line + l_v
							if l_shl.item.lnum = a_lnum then
								l_shl.item.startcol := l_shl.item.rm.startpos[0].col
								if l_shl.item.rm.endpos[0].lnum = 0 then
									l_shl.item.endcol := l_shl.item.rm.endpos[0].col
								else
									l_shl.item.endcol := (2_147_483_647).to_integer_32
								end
								if l_shl.item.startcol = l_shl.item.endcol then
									if globals_inst.has_mbyte.to_boolean then
										l_shl.item.endcol := l_shl.item.endcol + (globals_inst.mb_ptr2len.integer_32_item ([l_line + l_shl.item.endcol]))
									else
										l_shl.item.endcol := (l_shl.item.endcol) + 1
									end
								end
								js.continue
							end
						end
				when 74 then
						if not js.loop_jumped then
							js.break
						end
						l_pos := -1 + 69 -- back to loop condition
				when 75 then -- loop done
						if not l_shl.is_equal (search_hl) then
							if not l_cur.is_void then
								l_cur := l_cur.item.next
							end
						end
				when 76 then -- if done
						l_pos := -1 + 60 -- back to loop condition
				when 77 then -- loop done
						l_search_attr := search_hl.item.attr_cur
						l_cur := a_wp___0.item.w_match_head
						l_shl_flag := 0
				when 78 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 89 -- skip loop
						end
				when 79 then -- loop body:
						if l_cur.is_void then
							if l_shl_flag /= 0 then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 88 -- skip if block
						end
				when 80 then -- if:
						if l_shl_flag /= 0 then
							l_pos := -1 + 86 -- skip if block
						end
				when 81 then -- if:
						if l_cur.is_void then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if l_cur.item.priority > 0 then
							l_shl := search_hl
							l_shl_flag := 1
						else
							l_pos := -1 + 84 -- goto _L___14
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else: | _L___14:
						if l_cur.is_void then
							l_shl := search_hl
							l_shl_flag := 1
						else
							l_shl := create {CE_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
						end
				when 85 then -- if done | if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else:
						l_shl := create {CE_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
				when 87 then
						if l_shl.item.attr_cur /= 0 then
							l_search_attr := l_shl.item.attr_cur
						end
						if not l_shl.is_equal (search_hl) then
							if not l_cur.is_void then
								l_cur := l_cur.item.next
							end
						end
				when 88 then -- if done
						l_pos := -1 + 78 -- back to loop condition
				when 89 then -- loop done | if done
						if l_diff_hlf /= ({PC_HLF_T}.HLF_8) then
							if l_diff_hlf = {NATURAL_32} 22 then
								if l_ptr.distance (l_line) >= l_change_start___0.item then
									if l_n_extra = 0 then
										l_diff_hlf := {PC_HLF_T}.HLF_TXD
									end
								end
							end
							if l_diff_hlf = {NATURAL_32} 24 then
								if l_ptr.distance (l_line) > l_change_end___0.item then
									if l_n_extra = 0 then
										l_diff_hlf := {PC_HLF_T}.HLF_CHD
									end
								end
							end
							l_line_attr := globals_inst.highlight_attr[l_diff_hlf.to_integer_32]
						end
						l_attr_pri := 1
						if l_area_attr = 0 then
							l_pos := -1 + 92 -- skip if block
						end
				when 90 then -- if:
						l_char_attr := l_area_attr
				when 91 then -- if block done, skip else block:
						l_pos := -1 + 102
				when 92 then -- else:
						if l_search_attr = 0 then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						l_char_attr := l_search_attr
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 102
				when 95 then -- else:
						if l_line_attr = 0 then
							l_pos := -1 + 101 -- skip if block
						end
				when 96 then -- if:
						if l_fromcol.item /= -10 then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						if (l_tocol.item).to_integer_32 = 2_147_483_647 then
							l_char_attr := l_line_attr
						else
							l_pos := -1 + 99 -- goto _L___16
						end
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 99 then -- else: | _L___16:
						if l_vcol < (l_fromcol.item).to_integer_32 then
							l_char_attr := l_line_attr
						elseif l_vcol_prev < l_fromcol_prev.to_integer_32 then
							l_char_attr := l_line_attr
						elseif l_vcol >= (l_tocol.item).to_integer_32 then
							l_char_attr := l_line_attr
						else
							l_pos := -1 + 101 -- goto _L___15
						end
				when 100 then -- if done | if block done, skip else block:
						l_pos := -1 + 102
				when 101 then -- else: | _L___15:
						l_attr_pri := 0
						if l_has_syntax.to_boolean then
							l_char_attr := l_syntax_attr
						else
							l_char_attr := 0
						end
				when 102 then -- if done | if done | if done | if done
						if not (l_n_extra > 0) then
							l_pos := -1 + 105 -- skip if block
						end
				when 103 then -- if:
						if l_c_extra /= 0 then
							l_c := l_c_extra
							l_mb_c := l_c
							if globals_inst.enc_utf8.to_boolean then
								if (globals_inst.mb_char2len.integer_32_item ([l_c])) > 1 then
									l_mb_utf8 := 1
									l_u8cc[0] := 0
									l_c := 192
								else
									l_mb_utf8 := 0
								end
							else
								l_mb_utf8 := 0
							end
						else
							l_c := (l_p_extra.item.item).to_integer_32
							if globals_inst.has_mbyte.to_boolean then
								l_mb_c := l_c
								if globals_inst.enc_utf8.to_boolean then
									l_mb_l := globals_inst.mb_ptr2len.integer_32_item ([l_p_extra.item])
									l_mb_utf8 := 0
									if l_mb_l > l_n_extra then
										l_mb_l := 1
									elseif l_mb_l > 1 then
										l_mb_c := mbyte_inst.utfc_ptr2char (l_p_extra.item, l_u8cc)
										l_mb_utf8 := 1
										l_c := 192
									end
								else
									l_mb_l := (globals_inst.mb_bytelen_tab[l_c]).to_integer_32
									if l_mb_l >= l_n_extra then
										l_mb_l := 1
									elseif l_mb_l > 1 then
										l_mb_c := ((l_c).bit_shift_left (8)) + (l_p_extra.item[1]).to_integer_32
									end
								end
								if l_mb_l = 0 then
									l_mb_l := 1
								end
								if l_col >= a_wp___0.item.w_width - 1 then
									if (globals_inst.mb_char2cells.integer_32_item ([l_mb_c])) = 2 then
										l_c := ('>').code
										l_mb_c := l_c
										l_mb_l := 1
										l_mb_utf8 := 0
										l_multi_attr := globals_inst.highlight_attr[1]
										l_n_extra := l_n_extra + 1
										l_p_extra.item := l_p_extra.item - 1
									else
										l_n_extra := l_n_extra - (l_mb_l - 1)
										l_p_extra.item := l_p_extra.item + (l_mb_l - 1)
									end
								else
									l_n_extra := l_n_extra - (l_mb_l - 1)
									l_p_extra.item := l_p_extra.item + (l_mb_l - 1)
								end
							end
							l_p_extra.item := l_p_extra.item + 1
						end
						l_n_extra := l_n_extra - 1
				when 104 then -- if block done, skip else block:
						l_pos := -1 + 196
				when 105 then -- else:
						l_c := (l_ptr.item).to_integer_32
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 127 -- skip if block
						end
				when 106 then -- if:
						l_mb_c := l_c
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 121 -- skip if block
						end
				when 107 then -- if:
						l_mb_l := globals_inst.mb_ptr2len.integer_32_item ([l_ptr])
						l_mb_utf8 := 0
						if l_mb_l > 1 then
							l_mb_c := mbyte_inst.utfc_ptr2char (l_ptr, l_u8cc)
							if l_mb_c < 128 then
								l_c := l_mb_c
							end
							l_mb_utf8 := 1
							if (mbyte_inst.utf_iscomposing (l_mb_c)).to_boolean then
								l_i___0 := globals_inst.Screen_mco - 1
								from
								until
									not (l_i___0 > 0)
								loop
									l_u8cc[l_i___0] := l_u8cc[l_i___0 - 1]
									l_i___0 := l_i___0 - 1
								end
								l_u8cc[0] := l_mb_c
								l_mb_c := (' ').code
							end
						end
						if l_mb_l /= 1 then
							l_pos := -1 + 110 -- skip if block
						end
				when 108 then -- if:
						if l_c >= 128 then
							l_pos := -1 + 117 -- goto _L___17
						else
							l_pos := -1 + 110 -- goto _L___20
						end
				when 109 then -- if block done, skip else block:
						l_pos := -1 + 120
				when 110 then -- else: | _L___20:
						if not (l_mb_l >= 1) then
							l_pos := -1 + 113 -- skip if block
						end
				when 111 then -- if:
						if l_mb_c = 0 then
							l_pos := -1 + 117 -- goto _L___17
						else
							l_pos := -1 + 113 -- goto _L___19
						end
				when 112 then -- if block done, skip else block:
						l_pos := -1 + 120
				when 113 then -- else: | _L___19:
						if not (l_mb_l > 1) then
							l_pos := -1 + 119 -- skip if block
						end
				when 114 then -- if:
						if not ((charset_inst.vim_isprintc (l_mb_c)).to_boolean) then
							l_pos := -1 + 117 -- skip if block
						end
				when 115 then -- if:
						l_pos := -1 + 119 -- goto _L___18
				when 116 then -- if block done, skip else block:
						l_pos := -1 + 118
				when 117 then -- else: | _L___17:
						charset_inst.transchar_hex (l_extra, l_mb_c)
						l_p_extra.item := l_extra
						l_c := (l_p_extra.item.item).to_integer_32
						l_mb_c := mbyte_inst.mb_ptr2char_adv (l_p_extra)
						l_mb_utf8 := (l_c >= 128).to_integer
						l_n_extra := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p_extra.item))).to_integer_32
						l_c_extra := ('%/0/').code
						if l_area_attr = 0 then
							if l_search_attr = 0 then
								l_n_attr := l_n_extra + 1
								l_extra_attr := globals_inst.highlight_attr[0]
								l_saved_attr2 := l_char_attr
							end
						end
				when 118 then -- if done | if block done, skip else block:
						l_pos := -1 + 120
				when 119 then -- else: | _L___18:
						if l_mb_l = 0 then
							l_mb_l := 1
						end
				when 120 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 122
				when 121 then -- else:
						l_mb_l := (globals_inst.mb_bytelen_tab[l_c]).to_integer_32
						if l_mb_l = 0 then
							l_mb_l := 1
						elseif l_mb_l > 1 then
							if (l_ptr[1]).to_integer_32 >= 32 then
								l_mb_c := ((l_c).bit_shift_left (8)) + (l_ptr[1]).to_integer_32
							else
								if (l_ptr[1]).to_integer_32 = 0 then
									l_mb_l := 1
									charset_inst.transchar_nonprint (l_extra, l_c)
								else
									l_mb_l := 2
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_extra), ce_string ("XX")).do_nothing
								end
								l_p_extra.item := l_extra
								l_n_extra := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_extra))).to_integer_32 - 1
								l_c_extra := ('%/0/').code
								l_tmp___38 := l_p_extra.item
								l_p_extra.item := l_p_extra.item + 1
								l_c := (l_tmp___38.item).to_integer_32
								if l_area_attr = 0 then
									if l_search_attr = 0 then
										l_n_attr := l_n_extra + 1
										l_extra_attr := globals_inst.highlight_attr[0]
										l_saved_attr2 := l_char_attr
									end
								end
								l_mb_c := l_c
							end
						end
				when 122 then
						if not (l_col >= a_wp___0.item.w_width - 1) then
							l_pos := -1 + 125 -- skip if block
						end
				when 123 then -- if:
						if (globals_inst.mb_char2cells.integer_32_item ([l_mb_c])) = 2 then
							l_c := ('>').code
							l_mb_c := l_c
							l_mb_utf8 := 0
							l_mb_l := 1
							l_multi_attr := globals_inst.highlight_attr[1]
							l_ptr := l_ptr - 1
						else
							l_pos := -1 + 125 -- goto _L___21
						end
				when 124 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 125 then -- else: | _L___21:
						if (l_ptr.item).to_integer_32 /= 0 then
							l_ptr := l_ptr + (l_mb_l - 1)
						end
				when 126 then
						if l_n_skip > 0 then
							if l_mb_l > 1 then
								if l_n_extra = 0 then
									l_n_extra := 1
									l_c_extra := ('<').code
									l_c := (' ').code
									if l_area_attr = 0 then
										if l_search_attr = 0 then
											l_n_attr := l_n_extra + 1
											l_extra_attr := globals_inst.highlight_attr[1]
											l_saved_attr2 := l_char_attr
										end
									end
									l_mb_c := l_c
									l_mb_utf8 := 0
									l_mb_l := 1
								end
							end
						end
				when 127 then -- if done
						l_ptr := l_ptr + 1
						if not ((a_wp___0.item.w_onebuf_opt.wo_list).to_boolean) then
							l_pos := -1 + 134 -- skip if block
						end
				when 128 then -- if:
						if l_c /= 160 then
							l_pos := -1 + 131 -- skip if block
						end
				when 129 then -- if:
						l_pos := -1 + 133 -- goto _L___22
				when 130 then -- if block done, skip else block:
						l_pos := -1 + 134
				when 131 then -- else:
						if not (l_mb_utf8.to_boolean) then
							l_pos := -1 + 134 -- skip if block
						end
				when 132 then -- if:
						if l_mb_c /= 160 then
							l_pos := -1 + 134 -- skip if block
						end
				when 133 then -- if: | _L___22:
						if (globals_inst.lcs_nbsp.item).to_boolean then
							l_c := globals_inst.lcs_nbsp.item
							if l_area_attr = 0 then
								if l_search_attr = 0 then
									l_n_attr := 1
									l_extra_attr := globals_inst.highlight_attr[0]
									l_saved_attr2 := l_char_attr
								end
							end
							l_mb_c := l_c
							if globals_inst.enc_utf8.to_boolean then
								if (globals_inst.mb_char2len.integer_32_item ([l_c])) > 1 then
									l_mb_utf8 := 1
									l_u8cc[0] := 0
									l_c := 192
								else
									l_mb_utf8 := 0
								end
							else
								l_mb_utf8 := 0
							end
						end
				when 134 then -- if done | if done | if done
						if not (l_extra_check.to_boolean) then
							l_pos := -1 + 145 -- skip if block
						end
				when 135 then -- if:
						l_can_spell.item := 1
						l_v := (l_ptr.distance (l_line)).to_integer_32
						if l_has_syntax.to_boolean then
							if l_v > 0 then
								l_save_did_emsg := globals_inst.did_emsg
								globals_inst.did_emsg := 0
								if l_has_spell.to_boolean then
									l_tmp___41 := l_can_spell
								else
									l_tmp___41 := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
								end
								l_syntax_attr := syntax_inst.get_syntax_attr (l_v.to_integer_32 - 1, l_tmp___41, 0)
								if globals_inst.did_emsg.to_boolean then
									(a_wp___0.item.w_s).item.b_syn_error := 1
									l_has_syntax := 0
								else
									globals_inst.did_emsg := l_save_did_emsg
								end
								l_line := memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum, 0)
								l_ptr := l_line + l_v
								if not l_attr_pri.to_boolean then
									l_char_attr := l_syntax_attr
								else
									l_char_attr := syntax_inst.hl_combine_attr (l_syntax_attr, l_char_attr)
								end
							end
						end
						if not (l_has_spell.to_boolean) then
							l_pos := -1 + 144 -- skip if block
						end
				when 136 then -- if:
						if not (l_v >= l_word_end.to_integer_32) then
							l_pos := -1 + 144 -- skip if block
						end
				when 137 then -- if:
						if not (l_v > l_cur_checked_col.to_integer_32) then
							l_pos := -1 + 144 -- skip if block
						end
				when 138 then -- if:
						l_spell_attr := 0
						if not l_attr_pri.to_boolean then
							l_char_attr := l_syntax_attr
						end
						if l_c = 0 then
							l_pos := -1 + 144 -- skip if block
						end
				when 139 then -- if:
						if l_has_syntax.to_boolean then
							l_pos := -1 + 142 -- skip if block
						end
				when 140 then -- if:
						l_pos := -1 + 143 -- goto _L___23
				when 141 then -- if block done, skip else block:
						l_pos := -1 + 144
				when 142 then -- else:
						if not ((l_can_spell.item).to_boolean) then
							l_pos := -1 + 144 -- skip if block
						end
				when 143 then -- if: | _L___23:
						l_spell_hlf___0.item := {PC_HLF_T}.HLF_COUNT
						if globals_inst.has_mbyte.to_boolean then
							l_prev_ptr___0 := l_ptr - l_mb_l
							l_v := l_v - (l_mb_l - 1).to_integer_32
						else
							l_prev_ptr___0 := l_ptr - 1
						end
						if (l_prev_ptr___0.distance (l_line)) - l_nextlinecol >= 0 then
							l_p___0 := (l_nextline + (l_prev_ptr___0.distance (l_line))) - l_nextlinecol
						else
							l_p___0 := l_prev_ptr___0
						end
						cap_col.item := cap_col.item - (l_prev_ptr___0.distance (l_line))
						l_len___0 := spell_inst.spell_check (a_wp___0, l_p___0, l_spell_hlf___0, cap_col, a_nochange)
						l_word_end := (l_v + l_len___0.to_integer_32).to_integer_32
						if l_spell_hlf___0.item /= {NATURAL_32} 41 then
							if ((globals_inst.State).bit_and (16)) /= 0 then
								if a_wp___0.item.w_cursor.lnum = a_lnum then
									if a_wp___0.item.w_cursor.col >= l_prev_ptr___0.distance (l_line) then
										if a_wp___0.item.w_cursor.col < l_word_end then
											l_spell_hlf___0.item := {PC_HLF_T}.HLF_COUNT
											globals_inst.spell_redraw_lnum := a_lnum
										end
									end
								end
							end
						end
						if l_spell_hlf___0.item = {NATURAL_32} 41 then
							if not l_p___0.is_equal (l_prev_ptr___0) then
								if (l_p___0.distance (l_nextline)) + l_len___0 > l_nextline_idx then
									checked_lnum := a_lnum + 1
									checked_col := ((l_p___0.distance (l_nextline)) + l_len___0) - l_nextline_idx
								end
							end
						end
						if l_spell_hlf___0.item /= {NATURAL_32} 41 then
							l_spell_attr := globals_inst.highlight_attr[(l_spell_hlf___0.item).to_integer_32]
						end
						if cap_col.item > 0 then
							if not l_p___0.is_equal (l_prev_ptr___0) then
								if (l_p___0.distance (l_nextline)) + cap_col.item >= l_nextline_idx then
									capcol_lnum := a_lnum + 1
									cap_col.item := ((l_p___0.distance (l_nextline)) + cap_col.item) - l_nextline_idx
								else
									cap_col.item := cap_col.item + (l_prev_ptr___0.distance (l_line))
								end
							else
								cap_col.item := cap_col.item + (l_prev_ptr___0.distance (l_line))
							end
						end
				when 144 then -- if done | if done | if done | if done | if done
						if l_spell_attr /= 0 then
							if not l_attr_pri.to_boolean then
								l_char_attr := syntax_inst.hl_combine_attr (l_char_attr, l_spell_attr)
							else
								l_char_attr := syntax_inst.hl_combine_attr (l_spell_attr, l_char_attr)
							end
						end
						if (a_wp___0.item.w_onebuf_opt.wo_lbr).to_boolean then
							if (globals_inst.breakat_flags[(l_c.to_natural_8).to_integer_32]).to_boolean then
								if not (globals_inst.breakat_flags[(l_ptr.item).to_integer_32]).to_boolean then
									if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
										if globals_inst.has_mbyte.to_boolean then
											l_tmp___42 := l_mb_l
										else
											l_tmp___42 := 1
										end
										l_n_extra := (charset_inst.win_lbr_chartabsize (a_wp___0, l_ptr - l_tmp___42, l_vcol.to_integer_32, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) - 1
										l_c_extra := (' ').code
										if l_c = 32 then
											l_c := (' ').code
										elseif l_c = 9 then
											l_c := (' ').code
										end
									end
								end
							end
						end
						if l_trailcol.to_integer_32 /= 2_147_483_647 then
							if (l_ptr.c_pointer.to_integer_32).to_natural_32 > ((l_line + l_trailcol).c_pointer.to_integer_32).to_natural_32 then
								if l_c = 32 then
									l_c := globals_inst.lcs_trail.item
									if not l_attr_pri.to_boolean then
										l_n_attr := 1
										l_extra_attr := globals_inst.highlight_attr[0]
										l_saved_attr2 := l_char_attr
									end
									l_mb_c := l_c
									if globals_inst.enc_utf8.to_boolean then
										if (globals_inst.mb_char2len.integer_32_item ([l_c])) > 1 then
											l_mb_utf8 := 1
											l_u8cc[0] := 0
											l_c := 192
										else
											l_mb_utf8 := 0
										end
									else
										l_mb_utf8 := 0
									end
								end
							end
						end
				when 145 then -- if done
						if (((globals_inst.chartab[(l_c).bit_and (255)]).to_integer_32).bit_and (16)).to_boolean then
							l_pos := -1 + 196 -- skip if block
						end
				when 146 then -- if:
						if l_c /= 9 then
							l_pos := -1 + 155 -- skip if block
						end
				when 147 then -- if:
						if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
							l_pos := -1 + 150 -- skip if block
						end
				when 148 then -- if:
						l_pos := -1 + 151 -- goto _L___39
				when 149 then -- if block done, skip else block:
						l_pos := -1 + 154
				when 150 then -- else:
						if not (globals_inst.lcs_tab1.to_boolean) then
							l_pos := -1 + 153 -- skip if block
						end
				when 151 then -- if: | _L___39:
						l_n_extra := (((((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32).to_integer_32 - l_vcol \\ (((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32).to_integer_32) - 1).to_integer_32
						l_mb_utf8 := 0
						if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
							l_c := globals_inst.lcs_tab1
							l_c_extra := globals_inst.lcs_tab2.item
							l_n_attr := l_n_extra + 1
							l_extra_attr := globals_inst.highlight_attr[0]
							l_saved_attr2 := l_char_attr
							l_mb_c := l_c
							if globals_inst.enc_utf8.to_boolean then
								if (globals_inst.mb_char2len.integer_32_item ([l_c])) > 1 then
									l_mb_utf8 := 1
									l_u8cc[0] := 0
									l_c := 192
								end
							end
						else
							l_c_extra := (' ').code
							l_c := (' ').code
						end
				when 152 then -- if block done, skip else block:
						l_pos := -1 + 154
				when 153 then -- else:
						l_pos := -1 + 155 -- goto _L___38
				when 154 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 196
				when 155 then -- else: | _L___38:
						if l_c /= 0 then
							l_pos := -1 + 179 -- skip if block
						end
				when 156 then -- if:
						if not ((a_wp___0.item.w_onebuf_opt.wo_list).to_boolean) then
							l_pos := -1 + 159 -- skip if block
						end
				when 157 then -- if:
						if globals_inst.lcs_eol.item > 0 then
							l_pos := -1 + 169 -- goto _L___35
						else
							l_pos := -1 + 159 -- goto _L___37
						end
				when 158 then -- if block done, skip else block:
						l_pos := -1 + 178
				when 159 then -- else: | _L___37:
						if not (l_fromcol.item >= 0) then
							l_pos := -1 + 162 -- skip if block
						end
				when 160 then -- if:
						l_pos := -1 + 163 -- goto _L___36
				when 161 then -- if block done, skip else block:
						l_pos := -1 + 178
				when 162 then -- else:
						if not (l_fromcol_prev >= 0) then
							l_pos := -1 + 177 -- skip if block
						end
				when 163 then -- if: | _L___36:
						if not ((l_tocol.item).to_integer_32 > l_vcol) then
							l_pos := -1 + 175 -- skip if block
						end
				when 164 then -- if:
						if globals_inst.VIsual_mode = 22 then
							l_pos := -1 + 173 -- skip if block
						end
				when 165 then -- if:
						if not (l_col < a_wp___0.item.w_width) then
							l_pos := -1 + 171 -- skip if block
						end
				when 166 then -- if:
						if not (l_noinvcur.to_boolean) then
							l_pos := -1 + 169 -- skip if block
						end
				when 167 then -- if:
						if a_lnum = a_wp___0.item.w_cursor.lnum then
							if l_vcol.to_integer_32 = a_wp___0.item.w_virtcol then
								l_pos := -1 + 179 -- goto _L___32
							else
								l_pos := -1 + 169 -- goto _L___35
							end
						else
							l_pos := -1 + 169 -- goto _L___35
						end
				when 168 then -- if block done, skip else block:
						l_pos := -1 + 170
				when 169 then -- else: | _L___35:
						if l_lcs_eol_one >= 0 then
							if l_diff_hlf = ({PC_HLF_T}.HLF_8) then
								if l_line_attr = 0 then
									if l_area_highlighting.to_boolean then
										if (misc2_inst.virtual_active).to_boolean then
											if (l_tocol.item).to_integer_32 /= 2_147_483_647 then
												if l_vcol < (l_tocol.item).to_integer_32 then
													l_n_extra := 0
												else
													l_p_extra.item := at_end_str
													l_n_extra := 1
													l_c_extra := ('%/0/').code
												end
											else
												l_p_extra.item := at_end_str
												l_n_extra := 1
												l_c_extra := ('%/0/').code
											end
										else
											l_p_extra.item := at_end_str
											l_n_extra := 1
											l_c_extra := ('%/0/').code
										end
									else
										l_p_extra.item := at_end_str
										l_n_extra := 1
										l_c_extra := ('%/0/').code
									end
								end
							end
							if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
								l_c := globals_inst.lcs_eol.item
							else
								l_c := (' ').code
							end
							l_lcs_eol_one := -1
							l_ptr := l_ptr - 1
							if not l_attr_pri.to_boolean then
								l_extra_attr := globals_inst.highlight_attr[1]
								l_n_attr := 1
							end
							l_mb_c := l_c
							if globals_inst.enc_utf8.to_boolean then
								if (globals_inst.mb_char2len.integer_32_item ([l_c])) > 1 then
									l_mb_utf8 := 1
									l_u8cc[0] := 0
									l_c := 192
								else
									l_mb_utf8 := 0
								end
							else
								l_mb_utf8 := 0
							end
						else
							l_pos := -1 + 179 -- goto _L___32
						end
				when 170 then -- if done | if block done, skip else block:
						l_pos := -1 + 172
				when 171 then -- else:
						l_pos := -1 + 179 -- goto _L___32
				when 172 then -- if done | if block done, skip else block:
						l_pos := -1 + 174
				when 173 then -- else:
						l_pos := -1 + 179 -- goto _L___32
				when 174 then -- if done | if block done, skip else block:
						l_pos := -1 + 176
				when 175 then -- else:
						l_pos := -1 + 179 -- goto _L___32
				when 176 then -- if done | if block done, skip else block:
						l_pos := -1 + 178
				when 177 then -- else:
						l_pos := -1 + 179 -- goto _L___32
				when 178 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 196
				when 179 then -- else: | _L___32:
						if l_c = 0 then
							l_pos := -1 + 182 -- skip if block
						end
				when 180 then -- if:
						l_p_extra.item := charset_inst.transchar (l_c)
						l_n_extra := (charset_inst.byte2cells (l_c)) - 1
						l_c_extra := ('%/0/').code
						l_tmp___49 := l_p_extra.item
						l_p_extra.item := l_p_extra.item + 1
						l_c := (l_tmp___49.item).to_integer_32
						if not l_attr_pri.to_boolean then
							l_n_attr := l_n_extra + 1
							l_extra_attr := globals_inst.highlight_attr[0]
							l_saved_attr2 := l_char_attr
						end
						l_mb_utf8 := 0
				when 181 then -- if block done, skip else block:
						l_pos := -1 + 196
				when 182 then -- else:
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 191 -- skip if block
						end
				when 183 then -- if:
						if globals_inst.VIsual_mode /= 22 then
							l_pos := -1 + 186 -- skip if block
						end
				when 184 then -- if:
						l_pos := -1 + 187 -- goto _L___30
				when 185 then -- if block done, skip else block:
						l_pos := -1 + 190
				when 186 then -- else:
						if globals_inst.VIsual_mode /= 118 then
							l_pos := -1 + 189 -- skip if block
						end
				when 187 then -- if: | _L___30:
						if (misc2_inst.virtual_active).to_boolean then
							if (l_tocol.item).to_integer_32 /= 2_147_483_647 then
								if l_vcol < (l_tocol.item).to_integer_32 then
									if l_col < a_wp___0.item.w_width then
										l_c := (' ').code
										l_ptr := l_ptr - 1
									else
										l_pos := -1 + 191 -- goto _L___29
									end
								else
									l_pos := -1 + 191 -- goto _L___29
								end
							else
								l_pos := -1 + 191 -- goto _L___29
							end
						else
							l_pos := -1 + 191 -- goto _L___29
						end
				when 188 then -- if block done, skip else block:
						l_pos := -1 + 190
				when 189 then -- else:
						l_pos := -1 + 191 -- goto _L___29
				when 190 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 196
				when 191 then -- else: | _L___29:
						if l_diff_hlf = ({PC_HLF_T}.HLF_8) then
							l_pos := -1 + 194 -- skip if block
						end
				when 192 then -- if:
						l_pos := -1 + 195 -- goto _L___24
				when 193 then -- if block done, skip else block:
						l_pos := -1 + 196
				when 194 then -- else:
						if l_line_attr = 0 then
							l_pos := -1 + 196 -- skip if block
						end
				when 195 then -- if: | _L___24:
						if l_col < a_wp___0.item.w_width then
							l_c := (' ').code
							l_ptr := l_ptr - 1
							l_did_line_attr := l_did_line_attr + 1
							if l_line_attr /= 0 then
								if l_char_attr = l_search_attr then
									if l_col > 0 then
										l_char_attr := l_line_attr
									end
								end
							end
							if l_diff_hlf = {NATURAL_32} 24 then
								l_diff_hlf := {PC_HLF_T}.HLF_CHD
								if l_attr = 0 then
									l_char_attr := globals_inst.highlight_attr[l_diff_hlf.to_integer_32]
								elseif l_char_attr /= l_attr then
									l_char_attr := globals_inst.highlight_attr[l_diff_hlf.to_integer_32]
								end
							end
						end
				when 196 then -- if done | if done | if done | if done | if done | if done | if done
						if l_n_attr > 0 then
							if l_draw_state = 6 then
								if not l_attr_pri.to_boolean then
									l_char_attr := l_extra_attr
								end
							end
						end
						if globals_inst.xic.is_void then
							l_pos := -1 + 206 -- skip if block
						end
				when 197 then -- if:
						if a_lnum /= a_wp___0.item.w_cursor.lnum then
							l_pos := -1 + 206 -- skip if block
						end
				when 198 then -- if:
						if not (((globals_inst.State).bit_and (16)).to_boolean) then
							l_pos := -1 + 206 -- skip if block
						end
				when 199 then -- if:
						if (option_inst.p_imdisable.item).to_boolean then
							l_pos := -1 + 206 -- skip if block
						end
				when 200 then -- if:
						if not ((mbyte_inst.im_is_preediting).to_boolean) then
							l_pos := -1 + 206 -- skip if block
						end
				when 201 then -- if:
						if l_draw_state /= 6 then
							l_pos := -1 + 206 -- skip if block
						end
				when 202 then -- if:
						if globals_inst.preedit_end_col.to_integer_32 = 2_147_483_647 then
							charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_tcol, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						else
							l_tcol.item := globals_inst.preedit_end_col
						end
						if not ((globals_inst.preedit_start_col.item).to_integer_32 <= l_vcol) then
							l_pos := -1 + 205 -- skip if block
						end
				when 203 then -- if:
						if l_vcol < (l_tcol.item).to_integer_32 then
							if l_feedback_old_attr < 0 then
								l_feedback_col := 0
								l_feedback_old_attr := l_char_attr
							end
							l_char_attr := mbyte_inst.im_get_feedback_attr (l_feedback_col)
							if l_char_attr < 0 then
								l_char_attr := l_feedback_old_attr
							end
							l_feedback_col := l_feedback_col + 1
						else
							l_pos := -1 + 205 -- goto _L___40
						end
				when 204 then -- if block done, skip else block:
						l_pos := -1 + 206
				when 205 then -- else: | _L___40:
						if l_feedback_old_attr >= 0 then
							l_char_attr := l_feedback_old_attr
							l_feedback_old_attr := -1
							l_feedback_col := 0
						end
				when 206 then -- if done | if done | if done | if done | if done | if done
						if l_lcs_prec_todo /= 0 then
							if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
								l_tmp___53 := (a_wp___0.item.w_skipcol > 0).to_integer
							else
								l_tmp___53 := (a_wp___0.item.w_leftcol > 0).to_integer
							end
							if l_tmp___53.to_boolean then
								if l_filler_todo <= 0 then
									if l_draw_state > 4 then
										if l_c /= 0 then
											l_c := globals_inst.lcs_prec.item
											l_lcs_prec_todo := ('%/0/').code
											l_mb_c := l_c
											if globals_inst.enc_utf8.to_boolean then
												if (globals_inst.mb_char2len.integer_32_item ([l_c])) > 1 then
													l_mb_utf8 := 1
													l_u8cc[0] := 0
													l_c := 192
												else
													l_mb_utf8 := 0
												end
											else
												l_mb_utf8 := 0
											end
											if not l_attr_pri.to_boolean then
												l_saved_attr3 := l_char_attr
												l_char_attr := globals_inst.highlight_attr[1]
												l_n_attr3 := 1
											end
										end
									end
								end
							end
						end
						if l_c /= 0 then
							l_pos := -1 + 209 -- skip if block
						end
				when 207 then -- if:
						l_pos := -1 + 210 -- goto _L___47
				when 208 then -- if block done, skip else block:
						l_pos := -1 + 242
				when 209 then -- else:
						if l_did_line_attr /= 1 then
							l_pos := -1 + 242 -- skip if block
						end
				when 210 then -- if: | _L___47:
						l_prevcol := (l_ptr.distance (l_line)).to_integer_32 - (l_c = 0).to_integer
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_tmp___54 := a_wp___0.item.w_skipcol
						else
							l_tmp___54 := a_wp___0.item.w_leftcol
						end
						if l_tmp___54.to_integer_32 > l_prevcol then
							l_prevcol := l_prevcol + 1
						end
						l_prevcol_hl_flag := 0
						if l_prevcol = (search_hl.item.startcol).to_integer_32 then
							l_prevcol_hl_flag := 1
						else
							l_cur := a_wp___0.item.w_match_head
							from
							until
								not (not js.loop_done and then (not l_cur.is_void))
							loop
								if l_prevcol = (l_cur.item.hl.startcol).to_integer_32 then
									l_prevcol_hl_flag := 1
									js.break
								end
								if not js.loop_jumped then
									l_cur := l_cur.item.next
								end
							end
						end
						if globals_inst.lcs_eol.item /= l_lcs_eol_one then
							l_pos := -1 + 242 -- skip if block
						end
				when 211 then -- if:
						if l_area_attr = 0 then
							l_pos := -1 + 226 -- skip if block
						end
				when 212 then -- if:
						if l_vcol /= (l_fromcol.item).to_integer_32 then
							l_pos := -1 + 224 -- skip if block
						end
				when 213 then -- if:
						if globals_inst.VIsual_mode = 22 then
							l_pos := -1 + 216 -- skip if block
						end
				when 214 then -- if:
						l_pos := -1 + 220 -- goto _L___45
				when 215 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 216 then -- else:
						if a_lnum /= globals_inst.VIsual.item.lnum then
							l_pos := -1 + 219 -- skip if block
						end
				when 217 then -- if:
						l_pos := -1 + 220 -- goto _L___45
				when 218 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 219 then -- else:
						if a_lnum /= globals_inst.curwin.item.w_cursor.lnum then
							l_pos := -1 + 222 -- skip if block
						end
				when 220 then -- if: | _L___45:
						if l_c = 0 then
							l_pos := -1 + 228 -- goto _L___42
						else
							l_pos := -1 + 226 -- goto _L___46
						end
				when 221 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 222 then -- else:
						l_pos := -1 + 226 -- goto _L___46
				when 223 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 225
				when 224 then -- else:
						l_pos := -1 + 226 -- goto _L___46
				when 225 then -- if done | if block done, skip else block:
						l_pos := -1 + 242
				when 226 then -- else: | _L___46:
						if l_prevcol_hl_flag /= 1 then
							l_pos := -1 + 242 -- skip if block
						end
				when 227 then -- if:
						if not (l_did_line_attr <= 1) then
							l_pos := -1 + 242 -- skip if block
						end
				when 228 then -- if: | _L___42:
						l_n := 0
						if l_col >= a_wp___0.item.w_width then
							l_n := -1
						end
						if l_n /= 0 then
							l_off___0 := l_off___0 + l_n.to_natural_32
							l_col := l_col + l_n
						else
							globals_inst.ScreenLines[l_off___0.to_integer_32] := ((' ').code).to_natural_8
							if globals_inst.enc_utf8.to_boolean then
								globals_inst.ScreenLinesUC[l_off___0.to_integer_32] := (0).to_natural_32
							end
						end
						if l_area_attr /= 0 then
							l_pos := -1 + 241 -- skip if block
						end
				when 229 then -- if:
						l_char_attr := search_hl.item.attr
						l_cur := a_wp___0.item.w_match_head
						l_shl_flag := 0
				when 230 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 241 -- skip loop
						end
				when 231 then -- loop body:
						if l_cur.is_void then
							if l_shl_flag /= 0 then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 240 -- skip if block
						end
				when 232 then -- if:
						if l_shl_flag /= 0 then
							l_pos := -1 + 238 -- skip if block
						end
				when 233 then -- if:
						if l_cur.is_void then
							l_pos := -1 + 236 -- skip if block
						end
				when 234 then -- if:
						if l_cur.item.priority > 0 then
							l_shl := search_hl
							l_shl_flag := 1
						else
							l_pos := -1 + 236 -- goto _L___41
						end
				when 235 then -- if block done, skip else block:
						l_pos := -1 + 237
				when 236 then -- else: | _L___41:
						if l_cur.is_void then
							l_shl := search_hl
							l_shl_flag := 1
						else
							l_shl := create {CE_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
						end
				when 237 then -- if done | if block done, skip else block:
						l_pos := -1 + 239
				when 238 then -- else:
						l_shl := create {CE_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
				when 239 then
						if ((l_ptr.distance (l_line)) - 1).to_integer_32 = (l_shl.item.startcol).to_integer_32 then
							l_char_attr := l_shl.item.attr
						end
						if not l_shl.is_equal (search_hl) then
							if not l_cur.is_void then
								l_cur := l_cur.item.next
							end
						end
				when 240 then -- if done
						l_pos := -1 + 230 -- back to loop condition
				when 241 then -- loop done | if done
						globals_inst.ScreenAttrs[l_off___0.to_integer_32] := l_char_attr.to_natural_16
						l_col := l_col + 1
						l_off___0 := l_off___0 + 1
						l_vcol := l_vcol + 1
						l_eol_hl_off := 1
				when 242 then -- if done | if done | if done | if done | if done
						if l_c /= 0 then
							l_pos := -1 + 255 -- skip if block
						end
				when 243 then -- if:
						if l_eol_hl_off > 0 then
							if l_vcol - l_eol_hl_off.to_integer_32 = (a_wp___0.item.w_virtcol).to_integer_32 then
								if a_lnum = a_wp___0.item.w_cursor.lnum then
									l_col := l_col - 1
									l_off___0 := l_off___0 - 1
									l_vcol := l_vcol - 1
								end
							end
						end
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_v := (a_wp___0.item.w_skipcol).to_integer_32
						else
							l_v := (a_wp___0.item.w_leftcol).to_integer_32
						end
						if l_vcol < (l_v + l_col.to_integer_32) - (move_inst.win_col_off (a_wp___0)).to_integer_32 then
							l_vcol := (l_v + l_col.to_integer_32) - (move_inst.win_col_off (a_wp___0)).to_integer_32
						end
						if l_draw_color_col.to_boolean then
							l_draw_color_col := advance_color_col (l_vcol.to_integer_32, l_color_cols)
						end
						if not ((a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean) then
							l_pos := -1 + 246 -- skip if block
						end
				when 244 then -- if:
						if (a_wp___0.item.w_virtcol).to_integer_32 >= l_vcol - l_eol_hl_off.to_integer_32 then
							if (a_wp___0.item.w_virtcol).to_integer_32 < (a_wp___0.item.w_width * ((l_row - a_startrow) + 1)).to_integer_32 + l_v then
								if a_lnum /= a_wp___0.item.w_cursor.lnum then
									l_pos := -1 + 247 -- goto _L___49
								else
									l_pos := -1 + 246 -- goto _L___52
								end
							else
								l_pos := -1 + 246 -- goto _L___52
							end
						else
							l_pos := -1 + 246 -- goto _L___52
						end
				when 245 then -- if block done, skip else block:
						l_pos := -1 + 254
				when 246 then -- else: | _L___52:
						if not (l_draw_color_col.to_boolean) then
							l_pos := -1 + 254 -- skip if block
						end
				when 247 then -- if: | _L___49:
						l_rightmost_vcol := 0
						if (a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean then
							l_rightmost_vcol := a_wp___0.item.w_virtcol
						end
						if l_draw_color_col.to_boolean then
							l_i___1 := 0
							from
							until
								not (l_color_cols.item[l_i___1] >= 0)
							loop
								if l_rightmost_vcol < l_color_cols.item[l_i___1] then
									l_rightmost_vcol := l_color_cols.item[l_i___1]
								end
								l_i___1 := l_i___1 + 1
							end
						end
				when 248 then -- loop condition:
						if not (not js.loop_done and then (l_col < a_wp___0.item.w_width)) then
							l_pos := -1 + 254 -- skip loop
						end
				when 249 then -- loop body:
						globals_inst.ScreenLines[l_off___0.to_integer_32] := ((' ').code).to_natural_8
						if globals_inst.enc_utf8.to_boolean then
							globals_inst.ScreenLinesUC[l_off___0.to_integer_32] := (0).to_natural_32
						end
						l_col := l_col + 1
						if l_draw_color_col.to_boolean then
							l_draw_color_col := advance_color_col (l_vcol.to_integer_32, l_color_cols)
						end
						if not ((a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean) then
							l_pos := -1 + 252 -- skip if block
						end
				when 250 then -- if:
						if l_vcol = (a_wp___0.item.w_virtcol).to_integer_32 then
							l_tmp___57 := l_off___0
							l_off___0 := l_off___0 + 1
							globals_inst.ScreenAttrs[l_tmp___57.to_integer_32] := (globals_inst.highlight_attr[38]).to_natural_16
						else
							l_pos := -1 + 252 -- goto _L___48
						end
				when 251 then -- if block done, skip else block:
						l_pos := -1 + 253
				when 252 then -- else: | _L___48:
						if l_draw_color_col.to_boolean then
							if l_vcol = (l_color_cols.item.item).to_integer_32 then
								l_tmp___58 := l_off___0
								l_off___0 := l_off___0 + 1
								globals_inst.ScreenAttrs[l_tmp___58.to_integer_32] := (globals_inst.highlight_attr[40]).to_natural_16
							else
								l_tmp___59 := l_off___0
								l_off___0 := l_off___0 + 1
								globals_inst.ScreenAttrs[l_tmp___59.to_integer_32] := (0).to_natural_16
							end
						else
							l_tmp___59 := l_off___0
							l_off___0 := l_off___0 + 1
							globals_inst.ScreenAttrs[l_tmp___59.to_integer_32] := (0).to_natural_16
						end
				when 253 then
						if l_vcol >= l_rightmost_vcol.to_integer_32 then
							js.break
						end
						if not js.loop_jumped then
							l_vcol := l_vcol + 1
						end
						l_pos := -1 + 248 -- back to loop condition
				when 254 then -- loop done | if done
						screen_line (l_screen_row, a_wp___0.item.w_wincol, l_col, a_wp___0.item.w_width)
						l_row := l_row + 1
						if a_wp___0.is_equal (globals_inst.curwin) then
							if a_lnum = globals_inst.curwin.item.w_cursor.lnum then
								globals_inst.curwin.item.w_cline_row := a_startrow
								globals_inst.curwin.item.w_cline_height := l_row - a_startrow
								globals_inst.curwin.item.w_cline_folded := 0
								globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((24))
							end
						end
						js.break
				when 255 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 315 -- skip if block
						end
				when 256 then -- if:
						if not ((globals_inst.lcs_ext.item).to_boolean) then
							l_pos := -1 + 272 -- skip if block
						end
				when 257 then -- if:
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_pos := -1 + 272 -- skip if block
						end
				when 258 then -- if:
						if not (l_filler_todo <= 0) then
							l_pos := -1 + 272 -- skip if block
						end
				when 259 then -- if:
						if l_col /= a_wp___0.item.w_width - 1 then
							l_pos := -1 + 272 -- skip if block
						end
				when 260 then -- if:
						if (l_ptr.item).to_integer_32 = 0 then
							l_pos := -1 + 263 -- skip if block
						end
				when 261 then -- if:
						l_pos := -1 + 271 -- goto _L___54
				when 262 then -- if block done, skip else block:
						l_pos := -1 + 272
				when 263 then -- else:
						if not ((a_wp___0.item.w_onebuf_opt.wo_list).to_boolean) then
							l_pos := -1 + 266 -- skip if block
						end
				when 264 then -- if:
						if l_lcs_eol_one > 0 then
							l_pos := -1 + 271 -- goto _L___54
						else
							l_pos := -1 + 266 -- goto _L___55
						end
				when 265 then -- if block done, skip else block:
						l_pos := -1 + 272
				when 266 then -- else: | _L___55:
						if not (l_n_extra.to_boolean) then
							l_pos := -1 + 272 -- skip if block
						end
				when 267 then -- if:
						if l_c_extra = 0 then
							l_pos := -1 + 270 -- skip if block
						end
				when 268 then -- if:
						l_pos := -1 + 271 -- goto _L___54
				when 269 then -- if block done, skip else block:
						l_pos := -1 + 272
				when 270 then -- else:
						if (l_p_extra.item.item).to_integer_32 = 0 then
							l_pos := -1 + 272 -- skip if block
						end
				when 271 then -- if: | _L___54:
						l_c := globals_inst.lcs_ext.item
						l_char_attr := globals_inst.highlight_attr[1]
						l_mb_c := l_c
						if globals_inst.enc_utf8.to_boolean then
							if (globals_inst.mb_char2len.integer_32_item ([l_c])) > 1 then
								l_mb_utf8 := 1
								l_u8cc[0] := 0
								l_c := 192
							else
								l_mb_utf8 := 0
							end
						else
							l_mb_utf8 := 0
						end
				when 272 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if l_draw_color_col.to_boolean then
							l_draw_color_col := advance_color_col (l_vcol.to_integer_32, l_color_cols)
						end
						l_vcol_save_attr := -1
						if l_draw_state /= 6 then
							l_pos := -1 + 278 -- skip if block
						end
				when 273 then -- if:
						if l_lnum_in_visual_area.to_boolean then
							l_pos := -1 + 278 -- skip if block
						end
				when 274 then -- if:
						if not ((a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean) then
							l_pos := -1 + 277 -- skip if block
						end
				when 275 then -- if:
						if l_vcol = (a_wp___0.item.w_virtcol).to_integer_32 then
							if a_lnum /= a_wp___0.item.w_cursor.lnum then
								l_vcol_save_attr := l_char_attr
								l_char_attr := syntax_inst.hl_combine_attr (l_char_attr, globals_inst.highlight_attr[38])
							else
								l_pos := -1 + 277 -- goto _L___57
							end
						else
							l_pos := -1 + 277 -- goto _L___57
						end
				when 276 then -- if block done, skip else block:
						l_pos := -1 + 278
				when 277 then -- else: | _L___57:
						if l_draw_color_col.to_boolean then
							if l_vcol = (l_color_cols.item.item).to_integer_32 then
								l_vcol_save_attr := l_char_attr
								l_char_attr := syntax_inst.hl_combine_attr (l_char_attr, globals_inst.highlight_attr[40])
							end
						end
				when 278 then -- if done | if done
						l_vcol_prev := l_vcol
						if not (l_draw_state < 6) then
							l_pos := -1 + 281 -- skip if block
						end
				when 279 then -- if:
						l_pos := -1 + 282 -- goto _L___58
				when 280 then -- if block done, skip else block:
						l_pos := -1 + 285
				when 281 then -- else:
						if not (l_n_skip <= 0) then
							l_pos := -1 + 284 -- skip if block
						end
				when 282 then -- if: | _L___58:
						globals_inst.ScreenLines[l_off___0.to_integer_32] := l_c.to_natural_8
						if globals_inst.enc_dbcs = 9_932 then
							if ((l_mb_c).bit_and (65_280)) = 36_352 then
								globals_inst.ScreenLines[l_off___0.to_integer_32] := (142).to_natural_8
							end
							globals_inst.ScreenLines2[l_off___0.to_integer_32] := ((l_mb_c).bit_and (255)).to_natural_8
						elseif globals_inst.enc_utf8.to_boolean then
							if l_mb_utf8.to_boolean then
								globals_inst.ScreenLinesUC[l_off___0.to_integer_32] := l_mb_c.to_natural_32
								if ((l_c).bit_and (255)) = 0 then
									globals_inst.ScreenLines[l_off___0.to_integer_32] := (128).to_natural_8
								end
								l_i___2 := 0
								from
								until
									not (not js.loop_done and then (l_i___2 < globals_inst.Screen_mco))
								loop
									(globals_inst.ScreenLinesC[l_i___2])[l_off___0.to_integer_32] := (l_u8cc[l_i___2]).to_natural_32
									if l_u8cc[l_i___2] = 0 then
										js.break
									end
									if not js.loop_jumped then
										l_i___2 := l_i___2 + 1
									end
								end
							else
								globals_inst.ScreenLinesUC[l_off___0.to_integer_32] := (0).to_natural_32
							end
						end
						if l_multi_attr.to_boolean then
							globals_inst.ScreenAttrs[l_off___0.to_integer_32] := l_multi_attr.to_natural_16
							l_multi_attr := 0
						else
							globals_inst.ScreenAttrs[l_off___0.to_integer_32] := l_char_attr.to_natural_16
						end
						if globals_inst.has_mbyte.to_boolean then
							if (globals_inst.mb_char2cells.integer_32_item ([l_mb_c])) > 1 then
								l_off___0 := l_off___0 + 1
								l_col := l_col + 1
								if globals_inst.enc_utf8.to_boolean then
									globals_inst.ScreenLines[l_off___0.to_integer_32] := (0).to_natural_8
								else
									globals_inst.ScreenLines[l_off___0.to_integer_32] := ((l_mb_c).bit_and (255)).to_natural_8
								end
								l_vcol := l_vcol + 1
								if (l_tocol.item).to_integer_32 = l_vcol then
									l_tocol.item := l_tocol.item + 1
								end
							end
						end
						l_off___0 := l_off___0 + 1
						l_col := l_col + 1
				when 283 then -- if block done, skip else block:
						l_pos := -1 + 285
				when 284 then -- else:
						l_n_skip := l_n_skip - 1
				when 285 then -- if done
						if l_draw_state > 4 then
							if l_filler_todo <= 0 then
								l_vcol := l_vcol + 1
							end
						end
						if l_vcol_save_attr >= 0 then
							l_char_attr := l_vcol_save_attr
						end
						if l_draw_state > 4 then
							if l_n_attr3 > 0 then
								l_n_attr3 := l_n_attr3 - 1
								if l_n_attr3 = 0 then
									l_char_attr := l_saved_attr3
								end
							end
						end
						if l_n_attr > 0 then
							if l_draw_state = 6 then
								l_n_attr := l_n_attr - 1
								if l_n_attr = 0 then
									l_char_attr := l_saved_attr2
								end
							end
						end
						if not (l_col >= a_wp___0.item.w_width) then
							l_pos := -1 + 315 -- skip if block
						end
				when 286 then -- if:
						if (l_ptr.item).to_integer_32 = 0 then
							l_pos := -1 + 289 -- skip if block
						end
				when 287 then -- if:
						l_pos := -1 + 300 -- goto _L___62
				when 288 then -- if block done, skip else block:
						l_pos := -1 + 315
				when 289 then -- else:
						if not (l_filler_todo > 0) then
							l_pos := -1 + 292 -- skip if block
						end
				when 290 then -- if:
						l_pos := -1 + 300 -- goto _L___62
				when 291 then -- if block done, skip else block:
						l_pos := -1 + 315
				when 292 then -- else:
						if not ((a_wp___0.item.w_onebuf_opt.wo_list).to_boolean) then
							l_pos := -1 + 295 -- skip if block
						end
				when 293 then -- if:
						if globals_inst.lcs_eol.item /= 0 then
							if not (l_p_extra.item).is_equal (at_end_str) then
								l_pos := -1 + 300 -- goto _L___62
							else
								l_pos := -1 + 295 -- goto _L___64
							end
						else
							l_pos := -1 + 295 -- goto _L___64
						end
				when 294 then -- if block done, skip else block:
						l_pos := -1 + 315
				when 295 then -- else: | _L___64:
						if l_n_extra = 0 then
							l_pos := -1 + 315 -- skip if block
						end
				when 296 then -- if:
						if l_c_extra = 0 then
							l_pos := -1 + 299 -- skip if block
						end
				when 297 then -- if:
						l_pos := -1 + 300 -- goto _L___62
				when 298 then -- if block done, skip else block:
						l_pos := -1 + 315
				when 299 then -- else:
						if (l_p_extra.item.item).to_integer_32 = 0 then
							l_pos := -1 + 315 -- skip if block
						end
				when 300 then -- if: | _L___62:
						screen_line (l_screen_row, a_wp___0.item.w_wincol, l_col, a_wp___0.item.w_width)
						l_row := l_row + 1
						l_screen_row := l_screen_row + 1
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_pos := -1 + 303 -- skip if block
						end
				when 301 then -- if:
						if l_filler_todo <= 0 then
							js.break
						else
							l_pos := -1 + 303 -- goto _L___59
						end
				when 302 then -- if block done, skip else block:
						l_pos := -1 + 304
				when 303 then -- else: | _L___59:
						if l_lcs_eol_one = -1 then
							js.break
						end
				when 304 then
						if not js.loop_jumped then
							if l_draw_state /= 6 then
								if l_filler_todo <= 0 then
									win_draw_end (a_wp___0, ('@').code, (' ').code, l_row, a_wp___0.item.w_height, {PC_HLF_T}.HLF_AT)
									draw_vsep_win (a_wp___0, l_row)
									l_row := a_endrow
								end
							end
							if l_row = a_endrow then
								l_row := l_row + 1
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 315 -- skip if block
						end
				when 305 then -- if:
						if screen_cur_row /= l_screen_row - 1 then
							l_pos := -1 + 314 -- skip if block
						end
				when 306 then -- if:
						if not (l_filler_todo <= 0) then
							l_pos := -1 + 314 -- skip if block
						end
				when 307 then -- if:
						if (a_wp___0.item.w_width).to_integer_32 /= globals_inst.Columns.item then
							l_pos := -1 + 314 -- skip if block
						end
				when 308 then -- if:
						globals_inst.LineWraps[(l_screen_row - 1)] := (1).to_natural_8
						if not ((option_inst.p_tf.item).to_boolean) then
							l_pos := -1 + 314 -- skip if block
						end
				when 309 then -- if:
						if (gui_inst.gui.item.in_use).to_boolean then
							l_pos := -1 + 314 -- skip if block
						end
				when 310 then -- if:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 313 -- skip if block
						end
				when 311 then -- if:
						if (globals_inst.mb_off2cells.integer_32_item ([globals_inst.LineOffset[l_screen_row], globals_inst.LineOffset[l_screen_row] + globals_inst.screen_Columns.to_natural_32])) /= 2 then
							if (globals_inst.mb_off2cells.integer_32_item ([(globals_inst.LineOffset[(l_screen_row - 1)] + ((globals_inst.Columns.item).to_integer_32).to_natural_32) - {NATURAL_32} 2, globals_inst.LineOffset[l_screen_row] + globals_inst.screen_Columns.to_natural_32])) /= 2 then
								l_pos := -1 + 313 -- goto _L___60
							end
						end
				when 312 then -- if block done, skip else block:
						l_pos := -1 + 314
				when 313 then -- else: | _L___60:
						if screen_cur_col /= a_wp___0.item.w_width then
							screen_char ((globals_inst.LineOffset[(l_screen_row - 1)] + (globals_inst.Columns.item).to_natural_32) - {NATURAL_32} 1, l_screen_row - 1, (globals_inst.Columns.item - 1).to_integer_32)
						end
						if globals_inst.has_mbyte.to_boolean then
							if (globals_inst.mb_bytelen_tab[(globals_inst.ScreenLines[((globals_inst.LineOffset[(l_screen_row - 1)]).to_natural_32 + (globals_inst.Columns.item - 1).to_natural_32).to_integer_32]).to_integer_32]).to_integer_32 > 1 then
								term_inst.out_char (((' ').code).to_natural_32)
							else
								term_inst.out_char ((globals_inst.ScreenLines[((globals_inst.LineOffset[(l_screen_row - 1)]).to_natural_32 + (globals_inst.Columns.item - 1).to_natural_32).to_integer_32]).to_natural_32)
							end
						else
							term_inst.out_char ((globals_inst.ScreenLines[((globals_inst.LineOffset[(l_screen_row - 1)]).to_natural_32 + (globals_inst.Columns.item - 1).to_natural_32).to_integer_32]).to_natural_32)
						end
						globals_inst.ScreenAttrs[(globals_inst.LineOffset[l_screen_row]).to_integer_32] := (-1).to_natural_16
						screen_start
				when 314 then -- if done | if done | if done | if done | if done
						l_col := 0
						l_off___0 := (current_ScreenLine.distance (globals_inst.ScreenLines)).to_natural_32
						l_draw_state := 0
						l_saved_n_extra := l_n_extra
						l_saved_p_extra := l_p_extra.item
						l_saved_c_extra := l_c_extra
						l_saved_char_attr := l_char_attr
						l_n_extra := 0
						l_lcs_prec_todo := globals_inst.lcs_prec.item
						if l_filler_todo <= 0 then
							l_need_showbreak := 1
						end
						l_filler_todo := l_filler_todo - 1
						if l_filler_todo = 0 then
							if (a_wp___0.item.w_botfill).to_boolean then
								js.break
							end
						end
				when 315 then -- if done | if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + 22 -- back to loop condition
				when 316 then -- loop done
						if ((charset_inst.skipwhite (l_line)).item).to_integer_32 = 0 then
							capcol_lnum := a_lnum + 1
							cap_col.item := 0
						end
						Result := l_row
				when 317 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_redr_custom (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_draw_ruler: INTEGER_32)
		local
			l_attr: CE_ARRAY [INTEGER_32]
			l_curattr: INTEGER_32
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_maxwidth: INTEGER_32
			l_width: INTEGER_32
			l_n: INTEGER_32
			l_len: INTEGER_32
			l_fillchar: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_stl: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_hltab: CE_ARRAY [PD_STL_HLREC]
			l_tabtab: CE_ARRAY [PD_STL_HLREC]
			l_use_sandbox: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [PD_WINDOW_S]
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
		do
			create l_attr.make (<<1>>)
			create l_buf___6.make (<<4_096>>)
			create l_stl.make
			create l_p___0.make
			create l_hltab.make (<<80>>)
			create l_tabtab.make (<<80>>)
			create l_tmp___0.make
			create l_tmp___2.make

			l_col := 0
			l_use_sandbox := 0
			if a_wp___0.is_void then
				l_stl := option_inst.p_tal.item
				l_row := 0
				l_fillchar := (' ').code
				l_attr.item := globals_inst.highlight_attr[37]
				l_maxwidth := (globals_inst.Columns.item).to_integer_32
				l_use_sandbox := option_inst.was_set_insecurely (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tabline")), 0)
			else
				l_row := a_wp___0.item.w_winrow + a_wp___0.item.w_height
				l_fillchar := fillchar_status (l_attr, (a_wp___0.is_equal (globals_inst.curwin)).to_integer)
				l_maxwidth := a_wp___0.item.w_width
				if a_draw_ruler.to_boolean then
					l_stl := option_inst.p_ruf.item
					if (l_stl.item).to_integer_32 = 37 then
						l_stl := l_stl + 1
						if (l_stl.item).to_integer_32 = 45 then
							l_stl := l_stl + 1
						end
						if (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_stl))).to_boolean then
							from
							until
								js.loop_done
							loop
								if (l_stl.item).to_integer_32 >= 48 then
									if not ((l_stl.item).to_integer_32 <= 57) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_stl := l_stl + 1
								end
							end
						end
						l_tmp___0 := l_stl
						l_stl := l_stl + 1
						if (l_tmp___0.item).to_integer_32 /= 40 then
							l_stl := option_inst.p_ruf.item
						end
					end
					l_col := (globals_inst.ru_col.to_integer_32 - (globals_inst.Columns.item - (a_wp___0.item.w_width).to_integer_32)).to_integer_32
					if l_col < (a_wp___0.item.w_width + 1) // 2 then
						l_col := (a_wp___0.item.w_width + 1) // 2
					end
					l_maxwidth := a_wp___0.item.w_width - l_col
					if not (a_wp___0.item.w_status_height).to_boolean then
						l_row := (globals_inst.Rows.item - 1).to_integer_32
						l_maxwidth := l_maxwidth - 1
						l_fillchar := (' ').code
						l_attr.item := 0
					end
					l_use_sandbox := option_inst.was_set_insecurely (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("rulerformat")), 0)
				else
					if ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 /= 0 then
						l_stl := a_wp___0.item.w_onebuf_opt.wo_stl
					else
						l_stl := option_inst.p_stl.item
					end
					if ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 = 0 then
						l_tmp___1 := 0
					else
						l_tmp___1 := 4
					end
					l_use_sandbox := option_inst.was_set_insecurely (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("statusline")), l_tmp___1)
				end
				l_col := l_col + (a_wp___0.item.w_wincol)
			end
			if l_maxwidth <= 0 then
				js.return
			end
			if not js.return_called then
				l_stl := misc2_inst.vim_strsave (l_stl)
				if a_wp___0.is_void then
					l_tmp___2 := globals_inst.curwin
				else
					l_tmp___2 := a_wp___0
				end
				l_width := buffer_inst.build_stl_str_hl (l_tmp___2, l_buf___6, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), l_stl, l_use_sandbox, l_fillchar, l_maxwidth, l_hltab, l_tabtab)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_stl))
				l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32
				from
				until
					js.loop_done
				loop
					if l_width < l_maxwidth then
						if not (l_len < ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32).to_integer_32 - 1) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_len := l_len + (globals_inst.mb_char2bytes.integer_32_item ([l_fillchar, l_buf___6 + l_len]))
						l_width := l_width + 1
					end
				end
				l_buf___6[l_len] := (('%/0/').code).to_natural_8
				l_curattr := l_attr.item
				l_p___0 := l_buf___6
				l_n := 0
				from
				until
					(l_hltab[l_n].start).is_void
				loop
					l_len := (l_hltab[l_n].start).distance (l_p___0)
					screen_puts_len (l_p___0, l_len, l_row, l_col, l_curattr)
					l_col := l_col + (charset_inst.vim_strnsize (l_p___0, l_len))
					l_p___0 := l_hltab[l_n].start
					if l_hltab[l_n].userhl = 0 then
						l_curattr := l_attr.item
					elseif l_hltab[l_n].userhl < 0 then
						l_curattr := syntax_inst.syn_id2attr (-l_hltab[l_n].userhl)
					elseif not a_wp___0.is_void then
						if not a_wp___0.is_equal (globals_inst.curwin) then
							if a_wp___0.item.w_status_height /= 0 then
								l_curattr := globals_inst.highlight_stlnc[l_hltab[l_n].userhl - 1]
							else
								l_curattr := globals_inst.highlight_user[l_hltab[l_n].userhl - 1]
							end
						else
							l_curattr := globals_inst.highlight_user[l_hltab[l_n].userhl - 1]
						end
					else
						l_curattr := globals_inst.highlight_user[l_hltab[l_n].userhl - 1]
					end
					l_n := l_n + 1
				end
				screen_puts (l_p___0, l_row, l_col, l_curattr)
				if a_wp___0.is_void then
					l_col := 0
					l_len := 0
					l_p___0 := l_buf___6
					l_fillchar := 0
					l_n := 0
					from
					until
						not (not js.loop_done and then (not (l_tabtab[l_n].start).is_void))
					loop
						l_len := l_len + (charset_inst.vim_strnsize (l_p___0, (l_tabtab[l_n].start).distance (l_p___0)))
						from
						until
							not (l_col < l_len)
						loop
							l_tmp___7 := l_col
							l_col := l_col + 1
							globals_inst.TabPageIdxs[l_tmp___7] := l_fillchar.to_integer_16
						end
						l_p___0 := l_tabtab[l_n].start
						l_fillchar := l_tabtab[l_n].userhl
						l_n := l_n + 1
					end
					from
					until
						not (l_col.to_integer_32 < globals_inst.Columns.item)
					loop
						l_tmp___8 := l_col
						l_col := l_col + 1
						globals_inst.TabPageIdxs[l_tmp___8] := l_fillchar.to_integer_16
					end
				end
			end
		end

	win_redr_ruler (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_always: INTEGER_32)
		local
			l_buffer: CE_ARRAY [NATURAL_8]
			l_row: INTEGER_32
			l_fillchar: INTEGER_32
			l_attr: CE_ARRAY [INTEGER_32]
			l_empty_line: INTEGER_32
			l_virtcol: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_len: NATURAL_32
			l_o: INTEGER_32
			l_this_ru_col: INTEGER_32
			l_off___0: INTEGER_32
			l_width: INTEGER_32
			l_save_called_emsg: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buffer.make (<<70>>)
			create l_attr.make (<<1>>)
			create l_virtcol.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_empty_line := 0
					l_off___0 := 0
					l_width := (globals_inst.Columns.item).to_integer_32
					if not (option_inst.p_ru.item).to_boolean then
						js.return
					end
					if not js.return_called and then (a_wp___0.item.w_cursor.lnum > (a_wp___0.item.w_buffer).item.b_ml.ml_line_count) then
						js.return
					end
					if not js.return_called and then (a_wp___0.is_equal (globals_inst.lastwin)) then
						if globals_inst.lastwin.item.w_status_height = 0 then
							if not globals_inst.edit_submode.is_void then
								js.return
							end
						end
					end
					if not js.return_called then
						if (popupmnu_inst.pum_visible).to_boolean then
							js.return
						end
					end
					if not js.return_called and then ((option_inst.p_ruf.item.item).to_boolean) then
						l_save_called_emsg := globals_inst.called_emsg
						globals_inst.called_emsg := 0
						win_redr_custom (a_wp___0, 1)
						if globals_inst.called_emsg.to_boolean then
							option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("rulerformat")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 1, -5)
						end
						globals_inst.called_emsg := (globals_inst.called_emsg).bit_or (l_save_called_emsg)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 30 -- skip if block
					end
				when 1 then -- if:
						if not ((globals_inst.State).bit_and (16)).to_boolean then
							if ((memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_wp___0.item.w_cursor.lnum, 0)).item).to_integer_32 = 0 then
								l_empty_line := 1
							end
						end
						move_inst.validate_virtcol_win (a_wp___0)
						if not (globals_inst.redraw_cmdline.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 4 then -- else:
						if not (a_always.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 7 then -- else:
						if a_wp___0.item.w_cursor.lnum = a_wp___0.item.w_ru_cursor.lnum then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 10 then -- else:
						if a_wp___0.item.w_cursor.col = a_wp___0.item.w_ru_cursor.col then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 13 then -- else:
						if a_wp___0.item.w_virtcol = a_wp___0.item.w_ru_virtcol then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 16 then -- else:
						if a_wp___0.item.w_cursor.coladd = a_wp___0.item.w_ru_cursor.coladd then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 19 then -- else:
						if a_wp___0.item.w_topline = a_wp___0.item.w_ru_topline then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 22 then -- else:
						if (a_wp___0.item.w_buffer).item.b_ml.ml_line_count = a_wp___0.item.w_ru_line_count then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 25 then -- else:
						if a_wp___0.item.w_topfill = a_wp___0.item.w_ru_topfill then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if l_empty_line = (a_wp___0.item.w_ru_empty).to_integer_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L:
						term_inst.cursor_off
						if (a_wp___0.item.w_status_height).to_boolean then
							l_row := a_wp___0.item.w_winrow + a_wp___0.item.w_height
							l_fillchar := fillchar_status (l_attr, (a_wp___0.is_equal (globals_inst.curwin)).to_integer)
							l_off___0 := a_wp___0.item.w_wincol
							l_width := a_wp___0.item.w_width
						else
							l_row := (globals_inst.Rows.item - 1).to_integer_32
							l_fillchar := (' ').code
							l_attr.item := 0
							l_width := (globals_inst.Columns.item).to_integer_32
							l_off___0 := 0
						end
						l_virtcol.item := a_wp___0.item.w_virtcol
						if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
							if globals_inst.lcs_tab1 = 0 then
								a_wp___0.item.w_onebuf_opt.wo_list := 0
								charset_inst.getvvcol (a_wp___0, create {CE_POINTER [PD_POS_T]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_virtcol, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								a_wp___0.item.w_onebuf_opt.wo_list := 1
							end
						end
						if (((a_wp___0.item.w_buffer).item.b_ml.ml_flags).bit_and (1)).to_boolean then
							l_tmp___1 := 0
						else
							l_tmp___1 := a_wp___0.item.w_cursor.lnum
						end
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer), (70).to_natural_32, ce_string ("%%ld,"), l_tmp___1]).do_nothing
						l_len := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer))
						if l_empty_line.to_boolean then
							l_tmp___2 := 0
						else
							l_tmp___2 := a_wp___0.item.w_cursor.col + 1
						end
						buffer_inst.col_print (l_buffer + l_len.to_integer_32, {NATURAL_32} 70 - l_len, l_tmp___2, l_virtcol.item + 1)
						l_i___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer))).to_integer_32
						buffer_inst.get_rel_pos (a_wp___0, (l_buffer + l_i___0) + 1, (70 - l_i___0) - 1)
						l_o := l_i___0 + (charset_inst.vim_strsize ((l_buffer + l_i___0) + 1))
						if a_wp___0.item.w_status_height = 0 then
							l_o := l_o + 1
						end
						l_this_ru_col := (globals_inst.ru_col.to_integer_32 - (globals_inst.Columns.item - l_width.to_integer_32)).to_integer_32
						if l_this_ru_col < 0 then
							l_this_ru_col := 0
						end
						if l_this_ru_col < (l_width + 1) // 2 then
							l_this_ru_col := (l_width + 1) // 2
						end
						if l_this_ru_col + l_o < l_width then
							from
							until
								not (l_this_ru_col + l_o < l_width)
							loop
								if globals_inst.has_mbyte.to_boolean then
									l_i___0 := l_i___0 + (globals_inst.mb_char2bytes.integer_32_item ([l_fillchar, l_buffer + l_i___0]))
								else
									l_tmp___6 := l_i___0
									l_i___0 := l_i___0 + 1
									l_buffer[l_tmp___6] := l_fillchar.to_natural_8
								end
								l_o := l_o + 1
							end
							buffer_inst.get_rel_pos (a_wp___0, l_buffer + l_i___0, 70 - l_i___0)
						end
						if globals_inst.has_mbyte.to_boolean then
							l_o := 0
							l_i___0 := 0
							from
							until
								not (not js.loop_done and then ((l_buffer[l_i___0]).to_integer_32 /= 0))
							loop
								l_o := l_o + (globals_inst.mb_ptr2cells.integer_32_item ([l_buffer + l_i___0]))
								if l_this_ru_col + l_o > l_width then
									l_buffer[l_i___0] := (('%/0/').code).to_natural_8
									js.break
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_buffer + l_i___0]))
								end
							end
						elseif l_this_ru_col + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer))).to_integer_32 > l_width then
							l_buffer[l_width - l_this_ru_col] := (('%/0/').code).to_natural_8
						end
						screen_puts (l_buffer, l_row, l_this_ru_col + l_off___0, l_attr.item)
						l_i___0 := globals_inst.redraw_cmdline
						screen_fill (l_row, l_row + 1, (l_this_ru_col + l_off___0) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer))).to_integer_32, l_off___0 + l_width, l_fillchar, l_fillchar, l_attr.item)
						globals_inst.redraw_cmdline := l_i___0
						a_wp___0.item.w_ru_cursor := (a_wp___0.item.w_cursor).twin
						a_wp___0.item.w_ru_virtcol := a_wp___0.item.w_virtcol
						a_wp___0.item.w_ru_empty := l_empty_line.to_integer_8
						a_wp___0.item.w_ru_topline := a_wp___0.item.w_topline
						a_wp___0.item.w_ru_line_count := (a_wp___0.item.w_buffer).item.b_ml.ml_line_count
						a_wp___0.item.w_ru_topfill := a_wp___0.item.w_topfill
				when 30 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	win_redr_status (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_row: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_fillchar: INTEGER_32
			l_attr: CE_ARRAY [INTEGER_32]
			l_this_ru_col: INTEGER_32
			l_tmp___0: INTEGER_32
			l_clen: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_attr.make (<<1>>)

			if busy___1.to_boolean then
				js.return
			end
			if not js.return_called then
				busy___1 := 1
				a_wp___0.item.w_redr_status := 0
				if a_wp___0.item.w_status_height = 0 then
					globals_inst.redraw_cmdline := 1
				elseif (redrawing).to_boolean then
					if (popupmnu_inst.pum_visible).to_boolean then
						a_wp___0.item.w_redr_status := 1
					elseif (option_inst.p_stl.item.item).to_integer_32 /= 0 then
						redraw_custom_statusline (a_wp___0)
					elseif ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 /= 0 then
						redraw_custom_statusline (a_wp___0)
					else
						l_fillchar := fillchar_status (l_attr, (a_wp___0.is_equal (globals_inst.curwin)).to_integer)
						get_trans_bufname (a_wp___0.item.w_buffer)
						l_p___0 := globals_inst.NameBuff.item
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
						if ((a_wp___0.item.w_buffer).item.b_help).to_boolean then
							l_tmp___0 := l_len
							l_len := l_len + 1
							l_p___0[l_tmp___0] := ((' ').code).to_natural_8
						elseif (a_wp___0.item.w_onebuf_opt.wo_pvw).to_boolean then
							l_tmp___0 := l_len
							l_len := l_len + 1
							l_p___0[l_tmp___0] := ((' ').code).to_natural_8
						elseif (undo_inst.bufIsChanged (a_wp___0.item.w_buffer)).to_boolean then
							l_tmp___0 := l_len
							l_len := l_len + 1
							l_p___0[l_tmp___0] := ((' ').code).to_natural_8
						elseif ((a_wp___0.item.w_buffer).item.b_p_ro).to_boolean then
							l_tmp___0 := l_len
							l_len := l_len + 1
							l_p___0[l_tmp___0] := ((' ').code).to_natural_8
						end
						if ((a_wp___0.item.w_buffer).item.b_help).to_boolean then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_len)), (gettext (ce_string ("[Help]")))).do_nothing
							l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_len)))).to_integer_32
						end
						if (a_wp___0.item.w_onebuf_opt.wo_pvw).to_boolean then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_len)), (gettext (ce_string ("[Preview]")))).do_nothing
							l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_len)))).to_integer_32
						end
						if (undo_inst.bufIsChanged (a_wp___0.item.w_buffer)).to_boolean then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_len)), ce_string ("[+]")).do_nothing
							l_len := l_len + (3)
						end
						if ((a_wp___0.item.w_buffer).item.b_p_ro).to_boolean then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_len)), ce_string ("[RO]")).do_nothing
							l_len := l_len + (4)
						end
						l_this_ru_col := (globals_inst.ru_col.to_integer_32 - (globals_inst.Columns.item - (a_wp___0.item.w_width).to_integer_32)).to_integer_32
						if l_this_ru_col < (a_wp___0.item.w_width + 1) // 2 then
							l_this_ru_col := (a_wp___0.item.w_width + 1) // 2
						end
						if l_this_ru_col <= 1 then
							l_p___0 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<"))
							l_len := 1
						elseif globals_inst.has_mbyte.to_boolean then
							l_clen := 0
							l_clen := mbyte_inst.mb_string2cells (l_p___0, -1)
							l_i___0 := 0
							from
							until
								js.loop_done
							loop
								if (l_p___0[l_i___0]).to_integer_32 /= 0 then
									if not (l_clen >= l_this_ru_col - 1) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_clen := l_clen - (globals_inst.mb_ptr2cells.integer_32_item ([l_p___0 + l_i___0]))
									l_i___0 := l_i___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_p___0 + l_i___0]))
								end
							end
							l_len := l_clen
							if l_i___0 > 0 then
								l_p___0 := (l_p___0 + l_i___0) - 1
								l_p___0.item := (('<').code).to_natural_8
								l_len := l_len + 1
							end
						elseif l_len > l_this_ru_col - 1 then
							l_p___0 := l_p___0 + (l_len - (l_this_ru_col - 1))
							l_p___0.item := (('<').code).to_natural_8
							l_len := l_this_ru_col - 1
						end
						l_row := a_wp___0.item.w_winrow + a_wp___0.item.w_height
						screen_puts (l_p___0, l_row, a_wp___0.item.w_wincol, l_attr.item)
						screen_fill (l_row, l_row + 1, l_len + a_wp___0.item.w_wincol, l_this_ru_col + a_wp___0.item.w_wincol, l_fillchar, l_fillchar, l_attr.item)
						if (get_keymap_str (a_wp___0, globals_inst.NameBuff.item, 4_096)).to_boolean then
							if l_this_ru_col - l_len > ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff.item))) + {NATURAL_32} 1).to_integer_32 then
								screen_puts (globals_inst.NameBuff.item, l_row, (((l_this_ru_col.to_natural_32 - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff.item)))) - {NATURAL_32} 1) + (a_wp___0.item.w_wincol).to_natural_32).to_integer_32, l_attr.item)
							end
						end
						win_redr_ruler (a_wp___0, 1)
					end
				else
					a_wp___0.item.w_redr_status := 1
				end
				if a_wp___0.item.w_vsep_width /= 0 then
					if a_wp___0.item.w_status_height /= 0 then
						if (redrawing).to_boolean then
							if (stl_connected (a_wp___0)).to_boolean then
								l_fillchar := fillchar_status (l_attr, (a_wp___0.is_equal (globals_inst.curwin)).to_integer)
							else
								l_fillchar := fillchar_vsep (l_attr)
							end
							screen_putchar (l_fillchar, a_wp___0.item.w_winrow + a_wp___0.item.w_height, a_wp___0.item.w_wincol + a_wp___0.item.w_width, l_attr.item)
						end
					end
				end
				busy___1 := 0
			end
		end

	win_redr_status_matches (a_xp: CE_POINTER [PD_EXPAND]; a_num_matches___0: INTEGER_32; a_matches___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_match: INTEGER_32; a_showtail: INTEGER_32)
		local
			l_match: INTEGER_32
			l_row: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_clen: INTEGER_32
			l_fillchar: INTEGER_32
			l_attr: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_highlight: INTEGER_32
			l_selstart: CE_POINTER [NATURAL_8]
			l_selstart_col: INTEGER_32
			l_selend: CE_POINTER [NATURAL_8]
			l_add_left: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_emenu: INTEGER_32
			l_l: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: NATURAL_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___25: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_attr.make (<<1>>)
			create l_selstart.make
			create l_selend.make
			create l_s.make
			create l_tmp___0.make
			create l_tmp___3.make
			create l_tmp___6.make
			create l_tmp___9.make
			create l_tmp___17.make
			create l_tmp___23.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_match := a_match
					l_highlight := 1
					l_selstart := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_selstart_col := 0
					l_selend := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_add_left := 0
					if a_matches___0.is_void then
						js.return
					end
					if not js.return_called then
						if globals_inst.has_mbyte.to_boolean then
							l_buf___6 := misc2_inst.alloc ((globals_inst.Columns.item).to_natural_32 * {NATURAL_32} 21 + {NATURAL_32} 1)
						else
							l_buf___6 := misc2_inst.alloc ((globals_inst.Columns.item).to_natural_32 + {NATURAL_32} 1)
						end
						if l_buf___6.is_void then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if l_match = -1 then
							l_match := 0
							l_highlight := 0
						end
						if a_showtail.to_boolean then
							l_tmp___0 := (ex_getln_inst.sm_gettail (a_matches___0[l_match]))
						else
							l_tmp___0 := a_matches___0[l_match]
						end
						l_clen := (status_match_len (a_xp, l_tmp___0)) + 3
						if l_match = 0 then
							first_match := 0
						elseif l_match < first_match then
							first_match := l_match
							l_add_left := 1
						else
							l_i___0 := first_match
							from
							until
								not (l_i___0 < l_match)
							loop
								if a_showtail.to_boolean then
									l_tmp___3 := (ex_getln_inst.sm_gettail (a_matches___0[l_i___0]))
								else
									l_tmp___3 := a_matches___0[l_i___0]
								end
								l_clen := l_clen + ((status_match_len (a_xp, l_tmp___3)) + 2)
								l_i___0 := l_i___0 + 1
							end
							if first_match > 0 then
								l_clen := l_clen + (2)
							end
							if l_clen.to_integer_32 > globals_inst.Columns.item then
								first_match := l_match
								l_clen := 2
								l_i___0 := l_match
								from
								until
									not (not js.loop_done and then (l_i___0 < a_num_matches___0))
								loop
									if a_showtail.to_boolean then
										l_tmp___6 := (ex_getln_inst.sm_gettail (a_matches___0[l_i___0]))
									else
										l_tmp___6 := a_matches___0[l_i___0]
									end
									l_clen := l_clen + ((status_match_len (a_xp, l_tmp___6)) + 2)
									if l_clen.to_integer_32 >= globals_inst.Columns.item then
										js.break
									end
									if not js.loop_jumped then
										l_i___0 := l_i___0 + 1
									end
								end
								if l_i___0 = a_num_matches___0 then
									l_add_left := 1
								end
							end
						end
						if l_add_left.to_boolean then
							from
							until
								not (not js.loop_done and then (first_match > 0))
							loop
								if a_showtail.to_boolean then
									l_tmp___9 := (ex_getln_inst.sm_gettail (a_matches___0[(first_match - 1)]))
								else
									l_tmp___9 := a_matches___0[(first_match - 1)]
								end
								l_clen := l_clen + ((status_match_len (a_xp, l_tmp___9)) + 2)
								if l_clen.to_integer_32 >= globals_inst.Columns.item then
									js.break
								end
								if not js.loop_jumped then
									first_match := first_match - 1
								end
							end
						end
						l_fillchar := fillchar_status (l_attr, 1)
						if first_match = 0 then
							l_buf___6.item := (('%/0/').code).to_natural_8
							l_len := 0
						else
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("< ")).do_nothing
							l_len := 2
						end
						l_clen := l_len
						l_i___0 := first_match
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						if a_showtail.to_boolean then
							l_tmp___23 := (ex_getln_inst.sm_gettail (a_matches___0[l_i___0]))
						else
							l_tmp___23 := a_matches___0[l_i___0]
						end
						if not (((l_clen + (status_match_len (a_xp, l_tmp___23))) + 2).to_integer_32 < globals_inst.Columns.item) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_i___0 = l_match then
							l_selstart := l_buf___6 + l_len
							l_selstart_col := l_clen
						end
						if a_showtail.to_boolean then
							l_s := (ex_getln_inst.sm_gettail (a_matches___0[l_i___0]))
						else
							l_s := a_matches___0[l_i___0]
						end
						if a_xp.item.xp_context = 11 then
							l_tmp___12 := 1
						elseif a_xp.item.xp_context = 21 then
							l_tmp___12 := 1
						else
							l_tmp___12 := 0
						end
						l_emenu := l_tmp___12
						if not (l_emenu.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (menu_inst.menu_is_separator (l_s)).to_boolean then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_len)), create {CE_POINTER [INTEGER_8]}.make_cast ((charset_inst.transchar (('|').code)))).do_nothing
							l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_len)))).to_integer_32
							l_len := l_len + l_l
							l_clen := l_clen + l_l
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							(l_s.item).to_integer_32 = 0
						loop
							l_s := l_s + (skip_status_match_char (a_xp, l_s))
							l_clen := l_clen + (charset_inst.ptr2cells (l_s))
							if globals_inst.has_mbyte.to_boolean then
								l_l := globals_inst.mb_ptr2len.integer_32_item ([l_s])
								if l_l > 1 then
									strncpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_len)), create {CE_POINTER [INTEGER_8]}.make_cast (l_s), l_l.to_natural_32).do_nothing
									l_s := l_s + (l_l - 1)
									l_len := l_len + l_l
								else
									l_tmp___17 := charset_inst.transchar_byte ((l_s.item).to_integer_32)
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_len)), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___17)).do_nothing
									l_tmp___18 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_len)))
									l_len := l_len + l_tmp___18.to_integer_32
								end
							else
								l_tmp___17 := charset_inst.transchar_byte ((l_s.item).to_integer_32)
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_len)), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___17)).do_nothing
								l_tmp___18 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_len)))
								l_len := l_len + l_tmp___18.to_integer_32
							end
							l_s := l_s + 1
						end
				when 8 then
						if l_i___0 = l_match then
							l_selend := l_buf___6 + l_len
						end
						l_tmp___20 := l_len
						l_len := l_len + 1
						l_buf___6[l_tmp___20] := ((' ').code).to_natural_8
						l_tmp___21 := l_len
						l_len := l_len + 1
						l_buf___6[l_tmp___21] := ((' ').code).to_natural_8
						l_clen := l_clen + (2)
						l_i___0 := l_i___0 + 1
						if l_i___0 = a_num_matches___0 then
							js.break
						end
				when 9 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						if l_i___0 /= a_num_matches___0 then
							l_tmp___25 := l_len
							l_len := l_len + 1
							l_buf___6[l_tmp___25] := (('>').code).to_natural_8
							l_clen := l_clen + 1
						end
						l_buf___6[l_len] := (('%/0/').code).to_natural_8
						l_row := globals_inst.cmdline_row - 1
						if l_row >= 0 then
							if globals_inst.wild_menu_showing = 0 then
								if globals_inst.msg_scrolled > 0 then
									if globals_inst.cmdline_row.to_integer_32 = globals_inst.Rows.item - 1 then
										screen_del_lines (0, 0, 1, (globals_inst.Rows.item).to_integer_32, 1, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)).do_nothing
										globals_inst.msg_scrolled := globals_inst.msg_scrolled + 1
									else
										globals_inst.cmdline_row := globals_inst.cmdline_row + 1
										l_row := l_row + 1
									end
									globals_inst.wild_menu_showing := 2
								else
									if globals_inst.lastwin.item.w_status_height = 0 then
										globals_inst.save_p_ls := (option_inst.p_ls.item).to_integer_32
										globals_inst.save_p_wmh := (option_inst.p_wmh.item).to_integer_32
										option_inst.p_ls.item := 2
										option_inst.p_wmh.item := 0
										window_inst.last_status (0)
									end
									globals_inst.wild_menu_showing := 1
								end
							end
							screen_puts (l_buf___6, l_row, 0, l_attr.item)
							if not l_selstart.is_void then
								if l_highlight.to_boolean then
									l_selend.item := (('%/0/').code).to_natural_8
									screen_puts (l_selstart, l_row, l_selstart_col, globals_inst.highlight_attr[18])
								end
							end
							screen_fill (l_row, l_row + 1, l_clen, (globals_inst.Columns.item).to_integer_32, l_fillchar, l_fillchar, l_attr.item)
						end
						win_redraw_last_status (globals_inst.topframe)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_redraw_last_status (a_frp: CE_POINTER [PD_FRAME_S])
		local
			l_frp: CE_POINTER [PD_FRAME_S]
		do
			create l_frp.make

			l_frp := a_frp
			if (l_frp.item.fr_layout).to_integer_32 = 0 then
				(l_frp.item.fr_win).item.w_redr_status := 1
			elseif (l_frp.item.fr_layout).to_integer_32 = 1 then
				l_frp := l_frp.item.fr_child
				from
				until
					l_frp.is_void
				loop
					win_redraw_last_status (l_frp)
					l_frp := l_frp.item.fr_next
				end
			else
				l_frp := l_frp.item.fr_child
				from
				until
					(l_frp.item.fr_next).is_void
				loop
					l_frp := l_frp.item.fr_next
				end
				win_redraw_last_status (l_frp)
			end
		end

	win_rest_invalid (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			create l_wp___0.make

			l_wp___0 := a_wp___0
			from
			until
				l_wp___0.is_void
			loop
				redraw_win_later (l_wp___0, 40)
				l_wp___0.item.w_redr_status := 1
				l_wp___0 := l_wp___0.item.w_next
			end
			globals_inst.redraw_cmdline := 1
		end

	win_update (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_type: INTEGER_32
			l_top_end: INTEGER_32
			l_mid_start: INTEGER_32
			l_mid_end: INTEGER_32
			l_bot_start: INTEGER_32
			l_scrolled_down: INTEGER_32
			l_cur: CE_POINTER [PD_MATCHITEM]
			l_top_to_mod: INTEGER_32
			l_row: INTEGER_32
			l_lnum: INTEGER_32
			l_idx: INTEGER_32
			l_srow: INTEGER_32
			l_eof: INTEGER_32
			l_didline: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_old_botline: INTEGER_32
			l_fold_count: INTEGER_32
			l_did_update: INTEGER_32
			l_syntax_last_parsed: INTEGER_32
			l_mod_top: CE_ARRAY [INTEGER_32]
			l_mod_bot: CE_ARRAY [INTEGER_32]
			l_save_got_int: INTEGER_32
			l_tmp: INTEGER_32
			l_lnumt: INTEGER_32
			l_lnumb: INTEGER_32
			l_ln: CE_ARRAY [INTEGER_32]
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___12: INTEGER_32
			l_from: INTEGER_32
			l_to: INTEGER_32
			l_fromc: CE_ARRAY [INTEGER_32]
			l_toc: CE_ARRAY [INTEGER_32]
			l_old_rows: INTEGER_32
			l_new_rows: INTEGER_32
			l_xtra_rows: INTEGER_32
			l_l: CE_ARRAY [INTEGER_32]
			l_tmp___14: INTEGER_32
			l_x___0: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___25: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_cur.make
			create l_mod_top.make (<<1>>)
			create l_mod_bot.make (<<1>>)
			create l_ln.make (<<1>>)
			create l_fromc.make (<<1>>)
			create l_toc.make (<<1>>)
			create l_l.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := a_wp___0.item.w_buffer
					l_top_end := 0
					l_mid_start := 999
					l_mid_end := 0
					l_bot_start := 999
					l_scrolled_down := 0
					l_top_to_mod := 0
					l_eof := 0
					l_didline := 0
					l_old_botline := (a_wp___0.item.w_botline).to_integer_32
					l_did_update := 1
					l_syntax_last_parsed := (0).to_integer_32
					l_mod_top.item := (0).to_integer_32
					l_mod_bot.item := (0).to_integer_32
					l_type := a_wp___0.item.w_redr_type
					if l_type = 40 then
						a_wp___0.item.w_redr_status := 1
						a_wp___0.item.w_lines_valid := 0
					end
					if a_wp___0.item.w_height = 0 then
						a_wp___0.item.w_redr_type := 0
						js.return
					end
					if not js.return_called and then (a_wp___0.item.w_width = 0) then
						draw_vsep_win (a_wp___0, 0)
						a_wp___0.item.w_redr_type := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 155 -- skip if block
					end
				when 1 then -- if:
						init_search_hl (a_wp___0)
						if (a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean then
							l_tmp := number_width (a_wp___0)
							l_i___0 := l_tmp
						elseif (a_wp___0.item.w_onebuf_opt.wo_rnu).to_boolean then
							l_tmp := number_width (a_wp___0)
							l_i___0 := l_tmp
						else
							l_i___0 := 0
						end
						if a_wp___0.item.w_nrwidth = l_i___0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_type := 40
						a_wp___0.item.w_nrwidth := l_i___0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else:
						if not ((l_buf___6.item.b_mod_set).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_buf___6.item.b_mod_xlines /= 0 then
							if a_wp___0.item.w_redraw_top /= 0 then
								l_type := 40
							else
								l_pos := -1 + 7 -- goto _L___2
							end
						else
							l_pos := -1 + 7 -- goto _L___2
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else: | _L___2:
						l_mod_top.item := a_wp___0.item.w_redraw_top
						if a_wp___0.item.w_redraw_bot /= 0 then
							l_mod_bot.item := a_wp___0.item.w_redraw_bot + 1
						else
							l_mod_bot.item := (0).to_integer_32
						end
						a_wp___0.item.w_redraw_top := (0).to_integer_32
						a_wp___0.item.w_redraw_bot := (0).to_integer_32
						if not ((l_buf___6.item.b_mod_set).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if l_mod_top.item /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (l_mod_top.item > l_buf___6.item.b_mod_top) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_mod_top.item := l_buf___6.item.b_mod_top
						if (syntax_inst.syntax_present (a_wp___0)).to_boolean then
							l_mod_top.item := l_mod_top.item - (l_buf___6.item.b_s.b_syn_sync_linebreaks)
							if l_mod_top.item < 1 then
								l_mod_top.item := (1).to_integer_32
							end
						end
				when 13 then -- if done
						if l_mod_bot.item = 0 then
							l_mod_bot.item := l_buf___6.item.b_mod_bot
						elseif l_mod_bot.item < l_buf___6.item.b_mod_bot then
							l_mod_bot.item := l_buf___6.item.b_mod_bot
						end
						if (search_hl.item.rm.regprog).is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if (regexp_inst.re_multiline (search_hl.item.rm.regprog)).to_boolean then
							l_top_to_mod := 1
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						l_cur := a_wp___0.item.w_match_head
						from
						until
							not (not js.loop_done and then (not l_cur.is_void))
						loop
							if not (l_cur.item.match.regprog).is_void then
								if (regexp_inst.re_multiline (l_cur.item.match.regprog)).to_boolean then
									l_top_to_mod := 1
									js.break
								end
							end
							if not js.loop_jumped then
								l_cur := l_cur.item.next
							end
						end
				when 17 then -- if done
						if l_mod_top.item /= 0 then
							if (fold_inst.hasAnyFolding (a_wp___0)).to_boolean then
								l_lnumt := a_wp___0.item.w_topline
								l_lnumb := 2_147_483_647
								l_i___0 := 0
								from
								until
									not (l_i___0 < a_wp___0.item.w_lines_valid)
								loop
									if ((a_wp___0.item.w_lines + l_i___0).item.wl_valid).to_boolean then
										if (a_wp___0.item.w_lines + l_i___0).item.wl_lastlnum < l_mod_top.item then
											l_lnumt := (a_wp___0.item.w_lines + l_i___0).item.wl_lastlnum + 1
										end
										if l_lnumb = 2_147_483_647 then
											if (a_wp___0.item.w_lines + l_i___0).item.wl_lnum >= l_mod_bot.item then
												l_lnumb := (a_wp___0.item.w_lines + l_i___0).item.wl_lnum
												if a_wp___0.item.w_onebuf_opt.wo_fdc > 0 then
													l_lnumb := l_lnumb + 1
												end
											end
										end
									end
									l_i___0 := l_i___0 + 1
								end
								fold_inst.hasFoldingWin (a_wp___0, l_mod_top.item, l_mod_top, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
								if l_mod_top.item > l_lnumt then
									l_mod_top.item := l_lnumt
								end
								l_mod_bot.item := l_mod_bot.item - 1
								fold_inst.hasFoldingWin (a_wp___0, l_mod_bot.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_mod_bot, 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
								l_mod_bot.item := l_mod_bot.item + 1
								if l_mod_bot.item < l_lnumb then
									l_mod_bot.item := l_lnumb
								end
							end
						end
						if l_mod_top.item /= 0 then
							if l_mod_top.item < a_wp___0.item.w_topline then
								if l_mod_bot.item > a_wp___0.item.w_topline then
									l_mod_top.item := a_wp___0.item.w_topline
								elseif (syntax_inst.syntax_present (a_wp___0)).to_boolean then
									l_top_end := 1
								end
							end
						end
						if l_mod_top.item /= 0 then
							if l_buf___6.item.b_mod_xlines /= 0 then
								if (a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean then
									l_mod_bot.item := 2_147_483_647
								end
							end
						end
				when 18 then -- if done
						if l_type = 30 then
							l_j := 0
							l_i___0 := 0
							from
							until
								not (not js.loop_done and then (l_i___0 < a_wp___0.item.w_lines_valid))
							loop
								l_j := l_j + ((a_wp___0.item.w_lines + l_i___0).item.wl_size).to_integer_32
								if l_j >= (a_wp___0.item.w_upd_rows).to_integer_32 then
									l_top_end := l_j.to_integer_32
									js.break
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							if l_top_end = 0 then
								l_type := 40
							else
								l_type := 10
							end
						end
						if globals_inst.screen_cleared.to_boolean then
							globals_inst.screen_cleared := 2
						end
						if l_type /= 10 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 28 -- goto _L___7
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 21 then -- else:
						if l_type /= 35 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 28 -- goto _L___7
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 24 then -- else:
						if l_type /= 20 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___7
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 27 then -- else:
						if l_type /= 25 then
							l_pos := -1 + 59 -- skip if block
						end
				when 28 then -- if: | _L___7:
						if (a_wp___0.item.w_botfill).to_boolean then
							l_pos := -1 + 57 -- skip if block
						end
				when 29 then -- if:
						if (a_wp___0.item.w_old_botfill).to_boolean then
							l_pos := -1 + 55 -- skip if block
						end
				when 30 then -- if:
						if l_mod_top.item = 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if a_wp___0.item.w_topline /= l_mod_top.item then
							l_pos := -1 + 33 -- goto _L___6
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 33 then -- else: | _L___6:
						if not (((a_wp___0.item.w_lines + 0).item.wl_valid).to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 34 then -- if:
						if not (a_wp___0.item.w_topline < (a_wp___0.item.w_lines + 0).item.wl_lnum) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 39 -- goto _L___5
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 37 then -- else:
						if a_wp___0.item.w_topline /= (a_wp___0.item.w_lines + 0).item.wl_lnum then
							l_pos := -1 + 43 -- skip if block
						end
				when 38 then -- if:
						if not (a_wp___0.item.w_topfill > a_wp___0.item.w_old_topfill) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if: | _L___5:
						if (fold_inst.hasAnyFolding (a_wp___0)).to_boolean then
							l_j := 0
							l_ln.item := a_wp___0.item.w_topline
							from
							until
								not (not js.loop_done and then (l_ln.item < (a_wp___0.item.w_lines + 0).item.wl_lnum))
							loop
								l_j := l_j + 1
								if l_j >= (a_wp___0.item.w_height - 2).to_integer_32 then
									js.break
								end
								if not js.loop_jumped then
									fold_inst.hasFoldingWin (a_wp___0, l_ln.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_ln, 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
									l_ln.item := l_ln.item + 1
								end
							end
						else
							l_j := (a_wp___0.item.w_lines + 0).item.wl_lnum - a_wp___0.item.w_topline
						end
						if l_j < (a_wp___0.item.w_height - 2).to_integer_32 then
							l_i___0 := misc1_inst.plines_m_win (a_wp___0, a_wp___0.item.w_topline, (a_wp___0.item.w_lines + 0).item.wl_lnum - 1)
							if (a_wp___0.item.w_lines + 0).item.wl_lnum /= a_wp___0.item.w_topline then
								l_i___0 := l_i___0 + ((diff_inst.diff_check_fill (a_wp___0, (a_wp___0.item.w_lines + 0).item.wl_lnum)) - a_wp___0.item.w_old_topfill)
							end
							if l_i___0 < a_wp___0.item.w_height - 2 then
								if l_i___0 > 0 then
									check_for_delay (0)
								end
								if (win_ins_lines (a_wp___0, 0, l_i___0, 0, (a_wp___0.is_equal (globals_inst.firstwin)).to_integer)) = 1 then
									if a_wp___0.item.w_lines_valid /= 0 then
										l_top_end := l_i___0
										l_scrolled_down := 1
										l_tmp___7 := ((a_wp___0.item.w_lines_valid).to_integer_32 + l_j).to_integer_32
										a_wp___0.item.w_lines_valid := l_tmp___7
										if l_tmp___7 > a_wp___0.item.w_height then
											a_wp___0.item.w_lines_valid := a_wp___0.item.w_height
										end
										l_idx := a_wp___0.item.w_lines_valid
										from
										until
											not (l_idx.to_integer_32 - l_j >= 0)
										loop
											a_wp___0.item.w_lines[l_idx] := (a_wp___0.item.w_lines[(l_idx.to_integer_32 - l_j)]).twin
											l_idx := l_idx - 1
										end
										from
										until
											not (l_idx >= 0)
										loop
											l_tmp___8 := l_idx
											l_idx := l_idx - 1;
											(a_wp___0.item.w_lines + l_tmp___8).item.wl_valid := (0).to_integer_8
										end
									end
								else
									l_mid_start := 0
								end
							else
								l_mid_start := 0
							end
						else
							l_mid_start := 0
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_pos := -1 + 45 -- goto _L___4
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_pos := -1 + 45 -- goto _L___4
				when 44 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 53
				when 45 then -- else: | _L___4:
						l_j := -1
						l_row := 0
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0 < a_wp___0.item.w_lines_valid))
						loop
							if ((a_wp___0.item.w_lines + l_i___0).item.wl_valid).to_boolean then
								if (a_wp___0.item.w_lines + l_i___0).item.wl_lnum = a_wp___0.item.w_topline then
									l_j := l_i___0.to_integer_32
									js.break
								end
							end
							if not js.loop_jumped then
								l_row := l_row + ((a_wp___0.item.w_lines + l_i___0).item.wl_size).to_integer_32
								l_i___0 := l_i___0 + 1
							end
						end
						if l_j /= -1 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_mid_start := 0
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 48 then -- else:
						if (a_wp___0.item.w_lines + 0).item.wl_lnum = a_wp___0.item.w_topline then
							l_row := l_row + (a_wp___0.item.w_old_topfill)
						else
							l_row := l_row + (diff_inst.diff_check_fill (a_wp___0, a_wp___0.item.w_topline))
						end
						l_row := l_row - (a_wp___0.item.w_topfill)
						if l_row > 0 then
							check_for_delay (0)
							if (win_del_lines (a_wp___0, 0, l_row, 0, (a_wp___0.is_equal (globals_inst.firstwin)).to_integer)) = 1 then
								l_bot_start := a_wp___0.item.w_height - l_row
							else
								l_mid_start := 0
							end
						end
						if l_row /= 0 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto _L___3
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 51 then -- else:
						if not (l_bot_start < 999) then
							l_pos := -1 + 53 -- skip if block
						end
				when 52 then -- if: | _L___3:
						if a_wp___0.item.w_lines_valid /= 0 then
							l_bot_start := 0
							l_idx := 0
							from
							until
								js.loop_done
							loop
								a_wp___0.item.w_lines[l_idx] := (a_wp___0.item.w_lines[l_j]).twin
								if l_row > 0 then
									if (l_bot_start + l_row) + ((a_wp___0.item.w_lines + l_j).item.wl_size).to_integer_32 > a_wp___0.item.w_height then
										a_wp___0.item.w_lines_valid := l_idx + 1
										js.break
									end
								end
								if not js.loop_jumped then
									l_tmp___12 := l_idx
									l_idx := l_idx + 1
									l_bot_start := l_bot_start + ((a_wp___0.item.w_lines + l_tmp___12).item.wl_size).to_integer_32
									l_j := l_j + 1
									if l_j >= (a_wp___0.item.w_lines_valid).to_integer_32 then
										a_wp___0.item.w_lines_valid := l_idx
										js.break
									end
								end
							end
							if (a_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
								if l_bot_start > 0 then
									(a_wp___0.item.w_lines + 0).item.wl_size := ((misc1_inst.plines_win_nofill (a_wp___0, a_wp___0.item.w_topline, 1)) + a_wp___0.item.w_topfill).to_natural_16
								end
							end
						end
				when 53 then -- if done | if done | if done | if done
						if l_mid_start = 0 then
							l_mid_end := a_wp___0.item.w_height
							if globals_inst.lastwin.is_equal (globals_inst.firstwin) then
								if globals_inst.screen_cleared /= 1 then
									screenclear
								end
								if globals_inst.redraw_tabline.to_boolean then
									draw_tabline
								end
							end
						end
						if globals_inst.screen_cleared = 1 then
							globals_inst.must_redraw := 0
						end
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 55 then -- else:
						l_mid_start := 0
						l_mid_end := a_wp___0.item.w_height
				when 56 then -- if done | if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else:
						l_mid_start := 0
						l_mid_end := a_wp___0.item.w_height
				when 58 then -- if done | if block done, skip else block:
						l_pos := -1 + 60
				when 59 then -- else:
						l_mid_start := 0
						l_mid_end := a_wp___0.item.w_height
				when 60 then -- if done | if done | if done
						if l_type = 35 then
							l_mid_start := 0
							l_mid_end := a_wp___0.item.w_height
							l_type := 40
						end
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if l_buf___6.is_equal (globals_inst.curwin.item.w_buffer) then
							l_pos := -1 + 65 -- goto _L___12
						else
							l_pos := -1 + 63 -- goto _L___13
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 90
				when 63 then -- else: | _L___13:
						if a_wp___0.item.w_old_cursor_lnum = 0 then
							l_pos := -1 + 90 -- skip if block
						end
				when 64 then -- if:
						if l_type = 40 then
							l_pos := -1 + 90 -- skip if block
						end
				when 65 then -- if: | _L___12:
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 88 -- skip if block
						end
				when 66 then -- if:
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 75 -- skip if block
						end
				when 67 then -- if:
						if globals_inst.VIsual_mode = (a_wp___0.item.w_old_visual_mode).to_integer_32 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_pos := -1 + 71 -- goto _L___10
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 70 then -- else:
						if l_type /= 25 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if: | _L___10:
						if globals_inst.curwin.item.w_cursor.lnum < globals_inst.VIsual.item.lnum then
							l_from := globals_inst.curwin.item.w_cursor.lnum
							l_to := globals_inst.VIsual.item.lnum
						else
							l_from := globals_inst.VIsual.item.lnum
							l_to := globals_inst.curwin.item.w_cursor.lnum
						end
						if a_wp___0.item.w_old_cursor_lnum < l_from then
							l_from := a_wp___0.item.w_old_cursor_lnum
						end
						if a_wp___0.item.w_old_cursor_lnum > l_to then
							l_to := a_wp___0.item.w_old_cursor_lnum
						end
						if a_wp___0.item.w_old_visual_lnum < l_from then
							l_from := a_wp___0.item.w_old_visual_lnum
						end
						if a_wp___0.item.w_old_visual_lnum > l_to then
							l_to := a_wp___0.item.w_old_visual_lnum
						end
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 73 then -- else:
						l_pos := -1 + 75 -- goto _L___9
				when 74 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 80
				when 75 then -- else: | _L___9:
						if globals_inst.curwin.item.w_cursor.lnum < a_wp___0.item.w_old_cursor_lnum then
							l_from := globals_inst.curwin.item.w_cursor.lnum
							l_to := a_wp___0.item.w_old_cursor_lnum
						else
							l_from := a_wp___0.item.w_old_cursor_lnum
							l_to := globals_inst.curwin.item.w_cursor.lnum
							if l_from = 0 then
								l_from := l_to
							end
						end
						if globals_inst.VIsual.item.lnum = a_wp___0.item.w_old_visual_lnum then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						l_pos := -1 + 79 -- goto _L___8
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 78 then -- else:
						if globals_inst.VIsual.item.col = a_wp___0.item.w_old_visual_col then
							l_pos := -1 + 80 -- skip if block
						end
				when 79 then -- if: | _L___8:
						if a_wp___0.item.w_old_visual_lnum < l_from then
							if a_wp___0.item.w_old_visual_lnum /= 0 then
								l_from := a_wp___0.item.w_old_visual_lnum
							end
						end
						if a_wp___0.item.w_old_visual_lnum > l_to then
							l_to := a_wp___0.item.w_old_visual_lnum
						end
						if globals_inst.VIsual.item.lnum < l_from then
							l_from := globals_inst.VIsual.item.lnum
						end
						if globals_inst.VIsual.item.lnum > l_to then
							l_to := globals_inst.VIsual.item.lnum
						end
				when 80 then -- if done | if done
						if globals_inst.VIsual_mode /= 22 then
							l_pos := -1 + 87 -- skip if block
						end
				when 81 then -- if:
						charset_inst.getvcols (a_wp___0, globals_inst.VIsual, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_fromc, l_toc)
						l_toc.item := l_toc.item + 1
						if (globals_inst.curwin.item.w_curswant).to_integer_32 = 2_147_483_647 then
							l_toc.item := (2_147_483_647).to_integer_32
						end
						if l_fromc.item = a_wp___0.item.w_old_cursor_fcol then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						l_pos := -1 + 85 -- goto _L___11
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 86
				when 84 then -- else:
						if l_toc.item = a_wp___0.item.w_old_cursor_lcol then
							l_pos := -1 + 86 -- skip if block
						end
				when 85 then -- if: | _L___11:
						if l_from > globals_inst.VIsual.item.lnum then
							l_from := globals_inst.VIsual.item.lnum
						end
						if l_to < globals_inst.VIsual.item.lnum then
							l_to := globals_inst.VIsual.item.lnum
						end
				when 86 then -- if done
						a_wp___0.item.w_old_cursor_fcol := l_fromc.item
						a_wp___0.item.w_old_cursor_lcol := l_toc.item
				when 87 then -- if done | if block done, skip else block:
						l_pos := -1 + 89
				when 88 then -- else:
						if a_wp___0.item.w_old_cursor_lnum < a_wp___0.item.w_old_visual_lnum then
							l_from := a_wp___0.item.w_old_cursor_lnum
							l_to := a_wp___0.item.w_old_visual_lnum
						else
							l_from := a_wp___0.item.w_old_visual_lnum
							l_to := a_wp___0.item.w_old_cursor_lnum
						end
				when 89 then -- if done
						if l_from < a_wp___0.item.w_topline then
							l_from := a_wp___0.item.w_topline
						end
						if ((a_wp___0.item.w_valid).bit_and (32)).to_boolean then
							if l_from >= a_wp___0.item.w_botline then
								l_from := a_wp___0.item.w_botline - 1
							end
							if l_to >= a_wp___0.item.w_botline then
								l_to := a_wp___0.item.w_botline - 1
							end
						end
						if l_mid_start > 0 then
							l_lnum := a_wp___0.item.w_topline
							l_idx := 0
							l_srow := 0
							if l_scrolled_down.to_boolean then
								l_mid_start := l_top_end
							else
								l_mid_start := 0
							end
							from
							until
								js.loop_done
							loop
								if l_lnum < l_from then
									if not (l_idx < a_wp___0.item.w_lines_valid) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if ((a_wp___0.item.w_lines + l_idx).item.wl_valid).to_boolean then
										l_mid_start := l_mid_start + ((a_wp___0.item.w_lines + l_idx).item.wl_size).to_integer_32
									elseif not l_scrolled_down.to_boolean then
										l_srow := l_srow + ((a_wp___0.item.w_lines + l_idx).item.wl_size).to_integer_32
									end
									l_idx := l_idx + 1
									if l_idx < a_wp___0.item.w_lines_valid then
										if ((a_wp___0.item.w_lines + l_idx).item.wl_valid).to_boolean then
											l_lnum := (a_wp___0.item.w_lines + l_idx).item.wl_lnum
										else
											l_lnum := l_lnum + 1
										end
									else
										l_lnum := l_lnum + 1
									end
								end
							end
							l_srow := l_srow + l_mid_start
							l_mid_end := a_wp___0.item.w_height
							from
							until
								not (not js.loop_done and then (l_idx < a_wp___0.item.w_lines_valid))
							loop
								if ((a_wp___0.item.w_lines + l_idx).item.wl_valid).to_boolean then
									if (a_wp___0.item.w_lines + l_idx).item.wl_lnum >= l_to + 1 then
										l_mid_end := l_srow
										js.break
									end
								end
								if not js.loop_jumped then
									l_srow := l_srow + ((a_wp___0.item.w_lines + l_idx).item.wl_size).to_integer_32
									l_idx := l_idx + 1
								end
							end
						end
				when 90 then -- if done | if done
						if globals_inst.VIsual_active.to_boolean then
							if l_buf___6.is_equal (globals_inst.curwin.item.w_buffer) then
								a_wp___0.item.w_old_visual_mode := globals_inst.VIsual_mode.to_integer_8
								a_wp___0.item.w_old_cursor_lnum := globals_inst.curwin.item.w_cursor.lnum
								a_wp___0.item.w_old_visual_lnum := globals_inst.VIsual.item.lnum
								a_wp___0.item.w_old_visual_col := globals_inst.VIsual.item.col
								a_wp___0.item.w_old_curswant := globals_inst.curwin.item.w_curswant
							else
								a_wp___0.item.w_old_visual_mode := (0).to_integer_8
								a_wp___0.item.w_old_cursor_lnum := (0).to_integer_32
								a_wp___0.item.w_old_visual_lnum := (0).to_integer_32
								a_wp___0.item.w_old_visual_col := 0
							end
						else
							a_wp___0.item.w_old_visual_mode := (0).to_integer_8
							a_wp___0.item.w_old_cursor_lnum := (0).to_integer_32
							a_wp___0.item.w_old_visual_lnum := (0).to_integer_32
							a_wp___0.item.w_old_visual_col := 0
						end
						l_save_got_int := globals_inst.got_int
						globals_inst.got_int := 0
						win_foldinfo.item.fi_level := 0
						l_idx := 0
						l_row := 0
						l_srow := 0
						l_lnum := a_wp___0.item.w_topline
				when 91 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 150 -- skip loop
						end
				when 92 then -- loop body:
						if l_row = a_wp___0.item.w_height then
							l_didline := 1
							js.break
						end
						if not js.loop_jumped and then (l_lnum > l_buf___6.item.b_ml.ml_line_count) then
							l_eof := 1
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 149 -- skip if block
						end
				when 93 then -- if:
						l_srow := l_row
						if not (l_row < l_top_end) then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 96 then -- else:
						if not (l_row >= l_mid_start) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						if l_row < l_mid_end then
							l_pos := -1 + 125 -- goto _L___25
						else
							l_pos := -1 + 99 -- goto _L___27
						end
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 99 then -- else: | _L___27:
						if not (l_top_to_mod.to_boolean) then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 102 then -- else:
						if not (l_idx >= a_wp___0.item.w_lines_valid) then
							l_pos := -1 + 105 -- skip if block
						end
				when 103 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 104 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 105 then -- else:
						if not (l_row + ((a_wp___0.item.w_lines + l_idx).item.wl_size).to_integer_32 > l_bot_start) then
							l_pos := -1 + 108 -- skip if block
						end
				when 106 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 107 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 108 then -- else:
						if l_mod_top.item = 0 then
							l_pos := -1 + 148 -- skip if block
						end
				when 109 then -- if:
						if l_lnum /= l_mod_top.item then
							l_pos := -1 + 112 -- skip if block
						end
				when 110 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 111 then -- if block done, skip else block:
						l_pos := -1 + 147
				when 112 then -- else:
						if not (l_lnum >= l_mod_top.item) then
							l_pos := -1 + 146 -- skip if block
						end
				when 113 then -- if:
						if not (l_lnum < l_mod_bot.item) then
							l_pos := -1 + 116 -- skip if block
						end
				when 114 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 115 then -- if block done, skip else block:
						l_pos := -1 + 145
				when 116 then -- else:
						if l_did_update /= 3 then
							l_pos := -1 + 119 -- skip if block
						end
				when 117 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 118 then -- if block done, skip else block:
						l_pos := -1 + 145
				when 119 then -- else:
						if l_did_update /= 2 then
							l_pos := -1 + 144 -- skip if block
						end
				when 120 then -- if:
						if not ((syntax_inst.syntax_present (a_wp___0)).to_boolean) then
							l_pos := -1 + 142 -- skip if block
						end
				when 121 then -- if:
						if not ((fold_inst.foldmethodIsSyntax (a_wp___0)).to_boolean) then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						if (fold_inst.hasAnyFolding (a_wp___0)).to_boolean then
							l_pos := -1 + 125 -- goto _L___25
						else
							l_pos := -1 + 124 -- goto _L___26
						end
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 141
				when 124 then -- else: | _L___26:
						if not ((syntax_inst.syntax_check_changed (l_lnum)).to_boolean) then
							l_pos := -1 + 140 -- skip if block
						end
				when 125 then -- if: | _L___25:
						if l_lnum = l_mod_top.item then
							l_top_to_mod := 0
						end
						if l_lnum /= l_mod_top.item then
							l_pos := -1 + 131 -- skip if block
						end
				when 126 then -- if:
						if l_mod_bot.item = 2_147_483_647 then
							l_pos := -1 + 131 -- skip if block
						end
				when 127 then -- if:
						if globals_inst.dollar_vcol = 0 then
							l_pos := -1 + 130 -- skip if block
						end
				when 128 then -- if:
						if l_mod_bot.item /= l_mod_top.item + 1 then
							l_pos := -1 + 130 -- goto _L___14
						end
				when 129 then -- if block done, skip else block:
						l_pos := -1 + 131
				when 130 then -- else: | _L___14:
						l_old_rows := 0
						l_new_rows := 0
						l_i___0 := l_idx
						from
						until
							not (not js.loop_done and then (l_i___0 < a_wp___0.item.w_lines_valid))
						loop
							if ((a_wp___0.item.w_lines + l_i___0).item.wl_valid).to_boolean then
								if (a_wp___0.item.w_lines + l_i___0).item.wl_lnum = l_mod_bot.item then
									js.break
								end
							end
							if not js.loop_jumped then
								l_old_rows := l_old_rows + ((a_wp___0.item.w_lines + l_i___0).item.wl_size).to_integer_32
								if ((a_wp___0.item.w_lines + l_i___0).item.wl_valid).to_boolean then
									if (a_wp___0.item.w_lines + l_i___0).item.wl_lastlnum + 1 = l_mod_bot.item then
										l_i___0 := l_i___0 + 1
										from
										until
											js.loop_done
										loop
											if l_i___0 < a_wp___0.item.w_lines_valid then
												if ((a_wp___0.item.w_lines + l_i___0).item.wl_valid).to_boolean then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_tmp___14 := l_i___0
												l_i___0 := l_i___0 + 1
												l_old_rows := l_old_rows + ((a_wp___0.item.w_lines + l_tmp___14).item.wl_size).to_integer_32
											end
										end
										js.break
									end
								end
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						if l_i___0 >= a_wp___0.item.w_lines_valid then
							l_bot_start := 0
						else
							l_j := l_idx.to_integer_32
							l_l.item := l_lnum
							from
							until
								not (not js.loop_done and then (l_l.item < l_mod_bot.item))
							loop
								if (fold_inst.hasFoldingWin (a_wp___0, l_l.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_l, 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))).to_boolean then
									l_new_rows := l_new_rows + 1
								elseif l_l.item = a_wp___0.item.w_topline then
									l_new_rows := l_new_rows + ((misc1_inst.plines_win_nofill (a_wp___0, l_l.item, 1)) + a_wp___0.item.w_topfill)
								else
									l_new_rows := l_new_rows + (misc1_inst.plines_win (a_wp___0, l_l.item, 1))
								end
								l_j := l_j + 1
								if l_new_rows > (a_wp___0.item.w_height - l_row) - 2 then
									l_new_rows := 9_999
									js.break
								end
								if not js.loop_jumped then
									l_l.item := l_l.item + 1
								end
							end
							l_xtra_rows := l_new_rows - l_old_rows
							if l_xtra_rows < 0 then
								if l_row - l_xtra_rows >= a_wp___0.item.w_height - 2 then
									l_mod_bot.item := 2_147_483_647
								else
									check_for_delay (0)
									if (win_del_lines (a_wp___0, l_row, -l_xtra_rows, 0, 0)) = 0 then
										l_mod_bot.item := 2_147_483_647
									else
										l_bot_start := a_wp___0.item.w_height + l_xtra_rows
									end
								end
							elseif l_xtra_rows > 0 then
								if l_row + l_xtra_rows >= a_wp___0.item.w_height - 2 then
									l_mod_bot.item := 2_147_483_647
								else
									check_for_delay (0)
									if (win_ins_lines (a_wp___0, l_row + l_old_rows, l_xtra_rows, 0, 0)) = 0 then
										l_mod_bot.item := 2_147_483_647
									elseif l_top_end > l_row + l_old_rows then
										l_top_end := l_top_end + l_xtra_rows
									end
								end
							end
							if l_mod_bot.item /= 2_147_483_647 then
								if l_i___0.to_integer_32 /= l_j then
									if l_j < l_i___0.to_integer_32 then
										l_x___0 := l_row + l_new_rows
										from
										until
											js.loop_done
										loop
											if l_i___0 >= a_wp___0.item.w_lines_valid then
												a_wp___0.item.w_lines_valid := l_j.to_integer_32
												js.break
											end
											if not js.loop_jumped then
												a_wp___0.item.w_lines[l_j] := (a_wp___0.item.w_lines[l_i___0]).twin
												if l_x___0 + ((a_wp___0.item.w_lines + l_j).item.wl_size).to_integer_32 > a_wp___0.item.w_height then
													a_wp___0.item.w_lines_valid := (l_j + 1).to_integer_32
													js.break
												end
											end
											if not js.loop_jumped then
												l_tmp___20 := l_j
												l_j := l_j + 1
												l_x___0 := l_x___0 + ((a_wp___0.item.w_lines + l_tmp___20).item.wl_size).to_integer_32
												l_i___0 := l_i___0 + 1
											end
										end
										if l_bot_start > l_x___0 then
											l_bot_start := l_x___0
										end
									else
										l_j := l_j - l_i___0.to_integer_32
										a_wp___0.item.w_lines_valid := ((a_wp___0.item.w_lines_valid).to_integer_32 + l_j).to_integer_32
										if a_wp___0.item.w_lines_valid > a_wp___0.item.w_height then
											a_wp___0.item.w_lines_valid := a_wp___0.item.w_height
										end
										l_i___0 := a_wp___0.item.w_lines_valid
										from
										until
											not (l_i___0.to_integer_32 - l_j >= l_idx.to_integer_32)
										loop
											a_wp___0.item.w_lines[l_i___0] := (a_wp___0.item.w_lines[(l_i___0.to_integer_32 - l_j)]).twin
											l_i___0 := l_i___0 - 1
										end
										from
										until
											not (l_i___0 >= l_idx)
										loop
											(a_wp___0.item.w_lines + l_i___0).item.wl_size := (0).to_natural_16
											l_tmp___21 := l_i___0
											l_i___0 := l_i___0 - 1;
											(a_wp___0.item.w_lines + l_tmp___21).item.wl_valid := (0).to_integer_8
										end
									end
								end
							end
						end
				when 131 then -- if done | if done
						l_fold_count := fold_inst.foldedCount (a_wp___0, l_lnum, win_foldinfo)
						if l_fold_count = 0 then
							l_pos := -1 + 134 -- skip if block
						end
				when 132 then -- if:
						fold_line (a_wp___0, l_fold_count, win_foldinfo, l_lnum, l_row)
						l_row := l_row + 1
						l_fold_count := l_fold_count - 1;
						(a_wp___0.item.w_lines + l_idx).item.wl_folded := (1).to_integer_8;
						(a_wp___0.item.w_lines + l_idx).item.wl_lastlnum := l_lnum + l_fold_count
						l_did_update := 3
				when 133 then -- if block done, skip else block:
						l_pos := -1 + 138
				when 134 then -- else:
						if not (l_idx < a_wp___0.item.w_lines_valid) then
							l_pos := -1 + 137 -- skip if block
						end
				when 135 then -- if:
						if ((a_wp___0.item.w_lines + l_idx).item.wl_valid).to_boolean then
							if (a_wp___0.item.w_lines + l_idx).item.wl_lnum = l_lnum then
								if l_lnum > a_wp___0.item.w_topline then
									if not ((option_inst.dy_flags.item).bit_and ({NATURAL_32} 1)).to_boolean then
										if l_srow + ((a_wp___0.item.w_lines + l_idx).item.wl_size).to_integer_32 > a_wp___0.item.w_height then
											if (diff_inst.diff_check_fill (a_wp___0, l_lnum)) = 0 then
												l_row := a_wp___0.item.w_height + 1
											else
												l_pos := -1 + 137 -- goto _L___20
											end
										else
											l_pos := -1 + 137 -- goto _L___20
										end
									else
										l_pos := -1 + 137 -- goto _L___20
									end
								else
									l_pos := -1 + 137 -- goto _L___20
								end
							else
								l_pos := -1 + 137 -- goto _L___20
							end
						else
							l_pos := -1 + 137 -- goto _L___20
						end
				when 136 then -- if block done, skip else block:
						l_pos := -1 + 138
				when 137 then -- else: | _L___20:
						prepare_search_hl (a_wp___0, l_lnum)
						if l_syntax_last_parsed /= 0 then
							if l_syntax_last_parsed + 1 < l_lnum then
								if (syntax_inst.syntax_present (a_wp___0)).to_boolean then
									syntax_inst.syntax_end_parsing (l_syntax_last_parsed + 1)
								end
							end
						end
						l_row := win_line (a_wp___0, l_lnum, l_srow, a_wp___0.item.w_height, (l_mod_top.item = 0).to_integer);
						(a_wp___0.item.w_lines + l_idx).item.wl_folded := (0).to_integer_8;
						(a_wp___0.item.w_lines + l_idx).item.wl_lastlnum := l_lnum
						l_did_update := 2
						l_syntax_last_parsed := l_lnum
				when 138 then; -- if done
						(a_wp___0.item.w_lines + l_idx).item.wl_lnum := l_lnum;
						(a_wp___0.item.w_lines + l_idx).item.wl_valid := (1).to_integer_8
						if l_row > a_wp___0.item.w_height then
							if globals_inst.dollar_vcol = 0 then
								(a_wp___0.item.w_lines + l_idx).item.wl_size := (misc1_inst.plines_win (a_wp___0, l_lnum, 1)).to_natural_16
							end
							l_idx := l_idx + 1
							js.break
						end
						if not js.loop_jumped then
							if globals_inst.dollar_vcol = 0 then
								(a_wp___0.item.w_lines + l_idx).item.wl_size := (l_row - l_srow).to_natural_16
							end
							l_idx := l_idx + 1
							l_lnum := l_lnum + (l_fold_count + 1)
						end
				when 139 then -- if block done, skip else block:
						l_pos := -1 + 141
				when 140 then -- else:
						l_pos := -1 + 148 -- goto _L___22
				when 141 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 143
				when 142 then -- else:
						l_pos := -1 + 148 -- goto _L___22
				when 143 then -- if done | if block done, skip else block:
						l_pos := -1 + 145
				when 144 then -- else:
						l_pos := -1 + 148 -- goto _L___22
				when 145 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 147
				when 146 then -- else:
						l_pos := -1 + 148 -- goto _L___22
				when 147 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 149
				when 148 then -- else: | _L___22:
						l_tmp___25 := l_idx
						l_idx := l_idx + 1
						l_row := l_row + ((a_wp___0.item.w_lines + l_tmp___25).item.wl_size).to_integer_32
						if l_row > a_wp___0.item.w_height then
							js.break
						end
						if not js.loop_jumped then
							l_lnum := (a_wp___0.item.w_lines + (l_idx - 1)).item.wl_lastlnum + 1
							l_did_update := 1
						end
				when 149 then -- if done | if done | if done | if done | if done | if done
						if not js.loop_jumped and then (l_lnum > l_buf___6.item.b_ml.ml_line_count) then
							l_eof := 1
							js.break
						end
						l_pos := -1 + 91 -- back to loop condition
				when 150 then -- loop done
						if l_idx > a_wp___0.item.w_lines_valid then
							a_wp___0.item.w_lines_valid := l_idx
						end
						if l_syntax_last_parsed /= 0 then
							if (syntax_inst.syntax_present (a_wp___0)).to_boolean then
								syntax_inst.syntax_end_parsing (l_syntax_last_parsed + 1)
							end
						end
						a_wp___0.item.w_empty_rows := 0
						a_wp___0.item.w_filler_rows := 0
						if l_eof.to_boolean then
							l_pos := -1 + 153 -- skip if block
						end
				when 151 then -- if:
						if not l_didline.to_boolean then
							if l_lnum = a_wp___0.item.w_topline then
								a_wp___0.item.w_botline := l_lnum + 1
							elseif (diff_inst.diff_check_fill (a_wp___0, l_lnum)) >= a_wp___0.item.w_height - l_srow then
								a_wp___0.item.w_botline := l_lnum
								a_wp___0.item.w_filler_rows := a_wp___0.item.w_height - l_srow
							elseif ((option_inst.dy_flags.item).bit_and ({NATURAL_32} 1)).to_boolean then
								screen_fill ((a_wp___0.item.w_winrow + a_wp___0.item.w_height) - 1, a_wp___0.item.w_winrow + a_wp___0.item.w_height, (a_wp___0.item.w_wincol + a_wp___0.item.w_width) - 3, a_wp___0.item.w_wincol + a_wp___0.item.w_width, ('@').code, ('@').code, globals_inst.highlight_attr[1])
								move_inst.set_empty_rows (a_wp___0, l_srow)
								a_wp___0.item.w_botline := l_lnum
							else
								win_draw_end (a_wp___0, ('@').code, (' ').code, l_srow, a_wp___0.item.w_height, {PC_HLF_T}.HLF_AT)
								a_wp___0.item.w_botline := l_lnum
							end
						else
							l_pos := -1 + 153 -- goto _L___28
						end
				when 152 then -- if block done, skip else block:
						l_pos := -1 + 154
				when 153 then -- else: | _L___28:
						draw_vsep_win (a_wp___0, l_row)
						if l_eof.to_boolean then
							a_wp___0.item.w_botline := l_buf___6.item.b_ml.ml_line_count + 1
							l_j := (diff_inst.diff_check_fill (a_wp___0, a_wp___0.item.w_botline)).to_integer_32
							if l_j > 0 then
								if not (a_wp___0.item.w_botfill).to_boolean then
									if (charset_inst.char2cells (globals_inst.fill_diff.item)) > 1 then
										l_i___0 := ('-').code
									else
										l_i___0 := globals_inst.fill_diff.item
									end
									if l_row.to_integer_32 + l_j > (a_wp___0.item.w_height).to_integer_32 then
										l_j := (a_wp___0.item.w_height - l_row).to_integer_32
									end
									win_draw_end (a_wp___0, l_i___0, l_i___0, l_row, l_row + l_j.to_integer_32, {PC_HLF_T}.HLF_DED)
									l_row := (l_row.to_integer_32 + l_j).to_integer_32
								end
							end
						elseif globals_inst.dollar_vcol = 0 then
							a_wp___0.item.w_botline := l_lnum
						end
						win_draw_end (a_wp___0, ('~').code, (' ').code, l_row, a_wp___0.item.w_height, {PC_HLF_T}.HLF_AT)
				when 154 then
						a_wp___0.item.w_redr_type := 0
						a_wp___0.item.w_old_topfill := a_wp___0.item.w_topfill
						a_wp___0.item.w_old_botfill := a_wp___0.item.w_botfill
						if globals_inst.dollar_vcol = 0 then
							a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_or ((32))
							if a_wp___0.is_equal (globals_inst.curwin) then
								if a_wp___0.item.w_botline /= l_old_botline.to_integer_32 then
									if not recursive___4.to_boolean then
										recursive___4 := 1
										globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-129))
										move_inst.update_topline
										if globals_inst.must_redraw /= 0 then
											l_i___0 := globals_inst.curbuf.item.b_mod_set
											globals_inst.curbuf.item.b_mod_set := 0
											win_update (globals_inst.curwin)
											globals_inst.must_redraw := 0
											globals_inst.curbuf.item.b_mod_set := l_i___0
										end
										recursive___4 := 0
									end
								end
							end
						end
						if not globals_inst.got_int.to_boolean then
							globals_inst.got_int := l_save_got_int
						end
				when 155 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	windgoto (a_row: INTEGER_32; a_col: INTEGER_32)
		local
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_16]
			l_i___0: INTEGER_32
			l_plan: INTEGER_32
			l_cost: INTEGER_32
			l_wouldbe_col: INTEGER_32
			l_noinvcurs: INTEGER_32
			l_bs: CE_POINTER [NATURAL_8]
			l_goto_cost: INTEGER_32
			l_attr: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_16]
			l_tmp___1: CE_POINTER [NATURAL_16]
			l_tmp___2: INTEGER_32
			l_off___0: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_bs.make
			create l_tmp___0.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_row := a_row
					l_col := a_col
					if globals_inst.ScreenLines.is_void then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if l_col = screen_cur_col then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 4 then -- else:
						if l_row = screen_cur_row then
							l_pos := -1 + 22 -- skip if block
						end
				when 5 then -- if: | _L___1:
						if l_row < 0 then
							l_row := 0
						end
						if l_row >= globals_inst.screen_Rows then
							l_row := globals_inst.screen_Rows - 1
						end
						if l_col >= globals_inst.screen_Columns then
							l_col := globals_inst.screen_Columns - 1
						end
						if screen_attr.to_boolean then
							if ((term_inst.term_strings[26]).item).to_integer_32 = 0 then
								l_noinvcurs := 5
							else
								l_noinvcurs := 0
							end
						else
							l_noinvcurs := 0
						end
						l_goto_cost := 7 + l_noinvcurs
						if not (l_row >= screen_cur_row) then
							l_pos := -1 + 20 -- skip if block
						end
				when 6 then -- if:
						if not (screen_cur_col.to_integer_32 < globals_inst.Columns.item) then
							l_pos := -1 + 18 -- skip if block
						end
				when 7 then -- if:
						l_bs := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_attr := screen_attr
						if l_row /= screen_cur_row then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_col < screen_cur_col then
							if ((term_inst.term_strings[44]).item).to_boolean then
								l_bs := term_inst.term_strings[44]
							else
								l_bs := term_inst.term_strings[35]
							end
							if (l_bs.item).to_boolean then
								l_cost := (screen_cur_col - l_col) * (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_bs))).to_integer_32
							else
								l_cost := 999
							end
							if l_col + 1 < l_cost then
								l_plan := 2
								l_wouldbe_col := 0
								l_cost := 1
							else
								l_plan := 1
								l_wouldbe_col := l_col
							end
							if l_noinvcurs.to_boolean then
								l_cost := l_cost + l_noinvcurs
								l_attr := 0
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_row > screen_cur_row then
							l_plan := 3
							l_wouldbe_col := 0
							l_cost := (l_row - screen_cur_row) * 2
							if l_noinvcurs.to_boolean then
								l_cost := l_cost + l_noinvcurs
								l_attr := 0
							end
						else
							l_plan := 4
							l_wouldbe_col := screen_cur_col
							l_cost := 0
						end
				when 11 then
						l_i___0 := l_col - l_wouldbe_col
						if l_i___0 > 0 then
							l_cost := l_cost + l_i___0
						end
						if l_cost < l_goto_cost then
							if l_i___0 > 0 then
								l_p___0 := (globals_inst.ScreenAttrs + (globals_inst.LineOffset[l_row]).to_integer_32) + l_wouldbe_col
								from
								until
									js.loop_done
								loop
									if l_i___0.to_boolean then
										l_tmp___0 := l_p___0
										l_p___0 := l_p___0 + 1
										if (l_tmp___0.item).to_integer_32 /= l_attr then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_i___0 := l_i___0 - 1
									end
								end
								if l_i___0 /= 0 then
									l_p___0 := l_p___0 - 1
									if (l_p___0.item).to_integer_32 = 0 then
										l_cost := l_cost + l_noinvcurs
										from
										until
											js.loop_done
										loop
											if l_i___0.to_boolean then
												l_tmp___1 := l_p___0
												l_p___0 := l_p___0 + 1
												if (l_tmp___1.item).to_integer_32 /= 0 then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_i___0 := l_i___0 - 1
											end
										end
									end
									if l_i___0 /= 0 then
										l_cost := 999
									end
								end
								if globals_inst.enc_utf8.to_boolean then
									l_i___0 := l_wouldbe_col
									from
									until
										not (not js.loop_done and then (l_i___0 < l_col))
									loop
										if globals_inst.ScreenLinesUC[(globals_inst.LineOffset[l_row] + l_i___0.to_natural_32).to_integer_32] /= {NATURAL_32} 0 then
											l_cost := 999
											js.break
										end
										if not js.loop_jumped then
											l_i___0 := l_i___0 + 1
										end
									end
								end
							end
						end
						if not (l_cost < l_goto_cost) then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if l_plan = 1 then
							if l_noinvcurs.to_boolean then
								screen_stop_highlight
							end
							from
							until
								not (screen_cur_col > l_col)
							loop
								term_inst.out_str (l_bs)
								screen_cur_col := screen_cur_col - 1
							end
						elseif l_plan = 2 then
							if l_noinvcurs.to_boolean then
								screen_stop_highlight
							end
							term_inst.out_char ((('%R').code).to_natural_32)
							screen_cur_col := 0
						elseif l_plan = 3 then
							if l_noinvcurs.to_boolean then
								screen_stop_highlight
							end
							from
							until
								not (screen_cur_row < l_row)
							loop
								term_inst.out_char ((('%N').code).to_natural_32)
								screen_cur_row := screen_cur_row + 1
							end
							screen_cur_col := 0
						end
						l_i___0 := l_col - screen_cur_col
						if not (l_i___0 > 0) then
							l_pos := -1 + 17 -- skip if block
						end
				when 13 then -- if:
						if ((term_inst.term_strings[45])[0]).to_integer_32 = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if ((term_inst.term_strings[45])[1]).to_integer_32 = 0 then
							from
							until
								js.loop_done
							loop
								l_tmp___2 := l_i___0
								l_i___0 := l_i___0 - 1
								if not (l_tmp___2 > 0) then
									js.break
								end
								if not js.loop_jumped then
									term_inst.out_char (((term_inst.term_strings[45]).item).to_natural_32)
								end
							end
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						l_off___0 := (globals_inst.LineOffset[l_row] + screen_cur_col.to_natural_32).to_integer_32
						from
						until
							js.loop_done
						loop
							l_tmp___3 := l_i___0
							l_i___0 := l_i___0 - 1
							if not (l_tmp___3 > 0) then
								js.break
							end
							if not js.loop_jumped then
								if (globals_inst.ScreenAttrs[l_off___0]).to_integer_32 /= screen_attr then
									screen_stop_highlight
								end
								term_inst.out_flush_check
								term_inst.out_char ((globals_inst.ScreenLines[l_off___0]).to_natural_32)
								if globals_inst.enc_dbcs = 9_932 then
									if (globals_inst.ScreenLines[l_off___0]).to_integer_32 = 142 then
										term_inst.out_char ((globals_inst.ScreenLines2[l_off___0]).to_natural_32)
									end
								end
								l_off___0 := l_off___0 + 1
							end
						end
				when 17 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_cost := 999
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_cost := 999
				when 21 then
						if l_cost >= l_goto_cost then
							if l_noinvcurs.to_boolean then
								screen_stop_highlight
							end
							if l_row = screen_cur_row then
								if l_col > screen_cur_col then
									if ((term_inst.term_strings[29]).item).to_integer_32 /= 0 then
										term_inst.term_cursor_right (l_col - screen_cur_col)
									else
										term_inst.term_windgoto (l_row, l_col)
									end
								else
									term_inst.term_windgoto (l_row, l_col)
								end
							else
								term_inst.term_windgoto (l_row, l_col)
							end
						end
						screen_cur_row := l_row
						screen_cur_col := l_col
				when 22 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
