class
	P_SPELL

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create dumsft.make (<<1>>)
			create dumwc.make (<<1>>)
			create e_affform.make
			create e_affname.make
			create e_affrange.make
			create e_afftrailing.make
			create e_format.make
			create e_spell_trunc.make
			create first_lang.make
			create int_wordlist.make
			create msg_compressing.make
			create repl_from.make
			create repl_to.make
			create spelltab.make (<<1>>)
		end

feature {ANY} -- attributes

	compress_added: INTEGER_32 assign set_compress_added

	set_compress_added (a_compress_added: INTEGER_32)
		do
			compress_added := a_compress_added
		end

	compress_inc: INTEGER_32 assign set_compress_inc

	set_compress_inc (a_compress_inc: INTEGER_32)
		do
			compress_inc := a_compress_inc
		end

	compress_start: INTEGER_32 assign set_compress_start

	set_compress_start (a_compress_start: INTEGER_32)
		do
			compress_start := a_compress_start
		end

	did_set_spelltab: INTEGER_32 assign set_did_set_spelltab

	set_did_set_spelltab (a_did_set_spelltab: INTEGER_32)
		do
			did_set_spelltab := a_did_set_spelltab
		end

	dumsft: CE_ARRAY [PD_SFTWORD_T]

	dumwc: CE_ARRAY [PD_WORDCOUNT_S]

	e_affform: CE_POINTER [INTEGER_8] assign set_e_affform

	set_e_affform (a_e_affform: CE_POINTER [INTEGER_8])
		do
			e_affform := a_e_affform
		end

	e_affname: CE_POINTER [INTEGER_8] assign set_e_affname

	set_e_affname (a_e_affname: CE_POINTER [INTEGER_8])
		do
			e_affname := a_e_affname
		end

	e_affrange: CE_POINTER [INTEGER_8] assign set_e_affrange

	set_e_affrange (a_e_affrange: CE_POINTER [INTEGER_8])
		do
			e_affrange := a_e_affrange
		end

	e_afftrailing: CE_POINTER [INTEGER_8] assign set_e_afftrailing

	set_e_afftrailing (a_e_afftrailing: CE_POINTER [INTEGER_8])
		do
			e_afftrailing := a_e_afftrailing
		end

	e_format: CE_POINTER [INTEGER_8] assign set_e_format

	set_e_format (a_e_format: CE_POINTER [INTEGER_8])
		do
			e_format := a_e_format
		end

	e_spell_trunc: CE_POINTER [INTEGER_8] assign set_e_spell_trunc

	set_e_spell_trunc (a_e_spell_trunc: CE_POINTER [INTEGER_8])
		do
			e_spell_trunc := a_e_spell_trunc
		end

	expr_busy: INTEGER_32 assign set_expr_busy

	set_expr_busy (a_expr_busy: INTEGER_32)
		do
			expr_busy := a_expr_busy
		end

	first_lang: CE_POINTER [PD_SLANG_S] assign set_first_lang

	set_first_lang (a_first_lang: CE_POINTER [PD_SLANG_S])
		do
			first_lang := a_first_lang
		end

	int_wordlist: CE_POINTER [NATURAL_8] assign set_int_wordlist

	set_int_wordlist (a_int_wordlist: CE_POINTER [NATURAL_8])
		do
			int_wordlist := a_int_wordlist
		end

	msg_compressing: CE_POINTER [INTEGER_8] assign set_msg_compressing

	set_msg_compressing (a_msg_compressing: CE_POINTER [INTEGER_8])
		do
			msg_compressing := a_msg_compressing
		end

	recursive___5: INTEGER_32 assign set_recursive___5

	set_recursive___5 (a_recursive___5: INTEGER_32)
		do
			recursive___5 := a_recursive___5
		end

	repl_from: CE_POINTER [NATURAL_8] assign set_repl_from

	set_repl_from (a_repl_from: CE_POINTER [NATURAL_8])
		do
			repl_from := a_repl_from
		end

	repl_to: CE_POINTER [NATURAL_8] assign set_repl_to

	set_repl_to (a_repl_to: CE_POINTER [NATURAL_8])
		do
			repl_to := a_repl_to
		end

	spell_expand_need_cap: INTEGER_32 assign set_spell_expand_need_cap

	set_spell_expand_need_cap (a_spell_expand_need_cap: INTEGER_32)
		do
			spell_expand_need_cap := a_spell_expand_need_cap
		end

	spelltab: CE_ARRAY [PD_SPELLTAB_S]

	sps_flags: INTEGER_32 assign set_sps_flags

	set_sps_flags (a_sps_flags: INTEGER_32)
		do
			sps_flags := a_sps_flags
		end

	sps_limit: INTEGER_32 assign set_sps_limit

	set_sps_limit (a_sps_limit: INTEGER_32)
		do
			sps_limit := a_sps_limit
		end

feature {ANY} -- routines

	add_banned (a_su: CE_POINTER [PD_SUGINFO_S]; a_word: CE_POINTER [NATURAL_8])
		local
			l_s: CE_POINTER [NATURAL_8]
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_hi___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_hash := hashtab_inst.hash_hash (a_word)
					l_hi___1 := hashtab_inst.hash_lookup (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned")), a_word, l_hash)
					if not ((l_hi___1.item.hi_key).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_s := misc2_inst.vim_strsave (a_word)
						if not l_s.is_void then
							hashtab_inst.hash_add_item (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned")), l_hi___1, l_s, l_hash).do_nothing
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	add_fromto (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_gap: CE_POINTER [PD_GROWARRAY]; a_from: CE_POINTER [NATURAL_8]; a_to: CE_POINTER [NATURAL_8])
		local
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_word: CE_ARRAY [NATURAL_8]
		do
			create l_ftp.make
			create l_word.make (<<250>>)

			if (misc2_inst.ga_grow (a_gap, 1)) = 1 then
				l_ftp := create {CE_POINTER [PD_FROMTO_S]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len
				spell_casefold (a_from, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_from))).to_integer_32, l_word, 250).do_nothing
				l_ftp.item.ft_from := getroom_save (a_spin, l_word)
				spell_casefold (a_to, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_to))).to_integer_32, l_word, 250).do_nothing
				l_ftp.item.ft_to := getroom_save (a_spin, l_word)
				a_gap.item.ga_len := (a_gap.item.ga_len) + 1
			end
		end

	add_sound_suggest (a_su: CE_POINTER [PD_SUGINFO_S]; a_goodword: CE_POINTER [NATURAL_8]; a_score: INTEGER_32; a_lp: CE_POINTER [PD_LANGP_S])
		local
			l_slang: CE_POINTER [PD_SLANG_S]
			l_sfwordnr: INTEGER_32
			l_nrline: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_orgnr: INTEGER_32
			l_theword: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_wlen: INTEGER_32
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_n: INTEGER_32
			l_wordcount: INTEGER_32
			l_wc: INTEGER_32
			l_goodscore: INTEGER_32
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_sft: CE_POINTER [PD_SFTWORD_T]
			l_bc: INTEGER_32
			l_gc: INTEGER_32
			l_limit: INTEGER_32
			l_tmp___3: INTEGER_32
			l_cword: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_flags___0: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_slang.make
			create l_nrline.make (<<1>>)
			create l_theword.make (<<250>>)
			create l_byts.make
			create l_idxs.make
			create l_hi___1.make
			create l_sft.make
			create l_cword.make (<<250>>)
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_slang := a_lp.item.lp_slang
					l_hash := hashtab_inst.hash_hash (a_goodword)
					l_hi___1 := hashtab_inst.hash_lookup (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone")), a_goodword, l_hash)
					if not ((l_hi___1.item.hi_key).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_sft := create {CE_POINTER [PD_SFTWORD_T]}.make_cast ((misc2_inst.alloc ((create {PD_SFTWORD_T}.make).structure_size.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_goodword))))))
						if not l_sft.is_void then
							l_sft.item.sft_score := a_score.to_integer_16
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_sft.item.sft_word)), create {CE_POINTER [INTEGER_8]}.make_cast (a_goodword)).do_nothing
							hashtab_inst.hash_add_item (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone")), l_hi___1, l_sft.item.sft_word, l_hash).do_nothing
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_sft := create {CE_POINTER [PD_SFTWORD_T]}.make_cast ((l_hi___1.item.hi_key - ((dumsft.item.sft_word).distance ((create {CE_POINTER [NATURAL_8]}.make_cast (dumsft))))))
						if a_score >= (l_sft.item.sft_score).to_integer_32 then
							js.return
						end
						if not js.return_called then
							l_sft.item.sft_score := a_score.to_integer_16
						end
				when 7 then -- if done
						if not js.return_called then
							l_sfwordnr := soundfold_find (l_slang, a_goodword)
							if l_sfwordnr < 0 then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_intern2)))), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("add_sound_suggest()"))).do_nothing
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 47 -- skip if block
						end
				when 8 then -- if:
							l_nrline.item := memline_inst.ml_get_buf (l_slang.item.sl_sugbuf, (l_sfwordnr + 1).to_integer_32, 0)
							l_orgnr := 0
				when 9 then -- loop condition:
							if not (not js.loop_done and then ((l_nrline.item.item).to_integer_32 /= 0)) then
								l_pos := -1 + 47 -- skip loop
							end
				when 10 then -- loop body:
							l_orgnr := l_orgnr + (bytes2offset (l_nrline))
							l_byts := l_slang.item.sl_fbyts
							l_idxs := l_slang.item.sl_fidxs
							l_n := 0
							l_wlen := 0
							l_wordcount := 0
				when 11 then -- loop condition:
							if js.loop_done then
								l_pos := -1 + 19 -- skip loop
							end
				when 12 then -- loop body:
							l_i___0 := 1
							if l_wordcount = l_orgnr then
								if (l_byts[(l_n + 1)]).to_integer_32 = 0 then
									js.break
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 18 -- skip if block
							end
				when 13 then -- if:
							if (l_byts[(l_n + 1)]).to_integer_32 = 0 then
								l_wordcount := l_wordcount + 1
							end
				when 14 then -- loop condition:
							if (l_byts[(l_n + l_i___0)]).to_integer_32 /= 0 then
								l_pos := -1 + 17 -- skip loop
							end
				when 15 then -- loop body:
							if l_i___0 > (l_byts[l_n]).to_integer_32 then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_theword + l_wlen)), ce_string ("BAD")).do_nothing
								l_pos := -1 + 19 -- goto badword
							end
				when 16 then
							l_i___0 := l_i___0 + 1
							l_pos := -1 + 14 -- back to loop condition
				when 17 then -- loop done
							from
							until
								not (not js.loop_done and then (l_i___0 < (l_byts[l_n]).to_integer_32))
							loop
								l_wc := l_idxs[(l_idxs[(l_n + l_i___0)])]
								if l_wordcount + l_wc > l_orgnr then
									js.break
								end
								if not js.loop_jumped then
									l_wordcount := l_wordcount + l_wc
									l_i___0 := l_i___0 + 1
								end
							end
							l_tmp___3 := l_wlen
							l_wlen := l_wlen + 1
							l_theword[l_tmp___3] := l_byts[(l_n + l_i___0)]
							l_n := l_idxs[(l_n + l_i___0)]
				when 18 then -- if done
							l_pos := -1 + 11 -- back to loop condition
				when 19 then -- badword:
							l_theword[l_wlen] := (('%/0/').code).to_natural_8
				when 20 then -- loop condition:
							if js.loop_done then
								l_pos := -1 + 46 -- skip loop
							end
				when 21 then -- loop body:
							if l_i___0 <= (l_byts[l_n]).to_integer_32 then
								if (l_byts[(l_n + l_i___0)]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_flags___0 := l_idxs[(l_n + l_i___0)]
								if ((l_flags___0).bit_and (1_024)).to_boolean then
									js.continue
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 45 -- skip if block
							end
				when 22 then -- if:
							if ((l_flags___0).bit_and (128)).to_boolean then
								find_keepcap_word (l_slang, l_theword, l_cword)
								l_p___0 := l_cword
							else
								l_flags___0 := (l_flags___0).bit_or ((a_su.item.su_badflags))
								if ((l_flags___0).bit_and (198)) /= 0 then
									make_case_word (l_theword, l_cword, l_flags___0)
									l_p___0 := l_cword
								else
									l_p___0 := l_theword
								end
							end
							if not (((sps_flags).bit_and (4)).to_boolean) then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if:
							if a_score <= a_su.item.su_maxscore then
								add_suggestion (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga")), l_p___0, a_su.item.su_badlen, a_score, 0, 0, l_slang, 0)
							end
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 45
				when 25 then -- else:
							if ((l_flags___0).bit_and (1)).to_boolean then
								if ((((l_flags___0.to_natural_32).bit_shift_right (16))).bit_and ((a_lp.item.lp_region).to_natural_32)) = {NATURAL_32} 0 then
									l_goodscore := 200
								else
									l_goodscore := 0
								end
							else
								l_goodscore := 0
							end
							if globals_inst.has_mbyte.to_boolean then
								l_gc := (globals_inst.mb_ptr2char.integer_32_item ([l_p___0]))
							else
								l_gc := (l_p___0.item).to_integer_32
							end
							if not (globals_inst.enc_utf8.to_boolean) then
								l_pos := -1 + 28 -- skip if block
							end
				when 26 then -- if:
							if l_gc >= 128 then
								l_tmp___21 := (mbyte_inst.utf_isupper (l_gc))
							else
								l_pos := -1 + 28 -- goto _L___3
							end
				when 27 then -- if block done, skip else block:
							l_pos := -1 + 29
				when 28 then -- else: | _L___3:
							if l_gc < 256 then
								l_tmp___20 := (spelltab.item.st_isu[l_gc]).to_integer_32
							else
								l_tmp___20 := (iswupper (l_gc.to_natural_32))
							end
							l_tmp___21 := l_tmp___20
				when 29 then
							if not (l_tmp___21.to_boolean) then
								l_pos := -1 + 44 -- skip if block
							end
				when 30 then -- if:
							if globals_inst.has_mbyte.to_boolean then
								l_bc := (globals_inst.mb_ptr2char.integer_32_item ([a_su.item.su_badword]))
							else
								l_bc := (a_su.item.su_badword[0]).to_integer_32
							end
							if not (globals_inst.enc_utf8.to_boolean) then
								l_pos := -1 + 33 -- skip if block
							end
				when 31 then -- if:
							if l_bc >= 128 then
								l_tmp___9 := (mbyte_inst.utf_isupper (l_bc))
							else
								l_pos := -1 + 33 -- goto _L___0
							end
				when 32 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 33 then -- else: | _L___0:
							if l_bc < 256 then
								l_tmp___8 := (spelltab.item.st_isu[l_bc]).to_integer_32
							else
								l_tmp___8 := (iswupper (l_bc.to_natural_32))
							end
							l_tmp___9 := l_tmp___8
				when 34 then
							if l_tmp___9.to_boolean then
								l_pos := -1 + 44 -- skip if block
							end
				when 35 then -- if:
							if not (globals_inst.enc_utf8.to_boolean) then
								l_pos := -1 + 38 -- skip if block
							end
				when 36 then -- if:
							if l_bc >= 128 then
								l_tmp___13 := (mbyte_inst.utf_fold (l_bc))
							else
								l_pos := -1 + 38 -- goto _L___1
							end
				when 37 then -- if block done, skip else block:
							l_pos := -1 + 39
				when 38 then -- else: | _L___1:
							if l_bc < 256 then
								l_tmp___12 := (spelltab.item.st_fold[l_bc]).to_integer_32
							else
								l_tmp___12 := (towlower (l_bc.to_natural_32)).to_integer_32
							end
							l_tmp___13 := l_tmp___12
				when 39 then
							if not (globals_inst.enc_utf8.to_boolean) then
								l_pos := -1 + 42 -- skip if block
							end
				when 40 then -- if:
							if l_gc >= 128 then
								l_tmp___17 := (mbyte_inst.utf_fold (l_gc))
							else
								l_pos := -1 + 42 -- goto _L___2
							end
				when 41 then -- if block done, skip else block:
							l_pos := -1 + 43
				when 42 then -- else: | _L___2:
							if l_gc < 256 then
								l_tmp___16 := (spelltab.item.st_fold[l_gc]).to_integer_32
							else
								l_tmp___16 := (towlower (l_gc.to_natural_32)).to_integer_32
							end
							l_tmp___17 := l_tmp___16
				when 43 then
							if l_tmp___13 /= l_tmp___17 then
								l_goodscore := l_goodscore + (26)
							end
				when 44 then -- if done | if done
							l_limit := ((4 * a_su.item.su_sfmaxscore - l_goodscore) - a_score) // 3
							if l_limit > 350 then
								l_goodscore := l_goodscore + (spell_edit_score (l_slang, a_su.item.su_badword, l_p___0))
							else
								l_goodscore := l_goodscore + (spell_edit_score_limit (l_slang, a_su.item.su_badword, l_p___0, l_limit))
							end
							if l_goodscore < 999_999 then
								l_goodscore := score_wordcount_adj (l_slang, l_goodscore, l_p___0, 0)
								l_goodscore := (3 * l_goodscore + a_score) // 4
								if l_goodscore <= a_su.item.su_sfmaxscore then
									add_suggestion (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_p___0, a_su.item.su_badlen, l_goodscore, a_score, 1, l_slang, 1)
								end
							end
				when 45 then -- if done | if done
							if js.loop_increment then
								l_i___0 := l_i___0 + 1
							end
							l_pos := -1 + 20 -- back to loop condition
				when 46 then -- loop done
							l_pos := -1 + 9 -- back to loop condition
				when 47 then -- loop done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	add_suggestion (a_su: CE_POINTER [PD_SUGINFO_S]; a_gap: CE_POINTER [PD_GROWARRAY]; a_goodword: CE_POINTER [NATURAL_8]; a_badlenarg: INTEGER_32; a_score: INTEGER_32; a_altscore: INTEGER_32; a_had_bonus: INTEGER_32; a_slang: CE_POINTER [PD_SLANG_S]; a_maxsf: INTEGER_32)
		local
			l_goodlen: INTEGER_32
			l_badlen: INTEGER_32
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_new_sug: CE_ARRAY [PD_SUGGEST_S]
			l_i___0: INTEGER_32
			l_pgood: CE_POINTER [NATURAL_8]
			l_pbad: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
		do
			create l_stp.make
			create l_new_sug.make (<<1>>)
			create l_pgood.make
			create l_pbad.make

			l_pgood := a_goodword + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_goodword))).to_integer_32
			l_pbad := a_su.item.su_badptr + a_badlenarg
			from
			until
				js.loop_done
			loop
				l_goodlen := l_pgood.distance (a_goodword)
				l_badlen := l_pbad.distance ((a_su.item.su_badptr))
				if l_goodlen <= 0 then
					js.break
				elseif l_badlen <= 0 then
					js.break
				end
				if not js.loop_jumped then
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___1 := (globals_inst.mb_head_off.integer_32_item ([a_goodword, l_pgood - 1])) + 1
					else
						l_tmp___1 := 1
					end
					l_pgood := l_pgood - l_tmp___1
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___3 := (globals_inst.mb_head_off.integer_32_item ([a_su.item.su_badptr, l_pbad - 1])) + 1
					else
						l_tmp___3 := 1
					end
					l_pbad := l_pbad - l_tmp___3
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___4 := globals_inst.mb_ptr2char.integer_32_item ([l_pgood])
						if l_tmp___4 /= (globals_inst.mb_ptr2char.integer_32_item ([l_pbad])) then
							js.break
						end
					elseif (l_pgood.item).to_integer_32 /= (l_pbad.item).to_integer_32 then
						js.break
					end
				end
			end
			if l_badlen = 0 then
				if l_goodlen = 0 then
					js.return
				end
			end
			if not js.return_called then
				if a_gap.item.ga_len = 0 then
					l_i___0 := -1
				else
					l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_gap.item.ga_data) + 0
					l_i___0 := a_gap.item.ga_len
					from
					until
						js.loop_done
					loop
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							js.break
						end
						if not js.loop_jumped and then (l_stp.item.st_wordlen = l_goodlen) then
							if l_stp.item.st_orglen = l_badlen then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_stp.item.st_word), create {CE_POINTER [INTEGER_8]}.make_cast (a_goodword), l_goodlen.to_natural_32)) = 0 then
									if (l_stp.item.st_slang).is_void then
										l_stp.item.st_slang := a_slang
									end
									l_new_sug.item.st_score := a_score
									l_new_sug.item.st_altscore := a_altscore
									l_new_sug.item.st_had_bonus := a_had_bonus
									if l_stp.item.st_had_bonus /= a_had_bonus then
										if a_had_bonus.to_boolean then
											rescore_one (a_su, l_stp)
										else
											l_new_sug.item.st_word := l_stp.item.st_word
											l_new_sug.item.st_wordlen := l_stp.item.st_wordlen
											l_new_sug.item.st_slang := l_stp.item.st_slang
											l_new_sug.item.st_orglen := l_badlen
											rescore_one (a_su, l_new_sug)
										end
									end
									if l_stp.item.st_score > l_new_sug.item.st_score then
										l_stp.item.st_score := l_new_sug.item.st_score
										l_stp.item.st_altscore := l_new_sug.item.st_altscore
										l_stp.item.st_had_bonus := l_new_sug.item.st_had_bonus
									end
									js.break
								end
							end
						end
						if not js.loop_jumped then
							l_stp := l_stp + 1
						end
					end
				end
				if l_i___0 < 0 then
					if (misc2_inst.ga_grow (a_gap, 1)) = 1 then
						l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len
						l_stp.item.st_word := misc2_inst.vim_strnsave (a_goodword, l_goodlen)
						if not (l_stp.item.st_word).is_void then
							l_stp.item.st_wordlen := l_goodlen
							l_stp.item.st_score := a_score
							l_stp.item.st_altscore := a_altscore
							l_stp.item.st_had_bonus := a_had_bonus
							l_stp.item.st_orglen := l_badlen
							l_stp.item.st_slang := a_slang
							a_gap.item.ga_len := (a_gap.item.ga_len) + 1
							if a_su.item.su_maxcount < 130 then
								l_tmp___9 := 150
							else
								l_tmp___9 := a_su.item.su_maxcount + 20
							end
							if a_gap.item.ga_len > l_tmp___9 + 50 then
								if a_maxsf.to_boolean then
									if a_su.item.su_maxcount < 130 then
										l_tmp___7 := 150
									else
										l_tmp___7 := a_su.item.su_maxcount + 20
									end
									a_su.item.su_sfmaxscore := cleanup_suggestions (a_gap, a_su.item.su_sfmaxscore, l_tmp___7)
								else
									l_i___0 := a_su.item.su_maxscore
									if a_su.item.su_maxcount < 130 then
										l_tmp___8 := 150
									else
										l_tmp___8 := a_su.item.su_maxcount + 20
									end
									a_su.item.su_maxscore := cleanup_suggestions (a_gap, a_su.item.su_maxscore, l_tmp___8)
								end
							end
						end
					end
				end
			end
		end

	aff_check_number (a_spinval: INTEGER_32; a_affval: INTEGER_32; a_name___1: CE_POINTER [INTEGER_8])
		do
			if a_spinval /= 0 then
				if a_spinval /= a_affval then
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%s value differs from what is used in another .aff file")))), a_name___1]).do_nothing
				end
			end
		end

	aff_check_string (a_spinval: CE_POINTER [NATURAL_8]; a_affval: CE_POINTER [NATURAL_8]; a_name___1: CE_POINTER [INTEGER_8])
		do
			if not a_spinval.is_void then
				if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_spinval), create {CE_POINTER [INTEGER_8]}.make_cast (a_affval))) /= 0 then
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%s value differs from what is used in another .aff file")))), a_name___1]).do_nothing
				end
			end
		end

	aff_process_flags (a_affile: CE_POINTER [PD_AFFFILE_S]; a_entry: CE_POINTER [PD_AFFENTRY_S])
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prevp: CE_POINTER [NATURAL_8]
			l_flag: NATURAL_32
			l_pos: INTEGER_32
		do
			create l_p___0.make (<<1>>)
			create l_prevp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_entry.item.ae_flags).is_void then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if a_affile.item.af_compforbid = {NATURAL_32} 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if a_affile.item.af_comppermit = {NATURAL_32} 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if: | _L___0:
						l_p___0.item := a_entry.item.ae_flags
				when 6 then -- loop condition:
						if (l_p___0.item.item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip loop
						end
				when 7 then -- loop body:
						l_prevp := l_p___0.item
						l_flag := get_affitem (a_affile.item.af_flagtype, l_p___0)
						if l_flag /= a_affile.item.af_comppermit then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if l_flag /= a_affile.item.af_compforbid then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						memmove (create {CE_POINTER [ANY]}.make_cast (l_prevp), create {CE_POINTER [ANY]}.make_cast (l_p___0.item), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item))) + {NATURAL_32} 1).do_nothing
						l_p___0.item := l_prevp
						if l_flag = a_affile.item.af_comppermit then
							a_entry.item.ae_comppermit := (1).to_integer_8
						else
							a_entry.item.ae_compforbid := (1).to_integer_8
						end
				when 12 then -- if done
						if a_affile.item.af_flagtype = 3 then
							if (l_p___0.item.item).to_integer_32 = 44 then
								l_p___0.item := l_p___0.item + 1
							end
						end
						l_pos := -1 + 6 -- back to loop condition
				when 13 then -- loop done
						if ((a_entry.item.ae_flags).item).to_integer_32 = 0 then
							a_entry.item.ae_flags := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
				when 14 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	affitem2flag (a_flagtype: INTEGER_32; a_item: CE_POINTER [NATURAL_8]; a_fname: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32): NATURAL_32
		local
			l_res: NATURAL_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			js: JUMP_STATE
		do
			create l_p___0.make (<<1>>)

			l_p___0.item := a_item
			l_res := get_affitem (a_flagtype, l_p___0)
			if l_res = {NATURAL_32} 0 then
				if a_flagtype = 3 then
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Flag is not a number in %%s line %%d: %%s")))), a_fname, a_lnum, a_item]).do_nothing
				else
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Illegal flag in %%s line %%d: %%s")))), a_fname, a_lnum, a_item]).do_nothing
				end
			end
			if (l_p___0.item.item).to_integer_32 /= 0 then
				message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_affname))), a_fname, a_lnum, a_item]).do_nothing
				Result := {NATURAL_32} 0
				js.return
			end
			if not js.return_called then
				Result := l_res
			end
		end

	allcap_copy (a_word: CE_POINTER [NATURAL_8]; a_wcopy: CE_POINTER [NATURAL_8])
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_d: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make (<<1>>)
			create l_d.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_wcopy
					l_s.item := a_word
				when 1 then -- loop condition:
					if not (not js.loop_done and then ((l_s.item.item).to_integer_32 /= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if globals_inst.has_mbyte.to_boolean then
							l_c := mbyte_inst.mb_cptr2char_adv (l_s)
						else
							l_tmp := l_s.item
							l_s.item := l_s.item + 1
							l_c := (l_tmp.item).to_integer_32
						end
						if not (globals_inst.enc_latin1like.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_c = 223 then
							l_c := ('S').code
							if l_d.distance (a_wcopy) >= 249 then
								js.break
							end
							if not js.loop_jumped then
								l_tmp___0 := l_d
								l_d := l_d + 1
								l_tmp___0.item := l_c.to_natural_8
							end
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___0:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_c >= 128 then
							l_c := (mbyte_inst.utf_toupper (l_c))
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_c < 256 then
							l_tmp___3 := (spelltab.item.st_upper[l_c]).to_integer_32
						else
							l_tmp___3 := (towupper (l_c.to_natural_32)).to_integer_32
						end
						l_c := l_tmp___3
				when 9 then -- if done
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								if l_d.distance (a_wcopy) >= 229 then
									js.break
								end
								if not js.loop_jumped then
									l_d := l_d + (globals_inst.mb_char2bytes.integer_32_item ([l_c, l_d]))
								end
							else
								if l_d.distance (a_wcopy) >= 249 then
									js.break
								end
								if not js.loop_jumped then
									l_tmp___5 := l_d
									l_d := l_d + 1
									l_tmp___5.item := l_c.to_natural_8
								end
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					l_d.item := (('%/0/').code).to_natural_8
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	badword_captype (a_word: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_flags___0: INTEGER_32
			l_c: INTEGER_32
			l_l: INTEGER_32
			l_u: INTEGER_32
			l_first___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_flags___0 := (captype (a_word, a_end))
					if not (((l_flags___0).bit_and (128)).to_boolean) then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_u := 0
						l_l := l_u
						l_first___0 := 0
						l_p___0 := a_word
				when 2 then -- loop condition:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						if globals_inst.has_mbyte.to_boolean then
							l_c := (globals_inst.mb_ptr2char.integer_32_item ([l_p___0]))
						else
							l_c := (l_p___0.item).to_integer_32
						end
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_c >= 128 then
							l_tmp___6 := (mbyte_inst.utf_isupper (l_c))
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if l_c < 256 then
							l_tmp___5 := (spelltab.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___5 := (iswupper (l_c.to_natural_32))
						end
						l_tmp___6 := l_tmp___5
				when 7 then
						if l_tmp___6.to_boolean then
							l_u := l_u + 1
							if l_p___0.is_equal (a_word) then
								l_first___0 := 1
							end
						else
							l_l := l_l + 1
						end
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
						else
							l_tmp___1 := 1
						end
						l_p___0 := l_p___0 + l_tmp___1
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						if not (l_u > l_l) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if l_u > 2 then
							l_flags___0 := (l_flags___0).bit_or ((4))
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___0:
						if l_first___0.to_boolean then
							l_flags___0 := (l_flags___0).bit_or ((2))
						end
				when 12 then
						if l_u >= 2 then
							if l_l >= 2 then
								l_flags___0 := (l_flags___0).bit_or ((32))
							end
						end
				when 13 then -- if done
					Result := l_flags___0
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	byte_in_str (a_str___1: CE_POINTER [NATURAL_8]; a_n: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0 := a_str___1
			from
			until
				not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				if (l_p___0.item).to_integer_32 = a_n then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_p___0 := l_p___0 + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	bytes2offset (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_nr: INTEGER_32
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make

			l_p___0 := a_pp.item
			l_tmp := l_p___0
			l_p___0 := l_p___0 + 1
			l_c := (l_tmp.item).to_integer_32
			if ((l_c).bit_and (128)) = 0 then
				l_nr := l_c - 1
			elseif ((l_c).bit_and (192)) = 128 then
				l_nr := ((l_c).bit_and (63)) - 1
				l_tmp___0 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___0.item).to_integer_32 - 1)
			elseif ((l_c).bit_and (224)) = 192 then
				l_nr := ((l_c).bit_and (31)) - 1
				l_tmp___1 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___1.item).to_integer_32 - 1)
				l_tmp___2 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___2.item).to_integer_32 - 1)
			else
				l_nr := ((l_c).bit_and (15)) - 1
				l_tmp___3 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___3.item).to_integer_32 - 1)
				l_tmp___4 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___4.item).to_integer_32 - 1)
				l_tmp___5 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___5.item).to_integer_32 - 1)
			end
			a_pp.item := l_p___0
			Result := l_nr
		end

	can_be_compound (a_sp: CE_POINTER [PD_TRYSTATE_S]; a_slang: CE_POINTER [PD_SLANG_S]; a_compflags: CE_POINTER [NATURAL_8]; a_flag: INTEGER_32): INTEGER_32
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_v: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp.make

			if (a_sp.item.ts_complen).to_integer_32 = (a_sp.item.ts_compsplit).to_integer_32 then
				l_tmp := a_slang.item.sl_compstartflags
			else
				l_tmp := a_slang.item.sl_compallflags
			end
			if not (byte_in_str (l_tmp, a_flag)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called and then (not (a_slang.item.sl_comprules).is_void) then
				if (a_sp.item.ts_complen).to_integer_32 > (a_sp.item.ts_compsplit).to_integer_32 then
					a_compflags[(a_sp.item.ts_complen).to_integer_32] := a_flag.to_natural_8
					a_compflags[((a_sp.item.ts_complen).to_integer_32 + 1)] := (('%/0/').code).to_natural_8
					l_v := match_compoundrule (a_slang, a_compflags + (a_sp.item.ts_compsplit).to_integer_32)
					a_compflags[(a_sp.item.ts_complen).to_integer_32] := (('%/0/').code).to_natural_8
					Result := l_v
					js.return
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	can_compound (a_slang: CE_POINTER [PD_SLANG_S]; a_word: CE_POINTER [NATURAL_8]; a_flags___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_uflags: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_regmatch___0.make (<<1>>)
			create l_uflags.make (<<500>>)
			create l_p___0.make

			if (a_slang.item.sl_compprog).is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				if globals_inst.enc_utf8.to_boolean then
					l_p___0 := l_uflags
					l_i___0 := 0
					from
					until
						(a_flags___0[l_i___0]).to_integer_32 = 0
					loop
						l_p___0 := l_p___0 + (globals_inst.mb_char2bytes.integer_32_item ([(a_flags___0[l_i___0]).to_integer_32, l_p___0]))
						l_i___0 := l_i___0 + 1
					end
					l_p___0.item := (('%/0/').code).to_natural_8
					l_p___0 := l_uflags
				else
					l_p___0 := a_flags___0
				end
				l_regmatch___0.item.regprog := a_slang.item.sl_compprog
				l_regmatch___0.item.rm_ic := 0
				if not (regexp_inst.vim_regexec (l_regmatch___0, l_p___0, 0)).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called and then (a_slang.item.sl_compsylmax < 250) then
				if (count_syllables (a_slang, a_word)) > a_slang.item.sl_compsylmax then
					Result := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_flags___0))).to_integer_32 < a_slang.item.sl_compmax).to_integer
					js.return
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	captype (a_word: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_firstcap: INTEGER_32
			l_allcap: INTEGER_32
			l_past_second: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make (<<1>>)
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_past_second := 0
					l_p___0.item := a_word
					from
					until
						js.loop_done
					loop
						if (spell_iswordp_nmw (l_p___0.item)).to_boolean then
							js.break
						end
						if not js.loop_jumped then
							if a_end.is_void then
								l_tmp___1 := ((l_p___0.item.item).to_integer_32 = 0).to_integer
							else
								l_tmp___1 := (((l_p___0.item).c_pointer.to_integer_32).to_natural_32 >= (a_end.c_pointer.to_integer_32).to_natural_32).to_integer
							end
							if l_tmp___1.to_boolean then
								Result := 0
								js.return
							end
							if not js.return_called then
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0.item]))
								else
									l_tmp___0 := 1
								end
								l_p___0.item := l_p___0.item + l_tmp___0
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.has_mbyte.to_boolean then
							l_c := mbyte_inst.mb_ptr2char_adv (l_p___0)
						else
							l_tmp___3 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_c := (l_tmp___3.item).to_integer_32
						end
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_c >= 128 then
							l_allcap := (mbyte_inst.utf_isupper (l_c))
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_c < 256 then
							l_tmp___6 := (spelltab.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___6 := (iswupper (l_c.to_natural_32))
						end
						l_allcap := l_tmp___6
				when 5 then
						l_firstcap := l_allcap
				when 6 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 16 -- skip loop
						end
				when 7 then -- loop body:
						if a_end.is_void then
							l_tmp___15 := ((l_p___0.item.item).to_integer_32 /= 0).to_integer
						else
							l_tmp___15 := (((l_p___0.item).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32).to_integer
						end
						if not l_tmp___15.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if not ((spell_iswordp_nmw (l_p___0.item)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if globals_inst.has_mbyte.to_boolean then
							l_c := (globals_inst.mb_ptr2char.integer_32_item ([l_p___0.item]))
						else
							l_c := (l_p___0.item.item).to_integer_32
						end
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_c >= 128 then
							l_tmp___13 := (mbyte_inst.utf_isupper (l_c))
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if l_c < 256 then
							l_tmp___12 := (spelltab.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___12 := (iswupper (l_c.to_natural_32))
						end
						l_tmp___13 := l_tmp___12
				when 13 then
						if l_tmp___13.to_boolean then
							if not l_allcap.to_boolean then
								Result := 128
								js.return
							end
						else
							if l_past_second.to_boolean then
								if l_allcap.to_boolean then
									Result := 128
									js.return
								end
							end
							if not js.return_called then
								l_allcap := 0
							end
						end
						if not js.return_called then
							l_past_second := 1
						end
				when 14 then -- if done
						if not js.return_called then
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___8 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0.item]))
							else
								l_tmp___8 := 1
							end
							l_p___0.item := l_p___0.item + l_tmp___8
						end
				when 15 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 16 then -- loop done | if done
						if not js.return_called and then (l_allcap.to_boolean) then
							Result := 4
							js.return
						end
						if not js.return_called and then (l_firstcap.to_boolean) then
							Result := 2
							js.return
						end
						if not js.return_called then
							Result := 0
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_need_cap (a_lnum: INTEGER_32; a_col: INTEGER_32): INTEGER_32
		local
			l_need_cap: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_line_copy: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_endcol: INTEGER_32
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make
			create l_line_copy.make
			create l_p___0.make
			create l_regmatch___0.make (<<1>>)

			l_need_cap := 0
			l_line_copy := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if ((globals_inst.curwin.item.w_s).item.b_cap_prog).is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_line := memline_inst.ml_get_curline
				l_endcol := 0
				if (charset_inst.skipwhite (l_line)).distance (l_line) >= a_col then
					if a_lnum = 1 then
						l_need_cap := 1
					else
						l_line := memline_inst.ml_get (a_lnum - 1)
						if ((charset_inst.skipwhite (l_line)).item).to_integer_32 = 0 then
							l_need_cap := 1
						else
							l_line_copy := misc1_inst.concat_str (l_line, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
							l_line := l_line_copy
							l_endcol := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32
						end
					end
				else
					l_endcol := a_col
				end
				if l_endcol > 0 then
					l_regmatch___0.item.regprog := (globals_inst.curwin.item.w_s).item.b_cap_prog
					l_regmatch___0.item.rm_ic := 0
					l_p___0 := l_line + l_endcol
					from
					until
						js.loop_done
					loop
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___3 := (globals_inst.mb_head_off.integer_32_item ([l_line, l_p___0 - 1])) + 1
						else
							l_tmp___3 := 1
						end
						l_p___0 := l_p___0 - l_tmp___3
						if l_p___0.is_equal (l_line) then
							js.break
						elseif (spell_iswordp_nmw (l_p___0)).to_boolean then
							js.break
						end
						if not js.loop_jumped then
							if (regexp_inst.vim_regexec (l_regmatch___0, l_p___0, 0)).to_boolean then
								if (l_regmatch___0.item.endp[0]).is_equal (l_line + l_endcol) then
									l_need_cap := 1
									js.break
								end
							end
						end
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line_copy))
				Result := l_need_cap
			end
		end

	check_renumber (a_spin: CE_POINTER [PD_SPELLINFO_S])
		do
			if a_spin.item.si_newprefID = a_spin.item.si_newcompID then
				if a_spin.item.si_newcompID < 128 then
					a_spin.item.si_newprefID := 127
					a_spin.item.si_newcompID := 255
				end
			end
		end

	check_suggestions (a_su: CE_POINTER [PD_SUGINFO_S]; a_gap: CE_POINTER [PD_GROWARRAY])
		local
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_i___0: INTEGER_32
			l_longword: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_attr: CE_ARRAY [NATURAL_32]
		do
			create l_stp.make
			create l_longword.make (<<251>>)
			create l_attr.make (<<1>>)

			l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_gap.item.ga_data) + 0
			l_i___0 := a_gap.item.ga_len - 1
			from
			until
				not (l_i___0 >= 0)
			loop
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_longword), create {CE_POINTER [INTEGER_8]}.make_cast ((l_stp + l_i___0).item.st_word)).do_nothing
				l_len := (l_stp + l_i___0).item.st_wordlen
				misc2_inst.vim_strncpy (l_longword + l_len, a_su.item.su_badptr + (l_stp + l_i___0).item.st_orglen, (250 - l_len).to_natural_32)
				l_attr.item := {PC_HLF_T}.HLF_COUNT
				spell_check (globals_inst.curwin, l_longword, l_attr, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0).do_nothing
				if l_attr.item /= {NATURAL_32} 41 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_stp + l_i___0).item.st_word))
					a_gap.item.ga_len := (a_gap.item.ga_len) - 1
					if l_i___0 < a_gap.item.ga_len then
						memmove (create {CE_POINTER [ANY]}.make_cast ((l_stp + l_i___0)), create {CE_POINTER [ANY]}.make_cast (((l_stp + l_i___0) + 1)), (create {PD_SUGGEST_S}.make).structure_size.to_natural_32 * (a_gap.item.ga_len - l_i___0).to_natural_32).do_nothing
					end
				end
				l_i___0 := l_i___0 - 1
			end
		end

	cleanup_suggestions (a_gap: CE_POINTER [PD_GROWARRAY]; a_maxscore: INTEGER_32; a_keep: INTEGER_32): INTEGER_32
		local
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_stp.make

			l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_gap.item.ga_data) + 0
			qsort (a_gap.item.ga_data, (a_gap.item.ga_len).to_natural_32, (create {PD_SUGGEST_S}.make).structure_size.to_natural_32, sug_compare_address)
			if a_gap.item.ga_len > a_keep then
				l_i___0 := a_keep
				from
				until
					not (l_i___0 < a_gap.item.ga_len)
				loop
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_stp + l_i___0).item.st_word))
					l_i___0 := l_i___0 + 1
				end
				a_gap.item.ga_len := a_keep
				Result := ((l_stp + (a_keep - 1)).item.st_score)
				js.return
			end
			if not js.return_called then
				Result := a_maxscore
			end
		end

	clear_midword (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			memset (create {CE_POINTER [ANY]}.make_cast (((a_wp___0.item.w_s).item.b_spell_ismw)), 0, (256).to_natural_32).do_nothing
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((a_wp___0.item.w_s).item.b_spell_ismw_mb));
			(a_wp___0.item.w_s).item.b_spell_ismw_mb := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
		end

	clear_node (a_node: CE_POINTER [PD_WORDNODE_S])
		local
			l_np: CE_POINTER [PD_WORDNODE_S]
		do
			create l_np.make

			if not a_node.is_void then
				l_np := a_node
				from
				until
					l_np.is_void
				loop
					l_np.item.wn_u1.index := 0
					l_np.item.wn_u2.wnode := create {CE_POINTER [PD_WORDNODE_S]}.make_shared (default_pointer)
					if (l_np.item.wn_byte).to_integer_32 /= 0 then
						clear_node (l_np.item.wn_child)
					end
					l_np := l_np.item.wn_sibling
				end
			end
		end

	clear_spell_chartab (a_sp: CE_POINTER [PD_SPELLTAB_S])
		local
			l_i___0: INTEGER_32
		do
			memset (create {CE_POINTER [ANY]}.make_cast ((a_sp.item.st_isw)), 0, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (256).to_natural_32)).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast ((a_sp.item.st_isu)), 0, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (256).to_natural_32)).do_nothing
			l_i___0 := 0
			from
			until
				not (l_i___0 < 256)
			loop
				a_sp.item.st_fold[l_i___0] := l_i___0.to_natural_8
				a_sp.item.st_upper[l_i___0] := l_i___0.to_natural_8
				l_i___0 := l_i___0 + 1
			end
			l_i___0 := ('0').code
			from
			until
				not (l_i___0 <= 57)
			loop
				a_sp.item.st_isw[l_i___0] := (1).to_natural_8
				l_i___0 := l_i___0 + 1
			end
			l_i___0 := ('A').code
			from
			until
				not (l_i___0 <= 90)
			loop
				a_sp.item.st_isw[l_i___0] := (1).to_natural_8
				a_sp.item.st_isu[l_i___0] := (1).to_natural_8
				a_sp.item.st_fold[l_i___0] := (l_i___0 + 32).to_natural_8
				l_i___0 := l_i___0 + 1
			end
			l_i___0 := ('a').code
			from
			until
				not (l_i___0 <= 122)
			loop
				a_sp.item.st_isw[l_i___0] := (1).to_natural_8
				a_sp.item.st_upper[l_i___0] := (l_i___0 - 32).to_natural_8
				l_i___0 := l_i___0 + 1
			end
		end

	close_spellbuf (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			if not a_buf___6.is_void then
				memline_inst.ml_close (a_buf___6, 1)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_buf___6))
			end
		end

	count_common_word (a_lp: CE_POINTER [PD_SLANG_S]; a_word: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_count___2: INTEGER_32)
		local
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_wc: CE_POINTER [PD_WORDCOUNT_S]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: NATURAL_16
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hi___1.make
			create l_wc.make
			create l_buf___6.make (<<250>>)
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_len = -1 then
						l_p___0 := a_word
					else
						misc2_inst.vim_strncpy (l_buf___6, a_word, a_len.to_natural_32)
						l_p___0 := l_buf___6
					end
					l_hash := hashtab_inst.hash_hash (l_p___0)
					l_hi___1 := hashtab_inst.hash_lookup (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount")), l_p___0, l_hash)
					if not ((l_hi___1.item.hi_key).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_wc := create {CE_POINTER [PD_WORDCOUNT_S]}.make_cast ((misc2_inst.alloc ((create {PD_WORDCOUNT_S}.make).structure_size.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))))))
						if l_wc.is_void then
							js.return
						end
						if not js.return_called then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_wc.item.wc_word)), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
							l_wc.item.wc_count := a_count___2.to_natural_16
							hashtab_inst.hash_add_item (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount")), l_hi___1, l_wc.item.wc_word, l_hash).do_nothing
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_wc := create {CE_POINTER [PD_WORDCOUNT_S]}.make_cast ((l_hi___1.item.hi_key - (((dumwc.item.wc_word).distance ((create {CE_POINTER [NATURAL_8]}.make_cast (dumwc)))).to_natural_32).to_integer_32))
						l_tmp___1 := ((l_wc.item.wc_count).to_integer_32 + a_count___2).to_natural_16
						l_wc.item.wc_count := l_tmp___1
						if l_tmp___1.to_natural_32 < a_count___2.to_natural_32 then
							l_wc.item.wc_count := (65_535).to_natural_16
						end
				when 7 then -- if done
						if not js.return_called then
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	count_syllables (a_slang: CE_POINTER [PD_SLANG_S]; a_word: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_cnt: INTEGER_32
			l_skip___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_syl: CE_POINTER [PD_SYL_ITEM_S]
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_syl.make

			l_cnt := 0
			l_skip___0 := 0
			if (a_slang.item.sl_syllable).is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_p___0 := a_word
				from
				until
					not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					if (l_p___0.item).to_integer_32 = 32 then
						l_len := 1
						l_cnt := 0
						js.continue
					end
					if not js.loop_jumped then
						l_len := 0
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_slang.item.sl_syl_items.ga_len)
						loop
							l_syl := create {CE_POINTER [PD_SYL_ITEM_S]}.make_cast (a_slang.item.sl_syl_items.ga_data) + l_i___0
							if l_syl.item.sy_len > l_len then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast ((l_syl.item.sy_chars)), (l_syl.item.sy_len).to_natural_32)) = 0 then
									l_len := l_syl.item.sy_len
								end
							end
							l_i___0 := l_i___0 + 1
						end
						if l_len /= 0 then
							l_cnt := l_cnt + 1
							l_skip___0 := 0
						else
							l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
							l_len := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
							if (misc2_inst.vim_strchr (a_slang.item.sl_syllable, l_c)).is_void then
								l_skip___0 := 0
							elseif not l_skip___0.to_boolean then
								l_cnt := l_cnt + 1
								l_skip___0 := 1
							end
						end
					end
					if js.loop_increment then
						l_p___0 := l_p___0 + l_len
					end
				end
				Result := l_cnt
			end
		end

	deref_wordnode (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_node: CE_POINTER [PD_WORDNODE_S]): INTEGER_32
		local
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_cnt: INTEGER_32
		do
			create l_np.make

			l_cnt := 0
			a_node.item.wn_refs := (a_node.item.wn_refs) - 1
			if a_node.item.wn_refs = 0 then
				l_np := a_node
				from
				until
					l_np.is_void
				loop
					if not (l_np.item.wn_child).is_void then
						l_cnt := l_cnt + (deref_wordnode (a_spin, l_np.item.wn_child))
					end
					free_wordnode (a_spin, l_np)
					l_cnt := l_cnt + 1
					l_np := l_np.item.wn_sibling
				end
				l_cnt := l_cnt + 1
			end
			Result := l_cnt
		end

	did_set_spelllang (a_wp___0: CE_POINTER [PD_WINDOW_S]): CE_POINTER [NATURAL_8]
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_splp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_region: CE_POINTER [NATURAL_8]
			l_region_cp: CE_ARRAY [NATURAL_8]
			l_filename: INTEGER_32
			l_region_mask: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_c: INTEGER_32
			l_lang: CE_ARRAY [NATURAL_8]
			l_spf_name: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_round: INTEGER_32
			l_spf: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_use_region: CE_POINTER [NATURAL_8]
			l_dont_use_region: INTEGER_32
			l_nobreak: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lp2: CE_POINTER [PD_LANGP_S]
			l_ret_msg: CE_POINTER [NATURAL_8]
			l_spl_copy: CE_POINTER [NATURAL_8]
			l_tmp___13: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ga.make (<<1>>)
			create l_splp.make (<<1>>)
			create l_region.make
			create l_region_cp.make (<<3>>)
			create l_slang.make
			create l_lang.make (<<251>>)
			create l_spf_name.make (<<4_096>>)
			create l_p___0.make
			create l_spf.make (<<1>>)
			create l_use_region.make
			create l_lp.make
			create l_lp2.make
			create l_ret_msg.make
			create l_spl_copy.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_use_region := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_dont_use_region := 0
					l_nobreak := 0
					l_ret_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					if recursive___5.to_boolean then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						recursive___5 := 1
						misc2_inst.ga_init2 (l_ga, ((create {PD_LANGP_S}.make).structure_size.to_natural_32).to_integer_32, 2)
						clear_midword (a_wp___0)
						l_spl_copy := misc2_inst.vim_strsave ((a_wp___0.item.w_s).item.b_p_spl)
						if l_spl_copy.is_void then
							l_pos := -1 + 18 -- goto theend
						end
				when 2 then
						l_splp.item := l_spl_copy
				when 3 then -- loop condition:
						if not (not js.loop_done and then ((l_splp.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 4 then -- loop body:
						misc2_inst.copy_option_part (l_splp, l_lang, 250, ce_string (",")).do_nothing
						l_region := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lang))).to_integer_32
						if not (l_len > 4) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (((l_lang + l_len) - 4)), ce_string (".spl"))) = 0 then
							l_filename := 1
							l_p___0 := misc2_inst.vim_strchr ((misc1_inst.gettail (l_lang)), ('_').code)
							if not l_p___0.is_void then
								if (l_p___0[1]).to_integer_32 < 127 then
									if ((((ctype_b_loc).item[(l_p___0[1]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
										if (l_p___0[2]).to_integer_32 < 127 then
											if ((((ctype_b_loc).item[(l_p___0[2]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
												if (l_p___0[3]).to_integer_32 < 127 then
													if ((((ctype_b_loc).item[(l_p___0[3]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
														l_dont_use_region := 1
													else
														misc2_inst.vim_strncpy (l_region_cp, l_p___0 + 1, (2).to_natural_32)
														memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 3)), ((l_len - (l_p___0.distance (l_lang))) - 2).to_natural_32).do_nothing
														l_len := l_len - (3)
														l_region := l_region_cp
													end
												else
													misc2_inst.vim_strncpy (l_region_cp, l_p___0 + 1, (2).to_natural_32)
													memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 3)), ((l_len - (l_p___0.distance (l_lang))) - 2).to_natural_32).do_nothing
													l_len := l_len - (3)
													l_region := l_region_cp
												end
											else
												l_dont_use_region := 1
											end
										else
											l_dont_use_region := 1
										end
									else
										l_dont_use_region := 1
									end
								else
									l_dont_use_region := 1
								end
							else
								l_dont_use_region := 1
							end
							l_slang := first_lang
							from
							until
								not (not js.loop_done and then (not l_slang.is_void))
							loop
								if (misc1_inst.fullpathcmp (l_lang, l_slang.item.sl_fname, 0)) = 1 then
									js.break
								end
								if not js.loop_jumped then
									l_slang := l_slang.item.sl_next
								end
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_filename := 0
						if l_len > 3 then
							if (l_lang[l_len - 3]).to_integer_32 = 95 then
								l_region := (l_lang + l_len) - 2
								l_len := l_len - (3)
								l_lang[l_len] := (('%/0/').code).to_natural_8
							else
								l_dont_use_region := 1
							end
						else
							l_dont_use_region := 1
						end
						l_slang := first_lang
						from
						until
							not (not js.loop_done and then (not l_slang.is_void))
						loop
							if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lang), create {CE_POINTER [INTEGER_8]}.make_cast (l_slang.item.sl_name))) = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_slang := l_slang.item.sl_next
							end
						end
				when 8 then
						if not l_region.is_void then
							if not l_use_region.is_void then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_region), create {CE_POINTER [INTEGER_8]}.make_cast (l_use_region))) /= 0 then
									l_dont_use_region := 1
								end
							end
							l_use_region := l_region
						end
						if l_slang.is_void then
							if l_filename.to_boolean then
								spell_load_file (l_lang, l_lang, create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer), 0).do_nothing
							else
								spell_load_lang (l_lang)
								if not (buffer_inst.buf_valid (a_wp___0.item.w_buffer)).to_boolean then
									l_ret_msg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E797: SpellFileMissing autocommand deleted buffer"))
									l_pos := -1 + 18 -- goto theend
								end
							end
						end
				when 9 then
						l_slang := first_lang
				when 10 then -- loop condition:
						if l_slang.is_void then
							l_pos := -1 + 16 -- skip loop
						end
				when 11 then -- loop body:
						if l_filename.to_boolean then
							l_tmp___13 := ((misc1_inst.fullpathcmp (l_lang, l_slang.item.sl_fname, 0)) = 1).to_integer
						else
							l_tmp___13 := ((strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lang), create {CE_POINTER [INTEGER_8]}.make_cast (l_slang.item.sl_name))) = 0).to_integer
						end
						if not (l_tmp___13.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 12 then -- if:
						l_region_mask := 255
						if not l_filename.to_boolean then
							if not l_region.is_void then
								l_c := find_region (l_slang.item.sl_regions, l_region)
								if l_c = 255 then
									if (l_slang.item.sl_add).to_boolean then
										if (l_slang.item.sl_regions[0]).to_integer_32 /= 0 then
											l_region_mask := 0
										end
									else
										message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Warning: region %%s not supported")))), l_region]).do_nothing
									end
								else
									l_region_mask := (1).bit_shift_left (l_c)
								end
							end
						end
						if l_region_mask = 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (misc2_inst.ga_grow (l_ga, 1)) = 0 then
							misc2_inst.ga_clear (l_ga)
							l_ret_msg := globals_inst.e_outofmem
							l_pos := -1 + 18 -- goto theend
						end
				when 14 then;
						(create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_slang := l_slang;
						(create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_region := l_region_mask
						l_ga.item.ga_len := (l_ga.item.ga_len) + 1
						use_midword (l_slang, a_wp___0)
						if (l_slang.item.sl_nobreak).to_boolean then
							l_nobreak := 1
						end
				when 15 then -- if done | if done
						l_slang := l_slang.item.sl_next
						l_pos := -1 + 10 -- back to loop condition
				when 16 then -- loop done
						l_pos := -1 + 3 -- back to loop condition
				when 17 then -- loop done
						l_spf.item := (globals_inst.curwin.item.w_s).item.b_p_spf
						l_round := 0
						from
						until
							js.loop_done
						loop
							if l_round /= 0 then
								if (l_spf.item.item).to_integer_32 = 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								if l_round = 0 then
									if int_wordlist.is_void then
										js.continue
									end
									if not js.loop_jumped then
										int_wordlist_spl (l_spf_name)
									end
								else
									misc2_inst.copy_option_part (l_spf, l_spf_name, 4_091, ce_string (",")).do_nothing
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_spf_name), ce_string (".spl")).do_nothing
									l_c := 0
									from
									until
										not (not js.loop_done and then (l_c < l_ga.item.ga_len))
									loop
										l_p___0 := ((create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_c).item.lp_slang).item.sl_fname
										if not l_p___0.is_void then
											if (misc1_inst.fullpathcmp (l_spf_name, l_p___0, 0)) = 1 then
												js.break
											end
										end
										if not js.loop_jumped then
											l_c := l_c + 1
										end
									end
									if l_c < l_ga.item.ga_len then
										js.continue
									end
								end
							end
							if not js.loop_jumped then
								l_slang := first_lang
								from
								until
									not (not js.loop_done and then (not l_slang.is_void))
								loop
									if (misc1_inst.fullpathcmp (l_spf_name, l_slang.item.sl_fname, 0)) = 1 then
										js.break
									end
									if not js.loop_jumped then
										l_slang := l_slang.item.sl_next
									end
								end
								if l_slang.is_void then
									if l_round = 0 then
										strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_lang), ce_string ("internal wordlist")).do_nothing
									else
										misc2_inst.vim_strncpy (l_lang, (misc1_inst.gettail (l_spf_name)), (250).to_natural_32)
										l_p___0 := misc2_inst.vim_strchr (l_lang, ('.').code)
										if not l_p___0.is_void then
											l_p___0.item := (('%/0/').code).to_natural_8
										end
									end
									l_slang := spell_load_file (l_spf_name, l_lang, create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer), 1)
									if not l_slang.is_void then
										if l_nobreak.to_boolean then
											l_slang.item.sl_nobreak := (1).to_natural_8
										end
									end
								end
								if not l_slang.is_void then
									if (misc2_inst.ga_grow (l_ga, 1)) = 1 then
										l_region_mask := 255
										if not l_use_region.is_void then
											if not l_dont_use_region.to_boolean then
												l_c := find_region (l_slang.item.sl_regions, l_use_region)
												if l_c /= 255 then
													l_region_mask := (1).bit_shift_left (l_c)
												elseif (l_slang.item.sl_regions[0]).to_integer_32 /= 0 then
													l_region_mask := 0
												end
											end
										end
										if l_region_mask /= 0 then
											(create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_slang := l_slang;
											(create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_sallang := create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer);
											(create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_replang := create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer);
											(create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_region := l_region_mask
											l_ga.item.ga_len := (l_ga.item.ga_len) + 1
											use_midword (l_slang, a_wp___0)
										end
									end
								end
							end
							if js.loop_increment then
								l_round := l_round + 1
							end
						end
						misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared ((a_wp___0.item.w_s).c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_langp")));
						(a_wp___0.item.w_s).item.b_langp := (l_ga.item).twin
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0 < l_ga.item.ga_len))
						loop
							l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_i___0
							if (l_lp.item.lp_slang).item.sl_sal.ga_len > 0 then
								l_lp.item.lp_sallang := l_lp.item.lp_slang
							else
								l_j := 0
								from
								until
									not (not js.loop_done and then (l_j < l_ga.item.ga_len))
								loop
									l_lp2 := create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_j
									if (l_lp2.item.lp_slang).item.sl_sal.ga_len > 0 then
										if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_lp.item.lp_slang).item.sl_name), create {CE_POINTER [INTEGER_8]}.make_cast ((l_lp2.item.lp_slang).item.sl_name), (2).to_natural_32)) = 0 then
											l_lp.item.lp_sallang := l_lp2.item.lp_slang
											js.break
										end
									end
									if not js.loop_jumped then
										l_j := l_j + 1
									end
								end
							end
							if (l_lp.item.lp_slang).item.sl_rep.ga_len > 0 then
								l_lp.item.lp_replang := l_lp.item.lp_slang
							else
								l_j := 0
								from
								until
									not (not js.loop_done and then (l_j < l_ga.item.ga_len))
								loop
									l_lp2 := create {CE_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_j
									if (l_lp2.item.lp_slang).item.sl_rep.ga_len > 0 then
										if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_lp.item.lp_slang).item.sl_name), create {CE_POINTER [INTEGER_8]}.make_cast ((l_lp2.item.lp_slang).item.sl_name), (2).to_natural_32)) = 0 then
											l_lp.item.lp_replang := l_lp2.item.lp_slang
											js.break
										end
									end
									if not js.loop_jumped then
										l_j := l_j + 1
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
				when 18 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_spl_copy))
						recursive___5 := 0
						Result := l_ret_msg
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dump_prefixes (a_slang: CE_POINTER [PD_SLANG_S]; a_word: CE_POINTER [NATURAL_8]; a_pat: CE_POINTER [NATURAL_8]; a_dir___0: CE_POINTER [INTEGER_32]; a_dumpflags: INTEGER_32; a_flags___0: INTEGER_32; a_startlnum: INTEGER_32): INTEGER_32
		local
			l_arridx: CE_ARRAY [INTEGER_32]
			l_curi: CE_ARRAY [INTEGER_32]
			l_prefix: CE_ARRAY [NATURAL_8]
			l_word_up: CE_ARRAY [NATURAL_8]
			l_has_word_up: INTEGER_32
			l_c: INTEGER_32
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_lnum: INTEGER_32
			l_depth___1: INTEGER_32
			l_n: INTEGER_32
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arridx.make (<<250>>)
			create l_curi.make (<<250>>)
			create l_prefix.make (<<250>>)
			create l_word_up.make (<<250>>)
			create l_byts.make
			create l_idxs.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_has_word_up := 0
					l_lnum := a_startlnum
					if globals_inst.has_mbyte.to_boolean then
						l_c := (globals_inst.mb_ptr2char.integer_32_item ([a_word]))
					else
						l_c := (a_word.item).to_integer_32
					end
					if not (globals_inst.enc_utf8.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_c >= 128 then
							l_tmp___3 := (mbyte_inst.utf_toupper (l_c))
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_c < 256 then
							l_tmp___2 := (spelltab.item.st_upper[l_c]).to_integer_32
						else
							l_tmp___2 := (towupper (l_c.to_natural_32)).to_integer_32
						end
						l_tmp___3 := l_tmp___2
				when 4 then
					if l_tmp___3 /= l_c then
						onecap_copy (a_word, l_word_up, 1)
						l_has_word_up := 1
					end
					l_byts := a_slang.item.sl_pbyts
					l_idxs := a_slang.item.sl_pidxs
					if not l_byts.is_void then
						l_depth___1 := 0
						l_arridx[0] := 0
						l_curi[0] := 1
						from
						until
							js.loop_done
						loop
							if l_depth___1 >= 0 then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_n := l_arridx[l_depth___1]
								l_len := (l_byts[l_n]).to_integer_32
								if l_curi[l_depth___1] > l_len then
									l_depth___1 := l_depth___1 - 1
									misc1_inst.line_breakcheck
								else
									l_n := l_n + (l_curi[l_depth___1])
									l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
									l_c := (l_byts[l_n]).to_integer_32
									if l_c = 0 then
										l_i___0 := 1
										from
										until
											not (not js.loop_done and then (l_i___0 < l_len))
										loop
											if (l_byts[(l_n + l_i___0)]).to_integer_32 /= 0 then
												js.break
											end
											if not js.loop_jumped then
												l_i___0 := l_i___0 + 1
											end
										end
										l_curi[l_depth___1] := l_curi[l_depth___1] + (l_i___0 - 1)
										l_c := valid_word_prefix (l_i___0, l_n, a_flags___0, a_word, a_slang, 0)
										if l_c /= 0 then
											misc2_inst.vim_strncpy (l_prefix + l_depth___1, a_word, ((250 - l_depth___1) - 1).to_natural_32)
											if ((l_c).bit_and (((1).bit_shift_left (24)))).to_boolean then
												l_tmp___4 := (a_flags___0).bit_or (8)
											else
												l_tmp___4 := a_flags___0
											end
											dump_word (a_slang, l_prefix, a_pat, a_dir___0, a_dumpflags, l_tmp___4, l_lnum)
											if l_lnum /= 0 then
												l_lnum := l_lnum + 1
											end
										end
										if l_has_word_up.to_boolean then
											l_c := valid_word_prefix (l_i___0, l_n, a_flags___0, l_word_up, a_slang, 1)
											if l_c /= 0 then
												misc2_inst.vim_strncpy (l_prefix + l_depth___1, l_word_up, ((250 - l_depth___1) - 1).to_natural_32)
												if ((l_c).bit_and (((1).bit_shift_left (24)))).to_boolean then
													l_tmp___5 := (a_flags___0).bit_or (8)
												else
													l_tmp___5 := a_flags___0
												end
												dump_word (a_slang, l_prefix, a_pat, a_dir___0, a_dumpflags, l_tmp___5, l_lnum)
												if l_lnum /= 0 then
													l_lnum := l_lnum + 1
												end
											end
										end
									else
										l_tmp___6 := l_depth___1
										l_depth___1 := l_depth___1 + 1
										l_prefix[l_tmp___6] := l_c.to_natural_8
										l_arridx[l_depth___1] := l_idxs[l_n]
										l_curi[l_depth___1] := 1
									end
								end
							end
						end
					end
					Result := l_lnum
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dump_word (a_slang: CE_POINTER [PD_SLANG_S]; a_word: CE_POINTER [NATURAL_8]; a_pat: CE_POINTER [NATURAL_8]; a_dir___0: CE_POINTER [INTEGER_32]; a_dumpflags: INTEGER_32; a_wordflags: INTEGER_32; a_lnum: INTEGER_32)
		local
			l_keepcap: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tw: CE_POINTER [NATURAL_8]
			l_cword: CE_ARRAY [NATURAL_8]
			l_badword: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_flags___0: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp___5: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tw.make
			create l_cword.make (<<250>>)
			create l_badword.make (<<260>>)
			create l_hi___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_keepcap := 0
					l_flags___0 := a_wordflags
					if ((a_dumpflags).bit_and (8)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((2))
					end
					if ((a_dumpflags).bit_and (16)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((4))
					end
					if ((a_dumpflags).bit_and (1)) /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((l_flags___0).bit_and (198)) /= 0 then
							make_case_word (a_word, l_cword, l_flags___0)
							l_p___0 := l_cword
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_p___0 := a_word
						if ((a_dumpflags).bit_and (1)).to_boolean then
							if (((captype (a_word, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)))).bit_and (128)) = 0 then
								l_keepcap := 1
							elseif ((l_flags___0).bit_and (64)) /= 0 then
								l_keepcap := 1
							end
						end
				when 4 then
					l_tw := l_p___0
					if not (a_pat.is_void) then
						l_pos := -1 + 12 -- skip if block
					end
				when 5 then -- if:
						if not (((l_flags___0).bit_and (25)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not (l_keepcap.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L___0:
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_badword), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_badword), ce_string ("/")).do_nothing
						if l_keepcap.to_boolean then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_badword), ce_string ("=")).do_nothing
						end
						if ((l_flags___0).bit_and (16)).to_boolean then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_badword), ce_string ("!")).do_nothing
						elseif ((l_flags___0).bit_and (8)).to_boolean then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_badword), ce_string ("?")).do_nothing
						end
						if ((l_flags___0).bit_and (1)).to_boolean then
							l_i___0 := 0
							from
							until
								not (l_i___0 < 7)
							loop
								if ((l_flags___0).bit_and (((65_536).bit_shift_left (l_i___0)))).to_boolean then
									sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_badword) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_badword))).to_integer_32), ce_string ("%%d"), l_i___0 + 1]).do_nothing
								end
								l_i___0 := l_i___0 + 1
							end
						end
						l_p___0 := l_badword
				when 10 then -- if done
						if ((a_dumpflags).bit_and (2)).to_boolean then
							l_hi___1 := hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount")), l_tw)
							if not ((l_hi___1.item.hi_key).is_void) then
								if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("%%s%T%%d"), l_tw, ((create {CE_POINTER [PD_WORDCOUNT_S]}.make_cast ((l_hi___1.item.hi_key - (((dumwc.item.wc_word).distance ((create {CE_POINTER [NATURAL_8]}.make_cast (dumwc)))).to_natural_32).to_integer_32))).item.wc_count).to_integer_32]).do_nothing
									l_p___0 := globals_inst.IObuff
								end
							end
						end
						memline_inst.ml_append (a_lnum, l_p___0, 0, 0).do_nothing
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if ((a_dumpflags).bit_and (4)).to_boolean then
							l_tmp___5 := ((mbyte_inst.mb_strnicmp (l_p___0, a_pat, ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pat))).to_integer_32).to_natural_32)) = 0).to_integer
						else
							l_tmp___5 := ((strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (a_pat), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pat))))) = 0).to_integer
						end
						if l_tmp___5.to_boolean then
							if (edit_inst.ins_compl_add_infercase (l_p___0, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32, option_inst.p_ic.item, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_dir___0.item, 0)) = 1 then
								a_dir___0.item := 1
							end
						end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eval_soundfold (a_word: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_sound: CE_ARRAY [NATURAL_8]
			l_lpi: INTEGER_32
			js: JUMP_STATE
		do
			create l_lp.make
			create l_sound.make (<<250>>)

			if (globals_inst.curwin.item.w_onebuf_opt.wo_spell).to_boolean then
				if (((globals_inst.curwin.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
					l_lpi := 0
					from
					until
						not (not js.loop_done and then (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len))
					loop
						l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
						if (l_lp.item.lp_slang).item.sl_sal.ga_len > 0 then
							spell_soundfold (l_lp.item.lp_slang, a_word, 0, l_sound)
							Result := (misc2_inst.vim_strsave (l_sound))
							js.return
						end
						if not js.return_called then
							l_lpi := l_lpi + 1
						end
					end
				end
			end
			if not js.return_called then
				Result := (misc2_inst.vim_strsave (a_word))
			end
		end

	ex_mkspell (a_eap: CE_POINTER [PD_EXARG])
		local
			l_fcount: CE_ARRAY [INTEGER_32]
			l_fnames: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_arg: CE_POINTER [NATURAL_8]
			l_ascii: INTEGER_32
		do
			create l_fcount.make (<<1>>)
			create l_fnames.make (<<1>>)
			create l_arg.make

			l_arg := a_eap.item.arg
			l_ascii := 0
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("-ascii"), (6).to_natural_32)) = 0 then
				l_ascii := 1
				l_arg := charset_inst.skipwhite (l_arg + 6)
			end
			if (ex_cmds2_inst.get_arglist_exp (l_arg, l_fcount, l_fnames)) = 1 then
				mkspell (l_fcount.item, l_fnames.item, l_ascii, a_eap.item.forceit, 0)
				misc1_inst.FreeWild (l_fcount.item, l_fnames.item)
			end
		end

	ex_mkspell_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_mkspell)
		end

	ex_spell (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp: INTEGER_32
		do
			if (a_eap.item.forceit).to_boolean then
				l_tmp := 0
			else
				l_tmp := (a_eap.item.line2).to_integer_32
			end
			spell_add_word (a_eap.item.arg, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32, (a_eap.item.cmdidx = 396).to_integer, l_tmp, (a_eap.item.cmdidx = 395).to_integer)
		end

	ex_spell_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_spell)
		end

	ex_spelldump (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			if (no_spell_checking (globals_inst.curwin)).to_boolean then
				js.return
			end
			if not js.return_called then
				ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("new"))).do_nothing
				if globals_inst.curbuf.item.b_ml.ml_line_count = 1 then
					if ((memline_inst.ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
						if not (buffer_inst.buf_valid (globals_inst.curbuf)).to_boolean then
							js.return
						end
					else
						js.return
					end
				else
					js.return
				end
			end
			if not js.return_called then
				if (a_eap.item.forceit).to_boolean then
					l_tmp___2 := 2
				else
					l_tmp___2 := 0
				end
				spell_dump_compl (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_tmp___2)
				if globals_inst.curbuf.item.b_ml.ml_line_count > 1 then
					memline_inst.ml_delete (globals_inst.curbuf.item.b_ml.ml_line_count, 0).do_nothing
				end
				screen_inst.redraw_later (40)
			end
		end

	ex_spelldump_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_spelldump)
		end

	ex_spellinfo (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lpi: INTEGER_32
			l_lp: CE_POINTER [PD_LANGP_S]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_lp.make
			create l_p___0.make

			if (no_spell_checking (globals_inst.curwin)).to_boolean then
				js.return
			end
			if not js.return_called then
				message_inst.msg_start
				l_lpi := 0
				from
				until
					js.loop_done
				loop
					if l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len then
						if globals_inst.got_int.to_boolean then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file: ")))
						message_inst.msg_puts ((l_lp.item.lp_slang).item.sl_fname)
						message_inst.msg_putchar (('%N').code)
						l_p___0 := (l_lp.item.lp_slang).item.sl_info
						if not l_p___0.is_void then
							message_inst.msg_puts (l_p___0)
							message_inst.msg_putchar (('%N').code)
						end
						l_lpi := l_lpi + 1
					end
				end
				message_inst.msg_end.do_nothing
			end
		end

	ex_spellinfo_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_spellinfo)
		end

	ex_spellrepall (a_eap: CE_POINTER [PD_EXARG])
		local
			l_pos___3: PD_POS_T
			l_frompat: CE_POINTER [NATURAL_8]
			l_addlen: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_save_ws: INTEGER_32
			l_prev_lnum___1: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pos___3.make
			create l_frompat.make
			create l_line.make
			create l_p___0.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pos___3 := (globals_inst.curwin.item.w_cursor).twin
					l_save_ws := option_inst.p_ws.item
					l_prev_lnum___1 := (0).to_integer_32
					if repl_from.is_void then
						l_tmp := gettext (ce_string ("E752: No previous spell replacement"))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						js.return
					elseif repl_to.is_void then
						l_tmp := gettext (ce_string ("E752: No previous spell replacement"))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						js.return
					end
					if not js.return_called then
						l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (repl_to))
						l_addlen := (l_tmp___0 - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (repl_from)))).to_integer_32
						l_frompat := misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (repl_from))) + {NATURAL_32} 7)
						if l_frompat.is_void then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_frompat), ce_string ("\V\<%%s\>"), repl_from]).do_nothing
						option_inst.p_ws.item := 0
						globals_inst.sub_nsubs := 0
						globals_inst.sub_nlines := (0).to_integer_32
						globals_inst.curwin.item.w_cursor.lnum := (0).to_integer_32
				when 2 then -- loop condition:
						if not (not js.loop_done and then (not globals_inst.got_int.to_boolean)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						if (search_inst.do_search (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('/').code, l_frompat, 1, 1_024, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))) = 0 then
							js.break
						elseif (undo_inst.u_save_cursor) = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_line := memline_inst.ml_get_curline
						if not (l_addlen <= 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_line + globals_inst.curwin.item.w_cursor.col)), create {CE_POINTER [INTEGER_8]}.make_cast (repl_to), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (repl_to))))) = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_p___0 := misc2_inst.alloc (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))) + l_addlen.to_natural_32) + {NATURAL_32} 1)
						if l_p___0.is_void then
							js.break
						end
						if not js.loop_jumped then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_line), (globals_inst.curwin.item.w_cursor.col).to_natural_32).do_nothing
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + globals_inst.curwin.item.w_cursor.col)), create {CE_POINTER [INTEGER_8]}.make_cast (repl_to)).do_nothing
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (((l_line + globals_inst.curwin.item.w_cursor.col) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (repl_from))).to_integer_32))).do_nothing
							memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_p___0, 0).do_nothing
							misc1_inst.changed_bytes (globals_inst.curwin.item.w_cursor.lnum, globals_inst.curwin.item.w_cursor.col)
							if globals_inst.curwin.item.w_cursor.lnum /= l_prev_lnum___1 then
								globals_inst.sub_nlines := globals_inst.sub_nlines + 1
								l_prev_lnum___1 := globals_inst.curwin.item.w_cursor.lnum
							end
							globals_inst.sub_nsubs := globals_inst.sub_nsubs + 1
						end
				when 9 then -- if done | if done
						if not js.loop_jumped then
							globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (repl_to))).to_integer_32
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						option_inst.p_ws.item := l_save_ws
						globals_inst.curwin.item.w_cursor := l_pos___3.twin
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_frompat))
						if globals_inst.sub_nsubs = 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E753: Not found: %%s")))), repl_from).do_nothing
						else
							ex_cmds_inst.do_sub_msg (0).do_nothing
						end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_spellrepall_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_spellrepall)
		end

	expand_spelling (a_lnum: INTEGER_32; a_pat: CE_POINTER [NATURAL_8]; a_matchp: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
		do
			create l_ga.make (<<1>>)

			spell_suggest_list (l_ga, a_pat, 100, spell_expand_need_cap, 1)
			a_matchp.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.item.ga_data)
			Result := (l_ga.item.ga_len)
		end

	find_keepcap_word (a_slang: CE_POINTER [PD_SLANG_S]; a_fword: CE_POINTER [NATURAL_8]; a_kword: CE_POINTER [NATURAL_8])
		local
			l_uword: CE_ARRAY [NATURAL_8]
			l_depth___1: INTEGER_32
			l_tryidx: INTEGER_32
			l_arridx: CE_ARRAY [INTEGER_32]
			l_round: CE_ARRAY [INTEGER_32]
			l_fwordidx: CE_ARRAY [INTEGER_32]
			l_uwordidx: CE_ARRAY [INTEGER_32]
			l_kwordlen: CE_ARRAY [INTEGER_32]
			l_flen: INTEGER_32
			l_ulen: INTEGER_32
			l_l: INTEGER_32
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_lo: INTEGER_32
			l_hi___1: INTEGER_32
			l_m: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_uword.make (<<250>>)
			create l_arridx.make (<<250>>)
			create l_round.make (<<250>>)
			create l_fwordidx.make (<<250>>)
			create l_uwordidx.make (<<250>>)
			create l_kwordlen.make (<<250>>)
			create l_p___0.make
			create l_byts.make
			create l_idxs.make
			create l_tmp___4.make

			l_byts := a_slang.item.sl_kbyts
			l_idxs := a_slang.item.sl_kidxs
			if l_byts.is_void then
				a_kword.item := (('%/0/').code).to_natural_8
				js.return
			end
			if not js.return_called then
				allcap_copy (a_fword, l_uword)
				l_depth___1 := 0
				l_arridx[0] := 0
				l_round[0] := 0
				l_fwordidx[0] := 0
				l_uwordidx[0] := 0
				l_kwordlen[0] := 0
				from
				until
					not (not js.loop_done and then (l_depth___1 >= 0))
				loop
					if (a_fword[(l_fwordidx[l_depth___1])]).to_integer_32 = 0 then
						if (l_byts[(l_arridx[l_depth___1] + 1)]).to_integer_32 = 0 then
							a_kword[(l_kwordlen[l_depth___1])] := (('%/0/').code).to_natural_8
							js.return
						end
						if not js.return_called then
							l_depth___1 := l_depth___1 - 1
						end
					else
						l_round[l_depth___1] := (l_round[l_depth___1]) + 1
						if l_round[l_depth___1] > 2 then
							l_depth___1 := l_depth___1 - 1
						else
							if globals_inst.has_mbyte.to_boolean then
								if globals_inst.enc_utf8.to_boolean then
									l_flen := (mbyte_inst.utf_ptr2len (a_fword + l_fwordidx[l_depth___1]))
								else
									l_flen := (globals_inst.mb_ptr2len.integer_32_item ([a_fword + l_fwordidx[l_depth___1]]))
								end
								if globals_inst.enc_utf8.to_boolean then
									l_ulen := (mbyte_inst.utf_ptr2len (l_uword + l_uwordidx[l_depth___1]))
								else
									l_ulen := (globals_inst.mb_ptr2len.integer_32_item ([l_uword + l_uwordidx[l_depth___1]]))
								end
							else
								l_flen := 1
								l_ulen := l_flen
							end
							if l_round[l_depth___1] = 1 then
								l_p___0 := a_fword + l_fwordidx[l_depth___1]
								l_l := l_flen
							else
								l_p___0 := l_uword + l_uwordidx[l_depth___1]
								l_l := l_ulen
							end
							l_tryidx := l_arridx[l_depth___1]
							from
							until
								not (not js.loop_done and then (l_l > 0))
							loop
								l_tmp___3 := l_tryidx
								l_tryidx := l_tryidx + 1
								l_len := (l_byts[l_tmp___3]).to_integer_32
								l_tmp___4 := l_p___0
								l_p___0 := l_p___0 + 1
								l_c := (l_tmp___4.item).to_integer_32
								l_lo := l_tryidx
								l_hi___1 := (l_tryidx + l_len) - 1
								from
								until
									not (not js.loop_done and then (l_lo < l_hi___1))
								loop
									l_m := (l_lo + l_hi___1) // 2
									if (l_byts[l_m]).to_integer_32 > l_c then
										l_hi___1 := l_m - 1
									elseif (l_byts[l_m]).to_integer_32 < l_c then
										l_lo := l_m + 1
									else
										l_hi___1 := l_m
										l_lo := l_hi___1
										js.break
									end
								end
								if l_hi___1 < l_lo then
									js.break
								elseif (l_byts[l_lo]).to_integer_32 /= l_c then
									js.break
								end
								if not js.loop_jumped then
									l_tryidx := l_idxs[l_lo]
									l_l := l_l - 1
								end
							end
							if l_l = 0 then
								if l_round[l_depth___1] = 1 then
									strncpy (create {CE_POINTER [INTEGER_8]}.make_cast ((a_kword + l_kwordlen[l_depth___1])), create {CE_POINTER [INTEGER_8]}.make_cast ((a_fword + l_fwordidx[l_depth___1])), l_flen.to_natural_32).do_nothing
									l_kwordlen[l_depth___1 + 1] := l_kwordlen[l_depth___1] + l_flen
								else
									strncpy (create {CE_POINTER [INTEGER_8]}.make_cast ((a_kword + l_kwordlen[l_depth___1])), create {CE_POINTER [INTEGER_8]}.make_cast ((l_uword + l_uwordidx[l_depth___1])), l_ulen.to_natural_32).do_nothing
									l_kwordlen[l_depth___1 + 1] := l_kwordlen[l_depth___1] + l_ulen
								end
								l_fwordidx[l_depth___1 + 1] := l_fwordidx[l_depth___1] + l_flen
								l_uwordidx[l_depth___1 + 1] := l_uwordidx[l_depth___1] + l_ulen
								l_depth___1 := l_depth___1 + 1
								l_arridx[l_depth___1] := l_tryidx
								l_round[l_depth___1] := 0
							end
						end
					end
				end
			end
			if not js.return_called then
				a_kword.item := (('%/0/').code).to_natural_8
			end
		end

	find_prefix (a_mip: CE_POINTER [PD_MATCHINF_S]; a_mode: INTEGER_32)
		local
			l_arridx: INTEGER_32
			l_len: INTEGER_32
			l_wlen: INTEGER_32
			l_flen: INTEGER_32
			l_c: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_lo: INTEGER_32
			l_hi___1: INTEGER_32
			l_m: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_ptr.make
			create l_slang.make
			create l_byts.make
			create l_idxs.make

			l_arridx := 0
			l_wlen := 0
			l_slang := (a_mip.item.mi_lp).item.lp_slang
			l_byts := l_slang.item.sl_pbyts
			if l_byts.is_void then
				js.return
			end
			if not js.return_called then
				l_ptr := a_mip.item.mi_fword
				l_flen := a_mip.item.mi_fwordlen
				if a_mode = 3 then
					l_ptr := l_ptr + (a_mip.item.mi_compoff)
					l_flen := l_flen - (a_mip.item.mi_compoff)
				end
				l_idxs := l_slang.item.sl_pidxs
				from
				until
					js.loop_done
				loop
					if l_flen = 0 then
						if ((a_mip.item.mi_fend).item).to_integer_32 /= 0 then
							l_flen := fold_more (a_mip)
						end
					end
					l_tmp := l_arridx
					l_arridx := l_arridx + 1
					l_len := (l_byts[l_tmp]).to_integer_32
					if (l_byts[l_arridx]).to_integer_32 = 0 then
						a_mip.item.mi_prefarridx := l_arridx
						a_mip.item.mi_prefcnt := l_len
						from
						until
							js.loop_done
						loop
							if l_len > 0 then
								if (l_byts[l_arridx]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_arridx := l_arridx + 1
								l_len := l_len - 1
							end
						end
						a_mip.item.mi_prefcnt := a_mip.item.mi_prefcnt - l_len
						a_mip.item.mi_prefixlen := l_wlen
						if a_mode = 3 then
							a_mip.item.mi_prefixlen := a_mip.item.mi_prefixlen + (a_mip.item.mi_compoff)
						end
						if globals_inst.has_mbyte.to_boolean then
							a_mip.item.mi_cprefixlen := nofold_len (a_mip.item.mi_fword, a_mip.item.mi_prefixlen, a_mip.item.mi_word)
						else
							a_mip.item.mi_cprefixlen := a_mip.item.mi_prefixlen
						end
						find_word (a_mip, 2)
						if l_len = 0 then
							js.break
						end
					end
					if not js.loop_jumped and then ((l_ptr[l_wlen]).to_integer_32 = 0) then
						js.break
					end
					if not js.loop_jumped then
						l_c := (l_ptr[l_wlen]).to_integer_32
						l_lo := l_arridx
						l_hi___1 := (l_arridx + l_len) - 1
						from
						until
							not (not js.loop_done and then (l_lo < l_hi___1))
						loop
							l_m := (l_lo + l_hi___1) // 2
							if (l_byts[l_m]).to_integer_32 > l_c then
								l_hi___1 := l_m - 1
							elseif (l_byts[l_m]).to_integer_32 < l_c then
								l_lo := l_m + 1
							else
								l_hi___1 := l_m
								l_lo := l_hi___1
								js.break
							end
						end
						if l_hi___1 < l_lo then
							js.break
						elseif (l_byts[l_lo]).to_integer_32 /= l_c then
							js.break
						end
					end
					if not js.loop_jumped then
						l_arridx := l_idxs[l_lo]
						l_wlen := l_wlen + 1
						l_flen := l_flen - 1
					end
				end
			end
		end

	find_region (a_rp: CE_POINTER [NATURAL_8]; a_region: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				js.loop_done
			loop
				if (a_rp[l_i___0]).to_integer_32 = 0 then
					Result := 255
					js.return
				end
				if not js.return_called then
					if (a_rp[l_i___0]).to_integer_32 = (a_region[0]).to_integer_32 then
						if (a_rp[(l_i___0 + 1)]).to_integer_32 = (a_region[1]).to_integer_32 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + (2)
					end
				end
			end
			if not js.return_called then
				Result := (l_i___0 // 2)
			end
		end

	find_word (a_mip: CE_POINTER [PD_MATCHINF_S]; a_mode: INTEGER_32)
		local
			l_arridx: INTEGER_32
			l_endlen: CE_ARRAY [INTEGER_32]
			l_endidx: CE_ARRAY [INTEGER_32]
			l_endidxcnt: INTEGER_32
			l_len: INTEGER_32
			l_wlen: INTEGER_32
			l_flen: INTEGER_32
			l_c: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_lo: INTEGER_32
			l_hi___1: INTEGER_32
			l_m: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_res: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_flags___0: NATURAL_32
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_word_ends: INTEGER_32
			l_prefix_found: INTEGER_32
			l_nobreak_result: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_capflags: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_fword: CE_ARRAY [NATURAL_8]
			l_save_result: INTEGER_32
			l_save_end: CE_POINTER [NATURAL_8]
			l_save_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___31: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_endlen.make (<<250>>)
			create l_endidx.make (<<250>>)
			create l_ptr.make
			create l_s.make
			create l_p___0.make
			create l_slang.make
			create l_byts.make
			create l_idxs.make
			create l_tmp___12.make
			create l_fword.make (<<250>>)
			create l_save_end.make
			create l_save_lp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arridx := 0
					l_endidxcnt := 0
					l_wlen := 0
					l_res := 3
					l_slang := (a_mip.item.mi_lp).item.lp_slang
					if a_mode /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_mode /= 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_ptr := a_mip.item.mi_word
						l_flen := 9_999
						l_byts := l_slang.item.sl_kbyts
						l_idxs := l_slang.item.sl_kidxs
						if a_mode = 4 then
							l_wlen := l_wlen + (a_mip.item.mi_compoff)
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_ptr := a_mip.item.mi_fword
						l_flen := a_mip.item.mi_fwordlen
						l_byts := l_slang.item.sl_fbyts
						l_idxs := l_slang.item.sl_fidxs
						if a_mode = 2 then
							l_wlen := a_mip.item.mi_prefixlen
							l_flen := l_flen - (a_mip.item.mi_prefixlen)
						elseif a_mode = 3 then
							l_wlen := a_mip.item.mi_compoff
							l_flen := l_flen - (a_mip.item.mi_compoff)
						end
				when 7 then -- if done
						if l_byts.is_void then
							js.return
						end
						if not js.return_called then
							from
							until
								js.loop_done
							loop
								if l_flen <= 0 then
									if ((a_mip.item.mi_fend).item).to_integer_32 /= 0 then
										l_flen := fold_more (a_mip)
									end
								end
								l_tmp := l_arridx
								l_arridx := l_arridx + 1
								l_len := (l_byts[l_tmp]).to_integer_32
								if (l_byts[l_arridx]).to_integer_32 = 0 then
									if l_endidxcnt = 250 then
										message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_format)))).do_nothing
										js.return
									end
									if not js.return_called then
										l_endlen[l_endidxcnt] := l_wlen
										l_tmp___1 := l_endidxcnt
										l_endidxcnt := l_endidxcnt + 1
										l_tmp___2 := l_arridx
										l_arridx := l_arridx + 1
										l_endidx[l_tmp___1] := l_tmp___2
										l_len := l_len - 1
										from
										until
											js.loop_done
										loop
											if l_len > 0 then
												if (l_byts[l_arridx]).to_integer_32 /= 0 then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_arridx := l_arridx + 1
												l_len := l_len - 1
											end
										end
										if l_len = 0 then
											js.break
										end
									end
								end
								if not js.loop_jumped and then ((l_ptr[l_wlen]).to_integer_32 = 0) then
									js.break
								end
								if not js.loop_jumped then
									l_c := (l_ptr[l_wlen]).to_integer_32
									if l_c = 9 then
										l_c := (' ').code
									end
									l_lo := l_arridx
									l_hi___1 := (l_arridx + l_len) - 1
									from
									until
										not (not js.loop_done and then (l_lo < l_hi___1))
									loop
										l_m := (l_lo + l_hi___1) // 2
										if (l_byts[l_m]).to_integer_32 > l_c then
											l_hi___1 := l_m - 1
										elseif (l_byts[l_m]).to_integer_32 < l_c then
											l_lo := l_m + 1
										else
											l_hi___1 := l_m
											l_lo := l_hi___1
											js.break
										end
									end
									if l_hi___1 < l_lo then
										js.break
									elseif (l_byts[l_lo]).to_integer_32 /= l_c then
										js.break
									end
								end
								if not js.loop_jumped then
									l_arridx := l_idxs[l_lo]
									l_wlen := l_wlen + 1
									l_flen := l_flen - 1
									if l_c = 32 then
										from
										until
											js.loop_done
										loop
											if l_flen <= 0 then
												if ((a_mip.item.mi_fend).item).to_integer_32 /= 0 then
													l_flen := fold_more (a_mip)
												end
											end
											if (l_ptr[l_wlen]).to_integer_32 /= 32 then
												if (l_ptr[l_wlen]).to_integer_32 /= 9 then
													js.break
												end
											end
											if not js.loop_jumped then
												l_wlen := l_wlen + 1
												l_flen := l_flen - 1
											end
										end
									end
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 33 -- skip if block
						end
				when 8 then -- if: | loop condition:
							if not (not js.loop_done and then (l_endidxcnt > 0)) then
								l_pos := -1 + 33 -- skip loop
							end
				when 9 then -- loop body:
							l_endidxcnt := l_endidxcnt - 1
							l_arridx := l_endidx[l_endidxcnt]
							l_wlen := l_endlen[l_endidxcnt]
							if (globals_inst.mb_head_off.integer_32_item ([l_ptr, l_ptr + l_wlen])) > 0 then
								js.continue
							end
							if not js.loop_jumped then
								if (spell_iswordp (l_ptr + l_wlen, a_mip.item.mi_win)).to_boolean then
									if (l_slang.item.sl_compprog).is_void then
										if not (l_slang.item.sl_nobreak).to_boolean then
											js.continue
										end
									end
									if not js.loop_jumped then
										l_word_ends := 0
									end
								else
									l_word_ends := 1
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 32 -- skip if block
							end
				when 10 then -- if:
							l_prefix_found := 0
							if a_mode /= 1 then
								if globals_inst.has_mbyte.to_boolean then
									l_p___0 := a_mip.item.mi_word
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), l_wlen.to_natural_32)) /= 0 then
										l_s := l_ptr
										from
										until
											not ((l_s.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_wlen).c_pointer.to_integer_32).to_natural_32)
										loop
											if globals_inst.has_mbyte.to_boolean then
												l_tmp___8 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
											else
												l_tmp___8 := 1
											end
											l_p___0 := l_p___0 + l_tmp___8
											if globals_inst.has_mbyte.to_boolean then
												l_tmp___6 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
											else
												l_tmp___6 := 1
											end
											l_s := l_s + l_tmp___6
										end
										l_wlen := l_p___0.distance ((a_mip.item.mi_word))
									end
								end
							end
							l_res := 3
							l_len := (l_byts[(l_arridx - 1)]).to_integer_32
				when 11 then -- loop condition:
							if js.loop_done then
								l_pos := -1 + 31 -- skip loop
							end
				when 12 then -- loop body:
							if l_len > 0 then
								if (l_byts[l_arridx]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_flags___0 := (l_idxs[l_arridx]).to_natural_32
								if a_mode = 0 then
									if not (a_mip.item.mi_cend).is_equal (a_mip.item.mi_word + l_wlen) then
										a_mip.item.mi_cend := a_mip.item.mi_word + l_wlen
										a_mip.item.mi_capflags := captype (a_mip.item.mi_word, a_mip.item.mi_cend)
									end
									if a_mip.item.mi_capflags = 128 then
										js.continue
									elseif not (spell_valid_case (a_mip.item.mi_capflags, l_flags___0.to_integer_32)).to_boolean then
										js.continue
									end
								elseif a_mode = 2 then
									if not l_prefix_found.to_boolean then
										l_c := valid_word_prefix (a_mip.item.mi_prefcnt, a_mip.item.mi_prefarridx, l_flags___0.to_integer_32, a_mip.item.mi_word + a_mip.item.mi_cprefixlen, l_slang, 0)
										if l_c = 0 then
											js.continue
										end
										if not js.loop_jumped then
											if ((l_c).bit_and (((1).bit_shift_left (24)))).to_boolean then
												l_flags___0 := (l_flags___0).bit_or (({NATURAL_32} 8))
											end
											l_prefix_found := 1
										end
									end
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 30 -- skip if block
							end
				when 13 then -- if:
							if not ((l_slang.item.sl_nobreak).to_boolean) then
								l_pos := -1 + 20 -- skip if block
							end
				when 14 then -- if:
							if a_mode /= 3 then
								l_pos := -1 + 17 -- skip if block
							end
				when 15 then -- if:
							l_pos := -1 + 18 -- goto _L___0
				when 16 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 17 then -- else:
							if a_mode /= 4 then
								l_pos := -1 + 19 -- skip if block
							end
				when 18 then -- if: | _L___0:
							if ((l_flags___0).bit_and ({NATURAL_32} 16)) = {NATURAL_32} 0 then
								a_mip.item.mi_result := 0
								js.break
							end
				when 19 then -- if done | if done | if block done, skip else block:
							l_pos := -1 + 30
				when 20 then -- else:
							if a_mode /= 3 then
								l_pos := -1 + 23 -- skip if block
							end
				when 21 then -- if:
							l_pos := -1 + 27 -- goto _L___1
				when 22 then -- if block done, skip else block:
							l_pos := -1 + 30
				when 23 then -- else:
							if a_mode /= 4 then
								l_pos := -1 + 26 -- skip if block
							end
				when 24 then -- if:
							l_pos := -1 + 27 -- goto _L___1
				when 25 then -- if block done, skip else block:
							l_pos := -1 + 30
				when 26 then -- else:
							if l_word_ends.to_boolean then
								l_pos := -1 + 29 -- skip if block
							end
				when 27 then -- if: | _L___1:
							if (l_flags___0).bit_shift_right (24) = {NATURAL_32} 0 then
								js.continue
							elseif l_wlen - a_mip.item.mi_compoff < l_slang.item.sl_compminlen then
								js.continue
							end
							if not js.loop_jumped and then (globals_inst.has_mbyte.to_boolean) then
								if l_slang.item.sl_compminlen > 0 then
									if (mbyte_inst.mb_charlen_len (a_mip.item.mi_word + a_mip.item.mi_compoff, l_wlen - a_mip.item.mi_compoff)) < l_slang.item.sl_compminlen then
										js.continue
									end
								end
							end
							if not js.loop_jumped and then (not l_word_ends.to_boolean) then
								if (a_mip.item.mi_complen + a_mip.item.mi_compextra) + 2 > l_slang.item.sl_compmax then
									if l_slang.item.sl_compsylmax = 250 then
										js.continue
									end
								end
							end
							if not js.loop_jumped and then (a_mip.item.mi_complen > 0) then
								if ((l_flags___0).bit_and ({NATURAL_32} 4_096)).to_boolean then
									js.continue
								end
							end
							if not js.loop_jumped and then (not l_word_ends.to_boolean) then
								if ((l_flags___0).bit_and ({NATURAL_32} 8_192)).to_boolean then
									js.continue
								end
							end
							if not js.loop_jumped then
								if a_mip.item.mi_complen = 0 then
									l_tmp___12 := l_slang.item.sl_compstartflags
								else
									l_tmp___12 := l_slang.item.sl_compallflags
								end
								if not (byte_in_str (l_tmp___12, ((l_flags___0).bit_shift_right (24)).to_integer_32)).to_boolean then
									js.continue
								end
							end
							if not js.loop_jumped then
								if (match_checkcompoundpattern (l_ptr, l_wlen, create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_comppat")))).to_boolean then
									js.continue
								end
							end
							if not js.loop_jumped and then (a_mode = 3) then
								if globals_inst.has_mbyte.to_boolean then
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), create {CE_POINTER [INTEGER_8]}.make_cast (a_mip.item.mi_word), (a_mip.item.mi_compoff).to_natural_32)) /= 0 then
										l_p___0 := a_mip.item.mi_word
										l_s := l_ptr
										from
										until
											not ((l_s.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + a_mip.item.mi_compoff).c_pointer.to_integer_32).to_natural_32)
										loop
											if globals_inst.has_mbyte.to_boolean then
												l_tmp___18 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
											else
												l_tmp___18 := 1
											end
											l_p___0 := l_p___0 + l_tmp___18
											if globals_inst.has_mbyte.to_boolean then
												l_tmp___16 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
											else
												l_tmp___16 := 1
											end
											l_s := l_s + l_tmp___16
										end
									else
										l_p___0 := a_mip.item.mi_word + a_mip.item.mi_compoff
									end
								else
									l_p___0 := a_mip.item.mi_word + a_mip.item.mi_compoff
								end
								l_capflags := captype (l_p___0, a_mip.item.mi_word + l_wlen)
								if l_capflags = 128 then
									js.continue
								elseif l_capflags = 4 then
									if ((l_flags___0).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
										js.continue
									end
								end
								if not js.loop_jumped and then (l_capflags /= 4) then
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___21 := (globals_inst.mb_head_off.integer_32_item ([a_mip.item.mi_word, l_p___0 - 1])) + 1
									else
										l_tmp___21 := 1
									end
									l_p___0 := l_p___0 - l_tmp___21
									if (spell_iswordp_nmw (l_p___0)).to_boolean then
										l_tmp___24 := (l_capflags = 2).to_integer
									else
										if ((l_flags___0).bit_and ({NATURAL_32} 2)) /= {NATURAL_32} 0 then
											if l_capflags /= 2 then
												l_tmp___23 := 1
											else
												l_tmp___23 := 0
											end
										else
											l_tmp___23 := 0
										end
										l_tmp___24 := l_tmp___23
									end
									if l_tmp___24.to_boolean then
										js.continue
									end
								end
							end
							if not js.loop_jumped then
								a_mip.item.mi_compflags[a_mip.item.mi_complen] := ((l_flags___0).bit_shift_right (24)).to_natural_8
								a_mip.item.mi_compflags[a_mip.item.mi_complen + 1] := (('%/0/').code).to_natural_8
								if l_word_ends.to_boolean then
									if l_slang.item.sl_compsylmax < 250 then
										if l_ptr.is_equal (a_mip.item.mi_word) then
											spell_casefold (l_ptr, l_wlen, l_fword, 250).do_nothing
										else
											misc2_inst.vim_strncpy (l_fword, l_ptr, (l_endlen[l_endidxcnt]).to_natural_32)
										end
									end
									if not (can_compound (l_slang, l_fword, a_mip.item.mi_compflags)).to_boolean then
										js.continue
									end
								elseif not (l_slang.item.sl_comprules).is_void then
									if not (match_compoundrule (l_slang, a_mip.item.mi_compflags)).to_boolean then
										js.continue
									end
								end
							end
				when 28 then -- if block done, skip else block:
							l_pos := -1 + 30
				when 29 then -- else:
							if ((l_flags___0).bit_and ({NATURAL_32} 512)).to_boolean then
								js.continue
							end
				when 30 then -- if done | if done | if done | if done
							if not js.loop_jumped then
								l_nobreak_result := 0
								if not l_word_ends.to_boolean then
									l_save_result := a_mip.item.mi_result
									l_save_end := a_mip.item.mi_end
									l_save_lp := a_mip.item.mi_lp
									if (l_slang.item.sl_nobreak).to_boolean then
										a_mip.item.mi_result := 3
									end
									a_mip.item.mi_compoff := l_endlen[l_endidxcnt]
									if globals_inst.has_mbyte.to_boolean then
										if a_mode = 1 then
											l_p___0 := a_mip.item.mi_fword
											if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), l_wlen.to_natural_32)) /= 0 then
												l_s := l_ptr
												from
												until
													not ((l_s.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_wlen).c_pointer.to_integer_32).to_natural_32)
												loop
													if globals_inst.has_mbyte.to_boolean then
														l_tmp___31 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
													else
														l_tmp___31 := 1
													end
													l_p___0 := l_p___0 + l_tmp___31
													if globals_inst.has_mbyte.to_boolean then
														l_tmp___29 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
													else
														l_tmp___29 := 1
													end
													l_s := l_s + l_tmp___29
												end
												a_mip.item.mi_compoff := l_p___0.distance ((a_mip.item.mi_fword))
											end
										end
									end
									l_c := a_mip.item.mi_compoff
									a_mip.item.mi_complen := (a_mip.item.mi_complen) + 1
									if ((l_flags___0).bit_and ({NATURAL_32} 2_048)).to_boolean then
										a_mip.item.mi_compextra := (a_mip.item.mi_compextra) + 1
									end
									l_lpi := 0
									from
									until
										not (not js.loop_done and then (l_lpi < ((a_mip.item.mi_win).item.w_s).item.b_langp.ga_len))
									loop
										if (l_slang.item.sl_nobreak).to_boolean then
											a_mip.item.mi_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast (((a_mip.item.mi_win).item.w_s).item.b_langp.ga_data) + l_lpi
											if (((a_mip.item.mi_lp).item.lp_slang).item.sl_fidxs).is_void then
												js.continue
											elseif not (((a_mip.item.mi_lp).item.lp_slang).item.sl_nobreak).to_boolean then
												js.continue
											end
										end
										if not js.loop_jumped then
											find_word (a_mip, 3)
											if not (l_slang.item.sl_nobreak).to_boolean then
												a_mip.item.mi_compoff := l_wlen
												find_word (a_mip, 4)
											elseif a_mip.item.mi_result = 3 then
												a_mip.item.mi_compoff := l_wlen
												find_word (a_mip, 4)
											end
											if not (l_slang.item.sl_nobreak).to_boolean then
												js.break
											end
										end
										if js.loop_increment then
											l_lpi := l_lpi + 1
										end
									end
									a_mip.item.mi_complen := (a_mip.item.mi_complen) - 1
									if ((l_flags___0).bit_and ({NATURAL_32} 2_048)).to_boolean then
										a_mip.item.mi_compextra := (a_mip.item.mi_compextra) - 1
									end
									a_mip.item.mi_lp := l_save_lp
									if (l_slang.item.sl_nobreak).to_boolean then
										l_nobreak_result := a_mip.item.mi_result
										a_mip.item.mi_result := l_save_result
										a_mip.item.mi_end := l_save_end
									else
										if a_mip.item.mi_result = 0 then
											js.break
										end
										if not js.loop_jumped then
											js.continue
										end
									end
								end
							end
							if not js.loop_jumped then
								if ((l_flags___0).bit_and ({NATURAL_32} 16)).to_boolean then
									l_res := -1
								elseif ((l_flags___0).bit_and ({NATURAL_32} 1)).to_boolean then
									if ((((a_mip.item.mi_lp).item.lp_region).to_natural_32).bit_and (((l_flags___0).bit_shift_right (16)))) /= {NATURAL_32} 0 then
										l_res := 0
									else
										l_res := 2
									end
								elseif ((l_flags___0).bit_and ({NATURAL_32} 8)).to_boolean then
									l_res := 1
								else
									l_res := 0
								end
								if l_nobreak_result = 3 then
									if a_mip.item.mi_result2 > l_res then
										a_mip.item.mi_result2 := l_res
										a_mip.item.mi_end2 := a_mip.item.mi_word + l_wlen
									elseif a_mip.item.mi_result2 = l_res then
										if ((a_mip.item.mi_end2).c_pointer.to_integer_32).to_natural_32 < ((a_mip.item.mi_word + l_wlen).c_pointer.to_integer_32).to_natural_32 then
											a_mip.item.mi_end2 := a_mip.item.mi_word + l_wlen
										end
									end
								elseif a_mip.item.mi_result > l_res then
									a_mip.item.mi_result := l_res
									a_mip.item.mi_end := a_mip.item.mi_word + l_wlen
								elseif a_mip.item.mi_result = l_res then
									if ((a_mip.item.mi_end).c_pointer.to_integer_32).to_natural_32 < ((a_mip.item.mi_word + l_wlen).c_pointer.to_integer_32).to_natural_32 then
										a_mip.item.mi_end := a_mip.item.mi_word + l_wlen
									end
								end
								if a_mip.item.mi_result = 0 then
									js.break
								end
							end
							if js.loop_increment then
								l_len := l_len - 1
								l_arridx := l_arridx + 1
							end
							l_pos := -1 + 11 -- back to loop condition
				when 31 then -- loop done
							if a_mip.item.mi_result = 0 then
								js.break
							end
				when 32 then -- if done
							l_pos := -1 + 8 -- back to loop condition
				when 33 then -- loop done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	flag_in_afflist (a_flagtype: INTEGER_32; a_afflist: CE_POINTER [NATURAL_8]; a_flag: NATURAL_32): INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_n: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_flagtype -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 13
					else l_pos := -1 + 14
					end
				when 1 then -- switch 1, case 0
					Result := (not (misc2_inst.vim_strchr (a_afflist, a_flag.to_integer_32)).is_void).to_integer
					js.return
				when 2 then -- switch 1, case 2 | switch 1, case 1
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 3 then -- if:
						l_p___0.item := a_afflist
				when 4 then -- loop condition:
						if not (not js.loop_done and then ((l_p___0.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 5 then -- loop body:
						l_n := (mbyte_inst.mb_ptr2char_adv (l_p___0)).to_natural_32
						if a_flagtype /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 8 then -- else:
						if not (l_n >= {NATURAL_32} 65) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if not (l_n <= {NATURAL_32} 90) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (l_p___0.item.item).to_integer_32 /= 0 then
							l_n := (mbyte_inst.mb_ptr2char_adv (l_p___0)).to_natural_32 + ((l_n).bit_shift_left (16))
						end
				when 11 then -- if done | if done
						if l_n = a_flag then
							Result := 1
							js.return
						end
						l_pos := -1 + 4 -- back to loop condition
				when 12 then -- loop done | if done
						l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, case 3
						l_p___0.item := a_afflist
						from
						until
							not (not js.loop_done and then ((l_p___0.item.item).to_integer_32 /= 0))
						loop
							l_n := (charset_inst.getdigits (l_p___0)).to_natural_32
							if l_n = a_flag then
								Result := 1
								js.return
							end
							if not js.return_called and then ((l_p___0.item.item).to_integer_32 /= 0) then
								l_p___0.item := l_p___0.item + 1
							end
						end
						l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done:
						if not js.return_called then
							Result := 0
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	fold_more (a_mip: CE_POINTER [PD_MATCHINF_S]): INTEGER_32
		local
			l_flen: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0 := a_mip.item.mi_fend
			from
			until
				js.loop_done
			loop
				if globals_inst.has_mbyte.to_boolean then
					l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([a_mip.item.mi_fend]))
				else
					l_tmp___0 := 1
				end
				a_mip.item.mi_fend := a_mip.item.mi_fend + l_tmp___0
				if ((a_mip.item.mi_fend).item).to_integer_32 /= 0 then
					if not (spell_iswordp (a_mip.item.mi_fend, a_mip.item.mi_win)).to_boolean then
						js.break
					end
				else
					js.break
				end
			end
			if ((a_mip.item.mi_fend).item).to_integer_32 /= 0 then
				if globals_inst.has_mbyte.to_boolean then
					l_tmp___3 := (globals_inst.mb_ptr2len.integer_32_item ([a_mip.item.mi_fend]))
				else
					l_tmp___3 := 1
				end
				a_mip.item.mi_fend := a_mip.item.mi_fend + l_tmp___3
			end
			spell_casefold (l_p___0, (a_mip.item.mi_fend).distance (l_p___0), a_mip.item.mi_fword + a_mip.item.mi_fwordlen, 250 - a_mip.item.mi_fwordlen).do_nothing
			l_flen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_mip.item.mi_fword + a_mip.item.mi_fwordlen)))).to_integer_32
			a_mip.item.mi_fwordlen := a_mip.item.mi_fwordlen + l_flen
			Result := l_flen
		end

	free_blocks (a_bl: CE_POINTER [PD_SBLOCK_S])
		local
			l_bl: CE_POINTER [PD_SBLOCK_S]
			l_next: CE_POINTER [PD_SBLOCK_S]
		do
			create l_bl.make
			create l_next.make

			l_bl := a_bl
			from
			until
				l_bl.is_void
			loop
				l_next := l_bl.item.sb_next
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_bl))
				l_bl := l_next
			end
		end

	free_wordnode (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_n: CE_POINTER [PD_WORDNODE_S])
		do
			a_n.item.wn_child := a_spin.item.si_first_free
			a_spin.item.si_first_free := a_n
			a_spin.item.si_free_count := (a_spin.item.si_free_count) + 1
		end

	get_affitem (a_flagtype: INTEGER_32; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): NATURAL_32
		local
			l_res: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_flagtype /= 3 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((a_pp.item).item).to_integer_32 >= 48 then
							if not (((a_pp.item).item).to_integer_32 <= 57) then
								a_pp.item := (a_pp.item) + 1
								Result := {NATURAL_32} 0
								js.return
							end
						else
							a_pp.item := (a_pp.item) + 1
							Result := {NATURAL_32} 0
							js.return
						end
						if not js.return_called then
							l_res := (charset_inst.getdigits (a_pp)).to_integer_32
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						l_res := mbyte_inst.mb_ptr2char_adv (a_pp)
						if a_flagtype /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_flagtype /= 2 then
							l_pos := -1 + 10 -- skip if block
						end
				when 7 then -- if:
						if not (l_res >= 65) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not (l_res <= 90) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if ((a_pp.item).item).to_integer_32 = 0 then
							Result := {NATURAL_32} 0
							js.return
						end
						if not js.return_called then
							l_res := (mbyte_inst.mb_ptr2char_adv (a_pp)) + ((l_res).bit_shift_left (16))
						end
				when 10 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := l_res.to_natural_32
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_affix_flags (a_affile: CE_POINTER [PD_AFFFILE_S]; a_afflist: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_flags___0: INTEGER_32
		do
			l_flags___0 := 0
			if a_affile.item.af_keepcase /= {NATURAL_32} 0 then
				if (flag_in_afflist (a_affile.item.af_flagtype, a_afflist, a_affile.item.af_keepcase)).to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((192))
				end
			end
			if a_affile.item.af_rare /= {NATURAL_32} 0 then
				if (flag_in_afflist (a_affile.item.af_flagtype, a_afflist, a_affile.item.af_rare)).to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((8))
				end
			end
			if a_affile.item.af_bad /= {NATURAL_32} 0 then
				if (flag_in_afflist (a_affile.item.af_flagtype, a_afflist, a_affile.item.af_bad)).to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((16))
				end
			end
			if a_affile.item.af_needcomp /= {NATURAL_32} 0 then
				if (flag_in_afflist (a_affile.item.af_flagtype, a_afflist, a_affile.item.af_needcomp)).to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((512))
				end
			end
			if a_affile.item.af_comproot /= {NATURAL_32} 0 then
				if (flag_in_afflist (a_affile.item.af_flagtype, a_afflist, a_affile.item.af_comproot)).to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((2_048))
				end
			end
			if a_affile.item.af_nosuggest /= {NATURAL_32} 0 then
				if (flag_in_afflist (a_affile.item.af_flagtype, a_afflist, a_affile.item.af_nosuggest)).to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((1_024))
				end
			end
			Result := l_flags___0
		end

	get_compflags (a_affile: CE_POINTER [PD_AFFFILE_S]; a_afflist: CE_POINTER [NATURAL_8]; a_store_afflist: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prevp: CE_POINTER [NATURAL_8]
			l_cnt: INTEGER_32
			l_key: CE_ARRAY [NATURAL_8]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp: INTEGER_32
		do
			create l_p___0.make (<<1>>)
			create l_prevp.make
			create l_key.make (<<17>>)
			create l_hi___1.make

			l_cnt := 0
			l_p___0.item := a_afflist
			from
			until
				(l_p___0.item.item).to_integer_32 = 0
			loop
				l_prevp := l_p___0.item
				if (get_affitem (a_affile.item.af_flagtype, l_p___0)) /= {NATURAL_32} 0 then
					misc2_inst.vim_strncpy (l_key, l_prevp, ((l_p___0.item).distance (l_prevp)).to_natural_32)
					l_hi___1 := hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp")), l_key)
					if not ((l_hi___1.item.hi_key).is_void) then
						if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_tmp := l_cnt
							l_cnt := l_cnt + 1
							a_store_afflist[l_tmp] := ((create {CE_POINTER [PD_COMPITEM_S]}.make_cast (l_hi___1.item.hi_key)).item.ci_newID).to_natural_8
						end
					end
				end
				if a_affile.item.af_flagtype = 3 then
					if (l_p___0.item.item).to_integer_32 = 44 then
						l_p___0.item := l_p___0.item + 1
					end
				end
			end
			a_store_afflist[l_cnt] := (('%/0/').code).to_natural_8
		end

	get_pfxlist (a_affile: CE_POINTER [PD_AFFFILE_S]; a_afflist: CE_POINTER [NATURAL_8]; a_store_afflist: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prevp: CE_POINTER [NATURAL_8]
			l_cnt: INTEGER_32
			l_id: INTEGER_32
			l_key: CE_ARRAY [NATURAL_8]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp: INTEGER_32
		do
			create l_p___0.make (<<1>>)
			create l_prevp.make
			create l_key.make (<<17>>)
			create l_hi___1.make

			l_cnt := 0
			l_p___0.item := a_afflist
			from
			until
				(l_p___0.item.item).to_integer_32 = 0
			loop
				l_prevp := l_p___0.item
				if (get_affitem (a_affile.item.af_flagtype, l_p___0)) /= {NATURAL_32} 0 then
					misc2_inst.vim_strncpy (l_key, l_prevp, ((l_p___0.item).distance (l_prevp)).to_natural_32)
					l_hi___1 := hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref")), l_key)
					if not ((l_hi___1.item.hi_key).is_void) then
						if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_id := (create {CE_POINTER [PD_AFFHEADER_S]}.make_cast (l_hi___1.item.hi_key)).item.ah_newID
							if l_id /= 0 then
								l_tmp := l_cnt
								l_cnt := l_cnt + 1
								a_store_afflist[l_tmp] := l_id.to_natural_8
							end
						end
					end
				end
				if a_affile.item.af_flagtype = 3 then
					if (l_p___0.item.item).to_integer_32 = 44 then
						l_p___0.item := l_p___0.item + 1
					end
				end
			end
			a_store_afflist[l_cnt] := (('%/0/').code).to_natural_8
			Result := l_cnt
		end

	get_wordnode (a_spin: CE_POINTER [PD_SPELLINFO_S]): CE_POINTER [PD_WORDNODE_S]
		local
			l_n: CE_POINTER [PD_WORDNODE_S]
		do
			create l_n.make

			if (a_spin.item.si_first_free).is_void then
				l_n := create {CE_POINTER [PD_WORDNODE_S]}.make_cast ((getroom (a_spin, (create {PD_WORDNODE_S}.make).structure_size.to_natural_32, 1)))
			else
				l_n := a_spin.item.si_first_free
				a_spin.item.si_first_free := l_n.item.wn_child
				memset (create {CE_POINTER [ANY]}.make_cast (l_n), 0, (create {PD_WORDNODE_S}.make).structure_size.to_natural_32).do_nothing
				a_spin.item.si_free_count := (a_spin.item.si_free_count) - 1
			end
			Result := l_n
		end

	getroom (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_len: NATURAL_32; a_align: INTEGER_32): CE_POINTER [ANY]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_bl: CE_POINTER [PD_SBLOCK_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_bl.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bl := a_spin.item.si_blocks
					if a_align.to_boolean then
						if not l_bl.is_void then
							l_bl.item.sb_used := (((((l_bl.item.sb_used).to_natural_32 + {PLATFORM}.Pointer_bytes.to_natural_32) - {NATURAL_32} 1)).bit_and ((({PLATFORM}.Pointer_bytes.to_natural_32 - {NATURAL_32} 1)).bit_not)).to_integer_32
						end
					end
					if not (l_bl.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((l_bl.item.sb_used).to_natural_32 + a_len > {NATURAL_32} 16_000) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_bl := create {CE_POINTER [PD_SBLOCK_S]}.make_cast ((misc2_inst.alloc_clear ((create {PD_SBLOCK_S}.make).structure_size.to_natural_32 + {NATURAL_32} 16_000)))
						if l_bl.is_void then
							Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_bl.item.sb_next := a_spin.item.si_blocks
							a_spin.item.si_blocks := l_bl
							l_bl.item.sb_used := 0
							a_spin.item.si_blocks_cnt := (a_spin.item.si_blocks_cnt) + 1
						end
				when 5 then -- if done
						if not js.return_called then
							l_p___0 := l_bl.item.sb_data + l_bl.item.sb_used
							l_bl.item.sb_used := l_bl.item.sb_used + a_len.to_integer_32
							Result := (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	getroom_save (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_sc: CE_POINTER [NATURAL_8]
		do
			create l_sc.make

			l_sc := create {CE_POINTER [NATURAL_8]}.make_cast ((getroom (a_spin, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s))) + {NATURAL_32} 1, 0)))
			if not l_sc.is_void then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_sc), create {CE_POINTER [INTEGER_8]}.make_cast (a_s)).do_nothing
			end
			Result := l_sc
		end

	go_deeper (a_stack: CE_POINTER [PD_TRYSTATE_S]; a_depth___1: INTEGER_32; a_score_add: INTEGER_32)
		do
			a_stack[(a_depth___1 + 1)] := (a_stack[a_depth___1]).twin;
			(a_stack + (a_depth___1 + 1)).item.ts_state := {PC_STATE_T}.STATE_START;
			(a_stack + (a_depth___1 + 1)).item.ts_score := (a_stack + a_depth___1).item.ts_score + a_score_add;
			(a_stack + (a_depth___1 + 1)).item.ts_curi := (1).to_integer_16;
			(a_stack + (a_depth___1 + 1)).item.ts_flags := (0).to_natural_8
		end

	has_non_ascii (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			if not a_s.is_void then
				l_p___0 := a_s
				from
				until
					not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					if (l_p___0.item).to_integer_32 >= 128 then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_p___0 := l_p___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	init_spell_chartab
		local
			l_i___0: INTEGER_32
			l_f: INTEGER_32
			l_u: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			did_set_spelltab := 0
			clear_spell_chartab (spelltab)
			if globals_inst.enc_dbcs.to_boolean then
				l_i___0 := 128
				from
				until
					not (l_i___0 <= 255)
				loop
					if (globals_inst.mb_bytelen_tab[l_i___0]).to_integer_32 = 2 then
						spelltab.item.st_isw[l_i___0] := (1).to_natural_8
					end
					l_i___0 := l_i___0 + 1
				end
			elseif globals_inst.enc_utf8.to_boolean then
				l_i___0 := 128
				from
				until
					not (l_i___0 < 256)
				loop
					l_f := (mbyte_inst.utf_fold (l_i___0))
					l_u := (mbyte_inst.utf_toupper (l_i___0))
					spelltab.item.st_isu[l_i___0] := (mbyte_inst.utf_isupper (l_i___0)).to_natural_8
					if (spelltab.item.st_isu[l_i___0]).to_boolean then
						l_tmp___3 := 1
					elseif (mbyte_inst.utf_islower (l_i___0)).to_boolean then
						l_tmp___3 := 1
					else
						l_tmp___3 := 0
					end
					spelltab.item.st_isw[l_i___0] := l_tmp___3.to_natural_8
					if l_f < 256 then
						spelltab.item.st_fold[l_i___0] := l_f.to_natural_8
					else
						spelltab.item.st_fold[l_i___0] := l_i___0.to_natural_8
					end
					if l_u < 256 then
						spelltab.item.st_upper[l_i___0] := l_u.to_natural_8
					else
						spelltab.item.st_upper[l_i___0] := l_i___0.to_natural_8
					end
					l_i___0 := l_i___0 + 1
				end
			else
				l_i___0 := 128
				from
				until
					not (l_i___0 < 256)
				loop
					if (charset_inst.vim_isupper (l_i___0)).to_boolean then
						spelltab.item.st_isw[l_i___0] := (1).to_natural_8
						spelltab.item.st_isu[l_i___0] := (1).to_natural_8
						spelltab.item.st_fold[l_i___0] := (charset_inst.vim_tolower (l_i___0)).to_natural_8
					elseif (charset_inst.vim_islower (l_i___0)).to_boolean then
						spelltab.item.st_isw[l_i___0] := (1).to_natural_8
						spelltab.item.st_upper[l_i___0] := (charset_inst.vim_toupper (l_i___0)).to_natural_8
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	init_spellfile
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_l: INTEGER_32
			l_fname: CE_POINTER [NATURAL_8]
			l_rtp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_lend: CE_POINTER [NATURAL_8]
			l_aspath: INTEGER_32
			l_lstart: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_buf___6.make (<<4_096>>)
			create l_fname.make
			create l_rtp.make (<<1>>)
			create l_lend.make
			create l_lstart.make
			create l_tmp___8.make
			create l_tmp___9.make

			l_aspath := 0
			l_lstart := globals_inst.curbuf.item.b_s.b_p_spl
			if (((globals_inst.curwin.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
				if (globals_inst.curwin.item.w_s).item.b_langp.ga_len > 0 then
					l_lend := (globals_inst.curwin.item.w_s).item.b_p_spl
					from
					until
						js.loop_done
					loop
						if (l_lend.item).to_integer_32 /= 0 then
							if not ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (",._")), (l_lend.item).to_integer_32)).is_void) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							if (misc1_inst.vim_ispathsep ((l_lend.item).to_integer_32)).to_boolean then
								l_aspath := 1
								l_lstart := l_lend + 1
							end
							l_lend := l_lend + 1
						end
					end
					l_rtp.item := option_inst.p_rtp.item
					from
					until
						not (not js.loop_done and then ((l_rtp.item.item).to_integer_32 /= 0))
					loop
						if l_aspath.to_boolean then
							misc2_inst.vim_strncpy (l_buf___6, globals_inst.curbuf.item.b_s.b_p_spl, ((l_lstart.distance ((globals_inst.curbuf.item.b_s.b_p_spl))) - 1).to_natural_32)
						else
							misc2_inst.copy_option_part (l_rtp, l_buf___6, 4_096, ce_string (",")).do_nothing
						end
						if (misc2_inst.filewritable (l_buf___6)) = 2 then
							if l_aspath.to_boolean then
								misc2_inst.vim_strncpy (l_buf___6, globals_inst.curbuf.item.b_s.b_p_spl, (l_lend.distance ((globals_inst.curbuf.item.b_s.b_p_spl))).to_natural_32)
							else
								l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32
								message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6) + l_l, (4_096 - l_l).to_natural_32, ce_string ("/spell")]).do_nothing
								if (misc2_inst.filewritable (l_buf___6)).to_boolean then
									l_tmp___3 := 0
								else
									l_tmp___3 := 1
								end
								if l_tmp___3 /= 2 then
									mkdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), (493).to_natural_32).do_nothing
								end
								l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32
								message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6) + l_l, (4_096 - l_l).to_natural_32, ce_string ("/%%.*s"), l_lend.distance (l_lstart), l_lstart]).do_nothing
							end
							l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32
							l_fname := ((create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + 0).item.lp_slang).item.sl_fname
							if not l_fname.is_void then
								if not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (l_fname))), ce_string (".ascii."))).is_void then
									l_tmp___9 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ascii"))
								else
									l_tmp___8 := spell_enc
									l_tmp___9 := l_tmp___8
								end
							else
								l_tmp___8 := spell_enc
								l_tmp___9 := l_tmp___8
							end
							message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6) + l_l, (4_096 - l_l).to_natural_32, ce_string (".%%s.add"), l_tmp___9]).do_nothing
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("spellfile")), 0, l_buf___6, 4)
							js.break
						end
						if not js.loop_jumped then
							l_aspath := 0
						end
					end
				end
			end
		end

	init_syl_tab (a_slang: CE_POINTER [PD_SLANG_S]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_syl: CE_POINTER [PD_SYL_ITEM_S]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_s.make
			create l_syl.make
			create l_tmp.make

			misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_syl_items")), ((create {PD_SYL_ITEM_S}.make).structure_size.to_natural_32).to_integer_32, 4)
			l_p___0 := misc2_inst.vim_strchr (a_slang.item.sl_syllable, ('/').code)
			from
			until
				not (not js.loop_done and then (not l_p___0.is_void))
			loop
				l_tmp := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp.item := (('%/0/').code).to_natural_8
				if (l_p___0.item).to_integer_32 = 0 then
					js.break
				end
				if not js.loop_jumped then
					l_s := l_p___0
					l_p___0 := misc2_inst.vim_strchr (l_p___0, ('/').code)
					if l_p___0.is_void then
						l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
					else
						l_l := l_p___0.distance (l_s)
					end
					if l_l >= 30 then
						Result := (-2)
						js.return
					end
					if not js.return_called then
						if (misc2_inst.ga_grow (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_syl_items")), 1)) = 0 then
							Result := (-3)
							js.return
						end
					end
					if not js.return_called then
						l_tmp___2 := a_slang.item.sl_syl_items.ga_len
						a_slang.item.sl_syl_items.ga_len := (a_slang.item.sl_syl_items.ga_len) + 1
						l_syl := create {CE_POINTER [PD_SYL_ITEM_S]}.make_cast (a_slang.item.sl_syl_items.ga_data) + l_tmp___2
						misc2_inst.vim_strncpy (l_syl.item.sy_chars, l_s, l_l.to_natural_32)
						l_syl.item.sy_len := l_l
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	int_wordlist_spl (a_fname: CE_POINTER [NATURAL_8])
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), (4_096).to_natural_32, ce_string ("%%s.%%s.spl"), int_wordlist, (spell_enc)]).do_nothing
		end

	is_aff_rule (a_items: CE_POINTER [CE_POINTER [NATURAL_8]]; a_itemcnt: INTEGER_32; a_rulename: CE_POINTER [INTEGER_8]; a_mincount: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_items[0]), a_rulename)) = 0 then
				if a_itemcnt = a_mincount then
					l_tmp___0 := 1
				elseif a_itemcnt > a_mincount then
					if ((a_items[a_mincount])[0]).to_integer_32 = 35 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	make_case_word (a_fword: CE_POINTER [NATURAL_8]; a_cword: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32)
		do
			if ((a_flags___0).bit_and (4)).to_boolean then
				allcap_copy (a_fword, a_cword)
			elseif ((a_flags___0).bit_and (2)).to_boolean then
				onecap_copy (a_fword, a_cword, 1)
			else
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_cword), create {CE_POINTER [INTEGER_8]}.make_cast (a_fword)).do_nothing
			end
		end

	match_checkcompoundpattern (a_ptr: CE_POINTER [NATURAL_8]; a_wlen: INTEGER_32; a_gap: CE_POINTER [PD_GROWARRAY]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_i___0 := 0
			from
			until
				not (not js.loop_done and then (l_i___0 + 1 < a_gap.item.ga_len))
			loop
				l_p___0 := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[(l_i___0 + 1)]
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((a_ptr + a_wlen)), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))))) = 0 then
					l_p___0 := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[l_i___0]
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
					if l_len <= a_wlen then
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (((a_ptr + a_wlen) - l_len)), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), l_len.to_natural_32)) = 0 then
							Result := 1
							js.return
						end
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + (2)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	match_compoundrule (a_slang: CE_POINTER [PD_SLANG_S]; a_compflags: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_match: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp.make

			l_p___0 := a_slang.item.sl_comprules
			from
			until
				not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				l_i___0 := 0
				from
				until
					js.loop_done
				loop
					l_c := (a_compflags[l_i___0]).to_integer_32
					if l_c = 0 then
						Result := 1
						js.return
					end
					if not js.return_called then
						if (l_p___0.item).to_integer_32 = 47 then
							js.break
						elseif (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							if (l_p___0.item).to_integer_32 = 91 then
								l_match := 0
								l_p___0 := l_p___0 + 1
								from
								until
									js.loop_done
								loop
									if (l_p___0.item).to_integer_32 /= 93 then
										if (l_p___0.item).to_integer_32 = 0 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_tmp := l_p___0
										l_p___0 := l_p___0 + 1
										if (l_tmp.item).to_integer_32 = l_c then
											l_match := 1
										end
									end
								end
								if not l_match.to_boolean then
									js.break
								end
							elseif (l_p___0.item).to_integer_32 /= l_c then
								js.break
							end
						end
						if not js.loop_jumped then
							l_p___0 := l_p___0 + 1
							l_i___0 := l_i___0 + 1
						end
					end
				end
				if not js.return_called then
					l_p___0 := misc2_inst.vim_strchr (l_p___0, ('/').code)
					if l_p___0.is_void then
						js.break
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	mb_str2wide (a_s: CE_POINTER [NATURAL_8]): CE_POINTER [INTEGER_32]
		local
			l_res: CE_POINTER [INTEGER_32]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_i___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			create l_res.make
			create l_p___0.make (<<1>>)

			l_i___0 := 0
			l_res := create {CE_POINTER [INTEGER_32]}.make_cast ((misc2_inst.alloc ({PLATFORM}.Integer_32_bytes.to_natural_32 * ((mbyte_inst.mb_charlen (a_s)) + 1).to_natural_32)))
			if not l_res.is_void then
				l_p___0.item := a_s
				from
				until
					(l_p___0.item.item).to_integer_32 = 0
				loop
					l_tmp___1 := l_i___0
					l_i___0 := l_i___0 + 1
					l_res[l_tmp___1] := mbyte_inst.mb_ptr2char_adv (l_p___0)
				end
				l_res[l_i___0] := ('%/0/').code
			end
			Result := l_res
		end

	mkspell (a_fcount: INTEGER_32; a_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]; a_ascii: INTEGER_32; a_overwrite: INTEGER_32; a_added_word: INTEGER_32)
		local
			l_fname: CE_ARRAY [NATURAL_8]
			l_wfname: CE_ARRAY [NATURAL_8]
			l_innames: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_incount: INTEGER_32
			l_afile: CE_ARRAY [CE_POINTER [PD_AFFFILE_S]]
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_st: CE_ARRAY [SD_STAT]
			l_error: INTEGER_32
			l_spin: CE_ARRAY [PD_SPELLINFO_S]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fname.make (<<4_096>>)
			create l_wfname.make (<<4_096>>)
			create l_innames.make
			create l_afile.make (<<8>>)
			create l_st.make (<<1>>)
			create l_spin.make (<<1>>)
			create l_tmp___1.make
			create l_tmp___3.make
			create l_tmp___18.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_error := 0
					memset (create {CE_POINTER [ANY]}.make_cast (l_spin), 0, (create {PD_SPELLINFO_S}.make).structure_size.to_natural_32).do_nothing
					l_spin.item.si_verbose := (not a_added_word.to_boolean).to_integer
					l_spin.item.si_ascii := a_ascii
					l_spin.item.si_followup := 1
					l_spin.item.si_rem_accents := 1
					misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_rep")), ((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 20)
					misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_repsal")), ((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 20)
					misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_sal")), ((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 20)
					misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_map")), ({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 100)
					misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_comppat")), ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 20)
					misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond")), ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 50)
					hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords")))
					l_spin.item.si_newcompID := 127
					l_innames := a_fnames + 1
					l_incount := a_fcount - 1
					if not (a_fcount >= 1) then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fnames[0]))).to_integer_32
						if a_fcount /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_len > 4 then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (((a_fnames[0] + l_len) - 4)), ce_string (".add"))) = 0 then
								l_innames := a_fnames + 0
								l_incount := 1
								message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_wfname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.spl"), a_fnames[0]]).do_nothing
							else
								l_pos := -1 + 4 -- goto _L___1
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else: | _L___1:
						if a_fcount /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_innames := a_fnames + 0
						l_incount := 1
						if (l_spin.item.si_ascii).to_boolean then
							l_tmp___1 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ascii"))
						else
							l_tmp___1 := (spell_enc)
						end
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_wfname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.%%s.spl"), a_fnames[0], l_tmp___1]).do_nothing
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if not (l_len > 4) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (((a_fnames[0] + l_len) - 4)), ce_string (".spl"))) = 0 then
							misc2_inst.vim_strncpy (l_wfname, a_fnames[0], ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32) - {NATURAL_32} 1)
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if (l_spin.item.si_ascii).to_boolean then
							l_tmp___3 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ascii"))
						else
							l_tmp___3 := (spell_enc)
						end
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_wfname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.%%s.spl"), a_fnames[0], l_tmp___3]).do_nothing
				when 11 then -- if done | if done
						if not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (l_wfname))), ce_string (".ascii."))).is_void then
							l_spin.item.si_ascii := 1
						end
						if not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (l_wfname))), ce_string (".add."))).is_void then
							l_spin.item.si_add := 1
						end
				when 12 then -- if done
					if l_incount <= 0 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
					elseif not (misc2_inst.vim_strchr ((misc1_inst.gettail (l_wfname)), ('_').code)).is_void then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E751: Output file name must not have region name"))))).do_nothing
					elseif l_incount > 8 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E754: Only up to 8 regions supported"))))).do_nothing
					else
						if not a_overwrite.to_boolean then
							if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_wfname), l_st)) >= 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_exists))))).do_nothing
								js.return
							end
						end
						if not js.return_called then
							if (os_unix_inst.mch_isdir (l_wfname)).to_boolean then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_isadir2)))), l_wfname).do_nothing
								js.return
							end
						end
						if not js.return_called then
							l_i___0 := 0
							from
							until
								not (not js.loop_done and then (l_i___0 < l_incount))
							loop
								l_afile[l_i___0] := create {CE_POINTER [PD_AFFFILE_S]}.make_shared (default_pointer)
								if l_incount > 1 then
									l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_innames[l_i___0]))).to_integer_32
									if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (l_innames[l_i___0]))))) < {NATURAL_32} 5 then
										l_tmp___18 := gettext (ce_string ("E755: Invalid region in %%s"))
										message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___18), l_innames[l_i___0]).do_nothing
										js.return
									elseif ((l_innames[l_i___0])[(l_len - 3)]).to_integer_32 /= 95 then
										l_tmp___18 := gettext (ce_string ("E755: Invalid region in %%s"))
										message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___18), l_innames[l_i___0]).do_nothing
										js.return
									end
									if not js.return_called then
										if ((l_innames[l_i___0])[(l_len - 2)]).to_integer_32 < 65 then
											l_spin.item.si_region_name[l_i___0 * 2] := (l_innames[l_i___0])[(l_len - 2)]
										elseif ((l_innames[l_i___0])[(l_len - 2)]).to_integer_32 > 90 then
											l_spin.item.si_region_name[l_i___0 * 2] := (l_innames[l_i___0])[(l_len - 2)]
										else
											l_spin.item.si_region_name[l_i___0 * 2] := (((l_innames[l_i___0])[(l_len - 2)]).to_integer_32 + 32).to_natural_8
										end
										if ((l_innames[l_i___0])[(l_len - 1)]).to_integer_32 < 65 then
											l_spin.item.si_region_name[l_i___0 * 2 + 1] := (l_innames[l_i___0])[(l_len - 1)]
										elseif ((l_innames[l_i___0])[(l_len - 1)]).to_integer_32 > 90 then
											l_spin.item.si_region_name[l_i___0 * 2 + 1] := (l_innames[l_i___0])[(l_len - 1)]
										else
											l_spin.item.si_region_name[l_i___0 * 2 + 1] := (((l_innames[l_i___0])[(l_len - 1)]).to_integer_32 + 32).to_natural_8
										end
									end
								end
								if not js.return_called then
									l_i___0 := l_i___0 + 1
								end
							end
						end
						if not js.return_called then
							l_spin.item.si_region_count := l_incount
							l_spin.item.si_foldroot := wordtree_alloc (l_spin)
							l_spin.item.si_keeproot := wordtree_alloc (l_spin)
							l_spin.item.si_prefroot := wordtree_alloc (l_spin)
							if (l_spin.item.si_foldroot).is_void then
								free_blocks (l_spin.item.si_blocks)
								js.return
							elseif (l_spin.item.si_keeproot).is_void then
								free_blocks (l_spin.item.si_blocks)
								js.return
							elseif (l_spin.item.si_prefroot).is_void then
								free_blocks (l_spin.item.si_blocks)
								js.return
							end
						end
						if not js.return_called then
							if not (l_spin.item.si_add).to_boolean then
								l_spin.item.si_clear_chartab := 1
							end
							l_i___0 := 0
							from
							until
								js.loop_done
							loop
								if l_i___0 < l_incount then
									if l_error.to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_spin.item.si_conv.vc_type := 0
									l_spin.item.si_region := (1).bit_shift_left (l_i___0)
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.aff"), l_innames[l_i___0]]).do_nothing
									if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), l_st)) >= 0 then
										l_afile[l_i___0] := spell_read_aff (l_spin, l_fname)
										if (l_afile[l_i___0]).is_void then
											l_error := 1
										else
											message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.dic"), l_innames[l_i___0]]).do_nothing
											if (spell_read_dic (l_spin, l_fname, l_afile[l_i___0])) = 0 then
												l_error := 1
											end
										end
									elseif (spell_read_wordfile (l_spin, l_innames[l_i___0])) = 0 then
										l_error := 1
									end
									mbyte_inst.convert_setup (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
									l_i___0 := l_i___0 + 1
								end
							end
							if not (l_spin.item.si_compflags).is_void then
								if (l_spin.item.si_nobreak).to_boolean then
									message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Warning: both compounding and NOBREAK specified"))))).do_nothing
								end
							end
							if not l_error.to_boolean then
								if not globals_inst.got_int.to_boolean then
									spell_message (l_spin, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (msg_compressing))))
									wordtree_compress (l_spin, l_spin.item.si_foldroot)
									wordtree_compress (l_spin, l_spin.item.si_keeproot)
									wordtree_compress (l_spin, l_spin.item.si_prefroot)
								end
							end
							if not l_error.to_boolean then
								if not globals_inst.got_int.to_boolean then
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Writing spell file %%s ..."))), l_wfname]).do_nothing
									spell_message (l_spin, globals_inst.IObuff)
									l_error := ((write_vim_spell (l_spin, l_wfname)) = 0).to_integer
									spell_message (l_spin, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Done!")))))
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Estimated runtime memory use: %%d bytes"))), l_spin.item.si_memtot]).do_nothing
									spell_message (l_spin, globals_inst.IObuff)
									if not l_error.to_boolean then
										spell_reload_one (l_wfname, a_added_word)
									end
								end
							end
							misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_rep")))
							misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_repsal")))
							misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_sal")))
							misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_map")))
							misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_comppat")))
							misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond")))
							hashtab_inst.hash_clear_all (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords")), 0)
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_incount)
							loop
								if not (l_afile[l_i___0]).is_void then
									spell_free_aff (l_afile[l_i___0])
								end
								l_i___0 := l_i___0 + 1
							end
							free_blocks (l_spin.item.si_blocks)
							if l_spin.item.si_sugtime /= 0 then
								if not l_error.to_boolean then
									if not globals_inst.got_int.to_boolean then
										spell_make_sugfile (l_spin, l_wfname)
									end
								end
							end
						end
					end
					if not js.return_called then
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	no_spell_checking (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			if not (a_wp___0.item.w_onebuf_opt.wo_spell).to_boolean then
				l_tmp := gettext (ce_string ("E756: Spell checking is not enabled"))
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
				Result := 1
				js.return
			elseif (((a_wp___0.item.w_s).item.b_p_spl).item).to_integer_32 = 0 then
				l_tmp := gettext (ce_string ("E756: Spell checking is not enabled"))
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
				Result := 1
				js.return
			elseif (a_wp___0.item.w_s).item.b_langp.ga_len = 0 then
				l_tmp := gettext (ce_string ("E756: Spell checking is not enabled"))
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	node_compress (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_node: CE_POINTER [PD_WORDNODE_S]; a_ht: CE_POINTER [PD_HASHTABLE_S]; a_tot: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_tp: CE_POINTER [PD_WORDNODE_S]
			l_child: CE_POINTER [PD_WORDNODE_S]
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_len: INTEGER_32
			l_nr: NATURAL_32
			l_n: NATURAL_32
			l_compressed: INTEGER_32
			js: JUMP_STATE
		do
			create l_np.make
			create l_tp.make
			create l_child.make
			create l_hi___1.make

			l_len := 0
			l_compressed := 0
			l_np := a_node
			from
			until
				js.loop_done
			loop
				if not l_np.is_void then
					if globals_inst.got_int.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_len := l_len + 1
					l_child := l_np.item.wn_child
					if not l_child.is_void then
						l_compressed := l_compressed + (node_compress (a_spin, l_child, a_ht, a_tot))
						l_hash := hashtab_inst.hash_hash (l_child.item.wn_u1.hashkey)
						l_hi___1 := hashtab_inst.hash_lookup (a_ht, l_child.item.wn_u1.hashkey, l_hash)
						if (l_hi___1.item.hi_key).is_void then
							hashtab_inst.hash_add_item (a_ht, l_hi___1, l_child.item.wn_u1.hashkey, l_hash).do_nothing
						elseif (l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed) then
							hashtab_inst.hash_add_item (a_ht, l_hi___1, l_child.item.wn_u1.hashkey, l_hash).do_nothing
						else
							l_tp := create {CE_POINTER [PD_WORDNODE_S]}.make_cast (l_hi___1.item.hi_key)
							from
							until
								not (not js.loop_done and then (not l_tp.is_void))
							loop
								if (node_equal (l_child, l_tp)).to_boolean then
									l_tp.item.wn_refs := (l_tp.item.wn_refs) + 1
									l_compressed := l_compressed + (deref_wordnode (a_spin, l_child))
									l_np.item.wn_child := l_tp
									js.break
								end
								if not js.loop_jumped then
									l_tp := l_tp.item.wn_u2.next
								end
							end
							if l_tp.is_void then
								l_tp := create {CE_POINTER [PD_WORDNODE_S]}.make_cast (l_hi___1.item.hi_key)
								l_child.item.wn_u2.next := l_tp.item.wn_u2.next
								l_tp.item.wn_u2.next := l_child
							end
						end
					end
					l_np := l_np.item.wn_sibling
				end
			end
			a_tot.item := a_tot.item + (l_len + 1)
			a_node.item.wn_u1.hashkey[0] := l_len.to_natural_8
			l_nr := {NATURAL_32} 0
			l_np := a_node
			from
			until
				l_np.is_void
			loop
				if (l_np.item.wn_byte).to_integer_32 = 0 then
					l_n := (((l_np.item.wn_flags).to_integer_32 + (((l_np.item.wn_region).to_integer_32).bit_shift_left (8))) + (((l_np.item.wn_affixID).to_integer_32).bit_shift_left (16))).to_natural_32
				else
					l_n := ((l_np.item.wn_byte).to_natural_32 + ((((l_np.item.wn_child).c_pointer.to_integer_32).to_natural_32).bit_shift_left (8))).to_natural_32
				end
				l_nr := l_nr * {NATURAL_32} 101 + l_n
				l_np := l_np.item.wn_sibling
			end
			l_n := (l_nr).bit_and ({NATURAL_32} 255)
			if l_n = {NATURAL_32} 0 then
				a_node.item.wn_u1.hashkey[1] := (1).to_natural_8
			else
				a_node.item.wn_u1.hashkey[1] := l_n.to_natural_8
			end
			l_n := (((l_nr).bit_shift_right (8))).bit_and ({NATURAL_32} 255)
			if l_n = {NATURAL_32} 0 then
				a_node.item.wn_u1.hashkey[2] := (1).to_natural_8
			else
				a_node.item.wn_u1.hashkey[2] := l_n.to_natural_8
			end
			l_n := (((l_nr).bit_shift_right (16))).bit_and ({NATURAL_32} 255)
			if l_n = {NATURAL_32} 0 then
				a_node.item.wn_u1.hashkey[3] := (1).to_natural_8
			else
				a_node.item.wn_u1.hashkey[3] := l_n.to_natural_8
			end
			l_n := (((l_nr).bit_shift_right (24))).bit_and ({NATURAL_32} 255)
			if l_n = {NATURAL_32} 0 then
				a_node.item.wn_u1.hashkey[4] := (1).to_natural_8
			else
				a_node.item.wn_u1.hashkey[4] := l_n.to_natural_8
			end
			a_node.item.wn_u1.hashkey[5] := (('%/0/').code).to_natural_8
			misc1_inst.fast_breakcheck
			Result := l_compressed
		end

	node_equal (a_n1: CE_POINTER [PD_WORDNODE_S]; a_n2: CE_POINTER [PD_WORDNODE_S]): INTEGER_32
		local
			l_p1: CE_POINTER [PD_WORDNODE_S]
			l_p2: CE_POINTER [PD_WORDNODE_S]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_p1.make
			create l_p2.make

			l_p1 := a_n1
			l_p2 := a_n2
			from
			until
				js.loop_done
			loop
				if not l_p1.is_void then
					if l_p2.is_void then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (l_p1.item.wn_byte).to_integer_32 /= (l_p2.item.wn_byte).to_integer_32 then
						js.break
					else
						if (l_p1.item.wn_byte).to_integer_32 = 0 then
							if (l_p1.item.wn_flags).to_integer_32 /= (l_p2.item.wn_flags).to_integer_32 then
								l_tmp := 1
							elseif (l_p1.item.wn_region).to_integer_32 /= (l_p2.item.wn_region).to_integer_32 then
								l_tmp := 1
							elseif (l_p1.item.wn_affixID).to_integer_32 /= (l_p2.item.wn_affixID).to_integer_32 then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						else
							l_tmp___0 := (not (l_p1.item.wn_child).is_equal (l_p2.item.wn_child)).to_integer
						end
						if l_tmp___0.to_boolean then
							js.break
						end
					end
				end
				if not js.loop_jumped then
					l_p1 := l_p1.item.wn_sibling
					l_p2 := l_p2.item.wn_sibling
				end
			end
			if l_p1.is_void then
				if l_p2.is_void then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	nofold_len (a_fword: CE_POINTER [NATURAL_8]; a_flen: INTEGER_32; a_word: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			create l_p___0.make

			l_i___0 := 0
			l_p___0 := a_fword
			from
			until
				not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((a_fword + a_flen).c_pointer.to_integer_32).to_natural_32)
			loop
				l_i___0 := l_i___0 + 1
				if globals_inst.has_mbyte.to_boolean then
					l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
				else
					l_tmp___0 := 1
				end
				l_p___0 := l_p___0 + l_tmp___0
			end
			l_p___0 := a_word
			from
			until
				not (l_i___0 > 0)
			loop
				l_i___0 := l_i___0 - 1
				if globals_inst.has_mbyte.to_boolean then
					l_tmp___2 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
				else
					l_tmp___2 := 1
				end
				l_p___0 := l_p___0 + l_tmp___2
			end
			Result := (l_p___0.distance (a_word))
		end

	offset2bytes (a_nr: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_rem: INTEGER_32
			l_b1: INTEGER_32
			l_b2: INTEGER_32
			l_b3: INTEGER_32
			l_b4: INTEGER_32
			js: JUMP_STATE
		do
			l_b1 := a_nr \\ 255 + 1
			l_rem := a_nr // 255
			l_b2 := l_rem \\ 255 + 1
			l_rem := l_rem // (255)
			l_b3 := l_rem \\ 255 + 1
			l_b4 := l_rem // 255 + 1
			if l_b4 > 1 then
				a_buf___6[0] := (224 + l_b4).to_natural_8
				a_buf___6[1] := l_b3.to_natural_8
				a_buf___6[2] := l_b2.to_natural_8
				a_buf___6[3] := l_b1.to_natural_8
				Result := 4
				js.return
			elseif l_b3 > 31 then
				a_buf___6[0] := (224 + l_b4).to_natural_8
				a_buf___6[1] := l_b3.to_natural_8
				a_buf___6[2] := l_b2.to_natural_8
				a_buf___6[3] := l_b1.to_natural_8
				Result := 4
				js.return
			end
			if not js.return_called then
				if l_b3 > 1 then
					a_buf___6[0] := (192 + l_b3).to_natural_8
					a_buf___6[1] := l_b2.to_natural_8
					a_buf___6[2] := l_b1.to_natural_8
					Result := 3
					js.return
				elseif l_b2 > 63 then
					a_buf___6[0] := (192 + l_b3).to_natural_8
					a_buf___6[1] := l_b2.to_natural_8
					a_buf___6[2] := l_b1.to_natural_8
					Result := 3
					js.return
				end
			end
			if not js.return_called then
				if l_b2 > 1 then
					a_buf___6[0] := (128 + l_b2).to_natural_8
					a_buf___6[1] := l_b1.to_natural_8
					Result := 2
					js.return
				elseif l_b1 > 127 then
					a_buf___6[0] := (128 + l_b2).to_natural_8
					a_buf___6[1] := l_b1.to_natural_8
					Result := 2
					js.return
				end
			end
			if not js.return_called then
				a_buf___6[0] := l_b1.to_natural_8
				Result := 1
			end
		end

	onecap_copy (a_word: CE_POINTER [NATURAL_8]; a_wcopy: CE_POINTER [NATURAL_8]; a_upper: INTEGER_32)
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_l: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___5: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_p___0.make (<<1>>)
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.item := a_word
					if globals_inst.has_mbyte.to_boolean then
						l_c := mbyte_inst.mb_cptr2char_adv (l_p___0)
					else
						l_tmp := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_c := (l_tmp.item).to_integer_32
					end
					if not (a_upper.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_c >= 128 then
							l_c := (mbyte_inst.utf_toupper (l_c))
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_c < 256 then
							l_tmp___2 := (spelltab.item.st_upper[l_c]).to_integer_32
						else
							l_tmp___2 := (towupper (l_c.to_natural_32)).to_integer_32
						end
						l_c := l_tmp___2
				when 5 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_c >= 128 then
							l_c := (mbyte_inst.utf_fold (l_c))
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						if l_c < 256 then
							l_tmp___5 := (spelltab.item.st_fold[l_c]).to_integer_32
						else
							l_tmp___5 := (towlower (l_c.to_natural_32)).to_integer_32
						end
						l_c := l_tmp___5
				when 10 then -- if done
						if globals_inst.has_mbyte.to_boolean then
							l_l := globals_inst.mb_char2bytes.integer_32_item ([l_c, a_wcopy])
						else
							l_l := 1
							a_wcopy[0] := l_c.to_natural_8
						end
						misc2_inst.vim_strncpy (a_wcopy + l_l, l_p___0.item, ((250 - l_l) - 1).to_natural_32)
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	open_spellbuf: CE_POINTER [PD_FILE_BUFFER]
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
		do
			create l_buf___6.make

			l_buf___6 := create {CE_POINTER [PD_FILE_BUFFER]}.make_cast ((misc2_inst.alloc_clear ((create {PD_FILE_BUFFER}.make).structure_size.to_natural_32)))
			if not l_buf___6.is_void then
				l_buf___6.item.b_spell := 1
				l_buf___6.item.b_p_swf := 1
				memline_inst.ml_open (l_buf___6).do_nothing
				memline_inst.ml_open_file (l_buf___6)
			end
			Result := l_buf___6
		end

	process_compflags (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_aff: CE_POINTER [PD_AFFFILE_S]; a_compflags: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prevp: CE_POINTER [NATURAL_8]
			l_flag: NATURAL_32
			l_ci: CE_POINTER [PD_COMPITEM_S]
			l_id: INTEGER_32
			l_len: INTEGER_32
			l_tp: CE_POINTER [NATURAL_8]
			l_key: CE_ARRAY [NATURAL_8]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make (<<1>>)
			create l_prevp.make
			create l_ci.make
			create l_tp.make
			create l_key.make (<<17>>)
			create l_hi___1.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___8.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_compflags))).to_integer_32 + 1
					if not (a_spin.item.si_compflags).is_void then
						l_len := l_len + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_compflags))).to_integer_32 + 1)
					end
					l_p___0.item := create {CE_POINTER [NATURAL_8]}.make_cast ((getroom (a_spin, l_len.to_natural_32, 0)))
					if (l_p___0.item).is_void then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if not (a_spin.item.si_compflags).is_void then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_compflags)).do_nothing
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("/")).do_nothing
						end
						a_spin.item.si_compflags := l_p___0.item
						l_tp := l_p___0.item + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item))).to_integer_32
						l_p___0.item := a_compflags
				when 2 then -- loop condition:
						if not (not js.loop_done and then ((l_p___0.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 3 then -- loop body:
						if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/*+[]")), (l_p___0.item.item).to_integer_32)).is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp___3 := l_tp
						l_tp := l_tp + 1
						l_tmp___4 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_tmp___3.item := l_tmp___4.item
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						l_prevp := l_p___0.item
						l_flag := get_affitem (a_aff.item.af_flagtype, l_p___0)
						if l_flag = {NATURAL_32} 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
						misc2_inst.vim_strncpy (l_key, l_prevp, ((l_p___0.item).distance (l_prevp)).to_natural_32)
						l_hi___1 := hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp")), l_key)
						if not ((l_hi___1.item.hi_key).is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						l_ci := create {CE_POINTER [PD_COMPITEM_S]}.make_cast ((getroom (a_spin, (create {PD_COMPITEM_S}.make).structure_size.to_natural_32, 1)))
						if l_ci.is_void then
							js.break
						end
						if not js.loop_jumped then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_ci.item.ci_key)), create {CE_POINTER [INTEGER_8]}.make_cast (l_key)).do_nothing
							l_ci.item.ci_flag := l_flag
							from
							until
								js.loop_done
							loop
								check_renumber (a_spin)
								l_tmp___6 := a_spin.item.si_newcompID
								a_spin.item.si_newcompID := (a_spin.item.si_newcompID) - 1
								l_id := l_tmp___6
								if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/+*[]\-^")), l_id)).is_void then
									js.break
								end
							end
							l_ci.item.ci_newID := l_id
							hashtab_inst.hash_add (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp")), l_ci.item.ci_key).do_nothing
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_id := (create {CE_POINTER [PD_COMPITEM_S]}.make_cast (l_hi___1.item.hi_key)).item.ci_newID
				when 14 then -- if done
						if not js.loop_jumped then
							l_tmp___8 := l_tp
							l_tp := l_tp + 1
							l_tmp___8.item := l_id.to_natural_8
						end
				when 15 then -- if done
						if not js.loop_jumped and then (a_aff.item.af_flagtype = 3) then
							if (l_p___0.item.item).to_integer_32 = 44 then
								l_p___0.item := l_p___0.item + 1
							end
						end
				when 16 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 17 then -- loop done
						l_tp.item := (('%/0/').code).to_natural_8
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	put_node (a_fd: CE_POINTER [SD_IO_FILE]; a_node: CE_POINTER [PD_WORDNODE_S]; a_idx: INTEGER_32; a_regionmask: INTEGER_32; a_prefixtree: INTEGER_32): INTEGER_32
		local
			l_newindex: INTEGER_32
			l_siblingcount: INTEGER_32
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_flags___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_np.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newindex := a_idx
					l_siblingcount := 0
					if a_node.is_void then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						a_node.item.wn_u1.index := a_idx
						l_np := a_node
						from
						until
							l_np.is_void
						loop
							l_siblingcount := l_siblingcount + 1
							l_np := l_np.item.wn_sibling
						end
						if not a_fd.is_void then
							IO_putc (l_siblingcount, a_fd).do_nothing
						end
						l_np := a_node
				when 2 then -- loop condition:
						if not (not js.loop_done and then (not l_np.is_void)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						if (l_np.item.wn_byte).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not a_fd.is_void then
							if a_prefixtree.to_boolean then
								if (l_np.item.wn_flags).to_integer_32 = 65_280 then
									IO_putc (0, a_fd).do_nothing
								else
									IO_putc (2, a_fd).do_nothing
									IO_putc ((l_np.item.wn_flags).to_integer_32, a_fd).do_nothing
								end
								IO_putc ((l_np.item.wn_affixID).to_integer_32, a_fd).do_nothing
								misc2_inst.put_bytes (a_fd, (l_np.item.wn_region).to_natural_32, 2).do_nothing
							else
								l_flags___0 := (l_np.item.wn_flags).to_integer_32
								if a_regionmask /= 0 then
									if (l_np.item.wn_region).to_integer_32 /= a_regionmask then
										l_flags___0 := (l_flags___0).bit_or ((1))
									end
								end
								if (l_np.item.wn_affixID).to_integer_32 /= 0 then
									l_flags___0 := (l_flags___0).bit_or ((32))
								end
								if l_flags___0 = 0 then
									IO_putc (0, a_fd).do_nothing
								else
									if (l_np.item.wn_flags).to_integer_32 >= 256 then
										IO_putc (3, a_fd).do_nothing
										IO_putc (l_flags___0, a_fd).do_nothing
										IO_putc (((l_flags___0.to_natural_32).bit_shift_right (8)).to_integer_32, a_fd).do_nothing
									else
										IO_putc (2, a_fd).do_nothing
										IO_putc (l_flags___0, a_fd).do_nothing
									end
									if ((l_flags___0).bit_and (1)).to_boolean then
										IO_putc ((l_np.item.wn_region).to_integer_32, a_fd).do_nothing
									end
									if ((l_flags___0).bit_and (32)).to_boolean then
										IO_putc ((l_np.item.wn_affixID).to_integer_32, a_fd).do_nothing
									end
								end
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if (l_np.item.wn_child).item.wn_u1.index = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not ((l_np.item.wn_child).item.wn_u2.wnode).is_equal (a_node) then
							if not a_fd.is_void then
								IO_putc (1, a_fd).do_nothing
								misc2_inst.put_bytes (a_fd, ((l_np.item.wn_child).item.wn_u1.index).to_natural_32, 3).do_nothing
							end
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if ((l_np.item.wn_child).item.wn_u2.wnode).is_void then
							(l_np.item.wn_child).item.wn_u2.wnode := a_node
						end
				when 10 then
						if not a_fd.is_void then
							if (IO_putc ((l_np.item.wn_byte).to_integer_32, a_fd)) = -1 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_write))))).do_nothing
								Result := 0
								js.return
							end
						end
				when 11 then -- if done
						if not js.return_called then
							l_np := l_np.item.wn_sibling
						end
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done | if done
						if not js.return_called then
							l_newindex := l_newindex + (l_siblingcount + 1)
							l_np := a_node
							from
							until
								l_np.is_void
							loop
								if (l_np.item.wn_byte).to_integer_32 /= 0 then
									if ((l_np.item.wn_child).item.wn_u2.wnode).is_equal (a_node) then
										l_newindex := put_node (a_fd, l_np.item.wn_child, l_newindex, a_regionmask, a_prefixtree)
									end
								end
								l_np := l_np.item.wn_sibling
							end
							Result := l_newindex
						end
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	read_charflags_section (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_flags___0: CE_POINTER [NATURAL_8]
			l_fol: CE_POINTER [NATURAL_8]
			l_flagslen: CE_ARRAY [INTEGER_32]
			l_follen: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_flags___0.make
			create l_fol.make
			create l_flagslen.make (<<1>>)
			create l_follen.make (<<1>>)

			l_flags___0 := read_cnt_string (a_fd, 1, l_flagslen)
			if l_flagslen.item < 0 then
				Result := (l_flagslen.item)
				js.return
			end
			if not js.return_called then
				l_fol := read_cnt_string (a_fd, 2, l_follen)
				if l_follen.item < 0 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_flags___0))
					Result := (l_follen.item)
					js.return
				end
			end
			if not js.return_called then
				if not l_flags___0.is_void then
					if not l_fol.is_void then
						set_spell_charflags (l_flags___0, l_flagslen.item, l_fol)
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_flags___0))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fol))
				if (l_flags___0.is_void) /= (l_fol.is_void) then
					Result := (-2)
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	read_cnt_string (a_fd: CE_POINTER [SD_IO_FILE]; a_cnt_bytes: INTEGER_32; a_cntp: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_cnt: INTEGER_32
			l_i___0: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_str___1.make

			l_cnt := 0
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_cnt_bytes)
			loop
				l_cnt := ((l_cnt).bit_shift_left (8)) + (IO_getc (a_fd))
				l_i___0 := l_i___0 + 1
			end
			if l_cnt < 0 then
				a_cntp.item := -1
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				a_cntp.item := l_cnt
				if l_cnt = 0 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_str___1 := misc2_inst.read_string (a_fd, l_cnt)
				if l_str___1.is_void then
					a_cntp.item := -3
				end
				Result := l_str___1
			end
		end

	read_compound (a_fd: CE_POINTER [SD_IO_FILE]; a_slang: CE_POINTER [PD_SLANG_S]; a_len: INTEGER_32): INTEGER_32
		local
			l_todo: INTEGER_32
			l_c: INTEGER_32
			l_atstart: INTEGER_32
			l_pat: CE_POINTER [NATURAL_8]
			l_pp: CE_POINTER [NATURAL_8]
			l_cp: CE_POINTER [NATURAL_8]
			l_ap___0: CE_POINTER [NATURAL_8]
			l_crp: CE_POINTER [NATURAL_8]
			l_cnt: CE_ARRAY [INTEGER_32]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___15: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_pat.make
			create l_pp.make
			create l_cp.make
			create l_ap___0.make
			create l_crp.make
			create l_cnt.make (<<1>>)
			create l_gap.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___7.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___14.make
			create l_tmp___16.make
			create l_tmp___17.make
			create l_tmp___18.make

			l_todo := a_len
			if l_todo < 2 then
				Result := (-2)
				js.return
			end
			if not js.return_called then
				l_todo := l_todo - 1
				l_c := IO_getc (a_fd)
				if l_c < 2 then
					l_c := 250
				end
				a_slang.item.sl_compmax := l_c
				l_todo := l_todo - 1
				l_c := IO_getc (a_fd)
				if l_c < 1 then
					l_c := 0
				end
				a_slang.item.sl_compminlen := l_c
				l_todo := l_todo - 1
				l_c := IO_getc (a_fd)
				if l_c < 1 then
					l_c := 250
				end
				a_slang.item.sl_compsylmax := l_c
				l_c := IO_getc (a_fd)
				if l_c /= 0 then
					ungetc (l_c, a_fd).do_nothing
				else
					l_todo := l_todo - 1
					l_c := IO_getc (a_fd)
					l_todo := l_todo - 1
					a_slang.item.sl_compoptions := l_c
					l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_comppat"))
					l_c := misc2_inst.get2c (a_fd)
					l_todo := l_todo - (2)
					misc2_inst.ga_init2 (l_gap, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, l_c)
					if (misc2_inst.ga_grow (l_gap, l_c)) = 1 then
						from
						until
							js.loop_done
						loop
							l_c := l_c - 1
							if not (l_c >= 0) then
								js.break
							end
							if not js.loop_jumped then
								l_tmp := l_gap.item.ga_len
								l_gap.item.ga_len := (l_gap.item.ga_len) + 1
								create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_gap.item.ga_data)[l_tmp] := read_cnt_string (a_fd, 1, l_cnt)
								if l_cnt.item < 0 then
									Result := (l_cnt.item)
									js.return
								end
								if not js.return_called then
									l_todo := l_todo - (l_cnt.item + 1)
								end
							end
						end
					end
				end
			end
			if not js.return_called and then (l_todo < 0) then
				Result := (-2)
				js.return
			end
			if not js.return_called then
				l_c := l_todo * 2 + 7
				if globals_inst.enc_utf8.to_boolean then
					l_c := l_c + (l_todo * 2)
				end
				l_pat := misc2_inst.alloc (l_c.to_natural_32)
				if l_pat.is_void then
					Result := (-3)
					js.return
				end
			end
			if not js.return_called then
				l_cp := misc2_inst.alloc ((l_todo + 1).to_natural_32)
				if l_cp.is_void then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat))
					Result := (-3)
					js.return
				end
			end
			if not js.return_called then
				a_slang.item.sl_compstartflags := l_cp
				l_cp.item := (('%/0/').code).to_natural_8
				l_ap___0 := misc2_inst.alloc ((l_todo + 1).to_natural_32)
				if l_ap___0.is_void then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat))
					Result := (-3)
					js.return
				end
			end
			if not js.return_called then
				a_slang.item.sl_compallflags := l_ap___0
				l_ap___0.item := (('%/0/').code).to_natural_8
				l_crp := misc2_inst.alloc ((l_todo + 1).to_natural_32)
				a_slang.item.sl_comprules := l_crp
				l_pp := l_pat
				l_tmp___1 := l_pp
				l_pp := l_pp + 1
				l_tmp___1.item := (('^').code).to_natural_8
				l_tmp___2 := l_pp
				l_pp := l_pp + 1
				l_tmp___2.item := (('\').code).to_natural_8
				l_tmp___3 := l_pp
				l_pp := l_pp + 1
				l_tmp___3.item := (('(').code).to_natural_8
				l_atstart := 1
				from
				until
					js.loop_done
				loop
					l_tmp___15 := l_todo
					l_todo := l_todo - 1
					if not (l_tmp___15 > 0) then
						js.break
					end
					if not js.loop_jumped then
						l_c := IO_getc (a_fd)
						if l_c = -1 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat))
							Result := (-1)
							js.return
						end
						if not js.return_called then
							if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("+*[]/")), l_c)).is_void then
								if not (byte_in_str (a_slang.item.sl_compallflags, l_c)).to_boolean then
									l_tmp___4 := l_ap___0
									l_ap___0 := l_ap___0 + 1
									l_tmp___4.item := l_c.to_natural_8
									l_ap___0.item := (('%/0/').code).to_natural_8
								end
							end
							if l_atstart /= 0 then
								if l_c = 91 then
									l_atstart := 2
								elseif l_c = 93 then
									l_atstart := 0
								else
									if not (byte_in_str (a_slang.item.sl_compstartflags, l_c)).to_boolean then
										l_tmp___7 := l_cp
										l_cp := l_cp + 1
										l_tmp___7.item := l_c.to_natural_8
										l_cp.item := (('%/0/').code).to_natural_8
									end
									if l_atstart = 1 then
										l_atstart := 0
									end
								end
							end
							if not l_crp.is_void then
								if l_c = 43 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_slang.item.sl_comprules))
									a_slang.item.sl_comprules := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
									l_crp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								elseif l_c = 42 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_slang.item.sl_comprules))
									a_slang.item.sl_comprules := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
									l_crp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								else
									l_tmp___9 := l_crp
									l_crp := l_crp + 1
									l_tmp___9.item := l_c.to_natural_8
								end
							end
							if l_c = 47 then
								l_tmp___10 := l_pp
								l_pp := l_pp + 1
								l_tmp___10.item := (('\').code).to_natural_8
								l_tmp___11 := l_pp
								l_pp := l_pp + 1
								l_tmp___11.item := (('|').code).to_natural_8
								l_atstart := 1
							else
								if l_c = 43 then
									l_tmp___12 := l_pp
									l_pp := l_pp + 1
									l_tmp___12.item := (('\').code).to_natural_8
								elseif l_c = 126 then
									l_tmp___12 := l_pp
									l_pp := l_pp + 1
									l_tmp___12.item := (('\').code).to_natural_8
								end
								if globals_inst.enc_utf8.to_boolean then
									l_pp := l_pp + (globals_inst.mb_char2bytes.integer_32_item ([l_c, l_pp]))
								else
									l_tmp___14 := l_pp
									l_pp := l_pp + 1
									l_tmp___14.item := l_c.to_natural_8
								end
							end
						end
					end
				end
			end
			if not js.return_called then
				l_tmp___16 := l_pp
				l_pp := l_pp + 1
				l_tmp___16.item := (('\').code).to_natural_8
				l_tmp___17 := l_pp
				l_pp := l_pp + 1
				l_tmp___17.item := ((')').code).to_natural_8
				l_tmp___18 := l_pp
				l_pp := l_pp + 1
				l_tmp___18.item := (('$').code).to_natural_8
				l_pp.item := (('%/0/').code).to_natural_8
				if not l_crp.is_void then
					l_crp.item := (('%/0/').code).to_natural_8
				end
				a_slang.item.sl_compprog := regexp_inst.vim_regcomp (l_pat, 7)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat))
				if (a_slang.item.sl_compprog).is_void then
					Result := (-2)
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	read_prefcond_section (a_fd: CE_POINTER [SD_IO_FILE]; a_lp: CE_POINTER [PD_SLANG_S]): INTEGER_32
		local
			l_cnt: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_buf___6.make (<<251>>)
			create l_tmp___0.make

			l_cnt := misc2_inst.get2c (a_fd)
			if l_cnt <= 0 then
				Result := (-2)
				js.return
			end
			if not js.return_called then
				a_lp.item.sl_prefprog := create {CE_POINTER [CE_POINTER [PD_REGPROG_T]]}.make_cast ((misc2_inst.alloc_clear ({PLATFORM}.Pointer_bytes.to_natural_32 * l_cnt.to_natural_32)))
				if (a_lp.item.sl_prefprog).is_void then
					Result := (-3)
					js.return
				end
			end
			if not js.return_called then
				a_lp.item.sl_prefixcnt := l_cnt
				l_i___0 := 0
				from
				until
					not (not js.loop_done and then (l_i___0 < l_cnt))
				loop
					l_n := IO_getc (a_fd)
					if l_n < 0 then
						Result := (-2)
						js.return
					elseif l_n >= 250 then
						Result := (-2)
						js.return
					end
					if not js.return_called then
						if l_n > 0 then
							l_buf___6[0] := (('^').code).to_natural_8
							l_p___0 := l_buf___6 + 1
							from
							until
								js.loop_done
							loop
								l_tmp___2 := l_n
								l_n := l_n - 1
								if not (l_tmp___2 > 0) then
									js.break
								end
								if not js.loop_jumped then
									l_tmp___0 := l_p___0
									l_p___0 := l_p___0 + 1
									l_tmp___0.item := (IO_getc (a_fd)).to_natural_8
								end
							end
							l_p___0.item := (('%/0/').code).to_natural_8
							a_lp.item.sl_prefprog[l_i___0] := regexp_inst.vim_regcomp (l_buf___6, 3)
						end
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	read_region_section (a_fd: CE_POINTER [SD_IO_FILE]; a_lp: CE_POINTER [PD_SLANG_S]; a_len: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if a_len > 16 then
				Result := (-2)
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_len)
				loop
					a_lp.item.sl_regions[l_i___0] := (IO_getc (a_fd)).to_natural_8
					l_i___0 := l_i___0 + 1
				end
				a_lp.item.sl_regions[a_len] := (('%/0/').code).to_natural_8
				Result := 0
			end
		end

	read_rep_section (a_fd: CE_POINTER [SD_IO_FILE]; a_gap: CE_POINTER [PD_GROWARRAY]; a_first___0: CE_POINTER [INTEGER_16]): INTEGER_32
		local
			l_cnt: INTEGER_32
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_i___0: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_ftp.make
			create l_i___0.make (<<1>>)

			l_cnt := misc2_inst.get2c (a_fd)
			if l_cnt < 0 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if (misc2_inst.ga_grow (a_gap, l_cnt)) = 0 then
					Result := (-3)
					js.return
				end
			end
			if not js.return_called then
				from
				until
					not (not js.loop_done and then (a_gap.item.ga_len < l_cnt))
				loop
					l_ftp := create {CE_POINTER [PD_FROMTO_S]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len
					l_ftp.item.ft_from := read_cnt_string (a_fd, 1, l_i___0)
					if l_i___0.item < 0 then
						Result := (l_i___0.item)
						js.return
					end
					if not js.return_called and then (l_i___0.item = 0) then
						Result := (-2)
						js.return
					end
					if not js.return_called then
						l_ftp.item.ft_to := read_cnt_string (a_fd, 1, l_i___0)
						if l_i___0.item <= 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ftp.item.ft_from))
							if l_i___0.item < 0 then
								Result := (l_i___0.item)
								js.return
							end
							if not js.return_called then
								Result := (-2)
								js.return
							end
						end
					end
					if not js.return_called then
						a_gap.item.ga_len := (a_gap.item.ga_len) + 1
					end
				end
			end
			if not js.return_called then
				l_i___0.item := 0
				from
				until
					not (l_i___0.item < 256)
				loop
					a_first___0[l_i___0.item] := (-1).to_integer_16
					l_i___0.item := l_i___0.item + 1
				end
				l_i___0.item := 0
				from
				until
					not (l_i___0.item < a_gap.item.ga_len)
				loop
					l_ftp := create {CE_POINTER [PD_FROMTO_S]}.make_cast (a_gap.item.ga_data) + l_i___0.item
					if (a_first___0[((l_ftp.item.ft_from).item).to_integer_32]).to_integer_32 = -1 then
						a_first___0[((l_ftp.item.ft_from).item).to_integer_32] := (l_i___0.item).to_integer_16
					end
					l_i___0.item := l_i___0.item + 1
				end
				Result := 0
			end
		end

	read_sal_section (a_fd: CE_POINTER [SD_IO_FILE]; a_slang: CE_POINTER [PD_SLANG_S]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_cnt: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_ccnt: CE_ARRAY [INTEGER_32]
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_gap.make
			create l_smp.make
			create l_ccnt.make (<<1>>)
			create l_p___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___8.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := ('%/0/').code
					a_slang.item.sl_sofo := 0
					l_i___0 := IO_getc (a_fd)
					if ((l_i___0).bit_and (1)).to_boolean then
						a_slang.item.sl_followup := 1
					end
					if ((l_i___0).bit_and (2)).to_boolean then
						a_slang.item.sl_collapse := 1
					end
					if ((l_i___0).bit_and (4)).to_boolean then
						a_slang.item.sl_rem_accents := 1
					end
					l_cnt := misc2_inst.get2c (a_fd)
					if l_cnt < 0 then
						Result := (-1)
						js.return
					end
					if not js.return_called then
						l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sal"))
						misc2_inst.ga_init2 (l_gap, ((create {PD_SALITEM_S}.make).structure_size.to_natural_32).to_integer_32, 10)
						if (misc2_inst.ga_grow (l_gap, l_cnt + 1)) = 0 then
							Result := (-3)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not js.loop_done and then (l_gap.item.ga_len < l_cnt)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 2 then -- loop body:
						l_smp := create {CE_POINTER [PD_SALITEM_S]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len
						l_ccnt.item := IO_getc (a_fd)
						if l_ccnt.item < 0 then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_p___0 := misc2_inst.alloc ((l_ccnt.item + 2).to_natural_32)
							if l_p___0.is_void then
								Result := (-3)
								js.return
							end
						end
						if not js.return_called then
							l_smp.item.sm_lead := l_p___0
							l_i___0 := 0
							from
							until
								not (not js.loop_done and then (l_i___0 < l_ccnt.item))
							loop
								l_c := IO_getc (a_fd)
								if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("0123456789(-<^$")), l_c)).is_void then
									js.break
								end
								if not js.loop_jumped then
									l_tmp___1 := l_p___0
									l_p___0 := l_p___0 + 1
									l_tmp___1.item := l_c.to_natural_8
									l_i___0 := l_i___0 + 1
								end
							end
							l_smp.item.sm_leadlen := l_p___0.distance ((l_smp.item.sm_lead))
							l_tmp___2 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___2.item := (('%/0/').code).to_natural_8
							if l_c = 40 then
								l_smp.item.sm_oneof := l_p___0
								l_i___0 := l_i___0 + 1
								from
								until
									not (not js.loop_done and then (l_i___0 < l_ccnt.item))
								loop
									l_c := IO_getc (a_fd)
									if l_c = 41 then
										js.break
									end
									if not js.loop_jumped then
										l_tmp___3 := l_p___0
										l_p___0 := l_p___0 + 1
										l_tmp___3.item := l_c.to_natural_8
										l_i___0 := l_i___0 + 1
									end
								end
								l_tmp___4 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___4.item := (('%/0/').code).to_natural_8
								l_i___0 := l_i___0 + 1
								if l_i___0 < l_ccnt.item then
									l_c := IO_getc (a_fd)
								end
							else
								l_smp.item.sm_oneof := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
							l_smp.item.sm_rules := l_p___0
							if l_i___0 < l_ccnt.item then
								l_tmp___5 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___5.item := l_c.to_natural_8
							end
							l_i___0 := l_i___0 + 1
							from
							until
								not (l_i___0 < l_ccnt.item)
							loop
								l_tmp___6 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___6.item := (IO_getc (a_fd)).to_natural_8
								l_i___0 := l_i___0 + 1
							end
							l_tmp___8 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___8.item := (('%/0/').code).to_natural_8
							l_smp.item.sm_to := read_cnt_string (a_fd, 1, l_ccnt)
							if l_ccnt.item < 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_lead))
								Result := (l_ccnt.item)
								js.return
							end
						end
						if not (not js.return_called and then (globals_inst.has_mbyte.to_boolean)) then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						l_smp.item.sm_lead_w := mb_str2wide (l_smp.item.sm_lead)
						l_smp.item.sm_leadlen := mbyte_inst.mb_charlen (l_smp.item.sm_lead)
						if (l_smp.item.sm_oneof).is_void then
							l_smp.item.sm_oneof_w := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
						else
							l_smp.item.sm_oneof_w := mb_str2wide (l_smp.item.sm_oneof)
						end
						if (l_smp.item.sm_to).is_void then
							l_smp.item.sm_to_w := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
						else
							l_smp.item.sm_to_w := mb_str2wide (l_smp.item.sm_to)
						end
						if not ((l_smp.item.sm_lead_w).is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 6 then -- else:
						if not ((l_smp.item.sm_oneof_w).is_void) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not (l_smp.item.sm_oneof).is_void then
							l_pos := -1 + 11 -- goto _L
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 9 then -- else: | _L___0:
						if not ((l_smp.item.sm_to_w).is_void) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_smp.item.sm_to).is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_lead))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_to))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_lead_w))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_oneof_w))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_to_w))
						Result := (-3)
						js.return
				when 12 then -- if done | if done | if done | if done
						if not js.return_called then
							l_gap.item.ga_len := (l_gap.item.ga_len) + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done | if done
						if not js.return_called and then (l_gap.item.ga_len > 0) then
							l_smp := create {CE_POINTER [PD_SALITEM_S]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len
							l_p___0 := misc2_inst.alloc ({NATURAL_32} 1)
							if l_p___0.is_void then
								Result := (-3)
								js.return
							end
							if not js.return_called then
								l_p___0[0] := (('%/0/').code).to_natural_8
								l_smp.item.sm_lead := l_p___0
								l_smp.item.sm_leadlen := 0
								l_smp.item.sm_oneof := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								l_smp.item.sm_rules := l_p___0
								l_smp.item.sm_to := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								if globals_inst.has_mbyte.to_boolean then
									l_smp.item.sm_lead_w := mb_str2wide (l_smp.item.sm_lead)
									l_smp.item.sm_leadlen := 0
									l_smp.item.sm_oneof_w := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
									l_smp.item.sm_to_w := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
								end
								l_gap.item.ga_len := (l_gap.item.ga_len) + 1
							end
						end
						if not js.return_called then
							set_sal_first (a_slang)
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	read_sofo_section (a_fd: CE_POINTER [SD_IO_FILE]; a_slang: CE_POINTER [PD_SLANG_S]): INTEGER_32
		local
			l_cnt: CE_ARRAY [INTEGER_32]
			l_from: CE_POINTER [NATURAL_8]
			l_to: CE_POINTER [NATURAL_8]
			l_res: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cnt.make (<<1>>)
			create l_from.make
			create l_to.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_slang.item.sl_sofo := 1
					l_from := read_cnt_string (a_fd, 2, l_cnt)
					if l_cnt.item < 0 then
						Result := (l_cnt.item)
						js.return
					end
					if not js.return_called then
						l_to := read_cnt_string (a_fd, 2, l_cnt)
						if l_cnt.item < 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_from))
							Result := (l_cnt.item)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if l_from.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not l_to.is_void then
							l_res := set_sofo (a_slang, l_from, l_to)
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not l_from.is_void then
							l_res := -2
						elseif not l_to.is_void then
							l_res := -2
						else
							l_res := 0
						end
				when 5 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_from))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_to))
						Result := l_res
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_tree_node (a_fd: CE_POINTER [SD_IO_FILE]; a_byts: CE_POINTER [NATURAL_8]; a_idxs: CE_POINTER [INTEGER_32]; a_maxidx: INTEGER_32; a_startidx: INTEGER_32; a_prefixtree: INTEGER_32; a_maxprefcondnr: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_idx: INTEGER_32
			l_c: INTEGER_32
			l_c2: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx := a_startidx
					l_len := IO_getc (a_fd)
					if l_len <= 0 then
						Result := (-1)
						js.return
					end
					if not js.return_called and then (a_startidx + l_len >= a_maxidx) then
						Result := (-2)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_tmp := l_idx
						l_idx := l_idx + 1
						a_byts[l_tmp] := l_len.to_natural_8
						l_i___0 := 1
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_i___0 <= l_len)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						l_c := IO_getc (a_fd)
						if l_c < 0 then
							Result := (-1)
							js.return
						end
						if not (not js.return_called and then (l_c <= 3)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if l_c /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not a_prefixtree.to_boolean then
							a_idxs[l_idx] := 0
							l_c := 0
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_c /= 1 then
							if a_prefixtree.to_boolean then
								if l_c = 2 then
									l_c := ((IO_getc (a_fd))).bit_shift_left (24)
								else
									l_c := 0
								end
								l_c := (l_c).bit_or ((IO_getc (a_fd)))
								l_n := misc2_inst.get2c (a_fd)
								if l_n >= a_maxprefcondnr then
									Result := (-2)
									js.return
								end
								if not js.return_called then
									l_c := (l_c).bit_or (((l_n).bit_shift_left (8)))
								end
							else
								l_c2 := l_c
								l_c := IO_getc (a_fd)
								if l_c2 = 3 then
									l_c := (((IO_getc (a_fd))).bit_shift_left (8)) + l_c
								end
								if ((l_c).bit_and (1)).to_boolean then
									l_c := (((IO_getc (a_fd))).bit_shift_left (16)) + l_c
								end
								if ((l_c).bit_and (32)).to_boolean then
									l_c := (((IO_getc (a_fd))).bit_shift_left (24)) + l_c
								end
							end
							if not js.return_called then
								a_idxs[l_idx] := l_c
								l_c := 0
							end
						else
							l_n := misc2_inst.get3c (a_fd)
							if l_n < 0 then
								Result := (-2)
								js.return
							elseif l_n >= a_maxidx then
								Result := (-2)
								js.return
							end
							if not js.return_called then
								a_idxs[l_idx] := l_n + 134_217_728
								l_c := IO_getc (a_fd)
							end
						end
				when 8 then -- if done
						if not js.return_called then
							l_tmp___5 := l_idx
							l_idx := l_idx + 1
							a_byts[l_tmp___5] := l_c.to_natural_8
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done | if done
						if not js.return_called then
							l_i___0 := 1
							from
							until
								not (not js.loop_done and then (l_i___0 <= l_len))
							loop
								if (a_byts[(a_startidx + l_i___0)]).to_integer_32 /= 0 then
									if ((a_idxs[(a_startidx + l_i___0)]).bit_and (134_217_728)).to_boolean then
										a_idxs[(a_startidx + l_i___0)] := (a_idxs[(a_startidx + l_i___0)]).bit_and ((-134_217_729))
									else
										a_idxs[(a_startidx + l_i___0)] := l_idx
										l_idx := read_tree_node (a_fd, a_byts, a_idxs, a_maxidx, l_idx, a_prefixtree, a_maxprefcondnr)
										if l_idx < 0 then
											js.break
										end
									end
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							Result := l_idx
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	read_words_section (a_fd: CE_POINTER [SD_IO_FILE]; a_lp: CE_POINTER [PD_SLANG_S]; a_len: INTEGER_32): INTEGER_32
		local
			l_done___2: INTEGER_32
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_word: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
		do
			create l_word.make (<<250>>)

			l_done___2 := 0
			from
			until
				not (not js.loop_done and then (l_done___2 < a_len))
			loop
				l_i___0 := 0
				from
				until
					js.loop_done
				loop
					l_c := IO_getc (a_fd)
					if l_c = -1 then
						Result := (-1)
						js.return
					end
					if not js.return_called then
						l_word[l_i___0] := l_c.to_natural_8
						if (l_word[l_i___0]).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							if l_i___0 = 249 then
								Result := (-2)
								js.return
							end
							if not js.return_called then
								l_i___0 := l_i___0 + 1
							end
						end
					end
				end
				if not js.return_called then
					count_common_word (a_lp, l_word, -1, 10)
					l_done___2 := l_done___2 + (l_i___0 + 1)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	rep_compare (a_s1: CE_POINTER [ANY]; a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_p1: CE_POINTER [PD_FROMTO_S]
			l_p2: CE_POINTER [PD_FROMTO_S]
		do
			create l_p1.make
			create l_p2.make

			l_p1 := create {CE_POINTER [PD_FROMTO_S]}.make_cast (a_s1)
			l_p2 := create {CE_POINTER [PD_FROMTO_S]}.make_cast (a_s2)
			Result := (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p1.item.ft_from), create {CE_POINTER [INTEGER_8]}.make_cast (l_p2.item.ft_from)))
		end

	rep_compare_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rep_compare)
		end

	rescore_one (a_su: CE_POINTER [PD_SUGINFO_S]; a_stp: CE_POINTER [PD_SUGGEST_S])
		local
			l_slang: CE_POINTER [PD_SLANG_S]
			l_sal_badword: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_slang.make
			create l_sal_badword.make (<<250>>)
			create l_p___0.make

			l_slang := a_stp.item.st_slang
			if not l_slang.is_void then
				if l_slang.item.sl_sal.ga_len > 0 then
					if not (a_stp.item.st_had_bonus).to_boolean then
						if l_slang.is_equal (a_su.item.su_sallang) then
							l_p___0 := a_su.item.su_sal_badword
						else
							spell_soundfold (l_slang, a_su.item.su_fbadword, 1, l_sal_badword)
							l_p___0 := l_sal_badword
						end
						a_stp.item.st_altscore := stp_sal_score (a_stp, a_su, l_slang, l_p___0)
						if a_stp.item.st_altscore = 999_999 then
							a_stp.item.st_altscore := 288
						end
						a_stp.item.st_score := (3 * a_stp.item.st_score + a_stp.item.st_altscore) // 4
						a_stp.item.st_had_bonus := 1
					end
				end
			end
		end

	rescore_suggestions (a_su: CE_POINTER [PD_SUGINFO_S])
		local
			l_i___0: INTEGER_32
		do
			if not (a_su.item.su_sallang).is_void then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_su.item.su_ga.ga_len)
				loop
					rescore_one (a_su, create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_su.item.su_ga.ga_data) + l_i___0)
					l_i___0 := l_i___0 + 1
				end
			end
		end

	sal_to_bool (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), ce_string ("1"))) = 0 then
				l_tmp___1 := 1
			elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), ce_string ("true"))) = 0 then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	score_combine (a_su: CE_POINTER [PD_SUGINFO_S])
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_lp: CE_POINTER [PD_LANGP_S]
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_p___0: CE_POINTER [NATURAL_8]
			l_badsound: CE_ARRAY [NATURAL_8]
			l_round: INTEGER_32
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_ga.make (<<1>>)
			create l_gap.make
			create l_lp.make
			create l_stp.make
			create l_p___0.make
			create l_badsound.make (<<250>>)
			create l_slang.make

			l_slang := create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
			l_lpi := 0
			from
			until
				not (not js.loop_done and then (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len))
			loop
				l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
				if (l_lp.item.lp_slang).item.sl_sal.ga_len > 0 then
					l_slang := l_lp.item.lp_slang
					spell_soundfold (l_slang, a_su.item.su_fbadword, 1, l_badsound)
					l_i___0 := 0
					from
					until
						not (l_i___0 < a_su.item.su_ga.ga_len)
					loop
						l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_su.item.su_ga.ga_data) + l_i___0
						l_stp.item.st_altscore := stp_sal_score (l_stp, a_su, l_slang, l_badsound)
						if l_stp.item.st_altscore = 999_999 then
							l_stp.item.st_score := (l_stp.item.st_score * 3 + 288) // 4
						else
							l_stp.item.st_score := (l_stp.item.st_score * 3 + l_stp.item.st_altscore) // 4
						end
						l_stp.item.st_salscore := 0
						l_i___0 := l_i___0 + 1
					end
					js.break
				end
				if not js.loop_jumped then
					l_lpi := l_lpi + 1
				end
			end
			if l_slang.is_void then
				cleanup_suggestions (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), a_su.item.su_maxscore, a_su.item.su_maxcount).do_nothing
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_su.item.su_sga.ga_len)
				loop
					l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_su.item.su_sga.ga_data) + l_i___0
					l_stp.item.st_altscore := spell_edit_score (l_slang, a_su.item.su_badword, l_stp.item.st_word)
					if l_stp.item.st_score = 999_999 then
						l_stp.item.st_score := (2_016 + l_stp.item.st_altscore) // 8
					else
						l_stp.item.st_score := (l_stp.item.st_score * 7 + l_stp.item.st_altscore) // 8
					end
					l_stp.item.st_salscore := 1
					l_i___0 := l_i___0 + 1
				end
				check_suggestions (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")))
				cleanup_suggestions (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), a_su.item.su_maxscore, a_su.item.su_maxcount).do_nothing
				check_suggestions (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga")))
				cleanup_suggestions (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga")), a_su.item.su_maxscore, a_su.item.su_maxcount).do_nothing
				misc2_inst.ga_init2 (l_ga, ((create {PD_SUGINFO_S}.make).structure_size.to_natural_32).to_integer_32, 1)
				if (misc2_inst.ga_grow (l_ga, a_su.item.su_ga.ga_len + a_su.item.su_sga.ga_len)) = 0 then
					js.return
				end
			end
			if not js.return_called then
				l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (l_ga.item.ga_data) + 0
				l_i___0 := 0
				from
				until
					js.loop_done
				loop
					if not (l_i___0 < a_su.item.su_ga.ga_len) then
						if not (l_i___0 < a_su.item.su_sga.ga_len) then
							js.break
						end
					end
					if not js.loop_jumped then
						l_round := 1
						from
						until
							not (not js.loop_done and then (l_round <= 2))
						loop
							if l_round = 1 then
								l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))
							else
								l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga"))
							end
							if l_i___0 < l_gap.item.ga_len then
								l_p___0 := (create {CE_POINTER [PD_SUGGEST_S]}.make_cast (l_gap.item.ga_data) + l_i___0).item.st_word
								l_j := 0
								from
								until
									not (not js.loop_done and then (l_j < l_ga.item.ga_len))
								loop
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_stp + l_j).item.st_word), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) = 0 then
										js.break
									end
									if not js.loop_jumped then
										l_j := l_j + 1
									end
								end
								if l_j = l_ga.item.ga_len then
									l_tmp___1 := l_ga.item.ga_len
									l_ga.item.ga_len := (l_ga.item.ga_len) + 1
									l_stp[l_tmp___1] := (create {CE_POINTER [PD_SUGGEST_S]}.make_cast (l_gap.item.ga_data)[l_i___0]).twin
								else
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								end
							end
							l_round := l_round + 1
						end
						l_i___0 := l_i___0 + 1
					end
				end
				misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")))
				misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga")))
				if l_ga.item.ga_len > a_su.item.su_maxcount then
					l_i___0 := a_su.item.su_maxcount
					from
					until
						not (l_i___0 < l_ga.item.ga_len)
					loop
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_stp + l_i___0).item.st_word))
						l_i___0 := l_i___0 + 1
					end
					l_ga.item.ga_len := a_su.item.su_maxcount
				end
				a_su.item.su_ga := (l_ga.item).twin
			end
		end

	score_comp_sal (a_su: CE_POINTER [PD_SUGINFO_S])
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_badsound: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_sstp: CE_POINTER [PD_SUGGEST_S]
			l_score: INTEGER_32
			l_lpi: INTEGER_32
			js: JUMP_STATE
		do
			create l_lp.make
			create l_badsound.make (<<250>>)
			create l_stp.make
			create l_sstp.make

			if (misc2_inst.ga_grow (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga")), a_su.item.su_ga.ga_len)) = 0 then
				js.return
			end
			if not js.return_called then
				l_lpi := 0
				from
				until
					not (not js.loop_done and then (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len))
				loop
					l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
					if (l_lp.item.lp_slang).item.sl_sal.ga_len > 0 then
						spell_soundfold (l_lp.item.lp_slang, a_su.item.su_fbadword, 1, l_badsound)
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_su.item.su_ga.ga_len)
						loop
							l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_su.item.su_ga.ga_data) + l_i___0
							l_score := stp_sal_score (l_stp, a_su, l_lp.item.lp_slang, l_badsound)
							if l_score < 999_999 then
								l_sstp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_su.item.su_sga.ga_data) + a_su.item.su_sga.ga_len
								l_sstp.item.st_word := misc2_inst.vim_strsave (l_stp.item.st_word)
								if not (l_sstp.item.st_word).is_void then
									l_sstp.item.st_wordlen := l_stp.item.st_wordlen
									l_sstp.item.st_score := l_score
									l_sstp.item.st_altscore := 0
									l_sstp.item.st_orglen := l_stp.item.st_orglen
									a_su.item.su_sga.ga_len := (a_su.item.su_sga.ga_len) + 1
								end
							end
							l_i___0 := l_i___0 + 1
						end
						js.break
					end
					if not js.loop_jumped then
						l_lpi := l_lpi + 1
					end
				end
			end
		end

	score_wordcount_adj (a_slang: CE_POINTER [PD_SLANG_S]; a_score: INTEGER_32; a_word: CE_POINTER [NATURAL_8]; a_split: INTEGER_32): INTEGER_32
		local
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_wc: CE_POINTER [PD_WORDCOUNT_S]
			l_bonus: INTEGER_32
			l_newscore: INTEGER_32
			js: JUMP_STATE
		do
			create l_hi___1.make
			create l_wc.make

			l_hi___1 := hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount")), a_word)
			if not ((l_hi___1.item.hi_key).is_void) then
				if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
					l_wc := create {CE_POINTER [PD_WORDCOUNT_S]}.make_cast ((l_hi___1.item.hi_key - (((dumwc.item.wc_word).distance ((create {CE_POINTER [NATURAL_8]}.make_cast (dumwc)))).to_natural_32).to_integer_32))
					if (l_wc.item.wc_count).to_integer_32 < 10 then
						l_bonus := 30
					elseif (l_wc.item.wc_count).to_integer_32 < 100 then
						l_bonus := 40
					else
						l_bonus := 50
					end
					if a_split.to_boolean then
						l_newscore := a_score - l_bonus // 2
					else
						l_newscore := a_score - l_bonus
					end
					if l_newscore < 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						Result := l_newscore
						js.return
					end
				end
			end
			if not js.return_called then
				Result := a_score
			end
		end

	set_map_str (a_lp: CE_POINTER [PD_SLANG_S]; a_map: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_headc: INTEGER_32
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_cl: INTEGER_32
			l_headcl: INTEGER_32
			l_b: CE_POINTER [NATURAL_8]
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			js: JUMP_STATE
		do
			create l_p___0.make (<<1>>)
			create l_b.make
			create l_hi___1.make

			l_headc := 0
			if (a_map.item).to_integer_32 = 0 then
				a_lp.item.sl_has_map := 0
				js.return
			end
			if not js.return_called then
				a_lp.item.sl_has_map := 1
				l_i___0 := 0
				from
				until
					not (l_i___0 < 256)
				loop
					a_lp.item.sl_map_array[l_i___0] := 0
					l_i___0 := l_i___0 + 1
				end
				hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash")))
				l_p___0.item := a_map
				from
				until
					not (not js.loop_done and then ((l_p___0.item.item).to_integer_32 /= 0))
				loop
					l_c := mbyte_inst.mb_cptr2char_adv (l_p___0)
					if l_c = 47 then
						l_headc := 0
					else
						if l_headc = 0 then
							l_headc := l_c
						end
						if l_c >= 256 then
							l_cl := (globals_inst.mb_char2len.integer_32_item ([l_c]))
							l_headcl := (globals_inst.mb_char2len.integer_32_item ([l_headc]))
							l_b := misc2_inst.alloc (((l_cl + l_headcl) + 2).to_natural_32)
							if l_b.is_void then
								js.return
							end
							if not js.return_called then
								globals_inst.mb_char2bytes.call ([l_c, l_b])
								l_b[l_cl] := (('%/0/').code).to_natural_8
								globals_inst.mb_char2bytes.call ([l_headc, (l_b + l_cl) + 1])
								l_b[((l_cl + 1) + l_headcl)] := (('%/0/').code).to_natural_8
								l_hash := hashtab_inst.hash_hash (l_b)
								l_hi___1 := hashtab_inst.hash_lookup (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash")), l_b, l_hash)
								if (l_hi___1.item.hi_key).is_void then
									hashtab_inst.hash_add_item (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash")), l_hi___1, l_b, l_hash).do_nothing
								elseif (l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed) then
									hashtab_inst.hash_add_item (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash")), l_hi___1, l_b, l_hash).do_nothing
								else
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E783: duplicate char in MAP entry"))))).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_b))
								end
							end
						else
							a_lp.item.sl_map_array[l_c] := l_headc
						end
					end
				end
			end
			if not js.return_called then
			end
		end

	set_sal_first (a_lp: CE_POINTER [PD_SLANG_S])
		local
			l_sfirst: CE_POINTER [INTEGER_32]
			l_i___0: INTEGER_32
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_c: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_n: INTEGER_32
			l_tsal: PD_SALITEM_S
			js: JUMP_STATE
		do
			create l_sfirst.make
			create l_smp.make
			create l_gap.make
			create l_tsal.make

			l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sal"))
			l_sfirst := a_lp.item.sl_sal_first
			l_i___0 := 0
			from
			until
				not (l_i___0 < 256)
			loop
				l_sfirst[l_i___0] := -1
				l_i___0 := l_i___0 + 1
			end
			l_smp := create {CE_POINTER [PD_SALITEM_S]}.make_cast (l_gap.item.ga_data)
			l_i___0 := 0
			from
			until
				not (not js.loop_done and then (l_i___0 < l_gap.item.ga_len))
			loop
				if globals_inst.has_mbyte.to_boolean then
					l_c := (((l_smp + l_i___0).item.sm_lead_w).item).bit_and (255)
				else
					l_c := (((l_smp + l_i___0).item.sm_lead).item).to_integer_32
				end
				if l_sfirst[l_c] = -1 then
					l_sfirst[l_c] := l_i___0
					if globals_inst.has_mbyte.to_boolean then
						from
						until
							js.loop_done
						loop
							if l_i___0 + 1 < l_gap.item.ga_len then
								if ((((l_smp + (l_i___0 + 1)).item.sm_lead_w).item).bit_and (255)) /= l_c then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						l_n := 1
						from
						until
							not (l_i___0 + l_n < l_gap.item.ga_len)
						loop
							if ((((l_smp + (l_i___0 + l_n)).item.sm_lead_w).item).bit_and (255)) = l_c then
								l_i___0 := l_i___0 + 1
								l_n := l_n - 1
								l_tsal := (l_smp[(l_i___0 + l_n)]).twin
								memmove (create {CE_POINTER [ANY]}.make_cast (((l_smp + l_i___0) + 1)), create {CE_POINTER [ANY]}.make_cast ((l_smp + l_i___0)), (create {PD_SALITEM_S}.make).structure_size.to_natural_32 * l_n.to_natural_32).do_nothing
								l_smp[l_i___0] := l_tsal.twin
							end
							l_n := l_n + 1
						end
					end
				end
				l_i___0 := l_i___0 + 1
			end
		end

	set_sofo (a_lp: CE_POINTER [PD_SLANG_S]; a_from: CE_POINTER [NATURAL_8]; a_to: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_inp: CE_POINTER [INTEGER_32]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_32]
			l_tmp___5: CE_POINTER [INTEGER_32]
			l_tmp___6: CE_POINTER [INTEGER_32]
			l_tmp___7: NATURAL_32
			js: JUMP_STATE
		do
			create l_gap.make
			create l_s.make (<<1>>)
			create l_p___0.make (<<1>>)
			create l_inp.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make

			if globals_inst.has_mbyte.to_boolean then
				l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sal"))
				misc2_inst.ga_init2 (l_gap, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 1)
				if (misc2_inst.ga_grow (l_gap, 256)) = 0 then
					Result := (-3)
					js.return
				end
				if not js.return_called then
					memset (l_gap.item.ga_data, 0, {PLATFORM}.Pointer_bytes.to_natural_32 * {NATURAL_32} 256).do_nothing
					l_gap.item.ga_len := 256
					l_p___0.item := a_from
					l_s.item := a_to
					from
					until
						js.loop_done
					loop
						if (l_p___0.item.item).to_integer_32 /= 0 then
							if (l_s.item.item).to_integer_32 = 0 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_c := mbyte_inst.mb_cptr2char_adv (l_p___0)
							if globals_inst.enc_utf8.to_boolean then
								l_tmp___3 := (mbyte_inst.utf_ptr2len (l_s.item))
							else
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___2 := (globals_inst.mb_ptr2len.integer_32_item ([l_s.item]))
								else
									l_tmp___2 := 1
								end
								l_tmp___3 := l_tmp___2
							end
							l_s.item := l_s.item + l_tmp___3
							if l_c >= 256 then
								a_lp.item.sl_sal_first[(l_c).bit_and (255)] := (a_lp.item.sl_sal_first[(l_c).bit_and (255)]) + 1
							end
						end
					end
					if (l_p___0.item.item).to_integer_32 /= 0 then
						Result := (-2)
						js.return
					elseif (l_s.item.item).to_integer_32 /= 0 then
						Result := (-2)
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := 0
					from
					until
						not (not js.loop_done and then (l_i___0 < 256))
					loop
						if a_lp.item.sl_sal_first[l_i___0] > 0 then
							l_p___0.item := misc2_inst.alloc ({PLATFORM}.Integer_32_bytes.to_natural_32 * (a_lp.item.sl_sal_first[l_i___0] * 2 + 1).to_natural_32)
							if (l_p___0.item).is_void then
								Result := (-3)
								js.return
							end
							if not js.return_called then
								create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_cast (l_gap.item.ga_data)[l_i___0] := create {CE_POINTER [INTEGER_32]}.make_cast (l_p___0.item);
								(create {CE_POINTER [INTEGER_32]}.make_cast (l_p___0.item)).item := 0
							end
						end
						if not js.return_called then
							l_i___0 := l_i___0 + 1
						end
					end
				end
				if not js.return_called then
					memset (create {CE_POINTER [ANY]}.make_cast ((a_lp.item.sl_sal_first)), 0, {PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 256).do_nothing
					l_p___0.item := a_from
					l_s.item := a_to
					from
					until
						js.loop_done
					loop
						if (l_p___0.item.item).to_integer_32 /= 0 then
							if (l_s.item.item).to_integer_32 = 0 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_c := mbyte_inst.mb_cptr2char_adv (l_p___0)
							l_i___0 := mbyte_inst.mb_cptr2char_adv (l_s)
							if l_c >= 256 then
								l_inp := create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_cast (l_gap.item.ga_data)[((l_c).bit_and (255))]
								from
								until
									l_inp.item = 0
								loop
									l_inp := l_inp + 1
								end
								l_tmp___4 := l_inp
								l_inp := l_inp + 1
								l_tmp___4.item := l_c
								l_tmp___5 := l_inp
								l_inp := l_inp + 1
								l_tmp___5.item := l_i___0
								l_tmp___6 := l_inp
								l_inp := l_inp + 1
								l_tmp___6.item := ('%/0/').code
							else
								a_lp.item.sl_sal_first[l_c] := l_i___0
							end
						end
					end
				end
			else
				l_tmp___7 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_from))
				if l_tmp___7 /= (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_to))) then
					Result := (-2)
					js.return
				end
				if not js.return_called then
					l_i___0 := 0
					from
					until
						(a_to[l_i___0]).to_integer_32 = 0
					loop
						a_lp.item.sl_sal_first[(a_from[l_i___0]).to_integer_32] := (a_to[l_i___0]).to_integer_32
						l_i___0 := l_i___0 + 1
					end
					a_lp.item.sl_sal.ga_len := 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	set_spell_charflags (a_flags___0: CE_POINTER [NATURAL_8]; a_cnt: INTEGER_32; a_fol: CE_POINTER [NATURAL_8])
		local
			l_new_st: CE_ARRAY [PD_SPELLTAB_S]
			l_i___0: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
		do
			create l_new_st.make (<<1>>)
			create l_p___0.make (<<1>>)

			l_p___0.item := a_fol
			clear_spell_chartab (l_new_st)
			l_i___0 := 0
			from
			until
				not (l_i___0 < 128)
			loop
				if l_i___0 < a_cnt then
					l_new_st.item.st_isw[l_i___0 + 128] := ((((a_flags___0[l_i___0]).to_integer_32).bit_and (1)) /= 0).to_integer.to_natural_8
					l_new_st.item.st_isu[l_i___0 + 128] := ((((a_flags___0[l_i___0]).to_integer_32).bit_and (2)) /= 0).to_integer.to_natural_8
				end
				if (l_p___0.item.item).to_integer_32 /= 0 then
					l_c := mbyte_inst.mb_ptr2char_adv (l_p___0)
					l_new_st.item.st_fold[l_i___0 + 128] := l_c.to_natural_8
					if l_i___0 + 128 /= l_c then
						if (l_new_st.item.st_isu[l_i___0 + 128]).to_boolean then
							if l_c < 256 then
								l_new_st.item.st_upper[l_c] := (l_i___0 + 128).to_natural_8
							end
						end
					end
				end
				l_i___0 := l_i___0 + 1
			end
			set_spell_finish (l_new_st).do_nothing
		end

	set_spell_chartab (a_fol: CE_POINTER [NATURAL_8]; a_low: CE_POINTER [NATURAL_8]; a_upp: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_new_st: CE_ARRAY [PD_SPELLTAB_S]
			l_pf: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pl: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pu: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_f: INTEGER_32
			l_l: INTEGER_32
			l_u: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_new_st.make (<<1>>)
			create l_pf.make (<<1>>)
			create l_pl.make (<<1>>)
			create l_pu.make (<<1>>)
			create l_tmp.make
			create l_tmp___2.make

			l_pf.item := a_fol
			l_pl.item := a_low
			l_pu.item := a_upp
			clear_spell_chartab (l_new_st)
			from
			until
				not (not js.loop_done and then ((l_pf.item.item).to_integer_32 /= 0))
			loop
				if (l_pl.item.item).to_integer_32 = 0 then
					l_tmp := gettext (e_affform)
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
					Result := 0
					js.return
				elseif (l_pu.item.item).to_integer_32 = 0 then
					l_tmp := gettext (e_affform)
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
					Result := 0
					js.return
				end
				if not js.return_called then
					l_f := mbyte_inst.mb_ptr2char_adv (l_pf)
					l_l := mbyte_inst.mb_ptr2char_adv (l_pl)
					l_u := mbyte_inst.mb_ptr2char_adv (l_pu)
					if l_f < 256 then
						l_new_st.item.st_isw[l_f] := (1).to_natural_8
					end
					if l_l < 256 then
						l_new_st.item.st_isw[l_l] := (1).to_natural_8
					end
					if l_u < 256 then
						l_new_st.item.st_isw[l_u] := (1).to_natural_8
					end
					if l_l < 256 then
						if l_l /= l_f then
							if l_f >= 256 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_affrange)))).do_nothing
								Result := 0
								js.return
							end
							if not js.return_called then
								l_new_st.item.st_fold[l_l] := l_f.to_natural_8
							end
						end
					end
				end
				if not js.return_called and then (l_u < 256) then
					if l_u /= l_f then
						if l_f >= 256 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_affrange)))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							l_new_st.item.st_fold[l_u] := l_f.to_natural_8
							l_new_st.item.st_isu[l_u] := (1).to_natural_8
							l_new_st.item.st_upper[l_f] := l_u.to_natural_8
						end
					end
				end
			end
			if not js.return_called then
				if (l_pl.item.item).to_integer_32 /= 0 then
					l_tmp___2 := gettext (e_affform)
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___2)).do_nothing
					Result := 0
					js.return
				elseif (l_pu.item.item).to_integer_32 /= 0 then
					l_tmp___2 := gettext (e_affform)
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___2)).do_nothing
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (set_spell_finish (l_new_st))
			end
		end

	set_spell_finish (a_new_st: CE_POINTER [PD_SPELLTAB_S]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			if did_set_spelltab.to_boolean then
				l_i___0 := 0
				from
				until
					not (not js.loop_done and then (l_i___0 < 256))
				loop
					if (spelltab.item.st_isw[l_i___0]).to_integer_32 /= (a_new_st.item.st_isw[l_i___0]).to_integer_32 then
						l_tmp := gettext (ce_string ("E763: Word characters differ between spell files"))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						Result := 0
						js.return
					elseif (spelltab.item.st_isu[l_i___0]).to_integer_32 /= (a_new_st.item.st_isu[l_i___0]).to_integer_32 then
						l_tmp := gettext (ce_string ("E763: Word characters differ between spell files"))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						Result := 0
						js.return
					elseif (spelltab.item.st_fold[l_i___0]).to_integer_32 /= (a_new_st.item.st_fold[l_i___0]).to_integer_32 then
						l_tmp := gettext (ce_string ("E763: Word characters differ between spell files"))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						Result := 0
						js.return
					elseif (spelltab.item.st_upper[l_i___0]).to_integer_32 /= (a_new_st.item.st_upper[l_i___0]).to_integer_32 then
						l_tmp := gettext (ce_string ("E763: Word characters differ between spell files"))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						Result := 0
						js.return
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			else
				spelltab.item := (a_new_st.item).twin
				did_set_spelltab := 1
			end
			if not js.return_called then
				Result := 1
			end
		end

	similar_chars (a_slang: CE_POINTER [PD_SLANG_S]; a_c1: INTEGER_32; a_c2: INTEGER_32): INTEGER_32
		local
			l_m1: INTEGER_32
			l_m2: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			js: JUMP_STATE
		do
			create l_buf___6.make (<<21>>)
			create l_hi___1.make

			if a_c1 >= 256 then
				l_buf___6[(globals_inst.mb_char2bytes.integer_32_item ([a_c1, l_buf___6]))] := (0).to_natural_8
				l_hi___1 := hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash")), l_buf___6)
				if (l_hi___1.item.hi_key).is_void then
					l_m1 := 0
				elseif (l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed) then
					l_m1 := 0
				else
					l_m1 := globals_inst.mb_ptr2char.integer_32_item ([(l_hi___1.item.hi_key + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_hi___1.item.hi_key))).to_integer_32) + 1])
				end
			else
				l_m1 := a_slang.item.sl_map_array[a_c1]
			end
			if l_m1 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if a_c2 >= 256 then
					l_buf___6[(globals_inst.mb_char2bytes.integer_32_item ([a_c2, l_buf___6]))] := (0).to_natural_8
					l_hi___1 := hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash")), l_buf___6)
					if (l_hi___1.item.hi_key).is_void then
						l_m2 := 0
					elseif (l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed) then
						l_m2 := 0
					else
						l_m2 := globals_inst.mb_ptr2char.integer_32_item ([(l_hi___1.item.hi_key + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_hi___1.item.hi_key))).to_integer_32) + 1])
					end
				else
					l_m2 := a_slang.item.sl_map_array[a_c2]
				end
				Result := (l_m1 = l_m2).to_integer
			end
		end

	slang_alloc (a_lang: CE_POINTER [NATURAL_8]): CE_POINTER [PD_SLANG_S]
		local
			l_lp: CE_POINTER [PD_SLANG_S]
		do
			create l_lp.make

			l_lp := create {CE_POINTER [PD_SLANG_S]}.make_cast ((misc2_inst.alloc_clear ((create {PD_SLANG_S}.make).structure_size.to_natural_32)))
			if not l_lp.is_void then
				if not a_lang.is_void then
					l_lp.item.sl_name := misc2_inst.vim_strsave (a_lang)
				end
				misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep")), ((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 10)
				misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal")), ((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 10)
				l_lp.item.sl_compmax := 250
				l_lp.item.sl_compsylmax := 250
				hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount")))
			end
			Result := l_lp
		end

	slang_clear (a_lp: CE_POINTER [PD_SLANG_S])
		local
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_i___0: INTEGER_32
			l_round: INTEGER_32
			js: JUMP_STATE
		do
			create l_gap.make
			create l_ftp.make
			create l_smp.make

			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_fbyts))
			a_lp.item.sl_fbyts := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_kbyts))
			a_lp.item.sl_kbyts := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_pbyts))
			a_lp.item.sl_pbyts := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_fidxs))
			a_lp.item.sl_fidxs := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_kidxs))
			a_lp.item.sl_kidxs := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_pidxs))
			a_lp.item.sl_pidxs := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_round := 1
			from
			until
				not (not js.loop_done and then (l_round <= 2))
			loop
				if l_round = 1 then
					l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep"))
				else
					l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal"))
				end
				from
				until
					not (l_gap.item.ga_len > 0)
				loop
					l_gap.item.ga_len := (l_gap.item.ga_len) - 1
					l_ftp := create {CE_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ftp.item.ft_from))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ftp.item.ft_to))
				end
				misc2_inst.ga_clear (l_gap)
				l_round := l_round + 1
			end
			l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sal"))
			if (a_lp.item.sl_sofo).to_boolean then
				if not (l_gap.item.ga_data).is_void then
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_gap.item.ga_len)
					loop
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_cast (l_gap.item.ga_data)[l_i___0]))
						l_i___0 := l_i___0 + 1
					end
				end
			else
				from
				until
					not (l_gap.item.ga_len > 0)
				loop
					l_gap.item.ga_len := (l_gap.item.ga_len) - 1
					l_smp := create {CE_POINTER [PD_SALITEM_S]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_lead))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_to))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_lead_w))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_oneof_w))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_smp.item.sm_to_w))
				end
			end
			misc2_inst.ga_clear (l_gap)
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_lp.item.sl_prefixcnt)
			loop
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_prefprog[l_i___0]))
				l_i___0 := l_i___0 + 1
			end
			a_lp.item.sl_prefixcnt := 0
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_prefprog))
			a_lp.item.sl_prefprog := create {CE_POINTER [CE_POINTER [PD_REGPROG_T]]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_info))
			a_lp.item.sl_info := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_midword))
			a_lp.item.sl_midword := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_compprog))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_comprules))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_compstartflags))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_compallflags))
			a_lp.item.sl_compprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			a_lp.item.sl_comprules := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_lp.item.sl_compstartflags := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_lp.item.sl_compallflags := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_syllable))
			a_lp.item.sl_syllable := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_syl_items")))
			misc2_inst.ga_clear_strings (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_comppat")))
			hashtab_inst.hash_clear_all (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount")), (((dumwc.item.wc_word).distance ((create {CE_POINTER [NATURAL_8]}.make_cast (dumwc)))).to_natural_32).to_integer_32)
			hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount")))
			hashtab_inst.hash_clear_all (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash")), 0)
			slang_clear_sug (a_lp)
			a_lp.item.sl_compmax := 250
			a_lp.item.sl_compminlen := 0
			a_lp.item.sl_compsylmax := 250
			a_lp.item.sl_regions[0] := (('%/0/').code).to_natural_8
		end

	slang_clear_sug (a_lp: CE_POINTER [PD_SLANG_S])
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_sbyts))
			a_lp.item.sl_sbyts := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_sidxs))
			a_lp.item.sl_sidxs := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			close_spellbuf (a_lp.item.sl_sugbuf)
			a_lp.item.sl_sugbuf := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
			a_lp.item.sl_sugloaded := 0
			a_lp.item.sl_sugtime := (0).to_integer_32
		end

	slang_free (a_lp: CE_POINTER [PD_SLANG_S])
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_name))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp.item.sl_fname))
			slang_clear (a_lp)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_lp))
		end

	soundalike_score (a_goodstart: CE_POINTER [NATURAL_8]; a_badstart: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_goodsound: CE_POINTER [NATURAL_8]
			l_badsound: CE_POINTER [NATURAL_8]
			l_goodlen: INTEGER_32
			l_badlen: INTEGER_32
			l_n: INTEGER_32
			l_pl: CE_POINTER [NATURAL_8]
			l_ps: CE_POINTER [NATURAL_8]
			l_pl2: CE_POINTER [NATURAL_8]
			l_ps2: CE_POINTER [NATURAL_8]
			l_score: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_goodsound.make
			create l_badsound.make
			create l_pl.make
			create l_ps.make
			create l_pl2.make
			create l_ps2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_goodsound := a_goodstart
					l_badsound := a_badstart
					l_score := 0
					if (l_badsound.item).to_integer_32 /= 42 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___2
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 3 then -- else:
						if (l_goodsound.item).to_integer_32 /= 42 then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if: | _L___2:
						if (l_badsound.item).to_integer_32 = (l_goodsound.item).to_integer_32 then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						if (l_badsound[0]).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_goodsound[1]).to_integer_32 = 0 then
							Result := 94
							js.return
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if (l_goodsound[0]).to_integer_32 = 0 then
							if (l_badsound[1]).to_integer_32 = 0 then
								Result := 94
								js.return
							end
						end
				when 9 then
						if not js.return_called then
							if (l_badsound[0]).to_integer_32 = 0 then
								Result := 999_999
								js.return
							elseif (l_goodsound[0]).to_integer_32 = 0 then
								Result := 999_999
								js.return
							end
						end
						if not (not js.return_called and then ((l_badsound[1]).to_integer_32 /= (l_goodsound[1]).to_integer_32)) then
							l_pos := -1 + 14 -- skip if block
						end
				when 10 then -- if:
						if (l_badsound[1]).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (l_goodsound[1]).to_integer_32 /= 0 then
							if (l_badsound[2]).to_integer_32 /= (l_goodsound[2]).to_integer_32 then
								l_pos := -1 + 13 -- goto _L___1
							end
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___1:
						l_score := 62
						if (l_badsound.item).to_integer_32 = 42 then
							l_badsound := l_badsound + 1
						else
							l_goodsound := l_goodsound + 1
						end
				when 14 then -- if done | if done | if done | if done
						if not js.return_called then
							l_goodlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_goodsound))).to_integer_32
							l_badlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_badsound))).to_integer_32
							l_n := l_goodlen - l_badlen
							if l_n < -2 then
								Result := 999_999
								js.return
							elseif l_n > 2 then
								Result := 999_999
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
							if l_n > 0 then
								l_pl := l_goodsound
								l_ps := l_badsound
							else
								l_pl := l_badsound
								l_ps := l_goodsound
							end
							from
							until
								js.loop_done
							loop
								if (l_pl.item).to_integer_32 = (l_ps.item).to_integer_32 then
									if (l_pl.item).to_integer_32 = 0 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_pl := l_pl + 1
									l_ps := l_ps + 1
								end
							end
							inspect l_n -- switch 1 head
							when -2 then l_pos := -1 + 16 -- -2
							when 2 then l_pos := -1 + 16
							when -1 then l_pos := -1 + 17 -- -1
							when 1 then l_pos := -1 + 17
							when 0 then l_pos := -1 + 18
							else l_pos := -1 + 19
							end
				when 16 then -- switch 1, case -2 | switch 1, case 2
							l_pl := l_pl + 1
							from
							until
								(l_pl.item).to_integer_32 /= (l_ps.item).to_integer_32
							loop
								l_pl := l_pl + 1
								l_ps := l_ps + 1
							end
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_ps))) = 0 then
								Result := (l_score + 188)
								js.return
							end
							l_pos := -1 + 19 -- switch 1; break
				when 17 then -- switch 1, case -1 | switch 1, case 1
							l_pl2 := l_pl + 1
							l_ps2 := l_ps
							from
							until
								not (not js.loop_done and then ((l_pl2.item).to_integer_32 = (l_ps2.item).to_integer_32))
							loop
								if (l_pl2.item).to_integer_32 = 0 then
									Result := (l_score + 94)
									js.return
								end
								if not js.return_called then
									l_pl2 := l_pl2 + 1
									l_ps2 := l_ps2 + 1
								end
							end
							if not js.return_called and then ((l_pl2[0]).to_integer_32 = (l_ps2[1]).to_integer_32) then
								if (l_pl2[1]).to_integer_32 = (l_ps2[0]).to_integer_32 then
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl2 + 2)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_ps2 + 2)))) = 0 then
										Result := ((l_score + 94) + 75)
										js.return
									end
								end
							end
							if not js.return_called then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl2 + 1)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_ps2 + 1)))) = 0 then
									Result := ((l_score + 94) + 93)
									js.return
								end
							end
							if not js.return_called and then ((l_pl[0]).to_integer_32 = (l_ps[1]).to_integer_32) then
								if (l_pl[1]).to_integer_32 = (l_ps[0]).to_integer_32 then
									l_pl2 := l_pl + 2
									l_ps2 := l_ps + 2
									from
									until
										(l_pl2.item).to_integer_32 /= (l_ps2.item).to_integer_32
									loop
										l_pl2 := l_pl2 + 1
										l_ps2 := l_ps2 + 1
									end
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl2 + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_ps2))) = 0 then
										Result := ((l_score + 75) + 94)
										js.return
									end
								end
							end
							if not js.return_called then
								l_pl2 := l_pl + 1
								l_ps2 := l_ps + 1
								from
								until
									(l_pl2.item).to_integer_32 /= (l_ps2.item).to_integer_32
								loop
									l_pl2 := l_pl2 + 1
									l_ps2 := l_ps2 + 1
								end
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl2 + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_ps2))) = 0 then
									Result := ((l_score + 93) + 94)
									js.return
								end
							end
							l_pos := -1 + 19 -- switch 1; break
				when 18 then -- switch 1, case 0
							if (l_pl.item).to_integer_32 = 0 then
								Result := l_score
								js.return
							end
							if not js.return_called and then ((l_pl[0]).to_integer_32 = (l_ps[1]).to_integer_32) then
								if (l_pl[1]).to_integer_32 = (l_ps[0]).to_integer_32 then
									l_pl2 := l_pl + 2
									l_ps2 := l_ps + 2
									from
									until
										not (not js.loop_done and then ((l_pl2.item).to_integer_32 = (l_ps2.item).to_integer_32))
									loop
										if (l_pl2.item).to_integer_32 = 0 then
											Result := (l_score + 75)
											js.return
										end
										if not js.return_called then
											l_pl2 := l_pl2 + 1
											l_ps2 := l_ps2 + 1
										end
									end
									if not js.return_called and then ((l_pl2[0]).to_integer_32 = (l_ps2[1]).to_integer_32) then
										if (l_pl2[1]).to_integer_32 = (l_ps2[0]).to_integer_32 then
											if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl2 + 2)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_ps2 + 2)))) = 0 then
												Result := ((l_score + 75) + 75)
												js.return
											end
										end
									end
									if not js.return_called then
										if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl2 + 1)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_ps2 + 1)))) = 0 then
											Result := ((l_score + 75) + 93)
											js.return
										end
									end
								end
							end
							if not js.return_called then
								l_pl2 := l_pl + 1
								l_ps2 := l_ps + 1
								from
								until
									not (not js.loop_done and then ((l_pl2.item).to_integer_32 = (l_ps2.item).to_integer_32))
								loop
									if (l_pl2.item).to_integer_32 = 0 then
										Result := (l_score + 93)
										js.return
									end
									if not js.return_called then
										l_pl2 := l_pl2 + 1
										l_ps2 := l_ps2 + 1
									end
								end
							end
							if not js.return_called and then ((l_pl2[0]).to_integer_32 = (l_ps2[1]).to_integer_32) then
								if (l_pl2[1]).to_integer_32 = (l_ps2[0]).to_integer_32 then
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl2 + 2)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_ps2 + 2)))) = 0 then
										Result := ((l_score + 93) + 75)
										js.return
									end
								end
							end
							if not js.return_called then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl2 + 1)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_ps2 + 1)))) = 0 then
									Result := ((l_score + 93) + 93)
									js.return
								end
							end
							if not js.return_called then
								l_pl2 := l_pl
								l_ps2 := l_ps + 1
								from
								until
									(l_pl2.item).to_integer_32 /= (l_ps2.item).to_integer_32
								loop
									l_pl2 := l_pl2 + 1
									l_ps2 := l_ps2 + 1
								end
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_pl2 + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_ps2))) = 0 then
									Result := ((l_score + 96) + 94)
									js.return
								end
							end
							if not js.return_called then
								l_pl2 := l_pl + 1
								l_ps2 := l_ps
								from
								until
									(l_pl2.item).to_integer_32 /= (l_ps2.item).to_integer_32
								loop
									l_pl2 := l_pl2 + 1
									l_ps2 := l_ps2 + 1
								end
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_pl2), create {CE_POINTER [INTEGER_8]}.make_cast ((l_ps2 + 1)))) = 0 then
									Result := ((l_score + 96) + 94)
									js.return
								end
							end
							l_pos := -1 + 19 -- switch 1; break
				when 19 then -- switch 1, done: | if done
							if not js.return_called then
								Result := 999_999
							end
				when 20 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	soundfold_find (a_slang: CE_POINTER [PD_SLANG_S]; a_word: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_arridx: INTEGER_32
			l_len: INTEGER_32
			l_wlen: INTEGER_32
			l_c: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_wordnr: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_ptr.make
			create l_byts.make
			create l_idxs.make

			l_arridx := 0
			l_wlen := 0
			l_ptr := a_word
			l_wordnr := 0
			l_byts := a_slang.item.sl_sbyts
			l_idxs := a_slang.item.sl_sidxs
			from
			until
				js.loop_done
			loop
				l_tmp := l_arridx
				l_arridx := l_arridx + 1
				l_len := (l_byts[l_tmp]).to_integer_32
				l_c := (l_ptr[l_wlen]).to_integer_32
				if (l_byts[l_arridx]).to_integer_32 = 0 then
					if l_c = 0 then
						js.break
					end
					if not js.loop_jumped then
						from
						until
							js.loop_done
						loop
							if l_len > 0 then
								if (l_byts[l_arridx]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_arridx := l_arridx + 1
								l_len := l_len - 1
							end
						end
						if l_len = 0 then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_wordnr := l_wordnr + 1
						end
					end
				end
				if not js.loop_jumped then
					if l_c = 0 then
						Result := (-1)
						js.return
					end
					if not js.return_called then
						if l_c = 9 then
							l_c := (' ').code
						end
						from
						until
							not (not js.loop_done and then ((l_byts[l_arridx]).to_integer_32 < l_c))
						loop
							l_wordnr := l_wordnr + (l_idxs[(l_idxs[l_arridx])])
							l_arridx := l_arridx + 1
							l_len := l_len - 1
							if l_len = 0 then
								Result := (-1)
								js.return
							end
						end
					end
					if not js.return_called and then ((l_byts[l_arridx]).to_integer_32 /= l_c) then
						Result := (-1)
						js.return
					end
					if not js.return_called then
						l_arridx := l_idxs[l_arridx]
						l_wlen := l_wlen + 1
						if l_c = 32 then
							from
							until
								js.loop_done
							loop
								if (l_ptr[l_wlen]).to_integer_32 /= 32 then
									if (l_ptr[l_wlen]).to_integer_32 /= 9 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_wlen := l_wlen + 1
								end
							end
						end
					end
				end
			end
			if not js.return_called then
				Result := l_wordnr
			end
		end

	spell_add_word (a_word: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_bad: INTEGER_32; a_idx: INTEGER_32; a_undo: INTEGER_32)
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_new_spf: INTEGER_32
			l_fname: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fnamebuf: CE_ARRAY [NATURAL_8]
			l_line: CE_ARRAY [NATURAL_8]
			l_fpos: INTEGER_32
			l_fpos_next: INTEGER_32
			l_i___0: INTEGER_32
			l_spf: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fd.make
			create l_buf___6.make
			create l_fname.make (<<1>>)
			create l_fnamebuf.make (<<4_096>>)
			create l_line.make (<<500>>)
			create l_spf.make (<<1>>)
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fd := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
					l_buf___6 := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					l_new_spf := 0
					l_fpos_next := 0
					if a_idx = 0 then
						if int_wordlist.is_void then
							int_wordlist := fileio_inst.vim_tempname (('s').code)
							if int_wordlist.is_void then
								js.return
							end
						end
						if not js.return_called then
							l_fname.item := int_wordlist
						end
					else
						if (((globals_inst.curwin.item.w_s).item.b_p_spf).item).to_integer_32 = 0 then
							init_spellfile
							l_new_spf := 1
						end
						if (((globals_inst.curwin.item.w_s).item.b_p_spf).item).to_integer_32 = 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notset)))), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("spellfile"))).do_nothing
							js.return
						end
						if not js.return_called then
							l_spf.item := (globals_inst.curwin.item.w_s).item.b_p_spf
							l_i___0 := 1
							from
							until
								not (not js.loop_done and then ((l_spf.item.item).to_integer_32 /= 0))
							loop
								misc2_inst.copy_option_part (l_spf, l_fnamebuf, 4_096, ce_string (",")).do_nothing
								if l_i___0 = a_idx then
									js.break
								end
								if not js.loop_jumped then
									if (l_spf.item.item).to_integer_32 = 0 then
										misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E765: %'spellfile%' does not have %%ld entries")))), a_idx.to_integer_32).do_nothing
										js.return
									end
									if not js.return_called then
										l_i___0 := l_i___0 + 1
									end
								end
							end
						end
						if not js.return_called then
							l_buf___6 := buffer_inst.buflist_findname_exp (l_fnamebuf)
							if not l_buf___6.is_void then
								if (l_buf___6.item.b_ml.ml_mfp).is_void then
									l_buf___6 := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
								end
							end
							if not l_buf___6.is_void then
								if (undo_inst.bufIsChanged (l_buf___6)).to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_bufloaded))))).do_nothing
									js.return
								end
							end
						end
						if not js.return_called then
							l_fname.item := l_fnamebuf
						end
					end
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						if not (a_bad.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 4 then -- else:
						if not (a_undo.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 5 then -- if: | _L___0:
						l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname.item), ce_string ("r"))
						if l_fd.is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 6 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 15 -- skip loop
						end
				when 7 then -- loop body:
						if (fileio_inst.vim_fgets (l_line, 500, l_fd)).to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						l_fpos := l_fpos_next
						l_fpos_next := ftell (l_fd)
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_word), create {CE_POINTER [INTEGER_8]}.make_cast (l_line), a_len.to_natural_32)) /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if (l_line[a_len]).to_integer_32 /= 47 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if not ((l_line[a_len]).to_integer_32 < 32) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						fclose (l_fd).do_nothing
						l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname.item), ce_string ("r+"))
						if l_fd.is_void then
							js.break
						end
						if not js.loop_jumped then
							if (fseek (l_fd, l_fpos, 0)) = 0 then
								fputc (('#').code, l_fd).do_nothing
								if a_undo.to_boolean then
									misc1_inst.home_replace (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_fname.item, globals_inst.NameBuff.item, 4_096, 1)
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Word removed from %%s")))), globals_inst.NameBuff.item]).do_nothing
								end
							end
							fseek (l_fd, l_fpos_next, 0).do_nothing
						end
				when 14 then -- if done | if done | if done
						l_pos := -1 + 6 -- back to loop condition
				when 15 then -- loop done
						if not l_fd.is_void then
							fclose (l_fd).do_nothing
						end
				when 16 then -- if done | if done
						if not a_undo.to_boolean then
							l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname.item), ce_string ("a"))
							if l_fd.is_void then
								if l_new_spf.to_boolean then
									if not (misc1_inst.dir_of_file_exists (l_fname.item)).to_boolean then
										l_p___0 := misc1_inst.gettail_sep (l_fname.item)
										if not l_p___0.is_equal (l_fname.item) then
											l_c := (l_p___0.item).to_integer_32
											l_p___0.item := (('%/0/').code).to_natural_8
											mkdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname.item), (493).to_natural_32).do_nothing
											l_p___0.item := l_c.to_natural_8
											l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname.item), ce_string ("a"))
										end
									end
								end
							end
							if l_fd.is_void then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), l_fname.item).do_nothing
							else
								if a_bad.to_boolean then
									fprintf ([l_fd, ce_string ("%%.*s/!%N"), a_len, a_word]).do_nothing
								else
									fprintf ([l_fd, ce_string ("%%.*s%N"), a_len, a_word]).do_nothing
								end
								fclose (l_fd).do_nothing
								misc1_inst.home_replace (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_fname.item, globals_inst.NameBuff.item, 4_096, 1)
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Word added to %%s")))), globals_inst.NameBuff.item]).do_nothing
							end
						end
						if not l_fd.is_void then
							mkspell (1, l_fname, 0, 1, 1)
							if not l_buf___6.is_void then
								fileio_inst.buf_reload (l_buf___6, l_buf___6.item.b_orig_mode)
							end
							screen_inst.redraw_all_later (35)
						end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_casefold (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_outi: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_len >= a_buflen then
						a_buf___6[0] := (('%/0/').code).to_natural_8
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						l_outi := 0
						l_p___0.item := a_str___1
				when 3 then -- loop condition:
						if not (not js.loop_done and then (((l_p___0.item).c_pointer.to_integer_32).to_natural_32 < ((a_str___1 + a_len).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 4 then -- loop body:
						if l_outi + 21 > a_buflen then
							a_buf___6[l_outi] := (('%/0/').code).to_natural_8
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						l_c := mbyte_inst.mb_cptr2char_adv (l_p___0)
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_c >= 128 then
							l_tmp___2 := (mbyte_inst.utf_fold (l_c))
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_c < 256 then
							l_tmp___1 := (spelltab.item.st_fold[l_c]).to_integer_32
						else
							l_tmp___1 := (towlower (l_c.to_natural_32)).to_integer_32
						end
						l_tmp___2 := l_tmp___1
				when 9 then
						l_outi := l_outi + (globals_inst.mb_char2bytes.integer_32_item ([l_tmp___2, a_buf___6 + l_outi]))
				when 10 then -- if done
						l_pos := -1 + 3 -- back to loop condition
				when 11 then -- loop done
						if not js.return_called then
							a_buf___6[l_outi] := (('%/0/').code).to_natural_8
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_len)
						loop
							a_buf___6[l_i___0] := spelltab.item.st_fold[(a_str___1[l_i___0]).to_integer_32]
							l_i___0 := l_i___0 + 1
						end
						a_buf___6[l_i___0] := (('%/0/').code).to_natural_8
				when 14 then -- if done | if done
						if not js.return_called then
							Result := 1
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	spell_cat_line (a_buf___6: CE_POINTER [NATURAL_8]; a_line: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0 := charset_inst.skipwhite (a_line)
			from
			until
				js.loop_done
			loop
				if (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("*#/%"%T")), (l_p___0.item).to_integer_32)).is_void then
					js.break
				end
				if not js.loop_jumped then
					l_p___0 := charset_inst.skipwhite (l_p___0 + 1)
				end
			end
			if (l_p___0.item).to_integer_32 /= 0 then
				l_n := (l_p___0.distance (a_line)) + 1
				if l_n < a_maxlen - 1 then
					memset (create {CE_POINTER [ANY]}.make_cast (a_buf___6), (' ').code, l_n.to_natural_32).do_nothing
					misc2_inst.vim_strncpy (a_buf___6 + l_n, l_p___0, ((a_maxlen - 1) - l_n).to_natural_32)
				end
			end
		end

	spell_check (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_ptr: CE_POINTER [NATURAL_8]; a_attrp: CE_POINTER [NATURAL_32]; a_capcol: CE_POINTER [INTEGER_32]; a_docount: INTEGER_32): INTEGER_32
		local
			l_mi: CE_ARRAY [PD_MATCHINF_S]
			l_nrlen: INTEGER_32
			l_c: INTEGER_32
			l_wrongcaplen: INTEGER_32
			l_lpi: INTEGER_32
			l_count_word: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___9: INTEGER_32
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_tmp___14: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_fp: CE_POINTER [NATURAL_8]
			l_save_result: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___18: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_mi.make (<<1>>)
			create l_regmatch___0.make (<<1>>)
			create l_p___0.make
			create l_fp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nrlen := 0
					l_wrongcaplen := 0
					l_count_word := a_docount
					if (a_ptr.item).to_integer_32 <= 32 then
						Result := 1
						js.return
					end
					if not js.return_called and then ((a_wp___0.item.w_s).item.b_langp.ga_len = 0) then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						memset (create {CE_POINTER [ANY]}.make_cast (l_mi), 0, (create {PD_MATCHINF_S}.make).structure_size.to_natural_32).do_nothing
						if (a_ptr.item).to_integer_32 >= 48 then
							if (a_ptr.item).to_integer_32 <= 57 then
								if (a_ptr.item).to_integer_32 = 48 then
									if (a_ptr[1]).to_integer_32 = 120 then
										l_mi.item.mi_end := charset_inst.skiphex (a_ptr + 2)
									elseif (a_ptr[1]).to_integer_32 = 88 then
										l_mi.item.mi_end := charset_inst.skiphex (a_ptr + 2)
									else
										l_mi.item.mi_end := charset_inst.skipdigits (a_ptr)
									end
								else
									l_mi.item.mi_end := charset_inst.skipdigits (a_ptr)
								end
								l_nrlen := (l_mi.item.mi_end).distance (a_ptr)
							end
						end
						l_mi.item.mi_word := a_ptr
						l_mi.item.mi_fend := a_ptr
						if not ((spell_iswordp (l_mi.item.mi_fend, a_wp___0)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						from
						until
							js.loop_done
						loop
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_mi.item.mi_fend]))
							else
								l_tmp___0 := 1
							end
							l_mi.item.mi_fend := l_mi.item.mi_fend + l_tmp___0
							if ((l_mi.item.mi_fend).item).to_integer_32 /= 0 then
								if not (spell_iswordp (l_mi.item.mi_fend, a_wp___0)).to_boolean then
									js.break
								end
							else
								js.break
							end
						end
						if a_capcol.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if a_capcol.item /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if ((a_wp___0.item.w_s).item.b_cap_prog).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if globals_inst.has_mbyte.to_boolean then
							l_c := (globals_inst.mb_ptr2char.integer_32_item ([a_ptr]))
						else
							l_c := (a_ptr.item).to_integer_32
						end
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_c >= 128 then
							l_tmp___6 := (mbyte_inst.utf_isupper (l_c))
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_c < 256 then
							l_tmp___5 := (spelltab.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___5 := (iswupper (l_c.to_natural_32))
						end
						l_tmp___6 := l_tmp___5
				when 9 then
						if not l_tmp___6.to_boolean then
							l_wrongcaplen := (l_mi.item.mi_fend).distance (a_ptr)
						end
				when 10 then -- if done | if done | if done | if done
						if not a_capcol.is_void then
							a_capcol.item := -1
						end
						l_mi.item.mi_end := l_mi.item.mi_fend
						l_mi.item.mi_capflags := 0
						l_mi.item.mi_cend := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_mi.item.mi_win := a_wp___0
						if ((l_mi.item.mi_fend).item).to_integer_32 /= 0 then
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___9 := (globals_inst.mb_ptr2len.integer_32_item ([l_mi.item.mi_fend]))
							else
								l_tmp___9 := 1
							end
							l_mi.item.mi_fend := l_mi.item.mi_fend + l_tmp___9
						end
						spell_casefold (a_ptr, (l_mi.item.mi_fend).distance (a_ptr), l_mi.item.mi_fword, 251).do_nothing
						l_mi.item.mi_fwordlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_mi.item.mi_fword)))).to_integer_32
						l_mi.item.mi_result := 3
						l_mi.item.mi_result2 := 3
						l_lpi := 0
						from
						until
							not (l_lpi < (a_wp___0.item.w_s).item.b_langp.ga_len)
						loop
							l_mi.item.mi_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((a_wp___0.item.w_s).item.b_langp.ga_data) + l_lpi
							if (((l_mi.item.mi_lp).item.lp_slang).item.sl_fidxs).is_void then
								js.continue
							end
							if not js.loop_jumped then
								find_word (l_mi, 0)
								find_word (l_mi, 1)
								find_prefix (l_mi, 0)
								if (((l_mi.item.mi_lp).item.lp_slang).item.sl_nobreak).to_boolean then
									if l_mi.item.mi_result = 3 then
										if l_mi.item.mi_result2 /= 3 then
											l_mi.item.mi_result := l_mi.item.mi_result2
											l_mi.item.mi_end := l_mi.item.mi_end2
										end
									end
								end
								if l_count_word.to_boolean then
									if l_mi.item.mi_result = 0 then
										count_common_word ((l_mi.item.mi_lp).item.lp_slang, a_ptr, (l_mi.item.mi_end).distance (a_ptr), 1)
										l_count_word := 0
									end
								end
							end
							l_lpi := l_lpi + 1
						end
						if l_mi.item.mi_result /= 0 then
							if l_nrlen > 0 then
								if l_mi.item.mi_result = 3 then
									Result := l_nrlen
									js.return
								elseif l_mi.item.mi_result = -1 then
									Result := l_nrlen
									js.return
								end
							elseif (spell_iswordp_nmw (a_ptr)).to_boolean then
								if (l_mi.item.mi_end).is_equal (a_ptr) then
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___14 := (globals_inst.mb_ptr2len.integer_32_item ([l_mi.item.mi_end]))
									else
										l_tmp___14 := 1
									end
									l_mi.item.mi_end := l_mi.item.mi_end + l_tmp___14
								elseif l_mi.item.mi_result = 3 then
									if (((create {CE_POINTER [PD_LANGP_S]}.make_cast ((a_wp___0.item.w_s).item.b_langp.ga_data) + 0).item.lp_slang).item.sl_nobreak).to_boolean then
										l_save_result := l_mi.item.mi_result
										l_mi.item.mi_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((a_wp___0.item.w_s).item.b_langp.ga_data) + 0
										if not (((l_mi.item.mi_lp).item.lp_slang).item.sl_fidxs).is_void then
											l_p___0 := l_mi.item.mi_word
											l_fp := l_mi.item.mi_fword
											from
											until
												js.loop_done
											loop
												if globals_inst.has_mbyte.to_boolean then
													l_tmp___16 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
												else
													l_tmp___16 := 1
												end
												l_p___0 := l_p___0 + l_tmp___16
												if globals_inst.has_mbyte.to_boolean then
													l_tmp___18 := (globals_inst.mb_ptr2len.integer_32_item ([l_fp]))
												else
													l_tmp___18 := 1
												end
												l_fp := l_fp + l_tmp___18
												if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= ((l_mi.item.mi_end).c_pointer.to_integer_32).to_natural_32 then
													js.break
												end
												if not js.loop_jumped then
													l_mi.item.mi_compoff := l_fp.distance ((l_mi.item.mi_fword))
													find_word (l_mi, 3)
													if l_mi.item.mi_result /= 3 then
														l_mi.item.mi_end := l_p___0
														js.break
													end
												end
											end
											l_mi.item.mi_result := l_save_result
										end
									end
								end
							else
								if not a_capcol.is_void then
									if not ((a_wp___0.item.w_s).item.b_cap_prog).is_void then
										l_regmatch___0.item.regprog := (a_wp___0.item.w_s).item.b_cap_prog
										l_regmatch___0.item.rm_ic := 0
										if (regexp_inst.vim_regexec (l_regmatch___0, a_ptr, 0)).to_boolean then
											a_capcol.item := (l_regmatch___0.item.endp[0]).distance (a_ptr)
										end
									end
								end
								if globals_inst.has_mbyte.to_boolean then
									Result := (globals_inst.mb_ptr2len.integer_32_item ([a_ptr]))
									js.return
								end
								if not js.return_called then
									Result := 1
									js.return
								end
							end
							if not js.return_called then
								if l_mi.item.mi_result = 3 then
									a_attrp.item := {PC_HLF_T}.HLF_SPB
								elseif l_mi.item.mi_result = -1 then
									a_attrp.item := {PC_HLF_T}.HLF_SPB
								elseif l_mi.item.mi_result = 1 then
									a_attrp.item := {PC_HLF_T}.HLF_SPR
								else
									a_attrp.item := {PC_HLF_T}.HLF_SPL
								end
							end
						end
				when 11 then -- if done
					if not js.return_called and then (l_wrongcaplen > 0) then
						if l_mi.item.mi_result = 0 then
							a_attrp.item := {PC_HLF_T}.HLF_SPC
							Result := l_wrongcaplen
							js.return
						elseif l_mi.item.mi_result = 1 then
							a_attrp.item := {PC_HLF_T}.HLF_SPC
							Result := l_wrongcaplen
							js.return
						end
					end
					if not js.return_called then
						Result := ((l_mi.item.mi_end).distance (a_ptr))
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_check_msm: INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_start___1: INTEGER_32
			l_incr: INTEGER_32
			l_added: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make (<<1>>)

			l_p___0.item := option_inst.p_msm.item
			l_start___1 := 0
			l_incr := 0
			l_added := 0
			if (l_p___0.item.item).to_integer_32 >= 48 then
				if not ((l_p___0.item.item).to_integer_32 <= 57) then
					Result := 0
					js.return
				end
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				l_start___1 := ((charset_inst.getdigits (l_p___0)) * 10) // 156
				if (l_p___0.item.item).to_integer_32 /= 44 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_p___0.item := l_p___0.item + 1
				if (l_p___0.item.item).to_integer_32 >= 48 then
					if not ((l_p___0.item.item).to_integer_32 <= 57) then
						Result := 0
						js.return
					end
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_incr := ((charset_inst.getdigits (l_p___0)) * 102) // 1_600
				if (l_p___0.item.item).to_integer_32 /= 44 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_p___0.item := l_p___0.item + 1
				if (l_p___0.item.item).to_integer_32 >= 48 then
					if not ((l_p___0.item.item).to_integer_32 <= 57) then
						Result := 0
						js.return
					end
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_added := (charset_inst.getdigits (l_p___0)) * 1_024
				if (l_p___0.item.item).to_integer_32 /= 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if l_start___1 = 0 then
					Result := 0
					js.return
				elseif l_incr = 0 then
					Result := 0
					js.return
				elseif l_added = 0 then
					Result := 0
					js.return
				elseif l_incr > l_start___1 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				compress_start := l_start___1
				compress_inc := l_incr
				compress_added := l_added
				Result := 1
			end
		end

	spell_check_sps: INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_f: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make (<<1>>)
			create l_s.make (<<1>>)
			create l_buf___6.make (<<4_096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					sps_flags := 0
					sps_limit := 9_999
					l_p___0.item := option_inst.p_sps.item
				when 1 then -- loop condition:
					if not (not js.loop_done and then ((l_p___0.item.item).to_integer_32 /= 0)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						misc2_inst.copy_option_part (l_p___0, l_buf___6, 4_096, ce_string (",")).do_nothing
						l_f := 0
						if not ((l_buf___6[0]).to_integer_32 >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_buf___6[0]).to_integer_32 <= 57 then
							l_s.item := l_buf___6
							sps_limit := (charset_inst.getdigits (l_s)).to_integer_32
							if (l_s.item.item).to_integer_32 /= 0 then
								if (l_s.item.item).to_integer_32 >= 48 then
									if not ((l_s.item.item).to_integer_32 <= 57) then
										l_f := -1
									end
								else
									l_f := -1
								end
							end
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("best"))) = 0 then
							l_f := 1
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("fast"))) = 0 then
							l_f := 2
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("double"))) = 0 then
							l_f := 4
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("expr:"), (5).to_natural_32)) /= 0 then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("file:"), (5).to_natural_32)) /= 0 then
								l_f := -1
							end
						end
				when 6 then
						if l_f = -1 then
							sps_flags := 1
							sps_limit := 9_999
							Result := 0
							js.return
						elseif sps_flags /= 0 then
							if l_f /= 0 then
								sps_flags := 1
								sps_limit := 9_999
								Result := 0
								js.return
							end
						end
						if not js.return_called and then (l_f /= 0) then
							sps_flags := l_f
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not js.return_called then
						if sps_flags = 0 then
							sps_flags := 1
						end
						Result := 1
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_dump_compl (a_pat: CE_POINTER [NATURAL_8]; a_ic: INTEGER_32; a_dir___0: CE_POINTER [INTEGER_32]; a_dumpflags_arg: INTEGER_32)
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_slang: CE_POINTER [PD_SLANG_S]
			l_arridx: CE_ARRAY [INTEGER_32]
			l_curi: CE_ARRAY [INTEGER_32]
			l_word: CE_ARRAY [NATURAL_8]
			l_c: INTEGER_32
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_lnum: INTEGER_32
			l_round: INTEGER_32
			l_depth___1: INTEGER_32
			l_n: INTEGER_32
			l_flags___0: INTEGER_32
			l_region_names: CE_POINTER [NATURAL_8]
			l_do_region: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_lpi: INTEGER_32
			l_dumpflags: INTEGER_32
			l_patlen: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lp.make
			create l_slang.make
			create l_arridx.make (<<250>>)
			create l_curi.make (<<250>>)
			create l_word.make (<<250>>)
			create l_byts.make
			create l_idxs.make
			create l_region_names.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := (0).to_integer_32
					l_region_names := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_do_region := 1
					l_dumpflags := a_dumpflags_arg
					if not a_pat.is_void then
						if a_ic.to_boolean then
							l_dumpflags := (l_dumpflags).bit_or ((4))
						else
							l_n := captype (a_pat, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							if l_n = 2 then
								l_dumpflags := (l_dumpflags).bit_or ((8))
							elseif l_n = 4 then
								l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pat))
								if l_tmp.to_integer_32 > (globals_inst.mb_ptr2len.integer_32_item ([a_pat])) then
									l_dumpflags := (l_dumpflags).bit_or ((16))
								end
							end
						end
					end
					l_lpi := 0
					from
					until
						not (not js.loop_done and then (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len))
					loop
						l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
						l_p___0 := (l_lp.item.lp_slang).item.sl_regions
						if (l_p___0[0]).to_integer_32 /= 0 then
							if l_region_names.is_void then
								l_region_names := l_p___0
							elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_region_names), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) /= 0 then
								l_do_region := 0
								js.break
							end
						end
						if not js.loop_jumped then
							l_lpi := l_lpi + 1
						end
					end
					if l_do_region.to_boolean then
						if not l_region_names.is_void then
							if a_pat.is_void then
								message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("/regions=%%s"), l_region_names]).do_nothing
								l_tmp___2 := l_lnum
								l_lnum := l_lnum + 1
								memline_inst.ml_append (l_tmp___2, globals_inst.IObuff, 0, 0).do_nothing
							end
						else
							l_do_region := 0
						end
					else
						l_do_region := 0
					end
					l_lpi := 0
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len)) then
						l_pos := -1 + 36 -- skip loop
					end
				when 2 then -- loop body:
						l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
						l_slang := l_lp.item.lp_slang
						if (l_slang.item.sl_fbyts).is_void then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 35 -- skip if block
						end
				when 3 then -- if:
						if a_pat.is_void then
							message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("# file: %%s"), l_slang.item.sl_fname]).do_nothing
							l_tmp___3 := l_lnum
							l_lnum := l_lnum + 1
							memline_inst.ml_append (l_tmp___3, globals_inst.IObuff, 0, 0).do_nothing
						end
						if not a_pat.is_void then
							if (l_slang.item.sl_pbyts).is_void then
								l_patlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pat))).to_integer_32
							else
								l_patlen := -1
							end
						else
							l_patlen := -1
						end
						l_round := 1
				when 4 then -- loop condition:
						if not (not js.loop_done and then (l_round <= 2)) then
							l_pos := -1 + 35 -- skip loop
						end
				when 5 then -- loop body:
						if l_round = 1 then
							l_dumpflags := (l_dumpflags).bit_and ((-2))
							l_byts := l_slang.item.sl_fbyts
							l_idxs := l_slang.item.sl_fidxs
						else
							l_dumpflags := (l_dumpflags).bit_or ((1))
							l_byts := l_slang.item.sl_kbyts
							l_idxs := l_slang.item.sl_kidxs
						end
						if l_byts.is_void then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 34 -- skip if block
						end
				when 6 then -- if:
						l_depth___1 := 0
						l_arridx[0] := 0
						l_curi[0] := 1
				when 7 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 34 -- skip loop
						end
				when 8 then -- loop body:
						if l_depth___1 >= 0 then
							if not globals_inst.got_int.to_boolean then
								if not (a_pat.is_void) then
									if globals_inst.compl_interrupted.to_boolean then
										js.break
									end
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 33 -- skip if block
						end
				when 9 then -- if:
						if not (l_curi[l_depth___1] > (l_byts[(l_arridx[l_depth___1])]).to_integer_32) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_depth___1 := l_depth___1 - 1
						misc1_inst.line_breakcheck
						edit_inst.ins_compl_check_keys (50)
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 12 then -- else:
						l_n := l_arridx[l_depth___1] + l_curi[l_depth___1]
						l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
						l_c := (l_byts[l_n]).to_integer_32
						if l_c /= 0 then
							l_pos := -1 + 32 -- skip if block
						end
				when 13 then -- if:
						l_flags___0 := l_idxs[l_n]
						if l_round /= 2 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 16 then -- else:
						if ((l_flags___0).bit_and (128)) /= 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 17 then -- if: | _L___1:
						if ((l_flags___0).bit_and (512)) /= 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 18 then -- if:
						if not (l_do_region.to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 25 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 21 then -- else:
						if ((l_flags___0).bit_and (1)) /= 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___0
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 24 then -- else:
						if ((((l_flags___0.to_natural_32).bit_shift_right (16))).bit_and ((l_lp.item.lp_region).to_natural_32)) = {NATURAL_32} 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 25 then -- if: | _L___0:
						l_word[l_depth___1] := (('%/0/').code).to_natural_8
						if not l_do_region.to_boolean then
							l_flags___0 := (l_flags___0).bit_and ((-2))
						end
						l_c := ((l_flags___0.to_natural_32).bit_shift_right (24)).to_integer_32
						if l_c /= 0 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if l_curi[l_depth___1] /= 2 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L:
						dump_word (l_slang, l_word, a_pat, a_dir___0, l_dumpflags, l_flags___0, l_lnum)
						if a_pat.is_void then
							l_lnum := l_lnum + 1
						end
				when 30 then -- if done
						if l_c /= 0 then
							l_lnum := dump_prefixes (l_slang, l_word, a_pat, a_dir___0, l_dumpflags, l_flags___0, l_lnum)
						end
				when 31 then -- if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_tmp___5 := l_depth___1
						l_depth___1 := l_depth___1 + 1
						l_word[l_tmp___5] := l_c.to_natural_8
						l_arridx[l_depth___1] := l_idxs[l_n]
						l_curi[l_depth___1] := 1
						if l_depth___1 <= l_patlen then
							if (mbyte_inst.mb_strnicmp (l_word, a_pat, l_depth___1.to_natural_32)) /= 0 then
								l_depth___1 := l_depth___1 - 1
							end
						end
				when 33 then -- if done | if done
						l_pos := -1 + 7 -- back to loop condition
				when 34 then -- loop done | if done
						if js.loop_increment then
							l_round := l_round + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 35 then -- loop done | if done
						if js.loop_increment then
							l_lpi := l_lpi + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 36 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_edit_score (a_slang: CE_POINTER [PD_SLANG_S]; a_badword: CE_POINTER [NATURAL_8]; a_goodword: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_cnt: CE_POINTER [INTEGER_32]
			l_badlen: INTEGER_32
			l_goodlen: INTEGER_32
			l_j: INTEGER_32
			l_i___0: INTEGER_32
			l_t: INTEGER_32
			l_bc: INTEGER_32
			l_gc: INTEGER_32
			l_pbc: INTEGER_32
			l_pgc: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_wbadword: CE_ARRAY [INTEGER_32]
			l_wgoodword: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cnt.make
			create l_p___0.make (<<1>>)
			create l_wbadword.make (<<250>>)
			create l_wgoodword.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.has_mbyte.to_boolean then
						l_p___0.item := a_badword
						l_badlen := 0
						from
						until
							(l_p___0.item.item).to_integer_32 = 0
						loop
							l_tmp := l_badlen
							l_badlen := l_badlen + 1
							l_wbadword[l_tmp] := mbyte_inst.mb_cptr2char_adv (l_p___0)
						end
						l_tmp___0 := l_badlen
						l_badlen := l_badlen + 1
						l_wbadword[l_tmp___0] := 0
						l_p___0.item := a_goodword
						l_goodlen := 0
						from
						until
							(l_p___0.item.item).to_integer_32 = 0
						loop
							l_tmp___1 := l_goodlen
							l_goodlen := l_goodlen + 1
							l_wgoodword[l_tmp___1] := mbyte_inst.mb_cptr2char_adv (l_p___0)
						end
						l_tmp___2 := l_goodlen
						l_goodlen := l_goodlen + 1
						l_wgoodword[l_tmp___2] := 0
					else
						l_badlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_badword))).to_integer_32 + 1
						l_goodlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_goodword))).to_integer_32 + 1
					end
					l_cnt := create {CE_POINTER [INTEGER_32]}.make_cast ((misc2_inst.lalloc ((({PLATFORM}.Integer_32_bytes.to_natural_32 * (l_badlen + 1).to_natural_32) * (l_goodlen + 1).to_natural_32).to_natural_32, 1)))
					if l_cnt.is_void then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_cnt[0] := 0
						l_j := 1
						from
						until
							not (l_j <= l_goodlen)
						loop
							l_cnt[l_j * (l_badlen + 1)] := l_cnt[(l_j - 1) * (l_badlen + 1)] + 96
							l_j := l_j + 1
						end
						l_i___0 := 1
				when 2 then -- loop condition:
						if not (not js.loop_done and then (l_i___0 <= l_badlen)) then
							l_pos := -1 + 19 -- skip loop
						end
				when 3 then -- loop body:
						l_cnt[l_i___0] := l_cnt[(l_i___0 - 1)] + 94
						l_j := 1
				when 4 then -- loop condition:
						if not (l_j <= l_goodlen) then
							l_pos := -1 + 18 -- skip loop
						end
				when 5 then -- loop body:
						if globals_inst.has_mbyte.to_boolean then
							l_bc := l_wbadword[l_i___0 - 1]
							l_gc := l_wgoodword[l_j - 1]
						else
							l_bc := (a_badword[(l_i___0 - 1)]).to_integer_32
							l_gc := (a_goodword[(l_j - 1)]).to_integer_32
						end
						if l_bc /= l_gc then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 8 then -- else:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if l_bc >= 128 then
							l_tmp___10 := (mbyte_inst.utf_fold (l_bc))
						else
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if l_bc < 256 then
							l_tmp___9 := (spelltab.item.st_fold[l_bc]).to_integer_32
						else
							l_tmp___9 := (towlower (l_bc.to_natural_32)).to_integer_32
						end
						l_tmp___10 := l_tmp___9
				when 12 then
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_gc >= 128 then
							l_tmp___14 := (mbyte_inst.utf_fold (l_gc))
						else
							l_pos := -1 + 15 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L___0:
						if l_gc < 256 then
							l_tmp___13 := (spelltab.item.st_fold[l_gc]).to_integer_32
						else
							l_tmp___13 := (towlower (l_gc.to_natural_32)).to_integer_32
						end
						l_tmp___14 := l_tmp___13
				when 16 then
						if l_tmp___10 = l_tmp___14 then
							l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 52 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
						elseif not a_slang.is_void then
							if (a_slang.item.sl_has_map).to_boolean then
								if (similar_chars (a_slang, l_gc, l_bc)).to_boolean then
									l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 33 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
								else
									l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 93 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
								end
							else
								l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 93 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
							end
						else
							l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 93 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
						end
						if l_i___0 > 1 then
							if l_j > 1 then
								if globals_inst.has_mbyte.to_boolean then
									l_pbc := l_wbadword[l_i___0 - 2]
									l_pgc := l_wgoodword[l_j - 2]
								else
									l_pbc := (a_badword[(l_i___0 - 2)]).to_integer_32
									l_pgc := (a_goodword[(l_j - 2)]).to_integer_32
								end
								if l_bc = l_pgc then
									if l_pbc = l_gc then
										l_t := 75 + l_cnt[((l_i___0 - 2) + (l_j - 2) * (l_badlen + 1))]
										if l_t < l_cnt[(l_i___0 + l_j * (l_badlen + 1))] then
											l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := l_t
										end
									end
								end
							end
						end
						l_t := 94 + l_cnt[((l_i___0 - 1) + l_j * (l_badlen + 1))]
						if l_t < l_cnt[(l_i___0 + l_j * (l_badlen + 1))] then
							l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := l_t
						end
						l_t := 96 + l_cnt[(l_i___0 + (l_j - 1) * (l_badlen + 1))]
						if l_t < l_cnt[(l_i___0 + l_j * (l_badlen + 1))] then
							l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := l_t
						end
				when 17 then -- if done
						l_j := l_j + 1
						l_pos := -1 + 4 -- back to loop condition
				when 18 then -- loop done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 2 -- back to loop condition
				when 19 then -- loop done
						l_i___0 := l_cnt[((l_badlen - 1) + (l_goodlen - 1) * (l_badlen + 1))]
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cnt))
						Result := l_i___0
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_edit_score_limit (a_slang: CE_POINTER [PD_SLANG_S]; a_badword: CE_POINTER [NATURAL_8]; a_goodword: CE_POINTER [NATURAL_8]; a_limit: INTEGER_32): INTEGER_32
		local
			l_stack: CE_ARRAY [PD_LIMITSCORE_T]
			l_stackidx: INTEGER_32
			l_bi: INTEGER_32
			l_gi: INTEGER_32
			l_bi2: INTEGER_32
			l_gi2: INTEGER_32
			l_bc: INTEGER_32
			l_gc: INTEGER_32
			l_score: INTEGER_32
			l_score_off: INTEGER_32
			l_minscore: INTEGER_32
			l_round: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_stack.make (<<10>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.has_mbyte.to_boolean then
						Result := (spell_edit_score_limit_w (a_slang, a_badword, a_goodword, a_limit))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						l_stackidx := 0
						l_bi := 0
						l_gi := 0
						l_score := 0
						l_minscore := a_limit + 1
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 33 -- skip loop
						end
				when 3 then -- loop body: | loop condition:
						if js.loop_done then
							l_pos := -1 + 8 -- skip loop
						end
				when 4 then -- loop body:
						l_bc := (a_badword[l_bi]).to_integer_32
						l_gc := (a_goodword[l_gi]).to_integer_32
						if l_bc /= l_gc then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_bc = 0 then
							if l_score < l_minscore then
								l_minscore := l_score
							end
							l_pos := -1 + 31 -- goto pop
						end
				when 6 then
						l_bi := l_bi + 1
						l_gi := l_gi + 1
				when 7 then -- if done
						l_pos := -1 + 3 -- back to loop condition
				when 8 then -- loop done
						if l_gc /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 12 -- skip loop
						end
				when 10 then -- loop body:
						l_score := l_score + (94)
						if l_score >= l_minscore then
							l_pos := -1 + 31 -- goto pop
						end
				when 11 then
						l_bi := l_bi + 1
						if (a_badword[l_bi]).to_integer_32 = 0 then
							js.break
						end
						l_pos := -1 + 9 -- back to loop condition
				when 12 then -- loop done
						l_minscore := l_score
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 14 then -- else:
						if l_bc /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 15 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 18 -- skip loop
						end
				when 16 then -- loop body:
						l_score := l_score + (96)
						if l_score >= l_minscore then
							l_pos := -1 + 31 -- goto pop
						end
				when 17 then
						l_gi := l_gi + 1
						if (a_goodword[l_gi]).to_integer_32 = 0 then
							js.break
						end
						l_pos := -1 + 15 -- back to loop condition
				when 18 then -- loop done
						l_minscore := l_score
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 20 then -- else:
						l_round := 0
						from
						until
							not (not js.loop_done and then (l_round <= 1))
						loop
							if l_round = 0 then
								l_tmp___0 := 94
							else
								l_tmp___0 := 96
							end
							l_score_off := l_score + l_tmp___0
							if l_score_off < l_minscore then
								if l_score_off + 33 >= l_minscore then
									l_bi2 := (l_bi + 1) - l_round
									l_gi2 := l_gi + l_round
									from
									until
										not (not js.loop_done and then ((a_goodword[l_gi2]).to_integer_32 = (a_badword[l_bi2]).to_integer_32))
									loop
										if (a_goodword[l_gi2]).to_integer_32 = 0 then
											l_minscore := l_score_off
											js.break
										end
										if not js.loop_jumped then
											l_bi2 := l_bi2 + 1
											l_gi2 := l_gi2 + 1
										end
									end
								else
									l_stack[l_stackidx].badi := (l_bi + 1) - l_round
									l_stack[l_stackidx].goodi := l_gi + l_round
									l_stack[l_stackidx].score := l_score_off
									l_stackidx := l_stackidx + 1
								end
							end
							l_round := l_round + 1
						end
						if l_score + 75 < l_minscore then
							if l_gc = (a_badword[(l_bi + 1)]).to_integer_32 then
								if l_bc = (a_goodword[(l_gi + 1)]).to_integer_32 then
									l_gi := l_gi + (2)
									l_bi := l_bi + (2)
									l_score := l_score + (75)
									js.continue
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 30 -- skip if block
						end
				when 21 then -- if:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_bc >= 128 then
							l_tmp___5 := (mbyte_inst.utf_fold (l_bc))
						else
							l_pos := -1 + 24 -- goto _L
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L:
						if l_bc < 256 then
							l_tmp___4 := (spelltab.item.st_fold[l_bc]).to_integer_32
						else
							l_tmp___4 := (towlower (l_bc.to_natural_32)).to_integer_32
						end
						l_tmp___5 := l_tmp___4
				when 25 then
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_gc >= 128 then
							l_tmp___9 := (mbyte_inst.utf_fold (l_gc))
						else
							l_pos := -1 + 28 -- goto _L___0
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L___0:
						if l_gc < 256 then
							l_tmp___8 := (spelltab.item.st_fold[l_gc]).to_integer_32
						else
							l_tmp___8 := (towlower (l_gc.to_natural_32)).to_integer_32
						end
						l_tmp___9 := l_tmp___8
				when 29 then
						if l_tmp___5 = l_tmp___9 then
							l_score := l_score + (52)
						elseif not a_slang.is_void then
							if (a_slang.item.sl_has_map).to_boolean then
								if (similar_chars (a_slang, l_gc, l_bc)).to_boolean then
									l_score := l_score + (33)
								else
									l_score := l_score + (93)
								end
							else
								l_score := l_score + (93)
							end
						else
							l_score := l_score + (93)
						end
						if l_score < l_minscore then
							l_gi := l_gi + 1
							l_bi := l_bi + 1
							js.continue
						end
				when 30 then -- if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | pop:
						if l_stackidx = 0 then
							js.break
						end
				when 32 then -- if done
						if not js.loop_jumped then
							l_stackidx := l_stackidx - 1
							l_gi := l_stack[l_stackidx].goodi
							l_bi := l_stack[l_stackidx].badi
							l_score := l_stack[l_stackidx].score
						end
						if js.loop_increment then
							
						end
						l_pos := -1 + 2 -- back to loop condition
				when 33 then -- loop done
						if l_minscore > a_limit then
							Result := 999_999
							js.return
						end
				when 34 then -- if done
					if not js.return_called then
						Result := l_minscore
					end
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_edit_score_limit_w (a_slang: CE_POINTER [PD_SLANG_S]; a_badword: CE_POINTER [NATURAL_8]; a_goodword: CE_POINTER [NATURAL_8]; a_limit: INTEGER_32): INTEGER_32
		local
			l_stack: CE_ARRAY [PD_LIMITSCORE_T]
			l_stackidx: INTEGER_32
			l_bi: INTEGER_32
			l_gi: INTEGER_32
			l_bi2: INTEGER_32
			l_gi2: INTEGER_32
			l_bc: INTEGER_32
			l_gc: INTEGER_32
			l_score: INTEGER_32
			l_score_off: INTEGER_32
			l_minscore: INTEGER_32
			l_round: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_wbadword: CE_ARRAY [INTEGER_32]
			l_wgoodword: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_stack.make (<<10>>)
			create l_p___0.make (<<1>>)
			create l_wbadword.make (<<250>>)
			create l_wgoodword.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bi := 0
					l_p___0.item := a_badword
					from
					until
						(l_p___0.item.item).to_integer_32 = 0
					loop
						l_tmp := l_bi
						l_bi := l_bi + 1
						l_wbadword[l_tmp] := mbyte_inst.mb_cptr2char_adv (l_p___0)
					end
					l_tmp___0 := l_bi
					l_bi := l_bi + 1
					l_wbadword[l_tmp___0] := 0
					l_gi := 0
					l_p___0.item := a_goodword
					from
					until
						(l_p___0.item.item).to_integer_32 = 0
					loop
						l_tmp___1 := l_gi
						l_gi := l_gi + 1
						l_wgoodword[l_tmp___1] := mbyte_inst.mb_cptr2char_adv (l_p___0)
					end
					l_tmp___2 := l_gi
					l_gi := l_gi + 1
					l_wgoodword[l_tmp___2] := 0
					l_stackidx := 0
					l_bi := 0
					l_gi := 0
					l_score := 0
					l_minscore := a_limit + 1
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 32 -- skip loop
					end
				when 2 then -- loop body: | loop condition:
						if js.loop_done then
							l_pos := -1 + 7 -- skip loop
						end
				when 3 then -- loop body:
						l_bc := l_wbadword[l_bi]
						l_gc := l_wgoodword[l_gi]
						if l_bc /= l_gc then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_bc = 0 then
							if l_score < l_minscore then
								l_minscore := l_score
							end
							l_pos := -1 + 30 -- goto pop
						end
				when 5 then
						l_bi := l_bi + 1
						l_gi := l_gi + 1
				when 6 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 7 then -- loop done
						if l_gc /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 11 -- skip loop
						end
				when 9 then -- loop body:
						l_score := l_score + (94)
						if l_score >= l_minscore then
							l_pos := -1 + 30 -- goto pop
						end
				when 10 then
						l_bi := l_bi + 1
						if l_wbadword[l_bi] = 0 then
							js.break
						end
						l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
						l_minscore := l_score
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 13 then -- else:
						if l_bc /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 17 -- skip loop
						end
				when 15 then -- loop body:
						l_score := l_score + (96)
						if l_score >= l_minscore then
							l_pos := -1 + 30 -- goto pop
						end
				when 16 then
						l_gi := l_gi + 1
						if l_wgoodword[l_gi] = 0 then
							js.break
						end
						l_pos := -1 + 14 -- back to loop condition
				when 17 then -- loop done
						l_minscore := l_score
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 19 then -- else:
						l_round := 0
						from
						until
							not (not js.loop_done and then (l_round <= 1))
						loop
							if l_round = 0 then
								l_tmp___3 := 94
							else
								l_tmp___3 := 96
							end
							l_score_off := l_score + l_tmp___3
							if l_score_off < l_minscore then
								if l_score_off + 33 >= l_minscore then
									l_bi2 := (l_bi + 1) - l_round
									l_gi2 := l_gi + l_round
									from
									until
										not (not js.loop_done and then (l_wgoodword[l_gi2] = l_wbadword[l_bi2]))
									loop
										if l_wgoodword[l_gi2] = 0 then
											l_minscore := l_score_off
											js.break
										end
										if not js.loop_jumped then
											l_bi2 := l_bi2 + 1
											l_gi2 := l_gi2 + 1
										end
									end
								else
									l_stack[l_stackidx].badi := (l_bi + 1) - l_round
									l_stack[l_stackidx].goodi := l_gi + l_round
									l_stack[l_stackidx].score := l_score_off
									l_stackidx := l_stackidx + 1
								end
							end
							l_round := l_round + 1
						end
						if l_score + 75 < l_minscore then
							if l_gc = l_wbadword[l_bi + 1] then
								if l_bc = l_wgoodword[l_gi + 1] then
									l_gi := l_gi + (2)
									l_bi := l_bi + (2)
									l_score := l_score + (75)
									js.continue
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 29 -- skip if block
						end
				when 20 then -- if:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if l_bc >= 128 then
							l_tmp___8 := (mbyte_inst.utf_fold (l_bc))
						else
							l_pos := -1 + 23 -- goto _L
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L:
						if l_bc < 256 then
							l_tmp___7 := (spelltab.item.st_fold[l_bc]).to_integer_32
						else
							l_tmp___7 := (towlower (l_bc.to_natural_32)).to_integer_32
						end
						l_tmp___8 := l_tmp___7
				when 24 then
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if l_gc >= 128 then
							l_tmp___12 := (mbyte_inst.utf_fold (l_gc))
						else
							l_pos := -1 + 27 -- goto _L___0
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___0:
						if l_gc < 256 then
							l_tmp___11 := (spelltab.item.st_fold[l_gc]).to_integer_32
						else
							l_tmp___11 := (towlower (l_gc.to_natural_32)).to_integer_32
						end
						l_tmp___12 := l_tmp___11
				when 28 then
						if l_tmp___8 = l_tmp___12 then
							l_score := l_score + (52)
						elseif not a_slang.is_void then
							if (a_slang.item.sl_has_map).to_boolean then
								if (similar_chars (a_slang, l_gc, l_bc)).to_boolean then
									l_score := l_score + (33)
								else
									l_score := l_score + (93)
								end
							else
								l_score := l_score + (93)
							end
						else
							l_score := l_score + (93)
						end
						if l_score < l_minscore then
							l_gi := l_gi + 1
							l_bi := l_bi + 1
							js.continue
						end
				when 29 then -- if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 31 -- skip if block
						end
				when 30 then -- if: | pop:
						if l_stackidx = 0 then
							js.break
						end
				when 31 then -- if done
						if not js.loop_jumped then
							l_stackidx := l_stackidx - 1
							l_gi := l_stack[l_stackidx].goodi
							l_bi := l_stack[l_stackidx].badi
							l_score := l_stack[l_stackidx].score
						end
						if js.loop_increment then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 32 then -- loop done
					if l_minscore > a_limit then
						Result := 999_999
						js.return
					end
					if not js.return_called then
						Result := l_minscore
					end
				when 33 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_enc: CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc.item))) < {NATURAL_32} 60 then
				if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc.item), ce_string ("iso-8859-15"))) /= 0 then
					Result := (option_inst.p_enc.item)
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("latin1")))
			end
		end

	spell_expand_check_cap (a_col: INTEGER_32)
		do
			spell_expand_need_cap := check_need_cap (globals_inst.curwin.item.w_cursor.lnum, a_col)
		end

	spell_find_cleanup (a_su: CE_POINTER [PD_SUGINFO_S])
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_su.item.su_ga.ga_len)
			loop
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_su.item.su_ga.ga_data) + l_i___0).item.st_word))
				l_i___0 := l_i___0 + 1
			end
			misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")))
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_su.item.su_sga.ga_len)
			loop
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_su.item.su_sga.ga_data) + l_i___0).item.st_word))
				l_i___0 := l_i___0 + 1
			end
			misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga")))
			hashtab_inst.hash_clear_all (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned")), 0)
		end

	spell_find_suggest (a_badptr: CE_POINTER [NATURAL_8]; a_badlen: INTEGER_32; a_su: CE_POINTER [PD_SUGINFO_S]; a_maxcount: INTEGER_32; a_banbadword: INTEGER_32; a_need_cap: INTEGER_32; a_interactive: INTEGER_32)
		local
			l_attr: CE_ARRAY [NATURAL_32]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_do_combine: INTEGER_32
			l_sps_copy: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_lp: CE_POINTER [PD_LANGP_S]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_attr.make (<<1>>)
			create l_buf___6.make (<<4_096>>)
			create l_p___0.make (<<1>>)
			create l_sps_copy.make
			create l_lp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_attr.item := {PC_HLF_T}.HLF_COUNT
					l_do_combine := 0
					memset (create {CE_POINTER [ANY]}.make_cast (a_su), 0, (create {PD_SUGINFO_S}.make).structure_size.to_natural_32).do_nothing
					misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), ((create {PD_SUGGEST_S}.make).structure_size.to_natural_32).to_integer_32, 10)
					misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga")), ((create {PD_SUGGEST_S}.make).structure_size.to_natural_32).to_integer_32, 10)
					if (a_badptr.item).to_integer_32 = 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned")))
						a_su.item.su_badptr := a_badptr
						if a_badlen /= 0 then
							a_su.item.su_badlen := a_badlen
						else
							a_su.item.su_badlen := spell_check (globals_inst.curwin, a_su.item.su_badptr, l_attr, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
						end
						a_su.item.su_maxcount := a_maxcount
						a_su.item.su_maxscore := 350
						if a_su.item.su_badlen >= 250 then
							a_su.item.su_badlen := 249
						end
						misc2_inst.vim_strncpy (a_su.item.su_badword, a_su.item.su_badptr, (a_su.item.su_badlen).to_natural_32)
						spell_casefold (a_su.item.su_badptr, a_su.item.su_badlen, a_su.item.su_fbadword, 250).do_nothing
						a_su.item.su_badflags := badword_captype (a_su.item.su_badptr, a_su.item.su_badptr + a_su.item.su_badlen)
						if a_need_cap.to_boolean then
							a_su.item.su_badflags := (a_su.item.su_badflags).bit_or ((2))
						end
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0 < globals_inst.curbuf.item.b_s.b_langp.ga_len))
						loop
							l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast (globals_inst.curbuf.item.b_s.b_langp.ga_data) + l_i___0
							if not (l_lp.item.lp_sallang).is_void then
								a_su.item.su_sallang := l_lp.item.lp_sallang
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						if not (a_su.item.su_sallang).is_void then
							spell_soundfold (a_su.item.su_sallang, a_su.item.su_fbadword, 1, a_su.item.su_sal_badword)
						end
						if globals_inst.has_mbyte.to_boolean then
							l_c := (globals_inst.mb_ptr2char.integer_32_item ([a_su.item.su_badptr]))
						else
							l_c := ((a_su.item.su_badptr).item).to_integer_32
						end
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_c >= 128 then
							l_tmp___3 := (mbyte_inst.utf_isupper (l_c))
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_c < 256 then
							l_tmp___2 := (spelltab.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___2 := (iswupper (l_c.to_natural_32))
						end
						l_tmp___3 := l_tmp___2
				when 5 then
						if not l_tmp___3.to_boolean then
							if l_attr.item = {NATURAL_32} 41 then
								make_case_word (a_su.item.su_badword, l_buf___6, 2)
								add_suggestion (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_buf___6, a_su.item.su_badlen, 52, 0, 1, a_su.item.su_sallang, 0)
							end
						end
						if a_banbadword.to_boolean then
							add_banned (a_su, a_su.item.su_badword)
						end
						l_sps_copy := misc2_inst.vim_strsave (option_inst.p_sps.item)
						if l_sps_copy.is_void then
							js.return
						end
				when 6 then -- if done
					if not js.return_called then
						l_p___0.item := l_sps_copy
						from
						until
							(l_p___0.item.item).to_integer_32 = 0
						loop
							misc2_inst.copy_option_part (l_p___0, l_buf___6, 4_096, ce_string (",")).do_nothing
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("expr:"), (5).to_natural_32)) = 0 then
								if not expr_busy.to_boolean then
									expr_busy := 1
									spell_suggest_expr (a_su, l_buf___6 + 5)
									expr_busy := 0
								end
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("file:"), (5).to_natural_32)) = 0 then
								spell_suggest_file (a_su, l_buf___6 + 5)
							else
								spell_suggest_intern (a_su, a_interactive)
								if ((sps_flags).bit_and (4)).to_boolean then
									l_do_combine := 1
								end
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sps_copy))
						if l_do_combine.to_boolean then
							score_combine (a_su)
						end
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_free_aff (a_aff: CE_POINTER [PD_AFFFILE_S])
		local
			l_ht: CE_POINTER [PD_HASHTABLE_S]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_todo: INTEGER_32
			l_ah: CE_POINTER [PD_AFFHEADER_S]
			l_ae: CE_POINTER [PD_AFFENTRY_S]
			js: JUMP_STATE
		do
			create l_ht.make
			create l_hi___1.make
			create l_ah.make
			create l_ae.make

			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_aff.item.af_enc))
			l_ht := create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref"))
			from
			until
				js.loop_done
			loop
				l_todo := (l_ht.item.ht_used).to_integer_32
				l_hi___1 := l_ht.item.ht_array
				from
				until
					not (not js.loop_done and then (l_todo > 0))
				loop
					if not ((l_hi___1.item.hi_key).is_void) then
						if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_todo := l_todo - 1
							l_ah := create {CE_POINTER [PD_AFFHEADER_S]}.make_cast (l_hi___1.item.hi_key)
							l_ae := l_ah.item.ah_first
							from
							until
								l_ae.is_void
							loop
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ae.item.ae_prog))
								l_ae := l_ae.item.ae_next
							end
						end
					end
					l_hi___1 := l_hi___1 + 1
				end
				if l_ht.is_equal (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff"))) then
					js.break
				end
				if not js.loop_jumped then
					l_ht := create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff"))
				end
			end
			hashtab_inst.hash_clear (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref")))
			hashtab_inst.hash_clear (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff")))
			hashtab_inst.hash_clear (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp")))
		end

	spell_free_all
		local
			l_slang: CE_POINTER [PD_SLANG_S]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_fname: CE_ARRAY [NATURAL_8]
		do
			create l_slang.make
			create l_buf___6.make
			create l_fname.make (<<4_096>>)

			l_buf___6 := globals_inst.firstbuf
			from
			until
				l_buf___6.is_void
			loop
				misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s") + (create {PD_SYNBLOCK_T}.make).offset_of ("b_langp")))
				l_buf___6 := l_buf___6.item.b_next
			end
			from
			until
				first_lang.is_void
			loop
				l_slang := first_lang
				first_lang := l_slang.item.sl_next
				slang_free (l_slang)
			end
			if not int_wordlist.is_void then
				unlink (create {CE_POINTER [INTEGER_8]}.make_cast (int_wordlist)).do_nothing
				int_wordlist_spl (l_fname)
				unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)).do_nothing
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (int_wordlist))
				int_wordlist := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			init_spell_chartab
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (repl_to))
			repl_to := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (repl_from))
			repl_from := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
		end

	spell_info_item (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___5: INTEGER_32
		do
			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), ce_string ("NAME"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), ce_string ("HOME"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), ce_string ("VERSION"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), ce_string ("AUTHOR"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), ce_string ("EMAIL"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), ce_string ("COPYRIGHT"))) = 0 then
				l_tmp___5 := 1
			else
				l_tmp___5 := 0
			end
			Result := l_tmp___5
		end

	spell_iswordp (a_p___0: CE_POINTER [NATURAL_8]; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_c: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			if globals_inst.has_mbyte.to_boolean then
				l_l := (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32
				l_s := a_p___0
				if l_l = 1 then
					if ((a_wp___0.item.w_s).item.b_spell_ismw[(a_p___0.item).to_integer_32]).to_boolean then
						l_s := a_p___0 + 1
						l_l := (globals_inst.mb_bytelen_tab[(l_s.item).to_integer_32]).to_integer_32
					end
				else
					l_c := globals_inst.mb_ptr2char.integer_32_item ([a_p___0])
					if l_c < 256 then
						l_tmp___1 := ((a_wp___0.item.w_s).item.b_spell_ismw[l_c]).to_integer_32
					else
						if not ((a_wp___0.item.w_s).item.b_spell_ismw_mb).is_void then
							if not (misc2_inst.vim_strchr ((a_wp___0.item.w_s).item.b_spell_ismw_mb, l_c)).is_void then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						l_tmp___1 := l_tmp___0
					end
					if l_tmp___1.to_boolean then
						l_s := a_p___0 + l_l
						l_l := (globals_inst.mb_bytelen_tab[(l_s.item).to_integer_32]).to_integer_32
					end
				end
				l_c := globals_inst.mb_ptr2char.integer_32_item ([l_s])
				if l_c > 255 then
					Result := (spell_mb_isword_class ((mbyte_inst.mb_get_class (l_s))))
					js.return
				end
				if not js.return_called then
					Result := (spelltab.item.st_isw[l_c]).to_integer_32
					js.return
				end
			end
			if not js.return_called then
				if ((a_wp___0.item.w_s).item.b_spell_ismw[(a_p___0.item).to_integer_32]).to_boolean then
					l_tmp___4 := (a_p___0[1]).to_integer_32
				else
					l_tmp___4 := (a_p___0[0]).to_integer_32
				end
				Result := (spelltab.item.st_isw[l_tmp___4]).to_integer_32
			end
		end

	spell_iswordp_nmw (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.has_mbyte.to_boolean then
				l_c := globals_inst.mb_ptr2char.integer_32_item ([a_p___0])
				if l_c > 255 then
					Result := (spell_mb_isword_class ((mbyte_inst.mb_get_class (a_p___0))))
					js.return
				end
				if not js.return_called then
					Result := (spelltab.item.st_isw[l_c]).to_integer_32
					js.return
				end
			end
			if not js.return_called then
				Result := (spelltab.item.st_isw[(a_p___0.item).to_integer_32]).to_integer_32
			end
		end

	spell_iswordp_w (a_p___0: CE_POINTER [INTEGER_32]; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_32]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			if a_p___0.item < 256 then
				l_tmp___1 := ((a_wp___0.item.w_s).item.b_spell_ismw[a_p___0.item]).to_integer_32
			else
				if not ((a_wp___0.item.w_s).item.b_spell_ismw_mb).is_void then
					if not (misc2_inst.vim_strchr ((a_wp___0.item.w_s).item.b_spell_ismw_mb, a_p___0.item)).is_void then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
				l_tmp___1 := l_tmp___0
			end
			if l_tmp___1.to_boolean then
				l_s := a_p___0 + 1
			else
				l_s := a_p___0
			end
			if l_s.item > 255 then
				if globals_inst.enc_utf8.to_boolean then
					Result := (spell_mb_isword_class ((mbyte_inst.utf_class (l_s.item))))
					js.return
				end
				if not js.return_called and then (globals_inst.enc_dbcs.to_boolean) then
					Result := ((mbyte_inst.dbcs_class (((l_s.item).to_natural_32).bit_shift_right (8), ((l_s.item).bit_and (255)).to_natural_32)) >= 2).to_integer
					js.return
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (spelltab.item.st_isw[l_s.item]).to_integer_32
			end
		end

	spell_load_cb (a_fname: CE_POINTER [NATURAL_8]; a_cookie: CE_POINTER [ANY])
		local
			l_slp: CE_POINTER [PD_SPELLOAD_S]
			l_slang: CE_POINTER [PD_SLANG_S]
			l_pos: INTEGER_32
		do
			create l_slp.make
			create l_slang.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_slp := create {CE_POINTER [PD_SPELLOAD_S]}.make_cast (a_cookie)
					l_slang := spell_load_file (a_fname, l_slp.item.sl_lang, create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer), 0)
					if l_slang.is_void then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not ((l_slp.item.sl_nobreak).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_slang.item.sl_add).to_boolean then
							l_slang.item.sl_nobreak := (1).to_natural_8
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (l_slang.item.sl_nobreak).to_boolean then
							l_slp.item.sl_nobreak := 1
						end
				when 5 then
						l_slp.item.sl_slang := l_slang
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_load_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent spell_load_cb)
		end

	spell_load_file (a_fname: CE_POINTER [NATURAL_8]; a_lang: CE_POINTER [NATURAL_8]; a_old_lp: CE_POINTER [PD_SLANG_S]; a_silent: INTEGER_32): CE_POINTER [PD_SLANG_S]
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_len: INTEGER_32
			l_save_sourcing_name: CE_POINTER [NATURAL_8]
			l_save_sourcing_lnum: INTEGER_32
			l_lp: CE_POINTER [PD_SLANG_S]
			l_c: INTEGER_32
			l_res: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fd.make
			create l_buf___6.make (<<8>>)
			create l_p___0.make
			create l_save_sourcing_name.make
			create l_lp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_save_sourcing_name := globals_inst.sourcing_name
					l_save_sourcing_lnum := globals_inst.sourcing_lnum
					l_lp := create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
					l_c := 0
					l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), ce_string ("r"))
					if l_fd.is_void then
						if not a_silent.to_boolean then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_fname).do_nothing
						elseif option_inst.p_verbose.item > 2 then
							message_inst.verbose_enter
							message_inst.smsg ([globals_inst.e_notopen, a_fname]).do_nothing
							message_inst.verbose_leave
						end
						l_pos := -1 + 48 -- goto endFAIL
					end
				when 1 then
					if option_inst.p_verbose.item > 2 then
						message_inst.verbose_enter
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Reading spell file %"%%s%"")))), a_fname]).do_nothing
						message_inst.verbose_leave
					end
					if not (a_old_lp.is_void) then
						l_pos := -1 + 6 -- skip if block
					end
				when 2 then -- if:
						l_lp := slang_alloc (a_lang)
						if l_lp.is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 3 then
						l_lp.item.sl_fname := misc2_inst.vim_strsave (a_fname)
						if (l_lp.item.sl_fname).is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 4 then
						l_lp.item.sl_add := (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (a_fname))), ce_string (".add."))).is_void).to_integer
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_lp := a_old_lp
				when 7 then -- if done
					globals_inst.sourcing_name := a_fname
					globals_inst.sourcing_lnum := (0).to_integer_32
					l_i___0 := 0
					from
					until
						not (l_i___0 < 8)
					loop
						l_buf___6[l_i___0] := (IO_getc (l_fd)).to_natural_8
						l_i___0 := l_i___0 + 1
					end
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("VIMspell"), (8).to_natural_32)) /= 0 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E757: This does not look like a spell file"))))).do_nothing
						l_pos := -1 + 48 -- goto endFAIL
					end
				when 8 then
					l_c := IO_getc (l_fd)
					if l_c < 50 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E771: Old spell file, needs to be updated"))))).do_nothing
						l_pos := -1 + 48 -- goto endFAIL
					elseif l_c > 50 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E772: Spell file is for newer version of Vim"))))).do_nothing
						l_pos := -1 + 48 -- goto endFAIL
					end
				when 9 then
					if js.loop_done then
						l_pos := -1 + 44 -- skip loop
					end
				when 10 then -- loop body:
						l_n := IO_getc (l_fd)
						if l_n = 255 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 43 -- skip if block
						end
				when 11 then -- if:
						l_c := IO_getc (l_fd)
						l_len := misc2_inst.get4c (l_fd)
						if l_len < 0 then
							l_pos := -1 + 41 -- goto truncerr
						end
				when 12 then
						l_res := 0
						inspect l_n -- switch 1 head
						when 15 then l_pos := -1 + 13
						when 0 then l_pos := -1 + 15
						when 1 then l_pos := -1 + 16
						when 2 then l_pos := -1 + 17
						when 3 then l_pos := -1 + 19
						when 4 then l_pos := -1 + 20
						when 12 then l_pos := -1 + 21
						when 5 then l_pos := -1 + 22
						when 6 then l_pos := -1 + 23
						when 7 then l_pos := -1 + 24
						when 13 then l_pos := -1 + 26
						when 11 then l_pos := -1 + 27
						when 14 then l_pos := -1 + 28
						when 8 then l_pos := -1 + 29
						when 10 then l_pos := -1 + 30
						when 9 then l_pos := -1 + 31
						else l_pos := -1 + 34
						end
				when 13 then -- switch 1, case 15
						l_lp.item.sl_info := misc2_inst.read_string (l_fd, l_len)
						if (l_lp.item.sl_info).is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 14 then
						l_pos := -1 + 39 -- switch 1; break
				when 15 then -- switch 1, case 0
						l_res := read_region_section (l_fd, l_lp, l_len)
						l_pos := -1 + 39 -- switch 1; break
				when 16 then -- switch 1, case 1
						l_res := read_charflags_section (l_fd)
						l_pos := -1 + 39 -- switch 1; break
				when 17 then -- switch 1, case 2
						l_lp.item.sl_midword := misc2_inst.read_string (l_fd, l_len)
						if (l_lp.item.sl_midword).is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 18 then
						l_pos := -1 + 39 -- switch 1; break
				when 19 then -- switch 1, case 3
						l_res := read_prefcond_section (l_fd, l_lp)
						l_pos := -1 + 39 -- switch 1; break
				when 20 then -- switch 1, case 4
						l_res := read_rep_section (l_fd, create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep")), l_lp.item.sl_rep_first)
						l_pos := -1 + 39 -- switch 1; break
				when 21 then -- switch 1, case 12
						l_res := read_rep_section (l_fd, create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal")), l_lp.item.sl_repsal_first)
						l_pos := -1 + 39 -- switch 1; break
				when 22 then -- switch 1, case 5
						l_res := read_sal_section (l_fd, l_lp)
						l_pos := -1 + 39 -- switch 1; break
				when 23 then -- switch 1, case 6
						l_res := read_sofo_section (l_fd, l_lp)
						l_pos := -1 + 39 -- switch 1; break
				when 24 then -- switch 1, case 7
						l_p___0 := misc2_inst.read_string (l_fd, l_len)
						if l_p___0.is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 25 then
						set_map_str (l_lp, l_p___0)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						l_pos := -1 + 39 -- switch 1; break
				when 26 then -- switch 1, case 13
						l_res := read_words_section (l_fd, l_lp, l_len)
						l_pos := -1 + 39 -- switch 1; break
				when 27 then -- switch 1, case 11
						l_lp.item.sl_sugtime := misc2_inst.get8ctime (l_fd)
						l_pos := -1 + 39 -- switch 1; break
				when 28 then -- switch 1, case 14
						l_lp.item.sl_nosplitsugs := 1
						l_pos := -1 + 39 -- switch 1; break
				when 29 then -- switch 1, case 8
						l_res := read_compound (l_fd, l_lp, l_len)
						l_pos := -1 + 39 -- switch 1; break
				when 30 then -- switch 1, case 10
						l_lp.item.sl_nobreak := (1).to_natural_8
						l_pos := -1 + 39 -- switch 1; break
				when 31 then -- switch 1, case 9
						l_lp.item.sl_syllable := misc2_inst.read_string (l_fd, l_len)
						if (l_lp.item.sl_syllable).is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 32 then
						if (init_syl_tab (l_lp)) = 0 then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 33 then
						l_pos := -1 + 39 -- switch 1; break
				when 34 then -- switch 1, default:
						if ((l_c).bit_and (1)).to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E770: Unsupported section in spell file"))))).do_nothing
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 35 then
						if js.loop_done then
							l_pos := -1 + 38 -- skip loop
						end
				when 36 then -- loop body:
						l_len := l_len - 1
						if not (l_len >= 0) then
							js.break
						end
						if not js.loop_jumped then
							if (IO_getc (l_fd)) < 0 then
								l_pos := -1 + 41 -- goto truncerr
							end
						end
				when 37 then
						l_pos := -1 + 35 -- back to loop condition
				when 38 then -- loop done
						l_pos := -1 + 39 -- switch 1; break
				when 39 then -- switch 1, done: | someerror:
						if l_res = -2 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_format)))).do_nothing
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 40 then
						if l_res /= -1 then
							l_pos := -1 + 42 -- skip if block
						end
				when 41 then -- if: | truncerr:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_spell_trunc)))).do_nothing
						l_pos := -1 + 48 -- goto endFAIL
				when 42 then
						if l_res = -3 then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 43 then
						l_pos := -1 + 9 -- back to loop condition
				when 44 then -- loop done
					l_res := spell_read_tree (l_fd, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_fbyts")), create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_fidxs")), 0, 0)
					if l_res /= 0 then
						l_pos := -1 + 39 -- goto someerror
					end
				when 45 then
					l_res := spell_read_tree (l_fd, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_kbyts")), create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_kidxs")), 0, 0)
					if l_res /= 0 then
						l_pos := -1 + 39 -- goto someerror
					end
				when 46 then
					l_res := spell_read_tree (l_fd, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_pbyts")), create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_pidxs")), 1, l_lp.item.sl_prefixcnt)
					if l_res /= 0 then
						l_pos := -1 + 39 -- goto someerror
					end
				when 47 then
					if a_old_lp.is_void then
						if not a_lang.is_void then
							l_lp.item.sl_next := first_lang
							first_lang := l_lp
						end
					end
					l_pos := -1 + 49 -- goto endOK
				when 48 then -- endFAIL:
					if not a_lang.is_void then
						a_lang.item := (('%/0/').code).to_natural_8
					end
					if not l_lp.is_void then
						if a_old_lp.is_void then
							slang_free (l_lp)
						end
					end
					l_lp := create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
				when 49 then -- endOK:
					if not l_fd.is_void then
						fclose (l_fd).do_nothing
					end
					globals_inst.sourcing_name := l_save_sourcing_name
					globals_inst.sourcing_lnum := l_save_sourcing_lnum
					Result := l_lp
				when 50 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_load_lang (a_lang: CE_POINTER [NATURAL_8])
		local
			l_fname_enc: CE_ARRAY [NATURAL_8]
			l_r: INTEGER_32
			l_sl: CE_ARRAY [PD_SPELLOAD_S]
			l_round: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_fname_enc.make (<<85>>)
			create l_sl.make (<<1>>)
			create l_tmp___1.make

			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_sl.item.sl_lang)), create {CE_POINTER [INTEGER_8]}.make_cast (a_lang)).do_nothing
			l_sl.item.sl_slang := create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
			l_sl.item.sl_nobreak := 0
			l_round := 1
			from
			until
				not (not js.loop_done and then (l_round <= 2))
			loop
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_fname_enc), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (85).to_natural_32) - {NATURAL_32} 5, ce_string ("spell/%%s.%%s.spl"), a_lang, (spell_enc)]).do_nothing
				l_r := ex_cmds2_inst.do_in_runtimepath (l_fname_enc, 0, spell_load_cb_address, create {CE_POINTER [ANY]}.make_cast (l_sl))
				if l_r = 0 then
					if (l_sl.item.sl_lang[0]).to_integer_32 /= 0 then
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_fname_enc), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (85).to_natural_32) - {NATURAL_32} 5, ce_string ("spell/%%s.ascii.spl"), a_lang]).do_nothing
						l_r := ex_cmds2_inst.do_in_runtimepath (l_fname_enc, 0, spell_load_cb_address, create {CE_POINTER [ANY]}.make_cast (l_sl))
						if l_r = 0 then
							if (l_sl.item.sl_lang[0]).to_integer_32 /= 0 then
								if l_round = 1 then
									if (fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_SPELLFILEMISSING, a_lang, globals_inst.curbuf.item.b_fname, 0, globals_inst.curbuf)).to_boolean then
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped then
							js.break
						end
					end
				end
				if not js.loop_jumped then
					js.break
				end
				if js.loop_increment then
					l_round := l_round + 1
				end
			end
			if l_r = 0 then
				l_tmp___1 := spell_enc
				message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Warning: Cannot find word list %"%%s.%%s.spl%" or %"%%s.ascii.spl%"")))), a_lang, l_tmp___1, a_lang]).do_nothing
			elseif not (l_sl.item.sl_slang).is_void then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (((l_fname_enc + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname_enc))).to_integer_32) - 3)), ce_string ("add.spl")).do_nothing
				ex_cmds2_inst.do_in_runtimepath (l_fname_enc, 1, spell_load_cb_address, create {CE_POINTER [ANY]}.make_cast (l_sl)).do_nothing
			end
		end

	spell_make_sugfile (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_wfname: CE_POINTER [NATURAL_8])
		local
			l_fname: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_free_slang: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fname.make (<<4_096>>)
			create l_slang.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_free_slang := 0
					l_slang := first_lang
					from
					until
						not (not js.loop_done and then (not l_slang.is_void))
					loop
						if (misc1_inst.fullpathcmp (a_wfname, l_slang.item.sl_fname, 0)) = 1 then
							js.break
						end
						if not js.loop_jumped then
							l_slang := l_slang.item.sl_next
						end
					end
					if l_slang.is_void then
						spell_message (a_spin, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Reading back spell file...")))))
						l_slang := spell_load_file (a_wfname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer), 0)
						if l_slang.is_void then
							js.return
						end
						if not js.return_called then
							l_free_slang := 1
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						a_spin.item.si_blocks := create {CE_POINTER [PD_SBLOCK_S]}.make_shared (default_pointer)
						a_spin.item.si_blocks_cnt := 0
						a_spin.item.si_compress_cnt := 0
						a_spin.item.si_free_count := 0
						a_spin.item.si_first_free := create {CE_POINTER [PD_WORDNODE_S]}.make_shared (default_pointer)
						a_spin.item.si_foldwcount := 0
						spell_message (a_spin, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Performing soundfolding...")))))
						if (sug_filltree (a_spin, l_slang)) = 0 then
							l_pos := -1 + 4 -- goto theend
						end
				when 2 then
						if (sug_maketable (a_spin)) = 0 then
							l_pos := -1 + 4 -- goto theend
						end
				when 3 then
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Number of words after soundfolding: %%ld")))), (a_spin.item.si_spellbuf).item.b_ml.ml_line_count]).do_nothing
						spell_message (a_spin, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (msg_compressing))))
						wordtree_compress (a_spin, a_spin.item.si_foldroot)
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), create {CE_POINTER [INTEGER_8]}.make_cast (a_wfname)).do_nothing
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname))).to_integer_32
						l_fname[l_len - 2] := (('u').code).to_natural_8
						l_fname[l_len - 1] := (('g').code).to_natural_8
						sug_write (a_spin, l_fname)
				when 4 then -- theend:
						if l_free_slang.to_boolean then
							slang_free (l_slang)
						end
						free_blocks (a_spin.item.si_blocks)
						close_spellbuf (a_spin.item.si_spellbuf)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_mb_isword_class (a_cl: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_cl >= 2 then
				if a_cl /= 8_304 then
					if a_cl /= 8_320 then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	spell_message (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_str___1: CE_POINTER [NATURAL_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_spin.item.si_verbose).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (option_inst.p_verbose.item > 2) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if not (a_spin.item.si_verbose).to_boolean then
							message_inst.verbose_enter
						end
						message_inst.msg (a_str___1).do_nothing
						term_inst.out_flush
						if not (a_spin.item.si_verbose).to_boolean then
							message_inst.verbose_leave
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	spell_move_to (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_dir___0: INTEGER_32; a_allwords: INTEGER_32; a_curline: INTEGER_32; a_attrp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_lnum: INTEGER_32
			l_found_pos: PD_POS_T
			l_found_len: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_endp: CE_POINTER [NATURAL_8]
			l_attr: CE_ARRAY [NATURAL_32]
			l_len: INTEGER_32
			l_has_syntax: INTEGER_32
			l_col: INTEGER_32
			l_can_spell: CE_ARRAY [INTEGER_32]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_buflen: INTEGER_32
			l_skip___0: INTEGER_32
			l_capcol: CE_ARRAY [INTEGER_32]
			l_found_one: INTEGER_32
			l_wrapped: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_found_pos.make
			create l_line.make
			create l_p___0.make
			create l_endp.make
			create l_attr.make (<<1>>)
			create l_can_spell.make (<<1>>)
			create l_buf___6.make
			create l_capcol.make (<<1>>)
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_found_len := 0
					l_has_syntax := (syntax_inst.syntax_present (a_wp___0))
					l_buf___6 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_buflen := 0
					l_skip___0 := 0
					l_capcol.item := -1
					l_found_one := 0
					l_wrapped := 0
					if (no_spell_checking (a_wp___0)).to_boolean then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 32 -- skip if block
					end
				when 1 then -- if:
						l_lnum := a_wp___0.item.w_cursor.lnum
						l_found_pos.lnum := (0).to_integer_32
						l_found_pos.col := 0
						l_found_pos.coladd := 0
				when 2 then -- loop condition:
						if not (not js.loop_done and then (not globals_inst.got_int.to_boolean)) then
							l_pos := -1 + 32 -- skip loop
						end
				when 3 then -- loop body:
						l_line := memline_inst.ml_get_buf (a_wp___0.item.w_buffer, l_lnum, 0)
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32
						if l_buflen < (l_len + 250) + 2 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
							l_buflen := (l_len + 250) + 2
							l_buf___6 := misc2_inst.alloc (l_buflen.to_natural_32)
							if l_buf___6.is_void then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 31 -- skip if block
						end
				when 4 then -- if:
						if l_lnum = 1 then
							l_capcol.item := 0
						end
						if l_capcol.item = 0 then
							l_capcol.item := (charset_inst.skipwhite (l_line)).distance (l_line)
						elseif a_curline.to_boolean then
							if a_wp___0.is_equal (globals_inst.curwin) then
								l_col := (charset_inst.skipwhite (l_line)).distance (l_line)
								if (check_need_cap (l_lnum, l_col)).to_boolean then
									l_capcol.item := l_col
								end
								l_line := memline_inst.ml_get_buf (a_wp___0.item.w_buffer, l_lnum, 0)
							end
						end
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (l_line)).do_nothing
						if l_lnum < (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
							l_tmp___5 := memline_inst.ml_get_buf (a_wp___0.item.w_buffer, l_lnum + 1, 0)
							spell_cat_line (l_buf___6 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32, l_tmp___5, 250)
						end
						l_p___0 := l_buf___6 + l_skip___0
						l_endp := l_buf___6 + l_len
				when 5 then -- loop condition:
						if not (not js.loop_done and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_endp.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 30 -- skip loop
						end
				when 6 then -- loop body:
						if a_dir___0 = -1 then
							if l_lnum = a_wp___0.item.w_cursor.lnum then
								if not l_wrapped.to_boolean then
									if l_p___0.distance (l_buf___6) >= a_wp___0.item.w_cursor.col then
										js.break
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 29 -- skip if block
						end
				when 7 then -- if:
						l_attr.item := {PC_HLF_T}.HLF_COUNT
						l_len := spell_check (a_wp___0, l_p___0, l_attr, l_capcol, 0)
						if l_attr.item = {NATURAL_32} 41 then
							l_pos := -1 + 28 -- skip if block
						end
				when 8 then -- if:
						if not (a_allwords.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___1
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 11 then -- else:
						if l_attr.item /= {NATURAL_32} 27 then
							l_pos := -1 + 28 -- skip if block
						end
				when 12 then -- if: | _L___1:
						if a_dir___0 /= -1 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 15 then -- else:
						if l_lnum = a_wp___0.item.w_cursor.lnum then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 18 then -- else:
						if l_lnum /= a_wp___0.item.w_cursor.lnum then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if not (l_wrapped.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						if a_curline.to_boolean then
							l_tmp___7 := (l_p___0.distance (l_buf___6)) + l_len
						else
							l_tmp___7 := l_p___0.distance (l_buf___6)
						end
						if not (l_tmp___7 > a_wp___0.item.w_cursor.col) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if: | _L___0:
						if l_has_syntax.to_boolean then
							l_col := l_p___0.distance (l_buf___6)
							syntax_inst.syn_get_id (a_wp___0, l_lnum, l_col, 0, l_can_spell, 0).do_nothing
							if not (l_can_spell.item).to_boolean then
								l_attr.item := {PC_HLF_T}.HLF_COUNT
							end
						else
							l_can_spell.item := 1
						end
						if (l_can_spell.item).to_boolean then
							l_found_one := 1
							l_found_pos.lnum := l_lnum
							l_found_pos.col := l_p___0.distance (l_buf___6)
							l_found_pos.coladd := 0
							if a_dir___0 = 1 then
								a_wp___0.item.w_cursor := l_found_pos.twin
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
								if not a_attrp.is_void then
									a_attrp.item := l_attr.item
								end
								Result := l_len
								js.return
							elseif a_curline.to_boolean then
								l_found_pos.col := l_found_pos.col + l_len
							end
							if not js.return_called then
								l_found_len := l_len
							end
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_found_one := 1
				when 26 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_found_one := 1
				when 28 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							l_p___0 := l_p___0 + l_len
							l_capcol.item := l_capcol.item - l_len
						end
				when 29 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 30 then -- loop done
						if not js.return_called and then (a_dir___0 = -1) then
							if l_found_pos.lnum /= 0 then
								a_wp___0.item.w_cursor := l_found_pos.twin
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
								Result := l_found_len
								js.return
							end
						end
						if not js.return_called then
							if a_curline.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								if a_dir___0 = -1 then
									if l_lnum = a_wp___0.item.w_cursor.lnum then
										if l_wrapped.to_boolean then
											js.break
										end
									end
									if not js.loop_jumped then
										if l_lnum > 1 then
											l_lnum := l_lnum - 1
										elseif not (option_inst.p_ws.item).to_boolean then
											js.break
										else
											l_lnum := (a_wp___0.item.w_buffer).item.b_ml.ml_line_count
											l_wrapped := 1
											if not (option_inst.shortmess (('s').code)).to_boolean then
												message_inst.give_warning (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (globals_inst.top_bot_msg))), 1)
											end
										end
									end
									if not js.loop_jumped then
										l_capcol.item := -1
									end
								else
									if l_lnum < (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
										l_lnum := l_lnum + 1
									elseif not (option_inst.p_ws.item).to_boolean then
										js.break
									else
										l_lnum := (1).to_integer_32
										l_wrapped := 1
										if not (option_inst.shortmess (('s').code)).to_boolean then
											message_inst.give_warning (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (globals_inst.bot_top_msg))), 1)
										end
									end
									if not js.loop_jumped and then (l_lnum = a_wp___0.item.w_cursor.lnum) then
										if not l_found_one.to_boolean then
											js.break
										elseif l_wrapped.to_boolean then
											js.break
										end
									end
									if not js.loop_jumped then
										if l_attr.item = {NATURAL_32} 41 then
											l_skip___0 := l_p___0.distance (l_endp)
										else
											l_skip___0 := 0
										end
										l_capcol.item := l_capcol.item - 1
										if ((charset_inst.skipwhite (l_line)).item).to_integer_32 = 0 then
											l_capcol.item := 0
										end
									end
								end
							end
							if not js.loop_jumped then
								misc1_inst.line_breakcheck
							end
						end
				when 31 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 32 then -- loop done | if done
						if not js.return_called then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
							Result := 0
						end
				when 33 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	spell_read_aff (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [PD_AFFFILE_S]
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_aff: CE_POINTER [PD_AFFFILE_S]
			l_rline: CE_ARRAY [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_pc: CE_POINTER [NATURAL_8]
			l_items: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_itemcnt: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_lnum: INTEGER_32
			l_cur_aff: CE_POINTER [PD_AFFHEADER_S]
			l_did_postpone_prefix: INTEGER_32
			l_aff_todo: INTEGER_32
			l_tp: CE_POINTER [PD_HASHTABLE_S]
			l_low: CE_POINTER [NATURAL_8]
			l_fol: CE_POINTER [NATURAL_8]
			l_upp: CE_POINTER [NATURAL_8]
			l_do_rep: INTEGER_32
			l_do_repsal: INTEGER_32
			l_do_sal: INTEGER_32
			l_do_mapline: INTEGER_32
			l_found_map: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_l: INTEGER_32
			l_compminlen: INTEGER_32
			l_compsylmax: INTEGER_32
			l_compoptions: INTEGER_32
			l_compmax: INTEGER_32
			l_compflags: CE_POINTER [NATURAL_8]
			l_midword: CE_POINTER [NATURAL_8]
			l_syllable: CE_POINTER [NATURAL_8]
			l_sofofrom: CE_POINTER [NATURAL_8]
			l_sofoto: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___14: NATURAL_32
			l_tmp___15: NATURAL_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_i___0: INTEGER_32
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_lasti: INTEGER_32
			l_key: CE_ARRAY [NATURAL_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_aff_entry: CE_POINTER [PD_AFFENTRY_S]
			l_upper: INTEGER_32
			l_lasti___0: INTEGER_32
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___51: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_c: INTEGER_32
			l_c_up: INTEGER_32
			l_tmp___58: INTEGER_32
			l_tmp___61: INTEGER_32
			l_buf___7: CE_ARRAY [NATURAL_8]
			l_tmp___63: INTEGER_32
			l_tmp___65: INTEGER_32
			l_idx: INTEGER_32
			l_pp: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_n: INTEGER_32
			l_tmp___68: INTEGER_32
			l_tmp___76: INTEGER_32
			l_tmp___78: INTEGER_32
			l_tmp___79: CE_POINTER [PD_GROWARRAY]
			l_tmp___80: INTEGER_32
			l_c___0: INTEGER_32
			l_tmp___83: CE_POINTER [INTEGER_8]
			l_tmp___87: CE_POINTER [NATURAL_8]
			l_i___1: INTEGER_32
			l_tmp___149: CE_POINTER [INTEGER_8]
			l_tmp___151: CE_POINTER [INTEGER_8]
			l_tmp___152: CE_POINTER [INTEGER_8]
			l_tmp___154: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fd.make
			create l_aff.make
			create l_rline.make (<<500>>)
			create l_line.make
			create l_pc.make
			create l_items.make (<<30>>)
			create l_p___0.make (<<1>>)
			create l_cur_aff.make
			create l_tp.make
			create l_low.make
			create l_fol.make
			create l_upp.make
			create l_hi___1.make
			create l_compflags.make
			create l_midword.make
			create l_syllable.make
			create l_sofofrom.make
			create l_sofoto.make
			create l_tmp___5.make
			create l_tmp___12.make
			create l_gap.make
			create l_key.make (<<17>>)
			create l_tmp___41.make
			create l_aff_entry.make
			create l_tmp___47.make
			create l_tmp___51.make
			create l_buf___6.make (<<500>>)
			create l_buf___7.make (<<500>>)
			create l_pp.make
			create l_tmp___79.make
			create l_tmp___83.make
			create l_tmp___87.make
			create l_tmp___149.make
			create l_tmp___151.make
			create l_tmp___152.make
			create l_tmp___154.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pc := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_lnum := 0
					l_cur_aff := create {CE_POINTER [PD_AFFHEADER_S]}.make_shared (default_pointer)
					l_did_postpone_prefix := 0
					l_aff_todo := 0
					l_low := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_fol := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_upp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_found_map := 0
					l_compminlen := 0
					l_compsylmax := 0
					l_compoptions := 0
					l_compmax := 0
					l_compflags := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_midword := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_syllable := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_sofofrom := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_sofoto := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), ce_string ("r"))
					if l_fd.is_void then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_fname).do_nothing
						Result := (create {CE_POINTER [PD_AFFFILE_S]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Reading affix file %%s ..."))), a_fname]).do_nothing
						spell_message (a_spin, globals_inst.IObuff)
						l_do_rep := (a_spin.item.si_rep.ga_len = 0).to_integer
						l_do_repsal := (a_spin.item.si_repsal.ga_len = 0).to_integer
						l_do_sal := (a_spin.item.si_sal.ga_len = 0).to_integer
						l_do_mapline := (a_spin.item.si_map.ga_len = 0).to_integer
						l_aff := create {CE_POINTER [PD_AFFFILE_S]}.make_cast ((getroom (a_spin, (create {PD_AFFFILE_S}.make).structure_size.to_natural_32, 1)))
						if l_aff.is_void then
							fclose (l_fd).do_nothing
							Result := (create {CE_POINTER [PD_AFFFILE_S]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 252 -- skip if block
					end
				when 1 then -- if:
						hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref")))
						hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff")))
						hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp")))
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 232 -- skip loop
						end
				when 3 then -- loop body:
						if (fileio_inst.vim_fgets (l_rline, 500, l_fd)).to_boolean then
							js.break
						elseif globals_inst.got_int.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							misc1_inst.line_breakcheck
							l_lnum := l_lnum + 1
							if (l_rline[0]).to_integer_32 = 35 then
								js.continue
							end
						end
						if not js.loop_jumped then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pc))
							if a_spin.item.si_conv.vc_type /= 0 then
								l_pc := mbyte_inst.string_convert (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv")), l_rline, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								if l_pc.is_void then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Conversion failure for word in %%s line %%d: %%s")))), a_fname, l_lnum, l_rline]).do_nothing
									js.continue
								end
								if not js.loop_jumped then
									l_line := l_pc
								end
							else
								l_pc := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								l_line := l_rline
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 231 -- skip if block
						end
				when 4 then -- if:
						l_itemcnt := 0
						l_p___0.item := l_line
				when 5 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						from
						until
							js.loop_done
						loop
							if (l_p___0.item.item).to_integer_32 /= 0 then
								if not ((l_p___0.item.item).to_integer_32 <= 32) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.item := l_p___0.item + 1
							end
						end
						if (l_p___0.item.item).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped and then (l_itemcnt = 30) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						l_tmp___3 := l_itemcnt
						l_itemcnt := l_itemcnt + 1
						l_items[l_tmp___3] := l_p___0.item
						if l_itemcnt /= 2 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (spell_info_item (l_items[0])).to_boolean then
							from
							until
								js.loop_done
							loop
								if not ((l_p___0.item.item).to_integer_32 >= 32) then
									if (l_p___0.item.item).to_integer_32 /= 9 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_p___0.item := l_p___0.item + 1
								end
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						from
						until
							not ((l_p___0.item.item).to_integer_32 > 32)
						loop
							l_p___0.item := l_p___0.item + 1
						end
				when 11 then
						if (l_p___0.item.item).to_integer_32 = 0 then
							js.break
						end
				when 12 then -- if done
						if not js.loop_jumped then
							l_tmp___5 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_tmp___5.item := (('%/0/').code).to_natural_8
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						if not (l_itemcnt > 0) then
							l_pos := -1 + 231 -- skip if block
						end
				when 14 then -- if:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SET"), 2)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_aff.item.af_enc).is_void then
							l_aff.item.af_enc := mbyte_inst.enc_canonize (l_items[1])
							if not (l_aff.item.af_enc).is_void then
								if not (a_spin.item.si_ascii).to_boolean then
									if (mbyte_inst.convert_setup (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv")), l_aff.item.af_enc, option_inst.p_enc.item)) = 0 then
										message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Conversion in %%s not supported: from %%s to %%s")))), a_fname, l_aff.item.af_enc, option_inst.p_enc.item]).do_nothing
									end
								end
							end
							a_spin.item.si_conv.vc_fail := 1
						else
							l_pos := -1 + 17 -- goto _L___42
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 17 then -- else: | _L___42:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("FLAG"), 2)).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if l_aff.item.af_flagtype = 0 then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]), ce_string ("long"))) = 0 then
								l_aff.item.af_flagtype := 1
							elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]), ce_string ("num"))) = 0 then
								l_aff.item.af_flagtype := 3
							elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]), ce_string ("caplong"))) = 0 then
								l_aff.item.af_flagtype := 2
							else
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Invalid value for FLAG in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
							end
							if l_aff.item.af_rare /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_keepcase /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_bad /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_needaffix /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_circumfix /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_needcomp /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_comproot /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_nosuggest /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif not l_compflags.is_void then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_suff.ht_used > {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_pref.ht_used > {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							end
						else
							l_pos := -1 + 20 -- goto _L___41
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 20 then -- else: | _L___41:
						if not ((spell_info_item (l_items[0])).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if (a_spin.item.si_info).is_void then
							l_tmp___14 := (0).to_natural_32
						else
							l_tmp___14 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_info)))
						end
						l_tmp___15 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[0]))
						l_p___0.item := create {CE_POINTER [NATURAL_8]}.make_cast ((getroom (a_spin, ((l_tmp___14 + l_tmp___15) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1])))) + {NATURAL_32} 3, 0)))
						if not (l_p___0.item).is_void then
							if not (a_spin.item.si_info).is_void then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_info)).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("%N")).do_nothing
							end
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), create {CE_POINTER [INTEGER_8]}.make_cast (l_items[0])).do_nothing
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string (" ")).do_nothing
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1])).do_nothing
							a_spin.item.si_info := l_p___0.item
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 23 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("MIDWORD"), 2)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if l_midword.is_void then
							l_midword := getroom_save (a_spin, l_items[1])
						else
							l_pos := -1 + 26 -- goto _L___40
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 26 then -- else: | _L___40:
						if (is_aff_rule (l_items, l_itemcnt, ce_string ("TRY"), 2)).to_boolean then
							l_pos := -1 + 231 -- skip if block
						end
				when 27 then -- if:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("RAR"), 2)).to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L___39
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 30 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("RARE"), 2)).to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if: | _L___39:
						if l_aff.item.af_rare = {NATURAL_32} 0 then
							l_aff.item.af_rare := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 33 -- goto _L___38
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 33 then -- else: | _L___38:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("KEP"), 2)).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 37 -- goto _L___37
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 36 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("KEEPCASE"), 2)).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if: | _L___37:
						if l_aff.item.af_keepcase = {NATURAL_32} 0 then
							l_aff.item.af_keepcase := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 39 -- goto _L___36
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 39 then -- else: | _L___36:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("BAD"), 2)).to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 43 -- goto _L___35
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 42 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("FORBIDDENWORD"), 2)).to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if: | _L___35:
						if l_aff.item.af_bad = {NATURAL_32} 0 then
							l_aff.item.af_bad := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 45 -- goto _L___34
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 45 then -- else: | _L___34:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NEEDAFFIX"), 2)).to_boolean) then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if l_aff.item.af_needaffix = {NATURAL_32} 0 then
							l_aff.item.af_needaffix := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 48 -- goto _L___33
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 48 then -- else: | _L___33:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CIRCUMFIX"), 2)).to_boolean) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if l_aff.item.af_circumfix = {NATURAL_32} 0 then
							l_aff.item.af_circumfix := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 51 -- goto _L___32
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 51 then -- else: | _L___32:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NOSUGGEST"), 2)).to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						if l_aff.item.af_nosuggest = {NATURAL_32} 0 then
							l_aff.item.af_nosuggest := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 54 -- goto _L___31
						end
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 54 then -- else: | _L___31:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NEEDCOMPOUND"), 2)).to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						l_pos := -1 + 58 -- goto _L___30
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 57 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("ONLYINCOMPOUND"), 2)).to_boolean) then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if: | _L___30:
						if l_aff.item.af_needcomp = {NATURAL_32} 0 then
							l_aff.item.af_needcomp := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 60 -- goto _L___29
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 60 then -- else: | _L___29:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDROOT"), 2)).to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if l_aff.item.af_comproot = {NATURAL_32} 0 then
							l_aff.item.af_comproot := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 63 -- goto _L___28
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 63 then -- else: | _L___28:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDFORBIDFLAG"), 2)).to_boolean) then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if l_aff.item.af_compforbid = {NATURAL_32} 0 then
							l_aff.item.af_compforbid := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
							if l_aff.item.af_pref.ht_used > {NATURAL_32} 0 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Defining COMPOUNDFORBIDFLAG after PFX item may give wrong results in %%s line %%d")))), a_fname, l_lnum]).do_nothing
							end
						else
							l_pos := -1 + 66 -- goto _L___27
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 66 then -- else: | _L___27:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDPERMITFLAG"), 2)).to_boolean) then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						if l_aff.item.af_comppermit = {NATURAL_32} 0 then
							l_aff.item.af_comppermit := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
							if l_aff.item.af_pref.ht_used > {NATURAL_32} 0 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Defining COMPOUNDPERMITFLAG after PFX item may give wrong results in %%s line %%d")))), a_fname, l_lnum]).do_nothing
							end
						else
							l_pos := -1 + 69 -- goto _L___26
						end
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 69 then -- else: | _L___26:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDFLAG"), 2)).to_boolean) then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						if l_compflags.is_void then
							l_p___0.item := create {CE_POINTER [NATURAL_8]}.make_cast ((getroom (a_spin, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))) + {NATURAL_32} 2, 0)))
							if not (l_p___0.item).is_void then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1])).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("+")).do_nothing
								l_compflags := l_p___0.item
							end
						else
							l_pos := -1 + 72 -- goto _L___25
						end
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 72 then -- else: | _L___25:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDRULES"), 2)).to_boolean) then
							l_pos := -1 + 75 -- skip if block
						end
				when 73 then -- if:
						if (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))) = 0 then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Wrong COMPOUNDRULES value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
						end
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 75 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDRULE"), 2)).to_boolean) then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))).to_integer_32 + 1
						if not l_compflags.is_void then
							l_l := l_l + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_compflags))).to_integer_32 + 1)
						end
						l_p___0.item := create {CE_POINTER [NATURAL_8]}.make_cast ((getroom (a_spin, l_l.to_natural_32, 0)))
						if not (l_p___0.item).is_void then
							if not l_compflags.is_void then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), create {CE_POINTER [INTEGER_8]}.make_cast (l_compflags)).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), ce_string ("/")).do_nothing
							end
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0.item), create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1])).do_nothing
							l_compflags := l_p___0.item
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 78 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDWORDMAX"), 2)).to_boolean) then
							l_pos := -1 + 81 -- skip if block
						end
				when 79 then -- if:
						if l_compmax = 0 then
							l_compmax := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))
							if l_compmax = 0 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Wrong COMPOUNDWORDMAX value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
							end
						else
							l_pos := -1 + 81 -- goto _L___24
						end
				when 80 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 81 then -- else: | _L___24:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDMIN"), 2)).to_boolean) then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if l_compminlen = 0 then
							l_compminlen := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))
							if l_compminlen = 0 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Wrong COMPOUNDMIN value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
							end
						else
							l_pos := -1 + 84 -- goto _L___23
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 84 then -- else: | _L___23:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDSYLMAX"), 2)).to_boolean) then
							l_pos := -1 + 87 -- skip if block
						end
				when 85 then -- if:
						if l_compsylmax = 0 then
							l_compsylmax := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))
							if l_compsylmax = 0 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Wrong COMPOUNDSYLMAX value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
							end
						else
							l_pos := -1 + 87 -- goto _L___22
						end
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 87 then -- else: | _L___22:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDDUP"), 1)).to_boolean) then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						l_compoptions := (l_compoptions).bit_or ((1))
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 90 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDREP"), 1)).to_boolean) then
							l_pos := -1 + 93 -- skip if block
						end
				when 91 then -- if:
						l_compoptions := (l_compoptions).bit_or ((2))
				when 92 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 93 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDCASE"), 1)).to_boolean) then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						l_compoptions := (l_compoptions).bit_or ((4))
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 96 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDTRIPLE"), 1)).to_boolean) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						l_compoptions := (l_compoptions).bit_or ((8))
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 99 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDPATTERN"), 2)).to_boolean) then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						if (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))) = 0 then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Wrong CHECKCOMPOUNDPATTERN value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
						end
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 102 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDPATTERN"), 3)).to_boolean) then
							l_pos := -1 + 105 -- skip if block
						end
				when 103 then -- if:
						l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_comppat"))
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0 < l_gap.item.ga_len - 1))
						loop
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_gap.item.ga_data)[l_i___0]), create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))) = 0 then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_gap.item.ga_data)[(l_i___0 + 1)]), create {CE_POINTER [INTEGER_8]}.make_cast (l_items[2]))) = 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + (2)
							end
						end
						if l_i___0 >= l_gap.item.ga_len then
							if (misc2_inst.ga_grow (l_gap, 2)) = 1 then
								l_tmp___34 := l_gap.item.ga_len
								l_gap.item.ga_len := (l_gap.item.ga_len) + 1
								create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_gap.item.ga_data)[l_tmp___34] := getroom_save (a_spin, l_items[1])
								l_tmp___35 := l_gap.item.ga_len
								l_gap.item.ga_len := (l_gap.item.ga_len) + 1
								create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_gap.item.ga_data)[l_tmp___35] := getroom_save (a_spin, l_items[2])
							end
						end
				when 104 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 105 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SYLLABLE"), 2)).to_boolean) then
							l_pos := -1 + 108 -- skip if block
						end
				when 106 then -- if:
						if l_syllable.is_void then
							l_syllable := getroom_save (a_spin, l_items[1])
						else
							l_pos := -1 + 108 -- goto _L___21
						end
				when 107 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 108 then -- else: | _L___21:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NOBREAK"), 1)).to_boolean) then
							l_pos := -1 + 111 -- skip if block
						end
				when 109 then -- if:
						a_spin.item.si_nobreak := (1).to_natural_8
				when 110 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 111 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NOSPLITSUGS"), 1)).to_boolean) then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						a_spin.item.si_nosplitsugs := 1
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 114 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NOSUGFILE"), 1)).to_boolean) then
							l_pos := -1 + 117 -- skip if block
						end
				when 115 then -- if:
						a_spin.item.si_nosugfile := 1
				when 116 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 117 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("PFXPOSTPONE"), 1)).to_boolean) then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						l_aff.item.af_pfxpostpone := 1
				when 119 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 120 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[0]), ce_string ("PFX"))) /= 0 then
							l_pos := -1 + 123 -- skip if block
						end
				when 121 then -- if:
						l_pos := -1 + 124 -- goto _L___20
				when 122 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 123 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[0]), ce_string ("SFX"))) /= 0 then
							l_pos := -1 + 139 -- skip if block
						end
				when 124 then -- if: | _L___20:
						if l_aff_todo /= 0 then
							l_pos := -1 + 137 -- skip if block
						end
				when 125 then -- if:
						if not (l_itemcnt >= 4) then
							l_pos := -1 + 135 -- skip if block
						end
				when 126 then -- if:
						l_lasti := 4
						if ((l_items[0]).item).to_integer_32 = 80 then
							l_tp := create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref"))
						else
							l_tp := create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff"))
						end
						misc2_inst.vim_strncpy (l_key, l_items[1], (16).to_natural_32)
						l_hi___1 := hashtab_inst.hash_find (l_tp, l_key)
						if not ((l_hi___1.item.hi_key).is_void) then
							l_pos := -1 + 129 -- skip if block
						end
				when 127 then -- if:
						l_pos := -1 + 130 -- goto _L___0
				when 128 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 129 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if: | _L___0:
						l_cur_aff := create {CE_POINTER [PD_AFFHEADER_S]}.make_cast ((getroom (a_spin, (create {PD_AFFHEADER_S}.make).structure_size.to_natural_32, 1)))
						if l_cur_aff.is_void then
							js.break
						end
						if not js.loop_jumped then
							l_cur_aff.item.ah_flag := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
							if l_cur_aff.item.ah_flag = {NATURAL_32} 0 then
								js.break
							elseif (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))) >= {NATURAL_32} 17 then
								js.break
							end
						end
						if not js.loop_jumped then
							if l_cur_aff.item.ah_flag = l_aff.item.af_bad then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_rare then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_keepcase then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_needaffix then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_circumfix then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_nosuggest then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_needcomp then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_comproot then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"))
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							end
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_cur_aff.item.ah_key)), create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1])).do_nothing
							hashtab_inst.hash_add (l_tp, l_cur_aff.item.ah_key).do_nothing
							l_cur_aff.item.ah_combine := (((l_items[2]).item).to_integer_32 = 89).to_integer
						end
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 132 then -- else:
						l_cur_aff := create {CE_POINTER [PD_AFFHEADER_S]}.make_cast (l_hi___1.item.hi_key)
						if (l_cur_aff.item.ah_combine).to_boolean /= (((l_items[2]).item).to_integer_32 = 89) then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Different combining flag in continued affix block in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
						end
						if not (l_cur_aff.item.ah_follows).to_boolean then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Duplicate affix in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
						end
				when 133 then -- if done
						if not js.loop_jumped then
							if l_itemcnt > l_lasti then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[l_lasti]), ce_string ("S"))) = 0 then
									l_lasti := l_lasti + 1
									l_cur_aff.item.ah_follows := 1
								else
									l_cur_aff.item.ah_follows := 0
								end
							else
								l_cur_aff.item.ah_follows := 0
							end
							if l_itemcnt > l_lasti then
								if ((l_items[l_lasti]).item).to_integer_32 /= 35 then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_afftrailing))), a_fname, l_lnum, l_items[l_lasti]]).do_nothing
								end
							end
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[2]), ce_string ("Y"))) /= 0 then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[2]), ce_string ("N"))) /= 0 then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Expected Y or N in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[2]]).do_nothing
								end
							end
							if ((l_items[0]).item).to_integer_32 = 80 then
								if (l_aff.item.af_pfxpostpone).to_boolean then
									if l_cur_aff.item.ah_newID = 0 then
										check_renumber (a_spin)
										a_spin.item.si_newprefID := (a_spin.item.si_newprefID) + 1
										l_cur_aff.item.ah_newID := a_spin.item.si_newprefID
										l_did_postpone_prefix := 0
									else
										l_did_postpone_prefix := 1
									end
								end
							end
							l_aff_todo := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[3]))
						end
				when 134 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 135 then -- else:
						l_pos := -1 + 139 -- goto _L___19
				when 136 then -- if done | if block done, skip else block:
						l_pos := -1 + 138
				when 137 then -- else:
						l_pos := -1 + 139 -- goto _L___19
				when 138 then -- if done | if block done, skip else block:
						l_pos := -1 + 231
				when 139 then -- else: | _L___19:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[0]), ce_string ("PFX"))) /= 0 then
							l_pos := -1 + 142 -- skip if block
						end
				when 140 then -- if:
						l_pos := -1 + 143 -- goto _L___17
				when 141 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 142 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[0]), ce_string ("SFX"))) /= 0 then
							l_pos := -1 + 176 -- skip if block
						end
				when 143 then -- if: | _L___17:
						if not (l_aff_todo > 0) then
							l_pos := -1 + 174 -- skip if block
						end
				when 144 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_cur_aff.item.ah_key)), create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]))) /= 0 then
							l_pos := -1 + 172 -- skip if block
						end
				when 145 then -- if:
						if not (l_itemcnt >= 5) then
							l_pos := -1 + 170 -- skip if block
						end
				when 146 then -- if:
						l_upper := 0
						l_lasti___0 := 5
						if l_itemcnt > l_lasti___0 then
							if ((l_items[l_lasti___0]).item).to_integer_32 /= 35 then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[l_lasti___0]), ce_string ("-"))) /= 0 then
									l_tmp___47 := gettext (e_afftrailing)
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___47), a_fname, l_lnum, l_items[l_lasti___0]]).do_nothing
								elseif l_itemcnt /= l_lasti___0 + 1 then
									l_tmp___47 := gettext (e_afftrailing)
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___47), a_fname, l_lnum, l_items[l_lasti___0]]).do_nothing
								end
							end
						end
						l_aff_todo := l_aff_todo - 1
						l_aff_entry := create {CE_POINTER [PD_AFFENTRY_S]}.make_cast ((getroom (a_spin, (create {PD_AFFENTRY_S}.make).structure_size.to_natural_32, 1)))
						if l_aff_entry.is_void then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 169 -- skip if block
						end
				when 147 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[2]), ce_string ("0"))) /= 0 then
							l_aff_entry.item.ae_chop := getroom_save (a_spin, l_items[2])
						end
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[3]), ce_string ("0"))) /= 0 then
							l_aff_entry.item.ae_add := getroom_save (a_spin, l_items[3])
							l_aff_entry.item.ae_flags := misc2_inst.vim_strchr (l_aff_entry.item.ae_add, ('/').code)
							if not (l_aff_entry.item.ae_flags).is_void then
								l_tmp___51 := l_aff_entry.item.ae_flags
								l_aff_entry.item.ae_flags := (l_aff_entry.item.ae_flags) + 1
								l_tmp___51.item := (('%/0/').code).to_natural_8
								aff_process_flags (l_aff, l_aff_entry)
							end
						end
						if (a_spin.item.si_ascii).to_boolean then
							l_pos := -1 + 150 -- skip if block
						end
				when 148 then -- if:
						l_pos := -1 + 152 -- goto _L___3
				when 149 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 150 then -- else:
						if (has_non_ascii (l_aff_entry.item.ae_chop)).to_boolean then
							l_pos := -1 + 169 -- skip if block
						end
				when 151 then -- if:
						if (has_non_ascii (l_aff_entry.item.ae_add)).to_boolean then
							l_pos := -1 + 169 -- skip if block
						end
				when 152 then -- if: | _L___3:
						l_aff_entry.item.ae_next := l_cur_aff.item.ah_first
						l_cur_aff.item.ah_first := l_aff_entry
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[4]), ce_string ("."))) /= 0 then
							l_aff_entry.item.ae_cond := getroom_save (a_spin, l_items[4])
							if ((l_items[0]).item).to_integer_32 = 80 then
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("^%%s"), l_items[4]]).do_nothing
							else
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("%%s$"), l_items[4]]).do_nothing
							end
							l_aff_entry.item.ae_prog := regexp_inst.vim_regcomp (l_buf___6, 7)
							if (l_aff_entry.item.ae_prog).is_void then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Broken condition in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[4]]).do_nothing
							end
						end
						if ((l_items[0]).item).to_integer_32 /= 80 then
							l_pos := -1 + 169 -- skip if block
						end
				when 153 then -- if:
						if not ((l_aff.item.af_pfxpostpone).to_boolean) then
							l_pos := -1 + 169 -- skip if block
						end
				when 154 then -- if:
						if not ((l_aff_entry.item.ae_flags).is_void) then
							l_pos := -1 + 169 -- skip if block
						end
				when 155 then -- if:
						if (l_aff_entry.item.ae_chop).is_void then
							l_pos := -1 + 168 -- skip if block
						end
				when 156 then -- if:
						if (l_aff_entry.item.ae_add).is_void then
							l_pos := -1 + 168 -- skip if block
						end
				when 157 then -- if:
						if (l_aff_entry.item.ae_chop[(globals_inst.mb_ptr2len.integer_32_item ([l_aff_entry.item.ae_chop]))]).to_integer_32 /= 0 then
							l_pos := -1 + 168 -- skip if block
						end
				when 158 then -- if:
						if globals_inst.has_mbyte.to_boolean then
							l_c := (globals_inst.mb_ptr2char.integer_32_item ([l_aff_entry.item.ae_chop]))
						else
							l_c := ((l_aff_entry.item.ae_chop).item).to_integer_32
						end
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 161 -- skip if block
						end
				when 159 then -- if:
						if l_c >= 128 then
							l_c_up := (mbyte_inst.utf_toupper (l_c))
						else
							l_pos := -1 + 161 -- goto _L___1
						end
				when 160 then -- if block done, skip else block:
						l_pos := -1 + 162
				when 161 then -- else: | _L___1:
						if l_c < 256 then
							l_tmp___58 := (spelltab.item.st_upper[l_c]).to_integer_32
						else
							l_tmp___58 := (towupper (l_c.to_natural_32)).to_integer_32
						end
						l_c_up := l_tmp___58
				when 162 then
						if l_c_up = l_c then
							l_pos := -1 + 168 -- skip if block
						end
				when 163 then -- if:
						if not ((l_aff_entry.item.ae_cond).is_void) then
							l_pos := -1 + 166 -- skip if block
						end
				when 164 then -- if:
						l_pos := -1 + 167 -- goto _L___2
				when 165 then -- if block done, skip else block:
						l_pos := -1 + 168
				when 166 then -- else:
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___65 := (globals_inst.mb_ptr2char.integer_32_item ([l_aff_entry.item.ae_cond]))
						else
							l_tmp___65 := ((l_aff_entry.item.ae_cond).item).to_integer_32
						end
						if l_tmp___65 /= l_c then
							l_pos := -1 + 168 -- skip if block
						end
				when 167 then -- if: | _L___2:
						l_p___0.item := l_aff_entry.item.ae_add + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_aff_entry.item.ae_add))).to_integer_32
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___61 := (globals_inst.mb_head_off.integer_32_item ([l_aff_entry.item.ae_add, l_p___0.item - 1])) + 1
						else
							l_tmp___61 := 1
						end
						l_p___0.item := l_p___0.item - l_tmp___61
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___63 := (globals_inst.mb_ptr2char.integer_32_item ([l_p___0.item]))
						else
							l_tmp___63 := (l_p___0.item.item).to_integer_32
						end
						if l_tmp___63 = l_c_up then
							l_upper := 1
							l_aff_entry.item.ae_chop := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_p___0.item.item := (('%/0/').code).to_natural_8
							if not (l_aff_entry.item.ae_cond).is_void then
								if globals_inst.has_mbyte.to_boolean then
									onecap_copy (l_items[4], l_buf___7, 1)
									l_aff_entry.item.ae_cond := getroom_save (a_spin, l_buf___7)
								else
									(l_aff_entry.item.ae_cond).item := l_c_up.to_natural_8
								end
								if not (l_aff_entry.item.ae_cond).is_void then
									sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___7), ce_string ("^%%s"), l_aff_entry.item.ae_cond]).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_aff_entry.item.ae_prog))
									l_aff_entry.item.ae_prog := regexp_inst.vim_regcomp (l_buf___7, 3)
								end
							end
						end
				when 168 then -- if done | if done | if done | if done | if done
						if (l_aff_entry.item.ae_chop).is_void then
							if (l_aff_entry.item.ae_flags).is_void then
								l_idx := a_spin.item.si_prefcond.ga_len - 1
								from
								until
									not (not js.loop_done and then (l_idx >= 0))
								loop
									l_p___0.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_spin.item.si_prefcond.ga_data)[l_idx]
									if (str_equal (l_p___0.item, l_aff_entry.item.ae_cond)).to_boolean then
										js.break
									end
									if not js.loop_jumped then
										l_idx := l_idx - 1
									end
								end
								if l_idx < 0 then
									if (misc2_inst.ga_grow (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond")), 1)) = 1 then
										l_tmp___68 := a_spin.item.si_prefcond.ga_len
										a_spin.item.si_prefcond.ga_len := (a_spin.item.si_prefcond.ga_len) + 1
										l_idx := l_tmp___68
										l_pp := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_spin.item.si_prefcond.ga_data) + l_idx
										if (l_aff_entry.item.ae_cond).is_void then
											l_pp.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
										else
											l_pp.item := getroom_save (a_spin, l_aff_entry.item.ae_cond)
										end
									end
								end
								if (l_aff_entry.item.ae_add).is_void then
									l_p___0.item := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
								else
									l_p___0.item := l_aff_entry.item.ae_add
								end
								l_n := -256
								if not (l_cur_aff.item.ah_combine).to_boolean then
									l_n := (l_n).bit_or ((2))
								end
								if l_upper.to_boolean then
									l_n := (l_n).bit_or ((4))
								end
								if (l_aff_entry.item.ae_comppermit).to_boolean then
									l_n := (l_n).bit_or ((8))
								end
								if (l_aff_entry.item.ae_compforbid).to_boolean then
									l_n := (l_n).bit_or ((16))
								end
								tree_add_word (a_spin, l_p___0.item, a_spin.item.si_prefroot, l_n, l_idx, l_cur_aff.item.ah_newID).do_nothing
								l_did_postpone_prefix := 1
							end
						end
						if l_aff_todo = 0 then
							if not l_did_postpone_prefix.to_boolean then
								a_spin.item.si_newprefID := (a_spin.item.si_newprefID) - 1
								l_cur_aff.item.ah_newID := 0
							end
						end
				when 169 then -- if done | if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 171
				when 170 then -- else:
						l_pos := -1 + 176 -- goto _L___16
				when 171 then -- if done | if block done, skip else block:
						l_pos := -1 + 173
				when 172 then -- else:
						l_pos := -1 + 176 -- goto _L___16
				when 173 then -- if done | if block done, skip else block:
						l_pos := -1 + 175
				when 174 then -- else:
						l_pos := -1 + 176 -- goto _L___16
				when 175 then -- if done | if block done, skip else block:
						l_pos := -1 + 231
				when 176 then -- else: | _L___16:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("FOL"), 2)).to_boolean) then
							l_pos := -1 + 179 -- skip if block
						end
				when 177 then -- if:
						if l_fol.is_void then
							l_fol := misc2_inst.vim_strsave (l_items[1])
						else
							l_pos := -1 + 179 -- goto _L___13
						end
				when 178 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 179 then -- else: | _L___13:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("LOW"), 2)).to_boolean) then
							l_pos := -1 + 182 -- skip if block
						end
				when 180 then -- if:
						if l_low.is_void then
							l_low := misc2_inst.vim_strsave (l_items[1])
						else
							l_pos := -1 + 182 -- goto _L___12
						end
				when 181 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 182 then -- else: | _L___12:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("UPP"), 2)).to_boolean) then
							l_pos := -1 + 185 -- skip if block
						end
				when 183 then -- if:
						if l_upp.is_void then
							l_upp := misc2_inst.vim_strsave (l_items[1])
						else
							l_pos := -1 + 185 -- goto _L___11
						end
				when 184 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 185 then -- else: | _L___11:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("REP"), 2)).to_boolean) then
							l_pos := -1 + 188 -- skip if block
						end
				when 186 then -- if:
						l_pos := -1 + 189 -- goto _L___10
				when 187 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 188 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("REPSAL"), 2)).to_boolean) then
							l_pos := -1 + 191 -- skip if block
						end
				when 189 then -- if: | _L___10:
						if not ((((ctype_b_loc).item[((l_items[1]).item).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Expected REP(SAL) count in %%s line %%d")))), a_fname, l_lnum]).do_nothing
						end
				when 190 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 191 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[0]), ce_string ("REP"))) /= 0 then
							l_pos := -1 + 194 -- skip if block
						end
				when 192 then -- if:
						l_pos := -1 + 195 -- goto _L___9
				when 193 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 194 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[0]), ce_string ("REPSAL"))) /= 0 then
							l_pos := -1 + 197 -- skip if block
						end
				when 195 then -- if: | _L___9:
						if l_itemcnt >= 3 then
							if l_itemcnt > 3 then
								if ((l_items[3])[0]).to_integer_32 /= 35 then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_afftrailing))), a_fname, l_lnum, l_items[3]]).do_nothing
								end
							end
							if ((l_items[0])[3]).to_integer_32 = 83 then
								l_tmp___80 := l_do_repsal
							else
								l_tmp___80 := l_do_rep
							end
							if l_tmp___80.to_boolean then
								l_p___0.item := l_items[1]
								from
								until
									(l_p___0.item.item).to_integer_32 = 0
								loop
									if (l_p___0.item.item).to_integer_32 = 95 then
										l_p___0.item.item := ((' ').code).to_natural_8
									end
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___76 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0.item]))
									else
										l_tmp___76 := 1
									end
									l_p___0.item := l_p___0.item + l_tmp___76
								end
								l_p___0.item := l_items[2]
								from
								until
									(l_p___0.item.item).to_integer_32 = 0
								loop
									if (l_p___0.item.item).to_integer_32 = 95 then
										l_p___0.item.item := ((' ').code).to_natural_8
									end
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___78 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0.item]))
									else
										l_tmp___78 := 1
									end
									l_p___0.item := l_p___0.item + l_tmp___78
								end
								if ((l_items[0])[3]).to_integer_32 = 83 then
									l_tmp___79 := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_repsal"))
								else
									l_tmp___79 := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_rep"))
								end
								add_fromto (a_spin, l_tmp___79, l_items[1], l_items[2])
							end
						else
							l_pos := -1 + 197 -- goto _L___8
						end
				when 196 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 197 then -- else: | _L___8:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("MAP"), 2)).to_boolean) then
							l_pos := -1 + 211 -- skip if block
						end
				when 198 then -- if:
						if l_found_map.to_boolean then
							l_pos := -1 + 201 -- skip if block
						end
				when 199 then -- if:
						l_found_map := 1
						if not ((((ctype_b_loc).item[((l_items[1]).item).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Expected MAP count in %%s line %%d")))), a_fname, l_lnum]).do_nothing
						end
				when 200 then -- if block done, skip else block:
						l_pos := -1 + 210
				when 201 then -- else:
						if not (l_do_mapline.to_boolean) then
							l_pos := -1 + 210 -- skip if block
						end
				when 202 then -- if:
						l_p___0.item := l_items[1]
				when 203 then -- loop condition:
						if (l_p___0.item.item).to_integer_32 = 0 then
							l_pos := -1 + 209 -- skip loop
						end
				when 204 then -- loop body:
						l_c___0 := mbyte_inst.mb_ptr2char_adv (l_p___0)
						if not (a_spin.item.si_map.ga_len > 0) then
							l_pos := -1 + 207 -- skip if block
						end
				when 205 then -- if:
						if not (misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (a_spin.item.si_map.ga_data), l_c___0)).is_void then
							l_tmp___83 := gettext (ce_string ("Duplicate character in MAP in %%s line %%d"))
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___83), a_fname, l_lnum]).do_nothing
						else
							l_pos := -1 + 207 -- goto _L___4
						end
				when 206 then -- if block done, skip else block:
						l_pos := -1 + 208
				when 207 then -- else: | _L___4:
						if not (misc2_inst.vim_strchr (l_p___0.item, l_c___0)).is_void then
							l_tmp___83 := gettext (ce_string ("Duplicate character in MAP in %%s line %%d"))
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___83), a_fname, l_lnum]).do_nothing
						end
				when 208 then
						l_pos := -1 + 203 -- back to loop condition
				when 209 then -- loop done
						misc2_inst.ga_concat (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_map")), l_items[1])
						misc2_inst.ga_append (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_map")), ('/').code)
				when 210 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 231
				when 211 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SAL"), 3)).to_boolean) then
							l_pos := -1 + 214 -- skip if block
						end
				when 212 then -- if:
						if l_do_sal.to_boolean then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]), ce_string ("followup"))) = 0 then
								a_spin.item.si_followup := sal_to_bool (l_items[2])
							elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]), ce_string ("collapse_result"))) = 0 then
								a_spin.item.si_collapse := sal_to_bool (l_items[2])
							elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[1]), ce_string ("remove_accents"))) = 0 then
								a_spin.item.si_rem_accents := sal_to_bool (l_items[2])
							else
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[2]), ce_string ("_"))) = 0 then
									l_tmp___87 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
								else
									l_tmp___87 := l_items[2]
								end
								add_fromto (a_spin, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_sal")), l_items[1], l_tmp___87)
							end
						end
				when 213 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 214 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SOFOFROM"), 2)).to_boolean) then
							l_pos := -1 + 217 -- skip if block
						end
				when 215 then -- if:
						if l_sofofrom.is_void then
							l_sofofrom := getroom_save (a_spin, l_items[1])
						else
							l_pos := -1 + 217 -- goto _L___7
						end
				when 216 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 217 then -- else: | _L___7:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SOFOTO"), 2)).to_boolean) then
							l_pos := -1 + 220 -- skip if block
						end
				when 218 then -- if:
						if l_sofoto.is_void then
							l_sofoto := getroom_save (a_spin, l_items[1])
						else
							l_pos := -1 + 220 -- goto _L___6
						end
				when 219 then -- if block done, skip else block:
						l_pos := -1 + 231
				when 220 then -- else: | _L___6:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_items[0]), ce_string ("COMMON"))) /= 0 then
							l_pos := -1 + 230 -- skip if block
						end
				when 221 then -- if:
						l_i___1 := 1
				when 222 then -- loop condition:
						if not (not js.loop_done and then (l_i___1 < l_itemcnt)) then
							l_pos := -1 + 229 -- skip loop
						end
				when 223 then -- loop body:
						if not (((hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords")), l_items[l_i___1])).item.hi_key).is_void) then
							l_pos := -1 + 226 -- skip if block
						end
				when 224 then -- if:
						l_pos := -1 + 227 -- goto _L___5
				when 225 then -- if block done, skip else block:
						l_pos := -1 + 228
				when 226 then -- else:
						if not (((hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords")), l_items[l_i___1])).item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_pos := -1 + 228 -- skip if block
						end
				when 227 then -- if: | _L___5:
						l_p___0.item := misc2_inst.vim_strsave (l_items[l_i___1])
						if (l_p___0.item).is_void then
							js.break
						end
						if not js.loop_jumped then
							hashtab_inst.hash_add (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords")), l_p___0.item).do_nothing
						end
				when 228 then -- if done
						if not js.loop_jumped then
							l_i___1 := l_i___1 + 1
						end
						l_pos := -1 + 222 -- back to loop condition
				when 229 then -- loop done | if block done, skip else block:
						l_pos := -1 + 231
				when 230 then -- else:
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Unrecognized or duplicate item in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[0]]).do_nothing
				when 231 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 232 then -- loop done
						if l_fol.is_void then
							l_pos := -1 + 235 -- skip if block
						end
				when 233 then -- if:
						l_pos := -1 + 239 -- goto _L___43
				when 234 then -- if block done, skip else block:
						l_pos := -1 + 240
				when 235 then -- else:
						if l_low.is_void then
							l_pos := -1 + 238 -- skip if block
						end
				when 236 then -- if:
						l_pos := -1 + 239 -- goto _L___43
				when 237 then -- if block done, skip else block:
						l_pos := -1 + 240
				when 238 then -- else:
						if l_upp.is_void then
							l_pos := -1 + 240 -- skip if block
						end
				when 239 then -- if: | _L___43:
						if (a_spin.item.si_clear_chartab).to_boolean then
							init_spell_chartab
							a_spin.item.si_clear_chartab := 0
						end
						if not (a_spin.item.si_ascii).to_boolean then
							if not globals_inst.enc_utf8.to_boolean then
								if l_fol.is_void then
									l_tmp___149 := gettext (ce_string ("Missing FOL/LOW/UPP line in %%s"))
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___149), a_fname]).do_nothing
								elseif l_low.is_void then
									l_tmp___149 := gettext (ce_string ("Missing FOL/LOW/UPP line in %%s"))
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___149), a_fname]).do_nothing
								elseif l_upp.is_void then
									l_tmp___149 := gettext (ce_string ("Missing FOL/LOW/UPP line in %%s"))
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___149), a_fname]).do_nothing
								else
									set_spell_chartab (l_fol, l_low, l_upp).do_nothing
								end
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fol))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_low))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_upp))
				when 240 then -- if done | if done
						if l_compmax /= 0 then
							aff_check_number (a_spin.item.si_compmax, l_compmax, ce_string ("COMPOUNDWORDMAX"))
							a_spin.item.si_compmax := l_compmax
						end
						if l_compminlen /= 0 then
							aff_check_number (a_spin.item.si_compminlen, l_compminlen, ce_string ("COMPOUNDMIN"))
							a_spin.item.si_compminlen := l_compminlen
						end
						if l_compsylmax /= 0 then
							if l_syllable.is_void then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("COMPOUNDSYLMAX used without SYLLABLE"))))]).do_nothing
							end
							aff_check_number (a_spin.item.si_compsylmax, l_compsylmax, ce_string ("COMPOUNDSYLMAX"))
							a_spin.item.si_compsylmax := l_compsylmax
						end
						if l_compoptions /= 0 then
							aff_check_number (a_spin.item.si_compoptions, l_compoptions, ce_string ("COMPOUND options"))
							a_spin.item.si_compoptions := (a_spin.item.si_compoptions).bit_or (l_compoptions)
						end
						if not l_compflags.is_void then
							process_compflags (a_spin, l_aff, l_compflags)
						end
						if a_spin.item.si_newcompID < a_spin.item.si_newprefID then
							if a_spin.item.si_newcompID = 127 then
								l_tmp___151 := gettext (ce_string ("Too many postponed prefixes"))
								message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___151)).do_nothing
							elseif a_spin.item.si_newcompID = 255 then
								l_tmp___151 := gettext (ce_string ("Too many postponed prefixes"))
								message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___151)).do_nothing
							elseif a_spin.item.si_newprefID = 0 then
								l_tmp___152 := gettext (ce_string ("Too many compound flags"))
								message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___152)).do_nothing
							elseif a_spin.item.si_newprefID = 127 then
								l_tmp___152 := gettext (ce_string ("Too many compound flags"))
								message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___152)).do_nothing
							else
								message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Too many postponed prefixes and/or compound flags"))))).do_nothing
							end
						end
						if not l_syllable.is_void then
							aff_check_string (a_spin.item.si_syllable, l_syllable, ce_string ("SYLLABLE"))
							a_spin.item.si_syllable := l_syllable
						end
						if l_sofofrom.is_void then
							l_pos := -1 + 243 -- skip if block
						end
				when 241 then -- if:
						l_pos := -1 + 244 -- goto _L___45
				when 242 then -- if block done, skip else block:
						l_pos := -1 + 251
				when 243 then -- else:
						if l_sofoto.is_void then
							l_pos := -1 + 251 -- skip if block
						end
				when 244 then -- if: | _L___45:
						if not (l_sofofrom.is_void) then
							l_pos := -1 + 247 -- skip if block
						end
				when 245 then -- if:
						l_pos := -1 + 248 -- goto _L___44
				when 246 then -- if block done, skip else block:
						l_pos := -1 + 251
				when 247 then -- else:
						if not (l_sofoto.is_void) then
							l_pos := -1 + 250 -- skip if block
						end
				when 248 then -- if: | _L___44:
						if l_sofofrom.is_void then
							l_tmp___154 := ce_string ("FROM")
						else
							l_tmp___154 := ce_string ("TO")
						end
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Missing SOFO%%s line in %%s")))), l_tmp___154, a_fname]).do_nothing
				when 249 then -- if block done, skip else block:
						l_pos := -1 + 251
				when 250 then -- else:
						if a_spin.item.si_sal.ga_len > 0 then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Both SAL and SOFO lines in %%s")))), a_fname]).do_nothing
						else
							aff_check_string (a_spin.item.si_sofofr, l_sofofrom, ce_string ("SOFOFROM"))
							aff_check_string (a_spin.item.si_sofoto, l_sofoto, ce_string ("SOFOTO"))
							a_spin.item.si_sofofr := l_sofofrom
							a_spin.item.si_sofoto := l_sofoto
						end
				when 251 then -- if done | if done | if done
						if not l_midword.is_void then
							aff_check_string (a_spin.item.si_midword, l_midword, ce_string ("MIDWORD"))
							a_spin.item.si_midword := l_midword
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pc))
						fclose (l_fd).do_nothing
						Result := l_aff
				when 252 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_read_dic (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8]; a_affile: CE_POINTER [PD_AFFFILE_S]): INTEGER_32
		local
			l_ht: CE_ARRAY [PD_HASHTABLE_S]
			l_line: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_afflist: CE_POINTER [NATURAL_8]
			l_store_afflist: CE_ARRAY [NATURAL_8]
			l_pfxlen: INTEGER_32
			l_need_affix: INTEGER_32
			l_dw: CE_POINTER [NATURAL_8]
			l_pc: CE_POINTER [NATURAL_8]
			l_w: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_lnum: INTEGER_32
			l_non_ascii: INTEGER_32
			l_retval: INTEGER_32
			l_message: CE_ARRAY [NATURAL_8]
			l_flags___0: INTEGER_32
			l_duplicate: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ht.make (<<1>>)
			create l_line.make (<<500>>)
			create l_p___0.make
			create l_afflist.make
			create l_store_afflist.make (<<250>>)
			create l_dw.make
			create l_pc.make
			create l_w.make
			create l_hi___1.make
			create l_fd.make
			create l_message.make (<<750>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := 1
					l_non_ascii := 0
					l_retval := 1
					l_duplicate := 0
					l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), ce_string ("r"))
					if l_fd.is_void then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_fname).do_nothing
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						hashtab_inst.hash_init (l_ht)
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Reading dictionary file %%s ..."))), a_fname]).do_nothing
						spell_message (a_spin, globals_inst.IObuff)
						a_spin.item.si_msg_count := 999_999
						fileio_inst.vim_fgets (l_line, 500, l_fd).do_nothing
						if not (charset_inst.vim_isdigit (((charset_inst.skipwhite (l_line)).item).to_integer_32)).to_boolean then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E760: No word count in %%s")))), a_fname).do_nothing
						end
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						if (fileio_inst.vim_fgets (l_line, 500, l_fd)).to_boolean then
							js.break
						elseif globals_inst.got_int.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							misc1_inst.line_breakcheck
							l_lnum := l_lnum + 1
							if (l_line[0]).to_integer_32 = 35 then
								js.continue
							elseif (l_line[0]).to_integer_32 = 47 then
								js.continue
							end
						end
						if not js.loop_jumped then
							l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32
							from
							until
								js.loop_done
							loop
								if l_l > 0 then
									if not ((l_line[l_l - 1]).to_integer_32 <= 32) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_l := l_l - 1
								end
							end
							if l_l = 0 then
								js.continue
							end
						end
						if not js.loop_jumped then
							l_line[l_l] := (('%/0/').code).to_natural_8
							if a_spin.item.si_conv.vc_type /= 0 then
								l_pc := mbyte_inst.string_convert (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv")), l_line, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								if l_pc.is_void then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Conversion failure for word in %%s line %%d: %%s")))), a_fname, l_lnum, l_line]).do_nothing
									js.continue
								end
								if not js.loop_jumped then
									l_w := l_pc
								end
							else
								l_pc := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								l_w := l_line
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						l_afflist := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_p___0 := l_w
				when 5 then -- loop condition:
						if not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 6 then -- loop body:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_p___0[1]).to_integer_32 = 92 then
							l_tmp___8 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))
							memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), l_tmp___8 + {NATURAL_32} 1).do_nothing
						elseif (l_p___0[1]).to_integer_32 = 47 then
							l_tmp___8 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))
							memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), l_tmp___8 + {NATURAL_32} 1).do_nothing
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (l_p___0.item).to_integer_32 = 47 then
							l_p___0.item := (('%/0/').code).to_natural_8
							l_afflist := l_p___0 + 1
							js.break
						end
				when 10 then
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___7 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
							else
								l_tmp___7 := 1
							end
							l_p___0 := l_p___0 + l_tmp___7
						end
						l_pos := -1 + 5 -- back to loop condition
				when 11 then -- loop done
						if (a_spin.item.si_ascii).to_boolean then
							if (has_non_ascii (l_w)).to_boolean then
								l_non_ascii := l_non_ascii + 1
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pc))
								js.continue
							end
						end
				when 12 then -- if done
						if not js.loop_jumped then
							if (a_spin.item.si_verbose).to_boolean then
								if a_spin.item.si_msg_count > 10_000 then
									a_spin.item.si_msg_count := 0
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_message), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (750).to_natural_32), (gettext (ce_string ("line %%6d, word %%6d - %%s"))), l_lnum, a_spin.item.si_foldwcount + a_spin.item.si_keepwcount, l_w]).do_nothing
									message_inst.msg_start
									message_inst.msg_puts_long_attr (l_message, 0)
									message_inst.msg_clr_eos
									globals_inst.msg_didout := 0
									globals_inst.msg_col := 0
									term_inst.out_flush
								end
							end
							l_dw := (getroom_save (a_spin, l_w))
							if l_dw.is_void then
								l_retval := 0
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pc))
								js.break
							end
						end
						if not js.loop_jumped then
							l_hash := hashtab_inst.hash_hash (l_dw)
							l_hi___1 := hashtab_inst.hash_lookup (l_ht, l_dw, l_hash)
							if (l_hi___1.item.hi_key).is_void then
								hashtab_inst.hash_add_item (l_ht, l_hi___1, l_dw, l_hash).do_nothing
							elseif (l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed) then
								hashtab_inst.hash_add_item (l_ht, l_hi___1, l_dw, l_hash).do_nothing
							else
								if option_inst.p_verbose.item > 0 then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Duplicate word in %%s line %%d: %%s")))), a_fname, l_lnum, l_dw]).do_nothing
								elseif l_duplicate = 0 then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("First duplicate word in %%s line %%d: %%s")))), a_fname, l_lnum, l_dw]).do_nothing
								end
								l_duplicate := l_duplicate + 1
							end
							l_flags___0 := 0
							l_store_afflist[0] := (('%/0/').code).to_natural_8
							l_pfxlen := 0
							l_need_affix := 0
							if not l_afflist.is_void then
								l_flags___0 := (l_flags___0).bit_or ((get_affix_flags (a_affile, l_afflist)))
								if a_affile.item.af_needaffix /= {NATURAL_32} 0 then
									if (flag_in_afflist (a_affile.item.af_flagtype, l_afflist, a_affile.item.af_needaffix)).to_boolean then
										l_need_affix := 1
									end
								end
								if (a_affile.item.af_pfxpostpone).to_boolean then
									l_pfxlen := get_pfxlist (a_affile, l_afflist, l_store_afflist)
								end
								if not (a_spin.item.si_compflags).is_void then
									get_compflags (a_affile, l_afflist, l_store_afflist + l_pfxlen)
								end
							end
							if (store_word (a_spin, l_dw, l_flags___0, a_spin.item.si_region, l_store_afflist, l_need_affix)) = 0 then
								l_retval := 0
							end
							if not l_afflist.is_void then
								if (store_aff_word (a_spin, l_dw, l_afflist, a_affile, create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff")), create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref")), 4, l_flags___0, l_store_afflist, l_pfxlen)) = 0 then
									l_retval := 0
								end
								if (store_aff_word (a_spin, l_dw, l_afflist, a_affile, create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref")), create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (default_pointer), 4, l_flags___0, l_store_afflist, l_pfxlen)) = 0 then
									l_retval := 0
								end
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pc))
						end
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done
						if l_duplicate > 0 then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%d duplicate word(s) in %%s")))), l_duplicate, a_fname]).do_nothing
						end
						if (a_spin.item.si_ascii).to_boolean then
							if l_non_ascii > 0 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Ignored %%d word(s) with non-ASCII characters in %%s")))), l_non_ascii, a_fname]).do_nothing
							end
						end
						hashtab_inst.hash_clear (l_ht)
						fclose (l_fd).do_nothing
						Result := l_retval
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_read_tree (a_fd: CE_POINTER [SD_IO_FILE]; a_bytsp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_idxsp: CE_POINTER [CE_POINTER [INTEGER_32]]; a_prefixtree: INTEGER_32; a_prefixcnt: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_idx: INTEGER_32
			l_bp___0: CE_POINTER [NATURAL_8]
			l_ip: CE_POINTER [INTEGER_32]
			js: JUMP_STATE
		do
			create l_bp___0.make
			create l_ip.make

			l_len := misc2_inst.get4c (a_fd)
			if l_len < 0 then
				Result := (-1)
				js.return
			end
			if not js.return_called and then (l_len > 0) then
				l_bp___0 := misc2_inst.lalloc (l_len.to_natural_32, 1)
				if l_bp___0.is_void then
					Result := (-3)
					js.return
				end
				if not js.return_called then
					a_bytsp.item := l_bp___0
					l_ip := create {CE_POINTER [INTEGER_32]}.make_cast ((misc2_inst.lalloc_clear ((l_len.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).to_natural_32, 1)))
					if l_ip.is_void then
						Result := (-3)
						js.return
					end
				end
				if not js.return_called then
					a_idxsp.item := l_ip
					l_idx := read_tree_node (a_fd, l_bp___0, l_ip, l_len, 0, a_prefixtree, a_prefixcnt)
					if l_idx < 0 then
						Result := l_idx
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	spell_read_wordfile (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_lnum: INTEGER_32
			l_rline: CE_ARRAY [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_pc: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_retval: INTEGER_32
			l_did_word: INTEGER_32
			l_non_ascii: INTEGER_32
			l_flags___0: INTEGER_32
			l_regionmask: INTEGER_32
			l_enc: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_fd.make
			create l_rline.make (<<500>>)
			create l_line.make
			create l_pc.make
			create l_p___0.make
			create l_enc.make
			create l_tmp___14.make
			create l_tmp___16.make

			l_lnum := 0
			l_pc := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_retval := 1
			l_did_word := 0
			l_non_ascii := 0
			l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), ce_string ("r"))
			if l_fd.is_void then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_fname).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Reading word file %%s ..."))), a_fname]).do_nothing
				spell_message (a_spin, globals_inst.IObuff)
				from
				until
					js.loop_done
				loop
					if (fileio_inst.vim_fgets (l_rline, 500, l_fd)).to_boolean then
						js.break
					elseif globals_inst.got_int.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						misc1_inst.line_breakcheck
						l_lnum := l_lnum + 1
						if (l_rline[0]).to_integer_32 = 35 then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_rline))).to_integer_32
						from
						until
							js.loop_done
						loop
							if l_l > 0 then
								if not ((l_rline[l_l - 1]).to_integer_32 <= 32) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_l := l_l - 1
							end
						end
						if l_l = 0 then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_rline[l_l] := (('%/0/').code).to_natural_8
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pc))
						if a_spin.item.si_conv.vc_type /= 0 then
							l_pc := mbyte_inst.string_convert (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv")), l_rline, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							if l_pc.is_void then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Conversion failure for word in %%s line %%d: %%s")))), a_fname, l_lnum, l_rline]).do_nothing
								js.continue
							end
							if not js.loop_jumped then
								l_line := l_pc
							end
						else
							l_pc := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_line := l_rline
						end
					end
					if not js.loop_jumped and then ((l_line.item).to_integer_32 = 47) then
						l_line := l_line + 1
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_line), ce_string ("encoding="), (9).to_natural_32)) = 0 then
							if a_spin.item.si_conv.vc_type /= 0 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Duplicate /encoding= line ignored in %%s line %%d: %%s")))), a_fname, l_lnum, l_line - 1]).do_nothing
							elseif l_did_word.to_boolean then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("/encoding= line after word ignored in %%s line %%d: %%s")))), a_fname, l_lnum, l_line - 1]).do_nothing
							else
								l_line := l_line + (9)
								l_enc := mbyte_inst.enc_canonize (l_line)
								if not l_enc.is_void then
									if not (a_spin.item.si_ascii).to_boolean then
										if (mbyte_inst.convert_setup (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv")), l_enc, option_inst.p_enc.item)) = 0 then
											message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Conversion in %%s not supported: from %%s to %%s")))), a_fname, l_line, option_inst.p_enc.item]).do_nothing
										end
									end
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_enc))
								a_spin.item.si_conv.vc_fail := 1
							end
							js.continue
						end
						if not js.loop_jumped then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_line), ce_string ("regions="), (8).to_natural_32)) = 0 then
								if a_spin.item.si_region_count > 1 then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Duplicate /regions= line ignored in %%s line %%d: %%s")))), a_fname, l_lnum, l_line]).do_nothing
								else
									l_line := l_line + (8)
									if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))) > {NATURAL_32} 16 then
										message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Too many regions in %%s line %%d: %%s")))), a_fname, l_lnum, l_line]).do_nothing
									else
										a_spin.item.si_region_count := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32 // 2
										strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((a_spin.item.si_region_name)), create {CE_POINTER [INTEGER_8]}.make_cast (l_line)).do_nothing
										a_spin.item.si_region := ((1).bit_shift_left (a_spin.item.si_region_count)) - 1
									end
								end
								js.continue
							end
						end
						if not js.loop_jumped then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("/ line ignored in %%s line %%d: %%s")))), a_fname, l_lnum, l_line - 1]).do_nothing
							js.continue
						end
					end
					if not js.loop_jumped then
						l_flags___0 := 0
						l_regionmask := a_spin.item.si_region
						l_p___0 := misc2_inst.vim_strchr (l_line, ('/').code)
						if not l_p___0.is_void then
							l_tmp___14 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___14.item := (('%/0/').code).to_natural_8
							from
							until
								not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0))
							loop
								if (l_p___0.item).to_integer_32 = 61 then
									l_flags___0 := (l_flags___0).bit_or ((192))
								elseif (l_p___0.item).to_integer_32 = 33 then
									l_flags___0 := (l_flags___0).bit_or ((16))
								elseif (l_p___0.item).to_integer_32 = 63 then
									l_flags___0 := (l_flags___0).bit_or ((8))
								elseif (l_p___0.item).to_integer_32 >= 48 then
									if (l_p___0.item).to_integer_32 <= 57 then
										if ((l_flags___0).bit_and (1)) = 0 then
											l_regionmask := 0
										end
										l_flags___0 := (l_flags___0).bit_or ((1))
										l_l := (l_p___0.item).to_integer_32 - 48
										if l_l > a_spin.item.si_region_count then
											message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Invalid region nr in %%s line %%d: %%s")))), a_fname, l_lnum, l_p___0]).do_nothing
											js.break
										end
										if not js.loop_jumped then
											l_regionmask := (l_regionmask).bit_or (((1).bit_shift_left ((l_l - 1))))
										end
									else
										l_tmp___16 := gettext (ce_string ("Unrecognized flags in %%s line %%d: %%s"))
										message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___16), a_fname, l_lnum, l_p___0]).do_nothing
										js.break
									end
								else
									l_tmp___16 := gettext (ce_string ("Unrecognized flags in %%s line %%d: %%s"))
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___16), a_fname, l_lnum, l_p___0]).do_nothing
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_p___0 + 1
								end
							end
						end
						if (a_spin.item.si_ascii).to_boolean then
							if (has_non_ascii (l_line)).to_boolean then
								l_non_ascii := l_non_ascii + 1
								js.continue
							end
						end
					end
					if not js.loop_jumped then
						if (store_word (a_spin, l_line, l_flags___0, l_regionmask, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)) = 0 then
							l_retval := 0
							js.break
						end
					end
					if not js.loop_jumped then
						l_did_word := 1
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pc))
				fclose (l_fd).do_nothing
				if (a_spin.item.si_ascii).to_boolean then
					if l_non_ascii > 0 then
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Ignored %%d words with non-ASCII characters"))), l_non_ascii]).do_nothing
						spell_message (a_spin, globals_inst.IObuff)
					end
				end
				Result := l_retval
			end
		end

	spell_reload
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
		do
			create l_wp___0.make

			init_spell_chartab
			spell_free_all
			l_wp___0 := globals_inst.firstwin
			from
			until
				not (not js.loop_done and then (not l_wp___0.is_void))
			loop
				if (((l_wp___0.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
					if (l_wp___0.item.w_onebuf_opt.wo_spell).to_boolean then
						did_set_spelllang (l_wp___0).do_nothing
						js.break
					end
				end
				if not js.loop_jumped then
					l_wp___0 := l_wp___0.item.w_next
				end
			end
		end

	spell_reload_one (a_fname: CE_POINTER [NATURAL_8]; a_added_word: INTEGER_32)
		local
			l_slang: CE_POINTER [PD_SLANG_S]
			l_didit: INTEGER_32
		do
			create l_slang.make

			l_didit := 0
			l_slang := first_lang
			from
			until
				l_slang.is_void
			loop
				if (misc1_inst.fullpathcmp (a_fname, l_slang.item.sl_fname, 0)) = 1 then
					slang_clear (l_slang)
					if (spell_load_file (a_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_slang, 0)).is_void then
						slang_clear (l_slang)
					end
					screen_inst.redraw_all_later (35)
					l_didit := 1
				end
				l_slang := l_slang.item.sl_next
			end
			if a_added_word.to_boolean then
				if not l_didit.to_boolean then
					did_set_spelllang (globals_inst.curwin).do_nothing
				end
			end
		end

	spell_soundfold (a_slang: CE_POINTER [PD_SLANG_S]; a_inword: CE_POINTER [NATURAL_8]; a_folded: INTEGER_32; a_res: CE_POINTER [NATURAL_8])
		local
			l_fword: CE_ARRAY [NATURAL_8]
			l_word: CE_POINTER [NATURAL_8]
		do
			create l_fword.make (<<250>>)
			create l_word.make

			if (a_slang.item.sl_sofo).to_boolean then
				spell_soundfold_sofo (a_slang, a_inword, a_res)
			else
				if a_folded.to_boolean then
					l_word := a_inword
				else
					spell_casefold (a_inword, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_inword))).to_integer_32, l_fword, 250).do_nothing
					l_word := l_fword
				end
				if globals_inst.has_mbyte.to_boolean then
					spell_soundfold_wsal (a_slang, l_word, a_res)
				else
					spell_soundfold_sal (a_slang, l_word, a_res)
				end
			end
		end

	spell_soundfold_sal (a_slang: CE_POINTER [PD_SLANG_S]; a_inword: CE_POINTER [NATURAL_8]; a_res: CE_POINTER [NATURAL_8])
		local
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_word: CE_ARRAY [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_t: CE_POINTER [NATURAL_8]
			l_pf: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_z: INTEGER_32
			l_reslen: INTEGER_32
			l_n: INTEGER_32
			l_k: INTEGER_32
			l_z0: INTEGER_32
			l_k0: INTEGER_32
			l_n0: INTEGER_32
			l_c: INTEGER_32
			l_pri: INTEGER_32
			l_p0: INTEGER_32
			l_c0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_smp.make
			create l_word.make (<<250>>)
			create l_s.make
			create l_t.make
			create l_pf.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_inword
					l_k := 0
					l_p0 := -333
					if (a_slang.item.sl_rem_accents).to_boolean then
						l_t := l_word
						from
						until
							(l_s.item).to_integer_32 = 0
						loop
							if (l_s.item).to_integer_32 = 32 then
								l_tmp := l_t
								l_t := l_t + 1
								l_tmp.item := ((' ').code).to_natural_8
								l_s := charset_inst.skipwhite (l_s)
							elseif (l_s.item).to_integer_32 = 9 then
								l_tmp := l_t
								l_t := l_t + 1
								l_tmp.item := ((' ').code).to_natural_8
								l_s := charset_inst.skipwhite (l_s)
							else
								if (spell_iswordp_nmw (l_s)).to_boolean then
									l_tmp___0 := l_t
									l_t := l_t + 1
									l_tmp___0.item := l_s.item
								end
								l_s := l_s + 1
							end
						end
						l_t.item := (('%/0/').code).to_natural_8
					else
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_word), create {CE_POINTER [INTEGER_8]}.make_cast (l_s)).do_nothing
					end
					l_smp := create {CE_POINTER [PD_SALITEM_S]}.make_cast (a_slang.item.sl_sal.ga_data)
					l_z := 0
					l_reslen := l_z
					l_i___0 := l_reslen
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 51 -- skip loop
					end
				when 2 then -- loop body:
						l_c := (l_word[l_i___0]).to_integer_32
						if l_c = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 50 -- skip if block
						end
				when 3 then -- if:
						l_n := a_slang.item.sl_sal_first[l_c]
						l_z0 := 0
						if not (l_n >= 0) then
							l_pos := -1 + 48 -- skip if block
						end
				when 4 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 47 -- skip loop
						end
				when 5 then -- loop body:
						l_s := (l_smp + l_n).item.sm_lead
						if (l_s[0]).to_integer_32 /= l_c then
							js.break
						end
						if not js.loop_jumped then
							l_k := (l_smp + l_n).item.sm_leadlen
							if l_k > 1 then
								if (l_word[l_i___0 + 1]).to_integer_32 /= (l_s[1]).to_integer_32 then
									js.continue
								end
								if not js.loop_jumped and then (l_k > 2) then
									l_j := 2
									from
									until
										not (not js.loop_done and then (l_j < l_k))
									loop
										if (l_word[l_i___0 + l_j]).to_integer_32 /= (l_s[l_j]).to_integer_32 then
											js.break
										end
										if not js.loop_jumped then
											l_j := l_j + 1
										end
									end
									if l_j < l_k then
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped then
							l_pf := (l_smp + l_n).item.sm_oneof
							if not l_pf.is_void then
								from
								until
									js.loop_done
								loop
									if (l_pf.item).to_integer_32 /= 0 then
										if (l_pf.item).to_integer_32 = (l_word[l_i___0 + l_k]).to_integer_32 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_pf := l_pf + 1
									end
								end
								if (l_pf.item).to_integer_32 = 0 then
									js.continue
								end
								if not js.loop_jumped then
									l_k := l_k + 1
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 46 -- skip if block
						end
				when 6 then -- if:
						l_s := (l_smp + l_n).item.sm_rules
						l_pri := 5
						l_p0 := (l_s.item).to_integer_32
						l_k0 := l_k
						from
						until
							js.loop_done
						loop
							if (l_s.item).to_integer_32 = 45 then
								if not (l_k > 1) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_k := l_k - 1
								l_s := l_s + 1
							end
						end
						if (l_s.item).to_integer_32 = 60 then
							l_s := l_s + 1
						end
						if (l_s.item).to_integer_32 >= 48 then
							if (l_s.item).to_integer_32 <= 57 then
								l_pri := (l_s.item).to_integer_32 - 48
								l_s := l_s + 1
							end
						end
						if (l_s.item).to_integer_32 = 94 then
							if (l_s[1]).to_integer_32 = 94 then
								l_s := l_s + 1
							end
						end
						if (l_s.item).to_integer_32 /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 9 then -- else:
						if (l_s.item).to_integer_32 /= 94 then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if l_i___0 /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 19 -- goto _L___4
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if (l_word[l_i___0 - 1]).to_integer_32 /= 32 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if not ((spell_iswordp ((l_word + l_i___0) - 1, globals_inst.curwin)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___4:
						if (l_s[1]).to_integer_32 /= 36 then
							l_pos := -1 + 25 -- goto _L___1
						elseif (spell_iswordp ((l_word + l_i___0) + l_k0, globals_inst.curwin)).to_boolean then
							l_pos := -1 + 21 -- goto _L___3
						else
							l_pos := -1 + 25 -- goto _L___1
						end
				when 20 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 46
				when 21 then -- else: | _L___3:
						if (l_s.item).to_integer_32 /= 36 then
							l_pos := -1 + 46 -- skip if block
						end
				when 22 then -- if:
						if not (l_i___0 > 0) then
							l_pos := -1 + 46 -- skip if block
						end
				when 23 then -- if:
						if not ((spell_iswordp ((l_word + l_i___0) - 1, globals_inst.curwin)).to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 24 then -- if:
						if (spell_iswordp ((l_word + l_i___0) + l_k0, globals_inst.curwin)).to_boolean then
							l_pos := -1 + 46 -- skip if block
						end
				when 25 then -- if: | _L___1:
						l_c0 := (l_word[(l_i___0 + l_k) - 1]).to_integer_32
						l_n0 := a_slang.item.sl_sal_first[l_c0]
						if not ((a_slang.item.sl_followup).to_boolean) then
							l_pos := -1 + 40 -- skip if block
						end
				when 26 then -- if:
						if not (l_k > 1) then
							l_pos := -1 + 40 -- skip if block
						end
				when 27 then -- if:
						if not (l_n0 >= 0) then
							l_pos := -1 + 40 -- skip if block
						end
				when 28 then -- if:
						if l_p0 = 45 then
							l_pos := -1 + 40 -- skip if block
						end
				when 29 then -- if:
						if (l_word[l_i___0 + l_k]).to_integer_32 = 0 then
							l_pos := -1 + 40 -- skip if block
						end
				when 30 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 39 -- skip loop
						end
				when 31 then -- loop body:
						l_s := (l_smp + l_n0).item.sm_lead
						if (l_s[0]).to_integer_32 /= l_c0 then
							js.break
						end
						if not js.loop_jumped then
							l_k0 := (l_smp + l_n0).item.sm_leadlen
							if l_k0 > 1 then
								if (l_word[l_i___0 + l_k]).to_integer_32 /= (l_s[1]).to_integer_32 then
									js.continue
								end
								if not js.loop_jumped and then (l_k0 > 2) then
									l_pf := ((l_word + l_i___0) + l_k) + 1
									l_j := 2
									from
									until
										not (not js.loop_done and then (l_j < l_k0))
									loop
										l_tmp___2 := l_pf
										l_pf := l_pf + 1
										if (l_tmp___2.item).to_integer_32 /= (l_s[l_j]).to_integer_32 then
											js.break
										end
										if not js.loop_jumped then
											l_j := l_j + 1
										end
									end
									if l_j < l_k0 then
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped then
							l_k0 := l_k0 + (l_k - 1)
							l_pf := (l_smp + l_n0).item.sm_oneof
							if not l_pf.is_void then
								from
								until
									js.loop_done
								loop
									if (l_pf.item).to_integer_32 /= 0 then
										if (l_pf.item).to_integer_32 = (l_word[l_i___0 + l_k0]).to_integer_32 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_pf := l_pf + 1
									end
								end
								if (l_pf.item).to_integer_32 = 0 then
									js.continue
								end
								if not js.loop_jumped then
									l_k0 := l_k0 + 1
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 38 -- skip if block
						end
				when 32 then -- if:
						l_p0 := 5
						l_s := (l_smp + l_n0).item.sm_rules
						from
						until
							(l_s.item).to_integer_32 /= 45
						loop
							l_s := l_s + 1
						end
						if (l_s.item).to_integer_32 = 60 then
							l_s := l_s + 1
						end
						if (l_s.item).to_integer_32 >= 48 then
							if (l_s.item).to_integer_32 <= 57 then
								l_p0 := (l_s.item).to_integer_32 - 48
								l_s := l_s + 1
							end
						end
						if (l_s.item).to_integer_32 /= 0 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 37 -- goto _L
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 35 then -- else:
						if (l_s.item).to_integer_32 /= 36 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if (spell_iswordp ((l_word + l_i___0) + l_k0, globals_inst.curwin)).to_boolean then
							l_pos := -1 + 38 -- skip if block
						end
				when 37 then -- if: | _L:
						if l_k0 = l_k then
							js.continue
						end
						if not js.loop_jumped and then (l_p0 < l_pri) then
							js.continue
						end
						if not js.loop_jumped then
							js.break
						end
				when 38 then -- if done | if done | if done
						if js.loop_increment then
							l_n0 := l_n0 + 1
						end
						l_pos := -1 + 30 -- back to loop condition
				when 39 then -- loop done
						if l_p0 >= l_pri then
							if ((l_smp + l_n0).item.sm_lead[0]).to_integer_32 = l_c0 then
								js.continue
							end
						end
				when 40 then -- if done | if done | if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						l_s := (l_smp + l_n).item.sm_to
						if l_s.is_void then
							l_s := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
						end
						l_pf := (l_smp + l_n).item.sm_rules
						if not (misc2_inst.vim_strchr (l_pf, ('<').code)).is_void then
							l_p0 := 1
						else
							l_p0 := 0
						end
						if l_p0 /= 1 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if l_z = 0 then
							if l_reslen > 0 then
								if (l_s.item).to_integer_32 /= 0 then
									if (a_res[(l_reslen - 1)]).to_integer_32 = l_c then
										l_reslen := l_reslen - 1
									elseif (a_res[(l_reslen - 1)]).to_integer_32 = (l_s.item).to_integer_32 then
										l_reslen := l_reslen - 1
									end
								end
							end
							l_z0 := 1
							l_z := 1
							l_k0 := 0
							from
							until
								js.loop_done
							loop
								if (l_s.item).to_integer_32 /= 0 then
									if (l_word[l_i___0 + l_k0]).to_integer_32 = 0 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_word[l_i___0 + l_k0] := l_s.item
									l_k0 := l_k0 + 1
									l_s := l_s + 1
								end
							end
							if l_k > l_k0 then
								memmove (create {CE_POINTER [ANY]}.make_cast (((l_word + l_i___0) + l_k0)), create {CE_POINTER [ANY]}.make_cast (((l_word + l_i___0) + l_k)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((l_word + l_i___0) + l_k)))) + {NATURAL_32} 1).do_nothing
							end
							l_c := (l_word[l_i___0]).to_integer_32
						else
							l_pos := -1 + 44 -- goto _L___0
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___0:
						l_i___0 := l_i___0 + (l_k - 1)
						l_z := 0
						from
						until
							js.loop_done
						loop
							if (l_s.item).to_integer_32 /= 0 then
								if (l_s[1]).to_integer_32 /= 0 then
									if not (l_reslen < 250) then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if l_reslen = 0 then
									l_tmp___7 := l_reslen
									l_reslen := l_reslen + 1
									a_res[l_tmp___7] := l_s.item
								elseif (a_res[(l_reslen - 1)]).to_integer_32 /= (l_s.item).to_integer_32 then
									l_tmp___7 := l_reslen
									l_reslen := l_reslen + 1
									a_res[l_tmp___7] := l_s.item
								end
								l_s := l_s + 1
							end
						end
						l_c := (l_s.item).to_integer_32
						if not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_pf), ce_string ("^^"))).is_void then
							if l_c /= 0 then
								l_tmp___8 := l_reslen
								l_reslen := l_reslen + 1
								a_res[l_tmp___8] := l_c.to_natural_8
							end
							memmove (create {CE_POINTER [ANY]}.make_cast (l_word), create {CE_POINTER [ANY]}.make_cast (((l_word + l_i___0) + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((l_word + l_i___0) + 1)))) + {NATURAL_32} 1).do_nothing
							l_i___0 := 0
							l_z0 := 1
						end
				when 45 then
						js.break
				when 46 then -- if done | if done | if done | if done | if done | if done | if done
						if js.loop_increment then
							l_n := l_n + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 47 then -- loop done | if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:
						if l_c = 32 then
							l_c := (' ').code
							l_k := 1
						elseif l_c = 9 then
							l_c := (' ').code
							l_k := 1
						end
				when 49 then -- if done
						if l_z0 = 0 then
							if l_k.to_boolean then
								if not l_p0.to_boolean then
									if l_reslen < 250 then
										if l_c /= 0 then
											if not (a_slang.item.sl_collapse).to_boolean then
												l_tmp___15 := l_reslen
												l_reslen := l_reslen + 1
												a_res[l_tmp___15] := l_c.to_natural_8
											elseif l_reslen = 0 then
												l_tmp___15 := l_reslen
												l_reslen := l_reslen + 1
												a_res[l_tmp___15] := l_c.to_natural_8
											elseif (a_res[(l_reslen - 1)]).to_integer_32 /= l_c then
												l_tmp___15 := l_reslen
												l_reslen := l_reslen + 1
												a_res[l_tmp___15] := l_c.to_natural_8
											end
										end
									end
								end
							end
							l_i___0 := l_i___0 + 1
							l_z := 0
							l_k := 0
						end
				when 50 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 51 then -- loop done
					a_res[l_reslen] := (('%/0/').code).to_natural_8
				when 52 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_soundfold_sofo (a_slang: CE_POINTER [PD_SLANG_S]; a_inword: CE_POINTER [NATURAL_8]; a_res: CE_POINTER [NATURAL_8])
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ri: INTEGER_32
			l_c: INTEGER_32
			l_prevc: INTEGER_32
			l_ip: CE_POINTER [INTEGER_32]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make (<<1>>)
			create l_ip.make

			l_ri := 0
			if globals_inst.has_mbyte.to_boolean then
				l_prevc := 0
				l_s.item := a_inword
				from
				until
					not (not js.loop_done and then ((l_s.item.item).to_integer_32 /= 0))
				loop
					l_c := mbyte_inst.mb_cptr2char_adv (l_s)
					if globals_inst.enc_utf8.to_boolean then
						l_tmp___1 := ((mbyte_inst.utf_class (l_c)) = 0).to_integer
					else
						if l_c = 32 then
							l_tmp___0 := 1
						elseif l_c = 9 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
						l_tmp___1 := l_tmp___0
					end
					if l_tmp___1.to_boolean then
						l_c := (' ').code
					elseif l_c < 256 then
						l_c := a_slang.item.sl_sal_first[l_c]
					else
						l_ip := create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_cast (a_slang.item.sl_sal.ga_data)[((l_c).bit_and (255))]
						if l_ip.is_void then
							l_c := ('%/0/').code
						else
							from
							until
								js.loop_done
							loop
								if l_ip.item = 0 then
									l_c := ('%/0/').code
									js.break
								end
								if not js.loop_jumped and then (l_ip.item = l_c) then
									l_c := l_ip[1]
									js.break
								end
								if not js.loop_jumped then
									l_ip := l_ip + (2)
								end
							end
						end
					end
					if l_c /= 0 then
						if l_c /= l_prevc then
							l_ri := l_ri + (globals_inst.mb_char2bytes.integer_32_item ([l_c, a_res + l_ri]))
							if l_ri + 21 > 250 then
								js.break
							end
							if not js.loop_jumped then
								l_prevc := l_c
							end
						end
					end
				end
			else
				l_s.item := a_inword
				from
				until
					js.loop_done
				loop
					l_c := (l_s.item.item).to_integer_32
					if l_c = 0 then
						js.break
					end
					if not js.loop_jumped then
						if l_c = 32 then
							l_c := (' ').code
						elseif l_c = 9 then
							l_c := (' ').code
						else
							l_c := a_slang.item.sl_sal_first[l_c]
						end
						if l_c /= 0 then
							if l_ri = 0 then
								l_tmp___3 := l_ri
								l_ri := l_ri + 1
								a_res[l_tmp___3] := l_c.to_natural_8
							elseif (a_res[(l_ri - 1)]).to_integer_32 /= l_c then
								l_tmp___3 := l_ri
								l_ri := l_ri + 1
								a_res[l_tmp___3] := l_c.to_natural_8
							end
						end
						l_s.item := l_s.item + 1
					end
				end
			end
			a_res[l_ri] := (('%/0/').code).to_natural_8
		end

	spell_soundfold_wsal (a_slang: CE_POINTER [PD_SLANG_S]; a_inword: CE_POINTER [NATURAL_8]; a_res: CE_POINTER [NATURAL_8])
		local
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_word: CE_ARRAY [INTEGER_32]
			l_wres: CE_ARRAY [INTEGER_32]
			l_l: INTEGER_32
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ws: CE_POINTER [INTEGER_32]
			l_t: CE_POINTER [NATURAL_8]
			l_pf: CE_POINTER [INTEGER_32]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_z: INTEGER_32
			l_reslen: INTEGER_32
			l_n: INTEGER_32
			l_k: INTEGER_32
			l_z0: INTEGER_32
			l_k0: INTEGER_32
			l_n0: INTEGER_32
			l_c: INTEGER_32
			l_pri: INTEGER_32
			l_p0: INTEGER_32
			l_c0: INTEGER_32
			l_did_white: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_32]
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___17: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_smp.make
			create l_word.make (<<250>>)
			create l_wres.make (<<250>>)
			create l_s.make (<<1>>)
			create l_ws.make
			create l_t.make
			create l_pf.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_smp := create {CE_POINTER [PD_SALITEM_S]}.make_cast (a_slang.item.sl_sal.ga_data)
					l_k := 0
					l_p0 := -333
					l_did_white := 0
					l_n := 0
					l_s.item := a_inword
					from
					until
						(l_s.item.item).to_integer_32 = 0
					loop
						l_t := l_s.item
						l_c := mbyte_inst.mb_cptr2char_adv (l_s)
						if (a_slang.item.sl_rem_accents).to_boolean then
							if globals_inst.enc_utf8.to_boolean then
								l_tmp___2 := ((mbyte_inst.utf_class (l_c)) = 0).to_integer
							else
								if l_c = 32 then
									l_tmp___1 := 1
								elseif l_c = 9 then
									l_tmp___1 := 1
								else
									l_tmp___1 := 0
								end
								l_tmp___2 := l_tmp___1
							end
							if l_tmp___2.to_boolean then
								if l_did_white.to_boolean then
									js.continue
								end
								if not js.loop_jumped then
									l_c := (' ').code
									l_did_white := 1
								end
							else
								l_did_white := 0
								if not (spell_iswordp_nmw (l_t)).to_boolean then
									js.continue
								end
							end
						end
						if not js.loop_jumped then
							l_tmp___3 := l_n
							l_n := l_n + 1
							l_word[l_tmp___3] := l_c
						end
						
					end
					l_word[l_n] := ('%/0/').code
					l_z := 0
					l_reslen := l_z
					l_i___0 := l_reslen
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 51 -- skip loop
					end
				when 2 then -- loop body:
						l_c := l_word[l_i___0]
						if l_c = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 50 -- skip if block
						end
				when 3 then -- if:
						l_n := a_slang.item.sl_sal_first[(l_c).bit_and (255)]
						l_z0 := 0
						if not (l_n >= 0) then
							l_pos := -1 + 48 -- skip if block
						end
				when 4 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 47 -- skip loop
						end
				when 5 then -- loop body:
						l_ws := (l_smp + l_n).item.sm_lead_w
						if ((l_ws[0]).bit_and (255)) = ((l_c).bit_and (255)) then
							if l_ws[0] = 0 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped and then (l_c /= l_ws[0]) then
							js.continue
						end
						if not js.loop_jumped then
							l_k := (l_smp + l_n).item.sm_leadlen
							if l_k > 1 then
								if l_word[l_i___0 + 1] /= l_ws[1] then
									js.continue
								end
								if not js.loop_jumped and then (l_k > 2) then
									l_j := 2
									from
									until
										not (not js.loop_done and then (l_j < l_k))
									loop
										if l_word[l_i___0 + l_j] /= l_ws[l_j] then
											js.break
										end
										if not js.loop_jumped then
											l_j := l_j + 1
										end
									end
									if l_j < l_k then
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped then
							l_pf := (l_smp + l_n).item.sm_oneof_w
							if not l_pf.is_void then
								from
								until
									js.loop_done
								loop
									if l_pf.item /= 0 then
										if l_pf.item = l_word[l_i___0 + l_k] then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_pf := l_pf + 1
									end
								end
								if l_pf.item = 0 then
									js.continue
								end
								if not js.loop_jumped then
									l_k := l_k + 1
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 46 -- skip if block
						end
				when 6 then -- if:
						l_s.item := (l_smp + l_n).item.sm_rules
						l_pri := 5
						l_p0 := (l_s.item.item).to_integer_32
						l_k0 := l_k
						from
						until
							js.loop_done
						loop
							if (l_s.item.item).to_integer_32 = 45 then
								if not (l_k > 1) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_k := l_k - 1
								l_s.item := l_s.item + 1
							end
						end
						if (l_s.item.item).to_integer_32 = 60 then
							l_s.item := l_s.item + 1
						end
						if (l_s.item.item).to_integer_32 >= 48 then
							if (l_s.item.item).to_integer_32 <= 57 then
								l_pri := (l_s.item.item).to_integer_32 - 48
								l_s.item := l_s.item + 1
							end
						end
						if (l_s.item.item).to_integer_32 = 94 then
							if (l_s.item[1]).to_integer_32 = 94 then
								l_s.item := l_s.item + 1
							end
						end
						if (l_s.item.item).to_integer_32 /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 9 then -- else:
						if (l_s.item.item).to_integer_32 /= 94 then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if l_i___0 /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 19 -- goto _L___4
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if l_word[l_i___0 - 1] /= 32 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if not ((spell_iswordp_w ((l_word + l_i___0) - 1, globals_inst.curwin)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___4:
						if (l_s.item[1]).to_integer_32 /= 36 then
							l_pos := -1 + 25 -- goto _L___1
						elseif (spell_iswordp_w ((l_word + l_i___0) + l_k0, globals_inst.curwin)).to_boolean then
							l_pos := -1 + 21 -- goto _L___3
						else
							l_pos := -1 + 25 -- goto _L___1
						end
				when 20 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 46
				when 21 then -- else: | _L___3:
						if (l_s.item.item).to_integer_32 /= 36 then
							l_pos := -1 + 46 -- skip if block
						end
				when 22 then -- if:
						if not (l_i___0 > 0) then
							l_pos := -1 + 46 -- skip if block
						end
				when 23 then -- if:
						if not ((spell_iswordp_w ((l_word + l_i___0) - 1, globals_inst.curwin)).to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 24 then -- if:
						if (spell_iswordp_w ((l_word + l_i___0) + l_k0, globals_inst.curwin)).to_boolean then
							l_pos := -1 + 46 -- skip if block
						end
				when 25 then -- if: | _L___1:
						l_c0 := l_word[(l_i___0 + l_k) - 1]
						l_n0 := a_slang.item.sl_sal_first[(l_c0).bit_and (255)]
						if not ((a_slang.item.sl_followup).to_boolean) then
							l_pos := -1 + 40 -- skip if block
						end
				when 26 then -- if:
						if not (l_k > 1) then
							l_pos := -1 + 40 -- skip if block
						end
				when 27 then -- if:
						if not (l_n0 >= 0) then
							l_pos := -1 + 40 -- skip if block
						end
				when 28 then -- if:
						if l_p0 = 45 then
							l_pos := -1 + 40 -- skip if block
						end
				when 29 then -- if:
						if l_word[l_i___0 + l_k] = 0 then
							l_pos := -1 + 40 -- skip if block
						end
				when 30 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 39 -- skip loop
						end
				when 31 then -- loop body:
						l_ws := (l_smp + l_n0).item.sm_lead_w
						if ((l_ws[0]).bit_and (255)) /= ((l_c0).bit_and (255)) then
							js.break
						end
						if not js.loop_jumped and then (l_c0 /= l_ws[0]) then
							js.continue
						end
						if not js.loop_jumped then
							l_k0 := (l_smp + l_n0).item.sm_leadlen
							if l_k0 > 1 then
								if l_word[l_i___0 + l_k] /= l_ws[1] then
									js.continue
								end
								if not js.loop_jumped and then (l_k0 > 2) then
									l_pf := ((l_word + l_i___0) + l_k) + 1
									l_j := 2
									from
									until
										not (not js.loop_done and then (l_j < l_k0))
									loop
										l_tmp___4 := l_pf
										l_pf := l_pf + 1
										if l_tmp___4.item /= l_ws[l_j] then
											js.break
										end
										if not js.loop_jumped then
											l_j := l_j + 1
										end
									end
									if l_j < l_k0 then
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped then
							l_k0 := l_k0 + (l_k - 1)
							l_pf := (l_smp + l_n0).item.sm_oneof_w
							if not l_pf.is_void then
								from
								until
									js.loop_done
								loop
									if l_pf.item /= 0 then
										if l_pf.item = l_word[l_i___0 + l_k0] then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_pf := l_pf + 1
									end
								end
								if l_pf.item = 0 then
									js.continue
								end
								if not js.loop_jumped then
									l_k0 := l_k0 + 1
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 38 -- skip if block
						end
				when 32 then -- if:
						l_p0 := 5
						l_s.item := (l_smp + l_n0).item.sm_rules
						from
						until
							(l_s.item.item).to_integer_32 /= 45
						loop
							l_s.item := l_s.item + 1
						end
						if (l_s.item.item).to_integer_32 = 60 then
							l_s.item := l_s.item + 1
						end
						if (l_s.item.item).to_integer_32 >= 48 then
							if (l_s.item.item).to_integer_32 <= 57 then
								l_p0 := (l_s.item.item).to_integer_32 - 48
								l_s.item := l_s.item + 1
							end
						end
						if (l_s.item.item).to_integer_32 /= 0 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 37 -- goto _L
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 35 then -- else:
						if (l_s.item.item).to_integer_32 /= 36 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if (spell_iswordp_w ((l_word + l_i___0) + l_k0, globals_inst.curwin)).to_boolean then
							l_pos := -1 + 38 -- skip if block
						end
				when 37 then -- if: | _L:
						if l_k0 = l_k then
							js.continue
						end
						if not js.loop_jumped and then (l_p0 < l_pri) then
							js.continue
						end
						if not js.loop_jumped then
							js.break
						end
				when 38 then -- if done | if done | if done
						if js.loop_increment then
							l_n0 := l_n0 + 1
						end
						l_pos := -1 + 30 -- back to loop condition
				when 39 then -- loop done
						if l_p0 >= l_pri then
							if (((l_smp + l_n0).item.sm_lead_w[0]).bit_and (255)) = ((l_c0).bit_and (255)) then
								js.continue
							end
						end
				when 40 then -- if done | if done | if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						l_ws := (l_smp + l_n).item.sm_to_w
						l_s.item := (l_smp + l_n).item.sm_rules
						if not (misc2_inst.vim_strchr (l_s.item, ('<').code)).is_void then
							l_p0 := 1
						else
							l_p0 := 0
						end
						if l_p0 /= 1 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if l_z = 0 then
							if l_reslen > 0 then
								if not l_ws.is_void then
									if l_ws.item /= 0 then
										if l_wres[l_reslen - 1] = l_c then
											l_reslen := l_reslen - 1
										elseif l_wres[l_reslen - 1] = l_ws.item then
											l_reslen := l_reslen - 1
										end
									end
								end
							end
							l_z0 := 1
							l_z := 1
							l_k0 := 0
							if not l_ws.is_void then
								from
								until
									js.loop_done
								loop
									if l_ws.item /= 0 then
										if l_word[l_i___0 + l_k0] = 0 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_word[l_i___0 + l_k0] := l_ws.item
										l_k0 := l_k0 + 1
										l_ws := l_ws + 1
									end
								end
							end
							if l_k > l_k0 then
								memmove (create {CE_POINTER [ANY]}.make_cast (((l_word + l_i___0) + l_k0)), create {CE_POINTER [ANY]}.make_cast (((l_word + l_i___0) + l_k)), {PLATFORM}.Integer_32_bytes.to_natural_32 * ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((l_word + l_i___0) + l_k)))) + {NATURAL_32} 1)).do_nothing
							end
							l_c := l_word[l_i___0]
						else
							l_pos := -1 + 44 -- goto _L___0
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___0:
						l_i___0 := l_i___0 + (l_k - 1)
						l_z := 0
						if not l_ws.is_void then
							from
							until
								js.loop_done
							loop
								if l_ws.item /= 0 then
									if l_ws[1] /= 0 then
										if not (l_reslen < 250) then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if l_reslen = 0 then
										l_tmp___9 := l_reslen
										l_reslen := l_reslen + 1
										l_wres[l_tmp___9] := l_ws.item
									elseif l_wres[l_reslen - 1] /= l_ws.item then
										l_tmp___9 := l_reslen
										l_reslen := l_reslen + 1
										l_wres[l_tmp___9] := l_ws.item
									end
									l_ws := l_ws + 1
								end
							end
						end
						if l_ws.is_void then
							l_c := ('%/0/').code
						else
							l_c := l_ws.item
						end
						if not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_s.item), ce_string ("^^"))).is_void then
							if l_c /= 0 then
								l_tmp___10 := l_reslen
								l_reslen := l_reslen + 1
								l_wres[l_tmp___10] := l_c
							end
							memmove (create {CE_POINTER [ANY]}.make_cast (l_word), create {CE_POINTER [ANY]}.make_cast (((l_word + l_i___0) + 1)), {PLATFORM}.Integer_32_bytes.to_natural_32 * ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((l_word + l_i___0) + 1)))) + {NATURAL_32} 1)).do_nothing
							l_i___0 := 0
							l_z0 := 1
						end
				when 45 then
						js.break
				when 46 then -- if done | if done | if done | if done | if done | if done | if done
						if js.loop_increment then
							l_n := l_n + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 47 then -- loop done | if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:
						if l_c = 32 then
							l_c := (' ').code
							l_k := 1
						elseif l_c = 9 then
							l_c := (' ').code
							l_k := 1
						end
				when 49 then -- if done
						if l_z0 = 0 then
							if l_k.to_boolean then
								if not l_p0.to_boolean then
									if l_reslen < 250 then
										if l_c /= 0 then
											if not (a_slang.item.sl_collapse).to_boolean then
												l_tmp___17 := l_reslen
												l_reslen := l_reslen + 1
												l_wres[l_tmp___17] := l_c
											elseif l_reslen = 0 then
												l_tmp___17 := l_reslen
												l_reslen := l_reslen + 1
												l_wres[l_tmp___17] := l_c
											elseif l_wres[l_reslen - 1] /= l_c then
												l_tmp___17 := l_reslen
												l_reslen := l_reslen + 1
												l_wres[l_tmp___17] := l_c
											end
										end
									end
								end
							end
							l_i___0 := l_i___0 + 1
							l_z := 0
							l_k := 0
						end
				when 50 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 51 then -- loop done
					l_l := 0
					l_n := 0
					from
					until
						not (not js.loop_done and then (l_n < l_reslen))
					loop
						l_l := l_l + (globals_inst.mb_char2bytes.integer_32_item ([l_wres[l_n], a_res + l_l]))
						if l_l + 21 > 250 then
							js.break
						end
						if not js.loop_jumped then
							l_n := l_n + 1
						end
					end
					a_res[l_l] := (('%/0/').code).to_natural_8
				when 52 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_suggest (a_count___2: INTEGER_32)
		local
			l_line: CE_POINTER [NATURAL_8]
			l_prev_cursor: PD_POS_T
			l_wcopy: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_sug: CE_ARRAY [PD_SUGINFO_S]
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_mouse_used: CE_ARRAY [INTEGER_32]
			l_need_cap: INTEGER_32
			l_limit: INTEGER_32
			l_selected: INTEGER_32
			l_badlen: INTEGER_32
			l_msg_scroll_save: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___13: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_prev_cursor.make
			create l_wcopy.make (<<252>>)
			create l_p___0.make
			create l_sug.make (<<1>>)
			create l_stp.make
			create l_mouse_used.make (<<1>>)
			create l_tmp___13.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_prev_cursor := (globals_inst.curwin.item.w_cursor).twin
					l_selected := a_count___2
					l_badlen := 0
					l_msg_scroll_save := globals_inst.msg_scroll
					if (no_spell_checking (globals_inst.curwin)).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if globals_inst.curwin.item.w_cursor.lnum /= globals_inst.VIsual.item.lnum then
							misc1_inst.vim_beep
							js.return
						end
						if not js.return_called then
							l_badlen := globals_inst.curwin.item.w_cursor.col - globals_inst.VIsual.item.col
							if l_badlen < 0 then
								l_badlen := -l_badlen
							else
								globals_inst.curwin.item.w_cursor.col := globals_inst.VIsual.item.col
							end
							l_badlen := l_badlen + 1
							normal_inst.end_visual_mode
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if (spell_move_to (globals_inst.curwin, 1, 1, 1, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer))) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (globals_inst.curwin.item.w_cursor.col > l_prev_cursor.col) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						globals_inst.curwin.item.w_cursor := l_prev_cursor.twin
						l_line := memline_inst.ml_get_curline
						l_p___0 := l_line + globals_inst.curwin.item.w_cursor.col
						from
						until
							js.loop_done
						loop
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32 then
								if not (spell_iswordp_nmw (l_p___0)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___1 := (globals_inst.mb_head_off.integer_32_item ([l_line, l_p___0 - 1])) + 1
								else
									l_tmp___1 := 1
								end
								l_p___0 := l_p___0 - l_tmp___1
							end
						end
						from
						until
							js.loop_done
						loop
							if (l_p___0.item).to_integer_32 /= 0 then
								if (spell_iswordp_nmw (l_p___0)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___4 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
								else
									l_tmp___4 := 1
								end
								l_p___0 := l_p___0 + l_tmp___4
							end
						end
						if not (spell_iswordp_nmw (l_p___0)).to_boolean then
							misc1_inst.beep_flush
							js.return
						end
						if not js.return_called then
							globals_inst.curwin.item.w_cursor.col := l_p___0.distance (l_line)
						end
				when 9 then -- if done | if done | if done
						if js.return_called then
							l_pos := -1 + 13 -- skip if block
						end
				when 10 then -- if:
							l_need_cap := check_need_cap (globals_inst.curwin.item.w_cursor.lnum, globals_inst.curwin.item.w_cursor.col)
							l_line := misc2_inst.vim_strsave ((memline_inst.ml_get_curline))
							if l_line.is_void then
								l_pos := -1 + 12 -- goto skip
							end
				when 11 then
							if sps_limit > (globals_inst.Rows.item).to_integer_32 - 2 then
								l_limit := (globals_inst.Rows.item).to_integer_32 - 2
							else
								l_limit := sps_limit
							end
							spell_find_suggest (l_line + globals_inst.curwin.item.w_cursor.col, l_badlen, l_sug, l_limit, 1, l_need_cap, 1)
							if l_sug.item.su_ga.ga_len = 0 then
								message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Sorry, no suggestions"))))).do_nothing
							elseif a_count___2 > 0 then
								if a_count___2 > l_sug.item.su_ga.ga_len then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Sorry, only %%ld suggestions")))), (l_sug.item.su_ga.ga_len).to_integer_32]).do_nothing
								end
							else
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (repl_from))
								repl_from := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (repl_to))
								repl_to := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								message_inst.msg_start
								globals_inst.msg_row := (globals_inst.Rows.item - 1).to_integer_32
								globals_inst.lines_left := (globals_inst.Rows.item).to_integer_32
								message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Change %"%%.*s%" to:"))), l_sug.item.su_badlen, l_sug.item.su_badptr]).do_nothing
								message_inst.msg_puts (globals_inst.IObuff)
								message_inst.msg_clr_eos
								message_inst.msg_putchar (('%N').code)
								globals_inst.msg_scroll := 1
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_sug.item.su_ga.ga_len)
								loop
									l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (l_sug.item.su_ga.ga_data) + l_i___0
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_wcopy), create {CE_POINTER [INTEGER_8]}.make_cast (l_stp.item.st_word)).do_nothing
									if l_sug.item.su_badlen > l_stp.item.st_orglen then
										misc2_inst.vim_strncpy (l_wcopy + l_stp.item.st_wordlen, l_sug.item.su_badptr + l_stp.item.st_orglen, (l_sug.item.su_badlen - l_stp.item.st_orglen).to_natural_32)
									end
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("%%2d"), l_i___0 + 1]).do_nothing
									message_inst.msg_puts (globals_inst.IObuff)
									message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string (" %"%%s%""), l_wcopy]).do_nothing
									message_inst.msg_puts (globals_inst.IObuff)
									if l_sug.item.su_badlen < l_stp.item.st_orglen then
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string (" < %"%%.*s%""))), l_stp.item.st_orglen, l_sug.item.su_badptr]).do_nothing
										message_inst.msg_puts (globals_inst.IObuff)
									end
									if option_inst.p_verbose.item > 0 then
										if ((sps_flags).bit_and (5)).to_boolean then
											if (l_stp.item.st_salscore).to_boolean then
												l_tmp___13 := ce_string ("s ")
											else
												l_tmp___13 := ce_string ("")
											end
											message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string (" (%%s%%d - %%d)"), l_tmp___13, l_stp.item.st_score, l_stp.item.st_altscore]).do_nothing
										else
											message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string (" (%%d)"), l_stp.item.st_score]).do_nothing
										end
										message_inst.msg_advance (30)
										message_inst.msg_puts (globals_inst.IObuff)
									end
									message_inst.msg_putchar (('%N').code)
									l_i___0 := l_i___0 + 1
								end
								l_selected := misc1_inst.prompt_for_number (l_mouse_used)
								if (l_mouse_used.item).to_boolean then
									l_selected := l_selected - globals_inst.lines_left
								end
								globals_inst.lines_left := (globals_inst.Rows.item).to_integer_32
								globals_inst.msg_scroll := l_msg_scroll_save
							end
							if l_selected > 0 then
								if l_selected <= l_sug.item.su_ga.ga_len then
									if (undo_inst.u_save_cursor) = 1 then
										l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (l_sug.item.su_ga.ga_data) + (l_selected - 1)
										if l_sug.item.su_badlen > l_stp.item.st_orglen then
											repl_from := misc2_inst.vim_strnsave (l_sug.item.su_badptr, l_sug.item.su_badlen)
											message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("%%s%%.*s"), l_stp.item.st_word, l_sug.item.su_badlen - l_stp.item.st_orglen, l_sug.item.su_badptr + l_stp.item.st_orglen]).do_nothing
											repl_to := misc2_inst.vim_strsave (globals_inst.IObuff)
										else
											repl_from := misc2_inst.vim_strnsave (l_sug.item.su_badptr, l_stp.item.st_orglen)
											repl_to := misc2_inst.vim_strsave (l_stp.item.st_word)
										end
										l_p___0 := misc2_inst.alloc ((((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))) - (l_stp.item.st_orglen).to_natural_32) + (l_stp.item.st_wordlen).to_natural_32) + {NATURAL_32} 1)
										if not l_p___0.is_void then
											l_c := (l_sug.item.su_badptr).distance (l_line)
											memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_line), l_c.to_natural_32).do_nothing
											strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_c)), create {CE_POINTER [INTEGER_8]}.make_cast (l_stp.item.st_word)).do_nothing
											strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast ((l_sug.item.su_badptr + l_stp.item.st_orglen))).do_nothing
											memline_inst.ml_replace (globals_inst.curwin.item.w_cursor.lnum, l_p___0, 0).do_nothing
											globals_inst.curwin.item.w_cursor.col := l_c
											getchar_inst.ResetRedobuff
											getchar_inst.AppendToRedobuff (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ciw")))
											getchar_inst.AppendToRedobuffLit (l_p___0 + l_c, (l_stp.item.st_wordlen + l_sug.item.su_badlen) - l_stp.item.st_orglen)
											getchar_inst.AppendCharToRedobuff (('%/27/').code)
											misc1_inst.changed_bytes (globals_inst.curwin.item.w_cursor.lnum, l_c)
										end
									else
										globals_inst.curwin.item.w_cursor := l_prev_cursor.twin
									end
								else
									globals_inst.curwin.item.w_cursor := l_prev_cursor.twin
								end
							else
								globals_inst.curwin.item.w_cursor := l_prev_cursor.twin
							end
							spell_find_cleanup (l_sug)
				when 12 then -- skip:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line))
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	spell_suggest_expr (a_su: CE_POINTER [PD_SUGINFO_S]; a_expr: CE_POINTER [NATURAL_8])
		local
			l_list: CE_POINTER [PD_LISTVAR_S]
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_score: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
		do
			create l_list.make
			create l_li.make
			create l_p___0.make (<<1>>)

			l_list := eval_inst.eval_spell_expr (a_su.item.su_badword, a_expr)
			if not l_list.is_void then
				l_li := l_list.item.lv_first
				from
				until
					l_li.is_void
				loop
					if (l_li.item.li_tv.v_type).to_integer_32 = 4 then
						l_score := eval_inst.get_spellword (l_li.item.li_tv.vval.v_list, l_p___0)
						if l_score >= 0 then
							if l_score <= a_su.item.su_maxscore then
								add_suggestion (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_p___0.item, a_su.item.su_badlen, l_score, 0, 1, a_su.item.su_sallang, 0)
							end
						end
					end
					l_li := l_li.item.li_next
				end
				eval_inst.list_unref (l_list)
			end
			check_suggestions (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")))
			cleanup_suggestions (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), a_su.item.su_maxscore, a_su.item.su_maxcount).do_nothing
		end

	spell_suggest_file (a_su: CE_POINTER [PD_SUGINFO_S]; a_fname: CE_POINTER [NATURAL_8])
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_line: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_cword: CE_ARRAY [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_fd.make
			create l_line.make (<<500>>)
			create l_p___0.make
			create l_cword.make (<<250>>)
			create l_tmp___0.make

			l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), ce_string ("r"))
			if l_fd.is_void then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_fname).do_nothing
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if (fileio_inst.vim_fgets (l_line, 500, l_fd)).to_boolean then
						js.break
					elseif globals_inst.got_int.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						misc1_inst.line_breakcheck
						l_p___0 := misc2_inst.vim_strchr (l_line, ('/').code)
						if l_p___0.is_void then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___0.item := (('%/0/').code).to_natural_8
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((a_su.item.su_badword)), create {CE_POINTER [INTEGER_8]}.make_cast (l_line))) = 0 then
							l_len := 0
							from
							until
								not ((l_p___0[l_len]).to_integer_32 >= 32)
							loop
								l_len := l_len + 1
							end
							l_p___0[l_len] := (('%/0/').code).to_natural_8
							if (captype (l_p___0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 0 then
								make_case_word (l_p___0, l_cword, a_su.item.su_badflags)
								l_p___0 := l_cword
							end
							add_suggestion (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_p___0, a_su.item.su_badlen, 30, 0, 1, a_su.item.su_sallang, 0)
						end
					end
				end
				fclose (l_fd).do_nothing
				check_suggestions (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")))
				cleanup_suggestions (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), a_su.item.su_maxscore, a_su.item.su_maxcount).do_nothing
			end
		end

	spell_suggest_intern (a_su: CE_POINTER [PD_SUGINFO_S]; a_interactive: INTEGER_32)
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			suggest_load_files
			suggest_try_special (a_su)
			suggest_try_change (a_su)
			if ((sps_flags).bit_and (4)).to_boolean then
				score_comp_sal (a_su)
			end
			if ((sps_flags).bit_and (2)) = 0 then
				if ((sps_flags).bit_and (1)).to_boolean then
					rescore_suggestions (a_su)
				end
				suggest_try_soundalike_prep
				a_su.item.su_maxscore := 200
				a_su.item.su_sfmaxscore := 1_050
				suggest_try_soundalike (a_su)
				if a_su.item.su_maxcount < 130 then
					l_tmp___0 := 150
				else
					l_tmp___0 := a_su.item.su_maxcount + 20
				end
				if a_su.item.su_ga.ga_len < l_tmp___0 then
					a_su.item.su_maxscore := 300
					suggest_try_soundalike (a_su)
					if a_su.item.su_maxcount < 130 then
						l_tmp := 150
					else
						l_tmp := a_su.item.su_maxcount + 20
					end
					if a_su.item.su_ga.ga_len < l_tmp then
						a_su.item.su_maxscore := 400
						suggest_try_soundalike (a_su)
					end
				end
				a_su.item.su_maxscore := a_su.item.su_sfmaxscore
				suggest_try_soundalike_finish
			end
			ui_inst.ui_breakcheck
			if a_interactive.to_boolean then
				if globals_inst.got_int.to_boolean then
					getchar_inst.vgetc.do_nothing
					globals_inst.got_int := 0
				end
			end
			if ((sps_flags).bit_and (4)) = 0 then
				if a_su.item.su_ga.ga_len /= 0 then
					if ((sps_flags).bit_and (1)).to_boolean then
						rescore_suggestions (a_su)
					end
					check_suggestions (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")))
					cleanup_suggestions (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), a_su.item.su_maxscore, a_su.item.su_maxcount).do_nothing
				end
			end
		end

	spell_suggest_list (a_gap: CE_POINTER [PD_GROWARRAY]; a_word: CE_POINTER [NATURAL_8]; a_maxcount: INTEGER_32; a_need_cap: INTEGER_32; a_interactive: INTEGER_32)
		local
			l_sug: CE_ARRAY [PD_SUGINFO_S]
			l_i___0: INTEGER_32
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_wcopy: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_sug.make (<<1>>)
			create l_stp.make
			create l_wcopy.make

			spell_find_suggest (a_word, 0, l_sug, a_maxcount, 0, a_need_cap, a_interactive)
			misc2_inst.ga_init2 (a_gap, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, l_sug.item.su_ga.ga_len + 1)
			if (misc2_inst.ga_grow (a_gap, l_sug.item.su_ga.ga_len)) = 1 then
				l_i___0 := 0
				from
				until
					not (not js.loop_done and then (l_i___0 < l_sug.item.su_ga.ga_len))
				loop
					l_stp := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (l_sug.item.su_ga.ga_data) + l_i___0
					l_wcopy := misc2_inst.alloc (((l_stp.item.st_wordlen).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_sug.item.su_badptr + l_stp.item.st_orglen))))) + {NATURAL_32} 1)
					if l_wcopy.is_void then
						js.break
					end
					if not js.loop_jumped then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_wcopy), create {CE_POINTER [INTEGER_8]}.make_cast (l_stp.item.st_word)).do_nothing
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_wcopy + l_stp.item.st_wordlen)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_sug.item.su_badptr + l_stp.item.st_orglen))).do_nothing
						l_tmp___0 := a_gap.item.ga_len
						a_gap.item.ga_len := (a_gap.item.ga_len) + 1
						create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[l_tmp___0] := l_wcopy
						l_i___0 := l_i___0 + 1
					end
				end
			end
			spell_find_cleanup (l_sug)
		end

	spell_to_word_end (a_start___1: CE_POINTER [NATURAL_8]; a_win: CE_POINTER [PD_WINDOW_S]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0 := a_start___1
			from
			until
				js.loop_done
			loop
				if (l_p___0.item).to_integer_32 /= 0 then
					if not (spell_iswordp (l_p___0, a_win)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
					else
						l_tmp___0 := 1
					end
					l_p___0 := l_p___0 + l_tmp___0
				end
			end
			Result := l_p___0
		end

	spell_valid_case (a_wordflags: INTEGER_32; a_treeflags: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_wordflags /= 4 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((a_treeflags).bit_and (64)) = 0 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((a_treeflags).bit_and (132)) = 0 then
							if ((a_treeflags).bit_and (2)) = 0 then
								l_tmp := 1
							elseif ((a_wordflags).bit_and (2)) /= 0 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 4 then
					Result := l_tmp
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_word_start (a_startcol: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make
			create l_p___0.make

			l_col := 0
			if (no_spell_checking (globals_inst.curwin)).to_boolean then
				Result := a_startcol
				js.return
			end
			if not js.return_called then
				l_line := memline_inst.ml_get_curline
				l_p___0 := l_line + a_startcol
				from
				until
					not (not js.loop_done and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32))
				loop
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___1 := (globals_inst.mb_head_off.integer_32_item ([l_line, l_p___0 - 1])) + 1
					else
						l_tmp___1 := 1
					end
					l_p___0 := l_p___0 - l_tmp___1
					if (spell_iswordp_nmw (l_p___0)).to_boolean then
						js.break
					end
				end
				from
				until
					not (not js.loop_done and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32))
				loop
					l_col := l_p___0.distance (l_line)
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___4 := (globals_inst.mb_head_off.integer_32_item ([l_line, l_p___0 - 1])) + 1
					else
						l_tmp___4 := 1
					end
					l_p___0 := l_p___0 - l_tmp___4
					if not (spell_iswordp (l_p___0, globals_inst.curwin)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_col := 0
					end
				end
				Result := l_col
			end
		end

	store_aff_word (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_word: CE_POINTER [NATURAL_8]; a_afflist: CE_POINTER [NATURAL_8]; a_affile: CE_POINTER [PD_AFFFILE_S]; a_ht: CE_POINTER [PD_HASHTABLE_S]; a_xht: CE_POINTER [PD_HASHTABLE_S]; a_condit: INTEGER_32; a_flags___0: INTEGER_32; a_pfxlist: CE_POINTER [NATURAL_8]; a_pfxlen: INTEGER_32): INTEGER_32
		local
			l_todo: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_ah: CE_POINTER [PD_AFFHEADER_S]
			l_ae: CE_POINTER [PD_AFFENTRY_S]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_newword: CE_ARRAY [NATURAL_8]
			l_retval: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_use_flags: INTEGER_32
			l_use_pfxlist: CE_POINTER [NATURAL_8]
			l_use_pfxlen: INTEGER_32
			l_need_affix: INTEGER_32
			l_store_afflist: CE_ARRAY [NATURAL_8]
			l_pfx_pfxlist: CE_ARRAY [NATURAL_8]
			l_wordlen: NATURAL_32
			l_use_condit: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___22: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hi___1.make
			create l_ah.make
			create l_ae.make
			create l_regmatch___0.make (<<1>>)
			create l_newword.make (<<250>>)
			create l_p___0.make
			create l_use_pfxlist.make
			create l_store_afflist.make (<<250>>)
			create l_pfx_pfxlist.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 1
					l_wordlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_word)))
					l_todo := (a_ht.item.ht_used).to_integer_32
					l_hi___1 := a_ht.item.ht_array
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 41 -- skip loop
					end
				when 2 then -- loop body:
						if l_todo > 0 then
							if l_retval /= 1 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 40 -- skip if block
						end
				when 3 then -- if:
						if ((l_hi___1.item.hi_key).is_void) then
							l_pos := -1 + 39 -- skip if block
						end
				when 4 then -- if:
						if ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_pos := -1 + 39 -- skip if block
						end
				when 5 then -- if:
						l_todo := l_todo - 1
						l_ah := create {CE_POINTER [PD_AFFHEADER_S]}.make_cast (l_hi___1.item.hi_key)
						if ((a_condit).bit_and (1)) /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___3
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 8 then -- else:
						if not ((l_ah.item.ah_combine).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 9 then -- if: | _L___3:
						if not ((flag_in_afflist (a_affile.item.af_flagtype, a_afflist, l_ah.item.ah_flag)).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 10 then -- if:
						l_ae := l_ah.item.ah_first
				when 11 then -- loop condition:
						if not (not js.loop_done and then (not l_ae.is_void)) then
							l_pos := -1 + 39 -- skip loop
						end
				when 12 then -- loop body:
						l_regmatch___0.item.regprog := l_ae.item.ae_prog
						l_regmatch___0.item.rm_ic := 0
						if a_xht.is_void then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 22 -- goto _L___2
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 15 then -- else:
						if (a_affile.item.af_pfxpostpone).to_boolean then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 22 -- goto _L___2
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 18 then -- else:
						if (l_ae.item.ae_chop).is_void then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___2
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 21 then -- else:
						if (l_ae.item.ae_flags).is_void then
							l_pos := -1 + 38 -- skip if block
						end
				when 22 then -- if: | _L___2:
						if not ((l_ae.item.ae_chop).is_void) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___1
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 25 then -- else:
						if not ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ae.item.ae_chop))) < l_wordlen) then
							l_pos := -1 + 38 -- skip if block
						end
				when 26 then -- if: | _L___1:
						if not ((l_ae.item.ae_prog).is_void) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 30 -- goto _L___0
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 29 then -- else:
						if not ((regexp_inst.vim_regexec (l_regmatch___0, a_word, 0)).to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 30 then -- if: | _L___0:
						if ((a_condit).bit_and (8)) = 0 then
							l_tmp___22 := 1
						elseif (l_ae.item.ae_flags).is_void then
							l_tmp___22 := 1
						elseif (flag_in_afflist (a_affile.item.af_flagtype, l_ae.item.ae_flags, a_affile.item.af_circumfix)).to_boolean then
							l_tmp___22 := 0
						else
							l_tmp___22 := 1
						end
						if (((a_condit).bit_and (2)) = 0) /= l_tmp___22.to_boolean then
							l_pos := -1 + 38 -- skip if block
						end
				when 31 then -- if:
						if a_xht.is_void then
							if (l_ae.item.ae_add).is_void then
								l_newword[0] := (('%/0/').code).to_natural_8
							else
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_newword), create {CE_POINTER [INTEGER_8]}.make_cast (l_ae.item.ae_add)).do_nothing
							end
							l_p___0 := a_word
							if not (l_ae.item.ae_chop).is_void then
								if globals_inst.has_mbyte.to_boolean then
									l_i___0 := mbyte_inst.mb_charlen (l_ae.item.ae_chop)
									from
									until
										not (l_i___0 > 0)
									loop
										if globals_inst.has_mbyte.to_boolean then
											l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
										else
											l_tmp___1 := 1
										end
										l_p___0 := l_p___0 + l_tmp___1
										l_i___0 := l_i___0 - 1
									end
								else
									l_p___0 := l_p___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ae.item.ae_chop))).to_integer_32
								end
							end
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_newword), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
						else
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_newword), create {CE_POINTER [INTEGER_8]}.make_cast (a_word)).do_nothing
							if not (l_ae.item.ae_chop).is_void then
								l_p___0 := l_newword + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_newword))).to_integer_32
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___6 := (mbyte_inst.mb_charlen (l_ae.item.ae_chop))
								else
									l_tmp___6 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ae.item.ae_chop))).to_integer_32
								end
								l_i___0 := l_tmp___6
								from
								until
									not (l_i___0 > 0)
								loop
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___8 := (globals_inst.mb_head_off.integer_32_item ([l_newword, l_p___0 - 1])) + 1
									else
										l_tmp___8 := 1
									end
									l_p___0 := l_p___0 - l_tmp___8
									l_i___0 := l_i___0 - 1
								end
								l_p___0.item := (('%/0/').code).to_natural_8
							end
							if not (l_ae.item.ae_add).is_void then
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_newword), create {CE_POINTER [INTEGER_8]}.make_cast (l_ae.item.ae_add)).do_nothing
							end
						end
						l_use_flags := a_flags___0
						l_use_pfxlist := a_pfxlist
						l_use_pfxlen := a_pfxlen
						l_need_affix := 0
						l_use_condit := (((a_condit).bit_or (1))).bit_or (8)
						if (l_ae.item.ae_flags).is_void then
							l_pos := -1 + 37 -- skip if block
						end
				when 32 then -- if:
						l_use_flags := (l_use_flags).bit_or ((get_affix_flags (a_affile, l_ae.item.ae_flags)))
						if a_affile.item.af_needaffix /= {NATURAL_32} 0 then
							if (flag_in_afflist (a_affile.item.af_flagtype, l_ae.item.ae_flags, a_affile.item.af_needaffix)).to_boolean then
								l_need_affix := 1
							end
						end
						if a_affile.item.af_circumfix /= {NATURAL_32} 0 then
							if (flag_in_afflist (a_affile.item.af_flagtype, l_ae.item.ae_flags, a_affile.item.af_circumfix)).to_boolean then
								l_use_condit := (l_use_condit).bit_or ((2))
								if ((a_condit).bit_and (2)) = 0 then
									l_need_affix := 1
								end
							end
						end
						if not ((a_affile.item.af_pfxpostpone).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 35 then -- else:
						if (a_spin.item.si_compflags).is_void then
							l_pos := -1 + 37 -- skip if block
						end
				when 36 then -- if: | _L:
						if (a_affile.item.af_pfxpostpone).to_boolean then
							l_use_pfxlen := get_pfxlist (a_affile, l_ae.item.ae_flags, l_store_afflist)
						else
							l_use_pfxlen := 0
						end
						l_use_pfxlist := l_store_afflist
						l_i___0 := 0
						from
						until
							not (not js.loop_done and then (l_i___0 < a_pfxlen))
						loop
							l_j := 0
							from
							until
								not (not js.loop_done and then (l_j < l_use_pfxlen))
							loop
								if (a_pfxlist[l_i___0]).to_integer_32 = (l_use_pfxlist[l_j]).to_integer_32 then
									js.break
								end
								if not js.loop_jumped then
									l_j := l_j + 1
								end
							end
							if l_j = l_use_pfxlen then
								l_tmp___12 := l_use_pfxlen
								l_use_pfxlen := l_use_pfxlen + 1
								l_use_pfxlist[l_tmp___12] := a_pfxlist[l_i___0]
							end
							l_i___0 := l_i___0 + 1
						end
						if not (a_spin.item.si_compflags).is_void then
							get_compflags (a_affile, l_ae.item.ae_flags, l_use_pfxlist + l_use_pfxlen)
						end
						l_i___0 := a_pfxlen
						from
						until
							not (not js.loop_done and then ((a_pfxlist[l_i___0]).to_integer_32 /= 0))
						loop
							l_j := l_use_pfxlen
							from
							until
								not (not js.loop_done and then ((l_use_pfxlist[l_j]).to_integer_32 /= 0))
							loop
								if (a_pfxlist[l_i___0]).to_integer_32 = (l_use_pfxlist[l_j]).to_integer_32 then
									js.break
								end
								if not js.loop_jumped then
									l_j := l_j + 1
								end
							end
							if (l_use_pfxlist[l_j]).to_integer_32 = 0 then
								l_tmp___13 := l_j
								l_j := l_j + 1
								l_use_pfxlist[l_tmp___13] := a_pfxlist[l_i___0]
								l_use_pfxlist[l_j] := (('%/0/').code).to_natural_8
							end
							l_i___0 := l_i___0 + 1
						end
				when 37 then -- if done | if done
						if not l_use_pfxlist.is_void then
							if (l_ae.item.ae_compforbid).to_boolean then
								misc2_inst.vim_strncpy (l_pfx_pfxlist, l_use_pfxlist, l_use_pfxlen.to_natural_32)
								l_use_pfxlist := l_pfx_pfxlist
							end
						end
						if not (a_spin.item.si_prefroot).is_void then
							if not ((a_spin.item.si_prefroot).item.wn_sibling).is_void then
								l_use_flags := (l_use_flags).bit_or ((256))
								if not (l_ah.item.ah_combine).to_boolean then
									if not l_use_pfxlist.is_void then
										l_use_pfxlist := l_use_pfxlist + l_use_pfxlen
									end
								end
							end
						end
						if not (a_spin.item.si_compflags).is_void then
							if not (l_ae.item.ae_comppermit).to_boolean then
								if not a_xht.is_void then
									l_use_flags := (l_use_flags).bit_or ((8_192))
								else
									l_use_flags := (l_use_flags).bit_or ((4_096))
								end
							end
						end
						if (store_word (a_spin, l_newword, l_use_flags, a_spin.item.si_region, l_use_pfxlist, l_need_affix)) = 0 then
							l_retval := 0
						end
						if ((a_condit).bit_and (4)).to_boolean then
							if not (l_ae.item.ae_flags).is_void then
								if a_xht.is_void then
									l_tmp___15 := (0).bit_not
								else
									l_tmp___15 := (4).bit_not
								end
								if (store_aff_word (a_spin, l_newword, l_ae.item.ae_flags, a_affile, create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff")), a_xht, (l_use_condit).bit_and (l_tmp___15), l_use_flags, l_use_pfxlist, a_pfxlen)) = 0 then
									l_retval := 0
								end
							end
						end
						if not a_xht.is_void then
							if (l_ah.item.ah_combine).to_boolean then
								if (store_aff_word (a_spin, l_newword, a_afflist, a_affile, a_xht, create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (default_pointer), l_use_condit, l_use_flags, l_use_pfxlist, a_pfxlen)) = 0 then
									l_retval := 0
								elseif not (l_ae.item.ae_flags).is_void then
									if (store_aff_word (a_spin, l_newword, l_ae.item.ae_flags, a_affile, a_xht, create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (default_pointer), l_use_condit, l_use_flags, l_use_pfxlist, a_pfxlen)) = 0 then
										l_retval := 0
									end
								end
							end
						end
				when 38 then -- if done | if done | if done | if done | if done | if done | if done | if done
						l_ae := l_ae.item.ae_next
						l_pos := -1 + 11 -- back to loop condition
				when 39 then -- loop done | if done | if done | if done | if done
						l_hi___1 := l_hi___1 + 1
				when 40 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 41 then -- loop done
					Result := l_retval
				when 42 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	store_word (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_word: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32; a_region: INTEGER_32; a_pfxlist: CE_POINTER [NATURAL_8]; a_need_affix: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_ct: INTEGER_32
			l_foldword: CE_ARRAY [NATURAL_8]
			l_res: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_foldword.make (<<250>>)
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_word))).to_integer_32
					l_ct := (captype (a_word, a_word + l_len))
					l_res := 1
					spell_casefold (a_word, l_len, l_foldword, 250).do_nothing
					l_p___0 := a_pfxlist
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_res = 1)) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						if a_need_affix.to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 5 then -- else:
						if l_p___0.is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_p___0.is_void then
							l_tmp___1 := 0
						else
							l_tmp___1 := (l_p___0.item).to_integer_32
						end
						l_res := tree_add_word (a_spin, l_foldword, a_spin.item.si_foldroot, (l_ct).bit_or (a_flags___0), a_region, l_tmp___1)
				when 8 then -- if done | if done
						if l_p___0.is_void then
							js.break
						elseif (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					a_spin.item.si_foldwcount := (a_spin.item.si_foldwcount) + 1
					if l_res /= 1 then
						l_pos := -1 + 24 -- skip if block
					end
				when 10 then -- if:
						if l_ct /= 128 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___1
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 13 then -- else:
						if not (((a_flags___0).bit_and (128)).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 14 then -- if: | _L___1:
						l_p___0 := a_pfxlist
				when 15 then -- loop condition:
						if not (not js.loop_done and then (l_res = 1)) then
							l_pos := -1 + 23 -- skip loop
						end
				when 16 then -- loop body:
						if a_need_affix.to_boolean then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 19 then -- else:
						if l_p___0.is_void then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L___0:
						if l_p___0.is_void then
							l_tmp___2 := 0
						else
							l_tmp___2 := (l_p___0.item).to_integer_32
						end
						l_res := tree_add_word (a_spin, a_word, a_spin.item.si_keeproot, a_flags___0, a_region, l_tmp___2)
				when 22 then -- if done | if done
						if l_p___0.is_void then
							js.break
						elseif (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 15 -- back to loop condition
				when 23 then -- loop done
						a_spin.item.si_keepwcount := (a_spin.item.si_keepwcount) + 1
				when 24 then -- if done | if done
						Result := l_res
				when 25 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	stp_sal_score (a_stp: CE_POINTER [PD_SUGGEST_S]; a_su: CE_POINTER [PD_SUGINFO_S]; a_slang: CE_POINTER [PD_SLANG_S]; a_badsound: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pbad: CE_POINTER [NATURAL_8]
			l_pgood: CE_POINTER [NATURAL_8]
			l_badsound2: CE_ARRAY [NATURAL_8]
			l_fword: CE_ARRAY [NATURAL_8]
			l_goodsound: CE_ARRAY [NATURAL_8]
			l_goodword: CE_ARRAY [NATURAL_8]
			l_lendiff: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_pbad.make
			create l_pgood.make
			create l_badsound2.make (<<250>>)
			create l_fword.make (<<250>>)
			create l_goodsound.make (<<250>>)
			create l_goodword.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lendiff := a_su.item.su_badlen - a_stp.item.st_orglen
					if not (l_lendiff >= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pbad := a_badsound
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						spell_casefold (a_su.item.su_badptr, a_stp.item.st_orglen, l_fword, 250).do_nothing
						if (a_su.item.su_badptr[a_su.item.su_badlen]).to_integer_32 /= 32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (a_su.item.su_badptr[a_su.item.su_badlen]).to_integer_32 /= 9 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if ((charset_inst.skiptowhite (a_stp.item.st_word)).item).to_integer_32 = 0 then
							l_p___0 := l_fword
							from
							until
								js.loop_done
							loop
								l_p___0 := charset_inst.skiptowhite (l_p___0)
								if (l_p___0.item).to_integer_32 = 0 then
									js.break
								end
								if not js.loop_jumped then
									memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
								end
							end
						end
				when 8 then -- if done
						spell_soundfold (a_slang, l_fword, 1, l_badsound2)
						l_pbad := l_badsound2
				when 9 then -- if done
					if l_lendiff > 0 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_goodword), create {CE_POINTER [INTEGER_8]}.make_cast (a_stp.item.st_word)).do_nothing
						misc2_inst.vim_strncpy (l_goodword + a_stp.item.st_wordlen, (a_su.item.su_badptr + a_su.item.su_badlen) - l_lendiff, l_lendiff.to_natural_32)
						l_pgood := l_goodword
					else
						l_pgood := a_stp.item.st_word
					end
					spell_soundfold (a_slang, l_pgood, 0, l_goodsound)
					Result := (soundalike_score (l_goodsound, l_pbad))
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	str_equal (a_s1: CE_POINTER [NATURAL_8]; a_s2: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_s1.is_void then
				Result := (a_s1.is_equal (a_s2)).to_integer
				js.return
			elseif a_s2.is_void then
				Result := (a_s1.is_equal (a_s2)).to_integer
				js.return
			end
			if not js.return_called then
				Result := ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_s1), create {CE_POINTER [INTEGER_8]}.make_cast (a_s2))) = 0).to_integer
			end
		end

	sug_compare (a_s1: CE_POINTER [ANY]; a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_p1: CE_POINTER [PD_SUGGEST_S]
			l_p2: CE_POINTER [PD_SUGGEST_S]
			l_n: INTEGER_32
		do
			create l_p1.make
			create l_p2.make

			l_p1 := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_s1)
			l_p2 := create {CE_POINTER [PD_SUGGEST_S]}.make_cast (a_s2)
			l_n := l_p1.item.st_score - l_p2.item.st_score
			if l_n = 0 then
				l_n := l_p1.item.st_altscore - l_p2.item.st_altscore
				if l_n = 0 then
					l_n := strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p1.item.st_word), create {CE_POINTER [INTEGER_8]}.make_cast (l_p2.item.st_word))
				end
			end
			Result := l_n
		end

	sug_compare_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sug_compare)
		end

	sug_filltable (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_node: CE_POINTER [PD_WORDNODE_S]; a_startwordnr: INTEGER_32; a_gap: CE_POINTER [PD_GROWARRAY]): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_WORDNODE_S]
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_wordnr: INTEGER_32
			l_nr: INTEGER_32
			l_prev_nr: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_np.make

			l_wordnr := a_startwordnr
			l_p___0 := a_node
			from
			until
				not (not js.loop_done and then (not l_p___0.is_void))
			loop
				if (l_p___0.item.wn_byte).to_integer_32 = 0 then
					a_gap.item.ga_len := 0
					l_prev_nr := 0
					l_np := l_p___0
					from
					until
						js.loop_done
					loop
						if not l_np.is_void then
							if (l_np.item.wn_byte).to_integer_32 /= 0 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							if (misc2_inst.ga_grow (a_gap, 10)) = 0 then
								Result := (-1)
								js.return
							end
							if not js.return_called then
								l_nr := (((l_np.item.wn_flags).to_integer_32).bit_shift_left (16)) + (((l_np.item.wn_region).to_integer_32).bit_and (65_535))
								l_nr := l_nr - l_prev_nr
								l_prev_nr := l_prev_nr + l_nr
								a_gap.item.ga_len := a_gap.item.ga_len + (offset2bytes (l_nr, create {CE_POINTER [NATURAL_8]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len))
								l_np := l_np.item.wn_sibling
							end
						end
					end
					if not js.return_called then
						l_tmp___1 := a_gap.item.ga_len
						a_gap.item.ga_len := (a_gap.item.ga_len) + 1
						create {CE_POINTER [NATURAL_8]}.make_cast (a_gap.item.ga_data)[l_tmp___1] := (('%/0/').code).to_natural_8
						if (memline_inst.ml_append_buf (a_spin.item.si_spellbuf, l_wordnr.to_integer_32, create {CE_POINTER [NATURAL_8]}.make_cast (a_gap.item.ga_data), a_gap.item.ga_len, 1)) = 0 then
							Result := (-1)
							js.return
						end
					end
					if not js.return_called then
						l_wordnr := l_wordnr + 1
						from
						until
							js.loop_done
						loop
							if not (l_p___0.item.wn_sibling).is_void then
								if ((l_p___0.item.wn_sibling).item.wn_byte).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.item.wn_sibling := (l_p___0.item.wn_sibling).item.wn_sibling
							end
						end
						l_p___0.item.wn_flags := (0).to_natural_16
						l_p___0.item.wn_region := (0).to_integer_16
					end
				else
					l_wordnr := sug_filltable (a_spin, l_p___0.item.wn_child, l_wordnr, a_gap)
					if l_wordnr = -1 then
						Result := (-1)
						js.return
					end
				end
				if not js.return_called then
					l_p___0 := l_p___0.item.wn_sibling
				end
			end
			if not js.return_called then
				Result := l_wordnr
			end
		end

	sug_filltree (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_slang: CE_POINTER [PD_SLANG_S]): INTEGER_32
		local
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_depth___1: INTEGER_32
			l_arridx: CE_ARRAY [INTEGER_32]
			l_curi: CE_ARRAY [INTEGER_32]
			l_tword: CE_ARRAY [NATURAL_8]
			l_tsalword: CE_ARRAY [NATURAL_8]
			l_c: INTEGER_32
			l_n: INTEGER_32
			l_words_done: NATURAL_32
			l_wordcount: CE_ARRAY [INTEGER_32]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_byts.make
			create l_idxs.make
			create l_arridx.make (<<250>>)
			create l_curi.make (<<250>>)
			create l_tword.make (<<250>>)
			create l_tsalword.make (<<250>>)
			create l_wordcount.make (<<250>>)

			l_words_done := {NATURAL_32} 0
			a_spin.item.si_foldroot := wordtree_alloc (a_spin)
			if (a_spin.item.si_foldroot).is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				a_spin.item.si_sugtree := 1
				l_byts := a_slang.item.sl_fbyts
				l_idxs := a_slang.item.sl_fidxs
				l_arridx[0] := 0
				l_curi[0] := 1
				l_wordcount[0] := 0
				l_depth___1 := 0
				from
				until
					js.loop_done
				loop
					if l_depth___1 >= 0 then
						if globals_inst.got_int.to_boolean then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if l_curi[l_depth___1] > (l_byts[(l_arridx[l_depth___1])]).to_integer_32 then
							l_idxs[(l_arridx[l_depth___1])] := l_wordcount[l_depth___1]
							if l_depth___1 > 0 then
								l_wordcount[l_depth___1 - 1] := l_wordcount[l_depth___1 - 1] + (l_wordcount[l_depth___1])
							end
							l_depth___1 := l_depth___1 - 1
							misc1_inst.line_breakcheck
						else
							l_n := l_arridx[l_depth___1] + l_curi[l_depth___1]
							l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
							l_c := (l_byts[l_n]).to_integer_32
							if l_c = 0 then
								l_tword[l_depth___1] := (('%/0/').code).to_natural_8
								spell_soundfold (a_slang, l_tword, 1, l_tsalword)
								if (tree_add_word (a_spin, l_tsalword, a_spin.item.si_foldroot, ((l_words_done).bit_shift_right (16)).to_integer_32, ((l_words_done).bit_and ({NATURAL_32} 65_535)).to_integer_32, 0)) = 0 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_words_done := l_words_done + 1
									l_wordcount[l_depth___1] := (l_wordcount[l_depth___1]) + 1
									a_spin.item.si_blocks_cnt := 0
									from
									until
										(l_byts[(l_n + 1)]).to_integer_32 /= 0
									loop
										l_n := l_n + 1
										l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
									end
								end
							else
								l_tmp___0 := l_depth___1
								l_depth___1 := l_depth___1 + 1
								l_tword[l_tmp___0] := l_c.to_natural_8
								l_arridx[l_depth___1] := l_idxs[l_n]
								l_curi[l_depth___1] := 1
								l_wordcount[l_depth___1] := 0
							end
						end
					end
				end
			end
			if not js.return_called then
				message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Total number of words: %%d")))), l_words_done]).do_nothing
				Result := 1
			end
		end

	sug_maketable (a_spin: CE_POINTER [PD_SPELLINFO_S]): INTEGER_32
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_res: INTEGER_32
			js: JUMP_STATE
		do
			create l_ga.make (<<1>>)

			l_res := 1
			a_spin.item.si_spellbuf := open_spellbuf
			if (a_spin.item.si_spellbuf).is_void then
				Result := 0
				js.return
			end
			if not js.return_called then
				misc2_inst.ga_init2 (l_ga, 1, 100)
				if (sug_filltable (a_spin, (a_spin.item.si_foldroot).item.wn_sibling, 0, l_ga)) = -1 then
					l_res := 0
				end
				misc2_inst.ga_clear (l_ga)
				Result := l_res
			end
		end

	sug_write (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8])
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_tree: CE_POINTER [PD_WORDNODE_S]
			l_nodecount: INTEGER_32
			l_wcount: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fd.make
			create l_tree.make
			create l_line.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), ce_string ("w"))
					if l_fd.is_void then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_fname).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Writing suggestion file %%s ..."))), a_fname]).do_nothing
						spell_message (a_spin, globals_inst.IObuff)
						if (fwrite (create {CE_POINTER [ANY]}.make_cast (ce_string ("VIMsug")), (6).to_natural_32, (1).to_natural_32, l_fd)) /= {NATURAL_32} 1 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_write))))).do_nothing
							l_pos := -1 + 7 -- goto theend
						end
				when 2 then
						IO_putc (1, l_fd).do_nothing
						misc2_inst.put_time (l_fd, a_spin.item.si_sugtime)
						a_spin.item.si_memtot := 0
						l_tree := (a_spin.item.si_foldroot).item.wn_sibling
						clear_node (l_tree)
						l_nodecount := put_node (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer), l_tree, 0, 0, 0)
						misc2_inst.put_bytes (l_fd, l_nodecount.to_natural_32, 4).do_nothing
						a_spin.item.si_memtot := ((a_spin.item.si_memtot).to_natural_32 + (l_nodecount.to_natural_32 + l_nodecount.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)).to_integer_32
						put_node (l_fd, l_tree, 0, 0, 0).do_nothing
						l_wcount := ((a_spin.item.si_spellbuf).item.b_ml.ml_line_count).to_integer_32
						misc2_inst.put_bytes (l_fd, l_wcount.to_natural_32, 4).do_nothing
						l_lnum := (1).to_integer_32
				when 3 then -- loop condition:
						if not (l_lnum <= l_wcount.to_integer_32) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_line := memline_inst.ml_get_buf (a_spin.item.si_spellbuf, l_lnum, 0)
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32 + 1
						if (fwrite (create {CE_POINTER [ANY]}.make_cast (l_line), l_len.to_natural_32, (1).to_natural_32, l_fd)) = {NATURAL_32} 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_write))))).do_nothing
							l_pos := -1 + 7 -- goto theend
						end
				when 5 then
						a_spin.item.si_memtot := a_spin.item.si_memtot + l_len
						l_lnum := l_lnum + 1
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						if (IO_putc (0, l_fd)) = -1 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_write))))).do_nothing
						end
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Estimated runtime memory use: %%d bytes"))), a_spin.item.si_memtot]).do_nothing
						spell_message (a_spin, globals_inst.IObuff)
				when 7 then -- theend:
						fclose (l_fd).do_nothing
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	suggest_load_files
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_dotp: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_timestamp: INTEGER_32
			l_wcount: INTEGER_32
			l_wordnr: INTEGER_32
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_c: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lp.make
			create l_slang.make
			create l_dotp.make
			create l_fd.make
			create l_buf___6.make (<<250>>)
			create l_ga.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lpi := 0
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len)) then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
						l_slang := l_lp.item.lp_slang
						if l_slang.item.sl_sugtime = 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						if (l_slang.item.sl_sugloaded).to_boolean then
							l_pos := -1 + 23 -- skip if block
						end
				when 4 then -- if:
						l_slang.item.sl_sugloaded := 1
						l_dotp := misc2_inst.vim_strrchr (l_slang.item.sl_fname, ('.').code)
						if l_dotp.is_void then
							js.continue
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_dotp), ce_string (".spl"))) /= 0 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 5 then -- if:
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_dotp), ce_string (".sug")).do_nothing
						l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_slang.item.sl_fname), ce_string ("r"))
						if l_fd.is_void then
							l_pos := -1 + 22 -- goto nextone
						end
				when 6 then
						l_i___0 := 0
						from
						until
							not (l_i___0 < 6)
						loop
							l_buf___6[l_i___0] := (IO_getc (l_fd)).to_natural_8
							l_i___0 := l_i___0 + 1
						end
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("VIMsug"), (6).to_natural_32)) /= 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E778: This does not look like a .sug file: %%s")))), l_slang.item.sl_fname).do_nothing
							l_pos := -1 + 22 -- goto nextone
						end
				when 7 then
						l_c := IO_getc (l_fd)
						if l_c < 1 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E779: Old .sug file, needs to be updated: %%s")))), l_slang.item.sl_fname).do_nothing
							l_pos := -1 + 22 -- goto nextone
						elseif l_c > 1 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E780: .sug file is for newer version of Vim: %%s")))), l_slang.item.sl_fname).do_nothing
							l_pos := -1 + 22 -- goto nextone
						end
				when 8 then
						l_timestamp := misc2_inst.get8ctime (l_fd)
						if l_timestamp /= l_slang.item.sl_sugtime then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E781: .sug file doesn%'t match .spl file: %%s")))), l_slang.item.sl_fname).do_nothing
							l_pos := -1 + 22 -- goto nextone
						end
				when 9 then
						if (spell_read_tree (l_fd, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sbyts")), create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sidxs")), 0, 0)) = 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | someerror:
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E782: error while reading .sug file: %%s")))), l_slang.item.sl_fname).do_nothing
						slang_clear_sug (l_slang)
						l_pos := -1 + 22 -- goto nextone
				when 11 then
						l_slang.item.sl_sugbuf := open_spellbuf
						if (l_slang.item.sl_sugbuf).is_void then
							l_pos := -1 + 10 -- goto someerror
						end
				when 12 then
						l_wcount := misc2_inst.get4c (l_fd)
						if l_wcount < 0 then
							l_pos := -1 + 10 -- goto someerror
						end
				when 13 then
						misc2_inst.ga_init2 (l_ga, 1, 100)
						l_wordnr := 0
				when 14 then -- loop condition:
						if not (not js.loop_done and then (l_wordnr < l_wcount)) then
							l_pos := -1 + 21 -- skip loop
						end
				when 15 then -- loop body:
						l_ga.item.ga_len := 0
				when 16 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 19 -- skip loop
						end
				when 17 then -- loop body:
						l_c := IO_getc (l_fd)
						if l_c < 0 then
							l_pos := -1 + 10 -- goto someerror
						elseif (misc2_inst.ga_grow (l_ga, 1)) = 0 then
							l_pos := -1 + 10 -- goto someerror
						end
				when 18 then
						l_tmp___9 := l_ga.item.ga_len
						l_ga.item.ga_len := (l_ga.item.ga_len) + 1
						create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)[l_tmp___9] := l_c.to_natural_8
						if l_c = 0 then
							js.break
						end
						l_pos := -1 + 16 -- back to loop condition
				when 19 then -- loop done
						if (memline_inst.ml_append_buf (l_slang.item.sl_sugbuf, l_wordnr.to_integer_32, create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data), l_ga.item.ga_len, 1)) = 0 then
							l_pos := -1 + 10 -- goto someerror
						end
				when 20 then
						l_wordnr := l_wordnr + 1
						l_pos := -1 + 14 -- back to loop condition
				when 21 then -- loop done
						misc2_inst.ga_clear (l_ga)
						tree_count_words (l_slang.item.sl_fbyts, l_slang.item.sl_fidxs)
						tree_count_words (l_slang.item.sl_sbyts, l_slang.item.sl_sidxs)
				when 22 then -- nextone:
						if not l_fd.is_void then
							fclose (l_fd).do_nothing
						end
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_dotp), ce_string (".spl")).do_nothing
				when 23 then -- if done | if done | if done
						if js.loop_increment then
							l_lpi := l_lpi + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	suggest_trie_walk (a_su: CE_POINTER [PD_SUGINFO_S]; a_lp: CE_POINTER [PD_LANGP_S]; a_fword: CE_POINTER [NATURAL_8]; a_soundfold: INTEGER_32)
		local
			l_tword: CE_ARRAY [NATURAL_8]
			l_stack: CE_ARRAY [PD_TRYSTATE_S]
			l_preword: CE_ARRAY [NATURAL_8]
			l_compflags: CE_ARRAY [NATURAL_8]
			l_sp: CE_POINTER [PD_TRYSTATE_S]
			l_newscore: INTEGER_32
			l_score: INTEGER_32
			l_byts: CE_POINTER [NATURAL_8]
			l_fbyts: CE_POINTER [NATURAL_8]
			l_pbyts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_fidxs: CE_POINTER [INTEGER_32]
			l_pidxs: CE_POINTER [INTEGER_32]
			l_depth___1: INTEGER_32
			l_c: INTEGER_32
			l_c2: INTEGER_32
			l_c3: INTEGER_32
			l_n: INTEGER_32
			l_flags___0: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_arridx: INTEGER_32
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_fl: INTEGER_32
			l_tl: INTEGER_32
			l_repextra: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_fword_ends: INTEGER_32
			l_goodword_ends: INTEGER_32
			l_breakcheckcount: INTEGER_32
			l_compound_ok: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___29: INTEGER_32
			l_try_compound: INTEGER_32
			l_try_split: INTEGER_32
			l_tmp___30: INTEGER_32
			l_l: INTEGER_32
			l_tmp___38: INTEGER_16
			l_tmp___39: NATURAL_8
			l_tmp___40: INTEGER_32
			l_tmp___48: INTEGER_32
			l_tmp___54: INTEGER_16
			l_tmp___55: NATURAL_8
			l_tmp___74: INTEGER_32
			l_tmp___79: INTEGER_32
			l_tmp___82: INTEGER_16
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tword.make (<<250>>)
			create l_stack.make (<<250>>)
			create l_preword.make (<<750>>)
			create l_compflags.make (<<250>>)
			create l_sp.make
			create l_byts.make
			create l_fbyts.make
			create l_pbyts.make
			create l_idxs.make
			create l_fidxs.make
			create l_pidxs.make
			create l_gap.make
			create l_p___0.make
			create l_ftp.make
			create l_slang.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := 0
					l_fl := 0
					l_repextra := 0
					l_slang := a_lp.item.lp_slang
					l_breakcheckcount := 1_000
					l_depth___1 := 0
					l_sp := l_stack + 0
					memset (create {CE_POINTER [ANY]}.make_cast (l_sp), 0, (create {PD_TRYSTATE_S}.make).structure_size.to_natural_32).do_nothing
					l_sp.item.ts_curi := (1).to_integer_16
					if a_soundfold.to_boolean then
						l_fbyts := l_slang.item.sl_sbyts
						l_byts := l_fbyts
						l_fidxs := l_slang.item.sl_sidxs
						l_idxs := l_fidxs
						l_pbyts := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_pidxs := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
						l_sp.item.ts_prefixdepth := (255).to_natural_8
						l_sp.item.ts_state := {PC_STATE_T}.STATE_START
					else
						l_fbyts := l_slang.item.sl_fbyts
						l_fidxs := l_slang.item.sl_fidxs
						l_pbyts := l_slang.item.sl_pbyts
						l_pidxs := l_slang.item.sl_pidxs
						if not l_pbyts.is_void then
							l_byts := l_pbyts
							l_idxs := l_pidxs
							l_sp.item.ts_prefixdepth := (254).to_natural_8
							l_sp.item.ts_state := {PC_STATE_T}.STATE_NOPREFIX
						else
							l_byts := l_fbyts
							l_idxs := l_fidxs
							l_sp.item.ts_prefixdepth := (255).to_natural_8
							l_sp.item.ts_state := {PC_STATE_T}.STATE_START
						end
					end
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 163 -- skip loop
					end
				when 2 then -- loop body:
						if l_depth___1 >= 0 then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 162 -- skip if block
						end
				when 3 then -- if:
						l_sp := l_stack + l_depth___1
						inspect (l_sp.item.ts_state).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 93
						when 3 then l_pos := -1 + 94
						when 4 then l_pos := -1 + 96
						when 5 then l_pos := -1 + 126
						when 6 then l_pos := -1 + 137
						when 7 then l_pos := -1 + 139
						when 8 then l_pos := -1 + 141
						when 9 then l_pos := -1 + 146
						when 10 then l_pos := -1 + 147
						when 11 then l_pos := -1 + 149
						when 12 then l_pos := -1 + 151
						when 13 then l_pos := -1 + 152
						when 14 then l_pos := -1 + 153
						when 15 then l_pos := -1 + 159
						when 16 then l_pos := -1 + 160
						else l_pos := -1 + 161
						end
				when 4 then -- switch 1, case 0 | switch 1, case 1
						l_arridx := l_sp.item.ts_arridx
						l_len := (l_byts[l_arridx]).to_integer_32
						l_arridx := l_arridx + (l_sp.item.ts_curi).to_integer_32
						if (l_sp.item.ts_prefixdepth).to_integer_32 /= 254 then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						l_n := 0
						from
						until
							js.loop_done
						loop
							if l_n < l_len then
								if (l_byts[(l_arridx + l_n)]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_n := l_n + 1
							end
						end
						l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + l_n).to_integer_16
						l_n := (l_sp.item.ts_state).to_integer_32
						l_sp.item.ts_state := {PC_STATE_T}.STATE_ENDNUL
						l_sp.item.ts_save_badflags := (a_su.item.su_badflags).to_natural_8
						if (l_byts[l_arridx]).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if l_n /= 1 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if globals_inst.has_mbyte.to_boolean then
							l_n := nofold_len (a_fword, (l_sp.item.ts_fidx).to_integer_32, a_su.item.su_badptr)
						else
							l_n := (l_sp.item.ts_fidx).to_integer_32
						end
						l_flags___0 := badword_captype (a_su.item.su_badptr, a_su.item.su_badptr + l_n)
						a_su.item.su_badflags := badword_captype (a_su.item.su_badptr + l_n, a_su.item.su_badptr + a_su.item.su_badlen)
						go_deeper (l_stack, l_depth___1, 0)
						l_depth___1 := l_depth___1 + 1
						l_sp := l_stack + l_depth___1
						l_sp.item.ts_prefixdepth := (l_depth___1 - 1).to_natural_8
						l_byts := l_fbyts
						l_idxs := l_fidxs
						l_sp.item.ts_arridx := 0
						l_tword[(l_sp.item.ts_twordlen).to_integer_32] := (('%/0/').code).to_natural_8
						make_case_word (l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, l_flags___0)
						l_sp.item.ts_prewordlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_preword))).to_natural_8
						l_sp.item.ts_splitoff := l_sp.item.ts_twordlen
				when 10 then -- if done
						l_pos := -1 + 162 -- switch 1; break
				when 11 then
						if (l_sp.item.ts_curi).to_integer_32 > l_len then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_ENDNUL
							l_sp.item.ts_save_badflags := (a_su.item.su_badflags).to_natural_8
							l_pos := -1 + 162 -- switch 1; break
						elseif (l_byts[l_arridx]).to_integer_32 /= 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_ENDNUL
							l_sp.item.ts_save_badflags := (a_su.item.su_badflags).to_natural_8
							l_pos := -1 + 162 -- switch 1; break
						end
				when 12 then
						l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
						l_flags___0 := l_idxs[l_arridx]
						if ((l_flags___0).bit_and (1_024)).to_boolean then
							l_pos := -1 + 162 -- switch 1; break
						end
				when 13 then
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 0 then
							l_tmp___4 := 1
						else
							if a_soundfold.to_boolean then
								if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 32 then
									l_tmp___0 := 1
								elseif (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 9 then
									l_tmp___0 := 1
								else
									l_tmp___0 := 0
								end
								l_tmp___3 := l_tmp___0
							else
								if (spell_iswordp (a_fword + (l_sp.item.ts_fidx).to_integer_32, globals_inst.curwin)).to_boolean then
									l_tmp___2 := 0
								else
									l_tmp___2 := 1
								end
								l_tmp___3 := l_tmp___2
							end
							if l_tmp___3.to_boolean then
								l_tmp___4 := 1
							else
								l_tmp___4 := 0
							end
						end
						l_fword_ends := l_tmp___4
						l_tword[(l_sp.item.ts_twordlen).to_integer_32] := (('%/0/').code).to_natural_8
						if not ((l_sp.item.ts_prefixdepth).to_integer_32 <= 253) then
							l_pos := -1 + 18 -- skip if block
						end
				when 14 then -- if:
						if (((l_sp.item.ts_flags).to_integer_32).bit_and (1)) /= 0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 15 then -- if:
						l_n := l_stack[(l_sp.item.ts_prefixdepth).to_integer_32].ts_arridx
						l_tmp___5 := l_n
						l_n := l_n + 1
						l_len := (l_pbyts[l_tmp___5]).to_integer_32
						l_c := 0
						from
						until
							js.loop_done
						loop
							if l_c < l_len then
								if (l_pbyts[(l_n + l_c)]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_c := l_c + 1
							end
						end
						if not (l_c > 0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_c := valid_word_prefix (l_c, l_n, l_flags___0, l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_slang, 0)
						if l_c = 0 then
							l_pos := -1 + 162 -- switch 1; break
						end
				when 17 then
						if ((l_c).bit_and (((1).bit_shift_left (24)))).to_boolean then
							l_flags___0 := (l_flags___0).bit_or ((8))
						end
						l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_or (1)).to_natural_8
				when 18 then -- if done | if done | if done
						if (l_sp.item.ts_complen).to_integer_32 = (l_sp.item.ts_compsplit).to_integer_32 then
							if l_fword_ends.to_boolean then
								if ((l_flags___0).bit_and (512)).to_boolean then
									l_goodword_ends := 0
								else
									l_goodword_ends := 1
								end
							else
								l_goodword_ends := 1
							end
						else
							l_goodword_ends := 1
						end
						l_p___0 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_compound_ok := 1
						if not ((l_sp.item.ts_complen).to_integer_32 > (l_sp.item.ts_compsplit).to_integer_32) then
							l_pos := -1 + 25 -- skip if block
						end
				when 19 then -- if:
						if not ((l_slang.item.sl_nobreak).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (l_sp.item.ts_fidx).to_integer_32 - (l_sp.item.ts_splitfidx).to_integer_32 = (l_sp.item.ts_twordlen).to_integer_32 - (l_sp.item.ts_splitoff).to_integer_32 then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((a_fword + (l_sp.item.ts_splitfidx).to_integer_32)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_tword + (l_sp.item.ts_splitoff).to_integer_32)), ((l_sp.item.ts_fidx).to_integer_32 - (l_sp.item.ts_splitfidx).to_integer_32).to_natural_32)) = 0 then
								l_preword[(l_sp.item.ts_prewordlen).to_integer_32] := (('%/0/').code).to_natural_8
								l_newscore := score_wordcount_adj (l_slang, l_sp.item.ts_score, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, ((l_sp.item.ts_prewordlen).to_integer_32 > 0).to_integer)
								if l_newscore <= a_su.item.su_maxscore then
									add_suggestion (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_preword, (l_sp.item.ts_splitfidx).to_integer_32 - l_repextra, l_newscore, 0, 0, a_lp.item.lp_sallang, 0)
								end
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 22 then -- else:
						if (l_flags___0.to_natural_32).bit_shift_right (24) = {NATURAL_32} 0 then
							l_pos := -1 + 162 -- switch 1; break
						elseif (l_sp.item.ts_twordlen).to_integer_32 - (l_sp.item.ts_splitoff).to_integer_32 < l_slang.item.sl_compminlen then
							l_pos := -1 + 162 -- switch 1; break
						end
				when 23 then
						if globals_inst.has_mbyte.to_boolean then
							if l_slang.item.sl_compminlen > 0 then
								if (mbyte_inst.mb_charlen (l_tword + (l_sp.item.ts_splitoff).to_integer_32)) < l_slang.item.sl_compminlen then
									l_pos := -1 + 162 -- switch 1; break
								end
							end
						end
				when 24 then
						l_compflags[(l_sp.item.ts_complen).to_integer_32] := ((l_flags___0.to_natural_32).bit_shift_right (24)).to_natural_8
						l_compflags[(l_sp.item.ts_complen).to_integer_32 + 1] := (('%/0/').code).to_natural_8
						misc2_inst.vim_strncpy (l_preword + (l_sp.item.ts_prewordlen).to_integer_32, l_tword + (l_sp.item.ts_splitoff).to_integer_32, ((l_sp.item.ts_twordlen).to_integer_32 - (l_sp.item.ts_splitoff).to_integer_32).to_natural_32)
						if (match_checkcompoundpattern (l_preword, (l_sp.item.ts_prewordlen).to_integer_32, create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_comppat")))).to_boolean then
							l_compound_ok := 0
						end
						if l_compound_ok.to_boolean then
							l_p___0 := l_preword
							from
							until
								js.loop_done
							loop
								if ((charset_inst.skiptowhite (l_p___0)).item).to_integer_32 = 0 then
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := charset_inst.skipwhite ((charset_inst.skiptowhite (l_p___0)))
								end
							end
							if l_fword_ends.to_boolean then
								if not (can_compound (l_slang, l_p___0, l_compflags + (l_sp.item.ts_compsplit).to_integer_32)).to_boolean then
									l_compound_ok := 0
								end
							end
						end
						l_p___0 := l_preword + (l_sp.item.ts_prewordlen).to_integer_32
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___13 := (globals_inst.mb_head_off.integer_32_item ([l_preword, l_p___0 - 1])) + 1
						else
							l_tmp___13 := 1
						end
						l_p___0 := l_p___0 - l_tmp___13
				when 25 then -- if done
						if a_soundfold.to_boolean then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_preword + (l_sp.item.ts_prewordlen).to_integer_32)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_tword + (l_sp.item.ts_splitoff).to_integer_32))).do_nothing
						elseif ((l_flags___0).bit_and (128)).to_boolean then
							find_keepcap_word (l_slang, l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_preword + (l_sp.item.ts_prewordlen).to_integer_32)
						else
							l_c := a_su.item.su_badflags
							if ((l_c).bit_and (4)).to_boolean then
								if a_su.item.su_badlen = (globals_inst.mb_ptr2len.integer_32_item ([a_su.item.su_badptr])) then
									l_c := 2
								end
							end
							l_c := (l_c).bit_or (l_flags___0)
							if not l_p___0.is_void then
								if (spell_iswordp_nmw (l_p___0)).to_boolean then
									l_c := (l_c).bit_and ((-3))
								end
							end
							make_case_word (l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, l_c)
						end
						if a_soundfold.to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 26 then -- if:
						if ((l_flags___0).bit_and (16)).to_boolean then
							add_banned (a_su, l_preword + (l_sp.item.ts_prewordlen).to_integer_32)
							l_pos := -1 + 162 -- switch 1; break
						end
				when 27 then
						if (l_sp.item.ts_complen).to_integer_32 /= (l_sp.item.ts_compsplit).to_integer_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if ((hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned")), l_preword + (l_sp.item.ts_prewordlen).to_integer_32)).item.hi_key).is_void then
							l_pos := -1 + 30 -- goto _L___1
						elseif ((hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned")), l_preword + (l_sp.item.ts_prewordlen).to_integer_32)).item.hi_key).is_equal (globals_inst.hash_removed) then
							l_pos := -1 + 30 -- goto _L___1
						else
							l_pos := -1 + 32 -- goto _L___0
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 30 then -- else: | _L___1:
						if (((hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned")), l_preword)).item.hi_key).is_void) then
							l_pos := -1 + 34 -- skip if block
						end
				when 31 then -- if:
						if (((hashtab_inst.hash_find (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned")), l_preword)).item.hi_key).is_equal (globals_inst.hash_removed)) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if: | _L___0:
						if (l_slang.item.sl_compprog).is_void then
							l_pos := -1 + 162 -- switch 1; break
						end
				when 33 then
						l_goodword_ends := 0
				when 34 then -- if done | if done | if done
						l_newscore := 0
						if not a_soundfold.to_boolean then
							if ((l_flags___0).bit_and (1)).to_boolean then
								if ((((l_flags___0.to_natural_32).bit_shift_right (16))).bit_and ((a_lp.item.lp_region).to_natural_32)) = {NATURAL_32} 0 then
									l_newscore := l_newscore + (200)
								end
							end
							if ((l_flags___0).bit_and (8)).to_boolean then
								l_newscore := l_newscore + (180)
							end
							if not (spell_valid_case (a_su.item.su_badflags, (captype (l_preword + (l_sp.item.ts_prewordlen).to_integer_32, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))))).to_boolean then
								l_newscore := l_newscore + (52)
							end
						end
						if not (l_fword_ends.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 35 then -- if:
						if not (l_goodword_ends.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 36 then -- if:
						if not ((l_sp.item.ts_fidx).to_integer_32 >= (l_sp.item.ts_fidxtry).to_integer_32) then
							l_pos := -1 + 49 -- skip if block
						end
				when 37 then -- if:
						if not (l_compound_ok.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 38 then -- if:
						if not (a_soundfold.to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						add_sound_suggest (a_su, l_preword, l_sp.item.ts_score, a_lp)
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 41 then -- else:
						if not ((l_sp.item.ts_fidx).to_integer_32 > 0) then
							l_pos := -1 + 49 -- skip if block
						end
				when 42 then -- if:
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___23 := (globals_inst.mb_head_off.integer_32_item ([a_fword, l_p___0 - 1])) + 1
						else
							l_tmp___23 := 1
						end
						l_p___0 := l_p___0 - l_tmp___23
						if not (spell_iswordp (l_p___0, globals_inst.curwin)).to_boolean then
							l_p___0 := l_preword + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_preword))).to_integer_32
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___26 := (globals_inst.mb_head_off.integer_32_item ([l_preword, l_p___0 - 1])) + 1
							else
								l_tmp___26 := 1
							end
							l_p___0 := l_p___0 - l_tmp___26
							if (spell_iswordp (l_p___0, globals_inst.curwin)).to_boolean then
								l_newscore := l_newscore + (103)
							end
						end
						l_score := score_wordcount_adj (l_slang, l_sp.item.ts_score + l_newscore, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, ((l_sp.item.ts_prewordlen).to_integer_32 > 0).to_integer)
						if not (l_score <= a_su.item.su_maxscore) then
							l_pos := -1 + 49 -- skip if block
						end
				when 43 then -- if:
						add_suggestion (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_preword, (l_sp.item.ts_fidx).to_integer_32 - l_repextra, l_score, 0, 0, a_lp.item.lp_sallang, 0)
						if not (((a_su.item.su_badflags).bit_and (32)).to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 44 then -- if:
						l_c := captype (l_preword, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if l_c /= 0 then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						l_pos := -1 + 48 -- goto _L___2
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 47 then -- else:
						if l_c /= 4 then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | _L___2:
						if l_c = 0 then
							l_tmp___29 := 4
						else
							l_tmp___29 := 0
						end
						make_case_word (l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, l_tmp___29)
						add_suggestion (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_preword, (l_sp.item.ts_fidx).to_integer_32 - l_repextra, l_score + 52, 0, 0, a_lp.item.lp_sallang, 0)
				when 49 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not ((l_sp.item.ts_fidx).to_integer_32 >= (l_sp.item.ts_fidxtry).to_integer_32) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 53 -- goto _L___10
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 92
				when 52 then -- else:
						if not (l_fword_ends.to_boolean) then
							l_pos := -1 + 92 -- skip if block
						end
				when 53 then -- if: | _L___10:
						if globals_inst.has_mbyte.to_boolean then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_pos := -1 + 57 -- goto _L___9
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 92
				when 56 then -- else:
						if (l_sp.item.ts_tcharlen).to_integer_32 /= 0 then
							l_pos := -1 + 92 -- skip if block
						end
				when 57 then -- if: | _L___9:
						if (l_sp.item.ts_fidx).to_integer_32 - l_repextra < a_su.item.su_badlen then
							if not a_soundfold.to_boolean then
								l_tmp___30 := 1
							else
								l_tmp___30 := 0
							end
						else
							l_tmp___30 := 0
						end
						l_try_split := l_tmp___30
						l_try_compound := 0
						if a_soundfold.to_boolean then
							l_pos := -1 + 73 -- skip if block
						end
				when 58 then -- if:
						if (l_slang.item.sl_compprog).is_void then
							l_pos := -1 + 73 -- skip if block
						end
				when 59 then -- if:
						if (l_flags___0.to_natural_32).bit_shift_right (24) = {NATURAL_32} 0 then
							l_pos := -1 + 73 -- skip if block
						end
				when 60 then -- if:
						if not ((l_sp.item.ts_twordlen).to_integer_32 - (l_sp.item.ts_splitoff).to_integer_32 >= l_slang.item.sl_compminlen) then
							l_pos := -1 + 73 -- skip if block
						end
				when 61 then -- if:
						if globals_inst.has_mbyte.to_boolean then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						l_pos := -1 + 68 -- goto _L___4
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 64 then -- else:
						if l_slang.item.sl_compminlen /= 0 then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if:
						l_pos := -1 + 68 -- goto _L___4
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 67 then -- else:
						if not ((mbyte_inst.mb_charlen (l_tword + (l_sp.item.ts_splitoff).to_integer_32)) >= l_slang.item.sl_compminlen) then
							l_pos := -1 + 73 -- skip if block
						end
				when 68 then -- if: | _L___4:
						if not (l_slang.item.sl_compsylmax < 250) then
							l_pos := -1 + 71 -- skip if block
						end
				when 69 then -- if:
						l_pos := -1 + 72 -- goto _L___3
				when 70 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 71 then -- else:
						if not (((l_sp.item.ts_complen).to_integer_32 + 1) - (l_sp.item.ts_compsplit).to_integer_32 < l_slang.item.sl_compmax) then
							l_pos := -1 + 73 -- skip if block
						end
				when 72 then -- if: | _L___3:
						if (can_be_compound (l_sp, l_slang, l_compflags, ((l_flags___0.to_natural_32).bit_shift_right (24)).to_integer_32)).to_boolean then
							l_try_compound := 1
							l_compflags[(l_sp.item.ts_complen).to_integer_32] := ((l_flags___0.to_natural_32).bit_shift_right (24)).to_natural_8
							l_compflags[(l_sp.item.ts_complen).to_integer_32 + 1] := (('%/0/').code).to_natural_8
						end
				when 73 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if (l_slang.item.sl_nobreak).to_boolean then
							l_try_compound := 1
						elseif not l_fword_ends.to_boolean then
							if l_try_compound.to_boolean then
								if (((l_sp.item.ts_flags).to_integer_32).bit_and (2)) = 0 then
									l_try_compound := 0
									l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_or (2)).to_natural_8
									l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 - 1).to_integer_16
									l_compflags[(l_sp.item.ts_complen).to_integer_32] := (('%/0/').code).to_natural_8
								else
									l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_and (-3)).to_natural_8
								end
							else
								l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_and (-3)).to_natural_8
							end
						else
							l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_and (-3)).to_natural_8
						end
						if not (l_try_split.to_boolean) then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						l_pos := -1 + 77 -- goto _L___8
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 92
				when 76 then -- else:
						if not (l_try_compound.to_boolean) then
							l_pos := -1 + 92 -- skip if block
						end
				when 77 then -- if: | _L___8:
						if l_try_compound.to_boolean then
							l_pos := -1 + 85 -- skip if block
						end
				when 78 then -- if:
						if l_fword_ends.to_boolean then
							l_pos := -1 + 81 -- skip if block
						end
				when 79 then -- if:
						l_pos := -1 + 82 -- goto _L___5
				when 80 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 81 then -- else:
						if l_goodword_ends.to_boolean then
							l_pos := -1 + 85 -- skip if block
						end
				when 82 then -- if: | _L___5:
						if (l_sp.item.ts_complen).to_integer_32 = (l_sp.item.ts_compsplit).to_integer_32 then
							if ((l_flags___0).bit_and (512)).to_boolean then
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 83 then
						l_p___0 := l_preword
						from
						until
							js.loop_done
						loop
							if ((charset_inst.skiptowhite (l_p___0)).item).to_integer_32 = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_p___0 := charset_inst.skipwhite ((charset_inst.skiptowhite (l_p___0)))
							end
						end
						if (l_sp.item.ts_complen).to_integer_32 > (l_sp.item.ts_compsplit).to_integer_32 then
							if not (can_compound (l_slang, l_p___0, l_compflags + (l_sp.item.ts_compsplit).to_integer_32)).to_boolean then
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 84 then
						if (l_slang.item.sl_nosplitsugs).to_boolean then
							l_newscore := l_newscore + (249)
						else
							l_newscore := l_newscore + (149)
						end
						l_newscore := score_wordcount_adj (l_slang, l_newscore, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, 1)
				when 85 then -- if done | if done
						if not (l_stack[l_depth___1].ts_score + l_newscore < a_su.item.su_maxscore) then
							l_pos := -1 + 92 -- skip if block
						end
				when 86 then -- if:
						go_deeper (l_stack, l_depth___1, l_newscore)
						l_sp.item.ts_save_badflags := (a_su.item.su_badflags).to_natural_8
						l_sp.item.ts_state := {PC_STATE_T}.STATE_SPLITUNDO
						l_depth___1 := l_depth___1 + 1
						l_sp := l_stack + l_depth___1
						if not l_try_compound.to_boolean then
							if not l_fword_ends.to_boolean then
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_preword), ce_string (" ")).do_nothing
							end
						end
						l_sp.item.ts_prewordlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_preword))).to_natural_8
						l_sp.item.ts_splitoff := l_sp.item.ts_twordlen
						l_sp.item.ts_splitfidx := l_sp.item.ts_fidx
						if l_try_compound.to_boolean then
							l_pos := -1 + 89 -- skip if block
						end
				when 87 then -- if:
						if (spell_iswordp_nmw (a_fword + (l_sp.item.ts_fidx).to_integer_32)).to_boolean then
							l_pos := -1 + 89 -- goto _L___7
						else
							l_pos := -1 + 90 -- goto _L___6
						end
				when 88 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 89 then -- else: | _L___7:
						if not (l_fword_ends.to_boolean) then
							l_pos := -1 + 91 -- skip if block
						end
				when 90 then -- if: | _L___6:
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 /= 0 then
							if l_goodword_ends.to_boolean then
								if globals_inst.has_mbyte.to_boolean then
									l_l := (globals_inst.mb_bytelen_tab[(a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32]).to_integer_32
								else
									l_l := 1
								end
								if l_fword_ends.to_boolean then
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_preword + (l_sp.item.ts_prewordlen).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((a_fword + (l_sp.item.ts_fidx).to_integer_32)), l_l.to_natural_32).do_nothing
									l_sp.item.ts_prewordlen := ((l_sp.item.ts_prewordlen).to_integer_32 + l_l).to_natural_8
									l_preword[(l_sp.item.ts_prewordlen).to_integer_32] := (('%/0/').code).to_natural_8
								else
									l_sp.item.ts_score := l_sp.item.ts_score - (56)
								end
								l_sp.item.ts_fidx := ((l_sp.item.ts_fidx).to_integer_32 + l_l).to_natural_8
							end
						end
				when 91 then -- if done
						if l_try_compound.to_boolean then
							l_sp.item.ts_complen := ((l_sp.item.ts_complen).to_integer_32 + 1).to_natural_8
						else
							l_sp.item.ts_compsplit := l_sp.item.ts_complen
						end
						l_sp.item.ts_prefixdepth := (255).to_natural_8
						if globals_inst.has_mbyte.to_boolean then
							l_n := nofold_len (a_fword, (l_sp.item.ts_fidx).to_integer_32, a_su.item.su_badptr)
						else
							l_n := (l_sp.item.ts_fidx).to_integer_32
						end
						a_su.item.su_badflags := badword_captype (a_su.item.su_badptr + l_n, a_su.item.su_badptr + a_su.item.su_badlen)
						l_sp.item.ts_arridx := 0
						if not l_pbyts.is_void then
							l_byts := l_pbyts
							l_idxs := l_pidxs
							l_sp.item.ts_prefixdepth := (254).to_natural_8
							l_sp.item.ts_state := {PC_STATE_T}.STATE_NOPREFIX
						end
				when 92 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 162 -- switch 1; break
				when 93 then -- switch 1, case 2
						a_su.item.su_badflags := (l_sp.item.ts_save_badflags).to_integer_32
						l_sp.item.ts_state := {PC_STATE_T}.STATE_START
						l_byts := l_fbyts
						l_idxs := l_fidxs
						l_pos := -1 + 162 -- switch 1; break
				when 94 then -- switch 1, case 3
						a_su.item.su_badflags := (l_sp.item.ts_save_badflags).to_integer_32
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 0 then
							if (l_sp.item.ts_tcharlen).to_integer_32 = 0 then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_DEL
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 95 then
						l_sp.item.ts_state := {PC_STATE_T}.STATE_PLAIN
				when 96 then -- switch 1, case 4
						l_arridx := l_sp.item.ts_arridx
						if not ((l_sp.item.ts_curi).to_integer_32 > (l_byts[l_arridx]).to_integer_32) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						if (l_sp.item.ts_fidx).to_integer_32 >= (l_sp.item.ts_fidxtry).to_integer_32 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_DEL
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
						end
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 99 then -- else:
						l_tmp___38 := l_sp.item.ts_curi
						l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
						l_arridx := l_arridx + l_tmp___38
						l_c := (l_byts[l_arridx]).to_integer_32
						if l_c = (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 then
							l_newscore := 0
						elseif (l_sp.item.ts_tcharlen).to_integer_32 > 0 then
							if (l_sp.item.ts_isdiff).to_integer_32 /= 0 then
								l_newscore := 0
							else
								l_newscore := 93
							end
						else
							l_newscore := 93
						end
						if l_newscore /= 0 then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						l_pos := -1 + 107 -- goto _L___15
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 102 then -- else:
						if not ((l_sp.item.ts_fidx).to_integer_32 >= (l_sp.item.ts_fidxtry).to_integer_32) then
							l_pos := -1 + 125 -- skip if block
						end
				when 103 then -- if:
						if (((l_sp.item.ts_flags).to_integer_32).bit_and (4)) /= 0 then
							l_pos := -1 + 106 -- skip if block
						end
				when 104 then -- if:
						l_pos := -1 + 107 -- goto _L___15
				when 105 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 106 then -- else:
						if l_c = (a_fword[(l_sp.item.ts_delidx).to_integer_32]).to_integer_32 then
							l_pos := -1 + 125 -- skip if block
						end
				when 107 then -- if: | _L___15:
						if not (l_stack[l_depth___1].ts_score + l_newscore < a_su.item.su_maxscore) then
							l_pos := -1 + 125 -- skip if block
						end
				when 108 then -- if:
						go_deeper (l_stack, l_depth___1, l_newscore)
						l_depth___1 := l_depth___1 + 1
						l_sp := l_stack + l_depth___1
						l_sp.item.ts_fidx := ((l_sp.item.ts_fidx).to_integer_32 + 1).to_natural_8
						l_tmp___39 := l_sp.item.ts_twordlen
						l_sp.item.ts_twordlen := ((l_sp.item.ts_twordlen).to_integer_32 + 1).to_natural_8
						l_tword[l_tmp___39.to_integer_32] := l_c.to_natural_8
						l_sp.item.ts_arridx := l_idxs[l_arridx]
						if l_newscore = 93 then
							l_sp.item.ts_isdiff := (1).to_natural_8
						end
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 124 -- skip if block
						end
				when 109 then -- if:
						if (l_sp.item.ts_tcharlen).to_integer_32 = 0 then
							l_sp.item.ts_tcharidx := (0).to_natural_8
							l_sp.item.ts_tcharlen := (globals_inst.mb_bytelen_tab[l_c]).to_natural_8
							l_sp.item.ts_fcharstart := ((l_sp.item.ts_fidx).to_integer_32 - 1).to_natural_8
							if l_newscore /= 0 then
								l_sp.item.ts_isdiff := (1).to_natural_8
							else
								l_sp.item.ts_isdiff := (0).to_natural_8
							end
						elseif (l_sp.item.ts_isdiff).to_integer_32 = 2 then
							l_sp.item.ts_fidx := ((l_sp.item.ts_fidx).to_integer_32 - 1).to_natural_8
						end
						l_sp.item.ts_tcharidx := ((l_sp.item.ts_tcharidx).to_integer_32 + 1).to_natural_8
						if l_sp.item.ts_tcharidx /= (l_sp.item.ts_tcharlen).to_integer_32 then
							l_pos := -1 + 123 -- skip if block
						end
				when 110 then -- if:
						if (l_sp.item.ts_isdiff).to_integer_32 /= 1 then
							l_pos := -1 + 116 -- skip if block
						end
				when 111 then -- if:
						l_sp.item.ts_fidx := ((l_sp.item.ts_fcharstart).to_integer_32 + (globals_inst.mb_bytelen_tab[(a_fword[(l_sp.item.ts_fcharstart).to_integer_32]).to_integer_32]).to_integer_32).to_natural_8
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						if (mbyte_inst.utf_iscomposing ((globals_inst.mb_ptr2char.integer_32_item ([(l_tword + (l_sp.item.ts_twordlen).to_integer_32) - (l_sp.item.ts_tcharlen).to_integer_32])))).to_boolean then
							if (mbyte_inst.utf_iscomposing ((globals_inst.mb_ptr2char.integer_32_item ([a_fword + (l_sp.item.ts_fcharstart).to_integer_32])))).to_boolean then
								l_sp.item.ts_score := l_sp.item.ts_score - (60)
							else
								l_pos := -1 + 114 -- goto _L___12
							end
						else
							l_pos := -1 + 114 -- goto _L___12
						end
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 115
				when 114 then -- else: | _L___12:
						if not a_soundfold.to_boolean then
							if (l_slang.item.sl_has_map).to_boolean then
								l_tmp___40 := globals_inst.mb_ptr2char.integer_32_item ([a_fword + (l_sp.item.ts_fcharstart).to_integer_32])
								if (similar_chars (l_slang, (globals_inst.mb_ptr2char.integer_32_item ([(l_tword + (l_sp.item.ts_twordlen).to_integer_32) - (l_sp.item.ts_tcharlen).to_integer_32])), l_tmp___40)).to_boolean then
									l_sp.item.ts_score := l_sp.item.ts_score - (60)
								end
							end
						end
				when 115 then -- if done | if block done, skip else block:
						l_pos := -1 + 122
				when 116 then -- else:
						if (l_sp.item.ts_isdiff).to_integer_32 /= 2 then
							l_pos := -1 + 122 -- skip if block
						end
				when 117 then -- if:
						if not ((l_sp.item.ts_twordlen).to_integer_32 > (l_sp.item.ts_tcharlen).to_integer_32) then
							l_pos := -1 + 122 -- skip if block
						end
				when 118 then -- if:
						l_p___0 := (l_tword + (l_sp.item.ts_twordlen).to_integer_32) - (l_sp.item.ts_tcharlen).to_integer_32
						l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 121 -- skip if block
						end
				when 119 then -- if:
						if (mbyte_inst.utf_iscomposing (l_c)).to_boolean then
							l_sp.item.ts_score := l_sp.item.ts_score - (66)
						else
							l_pos := -1 + 121 -- goto _L___13
						end
				when 120 then -- if block done, skip else block:
						l_pos := -1 + 122
				when 121 then -- else: | _L___13:
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___48 := (globals_inst.mb_head_off.integer_32_item ([l_tword, l_p___0 - 1])) + 1
						else
							l_tmp___48 := 1
						end
						l_p___0 := l_p___0 - l_tmp___48
						if l_c = (globals_inst.mb_ptr2char.integer_32_item ([l_p___0])) then
							l_sp.item.ts_score := l_sp.item.ts_score - (29)
						end
				when 122 then -- if done | if done | if done
						l_sp.item.ts_tcharlen := (0).to_natural_8
				when 123 then -- if done | if block done, skip else block:
						l_pos := -1 + 125
				when 124 then -- else:
						if l_newscore /= 0 then
							if not a_soundfold.to_boolean then
								if (l_slang.item.sl_has_map).to_boolean then
									if (similar_chars (l_slang, l_c, (a_fword[((l_sp.item.ts_fidx).to_integer_32 - 1)]).to_integer_32)).to_boolean then
										l_sp.item.ts_score := l_sp.item.ts_score - (60)
									end
								end
							end
						end
				when 125 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 162 -- switch 1; break
				when 126 then -- switch 1, case 5
						if globals_inst.has_mbyte.to_boolean then
							if (l_sp.item.ts_tcharlen).to_integer_32 > 0 then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 127 then
						l_sp.item.ts_state := {PC_STATE_T}.STATE_INS_PREP
						l_sp.item.ts_curi := (1).to_integer_16
						if a_soundfold.to_boolean then
							if (l_sp.item.ts_fidx).to_integer_32 = 0 then
								if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 42 then
									l_newscore := 62
								else
									l_newscore := 94
								end
							else
								l_newscore := 94
							end
						else
							l_newscore := 94
						end
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 0 then
							l_pos := -1 + 137 -- skip if block
						end
				when 128 then -- if:
						if not (l_stack[l_depth___1].ts_score + l_newscore < a_su.item.su_maxscore) then
							l_pos := -1 + 137 -- skip if block
						end
				when 129 then -- if:
						go_deeper (l_stack, l_depth___1, l_newscore)
						l_depth___1 := l_depth___1 + 1
						l_stack[l_depth___1].ts_flags := (((l_stack[l_depth___1].ts_flags).to_integer_32).bit_or (4)).to_natural_8
						l_stack[l_depth___1].ts_delidx := l_sp.item.ts_fidx
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 135 -- skip if block
						end
				when 130 then -- if:
						l_c := globals_inst.mb_ptr2char.integer_32_item ([a_fword + (l_sp.item.ts_fidx).to_integer_32])
						l_stack[l_depth___1].ts_fidx := ((l_stack[l_depth___1].ts_fidx).to_integer_32 + (globals_inst.mb_bytelen_tab[(a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32]).to_integer_32).to_natural_8
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 133 -- skip if block
						end
				when 131 then -- if:
						if (mbyte_inst.utf_iscomposing (l_c)).to_boolean then
							l_stack[l_depth___1].ts_score := l_stack[l_depth___1].ts_score - (66)
						else
							l_pos := -1 + 133 -- goto _L___16
						end
				when 132 then -- if block done, skip else block:
						l_pos := -1 + 134
				when 133 then -- else: | _L___16:
						if l_c = (globals_inst.mb_ptr2char.integer_32_item ([a_fword + (l_stack[l_depth___1].ts_fidx).to_integer_32])) then
							l_stack[l_depth___1].ts_score := l_stack[l_depth___1].ts_score - (28)
						end
				when 134 then -- if done | if block done, skip else block:
						l_pos := -1 + 136
				when 135 then -- else:
						l_stack[l_depth___1].ts_fidx := ((l_stack[l_depth___1].ts_fidx).to_integer_32 + 1).to_natural_8
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = (a_fword[((l_sp.item.ts_fidx).to_integer_32 + 1)]).to_integer_32 then
							l_stack[l_depth___1].ts_score := l_stack[l_depth___1].ts_score - (28)
						end
				when 136 then
						l_pos := -1 + 162 -- switch 1; break
				when 137 then -- if done | switch 1, case 6
						if (((l_sp.item.ts_flags).to_integer_32).bit_and (4)).to_boolean then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_SWAP
							l_pos := -1 + 162 -- switch 1; break
						end
				when 138 then
						l_n := l_sp.item.ts_arridx
						from
						until
							js.loop_done
						loop
							if (l_sp.item.ts_curi).to_integer_32 > (l_byts[l_n]).to_integer_32 then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_SWAP
								js.break
							end
							if not js.loop_jumped and then ((l_byts[(l_n + (l_sp.item.ts_curi).to_integer_32)]).to_integer_32 /= 0) then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_INS
								js.break
							end
							if not js.loop_jumped then
								l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
							end
						end
						l_pos := -1 + 162 -- switch 1; break
				when 139 then -- switch 1, case 7
						l_n := l_sp.item.ts_arridx
						if (l_sp.item.ts_curi).to_integer_32 > (l_byts[l_n]).to_integer_32 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_SWAP
							l_pos := -1 + 162 -- switch 1; break
						end
				when 140 then
						l_tmp___54 := l_sp.item.ts_curi
						l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
						l_n := l_n + l_tmp___54
						l_c := (l_byts[l_n]).to_integer_32
						if a_soundfold.to_boolean then
							if (l_sp.item.ts_twordlen).to_integer_32 = 0 then
								if l_c = 42 then
									l_newscore := 64
								else
									l_newscore := 96
								end
							else
								l_newscore := 96
							end
						else
							l_newscore := 96
						end
						if l_c /= (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 then
							if l_stack[l_depth___1].ts_score + l_newscore < a_su.item.su_maxscore then
								go_deeper (l_stack, l_depth___1, l_newscore)
								l_depth___1 := l_depth___1 + 1
								l_sp := l_stack + l_depth___1
								l_tmp___55 := l_sp.item.ts_twordlen
								l_sp.item.ts_twordlen := ((l_sp.item.ts_twordlen).to_integer_32 + 1).to_natural_8
								l_tword[l_tmp___55.to_integer_32] := l_c.to_natural_8
								l_sp.item.ts_arridx := l_idxs[l_n]
								if globals_inst.has_mbyte.to_boolean then
									l_fl := (globals_inst.mb_bytelen_tab[l_c]).to_integer_32
									if l_fl > 1 then
										l_sp.item.ts_tcharlen := l_fl.to_natural_8
										l_sp.item.ts_tcharidx := (1).to_natural_8
										l_sp.item.ts_isdiff := (2).to_natural_8
									end
								else
									l_fl := 1
								end
								if l_fl = 1 then
									if (l_sp.item.ts_twordlen).to_integer_32 >= 2 then
										if (l_tword[(l_sp.item.ts_twordlen).to_integer_32 - 2]).to_integer_32 = l_c then
											l_sp.item.ts_score := l_sp.item.ts_score - (29)
										end
									end
								end
							end
						end
						l_pos := -1 + 162 -- switch 1; break
				when 141 then -- switch 1, case 8
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						l_c := (l_p___0.item).to_integer_32
						if l_c = 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						end
				when 142 then
						if not a_soundfold.to_boolean then
							if not (spell_iswordp (l_p___0, globals_inst.curwin)).to_boolean then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 143 then
						if globals_inst.has_mbyte.to_boolean then
							if globals_inst.enc_utf8.to_boolean then
								l_n := (mbyte_inst.utf_ptr2len (l_p___0))
							else
								l_n := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
							end
							l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
							if (l_p___0[l_n]).to_integer_32 = 0 then
								l_c2 := ('%/0/').code
							elseif not a_soundfold.to_boolean then
								if (spell_iswordp (l_p___0 + l_n, globals_inst.curwin)).to_boolean then
									l_c2 := globals_inst.mb_ptr2char.integer_32_item ([l_p___0 + l_n])
								else
									l_c2 := l_c
								end
							else
								l_c2 := globals_inst.mb_ptr2char.integer_32_item ([l_p___0 + l_n])
							end
						elseif (l_p___0[1]).to_integer_32 = 0 then
							l_c2 := ('%/0/').code
						elseif not a_soundfold.to_boolean then
							if (spell_iswordp (l_p___0 + 1, globals_inst.curwin)).to_boolean then
								l_c2 := (l_p___0[1]).to_integer_32
							else
								l_c2 := l_c
							end
						else
							l_c2 := (l_p___0[1]).to_integer_32
						end
						if l_c2 = 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
							l_pos := -1 + 162 -- switch 1; break
						end
				when 144 then
						if l_c = l_c2 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_SWAP3
							l_pos := -1 + 162 -- switch 1; break
						end
				when 145 then
						if l_c2 /= 0 then
							if l_stack[l_depth___1].ts_score + 75 < a_su.item.su_maxscore then
								go_deeper (l_stack, l_depth___1, 75)
								l_sp.item.ts_state := {PC_STATE_T}.STATE_UNSWAP
								l_depth___1 := l_depth___1 + 1
								if globals_inst.has_mbyte.to_boolean then
									l_fl := globals_inst.mb_char2len.integer_32_item ([l_c2])
									memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_n)), l_fl.to_natural_32).do_nothing
									globals_inst.mb_char2bytes.call ([l_c, l_p___0 + l_fl])
									l_stack[l_depth___1].ts_fidxtry := (((l_sp.item.ts_fidx).to_integer_32 + l_n) + l_fl).to_natural_8
								else
									l_p___0[0] := l_c2.to_natural_8
									l_p___0[1] := l_c.to_natural_8
									l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + 2).to_natural_8
								end
							else
								l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
							end
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
						end
						l_pos := -1 + 162 -- switch 1; break
				when 146 then -- switch 1, case 9
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if globals_inst.has_mbyte.to_boolean then
							l_n := (globals_inst.mb_bytelen_tab[(l_p___0.item).to_integer_32]).to_integer_32
							l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0 + l_n])
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + (globals_inst.mb_bytelen_tab[(l_p___0[l_n]).to_integer_32]).to_integer_32)), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_n.to_natural_32).do_nothing
							globals_inst.mb_char2bytes.call ([l_c, l_p___0])
						else
							l_c := (l_p___0.item).to_integer_32
							l_p___0.item := l_p___0[1]
							l_p___0[1] := l_c.to_natural_8
						end
				when 147 then -- switch 1, case 10
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if globals_inst.has_mbyte.to_boolean then
							if globals_inst.enc_utf8.to_boolean then
								l_n := (mbyte_inst.utf_ptr2len (l_p___0))
							else
								l_n := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
							end
							l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
							if globals_inst.enc_utf8.to_boolean then
								l_fl := (mbyte_inst.utf_ptr2len (l_p___0 + l_n))
							else
								l_fl := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0 + l_n]))
							end
							l_c2 := globals_inst.mb_ptr2char.integer_32_item ([l_p___0 + l_n])
							if not a_soundfold.to_boolean then
								if (spell_iswordp ((l_p___0 + l_n) + l_fl, globals_inst.curwin)).to_boolean then
									l_c3 := globals_inst.mb_ptr2char.integer_32_item ([(l_p___0 + l_n) + l_fl])
								else
									l_c3 := l_c
								end
							else
								l_c3 := globals_inst.mb_ptr2char.integer_32_item ([(l_p___0 + l_n) + l_fl])
							end
						else
							l_c := (l_p___0.item).to_integer_32
							l_c2 := (l_p___0[1]).to_integer_32
							if not a_soundfold.to_boolean then
								if (spell_iswordp (l_p___0 + 2, globals_inst.curwin)).to_boolean then
									l_c3 := (l_p___0[2]).to_integer_32
								else
									l_c3 := l_c
								end
							else
								l_c3 := (l_p___0[2]).to_integer_32
							end
						end
						if l_c = l_c3 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
							l_pos := -1 + 162 -- switch 1; break
						elseif l_c3 = 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
							l_pos := -1 + 162 -- switch 1; break
						end
				when 148 then
						if l_stack[l_depth___1].ts_score + 110 < a_su.item.su_maxscore then
							go_deeper (l_stack, l_depth___1, 110)
							l_sp.item.ts_state := {PC_STATE_T}.STATE_UNSWAP3
							l_depth___1 := l_depth___1 + 1
							if globals_inst.has_mbyte.to_boolean then
								l_tl := globals_inst.mb_char2len.integer_32_item ([l_c3])
								memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (((l_p___0 + l_n) + l_fl)), l_tl.to_natural_32).do_nothing
								globals_inst.mb_char2bytes.call ([l_c2, l_p___0 + l_tl])
								globals_inst.mb_char2bytes.call ([l_c, (l_p___0 + l_fl) + l_tl])
								l_stack[l_depth___1].ts_fidxtry := ((((l_sp.item.ts_fidx).to_integer_32 + l_n) + l_fl) + l_tl).to_natural_8
							else
								l_p___0[0] := l_p___0[2]
								l_p___0[2] := l_c.to_natural_8
								l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + 3).to_natural_8
							end
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
						end
						l_pos := -1 + 162 -- switch 1; break
				when 149 then -- switch 1, case 11
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if globals_inst.has_mbyte.to_boolean then
							l_n := (globals_inst.mb_bytelen_tab[(l_p___0.item).to_integer_32]).to_integer_32
							l_c2 := globals_inst.mb_ptr2char.integer_32_item ([l_p___0 + l_n])
							l_fl := (globals_inst.mb_bytelen_tab[(l_p___0[l_n]).to_integer_32]).to_integer_32
							l_c := globals_inst.mb_ptr2char.integer_32_item ([(l_p___0 + l_n) + l_fl])
							l_tl := (globals_inst.mb_bytelen_tab[(l_p___0[(l_n + l_fl)]).to_integer_32]).to_integer_32
							memmove (create {CE_POINTER [ANY]}.make_cast (((l_p___0 + l_fl) + l_tl)), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_n.to_natural_32).do_nothing
							globals_inst.mb_char2bytes.call ([l_c, l_p___0])
							globals_inst.mb_char2bytes.call ([l_c2, l_p___0 + l_tl])
							l_p___0 := l_p___0 + l_tl
						else
							l_c := (l_p___0.item).to_integer_32
							l_p___0.item := l_p___0[2]
							l_p___0[2] := l_c.to_natural_8
							l_p___0 := l_p___0 + 1
						end
						if not a_soundfold.to_boolean then
							if not (spell_iswordp (l_p___0, globals_inst.curwin)).to_boolean then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 150 then
						if l_stack[l_depth___1].ts_score + 110 < a_su.item.su_maxscore then
							go_deeper (l_stack, l_depth___1, 110)
							l_sp.item.ts_state := {PC_STATE_T}.STATE_UNROT3L
							l_depth___1 := l_depth___1 + 1
							l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
							if globals_inst.has_mbyte.to_boolean then
								if globals_inst.enc_utf8.to_boolean then
									l_n := (mbyte_inst.utf_ptr2len (l_p___0))
								else
									l_n := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
								end
								l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
								if globals_inst.enc_utf8.to_boolean then
									l_fl := (mbyte_inst.utf_ptr2len (l_p___0 + l_n))
								else
									l_fl := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0 + l_n]))
								end
								if globals_inst.enc_utf8.to_boolean then
									l_tmp___74 := (mbyte_inst.utf_ptr2len ((l_p___0 + l_n) + l_fl))
								else
									l_tmp___74 := (globals_inst.mb_ptr2len.integer_32_item ([(l_p___0 + l_n) + l_fl]))
								end
								l_fl := l_fl + l_tmp___74
								memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_n)), l_fl.to_natural_32).do_nothing
								globals_inst.mb_char2bytes.call ([l_c, l_p___0 + l_fl])
								l_stack[l_depth___1].ts_fidxtry := (((l_sp.item.ts_fidx).to_integer_32 + l_n) + l_fl).to_natural_8
							else
								l_c := (l_p___0.item).to_integer_32
								l_p___0.item := l_p___0[1]
								l_p___0[1] := l_p___0[2]
								l_p___0[2] := l_c.to_natural_8
								l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + 3).to_natural_8
							end
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
						end
						l_pos := -1 + 162 -- switch 1; break
				when 151 then -- switch 1, case 12
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if globals_inst.has_mbyte.to_boolean then
							l_n := (globals_inst.mb_bytelen_tab[(l_p___0.item).to_integer_32]).to_integer_32
							l_n := l_n + (globals_inst.mb_bytelen_tab[(l_p___0[l_n]).to_integer_32]).to_integer_32
							l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0 + l_n])
							l_tl := (globals_inst.mb_bytelen_tab[(l_p___0[l_n]).to_integer_32]).to_integer_32
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_tl)), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_n.to_natural_32).do_nothing
							globals_inst.mb_char2bytes.call ([l_c, l_p___0])
						else
							l_c := (l_p___0[2]).to_integer_32
							l_p___0[2] := l_p___0[1]
							l_p___0[1] := l_p___0.item
							l_p___0.item := l_c.to_natural_8
						end
						if l_stack[l_depth___1].ts_score + 110 < a_su.item.su_maxscore then
							go_deeper (l_stack, l_depth___1, 110)
							l_sp.item.ts_state := {PC_STATE_T}.STATE_UNROT3R
							l_depth___1 := l_depth___1 + 1
							l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
							if globals_inst.has_mbyte.to_boolean then
								if globals_inst.enc_utf8.to_boolean then
									l_n := (mbyte_inst.utf_ptr2len (l_p___0))
								else
									l_n := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
								end
								if globals_inst.enc_utf8.to_boolean then
									l_tmp___79 := (mbyte_inst.utf_ptr2len (l_p___0 + l_n))
								else
									l_tmp___79 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0 + l_n]))
								end
								l_n := l_n + l_tmp___79
								l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0 + l_n])
								if globals_inst.enc_utf8.to_boolean then
									l_tl := (mbyte_inst.utf_ptr2len (l_p___0 + l_n))
								else
									l_tl := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0 + l_n]))
								end
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_tl)), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_n.to_natural_32).do_nothing
								globals_inst.mb_char2bytes.call ([l_c, l_p___0])
								l_stack[l_depth___1].ts_fidxtry := (((l_sp.item.ts_fidx).to_integer_32 + l_n) + l_tl).to_natural_8
							else
								l_c := (l_p___0[2]).to_integer_32
								l_p___0[2] := l_p___0[1]
								l_p___0[1] := l_p___0.item
								l_p___0.item := l_c.to_natural_8
								l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + 3).to_natural_8
							end
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
						end
						l_pos := -1 + 162 -- switch 1; break
				when 152 then -- switch 1, case 13
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if globals_inst.has_mbyte.to_boolean then
							l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
							l_tl := (globals_inst.mb_bytelen_tab[(l_p___0.item).to_integer_32]).to_integer_32
							l_n := (globals_inst.mb_bytelen_tab[(l_p___0[l_tl]).to_integer_32]).to_integer_32
							l_n := l_n + (globals_inst.mb_bytelen_tab[(l_p___0[(l_tl + l_n)]).to_integer_32]).to_integer_32
							memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_tl)), l_n.to_natural_32).do_nothing
							globals_inst.mb_char2bytes.call ([l_c, l_p___0 + l_n])
						else
							l_c := (l_p___0.item).to_integer_32
							l_p___0.item := l_p___0[1]
							l_p___0[1] := l_p___0[2]
							l_p___0[2] := l_c.to_natural_8
						end
				when 153 then -- switch 1, case 14
						if not ((a_lp.item.lp_replang).is_void) then
							l_pos := -1 + 156 -- skip if block
						end
				when 154 then -- if:
						if not a_soundfold.to_boolean then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						else
							l_pos := -1 + 156 -- goto _L___17
						end
				when 155 then -- if block done, skip else block:
						l_pos := -1 + 157
				when 156 then -- else: | _L___17:
						if l_sp.item.ts_score + 65 >= a_su.item.su_maxscore then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						elseif (l_sp.item.ts_fidx).to_integer_32 < (l_sp.item.ts_fidxtry).to_integer_32 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						end
				when 157 then
						if a_soundfold.to_boolean then
							l_sp.item.ts_curi := l_slang.item.sl_repsal_first[(a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32]
						else
							l_sp.item.ts_curi := (a_lp.item.lp_replang).item.sl_rep_first[(a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32]
						end
						if (l_sp.item.ts_curi).to_integer_32 < 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						end
				when 158 then
						l_sp.item.ts_state := {PC_STATE_T}.STATE_REP
				when 159 then -- switch 1, case 15
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if a_soundfold.to_boolean then
							l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal"))
						else
							l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared ((a_lp.item.lp_replang).c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep"))
						end
						from
						until
							not (not js.loop_done and then ((l_sp.item.ts_curi).to_integer_32 < l_gap.item.ga_len))
						loop
							l_tmp___82 := l_sp.item.ts_curi
							l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
							l_ftp := create {CE_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + l_tmp___82.to_integer_32
							if ((l_ftp.item.ft_from).item).to_integer_32 /= (l_p___0.item).to_integer_32 then
								l_sp.item.ts_curi := (l_gap.item.ga_len).to_integer_16
								js.break
							end
							if not js.loop_jumped then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ftp.item.ft_from), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ftp.item.ft_from))))) = 0 then
									if l_stack[l_depth___1].ts_score + 65 < a_su.item.su_maxscore then
										go_deeper (l_stack, l_depth___1, 65)
										l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_UNDO
										l_depth___1 := l_depth___1 + 1
										l_fl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ftp.item.ft_from))).to_integer_32
										l_tl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ftp.item.ft_to))).to_integer_32
										if l_fl /= l_tl then
											memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_tl)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_fl)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_fl)))) + {NATURAL_32} 1).do_nothing
											l_repextra := l_repextra + (l_tl - l_fl)
										end
										memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_ftp.item.ft_to), l_tl.to_natural_32).do_nothing
										l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + l_tl).to_natural_8
										l_stack[l_depth___1].ts_tcharlen := (0).to_natural_8
										js.break
									end
								end
							end
						end
						if (l_sp.item.ts_curi).to_integer_32 >= l_gap.item.ga_len then
							if l_sp.item.ts_state = {NATURAL_32} 15 then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							end
						end
						l_pos := -1 + 162 -- switch 1; break
				when 160 then -- switch 1, case 16
						if a_soundfold.to_boolean then
							l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal"))
						else
							l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared ((a_lp.item.lp_replang).c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep"))
						end
						l_ftp := (create {CE_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + (l_sp.item.ts_curi).to_integer_32) - 1
						l_fl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ftp.item.ft_from))).to_integer_32
						l_tl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ftp.item.ft_to))).to_integer_32
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if l_fl /= l_tl then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_fl)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_tl)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_tl)))) + {NATURAL_32} 1).do_nothing
							l_repextra := l_repextra - (l_tl - l_fl)
						end
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_ftp.item.ft_from), l_fl.to_natural_32).do_nothing
						l_sp.item.ts_state := {PC_STATE_T}.STATE_REP
						l_pos := -1 + 162 -- switch 1; break
				when 161 then -- switch 1, default:
						l_depth___1 := l_depth___1 - 1
						if l_depth___1 >= 0 then
							if (l_stack[l_depth___1].ts_prefixdepth).to_integer_32 = 254 then
								l_byts := l_pbyts
								l_idxs := l_pidxs
							end
						end
						l_breakcheckcount := l_breakcheckcount - 1
						if l_breakcheckcount = 0 then
							ui_inst.ui_breakcheck
							l_breakcheckcount := 1_000
						end
				when 162 then -- switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 163 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	suggest_try_change (a_su: CE_POINTER [PD_SUGINFO_S])
		local
			l_fword: CE_ARRAY [NATURAL_8]
			l_n: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_lpi: INTEGER_32
			l_lp: CE_POINTER [PD_LANGP_S]
			js: JUMP_STATE
		do
			create l_fword.make (<<250>>)
			create l_p___0.make
			create l_lp.make

			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_fword), create {CE_POINTER [INTEGER_8]}.make_cast ((a_su.item.su_fbadword))).do_nothing
			l_n := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fword))).to_integer_32
			l_p___0 := a_su.item.su_badptr + a_su.item.su_badlen
			spell_casefold (l_p___0, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32, l_fword + l_n, 250 - l_n).do_nothing
			l_lpi := 0
			from
			until
				not (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len)
			loop
				l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
				if ((l_lp.item.lp_slang).item.sl_fbyts).is_void then
					js.continue
				end
				if not js.loop_jumped then
					suggest_trie_walk (a_su, l_lp, l_fword, 0)
				end
				l_lpi := l_lpi + 1
			end
		end

	suggest_try_soundalike (a_su: CE_POINTER [PD_SUGINFO_S])
		local
			l_salword: CE_ARRAY [NATURAL_8]
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
		do
			create l_salword.make (<<250>>)
			create l_lp.make
			create l_slang.make

			l_lpi := 0
			from
			until
				not (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len)
			loop
				l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
				l_slang := l_lp.item.lp_slang
				if l_slang.item.sl_sal.ga_len > 0 then
					if not (l_slang.item.sl_sbyts).is_void then
						spell_soundfold (l_slang, a_su.item.su_fbadword, 1, l_salword)
						suggest_trie_walk (a_su, l_lp, l_salword, 1)
					end
				end
				l_lpi := l_lpi + 1
			end
		end

	suggest_try_soundalike_finish
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_todo: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			js: JUMP_STATE
		do
			create l_lp.make
			create l_slang.make
			create l_hi___1.make

			l_lpi := 0
			from
			until
				not (not js.loop_done and then (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len))
			loop
				l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
				l_slang := l_lp.item.lp_slang
				if l_slang.item.sl_sal.ga_len > 0 then
					if not (l_slang.item.sl_sbyts).is_void then
						l_todo := (l_slang.item.sl_sounddone.ht_used).to_integer_32
						l_hi___1 := l_slang.item.sl_sounddone.ht_array
						from
						until
							not (l_todo > 0)
						loop
							if not ((l_hi___1.item.hi_key).is_void) then
								if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_hi___1.item.hi_key - ((dumsft.item.sft_word).distance ((create {CE_POINTER [NATURAL_8]}.make_cast (dumsft)))))))
									l_todo := l_todo - 1
								end
							end
							l_hi___1 := l_hi___1 + 1
						end
						hashtab_inst.hash_clear (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone")))
						hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone")))
					end
				end
				l_lpi := l_lpi + 1
			end
		end

	suggest_try_soundalike_prep
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
		do
			create l_lp.make
			create l_slang.make

			l_lpi := 0
			from
			until
				not (l_lpi < (globals_inst.curwin.item.w_s).item.b_langp.ga_len)
			loop
				l_lp := create {CE_POINTER [PD_LANGP_S]}.make_cast ((globals_inst.curwin.item.w_s).item.b_langp.ga_data) + l_lpi
				l_slang := l_lp.item.lp_slang
				if l_slang.item.sl_sal.ga_len > 0 then
					if not (l_slang.item.sl_sbyts).is_void then
						hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone")))
					end
				end
				l_lpi := l_lpi + 1
			end
		end

	suggest_try_special (a_su: CE_POINTER [PD_SUGINFO_S])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_c: INTEGER_32
			l_word: CE_ARRAY [NATURAL_8]
		do
			create l_p___0.make
			create l_word.make (<<250>>)

			l_p___0 := charset_inst.skiptowhite (a_su.item.su_fbadword)
			l_len := (l_p___0.distance ((a_su.item.su_fbadword))).to_natural_32
			l_p___0 := charset_inst.skipwhite (l_p___0)
			if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) = l_len then
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((a_su.item.su_fbadword)), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), l_len)) = 0 then
					l_c := (a_su.item.su_fbadword[l_len.to_integer_32]).to_integer_32
					a_su.item.su_fbadword[l_len.to_integer_32] := (('%/0/').code).to_natural_8
					make_case_word (a_su.item.su_fbadword, l_word, a_su.item.su_badflags)
					a_su.item.su_fbadword[l_len.to_integer_32] := l_c.to_natural_8
					add_suggestion (a_su, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_word, a_su.item.su_badlen, 48, 0, 1, a_su.item.su_sallang, 0)
				end
			end
		end

	tree_add_word (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_word: CE_POINTER [NATURAL_8]; a_root: CE_POINTER [PD_WORDNODE_S]; a_flags___0: INTEGER_32; a_region: INTEGER_32; a_affixID: INTEGER_32): INTEGER_32
		local
			l_node: CE_POINTER [PD_WORDNODE_S]
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_copyp: CE_POINTER [PD_WORDNODE_S]
			l_copyprev: CE_POINTER [CE_POINTER [PD_WORDNODE_S]]
			l_prev: CE_POINTER [CE_POINTER [PD_WORDNODE_S]]
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_node.make
			create l_np.make
			create l_copyp.make
			create l_copyprev.make
			create l_prev.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_node := a_root
					l_prev := create {CE_POINTER [CE_POINTER [PD_WORDNODE_S]]}.make_shared (default_pointer)
					l_i___0 := 0
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 22 -- skip loop
					end
				when 2 then -- loop body:
						if not l_node.is_void then
							if l_node.item.wn_refs > 1 then
								l_node.item.wn_refs := (l_node.item.wn_refs) - 1
								l_copyprev := l_prev
								l_copyp := l_node
								from
								until
									not (not js.loop_done and then (not l_copyp.is_void))
								loop
									l_np := get_wordnode (a_spin)
									if l_np.is_void then
										Result := 0
										js.return
									end
									if not js.return_called then
										l_np.item.wn_child := l_copyp.item.wn_child
										if not (l_np.item.wn_child).is_void then
											(l_np.item.wn_child).item.wn_refs := ((l_np.item.wn_child).item.wn_refs) + 1
										end
										l_np.item.wn_byte := l_copyp.item.wn_byte
										if (l_np.item.wn_byte).to_integer_32 = 0 then
											l_np.item.wn_flags := l_copyp.item.wn_flags
											l_np.item.wn_region := l_copyp.item.wn_region
											l_np.item.wn_affixID := l_copyp.item.wn_affixID
										end
										l_np.item.wn_refs := 1
										if not l_copyprev.is_void then
											l_copyprev.item := l_np
										end
										l_copyprev := create {CE_POINTER [CE_POINTER [PD_WORDNODE_S]]}.make_shared (l_np.c_pointer + (create {PD_WORDNODE_S}.make).offset_of ("wn_sibling"))
										if l_copyp.is_equal (l_node) then
											l_node := l_np
										end
										l_copyp := l_copyp.item.wn_sibling
									end
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 21 -- skip if block
						end
				when 3 then -- if:
						from
						until
							js.loop_done
						loop
							if not l_node.is_void then
								if not ((l_node.item.wn_byte).to_integer_32 < (a_word[l_i___0]).to_integer_32) then
									if (l_node.item.wn_byte).to_integer_32 = 0 then
										if a_flags___0 < 0 then
											l_tmp___1 := ((l_node.item.wn_affixID).to_natural_32 < a_affixID.to_natural_32).to_integer
										else
											if (l_node.item.wn_flags).to_natural_32 < ((a_flags___0).bit_and (65_535)).to_natural_32 then
												l_tmp___0 := 1
											elseif (l_node.item.wn_flags).to_integer_32 = ((a_flags___0).bit_and (65_535)) then
												if (a_spin.item.si_sugtree).to_boolean then
													l_tmp := ((((l_node.item.wn_region).to_integer_32).bit_and (65_535)) < a_region).to_integer
												else
													l_tmp := ((l_node.item.wn_affixID).to_natural_32 < a_affixID.to_natural_32).to_integer
												end
												if l_tmp.to_boolean then
													l_tmp___0 := 1
												else
													l_tmp___0 := 0
												end
											else
												l_tmp___0 := 0
											end
											l_tmp___1 := l_tmp___0
										end
										if not l_tmp___1.to_boolean then
											js.break
										end
									else
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_prev := create {CE_POINTER [CE_POINTER [PD_WORDNODE_S]]}.make_shared (l_node.c_pointer + (create {PD_WORDNODE_S}.make).offset_of ("wn_sibling"))
								l_node := l_prev.item
							end
						end
						if not (l_node.is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 6 then -- else:
						if (l_node.item.wn_byte).to_integer_32 = (a_word[l_i___0]).to_integer_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 9 then -- else:
						if (a_word[l_i___0]).to_integer_32 /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if not (a_flags___0 < 0) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 13 then -- else:
						if not ((a_spin.item.si_sugtree).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 16 then -- else:
						if (l_node.item.wn_flags).to_integer_32 = ((a_flags___0).bit_and (65_535)) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if (l_node.item.wn_affixID).to_integer_32 = a_affixID then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L___0:
						l_np := get_wordnode (a_spin)
						if l_np.is_void then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_np.item.wn_byte := a_word[l_i___0]
							if l_node.is_void then
								l_np.item.wn_refs := 1
							else
								l_np.item.wn_refs := l_node.item.wn_refs
								l_node.item.wn_refs := 1
							end
							if not l_prev.is_void then
								l_prev.item := l_np
							end
							l_np.item.wn_sibling := l_node
							l_node := l_np
						end
				when 21 then -- if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							if (a_word[l_i___0]).to_integer_32 = 0 then
								l_node.item.wn_flags := a_flags___0.to_natural_16
								l_node.item.wn_region := (((l_node.item.wn_region).to_integer_32).bit_or (a_region)).to_integer_16
								l_node.item.wn_affixID := a_affixID.to_natural_8
								js.break
							end
							if not js.loop_jumped then
								l_prev := create {CE_POINTER [CE_POINTER [PD_WORDNODE_S]]}.make_shared (l_node.c_pointer + (create {PD_WORDNODE_S}.make).offset_of ("wn_child"))
								l_node := l_prev.item
								l_i___0 := l_i___0 + 1
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 22 then -- loop done
					if not js.return_called then
						a_spin.item.si_msg_count := (a_spin.item.si_msg_count) + 1
						if a_spin.item.si_compress_cnt > 1 then
							a_spin.item.si_compress_cnt := (a_spin.item.si_compress_cnt) - 1
							if a_spin.item.si_compress_cnt = 1 then
								a_spin.item.si_blocks_cnt := a_spin.item.si_blocks_cnt + compress_inc
							end
						end
						if a_spin.item.si_compress_cnt = 1 then
							l_tmp___3 := (a_spin.item.si_free_count < 250).to_integer
						else
							l_tmp___3 := (a_spin.item.si_blocks_cnt >= compress_start).to_integer
						end
						if l_tmp___3.to_boolean then
							a_spin.item.si_blocks_cnt := a_spin.item.si_blocks_cnt - compress_inc
							a_spin.item.si_compress_cnt := compress_added
							if (a_spin.item.si_verbose).to_boolean then
								message_inst.msg_start
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (msg_compressing))))
								message_inst.msg_clr_eos
								globals_inst.msg_didout := 0
								globals_inst.msg_col := 0
								term_inst.out_flush
							end
							wordtree_compress (a_spin, a_spin.item.si_foldroot)
							if a_affixID >= 0 then
								wordtree_compress (a_spin, a_spin.item.si_keeproot)
							end
						end
						Result := 1
					end
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tree_count_words (a_byts: CE_POINTER [NATURAL_8]; a_idxs: CE_POINTER [INTEGER_32])
		local
			l_depth___1: INTEGER_32
			l_arridx: CE_ARRAY [INTEGER_32]
			l_curi: CE_ARRAY [INTEGER_32]
			l_c: INTEGER_32
			l_n: INTEGER_32
			l_wordcount: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_arridx.make (<<250>>)
			create l_curi.make (<<250>>)
			create l_wordcount.make (<<250>>)

			l_arridx[0] := 0
			l_curi[0] := 1
			l_wordcount[0] := 0
			l_depth___1 := 0
			from
			until
				js.loop_done
			loop
				if l_depth___1 >= 0 then
					if globals_inst.got_int.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if l_curi[l_depth___1] > (a_byts[(l_arridx[l_depth___1])]).to_integer_32 then
						a_idxs[(l_arridx[l_depth___1])] := l_wordcount[l_depth___1]
						if l_depth___1 > 0 then
							l_wordcount[l_depth___1 - 1] := l_wordcount[l_depth___1 - 1] + (l_wordcount[l_depth___1])
						end
						l_depth___1 := l_depth___1 - 1
						misc1_inst.fast_breakcheck
					else
						l_n := l_arridx[l_depth___1] + l_curi[l_depth___1]
						l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
						l_c := (a_byts[l_n]).to_integer_32
						if l_c = 0 then
							l_wordcount[l_depth___1] := (l_wordcount[l_depth___1]) + 1
							from
							until
								(a_byts[(l_n + 1)]).to_integer_32 /= 0
							loop
								l_n := l_n + 1
								l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
							end
						else
							l_depth___1 := l_depth___1 + 1
							l_arridx[l_depth___1] := a_idxs[l_n]
							l_curi[l_depth___1] := 1
							l_wordcount[l_depth___1] := 0
						end
					end
				end
			end
		end

	use_midword (a_lp: CE_POINTER [PD_SLANG_S]; a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_l: INTEGER_32
			l_n: INTEGER_32
			l_bp___0: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_bp___0.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_lp.item.sl_midword).is_void then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_p___0 := a_lp.item.sl_midword
				when 2 then -- loop condition:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
						l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
						if not (l_c < 256) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_l <= 2 then
							(a_wp___0.item.w_s).item.b_spell_ismw[l_c] := (1).to_natural_8
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if ((a_wp___0.item.w_s).item.b_spell_ismw_mb).is_void then
							(a_wp___0.item.w_s).item.b_spell_ismw_mb := misc2_inst.vim_strnsave (l_p___0, l_l)
						else
							l_n := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_wp___0.item.w_s).item.b_spell_ismw_mb))).to_integer_32
							l_bp___0 := misc2_inst.vim_strnsave ((a_wp___0.item.w_s).item.b_spell_ismw_mb, l_n + l_l)
							if not l_bp___0.is_void then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((a_wp___0.item.w_s).item.b_spell_ismw_mb));
								(a_wp___0.item.w_s).item.b_spell_ismw_mb := l_bp___0
								misc2_inst.vim_strncpy (l_bp___0 + l_n, l_p___0, l_l.to_natural_32)
							end
						end
				when 8 then
						l_p___0 := l_p___0 + l_l
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1;
						(a_wp___0.item.w_s).item.b_spell_ismw[(l_tmp___0.item).to_integer_32] := (1).to_natural_8
				when 11 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	valid_word_prefix (a_totprefcnt: INTEGER_32; a_arridx: INTEGER_32; a_flags___0: INTEGER_32; a_word: CE_POINTER [NATURAL_8]; a_slang: CE_POINTER [PD_SLANG_S]; a_cond_req: INTEGER_32): INTEGER_32
		local
			l_prefcnt: INTEGER_32
			l_pidx: INTEGER_32
			l_rp: CE_POINTER [PD_REGPROG_T]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_prefid: INTEGER_32
			js: JUMP_STATE
		do
			create l_rp.make
			create l_regmatch___0.make (<<1>>)

			l_prefid := ((a_flags___0.to_natural_32).bit_shift_right (24)).to_integer_32
			l_prefcnt := a_totprefcnt - 1
			from
			until
				not (not js.loop_done and then (l_prefcnt >= 0))
			loop
				l_pidx := a_slang.item.sl_pidxs[(a_arridx + l_prefcnt)]
				if l_prefid /= ((l_pidx).bit_and (255)) then
					js.continue
				end
				if not js.loop_jumped and then (((a_flags___0).bit_and (256)).to_boolean) then
					if ((l_pidx).bit_and (((2).bit_shift_left (24)))).to_boolean then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_rp := a_slang.item.sl_prefprog[((((l_pidx.to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 65_535)).to_integer_32]
					if not l_rp.is_void then
						l_regmatch___0.item.regprog := l_rp
						l_regmatch___0.item.rm_ic := 0
						if not (regexp_inst.vim_regexec (l_regmatch___0, a_word, 0)).to_boolean then
							js.continue
						end
					elseif a_cond_req.to_boolean then
						js.continue
					end
				end
				if not js.loop_jumped then
					Result := l_pidx
					js.return
				end
				if js.loop_increment then
					l_prefcnt := l_prefcnt - 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	wordtree_alloc (a_spin: CE_POINTER [PD_SPELLINFO_S]): CE_POINTER [PD_WORDNODE_S]
		do
			Result := (create {CE_POINTER [PD_WORDNODE_S]}.make_cast ((getroom (a_spin, (create {PD_WORDNODE_S}.make).structure_size.to_natural_32, 1))))
		end

	wordtree_compress (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_root: CE_POINTER [PD_WORDNODE_S])
		local
			l_ht: CE_ARRAY [PD_HASHTABLE_S]
			l_n: INTEGER_32
			l_tot: CE_ARRAY [INTEGER_32]
			l_perc: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_ht.make (<<1>>)
			create l_tot.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tot.item := 0
					if (a_root.item.wn_sibling).is_void then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						hashtab_inst.hash_init (l_ht)
						l_n := node_compress (a_spin, a_root.item.wn_sibling, l_ht, l_tot)
						if not ((a_spin.item.si_verbose).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (option_inst.p_verbose.item > 2) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_tot.item > 1_000_000 then
							l_perc := (l_tot.item - l_n) // (l_tot.item // 100)
						elseif l_tot.item = 0 then
							l_perc := 0
						else
							l_perc := ((l_tot.item - l_n) * 100) // l_tot.item
						end
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, (gettext (ce_string ("Compressed %%d of %%d nodes; %%d (%%d%%%%) remaining"))), l_n, l_tot.item, l_tot.item - l_n, l_perc]).do_nothing
						spell_message (a_spin, globals_inst.IObuff)
				when 6 then -- if done
						hashtab_inst.hash_clear (l_ht)
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	write_spell_prefcond (a_fd: CE_POINTER [SD_IO_FILE]; a_gap: CE_POINTER [PD_GROWARRAY]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_totlen: INTEGER_32
			l_x___0: NATURAL_32
		do
			create l_p___0.make

			l_x___0 := (1).to_natural_32
			if not a_fd.is_void then
				misc2_inst.put_bytes (a_fd, (a_gap.item.ga_len).to_natural_32, 2).do_nothing
			end
			l_totlen := 2 + a_gap.item.ga_len
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_gap.item.ga_len)
			loop
				l_p___0 := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[l_i___0]
				if not l_p___0.is_void then
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
					if not a_fd.is_void then
						fputc (l_len, a_fd).do_nothing
						l_x___0 := (l_x___0).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (l_p___0), l_len.to_natural_32, (1).to_natural_32, a_fd)))
					end
					l_totlen := l_totlen + l_len
				elseif not a_fd.is_void then
					fputc (0, a_fd).do_nothing
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_totlen
		end

	write_vim_spell (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_regionmask: INTEGER_32
			l_round: INTEGER_32
			l_tree: CE_POINTER [PD_WORDNODE_S]
			l_nodecount: INTEGER_32
			l_i___0: INTEGER_32
			l_l: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_p___0: CE_POINTER [NATURAL_8]
			l_rr: INTEGER_32
			l_retval: INTEGER_32
			l_fwv: NATURAL_32
			l_folchars: CE_ARRAY [NATURAL_8]
			l_flags___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___9: INTEGER_32
			l_todo: INTEGER_32
			l_len: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fd.make
			create l_tree.make
			create l_gap.make
			create l_ftp.make
			create l_p___0.make
			create l_folchars.make (<<1_024>>)
			create l_hi___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 1
					l_fwv := (1).to_natural_32
					l_fd := fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), ce_string ("w"))
					if l_fd.is_void then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_fname).do_nothing
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (ce_string ("VIMspell")), (8).to_natural_32, (1).to_natural_32, l_fd)))
						if l_fwv /= {NATURAL_32} 1 then
							l_pos := -1 + 3 -- goto theend
						end
				when 2 then
						IO_putc (50, l_fd).do_nothing
						if not (a_spin.item.si_info).is_void then
							IO_putc (15, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_i___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_info))).to_integer_32
							misc2_inst.put_bytes (l_fd, l_i___0.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (a_spin.item.si_info), l_i___0.to_natural_32, (1).to_natural_32, l_fd)))
						end
						if a_spin.item.si_region_count > 1 then
							IO_putc (0, l_fd).do_nothing
							IO_putc (1, l_fd).do_nothing
							l_l := a_spin.item.si_region_count * 2
							misc2_inst.put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast ((a_spin.item.si_region_name)), l_l.to_natural_32, (1).to_natural_32, l_fd)))
							l_regionmask := ((1).bit_shift_left (a_spin.item.si_region_count)) - 1
						else
							l_regionmask := 0
						end
						if not (a_spin.item.si_ascii).to_boolean then
							if not (a_spin.item.si_add).to_boolean then
								IO_putc (1, l_fd).do_nothing
								IO_putc (1, l_fd).do_nothing
								l_l := 0
								l_i___0 := 128
								from
								until
									not (l_i___0 < 256)
								loop
									if globals_inst.has_mbyte.to_boolean then
										l_l := l_l + (globals_inst.mb_char2bytes.integer_32_item ([(spelltab.item.st_fold[l_i___0]).to_integer_32, l_folchars + l_l]))
									else
										l_tmp___5 := l_l
										l_l := l_l + 1
										l_folchars[l_tmp___5] := spelltab.item.st_fold[l_i___0]
									end
									l_i___0 := l_i___0 + 1
								end
								misc2_inst.put_bytes (l_fd, (131 + l_l).to_natural_32, 4).do_nothing
								fputc (128, l_fd).do_nothing
								l_i___0 := 128
								from
								until
									not (l_i___0 < 256)
								loop
									l_flags___0 := 0
									if (spelltab.item.st_isw[l_i___0]).to_boolean then
										l_flags___0 := (l_flags___0).bit_or ((1))
									end
									if (spelltab.item.st_isu[l_i___0]).to_boolean then
										l_flags___0 := (l_flags___0).bit_or ((2))
									end
									fputc (l_flags___0, l_fd).do_nothing
									l_i___0 := l_i___0 + 1
								end
								misc2_inst.put_bytes (l_fd, l_l.to_natural_32, 2).do_nothing
								l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (l_folchars), l_l.to_natural_32, (1).to_natural_32, l_fd)))
							end
						end
						if not (a_spin.item.si_midword).is_void then
							IO_putc (2, l_fd).do_nothing
							IO_putc (1, l_fd).do_nothing
							l_i___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_midword))).to_integer_32
							misc2_inst.put_bytes (l_fd, l_i___0.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (a_spin.item.si_midword), l_i___0.to_natural_32, (1).to_natural_32, l_fd)))
						end
						if a_spin.item.si_prefcond.ga_len > 0 then
							IO_putc (3, l_fd).do_nothing
							IO_putc (1, l_fd).do_nothing
							l_l := write_spell_prefcond (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer), create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond")))
							misc2_inst.put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing
							write_spell_prefcond (l_fd, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond"))).do_nothing
						end
						l_round := 1
						from
						until
							not (not js.loop_done and then (l_round <= 3))
						loop
							if l_round = 1 then
								l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_rep"))
							elseif l_round = 2 then
								if not (a_spin.item.si_sofofr).is_void then
									if not (a_spin.item.si_sofoto).is_void then
										js.continue
									end
								end
								if not js.loop_jumped then
									l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_sal"))
								end
							else
								l_gap := create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_repsal"))
							end
							if not js.loop_jumped and then (l_gap.item.ga_len = 0) then
								js.continue
							end
							if not js.loop_jumped then
								if l_round /= 2 then
									qsort (l_gap.item.ga_data, (l_gap.item.ga_len).to_natural_32, (create {PD_FROMTO_S}.make).structure_size.to_natural_32, rep_compare_address)
								end
								if l_round = 1 then
									l_i___0 := 4
								else
									if l_round = 2 then
										l_tmp___9 := 5
									else
										l_tmp___9 := 12
									end
									l_i___0 := l_tmp___9
								end
								IO_putc (l_i___0, l_fd).do_nothing
								IO_putc (0, l_fd).do_nothing
								l_l := 2
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_gap.item.ga_len)
								loop
									l_ftp := create {CE_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + l_i___0
									l_l := l_l + (1 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ftp.item.ft_from))).to_integer_32)
									l_l := l_l + (1 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ftp.item.ft_to))).to_integer_32)
									l_i___0 := l_i___0 + 1
								end
								if l_round = 2 then
									l_l := l_l + 1
								end
								misc2_inst.put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing
								if l_round = 2 then
									l_i___0 := 0
									if (a_spin.item.si_followup).to_boolean then
										l_i___0 := (l_i___0).bit_or ((1))
									end
									if (a_spin.item.si_collapse).to_boolean then
										l_i___0 := (l_i___0).bit_or ((2))
									end
									if (a_spin.item.si_rem_accents).to_boolean then
										l_i___0 := (l_i___0).bit_or ((4))
									end
									IO_putc (l_i___0, l_fd).do_nothing
								end
								misc2_inst.put_bytes (l_fd, (l_gap.item.ga_len).to_natural_32, 2).do_nothing
								l_i___0 := 0
								from
								until
									not (not js.loop_done and then (l_i___0 < l_gap.item.ga_len))
								loop
									l_ftp := create {CE_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + l_i___0
									l_rr := 1
									from
									until
										not (l_rr <= 2)
									loop
										if l_rr = 1 then
											l_p___0 := l_ftp.item.ft_from
										else
											l_p___0 := l_ftp.item.ft_to
										end
										l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
										IO_putc (l_l, l_fd).do_nothing
										if l_l > 0 then
											l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (l_p___0), l_l.to_natural_32, (1).to_natural_32, l_fd)))
										end
										l_rr := l_rr + 1
									end
									l_i___0 := l_i___0 + 1
								end
							end
							if js.loop_increment then
								l_round := l_round + 1
							end
						end
						if not (a_spin.item.si_sofofr).is_void then
							if not (a_spin.item.si_sofoto).is_void then
								IO_putc (6, l_fd).do_nothing
								IO_putc (0, l_fd).do_nothing
								l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_sofofr))).to_integer_32
								misc2_inst.put_bytes (l_fd, ((l_l.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_sofoto)))) + {NATURAL_32} 4).to_natural_32, 4).do_nothing
								misc2_inst.put_bytes (l_fd, l_l.to_natural_32, 2).do_nothing
								l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (a_spin.item.si_sofofr), l_l.to_natural_32, (1).to_natural_32, l_fd)))
								l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_sofoto))).to_integer_32
								misc2_inst.put_bytes (l_fd, l_l.to_natural_32, 2).do_nothing
								l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (a_spin.item.si_sofoto), l_l.to_natural_32, (1).to_natural_32, l_fd)))
							end
						end
						if a_spin.item.si_commonwords.ht_used > {NATURAL_32} 0 then
							IO_putc (13, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_round := 1
							from
							until
								not (not js.loop_done and then (l_round <= 2))
							loop
								l_len := 0
								l_todo := (a_spin.item.si_commonwords.ht_used).to_integer_32
								l_hi___1 := a_spin.item.si_commonwords.ht_array
								from
								until
									not (l_todo > 0)
								loop
									if not ((l_hi___1.item.hi_key).is_void) then
										if not ((l_hi___1.item.hi_key).is_equal (globals_inst.hash_removed)) then
											l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_hi___1.item.hi_key))).to_integer_32 + 1
											l_len := l_len + l_l
											if l_round = 2 then
												l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (l_hi___1.item.hi_key), l_l.to_natural_32, (1).to_natural_32, l_fd)))
											end
											l_todo := l_todo - 1
										end
									end
									l_hi___1 := l_hi___1 + 1
								end
								if l_round = 1 then
									misc2_inst.put_bytes (l_fd, l_len.to_natural_32, 4).do_nothing
								end
								l_round := l_round + 1
							end
						end
						if a_spin.item.si_map.ga_len > 0 then
							IO_putc (7, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_l := a_spin.item.si_map.ga_len
							misc2_inst.put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (a_spin.item.si_map.ga_data, l_l.to_natural_32, (1).to_natural_32, l_fd)))
						end
						if not (a_spin.item.si_nosugfile).to_boolean then
							if a_spin.item.si_sal.ga_len > 0 then
								IO_putc (11, l_fd).do_nothing
								IO_putc (0, l_fd).do_nothing
								misc2_inst.put_bytes (l_fd, (8).to_natural_32, 4).do_nothing
								a_spin.item.si_sugtime := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								misc2_inst.put_time (l_fd, a_spin.item.si_sugtime)
							elseif not (a_spin.item.si_sofofr).is_void then
								if not (a_spin.item.si_sofoto).is_void then
									IO_putc (11, l_fd).do_nothing
									IO_putc (0, l_fd).do_nothing
									misc2_inst.put_bytes (l_fd, (8).to_natural_32, 4).do_nothing
									a_spin.item.si_sugtime := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
									misc2_inst.put_time (l_fd, a_spin.item.si_sugtime)
								end
							end
						end
						if (a_spin.item.si_nosplitsugs).to_boolean then
							IO_putc (14, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							misc2_inst.put_bytes (l_fd, (0).to_natural_32, 4).do_nothing
						end
						if not (a_spin.item.si_compflags).is_void then
							IO_putc (8, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_compflags))).to_integer_32
							l_i___0 := 0
							from
							until
								not (l_i___0 < a_spin.item.si_comppat.ga_len)
							loop
								l_l := l_l + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_spin.item.si_comppat.ga_data)[l_i___0]))).to_integer_32 + 1)
								l_i___0 := l_i___0 + 1
							end
							misc2_inst.put_bytes (l_fd, (l_l + 7).to_natural_32, 4).do_nothing
							IO_putc (a_spin.item.si_compmax, l_fd).do_nothing
							IO_putc (a_spin.item.si_compminlen, l_fd).do_nothing
							IO_putc (a_spin.item.si_compsylmax, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							IO_putc (a_spin.item.si_compoptions, l_fd).do_nothing
							misc2_inst.put_bytes (l_fd, (a_spin.item.si_comppat.ga_len).to_natural_32, 2).do_nothing
							l_i___0 := 0
							from
							until
								not (l_i___0 < a_spin.item.si_comppat.ga_len)
							loop
								l_p___0 := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_spin.item.si_comppat.ga_data)[l_i___0]
								IO_putc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32, l_fd).do_nothing
								l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))), (1).to_natural_32, l_fd)))
								l_i___0 := l_i___0 + 1
							end
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (a_spin.item.si_compflags), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_compflags))), (1).to_natural_32, l_fd)))
						end
						if (a_spin.item.si_nobreak).to_boolean then
							IO_putc (10, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							misc2_inst.put_bytes (l_fd, (0).to_natural_32, 4).do_nothing
						end
						if not (a_spin.item.si_syllable).is_void then
							IO_putc (9, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_spin.item.si_syllable))).to_integer_32
							misc2_inst.put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_POINTER [ANY]}.make_cast (a_spin.item.si_syllable), l_l.to_natural_32, (1).to_natural_32, l_fd)))
						end
						IO_putc (255, l_fd).do_nothing
						a_spin.item.si_memtot := 0
						l_round := 1
						from
						until
							not (l_round <= 3)
						loop
							if l_round = 1 then
								l_tree := (a_spin.item.si_foldroot).item.wn_sibling
							elseif l_round = 2 then
								l_tree := (a_spin.item.si_keeproot).item.wn_sibling
							else
								l_tree := (a_spin.item.si_prefroot).item.wn_sibling
							end
							clear_node (l_tree)
							l_nodecount := put_node (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer), l_tree, 0, l_regionmask, (l_round = 3).to_integer)
							misc2_inst.put_bytes (l_fd, l_nodecount.to_natural_32, 4).do_nothing
							a_spin.item.si_memtot := ((a_spin.item.si_memtot).to_natural_32 + (l_nodecount.to_natural_32 + l_nodecount.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)).to_integer_32
							put_node (l_fd, l_tree, 0, l_regionmask, (l_round = 3).to_integer).do_nothing
							l_round := l_round + 1
						end
						if (IO_putc (0, l_fd)) = -1 then
							l_retval := 0
						end
				when 3 then -- theend:
						if (fclose (l_fd)) = -1 then
							l_retval := 0
						end
						if l_fwv /= {NATURAL_32} 1 then
							l_retval := 0
						end
						if l_retval = 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_write))))).do_nothing
						end
						Result := l_retval
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
