class
	P_SWAP_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_char_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [INTEGER_8]
			l_col2: CE_POINTER [INTEGER_8]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: INTEGER_8
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_char_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [INTEGER_8]
			l_col: CE_POINTER [INTEGER_8]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: INTEGER_8
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_char_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [INTEGER_8]
			l_row2: CE_POINTER [INTEGER_8]
			l_k: NATURAL_32
			l_tmp: INTEGER_8
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_char_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: INTEGER_8
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_char_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_src: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_float_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [REAL_32]
			l_col2: CE_POINTER [REAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + ({NATURAL_32} 2 * a_i).to_integer_32
					l_col2 := a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := (l_p * {NATURAL_32} 2) * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 2)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [REAL_32]
			l_col: CE_POINTER [REAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (({NATURAL_32} 2 * a_i) * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p * {NATURAL_32} 2
					l_c___1 := (l_p * {NATURAL_32} 2) * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [REAL_32]
			l_row2: CE_POINTER [REAL_32]
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (({NATURAL_32} 2 * a_i) * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (({NATURAL_32} 2 * a_j) * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2 * l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 2)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) * {NATURAL_32} 2 + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) * {NATURAL_32} 2 + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 2)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) * {NATURAL_32} 2 + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) * {NATURAL_32} 2 + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_long_double_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [REAL_96]
			l_col2: CE_POINTER [REAL_96]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + ({NATURAL_32} 2 * a_i).to_integer_32
					l_col2 := a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := (l_p * {NATURAL_32} 2) * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 2)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_complex_long_double_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [REAL_96]
			l_col: CE_POINTER [REAL_96]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (({NATURAL_32} 2 * a_i) * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p * {NATURAL_32} 2
					l_c___1 := (l_p * {NATURAL_32} 2) * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_long_double_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [REAL_96]
			l_row2: CE_POINTER [REAL_96]
			l_k: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (({NATURAL_32} 2 * a_i) * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (({NATURAL_32} 2 * a_j) * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2 * l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_complex_long_double_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 2)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) * {NATURAL_32} 2 + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) * {NATURAL_32} 2 + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_long_double_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 2)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) * {NATURAL_32} 2 + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) * {NATURAL_32} 2 + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [REAL_64]
			l_col2: CE_POINTER [REAL_64]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + ({NATURAL_32} 2 * a_i).to_integer_32
					l_col2 := a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := (l_p * {NATURAL_32} 2) * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 2)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_complex_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [REAL_64]
			l_col: CE_POINTER [REAL_64]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (({NATURAL_32} 2 * a_i) * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p * {NATURAL_32} 2
					l_c___1 := (l_p * {NATURAL_32} 2) * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [REAL_64]
			l_row2: CE_POINTER [REAL_64]
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (({NATURAL_32} 2 * a_i) * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (({NATURAL_32} 2 * a_j) * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2 * l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_complex_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 2)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) * {NATURAL_32} 2 + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) * {NATURAL_32} 2 + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 2)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) * {NATURAL_32} 2 + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) * {NATURAL_32} 2 + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_float_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [REAL_32]
			l_col2: CE_POINTER [REAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_float_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [REAL_32]
			l_col: CE_POINTER [REAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_float_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [REAL_32]
			l_row2: CE_POINTER [REAL_32]
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_float_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_float_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_src: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_int_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [INTEGER_32]
			l_col2: CE_POINTER [INTEGER_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_int_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [INTEGER_32]
			l_col: CE_POINTER [INTEGER_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_int_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [INTEGER_32]
			l_row2: CE_POINTER [INTEGER_32]
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_int_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_int_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_INT]; a_src: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_long_double_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [REAL_96]
			l_col2: CE_POINTER [REAL_96]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_long_double_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [REAL_96]
			l_col: CE_POINTER [REAL_96]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_double_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [REAL_96]
			l_row2: CE_POINTER [REAL_96]
			l_k: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_long_double_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_double_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_src: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_long_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [INTEGER_32]
			l_col2: CE_POINTER [INTEGER_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_long_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [INTEGER_32]
			l_col: CE_POINTER [INTEGER_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [INTEGER_32]
			l_row2: CE_POINTER [INTEGER_32]
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_long_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_LONG]; a_src: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_short_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [INTEGER_16]
			l_col2: CE_POINTER [INTEGER_16]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: INTEGER_16
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_short_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [INTEGER_16]
			l_col: CE_POINTER [INTEGER_16]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: INTEGER_16
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_short_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [INTEGER_16]
			l_row2: CE_POINTER [INTEGER_16]
			l_k: NATURAL_32
			l_tmp: INTEGER_16
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_short_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: INTEGER_16
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_short_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_src: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [REAL_64]
			l_col2: CE_POINTER [REAL_64]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [REAL_64]
			l_col: CE_POINTER [REAL_64]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [REAL_64]
			l_row2: CE_POINTER [REAL_64]
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX]; a_src: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_uchar_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [NATURAL_8]
			l_col2: CE_POINTER [NATURAL_8]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_uchar_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [NATURAL_8]
			l_col: CE_POINTER [NATURAL_8]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uchar_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [NATURAL_8]
			l_row2: CE_POINTER [NATURAL_8]
			l_k: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_uchar_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uchar_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_src: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_uint_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [NATURAL_32]
			l_col2: CE_POINTER [NATURAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_uint_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [NATURAL_32]
			l_col: CE_POINTER [NATURAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uint_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [NATURAL_32]
			l_row2: CE_POINTER [NATURAL_32]
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_uint_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uint_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_UINT]; a_src: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_ulong_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [NATURAL_32]
			l_col2: CE_POINTER [NATURAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_ulong_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [NATURAL_32]
			l_col: CE_POINTER [NATURAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ulong_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [NATURAL_32]
			l_row2: CE_POINTER [NATURAL_32]
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_ulong_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ulong_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_src: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_ushort_swap_columns (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [NATURAL_16]
			l_col2: CE_POINTER [NATURAL_16]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: NATURAL_16
			js: JUMP_STATE
		do
			create l_col1.make
			create l_col2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_col1 := a_m___4.item.data + a_i.to_integer_32
					l_col2 := a_m___4.item.data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_p < l_size1))
					loop
						l_n := l_p * a_m___4.item.tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_swap_rowcol (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [NATURAL_16]
			l_col: CE_POINTER [NATURAL_16]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: NATURAL_16
			js: JUMP_STATE
		do
			create l_row.make
			create l_col.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_i >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size2) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_row := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_col := a_m___4.item.data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * a_m___4.item.tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_swap_rows (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [NATURAL_16]
			l_row2: CE_POINTER [NATURAL_16]
			l_k: NATURAL_32
			l_tmp: NATURAL_16
			js: JUMP_STATE
		do
			create l_row1.make
			create l_row2.make

			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if a_i >= l_size1 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size1) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_row1 := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
					l_row2 := a_m___4.item.data + (a_j * a_m___4.item.tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						l_row2[l_k.to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_transpose (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: NATURAL_16
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			if l_size1 /= l_size2 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not js.loop_done and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * a_m___4.item.tda + l_j) + l_k
							l_e2 := (l_j * a_m___4.item.tda + l_i) + l_k
							l_tmp := a_m___4.item.data[l_e1.to_integer_32]
							a_m___4.item.data[l_e1.to_integer_32] := a_m___4.item.data[l_e2.to_integer_32]
							a_m___4.item.data[l_e2.to_integer_32] := l_tmp
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_transpose_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_src: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_done and then (l_i < l_dest_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_done and then (l_j < l_dest_size2))
								loop
									l_k := (0).to_natural_32
									from
									until
										not (l_k < {NATURAL_32} 1)
									loop
										l_e1 := (l_i * a_dest.item.tda + l_j) + l_k
										l_e2 := (l_j * a_src.item.tda + l_i) + l_k
										a_dest.item.data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
										l_k := l_k + 1
									end
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_vector_char_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_data: CE_POINTER [INTEGER_8]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_8
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_char_swap (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_w: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_d1: CE_POINTER [INTEGER_8]
			l_d2: CE_POINTER [INTEGER_8]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_8
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_char_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [INTEGER_8]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_8
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_complex_float_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_data: CE_POINTER [REAL_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := {NATURAL_32} 2 * l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 2)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_float_swap (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_w: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_d1: CE_POINTER [REAL_32]
			l_d2: CE_POINTER [REAL_32]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := {NATURAL_32} 2 * a_v.item.stride
			l_s2 := {NATURAL_32} 2 * a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_float_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [REAL_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := {NATURAL_32} 2 * l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_complex_long_double_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_data: CE_POINTER [REAL_96]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := {NATURAL_32} 2 * l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 2)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_long_double_swap (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_w: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_d1: CE_POINTER [REAL_96]
			l_d2: CE_POINTER [REAL_96]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := {NATURAL_32} 2 * a_v.item.stride
			l_s2 := {NATURAL_32} 2 * a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_long_double_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [REAL_96]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := {NATURAL_32} 2 * l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_complex_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_data: CE_POINTER [REAL_64]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := {NATURAL_32} 2 * l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 2)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_swap (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_w: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_d1: CE_POINTER [REAL_64]
			l_d2: CE_POINTER [REAL_64]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := {NATURAL_32} 2 * a_v.item.stride
			l_s2 := {NATURAL_32} 2 * a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [REAL_64]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := {NATURAL_32} 2 * l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_float_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_data: CE_POINTER [REAL_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_float_swap (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_w: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_d1: CE_POINTER [REAL_32]
			l_d2: CE_POINTER [REAL_32]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_float_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [REAL_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_int_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_data: CE_POINTER [INTEGER_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_int_swap (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_w: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_d1: CE_POINTER [INTEGER_32]
			l_d2: CE_POINTER [INTEGER_32]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_int_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [INTEGER_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_long_double_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_data: CE_POINTER [REAL_96]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_long_double_swap (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_w: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_d1: CE_POINTER [REAL_96]
			l_d2: CE_POINTER [REAL_96]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_long_double_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [REAL_96]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_long_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_data: CE_POINTER [INTEGER_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_long_swap (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_w: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_d1: CE_POINTER [INTEGER_32]
			l_d2: CE_POINTER [INTEGER_32]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_long_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [INTEGER_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_reverse (a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_data: CE_POINTER [REAL_64]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_short_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_data: CE_POINTER [INTEGER_16]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_16
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_short_swap (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_w: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_d1: CE_POINTER [INTEGER_16]
			l_d2: CE_POINTER [INTEGER_16]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_16
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_short_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [INTEGER_16]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: INTEGER_16
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_swap (a_v: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_d1: CE_POINTER [REAL_64]
			l_d2: CE_POINTER [REAL_64]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [REAL_64]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_uchar_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_data: CE_POINTER [NATURAL_8]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_uchar_swap (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_w: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_d1: CE_POINTER [NATURAL_8]
			l_d2: CE_POINTER [NATURAL_8]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_uchar_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [NATURAL_8]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_uint_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_data: CE_POINTER [NATURAL_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_uint_swap (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_w: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_d1: CE_POINTER [NATURAL_32]
			l_d2: CE_POINTER [NATURAL_32]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_uint_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [NATURAL_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_ulong_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_data: CE_POINTER [NATURAL_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_ulong_swap (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_w: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_d1: CE_POINTER [NATURAL_32]
			l_d2: CE_POINTER [NATURAL_32]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_ulong_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [NATURAL_32]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_ushort_reverse (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_data: CE_POINTER [NATURAL_16]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_16
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			l_s := l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 1)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_ushort_swap (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_w: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_d1: CE_POINTER [NATURAL_16]
			l_d2: CE_POINTER [NATURAL_16]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_16
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1 := a_v.item.data
			l_d2 := a_w.item.data
			l_size := a_v.item.size
			l_s1 := a_v.item.stride
			l_s2 := a_w.item.stride
			if a_v.item.size /= a_w.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_ushort_swap_elements (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [NATURAL_16]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: NATURAL_16
			js: JUMP_STATE
		do
			create l_data.make

			l_data := a_v.item.data
			l_size := a_v.item.size
			l_stride := a_v.item.stride
			if a_i >= l_size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called and then (a_j >= l_size) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				if a_i /= a_j then
					l_s := l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

end
